prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4415
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4415 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4415
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110305604620364095')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'it'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.4415)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112716'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.4415)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.4415)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Scollega'
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>'Scollega da Application Express'
,p_list_text_09=>'Y'
,p_list_text_10=>'logout exit quit :q'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.4415)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Crea un''applicazione da un foglio di calcolo'
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>'Importare i file Excel o CSV e creare l''applicazione'
,p_list_text_09=>'Y'
,p_list_text_10=>'excel csv xsl xslx spreadsheet data paste load import'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.4415)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Home Oracle APEX'
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>'inizio home page '
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.4415)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sfoglia icone Carattere APEX'
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>'Sfogliare le icone Carattere APEX, aggiungere i modificatori e copiare CSS o HTML necessari.'
,p_list_text_09=>'Y'
,p_list_text_10=>'icone elementi grafici libreria apex'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.4415)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.4415)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Esporta applicazione'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>'Esporta l''applicazione {APP_ID} come file SQL'
,p_list_text_09=>'Y'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.4415)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Liste inutilizzate'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.4415)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.4415)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.4415)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.4415)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.4415)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.4415)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.4415)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.4415)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.4415)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.4415)
,p_theme_id=>1
,p_name=>'One Level Tabs.it'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.4415)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4415)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.4415)
,p_theme_id=>1
,p_name=>'Printer Friendly.it'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.4415)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4415)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.4415)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4415)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.4415)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4415)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.4415)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.4415)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.4415)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4415)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.4415)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.4415)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.4415)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.4415)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.4415)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.4415)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>'Finestra di dialogo di ricerca'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>'Cerca'
,p_close_button_text=>'Chiudi'
,p_next_button_text=>'Successivo >'
,p_prev_button_text=>'< Precedente'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Righe #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.4415)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.4415)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.4415)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185567971306711)
,p_name=>'2DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 2D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187640209306712)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'it'
,p_message_text=>'A linee di colonne 2D'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185678994306711)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'it'
,p_message_text=>'Ad anello 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187490839306712)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'it'
,p_message_text=>'A colonne 2D orizzontali in pila (percentuale)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185758824306711)
,p_name=>'2DLINE'
,p_message_language=>'it'
,p_message_text=>'A linee 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185856333306711)
,p_name=>'2DPIE'
,p_message_language=>'it'
,p_message_text=>'A torta 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187295033306712)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'it'
,p_message_text=>'A colonne 2D in pila (percentuale)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185999829306711)
,p_name=>'3DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 3D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187590080306712)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'it'
,p_message_text=>'A colonne 3D orizzontali in pila (percentuale)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186092691306711)
,p_name=>'3DPIE'
,p_message_language=>'it'
,p_message_text=>'A torta 3D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187391182306712)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'it'
,p_message_text=>'A colonne 3D in pila (percentuale)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955464606307361)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'it'
,p_message_text=>'0 elementi da inserire nel dizionario attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955211404307361)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'it'
,p_message_text=>'0 elementi per l''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955624206307361)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'it'
,p_message_text=>'0 elementi per aggiornare il dizionario attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956014772307361)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'it'
,p_message_text=>'0 colonne del report da inserire nel dizionario attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956255223307362)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'it'
,p_message_text=>'0 colonne del report per aggiornare il dizionario attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955114176307361)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'it'
,p_message_text=>'Controllare %0 elementi per l''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955806958307361)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'it'
,p_message_text=>'0 colonne di report per l''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955308727307361)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'it'
,p_message_text=>'Rivedi %0 elementi da inserire nel dizionario attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955516009307361)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'it'
,p_message_text=>'Rivedi %0 elementi per aggiornare il dizionario attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955944234307361)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'it'
,p_message_text=>'Rivedi %0 colonne del report da inserire nel dizionario attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955703396307361)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'it'
,p_message_text=>'Controllare %0 colonne di report per l''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956188691307361)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'it'
,p_message_text=>'Rivedi %0 colonne del report per aggiornare il dizionario attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747816487307193)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'it'
,p_message_text=>'Il valore deve essere numerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733023883307179)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'it'
,p_message_text=>'<span class="fielddata"> Impossibile riordinare. Sequenze di aree non univoche.</span>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733158789307179)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'it'
,p_message_text=>'<span class="fielddata">Impossibile riordinare. Sequenze di pulsanti non univoche.</span>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733222005307179)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'it'
,p_message_text=>'<span class="fielddata">Impossibile riordinare. Sequenze di barre di navigazione non univoche.</span>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733326603307179)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'it'
,p_message_text=>'<span class="fielddata">Impossibile riordinare. Sequenze di elementi di area non univoche.</span>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802238760307243)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'it'
,p_message_text=>'ID applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316945986306810)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Modifica applicazione: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706543615307155)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'it'
,p_message_text=>unistr('Il formato data specificato non \00E8 valido. Il calendario richiede che la data sia in formato YYYYMMDD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752597772307197)
,p_name=>'4000_TREE'
,p_message_language=>'it'
,p_message_text=>'Struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802311647307243)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'it'
,p_message_text=>'ID area di lavoro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596914225307048)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il nome del nuovo schema da creare. Scegliere',
'         una password per lo schema, quindi la tablespace predefinita',
'         e la tablespace temporanea.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597079931307048)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome dello schema esistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597135132307048)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'it'
,p_message_text=>'Al termine, fare clic su <strong>Successivo</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467284676306932)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'it'
,p_message_text=>'Elimina le tablespace e i file di dati associati: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467134870306932)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'it'
,p_message_text=>'Elimina utente del database: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331092643307655)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'it'
,p_message_text=>unistr('Voci del log di attivit\00E0 Web Service')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179199475306706)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'it'
,p_message_text=>'Voci del log di sincronizzazione REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179983563306706)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'it'
,p_message_text=>'Voci di log di automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590822379307042)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'it'
,p_message_text=>unistr('Voci di log di attivit\00E0 dello sviluppatore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229716615306744)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'it'
,p_message_text=>'Voci log degli accessi di login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590377264307042)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'it'
,p_message_text=>'Richieste di modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590469951307042)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'it'
,p_message_text=>'Richieste di runtime'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590180812307042)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'it'
,p_message_text=>'Richieste di area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592631638307044)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'it'
,p_message_text=>'Voci della cronologia del processore comandi SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592502009307044)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'it'
,p_message_text=>'Voci di log di esecuzione dei control file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592406417307044)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'it'
,p_message_text=>'Voci di log di esecuzione dei file di script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592753909307044)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'it'
,p_message_text=>'Voci degli archivi SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594406618307046)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'it'
,p_message_text=>'Informazioni sul log attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594525863307046)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'it'
,p_message_text=>'Numero del log corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594608352307046)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'it'
,p_message_text=>'Indicatore orario del log corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595228683307046)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'it'
,p_message_text=>'Ore fino al log switch successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594829474307046)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'it'
,p_message_text=>'Intervallo in giorni (costante)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595144903307046)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'it'
,p_message_text=>'Log switch successivo pianificato per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595568996307046)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'it'
,p_message_text=>unistr('Voci di log di attivit\00E0 dello sviluppatore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595719056307047)
,p_name=>'4050_71_CLICK'
,p_message_language=>'it'
,p_message_text=>'Voci di log dei clic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596566332307047)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'it'
,p_message_text=>'Voci della cronologia del processore comandi SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596477794307047)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'it'
,p_message_text=>'Voci di log di esecuzione dei control file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596285333307047)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'it'
,p_message_text=>'Voci di log di esecuzione dei file di script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596682738307047)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'it'
,p_message_text=>'Voci degli archivi SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596774992307048)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'L''area di lavoro %1 ha %2 applicazione/i e %3 utente/i.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596817023307048)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'it'
,p_message_text=>'Voci di log di conteggio clic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777988375307221)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>unistr('Applicazioni di produttivit\00E0 e di esempio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778024610307221)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'it'
,p_message_text=>'Websheet di esempio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777275046307220)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio aree di lavoro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524384772306981)
,p_name=>'4350_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524452456306981)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Modifica applicazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244213666306755)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'it'
,p_message_text=>'Oracle Database Express Edition 2 Day DBA.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244333233306755)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'it'
,p_message_text=>'Oracle Database Express Edition 2 Day Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244117585306755)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'it'
,p_message_text=>'Oracle Application Express 2 Day Plus Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244422350306755)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'it'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus Java Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244500191306755)
,p_name=>'4500 800 HD NET'
,p_message_language=>'it'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus .NET Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244605550306755)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'it'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus PHP Developer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244718581306755)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'it'
,p_message_text=>'Tratta dei comuni task amministrativi quotidiani.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244835400306756)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'it'
,p_message_text=>unistr('Illustra come sfruttare le potenzialit\00E0 dell''ambiente di sviluppo di Oracle Database Express Edition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244924181306756)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'it'
,p_message_text=>unistr('Offre una serie di esercitazioni che illustrano le modalit\00E0 di creazione di applicazioni Web basate su database.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245191388306756)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'it'
,p_message_text=>'Questo documento fornisce un''esercitazione che illustra come utilizzare Java e JDBC per connettersi a Oracle Database XE e mostra come sviluppare una semplice applicazione Java per l''accesso e la modifica dei dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245213442306756)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'it'
,p_message_text=>'Questo documento descrive le funzioni fondamentali di Oracle Data Provider for .NET e Oracle Developer Tools for Visual Studio .NET, fornisce istruzioni dettagliate per l''installazione e la configurazione e mostra come creare applicazioni di base uti'
||unistr('lizzando Oracle Data Provider for .NET e Oracle Developer Tools for Visual Studio .NET, nonch\00E9 come creare e utilizzare stored procedure PL/SQL e .NET.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245080285306756)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'it'
,p_message_text=>'Questo documento fornisce un''esercitazione che illustra come scaricare e installare i driver PHP Zend Core e Apache e come utilizzare PHP per connettersi a Oracle Database XE; mostra inoltre come utilizzare PHP per sviluppare un''applicazione semplice'
||' per l''accesso e la modifica dei dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215789208306734)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215633831306733)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215964572306734)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647528741307099)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216375910306734)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216418725306734)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'it'
,p_message_text=>'Raggruppa per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215849355306734)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'it'
,p_message_text=>'Oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216291986306734)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216022137306734)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'it'
,p_message_text=>'Tipo di ordinamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216148898306734)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'it'
,p_message_text=>'Criterio di ordinamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218936751306736)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'it'
,p_message_text=>'Join'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212780024306731)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'it'
,p_message_text=>'Fare clic qui per selezionare una colonna per il join.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219322506306736)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile selezionare un massimo di 60 colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212685907306731)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212520614306731)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'it'
,p_message_text=>'Mostra/Nascondi colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219074912306736)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'it'
,p_message_text=>'a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211509974306730)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'it'
,p_message_text=>'Risultati di %0, esecuzione alle %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467895332306933)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'it'
,p_message_text=>'Torna alla query originale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226786136306742)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'it'
,p_message_text=>'Prime %0 colonne visualizzate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675192913307125)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'it'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675061226307125)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'it'
,p_message_text=>'Kilobyte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674968024307125)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'it'
,p_message_text=>'Megabyte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247571526306758)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'it'
,p_message_text=>unistr('I valori predefiniti dell''interfaccia utente vengono utilizzati dall''App Builder per popolare i valori iniziali per l''area e le propriet\00E0 degli elementi che assicurano la coerenza su pi\00F9 pagine in una o pi\00F9 applicazioni.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277697514306780)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'it'
,p_message_text=>'Questa applicazione richiede l''abilitazione dei cookie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277527258306780)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'it'
,p_message_text=>'Questa applicazione richiede l''abilitazione di JavaScript.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704892290307153)
,p_name=>'ABOUT'
,p_message_language=>'it'
,p_message_text=>'Informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398313657307705)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'it'
,p_message_text=>'Confermare l''aggiunta dei %0 utenti seguenti all''area di lavoro.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716335343307164)
,p_name=>'ACCEPTED'
,p_message_language=>'it'
,p_message_text=>'Accettato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684426037307134)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'it'
,p_message_text=>'Assegnatario accesso facilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682537340307132)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Impatto accesso facilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684838556307134)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato accesso facilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449286025307748)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'it'
,p_message_text=>'Test accesso facilitato eseguito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358089565306845)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'it'
,p_message_text=>'Diritti di amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224380839306740)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina di amministrazione controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636705596307091)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'it'
,p_message_text=>'Amministratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741683596307187)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'it'
,p_message_text=>'Ruolo assegnato agli amministratori dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224592458306740)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'it'
,p_message_text=>'Amministrazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225149314306741)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 di applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225092357306741)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare la modalit\00E0 di controllo dell''accesso a questa applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226175430306741)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile elaborare la richiesta di impostazione della modalit\00E0 di applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226230401306742)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 di applicazione impostata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358412591306845)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eliminare se stessi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358562825306845)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere il privilegio di amministratore da se stessi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224480126306740)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'it'
,p_message_text=>'Crea tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636665022307091)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'it'
,p_message_text=>'Diritti contributo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636850269307091)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'it'
,p_message_text=>'Collaboratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741763770307187)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'it'
,p_message_text=>'Ruolo assegnato ai collaboratori dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677396041307127)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Verranno create le impostazioni applicazione seguenti:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636971521307091)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'it'
,p_message_text=>'Verranno creati i ruoli di accesso applicazione seguenti:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241729196306753)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Verranno creati gli schemi di autorizzazione seguenti:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297552252306795)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di controllo dell''accesso. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297488783306795)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare le tabelle di controllo dell''accesso. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359840996306846)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'it'
,p_message_text=>'Impossibile immettere un nome utente duplicato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358155030306845)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'it'
,p_message_text=>'controllo dell''accesso - modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225804257306741)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query senza distinzione tra maiuscole e minuscole, quindi fare clic sul pulsante <strong>Vai</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225961173306741)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile ottenere la modalit\00E0 di amministrazione dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225780171306741)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'it'
,p_message_text=>'Autore ultima modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225452601306741)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224636941306740)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'it'
,p_message_text=>'Accesso completo a tutto, lista di controllo dell''accesso non utilizzata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224792477306740)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'it'
,p_message_text=>'Accesso limitato. Accesso consentito solo agli utenti definiti nella lista di controllo dell''accesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224869701306741)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'it'
,p_message_text=>'Pubblico sola lettura. Privilegi di modifica e amministrazione controllati dalla lista di controllo dell''accesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224927512306741)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'it'
,p_message_text=>'Solo accesso amministrativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226068948306741)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'it'
,p_message_text=>'Nessun privilegio per l''azione tentata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225653550306741)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'it'
,p_message_text=>'Privilegio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677250116307127)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'it'
,p_message_text=>'Diritti lettore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677120115307127)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'it'
,p_message_text=>'Processo di lettura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741857405307187)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'it'
,p_message_text=>'Ruolo assegnato ai lettori dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242593498306754)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'it'
,p_message_text=>'Specificare i nomi utente che corrispondono allo schema di autenticazione di questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225230328306741)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Imposta modalit\00E0 di applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323612646306815)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione delle pagine di controllo dell''accesso completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637018196307091)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'it'
,p_message_text=>'Usa ruolo di controllo dell''accesso esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242473895306754)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Usa schema di autorizzazione esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241686596306753)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'it'
,p_message_text=>'Usa tabella esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358230456306845)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'it'
,p_message_text=>'controllo dell''accesso - visualizza'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245442230306756)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'it'
,p_message_text=>'Account creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931185062307343)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu account'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665066952307116)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'it'
,p_message_text=>'Confermato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665269038307116)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'it'
,p_message_text=>'Confermato, nessuna azione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725702517307172)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'it'
,p_message_text=>'Aggiungi utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334368719307657)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'it'
,p_message_text=>'Accesso al dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334422928307657)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'it'
,p_message_text=>unistr('Accesso a controllo attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333975963307657)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'it'
,p_message_text=>'Aggiungi/modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334289195307657)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'it'
,p_message_text=>'Amministrazione quando si esegue l''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333148165307656)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'it'
,p_message_text=>'Amministrazione dall''App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333869661307657)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'it'
,p_message_text=>'Annotazioni (file, tag, note)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332866023307656)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'it'
,p_message_text=>'Autenticazione dell''account Application Express senza lista di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332798101307656)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'it'
,p_message_text=>'Autenticazione con lista di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333569035307657)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'it'
,p_message_text=>'Modifica accesso SQL e oggetti consigliati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337553833307660)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'it'
,p_message_text=>unistr('Dopo aver eseguito l''autenticazione in un''applicazione, il controllo dell''accesso specifica cosa possono fare gli utenti nell''applicazione. La tabella riportata di seguito identifica le varie funzionalit\00E0 disponibili per gli utenti, a seconda dell''au')
||'tenticazione nell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334591656307657)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'it'
,p_message_text=>'Conserva lista di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333669196307657)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'it'
,p_message_text=>'Esegui e visualizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333315960307657)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiorna propriet\00E0 applicazione')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950637399307357)
,p_name=>'ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332280850307656)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni menu Azioni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253989682306763)
,p_name=>'ACTIVE'
,p_message_language=>'it'
,p_message_text=>'Attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644001842307097)
,p_name=>'ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685725232307135)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riepilogo attivit\00E0'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886389271307307)
,p_name=>'ADDED_BY'
,p_message_language=>'it'
,p_message_text=>'Autore aggiunta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328687633307653)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'it'
,p_message_text=>'Aggiunto alla lista di rimozione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943581376307352)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'it'
,p_message_text=>'Richieste ulteriori informazioni'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603824539307054)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'it'
,p_message_text=>'Aggiungi argomento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594253395307045)
,p_name=>'ADD_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Aggiungi colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791587090307234)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>'Aggiungi colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433421641306905)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'it'
,p_message_text=>'Aggiungi vincolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592331971307044)
,p_name=>'ADD_MORE...'
,p_message_language=>'it'
,p_message_text=>'Aggiungi altro...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658148264307109)
,p_name=>'ADD_ROW'
,p_message_language=>'it'
,p_message_text=>'Aggiungi riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796640522307238)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'it'
,p_message_text=>'Aggiungi interfaccia utente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800115722307241)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'it'
,p_message_text=>'Adegua spazio fornito di %0 MB'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591083737307042)
,p_name=>'ADMIN'
,p_message_language=>'it'
,p_message_text=>'Amministratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179859797306706)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'it'
,p_message_text=>'Colore banner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179675248306706)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'it'
,p_message_text=>'Abilita banner ambiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179744855306706)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta banner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599019173307050)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'it'
,p_message_text=>'Posizione banner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237804983306750)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'it'
,p_message_text=>'Amministratore area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685510527307135)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'it'
,p_message_text=>'Amministratori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597701801307048)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario fornire la posta elettronica degli amministratori')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750032791307195)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'it'
,p_message_text=>'Accesso facilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260324945306767)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260670309306767)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'it'
,p_message_text=>'Prestazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260720623306768)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'it'
,p_message_text=>unistr('Controllo di qualit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260494459306767)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'it'
,p_message_text=>'Sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260854600306768)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'it'
,p_message_text=>unistr('Usabilit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260552644306767)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'it'
,p_message_text=>'Avvertenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855047324307284)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento "%1" \00E8 protetto e non pu\00F2 essere impostato mediante una chiamata Ajax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855178962307284)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento "%1" \00E8 protetto e non pu\00F2 essere impostato mediante una chiamata Ajax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884481588307305)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento "%1" \00E8 protetto e non pu\00F2 essere impostato mediante una chiamata Ajax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286772453306787)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'it'
,p_message_text=>'Prefisso dello schema SYS mancante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990708673307387)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'it'
,p_message_text=>'Uso delle API WWV_FLOW (utilizzare invece le API APEX)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941082561307350)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'La colonna %0 non esiste nell''istruzione SQL dell''origine dell''area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270468087306775)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Colonna di report interattivo %0 inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268111612306773)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'%0 inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248482363306758)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'La colonna %0 non esiste nell''istruzione SQL dell''origine dell''area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020826862307410)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Colonna di form tabulare %0 inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268240568306773)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile fare riferimento a %0 come nome elemento di applicazione o di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403402667307712)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>unistr('Il processo dell''applicazione Callback Ajax non \00E8 protetto da uno schema di autorizzazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403064419307711)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina non \00E8 protetta da uno schema di autorizzazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269158876306774)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessuno schema di autorizzazione definito per la pagina di destinazione %1 nell''applicazione %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404775336307713)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'it'
,p_message_text=>unistr('L''autorizzazione di questa pagina \00E8 diversa dall''autorizzazione "%1" della pagina padre %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269243450306774)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'it'
,p_message_text=>unistr('L''autorizzazione "%0" nella pagina di destinazione \00E8 diversa da "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267761514306773)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'%0 inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267665090306773)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il controllo della sintassi di bind variable. Errore: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267834684306773)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile fare riferimento a %0 con una sintassi di bind variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269802937306774)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'it'
,p_message_text=>'Diramazione non condizionale prima di altre diramazioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402880481307711)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'it'
,p_message_text=>unistr('Il completamento automatico \00E8 attivato per una pagina che contiene elementi di password.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402990898307711)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'it'
,p_message_text=>'"Cache" consente al browser di inserire nella cache i dati riservati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202553136307558)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'it'
,p_message_text=>unistr('Con "Incorpora in frame" l''applicazione \00E8 vulnerabile agli attacchi di tipo clickjacking.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202677064307558)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('"Modalit\00E0 di escape HTML" si applica solo a un set di caratteri limitato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191122653306715)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'it'
,p_message_text=>'Gli elementi devono utilizzare la funzione di escape per i caratteri speciali in modo da evitare attacchi di tipo XSS (Cross-Site-Scripting).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209616941307563)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''intestazione della richiesta HTTP "Referer" pu\00F2 comportare la divulgazione di informazioni riservate sulla sessione a terze parti.'),
unistr('Per le applicazioni \00E8 necessario che "Criterio provenienza" sia impostato su "strict-origin".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207243812306727)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('In Attributi pulsante \00E8 stato rilevato un ID per un pulsante cui viene fatto riferimento in un''azione dinamica (%0). '),
'',
unistr('La definizione di un ID in Attributi pulsante provoca il mancato funzionamento delle azioni dinamiche che fanno riferimento al pulsante. Rimuovere questo ID, poich\00E9 il pulsante generer\00E0 un ID per impostazione predefinita.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207332925306727)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Il modello di pulsante utilizzato da un pulsante cui viene fatto riferimento in un''azione dinamica (%0) non contiene la stringa di sostituzione #BUTTON_ID#.',
'',
'Modello:',
'%1',
'',
'Aggiungere la stringa di sostituzione #BUTTON_ID# a questo modello oppure sostituire il modello di pulsante con uno che includa la stringa di sostituzione #BUTTON_ID#.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210684829306730)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore ''Azione'' non \00E8 ''Definita da azione dinamica'' per un pulsante cui viene fatto riferimento in un''azione dinamica (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216738245306734)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'it'
,p_message_text=>'Pulsante (%0) con valore di ''Azione'' impostato su ''Definita da azione dinamica'' ma senza azione dinamica corrispondente che fa riferimento a questo pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268864320306774)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina di svuotamento della cache %0 non \00E8 la pagina corrente o di destinazione %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267509420306773)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'%0 inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376601029307688)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'it'
,p_message_text=>unistr('Questo valore di attributo non \00E8 pi\00F9 valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379142506307690)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Questo tipo di componente non \00E8 pi\00F9 valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855236087307284)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'it'
,p_message_text=>'Elementi protetti nelle chiamate Ajax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286631385306787)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'it'
,p_message_text=>'Difetto del codice (interno APEX)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265642686306771)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'it'
,p_message_text=>'Riferimenti dichiarativi di elementi di applicazione, elementi di pagina, colonne o filtri di report interattivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402722405307711)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>'Autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265397866306771)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'it'
,p_message_text=>'Riferimenti con sintassi di bind variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266756480306772)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Diramazione non condizionale prima di altre diramazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403271421307712)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'it'
,p_message_text=>'Impostazioni di sicurezza del browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207134640306727)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'it'
,p_message_text=>'Pulsante non compatibile con le azioni dinamiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216537463306734)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'it'
,p_message_text=>'Riferimenti incoerenti tra azioni dinamiche e pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265916530306772)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'it'
,p_message_text=>unistr('Il numero di pagina di svuotamento della cache \00E8 uguale alla pagina di destinazione o corrente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265296481306771)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'it'
,p_message_text=>'Riferimenti con sintassi di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376519595307688)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>unistr('Valori attributi non pi\00F9 validi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266293119306772)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'it'
,p_message_text=>'I processi di recupero, DML e MR* sono validi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266690373306772)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'it'
,p_message_text=>'ID applicazione non modificabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662374768307113)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'it'
,p_message_text=>'L''elemento di pagina contiene il testo della Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749856726307195)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'it'
,p_message_text=>'La pagina dispone del titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774094838307217)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'it'
,p_message_text=>'L''elemento Visualizza immagine dispone di testo alternativo immagine definito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202359781307558)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Attributi applicazione che possono essere bloccati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265464727306771)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'it'
,p_message_text=>'L''elemento a cui si fa riferimento si trova nella pagina corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265559049306771)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento a cui si fa riferimento \00E8 un elemento della pagina di destinazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750515440307195)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'it'
,p_message_text=>'L''elemento di pagina non causa una modifica di contesto imprevista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751240679307196)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'it'
,p_message_text=>'L''elemento di pagina dispone di un''etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266934226306772)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'it'
,p_message_text=>'Lunghezza del nome degli elementi o delle colonne di form tabulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265744590306771)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'it'
,p_message_text=>'Riferimenti di elemento di pagina in una stringa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265887712306771)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Il numero di pagina a cui si fa riferimento esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750143634307195)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'it'
,p_message_text=>'L''area dispone di un''intestazione riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267178284306772)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'it'
,p_message_text=>'Il report ha un ordine predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403353159307712)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'it'
,p_message_text=>'Protezione stato sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266390677306772)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'it'
,p_message_text=>'Uso errato della sintassi di sostituzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265185260306771)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'it'
,p_message_text=>'Riferimenti con sintassi di sostituzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266113711306772)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'it'
,p_message_text=>unistr('L''autorizzazione della pagina di destinazione \00E8 impostata anche per il componente corrente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750341659307195)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'it'
,p_message_text=>'Stile tema sottoposto a test per l''accesso facilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845190157307277)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'it'
,p_message_text=>unistr('L''interfaccia utente include JavaScript di compatibilit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266821566306772)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento o colonna di convalide associato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266046143306772)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 codice SQL o PL/SQL valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266577944306772)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'it'
,p_message_text=>unistr('Verifica propriet\00E0 Clob')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102266419119306772)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'it'
,p_message_text=>'Funzione V utilizzata nelle istruzioni SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267032962306772)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'it'
,p_message_text=>'Il pulsante a cui si fa riferimento in Se si fa clic sul pulsante esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269462735306774)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'it'
,p_message_text=>'Errore di compilazione: %0. Istruzione: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269745105306774)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'it'
,p_message_text=>'Il collegamento contiene un valore non modificabile per l''ID applicazione corrente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662221946307113)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessun testo della Guida definito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749955212307195)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina \00E8 priva di titolo. I titoli di pagina significativi sono importanti per l''accesso facilitato e per aiutare gli utenti a capire il contenuto e lo scopo della pagina corrente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774198420307217)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('Nell''elemento manca il testo alternativo richiesto per l''immagine. Il testo valido da utilizzare deve descrivere in modo adeguato il contenuto dell''immagine e inoltre non deve ripetere le informazioni gi\00E0 visibili nella pagina visualizzata nel contes')
||unistr('to dell''immagine (per evitare possibili duplicazioni). Nota: se l''immagine \00E8 fornita dagli utenti, dovr\00E0 esserlo anche il testo alternativo dell''immagine, con istruzioni appropriate per aiutare gli utenti a fornire testo di alta qualit\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202464294307558)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'it'
,p_message_text=>'"Uso API runtime" consente la modifica delle applicazioni e delle aree di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267924066306773)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non \00E8 un elemento della pagina %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268075364306773)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non \00E8 un elemento della pagina di destinazione %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750629662307196)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'it'
,p_message_text=>unistr('L''impostazione ''Azione pagina su selezione'' per l''elemento di pagina pu\00F2 causare la modifica imprevista del contesto per l''utente. Scegliere l''impostazione ''Nessuno'' in modo che non si verifichi alcuna modifica del contesto e sostituire la funzionali')
||unistr('t\00E0 con Azioni dinamiche o LOV a catena (se \00E8 necessario rimanere nella stessa pagina). In alternativa, fornire informazioni per l''utente in modo che sappia cosa si verificher\00E0, ad esempio, aggiungendo ''Visualizza una nuova pagina'' nell''etichetta. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773964057307217)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'it'
,p_message_text=>'Definire un''etichetta per l''elemento. Se si preferisce non impostare un''etichetta visibile, definire comunque l''etichetta, ma selezionare il modello di etichetta ''Nascosta''.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751328221307196)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento definisce un valore ''Segnaposto valore'', ma non un''etichetta. Il testo del segnaposto non deve essere utilizzato come unica etichetta dell''elemento, in quanto causa problemi di accesso facilitato. Per migliorare l''accesso facilitato, \00E8 nec')
||'essario definire un''etichetta per l''elemento. Se si preferisce non impostare un''etichetta visibile, definire comunque l''etichetta, ma selezionare il modello di etichetta ''Nascosta''.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270157972306775)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>'Il nome ha una lunghezza di %0 caratteri, ma deve contenere al massimo 30 caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268302027306773)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'%0 potrebbe non esistere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268460489306773)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'%0 potrebbe non essere un elemento di pagina o di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268784032306774)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'La pagina di svuotamento della cache %1 nell''applicazione %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268595710306773)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Pagina %0 inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268646717306773)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'La pagina di destinazione %1 nell''applicazione %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677473505307127)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('Quest''area Attivazione/disattivazione colonna non contiene una colonna con l''attributo ''Usa come intestazione di riga'' impostato su ''S\00EC''. La colonna Intestazione riga deve essere la colonna che identifica in modo ottimale la riga corrente (ad esempio')
||' il nome di un cliente in un report delle informazioni sui clienti).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677591308307127)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('Quest''area Reflow non contiene una colonna con l''attributo ''Usa come intestazione di riga'' impostato su ''S\00EC''. La colonna Intestazione riga deve essere la colonna che identifica in modo ottimale la riga corrente (ad esempio il nome di un cliente in un')
||' report delle informazioni sui clienti).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750258717307195)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('Questa area di form tabulare non contiene una colonna con l''attributo "Usa come intestazione di riga" impostato su S\00EC. La colonna Intestazione riga deve essere la colonna che identifica in modo ottimale la riga corrente (ad esempio il nome del client')
||'e in una tabella di informazioni sul cliente). Queste informazioni vengono utilizzate successivamente durante la presentazione del form tabulare per fornire etichette univoche per i campi form di ogni riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270310189306775)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'it'
,p_message_text=>'Il report non ha un ordine predefinito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202789476307558)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'it'
,p_message_text=>unistr('"Funzione hash segnalibro" \00E8 impostata su un algoritmo precedente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202804943307558)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'it'
,p_message_text=>unistr('La funzione "Protezione stato sessione" \00E8 disabilitata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403106741307711)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'it'
,p_message_text=>unistr('In una pagina con un processo di recupero \00E8 necessario utilizzare Protezione accesso pagina e abilitare la protezione per gli elementi passati mediante l''URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239932518306752)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'it'
,p_message_text=>unistr('L''area contiene l''URL "f?p" che non \00E8 stato passato tramite APEX_UTIL.PREPARE_URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269516766306774)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato rilevato un possibile inserimento SQL. %0 \00E8 utilizzato con sintassi di sostituzione nel codice SQL o PL/SQL oppure con un nome di tabella di processo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267381591306773)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'%0 inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267468809306773)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile fare riferimento a %0 con una sintassi di sostituzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269305339306774)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato definito uno schema di autorizzazione per la pagina di destinazione %1 nell''applicazione %0, ma non per il componente corrente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750468067307195)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'it'
,p_message_text=>unistr('Lo stile di tema corrente per l''applicazione non \00E8 stato sottoposto a test per l''accesso facilitato. Passare a un altro stile di tema con l''attributo Test accesso facilitato eseguito impostato su S\00EC oppure, se lo stile di tema corrente \00E8 stato sottop')
||unistr('osto a test, impostarne l''attributo Test accesso facilitato eseguito su S\00EC nella pagina delle impostazioni del tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845359916307277)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'it'
,p_message_text=>unistr('L''interfaccia utente include la funzione di migrazione jQuery, che facilita la migrazione a una versione pi\00F9 recente di jQuery mediante il ripristino delle interfacce API rimosse e visualizza avvertenze nella console del browser quando vengono utiliz')
||unistr('zate interfacce API rimosse o non pi\00F9 valide. Ci\00F2 comporta l''inserimento di un file JavaScript extra in ogni pagina dell''applicazione. Per informazioni sulla rimozione di tali elementi, vedere la Guida all''aggiornamento della funzione di migrazione j')
||unistr('Query per i dettagli sulle interfacce API da modificare, quindi, dopo aver verificato che tali interfacce API non siano pi\00F9 utilizzate, impostare Includi migrazione jQuery su No.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845276143307277)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'it'
,p_message_text=>unistr('L''interfaccia utente include funzioni JavaScript non pi\00F9 valide o non pi\00F9 supportate. Ci\00F2 comporta l''inserimento di un file JavaScript extra in ogni pagina dell''applicazione. Per informazioni sulla rimozione di tali elementi, vedere la sezione relati')
||unistr('va alle funzioni non pi\00F9 valide delle Note di rilascio. Tale sezione contiene inoltre le istruzioni per il controllo delle dipendenze delle funzioni non pi\00F9 valide o non pi\00F9 supportate e suggerimenti per evitarne l''inclusione nell''applicazione in fut')
||'uro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270009690306775)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna o l''elemento associato non \00E8 definito, ma "Posizione di visualizzazione del messaggio di errore" lo richiede.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269950857306774)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna o l''elemento associato non \00E8 uguale a "%0", specificato nell''espressione di convalida 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102268996520306774)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'it'
,p_message_text=>'Errore di compilazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269047320306774)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessun codice SQL o PL/SQL definito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102267262327306772)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 pi\00F9 lungo di 32767 caratteri. Vengono controllati solo i primi 32767 caratteri. Lunghezza: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102269612696306774)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'it'
,p_message_text=>unistr('Contiene una chiamata di funzione V/NV/DV nell''istruzione SQL. \00C8 possibile che sia un problema di prestazioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270290455306775)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Il pulsante a cui si fa riferimento non esiste pi\00F9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649938370307102)
,p_name=>'AFTER'
,p_message_language=>'it'
,p_message_text=>'Dopo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597241791307048)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'it'
,p_message_text=>'Accordo mancante'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391350246306871)
,p_name=>'ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993514959307389)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'it'
,p_message_text=>'Consenti creazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934946924307346)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Consente l''installazione di applicazioni di produttivit\00E0 e di esempio.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836706469307270)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'it'
,p_message_text=>'Consenti uso dei servizi per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993697384307389)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'Consenti uso di SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993861165307389)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'it'
,p_message_text=>'Consenti uso di Team Development'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993466409307389)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'it'
,p_message_text=>'Consenti rimozione aree di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993752404307389)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'it'
,p_message_text=>'Consenti Websheet Development'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410580520306886)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Tutte le applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227750323306743)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'it'
,p_message_text=>'- Tutto - '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227584072306743)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'it'
,p_message_text=>'Tutte le categorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227800438306743)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'it'
,p_message_text=>'- Tutte le categorie -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996115019307391)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'it'
,p_message_text=>'Tutti i milestone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775511298307219)
,p_name=>'ALL_RELEASES'
,p_message_language=>'it'
,p_message_text=>'Tutte le release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414945954306889)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'it'
,p_message_text=>'tutti i file statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413539251306888)
,p_name=>'ALL_THEMES'
,p_message_language=>'it'
,p_message_text=>'tutti i temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014268743307405)
,p_name=>'ALL_TYPES'
,p_message_language=>'it'
,p_message_text=>'Tutti i tipi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014659387307405)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'it'
,p_message_text=>'- Tutti i tipi -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410627071306886)
,p_name=>'ALL_USERS'
,p_message_language=>'it'
,p_message_text=>'Tutti gli utenti'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398581730307705)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente dispone gi\00E0 di un account APEX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388495763307697)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente esiste gi\00E0 nell''area di lavoro')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354868093307672)
,p_name=>'ALWAYS'
,p_message_language=>'it'
,p_message_text=>'Sempre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664824144307116)
,p_name=>'ANALYSIS'
,p_message_language=>'it'
,p_message_text=>'Analisi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664982634307116)
,p_name=>'ANALYZE'
,p_message_language=>'it'
,p_message_text=>'Analizza per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792578478307235)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'it'
,p_message_text=>'Analizza con il metodo %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412467776306887)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'it'
,p_message_text=>'blocco anonimo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273574382306777)
,p_name=>'ANSWERS'
,p_message_language=>'it'
,p_message_text=>'Risposte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239680265306752)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'it'
,p_message_text=>'(Qualsiasi sviluppatore)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440503286307741)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'it'
,p_message_text=>'Modifiche all''applicazione:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440417395307741)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'it'
,p_message_text=>'Ora:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444518841307744)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'it'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440687757307741)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni di pagina: '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197258272307554)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Una chiamata di interfaccia API \00E8 stata proibita.'),
'Contattare l''amministratore.',
'I dettagli dell''incidente sono disponibili tramite l''ID debug "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298825634306796)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'it'
,p_message_text=>unistr('La chiamata di interfaccia API "%0" non \00E8 pi\00F9 supportata in Application Express versione %1. I dettagli relativi all''incidente sono disponibili tramite l''ID debug "%2".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674783479307125)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'it'
,p_message_text=>'#LABEL# inesistente nella lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951914788307358)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('Mostra solo diramazioni non \00E8 supportato se l''attributo di pagina "Ricarica se si fa clic su Sottometti" \00E8 impostato su "Solo per operazione riuscita".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416673888306891)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della diramazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205925575306726)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione del calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396746080306875)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448209397306917)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di condizione sconosciuto "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201948787306723)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'it'
,p_message_text=>'L''elemento Sfoglia file %0 deve usare la tabella APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179307235306706)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di caricamento "Unisci" non \00E8 supportato per il caricamento nelle raccolte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332570791307656)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'it'
,p_message_text=>'Il tipo di caricamento "Merge" richiede almeno una colonna di chiave primaria nel profilo dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332354513307656)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile analizzare la query SQL di origine caricamento: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332462758307656)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>'La query SQL di origine caricamento deve restituire VARCHAR2, CLOB o BLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609687258307060)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile visualizzare in modo corretto la pagina finestra di dialogo %1 dell''applicazione %0. Assicurarsi che il modello di pagina utilizzato nella pagina %1 sia del tipo "Pagina finestra di dialogo", con il codice JavaScript di inizializzazione, '
||'chiusura e annullamento della finestra di dialogo appropriato definito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429585047307732)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'it'
,p_message_text=>unistr('Copyright \00A9 %0. Tutti i diritti riservati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430300822307732)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Crea area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429453384307732)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'it'
,p_message_text=>unistr('Questo \00E8 un messaggio generato dal sistema, non rispondere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437908346307739)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'it'
,p_message_text=>'Ambiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448500803307747)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'it'
,p_message_text=>'Utente Oracle Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430918085307733)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'it'
,p_message_text=>'Introduzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429604817307732)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'it'
,p_message_text=>'Gentile %0,'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430603902307733)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438057741307739)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'it'
,p_message_text=>'Impedisci rimozione aree di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430877715307733)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'it'
,p_message_text=>unistr('Per evitare che l''area di lavoro venga rimossa, fare clic sul pulsante sottostante e attenersi alle istruzioni visualizzate. Se non si svolge alcuna attivit\00E0 per %0 giorno/i, l''area di lavoro verr\00E0 rimossa in modo automatico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437757103307738)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Non necessaria alcuna azione se l''area di lavoro non \00E8 pi\00F9 indispensabile.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438263832307739)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'it'
,p_message_text=>'L''area di lavoro sta per essere rimossa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437574870307738)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stata rilevata alcuna attivit\00E0 recente per l''area di lavoro %0, che \00E8 stata pianificata per essere rimossa a breve termine.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437488003307738)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'it'
,p_message_text=>'Avvertenza: l''area di lavoro "%0" sta per essere rimossa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437874771307738)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'it'
,p_message_text=>'Data rimozione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438541670307739)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'it'
,p_message_text=>'Completare la richiesta di area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438319872307739)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro "%0" \00E8 pronta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438663327307739)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro "%0" \00E8 stata approvata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438425044307739)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di area di lavoro \00E8 stata rifiutata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430213378307732)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438170646307739)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'it'
,p_message_text=>'Avvertenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430179577307732)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429729626307732)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'it'
,p_message_text=>'Richiesta di area di lavoro approvata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430441681307733)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'it'
,p_message_text=>'Fare clic sul pulsante riportato di seguito per completare il processo di approvazione e impostare la password.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429933079307732)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di area di lavoro \00E8 stata approvata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430517180307733)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'it'
,p_message_text=>'Fare clic sul pulsante in basso per iniziare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430703762307733)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro \00E8 pronta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429861864307732)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'it'
,p_message_text=>'Richiesta di area di lavoro rifiutata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103430095218307732)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di area di lavoro \00E8 stata rifiutata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206330664306727)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('I download non sono supportati se l''attributo di pagina "Ricarica se si fa clic su Sottometti" \00E8 impostato su "Solo per operazione riuscita". Impostare l''attributo di pagina "Ricarica se si fa clic su Sottometti" su "Sempre" oppure utilizzare un proc')
||'esso Prima dell''intestazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740193918307186)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'it'
,p_message_text=>'In coda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740249556307186)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'it'
,p_message_text=>'Inviati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236161460306749)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci di feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236293187306749)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci di feedback aperte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236390691306749)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575304726307028)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il gruppo "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410392837307717)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'it'
,p_message_text=>'Visualizza documentazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318275157306811)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''intestazione HTTP %0 \00E8 stata inviata due volte e potrebbe essere un attacco.'),
'<ul>',
'<li>Primo valore: "%1"</li>',
'<li>Secondo valore: "%2"</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355413780306843)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'it'
,p_message_text=>'Il supporto di stampa deve essere STANDARD, ADVANCED, APEX_LISTENER, AOP o NONE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355534996306843)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''impostazione del primo schema fornito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258879852306766)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'ID applicazione non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774944266307218)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'it'
,p_message_text=>'Indirizzo di posta elettronica non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251195104306760)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'it'
,p_message_text=>'Il valore deve essere pari a zero o un numero intero positivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355664459306843)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'it'
,p_message_text=>'Numero di porta non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802603998307243)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'ID sottoscrizione non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355774803306843)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'it'
,p_message_text=>'Il percorso del wallet deve essere nel file di formato: <filesystempath>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434621711306906)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro non trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434555530306906)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'it'
,p_message_text=>'ID area di lavoro non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459995074306926)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'it'
,p_message_text=>'Il valore non deve essere maggiore di %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370330635306854)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'it'
,p_message_text=>'Il valore "%1" del parametro di istanza "%0" non corrisponde all''espressione regolare "%2"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370205385306854)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Il parametro di istanza "%0" deve avere un valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355827827306843)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'it'
,p_message_text=>'Parametro di istanza non trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798763658307240)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'it'
,p_message_text=>'Password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206069970306726)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'it'
,p_message_text=>'Password (solo per l''autenticazione rispetto al repository degli account utente dell''area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991178071307387)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'it'
,p_message_text=>'Password (solo per l''autenticazione rispetto al repository degli account utente dell''area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884362653307305)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'it'
,p_message_text=>'Password (solo per l''autenticazione rispetto al repository degli account utente dell''area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290384821306790)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'it'
,p_message_text=>'Password (solo per l''autenticazione rispetto al repository degli account utente dell''area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513520975306968)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'it'
,p_message_text=>'Password (solo per l''autenticazione rispetto al repository degli account utente dell''area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798628046307240)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'it'
,p_message_text=>'Password (solo per l''autenticazione rispetto al repository degli account utente dell''area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357712122306845)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'it'
,p_message_text=>'Il protocollo del server di stampa deve essere http o https'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357841258306845)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Schema inesistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357913781306845)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'it'
,p_message_text=>'Schema limitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231241313306745)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231083836306745)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('L''applicazione non esiste pi\00F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035941533307422)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'it'
,p_message_text=>'Assegna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432893730306904)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'it'
,p_message_text=>'Allegati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362923515307678)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'it'
,p_message_text=>'Schede'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236675283306749)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'it'
,p_message_text=>'Chiuso/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233120566306747)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'it'
,p_message_text=>'Commentato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233038915306747)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'it'
,p_message_text=>'commenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236788495306749)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Completato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618172823307068)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'it'
,p_message_text=>'Ha creato questo errore %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207789092306728)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207528902306727)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 certi di voler eliminare questo commento?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020306506307410)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'it'
,p_message_text=>'Elimina problema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217440566306735)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 certi di voler eliminare questo problema?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234776966306748)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'it'
,p_message_text=>'Documento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233669520306747)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'it'
,p_message_text=>'Documenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207605089306727)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148450058307506)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'it'
,p_message_text=>'Modifica commento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148566584307506)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'it'
,p_message_text=>'Modifica problema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231842265306746)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''applicazione specificata non esiste in questa area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232271498306746)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'it'
,p_message_text=>'Errore durante il tentativo di eliminare il commento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232164370306746)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Commento non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232462811306746)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Problema non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232583738306746)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'it'
,p_message_text=>'Errore durante il tentativo di contrassegnare il problema per l''eliminazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231935201306746)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'La pagina specificata non esiste in questa area di lavoro o nell''applicazione fornita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232309549306746)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente non \00E8 autorizzato a eliminare questo commento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232695444306746)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente non \00E8 autorizzato a eliminare questo problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232069671306746)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente non \00E8 autorizzato a modificare la visibilit\00E0 di questo commento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241973129307587)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un problema durante il controllo delle dimensioni dei file. Contattare l''amministratore del sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241830523307587)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'it'
,p_message_text=>unistr('Uno di questi file \00E8 pi\00F9 grande della dimensione massima file di %0 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241748392307587)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'it'
,p_message_text=>unistr('Questo file \00E8 pi\00F9 grande della dimensione massima file di %0 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207884442306728)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'it'
,p_message_text=>'Nascondi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234507107306748)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233468177306747)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'it'
,p_message_text=>'Immagini'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230807264306745)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'un problema non trovato nel sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180201684306707)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'it'
,p_message_text=>'Aggiungi preferenza per l''utente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233220022306747)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'it'
,p_message_text=>'Allega file'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232984367306747)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'it'
,p_message_text=>'Chiuso/i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366842793307681)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'it'
,p_message_text=>'Intestazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234221938306747)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'it'
,p_message_text=>unistr('\00E8 vuoto.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234017970306747)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'it'
,p_message_text=>unistr('Uno di questi file \00E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232856906306746)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'it'
,p_message_text=>'Apri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235360910306748)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Elimina definitivamente elementi selezionati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021219065307410)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'it'
,p_message_text=>'Rimuovi tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235267216306748)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Ricrea istanza elementi selezionati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233384869306747)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di risposta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234176165306747)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'it'
,p_message_text=>'troppo grande per essere caricato. <br>La dimensione del file deve essere minore di'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234474098306748)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'it'
,p_message_text=>'Tipi di file supportati: '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216872759307569)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Selezionare un modello di risposta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233998360306747)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'it'
,p_message_text=>unistr('Questo file \00E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234386149306748)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('non \00E8 un tipo di file supportato.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963798258307367)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'it'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964388078307368)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'it'
,p_message_text=>'Problema di documentazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963843396307367)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'it'
,p_message_text=>'Richiesta di miglioramento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963909041307367)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'it'
,p_message_text=>'Richiesta di funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964200811307368)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'it'
,p_message_text=>'Problemi di installazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964179421307368)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'it'
,p_message_text=>'Problema di prestazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964067766307367)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'it'
,p_message_text=>'Problema di sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964477899307368)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'it'
,p_message_text=>'Problema di formazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965130979307368)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'it'
,p_message_text=>'Amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964802876307368)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'it'
,p_message_text=>'CSS / HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964991059307368)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'it'
,p_message_text=>'Azioni dinamiche/JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964683128307368)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'it'
,p_message_text=>'Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965212058307368)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'it'
,p_message_text=>'Integrazione sistema esterno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964744688307368)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'it'
,p_message_text=>'Integrazione REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965006369307368)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'it'
,p_message_text=>'Sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102964573967307368)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'it'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963626378307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'it'
,p_message_text=>'Categoria assegnata al problema.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962729144307366)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'it'
,p_message_text=>'Categoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963500143307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'it'
,p_message_text=>'Area funzionale interessata dal problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962851362307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'it'
,p_message_text=>'Area funzionale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963497564307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'it'
,p_message_text=>'Livello di importanza assegnato al problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962906927307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'it'
,p_message_text=>'Importanza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963322334307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'it'
,p_message_text=>'Livello d''impegno richiesto per risolvere il problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963055820307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'it'
,p_message_text=>'Livello d''impegno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963254788307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'it'
,p_message_text=>'Stato di avanzamento per la risoluzione del problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102963113195307367)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'it'
,p_message_text=>'Stato di avanzamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965634937307369)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'it'
,p_message_text=>'Backlog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965348421307368)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'it'
,p_message_text=>'Critico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965489668307368)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'it'
,p_message_text=>'Importante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965599109307369)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965796435307369)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'it'
,p_message_text=>unistr('Non verr\00E0 risolto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965882652307369)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'it'
,p_message_text=>'Correzione facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966042787307369)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'it'
,p_message_text=>'Grande impegno di sviluppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102965901282307369)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'it'
,p_message_text=>'Impegno moderato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966415293307369)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'it'
,p_message_text=>'Correzione impossibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966534373307369)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Completato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966283358307369)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'it'
,p_message_text=>'Richiede ulteriori informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966339075307369)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'it'
,p_message_text=>'In attesa di terze parti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966174199307369)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'it'
,p_message_text=>'In fase di elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976633693307377)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'it'
,p_message_text=>unistr('Questo gruppo di etichette non pu\00F2 essere eliminato perch\00E9 uno o pi\00F9 membri sono assegnati a un problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236428489306749)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Ultimo aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102232701205306746)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'it'
,p_message_text=>'Contrassegnato come duplicato di'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020796307307410)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'it'
,p_message_text=>'Assegnatari'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020655813307410)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'it'
,p_message_text=>'Etichette'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021146310307410)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'it'
,p_message_text=>'Milestone'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020596066307410)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230623145306745)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'it'
,p_message_text=>'milestone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966995520307370)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'it'
,p_message_text=>'Blocco codice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967196483307370)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'it'
,p_message_text=>'Release finale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967034685307370)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'it'
,p_message_text=>'Blocco interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235134015306748)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'it'
,p_message_text=>'%0 ha aggiunto un commento a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179266834306706)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'it'
,p_message_text=>'modificato/a.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984226696307382)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'it'
,p_message_text=>unistr('Il numero problema %0 nell''area di lavoro %1 \00E8 stato modificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241669363307587)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stata definita alcuna etichetta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236580544306749)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'it'
,p_message_text=>'Apri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233807026306747)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'it'
,p_message_text=>'Altro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231375897306745)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231161927306745)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina non esiste pi\00F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360414927307676)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Rimuovi tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036024135307422)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230959482306745)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'it'
,p_message_text=>'Associazione applicazione e pagina rimossa da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231656458306746)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'Allegato rimosso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335132680307658)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Sostituire il commento corrente con questo modello?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337141362307659)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Salve! ',
'',
unistr('Questo \00E8 il primo problema in assoluto. \00C8 possibile creare problemi per tenere traccia di task, funzioni, bug e feedback per tutti i progetti APEX personali. Utilizzando il linguaggio Markdown a sintassi abbreviata \00E8 possibile aggiungere etichette ai')
||' problemi, aggiungere assegnatari, impostare milestone e anche applicare la formattazione.  ',
'',
unistr('Di seguito viene illustrato un breve esempio delle possibilit\00E0 offerte dal linguaggio Markdown:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337005101307659)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Benvenuti in Team Development di Oracle APEX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036186962307422)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'it'
,p_message_text=>'- Seleziona -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231723021306746)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'it'
,p_message_text=>'Imposta stato su'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208069920306728)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Mostra azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336910784307659)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'it'
,p_message_text=>'Mostra altri...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231447012306745)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'it'
,p_message_text=>'Sottoscritto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242038847307587)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'it'
,p_message_text=>'%2 nuove notifiche nell''area di lavoro %1 per %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960220668307365)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'it'
,p_message_text=>'Modello utilizzato per registrare un bug.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960127989307364)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'it'
,p_message_text=>'Modello bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960003166307364)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Funzionamento previsto**',
'- Indicare cosa si ritiene si sia verificato.',
'',
'',
'**Funzionamento corrente**',
'- Indicare cosa realmente succede.',
'',
'',
'**Persone o elementi interessati**',
'- Comunicare le persone o gli elementi interessati. ',
'',
'**Possibile soluzione**',
'- Nei limiti del possibile, suggerire come si correggerebbe il bug.',
'',
'**Passi da riprodurre**',
'- Fornire in modo chiaro il set di passi da riprodurre, includendo screenshot e snippet di codice ove opportuno.',
'1.',
'2.',
'3.',
'',
'**Contesto**',
unistr('- Descrivere le caratteristiche dell''operazione in corso quando si \00E8 verificato il bug. Specificare se il bug si verifica solo in determinate condizioni, a certe ore del giorno e cos\00EC via.'),
'',
'**Ambiente**',
'',
'- Versione: ',
'- Piattaforma: ',
'- Sottosistema:',
'',
'______',
'',
'_**NOTA:** per associare un problema a un''applicazione e/o a una pagina, registrare in primo luogo il problema, quindi utilizzare l''elenco a discesa **AZIONI** per associare l''applicazione e la pagina._'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961307503307365)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato rilevato un bug.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961250994307365)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'it'
,p_message_text=>'Rilevato bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961405075307365)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C8 stato registrato un **bug** nel sistema esterno appropriato.'),
'',
'- Sistema di registrazione bug: ',
'- ID bug: ',
'- URL del bug: ',
'',
'Commenti:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960427452307365)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'it'
,p_message_text=>'Modello utilizzato per registrare una richiesta di funzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960342606307365)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'it'
,p_message_text=>'Modello richiesta funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960532985307365)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Riepilogo funzione**',
' - Fornire una panoramica generale di un solo paragrafo della richiesta di funzione.',
'',
'',
'**Contesto**',
unistr(' - Indicare se la richiesta riguarda una situazione o un processo specifici. Ad esempio, "L''esito \00E8 sempre negativo quando [...]"'),
'',
'',
unistr(' - Fornire tutte le informazioni di supporto possibili, allegando screenshot, casi d''uso e cos\00EC via.'),
'',
'',
'**Soluzione preferita**',
'- Fornire una descrizione chiara di cosa si desidera venga implementato.',
'',
'',
'**Soluzioni alternative**',
'- Fornire la descrizione delle soluzioni o delle funzioni alternative prese in considerazione o utilizzate.',
'',
'',
'______',
'_**NOTA:** per associare un problema a un''applicazione e/o a una pagina, registrare in primo luogo il problema, quindi utilizzare l''elenco a discesa **AZIONI** per associare l''applicazione e la pagina._'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961607728307366)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stata presentata una richiesta di funzione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961563219307366)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'it'
,p_message_text=>'Richiesta di funzione presentata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961733774307366)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Una **richiesta di funzione** \00E8 stata presentata nel sistema esterno appropriato.'),
'',
'- Sistema di registrazione funzioni: ',
'- ID funzione: ',
'- URL della definizione della funzione: ',
'',
'Commenti:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962504346307366)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 richiesta un''azione di follow-up.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962433393307366)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'it'
,p_message_text=>'Azione di follow-up richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962682486307366)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Eseguire le azioni seguenti: ',
'',
'1.',
'2.',
'3.',
'4.',
'',
'Commenti: '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960770268307365)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'it'
,p_message_text=>'Modello utilizzato per porre una domanda di procedura.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960684206307365)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'it'
,p_message_text=>'Come...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960877093307365)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Domanda**',
unistr('- Porre la domanda o la richiesta in modo pi\00F9 conciso possibile.'),
'',
'**Contesto generale**',
'- Specificare cosa si sta tentando di fare. ',
'',
'',
'- Indicare inoltre le ricerche effettuate o le persone contattate per trovare una risposta. ',
'',
'',
'**Ambiente** ',
'Specificare se la domanda riguarda in modo specifico un ambiente, un linguaggio di programmazione o un altro settore.',
'',
'______',
'_**NOTE:** per associare un problema a un''applicazione e/o a una pagina, registrare in primo luogo il problema, quindi utilizzare l''elenco a discesa **AZIONI** per associare l''applicazione e la pagina._'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962219638307366)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'it'
,p_message_text=>'Riferimento a un problema noto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962141122307366)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'it'
,p_message_text=>'Problema noto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962353931307366)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'L''analisi ha evidenziato che si tratta un problema noto. Vedere i dettagli riportati di seguito.',
'',
'- Sistema di registrazione bug: ',
'- ID bug: ',
'- URL del bug: ',
'',
'Commenti: '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961948826307366)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'it'
,p_message_text=>'Richiesta di ulteriori informazioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961800550307366)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'it'
,p_message_text=>'Sono necessarie ulteriori informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102962043083307366)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**Sono necessarie pi\00F9 informazioni per questo problema:**'),
'',
'Fornire le informazioni richieste in basso. Senza queste informazioni risulta difficile classificare e tentare di risolvere il problema.',
'',
'',
'Commenti:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961047420307365)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Non verr\00E0 eseguita alcuna azione per il problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102960957043307365)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'it'
,p_message_text=>'Nessuna azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102961133365307365)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Dopo un attento esame della situazione, **non verr\00E0 eseguita alcuna azione per questo problema**. '),
'',
'Commenti:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234804820306748)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'it'
,p_message_text=>'File di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233725982306747)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'it'
,p_message_text=>'File di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230571435306745)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'it'
,p_message_text=>'questo problema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985334805307383)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'ha aggiunto l''allegato %0 a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984315440307382)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'it'
,p_message_text=>'ha aggiunto %0 a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985954213307384)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'it'
,p_message_text=>'ha aggiunto %0 a %1 %2				'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984505024307382)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'it'
,p_message_text=>'ha assegnato %0 a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984940619307383)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'it'
,p_message_text=>'ha associato %0 a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235043806306748)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'it'
,p_message_text=>'ha modificato un commento per %0	%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432764834306904)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'it'
,p_message_text=>'problema modificato %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985897841307383)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'it'
,p_message_text=>unistr('Questo problema \00E8 stato nascosto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984743010307383)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'it'
,p_message_text=>'ha contrassegnato %0 come duplicato di %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985756563307383)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'it'
,p_message_text=>'ha aperto %0 mediante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985498836307383)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'ha rimosso l''allegato %0 da %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984456537307382)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'it'
,p_message_text=>'ha rimosso %0 da %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986020832307384)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'it'
,p_message_text=>'ha rimosso %0 da %1 %2 			'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985574210307383)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'it'
,p_message_text=>'ha impostato lo stato per %0 su %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985136576307383)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'it'
,p_message_text=>'ha eseguito la sottoscrizione a %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984621467307383)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'it'
,p_message_text=>'ha annullato l''assegnazione di %0 in %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985021068307383)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'it'
,p_message_text=>'ha rimosso l''associazione di applicazione e pagina da %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984889405307383)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'it'
,p_message_text=>'ha annullato il contrassegno di %0 come duplicato di %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985221388307383)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'it'
,p_message_text=>'ha annullato la sottoscrizione a %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102985647410307383)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'it'
,p_message_text=>'ha contrassegnato come duplicato di %0 %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230784629306745)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'it'
,p_message_text=>'Non assegnato/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207972163306728)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'it'
,p_message_text=>'Mostra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102231553769306745)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'it'
,p_message_text=>'Non sottoscritto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020484788307410)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'it'
,p_message_text=>'Aggiorna...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234624904306748)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'it'
,p_message_text=>'File ZIP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102233566688306747)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'it'
,p_message_text=>'File ZIP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191883330306715)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non \00E8 un elemento Indirizzo con codifica geografica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330147291307654)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Elemento %0 non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220538136307571)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('Il checksum della pagina offre un metodo semplice per stabilire se la stessa pagina viene distribuita altrove. \00C8 possibile confrontare questo checksum per verificare l''eventuale presenza di una corrispondenza. Le modifiche ai componenti condivisi usa')
||'ti in questa pagina non saranno evidenti nel checksum.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376180322307688)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'it'
,p_message_text=>'Informazioni sull''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375955315307688)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di configurazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376066245307688)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'it'
,p_message_text=>'Selezione stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208556053306728)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'it'
,p_message_text=>'Sono consentiti solo caratteri CFF (Compact Font Format) con un carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208664305306728)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'it'
,p_message_text=>'Sono consentiti solo caratteri CFF (Compact Font Format) con un DICT superiore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208762383306728)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'it'
,p_message_text=>'Sono consentiti solo caratteri CFF (Compact Font Format) con il formato CharString di tipo 2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220918344306738)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('Il carattere non \00E8 stato trovato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220882434306737)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'it'
,p_message_text=>'Sono supportate solo le tabelle cmap con formato 4 e 12.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221233590306738)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'it'
,p_message_text=>'Orientamento pagina non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221002873306738)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'it'
,p_message_text=>unistr('Il PDF non \00E8 stato inizializzato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220745827306737)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'it'
,p_message_text=>'Nessuna tabella secondaria cmap valida trovata nel carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221179984306738)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'it'
,p_message_text=>'Il PDF non contiene pagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656118711307107)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore interno durante la creazione del file PDF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226558351306742)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'it'
,p_message_text=>unistr('Al processo "%0" \00E8 stata assegnata un''area modificabile (non a pi\00F9 righe) non valida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214697202306733)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile richiamare il valore di chiave primaria successivo o precedente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884111608307305)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('Il Web Service non \00E8 stato trovato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421957470306896)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione del processo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241247942306753)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Application Express non \00E8 stato in grado di elaborare la richiesta a causa delle risorse limitate disponibili per la sessione del database. Riprovare pi\00F9 tardi.'),
'<p/>',
'I dettagli relativi all''incidente sono disponibili tramite l''ID debug "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215424164306733)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Durante la distribuzione dell''applicazione si \00E8 verificato il seguente errore: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218164990306735)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Distribuzione applicazione %0 sul server remoto riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221852639306738)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'it'
,p_message_text=>'Distribuzione applicazione %0 come %1 sul server remoto riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856341294307285)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'it'
,p_message_text=>'Autenticazione non riuscita per il servizio SQL abilitato per REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241576492306753)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'it'
,p_message_text=>unistr('Autenticazione non riuscita. La lista di valori utilizza un''origine dati SQL abilitata per REST che fa riferimento a credenziali Web non valide. Ci\00F2 impedir\00E0 di modificare le informazioni sulla colonna per questa LOV. Controllare le credenziali di au')
||'tenticazione. '
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362624139307678)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'it'
,p_message_text=>unistr('Errore di comunicazione. Durante il richiamo dell''origine dati SQL abilitato per REST a cui fa riferimento la lista di valori, si \00E8 verificato un problema che impedisce di modificare le informazioni delle colonne per la lista di valori. Controllare c')
||'he l''origine dati SQL abilitato per REST funzioni correttamente e che le credenziali di autenticazione corrispondenti siano corrette.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857657667307286)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore nel server remoto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832437948307267)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Istanza di SQL abilitato per REST ORDS specificata non trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438243336306909)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'it'
,p_message_text=>'Il server ha inviato un reindirizzamento a: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732721914307179)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('L''istruzione SQL \00E8 pi\00F9 lunga di 32,767 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751484099307196)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Salve, Application Express. Si \00E8 connessi come #USER#.'),
unistr('L''indicatore orario del database locale \00E8: #SYSDATE#.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976587760307377)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'it'
,p_message_text=>unistr('Si sta modificando l''alias per lo schema predefinito dell''area di lavoro. L''impostazione di questo alias comporter\00E0 anche la modifica del prefisso di percorso a livello di area di lavoro. Questa operazione avr\00E0 effetto sull''URL per tutti i servizi RE')
||'STful basati su APEX che potrebbero essere stati definiti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730454335307177)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'it'
,p_message_text=>'%0 riferimenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967876475307370)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'it'
,p_message_text=>'Utility'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967917318307370)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Utility dell''applicazione\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975387496307376)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'it'
,p_message_text=>'Vai a pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975267254307376)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'it'
,p_message_text=>'Vai a Componenti condivisi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968071378307370)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'it'
,p_message_text=>'App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968198885307370)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'it'
,p_message_text=>'Task App Builder > '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968282303307370)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968358573307371)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Elementi di applicazione\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968421194307371)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'it'
,p_message_text=>'Logica applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968549026307371)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'it'
,p_message_text=>'Schemi di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968625255307371)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Sicurezza - Schemi di autenticazione\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968710613307371)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'it'
,p_message_text=>'Schemi di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968839080307371)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Sicurezza - Schemi di autorizzazione\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102968979646307371)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'it'
,p_message_text=>'Indicatori di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969005318307371)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Indicatori di percorso\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969143176307371)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969204833307371)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Opzioni di creazione\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969323797307371)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969478893307371)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Impostazioni componente\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969578843307371)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'it'
,p_message_text=>'Calcoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969682674307372)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Calcoli di applicazione\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969738996307372)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'it'
,p_message_text=>'Crea elemento di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969824366307372)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Crea schema di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102969967913307372)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'it'
,p_message_text=>'Crea opzione di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970040643307372)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Crea calcolo applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970167898307372)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Crea modello di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970240412307372)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'it'
,p_message_text=>'Crea plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970367492307372)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'it'
,p_message_text=>'Crea tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970457797307372)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Crea credenziali Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970584001307372)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'it'
,p_message_text=>'Definizioni caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970624731307372)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Definizioni caricamento dati\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970755152307372)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'it'
,p_message_text=>'Origini dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970838515307372)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi definizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102970952773307372)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971052445307373)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'it'
,p_message_text=>'Layout report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971178040307373)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Layout report\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971257654307373)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'it'
,p_message_text=>'Web Service precedenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971343396307373)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Web Service precedenti\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971449712307373)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'it'
,p_message_text=>'Liste di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971595464307373)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Liste di navigazione classiche\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971675844307373)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971775885307373)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Lista di valori\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971882500307373)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102971965143307373)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'it'
,p_message_text=>'Altri componenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972099104307373)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'it'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972129040307373)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Plugin\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972233904307373)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'it'
,p_message_text=>'Processi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972384444307373)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Processi di applicazione\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972488788307374)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'it'
,p_message_text=>'Query report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972576545307374)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Query report\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972621850307374)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'it'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972725572307374)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'it'
,p_message_text=>'SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972879730307374)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\SQL abilitato per REST\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102972904529307374)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'it'
,p_message_text=>'Sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973046519307374)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'it'
,p_message_text=>'Protezione stato sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973178585307374)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'it'
,p_message_text=>'Imposta protezione stato applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973304319307374)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'it'
,p_message_text=>'Componenti condivisi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973498107307374)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973585577307374)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'it'
,p_message_text=>'Scorciatoie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973680353307374)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Scorciatoie\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973744950307375)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'it'
,p_message_text=>'Schede (precedenti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973842816307375)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973936334307375)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Interfaccia utente - Modelli\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974089458307375)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'it'
,p_message_text=>'Temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974123804307375)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Interfaccia utente - Temi\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974201065307375)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'it'
,p_message_text=>'Interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974361651307375)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Credenziali Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974461435307375)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Sicurezza - Credenziali Web\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974584705307375)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'it'
,p_message_text=>'Origine dati REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974664636307375)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Andare a: Componenti condivisi\Origini dati REST\%LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974721745307375)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974864442307375)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'it'
,p_message_text=>'Crea oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102974985182307375)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Crea %LIST_ITEM_NAME% in SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975073501307375)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'it'
,p_message_text=>'Editor degli script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975165617307376)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'it'
,p_message_text=>'Task SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433945928307735)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento di pagina %0 si basa su una colonna di database, ma l''attributo ''Origine utilizzata'' \00E8 impostato su ''Solo se il valore corrente dello stato di sessione \00E8 NULL''. Ci\00F2 \00E8 molto pericoloso e potrebbe causare la sovrascrittura involontaria dei d')
||unistr('ati quando di visualizzato e salvano pi\00F9 record. Impostare sempre ''Origine utilizzata'' su ''Sempre (sostituisci qualsiasi valore esistente nello stato di sessione)''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371251327307684)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'it'
,p_message_text=>unistr('L''accesso allo stato della sessione \00E8 disabilitato, un tentativo di lettura/scrittura \00E8 stato bloccato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254634646306763)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'it'
,p_message_text=>'Tentativo di salvataggio dell''elemento %0 nello stato delle sessioni durante l''elaborazione della visualizzazione: l''elemento ha una protezione "solo interna".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247463388306758)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'it'
,p_message_text=>unistr('Tentativo di salvataggio dell''elemento %0 nello stato delle sessioni durante l''elaborazione dell''accettazione: l''elemento ha una protezione "solo interna" o non \00E8 un elemento di form che pu\00F2 essere inviato tramite POST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247212642306757)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Il checksum calcolato sui valori di richiesta, di svuotamento di cache, di nome di argomento o di argomento (%0) non corrispondono al checksum passato nella procedura di visualizzazione (%1).',
'',
'Nota: agli utenti finali viene visualizzato un messaggio di errore diverso.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246730880306757)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Tentativo di salvataggio dell''elemento %0 nello stato delle sessioni durante l''elaborazione della visualizzazione. Il livello di protezione dell''elemento \00E8:'),
'%1.',
'',
unistr('Non \00E8 stato passato alcun checksum oppure il checksum \00E8 adatto a un elemento con livello di protezione "%2".'),
'',
'Nota: agli utenti finali viene visualizzato un messaggio di errore diverso.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421716413306895)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'ERR-1022 Impossibile salvare gli attributi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191371220306715)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'it'
,p_message_text=>'Impossibile convertire il valore SDO_GEOMETRY in GeoJSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188828707306713)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'it'
,p_message_text=>'Impossibile convertire il testo in un oggetto SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190084443306714)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'it'
,p_message_text=>'%0 non contiene dati GeoJSON validi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205602624306726)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il calcolo del valore predefinito per la colonna #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206504430306727)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Errore durante l''elaborazione del processo di eliminazione di pi\00F9 righe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448733794306918)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 richiesta una colonna di checksum ("FCS") ma non \00E8 stata fornita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448921644306918)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato fornito alcun valore di chiave primaria. Per eseguire gli aggiornamenti, \00E8 necessario fornire almeno una riga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449743499306918)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato fornito alcun valore secondario per la colonna chiave secondaria identificata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589315993307041)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'it'
,p_message_text=>'nessun dato trovato nel form tabulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448604052306917)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna della chiave primaria non \00E8 stata specificata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449641214306918)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna chiave secondaria identificata non \00E8 stata individuata nella lista di selezione della query')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448596930306917)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'it'
,p_message_text=>'Nome tabella non specificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448414908306917)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'it'
,p_message_text=>'Proprietario tabella non specificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469643042306934)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Errore durante l''elaborazione del processo di aggiornamento di pi\00F9 righe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229865679306744)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile copiare il tema "%0" nell''applicazione "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427429025307730)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Il tema importato non \00E8 compatibile con il tema corrente.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409563753307716)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'it'
,p_message_text=>unistr('Il numero del tema non \00E8 valido oppure il tema non \00E8 un tema dell''interfaccia utente corrente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370385952307684)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Colonne Chiave primaria e Chiave padre richieste per il calcolo della gerarchia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370447378307684)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Colonna livello nodo e Colonna stato nodo richieste quando la gerarchia non viene calcolata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388719993307697)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'it'
,p_message_text=>'Aspetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147734626307506)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362282433306848)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 scuro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362304173306848)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147672678307506)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 evidenziazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791165319307234)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Selezionare un''interfaccia utente dalla lista riportata di seguito:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793439438307235)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'it'
,p_message_text=>'%0 - Selezione interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332951958306825)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'it'
,p_message_text=>'Accesso non autorizzato (variabile di package del gruppo di sicurezza non impostata).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333333075306826)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile recuperare o trovare le informazioni sull''utente. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319136621306811)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'it'
,p_message_text=>'L''utente %0 richiede il privilegio ADMIN per eseguire questa operazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333254010306825)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'it'
,p_message_text=>'L''utente %0 non ha fornito un indirizzo di posta elettronica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289003491306789)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'it'
,p_message_text=>'Accesso non autorizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333100099306825)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''utente %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248191421306758)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'it'
,p_message_text=>unistr('Alla convalida "%0" \00E8 stata assegnata un''area modificabile (non a pi\00F9 righe) non valida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421826359306896)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371621464307685)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'it'
,p_message_text=>unistr('Application Express non \00E8 in grado di calcolare un profilo dati da un tipo di dati di risposta: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838369754307272)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'it'
,p_message_text=>'Tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838242104307271)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'it'
,p_message_text=>'Riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358298840307675)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'it'
,p_message_text=>unistr('L''espressione di filtro non \00E8 una notazione JSON valida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351433090307670)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'it'
,p_message_text=>'Filtro non supportato da Oracle REST Data Services.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730355443307177)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'it'
,p_message_text=>unistr('Il parametro URL di impaginazione "%0" \00E8 in conflitto con un parametro di origine REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833285823307268)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'it'
,p_message_text=>'HTTP 200: operazione riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833390259307268)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'it'
,p_message_text=>'HTTP 201: creato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832792970307267)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'it'
,p_message_text=>'HTTP 400: richiesta non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832568755307267)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'it'
,p_message_text=>'HTTP 401: non autorizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832883394307267)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'it'
,p_message_text=>'HTTP 403: vietato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832672542307267)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'it'
,p_message_text=>'HTTP 404: non trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832965537307267)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'it'
,p_message_text=>'HTTP 405: metodo non consentito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190674204306715)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'it'
,p_message_text=>'HTTP 407: richiesta autenticazione proxy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190914797306715)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'it'
,p_message_text=>'HTTP 409: conflitto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190765958306715)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'it'
,p_message_text=>'HTTP 412: precondizione non riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190845672306715)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'it'
,p_message_text=>'HTTP 428: richiesta precondizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833041531307267)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'it'
,p_message_text=>'HTTP 500: errore server interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833139389307268)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'it'
,p_message_text=>'HTTP 502: gateway non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372052347307685)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'it'
,p_message_text=>'HTTP 503: servizio non disponibile'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372147064307685)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'it'
,p_message_text=>'HTTP 504: timeout del gateway'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214279095307567)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'it'
,p_message_text=>'L''origine dati REST ha restituito un errore HTTP: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832317918307267)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Origine dati REST non trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388190178306868)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Il selettore di righe "%0" non ha selezionato un array di oggetti da trattare come tabella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388246933306868)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Il selettore di righe "%0" non ha selezionato un oggetto da trattare come riga singola.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193877338306717)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'it'
,p_message_text=>unistr('Il limite di frequenza dell''origine dati REST (%0 richieste in %1 secondi) \00E8 stato superato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182839511306709)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'it'
,p_message_text=>unistr('Il limite di frequenza dell''origine dati REST (%0 richieste in %1 secondi) \00E8 stato superato e il tempo di attesa necessario \00E8 troppo lungo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214145795307567)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'it'
,p_message_text=>'Il parametro obbligatorio IN "%0" di tipo "%1" dell''origine REST deve avere un valore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132186660307494)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'it'
,p_message_text=>unistr('Il corpo della risposta \00E8 troppo grande per essere visualizzato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797528292307239)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'it'
,p_message_text=>'Il servizio REST ORDS precedente utilizza dimensioni pagina fisse piccole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197445878306720)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Questa chiamata API sincronizza le colonne della tabella in modo dinamico con ',
'-- il profilo dati dell''origine dati REST eseguendo le istruzioni ALTER TABLE. ',
unistr('-- Se un tipo di dati della colonna non pu\00F2 essere modificato con ALTER TABLE, verr\00E0 '),
'-- richiamato un messaggio di errore.',
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196393279306719)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Impossibile applicare automaticamente le modifiche al profilo dati. Le colonne della tabella locale devono essere regolate manualmente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197516839306720)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- A partir\00E0 da %0 eseguir\00E0:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195506452306718)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'it'
,p_message_text=>'Il metodo di sincronizzazione Unisci richiede la definizione di una chiave primaria nel profilo dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195838079306718)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'La tabella locale e il profilo dati non hanno colonne in comune.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182441665306708)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'it'
,p_message_text=>'Job interrotto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196076767306719)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196113432306719)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'it'
,p_message_text=>'Incompleto (limite richieste superato)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196237025306719)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'it'
,p_message_text=>unistr('Il job \00E8 gi\00E0 in esecuzione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183319123306709)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'it'
,p_message_text=>'In esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183442803306709)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'it'
,p_message_text=>'Pianificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195906893306719)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195644329306718)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'it'
,p_message_text=>'Passo di sincronizzazione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195710594306718)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'it'
,p_message_text=>'%0 (Nuovo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680492677307130)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'it'
,p_message_text=>'Operazione di test'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751552758307196)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'it'
,p_message_text=>'Timeout superato durante il recupero di tutti i dati di origine REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727432980307174)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'it'
,p_message_text=>'I filtri SQL locali correnti richiedono un numero eccessivo di richieste "Pagina successiva" al servizio REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797423739307239)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensioni pagina fisse sconosciute per il servizio REST ORDS precedente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503846917306961)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'it'
,p_message_text=>'Dirama a pagina amministrativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478321421306941)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499981415306958)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'it'
,p_message_text=>'Commentato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484447298306946)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484715774306946)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'it'
,p_message_text=>'Aggiungi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485117256306946)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiungi pi\00F9 utenti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485213335306946)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'it'
,p_message_text=>'Aggiungi utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485361328306946)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'it'
,p_message_text=>'Aggiungi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484132235306945)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'it'
,p_message_text=>'Applica modifiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484288386306946)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484351339306946)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484081869306945)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'it'
,p_message_text=>'Crea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473367144306937)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484527468306946)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'it'
,p_message_text=>'Elimina selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484629353306946)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484818254306946)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473187876306937)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'it'
,p_message_text=>'Vai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473856340306938)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'it'
,p_message_text=>'Carica dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102484911206306946)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'it'
,p_message_text=>'Collega'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473510243306937)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473400402306937)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473211753306937)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473674042306937)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473730064306938)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Sottometti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485480271306946)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Sottometti feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485096998306946)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'it'
,p_message_text=>'Visualizza dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478297481306941)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta :%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497449057306956)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'it'
,p_message_text=>'Serie %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489801742306950)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'it'
,p_message_text=>'Ruoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478052698306941)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488893767306949)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0 per ora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488168389306949)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'it'
,p_message_text=>'Sessioni dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477936777306941)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'Allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477161864306940)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'it'
,p_message_text=>'Automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487771435306948)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo medio trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487110190306948)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488753521306949)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Contesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486082506306947)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485747551306947)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488043408306948)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti distinti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476976751306940)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486864728306948)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489708095306950)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'it'
,p_message_text=>'Terminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487416391306948)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477061664306940)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'it'
,p_message_text=>'Errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489629782306950)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485551781306947)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'it'
,p_message_text=>'Funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477606143306941)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477415020306940)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'it'
,p_message_text=>'Archiviato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490007124306950)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'it'
,p_message_text=>'Presentato da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488515620306949)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni pagina intera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487316573306948)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Ricerca IR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486190142306947)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486480576306947)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Ultima attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487689822306948)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo massimo trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487841023306948)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo mediano trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489213069306949)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489398724306949)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di messaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487581001306948)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo minimo trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489147262306949)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'it'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487280440306948)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'it'
,p_message_text=>'Numero di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488660291306949)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'it'
,p_message_text=>'Ricorrenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486965543306948)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488904347306949)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'it'
,p_message_text=>'Eventi di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487053436306948)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486544579306947)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488214272306949)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488492197306949)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni di pagina parziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489481325306949)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore chiave primaria '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477525963306940)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'it'
,p_message_text=>'Valutazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489968837306950)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'it'
,p_message_text=>'Causa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477728311306941)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'it'
,p_message_text=>'Risposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489083084306949)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'it'
,p_message_text=>'Righe recuperate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477300460306940)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'it'
,p_message_text=>'Pianificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477241409306940)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'it'
,p_message_text=>'Avviato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485659941306947)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102489576545306950)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe riuscite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486786647306947)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'it'
,p_message_text=>'Indicatore orario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102488326047306949)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485984025306947)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'it'
,p_message_text=>'Autore aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102485807353306947)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'it'
,p_message_text=>'Aggiornato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486698158306947)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'it'
,p_message_text=>'Utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486372281306947)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102477866890306941)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'it'
,p_message_text=>'User Agent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102486231855306947)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102487956054306948)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'it'
,p_message_text=>'Prestazioni ponderate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470596878306935)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo chiusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483447841306945)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483973702306945)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'it'
,p_message_text=>'Modifica filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483548873306945)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'it'
,p_message_text=>'Crea pulsante - Finestra di dialogo chiusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483687063306945)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'it'
,p_message_text=>'Modifica report - Finestra di dialogo chiusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483712741306945)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Esegue la ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483848302306945)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'it'
,p_message_text=>'Aggiorna report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473018941306937)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'it'
,p_message_text=>'Set di caratteri file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472612965306937)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'it'
,p_message_text=>'Ruoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496230403306955)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quando il controllo dell''accesso \00E8 abilitato, gli amministratori possono limitare l''accesso degli utenti autenticati a determinate funzioni dell''applicazione. Questa applicazione supporta i tre ruoli seguenti: Lettore, Collaboratore e Amministrato')
||'re.</p>',
'<ul>',
'  <li>I <strong>lettori</strong> hanno accesso in sola lettura a tutte le informazioni e possono anche visualizzare i report.</li>',
'  <li>I <strong>collaboratori</strong> possono creare, modificare ed eliminare le informazioni e visualizzare i report.</li>',
unistr('  <li>Gli <strong>amministratori</strong>, oltre alle funzionalit\00E0 previste per i collaboratori, possono eseguire anche la configurazione dell''applicazione.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496004227306955)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'it'
,p_message_text=>unistr('Qualsiasi utente autenticato pu\00F2 accedere a questa applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496154334306955)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Scegliere <strong>No</strong> se tutti gli utenti sono definiti nella lista di controllo dell''accesso. Scegliere <strong>S\00EC</strong>, se questa applicazione pu\00F2 essere usata anche dagli utenti autenticati che non si trovano nella lista di controllo d')
||'ell''accesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494398100306953)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formati data/numero da usare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494449388306954)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere se fornire formati di visualizzazione personalizzati o usare quelli standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496863697306955)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'Allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495863837306955)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'it'
,p_message_text=>'Automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494535407306954)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'it'
,p_message_text=>'Set di caratteri file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493389609306953)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'it'
,p_message_text=>'Copia e incolla dati delimitati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494642612306954)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'it'
,p_message_text=>'Simbolo valuta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494792605306954)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'it'
,p_message_text=>'Se i dati contengono un simbolo di valuta internazionale, immetterlo qui. Ad esempio, se i dati contengono "&euro;1.234,56" o "&yen;1.234,56", immettere "&euro;" o "&yen;". In caso contrario, i dati non verranno caricati correttamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493039761306952)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'it'
,p_message_text=>'Origine importazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495073689306954)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'it'
,p_message_text=>'Carattere decimale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495179401306954)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il carattere decimale separa la parte intera dalla parte decimale di un numero.</p>',
unistr('<p> Qualunque carattere pu\00F2 fungere da separatore decimale, purch\00E9 sia a byte singolo e diverso dal separatore delle migliaia. Il carattere pu\00F2 essere uno spazio, ma non un carattere numerico n\00E9 alcuno dei seguenti caratteri:</p>'),
'<ul class="noIndent">',
unistr('<li>segno pi\00F9 (+)</li>'),
'<li>trattino (-)</li> ',
'<li>segno minore di (<)</li>',
'<li>segno maggiore di (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472271811306936)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496980360306955)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'it'
,p_message_text=>'Abilita allegati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493644092306953)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'it'
,p_message_text=>'Facoltativamente racchiuso da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472519538306937)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un carattere delimitatore. \00C8 possibile utilizzare questo carattere per definire il limite iniziale e finale di un valore dei dati. Se si specifica un carattere delimitatore, Data Workshop ignora gli spazi vuoti prima del limite iniziale e f')
||unistr('inale di un valore dei dati. \00C8 possibile anche utilizzare questa opzione per racchiudere un valore dei dati con il carattere delimitatore specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496758248306955)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'it'
,p_message_text=>'Esperienza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494013310306953)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'it'
,p_message_text=>'Riga/e non riuscite:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472722145306937)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497025026306956)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'it'
,p_message_text=>'Archiviato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493163567306953)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493205626306953)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Nome del file da caricare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493770496306953)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare questa casella se i dati contengono nomi di colonne nella prima riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494808064306954)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'it'
,p_message_text=>'Separatore di gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494947151306954)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Il separatore delle migliaia \00E8 un carattere che separa gruppi di numeri interi, per mostrare ad esempio migliaia e milioni.</p>'),
unistr('<p>Qualsiasi carattere pu\00F2 fungere da separatore delle migliaia, purch\00E9 sia a byte singolo e diverso da qualsiasi altro carattere decimale. Il carattere pu\00F2 essere uno spazio, ma non pu\00F2 essere un carattere numerico n\00E9 alcuno dei seguenti:</p>'),
'<ul class="noIndent">',
unistr('<li>segno pi\00F9 (+)</li>'),
'<li>trattino (-)</li> ',
'<li>segno minore di (<)</li>',
'<li>segno maggiore di (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493896557306953)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'it'
,p_message_text=>'Riga/e inserite:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472884485306937)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472442114306937)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497142937306956)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'it'
,p_message_text=>'Valutazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492808447306952)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'it'
,p_message_text=>'Memorizza nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492992314306952)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Quando si seleziona questa casella di controllo, l''applicazione salva il nome utente nel cookie browser persistente denominato "LOGIN_USERNAME_COOKIE".',
'Durante il successivo accesso alla pagina di login,',
unistr('il campo del nome utente verr\00E0 popolato in modo automatico con questo valore.'),
'</p>',
'<p>',
unistr('Se si deseleziona la casella di controllo e il nome utente \00E8 stato gi\00E0 salvato nel cookie,'),
unistr('l''applicazione sovrascriver\00E0 il cookie con un valore vuoto.'),
unistr('\00C8 inoltre possibile usare gli strumenti di sviluppatore del browser per rimuovere completamente il cookie.'),
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497227417306956)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'it'
,p_message_text=>'Risposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494191357306953)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'it'
,p_message_text=>'Righe da controllare:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472048160306936)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472119809306936)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'it'
,p_message_text=>'Cerca...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493492745306953)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'it'
,p_message_text=>'Separatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493510212306953)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'it'
,p_message_text=>'Identificare un carattere separatore di colonne. Utilizzare <code>\t</code> per la separazione con tabulazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102494298396306953)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizzare le impostazioni avanzate per il caricamento dati: Simbolo valuta, Caratteri decimali, Codifica file o Formati data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495937339306955)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'it'
,p_message_text=>'Avviato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472915508306937)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495558791306954)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'it'
,p_message_text=>'Preferenza tema utente finale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495636083306954)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Se l''opzione viene selezionata, gli utenti finali possono scegliere uno stile tema personale utilizzando il collegamento Personalizza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495300140306954)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'it'
,p_message_text=>'Stile tema desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495419207306954)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Lo stile tema predefinito viene applicato a tutti gli utenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495247604306954)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'it'
,p_message_text=>'Intervallo di tempo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102493952145306953)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'it'
,p_message_text=>'Riga/e aggiornate:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102472379770306936)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496391655306955)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'it'
,p_message_text=>'Nomi utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496550869306955)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere i nomi utente separati da virgole, punti e virgola o spazi. I nomi utente esistenti o duplicati verranno ignorati automaticamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496410677306955)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'it'
,p_message_text=>'Immettere qui i nomi utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102496665967306955)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497319263306956)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'it'
,p_message_text=>'User Agent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102495777838306955)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'it'
,p_message_text=>'Visualizza come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475083217306939)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'it'
,p_message_text=>'Controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474982887306939)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'it'
,p_message_text=>unistr('Report attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499695823306957)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'it'
,p_message_text=>'Amministrazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474840378306938)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Configurazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475293159306939)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'it'
,p_message_text=>'Generazione report di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475189439306939)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499505558306957)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione delle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475370390306939)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'it'
,p_message_text=>'Generazione report su job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499426231306957)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499770605306958)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474762886306938)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'it'
,p_message_text=>'Interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499838691306958)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'it'
,p_message_text=>'Gestisci componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475520490306939)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'it'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475632692306939)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'it'
,p_message_text=>'Logout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475452583306939)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'it'
,p_message_text=>'Passo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497604790306956)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'it'
,p_message_text=>'Riga per pagina del report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499140739306957)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'it'
,p_message_text=>'Confermato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498555813306957)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499352540306957)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'it'
,p_message_text=>'Chiuso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497819660306956)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'it'
,p_message_text=>'Copia e incolla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498165960306956)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'it'
,p_message_text=>'Usa formati di visualizzazione standard applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498224042306956)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Fornisci formati personalizzati per le colonne caricate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498633774306957)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'it'
,p_message_text=>'Indirizzi di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498311118306957)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'it'
,p_message_text=>'Consenti agli utenti finali di scegliere lo stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497927948306956)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'it'
,p_message_text=>'La prima riga contiene nomi di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498935528306957)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'it'
,p_message_text=>'Negativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498845755306957)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'it'
,p_message_text=>'Neutra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499088427306957)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102499281849306957)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'it'
,p_message_text=>'Aperto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498766318306957)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'it'
,p_message_text=>'Positiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498476391306957)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102498015902306956)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Usa impostazioni avanzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497727530306956)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'it'
,p_message_text=>'Carica file separato da virgole (*.csv) o delimitato da tabulazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501758556306959)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'it'
,p_message_text=>unistr('Dashboard attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476279260306940)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiungi pi\00F9 utenti - Passo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476444734306940)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiungi pi\00F9 utenti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501381655306959)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'it'
,p_message_text=>'Amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501421752306959)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>La pagina di amministrazione consente ai proprietari dell''applicazione (amministratori) di configurare l''applicazione e gestire i dati comuni usati in tutta l''applicazione.',
unistr('Se si seleziona una delle impostazioni disponibili, gli amministratori possono eventualmente modificare la modalit\00E0 di visualizzazione e/o le funzioni disponibili per gli utenti finali.</p>'),
'<p>L''accesso a questa pagina dovrebbe essere limitato solo agli amministratori.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501982137306959)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'it'
,p_message_text=>'Log automazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502084879306959)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina fornisce un report interattivo del log delle automazioni.</p>',
unistr('<p>Rivedere le informazioni registrate relative alle precedenti esecuzioni delle automazioni. Il log contiene gli indicatori orari di inizio e fine, nonch\00E9 i dettagli relativi alle righe elaborate (riuscite e con errori). Eseguire il drill-down di Me')
||'ssaggi per visualizzare i singoli messaggi relativi alle righe elaborate.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501687174306959)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le impostazioni di configurazione consentono di rendere funzionalit\00E0 specifiche disponibili (abilitate) o non disponibili (disabilitate) per gli utenti finali.</p>'),
unistr('<p>Se una funzione specifica non \00E8 pronta al 100% o deve essere temporaneamente rimossa, fare clic su <strong>Disabilitata</strong>.'),
'Una volta resa disponibile, fare semplicemente clic su <strong>Abilitata</strong>.</p>',
unistr('<p><em><strong>Nota:</strong> le modifiche apportate in questo campo non saranno evidenti ai singoli utenti che eseguono attualmente l''applicazione. Le impostazioni delle funzioni riviste verranno richiamate una volta che l''utente finale si sar\00E0 scol')
||'legato e poi ricollegato.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503008224306960)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'it'
,p_message_text=>'Configura controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503120135306960)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare l''opzione appropriata per qualsiasi utente autenticato.<br>',
unistr('Se si seleziona <strong>No</strong>, si garantisce maggiore sicurezza all''applicazione poich\00E9 solo gli utenti specificati potranno accedere all''applicazione.'),
unistr('Tuttavia, se la community di utenti dell''applicazione \00E8 estesa, gestirli tutti potrebbe diventare oneroso. In questo caso, sarebbe preferibile scegliere <strong>S\00EC</strong> e immettere solo gli amministratori dell''applicazione ed eventualmente i coll')
||'aboratori.<br>',
unistr('Se si seleziona <strong>S\00EC</strong>, \00E8 necessario selezionare anche come gestire gli utenti non inclusi nell''apposita lista.</p>'),
'<p>Effettuare una selezione tra la richiesta di indirizzi di posta elettronica e qualsiasi valore numerico per Nomi utente.<br>',
unistr('In genere, \00E8 consigliabile impostare questa opzione su <strong>Indirizzo di posta elettronica</strong> se l''applicazione utilizza (o verr\00E0 configurata per usare) uno schema di autenticazione centralizzato come Oracle Access Manager o SSO.</p>'),
'<p><em><strong>Nota:</strong> questa applicazione supporta i tre livelli di accesso seguenti: Lettore, Collaboratore e Amministratore.',
'<ul>',
'  <li>I <strong>lettori</strong> hanno accesso in sola lettura a tutte le informazioni e possono visualizzare i report.</li>',
'  <li>I <strong>collaboratori</strong> possono creare, modificare ed eliminare le informazioni e visualizzare i report.</li>',
unistr('  <li>Gli <strong>amministratori</strong>, oltre alla funzionalit\00E0 previste per i collaboratori, possono eseguire anche la configurazione dell''applicazione accedendo alla sezione Amministrazione dell''applicazione.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502564374306960)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'it'
,p_message_text=>'Log degli errori dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502652509306960)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina fornisce un report interattivo di tutti gli errori imprevisti registrati dall''applicazione specifica.</p>',
'<p>Fare clic sulle intestazioni di colonna per ordinare e filtrare i dati oppure fare clic sul pulsante <strong>Azioni</strong> per personalizzare la visualizzazione della colonna e molte funzioni avanzate aggiuntive. Fare clic sul pulsante <strong>R'
||'eimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503365759306960)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503486600306960)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503560366306961)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p><strong>Abilita allegati</strong>: se l''impostazione \00E8 S\00EC, gli utenti potranno caricare un allegato a supporto del proprio feedback.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476351688306940)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'it'
,p_message_text=>'Feedback sottomesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476056601306939)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'it'
,p_message_text=>'Pagina globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475726144306939)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'it'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500456033306958)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic sull''icona di feedback (<span class="fa fa-comment-o" aria-hidden="true"></span>) nella barra di navigazione, in qualsiasi pagina dell''applicazione, per lasciare un feedback agli amministratori dell''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500237754306958)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Questa \00E8 la home page dell''applicazione. Fare clic sulle schede per accedere alle varie pagine dell''applicazione o utilizzare il menu di navigazione sul lato della pagina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500821435306958)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic sul menu a discesa del proprio nome nella barra di navigazione per scollegarsi dall''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500706493306958)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic sul menu dell''utente (<span class="fa fa-user" aria-hidden="true"></span>) nella barra di navigazione per aggiornare la preferenza di fuso orario e scollegarsi dall''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500150079306958)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'it'
,p_message_text=>'Home page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500399449306958)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Questa \00E8 la home page dell''applicazione. Fare clic sulle schede per accedere alle varie pagine dell''applicazione o utilizzare il menu di navigazione nella parte superiore della pagina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500628598306958)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Fare clic sul menu dell''utente (<span class="fa fa-user" aria-hidden="true"></span>) nella barra di navigazione (in alto a destra) per accedere al proprio profilo utente e scollegarsi dall''applicazione.<br>',
unistr('Se si fa clic su <strong>Visualizza profilo personale</strong>, \00E8 poi possibile fare clic su <strong>Aggiorna profilo</strong> per immettere i dettagli personali e caricare una foto o un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500577999306958)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Fare clic sul menu dell''utente (<span class="fa fa-user" aria-hidden="true"></span>) nella barra di navigazione per accedere al proprio profilo utente, aggiornare la preferenza di fuso orario e scollegarsi dall''applicazione.<br>',
unistr('Se si fa clic su <strong>Visualizza profilo personale</strong>, \00E8 poi possibile fare clic su <strong>Aggiorna profilo</strong> per immettere i dettagli personali e caricare una foto o un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501028571306959)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00C8 possibile inserire, aggiornare ed eliminare i dati direttamente all''interno di questa griglia interattiva.<br>'),
'  Inserire una nuova riga facendo clic sul pulsante Aggiungi riga.<br>',
'  Fare doppio clic in una cella o fare clic sul pulsante <strong>Modifica</strong> per aggiornare i valori dei dati, analogamente a quanto accede durante la modifica dei dati in un foglio di calcolo.</p>',
'',
'<p>Usare il menu Azioni riga (<span class="fa fa-bars" aria-hidden="true"></span>) nella parte superiore del report per duplicare, eliminare, aggiornare o ripristinare le righe selezionate.<br> ',
'  Usare il menu Azioni riga sulle singole righe per accedere anche alla visualizzazione di una singola riga o per aggiungere una nuova riga.</p>',
'',
'<p>Per trovare i dati, immettere un termine di ricerca nell''apposita finestra di dialogo o fare clic sulle intestazioni di colonna per limitare il numero di record restituiti.</p>',
'',
unistr('<p>\00C8 possibile eseguire numerose funzioni facendo clic sul pulsante <strong>Azioni</strong>, ad esempio selezionare le colonne visualizzate/nascoste e la relativa sequenza di visualizzazione, oltre a diverse funzioni relative a dati e formati. Inoltr')
||unistr('e, \00E8 possibile definire un''ulteriore vista dei dati utilizzando l''opzione basata sul grafico.</p>'),
'',
'<p>Se si desidera salvare le personalizzazioni, selezionare il report o fare clic su Download per scaricare i dati.<p>',
'',
'<p>Per ulteriori informazioni, fare clic su ? nella parte inferiore del menu Azioni.</p>',
'',
'<p>Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite della griglia interattiva.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501190396306959)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Per trovare i dati, immettere un termine di ricerca nell''apposita finestra di dialogo oppure fare clic sulle intestazioni di colonna per limitare il numero di record restituiti.</p>',
'',
unistr('<p>\00C8 possibile eseguire numerose funzioni facendo clic sul pulsante <strong>Azioni</strong>, ad esempio selezionare le colonne visualizzate/nascoste e la relativa sequenza di visualizzazione, oltre a diverse funzioni relative a dati e formati. Inoltr')
||unistr('e, \00E8 possibile definire una vista aggiuntiva dei dati usando l''opzione basata sul grafico.</p>'),
'',
'<p>Se si desidera salvare le personalizzazioni, selezionare il report o fare clic su Download per scaricare i dati.<p>',
'<br>',
'<p>Per ulteriori informazioni, fare clic su ? nella parte inferiore del menu Azioni.</p>',
'',
'<p>Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500955596306959)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Per trovare i dati, immettere un termine di ricerca nell''apposita finestra di dialogo oppure fare clic sulle intestazioni di colonna per limitare il numero di record restituiti.</p>',
'',
unistr('<p>\00C8 possibile eseguire numerose funzioni facendo clic sul pulsante <strong>Azioni</strong>, ad esempio selezionare le colonne visualizzate/nascoste e la relativa sequenza di visualizzazione, oltre a diverse funzioni relative a dati e formati. Inoltr')
||unistr('e, \00E8 possibile definire ulteriori viste dei dati usando le opzioni basate su grafici, raggruppamenti e pivot.</p>'),
'',
'<p>Se si desidera salvare le personalizzazioni, selezionare il report o fare clic su Download per scaricare i dati. Immettere il proprio indirizzo di posta elettronica e il periodo di tempo previsto dalla sottoscrizione durante il quale i dati devono'
||' essere inviati regolarmente.<p>',
'',
'<p>Per ulteriori informazioni, fare clic su ? nella parte inferiore del menu Azioni.</p>',
'',
'<p>Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475841929306939)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'it'
,p_message_text=>'Pagina di login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102475919590306939)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'it'
,p_message_text=>'%0 - Esegui login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502720234306960)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'it'
,p_message_text=>'Messaggi di log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503658736306961)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Gestisci feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503703832306961)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gli utenti finali possono immettere un feedback da qualsiasi pagina standard all''interno dell''applicazione.</p>',
'<p>Questo report mostra il feedback immesso, qualsiasi risposta fornita dagli amministratori e lo stato del feedback.</p>',
'<p>Fare clic sull''icona di modifica (matita gialla) per immettere una risposta o aggiornare lo stato del feedback.</p>',
'<p><em><strong>Nota:</strong> se i destinatari del feedback sono stati definiti, gli invii del feedback verranno trasmessi tramite posta elettronica agli indirizzi presenti nella lista dei destinatari del feedback.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502800283306960)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'it'
,p_message_text=>'Gestisci accesso utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502927682306960)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina mostra un report degli utenti dell''applicazione e il livello di accesso concesso.</p>',
'<p>Fare clic sulle intestazioni di colonna per ordinare e filtrare i dati oppure fare clic sul pulsante <strong>Azioni</strong> per personalizzare la visualizzazione della colonna e molte funzioni avanzate aggiuntive.<br>',
'Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>',
'<p>Fare clic sull''icona di modifica (matita gialla) per modificare i dettagli e il livello di accesso dell''utente o per eliminare l''utente.</p>',
'<p>Fare clic su <strong>Aggiungi utente</strong>, nella parte superiore del report, per aggiungere un nuovo utente e il rispettivo livello di accesso.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503287049306960)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questo form per immettere gli utenti, i rispettivi indirizzi di posta elettronica e impostarne il livello di accesso.',
unistr('Le impostazioni definite in <em>Configura controllo dell''accesso</em> determineranno se il nome utente deve essere l''indirizzo di posta elettronica o pu\00F2 essere qualsiasi immissione alfanumerica.</p>'),
'<p>Questa applicazione supporta i tre livelli di accesso seguenti: Lettore, Collaboratore e Amministratore.</p>',
'<ul>',
'  <li>I <strong>lettori</strong> hanno accesso in sola lettura a tutte le informazioni e possono anche visualizzare i report.</li>',
'  <li>I <strong>collaboratori</strong> possono creare, modificare ed eliminare le informazioni e visualizzare i report.</li>',
unistr('  <li>Gli <strong>amministratori</strong>, oltre alle funzionalit\00E0 previste per i collaboratori, possono eseguire anche la configurazione dell''applicazione accedendo alla sezione Amministrazione dell''applicazione.</li>'),
'</ul>',
unistr('<p>Quando si modifica un utente esistente, \00E8 possibile bloccare il relativo account impedendone quindi l''accesso all''applicazione.</p>'),
unistr('<p><em><strong>Nota:</strong> se si utilizzano account Oracle Application Express, gli utenti immessi in questo form devono essere definiti come utenti finali anche da un amministratore dell''area di lavoro, che pu\00F2 impostarne le password.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501276586306959)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In questa pagina di report sono visualizzati i record primari in un selettore a lato della pagina. ',
'  Selezionare un record per visualizzare il record Master e qualsiasi record Detail definito.<br> ',
'  Fare clic sull''icona di modifica (<span class="fa fa-pencil-square-o" aria-hidden="true"></span>) per modificare il record Master.',
'  Per i record Detail, fare clic sulla matita all''inizio di ogni riga per modificare il record corrispondente.</p>',
'<p>Per limitare i dati visualizzati nel selettore, immettere un termine di ricerca nell''apposita finestra di dialogo.</p>',
'',
'<p>Per aggiungere un nuovo record Master, fare clic su <strong>Crea</strong> nella parte superiore della pagina.',
unistr('  Per i record dettagliati, fare clic sull''icona con il segno pi\00F9 ( + ) nella parte superiore dell''area detail per aggiungere un record Detail.</p>'),
'',
'<p>Fare clic su <strong>Reimposta</strong> nella parte superiore della pagina per ripristinare le impostazioni predefinite della pagina, rimuovendo eventuali termini di ricerca definiti in precedenza.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502347845306960)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'it'
,p_message_text=>'Prestazioni della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502401813306960)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Questa pagina fornisce un report interattivo delle prestazioni e della popolarit\00E0 della pagina. Il report viene ordinato in base alle <strong>Prestazioni ponderate</strong> che vengono calcolate moltiplicando il tempo mediano trascorso per il nume')
||'ro di visualizzazioni di pagina.</p>',
'<p>Selezionare il periodo di tempo per la generazione del report (intervallo predefinito = 1 giorno) nella parte superiore della pagina, in base alle esigenze.<br>',
'Fare clic sulle intestazioni di colonna per ordinare e filtrare i dati oppure fare clic sul pulsante <strong>Azioni</strong> per personalizzare la visualizzazione della colonna e molte funzioni avanzate aggiuntive. Fare clic sul pulsante <strong>Reim'
||'posta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502140745306959)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102502234613306960)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Questa pagina fornisce un report interattivo delle visualizzazioni di pagina pi\00F9 recenti.</p>'),
'<p>Selezionare il periodo di tempo per la generazione del report (intervallo predefinito = 1 giorno) nella parte superiore della pagina, in base alle esigenze.<br>',
'Fare clic sulle intestazioni di colonna per ordinare e filtrare i dati oppure fare clic sul pulsante <strong>Azioni</strong> per personalizzare la visualizzazione della colonna e molte funzioni avanzate aggiuntive. Fare clic sul pulsante <strong>Reim'
||'posta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501552741306959)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la combinazione colori predefinita usata per visualizzare l''applicazione.</p>',
unistr('<p>Se l''opzione <strong>Consenti agli utenti finali di scegliere uno stile tema</strong> \00E8 selezionata, ciascun utente finale pu\00F2 selezionare uno degli stili di tema disponibili facendo clic sul collegamento <em>Personalizza</em> nell''angolo inferior')
||'e sinistro della home page.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476129744306939)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'it'
,p_message_text=>'Primi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102501835854306959)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questo report e il grafico per visualizzare gli utenti con il maggior numero di visualizzazioni di pagina durante l''intervallo di tempo specificato.</p>',
'<p>Selezionare il periodo di tempo per la generazione del report (intervallo predefinito = 1 giorno) e scegliere tra le icone del report e del grafico nella parte superiore della pagina.</p>',
unistr('<p>Per il report interattivo, usare il campo di ricerca o selezionare l''intestazione di colonna <strong>Utente</strong> per selezionare un utente specifico. \00C8 possibile eseguire numerose funzioni facendo clic sul pulsante <strong>Azioni</strong>, ad ')
||unistr('esempio per scegliere le colonne visualizzate/nascoste, le righe per pagina, il filtro e cos\00EC via. Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492216797306952)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'it'
,p_message_text=>'Aggiungi utenti alla lista di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492328185306952)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Utente/i aggiunto/i.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490541153306950)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'it'
,p_message_text=>'Svuota cache della pagina o delle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474102985306938)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'it'
,p_message_text=>'Chiudi finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492194899306952)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'it'
,p_message_text=>'Crea raccolte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474496655306938)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Elimina feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474523339306938)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Feedback eliminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492046804306952)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'it'
,p_message_text=>'Elabora form %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492777613306952)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'it'
,p_message_text=>'Recupera ID file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491733773306951)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Recupera dettagli log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491099339306951)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'it'
,p_message_text=>'Richiama valore di chiave primaria successivo o precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490440418306950)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'it'
,p_message_text=>'Recupera cookie nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490163246306950)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'it'
,p_message_text=>'%0 - Salva dati griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491951091306951)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'it'
,p_message_text=>'Inizializza form %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490909162306951)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Azione elaborata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474221882306938)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'it'
,p_message_text=>'Carica dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491138413306951)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati non riuscito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474383955306938)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Rispondi a feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102473917383306938)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'it'
,p_message_text=>'Reimposta impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490205853306950)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Reimposta ricerca report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474006825306938)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'it'
,p_message_text=>'Imposta controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491876224306951)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostazioni controllo dell''accesso salvate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491524034306951)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491670411306951)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di configurazione aggiornate. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492646610306952)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Salva impostazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490357417306950)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'it'
,p_message_text=>'Imposta cookie nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492497051306952)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Sottometti feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102492578333306952)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Feedback sottomesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490694650306950)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'#MRD_COUNT# riga/e eliminata/e.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490766401306950)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento applicato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102490846723306951)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'#MRU_COUNT# riga/e aggiornata/e, #MRI_COUNT# riga/e inserita/e.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491490584306951)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva preferenza di stile utente finale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102474651834306938)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni aspetto dell''applicazione salvate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491272476306951)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102491305541306951)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni aspetto dell''applicazione salvate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480927231306943)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'it'
,p_message_text=>'Controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480830391306943)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482647447306944)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'it'
,p_message_text=>'Configurazione di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481040756306943)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni ACL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480689331306943)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'it'
,p_message_text=>unistr('Report attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471609974306936)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'it'
,p_message_text=>'Amministrazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480436317306943)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Configurazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482490013306944)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'it'
,p_message_text=>'Esecuzione automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470754756306935)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479551164306942)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471539518306936)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480326326306943)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Configurazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480707805306943)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'it'
,p_message_text=>'Configura aspetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471077064306935)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479922354306942)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'it'
,p_message_text=>'Record non riusciti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480058534306942)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'it'
,p_message_text=>'Record modificati da un altro utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479841251306942)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'Avanzamento del caricamento guidato dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471391484306936)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'it'
,p_message_text=>unistr('Il conteggio massimo di righe per questo report \00E8 %0 righe. Applicare un filtro per ridurre il numero di record nella query.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471271694306936)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'it'
,p_message_text=>'Nessun dato trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481484355306943)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'it'
,p_message_text=>'Generazione report di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482828142306945)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'it'
,p_message_text=>'Eccezioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481101499306943)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471991948306936)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'it'
,p_message_text=>'Feedback sottomesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482110540306944)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'it'
,p_message_text=>'Filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483343338306945)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Area elementi form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471109941306936)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'it'
,p_message_text=>'Form su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483247086306945)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi nascosti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481600736306944)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'it'
,p_message_text=>'Eventi pagina orari'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479780392306942)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'it'
,p_message_text=>'Informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481503316306944)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'it'
,p_message_text=>'Generazione report su job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481270152306943)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'it'
,p_message_text=>'Selettore lingue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481968001306944)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0 pi\00F9 recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482056916306944)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'it'
,p_message_text=>unistr('Nessuna attivit\00E0 trovata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480101693306942)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'it'
,p_message_text=>'Record principali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482576027306944)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'it'
,p_message_text=>'Messaggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481790441306944)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'it'
,p_message_text=>unistr('Pagine pi\00F9 attive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471408452306936)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione delle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470997210306935)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Nessun record selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480244629306942)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'it'
,p_message_text=>'Nessun record selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483013868306945)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'it'
,p_message_text=>'Non esistono utenti validi - Informazioni pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102483180180306945)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'it'
,p_message_text=>'Nessun nuovo utente valido trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481816567306944)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'it'
,p_message_text=>'Errori recenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470803595306935)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'it'
,p_message_text=>'Selettore di visualizzazione area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471737705306936)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'it'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470651784306935)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482243161306944)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'it'
,p_message_text=>'Primi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482342790306944)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico Primi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102471899576306936)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'it'
,p_message_text=>'%0 utenti da aggiungere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102481376310306943)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report conteggi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102480536654306943)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'it'
,p_message_text=>'Interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482952289306945)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'it'
,p_message_text=>'Esistono utenti validi - Informazioni pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102482706998306944)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'it'
,p_message_text=>'Contenitore procedura guidata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479618047306942)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'Avanzamento procedura guidata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102500049901306958)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'it'
,p_message_text=>'Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102497541983306956)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 certi di voler uscire da questa pagina senza salvare?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478187612306941)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'it'
,p_message_text=>'%0 riga/e aggiornate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479377825306942)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 richiesto almeno un feedback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479421441306942)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'it'
,p_message_text=>'Fornire un feedback o la propria esperienza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479146957306942)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere se stessi dal ruolo di amministratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479233890306942)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere il ruolo di amministrazione da se stessi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478620492306941)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'it'
,p_message_text=>'Il valore di #COLUMN_HEADER# deve essere una data valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478407808306941)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #COLUMN_HEADER#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478527028306941)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'it'
,p_message_text=>'Il valore di #COLUMN_HEADER# deve essere numerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478793027306941)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'it'
,p_message_text=>'Il valore di #COLUMN_HEADER# deve essere un indicatore orario valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476714864306940)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'it'
,p_message_text=>'%0 deve essere una data valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478901978306942)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# deve essere una data valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102478893016306941)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #LABEL#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102479078456306942)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# deve essere un indicatore orario valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476525354306940)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'%0 non nullo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476642271306940)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'it'
,p_message_text=>'%0 deve essere numerico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102476864646306940)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'it'
,p_message_text=>'%0 deve essere un indicatore orario valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394062830307701)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'La colonna di griglia interattiva ''%0'' specificata per l''azione dinamica ''#COMPONENT_NAME#'' non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394294213307701)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'it'
,p_message_text=>unistr('Il processo ''%0'' ha restituito ''%1'' durante l''esecuzione del blocco delle righe. Questo errore pu\00F2 verificarsi quando il processo esegue SELECT FOR UPDATE su una vista complessa con un trigger instead-of per bloccare la riga. Impostare l''attributo di')
||' processo ''Blocca riga'' su No o su Codice PL/SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394173319307701)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'it'
,p_message_text=>unistr('Il processo ''%0'' ha restituito ''%1'' durante l''esecuzione di un comando DML. Questo errore pu\00F2 verificarsi quando una colonna \00E8 basata su un''aggregazione o su un''espressione SQL. Impostare l''attributo di colonna ''Solo query'' su Yes (S\00EC) per escludere ')
||'la colonna dalle istruzioni INSERT e UPDATE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015813023307406)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'it'
,p_message_text=>'La colonna master-detail ''%0'' non contiene alcun valore. Accertarsi che il processo ''%1'' sia eseguito dopo il corrispondente processo dell''area master.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376312352307688)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'it'
,p_message_text=>'La griglia interattiva ''%0'' non dispone di una colonna master definita, necessaria per una relazione master-detail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790751096307233)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'it'
,p_message_text=>'La griglia interattiva ''%0'' non dispone di una colonna chiave primaria definita, necessaria in una relazione master-detail o per eseguire operazioni di modifica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353749387307671)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'it'
,p_message_text=>'Per una griglia interattiva modificabile, l''attributo di pagina ''Ricarica se si fa clic su Sottometti'' deve essere impostato su ''Solo per operazione riuscita''.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324711556307650)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'it'
,p_message_text=>'Editor di codice: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324812619307650)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'it'
,p_message_text=>'Comprimi %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324950974307651)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'it'
,p_message_text=>'Selettore colori: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325078915307651)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'it'
,p_message_text=>'Modifica componente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325105264307651)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'it'
,p_message_text=>' (Errore)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325263564307651)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'it'
,p_message_text=>'Espandi %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324671125307650)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325338248307651)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'it'
,p_message_text=>'Nessun risultato trovato.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325481390307651)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun risultato trovato. Provare a cercare tutte le propriet\00E0 facendo clic sul pulsante ''Mostra tutto'' in alto.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325535892307651)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'it'
,p_message_text=>unistr('Propriet\00E0 filtro')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325634734307651)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'it'
,p_message_text=>'%0 (non valido)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325785710307651)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'it'
,p_message_text=>'Lista di valori: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325819765307651)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'it'
,p_message_text=>'No'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103325943369307651)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'it'
,p_message_text=>unistr('I componenti selezionati non hanno propriet\00E0 in comune.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327125190307652)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Nessun componente selezionato al momento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326062132307651)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'it'
,p_message_text=>'Seleziona %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326132783307651)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtro pin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326226588307651)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'it'
,p_message_text=>'Selezione rapida: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326343989307652)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'it'
,p_message_text=>'Cancella selezione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326494159307652)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Richiesto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326598562307652)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326608260307652)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'it'
,p_message_text=>'- Seleziona -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326750313307652)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'it'
,p_message_text=>' (Il valore varia)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326890303307652)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'it'
,p_message_text=>'Avvertenza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103326916875307652)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'it'
,p_message_text=>' (Avvertenza)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327045769307652)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353806015307671)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Per un form tabulare, l''attributo di pagina ''Ricarica se si fa clic su Sottometti'' deve essere impostato su ''Sempre''.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133402258307495)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario specificare l''ID statico area poich\00E9 la pagina contiene pi\00F9 griglie interattive.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358689693306845)
,p_name=>'APEXIR_3D'
,p_message_language=>'it'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469144855306934)
,p_name=>'APEXIR_ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951370274307358)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Aggiungi sottoscrizione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608148576307058)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Gli aggregati vengono visualizzati dopo ogni interruzione di controllo e alla fine del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524075073306981)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469537508306934)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351510111307670)
,p_name=>'APEXIR_AREA'
,p_message_language=>'it'
,p_message_text=>'Ad aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949130877307356)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'it'
,p_message_text=>'Nero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469819647306934)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575712731307029)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'it'
,p_message_text=>'Intestazione colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383788421307693)
,p_name=>'APEXIR_DAY'
,p_message_language=>'it'
,p_message_text=>'Giorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504022609306961)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'it'
,p_message_text=>'Elimina selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608488358307059)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'it'
,p_message_text=>'Eseguire questa azione di eliminazione?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587432192307039)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'it'
,p_message_text=>'Disabilita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358828878306845)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336572769306828)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'it'
,p_message_text=>'Ciambella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208181639306728)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'it'
,p_message_text=>'Solo dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358767325306845)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'it'
,p_message_text=>'- Non aggregare -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334737910307658)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Modifica valore predefinito alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587338092307039)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'it'
,p_message_text=>'Abilita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608223941307058)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la richiesta di flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938414514307348)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna funzione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949295725307356)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'it'
,p_message_text=>'Grigio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336386305306828)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'it'
,p_message_text=>'Evidenzia se'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884218211307305)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'it'
,p_message_text=>'Prefisso etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940231355307350)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Fare clic <a href=''%0''>qui</a> per gestire la sottoscrizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609017443307059)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'it'
,p_message_text=>'Altri dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354493913306842)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'it'
,p_message_text=>'- Nuova categoria -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504139745306961)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessuna aggregazione definita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432284555306904)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'it'
,p_message_text=>'Non sono disponibili informazioni sulle colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504233639306961)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessun calcolo definito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383648005307693)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'it'
,p_message_text=>'- Nessuna data di fine -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437373595307738)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'it'
,p_message_text=>'Selezionare una colonna righe diversa. L''espressione o il collegamento HTML nella colonna righe contiene una colonna definita come colonna pivot o di aggregazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469282756306934)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi aggregato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837947344307271)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'it'
,p_message_text=>'Il numero di colonne visualizzate nel report ha raggiunto il limite. Fare clic su Seleziona colonne nel menu Azioni per ridurre la liste delle colonne visualizzate del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443496511306913)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'it'
,p_message_text=>'Ordine righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207423746306727)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'it'
,p_message_text=>'Il numero di colonne visualizzate nel report ha raggiunto il limite. Fare clic su Seleziona colonne nel menu Azioni per ridurre la liste delle colonne visualizzate del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102503971677306961)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Salva come predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336433351306828)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'it'
,p_message_text=>'- Seleziona categoria -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609139532307059)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'it'
,p_message_text=>'Le colonne calcolate sono contraddistinte dal prefisso **.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383500186307693)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'- Seleziona colonna di ordinamento -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608921177307059)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'it'
,p_message_text=>'Seleziona valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383438749307693)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Ordina colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938348174307348)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'it'
,p_message_text=>unistr('Unit\00E0 finale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608370130307058)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'it'
,p_message_text=>'Non autorizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585624007307037)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'it'
,p_message_text=>'L''intestazione di colonna deve essere univoca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383842205307694)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'it'
,p_message_text=>'Settimana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204758733306725)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'it'
,p_message_text=>'Servizi di amministrazione di Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335055210307658)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'it'
,p_message_text=>'Nessuna autenticazione configurata per questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647300802307099)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'it'
,p_message_text=>'Gli oggetti di database seguenti verranno %0 nello schema selezionato:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647450275307099)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione %0 riuscita per gli oggetti di database seguenti:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022565844307411)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'it'
,p_message_text=>'scorrere in Basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022632543307411)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'it'
,p_message_text=>'Scorri fino all''inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210825249306730)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'it'
,p_message_text=>'Form di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334693910307658)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'it'
,p_message_text=>'Modifica riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802486627307243)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti non validi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387812728307697)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'it'
,p_message_text=>'Non esistono pagine peer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337922362307660)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'it'
,p_message_text=>'Oggetti da creare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338174882307660)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'it'
,p_message_text=>'Elimina dalle tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338347310307660)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Elimina oggetti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957317668307362)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'it'
,p_message_text=>'Elimina tabelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956636186307362)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'it'
,p_message_text=>'Questi oggetti verranno creati nello schema <strong>%0</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338481748307660)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'it'
,p_message_text=>unistr('Questi oggetti esistono gi\00E0 nello schema <strong>%0</strong> e sono utilizzati da altre aree di lavoro. Se si continua, gli oggetti Websheet esistenti e di propriet\00E0 di <strong>%0</strong> verranno associati anche a questa area di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338502726307660)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'it'
,p_message_text=>'Selezionare lo schema da utilizzare per questi oggetti:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338682307307660)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'it'
,p_message_text=>'Tabelle esistenti da utilizzare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339431149307661)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'it'
,p_message_text=>'Gli oggetti di database del Websheet verranno riutilizzati sulla base delle informazioni seguenti. Confermare la richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956768052307362)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'it'
,p_message_text=>'Se si desidera creare gli oggetti Websheet in un nuovo schema, utilizzare la procedura guidata <a href=%0>Richiedi schema di database</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956828583307362)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'it'
,p_message_text=>'Per eseguire i Websheet, sono richiesti gli oggetti seguenti:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956902357307362)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'it'
,p_message_text=>'Gli oggetti di database del Websheet verranno creati sulla base delle informazioni seguenti. Confermare la richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957008115307362)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'it'
,p_message_text=>'Tabelle da creare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957130441307362)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'it'
,p_message_text=>'Si stanno per rimuovere gli oggetti di database del Websheet. Verranno eliminati sia gli oggetti di database del Websheet che i dati interni che contengono i componenti di Websheet nell''area di lavoro. Continuare?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957415176307362)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'it'
,p_message_text=>unistr('Per eseguire i Websheet in modo corretto, \00E8 necessario correggere i seguenti oggetti non validi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338090232307660)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'it'
,p_message_text=>'Si stanno per rimuovere le definizioni di Websheet per questa area di lavoro. Gli oggetti di database di Websheet sono utilizzati anche da altre aree di lavoro, quindi non verranno eliminati. I record associati a questa area di lavoro verranno elimin'
||'ati. Continuare?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957501817307363)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957680651307363)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957289616307362)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337854002307660)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'it'
,p_message_text=>'Oggetti esistenti da usare'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260132233306767)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'it'
,p_message_text=>'Calcoli di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260007821306767)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Processi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796255479307238)
,p_name=>'APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857223926307285)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'it'
,p_message_text=>'App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711990207307160)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione calcolo di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714766670307162)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712013628307160)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione elaborazione di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643036262307096)
,p_name=>'APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777561874307221)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'it'
,p_message_text=>'Applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686145429307135)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0 applicazioni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724126659307171)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722294011307169)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'it'
,p_message_text=>'Applicazione eliminata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204565189306725)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'it'
,p_message_text=>'Sviluppo di applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723103156307170)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'it'
,p_message_text=>'Identifica l''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682960477307132)
,p_name=>'APPLICATION_ID'
,p_message_language=>'it'
,p_message_text=>'Numero applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582840456307035)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID applicazione \00E8 riservato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582791221307035)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Il valore di ID applicazione deve essere un numero intero positivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997571802307392)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'it'
,p_message_text=>'Immagini dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752242766307197)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286042247306786)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254920152306763)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'it'
,p_message_text=>'Applicazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724030325307171)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387473170307696)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'it'
,p_message_text=>'Nomi applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833981754307268)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'it'
,p_message_text=>'ID sostituzione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721745710307169)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387367877307696)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361403611306847)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721914159307169)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797825270307239)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'it'
,p_message_text=>'Versione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219613874306737)
,p_name=>'APPLICATION_X'
,p_message_language=>'it'
,p_message_text=>'Applicazione %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670523513307121)
,p_name=>'APPROVED'
,p_message_language=>'it'
,p_message_text=>'Approvato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728340338307175)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione dell''applicazione completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389924932307698)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Applicazione modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252873157306762)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'it'
,p_message_text=>'Applicazione di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252955074306762)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'it'
,p_message_text=>unistr('Applicazione di produttivit\00E0 o di esempio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749146937307194)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'it'
,p_message_text=>'Websheet di esempio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252708554306762)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'it'
,p_message_text=>'Applicazione Websheet'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670009883307120)
,p_name=>'ARCHIVED'
,p_message_language=>'it'
,p_message_text=>'Archiviato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255255230306763)
,p_name=>'ARCHIVELOG'
,p_message_language=>'it'
,p_message_text=>'Archiviazione log: attiva'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506125133306962)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'it'
,p_message_text=>'Gli argomenti devono avere checksum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593706312307045)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome argomento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593988896307045)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo argomento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664289446307115)
,p_name=>'ASAP'
,p_message_language=>'it'
,p_message_text=>'Il prima possibile'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661550943307112)
,p_name=>'ASSIGNED'
,p_message_language=>'it'
,p_message_text=>'Assegnato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359030609306846)
,p_name=>'ASSIGNEE'
,p_message_language=>'it'
,p_message_text=>'Assegnatario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409644786307716)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'it'
,p_message_text=>'Assegna %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415065346306890)
,p_name=>'ASSOCIATED'
,p_message_language=>'it'
,p_message_text=>'associato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360676319306847)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'it'
,p_message_text=>'Funzioni associate'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691384658307140)
,p_name=>'ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'Allegato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417473086307722)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'it'
,p_message_text=>'A rischio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386549071306867)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'it'
,p_message_text=>'Si sta per eseguire la migrazione delle opzioni di autenticazione personalizzate di questa applicazione in uno schema di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386001742306867)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'it'
,p_message_text=>'Metodo di autenticazione corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386444777306867)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione di autenticazione personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386182107306867)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina di login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386351967306867)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'it'
,p_message_text=>'URL di login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386236595306867)
,p_name=>'AUTH.NONE'
,p_message_language=>'it'
,p_message_text=>'nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391513732306871)
,p_name=>'AUTHENTICATION'
,p_message_language=>'it'
,p_message_text=>'Autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712927058307160)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712656203307160)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'it'
,p_message_text=>'Schema di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406552868306883)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'it'
,p_message_text=>unistr('Si sta per eliminare uno schema di autenticazione dall''applicazione %0. Se l''applicazione non sta utilizzando attualmente un''autenticazione di tipo SCHEME o se lo schema di autenticazione non \00E8 quello corrente, l''applicazione continuer\00E0 a funzionare ')
||unistr('correttamente se si elimina lo schema. Se il flusso utilizza un''autenticazione di tipo SCHEME e questo \00E8 lo schema di autenticazione corrente, l''applicazione continuer\00E0 a essere eseguita utilizzando l''autenticazione di tipo SCHEME, ma con uno schema ')
||unistr('di autenticazione predefinito che utilizzer\00E0 una pagina di login incorporata con verifica delle credenziali "open door" (tutti potranno eseguire l''applicazione). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408525551306884)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'it'
,p_message_text=>unistr('Fare clic sul pulsante Rendi corrente affinch\00E9 l''applicazione utilizzi questo schema di autenticazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884556850307305)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'it'
,p_message_text=>'Account di Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201126491306723)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'it'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884659120307305)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884902496307306)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'it'
,p_message_text=>'Nessuna autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884744475307306)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'it'
,p_message_text=>'Account di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146374616307504)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'it'
,p_message_text=>'Variabile di intestazione HTTP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885165399307306)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'it'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884846248307306)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'it'
,p_message_text=>'Directory LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885082445307306)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'it'
,p_message_text=>'Credenziali "open door"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179051108306706)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'it'
,p_message_text=>'Sign-In SAML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229698809306744)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'it'
,p_message_text=>'Social Sign-In'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753223775307198)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Schema di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712531851307160)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'it'
,p_message_text=>'Schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201274218306723)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'it'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219873364306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Query SQL - Esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219993335306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'it'
,p_message_text=>'Funzione PL/SQL che restituisce un risultato booleano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575451176307028)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'it'
,p_message_text=>'In ruolo o gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575579659307028)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'it'
,p_message_text=>'Non in ruolo o gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220066682306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''elemento in Espressione 1 \00E8 uguale a Espressione 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220151085306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''elemento in Espressione 1 \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220227152306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''elemento in Espressione 1 \00E8 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220374713306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''elemento in Espressione 1 NON \00E8 uguale a Espressione 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220451320306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Query SQL - Non esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220560633306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della preferenza in Espressione 1 \00E8 uguale a Espressione 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102220609841306737)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della preferenza in Espressione 1 NON \00E8 uguale a Espressione 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271738855306776)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'it'
,p_message_text=>'Valutazione per ogni visualizzazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271810011306776)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'it'
,p_message_text=>'Valuta una volta per sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223571766306740)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'it'
,p_message_text=>'Account scaduto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223493397306739)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'it'
,p_message_text=>'Account bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223829855306740)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'it'
,p_message_text=>'Numero massimo di tentativi di login superato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223993024306740)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore interno sconosciuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223758507306740)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'it'
,p_message_text=>'Primo utilizzo password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223684410306740)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'it'
,p_message_text=>'Password errata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223223882306739)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Autenticazione riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223388116306739)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'it'
,p_message_text=>'Nome utente sconosciuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318111625306810)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Nome di area di lavoro sconosciuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328297370306818)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'it'
,p_message_text=>'Nome di area di lavoro sconosciuto: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449284609306918)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'it'
,p_message_text=>'Istruzione di commit non applicabile. Viene eseguito il commit automatico di tutte le istruzioni.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147344335307505)
,p_name=>'AUTOMATIONS'
,p_message_language=>'it'
,p_message_text=>'Automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147423751307505)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azione di automazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778131157307221)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 di provisioning')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198711863306721)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'it'
,p_message_text=>'Primo elemento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799621207307241)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'it'
,p_message_text=>unistr('Disponibilit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227904785306743)
,p_name=>'AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Disponibili'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934512349307346)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'it'
,p_message_text=>'Disponibile solo per gli sviluppatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934455725307345)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'it'
,p_message_text=>'Disponibile con barra degli strumenti sviluppatore'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686938032307136)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'it'
,p_message_text=>'Tempo medio di presentazione (secondi)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668489806307119)
,p_name=>'BAR_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico a barre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986235635307384)
,p_name=>'BASIC'
,p_message_language=>'it'
,p_message_text=>'Di base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241887501306753)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'it'
,p_message_text=>'Sviluppatore di base'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649856131307102)
,p_name=>'BEFORE'
,p_message_language=>'it'
,p_message_text=>'Prima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392787339307700)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'it'
,p_message_text=>'Prima della voce di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408739808307716)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'it'
,p_message_text=>'Prima del primo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715878475307163)
,p_name=>'BIND_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta associazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715267514307163)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'it'
,p_message_text=>'Bind variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715372437307163)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta bind variable'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729892504307176)
,p_name=>'BLACK_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo nero'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205189017306726)
,p_name=>'BLANK'
,p_message_language=>'it'
,p_message_text=>'Vuota'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690550270307140)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835647962307269)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'it'
,p_message_text=>'Scarica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253810723306762)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836049786307270)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'Allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835744088307270)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835843707307270)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'it'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835992499307270)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'it'
,p_message_text=>'In linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691587883307141)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Formato BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691085074307140)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna ultimo aggiornamento BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690498134307139)
,p_name=>'BLOB_TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella BLOB'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729762367307176)
,p_name=>'BLUE_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo blu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706948601307155)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275522850306779)
,p_name=>'BRANCHES'
,p_message_language=>'it'
,p_message_text=>'Diramazioni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470048923306935)
,p_name=>'BREADCRUMB'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650509211307102)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650616742307102)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'it'
,p_message_text=>'Nome lungo indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470171322306935)
,p_name=>'BREADCRUMBS'
,p_message_language=>'it'
,p_message_text=>'Indicatori di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738636983307184)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voce di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752430394307197)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'it'
,p_message_text=>'Voce di indicatore di percorso: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583153247307035)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658021415307109)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'it'
,p_message_text=>'Area con indicatori di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332152683306821)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione dell''indicatore di percorso completata.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653148602307105)
,p_name=>'BROWSE_ICON'
,p_message_language=>'it'
,p_message_text=>'Icona Sfoglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652908292307105)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'it'
,p_message_text=>'Sfoglia package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593566343307045)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'it'
,p_message_text=>'Sfoglia tabella'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184843369306710)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'it'
,p_message_text=>'Liste ACL applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181137614306707)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'it'
,p_message_text=>'Calcoli di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229482541306744)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore durante il backup dell''applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181281074306707)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181497795306708)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'it'
,p_message_text=>'Processi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229145913306744)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'it'
,p_message_text=>'Applicazione %0 ripristinata dalla revisione %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181031931306707)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991915993307388)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'it'
,p_message_text=>unistr('Propriet\00E0 applicazione: modificate')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735248106307181)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Schema di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182104425306708)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'it'
,p_message_text=>'Schemi di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182278840306708)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'it'
,p_message_text=>'Schemi di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183851223306709)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'it'
,p_message_text=>'Indicatori di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183915271306709)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181316962306707)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184153399306710)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184013226306710)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735063883307181)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'it'
,p_message_text=>'Componenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146203438307504)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'it'
,p_message_text=>'%0 eliminate/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146162362307504)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'it'
,p_message_text=>'%0 modificate/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146092345307504)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'it'
,p_message_text=>'%0 nuove/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182555742306708)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189040613306713)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Credenziali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185313220306711)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193277362306717)
,p_name=>'BU.DELETED'
,p_message_language=>'it'
,p_message_text=>'%0 eliminate/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193369062306717)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'it'
,p_message_text=>'Sviluppatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182726625306709)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229584048306744)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'Backup applicazione in corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184468918306710)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735421543307181)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'it'
,p_message_text=>'Ultimo backup: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734930508307181)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'it'
,p_message_text=>'Ultimo aggiornamento: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181594494306708)
,p_name=>'BU.LISTS'
,p_message_language=>'it'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184390195306710)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229219338306744)
,p_name=>'BU.LOCKED'
,p_message_language=>'it'
,p_message_text=>'Bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181819039306708)
,p_name=>'BU.LOVS'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184757166306710)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188935996306713)
,p_name=>'BU.MESSAGES'
,p_message_language=>'it'
,p_message_text=>'Messaggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193161619306716)
,p_name=>'BU.MODIFIED'
,p_message_language=>'it'
,p_message_text=>'%0 modificate/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182058539306708)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735161773307181)
,p_name=>'BU.NEW'
,p_message_language=>'it'
,p_message_text=>'%0 nuove/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183763036306709)
,p_name=>'BU.PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145978552307504)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'it'
,p_message_text=>'%0 eliminate/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145801985307504)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'it'
,p_message_text=>'%0 modificate/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145722186307504)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'it'
,p_message_text=>'%0 nuove/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181985347306708)
,p_name=>'BU.PLUGINS'
,p_message_language=>'it'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184218666306710)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189241764306713)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'it'
,p_message_text=>'Rimuovi server'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185140900306710)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'it'
,p_message_text=>'Layout report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184651130306710)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690255745307139)
,p_name=>'BU.RESTORED'
,p_message_language=>'it'
,p_message_text=>'Applicazione ripristinata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219588190306736)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Applicazione ripristinata dalla revisione di backup %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183232697306709)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'it'
,p_message_text=>'SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185060026306710)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'it'
,p_message_text=>'Query condivise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182674424306708)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'it'
,p_message_text=>'Scorciatoie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182935334306709)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'it'
,p_message_text=>'File applicazione statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183064579306709)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'it'
,p_message_text=>'File area di lavoro statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226447090306742)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Riepilogo modifiche non disponibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184500773306710)
,p_name=>'BU.TABS'
,p_message_language=>'it'
,p_message_text=>'Schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183182260306709)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'it'
,p_message_text=>'Messaggi di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181779652306708)
,p_name=>'BU.THEMES'
,p_message_language=>'it'
,p_message_text=>'Temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102184997783306710)
,p_name=>'BU.TREES'
,p_message_language=>'it'
,p_message_text=>'Strutture'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229344550306744)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'it'
,p_message_text=>'Sbloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102181617654306708)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'it'
,p_message_text=>'Attributi interfaccia utente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102182306686306708)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Credenziali Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185203636306710)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'it'
,p_message_text=>'Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189110831306713)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'it'
,p_message_text=>'Origini dati REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209078063306729)
,p_name=>'BUFFER CACHE'
,p_message_language=>'it'
,p_message_text=>'Buffer cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664705841307115)
,p_name=>'BUG'
,p_message_language=>'it'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688045833307137)
,p_name=>'BUGS'
,p_message_language=>'it'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709441827307157)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'it'
,p_message_text=>'bug assegnato/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746628280307192)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'it'
,p_message_text=>'Bug assegnati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237664009306750)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'it'
,p_message_text=>'Bug chiusi (%0 / %1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015159975307406)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'it'
,p_message_text=>'Percentuale chiusura bug (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746754166307192)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'it'
,p_message_text=>'Bug non assegnati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746879425307192)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'it'
,p_message_text=>'Nessuna data Correggi entro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015599805307406)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'it'
,p_message_text=>'Bug: chiusi %1 su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414011656307720)
,p_name=>'BUG_LABEL'
,p_message_language=>'it'
,p_message_text=>'Bug: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703184955307151)
,p_name=>'BUILD QUERY'
,p_message_language=>'it'
,p_message_text=>'Crea query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192978910306716)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192818805306716)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192705385306716)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193099674306716)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192645832306716)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797264133307239)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'it'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794667161307236)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'it'
,p_message_text=>'[Non supportato]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993961573307389)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio di area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398788808306876)
,p_name=>'BUILD_OPTION'
,p_message_language=>'it'
,p_message_text=>'Opzione di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844237069307276)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'it'
,p_message_text=>'Opzione di creazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412796611307719)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'it'
,p_message_text=>'Stato di creazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845030530307276)
,p_name=>'BUILD_VERSION'
,p_message_language=>'it'
,p_message_text=>'Versione build'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740523148307186)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello report incorporato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649139304307101)
,p_name=>'BUTTON'
,p_message_language=>'it'
,p_message_text=>'pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837342726307271)
,p_name=>'BUTTON.ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217245153306735)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'it'
,p_message_text=>'In Attributi pulsante del pulsante selezionato non deve essere presente alcun ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217168987306735)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario che il pulsante selezionato abbia il valore di Azione impostato su ''Definita da azione dinamica''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217333671306735)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'it'
,p_message_text=>'Il pulsante selezionato utilizza un modello di pulsante che non contiene la stringa di sostituzione #BUTTON_ID#'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837164661307271)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275707822306779)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Specificare una pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254437251306763)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'it'
,p_message_text=>'Specificare la query del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252508198306761)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'it'
,p_message_text=>'Specificare la richiesta pulsante per tutti i tipi di origine per la richiesta pulsante, a meno che il tipo di origine per la richiesta pulsante non sia "Sempre NULL".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253239443306762)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'it'
,p_message_text=>'Specificare un tipo di origine per richiesta pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275812515306779)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Destinazione URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219216128306736)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'it'
,p_message_text=>unistr('Quando Azione \00E8 impostato su ''Definita da azione dinamica'', gli attributi del pulsante non devono contenere alcun ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276945597306780)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277098671306780)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Stile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276841852306780)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Modello.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219118761306736)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'it'
,p_message_text=>unistr('Quando lo stile del pulsante \00E8 ''Pulsante basato su modello'' e Azione \00E8 impostato su ''Definita da azione dinamica'', il modello di pulsante selezionato deve contenere la stringa di sostituzione #BUTTON_ID#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102207085824306727)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile eliminare il pulsante poich\00E9 vi si fa riferimento in un''azione dinamica (Pagina: %0, azione dinamica: ''%1'', azione: ''%2'', attributo: ''Elemento interessato'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206972051306727)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile eliminare il pulsante poich\00E9 vi si fa riferimento in un''azione dinamica (Pagina: %0, azione dinamica: ''%1'', attributo: ''When'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837211423307271)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Sottometti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833427556307268)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'it'
,p_message_text=>'Da utilizzare in un attributo "onClick"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836696104307270)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'it'
,p_message_text=>'Da utilizzare in un attributo "href"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275655475306779)
,p_name=>'BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716244597307163)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412536550307719)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'it'
,p_message_text=>'Pulsante: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720553280307168)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di pulsante'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272950648306777)
,p_name=>'BYTES'
,p_message_language=>'it'
,p_message_text=>'byte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664326641307115)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'it'
,p_message_text=>'Per patch successiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664403952307115)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'it'
,p_message_text=>'Per release successiva'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487122941307780)
,p_name=>'CA.ABOUT'
,p_message_language=>'it'
,p_message_text=>'Informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453408673307751)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina delle informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453335107307751)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Include una pagina Informazioni sull''applicazione che contenga la descrizione e la versione dell''applicazione e il conteggio delle pagine.',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376346484306859)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'it'
,p_message_text=>'Container contenuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487321283307780)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Pagina delle informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487458685307780)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo relativo all''applicazione specifica pu\00F2 essere inserito in questo campo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487043057307780)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'it'
,p_message_text=>'Informazioni su questa pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498265324307788)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'it'
,p_message_text=>'Informazioni su questa release in anteprima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336202553306828)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere se stessi dal ruolo di amministratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336188777306828)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere il ruolo di amministrazione da se stessi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453703414307751)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'it'
,p_message_text=>'Controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489652017307782)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479156378307774)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Configurazione di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452141782307750)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'it'
,p_message_text=>'Abilita l''autorizzazione utente basata su ruoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453804100307751)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Incorpora l''autenticazione utente basata su ruoli all''interno dell''applicazione.',
unistr('\00C8 possibile definire gli utenti come amministratori, collaboratori o lettori.'),
unistr('\00C8 quindi possibile definire facilmente accessi diversi in base ai ruoli per i vari componenti in tutta l''applicazione, ad esempio per le pagine, le voci di menu, le aree, le colonne, gli elementi, i pulsanti e cos\00EC via.</p>'),
'<p>Include i seguenti componenti:',
'<ul>',
'<li>Area della pagina amministrativa con collegamenti per accedere alle funzioni di controllo</li>',
'<li>Tabella utenti per gestire il controllo dell''accesso</li>',
'<li>Pagina di configurazione per impostare il livello di accesso degli utenti autenticati</li>',
'<li>Pagina di configurazione per specificare se i nomi utente sono o meno indirizzi di posta elettronica</li>',
'<li>Gestione della pagina di accesso degli utenti per segnalare e modificare l''accesso degli utenti</li>',
unistr('<li>Aggiunta della pagina utente con possibilit\00E0 di aggiungere un singolo utente</li>'),
unistr('<li>Aggiunta di una pagina per pi\00F9 utenti con possibilit\00E0 di aggiungere pi\00F9 utenti (solo nomi utente di posta elettronica)</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478060946307773)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'it'
,p_message_text=>'Ruolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478722764307773)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'it'
,p_message_text=>'ID ruolo di accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307885406306803)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'it'
,p_message_text=>'Ruoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478103325307773)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'it'
,p_message_text=>'Account bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335766281306827)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'it'
,p_message_text=>'Confermato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489493880307782)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'it'
,p_message_text=>'Informazioni ACL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490141219307782)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'it'
,p_message_text=>unistr('Privilegi insufficienti: l''utente non \00E8 un amministratore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490252338307782)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'it'
,p_message_text=>unistr('Non si \00E8 autorizzati a visualizzare questa applicazione: non si \00E8 autorizzati ad accedere o l''account \00E8 stato bloccato. Contattare l''amministratore dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490322457307782)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'it'
,p_message_text=>unistr('Privilegi insufficienti: l''utente non \00E8 un collaboratore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479822629307774)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'it'
,p_message_text=>'Impostazioni controllo dell''accesso salvate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484532790307778)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'it'
,p_message_text=>'HTML pulsante azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483479979307777)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483550716307777)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'it'
,p_message_text=>'Collegamento azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486119990307779)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'it'
,p_message_text=>'HTML collegamento azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471678593307768)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'it'
,p_message_text=>'Azione elaborata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477189314307772)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0 per ora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510305508307800)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'it'
,p_message_text=>unistr('Dashboard attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453996627307751)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'it'
,p_message_text=>unistr('Generazione report su attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453129609307751)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Include l''attivit\00E0 utente e i report degli errori')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454004252307751)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Include numerosi report sull''attivit\00E0 degli utenti finali con l''applicazione. Determina gli utenti pi\00F9 attivi, le pagine pi\00F9 utilizzate, le prestazioni delle pagine e gli errori che si sono verificati, per comprendere meglio la modalit\00E0 d''uso dell')
||'''applicazione e le aree che possono essere migliorate.</p>',
'<p>Include i seguenti componenti:',
'<ul>',
'<li>Report sui primi utenti</li>',
'<li>Report Log degli errori dell''applicazione</li>',
unistr('<li>Prestazioni globali, attivit\00E0 e prestazioni per pagina</li>'),
unistr('<li>Report sulle attivit\00E0 dell''applicazione per pagina</li>'),
'<li>Report dettagliato sulle viste di pagina</li>',
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700178338307149)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'it'
,p_message_text=>'Data di inizio effettiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489351009307782)
,p_name=>'CA.ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484741568307778)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Aggiungi modello di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501218203307793)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiungi pi\00F9 utenti - Passo 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487607966307780)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'it'
,p_message_text=>'Aggiungi nuovo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470697815307767)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Aggiungi notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376203708307688)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478823938307773)
,p_name=>'CA.ADD.USER'
,p_message_language=>'it'
,p_message_text=>'Aggiungi utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501684834307793)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'it'
,p_message_text=>'Aggiungi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455538382307753)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'it'
,p_message_text=>'Aggiunta delle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456069611307753)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Fare clic su <strong>Aggiungi pagina</strong> per aggiungere una pagina all''applicazione. Quindi selezionare il tipo di pagina (ad esempio Vuota, Grafico, Form, Report e cos\00EC via) e definirne gli attributi. Potrebbe essere inoltre necessario speci')
||'ficare una tabella o una vista valida oppure utilizzare SQL Workshop per preparare gli oggetti di database nell''area di lavoro.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485595906307779)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Avanzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699439756307148)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni aggiuntive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478556065307773)
,p_name=>'CA.ADDRESS'
,p_message_language=>'it'
,p_message_text=>'Indirizzo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458776423307755)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'it'
,p_message_text=>'Controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459309932307756)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'it'
,p_message_text=>'Imposta il livello di accesso per gli utenti autenticati di questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457808033307754)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'it'
,p_message_text=>unistr('Report attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458887930307755)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460564996307757)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'it'
,p_message_text=>'Amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459260406307756)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'it'
,p_message_text=>'Amministratori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732652679307179)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Configurazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832211087307267)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'it'
,p_message_text=>'Interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494132271307785)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'it'
,p_message_text=>'Amministrazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494274556307785)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'it'
,p_message_text=>'Gestisci componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457460936307754)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'it'
,p_message_text=>'Selezione stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457518001307754)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'it'
,p_message_text=>'Imposta l''aspetto predefinito dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457137864307754)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di configurazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457074347307754)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'it'
,p_message_text=>'Abilita o disabilita le funzioni dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458143112307755)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'it'
,p_message_text=>'Log degli errori dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458209260307755)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'it'
,p_message_text=>'Report degli errori registrati da questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457607532307754)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457763995307754)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'it'
,p_message_text=>'Imposta il nome e una descrizione breve dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457223004307754)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'it'
,p_message_text=>'Aggiornamenti applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457397666307754)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'it'
,p_message_text=>'Gestisce la lista di aggiornamenti dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456730320307754)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Configurazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459184235307756)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'it'
,p_message_text=>'Collaboratori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509194857307799)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'it'
,p_message_text=>'Dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509027505307799)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Visualizza metriche di attivit\00E0 dell''applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462298225307758)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'it'
,p_message_text=>'Fuso orario predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462370461307758)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'it'
,p_message_text=>'Impostare il fuso orario predefinito per questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460024636307756)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462428092307758)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462586306307758)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'it'
,p_message_text=>'Impostare se la posta elettronica deve essere inviata e, in tal caso, chi deve esserne il destinatario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459578364307756)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459818048307756)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459985011307756)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'it'
,p_message_text=>'Consente di specificare se gli allegati devono essere consentiti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459632819307756)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459726091307756)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'it'
,p_message_text=>'Report di tutti i feedback sottomessi dagli utenti dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460175189307756)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460256601307756)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'it'
,p_message_text=>'Gestisce i formati HTML e CSS dei modelli di posta elettronica usati da questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456808178307754)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'it'
,p_message_text=>'Notifiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456958629307754)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'it'
,p_message_text=>'Visualizza le notifiche nella home page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494864869307786)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376929232307689)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'it'
,p_message_text=>'Log automazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377011816307689)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'it'
,p_message_text=>'Report delle esecuzioni delle automazioni e dei messaggi registrati da questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458383882307755)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'it'
,p_message_text=>'Prestazioni della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458454988307755)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Report dell''attivit\00E0 e delle prestazioni in base alla pagina dell''applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458559963307755)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458681051307755)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'it'
,p_message_text=>'Report di ciascuna visualizzazione di pagina in base all''utente, inclusi data di accesso e tempo trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459057062307755)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'it'
,p_message_text=>'Lettori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502332578307794)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'it'
,p_message_text=>'Invia messaggio di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502479051307794)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'it'
,p_message_text=>'Invia messaggio di posta elettronica basato su modello da questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103457970080307755)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'it'
,p_message_text=>'Primi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458072219307755)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'it'
,p_message_text=>'Report delle visualizzazioni di pagina aggregate per utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103458999233307755)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103459435158307756)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'it'
,p_message_text=>'Modifica le impostazioni del controllo dell''accesso e lo disabilita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460345845307756)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'it'
,p_message_text=>'Log di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460463719307757)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'it'
,p_message_text=>'Visualizza il log dei messaggi di posta elettronica inviati da questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467900714306933)
,p_name=>'CA.ADVANCED'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
' <li><strong>Avanzate</strong>: espandere per visualizzare le opzioni avanzate.',
'    <ul>',
'      <li><strong>Imposta come home page</strong>: imposta la pagina corrente come home page per l''applicazione.<br>',
unistr('      &nbsp;&nbsp;&nbsp;La pagina definita in precedenza come home page verr\00E0 aggiornata.</li>'),
unistr('      <li><strong>Imposta come pagina di amministrazione</strong>: aggiunge la pagina corrente come pagina di amministrazione anzich\00E9 come pagina normale nell''applicazione. Per accedere, fare clic su Amministrazione nel menu principale, quindi effett')
||'uare la selezione nella lista Amministrazione applicazione.<br>',
unistr('        <em><strong>Nota:</strong> una pagina non pu\00F2 essere sia una home page che una pagina di amministrazione.</em></li>'),
'      &nbsp;<br>',
'      <li><strong>Guida sulla pagina</strong>: immettere il testo da aggiungere al testo della Guida per la pagina.</li>',
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355074976306842)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
' <li><strong>Avanzate</strong>: espandere per visualizzare le opzioni avanzate.',
'    <ul>',
'      <li><strong>Guida sulla pagina</strong>: immettere il testo da aggiungere al testo della Guida per la pagina.</li>',
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495208794307786)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni avanzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495383052307786)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'it'
,p_message_text=>'<p>Definire ulteriori impostazioni di definizione, sicurezza e globalizzazione. Queste impostazioni possono essere applicate quando si crea l''applicazione e possono essere inoltre modificate dopo la creazione dell''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497259747307788)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'it'
,p_message_text=>'<p>Per ulteriori informazioni, leggere la Guida dell''elemento ( <span class="fa fa-question-circle" aria-hidden="true"></span> ) per ciascuna impostazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503011646307794)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'it'
,p_message_text=>'Dopo le righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484462931307778)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'it'
,p_message_text=>'HTML dopo le righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487528682307780)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'it'
,p_message_text=>'Tutte le colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483668853307777)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'it'
,p_message_text=>'Consenti opt-out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693021550307142)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Consenti esecuzioni in modalit\00E0 limitata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477099868307772)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'it'
,p_message_text=>'Log degli errori dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472947297307769)
,p_name=>'CA.APP.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743044032307188)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Indica se il controllo dell''accesso \00E8 attivato o meno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743193198307188)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'it'
,p_message_text=>'Livello di accesso predefinito concesso agli utenti autenticati non contenuti nella lista di controllo dell''accesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473336590307769)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Impostazioni applicazione aggiornate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473175619307769)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'it'
,p_message_text=>'Descrizione breve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473204286307769)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Il testo immesso in questo campo viene visualizzato sotto il nome dell''applicazione nella relativa home page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462641138307758)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'it'
,p_message_text=>'Aspetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462774688307758)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'it'
,p_message_text=>'<p>Definire la combinazione di colori (stile tema) predefinita dell''applicazione, il punto in cui si trova la navigazione e l''icona usata per l''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482166450307776)
,p_name=>'CA.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469200420307764)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'it'
,p_message_text=>'Aspetto applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463200335307759)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'it'
,p_message_text=>'Icona applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463373971307759)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic su <strong>Scegli nuova icona</strong> per selezionare il colore dell''icona e una delle icone disponibili. La selezione viene visualizzata nella home page dell''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463634904307759)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'it'
,p_message_text=>'ID applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463722768307759)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere un identificativo numerico univoco per l''applicazione. Per impostazione predefinita, questo campo contiene un identificativo generato automaticamente.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482730808307776)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474958712307770)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'it'
,p_message_text=>'Sessioni dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453551231307751)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452466960307750)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'it'
,p_message_text=>'Imposta il nome e una descrizione breve dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453614892307751)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consente agli amministratori dell''applicazione di aggiornare varie impostazioni quali il nome e una descrizione dell''applicazione, il fuso orario predefinito e cos\00EC via.</p>'),
'<p>Include i seguenti componenti:',
'<ul>',
'<li>Voce e form della lista di pagine amministrative</li>',
unistr('<li>Possibilit\00E0 di impostare il nome dell''applicazione</li>'),
unistr('<li>Possibilit\00E0 di impostare il sottotitolo dell''area hero della home page</li>'),
unistr('<li>Possibilit\00E0 di impostare i destinatari del feedback, qualora si utilizzi il feedback</li>'),
unistr('<li>Possibilit\00E0 di impostare il fuso orario predefinito dell''applicazione</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508162926307799)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509936629307800)
,p_name=>'CA.APPLY'
,p_message_language=>'it'
,p_message_text=>'Applica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511717619307802)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Applicazione delle impostazioni predefinite applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468486594307763)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'it'
,p_message_text=>'Applica modifiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509744704307800)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'it'
,p_message_text=>'Applica filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830374726307265)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'it'
,p_message_text=>'Applicazione creata dalla Creazione guidata applicazione %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831633442307266)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva impostazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513966361307803)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'Allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569842120307023)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio allegati'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514060155307803)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569779606307023)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510027320307800)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'it'
,p_message_text=>unistr('Impostazioni predefinite attributi gi\00E0 definite per %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479264545307774)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'it'
,p_message_text=>unistr('Qualsiasi utente autenticato pu\00F2 accedere a questa applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464412375307760)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'it'
,p_message_text=>'Autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464576503307760)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Selezionare la modalit\00E0 di autenticazione degli utenti nell''applicazione.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695759787307144)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'it'
,p_message_text=>'Eliminazione automatica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377646403307689)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'it'
,p_message_text=>'Esecuzione automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475624929307771)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo medio trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740350009307186)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'it'
,p_message_text=>'Torna al report Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570517702307024)
,p_name=>'CA.BCC'
,p_message_language=>'it'
,p_message_text=>'CCN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502946008307794)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'it'
,p_message_text=>'Prima delle righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484353278307778)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'it'
,p_message_text=>'HTML prima delle righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485821944307779)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Contenuto prima delle righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461152327307757)
,p_name=>'CA.BLANK'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina vuota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461296687307757)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consente di creare una pagina vuota come segnaposto. Una volta creata l''applicazione, \00E8 possibile creare immediatamente le aree sulla pagina tramite Page Designer.</p>'),
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong> (obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'<!--  <li><strong>Includi navigazione di pagina</strong>: selezionare questa opzione per visualizzare una lista di schede di tutte le altre pagine definite nell''applicazione.<br>',
'      &nbsp;&nbsp;&nbsp;Questa opzione viene in genere usata nella home page dell''applicazione.</li>',
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494554685307786)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'it'
,p_message_text=>'Progetto applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494670521307786)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il progetto elenca la definizione dell''applicazione in formato JSON.</p>',
unistr('<p>Quando si accede a questa schermata per la prima volta, la definizione dell''applicazione corrente viene trasformata in un documento JSON e visualizzata. \00C8 possibile modificare il documento per aggiornare le propriet\00E0 dell''applicazione, quindi fare')
||' clic su <strong>Applica progetto</strong> per modificare i dettagli dell''applicazione corrente.</p>',
'<p>&nbsp;</p>',
unistr('<p>Per creare un numero elevato di pagine simili in modo molto pi\00F9 rapido rispetto all''uso manuale dell''opzione <strong>Aggiungi pagina</strong> per ciascuna pagina, copiare il codice JSON rilevante per una pagina e incollarlo pi\00F9 volte apportandovi ')
||'piccole modifiche.</p>',
unistr('<p>Fare clic su <strong>Carica progetto precedente</strong> per sostituire il progetto con la definizione di un''applicazione generata in precedenza. In questo modo \00E8 possibile ripetere molto facilmente la struttura di un''applicazione aggiungendo ulte')
||'riori pagine, modificando le funzioni o regolando le impostazioni, prima di generare nuovamente l''applicazione.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483234001307777)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo corpo 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483330617307777)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo corpo 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503337376307795)
,p_name=>'CA.BOTH'
,p_message_language=>'it'
,p_message_text=>'Entrambi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469639521307764)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'it'
,p_message_text=>'Dirama a pagina amministrativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466589894306932)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'it'
,p_message_text=>'Barra dei pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469346207307764)
,p_name=>'CA.BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461889577307758)
,p_name=>'CA.CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina di calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461968386307758)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di creare una pagina che visualizza un calendario.</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong> (obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  <li><strong>Tabella o vista</strong> (obbligatorio): selezionare l''oggetto di database per il calendario.</li>',
'  <li><strong>Colonna di visualizzazione</strong> (obbligatorio): selezionare la colonna della tabella o della vista da visualizzare negli eventi di calendario.</li>',
'  <li><strong>Colonna data di inizio</strong> (obbligatorio): selezionare la colonna della data nella tabella o nella vista da usare come data di inizio per gli eventi di calendario.</li>',
'  <li><strong>Colonna data di fine</strong>: : selezionare la colonna della data nella tabella o nella vista da usare come data di fine per gli eventi di calendario.<br>',
unistr('      &nbsp;&nbsp;&nbsp;Se \00E8 stata specificata una data di fine, verranno visualizzati gli eventi basati sulla durata. </li>'),
unistr('  <li><strong>Mostra ora</strong>: selezionare <strong>S\00EC</strong> per mostrare la parte oraria degli eventi, nonch\00E9 abilitare le viste di calendario Settimanale e Giornaliero. Selezionare <strong>No</strong> per mostrare solo le date degli eventi.</')
||'li>',
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468316361307763)
,p_name=>'CA.CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470220298307767)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'it'
,p_message_text=>'Annulla finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447509518306916)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'it'
,p_message_text=>'Annulla modale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480105175307774)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere i privilegi di amministrazione dal record personale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510981209307801)
,p_name=>'CA.CARD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510826912307801)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di creare una pagina che visualizza le schede.</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong>(obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  <li><strong>Tabella o vista</strong> (obbligatorio): selezionare l''oggetto di database per la scheda.</li>',
'  <li><strong>Titolo scheda</strong> (obbligatorio): selezionare la colonna della tabella o della vista da utilizzare come titolo per la scheda.</li>',
'  <li><strong>Colonna descrizione</strong> (obbligatorio): selezionare la colonna della tabella o della vista da utilizzare come descrizione per la scheda.</li>',
'  <li><strong>Colonna di testo aggiuntiva</strong>: selezionare la colonna della tabella o della vista da utilizzare come descrizione secondaria per la scheda.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509475829307800)
,p_name=>'CA.CARDS'
,p_message_language=>'it'
,p_message_text=>'Schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509541729307800)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570699647307024)
,p_name=>'CA.CC'
,p_message_language=>'it'
,p_message_text=>'CC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831076136307266)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'it'
,p_message_text=>'Modifica filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460986790307757)
,p_name=>'CA.CHART'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461057994307757)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di creare una pagina che visualizza un grafico ad aree, a barre, a linee o a torta.</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong> (obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  <li><strong>Tipo di grafico</strong>: selezionare il tipo di grafico da visualizzare [<strong>Ad aree</strong>, <strong>A barre</strong>, <strong>A linee</strong>, <strong>A torta</strong>].</li>',
'  <li><strong>Tabella o vista</strong> (obbligatorio): selezionare l''oggetto di database per il grafico.</li>',
'  <li><strong>Colonna etichetta</strong> (obbligatorio): selezionare la colonna da utilizzare come etichetta per il grafico dalla tabella o dalla vista.</li>',
unistr('  <li><strong>Aggregazione valori</strong>: selezionare le modalit\00E0 di visualizzazione o aggregazione della colonna valori<br>'),
'      &nbsp;&nbsp;&nbsp;[Valore colonna, Somma, Conteggio].</li>',
'  <li><strong>Colonna valori</strong> (obbligatorio): selezionare la colonna numerica usata per calcolare i valori del grafico visualizzati dalla tabella o dalla vista.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461383734307757)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3>Esempi</h3>',
'<p>Rivedere gli esempi che mostrano come utilizzare i vari tipi di <strong>Riepilogo</strong>:</p>',
'<p><strong>Esempio 1:</strong> visualizza un grafico relativo ai dipendenti con la matricola dipendente del responsabile relativa a ciascun dipendente.',
'<code><ul>',
'  <li>Tabella o vista: selezionare EMP.</li>',
'  <li>Colonna etichetta: selezionare ENAME.</li>',
'  <li>Riepilogo: selezionare <u><strong>Valore colonna</strong></u>.</li>',
'  <li>Colonna valori: selezionare MGR.</li>',
'</ul></code>',
'</p>',
'<p><strong>Esempio 2:</strong> visualizza un grafico relativo ai dipendenti con il salario totale di ciascuna mansione lavorativa.',
'<code><ul>',
'  <li>Tabella o vista: selezionare EMP.</li>',
'  <li>Colonna etichetta: selezionare JOB.</li>',
'  <li>Riepilogo: selezionare <u><strong>Somma</strong></u>.</li>',
'  <li>Colonna valori: selezionare SAL.</li>',
'</ul></code>',
'</p>',
'<p><strong>Esempio 3:</strong> visualizza un grafico relativo ai dipendenti con il numero di dipendenti in ciascun reparto.',
'<code><ul>',
'  <li>Tabella o vista: selezionare EMP.</li>',
'  <li>Colonna etichetta: selezionare DEPTNO.</li>',
'  <li>Riepilogo: selezionare <u><strong>Conteggio</strong></u>.</li>',
'  <li>Colonna valori: selezionare EMPNO.</li>',
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697745268307146)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'it'
,p_message_text=>'ID client'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514192701307804)
,p_name=>'CA.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335690002306827)
,p_name=>'CA.CLOSED'
,p_message_language=>'it'
,p_message_text=>'Chiuso/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512197168307802)
,p_name=>'CA.COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489167465307781)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'it'
,p_message_text=>'Colonna 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489209824307781)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'it'
,p_message_text=>'Colonna 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476531681307772)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507902258307798)
,p_name=>'CA.COMMENTS'
,p_message_language=>'it'
,p_message_text=>'Commenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474283536307770)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479040898307774)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'it'
,p_message_text=>'Configura controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469484310307764)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'it'
,p_message_text=>'Configura aspetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469576750307764)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'it'
,p_message_text=>'<p>L''aspetto dell''applicazione viene definito dallo stile tema.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472835497307769)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Opzioni di configurazione aggiornate. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454748968307752)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di configurazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453099668307751)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'it'
,p_message_text=>'Abilita o disabilita le funzioni dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454884339307752)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consente agli amministratori dell''applicazione di abilitare o disabilitare funzionalit\00E0 specifiche all''interno dell''applicazione. Questa funzione \00E8 utile se si selezionano funzioni che richiedono un ulteriore impegno a livello di sviluppo prima di')
||' poter essere usate dagli utenti finali.<br>',
unistr('Questa funzione pu\00F2 anche essere estesa a funzioni specifiche dell''applicazione. Se gli sviluppatori definiscono opzioni di creazione aggiuntive e le associano a funzionalit\00E0 specifiche in tutta l''applicazione, \00E8 possibile aggiungerle alle impostazio')
||'ni di configurazione per gli amministratori. Ad esempio, all''interno dell''applicazione Tracker clienti, gli amministratori possono attivare o disattivare funzioni quali Contatti, Caricamento dati, Geografia e molte altre ancora.',
'</p>',
'<p>Include i seguenti componenti:',
'<ul>',
unistr('<li>Possibilit\00E0 di abilitare e disabilitare funzionalit\00E0 dell''applicazione</li>'),
unistr('<li>Uso della funzione per consentire la funzionalit\00E0 selettiva in base alla distribuzione</li>'),
unistr('<li>Possibilit\00E0 di raggruppare le impostazioni dell''applicazione correlate</li>'),
'<li>Controllo dei componenti da parte degli sviluppatori dell''applicazione tramite opzioni di creazione</li>',
unistr('<li>Disponibilit\00E0 dalla pagina di amministrazione</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692677843307142)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome credenziale connessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692794365307142)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario credenziale di connessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359185995307675)
,p_name=>'CA.CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Contesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479589256307774)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'it'
,p_message_text=>'Collaboratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699606557307148)
,p_name=>'CA.CPU.USED'
,p_message_language=>'it'
,p_message_text=>'CPU utilizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488092626307781)
,p_name=>'CA.CREATE'
,p_message_language=>'it'
,p_message_text=>'Crea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493182699307784)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490767988307783)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'it'
,p_message_text=>'Creazione dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491847190307784)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'it'
,p_message_text=>'Creazione calcoli applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491163748307783)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'it'
,p_message_text=>'Creazione icona dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491797735307783)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'it'
,p_message_text=>'Creazione elementi applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491994165307784)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'it'
,p_message_text=>'Creazione processi applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368202241307682)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'it'
,p_message_text=>'Creazione delle impostazioni applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498042600307788)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Crea un''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741546308307187)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'it'
,p_message_text=>'Creazione dei ruoli applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491340877307783)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'it'
,p_message_text=>'Creazione schemi di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492152656307784)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina vuota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491209324307783)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'it'
,p_message_text=>'Creazione opzioni di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492565113307784)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina di calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504364650307795)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492392716307784)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492864818307784)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina report classico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492461168307784)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490644619307783)
,p_name=>'CA.CREATE.END'
,p_message_language=>'it'
,p_message_text=>'Completamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511676874307801)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione della pagina Ricerca con facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493430063307785)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'it'
,p_message_text=>'Creazione funzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508931997307799)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina contenuto filtrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492225711307784)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490887344307783)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493076842307784)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'it'
,p_message_text=>'Creazione lista navigazione home page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492965161307784)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492777474307784)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202119041306723)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione della pagina mappa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497713374307788)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagine Master-Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491500864307783)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'it'
,p_message_text=>'Creazione barre di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494751036307786)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'it'
,p_message_text=>'Creazione gruppo di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493369704307785)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'it'
,p_message_text=>'Esecuzione traduzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493237085307785)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'it'
,p_message_text=>'Esecuzione traduzione per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492628677307784)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina report e form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497990692307788)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'it'
,p_message_text=>'Salvataggio progetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491634477307783)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'it'
,p_message_text=>'Creazione collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103492091134307784)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201818599306723)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina di creazione dei filtri intelligenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490566748307783)
,p_name=>'CA.CREATE.START'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490928087307783)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'it'
,p_message_text=>'Creazione script oggetti di supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491456141307783)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione messaggi di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504456226307796)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'it'
,p_message_text=>'Creazione pagina controllo temporale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511888366307802)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'it'
,p_message_text=>'Crea pagina procedura guidata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472167944307768)
,p_name=>'CA.CREATED'
,p_message_language=>'it'
,p_message_text=>'Data creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472207946307768)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'it'
,p_message_text=>'Creazione di'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460649454307757)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Creazione dell''applicazione in corso ...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693398920307142)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome credenziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699557782307148)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario credenziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472738907307769)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493778931307785)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'it'
,p_message_text=>'Query personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782514625307225)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'it'
,p_message_text=>'Usa tema personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782609249307225)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Modifica la procedura guidata per consentire l''uso di un tema personalizzato al posto del tema universale.</p>',
'',
unistr('<p>Selezionare un tema area di lavoro per l''applicazione. Se il tema supporta gli stili, sar\00E0 possibile selezionare anche lo stile.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447282310306916)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'it'
,p_message_text=>'Tema personalizzato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494308143307785)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358148269307675)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'it'
,p_message_text=>'Grafico %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494472819307785)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consente di creare una pagina di dashboard con pi\00F9 grafici.</p>'),
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong> (obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  </ul>',
'</ul>',
'&nbsp;<br>',
'<p>Ogni grafico (Grafico 1, Grafico 2, Grafico 3 e Grafico 4) viene impostato automaticamente su diversi tipi di grafico e si basa sui <em>dati di esempio</em>. ',
unistr('  Non \00E8 pertanto necessario immettere ulteriori dettagli per aggiungere questa pagina.'),
unistr('  \00C8 tuttavia possibile personalizzare ciascun grafico sostituendo i valori predefiniti con le proprie selezioni.<br>'),
'  Per personalizzare un grafico, immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome grafico</strong> (obbligatorio): immettere il nome per il grafico.</li>',
'  <li><strong>Tipo di grafico</strong>: selezionare il tipo di grafico da visualizzare [<strong>Ad aree</strong>, <strong>A barre</strong>, <strong>A linee</strong>, <strong>A torta</strong>].</li>',
'  <li><strong>Tabella o vista</strong> (obbligatorio): selezionare l''oggetto di database per il grafico.</li>',
'  <li><strong>Colonna etichetta</strong> (obbligatorio): selezionare dalla tabella o dalla vista la colonna da usare come etichetta per il grafico.</li>',
unistr('  <li><strong>Aggregazione valori</strong>: selezionare la modalit\00E0 di visualizzazione o aggregazione della colonna valori<br>'),
'      &nbsp;&nbsp;&nbsp;[Valore colonna, Somma, Conteggio].</li>',
'  <li><strong>Colonna valori</strong> (obbligatorio): selezionare dalla tabella o dalla vista la colonna numerica usata per calcolare i valori del grafico visualizzati.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505077724307796)
,p_name=>'CA.DATATYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506102364307797)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473493704307769)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'it'
,p_message_text=>'Fuso orario predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473566105307769)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Fuso orario predefinito aggiornato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495163862307786)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Valori predefiniti attributi applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495425325307786)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'it'
,p_message_text=>unistr('Questo documento JSON consente un controllo dettagliato sulla generazione dei nomi delle colonne di report e form, sui formati di visualizzazione e cos\00EC via. \00C8 anche possibile definire le liste di valori e altri componenti condivisi. ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511472770307801)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'it'
,p_message_text=>'Attributo lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511507473307801)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di aggiungere un attributo LOV (Lista di valori). Le liste di valori possono essere utilizzate nelle definizioni delle colonne di tabella.</p>',
'<p>Immettere gli attributi riportati di seguito.',
'  <ul>',
'    <li><strong>Nome</strong> (obbligatorio): immettere il nome per la lista di valori.</li>',
'    <li><strong>Tipo</strong>: selezionare il tipo della lista [Strutturata, Dinamica, Statica].<br>',
'      Per il tipo <u>Strutturata</u> - ',
'      <ul>',
'          <li><strong>Tabella</strong> (obbligatorio): selezionare la tabella o la vista su cui basare la lista di valori.</li>',
'          <li><strong>Colonna di visualizzazione</strong> (obbligatorio): selezionare la colonna da mostrare agli utenti finali.</li>',
'          <li><strong>Colonna chiave</strong> (obbligatorio): selezionare il valore di colonna da restituire. Si tratta in genere della chiave primaria per la tabella.</li>',
'      </ul>',
'      &nbsp;<br>',
'      Per il tipo <u>Dinamica</u> -',
'      <ul>',
'          <li><strong>Query SQL</strong> (obbligatorio): immettere un''istruzione SELECT SQL valida per la restituzione di due valori (valore visualizzato e valore restituito).</li>',
'      </ul>',
'      &nbsp;<br>',
'      Per il tipo <u>Statica</u> -',
'      <ul>',
'          <li><strong>Lista di valori statica</strong> (obbligatorio): immettere una lista statica valida:',
'          <ul>',
'            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>Lista visualizzata secondo l''ordine di immissione</li>',
'            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>Lista in ordine alfabetico</li>',
'            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>Valore visualizzato e valore restituito uguali</li>',
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512620217307802)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'it'
,p_message_text=>'Attributi report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512738658307802)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di modificare gli attributi per tutti i report.</p>',
'<p>Immettere gli attributi riportati di seguito.',
'  <ul>',
'    <li><strong>Righe per pagina</strong>: immettere il numero di righe da visualizzare per impostazione predefinita.</li>',
unistr('    <li><strong>Metodo di impaginazione</strong>: selezionare le modalit\00E0 di visualizzazione dell''impaginazione dei report.</li>'),
'    <li><strong>Formato di visualizzazione numerico</strong>: immettere il formato di visualizzazione da applicare alle colonne e agli elementi numerici.</li>',
'    <li><strong>Formato di visualizzazione data</strong>: immettere il formato di visualizzazione da applicare alle colonne e agli elementi di data.</li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512467050307802)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'it'
,p_message_text=>'Attributi tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512290378307802)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'it'
,p_message_text=>'Attributi colonna tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512319460307802)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di modificare gli attributi per la colonna di tabella selezionata.</p>',
'<p>Immettere gli attributi riportati di seguito.',
'  <ul>',
'    <li><strong>Tabella</strong> (Sola visualizzazione): la tabella associata.</li>',
'    <li><strong>Colonna</strong> (Sola visualizzazione): la colonna in base alla quale sono definiti gli attributi.</li>',
'    <li><strong>Etichetta</strong>: immettere il testo da usare nelle intestazioni dei report e nelle etichette dei form.</li>',
'    <li><strong>Controllo form</strong>: selezionare il tipo di elemento da usare nei form.</li>',
'    <li><strong>Lista di valori</strong>: selezionare la lista di valori esistente da utilizzare per visualizzare in modo appropriato i nomi riconoscibili dall''utente.</li>',
unistr('    <li><strong>Formato di visualizzazione</strong>: immettere il formato di visualizzazione appropriato in base al tipo di colonna (testo, numerico, data e cos\00EC via).</li>'),
'    <li><strong>Valore predefinito statico</strong>: immettere un valore predefinito di testo per la colonna.</li>',
unistr('    <li><strong>Includi in form</strong>: fare clic su S\00EC se la colonna deve essere inclusa nei form.</li>'),
unistr('    <li><strong>Includi in report</strong>: fare clic su S\00EC se la colonna deve essere inclusa nei report.</li>'),
unistr('    <li><strong>Obbligatorio</strong>: fare clic su S\00EC se \00E8 obbligatorio inserire i dati in questa colonna nei form.</li>'),
'    <li><strong>?</strong>: immettere il testo della Guida aggiunto all''attributo Guida dell''elemento.</li>',
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512532705307802)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di modificare gli attributi per la tabella selezionata.</p>',
'<p>Immettere gli attributi riportati di seguito.',
'  <ul>',
'    <li><strong>Tabella</strong> (Sola visualizzazione): la tabella associata.</li>',
'    <li><strong>Etichetta, singolare</strong> (obbligatorio): immettere l''etichetta da usare nelle pagine dei form.</li>',
'    <li><strong>Etichetta, plurale</strong> (obbligatorio): immettere l''etichetta da usare nelle intestazioni delle aree e nei nomi delle pagine.</li>',
'    <li><strong>Colonna di visualizzazione primaria</strong>: selezionare la prima colonna da visualizzare, ad esempio nelle aree delle schede.</li>',
'    <li><strong>Colonna di visualizzazione secondaria</strong>: selezionare la seconda colonna da visualizzare, ad esempio nelle aree delle schede.</li>',
'    <li><strong>Colonna chiave primaria</strong>: selezionare la colonna di chiave primaria univoca per la tabella.</li>',
'    <li><strong>Descrizione</strong>: immettere la descrizione della tabella.</li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693119563307142)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'it'
,p_message_text=>'Eliminazione differita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506754565307797)
,p_name=>'CA.DEFINITION'
,p_message_language=>'it'
,p_message_text=>'Definizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490432218307782)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Disinstallazione completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470705923307767)
,p_name=>'CA.DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103490086357307782)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Eseguire questa azione di eliminazione?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456332119307753)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 certi di voler eliminare questa pagina?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480516176307775)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'it'
,p_message_text=>'Elimina foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471445488307768)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488677308307781)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'it'
,p_message_text=>'Barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488554059307781)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'it'
,p_message_text=>'Menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469744796307764)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'it'
,p_message_text=>'Stile tema desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469833802307764)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'it'
,p_message_text=>'Lo stile tema predefinito viene applicato a tutti gli utenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693563716307142)
,p_name=>'CA.DESTINATION'
,p_message_language=>'it'
,p_message_text=>'Destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693691537307143)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447365598306916)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Pulsanti finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485096481307778)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'it'
,p_message_text=>'Spedisci messaggi di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503530029307795)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'it'
,p_message_text=>'Determina se i messaggi di posta elettronica devono essere inviati dal framework di posta elettronica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471273606307767)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'it'
,p_message_text=>'Visualizza da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471130843307767)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Sequenza di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471387916307768)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'it'
,p_message_text=>'Visualizza fino a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505245627307796)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474827194307770)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti distinti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488158594307781)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'Scarica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495035407307786)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'it'
,p_message_text=>'Trascinare per riordinare la pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468036057306933)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
'  <li><strong>Collegamento drill-down</strong>: espandere per visualizzare gli attributi per la definizione di un collegamento di drill-down.',
'&nbsp;<br>',
unistr('    <em><strong>Nota:</strong> Collegamento drill-down sar\00E0 visibile solo se la pagina corrente si basa su una tabella o una vista, se il tipo di report \00E8 Report interattivo e se \00E8 stata definita una pagina di report (Report interattivo) o Master-Det')
||'ail (Master-Detail).</em>',
'  <ul>',
unistr('    <li><strong>Colonna di collegamento</strong>: selezionare la colonna che verr\00E0 modificata in colonna di collegamento nel report.</li>'),
unistr('    <li><strong>Chiave di collegamento</strong>: selezionare la colonna della chiave di collegamento (chiave esterna) utilizzata per identificare il record specifico nella pagina a cui \00E8 collegato.</li>'),
unistr('    <li><strong>Collegamento alla pagina</strong>: selezionare la pagina di report o di form che verr\00E0 visualizzata selezionando il collegamento.</li>'),
unistr('    <li><strong>Chiave di destinazione</strong>: selezionare la colonna della chiave di destinazione (chiave primaria) nella tabella su cui \00E8 basata la pagina di report che verr\00E0 visualizzata selezionando il collegamento.'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473990533307770)
,p_name=>'CA.ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456560924307753)
,p_name=>'CA.EMAIL'
,p_message_language=>'it'
,p_message_text=>'Framework posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503136042307795)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'it'
,p_message_text=>'Indirizzi di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513164415307803)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456424241307753)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiunge la possibilit\00E0 di configurare e inviare messaggi di posta elettronica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456625868307754)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Include la possibilit\00E0 di inviare messaggi di posta elettronica dall''applicazione. Utilizzando il modello di posta elettronica di esempio, \00E8 possibile inviare agli utenti messaggi di posta elettronica dall''aspetto professionale. I messaggi inviati')
||unistr(' vengono registrati in modo che gli amministratori possano tenere traccia dell''attivit\00E0 di posta elettronica.</p>'),
'<p>Include i componenti riportati di seguito.',
'<ul>',
'<li>Sistema di modelli di posta elettronica HTML estensibili</li>',
'<li>Package PL/SQL per l''invio di posta tramite package APEX</li>',
unistr('<li>Registrazione dell''attivit\00E0 e dello stato della posta elettronica</li>'),
'<li>Interfaccia utente amministrativa per gestire i modelli</li>',
'<li>Interfaccia utente amministrativa per visualizzare i log di posta elettronica</li>',
'<li>Interfaccia utente amministrativa per inviare i messaggi di posta elettronica</li>',
'</ul>',
'</p>',
'<p><em>Nota: questa funzione viene abilitata quando si seleziona Feedback</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508888796307799)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica - Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484037977307777)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'it'
,p_message_text=>'Log di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513729368307803)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Dettagli di impostazione posta elettronica obbligatori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513235637307803)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('L''indirizzo del mittente non \00E8 valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504737447307796)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('L''indirizzo del mittente non \00E8 valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503932908307795)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'it'
,p_message_text=>'Messaggio di posta elettronica elaborato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570955645307024)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'it'
,p_message_text=>'Generazione report di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743231052307189)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Report relativo a tutti i messaggi di posta elettronica inseriti in coda per l''invio e a quelli gi\00E0 inviati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484944163307778)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485309602307778)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Impostazioni di posta elettronica aggiornate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509200100307799)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato messaggio di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485453799307779)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'it'
,p_message_text=>'Dettagli modello di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991694172307388)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'it'
,p_message_text=>unistr('Indisponibilit\00E0 pianificata per #SERVICE_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789930536307233)
,p_name=>'CA.EMAIL2'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483963225307777)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'it'
,p_message_text=>'Messaggi di posta elettronica inviati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513351967307803)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'it'
,p_message_text=>'Abilita allegati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698601530307147)
,p_name=>'CA.ENABLED'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695866291307145)
,p_name=>'CA.END.DATE'
,p_message_language=>'it'
,p_message_text=>'Data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486037018307779)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Contenuto dopo le righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377347930307689)
,p_name=>'CA.ENDED'
,p_message_language=>'it'
,p_message_text=>'Terminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501014909307793)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'it'
,p_message_text=>'Immettere qui i nomi utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474581964307770)
,p_name=>'CA.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476835182307772)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'it'
,p_message_text=>'Backtrace degli errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476753870307772)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'it'
,p_message_text=>'Codice di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476099535307771)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700334351307149)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'it'
,p_message_text=>'Numero errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699303707307148)
,p_name=>'CA.ERRORS'
,p_message_language=>'it'
,p_message_text=>'Errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377508933307689)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696264624307145)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696303477307145)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'it'
,p_message_text=>'Agente coda eventi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696468408307145)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome coda eventi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696568171307145)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario coda eventi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696166983307145)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'it'
,p_message_text=>'Regola evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501319960307793)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'it'
,p_message_text=>'Eccezioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514229600307804)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'it'
,p_message_text=>'Esperienza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698372177307147)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472557314307768)
,p_name=>'CA.FEATURE'
,p_message_language=>'it'
,p_message_text=>'Funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147164483307505)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'it'
,p_message_text=>'Versione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147268009307505)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831400568307266)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'it'
,p_message_text=>'Aggiungi utenti alla lista di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831243953307266)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'it'
,p_message_text=>'Vai al passo successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831312913307266)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'it'
,p_message_text=>'Crea raccolte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831192447307266)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'it'
,p_message_text=>'Impossibile modificare l''ultimo amministratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146884284307505)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Ultima attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830907057307266)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('Nessuna attivit\00E0 trovata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147027816307505)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'it'
,p_message_text=>'Causa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831521599307266)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 richiesto almeno un feedback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831881001307266)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'it'
,p_message_text=>'Recupera ID file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830461659307265)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830547839307265)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'it'
,p_message_text=>'Salva preferenza di stile utente finale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146970099307505)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460724815307757)
,p_name=>'CA.FEATURES'
,p_message_language=>'it'
,p_message_text=>'Funzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103460868515307757)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Le funzioni forniscono funzionalit\00E0 a livello di applicazione e in genere vengono aggiunte una sola volta per applicazione. Scegliere le funzioni da includere nell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454691028307752)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452634500307750)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'it'
,p_message_text=>'Consente agli utenti di fornire un feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454522538307752)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Fornisce agli utenti finali un meccanismo per inviare commenti generali agli amministratori e agli sviluppatori dell''applicazione. Gli invii includono informazioni utili sullo stato della sessione che consentono di determinare da quale punto gli u'
||unistr('tenti finali hanno inviato il feedback. La disponibilit\00E0 di un ciclo di feedback tanto semplice migliora la comunicazione tra la community di utenti e i proprietari dell''applicazione, migliorando notevolmente la soddisfazione degli utenti finali.</p>'),
'<p>Include i seguenti componenti:',
'<ul>',
unistr('<li>Possibilit\00E0 per gli utenti finali di lasciare un feedback facendo clic sull''icona della barra di navigazione</li>'),
'<li>Report amministrativo per visualizzare e aggiornare il feedback</li>',
'<li>Acquisizione delle informazioni su utente, data e ora e User Agent tramite il feedback</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514646141307804)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'it'
,p_message_text=>'Fornire un feedback o la propria esperienza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513615976307803)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'it'
,p_message_text=>'Invia a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513042129307803)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482011140307776)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Impostazioni feedback aggiornate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513894071307803)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Feedback sottomesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695913867307145)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome watcher file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696084947307145)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario watcher file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354114987306842)
,p_name=>'CA.FILED'
,p_message_language=>'it'
,p_message_text=>'Archiviato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354263102306842)
,p_name=>'CA.FILED.BY'
,p_message_language=>'it'
,p_message_text=>'Presentato da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509374175307800)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'it'
,p_message_text=>'Filtra report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486451467307779)
,p_name=>'CA.FILTERS'
,p_message_language=>'it'
,p_message_text=>'Filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512090528307802)
,p_name=>'CA.FINISH'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480777436307775)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692906385307142)
,p_name=>'CA.FLAGS'
,p_message_language=>'it'
,p_message_text=>'Flag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462153668307758)
,p_name=>'CA.FORM'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462034981307758)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di creare una pagina che visualizza un pagina di form per consentire agli utenti finali di gestire i dati.</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong> (obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  <li><strong>Tabella</strong> (obbligatorio): selezionare la tabella per il form.</li>',
unistr('<li><strong>Includi report</strong> (obbligatorio): selezionare questa opzione per creare un report e un form. La prima pagina \00E8 un report interattivo. In ogni riga \00E8 disponibile un collegamento a un form in cui gli utenti possono aggiornare il recor')
||'d. </li>',
'  &nbsp;<br>',
'<li><strong>Avanzate</strong>: espandere per visualizzare le opzioni avanzate.',
'     <ul>',
'      <li><strong>Guida sulla pagina</strong>: immettere il testo da aggiungere al testo della Guida per la pagina.</li>',
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466663029306932)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'it'
,p_message_text=>'Area elementi form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488335189307781)
,p_name=>'CA.FORM.ON'
,p_message_language=>'it'
,p_message_text=>'Form su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500866062307793)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di form non \00E8 valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507266323307798)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506243539307797)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'it'
,p_message_text=>'Controllo form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471986244307768)
,p_name=>'CA.FROM'
,p_message_language=>'it'
,p_message_text=>'Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485170190307778)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'it'
,p_message_text=>'Indirizzo mittente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508768873307799)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'it'
,p_message_text=>'Impostazione posta elettronica "Indirizzo mittente"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504682469307796)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica mittente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504519803307796)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'it'
,p_message_text=>'Mittente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197531043307554)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'it'
,p_message_text=>'Ricerca %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475493908307771)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni pagina intera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484138407307778)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'it'
,p_message_text=>'HTML modello completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505731096307797)
,p_name=>'CA.FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455015328307752)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Ricerca globale'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452844314307750)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Fornisce funzionalit\00E0 di ricerca nell''applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454902123307752)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente agli utenti finali di cercare un testo nelle tabelle o viste chiave all''interno dell''applicazione. La pagina di ricerca avanzata include filtri per permettere agli utenti finali di limitare i risultati.<br>',
'Questa funzione estremamente efficace richiede un impegno a livello di sviluppo per definire le istruzioni SQL (in base agli esempi forniti).</p>',
'<p>Include i seguenti componenti:',
'<ul>',
'<li>Visualizzazione di un''icona di ricerca nella barra dell''intestazione</li>',
'<li>Presenza di una pagina di risultati di ricerca dettagliata con filtro della barra laterale</li>',
'<li>Implementazione delle istruzioni SQL da parte degli sviluppatori per definire la ricerca nell''applicazione</li>',
unistr('<li>Disponibilit\00E0 di dati di esempio per offrire una dimostrazione</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697685349307146)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'it'
,p_message_text=>'ID univoco globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830099519307265)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'it'
,p_message_text=>'Pagina globale - Desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447445747306916)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'it'
,p_message_text=>'Vai a pagina di amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461610171307758)
,p_name=>'CA.GRID'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina della griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461739892307758)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consente di creare una pagina che visualizza una griglia interattiva simile a un foglio di calcolo. Quando la modifica \00E8 consentita, ovvero quando il tipo di griglia Consenti modifica \00E8 abilitato, gli utenti possono modificare direttamente pi\00F9 rig')
||'he nella pagina.</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong> (obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  <li><strong>Tipo di query</strong>: selezionare l''origine per il report [<strong>Tabella o vista</strong> o <strong>Query SQL</strong>].<br>',
'    <strong>Tabella o vista</strong>:',
'    <ul>',
'      <li><strong>Tabella o vista</strong> (obbligatorio): selezionare l''oggetto di database per la griglia.</li>',
'    </ul>',
'    <strong>Query SQL</strong>:',
'    <ul>',
'      <li><strong>Query SQL</strong> (obbligatorio): immettere un''istruzione SQL valida che restituisca colonne distinte.</li>',
'    </ul>',
'  </li>',
'  <li><strong>Tipo di griglia</strong>: specificare per consentire o meno agli utenti di modificare le righe nella griglia [<strong>Consenti modifica</strong> o <strong>Sola lettura</strong>]. Per consentire la modifica, selezionare <strong>Consenti '
||'modifica</strong>.</li>',
'  &nbsp;<br>',
unistr('  <em><strong>Avvertenza:</strong> se si seleziona il tipo di query <strong>Query SQL</strong> e il tipo di griglia <strong>Consenti modifica</strong> e la query unisce tramite join due o pi\00F9 tabelle, la griglia interattiva generata produrr\00E0 un error')
||'e quando gli utenti tenteranno di aggiornare i record.',
unistr('Inoltre, se si seleziona il tipo di griglia <strong>Consenti modifica</strong> e la query (oppure la tabella o vista selezionata) usa una vista non aggiornabile, la griglia interattiva generata produrr\00E0 un errore quando gli utenti tenteranno di aggio')
||'rnare i record.</em><br>',
'  </li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486934117307780)
,p_name=>'CA.HELP'
,p_message_language=>'it'
,p_message_text=>'Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377183000307689)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina fornisce un report interattivo del log delle automazioni.</p>',
unistr('<p>Rivedere le informazioni registrate relative alle precedenti esecuzioni delle automazioni. Il log contiene gli indicatori orari di inizio e fine, nonch\00E9 i dettagli relativi alle righe elaborate (riuscite e con errori). Eseguire il drill-down di Me')
||'ssaggi per visualizzare i singoli messaggi relativi alle righe elaborate.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479387340307774)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'it'
,p_message_text=>unistr('Scegliere <strong>No</strong> se tutti gli utenti sono definiti nella lista di controllo dell''accesso. Scegliere <strong>S\00EC</strong>, se questa applicazione pu\00F2 essere usata anche dagli utenti autenticati che non si trovano nella lista di controllo d')
||'ell''accesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473066635307769)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo immesso in questo campo viene usato in tutta l''applicazione, in modo pi\00F9 evidente, nell''angolo superiore sinistro di ogni pagina. La modifica avr\00E0 effetto immediatamente per l''amministratore che la apporta, ma gli altri utenti visualizzerann')
||'o la modifica solo quando accederanno a una nuova sessione (ad esempio, al successivo login).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467678339307762)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic sull''icona di feedback (<span class="fa fa-comment-o" aria-hidden="true"></span>) nella barra di navigazione, in qualsiasi pagina dell''applicazione, per lasciare un feedback agli amministratori dell''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467324378307762)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Questa \00E8 la home page dell''applicazione. Fare clic sulle schede per accedere alle varie pagine dell''applicazione o utilizzare il menu di navigazione sul lato della pagina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467565758307762)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Questa \00E8 la home page dell''applicazione. Fare clic sulle schede per accedere alle varie pagine dell''applicazione o utilizzare il menu di navigazione nella parte superiore della pagina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467765800307762)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere un termine di ricerca nel campo <strong>Cerca nell''applicazione</strong> di questa pagina o fare clic sull''icona di ricerca (<span class="fa fa-search" aria-hidden="true"></span>) nella barra di navigazione di qualsiasi pagina, per cerca'
||'re il termine all''interno dell''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468072560307763)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic sul menu a discesa del proprio nome nella barra di navigazione per scollegarsi dall''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467942177307763)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic sul menu dell''utente (<span class="fa fa-user" aria-hidden="true"></span>) nella barra di navigazione per aggiornare la preferenza di fuso orario e scollegarsi dall''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467452410307762)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'it'
,p_message_text=>'Home page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468189526307763)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Fare clic sul menu dell''utente (<span class="fa fa-user" aria-hidden="true"></span>) nella barra di navigazione (in alto a destra) per accedere al proprio profilo utente e scollegarsi dall''applicazione.<br>',
unistr('Se si fa clic su <strong>Visualizza profilo personale</strong>, \00E8 poi possibile fare clic su <strong>Aggiorna profilo</strong> per immettere i dettagli personali e caricare una foto o un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467840603307763)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Fare clic sul menu dell''utente (<span class="fa fa-user" aria-hidden="true"></span>) nella barra di navigazione per accedere al proprio profilo utente, aggiornare la preferenza di fuso orario e scollegarsi dall''applicazione.<br>',
unistr('Se si fa clic su <strong>Visualizza profilo personale</strong>, \00E8 poi possibile fare clic su <strong>Aggiorna profilo</strong> per immettere i dettagli personali e caricare una foto o un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493971725307785)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Per trovare i dati, immettere un termine di ricerca nell''apposita finestra di dialogo oppure fare clic sulle intestazioni di colonna per limitare il numero di record restituiti.</p>',
'',
unistr('<p>\00C8 possibile eseguire numerose funzioni facendo clic sul pulsante <strong>Azioni</strong>, ad esempio selezionare le colonne visualizzate/nascoste e la relativa sequenza di visualizzazione, oltre a diverse funzioni relative a dati e formati. Inoltr')
||unistr('e, \00E8 possibile definire una vista aggiuntiva dei dati usando l''opzione basata sul grafico.</p>'),
'',
'<p>Se si desidera salvare le personalizzazioni, selezionare il report o fare clic su Download per scaricare i dati.<p>',
'<br>',
'<p>Per ulteriori informazioni, fare clic su ? nella parte inferiore del menu Azioni.</p>',
'',
'<p>Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493811594307785)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00C8 possibile inserire, aggiornare ed eliminare i dati direttamente all''interno di questa griglia interattiva.<br>'),
'  Inserire una nuova riga facendo clic sul pulsante Aggiungi riga.<br>',
'  Fare doppio clic in una cella o fare clic sul pulsante <strong>Modifica</strong> per aggiornare i valori dei dati, analogamente a quanto accede durante la modifica dei dati in un foglio di calcolo.</p>',
'',
'<p>Usare il menu Azioni riga (<span class="fa fa-bars" aria-hidden="true"></span>) nella parte superiore del report per duplicare, eliminare, aggiornare o ripristinare le righe selezionate.<br> ',
'  Usare il menu Azioni riga sulle singole righe per accedere anche alla visualizzazione di una singola riga o per aggiungere una nuova riga.</p>',
'',
'<p>Per trovare i dati, immettere un termine di ricerca nell''apposita finestra di dialogo o fare clic sulle intestazioni di colonna per limitare il numero di record restituiti.</p>',
'',
unistr('<p>\00C8 possibile eseguire numerose funzioni facendo clic sul pulsante <strong>Azioni</strong>, ad esempio selezionare le colonne visualizzate/nascoste e la relativa sequenza di visualizzazione, oltre a diverse funzioni relative a dati e formati. Inoltr')
||unistr('e, \00E8 possibile definire un''ulteriore vista dei dati utilizzando l''opzione basata sul grafico.</p>'),
'',
'<p>Se si desidera salvare le personalizzazioni, selezionare il report o fare clic su Download per scaricare i dati.<p>',
'',
'<p>Per ulteriori informazioni, fare clic su ? nella parte inferiore del menu Azioni.</p>',
'',
'<p>Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite della griglia interattiva.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467288563307762)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Per trovare i dati, immettere un termine di ricerca nell''apposita finestra di dialogo oppure fare clic sulle intestazioni di colonna per limitare il numero di record restituiti.</p>',
'',
unistr('<p>\00C8 possibile eseguire numerose funzioni facendo clic sul pulsante <strong>Azioni</strong>, ad esempio selezionare le colonne visualizzate/nascoste e la relativa sequenza di visualizzazione, oltre a diverse funzioni relative a dati e formati. Inoltr')
||unistr('e, \00E8 possibile definire ulteriori viste dei dati usando le opzioni basate su grafici, raggruppamenti e pivot.</p>'),
'',
'<p>Se si desidera salvare le personalizzazioni, selezionare il report o fare clic su Download per scaricare i dati. Immettere il proprio indirizzo di posta elettronica e il periodo di tempo previsto dalla sottoscrizione durante il quale i dati devono'
||' essere inviati regolarmente.<p>',
'',
'<p>Per ulteriori informazioni, fare clic su ? nella parte inferiore del menu Azioni.</p>',
'',
'<p>Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501815793307793)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In questa pagina di report sono visualizzati i record primari in un selettore a lato della pagina. ',
'  Selezionare un record per visualizzare il record Master e qualsiasi record Detail definito.<br> ',
'  Fare clic sull''icona di modifica (<span class="fa fa-pencil-square-o" aria-hidden="true"></span>) per modificare il record Master.',
'  Per i record Detail, fare clic sulla matita all''inizio di ogni riga per modificare il record corrispondente.</p>',
'<p>Per limitare i dati visualizzati nel selettore, immettere un termine di ricerca nell''apposita finestra di dialogo.</p>',
'',
'<p>Per aggiungere un nuovo record Master, fare clic su <strong>Crea</strong> nella parte superiore della pagina.',
unistr('  Per i record dettagliati, fare clic sull''icona con il segno pi\00F9 ( + ) nella parte superiore dell''area detail per aggiungere un record Detail.</p>'),
'',
'<p>Fare clic su <strong>Reimposta</strong> nella parte superiore della pagina per ripristinare le impostazioni predefinite della pagina, rimuovendo eventuali termini di ricerca definiti in precedenza.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465273933307760)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>La pagina di amministrazione consente ai proprietari dell''applicazione (amministratori) di configurare l''applicazione e gestire i dati comuni usati in tutta l''applicazione.',
unistr('Se si seleziona una delle impostazioni disponibili, gli amministratori possono eventualmente modificare la modalit\00E0 di visualizzazione e/o le funzioni disponibili per gli utenti finali.</p>'),
'<p>L''accesso a questa pagina dovrebbe essere limitato solo agli amministratori.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466402474307761)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare l''opzione appropriata per qualsiasi utente autenticato.<br>',
unistr('Se si seleziona <strong>No</strong>, si garantisce maggiore sicurezza all''applicazione poich\00E9 solo gli utenti specificati potranno accedere all''applicazione.'),
unistr('Tuttavia, se la community di utenti dell''applicazione \00E8 estesa, gestirli tutti potrebbe diventare oneroso. In questo caso, sarebbe preferibile scegliere <strong>S\00EC</strong> e immettere solo gli amministratori dell''applicazione ed eventualmente i coll')
||'aboratori.<br>',
unistr('Se si seleziona <strong>S\00EC</strong>, \00E8 necessario selezionare anche come gestire gli utenti non inclusi nell''apposita lista.</p>'),
'<p>Effettuare una selezione tra la richiesta di indirizzi di posta elettronica e qualsiasi valore numerico per Nomi utente.<br>',
unistr('In genere, \00E8 consigliabile impostare questa opzione su <strong>Indirizzo di posta elettronica</strong> se l''applicazione utilizza (o verr\00E0 configurata per usare) uno schema di autenticazione centralizzato come Oracle Access Manager o SSO.</p>'),
'<p><em><strong>Nota:</strong> questa applicazione supporta i tre livelli di accesso seguenti: Lettore, Collaboratore e Amministratore.',
'<ul>',
'  <li>I <strong>lettori</strong> hanno accesso in sola lettura a tutte le informazioni e possono visualizzare i report.</li>',
'  <li>I <strong>collaboratori</strong> possono creare, modificare ed eliminare le informazioni e visualizzare i report.</li>',
unistr('  <li>Gli <strong>amministratori</strong>, oltre alla funzionalit\00E0 previste per i collaboratori, possono eseguire anche la configurazione dell''applicazione accedendo alla sezione Amministrazione dell''applicazione.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466609214307762)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questo form per immettere gli utenti, i rispettivi indirizzi di posta elettronica e impostarne il livello di accesso.',
unistr('Le impostazioni definite in <em>Configura controllo dell''accesso</em> determineranno se il nome utente deve essere l''indirizzo di posta elettronica o pu\00F2 essere qualsiasi immissione alfanumerica.</p>'),
'<p>Questa applicazione supporta i tre livelli di accesso seguenti: Lettore, Collaboratore e Amministratore.</p>',
'<ul>',
'  <li>I <strong>lettori</strong> hanno accesso in sola lettura a tutte le informazioni e possono anche visualizzare i report.</li>',
'  <li>I <strong>collaboratori</strong> possono creare, modificare ed eliminare le informazioni e visualizzare i report.</li>',
unistr('  <li>Gli <strong>amministratori</strong>, oltre alle funzionalit\00E0 previste per i collaboratori, possono eseguire anche la configurazione dell''applicazione accedendo alla sezione Amministrazione dell''applicazione.</li>'),
'</ul>',
unistr('<p>Quando si modifica un utente esistente, \00E8 possibile bloccare il relativo account impedendone quindi l''accesso all''applicazione.</p>'),
unistr('<p><em><strong>Nota:</strong> se si utilizzano account Oracle Application Express, gli utenti immessi in questo form devono essere definiti come utenti finali anche da un amministratore dell''area di lavoro, che pu\00F2 impostarne le password.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466508192307761)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina mostra un report degli utenti dell''applicazione e il livello di accesso concesso.</p>',
'<p>Fare clic sulle intestazioni di colonna per ordinare e filtrare i dati oppure fare clic sul pulsante <strong>Azioni</strong> per personalizzare la visualizzazione della colonna e molte funzioni avanzate aggiuntive.<br>',
'Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>',
'<p>Fare clic sull''icona di modifica (matita gialla) per modificare i dettagli e il livello di accesso dell''utente o per eliminare l''utente.</p>',
'<p>Fare clic su <strong>Aggiungi utente</strong>, nella parte superiore del report, per aggiungere un nuovo utente e il rispettivo livello di accesso.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480068719307774)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quando il controllo dell''accesso \00E8 abilitato, gli amministratori possono limitare l''accesso degli utenti autenticati a determinate funzioni dell''applicazione. Questa applicazione supporta i tre ruoli seguenti: Lettore, Collaboratore e Amministrato')
||'re.</p>',
'<ul>',
'  <li>I <strong>lettori</strong> hanno accesso in sola lettura a tutte le informazioni e possono anche visualizzare i report.</li>',
'  <li>I <strong>collaboratori</strong> possono creare, modificare ed eliminare le informazioni e visualizzare i report.</li>',
unistr('  <li>Gli <strong>amministratori</strong>, oltre alle funzionalit\00E0 previste per i collaboratori, possono eseguire anche la configurazione dell''applicazione.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500972732307793)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'it'
,p_message_text=>'Immettere i nomi utente separati da virgole, punti e virgola o spazi. I nomi utente esistenti o duplicati verranno ignorati automaticamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465475914307761)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le impostazioni di configurazione consentono di rendere funzionalit\00E0 specifiche disponibili (abilitate) o non disponibili (disabilitate) per gli utenti finali.</p>'),
unistr('<p>Se una funzione specifica non \00E8 pronta al 100% o deve essere temporaneamente rimossa, fare clic su <strong>Disabilitata</strong>.'),
'Una volta resa disponibile, fare semplicemente clic su <strong>Abilitata</strong>.</p>',
unistr('<p><em><strong>Nota:</strong> le modifiche apportate in questo campo non saranno evidenti ai singoli utenti che eseguono attualmente l''applicazione. Le impostazioni delle funzioni riviste verranno richiamate una volta che l''utente finale si sar\00E0 scol')
||'legato e poi ricollegato.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465517163307761)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la combinazione colori predefinita usata per visualizzare l''applicazione.</p>',
unistr('<p>Se l''opzione <strong>Consenti agli utenti finali di scegliere uno stile tema</strong> \00E8 selezionata, ciascun utente finale pu\00F2 selezionare uno degli stili di tema disponibili facendo clic sul collegamento <em>Personalizza</em> nell''angolo inferior')
||'e sinistro della home page.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466142337307761)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina fornisce un report interattivo di tutti gli errori imprevisti registrati dall''applicazione specifica.</p>',
'<p>Fare clic sulle intestazioni di colonna per ordinare e filtrare i dati oppure fare clic sul pulsante <strong>Azioni</strong> per personalizzare la visualizzazione della colonna e molte funzioni avanzate aggiuntive. Fare clic sul pulsante <strong>R'
||'eimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466083540307761)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questo report e il grafico per visualizzare gli utenti con il maggior numero di visualizzazioni di pagina durante l''intervallo di tempo specificato.</p>',
'<p>Selezionare il periodo di tempo per la generazione del report (intervallo predefinito = 1 giorno) e scegliere tra le icone del report e del grafico nella parte superiore della pagina.</p>',
unistr('<p>Per il report interattivo, usare il campo di ricerca o selezionare l''intestazione di colonna <strong>Utente</strong> per selezionare un utente specifico. \00C8 possibile eseguire numerose funzioni facendo clic sul pulsante <strong>Azioni</strong>, ad ')
||unistr('esempio per scegliere le colonne visualizzate/nascoste, le righe per pagina, il filtro e cos\00EC via. Fare clic sul pulsante <strong>Reimposta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466223999307761)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Questa pagina fornisce un report interattivo delle prestazioni e della popolarit\00E0 della pagina. Il report viene ordinato in base alle <strong>Prestazioni ponderate</strong> che vengono calcolate moltiplicando il tempo mediano trascorso per il nume')
||'ro di visualizzazioni di pagina.</p>',
'<p>Selezionare il periodo di tempo per la generazione del report (intervallo predefinito = 1 giorno) nella parte superiore della pagina, in base alle esigenze.<br>',
'Fare clic sulle intestazioni di colonna per ordinare e filtrare i dati oppure fare clic sul pulsante <strong>Azioni</strong> per personalizzare la visualizzazione della colonna e molte funzioni avanzate aggiuntive. Fare clic sul pulsante <strong>Reim'
||'posta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466323087307761)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Questa pagina fornisce un report interattivo delle visualizzazioni di pagina pi\00F9 recenti.</p>'),
'<p>Selezionare il periodo di tempo per la generazione del report (intervallo predefinito = 1 giorno) nella parte superiore della pagina, in base alle esigenze.<br>',
'Fare clic sulle intestazioni di colonna per ordinare e filtrare i dati oppure fare clic sul pulsante <strong>Azioni</strong> per personalizzare la visualizzazione della colonna e molte funzioni avanzate aggiuntive. Fare clic sul pulsante <strong>Reim'
||'posta</strong> per ripristinare le impostazioni predefinite del report interattivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465321432307760)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Le notifiche vengono visualizzate nella home page quando sono attive.</p>',
'<p>Questo report mostra le notifiche definite e il periodo di tempo in cui vengono visualizzate.</p>',
'<p>Fare clic sull''icona di modifica (matita gialla) per modificare una notifica esistente oppure fare clic su <strong>Aggiungi notifica</strong> per inserire una nuova notifica.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465629869307761)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome e una descrizione breve dell''applicazione.</p>',
'<p>Il nome dell''applicazione viene visualizzato nella home page. La descrizione breve viene visualizzata sotto il nome dell''applicazione.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465812667307761)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gli utenti finali possono immettere un feedback da qualsiasi pagina standard all''interno dell''applicazione.</p>',
'<p>Questo report mostra il feedback immesso, qualsiasi risposta fornita dagli amministratori e lo stato del feedback.</p>',
'<p>Fare clic sull''icona di modifica (matita gialla) per immettere una risposta o aggiornare lo stato del feedback.</p>',
'<p><em><strong>Nota:</strong> se i destinatari del feedback sono stati definiti, gli invii del feedback verranno trasmessi tramite posta elettronica agli indirizzi presenti nella lista dei destinatari del feedback.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481925479307776)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'it'
,p_message_text=>'Fornire una lista separata da virgole di indirizzi di posta elettronica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465992755307761)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'it'
,p_message_text=>unistr('<p><strong>Abilita allegati</strong>: se l''impostazione \00E8 S\00EC, gli utenti potranno caricare un allegato a supporto del proprio feedback.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466964939307762)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In questa pagina vengono elencati i modelli di posta elettronica definiti e viene indicato per quante volte \00E8 stato fatto riferimento al modello nei messaggi di posta elettronica inviati.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466760367307762)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In questa pagina vengono elencati i messaggi di posta elettronica inviati.</p>',
'<p>Fare clic sull''icona a forma di lente di ingrandimento per visualizzare ulteriori dettagli sui messaggi di posta elettronica inviati.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103466894855307762)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere le informazioni nei campi riportati di seguito per definire un modello di posta elettronica:</p>',
'<ul>',
'  <li><strong>Nome modello</strong> (obbligatorio): immettere un nome significativo per il modello.</li>',
'  <li><strong>Modello HTML</strong> (obbligatorio): immettere il codice HTML usato per creare il messaggio di posta elettronica inviato ai destinatari che accettano la consegna di messaggi di posta elettronica in formato HTML.',
'    Di seguito sono elencati alcuni valori di sostituzione:',
'    <ul>',
unistr('        <li><strong>#APP_NAME#</strong>: verr\00E0 sostituito dal nome dell''applicazione</li>'),
unistr('        <li><strong>#BODY1#</strong>: verr\00E0 sostituito dal valore passato come p_body1_text</li> '),
unistr('        <li><strong>#TABLE#</strong>: verr\00E0 sostituito dal valore passato come p_table_content, utilizzando il codice HTML di apertura della tabella, della riga della tabella e di chiusura della tabella</li> '),
unistr('        <li><strong>#BODY2#</strong>: verr\00E0 sostituito dal valore passato come p_body2_text</li> '),
unistr('        <li><strong>#ACTION#</strong>: verr\00E0 sostituito dal valore passato come p_action_label e p_action_link, utilizzando il modello Collegamento azione</li>'),
'     </ul></li>',
'  <li><strong>Modello di testo non codificato</strong> (obbligatorio): immettere il testo non codificato usato per creare il messaggio di posta elettronica inviato ai destinatari che non accettano messaggi di posta elettronica in formato HTML. Vengon'
||'o utilizzate le stesse sostituzioni del modello HTML, ma #TABLE# e #ACTION# verranno visualizzate come testo non codificato.</li>',
'<ul>',
unistr('<p>Modelli HTML aggiuntivi consentono di definire messaggi di posta elettronica pi\00F9 avanzati. Di seguito sono riportati alcuni di questi elementi:</p>'),
'<ul>',
'  <li><strong>Prima delle righe</strong>: immettere il codice HTML per sostituire #TABLE# nel modello HTML. Utilizzato solo se p_table_content viene passato.</li>',
'  <li><strong>Modello di riga</strong>: immettere il codice HTML per il rendering di ogni riga della tabella, incluso il codice di apertura/chiusura della riga e di apertura/chiusura dei dati con le sostituzioni #LABEL# e #VALUE#. Utilizzato solo se '
||'p_table_content viene passato.</li>',
'  <li><strong>Dopo le righe</strong>: immettere il codice HTML per chiudere la tabella o div. Utilizzato solo se p_table_content viene passato.</li>',
'  <li><strong>HTML collegamento azione</strong>: immettere il codice HTML per sostituire #ACTION# nel modello HTML. Deve contenere #ACTION_LINK# e #ACTION_TEXT#. Utilizzato solo se p_action_label e p_action_link vengono passati.</li>',
'</ul>',
unistr('<p><em><strong>Nota:</strong> usare le voci all''interno del <strong>modello predefinito</strong> come esempio per sviluppare un modello personalizzato. I modelli predefiniti utilizzano tutte le variabili di sostituzione che \00E8 possibile includere nel ')
||'modello di posta elettronica personale.</em></p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467066409307762)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Abilitare o disabilitare l''invio di messaggi di posta elettronica selezionando una delle opzioni <strong>Spedisci messaggi di posta elettronica</strong>.</p>',
unistr('<p>Immettere i <strong>Messaggi di posta elettronica inviati da</strong> mediante l''indirizzo di posta elettronica del contatto primario per i problemi dell''applicazione. Questo valore pu\00F2 essere utilizzato o sovrascritto quando si usa la funzione di')
||' posta elettronica.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485200462307778)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'it'
,p_message_text=>unistr('Si tratta dell''indirizzo del mittente che verr\00E0 usato per inviare i messaggi di posta elettronica. Pu\00F2 essere sovrascritto quando si utilizza la funzione di posta elettronica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502556360307794)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare le informazioni indicate di seguito e fare clic su [Invia messaggio di posta elettronica]. Tutti i messaggi di posta elettronica inviati vengono registrati nel log di posta elettronica.',
'    <ul>',
unistr('        <li><strong>Da</strong>: se in Impostazioni di posta elettronica \00E8 impostato un "Indirizzo mittente", tale indirizzo sar\00E0 considerato come un''opzione da cui effettuare l''invio. Se l''applicazione corrente utilizza gli indirizzi di posta elettr')
||unistr('onica come nome utente, \00E8 possibile scegliere di inviare i messaggi di posta elettronica dal proprio indirizzo. Infine, \00E8 sempre possibile utilizzare lo stesso indirizzo come mittente e come destinatario.</li>'),
unistr('        <li><strong>Invia a</strong>: se l''applicazione corrente utilizza gli indirizzi di posta elettronica come nome utente, \00E8 possibile scegliere di inviare i messaggi di posta elettronica a indirizzi e/o utenti.</li>'),
'        <li><strong>Indirizzi di posta elettronica</strong>: elenco separato da virgole di indirizzi di posta elettronica che riceveranno il messaggio. Gli indirizzi non validi non verranno inclusi.</li>',
'        <li><strong>Ruolo</strong>: inviare messaggi di posta elettronica a tutti gli utenti con un ruolo selezionato o a tutti gli utenti definiti. La lista di selezione include una lista di ruoli e il numero di utenti in ciascun ruolo.</li>',
'        <li><strong>Modello</strong>: selezionare il modello di posta elettronica da utilizzare per creare il corpo del messaggio di posta elettronica.</li>',
'        <li><strong>Oggetto</strong>: l''oggetto del messaggio di posta elettronica.</li>',
'        <li><strong>Corpo messaggio di posta elettronica</strong>: testo da includere come corpo del messaggio di posta elettronica.</li>',
'        <li><strong>Consenti opt-out</strong>: alcuni messaggi di posta elettronica devono essere inviati indipendentemente dal fatto che l''utente abbia eseguito l''opt-out dalla ricezione dei messaggi di posta elettronica, ad esempio messaggi di inte'
||unistr('rruzione del servizio e cos\00EC via. Questo flag identifica se \00E8 consentito l''opt-out per il messaggio di posta elettronica o se tale messaggio deve essere inviato indipendentemente dalla preferenza dell''utente.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504295531307795)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare le informazioni indicate di seguito e fare clic su [Invia messaggio di posta elettronica]. Tutti i messaggi di posta elettronica inviati vengono registrati nel log di posta elettronica.',
'    <ul>',
unistr('        <li><strong>Da</strong>: se in Impostazioni di posta elettronica \00E8 impostato un "Indirizzo mittente", tale indirizzo sar\00E0 considerato come un''opzione da cui effettuare l''invio. Altrimenti, \00E8 sempre possibile utilizzare lo stesso indirizzo com')
||'e mittente e come destinatario.</li>',
'        <li><strong>Indirizzi di posta elettronica</strong>: elenco separato da virgole di indirizzi di posta elettronica che riceveranno il messaggio. Gli indirizzi non validi non verranno inclusi.</li>',
'        <li><strong>Modello</strong>: selezionare il modello di posta elettronica da utilizzare per creare il corpo del messaggio di posta elettronica.</li>',
'        <li><strong>Oggetto</strong>: l''oggetto del messaggio di posta elettronica.</li>',
'        <li><strong>Corpo messaggio di posta elettronica</strong>: testo da includere come corpo del messaggio di posta elettronica.</li>',
'        <li><strong>Consenti opt-out</strong>: alcuni messaggi di posta elettronica devono essere inviati indipendentemente dal fatto che l''utente abbia eseguito l''opt-out dalla ricezione dei messaggi di posta elettronica, ad esempio messaggi di inte'
||unistr('rruzione del servizio e cos\00EC via. Questo flag identifica se \00E8 consentito l''opt-out per il messaggio di posta elettronica o se tale messaggio deve essere inviato indipendentemente dalla preferenza dell''utente.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465786790307761)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il fuso orario predefinito per tutti gli utenti di questa applicazione.</p>',
'<p>I singoli utenti possono sostituire questa impostazione facendo clic sul proprio nome utente (in alto a destra) e selezionando <strong>Preferenze</strong>. In alternativa, possono fare clic sul collegamento del fuso orario visualizzato nella parte'
||' inferiore della home page.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481642478307776)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>unistr('A questa pagina non \00E8 possibile accedere direttamente tramite l''interfaccia utente. Viene utilizzata per agevolare il download della foto del profilo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481326731307775)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'it'
,p_message_text=>unistr('Nella pagina Profilo utente \00E8 possibile visualizzare informazioni pertinenti su un utente in un''unica schermata facile da usare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481037803307775)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'it'
,p_message_text=>'Caricare una foto con una simmetria quadrata, altrimenti potrebbe apparire distorta. Le dimensioni immagine preferenziali sono 250x250 pixel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103467143574307762)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questo form consente di aggiornare i dettagli personali e caricare una foto o un avatar.</p>',
'<p>Per caricare un''immagine, fare clic su <strong>Sfoglia</strong> oppure trascinare la selezione dell''immagine sul pulsante.<br>',
'Caricare una foto con una simmetria quadrata, altrimenti potrebbe apparire distorta. Le dimensioni immagine preferenziali sono 250x250 pixel.</p>',
'<p>Fare clic su <strong>Elimina foto</strong> per rimuovere l''immagine.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487248583307780)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'it'
,p_message_text=>unistr('In questa pagina \00E8 possibile accedere a tutto il testo della Guida sull''applicazione. I collegamenti presenti nell''area "Documentazione" offrono una spiegazione pi\00F9 approfondita delle caratteristiche e delle funzionalit\00E0 dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468274587307763)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'it'
,p_message_text=>unistr('In questa pagina, \00E8 possibile impostare le preferenze dell''applicazione per il proprio account che possono avere effetto su diversi aspetti dell''applicazione come il fuso orario. Fare clic sulle icone della Guida a livello di elemento per scoprire qu')
||'ali azioni vengono eseguite da ciascuna preferenza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571012110307024)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Questo report mostra tutti i messaggi di posta elettronica in attesa di invio nella coda e quelli gi\00E0 inviati.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692571012307141)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Questo report include tutti i job selezionati per essere monitorati da questa applicazione. Facendo clic sul nome del job \00E8 possibile visualizzare ulteriori dettagli su un job.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699138709307148)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'it'
,p_message_text=>'<p>Questo report include i dettagli di esecuzione relativi ai job selezionati per il monitoraggio da parte di questa applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452555599307750)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'it'
,p_message_text=>'Aggiunge una pagina di informazioni su questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468972364307763)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'it'
,p_message_text=>'Impostare questa opzione su No se non si desidera ricevere messaggi di posta elettronica da questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502057266307794)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un termine di ricerca nell''apposita finestra di dialogo e fare clic su <strong>Cerca</strong>.<br>',
'Fare clic su una delle intestazioni dei risultati per passare al record specifico corrispondente.</p>',
unistr('<p>Per limitare la ricerca, deselezionare una o pi\00F9 origini. Il report corrispondente verr\00E0 eliminato dai risultati della ricerca.</p>'),
'<p>Fare clic su <strong>Reimposta</strong> per rimuovere il termine di ricerca corrente e selezionare tutte le origini.</p> '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468745201307763)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'it'
,p_message_text=>'Impostare il fuso orario preferito da usare in tutta l''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466935075306932)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi nascosti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488886257307781)
,p_name=>'CA.HOME'
,p_message_language=>'it'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494967503307786)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'it'
,p_message_text=>'Home page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510200812307800)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'it'
,p_message_text=>'Eventi pagina orari'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570111605307023)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione corpo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485644603307779)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482396864307776)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'it'
,p_message_text=>'In corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506419890307797)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'it'
,p_message_text=>'Includi in form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506331436307797)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'it'
,p_message_text=>'Includi in report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103491089281307783)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'it'
,p_message_text=>'Installazione script oggetti di supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693232948307142)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'it'
,p_message_text=>'ID istanza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694440876307143)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'it'
,p_message_text=>'Persistenza istanza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464777110307760)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Benvenuti in questa anteprima esclusiva per l''ambiente cloud che riguarda un modo innovativo e migliorato di creare un''applicazione ancora pi\00F9 completa di funzionalit\00E0. La Creazione guidata dell''applicazione standard consente solo di selezionare l')
||'e pagine da generare, mentre questa procedura guida consente anche di precaricare rapidamente una serie di funzioni aggiuntive nell''applicazione.</p>',
'<p>Le applicazioni generate usando questa procedura guidata verranno completamente supportate e potrebbero anche includere oggetti di supporto per determinate funzioni quali Controllo dell''accesso, Framework posta elettronica, Feedback e molte altre '
||'ancora.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464932825307760)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Iniziare immettendo un nome per l''applicazione. Successivamente, aggiungere una o pi\00F9 pagine all''applicazione. Selezionare le funzioni da includere. Scegliere le opzioni relative all''aspetto dell''applicazione, quindi immettere le impostazioni.<br>'),
unistr('A questo punto, fare clic su <strong>Crea applicazione</strong> e la procedura \00E8 terminata.</p>'),
'<p>Fare clic su <strong>Visualizza progetto</strong> per riutilizzare il modello di un''applicazione generata in precedenza o per replicare rapidamente le pagine.</p>',
'<p><em><strong>Nota:</strong> ciascuna sezione e ogni ''Aggiungi pagina'' include una Guida dettagliata che fornisce ulteriore assistenza.</em></p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464862561307760)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'it'
,p_message_text=>'Come utilizzare questa procedura guidata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498461895307788)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Di seguito sono elencati i principali problemi riscontrati al momento della release:',
'<ol>',
unistr('  <li>La procedura guidata Create Application from Blueprint Wizard non \00E8 tradotta.</li>'),
'  <li>Le applicazioni tradotte generate con questa procedura guidata sono tradotte solo in parte.</li>',
'  <li>Il drill-down del report supporta una sola colonna di drill-down.</li>',
unistr('  <li>Non \00E8 possibile generare le pagine del report dei filtri.</li>'),
'  <li>La funzione di posta elettronica include l''API di livello inferiore, ma non include ancora le funzioni di posta elettronica di livello superiore.</li>',
unistr('  <li>La generazione di un''applicazione da un progetto che fa riferimento a tabelle mancanti determiner\00E0 un errore imprevisto.</li>'),
'  <li>Impostazioni avanzate: i formati delle date non vengono applicati all''applicazione generata.</li>',
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498379326307788)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'it'
,p_message_text=>'Problemi noti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465163159307760)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Rilasciata: %0.</p>',
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103465006327307760)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'it'
,p_message_text=>'Dettagli release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464614937307760)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'it'
,p_message_text=>'Creazione guidata applicazione da un progetto {anteprima solo per il cloud}'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476264369307771)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'it'
,p_message_text=>'Indirizzo IP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474423832307770)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Ricerca IR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477424293307772)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'it'
,p_message_text=>'Ricerche di report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504872341307796)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'it'
,p_message_text=>'Nome elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697261754307146)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698728779307147)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'it'
,p_message_text=>'Classe job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697843449307146)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'it'
,p_message_text=>'Creatore job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698968303307148)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695490620307144)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'it'
,p_message_text=>unistr('Priorit\00E0 job')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692442968307141)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'it'
,p_message_text=>'Generazione report su job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732553023307179)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'it'
,p_message_text=>'Visualizza i dettagli di stato e di esecuzione dei job che supportano questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699056794307148)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'it'
,p_message_text=>'Dettagli esecuzione job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697908844307147)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'it'
,p_message_text=>'Stile job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698030251307147)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'it'
,p_message_text=>'Nome secondario job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697357200307146)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694068141307143)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'it'
,p_message_text=>'Carico del job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505384342307796)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna chiave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507121058307798)
,p_name=>'CA.LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505658234307797)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507326641307798)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'it'
,p_message_text=>'Etichetta plurale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507089985307798)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'it'
,p_message_text=>'Etichetta singolare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463805379307759)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'it'
,p_message_text=>'Lingua'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463955153307759)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'it'
,p_message_text=>'Selezionare la lingua primaria per questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497857576307788)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('<p>La lingua primaria determina la lingua utilizzata per visualizzare le pagine e i componenti generati in App Builder. Se si selezionano pi\00F9 traduzioni, saranno disponibili pi\00F9 opzioni per gli utenti finali relativamente alla lingua utilizzata per i')
||'l rendering dell''applicazione di runtime.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830245446307265)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'it'
,p_message_text=>'Selettore lingue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480887608307775)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'it'
,p_message_text=>'Cognome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698152997307147)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'it'
,p_message_text=>'Durata ultima esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698295730307147)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'it'
,p_message_text=>'Ultima data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510695646307801)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0 pi\00F9 recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506535069307797)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501933688307794)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'it'
,p_message_text=>'Carica progetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700545950307149)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'it'
,p_message_text=>'Data log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700675110307149)
,p_name=>'CA.LOG.ID'
,p_message_language=>'it'
,p_message_text=>'ID log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694715118307144)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'it'
,p_message_text=>'Livello di log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377928222307689)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'it'
,p_message_text=>'Messaggi di log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468115182306933)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
' <li><strong>Colonne di ricerca</strong>: espandere per visualizzare gli attributi per la definizione di una ricerca in un''altra tabella. Utilizzare le colonne di ricerca per sostituire gli identificativi con una colonna di visualizzazione, ad esempi'
||unistr('o per mostrare il nome anzich\00E9 il numero del reparto.<br>'),
unistr('<em><strong>Nota:</strong> Colonne di ricerca sar\00E0 visibile solo se la pagina corrente si basa su una tabella o una vista e dispone di vincoli FOREIGN KEY su un''altra tabella.'),
'  <ul>',
unistr('    <li><strong>Chiave di ricerca</strong>: selezionare la colonna che verr\00E0 modificata per restituire la colonna di visualizzazione.</li>'),
'    <li><strong>Colonna di visualizzazione</strong>: selezionare la colonna da visualizzare dalla tabella di ricerca.</li>',
'    &nbsp;<br>',
'    <em><strong>Nota:</strong> selezionare solo le colonne che contengono un riferimento a un''altra colonna (mediante una chiave esterna).</em></li>',
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484816581307778)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Gestisci modelli di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482854103307777)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Gestisci feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478973961307774)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'it'
,p_message_text=>'Gestisci accesso utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511254284307801)
,p_name=>'CA.MASTER'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina Master-Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511399374307801)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di creare una pagina che visualizza una pagina Master-Detail per permettere agli utenti finali di visualizzare e gestire i dati.<br>',
'&nbsp;</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong> (obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  <li><strong>Tipo pagina</strong>: selezionare il tipo di pagina [Affiancate, In pila].<br>',
'    <strong>Affiancate</strong>: <br>',
'<em>Master-Detail a pagina singola che utilizza aree di layout e report affiancate con finestre di modifica modali.</em>',
'    <ul>',
'      <li><strong>Tabella</strong> (obbligatorio): selezionare la tabella master per la pagina.</li>',
'      <li><strong>Colonna di visualizzazione primaria</strong> (obbligatorio): selezionare la colonna da visualizzare nella lista dei record master.</li>',
'      <li><strong>Colonna di visualizzazione secondaria</strong> (obbligatorio): selezionare la colonna descrittiva da visualizzare nella lista dei record master sotto la colonna di visualizzazione primaria.</li>',
'      <li><strong>Tabella detail 1</strong> (obbligatorio): selezionare la prima tabella detail per la pagina.</li>',
'      <li><strong>Tabella detail 2</strong>: selezionare la seconda tabella detail per la pagina.</li>',
'      <li><strong>Tabella detail 3</strong>: selezionare la terza tabella detail per la pagina.</li>',
'      <li><strong>Tabella detail 4</strong>: selezionare la quarta tabella detail per la pagina.</li>',
'    </ul>',
'   <strong>In pila</strong>: <br>',
'<em>Master-Detail a pagina singola che utilizza griglie interattive modificabili.</em>',
'    <ul>',
'      <li><strong>Tabella</strong> (obbligatorio): selezionare la tabella master per la griglia interattiva modificabile.</li>',
'      <li><strong>Tabella detail</strong> (obbligatorio): selezionare la tabella detail per la pagina.</li>',
unistr('      <em><strong>Nota:</strong> quando si utilizza questa procedura guidata \00E8 possibile aggiungere una sola tabella detail (griglia interattiva modificabile). Ulteriori tabelle detail possono essere aggiunte con facilit\00E0 dopo la generazione della pa')
||'gina.</em>',
'    </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830109800307265)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'it'
,p_message_text=>'Record principali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475138624307771)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo massimo trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695275027307144)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'it'
,p_message_text=>'Numero massimo di errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694867751307144)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'it'
,p_message_text=>'Durata massima esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695322516307144)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'it'
,p_message_text=>'Numero massimo di esecuzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505555801307796)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'it'
,p_message_text=>'Numero massimo di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508584191307799)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'it'
,p_message_text=>'Larghezza massima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499154370307789)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'it'
,p_message_text=>'Aggiungi filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499593848307789)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'it'
,p_message_text=>'Aggiungi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499066640307789)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'it'
,p_message_text=>'Applica filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499928814307790)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500080355307790)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'it'
,p_message_text=>'Valore data 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499298457307789)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498630496307789)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498528407307789)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'it'
,p_message_text=>'Filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499659168307789)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'it'
,p_message_text=>'Nessun filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498922133307789)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'it'
,p_message_text=>'Nessun record selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498835001307789)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessun record trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499484738307789)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'it'
,p_message_text=>'Eliminazione di %0 completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499377664307789)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento di %0 completato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498715083307789)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499774348307789)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103499879198307790)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'it'
,p_message_text=>'Valore 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474617715307770)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo mediano trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483730542307777)
,p_name=>'CA.MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377706910307689)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di messaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508027427307799)
,p_name=>'CA.METRIC'
,p_message_language=>'it'
,p_message_text=>'Metrica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475513039307771)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo minimo trascorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478368117307773)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'it'
,p_message_text=>'Telefono cellulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474105528307770)
,p_name=>'CA.MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487953284307780)
,p_name=>'CA.MORE'
,p_message_language=>'it'
,p_message_text=>'Altro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477536053307772)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'it'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510411097307800)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'it'
,p_message_text=>unistr('Pagine pi\00F9 attive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468273677306933)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'it'
,p_message_text=>unistr('Pi\00F9 report')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468374444306933)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare uno o pi\00F9 nomi di tabella o di vista. In alternativa, fare clic sulla casella di controllo nell''intestazione per selezionare o deselezionare tutti gli oggetti di database elencati.</p>'),
unistr('<p>Verr\00E0 aggiunta una pagina con un report interattivo per ogni oggetto di database selezionato.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471542547307768)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# deve essere un indicatore orario valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507842105307798)
,p_name=>'CA.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463077807307759)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463199811307759)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'it'
,p_message_text=>'<p>Scegliere se il menu deve essere visualizzato sul lato o nella parte superiore dell''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514514520307804)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'it'
,p_message_text=>'Negativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514460480307804)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'it'
,p_message_text=>'Neutra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500572157307792)
,p_name=>'CA.NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695046548307144)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'it'
,p_message_text=>'Data esecuzione successiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693928232307143)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'it'
,p_message_text=>'Ambiente NLS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782978832307226)
,p_name=>'CA.NO'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482413390307776)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103494060876307785)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Guida non disponibile per questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467012556306932)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'it'
,p_message_text=>'Non esistono utenti validi - Informazioni pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501542461307793)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessun nuovo utente valido trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497658506307788)
,p_name=>'CA.NONE'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478653114307773)
,p_name=>'CA.NOTE'
,p_message_language=>'it'
,p_message_text=>'Nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454170551307751)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Notifiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452982967307751)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'it'
,p_message_text=>'Visualizza le notifiche nella home page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454223116307752)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consente agli amministratori dell''applicazione di specificare gli avvisi (in giallo) o gli errori (in rosso) visualizzati a tutti gli utenti finali nella home page dell''applicazione. Questa funzione \00E8 utile per trasmettere informazioni importanti ')
||'alla community di utenti finali.</p>',
'<p>Include i seguenti componenti:<ul>',
unistr('<li>Possibilit\00E0 di definire le notifiche</li>'),
'<li>Visualizzazione della notifica nella home page dell''applicazione</li>',
unistr('<li>Possibilit\00E0 di controllare l''intervallo di tempo di visualizzazione della notifica</li>'),
'<li>Supporto della codifica colore delle notifiche in base al tipo</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470860941307767)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474328988307770)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'it'
,p_message_text=>'Numero di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697140681307146)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'it'
,p_message_text=>'Numero di argomenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693786361307143)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'it'
,p_message_text=>'Numero di destinazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506004605307797)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione numero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475833379307771)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'it'
,p_message_text=>'Ricorrenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514710005307804)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire questa azione a meno che non vi sia un altro amministratore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482660619307776)
,p_name=>'CA.OPEN'
,p_message_language=>'it'
,p_message_text=>'Aperto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455659958307753)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'it'
,p_message_text=>'Organizzazione delle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455954818307753)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Disporre le pagine nell''ordine con cui si desidera vengano visualizzate nell''applicazione. <br>',
'Per riordinare le pagine nella lista, fare clic e tenere premuta l''icona <em>Menu</em> ( <span class="fa fa-bars" aria-hidden="true"></span> ) alla fine di ogni lista di pagine, quindi trascinare la pagina verso l''alto o verso il basso.</p>',
unistr('<p>La home page viene sempre visualizzata per prima e non pu\00F2 essere riordinata.<br>'),
unistr('Le pagine di amministrazione vengono sempre visualizzate alla fine della lista e l''ordine in cui sono visualizzate determiner\00E0 quello in cui appariranno nella lista Amministrazione applicazione della pagina Amministrazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699209405307148)
,p_name=>'CA.OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Output'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700475757307149)
,p_name=>'CA.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474051653307770)
,p_name=>'CA.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477232671307772)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'it'
,p_message_text=>'Eventi di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489741845307782)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Guida sulla pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476311135307771)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831985310307267)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'it'
,p_message_text=>'Modifica record principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832195719307267)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Esegue la ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473663915307769)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489084267307781)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione delle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475732777307771)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'it'
,p_message_text=>'Prestazioni della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500634230307792)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di pagina "%0" non \00E8 valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475037335307770)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456135899307753)
,p_name=>'CA.PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103456229650307753)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consente di definire la pagina o le pagine da includere nell''applicazione iniziale. \00C8 necessario definire almeno una pagina prima di poter creare l''applicazione.</p>'),
unistr('<p>\00C8 possibile eseguire lo stub dell''applicazione creando qualsiasi numero di pagine utilizzando questa procedura guidata. Dopo aver creato l''applicazione, usare la Creazione guidata della pagina per aggiungere altre pagine.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505903390307797)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'it'
,p_message_text=>'Metodo di impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475386437307771)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni di pagina parziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481116109307775)
,p_name=>'CA.PHOTO'
,p_message_language=>'it'
,p_message_text=>'Foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481778015307776)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'it'
,p_message_text=>'Foto eliminata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481279242307775)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480932097307775)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'it'
,p_message_text=>'Caricamento foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377845444307689)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore chiave primaria '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485792877307779)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di testo non codificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514349448307804)
,p_name=>'CA.POSITIVE'
,p_message_language=>'it'
,p_message_text=>'Positiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468554527307763)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'it'
,p_message_text=>'Preferenze'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511958778307802)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506677038307797)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna di visualizzazione primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507566843307798)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507648236307798)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella padre primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475993210307771)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'it'
,p_message_text=>'Procedura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469166143307764)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Preferenza di posta elettronica aggiornata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102831709406307266)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'it'
,p_message_text=>'Recupera riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378013452307689)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Recupera dettagli log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470342871307767)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni aspetto dell''applicazione salvate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469066738307763)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Preferenza fuso orario aggiornata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481599785307776)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'Download della foto del profilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697404985307146)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome programma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697567060307146)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario programma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210446939306730)
,p_name=>'CA.PWA'
,p_message_language=>'it'
,p_message_text=>'Installa applicazione Web progressiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210300686306729)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'it'
,p_message_text=>'Consente all''applicazione di essere installata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210546164306730)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Le applicazioni Web progressive sono applicazioni Web progettata per essere funzionali, affidabili e installabili. Un''applicazione Web progressiva funziona come un''applicazione specifica della piattaforma.</p>',
'<p>L''abilitazione di questa opzione consente di:</p>',
'<ul>',
'<li>aggiungere la nuova voce Installa applicazione nella barra di navigazione;</li>',
'<li>Consentire agli utenti di installare questa applicazione APEX sui dispositivi.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206428553306727)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'it'
,p_message_text=>'Installa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506961177307798)
,p_name=>'CA.QUERY'
,p_message_language=>'it'
,p_message_text=>'Query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694287493307143)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'it'
,p_message_text=>'Richiama eventi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335939920306828)
,p_name=>'CA.RATING'
,p_message_language=>'it'
,p_message_text=>'Valutazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479438844307774)
,p_name=>'CA.READERS'
,p_message_language=>'it'
,p_message_text=>'Lettori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468895879307763)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'it'
,p_message_text=>'Ricevi messaggi di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510517612307801)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'it'
,p_message_text=>'Errori recenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146626543307505)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146779293307505)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471039902307767)
,p_name=>'CA.RED'
,p_message_language=>'it'
,p_message_text=>'Rosso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484609024307778)
,p_name=>'CA.REFERENCED'
,p_message_language=>'it'
,p_message_text=>'Di riferimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830896392307266)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'it'
,p_message_text=>'Aggiorna pagina di amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448129111306917)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Aggiorna alla chiusura della finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102832060495307267)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'it'
,p_message_text=>'Aggiorna report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470526265307767)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Area pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470402869307767)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'it'
,p_message_text=>'Area elementi form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476456032307772)
,p_name=>'CA.REGION.ID'
,p_message_language=>'it'
,p_message_text=>'ID area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488419162307781)
,p_name=>'CA.RELEASE'
,p_message_language=>'it'
,p_message_text=>'Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455773437307753)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'it'
,p_message_text=>'Rimozione delle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455810761307753)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic su <strong>Modifica</strong> per selezionare la pagina, quindi fare clic su <strong>Elimina pagina</strong> per rimuovere una pagina dall''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698849805307147)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'it'
,p_message_text=>'Intervallo ripetizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570744433307024)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'it'
,p_message_text=>'Rispondi a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461591665307757)
,p_name=>'CA.REPORT'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103461420542307757)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di creare una pagina che visualizza un report interattivo o un report classico.</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong>: immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  <li><strong>Tipo di query</strong>: selezionare l''origine per il report [<strong>Tabella o vista</strong> o <strong>Query SQL</strong>]:<br>',
'    <strong>Tabella o vista</strong>:',
'    <ul>',
'      <li>Tabella o vista (obbligatorio): selezionare l''oggetto di database per il report.</li>',
'      <li>Includi form: selezionare per includere una pagina di form collegata per consentire agli utenti di gestire i valori delle tabelle.</li>',
'    </ul>',
'    <strong>Query SQL</strong>:',
'    <ul>',
'      <li>Query SQL (obbligatorio): immettere un''istruzione SQL valida che restituisca colonne distinte.</li>',
'    </ul>',
'  </li>',
'  <li><strong>Tipo di report</strong>: selezionare il tipo di report (<strong>Report interattivo</strong> o <strong>Report classico</strong>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103453276909307751)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'it'
,p_message_text=>'%0 con form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335808859307658)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'it'
,p_message_text=>'Report %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509657710307800)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508216506307799)
,p_name=>'CA.REPORTS'
,p_message_language=>'it'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700244079307149)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'it'
,p_message_text=>'Data di inizio richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508410187307799)
,p_name=>'CA.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Richiesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486579900307779)
,p_name=>'CA.RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482565261307776)
,p_name=>'CA.RESOLVED'
,p_message_language=>'it'
,p_message_text=>'Risolto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482218290307776)
,p_name=>'CA.RESPONSE'
,p_message_language=>'it'
,p_message_text=>'Risposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695518110307144)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'it'
,p_message_text=>'Riavvia in caso di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695650080307144)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'it'
,p_message_text=>'Riavvia in caso di recupero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692897826307142)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'it'
,p_message_text=>'Riavviabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102695176386307144)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio nuovi tentativi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503433952307795)
,p_name=>'CA.ROLE'
,p_message_language=>'it'
,p_message_text=>'Ruolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476619073307772)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'it'
,p_message_text=>'Numero riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103485928090307779)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502885808307794)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'it'
,p_message_text=>'HTML modello riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504133625307795)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'it'
,p_message_text=>'Contenuto righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477302370307772)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'it'
,p_message_text=>'Righe recuperate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505888326307797)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'it'
,p_message_text=>'Righe per pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698477329307147)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio esecuzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700075408307148)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'it'
,p_message_text=>'Durata esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694968332307144)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'it'
,p_message_text=>'Limite pianificazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696988805307146)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome pianificazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102697075100307146)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario pianificazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696818308307146)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di pianificazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464089832307759)
,p_name=>'CA.SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464142105307760)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'it'
,p_message_text=>'<p>Selezionare lo schema di database che memorizza gli oggetti di database da usare in questa applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504952562307796)
,p_name=>'CA.SCOPE'
,p_message_language=>'it'
,p_message_text=>'Ambito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486695767307779)
,p_name=>'CA.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486702265307780)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486851173307780)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103509890224307800)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'it'
,p_message_text=>'Filtri di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493583599307785)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Questa pagina si basa sulla lista di componenti condivisi denominata Tabelle in cui eseguire le ricerche.',
'',
'Eventuali pagine del report interattivo generate inizialmente dalla creazione guidata dell''applicazione verranno aggiunte automaticamente alla lista. ',
'Per aggiungere tabelle personali alla lista, passare a Componenti condivisi, selezionare Liste, quindi fare clic su Tabelle in cui eseguire le ricerche.',
'  Immettere i seguenti attributi:',
'    Voce: Etichetta voce di lista: immettere il nome visualizzato della tabella.',
'    Destinazione: Pagina: selezionare la pagina appropriata in cui spostarsi (preferibilmente un report interattivo)',
'    Destinazione: Svuota cache: immettere le eventuali pagine da cancellare (in genere lo stesso numero di pagine immesse in Pagina).',
unistr('       Se ci si sposta in una pagina di report interattivo, aggiungere CIR,RIR per cancellare eventuali filtri esistenti e cos\00EC via.'),
'    Destinazione: Imposta questi elementi: selezionare (o immettere) la pagina appropriata in cui inserire i dati.',
'       Se ci si sposta in una pagina di report interattivo, immettere IR_[COLUMN_NAME].',
'    Destinazione: Con questi valori: immettere =PK=',
'    Attributi definiti dall''utente: 1: immettere il nome della tabella in cui effettuare la ricerca in lettere maiuscole.',
'    Attributi definiti dall''utente: 2: immettere il nome della colonna primaria in lettere maiuscole.',
'    Attributi definiti dall''utente: 3 (facoltativo): lista separata da virgole di colonne in cui effettuare la ricerca.',
unistr('       Se non \00E8 specificata alcuna colonna, la ricerca viene effettuata in tutte le colonne di testo (varchar2) e clob (character large object).'),
'',
unistr('Nota: viene visualizzata una lista di tabelle disponibili in cui effettuare la ricerca solo se sono elencate pi\00F9 tabelle.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486302135307779)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'it'
,p_message_text=>'Risultati ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507495070307798)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna di visualizzazione secondaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103482944240307777)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570023419307023)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'it'
,p_message_text=>'Inizio invio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570412921307024)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio invii'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569990090307023)
,p_name=>'CA.SEND.END'
,p_message_language=>'it'
,p_message_text=>'Fine invio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570355220307024)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di invio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513421151307803)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'it'
,p_message_text=>'Invia messaggi di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103513523363307803)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Determina se \00E8 necessario inviare messaggi di posta elettronica alla ricezione di un nuovo feedback.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510159649307800)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'it'
,p_message_text=>'Invia da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502655582307794)
,p_name=>'CA.SEND.TO'
,p_message_language=>'it'
,p_message_text=>'Invia a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488262702307781)
,p_name=>'CA.SERIES'
,p_message_language=>'it'
,p_message_text=>'Serie %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699937236307148)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'it'
,p_message_text=>'ID sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505138267307796)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'it'
,p_message_text=>'Protezione stato sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463436786307759)
,p_name=>'CA.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103463562607307759)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'it'
,p_message_text=>'<p>Specificare le impostazioni utilizzate nella generazione dell''applicazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487824943307780)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'it'
,p_message_text=>'Mostra tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447667866306916)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'it'
,p_message_text=>'Mostra/nascondi ambito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488967594307781)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'it'
,p_message_text=>'Mostra fuso orario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103488754211307781)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'it'
,p_message_text=>'Collega'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489910976307782)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'it'
,p_message_text=>'Scollega'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699878191307148)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'it'
,p_message_text=>'PID slave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693869835307143)
,p_name=>'CA.SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500705907307792)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di origine non \00E8 valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103493610852307785)
,p_name=>'CA.SOURCES'
,p_message_language=>'it'
,p_message_text=>'Origini'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696764731307145)
,p_name=>'CA.START.DATE'
,p_message_language=>'it'
,p_message_text=>'Data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377241163307689)
,p_name=>'CA.STARTED'
,p_message_language=>'it'
,p_message_text=>'Avviato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102698580284307147)
,p_name=>'CA.STATE'
,p_message_language=>'it'
,p_message_text=>'Stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508303199307799)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'it'
,p_message_text=>'Valore statico predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472657017307769)
,p_name=>'CA.STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694554300307143)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Arresta alla chiusura della finestra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694669996307143)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Memorizza output'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483110452307777)
,p_name=>'CA.SUBJECT'
,p_message_language=>'it'
,p_message_text=>'Oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481889762307776)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Sottometti feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103377415507307689)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe riuscite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103505461912307796)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione consigliata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497367948307788)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti di supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497407570307788)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere il codice nello script di installazione, in genere per creare o manipolare gli oggetti di database oppure per eseguire operazioni di inserimento/aggiornamento/eliminazione nei record esistenti. Immettere il codice nello script di disinst'
||'allazione, in genere per rimuovere (eliminare) gli oggetti di database. Questi script verranno incorporati negli oggetti di supporto in modo che, quando si esporta l''applicazione, questi stessi aggiornamenti vengano eseguiti negli ambienti di prova e'
||' di produzione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497586631307788)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere istruzioni SQL e/o PL/SQL valide nello script di installazione eseguito quando l''applicazione viene importata.</p>',
'<p>Se si desidera che queste istruzioni vengano eseguite anche nell''ambiente corrente e non solo quando l''applicazione viene importata in un altro ambiente, fare clic su <strong>Esegui durante la creazione dell''applicazione</strong>.</p>',
'<p>Immettere istruzioni SQL e/o PL/SQL valide nello script di disinstallazione eseguito quando l''applicazione viene eliminata da App Builder.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694127120307143)
,p_name=>'CA.SYSTEM'
,p_message_language=>'it'
,p_message_text=>'Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103506817585307798)
,p_name=>'CA.TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464251858307760)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'it'
,p_message_text=>'Prefisso oggetti framework'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103464345718307760)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il prefisso di un oggetto che dovr\00E0 essere usato dall''applicazione. Alcune funzioni aggiungono questo prefisso agli oggetti di database creati (inclusi package e tabelle).</p>'),
unistr('<p>Avvertenza: verificare di immettere un prefisso univoco non utilizzato da altre applicazioni. Se il prefisso non \00E8 univoco, l''applicazione potrebbe restituire errori durante la creazione e non funzionare in modo corretto.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103507773672307798)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502751367307794)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103486258834307779)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome modello \00E8 gi\00E0 in uso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483020544307777)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471756013307768)
,p_name=>'CA.TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570230675307024)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione corpo testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103484280939307778)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103469905002307764)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'it'
,p_message_text=>'Preferenza tema utente finale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470108327307764)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Se l''opzione viene selezionata, gli utenti finali possono scegliere uno stile tema personale utilizzando il collegamento Personalizza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470034107307764)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'it'
,p_message_text=>'Consenti agli utenti finali di scegliere lo stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454314074307752)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'it'
,p_message_text=>'Selezione stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452722179307750)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'it'
,p_message_text=>'Aggiorna l''aspetto predefinito dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103454417532307752)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente agli amministratori di selezionare una combinazione di colori predefinita (stile tema) per l''applicazione. Inoltre, gli amministratori possono decidere di autorizzare gli utenti finali a scegliere uno stile di tema personalizzato. Gli ute'
||unistr('nti finali possono semplicemente fare clic sul pulsante <em>Personalizza</em> in fondo alla home page ed effettuare una selezione tra gli stili di tema disponibili. Ad esempio, gli utenti con capacit\00E0 visive ridotte potrebbero preferire l''uso dello s')
||unistr('tile di tema <em>Vista</em> che prevede un contrasto di colori molto pi\00F9 elevato.</p>'),
'<p>Include i seguenti componenti:',
'<ul>',
unistr('<li>Possibilit\00E0 per gli amministratori di definire lo stile di tema predefinito</li>'),
unistr('<li>Possibilit\00E0 per gli utenti finali di selezionare vari stili di tema</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462877687307758)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'it'
,p_message_text=>'Stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103462982708307759)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare lo stile tema predefinito usato per visualizzare l''applicazione.</p>',
unistr('<p>Lo stile pu\00F2 essere immediatamente modificato in un altro stile predefinito o modificato dopo la generazione. Per modificare lo stile, eseguire l''applicazione, quindi fare clic su <strong>Theme Roller</strong> nella barra degli strumenti sviluppat')
||'ore.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476946386307772)
,p_name=>'CA.TIME'
,p_message_language=>'it'
,p_message_text=>'Ora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103468631704307763)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'it'
,p_message_text=>'Fuso orario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455413733307753)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'it'
,p_message_text=>'Supporto fuso orario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452366605307750)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'it'
,p_message_text=>'Imposta fusi orari predefiniti e definiti dall''utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455159421307752)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consente agli utenti finali di impostare il proprio fuso orario. Questa funzione \00E8 importante se le tabelle dell''applicazione usano tipi di dati basati sul fuso orario (ad esempio un indicatore orario con fuso orario locale) in modo che i report e')
||unistr(' le immissioni di dati rispecchino la localit\00E0 in cui si trovano gli utenti finali.</p>'),
'<p>Include i seguenti componenti:',
'<ul>',
unistr('<li>Possibilit\00E0 per gli amministratori di impostare il fuso orario predefinito</li>'),
unistr('<li>Possibilit\00E0 per gli utenti finali di selezionare la preferenza di fuso orario</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103510722827307801)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'it'
,p_message_text=>'Intervallo di tempo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511073703307801)
,p_name=>'CA.TIMELINE'
,p_message_language=>'it'
,p_message_text=>'Aggiungi pagina controllo temporale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103511126420307801)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di creare una pagina che visualizza un controllo temporale, particolarmente utile per la visualizzazione degli aggiornamenti.</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome pagina</strong>(obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
'  <li><strong>Tabella o vista</strong> (obbligatorio): selezionare l''oggetto di database per il controllo temporale.</li>',
'  <li><strong>Nome utente</strong> (obbligatorio): selezionare la colonna della tabella o della vista da utilizzare per specificare l''utente visualizzato per le immissioni del controllo temporale.</li>',
'  <li><strong>Data</strong> (obbligatorio): selezionare la colonna della tabella o della vista da utilizzare per specificare la data per le immissioni del controllo temporale.</li>',
'  <li><strong>Nome evento</strong> (obbligatorio): selezionare la colonna della tabella o della vista da utilizzare per specificare il titolo per le immissioni del controllo temporale.</li>',
'  <li><strong>Descrizione</strong>: selezionare la colonna della tabella o della vista da utilizzare per specificare la descrizione per le immissioni del controllo temporale.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473820914307769)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'it'
,p_message_text=>'Indicatore orario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478466608307773)
,p_name=>'CA.TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102570890876307024)
,p_name=>'CA.TO'
,p_message_language=>'it'
,p_message_text=>'A'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477689120307773)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'it'
,p_message_text=>'Primi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477718678307773)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico Primi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103475228969307771)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479631882307774)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'it'
,p_message_text=>'Ruolo predefinito per gli utenti che non fanno parte della lista di controllo dell''accesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103471896526307768)
,p_name=>'CA.TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782318120307225)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Valori predefiniti interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782402122307225)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'it'
,p_message_text=>'Consente di definire i valori predefiniti per le impostazioni dell''interfaccia utente, quali le righe per pagina, e di aggiungere le definizioni delle liste di valori. Queste impostazioni vengono utilizzate durante la generazione dei componenti nell'''
||'applicazione. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472031901307768)
,p_name=>'CA.UNTIL'
,p_message_language=>'it'
,p_message_text=>'Fino a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830607268307265)
,p_name=>'CA.UPDATE'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103481468172307775)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'it'
,p_message_text=>'Aggiorna profilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472302992307768)
,p_name=>'CA.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Aggiornato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103472469869307768)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'it'
,p_message_text=>'Autore aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103473763657307769)
,p_name=>'CA.USER'
,p_message_language=>'it'
,p_message_text=>'Utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500219023307792)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiungi pi\00F9 utenti - Passo 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500311108307792)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiungi pi\00F9 utenti - Passo 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500432495307792)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiungi pi\00F9 utenti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103476100642307771)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'it'
,p_message_text=>'User Agent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489502804307782)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'it'
,p_message_text=>'Report conteggi utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477967645307773)
,p_name=>'CA.USER.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480493526307775)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'it'
,p_message_text=>'Profilo utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455369548307753)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'it'
,p_message_text=>'Profili utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452268717307750)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'it'
,p_message_text=>'Consente agli utenti di aggiornare il proprio profilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103455280002307752)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente agli utenti finali di immettere informazioni aggiuntive su se stessi, inclusa un''immagine o un avatar, per personalizzare il proprio account.</p>',
'<p>Include i seguenti componenti:',
'<ul>',
'<li>Impostazione della pagina da parte degli utenti finali per impostare il proprio profilo</li>',
unistr('<li>Possibilit\00E0 di caricare una foto o un avatar</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480680286307775)
,p_name=>'CA.USERNAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479767733307774)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501112556307793)
,p_name=>'CA.USERNAMES'
,p_message_language=>'it'
,p_message_text=>'Nomi utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789839950307232)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501746151307793)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'it'
,p_message_text=>'Utente/i aggiunto/i.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503231365307795)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'it'
,p_message_text=>'Utenti per ruolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103483840689307777)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'it'
,p_message_text=>'Utenti inclusi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103501407788307793)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'it'
,p_message_text=>'Utenti da aggiungere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103479944186307774)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Formato nome utente aggiornato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466868115306932)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'it'
,p_message_text=>'Esistono utenti validi - Informazioni pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495566132307786)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID applicazione esiste gi\00E0 oppure \00E8 riservato per un''altra applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737147564307183)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Nome applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503818998307795)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario specificare gli indirizzi di posta elettronica a cui inviare il messaggio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503642655307795)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario specificare gli indirizzi di posta elettronica o selezionare un gruppo di utenti a cui inviare il messaggio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103503788191307795)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario specificare gli indirizzi di posta elettronica o selezionare un gruppo di utenti a cui inviare il messaggio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495642025307786)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'it'
,p_message_text=>'Il prefisso della tabella non deve superare i sei caratteri, deve iniziare con una lettera e contenere solo lettere, numeri e caratteri di sottolineatura.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495756407307786)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un prefisso di tabella diverso. I seguenti oggetti di database esistono gi\00E0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480375019307775)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'it'
,p_message_text=>'Nome utente in un formato di indirizzo di posta elettronica non valido. Notare il formato del nome utente dell''applicazione riportato di seguito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103480282626307775)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'it'
,p_message_text=>'Verifica formato di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103477812972307773)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'it'
,p_message_text=>'Visualizza come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103498117741307788)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'it'
,p_message_text=>'Visualizza progetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103487784250307780)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'it'
,p_message_text=>'Visualizza dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103504095299307795)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'it'
,p_message_text=>'Visualizza posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103489865604307782)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'it'
,p_message_text=>'Visualizza profilo personale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103474734100307770)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'it'
,p_message_text=>'Prestazioni ponderate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103508641080307799)
,p_name=>'CA.WIDTH'
,p_message_language=>'it'
,p_message_text=>'Larghezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512884443307803)
,p_name=>'CA.WIZARD'
,p_message_language=>'it'
,p_message_text=>'Crea pagine procedura guidata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466713941306932)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'it'
,p_message_text=>'Contenitore procedura guidata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103512921701307803)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di creare una raccolta di pagine da utilizzare come procedura guidata. In genere le procedure guidate vengono utilizzate per l''immissione dei dati in vari passi successivi.</p>',
'<p>Immettere gli attributi riportati di seguito.</p>',
'<ul>',
'  <li><strong>Nome procedura guidata</strong> (obbligatorio): immettere un nome per questa pagina.</li>',
'  <li><strong>Imposta icona</strong>: selezionare l''icona da visualizzare nel menu di navigazione di questa pagina.</li>',
unistr('  <li><strong>Modalit\00E0 pagina</strong> (obbligatorio): specificare se i passi della procedura guidata verranno visualizzati come pagine di tipo modale o normale. Selezionare <strong>Pagina modale</strong> o <strong>Pagina intera</strong>.</li>'),
'  <li><strong>Passo 1 ... 8</strong>: immettere il nome pagina per i passi della procedura guidata.<br><em><strong>Nota:</strong> i passi da 5 a 8 vengono visualizzati quando si immette un nome per ogni passo precedente.</em></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103478218444307773)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'it'
,p_message_text=>'Telefono ufficio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103470929450307767)
,p_name=>'CA.YELLOW'
,p_message_language=>'it'
,p_message_text=>'Giallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782851924307226)
,p_name=>'CA.YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335839268306827)
,p_name=>'CACHED'
,p_message_language=>'it'
,p_message_text=>'Inserito nella cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239008122306751)
,p_name=>'CACHE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Cache creata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226616659306742)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'it'
,p_message_text=>unistr('La funzionalit\00E0 di eliminazione di dati \00E8 disabilitata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211669393306730)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'it'
,p_message_text=>unistr('La funzionalit\00E0 di aggiunta di dati \00E8 disabilitata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211759339306730)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'it'
,p_message_text=>unistr('La funzionalit\00E0 di aggiornamento di dati \00E8 disabilitata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364560267306850)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364499054306850)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250860541306760)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'it'
,p_message_text=>'Calendario semplice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268707170307607)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Modifica voce di calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200161656306722)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'it'
,p_message_text=>'Popup calendario per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331528503306821)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del calendario completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721103292307168)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di calendario precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250734338306760)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'it'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584170227307036)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessun modello di calendario trovato durante il tentativo di copia dall''applicazione %0 e dall''ID modello %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722551183307169)
,p_name=>'CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206634756306727)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954582000307360)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'it'
,p_message_text=>'CSS'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801933575307243)
,p_name=>'CHANGES'
,p_message_language=>'it'
,p_message_text=>'Modifiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379081049307690)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'it'
,p_message_text=>'Modifica autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717876078307165)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'it'
,p_message_text=>'Modifica dimensione database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717612839307165)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'it'
,p_message_text=>'Richiesta di modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931319519307343)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Modifica area di lavoro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691178111307140)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna set di caratteri'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412775490306888)
,p_name=>'CHART'
,p_message_language=>'it'
,p_message_text=>'grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195475736306718)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Query su grafico non valida: %0<br><br>',
'Utilizzare la seguente sintassi:',
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
'<tr><td>LABEL</td><td>Testo associato alla barra</td></tr>',
'<tr><td>VALUE</td><td>Colonna numerica che definisce la dimensione della barra</td></tr>',
'</table>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360359584306847)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Query su grafico non valida.<br /><br /> Utilizzare la seguente sintassi: <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>',
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
'<td>Colonna numerica che definisce il valore di composizione.</td>',
'</tr>',
'<tr>',
'<td>MAX</td>',
'<td>Colonna numerica che definisce il valore massimo di composizione.</td>',
'</tr>',
'<tr>',
'<td>LOW (facoltativo)</td>',
'<td>Colonna numerica che definisce il valore minimo precedente di composizione.</td>',
'</tr>',
'<tr>',
'<td>HIGH (facoltativo)</td>',
'<td>Colonna numerica che definisce il valore massimo precedente di composizione.</td>',
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427102608306900)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'it'
,p_message_text=>'Tipo di grafico non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195327152306718)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Analisi della query SQL non riuscita.',
'<p>%0</p>',
unistr('Alcune query possono essere eseguite solo se l''applicazione \00E8 in esecuzione. Se la query ha una sintassi corretta, \00E8 possibile salvarla senza convalida (vedere le opzioni sotto l''origine della query).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418650789307723)
,p_name=>'CHART_DEGREES'
,p_message_language=>'it'
,p_message_text=>'gradi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668654739307119)
,p_name=>'CHART_PAGE'
,p_message_language=>'it'
,p_message_text=>'Grafico %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227193165306742)
,p_name=>'CHART_SERIES'
,p_message_language=>'it'
,p_message_text=>'Serie di grafici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714325628307162)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore della serie di grafico %0 per %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323338069306814)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del grafico completata.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672463245307123)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Checksum obbligatorio: a livello applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505588891306962)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'it'
,p_message_text=>'Checksum obbligatorio: a livello di sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505487452306962)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'it'
,p_message_text=>'Checksum obbligatorio: a livello di utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505376137306962)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Checksum obbligatorio: a livello applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419409544307724)
,p_name=>'CHECK_ALL'
,p_message_language=>'it'
,p_message_text=>'Seleziona tutto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657960436307109)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario classico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660695821307112)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report classico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359119028306846)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne report classico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658356323307109)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'it'
,p_message_text=>'Struttura classica'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656207357307107)
,p_name=>'CLEAN_UP'
,p_message_language=>'it'
,p_message_text=>'Esegui cleanup della pagina'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221921514306738)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'it'
,p_message_text=>'Cancella comando'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665571577307116)
,p_name=>'CLOSED'
,p_message_language=>'it'
,p_message_text=>'Chiuso/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711116439307159)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'it'
,p_message_text=>'Chiusi negli ultimi 7 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464267982306930)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'it'
,p_message_text=>'Chiudi finestra'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199625654307556)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 di accesso facilitato')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495857976307787)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496860979307787)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'it'
,p_message_text=>'Trova'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496705064307787)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'it'
,p_message_text=>'Completamento automatico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324406790307650)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'it'
,p_message_text=>'Indentazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496142330307787)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione indentazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496382797307787)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'it'
,p_message_text=>'La tabulazione inserisce spazi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199766879307556)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''elemento %0 non esiste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200867843307557)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'it'
,p_message_text=>'Minimappa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200743801307557)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'it'
,p_message_text=>'Solo quando > 100 linee'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103500176781307792)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'it'
,p_message_text=>'Query Builder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496995424307787)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'it'
,p_message_text=>'Ripeti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496543545307787)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496476938307787)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'it'
,p_message_text=>'Mostra numeri di riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103495960648307787)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'it'
,p_message_text=>'Mostra righello'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200680832307557)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'it'
,p_message_text=>'Mostra suggerimenti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496219625307787)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione tabulazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496013659307787)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'it'
,p_message_text=>'Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200520092307557)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'it'
,p_message_text=>'Automatico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200430785307557)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'it'
,p_message_text=>'Scuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200232631307556)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'it'
,p_message_text=>'Contrasto elevato scuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200372578307556)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'it'
,p_message_text=>'Chiaro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200170852307556)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'it'
,p_message_text=>'Trasforma maiuscole/minuscole codice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497072323307787)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'it'
,p_message_text=>'Annulla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199941925307556)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'it'
,p_message_text=>'Non attivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200038283307556)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'it'
,p_message_text=>'Attivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103496651206307787)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'it'
,p_message_text=>'Convalida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103497147712307788)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Convalida completata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199824510307556)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'it'
,p_message_text=>'Mostra spazi vuoti'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603389544307054)
,p_name=>'COLLAPSE'
,p_message_language=>'it'
,p_message_text=>'Comprimi '
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102234912803306748)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'it'
,p_message_text=>'Tavolozza colori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424307110306898)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'it'
,p_message_text=>'Analogici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423972277306897)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'it'
,p_message_text=>'Complementari'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424538172306898)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'it'
,p_message_text=>'Colori complementari'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424410283306898)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'it'
,p_message_text=>'Monotoni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424084953306897)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'it'
,p_message_text=>'Complementari spaccati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424253574306897)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'it'
,p_message_text=>'Tetrade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424175609306897)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'it'
,p_message_text=>'Triade'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412309272307718)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'it'
,p_message_text=>'Nome visualizzato: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595822725307047)
,p_name=>'COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome colonna'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784047452307227)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'it'
,p_message_text=>'Tutti gli utenti autenticati possono accedere a questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784153278307227)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'it'
,p_message_text=>'Solo gli utenti definiti nella lista di controllo dell''accesso dell''applicazione possono accedere a questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784238359307227)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'it'
,p_message_text=>'Valore di impostazione del controllo dell''accesso imprevisto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228044963306743)
,p_name=>'COMING_SOON'
,p_message_language=>'it'
,p_message_text=>'Di futura implementazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596318869307047)
,p_name=>'COMMENT'
,p_message_language=>'it'
,p_message_text=>'Commento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465360965306931)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'it'
,p_message_text=>'Compilazione non riuscita: riga <a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796572161307238)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'it'
,p_message_text=>unistr('Compilazione non riuscita: riga %0 (%2). I numeri di riga associati agli errori di compilazione sono relativi alla prima istruzione BEGIN. Ci\00F2 influenza solo la compilazione dei trigger di database.<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465293668306931)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Compilazione del codice PL/SQL completata (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662937034307114)
,p_name=>'COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Completato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669943787307120)
,p_name=>'COMPLETED'
,p_message_language=>'it'
,p_message_text=>'Completato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676872319307127)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'it'
,p_message_text=>'Completato/nessun problema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711604249307159)
,p_name=>'COMPONENT'
,p_message_language=>'it'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839762929307273)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'it'
,p_message_text=>'Nome componente: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030759186307417)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'it'
,p_message_text=>'Componente non abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326907483306817)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del componente riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410016093307717)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Riepilogo componenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275475476306779)
,p_name=>'COMPUTATIONS'
,p_message_language=>'it'
,p_message_text=>'Calcoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733816220307180)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Componenti di applicazione installati.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465843524306931)
,p_name=>'CONDITIONAL'
,p_message_language=>'it'
,p_message_text=>'Condizionale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581528545307034)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'it'
,p_message_text=>'lista di valori popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655782474307107)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'it'
,p_message_text=>'sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387322999306868)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386746398306867)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386814190306867)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'it'
,p_message_text=>'elemento/colonna=valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386910295306867)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'elemento/colonna non nullo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103200929138307557)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'it'
,p_message_text=>'elemento/colonna nullo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387466914306868)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'it'
,p_message_text=>'mai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387556430306868)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'it'
,p_message_text=>'nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387167727306867)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'it'
,p_message_text=>'pagina inclusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387207024306867)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'it'
,p_message_text=>'pagina non inclusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387094112306867)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'it'
,p_message_text=>'richiesta=e1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398442630306876)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di condizione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618708861307068)
,p_name=>'CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Conferma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187879752306712)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Master-Detail a due pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187739434306712)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Master-Detail a tre pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373287595306857)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome effettivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662761225307114)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonne Aggrega per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662883626307114)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzioni aggregate da utilizzare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370627007306855)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384108164306865)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384277409306865)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'it'
,p_message_text=>'Lingua predefinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384008073306865)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281057316306783)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'it'
,p_message_text=>'Struttura dei risultati per il report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281167025306783)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'it'
,p_message_text=>'Parametri dei risultati per il report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384314502306865)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'it'
,p_message_text=>'Autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837822548307271)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'it'
,p_message_text=>'Dirama a pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587063344307039)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne di interruzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373042648306856)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'it'
,p_message_text=>'Diramazione del pulsante %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372980828306856)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo visualizzato del pulsante %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208389871306728)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'it'
,p_message_text=>'Abilita l''aggiunta di dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208274068306728)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'it'
,p_message_text=>'Abilita trascinamento della selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786328440307229)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'it'
,p_message_text=>'Annulla diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837626643307271)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta pulsante Annulla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829767363307265)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'it'
,p_message_text=>'Con distinzione tra maiuscole e minuscole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463789606306929)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 richiesto di modificare la query di report interattivo. Se sono state rimosse colonne nella query, verranno disabilitati i filtri esistenti, le regole di evidenziazione e altre impostazioni di report che fanno riferimento alle colonne eliminate.')
||' Confermare la richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374173781306857)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'it'
,p_message_text=>'Asse del grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722901155307170)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'it'
,p_message_text=>'Quadrante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723086315307170)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'it'
,p_message_text=>'Quadrante (con riempimento)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374867211306858)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375038250306858)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'it'
,p_message_text=>'Riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374326976306858)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'it'
,p_message_text=>'Maschera dei numeri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374991391306858)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'it'
,p_message_text=>'A torta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374071168306857)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query su grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374278780306857)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'it'
,p_message_text=>'Scala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375169889306858)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'it'
,p_message_text=>'A dispersione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374684031306858)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374534333306858)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo del grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374434534306858)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102374790831306858)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281255282306783)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'it'
,p_message_text=>'Nome set di risultati temporaneo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371448919306855)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586886639307039)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'it'
,p_message_text=>'Intestazioni di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749595514307194)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786577921307229)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'it'
,p_message_text=>'Nome/i colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383732692306865)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'it'
,p_message_text=>'Utilizza ordinamento intestazioni di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507716164306964)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di copiare un''applicazione con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382327721306864)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di copiare una pagina con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371994532306856)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'it'
,p_message_text=>unistr('Un nuovo set di schede "%0" verr\00E0 creato e utilizzato da questa pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383963757306865)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un''applicazione con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376478513306859)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di calendario con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379628143306862)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di report espanso con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432575688306904)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di report interattivo con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382675428306864)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di report con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391088597307699)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un''applicazione database utilizzando lo stesso ID di un''applicazione database esistente nell''area di lavoro corrente. L''applicazione database esistente verr\00E0 eliminata e sostituita dalla nuova applicazione database. Confer')
||'mare le selezioni. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746484701307192)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare pagine Vista form e lista con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662461513307113)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di form e di report con pagine di analisi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376053500306859)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un form basato su query SQL con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375946190306859)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un form basato su stored procedure con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375857360306859)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di form su tabella con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251585573306761)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un form su una pagina di riferimento a un Web Service con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291704875306791)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un form e un report su una pagina di riferimento a un Web Service con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690008171307139)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di mappa con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102185406062306711)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare pagine Master-Detail con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377610752306860)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un''area di indicatore di percorso e un''opzione di indicatore di percorso con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668731025307119)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 di creazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375626770306859)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440016341307740)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'it'
,p_message_text=>'Crea pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440187099307740)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Crea nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378489447306861)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare pagine di form e report con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386945601307696)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382491595306864)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di report con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376101553306859)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di grafico a barre HTML con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382043670306863)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di riepilogo con i seguenti attributi. Fare clic sul pulsante "Aggiungi altro" per aggiungere ulteriori elementi da altre pagine e/o aree. Fare clic su "Fine" per creare gli elementi di riepilogo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376254836306859)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina con grafico SVG con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375558960306858)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di form tabulare con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376783141306859)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una pagina di struttura con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375714038306859)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare una procedura guidata con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390932420307699)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un''applicazione Websheet utilizzando lo stesso ID di un''applicazione Websheet esistente nell''area di lavoro corrente. L''applicazione Websheet esistente verr\00E0 eliminata e sostituita dalla nuova applicazione Websheet. Confer')
||'mare le selezioni. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583535633307036)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'it'
,p_message_text=>'Etichetta di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327611062307652)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome definizione caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398075150307704)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Questa definizione di caricamento dati verr\00E0 ricreata con le ricerche di tabella e le regole di trasformazione esistenti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829802191307265)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'it'
,p_message_text=>'Numero pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376571417306859)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668829670307119)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Schema di autenticazione predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375474105306858)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380374684306862)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonne di visualizzazione dettagli %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188227821306713)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonna/e di visualizzazione dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381900886306863)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'it'
,p_message_text=>'Colonna indicatore di percorso dei dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381170203306863)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'it'
,p_message_text=>'Ordina per tabella dettagli %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379878739306862)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina dettagli %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188157238306713)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380174782306862)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome tabella dettagli %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379936294306862)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta scheda dettagli %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786899891307230)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna di caricamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373515516306857)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749223004307194)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'it'
,p_message_text=>'Colonna di caricamento 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749346525307194)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'it'
,p_message_text=>'Colonna di caricamento 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377805299306860)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447638485307746)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Modifica pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447778924307746)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Modifica nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573457565307026)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Output CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574128741307027)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Output di stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574701127307028)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'it'
,p_message_text=>'Abilita ordinamento intestazioni di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620648322307070)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('Un''area verr\00E0 aggiunta alla pagina di amministrazione esistente:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786496493307229)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'it'
,p_message_text=>'Fine diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378998654306861)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379084715306861)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome pagina di form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379282427306861)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta scheda pagina form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379193599306861)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede pagina form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668900249307119)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'it'
,p_message_text=>'Importa componenti condivisi da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015748806307406)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Includi calendario personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188420043306713)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'it'
,p_message_text=>'Includere il report principale?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381688668306863)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'it'
,p_message_text=>'Includi un indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372755984306856)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372839567306856)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo predefinito informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251713521306761)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi di form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281418447306783)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello area form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281339657306783)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo area form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375226905306858)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Inserisci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372560378306856)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786797166307229)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna restituita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785697407307228)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'it'
,p_message_text=>'Colonna chiave di ricerca 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785765846307229)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'it'
,p_message_text=>'Colonna chiave 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785869291307229)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'it'
,p_message_text=>'Colonna chiave 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376692299306859)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749487491307194)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786673857307229)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188553335306713)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'it'
,p_message_text=>'Layout Master-Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188094005306713)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonna/e di visualizzazione principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188311468306713)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'it'
,p_message_text=>'Navigazione del record principale per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187906203306713)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586942673307039)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Numero massimo di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583385846307035)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe per pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439615135306910)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378126021306860)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'it'
,p_message_text=>'Collegamento indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381718779306863)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'it'
,p_message_text=>'Radice indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377990197306860)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378298808306861)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254225090306763)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 richiesto di aggiornare il grafico HTML a un nuovo grafico HTML5. Confermare la richiesta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406624826307714)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 richiesto di aggiornare jsTree a una nuova struttura. Confermare la richiesta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364318195306850)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Il grafico SVG verr\00E0 aggiornato con le seguenti limitazioni:  '),
'<ul>',
'<li>',
unistr('Verr\00E0 eseguita la migrazione solo dei formati numerici definiti in stringhe di formato dell''asse. I formati di data e ora verranno ignorati.'),
'</li>',
'<li>',
unistr('Verr\00E0 eseguita la migrazione degli elementi in formato numerico contenenti i seguenti caratteri:'),
'<br />',
'0,9,D,G,, (virgola),. (punto),$,C,L,FM',
'</li>',
'<li>',
unistr('L''etichetta per ciascuna serie nel grafico Flash verr\00E0 derivata dall''alias di colonna di ciascuna serie,  '),
'a differenza di quanto accadeva per i grafici SVG, in cui l''etichetta di ciascuna serie veniva derivata dall''attributo Nome serie.',
'</li>',
'<li>',
'I grafici flash a quadrante visualizzano valori effettivi invece che percentuali.',
'</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328360911306818)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 richiesto di aggiornare il grafico SVG al grafico HTML5. Confermare la richiesta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386705096307696)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384668455306865)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998065742307392)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680248020307130)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('Verr\00E0 aggiunta una nuova pagina di amministrazione. Pagina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463948782306930)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Nuove colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373309854306857)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Nuovo modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837423628307271)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta pulsante Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371858597306856)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato selezionato alcun set di schede per questa pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372402512306856)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Nessun modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251842838306761)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi di output'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373752431306857)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370754853306855)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384435691306865)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370833243306855)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371778905306855)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380253033306862)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonne di visualizzazione padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378397593306861)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381839431306863)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'it'
,p_message_text=>'Colonna indicatore di percorso padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380420094306862)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'it'
,p_message_text=>'Ordina per tabella padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379785961306862)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380067199306862)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome tabella padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372354903306856)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta scheda padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372273050306856)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463606935306929)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema di analisi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470394733306935)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento pagina parziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837575497307271)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta pulsante Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371608686306855)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'it'
,p_message_text=>'Colonna %0 chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379300206306861)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583682614307036)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato output'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587116925307039)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta collegamento di stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583786133307036)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Stampa report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373647742306857)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni dei processi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583470047307036)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372615950306856)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370904175306855)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377706775306860)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463853952306930)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne rimosse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379489775306861)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603444582307054)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'it'
,p_message_text=>'Implementazione report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378522075306861)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378601402306861)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome pagina di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378870070306861)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta scheda pagina di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378757101306861)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede pagina di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281687503306783)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello area report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281543939306783)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo area report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382757407306864)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284145540306785)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna versione di riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382926602306864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'it'
,p_message_text=>'predefinito: HTML (standard)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383222709306864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'it'
,p_message_text=>'predefinito: aspetto 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383330504306864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'it'
,p_message_text=>'predefinito: aspetto 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463480219306929)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'it'
,p_message_text=>'predefinito: aspetto 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463548759306929)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'it'
,p_message_text=>'predefinito: aspetto 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282127575306783)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'it'
,p_message_text=>'predefinito: aspetto 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383094664306864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'it'
,p_message_text=>'predefinito: report verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383418089306864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'it'
,p_message_text=>'esportazione: CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383563060306864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'it'
,p_message_text=>'esportazione: XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383117331306864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'it'
,p_message_text=>'predefinito: report verticale, aspetto 1 (includere le colonne NULL)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463226501306929)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'it'
,p_message_text=>'predefinito: report verticale, aspetto 2 (escludere le colonne NULL)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463382607306929)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'it'
,p_message_text=>'predefinito: report verticale, aspetto 2 (includere le colonne NULL)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786981817307230)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome regola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787151889307230)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787292918307230)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di regola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226833778306742)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di eseguire lo script riportato di seguito. Confermare la richiesta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102378051503306860)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382854635306864)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'it'
,p_message_text=>'Opzione di ordinamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373935238306857)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470264450306935)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618396707307068)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('Verranno create pi\00F9 pagine, iniziando dalla pagina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373885407306857)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome stored procedure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465111388306931)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario stored procedure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837706231307271)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta pulsante Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402070623307711)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'it'
,p_message_text=>'Sottoscrivi tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373131641306857)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome consigliato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662582125307113)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella/vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662670734307114)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonna Riepiloga per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848843858307279)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'it'
,p_message_text=>'Ricerche tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371345220306855)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371224646306855)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948915586307356)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'it'
,p_message_text=>'Regola di trasformazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787320159307230)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'it'
,p_message_text=>'Regole di trasformazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464178996306930)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome tabella/vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464037481306930)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario tabella/vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384521947306865)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'it'
,p_message_text=>'Schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372190104306856)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'it'
,p_message_text=>'Avvertenza: informazioni sul set di schede incomplete.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371110958306855)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta scheda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382591461306864)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome scheda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371098955306855)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383623091306865)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'modello:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377329867306860)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'it'
,p_message_text=>'Basato su un nuovo elemento della lista di valori popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377048986306860)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'it'
,p_message_text=>'Numero massimo livelli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376891642306859)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377211208306860)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377498487306860)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'it'
,p_message_text=>'Basato su una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377109421306860)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'it'
,p_message_text=>'Struttura iniziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102377554837306860)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102376933650306860)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384788305306865)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384803780306866)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'it'
,p_message_text=>'Blu e marrone chiaro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102384954708306866)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'it'
,p_message_text=>'Rosso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385031217306866)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'it'
,p_message_text=>'Blu scuro e grigio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385139714306866)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'it'
,p_message_text=>'Verde oliva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385251568306866)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'it'
,p_message_text=>'Bordeaux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385305730306866)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'it'
,p_message_text=>'Azzurro e marrone chiaro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385436903306866)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'it'
,p_message_text=>'Blu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385589035306866)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102371516340306855)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne aggiornabili'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102375372450306858)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102372014080306856)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina utilizzer\00E0 il set di schede "%0" esistente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251608221306761)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'it'
,p_message_text=>'Riferimento a Web Service, operazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102379594115306861)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'it'
,p_message_text=>'Clausola Where'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653082757307105)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'it'
,p_message_text=>'Icona di conferma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663356600307114)
,p_name=>'CONFIRMED'
,p_message_language=>'it'
,p_message_text=>'Confermato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663681027307114)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'it'
,p_message_text=>'Confermato da QA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583942193307036)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonne di interruzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583876575307036)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato di stampa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691285312307140)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'it'
,p_message_text=>'Disposizione contenuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723946505307171)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'it'
,p_message_text=>'Contenuto servito'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502147738307794)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'it'
,p_message_text=>'Collaboratori'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416732363307722)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'it'
,p_message_text=>'Nuovo ID statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463084693306929)
,p_name=>'COPY_ACTION'
,p_message_language=>'it'
,p_message_text=>'Copia azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328125281306818)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>unistr('L''applicazione \00E8 stata copiata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442473158306912)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''esecuzione di copy_button: %0 >> %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508371458306964)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'it'
,p_message_text=>'Copia attributi di definizione degli oggetti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303206129306799)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'it'
,p_message_text=>'Copia applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747293959307192)
,p_name=>'COPY_FEATURE'
,p_message_language=>'it'
,p_message_text=>'Copia funzione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507913533306964)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Copia da applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888840532307309)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Basato su modello applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508073007306964)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'it'
,p_message_text=>'Copia da nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331908700306821)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Copia voce di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442884191306913)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''esecuzione di copy_named_lov: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442719026306912)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'it'
,p_message_text=>'ID lista di valori "%0" non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442643130306912)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID della lista di valori "%0" non \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728731381307175)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'it'
,p_message_text=>'Copia da pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728875723307175)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'it'
,p_message_text=>'Copia a pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727859973307174)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>'- Seleziona autorizzazione-'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727768989307174)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'it'
,p_message_text=>'- Seleziona lista -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727672220307174)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'it'
,p_message_text=>'- Seleziona lista di valori -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792082299307234)
,p_name=>'COPY_TABLE'
,p_message_language=>'it'
,p_message_text=>'Copia %0 nella tabella %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508164031306964)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Copia in applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508296155306964)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'it'
,p_message_text=>'Copia a nome'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414800727306889)
,p_name=>'CORE'
,p_message_language=>'it'
,p_message_text=>'memoria'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857821241307286)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Crea applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857963827307286)
,p_name=>'CREATE OBJECT'
,p_message_language=>'it'
,p_message_text=>'Crea oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746945985307192)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'it'
,p_message_text=>'Creati negli ultimi 7 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303367050306799)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Da un modello applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330412814307654)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici a canne d''organo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330293345307654)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici 2D e 3D a colonne, a barre e in pila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330952465307655)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici a quadrante e quadrante (percentuale)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330318298307654)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici 2D e 3D a torta e anello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330672602307655)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici Gantt (progetto)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330827961307655)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici 2D e 3D a intervalli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330712348307655)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici Gantt (risorsa)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330523376307655)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici a indicatore dispersione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408201870306884)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'it'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408000287306884)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'it'
,p_message_text=>unistr('Freccia in gi\00F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408100660306884)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'it'
,p_message_text=>'Freccia a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407893058306884)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407927008306884)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'it'
,p_message_text=>'Condizioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408371107306884)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'it'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408414777306884)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'it'
,p_message_text=>'Anteprima condizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747666192307193)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'it'
,p_message_text=>'Fare clic sul pulsante Concedi privilegi sottostante per concedere subito questi privilegi a %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747499887307192)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non dispone del privilegio CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE o CREATE PROCEDURE, quindi non potr\00E0 installare l''applicazione demo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747581389307193)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 non dispone del privilegio di esecuzione su CTX_DOC e CTX_DDL, quindi non potr\00E0 installare la demo Discorso di insediamento del presidente. Concedere i seguenti privilegi come utente privilegiato: '),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991447562307388)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'it'
,p_message_text=>'Crea pulsante - Finestra di dialogo chiusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224279409306740)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'it'
,p_message_text=>'Crea lista dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464943668306930)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'it'
,p_message_text=>'Crea lista di valori dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202244212306723)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'it'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241351041306753)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'it'
,p_message_text=>'Account di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882594850307304)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'it'
,p_message_text=>'Autenticazione Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748014632307193)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'it'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386849166307696)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882658052307304)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'it'
,p_message_text=>'Nessuna autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882200493307304)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'it'
,p_message_text=>'Nessuna scheda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882364674307304)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'it'
,p_message_text=>'Un livello di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748131459307193)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'it'
,p_message_text=>'Single Sign On (SSO)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882408547307304)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'it'
,p_message_text=>'Due livelli di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303163025306799)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'it'
,p_message_text=>'Da un foglio di calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196834320306719)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('I componenti della pagina globale vengono visualizzati su tutte le pagine se il punto di visualizzazione della relativa area si trova all''interno del modello di pagina selezionato. Per eliminare la visualizzazione \00E8 possibile usare gli attributi di v')
||'isualizzazione condizionale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433579310306905)
,p_name=>'CREATE_INDEX'
,p_message_language=>'it'
,p_message_text=>'Crea indice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606873015307057)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'it'
,p_message_text=>'nessun''area associata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414535487306889)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'it'
,p_message_text=>'Creare una nuova pagina di login.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409939478306885)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'it'
,p_message_text=>'Torna a Creazione guidata tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409432504306885)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'it'
,p_message_text=>'Sfoglia package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409357416306885)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('Il package "%0" \00E8 stato creato nello schema "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410084852306885)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'it'
,p_message_text=>'Creazione della tabella "%0" non riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409894158306885)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'it'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409658215306885)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'it'
,p_message_text=>'Torna a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409705649306885)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'SQL&nbsp;Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409579997306885)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'it'
,p_message_text=>'Home di SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405102686306881)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessun elemento trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404745990306881)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405056904306881)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Prompt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404817882306881)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404905908306881)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'it'
,p_message_text=>'fare clic per impostare l''area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402849199306880)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402944794306880)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409282625306885)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'it'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409084609306885)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'it'
,p_message_text=>'Torna a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408936359306885)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'it'
,p_message_text=>'Esegui script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408635299306884)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('Lo script di creazione per la tabella %0 \00E8 stato creato nel repository script SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408733583306884)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'it'
,p_message_text=>'Vai a repository script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102409126439306885)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'SQL&nbsp;Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102408861167306885)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'it'
,p_message_text=>'Home di SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838474772307272)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'it'
,p_message_text=>'Form tabulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404629756307713)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'it'
,p_message_text=>unistr('Crea attivit\00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792656943307235)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'it'
,p_message_text=>'Crea trigger %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738989821307185)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Oggetti database Websheet.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102693463273307142)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario credenziale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657845824307109)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581201939307034)
,p_name=>'CURRENT'
,p_message_language=>'it'
,p_message_text=>'Corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650331619307102)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voce corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650024759307102)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'it'
,p_message_text=>'Elemento form corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424601032306898)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo Guida dell''elemento corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650170830307102)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'it'
,p_message_text=>'Numero di identificazione elemento corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650287231307102)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'it'
,p_message_text=>'Nome etichetta elemento corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705952452307154)
,p_name=>'CURRENT TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391260622306871)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398067950306876)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931547956307343)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'it'
,p_message_text=>unistr('ID che pu\00F2 essere usato su un elemento contenitore che manda a capo il campo corrente nell''attributo Prima di etichetta ed elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409306293307716)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta Guida dell''elemento corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359704241306846)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'it'
,p_message_text=>'Milestone corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397157916306875)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674685744307125)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'it'
,p_message_text=>'La pagina corrente non contiene elementi.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645911223307098)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'it'
,p_message_text=>'Personalizza collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205525789307560)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni personalizzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223128058306739)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'it'
,p_message_text=>'Sviluppatore definito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438395818306909)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore in %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359920318306846)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'it'
,p_message_text=>'Immettere una stringa da utilizzare come identificativo utente per questa sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360059959306846)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'it'
,p_message_text=>'Immettere nome utente e password %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360162984306846)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'it'
,p_message_text=>'Immettere nome utente e password per la verifica da parte dell''host LDAP: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360291159306846)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'it'
,p_message_text=>'Immettere nome utente e password dello schema di database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016040641307407)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Ricarica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021087743307410)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'it'
,p_message_text=>'Data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020947752307410)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'it'
,p_message_text=>'Data di inizio'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793510979307235)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se l''azione True \00E8 un valore impostato di tipo Istruzione SQL, \00E8 necessario definire gli elementi interessati nello stesso ordine della colonna dell''istruzione SQL. L''istruzione SQL definita \00E8 la seguente:</p>'),
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591169391307042)
,p_name=>'DATA'
,p_message_language=>'it'
,p_message_text=>'Dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857492050307285)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'Data Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446233386306915)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'it'
,p_message_text=>'Tutte le colonne %0 sono state mappate automaticamente alla tabella %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447081585306916)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'it'
,p_message_text=>'Ai dati nella tabella <code>%0</code> sono state aggiunte <b id="incompl_success_row_count"></b> righe nuove.<b class="u-danger-text" id="incompl_fail_row_count"></b> righe rifiutate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446639316306916)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Ai dati nella tabella <code>%0</code> sono state aggiunte <b id="success_row_count"></b> righe nuove.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446866434306916)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'it'
,p_message_text=>'Ai dati nella tabella <code>%0</code> sono state aggiunte <b id="err_success_row_count"></b> righe nuove. <b class="u-danger-text" id="err_fail_row_count"></b> righe rifiutate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199311542306721)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'it'
,p_message_text=>'Scegli file'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193976131306717)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Mapping colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236910495306750)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'it'
,p_message_text=>'Configurazione salvata.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198966367306721)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'it'
,p_message_text=>'Profilo dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199087168306721)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonne profilo dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198331426306720)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446371081306915)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'it'
,p_message_text=>'Definire il mapping delle colonne per caricare i dati nella tabella %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198805786306721)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'it'
,p_message_text=>'Definizione caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199263043306721)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'it'
,p_message_text=>'Trascinare i file qui oppure'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199121014306721)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'it'
,p_message_text=>'Formati supportati: csv, xlsx, txt, xml, json'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855426287307284)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'it'
,p_message_text=>'Esecuzione del job di caricamento dati arrestato in modo imprevisto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798370720307240)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'it'
,p_message_text=>'Job di caricamento dati nell''area di lavoro %0: caricamento nella tabella %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198578820306721)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'it'
,p_message_text=>'File caricato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446429919306915)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'it'
,p_message_text=>'%0 su %1 colonne sono state mappate automaticamente alla tabella %2. Configurare le restanti %3 colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836585766307270)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'it'
,p_message_text=>'Dati incollati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447126207306916)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'it'
,p_message_text=>'I dati nella tabella <code>%0</code> sono stati sostituiti con <b id="incompl_success_row_count"></b> righe nuove.<b class="u-danger-text" id="incompl_fail_row_count"></b> righe rifiutate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446774305306916)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'I dati nella tabella <code>%0</code> sono stati sostituiti con <b id="success_row_count"></b> righe nuove.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446997868306916)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'it'
,p_message_text=>'I dati nella tabella <code>%0</code> sono stati sostituiti con <b id="err_success_row_count"></b> righe nuove. <b class="u-danger-text" id="err_fail_row_count"></b> righe rifiutate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446555415306916)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'it'
,p_message_text=>'Selezionare le colonne da caricare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179412206306706)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'it'
,p_message_text=>'Formati supportati: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198414587306721)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'it'
,p_message_text=>'Carica un file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198647488306721)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'it'
,p_message_text=>'Foglio di lavoro XLSX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398785855307705)
,p_name=>'DATABASE'
,p_message_language=>'it'
,p_message_text=>'Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858017792307286)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'it'
,p_message_text=>'Database Browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343859251307664)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'it'
,p_message_text=>'Applicazione di database di esempio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398877892307705)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242801630306754)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258447862306766)
,p_name=>'DATABASE_APPS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733669221307180)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Applicazione <strong>%0</strong> installata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636384837307091)
,p_name=>'DATABASE_LINK'
,p_message_language=>'it'
,p_message_text=>'Database link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685835276307135)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'it'
,p_message_text=>'Conteggi di oggetti di database per tipo di oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689093788307138)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'it'
,p_message_text=>'Privilegi ruolo database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254154754306763)
,p_name=>'DATABASE_USERS'
,p_message_language=>'it'
,p_message_text=>'Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787894390307230)
,p_name=>'DATA_GRID'
,p_message_language=>'it'
,p_message_text=>'Griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333710151307657)
,p_name=>'DATA_GRIDS'
,p_message_language=>'it'
,p_message_text=>'Griglie dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334140143307657)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'it'
,p_message_text=>'Dati griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320684308307647)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'it'
,p_message_text=>'Impostazioni avanzate del caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333892788306826)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formati data/numero da usare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333905925306826)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere se fornire formati di visualizzazione personalizzati o usare quelli standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254576648306763)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'it'
,p_message_text=>'Set di caratteri file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847260318307278)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'it'
,p_message_text=>'Nomi di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731701453307178)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'it'
,p_message_text=>'Alias nomi colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986637238307384)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Caricamento ei dati nella tabella riuscito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992101847307388)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'it'
,p_message_text=>'Copia e incolla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981036542307380)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'it'
,p_message_text=>'Copia e incolla dati delimitati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363160387307678)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'it'
,p_message_text=>'Simbolo valuta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363208367307678)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'it'
,p_message_text=>'Se i dati contengono un simbolo di valuta internazionale, immetterlo qui. Ad esempio, se i dati contengono "&euro;1.234,56" o "&yen;1.234,56", immettere "&euro;" o "&yen;". In caso contrario, i dati non verranno caricati correttamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259208143306766)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320711360307648)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'it'
,p_message_text=>'Usa formati di visualizzazione standard applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320801681307648)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Fornisci formati personalizzati per le colonne caricate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364431065307679)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il carattere decimale separa la parte intera dalla parte decimale di un numero.</p>',
unistr('<p> Qualunque carattere pu\00F2 fungere da separatore decimale, purch\00E9 sia a byte singolo e diverso dal separatore delle migliaia. Il carattere pu\00F2 essere uno spazio, ma non un carattere numerico n\00E9 alcuno dei seguenti caratteri:</p>'),
'<ul class="noIndent">',
unistr('<li>segno pi\00F9 (+)</li>'),
'<li>trattino (-)</li> ',
'<li>segno minore di (<)</li>',
'<li>segno maggiore di (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363580762307678)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'it'
,p_message_text=>'Carattere decimale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362428844306848)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 richiesto un carattere decimale se \00E8 stato definito un separatore di gruppo per la colonna di tabella %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731916317307178)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798418799307240)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'it'
,p_message_text=>unistr('Pi\00F9 colonne di origine sono mappate alla colonna di tabella %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129848604307492)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'it'
,p_message_text=>'Riga/e non riuscite:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345269960307665)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'it'
,p_message_text=>'Record non riusciti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362792378307678)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'it'
,p_message_text=>'Nome del file da caricare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989242822307386)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'it'
,p_message_text=>'La prima riga contiene nomi di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362812705307678)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare questa casella se i dati contengono nomi di colonne nella prima riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363063748307678)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'it'
,p_message_text=>'Globalizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363491425307678)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Il separatore delle migliaia \00E8 un carattere che separa gruppi di numeri interi, per mostrare ad esempio migliaia e milioni.</p>'),
unistr('<p>Qualsiasi carattere pu\00F2 fungere da separatore delle migliaia, purch\00E9 sia a byte singolo e diverso da qualsiasi altro carattere decimale. Il carattere pu\00F2 essere uno spazio, ma non pu\00F2 essere un carattere numerico n\00E9 alcuno dei seguenti:</p>'),
'<ul class="noIndent">',
unistr('<li>segno pi\00F9 (+)</li>'),
'<li>trattino (-)</li> ',
'<li>segno minore di (<)</li>',
'<li>segno maggiore di (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363349946307678)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'it'
,p_message_text=>'Separatore di gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129652922307492)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'it'
,p_message_text=>'Riga/e inserite:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360232514307676)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'it'
,p_message_text=>unistr('Questa query restituisce pi\00F9 di #MAX_ROW_COUNT# righe. Filtrare i dati per ottenere risultati completi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730632549307177)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'it'
,p_message_text=>'Record modificati da un altro utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353800898306841)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'it'
,p_message_text=>'Con distinzione tra maiuscole e minuscole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353710337306841)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna univoca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952797387307359)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati non riuscito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952835304307359)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Azione elaborata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976850706307377)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'it'
,p_message_text=>'Origine importazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786059693307229)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'it'
,p_message_text=>'Passo 2 - Nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411158203307718)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'it'
,p_message_text=>'Nessuna anteprima file disponibile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361952978307677)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'it'
,p_message_text=>'Facoltativamente racchiuso da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324116715307650)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'it'
,p_message_text=>'Avanzamento del caricamento guidato dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786235867307229)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'it'
,p_message_text=>'Passo 4 - Nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731838702307178)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'it'
,p_message_text=>'Torna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730194577307177)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'it'
,p_message_text=>'Righe da controllare:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844380758307276)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate);',
'',
'my_func(p_1  => :SAL,',
'        p_2  => :COMM)',
'',
'dove SAL e COMM sono i nomi delle colonne dei dati caricati',
unistr('e my_func \00E8 la funzione che restituisce il valore che sar\00E0 il nuovo valore'),
'della colonna per la quale viene definita questa regola di trasformazione.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844561680307276)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'    l_result := :SAL * :COMM;',
'    return l_result;',
'end;',
'',
unistr('Il risultato restituito sar\00E0 il nuovo valore della colonna per la quale viene definita questa regola di trasformazione.'),
'',
':SAL e :COMM fanno riferimento ai nomi delle colonne SAL e COMM dei dati caricati..',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844497934307276)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select depno',
' from dept',
'where dname = :DEPTNAME',
'  and loc   = :LOC',
'',
'dove :DEPNAME e :LOC fanno riferimento ai nomi delle colonne DEPNAME e LOC dei dati caricati.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370509199306855)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'it'
,p_message_text=>unistr('Nella colonna di tabella %0 non \00E8 possibile definire lo stesso carattere come separatore di gruppo e come carattere decimale. Immettere caratteri diversi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361783446307677)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'it'
,p_message_text=>'Identificare un carattere separatore di colonne. Utilizzare <code>\t</code> per la separazione con tabulazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361841503307677)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'it'
,p_message_text=>'Separatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732088068307178)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320430587307647)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Usa impostazioni avanzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320502994307647)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizzare le impostazioni avanzate per il caricamento dati: Simbolo valuta, Caratteri decimali, Codifica file o Formati data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996718205307391)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785979986307229)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'it'
,p_message_text=>'Passo 1 - Nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399051605307705)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'it'
,p_message_text=>'(\t per la tabulazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360583018307676)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna univoca %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129701009307492)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'it'
,p_message_text=>'Riga/e aggiornate:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440363909307740)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato caricato un valore nullo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992026572307388)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'it'
,p_message_text=>'Carica file separato da virgole (*.csv) o delimitato da tabulazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996916864307392)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'it'
,p_message_text=>'Risultati caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996892734307392)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Convalida dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102786174622307229)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'it'
,p_message_text=>'Passo 3 - Nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790217517307233)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'it'
,p_message_text=>'Creazione delle pagine della Creazione guidata caricamento dati completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952994902307359)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'it'
,p_message_text=>'Mapping dati/tabella non riuscito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953075288307359)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Azione elaborata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659046233307110)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'it'
,p_message_text=>'Mapping colonna caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102383824323306865)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di colonna: colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245664600306756)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'it'
,p_message_text=>'Carattere decimale: colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245835073306756)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione: colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245778615306756)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'it'
,p_message_text=>'Separatore di gruppo: colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246032791306756)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Mappa a: colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432953158306904)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'it'
,p_message_text=>'Lunghezza massima: colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245991173306756)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'it'
,p_message_text=>'- Colonna non mappata -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779127513307222)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'it'
,p_message_text=>'Il valore di attributo %0 di data evidenziata immesso per l''elemento %1 non corrisponde al formato %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784321312307227)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore di attributo %0 di data evidenziata immesso per l''elemento %1 non \00E8 una data relativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779372411307222)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'it'
,p_message_text=>'Il valore di attributo %0 di data massima immesso per l''elemento %1 non corrisponde al formato %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784595297307227)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore di attributo %0 di data massima immesso per l''elemento %1 non \00E8 una data relativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196694217306719)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'it'
,p_message_text=>'Il valore di attributo %0 di statico massimo immesso per l''elemento %1 non corrisponde al formato %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779260549307222)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'it'
,p_message_text=>'Il valore di attributo %0 di data minima immesso per l''elemento %1 non corrisponde al formato %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784434875307227)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore di attributo %0 di data minima immesso per l''elemento %1 non \00E8 una data relativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196503315306719)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'it'
,p_message_text=>'Il valore di attributo %0 di statico minimo immesso per l''elemento %1 non corrisponde al formato %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886491547307307)
,p_name=>'DATE_ADDED'
,p_message_language=>'it'
,p_message_text=>'Data aggiunta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331150477307655)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'it'
,p_message_text=>'Job del database Oracle APEX con ora dell''ultima esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708916992307157)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'it'
,p_message_text=>'al milestone finale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709072598307157)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'it'
,p_message_text=>'al milestone finale della release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783732554307227)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'it'
,p_message_text=>'Aggiungi classe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336501403307659)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'it'
,p_message_text=>'Avviso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335359180307658)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'it'
,p_message_text=>'Annulla evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336742876307659)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'it'
,p_message_text=>'Cancella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336631755307659)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Conferma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176039352306703)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176134434306703)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328093103306818)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'it'
,p_message_text=>'Disabilita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327971456306818)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'it'
,p_message_text=>'Abilita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328215942307653)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'it'
,p_message_text=>'Esegui codice PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327888350306818)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'it'
,p_message_text=>'Nascondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704284310307152)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'it'
,p_message_text=>'Esegui codice JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958438557307363)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783805554307227)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'it'
,p_message_text=>'Rimuovi classe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783925466307227)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'it'
,p_message_text=>'Imposta stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941352929307350)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'it'
,p_message_text=>'Imposta selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704162626307152)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'it'
,p_message_text=>'Imposta valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327795598306818)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941466278307351)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Sottometti pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922914892307337)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'it'
,p_message_text=>'Comprimi struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922858335307337)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'it'
,p_message_text=>'Espandi struttura'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225397045306741)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'it'
,p_message_text=>'Account di database'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700825815307149)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'it'
,p_message_text=>'I nomi delle tabelle di database e delle colonne fanno distinzione tra maiuscole e minuscole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800571184307242)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'it'
,p_message_text=>'eccezione per creazione di oggetto di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238907913306751)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'it'
,p_message_text=>'Database Oracle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389277381307698)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385999710307695)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'it'
,p_message_text=>'Tutti i tipi MIME'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388948629307697)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'it'
,p_message_text=>'Crea handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386203668307695)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'it'
,p_message_text=>'Crea metodo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386094265307695)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'it'
,p_message_text=>'Crea parametro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386189130307695)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Crea modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393161539307701)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'it'
,p_message_text=>'Modulo servizio RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388896876307697)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'it'
,p_message_text=>'Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393622497307701)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'it'
,p_message_text=>'Bind variable handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366037170307680)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'it'
,p_message_text=>'Metodo handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393931326307701)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366175887307680)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di origine handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385785000307695)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'it'
,p_message_text=>'Metodo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393246809307701)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome modulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393705501307701)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'it'
,p_message_text=>'Prefisso URI modulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386351314307695)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Nessuna origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385621455307695)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'it'
,p_message_text=>'Parametro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393429783307701)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'it'
,p_message_text=>'Servizi RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385836810307695)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393816653307701)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'it'
,p_message_text=>'Modello URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365952970307680)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'it'
,p_message_text=>'URI (Uniform Resource Identifier)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392960115307701)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'it'
,p_message_text=>'Prefisso URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393081773307701)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366297623307680)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'it'
,p_message_text=>'Query su una riga'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610172429307060)
,p_name=>'DEBUG'
,p_message_language=>'it'
,p_message_text=>'Debug'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716526838307164)
,p_name=>'DECLINED'
,p_message_language=>'it'
,p_message_text=>'Rifiutato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438826942307739)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area pulsante finestra di dialogo predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438740083307739)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area contenuto finestra di dialogo predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953698594307360)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina predefinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595907825307047)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'it'
,p_message_text=>'tablespace predefinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597564812307048)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'it'
,p_message_text=>'Tablespace predefinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846054197307277)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello predefinito'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221364222306738)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'it'
,p_message_text=>'Definita da azione dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012384046307404)
,p_name=>'DEFINED_TABS'
,p_message_language=>'it'
,p_message_text=>'Questa applicazione dispone di %0 schede distribuite in %1 set di schede e di %2 schede padre definite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464878983306930)
,p_name=>'DEFINE_LOV'
,p_message_language=>'it'
,p_message_text=>'Definisci liste di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646017310307098)
,p_name=>'DEFINITION'
,p_message_language=>'it'
,p_message_text=>'Definizione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798236329307240)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'it'
,p_message_text=>'Script di disinstallazione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316517248306809)
,p_name=>'DELETED'
,p_message_language=>'it'
,p_message_text=>'Eliminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333261181307657)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Elimina applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838552155307272)
,p_name=>'DELETE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Elimina: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102830765198307266)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'it'
,p_message_text=>'Elimina %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248513477306758)
,p_name=>'DELETE_MSG'
,p_message_language=>'it'
,p_message_text=>'Eseguire questa azione di eliminazione?'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272898034306777)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'it'
,p_message_text=>'Dimostrazione collection consente di memorizzare le righe di dati da utilizzare in una sessione di Oracle APEX. Questa applicazione di database illustra come utilizzare il codice PL/SQL per creare e gestire lo stato della sessione basato su una colle'
||'ction.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272617551306776)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'it'
,p_message_text=>'Applicazione di esempio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272723420306777)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'it'
,p_message_text=>unistr('Portale prodotto \00E8 un''applicazione di esempio che evidenzia i concetti di progettazione pi\00F9 comuni. Include pagine dedicate per clienti, prodotti e ordini, nonch\00E9 illustra l''utilizzo di report, grafici, calendari, mappe e strutture.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666982842307117)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'it'
,p_message_text=>'Dimostrabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393686954306872)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'it'
,p_message_text=>'Esempi di report e nozioni fondamentali sull''impaginazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393303345306872)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'it'
,p_message_text=>'Esempio di commercio elettronico creato utilizzando %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394095823306873)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'it'
,p_message_text=>'Informazioni sull''utilizzo di Oracle Text con %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394481296306873)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'it'
,p_message_text=>'Esempio di applicazione di registrazione dello stato del progetto sviluppata con %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393876615306873)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'it'
,p_message_text=>'Informazioni sull''utilizzo dei Web Service con %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392219011306871)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390138988306870)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389824606306870)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'it'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393580432306872)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'it'
,p_message_text=>'Look aziendale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392304167306871)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'it'
,p_message_text=>'Dimostrazione collection'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389999290306870)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'it'
,p_message_text=>'CONTEXT INDEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389315684306869)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'it'
,p_message_text=>'Si sta per creare l''applicazione demo Esempi di base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387907265306868)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'it'
,p_message_text=>'Si sta per (ri)creare l''applicazione demo Look aziendale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389403866306869)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'it'
,p_message_text=>'Si sta per creare l''applicazione demo collection.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389552735306869)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'it'
,p_message_text=>'crea o ricrea nello schema %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387802342306868)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'it'
,p_message_text=>'Creare un''applicazione di esempio per una dimostrazione dei Web Service.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388006146306868)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'it'
,p_message_text=>'Si sta per creare l''applicazione demo World Cup Mania.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229062751306744)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392062638306871)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'it'
,p_message_text=>'Applicazione demo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390434981306870)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'it'
,p_message_text=>'Sono disponibili circa %0 MB di spazio libero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392828997306872)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'it'
,p_message_text=>'Installa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392549494306872)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'it'
,p_message_text=>'Installata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524512537306981)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'it'
,p_message_text=>'Si sta per installare l''applicazione di esempio per la dimostrazione delle principali funzioni di %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393483819306872)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'it'
,p_message_text=>'Installa ora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392413261306872)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'it'
,p_message_text=>'Informazioni introduttive sul carrello %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833589841307268)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'it'
,p_message_text=>'Bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390250242306870)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'it'
,p_message_text=>unistr('L''applicazione demo Discorso di insediamento del presidente richiede circa 7 MB di spazio libero su disco e la relativa installazione nello schema corrente pu\00F2 richiedere fino a 2 minuti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524229347306981)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'it'
,p_message_text=>'Spazio insufficiente per creare questa demo. Richiedere altro spazio passando alle pagine di amministrazione e dei servizi di fornitura, quindi facendo clic sul collegamento della richiesta di spazio aggiuntivo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392708970306872)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'it'
,p_message_text=>'Non installata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388746256306869)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'it'
,p_message_text=>'EXISTS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387612625306868)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388603815306869)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389788984306869)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'it'
,p_message_text=>'Nome oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102387797457306868)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Non esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388343404306868)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'it'
,p_message_text=>'I seguenti oggetti di database verranno ricreati se esistenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388532780306868)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389204298306869)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'it'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393224656306872)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'it'
,p_message_text=>'Negozio di animali domestici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393964101306873)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'it'
,p_message_text=>'Discorso di insediamento del presidente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394273187306873)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'it'
,p_message_text=>'Registrazione progetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601468767307052)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'it'
,p_message_text=>'Reinstalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392674124306872)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'it'
,p_message_text=>'Esegui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388448587306868)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389006238306869)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392186700306871)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388833862306869)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391980055306871)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Report stato installazione applicazioni demo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389123736306869)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'it'
,p_message_text=>'Trigger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833604132307268)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'it'
,p_message_text=>'Sbloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254377782306763)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento disponibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411911250307718)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'it'
,p_message_text=>unistr('Per eseguire i Websheet in modo corretto, \00E8 necessario correggere i seguenti oggetti non validi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393745655306873)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'it'
,p_message_text=>'Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390557369306870)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile che si verifichino errori se questa demo non viene ricreata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335549524306827)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Spazio insufficiente per creare questa demo. Richiedere altro spazio passando alla pagina di amministrazione e facendo clic sul collegamento "Richiedi modifiche al servizio corrente".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335436640306827)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'it'
,p_message_text=>unistr('L''applicazione demo %0 \00E8 stata creata.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990817220307387)
,p_name=>'DEPRECATED'
,p_message_language=>'it'
,p_message_text=>unistr('Non pi\00F9 valido')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286597777306787)
,p_name=>'DERIVED$'
,p_message_language=>'it'
,p_message_text=>'colonna derivata'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666882126307117)
,p_name=>'DESIRABLE'
,p_message_language=>'it'
,p_message_text=>'Richiesto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739624166307185)
,p_name=>'DETAIL'
,p_message_language=>'it'
,p_message_text=>'Dettaglio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796304190307238)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'it'
,p_message_text=>'Dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739763553307185)
,p_name=>'DETAIL_2'
,p_message_language=>'it'
,p_message_text=>'Dettaglio 2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237987883306750)
,p_name=>'DEVELOPER'
,p_message_language=>'it'
,p_message_text=>'Sviluppatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801725760307243)
,p_name=>'DEVELOPERS'
,p_message_language=>'it'
,p_message_text=>'Sviluppatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686491814307136)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'it'
,p_message_text=>unistr('Riepilogo attivit\00E0 sviluppatore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710267471307158)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Riepilogo sviluppatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194784837306718)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703592788307152)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'it'
,p_message_text=>'Personalizzazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859654636307287)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'it'
,p_message_text=>'Cancella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859505337307287)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'it'
,p_message_text=>'Copia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207985590307562)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'it'
,p_message_text=>'Personalizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885865325307306)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'it'
,p_message_text=>'Debug (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885377158307306)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'it'
,p_message_text=>'Livello di debug predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885595441307306)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'it'
,p_message_text=>'Informazioni (predefinite)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885694640307306)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'it'
,p_message_text=>'Trace applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885712767307306)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'it'
,p_message_text=>'Trace completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194830454306718)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848798580307279)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'it'
,p_message_text=>unistr('Si sono verificati uno o pi\00F9 errori dopo il caricamento della pagina. Aprire la console JavaScript del browser per visualizzare gli errori.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848995839307279)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'it'
,p_message_text=>'Errori JavaScript'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208066580307562)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'it'
,p_message_text=>'Modifica logo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922547226307337)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa funzionalit\00E0 richiede che la finestra App Builder di Application Express sia aperta. Aprire la Costruzione guidata in questa finestra?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918614460307334)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni della barra degli strumenti sviluppatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920335656307335)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'it'
,p_message_text=>'Nascondi automaticamente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920524048307335)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Posizione di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920429160307335)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'it'
,p_message_text=>'Mostra solo icone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920730219307335)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920672684307335)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'it'
,p_message_text=>'A sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920897204307335)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'it'
,p_message_text=>'A destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922178375307336)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'it'
,p_message_text=>'Inizio pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854631121307283)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854894806307284)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'it'
,p_message_text=>'Tempificazione prestazioni pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918785368307334)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica rapida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854714814307283)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'it'
,p_message_text=>'Mostra tempificazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419675963307724)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'it'
,p_message_text=>'Theme Roller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920226449307335)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'it'
,p_message_text=>'Barra degli strumenti sviluppatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661121273307112)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'it'
,p_message_text=>'Task di sviluppo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829437838307265)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'it'
,p_message_text=>'Avviso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829324979307265)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829233408307264)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore minimo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178593497306705)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'it'
,p_message_text=>'Gruppi di elementi di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260964801306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263391539306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'it'
,p_message_text=>'Schemi di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263468805306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>'Schemi di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262523698306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262432048306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'it'
,p_message_text=>'Indicatori di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449059803307747)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262116697306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'it'
,p_message_text=>'Calcoli di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262366700306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262685629306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'it'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262752138306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262812694306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212197226306731)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonne liste dei valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262920702306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263038865306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'it'
,p_message_text=>'Barre di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261000598306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262003830306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'it'
,p_message_text=>'Diramazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261417789306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635833088307090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636057210307091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'it'
,p_message_text=>'Assi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635915018307091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'it'
,p_message_text=>'Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261790515306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'it'
,p_message_text=>'Calcoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302636855306799)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'it'
,p_message_text=>'Azioni dinamiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302744765306799)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'it'
,p_message_text=>'Azione dinamica - Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261578722306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'it'
,p_message_text=>'Aree report interattivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261651728306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'it'
,p_message_text=>'Colonne report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261272656306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261962963306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'it'
,p_message_text=>'Processi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261130580306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'it'
,p_message_text=>'Aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202114264307558)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261320179306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonne report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384100791307694)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'it'
,p_message_text=>'Strutture'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102261814380306768)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'it'
,p_message_text=>'Convalide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263136139306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'it'
,p_message_text=>'Schede padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102262298925306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'it'
,p_message_text=>'Processi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409872995307717)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'it'
,p_message_text=>'Layout report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410158819307717)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'it'
,p_message_text=>'Report istruzioni query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409750104307716)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'it'
,p_message_text=>'Query report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358860205307675)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263550120306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'it'
,p_message_text=>'Scorciatoie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259061474306766)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'it'
,p_message_text=>'File delle applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102265002267306771)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'it'
,p_message_text=>'Stringhe di sostituzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448764583307747)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti di supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448878637307747)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'it'
,p_message_text=>'Oggetti di supporto - Opzioni di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264881732306771)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'it'
,p_message_text=>'Oggetti di supporto - Convalide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264983360306771)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'it'
,p_message_text=>'Oggetti di supporto - Script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263269716306769)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'it'
,p_message_text=>'Schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263937018306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'it'
,p_message_text=>'Modelli di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264057033306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Modelli di pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264177443306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Modelli di calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327426374306817)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'it'
,p_message_text=>'Modelli griglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264213822306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'it'
,p_message_text=>'Modelli di etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264328726306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'it'
,p_message_text=>'Modelli di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264421771306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'it'
,p_message_text=>'Modelli di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264520362306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'it'
,p_message_text=>'Modelli di LOV popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264607405306771)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'it'
,p_message_text=>'Modelli di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102264704073306771)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'it'
,p_message_text=>'Modelli report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263893870306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'it'
,p_message_text=>'Temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252456706306761)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'it'
,p_message_text=>'File di temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200221733306722)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'it'
,p_message_text=>'Stili tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691627898307141)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'it'
,p_message_text=>'Messaggi di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246202643306757)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'it'
,p_message_text=>'Traduzioni dinamiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246337874306757)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'it'
,p_message_text=>'Testo traducibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263701842306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'it'
,p_message_text=>'Strutture'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102263621930306770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'it'
,p_message_text=>'Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375712907307688)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'it'
,p_message_text=>'Ruoli di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375885333307688)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730867549307177)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'it'
,p_message_text=>'Assegnazione ruoli utente di controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189353204306714)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'it'
,p_message_text=>'Automazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189526389306714)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Automazione - Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411638517307718)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'it'
,p_message_text=>'File concatenati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216877759306734)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'it'
,p_message_text=>'Caricamenti dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643359714307096)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'it'
,p_message_text=>'Profili di analisi dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643427199307096)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'it'
,p_message_text=>'Colonne profilo di analisi dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427025645307730)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'it'
,p_message_text=>'Commenti sviluppatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390765418307699)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948875486307356)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella di caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943120426307352)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'it'
,p_message_text=>'Tabelle di caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943274454307352)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'it'
,p_message_text=>'Ricerche tabella di caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943391602307352)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'it'
,p_message_text=>'Regole di trasformazione tabella di caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206734023306727)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'it'
,p_message_text=>'Pagina di calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205736850306726)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'it'
,p_message_text=>'Schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205889210306726)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919707372307335)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'it'
,p_message_text=>'Aree griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919808030307335)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919987453307335)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'it'
,p_message_text=>'Gruppi di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180791677306707)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'it'
,p_message_text=>'Mappe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180837148306707)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'it'
,p_message_text=>'Layer mappe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278655321306781)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'it'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278777200306781)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690178541307139)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'it'
,p_message_text=>'Valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333692719306826)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'it'
,p_message_text=>'Eventi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280807799306783)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'it'
,p_message_text=>'File'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739921232307185)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'it'
,p_message_text=>'Operatori di filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448927626307747)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389644540307698)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'it'
,p_message_text=>'Metadati attributi standard plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643290387307096)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'it'
,p_message_text=>'Server SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202061561307558)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448664728307747)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'it'
,p_message_text=>'Gruppi di opzioni modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364945183307679)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'it'
,p_message_text=>'Gruppo di opzioni modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418158975307723)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'it'
,p_message_text=>'Posizioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418223150307723)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'it'
,p_message_text=>'Posizioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332030956306821)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'it'
,p_message_text=>'Punti di visualizzazione tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258907854306766)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'it'
,p_message_text=>'Interfacce utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643976388307097)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'it'
,p_message_text=>'Parametri origine REST componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643642248307096)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'it'
,p_message_text=>'Origini dati REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643758404307096)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'it'
,p_message_text=>'Operazioni di origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643800426307096)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'it'
,p_message_text=>'Parametri origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643595844307096)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'it'
,p_message_text=>'Server remoti origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189874440306714)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'it'
,p_message_text=>'Passi di sincronizzazione REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189779046306714)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'it'
,p_message_text=>'Log di automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189978475306714)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'it'
,p_message_text=>'Log dei messaggi di automazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392319329307700)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Successivo disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392285580307700)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Precedente disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792924345307235)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'it'
,p_message_text=>'Disabilita trigger %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398365517306876)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398521144306876)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo condizione di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838620105307272)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'it'
,p_message_text=>'Ordine di visualizzazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284853053306785)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448376071307747)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'it'
,p_message_text=>'Valore visualizzato: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387682130307696)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine distinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387752512307697)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti distinti'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211801579306731)
,p_name=>'DML_FORM'
,p_message_language=>'it'
,p_message_text=>'Form DML'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506081328306962)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'it'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682205558307132)
,p_name=>'DOC_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Impatto documentazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683413076307133)
,p_name=>'DOC_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato documentazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683625372307133)
,p_name=>'DOC_WRITER'
,p_message_language=>'it'
,p_message_text=>'Autore documentazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571298904307024)
,p_name=>'DOWN'
,p_message_language=>'it'
,p_message_text=>'Inattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691429637307140)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo di collegamento per il download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505783553306962)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Non aggiornare gli elementi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505897010306962)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Non aggiornare gli elementi di immissione dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505946778306962)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Non aggiornare elementi di sola visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505628848306962)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'it'
,p_message_text=>'Non aggiornare le pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506454033306963)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Non aggiornare gli elementi di pagina'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368433428306853)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'it'
,p_message_text=>'Trascinamento della selezione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276294901306779)
,p_name=>'DRILLDOWN'
,p_message_language=>'it'
,p_message_text=>'Espandi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276164280306779)
,p_name=>'DRILLUP'
,p_message_language=>'it'
,p_message_text=>'Esegui drill-up'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413727626306888)
,p_name=>'DRIVEN'
,p_message_language=>'it'
,p_message_text=>'basato su'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792757893307235)
,p_name=>'DROP TRIGGER'
,p_message_language=>'it'
,p_message_text=>'Elimina trigger %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791894047307234)
,p_name=>'DROP_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Elimina colonna %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939232254307349)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'it'
,p_message_text=>'Metodo di accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939008550307349)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome bind variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939488651307349)
,p_name=>'DS_HANDLER'
,p_message_language=>'it'
,p_message_text=>'Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939805067307349)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'it'
,p_message_text=>'Elementi per pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939675330307349)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'it'
,p_message_text=>'Tipi MIME consentiti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939755294307349)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'it'
,p_message_text=>'Origini consentite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939307783307349)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di parametro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939906274307349)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'it'
,p_message_text=>'Vincolo di sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939190735307349)
,p_name=>'DS_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102939581980307349)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940064946307350)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'it'
,p_message_text=>'Prefisso URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938704867307349)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello URI'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410232921307717)
,p_name=>'DUE'
,p_message_language=>'it'
,p_message_text=>'Scadenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683292045307133)
,p_name=>'DUE_DATE'
,p_message_language=>'it'
,p_message_text=>'Data scadenza'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663791868307115)
,p_name=>'DUPLICATE'
,p_message_language=>'it'
,p_message_text=>'Duplicato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388382627307697)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'it'
,p_message_text=>'Utente duplicato nella lista'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200632976306722)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200548374306722)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni dinamiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210728860306730)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'it'
,p_message_text=>'Form dinamico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316662546306809)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'it'
,p_message_text=>'HTML dinamico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367363369306852)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'it'
,p_message_text=>'Report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193723252306717)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Riferimento dinamico'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102463110188306929)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'it'
,p_message_text=>unistr('La condizione che si sta aggiungendo ha causato l''invalidit\00E0 della query.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205292310306726)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'it'
,p_message_text=>'Modifica gruppo di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723892288307171)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'it'
,p_message_text=>'Se si sceglie OK, le modifiche non salvate andranno perdute.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237264025306750)
,p_name=>'EDIT_ALL'
,p_message_language=>'it'
,p_message_text=>'Modifica tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464348212306930)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Modifica tutti gli attributi di definizione della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718788926307166)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'it'
,p_message_text=>'Modifica tutti gli elementi in questa area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649437041307101)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Modifica applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738403049307184)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'it'
,p_message_text=>'Modifica attributo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333419412307657)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'it'
,p_message_text=>'Modifica autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728218565307175)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'it'
,p_message_text=>'Modifica componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738509893307184)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'it'
,p_message_text=>'Modifica definizione dei componenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829952280307265)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'it'
,p_message_text=>'Modifica %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738301289307184)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'it'
,p_message_text=>'Modifica definizione lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402213786307711)
,p_name=>'EDIT_LOCK'
,p_message_language=>'it'
,p_message_text=>'Modifica lock'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609907350307060)
,p_name=>'EDIT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Modifica pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466470294306932)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Modifica attributi pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997364076307392)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'it'
,p_message_text=>'Modifica profilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014722231307405)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'it'
,p_message_text=>'L''utente 0% non dispone di privilegi per aggiornare le informazioni per un altro utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728019055307175)
,p_name=>'EDIT_REGION'
,p_message_language=>'it'
,p_message_text=>'Modifica area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802595727307243)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'it'
,p_message_text=>'Modifica periodo di tempo di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728121291307175)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'it'
,p_message_text=>'Modifica colonne di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991581569307388)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'it'
,p_message_text=>'Modifica report - Finestra di dialogo chiusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718026941307165)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Modifica messaggio di sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953473979307360)
,p_name=>'EDIT_TAB'
,p_message_language=>'it'
,p_message_text=>'Modifica scheda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739837383307185)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'it'
,p_message_text=>'Modifica questo attributo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592279237307044)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'it'
,p_message_text=>'Tempo trascorso'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670825085307121)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'it'
,p_message_text=>'<a href="#MY_APPLICATION_LINK#">Visitare Applicazione personale e gestire le preferenze di posta elettronica</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677781071307127)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'it'
,p_message_text=>'<b style="font-size: 24px;">Applicazione personale</b>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792255858307234)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Gentile #INVITEE#,</strong><br>',
'<br>',
unistr('questo \00E8 un promemoria per un evento imminente a cui si \00E8 invitati. I dettagli dell''evento sono riportati di seguito.<br>'),
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Organizzatore</th>',
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Data evento</th>',
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Ora di inizio</th>',
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Durata</th>',
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Luogo</th>',
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Note</th>',
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670744853307121)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Gentile #CUSTOMER_NAME#</strong>,<br>',
'<br>',
'grazie per l''ordine.<br>',
'<br>',
'<strong>Dettagli dell''ordine</strong><br>',
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Data ordine</th>',
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Numero ordine</th>',
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Destinatario</th>',
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Indirizzo di spedizione</th>',
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Articoli ordinati</th>',
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Totale ordine</th>',
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('Se \00E8 necessario apportare modifiche: <a href="#ORDER_URL#">gestire l''ordine #ORDER_NUMBER# qui.</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991802970307388)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Gentile #SERVICE_USER#,<br>',
'<br>',
unistr('tenere presente l''imminente indisponibilit\00E0 pianificata del servizio #SERVICE_NAME#.<br>'),
unistr('In base alla pianificazione, l''indisponibilit\00E0 inizier\00E0 alle #OUTAGE_START# e il servizio sar\00E0 indisponibile per #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.<br>'),
'<br>',
unistr('Durante l''indisponibilit\00E0 pianificata verranno eseguite le operazioni seguenti:<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
unistr('Per qualsiasi problema relativo all''indisponibilit\00E0 del servizio, rivolgersi a #OUTAGE_CONTACT#.<br>'),
'<br>',
'Grazie per la comprensione,<br>',
'#SERVICE_TEAM#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991249215307387)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'it'
,p_message_text=>'Promemoria evento: #EVENT_NAME#'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991305599307387)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'it'
,p_message_text=>'Ordine (#ORDER_NUMBER#) confermato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792428587307235)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Gentile #INVITEE#,',
'',
unistr('questo messaggio di posta elettronica \00E8 un promemoria per un evento imminente a cui si \00E8 associati.'),
'',
'Data evento: #EVENT_DATE#',
'Ora di inizio: #START_TIME#',
'Durata:      #DURATION#',
'Organizzatore: #ORGANIZER#',
'Luogo:     #LOCATION#',
'URL:        #URL_NAME# (#URL_LINK#)',
'Note:     #NOTES#',
'',
'Ulteriori dettagli sono disponibili qui: #EVENT_LINK#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792379566307234)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Gentile #CUSTOMER_NAME#,',
'',
'grazie per l''ordine.',
'',
'Dettagli dell''ordine',
'--------------------------------------------------------------------------------',
'  Data ordine:      #ORDER_DATE#',
'  Numero ordine:    #ORDER_NUMBER#',
'  Destinatario:     #SHIP_TO#',
'  Indirizzo di spedizione: #SHIPPING_ADDRESS_LINE_1#',
'                    #SHIPPING_ADDRESS_LINE_2#',
'  Articoli ordinati: #ITEMS_ORDERED#',
'  Totale ordine:     #ORDER_TOTAL#',
'--------------------------------------------------------------------------------',
'',
unistr('Se \00E8 necessario apportare modifiche, gestire l''ordine #ORDER_NUMBER# qui: #ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991745074307388)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Gentile #SERVICE_USER#,',
'',
unistr('tenere presente l''imminente indisponibilit\00E0 pianificata del servizio #SERVICE_NAME#.'),
unistr('In base alla pianificazione, l''indisponibilit\00E0 inizier\00E0 alle #OUTAGE_START# e il servizio sar\00E0 indisponibile per #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.'),
'',
unistr('Durante l''indisponibilit\00E0 pianificata verranno eseguite le operazioni seguenti:'),
'#OUTAGE_REASON#',
'',
unistr('Per qualsiasi problema relativo all''indisponibilit\00E0 del servizio, rivolgersi a #OUTAGE_CONTACT#.'),
'',
'Grazie per la comprensione,',
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722088817307169)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'it'
,p_message_text=>unistr('Abilita debug (S\00EC o No)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792859928307235)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'it'
,p_message_text=>'Abilita trigger %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239404421306751)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('La lunghezza del valore da cifrare non pu\00F2 superare 4000 byte.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238032443306750)
,p_name=>'END_USER'
,p_message_language=>'it'
,p_message_text=>'Utente finale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660874921307112)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'it'
,p_message_text=>'Richiesta di miglioramento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015425258307406)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'it'
,p_message_text=>'Richieste di miglioramento: chiuse %1 su %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663258354307114)
,p_name=>'ENTERED'
,p_message_language=>'it'
,p_message_text=>'Immesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204469000306725)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Immettere le credenziali Websheet.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651046872307103)
,p_name=>'ENTRY LINK'
,p_message_language=>'it'
,p_message_text=>'Collegamento della voce'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650937679307103)
,p_name=>'ENTRY TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo della voce'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706376240307154)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569462962307023)
,p_name=>'ERRORPAGE'
,p_message_language=>'it'
,p_message_text=>'Nella pagina di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719077028307166)
,p_name=>'ERRORS'
,p_message_language=>'it'
,p_message_text=>'Errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652246397307104)
,p_name=>'ERROR_ICON'
,p_message_language=>'it'
,p_message_text=>'Icona di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409252899307716)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio di errore'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644439020307097)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'it'
,p_message_text=>'<br><strong>I dati con escape superano il limite consentito. I risultati verranno troncati a 32k</strong>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412942520306888)
,p_name=>'ESCAPE_SC'
,p_message_language=>'it'
,p_message_text=>'caratteri speciali di escape'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684620062307134)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'it'
,p_message_text=>'Impegno stimato in ore'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938978870307349)
,p_name=>'ETAG_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query ETAG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938824846307349)
,p_name=>'ETAG_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo ETAG'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661311726307112)
,p_name=>'EVENT'
,p_message_language=>'it'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995903026307391)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'it'
,p_message_text=>'Dopo l''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996280110307391)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'it'
,p_message_text=>'Prima della sottomissione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995821741307391)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'it'
,p_message_text=>'Prima dell''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998408624307393)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'it'
,p_message_text=>'Eventi del browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459591858306926)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'it'
,p_message_text=>'Doppio tocco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459715505306926)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'it'
,p_message_text=>'Panoramica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459652161306926)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'it'
,p_message_text=>'Premi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459883706306926)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'it'
,p_message_text=>'Fai scorrere il dito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459409744306926)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'it'
,p_message_text=>'Tocca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995351870307390)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994685114307390)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'it'
,p_message_text=>'Clic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994793255307390)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'it'
,p_message_text=>'Doppio clic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994195841307390)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'it'
,p_message_text=>'Elemento attivo selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994017594307389)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'it'
,p_message_text=>'Elemento attivo deselezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995511779307391)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'it'
,p_message_text=>'Tasto premuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995685943307391)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'it'
,p_message_text=>'Pressione tasto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995758322307391)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'it'
,p_message_text=>'Rilascio tasto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994277326307390)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'it'
,p_message_text=>'Caricamento risorsa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994870645307390)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'it'
,p_message_text=>'Pressione pulsante del mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995125600307390)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'it'
,p_message_text=>'Entrata mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995210501307390)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'it'
,p_message_text=>'Uscita mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995061873307390)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'it'
,p_message_text=>'Spostamento mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994924768307390)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'it'
,p_message_text=>'Rilascio pulsante del mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203411750306724)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'it'
,p_message_text=>'Modifica orientamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001710000307395)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'it'
,p_message_text=>'Caricamento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994317185307390)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'it'
,p_message_text=>'Ridimensionamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994482359307390)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'it'
,p_message_text=>'Scorrimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203561647306724)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'it'
,p_message_text=>'Avvio scorrimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203606341306724)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'it'
,p_message_text=>'Arresto scorrimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102995454317307390)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'it'
,p_message_text=>'Selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202641254306724)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'it'
,p_message_text=>'Fai scorrere il dito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202795123306724)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'it'
,p_message_text=>'Fai scorrere il dito verso sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202875312306724)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'it'
,p_message_text=>'Fai scorrere il dito verso destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202455877306724)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'it'
,p_message_text=>'Tocca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202530071306724)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'it'
,p_message_text=>'Tocca e tieni premuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102994559990307390)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'it'
,p_message_text=>'Scaricamento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203232916306724)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'it'
,p_message_text=>'Clic virtuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203313926306724)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'it'
,p_message_text=>'Annullamento tocco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202903402306724)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'it'
,p_message_text=>'Avvia con tocco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203066330306724)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'it'
,p_message_text=>'Sposta con tocco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203134838306724)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'it'
,p_message_text=>'Fine tocco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998643139307393)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'it'
,p_message_text=>'Eventi di componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199499634306721)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Evento personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199551491306721)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998503059307393)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'it'
,p_message_text=>'Eventi del framework'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575868550307029)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo chiusa o annullata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727931133307174)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo chiusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417109334307722)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'it'
,p_message_text=>'Dopo l''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417286978307722)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'it'
,p_message_text=>'Prima della sottomissione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417039131307722)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'it'
,p_message_text=>'Prima dell''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646135908307098)
,p_name=>'EVENTS'
,p_message_language=>'it'
,p_message_text=>'Eventi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683313311307133)
,p_name=>'EVENT_ID'
,p_message_language=>'it'
,p_message_text=>'Numero milestone'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724215529307171)
,p_name=>'EXACT_SUBS'
,p_message_language=>'it'
,p_message_text=>'Stringhe di sostituzione esatte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838078300307271)
,p_name=>'EXAMPLE_1'
,p_message_language=>'it'
,p_message_text=>'Esempio 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838168504307271)
,p_name=>'EXAMPLE_2'
,p_message_language=>'it'
,p_message_text=>'Esempio 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338244270307660)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'it'
,p_message_text=>unistr('Questo \00E8 un esempio dei dati contenuti in una colonna di database XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388210912307697)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'it'
,p_message_text=>'URI esempio'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793975994307236)
,p_name=>'EXCLUDE'
,p_message_language=>'it'
,p_message_text=>'Escludi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773588260307217)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome di schema esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715546306307163)
,p_name=>'EXISTS'
,p_message_language=>'it'
,p_message_text=>'Esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270885108306775)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query SQL - Esiste'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986116528307384)
,p_name=>'EXPANDED'
,p_message_language=>'it'
,p_message_text=>'Espanso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384029204307694)
,p_name=>'EXPAND_ALL'
,p_message_language=>'it'
,p_message_text=>'Espandi tutto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336088948306828)
,p_name=>'EXPIRED'
,p_message_language=>'it'
,p_message_text=>'Scaduto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649665124307101)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'it'
,p_message_text=>'Explain plan'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646407130307098)
,p_name=>'EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esporta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954706567307360)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'it'
,p_message_text=>'Repository dei file di esportazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728589107307175)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Esportato da un''altra area di lavoro o applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728629088307175)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Esportato da area di lavoro corrente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797902829307239)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Esporta applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802183013307243)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Utilizzare questi collegamenti per scaricare l''applicazione e gli oggetti di supporto del database corrispondenti per la distribuzione in un''altra installazione di Oracle APEX. I file scaricati sono script SQL che possono essere eseguiti da SQL*Plus,'
||' SQL Developer o SQL Scripts all''interno di Oracle APEX.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798053455307239)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Esporta oggetti di supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646711007307099)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esportazione applicazione  '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646976207307099)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esportazione CSS (Cascading Style Sheet)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647144659307099)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esportazione file statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647081194307099)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esportazione immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646848988307099)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esportazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647213287307099)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esportazione file di script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102643111637307096)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Valori predefiniti interfaccia utente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574277379307027)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Calcolo applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572299891307025)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574008671307027)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Processo applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102388944780306869)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'it'
,p_message_text=>'Gli ID applicazione da 3000 a 8999 sono riservati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272085941306776)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'it'
,p_message_text=>unistr('Questa applicazione \00E8 stata esportata dall''area di lavoro corrente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272165630306776)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'it'
,p_message_text=>unistr('Questa applicazione \00E8 stata esportata da un''altra area di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205810053307561)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Credenziali del server di stampa remoto dell''applicazione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205618273307560)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'it'
,p_message_text=>'Server di stampa remoto dell''applicazione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573907651307027)
,p_name=>'F4000.BRANCH'
,p_message_language=>'it'
,p_message_text=>'Diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587889449307040)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'it'
,p_message_text=>'Dirama da pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588070058307040)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'it'
,p_message_text=>'Dirama a pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573587645307027)
,p_name=>'F4000.BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714571497307162)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327311364306817)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449820061306918)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna di calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588443892307040)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352417905307670)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome identificato della colonna \00E8 una parola riservata Oracle. Scegliere un altro nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715976992307163)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'it'
,p_message_text=>'Copia voce di lista: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601728514307052)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'it'
,p_message_text=>'Dinamico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286245315306787)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271999935306776)
,p_name=>'F4000.EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esporta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603947826307054)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'it'
,p_message_text=>'Correggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601387515307052)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'it'
,p_message_text=>'Per utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601234018307052)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'it'
,p_message_text=>'Per sessione utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588180491307040)
,p_name=>'F4000.FROM'
,p_message_language=>'it'
,p_message_text=>'da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390012084306870)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'it'
,p_message_text=>'L''intestazione deve contenere le tag <strong>&lt;head&gt;</strong> e <strong>&lt;/head&gt;</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390381471306870)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'it'
,p_message_text=>'La stringa di sostituzione <strong>#HEAD#</strong> deve trovarsi tra le tag <strong>&lt;head&gt;</strong> e <strong>&lt;/head&gt;</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658989099307110)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo dl file "%0" non \00E8 valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573254665307026)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573316652307026)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'it'
,p_message_text=>'Elemento di sola lettura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218604428306736)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'it'
,p_message_text=>'Istruzione SQL precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741922697307187)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606450055307057)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574643625307028)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218577116306736)
,p_name=>'F4000.LOCAL'
,p_message_language=>'it'
,p_message_text=>'Locale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574992829307028)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voce di lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588262236307040)
,p_name=>'F4000.MENU'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574887664307028)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'it'
,p_message_text=>'Voce di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618272124307068)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'it'
,p_message_text=>'Selezionare almeno un elemento da copiare o sottoscrivere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574362706307027)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Elemento della barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505098711306962)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'it'
,p_message_text=>'Icona&nbsp;barra&nbsp;di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572164121307025)
,p_name=>'F4000.NO'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601837643307052)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'it'
,p_message_text=>'Senza riferimenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586322558307038)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessun dato trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411783223307718)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''applicazione %0 non esiste nell''area di lavoro corrente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012664348307404)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'it'
,p_message_text=>'Controllo aggiornamenti disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611014026307061)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome tabella padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274751425306778)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'it'
,p_message_text=>'Diramazione del pulsante Annulla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274324049306778)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo visualizzato del pulsante Annulla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274840155306778)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'it'
,p_message_text=>'Diramazione del pulsante Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274450157306778)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo visualizzato del pulsante Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274688005306778)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo visualizzato del pulsante Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274526494306778)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo visualizzato del pulsante Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611198808307061)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611290102307061)
,p_name=>'F4000.P119.GO'
,p_message_language=>'it'
,p_message_text=>'Vai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611361815307061)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Utilizzando gli stessi modelli di un''applicazione esistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414258211307720)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'it'
,p_message_text=>'Copia %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415970409307721)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti schemi di autorizzazione:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416251299307722)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di indicatore di percorso:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416354665307722)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di pulsante:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416462373307722)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di calendario:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198052229306720)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare le seguenti definizioni di caricamento dati:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415889066307721)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di etichetta:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415649396307721)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di lista:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415361276307721)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare le seguenti liste di valori:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416178314307721)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti elementi della barra di navigazione:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415428815307721)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di pagina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416548476307722)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti plugin:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416660199307722)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di lista di valori popup:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415542184307721)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di area:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415749238307721)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare i seguenti modelli di report:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416052400307721)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione andr\00E0 ad aggiornare le seguenti scorciatoie:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774615247307218)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di pubblicare <strong>%0</strong>. Questa operazione aggiorner\00E0 le seguenti origini dati REST:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619007945307068)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'it'
,p_message_text=>'Copia di %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414159813307720)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'it'
,p_message_text=>'Definizione ricerche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411804867307718)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102389683214306869)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Specificare almeno un elemento per creare una convalida NOT NULL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324071648307650)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'it'
,p_message_text=>'Server di stampa %0 applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035812850307421)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Aggiorna impostazioni di esportazione predefinite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147527491307505)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'it'
,p_message_text=>'azione='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655203161307107)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'it'
,p_message_text=>'commento='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653318781307105)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'it'
,p_message_text=>'Utilizzato per eseguire il calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420661202307725)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'it'
,p_message_text=>'File concatenato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653923992307105)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'it'
,p_message_text=>'valore visualizzato='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420508775307725)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'it'
,p_message_text=>'file='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653675556307105)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'it'
,p_message_text=>'Barra delle icone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654182921307106)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'it'
,p_message_text=>'Lista di valori='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653888367307105)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'it'
,p_message_text=>'Dati della lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653725362307105)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'it'
,p_message_text=>'nome='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653220856307105)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'it'
,p_message_text=>'Utilizzato per visualizzare la pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655106627307107)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'it'
,p_message_text=>'Diramazione di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654262674307106)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653560558307105)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'it'
,p_message_text=>'Utilizzato per eseguire il processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102653435627307105)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654044888307106)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'it'
,p_message_text=>'valore restituito='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416872927307722)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Assegna voce di lista a livello padre differente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449421092306918)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Specificare almeno un''area da creare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571820052307025)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro non verr\00E0 creata perch\00E9 esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571992928307025)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro verr\00E0 creata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417699802307723)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'it'
,p_message_text=>'Blocca vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449577790306918)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Specificare almeno una pagina da creare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417762270307723)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina \00E8 sbloccata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981169030307380)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'it'
,p_message_text=>'LOV popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611714126307062)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'it'
,p_message_text=>'Posizione 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611806507307062)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'it'
,p_message_text=>'Posizione 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611929453307062)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'it'
,p_message_text=>'Posizione 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612026543307062)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'it'
,p_message_text=>'Posizione 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209995196306729)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'it'
,p_message_text=>'Pos.5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778849729307222)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'it'
,p_message_text=>'Posizione 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778917233307222)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'it'
,p_message_text=>'Posizione 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779024928307222)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'it'
,p_message_text=>'Posizione 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612199349307062)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'it'
,p_message_text=>'I pulsanti DML e di impaginazione richiedono nomi di pulsanti specifici e riferimenti al testo della Guida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414363517307720)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'it'
,p_message_text=>'%0 (classe corrispondente)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612220484307062)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'it'
,p_message_text=>'gestisci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420952694307725)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore originale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612372196307062)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'it'
,p_message_text=>'Stringa di sostituzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612498985307062)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore di sostituzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585796473307038)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">In questa area verr\00E0 visualizzata la Guida relativa alla pagina e all''elemento per la pagina corrente se l''area viene richiamata utilizzando la seguente sintassi:<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612564677307062)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'it'
,p_message_text=>'Form su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612636921307062)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'it'
,p_message_text=>'Valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336756909306828)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'it'
,p_message_text=>'Diramazione='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604822085307055)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'it'
,p_message_text=>'Pulsante='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227462165306742)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'it'
,p_message_text=>'Serie grafico ='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605066014307055)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'it'
,p_message_text=>'Calcolo='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604492351307055)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'it'
,p_message_text=>'Testo secondario icona='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604338462307055)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'it'
,p_message_text=>'Immagine='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604998693307055)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'it'
,p_message_text=>'Elemento='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604517635307055)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'it'
,p_message_text=>'Lista='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336837008306828)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'it'
,p_message_text=>'Voce di indicatore di percorso ='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604787988307055)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'it'
,p_message_text=>'Pagina='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605157836307055)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'it'
,p_message_text=>'Processo='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227321514306742)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'it'
,p_message_text=>'Area ='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601996105307052)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'it'
,p_message_text=>'Richiesto da ogni pagina dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604090349307054)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604162220307054)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Calcolo applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604206637307055)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Processo applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605367218307056)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'it'
,p_message_text=>'Nome scheda='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605458935307056)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'it'
,p_message_text=>'Set di schede='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102604614040307055)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'it'
,p_message_text=>'Testo='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605234838307056)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'it'
,p_message_text=>'Convalida='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614383060307064)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Scarica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614958004307065)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'it'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613907672307064)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'it'
,p_message_text=>'Aspetto predefinito 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614020007307064)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'it'
,p_message_text=>'Aspetto predefinito 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614174310307064)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'it'
,p_message_text=>'Aspetto predefinito 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614203416307064)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'it'
,p_message_text=>'Aspetto predefinito 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613032988307063)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'it'
,p_message_text=>'Utilizza pulsanti di impaginazione creati esternamente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613876303307064)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'it'
,p_message_text=>'Aspetto HTML standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614572563307064)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'it'
,p_message_text=>'Aspetto 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614650170307064)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'it'
,p_message_text=>'Aspetto 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614709201307064)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'it'
,p_message_text=>'Aspetto 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614871443307064)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'it'
,p_message_text=>'Aspetto 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613536553307063)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'it'
,p_message_text=>'Righe da X a Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613263761307063)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe 1-15 16-30 nella lista di selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613781015307063)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'it'
,p_message_text=>'Motore di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613303813307063)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'it'
,p_message_text=>'Motore di ricerca 1,2,3,4 (impaginazione in base a set)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613688061307063)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista di selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612865435307063)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'imposta valori predefiniti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612955331307063)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'it'
,p_message_text=>'disattiva impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613454989307063)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'it'
,p_message_text=>'Utilizza pulsanti di impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615023016307065)
,p_name=>'F4000.P420.XML'
,p_message_language=>'it'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102614466185307064)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esportazione XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615127305307065)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'it'
,p_message_text=>'Crea collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102613133138307063)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe da X a Y (con collegamenti Successivo e Precedente)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440206837307740)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'it'
,p_message_text=>'Valore NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739196297307185)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna DB'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739325472307185)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739415336307185)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739275713307185)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739018251307185)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'it'
,p_message_text=>'testo statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615260944307065)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'it'
,p_message_text=>'I pulsanti DML richiedono nomi di pulsanti specifici e riferimenti al testo della Guida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281874227306783)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nuovo plugin verr\00E0 creato nell''applicazione %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281784276306783)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'it'
,p_message_text=>unistr('Il plugin esistente nell''applicazione %0 verr\00E0 sostituito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615387415307065)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'it'
,p_message_text=>'HTML con scorciatoie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615585949307065)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'it'
,p_message_text=>'PLSQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606220923307056)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di pulsante predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327286745306817)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di calendario predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436539243307737)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area grafico predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327018760306817)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina finestra di dialogo predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436602264307737)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area form predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437088360307738)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area report interattivo predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606148075307056)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di etichetta predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436776208307738)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area lista predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606089855307056)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di lista predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437227293307738)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area indicatore di percorso predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606362255307057)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di indicatore di percorso predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436366467307737)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di lista barra di navigazione predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436042614307737)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello lista menu di navigazione predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435898802307737)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'it'
,p_message_text=>'Modello di etichetta facoltativo predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605771919307056)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605810747307056)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436836627307738)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area report predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605998320307056)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di report predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435915786307737)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'it'
,p_message_text=>'Modello di etichetta obbligatorio predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436287145307737)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello lista menu di navigazione laterale predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436994696307738)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area form tabulare predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436106235307737)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello lista menu di navigazione superiore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437126021307738)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di area procedura guidata predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605644252307056)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina di errore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103436496096307737)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina di login predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102605528075307056)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('Modello di pagina predefinito (modalit\00E0 di stampa)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102612741807307062)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'it'
,p_message_text=>'Report su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609381144307059)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'it'
,p_message_text=>'informazioni sugli avvisi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609594086307060)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'it'
,p_message_text=>'nuova area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609248278307059)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario creare almeno un''area prima di poter creare un elemento di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609449111307059)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'it'
,p_message_text=>'Utilizzare una procedura guidata per creare una nuova area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610727136307061)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'it'
,p_message_text=>unistr('l''ordinamento sar\00E0 alfabetico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610981660307061)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'it'
,p_message_text=>'Esempio 4: lista di valori con bind variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610898235307061)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'it'
,p_message_text=>'in ordine di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610479765307060)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'it'
,p_message_text=>'Esempio 2: lista di valori con lo stesso valore visualizzato e restituito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703232249307152)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'it'
,p_message_text=>'Esempio 5: la query contiene una query in linea; assicurarsi che la prima clausola FROM nell''istruzione SQL non faccia parte della query in linea.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610341162307060)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'it'
,p_message_text=>'Esempio 1: lista di valori basata su query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610625104307061)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'it'
,p_message_text=>'Esempio 3: esempi di lista statica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610566600307060)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'it'
,p_message_text=>'Se si seleziona la stessa colonna per i valori visualizzati e restituiti, utilizzare un alias di colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280799165306782)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'it'
,p_message_text=>unistr('mostra S\00EC / No, restituisci Y e N')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616175411307066)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Dopo l''elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615868392307065)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'it'
,p_message_text=>'Prima dei calcoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616024950307066)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Prima dell''elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615944528307065)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'it'
,p_message_text=>'Prima delle convalide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287146813306787)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616294798307066)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'it'
,p_message_text=>'Applica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284001211306785)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616446740307066)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616372586307066)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Sottometti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616610739307066)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'it'
,p_message_text=>unistr('Una volta eseguita questa procedura, verr\00E0 reimpostata l''impaginazione per tutte le pagine in questa applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628778509307085)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'it'
,p_message_text=>unistr('AVVERTENZA: \00E8 stata scelta una convalida di tipo Espressione regolare, non supportata dalla versione del database in uso. Questa convalida restituir\00E0 sempre un valore TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365606452307680)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'it'
,p_message_text=>'Le traduzioni per questa applicazione non sono abilitate. Vedere l''impostazione <em>Lingua dell''applicazione derivata da</em> in <a href="%0">Attributi di globalizzazione</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427839443307730)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'it'
,p_message_text=>unistr('Se il tempo massimo di inattivit\00E0 sessione non \00E8 impostato, verr\00E0 utilizzato il valore a livello di area di lavoro o di istanza (attualmente, %0 secondi).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427956971307730)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'it'
,p_message_text=>unistr('Se la lunghezza massima della sessione non \00E8 impostata, verr\00E0 utilizzato il valore a livello di area di lavoro o di istanza (attualmente, %0 secondi).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418309188307723)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'it'
,p_message_text=>'Nuova diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729422738307176)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Questi componenti sono stati esportati da un''applicazione diversa o da un''applicazione di un''area di lavoro differente. Impossibile installare i componenti in questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733402011307180)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Questi file sono stati esportati da un''area di lavoro diversa. Impossibile installarli in questa area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418497449307723)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'A modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419263959307724)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'it'
,p_message_text=>'Opzione di copia: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419303603307724)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'it'
,p_message_text=>'Lista di valori esistente: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670324252307121)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina \00E8 stata esportata da un''applicazione diversa o da un''applicazione di un''area di lavoro differente. Impossibile installare la pagina in questa applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571727838307025)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina \00E8 stata esportata da un''applicazione in un''area di lavoro diversa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571661824307025)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina \00E8 stata esportata da un''applicazione nell''area di lavoro corrente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990645020307387)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina \00E8 bloccata. Impossibile eseguire l''importazione in una pagina bloccata. Sbloccare la pagina e procedere all''installazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103416948971307722)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Cancella voce padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418780845307723)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'it'
,p_message_text=>'Seleziona parametro %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390656751306870)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Selezionare almeno uno schema da copiare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418905222307724)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'it'
,p_message_text=>'Valore per l''intestazione HTTP %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418861563307724)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'it'
,p_message_text=>'Valore per il parametro di input %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419159292307724)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'it'
,p_message_text=>'Elimina intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419032102307724)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'it'
,p_message_text=>'Elimina parametro: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618475610307068)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'it'
,p_message_text=>'Foglio di stile obbligatorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587581334307039)
,p_name=>'F4000.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602157459307053)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573631738307027)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Calcolo di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328493640306818)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione dinamica pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189467281306714)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione dinamica pagina - Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572350752307025)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191669152306715)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'it'
,p_message_text=>'Gruppo di elementi di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606583767307057)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'it'
,p_message_text=>'pagina/e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587646919307039)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573744586307027)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Processo di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602067724307053)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'it'
,p_message_text=>'Area di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602271946307053)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Convalida pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574584250307027)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588510389307040)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di lista di valori popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205759652307561)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Credenziali server di stampa remoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589180520307041)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'it'
,p_message_text=>'Pubblica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573132572307026)
,p_name=>'F4000.REGION'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202244822307558)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonna area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587717740307039)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'it'
,p_message_text=>'Pagina/e e componenti correlati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205984694307561)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'it'
,p_message_text=>'SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703060350307151)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218705030306736)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'it'
,p_message_text=>'SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589099027307041)
,p_name=>'F4000.SEED'
,p_message_language=>'it'
,p_message_text=>'Popola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102574476002307027)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601602525307052)
,p_name=>'F4000.STATIC'
,p_message_language=>'it'
,p_message_text=>'Statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588372126307040)
,p_name=>'F4000.TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588645706307040)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432440898306904)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome o i nomi %0 dei modelli esistono gi\00E0. Immettere un nuovo nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390720661306870)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario specificare il nome del modello.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588814036307040)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nuovo tema verr\00E0 creato nell''applicazione %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588963308307040)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tema esistente nell''applicazione %0 verr\00E0 sostituito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587955148307040)
,p_name=>'F4000.TO'
,p_message_language=>'it'
,p_message_text=>'a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575015747307028)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'it'
,p_message_text=>'Elemento dell''applicazione sconosciuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589225215307041)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna aggiornabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714448557307162)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'it'
,p_message_text=>'Le utility includono le pagine di modifica della griglia e i report su tutte le pagine dell''applicazione selezionata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573883245307027)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218892549306736)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine dati REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206069120307561)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'it'
,p_message_text=>'Origine dati REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572098269307025)
,p_name=>'F4000.YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648149697307100)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'it'
,p_message_text=>'Data MMDDYYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801813488307243)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353922513306842)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'it'
,p_message_text=>'Come applicazione su una tabella di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606924925307057)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'it'
,p_message_text=>'Come un''applicazione nelle tabelle di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618546970307068)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'it'
,p_message_text=>'Questa posizione di pulsante non si trova nel modello di area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354586689307672)
,p_name=>'F4000_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618844133307068)
,p_name=>'F4000_CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635440647307090)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'it'
,p_message_text=>'Copia e sottoscrivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619136562307068)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'it'
,p_message_text=>'Formato di data non riconosciuto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286815411306787)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'it'
,p_message_text=>'Bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718292979307165)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800937734307242)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome o i nomi delle liste di valori %0 esistono gi\00E0. Immettere un nuovo nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642048432307095)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Nessuna selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598398207307049)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'it'
,p_message_text=>'Nessuna applicazione associata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230180446306744)
,p_name=>'F4000_OFF'
,p_message_language=>'it'
,p_message_text=>'Non attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230010551306744)
,p_name=>'F4000_ON'
,p_message_language=>'it'
,p_message_text=>'Attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290436466306790)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'it'
,p_message_text=>'Modelli di calendario che fanno riferimento a questo modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671235261307121)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'it'
,p_message_text=>'visualizza pagine di questo tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399774016306877)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'it'
,p_message_text=>'per questo elemento non esiste la Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391788480306871)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'it'
,p_message_text=>'home autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391660871306871)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modifica questo modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407250592306883)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'it'
,p_message_text=>'Reimposta CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012768908307404)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina esiste gi\00E0 in questa applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287266239306787)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'it'
,p_message_text=>'La pagina deve essere numerica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287314396306787)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'it'
,p_message_text=>'I numeri di pagina devono essere numeri positivi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287449312306787)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'it'
,p_message_text=>'I numeri di pagina devono essere numeri interi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719547041307167)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'it'
,p_message_text=>'Importa schema/i di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669097557307119)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'it'
,p_message_text=>unistr('Importa uno o pi\00F9 schemi di autenticazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719629685307167)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'it'
,p_message_text=>'Importa barra/e di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669119729307119)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'it'
,p_message_text=>'Importa tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617001401307067)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'it'
,p_message_text=>'Form tabulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647801385307100)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'it'
,p_message_text=>'Autenticazione effettuata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647979716307100)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'it'
,p_message_text=>'Autenticazione non riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639741729307093)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Nessuna colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620302888307070)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'it'
,p_message_text=>unistr('Questa applicazione non \00E8 disponibile al momento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369233660306853)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'it'
,p_message_text=>'Data: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369381784306854)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'it'
,p_message_text=>'Data flessibile: %0 con qualsiasi separatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370094674306854)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'it'
,p_message_text=>'Formato di data non riconosciuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369970962306854)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Il formato della data deve essere %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368723236306853)
,p_name=>'F4000_P430_IP'
,p_message_language=>'it'
,p_message_text=>'Indirizzo IP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369573165306854)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'it'
,p_message_text=>'Indirizzo IP non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368863005306853)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'it'
,p_message_text=>'Numero di telefono (USA): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368978265306853)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'it'
,p_message_text=>'Numero di telefono USA flessibile: 999.999.9999, (999)-999-9999, 999 999 9999 ecc...'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369787426306854)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'it'
,p_message_text=>'Formato del numero di telefono non riconosciuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369692748306854)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'it'
,p_message_text=>'Il formato del numero di telefono deve essere %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368663195306853)
,p_name=>'F4000_P430_URL'
,p_message_language=>'it'
,p_message_text=>'URL: http(s)://domain/path/doc.(pdf)(html)(ecc...)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369418764306854)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'it'
,p_message_text=>'URL non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369091680306853)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'it'
,p_message_text=>'Codice postale: 99999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369103304306853)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'it'
,p_message_text=>'CAP + 4: 99999-9999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102369836936306854)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'it'
,p_message_text=>'Il formato del codice postale deve essere %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300113800306797)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300281902306797)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questo schema di autenticazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300473506306797)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Non esiste nessun sottoscrittore per questo schema di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300320539306797)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Schemi con sottoscrizione a questo schema di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355153737306842)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'it'
,p_message_text=>'- nessuno schema -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615648949307065)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Report 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620447461307070)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'it'
,p_message_text=>'Form su stored procedure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615796817307065)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Grafico 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619719201307069)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Sola visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619639762307069)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'it'
,p_message_text=>'Nascosto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619387383307069)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Svuota cache dell''elemento o degli elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619200367307069)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'it'
,p_message_text=>'Svuota cache della pagina o delle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642374430307095)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'it'
,p_message_text=>'Reimposta impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619504963307069)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'it'
,p_message_text=>'Imposta elemento mediante corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619416273307069)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'it'
,p_message_text=>'Assegnazione elementi statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616543196307066)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'it'
,p_message_text=>'Tutti gli elementi di pagina non inseriti nella cache dell''applicazione corrente verranno inizializzati con un valore NULL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620112127307069)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619897973307069)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Elemento NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102619992638307069)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'it'
,p_message_text=>'Elemento diverso da zero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620098014307069)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648325235307100)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'it'
,p_message_text=>'Data DDMMYYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648298219307100)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'it'
,p_message_text=>'Numero di telefono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386644462307696)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'it'
,p_message_text=>'Oggetto database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616757098307066)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'it'
,p_message_text=>'Nel browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616807867307066)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'it'
,p_message_text=>'Calendario 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355325255306843)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'it'
,p_message_text=>'(contenente la colonna Data o Indicatore orario)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835185463307269)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'it'
,p_message_text=>'Sintassi: select id, name, date from ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835487071307269)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'it'
,p_message_text=>'Esempio con pseudo colonna ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835544947307269)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'it'
,p_message_text=>'Esempio con chiave primaria della tabella di origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835219691307269)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'it'
,p_message_text=>'1. Includere almeno due colonne, una delle quali deve essere una colonna DATE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835314310307269)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'it'
,p_message_text=>'2. La prima colonna deve essere quella di chiave primaria da utilizzare per gestire le operazioni DML (Data Manipulation Language).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102616971454307066)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Form 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730040595307176)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'it'
,p_message_text=>'Manifest esportazione componente    '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671106118307121)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'it'
,p_message_text=>'Visualizza definizione di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617155498307067)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Pagina di riepilogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635708758307090)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'it'
,p_message_text=>'fare clic per impostare il set di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889848541307309)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'it'
,p_message_text=>'Il modello di pagina supporta schede a due livelli. Tuttavia, le schede standard non identificano un set di schede padre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889718968307309)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'it'
,p_message_text=>unistr('Nessuna scheda. Questa pagina non visualizzer\00E0 schede.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889542629307309)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'it'
,p_message_text=>'Questa pagina mostra un livello di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889997728307309)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'it'
,p_message_text=>'Pagine senza schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890043488307309)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'it'
,p_message_text=>'Nessuna scheda definita per un totale di %0 pagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889461471307309)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione scheda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889601452307309)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'it'
,p_message_text=>'Questa pagina mostra due livelli di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337376929307659)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Oracle APEX %0 \00E8 disponibile.</strong> L''upgrade dell''istanza verr\00E0 eseguito automaticamente il giorno <strong>%1</strong>. L''amministratore dell''istanza pu\00F2 avviare l''upgrade in qualsiasi momento prima di questa data in Administration Ser')
||'vices.</p>',
'<p>Vedere l''<a href="%2" target="_blank" rel="noreferrer">annuncio</a> per ulteriori informazioni sulle nuove funzioni e sui miglioramenti in Oracle APEX %0.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337226736307659)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'it'
,p_message_text=>unistr('<strong>\00C8 in corso l''upgrade dell''istanza %0 a una release pi\00F9 recente.</strong> Le modifiche alle applicazioni verranno disabilitate per un periodo di tempo durante il processo di upgrade. L''accesso alle applicazioni e all''ambiente di sviluppo %0 ve')
||unistr('rr\00E0 interrotto per al massimo %1 minuti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299084857306796)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299995849306797)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'it'
,p_message_text=>'Rende corrente questo schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300048148306797)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'it'
,p_message_text=>'rendi corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354976707306842)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'it'
,p_message_text=>'corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299766426306797)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'it'
,p_message_text=>'Modifica lo stato in non attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298523741306796)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'it'
,p_message_text=>'Dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298625447306796)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Logica di gestione della sessione incorporata, una pagina di login incorporata e l''autenticazione dell''utente al repository di account "utente cookie" interno.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298789228306796)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'it'
,p_message_text=>unistr('Questo metodo \00E8 stato sostituito dall''autenticazione SCHEME.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352985131306841)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'it'
,p_message_text=>'Modificare gli attributi di autenticazione non validi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353025769306841)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'it'
,p_message_text=>'attributi non validi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353174585306841)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'it'
,p_message_text=>unistr('oppure lasciarli in loco finch\00E9 non si \00E8 pronti a cambiare il metodo di autenticazione in %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353434051306841)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'it'
,p_message_text=>unistr('Specifica uno o pi\00F9 attributi di autenticazione non validi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353681821306841)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'it'
,p_message_text=>'o eseguire la loro migrazione a uno schema di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352668310306841)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299664218306797)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'it'
,p_message_text=>'Gestire gli schemi di autenticazione utilizzando il seguente report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298450192306796)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'it'
,p_message_text=>'Metodo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354884216306842)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'it'
,p_message_text=>'(Non modificabile)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299844498306797)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'it'
,p_message_text=>'(corrente)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352701789306841)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'it'
,p_message_text=>'(non valido)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299594953306796)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'it'
,p_message_text=>'(nessuno)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298914107306796)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'it'
,p_message_text=>'Pagine pubbliche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299160806306796)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'it'
,p_message_text=>'Rivedi o modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299228315306796)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'it'
,p_message_text=>'o modificare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299368955306796)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'it'
,p_message_text=>'gli attributi di gestione della sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102299410485306796)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'it'
,p_message_text=>'di questa applicazione nella pagina degli attributi dell''applicazione oppure utilizzare il report riportato sopra per creare e gestire gli schemi di autenticazione che possono essere utilizzati se si modifica il metodo di autenticazione in %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353292759306841)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Rivedere o modificare gli attributi di gestione della sessione',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353540594306841)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'it'
,p_message_text=>'Rivedere o modificare questi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352893671306841)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'it'
,p_message_text=>unistr('L''autenticazione %0 non \00E8 un metodo valido. Si consiglia di fare clic sul collegamento "Rendi corrente" (visualizzato sopra) in uno degli schemi di autenticazione in questa applicazione oppure di creare un nuovo schema di autenticazione e renderlo co')
||unistr('rrente. Lo schema di autenticazione INTERNAL-SETUP \00E8 funzionalmente equivalente al metodo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102353330153306841)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'it'
,p_message_text=>'Utilizza gli schemi di autenticazione per controllare l''autenticazione degli utenti e tutti gli altri aspetti della gestione delle sessioni per l''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617447602307067)
,p_name=>'F4000_P805_X'
,p_message_language=>'it'
,p_message_text=>unistr('Nel passo precedente \00E8 stata specificata una funzione sentry di pagina, responsabile della verifica delle sessioni su ogni pagina. Non \00E8 quindi possibile immettere qui una funzione di verifica delle sessioni. \00C8 possibile tornare indietro nella proced')
||'ura guidata per apportare le necessarie modifiche.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355981358306843)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'it'
,p_message_text=>'Pagina di login incorporata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356358007306843)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356085401306843)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'it'
,p_message_text=>'Pagina in questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356260993306843)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'it'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356183890306843)
,p_name=>'F4000_P806_URL'
,p_message_language=>'it'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356403444306843)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'it'
,p_message_text=>'Utilizzare nome utente e password dell''account %0 per eseguire l''autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242253715306754)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'it'
,p_message_text=>'Utilizzare nome utente e password dell''account di database per eseguire l''autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356530586306844)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'it'
,p_message_text=>'Non verificare le credenziali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356747028306844)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Utilizzare la funzione personalizzata per eseguire l''autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356685032306844)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'it'
,p_message_text=>'Utilizzare un server LDAP per eseguire l''autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620570498307070)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'- Nessun nome pagina -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301143921306798)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Funzione di autenticazione',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301968948306798)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'it'
,p_message_text=>'Dominio cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301765486306798)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301839480306798)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'it'
,p_message_text=>'Percorso cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239301596306751)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'it'
,p_message_text=>'Sicuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300969360306797)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'it'
,p_message_text=>'Destinazione di sessione non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301408574306798)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'it'
,p_message_text=>'Base di ricerca LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301570400306798)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica nome utente LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301215432306798)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'it'
,p_message_text=>'Host LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301332559306798)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'it'
,p_message_text=>'Porta LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302024003306798)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'it'
,p_message_text=>'URL di logout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300664886306797)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300545386306797)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'it'
,p_message_text=>'(Incorporato)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302131565306798)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'it'
,p_message_text=>'(Autenticazione del database)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300703282306797)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'it'
,p_message_text=>'Funzione sentry di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301661222306798)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'it'
,p_message_text=>'Processo di post-autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102301058903306798)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'it'
,p_message_text=>'Processo di pre-autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102300873669306797)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'it'
,p_message_text=>'Funzione di verifica delle sessioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356964548306844)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'it'
,p_message_text=>'Come copia di uno schema di autenticazione esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357047716306844)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'it'
,p_message_text=>'Basato su uno schema preconfigurato dalla galleria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102356812717306844)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'it'
,p_message_text=>'Basato su uno schema preconfigurato dalla galleria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314724948306808)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''aggiornamento degli schemi di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302352856306799)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'it'
,p_message_text=>'Metodo di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370135724306854)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'it'
,p_message_text=>'Avvertenza: si sta per eliminare lo schema di autenticazione corrente da questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302542852306799)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302269856306798)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'it'
,p_message_text=>'ID applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302475023306799)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357589691306844)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'it'
,p_message_text=>'Oracle Application Server Single Sign-On (applicazione personale come applicazione partner)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357178722306844)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'it'
,p_message_text=>'Mostra pagina di login e usa credenziali account %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357221662306844)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'it'
,p_message_text=>'Mostra pagina di login incorporata e usa credenziali "open door"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357355383306844)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'it'
,p_message_text=>'Mostra pagina di login e usa credenziali directory LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357459149306844)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'it'
,p_message_text=>'Oracle Application Server Single Sign-On (motore di %0 come applicazione partner)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302841731306799)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'it'
,p_message_text=>'Metodo di autenticazione corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314893344306808)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'it'
,p_message_text=>'Single Sign-On (solo uso Oracle)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314930397306808)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'it'
,p_message_text=>'Oracle Application Server Single Sign-On (%0 come applicazione partner)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315072333306808)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'it'
,p_message_text=>'Oracle Application Server Single Sign-On (applicazione personale come applicazione partner)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315137300306808)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'it'
,p_message_text=>'Pagina di login incorporata: usa credenziali account %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337683239306829)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'it'
,p_message_text=>'Nuova pagina di login creata: usa credenziali account %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337793085306829)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'it'
,p_message_text=>'Pagina di login esistente: usa credenziali account %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315290713306808)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'it'
,p_message_text=>'Pagina di login incorporata: credenziali "open door"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315333777306808)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'it'
,p_message_text=>'Pagina di login incorporata: usa credenziali directory LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337402439306829)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'it'
,p_message_text=>'Nuova pagina di login creata: usa credenziali directory LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337564880306829)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'it'
,p_message_text=>'Pagina di login esistente: usa credenziali directory LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315423215306808)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'it'
,p_message_text=>'Basato sullo schema di autenticazione della galleria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102357652275306844)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'it'
,p_message_text=>'Nuovo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394397881306873)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'it'
,p_message_text=>unistr('La funzione di annullamento di %0 utilizza una funzione di database incorporata denominata "Flashback query", che consente di eseguire query sui dati cos\00EC come si presentavano in un determinato momento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394125503306873)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''ora a cui si desidera tornare, quindi fare clic su "Applica" per riscrivere l''origine nella pagina di modifica dell''area e chiudere questa finestra di dialogo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394578572306873)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'it'
,p_message_text=>unistr('In base al parametro del database "UNDO_RETENTION", \00E8 possibile annullare solo le modifiche apportate nell''ultima o nelle ultime %0 ore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395057044306874)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'it'
,p_message_text=>'Conferma creazione scheda standard nell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395435095306874)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('Un nuovo set di schede %0 verr\00E0 creato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395334030306874)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina %0 utilizzer\00E0 il set di schede "%1" esistente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395178604306874)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'it'
,p_message_text=>'Avvertenza: informazioni sul set di schede incomplete.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836813228307270)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'it'
,p_message_text=>'Valore per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618952085307068)
,p_name=>'F4000_PREV'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607216376307057)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'it'
,p_message_text=>'Fare clic su <strong>Fine</strong> per creare o estendere l''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607070167307057)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'it'
,p_message_text=>'Includi supporti di navigazione basati su indicatori di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607154304307057)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'it'
,p_message_text=>'Nascondi chiave primaria nella pagina di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752788732307197)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'it'
,p_message_text=>'Scorciatoia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513340785306968)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618669022307068)
,p_name=>'F4000_TOP'
,p_message_language=>'it'
,p_message_text=>'Inizio pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718381194307165)
,p_name=>'F4000_TREE'
,p_message_language=>'it'
,p_message_text=>'Struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833726417307268)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270610176306775)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'it'
,p_message_text=>'Documento con risposta completa'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280699112306782)
,p_name=>'F400_P107_STEP'
,p_message_language=>'it'
,p_message_text=>'Passo %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251353980306761)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'it'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102835043701307269)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'it'
,p_message_text=>'Accettato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705046792307153)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema verr\00E0 assegnato all''area di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705161395307153)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema non verr\00E0 assegnato all''area di lavoro per i seguenti motivi:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704659928307153)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema aggiuntivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599833583307050)
,p_name=>'F4050.ADJUST'
,p_message_language=>'it'
,p_message_text=>'Adegua'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599128192307050)
,p_name=>'F4050.ALL'
,p_message_language=>'it'
,p_message_text=>'Tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834572954307269)
,p_name=>'F4050.APPROVED'
,p_message_language=>'it'
,p_message_text=>'Approvato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255134692306763)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta per un''area di lavoro \00E8 stata approvata e le credenziali sono state inviate all''indirizzo di posta elettronica fornito durante la registrazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673252862307123)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di un account \00E8 stata approvata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673199154307123)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'it'
,p_message_text=>'Approvata: richiesta di account per %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673668520307124)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di ulteriori %0 megabyte di memoria nell''area di lavoro %1 \00E8 stata approvata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834202837307268)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'it'
,p_message_text=>'Assegnato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345569487307665)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834153594307268)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Disponibili'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425766468307729)
,p_name=>'F4050.BROKEN'
,p_message_language=>'it'
,p_message_text=>'Interrotto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426144812307729)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'it'
,p_message_text=>'Concatenazione bloccata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674069978307124)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Richiesta di modifica approvata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674198568307124)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Richiesta di modifica rifiutata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425632151307729)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'it'
,p_message_text=>'Completato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704756057307153)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema verr\00E0 creato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834657273307269)
,p_name=>'F4050.DECLINED'
,p_message_language=>'it'
,p_message_text=>'Rifiutato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673591528307124)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'it'
,p_message_text=>'Rifiutata: richiesta di account per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673980506307124)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di ulteriori %0 megabyte di memoria nell''area di lavoro %1 \00E8 stata rifiutata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673738272307124)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta per lo schema di database %0 nell''area di lavoro %1 \00E8 stata rifiutata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673878993307124)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di arrestare il servizio per l''area di lavoro %0 \00E8 stata rifiutata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425333364307729)
,p_name=>'F4050.DISABLED'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251215826306760)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fare clic sul collegamento sottostante per completare il processo di approvazione. Al termine, si riceveranno le credenziali dell''area di lavoro in un messaggio di posta elettronica di follow-up.',
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673412353307124)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fare clic sul collegamento sottostante per iniziare.',
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425854885307729)
,p_name=>'F4050.FAILED'
,p_message_language=>'it'
,p_message_text=>'Non riuscito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278921861306781)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'it'
,p_message_text=>'Fare clic <a href=''%0''>qui</a> per completare il processo di approvazione e ricevere le credenziali.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589414536307041)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'it'
,p_message_text=>'Informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600651432307051)
,p_name=>'F4050.INSTALL'
,p_message_language=>'it'
,p_message_text=>'Installa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834742879307269)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'In corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599416302307050)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617516204307067)
,p_name=>'F4050.P23.USE'
,p_message_language=>'it'
,p_message_text=>'Usa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428889054307731)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'it'
,p_message_text=>'Controllo aggiornamenti disabilitato per l''intera istanza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617607574307067)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'it'
,p_message_text=>'Apri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704565887307153)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599777612307050)
,p_name=>'F4050.PROVISION'
,p_message_language=>'it'
,p_message_text=>'Fornitura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672998944307123)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'it'
,p_message_text=>'Richiesta di modifica approvata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672890291307123)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta per lo schema di database %0 nell''area di lavoro %1 \00E8 stata approvata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425957283307729)
,p_name=>'F4050.REMOTE'
,p_message_language=>'it'
,p_message_text=>'Remoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834879084307269)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'it'
,p_message_text=>'Richiesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598919723307050)
,p_name=>'F4050.RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673093104307123)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'it'
,p_message_text=>unistr('Avvertenza: lo schema richiesto \00E8 limitato in quanto \00E8 uno schema predefinito Oracle o a causa dei criteri specifici del sito. Impossibile assegnare schemi limitati alle aree di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425420306307729)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'it'
,p_message_text=>'Nuovi tentativi pianificati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704956642307153)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema esistente verr\00E0 riutilizzato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425521568307729)
,p_name=>'F4050.RUNNING'
,p_message_language=>'it'
,p_message_text=>'In esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425264976307728)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'it'
,p_message_text=>'Pianificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672676865307123)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'it'
,p_message_text=>unistr('Avvertenza: lo schema richiesto \00E8 gi\00E0 assegnato a una o pi\00F9 aree di lavoro. Prima di approvare questa richiesta, assicurarsi che l''accesso di pi\00F9 aree di lavoro allo stesso schema sia consentito dai criteri di sicurezza del sito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672598255307123)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Avvertenza: lo schema richiesto esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705232172307153)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Lo schema non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705470258307154)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema \00E8 riservato e non pu\00F2 essere assegnato alle aree di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672726483307123)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'it'
,p_message_text=>unistr('Avvertenza: lo schema richiesto \00E8 limitato in quanto si tratta di uno schema predefinito Oracle o a causa dei criteri specifici del sito. Se si assegna questo schema all''area di lavoro continuando con l''operazione, gli sviluppatori dell''area di lavor')
||'o specifica avranno accesso completo allo schema. Prima di approvare questa richiesta, assicurarsi che tale azione sia coerente con i criteri di sicurezza del sito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705351794307153)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema \00E8 limitato da criteri di sicurezza. Impossibile assegnare schemi limitati alle aree di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674289010307124)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Servizio arrestato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674349131307124)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'it'
,p_message_text=>unistr('Il servizio di sviluppo "%0" \00E8 stato arrestato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426016979307729)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'it'
,p_message_text=>'Operazione riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834300657307268)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'it'
,p_message_text=>'Sospeso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834487679307269)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'it'
,p_message_text=>'Termina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834996704307269)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'it'
,p_message_text=>'Cessato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425171933307728)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'Cessazione in corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600005073307051)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'it'
,p_message_text=>'Visualizza richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600401772307051)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'it'
,p_message_text=>'Esportazione area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366416534306851)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'it'
,p_message_text=>'Home area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366579216306851)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'it'
,p_message_text=>'Login ad area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670295988307120)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro non verr\00E0 creata. Esiste gi\00E0 un''area di lavoro con lo stesso ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670153443307120)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile creare l''area di lavoro. Esiste gi\00E0 un''area di lavoro con lo stesso nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443062282306913)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro %0 \00E8 stata creata il %1 e la conferma \00E8 stata inviata all''indirizzo di posta elettronica fornito al momento della registrazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272227167306776)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro non verr\00E0 creata perch\00E9 esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272391017306776)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro verr\00E0 creata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507477160306963)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Nuova password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507326026306963)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'it'
,p_message_text=>'Password dell''account modificata per l''utente %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507248377306963)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'it'
,p_message_text=>unistr('La password \00E8 stata modificata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390338970307699)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina controlla se l''upgrade di %0 verr\00E0 eseguito immediatamente una volta disponibile la release successiva o se verr\00E0 differito per un periodo fino a %1 giorni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390419144307699)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'it'
,p_message_text=>'Fare clic su Esegui upgrade adesso per avviare l''upgrade ora e non il giorno %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390037817307698)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'it'
,p_message_text=>unistr('Il sistema \00E8 aggiornato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390147642307698)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('%0 %1 \00E8 <a href="%2" target="_blank" rel="noreferrer">disponibile</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389187778307698)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'it'
,p_message_text=>unistr('Una volta disponibile una nuova release %0, l''upgrade dell''istanza verr\00E0 eseguito <strong>immediatamente</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389806884307698)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'it'
,p_message_text=>unistr('L''upgrade dell''istanza verr\00E0 eseguito immediatamente nel seguente periodo: <strong>%0</strong>. Fare clic sull''icona dell''ingranaggio per eseguire l''upgrade adesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389044546307697)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'it'
,p_message_text=>'%0 upgrade dell''istanza sono stati <strong>differiti</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931034574307343)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 in corso l''upgrade di %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259171218306766)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente di database %0 \00E8 stato creato con tablespace predefinita %1 che utilizza il file di dati %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275958243306779)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro %0 fornita con amministratore %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407707752306884)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'it'
,p_message_text=>'Mostra tutte le aree di lavoro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399019841306877)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('La lunghezza della colonna non pu\00F2 essere nulla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398939830306877)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'it'
,p_message_text=>unistr('La lunghezza della colonna non pu\00F2 essere zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399298319306877)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'it'
,p_message_text=>'I nomi di colonna non possono superare %0 caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399367109306877)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'I nomi di colonna non possono essere nulli.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399838902306877)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'it'
,p_message_text=>unistr('<strong>%0</strong> gi\00E0 utilizzato da un oggetto esistente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400017574306877)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('<strong>%0</strong> non \00E8 un nome di sequenza valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398678554306876)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome della tabella esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399672452306877)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('<strong>%0</strong> non \00E8 un nome di chiave primaria valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617732145307067)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'it'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102588716993307040)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'it'
,p_message_text=>'Importazione foglio di calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399521371306877)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'it'
,p_message_text=>'I nomi di tabella devono avere una lunghezza inferiore a %0 caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410284661306886)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'it'
,p_message_text=>'La prima riga contiene nomi di colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736068251307182)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'it'
,p_message_text=>'Importazione testo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436028355306907)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598706573307049)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'(disponibile)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598541916307049)
,p_name=>'F4350.CHANGE'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773644356307217)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'it'
,p_message_text=>'Si sta chiedendo di assegnare lo schema esistente %0 alla propria area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773772141307217)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'it'
,p_message_text=>'Si sta chiedendo di creare e assegnare lo schema %0 alla propria area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598272504307049)
,p_name=>'F4350.CREATE'
,p_message_language=>'it'
,p_message_text=>'Crea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442145121306912)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Creazione area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598699203307049)
,p_name=>'F4350.CURRENT'
,p_message_language=>'it'
,p_message_text=>'(corrente)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436599028306907)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'it'
,p_message_text=>'Ora corrente (sul server)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436359071306907)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'it'
,p_message_text=>'Utente corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598431569307049)
,p_name=>'F4350.DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443242454306913)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'it'
,p_message_text=>unistr('La creazione delle aree di lavoro \00E8 stata disabilitata temporaneamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435940267306907)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema host'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597964485307049)
,p_name=>'F4350.INSERTED'
,p_message_language=>'it'
,p_message_text=>'Inserito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436489436306907)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'it'
,p_message_text=>'Preferenza lingua'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435865858306907)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'it'
,p_message_text=>'Ora ultima DDL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919637894307335)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'it'
,p_message_text=>'Ora ultima patch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242735820306754)
,p_name=>'F4350.MORE'
,p_message_language=>'it'
,p_message_text=>'%0 altro...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919570554307334)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'it'
,p_message_text=>'Versione patch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435640649306907)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'it'
,p_message_text=>'Build prodotto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967486177307370)
,p_name=>'F4350.RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435772829306907)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'it'
,p_message_text=>unistr('Compatibilit\00E0 schema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242636917306754)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'(+%0 applicazioni tradotte)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598163270307049)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'it'
,p_message_text=>'Sconosciuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598015573307049)
,p_name=>'F4350.UPDATED'
,p_message_language=>'it'
,p_message_text=>'Aggiornato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436194779306907)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'it'
,p_message_text=>'ID area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436255622306907)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144362425307503)
,p_name=>'F4350_AJAX'
,p_message_language=>'it'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144256155307503)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'it'
,p_message_text=>'Callback di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599660160307050)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci di log dei clic:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599504148307050)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'it'
,p_message_text=>unistr('Voci di log di attivit\00E0 dello sviluppatore:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600142854307051)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti distinti in tutte le sessioni = %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600508408307051)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'it'
,p_message_text=>'nessun utente selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600869770307051)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'it'
,p_message_text=>'Esistono %0 preferenze per %1 utenti nell''area di lavoro "%2"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217008311306735)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'it'
,p_message_text=>'Esistono %0 preferenze per %1 utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599349492307050)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'it'
,p_message_text=>'Reimpostare le preferenze se si desidera eseguire l''applicazione senza valori preimpostati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274082947306778)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'it'
,p_message_text=>'Reimpostare lo stato di sessione per eseguire l''applicazione senza valori preimpostati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600941613307052)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'it'
,p_message_text=>'Utente selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600236898307051)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'it'
,p_message_text=>unistr('Sessioni pi\00F9 vecchie di %0 giorno/i = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600332158307051)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'it'
,p_message_text=>unistr('Sessioni pi\00F9 vecchie di %0 minuto/i = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102598804911307050)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'it'
,p_message_text=>unistr('La sessione \00E8 identificata da %0 e contiene %1 voci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601586193307052)
,p_name=>'F4350_SQL'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102600799185307051)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Riepilogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599919758307051)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'it'
,p_message_text=>unistr('Il totale delle sessioni per area di lavoro "%0" \00E8 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216918867306735)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'it'
,p_message_text=>'Sessioni totali: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601087361307052)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'it'
,p_message_text=>'L''utente %0 ha %1 preferenze.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102599257127307050)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'it'
,p_message_text=>'Per l''utente corrente %0 sono state impostate %1 preferenze.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102601181216307052)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'it'
,p_message_text=>'Schemi area di lavoro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603627748307054)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'it'
,p_message_text=>'La sequenza di visualizzazione nei form deve essere numerica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603750103307054)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'it'
,p_message_text=>'La sequenza di visualizzazione nei report deve essere numerica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407195600306883)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome dell''argomento <strong>%0</strong> \00E8 utilizzato pi\00F9 di una volta in questa funzione.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606770455307057)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'it'
,p_message_text=>'L''ordine di esecuzione deve essere specificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102606610380307057)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'it'
,p_message_text=>'L''ordine di esecuzione deve essere numerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589531676307041)
,p_name=>'F4500.FIND'
,p_message_language=>'it'
,p_message_text=>'Trova'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617994484307067)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'it'
,p_message_text=>'Nascondi SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589956177307041)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'it'
,p_message_text=>'Ingrandisci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589898994307041)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'it'
,p_message_text=>'Sposta colonna in basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589748224307041)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'it'
,p_message_text=>'Sposta colonna in alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400834005306878)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'it'
,p_message_text=>'Immettere un numero di ordine di esecuzione univoco.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202019615306723)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Nuove colonne da aggiungere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400447918306878)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('<strong>%0</strong> non \00E8 un nome di oggetto valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400235334306878)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('<strong>%0</strong> non \00E8 un nome di tabella valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102589698998307041)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'it'
,p_message_text=>'Nessuna immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590020323307042)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'it'
,p_message_text=>'Annullabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703343170307152)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'it'
,p_message_text=>'Esecuzioni precedenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406608473306883)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('I nomi di colonna <strong>%0</strong> sono utilizzati pi\00F9 di una volta in questa tabella.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407085614306883)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome di almeno una colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406992768306883)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome di colonna <strong>%0</strong> non \00E8 valido.<br />')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406736970306883)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'it'
,p_message_text=>unistr('La precisione per la colonna <strong>%0</strong> non \00E8 valida.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406884995306883)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'it'
,p_message_text=>unistr('La scala per la colonna <strong>%0</strong> non \00E8 valida.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257152905306765)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('La scala per la colonna <strong>%0</strong> \00E8 obbligatoria.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102618046043307067)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'it'
,p_message_text=>'Crea sinonimo su'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617811807307067)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'it'
,p_message_text=>'Mostra SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400541958306878)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Tabella <strong>%0</strong> non trovata nello schema <strong>%1</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206185690306726)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'it'
,p_message_text=>'Istruzioni di avvertenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602730050307053)
,p_name=>'F4500_BROKEN'
,p_message_language=>'it'
,p_message_text=>'Interrotto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603286469307054)
,p_name=>'F4500_BYTES'
,p_message_language=>'it'
,p_message_text=>'Byte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603186496307054)
,p_name=>'F4500_CARD'
,p_message_language=>'it'
,p_message_text=>unistr('Cardinalit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602584695307053)
,p_name=>'F4500_CHECK'
,p_message_language=>'it'
,p_message_text=>'Check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595029818307046)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'it'
,p_message_text=>'Fare clic per popolare il campo della query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603029034307053)
,p_name=>'F4500_COST'
,p_message_language=>'it'
,p_message_text=>'Costo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594302737307045)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione di creazione riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372473768307685)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti senza valori predefiniti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372303413307685)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti con valori predefiniti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593664198307045)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione di eliminazione riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246105746306757)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'it'
,p_message_text=>'Esterno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507675212306964)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'it'
,p_message_text=>'Chiave esterna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407498552306883)
,p_name=>'F4500_NATIVE'
,p_message_language=>'it'
,p_message_text=>'Formato di file nativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593326206307044)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'it'
,p_message_text=>'non disponibile per la modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602838998307053)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'it'
,p_message_text=>'non disponibile per la ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602693282307053)
,p_name=>'F4500_OF'
,p_message_language=>'it'
,p_message_text=>'Di'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602942451307053)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'it'
,p_message_text=>'Optimizer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595343629307046)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583050943307035)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Nessun messaggio area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735924162307182)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'it'
,p_message_text=>'non esistono tipi di colonna VARCHAR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280371824306782)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'it'
,p_message_text=>'Analisi dello script in corso. Attendere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227028896306742)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'it'
,p_message_text=>'Numero di istruzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468807325306934)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'it'
,p_message_text=>'il %0 da %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590700997307042)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'it'
,p_message_text=>'Se nello script sono presenti parametri, definirli prima dell''esecuzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226907486306742)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468782940306933)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione script in byte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465067556306931)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'it'
,p_message_text=>'Autore aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590950090307042)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749645028307195)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di importare lo script o gli script riportati di seguito. Confermare la richiesta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749726798307195)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'it'
,p_message_text=>'Lo script o gli script richiesti per l''importazione superano la memoria massima consentita. Contattare l''amministratore %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750741380307196)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'it'
,p_message_text=>'Script da importare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591476577307043)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'it'
,p_message_text=>'Nessun errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591226495307043)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'it'
,p_message_text=>'Numero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571118811307024)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Visualizza output'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652079586307104)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'it'
,p_message_text=>'Sfoglia sequenze'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652123244307104)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'it'
,p_message_text=>unistr('L''operazione di creazione sequenza non \00E8 riuscita per il seguente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651927080307104)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('La sequenza "%0" \00E8 stata creata nello schema "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591683852307043)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'it'
,p_message_text=>'Istruzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652488056307104)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'it'
,p_message_text=>'Sfoglia sinonimi di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652696799307104)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'it'
,p_message_text=>unistr('L''operazione di creazione sinonimo non \00E8 riuscita per il seguente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652318676307104)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'it'
,p_message_text=>unistr('Il sinonimo "%0" \00E8 stato creato nello schema "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652748398307104)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'it'
,p_message_text=>unistr('L''operazione di creazione package non \00E8 riuscita per il seguente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652853172307104)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('Il package "%0" \00E8 stato creato nello schema "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434479902306906)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'it'
,p_message_text=>'Salva su foglio di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591926370307043)
,p_name=>'F4500_P25_BY'
,p_message_language=>'it'
,p_message_text=>'Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591833582307043)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'it'
,p_message_text=>'Data creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591704423307043)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247892967306758)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'it'
,p_message_text=>'Scaduto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247995213306758)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'it'
,p_message_text=>'Scaduto e bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247741051306758)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'it'
,p_message_text=>'Bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247685839306758)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'it'
,p_message_text=>'Apri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651837609307103)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'it'
,p_message_text=>unistr('L''operazione non \00E8 riuscita per il seguente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628924334307085)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'it'
,p_message_text=>'non disponibile per inserimento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651741387307103)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'it'
,p_message_text=>'Sfoglia vista di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651433396307103)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'it'
,p_message_text=>unistr('L''operazione di creazione vista non \00E8 riuscita per il seguente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651593419307103)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'it'
,p_message_text=>'Home di SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651695766307103)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('La vista "%0" \00E8 stata creata nello schema "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620258820307069)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'it'
,p_message_text=>'Recupera commento di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777887013307221)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'it'
,p_message_text=>unistr('Identit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278888570306781)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'it'
,p_message_text=>'Nessun tipo di dati specificato per %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593484452307045)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione di tabella riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590536287307042)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'it'
,p_message_text=>'Questo file contiene %0 istruzioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590665161307042)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'it'
,p_message_text=>'L''utente ha definito il seguente o i seguenti %0 parametri:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407699419306883)
,p_name=>'F4500_PARSE'
,p_message_language=>'it'
,p_message_text=>'Analizzare questo script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602325622307053)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'it'
,p_message_text=>'Chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211244121306730)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'it'
,p_message_text=>'Referenziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407510043306883)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Visualizzare il documento in formato di solo testo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102602431200307053)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'it'
,p_message_text=>unistr('Univocit\00E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451819184307750)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'it'
,p_message_text=>'Esistono alcuni problemi con la configurazione dei file statici nell''ambiente. Consultare la sezione "Configuring Static File Support" nel documento Application Express Installation Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795234978307237)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'it'
,p_message_text=>'Benvenuti in Oracle APEX! Collegarsi utilizzando la password amministratore (ADMIN) di Autonomous Database.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447912570307746)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'it'
,p_message_text=>unistr('Si riceve questo messaggio di posta elettronica poich\00E9 \00E8 stata richiesta un''area di lavoro Oracle APEX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447881672307746)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'it'
,p_message_text=>'Azione obbligatoria: richiesta di account per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671506261307122)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'it'
,p_message_text=>'(utilizzata per l''invio delle credenziali tramite posta elettronica)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671743449307122)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'it'
,p_message_text=>'Immettere uno schema di database che attualmente esiste nel proprio database Oracle. Per motivi di sicurezza non viene fornita una lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671631251307122)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome dello schema del database Oracle da creare per l''area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670905581307121)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Nella descrizione riportata di seguito, spiegare il motivo della richiesta di uno schema limitato.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671050971307121)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'it'
,p_message_text=>unistr('Nella descrizione riportata di seguito, spiegare il motivo della richiesta di uno schema gi\00E0 utilizzato da una o pi\00F9 aree di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671407007307122)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'it'
,p_message_text=>unistr('Avvertenza: lo schema richiesto \00E8 limitato per motivi di sicurezza. L''amministratore %0 pu\00F2 rifiutare la richiesta di assegnare questo schema all''area di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671359134307122)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'it'
,p_message_text=>unistr('Avvertenza: lo schema richiesto \00E8 gi\00E0 utilizzato da una o pi\00F9 aree di lavoro. L''amministratore %0 pu\00F2 rifiutare la richiesta di assegnare questo schema all''area di lavoro. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668300860307119)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'it'
,p_message_text=>unistr('Il nuovo schema richiesto per l''area di lavoro \00E8 uno schema predefinito Oracle o potrebbe essere espressamente limitato al proprio sito per motivi di sicurezza e quindi non idoneo per l''assegnazione a un''area di lavoro. L''amministratore del sito pu\00F2 ')
||'rifiutare la richiesta di fornitura se viola un criterio di sicurezza del sito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668225758307119)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema richiesto per l''area di lavoro \00E8 gi\00E0 stato assegnato a %0 area o aree di lavoro. L''amministratore del sito pu\00F2 rifiutare la richiesta di fornitura se viola un criterio di sicurezza del sito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243519201306755)
,p_name=>'F4700P1_A'
,p_message_language=>'it'
,p_message_text=>'Oracle APEX fornisce l''accesso a un database Oracle e a strumenti di sviluppo basati sul browser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243641269306755)
,p_name=>'F4700P1_B'
,p_message_language=>'it'
,p_message_text=>'Applicazioni Web create in modo dichiarativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243740507306755)
,p_name=>'F4700P1_C'
,p_message_language=>'it'
,p_message_text=>'Crea e gestisce oggetti di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243850258306755)
,p_name=>'F4700P1_D'
,p_message_language=>'it'
,p_message_text=>unistr('Tiene traccia di milestone, bug, funzioni e attivit\00E0<')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382316332307692)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'it'
,p_message_text=>unistr('Installazione dell''applicazione riuscita. Se tuttavia si desidera eseguirla con l''autenticazione Account di Application Express, sar\00E0 necessario impostare un account utente Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382451914307693)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'it'
,p_message_text=>unistr('Installazione del Websheet riuscita. Se tuttavia si desidera eseguirlo con l''autenticazione Account di Application Express, sar\00E0 necessario impostare un amministratore con account Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736197298307182)
,p_name=>'F4750.VERSION'
,p_message_language=>'it'
,p_message_text=>'Versione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406466729307714)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Impossibile reimpostare i dati dei servizi RESTful di esempio: lo schema <code>%0</code> non esiste.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981273937307380)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Questa applicazione usa uno schema di autenticazione %0.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015615339307406)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Ricerca con facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989064026307386)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'it'
,p_message_text=>unistr('La procedura guidata non \00E8 in grado di creare una ricerca con facet utilizzando l''origine del report. Non vi sono colonne in cui eseguire la ricerca.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800829172307242)
,p_name=>'FAILURE'
,p_message_language=>'it'
,p_message_text=>'operazione non riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592141429307043)
,p_name=>'FAILURES'
,p_message_language=>'it'
,p_message_text=>'Errori'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666551146307117)
,p_name=>'FDASH1'
,p_message_language=>'it'
,p_message_text=>'%0 funzioni'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708037715307156)
,p_name=>'FEATURE'
,p_message_language=>'it'
,p_message_text=>'Funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426892468307730)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'it'
,p_message_text=>'Proprietari di funzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380566089306862)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina delle informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381249238306863)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Pagina Informazioni sull''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380668377306862)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'it'
,p_message_text=>'Controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381387409306863)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Incorpora un ruolo basato sull''autenticazione utente nell''applicazione e consente di gestire i mapping dei nomi utente ai ruoli applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380757149306862)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'it'
,p_message_text=>unistr('Generazione report su attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381404834306863)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('Include numerosi report e grafici sull''attivit\00E0 dell''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380867561306862)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di configurazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382230254306864)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('Consente agli amministratori dell''applicazione di abilitare o disabilitare le funzionalit\00E0 specifiche associate a un''opzione di creazione di Application Express dall''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680316608307130)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'it'
,p_message_text=>'Verranno create le opzioni di creazione seguenti:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741033312307186)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'it'
,p_message_text=>'Generazione report di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741125924307187)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'it'
,p_message_text=>'Include un report sulla coda di posta elettronica APEX_SEND().'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797786569307239)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('Include un report che visualizza il messaggio di posta elettronica da inviare con il log dei messaggi di posta elettronica gi\00E0 inviati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102380976290306863)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381524387306863)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Fornisce un meccanismo per gli utenti finali in modo che possano inviare i propri commenti agli amministratori e agli sviluppatori delle applicazioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741253961307187)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'it'
,p_message_text=>'Generazione report su job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741344111307187)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('Include un report sui job del database, con la possibilit\00E0 di eseguire il drill-down di un job specifico per visualizzare dettagli aggiuntivi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102381018295306863)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'it'
,p_message_text=>'Selezione stile tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102382168344306863)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Consente agli amministratori di selezionare una combinazione di colori predefinita (stile tema) per l''applicazione. Gli amministratori possono inoltre decidere di autorizzare gli utenti finali a scegliere uno stile di tema personalizzato. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688225418307137)
,p_name=>'FEATURES'
,p_message_language=>'it'
,p_message_text=>'Funzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996339750307391)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'it'
,p_message_text=>'100% delle funzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745492408307191)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'it'
,p_message_text=>'100% delle funzioni (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710668993307158)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'it'
,p_message_text=>'Funzioni 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238615878306751)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'it'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237414661306750)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Funzioni completate (%0 / %1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238500532306751)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'it'
,p_message_text=>'%0 completato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998876246307393)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'it'
,p_message_text=>'Funzioni per la release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745643061307191)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'it'
,p_message_text=>'Scadute (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014958993307406)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Percentuale funzioni completate funzionalmente (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745556784307191)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'it'
,p_message_text=>'Con date (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777769910307221)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Configurazione funzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683715832307133)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'it'
,p_message_text=>'Collaboratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745326278307191)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio funzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992327483307388)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'it'
,p_message_text=>'%0 funzione/i, %1 interamente completata/e, in %2 release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992489445307388)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'it'
,p_message_text=>'%0 funzioni di livello superiore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992587342307388)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'it'
,p_message_text=>'%0 senza data di scadenza, %1 scaduta/e e < 80% completate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992665665307388)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'it'
,p_message_text=>'%0 funzione/i completata/e funzionalmente, %1 no'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996070530307391)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'it'
,p_message_text=>'%0% delle funzioni completato al 100%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682004457307132)
,p_name=>'FEATURE_DESC'
,p_message_language=>'it'
,p_message_text=>'Descrizione funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683007407307132)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'it'
,p_message_text=>unistr('Desiderabilit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413983283307720)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Funzione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681665756307131)
,p_name=>'FEATURE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681788721307131)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682701867307132)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'it'
,p_message_text=>unistr('Priorit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682810234307132)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682699956307132)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'it'
,p_message_text=>'Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426917383307730)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'it'
,p_message_text=>'Non assegnato/i'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429340782307732)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'it'
,p_message_text=>'%0 registrato e assegnato a %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707966300307156)
,p_name=>'FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723527225307170)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'it'
,p_message_text=>'Fornire le informazioni da registrare come feedback.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794062210307236)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'it'
,p_message_text=>'Dashboard feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687888076307137)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci di feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237734217306750)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'it'
,p_message_text=>'%2 voci di feedback aperte (%0 chiuse)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723371741307170)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il feedback e fare clic sul pulsante Sottometti feedback.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015208663307406)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'it'
,p_message_text=>'Percentuale chiusura feedback (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718519011307166)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723421348307170)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'it'
,p_message_text=>'Identificare il tipo di feedback che si sta fornendo.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886204779307307)
,p_name=>'FILENAME'
,p_message_language=>'it'
,p_message_text=>'Nome file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690980857307140)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna nome file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933606722307345)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'it'
,p_message_text=>'Nome file: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689445982307139)
,p_name=>'FILES'
,p_message_language=>'it'
,p_message_text=>'File'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368920896307682)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'it'
,p_message_text=>'%0 file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688912803307138)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'it'
,p_message_text=>'%0 file, consumo di %1K'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413775299307720)
,p_name=>'FILE_LABEL'
,p_message_language=>'it'
,p_message_text=>'File: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102216643011306734)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'it'
,p_message_text=>unistr('Questo file di testo \00E8 troppo grande per essere modificato. Per cambiare il contenuto occorre modificare il file sul computer locale e caricarlo di nuovo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251094907306760)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Non esistono sessioni valide. Uno o pi\00F9 file caricati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250993353306760)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('In questa richiesta \00E8 stato caricato un numero di file superiore al numero dei tipi di elemento file definiti nella pagina.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102741489150307187)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Trova area di lavoro personale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222052170306738)
,p_name=>'FIND_TABLES'
,p_message_language=>'it'
,p_message_text=>'Trova tabelle'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449166825307747)
,p_name=>'FINISH'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594022025307045)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Prima voce'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747145575307192)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'it'
,p_message_text=>'Data Correggi entro scaduta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663536139307114)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'it'
,p_message_text=>'Corretto in fase di sviluppo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681845494307131)
,p_name=>'FOCUS_AREA'
,p_message_language=>'it'
,p_message_text=>'Area di interesse'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464525507306930)
,p_name=>'FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Testo pi\00E8 di pagina')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203717454306725)
,p_name=>'FORM'
,p_message_language=>'it'
,p_message_text=>'Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412461815307719)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745748941307191)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista form e lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745875735307191)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report con form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581732600307034)
,p_name=>'FORM_ON'
,p_message_language=>'it'
,p_message_text=>'Form in %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323223364306814)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'it'
,p_message_text=>'Form su tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725049687307172)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del form su query riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725392231307172)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del form e del report sul riferimento a un Web Service completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722649262307170)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del form completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725161969307172)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione della pagina di riepilogo completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724720516307172)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del form su tabella completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725280323307172)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del form sul riferimento a un Web Service completata.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272440667306776)
,p_name=>'FORWARD'
,p_message_language=>'it'
,p_message_text=>'Avanti'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782284783307225)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'it'
,p_message_text=>'dal dizionario attributi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410768244306886)
,p_name=>'FUNCTION'
,p_message_language=>'it'
,p_message_text=>'funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672091914307122)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Funzionalmente completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661806038307113)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'it'
,p_message_text=>'Implementazione funzionale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466186954306931)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412137048306887)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722307517307169)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'it'
,p_message_text=>'Corpo della funzione PL/SQL che restituisce un cursore di riferimento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715437451307163)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'it'
,p_message_text=>'Corpo della funzione PL/SQL che restituisce un risultato booleano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271212424306775)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'it'
,p_message_text=>'Funzione PL/SQL che restituisce un risultato booleano'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709104025307157)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'it'
,p_message_text=>'Milestone futuri'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361623260307677)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'it'
,p_message_text=>'Data baseline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361505005307677)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'it'
,p_message_text=>'Fine baseline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361485692307677)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'it'
,p_message_text=>'Inizio baseline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715067818307162)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'it'
,p_message_text=>'Data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714983721307162)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'it'
,p_message_text=>'Data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949058117307356)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'it'
,p_message_text=>'Task'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361147132307677)
,p_name=>'GANTT_DATE'
,p_message_language=>'it'
,p_message_text=>'Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361090287307677)
,p_name=>'GANTT_END'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361221596307677)
,p_name=>'GANTT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103361338063307677)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'Stato di avanzamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360847963307677)
,p_name=>'GANTT_ROW'
,p_message_language=>'it'
,p_message_text=>'Riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360923028307677)
,p_name=>'GANTT_START'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146491808307505)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'it'
,p_message_text=>'Raccogli statistiche tabelle'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664697602307115)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'it'
,p_message_text=>'Commento generale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015380999307406)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'it'
,p_message_text=>'Commenti generali: chiusi %1 su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276359939306779)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa tabella \00E8 stata creata mediante la Creazione guidata tabella.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360758736306847)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'it'
,p_message_text=>'Modifiche salvate.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670632045307121)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'it'
,p_message_text=>'Crea o modifica lista di valori statica'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683927409307133)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'it'
,p_message_text=>'Assegnatario globalizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682193587307132)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Impatto di globalizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684932601307134)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato globalizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204933057306725)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina globale'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729541666307176)
,p_name=>'GRAY_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo grigio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704417232307153)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'it'
,p_message_text=>'Nascondi colonne layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704388162307153)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'it'
,p_message_text=>'Mostra colonne layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303073018306799)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello griglia'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646541307307099)
,p_name=>'GROUPS'
,p_message_language=>'it'
,p_message_text=>'Gruppi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839009093307272)
,p_name=>'GROUP_LABEL'
,p_message_language=>'it'
,p_message_text=>'Gruppo: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464475380306930)
,p_name=>'HEADER'
,p_message_language=>'it'
,p_message_text=>'Testo intestazione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838851465307272)
,p_name=>'HEADING_LABEL'
,p_message_language=>'it'
,p_message_text=>'Intestazione: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409482886307716)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412513335306887)
,p_name=>'HELP_TEXT'
,p_message_language=>'it'
,p_message_text=>'testo della Guida'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507579104306963)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'it'
,p_message_text=>'Nascosto e protetto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665701039307116)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Desiderabilit\00E0 elevata')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368401226307682)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'it'
,p_message_text=>'Contrasto elevato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130040156307492)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'it'
,p_message_text=>'Attiva/disattiva contrasto elevato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646350214307098)
,p_name=>'HISTORY'
,p_message_language=>'it'
,p_message_text=>'Cronologia'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722147514307169)
,p_name=>'HOME_LINK'
,p_message_language=>'it'
,p_message_text=>'Collegamento Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200833141306722)
,p_name=>'HOME_NAV'
,p_message_language=>'it'
,p_message_text=>'Home Oracle APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253605134306762)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti:'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439535186306910)
,p_name=>'HORIZONTAL'
,p_message_language=>'it'
,p_message_text=>'orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186170378306711)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 2D orizzontali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186293352306711)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 3D orizzontali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186395134306711)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 2D con intervallo orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186483917306711)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 3D con intervallo orizzontale'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408880020307716)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello predefinito'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102244096503306755)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'it'
,p_message_text=>'Account HR sbloccato.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413612390306888)
,p_name=>'HTML'
,p_message_language=>'it'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432649601306904)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'it'
,p_message_text=>'HTML con scorciatoie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432397709306904)
,p_name=>'HTML_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274944572306778)
,p_name=>'HTML_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284305656306785)
,p_name=>'HTML_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464710884306930)
,p_name=>'HTML_HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284491001306785)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'it'
,p_message_text=>'HTML/Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412217972306887)
,p_name=>'HTML_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284537391306785)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'it'
,p_message_text=>'Testo HTML con collegamenti'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409019147307716)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'it'
,p_message_text=>'Classi CSS icona'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344720995307665)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'it'
,p_message_text=>unistr('Indica che il tema \00E8 compatibile con IE 6.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751881983307197)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'it'
,p_message_text=>'Consenti modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751908209307197)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'it'
,p_message_text=>'Sola lettura'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413848479306888)
,p_name=>'IMAGE'
,p_message_language=>'it'
,p_message_text=>'immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954673327307360)
,p_name=>'IMAGES'
,p_message_language=>'it'
,p_message_text=>'Immagini'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398210050306876)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721538929307168)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'it'
,p_message_text=>'Prefisso immagine'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659474486307110)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Importa da applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420761925307725)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'it'
,p_message_text=>'Nuovo valore per stringa di sostituzione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889310419307309)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Il file importato si trova nel <a href="%0">repository di esportazione</a>. Se non si prevede di installarlo di nuovo, rimuoverlo.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594904120307046)
,p_name=>'IN/OUT'
,p_message_language=>'it'
,p_message_text=>'In/Out'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211488593306730)
,p_name=>'INACTIVE'
,p_message_language=>'it'
,p_message_text=>'Inattivo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793863900307236)
,p_name=>'INCLUDE'
,p_message_language=>'it'
,p_message_text=>'Includi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413372165307719)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Includi: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410804415306886)
,p_name=>'INDEX'
,p_message_language=>'it'
,p_message_text=>'indice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791253544307234)
,p_name=>'INDEX_NOUN'
,p_message_language=>'it'
,p_message_text=>'Indice'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102355267061306843)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569286201307023)
,p_name=>'INLINE'
,p_message_language=>'it'
,p_message_text=>'In linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358771149307675)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello Guida in linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569184265307022)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'In linea e nella notifica'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715131434307162)
,p_name=>'INPUT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di input'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411521349306887)
,p_name=>'INSERT'
,p_message_language=>'it'
,p_message_text=>'inserisci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800629795307242)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'it'
,p_message_text=>'eccezione per inserimento in wwv_flow_companies:'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731224797307178)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'it'
,p_message_text=>'CSS (applicazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731071141307177)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine (applicazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731461519307178)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'it'
,p_message_text=>'File statico (applicazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240367876306752)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297842595306795)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile scegliere di includere le seguenti opzioni di creazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240271217306752)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Stringhe di sostituzione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297777252306795)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile configurare gli attributi dell''applicazione riportati di seguito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240578739306752)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'it'
,p_message_text=>'Conferma installazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298028967306795)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Confermare che si desidera installare gli oggetti di supporto di questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240902917306753)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'it'
,p_message_text=>'Conferma disinstallazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215521534306733)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'it'
,p_message_text=>'Script di disinstallazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241092794306753)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Disinstallazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298339511306796)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Disinstallazione completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585235943307037)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Errore durante l''esecuzione del controllo di installazione "%0":',
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585342675307037)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Errore durante l''esecuzione dello script di installazione "%0":',
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240166281306752)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'it'
,p_message_text=>'Verifica esistenza non riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240716996306752)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'it'
,p_message_text=>'Operazioni successive all''installazione non riuscite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298269292306795)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Installazione degli oggetti di database e dei seeddata non riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647637053307100)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'it'
,p_message_text=>unistr('L''Installer dell''applicazione ha rilevato che gli oggetti di supporto dell''applicazione sono stati gi\00E0 installati. Per poter installare l''applicazione \00E8 necessario rimuovere tali oggetti tramite SQL Workshop.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240833474306753)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'it'
,p_message_text=>'Licenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236035469306749)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'it'
,p_message_text=>'Errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235986321306749)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240686017306752)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazioni successive all''installazione completate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102298189576306795)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Installazione degli oggetti di supporto dell''applicazione completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337140418306829)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Confermare che si desidera aggiornare gli oggetti di supporto di questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337028133306828)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento degli oggetti di supporto dell''applicazione non riuscito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336644739306828)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'it'
,p_message_text=>unistr('Il programma di installazione dell''applicazione ha rilevato che gli oggetti di supporto dell''applicazione sono stati gi\00E0 installati. Questa procedura guidata assiste l''utente nel processo di aggiornamento di tali oggetti di supporto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102336908085306828)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento degli oggetti di supporto dell''applicazione completato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240436042306752)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297932084306795)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Per accertarsi che il sistema in uso sia compatibile con questa applicazione verranno eseguite le seguenti convalide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102240010171306752)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'it'
,p_message_text=>'Benvenuti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297616098306795)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Questo programma di installazione dell''applicazione assiste nel processo di creazione degli oggetti di database e dei seeddata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731194587307177)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'it'
,p_message_text=>'CSS (area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730912870307177)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'it'
,p_message_text=>'Immagine (area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731387820307178)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'it'
,p_message_text=>'File statico (area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228312506306743)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Installa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731588382307178)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'it'
,p_message_text=>'Installare un''applicazione di esempio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129417894307492)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'it'
,p_message_text=>'Home Oracle APEX Administration Services'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778776087307222)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni istanza'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680734887307130)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'it'
,p_message_text=>unistr('Questa istanza \00E8 eseguita in modalit\00E0 di provisioning manuale, quindi non accetta richieste di servizio.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773834618307217)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'it'
,p_message_text=>'Spazio insufficiente per installare l''applicazione.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661943277307113)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Integrazione completa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667120827307118)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'it'
,p_message_text=>'Scollegamento integrazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657641655307109)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'it'
,p_message_text=>'Griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433352952306905)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687139023307136)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'it'
,p_message_text=>'Ricerche di report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252315067306761)
,p_name=>'INTERNAL'
,p_message_language=>'it'
,p_message_text=>'Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204677317306725)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'it'
,p_message_text=>'Amministrazione interna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254087900306763)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'it'
,p_message_text=>'Interno'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581333969307034)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211305253306730)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'it'
,p_message_text=>unistr('Il file non \00E8 un archivio applicazione valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581890807307034)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome gruppo valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273143975306777)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'it'
,p_message_text=>unistr('L''oggetto %0 non \00E8 valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935053954307346)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome di gruppo di pagine valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449626054307748)
,p_name=>'INVALID_POSITION'
,p_message_language=>'it'
,p_message_text=>'Posizione non valida [non visualizzata]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800335924307241)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome schema non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714119212307162)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'it'
,p_message_text=>'Il valore della voce non valido deve essere un numero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398415597307705)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'it'
,p_message_text=>'%0 stringhe erano nomi utenti non validi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800274096307241)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome area di lavoro non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740886348307186)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'it'
,p_message_text=>'Oggetti Websheet non validi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738769534307184)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Oggetti Websheet non validi corretti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740902127307186)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'it'
,p_message_text=>'Gli oggetti di database necessari per la creazione delle applicazioni Websheet non sono validi oppure non esistono. Contattare l''amministratore dell''area di lavoro.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186522536306711)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'it'
,p_message_text=>'A linee 2D invertite'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663441485307114)
,p_name=>'IN_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'In corso'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359283772306846)
,p_name=>'IR_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607608573307058)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'it'
,p_message_text=>'Sviluppatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607563529307058)
,p_name=>'IR_END_USER'
,p_message_language=>'it'
,p_message_text=>'Utente finale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607957988307058)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584065860307036)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile visualizzare un solo report interattivo per pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607764518307058)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'it'
,p_message_text=>'Questa finestra di dialogo viene visualizzata solo per gli sviluppatori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607402933307058)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'it'
,p_message_text=>'Salva report *'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607831351307058)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'it'
,p_message_text=>'Salva *'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412948040307719)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'it'
,p_message_text=>'Applicazione: %0, Pagina: %1, Sottoscritto da: %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726798623307173)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione della pagina del report interattivo completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608094093307058)
,p_name=>'IR_UNITS'
,p_message_language=>'it'
,p_message_text=>unistr('Unit\00E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148112182307506)
,p_name=>'ISSUES'
,p_message_language=>'it'
,p_message_text=>'Problemi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595655946307047)
,p_name=>'IS_WRAPPED'
,p_message_language=>'it'
,p_message_text=>'sottoposto a wrapping'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706801872307155)
,p_name=>'ITEM CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284711354306785)
,p_name=>'ITEM NAME'
,p_message_language=>'it'
,p_message_text=>'Nome elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252033325306761)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Pulsanti elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433626527307735)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'it'
,p_message_text=>'Numero di colonne elemento corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271564178306776)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''elemento in Espressione 1 \00E8 uguale a Espressione 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271619772306776)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''elemento in Espressione 1 NON \00E8 uguale a Espressione 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271133762306775)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''elemento in Espressione 1 \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271002412306775)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''elemento in Espressione 1 \00E8 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412172570307718)
,p_name=>'ITEM_LABEL'
,p_message_language=>'it'
,p_message_text=>'Elemento: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329253081306819)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'it'
,p_message_text=>'Selettore data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329336359306819)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'it'
,p_message_text=>'Nascosto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672155654307122)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Campo di testo con completamento automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957862672307363)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'it'
,p_message_text=>'Casella di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327583068307652)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'it'
,p_message_text=>'Selettore colori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787484642307230)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'it'
,p_message_text=>'Selettore data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950051363307357)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'it'
,p_message_text=>'Selettore data (classico)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196749657306719)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'it'
,p_message_text=>'Selettore data (HTML5)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992233412307388)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'it'
,p_message_text=>'Visualizza immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951532694307358)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'it'
,p_message_text=>'Sola visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102991064861307387)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'it'
,p_message_text=>'Sfoglia file...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327301660307652)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'it'
,p_message_text=>'Nascosto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997973400307392)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'it'
,p_message_text=>'Gestione lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014124454307405)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'it'
,p_message_text=>'Editor Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941988502307351)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'it'
,p_message_text=>'Campo numero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943457252307352)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950767352307357)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'it'
,p_message_text=>'LOV popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957733411307363)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'it'
,p_message_text=>'Gruppo pulsanti di scelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703660698307152)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'it'
,p_message_text=>'Rich Text Editor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950160927307357)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista di selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952189756307359)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'it'
,p_message_text=>'Shuttle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217818452306735)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'it'
,p_message_text=>'Dispositivo di scorrimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329453169306819)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Arresta e avvia layout griglia (non pi\00F9 valido)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705649918307154)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'it'
,p_message_text=>'Area di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327462696307652)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'it'
,p_message_text=>'Campo di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217529964306735)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC/No')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279070701306781)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'it'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329565403306819)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'it'
,p_message_text=>'Lista di valori popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966885248307369)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'it'
,p_message_text=>'Valutazione a stelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329620285306819)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367055061307681)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello testo post elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366989743307681)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello testo pre elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732150537307178)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'it'
,p_message_text=>'Riga 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732256255307178)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'it'
,p_message_text=>'Riga 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732329110307179)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'it'
,p_message_text=>'Riga 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732449215307179)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'it'
,p_message_text=>'Riga 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941835941307351)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore massimo %0 immesso per l''elemento %1 non \00E8 numerico. Se il valore contiene posizioni decimali, specificare un punto come separatore decimale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941736770307351)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore minimo %0 immesso per l''elemento %1 non \00E8 numerico. Se il valore contiene posizioni decimali, specificare un punto come separatore decimale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217711673306735)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore di passo %0 immesso per l''elemento %1 non \00E8 numerico. Se il valore contiene posizioni decimali, specificare un punto come separatore decimale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279411187306781)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279550768306782)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'it'
,p_message_text=>'Sfoglia file...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279601836306782)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'it'
,p_message_text=>'Nascosto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279756426306782)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'it'
,p_message_text=>'Nascosto e protetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279896041306782)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'it'
,p_message_text=>'Selettore colori popup'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279936305306782)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'it'
,p_message_text=>'Campo di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280074393306782)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'it'
,p_message_text=>'Campo di testo (disabilitato, non salva lo stato)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280170791306782)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'it'
,p_message_text=>'Campo di testo (disabilitato, salva lo stato)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280204587306782)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Campo di testo (la pagina viene sottomessa sempre quando si preme Invio)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657427950307109)
,p_name=>'JET_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico JET'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592804287307044)
,p_name=>'JOB'
,p_message_language=>'it'
,p_message_text=>'Job'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658614763307110)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'it'
,p_message_text=>'Attivazione/disattivazione colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658515292307110)
,p_name=>'JQM REFLOW'
,p_message_language=>'it'
,p_message_text=>'Report reflow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734111682307180)
,p_name=>'JQM_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734029802307180)
,p_name=>'JQM_HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660507879307111)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista lista'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657721335307109)
,p_name=>'JSTREE'
,p_message_language=>'it'
,p_message_text=>'Struttura ad albero JavaScript'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683889646307133)
,p_name=>'JUSTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Giustificazione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148274949307506)
,p_name=>'LABELS'
,p_message_language=>'it'
,p_message_text=>'Etichette'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433577906307735)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'it'
,p_message_text=>'Numero di colonne etichetta corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427194136307730)
,p_name=>'LABEL_ID'
,p_message_language=>'it'
,p_message_text=>'ID etichetta elemento corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720612960307168)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385649395306866)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385710459306866)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questo modello.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385935169306866)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessun modello sottoscrive a questo modello.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102385831163306866)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Modelli di etichetta con sottoscrizione a questo modello'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228866135306743)
,p_name=>'LANGUAGES'
,p_message_language=>'it'
,p_message_text=>'Lingue'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686696934307136)
,p_name=>'LAST_CHANGE'
,p_message_language=>'it'
,p_message_text=>'Ultima modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594163655307045)
,p_name=>'LAST_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Ultima voce'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689569244307139)
,p_name=>'LAST_LOGIN'
,p_message_language=>'it'
,p_message_text=>'Ultimo login'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206208385306726)
,p_name=>'LAYOUT'
,p_message_language=>'it'
,p_message_text=>'%0 - Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243215189306754)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'it'
,p_message_text=>'Dopo il corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582586294307035)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'it'
,p_message_text=>'Dopo l''intestazione della pagina di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582215851307034)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Dopo il pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648511891307100)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'it'
,p_message_text=>'Dopo l''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997106579307392)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'it'
,p_message_text=>'Dopo l''elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931767968307343)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'it'
,p_message_text=>'Dopo l''etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932157292307344)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'it'
,p_message_text=>'Dopo etichetta ed elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333511800306826)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'it'
,p_message_text=>'Dopo l''autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102573032005307026)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Dopo l''elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582039635307034)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'it'
,p_message_text=>'Dopo le aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582376448307035)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Dopo la sottomissione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243146443306754)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'it'
,p_message_text=>'Prima del corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572727586307026)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Prima del calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582625476307035)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Pagina di errore prima del pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582161274307034)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Prima del pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572680651307026)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'it'
,p_message_text=>'Prima dell''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997046748307392)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'it'
,p_message_text=>'Prima dell''elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931677998307343)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Prima dell''etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932005346307344)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'it'
,p_message_text=>'Prima di etichetta ed elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572936831307026)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Prima dell''elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581991532307034)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'it'
,p_message_text=>'Prima delle aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572884307307026)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Prima della convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642250347307095)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'it'
,p_message_text=>'diramazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324283765306815)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'it'
,p_message_text=>'Sopra la casella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324373398306815)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'it'
,p_message_text=>'Sotto la casella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324479532306815)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324539317306815)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'it'
,p_message_text=>'Cambia modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324641309306815)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324761560306815)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'it'
,p_message_text=>'Copia modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324875592306816)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'it'
,p_message_text=>'Crea modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324981950306816)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325068808306816)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325187810306816)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'it'
,p_message_text=>'Espandi modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325252015306816)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'it'
,p_message_text=>'Modello successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325394199306816)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Modello precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325436054306816)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'it'
,p_message_text=>'Inizio pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565419435307019)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636178161307091)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784932620307228)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'it'
,p_message_text=>'Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564648967307018)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565115676307019)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Copia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564892309307019)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante CREATE2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196972247306719)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'it'
,p_message_text=>'Posizione personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784653346307227)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'it'
,p_message_text=>'False'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784700669307228)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'it'
,p_message_text=>'True'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565010182307019)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001562752307395)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta vuota - #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409152643307716)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564767709307018)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Espandi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506739204306963)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>'Funzione che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785016443307228)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'it'
,p_message_text=>'Pagina globale: '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564909757307019)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante ?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997235811307392)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'it'
,p_message_text=>'Collegamento Guida elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001666210307395)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'it'
,p_message_text=>'Nascosto - #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506696143306963)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'it'
,p_message_text=>'Testo HTML (caratteri speciali di escape)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358665358307675)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo Guida in linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367279742307681)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo post elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367145122307681)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo pre elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565296530307019)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642187230307095)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'it'
,p_message_text=>'Nessuna area nel punto di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785111407307228)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'it'
,p_message_text=>'Elementi di pagina e pulsanti senza area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674841986307125)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'it'
,p_message_text=>'Callback Ajax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931993225307344)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'it'
,p_message_text=>'In caso di errore dopo l''etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931872671307344)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'it'
,p_message_text=>'In caso di errore prima dell''etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575194776307028)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'it'
,p_message_text=>'In caso di nuova istanza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575216321307028)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'In caso di sottomissione e prima del calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565396670307019)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsante Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785373488307228)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174333809306702)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785418681307228)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'it'
,p_message_text=>'Corpo (#0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785537756307228)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'it'
,p_message_text=>'Posizione #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102784835456307228)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787778118307230)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'it'
,p_message_text=>'Esegui %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506891984306963)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico semplice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507178143306963)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query strutturata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787655321307230)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'it'
,p_message_text=>'Sottometti come "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659147245307110)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'it'
,p_message_text=>'Area secondaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507052193306963)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291877163306791)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'it'
,p_message_text=>'File CSS (Cascading Style Sheet) usati da &PRODUCT_NAME.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292234996306791)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'it'
,p_message_text=>'File e codice JavaScript usati da &PRODUCT_NAME.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411230943307718)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'it'
,p_message_text=>'File CSS (Cascading Style Sheet) definiti a livello di interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292488606306791)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'it'
,p_message_text=>'File JavaScript definiti a livello di interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737959474307184)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'it'
,p_message_text=>'Attributi finestra di dialogo, per definire gli attributi della finestra di dialogo non supportati in modo dichiarativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360339077307676)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'it'
,p_message_text=>'Classi CSS finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737543270307183)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'it'
,p_message_text=>'Altezza finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737705706307183)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'it'
,p_message_text=>'Larghezza massima finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737602954307183)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'it'
,p_message_text=>'Larghezza finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432082778307734)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'it'
,p_message_text=>'Etichetta per Espandi/comprimi navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432179917307734)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'it'
,p_message_text=>'Etichetta per Espandi/comprimi colonna laterale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401589877307710)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'it'
,p_message_text=>'Codice HTML favicon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292143455306791)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'it'
,p_message_text=>'CSS (Cascading Style Sheet) creati all''istante dal componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292532762306791)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'it'
,p_message_text=>'Codice Javascript creato all''istante dai componenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737844571307184)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 pagina finestra di dialogo (ad esempio ''true'' quando di tipo modale, ''false'' quando di tipo non modale)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292084741306791)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'it'
,p_message_text=>'File CSS (Cascading Style Sheet) e stile in linea definiti a livello di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285744516306786)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'it'
,p_message_text=>'Classi CSS pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941154093307350)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'it'
,p_message_text=>'File e codice Javascript definiti a livello di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203924705306725)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'it'
,p_message_text=>'ID statico pagina (ad esempio ''P100'')'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200378602306722)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'it'
,p_message_text=>'Transizione utilizzata per accedere a una nuova pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737482556307183)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'it'
,p_message_text=>'URL pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200459417306722)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'it'
,p_message_text=>'Transizione utilizzata per aprire un popup.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740618072307186)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'it'
,p_message_text=>'URL pagina richiesto dal browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411432697307718)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'it'
,p_message_text=>'Menu di navigazione (laterale)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291977617306791)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'it'
,p_message_text=>'File CSS (Cascading Style Sheet) e stile in linea definiti nel modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292372627306791)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'it'
,p_message_text=>'File e codice JavaScript definiti nel modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292697211306791)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'it'
,p_message_text=>'File CSS (Cascading Style Sheet) definiti a livello di tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420266325307725)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'it'
,p_message_text=>'File Javascript definiti a livello di tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420334645307725)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'it'
,p_message_text=>'File CSS (Cascading Style Sheet) definiti a livello di stile di tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411379953307718)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'it'
,p_message_text=>'Menu di navigazione (superiore)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738012399307184)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'it'
,p_message_text=>'Elemento di attivazione del trigger (ad esempio, l''elemento DOM corrente)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351032908306839)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'it'
,p_message_text=>'azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941211619307350)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'it'
,p_message_text=>'Elementi interessati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348092685306837)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'it'
,p_message_text=>'Schede dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344041423306834)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'it'
,p_message_text=>unistr('gi\00F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347690132306837)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo del corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343460397306833)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'it'
,p_message_text=>'crea diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344133643306834)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'it'
,p_message_text=>'crea pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346714714306836)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345878837306835)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348126391306837)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'it'
,p_message_text=>'Immagini dell''area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343255791306833)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'crea calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346496037306836)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'it'
,p_message_text=>'Copia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345628526306835)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'it'
,p_message_text=>'Crea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345739107306835)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'it'
,p_message_text=>'Crea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346314471306836)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345417393306835)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345540860306835)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'it'
,p_message_text=>'Espandi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346126815306835)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiusura form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346062318306835)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'it'
,p_message_text=>'Apertura form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347250697306836)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Notifica globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346215373306835)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'it'
,p_message_text=>'Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344217031306834)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'it'
,p_message_text=>'crea elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347060986306836)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346587086306836)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347144909306836)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347983341306837)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'it'
,p_message_text=>'Schede padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346671193306836)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343178107306833)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'it'
,p_message_text=>'crea processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343065984306833)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'it'
,p_message_text=>'crea area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345986958306835)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347798842306837)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'it'
,p_message_text=>'Posizione area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345344794306835)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347871111306837)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'it'
,p_message_text=>'Schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347453307306836)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Messaggio di operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347306920306836)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo del modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102347505164306837)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343357928306833)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'crea convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342992400306833)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'it'
,p_message_text=>'avvertenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788336988307231)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408650115307716)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'it'
,p_message_text=>'Etichetta indicatore di percorso (con escape dei caratteri HTML)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998951143307393)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Evento WHEN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348599288306837)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235845726306749)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'it'
,p_message_text=>'Diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341382353306832)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'it'
,p_message_text=>'Diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789729688307232)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione di diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325876877306816)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'it'
,p_message_text=>'Dirama a funzione che restituisce una pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325932738306816)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'it'
,p_message_text=>'Dirama a funzione che restituisce un URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325580573306816)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'it'
,p_message_text=>'Dirama ad accettazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325626775306816)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'it'
,p_message_text=>'Dirama a pagina identificata da elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351537531306840)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'it'
,p_message_text=>'Vai a pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326063603306816)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'it'
,p_message_text=>'Dirama a procedura PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102325753852306816)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'it'
,p_message_text=>'Dirama a URL identificato da elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788453401307231)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'it'
,p_message_text=>'Opzione di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340041149306831)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351499002306840)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789170717307232)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967357861307370)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'it'
,p_message_text=>'Esegui convalide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344969851306835)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'it'
,p_message_text=>'Pulsanti senza aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789588333307232)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query su grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789441878307232)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'it'
,p_message_text=>'Intestazione colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408405545307715)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'it'
,p_message_text=>'Classi CSS componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340238317306831)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Calcoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352152620306840)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'it'
,p_message_text=>'Calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340359073306831)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'it'
,p_message_text=>'La pagina 0 non supporta calcoli. I calcoli che devono essere eseguiti in ogni pagina devono essere gestiti da calcoli a livello di applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788803575307231)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351130558306839)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'it'
,p_message_text=>'condizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788191492307231)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'it'
,p_message_text=>'Espressione 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788223529307231)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'it'
,p_message_text=>'Espressione 2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788063548307231)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di condizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338381051306829)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Copia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338143406306829)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Crea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406516116307714)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'it'
,p_message_text=>unistr('Testo derivato dal messaggio di testo interno <em>APEX.CURRENT_PROGRESS</em> (il valore predefinito \00E8 <em>Avanzamento corrente</em>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349092625306838)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351328062306840)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789247452307232)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'it'
,p_message_text=>'Visualizza come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339840358306831)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'it'
,p_message_text=>'Punto&nbsp;di&nbsp;visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337430160307660)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'it'
,p_message_text=>'Azioni dinamiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338239440306829)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235795039306749)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'it'
,p_message_text=>'Modifica pagina in Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323447286306814)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Modifica attributi area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324018847306815)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351223663306839)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'it'
,p_message_text=>'esp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342828254306833)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'it'
,p_message_text=>'Nessuna diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342539703306833)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Nessun calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342389912306833)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'it'
,p_message_text=>'Nessuna pagina selezionata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342698240306833)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Nessun processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342449716306833)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'it'
,p_message_text=>'Nessuna area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342703728306833)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Nessuna convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348678819306837)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>unistr('Modello di pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349901282306838)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiusura form HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349440371306838)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'it'
,p_message_text=>'Apertura form HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348906889306838)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'it'
,p_message_text=>'Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340858849306831)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'it'
,p_message_text=>'La pagina globale non supporta diramazioni, calcoli, processi o convalide. I calcoli e i processi che devono essere eseguiti in ogni pagina devono essere gestiti da calcoli e processi a livello di applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001331846307395)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'it'
,p_message_text=>'Colonna griglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720238156307167)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'it'
,p_message_text=>'Numero colonne griglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348428717306837)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323805719306815)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'it'
,p_message_text=>'In linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323735649306815)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'In linea+Notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339098236306830)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340137617306831)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672240129307122)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345239076306835)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'it'
,p_message_text=>'Il conteggio degli elementi ha superato il valore massimo di 200.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789363448307232)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209516552306729)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'it'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392879614307700)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'it'
,p_message_text=>'ID lista univoco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102324183939306815)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368147869306853)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'it'
,p_message_text=>'Liste di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209435391306729)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'it'
,p_message_text=>'Indicatori di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001494352307395)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351781815306840)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'it'
,p_message_text=>'Naviga verso la pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342006218306832)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra di&nbsp;navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667270085307118)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'it'
,p_message_text=>'Menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326449556306817)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'it'
,p_message_text=>'mai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719980459307167)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'it'
,p_message_text=>'Inizia nuova griglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720116268307167)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Inizia nuova colonna griglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720003476307167)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'it'
,p_message_text=>'Inizia nuova riga griglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348393899306837)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326146846306817)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'it'
,p_message_text=>'nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323915521306815)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349572562306838)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'it'
,p_message_text=>'Messaggio di notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341453002306832)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene diramazioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345005188306835)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene pulsanti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102345189122306835)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene elementi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209708534306729)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'it'
,p_message_text=>'Nessuna lista utilizzata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368242860306853)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'it'
,p_message_text=>'Nessuna lista di valori condivisa utilizzata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209859218306729)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'it'
,p_message_text=>'Nessun indicatore di percorso utilizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342152396306832)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'it'
,p_message_text=>'L''applicazione "%0" non ha barre di navigazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340507568306831)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene calcoli di tipo "OnLoad".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340737549306831)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene processi di tipo "OnLoad".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340947449306831)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene calcoli di tipo "OnSubmit".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341258798306832)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene processi di tipo "OnSubmit".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337979171306829)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'it'
,p_message_text=>'Nessuna pagina selezionata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341697555306832)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'it'
,p_message_text=>'Nessuna scheda di livello padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339921883306831)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene aree.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341957153306832)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'La pagina %0 non ha set di schede.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368382816306853)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Nessun modello utilizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341118799306832)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'La pagina "%0" non contiene convalide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323582168306815)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'it'
,p_message_text=>'%0 elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338036867306829)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338819089306830)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339497287306830)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'it'
,p_message_text=>'Autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339282778306830)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>'Autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349788713306838)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349828786306838)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo corpo pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339375837306830)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'it'
,p_message_text=>'Opzione di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349325144306838)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'it'
,p_message_text=>'Intestazione di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338685307306830)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338569507306830)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Pagina non trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349187582306838)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'it'
,p_message_text=>'Pagina di tipo "OnLoad"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339508485306830)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'it'
,p_message_text=>'Pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339687448306830)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Richiesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339125775306830)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'it'
,p_message_text=>'Set di schede standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338916693306830)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338766356306830)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349210414306838)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'it'
,p_message_text=>'Titolo pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341514028306832)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'it'
,p_message_text=>'Schede padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340680236306831)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Processi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352064223306840)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'it'
,p_message_text=>'Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102340429410306831)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'it'
,p_message_text=>'La pagina 0 non supporta processi. I processi che devono essere eseguiti in ogni pagina devono essere gestiti da processi a livello di applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789663063307232)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351603702306840)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'it'
,p_message_text=>'Vai a pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348849360306838)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'it'
,p_message_text=>'Di riferimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408576289307716)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'it'
,p_message_text=>'Riferimento da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102339720225306831)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'it'
,p_message_text=>'Aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352455686306840)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660731549307112)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199988907306722)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'it'
,p_message_text=>'Classi CSS aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659576205307111)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'it'
,p_message_text=>'ID area univoco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718800215307166)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'it'
,p_message_text=>'Posizione area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350052183306839)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'it'
,p_message_text=>'Posizione 1 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654400455307106)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'it'
,p_message_text=>'Posizione 10 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654574670307106)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'it'
,p_message_text=>'Posizione 11 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654665576307106)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'it'
,p_message_text=>'Posizione 12 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654777877307106)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'it'
,p_message_text=>'Posizione 13 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654839078307106)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'it'
,p_message_text=>'Posizione 14 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654910167307106)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'it'
,p_message_text=>'Posizione 15 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655070156307106)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'it'
,p_message_text=>'Posizione 16 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350188681306839)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'it'
,p_message_text=>'Posizione 2 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350282294306839)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'it'
,p_message_text=>'Posizione 3 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350383047306839)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'it'
,p_message_text=>'Posizione 4 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350436435306839)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'it'
,p_message_text=>'Posizione 5 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350580318306839)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'it'
,p_message_text=>'Posizione 6 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350694432306839)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'it'
,p_message_text=>'Posizione 7 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350730287306839)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'it'
,p_message_text=>'Posizione 8 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102654309152307106)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'it'
,p_message_text=>'Posizione 9 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659640248307111)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'it'
,p_message_text=>'ID statico area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001266268307395)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326321100306817)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'it'
,p_message_text=>'condizione standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341757026306832)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'it'
,p_message_text=>'Schede&nbsp;standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348730644306837)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'it'
,p_message_text=>'Sostituzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660334398307111)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Aree secondarie - Modello di voce intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660495112307111)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Aree secondarie - Modello di intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660242293307111)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Aree secondarie - Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660009159307111)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'it'
,p_message_text=>'Aree secondarie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660176771307111)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'it'
,p_message_text=>'Intestazioni area secondaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659905238307111)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci intestazione area secondaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659755841307111)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'it'
,p_message_text=>'ID statico dell''area secondaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659838152307111)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo dell''area secondaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102349603694306838)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Messaggio di operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209237800306729)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'it'
,p_message_text=>'Form tabulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341898440306832)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346826842306836)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367455451306852)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343925556306834)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'it'
,p_message_text=>'crea diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344471816306834)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'it'
,p_message_text=>'crea pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343670615306834)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'crea calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344691893306834)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'it'
,p_message_text=>'crea elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343781594306834)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'it'
,p_message_text=>'crea processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343581600306833)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'it'
,p_message_text=>'crea area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102343874745306834)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'crea convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344530343306834)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'it'
,p_message_text=>'modifica pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344783377306834)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'it'
,p_message_text=>'modifica elemento pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344886180306834)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'it'
,p_message_text=>'modifica elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102344345337306834)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'it'
,p_message_text=>'titolo area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102789038953307232)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione WHEN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788915902307232)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'it'
,p_message_text=>'Elemento WHEN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326275368306817)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'it'
,p_message_text=>'Non condizionale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102341090977306832)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Convalide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351968024306840)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'it'
,p_message_text=>'Convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967245921307370)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'it'
,p_message_text=>'Esegui sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788608706307231)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'it'
,p_message_text=>'Espressione di convalida 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788791338307231)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'it'
,p_message_text=>'Espressione di convalida 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102788528410307231)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102338495940306829)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787982940307231)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'it'
,p_message_text=>'Se si fa clic sul pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102348262298306837)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506976387306963)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query SQL aggiornabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468900388306934)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102785280851307228)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'it'
,p_message_text=>'Convalida in corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465904739306931)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'it'
,p_message_text=>'Mai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508653937306964)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'it'
,p_message_text=>'Esegui'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713148976307161)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione di modifica nome utente LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102225568302306741)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'it'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243938139306755)
,p_name=>'LEARN MORE'
,p_message_language=>'it'
,p_message_text=>'Ulteriori informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361810842306848)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'it'
,p_message_text=>'Ulteriori informazioni su Oracle APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361638211306848)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'it'
,p_message_text=>'Ulteriori informazioni su App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102370467967306854)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'it'
,p_message_text=>'Ulteriori informazioni su Page Designer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361793646306848)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'it'
,p_message_text=>unistr('Ulteriori informazioni sulle applicazioni di produttivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361567682306847)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'Ulteriori informazioni su SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966631067307369)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'it'
,p_message_text=>'Fare clic qui per informazioni sui Websheet'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775780674307219)
,p_name=>'LEFT'
,p_message_language=>'it'
,p_message_text=>'A sinistra'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420164580307725)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario precedente'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250600370306760)
,p_name=>'LINES'
,p_message_language=>'it'
,p_message_text=>'Righe'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015921383307406)
,p_name=>'LINK'
,p_message_language=>'it'
,p_message_text=>'Collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286478138306787)
,p_name=>'LINK$'
,p_message_language=>'it'
,p_message_text=>'collegamento a colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687690806307137)
,p_name=>'LINKS'
,p_message_language=>'it'
,p_message_text=>'Collegamenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413666596307720)
,p_name=>'LINK_LABEL'
,p_message_language=>'it'
,p_message_text=>'Collegamento: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793276776307235)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'it'
,p_message_text=>'Collegamento a %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102607344251307057)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'it'
,p_message_text=>'collega a questo elemento pagina %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413407462306888)
,p_name=>'LIST'
,p_message_language=>'it'
,p_message_text=>'lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712101506307160)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione elemento di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708605139307157)
,p_name=>'LIST OF VALUES'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102281907392306783)
,p_name=>'LISTVIEW'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745967933307191)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione della vista form e lista riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752367386307197)
,p_name=>'LIST_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voce di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103452063106307750)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta voce di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740465191307186)
,p_name=>'LIST_INITCAP'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856855391307285)
,p_name=>'LIST_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657327899307108)
,p_name=>'LIST_REGION'
,p_message_language=>'it'
,p_message_text=>'Area di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720711456307168)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433119523306905)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468679460306933)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'it'
,p_message_text=>'Utilizzo lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746249402307191)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi pagina Vista lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746569368307192)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome pagina Vista lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746156058307191)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Pagina Vista lista'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399136589307705)
,p_name=>'LOAD_DATA'
,p_message_language=>'it'
,p_message_text=>'Carica dati'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795675439307237)
,p_name=>'LOCK'
,p_message_language=>'it'
,p_message_text=>'Blocca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883688223307305)
,p_name=>'LOCKED'
,p_message_language=>'it'
,p_message_text=>'bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581458976307034)
,p_name=>'LOCKED BY'
,p_message_language=>'it'
,p_message_text=>'Bloccato da: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401910129307710)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'it'
,p_message_text=>'%0 bloccato da %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402192703307711)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'it'
,p_message_text=>'Blocca script'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593885600307045)
,p_name=>'LOG'
,p_message_language=>'it'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721620887307169)
,p_name=>'LOGGING'
,p_message_language=>'it'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790082063307233)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'it'
,p_message_text=>'Memorizza nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790166373307233)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Quando si seleziona questa casella di controllo, l''applicazione salva il nome utente nel cookie browser persistente denominato "LOGIN_USERNAME_COOKIE".',
'Durante il successivo accesso alla pagina di login,',
unistr('il campo del nome utente verr\00E0 popolato in modo automatico con questo valore.'),
'</p>',
'<p>',
unistr('Se si deseleziona la casella di controllo e il nome utente \00E8 stato gi\00E0 salvato nel cookie,'),
unistr('l''applicazione sovrascriver\00E0 il cookie con un valore vuoto.'),
unistr('\00C8 inoltre possibile usare gli strumenti di sviluppatore del browser per rimuovere completamente il cookie.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721407642307168)
,p_name=>'LOGIN_URL'
,p_message_language=>'it'
,p_message_text=>'URL di login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721305643307168)
,p_name=>'LOGO'
,p_message_language=>'it'
,p_message_text=>'Logo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207740171307562)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'it'
,p_message_text=>'Nessun set di immagini.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207875579307562)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo logo applicazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206227535307561)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'it'
,p_message_text=>'Logo applicazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206785037307561)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'it'
,p_message_text=>'Questo file supera il limite consentito di %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207246335307562)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'it'
,p_message_text=>unistr('Il markup del logo personalizzato pu\00F2 essere impostato in Application Builder.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207156656307562)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'it'
,p_message_text=>'Trascinare i file o fare clic per selezionare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207074605307561)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207382732307562)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'it'
,p_message_text=>unistr('Per questa applicazione non verr\00E0 visualizzato alcun logo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206973441307561)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206837986307561)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207580949307562)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('Per questo tipo di logo \00E8 richiesta un''immagine.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207613276307562)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Salvataggio del logo riuscito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103207480347307562)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('Per questo tipo di logo \00E8 richiesto un testo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206675499307561)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'it'
,p_message_text=>'Sono consentite solo immagini'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388022417307697)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('Grazie per il feedback. \00C8 stato creato un bug per il problema. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389581166307698)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('Grazie per il feedback. La richiesta verr\00E0 presa in considerazione per una release futura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012842278307404)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('Grazie per il feedback. \00C8 stato registrato un problema nel sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389733026307698)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('Grazie per il feedback. \00C8 stato creato un task per risolvere il problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417547528307723)
,p_name=>'LOG_IN'
,p_message_language=>'it'
,p_message_text=>'Login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102594744766307046)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'it'
,p_message_text=>'Intervallo di log'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708582438307156)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione elemento di lista di valori'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666408405307117)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'it'
,p_message_text=>unistr('Priorit\00E0 bassa')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209677774306729)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'it'
,p_message_text=>'Gestisci gruppi di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858369959307286)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'it'
,p_message_text=>'Gestisci servizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858191126307286)
,p_name=>'MANAGE USERS'
,p_message_language=>'it'
,p_message_text=>'Gestisci utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857581334307285)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Gestisci area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802049168307243)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Gestisci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423605616306897)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'it'
,p_message_text=>'Gestisci non assegnati'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241165417306753)
,p_name=>'MANUAL'
,p_message_language=>'it'
,p_message_text=>'Manuale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102179526284306706)
,p_name=>'MAP_LAYER='
,p_message_language=>'it'
,p_message_text=>'Layer='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180952673306707)
,p_name=>'MAP_LAYERS'
,p_message_language=>'it'
,p_message_text=>'Layer mappe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326889325306817)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione della mappa riuscita.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665670084307116)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'it'
,p_message_text=>'Funzione di testo scorrevole'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102739531804307185)
,p_name=>'MASTER'
,p_message_language=>'it'
,p_message_text=>'Principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724828353307172)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione delle pagine Master-Detail completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178280868306705)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Master-Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178400630306705)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Dettagli %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178367199306705)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791366443307234)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista materializzata'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687003570307136)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'it'
,p_message_text=>'Tempo massimo di presentazione (secondi)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778241252307221)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'it'
,p_message_text=>unistr('Tempo massimo di inattivit\00E0 sessione (secondi)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778370277307221)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'it'
,p_message_text=>'Lunghezza massima sessione (secondi)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361322946306847)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'it'
,p_message_text=>unistr('L''eliminazione di milestone con funzioni associate non \00E8 consentita.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253597684306762)
,p_name=>'MEMORY'
,p_message_language=>'it'
,p_message_text=>'Memoria:'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411815832306887)
,p_name=>'MENU'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712299642307160)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione elemento di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721060541307168)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di indicatore di percorso'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954144790307360)
,p_name=>'MIGRATION FILES'
,p_message_language=>'it'
,p_message_text=>'File di migrazione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708192563307156)
,p_name=>'MILESTONE'
,p_message_language=>'it'
,p_message_text=>'Milestone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688151245307137)
,p_name=>'MILESTONES'
,p_message_language=>'it'
,p_message_text=>'Milestone'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144420786307503)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'it'
,p_message_text=>'ms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690835930307140)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna tipo MIME'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664172277307115)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Impatto minimo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228619301306743)
,p_name=>'MIN_VERSION'
,p_message_language=>'it'
,p_message_text=>'Versione minima'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388678759307697)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'it'
,p_message_text=>'Carattere @ mancante'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611681454307061)
,p_name=>'MODEL_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665882207307116)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Desiderabilit\00E0 moderata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664030466307115)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Impatto moderato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350839597306839)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'it'
,p_message_text=>'Indica un attributo modificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791659079307234)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Modifica colonna %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591364076307043)
,p_name=>'MONITOR'
,p_message_language=>'it'
,p_message_text=>'Controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858222175307286)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla attivit\00E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717449972307165)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'it'
,p_message_text=>'Altro...'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686564524307136)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>unistr('%0 applicazioni pi\00F9 attive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681561112307131)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Errore pi\00F9 recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982127122307381)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'it'
,p_message_text=>unistr('Il file pi\00F9 recente \00E8 %0 caricato da %1 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449957574306919)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'it'
,p_message_text=>'Errore in MRU: riga= %0, %1, %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448870126306918)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'it'
,p_message_text=>'La colonna della chiave primaria identificata non si trova nella lista di selezione della query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450048047306919)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'it'
,p_message_text=>unistr('La versione corrente dei dati nel database \00E8 cambiata da quando l''utente ha iniziato il processo di aggiornamento. checksum corrente = "%0", checksum elementi = "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448370072306917)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Non esistono righe da elaborare'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366224331306851)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'it'
,p_message_text=>'Accertarsi che il tipo di file del file del layout di report sia XSL-FO, utilizzando ''.xsl'' come estensione.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275111249306778)
,p_name=>'MY_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina personale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387583568307696)
,p_name=>'NAMES'
,p_message_language=>'it'
,p_message_text=>'Nomi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795581753307237)
,p_name=>'NAVBAR'
,p_message_language=>'it'
,p_message_text=>'Barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708337731307156)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione elemento di barra di navigazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391194958307699)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'it'
,p_message_text=>'Vai all''inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706202931307154)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'it'
,p_message_text=>'Barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721278983307168)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'it'
,p_message_text=>'Navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209342914306729)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina di navigazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200708767306722)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'it'
,p_message_text=>'Passa alla home page di App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427375950307730)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'it'
,p_message_text=>'Implementazione: lista %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427216666307730)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'it'
,p_message_text=>'Implementazione: classica'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676503567307126)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 richiesta la revisione')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669684476307120)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'it'
,p_message_text=>'Sono richieste informazioni'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687725629307137)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci di notizie'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421053989307725)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'it'
,p_message_text=>'Nuovo valore per bind variable %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430626200306903)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'it'
,p_message_text=>'Il nuovo indirizzo di posta elettronica per l''account Application Express.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665121070307116)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'it'
,p_message_text=>'Nuova richiesta di funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597349246307048)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'it'
,p_message_text=>'Nuovo o esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773423864307217)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome nuovo schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680870846307130)
,p_name=>'NEW_SERVICE'
,p_message_language=>'it'
,p_message_text=>'Nuovo servizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411716068306887)
,p_name=>'NEW_TABSET'
,p_message_language=>'it'
,p_message_text=>'Nuovo set di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406310911307714)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'it'
,p_message_text=>'- Nessun padre selezionato - '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717757233307165)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'it'
,p_message_text=>'Nuova richiesta di area di lavoro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725944248307173)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'it'
,p_message_text=>'Nessuna area corrispondente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659266606307110)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'it'
,p_message_text=>unistr('Tabella senza chiavi primarie definite. \00C8 necessario specificare una chiave primaria durante la creazione di report con form. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255301781306764)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'it'
,p_message_text=>'Archiviazione log: non attiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650407493307102)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voce non corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706095321307154)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda non corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710537807307158)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'it'
,p_message_text=>'Nessuno specificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398173833306876)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine non corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775149611307218)
,p_name=>'NON_PACKAGE'
,p_message_language=>'it'
,p_message_text=>unistr('-Applicazione non di produttivit\00E0 o di esempio-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666382323307117)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'it'
,p_message_text=>unistr('Priorit\00E0 normale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388168579307697)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Non disponibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413595697307719)
,p_name=>'NOTE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Nota: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569334198307023)
,p_name=>'NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663029836307114)
,p_name=>'NOT_A_BUG'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 un bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420010346307724)
,p_name=>'NOT_CURRENT'
,p_message_language=>'it'
,p_message_text=>'Non corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666005613307117)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'it'
,p_message_text=>'Non desiderabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715601637307163)
,p_name=>'NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Non esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270990827306775)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query SQL - Non esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663181891307114)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'it'
,p_message_text=>'Impossibile correggere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795398653307237)
,p_name=>'NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426743303307730)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Completamento all''80% o meno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728421432307175)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'it'
,p_message_text=>'Non installata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411621603306887)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'it'
,p_message_text=>'Non nel dizionario dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666765087307117)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'it'
,p_message_text=>unistr('Senza priorit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102664566627307115)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'it'
,p_message_text=>unistr('Senza priorit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710795721307158)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'it'
,p_message_text=>'Non fornito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986493839307384)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Non richiesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669489730307120)
,p_name=>'NOT_STARTED'
,p_message_language=>'it'
,p_message_text=>'Non avviato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747991004307193)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('<strong>%0</strong> non \00E8 un nome di vista valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228161507306743)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna applicazione trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102731664485307178)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Nessuna applicazione selezionata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506214689306963)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'it'
,p_message_text=>'Nessun argomento consentito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662125064307113)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'it'
,p_message_text=>unistr('Nessuna priorit\00E0 assegnata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273905195306777)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'it'
,p_message_text=>'nessuno schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710947324307159)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Non sono disponibili processi di coda dei job del database. Contattare l''amminstratore<br> in modo che aumenti il valore del parametro di inizializzazione JOB_QUEUE_PROCESSES <br>',
'o attendere il completamento degli altri job.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584863784307037)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di indicatore di percorso trovato nel tema. \00C8 necessario almeno un modello di indicatore di percorso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584948049307037)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di pulsante trovato nel tema. \00C8 necessario almeno un modello di pulsante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584452155307036)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di calendario trovato nel tema. \00C8 necessario almeno un modello di calendario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360479403306847)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'it'
,p_message_text=>'Nessuna data specificata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610228111307060)
,p_name=>'NO_DEBUG'
,p_message_language=>'it'
,p_message_text=>'Nessun debug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222331803306739)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'it'
,p_message_text=>'Nessun privilegio sviluppatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283787126306785)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'it'
,p_message_text=>'- Nessuna visualizzazione -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238800761306751)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'it'
,p_message_text=>'Nessuna funzione di destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582488987307035)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Nessuna guida disponibile per questo elemento di pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447459760307746)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna icona trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332609213306825)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna immagine trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569619535307023)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna immagine trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414014273306889)
,p_name=>'NO_ITEM'
,p_message_language=>'it'
,p_message_text=>'nessun elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775622551307219)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Processi della coda di job del database non abilitati. Contattare l''amministratore<br>',
'per impostare il parametro di inizializzazione JOB_QUEUE_PROCESSES.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584545490307037)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di etichetta trovato nel tema. \00C8 necessario almeno un modello di etichetta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316220891306809)
,p_name=>'NO_LAYOUT'
,p_message_language=>'it'
,p_message_text=>'Nessun layout di report selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584736227307037)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di lista trovato nel tema. \00C8 necessario almeno un modello di lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665396752307116)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 pi\00F9 un problema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273721442306777)
,p_name=>'NO_LOV'
,p_message_language=>'it'
,p_message_text=>'nessuna lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709235697307157)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'it'
,p_message_text=>'Nessun milestone definito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935953291307347)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'it'
,p_message_text=>'Non mostrare lista menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316121364306809)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'it'
,p_message_text=>'Lo sviluppatore non dispone del privilegio per creare un componente su questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585154932307037)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'it'
,p_message_text=>'Tentativo di copiare il tema e nessun modello di pagina trovato nell''applicazione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584257453307036)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di pagina trovato nel tema. \00C8 necessario almeno un modello di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102507813342306964)
,p_name=>'NO_PARENT'
,p_message_language=>'it'
,p_message_text=>'Nessuna voce di indicatore di percorso padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956382678307362)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessuna scheda padre definita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717331669307164)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'it'
,p_message_text=>'Nessuna richiesta in sospeso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585058703307037)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di lista di valori popup trovato nel tema. \00C8 necessario almeno un modello di lista di valori popup.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666689621307117)
,p_name=>'NO_PRIORITY'
,p_message_language=>'it'
,p_message_text=>unistr('Nessuna priorit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753627566307198)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Questa posizione di area non si trova nel modello di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584338814307036)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di area trovato nel tema. \00C8 necessario almeno un modello di area.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102584682339307037)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun modello di report trovato nel tema. \00C8 necessario almeno un modello di report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273837862306777)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'it'
,p_message_text=>'nessuna scorciatoia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669345180307120)
,p_name=>'NO_STATUS'
,p_message_language=>'it'
,p_message_text=>'Nessuno stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717991743307165)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessun messaggio di sistema definito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012228161307403)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessuna scheda definita per questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956561256307362)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna scheda trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953741093307360)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessuna scheda definita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102956440340307362)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Nessuna scheda selezionata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387959339307697)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna tag trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413920056306889)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Nessun modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506320583306963)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'it'
,p_message_text=>'Nessun accesso URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998262536307393)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('Per poter usare le tag SQL \00E8 necessario definire una lista delle tabelle consentite per motivi di sicurezza.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663884170307115)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Nessuna soluzione disponibile'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410149393306886)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'it'
,p_message_text=>'(nullo)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794742336307236)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747702527307193)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Utenti'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238759123306751)
,p_name=>'NUM_TOTAL'
,p_message_language=>'it'
,p_message_text=>'%0 del totale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646233665307098)
,p_name=>'OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941645772307351)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti senza valori predefiniti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102941582664307351)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti con valori predefiniti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413167462307719)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Oggetto: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734520290307180)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'it'
,p_message_text=>'estendi a catena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675840303307126)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'it'
,p_message_text=>'Specificare il vincolo Check.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102229915894306744)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'it'
,p_message_text=>'%0 errori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735684253307182)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome vincolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735788237307182)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'it'
,p_message_text=>'Colonna/e/Check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675689945307126)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Nome vincolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676028494307126)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'it'
,p_message_text=>unistr('Nome vincolo gi\00E0 utilizzato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734217185307180)
,p_name=>'OB_FK_NAME'
,p_message_language=>'it'
,p_message_text=>'Chiave esterna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675216392307125)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare un nome di chiave esterna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675936296307126)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'it'
,p_message_text=>unistr('Nome di chiave esterna gi\00E0 utilizzato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734366767307180)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'it'
,p_message_text=>'Tabella di riferimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734457664307180)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'it'
,p_message_text=>'Colonne di riferimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675554106307125)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'it'
,p_message_text=>'Selezionare le colonne dei riferimenti a chiavi esterne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675490965307125)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'it'
,p_message_text=>'Selezionare la tabella dei riferimenti a chiavi esterne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675374248307125)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'it'
,p_message_text=>'Selezionare le colonne chiave esterna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796088526307238)
,p_name=>'OB_POSITION'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735844963307182)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'it'
,p_message_text=>'- Seleziona tipo di dati -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734685739307181)
,p_name=>'OB_SET_NULL'
,p_message_language=>'it'
,p_message_text=>'imposta su null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102675774972307126)
,p_name=>'OB_UK_COLS'
,p_message_language=>'it'
,p_message_text=>'Specificare le colonne per la chiave univoca.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144603426307503)
,p_name=>'ODG.API.START'
,p_message_language=>'it'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144527088307503)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'it'
,p_message_text=>'Eccezione non gestita %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144737028307503)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'it'
,p_message_text=>'data_source built-in non gestita: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145566447307504)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Progetto non trovato o non creato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197194825306720)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'it'
,p_message_text=>'Il nome dell''origine dati deve contenere al massimo 26 caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197064381306719)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''importazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145423550307504)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''istruzione SQL INSERT-SELECT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144933554307503)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'it'
,p_message_text=>'%0 durante il tentativo di ottenere dati JSON. URL: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145693489307504)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'it'
,p_message_text=>'Script INSERT INTO:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197389685306720)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'it'
,p_message_text=>'Origine dati built-in non valida: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145321170307504)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'it'
,p_message_text=>'Errore: i dati JSON sono nulli.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145037526307503)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'it'
,p_message_text=>'Oggetto non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145113079307504)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'it'
,p_message_text=>'Errore: nessuna riga richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144884463307503)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'it'
,p_message_text=>unistr('Troppe righe richieste. Il numero massimo di righe consentito \00E8 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103145271312307504)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore imprevisto durante il caricamento di %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197252278306720)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'it'
,p_message_text=>'%0 deve essere Y o N'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275030064306778)
,p_name=>'ONE'
,p_message_language=>'it'
,p_message_text=>'Uno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227681184306743)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'it'
,p_message_text=>'Solo installate'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102464609413306930)
,p_name=>'ON_LOAD'
,p_message_language=>'it'
,p_message_text=>'In caso di caricamento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665413558307116)
,p_name=>'OPEN'
,p_message_language=>'it'
,p_message_text=>'Apri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711079274307159)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'it'
,p_message_text=>'Aperti negli ultimi 7 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710104980307158)
,p_name=>'OPEN_BUGS'
,p_message_language=>'it'
,p_message_text=>'Bug aperti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709869989307158)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'it'
,p_message_text=>'Funzioni aperte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943630246307352)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Aperto, elaborazione del feedback in corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710042960307158)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0 aperte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317214736306810)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'it'
,p_message_text=>'Apri Websheet %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651274322307103)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'it'
,p_message_text=>'Attributo facoltativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431438655307733)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'it'
,p_message_text=>'Classi CSS per icone facoltative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651118746307103)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine facoltativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102651328534307103)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi immagine facoltativi'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954247884307360)
,p_name=>'ORACLE FORMS'
,p_message_language=>'it'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359088382307675)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('La stampa basata su Oracle REST Data Services \00E8 stata dichiarata non pi\00F9 valida in Oracle APEX 19.1 e non \00E8 pi\00F9 supportata.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102209178786306729)
,p_name=>'OTHER'
,p_message_language=>'it'
,p_message_text=>'Altro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954852810307361)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'it'
,p_message_text=>'Altri file di area di lavoro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703771064307152)
,p_name=>'OTN'
,p_message_language=>'it'
,p_message_text=>'Oracle Technology Network'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703802840307152)
,p_name=>'OTN_FORUM'
,p_message_language=>'it'
,p_message_text=>'Forum di discussione di Oracle Technology Network'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102833896168307268)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'it'
,p_message_text=>'ID sostituzione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103409929623307717)
,p_name=>'OVERVIEW'
,p_message_language=>'it'
,p_message_text=>'Panoramica'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391410659306871)
,p_name=>'OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238442991306751)
,p_name=>'OWNERS'
,p_message_language=>'it'
,p_message_text=>'Proprietari'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102615402936307065)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione query SQL'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753063820307198)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365886738306851)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile eliminare questa LOV. \00C8 utilizzata nelle pagine %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102715705822307163)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento di associazione (immettere il nome elemento)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364510812307679)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'it'
,p_message_text=>'Potrebbe essere necessario un aggiornamento.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367311683307681)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Aggiungi Deployment Server'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641928018307095)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'it'
,p_message_text=>'Sfoglia database link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637974652307092)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'it'
,p_message_text=>unistr('L''operazione di creazione del database link non \00E8 riuscita per il seguente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638027914307092)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('Il database link "%0" \00E8 stato creato nello schema "%1".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410960837306886)
,p_name=>'PACKAGE'
,p_message_language=>'it'
,p_message_text=>'package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585547850307037)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'it'
,p_message_text=>unistr('Applicazione di produttivit\00E0 o di esempio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248299333306758)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>unistr('Applicazioni di produttivit\00E0 e di esempio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797397988307239)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''installazione dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628691819307085)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'it'
,p_message_text=>'Package body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775023605307218)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'it'
,p_message_text=>'-Globale-'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102392984343306872)
,p_name=>'PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713306723307161)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione calcolo area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793644763307235)
,p_name=>'PAGE HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705806700307154)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Intestazione pagina, corpo e pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713633551307161)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito elemento di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713885754307161)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione di visualizzazione dell''elemento di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714089634307161)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'it'
,p_message_text=>'Lista di valori di elementi di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713730038307161)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Calcolo successivo elemento di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713933029307161)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione di visualizzazione in sola lettura dell''elemento di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713556552307161)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine elemento di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629066571307085)
,p_name=>'PAGE ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706633161307155)
,p_name=>'PAGE PROCESS'
,p_message_language=>'it'
,p_message_text=>'Processo di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706765795307155)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione di elaborazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713461684307161)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione convalida pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642997695307096)
,p_name=>'PAGES'
,p_message_language=>'it'
,p_message_text=>'pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857006988307285)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687543495307137)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'it'
,p_message_text=>'Eventi di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723710884307171)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'it'
,p_message_text=>'Eventi pagina: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439911415307740)
,p_name=>'PAGE_FINDER'
,p_message_language=>'it'
,p_message_text=>'Strumento di ricerca pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102202328669306724)
,p_name=>'PAGE_GROUP'
,p_message_language=>'it'
,p_message_text=>'Gruppo di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723226791307170)
,p_name=>'PAGE_HELP'
,p_message_language=>'it'
,p_message_text=>'Identifica la pagina nell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888457211307308)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'it'
,p_message_text=>'Pagina %0 bloccata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888533479307308)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'it'
,p_message_text=>'Pagina %0 sbloccata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733776251307180)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Pagina di applicazione installata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629582022307086)
,p_name=>'PAGE_ITEM'
,p_message_language=>'it'
,p_message_text=>'elemento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839627993307272)
,p_name=>'PAGE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Pagina: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674432325307124)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'it'
,p_message_text=>'Pagina bloccata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102582961181307035)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'it'
,p_message_text=>'Pagina bloccata da %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703460579307152)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('il nome pagina \00E8 obbligatorio per tutte le pagine')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687337520307137)
,p_name=>'PAGE_POSTS'
,p_message_language=>'it'
,p_message_text=>'Invii di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857191172307285)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'it'
,p_message_text=>'Processi di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239183808306751)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Elaborazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724541288307171)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'it'
,p_message_text=>'Protezione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404423567306881)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404617546306881)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'it'
,p_message_text=>'Destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404507121306881)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404294578306881)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404392928306881)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404168995306881)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Nascondi origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102404001388306881)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Mostra origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403817994306880)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403695286306880)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403980821306881)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403785738306880)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326610720306817)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione della pagina %0 riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705714718307154)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102674549751307125)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'it'
,p_message_text=>'Pagina sbloccata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687467046307137)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'it'
,p_message_text=>'Visualizzazioni di pagina'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683184311307133)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'it'
,p_message_text=>'Numero funzione padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793381727307235)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna di report padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102955077406307361)
,p_name=>'PARENT_TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953363491307359)
,p_name=>'PARENT_TABS'
,p_message_language=>'it'
,p_message_text=>'Schede padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397610369306876)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397748857306876)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'it'
,p_message_text=>'Nuovo set di schede padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397823415306876)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo scheda padre'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954059597307360)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede padre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242374879306754)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema di analisi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239256873306751)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina parziale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222547844306739)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'it'
,p_message_text=>'Password scaduta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210260897306729)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'it'
,p_message_text=>'La password di questo account deve essere modificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222496900306739)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'it'
,p_message_text=>'Password valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230259191306745)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Password (sottomessa se si preme Invio)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747069098307192)
,p_name=>'PAST_DUE'
,p_message_language=>'it'
,p_message_text=>'Scaduto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836986903307271)
,p_name=>'PATH'
,p_message_language=>'it'
,p_message_text=>'Percorso'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996456860307391)
,p_name=>'PCT_CLOSED'
,p_message_language=>'it'
,p_message_text=>'% di chiusura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992778356307389)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formattazione grafica per le percentuali, numeri interi compresi tra 0 e 100'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905579161307321)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905625060307321)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242193012307587)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Calcoli di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242235038307587)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Calcolo applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907555479307322)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Elementi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907630456307322)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Elemento applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242361767307588)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Processi di applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242462678307588)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Processo applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907966554307323)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Autenticazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908080284307323)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908166502307323)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Autorizzazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908266721307323)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142752958307502)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Automazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142859650307502)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379494717307690)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Azioni di automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379521600307690)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Azione di automazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911711613307329)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Diramazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911835554307329)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908346264307323)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Indicatori di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908472341307323)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242593016307588)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Voci di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242623548307588)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Voce di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906995348307322)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907086267307322)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907706596307322)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Opzioni di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907878787307322)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Opzione di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910585514307328)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910603929307328)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906506325307322)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906613068307322)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907139394307322)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di calendario precedenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907287282307322)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di calendario precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222983969307573)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223066193307573)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223116256307573)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223292650307573)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925141411307339)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925247952307339)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913389324307330)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913448366307330)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913515523307330)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913628235307330)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002741675307396)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002881905307396)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209751894307563)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Definizioni caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209880630307564)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Definizione caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909387843307324)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Definizioni caricamento dati precedenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909477397307324)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Definizione caricamento dati precedenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910993283307328)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911003210307328)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910774846307328)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Azioni dinamiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910847275307328)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Azione dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467311151306932)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467457347306932)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143077245307502)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143191274307502)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214345425307567)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Gruppi di facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214476406307567)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Gruppo di facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214537959307567)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Caselle di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214611008307567)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Casella di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906358493307321)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di campo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906405601307321)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di campo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753821530307198)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753944584307199)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754250833307199)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754316526307199)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754030820307199)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Gruppi di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754115970307199)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Gruppo di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754487883307199)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754589020307199)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221193217307572)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Report salvati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221862117307572)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Report salvato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911972284307329)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912005164307329)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912544466307329)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912619146307329)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912364769307329)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Gruppi di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912432852307329)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Gruppo di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002598382307396)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002644432307396)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912100124307329)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Report salvati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912276816307329)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Report salvato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801291506307242)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801380497307242)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801056366307242)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Assi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801103286307242)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Asse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801483037307242)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801580344307242)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371814888307685)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371997321307685)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908506872307323)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908608660307323)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242765028307588)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Voci di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242826305307588)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Voce di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906733250307322)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906812414307322)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908708144307323)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Liste di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908834489307323)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103242920315307588)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Voci di lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243053233307588)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Voce di lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148857389307507)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148989463307507)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149096839307507)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149126925307507)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148651224307506)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148761992307507)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910195172307327)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910243712307327)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911316696307328)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Calcoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911462734307328)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909903633307327)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Gruppi di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910064961307327)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Gruppo di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608576285307059)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Elementi pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608631090307059)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Elemento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911531632307328)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Processi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911652724307329)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913159634307330)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri autenticazione Basic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913218919307330)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro autenticazione Basic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912781154307329)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri IN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912846454307329)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro IN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102912993000307329)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri OUT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913037071307330)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro OUT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905977373307321)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906045796307321)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243582401307588)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243697370307588)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910393051307328)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102910437214307328)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201562496307557)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201669408307558)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138255519307498)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138332412307498)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906174871307321)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102906221677307321)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849354116307280)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849495053307280)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629988733307086)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Database remoti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630067058307086)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009783492307401)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Layout report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009835463307401)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Layout report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907365781307322)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Modelli di report classico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102907420619307322)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Modello di report classico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575920827307029)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576049613307029)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576119021307029)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Filtra gruppi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576227037307029)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Gruppo di filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576301175307029)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Caselle di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576440381307029)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Casella di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243137485307588)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Scorciatoie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243273561307588)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Scorciatoia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909570691307324)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Set di schede standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909689335307324)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Set di schede standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915538895307331)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915608016307331)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915758014307332)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915885717307332)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002932719307396)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003027518307396)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905732544307321)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905807355307321)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243368296307588)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Strutture'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243435038307588)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909760603307324)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Interfacce utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909893360307327)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911111924307328)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Convalide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102911283207307328)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102908933707307323)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Riferimenti a Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909004858307323)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Riferimento a Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909174415307323)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Operazioni Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102909208685307323)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Operazione Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378517228307690)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri autenticazione Basic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378619647307690)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro autenticazione Basic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378717678307690)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri intestazione HTTP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378835015307690)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro intestazione HTTP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378155293307689)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri IN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378231282307689)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro IN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378385731307690)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri OUT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378405929307690)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro OUT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743383874307189)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Origini dati REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743419358307189)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Origine dati REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854015469307283)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854175394307283)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849185992307279)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Operazioni di origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849218321307279)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Operazione di origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854230918307283)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri operazione origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854381562307283)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro operazione origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854452231307283)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Parametri origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854551096307283)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Parametro origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743578697307189)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Query origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743633941307189)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Query origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864995701307291)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379600496307690)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'it'
,p_message_text=>'Esecuzione codice aggiuntiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526325404306983)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'it'
,p_message_text=>'Avanzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526603609306983)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'it'
,p_message_text=>'Elementi interessati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803635873307244)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'it'
,p_message_text=>'Animazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527657928306984)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'it'
,p_message_text=>'Aspetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524819452306982)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174569506306702)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'it'
,p_message_text=>'Informazioni di audit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526472151306983)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>'Autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243833730307589)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922481379307337)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527540198306984)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'it'
,p_message_text=>'Funzionamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897504927307315)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'it'
,p_message_text=>'Attributi BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223582784307574)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899831726307317)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'it'
,p_message_text=>'Formattazione di interruzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932571765307344)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi stato calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223311117307573)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'it'
,p_message_text=>unistr('Cardinalit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889006436307309)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'it'
,p_message_text=>'Lista di valori a catena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924045490307338)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394479453307702)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione lato client'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379799953307691)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'it'
,p_message_text=>'Codice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925798713307339)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'it'
,p_message_text=>'Colori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003486668307397)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001885138307395)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtro colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859750623307287)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'it'
,p_message_text=>'Formattazione colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003399557307396)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'it'
,p_message_text=>'Intestazioni di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802955386307244)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'it'
,p_message_text=>'Mapping colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524938903306982)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'it'
,p_message_text=>'Commenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526273080306983)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525132759306982)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'it'
,p_message_text=>'Configurazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436666561306907)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'it'
,p_message_text=>'Conferma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935183347307346)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'it'
,p_message_text=>'Controlli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525282833306982)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'it'
,p_message_text=>'CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621826022307080)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'it'
,p_message_text=>'Personalizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925556497307339)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario giornaliero e settimanale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243985272307589)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'it'
,p_message_text=>'Sessione database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924199924307338)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'it'
,p_message_text=>'Griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802863741307244)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'it'
,p_message_text=>'Cursore dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526704814306983)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888981914307309)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'it'
,p_message_text=>'Dipendente da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865018922307291)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865199652307291)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista dei dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933749674307345)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865214128307291)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'Scarica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925814969307339)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'it'
,p_message_text=>'Trascinamento della selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803515915307244)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'it'
,p_message_text=>'Assi Y doppio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754766837307199)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887088288307307)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'it'
,p_message_text=>'Modifica autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526846491306983)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754610409307199)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'it'
,p_message_text=>'Consenti agli utenti di'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932691831307344)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voce'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525067445306982)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525382164306982)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'it'
,p_message_text=>'Gestione errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526131072306983)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni di esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893484990307312)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'it'
,p_message_text=>'Esporta/stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899960285307317)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Elaborazione esterna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147864381307506)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'it'
,p_message_text=>'Data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923987491307338)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'it'
,p_message_text=>'Controllo temporale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345637031307666)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'it'
,p_message_text=>'Viewport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923594079307337)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'it'
,p_message_text=>'Misuratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525408324306982)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Intestazione e pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900149667307317)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'it'
,p_message_text=>'Intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525567709306982)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526921424306984)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525664264306982)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223749940307574)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'it'
,p_message_text=>'Icona e badge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865390378307291)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista icone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524665237306981)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Identificazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525771636306982)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'it'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527047457306984)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527742551306984)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'it'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923035824307337)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'it'
,p_message_text=>'Legenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803088925307244)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'it'
,p_message_text=>'A linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880178294307302)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'it'
,p_message_text=>'Collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987006997307384)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527117900306984)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925642989307339)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario vista Agenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355483010307673)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Post-elaborazione locale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621264610307070)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Elaborazione login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803255296307244)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'it'
,p_message_text=>'Graduazioni maggiori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149327692307507)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'it'
,p_message_text=>'Livelli di zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149284749307507)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'it'
,p_message_text=>'Mappa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149804160307508)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'it'
,p_message_text=>'Finestra informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149487271307507)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'it'
,p_message_text=>'Posizione iniziale e zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149689579307507)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'it'
,p_message_text=>'Configurazione cluster punti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149530241307507)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'it'
,p_message_text=>'Oggetti punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149781669307508)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'it'
,p_message_text=>'Assegnazione righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923172231307337)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'it'
,p_message_text=>'Margine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803157219307244)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'it'
,p_message_text=>'A indicatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948631058307356)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Master-Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223856584307574)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'it'
,p_message_text=>'Supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900054737307317)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'it'
,p_message_text=>'Messaggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803331533307244)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'it'
,p_message_text=>'Graduazioni minori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925397493307339)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario mensile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327671642306818)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'it'
,p_message_text=>'Valori multipli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656998237307108)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'it'
,p_message_text=>unistr('Dati grafico a pi\00F9 serie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244055427307589)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667587908307118)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431512714307733)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011479746307403)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Output'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102802716997307243)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'it'
,p_message_text=>'Panoramica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003288736307396)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003628445307397)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003515081307397)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865437236307291)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'it'
,p_message_text=>'Impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885425381307306)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'it'
,p_message_text=>'Parametro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754989746307200)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'it'
,p_message_text=>'Prestazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621373007307080)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'it'
,p_message_text=>'URL successivo al logout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917950627307333)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003199000307396)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103243721329307589)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'it'
,p_message_text=>'Query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527243374306984)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'it'
,p_message_text=>'Selezioni rapide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525858408306983)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'it'
,p_message_text=>'Sola lettura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621441536307080)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'it'
,p_message_text=>'Real Application Security'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366643019306851)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'it'
,p_message_text=>'Righe di riferimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886524178307307)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630184084307086)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'it'
,p_message_text=>'Cache remota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845712473307277)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223624658307574)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo secondario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102525975563306983)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'it'
,p_message_text=>'Sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923211164307337)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'it'
,p_message_text=>'Colore serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526086108306983)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'it'
,p_message_text=>'Cache server'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394362133307702)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione lato server'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244119035307589)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'it'
,p_message_text=>'Sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621588741307080)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi cookie di sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621692545307080)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'it'
,p_message_text=>'Sessione non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524744992306981)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865616207307292)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista a riga singola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865533642307291)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'it'
,p_message_text=>'Ordinamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527366850306984)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'it'
,p_message_text=>'Origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621786897307080)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Sottoscrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223457515307573)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'it'
,p_message_text=>'Sottotitolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881091214307303)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio di operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576555219307029)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'it'
,p_message_text=>'Suggerimenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431678547307733)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'it'
,p_message_text=>'Schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259337891306767)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'it'
,p_message_text=>'Soglie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803416115307244)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta di graduazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137719218307498)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'it'
,p_message_text=>'Scala temporale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923812209307338)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102754899359307199)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'it'
,p_message_text=>'Barra degli strumenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923798618307338)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'it'
,p_message_text=>'Descrizione comandi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916743481307332)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Riferimento impostazioni predefinite interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527469616306984)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923689541307338)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925485013307339)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Agenda settimanale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102526570979306983)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'it'
,p_message_text=>'Quando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923353949307337)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'it'
,p_message_text=>'Asse X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102923412247307337)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'it'
,p_message_text=>'Asse Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849582291307280)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'it'
,p_message_text=>'Scala di zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756644577307201)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare uno schema di autorizzazione per limitare il numero degli utenti che possono aggiungere le righe.',
'Per consentire a un utente finale di aggiungere le righe, lo schema di autorizzazione selezionato deve restituire TRUE.',
'Se non viene fornito alcuno schema di autorizzazione, tutti gli utenti potranno aggiungere le righe a questa griglia interattiva.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756584598307201)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759688553307204)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere un''etichetta alternativa per il pulsante Aggiungi. L''etichetta predefinita \00E8 <em>Aggiungi riga</em>.</p>'),
'        <p>Ad esempio, immettere <em>Aggiungi dipendente</em> per una griglia interattiva di gestione dei dipendenti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759573310307204)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta pulsante Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757847613307202)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se aggiungere una nuova riga se al momento la griglia interattiva non contiene record restituiti.',
unistr('        Il messaggio <em>Nessun dato trovato</em> non verr\00E0 mai visualizzato poich\00E9 vi sar\00E0 sempre almeno un record visualizzato.</p>'),
unistr('        <p>Nota: se non vengono eseguiti aggiornamenti per il record aggiunto in precedenza, il record non verr\00E0 inserito al salvataggio dell''area.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757766431307202)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aggiungi riga se vuota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241338303307587)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al facet. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216344019307568)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al gruppo di facet. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773038127307216)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
unistr('        <p>Nota: questa propriet\00E0 pu\00F2 essere utilizzata per apportare modifiche di stile all''elemento corrispondente quando la griglia interattiva \00E8 modificabile.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218095500307570)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'        <p>Nota: queste classi CSS verranno applicate alla tag elemento form HTML.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579912940307032)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al filtro. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580686793307033)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al gruppo di filtri. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217444465307569)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Aggiunta delle classi CSS <code>articlenumber</code> e <code>highlight</code> alla tag HTML del componente</dt>',
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217329009307569)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere sotto forma di lista separata da spazi le classi CSS aggiuntive da includere nel componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217220823307569)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559744428307014)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il pulsante interessato da questa azione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559633355307014)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395388508307702)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere la colonna o le colonne che dovranno essere interessate dall''azione.',
unistr('Se si specificano pi\00F9 colonne, separarne i nomi con virgole.'),
unistr('<p>\00C8 possibile digitare il nome oppure effettuare una scelta nella lista delle colonne disponibili.'),
unistr('Se si effettua una scelta nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente verr\00E0 inserita una virgola, seguita dal nome della colonna restituito dalla lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395237150307702)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna/e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560119796307014)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un oggetto DOM (<code>documento</code>, <code>finestra</code>) o l''<em>ID</em> di un oggetto DOM (<code>myElementID</code>) come elemento interessato da questa azione.</p>',
unistr('<p>Nota: l''<em>oggetto DOM</em> non \00E8 pi\00F9 valido e deve essere sostituito da un''<em>espressione JavaScript</em> o da un <em>selettore jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560009325307014)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Oggetto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559902882307014)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere uno o pi\00F9 elementi di pagina interessati da questa azione.'),
unistr('Quando si specificano pi\00F9 elementi, usare una virgola per separare i nomi.'),
unistr('<p>\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559837231307014)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391764908307700)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Restituisce un riferimento all''oggetto DOM <code>window</code> del browser.</dt>',
'<dd><code>window</code></dd>',
'<dt>Restituisce un riferimento all''oggetto DOM <code>document</code> del browser.</dt>',
'<dd>document</dd>',
'<dt>Il selettore jQuery seleziona tutti gli elementi DIV con una classe ''alert'', quindi restituisce un oggetto jQuery che contiene tutti gli elementi padre.</dt>',
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391695846307699)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''espressione JavaScript che deve restituire un singolo oggetto DOM, un array di oggetti DOM o un oggetto jQuery come elementi interessati da questa azione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391576193307699)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050131757307433)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Per selezionare un elemento di pagina con l''ID DOM <code>my_id</code></dt>',
'<dd><pre>#my_id</pre></dd>',
'<dt>Per selezionare tutti gli elementi di pagina con la classe <code>my_class</code></dt>',
'<dd><pre>.my_class</pre></dd>',
'<dt>Per selezionare tutti gli elementi di pagina che costituiscono input</dt>',
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560385121307014)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere la sintassi del selettore jQuery per la restituzione di uno o pi\00F9 elementi di pagina che dovranno essere interessati da questa azione. Nella libreria jQuery \00E8 disponibile una sintassi di selezione molto potente che facilita l''accesso a u')
||unistr('no o pi\00F9 elementi da una pagina.</p>'),
'<p>Consultare la documentazione ufficiale disponibile nella <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">home page di jQuery</a> per ulteriori informazioni sulla sintassi del selettore.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560289512307014)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Selettore jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559510750307014)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''area interessata da questa azione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559491369307014)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559382950307014)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la modalit\00E0 di definizione dei componenti della pagina che saranno interessati dall''esecuzione dell''azione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048972108307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049015827307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>'L''azione interessa il pulsante selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394671331307702)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna/e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394774983307702)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'L''azione interessa l''unica colonna o le varie colonne immesse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049314892307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'it'
,p_message_text=>'Oggetto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049460435307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'it'
,p_message_text=>'L''azione interessa l''elemento di pagina identificato dall''oggetto DOM o dell''ID DOM immesso dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049988072307433)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'it'
,p_message_text=>'Origine evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050040984307433)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''azione interessa l''elemento di pagina da cui ha origine l''evento, che in alcuni casi pu\00F2 essere diverso da "Elemento di trigger".</p>'),
unistr('<p>In questa configurazione avanzata, l''elemento di trigger specificato \00E8 di solito un elemento contenitore, ad esempio un''area, che gestisce gli eventi generati da tutti i relativi elementi secondari (ad esempio gli elementi di pagina dell''area).'),
unistr('Questo tipo di selezione pu\00F2 essere quindi utilizzato per agire sull''elemento secondario che ha attivato l''evento anzich\00E9 sull''elemento contenitore.'),
unistr('Se ad esempio si dispone di un''azione dinamica che definisce un evento <strong>''Modifica''</strong> su un''area della pagina, l''azione interesser\00E0 l''elemento dell''area che \00E8 stato effettivamente modificato.</p>'),
unistr('<p>L''utilizzo di <em>''Origine evento''</em> pu\00F2 rappresentare un modo pi\00F9 efficace per la definizione dei funzionamenti comuni che interessano numerosi elementi di pagina.'),
unistr('La capacit\00E0 degli elementi contenitori di rilevare gli eventi generati dagli elementi secondari dipende dal tipo di evento.'),
'Di seguito sono riportati i tipi di evento che supportano il rilevamento.</p>',
'<ul>',
'  <li><strong>Dopo l''aggiornamento</strong> (apexafterrefresh)</li>',
'  <li><strong>Prima dell''aggiornamento</strong> (apexbeforerefresh)</li>',
'  <li><strong>Modifica</strong> (change)</li>',
'  <li><strong>Clic</strong> (click)</li>',
'  <li><strong>Doppio clic</strong> (dblclick)</li>',
'  <li><strong>Elemento attivo selezionato</strong> (focus)</li>',
'  <li><strong>Tasto premuto</strong> (keydown)</li>',
'  <li><strong>Pressione tasto</strong> (keypress)</li>',
'  <li><strong>Rilascio tasto</strong> (keyup)</li>',
'  <li><strong>Elemento attivo deselezionato</strong> (blur)</li>',
'  <li><strong>Pressione pulsante del mouse</strong> (mousedown)</li>',
'  <li><strong>Rilascio pulsante del mouse</strong> (mouseup)</li>',
'  <li><strong>Spostamento mouse</strong> (mousemove)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048759942307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048834066307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'L''azione interessa l''unico elemento o i vari elementi di pagina immessi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391317266307699)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391463850307699)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'L''azione interessa l''elemento o gli elementi di pagina restituiti mediante l''espressione JavaScript immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049502972307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'it'
,p_message_text=>'Selettore jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049623952307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>'L''azione interessa l''elemento o gli elementi di pagina restituiti mediante la sintassi del selettore jQuery immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049147386307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049236028307432)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'L''azione interessa l''area selezionata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049712301307433)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'it'
,p_message_text=>'Elemento di trigger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103049843803307433)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'L''azione interessa l''elemento o il componente di pagina che ha attivato l''azione dinamica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559231267307013)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671807660307122)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuna aggregazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102671956672307122)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Restituisce la colonna valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322159377307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare le modalit\00E0 di aggregazione della colonna dei valori di grafico associati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323699747307650)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti approssimativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323757967307650)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Restituisce il numero approssimativo dei valori distinti. Questa aggregazione risulta molto pi\00F9 veloce dell''aggregazione <em>Conteggio distinti</em> quando si elaborano grandi quantit\00E0 di dati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322625245307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'it'
,p_message_text=>'Media'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322745939307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'it'
,p_message_text=>'Restituisce la media della colonna dei valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322271592307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'it'
,p_message_text=>'Conteggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322360465307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'it'
,p_message_text=>'Restituisce il numero dei record.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323479982307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323523721307650)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'it'
,p_message_text=>'Restituisce il numero esatto dei valori distinti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323293916307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'it'
,p_message_text=>'Massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323329959307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'it'
,p_message_text=>'Restituisce il valore massimo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322871704307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'it'
,p_message_text=>'Mediana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322948397307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Restituisce il numero intermedio, ignorando i valori nulli. Questo tipo di aggregazione \00E8 particolarmente adatto per i modelli di distribuzione continua in quanto restituisce il numero centrale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323021954307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'it'
,p_message_text=>'Minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323167928307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Restituisce il valore minimo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322468073307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'it'
,p_message_text=>'Somma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322545257307649)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'it'
,p_message_text=>'Restituisce il totale della colonna dei valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103322048819307648)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aggregazione valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538659846306994)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selezionare se l''utente finale \00E8 autorizzato a sottomettere pi\00F9 volte la stessa pagina.'),
'Utilizzare questa funzione per evitare che vengano eseguiti inserimenti duplicati nella stessa tabella.',
unistr('Ci\00F2 pu\00F2 verificarsi quando un utente finale fa clic sul pulsante Indietro del browser e quindi sottomette nuovamente la pagina oppure se fa clic sul pulsante Ricarica del browser.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040235752307425)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'No - Impedisci il nuovo invio della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040329035307425)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC - Consenti il nuovo invio della pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538534926306994)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Consenti sottomissioni di pagina duplicate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868475890307294)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se le colonne con valori nulli devono essere nascoste nella vista a record singolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868325025307293)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Escludi valori nulli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868690019307294)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se nella vista a record singolo devono essere visualizzate solo le colonne visualizzate al momento. Se si specifica <strong>Non attivo</strong>, anche le colonne non visualizzate del report potranno essere mostrate nella vista a record si'
||'ngolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868544132307294)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Solo colonne visualizzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862587786307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono aggregare questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862456453307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aggrega'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862996521307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono utilizzare questa colonna in un grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862807708307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862707825307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono utilizzare questa colonna in una colonna di calcolo da essi definita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862653160307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Calcola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862332351307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono utilizzare questa colonna in un''interruzione di controllo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862220709307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Interruzione di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861927984307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono filtrare questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861846206307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863101400307290)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono effettuare operazioni di raggruppamento in base a questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863089464307290)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Raggruppa per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861563075307288)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono nascondere questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861497978307288)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nascondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862195449307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono evidenziare questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102862078985307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Evidenzia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175304619306703)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se un utente finale pu\00F2 definire una visualizzazione dettagliata di pivot per questo report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175245283306703)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876403091307300)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono salvare la propria definizione di report corrente come report <em>Pubblico</em>.</p>',
'<p>I report pubblici vengono visualizzati in una lista di selezione dei report disponibili nella barra di ricerca e vengono visualizzati per chiunque.',
unistr('L''opzione nel menu Azioni \00E8 disponibile solo per gli utenti autenticati e viene ulteriormente limitata se si popola anche <strong>Salva autorizzazione report pubblico</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876345376307299)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Salva report pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876236961307299)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono salvare la propria definizione di report corrente come report <em>Privato</em>.</p>',
'<p>I report privati vengono visualizzati in una lista di selezione dei report disponibili nella barra di ricerca e vengono visualizzati solo per l''utente che ha salvato il report, a condizione che sia stato autenticato.',
unistr('L''opzione nel menu Azioni \00E8 disponibile solo per gli utenti autenticati.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876178794307299)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Salva report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876684930307300)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono salvare le categorie di report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876552087307300)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Salva categorie report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861703932307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono ordinare questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861620523307289)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ordina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763314373307207)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere l''etichetta alternativa da usare nelle finestre di dialogo e nella vista a riga singola.',
'        Usare un''etichetta alternativa quando l''intestazione contiene elementi di formattazione extra, ad esempio tag HTML, che non vengono visualizzati in modo appropriato.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763277231307207)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta alternativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640187382307094)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se la convalida deve essere eseguita sempre.',
unistr('Se l''impostazione \00E8 <strong>Attivo</strong>, la convalida verr\00E0 valutata sempre, indipendentemente dall''impostazione di <em>Esegui convalide</em> definita per il pulsante che ha sottomesso la pagina.'),
unistr('Se l''impostazione \00E8 <strong>Non attivo</strong>, la convalida verr\00E0 valutata solo se l''impostazione di <em>Esegui convalide</em> del pulsante di trigger \00E8 <strong>Attivo</strong>.</p>'),
'<p>Nota: la convalida deve essere inoltre conforme alle condizioni specificate per poter essere valutata.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640007901307094)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Esegui sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806210691307247)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare se l''animazione viene mostrata quando i dati vengono modificati nel grafico. La modifica dei dati pu\00F2 verificarsi se il grafico viene aggiornato in modo automatico, se il funzionamento nascondi e mostra viene attivato quando si fa clic')
||' su un elemento di legenda oppure quando i dati del grafico vengono aggiornati a livello di programmazione mediante codice JavaScript personalizzato o un''azione dinamica.</p>',
'        <p>Le opzioni <strong>Sposta a sinistra</strong> e <strong>Sposta a destra</strong> non si applicano ai grafici a quadrante</p>.  '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806390114307247)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936831666307347)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica le impostazioni di animazione predefinite configurate in Oracle JET per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806611595307247)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946388775307354)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>'Non viene applicata alcuna animazione al grafico quando i dati vengono modificati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806482847307247)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'it'
,p_message_text=>'Sposta a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946183115307354)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'it'
,p_message_text=>'Gli elementi dati si spostano a sinistra quando i dati vengono modificati. Questa impostazione non si applica ai grafici Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806543427307247)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'it'
,p_message_text=>'Sposta a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946269494307354)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Gli elementi dati si spostano a destra quando i dati vengono modificati. Questa impostazione non si applica ai grafici Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806161457307247)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Alla modifica dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805629826307246)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il tipo di animazione utilizzato alla prima visualizzazione del grafico.</p>',
'        <p>Le opzioni <strong>Dissolvenza alpha</strong> e <strong>Zoom</strong> non si applicano ai grafici a quadrante.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805846954307246)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'it'
,p_message_text=>'Dissolvenza alpha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936593684307347)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica la dissolvenza al grafico alla prima visualizzazione. Questa impostazione non si applica ai grafici Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805709383307246)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936496632307347)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica le impostazioni di animazione predefinite configurate in Oracle JET per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806040214307247)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936764814307347)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>'Non viene applicata alcuna animazione al grafico alla prima visualizzazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805965050307246)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'it'
,p_message_text=>'Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936693559307347)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'it'
,p_message_text=>'Esegue un ingrandimento del grafico alla prima visualizzazione. Questa impostazione non si applica ai grafici Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805542861307246)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Alla visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218169023307570)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241225714307587)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218980529307570)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere sotto forma di lista separata da spazi le classi CSS aggiuntive da aggiungere al report. Il modello di report deve includere la stringa di sostituzione <code>#COMPONENT_CSS_CLASSES#</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772862652307216)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'',
unistr('        <p>Nota: queste classi CSS verranno applicate alle celle nella griglia interattiva. Per applicare le classi CSS all''elemento corrispondente, vedere la propriet\00E0 Classi CSS nel gruppo Avanzate.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217829311307569)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217952594307570)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi da aggiungere all''elemento. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.<p/>'),
unistr('        <p>Questa propriet\00E0 pu\00F2 essere utilizzata per apportare modifiche di stile all''elemento, oltre alle opzioni di modello, o per fornire un metodo di selezione dell''elemento mediante JavaScript pi\00F9 semplice.</p>'),
unistr('        <p>Nota: per applicare le classi CSS alla tag dell''elemento di form HTML, vedere la propriet\00E0 Classi CSS nel gruppo Avanzate.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218215910307570)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219198743307570)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219037851307570)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere sotto forma di lista separata da spazi le classi CSS aggiuntive da aggiungere al report. Il modello di report deve includere la stringa di sostituzione <code>#COMPONENT_CSS_CLASSES#</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217701984307569)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Aggiunta delle classi CSS <code>articlenumber</code> e <code>highlight</code> al componente</dt>',
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217636488307569)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217512972307569)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176837018306704)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare l''ambito di questo elemento di applicazione. Selezionare <strong>Globale</strong> se la sessione di &PRODUCT_NAME. \00E8 condivisa da pi\00F9 applicazioni e il valore dell''elemento deve essere uguale per tutte le applicazioni.'),
'In caso contrario, selezionare <strong>Applicazione</strong>, ovvero l''ambito predefinito.</p>',
'<p>Se le relative autenticazioni contengono gli stessi <em>attributi cookie di sessione</em>, le applicazioni possono condividere la stessa sessione.',
'L''attributo di ambito degli elementi di applicazione deve essere uguale anche in queste applicazioni.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072067905307450)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072113400307450)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'it'
,p_message_text=>'Globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176795086306704)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ambito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822801528307260)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la serie corrente \00E8 assegnata all''asse Y2 visualizzato nel grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822789177307260)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Assegnato all''asse Y2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640707466307094)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna associata a questo componente di elaborazione pagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640630523307094)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna associata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640538594307094)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare l''elemento in cui viene visualizzato questo messaggio di errore di convalida.',
'Se si seleziona un elemento e <em>Posizione di visualizzazione del messaggio di errore</em> include "In linea con campo", il messaggio di errore viene visualizzato sotto l''etichetta dell''elemento selezionato.',
'Se <em>Posizione di visualizzazione del messaggio di errore</em> non include "In linea con campo", questo attributo non influisce sulla visualizzazione del messaggio di errore.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640499648307094)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento associato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244263174307589)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622563430307081)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568193467307022)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare uno schema di autorizzazione da applicare alla pagina. Gli schemi di autorizzazione vengono definiti a livello di applicazione e possono essere applicati a numerosi elementi all''interno dell''applicazione.</p>',
'<p>Uno schema di autorizzazione viene valutato una volta per ogni sessione di applicazione (in fase di creazione della sessione) oppure una volta per ogni visualizzazione di pagina. Se lo schema di autorizzazione selezionato restituisce <strong>TRUE<'
||unistr('/strong>, la pagina viene visualizzata ed \00E8 soggetta ad altre condizioni definite. Se invece restituisce <strong>FALSE</strong>, la pagina non viene visualizzata e viene visualizzato un messaggio di errore.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537814748306994)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare uno schema di autorizzazione per controllare questo componente. L''autorizzazione deve restituire TRUE affinch\00E9 questo elemento venga visualizzato o eseguito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537703462306993)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528747706306985)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare lo schema di autorizzazione applicato. Sono supportati i tipi di autorizzazione seguenti:</p>',
'#NATIVE_PLUGINS#',
'<p>A seconda della configurazione dell''applicazione, qui potrebbero essere disponibili plugin per il tipo di autorizzazione aggiuntivi.',
'Questi plugin vengono visualizzati con il formato <em>&lt;My Plug-in&gt; [plugin]</em>.',
'I plugin seguenti vengono installati nei componenti condivisi dell''applicazione:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528667107306985)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380683388307691)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380949079307691)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380811169307691)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380791329307691)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381047986307691)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380582368307691)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381861279307692)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''origine dei dati valutati durante l''esecuzione dell''automazione. Le automazioni possono basarsi su tabelle, query SQL o funzioni PL/SQL che restituiscono una query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381740004307692)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381606775307692)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381510648307692)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''origine dei dati valutati durante l''esecuzione dell''automazione. Le automazioni possono basarsi su tabelle, query SQL o funzioni PL/SQL che restituiscono una query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381438263307692)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381345373307692)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381276745307692)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''origine dei dati valutati durante l''esecuzione dell''automazione. Le automazioni possono basarsi su tabelle, query SQL o funzioni PL/SQL che restituiscono una query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381114399307692)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382055620307692)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''origine dei dati valutati durante l''esecuzione dell''automazione. Le automazioni possono basarsi su tabelle, query SQL o funzioni PL/SQL che restituiscono una query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103381912569307692)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380103625307691)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380026544307691)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379941225307691)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''origine dei dati valutati durante l''esecuzione dell''automazione. Le automazioni possono basarsi su tabelle, query SQL o funzioni PL/SQL che restituiscono una query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379855872307691)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380436880307691)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380352471307691)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di azione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103380202096307691)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679157833307129)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare se l''interfaccia utente appropriata deve essere rilevata in modo automatico.',
unistr('Se il rilevamento automatico \00E8 <strong>Attivo</strong>, l''utente verr\00E0 reindirizzato automaticamente alla pagina di login pi\00F9 appropriata oppure alla home page, in base alla dimensione del dispositivo in uso.'),
'Per determinare l''interfaccia utente corrispondente da visualizzare vengono utilizzate le query di supporto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679083733307129)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Rilevamento automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824894586307261)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore massimo dell''asse. Assume per impostazione automatica un valore nullo per il calcolo automatico basato sui dati.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824734466307261)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824668701307261)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore minimo dell''asse. Assume per impostazione automatica un valore nullo per il calcolo automatico basato sui dati.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824580024307261)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825681757307262)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione delle etichette da visualizzare nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825747564307262)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826107631307262)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825913444307262)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825814810307262)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826069451307262)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'it'
,p_message_text=>'Inizio pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825576765307262)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848065620307279)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la scala dell''asse. Si applica solo agli assi numerici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848158822307279)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'it'
,p_message_text=>'Lineare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848238425307279)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'it'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847991267307279)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Scala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825433216307262)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''incremento tra gli indicatori di graduazione maggiori. Assume per impostazione automatica un valore nullo per il calcolo automatico basato sui dati. Si applica solo agli assi temporali e numerici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825313808307262)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Incremento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232352482307580)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare come badge.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232232830307580)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna badge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232591421307580)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232486906307580)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS badge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232875876307580)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Per visualizzare la valutazione di un film</dt>',
'    <dd>L''opzione Colonna badge potrebbe essere impostata su VALUTAZIONE e l''opzione Etichetta badge su "Stelle"</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232790004307580)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''etichetta per descrivere il valore del badge.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232649530307580)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta badge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927888738307341)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare la data di inizio del calendario. La selezione di questa opzione comporta la creazione di un calendario che copre un intervallo di tempo completo, ad esempio un mese.</p>',
'<ul>',
unistr('  <li>Se l''impostazione di Inizia a inizio intervallo \00E8 <strong>Attivo</strong>, la data \00E8 il 15 giugno e la modalit\00E0 di visualizzazione \00E8 impostata su Mensile, il calendario risultante andr\00E0 dal 1\00B0 giugno al 30 giugno.</li>'),
unistr('  <li>Se l''impostazione di Inizia a inizio intervallo \00E8 <strong>Non attivo</strong>, la data \00E8 il 15 giugno e la modalit\00E0 di visualizzazione \00E8 impostata su Mensile, il calendario risultante andr\00E0 dal 15 giugno al 30 giugno.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927723464307341)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Inizia a inizio intervallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899177549307316)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la colonna del set di caratteri nella tabella in cui \00E8 memorizzato il contenuto BLOB che si desidera visualizzare. Se si seleziona una colonna con un tipo dati errato, l''immagine non verr\00E0 visualizzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899040523307316)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna set di caratteri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898119113307315)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la colonna BLOB nella tabella in cui \00E8 memorizzato il contenuto BLOB che si desidera visualizzare. Se si seleziona una colonna con un tipo dati errato, l''immagine non verr\00E0 visualizzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898061708307315)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898908275307316)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere la colonna del nome file della tabella in cui \00E8 memorizzato il contenuto BLOB che si desidera visualizzare. Se si seleziona una colonna con un tipo dati errato, l''immagine non verr\00E0 visualizzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898838572307316)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna nome file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899398157307316)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la colonna di ultimo aggiornamento dalla tabella in cui \00E8 memorizzato il contenuto BLOB da visualizzare. Se si dispone gi\00E0 di una colonna <code>UPDATED</code> con un trigger associato per la gestione della data, \00E8 possibile usare questa c')
||'olonna invece di definirne in modo specifico una nuova per l''ultimo aggiornamento dell''immagine. Se tuttavia vengono aggiornate regolarmente altre colonne diverse dal contenuto BLOB, l''inserimento dell''immagine nella cache potrebbe risultare pregiudi'
||unistr('cato. Se si seleziona una colonna con un tipo dati errato, l''immagine non verr\00E0 visualizzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899261431307316)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna ultimo aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898786913307316)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la colonna del tipo MIME nella tabella in cui \00E8 memorizzato il contenuto BLOB che si desidera visualizzare. Se si seleziona una colonna con un tipo dati errato, l''immagine non verr\00E0 visualizzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898631977307316)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna tipo MIME'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898309534307315)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la prima colonna della chiave primaria nella tabella in cui \00E8 memorizzato il contenuto BLOB che si desidera visualizzare. Se la chiave primaria della tabella contiene pi\00F9 di due colonne, \00E8 necessario selezionare la colonna <code>ROWID</co')
||unistr('de>. Se si seleziona una colonna con un tipo dati errato, l''immagine non verr\00E0 visualizzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898295094307315)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna 1 chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898590453307316)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare solo la seconda colonna della chiave primaria se la chiave primaria della tabella contiene solo due colonne. Se si seleziona <code>ROWID</code> per la prima colonna della chiave primaria, questa colonna non deve essere popolata. Se si sel'
||unistr('eziona una colonna con un tipo dati errato, l''immagine non verr\00E0 visualizzata.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102898487412307316)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna 2 chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897933941307315)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere il nome della tabella in cui \00E8 memorizzato il contenuto BLOB che si desidera visualizzare.'),
unistr('\00C8 possibile digitare il nome della tabella oppure selezionarlo nella lista delle tabelle disponibili.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897830403307315)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897702396307315)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare lo schema proprietario della tabella in cui \00E8 memorizzato il contenuto BLOB che si desidera visualizzare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897628487307315)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Proprietario tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227925624307577)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il componente viene visualizzato mediante una colonna oppure una formattazione avanzata con espressioni HTML e le stringhe di sostituzione supportate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227827761307577)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formattazione avanzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228145921307577)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare come corpo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228072152307577)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228607569307577)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228515013307577)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537458439306993)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il testo o il codice HTML da visualizzare prima delle aree presenti nella pagina in esecuzione.',
'Il testo immesso viene visualizzato prima della stringa di sostituzione <code>#BODY#</code> del modello di pagina.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537359588306993)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Intestazione corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228442453307577)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Le sostituzioni <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> in questo esempio sono colonne selezionate nella query SQL del report.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228321203307577)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da mostrare in questa colonna. Usare la sintassi <code>&COLUMN.</code> per mostrare i valori di colonna in formato HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228255404307577)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919055429307334)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la richiesta da includere nel collegamento della diramazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918958397307334)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317349420307645)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317687717307645)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317559222307645)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317458859307645)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317775871307645)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317296123307645)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892701497307311)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere l''elemento di pagina o di applicazione che contiene il numero di pagina o l''URL di destinazione del reindirizzamento.',
unistr('Questo elemento pu\00F2 essere impostato dalla pagina chiamante o da un processo quando la pagina viene caricata per la prima volta.'),
'La specifica di un elemento facilita l''impostazione dinamica della diramazione per le pagine chiamate da numerose altre pagine.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892625121307311)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318596198307646)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione Java che restituisce un numero di pagina o un URL al quale eseguire il reindirizzamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318496732307646)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318323537307646)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318235613307646)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione JavaScript che restituisce un numero di pagina o un URL al quale eseguire il reindirizzamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318117390307646)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639099693307093)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la pagina alla quale viene reindirizzata questa diramazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638917463307093)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639236960307093)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il codice PL/SQL eseguito dalla diramazione. Questa procedura PL/SQL \00E8 responsabile del richiamo dell''URL necessario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639116296307093)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318036366307646)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317968251307645)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce un numero di pagina o un URL al quale eseguire il reindirizzamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317827275307645)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638687053307093)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il punto del rendering o dell''elaborazione della pagina in cui deve essere eseguita questa diramazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060554279307441)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'it'
,p_message_text=>'Dopo l''elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350142623307669)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'it'
,p_message_text=>'Elaborazione: segue la diramazione dopo l''esecuzione dell''elaborazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060257618307441)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'it'
,p_message_text=>'Dopo la sottomissione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349813038307669)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Elaborazione: segue la diramazione dopo la sottomissione della pagina e prima dell''esecuzione del calcolo, delle convalide e dei processi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060618371307441)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'it'
,p_message_text=>'Prima dell''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350212866307669)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: segue la diramazione prima della visualizzazione della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060496011307441)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'it'
,p_message_text=>'Elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350039366307669)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'it'
,p_message_text=>'Elaborazione: segue la diramazione prima dell''esecuzione dell''elaborazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060327950307441)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'it'
,p_message_text=>'Convalida in corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349926199307669)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Elaborazione: segue la diramazione prima dell''esecuzione delle convalide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638566748307092)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318786219307646)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione Python che restituisce un numero di pagina o un URL al quale eseguire il reindirizzamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318682094307646)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638408735307092)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il tipo di diramazione di pagina da eseguire.</p>',
'<dl>',
'<dt>Diramazioni con reindirizzamento</dt>',
'<dd>&PRODUCT_NAME. restituisce la nuova pagina o il nuovo URL al browser, che esegue una nuova richiesta prima di mostrare la pagina risultante.',
unistr('Il vantaggio pi\00F9 importante di questa opzione \00E8 costituito dalla possibilit\00E0 di aggiornare la pagina senza perdere il contesto, in quanto l''indirizzo del browser contiene l''URL di pagina completo.'),
'Lo svantaggio consiste nel fatto che il browser esegue una richiesta aggiuntiva per mostrare la pagina.</dd>',
'<dt>Mostra solo diramazioni</dt>',
'<dd>&PRODUCT_NAME. presenta immediatamente la nuova pagina nell''ambito dell''elaborazione della pagina corrente, senza eseguire un''altra richiesta.',
'Il vantaggio di questa opzione consiste nel fatto che il browser non deve eseguire un''altra richiesta.',
unistr('Lo svantaggio pi\00F9 importante consiste nel fatto che l''indirizzo del browser sar\00E0 <code>wwv_flow.accept</code>.'),
unistr('Se l''utente finale aggiorna la pagina, il browser chieder\00E0 di inviare di nuovo i dati, in quanto l''indirizzo del browser non \00E8 un URL di pagina completo.</dd>'),
'</dl>',
'<p>Oracle consiglia di selezionare uno dei tipi Diramazioni con reindirizzamento per garantire una migliore esperienza per l''utente finale.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059616767307440)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Funzione che restituisce una pagina (solo visualizzazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059717086307440)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'it'
,p_message_text=>'Funzione che restituisce un URL (reindirizzamento)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060168846307441)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'it'
,p_message_text=>'Elaborazione pagina {non comune}'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059903344307440)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Pagina identificata da un elemento (solo visualizzazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059529655307440)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'it'
,p_message_text=>'Pagina (solo visualizzazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060080133307441)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'it'
,p_message_text=>'URL identificato da un elemento (reindirizzamento)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059812423307440)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'Procedura PL/SQL [precedente]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059449052307440)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'it'
,p_message_text=>'Pagina o URL (reindirizzamento)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638331700307092)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176676719306704)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il modello di indicatore di percorso utilizzato con questo indicatore di percorso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176517955306704)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello di indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904733110307320)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo visualizzato dopo le colonne di interruzione quando viene visualizzata una riga di interruzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904614275307320)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dopo la riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904330505307320)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo visualizzato prima delle colonne di interruzione quando viene visualizzata una riga di interruzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904208377307320)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Prima della riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915034874307331)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuna interruzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916217475307332)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuna interruzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903561037307319)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il numero di colonne di report da incorporare nella formattazione di interruzione. Devono essere colonne consecutive, con inizio dalla prima colonna visualizzata nel report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082583427307458)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'it'
,p_message_text=>'Prima colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082652396307458)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'it'
,p_message_text=>'Prima e seconda colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082725823307458)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'it'
,p_message_text=>'Prima, seconda e terza colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903495574307319)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonne di interruzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903728854307320)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare in che modo le interruzioni hanno effetto sulla formattazione di visualizzazione del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083084589307458)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'it'
,p_message_text=>'Formattazione di interruzione predefinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083107419307458)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'it'
,p_message_text=>'Le interruzioni vengono visualizzate in un unico report senza ripetizione delle intestazioni per ogni interruzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082885818307458)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'it'
,p_message_text=>'Ripeti intestazioni su interruzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082991786307458)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'it'
,p_message_text=>'Il report visualizza numerosi report secondari con ripetizione delle intestazioni per ogni interruzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903699312307319)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904104988307320)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo visualizzato nelle interruzioni del report. Utilizzare le sostituzioni <code>#SUM_COLUMN_HEADER#</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904070325307320)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato interruzioni report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904523176307320)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo per la colonna di interruzione quando si visualizza un''interruzione di report. \00C8 possibile utilizzare le sostituzioni <code>#COLUMN_VALUE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904406753307320)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato interruzione colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903929024307320)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo per le intestazioni ripetute visualizzate per le interruzioni di report. \00C8 possibile utilizzare le sostituzioni <code>#COLUMN_VALUE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903887377307320)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato intestazioni ripetute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914248409307330)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355376744307673)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Usa l''impostazione definita negli attributi di sicurezza dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539488811306995)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se la cache \00E8 abilitata, il browser pu\00F2 salvare il contenuto delle pagine dell''applicazione nella propria cache, sia in memoria che su disco.'),
'Se un utente fa clic sul pulsante Indietro del browser, la pagina viene in genere caricata dalla cache e non dal server.',
unistr('Se la cache \00E8 disabilitata, il browser non procede al salvataggio del contenuto della pagina e richiede di nuovo la pagina dal server.</p>'),
'<p>Per motivi di sicurezza, Oracle consiglia di disabilitare la cache, in modo che il browser non memorizzi i dati riservati e richieda sempre le pagine in caso di modifica dell''URL.',
'In caso contrario, potrebbe essere possibile passare alla cronologia del browser dopo avere eseguito il logout e visualizzare il contenuto della sessione precedente memorizzato nella cache.',
'La disabilitazione della cache del browser evita inoltre eventuali problemi con il pulsante Indietro se utilizzato con pagine che usano la funzione di aggiornamento parziale, ad esempio i report interattivi.</p>',
unistr('<p>Se questo attributo \00E8 impostato su <strong>Disabilitato</strong>, &PRODUCT_NAME. invia l''intestazione HTTP <em>cache-control: no-store</em>, che indica al browser di non memorizzare nella cache il contenuto delle pagine su disco o in memoria.'),
unistr('Se l''attributo \00E8 impostato su <strong>Valore predefinito applicazione</strong>, il valore in runtime viene derivato dall''attributo <em>Cache del browser</em> dell''applicazione.</p>'),
'<p>Nota: questa funzione richiede l''uso di browser moderni che supportino la variabile di risposta dell''intestazione HTTP <code>cache-control</code>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042673134307427)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042582131307427)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539387270306995)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Cache del browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424274295307728)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>1. Si sta sviluppando un''applicazione per la quale sono previste numerose installazioni.',
'                                        Inoltre, per ogni installazione si desidera poter abilitare o disabilitare determinate funzioni dell''applicazione.',
unistr('                                        Con le opzioni di creazione \00E8 possibile sviluppare un''applicazione e, dopo averla installata, configurare le opzioni per includere o escludere le funzionalit\00E0 associate.'),
unistr('                                        \00C8 inoltre possibile utilizzare l''interfaccia API per esporre questa funzione all''interno dell''applicazione.'),
unistr('                                        Ci\00F2 consente agli utenti finali con privilegi di abilitare o disabilitare in modo selettivo le funzionalit\00E0 dell''applicazione.</p>'),
unistr('                                      <p>2. Si sta sviluppando una funzionalit\00E0 che non \00E8 ancora completa, pertanto non si desidera esporla agli utenti finali.'),
unistr('									    Utilizzando le opzioni di creazione \00E8 possibile disabilitare la funzionalit\00E0 nell''applicazione eseguita negli ambienti di test e di produzione.'),
unistr('									    Il vantaggio di questo approccio consiste nel fatto che l''applicazione pu\00F2 essere comunque distribuita senza includere una funzionalit\00E0 incompleta.</p>'),
unistr('                                      <p>3. Si desidera rimuovere dall''applicazione una funzionalit\00E0 ritenuta non necessaria, ma non si \00E8 certi che sia un''operazione sicura.'),
unistr('                                        In questo caso \00E8 possibile usare le opzioni di creazione per "impostare come commento" le istruzioni della funzionalit\00E0 specifica.'),
unistr('									    Se durante la distribuzione la funzionalit\00E0 rimossa fosse ritenuta necessaria, sar\00E0 possibile ricrearne un''istanza.'),
unistr('									    Se invece fosse ritenuta non necessaria, la funzionalit\00E0 potr\00E0 essere rimossa in tutta sicurezza dall''applicazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539696266306995)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare un''opzione di creazione per questo componente.</p>',
unistr('                                     <p>Le opzioni di creazione consentono di abilitare o disabilitare in modo condizionale i componenti e la funzionalit\00E0 di un''applicazione al momento dell''installazione oppure in runtime mediante un''interfaccia API ')
||'(APEX_UTIL.SET_BUILD_OPTION_STATUS).<br>',
unistr('                                       Mediante le opzioni di creazione \00E8 possibile impostare il componente in modo che venga incluso o escluso nell''applicazione runtime.</p>'),
unistr('									 <p><strong>Incluso</strong>: il componente \00E8 abilitato e fa parte dell''applicazione.</p>'),
unistr('									 <p><strong>Escluso</strong>: il componente \00E8 disabilitato e non fa parte dell''applicazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539548848306995)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Opzione di creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528139438306985)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare uno stato di opzione di creazione per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036535889307422)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'it'
,p_message_text=>'Escludi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036658044307422)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'it'
,p_message_text=>'Il motore di &PRODUCT_NAME. ritiene che questo componente non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036305838307422)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'it'
,p_message_text=>'Includi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036486119307422)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'it'
,p_message_text=>'Il motore di &PRODUCT_NAME. considera questo componente come parte della definizione dell''applicazione in runtime.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528023937306985)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641705885307095)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''azione da eseguire quando si fa clic sul pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062327372307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'it'
,p_message_text=>'Definita da azione dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062435656307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Non sottomette la pagina n\00E9 reindirizza a un''altra pagina. Il funzionamento del pulsante viene definito da un''azione dinamica.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062702989307443)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Pagina successiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062876237307443)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina successiva.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062900172307443)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Pagina precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063007958307443)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina precedente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061978460307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina in un''altra applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062031061307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Reindirizza a una pagina di un''altra applicazione, con attributi aggiuntivi facoltativi per la reimpostazione dell''impaginazione, l''impostazione del valore della richiesta, la cancellazione del contenuto della cache e l''impostazione dei valori deg'
||'li elementi nella pagina di destinazione.</p>',
'<p>Nota: il reindirizzamento a una pagina di un''altra applicazione si basa sul deep link abilitato nell''applicazione di destinazione. Per abilitare il deep link, andare agli attributi <em>Sicurezza</em> dell''applicazione e abilitare <em>Deep link</em'
||'>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061731969307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina in questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061880681307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a una pagina dell''applicazione corrente, con attributi aggiuntivi facoltativi per la reimpostazione dell''impaginazione, l''impostazione del valore della richiesta, la cancellazione del contenuto della cache e l''impostazione dei valori degl'
||'i elementi nella pagina di destinazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062185936307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062223168307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza all''URL di destinazione specificato dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062505624307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'it'
,p_message_text=>'Reimposta pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103062601476307443)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'it'
,p_message_text=>'Reimposta la pagina eseguendone l''aggiornamento completo e non l''aggiornamento parziale (PPR).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061578945307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'it'
,p_message_text=>'Sottometti pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061646155307442)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'it'
,p_message_text=>'Sottomette la pagina corrente con un valore REQUEST uguale al nome del pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641677068307095)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545089578307000)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il tipo di operazione SQL eseguita quando si fa clic su questo pulsante.',
'Questa selezione viene usata per attivare l''azione di database specificata all''interno dell''elaborazione automatica delle righe (DML).',
'Se non si seleziona un tipo, l''elaborazione del database viene eseguita con il valore REQUEST, impostato in base al <strong>nome pulsante</strong> definito per questo pulsante.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056530335307438)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'it'
,p_message_text=>'Azione SQL DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056345530307438)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'it'
,p_message_text=>'Azione SQL INSERT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056462247307438)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'it'
,p_message_text=>'Azione SQL UPDATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544972786307000)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Azione di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239765219307586)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di visualizzazione per definire l''aspetto di questo pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240006880307586)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'it'
,p_message_text=>'Icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240135646307586)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza solo l''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239814142307586)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239979852307586)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza solo l''etichetta del pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240234750307586)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'it'
,p_message_text=>'Testo con icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240332874307586)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza un''icona accanto all''etichetta del pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239665957307586)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341597468307663)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli attributi aggiuntivi visualizzati dopo la cella della tabella HTML che visualizza ogni singola opzione in un gruppo di scelta o in un set di caselle di controllo.',
unistr('\00C8 possibile includere HTML, JavaScript e collegamenti.</p>'),
unistr('<p>\00C8 possibile fare riferimento alle stringhe di sostituzione riportate di seguito.</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Ottiene il nome dell''elemento di form HTML al quale \00E8 associato questo elemento di pagina.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Ottiene il nome dell''elemento di pagina corrente.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341476167307662)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo post '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341396201307662)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli attributi aggiuntivi visualizzati prima della cella della tabella HTML che visualizza ogni singola opzione in un gruppo di scelta o in un set di caselle di controllo.',
unistr('\00C8 possibile includere HTML, JavaScript e collegamenti.</p>'),
unistr('<p>\00C8 possibile fare riferimento alle stringhe di sostituzione riportate di seguito.</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Ottiene il nome dell''elemento di form HTML al quale \00E8 associato questo elemento di pagina.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Ottiene il nome dell''elemento di pagina corrente.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341216983307662)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo pre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544876925307000)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se la pagina viene sottomessa e questo attributo \00E8 impostato su <strong>Attivo</strong>, vengono eseguite tutte le convalide definite per la pagina e anche quelle incorporate (verifica del valore richiesto, numero valido o data valida) sul lato se')
||'rver.',
unistr('Inoltre, se la <em>modalit\00E0 di compatibilit\00E0</em> dell''applicazione \00E8 impostata su <strong>5.1</strong> o versione successiva, anche &PRODUCT_NAME. eseguir\00E0 le convalide lato client, ad esempio l''elemento richiesto. Per ulteriori informazioni, vedere')
||unistr(' "Modalit\00E0 di compatibilit\00E0" nelle note di rilascio.'),
unistr('La pagina non verr\00E0 sottomessa fino a quando non saranno risolti tutti i problemi.</p>'),
unistr('<p>Se l''attributo \00E8 impostato su <strong>Non attivo</strong>, non vengono eseguite n\00E9 le convalide definite n\00E9 quelle incorporate.'),
'Se si desidera eseguire una convalida specifica, indipendentemente da questa impostazione, modificare la convalida e impostare l''attributo di convalida <strong>Esegui sempre</strong> su <strong>Attivo</strong>.</p>',
unistr('<p>Questo attributo \00E8 particolarmente utile per i pulsanti Elimina o Annulla nei casi in cui la maggior parte delle convalide non deve essere eseguita.'),
unistr('In genere, agli utenti non deve essere impedito di eseguire queste azioni se un elemento \00E8 nullo oppure \00E8 di un tipo errato.'),
unistr('Se tuttavia le azioni, ad esempio un''eliminazione, devono essere eseguite solo da utenti autorizzati, \00E8 importante impostare l''attributo di convalida corrispondente <strong>Esegui sempre</strong> su <strong>Attivo</strong> oppure assicurarsi della pr')
||'esenza di una condizione appropriata definita per il pulsante in modo che il pulsante venga visualizzato solo agli utenti autorizzati.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544758060307000)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Esegui convalide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241199999307587)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se usare il pulsante <strong>Normale</strong> o <strong>Predefinito</strong> per il rendering di questo pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544441934307000)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se usare il modello di pulsante <strong>Normale</strong> o <strong>Predefinito</strong> per il rendering di questo pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544365427306999)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240910763307586)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo da visualizzare sul pulsante. Se il tipo di visualizzazione del pulsante \00E8 un''icona, questo testo diventer\00E0 il testo alternativo per l''immagine dell''icona.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557716798307012)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Se il pulsante \00E8 di tipo testuale, immettere il testo da visualizzare sul pulsante. Se il pulsante \00E8 un''immagine, questo testo diventer\00E0 il testo ALT per l''immagine.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557632264307012)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568620177307022)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome utilizzato per fare riferimento al pulsante su cui viene fatto clic. Quando la pagina viene sottomessa, il valore di REQUEST viene impostato su questo nome di pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557507887307012)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome utilizzato per identificare questo pulsante nell''elaborazione di pagina successiva.',
'Durante la sottomissione della pagina, quando si fa clic su questo pulsante il valore REQUEST viene impostato sul nome immesso.</p>',
'<p>Il nome pulsante non deve essere necessariamente univoco per i pulsanti presenti nella stessa pagina o nella stessa area.',
unistr('\00C8 possibile definire pi\00F9 pulsanti con lo stesso nome pulsante che imposta lo stesso valore REQUEST quando si fa clic.'),
unistr('Ci\00F2 \00E8 utile per definire pulsanti con <strong>etichette pulsante</strong> o condizioni diverse, che devono eseguire la stessa elaborazione di pagina mediante la semplice valutazione del valore REQUEST comune.</p>'),
'<p>Se si assegna al pulsante il nome <code>FLOW_RESET_BUTTON</code>, il pulsante reimposta la pagina corrente senza sottometterla.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557482895307012)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340974458307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Quando si fa clic su questo pulsante, la pagina viene sottomessa e la richiesta di pagina viene impostata su questo valore. Se questo valore \00E8 nullo e l''opzione <em>Tipo origine richiesta</em> \00E8 impostata su <em>Valore statico</em>, come valore della')
||unistr(' richiesta verr\00E0 utilizzato il nome del pulsante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340869120307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Origine richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338827116307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Identifica il tipo di espressione contenuto nell''attributo origine richiesta. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340680588307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'it'
,p_message_text=>'Valore NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340742709307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare su NULL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339151902307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339212958307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore colonna immesso in <em>Colonna database</em>, che viene recuperato da un processo di recupero righe incorporato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340037660307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340161963307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore risultante dall''esecuzione dell''<em>espressione PL/SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340203470307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340371280307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dal <em>corpo funzione PL/SQL</em> immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339340060307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339584546307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340490929307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103340528571307662)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore della <em>preferenza</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339682006307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL (restituisce un valore singolo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339753642307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul primo valore restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339838146307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL (restituisce un valore separato da due punti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339972788307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare su un valore separato da due punti singolo, che concatena ogni valore di riga, restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338989965307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103339030475307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul testo immesso in <em>Valore statico</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103338726589307661)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo origine richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544654983307000)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Fare clic su Destinazione per richiamare una finestra di dialogo di tipo modale. \00C8 possibile immettere la destinazione che deve essere chiamata quando si fa clic su questo pulsante. Immettere una destinazione solo per i pulsanti che non devono richia')
||'mare un''elaborazione di pagina quando l''utente fa clic (ad esempio un pulsante Annulla).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544546353307000)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544290907306999)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un modello di pulsante per definire l''aspetto di questo pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544119252306999)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello di pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220481013307571)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita per la pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241517057307587)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controllare le modifiche non salvate quando viene fatto clic sul pulsante, se il controllo \00E8 abilitato a livello pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220136955307571)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se l''utente viene avvisato quando si tenta di passare ad altro contenuto e lasciare la pagina che contiene modifiche non salvate facendo clic sul pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220212540307571)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'it'
,p_message_text=>'Non controllare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222850251307573)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il controllo delle modifiche non salvate non verr\00E0 eseguito quando viene fatto clic sul pulsante. Questa impostazione pu\00F2 essere utilizzata per i pulsanti Annulla, Elimina e Applica modifiche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220052625307571)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Avvisa in presenza di modifiche non salvate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270746337307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271157736307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271068963307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270939039307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271266790307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270859109307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270669508307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272738441307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273008349307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272917864307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272894417307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273123673307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272617567307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546228030307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546122397307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547612398307003)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547537775307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272302339307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Java per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272238763307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273985993307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273860644307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272137397307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272004615307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione JavaScript per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271998321307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273784654307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273653534307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273577967307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546463077307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista di valori separata da due punti (:) per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546309742307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546844745307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero di pagina per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546752865307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547064458307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista separata da virgole di numeri di pagina per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546938563307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271842357307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271714225307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione PL/SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271608956307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273451340307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273362302307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione PL/SQL che restituisca un valore booleano per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103273259722307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546660593307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la preferenza utente che viene confrontata con il valore specificato per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546546924307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272542287307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Python per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103272483762307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274109461307612)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274064928307611)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271537632307610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente \00E8 un responsabile (manager) e il relativo reparto si trova a Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271420501307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103271303419307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424783051307728)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori se esistono una o pi\00F9 righe durante il controllo per determinare se il dipendente si trova nel reparto 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>Per la corretta restituzione dei valori se non esistono righe durante il controllo per determinare se il dipendente si trova nel reparto 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545860678307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545799709307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547278073307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore di testo per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547104669307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547807305307003)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore, comprese le stringhe di sostituzione <code>&ITEM.</code>, per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547762068307003)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628292019307085)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di condizione che deve essere soddisfatto per consentire l''inserimento dell''area nella cache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545615297307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare una condizione. Se la condizione restituisce <strong>TRUE</strong>, la pagina viene visualizzata dalla cache. Se la condizione restituisce <strong>FALSE</strong>, la pagina viene visualizzata in modo dinamico e non viene recuperata dalla '
||'cache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110910258307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'it'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252425050307595)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il componente verr\00E0 visualizzato sempre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109528668307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 Microsoft Internet Explorer versione 7.0 o successiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109601374307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 un browser con capacit\00E0 XHTML/CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109484289307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 Mozilla, Netscape versione 6.x/7x o successiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109780162307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 un browser di altro tipo (o una versione precedente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108171180307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo \00E8 contenuto nell''elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110195825307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'it'
,p_message_text=>'Lingua corrente = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256020572307598)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale sta eseguendo l''applicazione nella lingua immessa nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109867883307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'it'
,p_message_text=>unistr('La lingua corrente \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256277463307598)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale sta eseguendo l''applicazione in una delle lingue immesse nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110066290307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'it'
,p_message_text=>'Lingua corrente != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256176930307598)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale non sta eseguendo l''applicazione nella lingua immessa nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109935065307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'it'
,p_message_text=>unistr('La lingua corrente NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256378385307598)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale non sta eseguendo l''applicazione in una delle lingue immesse nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107327098307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente = pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254888193307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 uguale al valore immesso in <em>Pagina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107552640307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 in una lista separata da virgole')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255040880307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 contenuta nella lista separata da virgole immessa in <em>Pagine</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107440991307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente != pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254950572307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 diversa dal valore immesso in <em>Pagina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107690140307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente NON \00E8 in una lista separata da virgole')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255170214307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente non \00E8 contenuta nella lista separata da virgole immessa in <em>Pagine</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110232431307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: DAD_NAME = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110326126307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: DAD_NAME != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109079255307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'it'
,p_message_text=>'Errori di convalida in linea visualizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255800538307598)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'it'
,p_message_text=>'Un errore di convalida in linea viene visualizzato nella pagina, dopo la sottomissione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108417888307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108280284307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108336709307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo NON \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108584001307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105056744307474)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Righe restituite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252586105307595)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La query SQL restituisce una o pi\00F9 righe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270419827307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270562129307609)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'L''espressione restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105204982307474)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252765832307595)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Il corpo funzione restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110609934307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: HTTP_HOST = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110772750307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: HTTP_HOST != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108745557307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina/area NON \00E8 di sola lettura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255547399307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina e l''area padre, se necessario, vengono visualizzate in modo normale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108607263307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina/area \00E8 di sola lettura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255494189307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina o l''area padre, se necessario; la condizione ''Sola lettura'' restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106589655307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento non contiene spazi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254042232307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'it'
,p_message_text=>'Il valore dell''<em>elemento</em> selezionato non contiene spazi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106878069307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 alfanumerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254311989307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 alfanumerico, ovvero contiene solo lettere o numeri e nessun carattere speciale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106016716307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253511686307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106782351307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254256243307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106262099307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253779389307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105903157307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253436546307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106398185307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NULL o pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253801073307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 vuoto o \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106623279307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254145476307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106145611307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253604963307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106451210307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL e NON \00E8 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253998473307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 vuoto e non \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109295472307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'it'
,p_message_text=>'Report SQL (OK per visualizzare il pulsante Avanti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109300519307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'it'
,p_message_text=>'Report SQL (OK per visualizzare il pulsante Indietro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110817346307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'it'
,p_message_text=>'Mai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103109143770307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'it'
,p_message_text=>'Errori di convalida in linea NON visualizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255976145307598)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'it'
,p_message_text=>'Un errore di convalida in linea non viene visualizzato nella pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105160483307474)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Nessuna riga restituita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252673433307595)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>'La query SQL non restituisce righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107935594307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 in modalit\00E0 Per la stampa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255249808307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 stata impostata su ''in modalit\00E0 Per la stampa'' dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108046584307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente NON \00E8 in modalit\00E0 Per la stampa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255381553307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente non \00E8 stata impostata su ''in modalit\00E0 Per la stampa'' dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105308202307474)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Richiesta = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252846131307595)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105567648307474)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253047001307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 contenuta nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105493068307474)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Richiesta != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252959053307595)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 diversa dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105617635307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253184329307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina non \00E8 contenuta nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110400261307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: SERVER_NAME = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103110597162307478)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: SERVER_NAME != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108868783307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 autenticato (non \00E8 pubblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255657117307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale \00E8 collegato all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103108970801307477)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 pubblico (non ha eseguito l''autenticazione)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103255704295307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale non \00E8 collegato all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107100627307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza utente = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254605173307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della <em>preferenza</em> immessa \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107225493307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza utente != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254731482307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della <em>preferenza</em> immessa \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103106956889307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 in una lista separata da due punti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254437596307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107033334307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 in una lista separata da due punti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103254540988307597)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105705512307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253268852307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103105883104307475)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103253372110307596)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107895919307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente != pagina sottomessa (inviata)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103107773774307476)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente = pagina sottomessa (inviata)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545584160307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102546049802307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore da confrontare con la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545921364307001)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547491419307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore, comprese le stringhe di sostituzione <code>&ITEM.</code>, per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547336732307002)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365301758307680)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la lista separata da virgole degli elementi da cui dipende il contenuto inserito nella cache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365260930307680)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dipende dagli elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359313248307675)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il modo in cui il motore di &PRODUCT_NAME. pu\00F2 inserire il testo HTML nella cache lato server. Se pu\00F2 essere usata, la funzione di inserimento nella cache restituisce il risultato inserito nella cache anzich\00E9 eseguire di nuovo il calcolo.')
||unistr(' In questo modo si riduce sensibilmente il tempo di calcolo sul server. Questa funzione non \00E8 correlata alle capacit\00E0 di inserimento nella cache del browser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359615461307676)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359700040307676)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'it'
,p_message_text=>'Il contenuto viene inserito nella cache e utilizzato da tutti gli utenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359453064307675)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359576748307676)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'it'
,p_message_text=>'Il contenuto non viene inserito nella cache e calcolato per ogni richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360012944307676)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'it'
,p_message_text=>'Cache per sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360139148307676)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Il contenuto viene inserito nella cache in modo specifico per ogni sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359811110307676)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'it'
,p_message_text=>'Cache per utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359996753307676)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'it'
,p_message_text=>'Il contenuto viene inserito nella cache in modo specifico per ogni utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103359245383307675)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Inserimento nella cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539204435306995)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il periodo di tempo di validit\00E0 di una pagina inserita nella cache. Se il timeout scade, le richieste di pagina successive non utilizzeranno la pagina inserita nella cache.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040665619307425)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'it'
,p_message_text=>'10 secondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041209475307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'it'
,p_message_text=>'3 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042165595307427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'it'
,p_message_text=>'2 settimane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041349398307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'it'
,p_message_text=>'4 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041760491307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'it'
,p_message_text=>'2 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040918041307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'it'
,p_message_text=>'30 minuti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041456593307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'it'
,p_message_text=>'6 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042294950307427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'it'
,p_message_text=>'4 settimane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041879636307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'it'
,p_message_text=>'3 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042484533307427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'it'
,p_message_text=>'1 anno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041977881307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'it'
,p_message_text=>'4 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041010801307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'it'
,p_message_text=>'1 ora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041548260307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'it'
,p_message_text=>'12 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040711604307425)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'it'
,p_message_text=>'1 minuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040822103307425)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'it'
,p_message_text=>'10 minuti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042001718307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'it'
,p_message_text=>'1 settimana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042337317307427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'it'
,p_message_text=>'10 settimane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041119242307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'it'
,p_message_text=>'2 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103041637263307426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'it'
,p_message_text=>'1 giorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539135149306995)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Timeout cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086254078307460)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione dei valori di colonna</dt>',
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
'<dt>Visualizzazione di un''immagine in un evento del calendario</dt>',
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932482881307344)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo personalizzato da visualizzare nelle celle del calendario. \00C8 possibile immettere espressioni HTML e usare la sintassi <code>#COLUMN_NAME#</code> per mostrare i valori delle colonne. Questo tipo di visualizzazione consente di immett')
||unistr('ere pi\00F9 colonne nella visualizzazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932356559307344)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926602731307340)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare l''elemento di pagina o di applicazione che contiene la data di inizio del calendario visualizzato al momento per l''utente finale.',
'L''elemento selezionato viene utilizzato dal motore di &PRODUCT_NAME. quando l''utente finale effettua una selezione per andare al periodo precedente o successivo.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926510671307340)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927292611307340)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare i valori visualizzati nel calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085658823307460)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085790614307460)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'it'
,p_message_text=>'Usa l''attributo <strong>Colonna di visualizzazione</strong> per selezionare la colonna da visualizzare nella cella del calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085817324307460)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085933949307460)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'it'
,p_message_text=>'Consente di immettere un formato colonna personalizzato utilizzando le espressioni HTML e le stringhe di sostituzione supportate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086028451307460)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessun valore visualizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086137073307460)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>'Non viene visualizzato alcun dato nelle celle del calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927199318307340)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926891898307340)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare l''elemento di pagina o di applicazione che contiene la data di fine del calendario visualizzato al momento per l''utente finale.',
'L''elemento selezionato viene utilizzato dal motore di &PRODUCT_NAME. quando l''utente finale effettua una selezione per andare al periodo precedente o successivo.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926727010307340)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926048564307339)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il modello da utilizzare per il rendering del calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925930853307339)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927061497307340)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''elemento di pagina o di applicazione che contiene il tipo di calendario visualizzato al momento per l''utente finale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926990340307340)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239492846307585)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero di schede da visualizzare per pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239343209307585)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Schede per pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238284182307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Determina la posizione del pulsante sulla scheda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238341728307585)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'it'
,p_message_text=>'Chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238485480307585)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'it'
,p_message_text=>'Secondaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238125738307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237068800307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il tipo di azione da aggiungere al componente scheda.</p>',
unistr('<p>\00C8 possibile definire pi\00F9 azioni dello stesso tipo, ma solo le azioni pulsante vengono visualizzate pi\00F9 volte.'),
'Per tutti gli altri tipi di azione, viene visualizzata la prima condizione di visualizzazione TRUE e il resto viene ignorato.</p>',
unistr('<p>Le condizioni di visualizzazione possono essere definite in base ai valori delle colonne se la condizione di esecuzione \00E8 impostata per il controllo di ogni riga.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237127774307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237242137307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>'Aggiunge un pulsante alla scheda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237325995307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'it'
,p_message_text=>'Scheda completa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237440164307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggiunge un collegamento alla scheda completa. In genere questo tipo di azione deve essere definito una sola volta.',
'In caso di definizione multipla, aggiungere una condizione di visualizzazione basata sul valore della colonna e impostare il controllo per ogni riga.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237998150307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'it'
,p_message_text=>'Supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238054209307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggiunge un collegamento al supporto della scheda. In genere questo tipo di azione deve essere definito una sola volta.',
'In caso di definizione multipla, aggiungere una condizione di visualizzazione basata sul valore della colonna della scheda e impostare il controllo per ogni riga.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237727169307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'it'
,p_message_text=>'Sottotitolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237808160307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggiunge un collegamento al sottotitolo della scheda. In genere questo tipo di azione deve essere definito una sola volta.',
'In caso di definizione multipla, aggiungere una condizione di visualizzazione basata sul valore della colonna e impostare il controllo per ogni riga.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237582647307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103237689607307584)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggiunge un collegamento al titolo della scheda. In genere questo tipo di azione deve essere definito una sola volta.',
'In caso di definizione multipla, aggiungere una condizione di visualizzazione basata sul valore della colonna e impostare il controllo per ogni riga.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236965364307583)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225989783307575)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi CSS da applicare a ogni singola scheda. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225879121307575)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231197899307579)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione di una freccia che punta a destra</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231075203307579)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'        <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230944454307579)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332043241307656)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione di una freccia che punta a destra</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331987199307656)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'        <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331888255307656)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224382523307574)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questa propriet\00E0 determina le modalit\00E0 di disposizione delle schede nella pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224663987307574)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'it'
,p_message_text=>'Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224788707307574)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Le schede vengono sottoposte a wrapping se non possono essere pi\00F9 inserite orizzontalmente nella schermata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224498838307574)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'it'
,p_message_text=>'Griglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224588158307574)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'it'
,p_message_text=>'Consente di disporre le schede in una griglia di colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224804379307575)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'it'
,p_message_text=>'Orizzontale (riga)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224975818307575)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Le schede verranno posizionate le une sulle altre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224236173307574)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238687611307585)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''azione da eseguire quando si fa clic sul tipo di azione specificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238908115307585)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina in un''altra applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239053341307585)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Reindirizza a una pagina di un''altra applicazione, con attributi aggiuntivi facoltativi per la reimpostazione dell''impaginazione, l''impostazione del valore della richiesta, la cancellazione del contenuto della cache e l''impostazione dei valori deg'
||'li elementi nella pagina di destinazione.</p>',
'<p>Nota: il reindirizzamento a una pagina di un''altra applicazione si basa sul deep link abilitato nell''applicazione di destinazione. Per abilitare il deep link, andare agli attributi <em>Sicurezza</em> dell''applicazione e abilitare <em>Deep link</em'
||'>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238703027307585)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina in questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238860107307585)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a una pagina dell''applicazione corrente, con attributi aggiuntivi facoltativi per la reimpostazione dell''impaginazione, l''impostazione del valore della richiesta, la cancellazione del contenuto della cache e l''impostazione dei valori degl'
||'i elementi nella pagina di destinazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239186507307585)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239250746307585)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza all''URL di destinazione specificato dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103238570178307585)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351761802307670)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la prima colonna della chiave primaria dall''origine area. Se la chiave primaria di questa tabella contiene pi\00F9 di due colonne, \00E8 necessario selezionare la colonna <code>ROWID</code>. Se l''area \00E8 impostata per visualizzare la paginazione a')
||' scorrimento, la chiave primaria viene utilizzata per evitare la visualizzazione di righe duplicate. Se nell''area viene visualizzata un''immagine proveniente da una colonna BLOB, la chiave primaria viene utilizzata per recuperare l''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351644755307670)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna 1 chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352123973307670)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la prima colonna della chiave primaria dall''origine area. Se la chiave primaria di questa tabella contiene pi\00F9 di due colonne, \00E8 necessario selezionare la colonna <code>ROWID</code>. Se l''area \00E8 impostata per visualizzare la paginazione a')
||' scorrimento, la chiave primaria viene utilizzata per evitare la visualizzazione di righe duplicate. Se nell''area viene visualizzata un''immagine proveniente da una colonna BLOB, la chiave primaria viene utilizzata per recuperare l''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352023825307670)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna 1 chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351910905307670)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la seconda colonna della chiave primaria solo se la chiave primaria dell''origine area contiene due colonne. Se si seleziona <code>ROWID</code> per la prima colonna della chiave primaria, non \00E8 necessario popolare questa colonna. Se l''area')
||unistr(' \00E8 impostata per visualizzare la paginazione a scorrimento, la seconda chiave primaria viene utilizzata per evitare la visualizzazione di righe duplicate. Se nell''area viene visualizzata un''immagine proveniente da una colonna BLOB, la seconda chiave ')
||'primaria viene utilizzata per recuperare l''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351813963307670)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna 2 chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352302257307670)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la seconda colonna della chiave primaria solo se la chiave primaria dell''origine area contiene due colonne. Se si seleziona <code>ROWID</code> per la prima colonna della chiave primaria, non \00E8 necessario popolare questa colonna. Se l''area')
||unistr(' \00E8 impostata per visualizzare la paginazione a scorrimento, la seconda chiave primaria viene utilizzata per evitare la visualizzazione di righe duplicate. Se nell''area viene visualizzata un''immagine proveniente da una colonna BLOB, la seconda chiave ')
||'primaria viene utilizzata per recuperare l''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352252534307670)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna 2 chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103239586380307585)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'La scheda usa la colonna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892263614307311)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome della colonna di database con distinzione tra maiuscole e minuscole della lista di valori, utilizzata per eseguirvi una query utilizzando il valore del facet o del filtro padre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892143644307311)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429152923307731)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere le colonne che attivano l''aggiornamento di questa lista di valori.',
unistr('Quando si specificano pi\00F9 colonne, usare una virgola per separare i nomi.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista delle colonne disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome della colonna restituito dalla lista.</p>'),
'<p>La lista di valori viene aggiornata ogni volta che il valore di una qualsiasi delle colonne specificate viene modificato nella pagina.</p>',
'<p>Per limitare il numero di valori restituiti, utilizzare le colonne specificate in questo attributo nella <em>clausola WHERE</em> della query SQL di questa lista di valori.</p>',
unistr('<p>Se ad esempio si dispone delle colonne Marca auto e Modello, \00E8 possibile specificare Marca auto come colonna padre della LOV a catena nella definizione Lista di valori per Modello e usare Marca auto nella clausola WHERE di tale lista di valori.'),
unistr('In questo modo, a ogni modifica di Marca auto, la lista di valori per Modello verr\00E0 aggiornata e nella lista verranno visualizzati solo i valori per la marca di auto selezionata al momento.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429047232307731)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna/e padre'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892467408307311)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un facet che attivi l''aggiornamento di questa lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892376966307311)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Facet padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578853311307031)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il filtro che attiva l''aggiornamento di questa lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578789404307031)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Filtro padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543988673306999)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli elementi di pagina o di applicazione che attivano l''aggiornamento di questa lista di valori.',
unistr('Quando si specificano pi\00F9 elementi, usare una virgola per separare i nomi.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.</p>'),
'<p>La lista di valori viene aggiornata ogni volta che il valore di uno qualsiasi degli elementi specificati viene modificato nella pagina.</p>',
'<p>Per limitare il numero di valori restituiti, utilizzare gli elementi di pagina specificati in questo attributo nella <em>clausola WHERE</em> della query SQL di questa lista di valori.</p>',
unistr('<p>Se ad esempio si dispone degli elementi di pagina Marca auto e Modello, \00E8 possibile specificare Marca auto come elemento padre della LOV a catena nella definizione Lista di valori per Modello e usare Marca auto nella clausola WHERE di tale lista d')
||'i valori.',
unistr('In questo modo, a ogni modifica di Marca auto, la lista di valori per Modello verr\00E0 aggiornata e nella lista verranno visualizzati solo i valori per la marca di auto selezionata al momento.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543827864306999)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento/i padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889222982307309)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare in quali condizioni questa lista di valori viene aggiornata.</p>',
unistr('<p>Se l''impostazione \00E8 <strong>Attivo</strong>, la chiamata di aggiornamento per recuperare nuovi valori viene eseguita solo se tutti gli <em>elementi padre LOV a catena</em> sono NOT NULL.'),
unistr('Se uno degli elementi \00E8 NULL, si presume che la query LOV non restituisca alcuna riga.'),
'In casi del genere, le voci della lista di selezione vengono semplicemente cancellate nel browser senza eseguire un aggiornamento.</p>',
unistr('<p>Se l''impostazione \00E8 <strong>Non attivo</strong>, l''aggiornamento viene eseguito sempre.'),
'Questa opzione viene usata solo se si gestiscono in modo specifico gli <em>elementi padre LOV a catena</em> annullabili nella <em>clausola WHERE</em> della query SQL LOV.',
'Se gli elementi di pagina annullabili non vengono gestiti in modo corretto, vengono eseguite chiamate di aggiornamento non necessarie che non restituiscono mai alcuna riga.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102889174806307309)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento padre obbligatorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174726575306702)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza le credenziali utente dello sviluppatore autore dell''ultimo aggiornamento di questo attributo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174668717306702)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Autore modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174985943306703)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la data dell''ultimo aggiornamento dell''attributo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174816745306702)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Data modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924792730307338)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere l''altezza del grafico in pixel. Con questa modalit\00E0 viene definita un''altezza fissa per l''area del grafico. In alternativa, lasciare vuoto questo elemento se si desidera abilitare il ridimensionamento automatico dell''altezza del grafico.'),
unistr('L''altezza verr\00E0 impostata sull''altezza del browser.</p>'),
'<p>Per impostazione predefinita, un grafico creato su una pagina utilizzando l''interfaccia utente Smartphone jQuery Mobile non dispone di un valore di altezza impostato e viene ridimensionato in modo appropriato per adattarsi al dispositivo su cui vi'
||'ene visualizzato.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924604009307338)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924821676307338)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948580235307356)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la larghezza massima del grafico in pixel. La larghezza massima definisce una larghezza fissa per l''area del grafico.',
unistr('In alternativa, non specificare alcun valore per questo elemento per abilitare la modifica automatica della larghezza del grafico. La larghezza verr\00E0 impostata in modo automatico sul 100% dell''area.</p>'),
'<p>Per impostazione predefinita, un grafico creato utilizzando l''interfaccia utente di Smartphone jQuery Mobile non dispone di valore di larghezza impostato e viene ridimensionato in modo corretto per adattarsi al dispositivo su cui viene visualizzat'
||'o.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942921310307352)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza massima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943017806307352)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921655984307336)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il titolo da visualizzare nella parte superiore del grafico. Per i grafici Gantt, questo valore viene utilizzato solo per definire il titolo accessibile del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921556777307336)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150079712307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione dei dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150157812307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'it'
,p_message_text=>'Database locale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150211226307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''origine dei dati \00E8 il database locale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150781576307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'it'
,p_message_text=>'Origine area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150811425307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''origine dei dati \00E8 la posizione specificata nella definizione dell''origine area.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150392911307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'it'
,p_message_text=>'SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150446690307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''origine dei dati \00E8 un database remoto, con connessione definita mediante SQL abilitato per REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150539063307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'it'
,p_message_text=>'Origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150674679307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''origine dei dati \00E8 un Web Service RESTful definito tramite origini dati REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103149940452307508)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915393607307331)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la base per questa colonna del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073101033307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'it'
,p_message_text=>'* Selettore data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073049298307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'it'
,p_message_text=>'* Selettore data (classico)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072936636307450)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'it'
,p_message_text=>'* Visualizza come testo (salva lo stato)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072639652307450)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'it'
,p_message_text=>'Scarica BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250074421307593)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come collegamento per scaricare il file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072867267307450)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna nascosta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250230312307593)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Non visualizza la colonna ma \00E8 possibile farvi riferimento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073653476307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'it'
,p_message_text=>'* Campo nascosto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072584435307450)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'it'
,p_message_text=>'Visualizza immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249997328307593)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072403028307450)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'it'
,p_message_text=>'Collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249801179307593)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come collegamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072703542307450)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'it'
,p_message_text=>'Grafico di percentuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250183492307593)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come grafico di percentuale. Il valore recuperato deve essere compreso tra 0 e 100.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072261989307450)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'it'
,p_message_text=>'Testo non codificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249622955307593)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il valore della colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103072372369307450)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'it'
,p_message_text=>'Testo non codificato (basato su lista di valori)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249782302307593)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il valore restituito dalla lista di valori specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073767671307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'it'
,p_message_text=>'* LOV popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073860747307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'it'
,p_message_text=>'* LOV chiave popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073523509307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'it'
,p_message_text=>'* Gruppo pulsanti di scelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321153142307648)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321202660307648)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna utilizzando HTML o Markdown.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074007077307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'it'
,p_message_text=>'* Selettore di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073483735307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'it'
,p_message_text=>'* Lista di selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073930700307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'it'
,p_message_text=>'* Casella di controllo semplice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073289370307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'it'
,p_message_text=>'* Campo di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103073325464307451)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'it'
,p_message_text=>'* Area di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915248464307331)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914961646307331)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuna impaginazione (mostra tutte le righe)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916176496307332)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuna impaginazione (mostra tutte le righe)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901396615307318)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il tipo di impaginazione da utilizzare in questo report.',
'Di solito nel report viene effettivamente visualizzato solo un subset dei risultati.',
'L''impaginazione fornisce all''utente le informazioni relative al numero di righe e alla posizione corrente all''interno del set di risultati. Definisce inoltre lo stile dei collegamenti o dei pulsanti utilizzati per passare alla pagina precedente o suc'
||'cessiva.</p>',
unistr('<p>L''impaginazione pu\00F2 essere visualizzata nella parte superiore o inferiore del report oppure in entrambe le posizioni, e pu\00F2 essere posizionata a sinistra o a destra.</p>'),
unistr('<p>\00C8 inoltre possibile utilizzare uno stile di impaginazione semplificato, quale ad esempio <strong>Intervalli di righe da X a Y (con collegamenti Successivo e Precedente)</strong> per migliorare le prestazioni.'),
'L''uso dei tipi di impaginazione con formato "da X a Y di Z" richiede l''esecuzione di due query da parte del motore di &PRODUCT_NAME. per ottenere i risultati.',
'La prima query recupera i record correnti da visualizzare, mentre la seconda ottiene il conteggio totale dei record da visualizzare nel controllo dell''impaginazione.',
'Per i report basati su data set di dimensioni molto grandi o in caso di esecuzione di query che prevedono l''uso intenso della CPU, ad esempio per numerosi join di tabella non ottimali o condizioni particolarmente dispendiose, questa query aggiuntiva '
||unistr('pu\00F2 prolungare il tempo di elaborazione e la visualizzazione del report potrebbe richiedere pi\00F9 tempo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081708136307457)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'it'
,p_message_text=>'Utilizza pulsanti di impaginazione creati esternamente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081880846307457)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe da X a Y (con collegamenti Successivo e Precedente)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081188259307456)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe da X a Y (senza impaginazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081238209307457)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe da X a Y di Z (senza impaginazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081489569307457)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe 1-15 16-30 (con impaginazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081583342307457)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe 1-15 16-30 nella lista di selezione (con impaginazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081385215307457)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe da X a Y di Z (con impaginazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081607491307457)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'it'
,p_message_text=>'Motore di ricerca 1,2,3,4 (impaginazione in base a set)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901276867307318)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870884030307295)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il numero di icone da visualizzare per riga nella vista icone. Se si specifica il valore 5, verranno visualizzate cinque icone per riga del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069240406307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'it'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069327705307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'it'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069444130307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'it'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069573055307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'it'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069659804307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'it'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069796368307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'it'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069863146307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'it'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069989978307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'it'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070072480307448)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'it'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870787956307295)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonne per riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861325682307288)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''allineamento di visualizzazione della colonna. Tenere presente che la selezione dell''allineamento deve essere supportata dal modello di report selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065379027307445)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'it'
,p_message_text=>'al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065266104307445)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'it'
,p_message_text=>'inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065461666307445)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861248275307288)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Allineamento colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917680184307333)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un tipo di valore colonna predefinito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085244793307460)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085176042307459)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917560666307333)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772581551307216)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo dell''intestazione del gruppo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860539631307288)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo dell''intestazione per la colonna del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860495035307288)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290238702306789)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 ordinabile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199441971307556)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere la colonna contenente la chiave univoca per identificare una riga. Utilizzare questa pagina per fornire il valore della chiave primaria per un codice JavaScript personalizzato o gli handler di eventi di mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199341880307556)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859963353307287)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome della colonna del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859895128307287)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915198130307331)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916543778307332)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895614570307313)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se questa colonna deve essere ordinata in ordine decrescente. Se non si specifica il tipo di ordine preferito, la colonna verr\00E0 ordinata in ordine crescente (impostazione predefinita).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078443923307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'it'
,p_message_text=>'Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895571231307313)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Direzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895433858307313)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare la sequenza di ordinamento per questa colonna.',
'Per il corretto ordinamento dell''output dl report, ogni colonna deve avere una sequenza univoca.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077645769307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'it'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077790169307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'it'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077820817307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'it'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077904048307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'it'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078066411307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'it'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078137018307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'it'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078220858307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'it'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078376634307454)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'it'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895307028307313)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sequenza predefinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860166736307287)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il tipo di dati per la colonna del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860099710307287)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893814372307312)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere la larghezza della colonna in pixel.',
'Usare questo attributo durante la visualizzazione dei report nel browser.',
'Tenere presente che la funzione di impostazione della larghezza delle colonne deve essere supportata dal modello di report selezionato.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893719642307312)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza cella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924282081307338)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528572867306985)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere i commenti o le note degli sviluppatori in questa sezione. Questi commenti vengono visualizzati solo nell''App Builder e non vengono mai visualizzati durante l''esecuzione dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528418074306985)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Commenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225721461307575)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi CSS da applicare al componente. Questa classe verr\00E0 applicata al contenitore di schede. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225694767307575)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285773143307621)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286169252307621)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286026662307621)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285903523307621)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286286174307621)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285832740307621)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285649754307621)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287755989307622)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288058210307622)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287919870307622)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287872904307622)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288196214307623)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287642203307622)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532516763306989)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione popolato da questo calcolo. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532430433306989)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533399841306989)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento il cui valore viene usato per popolare l''elemento di calcolo. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533294963306989)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287341582307622)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Java che produca un valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287289684307622)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288910708307623)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca un valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288882531307623)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287197402307622)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287040838307622)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione JavaScript che produca un valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286962469307622)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288731893307623)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288666670307623)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca un valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288571589307623)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286840414307621)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286798747307621)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione PL/SQL che produce un valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286607292307621)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288427493307623)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288337641307623)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce il valore usato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103288250075307623)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533944593306990)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il punto del rendering o dell''elaborazione della pagina in cui deve essere eseguito questo calcolo.',
unistr('Il punto di calcolo pi\00F9 frequente \00E8 <strong>Dopo la sottomissione</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045969446307429)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Dopo le aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347337892307667)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito dopo la visualizzazione delle aree.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046134506307430)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'it'
,p_message_text=>unistr('Dopo il pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347504565307667)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Rendering: eseguito dopo la visualizzazione del pi\00E8 di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045760288307429)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'it'
,p_message_text=>'Dopo l''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347112614307667)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito dopo la visualizzazione dell''intestazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046206093307430)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'it'
,p_message_text=>'Dopo la sottomissione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347648279307667)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'it'
,p_message_text=>'Elaborazione: eseguita dopo la sottomissione della pagina, ma prima dell''elaborazione della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045854938307429)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Prima delle aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347281594307667)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito prima della visualizzazione delle aree.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046011704307429)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'it'
,p_message_text=>unistr('Prima del pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347408429307667)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Rendering: eseguito prima della visualizzazione del pi\00E8 di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045677023307429)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'it'
,p_message_text=>'Prima dell''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347043920307667)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito prima della visualizzazione della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045532691307429)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'it'
,p_message_text=>'Nuova sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346925977307666)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Eseguito quando viene generata una nuova sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533864015306990)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533521795306990)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la preferenza utente che dispone del valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533470117306989)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287584810307622)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Python che produca un valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103287460732307622)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289110544307623)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca un valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289068723307623)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252382512307595)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere una query SQL che fornisca il valore utilizzato per popolare l''elemento di calcolo. Se il risultato contiene pi\00F9 righe, il valore di ogni riga verr\00E0 formato in un unico valore delimitato da due punti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252274387307595)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286533700307621)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente \00E8 un responsabile (manager) e il relativo reparto si trova a Chicago:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286405423307621)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione SQL che produca un valore utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103286394948307621)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533135547306989)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere una query SQL che fornisca il valore utilizzato per popolare l''elemento di calcolo. Se il risultato contiene pi\00F9 righe, verr\00E0 restituito solo il valore della prima riga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533030779306989)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532965884306989)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo utilizzato per popolare l''elemento di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532892233306989)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532776772306989)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un tipo di calcolo dalla lista riportata di seguito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268870364307607)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268947763307608)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore risultante dall''esecuzione dell''<em>espressione</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045044965307429)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247464980307591)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dal <em>corpo funzione</em> immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045384528307429)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247144106307591)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045199947307429)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL (restituisce un valore singolo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247221772307591)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul primo valore restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045298252307429)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL (restituisce un valore separato da due punti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247340054307591)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare su un valore separato da due punti singolo, che concatena ogni valore di riga, restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103045403964307429)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247536680307591)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore della <em>preferenza</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044979376307429)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247050002307591)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul testo immesso in <em>Valore statico</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532684583306989)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893624303307312)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Per questa colonna, specificare se la somma viene calcolata e visualizzata alla fine del report.',
'Se utilizzato con colonne di interruzione, vengono visualizzate la somma totale e la somma in ogni interruzione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893569366307312)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Calcola somma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278314754307615)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278752709307615)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278634838307615)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278555124307615)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278802544307615)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278406895307615)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278291001307615)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280309751307617)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280680124307617)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280578239307617)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280403417307617)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280786719307617)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280264854307616)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566007002307020)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565900130307020)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567421482307021)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567358033307021)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279951835307616)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Java per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279871458307616)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281536283307617)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281452598307617)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279752044307616)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279680912307616)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione JavaScript per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279512786307616)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281367078307617)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281207962307617)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281159636307617)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566270193307020)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista di valori separata da due punti (:) per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566181239307020)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566610734307020)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero di pagina per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566595517307020)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566832921307020)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista separata da virgole di numeri di pagina per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566778691307020)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279405128307616)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279398200307616)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione PL/SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279230004307616)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281092402307617)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280957373307617)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione PL/SQL che restituisca un valore booleano per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280867041307617)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566465768307020)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la preferenza utente che viene confrontata con il valore specificato per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566314378307020)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280122663307616)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Python per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103280033459307616)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281797394307618)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281696054307618)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279134971307616)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente \00E8 un responsabile (manager) e il relativo reparto si trova a Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103279087105307615)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278983716307615)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424923477307728)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori se esistono una o pi\00F9 righe durante il controllo per determinare se il dipendente si trova nel reparto 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>Per la corretta restituzione dei valori se non esistono righe durante il controllo per determinare se il dipendente si trova nel reparto 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565668829307019)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565580785307019)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567034507307021)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore di testo per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102566964818307020)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567631495307021)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore, comprese le stringhe di sostituzione <code>&ITEM.</code>, per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567525433307021)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940908678307350)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il tipo di condizione da soddisfare affinch\00E9 questa azione venga attivata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568539701307022)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il tipo di condizione da soddisfare affinch\00E9 questa azione dinamica venga attivata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564513933307018)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il tipo di condizione che deve essere soddisfatto affinch\00E9 questo componente venga visualizzato o elaborato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122959413307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'it'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260589626307601)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il componente verr\00E0 visualizzato sempre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121521570307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 Microsoft Internet Explorer versione 7.0 o successiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121606089307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 un browser con capacit\00E0 XHTML/CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121405474307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 Mozilla, Netscape versione 6.x/7x o successiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121733751307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 un browser di altro tipo (o una versione precedente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120136208307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo \00E8 contenuto nell''elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122110003307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'it'
,p_message_text=>'Lingua corrente = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264192319307604)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale sta eseguendo l''applicazione nella lingua immessa nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121814233307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'it'
,p_message_text=>unistr('La lingua corrente \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264303362307604)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale sta eseguendo l''applicazione in una delle lingue immesse nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122036246307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'it'
,p_message_text=>'Lingua corrente != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264276224307604)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale non sta eseguendo l''applicazione nella lingua immessa nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121942206307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'it'
,p_message_text=>unistr('La lingua corrente NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264477063307604)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale non sta eseguendo l''applicazione in una delle lingue immesse nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119338817307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente = pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262927239307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 uguale al valore immesso in <em>Pagina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119590309307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 in una lista separata da virgole')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263127050307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 contenuta nella lista separata da virgole immessa in <em>Pagine</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119415527307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente != pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263087041307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 diversa dal valore immesso in <em>Pagina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119615518307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente NON \00E8 in una lista separata da virgole')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263246872307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente non \00E8 contenuta nella lista separata da virgole immessa in <em>Pagine</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122225176307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: DAD_NAME = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122373674307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: DAD_NAME != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121090636307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'it'
,p_message_text=>'Errori di convalida in linea visualizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263904278307604)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'it'
,p_message_text=>'Un errore di convalida in linea viene visualizzato nella pagina, dopo la sottomissione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120423624307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120239342307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120356176307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo NON \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120509996307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117011498307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Righe restituite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260614153307601)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La query SQL restituisce una o pi\00F9 righe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278008834307615)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103278141462307615)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'L''espressione restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117219831307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260804363307601)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Il corpo funzione restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122677684307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: HTTP_HOST = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122729975307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: HTTP_HOST != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120759438307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina/area NON \00E8 di sola lettura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263692751307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina e l''area padre, se necessario, vengono visualizzate in modo normale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120646548307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina/area \00E8 di sola lettura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263527308307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina o l''area padre, se necessario; la condizione ''Sola lettura'' restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118530280307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento non contiene spazi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262130303307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'it'
,p_message_text=>'Il valore dell''<em>elemento</em> selezionato non contiene spazi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118840700307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 alfanumerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262432608307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 alfanumerico, ovvero contiene solo lettere o numeri e nessun carattere speciale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118086994307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261602117307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118715105307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262385830307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118220671307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261841778307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117983154307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261530764307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118320597307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NULL o pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261949607307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 vuoto o \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118672566307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262233115307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118130064307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261764728307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118418683307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL e NON \00E8 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262064322307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 vuoto e non \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121290700307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'it'
,p_message_text=>'Report SQL (OK per visualizzare il pulsante Avanti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121302753307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'it'
,p_message_text=>'Report SQL (OK per visualizzare il pulsante Indietro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122860393307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'it'
,p_message_text=>'Mai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264520218307604)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il componente non viene visualizzato mai.</p>',
'<p>Nota: se si modifica una condizione impostandola su <strong>Mai</strong>, verranno rimosse tutte le condizioni esistenti. Per disabilitare temporaneamente un componente, Oracle consiglia di usare preferibilmente l''attributo <em>Opzione di creazion'
||'e</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103121170553307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'it'
,p_message_text=>'Errori di convalida in linea NON visualizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264061155307604)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'it'
,p_message_text=>'Un errore di convalida in linea non viene visualizzato nella pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117152794307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Nessuna riga restituita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260772016307601)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>'La query SQL non restituisce righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119985645307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 in modalit\00E0 Per la stampa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263355641307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 stata impostata su ''in modalit\00E0 Per la stampa'' dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120079885307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente NON \00E8 in modalit\00E0 Per la stampa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263400695307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente non \00E8 stata impostata su ''in modalit\00E0 Per la stampa'' dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117390097307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Richiesta = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260974217307601)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117552716307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261160020307601)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 contenuta nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117463329307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Richiesta != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261088243307601)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 diversa dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117663609307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261223217307601)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina non \00E8 contenuta nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122414699307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: SERVER_NAME = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103122587479307487)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: SERVER_NAME != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120897622307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 autenticato (non \00E8 pubblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263764590307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale \00E8 collegato all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103120924812307486)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 pubblico (non ha eseguito l''autenticazione)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103263869496307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale non \00E8 collegato all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119149235307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza utente = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262717961307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della <em>preferenza</em> immessa \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119222529307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza utente != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262823384307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della <em>preferenza</em> immessa \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103118966957307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 in una lista separata da due punti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262546030307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119068666307484)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 in una lista separata da due punti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103262603272307603)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117775875307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261320348307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103117881056307483)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103261433684307602)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119853361307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente != pagina sottomessa (inviata)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103119700169307485)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente = pagina sottomessa (inviata)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564469839307018)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565815057307019)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore da confrontare con la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102565797337307019)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567273378307021)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore, comprese le stringhe di sostituzione <code>&ITEM.</code>, per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567123293307021)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436853146306908)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Protegge il funzionamento del pulsante con un prompt di conferma. Dopo che \00E8 stato fatto clic sul pulsante, viene visualizzata una finestra di dialogo di conferma, in cui l''utente deve confermare prima che il pulsante esegua la relativa azione.</p')
||'>',
unistr('<p>\00C8 possibile utilizzare questa funzionalit\00E0 per assicurarsi che l''utente non esegua inavvertitamente un''azione significativa, ad esempio l''eliminazione di un record.</p>'),
'<p>Nota: l''etichetta del pulsante di conferma nella finestra di dialogo deriva dall''etichetta del pulsante principale.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436721946306908)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Conferma necessaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437175294306908)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>unistr('<pre>&lt;strong&gt;Si \00E8 certi&lt;&#x2F;strong&gt; di voler eliminare il dipendente &amp;P1_ENAME.?</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437022005306908)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il messaggio da visualizzare nella finestra di dialogo di conferma.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102436970966306908)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Messaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437859682306908)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437382921306908)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare lo stile della finestra di dialogo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437650331306908)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'it'
,p_message_text=>'Pericolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437495787306908)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'it'
,p_message_text=>'Informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437787928306908)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'it'
,p_message_text=>'Operazione riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437519218306908)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'it'
,p_message_text=>'Avvertenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437249501306908)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899796844307317)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la disposizione del contenuto nella lista disponibile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078678200307455)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'it'
,p_message_text=>'Allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078731839307455)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'it'
,p_message_text=>'In linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899613847307316)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Disposizione contenuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624941120307082)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''attributo di dominio URL per il cookie della sessione.',
'Se il confronto della parte finale dell''URL della richiesta non corrisponde al dominio specificato, il cookie non viene inviato al browser.',
unistr('Il valore predefinito \00E8 il nome host dell''URL della richiesta.</p>'),
'<p>Usare questo attributo per specificare un percorso meno restrittivo quando si desidera condividere i cookie di sessione tra applicazioni che hanno domini comuni.',
'Ad esempio, <code>my.yahoo.com</code>, <code>sport.yahoo.com</code> e <code>finance.yahoo.com</code> possono accedere tutti allo stesso cookie se viene immesso un dominio <code>yahoo.com</code>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624878541307082)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dominio cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624515639307082)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome per il cookie di sessione, necessario per identificare una sessione di &PRODUCT_NAME. insieme all''ID sessione nell''URL.',
unistr('Se non si specifica un nome di cookie di sessione, &PRODUCT_NAME. utilizzer\00E0 un valore predefinito.</p>'),
unistr('<p>Quando si immette lo stesso nome di cookie di sessione in pi\00F9 applicazioni, ogni applicazione pu\00F2 utilizzare lo stesso cookie di sessione.'),
unistr('Pertanto, una chiamata di URL da un''applicazione &PRODUCT_NAME. a un''altra applicazione &PRODUCT_NAME. con lo stesso nome cookie non richiede che l''utente ripeta l''autenticazione, poich\00E9 la nuova applicazione pu\00F2 utilizzare il cookie di sessione esis')
||'tente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624468742307082)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624741388307082)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''attributo di percorso URL per il cookie della sessione.',
'Se la parte iniziale dell''URL della richiesta non corrisponde al percorso specificato, il cookie non viene inviato al browser.',
unistr('Il valore predefinito \00E8 il percorso dell''URL della richiesta.</p>'),
'<p>Usare questo attributo per specificare un percorso meno restrittivo quando si desidera condividere i cookie di sessione tra applicazioni dotate di percorsi URL inizialmente conformi.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624622674307082)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Percorso cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044704859307428)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Riferimento file standard</dt>',
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>Riferimento file standard che carica il file ridotto main.min.css da /mycss/minified/ per le visualizzazioni di pagina normali e il file main.css da /mycss/ in modalit\00E0 di debug o quando si esegue l''applicazione dall''App Builder.</dt>'),
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
'<dt>Query supporto condizionale</dt>',
'<dd><pre>[media="solo schermo e (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
'<dt>Riferimento file che utilizza una stringa di query nell''URL che indica la versione dell''applicazione, in modo che all''aggiornamento dell''applicazione (e all''aumento del numero di versione), il browser riceva istruzioni per caricare sempre il nuov'
||'o file e ignorare tutti i file inseriti in precedenza nella cache.</dt>',
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531399010306988)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli URL dei file CSS (Cascading Style Sheet) caricati in questa pagina. Ogni URL deve essere scritto in una nuova riga.',
unistr('Se si fornisce una versione ridotta del file, \00E8 possibile usare la stringa di sostituzione <code>#MIN#</code> per includere <code>.min</code> o la stringa di sostituzione <code>#MIN_DIRECTORY#</code> per includere <code>minified/</code> nell''URL del ')
||unistr('file per una visualizzazione normale della pagina e una stringa vuota se la pagina viene visualizzata nella modalit\00E0 di debug o quando si esegue l''applicazione dall''App Builder.'),
unistr('Se si desidera includere la versione dell''applicazione nell''URL del file, \00E8 inoltre possibile accedere alla stringa di sostituzione <code>#APP_VERSION#</code>.</p>'),
'<p>Gli URL dei file immessi qui sostituiranno la stringa di sostituzione <code>#PAGE_CSS#</code> nel modello della pagina.</p>',
unistr('<p>Nota: non \00E8 necessario includere le tag <code>script</code> di apertura o di chiusura. Includere solo l''URL del file.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531295362306987)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077539385307454)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Quando si imposta questo attributo su <code>color:#FF0000;</code>, il colore del testo della colonna diventa rosso e viene generato il codice HTML seguente</dt>',
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895037224307313)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere gli stili CSS da applicare al valore di questa colonna. \00C8 possibile digitare lo stile CSS oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894950764307313)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868066293307293)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un carattere delimitatore per specificare i limiti iniziale e finale di valore di dati. Il delimitatore predefinito \00E8 costituito dalle virgolette.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867975618307293)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'CSV racchiuso da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902964284307319)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se gli utenti finali possono scaricare il contenuto dei report in un file CSV. Per abilitare i <em>download CSV</em>, \00E8 necessario utilizzare un modello di report con una stringa di sostituzione <code>#CSV_LINK#</code> e impostare questa ')
||'opzione su <strong>Attivo</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902841916307319)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Esportazione CSV abilitata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867846983307293)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un separatore di colonna. Se non viene specificato alcun valore, verr\00E0 utilizzato un carattere di punto e virgola o una virgola in base alle impostazioni NLS correnti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867781424307293)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Separatore CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535821224306992)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare se si desidera che il cursore venga attivato al primo accesso alla pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038312039307423)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Primo elemento nella pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038412563307424)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il cursore \00E8 attivato sul primo campo della pagina mediante il codice JavaScript generato dal motore di &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038516501307424)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Non attivare il cursore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038642164307424)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Il cursore non viene attivato e il codice JavaScript non viene generato.<br>',
'Selezionare questa opzione se il codice JavaScript generato crea conflitti con il codice JavaScript personalizzato.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530455976306987)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attivazione cursore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628557800307085)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare se gli attributi visualizzati in questa area possono essere personalizzati dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059354321307440)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'it'
,p_message_text=>'Non personalizzabile dagli utenti finali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059250598307440)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'it'
,p_message_text=>'Personalizzabile e visualizzato per impostazione predefinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059133092307440)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'it'
,p_message_text=>'Personalizzabile e non visualizzato per impostazione predefinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628498961307085)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Personalizzabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627548756307084)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere l''etichetta per il collegamento, visualizzato sotto quest''area, che consente di accedere alla pagina di personalizzazione delle aree.',
'Questa etichetta viene visualizzata solo per le aree personalizzabili.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627400835307084)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933072306307344)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il testo HTML da includere per questo pulsante:',
'<ul>',
'  <li>Per i pulsanti di tipo <strong>Pulsante HTML</strong>, il testo immesso viene aggiunto alla definizione dell''elemento HTML.</li>',
'  <li>Per i pulsanti basati su modelli, il modello deve includere la stringa di sostituzione <code>#BUTTON_ATTRIBUTES#</code>.</li>',
'</ul>',
unistr('<p>\00C8 possibile usare questo attributo per controllare le tabulazioni.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933209929307345)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'it'
,p_message_text=>'La stringa di sostituzione del modello di report <code>#REPORT_ATTRIBUTES#</code> viene sostituita da questo valore. La stringa di sostituzione <code>#REPORT_ATTRIBUTES#</code> viene sostituita soltanto nell''attributo Prima delle righe del modello de'
||'l report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773103642307217)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere gli attributi aggiuntivi da includere nella tag HTML dell''elemento del form. Gli attributi HTML <code>size</code> e <code>id</code> HTML vengono generati, pertanto non devono essere forniti. Per l''attributo HTML <code>class</code> \00E8 preferi')
||'bile utilizzare l''attributo dedicato <em>Classi CSS</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932992462307344)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere gli attributi aggiuntivi da includere nella tag HTML dell''elemento del form. Gli attributi HTML <code>size</code> e <code>id</code> HTML vengono generati, pertanto non devono essere forniti. Per l''attributo HTML <code>class</code> \00E8 preferi')
||'bile utilizzare l''attributo dedicato <em>Classi CSS</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933151361307345)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore sostituito negli attributi di area. I modelli di area che contengono la stringa di sostituzione <code>#REGION_ATTRIBUTES#</code> verranno sostituiti con questo valore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933355394307345)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'it'
,p_message_text=>'La stringa di sostituzione del modello di report <code>#REPORT_ATTRIBUTES#</code> viene sostituita da questo valore. La stringa di sostituzione <code>#REPORT_ATTRIBUTES#</code> viene sostituita soltanto nell''attributo Prima delle righe del modello de'
||'l report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932859048307344)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere la lista separata da spazi degli attributi aggiuntivi da includere nella tag dell''elemento.',
'Per l''attributo CLASS HTML, Oracle consiglia di usare l''attributo dedicato Classi CSS.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932723304307344)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi personalizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844139550307276)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare il nome della colonna personalizzata che pu\00F2 essere utilizzato per definire una descrizione comandi personalizzata o i colori basati sul database da usare per gli elementi del grafico. Nel caso di un grafico box plot, la colonna non deve ')
||unistr('corrispondere al mapping colonne Valore selezionato. Se si seleziona una colonna corrispondente al mapping colonne Valore, nessuna colonna personalizzata verr\00E0 usata per il grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844074893307276)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna personalizzata '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534314746306990)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare un nome evento JavaScript personalizzato se gli eventi dichiarativi forniti non sono sufficienti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534231207306990)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Evento personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850814008307281)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''operazione del database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851372247307281)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'it'
,p_message_text=>'Elimina riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850976140307281)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'it'
,p_message_text=>'Recupera righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851082609307281)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'it'
,p_message_text=>'Recupera riga singola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851157135307281)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'it'
,p_message_text=>'Inserisci riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851202653307281)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'it'
,p_message_text=>'Aggiorna riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850793920307281)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Operazione database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088683621307462)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929221585307342)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per lo sfondo dei dati visualizzati in questo calendario.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929195521307341)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sfondo dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364084977306849)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome della colonna, con distinzione tra maiuscole e minuscole, utilizzata come origine per questo valore di elemento.</p>',
'<p>La colonna deve esistere nell''origine dati specificata nell''area Form.',
'Se il nome della colonna non esiste nella tabella di riferimento, viene restituito un errore in runtime e la pagina non viene caricata.',
unistr('Analogamente, se non \00E8 stato definito alcun processo di recupero righe built-in ed esiste un elemento con tipo di origine <strong>Colonna di database</strong>, viene restituito un errore e la pagina non viene caricata quando si tenta di visualizzarla')
||'.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363961320306849)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363816337306849)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''area di form associata per questo elemento di pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363747984306849)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area di form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129139460307492)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929419244307342)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per i dati in questo calendario.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929396530307342)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769064233307213)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di dati della colonna database di base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435476641307737)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'it'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435297489307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'it'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435178971307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'it'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434554358307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'it'
,p_message_text=>'DATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435015801307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'it'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434975126307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'it'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434407287307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'it'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435350835307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'it'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434794129306906)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'it'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434636167307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'it'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434869494307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'it'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434717412307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'it'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434338229307736)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'it'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768973956307213)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926205751307339)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna dalla tabella o dalla query che contiene le date da inserire nel calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926122941307339)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926405435307340)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se si desidera mostrare i valori di ora o solo i valori di data nel calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102926390318307340)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra ora'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894257617307312)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il formato di visualizzazione da applicare al selettore data per questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074666766307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'it'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074401576307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'it'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074514415307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'it'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075268200307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'it'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075093598307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'it'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075144264307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'it'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074956004307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'it'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074712938307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'it'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074885075307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'it'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075300706307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'it'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075530802307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'it'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075496060307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'it'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075685546307452)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'it'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075824166307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'it'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075776832307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'it'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103075916264307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'it'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076123189307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'it'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076098552307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'it'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076251861307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'it'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076441470307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'it'
,p_message_text=>'RR-MON-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076340686307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'it'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074104506307451)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'it'
,p_message_text=>'Usa formato data applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074262641307451)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'it'
,p_message_text=>'Usa formato di visualizzazione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103074357390307451)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'it'
,p_message_text=>'Usa formato di visualizzazione elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076575516307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'it'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076790897307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'it'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076644518307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'it'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076888986307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'it'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077242023307454)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'it'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077340959307454)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'it'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077060480307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'it'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077143418307454)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'it'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103076945951307453)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'it'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894181355307312)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930514842307343)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Fare clic su una destinazione per richiamare una finestra di dialogo di tipo modale. \00C8 possibile immettere il collegamento alla destinazione chiamato dal calendario durante la creazione di un evento facendo clic su una cella del calendario all''estern')
||'o di un evento esistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930410496307342)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Crea destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558735890307013)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare l''azione che si desidera eseguire. Sono supportate le azioni seguenti:</p>',
'#NATIVE_PLUGINS#',
'<p>A seconda della configurazione dell''applicazione, qui potrebbero essere disponibili plugin per le azioni dinamiche aggiuntivi.',
'Questi plugin vengono visualizzati con il formato <em>&lt;My Plug-in&gt; [plugin]</em>.',
'I plugin seguenti vengono installati nei componenti condivisi dell''applicazione:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558643817307013)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882126570307304)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''evento di azione dinamica appropriato dalla lista disponibile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882033357307304)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245210297307590)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Cleanup codice PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245112700307590)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice PL/SQL di inizializzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914172065307330)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355294650307672)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Usa l''impostazione definita negli attributi di sicurezza dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538222253306994)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selezionare la modalit\00E0 di gestione delle richieste di URL esterne a questa pagina.'),
'Le richieste di pagina inoltrate dall''applicazione a questa pagina non vengono considerate come deep link e non sono interessate dall''impostazione di questo attributo.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039272473307424)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039338848307424)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Se l''URL non contiene un ID sessione valido, &PRODUCT_NAME. avvia una nuova sessione e reindirizza l''utente alla home page dell''applicazione anzich\00E9 a questa pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039010977307424)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039129729307424)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se questa pagina \00E8 specificata come pagina di destinazione in un URL, il reindirizzamento viene eseguito a questa pagina.<br>'),
unistr('Se l''utente non \00E8 stato gi\00E0 autenticato e la pagina non \00E8 pubblica, viene richiesto all''utente di eseguire il login.'),
'Dopo aver eseguito il login all''applicazione, l''utente viene reindirizzato a questa pagina.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538156851306994)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Deep link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679343111307129)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se l''interfaccia utente \00E8 l''interfaccia predefinita dell''applicazione o meno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679231874307129)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528390801306985)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''opzione di creazione predefinita applicata a questo componente durante l''esportazione. Le opzioni di esportazione possono avere la priorit\00E0 sull''opzione selezionata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036776836307422)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'it'
,p_message_text=>'Escludi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346736794307666)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 disabilitato e non fa parte dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036806322307422)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'it'
,p_message_text=>'Includi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346860668307666)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 abilitato e fa parte dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528208214306985)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Predefinito in fase di esportazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769871036307213)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il modo in cui viene determinato il valore predefinito di questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269890217307608)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269905909307608)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dall''<em>espressione</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270001752307608)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270188842307608)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dal <em>corpo funzione</em> immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770160227307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770213367307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dallo stato sessione per l''<em>elemento</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770705604307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770845993307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Impostare sul valore restituito dalla <em>sequenza</em> immessa. Questo \00E8 un tipo predefinito "speciale": viene eseguito come parte del processo DML Griglia interattiva e <em>non</em> durante il caricamento della pagina. Usare questo tipo per i va')
||unistr('lori di chiave primaria generati automaticamente, quando non \00E8 possibile usare <strong>Restituisci chiavi primarie dopo l''inserimento</strong>, ad esempio quando si usano le viste e i trigger INSTEAD OF o i database link. Il nome della sequenza fa di')
||'stinzione tra maiuscole e minuscole; usare le virgolette per indicare un nome di sequenza che contiene lettere maiuscole e minuscole ("mySequence").</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770329269307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770433520307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770542645307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL restituisce lista separata da due punti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770639672307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Impostare sulla lista di valori separata da due punti restituita dalla <em>query SQL</em> immessa.</p>',
'        <p>Nota: le liste separate da due punti sono obbligatorie quando la colonna viene visualizzata come casella di controllo, gruppo di scelta o shuttle.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769955897307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770041549307214)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul testo immesso nel valore <em>Statico</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769706935307213)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292926333307626)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293390412307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293299687307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293183687307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293437739307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293067680307626)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292882803307626)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294978529307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295212260307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295168137307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295048200307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295376650307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294898121307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917840239307333)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''elemento di pagina o di applicazione che contiene il valore predefinito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917703810307333)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294556541307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione Java che produce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294448184307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296115626307629)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione Java che restituisce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296083404307629)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294360632307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294225712307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione JavaScript che produce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294136420307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295909361307629)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295835331307629)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione JavaScript che restituisce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295749366307629)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294071300307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293905481307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione PL/SQL che produce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293890333307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295615234307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295513940307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103295450056307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294756690307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione Python che produce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103294605464307628)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296361746307629)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione Python che restituisce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296200987307629)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771466772307215)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome della sequenza di database che restituisce il valore predefinito per questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771323387307215)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293746725307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente \00E8 un responsabile (manager) e il relativo reparto si trova a Chicago:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293690758307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione SQL che produce il valore per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103293585022307627)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771013321307215)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la query SQL che restituisce il valore predefinito per questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102770962891307214)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771248078307215)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le query SQL che restituisce la lista di valori separata da due punti predefinita per questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771126039307215)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Due punti query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551940632307007)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare un valore predefinito per l''elemento. Il valore predefinito viene utilizzato se il valore dell''elemento non viene derivato dallo stato di sessione e se il valore di origine \00E8 NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551831102307006)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551745663307006)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un tipo di valore predefinito per questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269299975307608)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269390748307608)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dall''<em>espressione</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269443026307608)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269587728307608)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dal <em>corpo funzione</em> immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362669926306848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362770559306848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dallo stato sessione per l''<em>elemento</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363229157306849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363369670306849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Impostare sul valore restituito dalla <em>sequenza</em> immessa. Questo \00E8 un tipo predefinito "speciale": viene eseguito come parte del processo DML Area di form e <em>non</em> durante il caricamento della pagina. Usare questo tipo per i valori di')
||unistr(' chiave primaria generati automaticamente, quando non \00E8 possibile usare <strong>Restituisci chiavi primarie dopo l''inserimento</strong>, ad esempio quando si usano le viste e i trigger INSTEAD OF o i database link. Il nome della sequenza fa distinzio')
||'ne tra maiuscole e minuscole.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362871677306848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362918017306849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363098013306849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL restituisce lista separata da due punti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363186720306849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Impostare sulla lista di valori separata da due punti restituita dalla <em>query SQL</em> immessa.</p>',
'        <p>Nota: le liste separate da due punti sono obbligatorie quando la colonna viene visualizzata come casella di controllo, gruppo di scelta o shuttle.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054016461307436)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'it'
,p_message_text=>'Statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362588527306848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul testo immesso nel valore <em>Statico</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551645195307006)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781411588307224)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Specificare se gli utenti finali possono definire un grafico per questa griglia interattiva.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781309050307224)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Definisci vista grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757053728307202)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare uno schema di autorizzazione per limitare il numero degli utenti che possono eliminare le righe.',
'		Per consentire a un utente finale di eliminare le righe, lo schema di autorizzazione selezionato deve restituire TRUE.',
'		Se non viene fornito alcuno schema di autorizzazione, tutti gli utenti potranno eliminare le righe in questa griglia interattiva.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756981855307201)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elimina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890441513307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare una condizione che controlli il valore di un altro facet o filtro per verificare se il facet o il filtro corrente deve essere visualizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890588061307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'it'
,p_message_text=>'uguale a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890670121307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore del <em>facet o filtro</em> "dipendente da" \00E8 uguale al <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890924074307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'it'
,p_message_text=>'in lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891083049307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore del <em>facet o filtro</em> "dipendente da" \00E8 nella <em>lista</em> specificata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890719888307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'it'
,p_message_text=>'diverso da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890857114307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore del <em>facet o filtro</em> "dipendente da" \00E8 diverso dal <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891187665307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'it'
,p_message_text=>'non in lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891274144307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore del <em>facet o filtro</em> "dipendente da" non \00E8 nella <em>lista</em> specificata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891524286307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('non \00E8 nullo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891658659307311)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore del <em>facet o filtro</em> "dipendente da" non \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891321544307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('\00E8 nullo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891498893307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore del <em>facet o filtro</em> "dipendente da" \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890371316307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892039931307311)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista di valori separata da virgole per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891957058307311)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891862655307311)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102891767997307311)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890270368307310)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il facet associato da controllare per stabilire se il facet corrente deve essere visualizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102890132082307309)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215711927307568)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la casella di controllo associata da selezionare per stabilire se la casella di controllo corrente deve essere visualizzata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215610649307568)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Casella di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578237804307031)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il filtro associato da selezionare per stabilire se il filtro corrente deve essere visualizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578116984307031)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578460254307031)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la casella di controllo associata da selezionare per stabilire se la casella di controllo corrente deve essere visualizzata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578361287307031)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Casella di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130302367307493)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'$$$ DJP attualmente nascosto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921223796307336)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna derivata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435764431307737)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una descrizione per questo report interattivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864885714307291)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la descrizione del gruppo di colonne. La descrizione non viene mai visualizzata dagli utenti finali.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532322233306988)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una descrizione non vuota.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532235617306988)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070748700307449)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873023701307297)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice HTML da visualizzare dopo le righe del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872959441307297)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dopo le righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070536092307449)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872635717307297)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice HTML da visualizzare prima delle righe del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872575720307297)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Prima delle righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772343130307216)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la vista dei dettagli \00E8 abilitata. Se si seleziona <strong>Attivo</strong>, viene aggiunta un''icona Visualizza dettagli alla barra di ricerca per i report interattivi, oppure al pulsante Visualizza della griglia interattiva, e gli uten')
||'ti possono accedere alla vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872447767307297)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la vista dei dettagli \00E8 abilitata. Se si seleziona <strong>Attivo</strong>, viene aggiunta un''icona Visualizza dettagli alla barra di ricerca per i report interattivi, oppure al pulsante Visualizza della griglia interattiva, e gli uten')
||'ti possono accedere alla vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872385620307297)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433272915307735)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433391977307735)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il corpo per le righe del report nella vista dei dettagli.</p>',
'<p>Sono disponibili le stringhe di sostituzione riportate di seguito.',
'<ul>',
'<li><code>&&lt;COLUMN_NAME&gt;.</code>: stringhe di sostituzione per i nomi delle colonne.</li>',
'<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code>: stringhe di sostituzione per le etichette delle colonne.</li>',
'<li><code>&APEX$ROW_ID.</code>: identificativo del record per la riga.</li>',
'<li><code>&APEX$ROW_INDEX.</code>: numero sequenza di visualizzazione del record.</li>',
'<li><code>&APEX$ROW_STATE_CLASSES.</code>: stato del record, ad esempio <code>is-inserted</code> o <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070624986307449)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872867568307297)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo per le righe del report nella vista dei dettagli. Usare le stringhe di sostituzione <code>#COLUMN_NAME#</code> per i nomi e le etichette delle colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872734388307297)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Per ogni riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532170359306988)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il supporto per le finestre di dialogo disponibile in &PRODUCT_NAME. varia a seconda dell''interfaccia utente della pagina.',
unistr('Un subset di attributi di finestra di dialogo \00E8 supportato in modalit\00E0 dichiarativa: <em>altezza, larghezza e larghezza massima</em>.'),
'Per definire attributi aggiuntivi di qualsiasi tipo per la finestra di dialogo, immettere le coppie nome-valore in una lista separata da virgole.</p>',
unistr('<p>La stringa di sostituzione <code>#DIALOG_ATTRIBUTES#</code> nel codice di inizializzazione della finestra di dialogo definito a livello del modello di pagina verr\00E0 sostituita dai valori immessi in questo elemento.</p>'),
'<p>Per le pagine che usano l''interfaccia utente Desktop viene utilizzato il widget per finestra di dialogo dell''interfaccia utente jQuery.',
'Per le pagine che usano l''interfaccia utente Smartphone jQuery Mobile viene utilizzato il widget per finestra di dialogo jQuery Mobile.</p>',
unistr('<p>Ad esempio, per una pagina finestra di dialogo che utilizza un''interfaccia utente Desktop \00E8 possibile definire gli attributi seguenti: <code>resizable:true, draggable:true</code></p>'),
'<p>Per ulteriori informazioni sugli attributi disponibili, fare riferimento alla <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">documentazione del widget per finestra di dialogo dell''interfaccia utente jQuery</a> e alla <a'
||' rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">documentazione del widget per finestra di dialogo jQuery Mobile</a>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102532043546306988)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222630668307573)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare <strong>Attivo</strong> se questa finestra di dialogo viene aperta da un''altra finestra di dialogo e deve riutilizzare la stessa finestra.',
unistr('Ad esempio, se questa finestra di dialogo fa parte di una creazione guidata finestre di dialogo con pi\00F9 pagine e si desidera riutilizzare la finestra per ogni passo della procedura guidata.<p><p>'),
unistr('Selezionare <strong>Non attivo</strong> se questa finestra di dialogo viene aperta da un''altra finestra di dialogo e deve essere aperta in una nuova finestra. Ad esempio, quando la finestra di dialogo \00E8 di tipo modale'),
'e si desidera aprirla all''interno di una finestra di dialogo di tipo modale padre.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222543884307573)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Concatenata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933922485307345)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933862464307345)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622438299307080)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere l''altezza della finestra di dialogo in pixel, ad esempio <strong><em>500</em></strong>.',
unistr('La stringa di sostituzione <code>#DIALOG_HEIGHT#</code> nel codice di inizializzazione della finestra di dialogo verr\00E0 sostituita con il valore immesso.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622325958307080)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531971885306988)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la larghezza massima della finestra di dialogo in pixel.',
'La stringa di sostituzione <code>#DIALOG_MAX_WIDTH#</code> nel codice di inizializzazione della finestra di dialogo del modello della pagina viene sostituita con il valore immesso in questo elemento.</p>',
unistr('<p>Per una pagina che usa l''interfaccia utente Smartphone jQuery Mobile, la larghezza massima \00E8 <strong><em>500</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531821460306988)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza massima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913829576307330)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667441154307118)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare un modello di finestra di dialogo per definire l''aspetto e il layout di questa pagina.</p>',
'        <p>I modelli di finestra di dialogo sono definiti nel tema dell''applicazione.',
'        Quando si crea una pagina finestra di dialogo, il modello viene impostato in modo automatico su <em>Impostazione predefinita tema</em>, che prevede la visualizzazione della pagina mediante il modello di pagina predefinito presente nel tema co'
||'rrente.',
'        La selezione effettuata qui comporta la sostituzione del modello di finestra di dialogo predefinito.</p>',
'        <p>Nel tema universale sono disponibili i modelli di finestra di dialogo descritti di seguito.',
'          <dl>',
'            <dt>Finestra di dialogo modale</dt>',
'              <dd>Utile per la maggior parte dei casi d''uso della finestre di dialogo.</dd>',
'            <dt>Finestra di dialogo modale per procedure guidate</dt>',
unistr('              <dd>Fornisce un''interfaccia utente semplificata ed \00E8 particolarmente adatto per le procedure guidate, gli avvisi, le notifiche o i form di piccole dimensioni delle finestra di dialogo modali.</dd>'),
'          </dl>',
'          Vedere anche: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667369189307118)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531716077306988)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la larghezza della finestra di dialogo, in pixel o sotto forma di valore percentuale.',
'La stringa di sostituzione <code>#DIALOG_WIDTH#</code> nel codice di inizializzazione della finestra di dialogo del modello della pagina viene sostituita con il valore immesso in questo elemento.</p>',
'<p>Per una pagina che usa un''interfaccia utente Desktop, il valore viene impostato in pixel, ad esempio <strong><em>500</em></strong>.',
'Per una pagina che usa l''interfaccia utente Smartphone jQuery Mobile, il valore viene invece impostato come valore percentuale, ad esempio <strong><em>80%</em></strong>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531693118306988)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849765718307280)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la direzione del parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849829005307280)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'it'
,p_message_text=>'In'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850046540307280)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'it'
,p_message_text=>'In/Out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849944250307280)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'it'
,p_message_text=>'Out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849612049307280)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Direzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895894670307314)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se questa colonna pu\00F2 essere usata dall''utente finale per ordinare il report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895763116307314)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ordinabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927416781307340)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna singola da visualizzare nelle celle del calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927306824307340)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543155679306998)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Un elemento potrebbe avere un valore di stato della sessione che non \00E8 presente nella definizione della lista di valori specificata.'),
'Selezionare se la lista di valori deve visualizzare il valore di stato della sessione extra.',
unistr('Se si sceglie di non visualizzarlo e non esiste un valore corrispondente nella definizione della lista di valori, verr\00E0 selezionato e visualizzato il primo valore della lista di valori.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543093730306998)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizza valori extra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543393888306999)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se la lista di valori utilizzata per questo elemento visualizza un valore NULL all''inizio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543277552306998)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizza valore nullo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585998667307038)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione utilizzata per visualizzare questo componente. Le posizioni derivano dai punti di visualizzazione appropriati del modello di pagina o area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585897788307038)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241064662307587)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere la sequenza di visualizzazione per questa azione.',
'Viene utilizzata per valutare la condizione di visualizzazione ed eseguire il rendering nell''ordine definito.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772774331307216)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la sequenza di visualizzazione per questa colonna. L''impostazione della sequenza determina la posizione di visualizzazione della colonna rispetto alle altre colonne all''interno dell''area.</p>',
'<p>Nota: due colonne della stessa area con lo stesso valore di sequenza potrebbero essere visualizzate secondo un ordine diverso quando l''applicazione viene esportata e importata in un altro ambiente, quale ad esempio un ambiente di test o di produzi'
||'one.',
'Per garantire la coerenza, Oracle consiglia di specificare numeri di sequenza univoci per ciascun elemento o almeno per gli elementi appartenenti alla stessa area.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864752059307291)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la sequenza di visualizzazione per questo gruppo di colonne. La sequenza determina l''ordine di visualizzazione dei gruppi di colonne nella vista dei dettagli.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198533799307555)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere la sequenza di visualizzazione per questo layer. L''impostazione della sequenza determina l''ordine di visualizzazione dei layer mappa l''uno sopra l''altro. I layer con numeri pi\00F9 elevati vengono visualizzati sopra quelli con numeri pi\00F9 bas')
||'si.</p>',
'<p>Nota: due layer mappa con lo stesso valore di sequenza potrebbero essere visualizzati secondo un ordine diverso quando l''applicazione viene esportata e importata in un altro ambiente, ad esempio in un ambiente di test o di produzione.',
'Per garantire la coerenza, Oracle consiglia di specificare numeri di sequenza univoci per ogni layer o almeno per quelli elementi appartenenti alla stessa area mappa.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561538330307016)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la sequenza di visualizzazione per questo elemento. La sequenza e altre impostazioni del layout determinano la posizione di visualizzazione dell''elemento rispetto agli altri elementi all''interno dell''area.</p>',
'<p>Nota: se due elementi della stessa area hanno lo stesso valore di sequenza, potrebbero essere visualizzati secondo un ordine diverso quando l''applicazione viene esportata e importata in un altro ambiente, quale ad esempio un ambiente di test o di '
||'produzione. Per garantire la coerenza, Oracle consiglia di specificare numeri di sequenza univoci per ciascun elemento o almeno per gli elementi appartenenti alla stessa area.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561470058307015)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382612319307693)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare uno schema di autorizzazione per limitare gli utenti che possono eseguire il download.',
'		Per consentire a un utente finale di eseguire il download, questo schema di autorizzazione deve restituire TRUE per l''utente specifico.</p>',
unistr('		<p>Nota: se non viene fornito alcuno schema di autorizzazione, il download \00E8 consentito a qualsiasi utente.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382502137307693)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905283508307321)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare un nome per il file di download CSV. Se non viene specificato alcun nome, verr\00E0 utilizzato il nome dell''area seguito dall''estensione .csv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916339545307332)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare un nome per il file di download CSV. Se non viene specificato alcun nome, verr\00E0 utilizzato il nome dell''area seguito dall''estensione .csv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900352212307317)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il nome file per il documento scaricato. Non specificare l''estensione del file, in quanto verr\00E0 aggiunta in modo automatico. Se si lascia vuota questo attributo, come nome del file verr\00E0 utilizzato il nome dell''area.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900242515307317)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867623155307293)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Selezionare i formati di download che gli utenti possono utilizzare per scaricare le colonne visualizzate.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068008366307447)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'it'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068150523307447)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'it'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068252027307447)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'it'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142980954307502)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'it'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867546912307293)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903127416307319)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo del collegamento per richiamare il download CSV.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903028522307319)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899537658307316)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo da usare per il collegamento di download nella pagina. Gli utenti finali utilizzano questo collegamento per scaricare il contenuto BLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102899424186307316)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Scarica testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930930950307343)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare uno schema di autorizzazione per limitare gli utenti autorizzati ad aggiornare gli eventi di calendario esistenti mediante trascinamento della selezione.',
unistr('Se specificato, lo schema di autorizzazione deve restituire TRUE affinch\00E9 il trascinamento della selezione venga elaborato.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930816883307343)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089597879307463)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Processo personalizzato</dt>',
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930722940307343)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'it'
,p_message_text=>'Definire il processo da eseguire quando si trascina una voce di calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930617318307343)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771619473307215)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se la colonna deve assumere per impostazione predefinita il valore di colonna esistente quando si duplica il record.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771519088307215)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore esistente copie duplicate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569569756307023)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Controlla le operazioni DML (Data Manipulation Language) supportate. Questo processo eseguir\00E0 le operazioni DML in base all''attributo <strong>Azione database</strong> del pulsante per sottomettere la pagina. Se questo attributo non \00E8 impostato, l''')
||unistr('operazione verr\00E0 determinata dal valore Richiesta del pulsante, che \00E8 impostato in base al nome del pulsante, come indicato di seguito:</p>'),
'<ul>',
'<li><strong>Aggiungi riga</strong> viene attivato dai valori di richiesta: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN</li>',
'<li><strong>Aggiorna riga</strong> viene attivato dai valori di richiesta: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%</li>',
'<li><strong>Elimina riga</strong> viene attivato dai valori di richiesta: DELETE, REMOVE, DELETE ROW, DROP</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755936047307201)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare le operazioni di manipolazione dati consentite su questa griglia interattiva.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756208871307201)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'it'
,p_message_text=>'Elimina riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756007240307201)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'it'
,p_message_text=>'Aggiungi riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756120181307201)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'it'
,p_message_text=>'Aggiorna riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755859962307200)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Operazioni consentite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756468509307201)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selezionare la colonna in cui il valore indica se la riga pu\00F2 essere aggiornata e/o eliminata. I valori consentiti sono:'),
'        <dl>',
'          <dt>U</dt>',
unistr('            <dd>La riga pu\00F2 essere aggiornata</dd>'),
'          <dt>D</dt>',
unistr('            <dd>La riga pu\00F2 essere eliminata</dd>'),
'          <dt>UD</dt>',
unistr('            <dd>La riga pu\00F2 essere aggiornata o eliminata</dd>'),
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756383805307201)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna operazioni riga consentite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548161603307003)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''allineamento dell''elemento all''interno della cella di tabella HTML che lo circonda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051705515307434)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'Centrato in basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051808769307434)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Centrato al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051975155307434)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'it'
,p_message_text=>'Centrato in alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051692425307434)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052140419307435)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'In basso a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052257531307435)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Centrato a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052368787307435)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'it'
,p_message_text=>'In alto a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052069098307434)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'it'
,p_message_text=>'A sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052593531307435)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'In basso a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052657601307435)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Centrato a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052701423307435)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'it'
,p_message_text=>'In alto a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052423803307435)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'A destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102544074702306999)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Allineamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548781463307004)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''altezza (numero di righe approssimativo) per le aree di testo, gli shuttle, le liste a selezione multipla e i tipi di elementi plugin che supportano l''attributo Con attributo di altezza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548673270307003)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934262555307345)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'it'
,p_message_text=>'linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548520600307003)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero massimo di caratteri che gli utenti possono digitare in questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548474232307003)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lunghezza massima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934303032307345)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'it'
,p_message_text=>'caratteri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549127275307004)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere sotto forma di lista separata da spazi gli attributi aggiuntivi per la cella di tabella HTML utilizzata per visualizzare le singole opzioni in un gruppo pulsanti di scelta o di caselle di controllo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549039122307004)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi HTML opzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549504496307004)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli attributi aggiuntivi visualizzati dopo la cella della tabella HTML che visualizza ogni singola opzione in un gruppo di scelta o in un set di caselle di controllo.',
unistr('\00C8 possibile includere HTML, JavaScript e collegamenti.</p>'),
unistr('<p>\00C8 possibile fare riferimento alle stringhe di sostituzione riportate di seguito.</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Ottiene il nome dell''elemento di form HTML al quale \00E8 associato questo elemento di pagina.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Ottiene il nome dell''elemento di pagina corrente.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549421469307004)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo post '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549330267307004)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli attributi aggiuntivi visualizzati prima della cella della tabella HTML che visualizza ogni singola opzione in un gruppo di scelta o in un set di caselle di controllo.',
unistr('\00C8 possibile includere HTML, JavaScript e collegamenti.</p>'),
unistr('<p>\00C8 possibile fare riferimento alle stringhe di sostituzione riportate di seguito.</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Ottiene il nome dell''elemento di form HTML al quale \00E8 associato questo elemento di pagina.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Ottiene il nome dell''elemento di pagina corrente.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549273980307004)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo pre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548986236307004)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il testo del suggerimento visualizzato in questo elemento quando non viene immesso alcun valore specifico. All''immissione di un testo qualsiasi nell''elemento, il suggerimento verr\00E0 rimosso.</p>'),
unistr('<p>Questo attributo segnaposto specifica un breve suggerimento che pu\00F2 essere utilizzato per descrivere il valore previsto di un elemento di pagina.'),
'I suggerimenti sono utili per fornire un valore campione, un esempio del formato previsto o istruzioni quali Ricerca nel titolo, nella descrizione o in una tag.',
'Per motivi correlati all''accesso facilitato, questo attributo non deve essere utilizzato come alternativa a un''etichetta ben definita e significativa.</p>',
unistr('<p><strong>Attenzione:</strong> si tratta di una funzione HTML5 riconosciuta solo dai browser pi\00F9 moderni. I browser meno recenti non visualizzano il testo immesso in questo attributo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548889463307004)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Segnaposto valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548325091307003)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la larghezza dell''elemento di form da utilizzare per visualizzare questo elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548204016307003)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934165657307345)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'it'
,p_message_text=>'caratteri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069112175307448)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870488158307295)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un indirizzo di posta elettronica valido da usare come indirizzo del mittente (<em>Da</em>) quando si invia un messaggio di posta elettronica dal report. I messaggi di posta elettronica vengono inviati da questo report per i download di '
||'tipo posta elettronica e per le sottoscrizioni.</p>',
unistr('<p>Il valore pu\00F2 essere una stringa di valori contenente un indirizzo di posta elettronica valido oppure un riferimento di sostituzione statico definito nell''applicazione mediante la sintassi di sostituzione.'),
unistr('L''uso della sostituzione di un elemento di pagina o di applicazione \00E8 SCONSIGLIATO in quanto funziona solo nel download via posta elettronica e fa s\00EC che i messaggi di posta elettronica di sottoscrizione non riescano poich\00E9 questi elementi non risult')
||'ano accessibili all''esterno di una sessione valida.',
'Le sottoscrizioni vengono inviate direttamente dal motore di &PRODUCT_NAME. e non da una sessione utente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870390467307295)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Indirizzo mittente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782043699307225)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono usare questa colonna nelle operazioni di interruzione di controllo e aggregazione.</p>',
'        <p>Nota: se autorizzate, queste operazioni possono avere un impatto negativo sulle prestazioni, soprattutto per i data set di grandi dimensioni, oppure quando non sono disponibili gli indici di colonna appropriati.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781935222307225)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Interruzione di controllo/Aggregazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760450934307205)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono scaricare il report in uno dei formati di download specificati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760360788307205)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Scarica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764528737307209)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono filtrare questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764439605307209)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781272300307224)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono utilizzare le flashback query per questa griglia interattiva.</p>',
unistr('<p>Le flashback query utilizzano Oracle Flashback Technology e la funzione Database Point-in-Time Recovery per visualizzare i dati cos\00EC come si presentavano in un point-in-time precedente. Gli utenti possono soltanto eseguire query su questi dati, se')
||unistr('nza annullare le modifiche che vi sono state apportate. Quanto sia possibile risalire nel tempo per l''esecuzione riuscita di una flashback query \00E8 determinato dal momento dell''ultimo scambio dei redo log file all''interno del database Oracle, in quant')
||'o questa tecnologia utilizza il backup RMAN.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781195306307224)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781872324307225)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono nascondere questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781738589307225)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nascondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761040640307205)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono inviare messaggi di posta elettronica con il download del report incluso come allegato.</p>',
unistr('<p>La posta elettronica \00E8 disponibile solo per gli utenti autenticati e richiede la configurazione del protocollo SMTP nell''applicazione &PRODUCT_NAME. Administration Services da parte dell''amministratore di un''istanza.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760916405307205)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Invia come posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010075908307402)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se abilitare la stampa dei report. Se si seleziona <strong>Attivo</strong> gli utenti potranno scaricare un report in diversi formati, compresi PDF, Microsoft Word, Microsoft Excel e HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009962183307401)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759881896307204)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono salvare la propria definizione di report corrente come report <em>Pubblico</em>.</p>',
'		<p>I report pubblici vengono visualizzati in una lista di selezione dei report disponibili nella barra degli strumenti e vengono visualizzati per chiunque.<p>',
unistr('		<p>Nota: questa opzione \00E8 disponibile solo per gli utenti autenticati e viene ulteriormente limitata se si popola anche <strong>Salva autorizzazione report pubblico</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759766226307204)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Salva report pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769699331307213)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono usare questa colonna nell''ordinamento.</p>',
unistr('        <p>Nota: se autorizzata, un''operazione di ordinamento pu\00F2 avere un impatto negativo sulle prestazioni, soprattutto per i data set di grandi dimensioni, oppure quando non sono disponibili gli indici di colonna appropriati.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769552748307213)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ordina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760286533307205)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire le impostazioni di sottoscrizione per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760169275307204)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sottoscrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556910976307011)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se cifrare questo elemento quando viene memorizzato nello stato della sessione.',
'Se nel contenuto di un elemento sono presenti dati riservati, si consiglia di cifrare il valore quando viene memorizzato nelle tabelle di gestione dello stato della sessione di &PRODUCT_NAME..',
'Senza tale cifratura, qualsiasi utente che dispone dei diritti di lettura delle tabelle dei metadati di &PRODUCT_NAME. potrebbe scrivere una query per estrarre i dati riservati.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556878638307011)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Memorizza il valore cifrato nello stato della sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928467767307341)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare l''ultimo giorno della settimana visualizzato nel calendario settimanale.',
unistr('Questo attributo pu\00F2 essere usato insieme all''attributo <strong>Giorno di inizio</strong> per limitare i giorni della settimana visualizzati oppure per selezionare il giorno prima del <strong>Giorno di inizio</strong> per mostrare tutti e sette i gio')
||'rni.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087766295307461)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'it'
,p_message_text=>'Domenica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087827044307461)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'it'
,p_message_text=>unistr('Luned\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087977479307461)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'it'
,p_message_text=>unistr('Marted\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088036722307462)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'it'
,p_message_text=>unistr('Mercoled\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088151140307462)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'it'
,p_message_text=>unistr('Gioved\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088204974307462)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'it'
,p_message_text=>unistr('Venerd\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088315572307462)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'it'
,p_message_text=>'Sabato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928316298307341)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Giorno di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929063684307341)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''ora di fine della visualizzazione del calendario settimanale e giornaliero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928984895307341)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ora di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930308854307342)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Fare clic su una destinazione per richiamare una finestra di dialogo di tipo modale. \00C8 possibile immettere il collegamento alla destinazione chiamato dal calendario per visualizzare i dettagli di un evento esistente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930247918307342)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Destinazione evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530507728306987)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome della funzione PL/SQL che viene chiamata quando si verifica un errore nell''applicazione.',
unistr('La funzione pu\00F2 essere usata per agire su vari codici di errore, compresi quelli provenienti dal database Oracle, e per registrare gli errori in una tabella personalizzata definita se necessario.'),
unistr('La funzione pu\00F2 includere la logica per modificare il messaggio di errore e la posizione di visualizzazione, trasformando i questo modo gli errori del database Oracle in messaggi riconoscibili dall''utente.'),
unistr('Ad esempio, \00E8 possibile rilevare una violazione di chiave univoca in <code>DEMO_CUSTOMERS</code> e sostituire il messaggio <code>ORA-00001</code> con questo testo: Il nome del cliente deve essere univoco.'),
'L''installazione dell''applicazione di database di esempio, da Applicazioni preparate, crea il package <code>SAMPLE_PKG</code>, che include la funzione <code>demo_error_handling</code>.',
unistr('Questa funzione di gestione degli errori di esempio \00E8 dotata di commenti completi che ne facilitano l''uso come base per la definizione di una funzione personalizzata.</p>'),
unistr('<p>Il nome funzione immesso pu\00F2 fare riferimento a una funzione package o a una funzione standalone nel database. Ad esempio:'),
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>Quando si fa riferimento a una funzione package o standalone PL/SQL del database, \00E8 possibile usare la stringa di sostituzione <code>#OWNER#</code> per fare riferimento allo schema di analisi dell''applicazione corrente. Ad esempio:'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
'<p>L''eventuale funzione di gestione degli errori specificata in una pagina viene utilizzata, al posto di questa impostazione a livello di applicazione, per la pagina interessata.</p>',
'<p>Le funzioni di gestione degli errori devono implementare l''interfaccia seguente:',
'<pre>',
'function &lt;nome della funzione> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
'<p>Per la descrizione del package <code>apex_error</code>, vedere il manuale di riferimento API.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540104002306996)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Funzione di gestione errori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246719955307591)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il messaggio di errore che verr\00E0 visualizzato se il calcolo non riesce.'),
'    Usare <code>#SQLERRM#</code> come stringa di sostituzione per il messaggio di errore SQL generato in seguito a un calcolo non riuscito.</p>',
'    <p>I calcoli sono stati progettati per riuscire sempre e non riescono solo a causa di errori non gestiti in anticipo.',
unistr('    Si sconsiglia di implementare un calcolo che non riesce con regolarit\00E0 e funge da pseudo-convalida utilizzando questo messaggio di errore.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568326168307022)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il messaggio di errore che verr\00E0 visualizzato se il calcolo non riesce.'),
'    Usare <code>#SQLERRM#</code> come stringa di sostituzione per il messaggio di errore SQL generato in seguito a un calcolo non riuscito.</p>',
'    <p>I calcoli sono stati progettati per riuscire sempre e non riescono solo a causa di errori non gestiti in anticipo.',
unistr('    Si sconsiglia di implementare un calcolo che non riesce con regolarit\00E0 e funge da pseudo-convalida utilizzando questo messaggio di errore.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881958043307303)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il messaggio di errore per questo processo.',
'Il messaggio immesso viene visualizzato se viene restituita un''eccezione non gestita. Dopo qualsiasi interruzione dell''elaborazione degli errori, viene eseguito il rollback e viene visualizzato un messaggio di errore.</p>',
unistr('<p>Nota: il messaggio di errore SQL (sqlerrm) viene visualizzato per impostazione predefinita se si definisce <strong>Nella pagina di errore</strong> come posizione di visualizzazione dell''errore. Non \00E8 necessario aggiungere <code>#SQLERRM#</code> al')
||' testo dell''errore personalizzato.</p>',
'<p>I messaggi di errore possono contenere le stringhe di sostituzione riportate di seguito.</p>',
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
'  <dd>Testo del messaggio di errore senza il numero dell''errore.</dd>',
'  <dt><code>#SQLERRM#</code></dt>',
'  <dd>Messaggio di errore completo.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441100075307741)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #LABEL#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528945593306985)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il testo da visualizzare se la convalida non viene superata.</p>',
unistr('<p>\00C8 possibile utilizzare <code>#LABEL#</code> come segnaposto per l''etichetta dell''elemento di pagina associato oppure <code>#COLUMN_HEADER#</code> per l''intestazione della colonna Area modificabile associata. I segnaposto non sono supportati se la ')
||unistr('posizione di visualizzazione dell''errore \00E8 impostata su Nella pagina di errore.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102528837027306985)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Messaggio di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640364244307094)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il punto in cui viene visualizzato il messaggio di errore per questa convalida.',
'I messaggi di errore di convalida vengono visualizzati in una pagina di errore distinta o in linea con la pagina esistente.',
'I messaggi di errore in linea vengono visualizzati sotto l''etichetta <em>Elemento associato</em> e/o in un''area di notifica definita come parte del modello di pagina.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060957420307441)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'it'
,p_message_text=>'In linea nella notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060862921307441)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'it'
,p_message_text=>'In linea con campo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103060735101307441)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'it'
,p_message_text=>'In linea con campo e nella notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061018019307441)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Nella pagina di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640286858307094)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557116609307011)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Per evitare gli attacchi di tipo XSS (Cross-Site Scripting), impostare sempre questo attributo su <strong>Attivo</strong>.',
unistr('Se \00E8 necessario visualizzare le tag HTML memorizzate nell''elemento di pagina o nelle voci di una lista di valori, \00E8 possibile impostare questo flag su <strong>Non attivo</strong>.'),
unistr('In casi del genere, \00E8 necessario prendere ulteriori precauzioni per garantire che all''input dell''utente in questi campi venga applicato in modo appropriato il carattere di escape durante l''immissione e prima del salvataggio.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557003246307011)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Caratteri speciali di escape'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529125615306986)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gli schemi di autorizzazione vengono valutati quando vengono usati per la prima volta in una sessione.',
'Selezionare il punto di valutazione appropriato per determinare se l''uso successivo dell''autorizzazione specificata ottiene il risultato dalla memoria oppure comporta una nuova valutazione dello schema di autorizzazione.</p>',
'#LOV_VALUES#',
unistr('<p>Il valore predefinito <em>Una volta per sessione</em> \00E8 il pi\00F9 efficiente.'),
'Scegliere un altro valore se il controllo dell''autorizzazione dipende dalla modifica dello stato della sessione o da altri fattori che si rivelano non coerenti nell''intera sessione.',
'Le opzioni <em>Una volta per componente</em> e <em>Sempre (nessun inserimento nella cache)</em> forniscono parametri aggiuntivi che possono essere definiti per essere usati dallo schema di autorizzazione.',
unistr('Nei plugin di autorizzazione \00E8 possibile usare gli attributi <em>component.type</em>, <em>component.id</em> e <em>component.name</em> del parametro <em>t_authorization</em>.'),
'Per i tipi di schema built-in <em>Query SQL - Esiste</em> e <em>Corpo funzione</em> sono disponibili le bind variable <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> e <em>:APP_COMPONENT_NAME</em> equivalenti.',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037361213307423)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'it'
,p_message_text=>'Una volta per componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037490920307423)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Esegue una volta la valutazione per ogni componente che fa riferimento allo schema di autorizzazione, ma salva il risultato nella sessione. Le ulteriori richieste di visualizzazione o elaborazione dello schema utilizzano il risultato presente in memo'
||'ria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037113369307422)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'it'
,p_message_text=>'Una volta per visualizzazione di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037275535307423)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Esegue una volta la valutazione per ogni richiesta elaborata. Usare il risultato presente in memoria se pi\00F9 componenti della pagina fanno riferimento allo schema di autorizzazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036918794307422)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'it'
,p_message_text=>'Una volta per sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037056571307422)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Esegue una sola volta la valutazione e quindi utilizza il risultato presente in memoria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037572995307423)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'it'
,p_message_text=>'Sempre (nessun inserimento nella cache)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037656938307423)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'it'
,p_message_text=>'Lo schema di autorizzazione viene valutato sempre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529090276306985)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Punto di valutazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534192553306990)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare l''evento che provocher\00E0 l''attivazione dell''azione dinamica.'),
'Per informazioni su eventi specifici, vedere la sezione pertinente in <em>App Builder User''s Guide</em>.</p>',
'Gli eventi sono suddivisi nelle categorie dei tipi riportati di seguito.',
'<dl>',
'  <dt>Eventi del browser</dt>',
'    <dd>Eventi standard del browser.</dd>',
'  <dt>Eventi del framework</dt>',
'    <dd>Gli eventi del framework vengono attivati dall''interno del framework di Application Express.</dd>',
'  <dt>Eventi di componente</dt>',
'    <dd>Sono disponibili solo quando esiste un componente disponibile per l''applicazione che attiva un evento personalizzato. Questi eventi vengono attivati da componenti nativi o da componenti di plugin installati nell''applicazione.</dd>',
'  <dt>Evento personalizzato</dt>',
'    <dd>Qualsiasi evento personalizzato attivato dall''applicazione.</dd>',
'</dl>',
'<p>Nota: gli eventi visualizzati differiscono a seconda del tipo dell''interfaccia utente corrente della pagina.',
unistr('Se si desidera selezionare un evento corrispondente a un tipo differente, \00E8 possibile selezionare <strong>Mostra non supportati</strong>,'),
'che consente di visualizzare tutti gli eventi, inclusi quelli non corrispondenti al tipo corrente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534079053306990)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558399228307013)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''ambito dell''evento, che determina il momento della seconda o successiva valutazione dell''evento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047948109307431)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'it'
,p_message_text=>'Statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048055643307431)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'it'
,p_message_text=>'Associa l''handler di eventi all''elemento o agli elementi di trigger per la durata della pagina corrente. L''associazione termina se tuttavia un elemento di trigger viene aggiornato mediante l''aggiornamento parziale della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048162779307431)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'it'
,p_message_text=>'Dinamico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048203527307431)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'it'
,p_message_text=>'Associa l''handler di eventi all''elemento o agli elementi di trigger per la durata della pagina corrente, indipendentemente dall''eventuale ricreazione degli elementi di trigger mediante l''aggiornamento parziale della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048303955307431)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'it'
,p_message_text=>'Una volta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048434935307431)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Associa una sola volta l''handler di eventi all''elemento o agli elementi di trigger. L''azione dinamica non verr\00E0 attivata di nuovo finch\00E9 la pagina non sar\00E0 stata completamente aggiornata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558207332307012)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ambito evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365812777307680)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se si desidera escludere questo titolo dalla traduzione. Questo attributo ha effetto solo quando si traduce l''applicazione in un''altra lingua.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365785520307680)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Escludi titolo dalla traduzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199016798307556)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare per quante volte deve essere eseguita questa condizione del layer.',
unistr('Se si fa riferimento alle <em>Colonne</em> nella condizione, \00E8 necessario specificare <strong>Per ogni riga</strong> in modo che la condizione venga valutata per ogni riga della query sul layer.'),
'In caso contrario, impostare su <strong>Una volta</strong> per valutare le convalide una sola volta per l''area.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641122222307094)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare per quante volte deve essere eseguita questa convalida dell''area modificabile.',
unistr('Se si fa riferimento alle <em>Colonne</em> nella condizione, \00E8 necessario specificare <strong>Per ogni riga</strong> in modo che la condizione venga valutata per ogni riga dell''area modificabile.'),
'In caso contrario, specificare <strong>Una volta</strong> per valutare le convalide una sola volta per l''area.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061433234307442)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Una volta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061391445307442)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Per ogni riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641077803307094)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Esegui condizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771892501307215)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indicare quando deve essere eseguita questa condizione di sola lettura.</p>',
unistr('        <p>Se si fa riferimento alle <em>Colonne</em> nella condizione di sola lettura, \00E8 necessario specificare <strong>Per ogni riga</strong> affinch\00E9 la condizione venga valutata per ogni riga della griglia interattiva.'),
'		In caso contrario, specificare <strong>Una volta</strong> per valutare la condizione una sola volta per l''area.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772060052307215)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Una volta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887816252307308)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>'Valuta la condizione di sola lettura una sola volta per l''intera area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771994027307215)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Per ogni riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887748654307308)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'it'
,p_message_text=>'Valuta la condizione di sola lettura in modo indipendente per ogni riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102771714030307215)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Esegui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640971790307094)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare l''ambito di esecuzione per questa convalida dell''area modificabile.',
'Selezionare <strong>Per righe create e modificate</strong> se si desidera che la convalida venga valutata per le righe nuove e aggiornate dell''area modificabile.',
'Se si desidera che la convalida venga valutata per ogni riga sottomessa, selezionare <strong>Tutte le righe sottomesse</strong>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061267410307441)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Tutte le righe sottomesse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103061103778307441)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Per righe create e modificate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102640822532307094)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ambito di esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533714427306990)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare la sequenza per questo componente. La sequenza determina l''ordine di esecuzione.</p>',
'<p>Nota: se due componenti hanno lo stesso valore di sequenza, potrebbero essere eseguiti secondo un ordine diverso quando l''applicazione viene esportata e importata in un altro ambiente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102533626491306990)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357373731307674)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per un servizio REST ORDS, applicazione di un filtro per filtrare tutti i record con un valore di attributo "sal" minore di 3000.</dt>',
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357273139307674)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Fornire l''espressione di filtro da passare al servizio REST esterno. L''espressione verr\00E0 passata al server remoto senza modifiche. La sintassi dipende dal tipo di origine dati REST. Ad esempio, Oracle REST Data Services (ORDS) prevede la sintassi JSO')
||'N.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357173028307674)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Filtro esterno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357663080307674)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per un servizio REST ORDS, ordinamento in base all''attributo "job" con criterio crescente, quindi in base a "ename" con criterio decrescente.</dt>',
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357596720307674)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Fornire un''espressione ORDER BY da passare al servizio REST esterno. L''espressione verr\00E0 passata al server remoto senza modifiche. La sintassi dipende dal tipo di origine dati REST. Ad esempio, Oracle REST Data Services (ORDS) prevede la sintassi JSO')
||'N.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357416890307674)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'ORDER BY - Esterno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905422080307321)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la post-elaborazione esterna \00E8 abilitata per questo report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905368254307321)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905147953307321)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo del collegamento sul quale gli utenti finali faranno clic per richiamare il motore di elaborazione esterno.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102905032896307320)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904915582307320)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''URL di un server per la post-elaborazione di questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102904862243307320)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214945939307567)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il gruppo di facet al quale \00E8 associata questa casella di controllo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214803493307567)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Gruppo di facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143376663307502)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo della lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144028803307503)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'it'
,p_message_text=>'Valori distinti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103144188454307503)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori si basa su una query generata in modo automatico che seleziona i valori di colonna distinti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270269936307609)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103270398092307609)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori dinamica si basa sulla query SQL restituita dal corpo della funzione immessa dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143436603307502)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'it'
,p_message_text=>'Componente condiviso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143538167307502)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori si basa su una la lista di valori predefinita definita nei componenti condivisi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143615866307502)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143763783307503)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori dinamica si basa sulla query SQL immessa dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143839258307503)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143965121307503)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori statica si basa sul valore del testo immesso dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103143225734307502)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988209441307385)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Specificare se il facet \00E8 comprimibile. Quando l''impostazione \00E8 <strong>Attivo</strong>, a sinistra del facet viene visualizzato un pulsante di attivazione/disattivazione che consente di nascondere o visualizzare le voci di lista. Quando l''imposta')
||unistr('zione \00E8 <strong>Non attivo</strong>, il facet e le relative voci di lista sono sempre visibili.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988164450307385)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Comprimibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406927657307714)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Specificare se calcolare il conteggio delle voci di lista per il facet o il filtro. L''uso di questa opzione influisce sulle prestazioni.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406825364307714)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Calcola conteggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215118947307568)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare come combinare i filtri all''interno di questo gruppo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215460227307568)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'it'
,p_message_text=>'AND (intersezione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215509038307568)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I filtri verranno combinati mediante l''operatore "AND", pertanto il risultato sar\00E0 l''intersezione di tutti i singoli filtri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215292334307568)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'it'
,p_message_text=>'OR (unione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215337842307568)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I filtri verranno combinati mediante l''operatore "OR", pertanto il risultato sar\00E0 il set di unione dei singoli filtri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215093844307567)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Combina filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987645533307385)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Specificare se consentire l''applicazione di filtri lato client delle voci di lista per il facet o il filtro. Quando l''impostazione \00E8 <strong>Attivo</strong>, al di sopra delle voci di lista viene visualizzato un campo di ricerca per consentire agl')
||'i utenti finali di applicare filtri alla lista.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987513883307385)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Applicazione filtri lato client'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216113920307568)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Specificare se il grafico deve essere visualizzato inizialmente. Questa propriet\00E0 si applica solo quando il valore della propriet\00E0 Mostra grafici dell''area Ricerca con facet \00E8 Selettore. Le modifiche apportate a questa propriet\00E0 potrebbero non ess')
||unistr('ere immediatamente visibili perch\00E9 il set di grafici visualizzato dall''utente \00E8 persistente nella sessione del browser. Per visualizzare l''effetto delle modifiche apportate a questa propriet\00E0, reimpostare il report utilizzando il collegamento Reimpos')
||'ta aree dell''opzione di controllo della cache, come con il pulsante Reimposta generato dalla procedura guidata.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216065098307568)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra grafico all''inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988454475307385)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Specificare se il facet deve essere inizialmente visualizzato in stato compresso. Le modifiche apportate a questa propriet\00E0 potrebbero non essere immediatamente visibili perch\00E9 lo stato di espansione \00E8 persistente nella sessione del browser. Per v')
||unistr('isualizzare l''effetto delle modifiche apportate a questa propriet\00E0, reimpostare il report utilizzando il collegamento Reimposta aree dell''opzione di controllo della cache, come con il pulsante Reimposta generato dalla procedura guidata.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988367729307385)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Inizialmente compresso'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221030153307572)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Determina se il facet viene visualizzato per impostazione predefinita. Le modifiche apportate a questa propriet\00E0 potrebbero non essere immediatamente visibili perch\00E9 lo stato visualizzato \00E8 persistente nella sessione del browser. Per visualizzare ')
||unistr('l''effetto delle modifiche apportate a questa propriet\00E0, reimpostare il report utilizzando il collegamento Reimposta aree dell''opzione di controllo della cache, come con il pulsante Reimposta generato dalla procedura guidata.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220990418307572)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizzato inizialmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988697505307385)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''altezza massima del facet in pixel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988503584307385)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza massima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988756734307386)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330996956306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare come combinare i singoli valori durante l''applicazione dei filtri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331200422306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'it'
,p_message_text=>'AND (intersezione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331343566306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I valori verranno combinati mediante l''operatore "AND", pertanto il risultato sar\00E0 l''intersezione di tutti i singoli valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331090736306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'it'
,p_message_text=>'OR (unione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331167384306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I valori verranno combinati mediante l''operatore "OR", pertanto il risultato sar\00E0 il set di unione dei singoli valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330893392306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Combinazione di filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330585887306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Caratteri normali:</dt>',
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
'<dt>Caratteri di controllo:</dt>',
'<dd>Tabulazione (<em>ASCII: 9</em>) <pre>\t</pre></dd>',
'<dd>Avanzamento riga (<em>ASCII: 10</em>) <pre>\n</pre></dd>',
'<dt>Altri caratteri:</dt>',
'<dd>Utilizzare un valore di codifica Unicode nel formato ''\xxxx'', dove ''xxxx'' indica il valore esadecimale di un carattere nel formato di codifica UCS-2.</dd>',
'<dd>Inizio dell''intestazione (<em>ASCII: 1</em>) <pre>\0001</pre></dd>',
'<dd>Simbolo "@" (<em>ASCII: 64</em>) <pre>\0040</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330438700306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Identifica il carattere che separa i diversi valori. Tenere presente che i caratteri <strong>"</strong> (virgolette) e <strong>\</strong> (barra rovesciata) non sono supportati come separatori di valori, neanche nel formato <strong>\xxxx</strong>.'
||'</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330315450306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Separatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330799380306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indica se rimuovere gli spazi vuoti iniziali e finali da singoli valori dopo la suddivisione.</p>',
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('<dt>Se l''opzione Rimuovi spazio vuoto \00E8 <em>disabilitata</em>, vengono conteggiati i singoli valori seguenti:</dt>'),
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
unistr('<dt>Se l''opzione Rimuovi spazio vuoto \00E8 <em>abilitata</em>, vengono conteggiati i singoli valori seguenti:</dt>'),
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  2',
'</pre></dd>',
unistr('<p>Tenere presente che la rimozione degli spazi vuoti pu\00F2 incidere notevolmente sulle prestazioni delle query. Per i set di dati di grandi dimensioni, si consiglia di effettuare una pulizia dei dati.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330618547306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Rimuovi spazio vuoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331689554306821)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331719745306821)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna non contiene pi\00F9 valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580124919307033)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580281078307033)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna non contiene pi\00F9 valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329821937306819)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Determina se la colonna di origine contiene pi\00F9 valori e come sono codificati.</p><p><em>I facet con pi\00F9 valori sono supportati solo sui database Oracle versione 12.2 o successiva. Su un database 12.1 &PRODUCT_NAME. generer\00E0 un errore di runtime s')
||unistr('e viene definito un facet con pi\00F9 valori.</em></p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330117920306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'it'
,p_message_text=>'Array JSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330283872306820)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>La colonna di origine contiene un array JSON di valori scalari. Se la colonna contiene una sintassi JSON non valida, &PRODUCT_NAME. generer\00E0 messaggi di errore.</p><pre>["APEX", "SQL" e "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329934356306819)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'it'
,p_message_text=>'Lista delimitata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102330044224306819)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>La colonna contiene valori come lista delimitata.</p><pre>APEX,SQL,PL/SQL</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329775037306819)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215912151307568)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Specificare se un pulsante viene visualizzato accanto al facet per consentire all''utente di visualizzare un grafico dei conteggi delle voci di lista del facet. Questa propriet\00E0 si applica solo quando il valore della propriet\00E0 Mostra grafici dell''a')
||unistr('rea Ricerca con facet non \00E8 No.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103215870056307568)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987497869307385)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Specificare se mostrare il conteggio delle ricorrenze delle voci di lista per il facet o il filtro. Quando l''impostazione \00E8 <strong>Attivo</strong>, il conteggio viene visualizzato tra parentesi accanto alla voci di lista. Ad esempio: KING (3).</p')
||'>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987300113307384)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra conteggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988091207307385)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Specificare il numero massimo di voci di lista da visualizzare per il facet. Quando si specifica un valore e la lista contiene un numero di voci superiore al valore specificato, viene visualizzato un collegamento <strong>Mostra altro</strong> nell'
||'a parte inferiore della lista. Quando non si specifica alcun valore vengono visualizzate tutte le voci.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987977576307385)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero massimo voci visualizzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987824153307385)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Specificare se le eventuali voci di lista selezionate devono essere mostrate per prime nella lista per il facet o il filtro. Questo attributo non si applica nei casi in cui la lista di valori associata al facet definisce gruppi.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987768407307385)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra selezionate per prime'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617394103307067)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se ordinare le voci della lista per il facet o il filtro. Quando l''impostazione \00E8 <strong>Attivo</strong>, le voci della lista vengono ordinate in base al conteggio decrescente. Quando l''impostazione \00E8 <strong>Non attivo</strong>, le voci')
||' della lista vengono visualizzate nell''ordine definito dalla lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102617233006307067)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Ordina per conteggi pi\00F9 alti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220812582307572)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Specificare se gli utenti finali possono mostrare o nascondere il facet. Quando questa opzione \00E8 attivata per almeno un facet, un pulsante "Pi\00F9 facet" viene aggiunto per consentire di scegliere i facet da mostrare o nascondere. Non sono previsti c')
||'osti relativi alle prestazioni per calcolare i conteggi dei facet che non vengono visualizzati.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220704450307572)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attivazione/disattivazione visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407197739307715)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Specificare il modo in cui le voci della lista con conteggio pari a zero vengono visualizzate per il facet o il filtro.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407488761307715)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'it'
,p_message_text=>'Disabilita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407599391307715)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Visualizza tutte le voci, ma disabilita quelle non filtrabili.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407245685307715)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'it'
,p_message_text=>'Nascondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407359288307715)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Visualizza solo voci di lista filtrabili.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407633957307715)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'it'
,p_message_text=>'Mostra ultime'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407748044307715)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Visualizza tutte le voci, ma disabilita quelle non filtrabili e le mostra per ultime nella lista per il facet o il filtro. Questa opzione viene ignorata se la lista di valori condivisa associata utilizza la funzione di gruppo.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407087220307714)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Voci con conteggio zero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540587738306996)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere gli attributi aggiuntivi da utilizzare nella cella di tabella HTML che contiene questa etichetta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540408194306996)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi cella tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896450510307314)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere il modello di campo da utilizzare per la presentazione del campo del form tabulare. Se non viene selezionato alcun modello, il campo viene presentato utilizzando l''etichetta conforme all''accesso facilitato predefinita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916606717307332)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere il modello di campo da utilizzare per la presentazione del campo del form tabulare. Se non viene selezionato alcun modello, il campo viene presentato utilizzando l''etichetta conforme all''accesso facilitato predefinita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540395514306996)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare un modello di etichetta per definire l''aspetto e il layout di questa etichetta di elemento.</p>',
'        <p>I modelli di etichetta sono definiti nel tema dell''applicazione.',
'        Quando si crea un elemento, il modello viene impostato in modo automatico sul modello di elemento predefinito presente nel tema corrente.</p>',
'        <p>Numerosi temi contengono modelli di etichetta per la visualizzazione di etichette obbligatorie, facoltative e nascoste.<br>',
'        Nel tema universale sono disponibili i modelli di etichetta riportati di seguito.',
'          <dl>',
'            <dt>Nascosto</dt>',
unistr('              <dd>Usare questo modello quando l''etichetta non deve essere visualizzata sullo schermo. Tenere presente che la tecnologia assistiva sar\00E0 comunque in grado di leggere l''etichetta.'),
unistr('              Il modello Nascosto viene ignorato per gli elementi di tipo Casella di controllo perch\00E9 dopo la casella di controllo deve essere visualizzata un''etichetta.</dd>'),
'            <dt>Facoltativo</dt>',
unistr('              <dd>Usare questo modello per gli elementi facoltativi del form. L''etichetta verr\00E0 visualizzata a lato dell''elemento.</dd>'),
'            <dt>Facoltativo - Al di sopra</dt>',
unistr('              <dd>Usare questo modello per gli elementi facoltativi del form. L''etichetta verr\00E0 visualizzata al di sopra dell''elemento.</dd>'),
'            <dt>Facoltativo - Mobile</dt>',
unistr('              <dd>Usare questo modello per gli elementi facoltativi del form. L''etichetta verr\00E0 visualizzata all''interno dell''elemento di input e verr\00E0 ridotta automaticamente dopo l''inserimento di un valore nel campo di input.</dd>'),
'            <dt>Obbligatorio</dt>',
unistr('              <dd>Questo modello di etichetta visualizza un asterisco di colore rosso accanto all''etichetta; viene usato per gli elementi del form per i quali \00E8 obbligatorio l''input dell''utente. L''etichetta verr\00E0 visualizzata a lato dell''elemento.</d')
||'d>',
'            <dt>Obbligatorio - Al di sopra</dt>',
unistr('              <dd>Questo modello di etichetta visualizza un asterisco di colore rosso accanto all''etichetta; viene usato per gli elementi del form per i quali \00E8 obbligatorio l''input dell''utente. L''etichetta verr\00E0 visualizzata al di sopra dell''element')
||'o. I modelli di elemento consentono di definire gli attributi dell''interfaccia utente come parte di un tema e di condividere la definizione tra numerosi elementi di pagina.</dd>',
'            <dt>Obbligatorio - Mobile</dt>',
unistr('              <dd>Questo modello di etichetta visualizza un asterisco di colore rosso accanto all''etichetta; viene usato per gli elementi del form per i quali \00E8 obbligatorio l''input dell''utente. L''etichetta verr\00E0 visualizzata all''interno dell''element')
||unistr('o di input e verr\00E0 ridotta automaticamente dopo l''inserimento di un valore nel campo di input. I modelli di elemento consentono di definire gli attributi dell''interfaccia utente come parte di un tema e di condividere la definizione tra numerosi eleme')
||'nti di pagina.</dd>',
'          </dl>',
'          Vedere anche: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540256624306996)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353525926307671)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Filtra tipo di dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767548828307211)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se eseguire una ricerca di tipo Corrispondenza esatta quando l''utente finale immette il testo in un filtro di colonna.',
unistr('      Se l''impostazione \00E8 <strong>Non attivo</strong>, il filtro eseguir\00E0 una ricerca di tipo Contiene anzich\00E9 una ricerca di tipo Uguale.</p>'),
unistr('      <p>Ad esempio, per una colonna denominata TAGS, ci\00F2 equivale a TAGS = ''<<valore>>''. Se la Corrispondenza esatta \00E8 impostata su <strong>Non attivo</strong>, ci\00F2 equivale a TAGS LIKE ''%<<valore>>%''. ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767491904307211)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corrispondenza esatta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765917162307210)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare se un filtro \00E8 sempre richiesto per questa colonna.</p>'),
unistr('        <p>Nota: un filtro verr\00E0 sempre richiesto per questa colonna specifica prima della restituzione di qualsiasi dato, indipendentemente dall''opzione <strong>Filtro obbligatorio</strong> negli attributi della griglia interattiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765869013307210)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Richiesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766167992307210)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare le modalit\00E0 di derivazione della lista di valori per il filtro quando un utente fa clic sull''intestazione della colonna o nelle finestre di dialogo di filtro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766458646307210)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'it'
,p_message_text=>'Colonna singola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766536615307210)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'it'
,p_message_text=>'I valori di colonna singola vengono visualizzati per le colonne VARCHAR2 e NUMBER. Le colonne DATE e TIMESTAMP utilizzano gli intervalli di data predefiniti incorporati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352543050307670)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352644458307670)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'it'
,p_message_text=>'I valori derivano dalla lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766238227307210)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766344719307210)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Disabilita tutti i valori visualizzati nel filtro.',
unistr('        Questa opzione \00E8 appropriata per le colonne di grandi dimensioni, con la maggior parte dei valori che supera 50 caratteri, oppure quando una lista non \00E8 utile per la selezione di un record specifico.'),
unistr('        In questo caso l''utente finale pu\00F2 semplicemente digitare un valore parziale e visualizzare i risultati.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767255224307211)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767399314307211)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'I valori derivano dal corpo di una funzione PL/SQL che restituisce una query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766809998307211)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'it'
,p_message_text=>'Componente condiviso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766940933307211)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'it'
,p_message_text=>'I valori derivano da una lista di valori esistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766697916307210)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766728522307211)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'I valori vengono derivati dalla definizione della query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767024367307211)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767103711307211)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'I valori derivano da una lista di valori statica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102766077292307210)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764746383307209)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare gli operatori di filtro che possono essere usati dagli utenti finali per questa colonna.</p>',
unistr('        <p>A seconda della dimensione del data set e degli indici di colonna, \00E8 possibile scegliere di disabilitare determinati operatori di filtro per evitare problemi relativi alle prestazioni per gli utenti finali.'),
'        Con certi operatori vengono eseguite le scansioni intera tabella e gli indici di colonna non vengono utilizzati.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936016496307347)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'it'
,p_message_text=>'Contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936106158307347)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il filtro restituisce i risultati dei valori di colonna che contengono il valore di filtro impostato.',
unistr('        &PRODUCT_NAME. utilizzer\00E0 <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code> nella clausola WHERE.</p>'),
'        <p>Nota: questo operatore impedisce l''uso di qualsiasi indice di colonna, pertanto potrebbe essere eseguita una scansione intera tabella.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764983617307209)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'it'
,p_message_text=>'Senza distinzione tra maiuscole e minuscole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887569116307308)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il filtro restituisce i risultati dei valori di colonna indipendentemente dalle differenze di lettere maiuscole/minuscole esistenti tra il valore della colonna e il valore del filtro.',
unistr('        &PRODUCT_NAME. utilizzer\00E0 <code>UPPER(column) <em>operatore</em> UPPER(filtervalue)</code> nella clausola WHERE.</p>'),
'        <p>Nota: in genere l''esecuzione di UPPER sia sul valore della colonna che sul valore del filtro evita l''uso degli indici di colonna, salvo per gli indici di colonna basati su funzione con UPPER(<em>column</em>).</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764842912307209)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'it'
,p_message_text=>'Espressione regolare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887648228307308)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il filtro restituisce i risultati in base all''espressione regolare immessa.</p>',
unistr('        <p>Nota: l''uso degli operatori REGEXP \00E8 complesso e riservato in genere solo agli utenti esperti. Questi operatori possono essere la causa di prestazioni insoddisfacenti.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936202209307347)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'it'
,p_message_text=>'Inizia con'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936396072307347)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il filtro restituisce i risultati dei valori di colonna che iniziano con il valore di filtro impostato.',
unistr('        &PRODUCT_NAME. utilizzer\00E0 <code>column LIKE filtervalue<strong>%</strong></code> nella clausola WHERE.</p>'),
unistr('        <p>Nota: questo operatore pu\00F2 utilizzare gli indici di colonna disponibili. {Vedere <strong>Senza distinzione tra maiuscole e minuscole</strong> per le eccezioni}.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764627826307209)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Operatori con conseguenze sulle prestazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765160584307209)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare con quale tipo di lettere, maiuscole o minuscole, viene memorizzato il testo all''interno del valore della colonna.</p>',
unistr('        <p>Se la colonna pu\00F2 essere specificata sempre con lettere maiuscole, ad esempio<em>Username</em>, o sempre con lettere minuscole, il recupero dei risultati del filtro risulta migliorato.'),
unistr('          Quando \00E8 selezionata l''opzione <strong>Maiuscole</strong> o <strong>Minuscole</strong>, vengono sempre effettuate ricerche con distinzione tra maiuscole e minuscole.</p>'),
'        <p>Nota: se si seleziona Misto, gli utenti possono specificare <strong>Con distinzione tra maiuscole e minuscole</strong> nelle finestre di dialogo Cerca e Filtro.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765407505307209)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'it'
,p_message_text=>'Minuscole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765564557307210)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Per i casi in cui il valore della colonna viene sempre memorizzato in lettere minuscole.',
unistr('        &PRODUCT_NAME. utilizzer\00E0 <code>colonna <em>operatore</em> LOWER(filtervalue)</code> nella clausola WHERE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765634127307210)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'it'
,p_message_text=>'Misto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765729506307210)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'it'
,p_message_text=>'Per i casi in cui il valore della colonna viene memorizzato in lettere maiuscole e minuscole. La clausola WHERE utilizzata viene determinata dall''operatore <strong>Senza distinzione tra maiuscole e minuscole</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765233858307209)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'it'
,p_message_text=>'Maiuscole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765363377307209)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Per i casi in cui il valore della colonna viene sempre memorizzato in lettere maiuscole.',
unistr('        &PRODUCT_NAME. utilizzer\00E0 <code>colonna <em>operatore</em> UPPER(filtervalue)</code> nella clausola WHERE.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102765097559307209)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Maiuscole/minuscole testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559198955307013)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se questa azione deve essere attivata al momento dell''inizializzazione.</p>',
unistr('        							<p>Il termine inizializzazione assume un significato leggermente diverso a seconda della modalit\00E0 di definizione'),
'        							dell''azione dinamica. Per le azioni dinamiche definite per essere attivate nelle colonne della griglia interattiva,',
'        							specifica se l''azione deve essere attivata quando la riga della griglia interattiva viene attivata per la modifica.',
'        							Per tutte le altre azioni dinamiche, specifica se l''azione deve essere attivata al caricamento della pagina.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102559074079307013)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attiva all''inizializzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558935200307013)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se questa azione deve essere attivata quando la condizione dell''elemento di trigger viene soddisfatta selezionando <strong>True</strong> (azione True) oppure quando non viene soddisfatta selezionando <strong>False</strong> (azione Fals'
||'e).</p>',
'<p>Nota: quando non si specifica alcuna condizione, vengono attivate solo le azioni <strong>True</strong>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048640873307432)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'it'
,p_message_text=>'False'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103048593048307431)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'it'
,p_message_text=>'True'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558881875307013)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Attiva se il risultato dell''evento \00E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432732359307734)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se fissare le intestazioni di colonna del report all''inizio della <strong>pagina</strong> o all''inizio dell''<strong>area</strong>, in modo che le intestazioni di colonna rimangano visibili quando l''utente scorre verticalmente il report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433760418307735)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433825328307735)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''intestazione del report non \00E8 fissa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432967289307734)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433150560307735)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Fissa l''intestazione del report all''inizio della pagina. Quando l''utente scorre verticalmente la pagina, l''intestazione del report rimane fissa all''inizio della pagina. Le intestazioni fisse a livello di <strong>pagina</strong> sono utili se il repor'
||unistr('t \00E8 il contenuto principale della pagina. Questa impostazione non \00E8 supportata quando l''area si trova in una finestra di dialogo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432830149307734)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433035015307735)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Fissa l''intestazione del report nella parte superiore dell''area corrente. Quando l''utente scorre verticalmente l''area, l''intestazione del report rimane fissa nella parte superiore dell''area. Le intestazioni fisse a livello di <strong>area</strong> po'
||unistr('ssono essere utili per una pagina che contiene pi\00F9 aree, ad esempio la pagina di un dashboard.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432618959307734)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Fissa a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434173366307735)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''altezza massima del report in pixel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434085717307735)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza massima report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103434233979307736)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942178427307351)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''altezza fissa del report in pixel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942015390307351)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza fissa report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942211795307351)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758650035307203)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se visualizzare la griglia interattiva con altezza di riga fissa.</p>',
unistr('        <p>Se l''impostazione \00E8 <em>S\00EC</em>, alla fine dei dati verr\00E0 visualizzata un''ellissi (...) per le colonne troppo strette per visualizzare tutti i dati.'),
unistr('        Se l''impostazione \00E8 <em>No</em> i dati verranno disposti su pi\00F9 righe se necessario.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758523978307203)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza riga fissa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628011114307085)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il pi\00E8 di pagina dell''area da visualizzare subito dopo il contenuto del corpo, ovvero dopo <code>#BODY#</code>, nel modello di area.'),
unistr('Per visualizzare il tempo impiegato per la visualizzazione dell''area, \00E8 possibile utilizzare scorciatoie nonch\00E9 la stringa di sostituzione <code>#TIMING#</code>.</p>'),
unistr('<p>Per le aree di report, \00E8 possibile utilizzare le stringhe di sostituzione di impaginazione riportate di seguito.</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
'    <dd>Mostra il numero di righe recuperate tramite FETCH dal motore per report (dimensioni della pagina). Utilizzare queste stringhe di sostituzione per visualizzare messaggi personalizzati all''utente.</dd>',
'  <dt><code>#TOTAL_ROWS#</code></dt>',
'    <dd>Visualizza il numero totale di righe che soddisfano una query SQL utilizzata per un report, ad esempio la Z in righe X - Y di Z.</dd>',
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd>La X in righe X - Y di Z.</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd>La Y in righe X - Y di Z.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537675134306993)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo o il codice HTML da visualizzare prima del pi\00E8 di pagina del modello di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537504969306993)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Testo pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103077461094307454)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Quando si imposta questo attributo su <code>fielddatabold</code> viene generato il codice HTML seguente</dt>',
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894890890307313)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi CSS da applicare al valore di questa colonna. \00C8 possibile digitare la classe CSS oppure selezionarla nella lista degli elementi disponibili.</p>'),
unistr('<p>Questa classe \00E8 inclusa per impostazione predefinita in tutte le pagine di &PRODUCT_NAME. e dispone della definizione <code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894775905307313)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896374526307314)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il formato di visualizzazione da applicare a questa colonna.',
unistr('    \00C8 possibile digitare il formato di visualizzazione oppure sceglierlo dalla lista dei formati di visualizzazione predefiniti, in base a una rappresentazione di esempio della relativa modalit\00E0 di visualizzazione.</p>'),
unistr('    <p>\00C8 importante che i formati di visualizzazione numerici vengano applicati solo alle colonne che contengono numeri e i formati di visualizzazione per i campi di tipo data vengano applicati solo alle colonne che contengono date.'),
unistr('    In caso contrario, viene visualizzato un errore di runtime quando un record qualsiasi contiene un valore che non pu\00F2 essere convertito usando il formato di visualizzazione specificato.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916415780307332)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il formato di visualizzazione da applicare a questa colonna.',
unistr('    \00C8 possibile digitare il formato di visualizzazione oppure sceglierlo dalla lista dei formati di visualizzazione predefiniti, in base a una rappresentazione di esempio della relativa modalit\00E0 di visualizzazione.</p>'),
unistr('    <p>\00C8 importante che i formati di visualizzazione numerici vengano applicati solo alle colonne che contengono numeri e i formati di visualizzazione per i campi di tipo data vengano applicati solo alle colonne che contengono date.'),
unistr('    In caso contrario, viene visualizzato un errore di runtime quando un record qualsiasi contiene un valore che non pu\00F2 essere convertito usando il formato di visualizzazione specificato.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542334162306998)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il formato di visualizzazione da applicare a questo componente.',
unistr('    \00C8 possibile digitare il formato di visualizzazione oppure sceglierlo dalla lista dei formati di visualizzazione predefiniti, in base a una rappresentazione di esempio della relativa modalit\00E0 di visualizzazione.</p>'),
unistr('    <p>\00C8 importante che i formati di visualizzazione numerici vengano applicati solo ai componenti che contengono numeri e i formati di visualizzazione per i campi di tipo data vengano applicati solo ai componenti che contengono date.'),
unistr('    In caso contrario, viene visualizzato un errore di runtime quando il componente contiene un valore che non pu\00F2 essere convertito usando il formato di visualizzazione specificato.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542201736306998)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542567487306998)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il formato di visualizzazione per i campi di tipo data da applicare a questo componente.',
unistr('\00C8 possibile digitare il formato di visualizzazione oppure sceglierlo dalla lista dei formati di visualizzazione predefiniti, in base a una rappresentazione di esempio della relativa modalit\00E0 di visualizzazione.'),
unistr('\00C8 inoltre possibile usare una sintassi di sostituzione per fare riferimento a un formato di visualizzazione dinamico da un elemento di applicazione o di pagina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542403825306998)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542754799306998)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il formato di visualizzazione dei valori numerici da applicare a questo componente.',
unistr('\00C8 possibile digitare il formato di visualizzazione oppure sceglierlo dalla lista dei formati di visualizzazione predefiniti, in base a una rappresentazione di esempio della relativa modalit\00E0 di visualizzazione.'),
unistr('\00C8 inoltre possibile usare una sintassi di sostituzione per fare riferimento a un formato di visualizzazione da un elemento di applicazione o di pagina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542623817306998)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539057699306995)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Specificare se la funzione di completamento automatico \00E8 disabilitata per questa pagina. Il valore <strong>Attivo</strong> non ha effetto su questa pagina, mentre il valore <strong>Non attivo</strong> genera il codice HTML seguente nella tag FORM:'),
'<pre>',
'autocomplete="off"',
'</pre>',
'<p>Nota: a seconda dei browser, possono esistere regole diverse quando l''impostazione <code>autocomplete="off"</code> viene rispettata o ignorata. Tenere presente questo concetto, in particolar modo quando si imposta l''opzione su <strong>Non attivo</'
||'strong> per poi sottoporla test nei browser di destinazione.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040595036307425)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'it'
,p_message_text=>'Non attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040422770307425)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'it'
,p_message_text=>'Attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538973898306995)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Completamento automatico form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250425733306760)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione delle etichette nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250380566306760)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893319277307312)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il numero massimo di colonne di report generiche.',
unistr('I report che utilizzano i nomi di colonne generiche vengono analizzati solo in runtime, quindi il numero di colonne non \00E8 noto quando si modifica il report.</p>'),
'<p>Il numero massimo di colonne di report deve corrispondere al numero di colonne di report previsto.',
unistr('Se il numero effettivo \00E8 minore, il report verr\00E0 visualizzato con il numero effettivo di colonne.'),
unistr('Se invece il numero effettivo \00E8 maggiore del numero massimo, verr\00E0 visualizzato un messaggio di errore.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893240112307312)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Conteggio colonne generiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680181050307130)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la pagina globale per l''interfaccia utente corrente se non ne \00E8 stata definita una.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680059234307130)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagina globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341047864307662)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914381044307330)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914638419307331)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541305889306997)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare una colonna specifica del layout. Usare <strong>Automatico</strong> per determinare in modo automatico la colonna disponibile successiva del layout in cui visualizzare il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541274087306997)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542149021306997)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere gli attributi aggiuntivi impostati per la colonna del layout. Questo valore sostituisce il segnaposto di sostituzione <code>#ATTRIBUTES#</code> nel modello di colonna del layout.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542032318306997)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240512068307586)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225152339307575)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il numero delle colonne di layout occupate da questo componente. Usare Automatico per bilanciare le colonne di layout disponibili tra tutti i componenti nella stessa riga.</p>',
'<dl>',
'  <dt>Automatico</dt>',
unistr('    <dd>Le schede avranno una larghezza iniziale e verranno riportate automaticamente su una nuova riga se non sar\00E0 pi\00F9 possibile adattarle normalmente.</dd>'),
'  <dt>2, 3, 4, 5 colonne</dt>',
'    <dd>Le schede verranno disposte in modo da adattarsi al numero di colonne per riga selezionato. Il layout potrebbe ridurre il numero delle colonne in base alla larghezza del viewport.</dd>',
unistr('  <dt>\00C8 possibile configurare la larghezza delle schede mediante l''impostazione di una variabile CSS.</dt>'),
'    <dd>Ad esempio, aggiungere lo snippet seguente per impostare la larghezza delle schede su 320 pixel: <pre>:root {',
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225220751307575)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'it'
,p_message_text=>'2 colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225342310307575)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'it'
,p_message_text=>'3 colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225437286307575)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'it'
,p_message_text=>'4 colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225542501307575)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'it'
,p_message_text=>'5 colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103225037847307575)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonne griglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435665590307737)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi CSS da applicare alla colonna di layout che contiene quest''area. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
unistr('        <p>Questa propriet\00E0 pu\00F2 essere utilizzata per fornire un maggiore controllo sulla capacit\00E0 di risposta e sul layout della colonna di layout dell''area quando le dimensioni del viewport vengono modificate.'),
unistr('        Per le applicazioni con tema universale, esistono numerosi modificatori CSS che \00E8 possibile utilizzare per estendere i componenti di pagina. Per ulteriori informazioni, vedere la sezione Riferimento dell''Applicazione di esempio con tema unive')
||'rsale.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103435533932307737)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341175981307662)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914403772307331)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914741878307331)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541782256306997)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il numero di colonne del layout occupate da questo componente. Usare l''opzione <strong>Automatico</strong> per bilanciare le colonne disponibili tra tutti i componenti nella stessa riga del layout.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541631397306997)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432509474307734)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432441726307734)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il numero di colonne del layout occupate dall''etichetta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432350083307734)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero di colonne etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541511380306997)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se questo componente viene visualizzato nella colonna successiva o nella stessa colonna del componente precedente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541434882306997)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nuova colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540957085306996)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se questo componente viene visualizzato in un nuovo layout o nello stesso layout del componente precedente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540848190306996)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Inizia nuovo layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541112630306997)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se questo componente viene visualizzato nella riga successiva dopo il componente precedente o nella stessa riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541036173306997)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Inizia nuova riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199207491307556)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi CSS da applicare alla riga di layout che contiene quest''area. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
unistr('        <p>Questa propriet\00E0 pu\00F2 essere utilizzata per fornire un maggiore controllo sulla capacit\00E0 di risposta e sul layout della riga di layout dell''area quando le dimensioni del viewport vengono modificate.'),
unistr('        Per le applicazioni con tema universale, esistono numerosi modificatori CSS che \00E8 possibile utilizzare per estendere i componenti di pagina. Per ulteriori informazioni, vedere la sezione Riferimento dell''Applicazione di esempio con tema unive')
||'rsale.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199132730307556)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541998645306997)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il numero di righe della tabella HTML occupate da questo componente. I pulsanti sono visualizzati in tabelle HTML. Questo attributo determina il valore da utilizzare per l''attributo <em>ROWSPAN</em> nella cella di tabella per questo compo'
||'nente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102541835042306997)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818493101307256)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome della colonna da utilizzare per definire una breve descrizione comandi personalizzata e descrittiva sul nome o sui nomi delle serie nella legenda del grafico. Nel caso di un grafico box plot, la colonna non deve corrispondere al m'
||unistr('apping colonne Valore selezionato. La selezione di una colonna corrispondente al mapping colonne Valore determiner\00E0 la mancata visualizzazione della descrizione comandi della legenda sul grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818396563307256)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Descrizione comandi legenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818682266307256)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome della colonna da utilizzare per definire una breve descrizione comandi personalizzata e descrittiva sull''etichetta o sulle etichette dell''asse x del grafico. Nel caso di un grafico box plot, la colonna non deve corrispondere al ma'
||unistr('pping colonne Valore selezionato. La selezione di una colonna corrispondente al mapping colonne Valore determiner\00E0 la mancata visualizzazione della descrizione comandi delle etichette sul grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818593653307256)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Descrizione comandi etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893132229307312)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare se si desidera che le definizioni di colonna vengano derivate dalla query SQL.',
'Questa operazione richiede l''analisi della query da parte di &PRODUCT_NAME..',
'Se non si desidera eseguire l''analisi della query in questa fase, utilizzare nomi di colonne generiche, producendo definizioni di colonna utilizzate come segnaposto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893016410307312)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Usa nomi colonne generiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627928071307085)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo HTML visualizzato nella parte superiore dell''area, prima del contenuto di <code>#BODY#</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537283943306993)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo o il codice HTML da visualizzare subito dopo l''intestazione di pagina e prima del contenuto del corpo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537123620306993)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900592145307317)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la modalit\00E0 di definizione delle intestazioni per il report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079274505307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>'Intestazioni personalizzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079319809307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Consente all''utente di immettere intestazioni proprie. Inizialmente le intestazioni assumono valori predefiniti in base a una query dei nomi di colonna.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079466351307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079502766307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Crea le intestazioni in base a una funzione PL/SQL che restituisce una lista di nomi separata da due punti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079670206307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079778452307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'it'
,p_message_text=>'Il report viene visualizzato senza intestazioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078884216307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'it'
,p_message_text=>'Nomi di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078961905307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>'Genera le intestazioni in base a una query dei nomi di colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079069217307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'it'
,p_message_text=>'Nomi colonna (InitCap)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079150471307455)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'it'
,p_message_text=>'Genera le intestazioni, le cui iniziali vengono convertite in maiuscolo, in base a una query dei nomi di colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900482447307317)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861129058307288)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''allineamento dell''intestazione. Tenere presente che la selezione dell''allineamento deve essere supportata dal modello di report selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065007977307445)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'it'
,p_message_text=>'al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064902035307444)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'it'
,p_message_text=>'inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065176168307445)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102861051710307288)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Allineamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079806833307456)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Fornire le intestazioni per un report basato sulla tabella DEPT</dt>',
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900785839307317)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una funzione PL/SQL che restituisca una stringa di intestazioni di colonna delimitata da due punti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900645097307317)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772428100307216)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Usare questo attributo per immettere il testo della Guida per la griglia interattiva. Il testo immesso verr\00E0 visualizzato insieme al contenuto predefinito della Guida nella Guida del menu Azioni.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773367096307217)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo della Guida per questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915428270307331)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo della Guida per questo elemento. Questo testo pu\00F2 essere utilizzato per fornire le informazioni della Guida contestuale a livello di campo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540031313306996)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilizzare questo attributo per immettere il testo della Guida per la pagina corrente. La Guida a livello di pagina supporta scorciatoie che utilizzano la seguente sintassi:</p>',
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>Il testo della Guida della pagina non viene visualizzato per impostazione predefinita. \00C8 tuttavia possibile sviluppare prontamente un sistema della Guida che esponga questo testo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539996460306995)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794450462307236)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilizzare questo attributo per immettere il testo della Guida per la pagina corrente. La Guida a livello di pagina supporta scorciatoie che utilizzano la seguente sintassi:</p>',
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>Il testo della Guida della pagina non viene visualizzato per impostazione predefinita. \00C8 tuttavia possibile sviluppare prontamente un sistema della Guida che esponga questo testo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794348613307236)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576676313307029)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201727894307558)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814342802307253)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il tipo di funzionamento nascondi e mostra attivato quando si fa clic su un elemento di legenda.',
unistr('        Ad esempio, quando si deseleziona un elemento di legenda, la relativa serie di dati associata verr\00E0 nascosta nel grafico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814408983307253)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938055614307348)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr(' Il grafico non abiliter\00E0 il funzionamento nascondi e mostra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814649736307253)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'it'
,p_message_text=>'Nessun ridimensionamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938245134307348)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr(' Gli assi del grafico non vengono ridimensionati. Ci\00F2 consente di mantenere l''utente nel contesto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814511843307253)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'it'
,p_message_text=>'Ridimensiona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938158782307348)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr(' Gli assi del grafico vengono ridimensionati quando i valori minimi e massimi dei dati visibili aumentano o diminuiscono. Questo funzionamento \00E8 utile per le serie con valori soggetti a forti variazioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814223883307253)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Funzionamento nascondi e mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895298443307313)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere le stringhe di testo da evidenziare in una colonna del report.',
unistr('Per evidenziare pi\00F9 parole, utilizzare una lista separata da virgole.'),
unistr('\00C8 inoltre possibile fare riferimento agli elementi di pagina o di applicazione utilizzando la sintassi <code>&amp;ITEM.</code>.'),
unistr('Ad esempio, \00E8 possibile evidenziare le stringhe immesse in un campo di ricerca.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895195290307313)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Evidenzia parole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679565453307129)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la home page dell''applicazione per l''interfaccia utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679405803307129)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557911469307012)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Selezionare l''allineamento orizzontale per il pulsante all''interno della posizione di modello specificata.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056107096307438)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'it'
,p_message_text=>'A sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056266466307438)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'A destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557858633307012)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Allineamento orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067047231307446)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
'    Le sostituzioni <code>#COLUMN_CLASS#</code> e <code>#EMPLOYEE_STATUS#</code> in questo esempio sono colonne selezionate nella query SQL del report.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863739030307290)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da mostrare in questa colonna. Usare la sintassi <code>#COLUMN#</code> per mostrare i valori di colonna in formato HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863634221307290)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536897892306993)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il testo che sostituir\00E0 la stringa di sostituzione <code>#HEAD#</code> nell''intestazione del modello di pagina.'),
'I valori immessi verranno inseriti dopo la tag HTML <code>&lt;head&gt;</code>. Utilizzare questo attributo di pagina per aggiungere metatag specifiche per la pagina.',
'</p>',
'<p>Nota: il codice JavaScript o i fogli CSS (Cascading Style Sheet) devono essere aggiunti agli attributi JavaScript e CSS dedicati.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536772672306993)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Intestazione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230627960307579)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che restituisce l''oggetto BLOB per l''origine dell''immagine dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230506399307579)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230495781307579)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare come origine dell''immagine dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230378151307579)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579136605307032)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera usare per identificare il facet. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'            <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</'
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579258805307032)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera usare per identificare il facet. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'            <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</'
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579385179307032)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera usare per identificare il facet. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'            <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</'
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358099355307674)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'        <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</p>',
unistr('        <p>Nota: l''icona verr\00E0 visualizzata all''interno dell''elemento e non come parte dell''etichetta.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357963510307674)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'        <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</p>',
unistr('        <p>Nota: l''icona verr\00E0 visualizzata all''interno dell''elemento e non come parte dell''etichetta.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579505870307032)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera usare per identificare il filtro. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'            <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</'
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580450672307033)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera usare per identificare il filtro. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'            <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</'
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580844499307033)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera usare per identificare il filtro. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'            <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</'
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217117697307569)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione di una freccia che punta a destra</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103217038683307569)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'        <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216940403307569)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232189631307580)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questo testo descrive l''icona e pu\00F2 essere utilizzato per le descrizioni comandi e il testo alterativo per le immagini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232097971307580)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Descrizione icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230860402307579)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''URL per l''origine dell''immagine dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230748210307579)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231394661307579)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Determina la posizione dell''icona nell''intestazione della scheda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231843567307580)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231985035307580)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'it'
,p_message_text=>'Allinea l''icona alla posizione finale (in genere sul lato destro) dell''intestazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231627928307580)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231712056307580)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'it'
,p_message_text=>'Allinea l''icona alla posizione iniziale (in genere sul lato sinistro) dell''intestazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231468263307579)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'it'
,p_message_text=>'Inizio pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231577303307580)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza l''icona nella parte superiore dell''intestazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103231294646307579)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240686308307586)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuna icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229743583307578)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''origine per l''icona visualizzata nell''intestazione del componente scheda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230243488307579)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'it'
,p_message_text=>'Colonna BLOB immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230049620307578)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'it'
,p_message_text=>'Colonna classe icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229866160307578)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'it'
,p_message_text=>'Iniziali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229984586307578)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'it'
,p_message_text=>'Classe icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103230121803307578)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'it'
,p_message_text=>'URL immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229614457307578)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Origine icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761347854307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761201258307205)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</p>Immettere l''HTML delle colonne personalizzate per la vista icone.</p>',
'<p>Sono disponibili le stringhe di sostituzione riportate di seguito.',
'<ul>',
'<li><code>&&lt;COLUMN_NAME&gt;.</code>: stringhe di sostituzione per i nomi delle colonne.</li>',
'<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code>: stringhe di sostituzione per le etichette delle colonne.</li>',
'<li><code>&APEX$ROW_ID.</code>: identificativo del record per la riga.</li>',
'<li><code>&APEX$ROW_INDEX.</code>: numero sequenza di visualizzazione del record.</li>',
'<li><code>&APEX$ROW_URL.</code>: riferimento alla destinazione collegamento specificata.</li>',
'<li><code>&APEX$ROW_STATE_CLASSES.</code>: stato del record, ad esempio <code>is-inserted</code> o <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761190431307205)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Icona personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070443985307449)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872250349307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il collegamento colonna per la vista icone. Usare le stringhe di sostituzione <code>#COLUMN_NAME#</code> per i nomi delle colonne come richiesto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872193449307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Collegamento personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772234575307216)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la vista icone \00E8 abilitata. Se si seleziona <strong>Attivo</strong>, viene aggiunta un''icona Visualizza icone alla barra di ricerca per i report interattivi, oppure al pulsante Visualizza della griglia interattiva, e gli utenti possono')
||' accedere alla vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870686596307295)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la vista icone \00E8 abilitata. Se si seleziona <strong>Attivo</strong>, viene aggiunta un''icona Visualizza icone alla barra di ricerca per i report interattivi, oppure al pulsante Visualizza della griglia interattiva, e gli utenti possono')
||' accedere alla vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870531254307295)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871831183307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo della tag HTML ALT per l''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871764665307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo alternativo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102872065825307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la tag HTML TITLE per l''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871943132307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo titolo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762571298307207)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere gli attributi immagine di icona utilizzati per la tag HTML IMG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762426603307207)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761991404307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna della griglia interattiva che restituisce l''oggetto BLOB per l''origine dell''immagine dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761891486307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762376094307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna della griglia interattiva che restituisce le classi CSS per l''origine dell''immagine dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762281107307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761530619307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di colonna che contiene l''origine dell''immagine dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761712275307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'it'
,p_message_text=>'Classi CSS icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761686576307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'it'
,p_message_text=>'Immagine nell''URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102761497715307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762136854307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna della griglia interattiva che restituisce l''URL per l''origine dell''immagine dell''icona.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762064502307206)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871652134307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere gli attributi di immagine utilizzati per la tag HTML IMG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871524670307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070210408307448)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Esame della colonna <code>IMAGE</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871299533307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna del report che restituisce l''origine dell''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871173586307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna origine immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070330831307448)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Esame della colonna <code>ENAME</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871444365307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna del report che restituisce l''etichetta dell''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871371471307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744630141307190)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Esame della colonna <code>ENAME</code></dt>',
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744504878307190)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna del report che restituisce l''etichetta dell''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744407719307190)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762934983307207)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere gli attributi HTML associati alla visualizzazione di ogni <strong>Destinazione collegamento</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762845514307207)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070106543307448)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Esame della colonna <code>LINK</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102871043838307296)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna del report che restituisce la destinazione di collegamento dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870953666307295)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298180481307630)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298478317307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298305967307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298204458307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298559392307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298034597307630)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299389528307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un corpo funzione Java che restituisca una query SQL per l''inserimento dei dati in questa lista di valori.</p>',
unistr('<p>\00C8 sufficiente che la query SQL restituisca una sola colonna. Se restituisce pi\00F9 colonne, per la ricerca del filtro verr\00E0 usata solo la prima colonna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299253746307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299167320307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione del nome del reparto, impostazione del numero del reparto</dt>',
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299036251307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un corpo funzione JavaScript che restituisca una query SQL per l''inserimento dei dati in questa lista di valori.</p>',
unistr('<p>\00C8 sufficiente che la query SQL restituisca una sola colonna. Se restituisce pi\00F9 colonne, per la ricerca del filtro verr\00E0 usata solo la prima colonna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298920730307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298875379307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Per la restituzione del nome del reparto:</dt>',
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298725078307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il corpo funzione PL/SQL che restituisce una query SQL per l''inserimento dei dati in questa lista di valori.</p>',
unistr('<p>\00C8 sufficiente che la query SQL restituisca una sola colonna. Se restituisce pi\00F9 colonne, per la ricerca del filtro verr\00E0 usata solo la prima colonna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103298616162307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299540923307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un corpo funzione Python che restituisca una query SQL per l''inserimento dei dati in questa lista di valori.</p>',
unistr('<p>\00C8 sufficiente che la query SQL restituisca una sola colonna. Se restituisce pi\00F9 colonne, per la ricerca del filtro verr\00E0 usata solo la prima colonna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299421086307631)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767873747307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>'<pre>Mucca,Cane,Gatto,Leone</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767734116307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere una lista separata da virgole di valori per questa lista statica.</p>',
'        <p>Nota: i valori statici verranno visualizzati sempre nello stesso ordine in cui sono specificati, non in ordine alfabetico.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767638152307211)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763508289307208)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il gruppo per questa colonne. I gruppi vengono usati per associare le colonne nella griglia e nella vista a riga singola.</p>',
'        <p>Nota: per aggiungere i gruppi, espandere la cartella degli attributi nella struttura ad albero Rendering e fare clic con il pulsante destro del mouse su Gruppi di colonne per creare un nuovo gruppo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763498875307207)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768087436307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di origine su cui si basa il valore di questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768114942307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768262696307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore colonna immesso in <em>Colonna database</em>, che viene recuperato dalla query SQL dell''origine area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768511676307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768610495307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>'Il valore della colonna non viene recuperato da alcuna origine. Ad esempio, le colonne APEX$ROW_SELECTOR e APEX$ROW_ACTION non hanno un''origine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768308901307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768436128307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dall''<em>espressione SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102767941793307212)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760696231307205)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Selezionare i formati di download che gli utenti possono utilizzare per scaricare le colonne visualizzate.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760716075307205)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'it'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760828299307205)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'it'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918863861307334)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'it'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204140792306725)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'it'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760570392307205)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762727751307207)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Fare clic su Destinazione collegamento per richiamare una finestra di dialogo di tipo modale. \00C8 possibile immettere la destinazione personalizzata da richiamare quando si fa clic sull''icona.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102762649662307207)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Destinazione collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758817486307203)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il tipo di impaginazione per il report. Spesso non tutte le righe vengono visualizzate nel report.',
unistr('		Per visualizzare righe aggiuntive, l''utente finale pu\00F2 usare l''impaginazione fornita.</p>'),
'		<p>L''impaginazione fornisce all''utente finale le informazioni sul numero di righe visualizzate e sulla posizione corrente all''interno del set di risultati.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759082587307203)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'it'
,p_message_text=>'Scorrimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887468118307308)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'All''inizio viene visualizzato un numero di righe sufficiente a riempire l''altezza della griglia interattiva.',
'        Man mano che l''utente finale scorre la griglia, vengono visualizzate righe aggiuntive e vengono recuperati i dati necessari dal server.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758937216307203)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887356067307307)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Verranno visualizzate le prime righe in base al numero specificato in <em>Righe per pagina</em>.',
unistr('        Se esistono ulteriori righe, verranno aggiunti alcuni controlli nel pi\00E8 di pagina del report, in modo che gli utenti finali possano spostarsi in avanti e a ritroso tra i row set.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758779322307203)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428939584307731)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222395884307573)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un alias per questo report salvato. Usare l''alias immesso per definire un collegamento URL pi\00F9 significativo a questo report salvato specifico. Il collegamento pu\00F2 essere usato per collegarsi direttamente da un altro punto dell''applicazione')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221319263307572)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222450026307573)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Visualizza la categoria del report salvato, che determina il punto di visualizzazione del report all''interno della lista di selezione Report. Questo attributo \00E8 di sola visualizzazione e non pu\00F2 essere aggiornato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221592998307572)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'it'
,p_message_text=>'Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222068816307572)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'it'
,p_message_text=>'Layout di report successivi salvati dagli sviluppatori, che gli utenti finali possono selezionare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221464061307572)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'it'
,p_message_text=>'Chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221919120307572)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'it'
,p_message_text=>'Report salvato dagli sviluppatori, visualizzato per impostazione predefinita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221768116307572)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'it'
,p_message_text=>'Privato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222258126307573)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Layout di report salvati da utenti finali, che possono essere selezionati solo dall''utente finale che li ha salvati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221616535307572)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'it'
,p_message_text=>'Pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222136780307573)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Layout di report salvati da utenti finali, che tutti gli altri utenti finali possono selezionare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103221215953307572)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Visibilit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763793827307208)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare dove viene usato il gruppo per visualizzare questa colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763806625307208)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'it'
,p_message_text=>'Entrambe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763990299307208)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il gruppo verr\00E0 visualizzato sia nell''intestazione del report che nella vista a riga singola.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764273972307208)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'it'
,p_message_text=>'Intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764399810307208)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il gruppo verr\00E0 visualizzato solo nell''intestazione del report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764049231307208)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'it'
,p_message_text=>'Vista a riga singola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102764118445307208)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il gruppo verr\00E0 visualizzato solo nella vista a riga singola.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763621649307208)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Usa gruppo per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627383517307084)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere gli attributi di tag di immagine inclusi nell''HTML dell''immagine. Utilizzabile per gli attributi di altezza, larghezza o testo alternativo dell''immagine (se questa non \00E8 decorativa).</p>'),
'<p>Nota: se non si definisce un testo alternativo negli attributi di tag di immagine, per impostazione predefinita &PRODUCT_NAME. presenta un''immagine decorativa, ovvero con una tag ALT vuota.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627267526307084)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi tag immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896009335307314)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se questa colonna deve essere inclusa quando il report viene esportato in un file CSV o stampato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102895959161307314)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Includi in esportazione/stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407940324307715)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se la lista di valori include un''opzione NULL all''inizio della lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103407820215307715)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Includi opzione NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748497891307194)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se la pseudo colonna ROWID deve essere selezionata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748360164307193)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Includi colonna ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865872128307292)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una barra di ricerca viene visualizzata al di sopra del report. Se la si include, sar\00E0 inoltre possibile personalizzare completamente le funzioni da visualizzare.</p>'),
unistr('La barra di ricerca pu\00F2 contenere i componenti riportati di seguito.'),
'<dl>',
'  <dt>Campo di ricerca</dt>',
'    <dd>Visualizza un campo di testo nella barra di ricerca, utilizzato per l''immissione dei criteri di ricerca.</dd>',
'  <dt>Elenco a discesa strumento di ricerca</dt>',
'    <dd>Incorporato nel <em>campo di ricerca</em>, visualizza un elenco a discesa delle colonne visualizzate. Quando si seleziona una colonna, la ricerca viene eseguita solo nei valori della colonna selezionata.</dd>',
'  <dt>Lista di selezione report</dt>',
unistr('    <dd>Visualizza la lista dei report disponibili per l''utente, con i report primari, alternativi, pubblici e privati. Questa lista viene visualizzata solo se l''utente pu\00F2 accedere a un report che non sia il report primario.</dd>'),
'  <dt>Selettore righe per pagina</dt>',
'    <dd>Visualizza una lista di selezione utilizzata per selezionare il numero di righe da visualizzare per ogni singola pagina.</dd>',
'  <dt>Menu Azioni</dt>',
'    <dd>Visualizza il pulsante del menu Azioni, che in genere include un set di opzioni completo. Queste opzioni consentono all''utente finale di personalizzare il report in base alle funzioni rese disponibili.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865734865307292)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Includi barra ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536600874306992)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&PRODUCT_NAME. richiede di solito file JavaScript e CSS specifici.',
'Per alcune applicazioni, quali ad esempio le applicazioni Mobile, si consiglia di impedire l''inclusione di questi file nella pagina.</p>',
'<p>Per includere i file &PRODUCT_NAME. e JavaScript standard, selezionare <strong>Attivo</strong>. Se si seleziona <strong>Non attivo</strong> si impedisce l''inclusione di questi file nell''intestazione HTML.</p>',
unistr('<p>Il risultato della non inclusione di questi file pu\00F2 essere negativo per certe applicazioni, che potrebbero essere interrotte.'),
unistr('La disabilitazione di questo attributo \00E8 consigliata solo per gli sviluppatori esperti.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536507904306992)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Includi JavaScript e CSS standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158378863307515)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che contiene la posizione iniziale della mappa come oggetto punto GeoJSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158205790307515)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158108027307515)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna SDO_GEOMETRY contenente la posizione iniziale della mappa come oggetto punto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158080775307515)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157305777307514)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Identifica il tipo di colonna da utilizzare per la posizione iniziale della mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157674002307514)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'it'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157755802307514)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'it'
,p_message_text=>'Geojson, come tipi di colonna VARCHAR2 o CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157836972307514)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'it'
,p_message_text=>'Longitudine/latitudine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157919743307514)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>'Longitudine e latitudine, come due colonne NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157474298307514)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'it'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157568448307514)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'it'
,p_message_text=>'Tipo Oracle SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157270570307514)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di dati della colonna geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156206860307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Indica se centrare la mappa rispetto alla posizione corrente dal browser. Se abilitata e il browser pu\00F2 accedere alla posizione corrente, questa ha la precedenza rispetto alla posizione iniziale determinata dai valori statici, dalla query SQL o ba')
||'sata sui risultati spaziali, secondo la configurazione riportata in precedenza.</p><p>Si applica esclusivamente al primo caricamento della pagina all''interno di una sessione APEX. Quando la pagina della mappa viene visitata di nuovo nella sessione AP'
||unistr('EX, la mappa verr\00E0 centrata in base all''ultima posizione.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156124697307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Recupera posizione dal browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158799372307515)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che contiene la latitudine della posizione iniziale della mappa. Il valore restituito deve essere compreso tra -90 e 90.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158630947307515)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna latitudine iniziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156992708307514)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la latitudine della posizione iniziale della mappa. Utilizzare valori compresi tra -90 (sud) e 90 (nord) e "." come carattere decimale, ad esempio <strong>45.5</strong>.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156859389307514)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Latitudine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158553844307515)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che contiene la longitudine della posizione iniziale della mappa. Il valore restituito deve essere compreso tra -180 e 180.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158402844307515)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna longitudine iniziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156781937307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la longitudine della posizione iniziale della mappa. Utilizzare valori compresi tra -180 (ovest) e 180 (est) e "." come carattere decimale, ad esempio: <strong>100.5</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156673464307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Longitudine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156597539307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Query che restituisce le colonne NUMBER per determinare la posizione iniziale della mappa e il livello di zoom:</p>',
'<pre>',
'select -133.5 longituide,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
'<p>Query che restituisce una colonna SDO_GEOMETRY per determinare la posizione iniziale della mappa e una colonna NUMBER per il livello di zoom.</p>',
'<pre>',
'select sdo_geometry( 2001,                                 -- 2 dimensional point',
'                     4326,                                 -- longitude/latitude (WGS84)',
'                     sdo_point_type( -133.5, 35.2, null ), -- concrete coordinates',
'                     null,                                 -- not used for points',
'                     null                                  -- not used for points',
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156474050307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la query SQL per determinare la posizione iniziale della mappa e il livello di zoom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156389349307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155486672307512)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specifica come determinare la posizione iniziale della mappa e il livello di zoom, per una nuova sessione APEX o dopo un''operazione <strong>Cancella</strong> o <strong>Reimposta</strong> di un''area della mappa. L''area mappa all''interno di una session'
||'e APEX memorizza la posizione e il livello di zoom correnti in tutte le richieste di pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155983659307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'it'
,p_message_text=>'In base ai risultati spaziali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103156013539307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La mappa verr\00E0 posizionata in modo che i risultati della query sul layer siano visibili. <em>Tenere presente che questa operazione non \00E8 supportata se si sceglie GeoJSON come tipo di colonna geometria del layer</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155701643307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155810344307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Fornire una query SQL che restituisce i valori per la posizione iniziale della mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155553635307512)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155685550307513)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Fornire i valori statici per la posizione iniziale della mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155365168307512)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158914293307515)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che contiene il livello di zoom iniziale. Il valore restituito deve essere compreso tra 1 e 18.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103158885422307515)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna livello di zoom iniziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157100897307514)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il livello di zoom iniziale. Utilizzare valori interi compresi tra 1 e 18.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103157081183307514)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Livello di zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044898461307429)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Imposta lo stile grassetto per la classe CSS <code>display_only</code>.</dt>',
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531505670306988)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice CSS (Cascading Style Sheet) da usare in questa pagina.',
unistr('Se lo stesso codice \00E8 richiesto in pi\00F9 pagine, si consiglia di inserirlo in un file esterno per evitare la duplicazione e per sfruttare l''inserimento dei file statici nella cache del browser.</p>'),
'<p>Il codice immesso qui sostituisce la stringa di sostituzione <code>#PAGE_CSS#</code> nel modello della pagina.</p>',
unistr('<p>Nota: non \00E8 necessario includere le tag <code>style</code> di apertura o di chiusura. Includere solo il codice CSS (Cascading Style Sheet).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531493320306988)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'In linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539834017306995)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il messaggio di errore visualizzato quando si verifica un errore in questa pagina. Il messaggio di errore sostituir\00E0 la stringa <code>#NOTIFICATION_MESSAGE#</code> nel modello di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102539749828306995)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo di notifica di errore incorporato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357828934307674)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo della Guida in linea per questo elemento. Questo testo viene visualizzato immediatamente con l''elemento e pu\00F2 essere utilizzato per fornire le informazioni della Guida contestuale a livello di campo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357799238307674)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo Guida in linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623318440307081)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la posizione a cui &PRODUCT_NAME. esegue il reindirizzamento se la sessione non \00E8 valida.'),
unistr('Ci\00F2 si verifica quando la <strong>funzione sentry</strong> o la <strong>funzione di verifica</strong> restituisce FALSE nelle richieste di pagina normali, ma non nelle richieste Ajax.</p>'),
unistr('<p>Nota: se si utilizza il tipo di schema di autenticazione <strong>''Personalizzato''</strong>, pu\00F2 essere utilizzato anche l''attributo <strong>Funzione sentry</strong> nello schema di autenticazione.'),
unistr('Per i tipi di schema di autenticazione plugin, ci\00F2 viene definito dallo sviluppatore del plugin nel callback <strong>''Nome funzione sentry di sessione''</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057818623307439)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'it'
,p_message_text=>'Pagina di login incorporata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057988828307439)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza all''URL definito in <code>wwv_flow_custom_auth_std.login_page</code>, fornito da &PRODUCT_NAME..'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057647988307439)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'it'
,p_message_text=>'Pagina di login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057707343307439)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza all''URL di login definito negli attributi dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058095519307439)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'it'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058141216307439)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza all''URL immesso dall''utente, ad esempio <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623231990307081)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Reindirizzamento sessione non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623506203307081)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''URL a cui &PRODUCT_NAME. effettua il reindirizzamento se la funzione sentry di sessione restituisce FALSE. In genere questo \00E8 l''URL di una pagina di login o di un portale Single Sign-On. Ad esempio, f?p=&amp;APP_ID.:101:&amp;SESSION')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623457426307081)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL sessione non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864564316307291)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il tipo di visualizzazione delle colonne pertinente per definire le modalit\00E0 di visualizzazione dei valori delle colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064548505307444)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'it'
,p_message_text=>'Scarica BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248822883307592)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come collegamento per scaricare il file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064873905307444)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna nascosta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249167160307593)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Non visualizza la colonna ma \00E8 possibile farvi riferimento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064428140307444)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'it'
,p_message_text=>'Visualizza immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248733714307592)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064363685307444)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'it'
,p_message_text=>'Collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248620585307592)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come collegamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064673028307444)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'it'
,p_message_text=>'Grafico di percentuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248948379307592)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come grafico di percentuale. Il valore recuperato deve essere compreso tra 0 e 100.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064192087307444)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'it'
,p_message_text=>'Testo non codificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248450066307592)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il valore della colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064256021307444)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'it'
,p_message_text=>'Testo non codificato (basato su lista di valori)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248548895307592)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il valore restituito dalla lista di valori specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320958975307648)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321031272307648)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna utilizzando HTML o Markdown.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064751583307444)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'it'
,p_message_text=>'Rimuovi HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249012882307593)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il valore della colonna dopo la rimozione delle tag HTML e dopo la definizione della sequenza di escape per i caratteri speciali.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864468190307291)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948789944307356)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Per la restituzione del nome del reparto:</dt>',
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882840158307304)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere una query SQL che deve restituire una sola colonna. Se la query restituisce pi\00F9 colonne, solo la prima viene utilizzata nella lista di valori.</p>'),
unistr('<p>L''immissione di una query SQL pu\00F2 migliorare le prestazioni in alcuni report oppure pu\00F2 essere utilizzata per limitare i valori visualizzati.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882786956307304)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002208576307396)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare una lista di valori denominata definita. Il filtro colonna utilizza solo la prima colonna della query sulla lista di valori dinamica oppure il valore visualizzato della lista di valori statica per filtrare i dati del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002179662307396)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'it'
,p_message_text=>'LOV denominata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863344423307290)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare le modalit\00E0 di derivazione di filtri forniti nell''elenco a discesa delle colonne del report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066346664307446)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori denominata per filtrare le corrispondenze esatte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066488016307446)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva la lista di valori da una lista di valori denominata per creare un filtro di uguaglianza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066541583307446)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori denominata per filtrare le parole contenute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066602794307446)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva la lista di valori da una lista di valori denominata per creare un filtro di parole contenute.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066133735307445)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori definita per filtrare le parole contenute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066230318307445)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva la lista di valori da una query SQL su una lista di valori definita per creare un filtro di parole contenute.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065759176307445)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita in base al tipo di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065871404307445)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'it'
,p_message_text=>'Le colonne STRING e NUMBER derivano la lista di valori da valori di colonna distinti. Le colonne DATE derivano la lista di valori da intervalli di data predefiniti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065553213307445)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065602579307445)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>'Nessun filtro colonna fornito per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103065902851307445)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori definita per filtrare le corrispondenze esatte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066067393307445)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva la lista di valori da una query SQL su una lista di valori definita per creare un filtro di uguaglianza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863247720307290)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864316630307291)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il gruppo per la colonna. I gruppi vengono usati per visualizzare le colonne in gruppi logici nella vista a riga singola.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864274020307290)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868229198307293)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il tipo di colonna di collegamento per il report.',
unistr('La colonna di collegamento selezionata viene sempre visualizzata come prima colonna del report e non pu\00F2 essere nascosta dall''utente.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068585320307447)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'it'
,p_message_text=>'Collega a destinazione personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068677288307447)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale viene indirizzato a un''altra pagina in base all''URL di destinazione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068769265307447)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Escludi colonna di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068877433307447)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>'La colonna di collegamento non viene visualizzata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068344380307447)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Collega a vista a riga singola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068433253307447)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale viene indirizzato a una pagina che mostra i valori di colonna per la riga specificata. Il contenuto visualizzato nelle colonne e le modalit\00E0 di visualizzazione delle colonne dipendono da vari attributi di report e di colonna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868177161307293)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914882829307331)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866062121307292)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il tipo di impaginazione per il report. Spesso viene visualizzato solo un certo numero di righe del report in una pagina.',
'Per includere righe aggiuntive, l''utente finale dell''applicazione deve andare alla pagina successiva del report.<p />',
'<p>L''impaginazione fornisce all''utente finale le informazioni relative al numero di righe e alla posizione corrente all''interno del set di risultati.<p />',
unistr('<p>L''impaginazione pu\00F2 essere visualizzata al di sopra o al di sotto del report oppure in entrambe le posizioni e pu\00F2 essere inserita a sinistra o a destra.<p />')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067339541307446)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe da X a Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067291265307446)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'it'
,p_message_text=>'Intervalli di righe da X a Y di Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102865988457307292)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880505883307302)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un alias per questo report salvato. Usare l''alias immesso per definire un collegamento URL pi\00F9 significativo a questo report salvato specifico. Il collegamento pu\00F2 essere usato per collegarsi direttamente da un altro punto dell''applicazione')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880491794307302)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880977631307303)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Visualizza la categoria del report salvato, che determina il punto di visualizzazione del report all''interno della lista di selezione Report. Questo attributo \00E8 di sola visualizzazione e non pu\00F2 essere aggiornato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070998426307449)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'it'
,p_message_text=>'Predefinito alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249339771307593)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>'Layout di report successivi salvati dagli sviluppatori, che gli utenti finali possono selezionare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103070813801307449)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'it'
,p_message_text=>'Predefinito primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249248532307593)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>'Report salvato dagli sviluppatori, visualizzato per impostazione predefinita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071178578307449)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'it'
,p_message_text=>'Privato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249519143307593)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Layout di report salvati da utenti finali, che possono essere selezionati solo dall''utente finale che li ha salvati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071062220307449)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'it'
,p_message_text=>'Pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103249465924307593)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Layout di report salvati da utenti finali, che tutti gli altri utenti finali possono selezionare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880883717307303)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Visibilit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714840262307162)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono modificare questa area di form.</p>',
'        <p>Nota: quando l''area di form viene resa modificabile, viene creato in modo automatico un processo per elaborare la riga.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755731219307200)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono modificare questa griglia interattiva.</p>',
'        <p>Nota: quando la griglia interattiva viene resa modificabile, viene creato in modo automatico un processo per elaborare le righe.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755678492307200)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353691986307671)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagina globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769448719307213)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la colonna \00E8 uno dei valori di chiave primaria per la tabella o le tabelle di base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769320605307213)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769277039307213)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se escludere la colonna dalle operazioni DML.</p>',
unistr('        <p>Se l''impostazione \00E8 <strong>Attivo</strong>, &PRODUCT_NAME. non utilizzer\00E0 la colonna durante l''esecuzione di Griglia interattiva - Elaborazione automatica delle righe (DML).'),
unistr('        Ad esempio, \00E8 opportuno escludere le colonne le cui definizioni includono concatenazioni, istruzioni SELECT interne, chiamate di funzione o una colonna in una vista aggiornabile basata su un''espressione.</p>'),
'        <p>Questa opzione deve essere impostata su <strong>Non attivo</strong> per tutte le colonne che devono essere incluse nelle istruzioni INSERT o UPDATE.</p>',
'        <p>Nota: a meno che questa opzione non venga impostata su <strong>Attivo</strong>, vengono incluse nell''Elaborazione automatica delle righe <u>anche</u> le colonne di tipo <em>Sola visualizzazione</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102769135085307213)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Solo query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850249831307280)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se il parametro pu\00F2 essere impostato solo una volta con un valore statico oppure essere sostituito a livello di componente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850139568307280)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201994539307558)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se questa colonna deve essere visualizzata o nascosta. \00C8 possibile fare riferimento alle colonne, anche se nascoste, utilizzando la sintassi di sostituzione <code>&amp;COLUMN_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201889778307558)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742381085307188)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome della colonna da utilizzare per la definizione del valore massimo in questo grafico. Se non si seleziona alcuna colonna, per determinare il valore massimo del grafico verr\00E0 utilizzato il data set.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742174482307188)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742232335307188)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome della colonna da utilizzare per la definizione del valore minimo in questo grafico. Se non si seleziona alcuna colonna, per determinare il valore minimo del grafico verr\00E0 utilizzato il data set. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742072048307187)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817237322307255)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore di chiusura in questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817123724307255)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816852252307255)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore massimo in questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816700852307255)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818863829307256)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione dell''etichetta o delle etichette dell''asse x nel grafico. Per un grafico borsistico, la colonna deve essere del tipo di dati Data/Indicatore orario per rappresentare le informazioni sul tit'
||'olo di borsa sull''asse del tempo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818705480307256)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648029387307100)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824280077307261)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere la stringa di stile CSS che definisce lo stile delle etichette in questo grafico.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824107025307261)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848419375307279)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Per le serie con intervallo, se viene fornito un array di due valori, il primo e il secondo valore verranno applicati rispettivamente al punto minimo e al punto massimo. Il valore <strong>Porzione esterna</strong> si applica solo ai grafici a tort'
||'a.',
'        I valori <strong>Al di sopra dell''indicatore</strong>, <strong>Sotto l''indicatore</strong>, <strong>Prima dell''indicatore</strong> e <strong>Dopo l''indicatore</strong> si applicano solo alle serie a linee, ad aree, a dispersione e a bolle. I '
||'valori <strong>Asse barra interna</strong> e <strong>Asse barra esterna</strong>',
unistr('        si applicano solo alla serie dei grafici a barre non polari. Le barre in pila non supportano <strong>Asse barra esterna</strong>. Il valore <strong>Inizio</strong> \00E8 applicabile solo ai grafici Misuratore misuratore stato orizzontali e vertic')
||unistr('ali. Attualmente il grafico non regola il layout per adattare le etichette all''interno dell''area di rappresentazione n\00E9 gestisce le sovrapposizioni tra le etichette.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823257994307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione delle etichette da visualizzare nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823446513307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'it'
,p_message_text=>'Al di sopra dell''indicatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823763978307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'it'
,p_message_text=>'Dopo l''indicatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824000831307261)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823662603307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'it'
,p_message_text=>'Prima dell''indicatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823519814307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'it'
,p_message_text=>'Sotto l''indicatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823340053307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823841144307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'it'
,p_message_text=>'Asse barra interna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847853659307278)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823914452307261)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'it'
,p_message_text=>'Asse barra esterna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847744928307278)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'it'
,p_message_text=>'Porzione esterna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283658043306785)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823128670307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102823050051307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se le etichette devono essere visualizzate nel grafico. Questa impostazione si applica alla visibilit\00E0 del valore di metrica in un grafico a quadrante. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822922568307260)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816679670307255)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore minimo in questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816534845307255)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818219771307256)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore massimo in questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818127382307256)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920116418307335)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore minimo in questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920008623307335)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817092311307255)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore di apertura in questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816990111307255)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Apri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819038931307257)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome della colonna da utilizzare per definire una breve descrizione comandi personalizzata e descrittiva sui data point del grafico. Per visualizzare una descrizione comandi sui datapoint del grafico, verificare che l''attributo <strong'
||'>Mostra</strong> della descrizione comandi del grafico sia impostato su <strong>Attivo</strong>. Nel caso di un grafico box plot, la colonna non deve corrispondere al mapping colonne Valore selezionato. La selezione di una colonna corrispondente al m'
||unistr('apping colonne Valore determiner\00E0 la mancata visualizzazione della descrizione comandi personalizzata sul grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818933737307257)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Descrizione comandi personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102818037600307256)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome colonna da utilizzare per la definizione del valore di destinazione in questo grafico. Quando \00E8 impostato, l''attributo valore definisce l''area riempita all''interno della porzione e rappresenta il valore dell''intera porzione. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817978267307256)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore di destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816410697307255)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome colonna da utilizzare per la definizione del valore in questo grafico. Per un grafico box plot, questa colonna verr\00E0 utilizzata per la definizione dei valori minimi, di quartile, intermedi e massimi del data set numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816384676307255)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817450432307255)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore di volume in questo grafico. Quando i valori vengono forniti, il volume viene visualizzato sull''asse y2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817319149307255)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Volume'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817640157307256)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore x in questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817572877307256)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817854350307256)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore y in questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102817754764307256)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815279635307254)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del valore z in questo grafico. Il valore z definisce il raggio delle bolle per un grafico a bolle, la larghezza di un elemento di box plot e la larghezza delle barre per un grafico a barre'
||' o combinato. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815127234307254)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626737033307084)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se i componenti dell''area (aree secondarie, elementi, pulsanti) vengono visualizzati sopra o sotto il contenuto di area principale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058987142307440)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'it'
,p_message_text=>'Al di sopra del contenuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103059023877307440)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'it'
,p_message_text=>'Al di sotto del contenuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626665556307084)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Rendering dei componenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561382918307015)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome di questo elemento. I nomi degli elementi devono essere identificativi Oracle validi. Si consiglia di scegliere nomi che non superino i 30 byte, in modo che possano essere utilizzati come bind variable nelle query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561268523307015)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772672043307216)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la modalit\00E0 di visualizzazione di questa colonna. Sono supportati i tipi di colonna seguenti:</p>'),
'#NATIVE_PLUGINS#',
'<p>A seconda della configurazione dell''applicazione, potrebbero essere disponibili altri plugin per il tipo di colonna.',
'Questi plugin vengono visualizzati con il formato <em>&lt;My Plug-in&gt; [plugin]</em>.',
'I plugin seguenti sono installati nel componenti condivisi dell''applicazione:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560993155307015)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare la modalit\00E0 di rendering di questo elemento. Sono supportati i tipi di elementi seguenti:</p>'),
'#NATIVE_PLUGINS#',
'<p>A seconda della configurazione dell''applicazione, potrebbero essere disponibili altri plugin per il tipo di elemento.',
'Questi plugin vengono visualizzati con il formato <em>&lt;My Plug-in&gt; [plugin]</em>.',
'I plugin seguenti vengono installati nel componenti condivisi dell''applicazione:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560874344307015)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220393352307571)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita per la pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103241456748307587)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Includere l''elemento nel controllo delle modifiche non salvate, se il controllo \00E8 abilitato a livello pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219828216307571)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se l''elemento pagina viene incluso nel controllo delle modifiche non salvate, che avvisa l''utente quando si tenta di passare ad altro contenuto e lasciare la pagina che contiene modifiche non salvate. Per alcuni elementi il controllo non '
||unistr('\00E8 necessario (ad esempio, quando non si basano su una colonna di database, come un elemento di ricerca), pertanto \00E8 possibile impostarli in modo che siano ignorati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219970744307571)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'it'
,p_message_text=>'Ignora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103222728905307573)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'it'
,p_message_text=>'Le modifiche apportate all''elemento vengono ignorate dal controllo delle modifiche non salvate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219782395307571)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Avvisa in presenza di modifiche non salvate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364642694307679)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783110750307226)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere una funzione JavaScript che assuma un oggetto di configurazione per la griglia interattiva, modifichi l''oggetto e quindi lo restituisca. Ci\00F2 rende possibile la personalizzazione avanzata dell''aspetto, delle funzioni e del funzionamento dell')
||'a griglia interattiva e di elementi quali la barra degli strumenti, i menu e le azioni.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364705174307679)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919414682307334)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere una funzione JavaScript che assuma un oggetto di configurazione per la colonna, modifichi l''oggetto e quindi lo restituisca. Ci\00F2 rende possibile la personalizzazione avanzata dell''aspetto, delle funzioni e del funzionamento della colonna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364879996307679)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
'    // Impostare una funzione di callback che viene richiamata quando vengono recuperati i dati e che consente la manipolazione della serie',
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
'    // Impostare le opzioni di inizializzazione del grafico',
'    options.type = "line";',
'    return options;',
'}</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828807759307264)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere il codice JavaScript per personalizzare il grafico.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365457858307680)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763168128307207)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Immettere una funzione JavaScript che assuma un oggetto di configurazione per il componente, modifichi l''oggetto e quindi lo restituisca. Ci\00F2 rende possibile la personalizzazione avanzata dell''aspetto, delle funzioni e del funzionamento del compon')
||'ente.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102763099481307207)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice di inizializzazione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134113465307495)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la posizione degli assi maggiore e minore nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134894989307496)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134729320307496)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'it'
,p_message_text=>'Inizio pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134022289307495)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione assi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137651339307498)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare la scala temporale da utilizzare per gli assi del grafico. La selezione \00E8 obbligatoria per la corretta visualizzazione del grafico Gantt. La scala temporale selezionata verr\00E0 utilizzata per la funzione di zoom se non sar\00E0 stata selezionat')
||'a alcuna opzione Scala di zoom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135714048307497)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'it'
,p_message_text=>'Giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135640732307496)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'it'
,p_message_text=>'Ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135368074307496)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'it'
,p_message_text=>'Minuti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136109794307497)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'it'
,p_message_text=>'Mesi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136336673307497)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'it'
,p_message_text=>'Trimestri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135237384307496)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'it'
,p_message_text=>'Secondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135947434307497)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'it'
,p_message_text=>'Settimane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136540067307497)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'it'
,p_message_text=>'Anni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137597693307498)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Scala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803818545307244)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo del grafico. Il tipo del grafico determina la visualizzazione utilizzata per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803985784307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'it'
,p_message_text=>'Ad aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944650404307353)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici ad aree sono utili per confrontare le tendenze di valori cumulativi nel tempo, ad esempio i dettagli dell''andamento delle vendite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804051960307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'it'
,p_message_text=>'A barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944781865307353)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici a barre sono utili per confrontare i valori di categorie diverse o in periodi di tempo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725590339307172)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'it'
,p_message_text=>'Box plot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725661225307172)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici box plot sono utili per l''analisi della distribuzione dei dati e per la visualizzazione dei valori minimi, di quartile, intermedi e massimi di gruppi di dati numerici. Per indicare i box plot si usa anche l''espressione diagrammi a scatola e'
||' baffi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804133892307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'it'
,p_message_text=>'A bolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944879445307353)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I grafici a bolle definiscono gli elementi dati utilizzando i valori x, y e z. Ci\00F2 li rende utili per la visualizzazione delle relazioni fra 3 dimensioni. La terza dimensione \00E8 rappresentata dalle dimensioni della bolla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804271519307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'it'
,p_message_text=>'Combinato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944993904307353)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I grafici combinati consentono di visualizzare sullo stesso grafico serie di barre, linee e aree. L''uso pi\00F9 comune prevede linee con barre o linee con barre in pila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804346722307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'it'
,p_message_text=>'Misuratore misuratore stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945090265307353)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'it'
,p_message_text=>'I misuratori misuratore stato vengono utilizzati per visualizzare un valore di metrica rispetto ai possibili valori minimo e massimo della metrica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839488307307272)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'it'
,p_message_text=>'Ciambella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945149065307353)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici a ciambella sono grafici a torta con un foro al centro. Sono utili per la visualizzazione delle parti di un insieme.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804498482307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'it'
,p_message_text=>'A imbuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945281931307353)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I grafici a imbuto sono utili per la visualizzazione dei dati dei vari stadi di un processo, ad esempio gli stadi di un processo di vendita. L''area di una porzione dell''imbuto \00E8 proporzionale al valore dello stadio corrispondente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134507687307496)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'it'
,p_message_text=>'Gantt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134613898307496)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici Gantt sono utili per la visualizzazione delle pianificazioni dei progetti con barre che indicano le date di inizio e di fine dei task.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804545692307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'it'
,p_message_text=>'A linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945301256307353)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici a linee sono utili per la visualizzazione delle tendenze in un set di valori nel tempo e per il confronto di tali valori tra serie diverse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804611467307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'it'
,p_message_text=>'A linee con area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945455247307354)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I grafici a linee con area sono uguali ai grafici a linee, ma l''area sottostante ogni linea \00E8 riempita.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804761893307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'it'
,p_message_text=>'A torta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945569385307354)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici a torta sono utili per la visualizzazione delle parti di un insieme.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839165950307272)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'it'
,p_message_text=>'Polare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945623630307354)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici polari dispongono di un asse y radiale e di un asse x tangente. I grafici polari possano essere visualizzati come tipi di serie dei grafici a barre, a linee, ad aree, combinati o a bolle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638148698307092)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'it'
,p_message_text=>'Piramide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638276702307092)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici a piramide sono utili per la visualizzazione delle relazioni gerarchiche, proporzionali e basate sulle fondamenta, dei passi di processo, dei layer organizzativi o delle interconnessioni degli argomenti. L''area di una sezione della piramide'
||unistr(' \00E8 proporzionale al proprio valore per la fase corrispondente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839232847307272)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'it'
,p_message_text=>'A radar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945796951307354)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I grafici a radar sono grafici polari con una forma a griglia poligonale anzich\00E9 un cerchio esterno. Sono supportati per i tipi di serie dei grafici a linee e ad aree.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839307733307272)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'it'
,p_message_text=>'Intervallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945844053307354)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'it'
,p_message_text=>'I grafici con intervallo visualizzano i valori massimo e minimo (alto/basso) per ogni voce mediante barre o aree.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804865836307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'it'
,p_message_text=>'A dispersione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102945981816307354)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I grafici a dispersione definiscono gli elementi dati utilizzando i valori x e y. Ci\00F2 li rende utili per la visualizzazione delle relazioni tra 2 dimensioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102804962750307245)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'it'
,p_message_text=>'Borsistico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946008589307354)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I grafici borsistici sono utili per la visualizzazione delle informazioni di borsa su un asse temporale. Caratteristica esclusiva dei grafici borsistici \00E8 la propriet\00E0 <strong>Visualizzazione azioni</strong> a canne d''organo, che consente di visualiz')
||'zare i valori di apertura, chiusura, massimo e minimo del prezzo di un''azione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102803782325307244)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742533516307188)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare se i divari esistenti nei dati dei grafici a pi\00F9 serie devono essere impostati su un valore zero o su un valore nullo.</p>'),
unistr('        <p>Quando l''impostazione \00E8 <strong>Attivo</strong>, i divari nei dati vengono gestiti come valori zero. Per un grafico a linee, ci\00F2 garantisce che le linee vengano visualizzate come linee continue. Per un grafico a barre in pila con Etichetta')
||unistr(' pila impostata su Attivo, ci\00F2 garantisce che l''etichetta venga visualizzata per ogni pila.</p>'),
unistr('        <p>Quando l''impostazione \00E8 <strong>Non attivo</strong>, i divari nei dati vengono gestiti come valori nulli. Per un grafico a linee, le linee verranno visualizzate come linee spezzate con divari che rappresentano i datapoint nulli.<p>'),
unistr('        <p>Questa impostazione verr\00E0 applicata ai tipi di grafici a pi\00F9 serie che supportano il rendering sotto forma di barre e linee, ovvero i grafici a barre, a linee, a linee con area, combinati, ad aree, polari, a radar e a dispersione. L''impost')
||unistr('azione predefinita \00E8 <strong>Attivo</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742457408307188)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizza divario come zero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806895332307247)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se il cursore dati deve essere abilitato nel grafico.',
unistr('        Il cursore dati \00E8 un''utile alternativa alle descrizioni comandi quando risulta difficile spostarsi sugli elementi dati, soprattutto con i dispositivi tattili.<p/>'),
unistr('        <p>Se l''impostazione \00E8 <strong>Automatico</strong>, il cursore dati verr\00E0 visualizzato solo per i grafici A linee e Ad aree nei dispositivi tattili.<p/>'),
unistr('        <p>Nota: il cursore dati non viene visualizzato quando la descrizione comandi \00E8 nulla e non \00E8 supportato nei grafici polari.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806988157307247)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946419881307354)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica la visualizzazione predefinita del cursore dati configurata in Oracle JET per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807137324307247)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946627354307354)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'it'
,p_message_text=>'Il cursore dati non viene visualizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807016822307247)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946582808307354)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'it'
,p_message_text=>'Il cursore dati viene visualizzato sempre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102806762357307247)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Cursore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807348406307248)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il funzionamento del cursore dati nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807489336307248)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102936904234307347)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica il funzionamento predefinito del cursore dati configurato in Oracle JET per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807523990307248)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'it'
,p_message_text=>'Uniforme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946708006307355)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il cursore dati segue in modo uniforme il movimento del mouse o del tocco e visualizza la descrizione comandi quando si passa il mouse su una parte qualsiasi dell''elemento dati e non soltanto su datapoint specifici. Un indicatore identifica l''elem'
||'ento dati selezionato.</p>',
unistr('        <p>Nota: impostare <strong>Cursore</strong> su <strong>S\00EC</strong> per ottenere il funzionamento ottimale della visualizzazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807690985307248)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'it'
,p_message_text=>'Aggancio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946832036307355)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il cursore dati si aggancia (salta) a un elemento dati quando si verifica un movimento del mouse o del tocco sul grafico e visualizza la descrizione comandi quando si passa il mouse su un elemento dati. Un indicatore identifica l''elemento dati sel'
||'ezionato.</p>',
unistr('        <p>Nota: impostare <strong>Cursore</strong> su <strong>S\00EC</strong> per ottenere il funzionamento ottimale della visualizzazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807258994307248)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Funzionamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657161103307108)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Consente di specificare se i divari esistenti nei dati dei grafici a pi\00F9 serie devono essere riempiti in modo automatico. Questa impostazione non si applica ai grafici con una sola serie, n\00E9 ai tipi di grafici seguenti: A bolle, Ciambella, A imbuto, ')
||unistr('Gantt, A torta, Piramide, A dispersione e Borsistico. Quando l''impostazione \00E8 <strong>Attivo</strong>, la logica di densificazione dei dati introdotta in Oracle Application Express 5.1.3 viene applicata ai dati del grafico. Quando l''impostazione \00E8 <s')
||unistr('trong>Non attivo</strong>, i divari nei dati non vengono riempiti e il rendering del grafico potrebbe risultare errato. L''impostazione predefinita \00E8 <strong>Attivo</strong>.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657080011307108)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Riempi divari nei dati del grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371064145307684)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Immettere le classi CSS da applicare alle barre di baseline nel grafico Gantt. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi. \00C8 inoltre possibile utilizzare le sostituzioni <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370997742307684)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS baseline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141275468307501)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome colonna da utilizzare per la definizione della data di fine della baseline nel grafico Gantt. La data di fine della baseline \00E8 la data di fine pianificata originale del task.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141116705307501)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Data fine baseline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141077268307500)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome colonna da utilizzare per la definizione della data di inizio della baseline nel grafico Gantt. La data di inizio della baseline \00E8 la data di inizio pianificata originale del task.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140955442307500)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Data inizio baseline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139416944307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione della data di fine nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139307533307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139627811307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''elemento di pagina o di applicazione da utilizzare per la definizione della data di fine del grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139555265307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento di data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138695079307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''origine da utilizzare per la definizione della data di fine del grafico Gantt. La data di fine \00E8 obbligatoria per la corretta visualizzazione del grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138851797307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138982815307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore colonna immesso in <em>Colonna data di fine</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139156253307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139285687307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento di data di fine</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138779324307499)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di origine data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141473003307501)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome colonna da utilizzare per la definizione dello stato di avanzamento dei task nel grafico Gantt. Il valore dello stato di avanzamento deve essere compreso tra 0 e 1. Se il valore non \00E8 valido, lo stato di avanzamento non verr\00E0 most')
||'rato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141382754307501)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stato di avanzamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370855660307684)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Immettere le classi CSS da applicare alle barre di avanzamento nel grafico Gantt. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi. \00C8 inoltre possibile utilizzare le sostituzioni <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370772053307684)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS avanzamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139879648307500)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome colonna da utilizzare per la definizione dell''ID riga sul grafico Gantt. L''ID riga \00E8 obbligatorio se si desidera visualizzare pi\00F9 task per riga. Se non viene definito alcun mapping colonna ID riga, ogni task verr\00E0 visualizzato com')
||'e un singolo task per riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139726215307500)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'it'
,p_message_text=>'RowID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140007192307500)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione del nome della riga nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139982333307500)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138595100307499)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione della data di inizio nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138423285307499)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148084781307506)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''elemento di pagina o di applicazione da utilizzare per la definizione della data di inizio del grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103139090001307499)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135097201307496)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''origine da utilizzare per la definizione della data di inizio del grafico Gantt. La data di inizio \00E8 obbligatoria per la corretta visualizzazione del grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137839902307498)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137936057307498)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore colonna immesso in <em>Colonna data di inizio</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138051889307498)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103138186449307498)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento di data di inizio</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134976745307496)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di origine data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370672783307684)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Immettere le classi CSS da applicare alle barre dei task nel grafico Gantt. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi. \00C8 inoltre possibile utilizzare le sostituzioni <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370520446307684)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS task'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140818952307500)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione della data di fine del task nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140797218307500)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Data di fine task'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140260039307500)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione dell''identificativo del task nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140154534307500)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'it'
,p_message_text=>'ID task'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140453242307500)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome colonna da utilizzare per la definizione del nome task nel grafico Gantt. Se non viene definito alcun mapping colonna nome riga, il nome task verr\00E0 utilizzato come etichetta riga sull''asse righe del grafico. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140325972307500)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome task'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140623779307500)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione della data di inizio del task nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103140546708307500)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Data di inizio task'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351200025307670)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione della data di fine del viewport nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346213557307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351337156307670)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''elemento di pagina o di applicazione da utilizzare per la definizione della data di fine del viewport del grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346062455307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento di data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350911246307669)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''origine da utilizzare per la definizione della data di fine del viewport del grafico Gantt. Per viewport si intende un intervallo di date che, se definito, pu\00F2 controllare lo zoom iniziale di un grafico visualizzato. Lo zoom del grafico')
||unistr(' verr\00E0 eseguito nell''intervallo di date specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346432863307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351005087307669)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore colonna immesso in <em>Colonna data di fine</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346607610307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103351169427307669)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento di data di fine</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345994277307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di origine data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350710748307669)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome colonna da utilizzare per la definizione della data di inizio del viewport nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346174847307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350842384307669)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''elemento di pagina o di applicazione da utilizzare per la definizione della data di inizio del viewport del grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345811290307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350410810307669)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''origine da utilizzare per la definizione della data di inizio del viewport del grafico Gantt. Per viewport si intende un intervallo di date che, se definito, pu\00F2 controllare lo zoom iniziale di un grafico visualizzato. Lo zoom del grafi')
||unistr('co verr\00E0 eseguito nell''intervallo di date specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346319500307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350543447307669)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore colonna immesso in <em>Colonna data di inizio</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103346579954307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350612818307669)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento di data di inizio</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345748469307666)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di origine data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250030907306760)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''estensione dell''angolo per il grafico Misuratore misuratore stato con orientamento circolare, in gradi. L''estensione dell''angolo \00E8 un angolo effettivo dell''orientamento circolare. I valori positivi definiscono un angolo iniziale in senso ')
||unistr('orario, mentre quelli negativi definiscono un angolo iniziale in senso antiorario. \00C8 possibile tracciare un misuratore circolare con qualsiasi angolo e modificarne la forma in base all''angolo scelto. La forma del misuratore dipende da due impostazion')
||'i: <strong>Angolo iniziale</strong> ed <strong>Estensione angolo</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249883915306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Estensione angolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249417050306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare il rapporto tra lo spessore relativo dell''indicatore e l''area di rappresentazione. Il valore predefinito \00E8 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249301878306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensioni indicatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249551459306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare il raggio interno di un grafico Misuratore misuratore stato con orientamento circolare, definito dalla distanza dal centro del misuratore al bordo pi\00F9 interno dell''indicatore e dell''area di rappresentazione. I valori validi sono una perce')
||'ntuale o un rapporto tra 0 e 1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249628948306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Raggio interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249014661306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di grafico Misuratore misuratore stato da visualizzare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248799383306758)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'it'
,p_message_text=>'Circolare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248891748306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'it'
,p_message_text=>'Orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248936173306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'it'
,p_message_text=>'Verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248629966306758)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Orientamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249256922306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se l''area di rappresentazione di un grafico Misuratore misuratore stato deve essere visualizzata.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249199949306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra area di rappresentazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363412331306849)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259658343306767)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore da visualizzare nell''area di rappresentazione di un grafico Misuratore misuratore stato. \00C8 possibile utilizzare le sostituzioni <code>&COLUMN_VALUE.</code>. Questo colore \00E8 valido solo quando i colori di soglia non sono stati d')
||'efiniti per il grafico.</p>',
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259512972306767)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore area di rappresentazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249944029306760)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''angolo iniziale per il grafico Misuratore misuratore stato con orientamento circolare, in gradi. I valori positivi definiscono un angolo iniziale in senso orario, mentre quelli negativi definiscono un angolo iniziale in senso antiorario. '
||unistr('\00C8 possibile tracciare un misuratore circolare con qualsiasi angolo e modificarne la forma in base all''angolo scelto. La forma del misuratore dipende da due impostazioni: <strong>Angolo iniziale</strong> ed <strong>Estensione</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102249709867306759)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Angolo iniziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134403765307496)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare le linee orizzontali della griglia nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133797727307495)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra griglia orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807891942307248)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare il funzionamento da attivare quando si passa il mouse sugli elementi dati del grafico.<p/>',
unistr('        Selezionare <strong>S\00EC</strong> per attenuare tutti gli elementi dati su cui non si passa il mouse ed evidenziare solo quelli su cui \00E8 stato passato il mouse.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807736971307248)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attenua al passaggio del mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395582834307703)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare lo zoom iniziale del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395600076307703)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'it'
,p_message_text=>'Primo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395754407307703)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'it'
,p_message_text=>'Zoom iniziale sui primi datapoint che possono essere adattati nell''area di rappresentazione del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395834714307703)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'it'
,p_message_text=>'Ultimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395952718307703)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'it'
,p_message_text=>'Zoom iniziale sugli ultimi datapoint che possono essere adattati nell''area di rappresentazione del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396008320307703)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396195100307703)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>'Consente di disabilitare lo zoom iniziale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395492313307702)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Zoom iniziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781099139307224)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523701248306981)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per visualizzare il carattere per l''attributo specificato.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520760209306973)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522350550306979)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la famiglia di caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520923070306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'it'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520806306306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'it'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521081535306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'it'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521135381306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'it'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521305133306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'it'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521262229306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521437543306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'it'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521591566306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'it'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521687915306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521770721306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'it'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521886409306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'it'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522079488306979)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'it'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102521937820306974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522165490306979)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'it'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522279531306979)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'it'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520425493306973)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Famiglia di caratteri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522878895306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la dimensione del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523074939306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'it'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523139596306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'it'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523252781306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'it'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523393222306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'it'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523402018306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'it'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523578933306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'it'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523620395306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'it'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522907776306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'it'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520693119306973)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522473589306979)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare lo stile del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522685776306979)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'it'
,p_message_text=>'Corsivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522543205306979)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102522750712306980)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'it'
,p_message_text=>'Obliquo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520590120306973)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331490290306821)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare le modalit\00E0 di visualizzazione delle etichette sulle porzioni del grafico a torta. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375028974307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'it'
,p_message_text=>'Etichetta - Percentuale ( valore )'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375515917307688)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Nelle etichette verranno visualizzati i dati Etichetta, Valore e Percentuale con il formato seguente: Etichetta - Percentuale ( valore ). Ad esempio, <strong>Bug - 15% ( 18 )</strong>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375173482307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'it'
,p_message_text=>'Percentuale ( valore )'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375677154307688)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Le etichette verranno visualizzate sotto forma di valori numerici in base al mapping delle colonne valori selezionato. Ad esempio, <strong>15% ( 18 )</strong>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374744445307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375238294307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Le etichette verranno visualizzate sulle porzioni del grafico in base al mapping delle colonne Etichetta selezionato. Ad esempio, <strong>Bug</strong>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719347847307166)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'it'
,p_message_text=>'Etichetta - Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719404514307166)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Nelle etichette verranno visualizzate le informazioni di etichetta e valore con il formato seguente: Etichetta - Valore. Ad esempio, <strong>Bug - 18</strong>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374808784307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'it'
,p_message_text=>'Percentuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375397854307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Le etichette verranno visualizzate sotto forma di valori compresi tra lo 0 e il 100% in base al mapping delle colonne valori selezionato. Il valore \00E8 una percentuale dei valori totali rappresentati nel grafico. Ad esempio, <strong>15%</strong>.</p')
||'>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374904280307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103375405880307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Le etichette verranno visualizzate sotto forma di valori numerici in base al mapping delle colonne valori selezionato.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374635967307687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizza come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780955264307224)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517713668306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per visualizzare il carattere per l''attributo specificato.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517306570306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517436319306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la famiglia di caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517958255306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'it'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517834239306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'it'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518022281306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'it'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518146686306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'it'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518358991306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'it'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518216577306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518401682306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'it'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518552056306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'it'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518698203306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518725054306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'it'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518878443306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'it'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519061549306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'it'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102518923454306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519102338306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'it'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519236880306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'it'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517024683306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Famiglia di caratteri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517691569306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la dimensione del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519707235306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'it'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519875687306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'it'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519934094306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'it'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520088341306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'it'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520154076306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'it'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520253544306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'it'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102520313820306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'it'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519641814306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'it'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517287678306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517544266306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare lo stile del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519411968306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'it'
,p_message_text=>'Corsivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519374335306972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102519534666306973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'it'
,p_message_text=>'Obliquo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102517140877306971)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367262923306852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Lista di colori separata da virgole:</dt>',
'<dd><pre>',
'<strong>rosso,giallo,blu</strong>',
'</pre></dd>',
'<dt>Lista di elementi di pagina o di applicazione sperata da virgole, che restituisce colori. Uso:</dt>',
'<dd><pre>',
'Sintassi: <code>&amp;ITEM.</code>. Ad esempio: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>Lista di colonne separata da virgole, che restituisce colori. Uso:</dt>',
'<dd><pre>',
'Sintassi: <code>&amp;COLUMN_NAME.</code>. Ad esempio: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367145199306852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il colore o colori da utilizzare per identificare la riga o le righe di riferimento da visualizzare in un grafico Misuratore misuratore stato.',
unistr('Per pi\00F9 righe di riferimento, utilizzare una lista separata da virgole.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366888915306852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367034545306852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Lista di valori numerici statici separata da virgole:</dt>',
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
'<dt>Lista di elementi di pagina o di applicazione sperata da virgole, che restituisce valori numerici. Uso:</dt>',
'<dd><pre>',
'Sintassi: <code>&amp;ITEM.</code>. Ad esempio: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>Lista di colonne separata da virgole, che restituisce valori numerici. Uso:</dt>',
'<dd><pre>',
'Sintassi: <code>&amp;COLUMN_NAME.</code>. Ad esempio: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366981899306852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il numero o i numeri da utilizzare per identificare la riga o le righe di riferimento da visualizzare in un grafico Misuratore misuratore stato.',
unistr('Per pi\00F9 righe di riferimento, utilizzare una lista separata da virgole.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366776824306852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134257138307495)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare le etichette delle righe nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133985480307495)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra asse righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819338885307257)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819298436307257)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore da visualizzare per gli elementi dati associati a questa serie di grafici. \00C8 possibile utilizzare le sostituzioni <code>&COLUMN_VALUE.</code>. Per un grafico Misuratore misuratore stato, questo colore verr\00E0 applicato all''indica')
||unistr('tore tranne quando sono definite le soglie e l''attributo <strong>Visualizzazione soglia</strong> \00E8 impostato su <strong>Su indicatore</strong>.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819178333307257)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745198252307190)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744930588307190)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore da visualizzare per il segmento q2 della serie del grafico box plot. \00C8 possibile utilizzare le sostituzioni <code>&COLUMN_VALUE.</code>.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744718652307190)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore Q2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745286949307190)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102745020371307190)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore da visualizzare per il segmento q3 della serie del grafico box plot. \00C8 possibile utilizzare le sostituzioni <code>&COLUMN_VALUE.</code>.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744889713307190)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore Q3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740097608307186)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di serie del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726988684307174)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'it'
,p_message_text=>'Ad aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727083732307174)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'it'
,p_message_text=>'A barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726806721307173)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'it'
,p_message_text=>'Box plot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727146782307174)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'it'
,p_message_text=>'A linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727227066307174)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'it'
,p_message_text=>'A linee con area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727371176307174)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841304458307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mapping colonna tipo serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841579985307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il tipo di serie del grafico. \00C8 inoltre possibile creare un grafico che combini tipi di serie diversi nella stessa rappresentazione di dati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841600241307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'it'
,p_message_text=>'Ad aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842167360307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'it'
,p_message_text=>'Intervallo aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841724318307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'it'
,p_message_text=>'A barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842038065307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'it'
,p_message_text=>'Intervallo barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841819997307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'it'
,p_message_text=>'A linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841991662307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'it'
,p_message_text=>'A linee con area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841403193307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842777980307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di serie del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842842102307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'it'
,p_message_text=>'Ad aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843425440307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'it'
,p_message_text=>'Intervallo aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842971444307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'it'
,p_message_text=>'A barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843308325307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'it'
,p_message_text=>'Intervallo barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843259091307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'it'
,p_message_text=>'A bolle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843050597307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'it'
,p_message_text=>'A linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130515826307493)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'it'
,p_message_text=>'A linee con area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843144019307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'it'
,p_message_text=>'A dispersione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842667663307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843685354307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di serie del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843748220307276)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'it'
,p_message_text=>'Ad aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843862723307276)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'it'
,p_message_text=>'Intervallo aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843970798307276)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'it'
,p_message_text=>'A linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102843556806307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842335303307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di serie del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842534495307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'it'
,p_message_text=>'Intervallo aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842470431307275)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'it'
,p_message_text=>'Intervallo barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102842263511307274)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824478019307261)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se l''asse deve essere visualizzato nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824371962307261)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra asse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365782693306851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare le informazioni sulla baseline nella descrizione comandi sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365181676306850)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra baseline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365587341306851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare la data di fine nella descrizione comandi sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364971881306850)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365618600306851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare l''avanzamento nella descrizione comandi sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365090068306850)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra stato di avanzamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365238153306850)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare le informazioni sulla riga nella descrizione comandi sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364660039306850)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365443744306851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare la data di inizio nella descrizione comandi sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364834987306850)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250276725306760)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il valore deve essere visualizzato nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250101913306760)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365396036306850)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare l''etichetta nella descrizione comandi sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364729910306850)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812625576307252)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se deve essere visualizzata una descrizione comandi nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812546152307252)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813253378307252)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare i valori nella descrizione comandi nel grafico. I valori derivano dalla query sul grafico e vengono visualizzati accanto ai dati del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813173191307252)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103147994115307506)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il criterio di ordinamento dei dati del grafico in un grafico a pi\00F9 serie in base al valore o all''etichetta del grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132533149307494)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'it'
,p_message_text=>'Etichetta - Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132969423307494)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare per ordinare il grafico in base alle etichette dell''asse X in ordine crescente. Si tratta del criterio di ordinamento predefinito. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132611360307494)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'it'
,p_message_text=>'Etichetta - Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133034330307495)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare per ordinare il grafico in base alle etichette dell''asse X in ordine decrescente. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132335871307494)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'it'
,p_message_text=>'Valore - Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132770663307494)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare per ordinare il grafico in base a valori disposti in ordine crescente (1, 2, 3, ...). Questa impostazione deve essere utilizzata solo per i grafici a torta, per i grafici a barre/a linee/ad aree con una sola serie o per i grafici a barre/ad'
||' aree in pila. Quando si usa un asse di gruppo gerarchico l''ordinamento non viene applicato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132408408307494)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'it'
,p_message_text=>'Valore - Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132836921307494)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare per ordinare il grafico in base a valori disposti in ordine decrescente (10, 9, 8, ...). Questa impostazione deve essere utilizzata solo per i grafici a torta, per i grafici a barre/a linee/ad aree con una sola serie o per i grafici a barre'
||'/ad aree in pila. Quando si usa un asse di gruppo gerarchico l''ordinamento non viene applicato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132203055307494)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Criterio di ordinamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977760877307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977650208307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per visualizzare il carattere per l''attributo specificato.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977208082307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977328708307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la famiglia di caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979071764307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'it'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978926106307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'it'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979157183307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'it'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979298508307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'it'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979461158307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'it'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979390443307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979575985307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'it'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979668033307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'it'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979724623307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979818668307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'it'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102979993695307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'it'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980141084307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'it'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980073609307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980286872307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'it'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980308040307379)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'it'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976950318307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Famiglia di caratteri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977510200307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la dimensione del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977993294307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'it'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978052797307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'it'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978100900307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'it'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978236221307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'it'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978354720307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'it'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978468882307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'it'
,p_message_text=>'20'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978516057307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'it'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977816793307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'it'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977115880307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977420114307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare lo stile del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978783781307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'it'
,p_message_text=>'Corsivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978660771307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102978835460307378)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'it'
,p_message_text=>'Obliquo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102977019329307377)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141695086307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione delle etichette dei task nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141957927307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142314305307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'it'
,p_message_text=>'L''etichetta del task viene visualizzata alla fine della barra degli strumenti nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142087223307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'it'
,p_message_text=>'Centro interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142458747307502)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'it'
,p_message_text=>'L''etichetta del task viene visualizzata in corrispondenza del centro interno nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142250764307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'it'
,p_message_text=>'Fine interna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142633148307502)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'it'
,p_message_text=>'L''etichetta del task viene visualizzata in corrispondenza del punto di fine interna della barra degli strumenti nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142100473307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'it'
,p_message_text=>'Inizio interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103142554407307502)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'it'
,p_message_text=>'L''etichetta del task viene visualizzata in corrispondenza del punto di inizio interno della barra degli strumenti nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141730332307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141849415307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'it'
,p_message_text=>'L''etichetta del task viene visualizzata all''inizio della barra degli strumenti nel grafico Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103141582999307501)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione etichetta task'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278500917306781)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Lista di colori separata da virgole:</dt>',
'<dd><pre>',
'<strong>rosso,giallo,blu</strong>',
'</pre></dd>',
'<dt>Lista di elementi di pagina o di applicazione sperata da virgole, che restituisce colori. Uso:</dt>',
'<dd><pre>',
'Sintassi: <code>&amp;ITEM.</code>. Ad esempio: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>Lista di colonne separata da virgole, che restituisce colori. Uso:</dt>',
'<dd><pre>',
'Sintassi: <code>&amp;COLUMN_NAME.</code>. Ad esempio: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278487677306781)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il colore o i colori da utilizzare per identificare il limite superiore della soglia o delle soglie da visualizzare in un grafico Misuratore misuratore stato.',
unistr('Per pi\00F9 soglie, utilizzare una lista separata da virgole.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259852091306767)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363531581306849)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare la modalit\00E0 di visualizzazione delle soglie nel grafico Misuratore misuratore stato. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277928843306780)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'it'
,p_message_text=>'Tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278045906306780)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'it'
,p_message_text=>'Tutte le soglie, definite utilizzando l''attributo <strong>Valori di soglia</strong>, vengono visualizzate nell''area di rappresentazione del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278273513306781)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'it'
,p_message_text=>'Solo soglia corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278310051306781)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La soglia corrente, definita utilizzando l''attributo <strong>Valori di soglia</strong>, viene visualizzata nell''area di rappresentazione del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102278166897306781)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'it'
,p_message_text=>'Su indicatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102363699609306849)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'it'
,p_message_text=>'La soglia corrente, definita utilizzando l''attributo <strong>Valori di soglia</strong>, viene visualizzata sull''indicatore del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277862988306780)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277735174306780)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Lista di valori numerici statici separata da virgole:</dt>',
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
'<dt>Lista di elementi di pagina o di applicazione sperata da virgole, che restituisce valori numerici. Uso:</dt>',
'<dd><pre>',
'Sintassi: <code>&amp;ITEM.</code>. Ad esempio: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>Lista di colonne separata da virgole, che restituisce valori numerici. Uso:</dt>',
'<dd><pre>',
'Sintassi: <code>&amp;COLUMN_NAME.</code>. Ad esempio: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259703095306767)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il numero o i numeri da utilizzare per identificare il limite superiore della soglia o delle soglie da visualizzare in un grafico Misuratore misuratore stato.',
unistr('Per pi\00F9 soglie, utilizzare una lista separata da virgole.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259454027306767)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780839427307224)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516998535306971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per visualizzare il carattere per l''attributo specificato.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513948435306968)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515507657306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la famiglia di caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514191429306968)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'it'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514062073306968)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'it'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514261260306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'it'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514361828306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'it'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514508361306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'it'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514458297306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514668316306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'it'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514716004306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'it'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514860001306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102514972410306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'it'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515031055306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'it'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515238198306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'it'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515126935306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515397214306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'it'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515440859306969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'it'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513604094306968)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Famiglia di caratteri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516013974306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la dimensione del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516297465306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'it'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516323899306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'it'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516401079306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'it'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516513376306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'it'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516682362306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'it'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516757685306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'it'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516859581306971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'it'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102516146469306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'it'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513899728306968)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515685407306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare lo stile del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515867649306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'it'
,p_message_text=>'Corsivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515719507306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102515917490306970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'it'
,p_message_text=>'Obliquo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513737320306968)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808099500307248)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il tipo di asse del tempo da visualizzare nel grafico. Questa impostazione visualizzer\00E0 in modo automatico i dati del grafico in ordine cronologico e non deve essere utilizzata se \00E8 necessario che i dati siano visualizzati in ordine crono')
||'logico inverso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808137356307248)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937094661307347)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica l''impostazione di asse temporale predefinita configurate in Oracle JET per il grafico in base ai dati visualizzati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808285691307248)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937160710307347)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'it'
,p_message_text=>'Non applica l''impostazione del tipo di asse temporale per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808382550307248)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937299080307347)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica l''impostazione del tipo di asse temporale per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808489719307248)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'it'
,p_message_text=>'Frequenza mista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847399045307278)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('I valori temporali visualizzati sull''asse del grafico verranno rappresentati con frequenza mista. Poich\00E9 il valore temporale dei dati pu\00F2 variare, la disposizione in pila non \00E8 supportata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847431369307278)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'it'
,p_message_text=>'Salta divari'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847593454307278)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'it'
,p_message_text=>'I valori temporali visualizzati sull''asse del grafico verranno rappresentati a intervalli regolari indipendentemente dai divari di tempo esistenti tra i dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102807958111307248)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo asse temporale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780753500307224)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513116122306968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per visualizzare il carattere per l''attributo specificato.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513093266306968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512754563306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la famiglia di caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511388715306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'it'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511243310306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'it'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511483900306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'it'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511508768306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'it'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511725173306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'it'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511608595306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511814154306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'it'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511994525306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'it'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512047710306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512195558306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'it'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512221289306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'it'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512499423306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'it'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512326984306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512546704306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'it'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512675327306967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'it'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509824264306965)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Famiglia di caratteri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512927877306968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la dimensione del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510521334306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'it'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510603191306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'it'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510733926306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'it'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510820623306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'it'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510941577306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'it'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511027122306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'it'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102511156774306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'it'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510418444306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'it'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510048295306965)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102512846184306968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare lo stile del carattere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510203620306965)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'it'
,p_message_text=>'Corsivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510123093306965)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102510317747306966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'it'
,p_message_text=>'Obliquo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509948587306965)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103134375670307495)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare le linee verticali della griglia nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133802117307495)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra griglia verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848309549307279)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare il funzionamento dell''ingrandimento e dello scorrimento nel grafico. <strong>In tempo reale</strong> indica che il grafico verr\00E0 aggiornato in modo continuo nel corso della manipolazione,'),
unistr('        mentre <strong>Ritardato</strong> indica che l''aggiornamento verr\00E0 eseguito solo dopo l''azione di ingrandimento o scorrimento. Sebbene l''ingrandimento e lo scorrimento di tipo <strong>In tempo reale</strong> garantisca un''esperienza ottimale ')
||'per l''utente finale, le prestazioni di',
unistr('        presentazione e la facilit\00E0 d''uso non sono garantite per i data set di grandi dimensioni o gli ambienti client lenti. Se le prestazioni sono un fattore importante, preferire l''ingrandimento e lo scorrimento di tipo <strong>Ritardato</strong>.')
||'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808622255307249)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Specificare le modalit\00E0 di ingrandimento e di scorrimento del grafico.'),
'        L''ingrandimento e lo scorrimento consentono all''utente finale di usare gesti, quali il trascinamento nell''area di rappresentazione, utilizzando la rotellina del mouse o due dita, per ridimensionare i valori visualizzati e spostarsi all''intern'
||'o del grafico per visualizzare valori diversi.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808803310307249)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'it'
,p_message_text=>'Ritardato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888087306307308)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La modifica apportata alla visualizzazione dei dati verr\00E0 eseguita solo dopo il completamento dell''azione di ingrandimento o di scorrimento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808924750307249)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'it'
,p_message_text=>'Solo scorrimento ritardato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888123825307308)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La modifica apportata alla visualizzazione dei dati verr\00E0 eseguita solo dopo il completamento dell''azione di scorrimento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809015114307249)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'it'
,p_message_text=>'In tempo reale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888270679307308)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Il funzionamento In tempo reale indica che il grafico verr\00E0 aggiornato in modo continuo nel corso della manipolazione.'),
'        Per i data set di grandi dimensioni e gli ambienti client lenti, si consiglia di selezionare <strong>Ritardato</strong>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809113834307249)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'it'
,p_message_text=>'Solo scorrimento in tempo reale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888329993307308)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Il funzionamento Solo scorrimento in tempo reale indica che il grafico verr\00E0 aggiornato in modo continuo durante lo scorrimento.'),
'        Per i data set di grandi dimensioni e gli ambienti client lenti, si consiglia di selezionare <strong>Solo scorrimento ritardato</strong>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808756007307249)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887934933307308)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'it'
,p_message_text=>'L''ingrandimento e lo scorrimento sono disabilitati per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102808506433307249)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ingrandimento e scorrimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352845830307671)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la direzione di zoom del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352933272307671)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Entrambi gli assi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353085004307671)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'it'
,p_message_text=>'Esegue lo zoom in entrambe le direzioni degli assi x e y.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353101865307671)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'it'
,p_message_text=>'Asse X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353260494307671)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'it'
,p_message_text=>'Esegue lo zoom solo nella direzione dell''asse x.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353399348307671)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Asse Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353461805307671)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'it'
,p_message_text=>'Esegue lo zoom solo nella direzione dell''asse y.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103352726586307671)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Direzione zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137072102307498)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se consentire lo zoom fino a una scala di giorni nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135854248307497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136918788307497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se consentire lo zoom fino a una scala di ore nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135572716307496)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136823797307497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se consentire lo zoom fino a una scala di minuti nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135473741307496)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Minuti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137233037307498)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se consentire lo zoom fino a una scala di mesi nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136264483307497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mesi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137350365307498)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se consentire lo zoom fino a una scala di trimestri nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136438513307497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Trimestri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136788551307497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se consentire lo zoom fino a una scala di secondi nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103135184272307496)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Secondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137177395307498)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se consentire lo zoom fino a una scala di settimane nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136008995307497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Settimane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103137423704307498)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se consentire lo zoom fino a una scala di anni nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103136684339307497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Anni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940670624307350)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare una condizione lato client per controllare se l''azione viene attivata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535743871306992)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare una condizione lato client per controllare se le azioni True o False vengono attivate. Se la condizione',
'                                  restituisce True, verranno attivate le azioni True; se la condizione restituisce False, verranno',
'                                  attivate le azioni False. Se la condizione non viene specificata, verranno attivate solo le azioni True.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046884016307430)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'it'
,p_message_text=>'Elemento = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403523767307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato \00E8 uguale al <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047040757307430)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'it'
,p_message_text=>'Elemento > valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403752336307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato \00E8 maggiore del <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047198456307430)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'it'
,p_message_text=>'Elemento >= valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403870022307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato \00E8 maggiore o uguale al <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047698273307431)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 nella lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404387108307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Controlla se il valore dell''<em>elemento</em> selezionato si trova nella <em>lista</em> specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047896239307431)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404537725307713)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Valuta l''espressione JavaScript specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047242983307430)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'it'
,p_message_text=>'Elemento < valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403926739307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato \00E8 minore del <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047388154307431)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'it'
,p_message_text=>'Elemento <= valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404094541307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato \00E8 minore o uguale al <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046985344307430)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'it'
,p_message_text=>'Elemento != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103403604847307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato \00E8 diverso dal <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047730465307431)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento non \00E8 nella lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404460157307713)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Controlla se il valore dell''<em>elemento</em> selezionato non si trova nella <em>lista</em> specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047564119307431)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento non \00E8 nullo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404218823307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se l''<em>elemento</em> selezionato non \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103047452506307431)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 nullo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404190353307712)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se l''<em>elemento</em> selezionato \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535663798306992)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404994755307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la colonna da utilizzare in questa condizione.</p>',
'<p>Nota: nella maggior parte dei casi deve trattarsi della colonna specificata in precedenza nel gruppo <em>Quando per l''attributo Colonna/e</em>',
'e che quindi viene proposta per impostazione predefinita. Se tuttavia si desidera basare la condizione su una colonna diversa,',
unistr('ad esempio con una griglia interattiva basata sulla tabella EMP, nonch\00E9 attivare un''azione dinamica a ogni modifica'),
unistr('di <code>SAL</code>, ma solo se <code>JOB</code> \00E8 uguale a <em>SALESMAN</em>, modificare questo attributo impostandolo su <code>JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399552120307705)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406238849307714)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se nella condizione viene usato un <em>elemento</em> o viene usata una <em>colonna</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395035803307702)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394908143307702)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394860276307702)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940765838307350)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Immettere l''elemento pagina utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940590577307350)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Immettere l''elemento pagina utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405099031307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere l''elemento pagina da utilizzare in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo dalla lista degli elementi disponibili.</p>'),
'<p>Nota: nella maggior parte dei casi deve trattarsi dell''elemento specificato in precedenza nel gruppo <em>Quando per l''attributo Elemento/i</em>',
'e che quindi viene proposto per impostazione predefinita. Se tuttavia si desidera basare la condizione su un elemento pagina diverso,',
unistr('ad esempio con un form basato sulla tabella EMP, nonch\00E9 attivare un''azione dinamica a ogni modifica di <code>P2_SAL</code>,'),
unistr('ma solo se <code>P2_JOB</code> \00E8 uguale a <em>SALESMAN</em>, modificare questo attributo impostandolo su <code>P2_JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103395193864307702)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103404817270307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento pagina utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399437417307705)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940828709307350)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare una condizione lato client per controllare se l''azione viene attivata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399704068307706)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare una condizione lato client per controllare se le azioni True o False vengono attivate. Se la condizione',
'                                  restituisce True, verranno attivate le azioni True; se la condizione restituisce False, verranno',
'                                  attivate le azioni False. Se la condizione non viene specificata, verranno attivate solo le azioni True.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399827587307706)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/colonna = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405108333307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato o della <em>colonna</em> selezionata \00E8 uguale al <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400051245307706)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/colonna > valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405355740307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato o della <em>colonna</em> selezionata \00E8 maggiore del <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400102065307709)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/colonna >= valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405425086307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato o della <em>colonna</em> selezionata \00E8 maggiore o uguale al <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400622013307709)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('Elemento/colonna \00E8 nella lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405981366307714)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Controlla se il valore dell''<em>elemento</em> selezionato o della <em>colonna</em> selezionata si trova nella <em>lista</em> specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400837715307710)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406111294307714)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Valuta l''espressione JavaScript specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400252105307709)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/colonna < valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405500933307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato o della <em>colonna</em> selezionata \00E8 minore del <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400382997307709)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/colonna <= valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405663251307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato o della <em>colonna</em> selezionata \00E8 minore o uguale al <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399926618307706)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/colonna != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405281790307713)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se il valore dell''<em>elemento</em> selezionato o della <em>colonna</em> selezionata non \00E8 uguale al <em>valore</em> specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400769061307710)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('Elemento/colonna non \00E8 nella lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406053713307714)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Controlla se il valore dell''<em>elemento</em> selezionato o della <em>colonna</em> selezionata non si trova nella <em>lista</em> specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400524635307709)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/colonna non nullo/a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405806629307714)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se l''<em>elemento</em> selezionato o la <em>colonna</em> selezionata non \00E8 vuoto/a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400490407307709)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/colonna nullo/a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103405737831307714)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Controlla se l''<em>elemento</em> selezionato o la <em>colonna</em> selezionata \00E8 vuoto/a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399654792307706)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940488591307350)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare l''espressione JavaScript da valutare per questa condizione.',
'Il codice accede agli attributi correlati alle azioni dinamiche riportati di seguito.</p>',
'<dl>',
'  <dt>this.triggeringElement</dt>',
'    <dd>Riferimento all''oggetto DOM dell''elemento che ha attivato l''azione dinamica.</dd>',
'  <dt>this.browserEvent</dt>',
unistr('    <dd>L''oggetto di evento che ha attivato l''evento. Nota: al caricamento, sar\00E0 uguale a ''load''.</dd>'),
'  <dt>this.data</dt>',
'    <dd>Dati aggiuntivi facoltativi che possono essere passati dall''handler di eventi.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940348823307350)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401424145307710)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare l''espressione JavaScript da valutare per questa condizione.',
'Il codice accede agli attributi correlati alle azioni dinamiche riportati di seguito.</p>',
'<dl>',
'  <dt>this.triggeringElement</dt>',
'    <dd>Riferimento all''oggetto DOM dell''elemento che ha attivato l''azione dinamica.</dd>',
'  <dt>this.browserEvent</dt>',
unistr('    <dd>L''oggetto di evento che ha attivato l''evento. Nota: al caricamento, sar\00E0 uguale a ''load''.</dd>'),
'  <dt>this.data</dt>',
'    <dd>Dati aggiuntivi facoltativi che possono essere passati dall''handler di eventi.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401377144307710)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399316210307705)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista di valori separata da virgole per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103399268370307705)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401216810307710)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la lista di valori separata da virgole per la condizione da sottoporre a test.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401141998307710)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439895461307740)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439744723307740)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401057690307710)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore per la condizione da sottoporre a test.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103400902435307710)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536401942306992)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice JavaScript da eseguire al caricamento della pagina.',
'Il codice immesso viene eseguito dopo il codice JavaScript generato da &PRODUCT_NAME..</p>',
'<p>Il codice immesso qui sostituisce la stringa di sostituzione <code>#GENERATED_JAVASCRIPT#</code> nel modello della pagina.</p>',
unistr('<p>Nota: non \00E8 necessario aggiungere tag <code>script</code> di apertura o chiusura. Includere solo il codice JavaScript.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536352056306992)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Esegui al caricamento della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038765515307424)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Riferimento file standard</dt>',
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>Riferimento file standard che carica il file ridotto <code>main.min.js</code> da <code>/myjs/minified/</code> per le visualizzazioni di pagina normali e il file <code>main.js</code> da <code>/myjs/</code> in modalit\00E0 di debug o quando si esegue l')
||'''applicazione dall''App Builder</dt>',
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
'<dt>Usare questa sintassi se la libreria viene utilizzata anche da una chiamata require RequireJS. Il nome definito deve corrispondere a quello utilizzato nei percorsi requirejs.config e il valore deve essere il simbolo globale esposto dalla libreria'
||'. Si applica solo quando si usa RequireJS. In questo modo si evita che RequireJS carichi la libreria una seconda volta.</dt>',
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
'<dt>Usare questa sintassi se esiste una dipendenza del file in RequireJS. In questo modo si carica automaticamente RequireJS prima di questo file.</dt>',
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
'<dt>Usare questa sintassi se esiste una dipendenza del file in Oracle JET. In questo modo si carica automaticamente RequireJS e la configurazione di Oracle JET RequireJS prima di questo file.</dt>',
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
'<dt>Riferimento file che utilizza una stringa di query nell''URL che indica la versione dell''applicazione, in modo che all''aggiornamento dell''applicazione (e all''aumento del numero di versione), il browser riceva istruzioni per caricare sempre il nuov'
||'o file e ignorare tutti i file inseriti in precedenza nella cache.</dt>',
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536042851306992)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli URL dei file JavaScript per il codice caricato in questa pagina. Ogni URL deve essere scritto in una nuova riga.',
unistr('Se si fornisce una versione ridotta del file, \00E8 possibile usare la stringa di sostituzione <code>#MIN#</code> per includere <code>.min</code> o la stringa di sostituzione <code>#MIN_DIRECTORY#</code> per includere <code>minified/</code> nell''URL del ')
||unistr('file per una visualizzazione normale della pagina e una stringa vuota se la pagina viene visualizzata nella modalit\00E0 di debug o quando si esegue l''applicazione dall''App Builder.'),
unistr('Se si desidera includere la versione dell''applicazione nell''URL del file, \00E8 inoltre possibile accedere alla stringa di sostituzione <code>#APP_VERSION#</code>.</p>'),
'<p>Gli URL dei file JavaScript immessi qui sostituiranno la stringa di sostituzione <code>#PAGE_JAVASCRIPT#</code> nel modello della pagina.</p>',
unistr('<p>Nota: non \00E8 necessario includere le tag <code>script</code> di apertura o di chiusura. Specificare solo l''URL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535984038306992)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536259063306992)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice JavaScript, ad esempio dichiarazioni di funzioni o di variabili globali, a cui si fa riferimento in questa pagina.',
'Per fare riferimento a una scorciatoia, usare <code>"SHORTCUTNAME"</code>.',
unistr('Se lo stesso codice JavaScript \00E8 richiesto in pi\00F9 pagine, si consiglia di inserirlo in un file JavaScript esterno per evitare la duplicazione e per sfruttare l''inserimento dei file statici nella cache del browser.</p>'),
'<p>Il codice immesso qui sostituisce la stringa di sostituzione <code>#PAGE_JAVASCRIPT#</code> nel modello della pagina.</p>',
unistr('<p>Nota: non \00E8 necessario aggiungere le tag <code>script</code> di apertura o di chiusura. Includere solo il codice JavaScript.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536163916306992)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dichiarazione di funzione e variabile globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376803332307688)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''etichetta per il facet.',
unistr('    L''etichetta viene visualizzata nella pagina solo se il facet viene visualizzato. L''etichetta per il tipo <strong>Ricerca</strong> \00E8 nascosta, ma disponibile per la tecnologia assistiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216279129307568)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'~Immettere l''etichetta del gruppo di facet.~'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216461023307568)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''etichetta per il facet.',
unistr('    L''etichetta viene visualizzata nella pagina solo se il facet viene visualizzato. L''etichetta per il tipo <strong>Ricerca</strong> \00E8 nascosta, ma disponibile per la tecnologia assistiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579452419307032)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''etichetta per il filtro.',
unistr('    L''etichetta viene visualizzata nella pagina solo se il filtro viene visualizzato. L''etichetta per il tipo <strong>Ricerca</strong> \00E8 nascosta, ma disponibile per la tecnologia assistiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580376822307033)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'~Immettere l''etichetta del gruppo di filtri.~'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580773039307033)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''etichetta per il filtro.',
unistr('    L''etichetta viene visualizzata nella pagina solo se il filtro viene visualizzato. L''etichetta per il tipo <strong>Ricerca</strong> \00E8 nascosta, ma disponibile per la tecnologia assistiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561982895307016)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''etichetta dl campo per l''elemento di pagina.',
'L''etichetta viene visualizzata nella pagina solo se l''elemento viene visualizzato.',
unistr('A seconda dell''allineamento e della modalit\00E0 di visualizzazione, l''etichetta verr\00E0 visualizzata nella propria cella di tabella HTML oppure nella stessa cella.</p>'),
'<p>Le etichette di elemento possono includere collegamenti che utilizzano la sintassi <code>"SHORTCUT_NAME"</code>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561815866307016)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562148887307016)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare l''allineamento dell''etichetta. Le etichette possono essere visualizzate sopra, sotto o a sinistra dell''elemento.',
'Quando viene visualizzata accanto a un elemento del form, l''etichetta occupa la propria cella di tabella HTML.',
unistr('Modificando l''allineamento, \00E8 possibile controllare la posizione dell''etichetta all''interno della cella di tabella.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050222263307433)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'it'
,p_message_text=>'In alto '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050380781307433)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050598630307433)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'Centrato in basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050624622307433)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Centrato al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050754589307433)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'it'
,p_message_text=>'Centrato in alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050485406307433)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050936167307433)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'In basso a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051006182307434)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Centrato a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051139157307434)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'it'
,p_message_text=>'In alto a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103050807166307433)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'it'
,p_message_text=>'A sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051391078307434)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'In basso a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051498477307434)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Centrato a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051583267307434)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'it'
,p_message_text=>'In alto a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103051286066307434)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'A destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562094237307016)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Allineamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379363803307690)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se caricare l''area in modo indipendente rispetto ai dati per l''area.</p>',
unistr('        <p>Quando si specifica il caricamento lento, la pagina viene visualizzata immediatamente, con un''area che risulta vuota finch\00E9 non vengono caricati i dati.'),
unistr('        In genere la pagina non viene visualizzata finch\00E9 non \00E8 stata caricata completamente ed \00E8 pronta per essere visualizzata.'),
'        Se pertanto il caricamento di tutti i dati per un''area richiede 5 secondi, senza il caricamento lento l''utente finale dovrebbe attendere per 5 secondi prima che la pagina inizi a essere visualizzata.</p>',
unistr('        <p>Nota: il caricamento lento non deve essere utilizzato su data set con tempi di caricamento lunghi, poich\00E9 aggiunge un sovraccarico di elaborazione non necessario nel database per le aree a caricamento rapido.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758208629307203)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se caricare l''area in modo indipendente rispetto ai dati per l''area.</p>',
unistr('        <p>Quando si specifica il caricamento lento, la pagina viene visualizzata immediatamente, con un''area che risulta vuota finch\00E9 non vengono caricati i dati.'),
unistr('        In genere la pagina non viene visualizzata finch\00E9 non \00E8 stata caricata completamente ed \00E8 pronta per essere visualizzata.'),
'        Se pertanto il caricamento di tutti i dati per un''area richiede 5 secondi, senza il caricamento lento l''utente finale dovrebbe attendere per 5 secondi prima che la pagina inizi a essere visualizzata.</p>',
unistr('        <p>Nota: il caricamento lento non deve essere utilizzato su data set con tempi di caricamento lunghi, poich\00E9 aggiunge un sovraccarico di elaborazione non necessario nel database per le aree a caricamento rapido.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758177720307203)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Caricamento lento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197921712307555)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se \00E8 possibile attivare o disattivare la visibilit\00E0 del layer facendo clic sul relativo nome nella legenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197891362307555)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Abilita per nascondere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198117211307555)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''icona da visualizzare per questo layer nella legenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198071774307555)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813608612307253)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione della legenda sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813773783307253)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814010646307253)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813995238307253)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813853812307253)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814185291307253)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'it'
,p_message_text=>'Inizio pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813517061307252)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813434279307252)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se deve essere visualizzata una legenda sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813303242307252)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198338762307555)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il titolo della legenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924557117307338)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il titolo da visualizzare nella parte superiore della legenda del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924482952307338)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819599119307257)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare lo stile della linea da visualizzare nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819708729307257)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'it'
,p_message_text=>'Tratteggiata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819663437307257)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'it'
,p_message_text=>'Punteggiata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819833813307257)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'it'
,p_message_text=>'Unita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819433705307257)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820373289307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il tipo di linea da visualizzare nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820498671307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820772446307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'it'
,p_message_text=>'Segmentato centrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820549736307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'it'
,p_message_text=>'A gradini centrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820661073307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'it'
,p_message_text=>'Curvo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821007730307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820907923307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'it'
,p_message_text=>'Segmentato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820890930307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'it'
,p_message_text=>'A gradini'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821147958307258)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'it'
,p_message_text=>'Linea retta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820279139307257)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820061766307257)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la larghezza della linea da visualizzare nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102819977015307257)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102820142767307257)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067182589307446)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Apertura del collegamento in nuova finestra</dt>',
'<dd><pre>target="_blank"</pre></dd>',
'<dt>Visualizzazione della descrizione comandi al passaggio del mouse</dt>',
'<dd><pre>title="Fare clic per modificare"</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864195075307290)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere gli attributi di collegamento alla colonna aggiuntivi da includere nella tag <code>&lt;a href=...&gt;</code>, tra i quali la destinazione del collegamento, le classi o gli stili.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864012380307290)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869805786307295)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare lo schema di autorizzazione da associare a una colonna di collegamento. Affinch\00E9 la colonna di collegamento venga visualizzata nel report, \00E8 necessario che lo schema di autorizzazione selezionato restituisca TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869724654307295)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282149906307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282577422307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282470863307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282311115307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282649318307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282242701307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282084126307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284174299307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284451153307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284341910307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284283120307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284503377307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284003191307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878481516307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878308421307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879868764307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879725740307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283702040307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Java per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283668402307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285305559307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285289414307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283531417307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283468645307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione JavaScript per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283305606307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285164996307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285061790307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284984904307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878679073307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista di valori separata da due punti (:) per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878528745307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879049681307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero di pagina per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878970455307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879298758307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista separata da virgole di numeri di pagina per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879113955307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283299956307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283145891307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione PL/SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283079449307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284875040307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284772437307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione PL/SQL che restituisca un valore booleano per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103284690625307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878842305307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la preferenza utente che viene confrontata con il valore specificato per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878740604307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283985997307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Python per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103283848565307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285530589307621)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103285411908307620)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282910674307619)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente \00E8 un responsabile (manager) e il relativo reparto si trova a Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282890268307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione SQL per la condizione.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103282791569307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103425068158307728)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori se esistono una o pi\00F9 righe durante il controllo per determinare se il dipendente si trova nel reparto 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>Per la corretta restituzione dei valori se non esistono righe durante il controllo per determinare se il dipendente si trova nel reparto 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878078136307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877934093307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879495029307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore di testo per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879347825307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880026996307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore, comprese le stringhe di sostituzione <code>&ITEM.</code>, per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879940574307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877898871307300)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il tipo di condizione che deve essere soddisfatto affinch\00E9 questo collegamento venga visualizzato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128960956307492)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'it'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264697007307604)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il componente verr\00E0 visualizzato sempre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127511808307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 Microsoft Internet Explorer versione 7.0 o successiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127642596307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 un browser con capacit\00E0 XHTML/CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127480308307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 Mozilla, Netscape versione 6.x/7x o successiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127752674307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 un browser di altro tipo (o una versione precedente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126121202307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo \00E8 contenuto nell''elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128123236307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'it'
,p_message_text=>'Lingua corrente = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268202262307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale sta eseguendo l''applicazione nella lingua immessa nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127858178307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'it'
,p_message_text=>unistr('La lingua corrente \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268471102307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale sta eseguendo l''applicazione in una delle lingue immesse nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128020930307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'it'
,p_message_text=>'Lingua corrente != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268324521307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale non sta eseguendo l''applicazione nella lingua immessa nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127973434307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'it'
,p_message_text=>unistr('La lingua corrente NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268550378307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale non sta eseguendo l''applicazione in una delle lingue immesse nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125388434307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente = pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267055866307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 uguale al valore immesso in <em>Pagina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125596395307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 in una lista separata da virgole')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267208228307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 contenuta nella lista separata da virgole immessa in <em>Pagine</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125435717307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente != pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267113169307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 diversa dal valore immesso in <em>Pagina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125661290307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente NON \00E8 in una lista separata da virgole')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267337371307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente non \00E8 contenuta nella lista separata da virgole immessa in <em>Pagine</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128248419307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: DAD_NAME = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128386694307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: DAD_NAME != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127067915307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'it'
,p_message_text=>'Errori di convalida in linea visualizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268065767307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'it'
,p_message_text=>'Un errore di convalida in linea viene visualizzato nella pagina, dopo la sottomissione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126481635307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126281312307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126366566307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo NON \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126525035307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123071636307487)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Righe restituite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264720927307604)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La query SQL restituisce una o pi\00F9 righe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281897923307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103281982038307618)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'L''espressione restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123212102307487)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264988862307604)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Il corpo funzione restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128612862307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: HTTP_HOST = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128708344307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: HTTP_HOST != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126752644307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina/area NON \00E8 di sola lettura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267740675307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina e l''area padre, se necessario, vengono visualizzate in modo normale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126671359307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina/area \00E8 di sola lettura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267610997307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina o l''area padre, se necessario; la condizione ''Sola lettura'' restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124557105307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento non contiene spazi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266277249307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'it'
,p_message_text=>'Il valore dell''<em>elemento</em> selezionato non contiene spazi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124805691307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 alfanumerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266517467307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 alfanumerico, ovvero contiene solo lettere o numeri e nessun carattere speciale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124078939307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265793175307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124742628307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266479405307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124239575307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265904603307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123954100307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265699594307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124360979307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NULL o pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266083337307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 vuoto o \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124668068307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266337925307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124131948307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265890760307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124485030307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL e NON \00E8 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266145205307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 vuoto e non \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127211788307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'it'
,p_message_text=>'Report SQL (OK per visualizzare il pulsante Avanti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127312347307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'it'
,p_message_text=>'Report SQL (OK per visualizzare il pulsante Indietro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128818910307492)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'it'
,p_message_text=>'Mai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268683802307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il componente non viene visualizzato mai.</p>',
'<p>Nota: se si modifica una condizione impostandola su <strong>Mai</strong>, verranno rimosse tutte le condizioni esistenti. Per disabilitare temporaneamente un componente, Oracle consiglia di usare preferibilmente l''attributo <em>Opzione di creazion'
||'e</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103127146009307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'it'
,p_message_text=>'Errori di convalida in linea NON visualizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103268195930307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'it'
,p_message_text=>'Un errore di convalida in linea non viene visualizzato nella pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123133032307487)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Nessuna riga restituita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103264872801307604)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>'La query SQL non restituisce righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125997490307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 in modalit\00E0 Per la stampa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267420315307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 stata impostata su ''in modalit\00E0 Per la stampa'' dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126024146307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente NON \00E8 in modalit\00E0 Per la stampa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267525050307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente non \00E8 stata impostata su ''in modalit\00E0 Per la stampa'' dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123315924307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Richiesta = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265032196307604)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123542187307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265211755307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 contenuta nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123428278307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Richiesta != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265169849307604)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 diversa dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123670056307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265313285307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina non \00E8 contenuta nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128436724307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: SERVER_NAME = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103128522923307491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: SERVER_NAME != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126849016307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 autenticato (non \00E8 pubblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267867980307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale \00E8 collegato all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103126961435307490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 pubblico (non ha eseguito l''autenticazione)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103267920785307607)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale non \00E8 collegato all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125105847307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza utente = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266883728307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della <em>preferenza</em> immessa \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125217411307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza utente != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266998839307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della <em>preferenza</em> immessa \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103124928542307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 in una lista separata da due punti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266683985307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125073453307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 in una lista separata da due punti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103266701086307606)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123709285307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265413731307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103123890841307488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103265588131307605)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125890370307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente != pagina sottomessa (inviata)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103125798439307489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente = pagina sottomessa (inviata)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877775126307300)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di condizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878281339307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore da confrontare con la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102878161243307301)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879644488307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore, comprese le stringhe di sostituzione <code>&ITEM.</code>, per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102879518799307302)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011312395307403)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Le aree del report possono essere stampate utilizzando il collegamento di stampa standard, disponibile sotto le aree, oppure utilizzando un pulsante. Se si desidera utilizzare un pulsante, rimuovere l''etichetta del collegamento e creare un pulsant'
||'e sulla pagina utilizzando l''URL indicato in URL di stampa come destinazione del pulsante.</p>',
unistr('<p>L''utilizzo di pulsanti per la stampa delle aree del report consente di impostare lo stato della sessione. Ci\00F2 \00E8 utile se si prevede di supportare la stampa in numerosi formati di output diversi (Word, Excel, PDF e cos\00EC via) e si desidera visualizz')
||'are un pulsante, un collegamento o un''immagine per ogni opzione. Per questa implementazione, utilizzare il formato di output derivato da un''opzione elemento e includere il nome e il valore dell''elemento nell''URL di stampa.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240454088307586)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Visualizza il collegamento dell''URL per questo report salvato. Questo attributo \00E8 di sola visualizzazione e non pu\00F2 essere aggiornato.</p>'),
unistr('    <p>Questo attributo consente di copiare rapidamente l''URL visualizzato. L''URL pu\00F2 essere usato per collegarsi direttamente a questo report salvato particolare da qualsiasi altro punto dell''applicazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011948815307403)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Le aree del report possono essere stampate utilizzando il collegamento di stampa standard, disponibile sotto le aree, oppure utilizzando un pulsante. Se si desidera utilizzare un pulsante, rimuovere l''etichetta del collegamento e creare un pulsant'
||'e sulla pagina utilizzando l''URL indicato in URL di stampa come destinazione del pulsante.</p>',
unistr('<p>L''utilizzo di pulsanti per la stampa delle aree del report consente di impostare lo stato della sessione. Ci\00F2 \00E8 utile se si prevede di supportare la stampa in numerosi formati di output diversi (Word, Excel, PDF e cos\00EC via) e si desidera visualizz')
||'are un pulsante, un collegamento o un''immagine per ogni opzione. Per questa implementazione, utilizzare il formato di output derivato da un''opzione elemento e includere il nome e il valore dell''elemento nell''URL di stampa.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880703491307303)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Visualizza il collegamento dell''URL per questo report salvato. Questo attributo \00E8 di sola visualizzazione e non pu\00F2 essere aggiornato.</p>'),
unistr('<p>Questo attributo consente di copiare rapidamente l''URL visualizzato. L''URL pu\00F2 essere usato per collegarsi direttamente a questo report salvato particolare da qualsiasi altro punto dell''applicazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880671490307303)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Esempio di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869669614307294)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il codice HTML da utilizzare per il collegamento. Utilizzare una tag di immagine per visualizzare le immagini oppure effettuare una scelta nella lista di immagini predefinite. In mancanza di una definizione specifica, verr\00E0 utilizzata l''imm')
||'agine <code>#IMAGE_PREFIX#ws/small_page.gif</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869523183307294)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Icona di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880342894307302)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fare clic su Destinazione per richiamare una finestra di dialogo di tipo modale. \00C8 possibile immettere una destinazione personalizzata da richiamare quando si fa clic su Colonna di collegamento.</p>'),
'        <p>Selezionare il tipo appropriato in Costruzione guidata collegamento - Destinazione a seconda delle esigenze.',
'        <dl>',
'        <dt>Pagina in questa applicazione</dt>',
'        <dd>Immettere quanto riportato di seguito.',
'        <ul>',
unistr('        <li>Pagina: immettere il numero o l''alias della pagina su cui spostarsi. \00C8 possibile selezionare il numero della pagina anche dalla select list.</li>'),
'        <li>Imposta elementi - Nome: immettere o selezionare gli elementi pagina (<code>P3_ID</code>), gli elementi di applicazione (<code>LAST_PAGE</code>) o i filtri dei report interattivi (<code>IR_EMPNO</code>) da impostare nello stato di session'
||'e.</li>',
'        <li>Imposta elementi - Valore: immettere o selezionare una colonna di report (<code>#ID#</code>), immettere un elemento di applicazione o pagina (<code>&P2_EMPNO.</code>) o immettere un valore statico (<code>2</code>).</li>',
'        <li>Svuota cache: immettere una lista separata da virgole di numeri di pagina (<code>2,3</code>), elementi (<code>P3_EMPNO,LAST_PAGE</code>) e impostazioni di report da cancellare. Per reimpostare l''impaginazione per un report, immettere <cod'
||'e>RP</code>. Per cancellare o reimpostare le impostazioni dei report interattivi, immettere <code>CIR</code> o <code>RIR</code>.</li>',
unistr('        <li>Reimposta impaginazione: selezionare S\00EC per reimpostare l''impaginazione, a ritroso fino al primo set di record, per i report della pagina di destinazione. L''effetto ottenuto \00E8 uguale a quello che si ottiene quando si passa <code>RP</code>')
||' in Svuota cache.</li>',
'        <li>Avanzate - Richiesta: immettere la richiesta da utilizzare.</li>',
'        </ul>',
'        </dd>',
'        <dt>Pagina in un''altra applicazione</dt>',
'        <dd>Immettere gli stessi attributi elencati per Pagina in questa applicazione. Immettere inoltre l''identificativo o l''alias dell''applicazione per Applicazione.</dd>',
'        <dt>URL</dt>',
'        <dd>Immettere l''URL.</dd>',
'        </dl></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102880271198307302)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198771073307555)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''azione da eseguire quando si fa clic su un oggetto sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815466737307254)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''azione da eseguire quando si fa clic sul grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774731376307218)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a URL restituito dalla prima colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774801460307218)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'La prima colonna della query SQL ha restituito il reindirizzamento all''URL di destinazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815727147307254)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina in un''altra applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815862539307254)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Reindirizza a una pagina di un''altra applicazione, con attributi aggiuntivi facoltativi per la reimpostazione dell''impaginazione, l''impostazione del valore della richiesta, la cancellazione del contenuto della cache e l''impostazione dei valori deg'
||'li elementi nella pagina di destinazione.</p>',
'<p>Nota: il reindirizzamento a una pagina di un''altra applicazione si basa sul deep link abilitato nell''applicazione di destinazione. Per abilitare il deep link, andare agli attributi <em>Sicurezza</em> dell''applicazione e abilitare <em>Deep link</em'
||'>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815565657307254)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina in questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815625767307254)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a una pagina dell''applicazione corrente, con attributi aggiuntivi facoltativi per la reimpostazione dell''impaginazione, l''impostazione del valore della richiesta, la cancellazione del contenuto della cache e l''impostazione dei valori degl'
||'i elementi nella pagina di destinazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815940001307254)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816096010307254)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza all''URL di destinazione specificato dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815389455307254)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863967383307290)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo HTML da mostrare come collegamento. Utilizzare una tag di immagine per visualizzare le immagini oppure scegliere un''immagine dalla lista di immagini predefinite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863847111307290)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176448344306704)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare un modello per definire l''aspetto e il layout di questa lista.</p>',
'        <p>I modelli di lista sono definiti nel tema dell''applicazione.',
'        Quando si crea un''area di lista, il modello viene impostato in modo automatico sul modello di lista predefinito presente nel tema corrente.</p>',
'        <p>Nel tema universale sono disponibili i modelli di lista riportati di seguito.',
'          <dl>',
'            <dt>Lista badge</dt>',
'            <dt>Schede</dt>',
'            <dt>Lista collegamenti</dt>',
'            <dt>Lista supporti</dt>',
'            <dt>Barra dei menu</dt>',
'            <dt>Popup menu</dt>',
'            <dt>Barra di navigazione</dt>',
'            <dt>Menu di navigazione laterale</dt>',
'            <dt>Schede</dt>',
'            <dt>Menu di navigazione superiore</dt>',
'            <dt>Avanzamento procedura guidata</dt>',
'          </dl>',
'          Vedere anche: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176321820306704)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244434285307589)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244961813307589)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245086199307590)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista dinamica si basa sulla query SQL restituita dal corpo funzione PL/SQL immesso dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244704141307589)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244802771307589)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista dinamica si basa sulla query SQL immessa dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244575663307589)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244619119307589)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista statica si basa sul valore del testo immesso dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103244329430307589)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929883538307342)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero totale di giorni da visualizzare nella vista Agenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929769085307342)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero di giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929966929307342)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'it'
,p_message_text=>'giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929633115307342)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare i giorni da visualizzare per la vista lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089121074307462)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089224457307462)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza le voci di calendario in base al numero di giorni immesso dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088753405307462)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'it'
,p_message_text=>'Mese corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088806611307462)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza le voci di calendario per il mese corrente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088997878307462)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'it'
,p_message_text=>'Anno corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089002787307462)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza le voci di calendario per l''anno corrente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102929544782307342)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679704951307129)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la pagina di login dell''applicazione per l''interfaccia utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679643977307129)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL di login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624134554307082)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la posizione a cui &PRODUCT_NAME. esegue il reindirizzamento dopo il logout.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058209372307439)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'it'
,p_message_text=>'Home page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058394460307439)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza al valore Collegamento home specificato negli attributi dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058414337307439)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'it'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058521761307439)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza all''URL immesso dall''utente, ad esempio <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624040929307082)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo logout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757213036307202)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare come proteggere i dati dalla perdita degli aggiornamenti.',
unistr('		La perdita degli aggiornamenti si verifica quando due o pi\00F9 persone tentano di aggiornare gli stessi dati e l''ultimo aggiornamento sovrascrive gli aggiornamenti effettuati dal primo utente che ha salvato le modifiche.'),
unistr('		Per evitare che ci\00F2 succeda, durante gli aggiornamenti \00E8 possibile controllare i valori di colonna esistenti nel database rispetto ai valori recuperati al momento dell''esecuzione della query originale sul record.</p>'),
'		<p>Ad esempio:',
'          <ol>',
'            <li>L''Utente A esegue una query sui record dei dipendenti (EMP).</li>',
'		    <li>L''Utente B esegue una query sugli stessi record dei dipendenti.</li>',
'		    <li>L''Utente B aggiorna i dettagli dipendente per EMPNO = 7839 e applica le modifiche, ovvero ne esegue il commit nel database.</li>',
'		    <li>L''Utente A aggiorna i dettagli dipendente per EMPNO = 7839 e tenta di applicare le modifiche nel database.</li>',
'          </ol>',
'          Se l''aggiornamento dello stesso record da parte dell''Utente A riesce, le modifiche apportate dall''Utente B andranno perdute.</p>',
'         <p>Quando l''Utente A tenta di salvare il record del dipendente, i dati nel database sono diversi da quelli su cui l''Utente A ha eseguito la query originale.',
'		  Nel Passo 1 della procedura precedente, i valori di colonna su cui l''Utente A ha eseguito la query originale possono essere acquisiti.',
'		  Nel Passo 4 i valori possono essere confrontati con i valori correnti nel database.',
unistr('		  Il confronto restituir\00E0 un errore per l''Utente A in quanto i valori del database sono stati aggiornati dall''Utente B nel Passo 3.'),
unistr('          Ci\00F2 impedisce che un utente sovrascriva le modifiche apportate da un altro utente alla stessa riga.</p>'),
unistr('		  <p>Nota: l''impostazione Tipo aggiornamento perso verr\00E0 usata solo se nel processo corrispondente, Griglia interattiva - Elaborazione automatica delle righe (DML), l''opzione <strong>Impedisci aggiornamenti persi</strong> \00E8 abilitata.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757499382307202)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna versione di riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887251208307307)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se la tabella di database include una colonna il cui valore aumenta a ogni aggiornamento di un record, preferibilmente da parte di un trigger del database, \00E8 possibile utilizzare tale colonna invece di calcolare i checksum.'),
unistr('        Questa opzione non deve essere utilizzata se la griglia interattiva aggiorna i dati in pi\00F9 tabelle.</p>'),
'        <p>Nota: la colonna delle versioni delle righe deve essere inclusa nell''origine SQL per l''area.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757303985307202)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'it'
,p_message_text=>'Valori riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102887156910307307)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Verr\00E0 calcolato un valore di checksum per ogni riga durante l''esecuzione iniziale della query sui dati.'),
'        Il checksum viene calcolato concatenando tutte le colonne aggiornabili in una stringa per generare un valore univoco.',
unistr('        Quando si esegue il commit del record aggiornato, il checksum calcolato verr\00E0 confrontato con il valore di checksum del record di database corrente.'),
unistr('        Se i due valori non corrispondono, verr\00E0 restituito un errore.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757155338307202)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo aggiornamento perso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296514694307629)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296895293307629)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296732467307629)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296619663307629)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296986801307629)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103296482787307629)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297739947307630)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un corpo funzione Java che restituisca una query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare un alias in tutte le colonne che includono un''espressione SQL.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297631854307630)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297529632307630)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione del nome del reparto, impostazione del numero del reparto</dt>',
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297464361307630)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un corpo funzione JavaScript che restituisca una query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare un alias in tutte le colonne che includono un''espressione SQL.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297300778307630)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892990592307311)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome della lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892851224307311)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622004187307080)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli elementi pagina, applicazione o colonna da impostare nello stato della sessione quando il valore di uno qualsiasi degli elementi padre LOV a catena specificati viene modificato in questa pagina.',
unistr('Quando si specificano pi\00F9 elementi, usare una virgola per separare i nomi.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.</p>'),
'<p>Utilizzare l''elemento o gli elementi di pagina specificati in questo attributo nella <em>clausola WHERE</em> della query SQL di questa lista di valori per limitare i valori restituiti.</p>',
unistr('<p>Nota: gli elementi di pagina definiti in <em>Elementi padre LOV a catena</em> vengono trasmessi in modo automatico, pertanto non \00E8 necessario immetterli in questo attributo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621991687307080)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elementi da sottomettere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297256452307630)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione del nome del reparto, impostazione del numero del reparto.</dt>',
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297196418307630)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un corpo funzione PL/SQL che restituisca una query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare gli alias in tutte le colonne che includono un''espressione SQL.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297018425307630)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297918219307630)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un corpo funzione Python che restituisca una query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare un alias in tutte le colonne che includono un''espressione SQL.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103297886341307630)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360755340307676)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la definizione di query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare gli alias in tutte le colonne che includono un''espressione SQL.</p>',
unistr('<p>Nota: quando si definisce un tipo di elemento LOV popup, se si desidera visualizzare pi\00F9 colonne nel popup, \00E8 necessario definire la lista di valori in Componenti predefiniti'),
unistr('con i necessari metadati aggiuntivi. La lista di valori in linea pu\00F2 essere utilizzata solo per visualizzare colonne singole per le LOV popup.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216567329307569)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la definizione di query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare gli alias in tutte le colonne che includono un''espressione SQL.</p>',
unistr('<p>Nota: quando si definisce un tipo di elemento LOV popup, se si desidera visualizzare pi\00F9 colonne nel popup, \00E8 necessario definire la lista di valori in Componenti predefiniti'),
unistr('con i necessari metadati aggiuntivi. La lista di valori in linea pu\00F2 essere utilizzata solo per visualizzare colonne singole per le LOV popup.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376728190307688)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la definizione di query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare gli alias in tutte le colonne che includono un''espressione SQL.</p>',
unistr('<p>Nota: quando si definisce un tipo di elemento LOV popup, se si desidera visualizzare pi\00F9 colonne nel popup, \00E8 necessario definire la lista di valori in Componenti predefiniti'),
unistr('con i necessari metadati aggiuntivi. La lista di valori in linea pu\00F2 essere utilizzata solo per visualizzare colonne singole per le LOV popup.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103360647969307676)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la definizione di query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare gli alias in tutte le colonne che includono un''espressione SQL.</p>',
unistr('<p>Nota: quando si definisce un tipo di elemento LOV popup, se si desidera visualizzare pi\00F9 colonne nel popup, \00E8 necessario definire la lista di valori in Componenti predefiniti'),
unistr('con i necessari metadati aggiuntivi. La lista di valori in linea pu\00F2 essere utilizzata solo per visualizzare colonne singole per le LOV popup.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579653804307032)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la definizione di query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare gli alias in tutte le colonne che includono un''espressione SQL.</p>',
unistr('<p>Nota: quando si definisce un tipo di elemento LOV popup, se si desidera visualizzare pi\00F9 colonne nel popup, \00E8 necessario definire la lista di valori in Componenti predefiniti'),
unistr('con i necessari metadati aggiuntivi. La lista di valori in linea pu\00F2 essere utilizzata solo per visualizzare colonne singole per le LOV popup.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580933564307033)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la definizione di query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare gli alias in tutte le colonne che includono un''espressione SQL.</p>',
unistr('<p>Nota: quando si definisce un tipo di elemento LOV popup, se si desidera visualizzare pi\00F9 colonne nel popup, \00E8 necessario definire la lista di valori in Componenti predefiniti'),
unistr('con i necessari metadati aggiuntivi. La lista di valori in linea pu\00F2 essere utilizzata solo per visualizzare colonne singole per le LOV popup.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103132018333307494)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione del nome del reparto, impostazione del numero del reparto.</dt>',
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883074359307304)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la definizione di query SQL per popolare questa lista di valori. In genere le query per le liste di valori hanno il formato seguente:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Ogni colonna selezionata deve avere un nome o un alias univoco. Oracle consiglia di utilizzare gli alias in tutte le colonne che includono un''espressione SQL.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102882992181307304)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883431937307305)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere i valori per questa lista di valori statica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883349835307305)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883295112307304)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo della lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269662924307608)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269726351307608)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori dinamica si basa sulla query SQL restituita dal corpo della funzione immessa dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755010278307200)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'it'
,p_message_text=>'Componente condiviso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755192891307200)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori si basa su una la lista di valori predefinita definita nei componenti condivisi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755259762307200)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755332377307200)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori dinamica si basa sulla query SQL immessa dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071851434307450)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071933766307450)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'La lista di valori statica si basa sul valore del testo immesso dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883166953307304)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551560897307006)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il modo in cui viene mantenuto lo stato della sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509047669306965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Per richiesta (solo memoria)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509155758306965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Non salva lo stato nel database. Lo stato \00E8 disponibile solo durante l''elaborazione della richiesta corrente. Quando le richieste AJAX devono usare un elemento, assicurarsi di trasferire il nome dell''elemento tramite "Elementi pagina da sottomettere"')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053937339307436)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'it'
,p_message_text=>'Per utente (disco)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348473049307668)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'it'
,p_message_text=>'Mantenere per un utente memorizzando il valore nel database, per accedervi attraverso le sessioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053837445307436)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Per sessione (disco)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348303360307667)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'it'
,p_message_text=>'Mantenere per ogni sessione memorizzando il valore nel database, per accedervi attraverso le richieste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551451721307006)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mantieni lo stato sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509336181306965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il modo in cui viene mantenuto lo stato della sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509404879306965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Per richiesta (solo memoria)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509514350306965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Non salva lo stato nel database. Lo stato \00E8 disponibile solo durante l''elaborazione della richiesta corrente. Quando le richieste AJAX devono usare un elemento, assicurarsi di trasferire il nome dell''elemento tramite "Elementi pagina da sottomettere"')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509693104306965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Per sessione (disco)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509712754306965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'it'
,p_message_text=>'Mantenere per ogni sessione memorizzando il valore nel database, per accedervi attraverso le richieste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102509228965306965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mantieni lo stato sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826399569307262)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli indicatori di graduazione maggiori vengono visualizzati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826481995307262)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826641920307263)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826575287307262)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826257914307262)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171415004307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171351199307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare il colore di riempimento per visualizzare un cluster di punti.',
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171264473307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore riempimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170608261307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare le classi CSS di icone da utilizzare per visualizzare un cluster di punti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170581575307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170412283307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''URL dell''immagine da utilizzare per visualizzare un cluster di punti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170334879307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170825526307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la forma SVG per visualizzare il cluster di punti. Scegliere tra le forme predefinite o immettere il nome di una <em>forma SVG personalizzata</em>, specificata nell''attributo dell''area di mappa <strong>Stili SVG personalizzati</strong>. Q'
||unistr('uando il nome specificato non \00E8 presente nella lista di stili SVG predefiniti o personalizzati, verr\00E0 usato l''<strong>indicatore predefinito</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204339860307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'it'
,p_message_text=>'Fotocamera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212102396307565)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208954591307563)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'it'
,p_message_text=>'Check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213428148307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204480363307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'it'
,p_message_text=>'Cerchio alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212374810307565)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171033566307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'it'
,p_message_text=>'Cerchio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212265022307565)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204221837307559)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212018565307565)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204515507307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'it'
,p_message_text=>'Faccina accigliata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212477540307565)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204631735307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'it'
,p_message_text=>'Faccina impassibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212596135307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204789809307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'it'
,p_message_text=>'Faccina sorridente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212627212307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209480438307563)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'it'
,p_message_text=>'Bandiera - Stendardo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213938664307567)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209588401307563)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'it'
,p_message_text=>'Bandiera - Doppio stendardo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214064329307567)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205149864307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'it'
,p_message_text=>'Cuore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213143466307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209063108307563)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'it'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213577873307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205286939307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'it'
,p_message_text=>'Pentagono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213255149307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204923163307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'it'
,p_message_text=>'Cerchio fisso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212926145307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205071800307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'it'
,p_message_text=>'Quadrato fisso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213027950307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209208269307563)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'it'
,p_message_text=>'Shine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213714142307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209113625307563)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'it'
,p_message_text=>'Slash'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213640611307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204893043307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'it'
,p_message_text=>'Quadrato alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212846125307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170995855307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'it'
,p_message_text=>'Quadrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103212750911307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209362044307563)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'it'
,p_message_text=>'Street View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213861605307567)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171196334307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'it'
,p_message_text=>'Triangolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103213351357307566)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170717833307525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205452098307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare il fattore di scala in modo che la forma SVG visualizza un cluster di punti. La scala massima \00E8 <strong>10</strong> e il componente mappa arrotonder\00E0 il valore alla prima cifra decimale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103205316638307560)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Scala forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174653580307528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Il raggio cluster in pixel. Se si specifica un valore pari a <strong>80</strong>, i punti all''interno degli 80 pixel di ognuno verranno',
'aggregati in un cluster di punti.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174524640307528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Raggio di configurazione cluster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174795711307528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195452565307553)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da visualizzare come descrizione comandi al passaggio del mouse su un indicatore cluster sulla mappa. Usare i segnaposto <strong>&LAYER.</strong> e <strong>&COUNT.</strong> per fare riferimento al nome del layer e alla q'
||unistr('uantit\00E0 di oggetti mappa nel cluster.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195327126307553)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Descrizione comandi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160982296307517)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Fornire l''informativa sul copyright da posizionare nel pi\00E8 di pagina della mappa. Se il campo \00E8 vuoto, verr\00E0 generata un''informativa relativa alla mappa di sfondo utilizzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160803168307517)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Informativa sul copyright'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162615817307518)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162576508307518)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fornire le definizioni per le forme SVG personalizzate che \00E8 possibile utilizzare come indicatori della mappa. Gli stili definiti qui possono essere usati come attributo <strong>Forma SVG</strong> all''interno di un layer di punti.</p>'),
unistr('<p>La forma SVG deve avere una larghezza e un''altezza pari a <strong>20</strong>. L''indicatore verr\00E0 posizionato sulla mappa in modo che il centro della parte inferiore della forma (coordinata SVG <strong>10</strong>, <strong>20</strong>) punti all''o')
||'ggetto mappa.</p>',
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
'<title id="prop1526_SvgTitle">Gli indicatori SVG hanno una larghezza e un''altezza pari a 20 e puntano alla seguente posizione della mappa: x=10 e y=20.</title>',
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162416650307518)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stili SVG personalizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193167902307551)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che restituisce un valore per determinare l''altezza del poligono estruso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193015694307551)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna valore estrusione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194839424307552)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''unit\00E0 per determinare l''altezza del poligono estruso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195134069307552)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'it'
,p_message_text=>'Piede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195020889307552)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'it'
,p_message_text=>'Chilometro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194935235307552)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'it'
,p_message_text=>'Metro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195226483307552)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'it'
,p_message_text=>'Miglio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194753690307552)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Unit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167350812307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167294552307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare il colore di riempimento.',
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167115047307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore riempimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176194170307529)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se usare una <em>combinazione di colori</em> per questo layer. Una combinazione di colori \00E8 una lista di colori. In base a valori minimi e massimi, il widget Mappa selezioner\00E0 il colore visualizzato effettivo per questo oggetto dalla list')
||'a.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176028261307529)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Usa combinazione di colori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328986709307653)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Lista di colori dal rosso al bianco</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Lista di colori dal blu al nero</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176394225307529)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare una <em>combinazione di colori</em> personalizzata per questo layer. Una combinazione di colori \00E8 una lista di colori. In base a valori minimi e massimi, il widget Mappa selezioner\00E0 il colore visualizzato effettivo per questo oggetto dall')
||'a lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176283283307529)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista di colori personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176538917307529)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che restituisce un valore per determinare il colore visualizzato dallo schema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176467667307529)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna valore colore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167588853307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare l''opacit\00E0 del riempimento. L''intervallo \00E8 compreso tra zero (completamente trasparente) a 1,0 (opaco).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167453902307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Opacit\00E0 riempimento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176738067307529)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la colonna che restituisce il valore per determinare il colore di visualizzazione dallo schema. Se non viene selezionata alcuna colonna, il colore visualizzato verr\00E0 determinato solo a partire dalla densit\00E0 del punto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176650717307529)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172533929307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la finestra informazioni viene visualizzata mediante colonne oppure una formattazione avanzata utilizzando espressioni HTML e stringhe di sostituzione supportate. La finestra informazioni verr\00E0 visualizzata sotto forma di popup quando ')
||'si fa clic su un oggetto nella mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172430126307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formattazione avanzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172993589307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la colonna da utilizzare come corpo per la finestra informazioni che verr\00E0 visualizzata come popup quando si fa clic su un oggetto nella mappa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172859915307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173442724307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi CSS da usare durante la visualizzazione del popup della finestra informazioni. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173316817307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173294867307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Le sostituzioni <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> in questo esempio sono colonne selezionate nella query SQL del report.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173166829307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da visualizzare come popup di informazioni quando si fa clic su un oggetto spaziale. Usare la sintassi <code>&COLUMN.</code> per mostrare i valori di colonna in formato HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173047187307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172764392307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la colonna da utilizzare come titolo per la finestra informazioni che verr\00E0 visualizzata come popup quando si fa clic su un oggetto sulla mappa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172620181307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196327853307553)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Etichetta da utilizzare per la visualizzazione nella legenda o nelle descrizioni comandi. Se non specificata, verr\00E0 usato l''attributo <strong>Nome</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196169540307553)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''etichetta da utilizzare per questo layer nella legenda e nelle descrizioni comandi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196050375307553)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195967832307553)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195866177307553)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare il colore di riempimento dell''indicatore.',
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195708407307553)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore riempimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195643699307553)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare l''opacit\00E0 del riempimento. L''intervallo \00E8 compreso tra zero (completamente trasparente) a 1,0 (opaco).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103195571421307553)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Opacit\00E0 riempimento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193479542307551)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193320183307551)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare il colore del tratto.',
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193265479307551)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore tratto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193690294307551)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare lo spessore del tratto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193576369307551)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Spessore del tratto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173630323307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare per assegnare le righe dall''origine dell''area a questo layer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173599989307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173861284307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Fornire il <em>valore</em> della <strong>colonna Assegnazione righe</strong> che assegna le righe dall''origine dell''area a questo layer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173754583307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore per questo layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166858576307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166716933307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare il colore del tratto.',
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166671155307521)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore tratto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174087546307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare lo stile del tratto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174315735307528)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'it'
,p_message_text=>'Tratteggiata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174202450307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'it'
,p_message_text=>'Punteggiata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174429760307528)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'it'
,p_message_text=>'Tratteggiata a punti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174141189307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'it'
,p_message_text=>'Unita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103173969140307527)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile tratto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167052593307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare lo spessore del tratto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166923783307522)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Spessore del tratto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171649857307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se la descrizione comandi viene visualizzata mediante una colonna oppure una formattazione avanzata utilizzando espressioni HTML e stringhe di sostituzione supportate. La descrizione comandi viene visualizzata quando si passa il mouse su '
||'un oggetto nella mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171544044307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formattazione avanzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171833362307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare come descrizione comandi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171748681307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172391920307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi CSS da utilizzare durante la visualizzazione della descrizione comandi. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172242874307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172131015307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Le sostituzioni <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> in questo esempio sono colonne selezionate nella query SQL del report.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103172022781307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da visualizzare come descrizione comandi al passaggio del mouse su un oggetto nella mappa. Usare la sintassi <code>&COLUMN.</code> per mostrare i valori di colonna in formato HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103171907792307526)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione HTML'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165955272307521)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Colonna che restituisce gli oggetti GeoJSON da visualizzare sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165825842307521)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166122601307521)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Colonna SDO_GEOMETRY che restituisce gli oggetti geometria da visualizzare sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166027464307521)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164580517307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Identificare il tipo di dati della colonna geometria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164874225307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'it'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164913552307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'it'
,p_message_text=>'Tipi GeoJSON, come VARCHAR2 o CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165019633307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'it'
,p_message_text=>'Longitudine/latitudine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165158813307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>'Longitudine e latitudine, come due colonne NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164683203307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'it'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164724121307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'it'
,p_message_text=>'Tipo Oracle SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164464374307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di dati della colonna geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165305271307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'it'
,p_message_text=>'Identificare il tipo di dati della colonna geometria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165465870307521)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'it'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165545079307521)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'it'
,p_message_text=>'Tipi GeoJSON, come VARCHAR2 o CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165609912307521)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'it'
,p_message_text=>'Longitudine/latitudine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165783994307521)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>'Longitudine e latitudine, come due colonne NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103165232035307520)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di dati della colonna geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164367817307520)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Abilitare questa opzione, se la tabella di base ha un indice spaziale e il widget Mappa deve utilizzarlo durante il recupero delle righe dal database. In questo caso, il widget recuperer\00E0 <em>solo</em> le righe relative alla finestra della mappa c')
||unistr('orrente dal database, offrendo un vantaggio a livello di prestazioni quando l''origine dati contiene una grande quantit\00E0 di righe.</p><p>\00C8 possibile creare un indice spaziale in una colonna SDO_GEOMETRY in SQL Workshop.</p>'),
unistr('<p>Tenere presente che <em>non</em> verr\00E0 usato alcun indice spaziale nelle situazioni seguenti:</p>'),
'<ul>',
unistr('<li>Pi\00F9 layer fanno riferimento all''<strong>origine dell''area</strong> come rispettiva origine dati.</li>'),
unistr('<li>La finestra della mappa \00E8 troppo grande, ossia si espande per oltre met\00E0 del mondo.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164209832307520)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Usa indice spaziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166501849307521)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Colonna NUMBER contenente la latitudine degli oggetti spaziali da visualizzare sulla mappa. I valore restituiti devono essere compresi tra -90 e 90.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166478663307521)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna latitudine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182122769307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere una delle combinazione di colori divergenti predefinite. Sono adatte per visualizzare i valori divergenti, passando da un estremo all''altro. Combinazioni di colori da cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartoco'
||'lor" target="_blank">CARTOcolor su GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182232027307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'it'
,p_message_text=>'Da "Army" a Rose'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182365018307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183404526307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'it'
,p_message_text=>'Earht Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183547056307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182451850307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'it'
,p_message_text=>'Fall Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182567454307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182635371307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'it'
,p_message_text=>'Geyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182790757307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183045587307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'it'
,p_message_text=>'Da Teal a Rose'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183173414307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182827460307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'it'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182961057307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183293720307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'it'
,p_message_text=>'Tropic Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183361912307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103182057753307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183705940307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere una delle combinazione di colori qualitative predefinite. Sono adatte per visualizzare colori distinti. Combinazioni di colori da cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor su Gi'
||'tHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183890636307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'it'
,p_message_text=>'Antique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183920995307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184054354307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'it'
,p_message_text=>'Bold'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184115647307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184250539307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'it'
,p_message_text=>'Pastel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184365540307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184450987307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'it'
,p_message_text=>'Prism'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184585103307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184650518307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'it'
,p_message_text=>'Safe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184764467307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184854350307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'it'
,p_message_text=>'Vivid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103184963820307535)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103183602850307534)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome combinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178139726307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere una delle combinazione di colori sequenziali predefinite. Sono adatte per visualizzare i valori sequenziali, passando da un valore minimo a un valore massimo. Combinazioni di colori da cartocolors (<a rel="noreferrer" href="https://github.c'
||'om/CartoDB/cartocolor" target="_blank">CARTOcolor su GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179636806307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'it'
,p_message_text=>'Da Blue a Green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179711481307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180211123307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'it'
,p_message_text=>'Da Blue a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180322974307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181839442307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'it'
,p_message_text=>'Da Brown a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181929787307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178282091307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'it'
,p_message_text=>'Burgundy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178355416307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178446278307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'it'
,p_message_text=>'Da Burgundy a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178554139307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179878303307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'it'
,p_message_text=>'Dark Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179982079307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180004887307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'it'
,p_message_text=>'Emerald'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180105241307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181484253307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'it'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181592359307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179473158307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'it'
,p_message_text=>'Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179567757307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178845348307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'it'
,p_message_text=>'Da Orange a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178969208307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179047178307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'it'
,p_message_text=>'Peach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179118530307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179255455307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'it'
,p_message_text=>'Da Pink a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103179358189307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180802072307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'it'
,p_message_text=>'Purple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180934944307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181024302307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'it'
,p_message_text=>'Da Purple to Orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181133732307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178625779307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'it'
,p_message_text=>'Da Red a Orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178772542307531)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181218880307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'it'
,p_message_text=>'Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181324349307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181672482307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'it'
,p_message_text=>'Dark Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103181727922307533)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180494247307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'it'
,p_message_text=>'Teal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180594362307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180606126307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'it'
,p_message_text=>'Da Teal a Green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103180757985307532)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103178027139307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196703350307554)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196810460307554)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare una lista di colori HTML (#rrggbb), separati da virgole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177340530307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere il tipo di combinazione di colori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177676670307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'it'
,p_message_text=>'Diverging'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177735389307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questa combinazione di colori \00E8 adatta per visualizzare valori divergenti, passando da un estremo all''altro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177861918307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'it'
,p_message_text=>'Qualitative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177907111307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questa combinazione di colori \00E8 adatta per visualizzare valori distinti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177402110307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'it'
,p_message_text=>'Sequential'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177563939307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questa combinazione di colori \00E8 adatta per visualizzare valori sequenziali, passando da un valore minimo a un valore massimo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177297334307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Combinazione di colori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329375789307654)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Lista di colori dal rosso al bianco</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Lista di colori dal blu al nero</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192952370307551)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare una <em>combinazione di colori</em> personalizzata per questo layer di mappa cromatica. Una combinazione di colori \00E8 una lista di colori. In base a valori minimi e massimi, il widget Mappa selezioner\00E0 il colore visualizzato effettivo per ')
||'questo oggetto dalla lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192873013307551)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista di colori personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189934189307548)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere una delle combinazione di colori divergenti predefinite. Sono adatte per visualizzare i valori divergenti, passando da un estremo all''altro. Combinazioni di colori da cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartoco'
||'lor" target="_blank">CARTOcolor su GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190027672307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'it'
,p_message_text=>'Da "Army" a Rose'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190177411307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191213951307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'it'
,p_message_text=>'Earht Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191322286307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190202710307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'it'
,p_message_text=>'Fall Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190303980307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190453092307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'it'
,p_message_text=>'Geyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190512103307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190873059307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'it'
,p_message_text=>'Da Teal a Rose'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190943151307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190604142307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'it'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103190777301307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191021509307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'it'
,p_message_text=>'Tropic Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191119282307549)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189851591307548)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191594286307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere una delle combinazione di colori qualitative predefinite. Sono adatte per visualizzare colori distinti. Combinazioni di colori da cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor su Gi'
||'tHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191631045307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'it'
,p_message_text=>'Antique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191704923307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191817499307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'it'
,p_message_text=>'Bold'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191920527307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192057336307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'it'
,p_message_text=>'Pastel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192135277307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192248821307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'it'
,p_message_text=>'Prism'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192339440307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192499739307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'it'
,p_message_text=>'Safe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192573409307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192640678307551)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'it'
,p_message_text=>'Vivid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103192782678307551)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103191438260307550)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185965806307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere una delle combinazione di colori sequenziali predefinite. Sono adatte per visualizzare i valori sequenziali, passando da un valore minimo a un valore massimo. Combinazioni di colori da cartocolors (<a rel="noreferrer" href="https://github.c'
||'om/CartoDB/cartocolor" target="_blank">CARTOcolor su GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187469760307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'it'
,p_message_text=>'Da Blue a Green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187553829307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188096822307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'it'
,p_message_text=>'Da Blue a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188130619307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189672077307548)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'it'
,p_message_text=>'Da Brown a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189761641307548)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186091911307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'it'
,p_message_text=>'Burgundy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186136046307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186256328307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'it'
,p_message_text=>'Da Burgundy a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186360745307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187607467307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'it'
,p_message_text=>'Dark Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187767350307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187884790307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'it'
,p_message_text=>'Emerald'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187967694307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189220960307548)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'it'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189372829307548)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187218641307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'it'
,p_message_text=>'Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187340106307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186688557307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'it'
,p_message_text=>'Da Orange a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186736976307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186820985307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'it'
,p_message_text=>'Peach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186977595307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187051714307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'it'
,p_message_text=>'Da Pink a Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103187146687307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188699829307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'it'
,p_message_text=>'Purple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188761624307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188823467307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'it'
,p_message_text=>'Da Purple to Orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188915722307539)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186421296307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'it'
,p_message_text=>'Da Red a Orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103186554323307537)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189029449307539)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'it'
,p_message_text=>'Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189179433307539)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189434782307548)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'it'
,p_message_text=>'Dark Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103189519327307548)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188246712307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'it'
,p_message_text=>'Teal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188370346307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188452980307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'it'
,p_message_text=>'Da Teal a Green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103188526961307538)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'it'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185851392307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196997198307554)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197065145307554)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare una lista di colori HTML (#rrggbb), separati da virgole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185130724307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere il tipo di combinazione di colori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185481424307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'it'
,p_message_text=>'Diverging'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185518024307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questa combinazione di colori \00E8 adatta per visualizzare valori divergenti, passando da un estremo all''altro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185636762307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'it'
,p_message_text=>'Qualitative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185733840307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questa combinazione di colori \00E8 adatta per visualizzare valori distinti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185283345307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'it'
,p_message_text=>'Sequential'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185304719307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questa combinazione di colori \00E8 adatta per visualizzare valori sequenziali, passando da un valore minimo a un valore massimo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103185033381307536)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Combinazione di colori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174921825307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Identificare il tipo di questo layer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175640850307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'it'
,p_message_text=>'Mappa cromatica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175779247307529)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Oggetti punto, visualizzati come mappa cromatica. Le mappe cromatiche sono utili per visualizzare la densit\00E0 degli oggetti punto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175262232307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'it'
,p_message_text=>'Linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175398357307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'it'
,p_message_text=>'Oggetti linea.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175096191307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'it'
,p_message_text=>'Punti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175177652307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'it'
,p_message_text=>'Oggetti punto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175415778307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'it'
,p_message_text=>'Poligoni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175506868307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'it'
,p_message_text=>'Oggetti poligono.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175811575307529)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'it'
,p_message_text=>'Poligoni estrusi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103175938727307529)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'it'
,p_message_text=>'Poligoni "estrusi" come oggetti 3D. L''altezza si basa su un valore di colonna dei risultati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103174889785307528)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177198667307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il livello di zoom massimo per mantenere visibile questo layer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103177053886307530)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176958619307529)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il livello di zoom minimo per rendere visibile questo layer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103176875029307529)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166366820307521)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Colonna NUMBER contenente la longitudine degli oggetti spaziali da visualizzare sulla mappa. I valore restituiti devono essere compresi tra -180 e 180.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103166257030307521)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna longitudine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170291678307525)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'it'
,p_message_text=>'Indica se raggruppare in cluster i punti di configurazione del cluster sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170186022307524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Abilita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167710346307522)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Identifica la modalit\00E0 di visualizzazione degli oggetti punto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168041871307523)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'it'
,p_message_text=>'Icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168165917307523)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza come icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167869194307523)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'it'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167971593307523)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza come forma SVG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103167697952307522)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169798426307524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la forma SVG per visualizzare gli oggetti punto. Scegliere tra le forme predefinite o immettere il nome di una <em>forma SVG personalizzata</em>, specificata nell''attributo dell''area di mappa <strong>Stili SVG personalizzati</strong>. Qua'
||unistr('ndo non si specifica alcun nome oppure il nome specificato non \00E8 presente nella lista di forme SVG predefinite o personalizzate, verr\00E0 usata la forma <strong>predefinita</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203083185307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'it'
,p_message_text=>'Fotocamera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210099724307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208227530307562)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'it'
,p_message_text=>'Check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211355311307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203193520307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'it'
,p_message_text=>'Cerchio alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210221605307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169955166307524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'it'
,p_message_text=>'Cerchio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210119031307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103202930050307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103209969059307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203215428307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'it'
,p_message_text=>'Faccina accigliata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210398222307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203341369307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'it'
,p_message_text=>'Faccina impassibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210438510307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203415913307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'it'
,p_message_text=>'Faccina sorridente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210530102307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208735143307563)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'it'
,p_message_text=>'Bandiera - Stendardo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211832198307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208869963307563)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'it'
,p_message_text=>'Bandiera - Doppio stendardo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211933624307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203829321307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'it'
,p_message_text=>'Cuore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211005184307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208322716307562)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'it'
,p_message_text=>'Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211471569307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203970849307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'it'
,p_message_text=>'Pentagono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211155336307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203618990307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'it'
,p_message_text=>'Cerchio fisso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210867788307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203730787307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'it'
,p_message_text=>'Quadrato fisso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210981833307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208554534307563)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'it'
,p_message_text=>'Shine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211602657307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208446787307562)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'it'
,p_message_text=>'Slash'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211554948307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103203561083307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'it'
,p_message_text=>'Quadrato alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210776344307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169886696307524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'it'
,p_message_text=>'Quadrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103210632063307564)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208657386307563)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'it'
,p_message_text=>'Street View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211728299307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103170063077307524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'it'
,p_message_text=>'Triangolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103211271429307565)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'it'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169682459307524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204174780307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare il fattore di scala per la forma SVG. La scala massima \00E8 <strong>10</strong>. Se si utilizza una sostituzione di colonna e il valore \00E8 maggiore di <strong>10</strong>, un messaggio viene scritto nella console JavaScript e l''indicatore vie')
||unistr('ne visualizzato con un fattore di scala pari a <strong>10</strong>. Il componente mappa arrotonder\00E0 il valore alla prima cifra decimale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103204039664307559)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Scala forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169181103307524)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che contiene le classi CSS dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169096646307524)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169597049307524)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>'Classi CSS da utilizzare come origine dell''icona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169409016307524)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169305103307524)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''URL per l''origine dell''immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103169292331307524)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168376733307523)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''origine dell''icona per visualizzare il punto sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168669685307523)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'it'
,p_message_text=>'Colonna classe icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168722208307523)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'it'
,p_message_text=>'Utilizzare singole classi CSS per ogni riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168420136307523)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'it'
,p_message_text=>'Classe icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168528025307523)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'it'
,p_message_text=>'Utilizzare una classe CSS statica per tutte le righe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168887126307523)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'it'
,p_message_text=>'URL immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168985013307523)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'it'
,p_message_text=>'URL di un''immagine da utilizzare per la visualizzazione dei punti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103168271437307523)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Origine icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159119893307515)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'it'
,p_message_text=>'Abilitare o disabilitare varie funzioni del widget mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160274388307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'it'
,p_message_text=>'Recupera posizione browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160354617307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Recupera la posizione corrente dell''utente dal browser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160449879307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'it'
,p_message_text=>'Strumento Cerchio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160505754307517)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'it'
,p_message_text=>'Lo strumento Cerchio consente agli utenti finali di disegnare un cerchio sulla mappa. Al termine, viene attivato un evento in modo che il cerchio possa essere elaborato da azioni dinamiche o da codice JavaScript.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160620352307517)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'it'
,p_message_text=>'Strumento Distanza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160765692307517)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'it'
,p_message_text=>'Consente agli utenti finali di misurare le distanze tra i punti sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160091991307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'it'
,p_message_text=>'Mappa infinita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103160180191307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'it'
,p_message_text=>'Scorrimento mappa infinito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159293044307515)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'it'
,p_message_text=>'Zoom con rotellina del mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159348151307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'it'
,p_message_text=>'Eseguire l''ingrandimento o la riduzione utilizzando la rotellina del mouse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159881740307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'it'
,p_message_text=>'Mappa generale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159934506307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza una mappa di panoramica in basso a destra.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159451025307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'it'
,p_message_text=>'Zoom rettangolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159581907307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'it'
,p_message_text=>'Eseguire lo zoom della mappa in un''area disegnando un rettangolo sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159610445307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'it'
,p_message_text=>'Barra scala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159763918307516)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza una barra di scala sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103159025010307515)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Opzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164038918307519)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare l''altezza dell''area mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163997168307519)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103164186380307520)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162311644307518)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi CSS da aggiungere alla legenda. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162298826307518)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162113834307518)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>'Selettore jQuery per l''elemento in cui visualizzare la legenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162098008307518)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Selettore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161313759307517)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la posizione della legenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161607340307517)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161723731307518)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra la legenda nella posizione finale (in genere al di sotto della mappa).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161811660307518)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'it'
,p_message_text=>'Selettore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161931191307518)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare un selettore jQuery per l''elemento in cui visualizzare la legenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161424722307517)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161506562307517)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra la legenda nella posizione iniziale (in genere al di sopra della mappa).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161293027307517)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196269449307553)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nascondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329138712307654)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Non mostrare i messaggi del layer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162813672307518)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la posizione in cui mostrare i messaggi Nessun dato trovato e Altri dati trovati del layer mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162951237307519)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'it'
,p_message_text=>'In alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163081807307519)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra i messaggi sopra la mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163131878307519)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163298542307519)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra i messaggi sotto la mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163331477307519)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'it'
,p_message_text=>'Selettore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163492059307519)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare un selettore jQuery per l''elemento in cui visualizzare i messaggi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103162700262307518)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione messaggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163618595307519)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>'Selettore jQuery per l''elemento in cui visualizzare i messaggi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163509421307519)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Selettore messaggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161125647307517)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se visualizzare una legenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103161038078307517)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163883076307519)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se si sceglie un elemento di pagina, l''area della mappa conserver\00E0 sempre il riquadro mappa corrente, in formato GeoJSON, come valore di questo elemento. Si tratta di una soluzione utile per connettere la mappa a un altro componente APEX (ad esemp')
||unistr('io, un report classico o interattivo): il contenuto dell''elemento riquadro pu\00F2 essere usato dall''altro componente per eseguire una query spaziale e visualizzare solo i dati visibili sulla mappa.</p>'),
'<p>Contenuto di esempio dell''elemento riquadro dopo uno spostamento della mappa o una modifica del livello di zoom:</p>',
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('Utilizzando un''azione dinamica <strong>Aggiorna</strong>, la mappa pu\00F2 essere connessa a un''area di report. L''area di report pu\00F2 applicare un filtro spaziale per visualizzare solo i risultati visibili sulla mappa.</p>'),
'<p>Query report di esempio:</p>',
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column], ',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] ) ',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103163766276307519)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento riquadro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193843195307551)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il sistema unitario da usare per la barra di scala e lo strumento di distanza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194138401307552)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'it'
,p_message_text=>'Imperiale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194296483307552)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'it'
,p_message_text=>'Usare il sistema imperiale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194301021307552)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Deriva da elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194407883307552)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva il sistema unitario dal valore di un elemento di pagina o di applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193934033307552)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'it'
,p_message_text=>'Metrico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194056894307552)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Usare il sistema metrico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103193791895307551)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sistema unitario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194629530307552)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''elemento di pagina o di applicazione contenente il valore da usare come sistema unitario della mappa: <strong>METRICO</strong> (<strong>M</strong>) o <strong>IMPERIALE</strong> (<strong>I</strong>).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103194537714307552)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento sistema unitario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821354615307258)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se deve essere visualizzato un indicatore sugli elementi dati del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821465814307258)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821637117307259)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821581323307258)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821268656307258)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821850261307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la forma dell''indicatore da visualizzare sugli elementi dati del grafico. Per le serie di intervallo \00E8 supportata solo l''opzione <strong>Automatico</strong>. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821919807307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822053641307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'it'
,p_message_text=>'Cerchio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822140750307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'it'
,p_message_text=>'Rombo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822261085307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'it'
,p_message_text=>'Persona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822336984307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'it'
,p_message_text=>unistr('Pi\00F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822486590307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'it'
,p_message_text=>'Quadrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847610359307278)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'it'
,p_message_text=>'Stella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822542076307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'it'
,p_message_text=>unistr('Triangolo in gi\00F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102822679954307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'it'
,p_message_text=>'Triangolo in su'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102821782206307259)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937702437307348)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se questa colonna \00E8 una colonna chiave esterna per l''area master della griglia interattiva, specificata da <strong>Area master</strong> nelle impostazioni dell''area, selezionare la colonna chiave primaria corrispondente dalla tabella master.</p>'),
'        <p>Si supponga, ad esempio, che l''area master sia DEPT e la griglia interattiva sia EMP: in questo caso si selezionerebbe la colonna DEPTNO all''interno della griglia interattiva EMP e quindi la colonna DEPTNO dalla lista delle colonne DEPT pe'
||'r la colonna master.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937648280307348)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna master'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755578392307200)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare l''area master a cui appartiene quest''area detail.<br>',
unistr('        \00C8 necessario effettuare l''impostazione quando l''area \00E8 l''area detail in una relazione Master-Detail con un''altra area della pagina.</p>'),
'        <p>Per il corretto funzionamento della relazione Master-Detail, selezionare le colonne di quest''area che costituiscono le chiavi esterne per l''area master e specificare <strong>Colonna master</strong> adeguatamente.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102755407122307200)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area master'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867405359307293)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero massimo di righe da visualizzare nel Selettore righe per pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867394361307293)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero massimo di righe per pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198933205307555)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il numero massimo di righe che \00E8 possibile elaborare per questo layer. Pu\00F2 essere utilizzato come misura rispetto a un numero eccessivo di oggetti spaziali scaricati e visualizzati sulla mappa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866629329307292)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il numero massimo di righe che la query potr\00E0 elaborare. Se il numero massimo di righe da elaborare supera il limite, al posto dei dati verr\00E0 visualizzato un messaggio di errore.'),
'Per definire un messaggio personalizzato, specificarne il testo in <strong>Altri dati trovati</strong>.</p>',
'<p>Questo attributo consente di evitare azioni degli utenti finali, ad esempio gli ordinamenti o le aggregazioni, eseguite su tutti i record delle tabelle o delle viste di grandi dimensioni, che hanno un impatto negativo sulle prestazioni.',
unistr('\00C8 invece necessario ridurre il numero dei record da elaborare mediante l''aggiunta di ulteriori filtri.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866570026307292)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero massimo di righe da elaborare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233083577307581)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il componente viene visualizzato mediante una colonna oppure una formattazione avanzata con espressioni HTML e le stringhe di sostituzione supportate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103232948036307581)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formattazione avanzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240824586307586)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235446801307582)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determina la simmetria per il supporto.',
'<strong>Automatico</strong>: utilizza l''adattamento ottimale per conservare le dimensioni originali del supporto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235542880307582)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'it'
,p_message_text=>'Quadrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235623256307583)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica la simmetria quadrata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235787400307583)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'it'
,p_message_text=>'A tutto schermo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235875155307583)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'it'
,p_message_text=>'Applica la simmetria a tutto schermo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235389140307582)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aspetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234413384307582)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che restituisce l''oggetto BLOB per l''origine del supporto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234324372307582)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236612069307583)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236510477307583)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236882033307583)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Questo testo descrive il supporto e pu\00F2 essere utilizzato per le descrizioni comandi e il testo alterativo per le immagini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236701016307583)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Descrizione immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234627510307582)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Determina la posizione del componente supporto sulla scheda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235163631307582)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'it'
,p_message_text=>'Come immagine di sfondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235289089307582)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il supporto come sfondo della scheda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234992821307582)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235031648307582)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il supporto all''interno del corpo della scheda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234766032307582)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'it'
,p_message_text=>'Primo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234888193307582)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il supporto prima dell''intestazione della scheda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234542416307582)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233378012307581)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Le sostituzioni <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> in questo esempio sono colonne selezionate nella query SQL del report.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233262148307581)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da mostrare in questa colonna. Usare la sintassi <code>&COLUMN.</code> per mostrare i valori di colonna in formato HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233107508307581)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236006959307583)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Determina le modalit\00E0 di dimensionamento del supporto all''interno del componente supporto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236360027307583)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'it'
,p_message_text=>'Copertura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236440972307583)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'it'
,p_message_text=>'Regola le dimensioni in modo che il supporto si adatti all''area di visualizzazione specifica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236154550307583)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'it'
,p_message_text=>'Adatta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103236259367307583)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'it'
,p_message_text=>'Regola le dimensioni in modo che il supporto sia contenuto nell''area di visualizzazione specifica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103235977775307583)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensionamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103240785549307586)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessun supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233597490307581)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di origine del supporto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233847825307581)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'it'
,p_message_text=>'Colonna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233723117307581)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'it'
,p_message_text=>'Colonna URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233641828307581)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'it'
,p_message_text=>'URL immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233461561307581)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531173778306987)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il tipo di supporto Internet, ovvero l''identificativo in due parti per i formati di file su Internet.',
unistr('Un tipo di supporto \00E8 composto da almeno due parti: un tipo, un sottotipo e uno o pi\00F9 parametri facoltativi.'),
unistr('Questo tipo di supporto \00E8 utilizzato nell''intestazione HTTP Content-Type quando viene presentata la pagina.</p>'),
'<p>Il tipo di supporto a livello di pagina ha la precedenza su quello a livello di applicazione.',
'Se i valori a livello di pagina e di applicazione per il tipo di supporto sono <code>NULL</code>, viene utilizzato il tipo di supporto <code>text/html</code>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102531051709306987)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234030528307581)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''URL per l''origine del supporto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103233976919307581)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234269775307582)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare come origine del supporto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103234197687307581)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827254739307263)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''incremento tra gli indicatori di graduazione minori. Assume per impostazione automatica un valore nullo per il calcolo automatico basato sui dati. Si applica solo agli assi numerici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827149724307263)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Incremento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827065041307263)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli indicatori di graduazione minori vengono visualizzati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826903192307263)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826824763307263)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''incremento minimo tra gli indicatori di graduazione maggiori. In genere questa opzione viene utilizzata per impedire valori di asse frazionari per le misure discrete.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102826795603307263)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Incremento minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246888211307591)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome del processo di applicazione per semplificare l''identificazione da parte degli sviluppatori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628315624307085)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome utilizzato dagli sviluppatori di applicazioni per fare riferimento a questo schema di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567808328307021)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome univoco che identifichi questo schema di autorizzazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641577545307095)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome della diramazione per semplificarne l''identificazione da parte degli sviluppatori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678402877307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo modello di indicatore di percorso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567746448307021)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome per questa opzione di creazione. Le opzioni di creazione sono impostazioni predefinite che determinano se i componenti all''interno di un''applicazione sono abilitati o meno.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678106202307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo modello di pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678523061307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo modello di indicatore di calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568430007307022)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome dell''azione dinamica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678283980307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo modello di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102864666999307291)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il nome del gruppo di colonne. Il nome immesso verr\00E0 visualizzato come intestazione di area nella vista dettagliata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678340812307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo modello di lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198471426307555)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo componente. Usare l''attributo <strong>Etichetta</strong> se sono necessari il formato HTML o le sostituzioni per la visualizzazione dell''etichetta nell''area mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102567922353307021)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome della pagina corrente. Questo nome viene utilizzato in numerosi report e pagine di &PRODUCT_NAME., insieme al numero di pagina e al titolo della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568260001307022)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome del gruppo di pagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102569093916307022)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il nome del processo di pagina per semplificare l''identificazione da parte degli sviluppatori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677947023307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo modello di pagina specifico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678033281307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo modello di area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678671839307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per questo modello di report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677836979307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un breve nome descrittivo per il tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678743667307128)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un nome per questa interfaccia utente. Il nome immesso verr\00E0 visualizzato nelle procedure guidate, quale ad esempio Crea tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641274900307094)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il nome della convalida. Deve essere un nome descrittivo per consentire agli sviluppatori di identificare con facilit\00E0 le condizioni controllate.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527911846306984)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome descrittivo per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102527888386306984)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542972107306998)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome di una lista di valori esistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102542827988306998)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154875893307512)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere la posizione della barra di navigazione sulla mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155173916307512)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155235105307512)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra la barra di navigazione nella posizione finale (in genere sul lato destro) della mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154966215307512)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'it'
,p_message_text=>'Inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103155024622307512)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra la barra di navigazione nella posizione iniziale (in genere sul lato sinistro) della mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154775982307512)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154077454307511)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Tipo di barra di navigazione da utilizzare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154528279307512)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'it'
,p_message_text=>'Zoom e bussola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154685736307512)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'it'
,p_message_text=>'Controlli zoom e bussola per controllare l''orientamento della mappa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154129784307511)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154252119307511)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'it'
,p_message_text=>'Nessuna barra di navigazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154388530307511)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'it'
,p_message_text=>'Solo zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103154442882307511)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'it'
,p_message_text=>'Solo controlli Ingrandisci e Riduci.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153924739307511)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411018640307717)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Non mostrare lista menu di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667995303307118)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la lista di menu di navigazione utilizzata per la navigazione in questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667844953307118)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410523858307717)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione per la lista del menu di navigazione in questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410710391307717)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'it'
,p_message_text=>'Laterale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410678983307717)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'it'
,p_message_text=>'Inizio pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410454348307717)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668150152307119)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il modello di lista di menu di navigazione utilizzato con la lista di menu di navigazione in questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668087670307118)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello di lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410931298307717)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Selezionare le opzioni di modello per personalizzare l''interfaccia utente di questa lista di navigazione.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103410891674307717)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Opzioni modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224184103307574)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione di una freccia che punta a destra</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103224034756307574)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere le classi per l''icona che si desidera aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.</p>'),
'        <p>Se il tema utilizza il carattere APEX, fare riferimento all''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a> per visualizzare le icone e i modificatori disponibili.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103223959420307574)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Icona Nessun dato trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408229589307715)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo da visualizzare all''interno dell''opzione NULL della lista nella parte superiore di questa lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216626535307569)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo da visualizzare all''interno dell''opzione NULL della lista nella parte superiore di questa lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579714836307032)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo da visualizzare all''interno dell''opzione NULL della lista nella parte superiore di questa lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581014280307033)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo da visualizzare all''interno dell''opzione NULL della lista nella parte superiore di questa lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543555788306999)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo da visualizzare nell''opzione NULL all''inizio di questa lista. Questo valore viene visualizzato anche durante il rendering dell''elemento se il valore \00E8 nullo. Se non si immette alcun testo, nella lista verr\00E0 visualizzata una riga vu')
||unistr('ota e in fase di rendering verr\00E0 visualizzato un elemento vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543496476306999)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore visualizzato NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543762885306999)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il valore da restituire quando viene selezionato il valore NULL in questa lista di valori. Se non si fornisce un valore, il valore dell''elemento rimarr\00E0 nullo quando verr\00E0 selezionata l''opzione NULL in questa lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102543635905306999)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore restituito NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901965207307318)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero di righe da visualizzare per ogni pagina del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901876222307318)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902192229307318)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''elemento il cui valore specifica il numero di righe da visualizzare per ogni pagina del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902084439307318)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901782354307318)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la modalit\00E0 di immissione del numero di righe per questo report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082031792307457)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'In base a valore elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081959362307457)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901647962307318)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo numero di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538851889306994)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una destinazione URL per i casi in cui un utente finale tenta di sottomettere una seconda volta la stessa pagina. &PRODUCT_NAME. visualizza un messaggio di errore e un collegamento a questo URL per consentire all''utente di continuare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538779494306994)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'In caso di sottomissioni di pagina duplicate, andare a questo URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930117468307342)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se la pagina o l''URL sostituisce la pagina corrente o se il collegamento viene aperto in una finestra di dialogo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089441941307463)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089364206307462)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'it'
,p_message_text=>'Stessa finestra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102930073847307342)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Apri collegamento in'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853910550307283)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Operazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742832538307188)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Durante l''accesso alla tabella <code>employee</code>, tentativo di uso dell''indice <code>emp_department_ix</code></dt>',
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
'<dt>Abilitazione dell''uso della clausola <code>WITH plsql_declarations</code> all''interno della query SQL</dt>',
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742759562307188)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il suggerimento dell''ottimizzatore Oracle che viene aggiunto all''istruzione di livello superiore durante l''esecuzione della query SQL.',
unistr('        Per suggerimento si intende un''istruzione data all''ottimizzatore. Durante la scrittura del codice SQL, \00E8 possibile disporre di informazioni sui dati sconosciute all''ottimizzatore. I suggerimenti consentono di prendere decisioni normalmente pr')
||'ese dell''ottimizzatore,',
unistr('        inducendo a volte l''ottimizzatore a selezionare un piano considerato pi\00F9 dispendioso.</p>'),
unistr('        <p>Ad esempio, si potrebbe sapere che un determinato indice \00E8 pi\00F9 selettivo per certe query. Sulla base di tali informazioni, si potrebbe scegliere un piano di esecuzione pi\00F9 efficiente di quello scelto dall''ottimizzatore.'),
'        In casi del genere, utilizzare i suggerimenti per indurre l''ottimizzatore a usare il piano di esecuzione ottimale.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742621126307188)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Suggerimento ottimizzatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415205688307721)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare una colonna indicizzata mediante un indice Oracle Text.</p>',
'<p>La ricerca delle righe restituisce i risultati in base all''operatore Oracle Text immesso, a condizione che l''indice Oracle Text corrispondente sia stato creato per la colonna.',
unistr('Questa opzione deve essere abilitata solo se l''indice necessario esiste gi\00E0 e se gli utenti finali hanno ricevuto una formazione su come utilizzare gli operatori di ricerca Oracle Text.'),
unistr('Per rendere pi\00F9 semplice la sintassi di Oracle Text per gli utenti finali, \00E8 possibile specificare una funzione per l''impostazione componente <em>Nome funzione PL/SQL Oracle Text</em> delle griglie interattive nei componenti condivisi.<br>'),
'Consultare la <a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">Guida per gli sviluppatori di applicazioni Oracle Text</a>.</p>',
'<p>Nota: l''immissione corretta degli operatori Oracle Text da parte degli utenti finali garantisce prestazioni di ricerca di gran lunga superiori.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415120475307721)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna indice Oracle Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246501329307591)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice cleanup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246496381307591)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice inizializzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805121868307246)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''orientamento di questo grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805203429307246)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'it'
,p_message_text=>'Orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935879027307346)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza orizzontalmente gli elementi grafici nel grafico. Le barre di un grafico a barre, ad esempio, verranno visualizzate orizzontalmente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935617264307346)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'it'
,p_message_text=>'Verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935712727307346)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza verticalmente gli elementi grafici nel grafico. Le barre di un grafico a barre, ad esempio, verranno visualizzate verticalmente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805026389307246)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Orientamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102815051884307254)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere in pixel (ad esempio 50px) o sotto forma di valore percentuale (ad esempio 15%) l''altezza della barra di scorrimento di panoramica da visualizzare nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814978911307253)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814884102307253)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se una barra di scorrimento di panoramica deve essere visualizzata nel grafico.',
unistr('        Attualmente questa opzione \00E8 supportata solo per i grafici A barre verticali, A linee, Ad aree, A linee con area, Borsistici e Combinati.</p>'),
unistr('        <p>Nota: per visualizzare la barra di scorrimento di panoramica \00E8 necessario abilitare l''opzione <strong>Ingrandimento e scorrimento</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102814765051307253)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667797009307118)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specifica se la navigazione a livello di interfaccia utente predefinita viene sovrascritta. \00C8 possibile farne uso per non disporre della navigazione per la pagina corrente oppure per scegliere una navigazione alternativa per la pagina corrente (ad es')
||unistr('empio per fornire modalit\00E0 di navigazione differenti intorno a una sezione secondaria dell''applicazione).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667697937307118)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ignora livello interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538466113306994)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di protezione dello stato della sessione implementato per questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039636198307424)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'it'
,p_message_text=>'Gli argomenti devono avere checksum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039765663307425)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se l''URL contiene gli argomenti di richiesta, svuotamento cache o coppie nome-valore, \00E8 necessario fornire anche un checksum.<br>'),
unistr('Il tipo del checksum deve essere compatibile con l''attributo <em>Protezione stato sessione</em> pi\00F9 severo tra tutti gli elementi passati come argomenti.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040016306307425)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'it'
,p_message_text=>'Nessun accesso URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103040139872307425)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Non \00E8 possibile accedere a questa pagina utilizzando un URL.<br>'),
unistr('La pagina pu\00F2 essere tuttavia la destinazione di un tipo di diramazione <em>Dirama a pagina</em> in quanto questo tipo di diramazione non esegue un reindirizzamento URL.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039448030307424)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Non limitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039551876307424)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina pu\00F2 essere richiesta utilizzando un URL, con o senza argomenti di stato della sessione, e senza avere necessariamente un checksum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039817759307425)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'it'
,p_message_text=>'Nessun argomento supportato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103039928662307425)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile utilizzare un URL per richiedere la pagina, ma l''URL non pu\00F2 contenere gli argomenti di richiesta, svuotamento cache o coppie nome-valore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538374585306994)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Protezione accesso pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529370885306986)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere un alias alfanumerico per questa pagina. L''alias immesso pu\00F2 essere utilizzato al posto del numero della pagina per fare riferimento alla pagina.'),
unistr('Ad esempio, se si sta utilizzando la pagina 1 dell''applicazione 100, \00E8 possibile creare un alias denominato <code>home</code>.'),
unistr('Sar\00E0 quindi possibile accedere a questa pagina da altre pagine utilizzando la seguente sintassi f?p:'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529213608306986)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Alias di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102538044936306994)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Specificare se questa pagina \00E8 pubblica o se richiede l''autenticazione.'),
unistr('Se viene identificata come pubblica, la pagina pu\00F2 essere visualizzata da qualsiasi utente in grado di accedervi.'),
unistr('La funzione sentry di pagina dell''applicazione pu\00F2 accedere a questo attributo di pagina per identificare le pagine che non richiedono l''autenticazione prima della visualizzazione.'),
'L''implementazione della funzione sentry di pagina dello schema di autenticazione determina se questo attributo ha effetto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038829341307424)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'La pagina richiede l''autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038908329307424)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina \00E8 pubblica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537905149306994)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529532495306986)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare il gruppo di pagine da associare a questa pagina.',
unistr('I gruppi di pagine non hanno effetto sulla funzionalit\00E0, ma consentono agli sviluppatori di gestire meglio le pagine all''interno di un''applicazione.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529430059306986)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Gruppo di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102537001956306993)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere il testo che andr\00E0 a sostituire la stringa di sostituzione <code>#ONLOAD#</code> del modello di pagina.'),
unistr('Per utilizzare questa funzione, \00E8 necessario che il modello di pagina includa la stringa di sostituzione <code>#ONLOAD#</code>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102536932537306993)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributo corpo HTML della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529788274306986)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la modalit\00E0 per questa pagina.</p>'),
'#LOV_VALUES#',
'<p>Le opzioni <em>Finestra di dialogo modale</em> e <em>Finestra di dialogo non modale</em> possono essere selezionate solo se il tema corrente dell''applicazione contiene un <em>modello di pagina di finestra di dialogo</em> predefinito.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037948008307423)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo modale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038031249307423)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'La pagina viene presentata come finestra di dialogo di tipo modale.<br>',
unistr('Per finestra di dialogo di tipo modale si intende una finestra overlay posizionata nel viewport, che rimane attiva finch\00E9 l''utente non avr\00E0 finito di utilizzarla e la chiuder\00E0.'),
unistr('La pagina sottostante \00E8 disattivata e l''utente non potr\00E0 interagire con il resto della pagina finch\00E9 la finestra di dialogo non verr\00E0 chiusa.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038197817307423)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo non modale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103038215237307423)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'La pagina viene presentata come finestra di dialogo di tipo non modale.<br>',
unistr('Per finestra di dialogo di tipo non modale si intende una finestra overlay posizionata nel viewport in cui l''utente finale pu\00F2 interagire con la finestra di dialogo e con il contenuto della relativa pagina di avvio.'),
unistr('Una pagina non modale pu\00F2 essere utilizzata quando le informazioni richieste non sono essenziali per continuare e quindi la finestra pu\00F2 essere lasciata aperta quando si continua a lavorare altrove.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037720783307423)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103037891000307423)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina viene presentata come pagina normale dell''applicazione &PRODUCT_NAME..'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529671841306986)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103379220800307690)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738282135307184)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare il tipo di processo eseguito. Sono supportati i tipi di processo seguenti:</p>',
'#NATIVE_PLUGINS#',
'<p>A seconda della configurazione dell''applicazione, qui potrebbero essere disponibili plugin per il tipo di processo aggiuntivi.',
'Questi plugin vengono visualizzati con il formato <em>&lt;My Plug-in&gt; [plugin]</em>.',
'I plugin seguenti vengono installati nei componenti condivisi dell''applicazione:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561179699307015)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362369279307678)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione PL/SQL che restituisca il valore usato come origine per questo parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362243742307678)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362189340307677)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato come origine per questo parametro. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362026350307677)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362538562307678)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere uno o pi\00F9 elementi di pagina o di applicazione da utilizzare come destinazione per questo parametro. Quando si specificano pi\00F9 elementi, usare una virgola per separare i nomi.</p>'),
unistr('<p>\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103362463124307678)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363706315307679)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''origine per il parametro dalla lista disponibile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364240012307679)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364337331307679)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dal <em>corpo funzione PL/SQL</em> immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363896308307679)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363989660307679)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364031205307679)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103364108664307679)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul testo immesso in <em>Valore statico</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103363667221307678)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886086481307307)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore per questo parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885906164307306)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913797925307330)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529928694306986)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare un modello di pagina per definire l''aspetto e il layout di questa pagina.</p>',
'        <p>I modelli di pagina sono definiti nel tema dell''applicazione.',
'        Quando si crea una pagina, il modello viene impostato in modo automatico su <em>Impostazione predefinita tema</em>, che prevede la visualizzazione della pagina mediante il modello di pagina predefinito presente nel tema corrente.',
unistr('        La selezione effettuata qui ha la priorit\00E0 sul modello di pagina predefinito.</p>'),
unistr('        <p>Numerosi temi contengono modelli di pagina per scopi specifici, ad esempio la visualizzazione di contenuto con colonne laterali, della pagina di login, di pagine di dialogo e cos\00EC via.<br>'),
'        Nel tema universale sono disponibili i modelli di pagina descritti di seguito.',
'          <dl>',
'            <dt>Standard</dt>',
'              <dd>Si tratta del modello di pagina predefinito, ideale per le home page, i dashboard, i report di grandi dimensioni e i layout in cui si desidera sfruttare le dimensioni massime dello schermo.</dd>',
'            <dt>Colonna sinistra</dt>',
'              <dd>Fornisce una posizione di visualizzazione a sinistra utile per le pagine di ricerca e dei filtri.</dd>',
'            <dt>Colonna destra</dt>',
'              <dd>Fornisce una posizione di visualizzazione a destra comprimibile utile per visualizzare i controlli orientati ad azioni, quali ad esempio i pulsanti o le liste.</dd>',
'            <dt>Colonne sinistra e destra</dt>',
'              <dd>Fornisce sia la colonna sinistra che la colonna destra comprimibile, adatte per le pagine molto complesse.</dd>',
'            <dt>Login</dt>',
'              <dd>Usato esclusivamente per la pagina di login all''applicazione.</dd>',
'            <dt>Testo scorrevole</dt>',
'              <dd>Fornisce una colonna destra comprimibile e un''area con barra del titolo che contiene le informazioni principali.',
unistr('              Questo modello di pagina \00E8 particolarmente adatto per la visualizzazione di un solo record con numerosi report o dati correlati.'),
'              Il testo scorrevole viene comunemente utilizzato per la visualizzazione delle relazioni Master-Detail in cui un singolo record viene selezionato per primo da un report. </dd>',
'            <dt>Minimo (nessuna navigazione)</dt>',
unistr('              <dd>Utile per pagine molto semplici, dichiarazioni di non responsabilit\00E0, applicazioni con pagine singole o laddove la navigazione non \00E8 necessaria.</dd>'),
'          </dl>',
'          Vedere anche: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102529829054306986)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102913974542307330)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354986015307672)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Usa l''impostazione definita nelle impostazioni predefinite del tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530717838306987)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare la transizione che dovr\00E0 essere utilizzata durante la navigazione a una nuova pagina o quando la pagina viene sottomessa.</p>'),
'<p>I browser meno recenti, che non supportano le trasformazioni 3D, non sono in grado di utilizzare la maggior parte delle transizioni.',
'Per impostazione predefinita, i dispositivi privi di supporto 3D, quale ad esempio Android 2.x, usano la dissolvenza per tutti i tipi di transizione.',
'Vedere la documentazione jQuery Mobile per informazioni dettagliate.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042833551307427)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'it'
,p_message_text=>'Dissolvenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042984925307427)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'it'
,p_message_text=>'Capovolgi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043042781307427)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'it'
,p_message_text=>'Flusso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103042793194307427)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043182712307427)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'it'
,p_message_text=>'Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043225621307427)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'it'
,p_message_text=>'Spostamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043387080307427)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'it'
,p_message_text=>'Sposta in basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043428621307427)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'it'
,p_message_text=>'Sposta con dissolvenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043519414307428)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'it'
,p_message_text=>'Sposta in alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043626262307428)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'it'
,p_message_text=>'Rotazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530634791306987)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Transizione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218832928307570)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se l''utente viene avvisato quando si tenta di passare ad altro contenuto e lasciare la pagina che contiene modifiche non salvate.',
unistr('        Anche Elementi pagina e Pulsanti offrono un controllo pi\00F9 accurato su quando viene effettuata questa verifica e su cosa \00E8 incluso.'),
unistr('        Per Pulsanti, \00E8 possibile specificare se la verifica verr\00E0 eseguita quando viene fatto clic sul pulsante.'),
unistr('        Per Elementi pagina, \00E8 possibile specificare se le modifiche apportate all''elemento vengono incluse nella verifica o ignorate (per entrambi, vedere l''attributo <em>Avvisa in presenza di modifiche non salvate</em>).</p>'),
'        <p>Nota: non applicabile a un utente finale che chiude la pagina di una finestra di dialogo Modale.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218730164307570)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Avvisa in presenza di modifiche non salvate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866283074307292)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il punto in cui visualizzare l''impaginazione del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067489755307446)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'it'
,p_message_text=>'In basso - A sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067500643307446)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'In basso - A destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067857146307447)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'it'
,p_message_text=>'In alto e in basso - A sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067926563307447)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'In alto e in basso - A destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067676826307446)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'it'
,p_message_text=>'In alto - A sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103067707350307447)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'In alto - A destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866162894307292)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103378915813307690)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'it'
,p_message_text=>'ID parametro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850496605307280)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se il parametro \00E8 obbligatorio e deve essere sempre impostato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850383101307280)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Richiesto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850683087307280)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore predefinito o statico per questo parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102850530451307280)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586264228307038)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessun padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545246110307000)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''area padre in cui verr\00E0 visualizzata l''area.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545149875307000)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901537000307318)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se usare la funzione di aggiornamento pagina parziale (PPR) per aggiornare la visualizzazione del report.</p>',
'Se l''utente finale esegue un''azione, quale ad esempio una richiesta di impaginazione o la selezione di una nuova colonna di ordinamento, le righe correnti del report devono essere aggiornate. L''impostazione di questo attributo su <strong>Attivo</stro'
||unistr('ng> fa s\00EC che venga aggiornata solo l''area del report, mentre l''impostazione dell''attributo su <strong>Non attivo</strong> comporta l''aggiornamento dell''intera pagina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901483701307318)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento pagina parziale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103078549733307455)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897024805307315)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per lo sfondo del grafico.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896912609307314)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore sfondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897487525307315)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la larghezza in pixel per questo grafico a barre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897316984307315)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924366953307338)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'it'
,p_message_text=>'pixel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129037475307492)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897255826307315)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per il primo piano del grafico.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102897179509307315)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore primo piano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809347112307249)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la frazione dell''intero grafico a torta al di sotto della quale le porzioni vengono aggregate in una porzione "Altro". I valori validi sono compresi tra 0 (impostazione predefinita) e 1.</p>',
'        <p>Ad esempio, il valore 0.15 comporta l''aggregazione nella porzione "Altro" di tutte le porzioni con dimensioni inferiori al 15% della torta.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809294295307249)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Soglia Altro grafico a torta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839908254307273)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''effetto che dovr\00E0 essere applicato alla selezione di una porzione del grafico a torta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840013080307273)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'it'
,p_message_text=>'Esplodi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840237112307273)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'it'
,p_message_text=>'Evidenzia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840167047307273)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'it'
,p_message_text=>'Evidenzia ed esplodi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839831358307273)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Effetto selezione torta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918395712307334)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione PL/SQL che fornisce un valore per la chiave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918215989307333)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918578021307334)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome per la chiave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918465753307334)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918185604307333)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di origine per la chiave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085443229307460)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085512566307460)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'it'
,p_message_text=>'Sequenza esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085361389307460)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'it'
,p_message_text=>'Trigger esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102918049262307333)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002471201307396)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere la query SQL da utilizzare al posto di una query generata in modo automatico per selezionare i valori delle singole colonne. La query SQL deve restituire una colonna. L''immissione di una query SQL pu\00F2 migliorare le prestazioni in alcuni rep')
||'ort. Questa lista di valori viene visualizzata quando un utente fa clic su un''intestazione di colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002353600307396)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103002065230307396)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare le modalit\00E0 di derivazione della lista di valori per il filtro nell''elenco a discesa delle colonne del report.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090474187307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori denominata per filtrare le corrispondenze esatte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090564368307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva la lista di valori da una lista di valori denominata per creare un filtro di uguaglianza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090634882307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori denominata per filtrare le parole contenute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090787981307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva la lista di valori da una lista di valori denominata per creare un filtro di parole contenute.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090294788307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori definita per filtrare le parole contenute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090361458307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva la lista di valori da una query SQL su una lista di valori definita per creare un filtro di parole contenute.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089880179307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita in base al tipo di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089945768307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'it'
,p_message_text=>'Le colonne STRING e NUMBER derivano la lista di valori da valori di colonna distinti. Le colonne DATE derivano la lista di valori da intervalli di data predefiniti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089616695307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103089791262307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>'Disabilita il filtro sulla lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090045983307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori definita per filtrare le corrispondenze esatte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090197448307463)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'it'
,p_message_text=>'Deriva la lista di valori da una query SQL su una lista di valori definita per creare un filtro di uguaglianza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001903689307395)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246957826307591)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice PL/SQL da eseguire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856283043307285)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice PL/SQL da eseguire sul database remoto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856152262307284)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice PL/SQL per generare l''output HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622955080307081)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''origine PL/SQL utilizzata in questo schema di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622845790307081)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855645307307284)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare dove viene eseguito il processo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855796620307284)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'it'
,p_message_text=>'Database locale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855822822307284)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'it'
,p_message_text=>'Il codice PL/SQL viene eseguito nel database locale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855954795307284)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'it'
,p_message_text=>'SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856050409307284)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'it'
,p_message_text=>'Il codice PL/SQL viene eseguito in un database remoto, con connessione definita mediante SQL abilitato per REST. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855507283307284)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737338798307183)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la categoria in cui viene visualizzato il plugin nell''interfaccia utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063331695307443)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'it'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063402742307443)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'it'
,p_message_text=>'Effetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063541922307443)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'it'
,p_message_text=>'Esegui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063632826307443)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'it'
,p_message_text=>'Inizializza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063776266307443)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'it'
,p_message_text=>'Varie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063895749307443)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'it'
,p_message_text=>'Navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063906474307443)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'it'
,p_message_text=>'Notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103064040759307444)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'it'
,p_message_text=>'Stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737210656307183)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Categoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389404904307698)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Immettere il codice JavaScript che \00E8 possibile eseguire. Nota: il funzionamento specifico del codice dipende dal plugin corrente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103389349381307698)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice di inizializzazione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914016070307330)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355091164307672)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Usa l''impostazione definita nelle impostazioni predefinite del tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530903220306987)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare la transizione utilizzata all''apertura di un popup.</p>',
'<p>I browser meno recenti, che non supportano le trasformazioni 3D, non sono in grado di utilizzare la maggior parte delle transizioni.',
'Per impostazione predefinita, i dispositivi privi di supporto 3D, quale ad esempio Android 2.x, usano la dissolvenza per tutti i tipi di transizione.',
'Vedere la documentazione jQuery Mobile per informazioni dettagliate.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043825987307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'it'
,p_message_text=>'Dissolvenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043999719307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'it'
,p_message_text=>'Capovolgi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044023092307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'it'
,p_message_text=>'Flusso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103043759650307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044124854307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'it'
,p_message_text=>'Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044227706307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'it'
,p_message_text=>'Spostamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044391884307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'it'
,p_message_text=>'Sposta in basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044432535307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'it'
,p_message_text=>'Sposta con dissolvenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044598305307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'it'
,p_message_text=>'Sposta in alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103044647729307428)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'it'
,p_message_text=>'Rotazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530812858306987)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Transizione popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623985146307082)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere il nome della procedura che la procedura di login (interfaccia API di login) di &PRODUCT_NAME. dovr\00E0 eseguire dopo il passo di autenticazione (verifica delle credenziali di login).'),
'La procedura di login esegue questo codice dopo l''esecuzione delle normali operazioni della procedura di login, tra cui l''impostazione di un cookie e la registrazione della sessione, ma immediatamente prima del reindirizzamento alla pagina dell''appli'
||'cazione desiderata.',
unistr('La procedura pu\00F2 essere definita nell''attributo "Codice PL/SQL" o nel database.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623857672307082)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome procedura post-autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551353140307006)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un''espressione PL/SQL per definire meglio il valore dell''elemento.</p>',
unistr('<p> Ad esempio, se l''elemento \00E8 denominato <code>P1_X</code>, per impostarne il valore finale \00E8 possibile utilizzare espressioni successive al calcolo come <code>UPPER(:P1_X)</code>, <code>INITCAP(:P2_Y)</code>, <code>MIN(:P1_X, :P2_Y - 200)</code>, ')
||'<code>NVL(:P1_X, :P2_Y)</code> o una chiamata di funzione come <code>my_func(:P1_X)</code>.',
'Tenere presente che questi esempi dimostrano che le espressioni possono fare riferimento all''elemento corrente o a qualsiasi altro elemento nello stato di sessione.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551251767307006)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Calcolo successivo al calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624346291307082)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''URL al quale verr\00E0 reindirizzata l''applicazione dopo che &PRODUCT_NAME. avr\00E0 eseguito il cleanup della sessione utente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102624244528307082)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'URL successivo al logout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301364702307633)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301610937307633)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301573228307633)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301497935307633)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301748215307633)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301290754307633)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302529419307634)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java in cui la query SQL restituita trasformi i dati recuperati dall''origine Web. La query SQL restituita dal corpo funzione Java deve effettuare la selezione dalla pseudotabella #APEX$SOURCE_DATA# e leggere le colonne dis'
||unistr('ponibili nel profilo dati. La fattorizzazione subquery con uso della clausola WITH SQL non \00E8 supportata qui. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302418572307634)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302365098307634)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selezione delle colonne EMPNO, ENAME e SAL e applicazione del filtro per filtrare tutte le righe con valore SAL minore di 3000.</dt>',
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302294701307634)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript in cui la query SQL restituita trasformi i dati recuperati dall''origine Web. La query SQL restituita dal corpo funzione JavaScript deve effettuare la selezione dalla pseudotabella #APEX$SOURCE_DATA# e leggere le'
||unistr(' colonne disponibili nel profilo dati. La fattorizzazione subquery con uso della clausola WITH SQL non \00E8 supportata qui. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302197238307634)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356880923307674)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Visualizzazione delle assunzioni pi\00F9 recenti per prime e delle persone non ancora assunte per ultime. Se la data \00E8 uguale, l''ordinamento si basa sul numero di reparto.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356715679307674)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere uno o pi\00F9 nomi di colonna separati da virgole, con le direttive, per definire l''ordine di recupero dei record.</p>'),
'        <p>Le direttive disponibili sono:',
'          <ul>',
'            <li>ASC: restituisce la colonna in ordine crescente;</li>',
'            <li>DESC: restituisce la colonna in ordine decrescente;</li>',
'            <li>NULLS FIRST: restituisce le colonne senza valori prima di quelle con valori;</li>',
'            <li>NULLS LAST: restituisce le colonne con valori prima di quelle senza valori.</li>',
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356601496307673)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ordina per'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302061009307634)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selezione delle colonne EMPNO, ENAME e SAL e applicazione del filtro per filtrare tutte le righe con valore SAL minore di 3000.</dt>',
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301969972307633)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo della funzione PL/SQL in cui la query SQL restituita trasformi i dati recuperati dall''origine Web. La query SQL restituita dal corpo della funzione PL/SQL deve effettuare la selezione dalla pseudotabella #APEX$SOURCE_DATA# e legger'
||unistr('e le colonne disponibili nel profilo dati. La fattorizzazione subquery con uso della clausola WITH SQL non \00E8 supportata qui. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301882946307633)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302766933307634)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python in cui la query SQL restituita trasformi i dati recuperati dall''origine Web. La query SQL restituita dal corpo funzione Python deve effettuare la selezione dalla pseudotabella #APEX$SOURCE_DATA# e leggere le colonne'
||unistr(' disponibili nel profilo dati. La fattorizzazione subquery con uso della clausola WITH SQL non \00E8 supportata qui. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302613078307634)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358363722307675)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selezione delle colonne EMPNO, ENAME e SAL e applicazione del filtro per filtrare tutte le righe con valore SAL minore di 3000.</dt>',
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103357068709307674)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query SQL per trasformare i dati recuperati dall''origine dati REST. Effettuare la selezione dalla pseudotabella #APEX$SOURCE_DATA# e specificare le colonne disponibili nel profilo dati. La fattorizzazione subquery con uso della clausola'
||unistr(' WITH SQL non \00E8 supportata qui.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356968944307674)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356597271307673)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Inclusione limitata ai dipendenti con responsabile o che sono venditori.</dt>',
'<dd><pre>',
unistr('( MGR non \00E8 nullo o JOB = ''SALESMAN'' )'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356411105307673)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una condizione Where SQL valida da utilizzare per limitare il numero dei record recuperati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356301832307673)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Clausola Where'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623713839307081)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome della procedura da eseguire dopo la sottomissione della pagina di login e immediatamente prima della verifica delle credenziali.',
unistr('La procedura pu\00F2 essere definita nell''attributo "Codice PL/SQL" o nel database.<p/>'),
'<p>Gli schemi di autenticazione in cui il controllo delle credenziali utente viene eseguito all''esterno di &PRODUCT_NAME. in genere non eseguono la procedura di pre-autenticazione.',
unistr('\00C8 il caso di <em>Variabile di intestazione HTTP</em>, <em>Oracle Application Server Single Sign-On</em> e degli schemi di autenticazione personalizzati che usano <code>apex_authentication.post_login</code> invece di <code>apex_authentication.login</c')
||'ode>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623671724307081)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome procedura pre-autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927633873307340)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna che contiene la chiave primaria per la tabella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927519734307340)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna chiave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092222395307465)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005232630307398)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per visualizzare il bordo per l''attributo specificato.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005123183307398)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore bordo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005065785307398)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la larghezza in pixel dei bordi di tabella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004920531307398)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza bordo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129338073307492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008432386307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che sar\00E0 utilizzato per visualizzare lo sfondo per il componente.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008334593307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore sfondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094350467307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008278668307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che sar\00E0 utilizzato per visualizzare il componente.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008142698307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007632101307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un tipo di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094002881307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093803895307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093963611307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007547957307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008067133307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una dimensione di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007992937307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007848331307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un spessore di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094261617307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'it'
,p_message_text=>'Grassetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094193444307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007703247307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Spessore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129241586307492)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007483648307400)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che sar\00E0 utilizzato per visualizzare lo sfondo per il componente.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007351099307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore sfondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093764785307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007222686307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che sar\00E0 utilizzato per visualizzare il componente.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007140265307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006641897307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un tipo di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093424397307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093219691307465)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093314193307465)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006566199307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103007080031307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una dimensione di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006978761307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006867576307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un spessore di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093631112307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'it'
,p_message_text=>'Grassetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093548565307466)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006726115307399)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Spessore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896253647307314)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la larghezza di colonna utilizzata per dimensionare questa colonna quando il report viene stampato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896158734307314)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011062866307402)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare le unit\00E0 utilizzate per definire i valori di larghezza delle colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095824831307467)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'it'
,p_message_text=>'Percentuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095905010307467)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'it'
,p_message_text=>'Punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010981983307402)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Unit\00E0 larghezza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010265438307402)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere un nome per il documento scaricato. Se non si specifica un nome, viene utilizzato come nome file il nome dell''area.',
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010140244307402)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004824342307398)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''altezza della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004763583307397)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011627201307403)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il testo relativo al collegamento per il download. Per sostituire il collegamento con un altro componente di navigazione, ad esempio un pulsante, lasciare vuoto questo campo. \00C8 possibile impostare l''altro componente affinch\00E9 avvii il pro')
||'cesso di stampa utilizzando come destinazione un URL con la sintassi seguente:</p>',
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
'</p><strong>Nota</strong>: sostituire <code>[REGION_ID]</code> nella stringa precedente con il proprio ID area.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011529271307403)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004244413307397)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''orientamento della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091732571307464)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'it'
,p_message_text=>'Orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091673040307464)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'it'
,p_message_text=>'Verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004111843307397)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Orientamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011185896307403)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Deriva da elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011756394307403)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Deriva da elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010458450307402)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il formato di output del report. \00C8 inoltre possibile disporre del formato di output specificato da un elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095693543307467)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'it'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095326464307467)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'it'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095439954307467)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'it'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095555189307467)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'it'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095799582307467)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'it'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010316685307402)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010692178307402)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere l''elemento di pagina o di applicazione che contiene il valore del formato. \00C8 possibile includere un elemento di pagina <em>Lista di selezione</em> per consentire agli utenti di selezionare il formato di output in runtime. Di seguito sono')
||' riportati i valori validi.</p>',
'<dl>',
'<dt>PDF</dt>',
'<dd>Apre il documento in un previewer PDF</dd>',
'<dt>RTF</dt>',
'<dd>Apre il documento in Microsoft Word</dd>',
'<dt>XLS</dt>',
'<dd>Apre il documento in Microsoft Excel</dd>',
'<dt>HTM</dt>',
'<dd>Scarica il documento come file HTML</dd>',
'<dt>XML</dt>',
'<dd>Scarica il documento come file XML</dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010518641307402)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009484379307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''allineamento per il pi\00E8 di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095197291307467)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'it'
,p_message_text=>'al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095082041307467)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'it'
,p_message_text=>'inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103095200172307467)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009342510307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Allineamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094990434307467)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009212370307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che sar\00E0 utilizzato per visualizzare il componente.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009125753307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008670135307400)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un tipo di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094664855307466)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094476097307466)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094539619307466)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008549311307400)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009024289307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una dimensione di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008918304307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008896506307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un spessore di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094823372307467)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'it'
,p_message_text=>'Grassetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103094735379307467)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103008701763307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Spessore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009606300307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il testo da visualizzare nella sezione del pi\00E8 di pagina del documento. Per mostrare i valori degli elementi di pagina o di applicazione, usare la sintassi <code>&amp;ITEM_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103009548717307401)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Testo pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006231624307399)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un allineamento per l''intestazione della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093087270307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'it'
,p_message_text=>'al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092927791307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'it'
,p_message_text=>'inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103093110928307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'it'
,p_message_text=>'fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006178603307399)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Allineamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092897617307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006089698307398)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che sar\00E0 utilizzato per visualizzare il componente.</p>'),
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005975428307398)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005465961307398)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un tipo di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092511812307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'it'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092318861307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'it'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092490873307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'it'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005322578307398)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005848663307398)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una dimensione di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005705308307398)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005617822307398)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un spessore di carattere per il componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092701820307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'it'
,p_message_text=>'Grassetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092611650307465)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'it'
,p_message_text=>'Normale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103005572576307398)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Spessore carattere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006448893307399)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo da visualizzare nella sezione di intestazione del documento. Per mostrare i valori degli elementi di pagina o di applicazione, usare la sintassi <code>&amp;ITEM_NAME.</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103006337183307399)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo intestazione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004061131307397)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare le dimensioni di pagina del report. Per digitare valori di larghezza e altezza di pagina propri, selezionare <b>Personalizzato</b>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091496404307464)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'it'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091328300307464)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'it'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091576469307464)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091138101307464)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'it'
,p_message_text=>'Legale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091056829307464)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'it'
,p_message_text=>'Lettera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091245958307464)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'it'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003931905307397)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004455442307397)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare le unit\00E0 utilizzate per specificare la larghezza e l''altezza della pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092076085307464)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'it'
,p_message_text=>'Centimetri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091829484307464)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'it'
,p_message_text=>'Pollici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103091999492307464)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'it'
,p_message_text=>'Millimetri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103092173737307465)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'it'
,p_message_text=>'Punti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004348803307397)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Unit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003847013307397)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''estensione Content-Disposition per il documento di stampa. Content-Disposition \00E8 un''estensione del protocollo MIME che fornisce al browser le istruzioni di visualizzazione del documento. Selezionando <strong>Allegato</strong> si indica ')
||'al browser di salvare il file sul disco invece di visualizzarlo in linea.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090830715307464)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'it'
,p_message_text=>'Allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103090952750307464)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'it'
,p_message_text=>'In linea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103003739549307397)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizza file come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004641116307397)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la larghezza della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103004540762307397)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Larghezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364277271306850)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''area di form associata per questo elemento di pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102364195509306849)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area di form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881570068307303)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la posizione in cui verr\00E0 visualizzato il messaggio di errore che indica che il processo non \00E8 stato completato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071419133307449)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'it'
,p_message_text=>'In linea nella notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071535543307449)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Il messaggio di errore del processo viene visualizzato nell''area "Notifica" (definita come parte del modello di pagina).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071657022307449)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'it'
,p_message_text=>'Nella pagina di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071777769307450)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Il messaggio di errore del processo viene visualizzato nella pagina di errore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881453384307303)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione di visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545486848307000)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il punto del rendering o dell''elaborazione della pagina in cui deve essere eseguito questo processo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057029425307438)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Dopo le aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348918584307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito dopo la visualizzazione delle aree.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057200967307439)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'it'
,p_message_text=>unistr('Dopo il pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349185175307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito dopo la visualizzazione della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056837872307438)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'it'
,p_message_text=>'Dopo l''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348705342307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito dopo la visualizzazione dell''intestazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057489096307439)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'it'
,p_message_text=>'Elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349359735307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'it'
,p_message_text=>'Elaborazione: eseguita dopo l''esecuzione delle convalide e dei calcoli durante l''elaborazione della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056932211307438)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Prima delle aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348833174307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito prima della visualizzazione delle aree.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057183122307438)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'it'
,p_message_text=>unistr('Prima del pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349086858307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Rendering: eseguito prima della visualizzazione del pi\00E8 di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056703092307438)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'it'
,p_message_text=>'Prima dell''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348654394307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>'Rendering: eseguito prima della visualizzazione della pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057520843307439)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'it'
,p_message_text=>'Callback Ajax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349452144307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'it'
,p_message_text=>'Eseguito quando richiamato dalle interfacce API JavaScript apex.server.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056647539307438)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'it'
,p_message_text=>'Nuova sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348548757307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Eseguito quando viene generata una nuova sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103057345507307439)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'it'
,p_message_text=>'Dopo la sottomissione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349214245307668)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Elaborazione: eseguita dopo la sottomissione della pagina, ma prima dell''esecuzione dei calcoli, delle convalide e dei processi di pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102545309747307000)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881712138307303)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''area da associare a questo processo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881687917307303)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area modificabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102760021097307204)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare uno schema di autorizzazione per limitare gli utenti che possono salvare le definizioni dei report pubblici.',
'		Per consentire a un utente finale di salvare un report pubblico, lo schema di autorizzazione deve restituire TRUE.</p>',
'		<p>Nota: se non viene fornito alcuno schema di autorizzazione, i report possono essere salvati da qualsiasi utente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759915265307204)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Salva autorizzazione report pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130295837307493)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'it'
,p_message_text=>'$$$ DJP attualmente nascosto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102920906211307336)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'it'
,p_message_text=>'ID query colonna report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552510145307007)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la prima <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552449496307007)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552997718307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la seconda <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552879954307007)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553316130307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la terza <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553205550307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553799881307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la quarta <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553652875307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554191306307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la quinta <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554067171307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554585609307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la sesta <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554486590307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554981666307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la settima <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554825649307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555355633307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per l''ottava <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555265468307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555791570307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la nona <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555629952307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556191937307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''etichetta per la decima <strong>selezione rapida</strong>. L''etichetta \00E8 il testo che viene visualizzato dall''utente finale dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556073610307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552379590307007)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere gli attributi HTML associati alla visualizzazione di ogni collegamento <strong>Selezione rapida</strong>.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552201699307007)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552701094307007)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla prima <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552618139307007)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553128519307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla seconda <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553033959307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553528627307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla terza <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553416963307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553938329307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla quarta <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102553883293307008)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554303766307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla quinta <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554255149307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554729450307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla sesta <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102554611269307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555110371307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla settima <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555017276307009)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555580913307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato all''ottava <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555473906307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555972704307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla nona <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102555877230307010)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556349140307011)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore associato alla decima <strong>selezione rapida</strong>. Il valore immesso sostituisce il valore di elemento esistente quando l''utente fa clic su questa selezione rapida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556232406307011)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894417257307313)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero di colonne da visualizzare per questa colonna di gruppo di scelta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894369904307313)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Numero di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625542987307083)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere una lista separata da due punti di ruoli dinamici Real Application Security, ad esempio:',
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
'<p>&PRODUCT_NAME. abilita questi ruoli durante la fase di login, passandoli tramite il parametro <em>enable_dynamic_roles</em> di <em>sys.dbms_xs_sessions.assign_user</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625419797307083)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ruoli dinamici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625381203307083)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il modo in cui Oracle Real Application Security (RAS) viene utilizzato in questa applicazione.</p>',
unistr('<p>Se si abilita la modalit\00E0 RAS, assicurarsi che gli utenti dispongano dei privilegi necessari per accedere agli oggetti di schema dell''applicazione.'),
unistr('Con <strong>Utenti esterni</strong>, ad esempio, \00E8 possibile concedere i privilegi di database a un <em>ruolo applicazione dinamico RAS</em> e configurare il ruolo in questo schema di autenticazione come <em>ruolo dinamico</em>.'),
unistr('\00C8 possibile abilitare i ruoli anche tramite una chiamata a <em>apex_authorization.enable_dynamic_groups</em>, ad esempio all''interno di una procedura di post-autenticazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058678918307440)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349507376307668)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Real Application Security non \00E8 utilizzato nell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058778204307440)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'it'
,p_message_text=>'Utenti esterni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349647254307668)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'it'
,p_message_text=>'&PRODUCT_NAME. suppone che tutti gli utenti siano interni e passa <em>false</em> a <em>sys.dbms_xs_sessions.assign_user</em> tramite il parametro <em>is_external</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103058871138307440)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'it'
,p_message_text=>'Utenti interni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103349721821307668)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'it'
,p_message_text=>'&PRODUCT_NAME. passa <em>true</em> a <em>sys.dbms_xs_sessions.assign_user</em> tramite il parametro <em>is_external</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625250449307083)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 RAS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625733685307083)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere una lista separata da due punti di modelli di spazi di nomi Real Application Security, ad esempio:',
'<pre>',
'NS1:NS2',
'</pre></p>',
'<p>&PRODUCT_NAME. abilita questi spazi di nomi durante la fase di login, passandoli tramite il parametro <em>namespaces</em> di <em>sys.dbms_xs_sessions.assign_user</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625633805307083)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Spazi di nomi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274561072307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274965811307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274806445307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274732652307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275022676307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274640481307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274481758307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276599849307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276872141307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276731455307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276666310307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276997234307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276478810307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562732293307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562683574307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564171508307018)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa condizione. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564012082307018)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276153976307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Java per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276062175307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277762697307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277638759307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275947302307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275864427307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione JavaScript per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275758940307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277561728307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277416706307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277358745307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562989763307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista di valori separata da due punti (:) per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562845373307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563361630307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero di pagina per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563219225307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563558710307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista separata da virgole di numeri di pagina per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563492455307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275697634307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275505652307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione PL/SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275449828307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277274595307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per la corretta restituzione dei valori quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277168350307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione PL/SQL che restituisca un valore booleano per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277040737307614)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563189998307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la preferenza utente che viene confrontata con il valore specificato per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563099094307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276379105307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Python per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103276230821307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277914509307615)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca un valore booleano per questa condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103277866604307615)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275389363307613)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori quando il dipendente \00E8 un responsabile (manager) e il relativo reparto si trova a Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275288412307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103275197334307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424844675307728)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per la corretta restituzione dei valori se esistono una o pi\00F9 righe durante il controllo per determinare se il dipendente si trova nel reparto 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>Per la corretta restituzione dei valori se non esistono righe durante il controllo per determinare se il dipendente si trova nel reparto 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562300774307016)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query SQL per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562225794307016)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563772965307018)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore di testo per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563613679307017)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564332544307018)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore, comprese le stringhe di sostituzione <code>&ITEM.</code>, per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102564202304307018)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102773254909307217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare dalla lista il tipo di condizione che deve essere soddisfatto affinch\00E9 questo componente venga visualizzato in sola lettura.'),
unistr('Se non si seleziona alcuna condizione, l''elemento verr\00E0 visualizzato in modo normale.'),
'Un elemento di sola lettura viene visualizzato con le stesse impostazioni di un elemento Sola visualizzazione.</p>',
'<p>Nota: impostare il tipo di condizione su <strong>Mai</strong> per visualizzare sempre l''elemento come campo modificabile.',
'Questa impostazione sovrascrive qualsiasi impostazione di condizione di sola lettura a livello di area o di pagina.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177259303306704)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare dalla lista il tipo di condizione che deve essere soddisfatto affinch\00E9 questo componente venga visualizzato in sola lettura.'),
unistr('Se non si seleziona alcuna condizione, l''elemento verr\00E0 visualizzato in modo normale.'),
'Un elemento di sola lettura viene visualizzato con le stesse impostazioni di un elemento Sola visualizzazione.</p>',
'<p>Nota: impostare il tipo di condizione su <strong>Mai</strong> per visualizzare sempre l''elemento come campo modificabile.',
'Questa impostazione sovrascrive qualsiasi impostazione di condizione di sola lettura a livello di area o di pagina.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628194125307085)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare il tipo di condizione che deve essere soddisfatto affinch\00E9 quest''area visualizzi gli elementi di pagina in sola lettura.'),
'Se non si seleziona alcuna condizione, gli elementi di pagina verranno visualizzati in modo normale.</p>',
'<p>Nota: se si desidera che un elemento di pagina di quest''area, ad esempio un campo di ricerca, venga sempre visualizzato come elemento modificabile indipendentemente dal risultato della valutazione della condizione, impostare la condizione di sola '
||'lettura dell''elemento di pagina su "Mai" per sovrascrivere l''impostazione dell''area.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102548056737307003)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare il tipo di condizione che deve essere soddisfatto affinch\00E9 questa pagina visualizzi gli elementi di pagina in sola lettura. Se non si seleziona alcuna condizione, gli elementi di pagina verranno visualizzati in modo normale.'),
'La condizione di sola lettura viene valutata dopo l''esecuzione dei processi con il punto di elaborazione impostato su <em>Prima dell''intestazione</em>.</p>',
'<p>Nota: se si desidera che alcuni elementi di pagina, ad esempio un campo di ricerca, o tutti gli elementi di pagina di un''area specifica vengano sempre visualizzati come elementi modificabili indipendentemente dal risultato della valutazione della '
||'condizione, impostare la condizione di sola lettura delle aree o degli elementi di pagina su <strong>Mai</strong> per sovrascrivere l''impostazione padre.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116999739307483)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'it'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256409059307598)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il componente verr\00E0 sempre visualizzato come componente di sola lettura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115503864307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 Microsoft Internet Explorer versione 7.0 o successiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115627225307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 un browser con capacit\00E0 XHTML/CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115432794307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 Mozilla, Netscape versione 6.x/7x o successiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115724774307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il browser client \00E8 un browser di altro tipo (o una versione precedente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114175908307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo \00E8 contenuto nell''elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116139025307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'it'
,p_message_text=>'Lingua corrente = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260052287307601)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale sta eseguendo l''applicazione nella lingua immessa nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115858125307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'it'
,p_message_text=>unistr('La lingua corrente \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260271476307601)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale sta eseguendo l''applicazione in una delle lingue immesse nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116053143307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'it'
,p_message_text=>'Lingua corrente != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260137788307601)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale non sta eseguendo l''applicazione nella lingua immessa nell''attributo <em>Valore</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115945941307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'it'
,p_message_text=>unistr('La lingua corrente NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260334469307601)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'it'
,p_message_text=>'L''utente finale non sta eseguendo l''applicazione in una delle lingue immesse nell''attributo <em>Valore</em>.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113352238307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente = pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258838284307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 uguale al valore immesso in <em>Pagina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113538168307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 in una lista separata da virgole')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259047991307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 contenuta nella lista separata da virgole immessa in <em>Pagine</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113419271307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente != pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258970961307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 diversa dal valore immesso in <em>Pagina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113613514307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente NON \00E8 in una lista separata da virgole')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259160881307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente non \00E8 contenuta nella lista separata da virgole immessa in <em>Pagine</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116245028307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: DAD_NAME = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116348396307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: DAD_NAME != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115020902307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'it'
,p_message_text=>'Errori di convalida in linea visualizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259865794307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'it'
,p_message_text=>'Un errore di convalida in linea viene visualizzato nella pagina, dopo la sottomissione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114410002307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114267018307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114337473307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>unistr('Il testo NON \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114594752307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Testo != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111057322307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Righe restituite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256539117307598)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La query SQL restituisce una o pi\00F9 righe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274207861307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103274361075307612)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'L''espressione restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111211444307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256789826307598)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Il corpo funzione restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116642988307483)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: HTTP_HOST = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116775709307483)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: HTTP_HOST != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114720524307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina/area NON \00E8 di sola lettura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259555786307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina e l''area padre, se necessario, vengono visualizzate in modo normale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114611551307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina/area \00E8 di sola lettura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259431209307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'La pagina o l''area padre, se necessario; la condizione ''Sola lettura'' restituisce TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112560054307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento non contiene spazi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258096922307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'it'
,p_message_text=>'Il valore dell''<em>elemento</em> selezionato non contiene spazi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112821150307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 alfanumerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258390536307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 alfanumerico, ovvero contiene solo lettere o numeri e nessun carattere speciale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112011114307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257519296307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112765446307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258283351307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112278878307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257769823307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111982951307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257479816307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112343334307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NULL o pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257820261307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 vuoto o \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112642930307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258174121307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112103419307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257677079307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112478872307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL e NON \00E8 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257986452307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 vuoto e non \00E8 il numero zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115213182307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'it'
,p_message_text=>'Report SQL (OK per visualizzare il pulsante Avanti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115398854307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'it'
,p_message_text=>'Report SQL (OK per visualizzare il pulsante Indietro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116875812307483)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'it'
,p_message_text=>'Mai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103260460952307601)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'it'
,p_message_text=>'Il componente viene visualizzato in modo normale, indipendentemente dalla condizione di sola lettura per il componente o i componenti padre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103115186091307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'it'
,p_message_text=>'Errori di convalida in linea NON visualizzati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259942727307601)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'it'
,p_message_text=>'Un errore di convalida in linea non viene visualizzato nella pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111105964307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Nessuna riga restituita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256621806307598)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>'La query SQL non restituisce righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113958061307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 in modalit\00E0 Per la stampa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259221212307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente \00E8 stata impostata su ''in modalit\00E0 Per la stampa'' dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114088019307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente NON \00E8 in modalit\00E0 Per la stampa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259311508307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina corrente non \00E8 stata impostata su ''in modalit\00E0 Per la stampa'' dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111310795307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Richiesta = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256889623307598)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111571554307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257013027307598)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 contenuta nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111485486307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'Richiesta != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103256998208307598)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina \00E8 diversa dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111664525307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257179612307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La richiesta di pagina non \00E8 contenuta nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116491012307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: SERVER_NAME = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103116507087307482)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'it'
,p_message_text=>'CGI_ENV: SERVER_NAME != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114838372307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 autenticato (non \00E8 pubblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259662493307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale \00E8 collegato all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103114941957307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 pubblico (non ha eseguito l''autenticazione)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103259749396307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente finale non \00E8 collegato all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113165760307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza utente = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258639213307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della <em>preferenza</em> immessa \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113291924307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza utente != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258718098307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della <em>preferenza</em> immessa \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103112947530307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 in una lista separata da due punti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258434922307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113059327307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 in una lista separata da due punti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103258514635307600)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato non \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111738403307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257239982307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103111871277307479)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103257377950307599)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''<em>elemento</em> selezionato \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113832948307481)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente != pagina sottomessa (inviata)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103113725987307480)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'it'
,p_message_text=>'Pagina corrente = pagina sottomessa (inviata)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102547997797307003)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562588205307016)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore da confrontare con la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102562448717307016)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563956080307018)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore, comprese le stringhe di sostituzione <code>&ITEM.</code>, per la condizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102563878773307018)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054199378307436)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556550291307011)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere gli attributi inclusi nella tag di cella di tabella HTML dell''elemento, <code>&lt;td&gt;</code>, durante la visualizzazione in modalit\00E0 di sola lettura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556491822307011)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Attributi HTML di sola lettura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841153392307274)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere, in secondi, l''intervallo tra un aggiornamento del grafico e l''altro. Si sconsiglia di utilizzare intervalli molto brevi, ad esempio di 2 secondi, in quanto possono causare seri problemi inerenti alle prestazioni del database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841060967307273)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Intervallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102841234140307274)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'it'
,p_message_text=>'secondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568822249307022)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''area in cui verr\00E0 visualizzato il pulsante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586198047307038)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessun padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177180374306704)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''area in cui verr\00E0 visualizzato l''elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586080264307038)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessun padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561768825307016)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare l''area in cui \00E8 associato questo componente. Se si tratta di un componente da visualizzare, verr\00E0 visualizzato all''interno dell''area specificata in una posizione relativa rispetto agli altri componenti presenti nell''area.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561602382307016)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626980428307084)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare <strong>Attivo</strong> se si desidera che l''area venga inclusa nel Selettore di visualizzazione area.',
unistr('Questo attributo viene utilizzato solo se un''area di tipo <em>Selettore di visualizzazione area</em> \00E8 stata definita ed \00E8 visualizzabile nella pagina.</p>'),
'<p>Quando un utente fa clic su un nome di area inclusa nel Selettore di visualizzazione area, viene mostrata solo l''area selezionata e tutte le altre aree elencate vengono nascoste.',
unistr('La prima voce del Selettore di visualizzazione area \00E8 <em>Mostra tutto</em>, che consente all''utente di visualizzare tutte le aree disponibili anzich\00E9 solo l''area selezionata in precedenza.</p>'),
unistr('<p>L''area non \00E8 disponibile in base alle condizioni specifiche non viene inclusa nelle liste delle aree nel Selettore di visualizzazione area.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626847347307084)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Selettore di visualizzazione area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627717114307084)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la funzione PL/SQL che restituisce la query SQL utilizzata come base per quest''area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627638159307084)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625921359307083)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''origine o il contenuto dell''area, a seconda del <em>tipo di area</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625835608307083)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627137981307084)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un riferimento all''immagine visualizzata in alto a sinistra nell''area. Non \00E8 possibile controllare la tag della tabella utilizzata per visualizzare l''immagine.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627023757307084)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Immagine area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921195535307336)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''origine del testo per questo componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921097699307336)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622289684307080)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''origine SQL per questo componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622183736307080)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626581414307084)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare un modello di area per definire l''aspetto e il layout di quest''area.</p>',
'        <p>I modelli di area sono definiti nel tema dell''applicazione.',
'        Quando si crea un''area, il modello viene impostato in modo automatico sul modello di area predefinito presente nel tema corrente.</p>',
unistr('        <p>Numerosi temi contengono modelli di area per la visualizzazione di report, form, avvisi, pulsanti, contenuto comprimibile (nascondi/mostra), form di login e cos\00EC via.<br>'),
'        Nel tema universale sono disponibili i modelli di area riportati di seguito.',
'          <dl>',
'            <dt>Avviso</dt>',
'            <dt>Vuoto con attributi</dt>',
'            <dt>Contenitore pulsanti</dt>',
'            <dt>Contenitore selettore</dt>',
'            <dt>Comprimibile</dt>',
'            <dt>Blocco contenuto</dt>',
'            <dt>Hero</dt>',
'            <dt>Finestra di dialogo in linea</dt>',
'            <dt>Report interattivo</dt>',
'            <dt>Login</dt>',
'            <dt>Standard</dt>',
'            <dt>Contenitore schede</dt>',
'            <dt>Barra del titolo</dt>',
'            <dt>Contenitore procedura guidata</dt>',
'          </dl>',
'          Vedere anche: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626425004307083)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738127166307184)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare la modalit\00E0 di rendering di quest''area. Sono supportati i tipi di area seguenti:</p>'),
'#NATIVE_PLUGINS#',
'<p>A seconda della configurazione dell''applicazione, potrebbero essere disponibili altri plugin per il tipo di area.',
'Questi plugin vengono visualizzati con il formato <em>&lt;My Plug-in&gt; [plugin]</em>.',
'I plugin seguenti vengono installati nel componenti condivisi dell''applicazione:</p>',
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102561060309307015)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000107154307394)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare il tipo di uguaglianza da sottoporre a test per questa convalida. A seconda della selezione effettuata, per definire in modo completo la convalida saranno necessari uno o pi\00F9 attributi aggiuntivi.</p>'),
'<p>Se la convalida supera il test di uguaglianza oppure restituisce TRUE, il messaggio di errore di convalida non viene visualizzato.',
'I messaggi di errore di convalida vengono visualizzati quando la convalida non supera il test di uguaglianza o restituisce FALSE, oppure quando viene restituita una stringa di testo non vuota.</p>',
'<p>Un errore di convalida non impedisce la valutazione delle convalide successive, pertanto ogni convalida successiva potrebbe restituire un messaggio di errore di convalida aggiuntivo. Se si desidera impedire l''esecuzione delle convalide successive,'
||unistr(' \00E8 necessario aggiungere ulteriore logica alla prima convalida non riuscita, ad esempio impostando un elemento di pagina su un valore specifico e quindi migliorando la logica condizionale nelle convalide successive in base alle esigenze. Se una o pi\00F9')
||' convalide non superano la valutazione, i processi e le diramazioni successivi non verranno eseguiti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100893245307471)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Righe restituite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100980730307471)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se la query SQL restituisce una o pi\00F9 righe.<br>'),
'Non riesce se la query SQL non restituisce alcuna riga.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308288777307638)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308361277307638)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se l''espressione restituisce TRUE.<br>',
'Non riesce se l''espressione restituisce FALSE.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101467175307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione (che restituisce un valore booleano)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101549175307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il corpo funzione restituisce TRUE.<br>',
'Non riesce se il corpo funzione restituisce FALSE.<br>',
'Nota: il risultato restituito dalla funzione deve essere booleano.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101620429307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione (che restituisce il testo dell''errore)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101791265307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il corpo funzione restituisce una stringa vuota.<br>',
'Non riesce se il corpo funzione restituisce una stringa non vuota. La stringa restituita viene visualizzata come messaggio di errore per la convalida.<br>',
'Nota: il risultato restituito dalla funzione deve essere una stringa di testo.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102453659307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'it'
,p_message_text=>'La colonna non contiene spazi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102551607307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore della colonna non contiene spazi.<br>',
'Non riesce se il valore della colonna contiene spazi.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104431297307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'La colonna contiene almeno uno dei caratteri presenti nel valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104503843307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore della colonna include almeno un carattere del testo immesso nell''attributo <em>Valore</em>.<br>',
'Non riesce se il valore della colonna non include alcun carattere del testo immesso nell''attributo <em>Valore</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104664276307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'La colonna NON contiene alcuno dei caratteri presenti nel valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104714684307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore della colonna non include alcun carattere del testo immesso nell''attributo <em>Valore</em>.<br>',
'Non riesce se il valore della colonna include almeno un carattere del testo immesso nell''attributo <em>Valore</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104253486307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'La colonna contiene solo i caratteri specificati nel valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104300218307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore della colonna contiene solo i caratteri presenti nel testo immesso nell''attributo <em>Valore</em>.<br>',
'Non riesce se il valore della colonna contiene caratteri che non si trovano nel testo immesso nell''attributo <em>Valore</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103411118307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'Colonna = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103566062307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.<br>'),
unistr('Non riesce se il valore della colonna non \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103808289307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103948339307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.<br>'),
unistr('Non riesce se il valore della colonna non \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103622762307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'Colonna != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103766204307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna \00E8 diverso dal testo immesso nell''attributo <em>Valore</em>.<br>'),
unistr('Non riesce se il valore della colonna \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104001500307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna NON \00E8 contenuta nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104103653307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna non \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.<br>'),
unistr('Non riesce se il valore della colonna \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102626349307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna \00E8 alfanumerica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102731399307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna \00E8 alfanumerico, ovvero contiene solo lettere e numeri senza caratteri speciali.<br>'),
'Non riesce se il valore della colonna contiene caratteri speciali.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103058251307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna \00E8 una data valida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103191643307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna \00E8 una data valida.<br>'),
unistr('Non riesce se il valore della colonna non \00E8 una data valida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102824792307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna \00E8 numerica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102910690307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna \00E8 numerico.<br>'),
'Non riesce se il valore della colonna caratteri non numerici, ovvero include spazi diversi dagli spazi iniziali.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103218392307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna \00E8 un indicatore orario valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103103323841307473)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna \00E8 un indicatore orario valido.<br>'),
unistr('Non riesce se il valore della colonna non \00E8 un indicatore orario valido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101872011307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101946952307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna non \00E8 vuoto.<br>'),
'Non riesce se il valore della colonna.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102044965307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna \00E8 NOT NULL o zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102158469307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna non \00E8 vuoto e non \00E8 il numero zero.<br>'),
unistr('Non riesce se il valore della colonna \00E8 vuoto o \00E8 il numero zero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102218448307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna NON \00E8 uguale a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103102344961307472)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore della colonna non \00E8 il numero zero.<br>'),
unistr('Non riesce se il valore della colonna \00E8 il numero zero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101000160307471)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Nessuna riga restituita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101156959307471)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se la query SQL non restituisce alcuna riga.<br>',
unistr('Non riesce se la query SQL restituisce una o pi\00F9 righe.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101206010307471)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'it'
,p_message_text=>'Errore PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103101315876307471)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il codice PL/SQL viene eseguito senza generare errori.<br>',
'Non riesce se l''espressione PL/SQL genera un errore durante l''esecuzione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104851409307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'La colonna corrisponde all''espressione regolare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103104968817307474)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore della colonna corrisponde all''espressione regolare immessa nell''attributo <em>Valore</em>.',
'Non riesce se il valore della colonna non corrisponde all''espressione regolare immessa nell''attributo <em>Valore</em>.<br>',
unistr('Nota: le espressioni regolari consentono di cercare i pattern nei dati delle stringhe mediante convenzioni di sintassi standardizzate anzich\00E9 mediante il semplice confronto dei caratteri.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000013971307394)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000784235307394)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un nome colonna con distinzione tra maiuscole e minuscole per la convalida. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000602936307394)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310157612307640)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310526251307640)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310408501307640)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310361870307640)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310653139307640)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310257546307640)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310032633307640)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312175194307641)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312421956307641)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312324740307641)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312282695307641)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312569830307641)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312056739307641)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308545943307638)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308839488307639)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308744043307639)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308637976307638)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308947569307639)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308452035307638)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311756117307641)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Java per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311627410307641)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313309011307642)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca un valore BOOLEAN come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313207043307642)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309769211307639)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca il testo di un messaggio di errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309685284307639)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java che restituisce il testo dell''errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311509241307641)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311463292307641)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione JavaScript per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311329330307641)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313129077307642)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313018319307642)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca un valore BOOLEAN come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312946140307642)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309539565307639)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione del messaggio di errore specificato, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Il dipendente si trova nel reparto " + apex.env.P2_DEPTNO + " e non nel reparto 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309479975307639)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca il testo di un messaggio di errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309356877307639)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript che restituisce il testo dell''errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424638918307728)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione del messaggio di errore specificato, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Il dipendente si trova nel reparto '' || :P2_DEPTNO || '' e non nel reparto 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000590330307394)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione PL/SQL che restituisce un errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000486452307394)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice PL/SQL che restituisce un errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311212432307640)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311169556307640)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione PL/SQL per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311056981307640)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312854700307642)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312775228307642)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce un valore BOOLEAN come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103312663604307642)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309227189307639)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione del messaggio di errore specificato, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Il dipendente si trova nel reparto '' || :P2_DEPTNO || '' e non nel reparto 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309166496307639)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce il testo di un messaggio di errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309044098307639)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce un testo di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311992171307641)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Python per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103311877099307641)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313539610307642)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca un valore BOOLEAN come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313470270307642)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309989294307639)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca il testo di un messaggio di errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103309808347307639)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python che restituisce il testo dell''errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001102400307395)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione regolare utilizzata per la corrispondenza con la colonna specificata per la convalida.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103001087836307395)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione regolare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310922298307640)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente \00E8 un responsabile (manager) o il reparto di trova a Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310827911307640)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione SQL per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103310734435307640)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424512367307728)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per <strong>Righe restituite</strong>, per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente \00E8 nel reparto 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Per <strong>Nessuna riga restituita</strong>, per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente \00E8 nel reparto 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000321399307394)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query SQL per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000256512307394)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000997298307395)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore da confrontare con il valore della colonna specificata per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103000826178307395)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014515806307405)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355113138307672)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Eredita l''impostazione definita rispetto all''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014469935307405)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questo attributo per controllare se &PRODUCT_NAME. deve supportare gli URL di applicazione che non contengono gli ID delle sessioni.',
unistr('Se la funzione Riunisci tramite join le sessioni \00E8 abilitata, &PRODUCT_NAME. tenta di usare il cookie della sessione per accedere a una sessione esistente quando un URL non contiene un ID sessione.'),
'</p>',
unistr('<p>Un''impostazione pi\00F9 restrittiva a livello di istanza ha la priorit\00E0 su questo valore a livello di pagina.'),
'</p>',
'<p><em><strong>Nota:</em></strong> l''abilitazione della funzione Riunisci tramite join le sessioni espone l''applicazione a possibili violazioni della sicurezza,',
'in quanto consente a utenti non autorizzati di assumere il controllo delle sessioni esistenti degli utenti finali.',
'Per ulteriori informazioni, vedere le sezioni <em>Rejoin Sessions</em> nel capitolo "Managing Application Security" del manuale App Builder User''s Guide.',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096000685307468)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096187548307468)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>'Se l''URL non contiene un ID sessione, &PRODUCT_NAME. crea una nuova sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096231814307468)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'it'
,p_message_text=>'Abilitato per le sessioni pubbliche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096358336307468)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se l''URL punta a una pagina pubblica e non contiene un ID sessione, &PRODUCT_NAME. tenta di utilizzare il cookie della sessione esistente stabilito per l''applicazione.',
'Per le applicazioni con pagine pubbliche e autenticate, viene definito un ID sessione quando l''utente finale esegue la procedura di autenticazione.',
unistr('&PRODUCT_NAME. esegue il join utilizzando il cookie solo quando la sessione non \00E8 stata ancora autenticata.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096450303307468)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Abilitato per tutte le sessioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096516875307468)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se l''URL non contiene un ID sessione, &PRODUCT_NAME. tenta di utilizzare il cookie della sessione esistente stabilito per l''applicazione, a condizione che vengano soddisfatte le condizioni riportate di seguito.</p>',
'<p><ul>',
unistr('  <li>La funzione Protezione stato sessione \00E8 abilitata per l''applicazione e l''URL include un checksum valido.'),
unistr('    Per i segnalibri pubblici, la protezione pi\00F9 restrittiva a livello elemento deve essere <em>Non limitato</em> o <em>Checksum obbligatorio: a livello applicazione</em>.</li>'),
'  <li>OPPURE, l''URL non contiene il payload (parametro di richiesta, svuota cache o coppie dati-valore).</li>',
'</ul></p>',
'<p>Questa impostazione richiede inoltre che l''attributo <em>Incorpora in frame</em> sia impostato su <em>Consenti dalla stessa origine</em> o su <em>Nega</em> per l''applicazione.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014343767307405)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Riunisci tramite join le sessioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942404338307351)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare quando ricaricare la pagina dopo la sottomissione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942543080307351)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'it'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942646255307352)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'it'
,p_message_text=>'Ricarica sempre la pagina per visualizzare gli errori e il messaggio di operazione riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942721546307352)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'it'
,p_message_text=>'Solo per operazione riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942846733307352)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra gli errori in modo dinamico senza ricaricare la pagina, ma la ricarica dopo un''elaborazione riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102942352079307351)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ricarica se si fa clic su Sottometti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323821638307650)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103323913063307650)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'I dati non vengono inseriti nella cache e vengono richiesti ogni volta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196545678307553)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196689942307554)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'I dati non vengono inseriti nella cache e vengono richiesti ogni volta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633984452307089)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634046510307089)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Il risultato non viene inserito nella cache. I dati vengono recuperati tramite fetch dal database remoto per ogni richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632155209307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selezionare il modo in cui il motore di &PRODUCT_NAME. pu\00F2 inserire i dati nella cache nel database locale.'),
unistr('        Se la funzione di inserimento nella cache pu\00F2 essere usata, il componente verr\00E0 visualizzato in base ai risultati inseriti nella cache anzich\00E9 recuperati tramite FETCH dal database remoto.'),
'        I risultati inseriti nella cache migliorano le prestazioni in modo significativo, soprattutto in caso di latenza tra il database locale e il database remoto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632218585307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'it'
,p_message_text=>'Per tutti gli utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632301794307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'it'
,p_message_text=>'Il risultato viene inserito nella cache e utilizzato da tutti gli utenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632622822307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'it'
,p_message_text=>'Per sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632733159307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Il risultato viene inserito nella cache in modo specifico per ogni sessione utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632438115307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'it'
,p_message_text=>'Per utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632586072307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'it'
,p_message_text=>'Il risultato viene inserito nella cache in modo specifico per ogni utente tra le varie sessioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632043791307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Inserimento nella cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633018780307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Scadenza dei dati 15 minuti dopo l''inserimento nella cache</dt>',
'  <dd><pre>15</pre></dd>',
'<dt>Scadenza dei dati allo scoccare dell''ora</dt>',
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
'<dt>Scadenza dei dati a mezzanotte</dt>',
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632968559307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare quando i dati inseriti nella cache devono essere invalidati.',
'        Immettere un numero di minuti oppure una stringa di gestione calendario DBMS_SCHEDULER.</p>',
unistr('        <p>Per la stringa di gestione calendario DBMS_SCHEDULER, \00E8 possibile definire che i dati inseriti nella cache vengano invalidati allo scoccare di ogni ora, a mezzanotte o in corrispondenza di un altro point-in-time ricorrente specifico.'),
'        Per ulteriori dettagli, vedere la documentazione di DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102632829630307088)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Timeout cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870064018307295)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere un alias alfanumerico per questa area di report interattivo.',
'L''alias deve essere univoco all''interno dell''applicazione.',
unistr('\00C8 possibile usare un alias per fare riferimento a un''area di report interattivo nella chiamata personalizzata di un''interfaccia API.'),
unistr('Ad esempio, \00E8 possibile scrivere una funzione che restituisca il valore <code>INTERACTIVE_REPORT_ID</code> eseguendo una query sulla colonna <code>ALIAS</code> della vista <code>APEX_APPLICATION_PAGE_IR</code>.'),
unistr('Poich\00E9 il valore <code>INTERACTIVE_REPORT_ID</code> pu\00F2 cambiare quando si importa o esporta l''applicazione in istanze diverse, \00E8 preferibile fare riferimento alle aree di un report interattivo utilizzando un alias.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869998347307295)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Alias area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863590478307290)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare le limitazioni di data della lista di valori.',
unistr('Per le colonne delle date, la lista di valori pu\00F2 visualizzare un''ora passata, un''ora futura o entrambi questi tipi di ore nel filtro per l''elenco a discesa delle colonne del report.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066738801307446)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'it'
,p_message_text=>'Tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066911326307446)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'it'
,p_message_text=>'Futuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103066801396307446)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'it'
,p_message_text=>'Passato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102863457447307290)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Intervalli di date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870208789307295)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare l''elemento di pagina o di applicazione il cui valore memorizza l''ID del report salvato.',
'Il report interattivo utilizza il valore di questo elemento per stabilire il collegamento a un report salvato.',
unistr('Ad esempio, \00E8 possibile definire una lista di report salvati con collegamenti al nome elemento definito e a un ID di report salvato come valore per stabilire il collegamento ai report predefiniti salvati e ai report pubblici o privati.'),
'Gli ID dei report salvati possono essere recuperati dalla vista <code>APEX_APPLICATION_PAGE_IR_RPT</code>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102870116935307295)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento ID report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011254261307403)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Layout report predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103011892668307403)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Layout report predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010838558307402)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il layout da utilizzare durante la stampa del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103010762106307402)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901163214307318)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un modello di report predefinito per controllare la visualizzazione di questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080305171307456)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'it'
,p_message_text=>'HTML (standard)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080455420307456)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'it'
,p_message_text=>'Crea una tabella HTML standard.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080549025307456)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'it'
,p_message_text=>'Report verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080694427307456)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra ogni colonna in una riga distinta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080755269307456)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'it'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080847388307456)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'it'
,p_message_text=>'Esporta il report come file CSV.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080919109307456)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'it'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103081007350307456)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'it'
,p_message_text=>'Esporta il report come file XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102901033788307317)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903350371307319)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo visualizzato accanto ai valori di somma del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102903290884307319)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta di somma del report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896631607307314)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare un modello di report per definire l''aspetto e il layout di questo report classico.</p>',
'        <p>I modelli di report sono definiti nel tema dell''applicazione.',
'        Quando si crea un report classico, il modello viene impostato in modo automatico sul modello di report predefinito presente nel tema corrente.</p>',
unistr('        <p>Numerosi temi contengono modelli di report classico per la visualizzazione dei dati in una tabella, nelle coppie chiave-valore, nei risultati delle ricerche, nelle schede e cos\00EC via.'),
'        Tenere presente che alcuni modelli di report, quali le schede e i risultati delle ricerche, sono "basati su righe" e prevedono che la query SQL restituisca un particolare set di alias di colonna che vengono sostituiti nel modello.<br>',
'        Nel tema universale sono disponibili i modelli di report descritti di seguito.',
'          <dl>',
'            <dt>Avvisi</dt>',
'              <dd>Visualizza un numero qualsiasi di avvisi o di notifiche orizzontali nella pagina.</dd>',
'            <dt>Lista badge</dt>',
'              <dd>Visualizza le coppie chiave-valore in un''interfaccia utente simile a un dashboard.</dd>',
'            <dt>Schede</dt>',
unistr('              <dd>Visualizza i dati dei report in schede, o blocchi di piccole dimensioni, ed \00E8 utile per la presentazione di numerosi tipi di informazioni. Le schede possono essere personalizzate in numerosi dettagli mediante le opzioni di modello.<')
||'/dd>',
'            <dt>Commenti</dt>',
'              <dd>Visualizza commenti e altri messaggi.</dd>',
'            <dt>Risultati ricerca</dt>',
'              <dd>Visualizza i risultati della ricerca secondo lo stile del motore di ricerca.</dd>',
'            <dt>Standard</dt>',
unistr('              <dd>Questo \00E8 il modello di report predefinito per la visualizzazione dei dati in una tabella e pu\00F2 essere personalizzato in numerosi dettagli mediante le opzioni di modello.</dd>'),
'            <dt>Controllo temporale</dt>',
unistr('              <dd>Visualizza un controllo temporale di azioni. \00C8 particolarmente adatto per le home page, i log delle modifiche e altre aree in cui \00E8 necessario un feed di attivit\00E0 delle azioni recenti.</dd>'),
'            <dt>Coppie di attributi di valori - Colonna</dt>',
'              <dd>Visualizza le coppie chiave-valore per le query basate su colonna. L''intestazione della colonna viene utilizzata come etichetta per ciascun elemento.</dd>',
'            <dt>Coppie di attributi di valori - Riga</dt>',
'              <dd>Visualizza le coppie chiave-valore per le query basate su riga. La prima colonna viene utilizzata per le etichette e la seconda per i valori.</dd>',
'          </dl>',
'          Vedere anche: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Applicazione di esempio con tema universale</a>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896595561307314)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758428647307203)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se impedire la visualizzazione dei dati da parte della griglia interattiva a meno che non venga definito almeno un filtro in una delle colonne del report.',
unistr('		Questa opzione \00E8 stata progettata per limitare i dati caricati da un data set di grandi dimensioni mediante la limitazione del numero delle righe restituite in base a un filtro.</p>'),
unistr('		<p>Per le singole colonne \00E8 possibile abilitare <strong>Filtro colonna obbligatorio</strong>, garantendo in questo modo che un filtro sia obbligatorio per la colonna interessata, mentre questa opzione richiede un solo filtro per qualsiasi colonna.<')
||'/p>',
'		<p>Nota: quando si imposta questa opzione e non vi sono filtri definiti, un messaggio invita l''utente a specificare un filtro.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758316521307203)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Filtro obbligatorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102914564016307331)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Tutti i caratteri possono essere salvati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557305335307012)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il modo in cui limitare i caratteri che possono essere salvati nello stato della sessione.',
unistr('&PRODUCT_NAME. visualizza un messaggio di errore se un utente tenta di salvare dati non conformi alla modalit\00E0 di limitazione dei caratteri selezionata.</p>'),
unistr('<p>La limitazione dei caratteri migliora la sicurezza dell''applicazione e pu\00F2 costituire un metodo di prevenzione degli attacchi di tipo CSS (Cross Site Scripting).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055684187307437)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'it'
,p_message_text=>'Lista di esclusione &<>"/;,*|=% e --'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055756438307437)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'it'
,p_message_text=>'I caratteri seguenti: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % e "--" (commento PL/SQL) NON possono essere salvati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055800868307437)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'it'
,p_message_text=>'Lista di esclusione &<>"/;,*|=% o -- e nuova riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055998303307437)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'it'
,p_message_text=>'I caratteri seguenti: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, %, "--" e i caratteri di nuova riga NON possono essere salvati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055231708307437)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'it'
,p_message_text=>'Lista di inclusione per a-Z, 0-9 e spazio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055345996307437)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'it'
,p_message_text=>'Possono essere salvati solo i caratteri a-z, A-Z, i numeri 0-9 e lo spazio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055477894307437)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'it'
,p_message_text=>'Caratteri comandi HTML lista di esclusione (<>")'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055501294307437)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'it'
,p_message_text=>'I caratteri HTML riservati NON possono essere salvati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103056067738307438)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'it'
,p_message_text=>'Schema area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102557201031307012)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Caratteri limitati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321482558307648)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il formato di input per il contenuto visualizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321597644307648)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'it'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321622128307648)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il contenuto contiene tag HTML e verr\00E0 visualizzato senza applicare caratteri speciali di escape. Assicurarsi che i dati siano sicuri e che non contengano dati immessi dall''utente finale per evitare vulnerabilit\00E0 XSS (Cross-Side Scripting).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321773234307648)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'it'
,p_message_text=>'Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321867975307648)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Il contenuto contiene tag Markdown che verranno tradotte in tag HTML sicure prima della visualizzazione. La traduzione delle tag Markdown comuni <strong>eviter\00E0</strong> eventuali vulnerabilit\00E0 XSS (Cross-Side Scripting).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321345047307648)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757684494307202)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la colonna in cui \00E8 memorizzato il numero di versione della riga per tabella in fase di aggiornamento. La colonna selezionata verr\00E0 utilizzata nel controllo degli aggiornamenti persi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757502529307202)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna versione di riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881222253307303)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la frequenza di esecuzione del processo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071374212307449)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Una volta per visita nella pagina (impostazione predefinita)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103071294518307449)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'it'
,p_message_text=>'Una volta per sessione o in caso di in caso di reimpostazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881126323307303)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Esegui processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867071718307293)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare uno schema di autorizzazione per limitare gli utenti che possono salvare le definizioni dei report pubblici.',
'Per consentire a un utente finale di salvare un report pubblico, lo schema di autorizzazione deve restituire TRUE.',
'Se non viene fornito alcuno schema di autorizzazione, i report possono essere salvati da qualsiasi utente.'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866987011307292)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Salva autorizzazione report pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639489385307093)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare se i valori nello stato della sessione devono essere salvati nel database prima dell''esecuzione della diramazione.',
unistr('\00C8 importante impostare questo attributo su <strong>Attivo</strong> quando ci si sposta a un''altra applicazione che deve accedere ai valori di stato della sessione da questa applicazione.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639312773307093)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Salva stato prima della diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626335907307083)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione da usare come schema di analisi di sostituzione. \00C8 riservato alle sole applicazioni interne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626290270307083)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento sostituzione schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246234535307590)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246125553307590)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245443067307590)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Selezionare le modalit\00E0 di applicazione di questo schema di autorizzazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245599299307590)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL - Esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245684466307590)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>'L''autorizzazione riesce quando la query restituisce un valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245926991307590)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Funzione PL/SQL che restituisce un risultato booleano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246054608307590)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione PL/SQL che restituisca un valore booleano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245759583307590)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL - Non esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245863829307590)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>'L''autorizzazione riesce quando la query non restituisce alcun valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103245310720307590)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867272766307293)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo per l''etichetta del pulsante di ricerca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102867156580307293)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta pulsante di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228861886307577)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il componente viene visualizzato mediante una colonna oppure una formattazione avanzata con espressioni HTML e le stringhe di sostituzione supportate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228759106307577)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formattazione avanzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229054455307578)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare come corpo secondario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103228912781307577)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229506945307578)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229401925307578)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229320786307578)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Le sostituzioni <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> in questo esempio sono colonne selezionate nella query SQL del report.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229239425307578)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da mostrare in questa colonna. Usare la sintassi <code>&COLUMN.</code> per mostrare i valori di colonna in formato HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103229117296307578)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625165055307082)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare <strong>Attivo</strong> per consentire l''invio del cookie di gestione della sessione dal browser solo quando il protocollo \00E8 HTTPS.'),
unistr('Selezionare <strong>Non attivo</strong> per consentire l''invio del cookie di gestione della sessione dal browser quando il protocollo \00E8 HTTP o HTTPS.</p>'),
unistr('<p> Se sul server Web \00E8 configurato SSL, selezionare <strong>Attivo</strong> per rafforzare la sicurezza dell''applicazione impendendo il traffico HTTP non cifrato.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102625081510307082)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sicuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781610228307224)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se la prima riga deve essere selezionata automaticamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102781528315307224)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Seleziona prima riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921718720307336)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di grafico serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816282216307255)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il nome colonna da utilizzare per la definizione della query dinamica a pi\00F9 serie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102816131741307254)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556717662307011)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un livello di protezione dello stato della sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054469119307436)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'it'
,p_message_text=>'Checksum obbligatorio: a livello applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054540510307436)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''impostazione dell''elemento pu\00F2 essere eseguita passando l''elemento in un URL che include in checksum specifico per l''area di lavoro e l''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055065512307437)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'it'
,p_message_text=>unistr('Limitato: non pu\00F2 essere impostato dal browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103055104100307437)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''elemento non pu\00F2 essere modificato utilizzando l''URL o l''istruzione POSTDATA.'),
unistr('Selezionare questa opzione per limitare i componenti che possono impostare il valore dell''elemento nei processi interni, nei calcoli e cos\00EC via.'),
unistr('Questo attributo si applica solo agli elementi non utilizzati come elementi di immissione dati e viene sempre esaminato, anche quando la funzione Protezione stato sessione \00E8 disabilitata.'),
'Utilizzare questo attributo per gli elementi di pagina o di applicazione con i tipi <strong>Visualizza come</strong> seguenti:',
'<ul>',
'  <li>Sola visualizzazione (Salva stato=No)</li>',
'  <li>Campo di testo (disabilitato, non salva lo stato)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054250874307436)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Non limitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054354410307436)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''impostazione dell''elemento pu\00F2 essere eseguita passando l''elemento in un URL o in un form. Nell''URL non \00E8 richiesto alcun checksum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054666786307437)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'it'
,p_message_text=>'Checksum obbligatorio: a livello di utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054764041307437)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''impostazione dell''elemento pu\00F2 essere eseguita passando l''elemento in un URL che include in checksum specifico per l''area di lavoro, l''applicazione e l''utente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054843360307437)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'it'
,p_message_text=>'Checksum obbligatorio: a livello di sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103054998272307437)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''impostazione dell''elemento pu\00F2 essere eseguita passando l''elemento in un URL che include un checksum specifico per la sessione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102556656804307011)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Protezione stato sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578651181307031)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il gruppo di filtri a cui \00E8 associata questa casella di controllo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578500565307031)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Gruppo di filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341968493307663)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246390490307591)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342054825307663)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877423738307300)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il menu <em>Azioni</em> deve essere incluso nella barra di ricerca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877359711307300)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Includi menu Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874673695307298)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire le aggregazioni per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874569029307298)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aggrega'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860350623307288)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se questa colonna viene visualizzata o meno nel report per impostazione predefinita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860217825307287)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra per valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874885539307298)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire i grafici per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874748467307298)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874499939307298)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire le colonne di calcolo per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874369593307298)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Calcola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874011709307298)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire le interruzioni di controllo per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873987847307298)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Interruzione di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579017851307032)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se visualizzare l''etichetta del facet accanto ai relativi valori selezionati nella lista dei facet correnti. Nascondere l''etichetta se il valore selezionato, quale ad esempio lo stato di un ordine, \00E8 sufficientemente chiaro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578936705307031)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra etichetta per il facet corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877064643307300)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare se un elenco a discesa distinto del selettore righe deve essere incluso nella barra di ricerca.',
'Non selezionare sia questo attributo che l''attributo <strong>Righe per pagina</strong>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876968258307300)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Selettore righe per pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875836336307299)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono scaricare il report in uno dei formati di download specificati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875709227307299)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Scarica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873226961307297)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire i filtri su questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873193474307297)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876881421307300)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare se l''elenco a discesa dello strumento di ricerca deve essere incluso all''inizio del campo Cerca nella barra di ricerca.',
unistr('L''elenco a discesa dello strumento di ricerca \00E8 una lista di colonne che consente agli utenti di limitare l''ambito della ricerca a una colonna specifica.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876717551307300)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elenco a discesa strumento di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875408075307299)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono utilizzare le flashback query per questo report.</p>',
unistr('<p>Le flashback query utilizzano Oracle Flashback Technology e la funzione di recupero point-in-time del database per visualizzare i dati cos\00EC come si presentavano in un point-in-time precedente. Gli utenti possono soltanto eseguire query su questi d')
||unistr('ati, senza annullare le modifiche che vi sono state apportate. Quanto sia possibile risalire nel tempo per l''esecuzione riuscita di una flashback query \00E8 determinato dal momento dell''ultimo scambio dei redo log file all''interno del database Oracle, i')
||'n quanto questa tecnologia utilizza il backup RMAN.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875338562307299)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875220758307299)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire un gruppo in base ai dettagli per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875100194307299)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Raggruppa per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102813025293307252)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il nome del gruppo deve essere visualizzato nella descrizione comandi che appare nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812926062307252)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra nome gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102876046892307299)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono richiamare la finestra di dialogo di tipo modale della Guida incorporata per i report interattivi.</p>',
'<p>La finestra di dialogo della Guida descrive solo le opzioni disponibili per l''utente corrente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875963267307299)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874239328307298)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire le evidenziazioni per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874194231307298)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Evidenzia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197714922307554)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se questo layer verr\00E0 visualizzato nella legenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197618150307554)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875062295307299)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire le impostazioni di sottoscrizione per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102874945336307298)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sottoscrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866417573307292)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo che si desidera visualizzare per le colonne NULL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866352265307292)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra valori nulli come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175112135306703)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire visualizzazioni dettagliate di pivot per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175075975306703)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552139088307007)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se le selezioni rapide devono essere visualizzate per questo elemento di pagina.',
unistr('Le selezioni rapide consentono agli utenti di selezionare i valori predefiniti con un solo clic del mouse anzich\00E9 digitando il testo oppure effettuando la selezione in una lista di opzioni disponibili.</p>'),
'<p>Si consiglia di specificare le selezioni rapide in presenza di un set di valori di input <em>comuni</em> relativamente piccolo e discreto.',
unistr('\00C8 possibile definire fino a dieci selezioni rapide per elemento.'),
'Questi aiuti per l''utente si rivelano utili quando vengono definiti per un elemento dotato di una lista di selezione dei valori disponibili particolarmente lunga.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102552057858307007)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra selezioni rapide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877603128307300)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifica se la lista di selezione Report viene visualizzata nella barra di ricerca.</p>',
unistr('<p>La lista di selezione Report viene visualizzata solo se un report diverso da quello primario \00E8 accessibile per l''utente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877517608307300)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista di selezione report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875625411307299)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se gli utenti finali possono reimpostare i propri report dal menu Azioni.</p>',
'<p>La reimpostazione del report annulla tutte le personalizzazioni effettuate dall''utente o specificate dall''URL chiamante e comporta la visualizzazione del report primario.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102875535231307299)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873661818307297)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono modificare il numero delle righe visualizzate per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873527816307297)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Righe per pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877215595307300)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il campo di ricerca deve essere incluso nella barra di ricerca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102877153725307300)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Campo di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873409134307297)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se gli utenti finali possono usare la voce <strong>Seleziona colonne</strong> del menu Azioni per modificare le colonne visualizzate nel report. Utilizzando questa opzione, l''utente pu\00F2 selezionare (o mostrare), deselezionare (o nasconder')
||unistr('e) e riordinare pi\00F9 colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873318934307297)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Seleziona colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812805579307252)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il nome della serie deve essere visualizzato nella descrizione comandi che appare nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812731134307252)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra nome serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873899058307298)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se gli utenti finali possono definire le colonne di ordinamento per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102873724934307298)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ordina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102578018821307031)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se mostrare l''etichetta del filtro o solo il valore nel chip di suggerimento. Nascondere l''etichetta se il valore suggerito, quale ad esempio lo stato di un ordine, \00E8 sufficientemente chiaro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577951315307031)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759407086307204)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la barra degli strumenti deve essere visualizzata al di sopra del report. La barra degli strumenti pu\00F2 contenere le funzionalit\00E0 Cerca, Tipo di report, Report salvati, Azioni, Modifica e Reimposta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759322241307204)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759284870307204)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare se visualizzare il conteggio delle righe totali nel pi\00E8 di pagina del report.<p/>'),
unistr('        <p>Nota: viene eseguita una query aggiuntiva per ottenere il conteggio delle righe totali; ci\00F2 pu\00F2 influire negativamente sulle prestazioni, soprattutto con i data set di grandi dimensioni.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102759132838307204)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra conteggio righe totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894628156307313)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Per il tipo di visualizzazione Casella di controllo semplice, immettere un solo valore o due valori separati da una virgola.',
unistr('Il primo valore verr\00E0 sottomesso se la casella di controllo viene selezionata. Il secondo valore, se definito, verr\00E0 sottomesso se la casella di controllo viene deselezionata.'),
'        p_examples           => q''~<dl>',
unistr('<dt>Viene sottomesso Yes se \00E8 selezionata e No se \00E8 deselezionata</dt>'),
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894583236307313)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valori casella di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860937416307288)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''etichetta di colonna da usare nella vista a riga singola.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860894104307288)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902536098307319)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Per le colonne di report che consentono l''ordinamento in base all''intestazione di colonna, selezionare la modalit\00E0 di ordinamento dei record con valori nulli rispetto a quelli con valori non nulli.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082156390307457)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'it'
,p_message_text=>'Primo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082257804307457)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'it'
,p_message_text=>'I record con valori nulli vengono visualizzati prima di tutte le colonne con valori non nulli.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082374583307457)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'it'
,p_message_text=>'Ultimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103082460085307457)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'it'
,p_message_text=>'I record con valori non nulli vengono visualizzati prima di tutte le colonne con valori nulli.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902478301307319)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ordina valori nulli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175846664306703)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la lista degli indicatori di percorso associata a questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175717545306703)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408343138307715)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere un nome colonna di database con distinzione tra maiuscole/minuscole utilizzato come origine per questo facet.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103216746425307569)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere un nome colonna di database con distinzione tra maiuscole/minuscole utilizzato come origine per questo facet.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580013783307032)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere il nome colonna di database con distinzione tra maiuscole/minuscole utilizzato come origine per questo filtro.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581142221307033)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Immettere il nome colonna di database con distinzione tra maiuscole/minuscole utilizzato come origine per questo filtro.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550929093307006)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome della colonna di database con distinzione tra maiuscole e minuscole utilizzato come origine per questo valore di elemento.</p>',
'<p>La colonna deve esistere nella tabella specificata nel processo di recupero righe incorporato definito in questa pagina.',
'Se il nome della colonna di database non esiste nella tabella di riferimento, viene restituito un errore e la pagina non viene caricata.',
unistr('Analogamente, se non \00E8 stato definito alcun processo di recupero righe incorporato ed esiste un elemento con tipo di origine <strong>Colonna di database</strong>, viene restituito un errore e la pagina non viene caricata quando si tenta di visualizza')
||'rla.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550887762307006)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289335712307624)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289710424307624)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289641151307624)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289549342307624)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289805747307624)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289499422307624)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289218260307623)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987271807307384)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''area associata a questa area di ricerca con facet o filtro intelligente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102987175187307384)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area filtrata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291364110307625)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291609777307625)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291590701307625)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291418840307625)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291744323307625)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291293929307625)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550771588307005)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere l''elemento di pagina o di applicazione utilizzato come origine per questo valore di elemento.',
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550606319307005)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320106403307647)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice Java da eseguire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320031682307647)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290937966307625)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Java che produca un valore utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290884995307625)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292524452307626)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca un valore utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292415456307626)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319909271307647)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Aumento dello stipendio del 3% per i dipendenti qualificati per l''aumento:</dt>',
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
'    // segnaposto per la logica complicata per calcolare se il dipendente necessita dell''aumento',
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319899650307647)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice JavaScript da eseguire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319725422307647)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290765399307625)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290641971307625)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione JavaScript che produca un valore utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290531410307625)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292398880307626)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292247549307626)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca un valore utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292101682307626)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175617462306703)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''origine per questa lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175551712306703)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633248502307089)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione dei dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633336118307089)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'it'
,p_message_text=>'Database locale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633424755307089)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''origine dei dati \00E8 il database locale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633569621307089)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'it'
,p_message_text=>'SQL abilitato per REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633613952307089)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''origine dei dati \00E8 un database remoto, con connessione definita mediante SQL abilitato per REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743711804307189)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'it'
,p_message_text=>'Origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103350394860307669)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('L''origine dei dati \00E8 un Web Service RESTful definito tramite origini dati REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633194340307088)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828959835307264)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista separata da virgole di elementi di pagina della pagina corrente da impostare nello stato della sessione quando i dati del grafico vengono letti con una richiesta separata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103196405227307553)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista separata da virgole di elementi di pagina della pagina corrente da impostare nello stato sessione quando i dati della mappa vengono recuperati con una richiesta separata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626170111307083)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere gli elementi di pagina o di applicazione da impostare nello stato della sessione quando l''area viene aggiornata mediante un aggiornamento pagina parziale.',
unistr('Quando si specificano pi\00F9 elementi, usare una virgola per separare i nomi.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.</p>'),
unistr('<p>L''area pu\00F2 essere aggiornata con l''aggiornamento pagina parziale durante l''impaginazione, se <em>Abilita aggiornamento pagina parziale</em> \00E8 impostato su <strong>Attivo</strong>, oppure con l''azione Aggiorna all''interno di un''azione dinamica.</p>'),
'Questi elementi di pagina possono essere utilizzati nella <em>condizione WHERE</em> della query SQL dell''origine area per limitare i risultati della query.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102626006016307083)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elementi pagina da sottomettere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319695829307647)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Aumento dello stipendio del 3% per i dipendenti qualificati per l''aumento:</dt>',
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319581654307647)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice PL/SQL da eseguire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319431134307647)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290445092307624)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290319823307624)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione PL/SQL che produce il valore utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290298686307624)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292054763307626)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291982762307626)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce il valore usato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291856881307626)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355669835307673)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare le modalit\00E0 per la post-elaborazione dei dati dell''origine REST recuperati nel database locale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356138848307673)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356203128307673)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo di funzione PL/SQL in cui la query SQL restituita trasformi i dati recuperati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355917633307673)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103356072015307673)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query SQL per trasformare i dati recuperati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355759570307673)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'it'
,p_message_text=>'Clausola Where/Order By'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355819514307673)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la clausola Where e/o la clausola Order by per limitare e ordinare i dati recuperati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103355571686307673)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551186042307006)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la preferenza utente da utilizzare come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102551031255307006)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320373501307647)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il codice Python da eseguire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103320224374307647)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291127334307625)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Python che produca un valore utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103291018691307625)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292744395307626)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca un valore utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103292667920307626)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550324811307005)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere la query SQL utilizzata come origine per questo valore di elemento. Se vengono restituite pi\00F9 righe, verr\00E0 usato il valore della prima riga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550235226307005)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550565031307005)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere la query SQL che restituisce una o pi\00F9 righe da utilizzare come origine per questo valore di elemento. Se il risultato contiene pi\00F9 righe, il valore di ogni riga verr\00E0 formato in un unico valore delimitato da due punti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550419936307005)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299735589307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300010796307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299970251307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299884947307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300144888307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103299674791307631)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300953353307633)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca una query SQL per la serie di grafici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300892767307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300741376307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selezione delle colonne EMPNO, ENAME e SAL e applicazione del filtro per filtrare tutte le righe con valore SAL minore di 3000.</dt>',
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300602894307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca una query SQL per la serie di grafici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300527829307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631758944307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Visualizzazione delle assunzioni pi\00F9 recenti per prime e delle persone non ancora assunte per ultime. Se la data \00E8 uguale, l''ordinamento si basa sul numero di reparto.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631619300307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere uno o pi\00F9 nomi di colonna separati da virgole, con le direttive, per definire l''ordine di recupero dei record.</p>'),
'        <p>Le direttive disponibili sono:',
'          <ul>',
'            <li>ASC: restituisce la colonna in ordine crescente;</li>',
'            <li>DESC: restituisce la colonna in ordine decrescente;</li>',
'            <li>NULLS FIRST: restituisce le colonne senza valori prima di quelle con valori;</li>',
'            <li>NULLS LAST: restituisce le colonne con valori prima di quelle senza valori.</li>',
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631522539307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ordina per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630966606307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare lo schema proprietario della tabella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630821379307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Proprietario tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744398852307190)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la funzione PL/SQL che restituisce la query SQL utilizzata come base per quest''area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744267085307190)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300442705307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selezione delle colonne EMPNO, ENAME e SAL e applicazione del filtro per filtrare tutte le righe con valore SAL minore di 3000.</dt>',
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300313134307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione PL/SQL che restituisca una query SQL per la serie di grafici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103300234252307632)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301181863307633)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca una query SQL per la serie di grafici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103301077620307633)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631181427307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un nome tabella o vista con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631033507307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome tabella'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630592477307086)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare le modalit\00E0 di esecuzione delle query sui dati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743861136307189)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione che restituisce una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102743932966307189)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'I dati vengono recuperati in base alla query SQL restituita in seguito all''esecuzione di un corpo funzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633791959307089)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102633817766307089)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'it'
,p_message_text=>'I dati vengono recuperati in base a una query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630606561307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'it'
,p_message_text=>'Tabella/vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630707034307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'it'
,p_message_text=>'I dati vengono recuperati in base a una tabella o a una vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630420679307086)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631435292307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Inclusione limitata ai dipendenti con responsabile o che sono venditori.</dt>',
'<dd><pre>',
unistr('( MGR non \00E8 nullo o JOB = ''SALESMAN'' )'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631345123307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una condizione Where SQL valida da utilizzare per limitare il numero dei record recuperati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631254102307087)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Clausola Where'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630330587307086)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il database server remoto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102630218044307086)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Server remoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318928090307646)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il codice immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319204549307646)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319125810307646)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319067440307646)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103319365647307646)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103318803126307646)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944543303307353)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Per concatenare due colonne:</dt>',
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
'<dt>Includere un''istruzione SELECT interna:</dt>',
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768893227307213)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102768738865307212)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290168627307624)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente \00E8 un responsabile (manager) e il relativo reparto si trova a Chicago:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103290022299307624)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione SQL che produca un valore utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103289922846307624)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198693406307555)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Query che restituisce i valori di longitudine e latitudine sotto forma di colonne NUMBER:</p>',
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
'<p>Query che restituisce la posizione del cliente sotto forma di colonna SDO_GEOMETRY:</p>',
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631996500307088)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''origine SQL per questo componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102631875758307087)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550167021307005)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore statico utilizzato come origine per questo valore di elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102550091393307005)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549907007307005)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il tipo di origine su cui si basa il valore di questo elemento.</p>',
unistr('<p>Nota: se l''impostazione di <strong>Origine utilizzata</strong> \00E8 <em>Solo se il valore corrente dello stato di sessione \00E8 NULL</em>, l''origine non verr\00E0 utilizzata se \00E8 stato impostato un valore nello stato della sessione per questo elemento.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053029637307435)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'it'
,p_message_text=>'Valore NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248316269307592)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Imposta su un valore nullo in quanto non \00E8 stato specificato alcun valore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053240993307435)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247732465307592)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore colonna immesso in <em>Colonna database</em>, che viene recuperato da un processo di recupero righe incorporato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269035714307608)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103269170904307608)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore risultante dall''esecuzione dell''<em>espressione</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053588657307436)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248120710307592)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dal <em>corpo funzione</em> immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053683248307436)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247872108307592)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053783481307436)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248279397307592)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore della <em>preferenza</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053364263307436)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL (restituisce un valore singolo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247905143307592)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul primo valore restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053420957307436)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL (restituisce un valore separato da due punti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103248050972307592)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare su un valore separato da due punti singolo, che concatena ogni valore di riga, restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103053101603307435)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103247667970307592)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul testo immesso in <em>Valore statico</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549849781307005)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549794377307005)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il valore che ha la precedenza tra quello presente nello stato di sessione e quello dell''origine dell''elemento.</p>',
'<p>Per gli elementi con tipo di origine <strong>Colonna di database</strong>, selezionare <strong>Sempre (sostituisci qualsiasi valore esistente nello stato di sessione)</strong> a meno che non si desideri che l''operazione associata di recupero delle'
||' righe popoli l''elemento qualora la pagina venga diramata a se stessa.',
unistr('Per gli altri tipi di origine, \00E8 necessario decidere, in base alle modalit\00E0 d''uso della pagina, se visualizzare il valore derivato in precedenza dall''origine o se il tipo di origine deve essere applicato di nuovo per ogni visualizzazione di pagina.</')
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052882959307435)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'it'
,p_message_text=>'Sempre (sostituisci qualsiasi valore esistente nello stato di sessione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103052901800307435)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'it'
,p_message_text=>unistr('Solo se il valore corrente dello stato di sessione \00E8 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102549645072307004)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Utilizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744118487307189)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''origine dati REST che supporta il recupero di una raccolta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102744016973307189)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828775030307264)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'In un grafico a Y doppio diviso, specificare la frazione di spazio assegnata al grafico secondario dell''asse Y. I valori validi sono i numeri compresi tra 0 e 1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828664852307264)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione separatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828220095307264)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se l''area di rappresentazione deve essere divisa in due sezioni in modo che i set di dati assegnati ad assi Y diversi vengano visualizzati in parti diverse dell''area di rappresentazione. I grafici borsistici non supportano l''impostazione '
||'<strong>No</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828397409307264)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828579163307264)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828423568307264)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828143574307264)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805426873307246)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Specificare se gli elementi dati sono disposti in pila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102805311994307246)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'it'
,p_message_text=>'In pila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429586677306902)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il nome della categoria di pila a cui assegnare questa serie. Per impostazione predefinita, tutte le serie di un grafico in pila vengono raggruppate nella stessa pila. Per raggruppare queste serie in una pila separata, impostare una categ'
||unistr('oria di pila. \00C8 possibile utilizzare le sostituzioni <code>&COLUMN_VALUE.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429434773306902)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Categoria pila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429357597306902)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Specificare se devono essere visualizzati i valori totali degli elementi di dati in pila. Si applica solo ai grafici a barre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429272215306902)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Etichetta pila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530140696306986)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare il set di schede standard utilizzato per questa pagina. Un set di schede standard \00E8 associato a un numero di pagina specifico. \00C8 possibile utilizzare le schede standard per collegare gli utenti a una pagina specifica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530031499306986)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Set di schede standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928206023307341)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il primo giorno della settimana visualizzato nel calendario settimanale.',
unistr('Questo attributo pu\00F2 essere usato insieme all''attributo <strong>Giorno di fine</strong> per limitare i giorni della settimana visualizzati o semplicemente per specificare il primo giorno della settimana visualizzato.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087080855307461)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'it'
,p_message_text=>'Domenica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087158518307461)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'it'
,p_message_text=>unistr('Luned\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087280848307461)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'it'
,p_message_text=>unistr('Marted\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087355737307461)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'it'
,p_message_text=>unistr('Mercoled\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087475978307461)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'it'
,p_message_text=>unistr('Gioved\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087503832307461)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'it'
,p_message_text=>unistr('Venerd\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103087629790307461)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'it'
,p_message_text=>'Sabato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928107792307341)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Giorno di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928079356307341)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'it'
,p_message_text=>'Determina il giorno della settimana in cui ha inizio il calendario mensile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086390451307460)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'it'
,p_message_text=>'Domenica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086497061307460)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'it'
,p_message_text=>unistr('Luned\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086576316307460)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'it'
,p_message_text=>unistr('Marted\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086614680307461)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'it'
,p_message_text=>unistr('Mercoled\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086733736307461)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'it'
,p_message_text=>unistr('Gioved\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086802589307461)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'it'
,p_message_text=>unistr('Venerd\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103086994899307461)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'it'
,p_message_text=>'Sabato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102927991435307341)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Giorno di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928870259307341)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''ora di inizio per l''attivazione della visualizzazione del calendario settimanale e giornaliero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928707690307341)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Ora di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558592707307013)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere il contenitore statico, o selettore jQuery, che dovr\00E0 essere usato da questa azione dinamica.'),
unistr('\00C8 possibile migliorare le prestazioni delle azioni dinamiche con ambito di evento <strong>Dinamico</strong>.'),
'Deve trattarsi di un elemento della pagina che non viene ricreato, ma che contiene gli elementi di trigger ricreati mediante l''aggiornamento di pagina parziale.',
'Questo riferimento all''elemento deve essere definito come selettore jQuery.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558499244307013)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Contenitore statico (selettore jQuery)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568711915307022)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere l''ID statico per il pulsante. Se definito, l''ID statico verr\00E0 utilizzato come ID per il pulsante. L''ID statico pu\00F2 rivelarsi utile quando si sviluppa un funzionamento JavaScript personalizzato per il pulsante. Se l''ID statico non viene defi')
||'nito, il pulsante genera un ID interno.</p>',
unistr('<p>Nota: affinch\00E9 il pulsante utilizzi l''ID statico immesso \00E8 necessario che il modello includa la stringa di sostituzione <code>#BUTTON_ID#</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772987538307216)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''ID statico per la colonna. L''ID statico \00E8 utile durante lo sviluppo di un funzionamento JavaScript personalizzato o di uno stile personalizzato per l''elemento di colonna. Se l''ID statico non viene definito, per l''ID dell''elemento di colon')
||unistr('na verr\00E0 utilizzato un ID interno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450173254307748)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''ID statico per la colonna. Se definito, l''ID statico verr\00E0 utilizzato come ID per la cella di intestazione tabella corrispondente e come valore HEADERS per le celle di dati tabella corrispondenti. L''ID statico pu\00F2 rivelarsi utile quando s')
||'i sviluppa un funzionamento JavaScript personalizzato o uno stile personalizzato per la colonna. Se l''ID statico non viene definito, la tabella genera un ID interno per questi valori di attributo.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829183005307264)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''ID statico per l''asse del grafico. L''ID statico \00E8 utile quando si sviluppa un funzionamento JavaScript personalizzato per l''asse del grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829047377307264)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''ID statico per la serie del grafico. L''ID statico \00E8 utile quando si sviluppa un funzionamento JavaScript personalizzato per la serie del grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102627840859307084)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere l''ID statico per quest''area. Se definito, l''ID statico verr\00E0 utilizzato come ID per l''area, mediante la stringa di sostituzione <code>#REGION_STATIC_ID#</code>. Ci\00F2 pu\00F2 rivelarsi utile quando si sviluppa un funzionamento JavaScript perso')
||'nalizzato per l''area. Se l''ID statico non viene definito, l''area genera un ID interno.</p>',
unistr('<p>Nota: affinch\00E9 l''area utilizzi l''ID statico immesso \00E8 necessario che il modello includa la stringa di sostituzione <code>#REGION_STATIC_ID#</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558150791307012)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''ID statico per questo componente. Se definito, questo ID pu\00F2 rivelarsi utile durante lo sviluppo di un funzionamento JavaScript personalizzato per il componente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102558017521307012)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'it'
,p_message_text=>'ID statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840470920307273)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di serie da applicare al grafico borsistico visualizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840590365307273)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'it'
,p_message_text=>'Ad aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840607390307273)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'it'
,p_message_text=>'A barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840757564307273)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'it'
,p_message_text=>'A canne d''organo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840800562307273)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'it'
,p_message_text=>'A linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840979308307273)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'it'
,p_message_text=>'A linee con area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102840308470307273)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Visualizza come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560568005307015)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se l''elaborazione di tutte le altre azioni in sospeso deve essere interrotta quando si verifica un errore durante l''esecuzione dell''azione corrente.</p>',
unistr('<p>Nota: l''ordine di esecuzione delle azioni specifiche \00E8 determinato dalla sequenza specificata per ogni azione. Per garantire che le azioni vengano eseguite nello stesso ordine, Oracle consiglia di specificare numeri di sequenza univoci per tutte l')
||'e azioni True e tutte le azioni False.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560444339307015)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Arresto esecuzione in caso di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637762076307092)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Usa impostazione report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637899439307092)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna utilizzer\00E0 l''impostazione di report <strong>Estendi</strong> definita dall''utente finale per determinare se la colonna deve essere estesa o meno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637259297307092)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se la colonna deve essere estesa se lo spazio nella schermata \00E8 sufficiente. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637504948307092)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'it'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637639953307092)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna verr\00E0 estesa sempre, indipendentemente dall''impostazione di report <strong>Estendi</strong> definita dall''utente finale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637329080307092)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'it'
,p_message_text=>'Mai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637452881307092)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna non verr\00E0 estesa e utilizzer\00E0 sempre la larghezza specificata. Questa opzione \00E8 utile per le colonne con contenuto breve, ad esempio S\00EC/No o numeri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102637153082307091)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Estendi'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902349591307318)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se rimuovere o meno le tag HTML dai valori di colonna originali.',
unistr('Ci\00F2 \00E8 particolarmente importante per le colonne che utilizzano espressioni HTML, sono utilizzate nei collegamenti di colonna o vengono esportate in file CSV.</p>'),
unistr('<p>Se si selezionano nel database valori che contengono gi\00E0 tag HTML, \00E8 possibile che tali tag generino conflitti con il codice HTML generato per le espressioni HTML o con l''URL generato per i collegamenti di colonna.'),
'Durante l''esportazione dei valori interessati, le tag HTML esistenti vengono incluse come testo non codificato nel file CSV generato.',
unistr('Quando questa opzione \00E8 abilitata, viene utilizzata solo la parte dati effettiva del valore della colonna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902290976307318)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Cancella HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102758057700307202)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se includere le righe selezionate nell''elaborazione della pagina, avviata in genere da un pulsante personalizzato, ad esempio <strong>Contrassegna come completato</strong>.',
'        Le righe selezionate potranno essere utilizzate in un processo personalizzato per eseguire l''azione richiesta.</p>',
unistr('        <p>Nota: le righe selezionate verranno elaborate anche se non \00E8 stato aggiornato nulla nella riga. In genere vengono elaborate solo le righe inserite, aggiornate o eliminate.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102757996478307202)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sottomissione include le righe selezionate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622750683307081)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un''applicazione al cui schema di autorizzazione si desidera sottoscrivere questo schema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102622699144307081)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sottoscritto da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227045675307576)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il componente viene visualizzato mediante una colonna oppure una formattazione avanzata con espressioni HTML e le stringhe di sostituzione supportate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226983545307576)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formattazione avanzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227256371307576)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare come sottotitolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227195013307576)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227776597307577)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227617628307577)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227505018307576)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Le sostituzioni <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> in questo esempio sono colonne selezionate nella query SQL del report.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227470977307576)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da mostrare in questa colonna. Usare la sintassi <code>&COLUMN.</code> per mostrare i valori di colonna in formato HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103227360710307576)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881859624307303)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il messaggio di operazione riuscita per il processo.',
unistr('Se il processo viene eseguito senza generare errori, il messaggio di processo riuscito immesso verr\00E0 visualizzato nella sezione di notifica della pagina risultante visualizzata.'),
'Se si sta eseguendo la diramazione a un''altra pagina mediante un reindirizzamento di URL, potrebbe essere necessario selezionare l''attributo <em>conservazione del messaggio di operazione riuscita</em>.</p>'',',
unistr('<p>Per i processi che interessano pi\00F9 righe \00E8 possibile usare la stringa di sostituzione riportata di seguito per ottenere il numero di record elaborati.</p>'),
'<ul>',
'  <li>Inserimento: <code>#MRI_COUNT#</code></li>',
'  <li>Aggiornamento: <code>#MRU_COUNT#</code></li>',
'  <li>Eliminazione: <code>#MRD_COUNT#</code></li>',
'</ul>',
unistr('<p>Per il tipo di processo Invia messaggio di posta elettronica \00E8 possibile usare la stringa di sostituzione <code>#TO#</code> per ottenere i destinatari del messaggio di posta elettronica.</p>'),
'<p>I plugin possono disporre di altre stringhe di sostituzione. Vedere la documentazione dei plugin per informazioni dettagliate.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103036202566307422)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il testo da visualizzare nell''area "Notifica" (definita come parte del modello di pagina) quando il processo viene completato e riesce.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102881345090307303)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Messaggio di operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577865756307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la query SQL utilizzata come origine dei suggerimenti.</p>',
'<p>Nota: l''ordine con cui vengono restituiti i valori viene utilizzato per determinare l''ordine di visualizzazione degli stessi.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577739283307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577689740307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere la lista separata da virgole di valori statici da utilizzare come origine dei suggerimenti.</p>',
'<p>Nota: l''ordine con cui vengono specificati i valori viene utilizzato per determinare l''ordine di visualizzazione degli stessi.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577513425307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102579818288307032)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102580598825307033)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576898155307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare le modalit\00E0 di determinazione dei suggerimenti per questo filtro.</p>'),
'<p>Nota: i valori forniti vengono comunque confrontati con le voci visibili della lista di valori e verranno utilizzati solo se viene rilevata una corrispondenza.',
unistr('Un valore non trovato verr\00E0 saltato e verr\00E0 controllato il valore successivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576930812307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'it'
,p_message_text=>'Dinamico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577065680307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Seleziona la <strong>prima</strong> voce visibile dalla lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577358060307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577454518307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'I valori vengono restituiti dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577123634307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valori statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102577233215307030)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Lista di valori separata da virgole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102576720234307029)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845585816307277)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il testo da visualizzare nella parte superiore dei file di download. \00C8 possibile immettere messaggi con classificazione dei dati, contenuto legale o avvertenze per i dati contenuti nei file.</p>'),
unistr('        <p> Nota: il testo immesso verr\00E0 incluso in tutti i formati di download dei report. Se \00E8 abilitato il download in formato CSV, il testo definito invalider\00E0 il formato di file CSV.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845400490307277)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Testo supplementare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860780716307288)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare questo attributo se si desidera usare il testo dell''intestazione della colonna come etichetta nella vista dei dettagli.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102860616920307288)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Usa intestazione colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916063435307332)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la base per questa colonna del form tabulare.</p>',
unistr('<p>La selezione determina se la colonna pu\00F2 essere aggiornata nel form tabulare.'),
unistr('Gli aggiornamenti possono essere eseguiti solo se viene definito un aggiornamento di pi\00F9 righe o implementato un processo PL/SQL per elaborare i dati aggiornati.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083430665307458)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'it'
,p_message_text=>'Selettore data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251803715307595)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la data oppure utilizzare il selettore data per selezionarla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083364764307458)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'it'
,p_message_text=>'Selettore data (classico)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251980889307595)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la data oppure utilizzare il selettore data per selezionarla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083264338307458)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'it'
,p_message_text=>'Testo non codificato (salva lo stato)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250533360307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Visualizza il valore della colonna e ne effettua il salvataggio nello stato della sessione. Questa colonna pu\00F2 essere utilizzata nell''elaborazione delle pagine.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084989457307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'it'
,p_message_text=>'Scarica BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250946537307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come collegamento per scaricare il file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084441220307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna nascosta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252090285307595)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Non visualizza la colonna, ma \00E8 possibile farvi riferimento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083939996307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'it'
,p_message_text=>'Colonna nascosta (salva lo stato)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103252125082307595)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Non visualizza la colonna, ma \00E8 possibile farvi riferimento. Questa colonna pu\00F2 essere utilizzata nell''elaborazione delle pagine.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084868764307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'it'
,p_message_text=>'Visualizza immagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250876706307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come immagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084775701307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'it'
,p_message_text=>'Collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250796077307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come collegamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103085079920307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'it'
,p_message_text=>'Grafico di percentuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251097095307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza la colonna come grafico di percentuale. Il valore recuperato deve essere compreso tra 0 e 100.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084579562307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'it'
,p_message_text=>'Testo non codificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250450319307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il valore della colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084609774307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'it'
,p_message_text=>'Testo non codificato (basato su lista di valori)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250609864307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il valore restituito dalla lista di valori specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084032534307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'it'
,p_message_text=>'LOV popup (mostra il valore restituito)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251524644307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un valore nel popup. Viene mostrato il valore restituito della lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084130523307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'it'
,p_message_text=>'LOV popup (mostra il valore visualizzato)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251426440307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un valore nel popup. Viene mostrato il valore visualizzato della lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083885743307458)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'it'
,p_message_text=>'Gruppo pulsanti di scelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251685202307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un solo gruppo di scelta nella lista di valori specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084378778307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'it'
,p_message_text=>'Selettore di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103250353173307593)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>'Include una casella di controllo all''inizio di ogni riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083768477307458)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'it'
,p_message_text=>'Lista di selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251387964307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un valore nella lista di valori specificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103084296367307459)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'it'
,p_message_text=>'Casella di controllo semplice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251735561307595)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare o deselezionare una sola casella di controllo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083549350307458)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Campo di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251150154307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un valore in un campo di testo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103083622254307458)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'it'
,p_message_text=>'Area di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103251240317307594)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un valore in un campo area di testo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102915926507307332)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638836998307093)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Fare clic su Destinazione per richiamare una finestra di dialogo di tipo modale. \00C8 possibile immettere la destinazione che viene chiamata quando viene richiamata la diramazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102638710091307093)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219307081307571)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare le opzioni di modello per personalizzare l''interfaccia utente di questo componente.</p>',
unistr('<p>Utilizzando la voce <strong>Opzioni modello attive</strong>, \00E8 inoltre possibile modificare le opzioni di modello quando si esegue l''applicazione.'),
unistr('Tramite Opzioni modello attive \00E8 possibile personalizzare l''applicazione in tempo reale, verificando in anteprima e applicando varie opzioni.'),
'Per accedere a Opzioni modello attive, eseguire l''applicazione da Application Builder e fare clic su <em>Modifica rapida</em> nella barra degli strumenti sviluppatore.',
'Passare il mouse su un componente di pagina, ad esempio un''area, e fare clic sull''icona che rappresenta una chiave inglese ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) visualizzata nell''angolo superiore sinistro.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219234966307570)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Opzioni modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219590028307571)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare le opzioni di modello per personalizzare l''interfaccia utente di questo componente.</p>',
unistr('<p>Utilizzando la voce <strong>Opzioni modello attive</strong>, \00E8 inoltre possibile modificare le opzioni di modello quando si esegue l''applicazione.'),
unistr('Tramite Opzioni modello attive \00E8 possibile personalizzare l''applicazione in tempo reale, verificando in anteprima e applicando varie opzioni.'),
'Per accedere a Opzioni modello attive, eseguire l''applicazione da Application Builder e fare clic su <em>Modifica rapida</em> nella barra degli strumenti sviluppatore.',
'Passare il mouse su un componente di pagina, ad esempio un''area, e fare clic sull''icona che rappresenta una chiave inglese ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) visualizzata nell''angolo superiore sinistro.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219411389307571)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Opzioni modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467632326306933)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'it'
,p_message_text=>'Segnaposto all''interno di un modello di posta elettronica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467529655306933)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Segnaposto modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900906147307317)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di modello per questo report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080188664307456)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'it'
,p_message_text=>'Predefiniti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080269605307456)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Modelli di report predefiniti non associati in modo diretto ad alcun tema. Poich\00E9 non esiste una correlazione tra i modelli predefiniti e il tema corrente, il layout del report non cambia anche se si modifica il tema dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103079931542307456)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103080049349307456)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'it'
,p_message_text=>'Modelli di report disponibili nel tema corrispondente, basati sul tema corrente per l''interfaccia utente di questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102900847352307317)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408125752307715)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A seconda se viene specificato il <strong>tipo di ricerca</strong>, immettere un nome o una lista di nomi colonna di database utilizzati per la ricerca.</p>',
'<ul>',
'  <li><strong>Ricerca delle righe</strong>: immettere una lista separata da virgole di nomi colonna di database di tipo VARCHAR2 utilizzati per la ricerca di testo. Se non viene specificata alcuna colonna, verranno utilizzate automaticamente tutte le'
||' colonne VARCHAR2.</li>',
'  <li><strong>Oracle Text</strong>: immettere un nome colonna di database con distinzione tra maiuscole/minuscole che contenga l''indice Oracle Text.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408025173307715)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna/e di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679916586307130)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tema da associare all''interfaccia utente corrente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102679858630307129)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827879318307263)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la posizione delle etichette di graduazione rispetto all''area di rappresentazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102828018610307264)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'it'
,p_message_text=>'Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827906946307264)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'it'
,p_message_text=>'Esterno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827719831307263)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827416723307263)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se le etichette di graduazione vengono visualizzate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827378855307263)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827627951307263)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Specificare se le etichette verranno ruotate in modo automatico di 90 gradi nel grafico per adattare pi\00F9 etichette sull''asse.'),
unistr('        La rotazione verr\00E0 applicata solo alle etichette di categoria per un asse orizzontale.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102827538032307263)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Rotazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198206628307555)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'it'
,p_message_text=>'Uguale a standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329072596307653)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Utilizzare la stessa mappa di sfondo per la modalit\00E0 chiara e scura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152886761307510)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Scegliere il layer a tasselli da utilizzare come mappa di sfondo quando \00E8 abilitata la modalit\00E0 scuro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153756745307511)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'it'
,p_message_text=>'Mappa del mondo Oracle BI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153822928307511)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base non invadente basata sui dati mappa HERE. Questo stile di mappa base fornisce il contesto di posizione dei dati e ne accentua la visualizzazione.</p>',
'<p>Schema e definizioni di stile di Oracle, Stati Uniti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153398205307511)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'it'
,p_message_text=>'OpenStreetMap brillante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153457460307511)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base generica basata sui dati OpenStreetMap. Questo stile di mappa base fornisce un contesto di posizione dettagliato per i dati.</p>',
'<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152930083307510)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'it'
,p_message_text=>'OpenStreetMap scura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153022710307510)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Mappa base chiara non invadente basata sui dati OpenStreetMap. Questo stile di mappa base accentua le visualizzazioni dei dati.</p>',
unistr('<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY. La cartografia di Stamen Design \00E8 concessa in licenza in base a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153157936307510)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'it'
,p_message_text=>'OpenStreetMap Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153216528307510)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base scura non invadente basata sui dati OpenStreetMap. Questo stile di mappa base accentua le visualizzazioni dei dati.</p>',
unistr('<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY. La cartografia di Stamen Design \00E8 concessa in licenza in base a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153500292307511)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'it'
,p_message_text=>'Mappa del mondo Oracle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103153681001307511)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base generica basata sui dati mappa HERE. Questo stile di mappa base fornisce il contesto di posizione dei dati e ne accentua la visualizzazione.</p>',
'<p>Schema e definizioni di stile di Oracle, Stati Uniti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152799970307510)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 scuro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151649220307509)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>'Scegliere il layer a tasselli da utilizzare come mappa di sfondo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152546217307510)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'it'
,p_message_text=>'Mappa del mondo Oracle BI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152686591307510)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base non invadente basata sui dati mappa HERE. Questo stile di mappa base fornisce il contesto di posizione dei dati e ne accentua la visualizzazione.</p>',
'<p>Schema e definizioni di stile di Oracle, Stati Uniti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152172612307510)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'it'
,p_message_text=>'OpenStreetMap brillante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152296571307510)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base generica basata sui dati OpenStreetMap. Questo stile di mappa base fornisce un contesto di posizione dettagliato per i dati.</p>',
'<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151907145307509)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'it'
,p_message_text=>'OpenStreetMap scura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152010243307509)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base scura non invadente basata sui dati OpenStreetMap. Questo stile di mappa base accentua le visualizzazioni dei dati.</p>',
unistr('<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY. La cartografia di Stamen Design \00E8 concessa in licenza in base a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151789312307509)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'it'
,p_message_text=>'OpenStreetMap Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151854637307509)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base chiara non invadente basata sui dati OpenStreetMap. Questo stile di mappa base accentua le visualizzazioni dei dati.</p>',
unistr('<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY. La cartografia di Stamen Design \00E8 concessa in licenza in base a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152367135307510)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'it'
,p_message_text=>'Mappa del mondo Oracle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103152445684307510)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base generica basata sui dati mappa HERE. Questo stile di mappa base fornisce il contesto di posizione dei dati e ne accentua la visualizzazione.</p>',
'<p>Schema e definizioni di stile di Oracle, Stati Uniti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151506041307509)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151080472307509)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la mappa di sfondo da usare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151397206307509)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151417261307509)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare i layer a tasselli della mappa da utilizzare per la mappa di sfondo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151172475307509)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103151203857307509)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>'Usare le impostazioni predefinite della mappa di sfondo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103150917039307509)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sfondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928646456307341)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare la modalit\00E0 di visualizzazione del formato dell''ora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088434544307462)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'it'
,p_message_text=>'12 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103088518253307462)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'it'
,p_message_text=>'24 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102928506316307341)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato ora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417325779307722)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un titolo per l''asse. Questo titolo descrive le informazioni rappresentate sull''asse del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568072515307021)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un titolo da visualizzare nella barra del titolo della finestra del browser. Il motore di &PRODUCT_NAME. utilizza il titolo specificato anzich\00E9 la stringa di sostituzione <code>#TITLE#</code> utilizzata nel modello di pagina. Questo titolo ')
||'viene inserito tra le tag HTML <code>&lt;TITLE&gt;</code> e <code>&lt;/TITLE&gt;</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102568954098307022)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere un titolo di area. Questo titolo viene visualizzato solo se \00E8 stato definito nel modello di area.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530341359306987)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il titolo della pagina. Il titolo della pagina viene visualizzato nella barra del titolo della finestra del browser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102530228547306987)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226139942307575)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se il componente viene visualizzato mediante una colonna oppure una formattazione avanzata con espressioni HTML e le stringhe di sostituzione supportate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226084408307575)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formattazione avanzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226330552307576)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna da utilizzare come titolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226269235307576)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226894517307576)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere le classi da aggiungere al componente. \00C8 possibile aggiungere pi\00F9 classi separandole con spazi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226793369307576)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Classi CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226618900307576)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Le sostituzioni <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> in questo esempio sono colonne selezionate nella query SQL del report.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226511927307576)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere le espressioni HTML da mostrare in questa colonna. Usare la sintassi <code>&COLUMN.</code> per mostrare i valori di colonna in formato HTML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103226496034307576)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779682498307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare i controlli aggiuntivi da visualizzare nella barra degli strumenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780180435307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'it'
,p_message_text=>'Menu Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780251510307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il pulsante del menu Azioni, che include in genere un set completo di opzioni. Queste opzioni consentono all''utente finale di personalizzare il report in base alle funzioni disponibili.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780318401307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'it'
,p_message_text=>'Pulsante Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780495953307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza il pulsante Reimposta. Quando si seleziona questo pulsante, vengono rimosse tutte le personalizzazioni, ad esempio filtri, larghezza colonna e ordinamento, e la definizione del report viene ricaricata dal server.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780525244307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'it'
,p_message_text=>'Pulsante Salva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780693066307224)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Visualizza il pulsante Salva. Quando si seleziona questo pulsante, vengono salvate solo le modifiche apportate a questa griglia interattiva e non \00E8 necessario salvare l''intera pagina.'),
unistr('        <p>Il pulsante Salva viene visualizzato solo se la griglia interattiva \00E8 modificabile e l''utente finale dispone dell''autorizzazione per effettuare le operazioni di aggiunta, aggiornamento o eliminazione.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779799819307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Selezione di colonne per la ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779818250307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza un elenco a discesa delle colonne non numeriche visualizzate. Se una colonna viene selezionata, la ricerca viene eseguita solo in base ai valori della colonna selezionata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779936607307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'it'
,p_message_text=>'Campo di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102780041020307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'it'
,p_message_text=>'Visualizza un campo di testo nella barra di ricerca utilizzato per immettere i criteri di ricerca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779589969307223)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Controlli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342141020307663)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103246614500307591)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342241208307663)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102884069620307305)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Indica se questa colonna dipende o meno dal fuso orario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883923065307305)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dipendente dal fuso orario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917303130307333)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il nome di colonna a cui fa riferimento questa colonna di report.',
'Questo attributo viene utilizzato per confrontare i riferimenti alle colonne tra applicazioni in base ai valori predefiniti dell''interfaccia utente.',
'Questo riferimento viene gestito manualmente dopo essere stato inizializzato mediante una procedura guidata, ove possibile.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917264915307333)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917184227307333)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare la tabella o la vista a cui fa riferimento questa colonna.',
'Questo attributo viene utilizzato per confrontare i riferimenti alle colonne tra le applicazioni in base ai valori predefiniti dell''interfaccia utente.',
'Questo riferimento viene gestito manualmente dopo essere stato inizializzato mediante una procedura guidata, ove possibile.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917050675307333)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916936793307333)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare lo schema proprietario della tabella di riferimento.',
'Questo attributo viene utilizzato per confrontare i riferimenti con le colonne tra le applicazioni in base alle impostazioni predefinite dell''interfaccia utente.',
'Questo riferimento viene gestito manualmente, ove possibile, dopo essere stato inizializzato mediante una procedura guidata.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102916880513307332)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Proprietario tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868842761307294)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare il tipo di colonna usato per identificare la riga corrente quando si utilizza la colonna di collegamento.',
unistr('Per impostazione predefinita, per identificare in modo univoco le righe in un report si usa <strong>ROWID</strong>. \00C8 tuttavia possibile utilizzare un''altra colonna selezionando <strong>Colonna univoca</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103069077782307448)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna univoca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103068957291307447)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'it'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868735932307294)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Identifica univocamente le righe per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869030963307294)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la prima colonna da utilizzare per identificare in modo univoco le righe per questo componente.</p>',
unistr('<p>Nella lista delle colonne disponibili \00E8 inclusa anche la colonna <strong>ROWID</strong> per garantire la compatibilit\00E0 con le versioni precedenti.</p>'),
unistr('<p>Nota: per un report interattivo con l''attributo <em>Colonna di collegamento</em> impostato su <strong>Collega a vista a riga singola</strong>, \00E8 possibile selezionare una sola colonna univoca. Per gli altri componenti \00E8 possibile selezionare fino ')
||'a tre colonne.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102868925832307294)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna univoca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869229510307294)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la seconda colonna da utilizzare per identificare in modo univoco le righe per questo componente. Usare questo attributo quando la tabella contiene una chiave primaria costituita da due parti.</p>',
unistr('<p>Nella lista delle colonne disponibili \00E8 inclusa anche la colonna <strong>ROWID</strong> per garantire la compatibilit\00E0 con le versioni precedenti.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869111323307294)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna univoca 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869478535307294)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la terza colonna da utilizzare per identificare in modo univoco le righe per questo componente. Usare questo attributo quando la tabella contiene una chiave primaria costituita da tre parti.</p>',
unistr('<p>Nella lista delle colonne disponibili \00E8 inclusa anche la colonna <strong>ROWID</strong> per garantire la compatibilit\00E0 con le versioni precedenti.</p>'),
unistr('<p>Nota: se la chiave primaria della tabella contiene pi\00F9 di tre colonne, sar\00E0 necessario identificare in modo univoco le righe mediante la colonna <strong>ROWID</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102869305826307294)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna univoca 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756810537307201)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare uno schema di autorizzazione per limitare il numero degli utenti che possono aggiornare le righe.',
'Per consentire a un utente finale di aggiornare le righe, lo schema di autorizzazione selezionato deve restituire TRUE.',
'Se non viene fornito alcuno schema di autorizzazione, tutti gli utenti potranno aggiornare le righe in questa griglia interattiva.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102756744456307201)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644382189307097)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'it'
,p_message_text=>'Mostra l''interfaccia utente per questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644237363307097)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678917316307129)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare un tipo di interfaccia utente per questa pagina. Per le pagine destinate principalmente all''uso su desktop, selezionare <strong>Desktop</strong>. Per le altre interfacce, quali smartphone o tablet, selezionare l''interfaccia utente corrisp'
||'ondente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063120699307443)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'it'
,p_message_text=>'Desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103063286085307443)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'it'
,p_message_text=>'Smartphone jQuery Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102678845601307129)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102894049522307312)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se questa colonna viene visualizzata anche nell''intestazione di riga.',
unistr('L''inclusione del valore di colonna pu\00F2 migliorare sensibilmente l''accesso facilitato per i campi visualizzati in un report.'),
unistr('Quando lo si specifica, l''intestazione di riga viene usata insieme all''intestazione di colonna per visualizzare le etichette per i campi dei form nel report. Il formato utilizzato \00E8 <code>''&lt;Intestazione colonna&gt; : &lt;Intestazione riga&gt;''</co')
||'de>.</p>',
unistr('<p>Si supponga ad esempio di disporre di un report nella tabella EMP e di definire la colonna ENAME come intestazione di riga. Per una riga in cui ENAME \00E8 ''JONES'', l''etichetta per il campo Stipendio di tale riga sar\00E0 "Stipendio : JONES".'),
'Questo approccio consente all''utente di un lettore di schermo di navigare in base ai campi del form nel report e di continuare a mantenere una chiara visione della relazione tra i campi dei form e la riga corrispondente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102893903490307312)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Usa come intestazione di riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922356394307337)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare se si desidera definire un collegamento personalizzato per la vista icone. Questa opzione offre una maggiore flessibilit\00E0 quando si definisce il contenuto della vista icone, compresa la possibilit\00E0 di utilizzare pi\00F9 colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922258407307337)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641479192307095)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare l''area associata per questa convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641393543307095)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area modificabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639905693307093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare il tipo di uguaglianza da sottoporre a test per questa convalida. A seconda della selezione effettuata, per definire in modo completo la convalida saranno necessari uno o pi\00F9 attributi aggiuntivi.</p>'),
'<p>Se la convalida supera il test di uguaglianza oppure restituisce TRUE, il messaggio di errore di convalida non viene visualizzato.',
'I messaggi di errore di convalida vengono visualizzati quando la convalida non supera il test di uguaglianza o restituisce FALSE, oppure quando viene restituita una stringa di testo non vuota.</p>',
'<p>Un errore di convalida non impedisce la valutazione delle convalide successive, pertanto ogni convalida successiva potrebbe restituire un messaggio di errore di convalida aggiuntivo. Se si desidera impedire l''esecuzione delle convalide successive,'
||unistr(' \00E8 necessario aggiungere ulteriore logica alla prima convalida non riuscita, ad esempio impostando un elemento di pagina su un valore specifico e quindi migliorando la logica condizionale nelle convalide successive in base alle esigenze. Se una o pi\00F9')
||' convalide non superano la valutazione, i processi e le diramazioni successivi non verranno eseguiti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096686619307468)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Righe restituite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096740846307468)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se la query SQL restituisce una o pi\00F9 righe.<br>'),
'Non riesce se la query SQL non restituisce alcuna riga.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302851732307634)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103302965158307634)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se l''espressione restituisce TRUE.<br>',
'Non riesce se l''espressione restituisce FALSE.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097245039307468)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione (che restituisce un valore booleano)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097397176307468)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il corpo funzione restituisce TRUE.<br>',
'Non riesce se il corpo funzione restituisce FALSE.<br>',
'Nota: il risultato restituito dalla funzione deve essere booleano.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097402361307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione (che restituisce il testo dell''errore)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097544099307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il corpo funzione restituisce una stringa vuota.<br>',
'Non riesce se il corpo funzione restituisce una stringa non vuota. La stringa restituita viene visualizzata come messaggio di errore per la convalida.<br>',
'Nota: il risultato restituito dalla funzione deve essere una stringa di testo.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098284440307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento non contiene spazi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098379799307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore dell''elemento non contiene spazi.<br>',
'Non riesce se il valore dell''elemento contiene spazi.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100264111307471)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento contiene almeno uno dei caratteri presenti nel valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100345949307471)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore dell''elemento include almeno un carattere del testo immesso nell''attributo <em>Valore</em>.<br>',
'Non riesce se il valore dell''elemento non include alcun carattere del testo immesso nell''attributo <em>Valore</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100475285307471)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento NON contiene alcun carattere del valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100553378307471)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore dell''elemento non include alcun carattere del testo immesso nell''attributo <em>Valore</em>.<br>',
'Non riesce se il valore dell''elemento include almeno un carattere del testo immesso nell''attributo <em>Valore</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100065470307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento contiene solo i caratteri specificati nel valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100164514307471)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore dell''elemento contiene solo i caratteri presenti nel testo immesso nell''attributo <em>Valore</em>.<br>',
'Non riesce se il valore dell''elemento contiene caratteri che non si trovano nel testo immesso nell''attributo <em>Valore</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099215409307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento = valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099385285307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.<br>'),
unistr('Non riesce se il valore dell''elemento non \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099671247307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099764497307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.<br>'),
unistr('Non riesce se il valore dell''elemento non \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099403192307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'it'
,p_message_text=>'Elemento != valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099550705307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento non \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.<br>'),
unistr('Non riesce se il valore dell''elemento \00E8 uguale al testo immesso nell''attributo <em>Valore</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099886412307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 contenuto nel valore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099948642307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento non \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.<br>'),
unistr('Non riesce se il valore dell''elemento \00E8 contenuto completamente nel testo immesso nell''attributo <em>Valore</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098498781307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 alfanumerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098502270307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento \00E8 alfanumerico, ovvero contiene solo lettere e numeri senza caratteri speciali.<br>'),
'Non riesce se il valore dell''elemento contiene caratteri speciali.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098832180307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 una data valida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098977429307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento \00E8 una data valida.<br>'),
unistr('Non riesce se il valore dell''elemento non \00E8 una data valida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098669768307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098774163307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento \00E8 numerico.<br>'),
'Non riesce se il valore dell''elemento contiene caratteri non numerici, ovvero include spazi diversi dagli spazi iniziali.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099029146307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 un indicatore orario valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103099116955307470)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento \00E8 un indicatore orario valido.<br>'),
unistr('Non riesce se il valore dell''elemento non \00E8 un indicatore orario valido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097602709307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097725867307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento non \00E8 vuoto.<br>'),
unistr('Non riesce se il valore dell''elemento \00E8 vuoto.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097878492307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento \00E8 NOT NULL o zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097914983307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento non \00E8 vuoto e non \00E8 il numero zero.<br>'),
unistr('Non riesce se il valore dell''elemento \00E8 vuoto o \00E8 il numero zero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098093919307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento NON \00E8 pari a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103098109604307469)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Riesce se il valore dell''elemento non \00E8 il numero zero.<br>'),
unistr('Non riesce se il valore dell''elemento \00E8 il numero zero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096858494307468)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'it'
,p_message_text=>'Nessuna riga restituita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103096922688307468)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se la query SQL non restituisce alcuna riga.<br>',
unistr('Non riesce se la query SQL restituisce una o pi\00F9 righe.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097035121307468)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'it'
,p_message_text=>'Errore PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103097145950307468)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il codice PL/SQL viene eseguito senza generare errori.<br>',
'Non riesce se l''espressione PL/SQL genera un errore durante l''esecuzione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100613678307471)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'L''elemento corrisponde all''espressione regolare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103100756287307471)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Riesce se il valore dell''elemento corrisponde all''espressione regolare immessa nell''attributo <em>Valore</em>.',
'Non riesce se il valore dell''elemento non corrisponde all''espressione regolare immessa nell''attributo <em>Valore</em>.<br>',
unistr('Nota: le espressioni regolari consentono di cercare i pattern nei dati delle stringhe mediante convenzioni di sintassi standardizzate anzich\00E9 mediante il semplice confronto dei caratteri.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639887107307093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825086764307261)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare se la baseline dell''asse inizia in corrispondenza del valore minimo dei dati oppure da zero. Si applica solo agli assi dei dati numerici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825112094307261)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'it'
,p_message_text=>'Minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102825208444307262)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'it'
,p_message_text=>'Zero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102824978105307261)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Scala baseline'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856784763307285)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il nome della raccolta. L''origine per questo valore di parametro si baser\00E0 sul valore della colonna CLOB della prima riga della raccolta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856665907307285)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811368903307251)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere la valuta che verr\00E0 usata durante la formattazione del valore nel grafico.'),
unistr('        Il valore deve essere un codice di valuta alfabetico ISO 4217. Se il formato \00E8 impostato su Valuta e non \00E8 definita alcuna valuta nella propriet\00E0 <strong>Valuta</strong>, la valuta verr\00E0 derivata automaticamente dalla lingua dell''applicazione')
||' quando viene visualizzato il grafico.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811234043307251)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valuta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937429156307348)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il numero di posizioni decimali da applicare al valore numerico nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102925049036307339)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il numero di posizioni decimali da utilizzare nelle etichette dei valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102924972683307339)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizioni decimali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313716761307642)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314123725307643)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314033833307643)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313901310307642)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314263847307643)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313881020307642)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103313612718307642)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811773406307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il funzionamento della scala sui valori del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811992602307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812288713307252)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'it'
,p_message_text=>'Miliardo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812194473307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'it'
,p_message_text=>'Milione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811860056307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812404682307252)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'it'
,p_message_text=>'Quadrilione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812005469307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'it'
,p_message_text=>'Migliaia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102812383604307252)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'it'
,p_message_text=>'Trilione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811656806307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato scala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937335605307348)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare il tipo di formattazione da applicare al valore nel grafico.',
'        I formati <strong>Decimale</strong>, <strong>Percentuale</strong> e <strong>Valuta</strong> si applicano solo ai valori numerici.',
'        I formati <strong>Data</strong>, <strong>Ora</strong> e <strong>Data e ora</strong> verranno applicati solo ai valori dei rispettivi tipi di dati nel grafico.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809743924307249)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo di formato numerico, data e/o ora da applicare al valore nel grafico. Per il formato data e/o ora, assicurarsi che l''attributo di grafico <strong>Tipo asse temporale</strong> sia impostato su uno dei valori seguenti, a seconda del'
||' tipo di dati del grafico: <strong>Abilitato</strong>, <strong>Frequenza mista</strong> o <strong>Salta divari</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811035849307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'it'
,p_message_text=>'Valuta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948396976307356)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Quando si imposta il formato valuta per un numero, la propriet\00E0 Valuta deve essere impostata sulla valuta specifica che verr\00E0 utilizzata per la formattazione del numero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810172968307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'it'
,p_message_text=>'Data - Completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947228207307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Con il tipo di formato Completo, la data formattata contiene il nome intero del giorno della settimana (EEEE), l''anno (a), il nome intero del mese (MMMM) e il giorno (g). Ad esempio: Mercoled\00EC 6 gennaio 2016.'),
'        In alcune lingue i nomi interi dei mesi non vengono utilizzati; nella lingua Giapponese, ad esempio, nei pattern viene utilizzato il numero del mese.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810057302307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'it'
,p_message_text=>'Data - Lungo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947104161307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'it'
,p_message_text=>'Con il tipo di formato Lungo, la data formattata contiene l''anno, il nome intero del mese e il giorno. Ad esempio: 6 gennaio 2016.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809981841307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'it'
,p_message_text=>'Data - Medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947094659307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Medio, la data formattata contiene l''anno, l''abbreviazione del mese (MMM) e il giorno. Ad esempio: 6 gen 2016.',
'        In alcune lingue le abbreviazioni dei mesi non vengono utilizzate; in questo caso il formato Medio contiene il numero del mese (MM/M).'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809866216307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'it'
,p_message_text=>'Data - Breve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102946900128307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'it'
,p_message_text=>'Con il tipo di formato Breve, la data formattata contiene l''anno, il numero del mese (MM/M) e il giorno. Ad esempio: 1/6/16.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948093109307356)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'it'
,p_message_text=>'Date e ora - Completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948196287307356)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Completo, la data e l''ora formattate contengono il nome intero del giorno della settimana (EEEE), l''anno (a), il nome intero del mese (MMMM), il giorno (g), i minuti (mm), i secondi (ss) e il fuso orario (zzzz). Ad esempio: Mer'
||unistr('coled\00EC 6 gennaio 2016 7 h 30 min 21 s.'),
'        Il formato dell''ora dipende dall''utilizzo o dal non utilizzo del formato a 12 ore nella lingua dell''applicazione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810879266307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'it'
,p_message_text=>'Data e ora - Lungo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947918693307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Lungo, la data e l''ora formattate contengono l''anno, il nome intero del mese, il giorno, l''ora, i minuti, i secondi e il fuso orario (z). Ad esempio: 6 gennaio 2016 7:30:21 AM.',
'        Il formato dell''ora dipende dall''utilizzo o dal non utilizzo del formato a 12 ore nella lingua dell''applicazione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810765282307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'it'
,p_message_text=>'Data e ora - Medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947826067307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Medio, la data e l''ora formattate contengono l''anno, l''abbreviazione del mese (MMM), il giorno, l''ora, i minuti, i secondi e il fuso orario. Ad esempio: 6 gennaio 2016 7:30:21 AM.',
'        Il formato dell''ora dipende dall''utilizzo o dal non utilizzo del formato a 12 ore nella lingua dell''applicazione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810621208307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'it'
,p_message_text=>'Data e ora - Breve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947788918307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Breve, la data e l''ora formattate contengono l''anno, il numero del mese (MM/M), il giorno, l''ora e i minuti. Ad esempio: 1/6/16 7:30 AM.',
'        Il formato dell''ora dipende dall''utilizzo o dal non utilizzo del formato a 12 ore nella lingua dell''applicazione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810974738307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'it'
,p_message_text=>'Decimale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948217176307356)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Quando si imposta il formato decimale per un numero, il carattere decimale viene sostituito con il simbolo pi\00F9 appropriato delle impostazioni nazionali. In Inglese si usa il punto ("."), mentre altre impostazioni nazionali prevedono la virgola (",").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811195823307251)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'it'
,p_message_text=>'Percentuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102948429196307356)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Quando si imposta il formato percentuale per un numero, i valori vengono moltiplicati per 100 per applicare il formato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810567905307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'it'
,p_message_text=>'Ora - Completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947680646307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Completo, l''ora formattata contiene l''ora (h/H), i minuti (mm), i secondi (ss) e il fuso orario (zzzz). Ad esempio: 7 h 30 min 21 s.',
'        Il formato dell''ora dipende dall''utilizzo o dal non utilizzo del formato a 12 ore nella lingua dell''applicazione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810460570307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'it'
,p_message_text=>'Ora - Lungo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947517592307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Lungo, l''ora formattata contiene l''ora, i minuti, i secondi e il fuso orario (z). Ad esempio: 7:30:21 AM.',
'        Il formato dell''ora dipende dall''utilizzo o dal non utilizzo del formato a 12 ore nella lingua dell''applicazione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810302605307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'it'
,p_message_text=>'Ora - Medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947418858307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Medio, l''ora formattata contiene l''ora, i minuti e i secondi. Ad esempio: 7:30:21 AM.',
'        Il formato dell''ora dipende dall''utilizzo o dal non utilizzo del formato a 12 ore nella lingua dell''applicazione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102810220751307250)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'it'
,p_message_text=>'Ora - Breve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102947337327307355)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Con il tipo di formato Breve, l''ora formattata contiene l''ora e i minuti. Ad esempio: 7:30 AM.',
'        Il formato dell''ora dipende dall''utilizzo o dal non utilizzo del formato a 12 ore nella lingua dell''applicazione.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809632898307249)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315746440307644)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316096029307644)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315943829307644)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315830715307644)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316126059307644)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315624729307644)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853646622307283)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere l''elemento di pagina o di applicazione utilizzato come origine per questo valore di parametro.',
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853521394307283)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315318381307644)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione Java che produce un valore utilizzato come origine per questo valore di parametro.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315202391307643)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316958289307645)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione Java che restituisce un valore utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316808848307645)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315186812307643)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315009417307643)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione JavaScript che produce un valore utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314946088307643)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316777752307645)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316627316307644)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione JavaScript che restituisce un valore utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316502920307644)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809566961307249)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il valore minimo per il grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102809463785307249)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937586090307348)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare il pattern numerico da applicare al valore numerico nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103429238400307731)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Pattern numerico per rappresentare le temperature in gradi Farenheit, ad esempio 15&deg;F:</dt>',
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
'<dt>Pattern numerico per rappresentare i numeri in un formato specifico, ad esempio 12,30,00:</dt>',
'<dd><pre>',
'##,##,##',
'</pre></dd>',
'<dt>Pattern numerico per rappresentare i numeri in millimetri:</dt>',
'<dd><pre>',
'# mm',
'</pre></dd>',
'<dt>Pattern di data per rappresentare la data con il formato Mese Anno, ad esempio Lug 2016:</dt>',
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
'<dt>Pattern di data per rappresentare la data con il formato Mese, ad esempio July:</dt>',
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811590940307251)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere un pattern numerico o di data localizzato facoltativo i cui caratteri siano conformi al repository CLDR Unicode per i formati di data e ora.',
unistr('        Se specificato, il pattern sostituir\00E0 il formato selezionato.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102811400889307251)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pattern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314844542307643)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314704899307643)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione PL/SQL che produce un valore utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314657552307643)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316497048307644)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per fare in modo che venga restituito YES quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316357044307644)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce un valore utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103316269381307644)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282974307306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'it'
,p_message_text=>'Specificare la posizione in cui deve essere visualizzato il valore nel grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282315803306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'it'
,p_message_text=>'Automatico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283015487306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il valore verr\00E0 visualizzato nella posizione predefinita per il grafico, che si trova all''esterno dell''area di rappresentazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282475878306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'it'
,p_message_text=>'Al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283176718306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il valore verr\00E0 visualizzato al centro dell''indicatore sul grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282564493306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'it'
,p_message_text=>'All''interno del bordo indicatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283223060306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il valore verr\00E0 visualizzato all''interno del bordo dell''indicatore sul grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282601668306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'it'
,p_message_text=>'All''esterno del bordo indicatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283314858306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il valore verr\00E0 visualizzato all''esterno del bordo dell''indicatore sul grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282761655306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'it'
,p_message_text=>'All''esterno dell''area di rappresentazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283413713306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il valore verr\00E0 visualizzato all''esterno dell''area di rappresentazione del grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282883846306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'it'
,p_message_text=>'Con etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283519425306785)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Se viene visualizzata l''etichetta, il valore verr\00E0 visualizzato nella stessa posizione dell''etichetta. Se non viene visualizzata l''etichetta, il valore verr\00E0 visualizzato all''esterno dell''area di rappresentazione del grafico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282224987306784)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853887888307283)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere la preferenza utente da utilizzare come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853703070307283)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315505110307644)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione Python che produce un valore utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103315447819307644)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317134425307645)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione Python che restituisce un valore utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103317054334307645)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853412234307283)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere la query SQL utilizzata come origine per questo valore di parametro. Se vengono restituite pi\00F9 righe, verr\00E0 usato il valore della prima riga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853391628307282)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540751736306996)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se l''impostazione \00E8 <strong>Attivo</strong> e l''elemento di pagina \00E8 visibile, &PRODUCT_NAME. esegue automaticamente una convalida NOT NULL alla sottomissione della pagina.</p>'),
unistr('<p>Se si definisce un messaggio chiamato <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong> in Componenti condivisi > Messaggi di testo, il testo di errore predefinito pu\00F2 essere sostituito da un testo di errore specifico dell''applicazione.</p>'),
unistr('<p>La posizione di visualizzazione del messaggio \00E8 definita dall''impostazione a livello di applicazione <strong>Posizione predefinita di visualizzazione errore</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102540692473306996)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore obbligatorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314504220307643)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per fare in modo che venga restituito YES quando il dipendente \00E8 un responsabile (manager) e il relativo reparto si trova a Chicago:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314412918307643)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione SQL che produce un valore utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103314313876307643)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853279671307282)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore statico utilizzato come origine per questo valore di parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853136684307282)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935508259307346)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Specificare la modalit\00E0 di visualizzazione del valore nel grafico, sotto forma di numero o di valore percentuale del valore totale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935307572307346)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'it'
,p_message_text=>'Numero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937843324307348)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il valore verr\00E0 visualizzato come un numero nel grafico.</p> <p>Nota: l''attributo <strong>Formato</strong> deve essere utilizzato solo per applicare la formattazione decimale o di valuta all''etichetta e al valore visualizzati nel grafico.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935443048307346)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'it'
,p_message_text=>'Percentuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102937921724307348)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il valore verr\00E0 visualizzato come una percentuale compresa tra 0% e 100%.</p> <p>Nota: quando l''attributo <strong>Formato</strong> \00E8 impostato su <strong>Percentuale</strong>, i valori del grafico vengono moltiplicati per 100 in modo da applicare ')
||'il formato percentuale. Se si desidera usare l''attributo Formato, assicurarsi che l''attributo Tipo etichetta sia impostato su un numero.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102935284508307346)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851686247307281)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il modo in cui viene popolato questo parametro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856450063307285)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'it'
,p_message_text=>'Raccolta (CLOB)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856580266307285)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore della colonna CLOB della prima riga della <em>Raccolta</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133533891307495)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita origine REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133611510307495)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'it'
,p_message_text=>'Utilizzare il valore definito come predefinito all''interno dell''origine dati REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851954904307281)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852051646307281)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore mantenuto nello stato della sessione per l''<em>elemento</em> selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852922434307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'it'
,p_message_text=>'Valore NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102853086979307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Imposta su un valore nullo in quanto non \00E8 stato specificato alcun valore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852333261307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852446017307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore risultante dall''esecuzione dell''<em>espressione PL/SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852566224307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852662649307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore restituito dal <em>corpo funzione PL/SQL</em> immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852770434307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'it'
,p_message_text=>'Preferenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852889476307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul valore della <em>preferenza</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852164370307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'it'
,p_message_text=>'Query SQL (restituisce un valore singolo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102852268560307282)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul primo valore restituito dalla <em>query SQL</em> immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851786244307281)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'it'
,p_message_text=>'Valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851876072307281)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'it'
,p_message_text=>'Impostare sul testo immesso in <em>Valore statico</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851581008307281)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304707348307636)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per valutare l''espressione immessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305129925307636)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305065268307636)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304918240307636)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305242928307636)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304811612307636)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'it'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304683739307635)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306757256307637)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307015396307637)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306964075307637)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306877515307637)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307145371307637)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306665715307637)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303119009307634)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il linguaggio utilizzato per eseguire il corpo funzione immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303496673307635)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'it'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303392668307635)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'it'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303213066307634)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303554348307635)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'it'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303085553307634)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Linguaggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999551759307394)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere l''elemento di pagina o di applicazione utilizzato in questa convalida. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999469152307393)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306370457307637)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Java per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306259978307637)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307985085307638)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca un valore BOOLEAN come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307894863307638)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304379428307635)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Java che restituisca il testo di un messaggio di errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304201889307635)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Java che restituisce il testo dell''errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306176663307637)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306031810307636)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione JavaScript per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305958683307636)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307748240307638)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307669686307638)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca un valore BOOLEAN come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307540381307638)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304193660307635)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione del messaggio di errore specificato, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Il dipendente si trova nel reparto " + apex.env.P2_DEPTNO + " e non nel reparto 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304089358307635)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione JavaScript che restituisca il testo di un messaggio di errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303989675307635)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione JavaScript che restituisce il testo dell''errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424476651307728)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione del messaggio di errore specificato, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Il dipendente si trova nel reparto '' || :P2_DEPTNO || '' e non nel reparto 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999334587307393)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione PL/SQL che restituisce un errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999292869307393)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Codice PL/SQL che restituisce un errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305861873307636)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente si trova nel reparto 30 o \00E8 un responsabile (manager):</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305770673307636)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione PL/SQL per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305601414307636)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307424051307638)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307304047307638)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce un valore BOOLEAN come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103307263297307637)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303822314307635)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Per ottenere la convalida senza visualizzazione del messaggio di errore specificato, quando il dipendente si trova nel reparto 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Il dipendente si trova nel reparto '' || :P2_DEPTNO || '' e non nel reparto 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303788722307635)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il corpo funzione PL/SQL che restituisce il testo di un messaggio di errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103303632906307635)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce un testo di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306592273307637)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione Python per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103306499006307637)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308112356307638)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca un valore BOOLEAN come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103308057637307638)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304564070307635)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un corpo funzione Python che restituisca il testo di un messaggio di errore come base per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103304425928307635)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione Python che restituisce il testo dell''errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999914345307394)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione regolare utilizzata per la corrispondenza con l''elemento specificato per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999832795307394)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione regolare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305598496307636)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente \00E8 un responsabile (manager) o il reparto di trova a Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305498728307636)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere un''espressione SQL per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103305379128307636)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424333331307728)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Per <strong>Righe restituite</strong>, per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente \00E8 nel reparto 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Per <strong>Nessuna riga restituita</strong>, per ottenere la convalida senza visualizzazione di un messaggio di errore, quando il dipendente \00E8 nel reparto 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999175544307393)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere una query SQL per definire la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999097952307393)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999712786307394)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il valore da confrontare con il valore della colonna elemento specificata per la convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102999630387307394)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130478575307493)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Limitazione dell''uso di un''applicazione a ore di lavoro specifiche.</dt>',
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623154961307081)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere il nome della funzione richiamata dopo che la funzione sentry di sessione \00E8 stata restituita in modo corretto.'),
unistr('La funzione pu\00F2 essere definita nell''attributo "Codice PL/SQL" oppure nel database.'),
unistr('Il risultato deve essere booleano: "True" indica che l''utente \00E8 stato verificato e "False" indica che la verifica dell''utente non \00E8 riuscita.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102623071747307081)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Verifica nome funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560719936307015)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se tutte le azioni in sospeso devono attendere il risultato dell''azione corrente.',
'Impostare questo attributo su <strong>Attivo</strong> se le azioni in sospeso dipendono dal risultato di questa azione',
unistr('oppure impostarlo su <strong>Non attivo</strong> se non vi \00E8 alcuna dipendenza e le azioni in sospeso possono essere eseguite in modalit\00E0 asincrona senza attendere.</p>'),
unistr('<p>Nota: l''ordine di esecuzione delle azioni specifiche \00E8 determinato dalla sequenza specificata per ogni azione.'),
'Per garantire che le azioni vengano eseguite nello stesso ordine, Oracle consiglia di specificare numeri di sequenza univoci per tutte le azioni True e tutte le azioni False.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102560661801307015)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'In attesa del risultato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648760085307101)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'it'
,p_message_text=>'Indica se l''origine dati REST dispone di una tabella di sincronizzazione locale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648653384307100)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'L''origine dati REST dispone di una tabella di sincronizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102851470335307281)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648996132307101)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'it'
,p_message_text=>'<p>Abilitare questa opzione per utilizzare la tabella locale configurata nella sezione <strong>Sincronizzazione</strong> dell''origine dati REST, invece di contattare il servizio REST esterno.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648887134307101)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Usa tabella di sincronizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534971904306991)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il pulsante per attivare l''azione dinamica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534822199306991)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639617644307093)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Se si desidera che questo componente di elaborazione pagine venga eseguito solo quando si fa clic sul pulsante specificato, selezionare un pulsante dalla lista. \00C8 possibile incorporare questa condizione di pulsante alle altre condizioni per definire ')
||'con maggiore precisione il momento dell''esecuzione di questo componente di elaborazione pagine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102639545886307093)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Se si fa clic sul pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396375863307703)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere una colonna o pi\00F9 colonne per attivare l''azione dinamica.'),
unistr('Se si specificano pi\00F9 colonne, separarne ogni nome elemento con una virgola.'),
unistr('\00C8 possibile digitare il nome oppure effettuare una scelta nella lista delle colonne disponibili.'),
unistr('Se si effettua una scelta nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente verr\00E0 inserita una virgola, seguita dal nome della colonna restituito dalla lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396266556307703)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Colonna/e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535324024306991)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un oggetto DOM (<code>documento</code>, <code>finestra</code>) o l''<em>ID</em> di un oggetto DOM (<code>myElementID</code>) come elemento per attivare l''azione dinamica.</p>',
unistr('<p>Nota: l''<em>oggetto DOM</em> non \00E8 pi\00F9 valido e deve essere sostituito da un''<em>espressione JavaScript</em> o da un <em>selettore jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535258312306991)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Oggetto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535123072306991)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere gli elementi di pagina o di applicazione per attivare l''azione dinamica.',
unistr('Quando si specificano pi\00F9 elementi, usare una virgola per separare i nomi degli elementi.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535006686306991)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Elemento/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392012275307700)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Restituisce un riferimento all''oggetto DOM <code>window</code> del browser.</dt>',
'<dd><code>window</code></dd>',
'<dt>Restituisce un riferimento all''oggetto DOM <code>document</code> del browser.</dt>',
'<dd><code>document</code></dd>',
'<dt>Il selettore jQuery seleziona tutti gli elementi DIV con una classe ''alert'', quindi restituisce un oggetto jQuery che contiene tutti gli elementi padre.</dt>',
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391972759307700)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere l''espressione JavaScript che deve restituire un singolo oggetto DOM, un array di oggetti DOM o un oggetto jQuery come elementi che attivano l''azione dinamica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391861988307700)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046703313307430)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Per selezionare un elemento di pagina con l''ID DOM <code>my_id</code></dt>',
'<dd><pre>#my_id</pre></dd>',
'<dt>Per selezionare tutti gli elementi di pagina con la classe <code>my_class</code></dt>',
'<dd><pre>.my_class</pre></dd>',
'<dt>Per selezionare tutti gli elementi di pagina che costituiscono input</dt>',
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535586059306991)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere la sintassi del selettore jQuery per la restituzione di uno o pi\00F9 elementi di pagina per attivare l''azione dinamica. Nella libreria jQuery \00E8 disponibile una sintassi di selezione molto potente che facilita l''accesso a uno o pi\00F9 elementi ')
||'da una pagina.</p>',
'<p>Consultare la documentazione ufficiale disponibile nella <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">home page di jQuery</a> per ulteriori informazioni sulla sintassi di selezione.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102535485525306991)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Selettore jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102772111777307216)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il testo del messaggio da visualizzare quando viene superato il limite <strong>Numero massimo di righe da elaborare</strong>.',
'Il messaggio predefinita suggerisce agli utenti finali di aggiungere ulteriori filtri per limitare il numero dei record da elaborare.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102917462745307333)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il messaggio di testo che viene visualizzato quando la query restituisce un numero di righe maggiore del numero massimo di righe immesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103198836416307555)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il testo del messaggio da visualizzare nell''area <strong>Messaggi</strong> quando viene superato il limite <strong>Numero massimo di righe da elaborare</strong> per il layer.',
'Usare la sostituzione <strong>#MAX_ROW_COUNT#</strong> per il numero di righe effettivamente recuperato.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902732311307319)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il messaggio di testo che viene visualizzato quando esistono pi\00F9 righe di report.'),
'Usare questo approccio come alternativa all''impaginazione, in special modo se un report contiene di solito soltanto un set di record discreto.',
unistr('Se la query sul report restituisce righe aggiuntive, questo messaggio pu\00F2 essere usato per avvisare l''utente finale dell''anomalia, anzich\00E9 limitarsi a visualizzare controlli di impaginazione leggermente diversi.'),
'Il messaggio di testo consente di incorporare una "chiamata di azione" in modo che gli utenti finali sappiano come rispondere a questo risultato inusuale della query e possano includere i collegamenti di pagina o URL.</p>',
unistr('<p>Nel messaggio \00E8 possibile utilizzare le stringhe di sostituzione di impaginazione riportate di seguito.</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
'    <dd>Il numero di righe visualizzate (dimensioni pagina)</dd>',
'  <dt><code>#TOTAL_ROWS#</code></dt>',
'    <dd>"Z" in "righe X - Y di Z"</dd>',
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd>"X" in "righe X - Y di Z"</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd>"Y" in "righe X - Y di Z"</dd>',
'  <dt><code>#ROW_RANGES"</code></dt>',
'    <dd>Mostra: riga/righe 1-15 16-30 30-32</dd>',
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
'    <dd>Identico a Intervalli di righe ma in una lista di selezione<dd>',
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
'    <dd>Set di pagine: 1 2 3 4 5 6</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102902623591307319)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Altri dati trovati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103376424864307688)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Immettere il messaggio di testo da visualizzare quando la query sul grafico non restituisce alcuna riga. Se non viene specificato, Oracle JET utilizzer\00E0 automaticamente il messaggio predefinito "Nessun dato da visualizzare".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329273266307654)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il messaggio di testo visualizzato nell''area <strong>Messaggi</strong> quando la query sul layer non restituisce alcuna riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866849557307292)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere il messaggio di testo da visualizzare se la query non restituisce righe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102866777796307292)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Nessun dato trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534792428306991)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il nome dell''area che attiva l''azione dinamica.',
'Ad esempio, potrebbe essere un''area di ''Report interattivo'', utilizzata insieme a un evento ''Dopo l''aggiornamento'' per definire l''azione dinamica attivata a ogni aggiornamento del report.</p>',
unistr('<p>La disponibilit\00E0 di un''area che attiva un''azione dinamica pu\00F2 essere utile quando si desidera definire un funzionamento simile per pi\00F9 elementi di pagina contenuti in un''area. Ci\00F2 \00E8 tuttavia possibile solo per determinati eventi generati dagli ele')
||'menti contenuti nell''area interessata.',
'Per la lista degli eventi che supportano questo tipo di definizione e un esempio del modo in cui possono essere utilizzati, consultare la Guida degli elementi per <em>Elementi interessati</em> &gt; <em>Tipo di selezione</em> della sezione Ambito even'
||'to della pagina Azione.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534645178306991)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534520806306990)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'it'
,p_message_text=>'Selezionare il tipo dell''elemento di pagina o del costrutto da utilizzare per attivare l''evento. Per esempi sull''uso di un tipo di selezione specifico, consultare la Guida dell''attributo associato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046496355307430)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'it'
,p_message_text=>'Pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347803211307667)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'it'
,p_message_text=>'Attivato da un pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103394528500307702)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'it'
,p_message_text=>'Colonna/e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348001337307667)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Attivato da una o pi\00F9 colonne.'' );'),
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''Oggetto DOM'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
'        p_help_text     => q''~<p>Attivato dall''oggetto DOM (<code>document</code>, <code>window</code>) o dall''<em>id</em> di un oggetto DOM (<code>myElementID</code>).</p>',
unistr('        <p>Nota: <em>Oggetto DOM</em> non \00E8 pi\00F9 valido e deve essere sostituito da <em>Espressione JavaScript</em> o <em>Selettore jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046387937307430)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'it'
,p_message_text=>'Elemento/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347727855307667)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Attivato da uno o pi\00F9 elementi di pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103391244595307699)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'it'
,p_message_text=>'Espressione JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348200284307667)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'it'
,p_message_text=>'Attivato dagli elementi di pagina restituiti dall''espressione JavaScript.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046651281307430)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'it'
,p_message_text=>'Selettore jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103348161598307667)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'it'
,p_message_text=>unistr('Attivato da uno o pi\00F9 elementi di pagina restituiti dal selettore jQuery.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103046509729307430)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103347967198307667)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'it'
,p_message_text=>'Attivato da un''area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102534418856306990)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Tipo di selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102590298686307042)
,p_name=>'PENDING'
,p_message_language=>'it'
,p_message_text=>'in sospeso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680615473307130)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'it'
,p_message_text=>'Voci in sospeso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689334635307138)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'it'
,p_message_text=>'Richieste in sospeso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711431769307159)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'it'
,p_message_text=>'Percentuale chiusi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709313523307157)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Percentuale di completamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711596010307159)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'it'
,p_message_text=>'Percentuale aperti'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102668591192307119)
,p_name=>'PIE_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico a torta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690697983307140)
,p_name=>'PKC1'
,p_message_language=>'it'
,p_message_text=>'Colonna 1 chiave primaria'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690745837307140)
,p_name=>'PKC2'
,p_message_language=>'it'
,p_message_text=>'Colonna 2 chiave primaria'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382992298307693)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'it'
,p_message_text=>'Disponibili per l''installazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383024701307693)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'it'
,p_message_text=>'Disponibili per l''aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383194699307693)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'it'
,p_message_text=>unistr('Eventi di applicazione di produttivit\00E0/esempio: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386578896307696)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'it'
,p_message_text=>'%0 utenti - %1 visualizzazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426225228307729)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Controlli dei prerequisiti seguenti non riusciti. Impossibile continuare l''installazione di questa applicazione e degli oggetti di supporto finch\00E9 tali problemi non vengono risolti.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426437131307729)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Oggetto esistente: <br />',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426378747307729)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Privilegi necessari: <br />',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103411568116307718)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilizzare questa pagina per controllare l''accesso per gli amministratori di aree di lavoro, gli sviluppatori di applicazioni e gli utenti finali di Application Express.</p>',
'',
unistr('<p>Gli <strong>amministratori delle aree di lavoro</strong> possono installare, rimuovere o aggiornare le applicazioni, nonch\00E9 gestire gli account utente e i servizi di sviluppo.</p>'),
'',
'<p>Gli <strong>sviluppatori</strong> possono installare, rimuovere o aggiornare le applicazioni.</p>',
'',
'<p>Gli <strong>utenti finali</strong> non hanno privilegi di sviluppo e possono solo accedere alle applicazioni che non utilizzano uno schema di autenticazione esterno.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382802960307693)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Selezionare un''area di lavoro nella lista riportata di seguito'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102652581397307104)
,p_name=>'PLSQL'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466344328306932)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'Espressione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719200406307166)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'it'
,p_message_text=>'Lista di valori basata su un corpo funzione PL/SQL che restituisce un''istruzione SQL contenente errori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412386011306887)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658802314307110)
,p_name=>'PLSQL_REGION'
,p_message_language=>'it'
,p_message_text=>'Area PL/SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953863459307360)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'it'
,p_message_text=>'File di plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102932238366307344)
,p_name=>'PLUGIN'
,p_message_language=>'it'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336490339307659)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'it'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336159299307659)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'it'
,p_message_text=>'Effetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336358255307659)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'it'
,p_message_text=>'Esegui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387288428307696)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'it'
,p_message_text=>'Inizializza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335943277307658)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'it'
,p_message_text=>'Varie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327233097307652)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336258707307659)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336031053307658)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'it'
,p_message_text=>'Stile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886178525307307)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'it'
,p_message_text=>unistr(' [Non pi\00F9 valido]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102672319331307123)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'it'
,p_message_text=>' [Plugin]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218623041307570)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'it'
,p_message_text=>' [Precedente]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838706467307272)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di schema di autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218477450306736)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286105661306786)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285532079306786)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983716740307382)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'it'
,p_message_text=>'Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285622018306786)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'it'
,p_message_text=>'Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702960730307151)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'it'
,p_message_text=>'Colonna report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448111165307747)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se si immette un URL, utilizzare le stringhe di sostituzione <code>&amp;APP_ID.</code>, <code>&amp;SESSION.</code> e <code>&amp;DEBUG.</code> e la sintassi <code>&amp;COLUMN_NAME.</code> per impostare l''ID riga o la chiave primaria sulla pagina di'
||' destinazione oppure per impostare altri valori di attributo.</p>',
'<p><strong>Esempi</strong></p>',
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
'<p>Per ulteriori informazioni sulla sintassi <code>f?p</code>, consultare il manuale Application Express Builder User''s Guide.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102704056984307152)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del plugin riuscita.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035778216307421)
,p_name=>'PNONUS'
,p_message_language=>'it'
,p_message_text=>'Percentuale di dipendenti al di fuori degli Stati Uniti'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414128281306889)
,p_name=>'POPUP_LOV'
,p_message_language=>'it'
,p_message_text=>'lista di valori popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752623216307197)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di lista di valori popup'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713032715307161)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'it'
,p_message_text=>'Processo di post-autenticazione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712849416307160)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'it'
,p_message_text=>'Processo di pre-autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596165777307047)
,p_name=>'PRECISION'
,p_message_language=>'it'
,p_message_text=>'Precisione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933427131307345)
,p_name=>'PREFERENCES'
,p_message_language=>'it'
,p_message_text=>'Preferenze'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405218115306882)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'it'
,p_message_text=>'applica permessi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405800267306882)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'nessuna azione richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405570461306882)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'it'
,p_message_text=>'revoca permessi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271307169306776)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'it'
,p_message_text=>'Valore della preferenza nell''espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102271487424306776)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della preferenza in Espressione 1 NON \00E8 uguale a Espressione 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102373460893306857)
,p_name=>'PRESENTATION'
,p_message_language=>'it'
,p_message_text=>'Presentazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433016293306905)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'it'
,p_message_text=>unistr('La stampa del report non \00E8 attualmente disponibile. Nessun server di stampa configurato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681077183307131)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'it'
,p_message_text=>'Avanzato (richiede Oracle BI Publisher)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681123619307131)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'it'
,p_message_text=>'Standard'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666273556307117)
,p_name=>'PRIORITIZED'
,p_message_language=>'it'
,p_message_text=>unistr('Priorit\00E0 assegnata')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676795787307127)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'it'
,p_message_text=>'Problemi corretti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676648956307126)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'it'
,p_message_text=>'Problemi identificati'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411013727306886)
,p_name=>'PROCEDURE'
,p_message_language=>'it'
,p_message_text=>'procedura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324597700307650)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188640851306713)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'it'
,p_message_text=>'Esegui codice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102188795020306713)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Invia messaggio di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275322855306778)
,p_name=>'PROCESSES'
,p_message_language=>'it'
,p_message_text=>'Processi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208826292306728)
,p_name=>'PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Elaborazione della richiesta in corso. Attendere...'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998354786307393)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'it'
,p_message_text=>'Calo di produzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398604199307705)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'it'
,p_message_text=>'Portale prodotto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413485612307719)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Prompt: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228451268306743)
,p_name=>'PROVIDER'
,p_message_language=>'it'
,p_message_text=>'Provider'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228511120306743)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica provider'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685435252307135)
,p_name=>'PROVISIONED'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provisioning eseguito',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799989994307241)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'it'
,p_message_text=>'Spazio fornito esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681265543307131)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Per richiesta utente con verifica via posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681452709307131)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'it'
,p_message_text=>'Manuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681347022307131)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'it'
,p_message_text=>'Per richiesta utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419648199306893)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni sull''amministratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420605513306894)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'it'
,p_message_text=>unistr('La tablespace verr\00E0 creata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420888424306894)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'it'
,p_message_text=>'File di dati per la tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419480845306893)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419886418306893)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420788763306894)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'it'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419156031306893)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418953794306893)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di fornire un/una nuovo/a %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420463597306894)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420212758306894)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Riutilizza lo schema esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420191341306894)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni sullo schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420531880306894)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419221739306893)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'it'
,p_message_text=>'ID area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419310860306893)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'it'
,p_message_text=>'Assegnato dal sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419981732306894)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419738137306893)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419020442306893)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni sull''area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420326656306894)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724489929307171)
,p_name=>'PROXY_SERVER'
,p_message_language=>'it'
,p_message_text=>'Server proxy'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406380177306882)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di aggiornare la seguente Guida dell''elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406403521306882)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'it'
,p_message_text=>'Se corretto, fare clic su Aggiorna tutto. In caso contrario, fare clic su Annulla.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030142559307417)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'it'
,p_message_text=>'Amministratori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025899290307414)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Inizio dell''eliminazione dell''area di lavoro %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025697957307414)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'it'
,p_message_text=>'Inizio dell''eliminazione della tablespace %0 per l''area di lavoro %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025282157307413)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'it'
,p_message_text=>'Inizio dell''eliminazione dell''utente %0 per l''area di lavoro %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024837634307413)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Inizio della rimozione dell''area di lavoro %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030035047307417)
,p_name=>'PURGE.BYTES'
,p_message_language=>'it'
,p_message_text=>'Byte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026164021307414)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''eliminazione dell''area di lavoro %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025708073307414)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''eliminazione della tablespace %0 per l''area di lavoro %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025537913307414)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''eliminazione dell''utente %0 per l''area di lavoro %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024691878307413)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Gentile utente di Oracle APEX,',
'',
unistr('nell''area di lavoro %0 in %1 non \00E8 stata effettuata alcuna attivit\00E0 recente. La rimozione dell''area di lavoro inattiva \00E8 stata pianificata per la data %2 o successivamente.'),
'',
unistr('Per evitare che l''area di lavoro venga rimossa, fare clic sull''URL in basso e scegliere di non rimuovere l''area di lavoro. Questa azione deve essere eseguita nei prossimi %3 giorni.  Se quest''area di lavoro non \00E8 pi\00F9 necessaria, non \00E8 richiesta alcun')
||'a azione.',
'',
'Collegamento di conferma:  %4'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024773241307413)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro Oracle APEX da rimuovere:   area di lavoro %0 in data %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025980962307414)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Fine dell''eliminazione dell''area di lavoro %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103336833988307659)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'it'
,p_message_text=>'Fine dell''eliminazione della tablespace %0 per l''area di lavoro %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025468290307413)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'it'
,p_message_text=>'Fine dell''eliminazione dell''utente %0 per l''area di lavoro %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022790316307412)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro %0 verr\00E0 aggiunta alla lista di rimozione in quanto \00E8 rimasta inattiva per almeno %1 giorni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022863204307412)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro %0 verr\00E0 rimossa dalla lista di rimozione a causa di attivit\00E0 recente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022929390307412)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Messaggio di posta elettronica inviato a %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023347740307412)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro %0 \00E8 stata spostata dalla lista di elementi conservati a quella di rimozione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029275153307416)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'it'
,p_message_text=>'Byte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026642164307414)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029146721307416)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'it'
,p_message_text=>'File di dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028814488307416)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'it'
,p_message_text=>'Schemi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026525787307414)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026959388307415)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'it'
,p_message_text=>unistr('Rimossa dalla lista di rimozione (a causa di attivit\00E0 recente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027680822307415)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'it'
,p_message_text=>'Aggiunta di nuovo alla lista di rimozione (precedentemente conservata, ma inattiva per %0 giorni)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027307278307415)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'it'
,p_message_text=>'Aggiunta alla lista di rimozione (inattiva per %0 giorni)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028294793307415)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'it'
,p_message_text=>'Rimossa oggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027102590307415)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'it'
,p_message_text=>'Conservata (l''amministratore ha richiesto di non rimuovere l''area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027881614307415)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'it'
,p_message_text=>'Da rimuovere tra %0 giorno/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028986556307416)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'it'
,p_message_text=>'Tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028777615307416)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'it'
,p_message_text=>'Aree di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028392784307416)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'it'
,p_message_text=>'Aree di lavoro rimaste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023128529307412)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'it'
,p_message_text=>'Risposta registrata dal messaggio di posta elettronica %0 con valore %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029824995307417)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024959689307413)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'it'
,p_message_text=>'Impostazione dello stato dello schema %0 su %1 per l''area di lavoro %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025022187307413)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'it'
,p_message_text=>'Impostazione dello stato della tablespace %0 su %1 per l''area di lavoro %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035329759307421)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'it'
,p_message_text=>'Riepilogo giornaliero della rimozione delle aree di lavoro per Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029977805307417)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030456169307417)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'it'
,p_message_text=>'Aree di lavoro aggiunte di nuovo alla lista di rimozione (precedentemente conservate, ma inattive per %0 giorni)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030378219307417)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'it'
,p_message_text=>'Aree di lavoro aggiunte alla lista di rimozione (inattive per %0 giorni)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029325843307416)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Riepilogo aree di lavoro rimosse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029518481307416)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'it'
,p_message_text=>'Aree di lavoro rimosse oggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030568087307417)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'it'
,p_message_text=>unistr('Aree di lavoro rimosse dalla lista di rimozione (a causa di attivit\00E0 recente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030664434307417)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'it'
,p_message_text=>'Aree di lavoro conservate (l''amministratore ha richiesto di non rimuovere l''area di lavoro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030242850307417)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'it'
,p_message_text=>'Aree di lavoro da rimuovere tra %0 giorno/i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029714345307417)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026425556307414)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Rimozione dell''area di lavoro %0 completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328305831307653)
,p_name=>'PURGED'
,p_message_language=>'it'
,p_message_text=>'Rimosso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413069612307719)
,p_name=>'PURGE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Rimuovi: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790507126307233)
,p_name=>'QB_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'&nbsp;Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102467770471306933)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'it'
,p_message_text=>'Immettere una query valida per visualizzare i risultati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790372319307233)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nome gi\00E0 utilizzato da una query esistente in Query Builder o nel processore di comandi SQL.<br> '),
'Selezionare un nuovo nome e salvare di nuovo.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649075345307101)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'it'
,p_message_text=>'Niente da salvare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629259771307086)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query salvata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795880164307237)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795981910307237)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Visualizza azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748661247307194)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Visual Query Builder non \00E8 in grado di aprire la query corrente.<br>'),
'Fare clic su Crea per sostituire la query corrente con una nuova oppure premere Invio per conservarla.'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748585464307194)
,p_name=>'QUERY'
,p_message_language=>'it'
,p_message_text=>'Query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273682134306777)
,p_name=>'QUERY BUILDER'
,p_message_language=>'it'
,p_message_text=>'Query Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440581414306911)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'it'
,p_message_text=>'Query non valida. Istruzione SELECT non trovata.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273497987306777)
,p_name=>'QUESTIONS'
,p_message_language=>'it'
,p_message_text=>'Domande'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992824854307389)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione per i numeri: 999G999G999G999G990'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798814869307240)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'it'
,p_message_text=>'Informazioni su Quick SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798945895307240)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quick SQL consente di generare rapidamente il codice SQL necessario alla creazione di un modello dati relazionale da un documento di testo indentato. Questo strumento \00E8 progettato per ridurre il tempo e l''impegno necessari per creare le tabelle, i')
||unistr(' trigger e le strutture di indice SQL. Non \00E8 invece stato progettato come strumento sostitutivo per la modellazione dei dati, in quanto costituisce semplicemente un metodo rapido per sviluppare uno script per tabelle e viste semplici. Il codice SQL c')
||unistr('reato pu\00F2 essere regolato e ampliato.</p>'),
'',
'<p>Casi d''uso principali',
'<ul>',
'  <li>Creazione rapida di modelli dati potenti</li>',
'  <li>Salvataggio della sintassi abbreviata Quick SQL come modello per ripetere le modifiche al modello o da utilizzare come modello per avviare la progettazione del modello successivo</li>',
'  <li>Generazione facilitata di dati casuali</li>',
'  <li>Apprendimento della sintassi di creazione tabelle, selezione, inserimento, indicizzazione, trigger, package PL/SQL e visualizzazione SQL con gli esempi forniti</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691733920307141)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Questa impostazione controlla la sintassi generata per supportare le colonne di audit. Se le colonne di audit sono abilitate, vengono generati trigger per gestire l''utente che crea una riga e l''utente autore dell''ultimo aggiornamento di una riga. Qua'
||unistr('ndo \00E8 abilitata viene utilizzata la funzione seguente:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691820278307141)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'it'
,p_message_text=>unistr('Quando non \00E8 abilitata, viene utilizzata la funzione seguente:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102691951913307141)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'it'
,p_message_text=>'Genera interfacce API PL/SQL in tutte le tabelle per operazioni di creazione, inserimento, aggiornamento, eliminazione e query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692066310307141)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'it'
,p_message_text=>'Aggiunge altre colonne CREATED, CREATED_BY, UPDATED e UPDATED_BY a ogni tabella creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692155545307141)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Quando \00E8 abilitata, crea tutte le tabelle in formato compresso. L''impostazione predefinita \00E8 non compresso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692288184307141)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Quando le colonne di audit sono abilitate, la colonna predefinita usata per tenere traccia dell''utente che ha creato una riga \00E8 CREATED_BY. Usare questa impostazione per sostituire il nome della colonna di audit predefinita. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102692351985307141)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Quando le colonne di audit sono abilitate, la colonna predefinita usata per tenere traccia dell''utente che ha creato una riga \00E8 CREATED. Usare questa impostazione per sostituire il nome della colonna di audit predefinita. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102694356764307143)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'it'
,p_message_text=>'Per impostazione predefinita, per tutte le colonne DATE create viene utilizzato il tipo di dati DATE Oracle. Utilizzare questa impostazione per sostituire l''impostazione predefinita. I valori validi sono:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102696629002307145)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'it'
,p_message_text=>'Specifica la versione del database con cui la sintassi deve essere compatibile. I valori validi sono:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701008982307149)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368682251307682)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'it'
,p_message_text=>'Reparti e dipendenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369226552307683)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'it'
,p_message_text=>'Sintassi SQL abbreviata che crea la tabella DEPARTMENTS e EMPLOYEES con un''istruzione VIEW SQL di join. Vengono inoltre generati dati casuali utilizzando la sintassi /INSERT. /NN aggiunge un vincolo di colonna SQL NOT NULL. Vengono utilizzate liste i'
||unistr('ndentate per definire le tabelle, le colonne e le tabelle figlio. Vengono aggiunte in modo automatico le colonne chiave primaria ed esterna. Non \00E8 necessario fornire le colonne chiave primaria o esterna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621180330307070)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102699712825307148)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'it'
,p_message_text=>'Include i comandi SQL per eliminare ogni oggetto di database creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368879286307682)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'it'
,p_message_text=>'Competenze dipendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369098593307682)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'it'
,p_message_text=>'Crea una tabella DEPARTMENTS, EMPLOYEES e SKILLS utilizzando l''indentazione per identificare le tabelle padre e figlio. Viene utilizzata la sintassi abbreviata VC255 per specificare un tipo di dati SQL e la sintassi /INSERT per generare dati casuali.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620939788307070)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'it'
,p_message_text=>'Esempio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799228713307240)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'it'
,p_message_text=>'Esempio %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701781078307150)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'it'
,p_message_text=>'Genera in modo automatico una colonna chiave primaria ID per ogni tabella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799055659307240)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'it'
,p_message_text=>'Operazioni preliminari'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799181573307240)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere i nomi delle tabelle padre senza alcuna indentazione. Immettere le colonne delle tabelle con un''indentazione uniforme di 2 o pi\00F9 spazi. In genere \00E8 preferibile non specificare le chiavi primarie, in quanto il sistema le generer\00E0 in modo ')
||'automatico. Le relazioni padre-figlio vengono create mediante la semplice indentazione delle tabelle figlio sotto le tabelle padre.</p>',
'',
unistr('<p>Il tipo di dati \00E8 di solito VARCHAR2. Se si desidera una colonna con un tipo di dati diverso, aggiungere uno spazio NUM, INT, DATE alla fine del nome della colonna. In base al testo in lingua Inglese contenuto nel nome della colonna e in assenza d')
||unistr('i qualsiasi tipo di dati specificato, il sistema effettuer\00E0 deduzioni educate per alcuni nomi di colonna. Ad esempio, se il nome della colonna contiene la parola DATE, il tipo di dati sar\00E0 DATE oppure se il nome della colonna contiene la parola NUMBE')
||unistr('R o NUM, il tipo di dati sar\00E0 NUMBER. Se si desidera specificare una determinata lunghezza VARCHAR2, immettere VCn, dove "n" rappresenta la lunghezza di VARCHAR2. Fare clic sul pulsante Sintassi per visualizzare la sintassi disponibile. I nomi degli ')
||unistr('oggetti verranno formattati in modo automatico, sostituendo gli spazi con caratteri di sottolineatura, pertanto \00E8 possibile usare gli spazi nei nomi delle colonne e delle tabelle.</p>'),
'',
unistr('<p>Fare clic sul pulsante Impostazioni per visualizzare numerose opzioni di generazione. \00C8 possibile aggiungere automaticamente "Colonne Chi", ad esempio per specificare chi ha creato o aggiornato per ultimo una determinata riga e quando ha effettuat')
||unistr('o l''operazione. \00C8 possibile aggiungere una colonna di sequenza di righe che viene aumentata in modo automatico di un''unit\00E0 a ogni aggiornamento delle righe. La sequenza di righe pu\00F2 essere utile per semplificare il rilevamento degli aggiornamenti per')
||unistr('si. Pu\00F2 essere inoltre generata un''interfaccia API PL/SQL che fornisca un package per tabella e le procedure per l''esecuzione di query, inserimenti, aggiornamenti ed eliminazioni delle righe.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373974411307686)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'it'
,p_message_text=>'Genera un''interfaccia API di package PL/SQL per eseguire query, inserire, aggiornare ed eliminare dati in una tabella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374063152307686)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'it'
,p_message_text=>'Aggiunge la funzione di audit Oracle, ovvero AUDIT ALL ON [TABLE NAME] per impostazione predefinita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374167492307686)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'it'
,p_message_text=>'Aggiunge automaticamente le colonne UPDATED, UPDATED_BY, INSERTED e INSERTED_BY e la logica di trigger per impostare i valori delle colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373332821307686)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'it'
,p_message_text=>'Aggiunge un vincolo CHECK di tipo between nella colonna. Ad esempio /between 1 and 100.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372740139307685)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'it'
,p_message_text=>'Crea a vincolo CHECK con valori delimitati con virgole o spazi vuoti, ad esempio /check Yes, No.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702892911307151)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'it'
,p_message_text=>'Inserisce questo valore come prefisso per tutte le colonne della tabella specificata. Se non fornito, aggiunge automaticamente un carattere di sottolineatura.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102742940173307188)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373776124307686)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'it'
,p_message_text=>'Racchiudere i commenti utilizzando parentesi quadre o la sintassi lineetta lineetta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374234484307687)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'it'
,p_message_text=>unistr('La tabella verr\00E0 creata con il formato compresso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372887277307685)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'it'
,p_message_text=>'Imposta questa colonna su un valore costante durante la generazione dei dati. Ad esempio, /constant NYC.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206148135307561)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'it'
,p_message_text=>unistr('Aggiunge il valore predefinito se la colonna \00E8 nulla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702797467307151)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'it'
,p_message_text=>'Aggiunge una colonna BLOB e le colonne _FILENAME, _CHARSET, _MIMETYPE e _LASTUPD per migliorare la funzione di download dei file tramite un browser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373566737307686)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'it'
,p_message_text=>unistr('Riferimenti di chiave esterna, ad esempio /references table_name. Tenere presente che \00E8 possibile fare riferimento a tabelle che non fanno parte del proprio modello.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373407951307686)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'it'
,p_message_text=>'Le colonne nascoste non vengono visualizzate quando si usa select * from con una tabella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102966704360307369)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'it'
,p_message_text=>'Crea un indice non univoco per la colonna associata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374310323307687)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'it'
,p_message_text=>'Genera <strong>NN</strong> istruzioni INSERT SQL con dati casuali, ad esempio: /INSERT 20. (Maximum = 1000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373196618307686)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'it'
,p_message_text=>'Applica in modo forzato il minuscolo ai valori delle colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373840198307686)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'it'
,p_message_text=>'NNN identifica un numero compreso tra 1 e 32767.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373206919307686)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'it'
,p_message_text=>'Aggiunge un vincolo NOT NULL nella colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373661650307686)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'it'
,p_message_text=>'Identifica una colonna come chiave primaria della tabella. Si consiglia di non specificare manualmente le chiavi primarie, ma di lasciare che l''applicazione crei in modo automatico le colonne chiavi primarie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374537093307687)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'it'
,p_message_text=>'Genera l''abilitazione REST della tabella utilizzando i servizi ORDS (Oracle REST Data Services).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103374491895307687)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'it'
,p_message_text=>'Genera un''istruzione SELECT SQL dopo la generazione dei dati per ogni tabella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508410735306964)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'it'
,p_message_text=>'Genera vincolo univoco a livello di tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372611499307685)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'it'
,p_message_text=>'Crea un vincolo UNIQUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103373060710307686)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'it'
,p_message_text=>'Applica in modo forzato il maiuscolo ai valori delle colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372928250307686)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'it'
,p_message_text=>'Lista separata da virgole dei valori da usare durante la generazione dei dati. Ad esempio, /values 1, 2, 3, 4 o /values Yes, No.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102801694306307242)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'it'
,p_message_text=>'Creazione degli oggetti di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829542624307265)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dopo aver completato l''immissione della sintassi abbreviata Quick SQL e applicato le impostazioni appropriate, si \00E8 pronti per usare il linguaggio SQL per creare gli oggetti di database ed eventualmente popolare le tabelle con dati casuali. Attene')
||'rsi alla procedura riportata di seguito.<br>',
'<ol>',
'  <li>Fare clic su <strong>Salva modello</strong> per salvare la sintassi abbreviata Quick SQL come modello, da riutilizzare in futuro.</li>',
'  <li>Immettere un nome di modello.</li>',
'  <li>Fare clic su <strong>Salva script SQL</strong> per salvare l''output sotto forma di script.</li>',
'  <li>Immettere il nome dello script.</li>',
'  <li>Fare clic su <strong>Riesamina ed esegui</strong> per accedere all''editor degli script.</li>',
'  <li>Nell''editor degli script esaminare il contenuto dello script per controllare che sia corretto.</li>',
'  <li>Fare clic su <strong>Esegui</strong> per creare gli oggetti di database.</li>',
'  <li>Nella pagina di conferma dello script fare clic su <strong>Esegui ora</strong>.</li>',
'  <li>Nella pagina dei risultati esaminare le istruzioni elaborate, riuscite e con errori.<br>',
'  Se vengono segnalati errori, scorrere la pagina dei risultati per individuare i messaggi di errore Oracle specifici.</li>',
'  <li>Facoltativamente, fare clic su <strong>Crea applicazione da script</strong> per passare alla Creazione guidata applicazione e ottenere la generazione automatica delle pagine in base alle tabelle e alle viste specificate nello script.</li>',
'</ol>',
'</p>',
'',
'<p><em><strong>Nota:</strong> Oracle consiglia di scaricare la sintassi abbreviata SQL nel computer in uso se si desidera aggiornare la stessa sintassi abbreviata SQL in futuro. Se sono state specificate eventuali impostazioni, spostarsi in fondo al '
||'riquadro Output SQL Oracle e copiare la riga che inizia con <code># settings =</code> nella parte superiore del riquadro Sintassi abbreviata Quick SQL.<br>',
'Fare clic su <strong>Scarica</strong> per salvare il file SQL nel computer in uso.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700748812307149)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Genera i dati utilizzati per le istruzioni INSERT con la lingua indicata. La lingua predefinita \00E8 l''Inglese. Sono supportate le lingue seguenti: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102700927346307149)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Identifica gli identificativi pi\00F9 lunghi da utilizzare per i nomi degli oggetti di database. Quando l''opzione \00E8 abilitata, gli identificativi pi\00F9 lunghi consentono di utilizzare nomi di oggetto con una lunghezza massima pari a 128 caratteri. Quando l')
||unistr('''opzione non \00E8 abilitata, la lunghezza massima di un nome di oggetto \00E8 di 30 caratteri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701112409307150)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Consente l''uso di identificativi pi\00F9 lunghi per i nomi degli oggetti di database. Con gli identificativi pi\00F9 lunghi la lunghezza massima di un tipo di dati di colonna VARCHAR2 sar\00E0 di 32767 caratteri. Quando l''opzione non \00E8 impostata, la lunghezza ma')
||unistr('ssima di un tipo di dati di colonna VARCHAR2 \00E8 di 4000 caratteri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701284116307150)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'it'
,p_message_text=>'Questa impostazione controlla le impostazioni ON DELETE della chiave esterna. I valori validi sono: '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701328310307150)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Quando \00E8 abilitata, tutte le impostazioni applicazione definite tramite la console dell''interfaccia utente vengono ignorate e vengono utilizzate solo le impostazioni presenti nello script.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701476989307150)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Determina le modalit\00E0 di impostazione della chiave primaria. Le chiavi primarie possono essere impostate mediante SYS_GUID, la colonna del tipo di dati di identit\00E0 o la sequenza. I valori validi sono:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701649959307150)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'it'
,p_message_text=>'Inserisce il nome della tabella come prefisso per le colonne chiave primaria della tabella del database. Ad esempio, la chiave primaria della tabella EMPLOYEE sarebbe EMPLOYEE_ID. Senza l''impostazione del nome delle colonne chiave primaria create in '
||'modo implicito sarebbe ID.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701587146307150)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Prefisso degli oggetti di database. Verr\00E0 aggiunto un carattere di sottolineatura, se non fornito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368719829307682)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'it'
,p_message_text=>'Vendite prodotti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369357413307683)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'it'
,p_message_text=>'Sintassi abbreviata che crea uno star schema con le tabelle PRODUCTS, CUSTOMERS, CHANNELS, PROMOTIONS e SALES. La tabella SALES contiene riferimenti di chiave esterna ad altre tabelle. Viene inoltre creata una vista SQL che riunisce tutte e cinque le'
||' tabelle. Vengono inoltre creati dati casuali di esempio. Le colonne numeriche vengono identificate con la sintassi NUM.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368553068307682)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'it'
,p_message_text=>'Project Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369136707307683)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'it'
,p_message_text=>'Crea una tabella PROJECT_MANAGEMENT e quattro tabelle detail. Vengono create due viste con la sintassi /VIEW. Vengono inoltre aggiunti vincoli CHECK di database utilizzando la sintassi /CHECK. Usa inoltre #APEX per definire le impostazioni che contro'
||'llano la generazione della sintassi SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701865951307150)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'it'
,p_message_text=>'Reimposta i valori predefiniti di tutte le impostazioni applicazione. Quando viene incluso, tutte le impostazioni applicazione attive per la sessione vengono ignorate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102701948643307150)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'it'
,p_message_text=>'Per ogni tabella creata aggiunge una colonna ROW_KEY per la generazione di un identificativo alfanumerico. I valori della colonna ROW_KEY verranno impostati dalla logica trigger della tabella del database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702141121307151)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'it'
,p_message_text=>unistr('Per ogni tabella generata aggiunge una colonna ROW_VERSION, che viene incrementata di 1 unit\00E0 a ogni aggiornamento. Quando \00E8 abilitata, la logica trigger delle tabelle di database verr\00E0 generata per aumentare le versioni di riga all''aggiornamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702297163307151)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'it'
,p_message_text=>'Inserisce un nome di schema come prefisso per i nomi degli oggetti. L''impostazione predefinita non prevede il prefisso di schema per i nomi degli oggetti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702039666307150)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('Per ogni tabella creata aggiunge una colonna TENANT_ID a supporto delle applicazioni multi-tenant. Il valore di questa colonna viene semplicemente aggiunto alla tabella; la logica per la conservazione del valore dovr\00E0 essere fornita dallo sviluppator')
||'e.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702685941307151)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile scegliere la semantica BYTE o CHAR oppure nessuna semantica di colonna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102621049727307070)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'it'
,p_message_text=>'Impostazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684221349307134)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00C8 possibile immettere impostazioni in linea per impostare in modo esplicito le opzioni di generazione della sintassi SQL. In alternativa, \00E8 possibile fare clic su <strong>Impostazioni</strong> nella parte superiore del riquadro destro per impostar')
||'e le opzioni di generazione in modo dichiarativo.</p>',
'',
'<p>L''immissione diretta delle impostazioni nel riquadro Sintassi abbreviata Quick SQL garantisce l''utilizzo delle stesse opzioni di generazione SQL anche se si scarica lo script e in seguito lo si incolla di nuovo. Ad esempio, immettere quanto riport'
||'ato di seguito per inserire la parola TEST come prefisso per tutti nomi di tabella e generare lo schema OBE:<br>',
'<code># settings = { prefix: "test", schema: "OBE" }</code>.<br>',
'In alternativa, immettere ogni impostazione in una riga distinta per ottenere lo stesso risultato:<br>',
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
unistr('<p><em><strong>Nota:</strong> le impostazioni devono iniziare in una nuova riga e avere come primo elemento <code># settings = </code> per l''immissione di pi\00F9 impostazioni o <code># </code> per l''immissione di una sola impostazione per riga. Tutti i ')
||'valori sono senza distinzione tra maiuscole e minuscole. Le parentesi, gli spazi e le virgole possono essere aggiunti per maggiore chiarezza, ma verranno ignorati. Per ottenere la generazione di tutte le impostazioni, usare <code># verbose: true</cod'
||'e>.</em> ',
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620712432307070)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'it'
,p_message_text=>'Sintassi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390561109307699)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390682863307699)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'it'
,p_message_text=>unistr('Crea le tabelle ASSEGNATARI e ATTIVIT\00C0. Questo \00E8 il punto di partenza progettato per consentire la creazione di un sistema di attivit\00E0 personalizzato entro pochi minuti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702376958307151)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'it'
,p_message_text=>'Quando si abilitano le colonne di audit, usare questa impostazione per sostituire il nome della colonna di audit predefinita. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702475793307151)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'it'
,p_message_text=>'Quando si abilitano le colonne di audit, usare questa impostazione per sostituire il nome della colonna di audit predefinita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102702519648307151)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'it'
,p_message_text=>'Verranno visualizzate tutte le impostazioni, non solo quelle diverse dalle impostazioni predefinite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102620844918307070)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'it'
,p_message_text=>'Assicurarsi che il nome della vista non contenga spazi e che i nomi tabella non contengano spazi. Delimitare i nomi tabella con uno spazio o una virgola.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102829666171307265)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Report di caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469071355306934)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'it'
,p_message_text=>'Analisi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676982471307127)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'it'
,p_message_text=>'Media %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352368084306840)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'it'
,p_message_text=>'Per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469455479306934)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'it'
,p_message_text=>'Grafici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352205980306840)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'it'
,p_message_text=>'Grafico per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102350990950306839)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista dei dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469333425306934)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'it'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677093930307127)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'it'
,p_message_text=>'Somma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844914563307276)
,p_name=>'QUICK_SQL'
,p_message_language=>'it'
,p_message_text=>'Quick SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186676353306712)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 2D con intervallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186785978306712)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 3D con intervallo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103502223269307794)
,p_name=>'READERS'
,p_message_language=>'it'
,p_message_text=>'Lettori'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418512806307723)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'it'
,p_message_text=>'Riassegna elemento: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210023363306729)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'it'
,p_message_text=>'Riassegna pagine'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102595486964307046)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'it'
,p_message_text=>'Cestino'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799325734307241)
,p_name=>'REDIRECT'
,p_message_language=>'it'
,p_message_text=>'Reindirizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799599069307241)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'it'
,p_message_text=>unistr('Questo pulsante reindirizza a un URL e, probabilmente, la pagina non verr\00E0 sottomessa. Se si desidera che il pulsante sottometta la pagina, non identificare una pagina o un URL di reindirizzamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465730828306931)
,p_name=>'REDIRECT_TO'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931469971307343)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza all''applicazione %0, pagina %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465670564306931)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a pagina %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273235873306777)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina in questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273362706306777)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102646629562307099)
,p_name=>'REFERENCED'
,p_message_language=>'it'
,p_message_text=>'Di riferimento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274200918306778)
,p_name=>'REGEN_VER'
,p_message_language=>'it'
,p_message_text=>'Rigenera codice di verifica'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649231603307101)
,p_name=>'REGION'
,p_message_language=>'it'
,p_message_text=>'area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793788572307236)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'it'
,p_message_text=>'Posizioni pulsante di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102713241821307161)
,p_name=>'REGION CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706411940307154)
,p_name=>'REGION CONTENT'
,p_message_language=>'it'
,p_message_text=>'Contenuto area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252142320306761)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Pulsanti di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102275210772306778)
,p_name=>'REGIONS'
,p_message_language=>'it'
,p_message_text=>'Aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433249888306905)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'it'
,p_message_text=>'Ignora modello di lista delle aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657509591307109)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'it'
,p_message_text=>'Selettore di visualizzazione area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175965173306703)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921841750307336)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194122998306717)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'it'
,p_message_text=>'Schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102641844910307095)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'it'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218375685306736)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'it'
,p_message_text=>'Mapping colonna caricamento dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655959518307107)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'it'
,p_message_text=>'Selettore di visualizzazione area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986591491307384)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Ricerca con facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775825784307219)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'it'
,p_message_text=>'Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177025682306704)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo Guida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783003599307226)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'it'
,p_message_text=>'Griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896731210307314)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'it'
,p_message_text=>'Report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636220944307091)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354611480307672)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'it'
,p_message_text=>'Report attivazione/disattivazione colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218243526306736)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354736547307672)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'it'
,p_message_text=>'Report reflow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922086596307336)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'it'
,p_message_text=>'Struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102175489645306703)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358524423307675)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'it'
,p_message_text=>'Mappa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996582394307391)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'it'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921492784307336)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico (HTML - Precedente)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102892528667307311)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102996692609307391)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'it'
,p_message_text=>'Contenuto statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921327002307336)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico (SVG - Precedente)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102896895366307314)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'it'
,p_message_text=>'Form tabulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102921920239307336)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'it'
,p_message_text=>'Struttura classica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176244795306704)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'it'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102342294343306832)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Nessun modello'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661251832307112)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'it'
,p_message_text=>'Rifiutato o duplicato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102681922258307131)
,p_name=>'RELEASE'
,p_message_language=>'it'
,p_message_text=>'Release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228783457306743)
,p_name=>'RELEASED'
,p_message_language=>'it'
,p_message_text=>'Data rilascio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711867637307159)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Riepilogo release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711750196307159)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'Riepilogo delle release per l''area di lavoro: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387112194307696)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'it'
,p_message_text=>'Ulteriori informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428254244307731)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('PL/SQL Web Toolkit %0 \00E8 obbligatorio <a href="%1" target="_blank">[Ulteriori informazioni]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428029346307731)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Il set di patch %0 \00E8 disponibile <a href="%1" target="_blank">[Ulteriori informazioni]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428162200307731)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Oracle APEX %0 \00E8 disponibile <a href="%1" target="_blank">[Ulteriori informazioni]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103387015262307696)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'it'
,p_message_text=>unistr('Il sistema \00E8 aggiornato')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328514880307653)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Rimosso a causa di attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228243080306743)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103219657057307571)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'it'
,p_message_text=>unistr('La definizione dell''applicazione verr\00E0 rimossa insieme a tutti gli oggetti di supporto creati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102727544508307174)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Rimozione dell''area di lavoro riuscita.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791740970307234)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Rinomina colonna %0 in %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791926067307234)
,p_name=>'RENAME_TABLE'
,p_message_language=>'it'
,p_message_text=>'Rinomina tabella %0 in %1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508849242306964)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Riordina pulsanti di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523969999306981)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'it'
,p_message_text=>'Riordina elementi della barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508947698306965)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'it'
,p_message_text=>'Riordina aree'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508518915306964)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Riordina elementi di area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102523877688306981)
,p_name=>'REORDER_TABS'
,p_message_language=>'it'
,p_message_text=>'Riordina schede'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629190871307085)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412246083307718)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'it'
,p_message_text=>'Alias report: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629458935307086)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'colonna report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746013797307191)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Colonne report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720800978307168)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di colonna di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720453137307167)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del form e del report riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685220251307135)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'it'
,p_message_text=>'Report generato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752902658307198)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'it'
,p_message_text=>'Layout report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102581686212307034)
,p_name=>'REPORT_ON'
,p_message_language=>'it'
,p_message_text=>'Report su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102746310372307191)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Attributi pagina report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337876339306829)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query valida. Bind variable analizzate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752858508307197)
,p_name=>'REPORT_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586407838307038)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'it'
,p_message_text=>'Passo 1 - Scarica file XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586514020307038)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'it'
,p_message_text=>'Passo 2 - Progetta layout report e salva file come RTF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586735745307038)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'it'
,p_message_text=>'Passo 2 - Carica file XSL-FO'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102586609897307038)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'it'
,p_message_text=>'Passo 3 - Carica file RTF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718957167307166)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'it'
,p_message_text=>'Righe di report recuperate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787005033307230)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del report completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720978428307168)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello di report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726198549307173)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione della pagina Report su Web Service riuscita.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642788772307096)
,p_name=>'REQUEST'
,p_message_language=>'it'
,p_message_text=>'Richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716487655307164)
,p_name=>'REQUESTED'
,p_message_language=>'it'
,p_message_text=>'Richiesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980688616307380)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'it'
,p_message_text=>'%0 dell''area di lavoro "%1" ha richiesto la modifica della dimensione del database di un ulteriore %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980529618307379)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'%0 ha richiesto un nuovo schema per l''area di lavoro "%1" con %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980421902307379)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'%0 richiede la nuova area di lavoro "%1" con dimensione di %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230473987306745)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'%0 richiede la nuova area di lavoro "%1"'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669509907307120)
,p_name=>'RESEARCHING'
,p_message_language=>'it'
,p_message_text=>'Ricerca in corso'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205054384306726)
,p_name=>'RESET_4000'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251966103306761)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'it'
,p_message_text=>'Reimposta valore nullo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102236818938306749)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'it'
,p_message_text=>'Gruppo di consumer Resource Manager'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934633601307346)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'it'
,p_message_text=>'Accesso limitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505146006306962)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'it'
,p_message_text=>unistr('Limitato: non pu\00F2 essere impostato dal browser')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722783514307170)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>unistr('Il riferimento al Web Service \00E8 stato aggiunto all''applicazione %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334781625306827)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'it'
,p_message_text=>'Con alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133300673307495)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Per i servizi RESTful APEX \00E8 attiva la modalit\00E0 di sola lettura.</p>'),
'',
unistr('<p>\00C8 possibile utilizzare i servizi RESTful basati su APEX con le definizioni correnti. Oracle ne consiglia tuttavia la migrazione in ORDS facendo clic su <strong>Esegui migrazione ai servizi RESTful ORDS</strong>.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129952450307492)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare la versione di ORDS attualmente in esecuzione. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334159501306826)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133259888307495)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Questa azione annulla la registrazione dello schema selezionato e rimuove tutte le definizioni dei servizi REST ORDS. L''azione non pu\00F2 essere annullata.</p>'),
'',
unistr('<p>Si \00E8 certi di voler annullare la registrazione di questo schema?</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102583273388307035)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'it'
,p_message_text=>unistr('Un prefisso di percorso APEX con questo valore \00E8 gi\00E0 definito per un''altra area di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644518038307097)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'it'
,p_message_text=>unistr('Questo alias di schema \00E8 gi\00E0 utilizzato da un altro schema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334095432306826)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369700862307683)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Oggetti abilitati totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317839082306810)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'it'
,p_message_text=>unistr('Il carattere glob (*) pu\00F2 comparire solo in un pattern di instradamento come ultimo carattere e pu\00F2 solo essere preceduto da un parametro denominato o da una barra (/).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982851562307381)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'it'
,p_message_text=>'Handler creato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983003459307381)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'it'
,p_message_text=>'Handler eliminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952510514307359)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'it'
,p_message_text=>'Previsto un ID handler, ricevuto valore NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982931319307381)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Handler aggiornato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317723062306810)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'it'
,p_message_text=>'Sono stati rilevati caratteri non validi nelle porzioni del valore del pattern di instradamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354667653306842)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'it'
,p_message_text=>'Autorizzazione obbligatoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402674185307711)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div style="padding: 20px; font-size: 12px;">Fare clic sul pulsante Esegui migrazione per copiare i metadati di tutti i servizi REST basati su APEX in ORDS. Le definizioni dei servizi basati su APEX esistenti rimarranno invariate, ma non verranno ese'
||unistr('guite finch\00E9 in ORDS non esister\00E0 un servizio corrispondente. '),
'',
'Dopo la migrazione, si consiglia di convalidare e sottoporre a test i servizi migrati basati su ORDS. Dopo aver effettuato la verifica, esportare ed eliminare i servizi basati su APEX.</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402543187307711)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX ha rilevato che l''area di lavoro contiene 2 o pi\00F9 moduli REST basati su APEX con prefissi URI NULL. ORDS non consente pi\00F9 moduli con lo stesso prefisso URI di base. </p>'),
'',
'<p>Per eseguire la migrazione di questi servizi in ORDS, verranno applicate le regole riportate di seguito. </p>',
'',
'<ul>',
'<li>Tutti i moduli interessati verranno compressi in un singolo modulo ORDS denominato <em><strong>merged.apex.rest.services</strong></em>.</li>',
unistr('<li>Se <strong><em>qualsiasi</em></strong> modulo basato su APEX che si sta unendo viene pubblicato, il nuovo modulo unito <strong><em>verr\00E0 pubblicato</em></strong>.</li>'),
unistr('<li>Se <strong><em>nessun</em></strong> modulo basato su APEX che si sta unendo viene pubblicato, il nuovo modulo unito <strong><em>non verr\00E0 pubblicato</em></strong>.</li>'),
'<li><strong><em>Tutti i ruoli</em></strong> associati ai moduli basati su APEX che vengono uniti <strong><em>verranno assegnati al nuovo modulo unito</em></strong>.</li>',
unistr('<li>La <strong><em>dimensione di impaginazione</em></strong> del modulo unito verr\00E0 impostata sulla <strong><em>dimensione di impaginazione pi\00F9 grande</em></strong> a partire dai moduli che vengono uniti.</li>'),
unistr('<li>Se sono presenti moduli APEX con URI di base NULL che hanno anche URI di modello duplicati, si verificher\00E0 quanto riportato di seguito.'),
'',
'<ul>',
unistr('<li>Il modello aggiornato pi\00F9 di recente manterr\00E0 l''URI duplicato</li>'),
'<li>Tutti gli altri modelli verranno preceduti dal prefisso dup001_*</li>',
unistr('<li>Il commento per il modello conterr\00E0 il nome del modulo originale dal quale \00E8 stata eseguita la migrazione e l''URI del modello originale</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402466252307711)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX ha rilevato che l''area di lavoro contiene 2 o pi\00F9 moduli REST basati su APEX con prefissi URI NULL. ORDS non consente pi\00F9 moduli con lo stesso prefisso URI di base. </p>'),
'',
unistr('<p>Attualmente non \00E8 possibile eseguire la migrazione dei servizi REST basati su APEX in ORDS. La migrazione sar\00E0 disponibile a partire da ORDS versione 18.2 e successive. </p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369444503307683)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Moduli totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982205440307381)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Modulo creato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982444658307381)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'it'
,p_message_text=>'Modulo eliminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952304853307359)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'it'
,p_message_text=>'Previsto un ID modulo, ricevuto valore NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982356770307381)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Modulo aggiornato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317552760306810)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'it'
,p_message_text=>'Un parametro denominato nel pattern di instradamento contiene caratteri non validi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103199524516307556)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'it'
,p_message_text=>unistr('Questo schema non \00E8 stato registrato con Oracle REST Data Services. Per registrare lo schema, fare clic su <strong>Registra schema con ORDS</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317953487306810)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'it'
,p_message_text=>'L''URI non corrisponde al pattern di stile URI o ROUTE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318012867306810)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 consentito avere pi\00F9 di una barra consecutiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317459571306810)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 consentito avere una stringa di query per un pattern di instradamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221494861306738)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'it'
,p_message_text=>unistr('<p>APEX \00E8 attualmente in esecuzione nel CDB. Non \00E8 possibile definire i servizi REST basati su ORDS nel CDB.</p><p>\00C8 possibile continuare a utilizzare i servizi RESTful basati su APEX.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103133190496307495)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La versione ORDS attualmente installata (%0) non supporta tutte le funzionalit\00E0 richieste per abilitare i servizi RESTful basati su ORDS in Application Express. \00C8 necessario installare come minimo la versione %1.</p>'),
unistr('<p>\00C8 possibile continuare a usare i servizi RESTful basati su APEX.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317611505306810)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'it'
,p_message_text=>unistr('Il carattere facoltativo (?) pu\00F2 comparire solo in un pattern di instradamento come ultimo carattere e deve essere preceduto da un parametro denominato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316465713306809)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il sistema non \00E8 in grado di individuare lo schema ORDS_METADATA, richiesto per abilitare Workshop REST ORDS. Per la procedura di installazione, fare riferimento alla guida all''installazione di Oracle REST Data Services.</p> <p>\00C8 possibile continu')
||'are a utilizzare i servizi RESTful basati su APEX.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334662021306827)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'it'
,p_message_text=>'Parzialmente protetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316383619306809)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'it'
,p_message_text=>unistr('<p>Il sistema sta attualmente utilizzando il gateway PL/SQL incorporato Oracle. \00C8 necessario installare la versione %0 o successiva di Oracle REST Data Services per poter abilitare l''accesso a Workshop REST ORDS.</p> <p>\00C8 possibile continuare a utili')
||'zzare i servizi RESTful basati su APEX.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369536873307683)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Privilegi totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983489222307382)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Privilegio creato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983637420307382)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'it'
,p_message_text=>'Privilegio eliminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983509297307382)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Privilegio aggiornato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334246907306826)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'it'
,p_message_text=>'Pubblicato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335339166306827)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Questa azione eliminer\00E0 e creer\00E0 di nuovo il modulo <strong>oracle.example.hr</strong> e gli oggetti di database correlati nello schema attualmente selezionato. Qualsiasi modifica o aggiunta eseguita andr\00E0 perduta e l''operazione non potr\00E0 essere a')
||'nnullata.</p>',
unistr('<p>Si \00E8 certi di voler reimpostare il servizio di esempio?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369612788307683)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Ruoli totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983175073307381)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Ruolo creato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983358273307382)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'it'
,p_message_text=>'Ruolo eliminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983201757307381)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Ruolo aggiornato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354564530306842)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'it'
,p_message_text=>'Stato accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354794136306842)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'it'
,p_message_text=>'Alias schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130150962307492)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('Lo script caricato \00E8 troppo grande. In Application Express esiste un limite di 32 MB (pari a 32767 byte).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334422217306826)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'it'
,p_message_text=>'Protetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952468291307359)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'it'
,p_message_text=>'Previsto un ID sequenza per il parametro, ricevuto valore NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369953841307683)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103369884796307683)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione riuscita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370021934307683)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'it'
,p_message_text=>'Avvertenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982529606307381)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Modello creato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982771886307381)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'it'
,p_message_text=>'Modello eliminato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952682980307359)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'it'
,p_message_text=>'Previsto un ID modello, ricevuto valore NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252694580306761)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('Il modello URI non pu\00F2 essere nullo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982696358307381)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Modello aggiornato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334937537306827)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti abilitati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335044340306827)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'it'
,p_message_text=>'Moduli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335157663306827)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'it'
,p_message_text=>'Privilegi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102335248099306827)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'it'
,p_message_text=>'Ruoli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358474680307675)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Servizi dati RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334862762306827)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'it'
,p_message_text=>'Senza alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334392040306826)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'it'
,p_message_text=>'Non pubblicato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102334546201306826)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'it'
,p_message_text=>'Non protetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317390216306810)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Uno o pi\00F9 variabili URI presentano un errore di sintassi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102933534250307345)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Lo script che si tenta di caricare \00E8 un''esportazione di servizio RESTful basato su APEX. Non pu\00F2 essere caricato utilizzando la pagina di importazione dei servizi RESTful ORDS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197142588307554)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'it'
,p_message_text=>unistr('Lo script che si tenta di caricare \00E8 un''esportazione di servizio RESTful basato su ORDS. Non pu\00F2 essere caricato utilizzando la pagina di importazione dei servizi RESTful APEX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370137382307683)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'it'
,p_message_text=>'Copia negli Appunti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103370217137307683)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'it'
,p_message_text=>'Copia URL completo negli Appunti'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328435127307653)
,p_name=>'RETAINED'
,p_message_language=>'it'
,p_message_text=>'Conservato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443149085306913)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'it'
,p_message_text=>'Torna alla pagina di login di %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448425465307747)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'it'
,p_message_text=>'Valore restituito: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669812077307120)
,p_name=>'REVIEWING'
,p_message_language=>'it'
,p_message_text=>'In revisione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102931216481307343)
,p_name=>'ROLE'
,p_message_language=>'it'
,p_message_text=>'Ruolo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449356585306918)
,p_name=>'ROLLBACK'
,p_message_language=>'it'
,p_message_text=>'Istruzione di rollback non applicabile. Viene eseguito il commit automatico di tutte le istruzioni.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793115920307235)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'it'
,p_message_text=>'%0 righe restituite in %1 secondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102273003413306777)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'it'
,p_message_text=>'righe restituite in'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883817809307305)
,p_name=>'RUN'
,p_message_language=>'it'
,p_message_text=>'Esegui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198132297306720)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'it'
,p_message_text=>'Esegui e sviluppa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649319803307101)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Esegui applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886646315307307)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'it'
,p_message_text=>'Esegui applicazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446086849306915)
,p_name=>'RUN_ONLY'
,p_message_language=>'it'
,p_message_text=>'Solo esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888642190307308)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'it'
,p_message_text=>'Esegui pagina: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102252243697306761)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni di esempio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846420737307277)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'it'
,p_message_text=>'Paesi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846718831307278)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'it'
,p_message_text=>'Lista di paesi, popolazione e capitale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433817740306905)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'it'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433933131306905)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'it'
,p_message_text=>'Tabelle EMP e DEPT generiche.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846511359307278)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'it'
,p_message_text=>'Formula 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846902642307278)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'it'
,p_message_text=>'Campioni del mondo di Formula 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327727708307653)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'it'
,p_message_text=>'Aggiornamenti dello stato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327881371307653)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'it'
,p_message_text=>'Aggiornamenti sullo stato di salute segnalato dal paziente semplificato per i provider di servizi sanitari.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434045979306905)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'it'
,p_message_text=>'Dati HR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434133797306905)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'it'
,p_message_text=>'Tabelle HR generiche comunemente utilizzate da Oracle Education.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886749653307307)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'it'
,p_message_text=>'Ordini cliente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886872274307307)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'it'
,p_message_text=>'Raccolta di clienti, negozi, prodotti e ordini. Questo data set include dati JSON per la descrizione dei prodotti e i valori di longitudine/latitudine per i negozi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433612546306905)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'it'
,p_message_text=>'Dati progetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102433729452306905)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'it'
,p_message_text=>'Raccolta di progetti, milestone, task e altri elementi. Questo data set include relazioni Master-Detail e una vista utile per la creazione di grafici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434205363306906)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'it'
,p_message_text=>'Foglio di calcolo task'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434391296306906)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'it'
,p_message_text=>'Tabella singola con dati non normalizzati che contiene task, date, stato, destinazione assegnazione, costo e budget.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846321668307277)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'it'
,p_message_text=>'Tennis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846834038307278)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'it'
,p_message_text=>'Vincitori, vincitrici e secondi classificati agli eventi del Grande Slam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846668219307278)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'it'
,p_message_text=>'Mondiali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847022450307278)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'it'
,p_message_text=>'Risultati dei Mondiali di calcio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730295157307177)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'it'
,p_message_text=>'Websheet di esempio'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717029643307164)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717191492307164)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'it'
,p_message_text=>'Esempio di collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717222738307164)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'it'
,p_message_text=>unistr('Report pi\00F9 salvati...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716786600307164)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716078120307163)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'it'
,p_message_text=>'Privato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716136875307163)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Sottoscrizione privata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716633212307164)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'it'
,p_message_text=>'Pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716982662307164)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102716898589307164)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di report'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361097015306847)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'it'
,p_message_text=>'Voce di indicatore di percorso eliminata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361272426306847)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'it'
,p_message_text=>'Voce di indicatore di percorso creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361163432306847)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Voce di indicatore di percorso aggiornata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360916883306847)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360844460306847)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso aggiornato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332891889306825)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332770816306825)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689204468307138)
,p_name=>'SCHEMAS'
,p_message_language=>'it'
,p_message_text=>'Schemi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800784165307242)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'it'
,p_message_text=>'eccezione per inserimento nello schema wwv_flow_companies'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799786159307241)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema "%0" \00E8 disponibile.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799832230307241)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema "%0" NON \00E8 disponibile al momento e non pu\00F2 essere creato poich\00E9 \00E8 in conflitto con un utente esistente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597411113307048)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Password schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414254806306889)
,p_name=>'SCHEMES'
,p_message_language=>'it'
,p_message_text=>'schemi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368376678307682)
,p_name=>'SCREEN_READER'
,p_message_language=>'it'
,p_message_text=>'Lettore di schermo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102720349427307167)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'it'
,p_message_text=>'Attiva/disattiva lettore di schermo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750943865307196)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>unistr('Questo file \00E8 stato esportato da un''altra area di lavoro (%0), probabilmente da un altro database %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392534839307700)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'it'
,p_message_text=>'Script %0 bloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392438642307700)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'it'
,p_message_text=>'Script %0 sbloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401667970307710)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'it'
,p_message_text=>unistr('Lo script non \00E8 bloccato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102677684408307127)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'Per descrivere un oggetto, digitare <br><br> ',
'',
'DESCRIBE &lt nome oggetto &gt nel riquadro dei comandi sopra riportato e fare clic su Esegui.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707114319307155)
,p_name=>'SC_NAME_NN'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome della query non pu\00F2 essere nullo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719127612307166)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
'Impossibile trovare l''oggetto da descrivere.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709768549307158)
,p_name=>'SC_SC'
,p_message_language=>'it'
,p_message_text=>'Query non visiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644146561307097)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'it'
,p_message_text=>'Istruzione SQL in esecuzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709670827307157)
,p_name=>'SC_VQ'
,p_message_language=>'it'
,p_message_text=>'Query visiva'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332173046307656)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni barra di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752181677307197)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'it'
,p_message_text=>'Campo di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597874974307049)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'it'
,p_message_text=>'Questa query non contiene colonne VARCHAR. Impossibile abilitare la ricerca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102587238134307039)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Nessuna colonna VARCHAR in cui effettuare la ricerca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102752080677307197)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'it'
,p_message_text=>unistr('Cerca applicazioni di produttivit\00E0 e di esempio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103146597941307505)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'it'
,p_message_text=>'Risultati ricerca'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334024166307657)
,p_name=>'SECTIONS'
,p_message_language=>'it'
,p_message_text=>'Sezioni'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393002621306872)
,p_name=>'SECURITY'
,p_message_language=>'it'
,p_message_text=>'Sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684328137307134)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'it'
,p_message_text=>'Assegnatario sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035296646307421)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('ID gruppo di sicurezza (identit\00E0 dell''area di lavoro) non valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682497962307132)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Impatto sicurezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724334334307171)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710862275307159)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'it'
,p_message_text=>'Non deve essere un utente pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684767777307134)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato sicurezza'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710361637307158)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'it'
,p_message_text=>'Vedere il report allegato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245581397306756)
,p_name=>'SELECT_ALL'
,p_message_language=>'it'
,p_message_text=>'Seleziona tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102591595108307043)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Seleziona applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200093347306722)
,p_name=>'SELECT_DATE'
,p_message_language=>'it'
,p_message_text=>'Selezionare una data dalla tabella. Mese corrente = %0, Anno corrente = %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218517211307570)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'it'
,p_message_text=>'Seleziona azione dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402640194306880)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402546316306880)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402476127306879)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402310675306879)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402787538306880)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419560565307724)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'it'
,p_message_text=>'Seleziona riga: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102854996799307284)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'it'
,p_message_text=>'Selezionare un''area di lavoro in basso per aprire l''ambiente di sviluppo di Application Express.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778581288307222)
,p_name=>'SELF_SERVICE'
,p_message_language=>'it'
,p_message_text=>'Self Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778424504307221)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Self Service con verifica posta elettronica'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392188430307700)
,p_name=>'SEPARATOR'
,p_message_language=>'it'
,p_message_text=>'Separatore'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411127534306886)
,p_name=>'SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102839521071307272)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Sequenza: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276490968306779)
,p_name=>'SERIES'
,p_message_language=>'it'
,p_message_text=>'Serie %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680918783307131)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'it'
,p_message_text=>'Modifica di servizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224037108306740)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'it'
,p_message_text=>'Amministrazione sito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661063041307112)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'it'
,p_message_text=>'Richiesta di servizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418781257306893)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'it'
,p_message_text=>'Immettere un codice di verifica con distinzione tra maiuscole e minuscole e fare clic su <strong>Sottometti richiesta</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417604243306892)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni sull''amministratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418612735306892)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensioni database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417542432306891)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417993388306892)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417762676306892)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417300651306891)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Giustificazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417837487306892)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'it'
,p_message_text=>'Cognome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417240527306891)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418481605306892)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418060505306892)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'it'
,p_message_text=>'Telefono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418206091306892)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Riutilizza lo schema esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418108312306892)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni sullo schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418525324306892)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417119911306891)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni sull''area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418353758306892)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102610021157307060)
,p_name=>'SESSION'
,p_message_language=>'it'
,p_message_text=>'Sessione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712792509307160)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione di verifica delle sessioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253791034306762)
,p_name=>'SESSIONS'
,p_message_language=>'it'
,p_message_text=>'Sessioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776492647307220)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'it'
,p_message_text=>'Buffer:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776274248307219)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'it'
,p_message_text=>'CPU:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775942905307219)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'it'
,p_message_text=>'Corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776382870307219)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'it'
,p_message_text=>'Disco:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776145826307219)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'it'
,p_message_text=>'Tempo trascorso:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776036052307219)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337335115306829)
,p_name=>'SET_BINDS'
,p_message_language=>'it'
,p_message_text=>'Quando si esegue il test di una query devono essere impostati i valori per tutte le bind variable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239561770306752)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'it'
,p_message_text=>'Impostare la data di scadenza delle %0 funzioni incomplete assegnate a %1 per la release %2 alla data del milestone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359395436306846)
,p_name=>'SET_MILESTONE'
,p_message_language=>'it'
,p_message_text=>'Imposta milestone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239810960306752)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'it'
,p_message_text=>'Impostare le funzioni con milestone mancati sul milestone (%3) per le %0 funzioni incomplete assegnate a %1 per la release %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102239776786306752)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'it'
,p_message_text=>'Modificare il milestone delle %0 funzioni incomplete assegnate a %1 per la release %2, che corrisponde a un milestone scaduto, con il milestone (%3).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358972903306845)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'it'
,p_message_text=>unistr('%0 funzione/i aperta/e verr\00E0 o verranno assegnate al milestone selezionato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359498648306846)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'it'
,p_message_text=>unistr('La data di scadenza di %0 funzione/i aperta/e verr\00E0 impostata sulla data del milestone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396608275307703)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'it'
,p_message_text=>'Imposta preferenze'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359692082306846)
,p_name=>'SET_RELEASE'
,p_message_language=>'it'
,p_message_text=>'Imposta release'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775221618307218)
,p_name=>'SHARED'
,p_message_language=>'it'
,p_message_text=>'Condiviso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954467506307360)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'it'
,p_message_text=>'Componenti condivisi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712492056307160)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'it'
,p_message_text=>'Lista di valori dinamica condivisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208973217306728)
,p_name=>'SHARED POOL'
,p_message_language=>'it'
,p_message_text=>'Pool condiviso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102712325483307160)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione lista di valori statica condivisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283920726306785)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'it'
,p_message_text=>'Componente condiviso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951737610307358)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Convalida condivisa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414369381306889)
,p_name=>'SHORTCUT'
,p_message_language=>'it'
,p_message_text=>'scorciatoia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102856944749307285)
,p_name=>'SHORTCUTS'
,p_message_language=>'it'
,p_message_text=>'Scorciatoie'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102663936117307115)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Impatto significativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102667034836307118)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'Avanzamento significativo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412885072306888)
,p_name=>'SIMPLE'
,p_message_language=>'it'
,p_message_text=>'semplice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658494983307110)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico semplice'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735520326307181)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'it'
,p_message_text=>'16 ore fa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795028095307237)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'it'
,p_message_text=>'1 giorno fa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794986891307237)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'it'
,p_message_text=>'1 ora fa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414969808307721)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'it'
,p_message_text=>'tra 16 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795149594307237)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'it'
,p_message_text=>'1 settimana fa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102250565158306760)
,p_name=>'SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371317540307684)
,p_name=>'SL.APP'
,p_message_language=>'it'
,p_message_text=>'Applicazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367442247307681)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'it'
,p_message_text=>'Modifica pagina %0 nell''applicazione %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367598613307681)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'it'
,p_message_text=>'Vai all''applicazione %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197327460307554)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'it'
,p_message_text=>'1 corrispondenza trovata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103197493024307554)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'it'
,p_message_text=>'%0 corrispondenze trovate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103214783712307567)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna corrispondenza trovata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371410155307684)
,p_name=>'SL.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102888705084307308)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'it'
,p_message_text=>'Cerca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934073338307345)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'it'
,p_message_text=>'Cerca %0 in tutte le applicazioni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367823373307682)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'it'
,p_message_text=>'Cerca %0 in questa applicazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103129564554307492)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'it'
,p_message_text=>'Immettere almeno due lettere per eseguire la ricerca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367736263307681)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'it'
,p_message_text=>'Cerca %0 nella pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367949306307682)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'it'
,p_message_text=>'Cerca %0 in Team Development'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368084251307682)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'it'
,p_message_text=>'Cerca utente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103368168489307682)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'it'
,p_message_text=>'Cerca %0 nell''area di lavoro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103367625723307681)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'it'
,p_message_text=>'Componenti condivisi dell''applicazione %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102660912443307112)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'it'
,p_message_text=>'Difetto del software'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102665989526307117)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Desiderabilit\00E0 sufficiente')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993317476307389)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'it'
,p_message_text=>'Identificativo origine'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800056541307241)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'it'
,p_message_text=>'Utilizzo spazio esistente'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649507030307101)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'SQL non disponibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857375867307285)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102793099116307235)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'it'
,p_message_text=>'Comandi SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688329717307138)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'it'
,p_message_text=>'Cronologia comandi SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466225912306931)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726683147307173)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'it'
,p_message_text=>'Riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726326562307173)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'it'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726495738307173)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'it'
,p_message_text=>'Procedura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726258907307173)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726598878307173)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'it'
,p_message_text=>'Variabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012095070307403)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'it'
,p_message_text=>unistr('L''accesso SQL e PL/SQL non \00E8 abilitato per questa applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012157504307403)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'it'
,p_message_text=>unistr('L''accesso SQL e PL/SQL non \00E8 abilitato per questa istanza.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411912768306887)
,p_name=>'SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217929432306735)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Query non valida. Istruzione SELECT non trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513419652306968)
,p_name=>'SQL_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316817542306810)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405652557306882)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406181287306882)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'it'
,p_message_text=>'Disabilita ordinamento colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405396391306882)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore visualizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405713322306882)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'it'
,p_message_text=>'Colonna di ordinamento primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316765180306809)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'it'
,p_message_text=>'Sostituisci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405445275306882)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore restituito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102405988965306882)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'it'
,p_message_text=>'Colonna di ordinamento secondaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406019178306882)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'it'
,p_message_text=>'Seleziona colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688515659307138)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'it'
,p_message_text=>'Script SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688458097307138)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'it'
,p_message_text=>'Risultati script SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998144256307392)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'it'
,p_message_text=>'I seguenti oggetti di database devono essere definiti nella lista delle tabelle consentite: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688605994307138)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468591667306933)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'it'
,p_message_text=>unistr('L''alias specificato \00E8 gi\00E0 utilizzato da un altro oggetto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102468492128306933)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'it'
,p_message_text=>unistr('L''alias di oggetto fornito non \00E8 valido. Gli alias validi possono contenere solo lettere, numeri, caratteri di sottolineatura e lineette.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782155260307225)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'it'
,p_message_text=>unistr('Questo schema non \00E8 stato registrato con i servizi di dati REST ORDS. Per registrare lo schema, andare a <strong> Servizi RESTful > Servizi RESTful ORDS</strong> e fare clic sul pulsante <strong>Registra schema con ORDS</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797106901307239)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'it'
,p_message_text=>unistr('APEX \00E8 attualmente in esecuzione nel CDB. Non \00E8 possibile definire i servizi REST basati su ORDS nel CDB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796962553307238)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'it'
,p_message_text=>unistr('La versione ORDS attualmente installata (%0) non supporta tutte le funzionalit\00E0 necessarie per abilitare gli oggetti di database per REST. \00C8 necessario installare una versione minima di %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796752625307238)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('Il sistema non \00E8 in grado di individuare lo schema ORDS_METADATA, richiesto per abilitare i servizi RESTful ORDS. Per la procedura di installazione, fare riferimento alla guida all''installazione di Oracle REST Data Services.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797065988307238)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'it'
,p_message_text=>'Versione ORDS <strong>%0</strong>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796874917307238)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'it'
,p_message_text=>unistr('Il sistema sta attualmente utilizzando il gateway PL/SQL incorporato Oracle. \00C8 necessario installare la versione %0 o successiva di Oracle REST Data Services per abilitare gli oggetti di database per REST.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186874553306712)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 2D in pila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102186968185306712)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 3D in pila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187075865306712)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 2D orizzontali in pila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102187195420306712)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne 3D orizzontali in pila'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953264469307359)
,p_name=>'STANDARD _TABS'
,p_message_language=>'it'
,p_message_text=>'Schede standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954950580307361)
,p_name=>'STANDARD_TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102393110077306872)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede standard'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279335107306781)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'it'
,p_message_text=>'File applicazione statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279260987306781)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'it'
,p_message_text=>'File area di lavoro statici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449945778307748)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'it'
,p_message_text=>'Immettere almeno una parola chiave di almeno due caratteri. '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450038637307748)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare risultati corrispondenti alla query di ricerca. '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102466070546306931)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'it'
,p_message_text=>'Assegnazione statica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798583558307240)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Nessuna applicazione associata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210150886306729)
,p_name=>'STATIC_HTML'
,p_message_language=>'it'
,p_message_text=>'HTML statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193636147306717)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Riferimento statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102657200701307108)
,p_name=>'STATIC_REGION'
,p_message_language=>'it'
,p_message_text=>'Area statica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102721874158307169)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'it'
,p_message_text=>'Stringhe di sostituzione statiche'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412638768307719)
,p_name=>'STATUS_LABEL'
,p_message_language=>'it'
,p_message_text=>'Stato: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593072818307044)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'it'
,p_message_text=>'Stato modificato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708471009307156)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione scheda standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401705059307710)
,p_name=>'STEAL_LOCK'
,p_message_language=>'it'
,p_message_text=>'Acquisisci lock'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253420322306762)
,p_name=>'STORAGE'
,p_message_language=>'it'
,p_message_text=>'Memorizzazione:'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412010921306887)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query strutturata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102513220059306968)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report strutturato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102799458575307241)
,p_name=>'SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Sottometti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592938103307044)
,p_name=>'SUBMITTED'
,p_message_language=>'it'
,p_message_text=>'Sottomissione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102508755810306964)
,p_name=>'SUBMIT_AS'
,p_message_language=>'it'
,p_message_text=>'Sottometti come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718660280307166)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'it'
,p_message_text=>'Sottometti feedback'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650714197307102)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voce corrente subordinata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102650808257307103)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voce non corrente subordinata'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427569334307730)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'it'
,p_message_text=>'Master inesistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427721200307730)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103427637899307730)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'it'
,p_message_text=>'Repository temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395211038306874)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395517845306874)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questo schema di autenticazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395760845306874)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessuno schema di autorizzazione sottoscrive a questo schema di autorizzazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395676212306874)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Schemi di autorizzazione con sottoscrizione a questo schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197667287306720)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197944753306720)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "primaria" di questa definizione di caricamento dati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197854533306720)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna sottoscrizione delle definizioni di caricamento dati a questa definizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102197718470306720)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Definizione caricamento dati con sottoscrizione a questa definizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394619784306873)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394785794306873)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questa Guida dell''elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394990882306873)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessun elemento sottoscrive a questo testo Guida dell''elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102394851127306873)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Elementi con sottoscrizione a questo testo Guida dell''elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397292920306875)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397394962306875)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" della lista di valori specifica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397512712306876)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna lista di valori sottoscritta a questa lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397483027306875)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Liste di valori con sottoscrizione a questa lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285392470306786)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102398880881306877)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questa barra di navigazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399469780306877)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna barra di navigazione sottoscrive a questa barra di navigazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399184293306877)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Barre di navigazione con sottoscrizione a questa barra di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284936890306786)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285091103306786)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questo plugin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285250527306786)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessun plugin esegue la sottoscrizione a questo plugin.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285129394306786)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Plugin con sottoscrizione a questo plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396042321306874)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396213005306875)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questa scorciatoia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396541202306875)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna scorciatoia sottoscrive a questa scorciatoia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396484738306875)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Scorciatoie con sottoscrizione a questa scorciatoia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390848884306870)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391070263306870)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questo modello.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391117501306871)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessun modello sottoscrive a questo modello.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102390996023306870)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'it'
,p_message_text=>'Modello di lista di valori popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401951555306879)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Modelli con sottoscrizione a questo modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366393941307680)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Sottoscritto a un tema applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103408947481307716)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'it'
,p_message_text=>'Sottoscritto a un tema standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366778563307681)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" del tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366677451307681)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessun tema con sottoscrizione a questo tema. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366443767307681)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'it'
,p_message_text=>'Tema di lista di valori popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103366592461307681)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Temi con sottoscrizione a questo tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774243635307218)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774371281307218)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "master" dell''origine dati REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774534422307218)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna origine dati REST con sottoscrizione a questa origine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102774452147307218)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Origini dati REST con sottoscrizione a questa origine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400920024306878)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'it'
,p_message_text=>'Copiato dall''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401794446306879)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'it'
,p_message_text=>unistr('Questa \00E8 la copia "principale" di questo modello di pulsante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402127537306879)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Nessun modello sottoscrive a questo modello di pulsante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402025461306879)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Modelli di pulsante con sottoscrizione a questo modello di pulsante'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102228984818306744)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'it'
,p_message_text=>'Uso della stringa di sostituzione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629619556307086)
,p_name=>'SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102706153774307154)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio di operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102592048859307043)
,p_name=>'SUCCESSES'
,p_message_language=>'it'
,p_message_text=>'Operazioni riuscite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458765679306926)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'it'
,p_message_text=>'Cluster troncato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455066807306923)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'it'
,p_message_text=>'Comando eseguito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457879592306925)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Contesto eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458063255306925)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'it'
,p_message_text=>'Database link creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457903439306925)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Database link eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458973920306926)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Funzione modificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453945229306922)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'it'
,p_message_text=>'Funzione creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456805632306924)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Funzione eliminata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458552883306925)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Tipo di indice modificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457741379306925)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Tipo di indice eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454371080306922)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'it'
,p_message_text=>'Indice creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457163375306924)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Indice eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454665444306922)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'it'
,p_message_text=>'Vista materializzata creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457228140306924)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Vista materializzata eliminata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458801875306926)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Package modificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454198115306922)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'it'
,p_message_text=>'Package body creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454295220306922)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'it'
,p_message_text=>'Package creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456144478306923)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Package eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459053004306926)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Procedura modificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454038241306922)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Procedura creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456903481306924)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Procedura eliminata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454785580306922)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Ruolo creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457385883306924)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Ruolo eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455534530306923)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'it'
,p_message_text=>'%0 riga/e eliminate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455377442306923)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'it'
,p_message_text=>'%0 riga/e inserite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455294495306923)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'it'
,p_message_text=>'%0 riga/e aggiornate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459117143306926)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Sequenza modificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454844577306922)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'it'
,p_message_text=>'Sequenza creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456521574306924)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Sequenza eliminata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180519859306707)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'it'
,p_message_text=>'Riga creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180427514306707)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'it'
,p_message_text=>'Riga eliminata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180386534306707)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Riga aggiornata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215356700306733)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'it'
,p_message_text=>'Istruzione elaborata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454956655306922)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'it'
,p_message_text=>'Sinonimo creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457403725306924)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Sinonimo eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456652999306924)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Tabella modificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453589523306921)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Tabella creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456081082306923)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Tabella eliminata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458164059306925)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'it'
,p_message_text=>'Tabella rinominata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458633560306925)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'it'
,p_message_text=>'Tabella troncata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458422325306925)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Trigger modificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453837777306922)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'it'
,p_message_text=>'Trigger creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457597667306925)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Trigger eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458315838306925)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Tipo modificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454489124306922)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Tipo creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457633242306925)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Tipo eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459226167306926)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Utente modificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102454505192306922)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'it'
,p_message_text=>'Utente creato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456293614306924)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Utente eliminato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102458245666306925)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'it'
,p_message_text=>'Vista modificata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453660811306921)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'it'
,p_message_text=>'Vista creata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456332788306924)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'it'
,p_message_text=>'Vista eliminata.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102798169375307239)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Oggetti di supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334876838307658)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'it'
,p_message_text=>unistr('La definizione dell''oggetto \00E8 stata modificata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103334906509307658)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'it'
,p_message_text=>unistr('L''oggetto non esiste pi\00F9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658742441307110)
,p_name=>'SVG CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748232461307193)
,p_name=>'SVG PLUGIN'
,p_message_language=>'it'
,p_message_text=>'Installare SVG Viewer per visualizzare il grafico.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178889404306705)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'it'
,p_message_text=>'Impossibile modificare un script SQL vuoto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178910489306706)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 possibile modificare gli script con dimensioni superiori a 30.000 byte.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411225791306886)
,p_name=>'SYNONYM'
,p_message_language=>'it'
,p_message_text=>'sinonimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012533149307404)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'it'
,p_message_text=>'(sinonimo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791484098307234)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'it'
,p_message_text=>'Sinonimo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922639453307337)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio di sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593165259307044)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102593232981307044)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'it'
,p_message_text=>'Stato sistema modificato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411342616306886)
,p_name=>'TABLE'
,p_message_language=>'it'
,p_message_text=>'tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102659366593307110)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non \00E8 un nome tabella o un nome vista valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689105674307138)
,p_name=>'TABLESPACES'
,p_message_language=>'it'
,p_message_text=>'Tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410393715306886)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'it'
,p_message_text=>'(tabella)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102705588652307154)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>'Il nome della tabella %0 supera la dimensione consentita.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718415654307166)
,p_name=>'TABULAR_FORM'
,p_message_language=>'it'
,p_message_text=>'Form tabulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724998215307172)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione del form tabulare completata.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102406246536306882)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'it'
,p_message_text=>'Avvertenza: la destinazione "%0" della scheda padre sembra fare riferimento a una pagina inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397960831306876)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Sequenza di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396866304306875)
,p_name=>'TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Set di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953193918307359)
,p_name=>'TAB_SETS'
,p_message_language=>'it'
,p_message_text=>'Set di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102397079076306875)
,p_name=>'TAB_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo scheda'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413879335307720)
,p_name=>'TAG_LABEL'
,p_message_language=>'it'
,p_message_text=>'Tag: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238378780306751)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'it'
,p_message_text=>'Funzioni di destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451936333307750)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'it'
,p_message_text=>'ID pagina di destinazione o URL personalizzato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102662076234307113)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'it'
,p_message_text=>'Task completato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686216438307135)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'it'
,p_message_text=>'Team Development'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102391845797306871)
,p_name=>'TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441096645307741)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645763639307098)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'it'
,p_message_text=>'Dopo l''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645831836307098)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Prima del pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440721354307741)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'it'
,p_message_text=>'Copia modello: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440909197307741)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Nuovo modello: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174471528306702)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'it'
,p_message_text=>'Corpo del modello di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645470190307098)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'it'
,p_message_text=>'Corpo del modello di pagina (1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645578553307098)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'it'
,p_message_text=>'Corpo del modello di pagina (2)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645698769307098)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'it'
,p_message_text=>'Corpo del modello di pagina (3)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103440820953307741)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'it'
,p_message_text=>'Anteprima modello: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644659190307097)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'it'
,p_message_text=>'Posizione 9 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644720614307097)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'it'
,p_message_text=>'Posizione 10 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644808583307097)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'it'
,p_message_text=>'Posizione 11 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102644978579307097)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'it'
,p_message_text=>'Posizione 12 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645092105307097)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'it'
,p_message_text=>'Posizione 13 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645111888307097)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'it'
,p_message_text=>'Posizione 14 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645242217307097)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'it'
,p_message_text=>'Posizione 15 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102645317263307098)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'it'
,p_message_text=>'Posizione 16 area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103148338127307506)
,p_name=>'TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Modelli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102778641012307222)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102208415389306728)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione di un''applicazione basata su un''applicazione modello.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845681356307277)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'it'
,p_message_text=>'Basato su modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776799586307220)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'it'
,p_message_text=>'Avanzate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776699118307220)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'it'
,p_message_text=>'Comune'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103220655746307571)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Valore predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776504306307220)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'it'
,p_message_text=>'Generale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337752579307660)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'it'
,p_message_text=>'Nessuna opzione modello corrispondente definita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345401329307665)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'it'
,p_message_text=>'- Nessuna opzione selezionata -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103321912462307648)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'it'
,p_message_text=>'Usa impostazioni predefinite modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428334496307731)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'it'
,p_message_text=>'Mancata corrispondenza delle opzioni del modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449438328307748)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'it'
,p_message_text=>unistr('Questo modello \00E8 sottoscritto al modello corrispondente nel tema principale. Per modificare questo modello, modificare quello principale, quindi aggiornare il tema. In alternativa, \00E8 possibile creare una copia locale con sottoscrizione annullata del ')
||'modello. I modelli con sottoscrizione annullata sono modificabili e non verranno sovrascritti dall''aggiornamento del tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449345979307748)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Questo modello \00E8 locale per l''applicazione e la sua sottoscrizione \00E8 annullata. '),
unistr('Non \00E8 possibile sottoscrivere singoli modelli se il tema associato \00E8 sottoscritto.'),
unistr('Invece di definire modelli locali, \00E8 possibile aggiungere nuovi modelli al tema principale, quindi eseguirne il PUSH o il PULL nell''applicazione.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403083142306880)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Di riferimento come modello predefinito di applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403217229306880)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Di riferimento come modello di errore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403445190306880)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'it'
,p_message_text=>'Questo modello di pagina NON contiene riferimenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403559181306880)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('Questo modello di pagina \00E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403304471306880)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Di riferimento nella pagina o nelle pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102403167374306880)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Di riferimento come modello per la stampa.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102597659720307048)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'it'
,p_message_text=>'Tablespace temporanea'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102459371398306926)
,p_name=>'TEST'
,p_message_language=>'it'
,p_message_text=>'Test'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684116487307134)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'it'
,p_message_text=>'Assegnatario test'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102682336904307132)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Test dell''impatto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684523560307134)
,p_name=>'TESTING_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato test'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102750840122307196)
,p_name=>'TEST_QUERY'
,p_message_language=>'it'
,p_message_text=>'Test della query'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102954350031307360)
,p_name=>'TEXT FILES'
,p_message_language=>'it'
,p_message_text=>'File di testo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102352535039306840)
,p_name=>'THEME'
,p_message_language=>'it'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102279193766306781)
,p_name=>'THEME FILES'
,p_message_language=>'it'
,p_message_text=>'File di temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953988941307360)
,p_name=>'THEME IMAGES'
,p_message_language=>'it'
,p_message_text=>'Immagini tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103415059872307721)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'it'
,p_message_text=>'Compatibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206313082307561)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'it'
,p_message_text=>'Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102346909507306836)
,p_name=>'THEMES'
,p_message_language=>'it'
,p_message_text=>'Temi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449562864307748)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'it'
,p_message_text=>'Impossibile annullare la sottoscrizione di singoli modelli che fanno parte di un tema sottoscritto a un altro tema allo stesso modello.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449841038307748)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile convertire l''applicazione in un tema utilizzando la navigazione basata su schede poich\00E9 utilizza la navigazione basata su lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103449742294307748)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile convertire l''applicazione in un tema utilizzando la navigazione basata su lista poich\00E9 utilizza due livelli di schede. Aggiornare l''applicazione e impostare le schede correnti in modo che utilizzino un solo livello di schede prima di camb')
||'iare tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102666168259307117)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'it'
,p_message_text=>'Impossibile cambiare un tema Desktop in tema Mobile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572516831307026)
,p_name=>'THEME_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di tema'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103413203394307719)
,p_name=>'TITLE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Titolo: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661422023307112)
,p_name=>'TO DO'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708210072307156)
,p_name=>'TODO'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687967225307137)
,p_name=>'TODOS'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237587610306750)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0 completata (%0 / %1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102992927155307389)
,p_name=>'TODO_DASH_1'
,p_message_language=>'it'
,p_message_text=>'%0 voce/i, %1 aperta/e, %2 completata/e.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993050601307389)
,p_name=>'TODO_DASH_2'
,p_message_language=>'it'
,p_message_text=>'%0 voce/i parzialmente completata/e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993142181307389)
,p_name=>'TODO_DASH_3'
,p_message_language=>'it'
,p_message_text=>'%0 voce/i parzialmente completata/e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686735089307136)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'it'
,p_message_text=>'Prime %0 tabelle per conteggio righe, secondo lo schema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711335170307159)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'it'
,p_message_text=>'Totale chiusi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708881944307157)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'it'
,p_message_text=>'Milestone totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102711295778307159)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'it'
,p_message_text=>'Totale aperti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686817157307136)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'it'
,p_message_text=>'Tempo totale di presentazione (secondi)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328736927307653)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'it'
,p_message_text=>'Da rimuovere (nei prossimi 7 giorni)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709901539307158)
,p_name=>'TO_DOS'
,p_message_language=>'it'
,p_message_text=>unistr('Attivit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103015094677307406)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'it'
,p_message_text=>unistr('Percentuale completamento attivit\00E0 (%0/%1):')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413311622306888)
,p_name=>'TREE'
,p_message_language=>'it'
,p_message_text=>'struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836138493307270)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'it'
,p_message_text=>'Struttura iniziale basata su elemento esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836278937307270)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>'Struttura iniziale basata su una query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836495491307270)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore della struttura iniziale \00E8 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102836372830307270)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'it'
,p_message_text=>'Struttura iniziale basata su un valore statico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326571393306817)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione della struttura completata.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102411411966306887)
,p_name=>'TRIGGER'
,p_message_language=>'it'
,p_message_text=>'trigger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288201745306788)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'it'
,p_message_text=>'I nomi dei pulsanti non devono essere uguali a quelli di schede esistenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794216516307236)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'it'
,p_message_text=>'L''ID applicazione e l''ID del gruppo di sicurezza corrente non sono coerenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288187707306788)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID gruppo di sicurezza 20 \00E8 riservato per l''area di lavoro ''ORACLE''')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102792191695307234)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'it'
,p_message_text=>'Tronca tabella %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102837076407307271)
,p_name=>'TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102838928425307272)
,p_name=>'TYPE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Tipo: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102787556722307230)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di elemento personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794132946307236)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'it'
,p_message_text=>'Visualizza definizione di colonna di database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102680570744307130)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'it'
,p_message_text=>'Passa a contenuto principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201362775306723)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'it'
,p_message_text=>'Desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201433501306723)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'it'
,p_message_text=>'Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201520650306723)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'it'
,p_message_text=>'Tablet jQuery Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201658569306723)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'it'
,p_message_text=>'Smartphone jQuery Mobile per PhoneGap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201725711306723)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'it'
,p_message_text=>'Tablet jQuery Mobile per PhoneGap'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102359562174306846)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile determinare la data del milestone'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730776830307177)
,p_name=>'UNASSIGNED'
,p_message_language=>'it'
,p_message_text=>'Non assegnato/i'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753708586307198)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'it'
,p_message_text=>'Utente non autenticato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934843237307346)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'it'
,p_message_text=>'Non disponibile (reindirizzamento a URL)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102934776361307346)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'it'
,p_message_text=>'Non disponibile (stato mostrato con PL/SQL)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669206681307120)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'it'
,p_message_text=>'Preso in considerazione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284217484306785)
,p_name=>'UNEXPIRED'
,p_message_language=>'it'
,p_message_text=>'Non scaduto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795718130307237)
,p_name=>'UNLOCK'
,p_message_language=>'it'
,p_message_text=>'Sblocca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883778879307305)
,p_name=>'UNLOCKED'
,p_message_language=>'it'
,p_message_text=>'sbloccato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248305064306758)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni sbloccate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102245377409306756)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Sblocca'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102505295781306962)
,p_name=>'UNRESTRICTED'
,p_message_language=>'it'
,p_message_text=>'Non limitato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460083023306927)
,p_name=>'UP'
,p_message_language=>'it'
,p_message_text=>'Su'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413154184306888)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'it'
,p_message_text=>'report aggiornabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102993200742307389)
,p_name=>'UPDATED_BY'
,p_message_language=>'it'
,p_message_text=>'Autore aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443303196306913)
,p_name=>'UPDATED_ON'
,p_message_language=>'it'
,p_message_text=>'Data aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845849525307277)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'it'
,p_message_text=>'Aggiorna a versione applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102845902891307277)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'it'
,p_message_text=>'Aggiorna a versione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345311170307665)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'it'
,p_message_text=>unistr('non \00E8 un formato di data supportato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016168425307407)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato data non supportato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396498090307703)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'it'
,p_message_text=>'Dopo l''aggiornamento, assicurarsi che l''attributo di serie Colonna etichetta sia mappato a una colonna Data o Indicatore orario.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413290577306888)
,p_name=>'URL'
,p_message_language=>'it'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102649785763307101)
,p_name=>'URL LINK'
,p_message_language=>'it'
,p_message_text=>'Collegamento URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102673355658307123)
,p_name=>'USERID'
,p_message_language=>'it'
,p_message_text=>'ID utente'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689680493307139)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'it'
,p_message_text=>unistr('%0 utenti, utente creato pi\00F9 di recente %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794580850307236)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'it'
,p_message_text=>'Nessuna pagina globale definita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102684064662307133)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'it'
,p_message_text=>'Assegnatario interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102683586821307133)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'it'
,p_message_text=>'Impatto interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685013049307134)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato interfaccia utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102302963548306799)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilizzare questa pagina per controllare l''accesso per gli amministratori di aree di lavoro, gli sviluppatori di applicazioni e gli utenti finali di Application Express.</p>',
'',
unistr('<p>Gli <strong>amministratori delle aree di lavoro</strong> possono creare e modificare le applicazioni e gli oggetti di database, nonch\00E9 gestire gli account utente, i gruppi e i servizi di sviluppo.</p>'),
'',
'<p>Gli <strong>sviluppatori</strong> possono creare e modificare sia le applicazioni che gli oggetti di database.</p>',
'',
'<p>Gli <strong>utenti finali</strong> non hanno privilegi di sviluppo e possono solo accedere alle applicazioni che non utilizzano uno schema di autenticazione esterno.</p>',
'',
'<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">Ulteriori informazioni...</a></p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327167266306817)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa pagina per controllare l''accesso per gli utenti finali di Application Express.</p>',
'',
'<p>Gli <strong>utenti finali</strong> non dispongono di privilegi di sviluppo e possono accedere solo alle applicazioni che non utilizzano uno schema di autenticazione esterno.</p>',
'',
'<p>Gli <strong>amministratori di area di lavoro</strong> e gli <strong>sviluppatori</strong> sono gestiti mediante la console Identity. Quando un amministratore di area di lavoro o uno sviluppatore esegue il login a Application Express, viene creato '
||unistr('un account "ombra". Se lo si desidera, \00E8 possibile rimuovere questi utenti "ombra".</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414687970306889)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'it'
,p_message_text=>'Utilizzare la pagina di login incorporata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414419664306889)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'it'
,p_message_text=>'Utilizzare la pagina %0 come pagina di login.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777419072307220)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilizzare l''attributo <strong>Svuota cache</strong> per rimuovere lo stato della sessione per una lista separata da virgole di pagine. \00C8 disponibile anche la seguente sintassi per lo svuotamento della cache:'),
'<ul>',
'<li>RIR - Reset Interactive Report. Reimposta il report interattivo.</li>',
'<li>CIR - Clear Interactive Report. Cancella il report interattivo.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102800440227307241)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'con utilizzo di schema esistente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422120578307726)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422464064307726)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'it'
,p_message_text=>'Editor di codice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422359746307726)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'it'
,p_message_text=>'Ingrandisci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422235613307726)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'it'
,p_message_text=>'Riduci a icona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423553294307727)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Se si modifica lo stile di tema, le modifiche non salvate verranno reimpostate. Questa operazione non pu\00F2 essere annullata. Procedere?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450813381307749)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'it'
,p_message_text=>'Modifica tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422050593307726)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'it'
,p_message_text=>'Stile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421867714307726)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421294754307725)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Conferma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450528534307749)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'it'
,p_message_text=>'Copia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421600266307726)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'it'
,p_message_text=>'No'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421744056307726)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'it'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450453252307749)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'it'
,p_message_text=>' Sono state apportate modifiche a un tema di sola lettura. Se il tema viene impostato come tema corrente, le modifiche verranno cancellate. Continuare? '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421999669307726)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome stile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421370655307725)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione completata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450620083307749)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'it'
,p_message_text=>'Avvertenza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421569227307726)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447116772307746)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Incollare la seguente linea di codice nella console JS per caricare la configurazione corrente in Theme Roller:'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447226337307746)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Theme Roller deve essere aperto e lo stile corrente deve essere valido per poter visualizzare l''output della configurazione.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335292351307658)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'it'
,p_message_text=>'Fattore di contrasto:'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428689805307731)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'it'
,p_message_text=>'Non riuscito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431088341307733)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'it'
,p_message_text=>'Per testo superiore a 18pt o grassetto superiore a 14pt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428710744307731)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Le convalide vengono eseguite secondo le linee guida Web Content Accessibility (WCAG) 2.0 in contrasto di colore per caratteri con dimensioni normali'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428516563307731)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'it'
,p_message_text=>'Riuscito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103428410627307731)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'it'
,p_message_text=>'Informazioni su contrasto colore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450363673307748)
,p_name=>'UTR.CURRENT'
,p_message_language=>'it'
,p_message_text=>'Corrente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423380200307727)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'it'
,p_message_text=>'CSS personalizzato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423446771307727)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('Questo codice verr\00E0 incluso alla fine del foglio di stile')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103432263375307734)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'it'
,p_message_text=>unistr('Questo codice CSS nasconde la finestra di dialogo di Theme Roller. Non verr\00E0 applicato alla pagina.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013023001307404)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'Scarica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013333312307404)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'it'
,p_message_text=>'Trascinare i file o fare clic per selezionare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013510943307404)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'it'
,p_message_text=>'Abilita compilazione LESS'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421499401307725)
,p_name=>'UTR.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423931212307727)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare lo stile di tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431908065307734)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('Errore durante il caricamento di uno o pi\00F9 URL di file CSS.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423762334307727)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'it'
,p_message_text=>unistr('Il codice LESS per questo stile di tema non \00E8 valido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424107077307728)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato possibile creare lo stile di tema. Assicurarsi che la finestra dell''App Builder sia ancora aperta e che la sessione sia valida.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450755968307749)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'it'
,p_message_text=>'Impossibile utilizzare il tema selezionato come tema corrente dell''applicazione.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423641109307727)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'it'
,p_message_text=>'Questo stile di tema non supporta la personalizzazione di Theme Roller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423879611307727)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'it'
,p_message_text=>'Questo tema non ha stili di tema. Selezionare un tema con stili di tema per utilizzare Theme Roller.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103424044719307727)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare lo stile di tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324201281307650)
,p_name=>'UTR.FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431104889307733)
,p_name=>'UTR.HELP'
,p_message_language=>'it'
,p_message_text=>'Guida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431226855307733)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'it'
,p_message_text=>unistr('Theme Roller consente di personalizzare facilmente l''interfaccia utente dell''applicazione mediante la selezione di colori e l''impostazione di stili per vari componenti dell''applicazione. Un''applicazione pu\00F2 avere un numero qualsiasi di stili di tema,')
||unistr(' ma solo quello corrente verr\00E0 utilizzato per mostrare l''applicazione agli utenti finali.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431378773307733)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Dopo aver apportato le modifiche, gli attributi possono essere ripristinati facilmente sia per lo stile di tema completo, premendo il pulsante Reimposta, oppure premendo l''icona di reimpostazione per il gruppo. ',
'',
'Nel caso degli attributi che consentono la selezione dei colori in primo piano e dello sfondo, la casella di controllo davanti alle due selezioni dei colori indica le informazioni sul contrasto di colore secondo le linee guida Web Content Accessibili'
||'ty (WCAG) 2.0. Un punteggio elevato per il contrasto indica che la combinazione di colori migliora l''accesso facilitato.'))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103208195836307562)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'it'
,p_message_text=>'Editor in linea'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732859373307179)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'it'
,p_message_text=>'Evidenziatore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442955874307743)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna azioni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446463434307745)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'it'
,p_message_text=>'Attivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447033897307746)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'it'
,p_message_text=>'Stato Attivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444952623307744)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'it'
,p_message_text=>'Sfondo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102732966060307179)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'it'
,p_message_text=>'Badge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442857304307742)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442741756307742)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'it'
,p_message_text=>'Accento corpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447308710307746)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'it'
,p_message_text=>'Larghezza massima contenuto del corpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443594334307743)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'it'
,p_message_text=>'Raggio bordo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441638009307741)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'it'
,p_message_text=>'Pulsanti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445151953307744)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'it'
,p_message_text=>'Colore 1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445928929307745)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'it'
,p_message_text=>'Colore 10'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414421108307720)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'it'
,p_message_text=>'Colore 11'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414564404307720)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'it'
,p_message_text=>'Colore 12'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414654389307720)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'it'
,p_message_text=>'Colore 13'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414769600307720)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'it'
,p_message_text=>'Colore 14'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103414840258307720)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'it'
,p_message_text=>'Colore 15'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445296869307744)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'it'
,p_message_text=>'Colore 2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446046405307745)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'it'
,p_message_text=>'Colore 3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445311634307744)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'it'
,p_message_text=>'Colore 4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445432354307745)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'it'
,p_message_text=>'Colore 5'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445545539307745)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'it'
,p_message_text=>'Colore 6'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445652318307745)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'it'
,p_message_text=>'Colore 7'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445749710307745)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'it'
,p_message_text=>'Colore 8'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445855247307745)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'it'
,p_message_text=>'Colore 9'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441705141307742)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'it'
,p_message_text=>'Contenitori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446110695307745)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'it'
,p_message_text=>'Raggio bordo contenitore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443914973307743)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'it'
,p_message_text=>'Pericolo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444348885307744)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443243473307743)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'it'
,p_message_text=>'Contorno selezione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444735400307744)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'it'
,p_message_text=>'Primo piano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451554478307749)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'it'
,p_message_text=>'Form'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441445984307741)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'it'
,p_message_text=>'Colori globali'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103445073923307744)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442666884307742)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'it'
,p_message_text=>'Accento intestazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102735371095307181)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'it'
,p_message_text=>'Altezza intestazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443706904307743)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'it'
,p_message_text=>'Predefinito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446722773307746)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'it'
,p_message_text=>'Passaggio del mouse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446804329307746)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'it'
,p_message_text=>'Stato passaggio del mouse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446312184307745)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'it'
,p_message_text=>'Icona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444421717307744)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442502112307742)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'it'
,p_message_text=>'Report interattivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451607510307750)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451786467307750)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441869079307742)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'it'
,p_message_text=>'Layout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443401427307743)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna sinistra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443130323307743)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'it'
,p_message_text=>'Colore collegamento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444601409307744)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'it'
,p_message_text=>'Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103437683225307738)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'it'
,p_message_text=>'Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102779404825307222)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'it'
,p_message_text=>'Stato al passaggio del mouse su una voce di menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441907868307742)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Navigazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446214130307745)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'it'
,p_message_text=>'Struttura di navigazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443663061307743)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'it'
,p_message_text=>'Normale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446509465307745)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'it'
,p_message_text=>'Non attivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442299596307742)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'it'
,p_message_text=>'Tavolozza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443842100307743)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'it'
,p_message_text=>'Chiave primaria'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608780201307059)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'it'
,p_message_text=>'Evidenziatore primario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441503383307741)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'it'
,p_message_text=>'Aree'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443335327307743)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426530196307729)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'it'
,p_message_text=>'Report e griglie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343799599307664)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'it'
,p_message_text=>'Sfondo corpo messaggio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343608767307664)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione corpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344456495307665)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0 di visualizzazione')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344644625307665)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'it'
,p_message_text=>'Compatto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344508780307665)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'it'
,p_message_text=>'Standard (predefinito)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328142437307653)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'it'
,p_message_text=>'Layout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331784746307655)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'it'
,p_message_text=>'Contenuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331599034307655)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'it'
,p_message_text=>'Da bordo a bordo (predefinito)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331640796307655)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'it'
,p_message_text=>'Mobile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328050988307653)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Modalit\00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331340842307655)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'it'
,p_message_text=>'Scuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331473461307655)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo scuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344801613307665)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Scuro (predefinito)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103331240279307655)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'it'
,p_message_text=>'Chiaro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344919648307665)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Chiaro (predefinito)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103327919223307653)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'it'
,p_message_text=>'Gruppo di prodotti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343414328307664)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'it'
,p_message_text=>'Beige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343059431307664)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'it'
,p_message_text=>'Lilla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342497493307663)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'it'
,p_message_text=>'Neutro (predefinito)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342933487307664)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'it'
,p_message_text=>'Blu oceano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342544254307663)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'it'
,p_message_text=>'Grigio ghiaia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342705491307663)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'it'
,p_message_text=>'Verde pino'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343376331307664)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'it'
,p_message_text=>'Prugna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343133574307664)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'it'
,p_message_text=>'Rosa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343211538307664)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'it'
,p_message_text=>'Terra di Siena'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342638382307663)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'it'
,p_message_text=>'Ardesia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342807517307664)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'it'
,p_message_text=>'Teal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343593283307664)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'it'
,p_message_text=>'Aspetto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103342337256307663)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'it'
,p_message_text=>'Opzioni Redwood'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102524178908306981)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'it'
,p_message_text=>'Scala'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102608886160307059)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'it'
,p_message_text=>'Evidenziatore secondario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446607077307745)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'it'
,p_message_text=>'Selezionato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103446927586307746)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'it'
,p_message_text=>'Stato Selezionato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444229253307744)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'it'
,p_message_text=>'Semplice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442091136307742)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'it'
,p_message_text=>'Stati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444143590307744)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione completata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444873814307744)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103443068403307743)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra del titolo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103444044673307743)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'it'
,p_message_text=>'Avvertenza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103324367150307650)
,p_name=>'UTR.LOADING'
,p_message_language=>'it'
,p_message_text=>'Caricamento in corso...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102326745201306817)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo alternativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976443280307377)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976372185307376)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile modificare il markup del logo in Application Builder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014062264307405)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato possibile caricare i dati del logo. Assicurarsi che la finestra di App Builder sia ancora aperta e che la sessione utente sia valida.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976243021307376)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016207556307407)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'it'
,p_message_text=>'Nessuna immagine caricata.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976129792307376)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'it'
,p_message_text=>'Immagine e testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013613496307405)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'it'
,p_message_text=>'Selezionare un file con dimensione inferiore a %0 KB'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976008809307376)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'it'
,p_message_text=>'Nessuno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013754202307405)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'it'
,p_message_text=>'Sono consentiti solo file immagine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012940331307404)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'it'
,p_message_text=>'Salva logo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013823994307405)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato possibile salvare il logo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013985825307405)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Salvataggio del logo riuscito.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975981687307376)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975756161307376)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975668663307376)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'it'
,p_message_text=>'Trascinare i file o fare clic per selezionare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206423244307561)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'it'
,p_message_text=>'Modifica logo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013476455307404)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'it'
,p_message_text=>'Sono consentiti solo file JSON'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439278206307740)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'it'
,p_message_text=>'Adiacente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439085375307739)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'it'
,p_message_text=>'RGB base'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451313240307749)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'it'
,p_message_text=>'Doppio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439142510307740)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'it'
,p_message_text=>'Monocromatico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439667230307740)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'it'
,p_message_text=>'Separazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439447071307740)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'it'
,p_message_text=>'Tetrade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439339944307740)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'it'
,p_message_text=>'Triade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103439565367307740)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'it'
,p_message_text=>'Con complemento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734760818307181)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'it'
,p_message_text=>'Le modifiche al logo non sono state salvate.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102734846636307181)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'it'
,p_message_text=>'Le modifiche al tema non sono state salvate.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442424886307742)
,p_name=>'UTR.REDO'
,p_message_language=>'it'
,p_message_text=>'Ripeti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423112370307727)
,p_name=>'UTR.RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423239942307727)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 certi di voler reimpostare il CSS? Tutte le modifiche andranno perse. L''operazione non pu\00F2 essere annullata.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450960289307749)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'it'
,p_message_text=>'Reimposta stile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422885474307727)
,p_name=>'UTR.SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422972071307727)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Aggiornare il nome per rinominare lo stile di tema corrente.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103423085837307727)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento dello stile di tema riuscito.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422505324307726)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'it'
,p_message_text=>'Salva con nome'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422622277307726)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Immettere un nome per il nuovo stile di tema.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103422796289307726)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Creazione dello stile di tema riuscita.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103438936208307739)
,p_name=>'UTR.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103206511807307561)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'it'
,p_message_text=>'Seleziona tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103450298044307748)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'it'
,p_message_text=>'Imposta come corrente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451072842307749)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'it'
,p_message_text=>'Imposta come stile di tema corrente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451102753307749)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'it'
,p_message_text=>unistr('Il tema selezionato adesso \00E8 il tema corrente dell''applicazione.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451292982307749)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Sono state apportate modifiche a un tema di sola lettura. Se il tema viene impostato come tema corrente dell''applicazione, le modifiche verranno cancellate. Continuare?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975537059307376)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'it'
,p_message_text=>'Logo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975430303307376)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'it'
,p_message_text=>'Stile tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103421196922307725)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'it'
,p_message_text=>'Theme Roller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431816523307734)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'it'
,p_message_text=>'Mostra tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103431763370307734)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'it'
,p_message_text=>'Mostra comuni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448056299307747)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'it'
,p_message_text=>'Diagramma circolare colori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442356006307742)
,p_name=>'UTR.UNDO'
,p_message_language=>'it'
,p_message_text=>'Annulla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013160446307404)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'it'
,p_message_text=>'Carica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103013234851307404)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'it'
,p_message_text=>'Carica file di configurazione'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423066551306897)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1812 Errore imprevisto durante la conversione dell''alias di applicazione (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412008403307718)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'it'
,p_message_text=>'Convalida: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204209203306725)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'it'
,p_message_text=>'Visualizza tutti i gruppi di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204395512306725)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'it'
,p_message_text=>'Visualizza tutti i tipi di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102351862132306840)
,p_name=>'VIEWS2'
,p_message_language=>'it'
,p_message_text=>'Viste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952280572307359)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'it'
,p_message_text=>'Visualizza debug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102227224005306742)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'it'
,p_message_text=>'Visualizza dettagli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796471179307238)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'it'
,p_message_text=>'Visualizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222283074306739)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'it'
,p_message_text=>'Visualizza per la stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980774678307380)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'it'
,p_message_text=>'Visualizza cronologia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371172287307684)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'it'
,p_message_text=>'Visualizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102410447410306886)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'it'
,p_message_text=>'(vista)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103401883547307710)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'it'
,p_message_text=>'Visualizza cronologia lock'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332631875307656)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'it'
,p_message_text=>unistr('Questa query SQL \00E8 utilizzata per generare il codice XML visualizzato dopo aver fatto clic sul pulsante <strong>Visualizza XML</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204806333306725)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'it'
,p_message_text=>'Visualizza pagine di questo tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102975884246307376)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'it'
,p_message_text=>'Visualizza cronologia modifiche pagina "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317065375306810)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'it'
,p_message_text=>unistr('Visualizza attivit\00E0 per %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102724636701307171)
,p_name=>'VPD'
,p_message_language=>'it'
,p_message_text=>'VPD (Virtual Private Database)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736626674307182)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'it'
,p_message_text=>'Installazione dell''applicazione in corso...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417860129307723)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'it'
,p_message_text=>'Rimozione dell''applicazione in corso...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103418000764307723)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'it'
,p_message_text=>'Sblocco dell''applicazione in corso...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103417902639307723)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento dell''applicazione in corso...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736774339307182)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'it'
,p_message_text=>'Elaborazione della richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736893605307183)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'it'
,p_message_text=>'Installazione degli oggetti di supporto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846279850307277)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'it'
,p_message_text=>'Nessuna classe corrispondente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102846144220307277)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'it'
,p_message_text=>unistr('Pi\00F9 corrispondenze')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191554295306715)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'it'
,p_message_text=>'Aggiungi servizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192594303306716)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'it'
,p_message_text=>'Da aggiungere dal catalogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192396143306716)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'it'
,p_message_text=>'Rimuovi servizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102658288351307109)
,p_name=>'WEBSHEET'
,p_message_language=>'it'
,p_message_text=>'Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688827752307138)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'it'
,p_message_text=>'Allegati Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398290162307704)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'it'
,p_message_text=>'Reparto IT AnyCo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398160555307704)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'it'
,p_message_text=>unistr('Reparto IT AnyCo illustra come utilizzare le funzionalit\00E0 delle applicazioni Websheet per contenuti basati su Web finalizzati alla condivisione e alla generazione di report relativi a dati strategici a livello aziendale. Questa applicazione Websheet ')
||'di esempio include diverse griglie di dati e descrive come includere i dati in report e grafici incorporati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103343932595307664)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'it'
,p_message_text=>'Grandi felini'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344223875307665)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'it'
,p_message_text=>unistr('Grandi felini descrive le funzionalit\00E0 dei Websheet, compreso l''incorporamento di immagini e collegamenti pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258352209306766)
,p_name=>'WEBSHEETS'
,p_message_language=>'it'
,p_message_text=>'Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034700176307421)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'it'
,p_message_text=>unistr('Un''applicazione Websheet \00E8 composta da pagine Web che abbinano testo e dati. Queste applicazioni sono molto dinamiche e definite dagli stessi utenti. Le applicazioni includono controlli di navigazione, funzionalit\00E0 di ricerca e la possibilit\00E0 di aggi')
||'ungere annotazioni come file, note e tag. Le applicazioni possono essere protette mediante liste di controllo dell''accesso e vari modelli di autenticazione incorporati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034866966307421)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'it'
,p_message_text=>'Le applicazioni Websheet consentono a un gruppo di collaboratori di creare rapidamente pagine informative, compresi report e grafici, utilizzando semplicemente un browser Web. Gli utenti possono gestire facilmente il testo e i dati locali (chiamati g'
||'riglie di dati) oltre a visualizzare i dati delle query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034914775307421)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'it'
,p_message_text=>unistr('Le applicazioni Websheet sono simili a quelle WIKI, ma sono ottimizzate per l''integrazione e la visualizzazione dei dati. Ad esempio, \00E8 possibile definire una griglia dati per memorizzare informazioni in formato tabulare, definire un report basato su')
||' tabelle esistenti o semplicemente utilizzare una tag SQL per visualizzare i dati del database in una pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035004755307421)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'it'
,p_message_text=>unistr('Le griglie dati sono un componente di Websheet e sono simili ai fogli di calcolo, nel senso che consentono di gestire facilmente le informazioni in formato tabulare. La differenza maggiore \00E8 che tutti i dati di Websheet, invece di essere memorizzati ')
||unistr('localmente in file, vengono memorizzati centralmente nel database Oracle. Utilizzando le griglie dati \00E8 possibile aggiungere annotazioni a ogni riga di dati, tra cui file, note, tag e collegamenti.  Un ulteriore vantaggio \00E8 che \00E8 possibile utilizzare')
||' la funzione di ricerca dell''applicazione per eseguire ricerche su tutti i dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035494804307421)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Le tag SQL consentono di incorporare facilmente i report in una pagina basata su istruzioni SQL scritte prendendo come riferimento le tabelle del database. Mediante SQL, gli utenti possono recuperare facilmente i dati dalle tabelle che preferiscono. '
||'Ad esempio, per vedere se esistono bug aperti scaduti, utilizzare la seguente tag: <pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
'Questa query viene eseguita ogni volta che la pagina viene visualizzata, fornendo dati dinamici invece che un classico snapshot temporale.  '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035122956307421)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Le applicazioni Websheet semplificano la condivisione dei contenuti e consentono di creare report di base molto semplici. L''intera struttura e tutti i contenuti di un''applicazione Websheet sono controllati dagli utenti (collaboratori e amministratori'
||unistr('). Al contrario, le applicazioni di database vengono utilizzate per ottenere funzioni pi\00F9 formali, sofisticate e specializzate di gestione e creazione dei report. La struttura di un''applicazione di database \00E8 controllata dagli sviluppatori, mentre i ')
||'contenuti sono controllati solitamente dagli utenti finali.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034247232307420)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'it'
,p_message_text=>unistr('Cos''\00E8 un Websheet?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034498339307420)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'it'
,p_message_text=>unistr('Perch\00E9 conviene creare un''applicazione Websheet?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034511729307420)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'it'
,p_message_text=>unistr('Qual \00E8 la differenza tra un''applicazione Websheet e una WIKI?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034648633307420)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'it'
,p_message_text=>'Le applicazioni Websheet in linea sono fogli di calcolo?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035503220307421)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'it'
,p_message_text=>unistr('Cos''\00E8 una tag SQL?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034334572307420)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'it'
,p_message_text=>unistr('Qual \00E8 la differenza tra un''applicazione Websheet e un''applicazione database?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102317118818306810)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'it'
,p_message_text=>'Componente non installato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419976251307724)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'it'
,p_message_text=>'Controllo dell''accesso Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103398901924307705)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242999010306754)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986333170307384)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Applicazione %0 attualmente non disponibile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689906672307139)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'it'
,p_message_text=>'Allegati Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980803600307380)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Ultimo aggiornamento contenuto %0 da parte di %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102980997707307380)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'it'
,p_message_text=>'Pagina creata %0 da %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344326446307665)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Si sta per installare un''applicazione Websheet di esempio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103412837255307719)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'it'
,p_message_text=>'Websheet: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102973280566307374)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Ultimo aggiornamento pagina il %0 da parte di %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102688771799307138)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'it'
,p_message_text=>'Dati non BLOB Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383916550307694)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'it'
,p_message_text=>'Gli oggetti Websheet non sono validi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733511126307180)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Applicazione Websheet %0 installata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997860492307392)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'it'
,p_message_text=>'Gli oggetti riportati di seguito possono essere sottoposti a query usando la tag di markup SQL o quella disponibile in Reports. Per identificare i nomi oggetto con distinzione tra maiuscole e minuscole vengono usate le virgolette.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102687294298307136)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'it'
,p_message_text=>'Viste di pagina Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102718180913307165)
,p_name=>'WEB_SERVICE'
,p_message_language=>'it'
,p_message_text=>'Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102412613001306887)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'it'
,p_message_text=>'Risultato Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178007526306705)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'it'
,p_message_text=>'Servizio REST Oracle Cloud Applications (SaaS)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177840607306705)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'it'
,p_message_text=>'HTTP semplice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178197824306705)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'it'
,p_message_text=>'Infrastruttura Oracle Cloud (OCI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177905911306705)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'it'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238153648306750)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'it'
,p_message_text=>'Completare questa procedura di registrazione guidata per richiedere un''area di lavoro Oracle APEX.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729616681307176)
,p_name=>'WHITE_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo bianco'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270788529306775)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'it'
,p_message_text=>'Nel prossimo giorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103337668489307660)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'it'
,p_message_text=>'Nei prossimi %0 giorni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689718471307139)
,p_name=>'WITH_ADMIN'
,p_message_language=>'it'
,p_message_text=>'con Admin Option'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102413025234306888)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'it'
,p_message_text=>'con scorciatoie'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102795409974307237)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Il numero di pagina esiste gi\00E0 in questa applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102794849626307237)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'it'
,p_message_text=>unistr('Il numero pagina \00E8 riservato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102446179409306915)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'it'
,p_message_text=>'Elimina selezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323124666306814)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'it'
,p_message_text=>'Commentato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180680329306707)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'it'
,p_message_text=>'Reimposta pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218482109307570)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne scheda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194023292306717)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'it'
,p_message_text=>'Crea schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021521058307411)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'it'
,p_message_text=>'Crea report classico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986734449307384)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Crea ricerca con facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022061003307411)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'it'
,p_message_text=>'Crea vista form e lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022409912307411)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'it'
,p_message_text=>'Crea form su procedura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022326575307411)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'it'
,p_message_text=>'Crea form su query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022224663307411)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'it'
,p_message_text=>'Crea form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396550870307703)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'it'
,p_message_text=>'Crea form su Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102200985134306722)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'it'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021470925307411)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'it'
,p_message_text=>'Crea griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021333442307410)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'it'
,p_message_text=>'Crea report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192286150306716)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'it'
,p_message_text=>'Crea pagina mappa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021633311307411)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'it'
,p_message_text=>'Crea Master-Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021886846307411)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'it'
,p_message_text=>'Crea report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021937709307411)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'it'
,p_message_text=>'Crea report con form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199827429306722)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'it'
,p_message_text=>'Crea filtri intelligenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102201096714306723)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103022146727307411)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'it'
,p_message_text=>'Crea form tabulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103021713618307411)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'it'
,p_message_text=>'Crea report su Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366132661306851)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Questa procedura guidata richiede un''applicazione basata su tema universale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180111840306706)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'it'
,p_message_text=>'Elabora form %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102180057039306706)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'it'
,p_message_text=>'Inizializza form %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776929264307220)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'it'
,p_message_text=>'Query SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102776848966307220)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790649125307233)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'it'
,p_message_text=>'%0 - Salva dati griglia interattiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783408960307226)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'it'
,p_message_text=>'Report classico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783375658307226)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'it'
,p_message_text=>'Griglia interattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783292435307226)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'it'
,p_message_text=>'Report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783606562307226)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'it'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102783561065307226)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'it'
,p_message_text=>'Report su Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102386601027306867)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #LABEL#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707311021307155)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore di convalida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707288233307155)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #COLUMN_HEADER#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102740717612307186)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione delle pagine della procedura guidata completata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103447541040307746)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'Avanzamento procedura guidata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102726008392307173)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>'Creazione della pagina Report procedura guidata riuscita.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102414791651306889)
,p_name=>'WORKSPACE'
,p_message_language=>'it'
,p_message_text=>'area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714647051307162)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine dell''area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777169330307220)
,p_name=>'WORKSPACES'
,p_message_language=>'it'
,p_message_text=>'Aree di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686069922307135)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'it'
,p_message_text=>'Applicazioni dell''area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102686322451307136)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'it'
,p_message_text=>unistr('Riepilogo attivit\00E0 applicazione area di lavoro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103328860755307653)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio aree di lavoro correnti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685314806307135)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'it'
,p_message_text=>'ID area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997444908307392)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'it'
,p_message_text=>'Immagini dell''area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777659938307221)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102596038120307047)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255021032306763)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102224157952306740)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'it'
,p_message_text=>'Login ad area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102922756685307337)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio di area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685173868307134)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102834044667307268)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'it'
,p_message_text=>'ID sostituzione area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102717511394307165)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'it'
,p_message_text=>'Richiesta di area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685918461307135)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'it'
,p_message_text=>'Schemi area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102274167970306778)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'it'
,p_message_text=>unistr('Si ricever\00E0 un messaggio di posta elettronica per attivare l''area di lavoro quando la richiesta sar\00E0 stata approvata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777316069307220)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'it'
,p_message_text=>'Utenti area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102689840618307139)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'it'
,p_message_text=>'Websheet area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102685635313307135)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Riepilogo area di lavoro %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661604021307113)
,p_name=>'WORK_INITIATED'
,p_message_language=>'it'
,p_message_text=>'Lavoro iniziato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102661771057307113)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'it'
,p_message_text=>'Lavoro in corso'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102669716568307120)
,p_name=>'WRITING'
,p_message_language=>'it'
,p_message_text=>'Scrittura'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103333074155307656)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'it'
,p_message_text=>unistr('Funzionalit\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103332977653307656)
,p_name=>'WS.READER'
,p_message_language=>'it'
,p_message_text=>'Processo di lettura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725444224307172)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'it'
,p_message_text=>unistr('Il riferimento al Web Service \00E8 stato aggiunto all''applicazione %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214577894306733)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'it'
,p_message_text=>'Controllo dell''accesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958575571307363)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'it'
,p_message_text=>'Aggiungi file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396715297307703)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Spazio insufficiente per aggiungere il file. Richiedere altro spazio passando alle pagine di amministrazione, passando alla gestione del servizio, quindi facendo clic sul collegamento della richiesta di spazio aggiuntivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981909450307381)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'it'
,p_message_text=>'Aggiungi collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016856309307407)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'it'
,p_message_text=>'Aggiungi nuovo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102982080104307381)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'it'
,p_message_text=>'Aggiungi nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981459905307380)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'it'
,p_message_text=>'Aggiungi riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981891050307380)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'it'
,p_message_text=>'Aggiungi tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026085752307414)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Aggiungi convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214386659306733)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'it'
,p_message_text=>'Amministrazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958171105307363)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare l''alias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102206832716306727)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'it'
,p_message_text=>'L''alias deve essere alfanumerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102218081703306735)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('Alias troppo lungo. Il limite \00E8 di 255 caratteri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023057475307412)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'it'
,p_message_text=>'Tutte le righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016918874307407)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'it'
,p_message_text=>'Annotazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214425182306733)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'it'
,p_message_text=>unistr('Propriet\00E0 applicazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031541459307418)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di visualizzazione selezionato non pu\00F2 utilizzare la lista di valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033910365307420)
,p_name=>'WS_CHANGED'
,p_message_language=>'it'
,p_message_text=>'Modificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018332841307408)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'it'
,p_message_text=>'Modifica tipo di colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034173282307420)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di modificare la query del report. Le eventuali colonne aggiunte alla query non verranno visualizzate durante l''esecuzione del report. Sar\00E0 necessario utilizzare il menu Azioni, quindi selezionare le colonne oppure fare clic su <str')
||'ong>Reimposta</strong>. Se sono state rimosse colonne dalla query, i filtri esistenti, le regole di evidenziazione e le altre impostazioni di report che fanno riferimento alle colonne rimosse verranno disabilitati. Confermare la richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211944228306731)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'it'
,p_message_text=>'Scegli file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018805599307409)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'it'
,p_message_text=>'Allineamento colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981723832307380)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'it'
,p_message_text=>'Gruppi di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393331170307701)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna esiste gi\00E0. Immettere un altro nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981697681307380)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'it'
,p_message_text=>unistr('Propriet\00E0 colonna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019881747307409)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'it'
,p_message_text=>'Confermare per eseguire questa azione di eliminazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031327512307418)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare l''etichetta della colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032633523307419)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'it'
,p_message_text=>'Selezionare una colonna per modificare il valore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032874008307419)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'it'
,p_message_text=>'Selezionare una colonna per sostituire il valore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031914748307418)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare il nome della colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031278414307418)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'it'
,p_message_text=>'Selezionare una colonna per modificarla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032061887307418)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'it'
,p_message_text=>unistr('Selezionare una o pi\00F9 colonne per rimuoverle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017850450307408)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'it'
,p_message_text=>'lista separata da virgole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019508488307409)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'it'
,p_message_text=>'Immettere una lista separata da virgole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030987851307417)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'it'
,p_message_text=>'Confermare l''eliminazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103406728424307714)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'it'
,p_message_text=>'Pannello di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329856048307654)
,p_name=>'WS_COPY'
,p_message_language=>'it'
,p_message_text=>'Copia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944477654307353)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'it'
,p_message_text=>'Nuova pagina come copia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967574833307370)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di creare un Websheet con i seguenti attributi. Confermare le selezioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943828081307352)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'it'
,p_message_text=>'Crea sezione grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722802965307170)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'it'
,p_message_text=>'Crea griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943964071307352)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'it'
,p_message_text=>'Crea sezione dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018021546307408)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'it'
,p_message_text=>'Data corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944181491307353)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'it'
,p_message_text=>'Crea sezione di navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944356706307353)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'it'
,p_message_text=>'Crea pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102248079990306758)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'it'
,p_message_text=>'Crea sezione PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102943765809307352)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'it'
,p_message_text=>'Crea sezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944078649307352)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'it'
,p_message_text=>'Crea sezione di testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018124407307408)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'it'
,p_message_text=>'Utente corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214132831306732)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'it'
,p_message_text=>'Dashboard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191415971306715)
,p_name=>'WS_DATA'
,p_message_language=>'it'
,p_message_text=>'Dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102703950918307152)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato raggiunto il numero massimo di colonne disponibili per il tipo di colonna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103393515810307701)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'it'
,p_message_text=>'Sono stati rilevati nomi di colonna duplicati. Il nome colonna deve essere univoco.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103358904954307675)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome della griglia dati esiste gi\00E0. Immettere un altro nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018287308307408)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017957131307408)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420491632307725)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Definisci colonne griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019620310307409)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Elimina colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102953540824307360)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'it'
,p_message_text=>'Elimina griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024037659307412)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'it'
,p_message_text=>'Elimina righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019738286307409)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'it'
,p_message_text=>'Selezionare la colonna o le colonne da rimuovere definitivamente, insieme ai dati:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237001078306750)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'it'
,p_message_text=>'La prima colonna deve essere la chiave primaria della griglia dati per poter visualizzare, modificare o aggiungere un collegamento di riga. Aggiungere la sostituzione "APXWS_DATA_GRID_PK" come prima colonna nell''istruzione SELECT in modo da includere'
||' la chiave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102230336958306745)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'it'
,p_message_text=>'La query deve fare riferimento alla griglia dati solo una volta per poter visualizzare, modificare o aggiungere un collegamento di riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237127993306750)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'it'
,p_message_text=>unistr('La query contiene pi\00F9 istruzioni SELECT. Aggiungere la sostituzione "APXWS_DATA_GRID_PK" come prima colonna nell''istruzione SELECT per visualizzare, modificare o aggiungere un collegamento di riga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103035629594307421)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'it'
,p_message_text=>'Sintassi tag SQLVALUE:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102782750487307225)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'it'
,p_message_text=>'Sintassi tag SQL:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017477313307408)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'it'
,p_message_text=>'Visualizza come'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017359333307408)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'it'
,p_message_text=>'Documento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958016746307363)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Impossibile scegliere la stessa colonna per la chiave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016649860307407)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'it'
,p_message_text=>'Modifica allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329989492307654)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'it'
,p_message_text=>'Modifica attributi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213293148306732)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'it'
,p_message_text=>'Modifica file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212878669306731)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'it'
,p_message_text=>'Modifica nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102944253990307353)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Modifica pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103330031887307654)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'it'
,p_message_text=>'Modifica query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951406774307358)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'it'
,p_message_text=>'Modifica sezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103014864826307406)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'it'
,p_message_text=>'Modifica sezioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213300372306732)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'it'
,p_message_text=>'Modifica tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277140285306780)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'it'
,p_message_text=>'Modifica tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253371827306762)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020217047307410)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'it'
,p_message_text=>'Righe vuote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102952004473307358)
,p_name=>'WS_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029648540307417)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Messaggio di errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033358762307419)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Messaggio di errore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983856590307382)
,p_name=>'WS_FILE'
,p_message_language=>'it'
,p_message_text=>'File'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959644386307364)
,p_name=>'WS_FILES'
,p_message_language=>'it'
,p_message_text=>'File'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103442108012307742)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Il file deve contenere un valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023687002307412)
,p_name=>'WS_FILL'
,p_message_language=>'it'
,p_message_text=>'Riempimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023713425307412)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'it'
,p_message_text=>'Riempire i valori di colonna nulli con il valore di colonna nella cella in alto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023433294307412)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'it'
,p_message_text=>'Trova'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938518018307348)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Le applicazioni Websheet consentono agli utenti finali di gestire dati strutturati e non strutturati senza l''assistenza di uno sviluppatore. I Websheet consentono agli utenti di eseguire le operazioni riportate di seguito.',
'<ul>',
'<li>Creare e condividere contenuto sul Web usando un browser Web.</li>',
'<li>Organizzare in gerarchia e collegare tra loro le pagine Web.</li>',
'<li>Creare e gestire dati in formato tabulare usando la funzione incorporata Griglie dati.</li>',
'<li>Creare report interattivi usando il linguaggio SQL su strutture dati esistenti del database.</li>',
'<li>Esporre i dati delle griglie dati e dei report all''interno delle pagine sotto forma di grafici o report.</li>',
'<li>Annotare le pagine con file, tag e note. Le immagini associate possono essere mostrate in linea nel contenuto di pagina.</li>',
'<li>Effettuare ricerche nel contenuto della pagina (mediante la funzione di ricerca built-in).</li>',
'<li>Gestire le persone che possono eseguire il login e, a login eseguito, le persone in grado di leggere, scrivere o amministrare l''applicazione (autenticazione e autorizzazione).</li>',
'</ul>',
'<p>Per ulteriori informazioni, fare clic su ?.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018487560307408)
,p_name=>'WS_GROUP'
,p_message_language=>'it'
,p_message_text=>'Gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024413780307413)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032349331307419)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare il nome del gruppo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018722775307409)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'it'
,p_message_text=>'Allineamento intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019140763307409)
,p_name=>'WS_HEIGHT'
,p_message_language=>'it'
,p_message_text=>'Altezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032543514307419)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'it'
,p_message_text=>'Colonna non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031101340307418)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome colonna non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989303244307386)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome o alias griglia dati non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959825545307364)
,p_name=>'WS_LINKS'
,p_message_language=>'it'
,p_message_text=>'Collegamenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025124849307413)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome collegamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958338450307363)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'it'
,p_message_text=>'Collegamento a questa pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023914054307412)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'it'
,p_message_text=>'ordine di caricamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031730501307418)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome della lista di valori esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017729738307408)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'it'
,p_message_text=>'Definizione lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031833777307418)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare la definizione della lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019321946307409)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'it'
,p_message_text=>'Utilizzare la lista di valori per limitare i valori di colonna che possono essere immessi da un utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019491457307409)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile associare la lista di valori definita a una colonna in Modifica propriet\00E0 colonna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031404934307418)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'it'
,p_message_text=>'Definire la lista di valori per il tipo di visualizzazione selezionato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031675324307418)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare il nome della lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017691017307408)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959472932307364)
,p_name=>'WS_MAP'
,p_message_language=>'it'
,p_message_text=>'Mappa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019088715307409)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'it'
,p_message_text=>'Larghezza massima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102791076533307233)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'it'
,p_message_text=>unistr('La larghezza massima non pu\00F2 essere maggiore di 4000.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016709748307407)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'it'
,p_message_text=>'riduci a icona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981591417307380)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Sposta colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344152023307664)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'it'
,p_message_text=>'%0 non corrisponde al formato di data %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032459354307419)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare il nome della nuova griglia dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102957957013307363)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare il nome.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020062909307410)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'it'
,p_message_text=>'Nuovo valore colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213911360306732)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'it'
,p_message_text=>'Nuova griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024268313307413)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'it'
,p_message_text=>'Nuovo nome griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024332248307413)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'it'
,p_message_text=>'Nuovo gruppo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017523719307408)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'it'
,p_message_text=>'Nuova lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019249162307409)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'it'
,p_message_text=>'Nuova lista di valori basata su valori correnti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213718529306732)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'it'
,p_message_text=>'Nuova pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214069452306732)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'it'
,p_message_text=>'Nuovo report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213677003306732)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'it'
,p_message_text=>'Nuova sezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026283882307414)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'it'
,p_message_text=>'Nuova convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033782259307420)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'it'
,p_message_text=>'Nuovo valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919254661307334)
,p_name=>'WS_NOTE'
,p_message_language=>'it'
,p_message_text=>'Nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959721296307364)
,p_name=>'WS_NOTES'
,p_message_language=>'it'
,p_message_text=>'Note'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919325151307334)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Nota. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213512603306732)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna colonna trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213152720306732)
,p_name=>'WS_NO_FILES'
,p_message_language=>'it'
,p_message_text=>'Nessun file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212064012306731)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'it'
,p_message_text=>'Nessun file scelto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212901752306731)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'it'
,p_message_text=>'Nessuna nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213470471306732)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'it'
,p_message_text=>'Nessuna tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017291392307407)
,p_name=>'WS_NUMBER'
,p_message_language=>'it'
,p_message_text=>'Numero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033658781307420)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'it'
,p_message_text=>'Vecchio valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023822306307412)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'it'
,p_message_text=>'Ordina per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984058838307382)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'it'
,p_message_text=>'Alias di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253184628306762)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Pagina creata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102984100853307382)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213812057306732)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'it'
,p_message_text=>'Directory pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214205700306732)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'it'
,p_message_text=>'Cronologia pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382271055307692)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'it'
,p_message_text=>'Lista gerarchica pagine con pagine figlio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329543722307654)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'it'
,p_message_text=>unistr('Propriet\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103030842249307417)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'it'
,p_message_text=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997727515307392)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'it'
,p_message_text=>'Le query sugli oggetti di applicazione interni non sono consentite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018638164307409)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'it'
,p_message_text=>'Sola lettura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033413704307420)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'it'
,p_message_text=>'Le modifiche recenti sono elencate di seguito:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329778359307654)
,p_name=>'WS_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Sostituisci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023560168307412)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'it'
,p_message_text=>'Sostituisci con'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033504183307420)
,p_name=>'WS_ROW'
,p_message_language=>'it'
,p_message_text=>'Riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024177492307413)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'it'
,p_message_text=>'Righe con colonne vuote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341771530307663)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'it'
,p_message_text=>'Riga %0 creata il %1 da %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341636167307663)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'it'
,p_message_text=>'Chiave riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103341827713307663)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'it'
,p_message_text=>'Ultimo aggiornamento contenuto %0 da parte di %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032762122307419)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'it'
,p_message_text=>'Selezionare una riga per impostare il valore della colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959549199307364)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'it'
,p_message_text=>'Ordine righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103031058603307418)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'it'
,p_message_text=>'Selezionare una riga per eliminarla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967699321307370)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('Verr\00E0 creata una home page campione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102981377077307380)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'it'
,p_message_text=>'Salva e aggiungi un altro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383229791307693)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'it'
,p_message_text=>'Report di ricerca %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102983967863307382)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'it'
,p_message_text=>'Contenuto sezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102253030570306762)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'it'
,p_message_text=>'Sezione creata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102967798265307370)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo sezione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103020183242307410)
,p_name=>'WS_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Selezionato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103023256004307412)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe selezionate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018552172307408)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'it'
,p_message_text=>'Seleziona gruppo di colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102940120618307350)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'it'
,p_message_text=>'Selezionare il nome del report per visualizzare le colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032202019307418)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'it'
,p_message_text=>'La sequenza deve essere numerica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032154535307418)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare la sequenza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103019998912307409)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'it'
,p_message_text=>'Imposta valori colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390237656307698)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'it'
,p_message_text=>'<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Norme sulla privacy Oracle</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382730147307693)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'it'
,p_message_text=>unistr('Facendo clic sul pulsante "Avanti", riconosci e accetti che l''utilizzo del sito Web di Oracle \00E8 soggetto alle <a href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Condizioni d''uso di Oracle.com</a>. Dettagli aggiuntivi relativi al')
||'la raccolta e all''uso dei dati personali da parte di Oracle, tra cui dati su accesso, conservazione, rettifica, cancellazione, sicurezza, trasferimenti al di fuori dei confini nazionali e altri argomenti sono disponibili nell''<a href="https://www.ora'
||'cle.com/legal/privacy/index.html" target="_new">Informativa sulla privacy di Oracle.</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017150910307407)
,p_name=>'WS_STRING'
,p_message_language=>'it'
,p_message_text=>'Stringa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103032907362307419)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare la stringa da trovare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959990585307364)
,p_name=>'WS_TAGS'
,p_message_language=>'it'
,p_message_text=>'Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329632313307654)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'it'
,p_message_text=>'Attiva/disattiva caselle di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026322095307414)
,p_name=>'WS_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103024571718307413)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne non assegnate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103017099205307407)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'it'
,p_message_text=>'Identificativo univoco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103025302909307413)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'it'
,p_message_text=>'Destinazione URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033018129307419)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Destinazione URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033818431307420)
,p_name=>'WS_USER'
,p_message_language=>'it'
,p_message_text=>'Utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103388524736307697)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>'Nome utente troppo lungo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103344031243307664)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'it'
,p_message_text=>'%0 deve essere numerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102919106115307334)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'(Valore obbligatorio)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029443707307416)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'Espressione di convalida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033196421307419)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Nome convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027288783307415)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata NON \00E8 uguale al valore di stringa nell''espressione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103033233697307419)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Sequenza di convalide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026813833307414)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'it'
,p_message_text=>'La colonna specificata contiene almeno un carattere nell''espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028561720307416)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata \00E8 alfanumerica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027920589307415)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata \00E8 contenuta nell''espressione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028072461307415)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata NON \00E8 uguale a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027764995307415)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata NON \00E8 contenuta nell''espressione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028414259307416)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata \00E8 NOT NULL o uguale a zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028168227307415)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'it'
,p_message_text=>'La colonna specificata non contiene spazi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103028670666307416)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata \00E8 numerica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103029042351307416)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata \00E8 una data valida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027554775307415)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata \00E8 uguale al valore di stringa nell''espressione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027494777307415)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'it'
,p_message_text=>'La colonna specificata non contiene nessun carattere nell''espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103026722174307414)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna specificata \00E8 NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103027082403307415)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'it'
,p_message_text=>'La colonna specificata contiene solo caratteri nell''espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103034007465307420)
,p_name=>'WS_VIEW'
,p_message_language=>'it'
,p_message_text=>'Visualizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103382100684307692)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'it'
,p_message_text=>'Visualizza griglia dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016373048307407)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'it'
,p_message_text=>'Visualizza file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016575522307407)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'it'
,p_message_text=>'Visualizza note'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103016450336307407)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'it'
,p_message_text=>'Visualizza tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958222958307363)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'it'
,p_message_text=>unistr('L''alias esiste gi\00E0. Immettere un altro alias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103329407307307654)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'it'
,p_message_text=>unistr('Propriet\00E0 Websheet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102938618293307349)
,p_name=>'WS_WELCOME'
,p_message_language=>'it'
,p_message_text=>'Benvenuti in Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103018960640307409)
,p_name=>'WS_WIDTH'
,p_message_language=>'it'
,p_message_text=>'Larghezza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958763803307363)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'it'
,p_message_text=>'Senza file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959132250307364)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'it'
,p_message_text=>'Senza collegamenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959328664307364)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'it'
,p_message_text=>'Senza posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958935721307364)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'it'
,p_message_text=>'Senza note'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958601041307363)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'it'
,p_message_text=>'Con file'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959012011307364)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'it'
,p_message_text=>'Con collegamenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102959283645307364)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'it'
,p_message_text=>'Con posizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102958849046307363)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'it'
,p_message_text=>'Con note'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102710441657307158)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'it'
,p_message_text=>'<p>La query deve contenere almeno una colonna relativa alla data o all''indicatore orario. Controllare la query. (%0) </p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445767308306915)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'it'
,p_message_text=>'La chiave deve essere 8, 16 o 24 byte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214901654306733)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'L''applicazione %0 non esiste in questa area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215130361306733)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'it'
,p_message_text=>'Caricamento della tabella %0 non riuscito. Errori registrati nella tabella %1. Questa tabella deve essere eliminata prima della nuova esecuzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214862546306733)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'it'
,p_message_text=>'nessun file generato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102214757251306733)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'it'
,p_message_text=>'righe esportate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215234449306733)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('La tabella degli errori %0 esiste gi\00E0. Questa tabella deve essere eliminata prima della nuova esecuzione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102215089089306733)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tutte le colonne incluse sono di tipi di dati non supportati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192162606306716)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'it'
,p_message_text=>'Lo schema %0 richiede i privilegi READ e WRITE sulla directory DATA_PUMP_DIR.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102196486748306719)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'it'
,p_message_text=>unistr('Il file dell''area di memorizzazione degli oggetti scelto \00E8 troppo grande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183588071306709)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore interno durante l''elaborazione della richiesta DBMS_CLOUD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102183663751306709)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di credenziale non valido per un riferimento all''area di memorizzazione degli oggetti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192093027306716)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'it'
,p_message_text=>'Lo schema %0 richiede privilegi di accesso per la directory DATA_PUMP_DIR.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195001087306718)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'it'
,p_message_text=>unistr('Il package DBMS_CLOUD non \00E8 disponibile in questo sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191977069306715)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'it'
,p_message_text=>'Lo schema %0 richiede il privilegio EXECUTE sul package DBMS_CLOUD.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427417714306900)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'it'
,p_message_text=>'errore di analisi: corpo funzione non deve essere nullo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427538792306900)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'it'
,p_message_text=>'errore di analisi: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420064689306894)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'it'
,p_message_text=>'applicazione=%0 area di lavoro corrente=%1 area di lavoro richiesta=%2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102419524100306893)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1014 Applicazione non trovata. Area di lavoro non valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421651339306895)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'it'
,p_message_text=>'applicazione=%0 pagina=%1 richiesta=%2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415643027306890)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1082 Errore durante l''esecuzione del codice dello schema di autorizzazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416413698306891)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('ERR-1007 Il punto di diramazione non pu\00F2 essere nullo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416543219306891)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1008 Errore durante l''esecuzione della diramazione alla pagina %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102176953622306704)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('ERR-7746 Impossibile elaborare la diramazione da una pagina finestra di dialogo a una pagina con modalit\00E0 diversa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424847855306898)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il recupero dell''ID del modello di pulsante=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415276959306890)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'it'
,p_message_text=>'<p>Fare clic <a href="%0">qui</a> per eseguire il login</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415968367306890)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1030 Errore durante l''esecuzione dell''espressione di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416077433306890)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1004 Impossibile calcolare la funzione. computation_point=%0 computation_type=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415853706306890)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1003 Errore durante l''esecuzione della query di calcolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415773165306890)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1001 Errore imprevisto durante la creazione dell''elemento: FSP_PROCESS_STATE_%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415425022306890)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1001 Errore imprevisto nella sessione make_deeplinking_item=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417091070306891)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'it'
,p_message_text=>'Era previsto il cookie p_company o wwv_flow_company per contenere l''ID gruppo di sicurezza del proprietario dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421394987306895)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-7621 Impossibile determinare l''area di lavoro per l''applicazione (%0) durante l''accettazione dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421426089306895)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'it'
,p_message_text=>'Era previsto il cookie p_company o wwv_flow_company per contenere l''ID gruppo di sicurezza del proprietario dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416855363306891)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1011 Tipo di valutazione non valido: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424735164306898)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore dell''applicazione in fetch_value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415570064306890)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1902 ID elemento non nullo nella routine find_item_name.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416319480306890)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1021 Impossibile eseguire la convalida di tipo "corpo funzione che restituisce un risultato booleano".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416263663306890)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1024 Impossibile eseguire la convalida di tipo "corpo funzione che restituisce un risultato testuale".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416955528306891)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1812 Errore imprevisto durante l''assegnazione di G_FLOW_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421592269306895)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('ERR-9988 Sono state fornite informazioni insufficienti per questa richiesta. \00C8 possibile che il tempo di attesa per il completo caricamento della pagina non sia stato sufficiente. Fare clic sui pulsanti Indietro e Aggiorna o Ricarica del browser in u')
||'so oppure andare alla home page dell''applicazione per continuare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102417464186306891)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1555 Non collegato al server di login Oracle. Nessun utente pubblico identificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421039338306894)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'it'
,p_message_text=>'Logout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415183659306890)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'it'
,p_message_text=>'Login non eseguito. Il cookie richiesto per l''autenticazione risulta mancante o non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422009214306896)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1777: La pagina %0 non ha fornito alcuna pagina a cui eseguire la diramazione. Notificare l''errore all''amministratore delle applicazioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421145294306894)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('ERR-1013 Nessun privilegio per eseguire l''operazione tentata dall''utente %0. Il ruolo richiesto \00E8 %1. Rivolgersi all''amministratore delle applicazioni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246969202306757)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina pu\00F2 essere richiesta con argomenti se viene passato un checksum alla procedura di visualizzazione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247152252306757)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'it'
,p_message_text=>unistr('Alla pagina \00E8 possibile accedere solo utilizzando una diramazione di tipo "Dirama a pagina" da un''altra pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247062238306757)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'it'
,p_message_text=>unistr('Alla pagina \00E8 possibile accedere solo senza argomenti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102247333812306757)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'it'
,p_message_text=>'Sono stati passati argomenti a una pagina che non li accetta (valori di richiesta, di svuotamento della cache, di elemento).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246829816306757)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina non \00E8 protetta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102420997787306894)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'it'
,p_message_text=>'Ruolo richiesto non abilitato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422189858306896)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'it'
,p_message_text=>'<a href="f?p=%0">Riavvia applicazione</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102415356848306890)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1001 Errore imprevisto durante il salvataggio della routine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416725050306891)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1910 Errore durante la valutazione dell''espressione SQL nel testo dell''intestazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447903102306917)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il reindirizzamento alla home page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102421286325306895)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1512 Impossibile risolvere l''alias di pagina (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425069025306898)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile impostare timed_statistics: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102424975754306898)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il trace: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102418855163306893)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1444 Schema di autenticazione non supportato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102416157152306890)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1006 Errore nella routine di convalida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427641906306900)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'it'
,p_message_text=>unistr('Non pi\00F9 valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455819774306923)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''eliminazione del ruolo sviluppatore. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455738226306923)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile recuperare o trovare le informazioni sull''utente. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655899329307107)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'it'
,p_message_text=>'Avvertenza: l''utente %0 non dispone di privilegi di sviluppatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322998588306814)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'it'
,p_message_text=>'COMPATIBILE (Dovrebbe essere possibile eseguire questa importazione senza problemi).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201116841307557)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'AVVERTENZA per la credenziale "%0" (ID statico):',
'',
'- I file di esportazione di Application Express non contengono informazioni sulle credenziali.',
'- Usare la procedura APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL per impostare',
'- le credenziali dopo l''importazione dell''applicazione. Alla credenziale viene fatto riferimento',
'- con il relativo ID statico "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318407263306811)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'it'
,p_message_text=>'Versione corrente:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790968404307233)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile eliminare l''applicazione %0, poich\00E9 \00E8 installata in un''area di lavoro diversa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322556133306814)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del nome dello schema di autenticazione=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321153051306813)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della diramazione id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322323653306814)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del bug id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319636411306812)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del nome di opzione di creazione=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319749924306812)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''impostazione dell''opzione di creazione id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321050673306813)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del nome pulsante="%0" id="%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676411833307126)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''azione dinamica secondaria name="%0" id="%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676372874307126)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''azione dinamica page="%0" name="%1" id="%2"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102360588918306847)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'it'
,p_message_text=>'La pagina di errore=%0 elemento="%1" ID="%2" ha lo stesso nome dell''elemento esistente a livello di applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320229922306812)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''elemento di calcolo dell''applicazione="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320110122306812)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''elemento dell''applicazione id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277487870306780)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''attributo di plugin id="%0"	'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102690335816307139)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del valore di plugin id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277343424306780)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del plugin id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333792386306826)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''evento di plugin id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319947548306812)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del processo dell''applicazione id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365184773307680)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''opzione modello dell''applicazione id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365068012307680)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del gruppo di opzioni modello dell''applicazione id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322105385306814)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'it'
,p_message_text=>'Form aggiunto alla pagina esistente %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297122939306795)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile importare gli attributi di installazione dell''oggetto di database id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297287352306795)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dello script di installazione id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321890656306813)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di report non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321648250306813)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della mappa di traduzione dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219494678306736)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della colonna della lista di valori id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320663360306812)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della lista di valori id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319856242306812)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''elemento barra di navigazione id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321350714306813)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della pagina di calcolo pagina=%0 elemento=%1 ID="%2"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320745833306812)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del nome pagina="%0" id="%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102730597953307177)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del gruppo di pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322098117306813)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina %0 dispone gi\00E0 di pulsanti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320814822306813)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del testo Guida %0 di pagina:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321201843306813)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'it'
,p_message_text=>'Pagina di errore=%0 elemento="%1" ID="%2"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320945742306813)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''aggiornamento del nome pagina="%0" id="%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321779717306813)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina sulla tabella "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321520165306813)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della pagina di processo pagina=%0 nome=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321453752306813)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della pagina di convalida pagina=%0 nome=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320569130306812)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della scheda padre id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320062382306812)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''impostazione di SQL processo id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102321917827306813)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'it'
,p_message_text=>'La pagina di report %0 esiste, area di report aggiunta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322280338306814)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina %0 non \00E8 stata creata perch\00E9 esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322476136306814)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della scorciatoia id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320346087306812)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione della scheda standard id="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102320493290306812)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'it'
,p_message_text=>'Errore durante la ridenominazione del set di schede %1 in %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319572449306812)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione del nome di modello=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318395644306811)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'it'
,p_message_text=>'Ultima estensione API:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322881752306814)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'it'
,p_message_text=>unistr('Questo file di esportazione non \00E8 compatibile con la versione di Application Express in cui si tenta di importare il file.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319313128306811)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stata richiamata la procedura %0 senza un valore per p_id. Fornire un ID applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178661361306705)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID applicazione "%0" non \00E8 compreso nell''intervallo consentito (%1 - %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790442674307233)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile utilizzare l''ID applicazione "%0". L''intervallo (%1 - %2) \00E8 riservato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322751486306814)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID applicazione %0 \00E8 riservato alla Oracle Corporation ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102178790497306705)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID applicazione "%0" \00E8 stato riservato per un''altra area di lavoro e non pu\00F2 essere usato qui')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319410360306811)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'it'
,p_message_text=>unistr('L''applicazione %0 non \00E8 stata eliminata. Non verr\00E0 eseguito un tentativo di importazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318592626306811)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'it'
,p_message_text=>unistr('Questa importazione \00E8 compatibile con la versione:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748996089307194)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile importare lo script. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319049424306811)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Combinazione di nome utente, password o area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318685012306811)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'it'
,p_message_text=>'L''importazione dell''applicazione non ha fornito una versione di esportazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201010425307557)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'it'
,p_message_text=>'Non sono stati forniti valori per il server remoto con ID statico "%0". Usare APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER prima di installare l''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748817853307194)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'it'
,p_message_text=>'nuovo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102323024572306814)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'it'
,p_message_text=>unistr('NON COMPATIBILE (L''esportazione pu\00F2 contenere chiamate non supportate dalla versione di %0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201446418307557)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'AVVERTENZA per il server remoto "%0" (ID statico).',
'',
'- Gli attributi per questo server remoto sono stati impostati con APEX_APPLICATION_INSTALL.',
'- Tenere presente che anche altre applicazioni utilizzano questo oggetto server remoto.',
'',
'Gli attributi del server remoto nell''area di lavoro sono stati pertanto aggiornati.',
'- URL di base:      %1',
'- Host HTTPS:    %2',
'- Fuso orario ORDS: %3'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201346174307557)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'AVVERTENZA per il server remoto "%0" (ID statico).',
'',
unistr('- L''attributo PROMPT_ON_INSTALL \00E8 impostato su YES.'),
'- Non sono stati forniti attributi con APEX_APPLICATION_INSTALL.',
'',
'Le impostazioni del server remoto nell''area di lavoro rimangono pertanto invariate.',
'- URL di base:      %1',
'- Host HTTPS:    %2',
'- Fuso orario ORDS: %3',
'',
'Per modificare gli attributi, usare APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103201245352307557)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'AVVERTENZA per il server remoto "%0" (ID statico).',
'',
unistr('- L''attributo PROMPT_ON_INSTALL \00E8 impostato su NO.'),
'- Le impostazioni nel file di importazione dell''applicazione sono diverse dagli attributi esistenti.',
'- Questo server remoto vene utilizzato anche da altre applicazioni dell''area di lavoro.',
'',
'Le impostazioni del server remoto nell''area di lavoro rimangono pertanto invariate.',
'- URL di base:      %1',
'- Host HTTPS:    %2',
'- Fuso orario ORDS: %3',
'',
'Per modificare gli attributi, usare APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER.'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102748715987307194)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'it'
,p_message_text=>'sostituisci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986994447307384)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'it'
,p_message_text=>'Impossibile importare il feedback nello stesso sistema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102749098014307194)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'it'
,p_message_text=>'La dimensione dello script di %0 byte supera il limite massimo consentito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102322618220306814)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'it'
,p_message_text=>'La variabile package g_security_group_id deve essere impostata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102319293942306811)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'it'
,p_message_text=>'La variabile package g_security_group_id deve essere impostata per importare un''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318867740306811)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'it'
,p_message_text=>'Impossibile stabilire l''ultima versione dell''API del motore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318775937306811)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'it'
,p_message_text=>'Impossibile stabilire la versione del motore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102318962748306811)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'it'
,p_message_text=>unistr('Sar\00E0 necessario eseguire l''aggiornamento per importare questa esportazione dell''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102986825449307384)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'it'
,p_message_text=>'Feedback non esportato per questo sistema di distribuzione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191264444306715)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'it'
,p_message_text=>'Le automazioni che fanno riferimento alle origini dati REST non possono essere copiate da un''altra applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102189613564306714)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'it'
,p_message_text=>'Nuova azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367778506306852)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Corpo funzione PL/SQL che restituisce una query SQL obbligatorio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367609378306852)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 richiesta una query SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367836183306852)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Servizio SQL abilitato per REST obbligatorio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367571781306852)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Nome tabella obbligatorio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102367973804306852)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Origine dati REST obbligatoria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368025599306853)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Clausola where o ORDER BY obbligatoria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423121649306897)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Applicazione:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439460760306910)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Nessuna applicazione selezionata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423492978306897)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'it'
,p_message_text=>'<span class="tiny">Nessuna pagina trovata.</font>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423238675306897)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423517783306897)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'it'
,p_message_text=>'%0 <font size=-2>pagine</span>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609735364307060)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'it'
,p_message_text=>'numero pagine:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102609801278307060)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'it'
,p_message_text=>'elenco pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423323445306897)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'it'
,p_message_text=>'PL/SQL %0 %1 contiene %2 righe di codice sorgente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858440188307286)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>'Completamento codice non supportato per SQL remoto.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102857736158307286)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('Query Builder non \00E8 supportato per SQL remoto.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455977194306923)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore di analisi del report aggiornabile: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103390878242307699)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il reindirizzamento da una pagina finestra di dialogo a una pagina normale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427879270306900)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'it'
,p_message_text=>'obsoleto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427718034306900)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'it'
,p_message_text=>'Svuotate %0 sessioni duplicate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396196480306874)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile modificare solo la propria password.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396333139306875)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore imprevisto durante l''elaborazione della richiesta di modifica della password: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395801176306874)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'it'
,p_message_text=>'Fornire la password e la password di conferma.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102395938218306874)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'it'
,p_message_text=>'Password non corrispondenti. Riprovare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396963572306875)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'it'
,p_message_text=>'Errore Oracle: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102396662507306875)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'it'
,p_message_text=>'ERR-1025 Errore durante l''elaborazione dell''espressione PL/SQL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287539708306787)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('Il numero di attributi del membro specificato %0 non \00E8 valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428265474306901)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'it'
,p_message_text=>'Condizione Esiste/Non esiste non valida: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428050119306901)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'it'
,p_message_text=>'Condizione del corpo funzione non valida: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427977020306900)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'it'
,p_message_text=>'Condizione dell''espressione PL/SQL non valida: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428114829306901)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'it'
,p_message_text=>'Condizione dell''espressione SQL non valida: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442387042306912)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''esecuzione di wwv_flow_copy: %0 >> %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177348486306704)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID dell''applicazione tradotta non \00E8 valido. L''ID dell''applicazione \00E8 utilizzato da un''applicazione esistente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442255110306912)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('ID gruppo di sicurezza (identit\00E0 dell''area di lavoro) non impostato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729913822307176)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'it'
,p_message_text=>unistr('La modalit\00E0 di compatibilit\00E0 "%0" dell''applicazione deve essere almeno 21.2 per l''aggiornamento di un tema. \00C8 possibile modificare la modalit\00E0 di compatibilit\00E0 da Definizione applicazione in Propriet\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103426667020307730)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'it'
,p_message_text=>unistr('Il tema corrente non \00E8 compatibile con il tema principale selezionato: gli identificativi dei temi non corrispondono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102855342880307284)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il modello. Modello padre non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295510091306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile pubblicare lo schema di autenticazione. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294964786306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile pubblicare il modello di pulsante. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449145010306918)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile pubblicare il modello di indicatore di percorso. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294799992306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile pubblicare il modello di campo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295626860306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile pubblicare la Guida dell''elemento. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294575125306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile pubblicare il modello di lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295483486306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile pubblicare la lista di valori. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295053653306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile pubblicare il modello di indicatore di percorso. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295384533306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'it'
,p_message_text=>'Impossibile pubblicare la barra di navigazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294397175306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile pubblicare il modello di pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294863590306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile pubblicare il modello di lista di valori popup. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294482354306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile pubblicare il modello di area. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294659789306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile pubblicare il modello di report. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295149836306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Impossibile pubblicare lo schema di sicurezza. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295218637306793)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile pubblicare la scorciatoia. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292708083306791)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento schema di autenticazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291666513306791)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento modello di pulsante. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102449052506306918)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile eseguire la sottoscrizione al modello di indicatore di percorso. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290931016306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento campo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292836316306791)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento Guida dell''elemento. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290799364306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291311142306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento lista di valori. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291512302306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento modello di indicatore di percorso. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291299533306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento barra di navigazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290585707306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291488204306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento modello di lista di valori popup. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290699788306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento area. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290802004306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento report. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291028203306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento schema di sicurezza. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102291119694306790)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere l''ID di riferimento scorciatoia. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294121934306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione allo schema di autenticazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293691788306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione al modello di pulsante. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103386401031307696)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile eseguire la sottoscrizione al modello di indicatore di percorso. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293327955306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione al modello di campo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294222336306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione alla Guida dell''elemento. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293104195306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione al modello di lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102294074952306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione alla lista di valori. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293502547306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione al modello di indicatore di percorso. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293936559306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione alla barra di navigazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102292931804306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione al modello di pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293406782306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione al modello di lista di valori popup. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293097235306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione al modello di area. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293236931306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione al modello di report. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293739163306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione allo schema di sicurezza. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102293865356306792)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione alla scorciatoia. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103365587928307680)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la sottoscrizione alle opzioni tema. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456480359306924)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''esecuzione di wwv_flow_copy_page: %0 >> %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442570158306912)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''esecuzione di wwv_flow_copy_page_item: %0 >> %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315508592306809)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare %0 (%1) da copiare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642848996307096)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('una scorciatoia denominata %0 esiste gi\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442918442306913)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare la scorciatoia (%0) da copiare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443928045306913)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione dei modelli di report): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444547209306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (calcolo delle destinazioni della scheda): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447864754306917)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia degli schemi di autenticazione): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102447768819306917)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia degli schemi di autorizzazione): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445349766306915)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia dei modelli di pulsante): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444864650306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia dei modelli di campo): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445178672306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia dei modelli di lista): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445549857306915)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia della lista di valori): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445289417306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia dei modelli di indicatore di percorso): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445467490306915)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia della barra di navigazione): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444758610306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia del modello di pagina): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445096799306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia dei modelli di area): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444997720306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia dei modelli di report): %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445677387306915)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (copia dello schema di sicurezza): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443849046306913)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione del modello di campo): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444166035306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione dei modelli di lista): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444203467306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione dei modelli di indicatore di percorso): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443652596306913)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione della pagina): %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444670105306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione delle schede padre): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443763487306913)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione del modello di pagina): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444311700306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione del modello di lista di valori popup): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444001511306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione dei modelli di area): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102444435841306914)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dell''applicazione (creazione delle schede standard): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102443559455306913)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'it'
,p_message_text=>'Verifica %0 errore: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642682021307096)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'it'
,p_message_text=>'Aggiungi righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642557332307095)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'it'
,p_message_text=>'Applica MRD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102642462470307095)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'it'
,p_message_text=>'Applica MRU'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629732212307086)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'it'
,p_message_text=>'Crea %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707450048307155)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina del form. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102733906583307180)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina globale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103218307090307570)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina della griglia interattiva. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707638491307156)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'it'
,p_message_text=>'Errore di creazione delle pagine. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707527071307156)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina del form tabulare. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707789875307156)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'it'
,p_message_text=>'Recupera riga da %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751102011307196)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'it'
,p_message_text=>'Recupera cookie nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102847103574307278)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'it'
,p_message_text=>'Menu di navigazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707013369307155)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'it'
,p_message_text=>'Pagina di menu %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102707850996307156)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'it'
,p_message_text=>'Elabora riga di %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102796120586307238)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'it'
,p_message_text=>'release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635353422307090)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'it'
,p_message_text=>'Reimposta elementi nascosti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102628836743307085)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Reimposta ricerca report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102723645123307170)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'it'
,p_message_text=>'Riga per pagina del report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719703925307167)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'it'
,p_message_text=>'Esecuzione dello script: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751012404307196)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'it'
,p_message_text=>'Imposta cookie nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636545012307091)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Questa procedura deve essere richiamata da una sessione dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102198237688306720)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'it'
,p_message_text=>unistr('La credenziale non pu\00F2 essere utilizzata per questo endpoint URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191726757306715)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'it'
,p_message_text=>'Gli URL nella lista devono iniziare con http:// o https://'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102737095263307183)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'it'
,p_message_text=>'Credenziali per %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445890556306915)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere il CSS: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751791713307197)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'it'
,p_message_text=>'Trascinamento della selezione non supportato per le origini dati REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427354776306900)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'it'
,p_message_text=>'Applica modifiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308879218306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'it'
,p_message_text=>unistr('La funzione di sentry di pagina restituir\00E0 il risultato booleano del controllo per la verifica delle sessioni incorporato al motore. Se il risultato \00E8 true, il motore continuer\00E0 a visualizzare o accettare la pagina. Se il risultato \00E8 false, il motore')
||unistr(' eseguir\00E0 il reindirizzamento alla pagina o all''URL di sessione non valida specificato in questo schema di autenticazione (vedere di seguito).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310162782306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'it'
,p_message_text=>unistr('Se la funzione di sentry di pagina restituisce TRUE, il rendering o l''elaborazione della pagina continua. Se il risultato \00E8 FALSE, il motore deve uscire perch\00E9 non \00E8 specificata nessuna destinazione di sessione non valida nello schema di autenticazio')
||'ne. In questo caso, si presume che la funzione di sentry di pagina fornita dall''utente abbia eseguito il reindirizzamento a una pagina di login al di fuori dell''ambiente %0, possibilmente a un portale di autenticazione esterno. La funzione dovrebbe a'
||'vere anche impostato la variabile globale g_unrecoverable_error := true per inviare al motore l''istruzione di uscire senza visualizzare una pagina di errore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310203128306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'it'
,p_message_text=>unistr('Il motore eseguir\00E0 il codice seguente specificato come processo di pre-autenticazione di questo schema di autenticazione:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310309175306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'it'
,p_message_text=>'Questo viene eseguito come blocco anonimo che non restituisce nessun valore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310489651306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 specificato nessun codice di pre-autenticazione in questo schema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310601592306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'it'
,p_message_text=>unistr('Qualsiasi combinazione di nome utente e password immessa nel form di login sar\00E0 considerata valida. Il nome utente immesso verr\00E0 utilizzato come nome dell''utente collegato per la durata della sessione. Questa tecnica pu\00F2 essere utile durante lo svilu')
||'ppo dell''applicazione ma prima che vengano stabiliti gli account utente effettivi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310711631306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'it'
,p_message_text=>unistr('Controllare il nome utente e la password immessi nel form di login con gli account (utente cookie) dell''App Builder. Questi sono gli stessi account utilizzati nell''area di lavoro per eseguire il login a %0. Questa tecnica pu\00F2 essere utile quando gli ')
||'utenti dell''applicazione sono sviluppatori con %0 account nello stesso database e nella stessa area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243082667306754)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'it'
,p_message_text=>unistr('Controllare il nome utente e la password immessi nel form di login rispetto agli account di database Oracle. Questa tecnica pu\00F2 essere utile quando gli utenti dell''applicazione dispongono di account nel database.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310840405306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'it'
,p_message_text=>'Controllare il nome utente e la password immessi nel form di login utilizzando la directory LDAP specificata in questo schema di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310992240306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'it'
,p_message_text=>'I parametri LDAP sono impostati su:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311629992306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'it'
,p_message_text=>'Eseguire il codice personalizzato seguente per verificare le credenziali:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311861321306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'it'
,p_message_text=>unistr('Controllare la tabella di sessioni incorporate per la sessione utilizzata dalla pagina di login incorporata. Se la sessione esiste e non \00E8 di propriet\00E0 di un altro utente, contrassegnarla come di propriet\00E0 dell''utente autenticato (utilizzando il nome')
||' utente del form di login).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308940943306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'it'
,p_message_text=>unistr('La funzione di sentry di pagina restituir\00E0 il risultato booleano del controllo per la verifica delle sessioni incorporato accoppiato con il risultato del controllo per la verifica fornito dall''utente al motore. Se il risultato \00E8 true, il motore conti')
||unistr('nuer\00E0 a mostrare o accettare la pagina. Se il risultato \00E8 false, il motore eseguir\00E0 il reindirizzamento alla destinazione di sessione non valida specificata in questo schema di autenticazione (vedere di seguito).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311985008306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'it'
,p_message_text=>'Impostare il cookie denominato %0 su un valore che individui la riga nella tabella di sessioni interne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312035722306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'it'
,p_message_text=>unistr('Determinare l''URL per il reindirizzamento successivo. Se \00E8 stato registrato un "deep link" nello stato di sessione dal motore dipresentazione, utilizzare tale link come URL a cui passare, altrimenti passare all''URL specificato come attributo di colle')
||'gamento alla home dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312287462306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'it'
,p_message_text=>unistr('Dopo la verifica delle credenziali, il motore eseguir\00E0 il seguente codice specificato come processo di post-autenticazione di questo schema di autenticazione:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312307495306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'it'
,p_message_text=>'Questo viene eseguito come blocco anonimo che non restituisce nessun valore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312425606306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'it'
,p_message_text=>'Nessun codice di post-autenticazione specificato in questo schema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312557330306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'it'
,p_message_text=>'Eseguire il reindirizzamento all''URL determinato sopra. Questo segna la fine dell''elaborazione login utilizzando la pagina di login incorporata e le API chiamate dalla pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309032997306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'it'
,p_message_text=>unistr('Utilizzare la logica personalizzata per eseguire i task di sentry di pagina. Per ciascuna richiesta di pagina, il motore eseguir\00E0 il codice seguente:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309123571306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'it'
,p_message_text=>unistr('Il risultato booleano del blocco precedente verr\00E0 restituito al motore. Se il risultato \00E8 true, il motore continuer\00E0 a mostrare o accettare la pagina. Se il risultato \00E8 false, il motore eseguir\00E0 il reindirizzamento alla destinazione di sessione non v')
||'alida specificata in questo schema di autenticazione (vedere di seguito).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309231395306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'it'
,p_message_text=>unistr('Il metodo incorporato per la verifica delle sessioni \00E8 disponibile per lo sviluppatore %0 che utilizza la chiamata API:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309302215306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'it'
,p_message_text=>unistr('Questo risultato di funzione booleano pu\00F2 essere combinato ad altri controlli nella funzione di sentry di pagina fornita dall''utente, specificata in uno schema di autenticazione. Se si richiama questa API, verr\00E0 controllato il cookie denominato %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309450290306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'it'
,p_message_text=>'Se il cookie esiste e il suo valore decodificato individua una riga nella tabella di sessioni interne, la sessione viene considerata valida e viene restituito un valore TRUE alla funzione di sentry di pagina che l''ha richiamata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309632094306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'it'
,p_message_text=>unistr('Se la funzione di sentry di pagina restituisce TRUE, il rendering o l''elaborazione della pagina continua. Se il risultato \00E8 FALSE, il motore mostrer\00E0 la pagina %0, considerata la pagina di login di questa applicazione in base alla sua designazione ne')
||'llo schema di autenticazione come pagina di sessione non valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310055845306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'it'
,p_message_text=>unistr('La funzione di sentry di pagina restituisce un risultato booleano al motore. Se il risultato \00E8 TRUE, il rendering o l''elaborazione della pagina continua. Se il risultato \00E8 FALSE, il motore eseguir\00E0 il reindirizzamento a %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312679786306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'it'
,p_message_text=>'Un approccio tipico fa in modo che la pagina contenga un form di login per acquisire le credenziali dell''utente. Quindi i processi successivi alla sottomissione della pagina richiamano un modulo di autenticazione per verificare le credenziali. Dopo l'
||'''autenticazione, la pagina esegue qualsiasi task di registrazione delle sessioni e di impostazione dei cookie e infine esegue il reindirizzamento alla pagina iniziale dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312789181306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'it'
,p_message_text=>unistr('La procedura %0 API: wwv_flow_custom_auth_std pu\00F2 essere richiamata da tali processi successivi alla sottomissione per eseguire qualsiasi passo appena descritto. Sono disponibili due punti di accesso:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312880545306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'it'
,p_message_text=>unistr('Richiamare la procedura di login per fare in modo che il motore esegua automaticamente tutti i passi. Il motore utilizzer\00E0 la tabella di sessioni incorporate ed eseguir\00E0 la registrazione delle sessioni e l''impostazione dei cookie. Il codice personali')
||unistr('zzato fornito dall''utente in questo schema di autenticazione verr\00E0 eseguito nei punti di pre-autenticazione, autenticazione o post-autenticazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312986782306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'it'
,p_message_text=>unistr('Richiamare la procedura post_login se si esegue l''autenticazione di persona ma si desidera che %0 gestisca tutte le attivit\00E0 di post-autenticazione. Con questi due punti di accesso \00E8 possibile utilizzare qualsiasi passo di elaborazione login incorpor')
||'ato in combinazione con la propria pagina di login e con i processi in esecuzione su tale pagina. Ricordare che l''uso dell''elaborazione post-autenticazione incorporata consente di utilizzare anche l''elaborazione di sentry di pagina e di verifica dell'
||'e sessioni incorporata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309740142306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'it'
,p_message_text=>'la pagina di login incorporata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313063483306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'it'
,p_message_text=>'Elaborazione login esterno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313839444306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'it'
,p_message_text=>unistr('L''URL di login %0 non appare per specificare una pagina dell''applicazione %1 come destinazione di sessione non valida. Inoltre non esistono valori di elaborazione login nello schema di autenticazione. Questa pagina \00E8 responsabile dell''esecuzione dei ')
||'seguenti passi:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313945536306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'it'
,p_message_text=>unistr('Notare che se i servizi richiamati in questo URL non utilizzano l''API %0 wwv_custom_auth_std per assistere i task di registrazione di sessione, l''applicazione non potr\00E0 utilizzare il sentry di pagina incorporato o l''elaborazione della verifica delle ')
||'sessioni. Tali operazioni dovranno essere eseguite con metodi stabiliti dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314257683306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'it'
,p_message_text=>unistr('L''URL di login %0 non appare per specificare una pagina dell''applicazione %1 come destinazione di sessione non valida. Questa pagina \00E8 responsabile dell''esecuzione dei seguenti passi:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314340107306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'it'
,p_message_text=>'I valori impostati per l''elaborazione del login nello schema di autenticazione sono mostrati di seguito:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314418653306808)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina di login specificata in questo schema \00E8 la pagina [%0] in questa applicazione. Questa pagina \00E8 responsabile dell''esecuzione dei seguenti passi:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314547630306808)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'it'
,p_message_text=>'Tuttavia non sono disponibili valori di elaborazione login nello schema di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314650528306808)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'it'
,p_message_text=>unistr('Poich\00E9 questa pagina \00E8 la pagina di login per l''applicazione designata, non \00E8 possibile eseguire alcune azioni sulla pagina la prima volta che viene visualizzata, perch\00E9 l''autenticazione dell''utente non \00E8 ancora avvenuta. Inoltre, alcune variabili di')
||' stato e di identificazione della sessione non sono disponibili per i calcoli o i processi di pagina come sarebbero sulle normali pagine elaborate dopo l''autenticazione. Per queste ragioni, la specifica di una pagina di login con un numero di pagina '
||unistr('in uno schema di autenticazione \00E8 adatta soltanto per pagine con funzionalit\00E0 scarsa o nulla a parte l''elaborazione dei form di login. Se si preferisce che la pagina di login sia pi\00F9 attiva, utilizzare la designazione di URL di login nella procedura ')
||unistr('guidata dello schema di autenticazione o nella pagina di modifica. Se si ricorda di impostare l''attributo di pagina pubblica su ''S\00EC, questa pagina \00E8 pubblica'' utilizzando il form Attributi pagina nel Builder, la pagina di login\005Cn pu\00F2 utilizzare la ga')
||'mma completa di funzioni %0 oltre a servire da pagina di login nell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313172422306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'it'
,p_message_text=>unistr('Questo schema di autenticazione non specifica una pagina di login n\00E9 un URL da utilizzare per la destinazione di sessione non valida. Questo implica che questo caso venga gestito dalla funzione di sentry di pagina. \00C8 possibile che tale funzione esegu')
||unistr('a il reindirizzamento a un portale Single Sign-on o a un altro server di login. Inoltre non esistono valori di elaborazione login nello schema di autenticazione. Se questo non \00E8 ci\00F2 che si intendeva, modificare questo schema di autenticazione e forni')
||'re una pagina o un URL di sessione non valido, quindi esaminare di nuovo questa vista del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313246236306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'it'
,p_message_text=>unistr('Questo schema di autenticazione non specifica una pagina di login n\00E9 un URL da utilizzare per la destinazione di sessione non valida. Questo implica che questo caso venga gestito dalla funzione di sentry di pagina. \00C8 possibile che tale funzione esegu')
||'a il reindirizzamento a un portale Single Sign-On o a un altro server di login ma esistono valori impostati per l''elaborazione login nello schema di autenticazione come mostrato di seguito:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313306996306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'it'
,p_message_text=>unistr('L''URL di login %0 viene visualizzato per specificare una pagina dell''applicazione %1 come destinazione di sessione non valida ma non sono disponibili valori di elaborazione login nello schema di autenticazione. Questa pagina \00E8 responsabile dell''esecu')
||'zione dei seguenti passi:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313406548306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'it'
,p_message_text=>unistr('Per consentire al motore %0 di mostrare o accettare la pagina di login nell''applicazione, \00E8 necessario selezionare l''attributo di pagina ''S\00EC, questa pagina \00E8 pubblica'' nella pagina Attributi pagina dell''App Builder, altrimenti il motore tenter\00E0 di es')
||unistr('eguire la funzione di sentry di pagina prima di mostrare la pagina. Se l''utente non si \00E8 ancora collegato, si tenter\00E0 un reindirizzamento allo stesso URL, che provocher\00E0 un loop indesiderato. Se si codifica la funzione di sentry di pagina, pu\00F2 essere')
||unistr(' necessario capire se la pagina corrente \00E8 questa pagina di login e gestirla in modo diverso dalle altre pagine. Se \00E8 possibile, identificarla per numero di pagina. Una tecnica pi\00F9 generica \00E8 l''uso della funzione booleana wwv_flow_custom_auth.current')
||'_page_is_public per riconoscere questo attributo pubblico della pagina di login o di qualsiasi altra pagina nell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313525972306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'it'
,p_message_text=>unistr('L''URL di login %0 appare per specificare una pagina dell''applicazione %1 come destinazione di sessione non valida. Questa pagina \00E8 responsabile dell''esecuzione dei seguenti passi:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313646460306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'it'
,p_message_text=>'I valori impostati per l''elaborazione del login nello schema di autenticazione sono mostrati di seguito:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102313795197306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'it'
,p_message_text=>unistr('Il server Oracle Application Server Single Sign-On eseguir\00E0 il reindirizzamento a questa applicazione dopo l''autenticazione dell''utente. Il punto di accesso \00E8 la procedura wwv_flow_custom_auth_sso.process_success nello schema %0. %0 \00E8 registrato come')
||unistr(' applicazione partner di Oracle Application Server Single Sign-On e pu\00F2 gestire tutte le interfacce del server di login per l''utente. Se si preferisce, \00E8 possibile registrare la propria applicazione nel proprio schema. \00C8 possibile scrivere la propria')
||unistr(' funzione sentry di pagina o semplicemente creare uno schema di autenticazione basato sullo schema Portal-SSO (la propria applicazione come applicazione partner) dalla galleria di schemi di autenticazione. Lo schema risultante richiamer\00E0 la funzione ')
||'sentry di pagina SSO incorporata wwv_flow_custom_auth_std.portal_sso_sentry_v1. Questa funzione richiede che lo schema di autenticazione corrente conosca il nome dell''applicazione partner, registrato con Oracle Application Server Single Sign-On. La C'
||unistr('reazione guidata schema di autenticazione chiede il nome dell''applicazione partner oppure \00E8 possibile aggiungerlo o modificarlo modificando lo schema dopo averlo creato. Il nome deve essere immesso esattamente come \00E8 stato registrato, rispettando le ')
||unistr('maiuscole e le minuscole. Sar\00E0 necessario anche scrivere la propria procedura ricevente URLC e richiamare l''API wwv_flow_custom_auth_sso.process_success da tale procedura, passando il nome dell''applicazione registrata con Oracle Application Server Si')
||unistr('ngle Sign-On. Questo eseguir\00E0 la registrazione di sessione con %0 dopo l''autenticazione. Se si scrive la propria funzione sentry di pagina, l''API wwv_flow_custom_auth_sso.portal_sso_redirect potrebbe essere richiamata dalla funzione sentry di pagina ')
||unistr('per eseguire il reindirizzamento al server di login quando determina che \00E8 richiesta l''autenticazione. \00C8 necessario passare il nome registrato dell''applicazione partner a questa procedura. Consultare la documentazione %0 e la documentazione %1 per i ')
||'dettagli.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314151297306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'it'
,p_message_text=>'Elaborazione post-autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102314022996306807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'it'
,p_message_text=>'Elaborazione pre-autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308542943306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'it'
,p_message_text=>'Utilizzando la logica incorporata, controllare il cookie denominato [%0]. Se il cookie esiste e il suo valore decodificato individua una riga nella tabella di sessioni interne, considerare valida la sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308711408306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'it'
,p_message_text=>'Calcola valore restituito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102310549997306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'it'
,p_message_text=>'Verifica delle credenziali (autenticazione)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102312135712306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'it'
,p_message_text=>'Elaborazione post-autenticazione personalizzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305208896306801)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'it'
,p_message_text=>'Argomento di punto di accesso non valido per wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.  '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305100420306801)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'it'
,p_message_text=>'Argomento p_session_id nullo per wwv_flow_custom_auth_std.login--p_flow_page:%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305067516306801)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire la funzione di controllo delle credenziali di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309525794306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'it'
,p_message_text=>'Destinazione di sessione non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311247634306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'it'
,p_message_text=>'Base di ricerca LDAP:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311305049306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'it'
,p_message_text=>unistr('Il blocco seguente \00E8 utilizzato per richiamare una funzione prima della chiamata a DBMS_LDAP.SIMPLE_BIND_S. Il nome utente acquisito nel form di login viene passato alla funzione che restituisce un valore utilizzato per sostituire %LDAP_USER% nella b')
||'ase di ricerca LDAP (vedere sopra).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311487974306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'it'
,p_message_text=>'Questo blocco di codice deve avere questa firma:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311570473306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'it'
,p_message_text=>'Questa funzione consente di trasformare il nome utente immesso nel form di login in qualsiasi formato corrispondente alla voce di directory LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311087651306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'it'
,p_message_text=>'Host LDAP:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311143078306805)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'it'
,p_message_text=>'Porta LDAP:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308078592306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'it'
,p_message_text=>'Questa applicazione (%0) utilizza la pagina %1 come pagina di login.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308199924306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'it'
,p_message_text=>'Ogni volta che viene richiesta la pagina %0, non vengono eseguiti ulteriori controlli di autenticazione e la pagina viene visualizzata o accettata. Questo consente la visualizzazione della pagina di login prima dell''autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307913056306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'it'
,p_message_text=>'Gestione pagina di login'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308251251306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione sentry di pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308302158306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'it'
,p_message_text=>'Utilizzare la logica incorporata per eseguire i task di sentry di pagina. Per ciascuna richiesta di pagina, la funzione di sentry di pagina esegue la verifica delle sessioni e calcola un valore restituito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102311709118306806)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'it'
,p_message_text=>'Elaborazione post-autenticazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308650645306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'it'
,p_message_text=>unistr('Utilizzare altro codice fornito dall''utente per stabilire se la sessione \00E8 valida. Dopo aver ottenuto il risultato TRUE dal controllo per la verifica delle sessioni incorporato precedente, eseguire il codice seguente e ricordare il valore booleano re')
||'stituito:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102308423825306803)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione di verifica delle sessioni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309838070306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'it'
,p_message_text=>'il server Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102309924358306804)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'it'
,p_message_text=>'l''URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102456720094306924)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'it'
,p_message_text=>'errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195196004306718)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'it'
,p_message_text=>'Job di caricamento dati avviato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366000003306851)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'it'
,p_message_text=>'I file %0 di dimensioni superiori a %1 MB non sono supportati per il caricamento dei dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102751605016307196)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'it'
,p_message_text=>'Espressione SQL non valida: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285453189306786)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Analizza %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285852772306786)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'it'
,p_message_text=>'Visualizza per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102445957665306915)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Formato data non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425507639306899)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'it'
,p_message_text=>'Debug:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425613685306899)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>'Funzione non supportata da questa versione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422716296306896)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1101 Impossibile elaborare la convalida di tipo "corpo funzione che restituisce una query".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425884865306899)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'it'
,p_message_text=>unistr('Errore 4323 Nella richiesta relativa alla Guida non \00E8 stato fornito un ID pagina numerico per il quale visualizzare la Guida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422508936306896)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1025 Errore durante l''elaborazione dell''espressione PL/SQL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422601758306896)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'it'
,p_message_text=>'Applicazione=%0 Pagina=%1 SQLERRM=%2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425351856306898)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile stampare la scorciatoia: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422833094306896)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1108 Impossibile elaborare la condizione corrente dell''elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425412113306898)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il rendering del grafico: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102575611696307028)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile presentare il componente %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102219762466306737)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la presentazione dell''area della lista dinamica: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425731979306899)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Errore 4322 Per la richiesta relativa alla Guida non \00E8 stata utilizzata la sintassi corretta. Richiesta nulla mentre era previsto un numero di pagina valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452356397306920)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile associare "%0". Usare le virgolette per gli elementi a pi\00F9 byte oppure verificare che la lunghezza dell''elemento sia pari a 30 byte al massimo. Usare la sintassi v() per fare riferimento agli elementi con lunghezza superiore a 30 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990469284307387)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Previsto un nome di colonna BLOB nel formato di visualizzazione di colonna report DOWNLOAD:TABLE_NAME:BLOB_COLUMN...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345024484307665)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Colonna %0 non trovata nella tabella %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102448089765306917)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore in DML: p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3. %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102282031604306783)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire l''operazione di inserimento.  %0  %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102603517380307054)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'it'
,p_message_text=>'Valore numerico %0 non valido per la colonna %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288726798306788)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione %0 non valida su questo oggetto. (%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989587912307386)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'it'
,p_message_text=>'Proprietario tabella non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989600843307386)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'it'
,p_message_text=>'URL non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989480203307386)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'it'
,p_message_text=>'Il tipo di dati "%1" dell''ultima colonna dati aggiornata "%0" usato per tenere traccia degli aggiornamenti in "%2" deve essere un tipo di dati Data o Indicatore orario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989758235307386)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'it'
,p_message_text=>'Errore: la chiamata deve essere eseguita da una pagina di form che contiene il nome di elemento di tipo FILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990042255307386)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Nessun formato di visualizzazione trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990525052307387)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Previsto un nome di colonna chiave primaria 1 nel formato di visualizzazione di colonna report DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103345135221307665)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Tabella o vista %0 non trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990374335307387)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Previsto un nome tabella nel formato di visualizzazione di colonna report DOWNLOAD:TABLE_NAME...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990209974307387)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Il formato di visualizzazione deve includere almeno 4 argomenti separati da caratteri due punti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990189711307387)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'it'
,p_message_text=>'Il formato di visualizzazione deve iniziare con DOWNLOAD o IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635654562307090)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" non \00E8 valido per la query SQL. Assicurarsi di utilizzare nomi alias univoci per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280934174306783)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa operazione non \00E8 consentita per l''origine dati REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635525283307090)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato selezionato un numero errato di colonne nella query SQL. Per i dettagli, vedere la Guida dell''attributo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102191069414306715)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di dati di %0 nell''istruzione SQL \00E8 errato. Il numero della colonna %1 \00E8 %2 mentre era previsto %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736569494307182)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" \00E8 gi\00E0 utilizzato nella query SQL. Assicurarsi di utilizzare nomi alias univoci per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736499443307182)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" non \00E8 valido per la query SQL della LOV. Assicurarsi di utilizzare nomi alias validi per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736222390307182)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'L''analisi ha restituito il risultati della query in "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736310870307182)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato selezionato un numero errato di colonne nella query SQL. Per i dettagli, vedere la Guida dell''attributo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190548584306714)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di origine dati REST %0 non \00E8 supportato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102192496098306716)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'it'
,p_message_text=>'Nome file duplicato: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384833739307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384688840307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'it'
,p_message_text=>'Costante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384336653307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385438661307695)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'it'
,p_message_text=>'Parola chiave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385343898307695)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista materializzata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384959442307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'it'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384757830307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'it'
,p_message_text=>'Elemento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384277442307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'it'
,p_message_text=>'Procedura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385044556307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385195198307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'it'
,p_message_text=>'Tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385548849307695)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384401495307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103384513927307694)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'it'
,p_message_text=>'Variabile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103385275435307695)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949487491307357)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'it'
,p_message_text=>'Analisi della query SQL LOV non riuscita. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102714236098307162)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'it'
,p_message_text=>'Sottomesso filtro di query non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950323903307357)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" \00E8 gi\00E0 utilizzato nella query SQL della LOV. Assicurarsi di utilizzare nomi alias univoci per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950237146307357)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" non \00E8 valido per la query SQL della LOV. Assicurarsi di utilizzare nomi alias validi per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949308962307356)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato selezionato un numero errato di colonne nella query SQL LOV. Vedere gli esempi di istruzioni valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288535072306788)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'it'
,p_message_text=>'Il server ha rilevato un errore durante il tentativo di rimozione del file "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288666758306788)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'it'
,p_message_text=>'Impossibile rimuovere il file %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288331594306788)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore durante la scrittura nella directory di file fisici "%0". (%1: %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423850047306897)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'it'
,p_message_text=>'Limite massimo di dimensione superato per i file non interni dell''area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288439580306788)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'it'
,p_message_text=>'Nessun file disponibile per la scrittura per l''ID %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102423732923306897)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'it'
,p_message_text=>'Limite massimo di dimensione superato per tutti i file dell''area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102457092208306924)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''eliminazione del ruolo sviluppatore. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333081324306825)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente non \00E8 stato creato per il seguente motivo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102997622072307392)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'it'
,p_message_text=>unistr('%0 \00E8 un indirizzo di posta elettronica non valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450763495306919)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'it'
,p_message_text=>'L''elemento %0 di tipo lista di selezione con reindirizzamento JS non ha query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450621077306919)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'it'
,p_message_text=>'L''elemento %0 di tipo lista di selezione non ha query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450860133306919)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'it'
,p_message_text=>'L''elemento %0 di tipo lista di selezione con reindirizzamento dell''URL non ha query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450933514306919)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'it'
,p_message_text=>'L''elemento %0 di tipo lista di selezione con reindirizzamento dell''URL alla pagina non ha query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425275896306898)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'it'
,p_message_text=>'Modifica elemento %0 - %1, sequenza: %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422339322306896)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1904 Impossibile calcolare l''elemento predefinito: tipo = Corpo funzione computation_type= %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422299497306896)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1020 Errore durante l''elaborazione dell''elemento PL/SQL (funzione).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422435570306896)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'it'
,p_message_text=>'Controllo ortografia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425170536306898)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'it'
,p_message_text=>'Impossibile convertire il valore "%0" nel formato di visualizzazione della data %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190264898306714)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>'Gli elementi del tipo di dati BLOB non sono supportati per SQL abilitato per REST o per l''origine dati REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190410246306714)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'it'
,p_message_text=>'Impossibile recuperare i metadati per l''ID area %s.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102670437316307121)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'it'
,p_message_text=>'Processo DML o di inizializzazione del form senza alcuna area di form assegnata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676182656307126)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore di migrazione della pagina del form precedente all''area di form: impossibile descrivere la tabella a cui si fa riferimento nel processo DML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102407305220306883)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun checksum trovato per il rilevamento dell''aggiornamento perduto. \00C8 possibile eseguire solo UPDATE o DELETE per le righe esistenti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102976730508307377)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il linguaggio DML del form su un''origine REST con sincronizzazione abilitata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190111511306714)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun elemento di chiave primaria \00E8 stato definito per l''area di form %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102190379610306714)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di dati dell''elemento %0 \00E8 errato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102358304253306845)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Esiste un indice di dominio nel %0 selezionato. La funzione Genera DDL non \00E8 in grado di generare la DDL per l''indice di dominio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296888104306794)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'it'
,p_message_text=>'Rem Impossibile generare DDL per %0 %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102327569633306818)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'it'
,p_message_text=>'Nessun %0 trovato per generare la DDL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297091747306795)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore Save_ddl %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102284625813306785)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile salvare la DDL come file di script. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296915650306794)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''analisi dello script DDL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451043273306919)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Errore: nome package %0 non valido o gi\00E0 assegnato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432101587306904)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'it'
,p_message_text=>'-- L''API tabelle per l''applicazione %0 ha generato %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430829190306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Creare il package PL/SQL %0 con le seguenti procedure:',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431757724306904)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'it'
,p_message_text=>'utilizzare per inserire i dati in %0. Fornire la chiave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431857529306904)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'it'
,p_message_text=>'utilizzare per aggiornare i dati nel %0 identificato dalla chiave o dalle chiavi primarie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431956289306904)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'it'
,p_message_text=>'utilizzare per eliminare i dati da %0 in base alla chiave o alle chiavi primarie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102432040643306904)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'it'
,p_message_text=>'utilizzare per recuperare i dati da %0 in base alla chiave o alle chiavi primarie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431611402306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431452841306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'it'
,p_message_text=>'Scarica corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431388720306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'it'
,p_message_text=>'Scarica specifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431265156306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'it'
,p_message_text=>'Nascondi corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431068181306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'it'
,p_message_text=>'Nascondi specifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504891885306961)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'it'
,p_message_text=>'-- package body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504910099306962)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'it'
,p_message_text=>'-- specifica package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431139755306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'it'
,p_message_text=>'Mostra corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430994831306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'it'
,p_message_text=>'Mostra specifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102431555820306903)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'it'
,p_message_text=>'Sottoprogramma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504333690306961)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'it'
,p_message_text=>'-- crea procedura per la tabella "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504582880306961)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'it'
,p_message_text=>'-- elimina procedura per la tabella "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504627659306961)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'it'
,p_message_text=>'-- recupera procedura per la tabella "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504733445306961)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'it'
,p_message_text=>'-- crea funzione MD5 per la tabella "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102504451140306961)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'it'
,p_message_text=>'-- aggiorna procedura per la tabella "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451155027306919)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'it'
,p_message_text=>'errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988815770307386)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario definire l''identificativo di origine dell''area di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102988914911307386)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('Il sistema di distribuzione non \00E8 stato specificato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329108507306819)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Il componente <strong>%0</strong> non pu\00F2 essere visualizzato nella <strong>Colonna %1</strong> poich\00E9 esiste gi\00E0 un altro componente all''interno di questa colonna.</p>'),
'<p>Questo problema viene risolto, di solito, impostando Colonna su <strong>Automatico</strong>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103433426185307735)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'it'
,p_message_text=>unistr('<p>L''etichetta dell''elemento di pagina <strong>%0</strong> non pu\00F2 essere visualizzata poich\00E9 l''impostazione per la griglia del numero di colonne per questo elemento di pagina non \00E8 valida. \00C8 impostata per essere visualizzata con un <strong>numero di')
||unistr(' colonne etichetta pari a %1</strong>. Questa impostazione non \00E8 supportata poich\00E9 l''elemento di pagina ha solo <strong>%2 colonna/e</strong> disponibili.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328974714306819)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Il componente <strong>%0</strong> non pu\00F2 essere visualizzato poich\00E9 le impostazioni della griglia per questo componente non sono valide. \00C8 impostato per essere visualizzato sulla <strong>Colonna %1</strong> con <span>Numero di colonne di %2</stro')
||unistr('ng>. Ci\00F2 non \00E8 possibile poich\00E9 la griglia in questa pagina supporta solo un massimo di <strong>%3 colonne</strong>.</p>'),
'<p>Questo problema viene risolto, di solito, impostando Colonna e Numero di colonne su <strong>Automatico</strong> per tutti i componenti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102329011130306819)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Il componente <strong>%0</strong> non pu\00F2 essere visualizzato poich\00E9 le impostazioni della griglia per questo componente non sono valide. \00C8 impostato per essere visualizzato sulla <strong>Colonna %1</strong> con <strong>Numero di colonne di %2</st')
||unistr('rong>. Ci\00F2 non \00E8 possibile poich\00E9 la griglia in questa pagina supporta solo un <strong>%3 colonne</strong>.</p>'),
'<p>Questo problema viene risolto, di solito, impostando Colonna e Numero di colonne su <strong>Automatico</strong> per tutti i componenti.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211142929306730)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'it'
,p_message_text=>'DBA - 2 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102211094477306730)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'it'
,p_message_text=>'2 giorni + Developer''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177463797306704)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'it'
,p_message_text=>'Guida all''amministrazione delle applicazioni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177572066306704)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'it'
,p_message_text=>'Riferimento API'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753386619307198)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'it'
,p_message_text=>'Contenuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102747371634307192)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'it'
,p_message_text=>'Informazioni su: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753408993307198)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'it'
,p_message_text=>'Trova'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102210985113306730)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'it'
,p_message_text=>'App Builder User''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859346661307287)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'it'
,p_message_text=>'la creazione iniziale dell''indice potrebbe richiedere alcuni secondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177624762306705)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'it'
,p_message_text=>'Guida alla migrazione delle applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753134149307198)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'it'
,p_message_text=>'File di mapping della documentazione non trovato: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102753525764307198)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'it'
,p_message_text=>'Punteggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102177737888306705)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'it'
,p_message_text=>'Guida di SQL Workshop e utility'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460294508306927)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore di normalizzazione della creazione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102636401456307091)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Non si dispone dell''accesso allo schema che si sta importando. Importazione non riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460100049306927)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stata richiamata la procedura remove_table_hint senza un valore per a p_table_id. Fornire una tabella.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102365997200306851)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stata rilevata una seconda chiamata create_company durante l''installazione dell''area di lavoro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328781633306818)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'it'
,p_message_text=>'Errore GET_BLOCK. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328629045306818)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'it'
,p_message_text=>'Errore GET_STMT. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328891063306819)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il file. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194989403306718)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'it'
,p_message_text=>unistr('Archivio zip non valido, non \00E8 stato trovato alcun file manifest di installazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332252856306825)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'it'
,p_message_text=>'Non si dispone di privilegi sullo schema %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102328540676306818)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''esecuzione dell''istruzione non \00E8 riuscita. %0'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102368524997306853)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stata rilevata una chiamata API alla procedura remove_page all''interno del blocco di grandi dimensioni nel file di esportazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629827941307086)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Per questo elemento non esiste un''etichetta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246680668306757)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un problema nell''ambiente in uso poich\00E9 i file di Application Express non sono aggiornati. I file per la versione #LOADED_VERSION# sono stati caricati, ma \00E8 previsto %0. Verificare di aver copiato la directory delle immagini nell''Appl')
||'ication Server secondo le istruzioni fornite nella Guida all''installazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246521484306757)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un problema nell''ambiente in uso poich\00E9 i file di Application Express non sono stati caricati. Verificare di aver copiato la directory delle immagini nell''Application Server secondo le istruzioni fornite nella Guida all''installazione.')
||unistr(' Verificare inoltre che il percorso del prefisso immagine sia corretto. Il percorso corrente \00E8 %0 (deve contenere le barre iniziale e finale, come il percorso predefinito /i/). Se \00E8 necessario modificarlo, usare lo script SQL reset_image_prefix.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450121039306919)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'it'
,p_message_text=>'Tentativo non autorizzato di eseguire il job %0 in base allo schema: %1 nell''applicazione: %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460791481306927)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la collection: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460326056306927)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'it'
,p_message_text=>'errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460424270306927)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore di ricerca del tipo di dati: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460601240306927)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore di recupero del tipo di dati: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460528634306927)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore 1 di recupero della lunghezza massima della colonna: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102648415456307100)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'it'
,p_message_text=>'Impossibile inserire una riga con oltre 32 KB di dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460858879306927)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'it'
,p_message_text=>'L''utente %0 non ha privilegi sullo schema %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451827793306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il tipo di condizione della diramazione delle pagine. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451779899306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il tipo di condizione del pulsante di pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451530033306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il tipo di calcolo dell''applicazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451435884306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile aggiornare il processo di applicazione se il tipo di condizione \00E8 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452231543306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''aggiornamento delle parole con errori ortografici. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451319329306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il tipo di condizione di visualizzazione della barra di navigazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451991601306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il tipo di calcolo della pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452129784306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il tipo di processo della pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451637068306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il tipo di sottotitolo della pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452090812306920)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiornare il tipo di convalida della pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102998732715307393)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'it'
,p_message_text=>unistr('%0: "Elementi padre LOV a catena" pu\00F2 essere usata solo se l''opzione "Caricamento lento" \00E8 impostata su S\00EC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989902071307386)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'it'
,p_message_text=>unistr('Errore: \00E8 possibile dichiarare un solo processo DML per pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989883712307386)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Errore: nessun processo DML corrispondente trovato per la pagina %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102990905572307387)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'it'
,p_message_text=>'%0 deve avere una colonna BLOB valida come origine.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951641607307358)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un codice PL/SQL che genera un codice HTML per l''elemento %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461785886306928)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire collection in blocco: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461482970306928)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile controllare se il codice \00E8 stato analizzato o meno: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461599323306928)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il control file: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462245081306928)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile controllare le statistiche del control file: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462157323306928)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eliminare le informazioni analizzate: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462055121306928)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('L''esecuzione dell''istruzione non \00E8 riuscita: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102460905231306927)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il file. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461107318306927)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile ottenere l''istruzione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427275921306900)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>'La lunghezza di riga %0 supera il valore massimo %1 alla riga %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461902378306928)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'it'
,p_message_text=>'Avvertenza: package body creato con errori di compilazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461668883306928)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il codice: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461802043306928)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire l''istruzione: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461299575306928)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile salvare il parametro nel database: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461094308306927)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile ottenere il blocco di codice: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102461390803306928)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile convalidare il file "%0". %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462380145306928)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile analizzare il file. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844779818307276)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna funzione di autenticazione definita per il plugin %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844895328307276)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna funzione successiva al logout definita per il plugin %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102844621226307276)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna funzione sentry di sessione definita per il plugin %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397942132307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'it'
,p_message_text=>'Azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397124684307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'it'
,p_message_text=>'Definita da azione dinamica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396876744307703)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Reindirizza alla pagina in questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397074578307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'it'
,p_message_text=>'Reindirizza a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103396921472307703)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Sottometti pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397585638307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'it'
,p_message_text=>'Svuota cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949513520307357)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'it'
,p_message_text=>'Query LOV non valida. Sono necessari un valore visualizzato e un valore restituito e i nomi delle colonne devono essere diversi. Se la query contiene una query in linea, la prima clausola FROM nell''istruzione SQL non deve appartenere alla query in li'
||'nea.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951258134307358)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'it'
,p_message_text=>'Analisi della query sull''origine dell''area non riuscita. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332335468306825)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'it'
,p_message_text=>'Analisi della query SQL non riuscita. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103420835888307725)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'it'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949619586307357)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'it'
,p_message_text=>'LOV statica non valida. Sono necessari un valore visualizzato e un valore restituito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102885235864307306)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'it'
,p_message_text=>'La tabella, la vista o il sinonimo non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102331857105306821)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'it'
,p_message_text=>'- Seleziona -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949944716307357)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Query lista di valori (LOV) o Lista di valori denominata per gli elementi con questo tipo di visualizzazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949897100307357)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'it'
,p_message_text=>unistr('L''uso di una lista di valori (LOV) denominata \00E8 supportato solo per tipi di elementi che richiedono almeno due colonne LOV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332529372306825)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'it'
,p_message_text=>'Il valore deve essere un numero intero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102332491657306825)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'it'
,p_message_text=>'Il valore deve essere numerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397243003307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258191003306766)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di dati della colonna \00E8 errato. Questo attributo richiede che la colona contenga uno dei tipi di dati seguenti: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102246416356306757)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna non esiste oppure la query sull''origine dell''area non \00E8 valida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258246174306766)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>'tipo di dati errato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950896802307358)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un''origine area per le aree di questo tipo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950903874307358)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" \00E8 gi\00E0 utilizzato nella query SQL dell''origine dell''area. Assicurarsi di utilizzare nomi alias univoci per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951037091307358)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" non \00E8 valido per la query SQL dell''origine dell''area. Assicurarsi di utilizzare nomi alias univoci per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951185657307358)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato selezionato un numero errato di colonne nella query dell''origine dell''area. Vedere gli esempi di istruzioni valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397474243307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'it'
,p_message_text=>'Richiesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397392375307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'it'
,p_message_text=>'Reimpostare l''impaginazione per questa pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397620405307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'it'
,p_message_text=>'Imposta questi elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950538551307357)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" \00E8 gi\00E0 utilizzato nella query SQL. Assicurarsi di utilizzare nomi alias univoci per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102950498127307357)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome colonna "%0" non \00E8 valido per la query SQL. Assicurarsi di utilizzare nomi alias univoci per le colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102333489886306826)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato selezionato un numero errato di colonne nella query SQL. Per i dettagli, vedere la Guida dell''attributo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102949717583307357)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'it'
,p_message_text=>'Le liste di valori (LOV) statiche sono supportate solo per tipi di elementi che richiedono almeno due colonne LOV.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397852615307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'it'
,p_message_text=>'Destinazione URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103397737044307704)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'it'
,p_message_text=>'Con questi valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452450420306921)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1711 Impossibile convertire l''ID della LOV popup nella richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452569139306921)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1721 Impossibile trovare l''elemento per l''ID della LOV popup nella richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102226328303306742)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile raggiungere il motore di stampa poich\00E9 l''URL specificato \00E8 errato o \00E8 necessario specificare un URL proxy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130969475307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'it'
,p_message_text=>'Sopra l''area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131379417307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'it'
,p_message_text=>'Sotto l''area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131404944307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'it'
,p_message_text=>'In basso nell''area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131026831307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'it'
,p_message_text=>'A sinistra del titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130661571307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'it'
,p_message_text=>'A destra della barra di ricerca del report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131124234307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'it'
,p_message_text=>'A destra del titolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131262787307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Impostazione predefinita area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130749079307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'it'
,p_message_text=>'In alto nell''area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103130829066307493)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'it'
,p_message_text=>'In alto e in basso nell''area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131534760307494)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'it'
,p_message_text=>'Dopo l''intestazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131625321307494)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Prima del pi\00E8 di pagina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354146631307672)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Componente non trovato. Potrebbe essere stato eliminato da un altro utente. Ricaricare la pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354034251307672)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'it'
,p_message_text=>unistr('Eliminazione impossibile poich\00E9 il componente ''%0'' fa riferimento a questo componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103353922094307672)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'it'
,p_message_text=>unistr('Eliminazione impossibile poich\00E9 il componente ''%0'' della pagina %1 fa riferimento a questo componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354213904307672)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'it'
,p_message_text=>unistr('L''attributo \00E8 stato gi\00E0 modificato da un altro utente. Ricaricare la pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354498037307672)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('L''attributo non \00E8 disponibile in questo contesto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103354392493307672)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('Il componente \00E8 stato modificato da un altro utente e questo attributo non esiste pi\00F9. Ricaricare la pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848695839307279)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'L''analisi ha restituito il risultati della query in "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441283673307741)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'it'
,p_message_text=>unistr('L''analisi ha restituito risultati di query in "%0". Se la sintassi della query \00E8 corretta, selezionare la casella di controllo "Usa nomi colonne generiche" in basso per continuare senza eseguire l''analisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103392615848307700)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'it'
,p_message_text=>'Deve essere univoco.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131726209307494)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Nessun modello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102848536305307279)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Il blocco pl/sql non ha restituito query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103441384506307741)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stata restituita alcuna query dal blocco PL/SQL. Se la sintassi della query \00E8 corretta, selezionare la casella di controllo "Usa nomi colonne generiche" in basso per continuare senza eseguire l''analisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131946282307494)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'it'
,p_message_text=>'Pagina bloccata da un altro utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103131848554307494)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'it'
,p_message_text=>unistr('La pagina \00E8 bloccata da %0. Impossibile salvare le modifiche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102738896664307184)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile estendere la tablespace poich\00E9 non esistono pi\00F9 schemi per questo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452657355306921)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Errore in drop_tablespace: p_name \00E8 nullo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452833828306921)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore in drop_user: nessun l_username.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103448294288307747)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'it'
,p_message_text=>unistr('Il wallet di cifratura non \00E8 aperto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102251448202306761)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Stringa di password non valida passata a wwv_flow_provision.create_user.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453494514306921)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Errore in remove_provisioned_company. L''area di lavoro \00E8 nulla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453220595306921)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la tablespace. %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453103065306921)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare l''utente. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452727619306921)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eliminare la tablespace. Errore: %0 \nsql:\n %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102452994892306921)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eliminare l''utente. Errore: %0 \nsql:\n %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453326038306921)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile concedere i privilegi iniziali. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102217678752306735)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'it'
,p_message_text=>unistr('Al momento non \00E8 possibile creare la tablespace. Riprovare in seguito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453025100306921)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296089953306794)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'it'
,p_message_text=>'Fornitura automatica non riuscita durante la fase "MAKE_REQUEST"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315685641306809)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile determinare l''ID gruppo di sicurezza per l''ID area di lavoro specificato = "%0"',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296399896306794)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro %0 \00E8 un nome riservato, richiesta rifiutata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296193417306794)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore durante l''aggiunta dell''utente all''area di lavoro %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102453713300306922)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'it'
,p_message_text=>'errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435581577306907)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'it'
,p_message_text=>'Non implementato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295859286306794)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'it'
,p_message_text=>'Nessuna area di lavoro trovata con l''ID area di lavoro: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295931373306794)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Nessuno schema assegnato per l''ID area di lavoro: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315740687306809)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Impossibile utilizzare questa funzione per rimuovere l''ultimo schema di un''area di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296732879306794)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Richiesta %0 non trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296523766306794)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'it'
,p_message_text=>'Impossibile elaborare la richiesta %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296252418306794)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'it'
,p_message_text=>unistr('Questa richiesta \00E8 stata elaborata o \00E8 in fase di elaborazione. Lo stato deve essere uguale a "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102316017349306809)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'it'
,p_message_text=>'Il nome utente %0 non esiste nell''area di lavoro %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315997520306809)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Reimpostazione password non consentita per uno schema non associato all''area di lavoro. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102315807856306809)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'Impossibile reimpostare la password per lo schema %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296619949306794)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile elaborare la richiesta %0 poich\00E9 lo schema %1 esiste nella tabella %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102296452795306794)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome di schema %0 \00E8 un nome riservato e non pu\00F2 essere fornito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102295725014306794)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'L''utente %0 non dispone del privilegio sullo schema %1.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255738270306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'it'
,p_message_text=>'Analisi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258594855306766)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'it'
,p_message_text=>'Analizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241476805306753)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'it'
,p_message_text=>'Utilizzare le credenziali di account di database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102272527257306776)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'it'
,p_message_text=>'Utilizzare credenziali di account %0 e pagina di login interne in questa applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102951872082307358)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'it'
,p_message_text=>'Usare Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255837632306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255664848306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Scegli una colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257818028306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile svuotare la cache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335449276307658)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #COLUMN_HEADER#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102285950392306786)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di analisi. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304139583306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il modello di pulsante. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304990851306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303593295306799)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare l''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305344014306801)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la home page. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304701941306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il form di inserimento. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303764488306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il modello di etichetta. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305417963306801)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305524288306801)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare l''elemento di lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303403151306799)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il modello di lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304592882306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare l''indicatore di percorso. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304030312306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il modello di indicatore di percorso. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305997852306801)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare moduli.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304470782306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la barra di navigazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256084219306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'it'
,p_message_text=>'Crea nuovo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258703468306766)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'it'
,p_message_text=>'Crea nuovo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303668076306799)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il modello di pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303990073306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il modello di area. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304605123306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di report. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102303880586306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il modello di report. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305689343306801)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di operazioni riuscite. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304323440306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare schede standard. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304802853306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il form di aggiornamento. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257758431306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'it'
,p_message_text=>'Foglio di calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335601111307658)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Il valore di #COLUMN_HEADER# deve essere una data valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305702746306801)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'it'
,p_message_text=>'Definire i modelli predefiniti per creare l''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102260289636306767)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile visualizzare l''area di pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257221536306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'it'
,p_message_text=>'Questa pagina visualizza la Guida per una pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257541137306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'it'
,p_message_text=>'Inserisci %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255966217306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'it'
,p_message_text=>'Inserisci form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256772508306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'it'
,p_message_text=>'Inserisci ancora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258029171306766)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile inserire una riga in %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256664184306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Inserimento dei dati completato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102719835388307167)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# deve essere una data valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256472718306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# deve essere numerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656009087307107)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# deve essere un indicatore orario valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257491966306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'it'
,p_message_text=>'Indicatore di percorso %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256322971306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335548778307658)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Il valore di #COLUMN_HEADER# deve essere numerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102304253278306800)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il modello di lista di valori popup.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102258652831306766)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'it'
,p_message_text=>'Report e modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257643633306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile visualizzare il report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257972808306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile reimpostare l''impaginazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256917494306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'it'
,p_message_text=>'Torna alla home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257397646306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'it'
,p_message_text=>'Torna alla pagina precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255491899306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Report di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372554437307685)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'it'
,p_message_text=>'Cerca in tutte le applicazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371716674307685)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'it'
,p_message_text=>'Applicazione di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103371580745307684)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'it'
,p_message_text=>'Cerca in Team Development'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103372210359307685)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'it'
,p_message_text=>'Cerca utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102255551042306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'it'
,p_message_text=>'Mostra grafico per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102259986847306767)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile visualizzare l''indicatore di percorso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102257045862306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256551022306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina di operazione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103335794589307658)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Il valore di #COLUMN_HEADER# deve essere un indicatore orario valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256245102306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'it'
,p_message_text=>'Aggiorna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256100622306764)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'it'
,p_message_text=>'Aggiorna form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102305894658306801)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile creare l''applicazione soltanto utilizzando una scheda di livello.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102256843497306765)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'it'
,p_message_text=>'Visualizza report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286994898306787)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'it'
,p_message_text=>'Informazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287067080306787)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'it'
,p_message_text=>'Diramazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102451235613306920)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102277252064306780)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'it'
,p_message_text=>'Una lista nidificata supporta solo il tipo di ricerca "Lato client".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439338215306910)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore imprevisto %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102422996213306896)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'it'
,p_message_text=>'Avvertenza: ID radice struttura "%0" non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635213909307090)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore nel codice PLSQL durante l''elaborazione delle istruzioni SQL remote.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102195247438306718)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di schede. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102777076039307220)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'it'
,p_message_text=>unistr('L''accesso per REST non \00E8 abilitato per questa istanza.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775386827307219)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('L''area non \00E8 stata trovata o non \00E8 abilitata per REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102775413758307219)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'it'
,p_message_text=>'Nessun metodo di output specificato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102425974610306899)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Area di lavoro obbligatoria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426047332306899)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Applicazione obbligatoria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426173747306899)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'it'
,p_message_text=>'Nome utente "%0" o password non validi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655408816307107)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'it'
,p_message_text=>'%0 nuovi attributi inseriti e che potrebbero dover essere tradotti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655515906307107)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'it'
,p_message_text=>unistr('%0 attributi eliminati e che non devono essere pi\00F9 tradotti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287851019306788)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di eliminazione del popolamento: %0.%1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287702314306788)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di inserimento del popolamento: %0.%1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655621394307107)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'it'
,p_message_text=>'%0 attributi totali che potrebbero dover essere tradotti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287612234306788)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare traduzione %0 dell''applicazione %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102655392122307107)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'it'
,p_message_text=>'%0 attributi esistenti aggiornati e che potrebbero dover essere tradotti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462423247306928)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'it'
,p_message_text=>'errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102725853152307173)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'it'
,p_message_text=>'Nessun indice su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656519481307108)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'it'
,p_message_text=>'Dati nella raccolta <code>%0</code> aggiunti con <b id="incompl_success_row_count"></b> documenti nuovi.<b class="u-danger-text" id="incompl_fail_row_count"></b> documenti rifiutati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656397855307108)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Ai dati nella raccolta <code>%0</code> sono stati aggiunti <b id="success_row_count"></b> documenti nuovi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194342278306717)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'it'
,p_message_text=>'Contenuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656736186307108)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194560748306718)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'it'
,p_message_text=>'Data creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194290079306717)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'it'
,p_message_text=>'Chiave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194635486306718)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'it'
,p_message_text=>'Ultima modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102194451885306717)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di supporto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199679286306721)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Guida dati non disponibile. La raccolta non contiene dati oppure non \00E8 stato ancora creato alcun indice di ricerca JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193544367306717)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'it'
,p_message_text=>'Carica file JSON, TXT o ZIP.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102199796934306722)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Metadati di raccolta non disponibili. Controllare il nome della raccolta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656668011307108)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'it'
,p_message_text=>'Dati nella raccolta <code>%0</code> sostituiti da <b id="incompl_success_row_count"></b> documenti nuovi.<b class="u-danger-text" id="incompl_fail_row_count"></b> documenti rifiutati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656439552307108)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Dati nella raccolta <code>%0</code> sostituiti da <b id="success_row_count"></b> documenti nuovi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440234458306910)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: l''intervallo dell''asse deve essere maggiore di zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440065173306910)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: il valore massimo dell''asse deve essere maggiore del valore minimo dell''asse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440487659306911)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: il valore massimo dell''asse deve essere maggiore di zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440353723306911)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: il valore minimo dell''asse deve essere maggiore o uguale a zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440124058306910)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: la larghezza delle barre deve essere maggiore di zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439735251306910)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'it'
,p_message_text=>'errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441765885306912)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di recupero: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441504491306911)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'it'
,p_message_text=>'Funzione che restituisce una query SQL: impossibile analizzare la query nell''App Builder. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440622664306911)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: gli spazi tra le barre devono essere maggiori o uguali a zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439800963306910)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: il numero massimo di righe da visualizzare deve essere maggiore di zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102442075061306912)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Altri dati trovati. Impossibile visualizzare pi\00F9 di 30 valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441607318306912)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di analisi: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441955230306912)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore del grafico SVG: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441832730306912)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile calcolare la posizione di ancoraggio del grafico: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441493916306911)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile ottenere il colore: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440807366306911)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: l''intervallo dell''asse X deve essere maggiore di zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441203509306911)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: Il valore massimo dell''asse X deve essere maggiore di zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441039783306911)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: Il valore minimo dell''asse X deve essere maggiore o uguale a zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440918782306911)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: l''intervallo dell''asse Y deve essere maggiore di zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102440701511306911)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: il valore massimo dell''asse Y deve essere maggiore del valore minimo dell''asse.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441322817306911)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: il valore massimo dell''asse Y deve essere maggiore di zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102441137570306911)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'it'
,p_message_text=>'Convalida non riuscita: il valore minimo dell''asse Y deve essere maggiore o uguale a zero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102437942009306909)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di aggiunta membro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242120637306753)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'it'
,p_message_text=>'Comando %0 bloccato. Impossibile eseguirlo da SQL Workshop.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434886150306906)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'it'
,p_message_text=>'L''utente %0 non ha privilegi sullo schema %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254826229306763)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'it'
,p_message_text=>'Lo schema %0 non dispone di privilegi select sulla tabella o vista %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438103368306909)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la creazione dello script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102434977569306906)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'it'
,p_message_text=>'tabella del piano creata per semplificare l''istruzione explain plan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435406890306907)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di creazione del file di script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435018923306906)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'it'
,p_message_text=>'Errore alla riga %0: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435254391306906)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''inserimento dello script nella tabella dei file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103383368047307693)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'it'
,p_message_text=>'ID riga non valido:  %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435391900306906)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''analisi dello script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102435145513306906)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'it'
,p_message_text=>'Lo schema "%0" non esiste nel database. Per impostare lo schema predefinito corretto, rivolgersi all''amministratore dell''area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235667149306749)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'it'
,p_message_text=>'Errore in run_sql_arr. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438010176306909)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di aggiornamento del membro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102254730010306763)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'it'
,p_message_text=>'La riga dello script supera i 32.767 byte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221622807306738)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'it'
,p_message_text=>'Annullato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102470433851306935)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'it'
,p_message_text=>'Annullamento in corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222632574306739)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'it'
,p_message_text=>'Completato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102223070833306739)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'it'
,p_message_text=>'%0 secondi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221794850306738)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'it'
,p_message_text=>'Esecuzione in corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280590644306782)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di eseguire uno script che contiene una o pi\00F9 istruzioni sconosciute. Rimuovere l''istruzione o le istruzioni riportate di seguito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222710762306739)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'In corso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102280401325306782)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'it'
,p_message_text=>'Numero riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102242019097306753)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'it'
,p_message_text=>unistr('ERR-1004 Impossibile nidificare gli script su pi\00F9 di %0 livelli.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243327349306754)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'it'
,p_message_text=>'ERR-1005 L''output dello script ha raggiunto il limite delle dimensioni massime. Modificare lo script in modo che generi un output inferiore o contattare l''amministratore per aumentare la dimensione massima dei risultati dello script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571563916307025)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'it'
,p_message_text=>'Lo script supera la dimensione massima consentita di %0 byte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102243422527306754)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'it'
,p_message_text=>'ERR-1005 L''output dello script ha raggiunto il limite delle dimensioni massime per i risultati nell''area di lavoro. Eliminare i risultati esistenti o contattare l''amministratore per aumentare la dimensione massima per i risultati nell''area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102506567651306963)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'it'
,p_message_text=>'Il buffer non contiene istruzioni da eseguire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102237342186306750)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'it'
,p_message_text=>unistr('L''istruzione SELECT non pu\00F2 essere maggiore di 32 KB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222862936306739)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'it'
,p_message_text=>'%0 riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222989641306739)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'it'
,p_message_text=>'%0 righe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102238287095306751)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'it'
,p_message_text=>'%0 righe selezionate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465553029306931)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di eseguire uno script che non contiene istruzioni eseguibili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235431913306748)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire lo script. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102235529733306748)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore in run_statement. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102465413024306931)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato richiesto di eseguire uno script che contiene una o pi\00F9 istruzioni che verranno ignorate da SQL Workshop. Confermare la richiesta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102241988132306753)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'ERR-1001 Script non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102221510530306738)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'it'
,p_message_text=>'Sottomissione completata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469986451306934)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'it'
,p_message_text=>'Istruzione sconosciuta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102469763439306934)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'it'
,p_message_text=>'%0% in uso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455485913306923)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Creazione del package non riuscita a causa della sintassi SQL non valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455187038306923)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'it'
,p_message_text=>'Creazione della tabella non riuscita a causa della sintassi SQL non valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288085350306788)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di sincronizzazione: %0.%1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611539169307061)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'it'
,p_message_text=>'riferimento proveniente da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102611479219307061)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'it'
,p_message_text=>'riferimenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102286303531306787)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'it'
,p_message_text=>'Tentativo di accesso a una colonna del form tabulare che verrebbe mappata a un array PL/SQL apex_application.g_f%0, ma sono supportate solo %1 colonne che salvano lo stato. Ridurre il numero delle colonne che salvano lo stato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102849043773307279)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'it'
,p_message_text=>'Aggiungi nuova scheda padre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634462604307089)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'it'
,p_message_text=>'Aggiungi nuova scheda standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635006632307090)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'it'
,p_message_text=>'Nuovo set di schede (consente di creare una scheda standard in un nuovo set di schede)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462770464306929)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il nuovo set di schede per l''ID scheda padre = %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462661106306929)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il vecchio set di schede per l''ID scheda = %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462801597306929)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID pagina: %0 non \00E8 un numero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634511351307089)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda padre: sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634979264307090)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'it'
,p_message_text=>unistr('non \00E8 associato a una scheda padre. \00C8 visualizzato come pseudoscheda padre in modo da poter modificare le schede standard in questo set di schede.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102635171228307090)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'it'
,p_message_text=>'Seleziona scheda standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634770747307090)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda padre selezionata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634688882307090)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'it'
,p_message_text=>'Pseudoscheda padre selezionata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462597323306929)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'it'
,p_message_text=>'L''ID gruppo di sicurezza deve essere impostato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102462928033306929)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'it'
,p_message_text=>'Specificare un nuovo set di schede per l''ID scheda = %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634351049307089)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'it'
,p_message_text=>'Scheda standard: sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634263060307089)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'it'
,p_message_text=>'Scheda corrente anche per le pagine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634113541307089)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'it'
,p_message_text=>'Scheda corrente per la pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102634884034307090)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'it'
,p_message_text=>'Il set di schede'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289237483306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il modello di pulsante (%0) nell''applicazione "%1" area di lavoro "%2" da copiare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290180176306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello di pulsante. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102455668664306923)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288903886306788)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il modello di campo (%0) nell''applicazione "%1" area di lavoro "%2" da copiare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289855559306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello di campo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289763434306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello di lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289166578306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il modello di indicatore di percorso (%0) nell''applicazione "%1" area di lavoro "%2" da copiare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289911835306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello di indicatore di percorso. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289460883306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello di pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102290049813306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello di lista di valori popup. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102572431236307025)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il modello popup (%0) nell''applicazione "%1" area di lavoro "%2" da copiare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289508856306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello di area. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289676447306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello di report. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102288874775306788)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il modello (%0) da copiare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102289315544306789)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'it'
,p_message_text=>'Impossibile sostituire il modello %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103402334284307711)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Stile di tema inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419826042307724)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile aggiornare lo stile poich\00E9 \00E8 di sola lettura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103419747068307724)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'it'
,p_message_text=>unistr('Nome gi\00E0 utilizzato da uno stile esistente.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102287931181306788)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di aggiornamento del popolamento: %0.%1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102736900938307183)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 in corso l''aggiornamento di Application Express a una versione pi\00F9 recente. Le modifiche alle applicazioni non sono consentite fino al termine dell''aggiornamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400117860306878)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205484968306726)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Applicazione %0 non trovata con login eseguito come utente di database %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205507950306726)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Applicazione %0 pagina %1 non trovata con login eseguito come utente di database %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401151088306878)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'it'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429166429306901)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'it'
,p_message_text=>'Errore durante la valutazione della query sulla casella di controllo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401245242306878)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428701067306901)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore: le liste di valori di sola visualizzazione devono selezionare due colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102399951604306877)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'it'
,p_message_text=>'Impossibile determinare la lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401531171306879)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'it'
,p_message_text=>'Trova %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450567209306919)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la generazione della lista di valori popup.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428478463306901)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la generazione della query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428510584306901)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''inizializzazione della lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429060309306901)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile inizializzare la query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354366286306842)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query sulla lista di valori popup non valida. Immettere un valore visualizzato e un valore restituito. I nomi delle colonne devono essere diversi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401618541306879)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'it'
,p_message_text=>'JavaScript non supportato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401804148306879)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102402244513306879)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''esecuzione della query di lista di valori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401090929306878)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400606579306878)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'it'
,p_message_text=>'Nessuna corrispondenza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401348836306879)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'it'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450242572306919)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'it'
,p_message_text=>'La lista di valori popup deve iniziare con "select".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428392467306901)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile generare la lista di valori popup con il filtro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450424958306919)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''inizializzazione della lista di valori popup con il filtro: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102450341777306919)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''inizializzazione della lista di valori popup.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428876324306901)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'it'
,p_message_text=>'Autenticazione della lista di valori popup non riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428941902306901)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'it'
,p_message_text=>'Verifica del checksum della lista di valori popup non riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400779641306878)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102400378501306878)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102401490454306879)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'it'
,p_message_text=>'Finestra di dialogo di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103012493939307404)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la visualizzazione dell''immagine. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429662899306902)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'it'
,p_message_text=>'Grassetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430082679306902)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'it'
,p_message_text=>'Elenco puntato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430470655306902)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'it'
,p_message_text=>'Rientro a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430524202306903)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'it'
,p_message_text=>'Rientro a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429740780306902)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'it'
,p_message_text=>'Corsivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430250237306902)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'it'
,p_message_text=>'Giustifica al centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430161523306902)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'it'
,p_message_text=>'Giustifica a sinistra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430389633306902)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'it'
,p_message_text=>'Giustifica a destra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429965556306902)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'it'
,p_message_text=>'Elenco numerato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102429803149306902)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'it'
,p_message_text=>'Sottolineato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102428608636306901)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile associare "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102205310234306726)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Applicazione Websheet %0 non trovata con login eseguito come utente di database %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102629330648307086)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'it'
,p_message_text=>unistr('Il Web Service non \00E8 raggiungibile poich\00E9 l''URL fornito non \00E8 valido, perch\00E9 l''ambiente in uso richiede un indirizzo di server proxy valido per la richieste HTTP, perch\00E9 si \00E8 verificato il timeout della richiesta oppure perch\00E9 un wallet deve essere c')
||'onfigurato per le richieste HTTPS. SQLERRM: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276034308306779)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato possibile recuperare il documento WSDL poich\00E9 l''URL fornito non \00E8 valido, perch\00E9 l''ambiente in uso richiede un indirizzo di server proxy valido per le richieste HTTP e non ne \00E8 stato definito uno per questa applicazione oppure perch\00E9 un w')
||'allet deve essere configurato per questa istanza di &PRODUCT_NAME. per le richieste HTTPS.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276715592306779)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'it'
,p_message_text=>'Azione elaborata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858784217307286)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggiungere le righe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102270506462306775)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il pulsante. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307009517306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di calendario. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306798468306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di grafico. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102989139367307386)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'it'
,p_message_text=>'Impossibile completare il processo di caricamento dati. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307470119306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il grafico Excel. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307129450306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il form su equijoin. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306351698306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il form su SP. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306411502306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il form sulla tabella. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306502399306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il form di inserimento. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102790883227307233)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il grafico Oracle JET. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102193475959306717)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina Master-Detail. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102676292822307126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare l''azione dinamica. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306634711306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la query e aggiornare la pagina. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306959573306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di report. %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307564924306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina di riepilogo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307647317306803)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la pagina del grafico SVG. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307375657306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare la struttura. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306295080306801)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il report aggiornabile. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307260636306802)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare Creazione guidata procedura guidata. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858683541307286)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile elaborare l''eliminazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859033727307287)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'#MRD_COUNT# riga/e eliminata/e.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212438004306731)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'it'
,p_message_text=>'Richiama valore di chiave primaria successivo o precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212344445306731)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'it'
,p_message_text=>unistr('Questo pulsante \00E8 necessario per il processo Richiama valore di chiave primaria successivo o precedente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102212206481306731)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'it'
,p_message_text=>unistr('Questo elemento \00E8 necessario per il processo Richiama valore di chiave primaria successivo o precedente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102213091971306731)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il processo Richiama valore di chiave primaria successivo o precedente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102222142717306738)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 certi di voler uscire da questa pagina senza salvare?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571455460307025)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile ottenere il valore dell''elemento chiave secondaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102571330450307025)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile ottenere il valore dell''elemento chiave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306887621306802)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di report non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102585448693307037)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Un report interattivo esiste gi\00E0. \00C8 possibile aggiungere un solo report interattivo per pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102297385858306795)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile creare il processo Richiama valore di chiave primaria successivo o precedente. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858530021307286)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'it'
,p_message_text=>'Guida non disponibile per questa pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306178395306801)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'it'
,p_message_text=>'Errore di analisi: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102306013807306801)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'it'
,p_message_text=>'errore di analisi2 %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859193223307287)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''invio della richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859405037307287)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'it'
,p_message_text=>'Mostra struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102859292570307287)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'it'
,p_message_text=>'Radice struttura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276508803306779)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'it'
,p_message_text=>'Impossibile recuperare la riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102276668767306779)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Impossibile elaborare la riga della tabella %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102307705161306803)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Esiste gi\00E0 una query SQL aggiornabile. \00C8 possibile aggiungere solo una query aggiornabile per pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858872526307286)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'it'
,p_message_text=>'Aggiornamento applicato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102858995811307286)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'#MRU_COUNT# riga/e aggiornata/e, #MRI_COUNT# riga/e inserita/e.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729349342307176)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'it'
,p_message_text=>'Copia schema di autorizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729122767307176)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'it'
,p_message_text=>'Copia lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102728912169307175)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'it'
,p_message_text=>'Copia lista di valori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729267896307176)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'it'
,p_message_text=>'Usa lista esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102729052939307175)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'it'
,p_message_text=>'Usa lista di valori esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102430747198306903)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il rendering del report: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102886920662307307)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'it'
,p_message_text=>'%0 GB totali | %1 GB usati | %2 percento usato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102204039567306725)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''impostazione della nuova destinazione aggregata PGA. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102203886407306725)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''impostazione della nuova destinazione SGA. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103451476637307749)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione di %0: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426452472306899)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'it'
,p_message_text=>'Media'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426398846306899)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'it'
,p_message_text=>'Asse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426962825306900)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'it'
,p_message_text=>'Primo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102427067030306900)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'it'
,p_message_text=>'Vai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426855529306900)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'it'
,p_message_text=>'Ultimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426671988306899)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'it'
,p_message_text=>'Massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426756528306899)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'it'
,p_message_text=>'Minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426260111306899)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102426596535306899)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'it'
,p_message_text=>'Somma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102361908971306848)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile analizzare la query. Il cursore non \00E8 ancora aperto oppure \00E8 stata restituita una funzione che restituisce una query SQL senza un valore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102722480782307169)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'it'
,p_message_text=>'La query contiene nomi alias duplicati. Le query utilizzate per i report devono avere nomi alias univoci.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102354013245306842)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'impossibile elaborare la convalida di tipo "corpo funzione che restituisce una query":',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439966060306910)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'it'
,p_message_text=>unistr('Numero di colonne definite non valido nella query. Per questo tipo di area \00E8 necessario definire %0 colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362028984306848)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Funzione che restituisce una query SQL: impossibile analizzare la query nel Builder. Se la sintassi della query \00E8 corretta, selezionare la casella di controllo relativa alle <strong>colonne generiche</strong> sotto l''origine dell''area per continuare ')
||'senza eseguire l''analisi.',
'<br/>',
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102362196990306848)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Impossibile analizzare la query nel Builder. Se la sintassi della query \00E8 corretta, selezionare la casella di controllo relativa alle colonne generiche sotto l''origine dell''area per continuare senza eseguire l''analisi.'),
'%0</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438439261306909)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi parola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439085136306909)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'it'
,p_message_text=>'Aggiungi a dizionario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438980840306909)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'it'
,p_message_text=>'Applica modifiche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438808509306909)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438758408306909)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102797637630307239)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'it'
,p_message_text=>'Sottometti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438600287306909)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('%0 gi\00E0 nel dizionario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439235364306910)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'it'
,p_message_text=>'Immettere una nuova parola.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102439144872306909)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'it'
,p_message_text=>'Scegli parola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102656810958307108)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'it'
,p_message_text=>'Correzione ortografica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102438599063306909)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'it'
,p_message_text=>'Aggiunto %0 al dizionario.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102283886493306785)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di caricamento XML.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102708741640307157)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'it'
,p_message_text=>'Esistono altre %0 tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102709525613307157)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'it'
,p_message_text=>'%0 bug non hanno una correzione per date'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102883515167307305)
,p_name=>'YEARLY'
,p_message_language=>'it'
,p_message_text=>'Anno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102337221381306829)
,p_name=>'YES_BY_USER'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC, per utente')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102366373495306851)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'it'
,p_message_text=>unistr('L''indirizzo di posta elettronica in uso \00E8 registrato come utente nelle seguenti aree di lavoro:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102647719494307100)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato eseguito il logout.')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.4415)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>'Indicatore di percorso'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizzare il trail dell''indicatore di percorso per la pagina corrente.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>'Lista'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza i valori in base a una lista statica o dinamica. In genere tali valori sono utilizzati per la navigazione alle pagine dell''applicazione.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>'Annulla finestra di dialogo'
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Cancella la pagina finestra di dialogo corrente.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>'Chiudi finestra di dialogo'
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Chiude la pagina finestra di dialogo corrente.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.4415)
,p_plugin_id=>wwv_flow_api.id(3734500756040.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elementi da restituire'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il nome di uno o pi\00F9 elementi di pagina che devono essere restituiti dalla finestra di dialogo. Se si specificano pi\00F9 elementi, usare una virgola per separare ogni nome elemento.</p>'),
unistr('<p>\00C8 possibile accedere ai valori di elementi restituiti definendo un''azione dinamica che deve essere attivata in caso di evento <strong>Finestra di dialogo chiusa</strong> sull''elemento che apre la finestra di dialogo, con un''azione <strong>Imposta ')
||'valore</strong> e <em>Tipo di set</em> impostato su <strong>Elemento restituito finestra di dialogo</strong>.</p>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>'Selettore di visualizzazione area'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizzare i nomi di area in una lista orizzontale, consentendo agli utenti finali di selezionare un''area per visualizzare o nascondere le altre aree. In quest''area verranno visualizzate solo le aree della pagina con <em>Selettore di visualizzazion'
||unistr('e area</em> impostato su <strong>S\00EC</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.4415)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Includi dispositivo di scorrimento'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Aggiungere in modo dinamico un dispositivo di scorrimento all''area se i nomi visualizzati superano la larghezza dell''area.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.4415)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Modalit\00E0')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare in che modo devono essere visualizzate nella pagina le aree per le quali <em>Selettore di visualizzazione area</em> \00E8 impostato su <strong>S\00EC</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4415)
,p_display_sequence=>10
,p_display_value=>'Visualizza area singola'
,p_return_value=>'STANDARD'
,p_help_text=>unistr('Mostra le aree sotto forma di schede. Se si seleziona una scheda, l''area corrispondente diventer\00E0 visibile, mentre le altre selezioni vengono nascoste.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4415)
,p_display_sequence=>20
,p_display_value=>'Scorri finestra'
,p_return_value=>'JUMP'
,p_help_text=>'Visualizza sempre tutte le aree nella pagina. Se si seleziona una scheda, la finestra scorre fino all''area corrispondente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.4415)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Includi ''Mostra tutto'''
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>'Aggiungere una scheda "Mostra tutto" che, se selezionata, visualizza tutte le aree nella pagina.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.4415)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Memorizza ultima selezione'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Al caricamento della pagina, verr\00E0 visualizzata l''ultima area selezionata.')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizzare il contenuto remoto con origine da un URL.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.4415)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Immettere un URL per il contenuto remoto.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.4415)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Modalit\00E0 di inclusione')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleziona la modalit\00E0 di inclusione nella pagina del contenuto remoto ottenuto dall''URL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4415)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>'Incorporare il contenuto remoto come un iframe.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4415)
,p_display_sequence=>20
,p_display_value=>'In linea (caratteri speciali di escape)'
,p_return_value=>'ESC_INLINE'
,p_help_text=>'Legge il contenuto remoto durante la fase di rendering della pagina e lo incorpora, ma applica la funzione di escape ai caratteri HTML per impedire gli attacchi di tipo XSS (Cross-Site Scripting).'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4415)
,p_display_sequence=>30
,p_display_value=>'In linea (nessuna funzione di escape)'
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('Legge il contenuto remoto durante la fase di rendering della pagina e lo incorpora. Questa opzione deve essere selezionata solo se il contenuto remoto pu\00F2 essere accettato come completamente sicuro, in quanto non viene applicata alcuna funzione di es')
||unistr('cape HTML. Ci\00F2 rende l''area vulnerabile agli attacchi di tipo XSS (Cross-Site Scripting).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.4415)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Attributi IFrame'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>'Immettere gli attributi di elemento HTML aggiuntivi per la tag iframe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.4415)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Elimina HTML fino a'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Utilizzare questo attributo per ritagliare una sezione di testo HTML da un documento pi\00F9 grande. Immettere una stringa che identifichi l''inizio della sezione o il punto fino al quale il testo HTML deve essere eliminato.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.4415)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Elimina HTML dopo'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Utilizzare questo attributo per ritagliare una sezione di testo HTML da un documento pi\00F9 grande. Immettere una stringa che identifichi la fine della sezione o il punto dopo il quale il testo HTML rimanente viene eliminato. La stringa che identifica l')
||'a fine della sezione interessata non viene inclusa nel testo restituito.'
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>'Testo Guida'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza un''area di Guida speciale utilizzata nella pagina Guida dedicata.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>'Ricerca con facet'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'<p>Area basata sull''origine di una ricerca con facet associata che fornisce agli utenti finali numerosi facet da utilizzare per limitare i risultati della ricerca in runtime. </p>'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Modifiche facet batch'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se applicare i facet selezionati in modalit\00E0 batch oppure individualmente nel report Ricerca con facet. Quando l''impostazione \00E8 S\00EC, i filtri del report vengono applicati quando l''utente fa clic sul pulsante Applica. Quando l''impostazione ')
||unistr('\00E8 No, i filtri del report vengono applicati non appena viene modificato un valore di facet qualsiasi.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Mostra facet correnti'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Specificare se visualizzare l''area dei facet correnti. L''area dei facet correnti visualizza i facet selezionati e consente di rimuoverli con facilit\00E0 uno per uno o tutti insieme.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4415)
,p_display_sequence=>10
,p_display_value=>unistr('S\00EC')
,p_return_value=>'Y'
,p_help_text=>'La lista dei facet correnti viene visualizzata nella parte superiore dell''area Ricerca con facet.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4415)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'La lista dei facet correnti non viene visualizzata.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4415)
,p_display_sequence=>30
,p_display_value=>'Selettore'
,p_return_value=>'E'
,p_help_text=>unistr('L''area dei facet correnti viene visualizzata all''interno dell''elemento specificato da questo selettore. Ci\00F2 consente di posizione l''area dei facet correnti quasi ovunque nella pagina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Selettore facet correnti'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>unistr('Questo \00E8 il selettore di un elemento della pagina in cui l''area Ricerca con facet visualizzer\00E0 i facet correnti.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Mostra conteggio righe totali'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare dove visualizzare il conteggio righe totali.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4415)
,p_display_sequence=>10
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'Il conteggio righe totali non viene visualizzato.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4415)
,p_display_sequence=>20
,p_display_value=>unistr('S\00EC')
,p_return_value=>'Y'
,p_help_text=>unistr('Il conteggio righe totali viene visualizzato nella parte superiore dell''area dei facet correnti oppure, se Mostra facet correnti \00E8 impostata su No, nella parte superiore dell''area Ricerca con facet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4415)
,p_display_sequence=>30
,p_display_value=>'Selettore'
,p_return_value=>'E'
,p_help_text=>unistr('Il conteggio righe totali (senza alcuna etichetta) viene visualizzato all''interno dell''elemento specificato da questo selettore. Ci\00F2 consente di posizionare il conteggio righe totali praticamente ovunque nella pagina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Etichetta conteggio righe totali'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Etichetta da utilizzare per il conteggio righe totali. Se non viene fornita alcuna etichetta qui, APEX utilizzer\00E0 il messaggio di testo APEX.FS.TOTAL_ROW_COUNT_LABEL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Selettore conteggio righe totali'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Questo \00E8 il selettore di un elemento della pagina in cui l''area di ricerca con facet visualizzer\00E0 il conteggio delle righe totali.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>'Soglia numeri compatti'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Fornire un valore soglia, al di sopra del quale i conteggi facet vengono visualizzati utilizzando un formato numerico compatto. Utilizzando tale formato, il valore <strong>1.234</strong> verr\00E0 visualizzato come <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Mostra grafici'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare dove vengono visualizzati i grafici dei valori dei facet.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4415)
,p_display_sequence=>10
,p_display_value=>'Finestra di dialogo'
,p_return_value=>'Y'
,p_help_text=>'I grafici dei valori dei facet vengono visualizzati in una finestra di dialogo non modale.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4415)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'Nessun pulsante presente per consentire agli utenti di visualizzare i grafici dei valori dei facet.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4415)
,p_display_sequence=>30
,p_display_value=>'Selettore'
,p_return_value=>'E'
,p_help_text=>unistr('I grafici dei valori dei facet vengono aggiunti all''elemento specificato da questo selettore. Ci\00F2 consente di posizionare i grafici in qualsiasi punto della pagina creando un dashboard dei grafici dei valori dei facet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Selettore grafici'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>unistr('Questo \00E8 il selettore di un elemento della pagina in cui l''area di ricerca con facet visualizzer\00E0 i grafici dei facet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Visualizza grafico per i primi N valori'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>unistr('Specificare il numero di valori da visualizzare nel grafico per ogni facet. Il valore <strong>10</strong> indica che nei grafici dei facet verranno visualizzati i <em>primi 10</em> elementi in base all''ordine nel facet. Quando la propriet\00E0 facet Ordi')
||unistr('na per conteggi pi\00F9 alti \00E8 attiva, far\00E0 riferimento ai <em>primi 10</em> elementi in base ai conteggi delle ricorrenze. Le modifiche a questa propriet\00E0 potrebbero non essere immediatamente visibili nelle sessioni del browser attualmente attive. Quest')
||unistr('o valore e la scelta del grafico a torta o a barre da parte dell''utente vengono salvati nella sessione del browser. Per visualizzare l''effetto delle modifiche apportate a questa propriet\00E0, reimpostare il report utilizzando il collegamento Reimposta a')
||'ree dell''opzione di controllo della cache, come con il pulsante Reimposta generato dalla procedura guidata.'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_name=>'facetsafterremovechart'
,p_display_name=>'Dopo la rimozione di un grafico'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>'Prima dell''aggiunta di un grafico'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.4415)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4415)
,p_name=>'facetschange'
,p_display_name=>'Modifica facet'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>'Collegamento SAML'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.4415)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>'Area memorizzazione credenziali per richieste di firma'
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selezionare l''area di memorizzazione delle credenziali che contiene il certificato pubblico e la chiave privata utilizzati per firmare i messaggi inviati al provider di identit\00E0.'),
unistr('\00C8 necessario registrare il certificato presso il provider di identit\00E0.'),
'&PRODUCT_NAME. utilizza la chiave privata per firmare le richieste.',
'Sebbene questo attributo sia facoltativo, si consiglia di firmare le richieste per motivi di sicurezza.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.4415)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Usa attributi SAML di'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>'Specificare se utilizzare una configurazione SAML a livello di istanza o specifica dell''applicazione.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4415)
,p_display_sequence=>10
,p_display_value=>'Istanza'
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Usa la configurazione SAML condivisa per l''intera istanza di &PRODUCT_NAME..',
unistr('Ci\00F2 richiede che l''amministratore dell''istanza abbia configurato gli attributi SAML a livello di istanza.'),
'In caso contrario, si verificheranno errori di runtime.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4415)
,p_display_sequence=>20
,p_display_value=>'Applicazione'
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>'Usa una configurazione SAML specifica dell''applicazione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.4415)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('URL Single Sign-On del provider di identit\00E0')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>unistr('Selezionare l''URL POST Single Sign-On del provider di identit\00E0.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.4415)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('URL Single Sign-Out del provider di identit\00E0')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selezionare l''URL POST Single Sign-Out del provider di identit\00E0.'),
unistr('Se non selezionato, verr\00E0 utilizzato l''URL Single Sign-On.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.4415)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('Provider di identit\00E0 emittente')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selezionare il valore "Emittente" del provider di identit\00E0.'),
unistr('&PRODUCT_NAME. verificher\00E0 il valore selezionato nei messaggi provenienti dal provider di identit\00E0.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.4415)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Attributo nome utente'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Attributo SAML che contiene il nome utente.',
unistr('L''impostazione predefinita \00E8 il valore del nodo "Assertion/Subject/NameID".')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.4415)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>unistr('Certificato di firma del provider di identit\00E0')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere il certificato utilizzato dal provider di identit\00E0 per firmare i messaggi.'),
unistr('&PRODUCT_NAME. utilizza il certificato per verificare i messaggi di risposta provenienti dal provider di identit\00E0.'),
'Sebbene questo attributo sia facoltativo, si consiglia di verificare le risposte per motivi di sicurezza.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.4415)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Converti nome utente in lettere maiuscole'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specificare se i valori di attributo per il nome utente devono essere convertiti in maiuscolo.'
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>'Campo di input'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.4415)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Operatore di confronto'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4415)
,p_display_sequence=>10
,p_display_value=>'Uguale'
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4415)
,p_display_sequence=>30
,p_display_value=>'Minore di'
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4415)
,p_display_sequence=>40
,p_display_value=>'Minore o uguale a'
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4415)
,p_display_sequence=>50
,p_display_value=>'Maggiore di'
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4415)
,p_display_sequence=>60
,p_display_value=>'Maggiore o uguale a'
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4415)
,p_display_sequence=>70
,p_display_value=>'Inizia con'
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4415)
,p_display_sequence=>80
,p_display_value=>'Contiene'
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.4415)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Con distinzione tra maiuscole e minuscole'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.4415)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Maiuscole/minuscole valori'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Se tutti i valori dei dati sono gi\00E0 in lettere minuscole o maiuscole, \00E8 possibile dichiarare qui tale condizione. Il filtro, fornito dall''utente finale, eseguir\00E0 automaticamente la conversione nel formato scelto, in modo che l''utente finale possa eff')
||unistr('ettuare ricerche senza distinzione tra maiuscole e minuscole, laddove il database esegue in realt\00E0 una ricerca con distinzione tra maiuscole e minuscole normale.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4415)
,p_display_sequence=>10
,p_display_value=>'Maiuscolo e minuscolo'
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4415)
,p_display_sequence=>20
,p_display_value=>'Minuscolo'
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4415)
,p_display_sequence=>30
,p_display_value=>'Maiuscolo'
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.4415)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Etichetta corrente'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'Applicazione del filtro per %0'
,p_help_text=>unistr('Fornire il testo da visualizzare per questo facet nell''area dei facet correnti. \00C8 possibile fare riferimento al valore corrente con il segnaposto <strong>%0</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.4415)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Testo del prefisso'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Fornire il testo da visualizzare prima del campo di input.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.4415)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Testo del suffisso'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Fornire il testo da visualizzare dopo il campo di input.'
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>'Schede'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Report basato su una query SQL che visualizza i dati per ogni riga nelle schede. Con le schede \00E8 possibile visualizzare facilmente i dati in blocchi di contenuto. \00C8 possibile personalizzare l''intestazione, il supporto, il corpo o le azioni in modo di')
||'chiarativo.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.4415)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4415)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.4415)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4415)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>'Modifica pagina'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.4415)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo di impaginazione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Nessuna impaginazione'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_display_sequence=>10
,p_display_value=>'Dimensione pagina e offset recupero'
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Impaginazione flessibile in cui l''API REST consente di richiedere un set specifico di righe utilizzando i parametri <em>page size</em> e <em>offset</em> ("inizia alla riga"). Di seguito \00E8 riportato un tipico esempio di URL, in cui vengono saltate ')
||'<strong>20</strong> righe e recuperate le successive <strong>100</strong>:</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_display_sequence=>20
,p_display_value=>'Dimensione pagina e numero pagina'
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Impaginazione in cui l''API REST consente di richiedere un set di righe utilizzando i parametri <em>page size</em> e <em>page number</em>. Di seguito \00E8 riportato un tipico esempio di URL in cui viene richiesto il numero di pagina <strong>2</strong>')
||' con una dimensione di pagina pari a <strong>100</strong>. Con queste impostazioni vengono restituite le righe da 101 a 200.',
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_display_sequence=>30
,p_display_value=>'Numero pagina'
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Impaginazione in cui l''API REST consente di richiedere un set di righe mediante il parametro <em>page</em>. La dimensione pagina \00E8 fissa e definita dall''API REST. Di seguito \00E8 riportato un tipico esempio di URL, in cui viene richiesto il numero di')
||' pagina <strong>2</strong>. Se l''API REST utilizza una dimensione pagina fissa pari a <strong>20</strong>, verranno restituite le righe da 21 a 40.',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Parametro URL dimensione pagina'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Fornire il parametro URL per specificare la <em>dimensione pagina</em> richiesta dall''API REST. I valori tipici sono <strong>limit</strong>, <strong>page_size</strong> o </strong>per_page</strong>.</p>',
unistr('<p><em>Non aggiungere questo parametro nei <strong>parametri</strong> dell''origine dati REST</em>. &PRODUCT_NAME. lo aggiunger\00E0 in modo automatico durante l''esecuzione della richiesta HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valore massimo dimensione pagina'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>'righe'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fornire il numero massimo di righe per pagina, che l''API REST consente di recuperare. &PRODUCT_NAME. non tenter\00E0 di richiedere pi\00F9 righe per pagina.</p>'),
unistr('<p>Assicurarsi che l''API REST <em>restituisca effettivamente</em> questo numero di righe, perch\00E9 &PRODUCT_NAME. presume che una pagina richiesta sia l''ultima se la risposta contiene un numero inferiore di righe rispetto a quello richiesto.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Parametro URL numero di pagina'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fornire il parametro URL per specificare il <em>numero di pagina</em> richiesto dall''API REST. Un valore tipico \00E8 <strong>page</strong>.</p>'),
unistr('<p><em>Non aggiungere questo parametro nei <strong>parametri</strong> dell''origine dati REST</em>. &PRODUCT_NAME. lo aggiunger\00E0 in modo automatico durante l''esecuzione della richiesta HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Indice della prima pagina'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Specificare se l''API REST inizia a conteggiare le pagine in corrispondenza dell''indice <strong>"0"</strong> o <strong>"1"</strong>.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4415)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>'L''API REST fa riferimento alla prima pagina come pagina <strong>1</strong>.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4415)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>'L''API REST fa riferimento alla prima pagina come pagina <strong>0</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Dimensioni pagina fisse'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>'righe'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Fornire la <em>dimensione pagina</em> (numero di righe per pagina), determinata dall''API REST.</p>',
unistr('<p>In genere, queste informazioni sono disponibili nella documentazione dell''API REST. Assicurarsi di specificare il valore corretto qui. Se il valore non \00E8 preciso, le righe risulteranno mancanti o duplicate quando &PRODUCT_NAME. recuperer\00E0 i dati d')
||'all''API REST.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Parametro URL offset riga'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>'righe'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Fornire il parametro URL per specificare l''<em>offset</em>, che indica le righe da saltare prima della restituzione della prima riga.</p>',
unistr('<p><em>Non aggiungere questo parametro nei <strong>parametri</strong> dell''origine dati REST</em>. &PRODUCT_NAME. lo aggiunger\00E0 in modo automatico durante l''esecuzione della richiesta HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Tipo di offset riga'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Scegliere se il parametro <strong>Offset</strong> indica il <em>numero di righe da saltare</em> o la <em>prima riga da recuperare</em>.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4415)
,p_display_sequence=>10
,p_display_value=>'Righe da saltare'
,p_return_value=>'OFFSET'
,p_help_text=>'Il valore di offset indica le righe da saltare. Ad esempio, se viene fornito il valore 100, l''API REST restituisce le righe a partire dall''indice 101.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4415)
,p_display_sequence=>20
,p_display_value=>'Prima riga da recuperare'
,p_return_value=>'START'
,p_help_text=>unistr('Il valore di offset indica la riga in corrispondenza della quale iniziare l''operazione di recupero. Ad esempio, se viene fornito il valore 100, l''API REST salter\00E0 99 righe e inizier\00E0 l''operazione di recupero in corrispondenza dell''indice 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Con selettore di pi\00F9 righe')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se un''API REST restituisce la seguente risposta JSON:</p>',
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('Il valore di <strong>Con selettore di pi\00F9 righe</strong> \00E8 <strong>metadata.pagination.moreRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se l''API REST di risposta restituisce informazioni che indicano se sono presenti pagine aggiuntive, fornire il <em>selettore</em> per estrarre questo attributo qui.</p>',
unistr('<p>Sebbene non sia necessario specificare l''opzione <strong>Con selettore di pi\00F9 righe</strong>, ci\00F2 consente a &PRODUCT_NAME. di salvare ulteriori richieste HTTP (che non restituiranno dati) quando tutti i dati sono gi\00E0 stati recuperati.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Con pi\00F9 righe se il valore')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Scegliere come interpretare il valore dell''attributo di risposta a cui fa riferimento l''opzione <strong>Con selettore di pi\00F9 righe</strong>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4415)
,p_display_sequence=>10
,p_display_value=>'Uguale'
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('Si presume che siano disponibili pi\00F9 righe quando l''attributo di risposta, a cui fa riferimento l''opzione <strong>Con selettore di pi\00F9 righe</strong>, \00E8 uguale a un valore.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4415)
,p_display_sequence=>20
,p_display_value=>unistr('Non \00E8 nullo')
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('Si presume che siano disponibili pi\00F9 righe quando l''attributo di risposta, a cui fa riferimento l''opzione <strong>Con selettore di pi\00F9 righe</strong>, esiste e non \00E8 vuoto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Con valore attributo Pi\00F9 righe')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('<p>&PRODUCT_NAME. presume che siano disponibili pi\00F9 righe se l''attributo di risposta, a cui fa riferimento l''opzione <strong>Con selettore di pi\00F9 righe</strong>, contiene questo valore.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.4415)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Selettore righe totali'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se l''API REST restituisce la seguente risposta JSON ...</p>',
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('... il valore di <strong>Con selettore di pi\00F9 righe</strong> \00E8 <strong>metadata.pagination.totalRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se l''API REST restituisce il <em>numero totale di righe</em> (in tutte le pagine) nella risposta, fornire il <em>selettore</em> per estrarre questo attributo qui.</p>',
unistr('<p>Sebbene non sia necessario specificare <strong>Con selettore di pi\00F9 righe</strong>, ci\00F2 consente di visualizzare il numero totale di righe nei componenti di &PRODUCT_NAME., <em>a condizione che i dati non vengano filtrati ulteriormente</em>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>'Indirizzo con codifica geografica'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Questo tipo di elemento fornisce la funzionalit\00E0 di codifica geografica (trasformazione di un indirizzo postale in una coordinata).<p>'),
unistr('<p>La codifica geografica viene eseguita dal <em>browser</em> mediante l''invio di una richiesta REST al servizio di codifica automatica di <strong>Oracle Elocation</strong> (elocation.oracle.com). Pertanto, affinch\00E9 la codifica geografica possa funzi')
||unistr('onare, \00E8 necessario che il browser sia connesso a Internet.</p>'),
unistr('<p>I dati di input della codifica geografica provengono da altri elementi di pagina, mappati alle parti dell''indirizzo quali Via, Numero civico, Codice postale o Citt\00E0. Il sistema di codifica geografica mostrer\00E0 una finestra popup contenente una list')
||unistr('a di corrispondenze possibili. Dopo aver scelto una corrispondenza, il valore dello stato della sessione dell''elemento diventer\00E0 la coordinata dell''indirizzo nel formato GeoJSON. Se la modalit\00E0 <strong>Correggi indirizzo</strong> \00E8 abilitata, gli ele')
||'menti di pagina inclusi nella parte dell''indirizzo verranno sovrascritti con i valori corretti ricevuti del servizio di codifica geografica.</p>',
unistr('<p>Per i casi d''uso pi\00F9 semplici, la modalit\00E0 <strong>Indirizzo non strutturato</strong> consente di mappare un solo campo di testo o una sola area di testo in cui gli utenti finali immettono le parti dell''indirizzo, separate da virgole. In questo ca')
||unistr('so, la modalit\00E0 <strong>Correggi indirizzo</strong> non \00E8 disponibile.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Modalit\00E0 di corrispondenza del sistema di codifica geografica')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>L''opzione <strong>Modalit\00E0 di corrispondenza</strong> determina il livello di corrispondenza degli attributi di un indirizzo di input con i dati da utilizzare per la codifica geografica.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4415)
,p_display_sequence=>10
,p_display_value=>'Esatto'
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>Tutte le parti dell''indirizzo fornite devono corrispondere. Tuttavia, se il numero civico, il nome o il tipo di via non <em>corrispondono</em>, viene restituita la prima corrispondenza tra le seguenti: codice postale, citt\00E0 e stato. Ad esempio, se')
||unistr(' il nome della via non \00E8 corretto, ma \00E8 stato specificato un codice postale valido, viene restituita una localit\00E0 nel codice postale.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4415)
,p_display_sequence=>20
,p_display_value=>'Tipo di via ridotto'
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>Il <em>tipo di via</em> fornito pu\00F2 essere diverso dai dati utilizzati per la codifica geografica. Ad esempio, <strong>Main Street</strong> o <strong>Main Blvd</strong> corrisponde a <strong>Main St</strong>, se non esistono altre vie denominate <')
||'strong>Main Blvd</strong> o <strong>Main Street</strong> nell''area rilevante.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4415)
,p_display_sequence=>30
,p_display_value=>'Numero civico ridotto'
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>Il numero civico e il tipo di via possono essere diversi dai dati utilizzati per la codifica geografica. Ad esempio, <strong>123 Main St</strong> corrisponde a <strong>123 Main Lane</strong> e <strong>124 Main St</strong> purch\00E9 non siano presenti')
||unistr(' ambiguit\00E0 o altre corrispondenze.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4415)
,p_display_sequence=>40
,p_display_value=>'Nome via ridotto'
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>Il <em>nome di base</em> della via, il numero dell''edificio e il tipo di via possono essere diversi dai dati utilizzati per la codifica geografica. Ad esempio, <strong>Pleasant Vale</strong> corrisponde a <strong>Pleasant Valley</strong> purch\00E9 no')
||unistr('n siano presenti ambiguit\00E0 o altre corrispondenza nei dati.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4415)
,p_display_sequence=>50
,p_display_value=>'Codice postale ridotto'
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>'<p>Il codice postale (se fornito), il nome della via, il tipo di via e il numero civico possono essere diversi dai dati utilizzati per la codifica geografica.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4415)
,p_display_sequence=>60
,p_display_value=>'Riduci tutto'
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>L''indirizzo pu\00F2 non trovarsi nella citt\00E0 specificata purch\00E9 si trovi nella stessa provincia. Inoltre, include le caratteristiche del <strong>codice postale ridotto</strong>.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostra coordinate in una finestra popup'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>'<p>Determina se visualizzare le coordinate dell''indirizzo (longitudine, latitudine) nella finestra di dialogo popup dei risultati della codifica geografica.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Anteprima mappa'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Indica se consentire l''anteprima dell''indirizzo con codifica geografica su una mappa.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4415)
,p_display_sequence=>10
,p_display_value=>'Popup risultati'
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mostra la mappa nel popup dei risultati della codifica geografica, in modo che gli utenti possano esaminare la posizione prima di selezionare un risultato.</p>',
unistr('<p>\00C8 supportato quando l''opzione "Visualizza come - Vista griglia" \00E8 abilitata.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4415)
,p_display_sequence=>20
,p_display_value=>'Elemento'
,p_return_value=>'ITEM'
,p_help_text=>'Mostra una mappa che visualizza l''indirizzo nella posizione dell''elemento.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Sfondo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Scegliere la mappa di sfondo in cui mostrare i risultati della codifica geografica.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4415)
,p_display_sequence=>5
,p_display_value=>'Valore predefinito'
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilizzare lo sfondo predefinito della mappa.</p>',
'<p>Per i temi scuri viene utilizzato "OpenStreetMap Bright" o "OpenStreetMap Dark".</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4415)
,p_display_sequence=>10
,p_display_value=>'OpenStreetMap brillante'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base generica basata sui dati OpenStreetMap. Questo stile di mappa base fornisce un contesto di posizione dettagliato per i dati.</p>',
'<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4415)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap scura'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base scura non invadente basata sui dati OpenStreetMap. Questo stile di mappa base accentua le visualizzazioni dei dati.</p>',
unistr('<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY. La cartografia di Stamen Design \00E8 concessa in licenza in base a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4415)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base chiara non invadente basata sui dati OpenStreetMap. Questo stile di mappa base accentua le visualizzazioni dei dati.</p>',
unistr('<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY. La cartografia di Stamen Design \00E8 concessa in licenza in base a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4415)
,p_display_sequence=>40
,p_display_value=>'Mappa del mondo Oracle'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base generica basata sui dati mappa HERE. Questo stile di mappa base fornisce il contesto di posizione dei dati e ne accentua la visualizzazione.</p>',
'<p>Schema e definizioni di stile di Oracle, Stati Uniti.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Altezza'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'pixel'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare l''altezza (in pixel) della mappa visualizzata.</p>',
'<p>L''altezza predefinita della mappa viene calcolata in base alla larghezza con una simmetria pari a 3:2.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Visualizza come'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selezionare la modalit\00E0 di visualizzazione dei risultati della codifica geografica.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4415)
,p_display_sequence=>10
,p_display_value=>'Vista lista'
,p_return_value=>'LIST'
,p_help_text=>'<p>I risultati verranno visualizzati in una vista elenco.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4415)
,p_display_sequence=>20
,p_display_value=>'Vista griglia'
,p_return_value=>'GRID'
,p_help_text=>'<p>I risultati verranno visualizzati in una vista griglia.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>'Indirizzo strutturato'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indica se le parti dell''indirizzo vengono fornite al servizio di codifica geografica in modo <em>strutturato</em> o <em>non strutturato</em>.</p>',
unistr('<p>La modalit\00E0 strutturata indica che gli elementi di pagina espliciti vengono mappati alle parti dell''indirizzo quali Via, Codice postale, Citt\00E0 o Regione. Questa modalit\00E0 consente di ottenere risultati di codifica geografica pi\00F9 accurati e fornire'),
'indirizzi corretti agli elementi di pagina.</p>',
unistr('<p>La modalit\00E0 non strutturata indica che viene utilizzato un solo elemento per l''intero indirizzo e le parti vengono separate da virgole. Questa modalit\00E0 non consente di fornire indirizzi corretti all''elemento di pagina.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Tipo di paese'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Scegliere se utilizzare un paese statico per la codifica geografica o se derivare il paese da un elemento.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4415)
,p_display_sequence=>10
,p_display_value=>'Statico'
,p_return_value=>'STATIC'
,p_help_text=>'<p>Utilizzare un paese statico da una lista di selezione.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4415)
,p_display_sequence=>20
,p_display_value=>'Elemento'
,p_return_value=>'ITEM'
,p_help_text=>'<p>Recupera il paese da un''applicazione o da un elemento di pagina. L''elemento deve contenere il codice ISO a 2 cifre relativo a un paese. </p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Paese'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><strong>US</strong>: Stati Uniti</li>',
'<li><strong>UK</strong>: Regno Unito</li>',
'<li><strong>DE</strong>: Germania</li>',
'<li><strong>AT</strong>: Austria</li>',
'</ul>'))
,p_help_text=>'<p>Scegliere un elemento della pagina o dell''applicazione da cui ricavare il paese per la codifica geografica. L''elemento deve contenere un codice ISO a 2 cifre relativo a un paese.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Paese'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Scegliere il paese da utilizzare per la codifica geografica.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>10
,p_display_value=>'Stati Uniti'
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>20
,p_display_value=>'Regno Unito'
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>30
,p_display_value=>'Germania'
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>40
,p_display_value=>'Francia'
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>50
,p_display_value=>'Italia '
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>60
,p_display_value=>'Canada'
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>70
,p_display_value=>'Paesi Bassi'
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>80
,p_display_value=>'Belgio'
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>90
,p_display_value=>'Austria'
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>100
,p_display_value=>'Svizzera'
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>110
,p_display_value=>'Spagna'
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>120
,p_display_value=>'Portogallo'
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>130
,p_display_value=>'Federazione Russa'
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>140
,p_display_value=>'Estonia'
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>150
,p_display_value=>'India'
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>160
,p_display_value=>'Messico'
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>170
,p_display_value=>'Australia'
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>180
,p_display_value=>'Brasile'
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>190
,p_display_value=>'Cile'
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>200
,p_display_value=>'Repubblica Ceca'
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>210
,p_display_value=>'Norvegia'
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>220
,p_display_value=>'Finlandia'
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>230
,p_display_value=>'Danimarca'
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>240
,p_display_value=>'Hong Kong'
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>250
,p_display_value=>'Irlanda'
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>260
,p_display_value=>'Lettonia'
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>270
,p_display_value=>'Romania'
,p_return_value=>'RO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>280
,p_display_value=>'Colombia'
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>290
,p_display_value=>'Polonia'
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>300
,p_display_value=>'Emirati Arabi Uniti'
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>310
,p_display_value=>'Ungheria'
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>320
,p_display_value=>'Arabia Saudita'
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4415)
,p_display_sequence=>330
,p_display_value=>'Sudafrica'
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>'Elemento indirizzo'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'<p>Scegliere l''elemento contenente le parti dell''indirizzo non strutturate, separate da virgole.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>'Elemento via'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Scegliere l''elemento contenente la parte dell''indirizzo <em>Via</em>.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>'Elemento numero civico'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Scegliere l''elemento contenente la parte dell''indirizzo <em>Numero civico</em>.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>unistr('Elemento area secondaria citt\00E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Scegliere l''elemento contenente la parte dell''indirizzo <em>Area secondaria (in una citt\00E0)</em>.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>unistr('Elemento citt\00E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Scegliere l''elemento contenente la parte dell''indirizzo <em>Citt\00E0</em>.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Elemento codice postale'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Scegliere l''elemento contenente la parte dell''indirizzo <em>Codice postale</em>.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>'Elemento area'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Scegliere l''elemento contenente la parte dell''indirizzo <em>Regione (Stato)</em>.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Correggi indirizzo'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Abilitare questa opzione per restituire agli elementi mappati i dati dell''indirizzo forniti dal servizio di codifica geografica.</p>'
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>'Corrispondenza elemento vettoriale'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Scegliere un elemento della pagina in cui il sistema di codifica geografica restituisce il <em>vettore di corrispondenza</em>. Il vettore di corrispondenza \00E8 una stringa composta da 17 cifre contenente informazioni dettagliate sul modo in cui cias')
||unistr('cun attributo dell''indirizzo \00E8 stato confrontato con i dati utilizzati per la codifica geografica.</p>'),
'<p><strong>Le cifre che compongono il vettore di corrispondenza possono essere le seguenti:</strong></p>',
'<ul>',
unistr('<li><p>0: l''attributo di input non \00E8 nullo e viene abbinato a un valore non nullo.</p></li>'),
unistr('<li><p>1: l''attributo di input \00E8 nullo e viene abbinato a un valore nullo.</p></li>'),
unistr('<li><p>2: l''attributo di input non \00E8 nullo e viene sostituito da un valore non nullo diverso.</p></li>'),
unistr('<li><p>3: l''attributo di input non \00E8 nullo e viene sostituito da un valore nullo.</p></li>'),
unistr('<li><p>4: l''attributo di input \00E8 nullo e viene sostituito da un valore non nullo.</p></li>'),
'</ul>',
'<br>',
'<p><strong>Di seguito sono riportate le cifre che costituiscono il vettore di corrispondenza e l''attributo dell''indirizzo corrispondente a ciascuna cifra:</strong></p>',
'<ul>',
'<li><p>3: coordinata dell''indirizzo (l''indirizzo esatto abbinato ai dati utilizzati per la codifica geografica)</p></li>',
'<li><p>4: nome del punto di interesse</p></li>',
'<li><p>5: numero civico</p></li>',
'<li><p>6: prefisso della via</p></li>',
'<li><p>7: nome della via</p></li>',
'<li><p>8: suffisso della via</p></li>',
'<li><p>9: tipo di via</p></li>',
unistr('<li><p>10: unit\00E0 secondaria</p></li>'),
unistr('<li><p>11: citt\00E0</p></li>'),
'<li><p>14: regione</p></li>',
'<li><p>15: paese</p></li>',
'<li><p>16: codice postale</p></li>',
'<li><p>17: codice postale aggiuntivo</p></li>',
'<li><p><em>Le altre cifre non vengono ancora utilizzate.</em></p></li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Attiva codifica geografica'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Determinare quando attivare la codifica geografica. Ad esempio, quando nel browser viene eseguita la richiesta REST per il servizio di codifica geografica e viene visualizzata la finestra popup con le corrispondenze possibili.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4415)
,p_display_sequence=>10
,p_display_value=>'Automatico'
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>La codifica geografica viene attivata automaticamente prima che la pagina venga sottomessa.</p>',
unistr('<p>Se il valore di un elemento dipendente \00E8 cambiato, come ad esempio il valore di <em>P1_STREET</em> e la codifica geografica non \00E8 stata eseguita fino a quel momento o non \00E8 stato selezionato un indirizzo valido, ci assicuriamo che la codifica geog')
||'rafica venga attivata automaticamente. In questo caso interrompiamo il flusso di sottomissione della pagina corrente e mostriamo prima una finestra popup con le possibili corrispondenze. Se l''utente ha scelto un risultato corrispondente, la pagina pu'
||unistr('\00F2 essere nuovamente sottomessa senza ulteriori interruzioni.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4415)
,p_display_sequence=>20
,p_display_value=>'Azione dinamica'
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>'<p>La codifica geografica deve essere attivata aggiungendo l''azione dinamica <em>Attiva codifica geografica</em> alla pagina.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4415)
,p_display_sequence=>30
,p_display_value=>'Selettore jQuery'
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>'<p>La codifica geografica viene attivata in base a un evento sull''elemento DOM interessato dal selettore. Se viene fatto riferimento a un campo di input, la codifica geografica viene attivata quando viene <em>modificato</em> l''elemento. Se viene fatt'
||'o riferimento a un pulsante, la codifica geografica viene attivata <em>quando si seleziona il pulsante</em>.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Selettore'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Eseguire il processo se gli elementi <em>P1_STREET</em> e <em>P1_ZIP_CODE</em> vengono modificai, selettore jQuery:</p>',
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>'<p>Fornire il selettore jQuery che fa riferimento all''elemento che attiva la codifica geografica. I pulsanti attiveranno la codifica geografica <em>quando vengono selezionati</em>, mentre gli altri elementi la attiveranno <em>quando vengono modificat'
||'e le impostazioni</em>.</p>'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_name=>'apexgeocoderresponse'
,p_display_name=>'Risposta codifica geografica'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.4415)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4415)
,p_name=>'apexgeocoderselection'
,p_display_name=>'Selezione risultati'
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>'Filtri intelligenti'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'<p>Area basata sull''origine di filtri intelligenti associati che fornisce agli utenti finali numerosi filtri da utilizzare per limitare i risultati della ricerca in runtime. </p>'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.4415)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Numero massimo di chip di suggerimento'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('Specificare il numero massimo di chip di suggerimento da visualizzare. Se non viene specificato alcun valore, verr\00E0 usato il valore predefinito pari a 5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.4415)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Altri chip di suggerimento filtri'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specificare se i filtri che non sono visualizzati come chip di suggerimento possono essere selezionati tramite il pulsante del menu a discesa Altri filtri'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.4415)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Soglia numeri compatti'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Fornire il valore soglia al di sopra del quale i conteggi vengono visualizzati con un formato numerico compatto. Con tale formato, il valore <strong>1.234</strong> verr\00E0 visualizzato come <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.4415)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostra conteggio righe totali'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare dove visualizzare il conteggio righe totali.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4415)
,p_display_sequence=>10
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'Il conteggio righe totali non viene visualizzato.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4415)
,p_display_sequence=>20
,p_display_value=>unistr('S\00EC')
,p_return_value=>'Y'
,p_help_text=>'Il conteggio righe totali viene visualizzato sotto i chip di suggerimento.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4415)
,p_display_sequence=>30
,p_display_value=>'Selettore'
,p_return_value=>'E'
,p_help_text=>unistr('Il conteggio righe totali (senza alcuna etichetta) viene visualizzato all''interno dell''elemento specificato da questo selettore. Ci\00F2 consente di posizionare il conteggio righe totali praticamente ovunque nella pagina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.4415)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Etichetta conteggio righe totali'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Etichetta da utilizzare per il conteggio righe totali. Se non viene fornita alcuna etichetta qui, APEX utilizzer\00E0 il messaggio di testo APEX.FS.TOTAL_ROW_COUNT_LABEL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.4415)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Selettore conteggio righe totali'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Questo \00E8 il selettore di un elemento della pagina in cui l''area Filtri intelligenti visualizzer\00E0 il conteggio delle righe totali.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.4415)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4415)
,p_name=>'facetschange'
,p_display_name=>'Modifica filtri'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.4415)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.4415)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.4415)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.4415)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Restituisce JSON ORDS precedente'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Abilitare questa opzione, se il servizio REST ORDS restituisce i dati nella <em>rappresentazione JSON precedente di ORDS</em>.'
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>'Cerca'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza un campo di testo per consentire all''utente finale di eseguire ricerche nelle voci di lista dei facet nell''area Ricerca con facet. Un''area Ricerca con facet supporta un solo facet Ricerca, che si trover\00E0 sempre all''inizio della lista dei f')
||'acet indipendentemente dalla relativa sequenza.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.4415)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo di ricerca'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4415)
,p_display_sequence=>10
,p_display_value=>'Ricerca righe'
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4415)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.4415)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Campo di input'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4415)
,p_display_sequence=>10
,p_display_value=>'Parte superiore dell''area Ricerca con facet'
,p_return_value=>'FACET'
,p_help_text=>unistr('Verr\00E0 visualizzato un campo di ricerca nella parte superiore dell''area Ricerca con facet, al di sopra dei facet.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4415)
,p_display_sequence=>20
,p_display_value=>'Elemento pagina esterno'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('Utilizzando l''attributo Elemento pagina esterno, \00E8 possibile selezionare un elemento pagina da utilizzare come campo di ricerca per l''area Ricerca con facet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.4415)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento pagina esterno'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.4415)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Campo di ricerca compresso'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se il campo di ricerca dei filtri avanzati \00E8 inizialmente compresso.')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>'Mappa'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.4415)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4415)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.4415)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4415)
,p_name=>'spatialmapchanged'
,p_display_name=>'Mappa modificata'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.4415)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4415)
,p_name=>'spatialmapclick'
,p_display_name=>unistr('Mappa su cui \00E8 stato fatto clic')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.4415)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4415)
,p_name=>'spatialmapinitialized'
,p_display_name=>'Mappa inizializzata'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.4415)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4415)
,p_name=>'spatialmapobjectclick'
,p_display_name=>unistr('Oggetto mappa su cui \00E8 stato fatto clic')
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>'Form'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Area di form che supporta origini dati diverse. L''area di form contiene informazioni sull''origine dati (che pu\00F2 essere locale, remota o il servizio REST) e dispone di elementi di pagina assegnati. Ogni elemento viene assegnato a un''area di form e a u')
||'n''area di visualizzazione.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.4415)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.4415)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>'Form - Elaborazione automatica delle righe (DML)'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processo per l''inserimento, l''aggiornamento o l''eliminazione di una o pi\00F9 righe di un''area di form.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.4415)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo di destinazione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare la tecnica di elaborazione delle righe da eseguire per salvare le modifiche apportate all''area di form.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4415)
,p_display_sequence=>10
,p_display_value=>'Origine area'
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gli inserimenti, gli aggiornamenti e le eliminazioni utilizzano la query SQL dell''origine area.</p>',
unistr('<p>Nota: assicurarsi che l''opzione <strong>Solo query</strong> sia impostata su <code>S\00EC</code> per le colonne su cui non \00E8 possibile eseguire inserimenti o aggiornamenti in modo da escluderle dall''elaborazione.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4415)
,p_display_sequence=>20
,p_display_value=>'Tabella/vista'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gli inserimenti, gli aggiornamenti e le eliminazioni utilizzano una tabella o una vista diversa da quella definita nella query SQL dell''origine area.',
'Ad esempio, la query SQL recupera i dati da una vista table-join o non aggiornabile e l''elaborazione DML deve essere eseguita rispetto a una tabella di base o a una vista aggiornabile singola.</p>',
unistr('<p>Nota: assicurarsi che l''opzione <strong>Solo query</strong> sia impostata su <code>S\00EC</code> per le colonne su cui non \00E8 possibile eseguire inserimenti o aggiornamenti in modo da escluderle dall''elaborazione.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4415)
,p_display_sequence=>30
,p_display_value=>'Codice PL/SQL'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''elaborazione \00E8 basata su codice PL/SQL personalizzato. Questa opzione consente di eseguire qualsiasi codice PL/SQL per implementare la manipolazione dei dati nel database di base.</p>'),
'<p>Questa opzione deve essere utilizzata quando si usano i package di database, ad esempio le interfacce API di tabella o le chiamate ai Web Service RESTful, per implementare la business logic.</p>',
unistr('<p>Nota: il codice PL/SQL verr\00E0 richiamato per ogni riga inserita, aggiornata o eliminata.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.4415)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Proprietario tabella'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Selezionare il nome del proprietario (schema) della tabella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.4415)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome tabella'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.4415)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Immettere un nome tabella o vista con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.4415)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Codice PL/SQL per inserimento/aggiornamento/eliminazione'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice PL/SQL per elaborare ogni riga dei dati manipolati nell''area di form.</p>',
unistr('<p>Usare il nome della colonna come bind variable per accedere al valore di una colonna. La variabile di sistema <code>APEX$ROW_STATUS</code> restituisce lo stato di una riga e pu\00F2 essere utilizzata per verificare se la riga \00E8 stata creata, aggiornat')
||'a o eliminata (vedere l''esempio riportato di seguito per istruzioni su come effettuare la verifica).</p>',
unistr('<p><em>Nota:</em> se le colonne chiave primaria vengono popolate da un trigger o nel codice PL/SQL, \00E8 obbligatorio assegnare i nuovi valori alle bind variable delle colonne chiave primaria, poich\00E9 &PRODUCT_NAME. utilizza tali valori per recuperare la')
||' riga tramite fetch dopo un inserimento o un aggiornamento.</p>',
unistr('<p>Oracle consiglia di chiamare le procedure o le funzioni dall''interno di un package PL/SQL per facilitare il riutilizzo e le capacit\00E0 di gestione.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.4415)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Impedisci aggiornamenti persi'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specifica se l''elaborazione deve garantire che gli aggiornamenti non vadano persi quando pi\00F9 utenti aggiornano lo stesso record di database.</p> '),
unistr('<p>La perdita degli aggiornamenti si verifica quando due o pi\00F9 persone tentano di aggiornare gli stessi dati e l''ultimo aggiornamento sovrascrive gli aggiornamenti effettuati dal primo utente che ha salvato le modifiche. Per evitare che ci\00F2 succeda, ')
||unistr('durante gli aggiornamenti \00E8 possibile controllare i valori di colonna esistenti nel database rispetto ai valori recuperati al momento dell''esecuzione della query originale sulla riga.</p>'),
'<p>Ad esempio:',
'  <ol>',
'    <li>L''Utente A esegue una query sui record dei dipendenti (EMP).</li>',
'    <li>L''Utente B esegue una query sugli stessi record dei dipendenti.</li>',
'    <li>L''Utente B aggiorna i dettagli dipendente per EMPNO = 7839 e applica le modifiche, ovvero ne esegue il commit nel database.</li>',
'    <li>L''Utente A aggiorna i dettagli dipendente per EMPNO = 7839 e tenta di applicare le modifiche nel database.</li>',
'  </ol>',
'Se l''aggiornamento della stessa riga da parte dell''Utente A riesce, le modifiche apportate dall''Utente B andranno perdute.',
'Quando l''Utente A tenta di salvare la riga del dipendente, i dati nel database sono diversi da quelli su cui l''Utente A ha eseguito la query originale. Nel Passo 1 della procedura precedente, i valori di colonna su cui l''Utente A ha eseguito la query'
||unistr(' originale possono essere acquisiti. Nel Passo 4 i valori possono essere confrontati con i valori correnti nel database. Il confronto restituir\00E0 un errore per l''Utente A in quanto i valori del database sono stati aggiornati dall''Utente B nel Passo 3.')
||unistr(' Ci\00F2 impedisce che un utente sovrascriva le modifiche apportate da un altro utente alla stessa riga.</p>'),
unistr('<p>Nota: le modalit\00E0 di rilevamento degli aggiornamenti persi \00E8 specificata negli attributi per l''area della griglia interattiva in base all''impostazione per <strong>Tipo aggiornamento perso</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.4415)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Blocca riga'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Specificare se ogni riga da aggiornare o eliminare deve essere bloccata nella tabella di base prima dell''elaborazione.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4415)
,p_display_sequence=>10
,p_display_value=>unistr('S\00EC')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le righe da aggiornare o eliminare verranno bloccate con SELECT ... FOR UPDATE per impedire l''esecuzione di altre transazioni sulla riga finch\00E9 non sar\00E0 stato eseguito il commit della transazione.</p>'),
unistr('<p>Nota: se viene restituito un errore, ad esempio per le viste aggiornabili che non supportano il blocco, sar\00E0 possibile utilizzare codice PL/SQL per bloccare la tabella di controllo.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4415)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'Le righe non verranno bloccate.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4415)
,p_display_sequence=>30
,p_display_value=>'Codice PL/SQL'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('Verr\00E0 utilizzato il codice PL/SQL personalizzato per bloccare le righe finch\00E9 non sar\00E0 stato eseguito il commit della transazione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.4415)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Codice PL/SQL per il blocco delle righe'
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>'Immettere il codice PL/SQL per bloccare le righe della tabella del database da aggiornare ed eliminare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.4415)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Restituisci chiavi primarie dopo l''inserimento'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se le colonne chiave primaria devono essere restituite agli elementi dell''area corrispondenti dopo l''inserimento della riga nel database.',
unistr('In genere questa opzione deve essere usata quando i dati delle colonne chiave primaria vengono inseriti da un trigger di database o da una colonna identit\00E0 di Oracle Database 12 <em>c</em>.</p>'),
unistr('<p>Nota: se viene visualizzato un messaggio di errore che specifica che la clausola RETURNING INTO non \00E8 consentita, impostare questa opzione su No e inserire preventivamente i dati nelle colonne chiave primaria.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>'Form - Inizializzazione'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processo per l''inizializzazione degli elementi dell''area di form. L''inizializzazione pu\00F2 prevedere il recupero dei dati dall''origine dell''area, utilizzando uno o pi\00F9 valori di chiave primaria, oppure la semplice inizializzazione degli elementi dell''a')
||'rea di form.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.4415)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento/i chiave primaria successiva'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.4415)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Elemento/i chiave primaria precedente'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.4415)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento riga/totale corrente'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>'Caricamento dati'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Processo per caricare i dati nella tabella o raccolta di destinazione in base alla definizione di caricamento dati specificata.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.4415)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Definizione caricamento dati'
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Selezionare <strong>Definizione caricamento dati</strong> da Componenti condivisi. Tra gli altri attributi, la definizione di caricamento dati definisce la tabella o la raccolta di destinazione e il <em>Profilo dati</em>. Tutte le informazioni su nom'
||'i di colonna, mapping di colonne e tipo di dati vengono memorizzate nel profilo dati.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.4415)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Tipo di dati di origine'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare l''origine dei dati da caricare.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4415)
,p_display_sequence=>10
,p_display_value=>'Elemento Sfoglia file'
,p_return_value=>'FILE'
,p_help_text=>unistr('Selezionare il nome di un elemento Sfoglia file nella pagina corrente. APEX caricher\00E0 i dati dal file scelto.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4415)
,p_display_sequence=>20
,p_display_value=>'Nome elemento area di testo'
,p_return_value=>'TEXT'
,p_help_text=>'Selezionare il nome di un elemento area di testo che contiene i dati da caricare.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4415)
,p_display_sequence=>30
,p_display_value=>'Query SQL'
,p_return_value=>'SQL_QUERY'
,p_help_text=>'Fornire una query SQL che restituisca un CLOB o un BLOB contenente i dati da caricare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.4415)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento Sfoglia file'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>'Selezionare l''elemento Sfoglia file da cui caricare i dati. L''elemento deve usare <strong>APEX_APPLICATION_TEMP_FILES</strong> come proprio <strong>tipo di memoria</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.4415)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Elemento area di testo'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>'Selezionare il nome di un elemento area di testo che contiene i dati da caricare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.4415)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Query SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>'Fornire una query SQL che restituisce una riga e una colonna, contenente un BLOB o CLOB da cui caricare i dati.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.4415)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Elemento di pagina che contiene il nome del foglio XLSX'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una lista di selezione o un elemento LOV popup per visualizzare i fogli di lavoro disponibili nel file XLSX caricato utilizzer\00E0 la seguente <em>lista di valori Query SQL</em> (<strong>PX_FILE</strong> \00E8 l''elemento Sfoglia file usato per caricare i')
||unistr('l file XLSX).</p><p>Tenere presente che \00E8 necessario usare l''attributo <strong>SHEET_FILE_NAME</strong> come colonna restituita LOV.</p>'),
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>Fornire un elemento di pagina contenente un nome di foglio di lavoro per il caricamento dei file XLSX. I dati verranno caricati dal foglio di lavoro specificato. Se non fornito, APEX caricher\00E0 i dati dal primo foglio di lavoro nel file XLSX. </p><')
||'p>In genere, vengono usati gli elementi <em>lista di selezione</em> per questo motivo: nella <em>query Lista di valori</em>, usare <strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong> per recuperare la visualizzazione del foglio di lavoro e i nomi i'
||'nterni.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.4415)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Elemento conteggio righe elaborate'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('Selezionare un elemento di pagina in cui memorizzare la quantit\00E0 di righe caricate ed elaborate. Il valore \00E8 disponibile al termine del processo di caricamento dei dati e pu\00F2 essere utilizzato per la visualizzazione nei messaggi.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.4415)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Elemento conteggio righe errore'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('Selezionare un elemento di pagina in cui memorizzare la quantit\00E0 di righe di errore. Il valore \00E8 disponibile al termine del processo di caricamento dei dati e pu\00F2 essere utilizzato per la visualizzazione nei messaggi.')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>'Intervallo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Visualizza un elemento con un selettore lista di valori incorporato. Il facet supporta la selezione singola o multipla e l''immissione manuale. A supporto della selezione singola, visualizza pi\00F9 valori sotto forma di opzioni di gruppo di scelta, co')
||unistr('nsentendo all''utente finale di selezionare un solo valore. A supporto della selezione multipla, visualizza pi\00F9 valori sotto forma di caselle di controllo, consentendo all''utente finale di selezionare pi\00F9 valori. A supporto dell''immissione manuale, so')
||unistr('tto il facet vengono visualizzati campi di testo e l''utente finale pu\00F2 immettere manualmente l''intervallo di valori che desidera utilizzare per applicare i filtri all''area filtrata.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.4415)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Seleziona pi\00F9 file')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se il facet supporta la selezione di pi\00F9 voci di lista. Quando l''impostazione \00E8 <strong>Attivo</strong>, il facet viene visualizzato sotto forma di caselle di controllo in modo da supportare la selezione multipla. Quando l''impostazione \00E8 ')
||'<strong>Non attivo</strong>, il facet viene visualizzato sotto forma di opzioni di gruppo di scelta per supportare la selezione singola.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.4415)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Immissione manuale'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se il facet Intervallo supporta l''immissione manuale. Quando l''impostazione \00E8 <strong>Attivo</strong>, sotto il facet vengono visualizzati campi di testo e l''utente finale pu\00F2 immettere manualmente l''intervallo di valori che desidera util')
||'izzare per applicare i filtri all''area filtrata.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.4415)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Testo intervallo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Immettere il testo da visualizzare tra i campi di testo di Immissione manuale.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.4415)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Etichetta corrente'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Tra 0% e %1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.4415)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Massimo apertura etichetta corrente'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Al di sopra di %0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.4415)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Minimo apertura etichetta corrente'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Al di sotto di %0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.4415)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4415)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista di valori basata su query SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>Lista di valori con lo stesso valore visualizzato e restituito</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Nota: si seleziona la stessa colonna sia per il valore visualizzato che per quello restituito, utilizzare un alias di colonna.</p>',
'</dd>',
'<dt>Lista di valori con bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: impostare l''attributo <em>Elementi padre LOV a catena</em> su <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> \00E8 un elemento di pagina modificabile della stessa pagina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>'Visualizza mappa'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza una mappa basata su coordinate nel formato punti GeoJSON.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.4415)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Sfondo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare la mappa di sfondo da usare.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4415)
,p_display_sequence=>10
,p_display_value=>'Valore predefinito'
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilizzare lo sfondo predefinito della mappa.</p>',
'<p>Per i temi scuri viene utilizzato "OpenStreetMap Bright" o "OpenStreetMap Dark".</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4415)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap brillante'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base generica basata sui dati OpenStreetMap. Questo stile di mappa base fornisce un contesto di posizione dettagliato per i dati.</p>',
'<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4415)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap scura'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base scura non invadente basata sui dati OpenStreetMap. Questo stile di mappa base accentua le visualizzazioni dei dati.</p>',
unistr('<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY. La cartografia di Stamen Design \00E8 concessa in licenza in base a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4415)
,p_display_sequence=>40
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base chiara non invadente basata sui dati OpenStreetMap. Questo stile di mappa base accentua le visualizzazioni dei dati.</p>',
unistr('<p>Schema e definizioni di stile dei collaboratori KlokanTech.com e OpenMapTiles, derivanti da "Mapbox Open Styles". Concessione in licenza in base alla licenza BSD/CC-BY. La cartografia di Stamen Design \00E8 concessa in licenza in base a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Visualizza su GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4415)
,p_display_sequence=>50
,p_display_value=>'Mappa del mondo Oracle'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Mappa base generica basata sui dati mappa HERE. Questo stile di mappa base fornisce il contesto di posizione dei dati e ne accentua la visualizzazione.</p>',
'<p>Schema e definizioni di stile di Oracle, Stati Uniti.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.4415)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Livello di zoom'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare il livello di zoom minimo per rendere visibile questo layer.</p>',
'<p>',
'Valore minimo: 1<br>',
'Valore massimo: 18',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.4415)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Mostra indicatore'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'<p>Specificare se deve essere visualizzato un indicatore.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.4415)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Colore indicatore'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare il colore di riempimento dell''indicatore.</p>',
unistr('<p>Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML. La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), ')
||'dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.4415)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Descrizione comandi'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare il testo della descrizione comando per un indicatore visualizzato.</p>',
'<p>L''attributo descrizione comando supporta le direttive per i modelli HTML e APEX.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.4415)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Mostra controlli mappa'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se devono essere visualizzati i controlli della mappa.</p>',
'<p>Questa opzione aggiunge i controlli di zoom e di rotazione alla mappa.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.4415)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Mappa interattiva'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se la mappa deve essere interattiva.</p>',
unistr('<p>Se questa opzione \00E8 impostata su "No", viene creata una mappa statica senza interattivit\00E0.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.4415)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Altezza'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'pixel'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare l''altezza (in pixel) della mappa visualizzata.</p>',
'<p>L''altezza predefinita della mappa viene calcolata in base alla larghezza con una simmetria pari a 3:2.</p>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>'Query SQL - Esiste'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Query che comporta l''accettazione dello schema di autorizzazione se restituisce almeno una riga e il rifiuto dello schema di autorizzazione se non restituisce alcuna riga.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.4415)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Query SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>'Query che comporta l''accettazione dello schema di autorizzazione se restituisce almeno una riga e il rifiuto dello schema di autorizzazione se non restituisce alcuna riga.'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>'Query SQL - Non esiste'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Query che comporta l''accettazione dello schema di autorizzazione se non restituisce alcuna riga e il rifiuto dello schema di autorizzazione se restituisce una o pi\00F9 righe.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.4415)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Query SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>'Query che comporta il rifiuto dello schema di autorizzazione se restituisce almeno una riga e l''accettazione dello schema di autorizzazione se non restituisce alcuna riga.'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>unistr('L''elemento \00E8 NULL')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Il valore dell''elemento \00E8 nullo.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.4415)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('L''autorizzazione viene accettata se il valore di questo elemento \00E8 nullo; in caso contrario non viene accettata.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>unistr('L''elemento \00E8 NOT NULL')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Il valore dell''elemento non \00E8 nullo.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.4415)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorizzazione viene accettata se il valore di questo elemento non \00E8 nullo; in caso contrario non viene accettata.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>'Funzione PL/SQL che restituisce un risultato booleano'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Corpo funzione PL/SQL che restituisce true o false. Lo schema di autorizzazione non viene accettato se il valore restituito \00E8 false e viene accettato se il valore restituito \00E8 true.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.4415)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Corpo funzione PL/SQL'
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Corpo funzione PL/SQL che restituisce True o False. Lo schema di autorizzazione non viene accettato se il valore restituito \00E8 Falso e viene accettato se il valore restituito \00E8 True.'),
'<p/>',
'Esempio:',
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>'Preferenza uguale al valore'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Il valore della preferenza \00E8 uguale al valore.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.4415)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome preferenza'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorizzazione viene accettata se il valore della preferenza \00E8 uguale al valore presente nel campo sotto e non viene accettata se i valori sono diversi')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.4415)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'vedere sopra'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>'Preferenza NON uguale al valore'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Il valore della preferenza non \00E8 uguale al valore.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.4415)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome preferenza'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorizzazione viene accettata se il valore della preferenza \00E8 diverso dal valore presente nel campo sotto e non viene accettata se i valori sono uguali')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.4415)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'vedere sopra'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>'Elemento uguale al valore'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Il valore dell''elemento \00E8 uguale al valore.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.4415)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorizzazione viene accettata se il valore dell''elemento \00E8 uguale al valore presente nel campo sotto e non viene accettata se i valori sono diversi')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.4415)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'vedere sopra'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>'Elemento NON uguale al valore'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Il valore dell''elemento non \00E8 uguale al valore.</p>'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.4415)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorizzazione viene accettata se il valore dell''elemento \00E8 diverso dal valore presente nel campo sotto e non viene accettata se i valori sono uguali')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.4415)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'vedere sopra'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>'Attiva codifica geografica'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Attivare manualmente la ricerca con codifica geografica di un elemento <em>Indirizzo con codifica geografica</em>.</p>'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>'Social Sign-In'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Supporta l''autenticazione con i provider di identit\00E0 Google, Facebook, OpenID Connect generici e OAuth2 generici.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Area memorizzazione credenziali'
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Selezionare l''area di memorizzazione delle credenziali che contiene l''ID e il segreto del client per il provider di autenticazione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Provider di autenticazione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_display_sequence=>10
,p_display_value=>'Provider OpenID Connect'
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>unistr('Usare un provider di autenticazione basato su OpenID Connect. \00C8 necessario immettere di seguito l''URL di ricerca automatica OpenID del provider.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_display_sequence=>20
,p_display_value=>'Provider OAuth2 generico'
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('Usare un provider di autenticazione OAuth2. \00C8 necessario immettere di seguito gli URL per gli endpoint di autorizzazione, token e informazioni utente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>'Usare impostazioni predefinite per il login a Google.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>'Usare impostazioni predefinite per il login a Facebook.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL ricerca automatica'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Immettere l''URL di ricerca automatica del provider OpenID Connect.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'URL endpoint autorizzazione'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Immettere l''URL dell''endpoint di autorizzazione del provider OAuth2.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'URL endpoint token'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Immettere l''URL dell''endpoint token del provider OAuth2.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'URL endpoint informazioni utente'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Immettere l''URL dell''endpoint delle informazioni utente del provider OAuth2.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Ambito'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>'posta elettronica,profilo'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Immettere una lista separata da virgole delle autorizzazioni da richiedere per l''utente che sta eseguendo il login.',
'I valori accettabili dipendono dal provider di autenticazione.',
'Per OpenID Connect e Google, Application Express aggiunge automaticamente l''ambito "openid".',
'Il provider di autenticazione restituisce gli attributi utente in base a queste autorizzazioni.',
unistr('\00C8 possibile mappare gli attributi agli elementi di applicazione oppure usare una procedura di post-autenticazione per elaborarli utilizzando le funzioni APEX_JSON.GET_%.'),
'</p><p>',
'Gli ambiti e gli attributi di OpenID Connect, definiti anche richieste, sono elencati a questo indirizzo: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Parametri URI autenticazione'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>'Immettere i parametri facoltativi per l''URI di autenticazione. Consultare la documentazione del provider di autenticazione per conoscere i parametri supportati.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Nome utente'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Immettere l''attributo che contiene il nome utente oppure testo libero con una o pi\00F9 sostituzioni di attributo racchiuse tra "#".'),
unistr('\00C8 possibile fare riferimento al nome dello schema di autenticazione con #APEX_AUTH_NAME#.'),
'Ad esempio, "#email# (#APEX_AUTH_NAME#)" restituisce un nome utente costituito dall''indirizzo di posta elettronica seguito da "(", seguito dal nome dello schema di autenticazione, seguito da ")", come in "jane.doe@example.com (Google)".',
'</p><p>',
'Per conoscere gli attributi supportati, consultare la documentazione del provider di autenticazione.',
unistr('Tenere presente che \00E8 necessario impostare l''ambito richiesto, altrimenti il provider di autenticazione non invier\00E0 tutti gli attributi.'),
'Gli ambiti e gli attributi di OpenID Connect, definiti anche richieste, sono elencati a questo indirizzo: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Attributi utente aggiuntivi'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'collegamento,immagine,posta elettronica'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Immettere una lista separata da virgole degli attributi dati utente aggiuntivi.',
'</p><p>',
'Per conoscere gli attributi supportati, consultare la documentazione del provider di autenticazione.',
unistr('Tenere presente che \00E8 necessario impostare l''ambito richiesto, altrimenti il provider di autenticazione non invier\00E0 tutti gli attributi.'),
'Gli ambiti e gli attributi di OpenID Connect, definiti anche richieste, sono elencati a questo indirizzo: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>'Converti nome utente in lettere maiuscole'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specificare se i valori di attributo per il nome utente devono essere convertiti in maiuscolo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Metodo di autenticazione token'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Immettere il modo in cui l''ID client e il segreto client della credenziale devono essere passati al server.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4415)
,p_display_sequence=>10
,p_display_value=>'Autenticazione di base'
,p_return_value=>'BASIC'
,p_help_text=>'Invia l''ID client e il segreto client in un''intestazione di autenticazione di base.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4415)
,p_display_sequence=>22
,p_display_value=>'Autenticazione di base e ID client nel corpo'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Invia l''ID client e il segreto client in un''intestazione di autenticazione di base, ma invia l''ID client anche nel corpo della richiesta.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4415)
,p_display_sequence=>30
,p_display_value=>'ID client e segreto client nel corpo'
,p_return_value=>'BODY'
,p_help_text=>'Invia l''ID client e il segreto client nel corpo della richiesta.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4415)
,p_display_sequence=>40
,p_display_value=>'ID client nel corpo'
,p_return_value=>'CLID'
,p_help_text=>'Invia l''ID client solo nel corpo della richiesta.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>'Verifica attributi'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Se l''opzione \00E8 abilitata, &PRODUCT_NAME. cercher\00E0 un attributo "#name#_verified", ad esempio "email_verified" per l''attributo "email". '),
unistr('OpenID imposta che il provider di identit\00E0 invii <code>"#name#_verified":false</code> per gli attributi "email" e "phone_number" non verificati.'),
'&PRODUCT_NAME. ignora questo tipo di attributi non verificati.',
unistr('In questo caso, si verificher\00E0 un''autenticazione non riuscita se "#name#" \00E8 l''attributo nome utente.'),
'</p><p>',
unistr('Se il provider di identit\00E0 consente a utenti non autorizzati di immettere dati non verificati usati dall''applicazione per l''autenticazione,'),
'questi potrebbero rappresentare altri utenti nell''applicazione.',
unistr('Il controllo "Verifica attributi" impedisce che ci\00F2 accada.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.4415)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>'Mappa attributi utente aggiuntivi a'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fornire una lista separata da virgole dei nomi degli elementi di applicazione ai quali sono mappati gli <em>Attributi utente aggiuntivi</em>. Ad esempio, se si imposta',
'<ul>',
'<li>Attributi utente aggiuntivi: email,profile,picture</li>',
'<li>Mappa attributi utente aggiuntivi a: G_EMAIL,G_PROFILE,G_PICTURE</li>',
'</ul>',
unistr('APEX salver\00E0 automaticamente i valori degli attributi nello stato della sessione per gli elementi corrispondenti.')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>'Vista lista'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizzare i dati in una lista di facile navigazione. \00C8 inoltre possibile incorporare numerose funzioni per migliorare la vista lista.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Funzioni'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare le funzioni abilitate per questa lista vista.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_display_sequence=>5
,p_display_value=>'Formattazione avanzata'
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_display_sequence=>10
,p_display_value=>'Mostra immagine'
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_display_sequence=>20
,p_display_value=>'Mostra divisore lista'
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_display_sequence=>50
,p_display_value=>'Con pulsante divisione'
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_display_sequence=>55
,p_display_value=>'Abilita ricerca'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_display_sequence=>65
,p_display_value=>'Vista lista nidificata'
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_display_sequence=>70
,p_display_value=>'Lista bassorilievi'
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Colonna di testo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>'Selezionare la colonna di database con il contenuto principale per la voce della vista lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Attributi lista'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Il client crea i divisori in base al testo dell''elemento di lista</dt>',
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
'<dt>Modifica dell''icona</dt>',
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
'<dt>Modifica dell''icona del pulsante Dividi</dt>',
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>'Immettere gli attributi aggiuntivi da impostare nell''elemento lista. Vedere gli esempi per alcuni attributi che hanno effetto sulla vista lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Attributi voci lista'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Impostazione dell''icona di collegamento delle voci di lista da eliminare.</dt>',
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>'Immettere gli attributi aggiuntivi da impostare nell''elemento di tipo elemento lista. Vedere gli esempi per alcuni attributi che hanno effetto sulla vista lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Formattazione testo'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione del nome e, di seguito, della data di assunzione di un dipendente</dt>',
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
'&lt;p&gt;Data assunzione: &amp;HIREDATE.&lt;/p&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il markup HTML per il rendering del contenuto principale per una voce di vista lista.',
'<p>Per fare riferimento ai valori di colonna dell''istruzione SQL della vista lista, usare la sintassi di sostituzione.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Colonna informazioni supplementari'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>'Selezionare la colonna di database che contiene le informazioni supplementari per la voce della vista lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Formattazione informazioni supplementari'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione dello stipendio in grassetto</dt>',
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il markup HTML per il rendering delle informazioni supplementari per una voce di vista lista.',
'<p>Per fare riferimento ai valori di colonna dell''istruzione SQL della vista lista, usare la sintassi di sostituzione.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Colonna contatore'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>'Selezionare la colonna di database che contiene il valore da visualizzare nella bolla di conteggio.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Tipo di immagine'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare il tipo e l''origine dell''immagine visualizzata. L''immagine visualizzata pu\00F2 essere un''icona con dimensioni 16x16 o un''anteprima con dimensioni 80x80. L''origine dell''immagine pu\00F2 essere una colonna BLOB del database o l''URL di un file stat')
||'ico.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4415)
,p_display_sequence=>20
,p_display_value=>'Icona memorizzata in BLOB'
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4415)
,p_display_sequence=>30
,p_display_value=>'Icona letta da URL'
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4415)
,p_display_sequence=>40
,p_display_value=>'Immagine memorizzata in BLOB'
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4415)
,p_display_sequence=>50
,p_display_value=>'Immagine letta da URL'
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Colonna BLOB immagine'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>'Selezionare la colonna di database del tipo di dati BLOB che contiene l''immagine.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Colonna 1 chiave primaria immagine'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>'Selezionare la colonna della chiave primaria o la colonna di database univoca utilizzata per cercare l''immagine.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Colonna 2 chiave primaria immagine'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Selezionare la seconda colonna della chiave primaria o la colonna di database univoca utilizzata per cercare l''immagine.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Colonna URL immagine'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>'Selezionare la colonna di database che contiene l''URL dell''icona o dell''immagine.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Colonna divisore lista'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>'Selezionare la colonna di database che contiene il divisore. A ogni modifica del valore del divisore, viene visualizzato un nuovo divisore tra le voci della vista lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Formattazione divisore lista'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione del nome del reparto e del numero di dipendenti come badge</dt>',
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il markup HTML per il rendering del divisore di una vista lista.',
'<p>Per fare riferimento ai valori di colonna dell''istruzione SQL della vista lista usare la sintassi di sostituzione.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Destinazione collegamento'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Immettere la pagina di destinazione da richiamare quando l''utente fa clic su una voce di lista.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>'Destinazione pulsante divisione'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Immettere la pagina di destinazione da richiamare quando l''utente fa clic su una voce di lista.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>'Tipo di ricerca'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la modalit\00E0 di esecuzione della ricerca.</p>'),
'<p>Una ricerca lato client viene eseguita immediatamente non appena l''utente inizia a digitare il testo. Per tutte le ricerche basate su server, l''utente deve fare clic su Invio per visualizzare i risultati della ricerca. Solo le ricerche basate su s'
||'erver prendono in considerazione gli attributi di globalizzazione Confronto valori dei caratteri definiti per l''applicazione.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4415)
,p_display_sequence=>20
,p_display_value=>'Lato client'
,p_return_value=>'CLIENT'
,p_help_text=>unistr('Per eseguire una ricerca basata sul browser, \00E8 necessario caricare nel browser tutte le voci della vista lista (tenere presente che l''attributo "Numero di righe recuperate" viene ignorato in questo caso). Usare questa opzione di ricerca solo per un n')
||'umero di voci di lista limitato, in modo da evitare caricamenti di pagina inutilmente lunghi.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4415)
,p_display_sequence=>30
,p_display_value=>'Server: esatto e maiuscole/minuscole'
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>'La funzione di ricerca utilizza LIKE [valore ricerca]% per eseguire la query sul risultato.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4415)
,p_display_sequence=>40
,p_display_value=>'Server: esatto e ignora maiuscole/minuscole'
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>'La funzione di ricerca utilizza LIKE UPPER [valore ricerca]% per eseguire la query sul risultato. Gli indici esistenti nella colonna non verranno utilizzati, a meno che non si tratti di indici basati su funzione che utilizzano un''espressione UPPER.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4415)
,p_display_sequence=>50
,p_display_value=>'Server: simile e maiuscole/minuscole'
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>unistr('La funzione di ricerca utilizza LIKE %[valore ricerca]% per eseguire la query sul risultato. Ci\00F2 impedir\00E0 l''uso di un indice esistente su tale colonna.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4415)
,p_display_sequence=>60
,p_display_value=>'Server: simile e ignora maiuscole/minuscole'
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>unistr('La funzione di ricerca utilizza LIKE %UPPER( [valore ricerca] )% per eseguire la query sul risultato. Ci\00F2 impedir\00E0 l''uso di un indice esistente su tale colonna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>'Colonna ricerca'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('Selezionare una colonna di database alternativa da utilizzare per la ricerca. Se non viene specificata alcuna colonna, verr\00E0 utilizzata la colonna di testo.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>'Segnaposto casella di ricerca'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('Immettere il testo visualizzato nella casella di ricerca. Se non viene specificato alcun valore, verr\00E0 usato il valore del messaggio di sistema <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>'Colonna lista nidificata'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>'Selezionare la colonna di database che contiene il livello di gerarchia di una query nidificata. Se si usa la query CONNECT BY, usare la pseudo colonna <code>LEVEL</code>.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.4415)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4415)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione di tutti i dipendenti ordinati per nome</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Visualizzazione di tutti i dipendenti del reparto corrente ordinati per nome</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
'<p>Quando si usano le bind variable per fare riferimento agli elementi di pagina, specificarle come <strong>Elementi pagina da sottomettere</strong>.</p>',
'</dd>',
'<dt>Uso di ROWID come colonna di chiave primaria</dt>',
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
unistr('<p>Quando si usa ROWID, \00E8 obbligatorio specificare un alias di colonna.</p>'),
'</dd>',
'<dt>Query nidificata che restituisce tutti i dipendenti</dt>',
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>'Chiudi area'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Chiude un''area, ad esempio una finestra di dialogo in linea, una finestra popup in linea o comprimibile, che supporta l''apertura ed \00E8 aperta.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>'Apri area'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Apre un''area, ad esempio una finestra di dialogo in linea, una finestra popup in linea o comprimibile, che supporta l''apertura.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>'In ruolo o gruppo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.4415)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome/i'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere uno o pi\00F9 nomi gruppo separati da virgole.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.4415)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4415)
,p_display_sequence=>10
,p_display_value=>'Ruolo applicazione'
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4415)
,p_display_sequence=>20
,p_display_value=>'Gruppo area di lavoro'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4415)
,p_display_sequence=>30
,p_display_value=>'Personalizzato'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.4415)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>'Non in ruolo o gruppo'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.4415)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome/i'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere uno o pi\00F9 nomi gruppo separati da virgole.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.4415)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4415)
,p_display_sequence=>10
,p_display_value=>'Ruolo applicazione'
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4415)
,p_display_sequence=>20
,p_display_value=>'Gruppo area di lavoro'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4415)
,p_display_sequence=>30
,p_display_value=>'Personalizzato'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>'Selettore data'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizza un campo di testo con un''icona calendario. Gli utenti finali possono immettere la data direttamente nell''elemento di testo oppure fare clic sull''icona calendario per selezionare una data, e se necessario un''ora, dal popup del calendario'
||'.</p>',
'<p>L''ora viene visualizzata nel popup del calendario solo se il <em>formato di visualizzazione</em> per questo elemento include i componenti di ora</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Aspetto'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Controlla l''aspetto del calendario utilizzato per selezionare le date.</p>',
unistr('<p>Nota: viene utilizzato solo quando ''Visualizza come'' \00E8 ''Popup'' o ''In linea''.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4415)
,p_display_sequence=>10
,p_display_value=>'Mostra settimana'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('Indica se la settimana dell''anno verr\00E0 mostrata.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4415)
,p_display_sequence=>20
,p_display_value=>'Selettore mese'
,p_return_value=>'MONTH-PICKER'
,p_help_text=>'Indica se il mese deve essere visualizzato come pulsante, non come testo, per consentire la selezione.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4415)
,p_display_sequence=>30
,p_display_value=>'Selettore anno'
,p_return_value=>'YEAR-PICKER'
,p_help_text=>'Indica se l''anno deve essere visualizzato come pulsante, non come testo, per consentire la selezione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Giorni al di fuori del mese'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indica il funzionamento dei giorni al di fuori del mese di visualizzazione corrente.</p>',
unistr('<p>Nota: viene utilizzato solo quando ''Visualizza come'' \00E8 ''Popup'' o ''In linea''.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4415)
,p_display_sequence=>10
,p_display_value=>'Nascosto'
,p_return_value=>'HIDDEN'
,p_help_text=>'I giorni al di fuori del mese di visualizzazione corrente verranno nascosti.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4415)
,p_display_sequence=>20
,p_display_value=>'Selezionabile'
,p_return_value=>'SELECTABLE'
,p_help_text=>'I giorni al di fuori del mese di visualizzazione corrente saranno visibili e selezionabili.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4415)
,p_display_sequence=>30
,p_display_value=>'Visibile'
,p_return_value=>'VISIBLE'
,p_help_text=>'I giorni al di fuori del mese di visualizzazione corrente saranno visibili.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Incremento temporale'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>'minuti'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incremento temporale in minuti usato dal controllo di selezione dell''ora. Nota: controlla solo il controllo usato per selezionare l''ora, qualsiasi periodo di tempo al di fuori di questi incrementi pu\00F2 essere comunque immesso manualmente e salvato.')
||'</p>',
unistr('<p>Nota: viene utilizzato solo quando ''Visualizza come'' \00E8 ''Popup'' o ''In linea'', nonch\00E9 quando l''opzione ''Mostra ora'' \00E8 attiva.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostra in caso di'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Controlla quando viene visualizzata la finestra popup del calendario. Nota: viene utilizzato solo quando ''Visualizza come'' \00E8 ''Popup'' o ''In linea''.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4415)
,p_display_sequence=>10
,p_display_value=>'Attivazione elemento'
,p_return_value=>'FOCUS'
,p_help_text=>'Quando l''elemento riceve lo stato attivo oppure si fa clic sull''icona del calendario.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4415)
,p_display_sequence=>20
,p_display_value=>'Clic sull''icona'
,p_return_value=>'IMAGE'
,p_help_text=>'Solo quando si fa clic sull''icona del calendario.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostra ora'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Indica se includere le informazioni sull''ora.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Visualizza come'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di visualizzazione per il selettore data.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4415)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>'Il calendario viene visualizzato in un popup quando l''elemento riceve lo stato attivo oppure si fa clic sull''icona del calendario.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4415)
,p_display_sequence=>20
,p_display_value=>'In linea'
,p_return_value=>'INLINE'
,p_help_text=>'Il calendario viene sempre visualizzato in linea nella pagina. Non vengono visualizzati campi di testo e la selezione data corrente appare evidenziata nel calendario.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4415)
,p_display_sequence=>30
,p_display_value=>'HTML nativo'
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Visualizzare con i tipi di date di input HTML nativo, se supportati dal browser. Quando l''opzione ''Mostra ora'' \00E8 disattivata, viene visualizzato un tipo ''date'', quando l''opzione \00E8 attivata, il tipo visualizzato \00E8 ''datetime-local''. Nota: l''esatta v')
||unistr('isualizzazione di questi tipi di date dipende dal browser. L''HTML nativo pu\00F2 essere l''opzione preferenziale quando l''applicazione viene usata su un dispositivo portatile.</p>'),
unistr('<p>Tenere presente che quando si utilizza ''HTML nativo'', poich\00E9 i tipi di date nativi sono molto specifici riguardo al formato della data richiesto, l''opzione ''Formato di visualizzazione'' dell''elemento verr\00E0 impostata automaticamente da APEX e non sa')
||unistr('r\00E0 possibile modificarla. Tuttavia, questo formato non sar\00E0 quello visualizzato all''utente finale. L''utente finale visualizzer\00E0 la data nel formato appropriato per le impostazioni nazionali correnti.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Data minima'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare se l''elemento ha una data minima.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4415)
,p_display_sequence=>10
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
,p_help_text=>'Nessuna data minima definita.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4415)
,p_display_sequence=>20
,p_display_value=>'Elemento'
,p_return_value=>'ITEM'
,p_help_text=>'La data minima viene derivata dinamicamente dal valore di un altro elemento.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4415)
,p_display_sequence=>30
,p_display_value=>'Statico'
,p_return_value=>'STATIC'
,p_help_text=>unistr('La data minima \00E8 un valore statico, definito come valore assoluto o valore relativo alla data odierna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Valore statico minimo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere la data minima che pu\00F2 essere fornita come input o selezionata.</p>'),
unistr('<p>Il valore della data pu\00F2 essere un valore assoluto nel formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> o <code>''YYYYMMDDHH24MI''</code>, un valore relativo rispetto alla data del giorno, quale ad esempio <code>+7d</code>, oppure un valore dinamico che')
||' utilizza la sintassi di sostituzione, a condizione che la sostituzione restituisca il formato data o il valore relativo corretto.</p>',
'<p>I valori di data relativi comprendono:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anni a partire dalla data del giorno</dd>',
'  <dt>m</dt>',
'    <dd>+ / - mesi a partire dalla data del giorno</dd>',
'  <dt>w</dt>',
'    <dd>+ / - settimane a partire dalla data del giorno</dd>',
'  <dt>d</dt>',
'    <dd>+ / - giorni a partire dalla data del giorno</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Elemento minimo'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>'<p>L''elemento che determina il valore minimo consentito. Deve essere un elemento di pagina che si trova sulla pagina corrente o sulla pagina globale.<p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Data massima'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare se l''elemento ha una data massima.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4415)
,p_display_sequence=>10
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
,p_help_text=>'Nessuna data massima definita.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4415)
,p_display_sequence=>20
,p_display_value=>'Elemento'
,p_return_value=>'ITEM'
,p_help_text=>'La data massima viene derivata dinamicamente dal valore di un altro elemento.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4415)
,p_display_sequence=>30
,p_display_value=>'Statico'
,p_return_value=>'STATIC'
,p_help_text=>unistr('La data massima \00E8 un valore statico, definito come valore assoluto o valore relativo alla data odierna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Valore statico massimo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere la data massima che pu\00F2 essere fornita come input o selezionata.</p>'),
unistr('<p>Il valore della data pu\00F2 essere un valore assoluto nel formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> o <code>''YYYYMMDDHH24MI''</code>, un valore relativo rispetto alla data del giorno, quale ad esempio <code>+7d</code>, oppure un valore dinamico che')
||' utilizza la sintassi di sostituzione, a condizione che la sostituzione restituisca il formato data o il valore relativo corretto.</p>',
'<p>I valori di data relativi comprendono:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anni a partire dalla data del giorno</dd>',
'  <dt>m</dt>',
'    <dd>+ / - mesi a partire dalla data del giorno</dd>',
'  <dt>w</dt>',
'    <dd>+ / - settimane a partire dalla data del giorno</dd>',
'  <dt>d</dt>',
'    <dd>+ / - giorni a partire dalla data del giorno</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Elemento massimo'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>'<p>L''elemento che determina il valore massimo consentito. Deve essere un elemento di pagina che si trova sulla pagina corrente o sulla pagina globale.<p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Pi\00F9 mesi')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>unistr('Indica se il calendario visualizzer\00E0 pi\00F9 mesi.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Numero di mesi'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Il numero di mesi da mostrare contemporaneamente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Usa impostazioni predefinite'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica se utilizzare le impostazioni predefinite definite per questo componente in Componenti condivisi > Impostazioni componente o le impostazioni personalizzate.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Aspetto'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Controlla l''aspetto del calendario utilizzato per selezionare le date.</p>',
unistr('<p>Nota: viene utilizzato solo quando ''Visualizza come'' \00E8 ''Popup'' o ''In linea''.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4415)
,p_display_sequence=>10
,p_display_value=>'Mostra settimana'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('Indica se la settimana dell''anno verr\00E0 mostrata.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4415)
,p_display_sequence=>20
,p_display_value=>'Selettore mese'
,p_return_value=>'MONTH-PICKER'
,p_help_text=>'Indica se il mese deve essere visualizzato come pulsante, non come testo, per consentire la selezione.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4415)
,p_display_sequence=>30
,p_display_value=>'Selettore anno'
,p_return_value=>'YEAR-PICKER'
,p_help_text=>'Indica se l''anno deve essere visualizzato come pulsante, non come testo, per consentire la selezione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Giorni al di fuori del mese'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indica il funzionamento dei giorni al di fuori del mese di visualizzazione corrente.</p>',
unistr('<p>Nota: viene utilizzato solo quando ''Visualizza come'' \00E8 ''Popup'' o ''In linea''.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4415)
,p_display_sequence=>10
,p_display_value=>'Nascosto'
,p_return_value=>'HIDDEN'
,p_help_text=>'I giorni al di fuori del mese di visualizzazione corrente verranno nascosti.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4415)
,p_display_sequence=>20
,p_display_value=>'Selezionabile'
,p_return_value=>'SELECTABLE'
,p_help_text=>'I giorni al di fuori del mese di visualizzazione corrente saranno visibili e selezionabili.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4415)
,p_display_sequence=>30
,p_display_value=>'Visibile'
,p_return_value=>'VISIBLE'
,p_help_text=>'I giorni al di fuori del mese di visualizzazione corrente saranno visibili.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Incremento temporale'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>'minuti'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incremento temporale in minuti usato dal controllo di selezione dell''ora. Nota: controlla solo il controllo usato per selezionare l''ora, qualsiasi periodo di tempo al di fuori di questi incrementi pu\00F2 essere comunque immesso manualmente e salvato.')
||'</p>',
unistr('<p>Nota: viene utilizzato solo quando ''Visualizza come'' \00E8 ''Popup'' o ''In linea'', nonch\00E9 quando l''opzione ''Mostra ora'' \00E8 attiva.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.4415)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Mostra in caso di'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Controlla quando viene visualizzata la finestra popup del calendario. Nota: viene utilizzato solo quando ''Visualizza come'' \00E8 ''Popup'' o ''In linea''.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4415)
,p_display_sequence=>10
,p_display_value=>'Attivazione elemento'
,p_return_value=>'FOCUS'
,p_help_text=>'Quando l''elemento riceve lo stato attivo oppure si fa clic sull''icona del calendario.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4415)
,p_display_sequence=>20
,p_display_value=>'Clic sull''icona'
,p_return_value=>'IMAGE'
,p_help_text=>'Solo quando si fa clic sull''icona del calendario.'
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>'Casella di controllo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza una singola casella di controllo che l''utente pu\00F2 selezionare o deselezionare. Il valore selezionato o deselezionato definito viene memorizzato nello stato della sessione quando viene sottomesso.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.4415)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valore selezionato'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Immettere il valore memorizzato nell''elemento pagina se l''utente finale seleziona la casella di controllo. Questo valore pu\00F2 avere una lunghezza massima di 255 caratteri.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.4415)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore non selezionato'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Immettere il valore memorizzato nell''elemento pagina se l''utente deseleziona la casella di controllo. Questo attributo pu\00F2 anche essere lasciato vuoto se si desidera memorizzare <code>NULL</code> quando \00E8 selezionato. Il valore pu\00F2 avere una lunghezz')
||'a massima di 255 caratteri.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.4415)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Usa impostazioni predefinite'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica se utilizzare le impostazioni predefinite definite per questo componente in Componenti condivisi > Impostazioni componente o le impostazioni personalizzate.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.4415)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore selezionato'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Immettere il valore memorizzato nell''elemento pagina se l''utente seleziona la casella di controllo. Il valore pu\00F2 avere una lunghezza massima di 255 caratteri.</p>'),
'<p>',
'Nella pagina Ricerca con facet, se il facet applica un filtro a una colonna di query <em>in base a una lista di valori</em>, questo valore deve corrispondere <em>sia al valore visualizzato della lista di valori che al valore restituito</em>. Se i val'
||unistr('ori visualizzato e restituito sono diversi, non sar\00E0 possibile utilizzare questo tipo di facet per la colonna e sar\00E0 necessario utilizzare il facet <strong>Gruppo di caselle di controllo</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.4415)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valore non selezionato'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il valore memorizzato nell''elemento pagina se l''utente deseleziona la casella di controllo. Questo attributo pu\00F2 anche essere lasciato vuoto se si desidera memorizzare <code>NULL</code> quando viene l''opzione viene deselezionata. Questo ')
||unistr('valore pu\00F2 avere una lunghezza massima di 255 caratteri.</p>'),
'<p><em>Nota: questo valore viene usato se l''elemento pagina viene popolato con un valore che non corrisponde a <strong>Valore selezionato</strong> o a <strong>Valore non selezionato</strong>.</em></p>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>'Griglia interattiva'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Area in linea a pi\00F9 righe completa basata su una query SQL che fornisce agli utenti finali numerose funzioni per la personalizzazione in runtime.'),
unistr('Pu\00F2 essere definita come modificabile o di sola lettura.</p>'),
unistr('<p>\00C8 possibile definire una sola griglia interattiva e consentire agli utenti finali di manipolare i dati visualizzati per soddisfare requisiti specifici anzich\00E9 sviluppare numerose aree simili con criteri diversi per soddisfare gli stessi requisiti.')
||'</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.4415)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4415)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.4415)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4415)
,p_name=>'apexbeginrecordedit'
,p_display_name=>'Inizializzazione righe'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.4415)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4415)
,p_name=>'gridpagechange'
,p_display_name=>'Modifica pagina'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.4415)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4415)
,p_name=>'interactivegridmodechange'
,p_display_name=>unistr('Modifica modalit\00E0')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.4415)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4415)
,p_name=>'interactivegridreportchange'
,p_display_name=>'Modifica report'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.4415)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4415)
,p_name=>'interactivegridsave'
,p_display_name=>'Salva'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.4415)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4415)
,p_name=>'interactivegridselectionchange'
,p_display_name=>'Modifica selezione'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.4415)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4415)
,p_name=>'interactivegridviewchange'
,p_display_name=>'Modifica vista'
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>'Selettore di righe'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Visualizza una casella di controllo su ogni riga di una griglia interattiva e consente di selezionare una o pi\00F9 righe specifiche per la manipolazione delle righe.</p>'),
unistr('<p>Per impostazione predefinita la colonna APEX$ROW_SELECTOR \00E8 impostata su un tipo di selettore righe. Questa colonna viene aggiunta in modo automatico quando si rende modificabile la griglia interattiva.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.4415)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Abilita selezione multipla'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Consente la selezione di pi\00F9 righe.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.4415)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostra Seleziona tutto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Consente all''utente di selezionare tutte le righe utilizzando Ctrl+A oppure una casella di controllo nell''intestazione di colonna quando l''impostazione di <em>Nascondi controlli</em> \00E8 <em>No</em>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.4415)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nascondi controllo'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Nascondere la casella di controllo o il pulsante di scelta visualizzato in ogni riga.'
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>'Menu Azioni'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizza l''icona Azioni (hamburger) su ogni riga di una griglia interattiva. ',
unistr('A seconda degli attributi della griglia e delle autorizzazioni dell''utente finale, il menu Azioni include opzioni quali Vista a riga singola, Aggiungi riga, Elimina riga, Aggiorna riga e cos\00EC via. Queste opzioni consentono agli utenti finali di esegu')
||'ire azioni specifiche sulla riga corrente nella griglia.</p>',
unistr('<p>\00C8 possibile usare il menu Azioni nelle griglie interattive sia modificabili che non modificabili, ma le opzioni di menu varieranno in base a questa impostazione. Nel caso delle griglie interattive non modificabili, il menu conterr\00E0 un subset di op')
||unistr('zioni, ad esempio Vista a riga singola e Aggiorna riga e non includer\00E0 azioni specifiche modificabili quali Aggiungi riga, Elimina riga e cos\00EC via.</p>'),
unistr('<p>Quando si rende modificabile una griglia interattiva, la colonna APEX$ROW_ACTION verr\00E0 aggiunta in modo automatico e impostata su un tipo di menu Azioni. Per le griglie interattive non modificabili, questa colonna deve essere aggiunta manualmente.')
||'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>'Grafico'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizzare i dati utilizzando vari tipi di grafico incorporati.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.4415)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.4415)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>'Nascondi'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Nasconde gli elementi interessati.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.4415)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nascondi tutti gli elementi di pagina nella stessa riga'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se nascondere tutti gli elementi e le etichette di pagina sulla stessa riga degli elementi interessati.</p>',
'<p>Nota: questo attributo non funziona per gli elementi sulle pagine che non usano una griglia di tabella per visualizzare gli elementi di form. Sono incluse tutte le pagine che usano un modello di pagina per sistemi portatili.</p>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>'Abilita'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Abilita gli elementi interessati.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>'Disabilita'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Disabilita gli elementi interessati. La disabilitazione rende non modificabili gli elementi, che pertanto non conservano i valori quando la pagina viene sottomessa.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>'Imposta valore'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Imposta il valore degli elementi interessati.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo di set'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di derivazione del valore o dei valori da impostare.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_display_sequence=>10
,p_display_value=>'Assegnazione statica'
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>'Imposta un singolo valore statico.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_display_sequence=>15
,p_display_value=>'Espressione JavaScript'
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>unistr('Imposta uno o pi\00F9 valori derivati o calcolati da JavaScript.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_display_sequence=>20
,p_display_value=>'Istruzione SQL'
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>unistr('Imposta uno o pi\00F9 valori in base al risultato di una query SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_display_sequence=>40
,p_display_value=>'Espressione PL/SQL'
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>'Imposta un solo valore in base al risultato di un''espressione PL/SQL.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_display_sequence=>50
,p_display_value=>'Corpo funzione PL/SQL'
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>'Imposta un solo valore in base al risultato di un corpo funzione PL/SQL.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_display_sequence=>60
,p_display_value=>'Elemento restituito finestra di dialogo'
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>'Impostare un singolo valore in base all''elemento restituito di una finestra di dialogo. Nota: questo tipo funziona solo se l''azione dinamica viene attivata per l''evento <strong>Finestra di dialogo chiusa</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>'Immettere un valore statico.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Istruzione SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>In questo esempio, immettere <code>P1_DEPTNO</code> in <strong>Elementi pagina da sottomettere</strong>. \00C8 inoltre necessario selezionare due <em>elementi interessati</em> per le colonne <code>loc</code> e <code>dname</code>, ad esempio P1_LOC e P')
||'1_DNAME.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un''istruzione SQL che restituisca da 1 a 100 colonne. Le colonne selezionate mediante l''istruzione SQL dovranno corrispondere per posizione agli elementi di pagina selezionati nell''attributo <strong>Elementi interessati</strong>.</p>',
unistr('<p>\00C8 possibile fare riferimento ad altri elementi di pagina o di applicazione mediante una sintassi di associazione a condizione di includerli nell''attributo <strong>Elementi pagina da sottomettere</strong>.</p>'),
unistr('<p><em>Nota: se l''istruzione SQL restituisce solo una riga, tale riga verr\00E0 utilizzata per impostare i valori. Se restituisce pi\00F9 righe, il set di valori sar\00E0 una stringa separata da virgole di tutte le righe per ogni valore.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Espressione PL/SQL'
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
'<p>In questo esempio, immettere <code>P1_SAL</code> in <strong>Elementi pagina da sottomettere</strong>.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''espressione PL/SQL da utilizzare per impostare il valore.</p>',
unistr('<p>\00C8 possibile fare riferimento a elementi di pagina o di applicazione, a condizione che siano stati inclusi negli <strong>Elementi pagina da sottomettere</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Espressione JavaScript'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questo codice accede agli attributi relativi alle azioni dinamiche riportati di seguito.</p>',
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
'    <dd>Riferimento all''oggetto DOM dell''elemento che ha attivato l''azione dinamica.</dd>',
'  <dt><code>this.affectedElements</code></dt>',
'    <dd>Oggetto jQuery che contiene tutti gli elementi interessati.</dd>',
'  <dt><code>this.action</code></dt>',
'    <dd>L''oggetto di azione che contiene dettagli quale il nome dell''azione e altri valori di attributo.</dd>',
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>L''oggetto di evento che ha attivato l''evento. Nota: al caricamento, sar\00E0 uguale a ''load''.</dd>'),
'  <dt><code>this.data</code></dt>',
'    <dd>Dati aggiuntivi facoltativi che possono essere passati dall''handler di eventi.</dd>',
'</dl>'))
,p_help_text=>unistr('Immettere l''espressione JavaScript utilizzata per impostare il valore. L''espressione pu\00F2 restituire un valore singolo o un array di valori (quando l''elemento impostato supporta pi\00F9 valori, come ad esempio uno shuttle).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Corpo funzione PL/SQL'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
'<p>In questo esempio, immettere <code>P1_SAL</code> e <code>P1_JOB</code> in <strong>Elementi pagina da sottomettere</strong>.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un corpo funzione PL/SQL da utilizzare per impostare il valore.</p>',
unistr('<p>\00C8 possibile fare riferimento a elementi di pagina o di applicazione, a condizione che siano stati inclusi negli <strong>Elementi pagina da sottomettere</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Elementi da sottomettere'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Immettere gli elementi di pagina o di applicazione da sottomettere quando si esegue questa azione. Quando si specificano pi\00F9 elementi, usare una virgola per separare i nomi. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi ')
||unistr('disponibili. Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Caratteri speciali di escape'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Specificare se applicare la funzione di escape dei caratteri speciali HTML. Oracle consiglia di impostare questo attributo su <strong>S\00EC</strong> per impedire gli attacchi di tipo XSS (Cross Site Scripting).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Elimina evento di modifica'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se l''evento di modifica deve essere eliminato negli elementi specificati in <strong>Elementi pagina da restituire</strong>. Ci\00F2 impedisce l''attivazione delle azioni dinamiche basate su <em>Modifica</em> successive per tali elementi.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.4415)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>'Elemento restituito'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>'Immettere il nome dell''elemento di pagina restituito dalla finestra di dialogo utilizzata per impostare il valore.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>'Esegui codice JavaScript'
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Consente di definire o richiamare un codice JavaScript personalizzato e specifico della pagina da utilizzare nel framework delle azioni dinamiche. Se si definisce un codice JavaScript specifico per una sola pagina, \00E8 inoltre possibile utilizzare il n')
||unistr('uovo attributo a livello di pagina <em>Dichiarazione di funzione e variabile globale</em>. Da questa azione in seguito sar\00E0 possibile fare riferimento alle funzioni e alle variabili definite qui.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.4415)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Codice'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questo codice accede agli attributi relativi alle azioni dinamiche riportati di seguito.</p>',
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
'    <dd>Riferimento all''oggetto DOM dell''elemento che ha attivato l''azione dinamica.</dd>',
'  <dt><code>this.affectedElements</code></dt>',
'    <dd>Oggetto jQuery che contiene tutti gli elementi interessati.</dd>',
'  <dt><code>this.action</code></dt>',
'    <dd>L''oggetto di azione che contiene dettagli quale il nome dell''azione e altri valori di attributo.</dd>',
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>L''oggetto di evento che ha attivato l''evento. Nota: al caricamento, sar\00E0 uguale a ''load''.</dd>'),
'  <dt><code>this.data</code></dt>',
'    <dd>Dati aggiuntivi facoltativi che possono essere passati dall''handler di eventi.</dd>',
'</dl>'))
,p_help_text=>'Immettere un codice JavaScript personalizzato specifico per la pagina o l''azione dinamica.'
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>'Griglia interattiva - Elaborazione automatica delle righe (DML)'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Processo per l''inserimento, l''aggiornamento o l''eliminazione delle righe di una griglia interattiva.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.4415)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo di destinazione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare la tecnica di elaborazione delle righe da eseguire per salvare le modifiche apportate ai dati della griglia interattiva.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4415)
,p_display_sequence=>10
,p_display_value=>'Origine area'
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gli inserimenti, gli aggiornamenti e le eliminazioni utilizzano la query SQL dell''origine area.</p>',
unistr('<p>Nota: assicurarsi che l''opzione <strong>Solo query</strong> sia impostata su <code>S\00EC</code> per le colonne su cui non \00E8 possibile eseguire inserimenti o aggiornamenti in modo da escluderle dall''elaborazione.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4415)
,p_display_sequence=>20
,p_display_value=>'Tabella/vista'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Gli inserimenti, gli aggiornamenti e le eliminazioni utilizzano una tabella o una vista diversa da quella definita nella query SQL dell''origine area.',
'Ad esempio, la query SQL recupera i dati da una vista table-join o non aggiornabile e l''elaborazione DML deve essere eseguita rispetto a una tabella di base o a una vista aggiornabile singola.</p>',
unistr('<p>Nota: assicurarsi che l''opzione <strong>Solo query</strong> sia impostata su <code>S\00EC</code> per le colonne su cui non \00E8 possibile eseguire inserimenti o aggiornamenti in modo da escluderle dall''elaborazione.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4415)
,p_display_sequence=>30
,p_display_value=>'Codice PL/SQL'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''elaborazione \00E8 basata su codice PL/SQL personalizzato. Questa opzione consente di eseguire qualsiasi codice PL/SQL per implementare la manipolazione dei dati nel database di base.</p>'),
'<p>Questa opzione deve essere utilizzata quando si usano i package di database, ad esempio le interfacce API di tabella o le chiamate ai Web Service RESTful, per implementare la business logic.</p>',
unistr('<p>Nota: il codice PL/SQL verr\00E0 richiamato per ogni riga inserita, aggiornata o eliminata.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.4415)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Proprietario tabella'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Selezionare il nome del proprietario (schema) della tabella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.4415)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome tabella'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.4415)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Immettere un nome tabella o vista con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.4415)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Codice PL/SQL per inserimento/aggiornamento/eliminazione'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice PL/SQL per elaborare ogni riga dei dati manipolati nella griglia interattiva.</p>',
unistr('<p>Usare il nome della colonna come bind variable per accedere al valore di una colonna. La variabile di sistema <code>APEX$ROW_STATUS</code> restituisce lo stato di una riga e pu\00F2 essere utilizzata per verificare se la riga \00E8 stata creata, aggiornat')
||'a o eliminata (vedere l''esempio riportato di seguito per istruzioni su come effettuare la verifica).</p>',
unistr('<p><em>Nota:</em> se le colonne chiave primaria vengono popolate da un trigger o nel codice PL/SQL, \00E8 obbligatorio assegnare i nuovi valori alle bind variable delle colonne chiave primaria, poich\00E9 &PRODUCT_NAME. utilizza tali valori per recuperare la')
||' riga tramite fetch dopo un inserimento o un aggiornamento.</p>',
unistr('<p>Oracle consiglia di chiamare le procedure o le funzioni dall''interno di un package PL/SQL per facilitare il riutilizzo e le capacit\00E0 di gestione.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.4415)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Impedisci aggiornamenti persi'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specifica se l''elaborazione deve garantire che gli aggiornamenti non vadano persi quando pi\00F9 utenti aggiornano lo stesso record di database.</p> '),
unistr('<p>La perdita degli aggiornamenti si verifica quando due o pi\00F9 persone tentano di aggiornare gli stessi dati e l''ultimo aggiornamento sovrascrive gli aggiornamenti effettuati dal primo utente che ha salvato le modifiche. Per evitare che ci\00F2 succeda, ')
||unistr('durante gli aggiornamenti \00E8 possibile controllare i valori di colonna esistenti nel database rispetto ai valori recuperati al momento dell''esecuzione della query originale sulla riga.</p>'),
'<p>Ad esempio:',
'  <ol>',
'    <li>L''Utente A esegue una query sui record dei dipendenti (EMP).</li>',
'    <li>L''Utente B esegue una query sugli stessi record dei dipendenti.</li>',
'    <li>L''Utente B aggiorna i dettagli dipendente per EMPNO = 7839 e applica le modifiche, ovvero ne esegue il commit nel database.</li>',
'    <li>L''Utente A aggiorna i dettagli dipendente per EMPNO = 7839 e tenta di applicare le modifiche nel database.</li>',
'  </ol>',
'Se l''aggiornamento della stessa riga da parte dell''Utente A riesce, le modifiche apportate dall''Utente B andranno perdute.',
'Quando l''Utente A tenta di salvare la riga del dipendente, i dati nel database sono diversi da quelli su cui l''Utente A ha eseguito la query originale. Nel Passo 1 della procedura precedente, i valori di colonna su cui l''Utente A ha eseguito la query'
||unistr(' originale possono essere acquisiti. Nel Passo 4 i valori possono essere confrontati con i valori correnti nel database. Il confronto restituir\00E0 un errore per l''Utente A in quanto i valori del database sono stati aggiornati dall''Utente B nel Passo 3.')
||unistr(' Ci\00F2 impedisce che un utente sovrascriva le modifiche apportate da un altro utente alla stessa riga.</p>'),
unistr('<p>Nota: le modalit\00E0 di rilevamento degli aggiornamenti persi \00E8 specificata negli attributi per l''area della griglia interattiva in base all''impostazione per <strong>Tipo aggiornamento perso</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.4415)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Blocca riga'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Specificare se ogni riga da aggiornare o eliminare deve essere bloccata nella tabella di base prima dell''elaborazione.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4415)
,p_display_sequence=>10
,p_display_value=>unistr('S\00EC')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le righe da aggiornare o eliminare verranno bloccate con SELECT ... FOR UPDATE per impedire l''esecuzione di altre transazioni sulla riga finch\00E9 non sar\00E0 stato eseguito il commit della transazione.</p>'),
unistr('<p>Nota: se viene restituito un errore, ad esempio per le viste aggiornabili che non supportano il blocco, sar\00E0 possibile utilizzare codice PL/SQL per bloccare la tabella di controllo.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4415)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'Le righe non verranno bloccate.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4415)
,p_display_sequence=>30
,p_display_value=>'Codice PL/SQL'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('Verr\00E0 utilizzato il codice PL/SQL personalizzato per bloccare le righe finch\00E9 non sar\00E0 stato eseguito il commit della transazione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.4415)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Codice PL/SQL per il blocco delle righe'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>'Immettere il codice PL/SQL per bloccare le righe della tabella del database da aggiornare ed eliminare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.4415)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Restituisci chiavi primarie dopo l''inserimento'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se le colonne chiave primaria devono essere restituite alla riga corrispondente della griglia interattiva dopo l''inserimento della riga nel database.',
unistr('In genere questa opzione deve essere usata quando i dati delle colonne chiave primaria vengono inseriti da un trigger di database o da una colonna identit\00E0 di Oracle Database 12 <em>c</em>.</p>'),
unistr('<p>Nota: se viene visualizzato un messaggio di errore che specifica che la clausola RETURNING INTO non \00E8 consentita, impostare questa opzione su No e inserire preventivamente i dati nelle colonne chiave primaria.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>'Aggiungi classe'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Aggiunge una o pi\00F9 classi CSS agli elementi interessati.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.4415)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Classe'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggiungere le classi CSS <code>articlenumber</code> e <code>highlight</code> alla tag HTML degli elementi interessati:',
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('Specificare una o pi\00F9 classi da applicare agli elementi interessati. Se si specificano pi\00F9 classi, separarne i nomi con uno spazio.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>'Rimuovi classe'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Rimuove una o pi\00F9 classi CSS dagli elementi interessati.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.4415)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Classe'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('<p>Specificare uno o pi\00F9 nomi classe da rimuovere dagli elementi interessati. Se si specificano pi\00F9 nomi, separarli con uno spazio. Non specificare alcun valore per rimuovere tutti i nomi classe dagli elementi interessati.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>'Imposta stile'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Imposta una propriet\00E0 stile (CSS) per gli elementi interessati.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.4415)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome stile'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere il nome della propriet\00E0 di stile (CSS) da impostare per gli elementi interessati.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.4415)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Immettere il valore per impostare la propriet\00E0 dello stile per gli elementi interessati. Non specificare alcun valore per rimuovere la propriet\00E0 dello stile dagli elementi interessati.')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>'Personalizzato'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Schema di autenticazione che consente di definire funzioni PL/SQL proprie per determinare l''autenticazione utente.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome funzione sentry'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare il codice PL/SQL che restituisce un valore booleano all''interno di ''Codice PL/SQL'' -</p>',
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
'<p>Specificare una funzione di database PL/SQL - </p>',
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome della funzione eseguita dal motore di &PRODUCT_NAME. all''avvio di qualsiasi richiesta inoltrata al motore, ad esempio prima della visualizzazione o dell''elaborazione di ciascuna pagina o dell''esecuzione di una richiesta AJAX. ',
unistr('La funzione pu\00F2 essere definita nel codice PL/SQL dell''autenticazione, all''interno di un package oppure come stored function.</p>'),
'<p>Se questa funzione restituisce un valore false, indicante ad esempio che l''utente non ha eseguito il login, la sessione viene contrassegnata come non valida e viene richiamata la <em>procedura sessione non valida</em>.',
'Successivamente, &PRODUCT_NAME. reindirizza all''URL definito in ''Sessione non valida > Vai a''.',
'Se non viene specificato alcun valore per questo campo,',
'viene richiamata una funzione sentry predefinita interna che tenta di stabilire una sessione valida confrontando l''ID sessione nell''URL con le informazioni sulla sessione nel cookie dello schema di autenticazione (con un fallback al cookie di &PRODUC'
||'T_NAME. Builder se il tentativo non riesce).</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome procedura di sessione non valido'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Autenticazione Basic richiesta'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="realm protetto"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome della procedura PL/SQL che viene richiamata quando viene rilevata una sessione non valida.</p>',
'',
unistr('<p>Il nome pu\00F2 fare riferimento a una funzione del blocco di codice PL/SQL anonimo, a una funzione package o a una funzione standalone nel database. Ad esempio: <code>invalid_session_basic_auth</code></p>'),
'',
unistr('<p>Quando si fa riferimento a una funzione package o standalone PL/SQL del database, \00E8 possibile usare la stringa di sostituzione <code>#OWNER#</code> per fare riferimento allo schema di analisi dell''applicazione corrente. Ad esempio: <code>#OWNER#.i')
||'nvalid_session_basic_auth</code></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome funzione di autenticazione'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice seguente nell''area di testo ''Codice PL/SQL''</p>',
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
'<p>e <code>my_authentication</code> come ''Funzione di autenticazione''.'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare il nome della funzione che verificher\00E0 il nome e la password dell''utente immessi in una pagina di login.'),
'Se non si specifica alcun nome, saranno valide tutte le combinazioni nome utente-password.',
unistr('La funzione pu\00F2 essere definita nell''area di testo ''Codice PL/SQL'' dell''autenticazione, all''interno di un package oppure come stored function.</p>'),
'',
'<p>Questa funzione deve restituire un valore booleano alla procedura di login che la richiama. Dispone dei due parametri di input ''p_username'' e ''p_password'', che possono essere utilizzati per accedere ai valori immessi da un utente finale nella pagi'
||'na di login.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Nome procedura successiva al logout'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice seguente nell''area di testo ''Codice PL/SQL''</p>',
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
'<p>e <code>my_post_logout</code> come ''Procedura successiva al logout''.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Il nome della procedura richiamata dopo che l''utente finale ha fatto clic sull''URL di logout. Pu\00F2 essere utilizzato per il log.'),
unistr('La procedura pu\00F2 essere definita nell''area di testo ''Codice PL/SQL'' dell''autenticazione, all''interno di un package oppure come stored function.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Abilita attributi autenticazione precedente'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se la lista di selezione \00E8 impostata su "S\00EC", diventano visibili ulteriori attributi di autenticazione.'),
'Si tratta di attributi che riguardano principalmente le autenticazioni personalizzate definite nelle versioni 4.0 e precedenti di &PRODUCT_NAME..'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Nome applicazione partner SSO'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se l''autenticazione viene eseguita con Oracle Application Server Single Sign-On e l''applicazione \00E8 un''applicazione partner registrata con SSO, immettere esattamente il nome usato durante la registrazione dell''applicazione partner con SSO.'),
'',
unistr('Se l''applicazione partner registrata dovr\00E0 essere Application Express, lasciare il campo vuoto.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Host LDAP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Il nome host del server delle directory LDAP.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Porta LDAP'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Il numero di porta dell''host delle directory LDAP.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Usa SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Scegliere se usare SSL per l''associazione alla directory LDAP. Se si sceglie SSL con autenticazione, \00E8 necessario configurare un wallet per l''istanza di &PRODUCT_NAME..')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4415)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4415)
,p_display_sequence=>20
,p_display_value=>'SSL con autenticazione'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4415)
,p_display_sequence=>30
,p_display_value=>'Nessun SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Stringa DN LDAP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>DN esatto</dt>',
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
'  <dt>DN non esatto (base di ricerca)</dt>',
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>'Immettere il pattern usato per creare la stringa del nome distinto (DN) completamente qualificato per DBMS_LDAP.SIMPLE_BIND_S se si usa il DN esatto o la base di ricerca se si usa un DN non esatto. Usare <strong>%LDAP_USER%</strong> come segnaposto p'
||'er il nome utente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Usa nome distinto (DN) esatto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Scegliere se la stringa del nome distinto (DN) LDAP \00E8 esatta o non esatta. Se \00E8 non esatta, il nome distinto (DN) LDAP \00E8 la base di ricerca ed \00E8 necessario fornire un filtro di ricerca.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Filtro di ricerca'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>'Immettere il filtro di ricerca necessario quando non si usa un nome distinto (DN) esatto. Usare <code>%LDAP_USER%</code> come segnaposto per il nome utente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Funzione di modifica nome utente LDAP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il codice seguente richiama una funzione che sostituisce tutte le ricorrenze di "." con "_" nella stringa del DN:</p>',
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('\00C8 possibile fornire codice aggiuntivo da eseguire per trasformare il nome utente in un formato idoneo per la voce di directory LDAP o per il nome utente LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.4415)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Escape nome utente'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Prima di sostituire <code><strong>%LDAP_USER%</strong></code> nel nome distinto e nella stringa di ricerca LDAP,',
unistr('&PRODUCT_NAME. pu\00F2 applicare automaticamente il valore di escape ai caratteri speciali presenti nel nome utente.'),
''))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4415)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Applica la funzione di escape ai caratteri speciali in base a RFC 4514 (per i nomi distinti) e a RFC 4515 (per le stringhe di ricerca).',
'La funzione di escape viene applicata anche ai caratteri Unicode.',
unistr('Si tratta dell''impostazione pi\00F9 sicura, che tuttavia pu\00F2 creare problemi con alcuni server LDAP.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4415)
,p_display_sequence=>20
,p_display_value=>'Solo caratteri speciali'
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Applica la funzione di escape ai caratteri speciali in base a RFC 4514 (per i nomi distinti) e a RFC 4515 (per le stringhe di ricerca).',
'Non applica la funzione di escape ai caratteri Unicode.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4415)
,p_display_sequence=>30
,p_display_value=>'Nessuna funzione di escape'
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Non applica la funzione di escape ad alcun carattere. Questa impostazione \00E8 potenzialmente non sicura,'),
'a meno che non sia utilizzata la <strong>Funzione di modifica del nome utente</strong> che applica',
unistr('gi\00E0 la funzione di escape al nome utente (ad esempio con <code>apex_escape.ldap_dn</code> or <code>apex_escape.ldap_search_filter</code>).')))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>'Esegui codice'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Processo per l''esecuzione del codice PL/SQL.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>'Chiudi finestra di dialogo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Processo per la chiusura della pagina corrente della finestra di dialogo di tipo modale o non modale.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.4415)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elementi da restituire '
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il nome di uno o pi\00F9 elementi di pagina che devono essere restituiti dalla finestra di dialogo. Se si specificano pi\00F9 elementi, usare una virgola per separare ogni nome elemento.</p>'),
unistr('<p>\00C8 possibile accedere ai valori di elementi restituiti definendo un''azione dinamica che deve essere attivata in caso di evento <strong>Finestra di dialogo chiusa</strong> sull''elemento che apre la finestra di dialogo, con un''azione <strong>Imposta ')
||'valore</strong> e <em>Tipo di set</em> impostato su <strong>Elemento restituito finestra di dialogo</strong>.</p>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>'Cancella stato sessione'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Processo per la cancellazione dello stato sessione memorizzato in &PRODUCT_NAME.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.4415)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare il tipo di stato della sessione da cancellare.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_display_sequence=>1
,p_display_value=>'Cancella tutti gli elementi della pagina corrente'
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_display_sequence=>3
,p_display_value=>'Cancella tutti gli elementi della/e pagina/e'
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_display_sequence=>5
,p_display_value=>'Cancella elementi  '
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_display_sequence=>7
,p_display_value=>'Cancella sessione corrente'
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_display_sequence=>9
,p_display_value=>'Cancella applicazione corrente'
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_display_sequence=>10
,p_display_value=>'Cancella applicazioni'
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.4415)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Applicazione/i'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>'Immettere una lista separata da virgole di ID applicazione, ad esempio <code>100,101,105</code>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.4415)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento/i'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('Selezionare gli elementi di pagina da cancellare dallo stato della sessione, ad esempio <code>P1_EMPNO,P1_ENAME</code>. Quando si specificano pi\00F9 elementi, usare una virgola per separare i nomi. \00C8 possibile digitare il nome oppure selezionarlo nella ')
||'lista degli elementi disponibili.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.4415)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Pagina/e'
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>'Immettere una lista separata da virgole di numeri di pagina, ad esempio <code>1,2,5</code>.'
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>'Reimposta impaginazione'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Processo per la reimpostazione dell''impaginazione dei report nella pagina corrente.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.4415)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Destinazione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare se l''impaginazione deve essere reimpostata su tutte le pagine, su alcune pagine o sulla pagina corrente.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4415)
,p_display_sequence=>10
,p_display_value=>'Questa pagina'
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4415)
,p_display_sequence=>20
,p_display_value=>'Pagina/e'
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4415)
,p_display_sequence=>30
,p_display_value=>'Tutte le pagine'
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.4415)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Pagina/e'
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>'Immettere una lista separata da virgole di numeri di pagina.'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>'Form tabulare - Aggiungi righe'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Processo per l''aggiunta di una riga nell''area Form tabulare.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.4415)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Numero di righe'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>'Immettere il numero di righe.'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>unistr('Form tabulare - Aggiornamento di pi\00F9 righe')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processo per l''aggiornamento di pi\00F9 righe di un''area Form tabulare. Il processo inserir\00E0 inoltre i record aggiunti nell''area.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.4415)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Proprietario tabella'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Selezionare il nome del proprietario (schema) della tabella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.4415)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome tabella'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.4415)
,p_help_text=>unistr('Immettere un nome tabella o vista con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.4415)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Colonna chiave primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4415)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la colonna che contiene il valore della chiave primaria. Per le tabelle con chiavi primarie costituite da pi\00F9 di due parti, selezionare <strong>ROWID</strong>.</p>'),
'<p>La chiave primaria viene utilizzata per identificare le righe da aggiornare e non deve essere modificabile nel form tabulare. Per le nuove righe, il valore della chiave primaria deve essere vuoto.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.4415)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Colonna chiave secondaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4415)
,p_help_text=>unistr('Selezionare la colonna che contiene il secondo valore della chiave primaria. Questo attributo deve essere popolato solo se la chiave primaria \00E8 costituita da due colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.4415)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Clausola WHERE di runtime'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limitare i reparti utilizzando:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>'Immettere la clausola WHERE SQL da aggiungere a tutte le istruzioni INSERT e UPDATE generate. Usare questo attributo per limitare i record usati nelle chiamate SQL generate in modo automatico.'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>'Recupero automatico delle righe'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Processo per il recupero di record da una singola tabella o vista di database. Viene utilizzato per popolare gli elementi di form con origine di tipo <strong>Colonna di database</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Proprietario tabella'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Selezionare il nome del proprietario (schema) della tabella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome tabella'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.4415)
,p_help_text=>unistr('Immettere un nome tabella o vista con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento chiave primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il valore della colonna della chiave primaria. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>'Colonna chiave primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4415)
,p_help_text=>unistr('Selezionare la colonna che contiene il valore della chiave primaria. Per le tabelle con chiavi primarie costituite da pi\00F9 di due parti, selezionare <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Elemento chiave secondaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il valore della seconda colonna della chiave primaria. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>'Colonna chiave secondaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4415)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('Selezionare la colonna che contiene il secondo valore della chiave primaria. Questo attributo deve essere popolato solo se la chiave primaria \00E8 costituita da due colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Colonna versione di riga'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4415)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la colonna che identifica la versione della riga. Non \00E8 necessario che questa colonna sia presente nella pagina. Lasciare vuoto questo attributo se si desidera usare il checksum incorporato.</p>'),
unistr('<p>La funzione di lock opportunistico usa il rilevamento degli aggiornamenti persi per garantire l''integrit\00E0 dei dati nelle applicazioni in cui \00E8 possibile utilizzare i dati mediante accesso concorrente. &PRODUCT_NAME. pu\00F2 usare un checksum incorpora')
||unistr('to per eseguire il rilevamento degli aggiornamenti persi e determinare la versione della riga. Il checksum \00E8 una funzione hash di tutti i valori di colonna per la riga di tabella specifica. Viene recuperato quando si esegue una query sul record dal d')
||'atabase e il risultato viene successivamente confrontato con l''hash del record corrente nel database come parte del processo <em>Recupero automatico delle righe</em>. Se i due valori sono uguali, l''aggiornamento viene eseguito, altrimenti il processo'
||' Recupero automatico delle righe restituisce un errore.</p>',
'<p>Questo attributo consente di specificare una colonna singola che contiene la versione della riga come metodo alternativo all''elaborazione del checksum incorporato. Questa colonna deve essere aggiornata a ogni aggiornamento di un record nel databas'
||'e. Oracle consiglia di implementare un trigger di database ''Prima dell''aggiornamento'' nella tabella per incrementare o aggiornare in altro modo il valore della colonna della versione della riga. Nelle colonne NUMBER si prevede sia contenuto un numero'
||unistr(' di sequenza della riga. Possono essere tuttavia utilizzate anche le colonne DATE e TIMESTAMP. Il vantaggio dell''uso di una colonna singola consiste nel fatto che il motore di &PRODUCT_NAME. non deve eseguire l''hash di tutta la riga, ma pu\00F2 limitarsi')
||' al semplice confronto del valore di una sola colonna.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Clausola WHERE di runtime'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limitare i reparti utilizzando:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>'Immettere la clausola WHERE SQL da aggiungere all''istruzione SELECT generata. Usare questo attributo per limitare i record usati nelle chiamate SQL generate in modo automatico.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.4415)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Modalit\00E0 fetch')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Questa opzione esiste solo per garantire la compatibilit\00E0 con le versioni precedenti.'),
'Per le nuove applicazioni questa impostazione deve essere sempre lasciata vuota.',
unistr('L''opzione "Imposta cache memoria sono in caso di visualizzazione" non \00E8 pi\00F9 valida e non viene utilizzata nei processi generati con questa release of &PRODUCT_NAME..'),
'</p>',
'<p>',
unistr('Quando un processo di recupero automatico di righe tramite FETCH seleziona una riga, gli elementi di pagina corrispondenti vengono impostati sui valori di colonna recuperati tramite FETCH. L''impostazione Modalit\00E0 fetch DML determina il momento in cui')
||unistr(' ci\00F2 avviene. La modalit\00E0 predefinita aggiorna immediatamente lo stato della sessione in memoria quando la riga viene recuperata. La modalit\00E0 ''Imposta cache memoria solo in caso di visualizzazione'' aggiorna lo stato di questa sessione solo se e quand')
||unistr('o l''elemento viene visualizzato. Se \00E8 necessario fare riferimento al valore recuperato dell''elemento utilizzando una bind variable o la sintassi <code>v(''ITEM_NAME'')</code> tra l''ora del recupero della riga e l''ora di visualizzazione dell''elemento, \00E8')
||unistr(' necessario utilizzare la modalit\00E0 di recupero tramite FETCH predefinita. Quando si crea un nuovo processo di recupero automatico delle righe, la modalit\00E0 di recupero tramite FETCH viene impostata su questa modalit\00E0 predefinita. A meno che la logica ')
||unistr('della pagina non dipenda da un funzionamento basato sulla visualizzazione, si consiglia di aggiornare questo processo e di impostarlo sul funzionamento predefinito per garantire il massimo livello di flessibilit\00E0 quando si fa riferimento ai valori di')
||' colonna recuperati durante il rendering della pagina.',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.4415)
,p_display_sequence=>20
,p_display_value=>unistr('Imposta cache memoria solo in caso di visualizzazione [non pi\00F9 valido]')
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>'Web Service'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Processo per l''utilizzo del Web Service specificato.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.4415)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Operazione Web Service'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>'Selezionare un''operazione di Web Service.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.4415)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Memorizza risultato in'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4415)
,p_display_sequence=>10
,p_display_value=>'Elemento/i'
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4415)
,p_display_sequence=>20
,p_display_value=>'Raccolta'
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.4415)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome collection'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>'Impaginazione form'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Processo per il recupero del record precedente o successivo da una tabella o una vista del database. Questo processo pu\00F2 essere utilizzato per fornire l''impaginazione nelle pagine di form, in modo che gli utenti finali possano recuperare il record')
||' precedente o successivo senza dover tornare a un report.</p>',
unistr('<p><em>Nota: se il form consente l''aggiornamento dei dati, \00E8 necessario assicurarsi che venga eseguita l''elaborazione appropriata del form prima che questo processo di impaginazione venga eseguito, altrimenti gli aggiornamenti eseguiti dall''utente fi')
||'nale andranno perduti al momento dello spostamento a un altro record.</em></p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Proprietario tabella'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Selezionare il nome del proprietario (schema) della tabella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome tabella'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.4415)
,p_help_text=>unistr('Immettere un nome tabella o vista con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Elemento chiave primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della colonna della chiave primaria. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'Colonna chiave primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4415)
,p_help_text=>unistr('Selezionare la colonna che contiene il valore della chiave primaria. Per le tabelle con chiavi primarie costituite da pi\00F9 di due parti, selezionare <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Elemento chiave secondaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della seconda colonna della chiave primaria. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Colonna chiave secondaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4415)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('Selezionare la colonna che contiene il secondo valore della chiave primaria. Questo attributo deve essere popolato solo se la chiave primaria \00E8 costituita da due colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Colonna ordine navigazione'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4415)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la colonna che contiene il valore dell''ordine di navigazione.</p>',
unistr('<p>Questa colonna viene utilizzata per determinare le righe precedenti e successive, pertanto una colonna quale <code>DISPLAY_SEQ</code> \00E8 la colonna ideale da usare. Se si desidera ordinare i record rispettando la sequenza in cui sono stati creati, ')
||unistr('\00E8 possibile utilizzare una colonna di tipo <code>CREATED</code> o <code>ID</code>, quando l''inserimento avviene da una sequenza o in base a una colonna Identit\00E0 di Oracle Database 12<em>c</em>. Esiste tuttavia la possibilit\00E0 di ordinare i record su d')
||'ue colonne qualsiasi, ad esempio <code>JOB</code> e <code>DEPTNO</code>.</p>',
unistr('<p><em>Nota: le colonne dell''ordine di navigazione devono corrispondere alle colonne predefinite utilizzate per ordinare il report dal quale gli utenti finali si sono spostati per ottenere questo form. In alternativa, \00E8 necessario assicurarsi che gli')
||' utenti finali siano informati di come vengono determinate le righe precedenti e successive, ad esempio mediante l''uso di etichette di pulsante o di testo della Guida.</em></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Colonna ordine navigazione secondaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4415)
,p_help_text=>unistr('Selezionare la colonna che contiene il secondo valore dell''ordine di navigazione. Questo attributo deve essere popolato solo se la chiave di navigazione \00E8 costituita da due colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Elemento chiave primaria successiva'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della colonna della chiave primaria per il record <em>successivo</em>. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Elemento chiave primaria precedente'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della colonna della chiave primaria per il record <em>precedente</em>. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Elemento chiave secondaria successiva'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della seconda colonna della chiave primaria per il record <em>successivo</em>. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Elemento chiave secondaria precedente'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della seconda colonna della chiave primaria per il record <em>precedente</em>. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Elemento conteggio righe correnti'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il valore del conteggio di record totale. \00C8 possibile digitare il nome oppure selezionarlo nella lista.</p>'),
unistr('<p>Se il set di risultati contiene pi\00F9 di 10.000 righe, la definizione di questo elemento pu\00F2 ridurre le prestazioni.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.4415)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Clausola WHERE di runtime'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>'Immettere l''istruzione SQL per limitare il numero dei record restituiti dalla query.'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>'Web Service precedente'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Processo per l''utilizzo del Web Service specificato. Oracle consiglia di aggiornare questo processo a <strong>Web Service</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.4415)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Riferimento a Web Service'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Immettere il numero di riferimento del Web Service.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.4415)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Memorizza risultato in'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4415)
,p_display_sequence=>10
,p_display_value=>'Elemento/i'
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4415)
,p_display_sequence=>20
,p_display_value=>'Raccolta'
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.4415)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome collection'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>'Area di testo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza un''area di testo a pi\00F9 righe.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.4415)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Ridimensionabile'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se il ridimensionamento dell''area di testo con il mouse \00E8 abilitato.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.4415)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Altezza automatica'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se l''altezza dell''area di testo varia in base alla quantit\00E0 di testo visualizzata. Utilizzare questa opzione per scalare l''area di testo in base alla quantit\00E0 di dati.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.4415)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Contatore caratteri'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se visualizzare un contatore sotto l''area di testo. Il contatore indica il numero dei caratteri immessi nel campo e il numero totale dei caratteri consentito, ad esempio <code>123 di 4000</code>. Quando la funzione \00E8 attiva \00E8 necessario s')
||'pecificare l''attributo Lunghezza massima.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.4415)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Rimuovi spazi'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 utilizzata per rifilare il valore dell''elemento dopo la sottomissione della pagina. Questa impostazione rimuove gli spazi, le tabulazioni e i caratteri di nuova riga dal testo immesso.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4415)
,p_display_sequence=>10
,p_display_value=>'Iniziale'
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4415)
,p_display_sequence=>20
,p_display_value=>'Finale'
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4415)
,p_display_sequence=>30
,p_display_value=>'Iniziale e finale'
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4415)
,p_display_sequence=>40
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>'Report classico'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Report semplificato basato su una query SQL. I report classici sono simili ai report interattivi, ma non comprendono le numerose opzioni di personalizzazione per l''utente finale disponibili nei report interattivi.'
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.4415)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.4415)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>'Form tabulare'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Visualizzare pi\00F9 righe di dati in un layout griglia, in cui gli utenti finali possono aggiornare i valori direttamente all''interno di un elemento della griglia.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.4415)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.4415)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>'Report interattivo'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Report in linea completo basato su una query SQL che fornisce agli utenti finali numerose funzioni per la personalizzazione del layout del report in runtime. \00C8 possibile controllare le capacit\00E0 degli utenti finali abilitando o disabilitando le var')
||'ie opzioni di personalizzazione del report.</p>',
unistr('<p>\00C8 possibile definire un solo report interattivo e consentire agli utenti finali di manipolare i dati visualizzati per soddisfare requisiti di report specifici anzich\00E9 sviluppare numerosi report simili con criteri diversi per soddisfare gli stessi ')
||'requisiti.</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.4415)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Struttura menu Azioni'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Specificare se la struttura del menu Azioni sar\00E0 coerente con il componente Griglia interattiva oppure se verr\00E0 utilizzata la struttura precedente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4415)
,p_display_sequence=>10
,p_display_value=>'Precedente'
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4415)
,p_display_sequence=>20
,p_display_value=>'Griglia interattiva'
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.4415)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4415)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>'Contenuto statico'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Visualizzare il contenuto di testo o un contenitore aree per gli elementi di pagina. Per restituire il markup HTML e non applicare la funzione di escape al contenuto, impostare <em>Tipo output</em> su <strong>HTML</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.4415)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>'Espandi scorciatoie'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>'Specificare se &PRODUCT_NAME. espande le scorciatoie nel corpo HTML.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.4415)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Tipo output'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di output del contenuto di testo.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4415)
,p_display_sequence=>10
,p_display_value=>'Testo (caratteri speciali di escape)'
,p_return_value=>'TEXT'
,p_help_text=>'&PRODUCT_NAME. applica la funzione di escape ai caratteri speciali HTML, ad esempio <code>"<", ">", "&"</code>, quando restituisce l''origine dell''area.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4415)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME. include il markup HTML quando restituisce l''origine dell''area. Ci\00F2 pu\00F2 rendere l''area vulnerabile agli attacchi di tipo XSS (Cross Site Scripting).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.4415)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Mostra interruzioni di riga'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>'Specificare se le interruzioni di riga nell''origine dell''area causano interruzioni di riga nell''output dell''area.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.4415)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4415)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>'Contenuto dinamico PL/SQL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza l''output HTML del codice PL/SQL.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.4415)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.4415)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>'Grafico SVG'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Visualizzare i dati in un grafico SVG. Questo tipo di area non \00E8 pi\00F9 valido. Usare il tipo di area <em>Grafico</em> per le nuove aree di grafico. Oracle consiglia di usare <em>Aggiorna applicazione</em> per aggiornare queste aree all''area grafico equ')
||'ivalente.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.4415)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.4415)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>'Grafico semplice'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Visualizzare i dati in un grafico HTML. Questo tipo di area non \00E8 pi\00F9 valido. Utilizzare il tipo di area <em>Grafico</em> per le nuove arre di un grafico. Oracle consiglia di usare <em>Aggiorna applicazione</em> per aggiornare queste aree all''area Gr')
||'afico equivalente.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>'Struttura'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizzare i dati in una struttura gerarchica basata sulle relazioni padre-figlio tra i record.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>'Attiva collegamento nodo con'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selezionare l''azione necessaria per attivare i collegamenti di nodo nella struttura. Una struttura pu\00F2 essere utilizzata principalmente per la selezione/visualizzazione o per la navigazione. Se la struttura \00E8 utilizzata sia per la selezione che pe')
||unistr('r la navigazione, \00E8 consigliabile impostare questa opzione su Doppio clic, in modo che un singolo clic consenta solo di selezionare il nodo.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4415)
,p_display_sequence=>10
,p_display_value=>'Clic singolo'
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4415)
,p_display_sequence=>20
,p_display_value=>'Doppio clic'
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>'Elemento pagina nodo selezionato'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare l''elemento di pagina o di applicazione che si desidera contenga il valore del nodo selezionato. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.</p>'),
unistr('<p>Impostato come contenitore del valore dell''ultimo nodo selezionato, questo elemento pu\00F2 essere usato per salvare lo stato della struttura. Il valore del nodo selezionato pu\00F2 essere salvato nell''elemento selezionato mediante l''attributo di collegam')
||unistr('ento del nodo o un processo di pagina. Quando la pagina verr\00E0 caricata di nuovo, la struttura verr\00E0 aperta sull''ultimo nodo selezionato.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>'Descrizione comandi'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare se le descrizioni comandi e l''origine delle descrizioni comandi devono essere visualizzate. Se definita, la descrizione comandi viene visualizzata quando l''utente finale attiva o sposta il mouse sull''etichetta di un nodo della struttura.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4415)
,p_display_sequence=>10
,p_display_value=>'Nessuno'
,p_return_value=>'N'
,p_help_text=>unistr('Non verr\00E0 visualizzata alcuna descrizione comandi.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4415)
,p_display_sequence=>20
,p_display_value=>'Modello precedente'
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>'Utilizzare un valore descrizione comandi statico con le seguenti sostituzioni di colonna di origine dati: #VALUE#, #TITLE#, #LINK# e #TOOLTIP#'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4415)
,p_display_sequence=>30
,p_display_value=>'Espressione HTML'
,p_return_value=>'TEMPLATE'
,p_help_text=>'Fornire l''espressione HTML da usare come descrizione comandi. Le sostituzioni vengono eseguite.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4415)
,p_display_sequence=>40
,p_display_value=>'Colonna di database'
,p_return_value=>'DB'
,p_help_text=>'Usa il valore della <strong>colonna Descrizione comandi</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>'Valore descrizione comandi'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>'Immettere il testo visualizzato quando l''utente finale sposta il mouse su un elemento della struttura.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>'ID struttura statica'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identificativo univoco facoltativo per la struttura.</p>',
unistr('<p>Per accedere all''elemento della struttura, \00E8 preferibile assegnare un ID statico all''area e usare l''interfaccia API apex.region("<i>static-id</i>").widget().</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>'Classe CSS tipo di icona'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Classe CSS utilizzata per specificare il tipo di icone utilizzate per tutti i nodi. Questa classe \00E8 utilizzata nelle regole CSS per specificare le propriet\00E0 per tutte le icone del tipo in questione. Il tipo di icona, insieme al valore della colonn')
||'a delle icone per l''origine dell''area, determina le classi CSS di icona utilizzate per ogni nodo.</p>',
'<p>Di seguito sono riportati i valori standard.</p>',
'<ul>',
'<li><strong><code>a-Icon</code></strong>: consente di usare un piccolo numero di icone APEX incorporate, ad esempio <code>icon-circle</code> o <code>icon-tree-folder</code>.</li>',
'<li><strong><code>fa</code></strong>: consente di usare le icone Carattere APEX o Font Awesome. Il tema universale rende disponibile una di queste librerie di icone.</li>',
'</ul>',
unistr('<p>Se non viene specificato alcun valore, il tipo di icone non verr\00E0 preso in considerazione. Se necessaria, la classe CSS del tipo di icone pu\00F2 essere inclusa nella colonna delle icone. Ad esempio, il valore della colonna delle icone potrebbe essere')
||' "fa fa-user".',
'Per una struttura senza icone non specificare alcun valore per gli attributi Tipo di icona e Icona predefinita; inoltre, la colonna delle icone dell''origine Query SQL deve essere nulla.',
unistr('I temi personalizzati o di terze parti possono disporre di proprie librerie di caratteri o di icone sprite CSS e usare una classe di tipo/prefisso per le icone diversa che \00E8 possibile specificare qui.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>'Classe CSS icone predefinite'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>Se l''opzione Tipo di icona \00E8 impostata su <code>fa</code> per Carattere APEX, \00E8 possibile utilizzare valori quali <code>fa-user-circle-o</code>, <code>fa-file-o</code> o <code>fa-arrow-circle-right</code>. Per la lista di tutte le icone disponibil')
||'i, vedere l''applicazione con tema universale.</p>'
,p_help_text=>unistr('Icona predefinita da utilizzare per la colonna dell''icona Query SQL \00E8 nulla. Il valore \00E8 un nome di classe CSS che specifica quale icona sar\00E0 visibile. I valori possibili dipendono dal tipo di icona.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>'Colonna etichetta nodo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Selezionare la colonna di origine dati che contiene il valore per l''etichetta del nodo. Il valore non pu\00F2 contenere markup.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>'Colonna livello gerarchia'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Selezionare la colonna di origine dati che contiene il valore per il livello di gerarchia del nodo. Obbligatorio quando l''attributo <strong>Gerarchia</strong> \00E8 impostato su <strong>Calcolo non eseguito</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>'Colonna classi CSS icona'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Selezionare la colonna di origine dati che contiene il valore per la classe CSS dell''icona da applicare al nodo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>'Colonna ID nodo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Selezionare la colonna di origine dati che contiene l''ID di un nodo. Questa operazione \00E8 necessaria durante la fase di calcolo della gerarchia da parte di Application Express. In genere qui viene scelta una colonna chiave primaria.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>'Colonna chiave padre'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>'Selezionare la colonna di origine dati che contiene il valore della chiave padre di un nodo. Obbligatorio quando Application Express calcola la gerarchia.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>'Colonna stato nodo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Selezionare la colonna di origine dati che contiene il valore per lo stato del nodo. Obbligatorio quando l''attributo <strong>Gerarchia</strong> \00E8 impostato su <strong>Calcolo non eseguito</strong>. La colonna deve contenere <strong>0</strong> per i n')
||'odi foglia e <strong>1</strong> per i nodi con figli.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>'Inizia struttura con'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Questo attributo determina le modalit\00E0 di calcolo della radice della struttura. I nodi per i quali la colonna <strong>Chiave padre</strong> contiene il valore definito qui verranno considerati nodi radice. Sono possibili pi\00F9 radici.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4415)
,p_display_sequence=>10
,p_display_value=>'Basato su elemento esistente'
,p_return_value=>'ITEM'
,p_help_text=>'Usa un valore elemento per iniziare la struttura ad albero.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4415)
,p_display_sequence=>20
,p_display_value=>'Basato su query SQL'
,p_return_value=>'SQL'
,p_help_text=>'Usa il valore restituito da una query SQL per iniziare la struttura ad albero.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4415)
,p_display_sequence=>30
,p_display_value=>'Basato su valore statico'
,p_return_value=>'STATIC'
,p_help_text=>'Usa un valore statico per iniziare la struttura ad albero.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4415)
,p_display_sequence=>40
,p_display_value=>'Valore NULL'
,p_return_value=>'NULL'
,p_help_text=>'Usa SQL NULL per iniziare la struttura ad albero.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>'Scegliere l''elemento che contiene il valore per iniziare la struttura ad albero.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>'Query SQL'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>'Specificare la query SQL per determinare il valore con cui iniziare la struttura ad albero. La query SQL viene sempre eseguita nel <em>database locale</em> e deve restituire esattamente una colonna.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>'Valore statico'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>'Valore statico con cui iniziare la struttura ad albero.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>'Colonna valori nodo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Selezionare la colonna di origine dati che contiene il valore per il nodo "value". Questo valore non viene visualizzato, ma aggiunto alla propriet\00E0 ID nodo adattatore della struttura accessibile tramite JavaScript.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>'Collegamento'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Specificare il collegamento da eseguire quando si fa clic su un nodo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>'Colonna descrizione comandi'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>'Selezionare la colonna di origine dati che contiene il valore per la descrizione comandi del nodo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>'Gerarchia'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indicare se Application Express deve calcolare la gerarchia della struttura ad albero dai dati o se i dati contengono gi\00E0 tutte le informazioni sulla gerarchia.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4415)
,p_display_sequence=>10
,p_display_value=>'Calcolata con SQL'
,p_return_value=>'SQL'
,p_help_text=>unistr('La gerarchia viene calcolata utilizzando la clausola SQL START WITH CONNECT BY. \00C8 obbligatorio fornire una <strong>Colonna chiave padre</strong>. Usare questa opzione solo se la query SQL <em>non</em> contiene gi\00E0 una clausola START WITH CONNECT BY.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4415)
,p_display_sequence=>20
,p_display_value=>'Non calcolata'
,p_return_value=>'LEVEL'
,p_help_text=>unistr('I dati contengono gi\00E0 tutte le informazioni relative alla gerarchia. Per questa opzione \00E8 richiesto il mapping delle colonne <strong>Livello nodo</strong> e <strong>Stato nodo</strong>. La colonna <strong>Livello nodo</strong> deve contenere il livel')
||'lo della gerarchia come valore numerico, mentre la colonna <strong>Stato nodo</strong> deve contenere <strong>0</strong> per un nodo foglia e  <strong>1</strong> per un nodo non foglia.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>'Colonna di collegamento'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Selezionare la colonna di origine dati che contiene il valore per il collegamento da eseguire quando si fa clic su un nodo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>'Ordina valori di pari livello per'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>'Selezionare la colonna di origine dati da utilizzare per ordinare gli elementi figlio all''interno di un nodo padre.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere una funzione JavaScript che assuma un oggetto di opzioni per la struttura, modifichi l''oggetto e quindi lo restituisca. Ci\00F2 consente di effettuare la personalizzazione avanzata della struttura durante l''inizializzazione del widget treeVi')
||'ew. Per conoscere le opzioni disponibili, consultare la documentazione dell''interfaccia API JavaScript del widget treeView.<p>',
'<p>Opzioni aggiuntive definite dall''area della struttura:</p>',
'<ul>',
'<li><strong>makeNodeAdapter</strong>: utilizzata per definire un nodeAdapter personalizzato. Si tratta di una funzione che assume gli stessi argomenti di makeDefaultNodeAdapter e deve restituire un''interfaccia treeNodeAdapter.</li>',
'<li><strong>initialSelectedNodeId</strong>: il valore di un nodo da selezionare. Viene impostata in base all''attributo Elemento pagina nodo selezionato.</li>',
unistr('<li><strong>nodeHasTooltip</strong>: viene impostata in base all''attributo Descrizione comandi. L''impostazione \00E8 true se il nodo dispone della descrizione comandi, altrimenti \00E8 false.</li>'),
'<li><strong>regionStaticId</strong>: l''identificativo elemento utilizzato per questa area.</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Quando l''attributo Gerarchia \00E8 impostato su Calcolata con SQL</dt>'),
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
'<p>Specificare EMPNO per Colonna ID nodo, MGR come Colonna chiave padre</p>',
'</dd>',
unistr('<dt>Quando l''attributo Gerarchia \00E8 impostato su Non calcolata</dt>'),
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
'<p>Specificare STATUS per Colonna stato nodo, LEVEL per Colonna livello gerarchia.</p>',
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.4415)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4415)
,p_name=>'treeviewselectionchange'
,p_display_name=>'Modifica selezione'
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>'Calendario'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizzare le voci basate su data in varie vista calendario.</p>',
unistr('<p>Utilizzare <em>Calendario</em> anzich\00E9 questo tipo di area quando si creano nuove aree. Le aree Calendario classico sono in genere quelle create in &PRODUCT_NAME. Release 4.2 o precedente.</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.4415)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.4415)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>'Struttura classica'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizzare i dati in una struttura gerarchica basata sulle relazioni padre-figlio tra i record.</p>',
unistr('<p>Quando si creano nuove aree, usare il tipo <em>Struttura</em> anzich\00E9 questo tipo di area. </p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.4415)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'ID componente struttura'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>'Espandi struttura'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Espandere il nodo corrente in un''area della struttura.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>'Comprimi struttura'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Comprimere il nodo corrente in un''area della struttura.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>'Password'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza un elemento di form con password HTML. Quando l''utente immette il testo, al posto di ogni carattere immesso viene visualizzato un punto nero.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.4415)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Sottometti se si preme Invio'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specificare se premendo il tasto <em>Invio</em> in questo campo si sottomette la pagina in modo automatico.'
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>'Arresta e avvia layout griglia'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Elemento precedente utilizzato per interrompere la tabella HTML precedente e iniziare una nuova tabella HTML. Prima dell''introduzione di <em>Layout griglia</em> in &PRODUCT_NAME. Release xx, questo tipo di elemento veniva utilizzato spesso per per'
||'sonalizzare la visualizzazione degli elementi di pagina.</p>',
unistr('<p>Oracle consiglia di eliminare gli elementi precedenti di questo tipo e di impostare <em>Inizia nuova griglia</em> su <strong>S\00EC</strong> per l''elemento di pagina successivo visualizzato nell''area. Questa funzionalit\00E0 \00E8 l''equivalente di Arresta e a')
||'vvia layout griglia.</p>'))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>'Aggiorna'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Attiva l''aggiornamento degli elementi interessati. Non tutti gli elementi supportano un''azione di aggiornamento. \00C8 possibile utilizzare questa azione per aggiornare il contenuto dei report interattivi, dei report classici e di tutti i tipi di element')
||'i con supporto di LOV a catena.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>'Mostra'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Mostra gli elementi interessati.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.4415)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostra tutto sulla stessa riga'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se mostrare tutti gli elementi e le etichette di pagina sulla stessa riga degli elementi interessati.</p>',
'<p>Nota: questo attributo non funziona per gli elementi sulle pagine che non usano una griglia di tabella per visualizzare gli elementi di form. Sono incluse tutte le pagine che usano un modello di pagina per sistemi portatili.</p>'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>'Variabile di intestazione HTTP'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Autenticazione esterna, in cui il nome utente viene memorizzato in una variabile di intestazione HTTP impostata dal Web server.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.4415)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome variabile intestazione HTTP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specifica il nome della variabile dell''intestazione HTTP contenente il nome utente. Se non si specifica alcun valore, verr\00E0 utilizzato REMOTE_USER.</p>'),
'',
unistr('<p>La variabile dell''intestazione HTTP \00E8 una variabile impostata dal Web server.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.4415)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Azione se nome utente non specificato'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Specifica l''azione da eseguire se il nome utente memorizzato nella variabile dell''intestazione HTTP \00E8 vuota. Sono disponibili le opzioni elencate di seguito.'),
'</p>',
'<p>',
'<ul>',
'  <li><strong>Reindirizza su URL built-in</strong>: consente di avviare un login dal Web server. Questo URL built-in deve essere impostato per la protezione da parte del Web server, in modo da forzare un login quando viene richiamato. Dopo il login, '
||unistr('il Web server deve memorizzare il nome utente convalidato nella variabile dell''intestazione HTTP, in modo che sia disponibile per lo schema di autenticazione. L''URL built-in \00E8'),
'<pre>/apex/apex_authentication.callback</pre>',
'Il prefisso <code>/apex/</code> dipende dalla configurazione del server.',
'</li>',
'  <li><strong>Reindirizza a URL</strong>: consente di avviare un login da un server esterno che quindi imposta il nome utente convalidato nella variabile dell''intestazione HTTP. Il server esterno deve essere reindirizzato all''applicazione utilizzando'
||' l''URL generato dal segnaposto <code>#CALLBACK#</code> per completare l''autenticazione nell''applicazione.</li>',
unistr('  <li><strong>Visualizza errore</strong>: consente di visualizzare il messaggio di errore specificato. Non verr\00E0 eseguito alcun login all''applicazione.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4415)
,p_display_sequence=>10
,p_display_value=>'Reindirizza su URL built-in'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4415)
,p_display_sequence=>20
,p_display_value=>'Reindirizza a URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4415)
,p_display_sequence=>30
,p_display_value=>'Visualizza errore'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.4415)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>'Specifica l''URL di un server di login esterno che imposta il nome utente convalidato nella variabile dell''intestazione HTTP. Il server esterno deve essere reindirizzato all''applicazione utilizzando l''URL generato dal segnaposto <code>#CALLBACK#</code'
||'> per completare l''autenticazione nell''applicazione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.4415)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Messaggio di errore'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifica il messaggio di errore da visualizzare se la variabile dell''intestazione HTTP non contiene un valore oppure se la variabile dell''intestazione HTTP non esiste.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.4415)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verifica nome utente'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifica la frequenza della verifica del nome utente memorizzato nella variabile dell''intestazione HTTP. Sono disponibili le opzioni riportate di seguito.',
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>Ogni richiesta</strong>: prevede che la variabile CGI venga sempre impostata non appena \00E8 stato eseguito il login dal Web server. Se il nome utente non \00E8 uguale a quello memorizzato nella sessione corrente di &PRODUCT_NAME., la sessione')
||unistr(' verr\00E0 invalidata e verr\00E0 avviato un nuovo login. Si tratta dell''opzione pi\00F9 sicura perch\00E9 rileva i logout o le variazioni a livello di nome utente.'),
'  </li>',
unistr('  <li><strong>Dopo il login</strong>: verificher\00E0 e memorizzer\00E0 solo il nome utente nella sessione di &PRODUCT_NAME. dopo che il Web server ha eseguito il login e ha chiamato il callback per completare l''autenticazione nell''applicazione. Per informaz')
||'ioni sul callback, vedere la configurazione dell''opzione "Azione se nome utente non specificato".',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4415)
,p_display_sequence=>10
,p_display_value=>'Ogni richiesta'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4415)
,p_display_sequence=>20
,p_display_value=>'Dopo il login'
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.4415)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'URL di logout del server SSO.'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Per la funzione Single Sign-On basata su Oracle Access Manager, immettere ad esempio:</p>',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se lo schema di autenticazione \00E8 basato su Oracle Access Manager o su server simili,'),
unistr('\00E8 possibile usare questo attributo per specificare un URL per eseguire il logout dal server Single Sign-On centrale.</p>'),
'',
unistr('<p>Il parametro di sostituzione <code>%POST_LOGOUT_URL%</code> verr\00E0 sostituito dall''URL codificato alla pagina di login dell''applicazione.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>'Espressione HTML'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza un elemento che non pu\00F2 essere immesso, basato su un''espressione HTML.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.4415)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Espressione HTML'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifica dei colori dello sfondo e del testo</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Uso dell''intestazione 2</dt>',
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Uso di una classe dinamica dalla query SQL</dt>',
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Le sostituzioni <code>&amp;COLUMN_CLASS!ATTR.</code> e <code>&amp;EMPLOYEE_STATUS.</code> in questo esempio sono colonne selezionate nella query SQL.</dd>',
'  <dt>Visualizzazione di un''immagine e della descrizione comandi al passaggio del mouse</dt>',
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>'Immettere le espressioni HTML da mostrare in questa colonna. Usare la sintassi <code>&amp;COLUMN.</code> per mostrare i valori di colonna in formato HTML.'
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>'Collegamento'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza un elemento che non pu\00F2 essere immesso, come un collegamento.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>'Cancella'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Cancella gli elementi interessati.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>'Avviso'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza un messaggio di avviso con un pulsante <em>OK</em>. Pu\00F2 essere utilizzato per visualizzare informazioni alle quali \00E8 necessario rispondere premendo un pulsante, senza tuttavia interrompere l''esecuzione dell''evento.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.4415)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Messaggio'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>'<p> &lt;strong&gt;Impossibile&lt;&#x2F;strong&gt; eliminare il dipendente &amp;P1_ENAME.</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il messaggio da visualizzare nella finestra di dialogo di avviso.</p>',
'<p>Le stringhe di sostituzione degli elementi verranno eseguite sul lato client quando viene visualizzata la finestra di dialogo.</p>'))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.4415)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Titolo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'<p>Fornire facoltativamente un titolo per la finestra di dialogo.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.4415)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Stile'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Valore predefinito'
,p_help_text=>'Specificare lo stile della finestra di dialogo.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4415)
,p_display_sequence=>10
,p_display_value=>'Informazioni'
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4415)
,p_display_sequence=>20
,p_display_value=>'Pericolo'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4415)
,p_display_sequence=>30
,p_display_value=>'Avvertenza'
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4415)
,p_display_sequence=>40
,p_display_value=>'Operazione riuscita'
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.4415)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Icona'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Specificare un''icona facoltativa per la finestra di dialogo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.4415)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Classi CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Immettere le classi CSS facoltative da applicare al contenitore della finestra di dialogo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.4415)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Etichetta OK'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Immettere l''etichetta del pulsante OK. Se non viene fornita alcuna etichetta, verr\00E0 utilizzato il valore del messaggio di testo <code>APEX.DIALOG.OK</code>.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>'Conferma'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza una finestra di dialogo contenente i pulsanti Annulla e Conferma. Se l''utente sceglie <em>Annulla</em>, le azioni precedenti non vengono eseguite e l''evento corrente viene annullato.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.4415)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Messaggio'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;Si \00E8 certi&lt;&#x2F;strong&gt; di voler eliminare il dipendente &amp;P1_ENAME.?</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il messaggio da visualizzare nella finestra di dialogo di conferma.</p>',
'<p>Le stringhe di sostituzione degli elementi verranno eseguite sul lato client quando viene visualizzata la finestra di dialogo.</p>'))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.4415)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Titolo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'<p>Fornire facoltativamente un titolo per la finestra di dialogo.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.4415)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Stile'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Valore predefinito'
,p_help_text=>'Specificare lo stile della finestra di dialogo.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4415)
,p_display_sequence=>10
,p_display_value=>'Informazioni'
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4415)
,p_display_sequence=>20
,p_display_value=>'Avvertenza'
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4415)
,p_display_sequence=>30
,p_display_value=>'Pericolo'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4415)
,p_display_sequence=>40
,p_display_value=>'Operazione riuscita'
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.4415)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Icona'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Specificare un''icona facoltativa per la finestra di dialogo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.4415)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Classi CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Immettere le classi CSS facoltative da applicare al contenitore della finestra di dialogo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.4415)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Etichetta Conferma'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Immettere l''etichetta del pulsante di conferma. Se non viene fornita alcuna etichetta, verr\00E0 utilizzato il valore del messaggio di testo <code>APEX.DIALOG.OK</code>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.4415)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Etichetta Annulla'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Immettere l''etichetta del pulsante Annulla. Se non viene fornita alcuna etichetta, verr\00E0 utilizzato il valore del messaggio di testo <code>APEX.DIALOG.CANCEL</code>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>'Analizza dati caricati'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Processo per l''analisi dei dati del foglio di calcolo in preparazione al caricamento in una tabella esistente. Questo tipo di processo viene generato dalla Creazione guidata pagina per <em>Caricamento dati</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Definizione caricamento dati'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Selezionare in Componenti condivisi la definizione di caricamento dati che definisce la tabella da caricare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Importa da elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere l''opzione <em>Origine importazione</em> scelta dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento separatore'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il testo <em>Separatore</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Elemento Racchiuso da'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il testo <em>Facoltativamente racchiuso da</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Elemento prima riga'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il valore della casella di controllo <em>La prima riga contiene nomi di colonna</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibil')
||'i.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Elemento simbolo valuta'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il testo <em>Simbolo valuta</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Elemento separatore di gruppo'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il testo <em>Separatore di gruppo</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Elemento carattere decimale'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il testo <em>Carattere decimale</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Elemento nome file'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il valore <em>Nome file</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Elemento Copia e incolla'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il testo <em>Copia e incolla data delimitata</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Elemento set di caratteri'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il <em>Set di caratteri file</em> selezionato dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.4415)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Elemento formato data'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina che dovr\00E0 contenere il testo <em>Formato data</em> immesso dall''utente finale. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>'Mapping colonna caricamento dati'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Colonne del foglio di calcolo caricate mediante mappa nelle colonne della tabella. Questo tipo di area viene generato dalla Creazione guidata pagina per <em>Caricamento dati</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.4415)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Definizione caricamento dati'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Selezionare la definizione di caricamento dati definita nel processo <em>Caricamento dati</em>.'
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>'Prepara dati caricati'
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Processo per la preparazione dei dati del foglio di calcolo al caricamento in una tabella esistente. Questo tipo di processo viene generato dalla Creazione guidata pagina per <em>Caricamento dati</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.4415)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Definizione caricamento dati'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Selezionare in Componenti condivisi la definizione di caricamento dati che definisce la tabella da caricare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.4415)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Elemento inserimento elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il numero dei record da inserire. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.4415)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento conteggio aggiornamenti'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il numero dei record da aggiornare. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.4415)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Elemento conteggio errori'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il numero dei record con errori. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.4415)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Elemento conteggio revisioni'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il numero dei record rivisti. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>'Carica dati caricati'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Processo per il caricamento dei dati del foglio di calcolo analizzati in una tabella o vista esistente. Questo tipo di processo viene generato dalla Creazione guidata pagina per <em>Caricamento dati</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.4415)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Definizione caricamento dati'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Selezionare in Componenti condivisi la definizione di caricamento dati che definisce la tabella da caricare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.4415)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Elemento inserimento elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il numero dei record inseriti.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.4415)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento conteggio aggiornamenti'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il numero dei record aggiornati.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.4415)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Elemento conteggio errori'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il numero dei record con errori.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.4415)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Elemento conteggio revisioni'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il numero dei record rivisti.'),
unistr('\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>'Account di Application Express'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Immettere il nome utente e la password per l''account &PRODUCT_NAME.. Ogni spazio di lavoro dispone del proprio repository di account utente. L''applicazione a cui si sta effettuando il login \00E8 di propriet\00E0 dell''area di lavoro &amp;F4155_WORKSPACE_N')
||'AME.. Le password fanno distinzione tra maiuscole e minuscole.</p>'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>'Credenziali "open door"'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Consente a chiunque di accedere all''applicazione in uso. Immettere un ID che identifichi l''utente corrente come utente dell''applicazione durante questa sessione. In questo modo, verr\00E0 impostato il valore della variabile APP_USER.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>'Account di database'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Questo schema di autenticazione richiede che esista un utente di database (schema) nel database locale. Quando si utilizza questo metodo, il nome utente e la password dell''account di database vengono utilizzati per eseguire l''autenticazione dell''uten'
||'te.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>'Directory LDAP'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Autenticazione dell''utente o della password mediante l''invio di una richiesta di autenticazione a un server LDAP.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.4415)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Il nome host del server delle directory LDAP.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.4415)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Porta'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Il numero di porta dell''host delle directory LDAP. L''impostazione predefinita \00E8 389.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.4415)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Usa SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Scegliere se usare SSL per l''associazione alla directory LDAP. Se si sceglie SSL con autenticazione, \00E8 necessario configurare un wallet per l''istanza di &PRODUCT_NAME..')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4415)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4415)
,p_display_sequence=>20
,p_display_value=>'SSL con autenticazione'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4415)
,p_display_sequence=>30
,p_display_value=>'Nessun SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.4415)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Stringa nome distinto (DN)'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il pattern usato per creare la stringa del nome distinto (DN) completamente qualificato per DBMS_LDAP.SIMPLE_BIND_S se si usa il DN esatto oppure la base di ricerca se si usa un DN non esatto. Usare <strong>%LDAP_USER%</strong> come segnapo'
||'sto per il nome utente. Ad esempio:',
'<p>',
'<strong>DN esatto</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>DN non esatto (base di ricerca)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.4415)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Usa nome distinto (DN) esatto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Scegliere se la stringa del nome distinto (DN) LDAP \00E8 esatta o non esatta. Se \00E8 non esatta, il nome distinto (DN) LDAP \00E8 la base di ricerca ed \00E8 necessario fornire un filtro di ricerca.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.4415)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Filtro di ricerca'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il filtro di ricerca quando non si usa un nome distinto (DN) esatto. Usare <strong>%LDAP_USER%</strong> come segnaposto per il nome utente. Ad esempio:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.4415)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Funzione di modifica nome utente LDAP'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\00C8 possibile fornire codice aggiuntivo da eseguire per trasformare il nome utente in un formato idoneo per la voce di directory LDAP o per il nome utente LDAP.'),
'La bind variable :USERNAME contiene il nome specificato dall''utente finale.',
'Ad esempio, il codice seguente richiama una funzione che sostituisce tutte le occorrenze di "."'' con "_"'' nella stringa DN:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME. utilizzer\00E0 la funzione di escape per il nome utente restituito in base all''attributo di autenticazione <strong>Escape nome utente</strong>.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.4415)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Escape nome utente'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Prima di sostituire <strong>%LDAP_USER%</strong> nel nome distinto e nella stringa di ricerca LDAP,',
unistr('&PRODUCT_NAME. pu\00F2 applicare automaticamente il valore di escape ai caratteri speciali presenti nel nome utente.'),
'<p/>',
'Di seguito sono riportate le regole di escape possibili.',
'<ul>',
'<li><strong>Standard</strong>:',
'applica la funzione di escape ai caratteri speciali in base a RFC 4514 (per i nomi distinti) e a RFC 4515 (per le stringhe di ricerca).',
'La funzione di escape viene applicata anche ai caratteri Unicode.',
unistr('Si tratta dell''impostazione pi\00F9 sicura, che tuttavia pu\00F2 creare problemi con alcuni server LDAP.</li>'),
'<li><strong>Solo caratteri speciali</strong>:',
'applica la funzione di escape ai caratteri speciali in base a RFC 4514 (per i nomi distinti) e a RFC 4515 (per le stringhe di ricerca).',
'Non applica la funzione di escape ai caratteri Unicode.</li>',
'<li><strong>Nessuna funzione di escape</strong>:',
'non applica la funzione di escape ad alcun carattere.',
unistr('Questa impostazione \00E8 potenzialmente non sicura,'),
'a meno che non sia utilizzata la <strong>Funzione di modifica del nome utente</strong> che applica',
unistr('gi\00E0 la funzione di escape al nome utente (ad esempio con apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4415)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4415)
,p_display_sequence=>20
,p_display_value=>'Solo caratteri speciali'
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4415)
,p_display_sequence=>30
,p_display_value=>'Nessuna funzione di escape'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Delega l''autenticazione al server Oracle AS Single Sign-On (SSO). Per usare questo schema di autenticazione, il sito deve essere stato registrato come applicazione partner con il server SSO.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.4415)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome applicazione partner'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se si esegue l''autenticazione con Oracle Application Server Single Sign-On e l''applicazione \00E8 un''applicazione partner registrata con SSO, immettere lo stesso nome utilizzato durante la registrazione dell''applicazione partner con SSO.'),
'</p>',
'<p>',
'Se si utilizza &PRODUCT_NAME. come applicazione partner registrata, lasciare questo campo vuoto.',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.4415)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'URL di logout del server SSO.'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il percorso di logout del server Single Sign-On, ad esempio:',
'<em>https://login.example.com/sso/logout</em>.',
unistr('Al momento del logout dell''applicazione, &PRODUCT_NAME. utilizzer\00E0 questo valore, concatener\00E0 ''?p_done_url='' e l''URL di login dell''applicazione e utilizzer\00E0 l''URL ottenuto per eseguire il logout di Single Sign-On prima di effettuare il reindirizzamen')
||'to all''applicazione.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.4415)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>'Nessuna autenticazione'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Adotta l''utente di database corrente. Pu\00F2 essere usato insieme a una configurazione DAD mod_plsql DAD che utilizza l''autenticazione Basic per impostare la sessione utente del database.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.4415)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome utente'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>'Immettere il nome utente per la sessione di &PRODUCT_NAME. Se non si specifica un nome utente, &PRODUCT_NAME. utilizza l''utente della sessione del database (in genere APEX_PUBLIC_USER).'
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>'Calendario'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizzare le voci basate sulla data in varie viste di calendario. Con l''inclusione di una data di fine, il calendario pu\00F2 visualizzare gli eventi basati sulla durata. Se la funzione di "trascinamento della selezione" \00E8 abilitata, i calendari posso')
||'no inoltre aggiornare direttamente i record.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Chiave API Google Calendar [non pi\00F9 valido]')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Immettere la chiave API Google Calendar per consentire l''integrazione dei calendari all''interno dell''applicazione con i dati dei calendari Google.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>'Colonna data di inizio'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Selezionare la colonna che contiene la data di inizio per gli eventi visualizzati in questo calendario.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Colonna data di fine'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Selezionare la colonna che contiene la data di fine per gli eventi visualizzati in questo calendario. Se questo attributo viene specificato, il calendario visualizza gli eventi basati sulla durata.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>'Colonna di visualizzazione'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Selezionare la colonna che contiene il testo visualizzato per gli eventi in questo calendario.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>'Colonna chiave primaria'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la colonna che contiene il valore della chiave primaria per gli eventi del calendario. Se la tabella dispone di una chiave primaria costituita da pi\00F9 parti, selezionare <strong>ROWID</strong>.</p>'),
'<p>Il valore della colonna selezionata viene restituito nella variabile di sostituzione <code>APEX$PK_VALUE</code>. Utilizzare questa variabile nell''attributo <em>Trascina codice</em> per identificare il record da aggiornare dopo l''operazione di tras'
||'cinamento sul calendario.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>'Visualizza/Modifica collegamento'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Immettere una pagina di destinazione da richiamare quando l''utente fa clic su una voce esistente.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Crea collegamento'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere una pagina di destinazione da richiamare quando l''utente fa clic su una cella vuota o fuori da una voce di calendario esistente.</p>',
'<p>Utilizzare le speciali variabili di sostituzione di calendario <pre>&APEX$NEW_START_DATE.</pre> e <pre>&APEX$NEW_END_DATE.</pre> per passare le date selezionate dal calendario alla pagina di destinazione.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>'Trascinamento della selezione'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se le operazioni di trascinamento della selezione sono consentite in questo calendario.</p>',
unistr('<p><em>Nota: se il trascinamento della selezione \00E8 abilitato, qualsiasi utente finale che dispone dei diritti per visualizzare il calendario potr\00E0 anche aggiornarne le voci.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>'Trascina codice PL/SQL'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Esempio con la sola data di inizio (per gli eventi non basati sulla durata)</dt>',
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'<dt>Esempio con le date di inizio e di fine (per gli eventi basati sulla durata)</dt>',
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice PL/SQL per aggiornare le tabelle di base o le viste aggiornabili quando una voce del calendario viene aggiornata tramite trascinamento della selezione.</p>',
'<p>Se il calendario mostra eventi basati sulla durata (mediante selezione di una colonna per Data di fine), anche il codice PL/SQL deve aggiornare tale valore. Se viene trascinato l''intero evento, la durata corrente viene gestita dalla data di fine. '
||unistr('Se viene trascinata la fine dell''evento, la durata dell''evento viene aggiornata. In questi casi la data di inizio rimarr\00E0 immutata, mentre la data di fine verr\00E0 aggiornata in modo da riflettere la durata aggiornata.</p>'),
'<p>Sono disponibili le variabili di sostituzione di calendario riportate di seguito.</p>',
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
unistr('    <dd>Restituisce la data di inizio aggiornata. Il formato della data \00E8 <code>''YYYYMMDDHH24MISS''</code> anche se l''opzione <em>Mostra ora</em> per il calendario \00E8 <strong>No</strong>.</dd>'),
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>Restituisce la data di fine aggiornata per gli eventi basati sulla durata. Il formato della data \00E8 <code>''YYYYMMDDHH24MISS''</code> anche se l''opzione <em>Mostra ora</em> per il calendario \00E8 <strong>No</strong>.</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
'    <dd>Restituisce il valore della colonna specificata nella colonna di chiave primaria.</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>'Viste di calendario aggiuntive'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare le viste calendario aggiuntive da visualizzare. La vista mensile viene visualizzata sempre.</p>',
unistr('<p>Nota: le viste settimanale e giornaliera non sono disponibili quando l''opzione Mostra ora \00E8 impostata su <strong>No</strong>.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4415)
,p_display_sequence=>40
,p_display_value=>'Lista'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4415)
,p_display_sequence=>50
,p_display_value=>'Navigazione'
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Esporta'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Scegliere i collegamenti di esportazione forniti nella parte inferiore del calendario.</p>',
'<p><em>Nota: verranno esportate tutte le voci del calendario visualizzate al momento e non una singola voce del calendario.</em></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4415)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4415)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4415)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>'Viste di calendario e navigazione'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selezionare le viste calendario da visualizzare. Selezionare almeno un tipo tra <strong>Giorno</strong>, <strong>Settimana</strong> e <strong>Mese</strong>. Se non si effettua alcuna selezione, nel calendario verr\00E0 visualizzata in modo automatico ')
||'la vista <strong>Mese</strong>.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4415)
,p_display_sequence=>10
,p_display_value=>'Mese'
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4415)
,p_display_sequence=>20
,p_display_value=>'Settimana'
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4415)
,p_display_sequence=>30
,p_display_value=>'Giorno'
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4415)
,p_display_sequence=>35
,p_display_value=>'Lista'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4415)
,p_display_sequence=>40
,p_display_value=>'Navigazione'
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'ID Google Calendar'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>'<p>ID Google Calendar: abc123@group.calendar.google.com</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''ID Google Calendar per il feed di dati di calendario da visualizzare in questo calendario.</p>',
'<p>A causa delle limitazioni alla sicurezza di Google Calendar, questi calendari devono essere pubblici o disponibili per tutti gli utenti finali di questo calendario.</p>',
unistr('<p><em>Nota: per il corretto funzionamento dei calendari Google, \00E8 necessario immettere la chiave API Google Calendar. Andare a Componenti condivisi > Impostazioni componente > Calendario per impostare la chiave per l''applicazione.</em</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>'Mostra ora'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare se la parte dell''ora della data deve essere visualizzata. </p>',
unistr('<p>Le viste settimanale e giornaliera saranno visualizzate solo se l''opzione Mostra ora \00E8 impostata su <strong>S\00EC</strong>. Se le colonne della data di inizio o della data di fine non includono componenti temporali, indicheranno un''ora pari alle 12:0')
||'0 am.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>'Classe CSS'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Impostazione dello stile del calendario in base allo stato del progetto</p>',
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare la colonna che contiene la classe CSS per generare lo stile degli eventi visualizzati in questo calendario. <br>',
'Sono disponibili varie classi predefinite.',
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
'Consultare la documentazione per aggiungere altre classi CSS.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Web Service REST (JSON)'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere l''URL per il feed di Web Service RESTful da visualizzare su questo calendario. Il calendario pu\00F2 visualizzare i dati JSON recuperati da origini esterne, ad esempio Oracle REST Data Services. Questi Web Service devono essere pubblici o di')
||'sponibili per tutti gli utenti finali di questo calendario.</p>',
'<p>Il feed JSON deve essere formattato per includere quanto riportato di seguito.</p>',
'<ol>',
'<li>La lista dell''array di eventi contenente - <code>items</code></li>',
'<li>Ogni oggetto di evento contenente - <code>{ id, title, start, allday, end, description }</code><br>Gli attributi title e start sono obbligatori.</li>',
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>'Informazioni supplementari'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere un codice HTML aggiuntivo da visualizzare nella vista lista e nella descrizione comandi. Utilizzare la sintassi &COLUMN. per mostrare i valori delle colonne nel linguaggio HTML. </p>',
unistr('<p>Nota: impostare Mostra descrizione comandi su <strong>S\00EC</strong> per visualizzare queste informazioni aggiuntive nelle viste Mese, Settimana e Giorno.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>'Mostra fine settimana'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Selezionare se i giorni Sabato e Domenica devono essere visualizzati per questo calendario.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>'Formato ora'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Selezionare il formato dell''ora utilizzato per visualizzare la parte ora di un evento per questo calendario.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4415)
,p_display_sequence=>10
,p_display_value=>'Valore predefinito'
,p_return_value=>'00'
,p_help_text=>unistr('Utilizza il formato di indicatore orario dell''applicazione immesso in Globalizzazione. Se questo attributo non viene popolato, verr\00E0 utilizzata l''impostazione NLS del database.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4415)
,p_display_sequence=>20
,p_display_value=>'12 ore'
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizza l''ora con il formato a 12 ore che include a.m. (dal latino <em>ante meridiem</em>, "antimeridiano") e p.m. (<em>post meridiem</em>, "pomeridiano"), ad esempio 8:00 a.m. e 4:00 p.m.</p>',
'<p>Il formato di visualizzazione effettivo per a.m./p.m., per quanto riguarda le lettere maiuscole e i punti, deriva dall''impostazione di Formato indicatore orario.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4415)
,p_display_sequence=>30
,p_display_value=>'24 ore'
,p_return_value=>'24'
,p_help_text=>'Visualizza i valori di ora nel formato a 24 ore, ad esempio 08:00 e 16:00.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>'Mostra descrizione comandi'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare se deve essere visualizzata una descrizione comandi quando gli utenti passano con il puntatore del mouse sopra un evento nel calendario.</p>',
unistr('<p><em>La finestra di dialogo a discesa visualizzer\00E0 il nome dell''evento, informazioni aggiuntive e dettagli sulla data.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>'Prima ora'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Immettere un numero intero compreso tra 0 e 23 per specificare la prima ora visualizzata nei calendari settimanale e giornaliero.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>'Numero massimo di eventi al giorno'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il numero massimo di eventi visualizzati per ogni giorno all''interno della vista mensile. </p>',
unistr('<p>Se esistono pi\00F9 eventi di quelli specificati in un singolo giorno, sar\00E0 visualizzata l''opzione <strong>Altro...</strong>. Fare clic su questo elemento per visualizzare una finestra popup con tutti gli eventi per il giorno specifico.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>unistr('Eventi su pi\00F9 righe')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare <strong>S\00EC</strong> per fare in modo che gli eventi vengano visualizzati su pi\00F9 righe, in base alla lunghezza del testo della colonna di visualizzazione. </p>'),
unistr('<p>Selezionare <strong>No</strong> se si desidera che ogni evento venga visualizzato su una singola riga, troncando il testo che non rientra nella visualizzazione. Il testo completo verr\00E0 visualizzato nella descrizione comandi.</p>'),
unistr('<p>Nota: l''impostazione degli eventi su pi\00F9 righe \00E8 utilizzata solo all''interno della vista mensile. Per la vista settimanale e per quella giornaliera, la durata dell''evento determina l''altezza dell''evento visualizzato.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>'Versione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>FullCalendar 3 non \00E8 pi\00F9 valido e verr\00E0 presto sostituito da FullCalendar 5. Si consiglia di effettuare il cambio ora per non rischiare l''interruzione dell''applicazione nelle versioni future. Se si \00E8 utilizzato un codice JavaScript di inizializzaz')
||unistr('ione personalizzato, tenere presente che l''interfaccia API di FullCalendar \00E8 stata modificata e che il codice dovr\00E0 probabilmente essere adeguato di conseguenza.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.4415)
,p_display_sequence=>10
,p_display_value=>unistr('FullCalendar 3 [non pi\00F9 valido]')
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
'    pOptions.titleFormat      = "[Conference Schedule]";                                // titolo personalizzato',
'   pOptions.slotMinTime      = "07:00:00";                                             // nasconde gli slot prima di minTime',
'    pOptions.slotMaxTime      = "18:00:00";                                             // nasconde gli slot dopo maxTime',
'    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // intestazioni colonne vista settimanale',
'    pOptions.slotDuration     = "00:15:00";                                             // durata slot personalizzata',
'    pOptions.weekNumbers      = true;                                                   // mostra i numeri delle settimane',
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>'Immettere una funzione JavaScript per sostituire gli attributi di inizializzazione FullCalendar standard. La funzione immessa deve restituire un oggetto che contiene gli attributi di inizializzazione del calendario sotto forma di parametri.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Impostazione dello stile del calendario in base allo stato del progetto</p>,',
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare la colonna che contiene la classe CSS per generare lo stile degli eventi visualizzati in questo calendario. Sono disponibili varie classi predefinite:</p>',
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
'<p>Consultare la documentazione per aggiungere altre classi CSS.</p>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_name=>'apexcalendardateselect'
,p_display_name=>'Data selezionata'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_name=>'apexcalendareventselect'
,p_display_name=>'Evento selezionato'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.4415)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4415)
,p_name=>'apexcalendarviewchange'
,p_display_name=>'Vista modificata'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>unistr('Form tabulare - Eliminazione di pi\00F9 righe')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processo per l''eliminazione di pi\00F9 righe da un''area Form tabulare.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.4415)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Proprietario tabella'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Selezionare il nome del proprietario (schema) della tabella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.4415)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome tabella'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.4415)
,p_help_text=>unistr('Immettere un nome tabella o vista aggiornabile con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.4415)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Colonna chiave primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4415)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la colonna che contiene il valore della chiave primaria. Per le tabelle con chiavi primarie costituite da pi\00F9 di due parti, selezionare <strong>ROWID</strong>.</p>'),
'<p>La chiave primaria viene utilizzata per identificare le righe da eliminare e non deve essere modificabile nel form tabulare. Per le nuove righe, il valore della chiave primaria deve essere vuoto.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.4415)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Colonna chiave secondaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4415)
,p_help_text=>unistr('Selezionare la colonna che contiene il secondo valore della chiave primaria. Questo attributo deve essere popolato solo se la chiave primaria \00E8 costituita da due colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.4415)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Clausola WHERE di runtime'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limitare i reparti utilizzando:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>'Immettere la clausola WHERE SQL da aggiungere all''istruzione DELETE generata. Usare questo attributo per limitare i record usati nelle chiamate SQL generate in modo automatico.'
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>'Preferenze utente'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Processo per l''impostazione delle preferenze utente per l''utente finale.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.4415)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare un tipo di processo per reimpostare o impostare le preferenze utente.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4415)
,p_display_sequence=>10
,p_display_value=>'Reimposta preferenze (rimuovi tutte le preferenze per l''utente corrente)'
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4415)
,p_display_sequence=>20
,p_display_value=>'Imposta su valore elemento'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4415)
,p_display_sequence=>30
,p_display_value=>'Imposta su valore elemento se non nullo'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.4415)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome preferenza'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>'Immettere un nome di preferenza.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.4415)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('Selezionare l''elemento di pagina o di applicazione che dovr\00E0 contenere il valore della preferenza. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>'Elaborazione automatica delle righe (DML)'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Processo per l''inserimento, l''aggiornamento o l''eliminazione di record in una singola tabella o vista aggiornabile del database. Questo processo viene utilizzato per elaborare gli elementi di form con origine di tipo <strong>Colonna di database</stro'
||'ng>. Gli attributi immessi per questo processo devono essere correlati agli attributi immessi nel processo <em>Recupero automatico delle righe</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Proprietario tabella'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Selezionare il nome del proprietario (schema) della tabella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome tabella'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.4415)
,p_help_text=>unistr('Immettere un nome tabella o vista con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Elemento chiave primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della colonna della chiave primaria. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'Colonna chiave primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4415)
,p_help_text=>unistr('Selezionare la colonna che contiene il valore della chiave primaria. Per le tabelle con chiavi primarie costituite da pi\00F9 di due parti, selezionare <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Elemento chiave secondaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della colonna della chiave secondaria. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Colonna chiave secondaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4415)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('Selezionare la colonna che contiene il secondo valore della chiave primaria. Questo attributo deve essere popolato solo se la chiave primaria \00E8 costituita da due colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Colonna versione di riga'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la colonna che identifica la versione della riga. Non \00E8 necessario che questa colonna sia presente nella pagina. Lasciare vuoto questo attributo se si desidera usare il checksum incorporato.</p>'),
unistr('<p>La funzione di lock opportunistico usa il rilevamento degli aggiornamenti persi per garantire l''integrit\00E0 dei dati nelle applicazioni in cui \00E8 possibile utilizzare i dati mediante accesso concorrente. &PRODUCT_NAME. pu\00F2 usare un checksum incorpora')
||unistr('to per eseguire il rilevamento degli aggiornamenti persi e determinare la versione della riga. Il checksum \00E8 una funzione hash di tutti i valori di colonna per la riga di tabella specifica. Viene recuperato quando si esegue una query sul record dal d')
||'atabase nel processo <em>Recupero automatico delle righe</em> e il risultato viene successivamente confrontato con l''hash del record corrente nel database come parte di tale processo. Se i due valori sono uguali, l''aggiornamento viene eseguito, altri'
||'menti il processo restituisce un errore.</p>',
'<p>Questo attributo consente di specificare una colonna singola che contiene la versione della riga come metodo alternativo all''elaborazione del checksum incorporato. Questa colonna deve essere aggiornata a ogni aggiornamento di un record nel databas'
||'e. Oracle consiglia di implementare un trigger di database <em>Prima dell''aggiornamento</en> nella tabella per incrementare o aggiornare in altro modo il valore della colonna della versione della riga. Nelle colonne NUMBER si prevede sia contenuto un'
||unistr(' numero di sequenza della riga. Possono essere tuttavia utilizzate anche le colonne DATE e TIMESTAMP. Il vantaggio dell''uso di una colonna singola consiste nel fatto che il motore di &PRODUCT_NAME. non deve eseguire l''hash di tutta la riga, ma pu\00F2 li')
||'mitarsi al semplice confronto del valore di una sola colonna.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Clausola WHERE di runtime'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limitare i reparti:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>'Immettere la clausola WHERE SQL da aggiungere a tutte le istruzioni INSERT, UPDATE e DELETE generate. Usare questo attributo per limitare i record usati nelle chiamate SQL generate in modo automatico.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Restituisci chiave nell''elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il valore della colonna della chiave primaria restituito da un''istruzione SQL INSERT. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.</p>'),
'<p>Specificare questa colonna per ottenere i campi di chiave primaria popolati da sequenze o da trigger di database. Questo valore viene impostato nello stato della sessione dal processo. </p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Restituisci seconda chiave nell''elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che dovr\00E0 contenere il valore della seconda colonna della chiave primaria restituito da un''istruzione SQL INSERT. \00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili')
||'.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Operazioni supportate'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Controlla le operazioni DML (Data Manipulation Language) supportate. Questo processo di manipolazione dati eseguir\00E0 un''operazione DML se il valore della richiesta \00E8 uno di quelli elencati. Se si utilizza un pulsante per sottomettere questa pagina, il')
||' valore della richiesta viene impostato dal pulsante.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4415)
,p_display_sequence=>10
,p_display_value=>'Inserisci'
,p_return_value=>'I'
,p_help_text=>'Attivato da valori di richiesta: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4415)
,p_display_sequence=>20
,p_display_value=>'Aggiorna'
,p_return_value=>'U'
,p_help_text=>'Attivato da valori di richiesta: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4415)
,p_display_sequence=>30
,p_display_value=>'Elimina'
,p_return_value=>'D'
,p_help_text=>'Attivato da valori di richiesta: DELETE, REMOVE, DELETE ROW, DROP'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.4415)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>'Blocca riga'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'<p>Specificare se ogni riga da aggiornare o eliminare deve essere bloccata nella tabella di base prima dell''elaborazione.</p>'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>'Imposta selezione'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Imposta la selezione sugli elementi interessati. Se ne esistono vari, per impostazione predefinita viene selezionato il primo elemento interessato. Questa azione \00E8 molto utile se utilizzata insieme alle azioni <em>Mostra</em> e <em>Abilita</em>, in m')
||'odo che l''utente possa accedere direttamente all''elemento appropriato.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>'Sottometti pagina'
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Sottomette la pagina.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.4415)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Richiesta/nome pulsante'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Immettere il valore della richiesta utilizzato per sottomettere la pagina. Impostare il valore sul nome di un pulsante se un pulsante attiva l''azione dinamica. Ci\00F2 garantisce che la propriet\00E0 <em>Esegui convalide</em> del pulsante venga rispettata du')
||'rante l''elaborazione della pagina.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.4415)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostra elaborazione'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se la pagina corrente viene disattivata e un''animazione di tipo ''elaborazione in corso'' viene visualizzata durante la sottomissione della pagina. Ci\00F2 pu\00F2 risultare utile per impedire azioni da parte dell''utente finale durante le operazion')
||'i caratterizzate da tempi di esecuzione lunghi, ad esempio il nuovo tentativo di fare clic sul pulsante di ricerca quando l''aggiornamento del report si svolge lentamente.'
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>'Campo numero'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Visualizza un campo numerico. Questo tipo di elemento determina in modo automatico che il valore \00E8 un numero.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.4415)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valore minimo'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere il valore minimo consentito. Pu\00F2 essere un valore statico o un valore dinamico che utilizza la sintassi di sostituzione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.4415)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore massimo'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere il valore massimo consentito. Pu\00F2 essere un valore statico o un valore dinamico che utilizza la sintassi di sostituzione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.4415)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Allineamento numeri'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare come allineare il numero visualizzato. Questa impostazione non si applica quando l''elemento viene visualizzato in modalit\00E0 <em>Sola lettura</em> o quando si specificano gli <strong>Attributi elemento form HTML</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4415)
,p_display_sequence=>10
,p_display_value=>'A sinistra'
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4415)
,p_display_sequence=>20
,p_display_value=>'Al centro'
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4415)
,p_display_sequence=>30
,p_display_value=>'A destra'
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>'Dispositivo di scorrimento'
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza un tipo di elemento dispositivo di scorrimento, che consente agli utenti di aggiornate il valore dell''elemento spostando il controllo a sinistra o a destra.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.4415)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valore minimo'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere il valore minimo consentito. Pu\00F2 essere un valore statico o un valore dinamico che utilizza la sintassi di sostituzione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.4415)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore massimo'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere il valore massimo consentito. Pu\00F2 essere un valore statico o un valore dinamico che utilizza la sintassi di sostituzione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.4415)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Incremento passo'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere un valore per forzare l''aggancio del dispositivo di scorrimento a un incremento specifico. Pu\00F2 essere un valore statico o un valore dinamico che utilizza la sintassi di sostituzione.')
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.4415)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Evidenzia selezione'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specificare se il dispositivo di scorrimento deve evidenziare la traccia fino alla posizione del quadratino del dispositivo di scorrimento.'
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>'Invia messaggio di posta elettronica'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processo per l''invio di un messaggio di posta elettronica, e se necessario di uno o pi\00F9 allegati, dall''applicazione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Da'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere l''indirizzo di posta elettronica da visualizzare per il mittente del messaggio. Deve trattarsi di un indirizzo di posta elettronica valido, altrimenti il messaggio non verr\00E0 inviato. Se si desidera usare un valore dinamico, utilizzare la si')
||'ntassi di sostituzione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'A'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere i destinatari di posta elettronica specificando uno o pi\00F9 indirizzi di posta elettronica. Per specificare pi\00F9 indirizzi, usare una lista separata da virgole. Se si desidera usare un valore dinamico, utilizzare la sintassi di sostituzione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Cc'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere i destinatari di posta elettronica in copia specificando uno o pi\00F9 indirizzi di posta elettronica. Per specificare pi\00F9 indirizzi, usare una lista separata da virgole. Se si desidera usare un valore dinamico, utilizzare la sintassi di sostit')
||'uzione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Ccn'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere i destinatari di posta elettronica in copia nascosta specificando uno o pi\00F9 indirizzi di posta elettronica. Per specificare pi\00F9 indirizzi, usare una lista separata da virgole. Se si desidera usare un valore dinamico, utilizzare la sintassi ')
||'di sostituzione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Rispondi a'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Immettere l''indirizzo di posta elettronica al quale devono essere inviate le risposte. Se non lo si specifica, verr\00E0 utilizzato l''indirizzo di posta elettronica presente in <strong>Da</strong>. Utilizzare la sintassi di sostituzione se si desidera ut')
||'ilizzare un valore dinamico.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Oggetto'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4415)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Immettere l''oggetto del messaggio di posta elettronica. Utilizzare la sintassi di sostituzione, ad esempio <code>&amp;P6_PRODUCT_NAME.</code>, se si desidera includere un valore dinamico.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>'Testo non codificato corpo'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il testo del messaggio di posta elettronica. Viene utilizzata la versione in testo non codificato se il client di posta elettronica del destinatario non supporta la visualizzazione in formato Rich Text. Utilizzare la sintassi di sostituz'
||'ione, ad esempio <code>&amp;P6_PRODUCT_NAME.</code>, se si desidera includere contenuto dinamico nel testo.</p>',
unistr('<p><em>Nota: la specifica SMTP/MIME prevede che una singola riga non possa superare i 1000 caratteri. Per rispettare tale limitazione, \00E8 necessario aggiungere caratteri di ritorno a capo o di nuova riga per dividere il testo in blocchi di 1000 caratt')
||'eri o meno. In caso contrario, si verificano errori nei messaggi, che potrebbero essere incompleti o contenere punti esclamativi non presenti nel testo originale.</em></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>'HTML corpo'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4415)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere un testo che restituisca un messaggio HTML multiparte che contenga sia testo non codificato che contenuto HTML. Le impostazioni e le funzionalit\00E0 del client di posta elettronica del destinatario determinano cosa viene visualizzato. Sebbe')
||unistr('ne la maggior parte dei moderni client di posta elettronica siano in grado di leggere un messaggio formattato in HTML, tenere presente che alcuni utenti disabilitano questa funzionalit\00E0 per motivi di sicurezza. Se si desidera includere contenuto dina')
||'mico nel testo, usare la sintassi di sostituzione <code>&amp;P6_PRODUCT_NAME.</code>.</p>',
'<p>Quando si fa riferimento a immagini mediante la tag &lt;img /&gt;, ricordare che il client di posta elettronica del destinatario deve poter accedere alle immagini per poterle visualizzare. Si supponga ad esempio di fare riferimento a un''immagine n'
||'ella rete chiamata hello.gif, come descritto di seguito.</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>In questo esempio, l''immagine non \00E8 allegata al messaggio di posta elettronica, ma vi si fa riferimento nel messaggio. Affinch\00E9 possa visualizzarla, il destinatario deve poter accedere all''immagine mediante un browser Web. Se l''immagine \00E8 protetta')
||unistr(' da un firewall e il destinatario si trova all''esterno del firewall, l''immagine non verr\00E0 visualizzata. Per questo motivo si consiglia di non utilizzare le immagini. Se \00E8 necessario includere immagini, assicurarsi di aggiungere l''attributo ALT per fo')
||'rnire una descrizione testuale nel caso in cui non sia possibile accedere all''immagine.</p>',
unistr('<p><em>Nota: la specifica SMTP/MIME prevede che una singola riga non possa superare i 1000 caratteri. Per rispettare tale limitazione, \00E8 necessario aggiungere caratteri di ritorno a capo o di nuova riga per dividere il testo in blocchi di 1000 caratt')
||'eri o meno. In caso contrario, si verificano errori nei messaggi, che potrebbero essere incompleti o contenere punti esclamativi non presenti nel testo originale.</em></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'SQL allegato'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>L''istruzione SQL deve avere il formato seguente:</p>',
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>Le colonne mime_type e content_id sono facoltative. Se la colonna content_id \00E8 presente, il file verr\00E0 allegato in linea e il valore di content_id verr\00E0 utilizzato per il CID dell''allegato.</p>'),
'<p>Se la colonna content_id contiene il valore ''my_inline_content'', l''immagine potrebbe essere incorporata nel messaggio di posta elettronica utilizzando il codice HTML seguente:</p>',
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere un''istruzione SQL che restituisca uno o pi\00F9 BLOB allegati come file al messaggio di posta elettronica.</p>'),
'<p>Se la colonna content_id contiene un valore nullo, i file associati saranno allegati standard. File come documenti o archivi zip vengono, in genere, allegati in questo modo.</p>',
unistr('<p>Se il valore di content_id non \00E8 nullo, il file associato verr\00E0 contrassegnato come allegato in linea. Il valore della colonna content_id verr\00E0 utilizzato come CID (ID contenuto) dell''allegato. Questo valore CID pu\00F2 essere utilizzato nel codice HT')
||'ML del messaggio di posta elettronica per incorporare le immagini direttamente nel contenuto del messaggio. Tenere presente che alcuni client di posta elettronica non possono visualizzare automaticamente gli allegati in linea. Inoltre, gli standard d'
||unistr('i posta elettronica prevedono vari requisiti per il formato degli identificativi di contenuto. Oracle Application Express non garantisce la conformit\00E0 a questi standard.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>'Invia immediatamente'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specificare se il messaggio di posta elettronica viene inviato immediatamente. Verranno inviati anche tutti i messaggi presenti al momento nella tabella della coda di posta elettronica di &PRODUCT_NAME.. Per impostazione predefinita, &PRODUCT_NAME. m'
||'emorizza i messaggi di posta elettronica non inviati in una tabella e li distribuisce periodicamente per garantire migliori prestazioni del sistema.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>'Modello di posta elettronica'
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Scegliere un modello di posta elettronica da utilizzare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>'Valori segnaposto'
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'I nomi dei segnaposto del modello e i valori da sostituire.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.4415)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>'Sostituzione lingua'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se si specifica un codice lingua, il processo cercher\00E0 il modello da una traduzione dell''applicazione per questa lingua. Se non esiste una traduzione, il processo utilizza la lingua primaria dell''applicazione. \00C8 supportata la sintassi di sostituzi')
||'one.</p>',
unistr('<p>\00C8 supportata la gerarchia del codice lingua. Se si specifica un valore "fr-ca" (Francese - Canada), ma esiste solo una traduzione per il francese (fr), viene utilizzata questa traduzione.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>'Sfoglia file...'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza un campo di testo con il pulsante <em>Sfoglia...</em>. Il pulsante Sfoglia consente all''utente di individuare e caricare un file dal file system locale.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Tipo di memoria'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la tabella del database in cui \00E8 memorizzato il file caricato.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_display_sequence=>10
,p_display_value=>'Colonna BLOB specificata nell''attributo Origine elemento'
,p_return_value=>'DB_COLUMN'
,p_help_text=>'Memorizza il file caricato nella tabella utilizzata dal processo <strong>Elaborazione automatica delle righe (DML)</strong> e nella colonna specificata nell''attributo Origine elemento. Deve trattarsi di una colonna con tipo dati BLOB. Se il file vien'
||unistr('e scaricato, verr\00E0 usato il nome tabella del processo <strong>Recupero automatico delle righe</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_display_sequence=>20
,p_display_value=>'Tabella APEX_APPLICATION_TEMP_FILES'
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Memorizza il file o i file caricati in una posizione temporanea accessibile mediante la vista APEX_APPLICATION_TEMP_FILES. &PRODUCT_NAME. eliminer\00E0 il file o i file in modo automatico alla fine della sessione o alla fine della richiesta di caricam')
||'ento, a seconda dell''opzione scelta per <strong>Momento rimozione file</strong>.</p>',
unistr('<p>Per accedere a un file quando l''opzione <strong>Consenti pi\00F9 file</strong> \00E8 impostata su <strong>No</strong>, utilizzare la sintassi seguente:</p>'),
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
unistr('<p>Per accedere a un file quando l''opzione <strong>Consenti pi\00F9 file</strong> \00E8 impostata su <strong>S\00EC</strong>, utilizzare la sintassi seguente:</p>'),
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- aggiungere il codice qui per memorizzare il file caricato nella propria tabella',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_display_sequence=>30
,p_display_value=>'Tabella WWV_FLOW_FILES'
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Memorizza il file caricato nella tabella <code>WWV_FLOW_FILES</code> di &PRODUCT_NAME..</p>',
'<p>Per accedere al file utilizzare questa sintassi:</p>',
'<pre>',
'select *',
'  from wwv_flow_files',
' where name = :<em>page item name</em>;',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>'Colonna tipo MIME'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Immettere, in maiuscolo, il nome dell''elemento di pagina o di applicazione utilizzato per memorizzare il tipo MIME del file caricato. Il tipo MIME viene usato dal browser per identificare l''applicazione da usare per visualizzare il contenuto dell''ogg'
||'etto BLOB quando il file viene scaricato.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>'Colonna nome file'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Immettere l''elemento di pagina o di applicazione utilizzato per memorizzare il nome del file caricato.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>'Colonna set di caratteri'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Immettere, in maiuscolo, il nome dell''elemento di pagina o di applicazione utilizzato per memorizzare il set di caratteri del file caricato. Il set di caratteri dell''oggetto BLOB non viene impostato in modo automatico al caricamento. Gli utenti final'
||'i devono impostare il set di caratteri per il documento in fase di caricamento.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>'Colonna ultimo aggiornamento BLOB'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Immettere, in maiuscolo, il nome dell''elemento di pagina o di applicazione utilizzato per memorizzare l''indicatore orario corrente quando si carica un file. Questo valore di data viene usato per l''inserimento nella cache del browser.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>'Visualizza collegamento di download'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Specificare se il collegamento di download viene visualizzato quando un oggetto BLOB non vuoto \00E8 associato a questo elemento.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>'Testo di collegamento per il download'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Immettere il testo visualizzato come parte del collegamento di download. Se non si specifica alcun testo, verr\00E0 visualizzato il testo memorizzato in Messaggio di testo per <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code> in Componenti condivisi.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>'Disposizione contenuto'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il modo in cui il browser gestisce il contenuto durante le operazioni di download.</p>',
unistr('<p><em>Nota: non tutti i tipi di contenuto possono essere visualizzati in linea. Il supporto per la visualizzazione del contenuto in linea \00E8 possibile se il browser supporta il tipo MIME specifico.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4415)
,p_display_sequence=>10
,p_display_value=>'In linea'
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4415)
,p_display_sequence=>20
,p_display_value=>'Allegato'
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'Momento rimozione file'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare se &PRODUCT_NAME. deve rimuovere il file temporaneo.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4415)
,p_display_sequence=>10
,p_display_value=>'Fine sessione'
,p_return_value=>'SESSION'
,p_help_text=>'Elimina il file alla fine della sessione corrente di &PRODUCT_NAME..'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4415)
,p_display_sequence=>20
,p_display_value=>'Fine richiesta'
,p_return_value=>'REQUEST'
,p_help_text=>'Elimina il file alla fine della richiesta HTTP corrente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('Consenti pi\00F9 file')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare se \00E8 possibile caricare pi\00F9 file contemporaneamente.</p>'),
'',
unistr('<p>Nota: pi\00F9 nomi file verranno memorizzati sotto forma di lista delimitata da due punti nell''elemento della pagina.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>'Tipi di file'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt>Per indicare che devono essere accettati solo i file immagine</dt>',
'<dd><pre>image/*</pre></dd>',
'<dt>Per indicare che devono essere accettati solo i file immagine e video</dt>',
'<dd><pre>image/*,video/*</pre></dd>',
'<dt>Per indicare che devono essere accettati solo i file immagine PNG</dt>',
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>unistr('Specificare una lista delimitata da virgole dei tipi di file che possono essere utilizzati dal browser per limitare i file che \00E8 possibile caricare.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>'Visualizza come'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare uno stile di visualizzazione per la modalit\00E0 di visualizzazione dell''elemento Sfoglia file.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4415)
,p_display_sequence=>10
,p_display_value=>'Sfoglia file in linea'
,p_return_value=>'INLINE'
,p_help_text=>unistr('Visualizza il campo di input Sfoglia file secondo modalit\00E0 simili a quelle degli altri campi ed elementi di testo nella pagina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4415)
,p_display_sequence=>20
,p_display_value=>'Zona di rilascio in linea'
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('Visualizza il campo di input Sfoglia file come zona di rilascio in linea che pu\00F2 disporre di un titolo e di una descrizione.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4415)
,p_display_sequence=>30
,p_display_value=>'Zona di rilascio blocco'
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('Visualizza il campo di input Sfoglia file come zona di rilascio di tipo procedura guidata che pu\00F2 disporre di un titolo e di una descrizione, nonch\00E9 di un pulsante per la selezione dei file.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4415)
,p_display_sequence=>40
,p_display_value=>'Sfoglia file nativo'
,p_return_value=>'NATIVE'
,p_help_text=>'Usare la formattazione nativa del browser per visualizzare l''elemento Sfoglia file.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>'Titolo zona di rilascio'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specificare il titolo per la zona di rilascio.',
unistr('Se il campo viene lasciato vuoto, verr\00E0 utilizzato per impostazione predefinita il messaggio di testo <code>APEX.ITEM.FILE.DROP_FILE</code> o <code>APEX.ITEM.FILE.DROP_FILES</code>.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>'Descrizione zona di rilascio'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare il testo della descrizione della zona di rilascio.</p>',
unistr('<p>Se il campo viene lasciato vuoto, verranno utilizzati per impostazione predefinita i messaggi di testo riportati di seguito, a seconda dell''impostazione della propriet\00E0 Visualizza come.</p>'),
'<p><strong>Zona di rilascio blocco</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
'<p><strong>Zona di rilascio in linea</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.4415)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Dimensione massima file'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_help_text=>'Immettere la dimensione file massima (in KB) da accettare per i file caricati mediante questo elemento.'
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>'Gestione lista'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizza un elemento di testo con un''icona lista di valori popup, i pulsanti <em>Aggiungi</em> e <em>Rimuovi</em> e una lista di valori selezionati.</p>',
unistr('<p>\00C8 possibile digitare direttamente il valore oppure sceglierlo dalla lista degli elementi disponibili. \00C8 inoltre possibile utilizzare i pulsanti per gestire i valori selezionati. I valori selezionati vengono memorizzati in un''unica stringa separata')
||' da due punti.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.4415)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Recupera'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di visualizzazione dei dati quando si apre la LOV popup.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4415)
,p_display_sequence=>10
,p_display_value=>'Nessun recupero'
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4415)
,p_display_sequence=>20
,p_display_value=>'Recupera primo rowset'
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4415)
,p_display_sequence=>30
,p_display_value=>'Recupera primo rowset e filtra valore corrente'
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.4415)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Conserva maiuscole/minuscole'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se il valore deve rimanere come \00E8 stato immesso oppure deve essere convertito in maiuscolo.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.4415)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4415)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista di valori basata su query SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>Lista di valori con lo stesso valore visualizzato e restituito</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Nota: si seleziona la stessa colonna sia per il valore visualizzato che per quello restituito, utilizzare un alias di colonna.</p>',
'</dd>',
'<dt>Lista di valori con bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: impostare l''attributo <em>Elementi padre LOV a catena</em> su <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> \00E8 un elemento di pagina modificabile della stessa pagina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.4415)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>'Elaborazione automatica delle righe precedente'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Processo per l''inserimento, l''aggiornamento o l''eliminazione di record in una singola tabella o vista aggiornabile del database. Questo processo viene utilizzato per elaborare gli elementi di form con origine di tipo <strong>Colonna di database</stro'
||'ng>. Oracle consiglia di aggiornare questo tipo di processo a <strong>Elaborazione automatica delle righe (DML)<strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.4415)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare le operazioni DML (Data Manipulation Language) supportate.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4415)
,p_display_sequence=>10
,p_display_value=>'Inserisci'
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4415)
,p_display_sequence=>20
,p_display_value=>'Aggiorna'
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4415)
,p_display_sequence=>30
,p_display_value=>'Elimina'
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.4415)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Proprietario tabella'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Selezionare il nome del proprietario (schema) della tabella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.4415)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome tabella'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.4415)
,p_help_text=>unistr('Immettere un nome tabella o vista con distinzione tra maiuscole e minuscole. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.4415)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Elemento chiave primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Immettere l''elemento di pagina o di applicazione che contiene il valore della colonna della chiave primaria. \00C8 possibile digitare il nome oppure selezionarlo nella lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.4415)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>'Colonna chiave primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.4415)
,p_help_text=>unistr('Selezionare la colonna che contiene il valore della chiave primaria. Se la tabella contiene una chiave primaria costituita da pi\00F9 parti, selezionare <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.4415)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Clausola WHERE di runtime'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limitare il reparto:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>'Immettere la clausola WHERE SQL da aggiungere a tutte le istruzioni SELECT, UPDATE e DELETE generate. Usare questo attributo per limitare i record usati nelle chiamate SQL generate in modo automatico.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>'Annulla evento'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Annulla l''evento corrente.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>'Selettore data (jQuery)'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizza un campo di testo con un''icona calendario. Gli utenti finali possono immettere la data direttamente nell''elemento di testo oppure fare clic sull''icona calendario per selezionare una data, e se necessario un''ora, dal popup del calendario'
||'.</p>',
'<p>L''ora viene visualizzata nel popup del calendario solo se il <em>formato di visualizzazione</em> per questo elemento include i componenti di ora</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.4415)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Data evidenziata'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il valore di data predefinito da evidenziare quando si richiama il popup del calendario. Se non si specifica alcun valore, il calendario evidenzia la data e l''ora correnti.</p>',
unistr('<p>Il valore pu\00F2 essere un valore assoluto nel formato <code>''YYYYMMDDHH24MI''</code>, un valore relativo rispetto alla data del giorno, quale ad esempio <code>+7d</code>, oppure un valore dinamico che utilizza la sintassi di sostituzione, a condizion')
||'e che la sostituzione restituisca il formato data o il valore relativo corretto.</p>',
'<p>I valori di data relativi comprendono:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anni a partire dalla data del giorno</dd>',
'  <dt>m</dt>',
'    <dd>+ / - mesi a partire dalla data del giorno</dd>',
'  <dt>w</dt>',
'    <dd>+ / - settimane a partire dalla data del giorno</dd>',
'  <dt>d</dt>',
'    <dd>+ / - giorni a partire dalla data del giorno</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.4415)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Data minima'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere la data minima che pu\00F2 essere fornita come input o selezionata.</p>'),
unistr('<p>Il valore della data pu\00F2 essere un valore assoluto nel formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> o <code>''YYYYMMDDHH24MI''</code>, un valore relativo rispetto alla data del giorno, quale ad esempio <code>+7d</code>, oppure un valore dinamico che')
||' utilizza la sintassi di sostituzione, a condizione che la sostituzione restituisca il formato data o il valore relativo corretto.</p>',
'<p>I valori di data relativi comprendono:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anni a partire dalla data del giorno</dd>',
'  <dt>m</dt>',
'    <dd>+ / - mesi a partire dalla data del giorno</dd>',
'  <dt>w</dt>',
'    <dd>+ / - settimane a partire dalla data del giorno</dd>',
'  <dt>d</dt>',
'    <dd>+ / - giorni a partire dalla data del giorno</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.4415)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Data massima'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere la data massima che pu\00F2 essere fornita come input o selezionata.</p>'),
unistr('<p>Il valore della data pu\00F2 essere un valore assoluto nel formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> o <code>''YYYYMMDDHH24MI''</code>, un valore relativo rispetto alla data del giorno, quale ad esempio <code>+7d</code>, oppure un valore dinamico che')
||' utilizza la sintassi di sostituzione, a condizione che la sostituzione restituisca il formato data o il valore relativo corretto.</p>',
'<p>I valori di data relativi comprendono:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anni a partire dalla data del giorno</dd>',
'  <dt>m</dt>',
'    <dd>+ / - mesi a partire dalla data del giorno</dd>',
'  <dt>w</dt>',
'    <dd>+ / - settimane a partire dalla data del giorno</dd>',
'  <dt>d</dt>',
'    <dd>+ / - giorni a partire dalla data del giorno</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.4415)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostra'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare quando deve essere visualizzato il calendario popup del selettore data.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4415)
,p_display_sequence=>10
,p_display_value=>'Se attivo'
,p_return_value=>'focus'
,p_help_text=>'Il popup del calendario viene visualizzato non appena l''elemento diventa attivo.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4415)
,p_display_sequence=>20
,p_display_value=>'Se si fa clic sull''icona'
,p_return_value=>'button'
,p_help_text=>'Il popup del calendario viene visualizzato quando si fa clic sull''icona.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4415)
,p_display_sequence=>30
,p_display_value=>'Entrambi'
,p_return_value=>'both'
,p_help_text=>'Il popup del calendario viene visualizzato non appena l''elemento diventa attivo e successivamente quando si fa clic sull''icona.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4415)
,p_display_sequence=>40
,p_display_value=>'In linea'
,p_return_value=>'inline'
,p_help_text=>'Il calendario viene sempre visualizzato in linea nella pagina. Non vengono visualizzati campi di testo e la selezione data corrente appare evidenziata nel calendario.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.4415)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Mostra altri mesi'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specificare se devono essere visualizzate le date iniziali del mese precedente e le date finali per il mese successivo. Le date iniziali e finali popolano completamente le prime e le ultime righe del calendario. Ad esempio, se il primo giorno della s'
||unistr('ettimana \00E8 Domenica e il primo del mese corrente visualizzato \00E8 un Mercoled\00EC, Domenica, Luned\00EC e Marted\00EC mostrano gli ultimi tre giorni del mese precedente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.4415)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Numero di mesi'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
'    <dd>Visualizza tre mesi orizzontalmente.</dd>',
'  <dt>[2,3]</dt>',
'    <dd>Visualizza sei mesi, con due righe per tre colonne.</dd>',
'  <dt>[4,3]</dt>',
'    <dd>Visualizza dodici mesi, co quattro righe per tre colonne.</dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il numero di mesi da mostrare nel popup del calendario.</p>',
unistr('<p>Per definire il numero di righe e colonne da visualizzare, \00E8 possibile immettere un valore intero oppure un array bidimensionale utilizzando <code>[<em>row,column</em>]</code>.</p>'),
'<p><em>Nota: vengono visualizzati i mesi successivi alla <strong>data evidenziata</strong>.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.4415)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Lista di navigazione per'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare se le liste di selezione devono essere fornite nel popup del calendario per Mese e/o Anno.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4415)
,p_display_sequence=>5
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4415)
,p_display_sequence=>10
,p_display_value=>'Mese'
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4415)
,p_display_sequence=>20
,p_display_value=>'Anno'
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4415)
,p_display_sequence=>30
,p_display_value=>'Mese e anno'
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.4415)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Intervallo di anni'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
'    <dd>Utilizza anni assoluti per limitare gli anni consentiti agli anni compresi tra il 2000 e il 2010, inclusivo.</dd>',
'  <dt>-05:+05</dt>',
'    <dd>Utilizza date relative per limitare gli anni consentiti ai cinque anni successivi o precedenti a partire dall''anno corrente.</dd>',
'  <dt>+01:+03</dt>',
'    <dd>Utilizza date relative per limitare gli anni consentiti all''anno successivo per un biennio supplementare.</dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''intervallo di anno consentiti mostrati nella lista di selezione <strong>Anno</strong> all''interno del popup del calendario.</p>',
unistr('<p>Il valore anno pu\00F2 essere un valore assoluto nel formato <code>''YYYY:YYYY''</code> oppure pi\00F9 valori relativi, nel formato <code>''-nn:+nn''</code>, dove <code>nn</code> sono valori interi.')))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>'Campo di testo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Visualizza un campo di testo.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.4415)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Sottometti se si preme Invio'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'Specificare se premendo il tasto <em>Invio</em> in questo campo si sottomette la pagina in modo automatico.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.4415)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Disabilitato'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare se questo elemento \00E8 disabilitato, condizione che impedisce agli utenti finali di modificarne il valore.</p>'),
unistr('<p>Un elemento di testo disabilitato viene comunque visualizzato con la stessa formattazione HTML, a differenza del tipo di elemento di <em>sola visualizzazione</em>, per il quale \00E8 prevista la rimozione della formattazione HTML. Gli elementi di test')
||unistr('o disabilitati fanno parte dell''origine della pagina e ci\00F2 consente di valutarne lo stato della sessione. Al contrario, gli elementi di sola visualizzazione non vengono memorizzati nello stato della sessione.</p>')))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.4415)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Invia alla sottomissione della pagina'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Specificare se il valore dell''elemento corrente deve essere inviato quando la pagina viene sottomessa.'
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.4415)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>'Sottotipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selezionare il sottotipo di testo HTML5. Ci\00F2 consente ai dispositivi con tastiera sullo schermo di mostrare un layout di tastiera ottimizzato specifico del sottotipo per facilitare l''input dei dati. La selezione del sottotipo viene utilizzata anche p')
||unistr('er la visualizzazione di un collegamento appropriato con il valore dell''elemento di pagina se visualizzato in modalit\00E0 di sola lettura. Questo attributo non modifica l''elemento di testo, o l''immissione dei dati, quando si usa una tastiera fisica.  '),
'</p>',
unistr('<p><strong><em>Nota:</strong> questa funzione HTML5 \00E8 riconosciuta solo dai browser pi\00F9 moderni. I vecchi browser, non conformi a HTML5, ignorano questo attributo e visualizzano l''elemento di pagina come campo di testo normale.</em></p>')))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4415)
,p_display_sequence=>5
,p_display_value=>'Testo'
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4415)
,p_display_sequence=>10
,p_display_value=>'Posta elettronica'
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4415)
,p_display_sequence=>20
,p_display_value=>'Numero di telefono'
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4415)
,p_display_sequence=>25
,p_display_value=>'Cerca'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4415)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.4415)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>'Rimuovi spazi'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 utilizzata per rifilare il valore dell''elemento dopo la sottomissione della pagina. Questa impostazione rimuove gli spazi, le tabulazioni e i caratteri di nuova riga dal testo immesso.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4415)
,p_display_sequence=>10
,p_display_value=>'Iniziale'
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4415)
,p_display_sequence=>20
,p_display_value=>'Finale'
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4415)
,p_display_sequence=>30
,p_display_value=>'Iniziale e finale'
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4415)
,p_display_sequence=>40
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.4415)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>'Maiuscole/minuscole testo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Nessuna modifica'
,p_help_text=>unistr('Selezionare le modalit\00E0 di trasformazione delle maiuscole e minuscole del testo del valore dell''elemento.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4415)
,p_display_sequence=>10
,p_display_value=>'Minuscole'
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4415)
,p_display_sequence=>20
,p_display_value=>'Maiuscole'
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>'Nascosto'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Elementi inclusi nell''origine della pagina ma non visualizzati. I valori degli elementi nascosti vengono salvati nello stato della sessione. Questi elementi vengono utilizzati di solito per memorizzare i valori richiesti dall''elaborazione delle pagin'
||'e o da altri elementi di pagina, ma non devono essere visualizzati dall''utente finale.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.4415)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valore protetto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Specificando che l''elemento \00E8 protetto, si impedisce la manipolazione del valore quando la pagina viene inviata.')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>'Visualizza immagine'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza un''immagine memorizzata nelle colonne BLOB di un database o basata su un URL di immagine.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Basato su'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare l''origine da cui recuperare l''immagine.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_display_sequence=>10
,p_display_value=>'URL immagine memorizzato in Valore di elemento di pagina'
,p_return_value=>'URL'
,p_help_text=>'L''URL dell''immagine viene letto dal valore memorizzato nello stato della sessione per l''elemento di pagina specificato.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_display_sequence=>20
,p_display_value=>'Colonna BLOB specificata in Origine elemento'
,p_return_value=>'DB_COLUMN'
,p_help_text=>'Legge l''immagine dalla colonna BLOB specificata nell''attributo <strong>Origine elemento</strong>.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_display_sequence=>30
,p_display_value=>'Colonna BLOB restituita da un''istruzione SQL'
,p_return_value=>'SQL'
,p_help_text=>'Visualizza l''immagine in base alla colonna BLOB restituita dall''istruzione SQL specificata.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.4415)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Testo alternativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>'Immettere il testo che viene letto dai lettori di schermo quando un utente finale accede a questo elemento.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.4415)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Colonna testo alternativa'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Immettere, in maiuscolo, il nome dell''elemento di pagina o di applicazione che contiene il testo alternativo per questa immagine. Il testo viene letto dai lettori di schermo quando un utente finale accede a questo elemento.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.4415)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Colonna nome file'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Immettere, in maiuscolo, il nome dell''elemento di pagina o di applicazione che contiene il valore della colonna del nome file associato alla colonna BLOB.'
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.4415)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Colonna ultimo aggiornamento BLOB'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere, in maiuscolo, il nome dell''elemento di pagina o di applicazione che contiene il valore della colonna della data dell''ultimo aggiornamento dell''oggetto BLOB associato.</p>',
unistr('<p>Questo valore viene usato per l''inserimento nella cache del browser e per determinare se l''immagine \00E8 stata modificata dopo l''ultima richiesta inoltrata dal browser. Se non \00E8 stata aggiornata, l''immagine viene recuperata dalla cache del browser, s')
||'e disponibile.</p>',
''))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.4415)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Istruzione SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>'Immettere l''istruzione SQL per la restituzione della colonna BLOB che contiene l''immagine.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.4415)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>'Colonna tipo MIME'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Immettere, in maiuscolo, il nome dell''elemento di pagina o di applicazione utilizzato per memorizzare il tipo MIME del file caricato. Il tipo MIME viene usato dal browser per identificare l''applicazione da usare per visualizzare il contenuto dell''ogg'
||'etto BLOB quando il file viene scaricato.'
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>'Campo di testo con completamento automatico'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza un campo di testo che mostra una lista di valori possibili, basata sul testo gi\00E0 immesso dall''utente finale, in linea con l''elemento di testo. Questa lista viene ulteriormente ridefinita quando l''utente finale digita altro testo.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.4415)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Cerca'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare come eseguire la ricerca del valore immesso. Se si utilizza <em>Caricamento lento</em>, questa impostazione pu\00F2 avere un impatto sulle prestazioni delle query.</p>'),
'<p><em>Nota: la selezione di <strong>Contiene e Maiuscole/minuscole</strong> o di <strong>Contiene e Ignora maiuscole/minuscole</strong> impedisce l''uso degli indici di colonna.</em></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4415)
,p_display_sequence=>10
,p_display_value=>'Contiene e Maiuscole/minuscole'
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4415)
,p_display_sequence=>20
,p_display_value=>'Esatto e Maiuscole/minuscole'
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4415)
,p_display_sequence=>30
,p_display_value=>'Contiene e Ignora maiuscole/minuscole'
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4415)
,p_display_sequence=>40
,p_display_value=>'Esatto e Ignora maiuscole/minuscole'
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.4415)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Caricamento lento'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se i valori corrispondenti vengono recuperati dal database mediante le tecniche di <em>caricamento lento</em>. La funzione Caricamento lento recupera i record corrispondenti dal database ogni volta che l''utente digita un carattere. Se '
||unistr('non \00E8 abilitata, al caricamento della pagina vengono caricati tutti i valori della lista.</p>'),
unistr('<p>Oracle consiglia di usare il <em>caricamento lento</em> quando si dispone di una lista di selezione di grandi dimensioni, in quanto il caricamento di un gran numero di record pu\00F2 avere un impatto negativo sulla durata di caricamento iniziale della')
||' pagina.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.4415)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Valori massimi nella lista'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il numero massimo di elementi da visualizzare nella casella di selezione.</p> ',
'<p>Questo valore contribuisce a evitare i problemi delle prestazioni dovuti alla restituzione di troppe righe e a set di risultati troppo grandi quando sono state immesse solo poche lettere.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.4415)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Ricerca minima'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>'caratteri'
,p_is_translatable=>false
,p_help_text=>'<p>Specificare il numero minimo di caratteri che devono essere immessi prima dell''esecuzione di una ricerca.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.4415)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>'Cache'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Specificare se i risultati della ricerca devono essere inseriti nella cache quando si utilizza il caricamento lento per recuperare i record corrispondenti.</p>'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.4415)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4415)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione e memorizzazione dello stesso valore in un elemento di pagina</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
'<dt>Visualizzazione dei dipendenti di un reparto specifico utilizzando una bind variable</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>Nota: impostare l''attributo <em>Elementi padre LOV a catena</em> su <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> \00E8 un elemento di pagina modificabile della stessa pagina.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.4415)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4415)
,p_name=>'ojupdate'
,p_display_name=>'Aggiorna'
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>'Rich Text Editor'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza un''area di testo con opzioni di formattazione del testo complete. Gli utenti finali possono migliorare il contenuto visualizzato secondo modalit\00E0 simili a quelle disponibili in un elaboratore di testi quale Microsoft Word. Gli utenti final')
||'i possono inoltre <em>tagliare e incollare</em> i documenti, con formato file RTF (Rich Text Format), in questo elemento.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Adattabilit\00E0 [non pi\00F9 valido]')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'Specificare se il Rich Text Editor deve essere adeguato in modo automatico alle dimensioni dell''area contenitore. Questa operazione richiede l''uso del tema universale o di un altro tema rispondente da parte dell''applicazione.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Barra degli strumenti'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare il numero di opzioni di formattazione del testo disponibili nell''editor.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4415)
,p_display_sequence=>10
,p_display_value=>'Di base'
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4415)
,p_display_sequence=>20
,p_display_value=>'Intermedio'
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4415)
,p_display_sequence=>30
,p_display_value=>'Completo'
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Barra degli strumenti espansa'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>'Specificare se l''editor deve essere inizialmente espanso all''interno dell''area di testo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Skin'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare lo skin usato per applicare lo stile all''editor.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4415)
,p_display_sequence=>1
,p_display_value=>'Moono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4415)
,p_display_sequence=>2
,p_display_value=>'Moono Color'
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4415)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Posizione barra degli strumenti'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare il punto dell''area di testo per la visualizzazione dell''editor.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4415)
,p_display_sequence=>10
,p_display_value=>'Inizio pagina'
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4415)
,p_display_sequence=>20
,p_display_value=>'In basso'
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>'Versione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'CKEditor 5'
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>CKEditor 4 non \00E8 pi\00F9 valido e verr\00E0 presto sostituito da CKEditor 5. Si consiglia di effettuare il cambio ora per non rischiare l''interruzione dell''applicazione nelle versioni future. Se si \00E8 utilizzato un codice JavaScript di inizializzazione per')
||unistr('sonalizzato, tenere presente che l''interfaccia API di CKEditor \00E8 stata modificata e che il codice dovr\00E0 probabilmente essere adeguato di conseguenza.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.4415)
,p_display_sequence=>10
,p_display_value=>unistr('CKEditor 4 [non pi\00F9 valido]')
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Altezza minima'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>'pixel'
,p_is_translatable=>false
,p_help_text=>'Impostare l''altezza minima in pixel dell''area modificabile.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Altezza massima'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>'pixel'
,p_is_translatable=>false
,p_help_text=>unistr('Impostare l''altezza massima in pixel dell''area modificabile. Se si lascia vuoto questo attributo, l''editor verr\00E0 ampliato all''infinito durante la digitazione.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>'Formato'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specificare il formato di output per il contenuto immesso nel Rich Text Editor.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4415)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>'Utilizzare HTML per l''origine e l''output di questo Rich Text Editor.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4415)
,p_display_sequence=>20
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
,p_help_text=>'Utilizzare il formato Markdown per l''origine e l''output di questo Rich Text Editor.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.4415)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4415)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
'    // disable the Autoformat feature',
'    options.editorOptions.removePlugins.push(''Autoformat'');',
'    // apply a custom toolbar',
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>'Immettere una funzione JavaScript per sostituire la configurazione dell''editor standard. Le opzioni specifiche di CKEditor5 devono essere applicate a <code>options.editorOptions</code>. Per ulteriori informazioni, vedere la documentazione relativa al'
||'l''API CKEditor5.'
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>'Selettore colori'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Consente agli utenti di scegliere o immettere un colore. \00C8 possibile selezionare i colori da uno spettro di colori.')
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('Modalit\00E0')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la quantit\00E0 di informazioni visualizzate nel selettore colori.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4415)
,p_display_sequence=>10
,p_display_value=>'Semplice'
,p_return_value=>'SIMPLE'
,p_help_text=>'Mostra solo i controlli dello spettro di colori e le eventuali preimpostazioni di colore definite.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4415)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>'Mostra campi aggiuntivi per visualizzare o immettere colori come valori esadecimali, HSL o RGB con valore alfa facoltativo a seconda di quanto specificato in Valore restituito come. Mostra anche i campi per il colore iniziale e corrente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Visualizza come'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di visualizzazione del selettore colori.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4415)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>unistr('Un colore pu\00F2 essere immesso nel campo di testo o scelto dal selettore colori popup.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4415)
,p_display_sequence=>20
,p_display_value=>'In linea'
,p_return_value=>'INLINE'
,p_help_text=>'Un selettore colori viene visualizzato in linea.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4415)
,p_display_sequence=>30
,p_display_value=>'Popup solo colore'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>'Un pulsante apre un selettore colori popup.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4415)
,p_display_sequence=>40
,p_display_value=>'Selettore colori nativi'
,p_return_value=>'NATIVE'
,p_help_text=>'Input del colore del browser nativo. L''interfaccia utente dipende dal browser.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Usa impostazioni predefinite'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica se utilizzare le impostazioni predefinite definite per questo componente in Componenti condivisi > Impostazioni componente o le impostazioni personalizzate.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('Modalit\00E0')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la quantit\00E0 di informazioni visualizzate nel selettore colori.</p>'),
unistr('<p>Tenere presente che non si applica quando Visualizza come \00E8 Selettore colori nativi.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4415)
,p_display_sequence=>10
,p_display_value=>'Semplice'
,p_return_value=>'SIMPLE'
,p_help_text=>'Mostra solo i controlli dello spettro di colori e le eventuali preimpostazioni di colore definite.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4415)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>'Mostra campi aggiuntivi per visualizzare o immettere colori come valori esadecimali, HSL o RGB con valore alfa facoltativo a seconda di quanto specificato in Valore restituito come. Mostra anche i campi per il colore iniziale e corrente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Visualizza come'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di visualizzazione del selettore colori.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4415)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>unistr('Un colore pu\00F2 essere immesso nel campo di testo o scelto dal selettore colori popup.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4415)
,p_display_sequence=>20
,p_display_value=>'In linea'
,p_return_value=>'INLINE'
,p_help_text=>'Un selettore colori viene visualizzato in linea.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4415)
,p_display_sequence=>30
,p_display_value=>'Popup solo colore'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>'Un pulsante apre un selettore colori popup.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4415)
,p_display_sequence=>40
,p_display_value=>'Selettore colori nativi'
,p_return_value=>'NATIVE'
,p_help_text=>'Input del colore del browser nativo. L''interfaccia utente dipende dal browser.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Preimpostazione colore'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare se il selettore colori deve mostrare un set di colori predefiniti e, in caso affermativo, se provengono dal tema o sono personalizzati.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4415)
,p_display_sequence=>10
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4415)
,p_display_sequence=>20
,p_display_value=>'Colori stile tema'
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4415)
,p_display_sequence=>30
,p_display_value=>'Colori personalizzati'
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Colori'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Lista di colori preimpostati da visualizzare nella finestra di dialogo del selettore colori.',
'Separare i colori utilizzando un punto e virgola.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Contrasto con'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Consente di confrontare il colore di questo elemento con il colore di un altro elemento o di un valore statico e di visualizzare il rapporto di contrasto tra di essi nell''interfaccia utente del selettore colori.  ',
unistr('Ci\00F2 pu\00F2 aiutare l''utente nella scelta di colori con contrasto sufficiente per essere accessibili a tutti.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4415)
,p_display_sequence=>10
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4415)
,p_display_sequence=>20
,p_display_value=>'Elemento pagina'
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4415)
,p_display_sequence=>30
,p_display_value=>'Colore statico'
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Elemento di contrasto'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>'Elemento da utilizzare per il confronto dei contrasti.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Colore contrasto'
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>'Colore da utilizzare per il confronto dei contrasti.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.4415)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Valore restituito come'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Specificare il formato del valore del colore restituito da questo elemento. Anche se viene immesso in un formato valido diverso, il colore verr\00E0 presentato, restituito e inviato al server in questo formato.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4415)
,p_display_sequence=>10
,p_display_value=>'Esadecimale'
,p_return_value=>'HEX'
,p_help_text=>unistr('Valore colore esadecimale. Non \00E8 consentito alcun valore alfa. Ad esempio: #2244ee')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4415)
,p_display_sequence=>20
,p_display_value=>'rgb'
,p_return_value=>'RGB'
,p_help_text=>'Rosso, verde, blu nella notazione della funzione rgb. Esempio: rgb(34,68,238)'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4415)
,p_display_sequence=>30
,p_display_value=>'rgb/rgba'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Rosso, verde, blu con alpha facoltativo (trasparenza) nella notazione della funzione rgb/rgba.',
unistr('Se il colore non ha un valore alpha (alpha \00E8 uguale a 1), viene usato un formato rgb.'),
'Se il colore ha un valore alpha, viene usato un formato rgba.',
'Esempio: rgba(34,68,238,0.5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4415)
,p_display_sequence=>40
,p_display_value=>'hsl'
,p_return_value=>'HSL'
,p_help_text=>unistr('Tonalit\00E0, saturazione, luminosit\00E0 nella notazione della funzione hsl. Esempio: hsl(230,86,53)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4415)
,p_display_sequence=>50
,p_display_value=>'hsl/hsla'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Tonalit\00E0, saturazione, luminosit\00E0 con alpha facoltativo (trasparenza) nella notazione della funzione hsl/hsla.'),
unistr('Se il colore non ha un valore alpha (alpha \00E8 uguale a 1), viene usato un formato hsl.'),
'Se il colore ha un valore alpha, viene usato un formato hsla.',
'Esempio: hsla(230,86,53,0.5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4415)
,p_display_sequence=>60
,p_display_value=>'Qualsiasi valore CSS'
,p_return_value=>'CSS'
,p_help_text=>'Qualsiasi formato di colore CSS valido, inclusi i nomi dei colori o una variabile CSS.'
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>'LOV popup'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizza un elemento di testo con un''icona lista di valori popup. Quando l''utente finale fa clic sull''icona, viene visualizzata una finestra popup con un campo di ricerca e la lista dei valori supportati.</p>',
'<p>L''elemento LOV popup si rivela particolarmente adeguato per le liste di grandi dimensioni in quanto gli utenti finali possono immettere i criteri di ricerca per ridurre i valori disponibili visualizzati. Per le liste relativamente brevi, spesso <e'
||unistr('m>Lista di selezione</em> si rivela essere l''elemento pi\00F9 adeguato.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Visualizza come'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di visualizzazione della lista di valori popup.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4415)
,p_display_sequence=>10
,p_display_value=>'Finestra di dialogo modale'
,p_return_value=>'DIALOG'
,p_help_text=>unistr('La lista di valori verr\00E0 visualizzata in una finestra di dialogo modale.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4415)
,p_display_sequence=>20
,p_display_value=>'Popup in linea'
,p_return_value=>'POPUP'
,p_help_text=>unistr('La lista di valori verr\00E0 visualizzata in un popup in linea sotto il campo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Recupero iniziale'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di recupero iniziale dei dati per la lista di valori. Ci\00F2 si applica solo la prima volta che il popup viene aperto dopo il caricamento della pagina o l''aggiornamento dell''elemento, ad esempio a causa di un''operazione a catena.')
||' Vedere anche il numero minimo di caratteri dell''attributo.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4415)
,p_display_sequence=>10
,p_display_value=>'Su richiesta dell''utente'
,p_return_value=>'NO_FETCH'
,p_help_text=>unistr('Inizialmente non verr\00E0 recuperata alcuna lista di valori finch\00E9 l''utente non effettuer\00E0 la ricerca con o senza un termine di ricerca.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4415)
,p_display_sequence=>20
,p_display_value=>'Automatico'
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>'Recupero iniziale della lista di valori senza un termine di ricerca.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4415)
,p_display_sequence=>30
,p_display_value=>'Automatico con valore corrente'
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>'Recupero iniziale della lista di valori con il valore corrente come termine di ricerca.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valori multipli'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se questo elemento pu\00F2 avere pi\00F9 valori o solo un singolo valore. I valori multipli vengono restituiti sotto forma di lista separata da virgole.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Immissione manuale'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se l''immissione manuale \00E8 consentita o meno. Se l''impostazione \00E8 S\00EC, l''utente pu\00F2 selezionare i valori esistenti dalla lista popup dei valori oppure immettere un valore manualmente. Questo funzionamento \00E8 analogo a quello di una casella c')
||unistr('ombinata. Se l''impostazione \00E8 No, l''utente pu\00F2 soltanto selezionare i valori dalla lista popup dei valori. Questo funzionamento \00E8 analogo a quello di una lista di selezione. Quando l''immissione manuale \00E8 consentita, deve essere immesso il valore rest')
||'ituito della lista di valori corrispondente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Ricerca mentre si digita'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Se si sceglie S\00EC, la lista di valori viene filtrata durante la digitazione nel campo di ricerca. Se si sceglie No, la lista di valori non viene filtrata finch\00E9 l''utente non preme Invio o il pulsante dell''icona di ricerca.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Numero minimo di caratteri'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Specificare il numero minimo di caratteri richiesti nel termine di ricerca prima che venga recuperata la lista di valori. Ci\00F2 pu\00F2 essere utile per ridurre la quantit\00E0 di ricerche che viene effettuata quando la query sulla LOV \00E8 molto complessa. Tutti')
||unistr(' i valori visualizzati nella lista devono essere pi\00F9 lunghi di questo valore minimo, altrimenti non potranno essere trovati.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4415)
,p_display_sequence=>10
,p_display_value=>'Nessun minimo (0)'
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4415)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4415)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4415)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4415)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4415)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Titolo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Titolo della finestra di dialogo popup. Se non viene specificato, verr\00E0 utilizzato il titolo predefinito.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Larghezza popup'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('Larghezza del popup. Se non viene specificata, verr\00E0 utilizzato il valore predefinito.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Altezza popup'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('Altezza del popup. Se non viene specificata, verr\00E0 utilizzato il valore predefinito.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Output aggiuntivi'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Restituisce colonne LOV (List of Value) aggiuntive ad altri elementi di pagina e colonne Griglia interattiva. Definisce un mapping di nome colonna LOV a un nome elemento di pagina o ID statico della colonna Griglia interattiva.</p>',
unistr('<p>Nota: \00E8 applicabile solo quando la definizione LOV include colonne aggiuntive.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>'Separatore'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere una funzione JavaScript che acquisisca un oggetto opzioni per l''elemento LOV popup, quindi modifichi e restituisca l''oggetto. Ci\00F2 rende possibile la personalizzazione avanzata della finestra di dialogo dell''elemento LOV popup e del relat')
||'ivo contenuto durante l''inizializzazione.</p>',
'',
'<p>Queste opzioni vengono passate al widget <code>popup</code> o al widget <code>dialog</code> dell''interfaccia utente JQuery:<br>',
'draggable, resizable, width, height, minWidth, minHeight, maxWidth e maxHeight<br>',
'Per informazioni dettagliate, consultare la documentazione del widget dialog dell''interfaccia utente di JQuery.</p>',
'',
unistr('<p>Quando i risultati vengono visualizzati in una lista semplice, l''opzione <code>defaultIconListOptions</code> \00E8 un oggetto che viene passato al widget <code>tableModelView</code>. Per conoscere le opzioni disponibili, consultare la documentazione d')
||'el widget tableModelView APEX.</p>',
'',
unistr('<p>Quando i risultati vengono visualizzati in un griglia, l''opzione <code>defaultGridOptions</code> \00E8 un oggetto che viene passato al widget <code>grid</code>.'),
'Per conoscere le opzioni disponibili, consultare la documentazione del widget grid APEX.</p>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.4415)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4415)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista di valori basata su query SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>Lista di valori con lo stesso valore visualizzato e restituito</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Nota: si seleziona la stessa colonna sia per il valore visualizzato che per quello restituito, utilizzare un alias di colonna.</p>',
'</dd>',
'<dt>Lista di valori con bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: impostare l''attributo <em>Elementi padre LOV a catena</em> su <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> \00E8 un elemento di pagina modificabile della stessa pagina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.4415)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>'Esegui codice lato server'
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Esegue il codice sul server.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.4415)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Codice PL/SQL'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Aumento dello stipendio del 3% per i dipendenti qualificati per l''aumento:</dt>',
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
unistr('<p>Per questo esempio \00E8 necessario immettere <code>P2_DEPTNO</code> in <strong>Elementi da sottomettere</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Specificare un blocco anonimo PL/SQL di sola esecuzione che verr\00E0 eseguito sul server.</p>'),
unistr('<p>\00C8 possibile fare riferimento ad altri elementi di pagina o di applicazione dall''interno dell''applicazione mediante una sintassi di associazione (ad esempio <code>:P1_MY_ITEM</code>). \00C8 inoltre necessario includere gli elementi ai quali si fa rifer')
||'imento in <strong>Elementi pagina da sottomettere</strong>.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.4415)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>'Codice JavaScript'
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Aumento dello stipendio del 3% per i dipendenti qualificati per l''aumento:</dt>',
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
'  // segnaposto per la logica complicata per calcolare se il dipendente necessita dell''aumento',
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
unistr('<p>Per questo esempio \00E8 necessario immettere <code>P2_DEPTNO</code> in <strong>Elementi da sottomettere</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare un blocco JavaScript di sola esecuzione che viene eseguito sul server.</p>',
unistr('<p>\00C8 possibile fare riferimento ad altri elementi di pagina o di applicazione dall''interno dell''applicazione mediante una sintassi di associazione (ad esempio <code>apex.env.P1_MY_ITEM</code>). \00C8 inoltre necessario includere gli elementi ai quali si ')
||'fa riferimento in <strong>Elementi pagina da sottomettere</strong>.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.4415)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Elementi da sottomettere'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere, in maiuscolo, gli elementi di pagina sottomessi al server e quindi disponibili per l''uso nel <strong>codice PL/SQL</strong>.</p>',
unistr('<p>\00C8 possibile digitare il nome dell''elemento oppure selezionarlo nella lista degli elementi disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.4415)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elementi da restituire'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
'<p>In questo esempio, immettere <code>P1_MY_ITEM</code> in questo attributo per visualizzare ''New Value'' nell''elemento nella pagina.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere, in maiuscolo, gli elementi di pagina impostati quando viene restituita la chiamata al server in base al relativo valore corrente nello stato della sessione. Se il <strong>codice PL/SQL</strong> imposta uno o pi\00F9 valori di elementi di pa')
||unistr('gina nello stato della sessione, \00E8 necessario definire tali elementi in questo attributo.</p>'),
unistr('<p>\00C8 possibile digitare il nome oppure selezionarlo nella lista degli elementi disponibili.'),
unistr('Se si effettua una selezione nella lista ed \00E8 stato gi\00E0 immesso del testo, alla fine del testo esistente viene posizionata una virgola, seguita dal nome dell''elemento restituito dalla lista.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.4415)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Elimina evento di modifica'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Specificare se l''evento di modifica deve essere eliminato negli elementi specificati in <strong>Elementi pagina da restituire</strong>. Ci\00F2 impedisce l''attivazione delle azioni dinamiche basate su <em>Modifica</em> successive per tali elementi.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.4415)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>'Lingua'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>'Sola visualizzazione'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Visualizza un elemento di testo che non pu\00F2 essere immesso.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.4415)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>'Invia alla sottomissione della pagina'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'Specificare se il valore dell''elemento corrente deve essere inviato quando la pagina viene sottomessa.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.4415)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Basato su'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare come determinare il valore visualizzato.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4415)
,p_display_sequence=>10
,p_display_value=>'Valore elemento'
,p_return_value=>'VALUE'
,p_help_text=>'Viene visualizzato il valore corrente dell''elemento.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4415)
,p_display_sequence=>20
,p_display_value=>'Valore visualizzato di lista di valori'
,p_return_value=>'LOV'
,p_help_text=>'Il valore corrente dell''elemento di pagina viene mappato a un valore di visualizzazione diverso mediante una lista di valori.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4415)
,p_display_sequence=>30
,p_display_value=>'Output del codice PL/SQL'
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>'Il codice PL/SQL specificato restituisce l''output visualizzato.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.4415)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Codice PL/SQL'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il codice PL/SQL che utilizza <code>sys.htp.p</code> o <code>sys.htp.prn</code> per generare il codice HTML.</p>',
'<p>Oracle consiglia di utilizzare <code>sys.htf.escape_sc</code> per aggiungere caratteri di escape ai valori recuperati dal database e garantire l''applicazione della funzione di escape alle tag HTML.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.4415)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostra interruzioni di riga'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare se le interruzioni di riga devono essere conservate nell''output.</p>',
unistr('<p>Poich\00E9 la visualizzazione viene presentata in formato HTML, quando l''impostazione \00E8 <strong>S\00EC</strong> le interruzioni di riga nel valore visualizzato vengono convertite in interruzioni di riga HTML in modo da essere visualizzate in modo corretto')
||'.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.4415)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>'Formato'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4415)
,p_display_sequence=>10
,p_display_value=>'Testo non codificato'
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4415)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4415)
,p_display_sequence=>30
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.4415)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4415)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Esempio 1: lista di valori basata su query SQL</strong>',
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
'<strong>Esempio 2: esempi di lista statica</strong>',
'<ul>',
'<li>STATIC:Yes;Y,No;N (mostra Yes / No, invece di Y e N)</li>',
'</ul>',
'</p>',
'',
'<p>',
'<strong>Esempio 3: lista di valori con ulteriore limitazione mediante bind variable</strong>',
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>'Valutazione a stelle'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Elemento di valutazione a stelle moderne</strong></p>',
unistr('<p>Questo elemento visualizza un valore numerico sotto forma di stelle o di altre icone. L''utente finale pu\00F2 modificare il valore selezionando il numero di stelle desiderato. Il valore pu\00F2 essere adeguato facendo clic sul numero di stelle con il mous')
||'e o mediante la tastiera.</p>',
unistr('<p>L''icona da visualizzare, nonch\00E9 i colori di sfondo e di primo piano, possono essere adeguati nelle impostazioni del componente o nelle impostazioni dei singoli elementi. Per utilizzare elementi e colori individuali, impostare l''attributo <strong>U')
||'sa impostazioni predefinite componente</strong> su <strong>No</strong>.</p>',
unistr('<p>Come icone \00E8 possibile utilizzare le icone Carattere icone disponibili nell''applicazione. Per le applicazioni Tema universale, utilizzare un''icona disponibile nella libreria<em>Carattere APEX</em>.</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icona predefinita'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>'Specificare l''icona predefinita da usare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Colore attivo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Scegliere il colore predefinito per le stelle attive.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Colore non attivo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Scegliere il colore predefinito per le stelle non attive.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Descrizione comandi'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>'Valutazione: #VALUE# stelle.'
,p_help_text=>'Specificare il modello per la descrizione comandi. La stringa di sostituzione #VALUE# viene sostituita dal valore di valutazione corrente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Numero di stelle'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Numero totale di stelle da visualizzare.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4415)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Usa impostazioni predefinite'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica se utilizzare le impostazioni predefinite definite per questo componente in Componenti condivisi > Impostazioni componente o le impostazioni personalizzate.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Icona'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>'Specificare l''icona da usare.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Colore attivo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Scegliere il colore predefinito per le stelle attive.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Colore non attivo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Scegliere il colore predefinito per le stelle non attive.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Descrizione comandi'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'Valutazione: #VALUE# stelle.'
,p_help_text=>'Specificare il modello per la descrizione comandi. La stringa di sostituzione #VALUE# viene sostituita dal valore di valutazione corrente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Mostra pulsante Cancella'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Scegliere se mostrare o meno il pulsante Cancella.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Mostra valore'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Scegliere se visualizzare il valore accanto alle stelle.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.4415)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Visualizzazione di sola lettura'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Scegliere cosa visualizzare quando l''elemento \00E8 di sola lettura.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4415)
,p_display_sequence=>20
,p_display_value=>'Stelle'
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4415)
,p_display_sequence=>30
,p_display_value=>'Valore'
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4415)
,p_display_sequence=>40
,p_display_value=>'Stelle e valore'
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4415)
,p_display_sequence=>50
,p_display_value=>'Una stella e un valore'
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>'Gruppo di caselle di controllo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Visualizza pi\00F9 valori sotto forma di caselle di controllo, consentendo all''utente finale di selezionare pi\00F9 valori. Per gli elementi visualizzati come caselle di controllo \00E8 necessaria una lista di valori. I valori corrispondenti alle caselle selezio')
||'nate sono memorizzati in un''unica stringa separata da due punti.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.4415)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Numero di colonne'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>'Immettere il numero di colonne di layout utilizzate per visualizzare le caselle di controllo. Ad esempio, il valore 2 visualizza due colonne di voci di caselle di controllo. Per impostazione predefinita, tutti i valori vengono visualizzati in una sol'
||'a colonna.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.4415)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Orientamento visualizzazione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selezionare la modalit\00E0 di visualizzazione delle caselle di controllo.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4415)
,p_display_sequence=>10
,p_display_value=>'Verticale'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4415)
,p_display_sequence=>20
,p_display_value=>'Orizzontale'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.4415)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4415)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista di valori basata su query SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>Lista di valori con lo stesso valore visualizzato e restituito</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Nota: si seleziona la stessa colonna sia per il valore visualizzato che per quello restituito, utilizzare un alias di colonna.</p>',
'</dd>',
'<dt>Lista di valori con bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: impostare l''attributo <em>Elementi padre LOV a catena</em> su <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> \00E8 un elemento di pagina modificabile della stessa pagina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>'Lista di selezione'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizza un elemento con un selettore lista di valori incorporato. Quando l''utente finale fa clic sull''elemento, la lista dei valori supportati viene visualizzata direttamente in linea con l''elemento corrente.</p>',
unistr('<p>L''elemento Lista di selezione \00E8 pi\00F9 adeguato per le liste relativamente brevi e discrete. Gli utenti finali possono selezionare molto rapidamente un valore senza dover attivare una finestra di dialogo popup. Per le liste di grandi dimensioni \00E8 spe')
||unistr('sso pi\00F9 adeguato l''elemento <em>LOV popup</em>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.4415)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Azione pagina su selezione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare l''azione eseguita quando viene selezionato un valore di una lista.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4415)
,p_display_sequence=>1
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
,p_help_text=>'Non viene eseguita alcuna sessione immediata alla modifica del valore.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4415)
,p_display_sequence=>5
,p_display_value=>'Sottometti pagina'
,p_return_value=>'SUBMIT'
,p_help_text=>'La pagina viene sottomessa con il valore REQUEST impostato sul nome dell''elemento di pagina.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4415)
,p_display_sequence=>7
,p_display_value=>'Reindirizza e imposta valore'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>'Il browser viene reindirizzato alla pagina corrente e lo stato della sessione per l''elemento corrente viene impostato sul valore selezionato.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4415)
,p_display_sequence=>9
,p_display_value=>'Reindirizza a pagina'
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>'Il browser viene reindirizzato alla pagina contenuta nel valore selezionato. I valori restituiti nella lista devono includere numeri o alias di pagina validi.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4415)
,p_display_sequence=>10
,p_display_value=>'Reindirizza a URL'
,p_return_value=>'REDIRECT_URL'
,p_help_text=>'Il browser viene reindirizzato all''URL contenuto nel valore selezionato. I valori restituiti nella lista devono includere URL validi.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.4415)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Consenti selezione multipla'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>unistr('Specificare se \00E8 possibile selezionare pi\00F9 valori oppure un solo valore dalla lista di valori. I valori multipli vengono restituiti sotto forma di lista separata da virgole.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.4415)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Esegui convalide'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>'Specificare se le convalide vengono eseguite alla sottomissione della pagina, in base all''impostazione di azione pagina <strong>Sottometti pagina</strong>.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.4415)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4415)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista di valori basata su query SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>Lista di valori con lo stesso valore visualizzato e restituito</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Nota: si seleziona la stessa colonna sia per il valore visualizzato che per quello restituito, utilizzare un alias di colonna.</p>',
'</dd>',
'<dt>Lista di valori con bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: impostare l''attributo <em>Elementi padre LOV a catena</em> su <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> \00E8 un elemento di pagina modificabile della stessa pagina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>'Report attivazione/disattivazione colonna'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza un report in cui gli utenti finali possono selezionare le colonne da visualizzare in runtime. Gli utenti finali possono quindi modificare le colonne in base alla larghezza e all''orientamento della schermata utilizzata per visualizzare il r'
||'eport.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare la base per questa colonna del report.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_display_sequence=>10
,p_display_value=>'Testo non codificato'
,p_return_value=>'PLAIN'
,p_help_text=>'Visualizza il valore della colonna.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_display_sequence=>20
,p_display_value=>'Collegamento'
,p_return_value=>'LINK'
,p_help_text=>'Visualizza la colonna come collegamento.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_display_sequence=>30
,p_display_value=>'Grafico di percentuale'
,p_return_value=>'PCT_GRAPH'
,p_help_text=>'Visualizza la colonna come grafico di percentuale. Il valore recuperato deve essere compreso tra 0 e 100.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Destinazione'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Immettere una pagina di destinazione da richiamare quando l''utente fa clic su una voce esistente.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Testo collegamento'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Immettere il testo HTML da mostrare come collegamento. Utilizzare una tag di immagine per visualizzare le immagini oppure scegliere un''immagine dalla lista di immagini predefinite.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Attributi collegamento'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Specificare gli attributi di collegamento alla colonna aggiuntivi da includere nella tag <code>&lt;a href=...&gt;</code>, tra i quali la destinazione del collegamento, le classi o gli stili.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Colore sfondo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per lo sfondo del grafico.'),
unistr('Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML.</p>'),
'<p>La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Colore primo piano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per il primo piano del grafico.'),
unistr('Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML.</p>'),
'<p>La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Larghezza barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'pixel'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>'Immettere la larghezza in pixel per questo grafico a barre.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Usa come intestazione di riga'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Viene utilizzato per l''accesso facilitato per identificare la colonna che rappresenta in modo ottimale il contenuto della riga.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>unistr('Priorit\00E0')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Il funzionamento del report prevede l''occultamento e la visualizzazione delle colonne in base a due input: la larghezza di schermata disponibile e la selezione/deselezione delle colonne da visualizzare nel menu del selettore colonne da parte dell'''
||unistr('utente. Selezionare un valore di priorit\00E0 per ogni colonna che si desidera visualizzare. Tutte le colonne alle quali si assegna una priorit\00E0 risulteranno disponibili nel menu del selettore colonne.<p>'),
'',
'<p>Per rendere persistente una colonna, in modo che non venga mai nascosta, selezionare <strong>Sempre visualizzata</strong>, che consente anche di rimuovere la colonna dal menu del selettore colonne.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4415)
,p_display_sequence=>5
,p_display_value=>'Sempre visualizzata'
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4415)
,p_display_sequence=>10
,p_display_value=>'1 - Nascondi ultimo'
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4415)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4415)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4415)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4415)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4415)
,p_display_sequence=>60
,p_display_value=>'6 - Nascondi primo'
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Opzioni layout'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Controllare opzioni di layout report aggiuntive.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4415)
,p_display_sequence=>10
,p_display_value=>'Striping'
,p_return_value=>'STRIPE'
,p_help_text=>'Aggiunge striping alternativi su ogni riga.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4415)
,p_display_sequence=>20
,p_display_value=>'Tratto'
,p_return_value=>'STROKE'
,p_help_text=>'Aggiunge linee orizzontali tra le righe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Classi CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Immettere sotto forma di lista separata da spazi le classi CSS aggiuntive da includere nel componente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Attributi personalizzati'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'<p>Immettere gli attributi aggiuntivi da includere nella tag HTML della tabella. L''attributo CLASS HTML viene generato, pertanto non deve essere fornito. Utilizzare preferibilmente l''attributo dedicato <em>Classi CSS</em>.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Testo pulsante colonna'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('Questa \00E8 l''etichetta da usare per il pulsante che visualizza il popup di selezione delle colonne. Se non viene specificato alcun testo, verr\00E0 utilizzata l''etichetta predefinita.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.4415)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4415)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione di tutti i dipendenti ordinati per nome</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Visualizzazione di tutti i dipendenti del reparto corrente ordinati per nome</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
'<p>Quando si usano le bind variable per fare riferimento agli elementi di pagina, specificarle come <strong>Elementi pagina da sottomettere</strong>.</p>',
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>'Shuttle'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Visualizza una lista di selezione multipla che include due caselle contenenti liste. Nella lista di sinistra vengono visualizzati i valori di origine non selezionati, mentre nella lista di destra vengono visualizzati i valori selezionati al moment'
||unistr('o. Gli utenti finali possono selezionare uno o pi\00F9 valori in una lista, quindi utilizzare i controlli shuttle per spostare i valori selezionati o tutti i valori.</p>'),
'<p>I valori correnti vengono visualizzati in un''unica stringa separata da due punti.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.4415)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostra controlli'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare i controlli di spostamento dei dati visualizzati al centro dello shuttle.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4415)
,p_display_sequence=>10
,p_display_value=>'Tutto'
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4415)
,p_display_sequence=>20
,p_display_value=>'Solo spostamento'
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4415)
,p_display_sequence=>30
,p_display_value=>'Solo ordinamento'
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4415)
,p_display_sequence=>40
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.4415)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4415)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista di valori basata su query SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>Lista di valori con lo stesso valore visualizzato e restituito</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Nota: si seleziona la stessa colonna sia per il valore visualizzato che per quello restituito, utilizzare un alias di colonna.</p>',
'</dd>',
'<dt>Lista di valori con bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: impostare l''attributo <em>Elementi padre LOV a catena</em> su <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> \00E8 un elemento di pagina modificabile della stessa pagina.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.4415)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4415)
,p_name=>'shuttlechangeorder'
,p_display_name=>'Cambia ordine'
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>'Gruppo pulsanti di scelta'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza pi\00F9 valori sotto forma di opzioni di gruppo di scelta, consentendo all''utente finale di selezionare un solo valore.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.4415)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Numero di colonne'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>'Immettere il numero di colonne di gruppo di scelta da visualizzare. Ad esempio, il valore <code>2</code> comporta la visualizzazione di due colonne, pertanto se fossero disponibili cinque valori verrebbero visualizzati in tre righe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.4415)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Azione pagina su selezione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare l''azione eseguita quando viene selezionato un valore di un gruppo di scelta.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4415)
,p_display_sequence=>10
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
,p_help_text=>'Non viene eseguita alcuna sessione immediata alla modifica del valore.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4415)
,p_display_sequence=>20
,p_display_value=>'Sottometti pagina'
,p_return_value=>'SUBMIT'
,p_help_text=>'La pagina viene sottomessa con il valore REQUEST impostato sul nome dell''elemento di pagina.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4415)
,p_display_sequence=>30
,p_display_value=>'Reindirizza e imposta valore'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>'Il browser reindirizza alla pagina corrente e lo stato della sessione per l''elemento corrente viene impostato sul valore selezionato.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.4415)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Esegui convalide'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>'Specificare se le convalide vengono eseguite alla sottomissione della pagina, a causa dell''impostazione di azione pagina <strong>Sottometti pagina</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.4415)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>'Orientamento visualizzazione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare l''orientamento per la visualizzazione dei valori del gruppo di scelta.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4415)
,p_display_sequence=>10
,p_display_value=>'Verticale'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4415)
,p_display_sequence=>20
,p_display_value=>'Orizzontale'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.4415)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Nascondi pulsanti di scelta'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.4415)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4415)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista di valori basata su query SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>Lista di valori con lo stesso valore visualizzato e restituito</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Nota: si seleziona la stessa colonna sia per il valore visualizzato che per quello restituito, utilizzare un alias di colonna.</p>',
'</dd>',
'<dt>Lista di valori con bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: impostare l''attributo <em>Elementi padre LOV a catena</em> su <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> \00E8 un elemento di pagina modificabile della stessa pagina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>'Report reflow'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Visualizza un report di risposta che esegue la trasformazione da colonne in righe per visualizzare i report in browser (schermate) di dimensioni pi\00F9 piccole.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selezionare la base per questa colonna del report.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_display_sequence=>10
,p_display_value=>'Testo non codificato'
,p_return_value=>'PLAIN'
,p_help_text=>'Visualizza il valore della colonna.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_display_sequence=>20
,p_display_value=>'Collegamento'
,p_return_value=>'LINK'
,p_help_text=>'Visualizza la colonna come collegamento.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_display_sequence=>30
,p_display_value=>'Grafico di percentuale'
,p_return_value=>'PCT_GRAPH'
,p_help_text=>'Visualizza la colonna come grafico di percentuale. Il valore recuperato deve essere compreso tra 0 e 100.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Destinazione'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Immettere una pagina di destinazione da richiamare quando l''utente fa clic su una voce esistente.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Testo collegamento'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Immettere il testo HTML da mostrare come collegamento. Utilizzare una tag di immagine per visualizzare le immagini oppure scegliere un''immagine dalla lista di immagini predefinite.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Attributi collegamento'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Specificare gli attributi di collegamento alla colonna aggiuntivi da includere nella tag <code>&lt;a href=...&gt;</code>, tra i quali la destinazione del collegamento, le classi o gli stili.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Colore sfondo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per lo sfondo del grafico.'),
unistr('Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML.</p>'),
'<p>La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Colore primo piano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Di seguito sono riportati alcuni esempi dei codici colore HTML pi\00F9 importanti - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Nero&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rosso&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Giallo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Verde limone&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Verde acqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Blu scuro&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Bianco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per il primo piano del grafico.'),
unistr('Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML.</p>'),
'<p>La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Larghezza barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'pixel'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>'Immettere la larghezza in pixel per questo grafico a barre.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Usa come intestazione di riga'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Viene utilizzato per l''accesso facilitato per identificare la colonna che rappresenta in modo ottimale il contenuto della riga.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Opzioni layout'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Controllare opzioni di layout report aggiuntive.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4415)
,p_display_sequence=>10
,p_display_value=>'Striping'
,p_return_value=>'STRIPE'
,p_help_text=>'Aggiunge striping alternativi su ogni riga.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4415)
,p_display_sequence=>20
,p_display_value=>'Tratto'
,p_return_value=>'STROKE'
,p_help_text=>'Aggiunge linee orizzontali tra le righe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Classi CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Immettere sotto forma di lista separata da spazi le classi CSS aggiuntive da includere nel componente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Attributi personalizzati'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'<p>Immettere gli attributi aggiuntivi da includere nella tag HTML della tabella. L''attributo CLASS HTML viene generato, pertanto non deve essere fornito. Utilizzare preferibilmente l''attributo dedicato <em>Classi CSS</em>.</p>'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.4415)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4415)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Visualizzazione di tutti i dipendenti ordinati per nome</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Visualizzazione di tutti i dipendenti del reparto corrente ordinati per nome</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
'<p>Quando si usano le bind variable per fare riferimento agli elementi di pagina, specificarle come <strong>Elementi pagina da sottomettere</strong>.</p>',
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>'Grafico di percentuale'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza il valore come grafico di percentuale. Il valore recuperato deve essere compreso tra 0 e 100.'
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.4415)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostra valore'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Specificare se il valore percentuale \00E8 visibile.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.4415)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Colore sfondo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per lo sfondo del grafico.'),
unistr('Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML.</p>'),
'<p>La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.4415)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Colore primo piano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per il primo piano del grafico.'),
unistr('Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML.</p>'),
'<p>La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.4415)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Colore testo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il colore che verr\00E0 utilizzato per il testo del grafico.'),
unistr('Il colore pu\00F2 essere specificato utilizzando una notazione esadecimale, i codici dei colori RGB o i nomi dei colori HTML.</p>'),
'<p>La notazione esadecimale viene definita con il formato #xxyyzz (carattere # seguito da 3 numeri esadecimali a doppia cifra), dove xx, yy e zz rappresentano, rispettivamente, i valori esadecimali a due caratteri per i colori rosso, verde e blu.',
unistr('Per la definizione dei codici RGB si usa il formato RGB(xxx,xxx,xxx), dove xxx \00E8 un numero compreso tra 0 e 255. Ogni numero rappresenta, rispettivamente, il singolo valore di byte a 8 bit per i colori rosso, verde e blu.</p>'),
'<p>Cercare su Internet ''Codici colori HTML'' per trovare il codice esadecimale o il codice RGB equivalente per il colore che si desidera utilizzare.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.4415)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Larghezza barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>'pixel'
,p_is_translatable=>false
,p_help_text=>'Immettere la larghezza in pixel per questo grafico a barre.'
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>'Editor Markdown'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Visualizza un''area di testo che supporta l''input Markdown, con opzioni di formattazione del testo, supporto per l''inclusione di immagini e un''opzione di anteprima per la visualizzazione del testo formattato. L''editor Markdown consente di scrivere uti'
||'lizzando testo non codificato di facile lettura e scrittura, quindi di convertire il testo in codice HTML strutturalmente valido mediante le varie opzioni fornite e la sintassi supportata.'
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.4415)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Barra degli strumenti'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Fornisce numerose opzioni per configurare la barra degli strumenti per l''editor Markdown.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4415)
,p_display_sequence=>10
,p_display_value=>'Semplice'
,p_return_value=>'SIMPLE'
,p_help_text=>'Visualizza i controlli di formattazione di base nella barra degli strumenti.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4415)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>'Visualizza il set completo dei controlli di formattazione nella barra degli strumenti.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4415)
,p_display_sequence=>40
,p_display_value=>'Nessuno'
,p_return_value=>'NONE'
,p_help_text=>'Nasconde la barra degli strumenti.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.4415)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Evidenziazione sintassi'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indica se applicare la sintassi di evidenziazione per specifici elementi Markdown, come grassetto, corsivo, blocchi di codice e cos\00EC via.</p>'),
unistr('<p>L''evidenziazione verr\00E0 applicata solo a contenuti con lunghezza inferiore a 4000 caratteri.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.4415)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4415)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>Immettere una funzione JavaScript che acquisisca un oggetto di configurazione per l''editor Markdown, quindi modifichi l''oggetto e lo restituisca. Ci\00F2 rende possibile la personalizzazione avanzata dell''aspetto dell''editor Markdown, delle funzioni e')
||' del funzionamento di elementi quali la barra degli strumenti, i menu e le azioni.</p>'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.4415)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4415)
,p_name=>'markdownified'
,p_display_name=>'con markdown'
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>'Cambia'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Viene visualizzato come interruttore bistabile.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valore Attivo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Immettere il valore memorizzato nell''elemento pagina se l''utente finale seleziona l''opzione <strong>Attivo</strong>. Questo valore pu\00F2 avere una lunghezza massima di 255 caratteri.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Etichetta Attivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il testo visualizzato per l''opzione <strong>Attivo</strong>. Se non si immette alcun testo, viene utilizzata l''etichetta predefinita del sistema.',
unistr('<p>Nota: se l''impostazione del componente ''Stile di visualizzazione'' \00E8 <strong>Cambia</strong>, questo attributo viene utilizzato solo come valore di visualizzazione per le colonne della griglia interattiva. Non verr\00E0 visualizzato per gli elementi di')
||' pagina normali.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valore Non attivo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere il valore memorizzato nell''elemento pagina se l''utente seleziona l''opzione <strong>Non attivo</strong>. Questo valore pu\00F2 avere una lunghezza massima di 255 caratteri.</p>'),
'<p><em>Nota: questo valore viene usato se l''elemento pagina viene popolato con un valore che non corrisponde a <strong>Valore Attivo</strong> o a <strong>Valore Non attivo</strong>.</em></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Etichetta Non attivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere il testo visualizzato per l''opzione <strong>Non attivo</strong>. Se non si immette alcun testo, verr\00E0 utilizzata l''etichetta predefinita del sistema.'),
unistr('<p>Nota: se l''impostazione del componente ''Stile di visualizzazione'' \00E8 <strong>Cambia</strong>, questo attributo viene utilizzato solo come valore di visualizzazione per le colonne della griglia interattiva. Non verr\00E0 visualizzato per gli elementi di')
||' pagina normali.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>'Stile di visualizzazione'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4415)
,p_display_sequence=>5
,p_display_value=>'Cambia'
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4415)
,p_display_sequence=>10
,p_display_value=>'Pulsante a forma di pillola'
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.4415)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4415)
,p_display_sequence=>20
,p_display_value=>'Lista di selezione'
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Usa impostazioni predefinite'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica se utilizzare le impostazioni predefinite definite per questo componente in Componenti condivisi > Impostazioni componente o le impostazioni personalizzate.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valore Attivo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Immettere il valore memorizzato nell''elemento pagina se l''utente seleziona l''opzione <strong>Attivo</strong>. Questo valore pu\00F2 avere una lunghezza massima di 255 caratteri.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Etichetta Attivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il testo visualizzato per l''opzione <strong>Attivo</strong>.',
unistr('<p>Nota: se l''impostazione del componente ''Stile di visualizzazione'' \00E8 <strong>Cambia</strong>, questo attributo non produce alcun effetto.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Valore Non attivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Immettere il valore memorizzato nell''elemento pagina se l''utente seleziona l''opzione <strong>Non attivo</strong>. Questo attributo pu\00F2 essere anche lasciato vuoto se si desidera memorizzare <code>NULL</code> quando viene selezionata l''opzione Non ')
||unistr('attivo. Questo valore pu\00F2 avere una lunghezza massima di 255 caratteri.</p>'),
'<p><em>Nota: questo valore viene usato se l''elemento pagina viene popolato con un valore che non corrisponde a <strong>Valore Attivo</strong> o a <strong>Valore Non attivo</strong>.</em></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.4415)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4415)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Etichetta Non attivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4415)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere il testo visualizzato per l''opzione <strong>Non attivo</strong>.',
unistr('<p>Nota: se l''impostazione del componente ''Stile di visualizzazione'' \00E8 <strong>Cambia</strong>, questo attributo non produce alcun effetto.</p>')))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.4415)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4415
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.4415)
,p_name=>'Messaggi'
,p_step_title=>'Messaggi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.4415)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
