prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4474
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4474 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4474
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102490870403637')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'it'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4474)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113351'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4474)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4474)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4474)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4474)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4474)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4474)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4474)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4474)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4474)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4474)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4474)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4474)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4474)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.it'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4474
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4474)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4474)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4474)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4474)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4474)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4474)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4474)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.it'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4474
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4474)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4474)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4474)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4474)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4474)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4474)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4474)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.it'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4474
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4474)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4474)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4474)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4474)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4474)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4474)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4474)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4474)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4474)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4474)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4474)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4474)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4474)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4474)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4474)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4474)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4474)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.it'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4474
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4474)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4474)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4474)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4474)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4474)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4474)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4474)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4474)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4474)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4474)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4474)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4474)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4474)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4474)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4474)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.it'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4474
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4474)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4474)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4474)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4474)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4474)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4474)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4474)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4474)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4474)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4474)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4474)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4474)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4474)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4474)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4474)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.it'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4474
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4474)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4474)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4474)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4474)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4474)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4474)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4474)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4474)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4474)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4474)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4474)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4474)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4474)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4474)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4474)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.it'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4474
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4474)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4474)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4474)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4474)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4474)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4474)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4474)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4474)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4474)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4474)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4474)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4474)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4474)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4474)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4474)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4474
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4474)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4474
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4474)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4474
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4474)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4474
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4474)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4474
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4474)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4474
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4474)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4474
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4474)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4474)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4474)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4474)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4474)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4474)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4474)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4474)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4474)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4474)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4474)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4474)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4474)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4474)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4474)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4474)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4474)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4474)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4474)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4474)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4474)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4474)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4474)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4474)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4474)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4474)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4474)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4474)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4474)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4474)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4474)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4474)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4474)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4474)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4474)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4474
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4474)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4474)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4474)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4474)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4474)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4474
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4474)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4474
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4474)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4474
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4474)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4474
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4474)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4474
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4474)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4474
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4474)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4474)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4474)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4474)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4474)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4474)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4474)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4474)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4474)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4474
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4474)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4474)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4474)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4474)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4474)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4474)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4474)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4474
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4474)
,p_page_name=>'winlov'
,p_page_title=>'Finestra di dialogo di ricerca'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Cerca'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Chiudi'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Successivo &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Precedente'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Righe #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4474
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4474)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4474
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4474)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4474)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4474)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4474)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4474)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4474)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4474)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4474)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4474)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4474)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4474)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4474)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4474)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4474)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4474)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4474)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4474)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4474)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4474)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4474)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4474)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4474)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4474)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4474)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4474)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4474)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4474)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4474)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4474)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4474)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4474)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4474)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4474)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4474)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4474)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4474)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4474)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4474)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4474)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4474)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4474)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4474)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4474)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4474)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4474)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4474)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4474)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4474)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4474)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4474)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4474)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4474)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4474)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4474)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4474)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4474)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4474)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4474)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4474)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4474)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4474)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4474)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4474)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4474)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4474)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4474)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4474)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4474)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4474)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4474)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4474)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4474)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4474)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4474)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4474)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4474)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4474)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4474)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4474)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4474)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4474)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4474)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4474)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4474)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4474)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4474)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4474)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4474)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4474)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4474)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4474)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4474)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4474)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4474)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4474)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4474)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4474)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4474)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4474)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4474)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4474)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4474)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4474)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4474)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4474)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4474)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4474)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4474)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4474)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4474)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4474)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4474)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4474)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4474)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4474)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4474)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4474)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4474)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4474)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4474)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4474)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4474)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4474)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4474)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4474)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4474)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4474)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4474)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4474)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4474)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4474)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4474)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4474)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4474)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4474)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4474)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4474)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4474)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4474)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4474)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4474)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4474)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4474)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4474)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4474)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4474)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4474)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4474)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4474)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4474)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4474)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4474)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4474)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4474)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4474)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4474)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4474)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4474)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4474)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4474)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4474)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4474)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4474)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4474)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4474)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4474)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4474)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4474)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4474)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4474)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4474)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4474)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4474)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4474)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4474)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4474)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4474)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4474)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4474)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4474)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4474)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4474)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4474)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4474)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4474)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4474)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713692920400377)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'it'
,p_message_text=>'Colonna %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700742284400368)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'it'
,p_message_text=>'Amministratore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700663423400367)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757941409400409)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'it'
,p_message_text=>'Accesso negato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717692249400380)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'it'
,p_message_text=>unistr('L''account %0 \00E8 stato creato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703242288400369)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'it'
,p_message_text=>unistr('L''account \00E8 bloccato.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693129601400362)
,p_name=>'AM_PM'
,p_message_language=>'it'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827520741400459)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'it'
,p_message_text=>'Attiva/disattiva %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835694000400466)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'it'
,p_message_text=>'(Attivo)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805162552400443)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'it'
,p_message_text=>'La chiamata Ajax ha restituito un errore del server %0 per %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735934888400393)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'it'
,p_message_text=>'Impossibile convertire l''alias di applicazione "%0" in un ID di applicazione univoco.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736080275400393)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'L''applicazione con l''alias "%0" non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725625163400385)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'ERR-1816 Errore imprevisto durante la conversione dell''alias di applicazione p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818500622400453)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('Il checksum dell''applicazione offre un metodo semplice per stabilire se la stessa applicazione viene distribuita nelle varie aree di lavoro. \00C8 possibile confrontare questo checksum per verificare l''eventuale presenza di una corrispondenza. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711464087400375)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della funzione di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696834093400365)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della funzione di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860304901400484)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome tenant %0 restituito da Oracle Cloud Identity Management non \00E8 autorizzato per il dominio %1.<br/><a href="&LOGOUT_URL.">Eseguire di nuovo il login</a> e specificare un nome tenant autorizzato oppure modificare l''URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694576927400363)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'it'
,p_message_text=>'L''account "%0" non dispone dei privilegi di sviluppo necessari (DB_DEVELOPER o DB_ADMINISTRATOR)<br/>per l''area di lavoro "%1". <a href="&LOGOUT_URL.">Eseguire di nuovo il login</a> dopo aver ottenuto i privilegi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693699624400362)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome tenant restituito da Oracle Cloud Identity Management non \00E8 autorizzato per l''area di lavoro corrente.<br/><a href="&LOGOUT_URL.">Eseguire di nuovo il login</a> e specificare un nome tenant autorizzato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694618923400363)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'it'
,p_message_text=>unistr('Per motivi di sicurezza, l''esecuzione delle applicazioni di questa area di lavoro tramite il dominio nell''URL non \00E8 consentita.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711196930400375)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'it'
,p_message_text=>'Chiedere al proprio DBA di eseguire $OH/rdbms/admin/catldap.sql.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711038612400375)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'it'
,p_message_text=>unistr('Il package SYS.DBMS_LDAP non esiste o non \00E8 valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710907604400375)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della funzione di modifica utente LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711249175400375)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione dell''autenticazione LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712004336400376)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'it'
,p_message_text=>'Errore nell''argomento p_flow_page per la procedura login_page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711623846400375)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'it'
,p_message_text=>'p_session non valido in wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759547123400410)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'it'
,p_message_text=>'Argomento con formato non valido per wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711730226400376)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'it'
,p_message_text=>'Nome utente nullo passato alla procedura di login.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700545088400367)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'it'
,p_message_text=>'Attendere <span id="apex_login_throttle_sec">%0</span> secondi prima di tentare di nuovo l''accesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701896304400368)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Il tentativo di login \00E8 stato bloccato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757374170400409)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Autenticazione "%0" non trovata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702198447400369)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'it'
,p_message_text=>'ID gruppo di sicurezza nullo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711548753400375)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''esecuzione del processo di post-autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711383958400375)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione del processo di pre-autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712519690400376)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aprire l''URL nello stesso browser in cui \00E8 stata avviata la richiesta di reimpostazione della password. Se si fa clic sul pulsante Reimposta URL password e si viene reindirizzati alla'),
'pagina di login, avviare di nuovo la reimpostazione della password e lasciare il',
'browser aperto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857875846400482)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'it'
,p_message_text=>'Reimposta URL password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694813229400363)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'it'
,p_message_text=>unistr('Il gruppo di consumer di Resource Manager %0 non \00E8 stato concesso a %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694939176400363)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'it'
,p_message_text=>'Usare DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP per concedere il privilegio mancante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722934803400383)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della funzione sentry della sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723023926400384)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della funzione di verifica della sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723256001400384)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'it'
,p_message_text=>'Chiedere all''amministratore di %0 di configurare il motore per Oracle Application Server Single Sign-On.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732787243400391)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'it'
,p_message_text=>'%0 non valido nel token %1 restituito da SSO.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711956761400376)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'it'
,p_message_text=>'Modificare lo schema di autenticazione e aggiungere il nome dell''applicazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732477426400390)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'it'
,p_message_text=>'Chiamante non valido della procedura %0:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732636322400391)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'it'
,p_message_text=>'Sessione di applicazione non valida nel token URLC: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732258258400390)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'it'
,p_message_text=>'Errore in portal_sso_redirect: informazioni sulla registrazione dell''applicazione mancanti: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723152045400384)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'it'
,p_message_text=>unistr('Il package WWSEC_SSO_ENABLER_PRIVATE non esiste o non \00E8 valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112711810469400376)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il nome di applicazione partner registrato nello schema di autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732372996400390)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'it'
,p_message_text=>'Registrare questa applicazione come descritto nella guida all''installazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723352048400384)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione dell''autenticazione SSO.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832775107400463)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'it'
,p_message_text=>'URL non autorizzato: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722734919400383)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione dell''autenticazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694732993400363)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro "%0" \00E8 inattiva. Contattare l''amministratore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695191436400364)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'it'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701571522400368)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Accesso negato dal controllo di sicurezza dell''applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701655673400368)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'it'
,p_message_text=>'Accesso negato dal controllo di sicurezza della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701757367400368)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione dell''autorizzazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765186379400414)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'it'
,p_message_text=>'Creato con %0 utilizzando %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765238861400414)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'it'
,p_message_text=>'love'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823004216400456)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione evento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822827190400456)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'it'
,p_message_text=>'Data di fine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823164578400456)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'it'
,p_message_text=>'ID evento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822776514400456)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'it'
,p_message_text=>'Data di inizio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822941349400456)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo evento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713589009400377)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di contenuto checksum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713444697400377)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore di formato checksum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777406910400423)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'it'
,p_message_text=>'Copiato negli Appunti.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777167528400423)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'it'
,p_message_text=>'Questo browser non supporta la copia da un pulsante o da un menu. Provare con Ctrl+C o Comando+C.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765631151400415)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Chiudi notifica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821699665400455)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'it'
,p_message_text=>'Contrasto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816132331400451)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'it'
,p_message_text=>'Corrente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816017124400451)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'it'
,p_message_text=>'Iniziale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820204587400454)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve essere un colore valido. Esempio: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815970056400451)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'it'
,p_message_text=>'Scegli un colore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816251719400451)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Modifica formato colore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855470873400480)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'it'
,p_message_text=>'Lista di valori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855558743400480)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'it'
,p_message_text=>'Apri lista per: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835782993400466)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'it'
,p_message_text=>'(Completato)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728008992400387)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'it'
,p_message_text=>'Rivolgersi all''amministratore delle applicazioni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742475034400398)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Contattare l''amministratore dell''applicazione.',
'I dettagli relativi all''incidente sono disponibili tramite l''ID debug "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820539692400454)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'it'
,p_message_text=>'Correggere gli errori prima di salvare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766501375400415)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'it'
,p_message_text=>'%0 corrispondenze trovate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766453689400415)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'it'
,p_message_text=>'Nessuna corrispondenza trovata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836265801400466)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'it'
,p_message_text=>'Avanzamento corrente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820974440400454)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Il file specificato nell''elemento %0 non esiste in APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809450656400446)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'it'
,p_message_text=>unistr('La versione corrente dei dati nel database \00E8 cambiata da quando l''utente ha iniziato il processo di aggiornamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778562170400424)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'it'
,p_message_text=>'Non caricare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825580845400458)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'it'
,p_message_text=>'Errore di pre-elaborazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825337406400458)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'it'
,p_message_text=>'Inserisci riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839444308400468)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'it'
,p_message_text=>'Sequenza: azione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825424189400458)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'it'
,p_message_text=>'Aggiorna riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766943056400415)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'it'
,p_message_text=>'Calendario popup: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689559186400360)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689603663400360)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825747051400458)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #LABEL#.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825699464400458)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve essere una data valida, ad esempio %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693241207400362)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve essere compresa tra %0 e %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693302779400362)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve essere uguale o successiva a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693448776400362)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve essere uguale o precedente a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770450146400418)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore di #LABEL# \00E8 maggiore della data massima specificata %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770899019400418)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# non corrisponde al formato %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770325328400418)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore di #LABEL# \00E8 minore della data minima specificata %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770532430400418)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'it'
,p_message_text=>'#LABEL# non rientra nell''intervallo valido compreso tra %0 e %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770709538400418)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore di #LABEL# non \00E8 compreso nell''intervallo valido di anni tra %0 e %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820899087400454)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848090478400475)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850020947400476)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'it'
,p_message_text=>'Guida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820670285400454)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'it'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820776153400454)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726979754400386)
,p_name=>'APEX.ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694360526400363)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'it'
,p_message_text=>unistr('Durante il callback di gestione degli errori si \00E8 verificato l''errore seguente: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703043573400369)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore durante la pittura della pagina di errore: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695006575400363)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'it'
,p_message_text=>'Errore interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834828277400465)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Contattare l''amministratore.',
'I dettagli relativi all''incidente sono disponibili tramite l''ID debug "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829192874400461)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'it'
,p_message_text=>unistr('Il database \00E8 aperto per l''accesso in sola lettura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859731105400483)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'it'
,p_message_text=>'ORA-28353: apertura del wallet non riuscita. Dati dell''applicazione attualmente non accessibili.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829273160400461)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina non \00E8 disponibile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696736533400365)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni tecniche (visibili solo per gli sviluppatori)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792888992400434)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'it'
,p_message_text=>'Messaggio di errore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806770561400444)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato previsto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773429396400420)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'it'
,p_message_text=>unistr('L''utente \00E8 gi\00E0 definito nella lista di controllo dell''accesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773364425400420)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Confermare l''aggiunta di %0 utente/i seguenti alla lista di controllo dell''accesso <strong>%1</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773803669400420)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'it'
,p_message_text=>'Esiste un utente duplicato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773553891400420)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'it'
,p_message_text=>'Chiocciola (@) mancante nell''indirizzo di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773645130400420)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'it'
,p_message_text=>'Punto (.) mancante nell''indirizzo di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773765137400420)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome utente \00E8 troppo lungo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774025862400421)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'it'
,p_message_text=>'Solo gli utenti definiti nella lista di controllo dell''accesso dell''applicazione possono accedere a questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774164179400421)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'it'
,p_message_text=>'Valore di impostazione del controllo dell''accesso imprevisto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773955638400420)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'it'
,p_message_text=>'Tutti gli utenti autenticati possono accedere a questa applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816703390400451)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816667748400451)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816975566400451)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'it'
,p_message_text=>unistr('%0: \00C8 disabilitato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816868338400451)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'it'
,p_message_text=>unistr('%0: \00C8 abilitato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816598645400451)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'it'
,p_message_text=>'non identificato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809656062400446)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'it'
,p_message_text=>'Scarica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766153954400415)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'it'
,p_message_text=>'Filtro applicato %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807254084400444)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'it'
,p_message_text=>'Applica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692122286400361)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'it'
,p_message_text=>'Grafico a barre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819920262400454)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'it'
,p_message_text=>'Altri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692279498400361)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'it'
,p_message_text=>'Grafico a torta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818637018400453)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'it'
,p_message_text=>'Grafico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691974695400361)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'it'
,p_message_text=>'Conteggio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807792806400445)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'it'
,p_message_text=>'Cancella'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807823808400445)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'it'
,p_message_text=>'Cancella tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807932707400445)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'it'
,p_message_text=>'Cancella %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825108799400458)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna %1, a cui fa riferimento il facet %0, non \00E8 disponibile o non \00E8 autorizzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682398492400354)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'it'
,p_message_text=>'Scegliere i filtri da mostrare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764392928400414)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'it'
,p_message_text=>'%0 risultati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764408469400414)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'it'
,p_message_text=>'%0 selezionati'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767081251400416)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'it'
,p_message_text=>'Filtri correnti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683827392400355)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista di filtri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823673293400456)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'it'
,p_message_text=>'Limite del valore distinto (%0) superato per il facet %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809215312400446)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'it'
,p_message_text=>unistr('Il facet %0 non \00E8 supportato per le colonne DATE o TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807353560400444)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtra %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807463376400444)
,p_name=>'APEX.FS.GO'
,p_message_language=>'it'
,p_message_text=>'Vai'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808816910400445)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'it'
,p_message_text=>'uguale a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692952437400362)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'it'
,p_message_text=>'contiene %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692692638400362)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'it'
,p_message_text=>'maggiore di %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692702880400362)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'it'
,p_message_text=>'maggiore o uguale a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692465353400362)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'it'
,p_message_text=>'minore di %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692588256400362)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'it'
,p_message_text=>'minore o uguale a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692870288400362)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'it'
,p_message_text=>'inizia con %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695342540400364)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di dati %0 (%1) non \00E8 supportato per il facet Campo di input.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685531738400357)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'it'
,p_message_text=>unistr('I facet con pi\00F9 valori richiedono database versione 12.2 o successiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809066691400446)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'it'
,p_message_text=>'Nessuna colonna di ricerca fornita per il facet %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682452464400354)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'it'
,p_message_text=>'Altri filtri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764539322400414)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'it'
,p_message_text=>'Inizio intervallo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808568886400445)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Da %0 a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808606023400445)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'it'
,p_message_text=>'Al di sopra di %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808741326400445)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'it'
,p_message_text=>'Al di sotto di %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764670807400414)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'it'
,p_message_text=>'Fine intervallo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827459442400459)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento LOV #%2 ("%1") per il facet Intervallo %0 non \00E8 valido (separatore "|" mancante).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808975844400446)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('Attualmente l''input manuale per il facet Intervallo %0 non \00E8 supportato perch\00E9 la colonna \00E8 del tipo DATE o TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808203170400445)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'it'
,p_message_text=>'a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692040190400361)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'it'
,p_message_text=>'Rimuovi grafico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761127232400411)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807605490400445)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'it'
,p_message_text=>'Cerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807534719400445)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'it'
,p_message_text=>'Cerca...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808464048400445)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'it'
,p_message_text=>'- Seleziona -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691882069400361)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'it'
,p_message_text=>'Mostra grafico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808011291400445)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'it'
,p_message_text=>'Mostra meno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808163428400445)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'it'
,p_message_text=>'Mostra altro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112808321192400445)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'it'
,p_message_text=>'%0 stelle e oltre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766033816400415)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'it'
,p_message_text=>'Filtra suggerimenti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809190135400446)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Attualmente il facet Campo di testo %0 u supportato solo per le colonne NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682234593400354)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Conteggio righe totali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825243134400458)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di dati %0 (%1) non \00E8 supportato per la ricerca con facet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817122502400452)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'it'
,p_message_text=>'Vai a errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774779368400421)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Aggregato.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782357246400426)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'it'
,p_message_text=>'Comprimi interruzione di controllo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774858990400421)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Interruzione di controllo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782278060400426)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'it'
,p_message_text=>'Espandi interruzione di controllo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860942797400484)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Colonna %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782095793400426)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'it'
,p_message_text=>'%0 righe eliminate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852424386400478)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'it'
,p_message_text=>unistr('Identit\00E0 duplicata')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771745225400419)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'it'
,p_message_text=>'All''inizio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775069899400421)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Intestazione gruppo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774977053400421)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Intestazione.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771873826400419)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'it'
,p_message_text=>'Alla fine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791856166400433)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'it'
,p_message_text=>'Carica altre righe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771511994400419)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'it'
,p_message_text=>'Successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775179511400421)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'it'
,p_message_text=>'Righe di pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771925948400419)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'it'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772039699400419)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'it'
,p_message_text=>'%0 - %1 di %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828011881400460)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'it'
,p_message_text=>'Selezione pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771610383400419)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'it'
,p_message_text=>'Precedente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852212477400478)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'it'
,p_message_text=>'Aggiunto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852356488400478)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'it'
,p_message_text=>'Modificato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860707635400484)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Riga %0, colonna %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860880619400484)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Riga %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852158497400478)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'it'
,p_message_text=>'Eliminato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775396892400422)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'it'
,p_message_text=>'Intestazione riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770943371400418)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'it'
,p_message_text=>'%0 celle selezionate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772122252400419)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'it'
,p_message_text=>'%0 righe selezionate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812430108400448)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'it'
,p_message_text=>'Seleziona tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782190846400426)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'it'
,p_message_text=>'Pagina %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775229979400421)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'it'
,p_message_text=>'Seleziona riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775482009400422)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'it'
,p_message_text=>'Con ordinamento crescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775573221400422)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'it'
,p_message_text=>'Con ordinamento decrescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771029095400418)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'it'
,p_message_text=>'Ordinamento crescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771377140400419)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'it'
,p_message_text=>'Ordinamento crescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771115603400419)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'it'
,p_message_text=>'Ordinamento decrescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771450838400419)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'it'
,p_message_text=>'Ordinamento decrescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112771241703400419)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'it'
,p_message_text=>'Non ordinare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781908253400426)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'it'
,p_message_text=>'Totale %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708381220400373)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'it'
,p_message_text=>'Richiesta HTTP per "%0" non riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849664332400476)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'it'
,p_message_text=>'Lista di selezione griglia: %0 colonne %1 righe. Utilizzare i tasti freccia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781893061400426)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'it'
,p_message_text=>'Lista di selezione: %0 righe. Utilizzare i tasti freccia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860562579400484)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'it'
,p_message_text=>'Griglia interattiva %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768679969400417)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769622469400417)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769560774400417)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'it'
,p_message_text=>'Aggiungi riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854080983400479)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'it'
,p_message_text=>'Aggregato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839583595400468)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'it'
,p_message_text=>'Aggregazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841245580400470)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'it'
,p_message_text=>'Tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797661420400437)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Tutte le colonne di testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798818466400438)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'it'
,p_message_text=>'Alternativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799981645400439)
,p_name=>'APEX.IG.AND'
,p_message_language=>'it'
,p_message_text=>'e'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819394622400453)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti appross.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855010253400480)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti appross. globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838108163400467)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'it'
,p_message_text=>'Ad aree'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840001455400469)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'it'
,p_message_text=>'Crescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798937359400438)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'it'
,p_message_text=>'Autorizzazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854142981400479)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'it'
,p_message_text=>'Automatico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819720528400454)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'it'
,p_message_text=>'Media'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854797565400480)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'it'
,p_message_text=>'Media globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837616208400467)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo asse etichetta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837880207400467)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'it'
,p_message_text=>'Posizioni decimali'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837724508400467)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo asse valori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843843226400472)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'it'
,p_message_text=>'Colore sfondo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838281549400468)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'it'
,p_message_text=>'A barre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794231770400435)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'it'
,p_message_text=>'tra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845041618400473)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'it'
,p_message_text=>'Entrambi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838315726400468)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'it'
,p_message_text=>'A bolle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769868022400418)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799821353400439)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'it'
,p_message_text=>'Con distinzione tra maiuscole e minuscole'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855669908400480)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'it'
,p_message_text=>'(Con distinzione tra maiuscole e minuscole)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826590206400459)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'it'
,p_message_text=>'Modifiche salvate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770259557400418)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'it'
,p_message_text=>'Modifica vista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800950651400440)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797436510400437)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'it'
,p_message_text=>'La query supera il numero massimo di %0 datapoint per grafico. Applicare un filtro per ridurre il numero di record nella query di base.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768530899400417)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista grafico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775887049400422)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'it'
,p_message_text=>'Cancella'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837169697400467)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844050940400472)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'it'
,p_message_text=>'Colori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820186434400454)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'it'
,p_message_text=>'Anteprima'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799272456400439)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768782868400417)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845835110400473)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'it'
,p_message_text=>'Scopo colonna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799394978400439)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'it'
,p_message_text=>'Complesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768943418400417)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'it'
,p_message_text=>'Calcola'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794828510400435)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'it'
,p_message_text=>'contiene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801165989400440)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'it'
,p_message_text=>'Interruzione di controllo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775655653400422)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'it'
,p_message_text=>'Copia negli Appunti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775784983400422)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'it'
,p_message_text=>'Copia in basso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819133067400453)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819277004400453)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854990845400480)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854851432400480)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'it'
,p_message_text=>'Conteggio globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852577173400478)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'it'
,p_message_text=>'Crea %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797844231400438)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'it'
,p_message_text=>'Dati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845665325400473)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di dati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845256662400473)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'it'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826330941400459)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore della data non valido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795515389400436)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'it'
,p_message_text=>'giorni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798507563400438)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni predefinite'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798305226400438)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo predefinito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769755204400418)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846840346400474)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 certi di voler eliminare questo report?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802936634400441)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'it'
,p_message_text=>'Elimina riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801725348400440)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'it'
,p_message_text=>'Elimina righe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840170513400469)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'it'
,p_message_text=>'Decrescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800690123400440)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'it'
,p_message_text=>'Dettaglio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768280549400416)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista dettagli'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828864129400460)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'it'
,p_message_text=>'Direzione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800335345400439)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794900882400436)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'it'
,p_message_text=>'non contiene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795127287400436)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'it'
,p_message_text=>'non inizia con'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838431794400468)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'it'
,p_message_text=>'A ciambella'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801334479400440)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'Scarica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700040592400367)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'it'
,p_message_text=>'Solo dati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847855933400475)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Scegliere un formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712612615400376)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'it'
,p_message_text=>'Formato di download %0 non abilitato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840895785400469)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'it'
,p_message_text=>'Aggregazione duplicata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840933834400470)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'it'
,p_message_text=>'Interruzione di controllo duplicata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802812795400441)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'it'
,p_message_text=>'Duplica riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801632266400440)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'it'
,p_message_text=>'Duplica righe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769377937400417)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839973453400469)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'it'
,p_message_text=>'Modifica grafico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851400207400477)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'it'
,p_message_text=>'Modifica raggruppamento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847436182400474)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'it'
,p_message_text=>'Copia nascosta (Ccn)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847608546400475)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'it'
,p_message_text=>'Messaggio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847319139400474)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'it'
,p_message_text=>'Copia (Cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847061677400474)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica inviata.'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847520799400474)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'it'
,p_message_text=>'Oggetto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847269256400474)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'it'
,p_message_text=>'Destinatario (A)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800027162400439)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793208514400434)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'it'
,p_message_text=>'uguale a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846424266400474)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'it'
,p_message_text=>'Esempio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800149629400439)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'Espressione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846300029400474)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812356878400448)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'it'
,p_message_text=>'File preparato. Avvio del download in corso.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112775929076400422)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'it'
,p_message_text=>'Riempimento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777082031400423)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'it'
,p_message_text=>'Riempi selezione con'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776958636400423)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'it'
,p_message_text=>'Riempi selezione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768817364400417)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799463939400439)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'it'
,p_message_text=>'Filtri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854478290400480)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'it'
,p_message_text=>'Filtra...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840375774400469)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'it'
,p_message_text=>'All''inizio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769070408400417)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'it'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797911010400438)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844994454400473)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846717285400474)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'it'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846607803400474)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'it'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759427705400410)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'it'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698759216400366)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'it'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802573553400441)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'it'
,p_message_text=>'Blocca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800234405400439)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'it'
,p_message_text=>'Funzioni e operatori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838575373400468)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'it'
,p_message_text=>'A imbuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819015567400453)
,p_name=>'APEX.IG.GO'
,p_message_language=>'it'
,p_message_text=>'Vai'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793806828400435)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'it'
,p_message_text=>'maggiore di'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793903751400435)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'it'
,p_message_text=>'maggiore o uguale a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800536980400440)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'it'
,p_message_text=>'Griglia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768053519400416)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista griglia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841136479400470)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'it'
,p_message_text=>'Gruppo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800754764400440)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'it'
,p_message_text=>'Raggruppa per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768305262400416)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista Raggruppa per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845536043400473)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di condizione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844408324400472)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'it'
,p_message_text=>'Intestazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844690718400472)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'it'
,p_message_text=>'Allineamento intestazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854325598400479)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'it'
,p_message_text=>'Guida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849837204400476)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00C8 possibile inserire, aggiornare ed eliminare i dati direttamente all''interno di questa griglia interattiva.</p>'),
'',
'<p>Per inserire una nuova riga, fare clic sul pulsante Aggiungi riga.</p>',
'',
unistr('<p>Per modificare i dati esistenti, fare doppio clic su una cella specifica. Per interventi di modifica pi\00F9 ampi, fare clic su Modifica per attivare la modalit\00E0 di modifica. Nella modalit\00E0 di modifica \00E8 possibile fare clic una sola volta oppure usare')
||' la tastiera per modificare le celle specifiche.</p>',
'',
unistr('<p>Usare il menu Modifica per duplicare e eliminare le righe. Per abilitare il menu Modifica, usare le caselle di controllo per selezionare una o pi\00F9 righe.</p>'),
'',
'<p>Per duplicare una riga selezionata, fare clic sul menu Modifica e selezionare Duplica righe. Per eliminare una riga selezionata, fare clic sul menu Modifica e selezionare Elimina riga.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851964340400478)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'it'
,p_message_text=>unistr('Capacit\00E0 di modifica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852040278400478)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una griglia interattiva presenta un set di dati in un report abilitato per le ricerche e personalizzabile. \00C8 possibile eseguire varie operazioni per limitare il numero dei record restituiti e modificare le modalit\00E0 di visualizzazione dei dati.</p>'),
'',
'<p>Usare il campo Cerca per filtrare i record restituiti. Fare clic su Azioni per accedere a varie opzioni per la modifica del layout del report oppure usare i menu Intestazione colonna nelle colonne visualizzate.</p>',
'',
unistr('<p>Usare Impostazioni report per salvare le personalizzazioni apportate a un report. \00C8 inoltre possibile scaricare i dati dal report in un file esterno oppure inviare i dati mediante posta elettronica a se stessi o ad altre persone.</p>'),
'',
'<p>Per ulteriori informazioni, vedere "Uso delle griglie interattive" in <em>Guida per l''utente finale di Oracle Application Express</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851765835400478)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'it'
,p_message_text=>'Panoramica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849782551400476)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00C8 possibile personalizzare la griglia interattiva per visualizzare i dati in vari modi diversi mediante le capacit\00E0 incorporate disponibili.</p>'),
'',
unistr('<p>Usare i menu Intestazione colonna o i menu Azione per determinare le colonne da visualizzare, scegliere la sequenza di visualizzazione e bloccare le colonne. \00C8 inoltre possibile definire vari filtri di dati e ordinare i dati restituiti.</p>'),
'',
unistr('<p>Usare il pulsante Visualizza, situato accanto al campo di ricerca, per accedere alle eventuali altre viste dati definite dallo sviluppatore dell''applicazione. \00C8 inoltre possibile creare un grafico o visualizzare un grafico esistente.</p> '),
'',
unistr('<p><em>Nota: per ottenere informazioni pi\00F9 dettagliate sulla funzione selezionata, fare clic su <strong>?</strong> nelle finestre di dialogo della griglia interattiva.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851802179400478)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'it'
,p_message_text=>unistr('Capacit\00E0 di report')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801538998400440)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida della griglia interattiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848644633400475)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa finestra di dialogo per aggregare le colonne. I valori aggregati vengono visualizzati sotto i dati oppure, se sono state definite le interruzioni di controllo, sotto ogni interruzione.</p>',
'',
'<p><strong>Lista Aggregazione</strong><br>',
'Nella lista Aggregazione vengono visualizzate le aggregazioni definite. Per disabilitare un''aggregazione esistente, deselezionarla.<br>',
'Fare clic su Aggiungi (&plus;) per creare una nuova aggregazione oppure su Elimina (&minus;) per rimuovere un''aggregazione esistente.</p>',
'',
'<p><strong>Impostazioni di aggregazione</strong><br>',
'Usare il form a destra per definire l''aggregazione.<br>',
'Selezionare il nome della colonna e il tipo di aggregazione.<br>',
'Se necessario, immettere una descrizione comandi per l''aggregazione.<br>',
unistr('Se \00E8 stata definita un''interruzione di controllo, la selezione di <strong>Mostra valore globale</strong> comporta la visualizzazione della media complessiva, del totale o di un altro valore simile sotto i dati.</p>'),
'',
'<p><em>Nota: per accedere alla finestra di dialogo Aggregazione, utilizzare il menu Azioni oppure fare clic sull''intestazione e sulla somma (&sum;) della colonna.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850834608400477)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Aggregazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849394500400476)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa finestra di dialogo per definire un grafico visualizzato come vista dati distinta.<br>',
'Selezionare un tipo di grafico e gli attributi del grafico.</p>',
'<p><strong>Attributi grafico</strong></br>',
'Gli attributi disponibili variano a seconda del tipo di grafico selezionato.</p>',
'<p>',
'<ul>',
'  <li>Selezionare la colonna che contiene il valore per l''attributo.',
'    <ul>',
'      <li>Etichetta: il testo per ogni datapoint.</li>',
'      <li>Valore: i dati da rappresentare.</li>',
unistr('      <li>Serie: consente di definire la query dinamica a pi\00F9 serie.</li>'),
'      <li>Apertura: prezzo di apertura giornaliero delle azioni (solo per il grafico Borsistico).</li>',
'      <li>Chiusura: prezzo di chiusura giornaliero delle azioni (solo per il grafico Borsistico).</li>',
'      <li>Valore massimo: il valore massimo (solo per i grafici Intervallo e Borsistico).</li>',
'      <li>Valore minimo: il valore minimo (solo per i grafici Con Intervallo e Borsistico).</li>',
'      <li>Volume: il volume di azioni giornaliero (solo per il grafico Borsistico).</li>',
'      <li>Destinazione: il valore di destinazione (solo grafico a imbuto).</li>',
'      <li>X: il valore dell''asse X (solo grafici A bolle e A dispersione).</li>',
'      <li>Y: il valore dell''asse Y (solo grafici A bolle e A dispersione).</li>',
'      <li>Z: la larghezza della barra o il raggio della bolla (solo grafici A barre, A bolle e Intervallo).</li>',
'    </ul>',
'  </li>',
'  <li>Orientamento: Verticale oppure Orizzontale.</li>',
unistr('  <li>Aggregazione: selezionare le modalit\00E0 di aggregazione dei valori del grafico.</li>'),
'  <li>In pila: specificare se gli elementi dati devono essere visualizzati in pila.</li>',
unistr('  <li>Ordina per: indicare se il grafico deve essere ordinato in base all''etichetta o a uno o pi\00F9 valori.'),
'    <ul>',
'      <li>Direzione: specificare se i dati devono essere ordinati in ordine crescente o decrescente.</li>',
unistr('      <li>Valori nulli: specificare le modalit\00E0 di ordinamento dei record con valori nulli rispetto ai record con valori non nulli.</li>'),
'    </ul>',
'  </li>',
'  <li>Posizioni decimali</li>',
'  <li>Titolo asse etichetta</li>',
'  <li>Titolo asse valori</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851291549400477)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Grafico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848340220400475)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa finestra di dialogo per scegliere le colonne da visualizzare e l''ordine di visualizzazione delle colonne.</p>',
'',
'<p>Per nascondere una colonna, deselezionarla.<br>',
'Per riordinare le colonne, fare clic su Sposta in alto (&uarr;) o su Sposta in basso (&darr;).<br>',
'Usare il selettore a discesa per elencare tutte le colonne, le colonne visualizzate o le colonne non visualizzate.</p>',
'',
'<p>Facoltativamente, usare il form per specificare la larghezza minima di una colonna in pixel.</p>',
'',
unistr('<p><em>Nota: \00E8 possibile riordinare le colonne visualizzate anche facendo clic sul quadratino di trascinamento (all''inizio dell''intestazione della colonna) e trascinando la colonna a sinistra o a destra. \00C8 possibile modificare la larghezza delle colo')
||'nne visualizzate anche selezionando il separatore delle colonne, tra le intestazioni, e spostandolo a sinistra o a destra.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851192489400477)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida sulle colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848720756400475)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa finestra di dialogo per definire colonne aggiuntive in base ai calcoli matematici e funzionali eseguiti sulle colonne esistenti.</p>',
'',
'<p><strong>Lista Calcolo</strong><br>',
'Nella lista Calcolo vengono visualizzati i calcoli definiti. Per disabilitare un calcolo esistente, deselezionarlo.<br>',
'Fare clic su Aggiungi (&plus;) per aggiungere un nuovo calcolo oppure su Elimina (&minus;) per rimuovere un calcolo esistente.</p>',
'',
'<p><strong>Impostazioni di calcolo</strong><br>',
'Usare il form per definire il calcolo.<br>',
'Immettere i dettagli di colonna, ovvero l''intestazione e l''etichetta, quindi selezionare le impostazioni di allineamento.<br> ',
'Usare l''area di testo Espressione per immettere la colonna o le colonne e le funzioni associate per il calcolo.<br>',
'Selezionare il tipo di dati appropriato e, facoltativamente, un formato di visualizzazione, per la nuova colonna.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850792192400477)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Calcola'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849096955400476)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Usare questa finestra di dialogo per definire un''interruzione di controllo in una o pi\00F9 colonne.</p>'),
'',
'<p><strong>Lista Interruzione di controllo</strong><br>',
'Nella lista Interruzione di controllo vengono visualizzate le interruzioni di controllo definite. Per disabilitare una colonna di interruzione di controllo esistente, deselezionarla.<br>',
'Fare clic su Aggiungi (&plus;) per includere una nuova colonna nell''interruzione di controllo oppure su Elimina (&minus;) per rimuovere una colonna esistente dall''interruzione di controllo.<br>',
'Per riordinare le colonne, fare clic su Sposta in alto (&uarr;) o su Sposta in basso (&darr;) per spostare la colonna selezionata verso l''alto o verso il basso rispetto alle altre colonne.</p>',
'',
'<p><strong>Impostazioni di interruzione di controllo</strong><br>',
'Usare il form per definire la colonna dell''interruzione di controllo.<br>',
unistr('Selezionare una colonna di interruzione di controllo, la direzione dell''ordinamento e le modalit\00E0 di ordinamento delle colonne nulle (le colonne prive di valori).</p>'),
'',
unistr('<p><em>Nota: durante la visualizzazione della griglia interattiva, \00E8 possibile definire un''interruzione di controllo facendo clic sull''intestazione di una colonna e selezionando l''icona Interruzione di controllo.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850413721400477)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Interruzione di controllo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849290378400476)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Usare questa finestra di dialogo per scaricare tutte le righe correnti in un file esterno. Il file conterr\00E0 solo le colonne visualizzate al momento in base ai filtri e all''ordinamento applicati ai dati.</p>'),
'',
'<p>Selezionare il formato del file e fare clic su Scarica.<br>',
'Nota: con il formato CSV i dettagli di formattazione del testo, quali le aggregazioni e le interruzioni di controllo, non vengono inclusi.</p>',
'',
'<p>Per inviare il file tramite posta elettronica, selezionare Invia come posta elettronica e immettere i dettagli dell''invio (Destinatario, Oggetto e Messaggio).</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850284001400476)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Scarica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848485452400475)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa finestra di dialogo per configurare i filtri dei dati che limitano il numero delle righe restituite.</p>',
'',
'<p><strong>Lista Filtro</strong><br>',
'La lista Filtro contiene i filtri definiti. Per disabilitare un filtro esistente, deselezionarlo.<br>',
'Fare clic su Aggiungi (&plus;) per creare un nuovo filtro o su Elimina (&minus;) per rimuovere un filtro esistente.</p>',
'',
'<p><strong>Impostazioni di filtro</strong><br>',
unistr('Usare il form per definire le propriet\00E0 del filtro.<br>'),
'Selezionare il tipo di filtro appropriato:<br>',
'&nbsp;&nbsp;&nbsp;Riga: filtro per un termine in qualsiasi colonna filtrabile.<br>',
'&nbsp;&nbsp;&nbsp;Colonna: filtra una colonna specifica con l''operatore e il valore specificati.</p>',
'',
unistr('<p><em>Nota: durante la visualizzazione della griglia interattiva, \00E8 possibile definire i filtri Riga digitando direttamente nel campo di ricerca. Fare clic su Selezionare le colonne in cui cercare per limitare la ricerca a una colonna specifica. In ')
||'alternativa, aprire un menu Intestazione colonna e selezionare un valore per creare un filtro Colonna.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851020218400477)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Filtra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848850765400475)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Usare questa finestra di dialogo per visualizzare i dati cos\00EC come si presentavano in un point-in-time precedente.</p>'),
'<p>Immettere il numero di minuti nel passato per eseguire la funzione Flashback query.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850637729400477)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851333838400477)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Raggruppa per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848900768400476)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa finestra di dialogo per evidenziare le righe o le colonne di dati in base alla condizione immessa.</p>',
'',
'<p><strong>Lista Evidenzia</strong><br>',
'Nella lista Evidenzia vengono visualizzate le evidenziazioni definite. Per disabilitare un''evidenziazione esistente, deselezionarla.<br>',
'Fare clic su Aggiungi (&plus;) per creare una nuova evidenziazione oppure su Elimina (&minus;) per rimuovere un''evidenziazione esistente.</p>',
'',
'<p><strong>Impostazioni di evidenziazione</strong><br>',
unistr('Usare il form per definire le propriet\00E0 di evidenziazione.<br>'),
'Immettere il nome, selezionare Riga o Colonna, quindi selezionare i codici di colore HTML per lo sfondo e il testo.<br>',
'Selezionare il <strong>tipo di condizione</strong> appropriato per evidenziare dati specifici:<br>',
'&nbsp;&nbsp;&nbsp;Riga: evidenzia un termine in qualsiasi colonna.<br>',
'&nbsp;&nbsp;&nbsp;Colonna: applica l''evidenziazione in una colonna specifica in base all''operatore e valore specificati.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850532754400477)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Evidenzia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849103732400476)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa finestra di dialogo per salvare le modifiche apportate al layout e alla configurazione della griglia corrente.<br>',
unistr('Gli sviluppatori di applicazioni possono definire pi\00F9 layout di report alternativi. Laddove si \00E8 autorizzati a farlo, \00E8 possibile salvare un report come Pubblico, ovvero renderlo disponibile per tutti gli altri utenti della griglia. \00C8 inoltre possibi')
||unistr('le salvare un report come Privato, in modo da essere l''unica persona che potr\00E0 visualizzarne il contenuto.</p>'),
'<p>Effettuare la selezione nei tipi disponibili e immettere un nome per il report salvato.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850332944400477)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Guida di Report',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848500076400475)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usare questa finestra di dialogo per impostare l''ordine di visualizzazione.</p>',
'',
'<p><strong>Lista Ordina</strong><br>',
'La finestra di dialogo Ordina visualizza la lista delle regole di ordinamento configurate.<br>',
'Fare clic su Aggiungi (&plus;) per creare una colonna di ordinamento oppure su Elimina (&minus;) per rimuovere una colonna di ordinamento.<br>',
'Fare clic su Sposta in alto (&uarr;) e su Sposta in basso (&darr;) per spostare la colonna di ordinamento selezionata verso l''alto e verso il basso rispetto alle altre colonne di ordinamento.</p>',
'',
'<p><strong>Impostazioni di ordinamento</strong><br>',
unistr('Selezionare una colonna di ordinamento, la direzione dell''ordinamento e le modalit\00E0 di ordinamento delle colonne nulle (le colonne prive di valori).</p>'),
'',
'<p><em>Nota: i dati possono essere ordinati in base a colonne non visualizzate, ma non tutte le colonne sono ordinabili.</em><br>',
unistr('<em>Le colonne visualizzate possono essere ordinate facendo clic sulla freccia su (ordine crescente) o sulla freccia gi\00F9 (ordine decrescente) alla fine delle intestazioni delle colonne. Per aggiungere un''ulteriore colonna a un ordinamento esistente, ')
||unistr('tenere premuto il tasto Maiusc e premere Freccia SU o Freccia GI\00D9.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850970293400477)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Ordina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112850103994400476)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'it'
,p_message_text=>'Guida di Sottoscrizione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802439419400441)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'it'
,p_message_text=>'Nascondi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769273854400417)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'it'
,p_message_text=>'Evidenzia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837243860400467)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Valore massimo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838050958400467)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'it'
,p_message_text=>'Orizzontale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795443967400436)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'it'
,p_message_text=>'ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800427348400439)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'it'
,p_message_text=>'Icona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768146639400416)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista icone'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793619635400435)
,p_name=>'APEX.IG.IN'
,p_message_language=>'it'
,p_message_text=>'in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802055016400441)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'it'
,p_message_text=>'Impostazione non attiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802186870400441)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni non attive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809790516400446)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore interno durante l''elaborazione della richiesta della griglia interattiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705597368400371)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di filtro colonna "%0" non \00E8 supportato per la colonna "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849985373400476)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato data non valido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824133129400457)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'it'
,p_message_text=>'La griglia interattiva non supporta la definizione di un filtro sulla colonna %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824001206400457)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non \00E8 un tipo di filtro valido per la definizione di un filtro di griglia interattiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710649130400375)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato numerico non valido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852674386400478)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'it'
,p_message_text=>'Impostazione non valida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852737936400478)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni non valide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843784973400472)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'it'
,p_message_text=>unistr('L''opzione Ordina per \00E8 stata impostata su %0, ma non \00E8 stata selezionata alcuna colonna per %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841050953400470)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore non valido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836170760400466)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'it'
,p_message_text=>'Non visualizzato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794471897400435)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'it'
,p_message_text=>'negli/lle ultimi/e'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794643555400435)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'it'
,p_message_text=>'nei seguenti'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793575213400435)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('non \00E8 vuoto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793435603400435)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('\00E8 vuoto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844500083400472)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836598445400466)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840442986400469)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'it'
,p_message_text=>'Alla fine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783749738400428)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'it'
,p_message_text=>'Ultimo giorno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783909254400428)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'it'
,p_message_text=>'Ultima ora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784419060400428)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'it'
,p_message_text=>'Ultimo minuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783443200400427)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'it'
,p_message_text=>'Mese scorso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783531386400427)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'it'
,p_message_text=>'Settimana scorsa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783671269400427)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'it'
,p_message_text=>'Ultimi %0 giorni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783841349400428)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'it'
,p_message_text=>'Ultime %0 ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784542540400428)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'it'
,p_message_text=>'Ultimi %0 minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784304695400428)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'it'
,p_message_text=>'Ultimi %0 mesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784213767400428)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'it'
,p_message_text=>'Ultime %0 settimane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783276352400427)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'it'
,p_message_text=>'Ultimi %0 anni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783319776400427)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'it'
,p_message_text=>'Anno scorso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844707498400472)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'it'
,p_message_text=>'Allineamento cella'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844867575400472)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'it'
,p_message_text=>'Usa gruppo per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794048879400435)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'it'
,p_message_text=>'minore di'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794176858400435)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'it'
,p_message_text=>'minore o uguale a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838651410400468)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'it'
,p_message_text=>'A linee'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838769493400468)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'it'
,p_message_text=>'A linee con area'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845165781400473)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'it'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837396232400467)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Valore minimo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847782086400475)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'it'
,p_message_text=>unistr('Separare pi\00F9 indirizzi con virgole')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795235762400436)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'corrisponde all''espressione regolare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819661163400453)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'it'
,p_message_text=>'Massimo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855266511400480)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'it'
,p_message_text=>'Massimo globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819830230400454)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'it'
,p_message_text=>'Mediana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855313665400480)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'it'
,p_message_text=>'Mediana globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819523762400453)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'it'
,p_message_text=>'Minimo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795316312400436)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'it'
,p_message_text=>'minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820362636400454)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'it'
,p_message_text=>'Minuti fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855140881400480)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'it'
,p_message_text=>'Minimo globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795716054400436)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'it'
,p_message_text=>'mesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802370561400441)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('I dati contengono pi\00F9 di %0 righe. Questo valore supera il limite massimo consentito. Applicare ulteriori filtri per visualizzare i risultati.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829059788400461)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario specificare l''ID statico area poich\00E9 la pagina contiene pi\00F9 griglie interattive.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798421731400438)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798694898400438)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report denominato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782607065400427)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'it'
,p_message_text=>'Giorno successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782434554400427)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'it'
,p_message_text=>'Ora successiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784605833400428)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'it'
,p_message_text=>'Minuto successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782906386400427)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'it'
,p_message_text=>'Mese successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782870415400427)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'it'
,p_message_text=>'Settimana successiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782770261400427)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'it'
,p_message_text=>'%0 giorni successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112782511326400427)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'it'
,p_message_text=>'%0 ore successive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784749606400428)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'it'
,p_message_text=>'%0 minuti successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784063075400428)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'it'
,p_message_text=>'%0 mesi successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784131363400428)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'it'
,p_message_text=>'%0 settimane successive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783150770400427)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'it'
,p_message_text=>'%0 anni successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112783098600400427)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'it'
,p_message_text=>'Anno successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794378636400435)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'it'
,p_message_text=>'non tra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793326905400434)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'it'
,p_message_text=>'non uguale a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859579016400483)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>unistr('L''area con ID %0 non \00E8 di tipo Griglia interattiva oppure non esiste nell''applicazione %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793728234400435)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'it'
,p_message_text=>'non in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794528449400435)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'it'
,p_message_text=>'non negli/lle ultimi/e'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112794705728400435)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'it'
,p_message_text=>'non nei/lle seguenti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802218031400441)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessun dato trovato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840219922400469)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'it'
,p_message_text=>'Valori nulli'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845347940400473)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'it'
,p_message_text=>'Numerico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840538649400469)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'it'
,p_message_text=>'Non attivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840683324400469)
,p_name=>'APEX.IG.ON'
,p_message_language=>'it'
,p_message_text=>'Attivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792521002400434)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'it'
,p_message_text=>'1 minuto fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848245568400475)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'it'
,p_message_text=>'Apri selettore colori: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837095284400467)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Apri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799574766400439)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'it'
,p_message_text=>'Operatore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836444960400466)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'it'
,p_message_text=>'Orientamento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838819682400468)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'it'
,p_message_text=>'A torta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112800896295400440)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'it'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112768483843400417)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112848101529400475)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'it'
,p_message_text=>'Separare i valori con "%0"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112838955954400468)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'it'
,p_message_text=>'Polare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844285767400472)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'it'
,p_message_text=>'Al centro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844331699400472)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'it'
,p_message_text=>'Fine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112844172679400472)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'it'
,p_message_text=>'Inizio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798778139400438)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'it'
,p_message_text=>'Primario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799057884400438)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Predefinito primario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815569290400450)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report primario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697748273400365)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Includi tag di accesso facilitato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696400001400364)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'it'
,p_message_text=>'Orizzontale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696514983400365)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'it'
,p_message_text=>'Verticale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696382171400364)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Orientamento pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696245880400364)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'it'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696194681400364)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'it'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697837070400365)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695956434400364)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'it'
,p_message_text=>'Legale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695850422400364)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'it'
,p_message_text=>'Lettera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696068753400364)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'it'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695712783400364)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Dimensione pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685920201400357)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'it'
,p_message_text=>'Rimuovi formattazione dal testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839074918400468)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'it'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839199595400468)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'it'
,p_message_text=>'A intervalli'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849471339400476)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803015650400441)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'it'
,p_message_text=>'Aggiorna riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801886316400440)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'it'
,p_message_text=>'Aggiorna righe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807009556400444)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''area Griglia interattiva non esiste nell''applicazione %0, pagina %1 e area %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769917570400418)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'it'
,p_message_text=>'Rimuovi %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798168258400438)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'it'
,p_message_text=>'Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858790319400483)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'it'
,p_message_text=>'Report eliminato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858474368400482)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'it'
,p_message_text=>'Report alternativo salvato per tutti gli utenti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858347438400482)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Report predefinito salvato per tutti gli utenti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858632287400483)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'it'
,p_message_text=>'Report privato salvato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858570589400482)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'it'
,p_message_text=>'Report pubblico salvato per tutti gli utenti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112807147020400444)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'La griglia interattiva salvata con nome %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792499547400434)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'it'
,p_message_text=>unistr('Dati del report cos\00EC come si presentavano %0 minuti fa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792381464400434)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'it'
,p_message_text=>unistr('Dati del report cos\00EC come si presentavano 1 minuto fa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732002059400390)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Il report della griglia interattiva non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851620163400477)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'it'
,p_message_text=>'Report - Modifica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806952013400444)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'La griglia interattiva salvata con ID %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112851567084400477)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'it'
,p_message_text=>'Report - Salva con nome'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770067219400418)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859674340400483)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'La griglia interattiva salvata con ID statico %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854596990400480)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769144457400417)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803126300400441)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'it'
,p_message_text=>'Annulla modifiche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801992592400441)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'it'
,p_message_text=>'Ripristina righe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799190909400439)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'it'
,p_message_text=>'Riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798021556400438)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'it'
,p_message_text=>'Righe per pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859213886400483)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860489052400484)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'it'
,p_message_text=>'Azioni per la riga %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112769404667400417)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812140058400448)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'it'
,p_message_text=>'salvato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767675485400416)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'it'
,p_message_text=>'Report salvati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767797670400416)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Predefinito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742220980400397)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Un report salvato denominato %0 esiste gi\00E0. Immettere un nuovo nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767847354400416)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'it'
,p_message_text=>'Privato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767908316400416)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'it'
,p_message_text=>'Pubblico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854261411400479)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'it'
,p_message_text=>'Salva con nome'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801274147400440)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Salva impostazioni report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839248038400468)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'it'
,p_message_text=>'A dispersione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767510633400416)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846561937400474)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Cerca: Tutte le colonne di testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767438482400416)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'it'
,p_message_text=>'Cerca: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845759299400473)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'it'
,p_message_text=>'Cerca: Testo completo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792284239400434)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'it'
,p_message_text=>'Cerca ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835833755400466)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'it'
,p_message_text=>'- Seleziona -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776054279400422)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'it'
,p_message_text=>'Selezione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828756556400460)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'it'
,p_message_text=>'Selezionare 1 riga nell''area master'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767393073400416)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Selezionare le colonne in cui cercare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858986824400483)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni selezione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776218123400422)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'it'
,p_message_text=>'Selezione celle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776157386400422)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'it'
,p_message_text=>'Selezione righe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847122807400474)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Invia come posta elettronica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839642453400469)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Serie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765389898400414)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'it'
,p_message_text=>'Mostra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817994216400452)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'it'
,p_message_text=>'Mostra valore globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802761426400441)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista a riga singola'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801089947400440)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'it'
,p_message_text=>'Ordina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839752037400469)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'it'
,p_message_text=>'Ordina per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859350276400483)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile definire solo un ordinamento per colonna.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859168106400483)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu Modifica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112840778560400469)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'it'
,p_message_text=>'In pila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795056662400436)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'it'
,p_message_text=>'inizia con'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839385987400468)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'it'
,p_message_text=>'Borsistico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760314638400411)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Estendi larghezza colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112801413339400440)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Sottoscrizione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112819476464400453)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'it'
,p_message_text=>'Somma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860685906400484)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Griglia interattiva. Report: %0, vista: %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112854638821400480)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'it'
,p_message_text=>'Somma globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837507367400467)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Destinazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843990123400472)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'it'
,p_message_text=>'Colore testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770169679400418)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'it'
,p_message_text=>'Attiva/disattiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817829737400452)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'it'
,p_message_text=>'Descrizione comando'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112798288956400438)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112802619236400441)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'it'
,p_message_text=>'Sblocca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799796674400439)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'it'
,p_message_text=>unistr('Unit\00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846911885400474)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Esistono modifiche non salvate. Continuare?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112799652635400439)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836645488400466)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Valore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841577314400470)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 richiesto un valore.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826493402400459)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'it'
,p_message_text=>'Valore (impossibile modificare il fuso orario)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845493257400473)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'it'
,p_message_text=>'Testo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837905333400467)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'it'
,p_message_text=>'Verticale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797763099400438)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'it'
,p_message_text=>'Visualizza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835978694400466)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'it'
,p_message_text=>'Visualizzato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112837487870400467)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Volume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795683149400436)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'it'
,p_message_text=>'settimane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836028475400466)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'it'
,p_message_text=>'Larghezza colonna minima (pixel)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786885508400430)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'it'
,p_message_text=>'%0 tra %1 e %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786539863400430)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'it'
,p_message_text=>'%0 contiene %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786600452400430)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'it'
,p_message_text=>'%0 non contiene %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764735995400414)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'it'
,p_message_text=>'%0 non inizia con %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785325063400429)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'it'
,p_message_text=>'%0 uguale a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785549067400429)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'it'
,p_message_text=>'%0 maggiore di %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785673227400429)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'it'
,p_message_text=>'%0 maggiore o uguale a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786346624400429)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'it'
,p_message_text=>'%0 in %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787576859400430)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'it'
,p_message_text=>'%0 negli ultimi %1 giorni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787347835400430)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'it'
,p_message_text=>'%0 nelle ultime %1 ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787129573400430)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'it'
,p_message_text=>'%0 negli ultimi %1 minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787936590400431)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'it'
,p_message_text=>'%0 negli ultimi %1 mesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787736369400430)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'it'
,p_message_text=>'%0 nelle ultime %1 settimane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788199435400431)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'it'
,p_message_text=>'%0 negli ultimi %1 anni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787434734400430)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'it'
,p_message_text=>'%0 nell''ultimo giorno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787246834400430)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'it'
,p_message_text=>'%0 nell''ultima ora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787063983400430)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'it'
,p_message_text=>'%0 nell''ultimo minuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787845789400430)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'it'
,p_message_text=>'%0 nell''ultimo mese'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112787648755400430)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'it'
,p_message_text=>'%0 nell''ultima settimana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788016898400431)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'it'
,p_message_text=>'%0 nell''ultimo anno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789957915400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'it'
,p_message_text=>'%0 nei %1 giorni successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789775312400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'it'
,p_message_text=>'%0 nelle %1 ore successive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789594052400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'it'
,p_message_text=>'%0 nei %1 minuti successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790376218400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'it'
,p_message_text=>'%0 nei %1 mesi successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790116830400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'it'
,p_message_text=>'%0 nelle %1 settimane successive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790564340400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'it'
,p_message_text=>'%0 nei %1 anni successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789891915400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'it'
,p_message_text=>'%0 nel giorno successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789655024400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'it'
,p_message_text=>'%0 nell''ora successiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789477523400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'it'
,p_message_text=>'%0 nel minuto successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790210267400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'it'
,p_message_text=>'%0 nel mese successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790004110400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'it'
,p_message_text=>'%0 nella settimana successiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790479617400432)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'it'
,p_message_text=>'%0 nell''anno successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786099031400429)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non \00E8 vuoto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785951190400429)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('%0 \00E8 vuoto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785789858400429)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'it'
,p_message_text=>'%0 minore di %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785827058400429)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'it'
,p_message_text=>'%0 minore o uguale a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786130012400429)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'it'
,p_message_text=>'%0 simile a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786786535400430)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'it'
,p_message_text=>'%0 corrisponde all''espressione regolare %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792613942400434)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 minuti fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786967230400430)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'it'
,p_message_text=>'%0 non compreso tra %1 e %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785477170400429)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'it'
,p_message_text=>'%0 diverso da %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786405636400429)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'it'
,p_message_text=>'%0 non in %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788772906400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'it'
,p_message_text=>'%0 non negli ultimi %1 giorni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788591026400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'it'
,p_message_text=>'%0 non nelle ultime %1 ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788320615400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'it'
,p_message_text=>'%0 non negli ultimi %1 minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789102024400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'it'
,p_message_text=>'%0 non negli ultimi %1 mesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788900335400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'it'
,p_message_text=>'%0 non nelle ultime %1 settimane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789328514400432)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'it'
,p_message_text=>'%0 non negli ultimi %1 anni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788680307400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'it'
,p_message_text=>'%0 non nell''ultimo giorno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788444477400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'it'
,p_message_text=>'%0 non nell''ultima ora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788248998400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'it'
,p_message_text=>'%0 non nell''ultimo minuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789001599400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'it'
,p_message_text=>'%0 non nell''ultimo mese'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112788882403400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'it'
,p_message_text=>'%0 non nell''ultima settimana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112789246596400431)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'it'
,p_message_text=>'%0 non nell''ultimo anno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791117544400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'it'
,p_message_text=>'%0 non nei %1 giorni successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790991085400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'it'
,p_message_text=>'%0 non nelle %1 ore successive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790788364400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'it'
,p_message_text=>'%0 non nei %1 minuti successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791566959400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'it'
,p_message_text=>'%0 non nei %1 mesi successivi '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791384533400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'it'
,p_message_text=>'%0 non nelle %1 settimane successive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791710779400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'it'
,p_message_text=>'%0 non nei %1 anni successivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791010318400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'it'
,p_message_text=>'%0 non nel giorno successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790816025400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'it'
,p_message_text=>'%0 non nell''ora successiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112790677231400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'it'
,p_message_text=>'%0 non nel minuto successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791450858400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'it'
,p_message_text=>'%0 non nel mese successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791256536400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'it'
,p_message_text=>'%0 non nella settimana successiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791697315400433)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'it'
,p_message_text=>'%0 non nell''anno successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112786266041400429)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'it'
,p_message_text=>'%0 non simile a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793197132400434)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'it'
,p_message_text=>'%0 inizia con %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836744848400466)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'it'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795839355400436)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'it'
,p_message_text=>'anni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836866131400466)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836926593400467)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112845957825400473)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'it'
,p_message_text=>unistr('Luned\00EC 12 gennaio 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846055098400473)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'it'
,p_message_text=>'Gennaio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846119881400473)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'it'
,p_message_text=>'16 ore fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112846211841400474)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'it'
,p_message_text=>'tra 16 ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701221595400368)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'it'
,p_message_text=>'Tipo di file non valido. Tipi di file supportati: %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828199395400460)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'it'
,p_message_text=>'Sfoglia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827898244400460)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'it'
,p_message_text=>'Scegli file'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827989693400460)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'it'
,p_message_text=>'Scegli file'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701020825400368)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'it'
,p_message_text=>'Trascinamento della selezione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701479607400368)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'it'
,p_message_text=>'Trascinamento file selezionati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702630895400369)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'it'
,p_message_text=>'Selezionare un file o rilasciarne uno qui.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702750796400369)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'it'
,p_message_text=>'Selezionare o rilasciare i file qui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702896262400369)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'it'
,p_message_text=>'Selezionare un file o rilasciarne uno qui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702954390400369)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'it'
,p_message_text=>'Selezionare o rilasciare i file qui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701318178400368)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'it'
,p_message_text=>'%0 file'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701114110400368)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'it'
,p_message_text=>unistr('File troppo grande. La dimensione file massima \00E8 di %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688974110400359)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Indirizzo obbligatorio.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687807223400358)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'it'
,p_message_text=>unistr('Citt\00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688227924400359)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'it'
,p_message_text=>'Codice paese'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687902969400358)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'it'
,p_message_text=>'Numero civico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688858974400359)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'it'
,p_message_text=>'Latitudine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688700130400359)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'it'
,p_message_text=>'Longitudine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688654832400359)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'it'
,p_message_text=>'Mostra su mappa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688352296400359)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'it'
,p_message_text=>'Punteggio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688084741400358)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'it'
,p_message_text=>'Codice postale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688131970400359)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'it'
,p_message_text=>'Stato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687783873400358)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'it'
,p_message_text=>'Via'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687672152400358)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'it'
,p_message_text=>'Risultati della codifica geografica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700278348400367)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'it'
,p_message_text=>'Con codifica geografica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700344903400367)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'it'
,p_message_text=>'Senza codifica geografica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688524634400359)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'it'
,p_message_text=>'Mappa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112688447075400359)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessun indirizzo trovato.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689052303400359)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'%0 obbligatorio.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858844163400483)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'it'
,p_message_text=>'Testo della Guida: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752207504400405)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'it'
,p_message_text=>'Selezionato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752382576400405)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'it'
,p_message_text=>'Deselezionato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698261277400366)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'it'
,p_message_text=>'#LABEL# non rientra nell''intervallo valido compreso tra %0 e %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698337972400366)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'it'
,p_message_text=>unistr('#LABEL# non \00E8 multiplo di %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697992732400366)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve corrispondere ai valori %0 e %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698116079400366)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776465787400422)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'it'
,p_message_text=>'Non attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776527873400422)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'it'
,p_message_text=>'Attivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698085795400366)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681426488400354)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Aggiungi voce'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810638045400447)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810725388400447)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681543195400354)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'it'
,p_message_text=>'Voci selezionate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814496444400450)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'it'
,p_message_text=>'Avanzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814776942400450)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814588352400450)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'it'
,p_message_text=>'Comune'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814830112400450)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'it'
,p_message_text=>'Opzioni modello attive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815469417400450)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Opzioni modello non disponibili: questo componente non \00E8 visualizzato nella pagina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814319916400450)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna opzione modello trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814657226400450)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689966698400360)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'it'
,p_message_text=>'Cancella cerchio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691739134400361)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'it'
,p_message_text=>'Gli stili personalizzati non sono JSON validi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690245266400360)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'it'
,p_message_text=>'Strumento Distanza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690050349400360)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'it'
,p_message_text=>'Disegna cerchio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682607835400355)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'it'
,p_message_text=>'La ricerca con facet richiede un''origine dati a livello di area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685249597400356)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'it'
,p_message_text=>'Posizione corrente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686343767400357)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'it'
,p_message_text=>'Le coordinate della posizione iniziale non sono valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683711453400355)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'La posizione iniziale deve essere una geometria di punti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686189588400357)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'it'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684764870400356)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'it'
,p_message_text=>'Layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818072974400452)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'it'
,p_message_text=>'Layer: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689384128400359)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'it'
,p_message_text=>'Mappa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682599232400355)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'it'
,p_message_text=>'Messaggi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686203221400357)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'it'
,p_message_text=>'miglia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817047649400452)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('I dati contengono pi\00F9 di %0 righe. Questo valore supera il limite massimo consentito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684547343400356)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'it'
,p_message_text=>unistr('\00A9 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Termini</a> &nbsp;&nbsp; Dati mappa \00A9 2017 QUI')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683485933400355)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di dati SDO_GEOMETRY non \00E8 disponibile in questo database.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684646244400356)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'it'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> \00A9 OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> \00A9 Collaboratori per OpenStreetMap </a>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684824819400356)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'it'
,p_message_text=>'Punti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818186451400452)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'it'
,p_message_text=>'%0 punti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690156351400360)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'it'
,p_message_text=>'Zoom rettangolo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689837577400360)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685140240400356)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'it'
,p_message_text=>'Ripristina orientamento nord'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765407108400414)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Attiva modalit\00E0 2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765517994400414)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'it'
,p_message_text=>unistr('Attiva modalit\00E0 3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689762985400360)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'it'
,p_message_text=>'Attiva/disattiva informativa sul copyright'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690375678400360)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'it'
,p_message_text=>'Distanza totale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684995286400356)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'it'
,p_message_text=>'Ingrandisci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685095468400356)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'it'
,p_message_text=>'Riduci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812548596400448)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'it'
,p_message_text=>'Grassetto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813473281400449)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813062863400449)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'it'
,p_message_text=>'Codice in linea'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826668293400459)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'it'
,p_message_text=>'Inserisci immagine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826772493400459)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'it'
,p_message_text=>'Inserisci collegamento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812628770400448)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'it'
,p_message_text=>'Corsivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827369677400459)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'it'
,p_message_text=>'Collega'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813377254400449)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'it'
,p_message_text=>'Lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813241010400449)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista ordinata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812785409400448)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'it'
,p_message_text=>'Anteprima'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812826522400448)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'it'
,p_message_text=>'Nessun elemento da visualizzare in anteprima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812988605400449)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'it'
,p_message_text=>'Barrato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813124445400449)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'it'
,p_message_text=>'Lista non ordinata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792094753400433)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'it'
,p_message_text=>'corrente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112849521940400476)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'it'
,p_message_text=>'Altro...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112791935988400433)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'it'
,p_message_text=>'Caricamento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823761146400457)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'it'
,p_message_text=>'Messaggio di notifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797069256400437)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve essere un numero minore o uguale a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797194778400437)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve essere un numero valido.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797203905400437)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# non corrisponde al formato numerico %0 (ad esempio %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796973086400437)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'it'
,p_message_text=>'#LABEL# deve essere un numero maggiore o uguale a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796861546400437)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'it'
,p_message_text=>'Il valore di #LABEL# deve essere un numero compreso tra %0 e %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792187559400434)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'it'
,p_message_text=>'si apre in una nuova finestra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745393838400400)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina \00E8 stata gi\00E0 sottomessa e non pu\00F2 essere sottomessa nuovamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727967136400387)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Applicazione "%0": pagina "%1" non trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761753107400412)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #LABEL#.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705053561400371)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811035704400447)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810911694400447)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'it'
,p_message_text=>'Trova %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811297826400447)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811187442400447)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697158971400365)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'it'
,p_message_text=>'Immettere un termine di ricerca di almeno %0 caratteri.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766609251400415)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'it'
,p_message_text=>'Lista di valori popup: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697274516400365)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'it'
,p_message_text=>'Immettere il termine di ricerca.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697022326400365)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'it'
,p_message_text=>'Nessun risultato trovato.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696954545400365)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784846712400428)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Termine di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810828886400447)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'it'
,p_message_text=>'Cerca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821522972400455)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'it'
,p_message_text=>'In fase di elaborazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695590034400364)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'it'
,p_message_text=>'Aggiungi a schermata home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691507549400361)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Il dispositivo o il browser non sembra supportare l''installazione delle applicazioni Web progressive in questo momento.</p>',
unistr('    <p class="a-pwaDialog-intro">Se questa applicazione \00E8 gi\00E0 installata sul dispositivo, aprirla dalla schermata home.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691112510400361)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione. Per utilizzarlo a schermo intero, aggiungerlo alla schermata home.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Toccare l''icona <strong>Menu</strong> nella barra di navigazione inferiore.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toccare <strong>Installa</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toccare <strong>Aggiungi</strong> per confermare.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691264651400361)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione che possono essere utilizzate al meglio in Chrome o Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Toccare l''icona <strong>Menu</strong> accanto alla barra dell''indirizzo.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toccare <strong>Installa</strong>.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690861288400360)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Q uesto sito Web offre le funzionalit\00E0 di un''applicazione che possono essere utilizzate al meglio in Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Toccare l''icona <strong>Condividi</strong> nella barra di navigazione inferiore.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toccare <strong>Apri in Safari</strong>.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690536098400360)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione. Per un''esperienza ottimale, aggiungerlo alla schermata home.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Toccare l''icona <strong>Condividi</strong> accanto alla barra degli indirizzi.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toccare <strong>Aggiungi a schermata home</strong>.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toccare <strong style="color:#007AE1;">Aggiungi</strong> per confermare.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690413077400360)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione. Per un''esperienza ottimale, aggiungerlo alla schermata home.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Toccare l''icona <strong>Condividi</strong> nella barra di navigazione.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Scorrere verso il basso e toccare <strong>Aggiungi a schermata home</strong>.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toccare <strong style="color:#007AE1;">Aggiungi</strong> per confermare.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685433937400357)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione. Per un''esperienza ottimale, aggiungerlo alla schermata home.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
'        <p class="a-pwaDialog-stepText">1. Toccare l''icona <strong>Altro</strong> accanto alla barra degli indirizzi.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toccare <strong>Aggiungi a schermata home</strong>.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toccare <strong style="color:#007AE1;">Aggiungi</strong> per confermare.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690709940400360)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione. Per un''esperienza ottimale, aggiungerlo alla schermata home.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Toccare l''icona <strong>Condividi</strong> accanto alla barra degli indirizzi.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Toccare <strong>Apri in Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690662084400360)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione. Per un''esperienza ottimale, aggiungerlo alla schermata home.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Toccare l''icona <strong>Condividi</strong> nella barra di navigazione.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Toccare <strong>Apri in Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691407493400361)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione che possono essere utilizzate al meglio in Chrome.</p>'),
'    <p class="a-pwaDialog-intro">Al momento, Firefox non supporta l''installazione di applicazioni Web.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112690951947400360)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione che possono essere utilizzate al meglio in Chrome o Edge.</p>'),
'    <p class="a-pwaDialog-intro">Al momento, Firefox non supporta l''installazione di applicazioni Web su MacOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691046521400361)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione che possono essere utilizzate al meglio in Chrome o Edge.</p>'),
'    <p class="a-pwaDialog-intro">Al momento, Safari non supporta l''installazione di applicazioni Web su MacOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691370445400361)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Questo sito Web offre le funzionalit\00E0 di un''applicazione che possono essere utilizzate al meglio in Chrome o Edge.</p>'),
'    <p class="a-pwaDialog-intro">Al momento, Firefox non supporta l''installazione di applicazioni Web su Windows.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693870745400363)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>Impossibile connettersi</h1>',
unistr('    <p>Per utilizzare questa applicazione, \00E8 necessaria una connessione a Internet.</p>'),
'    <button type="button">Riprovare</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693731664400363)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'it'
,p_message_text=>'Impossibile connettersi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833531847400464)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777913099400423)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'it'
,p_message_text=>'Giornata intera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856804782400481)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'it'
,p_message_text=>'Invia invito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856664483400481)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'it'
,p_message_text=>'Opzioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779770265400425)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'it'
,p_message_text=>'Vista giornaliera per tutto il giorno '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779555355400425)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'it'
,p_message_text=>'Vista giornaliera per dati con ora '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824477427400457)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'it'
,p_message_text=>'Giorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818839231400453)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709412200400374)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'it'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709261243400374)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'it'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709132167400374)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'it'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709324353400374)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'it'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708837977400373)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'it'
,p_message_text=>'Data di fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709049360400374)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'it'
,p_message_text=>'Nome evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856799478400481)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'it'
,p_message_text=>'Invito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824557311400457)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824293746400457)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'it'
,p_message_text=>'Mese'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827033691400459)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841383131400470)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'it'
,p_message_text=>'Nessun evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857095773400481)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'it'
,p_message_text=>'Modifica un evento esistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856933328400481)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'it'
,p_message_text=>'Invio di un invito mediante posta elettronica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827102872400459)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835168359400465)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'it'
,p_message_text=>'Invia messaggio di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834983740400465)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'it'
,p_message_text=>'Invia messaggio di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857753866400482)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Tutti i campi sono obbligatori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857600574400482)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'it'
,p_message_text=>'Invia invito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856581105400481)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'it'
,p_message_text=>'Oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835095926400465)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'it'
,p_message_text=>'A'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708943095400373)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'it'
,p_message_text=>'Data di inizio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832834231400463)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'it'
,p_message_text=>'Form su %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779359329400424)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'it'
,p_message_text=>'Quando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827242027400459)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'it'
,p_message_text=>'Oggi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825055272400457)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'it'
,p_message_text=>'Visualizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824386709400457)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'it'
,p_message_text=>'Settimana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779658366400425)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'it'
,p_message_text=>'Vista settimanale per tutto il giorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779459616400424)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'it'
,p_message_text=>'Vista settimanale per dati con ora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824954351400457)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'it'
,p_message_text=>'Anno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824617550400457)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824785438400457)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'it'
,p_message_text=>'Carica altro...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756859366400408)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'it'
,p_message_text=>'Indietro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703197120400369)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'it'
,p_message_text=>'Carica altro...'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705275735400371)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112824854310400457)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'it'
,p_message_text=>'Carica altro...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826993172400459)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'ID area %0 non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705155508400371)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Nessun dato trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729274217400388)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile reimpostare l''impaginazione per l''area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697487900400365)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''impostazione dell''impaginazione dell''area.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818299224400452)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826843997400459)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di area %0 non \00E8 supportato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697310603400365)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la presentazione dell''area "#COMPONENT_NAME#".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761808404400412)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per #COLUMN_HEADER#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856144054400481)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'it'
,p_message_text=>'%0, Rich Text Editor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763978462400413)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'it'
,p_message_text=>'Il markup HTML Rich Text supera la lunghezza massima dell''elemento (caratteri effettivi: %0, caratteri consentiti: %1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823876989400457)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815693447400450)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'it'
,p_message_text=>'Duplica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813905917400449)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'it'
,p_message_text=>'Colonne visualizzate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813849854400449)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'it'
,p_message_text=>'Escludi valori nulli'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823980417400457)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'it'
,p_message_text=>'Aggiungi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777584178400423)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'it'
,p_message_text=>'Sposta in basso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777685373400423)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'it'
,p_message_text=>'Sposta in alto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813617588400449)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'it'
,p_message_text=>'Successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814292114400450)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'it'
,p_message_text=>'Altre colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813755020400449)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'it'
,p_message_text=>'Precedente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814040500400449)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'it'
,p_message_text=>'Riga %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814108400400449)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'it'
,p_message_text=>'Riga %0 di %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815778529400451)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'it'
,p_message_text=>'Aggiorna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815879361400451)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'it'
,p_message_text=>'Annulla modifiche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112813569179400449)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu Impostazioni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774555038400421)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Ad esempio, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682026750400354)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'it'
,p_message_text=>'Accedere di nuovo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681993659400354)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'it'
,p_message_text=>unistr('La sessione \00E8 terminata')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682193395400354)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'it'
,p_message_text=>'Estendi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681781357400354)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'it'
,p_message_text=>unistr('La sessione terminer\00E0 alle %0. Estenderla?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681897340400354)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'it'
,p_message_text=>unistr('La sessione terminer\00E0 alle %0 e non pu\00F2 essere estesa. Salvare il lavoro ora per evitare di perdere dati.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834755684400465)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione del codice di cleanup della sessione del database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727803884400387)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione del codice di impostazione della sessione del database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112701987004400368)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'it'
,p_message_text=>unistr('La sessione \00E8 terminata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833668316400464)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'it'
,p_message_text=>'Chiudere questa finestra di dialogo e fare clic sul pulsante di ricaricamento del browser per ottenere una nuova sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852989567400478)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'it'
,p_message_text=>'Fare clic <a href="%0">qui</a> per creare una nuova sessione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739554649400396)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'it'
,p_message_text=>'Sessione non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779044003400424)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato possibile abilitare alcun ruolo dinamico nella sessione Real Application Security per l''utente "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725705927400385)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'ERR-99900 Impossibile creare un ID sessione univoco: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742076312400397)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'it'
,p_message_text=>unistr('Violazione della protezione dello stato sessione. Ci\00F2 potrebbe essere causato dalla modifica manuale dell''elemento di pagina protetto %0. Se non si \00E8 certi della causa dell''errore, contattare l''amministratore dell''applicazione per assistenza.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861150379400484)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'it'
,p_message_text=>unistr('Violazione della protezione della pagina. Ci\00F2 potrebbe essere causato dalla sottomissione di una pagina il cui caricamento era ancora in corso oppure dalla modifica manuale degli elementi di pagina protetti. Contattare l''amministratore dell''applicazi')
||'one per assistenza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860176018400484)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'it'
,p_message_text=>'%0 contiene uno dei caratteri non validi seguenti: &<>"/;,*|=% o --'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860238105400484)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'it'
,p_message_text=>'%0 contiene uno dei caratteri non validi seguenti: &<>"/;,*|=% o -- o nuova riga.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859909317400483)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'it'
,p_message_text=>'%0 contiene caratteri speciali. Sono consentiti solo i caratteri a-Z, 0-9 e gli spazi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112860075884400484)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'it'
,p_message_text=>'%0 contiene <, > o ", ovvero caratteri non validi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704100015400370)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 stato fornito nessun checksum per visualizzare l''elaborazione di una pagina che richiede un checksum se vengono passati valori di richiesta, di svuotamento di cache o di argomento come parametri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736980509400394)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'it'
,p_message_text=>unistr('Violazione della protezione dello stato sessione. Ci\00F2 potrebbe esse causato da una modifica manuale di un URL che contiene un checksum o dall''utilizzo di un collegamento con un checksum errato o mancante. Se non si \00E8 certi della causa dell''errore, co')
||'ntattare l''amministratore dell''applicazione per assistenza.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112814946096400450)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'it'
,p_message_text=>unistr('Disattiva modalit\00E0 contrasto elevato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815081235400450)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'it'
,p_message_text=>unistr('Attiva modalit\00E0 contrasto elevato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733696512400391)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733828833400391)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'it'
,p_message_text=>unistr('Gi\00F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733997381400391)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'it'
,p_message_text=>'Sposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734092353400392)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'it'
,p_message_text=>'Sposta tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734118495400392)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734222173400392)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'it'
,p_message_text=>'Rimuovi tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734397453400392)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733516824400391)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'it'
,p_message_text=>'In alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733769152400391)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'it'
,p_message_text=>'Su'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842605554400471)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843385148400471)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'tra %0 giorno/i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842581931400471)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843400308400471)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'tra %0 ora/e'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842364187400471)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'it'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843552958400472)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'tra %0 mese/i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842934288400471)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 mese/i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843169706400471)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'tra %0 mese/i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842469587400471)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843247503400471)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'tra %0 secondo/i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842749416400471)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843674226400472)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'tra %0 settimana/e'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842806922400471)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112843033606400471)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'tra %0 anno/i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682935209400355)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'it'
,p_message_text=>'[Linea]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683352896400355)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'it'
,p_message_text=>'[Linee multiple]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683153160400355)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'it'
,p_message_text=>'[Punti multipli]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683537268400355)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'it'
,p_message_text=>'[Poligoni multipli]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683671489400355)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'it'
,p_message_text=>'[Oggetto geometria]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682851102400355)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'it'
,p_message_text=>'[Punto (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683079684400355)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'it'
,p_message_text=>'[Poligono]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760231796400411)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'it'
,p_message_text=>'Comprimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760127802400411)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'it'
,p_message_text=>'Ripristina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806606331400444)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'it'
,p_message_text=>'Cancella valutazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796507043400437)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non \00E8 compreso nell''intervallo di valutazione 1 - %1 valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796678101400437)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'it'
,p_message_text=>unistr('%0 non \00E8 numerico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792761090400434)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'it'
,p_message_text=>'Messaggio di operazione riuscita'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855859083400481)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855783414400480)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841484360400470)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'it'
,p_message_text=>'Barra degli strumenti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856287619400481)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'it'
,p_message_text=>'Espandi/comprimi navigazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856312044400481)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'it'
,p_message_text=>'Espandi/comprimi colonna laterale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765971558400415)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'it'
,p_message_text=>'Navigazione principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772996366400420)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'it'
,p_message_text=>'1 giorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772775021400420)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'it'
,p_message_text=>'1 ora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773069254400420)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'it'
,p_message_text=>'%0 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772849479400420)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'it'
,p_message_text=>'%0 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772644861400420)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'it'
,p_message_text=>'%0 minuti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773243140400420)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'it'
,p_message_text=>'%0 settimane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112773129706400420)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'it'
,p_message_text=>'1 settimana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859489286400483)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'it'
,p_message_text=>'Inizio della pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721431050400382)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695291115400364)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''elaborazione della richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774691973400421)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Valore obbligatorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857567098400482)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'it'
,p_message_text=>'Attendere il caricamento completo della pagina e riprovare.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817733349400452)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'it'
,p_message_text=>'Questa pagina contiene modifiche non salvate.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698662463400366)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'it'
,p_message_text=>'La cartella di lavoro non ha un foglio di lavoro attivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698508425400366)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'it'
,p_message_text=>unistr('La cartella di lavoro non \00E8 stata inizializzata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698448954400366)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore interno durante la creazione del file XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700996130400368)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'it'
,p_message_text=>'Foglio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832644854400463)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750172104400403)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu Azioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745859170400400)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Aggiungi funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745700642400400)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Aggiungi colonna Raggruppa per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779904329400425)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Aggiungi colonna pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780080262400425)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Aggiungi colonna righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720203969400382)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'it'
,p_message_text=>'Aggregato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756342521400408)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'it'
,p_message_text=>'Aggregazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737401365400394)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'it'
,p_message_text=>'Media'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741722653400397)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737593135400394)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'it'
,p_message_text=>'Massimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737757359400394)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'it'
,p_message_text=>'Mediana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737695819400394)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'it'
,p_message_text=>'Minimo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737378029400394)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'it'
,p_message_text=>'Somma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738422092400395)
,p_name=>'APEXIR_ALL'
,p_message_language=>'it'
,p_message_text=>'Tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719574963400381)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Tutte le colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702026674400368)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'it'
,p_message_text=>'Tutte le righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829674022400461)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'it'
,p_message_text=>'Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831295313400462)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'it'
,p_message_text=>'Predefinito alternativo:  %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732132308400390)
,p_name=>'APEXIR_AND'
,p_message_language=>'it'
,p_message_text=>'e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721664472400383)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'it'
,p_message_text=>'Applica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715300238400378)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'it'
,p_message_text=>'Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734973569400392)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'it'
,p_message_text=>'A partire da %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831812313400463)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'it'
,p_message_text=>'Media %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823262491400456)
,p_name=>'APEXIR_BAR'
,p_message_language=>'it'
,p_message_text=>'A barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721007283400382)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'it'
,p_message_text=>'tra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714117655400377)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'it'
,p_message_text=>'Colore sfondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716044609400379)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'it'
,p_message_text=>'blu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747716000400401)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'it'
,p_message_text=>'In basso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716632134400379)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'it'
,p_message_text=>'Annulla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722523444400383)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'it'
,p_message_text=>'Categoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714054331400377)
,p_name=>'APEXIR_CELL'
,p_message_language=>'it'
,p_message_text=>'Cella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738352498400395)
,p_name=>'APEXIR_CHART'
,p_message_language=>'it'
,p_message_text=>'Grafico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748664426400402)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'it'
,p_message_text=>'Inizializzazione in corso...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112784929486400428)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare l''etichetta del grafico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797372175400437)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'it'
,p_message_text=>'La query supera il numero massimo di %0 datapoint per grafico. Applicare un filtro per ridurre il numero di record nella query di base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796238709400436)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'it'
,p_message_text=>'Il conteggio massimo di righe per una query di tipo Grafico limita il numero di righe nella query di base, non il numero di righe visualizzate. La query di base supera il conteggio massimo di righe pari a %0 righe. Applicare un filtro per ridurre il '
||'numero di record nella query di base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719648822400381)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112792952305400434)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'it'
,p_message_text=>'Seleziona tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735383749400393)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Scegliere il formato del report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742764436400398)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'it'
,p_message_text=>'cancellare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716599408400379)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753937861400406)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826215962400458)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtra...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744741003400399)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'it'
,p_message_text=>'Menu Intestazione colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748462474400402)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'it'
,p_message_text=>'Informazioni colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828548692400460)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746100012400400)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'it'
,p_message_text=>'Colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730296958400389)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'it'
,p_message_text=>'contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731188581400389)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'it'
,p_message_text=>'non contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715060289400378)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'it'
,p_message_text=>'in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731319504400390)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'it'
,p_message_text=>unistr('non \00E8 negli ultimi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739866073400396)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'it'
,p_message_text=>unistr('non \00E8 nei prossimi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731273715400390)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'it'
,p_message_text=>unistr('\00E8 negli ultimi')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739760248400396)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'it'
,p_message_text=>unistr('\00E8 nei prossimi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714943424400378)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('non \00E8 nullo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714830121400378)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('\00E8 nullo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714693445400378)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'it'
,p_message_text=>'simile a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715119128400378)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'it'
,p_message_text=>'non in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714791785400378)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'it'
,p_message_text=>'non simile a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730581044400389)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'it'
,p_message_text=>'corrisponde all''espressione regolare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735254825400392)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112795951965400436)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'Espressione di calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754210168400406)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'it'
,p_message_text=>'Creare un calcolo utilizzando alias di colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754330144400406)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'it'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754404375400406)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'it'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754593959400406)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'it'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700402363400367)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'it'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739199303400395)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'it'
,p_message_text=>'Calcola'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746734365400401)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'it'
,p_message_text=>'Interruzione di controllo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749765169400403)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'it'
,p_message_text=>'Interruzioni di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834116515400464)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne di interruzione controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697589127400365)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832336696400463)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'it'
,p_message_text=>'Conteggio distinti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832217274400463)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'it'
,p_message_text=>'Conteggio %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804338190400442)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'it'
,p_message_text=>'Giornaliero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859025515400483)
,p_name=>'APEXIR_DATA'
,p_message_language=>'it'
,p_message_text=>'Dati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748596662400402)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'it'
,p_message_text=>unistr('Dati del report cos\00EC come si presentavano %0 minuti fa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822006573400455)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'it'
,p_message_text=>'Guida per le griglie dati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720384845400382)
,p_name=>'APEXIR_DATE'
,p_message_language=>'it'
,p_message_text=>'Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752438630400405)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829444167400461)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di report predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716726582400379)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'it'
,p_message_text=>'Elimina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720693284400382)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Eliminare queste impostazioni di report?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815330559400450)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'it'
,p_message_text=>'Elimina report predefinito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746403868400401)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'it'
,p_message_text=>'Elimina report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715439473400378)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'it'
,p_message_text=>'Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722651048400383)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744615619400399)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista a riga singola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752954153400405)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'it'
,p_message_text=>'Direzione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753859490400406)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'it'
,p_message_text=>'Disabilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716243679400379)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'it'
,p_message_text=>'Visualizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719436566400381)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne visualizzate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752831562400405)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'it'
,p_message_text=>'Visualizza nel report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747651476400401)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'it'
,p_message_text=>unistr('Gi\00F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739217052400395)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'Scarica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752753737400405)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'it'
,p_message_text=>'Non visualizzare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818734831400453)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'it'
,p_message_text=>unistr('L''evidenziazione con la stessa condizione esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834366775400465)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna pivot duplicata. La colonna pivot deve essere univoca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834571027400465)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748715533400402)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'it'
,p_message_text=>'Modifica impostazioni grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755359842400407)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'it'
,p_message_text=>'Modifica grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755783536400407)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'it'
,p_message_text=>'Modifica filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810166719400446)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'it'
,p_message_text=>'Modifica raggruppamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755623906400407)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'it'
,p_message_text=>'Modifica evidenziazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780224565400425)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'it'
,p_message_text=>'Modifica pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829741049400461)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708430705400373)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'it'
,p_message_text=>'Indirizzo di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830043999400461)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'it'
,p_message_text=>'Ccn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830224118400461)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'it'
,p_message_text=>'Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829901592400461)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'it'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830740957400462)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'it'
,p_message_text=>'Frequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712191595400376)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica non configurata per questa applicazione. Contattare l''amministratore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803633258400442)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare l''indirizzo di posta elettronica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830390450400462)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'it'
,p_message_text=>'Vedere l''allegato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830116810400461)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'it'
,p_message_text=>'Oggetto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804634020400442)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare l''oggetto del messaggio di posta elettronica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829873303400461)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'it'
,p_message_text=>'A'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713823593400377)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'it'
,p_message_text=>'Abilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755520882400407)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'it'
,p_message_text=>'Abilita/disabilita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755067098400407)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754697088400407)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'it'
,p_message_text=>'Esempi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755477497400407)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'it'
,p_message_text=>'Esempi:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719302755400381)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'it'
,p_message_text=>'Escludi valori nulli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756086182400408)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'it'
,p_message_text=>'Espandi/comprimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753603408400406)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'Espressione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738734466400395)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749664119400403)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'it'
,p_message_text=>'Filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759939728400410)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'it'
,p_message_text=>'Espressione di filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856452026400481)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('L''espressione di filtro \00E8 troppo lunga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759850877400410)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756293932400408)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'it'
,p_message_text=>'Selezionare le colonne in cui cercare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739090366400395)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'it'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753469892400406)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('La funzione Flashback query consente di visualizzare i dati cos\00EC come si presentavano in un precedente point-in-time.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804029390400442)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'it'
,p_message_text=>'Durata flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805418461400443)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735185375400392)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Formato di visualizzazione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746331429400400)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Funzione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754144781400406)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'it'
,p_message_text=>'Funzioni %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829333150400461)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'it'
,p_message_text=>'Funzioni/operatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746088065400400)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'it'
,p_message_text=>'Funzione %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738507710400395)
,p_name=>'APEXIR_GO'
,p_message_language=>'it'
,p_message_text=>'Vai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714353648400377)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'it'
,p_message_text=>'verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112697626467400365)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'it'
,p_message_text=>'Raggruppa per '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830467944400462)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Raggruppa per colonna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785045551400428)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare la colonna Raggruppa per.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796197775400436)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'it'
,p_message_text=>'Il conteggio massimo di righe per una query di tipo Raggruppa per limita il numero di righe nella query di base, non il numero di righe visualizzate. La query di base supera il conteggio massimo di righe pari a %0 righe. Applicare un filtro per ridur'
||'re il numero di record nella query di base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776756322400423)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'it'
,p_message_text=>'Raggruppa per ordinamento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834226140400464)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'it'
,p_message_text=>'Raggruppa per criterio ordinamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719782591400381)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne orizzontali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751343224400404)
,p_name=>'APEXIR_HELP'
,p_message_language=>'it'
,p_message_text=>'Guida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743174639400398)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('I report interattivi consentono agli utenti finali di personalizzare i report. \00C8 possibile modificare il layout dei dati del report selezionando le colonne desiderate, applicando filtri, evidenziando e ordinando gli elementi. Gli utenti possono inolt')
||unistr('re definire interruzioni, aggregazioni, grafici e raggruppamenti nonch\00E9 aggiungere calcoli. \00C8 inoltre possibile impostare una sottoscrizione per inviare via posta elettronica una versione HTML del report in base all''intervallo specificato. Gli utenti')
||' possono creare varie versioni del report e salvarle come report denominati, visualizzabili pubblicamente o privatamente. ',
'<p/>',
unistr('Le sezioni seguenti contengono il riepilogo delle varie modalit\00E0 di personalizzazione di un report interattivo. Per ulteriori informazioni, vedere "Uso dei report interattivi" in <i>Guida per l''utente finale di Oracle Application Express</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750242587400403)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'it'
,p_message_text=>unistr('Il menu Azioni \00E8 visualizzato a destra del pulsante Vai nella barra di ricerca. Utilizzare questo menu per personalizzare un report interattivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743944245400399)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Gli aggregati sono calcoli matematici eseguiti su una colonna. Gli aggregati vengono visualizzati dopo ogni interruzione di controllo e alla fine del report all''interno della colonna in cui sono definiti. Opzioni disponibili:',
'<p>',
'</p><ul>',
'<li><strong>Aggregazione</strong>: consente di selezionare un''aggregazione definita',
'in precedenza per modificarla.</li>',
'<li><strong>Funzione</strong>: la funzione da eseguire (ad esempio SUM, MIN).</li>',
'<li><strong>Colonna</strong>: consente di selezionare la colonna a cui applicare la funzione matematica. Verranno visualizzate solo le',
'colonne numeriche.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744042449400399)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C8 possibile definire un grafico per report salvato. Dopo'),
unistr('aver definito il grafico, \00E8 possibile alternare le viste grafico e report utilizzando le icone specifiche della barra di ricerca.'),
'Di seguito sono riportate le opzioni disponibili.',
'<p>',
'</p><ul>',
'<li><strong>Tipo di grafico</strong>: identifica il tipo di grafico da includere.',
'Selezionare tra grafico a barre orizzontali, a barre verticali, a torta o a linee.</li>',
'<li><strong>Etichetta</strong>: consente di selezionare la colonna da utilizzare come etichetta.</li>',
unistr('<li><strong>Titolo asse per etichetta</strong>: il titolo che verr\00E0 visualizzato sull''asse associato alla colonna selezionata'),
'per Etichetta. Non disponibile per il grafico a torta.</li>',
'<li><strong>Valore</strong>: consente di selezionare la colonna da utilizzare come valore. Se la funzione',
unistr('\00E8 COUNT, non \00E8 necessario selezionare un valore.</li>'),
unistr('<li><strong>Titolo asse per valore</strong>: il titolo che verr\00E0 visualizzato sull''asse associato alla colonna selezionata'),
'per Valore. Non disponibile per il grafico a torta.</li>',
'<li><strong>Funzione</strong>: funzione facoltativa da eseguire sulla colonna selezionata per Valore.</li>',
'<li><strong>Ordina</strong>: consente di ordinare il set di risultati.</li></ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743329765400398)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Quando si fa clic su un''intestazione di colonna qualsiasi viene visualizzato un menu Intestazione colonna. Opzioni disponibili:',
'<p></p>',
'<ul>',
'<li><strong>Icona Ordinamento crescente</strong>: ordina il report in base alla colonna con ordinamento crescente.</li>',
'<li><strong>Icona Ordinamento decrescente</strong>: ordina il report in base alla colonna con ordinamento decrescente.</li>',
unistr('<li><strong>Nascondi colonna</strong>: nasconde la colonna. Non tutte le colonne possono essere nascoste. Se non \00E8 possibile nascondere una colonna, non sar\00E0 presente l''icona Nascondi colonna.</li>'),
'<li><strong>Colonna di interruzione</strong>: crea un gruppo di interruzione sulla colonna. La colonna viene estratta dal report e visualizzata come record principale.</li>',
'<li><strong>Informazioni colonna</strong>: visualizza il testo della Guida relativo alla colonna, se disponibile.</li>',
'<li><strong>Area di testo</strong>: questa voce di menu viene utilizzata per l''immissione di criteri',
unistr('di ricerca senza distinzione tra maiuscole e minuscole (non occorrono caratteri jolly). L''immissione di un valore comporta la riduzione della lista di valori alla fine del menu. \00C8 quindi possibile selezionare un valore'),
unistr('nella parte inferiore e il valore selezionato verr\00E0 creato come filtro con l''operatore ''='''),
unistr('(ad esempio, <code>column = ''ABC''</code>). In alternativa \00E8 possibile fare clic sull''icona a forma di torcia elettrica e immettere un valore da creare come filtro con'),
'il modificatore ''LIKE'' (ad esempio, <code>column LIKE ''%ABC%''</code>).</li>',
'<li><b>Lista di valori univoci</b> contiene i primi 500 valori univoci',
unistr('che soddisfano i criteri di filtro. Se la colonna \00E8 di tipo data, viene'),
'visualizzata una lista di intervalli di date. Se si seleziona un valore,',
unistr('verr\00E0 creato un filtro con l''operatore ''='' (ad esempio, <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743871459400399)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Consente di aggiungere colonne calcolate al report. Pu\00F2 trattarsi di calcoli matematici (ad esempio <code>NBR_HOURS/24</code>) o di funzioni Oracle'),
unistr('standard applicate a colonne esistenti (alcune sono state visualizzate ed \00E8 possibile utilizzarne altre, ad esempio <code>TO_DATE)</code>). Opzioni disponibili:'),
'<p></p>',
'<ul>',
'<li><strong>Calcolo</strong>: consente di selezionare un calcolo definito in precedenza per modificarlo.</li>',
'<li><strong>Intestazione colonna</strong>: l''intestazione della nuova colonna.</li>',
'<li><strong>Formato di visualizzazione</strong>: il formato di visualizzazione Oracle da applicare alla colonna (ad esempio S9999).</li>',
'<li><strong>Calcolo</strong>: il calcolo da eseguire. All''interno del calcolo per fare riferimento alle colonne si utilizzano gli alias visualizzati.</li>',
'</ul>',
'<p>Sotto il calcolo vengono visualizzate le colonne della query con',
'i rispettivi alias associati. Quando si fa clic sul nome o l''alias della colonna, ',
unistr('gli elementi vengono scritti nel calcolo. Accanto alle colonne \00E8 disponibile un tastierino,'),
unistr('che funge da scelta rapida per i tasti pi\00F9 utilizzati. A destra si trovano le funzioni.</p>'),
'<p>Di seguito viene riportato un esempio di calcolo del compenso totale:</p>',
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(dove A \00E8 l''ORGANIZZAZIONE, B \00E8 lo STIPENDIO e C \00E8 la COMMISSIONE)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750376649400403)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'it'
,p_message_text=>unistr('Consente di creare un gruppo di interruzione su una o pi\00F9 colonne. Questa operazione comporta l''estrazione delle colonne dal report interattivo e la loro visualizzazione come record principale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744574992400399)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'it'
,p_message_text=>unistr('Per visualizzare i dettagli di una sola riga alla volta, fare clic sull''icona della vista a riga singola sulla riga da visualizzare. Se disponibile, la vista a riga singola sar\00E0 sempre la prima colonna. A seconda della personalizzazione del report in')
||unistr('terattivo, la vista a riga singola pu\00F2 essere la vista standard oppure una pagina personalizzata che consente l''aggiornamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744401668400399)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'Consente di scaricare il set di risultati corrente. I formati di download variano a seconda dell''installazione e della definizione del report, ma possono comprendere CSV, HTML, Posta elettronica, XLS, PDF o RTF.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743512627400398)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Specifica ulteriormente il report aggiungendo o modificando la clausola <code>WHERE</code> nella query. \00C8 possibile applicare un filtro per colonna o per riga.  '),
'<p/>Se si applica il filtro per colonna, selezionare una colonna (non necessariamente quella',
'visualizzata), selezionare un operatore Oracle standard (=, !=, not in, between) e infine immettere un''espressione di confronto. Le espressioni distinguono tra maiuscole e minuscole. Utilizzare % come carattere jolly (ad esempio <code>STATE_NAME',
'like A%)<code>.</p>',
unistr('<p>Se si applica un filtro per riga, \00E8 possibile creare clausole <code>WHERE</code> complesse utilizzando'),
'alias di colonna e qualsiasi funzione o operatore Oracle (ad esempio <code>G = ''VA'' o G = ''CT''</code>, dove',
unistr('<code>G</code> \00E8 l''alias per <code>CUSTOMER_STATE</code>).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744101370400399)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Una funzione Flashback query consente di visualizzare i dati cos\00EC come si presentavano in un precedente'),
unistr('point in time. La quantit\00E0 di tempo massima presa in considerazione dalla funzione \00E8 pari a 3 ore (o 180'),
unistr('minuti) ma la quantit\00E0 effettiva varia a seconda del database.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805334379400443)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>L''opzione Formato consente di personalizzare la visualizzazione del report.',
'L''opzione Formato contiene i sottomenu seguenti:</p>',
'<ul><li>Ordina</li>',
'<li>Interruzione di controllo</li>',
'<li>Evidenzia</li>',
'<li>Calcola</li>',
'<li>Aggrega</li>',
'<li>Grafico</li>',
'<li>Raggruppa per</li>',
'<li>Pivot</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803516256400442)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C8 possibile definire una sola vista di raggruppamento per report salvato.'),
unistr('Dopo averla definita, \00E8 possibile alternare le viste di raggruppamento e report'),
'utilizzando le icone vista della barra di ricerca. Per creare una vista Raggruppa per',
unistr('\00E8 necessario selezionare:'),
'<p></p><ul>',
'<li>le colonne su cui basare il raggruppamento</li>',
unistr('<li>le colonne da aggregare insieme alla funzione da eseguire (media, somma, conteggio e cos\00EC via)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743750379400399)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consente di definire un filtro. Le righe che soddisfano i criteri del filtro vengono evidenziate mediante caratteristiche associate al filtro. Opzioni disponibili:</p>',
'<ul>',
'<li><strong>Nome</strong>: utilizzato solo per la visualizzazione.</li>',
'<li><strong>Sequenza</strong> : identifica la sequenza in cui verranno valutate le regole.</li>',
unistr('<li><strong>Abilitato</strong>: indica se la regola \00E8 abilitata o disabilitata.</li>'),
'<li><strong>Tipo di evidenziazione</strong>: indica se deve essere evidenziata la riga o',
'una cella. Se si seleziona Cella, viene evidenziata la colonna a cui si fa riferimento in Condizione di evidenziazione.</li>',
'<li><strong>Colore sfondo</strong>: il nuovo colore per lo sfondo dell''area evidenziata.</li>',
'<li><strong>Colore testo</strong>: il nuovo colore per il testo dell''area evidenziata.</li>',
'<li><strong>Condizione di evidenziazione</strong>: definisce la condizione del filtro.</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681370591400354)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C8 possibile definire una sola vista pivot per report salvato. Dopo averla definita, \00E8 possibile alternare le viste pivot e report utilizzando le icone vista nella barra di ricerca. Per creare una vista pivot \00E8 necessario selezionare:'),
'<p></p>',
'<ul>',
'<li>le colonne su cui eseguire il pivot</li>',
'<li>le colonne da visualizzare come righe</li>',
unistr('<li>le colonne da aggregare insieme alla funzione da eseguire (media, somma, conteggio e cos\00EC via)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754864793400407)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se si personalizza un report interattivo, le impostazioni del report verranno visualizzate',
unistr('sotto la barra di ricerca e sopra il report. Quest''area pu\00F2 essere compressa ed espansa utilizzando l''icona a sinistra.'),
'<p>',
unistr('Per ogni impostazione del report \00E8 possibile effettuare le operazioni riportate di seguito'),
'.</p><ul>',
'<li>Modificare un''impostazione facendo clic sul nome.</li>',
'<li>Disabilitare/abilitare un''impostazione deselezionando o selezionando la casella di controllo Abilita/disabilita. Questa casella di controllo consente di disattivare temporaneamente e riattivare l''impostazione.</li>',
'<li>Rimuovere un''impostazione facendo clic sull''icona Rimuovi.</li>',
'</ul>',
unistr('<p>Se \00E8 stato creato un grafico, un raggruppamento o una tabella pivot, \00E8 possibile alternarli'),
'con il report di base utilizzando i collegamenti Vista report, Vista grafico, Vista Raggruppa per e Vista pivot,',
unistr('mostrati a destra. Quando si visualizza il grafico, il raggruppamento o la tabella pivot, \00E8 possibile'),
'anche utilizzare il collegamento Modifica per modificare le impostazioni.</p>',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744397059400399)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'it'
,p_message_text=>'Ripristina i valori predefiniti del report rimuovendo tutte le personalizzazioni effettuate dall''utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805678787400443)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'it'
,p_message_text=>'Imposta il numero di record da visualizzare per pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744246030400399)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Salva il report personalizzato per poterlo utilizzare in futuro. Occorre fornire un nome e una descrizione facoltativa. \00C8 possibile fare in modo che il report sia accessibile pubblicamente, ovvero da parte di tutti gli utenti che possono accedere ')
||unistr('al report primario predefinito. \00C8 possibile salvare quattro tipi di report interattivo:</p>'),
'<ul>',
unistr('<li><strong>Predefinito primario</strong> (solo sviluppatori). Il report predefinito primario \00E8 quello visualizzato inizialmente. I report di questo tipo non possono essere rinominati o eliminati.</li>'),
unistr('<li><strong>Report alternativo</strong> (solo sviluppatori). Consente agli sviluppatori di creare pi\00F9 layout di report. Solo gli sviluppatori possono salvare, rinominare o eliminare un report alternativo.</li>'),
unistr('<li><strong>Report pubblico</strong> (utenti finali). Pu\00F2 essere salvato, rinominato o eliminato solo dall''utente finale che lo ha creato. Gli altri utenti possono visualizzare e salvare il layout come report diverso.</li>'),
unistr('<li><strong>Report privato</strong> (utenti finali). Solo l''utente finale che crea il report pu\00F2 visualizzare, salvare, rinominare o eliminare il report.</li>'),
'</ul>',
'<p>Se si salvano report personalizzati, viene visualizzato un selettore dei report nella barra di ricerca, a sinistra del selettore delle righe (qualora questa funzione sia abilitata).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743205245400398)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'it'
,p_message_text=>unistr('Nella parte superiore di ogni pagina di report \00E8 presente un''area di ricerca. Questa area o barra di ricerca dispone delle seguenti funzioni:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806225879400444)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'it'
,p_message_text=>'<li>Il menu <strong>Azioni</strong> consente di personalizzare un report. Vedere le sezioni seguenti.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805739390400443)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'it'
,p_message_text=>'<li>L''<strong>icona di selezione delle colonne</strong> consente di specificare una o tutte le colonne in cui eseguire la ricerca.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806087484400443)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'it'
,p_message_text=>'<li><strong>Report</strong> mostra un valore predefinito alternativo e salva i report pubblici o privati.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805902023400443)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'it'
,p_message_text=>'<li><strong>Righe</strong> imposta il numero di record da visualizzare per pagina.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805844698400443)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>L''<strong>area di testo</strong> consente di immettere criteri di ricerca senza distinzione tra maiuscole e minuscole (i caratteri jolly sono impliciti).</li>',
unistr('<li>Il pulsante <strong>Vai</strong> esegue la ricerca. Quando il cursore si trova nell''area del testo di ricerca, la ricerca verr\00E0 eseguita anche premendo il tasto Invio.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806160851400444)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'it'
,p_message_text=>'<li><strong>Visualizza icone</strong> alterna le viste a icone, report, dei dettagli, di grafico, di raggruppamento e pivot  del report, qualora siano definite.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822172218400455)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'it'
,p_message_text=>unistr('<li><strong>Gestisci</strong> consente di gestire propriet\00E0, colonne e righe e visualizzare la cronologia del report o della griglia dati.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743431723400398)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'it'
,p_message_text=>unistr('Utilizzato per modificare le colonne visualizzate. Le colonne a destra vengono visualizzate, mentre le colonne a sinistra vengono nascoste. \00C8 possibile riordinare le colonne visualizzate utilizzando le frecce a destra. Le colonne calcolate sono contr')
||'addistinte dal prefisso <strong>**</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743604615400399)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilizzato per modificare le colonne da ordinare e per indicare se',
unistr('il tipo di ordinamento \00E8 crescente o decrescente. \00C8 inoltre possibile specificare le modalit\00E0 di gestione'),
'dei valori <code>NULL</code>. L''impostazione predefinita visualizza i valori <code>NULL</code> sempre per ultimi o per primi. L''ordinamento finale viene visualizzato a destra delle',
'intestazioni di colonna nel report.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803301955400442)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>unistr('Quando si aggiunge una sottoscrizione, specificare un indirizzo di posta elettronica (o pi\00F9 indirizzi di posta elettronica separati da virgole), un oggetto del messaggio, la frequenza e le date di inizio e di fine. I messaggi di posta elettronica ris')
||'ultanti includono una versione HTML del report interattivo che contiene i dati correnti utilizzando l''impostazione di report presente al momento dell''aggiunta della sottoscrizione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821969158400455)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le griglie dati sono, in pratica, report modificabili e personalizzabili in vari modi. \00C8 possibile modificare il layout dei dati del report selezionando le colonne desiderate, applicando filtri, evidenziando e ordinando gli elementi. \00C8 possibile anch')
||'e definire interruzioni, aggregazioni, grafici diversi, raggruppamenti e calcoli. Gli utenti possono creare varie versioni del report e salvarle come report denominati, visualizzabili privatamente.',
'<p/>',
'Le griglie dati possono essere personalizzate dalla barra di ricerca, dal menu delle azioni o dal menu delle intestazioni di colonna.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833714317400464)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'it'
,p_message_text=>unistr('Il menu Azioni \00E8 visualizzato a destra del pulsante Vai nella barra di ricerca. Usare questo menu per personalizzare un report griglia dati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822429916400456)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'it'
,p_message_text=>'Pagina Aggiungi/modifica riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822535504400456)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Per aggiungere una riga alla griglia dati, fare clic su Aggiungi riga. Per modificare i dettagli di una riga, fare clic sull''icona di modifica della riga (prima colonna) nella riga che si desidera modificare. Verr\00E0 visualizzata la pagina Aggiungi/')
||'modifica riga, in cui sono presenti le colonne della griglia dati. </p>',
'',
unistr('<p>Quando si modifica una riga, \00E8 possibile effettuare le seguenti operazioni:</p>'),
'',
'<p><ul>',
'<li><strong>Eliminare</strong> la riga.</li>',
'<li><strong>Applicare le modifiche</strong> per salvare quelle apportate alla riga.</li>',
'<li>All''interno di <strong>Azioni</strong>, aggiungere una riga, aggiungere file, note, collegamenti o tag e rivedere la cronologia.</li>',
'<li>Accedere alle righe <strong>successive e precedenti</strong>.</li>',
unistr('<li>All''interno di <strong>Gestisci</strong>, impostare propriet\00E0 delle colonne, gruppi di colonne, convalide e liste di valori.</li>'),
'</ul></p>',
'',
'<p>L''area Annotazioni in fondo alla pagina mostra file, note, collegamenti o tag associate alla riga corrente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833849857400464)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'it'
,p_message_text=>unistr('Consente di creare un gruppo di interruzione su una o pi\00F9 colonne. Questa operazione comporta l''estrazione delle colonne dalla griglia dati e la loro visualizzazione come record principale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822322183400455)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Consente di scaricare il set di risultati corrente. I formati di download',
'comprendono CSV, HTML o Posta elettronica.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833954633400464)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se si personalizza un report griglia dati, le impostazioni del report verranno visualizzate',
unistr('sotto la barra di ricerca e sopra il report. Quest''area pu\00F2 essere compressa ed espansa utilizzando l''icona a sinistra.'),
'<p/>',
unistr('Per ogni impostazione del report \00E8 possibile effettuare le operazioni riportate di seguito.</p><ul>'),
'<li>Modificare un''impostazione facendo clic sul nome.</li>',
'<li>Disabilitare/abilitare un''impostazione deselezionando o selezionando la casella di controllo Abilita/disabilita. Questa casella di controllo consente di disattivare temporaneamente e riattivare l''impostazione.</li>',
'<li>Rimuovere un''impostazione facendo clic sull''icona Rimuovi.</li>',
'</ul>',
unistr('<p>Se \00E8 stato creato un grafico o un raggruppamento, \00E8 possibile alternarli'),
'con il report di base utilizzando i collegamenti Vista report, Vista grafico e Vista Raggruppa per,',
unistr('mostrati a destra. Quando si visualizza il grafico o il raggruppamento, \00E8 possibile'),
'anche utilizzare il collegamento Modifica per modificare le impostazioni.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822251719400455)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Salva il layout di report con griglia dati personalizzata per poterlo utilizzare in futuro. Occorre fornire un nome e una descrizione facoltativa. \00C8 possibile salvare tre tipi di layout di report con griglia dati:</p>'),
'<ul>',
unistr('<li><strong>Predefinito primario</strong> (solo amministratori). Il valore predefinito primario \00E8 il layout visualizzato inizialmente. I report di questo tipo non possono essere rinominati o eliminati.</li>'),
unistr('<li><strong>Report alternativo</strong> (solo amministratori). Consente agli amministratori di creare pi\00F9 layout di report. Solo gli amministratori possono salvare, rinominare o eliminare un report alternativo.</li>'),
unistr('<li><strong>Report privato</strong> (tutti gli utenti). L''utente che crea il layout di report pu\00F2 visualizzare, salvare, rinominare o eliminare il report.</li>'),
'</ul>',
'<p>Se si salvano report personalizzati, viene visualizzato un selettore dei report nella barra di ricerca, a sinistra del selettore delle righe (qualora questa funzione sia abilitata).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748330737400402)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Nascondi colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738905903400395)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'it'
,p_message_text=>'Evidenzia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749874284400403)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'it'
,p_message_text=>'Evidenziazioni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754943226400407)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'it'
,p_message_text=>'Condizione di evidenziazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803924425400442)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'it'
,p_message_text=>'Stile evidenziazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713945177400377)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di evidenziazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823476223400456)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'it'
,p_message_text=>'Orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853059066400478)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'it'
,p_message_text=>'1 impostazione non attiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853157126400479)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'%0 impostazioni non attive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744986119400399)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'it'
,p_message_text=>'Guida del report interattivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755980972400407)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'it'
,p_message_text=>'Non valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749326766400403)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Espressione di calcolo non valida. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708708581400373)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'it'
,p_message_text=>'La data di fine deve essere successiva alla data di inizio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763687209400413)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'it'
,p_message_text=>'Espressione di filtro non valida. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831447770400462)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'it'
,p_message_text=>'Query di filtro non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853216411400479)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'it'
,p_message_text=>'1 impostazione non valida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853341459400479)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'%0 impostazioni non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804161227400442)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'it'
,p_message_text=>'(in minuti)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821143298400455)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'it'
,p_message_text=>'%0 rientra nell''ultimo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821387456400455)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'it'
,p_message_text=>'%0 rientra nel prossimo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821283634400455)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'it'
,p_message_text=>'%0 non rientra nell''ultimo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821490759400455)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'it'
,p_message_text=>'%0 non rientra nel prossimo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754019001400406)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'it'
,p_message_text=>'Tastierino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720135979400381)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747967038400402)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo asse per etichetta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740487500400396)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'it'
,p_message_text=>'Ultimo giorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740602116400396)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'it'
,p_message_text=>'Ultima ora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740145454400396)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'it'
,p_message_text=>'Mese scorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740247928400396)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'it'
,p_message_text=>'Settimana scorsa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740391769400396)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'it'
,p_message_text=>'Ultimi %0 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740518677400396)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'it'
,p_message_text=>'Ultime %0 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739950029400396)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'it'
,p_message_text=>'Ultimi %0 anni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740004586400396)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'it'
,p_message_text=>'Anno scorso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720064347400381)
,p_name=>'APEXIR_LINE'
,p_message_language=>'it'
,p_message_text=>'A linee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716877462400379)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'it'
,p_message_text=>'A linee con area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831319729400462)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'it'
,p_message_text=>'Mappa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748891543400402)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'it'
,p_message_text=>'Secondo le stime la query supera il numero massimo di risorse consentito. Modificare le impostazioni del report e riprovare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731029049400389)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'it'
,p_message_text=>unistr('Il conteggio massimo di righe per questo report \00E8 %0 righe. Applicare un filtro per ridurre il numero di record nella query.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831959717400463)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'it'
,p_message_text=>'Massimo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832171034400463)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'it'
,p_message_text=>'Mediana %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735079102400392)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 minuti fa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832087563400463)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'it'
,p_message_text=>'Minimo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831092268400462)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'it'
,p_message_text=>'Mese'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804502468400442)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'it'
,p_message_text=>'Mensile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747159277400401)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'it'
,p_message_text=>'Sposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747072457400401)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'it'
,p_message_text=>'Sposta tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858209171400482)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 necessario specificare l''ID statico area poich\00E9 la pagina contiene pi\00F9 report interattivi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715559495400378)
,p_name=>'APEXIR_NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742981211400398)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'it'
,p_message_text=>'Nuova aggregazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853945428400479)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'it'
,p_message_text=>'Nuova categoria'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112743029345400398)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'it'
,p_message_text=>'Nuovo calcolo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737814991400394)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740916765400397)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'it'
,p_message_text=>'Giorno successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740702515400396)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'it'
,p_message_text=>'Ora successiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741290356400397)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'it'
,p_message_text=>'Mese successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741108231400397)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'it'
,p_message_text=>'Settimana successiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741091778400397)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'it'
,p_message_text=>'%0 giorni successivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112740868038400396)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'it'
,p_message_text=>'%0 ore successive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741476013400397)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'it'
,p_message_text=>'%0 anni successivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741314830400397)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'it'
,p_message_text=>'Anno successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715843468400378)
,p_name=>'APEXIR_NO'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756159189400408)
,p_name=>'APEXIR_NONE'
,p_message_language=>'it'
,p_message_text=>'- Nessuno -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803736022400442)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'it'
,p_message_text=>unistr('Non \00E8 un indirizzo di posta elettronica valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752667439400405)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'it'
,p_message_text=>'Valori nulli sempre per primi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752520579400405)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'it'
,p_message_text=>'Valori nulli sempre per ultimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753066825400405)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'it'
,p_message_text=>'Ordinamento valori nulli %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749435450400403)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'it'
,p_message_text=>'Il valore di tempo Flashback deve essere numerico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749032558400402)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'La sequenza deve essere numerica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753578890400406)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'it'
,p_message_text=>'Operatore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714401836400377)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'it'
,p_message_text=>'arancione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823305595400456)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'it'
,p_message_text=>'Orientamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716347395400379)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'it'
,p_message_text=>'Altro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699159543400366)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'it'
,p_message_text=>'Orientamento pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699845378400367)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'it'
,p_message_text=>'Orizzontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699982427400367)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'it'
,p_message_text=>'Verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699087385400366)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699607732400367)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'it'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699566356400367)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'it'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699735907400367)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699392814400367)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'it'
,p_message_text=>'Legale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699260222400366)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'it'
,p_message_text=>'Lettera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112699444138400367)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'it'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832498725400463)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'it'
,p_message_text=>'Percentuale del conteggio totale %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831634070400462)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'it'
,p_message_text=>'Percentuale della somma totale %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830681313400462)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'it'
,p_message_text=>'Percentuale del conteggio totale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830581389400462)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'it'
,p_message_text=>'Percentuale della somma totale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719927139400381)
,p_name=>'APEXIR_PIE'
,p_message_language=>'it'
,p_message_text=>'A torta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779861836400425)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'it'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781366496400426)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare l''aggregato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781560404400426)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'it'
,p_message_text=>'Impossibile aggregare una colonna selezionata come colonna righe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780791384400425)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780546164400425)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'it'
,p_message_text=>'Colonna pivot %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781163598400426)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare la colonna pivot.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681255678400354)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'it'
,p_message_text=>'Il numero massimo di righe per una query di tipo Pivot limita il numero di righe nella query di base, non il numero di righe visualizzate. La query di base supera il numero massimo di righe di %0 righe. Applicare un filtro per ridurre il numero di re'
||'cord nella query di base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781088378400426)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'it'
,p_message_text=>'Ordinamento pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750438701400403)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'it'
,p_message_text=>'La colonna pivot contiene troppi valori distinti: impossibile generare il codice SQL pivot.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803845060400442)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'it'
,p_message_text=>'Anteprima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737984983400394)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112829561114400461)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'it'
,p_message_text=>'Primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804848169400443)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698919816400366)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'it'
,p_message_text=>'Includi tag di accesso facilitato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685874744400357)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'it'
,p_message_text=>'Rimuovi formattazione dal testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762627133400412)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'it'
,p_message_text=>'Privato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720581876400382)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'it'
,p_message_text=>'Pubblico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716172707400379)
,p_name=>'APEXIR_RED'
,p_message_language=>'it'
,p_message_text=>'rosso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858185040400482)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''ID statico area %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747240372400401)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'it'
,p_message_text=>'Rimuovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747325180400401)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'it'
,p_message_text=>'Rimuovi tutto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853446599400479)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'it'
,p_message_text=>'Rimuovi grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746868731400401)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'it'
,p_message_text=>'Rimuovi interruzione di controllo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746512594400401)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'it'
,p_message_text=>'Rimuovi filtro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746636444400401)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'it'
,p_message_text=>'Rimuovi Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853560591400479)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'it'
,p_message_text=>'Rimuovi raggruppamento per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746961053400401)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'it'
,p_message_text=>'Rimuovi evidenziazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853690127400479)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'it'
,p_message_text=>'Rimuovi pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834694859400465)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'it'
,p_message_text=>'Rimuovi report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815265921400450)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'it'
,p_message_text=>'Rinomina report predefinito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756436314400408)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'it'
,p_message_text=>'Rinomina report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738289591400395)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832507584400463)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'it'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712737521400376)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Il report interattivo salvato con l''alias %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762962075400413)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Report inesistente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712817138400376)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''ID report interattivo salvato %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112754738718400407)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735590960400393)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'it'
,p_message_text=>'Vista report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739432571400395)
,p_name=>'APEXIR_RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720780089400382)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Ripristina le impostazioni predefinite del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715951433400379)
,p_name=>'APEXIR_ROW'
,p_message_language=>'it'
,p_message_text=>'Riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828695871400460)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'it'
,p_message_text=>'Impossibile utilizzare ROWID come colonna chiave primaria per un''origine dati REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745985268400400)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'it'
,p_message_text=>'Righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805558498400443)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'it'
,p_message_text=>'Righe per pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780810363400425)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780696355400425)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'it'
,p_message_text=>'Colonna righe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781292707400426)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificare la colonna righe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781456123400426)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'it'
,p_message_text=>'La colonna righe deve essere diversa dalla colonna pivot.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760019768400410)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtro righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735676845400393)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'it'
,p_message_text=>'Riga %0 di %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739658505400396)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'it'
,p_message_text=>'La riga di testo contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715292428400378)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750032206400403)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report salvato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749938984400403)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'it'
,p_message_text=>'Report salvato = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752195037400405)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'it'
,p_message_text=>'Le impostazioni di report correnti verranno utilizzate come predefinite per tutti gli utenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112815127524400450)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'it'
,p_message_text=>'Salva report predefinito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112739370572400395)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'it'
,p_message_text=>'Salva report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853838199400479)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Salva report *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806517939400444)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112744834196400399)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'it'
,p_message_text=>'Barra di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112853776688400479)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Cerca: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812008621400448)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report di ricerca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796097224400436)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Colonne selezionate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716925468400379)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'- Seleziona colonna -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738634687400395)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Seleziona colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720403428400382)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'- Seleziona funzione -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745647560400400)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'it'
,p_message_text=>'- Seleziona colonna Raggruppa per -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780396139400425)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'it'
,p_message_text=>'- Seleziona colonna pivot -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831549384400462)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'it'
,p_message_text=>'Seleziona riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780403020400425)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'it'
,p_message_text=>'- Seleziona colonna righe -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689134290400359)
,p_name=>'APEXIR_SEND'
,p_message_language=>'it'
,p_message_text=>'Invia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695447601400364)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Invia come posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715648601400378)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'it'
,p_message_text=>'Sequenza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738805018400395)
,p_name=>'APEXIR_SORT'
,p_message_language=>'it'
,p_message_text=>'Ordina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748171770400402)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'it'
,p_message_text=>'Ordinamento crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748258309400402)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'it'
,p_message_text=>'Ordinamento decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834040956400464)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'it'
,p_message_text=>'Criterio di ordinamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742655269400398)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'it'
,p_message_text=>'spazio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753723263400406)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'it'
,p_message_text=>'Stato %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804203375400442)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Sottoscrizione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830920676400462)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'it'
,p_message_text=>'Fine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685365362400356)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'it'
,p_message_text=>'Salta se nessun dato trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112830839791400462)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'it'
,p_message_text=>'A partire da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831798117400463)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'it'
,p_message_text=>'Somma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821748304400455)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'it'
,p_message_text=>'Area = %0, report = %1, vista = %2, inizio righe visualizzate = %3, fine righe visualizzate = %4, righe totali = %5.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742382768400398)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'it'
,p_message_text=>'Area = %0, report = %1, vista = %2, inizio righe visualizzate = %3, fine righe visualizzate = %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714594288400378)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'it'
,p_message_text=>'Colore testo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731632124400390)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'it'
,p_message_text=>'giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731551993400390)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'it'
,p_message_text=>'ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731490202400390)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'it'
,p_message_text=>'minuti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731873192400390)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'it'
,p_message_text=>'mesi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731715140400390)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'it'
,p_message_text=>'settimane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112731940171400390)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'it'
,p_message_text=>'anni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112834429727400465)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'it'
,p_message_text=>'Attiva/disattiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747470272400401)
,p_name=>'APEXIR_TOP'
,p_message_language=>'it'
,p_message_text=>'In alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827668251400460)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna non raggruppata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748992482400402)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'it'
,p_message_text=>'Il nome dell''evidenziazione deve essere univoco.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719240456400381)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>'tipo di dati non supportato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747533945400401)
,p_name=>'APEXIR_UP'
,p_message_language=>'it'
,p_message_text=>'Su'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749148860400402)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'it'
,p_message_text=>'Immettere un colore valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749255126400403)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'it'
,p_message_text=>'Immettere un formato di visualizzazione valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112716416057400379)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112748034274400402)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo asse per valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755885293400407)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Valore obbligatorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719850672400381)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'it'
,p_message_text=>'A colonne verticali'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112823544884400456)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'it'
,p_message_text=>'Verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755103045400407)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'it'
,p_message_text=>'Visualizza grafico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810303606400447)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'it'
,p_message_text=>'Visualizza dettaglio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112855902585400481)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Nessun vista %0 definita per il report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810463406400447)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'it'
,p_message_text=>'Visualizza raggruppamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810237745400447)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'it'
,p_message_text=>'Visualizza icone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780166354400425)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'it'
,p_message_text=>'Visualizza pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112755255161400407)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'it'
,p_message_text=>'Visualizza report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804497691400442)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'it'
,p_message_text=>'Settimanale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738183770400395)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'it'
,p_message_text=>'Report di lavoro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833182939400464)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'it'
,p_message_text=>'%0 giorni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833011442400464)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'it'
,p_message_text=>'%0 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112832979560400463)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'it'
,p_message_text=>'%0 minuti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833302892400464)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'it'
,p_message_text=>'%0 mesi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833225526400464)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'it'
,p_message_text=>'%0 settimane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112833403161400464)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'it'
,p_message_text=>'%0 anni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112831164954400462)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'it'
,p_message_text=>'Anno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112714201288400377)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'it'
,p_message_text=>'giallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112715780578400378)
,p_name=>'APEXIR_YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112747878243400401)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'it'
,p_message_text=>'%0 contiene < o >, che sono caratteri non validi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112770612182400418)
,p_name=>'APEX_REGION'
,p_message_language=>'it'
,p_message_text=>'Area'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112698896956400366)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'it'
,p_message_text=>'Precondizione interfaccia API violata'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718399670400380)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile ottenere il valore per l''impostazione applicazione %0 perch\00E9 l''opzione di creazione associata \00E8 disabilitata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718220739400380)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile impostare il valore per l''impostazione applicazione %0 perch\00E9 l''opzione di creazione associata \00E8 disabilitata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825966990400458)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore dell''impostazione applicazione %0 non \00E8 valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112825861648400458)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'it'
,p_message_text=>unistr('L''impostazione applicazione %0 richiesta non \00E8 definita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826058099400458)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'it'
,p_message_text=>unistr('L''impostazione applicazione %0 non pu\00F2 essereimpostata su un valore nullo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706915608400372)
,p_name=>'BACK'
,p_message_language=>'it'
,p_message_text=>'Indietro'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693926579400363)
,p_name=>'BUILDER'
,p_message_language=>'it'
,p_message_text=>'Builder'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758005753400409)
,p_name=>'BUTTON LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta pulsante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693097047400362)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'it'
,p_message_text=>'Classi CSS pulsanti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722277209400383)
,p_name=>'BUTTON_ID'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID pulsante generato sar\00E0 l''ID statico del pulsante se definito oppure in caso contrario sar\00E0 un ID generato internamente nel formato ''B'' || [ID pulsante interno]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685728666400357)
,p_name=>'CANDLESTICK'
,p_message_language=>'it'
,p_message_text=>'A canne d''organo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767232770400416)
,p_name=>'CENTER'
,p_message_language=>'it'
,p_message_text=>'Al centro'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717251536400379)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'it'
,p_message_text=>'%0 richiesta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708624544400373)
,p_name=>'CHECK$'
,p_message_language=>'it'
,p_message_text=>'selettore di righe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112827797819400460)
,p_name=>'CHECKED'
,p_message_language=>'it'
,p_message_text=>'selezionato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803203361400441)
,p_name=>'COLUMN'
,p_message_language=>'it'
,p_message_text=>'Colonna'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763729367400413)
,p_name=>'COMMENTS'
,p_message_language=>'it'
,p_message_text=>'Commenti'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745232457400400)
,p_name=>'CONTINUE'
,p_message_language=>'it'
,p_message_text=>'Continua'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707269933400372)
,p_name=>'COPYRIGHT'
,p_message_language=>'it'
,p_message_text=>'Copyright &copy; %0.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750918894400404)
,p_name=>'COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757681310400409)
,p_name=>'CREATE'
,p_message_language=>'it'
,p_message_text=>'Crea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809993527400446)
,p_name=>'CREATED'
,p_message_language=>'it'
,p_message_text=>'Data creazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810078482400446)
,p_name=>'CREATED_BY'
,p_message_language=>'it'
,p_message_text=>'Creazione di'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734860248400392)
,p_name=>'CREATED_ON'
,p_message_language=>'it'
,p_message_text=>'Data creazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745453082400400)
,p_name=>'CUSTOM'
,p_message_language=>'it'
,p_message_text=>'Personalizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756685861400408)
,p_name=>'CUSTOMIZE'
,p_message_language=>'it'
,p_message_text=>'Personalizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758251470400409)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'it'
,p_message_text=>'Preferenze di pagina reimpostate per l''utente %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758301723400409)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'it'
,p_message_text=>'Preferenze modificate per l''utente %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758134662400409)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'it'
,p_message_text=>'Preferenze di pagina reimpostate per l''utente %0.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721908208400383)
,p_name=>'DAILY'
,p_message_language=>'it'
,p_message_text=>'Giornaliero'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112693594310400362)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'it'
,p_message_text=>unistr('Il file caricato non \00E8 valido oppure l''estensione \00E8 errata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717401748400380)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'it'
,p_message_text=>'Utilizzato selettore XML o JSON non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686712054400358)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'it'
,p_message_text=>'Il profilo dati e il file caricato non contengono alcuna colonna della tabella di destinazione.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772458253400419)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'it'
,p_message_text=>'Nessun dato trovato nel file caricato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772571354400420)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'it'
,p_message_text=>'Nessun dato trovato nel foglio di lavoro "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112692314317400361)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'it'
,p_message_text=>unistr('Il file specificato non \00E8 un file XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112682740840400355)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati terminato: %0 righe elaborate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683912817400355)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati terminato: %0 righe elaborate con 1 errore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684211641400356)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati terminato: %0 righe elaborate con %1 errori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684022758400356)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati terminato: 1 riga elaborata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687017819400358)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati terminato: 1 riga elaborata con errori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684173091400356)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'it'
,p_message_text=>'Caricamento dati terminato: 1 riga elaborata senza errori.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777732371400423)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'it'
,p_message_text=>'Colonna di destinazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777869575400423)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'it'
,p_message_text=>'Colonna di origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778692934400424)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato data/numero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842076873400470)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'it'
,p_message_text=>'Recupero del valore di ricerca non riuscito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112810544232400447)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'it'
,p_message_text=>'Mapping dati/tabella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778790568400424)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'it'
,p_message_text=>'Riga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774264061400421)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'it'
,p_message_text=>'Errore della regola di trasformazione'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750512764400403)
,p_name=>'DATE'
,p_message_language=>'it'
,p_message_text=>'Data'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724629488400385)
,p_name=>'DAY'
,p_message_language=>'it'
,p_message_text=>'giorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724762331400385)
,p_name=>'DAYS'
,p_message_language=>'it'
,p_message_text=>'giorni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763400593400413)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'it'
,p_message_text=>'Debug non abilitato per questa applicazione.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112812297883400448)
,p_name=>'DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Predefinito'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725494226400385)
,p_name=>'DELETE'
,p_message_language=>'it'
,p_message_text=>'eliminazione'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112685696769400357)
,p_name=>'DIAL_PCT'
,p_message_language=>'it'
,p_message_text=>'Quadrante (Percentuale)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700165000400367)
,p_name=>'DOWNLOAD'
,p_message_language=>'it'
,p_message_text=>'Scarica'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811302498400447)
,p_name=>'DUP_USER'
,p_message_language=>'it'
,p_message_text=>'Nome utente duplicato nella lista.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707760148400373)
,p_name=>'EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717168749400379)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Indirizzo di posta elettronica "%0" non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702278441400369)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'it'
,p_message_text=>unistr('Questo messaggio di posta elettronica \00E8 stato inviato da %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811547245400448)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('Indirizzo di posta elettronica troppo lungo. Il limite \00E8 di 240 caratteri.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745170546400400)
,p_name=>'ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774375502400421)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'it'
,p_message_text=>'Impossibile impostare il valore di origine dell''elemento di pagina per l''area di aggiornamento di pagina parziale.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736613410400394)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'it'
,p_message_text=>'Creazione di'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702571701400369)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'it'
,p_message_text=>'Password scaduta'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112696623828400365)
,p_name=>'FILE_EMPTY'
,p_message_language=>'it'
,p_message_text=>unistr('Il file \00E8 vuoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776879119400423)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'it'
,p_message_text=>unistr('La dimensione del file caricato \00E8 superiore a %0 MB. Caricare un file pi\00F9 piccolo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704603658400370)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Autenticazione utente non riuscita. Uno o pi\00F9 file non caricati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704721721400370)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'it'
,p_message_text=>'Questa istanza non consente il caricamento dei file agli utenti non autenticati.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757722108400409)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato 1 errore')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756975218400408)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'it'
,p_message_text=>'Si sono verificati %0 errori'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707164986400372)
,p_name=>'FORM_OF'
,p_message_language=>'it'
,p_message_text=>'%0 di %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741865693400397)
,p_name=>'GO'
,p_message_language=>'it'
,p_message_text=>'Vai'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841634779400470)
,p_name=>'HELP'
,p_message_language=>'it'
,p_message_text=>'Guida'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694027312400363)
,p_name=>'HOME'
,p_message_language=>'it'
,p_message_text=>'Home'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724432234400385)
,p_name=>'HOUR'
,p_message_language=>'it'
,p_message_text=>'ora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724593539400385)
,p_name=>'HOURS'
,p_message_language=>'it'
,p_message_text=>'ore'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708549575400373)
,p_name=>'ICON'
,p_message_language=>'it'
,p_message_text=>'Icona %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758584417400409)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'it'
,p_message_text=>'Credenziali di login non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112858094699400482)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'it'
,p_message_text=>'Valore non valido per il parametro: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753260612400406)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'it'
,p_message_text=>'Come impostazioni predefinite report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753322228400406)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'it'
,p_message_text=>'Come report denominato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735759033400393)
,p_name=>'IR_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735483237400393)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile eseguire il calcolo dalla navigazione. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713075061400376)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Report interattivo non trovato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712485431400376)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''area report interattivo non esiste nell''applicazione %0, pagina %1 e area %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112753154352400405)
,p_name=>'IR_STAR'
,p_message_language=>'it'
,p_message_text=>'Visualizzato solo per gli sviluppatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741537304400397)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('La query di report deve avere una chiave univoca che identifica ogni riga. La chiave specificata non pu\00F2 essere utilizzata per questa query. Definire una colonna con chiave univoca. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741699426400397)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'it'
,p_message_text=>unistr('La query di report deve avere una chiave univoca che identifica ogni riga. La chiave specificata non pu\00F2 essere utilizzata per questa query. Modificare gli attributi del report per definire una colonna con chiave univoca. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778900657400424)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'it'
,p_message_text=>'Scegli file'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778877816400424)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'it'
,p_message_text=>'Trascinare i file qui oppure'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707483413400372)
,p_name=>'ITEMS'
,p_message_language=>'it'
,p_message_text=>'Elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736822229400394)
,p_name=>'ITEM_VALUE'
,p_message_language=>'it'
,p_message_text=>'Valore elemento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751205768400404)
,p_name=>'LABEL'
,p_message_language=>'it'
,p_message_text=>'Etichetta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763373469400413)
,p_name=>'LANGUAGE'
,p_message_language=>'it'
,p_message_text=>'Lingua'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725147896400385)
,p_name=>'LAST'
,p_message_language=>'it'
,p_message_text=>'ultimo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704557671400370)
,p_name=>'LENGTH'
,p_message_language=>'it'
,p_message_text=>'Lunghezza'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757820921400409)
,p_name=>'LOGIN'
,p_message_language=>'it'
,p_message_text=>'Esegui login'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796415669400437)
,p_name=>'MANAGE'
,p_message_language=>'it'
,p_message_text=>'Gestisci'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861012964400484)
,p_name=>'MAXIMIZE'
,p_message_language=>'it'
,p_message_text=>'Ingrandisci'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724275205400384)
,p_name=>'MINUTE'
,p_message_language=>'it'
,p_message_text=>'minuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724370907400384)
,p_name=>'MINUTES'
,p_message_language=>'it'
,p_message_text=>'minuti'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811719581400448)
,p_name=>'MISSING_AT'
,p_message_language=>'it'
,p_message_text=>'"@" mancante nell''indirizzo di posta elettronica.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811997169400448)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'it'
,p_message_text=>unistr('Avvertenza: non \00E8 stato definito alcun modello Pagina finestra di dialogo per la pagina di finestra di dialogo %0 nell''applicazione %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811672668400448)
,p_name=>'MISSING_DOT'
,p_message_language=>'it'
,p_message_text=>'"." mancante nel dominio dell''indirizzo di posta elettronica.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760869077400411)
,p_name=>'MODULE'
,p_message_language=>'it'
,p_message_text=>'Modulo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717970715400380)
,p_name=>'MONTH'
,p_message_language=>'it'
,p_message_text=>'Mese'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721769180400383)
,p_name=>'MONTHLY'
,p_message_language=>'it'
,p_message_text=>'Mensile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718048789400380)
,p_name=>'MONTHS'
,p_message_language=>'it'
,p_message_text=>'mesi'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750850901400404)
,p_name=>'MOVE'
,p_message_language=>'it'
,p_message_text=>'Sposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818303903400452)
,p_name=>'MOVE_FROM'
,p_message_language=>'it'
,p_message_text=>'Sposta da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818474557400453)
,p_name=>'MOVE_TO'
,p_message_language=>'it'
,p_message_text=>'Sposta in'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112738083484400394)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'it'
,p_message_text=>unistr('Errore nell''operazione di eliminazione di pi\00F9 righe: riga= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737061857400394)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'it'
,p_message_text=>'Non deve essere un utente pubblico'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694236796400363)
,p_name=>'NAME'
,p_message_language=>'it'
,p_message_text=>'Nome'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751047704400404)
,p_name=>'NEW'
,p_message_language=>'it'
,p_message_text=>'Nuovo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717749635400380)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile eseguire il login a %0 andando al seguente indirizzo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717802301400380)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Notifica nuovo account %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841875812400470)
,p_name=>'NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760742669400411)
,p_name=>'NO'
,p_message_language=>'it'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112856039334400481)
,p_name=>'NOBODY'
,p_message_language=>'it'
,p_message_text=>'nessuno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725523501400385)
,p_name=>'NOT'
,p_message_language=>'it'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766342180400415)
,p_name=>'NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'Non nullo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737108050400394)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'it'
,p_message_text=>'Non %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756776818400408)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'it'
,p_message_text=>'nessun dato trovato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765838136400415)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'it'
,p_message_text=>unistr('Nessun report aggiornabile trovato. Le operazioni di aggiornamento ed eliminazione di pi\00F9 righe possono essere eseguite solo su form tabulari di tipo ''report aggiornabile''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766717355400415)
,p_name=>'OK'
,p_message_language=>'it'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762429078400412)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'it'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112859847100400483)
,p_name=>'ORA_06550'
,p_message_language=>'it'
,p_message_text=>'ORA-06550: riga %0, colonna %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809372113400446)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'it'
,p_message_text=>'Si sta usando un browser Web obsoleto. Per conoscere la lista dei browser supportati, consultare Oracle Application Express Installation Guide.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710758850400375)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'it'
,p_message_text=>'Richiesto set di righe non valido, i dati di origine del report sono stati modificati.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730853141400389)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'it'
,p_message_text=>'Specificare un numero di pagina valido, ad esempio p?n=1234.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734454795400392)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'it'
,p_message_text=>'Successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734574328400392)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'it'
,p_message_text=>'Set successivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734682893400392)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112734729396400392)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'it'
,p_message_text=>'Set precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841748359400470)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'it'
,p_message_text=>'Seleziona impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772351823400419)
,p_name=>'PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717028686400379)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'it'
,p_message_text=>unistr('La password per %0 \00E8 stata modificata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706821813400372)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('La password non \00E8 conforme alle regole di complessit\00E0 password di questo sito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705951720400371)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'it'
,p_message_text=>'La nuova password deve differire dalla vecchia di almeno %0 caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706589474400372)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'it'
,p_message_text=>'La password non deve contenere il nome utente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706796594400372)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'it'
,p_message_text=>'La password contiene una parola semplice non consentita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706610348400372)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'it'
,p_message_text=>'La password non deve contenere il nome dell''area di lavoro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705899269400371)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'it'
,p_message_text=>'La password deve contenere almeno %0 caratteri.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706039416400371)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'it'
,p_message_text=>'La password deve contenere almeno un carattere alfabetico (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706475494400372)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'it'
,p_message_text=>'La password deve contenere almeno un carattere alfabetico minuscolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706142719400371)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'it'
,p_message_text=>'La password deve contenere almeno un carattere numerico (0123456789).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706269978400372)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'it'
,p_message_text=>'La password deve contenere almeno un carattere di punteggiatura (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112706342674400372)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'it'
,p_message_text=>'La password deve contenere almeno un carattere alfabetico maiuscolo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717552687400380)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'it'
,p_message_text=>'Notifica di reimpostazione password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704882029400370)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile che la password non possa essere utilizzata perch\00E9 utilizzata negli ultimi %0 giorni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785196319400429)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'it'
,p_message_text=>'Elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112785294842400429)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'it'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762292677400412)
,p_name=>'PERCENT'
,p_message_language=>'it'
,p_message_text=>'Percentuale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732583215400391)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'it'
,p_message_text=>'Contattare l''amministratore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112841956609400470)
,p_name=>'PREVIOUS'
,p_message_language=>'it'
,p_message_text=>'Precedente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777319264400423)
,p_name=>'PRINT'
,p_message_language=>'it'
,p_message_text=>'Stampa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761044324400411)
,p_name=>'PRIVILEGES'
,p_message_language=>'it'
,p_message_text=>'Privilegi'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730980274400389)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'it'
,p_message_text=>'Riferimenti delle aree'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751163378400404)
,p_name=>'REPORT'
,p_message_language=>'it'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760914807400411)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'it'
,p_message_text=>'Periodo report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842193870400470)
,p_name=>'REPORT_LABEL'
,p_message_language=>'it'
,p_message_text=>'Report: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761672279400412)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'it'
,p_message_text=>'Totale report'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710811264400375)
,p_name=>'RESET'
,p_message_language=>'it'
,p_message_text=>'Reimposta impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736770942400394)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'it'
,p_message_text=>'Reimposta impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765734150400415)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Reimposta password'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742558092400398)
,p_name=>'RESTORE'
,p_message_language=>'it'
,p_message_text=>'Ripristina'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112774470945400421)
,p_name=>'RESULTS'
,p_message_language=>'it'
,p_message_text=>'Risultati'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766843763400415)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'it'
,p_message_text=>'Torna all''applicazione.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112767117470400416)
,p_name=>'RIGHT'
,p_message_language=>'it'
,p_message_text=>'A destra'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796717446400437)
,p_name=>'ROW'
,p_message_language=>'it'
,p_message_text=>'Riga %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750778519400404)
,p_name=>'ROW_COUNT'
,p_message_language=>'it'
,p_message_text=>'Conteggio righe'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112766265774400415)
,p_name=>'SAVE'
,p_message_language=>'it'
,p_message_text=>'Salva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762816591400412)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Predefinito alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763272851400413)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'it'
,p_message_text=>'Descrizione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762787649400412)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Predefinito primario'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763502555400413)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'it'
,p_message_text=>'Oltre %0 righe disponibili. Aumentare il selettore di righe per visualizzare altre righe.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828990766400460)
,p_name=>'SEARCH'
,p_message_language=>'it'
,p_message_text=>'Cerca'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724137627400384)
,p_name=>'SECONDS'
,p_message_language=>'it'
,p_message_text=>'secondi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762388746400412)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'it'
,p_message_text=>'Vedere l''allegato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820052210400454)
,p_name=>'SELECT_ROW'
,p_message_language=>'it'
,p_message_text=>'Seleziona riga'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762040222400412)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'it'
,p_message_text=>unistr('Disattiva modalit\00E0 lettore di schermo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762109349400412)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'it'
,p_message_text=>unistr('Attiva modalit\00E0 lettore di schermo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758420209400409)
,p_name=>'SHOW'
,p_message_language=>'it'
,p_message_text=>'Mostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821899466400455)
,p_name=>'SHOW_ALL'
,p_message_language=>'it'
,p_message_text=>'Mostra tutto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112847904122400475)
,p_name=>'SIGN_IN'
,p_message_language=>'it'
,p_message_text=>'Accedi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112797514777400437)
,p_name=>'SIGN_OUT'
,p_message_language=>'it'
,p_message_text=>'Scollega'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751780872400404)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 giorni fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758986607400410)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'%0 giorni da adesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751699249400404)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 ore fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758812344400410)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'%0 ore da adesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751548464400404)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 minuti fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758751945400410)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'%0 minuti da adesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751913442400405)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 mesi fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759185771400410)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'%0 mesi da adesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759375508400410)
,p_name=>'SINCE_NOW'
,p_message_language=>'it'
,p_message_text=>'Ora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751420039400404)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 secondi fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112758687028400409)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'%0 secondi da adesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112751840541400404)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 settimane fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759080394400410)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'%0 settimane da adesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112752054265400405)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'it'
,p_message_text=>'%0 anni fa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759209001400410)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'it'
,p_message_text=>'%0 anni da adesso'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745546720400400)
,p_name=>'STANDARD'
,p_message_language=>'it'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761967769400412)
,p_name=>'START_DATE'
,p_message_language=>'it'
,p_message_text=>'Data di inizio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702453912400369)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'it'
,p_message_text=>unistr('Il mittente di questo messaggio di posta elettronica \00E8 la sottoscrizione a report interattivo creata da %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857144602400481)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'it'
,p_message_text=>'Sottoscrizioni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805217605400443)
,p_name=>'TAB'
,p_message_language=>'it'
,p_message_text=>'Scheda'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724096966400384)
,p_name=>'TITLE'
,p_message_language=>'it'
,p_message_text=>'Titolo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707023989400372)
,p_name=>'TODAY'
,p_message_language=>'it'
,p_message_text=>'Oggi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761566371400412)
,p_name=>'TOTAL'
,p_message_language=>'it'
,p_message_text=>'Totale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708045346400373)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile selezionare un massimo di %0 colonne.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686574961400357)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'it'
,p_message_text=>'Comprimi tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686818005400358)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'it'
,p_message_text=>'Comprimi tutto in basso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686405459400357)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'it'
,p_message_text=>'Espandi tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686608101400357)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'it'
,p_message_text=>'Espandi tutto in basso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686949873400358)
,p_name=>'TREE.REPARENT'
,p_message_language=>'it'
,p_message_text=>'Assegna a livello padre differente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779179410400424)
,p_name=>'TREES'
,p_message_language=>'it'
,p_message_text=>'Strutture'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112822671397400456)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Obbligatorio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112746214466400400)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'it'
,p_message_text=>'Non autorizzato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112793020454400434)
,p_name=>'UNAVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Non disponibile'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759747123400410)
,p_name=>'UNKNOWN'
,p_message_language=>'it'
,p_message_text=>'Sconosciuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703380597400369)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 verificato un errore di autenticazione non riconosciuto.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705312212400371)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'it'
,p_message_text=>unistr('Se non si desidera ricevere pi\00F9 i messaggi di posta elettronica, fare clic su <a href="%0">Annulla sottoscrizione</a> per gestire la sottoscrizione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112702306719400369)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'it'
,p_message_text=>unistr('Se non si desidera pi\00F9 ricevere i messaggi di posta elettronica, andare all''URL riportato di seguito per gestire la propria sottoscrizione:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112737237793400394)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>'tipo di dati non supportato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725398721400385)
,p_name=>'UPDATE'
,p_message_language=>'it'
,p_message_text=>'aggiornamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723980873400384)
,p_name=>'UPDATED'
,p_message_language=>'it'
,p_message_text=>'Aggiornato'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730615026400389)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'it'
,p_message_text=>unistr('L''URL richiesto \00E8 stato proibito. Contattare l''amministratore.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112750645627400404)
,p_name=>'USER'
,p_message_language=>'it'
,p_message_text=>'Utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112772283282400419)
,p_name=>'USERNAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811845649400448)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'it'
,p_message_text=>unistr('Nome utente troppo lungo. Il limite \00E8 di %0 caratteri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757401646400409)
,p_name=>'USERS'
,p_message_language=>'it'
,p_message_text=>'utenti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112811402121400447)
,p_name=>'USER_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome utente esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112826109088400458)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'it'
,p_message_text=>'Immagine profilo per l''utente %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713763126400377)
,p_name=>'VALID'
,p_message_language=>'it'
,p_message_text=>'Valido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707364645400372)
,p_name=>'VALIDATIONS'
,p_message_language=>'it'
,p_message_text=>'Convalide'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763000990400413)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806443965400444)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per %0.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732921343400391)
,p_name=>'VERTICAL'
,p_message_language=>'it'
,p_message_text=>'verticale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725223776400385)
,p_name=>'VIEW'
,p_message_language=>'it'
,p_message_text=>'visualizzazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757547094400409)
,p_name=>'VIEWS'
,p_message_language=>'it'
,p_message_text=>'viste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763862534400413)
,p_name=>'VIEW_ALL'
,p_message_language=>'it'
,p_message_text=>'Visualizza tutto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112745036259400400)
,p_name=>'WARNING'
,p_message_language=>'it'
,p_message_text=>'Avvertenza'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724826995400385)
,p_name=>'WEEK'
,p_message_language=>'it'
,p_message_text=>'settimana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721813164400383)
,p_name=>'WEEKLY'
,p_message_language=>'it'
,p_message_text=>'Settimanale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112724957186400385)
,p_name=>'WEEKS'
,p_message_language=>'it'
,p_message_text=>'settimane'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112763133705400413)
,p_name=>'WELCOME_USER'
,p_message_language=>'it'
,p_message_text=>'Benvenuto/a: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761308597400411)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato trovato un valore non valido. Verificare i dati immessi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761487854400411)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato trovato un valore non valido. Verificare i dati immessi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704438537400370)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato trovato un valore di data non valido. Verificare il formato della data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112761228279400411)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato trovato un valore numerico non valido. Verificare il formato numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713324641400377)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato trovato un valore di indicatore orario non valido. Verificare il formato di indicatore orario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112735825260400393)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile associare "%0". Usare le virgolette per gli elementi a pi\00F9 byte oppure verificare che la lunghezza dell''elemento sia pari a 30 byte al massimo. Usare la sintassi v() per fare riferimento agli elementi con lunghezza superiore a 30 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726329462400386)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'it'
,p_message_text=>'Accesso negato dal controllo di sicurezza %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728873436400388)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>'Applicazione non disponibile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727203374400387)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1014 Applicazione non trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727342581400387)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'it'
,p_message_text=>'applicazione=%0 area di lavoro=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727717344400387)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'it'
,p_message_text=>unistr('L''accesso a questa applicazione \00E8 limitato. Riprovare in seguito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727661561400387)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'it'
,p_message_text=>unistr('L''accesso a questa applicazione \00E8 limitato agli sviluppatori di applicazioni. Riprovare in seguito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726865057400386)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'it'
,p_message_text=>'ERR-7744 Impossibile elaborare la diramazione alla funzione che restituisce l''URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726780130400386)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-7744 Impossibile elaborare la diramazione alla funzione che restituisce la pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727051452400386)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1430 Chiamata per la visualizzazione dal processo di pagina non supportata: G_FLOW_STEP_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728154231400387)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1018 Errore durante la cancellazione della cache step.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726557385400386)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1005 Tipo di calcolo sconosciuto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727417045400387)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1201 ID sessione non impostato nell''autenticazione personalizzata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727515987400387)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'it'
,p_message_text=>'pagina=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112727163488400386)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-7620 Impossibile determinare l''area di lavoro per l''applicazione (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709569353400374)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'it'
,p_message_text=>'Modifica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726239818400386)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'it'
,p_message_text=>'ERR-1802 Impossibile trovare l''ID elemento "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725979392400386)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1002 Impossibile trovare l''ID elemento per l''elemento "%0" nell''applicazione "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726053123400386)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'it'
,p_message_text=>'Errore imprevisto. Impossibile trovare il nome dell''elemento a livello di applicazione o pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726467001400386)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Si \00E8 gi\00E0 nella prima pagina di dati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112741928031400397)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'it'
,p_message_text=>'L''ID di elemento (%0) non corrisponde a un elemento definito nella pagina corrente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704093028400370)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento non pu\00F2 essere impostato passando argomenti all''applicazione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704332517400370)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'it'
,p_message_text=>'(nessun checksum fornito)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703825175400370)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento pu\00F2 essere impostato se accompagnato da un checksum di tipo "segnalibro a livello di utente".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703793722400370)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento pu\00F2 essere impostato se accompagnato da un checksum di tipo "segnalibro a livello di applicazione".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703919091400370)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento pu\00F2 essere impostato se accompagnato da un checksum di tipo "sessione".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703661393400370)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'it'
,p_message_text=>unistr('L''elemento non \00E8 protetto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728230625400387)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'it'
,p_message_text=>'Nessuna Guida di pagina disponibile.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112717332054400380)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'it'
,p_message_text=>'L''area di lavoro %0 non dispone dei privilegi per eseguire l''analisi come schema %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726645342400386)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('ERR-1010 Superato il limite di ricorsivit\00E0 della diramazione all''elaborazione PAGE ACCEPT. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704274821400370)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina non pu\00F2 essere richiamata utilizzando un URL o istruzioni GET o POST per la procedura di visualizzazione, ma deve essere richiamata mediante una diramazione di tipo "Dirama a pagina".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112780923492400426)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il tentativo di salvataggio di un valore non numerico nell''elemento %0. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719069960400381)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Lo schema di analisi dell''applicazione "%0" non esiste nel database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112719158162400381)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'it'
,p_message_text=>'Gli account nell''area di lavoro INTERNAL possono essere utilizzati solo per accedere ai <a href="%0">servizi di amministrazione</a> di &PRODUCT_NAME..'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725871530400386)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-1029 Impossibile memorizzare le informazioni sulla sessione. Sessione=%0 elemento=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728980444400388)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile interrompere il trace: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112726131628400386)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore imprevisto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736169254400393)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore in update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729095549400388)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'it'
,p_message_text=>'Fornire l''applicazione e la pagina per visualizzare la Guida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112749557382400403)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Automazione non trovata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730127870400389)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'it'
,p_message_text=>'%0 sessioni eliminate.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689496369400359)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile eseguire il codice %0 in quanto non \00E8 supportato dal database o non \00E8 abilitato dal parametro MLE_LANGUAGES dell''istanza.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112689283001400359)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('Multilingual Engine non \00E8 disponibile in questa versione del database.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710072881400374)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>'L''array collection di applicazioni non deve essere nullo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709865030400374)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'it'
,p_message_text=>unistr('Il numero di attributi del membro specificato %0 non \00E8 valido. Il numero di attributi deve essere compreso tra 1 e %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710357257400374)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Collection di applicazioni esistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710103687400374)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome della collection non pu\00F2 essere nullo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710248173400374)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'it'
,p_message_text=>unistr('Il nome della collection non pu\00F2 superare i 255 caratteri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709645313400374)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'La collection di applicazioni %0 non esiste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710435547400375)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'it'
,p_message_text=>'Cursore non ancora aperto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709744097400374)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'La sequenza di membri %0 non esiste nella collection di applicazioni %1',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112709998895400374)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'it'
,p_message_text=>'La sequenza di membri %0 non esiste nella collection di applicazioni "%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781798250400426)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'it'
,p_message_text=>unistr('La funzione di crittografia "%0" non \00E8 supportata su questo sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835222917400465)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'it'
,p_message_text=>'Test accesso facilitato eseguito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729696209400388)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729785257400388)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'it'
,p_message_text=>'Opzioni di personalizzazione della pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729866589400388)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'it'
,p_message_text=>'Predefinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729953931400389)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'it'
,p_message_text=>'Visualizzato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730098004400389)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'it'
,p_message_text=>'Nascosto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729470114400388)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'it'
,p_message_text=>unistr('Controllare le aree che si desidera includere in questa pagina. \00C8 possibile che le aree controllate non vengano visualizzate se non ci si trova nel contesto dell''applicazione corretto oppure se non si dispone dei privilegi adeguati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729505517400388)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'it'
,p_message_text=>unistr('Questa pagina non \00E8 personalizzabile.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835593507400465)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 possibile personalizzare l''aspetto di questa applicazione modificando lo stile del tema. Selezionare uno stile di tema dalla lista sottostante e fare clic su Applica modifiche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112836383812400466)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'it'
,p_message_text=>'Visualizzazione area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835496101400465)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'it'
,p_message_text=>'Usa stile predefinito applicazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112835301986400465)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'it'
,p_message_text=>'Aspetto '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778323335400424)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''indice colonna a cui viene fatto riferimento nell''aggregato %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681636874400354)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>unistr('L''output CLOB non \00E8 supportato per il formato %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778083026400423)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'it'
,p_message_text=>'L''interruzione di colonna deve trovarsi all''inizio dell''array di colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778168436400424)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''indice gruppo di colonne a cui viene fatto riferimento in %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112695624858400364)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'it'
,p_message_text=>'esportazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112700829682400368)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'it'
,p_message_text=>'Il formato di esportazione deve essere XML utilizzando ORDS come server di stampa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778492310400424)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''indice colonna a cui viene fatto riferimento nell''evidenziazione %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694180067400363)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'it'
,p_message_text=>'Formato di esportazione non valido: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112778237058400424)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'L''indice gruppo padre a cui viene fatto riferimento in %0 non esiste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112803473882400442)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna %1 della tabella %0 \00E8 una colonna di identit\00E0 "GENERATED ALWAYS". Assicurarsi che non vi siano colonne di origine mappate alla colonna %1 nella finestra di dialogo Configura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720898739400382)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'it'
,p_message_text=>unistr('L''intervallo di commit specificato \00E8 troppo basso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112720909061400382)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'it'
,p_message_text=>'Non sono state fornite colonne per il caricamento dei dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722151379400383)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessuna colonna trovata per il selettore di righe "%0". Provare a rilevare automaticamente oppure a controllare la struttura JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730462047400389)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'it'
,p_message_text=>'Nessun foglio di lavoro trovato nel file XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730317726400389)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'it'
,p_message_text=>'Il foglio di lavoro specificato non esiste nel file XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112710582022400375)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'it'
,p_message_text=>unistr('La versione corrente dei dati nel database \00E8 cambiata da quando l''utente ha iniziato il processo di aggiornamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712922492400376)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'it'
,p_message_text=>'Errore durante l''aggiornamento delle colonne di report: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817665227400452)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'it'
,p_message_text=>'Impossibile convertire %0 in SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757193853400408)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'it'
,p_message_text=>'Impossibile convertire in VARCHAR2 la colonna %0 del tipo di dati %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764139708400413)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Colonna "%0" specificata per l''attributo "%1" non trovata nell''origine dati.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705463452400371)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di filtro %0 non \00E8 supportato per le colonne con pi\00F9 valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112821089621400454)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'it'
,p_message_text=>'Filtro "between" non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687523575400358)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'it'
,p_message_text=>'Specificato tipo di LOV non valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687495076400358)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'it'
,p_message_text=>'Tipo di query non valida. Il tipo di query deve essere una tabella, una query SQL o una funzione PL/SQL che restituisce una query SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757218590400408)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Analisi della query SQL non riuscita.',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764246886400414)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Posizione colonna %0 specificata per l''attributo "%1" non trovata nell''istruzione SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112686091886400357)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'it'
,p_message_text=>unistr('Troppi elementi utilizzati nel filtro con pi\00F9 valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764054289400413)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'it'
,p_message_text=>'Nessuna colonna specificata per l''attributo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687391464400358)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Il corpo della funzione PL/SQL non ha restituito un valore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112777289421400423)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'it'
,p_message_text=>'L''origine dati REST non contiene un''operazione per gestire l''azione DML richiesta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112683204129400355)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'it'
,p_message_text=>unistr('La conversione da GeoJSON a SDO_GEOMETRY (colonna %0) non \00E8 disponibile in questo database.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684300017400356)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'it'
,p_message_text=>unistr('La conversione SDO_GEOMETRY (colonna %0) non \00E8 supportata per le origini dati XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112691641647400361)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'it'
,p_message_text=>unistr('Il carattere %0 non \00E8 supportato come separatore di pi\00F9 valori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112818946222400453)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa funzione non pu\00F2 essere utilizzata nel contesto di una query.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112684404840400356)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>'Mancata corrispondenza del tipo di dati della colonna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687280590400358)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'it'
,p_message_text=>unistr('Superati i limiti della bind variable OUT di ORDS interna. Ridurre la quantit\00E0 di righe DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112765087186400414)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile analizzare la risposta JSON proveniente dal server remoto: ',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112687156717400358)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'it'
,p_message_text=>'Tipo di contesto sconosciuto o errato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112781684262400426)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Questo tipo di file non \00E8 supportato dal parser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736293077400393)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'it'
,p_message_text=>'Accesso non autorizzato (wwv_flow_api.set_credentials non impostato).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713220465400377)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'it'
,p_message_text=>unistr('L''area di lavoro non \00E8 stata creata perch\00E9 esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112713163075400377)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'it'
,p_message_text=>unistr('Il gruppo di utenti non \00E8 stato creato perch\00E9 esiste gi\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723476814400384)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'it'
,p_message_text=>'Nome utente duplicato trovato per %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723506082400384)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Errore durante il caricamento degli utenti. L''errore si \00E8 verificato in corrispondenza dell''utente %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733463627400391)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Potenziale caricamento di %0 utenti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733289325400391)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'it'
,p_message_text=>'Password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733302643400391)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'it'
,p_message_text=>'Privilegi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733051915400391)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'it'
,p_message_text=>'Nome utente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809519631400446)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'it'
,p_message_text=>'Errore durante la presentazione dell''elemento di pagina "#COMPONENT_NAME#".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729174862400388)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('Impossibile visualizzare l''elemento di pagina perch\00E9 il form HTML non era ancora stato aperto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112694446471400363)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il calcolo del valore predefinito per l''elemento di pagina #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728479686400387)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore nel calcolo successivo dell''elemento per l''elemento di pagina #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728334244400387)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il calcolo del valore di origine per l''elemento di pagina #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708106951400373)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'it'
,p_message_text=>'Accesso non autorizzato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728632460400388)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'it'
,p_message_text=>'JavaScript non supportato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728792709400388)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'it'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112729334765400388)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'it'
,p_message_text=>'Impossibile inizializzare la query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736590967400393)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'it'
,p_message_text=>unistr('L''aggiornamento di %0 non \00E8 supportato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112730787484400389)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'it'
,p_message_text=>'ID elemento non valido: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112757096449400408)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'it'
,p_message_text=>'Per questo elemento non esiste la Guida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721599357400382)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'it'
,p_message_text=>'Generazione della query su grafico non riuscita. Controllare le impostazioni di origine e del mapping colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816377139400451)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'it'
,p_message_text=>'L''allegato con dimensione di %0 MB supera la dimensione massima di allegato di %1 MB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722423710400383)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'it'
,p_message_text=>'Valore non valido per il parametro p_mail_id: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112839848931400469)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato superato il numero massimo di messaggi di posta elettronica per area di lavoro. Contattare l''amministratore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703470654400369)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'it'
,p_message_text=>'Questa procedura deve essere richiamata da una sessione dell''applicazione.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722363205400383)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'it'
,p_message_text=>'Specificato valore nullo per il parametro %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776391249400422)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'it'
,p_message_text=>'Modello di posta elettronica "%0" non trovato nell''applicazione %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112852889236400478)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Il parametro di istanza SMTP_HOST_ADDRESS deve essere impostato per l''invio di messaggi di posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722098803400383)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un destinatario per inviare il messaggio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112842264373400471)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'it'
,p_message_text=>'Impossibile stabilire la connessione SMTP con il server di posta elettronica configurato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112816459286400451)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'it'
,p_message_text=>'Chiamata Ajax non valida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707829476400373)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna funzione Ajax definita per il plugin %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806881970400444)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna funzione di esecuzione definita per il plugin %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707948239400373)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Nessuna funzione di visualizzazione definita per il plugin %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817327856400452)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Il plugin di origine dati REST "%0" non contiene una funzione "Capabilities".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817256165400452)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Il plugin di origine dati REST "%0" non contiene una funzione DML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817489305400452)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Il plugin di origine dati REST "%0" non contiene una funzione Execute.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112817511771400452)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'it'
,p_message_text=>'Il plugin di origine dati REST "%0" non contiene una funzione Fetch.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705640623400371)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore nel codice PLSQL durante l''elaborazione del plugin.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712235874400376)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742820373400398)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'it'
,p_message_text=>'Impossibile convertire il tipo di dati %0 in VARCHAR2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828474894400460)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Colonna "%0" specificata per l''attributo "%1" non trovata nell''istruzione SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804740455400443)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'it'
,p_message_text=>'Specificare un valore per Query lista di valori (LOV) o Lista di valori denominata per %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112806313307400444)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato selezionato un numero errato di colonne nella query SQL LOV per %0. Vedere gli esempi di istruzioni valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828284704400460)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'it'
,p_message_text=>'Nessuna colonna specificata per l''attributo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857904088400482)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('Il valore immesso %0 per l''attributo "%1" non \00E8 numerico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112809867808400446)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('Il tipo di dati di %0 nell''istruzione SQL \00E8 errato. Il numero della colonna %1 \00E8 %2 mentre era previsto %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112828333979400460)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'it'
,p_message_text=>unistr('La colonna "%0" specificata per l''attributo "%1" dispone del tipo di dati %2 mentre il tipo di dati previsto \00E8 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112704907184400371)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'it'
,p_message_text=>'Impossibile trovare il layout del report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764977473400414)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'it'
,p_message_text=>'Impossibile utilizzare la funzione Calcola somma per i report basati su un''origine dati REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112728543530400388)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'it'
,p_message_text=>'ERR-2904 Impossibile impostare il valore della scorciatoia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112732802368400391)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore: tipo di scorciatoia sconosciuto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112722812060400383)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'it'
,p_message_text=>'Impossibile recuperare authentication_scheme nell''applicazione %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112796343791400437)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'it'
,p_message_text=>unistr('L''ID tenant esiste gi\00E0 per la sessione corrente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112733113147400391)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'it'
,p_message_text=>'Posta elettronica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857366660400482)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'it'
,p_message_text=>'Autenticazione non riuscita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112759692653400410)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'it'
,p_message_text=>unistr('Uno o pi\00F9 cookie impostati in apex_util.g_request_cookies contengono un valore non valido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112742144651400397)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'it'
,p_message_text=>'Risposta non valida dal registro UDDI.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112705767148400371)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'it'
,p_message_text=>'L''URL fornito non ha restituito un documento WSDL valido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112708248136400373)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'it'
,p_message_text=>unistr('Il documento WSDL contiene pi\00F9 associazioni SOAP. &PRODUCT_NAME. supporta solo documenti WSDL con una associazione SOAP. Per procedere con la creazione di un riferimento per questo servizio, fare clic su Crea riferimento a Web Service manualmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112776696934400422)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'it'
,p_message_text=>unistr('La risposta dal servizio non \00E8 in formato XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857225606400482)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'it'
,p_message_text=>'Token di accesso OAuth non disponibile o scaduto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112820446425400454)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'it'
,p_message_text=>unistr('\00C8 stato superato il numero massimo di richieste Web Service per area di lavoro. Contattare l''amministratore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112857471646400482)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'it'
,p_message_text=>'Il server ha risposto con un tipo di token OAuth non supportato.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707662786400373)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'it'
,p_message_text=>'Il documento WSDL non conteneva un''associazione per il protocollo SOAP, richiesto per poter aggiungere il riferimento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112703576853400370)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'it'
,p_message_text=>'Questo WSDL richiede credenziali di autenticazione. Fornire di seguito nome utente e password.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112712363075400376)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'it'
,p_message_text=>'Motore di visualizzazione non in grado di interpretare il documento WSDL. Per procedere con la creazione di un riferimento per questo servizio, fare clic su Crea riferimento a Web Service manualmente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112779255562400424)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'it'
,p_message_text=>'Impossibile elaborare l''aggiornamento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112805079600400443)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'it'
,p_message_text=>'La colonna restituita e quella di visualizzazione della lista di valori sono uguali.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112804946885400443)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'it'
,p_message_text=>'La lista di valori non dispone di una colonna restituita.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736463847400393)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il recupero del valore della colonna: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760424100400411)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'it'
,p_message_text=>'I dati correnti del form tabulare sono troppo vecchi. I dati di origine sono stati modificati.<br/> Fare clic <strong><a href="%0">qui</a></strong> per annullare le modifiche e ricaricare i dati dal database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718513900400380)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'it'
,p_message_text=>'Errore durante la determinazione della stringa di impaginazione'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718454034400380)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'impossibile determinare le intestazioni delle query:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718600398400380)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'it'
,p_message_text=>unistr('Errore durante l''esecuzione delle sostituzioni dei pi\00E8 di pagina del report')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718752329400381)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'impossibile analizzare la query SQL:',
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723722167400384)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'it'
,p_message_text=>'Numero minimo di righe richieste: %0, righe trovate ma non visualizzate: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721222477400382)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'it'
,p_message_text=>unistr('la colonna di query n. %0 (%1) non \00E8 valida. Le colonne che utilizzano HTML devono disporre di nomi di alias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112736388180400393)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'it'
,p_message_text=>'Errore durante il recupero delle intestazioni della query: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718807202400381)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'errore nel report:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112756561641400408)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'it'
,p_message_text=>'Ordina per questa colonna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721364923400382)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Impossibile analizzare la query. Controllare la sintassi della query.',
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760598145400411)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'it'
,p_message_text=>'Questo form contiene modifiche non salvate. Fare clic su "OK" per proseguire senza salvare le modifiche. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112764892973400414)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'it'
,p_message_text=>unistr('Lo schema di impaginazione report (%0) non \00E8 supportato con l''origine dati scelta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112721150567400382)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'it'
,p_message_text=>unistr('la colonna di query n. %0 (%1) non \00E8 valida. Utilizzare alias di colonna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723804145400384)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'it'
,p_message_text=>unistr('riga/e %0 - %1 di pi\00F9 di %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112762592590400412)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'it'
,p_message_text=>unistr('%0-%1 di pi\00F9 di %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112723684264400384)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'it'
,p_message_text=>'riga/e: %0 - %1 di %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112707597437400372)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'it'
,p_message_text=>'%0 - %1 di %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718956214400381)
,p_name=>'Y'
,p_message_language=>'it'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112725036226400385)
,p_name=>'YEAR'
,p_message_language=>'it'
,p_message_text=>'anno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112718104482400380)
,p_name=>'YEARS'
,p_message_language=>'it'
,p_message_text=>'anni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112760683614400411)
,p_name=>'YES'
,p_message_language=>'it'
,p_message_text=>unistr('S\00EC')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4474)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4474)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4474
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4474)
,p_name=>'Messaggi'
,p_alias=>'MESSAGES'
,p_step_title=>'Messaggi'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
