prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4504
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4504 - Oracle APEX SQL Workshop
--
-- Application Export:
--   Application:     4504
--   Name:            Oracle APEX SQL Workshop
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    315
--       Items:                1,156
--       Computations:           219
--       Validations:            265
--       Processes:              472
--       Regions:              1,120
--       Buttons:                558
--       Dynamic Actions:        199
--     Shared Components:
--       Logic:
--         Items:                 19
--         Processes:             33
--         Computations:           2
--         Build Options:          8
--       Navigation:
--         Lists:                 76
--         Breadcrumbs:            2
--           Entries:            169
--         NavBar Entries:         3
--       Security:
--         Authentication:         1
--         Authorization:         20
--       User Interface:
--         Templates:
--           Page:                22
--           Region:              45
--           Label:               13
--           List:                25
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           2
--           Button:               8
--           Report:              22
--         LOVs:                 177
--         Shortcuts:              8
--         Plug-ins:              17
--       Globalization:
--         Messages:              29
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX SQL Workshop')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110306531794366788')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020110910'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'it'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&G_USER_DEFAULT_DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_publish_yn=>'Y'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(539837904309662819.4504)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'S'
,p_runtime_api_usage=>'O:W'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_friendly_url=>'N'
,p_substitution_string_01=>'PRODUCT_NAME'
,p_substitution_value_01=>'Oracle APEX'
,p_substitution_string_02=>'LOGOUT'
,p_substitution_value_02=>'Logout'
,p_substitution_string_03=>'MSG_COMPANY'
,p_substitution_value_03=>'Area di lavoro: &COMPANY.'
,p_substitution_string_04=>'MSG_LANGUAGE'
,p_substitution_value_04=>'Lingua'
,p_substitution_string_05=>'MSG_COPYRIGHT'
,p_substitution_value_05=>unistr('Copyright \00A9 1999-2021, Oracle e/o relative consociate.')
,p_substitution_string_06=>'MSG_USER'
,p_substitution_value_06=>'Utente'
,p_substitution_string_07=>'MSG_JSCRIPT'
,p_substitution_value_07=>'Eseguire questo prodotto con JavaScript abilitato.'
,p_substitution_string_08=>'MSG_TBL_SUMMARY'
,p_substitution_value_08=>'Tabella di layout di pagina'
,p_substitution_string_09=>'EDIT'
,p_substitution_value_09=>'Modifica'
,p_substitution_string_10=>'DONE'
,p_substitution_value_10=>'Fine'
,p_substitution_string_11=>'TOP'
,p_substitution_value_11=>'Inizio pagina'
,p_substitution_string_12=>'CLOSE'
,p_substitution_value_12=>'Chiudi'
,p_substitution_string_13=>'DATE_FORMAT'
,p_substitution_value_13=>'dd/mm/yyyy'
,p_substitution_string_14=>'LONG_DATE_FORMAT'
,p_substitution_value_14=>'fmDay dd Month yyyy'
,p_substitution_string_15=>'TIME_FORMAT'
,p_substitution_value_15=>'hh24:mi:ss'
,p_substitution_string_16=>'DATE_TIME_FORMAT'
,p_substitution_value_16=>'dd/mm/yyyy hh24:mi:ss'
,p_substitution_string_17=>'RETURN_TO_APPLICATION'
,p_substitution_value_17=>'Torna all''applicazione'
,p_substitution_string_18=>'HELP'
,p_substitution_value_18=>'Guida'
,p_substitution_string_19=>'MSG_WORKSPACE'
,p_substitution_value_19=>'Area di lavoro'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112743'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/sql_command_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(996508348031635.4504)
,p_name=>'SQL Command Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(996930166037917.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Risultati'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="result_tab" onclick="html_TabClick(this,''resultsHolder'');return false;"'
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(997202592039442.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Spiega'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="explain_tab" onclick="sc_getPlan();html_TabClick(this,''explainHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22157207203570630.4504)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Descrivi'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="describe_tab" onclick="sc_getDesc();html_TabClick(this,''describeHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'139'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(997509865041519.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'SQL salvato'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="savedsql_tab" onclick="sc_getSavedSQL();html_TabClick(this,''SavedSQLHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23661510949786902.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Cronologia'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="history_tab" onclick="sc_DisplayHist();html_TabClick(this,''historyHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/qb_sub_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1390719147195878.4504)
,p_name=>'QB_SUB_TABS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1391928151198404.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Condizioni'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="cond_tab" onclick="html_TabClick(this,''conditionsHolder'');return false;"'
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1395101055209596.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="sql_tab" onclick="qb_postState();qb_genSql();html_TabClick(this,''queryText_table'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1395705903210915.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Risultati'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="result_tab" onclick="qb_genSql();html_TabClick(this,''queryResults_table'');qb_checkQuery();return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159965504417193520.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'SQL salvato'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="SavedSql_tab" onclick="qb_getSavedSQL();html_TabClick(this,''SavedSQLHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/query_builder_link_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1993413324492056.4504)
,p_name=>'Query_Builder_Link_Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1994208260500093.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina join'
,p_list_item_link_target=>'javascript:qb_delLinkClick();'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1994516571502453.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Imposta left outer join'
,p_list_item_link_target=>'javascript:qb_outer(''L'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1994823151504371.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Imposta right outer join'
,p_list_item_link_target=>'javascript:qb_outer(''R'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1993900988497974.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Annulla impostazione outer join'
,p_list_item_link_target=>'javascript:qb_outer(''E'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_soda_collections_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3328044443428468.4504)
,p_name=>'OB_SODA_COLLECTIONS_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3375935517022672.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Contenuto raccolta'
,p_list_item_link_target=>'f?p=&APP_ID.:SODA_COLLECTION_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3162'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3328679162428481.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Guida dati'
,p_list_item_link_target=>'f?p=&APP_ID.:SODA_COLLECTION_DATAGUIDE:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3161'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3328211818428480.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Metadati raccolta'
,p_list_item_link_target=>'f?p=&APP_ID.:SODA_COLLECTION_METADATA:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3160'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_soda_collections_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3332563114476666.4504)
,p_name=>'OB_SODA_COLLECTIONS_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3332718022476667.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3333368042485975.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Carica dati'
,p_list_item_link_target=>'f?p=&APP_ID.:3161:&SESSION.:LOAD_DATA:&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/qb_query_quick_results_pg_111
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3531801850564253.4504)
,p_name=>'QB Query Quick Results (pg 111)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3532824014570648.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="sql_tab" onclick="html_TabClick(this,''QuerySQL'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_spatial_index_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4555880609113142.4504)
,p_name=>'create spatial index progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4556029924113154.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Nome tabella'
,p_list_item_link_target=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'57'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4556484466113159.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Definizione indice'
,p_list_item_link_target=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4608764502360739.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Metadati spaziali'
,p_list_item_link_target=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'226,227'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4556831852113159.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Conferma'
,p_list_item_link_target=>'f?p=&APP_ID.:225:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6375626175414380.4504)
,p_name=>'OB_TABLE_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14784603224538632.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Aggiungi colonna'
,p_list_item_link_target=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,ADD_COLUMN:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6380827392452521.4504)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Modifica colonna'
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:79,66,71:F4500_LAST_VIEW,OB_OBJECT_NAME,P67_ACTION:2100,&OB_OBJECT_NAME.,MODIFY_COLUMN:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14815409906673027.4504)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Rinomina colonna'
,p_list_item_link_target=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:76,79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,RENAME_COLUMN:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14813828822669058.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Elimina colonna'
,p_list_item_link_target=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,DROP_COLUMN:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15094617459545746.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Rinomina'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:73,79,66:F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14866912181862952.4504)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'Copia'
,p_list_item_link_target=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_text_01=>'DEBUG.:79,66:F4500_LAST_VIEW,P70_ACTION:&APP_PAGE_ID.,RENAME_COLUMN:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6381509169456787.4504)
,p_list_item_display_sequence=>12
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_ot:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10493511347365375.4504)
,p_list_item_display_sequence=>13
,p_list_item_link_text=>'Tronca'
,p_list_item_link_target=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.::F4500_LAST_VIEW,P102_OWNER,P102_ON,P102_ot,P67_ACTION:&APP_PAGE_ID.,&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.,TRUNCATE:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106666107378742202.4504)
,p_list_item_display_sequence=>104
,p_list_item_link_text=>'Crea tabella di ricerca'
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RP,101,103:F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(581934538126106898.4504)
,p_list_item_display_sequence=>114
,p_list_item_link_text=>'Crea applicazione'
,p_list_item_link_target=>'#'');apex.util.getTopApex().navigation.redirect(''f?p=4500:50:&APP_SESSION.::&DEBUG.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_index_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(7770017698212372.4504)
,p_name=>'OB_INDEX_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7771200298226202.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dettagli oggetto'
,p_list_item_link_target=>'f?p=&APP_ID.:INDEX_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2200'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15785230925715068.4504)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Statistiche'
,p_list_item_link_target=>'f?p=&APP_ID.:159:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NOT_EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
' sys.dba_indexes',
'where owner = :OB_SCHEMA',
'and  index_name = :OBJECT_NAME',
'and ITYP_NAME = ''CONTEXT'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'159'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7771509648228988.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:INDEX_DDL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2201'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_database_link_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(7818718708685757.4504)
,p_name=>'OB_DATABASE_LINK_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7819707196701396.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dettagli oggetto'
,p_list_item_link_target=>'f?p=&APP_ID.:DATABASE_LINK_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2600:2602'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15731419001550744.4504)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Dipendenze'
,p_list_item_link_target=>'f?p=&APP_ID.:108:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'108'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7824710153815728.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:DATABASE_LINK_DDL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2601'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_plsql_object_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(8047123559654396.4504)
,p_name=>'OB_PLSQL_OBJECT_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(111089013465719206.4504)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Specifica'
,p_list_item_link_target=>'f?p=&APP_ID.:2250:&SESSION.::&DEBUG.::OBJECT_TYPE:PACKAGE:'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'OBJECT_TYPE'
,p_list_item_disp_condition2=>'PACKAGE:PACKAGE BODY'
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':OBJECT_TYPE=''PACKAGE'' and :FLOW_PAGE_ID = 2250'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(8047607413659153.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Codice'
,p_list_item_link_target=>'f?p=&APP_ID.:FUNCTION_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'OBJECT_TYPE'
,p_list_item_disp_condition2=>'PACKAGE:PACKAGE BODY'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2250'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(111089623161722027.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Corpo'
,p_list_item_link_target=>'f?p=&APP_ID.:2250:&SESSION.::&DEBUG.::OBJECT_TYPE:PACKAGE BODY:'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'OBJECT_TYPE'
,p_list_item_disp_condition2=>'PACKAGE:PACKAGE BODY'
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':OBJECT_TYPE=''PACKAGE BODY'' and :FLOW_PAGE_ID = 2250'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(8047915378661444.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Dipendenze'
,p_list_item_link_target=>'f?p=&APP_ID.:FUNCTION_DEPENDENCIES:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2251'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(8048710923688553.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Errori'
,p_list_item_link_target=>'f?p=&APP_ID.:FUNCTION_ERRORS:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_for_pages=>'2252'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(8049120273691243.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Privilegi'
,p_list_item_link_target=>'f?p=&APP_ID.:FUNCTION_GRANTS:&SESSION.::&DEBUG.:RP:::'
,p_security_scheme=>wwv_flow_api.id(7676404413799609)
,p_list_item_current_for_pages=>'2253'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(256800835086660869.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'REST'
,p_list_item_link_target=>'f?p=&APP_ID.:OBJECT_REST:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(256109433659228165.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_types_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(9111807762217267.4504)
,p_name=>'OB_TYPES_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9191504112452724.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dettagli oggetto'
,p_list_item_link_target=>'f?p=&APP_ID.:TYPE_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2550'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9191907921453811.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Sinonimi'
,p_list_item_link_target=>'f?p=&APP_ID.:TYPE_SYNONYM:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2551'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9192311731454913.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Privilegi'
,p_list_item_link_target=>'f?p=&APP_ID.:TYPE_GRANTS:&SESSION.::&DEBUG.:RP:::'
,p_security_scheme=>wwv_flow_api.id(7676404413799609)
,p_list_item_current_for_pages=>'2552'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9193216925456442.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:TYPE_SQL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_trigger_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(9213221268571230.4504)
,p_name=>'OB_TRIGGER_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9214015512579070.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Dettagli oggetto'
,p_list_item_link_target=>'f?p=&APP_ID.:TRIGGER_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2500'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(275740605529762351.4504)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Codice'
,p_list_item_link_target=>'f?p=&APP_ID.:2250:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2250'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(276042225267818298.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'DO NOT TRANSLATE: Dummy Child'
,p_parent_list_item_id=>wwv_flow_api.id(275740605529762351.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9214705946585712.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Errori'
,p_list_item_link_target=>'f?p=&APP_ID.:TRIGGER_ERRORS:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_for_pages=>'2501'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9213709971577495.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:TRIGGER_SQL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2503'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_synonym_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(9225416906655157.4504)
,p_name=>'OB_SYNONYM_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9225829027658622.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dettagli oggetto'
,p_list_item_link_target=>'f?p=&APP_ID.:SYNONYM_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2450'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_procedure_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(9233300162716512.4504)
,p_name=>'OB_PROCEDURE_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9233824403723509.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Codice'
,p_list_item_link_target=>'f?p=&APP_ID.:PROCEDURE_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2350'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_sequence_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(9285616718241773.4504)
,p_name=>'OB_SEQUENCE_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9296219694507531.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dettagli oggetto'
,p_list_item_link_target=>'f?p=&APP_ID.:SEQUENCE_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2400'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9301004681569422.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Privilegi'
,p_list_item_link_target=>'f?p=&APP_ID.:SEQUENCE_GRANTS:&SESSION.::&DEBUG.:RP:::'
,p_security_scheme=>wwv_flow_api.id(7676404413799609)
,p_list_item_current_for_pages=>'2401'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9303226152575623.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Dipendenze'
,p_list_item_link_target=>'f?p=&APP_ID.:SEQUENCE_USED:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2403'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9303503081578415.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:SEQUENCE_SQL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_view_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10264324489517545.4504)
,p_name=>'OB_VIEW_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10265705919521633.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Compila'
,p_list_item_link_target=>'f?p=&APP_ID.:VIEW_DETAIL:&SESSION.:COMPILE:&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10266511460523224.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_plsql_object_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10281517394553333.4504)
,p_name=>'OB_PLSQL_OBJECT_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10282722935554923.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Salva e compila'
,p_list_item_link_target=>'javascript:doCompile();'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_sw_util.show_plsql_edit(:flow_security_group_id)'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'NEVER'
,p_list_item_current_for_pages=>'2250'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10284704365559051.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Scarica origine'
,p_list_item_link_target=>'javascript:downloadCode();'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10283527783556343.4504)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=4500:102:&SESSION.::NO::P102_OWNER,P102_ON,P102_OT,F4500_LAST_VIEW:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.,&APP_PAGE_ID.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_sw_util.show_plsql_edit(:flow_security_group_id)'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_index_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10296931855576458.4504)
,p_name=>'OB_INDEX_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10631027987221732.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Disabilita'
,p_list_item_link_target=>'f?p=&APP_ID.:INDEX_DETAIL:&SESSION.:DISABLE:&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10299413631580642.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10298910168579638.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Ricrea'
,p_list_item_link_target=>'f?p=&APP_ID.:INDEX_DETAIL:&SESSION.:REBUILD:&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_sequence_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10306018611591561.4504)
,p_name=>'OB_SEQUENCE_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10307324498593269.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10633408987244636.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Modifica'
,p_list_item_link_target=>'f?p=&APP_ID.:179:&SESSION.:ALTER:&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_synonym_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10312125668603017.4504)
,p_name=>'OB_SYNONYM_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10312730862604563.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_trigger_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10314911600608476.4504)
,p_name=>'OB_TRIGGER_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10316220604611044.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Compila'
,p_list_item_link_target=>'f?p=&APP_ID.:2500:&SESSION.:COMPILE:&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10317125453612414.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10634920546257449.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Scarica'
,p_list_item_link_target=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10319109307617252.4504)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Disabilita'
,p_list_item_link_target=>'f?p=&APP_ID.:2500:&SESSION.:DISABLE:&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P2500_STATUS'
,p_list_item_disp_condition2=>'ENABLED'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10318130301613878.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Abilita'
,p_list_item_link_target=>'f?p=&APP_ID.:2500:&SESSION.:ENABLE:&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P2500_STATUS'
,p_list_item_disp_condition2=>'DISABLED'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_types_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10323630778623422.4504)
,p_name=>'OB_TYPES_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10325006668625992.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,&OBJECT_TYPE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_database_link_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10360630703718055.4504)
,p_name=>'OB_DATABASE_LINK_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10362319060724124.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,DATABASE LINK:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10362014558722877.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Test'
,p_list_item_link_target=>'f?p=&APP_ID.:2602:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/table_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11239830706238313.4504)
,p_name=>'Table Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11129306899761893.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Colonne tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:1047:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11252702534296443.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Commenti tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11253122273302192.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Vincoli tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:706:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11286227355445574.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Statistiche tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:1052:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11215531943727735.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Dimensioni memorizzazione tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:1048:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/exception_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11254208206307506.4504)
,p_name=>'Exception Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11247001795267858.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Tabelle senza chiavi primarie'
,p_list_item_link_target=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11257003273325012.4504)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Tabelle senza indici'
,p_list_item_link_target=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11247315993271938.4504)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Chiavi esterne non indicizzate'
,p_list_item_link_target=>'f?p=&APP_ID.:704:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(69176903649450759.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Tabelle senza trigger'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/security_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11271128516379623.4504)
,p_name=>'Security Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11122717588736506.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Privilegi di oggetto'
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_security.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(8953808698289635.4504)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Privilegi di colonna'
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_security.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(240016507458722563.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Privilegi di ruolo'
,p_list_item_link_target=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_security.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(240018327890728456.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Privilegi di sistema'
,p_list_item_link_target=>'f?p=&APP_ID.:1404:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_security.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/pl_sql_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11319530060616601.4504)
,p_name=>'PL/SQL Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11134009370790923.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Argomenti di program unit'
,p_list_item_link_target=>'f?p=&APP_ID.:1046:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11323926167634444.4504)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Conteggi righe program unit'
,p_list_item_link_target=>'f?p=&APP_ID.:1054:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(163506601642923359.4504)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Cerca nel codice sorgente PL/SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/recycle_bin
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11401232423499912.4504)
,p_name=>'Recycle Bin'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11401613160503840.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Oggetti eliminati'
,p_list_item_link_target=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_page.png'
,p_list_item_icon_attributes=>'height="20" width="20"  alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11404101994519551.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Svuota cestino'
,p_list_item_link_target=>'f?p=&APP_ID.:403:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'height="20" width="20"  alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11739111107829730.4504)
,p_name=>'OB_TABLE_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11740501541836476.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tabella'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_DETAIL:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2100'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11744500680874063.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Dati'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_DATA:&SESSION.:T:&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2101:42:46:47'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11742226953853220.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Indici'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_INDEXES:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_for_pages=>'2102'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11742502842855728.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Modello'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_MODEL:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'2103'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11743118772860341.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Vincoli'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_CONSTRAINTS:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2104'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11743631586864077.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Privilegi'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_GRANTS:&SESSION.::&DEBUG.:RP:::'
,p_security_scheme=>wwv_flow_api.id(7676404413799609)
,p_list_item_current_for_pages=>'2105'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11744024098871375.4504)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Statistiche'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_STATISTICS:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_for_pages=>'2106'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11746129077882210.4504)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Valori predefiniti di interfaccia utente'
,p_list_item_link_target=>'f?p=&APP_ID.:OB_UI_DEFAULTS:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2155'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11746506352885196.4504)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Trigger'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_TRIGGERS:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_for_pages=>'2108'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11746906137894555.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Dipendenze'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_DEPENDENCIES:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_for_pages=>'2109'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11747316180897446.4504)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_DDL:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(243327690322706018.4504)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'REST'
,p_list_item_link_target=>'f?p=&APP_ID.:OBJECT_REST:&SESSION.::&DEBUG.:2111:::'
,p_security_scheme=>wwv_flow_api.id(802775228359756685)
,p_required_patch=>wwv_flow_api.id(256109433659228165.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(565810533598211906.4504)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Query di esempio'
,p_list_item_link_target=>'f?p=&APP_ID.:OBJECT_SAMPLE_QUERIES:&SESSION.::&DEBUG.:2112:::'
,p_security_scheme=>wwv_flow_api.id(802775228359756685)
,p_required_patch=>wwv_flow_api.id(256109433659228165.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_view_subtab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11795609889491706.4504)
,p_name=>'OB_VIEW_SUBTAB'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11796215907502913.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Vista'
,p_list_item_link_target=>'f?p=&APP_ID.:VIEW_DETAIL:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2150'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(275770510302858374.4504)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Codice'
,p_list_item_link_target=>'f?p=&APP_ID.:2250:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2250'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(275954917228560573.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'DO NOT TRANSLATE: Dummy Child'
,p_parent_list_item_id=>wwv_flow_api.id(275770510302858374.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11796923526505149.4504)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Dati'
,p_list_item_link_target=>'f?p=&APP_ID.:VIEW_DATA:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2156:42:46'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11796620409504293.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Privilegi'
,p_list_item_link_target=>'f?p=&APP_ID.:VIEW_GRANTS:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(7676404413799609)
,p_list_item_current_for_pages=>'2151'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15460922082198559.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Valori predefiniti di interfaccia utente'
,p_list_item_link_target=>'f?p=&APP_ID.:OB_UI_DEFAULTS:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2155'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11797231837507563.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Dipendenze'
,p_list_item_link_target=>'f?p=&APP_ID.:VIEW_DEPENDENCIES:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'2153'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11798011536511170.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:VIEW_DDL:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(256799136537648764.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'REST'
,p_list_item_link_target=>'f?p=&APP_ID.:OBJECT_REST:&SESSION.::&DEBUG.:2111:::'
,p_required_patch=>wwv_flow_api.id(256109433659228165.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_data_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(14089426771868187.4504)
,p_name=>'OB_TABLE_DATA_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14092422184885755.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Query'
,p_list_item_link_target=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.::F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149453228384232993.4504)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Conta righe'
,p_list_item_link_target=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:COUNT:&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(141149820477003321.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Inserisci riga'
,p_list_item_link_target=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:SW_QBE_SAVE:F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'163'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(184426071429609975.4504)
,p_list_item_display_sequence=>14
,p_list_item_link_text=>'Carica dati'
,p_list_item_link_target=>'#'');apex.util.getTopApex().navigation.redirect(''f?p=4500:53:&APP_SESSION.::&DEBUG.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_index_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(14921315593135016.4504)
,p_name=>'OB_TABLE_INDEX_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25220114374714654.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Crea'
,p_list_item_link_target=>'f?p=&APP_ID.:95:&SESSION.:TABLE:&DEBUG.:95,106,130:F4500_LAST_VIEW,P67_ACTION,P95_FROM:&APP_PAGE_ID.,CREATE_INDEX,TABLE:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25221222339716916.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Crea testo'
,p_list_item_link_target=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,CREATE_TEXT_INDEX:'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25220617837715658.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,DROP_INDEX:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_contraint_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(14992414558348243.4504)
,p_name=>'OB_TABLE_CONTRAINT_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40212436008062897.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Crea'
,p_list_item_link_target=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40212939471063901.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40213543973065159.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Abilita'
,p_list_item_link_target=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14997910121363886.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Disabilita'
,p_list_item_link_target=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW:&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_stats_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15123613473622266.4504)
,p_name=>'OB_TABLE_STATS_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30219451896172097.4504)
,p_list_item_display_sequence=>8
,p_list_item_link_text=>'Analizza'
,p_list_item_link_target=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,ANALYZE:'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(556017951625246222.4504)
,p_list_item_display_sequence=>18
,p_list_item_link_text=>'Raccogli statistiche tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:RP,49,50:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,GATHER_TABLE_STATS:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_trigger_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15140917230304234.4504)
,p_name=>'OB_TABLE_TRIGGER_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40362045086021150.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Crea'
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:79,66,22:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,CREATE_TRIGGER:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40360937121018888.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,DROP_TRIGGER:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40361440584019892.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Abilita'
,p_list_item_link_target=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,ENABLE_TRIGGER:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15143911364329301.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Disabilita'
,p_list_item_link_target=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,DISABLE_TRIGGER:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_grant_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15238925543915636.4504)
,p_name=>'OB_TABLE_GRANT_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40458915675630290.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Concedi'
,p_list_item_link_target=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.::F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,GRANT:'
,p_security_scheme=>wwv_flow_api.id(7676404413799609)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40460023640632552.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Revoca'
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:79,66:F4500_LAST_VIEW,P67_ACTION:&APP_PAGE_ID.,REVOKE_GRANT:'
,p_security_scheme=>wwv_flow_api.id(7676404413799609)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_index_stats_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15790302694745667.4504)
,p_name=>'OB_INDEX_STATS_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46009657719917764.4504)
,p_list_item_display_sequence=>8
,p_list_item_link_text=>'Analizza'
,p_list_item_link_target=>'f?p=&APP_ID.:160:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_mat_view_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15852414527126687.4504)
,p_name=>'OB_MAT_VIEW_TABS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15853027686130448.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Vista materializzata'
,p_list_item_link_target=>'f?p=&APP_ID.:MATERIALIZED_VIEW_DETAIL:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'161'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15864022454176282.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Dati'
,p_list_item_link_target=>'f?p=&APP_ID.:MATERIALIZED_VIEW_DATA:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'163:42'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15865505270180732.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Dettagli'
,p_list_item_link_target=>'f?p=&APP_ID.:MATERIALIZED_VIEW_DETAILS:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'166'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15920609491361728.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Privilegi'
,p_list_item_link_target=>'f?p=&APP_ID.:MATERIALIZED_VIEW_GRANTS:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(7676404413799609)
,p_list_item_current_for_pages=>'173'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15926013001391100.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Dipendenze	'
,p_list_item_link_target=>'f?p=&APP_ID.:MATERIALIZED_VIEW_SYNONYMS:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'174'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15859119422156428.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:MATERIALIZED_VIEW_SQL:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_create_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(18696924586125446.4504)
,p_name=>'OB_CREATE_LIST'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527967216283926194.4504)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Tabella'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527967527216926195.4504)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Vista'
,p_list_item_link_target=>'f?p=&APP_ID.:VIEW_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527967836705926196.4504)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Indice'
,p_list_item_link_target=>'f?p=&APP_ID.:INDEX_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527968148814926196.4504)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Sequenza'
,p_list_item_link_target=>'f?p=&APP_ID.:SEQUENCE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527968411767926196.4504)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Tipo'
,p_list_item_link_target=>'f?p=&APP_ID.:TYPE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527968775862926196.4504)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Package'
,p_list_item_link_target=>'f?p=&APP_ID.:PACKAGE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527969041327926196.4504)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'Procedura'
,p_list_item_link_target=>'f?p=&APP_ID.:PROCEDURE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527969301551926196.4504)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Funzione'
,p_list_item_link_target=>'f?p=&APP_ID.:FUNCTION_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527969688406926196.4504)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Trigger'
,p_list_item_link_target=>'f?p=&APP_ID.:TRIGGER_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527969899542926199.4504)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Database link'
,p_list_item_link_target=>'f?p=&APP_ID.:DATABASE_LINK_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1527970208830926199.4504)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Vista materializzata'
,p_list_item_link_target=>'f?p=&APP_ID.:MATERIALIZED_VIEW_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_required_patch=>wwv_flow_api.id(240247031763163202.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(960228917980286937.4504)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Sinonimo'
,p_list_item_link_target=>'f?p=&APP_ID.:SYNONYM_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(240237502901130926.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1500509745377353.4504)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Raccolta SODA'
,p_list_item_link_target=>'f?p=&APP_ID.:3150:&SESSION.::&DEBUG.:3150,3151:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_db_version.c_has_soda'
,p_list_item_disp_condition2=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(240237502901130926.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_mat_view_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(19933910744920832.4504)
,p_name=>'OB_MAT_VIEW_ACTIONS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30258824127546824.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elimina'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_OWNER,P102_ON,P102_OT:&OB_SCHEMA.,&OBJECT_NAME.,MATERIALIZED VIEW:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_ui_default_action
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(20344107517818485.4504)
,p_name=>'OB_UI_DEFAULT_ACTION'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20348102631864356.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Modifica'
,p_list_item_link_target=>'javascript:top.redirect(&quot;f?p=4500:802:&SESSION.:::802,RP:P800_SCHEMA,P802_TABLE_ID:&OBJECT_OWNER.,&P2155_UI_DEF_TABLE_ID.&quot;)'
,p_security_scheme=>wwv_flow_api.id(20416908986150096)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20376629156136971.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Crea valori predefiniti'
,p_list_item_link_target=>'javascript:top.redirect(&quot;f?p=4500:801:&SESSION.::&DEBUG.:RP,801,802:P800_SCHEMA,P801_TABLE_ID,P802_TABLE_ID:&OBJECT_OWNER.,&OBJECT_ID.,&quot;)'
,p_security_scheme=>'!'||wwv_flow_api.id(20416908986150096)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_object_types
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(23674222199102465.4504)
,p_name=>'OB_OBJECT_TYPES'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23674801898106075.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tabelle'
,p_list_item_icon=>'table_s.gif'
,p_list_text_01=>'TABLE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1001'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23675208132107838.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Viste'
,p_list_item_icon=>'view_s.gif'
,p_list_text_01=>'VIEW'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23676115750110093.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Indici'
,p_list_item_icon=>'index_s.gif'
,p_list_text_01=>'INDEX'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23677731334114549.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sequenze'
,p_list_item_icon=>'sequence_s.gif'
,p_list_text_01=>'SEQUENCE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23678808609117400.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Tipi'
,p_list_item_icon=>'type_s.gif'
,p_list_text_01=>'TYPE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23676924062112497.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Package'
,p_list_item_icon=>'package_s.gif'
,p_list_text_01=>'PACKAGE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23677327871113573.4504)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Procedure'
,p_list_item_icon=>'procedure_s.gif'
,p_list_text_01=>'PROCEDURE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23675611595108895.4504)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Funzioni'
,p_list_item_icon=>'function_s.gif'
,p_list_text_01=>'FUNCTION'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23678405146116460.4504)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Trigger'
,p_list_item_icon=>'trigger_s.gif'
,p_list_text_01=>'TRIGGER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23679113457118846.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Database link'
,p_list_item_icon=>'dblink_s.gif'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'DATABASE_LINK'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23676520945111591.4504)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Viste materializzate'
,p_list_item_icon=>'materialized_view_s.gif'
,p_list_text_01=>'MATERIALIZED_VIEW'
,p_required_patch=>wwv_flow_api.id(240247031763163202.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23678002029115528.4504)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Sinonimi'
,p_list_item_icon=>'synonym_s.gif'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'SYNONYM'
,p_required_patch=>wwv_flow_api.id(240237502901130926.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3310563180268546.4504)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Raccolte SODA'
,p_list_item_icon=>'table_s.gif'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_db_version.c_has_soda'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'SODA_COLLECTION'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1001'
);
end;
/
prompt --application/shared_components/navigation/lists/table_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(35404206746396755.4504)
,p_name=>'table.tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37849213608894974.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Processore comandi SQL'
,p_list_item_link_target=>'f?p=&FLOW_ID.:3:&SESSION.::&DEBUG.:3::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(35408016920409156.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Query By Example'
,p_list_item_link_target=>'f?p=&FLOW_ID.:42:&SESSION.:qbe:&DEBUG.:42:P42_OBJECT_ID:&P502_OBJECT_ID.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.g_flow_step_id not in (69,96,110) and',
':F4500_P500_OBJECT_TYPE not in (''FUNCTION'',''PROCEDURE'',''PACKAGE'',''PACKAGE BODY'')'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'42'
);
end;
/
prompt --application/shared_components/navigation/lists/ui_default_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(40650212014681045.4504)
,p_name=>'ui default tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40758212349422677.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Crea gruppo di colonne'
,p_list_item_link_target=>'f?p=&APP_ID.:804:&SESSION.::&DEBUG.:804:P804_TABLE_ID:&P802_TABLE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40841914817552027.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Gestisci gruppi di colonne'
,p_list_item_link_target=>'f?p=&APP_ID.:805:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(429084627870179449.4504)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Sincronizza con database'
,p_list_item_link_target=>'f?p=&APP_ID.:807:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201476126054569515.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Esegui migrazione nel dizionario attributi'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::P32_SCHEMA,P33_TABLE_ID:&P800_SCHEMA.,&P802_TABLE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40819416727890341.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Rimuovi da dizionario tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:830:&SESSION.::&DEBUG.::P830_TABLE_ID:&P802_TABLE_ID.:'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P802_TABLE_ID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/table_dictionary_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(40848526002687735.4504)
,p_name=>'table dictionary tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201458325044096158.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Migrazione dizionario attributi'
,p_list_item_link_target=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.::P32_SCHEMA:&P800_SCHEMA.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40876113946214023.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Esporta'
,p_list_item_link_target=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40876316370214768.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Importa'
,p_list_item_link_target=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sql_workshop_home_list_apex_4_0
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(46900227098494683.4504)
,p_name=>'SQL Workshop Home List - APEX 4.0'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46900407490498504.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Browser oggetti'
,p_list_item_link_target=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'sql-workshop-object-browser'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46900613377500241.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Comandi SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'sql-workshop-commands'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46900819264501864.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Script SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-sql-script'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46901026191503941.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.:1002:::'
,p_list_item_icon=>'qb'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47583907412198107.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utility'
,p_list_item_link_target=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(325069319924256588.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Servizi RESTful'
,p_list_item_link_target=>'f?p=4850:500:&SESSION.'
,p_list_item_icon=>'sql-workshop-rest'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_api.id(802775228359756685)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_0_homepage_large_icons
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(46901918965530186.4504)
,p_name=>'APEX 5.0 - Homepage Large Icons'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46902304205535426.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'App Builder'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.:::'
,p_list_item_icon=>'app-builder'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where provisioning_company_id = :flow_security_group_id',
'and   NVL(allow_app_building_yn,''Y'') = ''Y'''))
,p_list_text_01=>'app-builder'
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46902518057539426.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'SQL Workshop'
,p_list_item_link_target=>'f?p=&APP_ID.:3002:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'sql-workshop'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where provisioning_company_id = :flow_security_group_id',
'and   NVL(allow_sql_workshop_yn,''Y'') = ''Y'''))
,p_list_text_01=>'sql-workshop'
,p_security_scheme=>wwv_flow_api.id(178925305824656679)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(171304512978435723.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Team Development'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.:::'
,p_list_item_icon=>'issues'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_text_01=>'issues'
,p_security_scheme=>wwv_flow_api.id(173297929258927869)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46902925329541524.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Amministrazione'
,p_list_item_link_target=>'f?p=4350:1:&SESSION.'
,p_list_item_icon=>'administration'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_text_01=>'workspace-admin'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(402682359167084178.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Galleria'
,p_list_item_link_target=>'f?p=4750:50:&APP_SESSION.:::50'
,p_list_item_icon=>'pkg-apps'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_text_01=>'pkg-apps'
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ddl_wizard
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(87134126220568115.4504)
,p_name=>'DDL Wizard'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(87135922338569906.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Schema'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(87136718887571537.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Tipo di oggetto'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'43'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(87137516731572565.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nome oggetto'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'44'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(87138313496573982.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Script'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'29:45'
);
end;
/
prompt --application/shared_components/navigation/lists/4500_24_tablescolums
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(98332317887807047.4504)
,p_name=>'4500_24_TablesColums'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(98332922735808489.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tabelle'
,p_list_item_link_target=>'javascript:void($d_TabClick(''tabletab'',''tablereport'',''tabcurrent'',p24Tabs))'||wwv_flow.LF||
''
,p_list_text_01=>'id="tabletab"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(98333326198809479.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Colonne'
,p_list_item_link_target=>'javascript:void($d_TabClick(''columntab'',''columnreport'',''tabcurrent'',p24Tabs))'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P24_TABLE_NAME'
,p_list_text_01=>'id="columntab"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/database_monitor
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(133792932105421631.4504)
,p_name=>'database monitor'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(133794915960426480.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Sessioni'
,p_list_item_link_target=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(173640005872718109.4504)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'Statistiche di sistema'
,p_list_item_link_target=>'f?p=&APP_ID.:560:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(134580728113951404.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Prime istruzioni SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(137498619860396665.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Operazioni di lunga durata'
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_database_objects
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(149627725126847053.4504)
,p_name=>'Create Database Objects'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(279673154414663323.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tabella'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_table.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(279679031390694460.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Vista'
,p_list_item_link_target=>'f?p=&APP_ID.:VIEW_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_view.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(279681428404703059.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Indice'
,p_list_item_link_target=>'f?p=&APP_ID.:INDEX_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_index.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(279685138578715449.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sequenza'
,p_list_item_link_target=>'f?p=&APP_ID.:SEQUENCE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_sequence.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(279688529705722382.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Tipo'
,p_list_item_link_target=>'f?p=&APP_ID.:TYPE_CREATE:&SESSION.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/ob_type.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(451099159181446421.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Package'
,p_list_item_link_target=>'f?p=&APP_ID.:PACKAGE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_package_body.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(451100168185449035.4504)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Procedura'
,p_list_item_link_target=>'f?p=&APP_ID.:PROCEDURE_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_procedure.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(451097460089437295.4504)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Funzione'
,p_list_item_link_target=>'f?p=&APP_ID.:FUNCTION_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_function.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(451103965199457646.4504)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Trigger'
,p_list_item_link_target=>'f?p=&APP_ID.:TRIGGER_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_trigger.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(108262713773954997.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Database link'
,p_list_item_link_target=>'f?p=&APP_ID.:DATABASE_LINK_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_dblink.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(108264314597964669.4504)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Vista materializzata'
,p_list_item_link_target=>'f?p=&APP_ID.:MATERIALIZED_VIEW_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_materialized_view.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_required_patch=>wwv_flow_api.id(240247031763163202.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(108268718537975278.4504)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Sinonimo'
,p_list_item_link_target=>'f?p=&APP_ID.:SYNONYM_CREATE:&SESSION.::&DEBUG.:602,604,145,149,48,98,107,100,57,77,94,135,117,118,131,186,187,120,124,125,121,122,123,97,99,3,84,182,183,91,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:::'
,p_list_item_icon=>'htmldb/icons/ob_synonym.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(240237502901130926.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1200701823187736.4504)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Raccolta SODA'
,p_list_item_link_target=>'f?p=&APP_ID.:3150:&SESSION.::&DEBUG.:3150,3151:::'
,p_list_item_icon=>'htmldb/icons/ob_synonym.gif'
,p_list_item_icon_attributes=>'width="32" height="24" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_db_version.c_has_soda'
,p_list_item_disp_condition2=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(240237502901130926.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_table_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(149747621878186797.4504)
,p_name=>'create table progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149749617853195058.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Colonne'
,p_list_item_link_target=>'javascript:doSubmit(''COL'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'602'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149750402747200116.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Chiave primaria'
,p_list_item_link_target=>'javascript:doSubmit(''PK'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'604'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149751026296206923.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Chiave esterna'
,p_list_item_link_target=>'javascript:doSubmit(''FK'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'145'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(167420128965767313.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Vincoli'
,p_list_item_link_target=>'javascript:doSubmit(''CONS'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'149'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149751512574212399.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Conferma'
,p_list_item_link_target=>'javascript:doSubmit(''CONF'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'612:614'
);
end;
/
prompt --application/shared_components/navigation/lists/create_view_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(149867603205408487.4504)
,p_name=>'create view progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149868411863410941.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Definizione'
,p_list_item_link_target=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'48,602'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149869323637414393.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Conferma'
,p_list_item_link_target=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'52:54'
);
end;
/
prompt --application/shared_components/navigation/lists/create_database_link_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(149896424470499729.4504)
,p_name=>'create database link progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149897204169503329.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Definisci'
,p_list_item_link_target=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'91'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149898018021507393.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Conferma'
,p_list_item_link_target=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'92:58'
);
end;
/
prompt --application/shared_components/navigation/lists/create_function_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(149902807201523152.4504)
,p_name=>'create function progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149906007679532742.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Nome'
,p_list_item_link_target=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'98'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149907524994537698.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Argomenti'
,p_list_item_link_target=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'107'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149908003654541084.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Corpo funzione'
,p_list_item_link_target=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'100'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149910419238545537.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Conferma'
,p_list_item_link_target=>'f?p=&APP_ID.:109:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'109'
);
end;
/
prompt --application/shared_components/navigation/lists/create_index_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(149926526903576167.4504)
,p_name=>'create index progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149927600023577803.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Nome tabella'
,p_list_item_link_target=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'57'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149930021494584052.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Definizione indice'
,p_list_item_current_for_pages=>'77,94'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149930625649585213.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Conferma'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5:4'
);
end;
/
prompt --application/shared_components/navigation/lists/create_materialized_view_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(149951426304632759.4504)
,p_name=>'create materialized view progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149952408774637135.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Definisci'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'135'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149954100593644272.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Conferma'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'136:141'
);
end;
/
prompt --application/shared_components/navigation/lists/create_package_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(149957726913651895.4504)
,p_name=>'create package progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(171534808786575314.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Seleziona tipo'
,p_list_item_link_target=>'f?p=&APP_ID.:117:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'117'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149958822888660101.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nome'
,p_list_item_link_target=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'118,120,186'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(722930026779822542.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Definisci'
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131,124,187'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1080739923278204088.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Conferma'
,p_list_item_link_target=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P117_CREATE_PACKAGE'
,p_list_item_disp_condition2=>'TABLE'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_procedure_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(150037318536819700.4504)
,p_name=>'create procedure progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150045702783853023.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Nome'
,p_list_item_current_for_pages=>'121'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150053317852895220.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Argomenti'
,p_list_item_current_for_pages=>'122'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150840511032292788.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Definisci'
,p_list_item_current_for_pages=>'123'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150841506661300917.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Conferma'
,p_list_item_current_for_pages=>'114'
);
end;
/
prompt --application/shared_components/navigation/lists/create_sequence_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(150794104668931302.4504)
,p_name=>'create sequence progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150795517266944463.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Definisci'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'97'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150796123500946231.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Conferma'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'116:129'
);
end;
/
prompt --application/shared_components/navigation/lists/create_synonym_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(150805024941050729.4504)
,p_name=>'create synonym progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150805906025054758.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Definisci'
,p_list_item_current_for_pages=>'99'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150807117238067458.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Conferma'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'127'
);
end;
/
prompt --application/shared_components/navigation/lists/create_trigger_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(150811814776114073.4504)
,p_name=>'create trigger progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150812319971115562.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Nome'
,p_list_item_current_for_pages=>'3'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150813302094119896.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Definisci'
,p_list_item_current_for_pages=>'84'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150815310536131761.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Conferma'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9:16'
);
end;
/
prompt --application/shared_components/navigation/lists/create_type_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(150827529723222442.4504)
,p_name=>'create type progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150828211154226585.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Nome'
,p_list_item_current_for_pages=>'182'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150828619465228988.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Definisci'
,p_list_item_current_for_pages=>'183'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150829232279232684.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Conferma'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'184:185'
);
end;
/
prompt --application/shared_components/navigation/lists/recyclebin
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(151000331198918456.4504)
,p_name=>'recyclebin'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(151001418516924257.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Svuota cestino'
,p_list_item_link_target=>'f?p=&FLOW_ID.:403:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/session_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(159562414490322899.4504)
,p_name=>'session tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159564908042330521.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Sessioni'
,p_list_item_link_target=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'540'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159565421201334330.4504)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Lock'
,p_list_item_link_target=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'541'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162017426458197138.4504)
,p_list_item_display_sequence=>2.1
,p_list_item_link_text=>'Attese'
,p_list_item_link_target=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'548'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159588009305397176.4504)
,p_list_item_display_sequence=>2.2
,p_list_item_link_text=>'I/O'
,p_list_item_link_target=>'f?p=&APP_ID.:545:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'545'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159566527088336046.4504)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:542:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'542'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159567803324338684.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Cursori aperti'
,p_list_item_link_target=>'f?p=&APP_ID.:543:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'543,546'
);
end;
/
prompt --application/shared_components/navigation/lists/script_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(163470423703447178.4504)
,p_name=>'Script Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(164091703714775079.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Gestisci risultati'
,p_list_item_link_target=>'f?p=&APP_ID.:1220:&SESSION.::&DEBUG.:1220:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150027319743782244.4504)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Mostra quote'
,p_list_item_link_target=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(221300505462590355.4504)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Esporta'
,p_list_item_link_target=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:SCRIPTS_TO_EXPORT:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(221300908233591110.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Importa'
,p_list_item_link_target=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/utilities_line_1
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(169562905299954428.4504)
,p_name=>'Utilities line 1'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(169563123101954428.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_list_item_icon=>'icon-utilities-data-workshop'
,p_list_text_01=>'Caricare e scaricare i dati utilizzando file CSV, XLSX, XML o JSON.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(686840721222033340.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-query-builder'
,p_list_text_01=>unistr('Creare query in modalit\00E0 grafica mediante l''aggiunta di tabelle in un pannello e la selezione delle colonne da restituire.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713107322646978455.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:RP,1100:::'
,p_list_item_icon=>'a-Icon icon-utilities-query-builder'
,p_list_text_01=>'Generare un''istruzione SQL utilizzando la sintassi abbreviata'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165295291982048923.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Data set di esempio'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_list_item_icon=>'icon-sc-files'
,p_list_text_01=>'Installare, aggiornare o rimuovere i set di dati di esempio.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(621480553521527744.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Genera DDL'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-generate-ddl'
,p_list_text_01=>'Generare script per tutti gli oggetti di database o per gli oggetti di database selezionati di uno schema.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(169564017816954429.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Valori predefiniti interfaccia utente'
,p_list_item_link_target=>'f?p=&APP_ID.:813:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-ui-defaults'
,p_list_text_01=>unistr('Specificare propriet\00E0 di layout per generare in modo coerente elementi o colonne tra le pagine e le applicazioni.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(862293371954895810.4504)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Confronto degli schemi'
,p_list_item_link_target=>'f?p=&APP_ID.:1350:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilites-schema-comparison'
,p_list_text_01=>'Mostrare le differenze tra gli oggetti di database di due schemi diversi.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(169563411461954429.4504)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Metodi sulle tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120,124,125:::'
,p_list_item_icon=>'icon-utilities-methods-tables'
,p_list_text_01=>'Generare script di interfaccia API per le operazioni DML sulle tabelle specificate.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(862292771917895809.4504)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Cestino'
,p_list_item_link_target=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilites-recycle-bin'
,p_list_text_01=>'Ripristinare gli oggetti di database che sono stati eliminati.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1379793096144889954.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Report oggetti'
,p_list_item_link_target=>'f?p=&APP_ID.:1042:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-object-reports'
,p_list_text_01=>'Accedere a numerosi report su tabelle, eccezioni, sicurezza, oggetti e codice PL/SQL.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(862293694522895810.4504)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Informazioni sul database'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-about-database'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>unistr('Controllare i dettagli del database. Nota: \00E8 richiesto un account database al quale \00E8 stato concesso il ruolo DBA.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1144637580332327672.4504)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Controllo database'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-database-monitor'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>unistr('Eseguire report di attivit\00E0 del database. Nota: \00E8 richiesto un account database al quale \00E8 stato concesso il ruolo DBA. ')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sql_workshop_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(170601318269466378.4504)
,p_name=>'sql workshop navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(170601510360466387.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Browser oggetti'
,p_list_item_link_target=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/ob_browser.gif'
,p_list_text_01=>'browser'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(170601819280466388.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Comandi SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/sqlcmd.gif'
,p_list_text_01=>'commandLine'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(170602114146466388.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Script SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/sqlscrpt.gif'
,p_list_text_01=>'file'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(170602413280466389.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/qbuilder.gif'
,p_list_text_01=>'queryBuilder'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(170628208161633707.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utility'
,p_list_item_link_target=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/shared_comp_small.gif'
,p_list_text_01=>'utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(872825001018813755.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Servizi RESTful'
,p_list_item_link_target=>'f?p=4850:1:&SESSION.'
,p_list_item_icon=>'htmldb/icons/dbservice.png'
,p_list_text_01=>'restfulServices'
,p_security_scheme=>wwv_flow_api.id(802775228359756685)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ui_defaults_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(194504915759237345.4504)
,p_name=>'UI Defaults Navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(421011030860726171.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:813:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'813'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194505202972237349.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Dizionario tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.::P800_SCHEMA:&P813_SCHEMA.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'800'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194505603010237353.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Dizionario attributi'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'6:17'
);
end;
/
prompt --application/shared_components/navigation/lists/all_object_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(276235426866859669.4504)
,p_name=>'All Object Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(276237431846870512.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Tutti gli oggetti'
,p_list_item_link_target=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:500:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(276237707735873072.4504)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Oggetti non validi'
,p_list_item_link_target=>'f?p=&APP_ID.:1040:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(276238015700875357.4504)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Calendario creazione oggetti'
,p_list_item_link_target=>'f?p=&APP_ID.:1055:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_session.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(276238320549876791.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Conteggi di oggetti per tipo'
,p_list_item_link_target=>'f?p=&APP_ID.:1059:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(65214035632967721.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Dizionario dati'
,p_list_item_link_target=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/attribute_dictionary_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(442022106915434689.4504)
,p_name=>'attribute dictionary tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(442022828528434694.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Esporta'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(442023208094434695.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Importa'
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/home_resources_links
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(454525848376819263.4504)
,p_name=>'HOME RESOURCES LINKS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(577763356185589338.4504)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Sito Web APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_02=>'rel="noreferrer" target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454526878748819266.4504)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Blog'
,p_list_item_link_target=>'https://apex.oracle.com/blog'
,p_list_text_02=>'rel="noreferrer" target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454527233209819267.4504)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Esercitazioni'
,p_list_item_link_target=>'https://apex.oracle.com/hols'
,p_list_text_02=>'rel="noreferrer" target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454526082518819264.4504)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Video'
,p_list_item_link_target=>'https://apex.oracle.com/videos'
,p_list_text_02=>'rel="noreferrer" target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454527671515819267.4504)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Risorse didattiche'
,p_list_item_link_target=>'https://apex.oracle.com/education'
,p_list_text_02=>'rel="noreferrer" target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(138135484121357859.4504)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Idee e richieste di funzione'
,p_list_item_link_target=>'https://apex.oracle.com/ideas'
,p_list_text_02=>'rel="noreferrer" target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454526454015819266.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'apex.world'
,p_list_item_link_target=>'https://apex.oracle.com/apex.world'
,p_list_text_02=>'rel="noreferrer" target="_blank"'
,p_list_text_03=>'is-external-link'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_administration_header
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(697546799309390664.4504)
,p_name=>'APEX 5 - Administration (Header)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697546976894390664.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Amministrazione'
,p_list_item_link_target=>'f?p=4350:1:&APP_SESSION.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697547235161390665.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697547501968390665.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Gestisci servizio'
,p_security_scheme=>wwv_flow_api.id(12520119493499631)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697547855490390665.4504)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Gestisci servizio'
,p_list_item_link_target=>'f?p=4350:21:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697547501968390665.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697548157703390665.4504)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(697547501968390665.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(322769288632400743.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Effettua una richiesta di servizio'
,p_list_item_link_target=>'f?p=4350:96:&SESSION.::NO:49::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(697547501968390665.4504)
,p_security_scheme=>wwv_flow_api.id(12520119493499631)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697548721548390666.4504)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Imposta preferenze area di lavoro'
,p_list_item_link_target=>'f?p=4350:17:&SESSION.::NO:RP::'
,p_parent_list_item_id=>wwv_flow_api.id(697547501968390665.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697549084529390666.4504)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Definisci messaggio area di lavoro'
,p_list_item_link_target=>'f?p=4350:35:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697547501968390665.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180642720025555459.4504)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Definisci banner ambiente'
,p_list_item_link_target=>'f?p=4350:105:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697547501968390665.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697549313943390666.4504)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Utilizzo area di lavoro'
,p_list_item_link_target=>'f?p=4350:101:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697547501968390665.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697549654493390666.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Gestisci utenti e gruppi'
,p_list_item_link_target=>'f?p=4350:55:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(12520119493499631)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697549971815390666.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Controlla attivit\00E0')
,p_list_item_link_target=>'f?p=4350:22:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(10590808779171805)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697550297696390667.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=4350:33:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(10590808779171805)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1250750521916198591.4504)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Modifica password personale'
,p_list_item_link_target=>'f?p=4350:3:&SESSION.::&DEBUG.:3#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(10590808779171805)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(697551745129395610.4504)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(315961750369926048.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentazione Quick SQL'
,p_list_item_link_target=>'&SYSTEM_HELP_URL./aeutl/using-quick-sql.html'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'1100'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1815064344998576882.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentazione browser oggetti'
,p_list_item_link_target=>'&SYSTEM_HELP_URL./aeutl/managing-db-objects-with-object-browser.html'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'1001'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1815073082808606504.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentazione comandi SQL'
,p_list_item_link_target=>'&SYSTEM_HELP_URL./aeutl/using-SQL-commands.html'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'1003'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1815073545088614954.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentazione script SQL'
,p_list_item_link_target=>'&SYSTEM_HELP_URL./aeutl/using-SQL-scripts.html#AEUTL190'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'1004'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1815073871384621185.4504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentazione utility'
,p_list_item_link_target=>'&SYSTEM_HELP_URL./aeutl/using-oracle-application-express-utilities.html#'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'1005'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697551976020395610.4504)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Documentazione'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkDocLib'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2105955016147042297.4504)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Forum di discussione'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2185349560170378007.4504)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Ulteriori informazioni su Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697552813369395610.4504)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697553124884395611.4504)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Informazioni'
,p_list_item_link_target=>'f?p=4350:9:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(718942723406995455.4504)
,p_name=>'APEX 5 - Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'App Builder'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::P1500_SHOW::'
,p_list_item_icon_alt_attribute=>'Drill-down App Builder'
,p_list_text_01=>'tab-app-builder'
,p_security_scheme=>wwv_flow_api.id(178922732459641711)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718943273407995467.4504)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Applicazioni di database'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::P1500_SHOW:DATABASE:'
,p_parent_list_item_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718943883204995467.4504)
,p_list_item_display_sequence=>125
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718944189936995467.4504)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Crea'
,p_list_item_link_target=>'f?p=4000:56:&SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID:'
,p_parent_list_item_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718944432315995467.4504)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Importa'
,p_list_item_link_target=>'f?p=4000:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_parent_list_item_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718944721611995468.4504)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Esporta'
,p_list_item_link_target=>'f?p=4000:523:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718945016998995468.4504)
,p_list_item_display_sequence=>155
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718945356605995468.4504)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Utility area di lavoro'
,p_parent_list_item_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718945606934995468.4504)
,p_list_item_display_sequence=>161
,p_list_item_link_text=>'Tutte le utility area di lavoro'
,p_list_item_link_target=>'f?p=4000:182:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718945356605995468.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718945931869995468.4504)
,p_list_item_display_sequence=>162
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(718945356605995468.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718946275988995468.4504)
,p_list_item_display_sequence=>163
,p_list_item_link_text=>'Impostazioni predefinite di App Builder'
,p_list_item_link_target=>'f?p=4000:800:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718945356605995468.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718946880982995469.4504)
,p_list_item_display_sequence=>165
,p_list_item_link_text=>'Temi area di lavoro'
,p_list_item_link_target=>'f?p=4000:763:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718945356605995468.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718947172203995469.4504)
,p_list_item_display_sequence=>166
,p_list_item_link_text=>'Gruppi di applicazioni'
,p_list_item_link_target=>'f?p=4000:722:&SESSION.::&DEBUG.:RP'
,p_parent_list_item_id=>wwv_flow_api.id(718945356605995468.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718947405431995469.4504)
,p_list_item_display_sequence=>167
,p_list_item_link_text=>'Viste Application Express'
,p_list_item_link_target=>'f?p=4000:714:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718945356605995468.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718947797973995469.4504)
,p_list_item_display_sequence=>168
,p_list_item_link_text=>unistr('Report tra pi\00F9 applicazioni')
,p_list_item_link_target=>'f?p=4000:9009:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718945356605995468.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718948053893995469.4504)
,p_list_item_display_sequence=>169
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(718942975810995460.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718948661756995469.4504)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'SQL Workshop'
,p_list_item_link_target=>'f?p=&APP_ID.:3002:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'Espansione SQL Workshop'
,p_list_text_01=>'tab-sql-workshop'
,p_security_scheme=>wwv_flow_api.id(178925305824656679)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_PAGE_ID not in (''1000'',''8000'',''35'', ''900'')'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718948931578995473.4504)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Browser oggetti'
,p_list_item_link_target=>'f?p=4500:1001:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718948661756995469.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718949244351995473.4504)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Comandi SQL'
,p_list_item_link_target=>'f?p=4500:1003:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718948661756995469.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718949564220995473.4504)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Script SQL'
,p_list_item_link_target=>'f?p=4500:1004:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718948661756995469.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Utility'
,p_parent_list_item_id=>wwv_flow_api.id(718948661756995469.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718950193664995473.4504)
,p_list_item_display_sequence=>241
,p_list_item_link_text=>'Tutte le utility'
,p_list_item_link_target=>'f?p=4500:1005:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718950494237995474.4504)
,p_list_item_display_sequence=>242
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718950770765995474.4504)
,p_list_item_display_sequence=>243
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718951036197995474.4504)
,p_list_item_display_sequence=>244
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=4500:1002:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713689787906400408.4504)
,p_list_item_display_sequence=>245
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(671093275370024819.4504)
,p_list_item_display_sequence=>246
,p_list_item_link_text=>'Data set di esempio'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718951379214995474.4504)
,p_list_item_display_sequence=>247
,p_list_item_link_text=>'Genera DDL'
,p_list_item_link_target=>'f?p=4500:12:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718951612512995475.4504)
,p_list_item_display_sequence=>248
,p_list_item_link_text=>'Valori predefiniti interfaccia utente'
,p_list_item_link_target=>'f?p=4500:813:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718953111014995475.4504)
,p_list_item_display_sequence=>249
,p_list_item_link_text=>'Confronto degli schemi'
,p_list_item_link_target=>'f?p=4500:1350:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718951913502995475.4504)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Metodi sulle tabelle'
,p_list_item_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120,124,125:::'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718953475468995475.4504)
,p_list_item_display_sequence=>251
,p_list_item_link_text=>'Cestino'
,p_list_item_link_target=>'f?p=4500:1070:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718952543303995475.4504)
,p_list_item_display_sequence=>252
,p_list_item_link_text=>'Report oggetti'
,p_list_item_link_target=>'f?p=4500:1042:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718952200472995475.4504)
,p_list_item_display_sequence=>253
,p_list_item_link_text=>'Informazioni sul database'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718952838487995475.4504)
,p_list_item_display_sequence=>254
,p_list_item_link_text=>'Controllo database'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(718949806921995473.4504)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718953707380995475.4504)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Servizi RESTful'
,p_list_item_link_target=>'f?p=4850:500:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(718948661756995469.4504)
,p_security_scheme=>wwv_flow_api.id(802775228359756685)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718954076139995475.4504)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Team Development'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon_alt_attribute=>'Espansione Team Development'
,p_list_text_01=>'tab-team-dev'
,p_security_scheme=>wwv_flow_api.id(173297929258927869)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718954361259995476.4504)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Etichette'
,p_list_item_link_target=>'f?p=4600:300:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(718954076139995475.4504)
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718954622790995476.4504)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Milestone'
,p_list_item_link_target=>'f?p=4600:200:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(718954076139995475.4504)
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718954973671995476.4504)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Modelli'
,p_list_item_link_target=>'f?p=4600:1000:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(718954076139995475.4504)
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718955247249995476.4504)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Utility'
,p_list_item_link_target=>'f?p=4600:2000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718954076139995475.4504)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718955815286995476.4504)
,p_list_item_display_sequence=>355
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(718954076139995475.4504)
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718956179077995477.4504)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Feedback'
,p_list_item_link_target=>'f?p=4650:8012:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(718954076139995475.4504)
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(718960334577995481.4504)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>'Galleria'
,p_list_item_link_target=>'f?p=4750:50:&APP_SESSION.'
,p_list_text_01=>'tab-apps'
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
,p_list_item_current_type=>'NEVER'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(940455082467897.4504)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1810634689405953.4504)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14848715049940930.4504)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(92000308707572422.4504)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99821386660888928.4504)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176118118407506807.4504)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592208708731709428.4504)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1272782587538879395.4504)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072762112712055.4504)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831722742580993878.4504)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917693824782940193.4504)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_sql_and_not_cloudy
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(7676404413799609.4504)
,p_name=>'Flow: SQL and not cloudy'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_authorization.is_authorized_developer (',
'           p_developer_authorization => ''SQL'' ) ',
'       and not wwv_flow_global.g_cloud;',
''))
,p_error_message=>unistr('Questa funzione non \00E8 disponibile.')
,p_reference_id=>786930698123107979.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/dashboard_access
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(10590808779171805.4504)
,p_name=>'Dashboard access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''ADMIN''',
'    )',
'    or wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''EDIT''',
'    );'))
,p_error_message=>unistr('Non si \00E8 autorizzati ad accedere ai dashboard e a Controlla attivit\00E0.')
,p_reference_id=>786936829326142579.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sso_authentication
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(11007909946539925.4504)
,p_name=>'SSO authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication not in (''APEX'',''CLOUD_IDM'',''LDAP'',''DB'');'
,p_error_message=>unistr('Builder SSO non \00E8 abilitato')
,p_reference_id=>6738410669854771.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sql_scripts_supported
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(11650706329157488.4504)
,p_name=>'SQL_SCRIPTS Supported'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return true;'
,p_error_message=>unistr('La funzionalit\00E0 di script SQL non \00E8 supportata in questa configurazione.')
,p_reference_id=>786931734190107980.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sql_scripts_not_supported
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(11800412655616562.4504)
,p_name=>'SQL_SCRIPTS NOT Supported'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return false;'
,p_error_message=>unistr('La visualizzazione DDL in linea non \00E8 supportata.')
,p_reference_id=>786931461585107980.4504
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(12506407035221692.4504)
,p_name=>'Flow: EDIT'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'Non si dispone dell''autorizzazione per modificare le applicazioni'
,p_reference_id=>12480509677812756.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(12520119493499631.4504)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>'Non si dispone dell''autorizzazione per amministrare le applicazioni'
,p_reference_id=>12511219858301010.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_sql
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(12524102140541924.4504)
,p_name=>'Flow: SQL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'Non si dispone dell''autorizzazione per utilizzare SQL Workshop'
,p_reference_id=>12523823826538734.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/ui_def_exists_for_object
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(20416908986150096.4504)
,p_name=>'UI_DEF_EXISTS_FOR_OBJECT'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_id',
'  from wwv_flow_hnt_table_info',
' where schema     = :OBJECT_OWNER',
'   and table_name = :OBJECT_NAME'))
,p_error_message=>'Errore.'
,p_reference_id=>786932671432107981.4504
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_data_loader
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(46496411771574510.4504)
,p_name=>'Flow: DATA_LOADER'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'DATA_LOADER'
,p_error_message=>'Non si dispone dell''autorizzazione per il Data Loader'
,p_reference_id=>786941042784190072.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit_or_sql
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(46619710624049700.4504)
,p_name=>'Flow: EDIT or SQL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT:SQL'
,p_error_message=>'Non si dispone dell''autorizzazione per modificare le applicazioni o usare SQL Workshop'
,p_reference_id=>46618038002026587.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(173297929258927869.4504)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>'Team Development non abilitato per questa area di lavoro'
,p_reference_id=>786516861027697723.4504
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_websheets_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178913128250981971.4504)
,p_name=>'APEX 5.0 Websheets Enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, wwv_flow_fnd_user u',
'where nvl(w.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'''))
,p_error_message=>'Nessun privilegio per l''operazione tentata'
,p_reference_id=>786517166823697723.4504
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178922732459641711.4504)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'Nessun privilegio per l''operazione tentata'
,p_reference_id=>786516029127697713.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178925305824656679.4504)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'Non si dispone dell''autorizzazione per utilizzare SQL Workshop'
,p_reference_id=>786516265251697717.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/registered_dba_login_and_db_monitor_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(206059717799303330.4504)
,p_name=>'REGISTERED_DBA_LOGIN and DB Monitor Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR''), ''N'') = ''N'' then',
'    wwv_flow_debug.trace(''ALLOW_DB_MONITOR disabled'');',
'    return false;',
'elsif :APP_PAGE_ALIAS=''DBA_LOGIN'' then',
'    if not wwv_flow_authorization.is_authorized_developer(''SQL'') then',
'        wwv_flow_debug.trace(''must have SQL privs on DBA_LOGIN page'');',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end if;',
'',
'for c1 in (select 1',
'             from sys.dba_role_privs',
'            where grantee      = :DBA_USERNAME',
'              and granted_role = ''DBA'')',
'loop',
'    return true;',
'end loop;',
'',
':F4500_DBA_LOGIN := ''N'';',
'',
'wwv_flow_utilities.redirect_url (',
'    p_url => ''f?p=''||:APP_ID||'':DBA_LOGIN:''||:SESSION||'':''||:APP_ID||'',''||:APP_PAGE_ID||'':''||:DEBUG);',
'',
'return true;'))
,p_error_message=>'Le pagine DBA sono disabilitate.'
,p_reference_id=>.4504
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/db_10_2_or_higher
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(239225402734254498.4504)
,p_name=>'db 10.2 or higher'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'   from sys.dba_objects',
' where object_name = ''SYS_PLSQL_SQL_INJECT_TAB''',
' and owner = ''SYS'''))
,p_error_message=>unistr('L''analisi Inserimento SQL non \00E8 supportata dalla versione o configurazione corrente del database. \00C8 disponibile solo per Oracle release 10.2 o successiva con i package Inserimento SQL installati.')
,p_reference_id=>786933222298107982.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/db_10_1_or_higher
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(240648913515910366.4504)
,p_name=>'db 10.1 or higher'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>'select 1 from dual'
,p_error_message=>unistr('Questa funzione \00E8 supportata dai database 10.1.')
,p_reference_id=>786932968525107981.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(802775228359756685.4504)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>'Nessun privilegio per l''operazione tentata'
,p_reference_id=>786519856057734816.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/service_requests_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(916236223411830688.4504)
,p_name=>'Service Requests Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>'Nessun privilegio per l''operazione tentata.'
,p_reference_id=>786932326296107981.4504
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(767165102345220885.4504)
,p_icon_sequence=>10
,p_icon_subtext=>'Area di lavoro &COMPANY.'
,p_icon_target=>'#'
,p_icon_image_alt=>'Area di lavoro &COMPANY.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(331786907421617643.4504)
,p_icon_sequence=>20
,p_icon_subtext=>'( <span style="text-decoration:underline;">Cambia area di lavoro</span> )'
,p_icon_target=>'f?p=4550:20'
,p_icon_image_alt=>'Cambia area di lavoro'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_security_scheme=>wwv_flow_api.id(11007909946539925)
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(160707630779049420.4504)
,p_icon_sequence=>30
,p_icon_image=>'Logout'
,p_icon_subtext=>'( <span style="text-decoration:underline;">Logout</span> )'
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>'Logout'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_poststate
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(1504518033640244.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_postState'
,p_process_sql_clob=>':P1002_OWNER := :APP_USER;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 10-JAN-2005 17:03:31'
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_rendertable
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(1916013849479713.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_renderTable'
,p_process_sql_clob=>'wwv_flow_query_builder.renderTableV2(:P1002_ID,:P1002_COUNT);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 11-JAN-2005 09:16:46'
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_object_feed
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(3934212967688584.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_object_feed'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_object_feed.getmoreObjects(',
'p_type    =>'';TABLE;VIEW'',',
'p_owner   =>:P1002_SCHEMA,',
'p_display =>''DIV'',',
'p_session   =>:SESSION,',
'p_onclick =>:P1002_ONCLICK,',
'p_Start   =>1,',
'p_stop    =>50000,',
'p_class   =>''ob_Object'');',
'wwv_flow.debug(''End'');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 13-JAN-2005 19:11:46'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_posthistory
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(6231903825594156.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_posthistory'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_buffer varchar2(32767) := null;',
'  l_amount number;',
'  l_offset number;',
'begin',
'  for c1 in (select command',
'             from wwv_flow_sw_sql_cmds',
'             where id = :P1201_HISTORY_ID',
'             and security_group_id = :flow_security_group_id)',
'  loop',
'      if c1.command is not null and sys.dbms_lob.getlength( c1.command ) > 0 then',
'          l_amount := 8000;',
'          l_offset := 1;',
'          begin',
'              loop',
'                  sys.dbms_lob.read( c1.command, l_amount, l_offset, l_buffer );',
'                  sys.htp.prn( l_buffer );',
'                  l_offset := l_offset + l_amount;',
'                  l_amount := 8000;',
'              end loop;',
'          exception',
'              when others then',
'                  null;',
'          end;',
'      end if;    ',
'      exit;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get history.'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 18-JAN-2005 12:49:22'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_postsavedsql
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(7139200190149482.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_postSavedSQL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_buffer varchar2(32767) := null;',
'  l_amount number;',
'  l_offset number;',
'begin',
'  for c1 in (select qb_sql, id, title, description',
'               from wwv_flow_qb_saved_query',
'              where id = :P1003_QUERY_ID',
'                and security_group_id = :flow_security_group_id)',
'',
'  loop',
'      :P1003_QUERY_ID := c1.id;',
'      :P1003_SAVE_NAME := c1.title;',
'      :P1003_SAVE_DESC := c1.description;',
'      if c1.qb_sql is not null and sys.dbms_lob.getlength( c1.qb_sql ) > 0 then',
'          l_amount := 8000;',
'          l_offset := 1;',
'          begin',
'              loop',
'                  sys.dbms_lob.read( c1.qb_sql, l_amount, l_offset, l_buffer );',
'                  sys.htp.prn( l_buffer );',
'                  l_offset := l_offset + l_amount;',
'                  l_amount := 8000;',
'              end loop;',
'          exception',
'              when others then',
'                  null;',
'          end;',
'      end if;    ',
'      exit;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get saved SQL.'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 19-JAN-2005 12:35:15'
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_get_saved_query
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(7276531262852173.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_get_saved_query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.owa_util.mime_header(''text/javascript'', FALSE );',
'sys.htp.p(''Cache-Control: no-cache'');',
'sys.htp.p(''Pragma: no-cache'');',
'sys.owa_util.http_header_close;',
'sys.htp.p(''var fUser ="''||:APP_USER||''";'');',
'wwv_flow_query_builder.loadQuery;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 19-JAN-2005 17:19:02'
);
end;
/
prompt --application/shared_components/logic/application_processes/ob_get_object_feed
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(11551302098165190.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'OB_GET_OBJECT_FEED'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_object_feed.getmoreObjects(',
'p_type    =>:P2001_FEED_TYPE,',
'p_owner   =>:P2001_FEED_OWNER,',
'p_Start   =>:P2001_FEED_START,',
'p_stop    =>:P2001_FEED_STOP,',
'p_display =>:P2001_FEED_DISPLAY,',
'p_session   =>:SESSION,',
'p_include =>:P2001_FEED_INCLUDE,',
'p_onclick =>:P2001_FEED_ONCLICK,',
'p_class  =>:P2001_FEED_CLASS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'This is for the Object Browser please do not change'
);
end;
/
prompt --application/shared_components/logic/application_processes/compile_plsql_code
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(12649800434223403.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'compile_plsql_code'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_status varchar2(32767);',
'',
'begin',
'',
'   for c1 in (',
'       select clob001 from htmldb_collections',
'       where collection_name = ''PLSQL_OBJECT_SOURCE''',
'   ) loop',
'       l_status := wwv_flow_plsql_editor.compile(',
'           wwv_flow_sw_api.valid_workspace_schema(:OBJECT_OWNER),',
'           :OBJECT_NAME, ',
'           :OBJECT_TYPE, ',
'           c1.clob001',
'       );',
'       sys.htp.p(l_status);',
'   end loop;',
'',
'   htmldb_collection.truncate_collection(',
'      p_collection_name => ''PLSQL_OBJECT_SOURCE'' ',
'   );',
'',
'exception',
'   when others then',
'      sys.htp.p(sqlerrm);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 31-JAN-2005 16:01:43'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_getbind
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(21627908860597925.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_getBind'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_new_binds varchar2(32700);',
'l_old_binds varchar2(32700);',
'begin',
'  l_new_binds := wwv_flow_sw_api.get_binds(',
'                     p_stmt     => :P1003_SQL_COMMAND2,',
'                     p_language => :P1003_CMD_LANGUAGE );',
'  l_old_binds := v(''P1200_BINDS''); ',
'',
'  if (l_new_binds is null) then',
'    return;',
'  else',
'    sys.htp.p(''l_new_binds ''||l_new_binds);',
'  end if;',
'  if l_new_binds = l_old_binds then ',
'    return;',
'  else',
'    wwv_flow.update_cache_with_write (',
'      p_name   => ''P1200_BINDS'',',
'      p_value  => l_new_binds );',
'    wwv_flow.update_cache_with_write (',
'      p_name   => ''P1200_BIND_VALS'',',
'      p_value  => '''');',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get binds'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 14-FEB-2005 19:57:28'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_buildsql
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(22896611795429544.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_buildSql'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- used by sc_core.js/sc_getSQL',
'declare ',
'  i number := 0;',
'  l_owner  varchar2(128) := wwv_flow_sw_api.valid_workspace_schema(v(''P139_OWNER''));',
'  l_object varchar2(128) := v(''P139_OBJECT'');',
'begin',
'  sys.htp.p(l_owner||''.''||l_object||'' ('');',
'  for c in ( select argument_name',
'               from sys.dba_arguments',
'              where owner = l_owner',
'                and (package_name||''.''||object_name = l_object',
'                     or object_name = l_object)',
'                and argument_name is not null',
'                and data_level = 0',
'                and nvl(overload,1) = 1',
'              order by position )',
'  loop',
'    if (i < 1) then',
'      sys.htp.p(c.argument_name ||'' => '');',
'      i := i+1;',
'    else',
'      sys.htp.p('',''||c.argument_name ||'' => '');',
'    end if;',
'  end loop;',
'  sys.htp.p('')'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 15-FEB-2005 20:29:24'
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_parsing
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(28056921387126354.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_parsing'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_status varchar2(255) := null;',
'begin',
'  wwv_flow_sw_parser.parse_file(p_file_id => :P1023_FILE_ID);',
'  if wwv_flow_sw_script.invalid_script(p_file_id => :P1023_FILE_ID) = 1 then',
'    l_status := ''FAILURE'';',
'  else',
'    l_status := ''SUCCESS'';',
'  end if;',
'  sys.htp.p(l_status);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to parse the script.'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 21-FEB-2005 15:36:28'
);
end;
/
prompt --application/shared_components/logic/application_processes/ob_fk_get_columns
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(29884608907915599.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ob_fk_get_columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_cols varchar(2000) := null;',
' counter number := 0;',
' l_upper varchar2(2000) := null;',
' l_owner wwv_flow_global.t_dbms_id := wwv_flow_sw_api.valid_workspace_schema(:OB_SCHEMA);',
'begin',
'  ',
'  select count(column_name) into counter',
'           from sys.dba_tab_columns',
'           where owner = upper(l_owner)',
'           and table_name  = :P145_FK_REF_TABLE;',
'  if (counter = 0)  then ',
'     :P145_FK_REF_TABLE := upper(:P145_FK_REF_TABLE);',
'     select count(column_name) into counter',
'     from sys.dba_tab_columns',
'     where owner = upper(l_owner)',
'     and table_name  = :P145_FK_REF_TABLE;',
'  end if;',
'     l_upper := :P145_FK_REF_TABLE;',
'',
'     for c1 in (select column_name  ',
'           from sys.dba_tab_columns',
'           where owner = upper(l_owner)',
'           and table_name  = :P145_FK_REF_TABLE) loop',
'        l_cols := l_cols||c1.column_name;',
'        l_cols := l_cols||'';'';',
'     end loop;',
'',
'if (counter = 0) then',
'  sys.htp.prn(''NONE'');',
'else',
'  sys.htp.prn(wwv_flow_escape.html(l_upper||'';''||l_cols));',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 22-FEB-2005 16:01:20'
);
end;
/
prompt --application/shared_components/logic/application_processes/returnnothing
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(77984007292719402.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ReturnNothing'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_save_script
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(106683007949808585.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_save_script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'           from htmldb_collections',
'           where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'    wwv_flow_sw_script.update_script_file (',
'     p_file_id     => c1.file_id,',
'     p_script_name => c1.name,',
'     p_script      => c1.script);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to update script.'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 23-FEB-2005 15:37:51'
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_create_script
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(108492501270666096.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_create_script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'             from htmldb_collections',
'             where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'    wwv_flow_sw_script.create_script_from_clob (        ',
'     p_script_name => c1.name,',
'     p_script      => c1.script);   ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create script.'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 25-FEB-2005 10:54:13'
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_dup_name
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(112585108113201529.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_dup_name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cnt          number := 0;  ',
'  l_current_id   number := null;',
'  l_new_filename varchar2(4000) := null;',
'  l_old_filename varchar2(4000) := null;',
'  l_existing_id  number := null;',
'  l_created_by   varchar2(255) := null;',
'  ',
'  l_flag         varchar2(255) := null;',
'begin',
'  l_new_filename := lower(v(''P60_SCRIPT_NAME''));',
'  l_old_filename := lower(v(''P60_OLD_SCRIPT_NAME''));',
'  l_current_id := v(''P60_FILE_ID'');',
'	',
'  if l_new_filename = nvl(l_old_filename,'''') then',
'     l_flag := ''SUCCESS'';	   ',
'  else',
'     for c1 in (select id, created_by',
'                from wwv_flow_files',
'                where lower(filename) = l_new_filename)',
'     loop',
'       l_cnt := l_cnt + 1;    ',
'       l_existing_id := c1.id;',
'       l_created_by := c1.created_by;',
'       exit;    ',
'     end loop;',
'     if l_cnt > 0 then',
'       if l_existing_id = nvl(l_current_id,0) then',
'         l_flag := ''SAVE_NEW'';',
'       else       	 ',
'         l_flag := ''FAIL'';',
'       end if;',
'       if upper(l_created_by) != upper(v(''APP_USER'')) then    	 ',
'           l_flag := ''FAIL_RENAME'';         ',
'       end if;       ',
'     else',
'     	l_flag := ''SAVE_NEW'';',
'     end if;',
'  end if;',
'  sys.htp.p(l_flag);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get duplicate script name.'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 03-MAR-2005 22:12:36'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_create_job
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(136604317027747819.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_create_job'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1003_JOBID := wwv_flow_sc_transactions.sc_create_job(:P1003_LANGUAGE);',
':P1003_AUTOCOMMIT := ''Y'';'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create job '
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 15-MAR-2005 19:03:39'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_remove_job
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(136605514734756665.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_remove_job'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_tid number ;',
'begin',
'  l_tid := wwv_flow_sc_transactions.add_trans(:SESSION, :FLOW_USER, ',
'                :P1003_SCHEMA,''STOP'', 0, '''', ''exit'');',
'  :P1003_JOBID := '''';',
' :P1003_AUTOCOMMIT := '''';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove job'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 15-MAR-2005 19:05:07'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_read_out
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(137030824141880927.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_read_out'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_out   clob;',
'  l_tid   number;',
'  lob_length     integer;',
'  read_amount    integer;',
'  read_offset    integer := 1;',
'  buffer         varchar2(32700);',
'begin',
'   l_tid := v(''P1200_STMT'');',
'   select transaction_result into l_out ',
'    from wwv_flow_sc_trans ',
'    where session_id = (select nv(''SESSION'') x from dual)',
'    and transaction_id = l_tid;',
'   if (length(l_out) > 0) then',
'     lob_length := length(l_out);',
'     while (lob_length > 0) loop',
'       if (lob_length > 32000) then',
'         read_amount := 32000;',
'       else ',
'         read_amount := lob_length;',
'       end if;',
'       sys.dbms_lob.read(l_out,read_amount,read_offset,buffer);',
'       sys.htp.p(wwv_flow_escape.noop(buffer));',
'       read_offset := read_offset+read_amount;',
'       lob_length := lob_length-read_amount;',
'     end loop;',
'   else',
'     sys.htp.p(''HTMLDB:NONE'');',
'   end if;',
'',
'exception when others then',
' sys.htp.p(''HTMLDB:NONE ERROR ''||wwv_flow_escape.html(SQLERRM));',
' sys.htp.p(''HTMLDB:NONE ERROR ''||wwv_flow_escape.html(SQLERRM));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to read output'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 16-MAR-2005 09:19:10'
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_replace_script
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(138449522524133557.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_replace_script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'             from htmldb_collections',
'             where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'      for c2 in (select id',
'                 from wwv_flow_files',
'                 where lower(filename) = lower(c1.name)',
'                 and file_type = ''SCRIPT'')',
'      loop',
'          l_file_id := c2.id;',
'          exit;',
'      end loop; ',
'      if l_file_id is not null then          	',
'        wwv_flow_sw_script.update_script_file (',
'         p_file_id     => l_file_id,',
'         p_script_name => c1.name,',
'         p_script      => c1.script);',
'      end if;',
'  end loop;',
'end;  '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to replace script.'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 17-MAR-2005 16:34:36'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_read_dbms
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(140873708217846868.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_read_dbms'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_out   clob;',
'  l_tid   number;',
'begin',
'   l_tid := v(''P1200_STMT'');',
'   select transaction_output into l_out from wwv_flow_sc_trans ',
'   where session_id = :SESSION and transaction_id = l_tid;',
'   if length(l_out) > 0 then',
'     sys.htp.p(wwv_flow_escape.noop(l_out));',
'   else',
'     sys.htp.p(''HTMLDB:NONE'');',
'   end if;',
'exception when others then',
' sys.htp.p(''HTMLDB:NONE'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to read output'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 21-MAR-2005 17:00:09'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_sql_trans
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(141051327945527301.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_sql_trans'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_tid number;',
'begin',
'l_tid := wwv_flow_sc_transactions.add_trans (',
'    p_session => :SESSION,',
'    p_user    => :FLOW_USER,',
'    p_schema  => wwv_flow_sw_api.valid_workspace_schema(:P1003_SCHEMA),',
'    p_type    => :P1200_TYPE,',
'    p_rows    => :P1003_ROWS,',
'    p_binds   => :P1200_BIND_VALS,',
'    p_sql     => wwv_flow_sw_api.to_sql_command(wwv_flow.g_f01) );',
'sys.htp.prn(l_tid);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to load SQL trans'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 21-MAR-2005 21:40:14'
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_savequery
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(158194723674245313.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_saveQuery'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.sc_savequery (',
'    p_name     => :P1003_SAVE_NAME,',
'    p_desc     => :P1003_SAVE_DESC,',
'    p_query_id => :P1003_QUERY_ID,',
'    p_schema   => :P1003_SCHEMA,',
'    p_sql_command => :P1003_SQL_COMMAND2 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save Query'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 04-APR-2005 16:26:34'
);
end;
/
prompt --application/shared_components/logic/application_processes/ob_postid
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(171513520394208759.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ob_postId'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(:OBJECT_OWNER); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
);
end;
/
prompt --application/shared_components/logic/application_processes/ob_add_fk
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(172369000165936003.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ob_add_fk'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_counter number;',
'  l_id      number;',
'  l_error   number := 0;',
'  l_name  varchar2(255);',
'  l_schema varchar2(255);',
'  l_c001  varchar2(255);',
'  l_err_txt varchar2(2000) := ''<!-- HTMLDB:ERROR --><div class="htmldbNotification"><ul>'';',
'begin',
' if v(''P145_FK_NAME'') is null then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_FK_NAME_NOT_NULL'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
' if v(''P145_FROM_COLS'') is null then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_FK_SEL_COLS'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
' if v(''P145_FK_REF_TABLE'') is null then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_FK_REF_TAB'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
' if v(''P145_TO_COLS'') is null then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_FK_REF_COLS'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
'',
'l_c001 := upper(v(''P145_FK_NAME''));',
'',
' select count(*) into l_counter    ',
' from wwv_flow_collections        ',
' where collection_name = ''TBL_WIZ_FKS''',
'  and c001 = l_c001;',
' if l_counter > 0 then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_FK_NAME_USED'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
'',
'l_name := upper(v(''P145_FK_NAME''));',
'l_schema := v(''P145_SCHEMA'');',
'',
' select count(*) into l_counter    ',
' from sys.dba_objects',
' where object_name = l_name and owner = l_schema;',
'',
' if l_counter > 0 then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_FK_NAME_USED'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
'',
' l_err_txt := l_err_txt||''</ul></div>'';',
'',
' if l_error = 1 then ',
'   sys.htp.p(l_err_txt);',
' else',
'   begin',
'     wwv_flow_collection.create_collection(''TBL_WIZ_FKS'');',
'   exception ',
'     when others then null;',
'   end;',
'   l_id := wwv_flow_collection.add_member(',
'            p_collection_name => ''TBL_WIZ_FKS'',',
'            p_c001          => upper(v(''P145_FK_NAME'')),',
'            p_c002          => v(''P145_FROM_COLS''),',
'            p_c003          => v(''P145_FK_REF_TABLE''),',
'            p_c004          => v(''P145_TO_COLS''),',
'            p_c005          => v(''P145_FK_ACTION''));',
'',
'    sys.htp.prn(''<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" role="presentation" id="htmldbNewTable"><tbody>'');',
'    sys.htp.prn(''<tr><th class="tableheader2">''||    ',
'     wwv_flow_lang.system_message(''OB_FK_NAME'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''CREATE_CONDITION.COLUMNS'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''OB_FK_REFERENCED'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''OB_FK_REFERENCED_TAB'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''DEMO_APPLICATION.ACTION'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||''&nbsp;''||''</th>'');',
'    sys.htp.p(''</tr>'');',
'',
'for c1 in (select seq_id,c001, c002, c003,c004,c005',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_FKS''',
'                order by seq_id) loop',
'    sys.htp.prn(''<tr id="fkTab_''||c1.seq_id||''">'');',
'    sys.htp.prn(''<td>''||c1.c001||''</td>'');',
'    sys.htp.prn(''<td>''||c1.c002||''</td>'');',
'    sys.htp.prn(''<td>''||c1.c003||''</td>'');',
'    sys.htp.prn(''<td>''||c1.c004||''</td>'');',
'    sys.htp.prn(''<td>'');',
'    if c1.c005 = ''C'' then',
'      sys.htp.prn(wwv_flow_lang.system_message(''OB_CASCADE_DELETE'')||''</td>'');',
'    elsif c1.c005 = ''N'' then',
'      sys.htp.prn(wwv_flow_lang.system_message(''OB_SET_NULL'')||''</td>'');',
'    else',
'      sys.htp.prn(wwv_flow_lang.system_message(''SQL_REPORT_WIZ.DEFAULT'')||''</td>'');',
'    end if;',
'    sys.htp.prn(''<td style="text-align: center;" class="htmldbPseudoButton">'');',
'    sys.htp.prn(''<img src="#IMAGE_PREFIX#delete.gif" onclick="ob_rmFkRow('');',
'    sys.htp.prn(c1.seq_id||'')" /></td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'    sys.htp.p(''</tbody></table>'');',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Process'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 21-APR-2005 15:55:00'
);
end;
/
prompt --application/shared_components/logic/application_processes/ob_rm_fk_row
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(172867829404455433.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ob_rm_fk_row'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  HTMLDB_COLLECTION.DELETE_MEMBER(',
'    p_collection_name => ''TBL_WIZ_FKS'' ,',
'    p_seq             => :P145_FK_SEQ );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to process'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 21-APR-2005 17:21:35'
);
end;
/
prompt --application/shared_components/logic/application_processes/ob_add_cons
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(176127519858657209.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ob_add_cons'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_counter number;',
'  l_id      number;',
'  l_error   number := 0;',
'  l_err_txt varchar2(2000) := ''<!-- HTMLDB:ERROR --><div class="htmldbNotification"><ul>'';',
'  l_name    varchar2(2000) := upper(V(''P149_NAME''));',
'begin',
' if v(''P149_NAME'') is null then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_CONS_NAME_NN'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
' if (v(''P149_CONST_TYPE'') = ''U'' and v(''P149_SEL_COLS'') is null) then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_UK_COLS'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
' if (v(''P149_CONST_TYPE'') = ''C'' and v(''P149_CHECK'') is null) then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_CHECK_CON_NN'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
'',
' select count(*) into l_counter    ',
' from wwv_flow_collections        ',
' where collection_name = ''TBL_WIZ_CONS''',
'  and c001 = l_name;',
' if l_counter > 0 then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_CONS_NAME_USED'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
'',
' select count(*) into l_counter    ',
' from sys.dba_objects',
' where object_name = l_name;',
' if l_counter > 0 then',
'  l_err_txt := l_err_txt||''<li>'';',
'  l_err_txt := l_err_txt||wwv_flow_lang.system_message(''OB_CONS_NAME_USED'');',
'  l_err_txt := l_err_txt||''</li>'';',
'  l_error := 1;',
' end if;',
'',
' l_err_txt := l_err_txt||''</ul></div>'';',
'',
' if l_error = 1 then ',
'   sys.htp.p(l_err_txt);',
' else',
'   begin',
'     wwv_flow_collection.create_collection(''TBL_WIZ_CONS'');',
'   exception ',
'     when others then null;',
'   end;',
'   l_id := wwv_flow_collection.add_member(',
'                    p_collection_name => ''TBL_WIZ_CONS'',',
'                    p_c001          => upper(v(''P149_NAME'')),',
'                    p_c002          => v(''P149_CONST_TYPE''),',
'                    p_c003          => v(''P149_SEL_COLS''),',
'                    p_c004          => v(''P149_CHECK'') );',
'',
'',
'    sys.htp.prn(''<table cellpadding="0" cellspacing="0" class="htmldbStandard3"                ',
'      border="0" role="presentation" id="htmldbNewTable"><tbody>'');',
'    sys.htp.prn(''<tr><th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''OB_CONSTRAINT_NAME'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''PAGE_REGION.TREE_TYPE'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''OB_CONS_INFO'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||''&nbsp;''||''</th>'');',
'    sys.htp.p(''</tr>'');',
'',
'  for c1 in (select seq_id,c001, c002, c003, c004',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_CONS''',
'                and c001 is not null',
'                order by seq_id ) loop',
'    sys.htp.prn(''<tr id="consTab_''||c1.seq_id||''">'');',
'    sys.htp.prn(''<td>''||c1.c001||''</td>'');',
'    if c1.c002 = ''C'' then',
'      sys.htp.prn(''<td>''||wwv_flow_lang.system_message(''F4500_CHECK'')||''</td>'');',
'      sys.htp.prn(''<td>''||c1.c004||''</td>'');',
'    else',
'      sys.htp.prn(''<td>''||wwv_flow_lang.system_message(''F4500_UNIQUE'')||''</td>'');',
'      sys.htp.prn(''<td>''||c1.c003||''</td>'');',
'    end if;',
'    sys.htp.prn(''<td style="text-align: center;" class="htmldbPseudoButton">'');',
'    sys.htp.prn(''<img src="#IMAGE_PREFIX#delete.gif" onclick="ob_rmConsRow('');',
'    sys.htp.prn(c1.seq_id||'')" /></td>'');',
'    sys.htp.p(''</tr>'');',
'  end loop;',
'',
'    sys.htp.p(''</table>'');',
' end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to process'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 26-APR-2005 14:35:13'
);
end;
/
prompt --application/shared_components/logic/application_processes/ob_rm_cons_row
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(176138206577719675.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ob_rm_cons_row'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  HTMLDB_COLLECTION.DELETE_MEMBER(',
'    p_collection_name => ''TBL_WIZ_CONS'' ,',
'    p_seq             => :P149_CONS_SEQ',
'  );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to process'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 26-APR-2005 14:45:37'
);
end;
/
prompt --application/shared_components/logic/application_processes/check_avail_jobs
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(192446004690296352.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check_avail_jobs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_jobs number;',
'begin',
'  select value-(select count(*) from sys.dba_jobs) into l_jobs  ',
'  from v$parameter ',
'  where name = ''job_queue_processes'';',
'  sys.htp.prn(l_jobs);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get job status'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 10-MAY-2005 16:28:24'
);
end;
/
prompt --application/shared_components/logic/application_processes/spotlightindex
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(233722337928545821.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'spotlightIndex'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_spotlight_dev.emit_spotlight_index(',
'    p_app_id           => wwv_flow.g_x01,',
'    p_get_apps_list    => wwv_flow.g_x02);'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
end;
/
prompt --application/shared_components/logic/application_processes/check_job_queue
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(251183224917806135.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check_job_queue'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_jobs number;',
'begin',
'  select value into l_jobs  ',
'  from v$parameter ',
'  where name = ''job_queue_processes'';',
'  sys.htp.prn(l_jobs);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to check jobs'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 23-MAY-2005 11:26:42'
);
end;
/
prompt --application/shared_components/logic/application_processes/get_message
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(251509908846066406.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_message'
,p_process_sql_clob=>'sys.htp.p(wwv_flow_lang.system_message(:SYSTEM_MESSAGE));'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get message.'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_process_comment=>'created 23-MAY-2005 12:10:05'
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_check_unique
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(266120031373725934.4504)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_check_unique'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_counter number;',
'begin',
'',
'  select count(*) into l_counter ',
'  from wwv_flow_qb_saved_query ',
'  where title = v(''P1002_QUERY_NAME'') ',
'   and created_by = v(''FLOW_USER'')',
'   and security_group_id = wwv_flow_security.g_security_group_id;',
'',
'  if (l_counter > 0) then',
'   sys.htp.p(''<div class="htmldbNotification"><ul><li>'');',
'   sys.htp.p(wwv_flow_lang.system_message(''QB_DUPLICATE_QUERY''));',
'   sys.htp.p(''</li></ul></div>'');',
'  else',
'    sys.htp.prn(''0'');',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to validate save'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
,p_process_comment=>'created 20-JUN-2005 14:13:20'
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(5086354147.4504)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/current_object_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(63888631031213062.4504)
,p_name=>'CURRENT_OBJECT_ID'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/dba_username
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(25966015567654518.4504)
,p_name=>'DBA_USERNAME'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4500_dba_login
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(206052124417257915.4504)
,p_name=>'F4500_DBA_LOGIN'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4500_last_view
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(48602367732370754.4504)
,p_name=>'F4500_LAST_VIEW'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4500_p502_object_type
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(240551529397730482.4504)
,p_name=>'F4500_P502_OBJECT_TYPE'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(22437001853024837.4504)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by Custom2 authentication for deep linking support'
);
end;
/
prompt --application/shared_components/logic/application_items/g_ctrl_file_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(34319320571482284.4504)
,p_name=>'G_CTRL_FILE_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/g_user_default_date_format
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(367331519540068469.4504)
,p_name=>'G_USER_DEFAULT_DATE_FORMAT'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/last_selected_parse_as
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(101416805412462518.4504)
,p_name=>'LAST_SELECTED_PARSE_AS'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This is used to support public synonyms.  Supporting public synonym is on hold until R2.'
);
end;
/
prompt --application/shared_components/logic/application_items/last_step
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(48607820040821755.4504)
,p_name=>'LAST_STEP'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/object_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(12255104688621266.4504)
,p_name=>'OBJECT_ID'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/object_locker
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(12255530314628639.4504)
,p_name=>'OBJECT_LOCKER'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/object_name
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(12255902395630078.4504)
,p_name=>'OBJECT_NAME'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/object_owner
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(12256308628631835.4504)
,p_name=>'OBJECT_OWNER'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/object_type
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(12258200626676850.4504)
,p_name=>'OBJECT_TYPE'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ob_object_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(171514813299244598.4504)
,p_name=>'OB_OBJECT_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/success_msg
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(106656207167489750.4504)
,p_name=>'SUCCESS_MSG'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This application item is used to display success message for certain SQL Workshop regions. (Used from SQL Command Processor page 3 and page 1)'
);
end;
/
prompt --application/shared_components/logic/application_items/system_message
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(251508117719059591.4504)
,p_name=>'SYSTEM_MESSAGE'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Message displayed while running commands in SQL Commands. Message is retrieved using on-demand process "get_message".'
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(5088358914.4504)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Impossibile calcolare il nome dell''area di lavoro.'
);
end;
/
prompt --application/shared_components/logic/application_computations/g_user_default_date_format
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(367332002718076269.4504)
,p_computation_sequence=>10
,p_computation_item=>'G_USER_DEFAULT_DATE_FORMAT'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_date_format varchar2(255);',
'begin',
'    for c1 in (select default_date_format',
'                 from wwv_flow_fnd_user',
'                where user_name = :APP_USER',
'                  and security_group_id = :flow_security_group_id',
'                  and trim(default_date_format) is not null) loop',
'        return c1.default_date_format;',
'        exit;',
'    end loop;',
'    --',
'    return :DATE_FORMAT;',
'end;'))
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/accessibility_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(582053521006435152.4504)
,p_lov_name=>'ACCESSIBILITY_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(582053521006435152.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(582053811202435157.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lettore di schermo'
,p_lov_return_value=>'SCREEN_READER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/access_restrictions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(21837016666086569.4504)
,p_lov_name=>'ACCESS_RESTRICTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(21837016666086569.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21837217288086572.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disponibile solo dal server locale'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21837410790086575.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disponibile dal server locale e dai client remoti'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/active_inactive
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(133833120564560201.4504)
,p_lov_name=>'ACTIVE INACTIVE'
,p_lov_query=>'.'||wwv_flow_api.id(133833120564560201.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(133833301814560204.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Attivo'
,p_lov_return_value=>'ACTIVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(133833501889560209.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Inattivo'
,p_lov_return_value=>'INACTIVE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/alignment_left_right
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(40606619495197864.4504)
,p_lov_name=>'ALIGNMENT LEFT RIGHT'
,p_lov_query=>'.'||wwv_flow_api.id(40606619495197864.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40606830354197883.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'A sinistra'
,p_lov_return_value=>'L'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40607009987197887.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'A destra'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/all_or_varchar2_column_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88068725864843110.4504)
,p_lov_name=>'ALL.OR.VARCHAR2.COLUMN.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(88068725864843110.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88068924929843115.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tutti i tipi di colonna'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88069124491843115.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Tipi di colonna VARCHAR'
,p_lov_return_value=>'0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/all_selected_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88062000322816814.4504)
,p_lov_name=>'ALL.SELECTED.COLS'
,p_lov_query=>'.'||wwv_flow_api.id(88062000322816814.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88062216112816814.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tutte le colonne'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88062421264816815.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Colonne selezionate'
,p_lov_return_value=>'SELECTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/analyze_opts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88060821315813411.4504)
,p_lov_name=>'ANALYZE.OPTS'
,p_lov_query=>'.'||wwv_flow_api.id(88060821315813411.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88061023444813411.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Calcola statistiche'
,p_lov_return_value=>'COMPUTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88061212749813412.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Stima statistiche'
,p_lov_return_value=>'ESTIMATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88061405135813412.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Convalida struttura'
,p_lov_return_value=>'VALIDATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_dictionary_query_conditions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14480503854514923.4504)
,p_lov_name=>'APEX DICTIONARY QUERY CONDITIONS'
,p_lov_query=>'.'||wwv_flow_api.id(14480503854514923.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14480728931514923.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'='
,p_lov_return_value=>'='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14480909767514923.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'!='
,p_lov_return_value=>'!='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14481110010514923.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'LIKE'
,p_lov_return_value=>'LIKE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14493818099547338.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'NOT LIKE'
,p_lov_return_value=>'NOT LIKE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14482210780516882.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'>'
,p_lov_return_value=>'>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14482613551517732.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'<'
,p_lov_return_value=>'<'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14608723770258677.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'BETWEEN'
,p_lov_return_value=>'BETWEEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14609025848259268.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'IS'
,p_lov_return_value=>'IS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_dictionary_view_modes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14392800214125907.4504)
,p_lov_name=>'APEX DICTIONARY VIEW MODES'
,p_lov_query=>'.'||wwv_flow_api.id(14392800214125907.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14393015881125907.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Icone'
,p_lov_return_value=>'ICONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14393201164125907.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Struttura'
,p_lov_return_value=>'TREE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14393419313125907.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_view_names
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14454808001440421.4504)
,p_lov_name=>'APEX VIEW NAMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct apex_view_name d,',
'       apex_view_name r',
' from apex_dictionary ',
'where column_id=0',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/asc_desc_returns_asc_desc
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88023114905423598.4504)
,p_lov_name=>'ASC.DESC.RETURNS.ASC.DESC'
,p_lov_query=>'.'||wwv_flow_api.id(88023114905423598.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88023312120423599.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Crescente'
,p_lov_return_value=>'ASC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88023515635423599.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Decrescente'
,p_lov_return_value=>'DESC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ascdesc
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23484408692637977.4504)
,p_lov_name=>'ASCDESC'
,p_lov_query=>'.'||wwv_flow_api.id(23484408692637977.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23484707046637977.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Crescente'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23484911662637978.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Decrescente'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/autocommit
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(136789232141518670.4504)
,p_lov_name=>'AUTOCOMMIT'
,p_lov_query=>'.'||wwv_flow_api.id(136789232141518670.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(136789414003518672.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Commit automatico'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cascade_checkbox
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6527926084636289.4504)
,p_lov_name=>'CASCADE CHECKBOX'
,p_lov_query=>'.'||wwv_flow_api.id(6527926084636289.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6528129949636292.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp'
,p_lov_return_value=>'CASCADE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cascade_constraints
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88063516252821367.4504)
,p_lov_name=>'CASCADE.CONSTRAINTS'
,p_lov_query=>'.'||wwv_flow_api.id(88063516252821367.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88063706191821368.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vincoli a catena?'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/case_sensitive_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88013722767293437.4504)
,p_lov_name=>'CASE.SENSITIVE.Y'
,p_lov_query=>'.'||wwv_flow_api.id(88013722767293437.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88013930765293438.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Con distinzione tra maiuscole e minuscole'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_for_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(12319218872723617.4504)
,p_lov_name=>'CHECKBOX FOR VIEWS'
,p_lov_query=>'.'||wwv_flow_api.id(12319218872723617.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12319426920723618.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Viste'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/constraint_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8657002398372817.4504)
,p_lov_name=>'CONSTRAINT TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(8657002398372817.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8657206568372817.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Controlla'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8657415834372818.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Chiave primaria'
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8657606976372818.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Univocit\00E0')
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8657818917372818.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Referenziale'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/constraint_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(11518010813871302.4504)
,p_lov_name=>'CONSTRAINT.STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(11518010813871302.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11518205871871344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Abilitato'
,p_lov_return_value=>'ENABLED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11518415817871364.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabilitato'
,p_lov_return_value=>'DISABLED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11518621543871364.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Tutto'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/constraint_types_002
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88046920202557653.4504)
,p_lov_name=>'CONSTRAINT.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(88046920202557653.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88047118047557654.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Controlla'
,p_lov_return_value=>'CHECK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88047308153557654.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Chiave esterna'
,p_lov_return_value=>'FK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88047511353557655.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Chiave primaria'
,p_lov_return_value=>'PK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88047724693557655.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Unique'
,p_lov_return_value=>'UNIQUE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/contraint_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(270341627024745223.4504)
,p_lov_name=>'CONTRAINT TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(270341627024745223.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(270341802062745225.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Controlla'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(270342021056745226.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Univocit\00E0')
,p_lov_return_value=>'U'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_index_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16028009107759017.4504)
,p_lov_name=>'CREATE INDEX TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(16028009107759017.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16028212649759018.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normale'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16028407362759020.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Testo'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1800436823219905.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Spaziale'
,p_lov_return_value=>'S'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_db_version.c_has_locator'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_package_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14616623348446893.4504)
,p_lov_name=>'CREATE PACKAGE OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(14616623348446893.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14616819122446896.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Specifica'
,p_lov_return_value=>'SPEC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14617002053446897.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Corpo'
,p_lov_return_value=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16842100401146005.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Package con metodi su tabella/e di database'
,p_lov_return_value=>'TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_user_privileges
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(164684400772980444.4504)
,p_lov_name=>'CREATE USER PRIVILEGES'
,p_lov_query=>'.'||wwv_flow_api.id(164684400772980444.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164684601746980447.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'CONNECT'
,p_lov_return_value=>'CONNECT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164684816646980450.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'RESOURCE'
,p_lov_return_value=>'RESOURCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164685019181980451.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'DBA'
,p_lov_return_value=>'DBA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_wizard_p200
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(30039215638453183.4504)
,p_lov_name=>'CREATE WIZARD P200'
,p_lov_query=>'.'||wwv_flow_api.id(30039215638453183.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30039406403453188.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Applicazione Websheet'
,p_lov_return_value=>'WEBSHEET'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4900:205:&SESSION.::NO:200,205:P2_ID:"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" width="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a><br /><br />'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30039600349453191.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Applicazione di database personalizzata'
,p_lov_return_value=>'APPLICATION'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:56:&SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID:%2C"><img src="#IMAGE_PREFIX#menu/wiz_blank_140x90.gif" height="90" width="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIc'
||'ons" /></a><br /><br />'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30040019895453191.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Oggetto database'
,p_lov_return_value=>'DATABASE_OBJECT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4500:1001:&SESSION."><img src="#IMAGE_PREFIX#menu/wiz_blank_140x90.gif" height="90" width="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a><br /><br />'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_package_how
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88084232331986937.4504)
,p_lov_name=>'CREATE.PACKAGE.HOW'
,p_lov_query=>'.'||wwv_flow_api.id(88084232331986937.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88084409721986937.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Creazione di un package completamente nuovo'
,p_lov_return_value=>'SCRATCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88084631917986937.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Creazione di un package con metodi sulla tabella o sulle tabelle del database'
,p_lov_return_value=>'TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_table_how
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88092414548047979.4504)
,p_lov_name=>'CREATE.TABLE.HOW'
,p_lov_query=>'.'||wwv_flow_api.id(88092414548047979.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88092609025047979.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Completamente nuovo/a'
,p_lov_return_value=>'SCRATCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88092810507047980.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Con operazione di copia/incolla da un foglio di calcolo (verr\00E0 aperto Data Workshop)')
,p_lov_return_value=>'SPREADSHEET'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_table_now_script
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88093424937050988.4504)
,p_lov_name=>'CREATE.TABLE.NOW.SCRIPT'
,p_lov_query=>'.'||wwv_flow_api.id(88093424937050988.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88093602555050989.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Crea tabella ora'
,p_lov_return_value=>'RUN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88093808384050989.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Crea uno script per la modifica SQL'
,p_lov_return_value=>'EDIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_table_fk_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(111182618715174982.4504)
,p_lov_name=>'CREATE_TABLE_FK_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(111182618715174982.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(245703827624645868.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Non consentire eliminazione'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(111183005880174986.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Eliminazione a catena'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(111182804604174985.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Imposta su null se eliminato'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_csv_col_delimiter
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3927422505659936.4504)
,p_lov_name=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov_query=>'.'||wwv_flow_api.id(3927422505659936.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3927758348659940.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>','
,p_lov_return_value=>','
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3928144847659940.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>';'
,p_lov_return_value=>';'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3928530804659940.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'|'
,p_lov_return_value=>'|'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4182031389753526.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'#'
,p_lov_return_value=>'#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3928907085659940.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'tab'
,p_lov_return_value=>'tab'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_csv_enclosed_by
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3931221323686172.4504)
,p_lov_name=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov_query=>'.'||wwv_flow_api.id(3931221323686172.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4083926401630096.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nessuno'
,p_lov_return_value=>'None'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3931589877686177.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'"'
,p_lov_return_value=>'"'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3931843915686177.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>''''
,p_lov_return_value=>''''
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_data_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84321549291630718.4504)
,p_lov_name=>'DATA.LOAD.DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84321549291630718.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84321869333630699.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84322205066630696.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84322661858630696.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84323012454630696.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'TIMESTAMP'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84323403277630695.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84323862951630695.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'TIMESTAMP WITH TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84324206688630695.4504)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_first_line
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3934090607812623.4504)
,p_lov_name=>'DATA.LOAD.FIRST_LINE'
,p_lov_query=>'.'||wwv_flow_api.id(3934090607812623.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3934379444812623.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Prima riga con intestazioni'
,p_lov_return_value=>'HEADERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_force_sysguid
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(325824092198610958.4504)
,p_lov_name=>'DATA.LOAD.FORCE_SYSGUID'
,p_lov_query=>'.'||wwv_flow_api.id(325824092198610958.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(325824367791610958.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SYS_GUID'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(325824735376610959.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Colonna identit\00E0')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_max_row_range
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3867907456164412.4504)
,p_lov_name=>'DATA.LOAD.MAX_ROW_RANGE'
,p_lov_query=>'.'||wwv_flow_api.id(3867907456164412.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3868668632164428.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3870258934164431.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3870691602164431.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3925900413184232.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Tutte le righe'
,p_lov_return_value=>'0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_source_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(212732804335774230.4504)
,p_lov_name=>'DATA.LOAD.SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(212732804335774230.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(212733137832774240.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Carica un file'
,p_lov_return_value=>'FILE'
,p_lov_template=>'<span class="a-Icon icon-file-upload" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(212733551391774249.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Copia e incolla'
,p_lov_return_value=>'COPY_PASTE'
,p_lov_template=>'<span class="a-Icon icon-clipboard" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3891423527523942.4504)
,p_lov_name=>'DATA.LOAD.STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(3891423527523942.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3891740585523942.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'In esecuzione'
,p_lov_return_value=>'RUNNING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3892162613523943.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Terminato'
,p_lov_return_value=>'FINISHED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3924280979996980.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Non riuscito'
,p_lov_return_value=>'FAILED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_use_data_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2791739671154769.4504)
,p_lov_name=>'DATA.LOAD.USE_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(2791739671154769.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2792061691154772.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Usa i tipi di dati della colonna'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_upload_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1643936135665207.4504)
,p_lov_name=>'DATA.UPLOAD.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(1643936135665207.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1644247579665210.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Carica un file'
,p_lov_return_value=>'FILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1644613825665214.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Copia e incolla'
,p_lov_return_value=>'COPY_PASTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(21015224563508746.4504)
,p_lov_name=>'DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(21015224563508746.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21015508059508749.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21015722350508750.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21015902475508751.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21016106513508751.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'TIMESTAMP'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21016525754508751.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21016725005508751.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'BLOB'
,p_lov_return_value=>'BLOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24123119765584645.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'BFILE'
,p_lov_return_value=>'BFILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21016327140508751.4504)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'CHAR'
,p_lov_return_value=>'CHAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24128605267608850.4504)
,p_lov_disp_sequence=>85
,p_lov_disp_value=>'FLOAT'
,p_lov_return_value=>'FLOAT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24122330370578271.4504)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'INTERVAL YEAR TO MONTH'
,p_lov_return_value=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24122503489579932.4504)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'INTERVAL DAY TO SECOND'
,p_lov_return_value=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24121914440573626.4504)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'TIMESTAMP WITH TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24122121020575524.4504)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21019413051524343.4504)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'BINARY_FLOAT'
,p_lov_return_value=>'BINARY_FLOAT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21019722401527136.4504)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'BINARY_DOUBLE'
,p_lov_return_value=>'BINARY_DOUBLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24122707991581257.4504)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'RAW'
,p_lov_return_value=>'RAW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24122911108582116.4504)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'LONG RAW'
,p_lov_return_value=>'LONG RAW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24128400765607550.4504)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'NCHAR'
,p_lov_return_value=>'NCHAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21016914224508752.4504)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'NVARCHAR2'
,p_lov_return_value=>'NVARCHAR2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24138600492263086.4504)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'NCLOB'
,p_lov_return_value=>'NCLOB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_session_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1225013363619314377.4504)
,p_lov_name=>'DB SESSION STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(1225013363619314377.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1225013668008314381.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sessione corrente'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1225013946804314386.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Transazione di lunga durata'
,p_lov_return_value=>'L'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1225014259544314386.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Sessione attiva'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1225014590119314386.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Sessione inattiva'
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1225014814217314386.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Sessione di blocco'
,p_lov_return_value=>'B'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1225015134770314386.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Sessioni bloccate'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_parm_non_default
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244335514951659559.4504)
,p_lov_name=>'DB_PARM_NON_DEFAULT'
,p_lov_query=>'.'||wwv_flow_api.id(244335514951659559.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244335715591659561.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tutto'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244335932066659565.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Non predefinito'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ddl_actions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88039608166535203.4504)
,p_lov_name=>'DDL.ACTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(88039608166535203.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88039800819535204.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Aggiungi colonna'
,p_lov_return_value=>'ADD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88040002165535204.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Aggiungi vincolo'
,p_lov_return_value=>'ADD_CONSTRAINT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88040231651535205.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Analizza'
,p_lov_return_value=>'ANALYZE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88040417249535205.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Copia'
,p_lov_return_value=>'COPY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88040624827535205.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Crea indice'
,p_lov_return_value=>'INDEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88040822124535205.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Crea indice di testo'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88041012331535206.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Crea trigger'
,p_lov_return_value=>'CREATE_TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88041229308535206.4504)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Disabilita vincolo'
,p_lov_return_value=>'DISABLE_CONSTRAINT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88041400926535206.4504)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Disabilita trigger'
,p_lov_return_value=>'DISABLE_TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88041603607535208.4504)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Elimina colonna'
,p_lov_return_value=>'REMOVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88041815176535208.4504)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Elimina vincolo'
,p_lov_return_value=>'DROP_CONSTRAINT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88042009088535208.4504)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Elimina indice'
,p_lov_return_value=>'DROP_INDEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88042226760535209.4504)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Elimina tabella'
,p_lov_return_value=>'DROP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88042406323535209.4504)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Elimina trigger'
,p_lov_return_value=>'DROP_TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88042607701535209.4504)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Abilita vincolo'
,p_lov_return_value=>'ENABLE_CONSTRAINT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88042803313535209.4504)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Abilita trigger'
,p_lov_return_value=>'ENABLE_TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88043019072535210.4504)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Modifica colonna'
,p_lov_return_value=>'MODIFY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88043204776535210.4504)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Rinomina colonna'
,p_lov_return_value=>'RENAME_COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88043422512535210.4504)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Rinomina tabella'
,p_lov_return_value=>'RENAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88043603529535211.4504)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Tronca'
,p_lov_return_value=>'TRUNCATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/describe_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22153924949556802.4504)
,p_lov_name=>'DESCRIBE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(22153924949556802.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22154111837556805.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'TABLE'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22517827091787523.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'VIEW'
,p_lov_return_value=>'VIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22518130554788590.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PROCEDURE'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22518404019790369.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'FUNCTION'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22518909907792079.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PACKAGE'
,p_lov_return_value=>'PACKAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_inline
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88029914736461415.4504)
,p_lov_name=>'DISPLAY.INLINE'
,p_lov_query=>'.'||wwv_flow_api.id(88029914736461415.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88030128904461415.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Visualizza in linea'
,p_lov_return_value=>'DISPLAY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_as_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(285136607862263925.4504)
,p_lov_name=>'DISPLAY_AS_REPORTS'
,p_reference_id=>285506029323635827.4504
,p_lov_query=>'.'||wwv_flow_api.id(285136607862263925.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108084526445030643.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Colonna di report standard (sola visualizzazione, non salva lo stato)'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108084705562030643.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Visualizza come testo (basato su LOV, non salva lo stato)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108084932477030643.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Visualizza come testo (salva lo stato)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108085112395030643.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Visualizza come testo (caratteri speciali di escape, non salva lo stato)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108085330405030643.4504)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Nascosto '
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_as_tabular_forms
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(173321532130152965.4504)
,p_lov_name=>'DISPLAY_AS_TABULAR_FORMS'
,p_lov_query=>'.'||wwv_flow_api.id(173321532130152965.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108070909691016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Colonna di report standard (sola visualizzazione, non salva lo stato)'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108071103633016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Visualizza come testo (basato su LOV, non salva lo stato)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108071320755016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Visualizza come testo (salva lo stato)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108071517893016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Visualizza come testo (caratteri speciali di escape, non salva lo stato)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108071726823016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Campo di testo'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108071926389016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area di testo'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108072101156016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista di selezione'
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108072319348016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nascosto '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108072523666016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'LOV popup'
,p_lov_return_value=>'POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108072726301016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108072902041016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (utilizza il formato di visualizzazione per le applicazioni)'
,p_lov_return_value=>'PICK_DATE_USING_APP_FORMAT_MASK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108073114807016343.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-RR)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108073320317016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-RR HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108073505124016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-RR HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108073706032016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH24_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108073911349016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108074115783016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108074322493016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108074521430016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108074730419016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108074911008016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD/MM/YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108075100812016344.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD/MM/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108075332696016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD/MM/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108075516430016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (MM/DD/YYYY)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108075700209016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (MM/DD/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108075913799016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (MM/DD/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108076125223016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (RR-MON-DD)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108076313464016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (RR-MON-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108076515529016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (RR-MON-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108076725453016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY-MM-DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108076913772016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY-MM-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108077111031016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY-MM-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108077331467016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MM-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108077528710016345.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MM-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108077720268016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MM-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108077923098016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD.MM.YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108078110678016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD.MM.YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108078309308016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD.MM.YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108078528637016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY.DD.MM)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108078730750016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY.DD.MM HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH24_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108078928693016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY.DD.MM HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108079128762016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY/MM/DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108079326218016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY/MM/DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108079524994016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY/MM/DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108079705480016346.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (utilizza il formato data dell''applicazione)'
,p_lov_return_value=>'PICK_DATE_USING_APP_DATE_FORMAT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_or_save
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88028228457455927.4504)
,p_lov_name=>'DISPLAY_OR_SAVE'
,p_lov_query=>'.'||wwv_flow_api.id(88028228457455927.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88028407997455927.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Visualizza in linea'
,p_lov_return_value=>'DISPLAY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88028614614455928.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Salva come file di script'
,p_lov_return_value=>'SCRIPT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/distinct_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(102422424410025075.4504)
,p_lov_name=>'DISTINCT_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct :column_name',
'',
'from   :table_name',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_object_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(167453708814513863.4504)
,p_lov_name=>'DYNAMIC OBJECT TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       object_type d,',
'       object_type r',
' from sys.dba_objects where owner = :F4500_P500_SCHEMA',
'union  select ''DATABASE LINK'' d,''DATABASE LINK'' r from dual',
'union  select ''TABLE'' d,''TABLE'' r from dual',
'union  select ''TRIGGER'' d,''TRIGGER'' r from dual',
'union  select ''JAVA CLASS'' d,''JAVA CLASS'' r from dual',
'union  select ''JAVA SOURCE'' d,''JAVA SOURCE'' r from dual',
'union  select ''INDEX'' d,''INDEX'' r from dual',
'union  select ''SEQUENCE'' d,''SEQUENCE'' r from dual',
'union  select ''FUNCTION'' d,''FUNCTION'' r from dual',
'union  select ''PROCEDURE'' d,''PROCEDURE'' r from dual',
'union  select ''PACKAGE'' d,''PACKAGE'' r from dual',
'union  select ''PACKAGE BODY'' d,''PACKAGE BODY'' r from dual',
'union  select ''XML SCHEMA'' d,''XML SCHEMA'' r from dual',
'union  select ''TYPE'' d,''TYPE'' r from dual',
'union  select ''VIEW'' d,''VIEW'' r from dual',
'union  select ''MATERIALIZED VIEW'' d,''MATERIALIZED VIEW'' r from dual',
'union  select ''SYNONYM'' d,''SYNONYM'' r from dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/expire_password
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7461015136055036.4504)
,p_lov_name=>'EXPIRE PASSWORD'
,p_lov_query=>'.'||wwv_flow_api.id(7461015136055036.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7461210075055051.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'EXPIRE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/f4500_p93_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(166001030922348323.4504)
,p_lov_name=>'F4500_P93_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  upper(:OB_SCHEMA) and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/for_each_row
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88058923955804681.4504)
,p_lov_name=>'FOR.EACH.ROW'
,p_lov_query=>'.'||wwv_flow_api.id(88058923955804681.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88059109438804682.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Per ogni riga'
,p_lov_return_value=>'for each row'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_from_4000
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(197481124765787930.4504)
,p_lov_name=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_reference_id=>44798420131812391.4504
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_no_since_from_4000
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460129911419159358.4504)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE (FROM 4000)'
,p_reference_id=>170713321121898589.4504
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_number_from_4000
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460130116613160765.4504)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_NUMBER (FROM 4000)'
,p_reference_id=>441970320516445261.4504
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''N''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_validation_data_type_from_4000
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(197595525878393704.4504)
,p_lov_name=>'FORM_VALIDATION_DATA_TYPE (FROM 4000)'
,p_reference_id=>197490902498999083.4504
,p_lov_query=>'.'||wwv_flow_api.id(197595525878393704.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197596203845396779.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197596425687396780.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'VARCHAR'
,p_lov_return_value=>'VARCHAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/grant_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(270678820518416779.4504)
,p_lov_name=>'GRANT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(270678820518416779.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(270679015580416783.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ALL'
,p_lov_return_value=>'All'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(270679225991416783.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Privilegi specifici'
,p_lov_return_value=>'Specific'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_charset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(143356515285702408.4504)
,p_lov_name=>'I18N_IANA_CHARSET'
,p_reference_id=>144796827445692396.4504
,p_lov_query=>'.'||wwv_flow_api.id(143356515285702408.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9229220048925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'iso-8859-6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9229405581925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'windows-1256'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9229628588925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'big5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9229827838925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'gbk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9230014665925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'iso-8859-5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9230231223925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'koi8-r'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9230421211925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'koi8-u'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9230611952925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'windows-1251'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9230825878925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'iso-8859-2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9231020628925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'windows-1250'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9231210284925457.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'iso-8859-7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9231417884925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'windows-1253'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9231628287925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'iso-8859-8-i'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9231830514925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'windows-1255'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9232010444925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'euc-jp'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9232217412925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'shift_jis'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9232432569925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'euc-kr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9232618695925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'iso-8859-4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9232801800925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'windows-1257'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9233008729925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'iso-8859-3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9233226333925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'tis-620'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9233412235925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'iso-8859-9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9233629658925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'windows-1254'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9233803634925458.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'utf-8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9234002057925459.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'utf-16be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9234209685925459.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'utf-16le'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9234405813925459.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'us-ascii'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9234624781925459.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'windows-1258'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9234826068925459.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'iso-8859-1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9235025977925459.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'windows-1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_db_charset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(143362112016702427.4504)
,p_lov_name=>'I18N_IANA_DB_CHARSET'
,p_reference_id=>144802427115692411.4504
,p_lov_query=>'.'||wwv_flow_api.id(143362112016702427.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9197525868826969.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'AR8ISO8859P6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9197719499826969.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'AR8MSWIN1256'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9197926602826969.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'ZHT16MSWIN950'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9198108871826969.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'ZHS16GBK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9198314327826969.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'CL8ISO8859P5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9198509701826969.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'CL8KOI8R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9198725529826969.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'CL8KOI8U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9198913491826970.4504)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'CL8MSWIN1251'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9199128797826970.4504)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'EE8ISO8859P2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9199323295826970.4504)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'EE8MSWIN1250'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9199525603826970.4504)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'EL8ISO8859P7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9199710618826970.4504)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'EL8MSWIN1253'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9199917873826970.4504)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'IW8ISO8859P8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9200124476826971.4504)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'IW8MSWIN1255'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9200304639826971.4504)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'JA16EUC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9200514410826971.4504)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'JA16SJIS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9200704239826971.4504)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'KO16MSWIN949'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9200903786826971.4504)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'NEE8ISO8859P4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9201130515826971.4504)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'BLT8MSWIN1257'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9201303279826971.4504)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'SE8ISO8859P3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9201518062826971.4504)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'TH8TISASCII'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9201729626826971.4504)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'WE8ISO8859P9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9201928057826971.4504)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'TR8MSWIN1254'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9202110863826971.4504)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'AL32UTF8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9202305353826971.4504)
,p_lov_disp_sequence=>242
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'AL16UTF16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9202522080826972.4504)
,p_lov_disp_sequence=>244
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'AL16UTF16LE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9202732398826972.4504)
,p_lov_disp_sequence=>248
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'US7ASCII'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9202914568826972.4504)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'VN8MSWIN1258'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9203117480826972.4504)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'WE8ISO8859P1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9203309867826972.4504)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'WE8MSWIN1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_detail_view_modes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(144167830179232748.4504)
,p_lov_name=>'ICON DETAIL VIEW MODES'
,p_reference_id=>116048926655714272.4504
,p_lov_query=>'.'||wwv_flow_api.id(144167830179232748.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(240823626953628604.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Icone'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(240823804523628605.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Dettagli'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/identity_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(254185527365105468.4504)
,p_lov_name=>'IDENTITY_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(254185527365105468.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(254185828755105469.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sempre'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(254186111548105469.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Valore predefinito'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(254186405911105469.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Valore predefinito se Null'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_args_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88064701145826564.4504)
,p_lov_name=>'INCLUDE.ARGS.Y'
,p_lov_query=>'.'||wwv_flow_api.id(88064701145826564.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88064927960826565.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Includi argomenti'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/intra_component_navigator
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1457916849659682.4504)
,p_lov_name=>'INTRA COMPONENT NAVIGATOR'
,p_lov_query=>'.'||wwv_flow_api.id(1457916849659682.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1458119331659683.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Browser oggetti'
,p_lov_return_value=>'1001'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1458304212659683.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Comandi SQL'
,p_lov_return_value=>'1003'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1458524645659683.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Script SQL'
,p_lov_return_value=>'1004'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1458701375659683.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Query Builder'
,p_lov_return_value=>'1002'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_types_without_plugins
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(29577622544843540.4504)
,p_lov_name=>'ITEM_TYPES (WITHOUT PLUGINS)'
,p_reference_id=>29544521926748713.4504
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_native_plugins varchar2(255);',
'begin',
'    l_native_plugins := '' union all select display_name as d, name_with_prefix as r from wwv_flow_native_plugins where plugin_type = ''''ITEM TYPE'''' order by 1'';',
'',
'    if lower(wwv_flow.g_flow_language) = ''en'' then',
'        return ''select display_name as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    else',
'        return ''select wwv_flow_lang.system_message(''''ITEM_TYPE.''''||name) as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    end if;',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/language_selector
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(111525828615050878.4504)
,p_lov_name=>'LANGUAGE_SELECTOR'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''en'' d, ''en'' r',
'  from dual',
'union ',
'select flow_language d, flow_language r',
'  from wwv_flows',
' where id in ',
' (select translation_flow_id',
'    from wwv_flow_language_map',
'   where primary_language_flow_id = v(''APP_ID''))',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_schemas
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(26396713461308449.4504)
,p_lov_name=>'LIST_ALL_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d, username v',
'from sys.dba_users ',
'where wwv_flow_provisioning.restricted_schema_i(username,:APP_USER) = 0',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_schemas_wo_ob_schema
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(26377214558019246.4504)
,p_lov_name=>'LIST_ALL_SCHEMAS_WO_OB_SCHEMA'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d, username v',
'from sys.dba_users',
'where wwv_flow_provisioning.restricted_schema_i(username,:APP_USER) = 0  ',
'and username !=  :OB_SCHEMA   ',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(64015215313088942.4504)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas_qb
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14016705748242026.4504)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS-QB'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, ''; ',
'  q:=q||''       wwv_flow_fnd_user u ''; ',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1002_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1002_SCHEMA) a,:P1002_SCHEMA b from dual '';',
'  q:=q||''where  :P1002_POPUP = 1 '';',
'  q:=q||''order by 1'';',
'  return q;',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas_sc
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23001304041139468.4504)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select /* APEX4500L1 */ wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1003_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1003_SCHEMA) a,:P1003_SCHEMA b from dual '';',
'  q:=q||''where  :P1003_POPUP = 1 '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_sequences
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(20606105200562019.4504)
,p_lov_name=>'LIST_SEQUENCES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(sequence_name) a, sequence_name b from sys.dba_sequences ',
'where sequence_owner = :OB_SCHEMA',
'order by sequence_name',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_users
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(96930227515507687.4504)
,p_lov_name=>'LIST_USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || wwv_flow_lang.system_message(''ALL_USERS'') || '' -'' d, ''0'' r',
'  from dual',
' where exists (',
'    select null',
'      from  wwv_flow_developers ',
'     where security_group_id = :flow_security_group_id ',
'       and userid = :flow_user ',
'       and instr(developer_role||'':'',''ADMIN:'') > 0)',
'union all',
'select user_name d, user_name r',
'  from wwv_flow_fnd_user',
' where security_group_id = :flow_security_group_id',
'   and (user_name = :flow_user or exists',
'        (select null from wwv_flow_developers',
'          where security_group_id = :flow_security_group_id',
'            and userid = :flow_user',
'            and instr(developer_role||'':'',''ADMIN:'') > 0))',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_message
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(21459801069722432.4504)
,p_lov_name=>'LOGIN_MESSAGE'
,p_lov_query=>'.'||wwv_flow_api.id(21459801069722432.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21460014390722445.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nessun messaggio'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21460423875722448.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Messaggio personalizzato'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_objectstore_references
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2126335033862968.4504)
,p_lov_name=>'LOV_OBJECTSTORE_REFERENCES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, base_url, cloud_credential_name from wwv_remote_servers',
'where security_group_id = :WORKSPACE_ID',
'and server_type = ''CLOUD_OBJECT_STORE'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(2127071488865633.4504)
,p_query_column_name=>'ID'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(2127437388865635.4504)
,p_query_column_name=>'NAME'
,p_heading=>'Nome'
,p_display_sequence=>20
,p_data_type=>'VARCHAR2'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(2127806644865636.4504)
,p_query_column_name=>'BASE_URL'
,p_heading=>'URL'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(2128268586865636.4504)
,p_query_column_name=>'CLOUD_CREDENTIAL_NAME'
,p_heading=>'Credenziale DBMS_CLOUD'
,p_display_sequence=>40
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/manage_table_constraints
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(165911414842182864.4504)
,p_lov_name=>'MANAGE.TABLE.CONSTRAINTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.constraint_name) d,  c.constraint_name r',
'from sys.dba_constraints c, sys.dba_cons_columns l',
'where c.table_name = :OBJECT_NAME',
'and c.owner = :OBJECT_OWNER',
'and c.constraint_type in (''P'',''U'',''C'',''R'')',
'and c.constraint_name = l.constraint_name ',
'and l.owner = :OBJECT_OWNER',
'and l.table_name = :OBJECT_NAME',
'and (l.position = 1 or l.position is null)',
'and c.status = ''ENABLED''',
'order by c.constraint_name, c.constraint_type, l.position'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_a
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88005728392276151.4504)
,p_lov_name=>'MAX_ROWS_A'
,p_lov_query=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88005902539276153.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88006132674276154.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88006303849276154.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88006502528276154.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88006721789276154.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88006905692276155.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88007113392276155.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88007318997276155.4504)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88007513744276155.4504)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(182328908607767113.4504)
,p_lov_disp_sequence=>5000
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(260332524931295254.4504)
,p_lov_disp_sequence=>10000
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(260332828394296254.4504)
,p_lov_disp_sequence=>100000
,p_lov_disp_value=>'100000'
,p_lov_return_value=>'100000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_b
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88008910861280555.4504)
,p_lov_name=>'MAX_ROWS_B'
,p_lov_query=>'.'||wwv_flow_api.id(88008910861280555.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183741320426917019.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88009125818280556.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88009318636280556.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88009527364280557.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88009708671280557.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88009918679280557.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88010107969280558.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88010312982280558.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88010525571280558.4504)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88010713109280558.4504)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88010919618280559.4504)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88011124222280559.4504)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88011310169280559.4504)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'50000'
,p_lov_return_value=>'50000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/more_less_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161595731562973452.4504)
,p_lov_name=>'MORE_LESS_COLUMNS'
,p_lov_query=>'.'||wwv_flow_api.id(161595731562973452.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161595917373973455.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Pi\00F9 colonne')
,p_lov_return_value=>'MORE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161596108445973460.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Meno colonne'
,p_lov_return_value=>'LESS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/my_job
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88020412686337805.4504)
,p_lov_name=>'MY.JOB'
,p_lov_query=>'.'||wwv_flow_api.id(88020412686337805.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88020600548337806.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Job personali'
,p_lov_return_value=>'my_job'
);
end;
/
prompt --application/shared_components/user_interface/lovs/null_notnull
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88038204225524574.4504)
,p_lov_name=>'NULL.NOTNULL'
,p_lov_query=>'.'||wwv_flow_api.id(88038204225524574.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88038423679524575.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'NOT NULL (richiede un valore)'
,p_lov_return_value=>'NOT NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88038631515524575.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NULL (non richiede un valore)'
,p_lov_return_value=>'NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88081132547977521.4504)
,p_lov_name=>'OBJECT.TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''FUNCTION'')) d, ''98'' r from dual union all',
'select initcap(wwv_flow_lang.system_message(''INDEX'')) d, ''INDEX'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PACKAGE'')) d, ''117'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PROCEDURE'')) d, ''121'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SEQUENCE'')) d, ''97'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SYNONYM'')) d, ''99'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TABLE'')) d, ''600'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TRIGGER'')) d, ''TRIGGER'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''VIEW'')) d, ''48'' r from dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types_with_images2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161349613017569311.4504)
,p_lov_name=>'OBJECT.TYPES.WITH.IMAGES2'
,p_lov_query=>'.'||wwv_flow_api.id(161349613017569311.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161349926473569318.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Funzione'
,p_lov_return_value=>'98'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:98:&SESSION.::NO:98,107,100:P81_CREATE_OBJECT_TYPE:98"><img src="#IMAGE_PREFIX#htmldb/builder/function.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161350104339569322.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Indice'
,p_lov_return_value=>'INDEX'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:56:&SESSION.:index:NO:57:P70_ACTION,P81_CREATE_OBJECT_TYPE:INDEX,INDEX"><img src="#IMAGE_PREFIX#htmldb/builder/index.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_V'
||'ALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161350313495569322.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'117'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:117:&SESSION.::NO:117,118,120:P81_CREATE_OBJECT_TYPE:117"><img src="#IMAGE_PREFIX#htmldb/builder/package.gif" width="58" height="38" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a'
||'>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161350510273569323.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Procedura'
,p_lov_return_value=>'121'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:121:&SESSION.::NO:121,122,123:P81_CREATE_OBJECT_TYPE:121"><img src="#IMAGE_PREFIX#htmldb/builder/procedure.gif" width="58" height="38" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /><'
||'/a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161350704929569323.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Sequenza'
,p_lov_return_value=>'97'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:97:&SESSION.::NO:97:P81_CREATE_OBJECT_TYPE:97"><img src="#IMAGE_PREFIX#htmldb/builder/sequence.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161350927921569323.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Sinonimo'
,p_lov_return_value=>'99'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:99:&SESSION.::NO:99:P81_CREATE_OBJECT_TYPE:99"><img src="#IMAGE_PREFIX#htmldb/builder/synonym.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161351109256569323.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tabella'
,p_lov_return_value=>'TABLE_CREATE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:TABLE_CREATE:&SESSION.::NO:602,604,612:P81_CREATE_OBJECT_TYPE:600"><img src="#IMAGE_PREFIX#htmldb/builder/table.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#'
||'" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161351331481569324.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:3:&SESSION.:triger:NO:3::"><img src="#IMAGE_PREFIX#htmldb/builder/trigger.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161351517964569324.4504)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Vista'
,p_lov_return_value=>'48'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:48:&SESSION.::NO:48:P81_CREATE_OBJECT_TYPE:48"><img src="#IMAGE_PREFIX#htmldb/builder/view.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161351731977569324.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Database link'
,p_lov_return_value=>'91'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:91:&SESSION.::NO:91:P81_CREATE_OBJECT_TYPE:91"><img src="#IMAGE_PREFIX#htmldb/builder/dblink.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88087713200000281.4504)
,p_lov_name=>'OBJECT.TYPES2'
,p_lov_query=>'.'||wwv_flow_api.id(88087713200000281.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88087913591000281.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Colonne'
,p_lov_return_value=>'Columns'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88088111508000282.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'Packages'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88088331361000282.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Procedure/funzioni'
,p_lov_return_value=>'Procedures/Functions'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types3
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(149192410304386529.4504)
,p_lov_name=>'OBJECT.TYPES3'
,p_lov_query=>'.'||wwv_flow_api.id(149192410304386529.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149192703287386532.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Funzione'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149192916678386534.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Indice'
,p_lov_return_value=>'INDEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149193104939386534.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'PACKAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149193312103386534.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Procedura'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149193514215386535.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Sequenza'
,p_lov_return_value=>'SEQUENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149193711471386535.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Sinonimo'
,p_lov_return_value=>'SYNONYM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149193923583386535.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tabella'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149194128979386535.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149194306560386535.4504)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Vista'
,p_lov_return_value=>'VIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(106105223193950457.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Database link'
,p_lov_return_value=>'DATABASE LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109308316213864971.4504)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Tipo'
,p_lov_return_value=>'TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109321428942887516.4504)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Vista materializzata'
,p_lov_return_value=>'MATERIALIZED VIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ob_create_table_handler
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17956529721028277.4504)
,p_lov_name=>'OB_CREATE_TABLE_HANDLER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ob_cycle
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(276749314239737540.4504)
,p_lov_name=>'OB_CYCLE'
,p_lov_query=>'.'||wwv_flow_api.id(276749314239737540.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(276749519233737542.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ciclo'
,p_lov_return_value=>'CYCLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ob_grant_privs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15818831028847554.4504)
,p_lov_name=>'OB_GRANT_PRIVS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select privilege_name a, privilege_name b',
'  from sys.v_$object_privilege',
' where object_type_name = case :OBJECT_TYPE',
'                          when ''MATERIALIZED VIEW'' then ''TABLE''',
'                          when ''PACKAGE BODY'' then ''PACKAGE''',
'                          else :OBJECT_TYPE',
'                          end'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ob_order
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(276750123935740352.4504)
,p_lov_name=>'OB_ORDER'
,p_lov_query=>'.'||wwv_flow_api.id(276750123935740352.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(276750313195740352.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ordina'
,p_lov_return_value=>'ORDER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/on_delete_cascade_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88046110159554703.4504)
,p_lov_name=>'ON.DELETE.CASCADE.Y'
,p_lov_query=>'.'||wwv_flow_api.id(88046110159554703.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88046324301554704.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'In caso di eliminazione a catena'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/order_by
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88015211732318611.4504)
,p_lov_name=>'ORDER.BY'
,p_lov_query=>'.'||wwv_flow_api.id(88015211732318611.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88015409187318612.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Titolo'
,p_lov_return_value=>'title'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88015624432318612.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Nome file'))
,p_lov_return_value=>'filename'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88015826924318612.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Data creazione, crescente'))
,p_lov_return_value=>'created_on'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88016003779318613.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Data creazione, decrescente'))
,p_lov_return_value=>'created_on desc'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88016226006318613.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Autore creazione'))
,p_lov_return_value=>'created_by'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88016402368318613.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Dimensioni, in ordine crescente'))
,p_lov_return_value=>'doc_size'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88016613155318613.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Dimensioni, in ordine decrescente'))
,p_lov_return_value=>'doc_size desc'
);
end;
/
prompt --application/shared_components/user_interface/lovs/output_format
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88012712031290348.4504)
,p_lov_name=>'OUTPUT.FORMAT'
,p_lov_query=>'.'||wwv_flow_api.id(88012712031290348.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88012904683290349.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTML'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88013100776290349.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Excel'
,p_lov_return_value=>'EXCEL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1000_show
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184589019269022599.4504)
,p_lov_name=>'P1000 SHOW'
,p_lov_query=>'.'||wwv_flow_api.id(184589019269022599.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184589207940022600.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tutto'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184589426163022602.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Assegnazioni personali'
,p_lov_return_value=>'MINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184593723631288771.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Aperti - Personali'
,p_lov_return_value=>'MY_OPEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184593319129287486.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Aperti - Tutti'
,p_lov_return_value=>'ALL_OPEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1004_show_results
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(179031515879675216.4504)
,p_lov_name=>'P1004_SHOW_RESULTS'
,p_lov_query=>'.'||wwv_flow_api.id(179031515879675216.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179031709094675217.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mostra risultati'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p101_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(150992731358804903.4504)
,p_lov_name=>'P101_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.column_name)||'' - ''||lower(t.data_type) d, ',
'       t.column_name r',
'from   sys.dba_tab_columns t',
'where              ',
'      t.table_name = :P101_TABLE_NAME',
'  and t.owner = :P101_TABLE_OWNER and',
'      (nvl(:P101_SHOW,''1'') = ''1'' or t.data_type in (''VARCHAR'',''VARCHAR2'')) and column_id is not null',
'order by t.column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_audit_col_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(561151526618018480.4504)
,p_lov_name=>'P1101_AUDIT_COL_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(561151526618018480.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561151855252018480.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Colonne di audit'
,p_lov_return_value=>'AUDIT_COLS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561152288785018481.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Numero versione riga'
,p_lov_return_value=>'ROW_VERSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561152614552018481.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Chiave riga'
,p_lov_return_value=>'ROW_KEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561153026518018481.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'ID tenant'
,p_lov_return_value=>'TENANT_ID'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_date_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(561155009716075756.4504)
,p_lov_name=>'P1101_DATE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(561155009716075756.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561155337871075756.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561155720392075757.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'TIMESTAMP'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561156148788075757.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'TIMESTAMP WITH TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561156516823075757.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_db_version
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(561159215572120923.4504)
,p_lov_name=>'P1101_DB_VERSION'
,p_lov_query=>'.'||wwv_flow_api.id(561159215572120923.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(616271032412133442.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'21c'
,p_lov_return_value=>'21c'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561159550831120924.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'19c'
,p_lov_return_value=>'19c'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561159941578120924.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'12c'
,p_lov_return_value=>'12c'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561160307536120924.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'11g'
,p_lov_return_value=>'11g'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_length_semantics
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(561157497023099105.4504)
,p_lov_name=>'P1101_LENGTH_SEMANTICS'
,p_lov_query=>'.'||wwv_flow_api.id(561157497023099105.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561157786208099106.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Valore predefinito'
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561158557818099106.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'CHAR'
,p_lov_return_value=>'CHAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561158130042099106.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'BYTE'
,p_lov_return_value=>'BYTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_on_delete
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(561149224457990543.4504)
,p_lov_name=>'P1101_ON_DELETE'
,p_lov_query=>'.'||wwv_flow_api.id(561149224457990543.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561149574178990543.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'A catena'
,p_lov_return_value=>'CASCADE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561149925686990545.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Limita'
,p_lov_return_value=>'RESTRICT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561150376364990545.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Imposta su null'
,p_lov_return_value=>'SET NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_trigger_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(561153525630044678.4504)
,p_lov_name=>'P1101_TRIGGER_METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(561153525630044678.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561153872500044678.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'SYS_GUID'
,p_lov_return_value=>'GUID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561154212975044678.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Colonna identit\00E0')
,p_lov_return_value=>'IDENTITY'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'sys.dbms_db_version.version >= 12'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244368349049855044.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Sequenza'
,p_lov_return_value=>'SEQ'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1220_script_files
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(12563519145254272.4504)
,p_lov_name=>'P1220_SCRIPT_FILES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.filename, f.id',
'from wwv_flow_files f, wwv_flow_sw_results r',
'where f.id = r.file_id ',
'and f.file_type = ''SCRIPT''',
'and (nvl(:P1220_SHOW,''0'') = ''0'' or run_by = :P1220_SHOW)',
'order by f.filename'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1301_session_opts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(26561807054435939.4504)
,p_lov_name=>'P1301_SESSION_OPTS'
,p_lov_query=>'.'||wwv_flow_api.id(26561807054435939.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26562005235435939.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ALL'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26562200440435942.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sessioni riuscite'
,p_lov_return_value=>'SUC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26562427473435942.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Sessioni non riuscite'
,p_lov_return_value=>'FAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1302_sesopt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(26247521414208435.4504)
,p_lov_name=>'P1302_SESOPT'
,p_lov_query=>'.'||wwv_flow_api.id(26247521414208435.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26247711140208437.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ALL'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26247917746208441.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Login riuscito'
,p_lov_return_value=>'SUC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26248104479208441.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Login non riuscito'
,p_lov_return_value=>'FAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2610_users
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(20110029824731114.4504)
,p_lov_name=>'P2610_USERS'
,p_lov_query=>'.'||wwv_flow_api.id(20110029824731114.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20110203670731120.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tutti gli schemi'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20110423350731122.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Schemi interni'
,p_lov_return_value=>'INTERNAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20110606356731122.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Schemi del database'
,p_lov_return_value=>'USER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2613_locked_unlocked
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1493723866781789.4504)
,p_lov_name=>'P2613_LOCKED_UNLOCKED'
,p_lov_query=>'.'||wwv_flow_api.id(1493723866781789.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1493913666781840.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bloccato'
,p_lov_return_value=>'LOCK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1494107328781852.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sbloccato'
,p_lov_return_value=>'UNLOCK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3100_load_to
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(60089930390905970.4504)
,p_lov_name=>'P3100_LOAD_TO'
,p_lov_query=>'.'||wwv_flow_api.id(60089930390905970.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(60090216213905982.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nuova tabella'
,p_lov_return_value=>'NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(60090671533905996.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tabella esistente'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3100_update_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(60103143434104047.4504)
,p_lov_name=>'P3100_UPDATE_METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(60103143434104047.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(60103430659104047.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Aggiungi'
,p_lov_return_value=>'APPEND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(60103886752104048.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sostituisci'
,p_lov_return_value=>'REPLACE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3120_table_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(60123851090684199.4504)
,p_lov_name=>'P3120_TABLE_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name||'' (''|| initcap(data_type) ||'')'' as d,',
'       column_name as r',
'from sys.dba_tab_columns',
'where owner = :P3100_TABLE_OWNER',
'and table_name = :P3100_EXISTING_TABLE',
'order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3142_table_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2839941212629864.4504)
,p_lov_name=>'P3142_TABLE_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name||'' (''|| initcap(data_type) ||'')'' as d,',
'       column_name as r',
'from sys.dba_tab_columns',
'where owner = :P3140_SCHEMA',
'and table_name = :P3140_EXISTING_TABLE_NAME',
'order by column_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'R'
,p_display_column_name=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p35_timeframe
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(30574425871912860.4504)
,p_lov_name=>'P35_TIMEFRAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, to_char(t) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5*60 t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15*60 t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 3600 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 2*3600  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3*3600  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4*3600  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6*3600 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8*3600 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12*3600 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 18*3600 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1*24*60*60 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2*24*60*60 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3*24*60*60 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4*24*60*60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5*24*60*60 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 6*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7*24*60*60 t  from dual',
') q'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p36_display_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(998111353442494.4504)
,p_lov_name=>'P36_DISPLAY_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(998111353442494.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(998325750442498.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Versione'
,p_lov_return_value=>'VERSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(998523049442499.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Impostazioni'
,p_lov_return_value=>'DATABASE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(998704170442500.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Opzioni'
,p_lov_return_value=>'OPTIONS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(999130596442500.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'National Language Support'
,p_lov_return_value=>'NLS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(999327277442500.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Ambiente CGI'
,p_lov_return_value=>'CGI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5615222230694443.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Parametri'
,p_lov_return_value=>'PARAMETER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p40_interval
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174631600082053227.4504)
,p_lov_name=>'P40_INTERVAL'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' ''   ||initcap(wwv_flow_lang.system_message(''YEAR'')) d, 365 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 31 ''||initcap(wwv_flow_lang.system_message(''DAYS'')) d, 31 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 48 ''||initcap(wwv_flow_lang.system_message(''HOURS'')) d, 2 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 24 ''||initcap(wwv_flow_lang.system_message(''HOURS'')) d, 1 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 8 '' ||initcap(wwv_flow_lang.system_message(''HOURS'')) d, 8/24 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 6 '' ||initcap(wwv_flow_lang.system_message(''HOURS'')) d, 6/24 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 4 '' ||initcap(wwv_flow_lang.system_message(''HOURS'')) d, 4/24 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 2 '' ||initcap(wwv_flow_lang.system_message(''HOURS'')) d, 2/24 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' ''   ||initcap(wwv_flow_lang.system_message(''HOUR'')) d, 1/24 r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 30 ''||initcap(wwv_flow_lang.system_message(''MINUTES'')) d, 30/(24*60) r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 10 ''||initcap(wwv_flow_lang.system_message(''MINUTES'')) d, 10/(24*60) r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 5 '' ||initcap(wwv_flow_lang.system_message(''MINUTES'')) d, 5/(24*60) r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' ''   ||initcap(wwv_flow_lang.system_message(''MINUTE'')) d, 1/(24*60) r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 10 ''||initcap(wwv_flow_lang.system_message(''SECONDS'')) d, 10* (1/(24*60*60)) r from dual union all',
'select initcap(wwv_flow_lang.system_message(''LAST''))||'' 5 '' ||initcap(wwv_flow_lang.system_message(''SECONDS'')) d, 5* (1/(24*60*60)) r from dual',
'order by 2 desc'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p42_order_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(148760022603009971.4504)
,p_lov_name=>'P42.ORDER.COLUMNS'
,p_lov_query=>'select wwv_flow_escape.html(column_name) d, column_name v from sys.dba_tab_columns where owner = :F4500_P42_OBJECT_OWNER and table_name = :F4500_P42_OBJECT_NAME order by column_id'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p64_obj_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(27925820885518618.4504)
,p_lov_name=>'P64_OBJ_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(27925820885518618.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27926020563518626.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Applicazione'
,p_lov_return_value=>'APPLICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27926230018518634.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Esportazione CSS'
,p_lov_return_value=>'CSS_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27926402670518634.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Esportazione applicazione'
,p_lov_return_value=>'FLOW_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27926614786518636.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Script'
,p_lov_return_value=>'SCRIPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27926803274518636.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Esportazione file di script'
,p_lov_return_value=>'SCRIPT_FILE_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27927031603518636.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Tema'
,p_lov_return_value=>'THEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27927219004518642.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'File statico'
,p_lov_return_value=>'STATIC FILE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p71_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174553601832855016.4504)
,p_lov_name=>'P71_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER',
' and table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p76_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174520707223695721.4504)
,p_lov_name=>'P76_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p82_constraints
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174431027591821617.4504)
,p_lov_name=>'P82_CONSTRAINTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.constraint_name) d,  c.constraint_name r',
'from sys.dba_constraints c, sys.dba_cons_columns l',
'where c.table_name = :OBJECT_NAME',
'and c.owner = :OBJECT_OWNER',
'and c.constraint_type in (''P'',''U'',''C'',''R'')',
'and c.constraint_name = l.constraint_name ',
'and l.owner = :OBJECT_OWNER',
'and l.table_name = :OBJECT_NAME',
'and c.status = ''DISABLED''',
'order by c.constraint_name, c.constraint_type, l.position'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p86_triggers
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174475310182109956.4504)
,p_lov_name=>'P86_TRIGGERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.trigger_name)||'' (''||t.status||'')'' d, t.trigger_name r',
'from sys.dba_triggers t',
'where t.table_name = :OBJECT_NAME ',
'and t.table_owner = :OBJECT_OWNER',
'order by t.trigger_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(20561306137429854.4504)
,p_lov_name=>'PK_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(20561306137429854.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(29761700718146891.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nessuna chiave primaria'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20561825857429898.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Popolato da una nuova sequenza'
,p_lov_return_value=>'NEW_SEQUENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20562003984429898.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Popolato da una sequenza esistente'
,p_lov_return_value=>'EXISTING_SEQUENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20561603688429893.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Non popolato'
,p_lov_return_value=>'NOT_GENERATED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(276470910158447556.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Dati inseriti da colonna identit\00E0')
,p_lov_return_value=>'IDENTITY'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_global.g_12c'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pl_sql_object_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9486017492391468.4504)
,p_lov_name=>'PL/SQL OBJECT TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(9486017492391468.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9486202458391470.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Procedura'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9486430806391474.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Funzione'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9486609421391475.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'PACKAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9486818320391475.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Package body'
,p_lov_return_value=>'PACKAGE BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9487009618391475.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/preserve_case_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88034811582507798.4504)
,p_lov_name=>'PRESERVE.CASE.Y'
,p_lov_query=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88035027142507799.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Conserva maiuscole/minuscole'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/privileges_table_show
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8935311761146039.4504)
,p_lov_name=>'PRIVILEGES.TABLE.SHOW'
,p_lov_query=>'.'||wwv_flow_api.id(8935311761146039.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8935521709146041.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Privilegi per lo schema selezionato'
,p_lov_return_value=>'TO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8935711543146043.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Privilegi dallo schema selezionato'
,p_lov_return_value=>'FROM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8935913844146043.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Tutto'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_private
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88067712358839197.4504)
,p_lov_name=>'PUBLIC.PRIVATE'
,p_lov_query=>'.'||wwv_flow_api.id(88067712358839197.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88067900572839197.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Privato'
,p_lov_return_value=>'PRIVATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88068127252839198.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Pubblico'
,p_lov_return_value=>'PUBLIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/query_builder_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2308814912225605.4504)
,p_lov_name=>'QUERY_BUILDER_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(2308814912225605.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2309026164225610.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Privato'
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2309221064225612.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Pubblico'
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2309411169225612.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Lettura/scrittura pubblica'
,p_lov_return_value=>'W'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/query_owners
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3358317445244033.4504)
,p_lov_name=>'QUERY_OWNERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r from (',
'select wwv_flow_escape.html(created_by) d, created_by r ',
'  from wwv_flow_qb_saved_query',
'where security_group_id = :flow_security_group_id',
'and exists (     ',
'select 1 ',
'from  wwv_flow_developers ',
'where security_group_id = :flow_security_group_id and ',
'      userid = :flow_user and ',
'      instr(developer_role||'':'',''ADMIN:'') > 0 ',
'union ',
'select 1 ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id ',
'and user_name = :flow_user ',
'and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')) ',
'union all  ',
'select v(''APP_USER'') d, v(''APP_USER'') r',
'FROM DUAL) ',
'group by d,r',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/quicksql_data_lang
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(397206437082468486.4504)
,p_lov_name=>'QUICKSQL_DATA_LANG'
,p_lov_query=>'.'||wwv_flow_api.id(397206437082468486.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(397206751492468497.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Inglese'
,p_lov_return_value=>'EN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(397207144316468498.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tedesco'
,p_lov_return_value=>'DE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(397207548117468498.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Coreano'
,p_lov_return_value=>'KO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(397207927574468498.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Giapponese'
,p_lov_return_value=>'JA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(397208363097468498.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Spagnolo'
,p_lov_return_value=>'ES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/quota_size
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1589203900827893.4504)
,p_lov_name=>'QUOTA SIZE'
,p_lov_query=>'.'||wwv_flow_api.id(1589203900827893.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1589405753827932.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Zero'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1589832194827937.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Valore (MB)'
,p_lov_return_value=>'VALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1589631060827937.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Illimitato'
,p_lov_return_value=>'UNLIMITED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recycle_bin_object_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(165057106281786448.4504)
,p_lov_name=>'RECYCLE BIN OBJECT TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(165057106281786448.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(165057400753786453.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Indice'
,p_lov_return_value=>'INDEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(165057605335786456.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tabella'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(165057800969786457.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redaction_enabled
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7500901536272987.4504)
,p_lov_name=>'REDACTION_ENABLED'
,p_lov_query=>'.'||wwv_flow_api.id(7500901536272987.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7501216647272994.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Abilitato'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7501515266272994.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabilitato'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_expressions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7516909805609852.4504)
,p_lov_name=>'REDACT_EXPRESSIONS'
,p_lov_query=>'.'||wwv_flow_api.id(7516909805609852.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7517226584609865.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sempre'
,p_lov_return_value=>'1=1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7517506593609865.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('L''utente di Application Express \00E8')
,p_lov_return_value=>'v(''APP_USER'') = '''' or v(''APP_USER'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7517804068609865.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('L''utente di Application Express non \00E8')
,p_lov_return_value=>'v(''APP_USER'') != '''' or v(''APP_USER'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7518128701609866.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('L''utente della sessione dell''ambiente utente \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''SESSION_USER'') = '''' or SYS_CONTEXT(''USERENV'',''SESSION_USER'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7518404287609866.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('L''utente della sessione dell''ambiente utente non \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''SESSION_USER'') != '''' or SYS_CONTEXT(''USERENV'',''SESSION_USER'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7518717668609866.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Il ruolo della sessione dell''ambiente utente \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''SESSION_ROLE'') = '''' or SYS_CONTEXT(''USERENV'',''SESSION_ROLE'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7519030231609866.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Il ruolo della sessione dell''ambiente utente non \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''SESSION_ROLE'') != '''' or SYS_CONTEXT(''USERENV'',''SESSION_ROLE'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7519316622609867.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Il modulo applicativo dell''ambiente utente \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''APPLICATION_MODULE'') = '''' or SYS_CONTEXT(''USERENV'',''APPLICATION_MODULE'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7519610265609867.4504)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>unistr('Il modulo applicativo dell''ambiente utente non \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''APPLICATION_MODULE'') != '''' or SYS_CONTEXT(''USERENV'',''APPLICATION_MODULE'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7519923103609867.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('L''identificativo client dell''ambiente utente \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_IDENTIFIER'') = '''' or SYS_CONTEXT(''USERENV'',''CLIENT_IDENTIFIER'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7520222645609867.4504)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('L''identificativo client dell''ambiente utente non \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_IDENTIFIER'') != '''' or SYS_CONTEXT(''USERENV'',''CLIENT_IDENTIFIER'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7520505568609926.4504)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Le informazioni client dell''ambiente utente sono'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_INFORMATION'') = '''' or SYS_CONTEXT(''USERENV'',''CLIENT_INFORMATION'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7520806771609926.4504)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Le informazioni client dell''ambiente utente non sono'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_INFORMATION'') != '''' or SYS_CONTEXT(''USERENV'',''CLIENT_INFORMATION'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7521121453609926.4504)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('L''indirizzo IP client dell''ambiente utente \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_IP_ADDRESS'') = '''' or SYS_CONTEXT(''USERENV'',''CLIENT_IP_ADDRESS'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7521408264609926.4504)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('L''indirizzo IP client dell''ambiente utente non \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_IP_ADDRESS'') != '''' or SYS_CONTEXT(''USERENV'',''CLIENT_IP_ADDRESS'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7521704157619850.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Il nome computer client dell''ambiente utente \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_MACHINE_NAME'') = '''' or SYS_CONTEXT(''USERENV'',''CLIENT_MACHINE_NAME'') is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7522029162623362.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Il nome computer client dell''ambiente utente non \00E8')
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_MACHINE_NAME'') != '''' or SYS_CONTEXT(''USERENV'',''CLIENT_MACHINE_NAME'') is null'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_func_parms
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7469301964208818.4504)
,p_lov_name=>'REDACT_FUNC_PARMS'
,p_lov_query=>'.'||wwv_flow_api.id(7469301964208818.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7469607797208922.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Proteggi prime cinque cifre SSN USA'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,1,5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7469909319209004.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Proteggi ultime quattro cifre SSN USA'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,6,9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7470220279209004.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Proteggi tutto l''SSN USA'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,1,9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7470527551209004.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Proteggi prime cinque cifre SSN USA numerico'
,p_lov_return_value=>'9,1,5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7470809785209004.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Proteggi ultime quattro cifre SSN USA numerico'
,p_lov_return_value=>'9,6,9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7471105134209004.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Proteggi tutto l''SSN USA numerico'
,p_lov_return_value=>'9,1,9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7471430655209004.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Proteggi CAP USA numerico'
,p_lov_return_value=>'9,1,5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7471711236209005.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Proteggi prime dodici cifre numero carta di credito'
,p_lov_return_value=>'VVVVFVVVVFVVVVFVVVV,VVVV-VVVV-VVVV-VVVV,*,1,12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7472009351209006.4504)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Proteggi millennio data'
,p_lov_return_value=>'m1d1y2000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7472316128209006.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Proteggi epoca data'
,p_lov_return_value=>'m1d1y1970'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_regexp_pattern
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7472906353351996.4504)
,p_lov_name=>'REDACT_REGEXP_PATTERN'
,p_lov_query=>'.'||wwv_flow_api.id(7472906353351996.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7473231345352007.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Numero di previdenza sociale USA'
,p_lov_return_value=>'(\d\d\d)-(\d\d)-(\d\d\d\d)'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7473505981352008.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Parte centrale della carta di credito con 6 cifre iniziali e 4 cifre finali'
,p_lov_return_value=>'(\d\d\d\d\d\d)(\d\d\d*)(\d\d\d\d)'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7473832380352008.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Qualsiasi cifra'
,p_lov_return_value=>'\d'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7474122208352008.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Numero di telefono USA'
,p_lov_return_value=>'(\(\d\d\d\)|\d\d\d)-(\d\d\d)-(\d\d\d\d)'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7474420613352009.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Indirizzo di posta elettronica'
,p_lov_return_value=>'([A-Za-z0-9._%+-]+)@([A-Za-z0-9.-]+\.[A-Za-z]{2,4})'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7474702702352009.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Indirizzo IP'
,p_lov_return_value=>'(\d{1,3}\.\d{1,3}\.\d{1,3})\.\d{1,3}'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_regexp_repl_str
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7474914908572203.4504)
,p_lov_name=>'REDACT_REGEXP_REPL_STR'
,p_lov_query=>'.'||wwv_flow_api.id(7474914908572203.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7475217540572261.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Proteggi cifre centrali carta di credito'
,p_lov_return_value=>'\1XXXXXX\3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7475532017572262.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Proteggi con una sola X'
,p_lov_return_value=>'X'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7475808807572262.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Proteggi con un solo 1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7476121686572262.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Proteggi numero di telefono USA'
,p_lov_return_value=>'\1-XXX-XXXX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7476430001572262.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Proteggi nome posta elettronica'
,p_lov_return_value=>'xxxx@\2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7476702761572263.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Proteggi dominio posta elettronica'
,p_lov_return_value=>'\1 (at) xxxxx.com'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7477004982572263.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Proteggi tutta la posta elettronica'
,p_lov_return_value=>'xxxx (at) xxxxx.com'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7477316416572263.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Proteggi indirizzo IP'
,p_lov_return_value=>'\1.999'
);
end;
/
prompt --application/shared_components/user_interface/lovs/regexp_match_param
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7477530753595662.4504)
,p_lov_name=>'REGEXP_MATCH_PARAM'
,p_lov_query=>'.'||wwv_flow_api.id(7477530753595662.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7477819505595662.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Con distinzione tra maiuscole e minuscole'
,p_lov_return_value=>'c'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7478103965595662.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Senza distinzione tra maiuscole e minuscole'
,p_lov_return_value=>'i'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7478429992595663.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Righe multiple'
,p_lov_return_value=>'m'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7478728314595663.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Carattere jolly di nuova riga'
,p_lov_return_value=>'n'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7479001778595663.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ignora spazio vuoto'
,p_lov_return_value=>'x'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_select
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88095631994062466.4504)
,p_lov_name=>'ROW.SELECT'
,p_lov_query=>'.'||wwv_flow_api.id(88095631994062466.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88095810522062467.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tutte le righe'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88096011165062467.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Righe selezionate'
,p_lov_return_value=>'SELECTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88096206304062468.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Nessuna riga'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rows_percent
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88059704693808617.4504)
,p_lov_name=>'ROWS.PERCENT'
,p_lov_query=>'.'||wwv_flow_api.id(88059704693808617.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88059901028808618.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Percentuale'
,p_lov_return_value=>'percent'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88060116147808618.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Riga'
,p_lov_return_value=>'rows'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sample_data_spreadsheets
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(217855733246275209.4504)
,p_lov_name=>'SAMPLE.DATA.SPREADSHEETS'
,p_lov_query=>'.'||wwv_flow_api.id(217855733246275209.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217856069642275210.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Accademico'
,p_lov_return_value=>'ACADEMIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217856445509275213.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Reparti e dipendenti classici'
,p_lov_return_value=>'DEPT_EMP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217856856420275213.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Formula 1'
,p_lov_return_value=>'F1'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217857246380275213.4504)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Dati di test JSON e strutturati'
,p_lov_return_value=>'JSON_TEST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217857693606275213.4504)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Dati di test solo JSON'
,p_lov_return_value=>'JSON'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217858097098275213.4504)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Cinema'
,p_lov_return_value=>'MOVIE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217858447167275214.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Progetto e task'
,p_lov_return_value=>'PROJECTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217858839052275214.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Vendite'
,p_lov_return_value=>'SALES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217859293900275214.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Tennis'
,p_lov_return_value=>'TENNIS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217859626213275214.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Velocit\00E0 veicolo')
,p_lov_return_value=>'SPEED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217860008215275214.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Mondiali'
,p_lov_return_value=>'WORLDCUP'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217860462659275215.4504)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Popolazione mondiale'
,p_lov_return_value=>'WORLD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/schema_compare_categories
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14728126072025797.4504)
,p_lov_name=>'SCHEMA COMPARE CATEGORIES'
,p_lov_query=>'.'||wwv_flow_api.id(14728126072025797.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14728314552025797.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nomi colonne'
,p_lov_return_value=>'COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14728532416025797.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tabelle'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14728710300025797.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tipi di dati colonna'
,p_lov_return_value=>'DATATYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14839906156999563.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indici'
,p_lov_return_value=>'INDEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14877305584283250.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Funzione'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14929828730535894.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sequenze'
,p_lov_return_value=>'SEQUENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14932013409550455.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16908630581731543.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'PACKAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16908901622732667.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Package body'
,p_lov_return_value=>'PACKAGE BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16909205432733687.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Procedura'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16909507509734338.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tipo'
,p_lov_return_value=>'TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(77467331623506913.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vista'
,p_lov_return_value=>'VIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/script_output_view_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(11936228645031897.4504)
,p_lov_name=>'SCRIPT_OUTPUT_VIEW_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(11936228645031897.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11936413744031900.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Istruzione'
,p_lov_return_value=>'STMT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12078021672086769.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Risultati'
,p_lov_return_value=>'RESULTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11936610007031901.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Feedback'
,p_lov_return_value=>'MSG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/script_result_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16851103836270043.4504)
,p_lov_name=>'SCRIPT_RESULT_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(16851103836270043.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16851311853270045.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sottomissione completata'
,p_lov_return_value=>'SUBMITTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16851527617270045.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Esecuzione in corso'
,p_lov_return_value=>'EXECUTING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16851718446270046.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Completato'
,p_lov_return_value=>'COMPLETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16851904138270047.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Annullato'
,p_lov_return_value=>'CANCELED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/search_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(246393217654948737.4504)
,p_lov_name=>'SEARCH_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(246393217654948737.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246393407696948737.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Corrispondenza maiuscole/minuscole'
,p_lov_return_value=>'CASE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_monitoring_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159923116388036162.4504)
,p_lov_name=>'SESSION MONITORING STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(159923116388036162.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159923408566036193.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tutto'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159923619966036211.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Attivo'
,p_lov_return_value=>'ACTIVE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sga_target_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1417526170798303.4504)
,p_lov_name=>'SGA_TARGET_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(1417526170798303.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1417704549798326.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'64'
,p_lov_return_value=>'64M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1417915382798336.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'128'
,p_lov_return_value=>'128M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1418109764798336.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'192'
,p_lov_return_value=>'192M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1418312463798336.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'256'
,p_lov_return_value=>'256M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1418503267798338.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'320'
,p_lov_return_value=>'320M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1418716837798338.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'384'
,p_lov_return_value=>'384M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1418915626798339.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'448'
,p_lov_return_value=>'448M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1419122341798339.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'512'
,p_lov_return_value=>'512M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_details_checkbox
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(20435801528491678.4504)
,p_lov_name=>'SHOW DETAILS CHECKBOX'
,p_lov_query=>'.'||wwv_flow_api.id(20435801528491678.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20436019847491679.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mostra dettagli'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_difference_only_checkbox
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14974704196733524.4504)
,p_lov_name=>'SHOW DIFFERENCE ONLY CHECKBOX'
,p_lov_query=>'.'||wwv_flow_api.id(14974704196733524.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14974921191733525.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mostra solo differenze'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_tables_with_and_without_comments
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8639918272273372.4504)
,p_lov_name=>'SHOW TABLES WITH AND WITHOUT COMMENTS'
,p_lov_query=>'.'||wwv_flow_api.id(8639918272273372.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8640124542273376.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tabelle con commenti'
,p_lov_return_value=>'WITH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8640331660273378.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Tabelle senza commenti'
,p_lov_return_value=>'WITHOUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8640518874273378.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Tutte le tabelle'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_hide_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88026529019446655.4504)
,p_lov_name=>'SHOW.HIDE.Y.N'
,p_lov_query=>'.'||wwv_flow_api.id(88026529019446655.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88026728054446655.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mostra'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88026921198446656.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nascondi'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sid_service
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(270736905720819349.4504)
,p_lov_name=>'SID_SERVICE'
,p_lov_query=>'.'||wwv_flow_api.id(270736905720819349.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(270737132068819350.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nome servizio'
,p_lov_return_value=>'SERVICE_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(270737303121819350.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SID'
,p_lov_return_value=>'SID'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sql_script_result_view_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(164092723800780852.4504)
,p_lov_name=>'SQL SCRIPT RESULT VIEW MODE'
,p_lov_query=>'.'||wwv_flow_api.id(164092723800780852.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164092906932780860.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Riepilogo'
,p_lov_return_value=>'SUMMARY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164093123083780865.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Dettaglio'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sql_filetype
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88033203570477156.4504)
,p_lov_name=>'SQL.FILETYPE'
,p_lov_query=>'.'||wwv_flow_api.id(88033203570477156.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88033427813477157.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'File di script (*.sql)'
,p_lov_return_value=>'sql'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sql_txt_filetype
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88078901941959255.4504)
,p_lov_name=>'SQL.TXT.FILETYPE'
,p_lov_query=>'.'||wwv_flow_api.id(88078901941959255.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88079103923959257.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'File di testo (*.txt)'
,p_lov_return_value=>'txt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88079307836959257.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'File di script (*.sql)'
,p_lov_return_value=>'sql'
);
end;
/
prompt --application/shared_components/user_interface/lovs/synchronize_defaults_p809
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42723506268079541.4504)
,p_lov_name=>'SYNCHRONIZE DEFAULTS P809'
,p_lov_query=>'.'||wwv_flow_api.id(42723506268079541.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42723726496079548.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Attributi applicazione per valori predefiniti interfaccia utente'
,p_lov_return_value=>'FROM_APP'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#DISPLAY_VALUE#<br />',
'<span style="margin-left:20px;"><img src="#IMAGE_PREFIX#menu/info_64.gif" class="htmldbGreenIcon" alt="#DISPLAY_VALUE#" /></span>'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42723917981079550.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Valori predefiniti interfaccia utente per attributi applicazione'
,p_lov_return_value=>'FROM_DEF'
,p_lov_template=>'#DISPLAY_VALUE#<br /><span style="margin-left:20px;"><img src="#IMAGE_PREFIX#menu/client_64.gif" class="htmldbGreenIcon" alt="#DISPLAY_VALUE#" /></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42726531464105754.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Database per valori predefiniti interfaccia utente'
,p_lov_return_value=>'FROM_DB'
,p_lov_template=>'#DISPLAY_VALUE#<br /><span style="margin-left:20px;"><img src="#IMAGE_PREFIX#menu/db_64.gif" class="htmldbGreenIcon" alt="#DISPLAY_VALUE#" /></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/system_privileges
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(25560713417668203.4504)
,p_lov_name=>'SYSTEM PRIVILEGES'
,p_lov_query=>'.'||wwv_flow_api.id(25560713417668203.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25560932733668206.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE VIEW'
,p_lov_return_value=>'CREATE VIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25561118325668208.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PROCEDURE'
,p_lov_return_value=>'CREATE PROCEDURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25561329462668208.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SYNONYM'
,p_lov_return_value=>'CREATE SYNONYM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25561509484668208.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TABLE'
,p_lov_return_value=>'CREATE TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25561703573668209.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE INDEXTYPE'
,p_lov_return_value=>'CREATE INDEXTYPE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25561918387668209.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SEQUENCE'
,p_lov_return_value=>'CREATE SEQUENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25562101316668209.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE DATABASE LINK'
,p_lov_return_value=>'CREATE DATABASE LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25562309219668209.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TYPE'
,p_lov_return_value=>'CREATE TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25562510373668210.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE MATERIALIZED VIEW'
,p_lov_return_value=>'CREATE MATERIALIZED VIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25562725532668210.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE CLUSTER'
,p_lov_return_value=>'CREATE CLUSTER'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25562915030668210.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TRIGGER'
,p_lov_return_value=>'CREATE TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25563105054668210.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE OPERATOR'
,p_lov_return_value=>'CREATE OPERATOR'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25563322062668210.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE LIBRARY'
,p_lov_return_value=>'CREATE LIBRARY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25563526933668211.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE DIMENSION'
,p_lov_return_value=>'CREATE DIMENSION'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25563701512668211.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE JOB'
,p_lov_return_value=>'CREATE JOB'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25563918014668211.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PROFILE'
,p_lov_return_value=>'CREATE PROFILE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25564128815668211.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PUBLIC DATABASE LINK'
,p_lov_return_value=>'CREATE PUBLIC DATABASE LINK'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25564332270668211.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PUBLIC SYNONYM'
,p_lov_return_value=>'CREATE PUBLIC SYNONYM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25564509385668212.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE ROLE'
,p_lov_return_value=>'CREATE ROLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25564707743668213.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE ROLLBACK SEGMENT'
,p_lov_return_value=>'CREATE ROLLBACK SEGMENT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25564902366668213.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE RULE'
,p_lov_return_value=>'CREATE RULE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25565120530668213.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE RULE SET'
,p_lov_return_value=>'CREATE RULE SET'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25565300473668214.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SESSION'
,p_lov_return_value=>'CREATE SESSION'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25565512486668214.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TABLESPACE'
,p_lov_return_value=>'CREATE TABLESPACE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25565717929668214.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE USER'
,p_lov_return_value=>'CREATE USER'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/table_children
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3694131248687844.4504)
,p_lov_name=>'TABLE_CHILDREN'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''4500_1002_QB_JOIN'')||',
'       '' ''||wwv_flow_escape.html(p.column_name)||',
'       '' ''||wwv_flow_lang.system_message(''4500_1002_QB_TO'')||',
'       '' ''||wwv_flow_escape.html(c.table_name)||''.''||wwv_flow_escape.html(c.column_name) d , t.cid||''|''||c.column_name||''|''||p.column_name r',
'  from sys.dba_cons_columns c,',
'       sys.dba_cons_columns p,',
'       sys.dba_objects o,',
'       ( select c.r_constraint_name pc, ',
'                c.table_name cn, ',
'                c.constraint_name cc,',
'                oo.object_id cid, ',
'                rownum',
'           from sys.dba_constraints c,',
'                sys.dba_objects oo',
'          where c.constraint_type = ''R''',
'            and c.owner = :P59_SCHEMA',
'            and oo.object_name = c.table_name',
'            and oo.owner = c.owner ) t',
' where t.cc             = c.constraint_name',
'   and c.owner          = :P59_SCHEMA',
'   and t.pc             = p.constraint_name',
'   and p.owner          = :P59_SCHEMA',
'   and p.table_name     = :P59_TNAME ',
'   and o.object_name    = p.table_name',
'   and o.owner          = c.owner'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/table_parents
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3693427654677337.4504)
,p_lov_name=>'TABLE_PARENTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select wwv_flow_lang.system_message(''4500_1002_QB_JOIN'')||',
' '' ''||wwv_flow_escape.html(c.column_name)||'' ''||wwv_flow_lang.system_message(''4500_1002_QB_TO'')||',
' '' ''||wwv_flow_escape.html(p.table_name)||''.''||wwv_flow_escape.html(p.column_name) d , o.object_id||''|''||p.column_name||''|''||c.column_name r ',
'from',
'       sys.dba_cons_columns c,',
'       sys.dba_cons_columns p,',
'        sys.dba_objects o,',
'      ( SELECT c.r_constraint_name pc, c.table_name cn , c.constraint_name cc, rownum',
'        FROM sys.dba_constraints c ',
'        WHERE  c.constraint_type = ''R''',
'        AND c.table_name = :P59_TNAME',
'        and c.owner = :P59_SCHEMA ) t',
'where  t.cc = c.constraint_name',
'and c.owner = :P59_SCHEMA',
'and t.pc = p.constraint_name',
'and p.owner = :P59_SCHEMA',
'and o.object_name = p.table_name',
'and o.owner = c.owner'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabular_form_display_types_from_4000
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(197598824193421582.4504)
,p_lov_name=>'TABULAR_FORM_DISPLAY_TYPES (FROM 4000)'
,p_reference_id=>41868019518520883.4504
,p_lov_query=>'.'||wwv_flow_api.id(197598824193421582.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197599231811423843.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Colonna di report standard'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197599400226423843.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Visualizza come testo (basato su LOV, non salva lo stato)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197599610663423843.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Visualizza come testo (salva lo stato)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197599819865423845.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Visualizza come testo (caratteri speciali di escape, non salva lo stato)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197600018265423845.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Selettore data'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197600224897423845.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Campo di testo'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197600423450423845.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Area di testo'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197600606669423845.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Lista di selezione (LOV statica)'
,p_lov_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197600805803423845.4504)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Lista di selezione (LOV denominata)'
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197601002403423845.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lista di selezione (LOV basata su query)'
,p_lov_return_value=>'SELECT_LIST_FROM_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197601201540423846.4504)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Gruppo di scelta (LOV statica)'
,p_lov_return_value=>'RADIOGROUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197601419878423846.4504)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Gruppo di scelta (LOV denominata)'
,p_lov_return_value=>'RADIOGROUP_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197601630729423846.4504)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Gruppo di scelta (LOV basata su query)	'
,p_lov_return_value=>'RADIOGROUP_FROM_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197601813915423846.4504)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Nascosto '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197602006927423846.4504)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'LOV popup (LOV denominata)'
,p_lov_return_value=>'POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197602231429423846.4504)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'LOV popup (LOV basata su query)'
,p_lov_return_value=>'POPUP_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197602405258423846.4504)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'LOV chiave popup (LOV denominata)'
,p_lov_return_value=>'POPUPKEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197602612872423846.4504)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'LOV chiave popup (LOV basata su query) '
,p_lov_return_value=>'POPUPKEY_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/top_sql_by
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(236910808625037522.4504)
,p_lov_name=>'TOP_SQL_BY'
,p_lov_query=>'.'||wwv_flow_api.id(236910808625037522.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236911029447037524.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tempo CPU'
,p_lov_return_value=>'CPU_TIME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236911210865037524.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Letture disco'
,p_lov_return_value=>'DISK_READS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236911407417037525.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Esecuzioni'
,p_lov_return_value=>'EXECUTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236911618778037525.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Richieste buffer'
,p_lov_return_value=>'BUFFER_GETS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236911815989037525.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Richieste buffer/righe elaborate'
,p_lov_return_value=>'EFFICIENCY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236912011147037525.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Richieste buffer/esecuzioni'
,p_lov_return_value=>'EFFICIENCY2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/type_available
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16945125859541385.4504)
,p_lov_name=>'TYPE_AVAILABLE'
,p_lov_query=>'select wwv_flow_escape.html(type_name) d, type_name r from sys.dba_types where owner = :OB_SCHEMA'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/type_collection_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16529130513602905.4504)
,p_lov_name=>'TYPE_COLLECTION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(16529130513602905.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16529302646602905.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Varray'
,p_lov_return_value=>'V'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16529528167602906.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tabella nidificata'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/type_data_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16534820904659665.4504)
,p_lov_name=>'TYPE_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(16534820904659665.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16535002611659667.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'BFILE'
,p_lov_return_value=>'BFILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16535213310659667.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'BLOB'
,p_lov_return_value=>'BLOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16535418281659667.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'CHAR'
,p_lov_return_value=>'CHAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16535626402659668.4504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16535817963659668.4504)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16536022932659668.4504)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'DECIMAL'
,p_lov_return_value=>'DECIMAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16536213254659668.4504)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'DOUBLE PRECISION'
,p_lov_return_value=>'DOUBLE PRECISION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16536400283659668.4504)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'FLOAT'
,p_lov_return_value=>'FLOAT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16536606880659669.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'INTEGER'
,p_lov_return_value=>'INTEGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16536824560659669.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16547232731688790.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'REAL'
,p_lov_return_value=>'REAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16547507582690914.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'SMALLINT'
,p_lov_return_value=>'SMALLINT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16547811738692161.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'RAW'
,p_lov_return_value=>'RAW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16548116240693431.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16548420395694645.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'REF'
,p_lov_return_value=>'REF'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16548730785697678.4504)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'< oggetto nidificato >'
,p_lov_return_value=>'NEST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/type_of_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16521502229452853.4504)
,p_lov_name=>'TYPE_OF_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(16521502229452853.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16521731440452856.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tipo di collection'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16521925201452858.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tipo di oggetto'
,p_lov_return_value=>'O'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_default_exp_imp_formats
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(40883415986261937.4504)
,p_lov_name=>'UI DEFAULT EXP IMP FORMATS'
,p_lov_query=>'.'||wwv_flow_api.id(40883415986261937.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40883610383262047.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Unix'
,p_lov_return_value=>'UNIX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40883829969262053.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40884027551262053.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Database'
,p_lov_return_value=>'DB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_alignment_left_center_right
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(251500722928507973.4504)
,p_lov_name=>'UI_DEF_ALIGNMENT_LEFT_CENTER_RIGHT'
,p_lov_query=>'.'||wwv_flow_api.id(251500722928507973.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251500919515507973.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'A sinistra'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251501105156507973.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Al centro'
,p_lov_return_value=>'CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251501300215507973.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'A destra'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_alignment_l_c_r
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(260501806598530292.4504)
,p_lov_name=>'UI_DEF_ALIGNMENT_L_C_R'
,p_lov_query=>'.'||wwv_flow_api.id(260501806598530292.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(260502019605530294.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'A sinistra'
,p_lov_return_value=>'L'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(260502229771530295.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Al centro'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(260502407085530295.4504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'A destra'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_display_as_tabular_forms
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(251435312257287190.4504)
,p_lov_name=>'UI_DEF_DISPLAY_AS_TABULAR_FORMS'
,p_lov_query=>'.'||wwv_flow_api.id(251435312257287190.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17234522425911770.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Gruppo di scelta (LOV denominata)'
,p_lov_return_value=>'RADIOGROUP_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251435518816287190.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Colonna di report standard (sola visualizzazione, non salva lo stato)'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251435707171287190.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Visualizza come testo (basato su LOV, non salva lo stato)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251435904461287190.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Visualizza come testo (salva lo stato)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251436131397287190.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Visualizza come testo (caratteri speciali di escape, non salva lo stato)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251436331018287190.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Campo di testo'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251436513801287190.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area di testo'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251436712096287191.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista di selezione'
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251436921215287191.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nascosto '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251437110722287191.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'LOV popup'
,p_lov_return_value=>'POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251437316775287191.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (classico)'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251437506052287191.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (utilizza il formato di visualizzazione per le applicazioni)'
,p_lov_return_value=>'PICK_DATE_USING_APP_FORMAT_MASK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251437713738287195.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-RR)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251437928196287195.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-RR HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251438122869287195.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-RR HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251438327137287195.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH24_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251438527222287195.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251438708379287195.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251438921019287195.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251439126695287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251439305041287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MON-YY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251439508577287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD/MM/YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251439705601287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD/MM/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251439912743287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD/MM/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251440126520287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (MM/DD/YYYY)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251440332088287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (MM/DD/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251440513083287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (MM/DD/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251440720307287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (RR-MON-DD)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251440914527287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (RR-MON-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251441107529287196.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (RR-MON-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251441327665287197.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY-MM-DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251441519610287197.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY-MM-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251441716061287197.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY-MM-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251441922940287197.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MM-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251442121133287197.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MM-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251442323229287197.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD-MM-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251442518523287197.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD.MM.YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251442702648287197.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD.MM.YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251442915305287199.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (DD.MM.YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251443114390287199.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY.DD.MM)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251443317438287199.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY.DD.MM HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH24_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251443530076287199.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY.DD.MM HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251443706296287199.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY/MM/DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251443923019287199.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY/MM/DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251444119218287199.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (YYYY/MM/DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251444312958287199.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data (utilizza il formato data dell''applicazione)'
,p_lov_return_value=>'PICK_DATE_USING_APP_DATE_FORMAT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(619426426716882935.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selettore data'
,p_lov_return_value=>'DATE_PICKER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17235123595921491.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'LOV chiave popup (LOV denominata)'
,p_lov_return_value=>'POPUPKEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17235632599924147.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Casella di controllo semplice'
,p_lov_return_value=>'SIMPLE_CHECKBOX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_static_dynamic
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(251523907288749450.4504)
,p_lov_name=>'UI_DEF_STATIC_DYNAMIC'
,p_lov_query=>'.'||wwv_flow_api.id(251523907288749450.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251524122983749452.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Statico'
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251524330798749453.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Dinamico'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/unique
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88045300809552005.4504)
,p_lov_name=>'UNIQUE'
,p_lov_query=>'.'||wwv_flow_api.id(88045300809552005.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88045530124552006.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Univocit\00E0')
,p_lov_return_value=>'UNIQUE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/unix_dos
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88081812938981328.4504)
,p_lov_name=>'UNIX.DOS'
,p_lov_query=>'.'||wwv_flow_api.id(88081812938981328.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88082021798981329.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88082214036981329.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'UNIX'
,p_lov_return_value=>'UNIX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/user_interface_form_defaults_sync_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(40766106443619635.4504)
,p_lov_name=>'USER INTERFACE FORM DEFAULTS SYNC OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(40766106443619635.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40766308005619649.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Etichetta'
,p_lov_return_value=>'LABEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40766500283619653.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Visualizza come'
,p_lov_return_value=>'DISPLAY_AS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40766713910619654.4504)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Sequenza di visualizzazione form'
,p_lov_return_value=>'FORM_DISPLAY_SEQUENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40766902092619654.4504)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Larghezza elemento'
,p_lov_return_value=>'ELEMENT_WIDTH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40767122890619654.4504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Larghezza massima elemento'
,p_lov_return_value=>'ELEMENT_MAX_WIDTH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40767319691619654.4504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Altezza elemento'
,p_lov_return_value=>'ELEMENT_HEIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40767510229619654.4504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Allineamento'
,p_lov_return_value=>'ITEM_ALIGNMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40767731122619654.4504)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Testo Guida'
,p_lov_return_value=>'HELP_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40767913178619654.4504)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Gruppo di colonne'
,p_lov_return_value=>'COLUMN_GROUP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_detail_summary
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(183733207435875441.4504)
,p_lov_name=>'VIEW_DETAIL_SUMMARY'
,p_lov_query=>'.'||wwv_flow_api.id(183733207435875441.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183733411221875446.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dettaglio'
,p_lov_return_value=>'DETAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183733609162875449.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Riepilogo'
,p_lov_return_value=>'SUMMARY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_credentials_for_dbms_cloud
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3034883284660886.4504)
,p_lov_name=>'WEB_CREDENTIALS_FOR_DBMS_CLOUD'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       authentication_type,',
'       client_id',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID',
'   and authentication_type in (''OCI'', ''BASIC'')'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(3035303136662958.4504)
,p_query_column_name=>'ID'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(3035790565662962.4504)
,p_query_column_name=>'NAME'
,p_heading=>'Nome'
,p_display_sequence=>20
,p_data_type=>'VARCHAR2'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(3036173161662962.4504)
,p_query_column_name=>'AUTHENTICATION_TYPE'
,p_heading=>'Tipo di autenticazione'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(3036569773662962.4504)
,p_query_column_name=>'CLIENT_ID'
,p_heading=>'ID utente'
,p_display_sequence=>40
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/y_n_returns_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88037119678519608.4504)
,p_lov_name=>'Y.N.RETURNS.Y.N'
,p_lov_query=>'.'||wwv_flow_api.id(88037119678519608.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88037301694519609.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00EC')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88037513209519609.4504)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_true_false
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(550748599416480697.4504)
,p_lov_name=>'YES NO TRUE FALSE'
,p_lov_query=>'.'||wwv_flow_api.id(550748599416480697.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(550748896421480698.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00EC')
,p_lov_return_value=>'TRUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(550749224337480699.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'FALSE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23482928300634173.4504)
,p_lov_name=>'YES.NO.RETURNS.Y.N'
,p_lov_query=>'.'||wwv_flow_api.id(23482928300634173.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23483215241634177.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00EC')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23483425275634179.4504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_checkbox
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(270681628960428645.4504)
,p_lov_name=>'YES_CHECKBOX'
,p_lov_query=>'.'||wwv_flow_api.id(270681628960428645.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(270681822685428648.4504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00EC')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/y_noprompt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88018003898325845.4504)
,p_lov_name=>'Y_NOPROMPT'
,p_lov_query=>'.'||wwv_flow_api.id(88018003898325845.4504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88018226427325846.4504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;',
'',
''))
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/sql_workshop_breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(6696510824685479.4504)
,p_name=>'sql.workshop.breadcrumb'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(772329493998247.4504)
,p_parent_id=>wwv_flow_api.id(.4504)
,p_short_name=>'<span class="u-VisuallyHidden">SQL Workshop</span><span class="a-Icon icon-breadcrumb-previous" title="SQL Workshop"></span>'
,p_link=>'f?p=&APP_ID.:3002:&SESSION.::&DEBUG.:::'
,p_page_id=>3002
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2107388801517405.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Carica dall''area di memorizzazione degli oggetti'
,p_link=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:3130::'
,p_page_id=>3130
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2234766158770718.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Carica dall''area di memorizzazione degli oggetti'
,p_link=>'f?p=&APP_ID.:3132:&SESSION.::&DEBUG.:::'
,p_page_id=>3132
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2632992076169026.4504)
,p_parent_id=>wwv_flow_api.id(2107388801517405.4504)
,p_short_name=>'Rivedi tabella esterna'
,p_link=>'f?p=&APP_ID.:3140:&SESSION.::&DEBUG.:::'
,p_page_id=>3140
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4709605602573478.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea indice'
,p_link=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:::'
,p_page_id=>224
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4709841898578229.4504)
,p_parent_id=>wwv_flow_api.id(10588828468855036.4504)
,p_short_name=>'Crea indice'
,p_link=>'f?p=&APP_ID.:225:&SESSION.::&DEBUG.:::'
,p_page_id=>225
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4710097667581102.4504)
,p_parent_id=>wwv_flow_api.id(4709605602573478.4504)
,p_short_name=>'Metadati spaziali'
,p_link=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.:::'
,p_page_id=>226
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4710253413583531.4504)
,p_parent_id=>wwv_flow_api.id(4709605602573478.4504)
,p_short_name=>'Metadati spaziali'
,p_link=>'f?p=&APP_ID.:227:&SESSION.::&DEBUG.:::'
,p_page_id=>227
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6705201527713238.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Dizionario dati'
,p_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_page_id=>13
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6706426100716981.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Tutti gli oggetti'
,p_link=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:::'
,p_page_id=>500
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6811015570619086.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Genera DDL'
,p_link=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:::'
,p_page_id=>18
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6812109315622008.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Genera DDL'
,p_link=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::'
,p_page_id=>43
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6813302846625021.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Genera DDL'
,p_link=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:::'
,p_page_id=>44
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6814424184630342.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Genera DDL'
,p_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:::'
,p_page_id=>29
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8926117673071967.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Privilegi di oggetto'
,p_link=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::'
,p_page_id=>1401
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8952218341276601.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Privilegi di colonna'
,p_link=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::'
,p_page_id=>1402
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8971325993409812.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Privilegi di ruolo'
,p_link=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.:::'
,p_page_id=>1502
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10124106014708590.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Gestisci risultati script'
,p_link=>'f?p=&APP_ID.:1220:&SESSION.::&DEBUG.:1220::'
,p_page_id=>1220
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10588828468855036.4504)
,p_parent_id=>wwv_flow_api.id(.4504)
,p_short_name=>'<span class="u-VisuallyHidden">Home</span><span class="a-Icon icon-breadcrumb-previous" title="Home"></span>'
,p_link=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_page_id=>1000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10589915313861129.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Browser oggetti'
,p_link=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.:::'
,p_page_id=>1001
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10592208399879519.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Comandi SQL'
,p_link=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.:::'
,p_page_id=>1003
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10593427149886024.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Script SQL'
,p_link=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_page_id=>1004
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10594829078900305.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Utility'
,p_link=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.:::'
,p_page_id=>1005
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10596216354906213.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Query Builder'
,p_link=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.:::'
,p_page_id=>1002
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10992323079081645.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Carica script'
,p_link=>'f?p=&FLOW_ID.:1017:&SESSION.'
,p_page_id=>1017
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11068702995513360.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Oggetti non validi'
,p_link=>'f?p=&APP_ID.:1040:&SESSION.::&DEBUG.:::'
,p_page_id=>1040
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11085502299574373.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Report oggetti'
,p_link=>'f?p=&APP_ID.:1042:&SESSION.::&DEBUG.:::'
,p_page_id=>1042
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11149705248454307.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Argomenti program unit PL/SQL'
,p_link=>'f?p=&APP_ID.:1046:&SESSION.::&DEBUG.:::'
,p_page_id=>1046
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11153616234464356.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Colonne tabelle'
,p_link=>'f?p=&APP_ID.:1047:&SESSION.::&DEBUG.:::'
,p_page_id=>1047
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11217630077734286.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Dimensioni memorizzazione tabelle'
,p_link=>'f?p=&APP_ID.:1048:&SESSION.::&DEBUG.:::'
,p_page_id=>1048
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11288509439457981.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Statistiche tabelle'
,p_link=>'f?p=&APP_ID.:1052:&SESSION.::&DEBUG.:::'
,p_page_id=>1052
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11326702174643629.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Conteggi righe program unit PL/SQL'
,p_link=>'f?p=&APP_ID.:1054:&SESSION.::&DEBUG.:::'
,p_page_id=>1054
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11338430795706423.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Calendario creazione oggetti'
,p_link=>'f?p=&APP_ID.:1055:&SESSION.::&DEBUG.:::'
,p_page_id=>1055
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11357823604800886.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Conteggi di oggetti per tipo'
,p_link=>'f?p=&APP_ID.:1059:&SESSION.::&DEBUG.:::'
,p_page_id=>1059
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11399029987478216.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Cestino'
,p_link=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.:::'
,p_page_id=>1070
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11862912827302953.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Risultati'
,p_link=>'f?p=&APP_ID.:1225:&SESSION.::&DEBUG.:::'
,p_page_id=>1225
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14636719155541383.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Confronto degli schemi'
,p_link=>'f?p=&FLOW_ID.:1350:&SESSION.'
,p_page_id=>1350
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17981116039285577.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Commenti tabella'
,p_link=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.:::'
,p_page_id=>701
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(18641121311026961.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Tabelle senza chiavi primarie'
,p_link=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:::'
,p_page_id=>702
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(18645002872040514.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Chiavi esterne non indicizzate'
,p_link=>'f?p=&APP_ID.:704:&SESSION.::&DEBUG.:::'
,p_page_id=>704
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(20466103415554205.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Login amministratore del database'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>1
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(21105931218170005.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Vincoli tabelle'
,p_link=>'f?p=&APP_ID.:706:&SESSION.::&DEBUG.:::'
,p_page_id=>706
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(21759901986574992.4504)
,p_parent_id=>wwv_flow_api.id(6706426100716981.4504)
,p_short_name=>'Crea riga'
,p_link=>'f?p=&FLOW_ID.:51:&SESSION.'
,p_page_id=>51
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22279723159373331.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Esegui script'
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22285026166387102.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Editor degli script'
,p_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_page_id=>60
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22511901715091409.4504)
,p_parent_id=>wwv_flow_api.id(6705201527713238.4504)
,p_short_name=>'Browser dizionario dati'
,p_link=>'f?p=&FLOW_ID.:14:&SESSION.'
,p_page_id=>14
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22513030170093436.4504)
,p_parent_id=>wwv_flow_api.id(6705201527713238.4504)
,p_short_name=>'Browser dizionario dati'
,p_link=>'f?p=&FLOW_ID.:15:&SESSION.'
,p_page_id=>15
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27996403095868309.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Script non valido'
,p_link=>'f?p=&APP_ID.:1022:&SESSION.::&DEBUG.:::'
,p_page_id=>1022
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28034702528035781.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Analizza script'
,p_link=>'f?p=&FLOW_ID.:1023:&SESSION.'
,p_page_id=>1023
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28148306201885508.4504)
,p_parent_id=>wwv_flow_api.id(10588828468855036.4504)
,p_short_name=>'Cerca'
,p_link=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:::'
,p_page_id=>8000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(29042426642278445.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Tabelle senza indici'
,p_link=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.:::'
,p_page_id=>707
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40285323892651842.4504)
,p_parent_id=>wwv_flow_api.id(421010727467722425.4504)
,p_short_name=>'Dizionario tabelle'
,p_link=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_page_id=>800
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40292805535877838.4504)
,p_parent_id=>wwv_flow_api.id(40285323892651842.4504)
,p_short_name=>'Crea valori predefiniti'
,p_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_page_id=>801
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40299503213041788.4504)
,p_parent_id=>wwv_flow_api.id(40285323892651842.4504)
,p_short_name=>unistr('Propriet\00E0 tabella e colonna')
,p_link=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
,p_page_id=>802
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40567512492661701.4504)
,p_parent_id=>wwv_flow_api.id(40299503213041788.4504)
,p_short_name=>'Valori predefiniti colonne'
,p_link=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:::'
,p_page_id=>803
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40643306074424515.4504)
,p_parent_id=>wwv_flow_api.id(40299503213041788.4504)
,p_short_name=>'Dettagli'
,p_link=>'f?p=&APP_ID.:804:&SESSION.::&DEBUG.:::'
,p_page_id=>804
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40820227368905885.4504)
,p_parent_id=>wwv_flow_api.id(40299503213041788.4504)
,p_short_name=>'Rimuovi'
,p_link=>'f?p=&APP_ID.:830:&SESSION.::&DEBUG.:::'
,p_page_id=>830
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40837720793349176.4504)
,p_parent_id=>wwv_flow_api.id(40299503213041788.4504)
,p_short_name=>'Gruppi di colonne'
,p_link=>'f?p=&FLOW_ID.:805:&SESSION.'
,p_page_id=>805
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40849914508722527.4504)
,p_parent_id=>wwv_flow_api.id(40285323892651842.4504)
,p_short_name=>'Sincronizza valori predefiniti'
,p_link=>'f?p=&APP_ID.:840:&SESSION.::&DEBUG.:::'
,p_page_id=>840
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40878107658219856.4504)
,p_parent_id=>wwv_flow_api.id(40285323892651842.4504)
,p_short_name=>'Esporta'
,p_link=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.:::'
,p_page_id=>841
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40882008035232666.4504)
,p_parent_id=>wwv_flow_api.id(40285323892651842.4504)
,p_short_name=>'Importa'
,p_link=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_page_id=>842
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40886501144281716.4504)
,p_parent_id=>wwv_flow_api.id(40285323892651842.4504)
,p_short_name=>'Importa'
,p_link=>'f?p=&APP_ID.:843:&SESSION.::&DEBUG.:::'
,p_page_id=>843
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(69179911399462494.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Tabelle senza trigger'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
,p_page_id=>2
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(72162217233653931.4504)
,p_parent_id=>wwv_flow_api.id(11399029987478216.4504)
,p_short_name=>'Oggetti eliminati'
,p_link=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::'
,p_page_id=>400
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(75123728807801147.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Genera DDL'
,p_link=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:::'
,p_page_id=>45
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(111995318366763047.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Genera DDL'
,p_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_page_id=>12
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(133761526646244887.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Controllo database'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(134582607728955084.4504)
,p_parent_id=>wwv_flow_api.id(133761526646244887.4504)
,p_short_name=>'Prime istruzioni SQL'
,p_link=>'f?p=&FLOW_ID.:21:&SESSION.'
,p_page_id=>21
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(137474117958285727.4504)
,p_parent_id=>wwv_flow_api.id(133761526646244887.4504)
,p_short_name=>'Operazioni di lunga durata'
,p_link=>'f?p=&FLOW_ID.:34:&SESSION.'
,p_page_id=>34
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(143179626108764932.4504)
,p_parent_id=>wwv_flow_api.id(72162217233653931.4504)
,p_short_name=>'Dettagli oggetto'
,p_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_page_id=>401
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(143180608231769218.4504)
,p_parent_id=>wwv_flow_api.id(11399029987478216.4504)
,p_short_name=>'Svuota cestino'
,p_link=>'f?p=&APP_ID.:403:&SESSION.::&DEBUG.:::'
,p_page_id=>403
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(150053105689895122.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Quota script'
,p_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_page_id=>31
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(159591503203412870.4504)
,p_parent_id=>wwv_flow_api.id(133761526646244887.4504)
,p_short_name=>'Sessioni'
,p_link=>'f?p=&FLOW_ID.:540:&SESSION.'
,p_page_id=>540
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(159755809418519186.4504)
,p_parent_id=>wwv_flow_api.id(159591503203412870.4504)
,p_short_name=>'Dettagli sessioni'
,p_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.:::'
,p_page_id=>550
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(159933105269080223.4504)
,p_parent_id=>wwv_flow_api.id(159591503203412870.4504)
,p_short_name=>'Termina sessione'
,p_link=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.:::'
,p_page_id=>549
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(160130313889480180.4504)
,p_parent_id=>wwv_flow_api.id(159591503203412870.4504)
,p_short_name=>'SQL'
,p_link=>'f?p=&APP_ID.:542:&SESSION.::&DEBUG.:::'
,p_page_id=>542
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(160176710875611770.4504)
,p_parent_id=>wwv_flow_api.id(159591503203412870.4504)
,p_short_name=>'I/O'
,p_link=>'f?p=&APP_ID.:545:&SESSION.::&DEBUG.:::'
,p_page_id=>545
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(160179326112616109.4504)
,p_parent_id=>wwv_flow_api.id(159591503203412870.4504)
,p_short_name=>'Lock'
,p_link=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.:::'
,p_page_id=>541
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(160301306026960460.4504)
,p_parent_id=>wwv_flow_api.id(159591503203412870.4504)
,p_short_name=>'Cursori aperti'
,p_link=>'f?p=&APP_ID.:543:&SESSION.::&DEBUG.:::'
,p_page_id=>543
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(160475100044505141.4504)
,p_parent_id=>wwv_flow_api.id(160130313889480180.4504)
,p_short_name=>'Piano SQL'
,p_link=>'f?p=&FLOW_ID.:551:&SESSION.'
,p_page_id=>551
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(160542529171631000.4504)
,p_parent_id=>wwv_flow_api.id(160301306026960460.4504)
,p_short_name=>'Dettagli cursore'
,p_link=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.:::'
,p_page_id=>546
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(163508316960932084.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Cerca nel codice sorgente PL/SQL'
,p_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_page_id=>27
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(164008763793256066.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Gestisci dati di esempio'
,p_link=>'f?p=&APP_ID.:200:&SESSION.'
,p_page_id=>200
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(164035265026435705.4504)
,p_parent_id=>wwv_flow_api.id(164008763793256066.4504)
,p_short_name=>'Gestisci data set'
,p_link=>'f?p=&APP_ID.:201:&SESSION.'
,p_page_id=>201
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168883113098410783.4504)
,p_parent_id=>wwv_flow_api.id(159591503203412870.4504)
,p_short_name=>'Attese'
,p_link=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.:::'
,p_page_id=>548
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171425301256234951.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tabella'
,p_link=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::'
,p_page_id=>602
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171432228380283077.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tabella'
,p_link=>'f?p=&FLOW_ID.:604:&SESSION.'
,p_page_id=>604
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171436029446297824.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tabella'
,p_link=>'f?p=&FLOW_ID.:145:&SESSION.'
,p_page_id=>145
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171436513056305383.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tabella'
,p_link=>'f?p=&FLOW_ID.:149:&SESSION.'
,p_page_id=>149
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171439824030330759.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tabella'
,p_link=>'f?p=&FLOW_ID.:612:&SESSION.'
,p_page_id=>612
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171447012119396992.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea vista'
,p_link=>'f?p=&FLOW_ID.:48:&SESSION.'
,p_page_id=>48
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171448512957426996.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea vista'
,p_link=>'f?p=&FLOW_ID.:52:&SESSION.'
,p_page_id=>52
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171451019402454341.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea indice'
,p_link=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_page_id=>57
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171451828016465595.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea indice'
,p_link=>'f?p=&FLOW_ID.:77:&SESSION.'
,p_page_id=>77
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171454530592479551.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea indice'
,p_link=>'f?p=&FLOW_ID.:5:&SESSION.'
,p_page_id=>5
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171458922803513607.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea indice di testo'
,p_link=>'f?p=&FLOW_ID.:94:&SESSION.'
,p_page_id=>94
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171460222144529128.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea sequenza'
,p_link=>'f?p=&FLOW_ID.:97:&SESSION.'
,p_page_id=>97
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171460904244537406.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea sequenza'
,p_link=>'f?p=&FLOW_ID.:116:&SESSION.'
,p_page_id=>116
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171482002943811468.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:::'
,p_page_id=>120
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171486607219855054.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:::'
,p_page_id=>124
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171488126185861375.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.:::'
,p_page_id=>125
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171490019475894957.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tipo'
,p_link=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.:::'
,p_page_id=>182
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171491323548923460.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tipo di collection'
,p_link=>'f?p=&FLOW_ID.:183:&SESSION.'
,p_page_id=>183
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171493008870945443.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tipo di collection'
,p_link=>'f?p=&APP_ID.:184:&SESSION.::&DEBUG.:::'
,p_page_id=>184
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171494726973952173.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea procedura'
,p_link=>'f?p=&FLOW_ID.:121:&SESSION.'
,p_page_id=>121
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171495932353964930.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea procedura'
,p_link=>'f?p=&FLOW_ID.:122:&SESSION.'
,p_page_id=>122
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171496821570969952.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea procedura'
,p_link=>'f?p=&FLOW_ID.:123:&SESSION.'
,p_page_id=>123
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171497832340980133.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea procedura'
,p_link=>'f?p=&FLOW_ID.:114:&SESSION.'
,p_page_id=>114
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171499512487004501.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea funzione'
,p_link=>'f?p=&FLOW_ID.:98:&SESSION.'
,p_page_id=>98
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171500106017007485.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea funzione'
,p_link=>'f?p=&FLOW_ID.:107:&SESSION.'
,p_page_id=>107
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171500730159011487.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea funzione'
,p_link=>'f?p=&FLOW_ID.:100:&SESSION.'
,p_page_id=>100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171501317866017225.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea procedura'
,p_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::'
,p_page_id=>110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171504210725050867.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea funzione'
,p_link=>'f?p=&FLOW_ID.:109:&SESSION.'
,p_page_id=>109
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171505125809059139.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea trigger'
,p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_page_id=>3
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171507121649137024.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Disabilita trigger'
,p_link=>'f?p=&FLOW_ID.:85:&SESSION.'
,p_page_id=>85
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171510925088150539.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea trigger'
,p_link=>'f?p=&FLOW_ID.:84:&SESSION.'
,p_page_id=>84
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171512816233169881.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea database link'
,p_link=>'f?p=&FLOW_ID.:91:&SESSION.'
,p_page_id=>91
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171513601137176883.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea database link'
,p_link=>'f?p=&FLOW_ID.:92:&SESSION.'
,p_page_id=>92
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171516113201186517.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea vista materializzata'
,p_link=>'f?p=&FLOW_ID.:135:&SESSION.'
,p_page_id=>135
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171517422678197296.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea vista materializzata'
,p_link=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.:::'
,p_page_id=>136
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171518216424200174.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea sinonimo'
,p_link=>'f?p=&FLOW_ID.:99:&SESSION.'
,p_page_id=>99
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171522218137214533.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea sinonimo'
,p_link=>'f?p=&FLOW_ID.:127:&SESSION.'
,p_page_id=>127
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(172518105625045296.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Informazioni sul database'
,p_link=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:::'
,p_page_id=>36
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(182583013828345804.4504)
,p_parent_id=>wwv_flow_api.id(133761526646244887.4504)
,p_short_name=>'Statistiche di sistema'
,p_link=>'f?p=&APP_ID.:560:&SESSION.::&DEBUG.:::'
,p_page_id=>560
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(196241518637196386.4504)
,p_parent_id=>wwv_flow_api.id(421010727467722425.4504)
,p_short_name=>'Dizionario attributi'
,p_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::'
,p_page_id=>6
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(197565613605290234.4504)
,p_parent_id=>wwv_flow_api.id(196241518637196386.4504)
,p_short_name=>'Dettagli colonna'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200281305325646013.4504)
,p_parent_id=>wwv_flow_api.id(197565613605290234.4504)
,p_short_name=>'Sinonimo'
,p_link=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:::'
,p_page_id=>30
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201423513077254455.4504)
,p_parent_id=>wwv_flow_api.id(40299503213041788.4504)
,p_short_name=>'Valori predefiniti tabelle'
,p_link=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:::'
,p_page_id=>19
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201465410091357808.4504)
,p_parent_id=>wwv_flow_api.id(40285323892651842.4504)
,p_short_name=>'Esegui migrazione'
,p_link=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::'
,p_page_id=>32
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201468702160374868.4504)
,p_parent_id=>wwv_flow_api.id(201465410091357808.4504)
,p_short_name=>'Conferma'
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_page_id=>33
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(203665020594989187.4504)
,p_parent_id=>wwv_flow_api.id(10588828468855036.4504)
,p_short_name=>'Imposta periodo di tempo di report nella home page'
,p_link=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::'
,p_page_id=>35
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(221315102551645720.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Esporta script SQL'
,p_link=>'f?p=&FLOW_ID.:65:&SESSION.'
,p_page_id=>65
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(221325920426667820.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Importa script'
,p_link=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:::'
,p_page_id=>112
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(222573212803039290.4504)
,p_parent_id=>wwv_flow_api.id(10593427149886024.4504)
,p_short_name=>'Importa script'
,p_link=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:::'
,p_page_id=>115
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(239008520667654108.4504)
,p_parent_id=>wwv_flow_api.id(11085502299574373.4504)
,p_short_name=>'Privilegi di sistema'
,p_link=>'f?p=&APP_ID.:1404:&SESSION.::&DEBUG.:::'
,p_page_id=>1404
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(262136511357898947.4504)
,p_parent_id=>wwv_flow_api.id(196241518637196386.4504)
,p_short_name=>'Modifica griglia'
,p_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::'
,p_page_id=>28
);
end;
/
begin
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(293412507991016597.4504)
,p_parent_id=>wwv_flow_api.id(40567512492661701.4504)
,p_short_name=>'Lista di valori statica'
,p_link=>'f?p=&FLOW_ID.:37:&SESSION.'
,p_page_id=>37
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(421010727467722425.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Valori predefiniti interfaccia utente'
,p_link=>'f?p=&APP_ID.:813:&SESSION.::&DEBUG.:::'
,p_page_id=>813
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(428883026446520866.4504)
,p_parent_id=>wwv_flow_api.id(40567512492661701.4504)
,p_short_name=>'Crea lista di valori statica'
,p_link=>'f?p=&FLOW_ID.:40:&SESSION.'
,p_page_id=>40
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(429083825310173254.4504)
,p_parent_id=>wwv_flow_api.id(40299503213041788.4504)
,p_short_name=>'Sincronizza con database'
,p_link=>'f?p=&APP_ID.:807:&SESSION.::&DEBUG.:::'
,p_page_id=>807
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(442018226743378979.4504)
,p_parent_id=>wwv_flow_api.id(196241518637196386.4504)
,p_short_name=>'Esporta'
,p_link=>'f?p=&FLOW_ID.:39:&SESSION.'
,p_page_id=>39
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(442035418735604919.4504)
,p_parent_id=>wwv_flow_api.id(196241518637196386.4504)
,p_short_name=>'Importa'
,p_link=>'f?p=&FLOW_ID.:41:&SESSION.'
,p_page_id=>41
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(442061305390114586.4504)
,p_parent_id=>wwv_flow_api.id(196241518637196386.4504)
,p_short_name=>'Importa'
,p_link=>'f?p=&FLOW_ID.:56:&SESSION.'
,p_page_id=>56
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(460475029741643216.4504)
,p_parent_id=>wwv_flow_api.id(17981116039285577.4504)
,p_short_name=>'Modifica'
,p_link=>'f?p=&FLOW_ID.:70:&SESSION.'
,p_page_id=>70
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(479591118396883844.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea database link'
,p_link=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:::'
,p_page_id=>58
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480554732367338960.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tabella'
,p_link=>'f?p=&APP_ID.:614:&SESSION.::&DEBUG.:::'
,p_page_id=>614
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480558704933425630.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea vista'
,p_link=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:::'
,p_page_id=>54
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480564400225509403.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea indice'
,p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::'
,p_page_id=>4
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480645807666823734.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea sequenza'
,p_link=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:::'
,p_page_id=>129
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480707610492928646.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea tipo di collection'
,p_link=>'f?p=&APP_ID.:185:&SESSION.::&DEBUG.:::'
,p_page_id=>185
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480709530381095227.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea trigger'
,p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_page_id=>9
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480710828828132548.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea trigger'
,p_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
,p_page_id=>16
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(481056418596783126.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea vista materializzata'
,p_link=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:::'
,p_page_id=>141
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(481059006270864712.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea sinonimo'
,p_link=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::'
,p_page_id=>8
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(492587017575861321.4504)
,p_parent_id=>wwv_flow_api.id(10588828468855036.4504)
,p_short_name=>'Controlla aggiornamenti disponibili'
,p_link=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_page_id=>61
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1081401622843630208.4504)
,p_parent_id=>wwv_flow_api.id(10588828468855036.4504)
,p_short_name=>'Crea funzione'
,p_link=>'f?p=&APP_ID.:62:&SESSION.'
,p_page_id=>62
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1082294870183550455.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:117:&SESSION.::&DEBUG.:::'
,p_page_id=>117
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1082295312410555994.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1082295582684558595.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_page_id=>131
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1082296216976562127.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:186:&SESSION.::&DEBUG.:::'
,p_page_id=>186
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1082296445019564164.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:187:&SESSION.::&DEBUG.:::'
,p_page_id=>187
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1104480510265001727.4504)
,p_parent_id=>wwv_flow_api.id(772329493998247.4504)
,p_short_name=>'Crea package'
,p_link=>'f?p=&APP_ID.:126:&SESSION.::&DEBUG.:::'
,p_page_id=>126
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4213233088501710020.4504)
,p_parent_id=>wwv_flow_api.id(10594829078900305.4504)
,p_short_name=>'Quick SQL'
,p_link=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_page_id=>1100
);
end;
/
prompt --application/shared_components/navigation/breadcrumbs/alternative_sql_plan
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(238735327519050534.4504)
,p_name=>'Alternative SQL Plan'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(238744703025100258.4504)
,p_parent_id=>wwv_flow_api.id(239011303829658740.4504)
,p_short_name=>'Controllo database'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(238747600732109040.4504)
,p_parent_id=>wwv_flow_api.id(238744703025100258.4504)
,p_short_name=>'Prime istruzioni SQL'
,p_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_page_id=>21
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(238748709736111653.4504)
,p_parent_id=>wwv_flow_api.id(238747600732109040.4504)
,p_short_name=>'Piano SQL'
,p_link=>'f?p=&APP_ID.:551:&SESSION.::&DEBUG.:::'
,p_page_id=>551
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(239011303829658740.4504)
,p_parent_id=>wwv_flow_api.id(467828023586139366.4504)
,p_short_name=>'Utility'
,p_link=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.:::'
,p_page_id=>1005
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(467828023586139366.4504)
,p_parent_id=>wwv_flow_api.id(238741426181078594.4504)
,p_short_name=>'SQL Workshop'
,p_link=>'f?p=&APP_ID.:3002:&SESSION.::&DEBUG.:::'
,p_page_id=>3002
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(851340608959428999.4504)
,p_parent_id=>wwv_flow_api.id(.4504)
,p_short_name=>'Importa script'
,p_link=>'f?p=&FLOW_ID.:115:&SESSION.'
,p_page_id=>115
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/columbus_page_with_schema_jog_from_4999
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3490920094618697.4504)
,p_theme_id=>3
,p_name=>'(Columbus) Page With Schema Jog from 4999.it'
,p_internal_name=>'COLUMBUS_PAGE_WITH_SCHEMA_JOG_FROM_4999'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="page-header">',
'  <div>',
'      <a id="apex-logo" href="#HOME_LINK#"><h1>#LOGO#</h1></a>',
'      <div class="nav-bar">#NAVIGATION_BAR#</div>',
'  </div>',
'  <div class="apex-top-bar-end">',
'    <div class="apex-top-bar">',
'       #REGION_POSITION_07#',
'    </div>',
'  </div>',
'  <div id="apex-breadcrumb-region-end">',
'    <div id="apex-breadcrumb-region">',
'      <div id="apex-breadcrumbs">#REGION_POSITION_08#</div>',
'      <div id="apex-help"><a href="&SYSTEM_HELP_URL." target="_blank"><img src="#IMAGE_PREFIX#f_spacer.gif" class="iconSmall help" alt="" /><span>&HELP.</span></a></div>',
'      <div id="apex-controls">#REGION_POSITION_06#</div>',
'    </div>',
'  </div>',
'</div>',
'',
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div>#REGION_POSITION_01#</div>',
'  <div id="ContentBody">',
'    <div id="apex-two-col">',
'      <div id="apex-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</div>',
'      <div id="apex-content">#REGION_POSITION_02#',
'        <div id="apex-splash">#REGION_POSITION_04#<div id="BB">#BODY#</div></div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="apex-footer-info">',
'  <div style="float:right;">#FLOW_VERSION#</div>',
'  <div style="float:right;">#CUSTOMIZE#</div>',
'</div>',
'<div id="apex-footer">',
'   <div class="content">',
'     <div style="float:left;">&MSG_COMPANY.&nbsp;&MSG_USER.:&nbsp;&USER.</div>',
'     <div style="float:right;">&MSG_LANGUAGE.:&nbsp;&BROWSER_LANGUAGE.&nbsp;|&nbsp;&MSG_COPYRIGHT.</div>',
'   </div>',
'</div>',
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>29839111526369755.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140052492739349486.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140052530808349486.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140052636200349486.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140052754808349486.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140052830281349486.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140052941944349485.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053063315349485.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053179073349485.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053226887349485.4504)
,p_page_template_id=>wwv_flow_api.id(3490920094618697.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_query_builder_pop_up_to_be_deleted
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(13310402196993814.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Query Builder Pop Up (to be deleted).it'
,p_internal_name=>'APEX_5.0_QUERY_BUILDER_POP_UP_TO_BE_DELETED'
,p_is_popup=>false
,p_inline_css=>'.a-Header, #R387929284740561918 {display: none;}'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <script src="#IMAGE_PREFIX#sw/minified/htmldb_data.min.js" type="text/javascript" defer="defer"></script>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>787614155243007050.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054047549349484.4504)
,p_page_template_id=>wwv_flow_api.id(13310402196993814.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054101901349484.4504)
,p_page_template_id=>wwv_flow_api.id(13310402196993814.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054240771349484.4504)
,p_page_template_id=>wwv_flow_api.id(13310402196993814.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054390652349484.4504)
,p_page_template_id=>wwv_flow_api.id(13310402196993814.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054445576349484.4504)
,p_page_template_id=>wwv_flow_api.id(13310402196993814.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054542358349484.4504)
,p_page_template_id=>wwv_flow_api.id(13310402196993814.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054621772349484.4504)
,p_page_template_id=>wwv_flow_api.id(13310402196993814.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/columbus_minimal_for_ppr_only_pulls_from_4999
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(14599108081253832.4504)
,p_theme_id=>3
,p_name=>'(Columbus) Minimal For PPR only Pulls From 4999.it'
,p_internal_name=>'COLUMBUS_MINIMAL_FOR_PPR_ONLY_PULLS_FROM_4999'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com" xmlns:apex="http://apex.oracle.com">',
'',
'<head>',
'',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<title>#TITLE#</title>',
'</head>',
'<body onload="parent.htmldb_PageLoaded(this)">',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<htmldb:SUCCESS_MESSAGE><div id="SUCCESS_MESSAGE">#SUCCESS_MESSAGE#</div></htmldb:SUCCESS_MESSAGE>',
'<htmldb:NOTIFICATION_MESSAGE><div id="NOTIFICATION_MESSAGE">#NOTIFICATION_MESSAGE#</div></htmldb:NOTIFICATION_MESSAGE>',
'<htmldb:GLOBAL_NOTIFICATION><div id="GLOBAL_NOTIFICATION">#GLOBAL_NOTIFICATION#</div></htmldb:GLOBAL_NOTIFICATION>',
'<htmldb:REGION_POSITION_01><div id="REGION_POSITION_01">#REGION_POSITION_01#</div></htmldb:REGION_POSITION_01>',
'<htmldb:REGION_POSITION_02><div id="REGION_POSITION_02">#REGION_POSITION_02#</div></htmldb:REGION_POSITION_02>',
'<htmldb:REGION_POSITION_03><div id="REGION_POSITION_03">#REGION_POSITION_03#</div></htmldb:REGION_POSITION_03>',
'<htmldb:REGION_POSITION_04><div id="REGION_POSITION_04">#REGION_POSITION_04#</div></htmldb:REGION_POSITION_04>',
'<htmldb:REGION_POSITION_05><div id="REGION_POSITION_05">#REGION_POSITION_05#</div></htmldb:REGION_POSITION_05>',
'<htmldb:REGION_POSITION_06><div id="REGION_POSITION_06">#REGION_POSITION_06#</div></htmldb:REGION_POSITION_06>',
'<htmldb:REGION_POSITION_08><div id="REGION_POSITION_08">#REGION_POSITION_08#</div></htmldb:REGION_POSITION_08>',
'<htmldb:BOX_BODY><div id="BOX_BODY">#BODY#</div></htmldb:BOX_BODY>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_theme_class_id=>8
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>14502301802938058.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054701166349483.4504)
,p_page_template_id=>wwv_flow_api.id(14599108081253832.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054820502349483.4504)
,p_page_template_id=>wwv_flow_api.id(14599108081253832.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140054992825349483.4504)
,p_page_template_id=>wwv_flow_api.id(14599108081253832.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055007469349483.4504)
,p_page_template_id=>wwv_flow_api.id(14599108081253832.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055173904349483.4504)
,p_page_template_id=>wwv_flow_api.id(14599108081253832.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055205065349483.4504)
,p_page_template_id=>wwv_flow_api.id(14599108081253832.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055342903349483.4504)
,p_page_template_id=>wwv_flow_api.id(14599108081253832.4504)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055440437349482.4504)
,p_page_template_id=>wwv_flow_api.id(14599108081253832.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/iframe_for_object_browser_editor
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(18791925748855161.4504)
,p_theme_id=>3
,p_name=>'Iframe for Object Browser (Editor).it'
,p_internal_name=>'IFRAME_FOR_OBJECT_BROWSER_EDITOR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'<title>#TITLE#</title><link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#</head><body class="#PAGE_CSS_CLASSES#" #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div>#REGION_POSITION_01#</div>',
'  <div id="ContentBody">',
'    <table id="apex-page-body" cellspacing="0" cellpadding="0" border="0" summary="">',
'      <tbody>',
'        <tr>',
'          <td class="apex-page-content" width="100%">',
'            #REGION_POSITION_02#',
'            <div id="apex-splash">#REGION_POSITION_04#<div id="BB">#BODY#</div></div>	    ',
'	      </td>',
'          <td class="apex-page-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</td>     ',
'        </tr>',
'      </tbody>',
'    </table>',
'  </div>',
'</div>',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#<a name="END"></a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_theme_class_id=>8
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>7803400276444840.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055578423349482.4504)
,p_page_template_id=>wwv_flow_api.id(18791925748855161.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055632640349482.4504)
,p_page_template_id=>wwv_flow_api.id(18791925748855161.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055743338349482.4504)
,p_page_template_id=>wwv_flow_api.id(18791925748855161.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055889530349482.4504)
,p_page_template_id=>wwv_flow_api.id(18791925748855161.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140055978251349482.4504)
,p_page_template_id=>wwv_flow_api.id(18791925748855161.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056089724349482.4504)
,p_page_template_id=>wwv_flow_api.id(18791925748855161.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sql_commands_popup_to_be_deleted
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(22971005484952607.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - SQL Commands Popup (to be deleted).it'
,p_internal_name=>'APEX_5.0_SQL_COMMANDS_POPUP_TO_BE_DELETED'
,p_is_popup=>false
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#sc/sc_slider.js',
'#IMAGE_PREFIX#sc/sc_core.js'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(''#P1003_SQL_COMMAND1'').bind(''keydown'', function(e){',
'  sc_quickKeys(e);',
'});'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Header{',
'    display: none !important;',
'}',
'.a-Breadcrumb {',
'    display: none !important;',
'}',
'',
'.a-ControlBar .a-Form-inputContainer {',
'    float: left;',
'}'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Body">',
'    <main class="a-Main">     ',
'      <table border="0" cellspacing="0"  cellpadding="0" align="center" summary="" id="SqlAndResults" width="100%">',
'        <tr>',
'          <td valign="top"><div id="scRightHeader">#REGION_POSITION_01#</div>',
'            <div id="scCommandHolder" class="d1">#REGION_POSITION_03#</div>',
'            <div id="h_slide"><br />',
'            </div>',
'            <div id="scBottomHolder">#REGION_POSITION_04#',
'              <div id="htmlTabHolder" >#REGION_POSITION_05#</div>',
'            </div></td>',
'        </tr>',
'      </table>',
'        #BODY##REGION_POSITION_02#   ',
'    </main>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>797494421544604240.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056101563349482.4504)
,p_page_template_id=>wwv_flow_api.id(22971005484952607.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056299326349481.4504)
,p_page_template_id=>wwv_flow_api.id(22971005484952607.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056384628349481.4504)
,p_page_template_id=>wwv_flow_api.id(22971005484952607.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056450847349481.4504)
,p_page_template_id=>wwv_flow_api.id(22971005484952607.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056543959349481.4504)
,p_page_template_id=>wwv_flow_api.id(22971005484952607.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056645601349481.4504)
,p_page_template_id=>wwv_flow_api.id(22971005484952607.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056795368349481.4504)
,p_page_template_id=>wwv_flow_api.id(22971005484952607.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056877749349481.4504)
,p_page_template_id=>wwv_flow_api.id(22971005484952607.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_0_left_and_right_sidebar_builder
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(30058704563508114.4504)
,p_theme_id=>3
,p_name=>'APEX 4.0 - Left And Right SideBar (Builder).it'
,p_internal_name=>'APEX_4.0_LEFT_AND_RIGHT_SIDEBAR_BUILDER'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="page-header">',
'  <div>',
'      <a id="apex-logo" href="#HOME_LINK#"><h1>#LOGO#</h1></a>',
'      <div class="nav-bar">#NAVIGATION_BAR#</div>',
'  </div>',
'  <div class="apex-top-bar-end">',
'    <div class="apex-top-bar">',
'       #REGION_POSITION_07#',
'    </div>',
'  </div>',
'  <div id="apex-breadcrumb-region-end">',
'    <div id="apex-breadcrumb-region">',
'      <div id="apex-breadcrumbs">#REGION_POSITION_08#</div>',
'      <div id="apex-help"><a href="&SYSTEM_HELP_URL." target="_blank"><img src="#IMAGE_PREFIX#f_spacer.gif" class="iconSmall help" alt="" /><span>&HELP.</span></a></div>',
'      <div id="apex-controls">#REGION_POSITION_06#</div>',
'    </div>',
'  </div>',
'</div>',
'',
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div id="apex-main">',
'    <div id="ContentBody">',
'      <div id="apex-two-col">',
'        <div id="apex-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</div>',
'        <div id="apex-content">#REGION_POSITION_02#',
'          <div id="apex-splash">',
'            <div id="RP4">#REGION_POSITION_04#</div>',
'            <div id="BB">#BODY#</div>',
'          </div>',
'        </div>',
'      </div>',
'    </div>',
'    <div id="apex-left-sidebar">#REGION_POSITION_01#</div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="apex-footer-info">',
'  <div style="float:right;">#FLOW_VERSION#</div>',
'  <div style="float:right;">#CUSTOMIZE#</div>',
'</div>',
'<div id="apex-footer">',
'   <div class="content">',
'     <div style="float:left;">&MSG_COMPANY.&nbsp;&MSG_USER.:&nbsp;&USER.</div>',
'     <div style="float:right;">&MSG_LANGUAGE.:&nbsp;&BROWSER_LANGUAGE.&nbsp;|&nbsp;&MSG_COPYRIGHT.</div>',
'   </div>',
'</div>',
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>16
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>33514229015310264.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140056901971349481.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057045458349481.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057115660349480.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057225083349480.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057340981349480.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057452425349480.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057578783349480.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057634137349480.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057722626349480.4504)
,p_page_template_id=>wwv_flow_api.id(30058704563508114.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/done_popup
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(102479827851590823.4504)
,p_theme_id=>3
,p_name=>'(Done) Popup.it'
,p_internal_name=>'DONE_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'    <title>#TITLE#</title>',
'    <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'    ',
'    #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="aPopupPage">',
'    <noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>#REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##BODY#</div>',
'<div style="text-align:middle;">#REGION_POSITION_08#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>19940022257958945.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053335842349485.4504)
,p_page_template_id=>wwv_flow_api.id(102479827851590823.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053489710349485.4504)
,p_page_template_id=>wwv_flow_api.id(102479827851590823.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053574940349485.4504)
,p_page_template_id=>wwv_flow_api.id(102479827851590823.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053680216349485.4504)
,p_page_template_id=>wwv_flow_api.id(102479827851590823.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053735196349485.4504)
,p_page_template_id=>wwv_flow_api.id(102479827851590823.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053800266349484.4504)
,p_page_template_id=>wwv_flow_api.id(102479827851590823.4504)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140053964168349484.4504)
,p_page_template_id=>wwv_flow_api.id(102479827851590823.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/columbus_iframe_for_object_browser_editor
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(111249502165581395.4504)
,p_theme_id=>3
,p_name=>'(Columbus) Iframe for Object Browser / Editor.it'
,p_internal_name=>'COLUMBUS_IFRAME_FOR_OBJECT_BROWSER_/_EDITOR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<title>#TITLE#</title>',
'</head>',
'<body class="apex-iframe" #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div>#REGION_POSITION_01#</div>',
'  <div id="ContentBody">',
'    <table id="apex-page-body" width="100%" cellspacing="0" cellpadding="0" border="0" summary="">',
'      <tbody>',
'        <tr>',
'          <td class="apex-page-content" width="100%">',
'            #REGION_POSITION_02#',
'            <div id="apex-splash">#REGION_POSITION_04#<div id="BB">#BODY#</div></div>	    ',
'	      </td>',
'          <td class="apex-page-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</td>     ',
'        </tr>',
'      </tbody>',
'    </table>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#<a name="END"></a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_theme_class_id=>8
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>111241219607547888.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140101688207349391.4504)
,p_page_template_id=>wwv_flow_api.id(111249502165581395.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140101705362349391.4504)
,p_page_template_id=>wwv_flow_api.id(111249502165581395.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140101889553349391.4504)
,p_page_template_id=>wwv_flow_api.id(111249502165581395.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140101930021349391.4504)
,p_page_template_id=>wwv_flow_api.id(111249502165581395.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140102092964349391.4504)
,p_page_template_id=>wwv_flow_api.id(111249502165581395.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140102117360349391.4504)
,p_page_template_id=>wwv_flow_api.id(111249502165581395.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_2_popup
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(203703017586195109.4504)
,p_theme_id=>3
,p_name=>'APEX 4.2 - Popup.it'
,p_internal_name=>'APEX_4.2_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title><link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head><body #ONLOAD# style="padding:5px;min-width:380px;"><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>',
'  <div id="RP2">#REGION_POSITION_02#</div>',
'  <div id="RP3">#REGION_POSITION_03#</div>',
'  <div id="RP4">#REGION_POSITION_04#</div>',
'  <div id="RP5">#REGION_POSITION_05#</div>',
'  <div class="popupContent" id="ContentArea">#BODY#</div>',
'</div>',
'<div id="RP8" style="text-align:middle;">#REGION_POSITION_08#</div>',
'<br />',
'<br />',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>36144306570651063.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057805392349480.4504)
,p_page_template_id=>wwv_flow_api.id(203703017586195109.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140057920377349479.4504)
,p_page_template_id=>wwv_flow_api.id(203703017586195109.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058009615349479.4504)
,p_page_template_id=>wwv_flow_api.id(203703017586195109.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058118791349479.4504)
,p_page_template_id=>wwv_flow_api.id(203703017586195109.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058237072349479.4504)
,p_page_template_id=>wwv_flow_api.id(203703017586195109.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058368826349479.4504)
,p_page_template_id=>wwv_flow_api.id(203703017586195109.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(385762900697898960.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.it'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159327410235427630.4504)
,p_page_template_id=>wwv_flow_api.id(385762900697898960.4504)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159327911378427631.4504)
,p_page_template_id=>wwv_flow_api.id(385762900697898960.4504)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159328419806427631.4504)
,p_page_template_id=>wwv_flow_api.id(385762900697898960.4504)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159328980519427631.4504)
,p_page_template_id=>wwv_flow_api.id(385762900697898960.4504)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159329412517427632.4504)
,p_page_template_id=>wwv_flow_api.id(385762900697898960.4504)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159329905425427632.4504)
,p_page_template_id=>wwv_flow_api.id(385762900697898960.4504)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159330456883427632.4504)
,p_page_template_id=>wwv_flow_api.id(385762900697898960.4504)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(690782249755803171.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.it'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140068268162349462.4504)
,p_page_template_id=>wwv_flow_api.id(690782249755803171.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140068378595349462.4504)
,p_page_template_id=>wwv_flow_api.id(690782249755803171.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140068487053349462.4504)
,p_page_template_id=>wwv_flow_api.id(690782249755803171.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog_grid_layout
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(690782638016803186.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog (Grid Layout).it'
,p_internal_name=>'APEX_5.0_DIALOG_GRID_LAYOUT'
,p_is_popup=>true
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#',
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE#',
'#NOTIFICATION_MESSAGE#',
'#GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'#BODY#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#REGION_POSITION_06#',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'400'
,p_dialog_width=>'600'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>561572340071582364.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140071016629349459.4504)
,p_page_template_id=>wwv_flow_api.id(690782638016803186.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140071106516349459.4504)
,p_page_template_id=>wwv_flow_api.id(690782638016803186.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140071277608349459.4504)
,p_page_template_id=>wwv_flow_api.id(690782638016803186.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140071396624349459.4504)
,p_page_template_id=>wwv_flow_api.id(690782638016803186.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140071454429349459.4504)
,p_page_template_id=>wwv_flow_api.id(690782638016803186.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140071569367349459.4504)
,p_page_template_id=>wwv_flow_api.id(690782638016803186.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140071645904349459.4504)
,p_page_template_id=>wwv_flow_api.id(690782638016803186.4504)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(690783120585803188.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.it'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140074263261349456.4504)
,p_page_template_id=>wwv_flow_api.id(690783120585803188.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140074312346349456.4504)
,p_page_template_id=>wwv_flow_api.id(690783120585803188.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140074473336349456.4504)
,p_page_template_id=>wwv_flow_api.id(690783120585803188.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140074597875349455.4504)
,p_page_template_id=>wwv_flow_api.id(690783120585803188.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140074624955349455.4504)
,p_page_template_id=>wwv_flow_api.id(690783120585803188.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140074756991349455.4504)
,p_page_template_id=>wwv_flow_api.id(690783120585803188.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159332394079427634.4504)
,p_page_template_id=>wwv_flow_api.id(690783120585803188.4504)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159332873065427635.4504)
,p_page_template_id=>wwv_flow_api.id(690783120585803188.4504)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(690783685471803190.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.it'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076887398349453.4504)
,p_page_template_id=>wwv_flow_api.id(690783685471803190.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076919559349453.4504)
,p_page_template_id=>wwv_flow_api.id(690783685471803190.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077096921349453.4504)
,p_page_template_id=>wwv_flow_api.id(690783685471803190.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077185038349453.4504)
,p_page_template_id=>wwv_flow_api.id(690783685471803190.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077266634349453.4504)
,p_page_template_id=>wwv_flow_api.id(690783685471803190.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077385302349453.4504)
,p_page_template_id=>wwv_flow_api.id(690783685471803190.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077477844349452.4504)
,p_page_template_id=>wwv_flow_api.id(690783685471803190.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(690784265136803192.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.it'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079461055349450.4504)
,p_page_template_id=>wwv_flow_api.id(690784265136803192.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079564603349450.4504)
,p_page_template_id=>wwv_flow_api.id(690784265136803192.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079682686349450.4504)
,p_page_template_id=>wwv_flow_api.id(690784265136803192.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(703368619593851824.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.it'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140082101429349447.4504)
,p_page_template_id=>wwv_flow_api.id(703368619593851824.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140082200759349447.4504)
,p_page_template_id=>wwv_flow_api.id(703368619593851824.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140082383915349447.4504)
,p_page_template_id=>wwv_flow_api.id(703368619593851824.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140082430186349447.4504)
,p_page_template_id=>wwv_flow_api.id(703368619593851824.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140082534140349447.4504)
,p_page_template_id=>wwv_flow_api.id(703368619593851824.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140082672870349447.4504)
,p_page_template_id=>wwv_flow_api.id(703368619593851824.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140082704013349447.4504)
,p_page_template_id=>wwv_flow_api.id(703368619593851824.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sql_workshop_iframe_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(740688669716062470.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - SQL Workshop iFrame Page.it'
,p_internal_name=>'APEX_5.0_SQL_WORKSHOP_IFRAME_PAGE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="sql-workshop-iframe-page a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>751105067571616073.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140085158635349444.4504)
,p_page_template_id=>wwv_flow_api.id(740688669716062470.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140085232764349444.4504)
,p_page_template_id=>wwv_flow_api.id(740688669716062470.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140085340394349443.4504)
,p_page_template_id=>wwv_flow_api.id(740688669716062470.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sql_command_to_be_deleted
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(755489372405029415.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - SQL Command (to be deleted).it'
,p_internal_name=>'APEX_5.0_SQL_COMMAND_TO_BE_DELETED'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Body">',
'    <main class="a-Main">     ',
'      <table border="0" cellspacing="0"  cellpadding="0" align="center" summary="" id="SqlAndResults" width="100%">',
'        <tr>',
'          <td valign="top"><div id="scRightHeader">#REGION_POSITION_01#</div>',
'            <div id="scCommandHolder" class="d1">#REGION_POSITION_03#</div>',
'            <div id="h_slide"><br />',
'            </div>',
'            <div id="scBottomHolder">#REGION_POSITION_04#',
'              <div id="htmlTabHolder" >#REGION_POSITION_05#</div>',
'            </div></td>',
'        </tr>',
'      </table>',
'        #BODY##REGION_POSITION_02#   ',
'    </main>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>755495306770115352.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087161901349441.4504)
,p_page_template_id=>wwv_flow_api.id(755489372405029415.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087248824349441.4504)
,p_page_template_id=>wwv_flow_api.id(755489372405029415.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087384706349441.4504)
,p_page_template_id=>wwv_flow_api.id(755489372405029415.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087481350349441.4504)
,p_page_template_id=>wwv_flow_api.id(755489372405029415.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087599254349441.4504)
,p_page_template_id=>wwv_flow_api.id(755489372405029415.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087676183349441.4504)
,p_page_template_id=>wwv_flow_api.id(755489372405029415.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087782443349441.4504)
,p_page_template_id=>wwv_flow_api.id(755489372405029415.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087830091349441.4504)
,p_page_template_id=>wwv_flow_api.id(755489372405029415.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_object_browser_to_be_deleted
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(755497120063121833.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Object Browser (to be deleted).it'
,p_internal_name=>'APEX_5.0_OBJECT_BROWSER_TO_BE_DELETED'
,p_is_popup=>false
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(''#P1003_SQL_COMMAND1'').bind(''keydown'', function(e){',
'  sc_quickKeys(e);',
'});'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <script src="#IMAGE_PREFIX#sw/minified/htmldb_data.min.js" type="text/javascript" defer="defer"></script>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Body">',
'    <main class="a-Main">     ',
'    <table summary="" cellpadding="0" cellspacing="0" border="0" id="obTable" style="margin:5px;">',
'      <tr>',
'        <td width="200" id="obLeftColumn" valign="top"><div id="obLeftHeader" style="border-left:none;">#REGION_POSITION_01#</div>',
'          <div id="ob_ObjectsSlider">#REGION_POSITION_03#<br />',
'          </div></td>',
'        <td id="v_slide" class="obSlideBar" valign="middle" width="2px"><span id="qbSideBartoggle" onclick="html_ToggleElement(''obLeftColumn'')"><img id="qbSideBar_toggle" src="#IMAGE_PREFIX#qb/close.png" class="htmldbPseudoButton" /></span></td>',
'        <td valign="top" class="dbaseFrameHolder" width="100%" id="dbaseFrameHolder"><table id="obRightHeader" width="100%" summary="" cellpadding="0" border="0" cellspacing="0">',
'            <tr>',
'              <td id="ob_ObjectsDetail" width="100%"><br /></td>',
'              <td>#REGION_POSITION_02#</td>',
'            </tr>',
'          </table>',
'          #REGION_POSITION_04#</td>',
'      </tr>',
'    </table>',
'        #BODY#  ',
'    </main>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>755501609832139762.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140087951878349441.4504)
,p_page_template_id=>wwv_flow_api.id(755497120063121833.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140088052579349441.4504)
,p_page_template_id=>wwv_flow_api.id(755497120063121833.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140088132111349440.4504)
,p_page_template_id=>wwv_flow_api.id(755497120063121833.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140088299732349440.4504)
,p_page_template_id=>wwv_flow_api.id(755497120063121833.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140088386942349440.4504)
,p_page_template_id=>wwv_flow_api.id(755497120063121833.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140088477874349440.4504)
,p_page_template_id=>wwv_flow_api.id(755497120063121833.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140088506190349440.4504)
,p_page_template_id=>wwv_flow_api.id(755497120063121833.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_query_builder_to_be_deleted
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(755509294845301750.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Query Builder (to be deleted).it'
,p_internal_name=>'APEX_5.0_QUERY_BUILDER_TO_BE_DELETED'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <script src="#IMAGE_PREFIX#sw/minified/htmldb_data.min.js" type="text/javascript" defer="defer"></script>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Body">',
'    <main class="a-Main">     ',
'    <table summary="" cellpadding="0" cellspacing="0" border="0" id="qbTable" width="98%" height="70%">',
'      <tr>',
'        <td id="qbSideBar" valign="top" width="200" style="width:200px;"><div id="qbLeftHeader">#REGION_POSITION_02#</div>',
'          <div id="dbaseObjectsSlider"><br />',
'          </div></td>',
'        <td id="v_slide" class="obSlideBar" valign="middle" width="5" style="width:5px;"><span id="qbSideBartoggle" onclick="qb_toggleSideBar();"><img id="qbSideBar_toggle" src="#IMAGE_PREFIX#qb/close.png" alt="" class="htmldbPseudoButton" /></span><'
||'/td>',
'        <td valign="top" class="qbFrameHolder" id="qbFrameHolder"><div id="qbRightHeader">#REGION_POSITION_03#</div>',
'          <div id="qbTableHolder" class="d1">',
'            <div align="right">',
'              <div id="qbLinkHolder"></div>',
'            </div>',
'          </div>',
'          <div id="h_slide" onmousedown="qb_hPosition(this);">&nbsp;</div>',
'          <div id="qbBottomHolder" class="d2">#REGION_POSITION_04#',
'            <div id="htmlTabHolder" class="qbTabHolder">#REGION_POSITION_05#</div>',
'          </div></td>',
'      </tr>',
'    </table>',
'        #REGION_POSITION_01##BODY#  ',
'    </main>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140060983384349476.4504)
,p_page_template_id=>wwv_flow_api.id(755509294845301750.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061032146349476.4504)
,p_page_template_id=>wwv_flow_api.id(755509294845301750.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061193063349476.4504)
,p_page_template_id=>wwv_flow_api.id(755509294845301750.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061226080349476.4504)
,p_page_template_id=>wwv_flow_api.id(755509294845301750.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061378064349476.4504)
,p_page_template_id=>wwv_flow_api.id(755509294845301750.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061409051349476.4504)
,p_page_template_id=>wwv_flow_api.id(755509294845301750.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061559959349475.4504)
,p_page_template_id=>wwv_flow_api.id(755509294845301750.4504)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061698962349475.4504)
,p_page_template_id=>wwv_flow_api.id(755509294845301750.4504)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_query_builder_popup_legacy_to_be_deleted
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(787616727240016897.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Query Builder Popup (Legacy to be deleted).it'
,p_internal_name=>'APEX_5.0_QUERY_BUILDER_POPUP_LEGACY_TO_BE_DELETED'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'<script src="#IMAGE_PREFIX#sw/minified/htmldb_data.min.js" type="text/javascript"></script>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body #ONLOAD# xmlns:htmldb="http://htmldb.oracle.com"><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbBreadcrumbTop"><br /></div>',
'<table class="htmldbLayout" cellpadding="0" cellspacing="0" border="0" summary="">',
'<tr>',
'<td class="htmldbBreadcrumbRegion"><br /></td>',
'<td rowspan="2" class="htmldbRunEditRegion">#REGION_POSITION_06#</td></tr>',
'<tr>',
'<td id="htmldbRunEditZag"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" width="1" height="6" /></td>',
'</tr>',
'</table>',
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<table summary="" cellpadding="0" cellspacing="0" border="0" id="qbTable" width="98%" height="70%">',
'<tr>',
'<td id="qbSideBar" valign="top" width="200" style="width:200px;"><div id="qbLeftHeader">#REGION_POSITION_02#</div><div id="dbaseObjectsSlider"><br /></div></td>',
'<td id="v_slide" class="obSlideBar" valign="middle" width="5" style="width:5px;"><span id="qbSideBartoggle" onclick="qb_toggleSideBar();"><img id="qbSideBar_toggle" src="#IMAGE_PREFIX#qb/close.png" alt="" class="htmldbPseudoButton" /></span></td>',
'<td valign="top" class="qbFrameHolder" id="qbFrameHolder"><div id="qbRightHeader">#REGION_POSITION_03#</div>',
'<div id="qbTableHolder" class="d1"><div align="right"><div id="qbLinkHolder"></div></div></div>',
'<div id="h_slide" onmousedown="qb_hPosition(this);">&nbsp;</div>',
'<div id="qbBottomHolder" class="d2">#REGION_POSITION_04#<div id="htmlTabHolder" class="qbTabHolder">#REGION_POSITION_05#</div><br /><br /></div></td>',
'</tr>',
'</table><div class="htmldbBodyMargin">#REGION_POSITION_01##BODY#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'<a name="END"><br /></a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_top_non_curr_tab_font_attr=>'class="parenttabtextoff"'
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>16
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'no longer used'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140093017683349434.4504)
,p_page_template_id=>wwv_flow_api.id(787616727240016897.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140093198174349433.4504)
,p_page_template_id=>wwv_flow_api.id(787616727240016897.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140093288224349433.4504)
,p_page_template_id=>wwv_flow_api.id(787616727240016897.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140093382714349433.4504)
,p_page_template_id=>wwv_flow_api.id(787616727240016897.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140093468334349433.4504)
,p_page_template_id=>wwv_flow_api.id(787616727240016897.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140093506426349433.4504)
,p_page_template_id=>wwv_flow_api.id(787616727240016897.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140093696461349433.4504)
,p_page_template_id=>wwv_flow_api.id(787616727240016897.4504)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sql_commands_popup_legacy
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(797492749231600530.4504)
,p_theme_id=>3
,p_name=>'APEX 5.0 - SQL Commands Popup (Legacy).it'
,p_internal_name=>'APEX_5.0_SQL_COMMANDS_POPUP_LEGACY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<script src="#IMAGE_PREFIX#sc/sc_slider.js" type="text/javascript"></script>',
'<script src="#IMAGE_PREFIX#sc/sc_core.js" type="text/javascript"></script>',
'<script type="text/javascript">',
'document.onkeypress  = sc_quickKeys;',
'</script>',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbBreadcrumbTop"><br /></div>',
'<table class="htmldbLayout" cellpadding="0" cellspacing="0" border="0" summary="">',
'<tr>',
'<td class="htmldbBreadcrumbRegion"><div class="htmldbBreadcrumbs"><br /></td>',
'<td rowspan="2" class="htmldbRunEditRegion">#REGION_POSITION_06#</td></tr>',
'<tr>',
'<td id="htmldbRunEditZag"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" width="1" height="6" /></td>',
'</tr>',
'</table><a name="SkipRepNav"></a><div id="htmldbMessageHolder" style="padding:0px;margin:0px;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<table border="0" cellspacing="0"  cellpadding="0" align="center" summary="" id="SqlAndResults" width="100%">',
'<tr>',
'<td valign="top">',
'<div id="scRightHeader">#REGION_POSITION_01#</div>',
'<div id="scCommandHolder" class="d1">#REGION_POSITION_03#</div>',
'<div id="h_slide"><br /></div>',
'<div id="scBottomHolder">#REGION_POSITION_04#<div id="htmlTabHolder" >#REGION_POSITION_05#</div></div>  ',
'</td>',
'</tr>',
'</table>',
'#BODY##REGION_POSITION_02#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'<a name="END"><br /></a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>13
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>23028517589370116.4504
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140064189303349471.4504)
,p_page_template_id=>wwv_flow_api.id(797492749231600530.4504)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140064237262349470.4504)
,p_page_template_id=>wwv_flow_api.id(797492749231600530.4504)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140064303080349470.4504)
,p_page_template_id=>wwv_flow_api.id(797492749231600530.4504)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140064492396349470.4504)
,p_page_template_id=>wwv_flow_api.id(797492749231600530.4504)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140064545506349470.4504)
,p_page_template_id=>wwv_flow_api.id(797492749231600530.4504)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140064611828349470.4504)
,p_page_template_id=>wwv_flow_api.id(797492749231600530.4504)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140064728029349470.4504)
,p_page_template_id=>wwv_flow_api.id(797492749231600530.4504)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_button_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3791826543328.4504)
,p_template_name=>'HTML button (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_BUTTON_LEGACY_APEX_5_MIGRATION'
,p_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_hot_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_1_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(300313006293429763.4504)
,p_template_name=>'APEX 4.1 - Button'
,p_internal_name=>'APEX_4.1_BUTTON'
,p_template=>'<button class="aButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_hot_template=>'<button class="aButton hotButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_reference_id=>275775519061831382.4504
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="button-gray" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> ',
'',
'',
'<a href="#LINK#" class="button-orange" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> '))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(385765234519963355.4504)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4504
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(385765690470963369.4504)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4504
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(385765860428963371.4504)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4504
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(690706750701136097.4504)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4504
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(717395744009796543.4504)
,p_template_name=>'APEX 5.0 - Icon Badge Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><span class="a-But'
||'ton-badge"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><spa'
||'n class="a-Button-badge"></span></button>'
,p_reference_id=>631020282344854024.4504
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(717395999962796580.4504)
,p_template_name=>'APEX 5.0 - Icon Badge Menu Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_reference_id=>631020159860848910.4504
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/results_region_template
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(4569137138.4504)
,p_layout=>'TABLE'
,p_template=>'<table cellspacing="2" cellpadding="2" border="0" width="100%" bgcolor="#C5D5C5" summary="" id="#REGION_STATIC_ID#"><tr><td align=left bgcolor="#C5D5C5"><font class="regionheader" face=aria color=white>&nbsp;<h2>#TITLE#</h2></font></td><td width="1%"'
||' align="right"  bgcolor="#C5D5C5">#EXPAND#</td><td width="1%" align="right"  bgcolor="#C5D5C5">#CLOSE#</td></tr></table>#BODY#<p/>'
,p_page_plug_template_name=>'results_region_template'
,p_internal_name=>'RESULTS_REGION_TEMPLATE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>354972725853931304.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140566999519344442.4504)
,p_plug_template_id=>wwv_flow_api.id(4569137138.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567054888344442.4504)
,p_plug_template_id=>wwv_flow_api.id(4569137138.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567140160344442.4504)
,p_plug_template_id=>wwv_flow_api.id(4569137138.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567246624344442.4504)
,p_plug_template_id=>wwv_flow_api.id(4569137138.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/gray_box_c_htmldbgbr_100_from_4999
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(99113673096289.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading editRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'      <a href="#" class="aIconButton" onclick="uF();return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" class="upIcon" alt="&TOP." /></a>',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'Gray Box (c:htmldbGBR) (100%)  From 4999'
,p_internal_name=>'GRAY_BOX_C:HTMLDBGBR_100%_FROM_4999'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17353903289599940.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567372711344442.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567424691344442.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567512617344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567624141344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567744063344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567812381344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140567964100344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568073231344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568150859344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568292692344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568318369344441.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568437652344440.4504)
,p_plug_template_id=>wwv_flow_api.id(99113673096289.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/popup_dialog
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2315729644343442.4504)
,p_layout=>'TABLE'
,p_template=>'<table style="display:none;position:absolute;background-color:#EEEEEE;border:#000000 solid 1px;padding:0px;text-align:center;font-size:12px;color:#000000;" summary="" cellpadding="0" cellspacing="0" border="0" id="#REGION_STATIC_ID#"><tr><td class="h'
||'tmldbWizardHeader"><h2>#TITLE#</h2></td><td class="htmldbWizardHeader" align="right"><span onClick="dhtml_CloseDialog(this);"><img src="#IMAGE_PREFIX#qb/vertical_close.png" /></span></td></tr><tr><td colspan="2" class="htmldbWizardBody">#BODY#</td></'
||'tr><tr><td colspan="2" align="right">#CLOSE#&nbsp;&nbsp;&nbsp;#DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#</td></tr></table>'
,p_page_plug_template_name=>'Popup Dialog'
,p_internal_name=>'POPUP_DIALOG'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>140626130059891289.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568594196344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568698711344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568704569344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568867043344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140568907417344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569054311344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569150526344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569294370344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569392716344440.4504)
,p_plug_template_id=>wwv_flow_api.id(2315729644343442.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2976007666683831.4504)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 - DIV with ID and Region Attributes'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>2974803291668087.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569490740344439.4504)
,p_plug_template_id=>wwv_flow_api.id(2976007666683831.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569563531344439.4504)
,p_plug_template_id=>wwv_flow_api.id(2976007666683831.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/ppr_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(12270828624874231.4504)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_ID#" style="clear:both;"><htmldb:PPR_#REGION_ID#>#BODY#</htmldb:PPR_#REGION_ID#></div>'
,p_page_plug_template_name=>'PPR Region'
,p_internal_name=>'PPR_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569617539344439.4504)
,p_plug_template_id=>wwv_flow_api.id(12270828624874231.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569774467344439.4504)
,p_plug_template_id=>wwv_flow_api.id(12270828624874231.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/dhtml_hidden_with_id_c_htmldbhid_from_4999
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(18711815569354247.4504)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" style="display:none;">#BODY#</div>'
,p_page_plug_template_name=>'(DHTML) Hidden with ID (c:htmldbHID) From 4999'
,p_internal_name=>'DHTML_HIDDEN_WITH_ID_C:HTMLDBHID_FROM_4999'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>18544000951303738.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569858126344439.4504)
,p_plug_template_id=>wwv_flow_api.id(18711815569354247.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140569906308344439.4504)
,p_plug_template_id=>wwv_flow_api.id(18711815569354247.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/sub_tab_region_marc
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20150627851144569.4504)
,p_layout=>'TABLE'
,p_template=>'<table width="400" summary="" cellpadding="0" cellspacing="0" border="0" id="#REGION_STATIC_ID#"><tr><td>#BODY#</td></tr></table>'
,p_page_plug_template_name=>'sub tab region (Marc)'
,p_internal_name=>'SUB_TAB_REGION_MARC'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>354972912039931307.4504
,p_translate_this_template=>'N'
,p_template_comment=>'No region formatting'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570004084344439.4504)
,p_plug_template_id=>wwv_flow_api.id(20150627851144569.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570123571344439.4504)
,p_plug_template_id=>wwv_flow_api.id(20150627851144569.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/top_bar_white_collapsed
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(22867306215341549.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="top-bar" #REGION_ATTRIBUTES#><div style="float: left">#BODY#</div><div style="float: left">#CLOSE##EDIT##DELETE##CREATE##CREATE2##PREVIOUS##NEXT#</div></div>',
''))
,p_page_plug_template_name=>'Top Bar (white) (collapsed)'
,p_internal_name=>'TOP_BAR_WHITE_COLLAPSED'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>21
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17586323272111445.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570290826344439.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570388177344439.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570438244344438.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570535541344438.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570634988344438.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570756770344438.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570831895344438.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140570969512344438.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140571052856344438.4504)
,p_plug_template_id=>wwv_flow_api.id(22867306215341549.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/show_hide_minimal
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(35638231141594602.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="hide-show-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="hide-show-top">',
'    <div class="hide-show-title"><h3>',
'      <a href="#" onclick="htmldb_ToggleTableBody(''i#REGION_STATIC_ID#'',''body#REGION_STATIC_ID#''); return false;">',
'        <img src="#IMAGE_PREFIX#htmldb/builder/rollup_plus_dgray.gif" class="pseudoButtonActive" id="i#REGION_STATIC_ID#" alt="" />',
'        #TITLE#',
'      </a></h3>    ',
'    </div>',
'  </div>',
'  <div class="hide-show-body" style="display:none;" id="body#REGION_STATIC_ID#">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'Show / Hide - minimal'
,p_internal_name=>'SHOW_/_HIDE_MINIMAL'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>106535103160611208.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140611761005344396.4504)
,p_plug_template_id=>wwv_flow_api.id(35638231141594602.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140611856043344396.4504)
,p_plug_template_id=>wwv_flow_api.id(35638231141594602.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(40570329559709427.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion buttonRegion" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    #BODY#',
'    <span class="aButtonContainer">',
'      #CLOSE##COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#',
'    </span>',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Top Bar '
,p_internal_name=>'APEX_4.0_TOP_BAR_'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17357218626599946.4504
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140611925787344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612040422344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612189546344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612279567344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612354121344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612436483344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612518493344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612649548344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612722517344395.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612839339344394.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140612930650344394.4504)
,p_plug_template_id=>wwv_flow_api.id(40570329559709427.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_float_left
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(42819301025617014.4504)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# style="float:left;clear:both;">#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 - Div (Float Left)'
,p_internal_name=>'APEX_4.0_DIV_FLOAT_LEFT'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>35964702876463547.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613079355344394.4504)
,p_plug_template_id=>wwv_flow_api.id(42819301025617014.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613125997344394.4504)
,p_plug_template_id=>wwv_flow_api.id(42819301025617014.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(61427413413570608.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-region" id="#REGION_STATIC_ID#" style="width:100%">',
'  <div class="rc-gray-top"><div class="rc-gray-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'Report Region'
,p_internal_name=>'REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17354512447599941.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613214014344394.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613324771344394.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613469087344394.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613534190344394.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613650708344394.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613757780344394.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613807423344393.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140613921427344393.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614070511344393.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614178996344393.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614201186344393.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614378082344393.4504)
,p_plug_template_id=>wwv_flow_api.id(61427413413570608.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/info_c_htmldbinfo_from_4999
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(81906901123495005.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'Info (c:htmldbInfo)  From 4999'
,p_internal_name=>'INFO_C:HTMLDBINFO_FROM_4999'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614433513344393.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614567550344393.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614669864344393.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614711574344393.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614884812344392.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140614931260344392.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615011216344392.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615187964344392.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615214384344392.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615388607344392.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615495152344392.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615541852344392.4504)
,p_plug_template_id=>wwv_flow_api.id(81906901123495005.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/blank_wizard_region_c_htmldbbwr
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(106819925599248236.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbBWR" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">',
'<thead>',
'<tr>',
'<th class="T"><br /></th>',
'<th class="BT" valign="bottom">#CLOSE#&nbsp;&nbsp;#EDIT##DELETE#<img src="#IMAGE_PREFIX#htmldb/builder/1px_trans.gif" alt="" height="1" width="5" />#PREVIOUS##NEXT##CREATE##CREATE2#</th>',
'</tr>',
'</thead>',
'<tbody>',
'<tr>',
'<td colspan="2" class="B">#BODY#</td>',
'</tr>',
'</tbody>',
'</table>'))
,p_page_plug_template_name=>'Blank Wizard Region (c:htmldbBWR)'
,p_internal_name=>'BLANK_WIZARD_REGION_C:HTMLDBBWR'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615659540344392.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615799443344391.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615814240344391.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140615965516344391.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616067438344391.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616153694344391.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616296448344391.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616345733344391.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616421636344391.4504)
,p_plug_template_id=>wwv_flow_api.id(106819925599248236.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(140310301493602560.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box'
,p_internal_name=>'WIZARD_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616517579344391.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616632742344391.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616730557344390.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616811721344390.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140616991090344390.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617000909344390.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617133963344390.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617260011344390.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617380149344390.4504)
,p_plug_template_id=>wwv_flow_api.id(140310301493602560.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_success
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(156913627709610019.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion successRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Success)'
,p_internal_name=>'WIZARD_BOX_SUCCESS'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>149030901078827666.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617426347344390.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617560726344390.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617606616344390.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617799749344389.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617800564344389.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140617914679344389.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618095895344389.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618183439344389.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618227631344389.4504)
,p_plug_template_id=>wwv_flow_api.id(156913627709610019.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_confirm
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(162408401422136243.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Confirm)'
,p_internal_name=>'WIZARD_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618344653344389.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618407525344389.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618528734344389.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618614830344389.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618759652344388.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618818097344388.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140618964677344388.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619046946344388.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619195874344388.4504)
,p_plug_template_id=>wwv_flow_api.id(162408401422136243.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(197664431770780199.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Sidebar (Gray Header)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619290290344388.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619371059344388.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619403926344388.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619511891344388.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619674144344387.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619776450344387.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619870741344387.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140619969588344387.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620060719344387.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620109285344387.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620270326344387.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620387247344387.4504)
,p_plug_template_id=>wwv_flow_api.id(197664431770780199.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(201494524216316816.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Wizard Box'
,p_internal_name=>'APEX_4.0_WIZARD_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620496570344387.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620581461344387.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620609636344386.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620745224344386.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620898689344386.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140620906708344386.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621039898344386.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621135607344386.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621281875344386.4504)
,p_plug_template_id=>wwv_flow_api.id(201494524216316816.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(208285310117555084.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body'
,p_internal_name=>'APEX_4.2_WIZARD_BODY'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209615589242480.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621310888344386.4504)
,p_plug_template_id=>wwv_flow_api.id(208285310117555084.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621449506344386.4504)
,p_plug_template_id=>wwv_flow_api.id(208285310117555084.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_divider
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(208285802016555084.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'<div class="wizardRegionHeading">',
'  <h1>#TITLE#</h1>',
'  <div class="buttonContainer">',
'#EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'  </div>',
'</div>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body (Divider)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_DIVIDER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209811475242480.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621501085344386.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621610752344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621767079344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621884740344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140621949317344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622068051344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622106450344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622250830344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622357329344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622447061344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622514577344385.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622643379344384.4504)
,p_plug_template_id=>wwv_flow_api.id(208285802016555084.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/body_and_button_positions
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(267352014896608032.4504)
,p_layout=>'TABLE'
,p_template=>'<table  cellpadding="0" cellspacing="0" border="0" summary="" class="htmldbButtonPositionsOnly" id="#REGION_STATIC_ID#"><tbody><tr><td>#BODY#</td><td style="padding-right:25px;">#CLOSE#</td><td>#PREVIOUS#</td><td>#NEXT#</td><td>#DELETE#</td><td>#CHAN'
||'GE##EDIT#</td><td>#CREATE#</td><td>#CREATE2#</td><td>#HELP#</td></tr></tbody></table>'
,p_page_plug_template_name=>'Body and Button Positions'
,p_internal_name=>'BODY_AND_BUTTON_POSITIONS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>149939626832608434.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622773062344384.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622839124344384.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140622955035344384.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623035834344384.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623106716344384.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623237658344384.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623381858344384.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623493674344384.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623521160344383.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623663131344383.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623702882344383.4504)
,p_plug_template_id=>wwv_flow_api.id(267352014896608032.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(380771699411878611.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4504
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623805259344383.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140623997477344383.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624076527344383.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624171852344383.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624293410344383.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624385103344383.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624401609344383.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624544473344382.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624645080344382.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624783766344382.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624842241344382.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140624997050344382.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625004534344382.4504)
,p_plug_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(385770331595976651.4504)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625139435344382.4504)
,p_plug_template_id=>wwv_flow_api.id(385770331595976651.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625206202344382.4504)
,p_plug_template_id=>wwv_flow_api.id(385770331595976651.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625325837344382.4504)
,p_plug_template_id=>wwv_flow_api.id(385770331595976651.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625450930344381.4504)
,p_plug_template_id=>wwv_flow_api.id(385770331595976651.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_hidden_heading
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(385893260111566687.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Hidden Heading)'
,p_internal_name=>'APEX_5.0_REGION_HIDDEN_HEADING'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>717832816842067694.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625540218344381.4504)
,p_plug_template_id=>wwv_flow_api.id(385893260111566687.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625687233344381.4504)
,p_plug_template_id=>wwv_flow_api.id(385893260111566687.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_layout_container
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(386079172240342588.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="u-Table #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'#BODY#',
'#SUB_REGIONS#',
'</div>'))
,p_sub_plug_template=>'<div class="u-Table-fill">#SUB_REGION#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Layout Container'
,p_internal_name=>'APEX_5.0_LAYOUT_CONTAINER'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625790284344381.4504)
,p_plug_template_id=>wwv_flow_api.id(386079172240342588.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625807453344381.4504)
,p_plug_template_id=>wwv_flow_api.id(386079172240342588.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(690697788869123307.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140625999553344381.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626062703344381.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626126014344381.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626277717344381.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626327362344381.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626496588344380.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626586282344380.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626657635344380.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626705873344380.4504)
,p_plug_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(690714020036152159.4504)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626836729344380.4504)
,p_plug_template_id=>wwv_flow_api.id(690714020036152159.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140626979206344380.4504)
,p_plug_template_id=>wwv_flow_api.id(690714020036152159.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627056119344380.4504)
,p_plug_template_id=>wwv_flow_api.id(690714020036152159.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627158338344380.4504)
,p_plug_template_id=>wwv_flow_api.id(690714020036152159.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(703386252988943977.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>698829239393878937.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627292190344380.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627313317344380.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627452923344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627526600344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627602939344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627760217344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627886633344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140627909602344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628084853344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628170536344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628229298344379.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628317718344378.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628444911344378.4504)
,p_plug_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_accordion
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717402913540820747.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Accordion #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #SUBREGIONS#',
'</div>',
'<script type="text/javascript">',
'  apex.jQuery( "#accordion" ).accordion({',
'    icons: false,',
'    header: ".a-Region-header",',
'    heightStyle: ''content'',',
'    collapsible: true',
'  });',
'</script>'))
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Accordion-item">',
'#SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Accordion'
,p_internal_name=>'APEX_5.0_ACCORDION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174746301430371105.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628511837344378.4504)
,p_plug_template_id=>wwv_flow_api.id(717402913540820747.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628605263344378.4504)
,p_plug_template_id=>wwv_flow_api.id(717402913540820747.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717403738062820750.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628768286344378.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628896778344378.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140628950749344378.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629046289344378.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629183825344378.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629269705344378.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629362827344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629450750344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629590439344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629677724344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629792254344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629877448344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140629909864344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717413953976820775.4504)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #COMPONENT_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630098540344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717413953976820775.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630172078344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717413953976820775.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717414629694820775.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-PageColumn-header">',
'    <h2 class="a-PageColumn-heading">#TITLE#</h2>',
'  </div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613223222362440.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630234463344377.4504)
,p_plug_template_id=>wwv_flow_api.id(717414629694820775.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630313846344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717414629694820775.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column_body
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717415310646820776.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn-body #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column (Body)'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN_BODY'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174630015632506596.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630424943344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717415310646820776.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630552482344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717415310646820776.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717416284652820776.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #SUB_REGION_HEADERS#',
'  #SUB_REGIONS#',
'</div>',
'<script type="text/javascript">',
'    $("##REGION_STATIC_ID#").tabs({',
'      create: function() {',
'        $(this).addClass(''ui-tabs--simpleInset'')',
'      }',
'    });',
'</script>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#">#SUB_REGION_TITLE#</a></li>'
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer-item" id="#SUB_REGION_ID#">',
'#SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Tabs'
,p_internal_name=>'APEX_5.0_TABS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>183211208341566300.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630631085344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717416284652820776.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630722034344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717416284652820776.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717416953442820777.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Toolbar-items a-Toolbar-items--left">#PREVIOUS#</div>',
'  <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar'
,p_internal_name=>'APEX_5.0_TOOLBAR'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613705533399534.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630870751344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717416953442820777.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140630993119344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717416953442820777.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631068743344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717416953442820777.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631186746344376.4504)
,p_plug_template_id=>wwv_flow_api.id(717416953442820777.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_left
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717417607324820781.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--left #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Left)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_LEFT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174628415239478085.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631265610344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631366145344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631416167344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631504266344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631670438344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631796624344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631851827344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140631904406344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632086527344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632184989344375.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632272366344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632352001344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632498942344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717417607324820781.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_right
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717418310522820781.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--right #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Right)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_RIGHT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174629130392501406.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632574281344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632684557344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632728489344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632829190344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140632976120344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633006992344374.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633187155344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633239349344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633325873344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633488530344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633553386344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633605355344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633751591344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717418310522820781.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717419046555820782.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633824426344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140633968272344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634058093344373.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634187298344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634269600344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634358324344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634425692344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634598121344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634651276344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634770781344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634897134344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140634939761344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419046555820782.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717419707883820782.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635071870344372.4504)
,p_plug_template_id=>wwv_flow_api.id(717419707883820782.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635123057344371.4504)
,p_plug_template_id=>wwv_flow_api.id(717419707883820782.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(717420493098820783.4504)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635295761344371.4504)
,p_plug_template_id=>wwv_flow_api.id(717420493098820783.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635314550344371.4504)
,p_plug_template_id=>wwv_flow_api.id(717420493098820783.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_iframe_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(737759501522573640.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--iframe #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'  <div class="a-Region-iframeButtons">',
'    <div class="a-ButtonRegion">',
'      <div class="a-ButtonRegion-wrap">',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'          <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'        </div>',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - iFrame Region'
,p_internal_name=>'APEX_5.0_IFRAME_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--paddedBody'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>737749193541531906.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635430786344371.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635519515344371.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635623850344371.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635732017344371.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635860461344371.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140635916337344371.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636013446344370.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636119887344370.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636248417344370.4504)
,p_plug_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(746376253838324384.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636387849344370.4504)
,p_plug_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636479394344370.4504)
,p_plug_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636579333344370.4504)
,p_plug_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636639575344370.4504)
,p_plug_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636729256344370.4504)
,p_plug_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636805278344370.4504)
,p_plug_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_dialog
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#"  class="a-DialogRegion js-regionDialog #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# style="display:none" title="#TITLE#">',
'  <div class="a-DialogRegion-body">',
'#BODY#',
'  </div>',
'  <div class="a-DialogRegion-buttons">',
'     <div class="a-ButtonRegion a-ButtonRegion--dialogRegion">',
'       <div class="a-ButtonRegion-wrap">',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'       </div>',
'     </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region Dialog'
,p_internal_name=>'APEX_5.0_REGION_DIALOG'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'js-draggable:js-modal:js-resizable'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>428597701677720079.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140636961698344370.4504)
,p_plug_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637036888344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637180660344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637296576344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637375044344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637471669344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637577712344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637608675344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_nested_splitter
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1225836530715180993.4504)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="resize #REGION_CSS_CLASSES#"> ',
'#BODY#',
'<div id="#REGION_STATIC_ID#_content" class="resize">',
'#SUB_REGIONS#',
'</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Nested Splitter'
,p_internal_name=>'APEX_5.0_NESTED_SPLITTER'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>177373906751600776.4504
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637795916344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1225836530715180993.4504)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140637817526344369.4504)
,p_plug_template_id=>wwv_flow_api.id(1225836530715180993.4504)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist_from_4999
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1216501287578773.4504)
,p_list_template_current=>'<div class="dhtmlMenuItem"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#htmldb/builder/menu_pulldown.png" width="32" height="84" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBott'
||'om(this,''#LIST_ITEM_ID#'',false)" alt=""/><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_noncurrent=>'<div class="dhtmlMenuItem"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#htmldb/builder/menu_pulldown.png" width="32" height="84" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBott'
||'om(this,''#LIST_ITEM_ID#'',false)" alt="" /><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_name=>'DHTML List (Image) with Sublist from 4999'
,p_internal_name=>'DHTML_LIST_IMAGE_WITH_SUBLIST_FROM_4999'
,p_theme_id=>3
,p_theme_class_id=>10
,p_list_template_before_rows=>'<div class="dhtmlMenuLG">'
,p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>'
,p_before_sub_list=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">',
'<li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>'))
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_reference_id=>6245728734686542.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_tabbed_navigation_list_ppr
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(11751121765920036.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="javascript:ob_PPR_TAB(''#LINK#'')" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="javascript:ob_PPR_TAB(''#LINK#'')" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_list_template_name=>'Simple Tabbed Navigation List (PPR)'
,p_internal_name=>'SIMPLE_TABBED_NAVIGATION_LIST_PPR'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbTabbedNavigationList" border="0" cellpadding="0" cellspacing="0" summary=""><tr>',
'',
''))
,p_list_template_after_rows=>'<td width="100%"><br /></td></tr></table>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_reference_id=>108849122001556988.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/dhtml_list_button_with_sublist
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(18702621564272688.4504)
,p_list_template_current=>'<li>#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" class="dList" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_list_template_name=>'DHTML List Button with Sublist'
,p_internal_name=>'DHTML_LIST_BUTTON_WITH_SUBLIST'
,p_theme_id=>3
,p_theme_class_id=>10
,p_list_template_before_rows=>'<ul class="dList">'
,p_list_template_after_rows=>'</ul>'
,p_item_templ_curr_w_child=>'<li>#TEXT#</li>'
,p_item_templ_noncurr_w_child=>'<li><a href="#LINK#" class="dList" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_reference_id=>18183125227392377.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(20507805987268923.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List (2)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/flowwizard
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(23328315128356826.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-current"><span>#TEXT#</span></div>',
''))
,p_list_template_noncurrent=>'<div class="apex-wiz-non"><span>#TEXT#</span></div>'
,p_list_template_name=>'FlowWizard'
,p_internal_name=>'FLOWWIZARD'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-wiz-bar">'
,p_list_template_after_rows=>'</div>'
,p_between_items=>'<div class="apex-wiz-arrow"></div>'
,p_reference_id=>60218330803141060.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/columbus_object_browser_object_types
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(23673306353078906.4504)
,p_list_template_current=>'<option htmldb:type="#A01#" id="#A01#" value="#A01#" selected="selected"">#TEXT#</option>'
,p_list_template_noncurrent=>'<option htmldb:type="#A01#" id="#A01#" value="#A01#">#TEXT#</option>'
,p_list_template_name=>'(Columbus) Object Browser Object Types'
,p_internal_name=>'COLUMBUS_OBJECT_BROWSER_OBJECT_TYPES'
,p_theme_id=>3
,p_theme_class_id=>16
,p_list_template_before_rows=>'<label for="obObjectSelect" class="hideMeButHearMe">Object Type</label><select onchange="gLastTab=false;gSideBar.onchange(true);"  id="obObjectSelect" class="a-Form-select">'
,p_list_template_after_rows=>'</select>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(32427114807996970.4504)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>32421627622986728.4504
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/unordered_list_omit_current
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(35432701931461853.4504)
,p_list_template_current=>' '
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_list_template_name=>'Unordered List (omit current)'
,p_internal_name=>'UNORDERED_LIST_OMIT_CURRENT'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="noIndent">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>354043718465235283.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_tabbed_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(108863608130594810.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_list_template_name=>'Simple Tabbed Navigation List'
,p_internal_name=>'SIMPLE_TABBED_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbTabbedNavigationList" border="0" cellpadding="0" cellspacing="0"><tr>',
'',
''))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td width="100%"><br /></td></tr></table>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_reference_id=>108854228567566739.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/image_list_legend
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(175500817357553766.4504)
,p_list_template_current=>'<li><img src="#IMAGE_PREFIX##IMAGE#" style="margin-right:10px;" alt="" />#TEXT#</li>'
,p_list_template_noncurrent=>'<li><img src="#IMAGE_PREFIX##IMAGE#" style="margin-right:10px;" alt="" />#TEXT#</li>'
,p_list_template_name=>'Image List (Legend)'
,p_internal_name=>'IMAGE_LIST_LEGEND'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="htmldbSessionLegend">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>237858014773116158.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(196867506292090262.4504)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs (2)'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705.4504
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_pull_down_button_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(208299907447573159.4504)
,p_list_template_current=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton" type="button"><span>#TEXT#</span></button> '
,p_list_template_noncurrent=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton" type="button"><span>#TEXT#</span></button> '
,p_list_template_name=>'APEX 4.2 - Pull Down Button List'
,p_internal_name=>'APEX_4.2_PULL_DOWN_BUTTON_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<div class="rButtonContainer dhtmlMenuLGButton">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton" type="button"><span>#TEXT#</span></button> '
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" class="dhtmlMenu" type="button"><span>#TEXT#<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></span></button> ',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>'
,p_reference_id=>253872418832604079.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_run_edit_bar
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(212033724996722960.4504)
,p_list_template_current=>'  <li><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#TEXT_ESC_SC#" class="iconSmall #A01#" /></a></li>'
,p_list_template_noncurrent=>'  <li><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#TEXT_ESC_SC#" class="iconSmall #A01#" /></a></li>'
,p_list_template_name=>'APEX 4.2 - Run / Edit Bar'
,p_internal_name=>'APEX_4.2_RUN_/_EDIT_BAR'
,p_theme_id=>3
,p_theme_class_id=>3
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="aRunEditBar">',
'  <li><span class="currentPage">&PAGE. &FB_FLOW_PAGE_ID.</span></li>'))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>210390516819756900.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_wizard_progress_sidebar_clickable
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(240152923292316768.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-current">',
'  <div class="apex-wiz-top"></div>',
'  <div class="apex-wiz-body">#TEXT#</div>',
'</div>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-non">',
'  <div class="apex-wiz-top"></div>',
'  <div class="apex-wiz-body"><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div>',
'</div>'))
,p_list_template_name=>'(Done) Wizard Progress Sidebar (Clickable)'
,p_internal_name=>'DONE_WIZARD_PROGRESS_SIDEBAR_CLICKABLE'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-wiz-bar">'
,p_list_template_after_rows=>'</div>'
,p_between_items=>'<div class="apex-wiz-arrow-small"></div>'
,p_reference_id=>240146817030288131.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/button_list_horizontal_c_htmldbbuttonlist
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(292458412644987596.4504)
,p_list_template_current=>'<td><a href="#LINK#" class="htmldbButtonListCurrent">#TEXT#</a></td>'
,p_list_template_noncurrent=>'<td><a href="#LINK#" class="htmldbButtonList">#TEXT#</a></td>'
,p_list_template_name=>'Button List Horizontal (c:htmldbButtonList)'
,p_internal_name=>'BUTTON_LIST_HORIZONTAL_C:HTMLDBBUTTONLIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="htmldbButtonList" summary="" border="0" cellpadding="0" cellspacing="3"><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_item_templ_curr_w_child=>'<td><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" width="20" height="1" /></td>'
,p_item_templ_noncurr_w_child=>'<td><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" width="20" height="1" /></td>'
,p_reference_id=>21059717155998569.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(385776082908002390.4504)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(385776364537002403.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(385894774262579225.4504)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4504
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_pull_down_button_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(436814111820869843.4504)
,p_list_template_current=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton" type="button"><span>#TEXT#</span></button> '
,p_list_template_noncurrent=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton" type="button"><span>#TEXT#</span></button> '
,p_list_template_name=>'APEX 4.0 - Pull Down Button List'
,p_internal_name=>'APEX_4.0_PULL_DOWN_BUTTON_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<div class="rButtonContainer dhtmlMenuLGButton">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton" type="button"><span>#TEXT#</span></button> '
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" class="dhtmlMenu" type="button"><span>#TEXT#<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></span></button> ',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>'
,p_reference_id=>253872418832604079.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_ob_button_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(461032606198391037.4504)
,p_list_template_current=>'<div class="list-button-c"><button onclick="#LINK#" class="dhtmlMenu" type="button"><span>#TEXT#</span></button></div>'
,p_list_template_noncurrent=>'<div class="list-button-nc"><button onclick="#LINK#" class="dhtmlMenu" type="button"><span>#TEXT#</span></button></div>'
,p_list_template_name=>'APEX 4.0 - OB Button List'
,p_internal_name=>'APEX_4.0_OB_BUTTON_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<div class="dhtmlMenuLGButton">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<div class="list-button-c-sub"><button onclick="#LINK#" class="dhtmlMenu" type="button"><span>#TEXT#</span></button></div>'
,p_item_templ_noncurr_w_child=>'<div class="list-button-nc-sub"><button onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" class="dhtmlMenu" type="button"><span>#TEXT#</span></button></div>'
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>'
,p_reference_id=>461050507240493294.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(692727073209839891.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(703372217110859571.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_002
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(704358525679957526.4504)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4504
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs_002
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(764029929273005392.4504)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705.4504
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sql_workshop_buttons_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1241653799958177324.4504)
,p_list_template_current=>'<button type="button" onclick="apex.navigation.redirect(''#LINK#'')" class="a-Button">#TEXT#</button>'
,p_list_template_noncurrent=>'<button type="button" onclick="apex.navigation.redirect(''#LINK#'')" class="a-Button">#TEXT#</button>'
,p_list_template_name=>'APEX 5.0 - SQL Workshop Buttons List'
,p_internal_name=>'APEX_5.0_SQL_WORKSHOP_BUTTONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="a-Button-list">'
,p_list_template_after_rows=>'</div>'
,p_reference_id=>1241650007443166178.4504
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard_new_ajax
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2251716882439710.4504)
,p_row_template_name=>'Standard (New Ajax)'
,p_internal_name=>'STANDARD_NEW_AJAX'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999_3
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(7082409118250737.4504)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report From 4999 (3)'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999_3'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(11028007180514315.4504)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report from 4999'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999_2
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(22095907193828478.4504)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report From 4999 (2)'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999_2'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/database_browser_trigger_body
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(33210746522512634.4504)
,p_row_template_name=>'Database Browser Trigger Body'
,p_internal_name=>'DATABASE_BROWSER_TRIGGER_BODY'
,p_row_template1=>'<pre>#TRIGGER_BODY#</pre>'
,p_row_template_before_rows=>'<table><tr><td>'
,p_row_template_after_rows=>'</td></tr></table>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>354957901800346152.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/quick_pick_list_items
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(38811532466194226.4504)
,p_row_template_name=>'quick_pick_list_items'
,p_internal_name=>'QUICK_PICK_LIST_ITEMS'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(46912117501975223.4504)
,p_row_template_name=>'APEX 4.0 - Portlet Row Template'
,p_internal_name=>'APEX_4.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/icon_report_from_4999
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(134307417931747174.4504)
,p_row_template_name=>'Icon Report From 4999'
,p_internal_name=>'ICON_REPORT_FROM_4999'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100" style="float:left;margin:10px;">',
'<tr><td align="center"><a href="#3#"><img src="#IMAGE_PREFIX##1#" title="#2#" alt="#2#" style="display:block;"/></a></td></tr>',
'<tr><td align="center"><a href="#3#" class="htmldbIconName">#4#</a></td></tr>',
'</table>',
'<br style="clear:both;" />'))
,p_row_template_condition1=>'mod (#ROWNUM#, 5) = 0'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100" style="float:left;margin:10px;">',
'<tr><td align="center"><a href="#3#"><img src="#IMAGE_PREFIX##1#" title="#2#" alt="#2#" style="display:block;"/></a></td></tr>',
'<tr><td align="center"><a href="#3#" class="htmldbIconName">#4#</a></td></tr>',
'</table>'))
,p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table class="htmldbListIconHolder" border="0" cellpadding="0" cellpadding="0" summary="">#TOP_PAGINATION#<tr><td>'
,p_row_template_after_rows=>'</td></tr>#PAGINATION#</table></htmldb:#REGION_ID#></div>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>134516716361378454.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_no_background
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(161923301611160944.4504)
,p_row_template_name=>'Vertical - No Background'
,p_internal_name=>'VERTICAL_NO_BACKGROUND'
,p_row_template1=>'<tr><th scope="row" align="right">#COLUMN_HEADER#</th><td>#COLUMN_VALUE#</td></tr>'
,p_row_template_before_rows=>'#CSV_LINK#<table class="htmldbVerticalRptPlain" summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>172647727246303349.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/no_background
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(165449703104678078.4504)
,p_row_template_name=>'No Background'
,p_internal_name=>'NO_BACKGROUND'
,p_row_template1=>'<td#ALIGNMENT# id="td#ROWNUM#_#COLNUM#" headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" class="htmldbRptNoBackground" summary="#REGION_TITLE#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_before_first=>'<tr id="row#ROWNUM#">'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>237868603542157245.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(171907206171165798.4504)
,p_row_template_name=>'APEX 4.0 - Portlet Column Template'
,p_internal_name=>'APEX_4.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/automatic_ppr_no_background
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(172773906323382535.4504)
,p_row_template_name=>'Automatic PPR - No Background'
,p_internal_name=>'AUTOMATIC_PPR_NO_BACKGROUND'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="htmldbRptNoBackHoriz"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>172923115706660192.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(385896719135645040.4504)
,p_row_template_name=>'APEX 5.0 - Badge List'
,p_internal_name=>'APEX_5.0_BADGE_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_date_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(386075171368129866.4504)
,p_row_template_name=>'APEX 5.0 - Date List'
,p_internal_name=>'APEX_5.0_DATE_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="a-DateList-item">',
'    <div class="a-MediaBlock">',
'      <div class="a-MediaBlock-graphic">',
'        <span class="a-DateList-date">',
'          <span class="a-DateList-day">#DAY#</span>',
'          <span class="a-DateList-month">#MONTH#</span>',
'        </span>',
'      </div>',
'      <div class="a-MediaBlock-content">',
'        <span class="a-DateList-desc">#TEXT#</span>',
'        <span class="a-DateList-attribute">#CREATED_BY#</span>',
'        <span class="a-DateList-attribute">#CREATED_ON#</span>',
'      </div>',
'    </div>',
'  </li>'))
,p_row_template_before_rows=>'<ul class="a-DateList">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(617728329737082310.4504)
,p_row_template_name=>'APEX 4.0 - Standard Report'
,p_internal_name=>'APEX_4.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(717423775712828084.4504)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(717432943772828094.4504)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(717433602632828095.4504)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(717436155076828097.4504)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_vertical_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1127586271702515372.4504)
,p_row_template_name=>'APEX 5.0 - Vertical Report'
,p_internal_name=>'APEX_5.0_VERTICAL_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'  <td class="a-Report-cell a-Report-cell--header" scope="row">#COLUMN_HEADER#</td>',
'  <td class="a-Report-cell">#COLUMN_VALUE#</td>',
'</tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report a-Report--vertical a-Report--staticRowColors #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" summary="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>' '
,p_row_template_after_last=>' '
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>1126924627125205941.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1340556612002171029.4504)
,p_row_template_name=>'APEX 5.0 - Portlet Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1340557295961171098.4504)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3301520602864636.4504)
,p_template_name=>'FormField_Optional'
,p_internal_name=>'FORMFIELD_OPTIONAL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041.4504
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_required
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3301625476864638.4504)
,p_template_name=>'FormField_Required'
,p_internal_name=>'FORMFIELD_REQUIRED'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>2
,p_reference_id=>17388508175892042.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/label_tag_only
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(4904018598976684.4504)
,p_template_name=>'LABEL Tag Only'
,p_internal_name=>'LABEL_TAG_ONLY'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(6693608793786901.4504)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional_w_o_popup
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(12399821819620115.4504)
,p_template_name=>'FormField_Optional w/o popup'
,p_internal_name=>'FORMFIELD_OPTIONAL_W/O_POPUP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><span class="htmldbLabelOptional">'
,p_template_body2=>'</span></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>238114715839717766.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/htmldb_greenarealabel_c_htmldbgalabel
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(187652405321922937.4504)
,p_template_name=>'htmldb_GreenAreaLabel (c:htmldbGALabel)'
,p_internal_name=>'HTMLDB_GREENAREALABEL_C:HTMLDBGALABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_4_0_top_bar_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(197619827652543551.4504)
,p_template_name=>'APEX 4.0 - Top Bar Label'
,p_internal_name=>'APEX_4.0_TOP_BAR_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(488671029226029669.4504)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(488671190365029680.4504)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(492677255463052067.4504)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(492677350674053149.4504)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(717397080423801376.4504)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="" aria-label="" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span>'
||'</button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4504
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(717397144393801382.4504)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(6698104029693013.4504)
,p_name=>'breadcrumbs'
,p_internal_name=>'BREADCRUMBS'
,p_current_page_option=>'<span class="htmldbBreadcrumb">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#" class="htmldbBreadcrumb" title="#NAME#">#NAME#</a>'
,p_between_levels=>'<span class="htmldbBreadcrumbSep"><img alt="" src="#IMAGE_PREFIX#apex/apex_top_sep.gif"></span>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>60115300853820165.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(387975456606606350.4504)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4504
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(12797101143975616.4504)
,p_page_name=>'winlov'
,p_page_title=>'Finestra di dialogo di ricerca'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Cerca'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Chiudi'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Successivo &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Precedente'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Righe #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4504
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/basic_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(11334530416692434.4504)
,p_cal_template_name=>'Basic Calendar'
,p_internal_name=>'BASIC_CALENDAR'
,p_day_of_week_format=>'<th scope="col">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation">',
' <tr>',
'   <td align="center" style="font-weight:bold;">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="1" cellpadding="1" cellspacing="1" summary="0">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div>#DD#</div><br />'
,p_day_open_format=>'<td valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" bgcolor="#d3d3d3">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div>#DD#</div>'
,p_weekend_open_format=>'<td valign="top">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div>#DD#</div>'
,p_nonday_open_format=>'<td valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(72332249557526712.4504)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(204023927913767476.4504)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556399735490108657.4504)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556400064664109422.4504)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689635167517993971.4504)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689636107671993973.4504)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689636807321993973.4504)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689638757932993974.4504)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(692727409810839893.4504)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(696624360683145458.4504)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(697239665711708855.4504)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(698688432545187815.4504)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(698689189405187817.4504)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(698689890777187817.4504)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(698691450870187818.4504)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(717406084452820762.4504)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(717424165974828087.4504)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(717426618396828089.4504)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746376625117324389.4504)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746420691677405750.4504)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746421932096405751.4504)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746422298476405751.4504)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746422550773405751.4504)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746423628537405752.4504)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746423916240405752.4504)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746424218274405754.4504)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746424531468405755.4504)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746424813431405755.4504)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746425349736405755.4504)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(746425674061405755.4504)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1141459524801402371.4504)
,p_theme_id=>3
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Dialog Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Predefined dialog sizes'
,p_null_text=>'Default Size'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755319348318018349.4504)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755319458208018350.4504)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755319634177018356.4504)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(746376625117324389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755319862500018356.4504)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(746376625117324389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755320072547018357.4504)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(746376625117324389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755320288486018357.4504)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(717406084452820762)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755320416910018357.4504)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(717406084452820762)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755320549428018357.4504)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755320725444018357.4504)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(746376253838324384.4504)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(746376625117324389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755321011331018360.4504)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755321262415018361.4504)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755321430113018361.4504)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755321650581018361.4504)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755321826695018361.4504)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755321997452018361.4504)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755322169222018361.4504)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755322393600018361.4504)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690697788869123307.4504)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(696624360683145458)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755334063275018373.4504)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755334236254018373.4504)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755334469839018373.4504)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755334699540018373.4504)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755334871937018373.4504)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755335024214018375.4504)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755335244855018375.4504)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(737759501522573640.4504)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755343697621018390.4504)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755343852274018390.4504)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755344085264018390.4504)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755344293879018390.4504)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755344447099018391.4504)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755344602370018391.4504)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755344861153018391.4504)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755345020387018391.4504)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755345249021018391.4504)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755345413694018391.4504)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755345686664018391.4504)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755345836994018391.4504)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755346057787018391.4504)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(385896719135645040.4504)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755346536605018392.4504)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755346771517018392.4504)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755346908516018392.4504)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755347127238018393.4504)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755347387178018393.4504)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755347523204018393.4504)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755347707352018393.4504)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755347942333018393.4504)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755348111386018393.4504)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755348302485018394.4504)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755348557394018394.4504)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755348717973018394.4504)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755348979659018394.4504)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717423775712828084.4504)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755359739129018410.4504)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755359935524018410.4504)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755360139586018410.4504)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755360307757018410.4504)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755360503097018411.4504)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755360682997018411.4504)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755360717790018411.4504)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755360835509018411.4504)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755360943590018411.4504)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755361040145018411.4504)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755367926644019886.4504)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(746424531468405755)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755368131371019886.4504)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(746424813431405755)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755368316248019887.4504)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(746425349736405755)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755368553370019887.4504)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(746424218274405754)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755368735312019887.4504)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(746424531468405755)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755368927938019887.4504)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(746424813431405755)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755369189057019887.4504)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(746422550773405751)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755369395951019887.4504)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(746422550773405751)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755369570087019887.4504)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(746422550773405751)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755369737564019889.4504)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(746425674061405755)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755369838791019889.4504)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755370076039019889.4504)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(746424218274405754)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755370120514019889.4504)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755370393151019889.4504)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(746422298476405751)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755370562593019889.4504)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(746422298476405751)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755370786398019889.4504)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(746423916240405752)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755370945815019890.4504)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(746421932096405751)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755371117542019890.4504)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(746423628537405752)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755371211932019890.4504)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755371447167019890.4504)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(746422298476405751)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755371663537019890.4504)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(746422298476405751)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755371848184019890.4504)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755372020903019890.4504)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755372233442019890.4504)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755372416975019890.4504)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755372687978019890.4504)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(755372807853019891.4504)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787117311043949716.4504)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2251716882439710.4504)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(698688432545187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787117583690949716.4504)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2251716882439710.4504)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(698689189405187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787117782882949716.4504)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2251716882439710.4504)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787117993065949716.4504)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2251716882439710.4504)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787118109139949716.4504)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2251716882439710.4504)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787118210367949716.4504)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2251716882439710.4504)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787118446447949717.4504)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2251716882439710.4504)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(698691450870187818)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787118999001949718.4504)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(617728329737082310.4504)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(698688432545187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787119198364949718.4504)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(617728329737082310.4504)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(698689189405187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787119375234949718.4504)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(617728329737082310.4504)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787119542567949718.4504)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(617728329737082310.4504)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787119713399949718.4504)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(617728329737082310.4504)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787119853489949718.4504)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(617728329737082310.4504)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787120018395949718.4504)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(617728329737082310.4504)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(698691450870187818)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787133502775949747.4504)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717436155076828097.4504)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(698688432545187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787133742911949747.4504)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717436155076828097.4504)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(698689189405187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787133937296949747.4504)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717436155076828097.4504)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787134188912949747.4504)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717436155076828097.4504)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787134324612949747.4504)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717436155076828097.4504)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787134433950949747.4504)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717436155076828097.4504)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787134647594949747.4504)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717436155076828097.4504)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(698691450870187818)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(926399273702707533.4504)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(385776364537002403.4504)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(926399333093707533.4504)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(385776364537002403.4504)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(940697553666341585.4504)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131768309924193980.4504)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1127586271702515372.4504)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(698689189405187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131768523123193980.4504)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1127586271702515372.4504)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131768627575193980.4504)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1127586271702515372.4504)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131768874640193981.4504)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1127586271702515372.4504)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131769045921193981.4504)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1127586271702515372.4504)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(698691450870187818)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131769275377193981.4504)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1127586271702515372.4504)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1199561355394032423.4504)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(746425349736405755)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1445975050737085430.4504)
,p_theme_id=>3
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be resized.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1445975135241085430.4504)
,p_theme_id=>3
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be moved.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1445975358746085430.4504)
,p_theme_id=>3
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_api.id(1141459524801402371)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1445975518111085431.4504)
,p_theme_id=>3
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_api.id(1141459524801402371)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1445975704313085431.4504)
,p_theme_id=>3
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_api.id(1141459524801402371)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1445975835000085431.4504)
,p_theme_id=>3
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_api.id(1131993087623131882.4504)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
,p_help_text=>'Display as modal.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525655309965182076.4504)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525655479052182076.4504)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525655500963182076.4504)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525655616409182076.4504)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525655890890182076.4504)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697239665711708855)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525656046318182076.4504)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697239665711708855)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525667568855182133.4504)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525667694538182133.4504)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525667713426182133.4504)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525667858315182133.4504)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525668042336182133.4504)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697239665711708855)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525668231424182134.4504)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697239665711708855)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544815603312477990.4504)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(38811532466194226.4504)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544815753448477990.4504)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(38811532466194226.4504)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544815884959477990.4504)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(38811532466194226.4504)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544818837483478024.4504)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717433602632828095.4504)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544818973917478024.4504)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717433602632828095.4504)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544819035865478024.4504)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(717433602632828095.4504)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554812770773408377.4504)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554812985067408377.4504)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554813151047408377.4504)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554813301944408378.4504)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554813525412408378.4504)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689636107671993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554813730587408378.4504)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554813933522408378.4504)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554814137047408378.4504)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554814391152408378.4504)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554814467842408378.4504)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554814632627408378.4504)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(380771699411878611.4504)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(689636807321993973)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554831633096526796.4504)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(690714020036152159.4504)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554831701564526797.4504)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690714020036152159.4504)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554831806774526797.4504)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(690714020036152159.4504)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554846967207542276.4504)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554847055162542276.4504)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554847272590542276.4504)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554847450067542276.4504)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554847672581542276.4504)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689636107671993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554847887758542276.4504)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554848073675542277.4504)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554848294732542277.4504)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554848424496542277.4504)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(717406084452820762)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554848666729542278.4504)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(717403738062820750.4504)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(717406084452820762)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554862320208550802.4504)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554862544640550802.4504)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554862741972550802.4504)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554862983266550802.4504)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554863120634550802.4504)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554863336092550802.4504)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554863545945550802.4504)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554863760759550802.4504)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554863920638550802.4504)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689636107671993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554864134947550802.4504)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(703386252988943977.4504)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(140211619632429750.4504)
,p_build_option_name=>'SQL Command Processor Transactions'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'within the SQL command processor; ability to run in a transactional mode. ',
'',
'Uses DBMS_JOBS to maintain session state over multiple pages views / statements within a transaction.'))
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(140265918963157648.4504)
,p_build_option_name=>'Database Monitoring'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'monitor sessions',
'view SQL',
'view tablespace information',
'view data files',
'trace sessions',
''))
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(240237502901130926.4504)
,p_build_option_name=>'Create Synonym Wizard'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'Show or suppress the create synonym wizard'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(240247031763163202.4504)
,p_build_option_name=>'Create MView Wizard'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'Show or suppress create materialized view wizard'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(256109433659228165.4504)
,p_build_option_name=>'Object REST Enablement'
,p_build_option_status=>'INCLUDE'
,p_default_on_export=>'INCLUDE'
,p_build_option_comment=>'This is being used to hide REST Enablement features in the Object Browser.'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(693462110571635991.4504)
,p_build_option_name=>'Enable APEX Internal Feedback'
,p_build_option_status=>'EXCLUDE'
,p_default_on_export=>'EXCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(1080926199001296276.4504)
,p_build_option_name=>'Commented Out'
,p_build_option_status=>'EXCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(1694682434415493288.4504)
,p_build_option_name=>'BUILDER_AUTH_SSO'
,p_build_option_status=>'INCLUDE'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228211835316626)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'it'
,p_message_text=>'Chiudi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226720295316624)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'it'
,p_message_text=>'Trova'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228309545316626)
,p_name=>'CODE_EDITOR.FIND_INPUT'
,p_message_language=>'it'
,p_message_text=>'Trova'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226660169316624)
,p_name=>'CODE_EDITOR.FIND_NEXT'
,p_message_language=>'it'
,p_message_text=>'Trova successivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226594969316624)
,p_name=>'CODE_EDITOR.FIND_PREV'
,p_message_language=>'it'
,p_message_text=>'Trova precedente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227820055316625)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'it'
,p_message_text=>'Completamento automatico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227440761316625)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione indentazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227223064316625)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'it'
,p_message_text=>'La tabulazione inserisce spazi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228090302316625)
,p_name=>'CODE_EDITOR.MATCH_CASE'
,p_message_language=>'it'
,p_message_text=>'Corrispondenza maiuscole/minuscole'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228115855316626)
,p_name=>'CODE_EDITOR.MATCH_RE'
,p_message_language=>'it'
,p_message_text=>'Espressione regolare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228896402316626)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'it'
,p_message_text=>'Query Builder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226386656316624)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'it'
,p_message_text=>'Ripristina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226403064316624)
,p_name=>'CODE_EDITOR.REPLACE'
,p_message_language=>'it'
,p_message_text=>'Sostituisci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228596737316626)
,p_name=>'CODE_EDITOR.REPLACE_ALL'
,p_message_language=>'it'
,p_message_text=>'Sostituisci tutto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228474426316626)
,p_name=>'CODE_EDITOR.REPLACE_INPUT'
,p_message_language=>'it'
,p_message_text=>'Sostituisci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228669128316626)
,p_name=>'CODE_EDITOR.REPLACE_SKIP'
,p_message_language=>'it'
,p_message_text=>'Salta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226930064316625)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'it'
,p_message_text=>'Impostazioni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226829324316625)
,p_name=>'CODE_EDITOR.SHORTCUT_TITLE'
,p_message_language=>'it'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227135768316625)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'it'
,p_message_text=>'Mostra numeri di riga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227959908316625)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'it'
,p_message_text=>'Mostra righello'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227318217316625)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'it'
,p_message_text=>'Dimensione tabulazione'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227572243316625)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'it'
,p_message_text=>'Temi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226236912316624)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'it'
,p_message_text=>'Annulla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227053880316625)
,p_name=>'CODE_EDITOR.USE_PLAIN_TEXT_EDITOR'
,p_message_language=>'it'
,p_message_text=>'Usa editor di testo non codificato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227792262316625)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'it'
,p_message_text=>'Convalida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110227616750316625)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'it'
,p_message_text=>'Convalida completata'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226134015316624)
,p_name=>'DATA.LOAD.SODA_FILE_FORMATS'
,p_message_language=>'it'
,p_message_text=>'Formati supportati: json, txt e zip'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110226080441316624)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'it'
,p_message_text=>'Raccogli statistiche tabelle'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110228752235316626)
,p_name=>'SCRIPTS.CHANGES_SAVED'
,p_message_language=>'it'
,p_message_text=>'Modifiche salvate'
,p_is_js_message=>true
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/rename_script_name
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(32179615812392135.4504)
,p_shortcut_name=>'RENAME_SCRIPT_NAME'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('Il nome di script esiste gi\00E0 nell''area di lavoro ed \00E8 di propriet\00E0 di un altro utente. Immettere un altro nome.')
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/invalid_script_name
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(110796504497651817.4504)
,p_shortcut_name=>'INVALID_SCRIPT_NAME'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('Il nome dello script non pu\00F2 contenere caratteri riservati.')
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/null_script_name
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(110802131425678586.4504)
,p_shortcut_name=>'NULL_SCRIPT_NAME'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Specificare un valore per Nome script.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/null_script
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(110803013894682985.4504)
,p_shortcut_name=>'NULL_SCRIPT'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Immettere lo script.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/dup_script_name
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(111043910462526159.4504)
,p_shortcut_name=>'DUP_SCRIPT_NAME'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('Il nome script esiste gi\00E0 nell''area di lavoro.')
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/max_script_size
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(133393615560571789.4504)
,p_shortcut_name=>'MAX_SCRIPT_SIZE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Lo script supera la dimensione massima consentita.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(165162327257300666.4504)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Eseguire questa azione di eliminazione?'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/ok_to_get_next_prev_pk_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(180175522684124268.4504)
,p_shortcut_name=>'OK_TO_GET_NEXT_PREV_PK_VALUE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('Si \00E8 certi di voler uscire da questa pagina senza salvare?')
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(539837904309662819.4504)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>540226219724705040.4504
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_language
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2678472121698841.4504)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_LANGUAGE'
,p_display_name=>'Linguaggio del codice'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_LANGUAGE'),'')
,p_api_version=>2
,p_render_function=>'wwv_flow_f4000_plugins.render_code_language'
,p_validation_function=>'wwv_flow_f4000_plugins.validate_code_language'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_reference_id=>1801904462214602.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2678664416698833.4504)
,p_plugin_id=>wwv_flow_api.id(2678472121698841.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Default Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Automatically Picked'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2679023964698832.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(2678664416698833.4504)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2679542644698827.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(2678664416698833.4504)
,p_display_sequence=>20
,p_display_value=>'PL/SQL'
,p_return_value=>'PLSQL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2680096274698826.4504)
,p_plugin_id=>wwv_flow_api.id(2678472121698841.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Type Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2680454110698826.4504)
,p_plugin_id=>wwv_flow_api.id(2678472121698841.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Hide SQL'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2680096274698826.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12506617921221692.4504)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Autorizzazione sviluppatore'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(651605483130363833.4504)
,p_plugin_id=>wwv_flow_api.id(12506617921221692.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651605887107363834.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651606376314363835.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651606873879363835.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651607312731363835.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651607861427363835.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651608356270363836.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651608825236363836.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651609302545363836.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651609853767363837.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651610341143363837.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651610845882363837.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651611392210363837.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(651605483130363833.4504)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_plugin_dynamic_attribute
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12964533458812939.4504)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_display_name=>'Attributo dinamico plugin'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_plugin_attribute'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_plugin_attribute'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_reference_id=>6480508142096556.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(44507297529251872.4504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_reference_id=>77082398185639908.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(61354658999430857.4504)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Casella di ricerca'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513166384709230023.4504)
,p_plugin_id=>wwv_flow_api.id(61354658999430857.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513166776921230023.4504)
,p_plugin_id=>wwv_flow_api.id(61354658999430857.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(113746032581665431.4504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'Autenticazione Apex'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113737019268347425.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(118578616481923799.4504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>'INTERNAL - Social Sign-In'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_reference_id=>117694777698093086.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328149444430427041.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328149831182427041.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328150325360427041.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328150887348427042.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328151376844427042.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328151832449427042.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328152272150427042.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328152601649427042.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328153086388427043.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328153437417427043.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Application Express automatically adds the "openid" scope. The authent'
||'ication provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328153841169427043.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328154239387427043.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328154631928427043.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328155031688427044.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328155443813427044.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328149444430427041.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328155862064427044.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(328155443813427044.4504)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328156373941427044.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(328155443813427044.4504)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328156896430427045.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(328155443813427044.4504)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328157300537427045.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(328155443813427044.4504)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328157848185427045.4504)
,p_plugin_id=>wwv_flow_api.id(118578616481923799.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (e.g. "email_verified" for Username Attribute "email"). If this is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_wizard_selection
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(217679430964254738.4504)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.WIZARD_SELECTION'
,p_display_name=>'Selezione procedura guidata'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.WIZARD_SELECTION'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_wizard_selection'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_wizard_selection'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:SOURCE:ELEMENT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_reference_id=>3260301366184169092.4504
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(217679670985254744.4504)
,p_plugin_id=>wwv_flow_api.id(217679430964254738.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(217680058170254749.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(217679670985254744.4504)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(217680572057254752.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(217679670985254744.4504)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'M'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(217681055305254752.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(217679670985254744.4504)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'L'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(217681523143254753.4504)
,p_plugin_id=>wwv_flow_api.id(217679430964254738.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Submit Page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Select whether or not to submit the page when making a selection'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(217681920100254757.4504)
,p_plugin_id=>wwv_flow_api.id(217679430964254738.4504)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356673325634447685.4504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'Oracle Cloud Identity Management INTERNAL'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749806821809026.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356675826982447689.4504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'Account di database INTERNAL'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749511183746276.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356690631776447712.4504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'Variabile di intestazione HTTP INTERNAL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>708795120396802284.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43526557817381457.4504)
,p_plugin_id=>wwv_flow_api.id(356690631776447712.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43528213074381457.4504)
,p_plugin_id=>wwv_flow_api.id(356690631776447712.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43529964170381457.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(43528213074381457.4504)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43532214716381458.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(43528213074381457.4504)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43534350156381458.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(43528213074381457.4504)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43536131502381458.4504)
,p_plugin_id=>wwv_flow_api.id(356690631776447712.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(43528213074381457.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43537975309381458.4504)
,p_plugin_id=>wwv_flow_api.id(356690631776447712.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(43528213074381457.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43539670512381459.4504)
,p_plugin_id=>wwv_flow_api.id(356690631776447712.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(43528213074381457.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'BUILTIN_URL,URL'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43541495879381459.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(43539670512381459.4504)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43543420464381459.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(43539670512381459.4504)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43545345255381459.4504)
,p_plugin_id=>wwv_flow_api.id(356690631776447712.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356758608092447765.4504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'Directory LDAP INTERNAL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>863910941135523528.4504
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere il nome utente e la password per l''autenticazione rispetto alla directory LDAP identificata nella pagina di login. Le password possono distinguere tra maiuscole e minuscole.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356758914849447766.4504)
,p_plugin_id=>wwv_flow_api.id(356758608092447765.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356759306041447766.4504)
,p_plugin_id=>wwv_flow_api.id(356758608092447765.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356759710067447766.4504)
,p_plugin_id=>wwv_flow_api.id(356758608092447765.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356760114899447766.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(356759710067447766.4504)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356760629181447767.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(356759710067447766.4504)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356761131992447767.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(356759710067447766.4504)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356761615461447767.4504)
,p_plugin_id=>wwv_flow_api.id(356758608092447765.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356762006427447767.4504)
,p_plugin_id=>wwv_flow_api.id(356758608092447765.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356762419044447767.4504)
,p_plugin_id=>wwv_flow_api.id(356758608092447765.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(356762006427447767.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356762813227447768.4504)
,p_plugin_id=>wwv_flow_api.id(356758608092447765.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356763212988447768.4504)
,p_plugin_id=>wwv_flow_api.id(356758608092447765.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356763608991447768.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(356763212988447768.4504)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356764121289447769.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(356763212988447768.4504)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356764608128447769.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(356763212988447768.4504)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356819907237447808.4504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'Oracle Application Server Single Sign-On INTERNAL'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113750429890071859.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_clob_code_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(690797475249954954.4504)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_display_name=>'Editor di codice CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.CLOB_CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_code_editor'
,p_standard_attributes=>'SOURCE_SQL:NO_DATA_FOUND_MESSAGE'
,p_substitute_attributes=>true
,p_reference_id=>1127739634804688041.4504
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729286773493345807.4504)
,p_plugin_id=>wwv_flow_api.id(690797475249954954.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729287152340345807.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729287688563345807.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729288128545345808.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729288641621345808.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729292142350345810.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729289172784345808.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729289686457345808.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729290125681345809.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729290620568345809.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PL/SQL_FUNCTION_BODY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729291143491345809.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729291639061345810.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript'
,p_return_value=>'mle-javascript'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729292650203345810.4504)
,p_plugin_id=>wwv_flow_api.id(690797475249954954.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Height'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729293045705345810.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729292650203345810.4504)
,p_display_sequence=>1
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729293533609345811.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729292650203345810.4504)
,p_display_sequence=>2
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729294072468345811.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729292650203345810.4504)
,p_display_sequence=>3
,p_display_value=>'20'
,p_return_value=>'20'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729294525217345811.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729292650203345810.4504)
,p_display_sequence=>10
,p_display_value=>'30'
,p_return_value=>'30'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729295020393345811.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729292650203345810.4504)
,p_display_sequence=>20
,p_display_value=>'60'
,p_return_value=>'60'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729295504084345812.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729292650203345810.4504)
,p_display_sequence=>25
,p_display_value=>'80'
,p_return_value=>'80'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729296099420345812.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729292650203345810.4504)
,p_display_sequence=>30
,p_display_value=>'Automatic'
,p_return_value=>'AUTO'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729296547363345812.4504)
,p_plugin_id=>wwv_flow_api.id(690797475249954954.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Read Only'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729296979015345813.4504)
,p_plugin_id=>wwv_flow_api.id(690797475249954954.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>15
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729297312060345813.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729296979015345813.4504)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
,p_help_text=>'VARCHAR2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729297823143345813.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(729296979015345813.4504)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729298396163345814.4504)
,p_plugin_id=>wwv_flow_api.id(690797475249954954.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>'Specify the an item containing the ID of the remote database to use for code validation.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729298757310345814.4504)
,p_plugin_id=>wwv_flow_api.id(690797475249954954.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(729286773493345807.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'<p>An event listener will further be placed on this item, so that when its value changes, the editor will change accordingly.</p>',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(729300656723345816.4504)
,p_plugin_id=>wwv_flow_api.id(690797475249954954.4504)
,p_name=>'SOURCE_SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob_content',
'from demo_scripts'))
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_splitter
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.SPLITTER'
,p_display_name=>'Separatore'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.SPLITTER'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_splitter'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_splitter'
,p_substitute_attributes=>true
,p_reference_id=>330671351658403453.4504
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Il separatore divide in modo dinamico, orizzontalmente o verticalmente, lo spazio disponibile per due aree secondarie. L''area interessata dal separatore deve contenere esattamente due aree secondarie. \00C8 possibile utilizzare qualsiasi modello di ar')
||unistr('ea, a condizione che disponga di un attributo ID, ma alcuni modelli avranno un aspetto migliore rispetto agli altri. Evitare i modelli di area con margini o riempimento. Se il modello di area contiene un elemento che comprende le aree secondarie, \00E8 n')
||unistr('ecessario specificare un selettore CSS che selezioni l''elemento di wrapping nella propriet\00E0 Selettore.</p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272772239348879385.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Splitter Keyboard Navigation'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If yes a global keyboard handler will be added to support using Ctrl-F6 to navigate to the next splitter and Shift-Ctrl-F6 to navigate to the previous splitter.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272772670124879385.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>400
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An optional CSS selector that identifies the element that contains the two sub regions. The selector should start with the the static region id. If omitted the region id or static id will be used. ',
'<p>',
'Example:<br>',
'#regonStaticId > .container',
'<p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272773089811879385.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Orientation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'horizontal'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'A horizontal splitter has the two sub regions side by side. A vertical splitter has the two sub regions one on top of the other. The first sub region is always on the left or top.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1272773436103879385.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(1272773089811879385.4504)
,p_display_sequence=>10
,p_display_value=>'Horizontal'
,p_return_value=>'horizontal'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1272773955437879386.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(1272773089811879385.4504)
,p_display_sequence=>20
,p_display_value=>'Vertical'
,p_return_value=>'vertical'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272774486513879386.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Positioned From'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'begin'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'This determines from which side the position of the splitter is measured and to which side the splitter will collapse. Choose Begin to collapse to the left (right if direction is RTL) or top. Choose End to collapse to the right (left if direction is '
||'RTL) or bottom.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1272774832182879388.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(1272774486513879386.4504)
,p_display_sequence=>10
,p_display_value=>'Begin (left/top)'
,p_return_value=>'begin'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1272775310859879389.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(1272774486513879386.4504)
,p_display_sequence=>20
,p_display_value=>'End (right/bottom)'
,p_return_value=>'end'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272775861831879390.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Position'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'This is the initial position in pixels of the splitter bar. If the splitter is initially collapsed this is the position used when the splitter is first expanded. If Persist State is Yes then if there is a saved position it overrides this value.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272776298415879390.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Collapsed'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1272779866076879391.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If Yes the splitter is initially collapsed. If Persist State is Yes then if there is a saved collapsed state it overrides this value.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272776622800879390.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Snap'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'Optional. The number of pixels the splitter moves in each increment when dragging or with the arrow keys. If not specified the splitter can be dragged with single pixel precision.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272777035399879390.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Keyboard Increment'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1272776622800879390.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Optional. The number of pixels to move the splitter for each arrow key press. If not specified the default is 10.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272777443759879390.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Minimum Size'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'The minimum position of the splitter before it automatically collapses. If not specified the default of 60 is used.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272777835460879390.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Continuous Resize'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'If Yes the two sub regions are sized on each movement of the splitter while dragging or moving with the arrow keys. Otherwise the sub regions are sized only when the splitter stops moving. This should be set to No if the sub regions are computational'
||'ly expensive to resize.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272778274734879391.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Restore Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter handle when the splitter is collapsed. If not specified a default is provided.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272778621295879391.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Collapse Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter handle when the splitter is expanded. If not specified a default is provided.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272779063732879391.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter bar. Providing a title for each splitter is helpful for accessibility especially when there are multiple splitters.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272779463251879391.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>12
,p_prompt=>'Persist State'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If Yes the state of the splitter is persisted as a user preference.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272779866076879391.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>45
,p_prompt=>'Can Collapse '
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'When set to Yes the splitter can collapse or expand by clicking on the handle or pressing Enter or Space. When set to No the splitter can only be moved to its minimum size.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272780235601879392.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Sub Region Contains iframe'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Only set to Yes if either sub region of the splitter contains an iframe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272780635681879392.4504)
,p_plugin_id=>wwv_flow_api.id(1223659655805557097.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Drag To Collapse'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1272779866076879391.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If Yes the splitter can be collapsed by dragging past the minimum size. If No the splitter can only be dragged to the minimum size.'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1510820626581865225.4504)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_EDITOR'
,p_display_name=>'Editor di codice'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_code_editor'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:ENCRYPT'
,p_substitute_attributes=>true
,p_reference_id=>1114646612921244845.4504
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752234375796115191.4504)
,p_plugin_id=>wwv_flow_api.id(1510820626581865225.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752235224015115191.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752234707234115191.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752239761877115194.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752235769839115191.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752240276427115195.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752236242992115192.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752236781960115192.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752237248276115192.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>60
,p_display_value=>'PL/SQL Functions/Procedures'
,p_return_value=>'PLSQL_FUNCTIONS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752237718348115192.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752238254097115194.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752238781767115194.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752239257698115194.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript'
,p_return_value=>'mle-javascript'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752240758077115195.4504)
,p_plugin_id=>wwv_flow_api.id(1510820626581865225.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752241158484115195.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752240758077115195.4504)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752241621795115195.4504)
,p_plugin_attribute_id=>wwv_flow_api.id(752240758077115195.4504)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752242171128115196.4504)
,p_plugin_id=>wwv_flow_api.id(1510820626581865225.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Show Query Builder'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752242554369115196.4504)
,p_plugin_id=>wwv_flow_api.id(1510820626581865225.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Adjustable Height'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'If Yes the user can adjust the height of the code editor.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752242995959115196.4504)
,p_plugin_id=>wwv_flow_api.id(1510820626581865225.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote  Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Specify a page item containing the remote database ID to use for code validation.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752243342059115196.4504)
,p_plugin_id=>wwv_flow_api.id(1510820626581865225.4504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752234375796115191.4504)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'',
'<p>An event listener will be placed on this item, so when its value changes, the editor will change accordingly.</p>',
'',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2448181332878348304.4504)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Aggiungi casella di controllo Seleziona tutto'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512.4504
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>L''azione dinamica "Aggiungi casella di controllo Seleziona tutto" converte un''intestazione di colonna contenente la stringa #CHECK_ALL_CHECKBOX# in una casella di controllo accessibile di tipo Seleziona tutto, ovvero tutte le caselle di controllo '
||'nella colonna corrispondente verranno selezionate o deselezionate.<p>',
'<p>',
'Per utilizzare questo plugin, assicurarsi che siano impostati gli attributi riportati di seguito.',
'<ol>',
'<li>Nella colonna di report, ''#CHECK_ALL_CHECKBOX#'' deve essere definito come valore di intestazione.</li>',
'<li>Per l''attributo Quando dell''azione dinamica, selezionare l''area del report contenente la colonna.</li>',
'<li>Definire l''azione dinamica in modo che si attivi ''Dopo l''aggiornamento'', mentre l''azione deve essere impostata su ''Attiva al caricamento della pagina''. Entrambe le azioni verranno preimpostate in modo adeguato se l''azione dinamica viene creata se'
||'lezionando l''area nella sezione ''Rendering'' di Page Designer e creando l''azione dinamica da qui.</li>',
unistr('<li>Non verr\00E0 gestito l''accesso facilitato delle caselle di controllo visualizzate in ogni riga. Ci\00F2 dovr\00E0 essere eseguito separatamente nell''origine dell''area. Per un esempio, vedere 4000:656 ''Aree''.</li>'),
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4969205754302342.4504)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=4500:1000:&SESSION.'
,p_login_url=>'f?p=4550:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>.4504
,p_nav_list_template_options=>'#DEFAULT#'
,p_css_file_urls=>'#IMAGE_PREFIX#css/apex_builder#MIN#.css'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_api.create_page(
 p_id=>.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'zero'
,p_step_title=>'zero'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11140505307196687.4504)
,p_plug_name=>'Global Items For Object Browser'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'23'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386906063356677524.4504)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-sql-workshop'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386906446198682887.4504)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_api.id(386906063356677524.4504)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385795398770024112.4504)
,p_plug_name=>'APEX 5 - Tabs'
,p_region_name=>'a_Header_menu'
,p_parent_plug_id=>wwv_flow_api.id(386906446198682887.4504)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(718942723406995455.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(385776082908002390.4504)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386906842726682887.4504)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_api.id(386906446198682887.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<a href="f?p=4500:1000:''||:APP_SESSION||''::''||:DEBUG||''::::" class="a-Header-logo" title="''||wwv_flow_lang.system_message(''HOME_NAV'')||''"><span class="a-Header-apexLogo"><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''HOME_'
||'NAV'')||''</span></span></a>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386906639708682887.4504)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_api.id(386906063356677524.4504)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385807144565239746.4504)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_api.id(386906639708682887.4504)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385814960550248814.4504)
,p_plug_name=>'Administration Menu'
,p_region_name=>'adminMenu'
,p_parent_plug_id=>wwv_flow_api.id(385807144565239746.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(697546799309390664.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(385776364537002403.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486772007528301730.4504)
,p_plug_name=>'Help Menu'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_api.id(385807144565239746.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(697551745129395610.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(385776364537002403.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385816859034290012.4504)
,p_plug_name=>'Header Account'
,p_parent_plug_id=>wwv_flow_api.id(386906639708682887.4504)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388720726124473736.4504)
,p_plug_name=>'APEX 5 - Search'
,p_parent_plug_id=>wwv_flow_api.id(386906639708682887.4504)
,p_region_css_classes=>'a-Header-search'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-SearchBox a-SearchBox--noGoButton a-SearchBox--autoExpand a-SearchBox--fill">'');',
'sys.htp.p(''  <div class="a-SearchBox-field">'');',
'sys.htp.p(''    <span class="a-SearchBox-icon"><span class="a-Icon icon-search"></span></span>'');',
'sys.htp.p(''    <label for="P0_SEARCH" class="visuallyhidden">''||wwv_flow_lang.system_message(''SEARCH'')||''</label>'');',
'sys.htp.p(''    <input type="text" class="a-SearchBox-input" id="P0_SEARCH" placeholder="''||wwv_flow_lang.system_message(''SEARCH'')||''">'');',
'sys.htp.p(''  </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_IN_CONDITION'
,p_plug_display_when_condition=>'1000'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(1080926199001296276.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(387929033434561917.4504)
,p_plug_name=>'APEX 5 - Control Bar'
,p_region_css_classes=>'a-ControlBar apex-sql-workshop'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'1000,3002'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(387929284740561918.4504)
,p_plug_name=>'APEX 5 - Control Bar Left'
,p_parent_plug_id=>wwv_flow_api.id(387929033434561917.4504)
,p_region_css_classes=>'a-ControlBar-col a-ControlBar-col--noPadding'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid=>true
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(384688805135932803.4504)
,p_plug_name=>'APEX 5 - Breadcrumb'
,p_parent_plug_id=>wwv_flow_api.id(387929284740561918.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid=>true
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(6696510824685479.4504)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(387975456606606350.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(387929403973561918.4504)
,p_plug_name=>'APEX 5 - Control Bar Right'
,p_parent_plug_id=>wwv_flow_api.id(387929033434561917.4504)
,p_region_css_classes=>'a-ControlBar-col'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(387994680244652086.4504)
,p_plug_name=>'Schema'
,p_region_name=>'apex-control-icons'
,p_parent_plug_id=>wwv_flow_api.id(387929403973561918.4504)
,p_region_css_classes=>'a-Form a-Form--small a-Form--schemaSelect'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(735033617066168731.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(385807144565239746.4504)
,p_button_name=>'UPGRADE_AVAILABLE'
,p_button_static_id=>'header-upgradeAvailable'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Upgrade disponibile'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_AVAILABLE:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-calendar u-info-text'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(735033564580168730.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(385807144565239746.4504)
,p_button_name=>'UPGRADE_IN_PROGRESS'
,p_button_static_id=>'header-upgradeInProgress'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upgrade in corso'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_IN_PROGRESS:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''RUNNING'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-warning u-danger-text'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161345724959782337.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(385807144565239746.4504)
,p_button_name=>'SPOTLIGHT'
,p_button_static_id=>'header-spotlightSearch'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Ricerca evidenziazione'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-search'
,p_button_cattributes=>'data-action="spotlight-search"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(385815804801264383.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(385807144565239746.4504)
,p_button_name=>'HEADER_ADMINISTRATION'
,p_button_static_id=>'header-adminMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765690470963369.4504)
,p_button_image_alt=>'Amministrazione'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-gears-alt'
,p_button_cattributes=>'data-menu="adminMenu_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(385816282863272115.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(385807144565239746.4504)
,p_button_name=>'HEADER_FEEDBACK'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Feedback'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4750:11001:&SESSION.::&DEBUG.:RP,11001:P11001_APPLICATION_ID,P11001_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-comments'
,p_required_patch=>wwv_flow_api.id(693462110571635991.4504)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(385816622634278210.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(385807144565239746.4504)
,p_button_name=>'HEADER_HELP'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765690470963369.4504)
,p_button_image_alt=>'Guida'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11141129549203626.4504)
,p_name=>'OB_OBJECT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(11140505307196687.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11143605700225196.4504)
,p_name=>'P0_PPRTIMESTAMP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(11140505307196687.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(387994857980652090.4504)
,p_name=>'P0_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(387994680244652086.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-QB'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, ''; ',
'  q:=q||''       wwv_flow_fnd_user u ''; ',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1002_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1002_SCHEMA) a,:P1002_SCHEMA b from dual '';',
'  q:=q||''where  :P1002_POPUP = 1 '';',
'  q:=q||''order by 1'';',
'  return q;',
'end;'))
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'a-Form-select'
,p_label_alignment=>'RIGHT'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Login amministratore del database'
,p_alias=>'DBA_LOGIN'
,p_step_title=>'Login amministratore del database'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'#P1_USERNAME ,#P1_PASSWORD{width:200px;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_montitor.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1043922209309492.4504)
,p_plug_name=>'Login amministratore del database'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>20
,p_plug_header=>unistr('<p>\00C8 stato richiesto l''accesso a una pagina per la quale sono necessari i privilegi di database specifici. Immettere le credenziali per un account di database a cui \00E8 stato concesso il ruolo DBA.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1019666021060320819.4504)
,p_plug_name=>'button region'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1020222865942116889.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1019666021060320819.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(359654713065770667.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1019666021060320819.4504)
,p_button_name=>'P1_LOGIN'
,p_button_static_id=>'P1_LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Login'
,p_button_position=>'CREATE'
,p_request_source=>'LOGIN_BUTTON'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(155129504944225119.4504)
,p_branch_action=>'return ''f?p=''||:P1_APP||'':''||:P1_PAGE||'':''||:SESSION;'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_FUNCTION_RETURNING_URL'
,p_branch_language=>'PLSQL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1046305318309560.4504)
,p_name=>'P1_USERNAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1043922209309492.4504)
,p_prompt=>'Nome utente'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>25
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere un nome utente e una password per l''account di database in questo database con privilegi DBA.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1046904764309562.4504)
,p_name=>'P1_PASSWORD'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1043922209309492.4504)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>25
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere la password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(206105727449627884.4504)
,p_name=>'P1_APP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1043922209309492.4504)
,p_item_default=>'&APP_ID.'
,p_source=>'substr(:REQUEST,1,instr(:REQUEST,'','')-1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(206106408533631817.4504)
,p_name=>'P1_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1043922209309492.4504)
,p_item_default=>'1'
,p_source=>'substr(:REQUEST,instr(:REQUEST,'','')+1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(206083700119496957.4504)
,p_validation_name=>'check dba password'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_auth boolean := false;',
'begin',
'    l_auth := sys.wwv_flow_val.verify_user (',
'                  username => :P1_USERNAME,',
'                  password => :P1_PASSWORD ) = sys.wwv_flow_val.valid_user;',
'',
'    if    l_auth',
'      and wwv_flow_security.user_is_dba (',
'              p_username => :P1_USERNAME )',
'    then',
'        :F4500_DBA_LOGIN := ''Y'';',
'        :DBA_USERNAME := upper(:P1_USERNAME);',
'        return true;',
'    end if;',
'',
'    :F4500_DBA_LOGIN := ''N'';',
'    return false;',
'exception when others then',
'    return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Password non corretta o l''utente non dispone del ruolo richiesto.'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(155252725985250123.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear sensitive items'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P1_USERNAME,P1_PASSWORD'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_api.create_page(
 p_id=>2.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Tabelle senza trigger'
,p_step_title=>'Tabelle senza trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_excp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34148419202124380.4504)
,p_plug_name=>'Tabelle senza trigger'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name',
'  from sys.user_tables a',
' where table_name not like ''BIN$%''',
'   and not exists ( select 1',
'                     from sys.user_triggers',
'                    where table_name = a.table_name )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P2_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(34148531542124380.4504)
,p_name=>'Tables without Triggers'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34148708061124427.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nome tabella'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(69172413159446494.4504)
,p_plug_name=>'Tabelle senza trigger'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Questo report visualizza le tabelle senza trigger.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(69173409024446500.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722738457991798612.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34148419202124380.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP,RIR,2:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(69175712074446516.4504)
,p_branch_action=>'2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69174122456446507.4504)
,p_name=>'P2_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(69173409024446500.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(69175301137446513.4504)
,p_computation_sequence=>10
,p_computation_item=>'P2_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P2_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69192210847547410.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P2_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_api.create_page(
 p_id=>3.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Scegli trigger per creazione tabella'
,p_alias=>'TRIGGER_CREATE'
,p_step_title=>'Scegli tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106724407422013886.4504)
,p_plug_name=>'Crea trigger'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150817615862142740.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150811814776114073.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240050607367537341.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752117455494695886.4504)
,p_plug_name=>'Crea trigger'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106724801560013890.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240050607367537341.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106724622614013889.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(240050607367537341.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(106728014234013914.4504)
,p_branch_action=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106725016917013892.4504)
,p_name=>'P3_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(106724407422013886.4504)
,p_prompt=>'Nome tabella'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>40
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P3_FROM'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Selezionare la tabella associata a questo trigger.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106725532339013897.4504)
,p_name=>'P3_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(106724407422013886.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(273749223696559998.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3_TABLE'
,p_computation_type=>'QUERY'
,p_computation=>'select table_name from sys.dba_tables where upper(table_name) = upper(:p3_table);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(274022614606626627.4504)
,p_validation_name=>'table exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from sys.dba_objects where upper(object_name) = upper(:P3_TABLE) and owner = :OB_SCHEMA and object_type =',
'''TABLE'''))
,p_validation_type=>'EXISTS'
,p_error_message=>'Tabella inesistente.'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_api.create_page(
 p_id=>4.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare l''indice'
,p_step_title=>'Impossibile creare l''indice'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107474329693138421.4504)
,p_plug_name=>'Impossibile creare l''indice'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>31
,p_plug_source=>'&P4_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208343830183777608.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>81
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107475119034138424.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208343830183777608.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(270764810820114173.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208343830183777608.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107476418042138429.4504)
,p_branch_action=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(107475119034138424.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107475508914138426.4504)
,p_name=>'P4_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107474329693138421.4504)
,p_prompt=>'Messaggio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107476032550138427.4504)
,p_name=>'P4_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107474329693138421.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182459028608141946.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- SR: JAS 01/26/09 - could not determine how to exercise page, did not change',
'declare',
' l_name varchar2(2000);',
'begin',
' if :P5_PREVIOUS = 94 then',
'   l_name := :P94_INDEX_NAME;',
' elsif :P5_PREVIOUS = 225 then',
'   l_name := :P225_TABLE;',
' else',
'   l_name := :P77_INDEX_NAME;',
' end if;',
' if ( :P5_ACTION = ''CREATE_INDEX'') then ',
'  for r in ( select object_id,object_name,owner,object_type',
'   from sys.dba_objects',
'   where owner = :OB_SCHEMA',
'   and object_name = l_name',
'   and object_type = ''INDEX'' ) loop',
'     :OBJECT_ID    := r.object_id;',
'     :OBJECT_NAME  := r.object_name;',
'     :OBJECT_OWNER := r.owner;',
'     :OBJECT_TYPE  := r.object_type;',
'  end loop;',
' end if; /* end create_index */',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_api.create_page(
 p_id=>5.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma creazione dell''indice'
,p_step_title=>'Conferma creazione dell''indice'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107489816716162291.4504)
,p_plug_name=>'Confermare la richiesta. '
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Confermare la richiesta.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107490015850162292.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149949010721628282.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149926526903576167.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'F4500_LAST_VIEW'
,p_plug_display_when_cond2=>'2102'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208342000270759522.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752117609914695886.4504)
,p_plug_name=>'Crea indice'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107490423349162293.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208342000270759522.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea indice'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107490616048162293.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208342000270759522.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P5_PREVIOUS.:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107490221219162293.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208342000270759522.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107534407216303661.4504)
,p_branch_action=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.::P4_OBJECT_ID:&P5_NEW_OBJECT_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(107490423349162293.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107490830150162294.4504)
,p_name=>'P5_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107489816716162291.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107491320593162295.4504)
,p_name=>'P5_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107489816716162291.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Oggetto:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p5_PREVIOUS = ''77'' then ',
' return :P77_INDEX_NAME;',
'else',
' return :P94_INDEX_NAME;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107491812633162296.4504)
,p_name=>'P5_ACTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(107489816716162291.4504)
,p_prompt=>'Azione:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica il tipo di azione da eseguire sulla tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107492322417162297.4504)
,p_name=>'P5_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(107490015850162292.4504)
,p_prompt=>'SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107492522422162297.4504)
,p_name=>'P5_PREVIOUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(107489816716162291.4504)
,p_prompt=>'Previous'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107492718130162298.4504)
,p_name=>'P5_NEW_OBJECT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(107489816716162291.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(107492916493162298.4504)
,p_computation_sequence=>10
,p_computation_item=>'P57_TABLE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P73_NEW_TABLE_NAME'
,p_compute_when=>':P70_ACTION = ''RENAME'' and :REQUEST = ''FINISH'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107493718722162300.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(107490423349162293.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107493904672162301.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P5_SQL );',
'if :p5_PREVIOUS = ''94'' then',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :p94_index_name ',
'          and owner = :OB_SCHEMA ',
'          and object_type = ''INDEX'') loop',
'  :P5_NEW_OBJECT_ID := c.object_id;',
'end loop;',
'else',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :p77_index_name ',
'          and owner = :OB_SCHEMA ',
'          and object_type = ''INDEX'') loop',
'  :P5_NEW_OBJECT_ID := c.object_id;',
'end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(107490423349162293.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107494126732162301.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P5_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(107490423349162293.4504)
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_api.create_page(
 p_id=>6.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dizionario attributi'
,p_step_title=>'Dizionario attributi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196872320678099165.4504)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_api.id(194504915759237345.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197497415607067300.4504)
,p_plug_name=>'attributi colonna'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>15
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    c.column_id,',
'    s.syn_name column_name,',
'    case when c.column_name != s.syn_name',
'         then c.column_name',
'         end base_record,',
'    --',
'    c.label,',
'    c.help_text,',
'    c.format_mask,',
'    c.default_value,',
'    --',
'    c.form_format_mask,',
'    c.form_display_width,',
'    c.form_display_height,',
'    c.form_data_type,',
'    --',
'    c.report_format_mask,',
'    decode(c.report_col_alignment,',
'           ''LEFT'',l.m,''CENTER'',ctr.m,''RIGHT'',r.m,null) report_col_alignment,',
'    --',
'    c.created_by,',
'    c.created_on,',
'    c.last_updated_by,',
'    c.last_updated_on',
'  from WWV_FLOW_HNT_COLUMN_DICT c,',
'       wwv_flow_hnt_col_dict_syn s,',
'       (select wwv_flow_lang.system_message(''LEFT'') m from dual) l,',
'       (select wwv_flow_lang.system_message(''CENTER'') m from dual) ctr,',
'       (select wwv_flow_lang.system_message(''RIGHT'') m from dual) r',
' where c.security_group_id = :flow_security_group_id',
'   and c.column_id = s.column_id',
'   and s.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(197497511891067300.4504)
,p_name=>'column attributes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_col_group(
 p_id=>wwv_flow_api.id(197503401945084100.4504)
,p_name=>'Attributi generali'
,p_display_sequence=>10
);
wwv_flow_api.create_worksheet_col_group(
 p_id=>wwv_flow_api.id(197503509910086389.4504)
,p_name=>'Attributi specifici del form'
,p_display_sequence=>20
);
wwv_flow_api.create_worksheet_col_group(
 p_id=>wwv_flow_api.id(197503615105087841.4504)
,p_name=>'Attributi specifici del report'
,p_display_sequence=>30
);
wwv_flow_api.create_worksheet_col_group(
 p_id=>wwv_flow_api.id(197503919607089151.4504)
,p_name=>'Attributi specifici del form tabulare'
,p_display_sequence=>40
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197497702734067305.4504)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>1
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'A'
,p_column_label=>'ID colonna'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197497823803067306.4504)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>2
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'B'
,p_column_label=>'Nome colonna'
,p_column_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:RP:P17_COLUMN_ID,F4500_LAST_VIEW:#COLUMN_ID#,6:'
,p_column_linktext=>'#COLUMN_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(198209126276365169.4504)
,p_db_column_name=>'BASE_RECORD'
,p_display_order=>3
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'AZ'
,p_column_label=>'Sinonimo di'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197497923751067307.4504)
,p_db_column_name=>'LABEL'
,p_display_order=>4
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'C'
,p_column_label=>'Etichetta'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197498014645067307.4504)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>5
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'D'
,p_column_label=>'Testo Guida'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197498129478067308.4504)
,p_db_column_name=>'FORMAT_MASK'
,p_display_order=>6
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'E'
,p_column_label=>'Formato di visualizzazione'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197498230034067309.4504)
,p_db_column_name=>'DEFAULT_VALUE'
,p_display_order=>7
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'F'
,p_column_label=>'Valore predefinito'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197498415272067310.4504)
,p_db_column_name=>'FORM_FORMAT_MASK'
,p_display_order=>9
,p_group_id=>wwv_flow_api.id(197503509910086389.4504)
,p_column_identifier=>'H'
,p_column_label=>'Formato di visualizzazione form'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197498505217067311.4504)
,p_db_column_name=>'FORM_DISPLAY_WIDTH'
,p_display_order=>10
,p_group_id=>wwv_flow_api.id(197503509910086389.4504)
,p_column_identifier=>'I'
,p_column_label=>'Larghezza di visualizzazione form'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197498621334067312.4504)
,p_db_column_name=>'FORM_DISPLAY_HEIGHT'
,p_display_order=>11
,p_group_id=>wwv_flow_api.id(197503509910086389.4504)
,p_column_identifier=>'J'
,p_column_label=>'Altezza di visualizzazione form'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197498705818067313.4504)
,p_db_column_name=>'FORM_DATA_TYPE'
,p_display_order=>12
,p_group_id=>wwv_flow_api.id(197503509910086389.4504)
,p_column_identifier=>'K'
,p_column_label=>'Tipo di dati form'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197499906035067322.4504)
,p_db_column_name=>'REPORT_FORMAT_MASK'
,p_display_order=>13
,p_group_id=>wwv_flow_api.id(197503615105087841.4504)
,p_column_identifier=>'W'
,p_column_label=>'Formato di visualizzazione report'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197500006990067324.4504)
,p_db_column_name=>'REPORT_COL_ALIGNMENT'
,p_display_order=>14
,p_group_id=>wwv_flow_api.id(197503615105087841.4504)
,p_column_identifier=>'X'
,p_column_label=>'Allineamento colonna report'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197502421219067350.4504)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>18
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'AV'
,p_column_label=>'Creazione di'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197502514016067351.4504)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>19
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'AW'
,p_column_label=>'Data creazione'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197502620316067351.4504)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>20
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'AX'
,p_column_label=>'Autore aggiornamento'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(197502708086067352.4504)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>21
,p_group_id=>wwv_flow_api.id(197503401945084100.4504)
,p_column_identifier=>'AY'
,p_column_label=>'Aggiornato'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197652104930775557.4504)
,p_plug_name=>'Dizionario attributi'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>25
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I valori predefiniti dell''interfaccia utente vengono utilizzati per popolare i valori iniziali per l''area e le propriet\00E0 degli elementi che assicurano la coerenza su pi\00F9 pagine in un''applicazione o su pi\00F9 applicazioni.</p>'),
'',
unistr('<p>Il dizionario attributi contiene un set di attributi su una colonna, utilizzati per creare form e report. Le definizioni vengono confrontate per nome colonna ed \00E8 possibile condividere una determinata definizione tra pi\00F9 colonne mediante i sinonim')
||'i.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(442023927001440467.4504)
,p_plug_name=>'Task'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(442022106915434689.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196941919040505465.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(197497415607067300.4504)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(262152709439070830.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(197497415607067300.4504)
,p_button_name=>'GRID_EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Modifica griglia'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196240900601196384.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(197497415607067300.4504)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:F4500_LAST_VIEW:6'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1019663455307233863.4504)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(442023927001440467.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1019663721484233884.4504)
,p_event_id=>wwv_flow_api.id(1019663455307233863.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:6:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_api.create_page(
 p_id=>7.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Fine creazione tabella di ricerca'
,p_step_title=>'Crea tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(126728219494826365.4504)
,p_computation_sequence=>20
,p_computation_item=>'P57_TABLE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&P602_NAME.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(126728409921826371.4504)
,p_computation_sequence=>30
,p_computation_item=>'P42_OBJECT_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id',
'from sys.dba_objects',
'where owner = :P56_SCHEMA',
'and object_name = :P57_TABLE',
'and object_type = ''TABLE'''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(126729024635826377.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object_name/type/id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' for r in ( select object_id,object_name,owner,object_type',
'from sys.dba_objects',
'where owner = :OB_SCHEMA',
'and object_name = :P105_NEW_TABLE_TO_BE_CREATED',
'and object_type = ''TABLE'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.htp.p(''<script type="text/javascript">top.gSideBar.reload("TABLE",''||',
'          wwv_flow_escape.js_literal(:OBJECT_ID)||',
'          '',true);</script>'');'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_api.create_page(
 p_id=>8.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare il sinonimo'
,p_step_title=>'Impossibile creare il sinonimo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_syn.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107691211986788096.4504)
,p_plug_name=>'Impossibile creare il sinonimo'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_plug_source=>'&P8_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P8_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(242968731284108170.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107691627841788100.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(242968731284108170.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107691416204788097.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(242968731284108170.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:127:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107692206615788105.4504)
,p_name=>'P8_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107691211986788096.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182563319407300115.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for r in ( select object_id,object_name,owner,object_type',
' from sys.dba_objects',
' where owner = :OB_SCHEMA',
' and object_name = :P99_NAME',
' and object_type = ''SYNONYM'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P8_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_api.create_page(
 p_id=>9.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma creazione trigger'
,p_step_title=>'Conferma creazione trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_trig.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108192008291627341.4504)
,p_plug_name=>'Confermare la richiesta. '
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108192200834627347.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150816405819139865.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150811814776114073.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240130501844037227.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752117899743695887.4504)
,p_plug_name=>'Crea trigger'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(108192601224627348.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(240130501844037227.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea trigger'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(108192830309627349.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240130501844037227.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(108192406052627348.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(240130501844037227.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(108215531314676142.4504)
,p_branch_action=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(108192601224627348.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108193005205627351.4504)
,p_name=>'P9_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108192008291627341.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108193517080627355.4504)
,p_name=>'P9_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(108192008291627341.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Oggetto:'
,p_source=>'P3_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108194026282627356.4504)
,p_name=>'P9_ACTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(108192008291627341.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Azione:'
,p_source=>'wwv_flow_lang.system_message(''CREATE_TRIGGER'',:P84_TRIGGER_NAME);'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il tipo di azione da eseguire sulla tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108194505205627357.4504)
,p_name=>'P9_SQL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(108192200834627347.4504)
,p_prompt=>'SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(108195917976627367.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &P56_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(108192601224627348.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(108196125269627368.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P16_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P9_SQL );',
'',
'for c in (select object_id from sys.dba_objects where object_name = :P84_TRIGGER_NAME and owner = :OB_SCHEMA and',
'          object_type = ''TRIGGER'') loop',
'  :object_id := c.object_id;',
'  :object_type := ''TRIGGER'';',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(108192601224627348.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(108196325839627370.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P9_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(108192601224627348.4504)
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_api.create_page(
 p_id=>10.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Script - Esegui'
,p_step_title=>'Esegui script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213236600761856491)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_inline_css=>'.u-Report {width: 100%; font-size: 12px;}'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep_run_script.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10048401428195635.4504)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42832115592689804.4504)
,p_plug_name=>'Esegui script'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_script.display_run_confirm(',
'    p_file_id => :F4500_P10_FILE_ID,',
'    p_date_time_format => ''&DATE_TIME_FORMAT.'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(372022143187.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(42832115592689804.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109787703963442985.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(42832115592689804.4504)
,p_button_name=>'EDIT_SCRIPT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Modifica script'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:&F4500_P10_FILE_ID.'
,p_button_condition=>'wwv_flow_sw_script.script_w_warning(p_file_id => :F4500_P10_FILE_ID)'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(372007991036.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(42832115592689804.4504)
,p_button_name=>'RUN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esegui ora'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(471472722487546596.4504)
,p_branch_name=>'Go To Page 1225'
,p_branch_action=>'f?p=&APP_ID.:1225:&SESSION.::&DEBUG.:RP,1225:P1224_RESULT_ID:&P10_RESULT_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29063885017.4504)
,p_name=>'P10_RUN_AS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(387994680244652086.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_tag_attributes=>'class="a-Form-select"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare uno schema di database (o nome utente) per l''esecuzione di questo script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29128987183.4504)
,p_name=>'F4500_P10_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(42832115592689804.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16826800561032587.4504)
,p_name=>'P10_RESULT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(10048401428195635.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145945111357011245.4504)
,p_name=>'P10_SCRIPT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(42832115592689804.4504)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'from wwv_flow_files',
'where id = :F4500_P10_FILE_ID',
'and file_type = ''SCRIPT'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18056327424.4504)
,p_validation_name=>'Must Select Run As'
,p_validation_sequence=>10
,p_validation=>'P10_RUN_AS'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Specificare uno schema Oracle (NOME UTENTE) per l''esecuzione di questo script.  '
,p_validation_condition=>'RUN,RUN_IN_BACKGROUND'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(29063885017.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(128081917428230107.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P10_RUN_AS',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il controllo dei privilegi.'
,p_process_when_button_id=>wwv_flow_api.id(372007991036.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19995201456899729.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set sort preference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_preferences.set_preference(',
'p_preference=>''FSP4500_P1220_R11177418830226625_SORT'',',
'p_value => ''fsp_sort_8'',',
'p_user => v(''USER''));'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(210368638674469028.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'submit script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P10_RESULT_ID := wwv_flow_sw_script.submit_to_run (',
'                   p_file_id  => :F4500_P10_FILE_ID,',
'                   p_run_by   => :APP_USER,',
'                   p_run_as   => :P10_RUN_AS',
'                   );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile sottomettere lo script da eseguire.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9321931833012508.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_script.run_file',
'      (p_result_id => :P10_RESULT_ID,',
'       p_file_id => :F4500_P10_FILE_ID,       ',
'       p_schema    => :P10_RUN_AS,',
'       p_run_by  => :APP_USER);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile eseguire lo script.'
,p_process_when_button_id=>wwv_flow_api.id(372007991036.4504)
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_api.create_page(
 p_id=>11.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Controllo database'
,p_step_title=>'Controllo database'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_help_text=>'AEUTL/dbadm_montitor.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(133796225310429187.4504)
,p_plug_name=>unistr('Attivit\00E0')
,p_icon_css_classes=>'icon-region-native-flash-chart5'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(703386252988943977.4504)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(133792932105421631.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_api.create_page(
 p_id=>12.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Genera DDL'
,p_step_title=>'Genera DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1486819378945387.4504)
,p_plug_name=>'Oggetti dello schema'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>11
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner schema_owner, ',
'       sum(decode(object_type,''TABLE'',1,0)) tables,',
'       sum(decode(object_type,''VIEW'',1,0)) views,',
'       sum(decode(object_type,''PACKAGE'',1,0)) packages,',
'       sum(decode(object_type,''PROCEDURE'',1,0)) procedures,',
'       sum(decode(object_type,''FUNCTION'',1,0)) functions,',
'       sum(decode(object_type,''TRIGGER'',1,0)) triggers,',
'       sum(decode(object_type,''SYNONYM'',1,0)) synonyms,',
'       sum(decode(object_type,''TYPE'',1,0)) types,',
'       sum(decode(object_type,''SEQUENCE'',1,0)) sequences,',
'       sum(decode(object_type,''INDEX'',1,0)) indexes,',
'       sum(decode(object_type,''DATABASE LINK'',1,0)) database_links,',
'       sum(decode(object_type,''MATERIALIZED VIEW'',1,0)) materialized_views',
'from (',
'select owner, object_type, object_name',
'from sys.dba_objects where owner in (',
'select c.schema',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
'where  c.security_group_id = :flow_security_group_id and',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :flow_user and',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'        instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0))',
') x',
'group by owner'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1486931056945387.4504)
,p_name=>'Schema Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487112568945421.4504)
,p_db_column_name=>'SCHEMA_OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487206500945426.4504)
,p_db_column_name=>'TABLES'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Tabelle'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487310320945426.4504)
,p_db_column_name=>'VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Viste'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487409322945426.4504)
,p_db_column_name=>'PACKAGES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Package'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487510143945426.4504)
,p_db_column_name=>'PROCEDURES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Procedure'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487601504945427.4504)
,p_db_column_name=>'FUNCTIONS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Funzioni'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487703932945427.4504)
,p_db_column_name=>'TRIGGERS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Trigger'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487827146945427.4504)
,p_db_column_name=>'SYNONYMS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Sinonimi'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1487904312945427.4504)
,p_db_column_name=>'TYPES'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Tipi'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1488006466945427.4504)
,p_db_column_name=>'SEQUENCES'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Sequenze'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1488122175945427.4504)
,p_db_column_name=>'INDEXES'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Indici'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1488212701945428.4504)
,p_db_column_name=>'DATABASE_LINKS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Database link'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1488332313945428.4504)
,p_db_column_name=>'MATERIALIZED_VIEWS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Viste materializzate'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112022311206824401.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1486819378945387.4504)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea script'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(698586606001530549.4504)
,p_name=>'On Close Modal'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(112022311206824401.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(698586727765530550.4504)
,p_event_id=>wwv_flow_api.id(698586606001530549.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1486819378945387.4504)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'    lUrl        = ''f?p=4500:1004:&SESSION.::&DEBUG.:'';',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
' setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_api.create_page(
 p_id=>13.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dizionario dati'
,p_step_title=>'Dizionario dati'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11600917523650714.4504)
,p_plug_name=>'schema owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441230013633249819.4504)
,p_plug_name=>'Tutti gli oggetti'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select DISTINCT o.object_name, c.comments',
'  from sys.all_objects o, sys.all_tab_comments c',
'  where o.owner = c.owner',
'    and o.object_name = c.table_name',
'    and o.object_type = ''VIEW'' ',
'    and (o.owner = ''SYS'' or ',
'         o.owner like ''FLOWS_%'' or',
'         o.owner like ''APEX_%'')',
'    and (o.object_name like ''USER%'' or',
'         o.object_name like ''ALL%'' or',
'         o.object_name like ''APEX_%'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P13_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441230131418249819.4504)
,p_name=>'All Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441230306780249821.4504)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nome oggetto'
,p_column_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.::F4500_P14_OBJECT_NAME,F4500_P15_PARSE_STMT_AS:#OBJECT_NAME#,&P13_SCHEMA.'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441230423945249822.4504)
,p_db_column_name=>'COMMENTS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Commenti'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(72492410848555529.4504)
,p_branch_action=>'13'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(465515900436190.4504)
,p_name=>'P13_SCHEMA'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(11600917523650714.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database su cui si basa la visualizzazione di questa pagina.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(467211183444240.4504)
,p_name=>'P13_SCHEMA_LABEL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(441230013633249819.4504)
,p_source=>'wwv_flow_lang.system_message(''CONFIRM.PARSING_SCHEMA'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_source_post_computation=>'wwv_flow_escape.html(:P13_SCHEMA_LABEL)'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112261530045965316.4504)
,p_computation_sequence=>10
,p_computation_item=>'P13_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P13_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432751826383974955.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P13_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_api.create_page(
 p_id=>14.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Browser dizionario dati'
,p_step_title=>'Browser dizionario dati'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'function ToggleAll(e){',
'  if (e.checked){CheckAll(); }',
'  else{ClearAll();}',
'  }',
'',
'function Check(e){e.checked = true; }',
'function Clear(e){e.checked = false;}',
'function CheckAll(){',
'  var ml = document.wwv_flow;',
'  var len = ml.elements.length;',
'  for (var i = 0; i < len; i++){',
'    var e = ml.elements[i];',
'    if (e.name == "f01") {Check(e);}',
'   }',
'  ml.f01.checked = true;',
' }',
'',
'function ClearAll(){',
'  var ml = document.wwv_flow;',
'  var len = ml.elements.length;',
'  for (var i = 0; i < len; i++){',
'    var e = ml.elements[i];',
'    if (e.name == "f01") {Clear(e);}',
'  }',
'  ml.f01.checked = false;',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8433315974658433.4504)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(72610012393226909.4504)
,p_name=>'Form QBE (Query By Example) dizionario'
,p_template=>wwv_flow_api.id(385893260111566687.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767);',
'begin',
'  q := ',
'''select',
'  wwv_flow_item.checkbox(1,x.column_name) include,  ',
'  x.column_id,',
'  x.column_name column_name, ',
'  wwv_flow_item.text(2,null,90)||wwv_flow_item.hidden(3,x.data_type)||wwv_flow_item.hidden(4,x.column_name) condition,   ',
'  x.data_type data_type,',
'  x.comments',
'from (',
'select ',
'  t.column_id,',
'  t.column_name,',
'  t.data_type,',
'  c.comments',
'from sys.all_tab_columns t, sys.all_col_comments c',
'where t.owner = c.owner',
'and t.table_name = c.table_name',
'and t.column_name = c.column_name',
'and (t.owner in (''''SYS'''','''''' || wwv_flow.g_flow_schema_owner || ''''''))',
'and t.table_name = :F4500_P14_OBJECT_NAME',
') x'';',
'return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>60
,p_query_num_rows=>1000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_LEFT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'F4500_P15_PARSE_STMT_AS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48718216970771769.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Includi'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48718313462771769.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Sequenza'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48718420839771769.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Nome colonna'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48718529301771769.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Condizione colonna'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48718632395771769.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo dati'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48718718158771769.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Nome colonna'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48718831167771769.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48718909626771769.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48719009204771770.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48719105173771770.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48719221922771770.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48719316380771770.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48719417803771770.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48719518395771770.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48719617809771770.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191029519116227646.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191029610644227647.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191029716011227647.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191029817088227647.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191029916789227647.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030025132227647.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030120853227647.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030206484227647.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030332711227648.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030404015227648.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030511643227648.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030618215227648.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030726761227648.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030832475227648.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191030919647227648.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031004327227648.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031110691227648.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031218978227649.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031318337227649.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031402823227649.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031516513227649.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031603927227649.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031722871227649.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031805641227649.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191031923723227649.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032023968227650.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032102507227650.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032204363227650.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032300003227650.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032426520227650.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032530901227650.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032628309227650.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032729791227650.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032817859227651.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191032901529227651.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033006050227652.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033129993227652.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033221815227652.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033321315227652.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033418668227652.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033510260227653.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033632393227653.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033723264227653.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033822141227653.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191033916672227653.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(72676514275580298.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8433315974658433.4504)
,p_button_name=>'Query'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Query'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(72673335411575794.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8433315974658433.4504)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(72676946566580304.4504)
,p_branch_action=>'15'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(72676514275580298.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(72673714957575801.4504)
,p_branch_action=>'13'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(72673335411575794.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72694595799623334.4504)
,p_name=>'F4500_P14_OBJECT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(8433315974658433.4504)
,p_prompt=>'Nome vista'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il nome vista del dizionario dati'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72783020283894832.4504)
,p_name=>'F4500_P14_QUERY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(72610012393226909.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72974620438464018.4504)
,p_name=>'F4500_P15_PARSE_STMT_AS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8433315974658433.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare uno schema (o nome utente) per l''esecuzione di questa query in base a esempio.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101240401152279929.4504)
,p_name=>'F4500_P14_CHECK_ALL'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(72610012393226909.4504)
,p_prompt=>'Seleziona tutto'
,p_post_element_text=>'<input type="checkbox" name="f10" onclick="ToggleAll(this)" />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_help_text=>'Controlla tutte le righe'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112334425618219519.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_P15_PARSE_STMT_AS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'F4500_P15_PARSE_STMT_AS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101182427964386235.4504)
,p_validation_name=>'select at least one column'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'begin',
'',
'  if wwv_flow.g_f01.count = 0 then',
'',
'    return false;',
'',
'  else',
'',
'    return true;',
'',
'  end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Specificare almeno una colonna da visualizzare. '
,p_when_button_pressed=>wwv_flow_api.id(72676514275580298.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(128448727865650733.4504)
,p_validation_name=>'must select parse as'
,p_validation_sequence=>10
,p_validation=>'F4500_P15_PARSE_STMT_AS'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Specificare uno schema Oracle (NOME UTENTE) per l''analisi di questa query.  '
,p_when_button_pressed=>wwv_flow_api.id(72676514275580298.4504)
,p_associated_item=>wwv_flow_api.id(72974620438464018.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(72792311558912454.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql   varchar2(32767) := null;',
'  l_count number := 1;',
'begin  ',
'  l_sql:=''select '';',
'',
'  for i in 1..wwv_flow.g_f01.count loop',
'    l_sql:=l_sql||wwv_flow.g_f01(i)||'', '';',
'  end loop;',
'  l_sql:=rtrim(l_sql,'', '');',
'',
'  l_sql:=l_sql||'' from ''||:F4500_P14_OBJECT_NAME;  ',
'  ',
'  for j in 1..wwv_flow.g_f04.count loop -- column_name',
'    if wwv_flow.g_f02(j) is not null then    -- condition',
'        ',
'      if l_count = 1 then      ',
'        l_sql:=l_sql||'' where ''||wwv_flow.g_f04(j)||'' like '';',
'        l_sql:=l_sql||wwv_flow_utilities.ite(wwv_flow.g_f03(j)=''VARCHAR2'',',
'                                             ''''''''||upper(wwv_flow.g_f02(j))||'''''''',',
'                                             wwv_flow.g_f02(j));',
'      elsif l_count > 1 then',
'        l_sql:=l_sql||'' and ''||wwv_flow.g_f04(j)||'' like '';',
'        l_sql:=l_sql||wwv_flow_utilities.ite(wwv_flow.g_f03(j)=''VARCHAR2'',',
'                                             ''''''''||upper(wwv_flow.g_f02(j))||'''''''',',
'                                             wwv_flow.g_f02(j));',
'      end if;',
'      l_count := l_count + 1;',
'    end if;    ',
'  end loop; ',
'  ',
'  :f4500_p14_query := l_sql;',
'  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la creazione di una query di dizionario dati valida.'
,p_process_when_button_id=>wwv_flow_api.id(72676514275580298.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69310525990845161.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:F4500_P15_PARSE_STMT_AS);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_api.create_page(
 p_id=>15.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Browser dizionario dati'
,p_step_title=>'Browser dizionario dati'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215533519659718594)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8428426757653465.4504)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(72708419326651673.4504)
,p_name=>'Risultati query'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'--',
'-- flows has privs to set non public parsing schema',
'--',
'wwv_flow_sw_api.check_priv (',
'    p_schema => :F4500_P15_PARSE_STMT_AS);',
'',
'wwv_flow.debug(:f4500_p14_query);',
'return :f4500_p14_query;',
'',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_item=>'F4500_P15_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_LEFT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'F4500_P15_PARSE_STMT_AS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48496908414770400.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'COL01'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497024693770400.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'COL02'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497115550770400.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'COL03'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497214669770400.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'COL04'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497315430770401.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'COL05'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497418633770401.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497501678770401.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497624681770401.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497703128770401.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497823777770401.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48497912399770401.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48498024704770401.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48498100804770401.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48498211783770402.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48498322912770402.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(101387732499375710.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'COL16'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(101387824096375712.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'COL17'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(101387902538375712.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'COL18'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(101388010724375712.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'COL19'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(101388126372375712.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'COL20'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162268930148685559.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'COL21'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269023884685559.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'COL22'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269121692685565.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'COL23'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269213375685566.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'COL24'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269321244685566.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'COL25'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269410621685566.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'COL26'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269504428685566.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'COL27'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269604156685566.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'COL28'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269728992685566.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'COL29'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269820824685566.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'COL30'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162269903098685567.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'COL31'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270022230685567.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'COL32'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270123628685567.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'COL33'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270214729685567.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'COL34'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270306013685567.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'COL35'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270403739685567.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'COL36'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270512314685567.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'COL37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270619695685567.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'COL38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270725824685568.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'COL39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270819092685568.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'COL40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162270931199685568.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'COL41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271022721685568.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'COL42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271100480685568.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'COL43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271206417685568.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'COL44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271320546685568.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'COL45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271422779685568.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'COL46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271504769685569.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'COL47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271608376685569.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'COL48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271732479685569.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'COL49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271816655685569.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'COL50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162271917777685569.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'COL51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272006093685569.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'COL52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272124828685569.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'COL53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272203274685569.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'COL54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272315265685570.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'COL55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272400451685570.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'COL56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272518315685570.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'COL57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272609604685570.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'COL58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272725503685570.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'COL59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162272824324685570.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'COL60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72709513331652891.4504)
,p_plug_name=>'Risultato query'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Questa pagina visualizza i risultati della query del dizionario dati. Fare clic sui pulsanti di navigazione nella parte superiore della lista dei risultati per immettere una nuova query o per sfogliare un''altra tabella del dizionario dati.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72923691296374499.4504)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(83958920185763837.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(8428426757653465.4504)
,p_button_name=>'F4500_P15_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73092323108960513.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8428426757653465.4504)
,p_button_name=>'BrowseAnotherView'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Sfoglia un''altra vista'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73051386810876661.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8428426757653465.4504)
,p_button_name=>'New_Query'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Nuova query'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73051719881876667.4504)
,p_branch_action=>'14'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(73051386810876661.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73092721135960520.4504)
,p_branch_action=>'13'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(73092323108960513.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(72886276500307504.4504)
,p_branch_action=>'15'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72928317406381693.4504)
,p_name=>'F4500_P15_ROWS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8428426757653465.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il numero massimo di righe da visualizzare nel report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(72933410758391006.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset when max rows changes'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37917032522591199.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset pagination'
,p_process_sql_clob=>'wwv_flow_disp_page_plugs.reset_region_pagination(72708419326651673);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_api.create_page(
 p_id=>16.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare il trigger'
,p_step_title=>'Impossibile creare il trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_trig.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108198732257632292.4504)
,p_plug_name=>'Impossibile creare il trigger'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>31
,p_plug_source=>'&P16_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P16_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969055780581554644.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>41
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(108199509676632295.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(969055780581554644.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(480711032422143120.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(969055780581554644.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108199917731632296.4504)
,p_name=>'P16_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108198732257632292.4504)
,p_prompt=>'Messaggio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182503528617217617.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for r in ( select object_id,object_name,owner,object_type',
' from sys.dba_objects',
' where owner = :OB_SCHEMA',
' and object_name = :P84_TRIGGER_NAME',
' and object_type = ''TRIGGER'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P16_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_api.create_page(
 p_id=>17.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dettagli colonna'
,p_step_title=>'Dettagli colonna'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(690783120585803188.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46291826911679077.4504)
,p_plug_name=>'Selettore di visualizzazione area'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717413953976820775.4504)
,p_plug_display_sequence=>7
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197559328785290205.4504)
,p_plug_name=>'Dettagli'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197566004135292852.4504)
,p_plug_name=>'Attributi specifici del form'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197566208984294244.4504)
,p_plug_name=>'Attributi specifici del report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197567331624310205.4504)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197822732653934972.4504)
,p_plug_name=>'Dettagli colonna'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Questi dettagli vengono utilizzati dall''App Builder per la creazione di pagine e aree. Le definizioni vengono confrontate per nome colonna ed \00E8 possibile condividere una determinata definizione tra pi\00F9 colonne mediante i sinonimi.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(198173528700015897.4504)
,p_name=>'Sinonimi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>15
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select syn_id, syn_name',
'  from wwv_flow_hnt_col_dict_syn',
' where column_id  = :P17_COLUMN_ID',
'   and syn_name  != :P17_COLUMN_NAME',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_condition=>'P17_COLUMN_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200287610973758311.4504)
,p_query_column_id=>1
,p_column_alias=>'SYN_ID'
,p_column_display_sequence=>1
,p_column_link=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:30:P30_SYN_ID:#SYN_ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" />'
,p_column_link_attr=>'width="16" height="16" border="0" '
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(198173830721015920.4504)
,p_query_column_id=>2
,p_column_alias=>'SYN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome sinonimo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200265324873440726.4504)
,p_plug_name=>'Sinonimi'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>12
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P17_COLUMN_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197559816861290206.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200447708951211856.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(198173528700015897.4504)
,p_button_name=>'ADD_SYN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Aggiungi sinonimo'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:30:P30_COLUMN_ID:&P17_COLUMN_ID.'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197559726985290205.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P17_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197559625357290205.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197559529748290205.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197615115236523203.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_button_name=>'GET_PREVIOUS_COLUMN_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_COLUMN_ID'')'
,p_button_condition=>'P17_COLUMN_ID_PREV'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197615015591523203.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_button_name=>'GET_NEXT_COLUMN_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Successivo'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_COLUMN_ID'')'
,p_button_condition=>'P17_COLUMN_ID_NEXT'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197617918295523222.4504)
,p_branch_action=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::P17_COLUMN_ID:&P17_COLUMN_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(197615015591523203.4504)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197618101873523223.4504)
,p_branch_action=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::P17_COLUMN_ID:&P17_COLUMN_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(197615115236523203.4504)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197560601247290207.4504)
,p_branch_action=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197560802788290208.4504)
,p_name=>'P17_COLUMN_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(197559328785290205.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'COLUMN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197561021685290219.4504)
,p_name=>'P17_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(197559328785290205.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome colonna'
,p_source=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Il nome colonna associato ai valori predefiniti.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197561232285290220.4504)
,p_name=>'P17_LABEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(197559328785290205.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etichetta'
,p_source=>'LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Etichetta da utilizzare ogni volta che si fa riferimento a una colonna con questo nome o uno dei suoi sinonimi mediante una Creazione guidata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197561404939290221.4504)
,p_name=>'P17_HELP_TEXT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(197559328785290205.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Testo Guida'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Utilizzato come testo della Guida in un form o in un report interattivo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197561629856290221.4504)
,p_name=>'P17_FORMAT_MASK'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(197559328785290205.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato di visualizzazione'
,p_source=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Formato di visualizzazione predefinito. Se esiste un formato di visualizzazione di report, form o form tabulare per questa colonna, verr\00E0 utilizzato al posto di quello predefinito.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197561806342290223.4504)
,p_name=>'P17_DEFAULT_VALUE'
,p_item_sequence=>46
,p_item_plug_id=>wwv_flow_api.id(197559328785290205.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valore predefinito'
,p_source=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Se si crea un form che fa riferimento a questa colonna, specifica il valore predefinito per l''elemento risultante da questa colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197562214371290224.4504)
,p_name=>'P17_FORM_FORMAT_MASK'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(197566004135292852.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato di visualizzazione'
,p_source=>'FORM_FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un form che fa riferimento a questa colonna o a uno dei suoi sinonimi, verr\00E0 utilizzato questo formato di visualizzazione. Se specificato, andr\00E0 a sostituire il formato di visualizzazione generale.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197562431629290224.4504)
,p_name=>'P17_FORM_DISPLAY_WIDTH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(197566004135292852.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Larghezza'
,p_source=>'FORM_DISPLAY_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>12
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Se si crea un form che fa riferimento a questa colonna o a uno dei suoi sinonimi, determina la larghezza di visualizzazione.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197562831365290226.4504)
,p_name=>'P17_FORM_DISPLAY_HEIGHT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(197566004135292852.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_prompt=>'Altezza'
,p_source=>'FORM_DISPLAY_HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>12
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se si crea un form che fa riferimento a questa colonna o a uno dei suoi sinonimi, determina l''altezza dell''elemento risultante. Ci\00F2 \00E8 valido solo per gli elementi di tipo area di testo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197563204690290226.4504)
,p_name=>'P17_FORM_DATA_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(197566004135292852.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo dati'
,p_source=>'FORM_DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FORM_VALIDATION_DATA_TYPE (FROM 4000)'
,p_lov=>'.'||wwv_flow_api.id(197595525878393704.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Non specificato -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un form che fa riferimento a questa colonna o a uno dei suoi sinonimi, determina se la convalida del tipo di dati deve essere impostata su VARCHAR (impostazione predefinita) o su NUMBER.  In quest''ultimo caso, verr\00E0 eseguita una convalida ')
||'per assicurarsi che il valore dell''elemento sia numerico.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197563625318290228.4504)
,p_name=>'P17_REPORT_FORMAT_MASK'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(197566208984294244.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato di visualizzazione'
,p_source=>'REPORT_FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un report che fa riferimento a questa colonna o a uno dei suoi sinonimi, verr\00E0 utilizzato questo formato di visualizzazione. Se specificato, andr\00E0 a sostituire il formato di visualizzazione generale.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197563811032290228.4504)
,p_name=>'P17_REPORT_COL_ALIGNMENT'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(197566208984294244.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allineamento colonna'
,p_source=>'REPORT_COL_ALIGNMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI_DEF_ALIGNMENT_LEFT_CENTER_RIGHT'
,p_lov=>'.'||wwv_flow_api.id(251500722928507973.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Se si crea un report che fa riferimento a questa colonna o a uno dei suoi sinonimi, determina l''allineamento della colonna (a sinistra, al centro o a destra).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197616916753523211.4504)
,p_name=>'P17_COLUMN_ID_NEXT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197617117858523212.4504)
,p_name=>'P17_COLUMN_ID_PREV'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197617302147523213.4504)
,p_name=>'P17_COLUMN_ID_COUNT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(197567331624310205.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_display_when=>'P17_COLUMN_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Numero di colonne definito attualmente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200265725696450365.4504)
,p_name=>'P17_SYN_NAME1'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(200265324873440726.4504)
,p_prompt=>'Sinonimo 1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Primo sinonimo della colonna. Se si aggiungono altri sinonimi, la definizione per la colonna di base verr\00E0 utilizzata ogni volta che un nome colonna corrisponde al sinonimo. \00C8 possibile aggiungere altri sinonimi dopo la creazione della colonna di bas')
||'e.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200265932622452354.4504)
,p_name=>'P17_SYN_NAME2'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(200265324873440726.4504)
,p_prompt=>'Sinonimo 2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Secondo sinonimo della colonna. \00C8 possibile aggiungere altri sinonimi dopo la creazione della colonna di base.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(198129821429313685.4504)
,p_validation_name=>'COLUMN_NAME UNIQUE'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_need_check varchar2(1) := ''N'';',
'begin',
'   if :P17_COLUMN_ID is not null then',
'      for c1 in (',
'         select column_name old_col_name',
'           from wwv_flow_hnt_column_dict',
'          where column_id = :P17_COLUMN_ID',
'            and security_group_id = :flow_security_group_id )',
'      loop',
'         if c1.old_col_name != :P17_COLUMN_NAME then',
'            l_need_check := ''Y'';  -- name change',
'         end if;',
'      end loop;',
'   else l_need_check := ''Y'';  -- new record',
'   end if;',
'',
'   if l_need_check = ''Y'' then',
'      for c1 in (',
'         select count(*) cnt',
'           from wwv_flow_hnt_col_dict_syn',
'          where syn_name = upper(:P17_COLUMN_NAME) ',
'            and security_group_id = :flow_security_group_id )',
'      loop',
'         if c1.cnt > 0 then',
'            return false;',
'         else return true;',
'         end if;',
'      end loop;',
'   else return true;',
'   end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Questo nome colonna esiste gi\00E0 come colonna o sinonimo di una colonna.')
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(197561021685290219.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200440001922077374.4504)
,p_validation_name=>'syn1 != syn2'
,p_validation_sequence=>15
,p_validation=>':P17_SYN_NAME1 != :P17_SYN_NAME2'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'I sinonimi 1 e 2 non devono essere uguali.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P17_SYN_NAME1 is not null and',
':P17_SYN_NAME2 is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(197559529748290205.4504)
,p_associated_item=>wwv_flow_api.id(200265725696450365.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200442715213090738.4504)
,p_validation_name=>'syn, syn2 != col'
,p_validation_sequence=>16
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(:P17_SYN_NAME1,''1'') != :P17_COLUMN_NAME and',
'nvl(:P17_SYN_NAME2,''2'') != :P17_COLUMN_NAME'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'I sinonimi non devono essere uguali al nome colonna.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P17_SYN_NAME1 is not null or',
':P17_SYN_NAME2 is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(197559529748290205.4504)
,p_associated_item=>wwv_flow_api.id(200265725696450365.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200297601688935415.4504)
,p_validation_name=>'SYN_NAME1 UNIQUE'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_col_dict_syn',
' where syn_name = upper(:P17_SYN_NAME1)',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Questo sinonimo esiste gi\00E0 come colonna o sinonimo di una colonna.')
,p_validation_condition=>'P17_SYN_NAME1'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(197559529748290205.4504)
,p_associated_item=>wwv_flow_api.id(200265725696450365.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200443508680117227.4504)
,p_validation_name=>'SYN_NAME2 UNIQUE'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_col_dict_syn',
' where syn_name = upper(:P17_SYN_NAME2)',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Questo sinonimo esiste gi\00E0 come colonna o sinonimo di una colonna.')
,p_validation_condition=>'P17_SYN_NAME2'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(197559529748290205.4504)
,p_associated_item=>wwv_flow_api.id(200265932622452354.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1019620180310959568.4504)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(198173528700015897.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1019620416321959569.4504)
,p_event_id=>wwv_flow_api.id(1019620180310959568.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:17:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(197564805519290231.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_03=>'P17_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossibile recuperare la riga.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(197617702299523215.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_03=>'P17_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_07=>'COLUMN_NAME'
,p_attribute_09=>'P17_COLUMN_ID_NEXT'
,p_attribute_10=>'P17_COLUMN_ID_PREV'
,p_attribute_13=>'P17_COLUMN_ID_COUNT'
,p_process_error_message=>'Impossibile eseguire il processo Richiama valore di chiave primaria successivo o precedente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(197565016928290232.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_03=>'P17_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_09=>'P17_COLUMN_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Impossibile elaborare la riga della tabella WWV_FLOW_HNT_COLUMN_DICT.'
,p_process_success_message=>'Azione elaborata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(200266428036470028.4504)
,p_process_sequence=>35
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Insert Synonyms'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P17_SYN_NAME1 is not null then',
'   insert into wwv_flow_hnt_col_dict_syn',
'      (column_id, syn_name)',
'   values',
'      (:P17_COLUMN_ID, :P17_SYN_NAME1);',
'end if;',
'if :P17_SYN_NAME2 is not null then',
'   insert into wwv_flow_hnt_col_dict_syn',
'      (column_id, syn_name)',
'   values',
'      (:P17_COLUMN_ID, :P17_SYN_NAME2);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Creazione dei sinonimi non riuscita.'
,p_process_when_button_id=>wwv_flow_api.id(197559529748290205.4504)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P17_SYN_NAME1 is not null or',
':P17_SYN_NAME2 is not null'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(197565221306290233.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'17'
,p_process_when_button_id=>wwv_flow_api.id(197559726985290205.4504)
);
null;
end;
/
prompt --application/pages/page_00018
begin
wwv_flow_api.create_page(
 p_id=>18.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Genera DDL - Schema'
,p_page_mode=>'MODAL'
,p_step_title=>'Genera DDL - Schema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(74343509509191237.4504)
,p_plug_name=>'Genera DDL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>'<p>Selezionare lo schema di database proprietario degli oggetti di database per i quali si desidera generare uno script DDL (Data Definition Language).</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(87140610261575493.4504)
,p_plug_name=>'Navigazione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(87134126220568115.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208302519813575959.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(946241682753406286.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208302519813575959.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(74371220283225403.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208302519813575959.4504)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(74355506047207982.4504)
,p_branch_action=>'43'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(74371220283225403.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74350120711201184.4504)
,p_name=>'F4500_P18_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(74343509509191237.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema di database proprietario degli oggetti per i quali si desidera generare la DDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(148823616528244857.4504)
,p_computation_sequence=>10
,p_computation_item=>'LAST_SELECTED_PARSE_AS'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4500_P18_SCHEMA'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87184711302620651.4504)
,p_validation_name=>'F4500_P18_SCHEMA Not Null'
,p_validation_sequence=>1
,p_validation=>'F4500_P18_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare uno schema.'
,p_associated_item=>wwv_flow_api.id(74350120711201184.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-AUG-2002 11:49'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(946246338971408274.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(946241682753406286.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(946246684483408279.4504)
,p_event_id=>wwv_flow_api.id(946246338971408274.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_api.create_page(
 p_id=>19.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Valori predefiniti tabelle'
,p_step_title=>'Valori predefiniti tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201420231138254416.4504)
,p_plug_name=>'Valori predefiniti tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(940656935720194111.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(940657010859194112.4504)
,p_plug_name=>'Valori predefiniti tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201420615995254420.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(940656935720194111.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201420425314254419.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(940656935720194111.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'CREATE'
,p_button_condition=>'P19_TABLE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201420527486254419.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(940656935720194111.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P19_TABLE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201444027095519583.4504)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:802::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(201420527486254419.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201421332116254423.4504)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201421521710254426.4504)
,p_name=>'P19_TABLE_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(201420231138254416.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201421718276254441.4504)
,p_name=>'P19_SCHEMA'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(201420231138254416.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'SCHEMA'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Lo schema proprietario della tabella o della vista corrente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201421914895254443.4504)
,p_name=>'P19_TABLE_NAME'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(201420231138254416.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome oggetto:'
,p_source=>'TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'La tabella o la vista all''interno dello schema corrente a cui sono associati i valori predefiniti di interfaccia utente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201422109033254444.4504)
,p_name=>'P19_FORM_REGION_TITLE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(201420231138254416.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Titolo area form'
,p_source=>'FORM_REGION_TITLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se si crea un form che fa riferimento a questa tabella, questo titolo verr\00E0 utilizzato come titolo di area risultante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201422314187254445.4504)
,p_name=>'P19_REPORT_REGION_TITLE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(201420231138254416.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Titolo area report'
,p_source=>'REPORT_REGION_TITLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se si crea un report o un form tabulare su questa vista, questo titolo verr\00E0 utilizzato come titolo di area risultante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201422723289254449.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_TABLE_INFO'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_TABLE_INFO'
,p_attribute_03=>'P19_TABLE_ID'
,p_attribute_04=>'TABLE_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossibile recuperare la riga.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201422915388254451.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_TABLE_INFO'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_TABLE_INFO'
,p_attribute_03=>'P19_TABLE_ID'
,p_attribute_04=>'TABLE_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Impossibile elaborare la riga della tabella WWV_FLOW_HNT_TABLE_INFO.'
,p_process_success_message=>'Azione elaborata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201423127741254452.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'19'
,p_process_when_button_id=>wwv_flow_api.id(201420527486254419.4504)
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_api.create_page(
 p_id=>20.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea applicazione da script'
,p_page_mode=>'MODAL'
,p_step_title=>'Crea applicazione da script'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(82705316400738126.4504)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179748680802869406.4504)
,p_plug_name=>'Nessuna tabella trovata'
,p_region_css_classes=>'a-Alert--dialog margin-top-md'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Questo script non contiene istruzioni CREATE TABLE oppure le tabelle non esistono nello schema selezionato.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value table_name',
'from table(',
'    wwv_flow_define_app_v3.get_valid_tables(',
'        p_schema    => :P20_SCHEMA,',
'        p_file_id   => :P20_SCRIPT_FILE_ID ))'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1152240684997363045.4504)
,p_name=>'Tabelle'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--noBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value table_name',
'from table(',
'    wwv_flow_define_app_v3.get_valid_tables(',
'        p_schema    => :P20_SCHEMA,',
'        p_file_id   => :P20_SCRIPT_FILE_ID ))',
'order by 1;'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value table_name',
'from table(',
'    wwv_flow_define_app_v3.get_valid_tables(',
'        p_schema    => :P20_SCHEMA,',
'        p_file_id   => :P20_SCRIPT_FILE_ID ))'))
,p_display_condition_type=>'EXISTS'
,p_header=>'Le tabelle riportate di seguito in questo script verranno utilizzate per le pagine di report e form predefinite nella Creazione guidata applicazione.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Lo script NON contiene alcuna istruzione CREATE TABLE oppure le tabelle NON esistono nello schema di database.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(179748550028869405.4504)
,p_query_column_id=>1
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome tabella'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1152240724442363046.4504)
,p_plug_name=>'Pulsanti procedura guidata'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1152240897463363047.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1152240724442363046.4504)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1152241140193363050.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1152240724442363046.4504)
,p_button_name=>'CREATE_APP_WIZ'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea applicazione'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value table_name',
'from table(',
'    wwv_flow_define_app_v3.get_valid_tables(',
'        p_schema    => :P20_SCHEMA,',
'        p_file_id   => :P20_SCRIPT_FILE_ID ))'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(179748914199869409.4504)
,p_branch_name=>'create app wizard'
,p_branch_action=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:RP,1,5,130,150,170,250:P1_SCRIPT_FILE_ID,P1_SCHEMA:&P20_SCRIPT_FILE_ID.,&P20_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1152241140193363050.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(82704992099738122.4504)
,p_name=>'P20_SCHEMA'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(82705316400738126.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare uno schema di database. Le istruzioni CREATE TABLE in questo script possono essere controllate rispetto allo schema di database per verificare se possono essere utilizzate nella Creazione guidata applicazione.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(82706436951738137.4504)
,p_name=>'P20_SCRIPT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(82705316400738126.4504)
,p_prompt=>'Nome script'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'from wwv_flow_files',
'where id = :P20_SCRIPT_FILE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(179748251592869402.4504)
,p_name=>'P20_SCRIPT_FILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1152240684997363045.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1152240917321363048.4504)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1152240897463363047.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1152241056917363049.4504)
,p_event_id=>wwv_flow_api.id(1152240917321363048.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(82705089581738123.4504)
,p_name=>'set schema in session'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P20_SCHEMA'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82705167397738124.4504)
,p_event_id=>wwv_flow_api.id(82705089581738123.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(657512869312459935.4504)
,p_name=>'Create App'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1152241140193363050.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(657512906754459936.4504)
,p_event_id=>wwv_flow_api.id(657512869312459935.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_APP_WIZ'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_api.create_page(
 p_id=>21.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Prime istruzioni SQL'
,p_step_title=>'Prime istruzioni SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_topsql.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160632704976002525.4504)
,p_plug_name=>'Query Parameter Container'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(168892618181554185.4504)
,p_name=>'Prime istruzioni SQL'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>21
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    x   varchar2(32767);',
'    p   varchar2(32767):= null;',
'begin',
'',
'x:=''select * from ( '';',
'x:=x||''select wwv_flow_escape.html(replace(replace(substr(sql_text,1,500),'''','''','''', ''''),'''',''''||chr(32)||chr(32),'''',''''||chr(32))) sql_text, '';',
'x:=x||''  (cpu_time/1000000) cpu_time,disk_reads,buffer_gets, '';',
'x:=x||''  executions, '';',
'x:=x||''  case when rows_processed = 0 then null else (buffer_gets/nvl(replace(rows_processed,0,1),1)) end efficiency, '';',
'x:=x||''  (buffer_gets/nvl(replace(executions,0,1),1)) efficiency2, '';',
'x:=x||''  child_number,hash_value,address, '';',
'x:=x||'' case '';',
'x:=x||'' when (select count(*) from sys.gv_$sql_plan sp where  sp.address=s.address '';',
'x:=x||'' and sp.HASH_VALUE=s.hash_value and sp.CHILD_NUMBER=s.child_number) > 0'';',
'x:=x||'' then ''''<a href="f?p=4500:551:&SESSION.::NO:551:P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER,P551_INST_ID:''''||s.address||'''',''''||s.hash_value||'''',''''||s.child_number||'''',''''||s.inst_id||''''"><span class="a-Icon icon-search"></span><span class="u'
||'-VisuallyHidden">''||wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'')||''</span></a> '''' '';',
'x:=x||'' else null '';',
'x:=x||'' end x, '';',
'x:=x||'' null link, '';',
'x:=x||''  (elapsed_time/1000000) elapsed_time,  '';',
'x:=x||''  ''''''||wwv_flow_lang.system_message(''SESSION_MON_ELAPSED'')||'' ''''||to_char((elapsed_time/1000000),''''999G999G999G999D00'''') || '';',
'x:=x||''  ''''<br />''||wwv_flow_lang.system_message(''SESSION_MON_CPU'')||'' ''''||to_char((cpu_time/1000000),''''999G999G999G999D00'''') the_time,  '';',
'x:=x||''  ''''''||wwv_flow_lang.system_message(''SESSION_MON_DISK'')||'' ''''||to_char(disk_reads,''''999G999G999G999'''')||''''<br />''''|| '';',
'x:=x||''  ''''''||wwv_flow_lang.system_message(''SESSION_MON_BUFFER'')||'' ''''||to_char(buffer_gets,''''999G999G999G999'''') reads,module  '';',
'',
'',
'',
'x:=x||''from sys.gv_$sql s '';',
'-- Begin Predicates',
'if :P21_SEARCH is not null then',
'  p := p||''where instr(upper(sql_text),upper(:P21_SEARCH))>0 '';',
'end if;',
'',
'if :P21_MINIMUM_EXECUTIONS  is not null then',
'    if p is null then',
'        p := p||'' where '';',
'    else',
'        p := p||'' and '';',
'    end if;',
'    ',
'    p := p||''EXECUTIONS >=:P21_MINIMUM_EXECUTIONS '';',
'end if;',
'',
'if :P21_MODULE is not null then',
'    if p is null then',
'        p := p||'' where '';',
'    else',
'        p := p||'' and '';',
'    end if;',
'    p := p||'' instr(upper(module),upper(:P21_MODULE))>0 '';',
'end if;',
'',
'if p is not null then',
'    x:=x||p;',
'end if;',
'',
'-- End Predicates',
'x:=x||'' order by '';',
'',
'case :P21_TOP_BY',
'    when ''CPU_TIME'' then x:=x||'' CPU_TIME '';',
'    when ''DISK_READS'' then x:=x||'' DISK_READS '';',
'    when ''BUFFER_GETS'' then x:=x||'' BUFFER_GETS '';',
'    when ''EXECUTIONS'' then x:=x||'' EXECUTIONS '';',
'    when ''EFFICIENCY'' then x:=x||'' EFFICIENCY '';',
'    when ''EFFICIENCY2'' then x:=x||'' EFFICIENCY2 '';',
'    ',
'else x:=x||'' CPU_TIME '';',
'end case;',
'',
'',
'x:=x||''  desc nulls last) '';',
'',
'wwv_flow.debug(x);',
'',
'return x;',
'',
'end;'))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_item=>'P21_TOP_N'
,p_query_row_count_max=>10000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171388315032544852.4504)
,p_query_column_id=>1
,p_column_alias=>'SQL_TEXT'
,p_column_display_sequence=>16
,p_column_heading=>'Testo SQL'
,p_column_css_style=>'font-family:monospace;'
,p_column_hit_highlight=>'&P21_SEARCH.'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171388404157544852.4504)
,p_query_column_id=>2
,p_column_alias=>'CPU_TIME'
,p_column_display_sequence=>5
,p_column_heading=>'CPU<br />Time in<br />Seconds'
,p_column_format=>'999G999G999G999G990D000'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171388519098544852.4504)
,p_query_column_id=>3
,p_column_alias=>'DISK_READS'
,p_column_display_sequence=>7
,p_column_heading=>'Disk<br />Reads'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171388702211544853.4504)
,p_query_column_id=>4
,p_column_alias=>'BUFFER_GETS'
,p_column_display_sequence=>8
,p_column_heading=>'Buffer<br />Gets'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171389222447544853.4504)
,p_query_column_id=>5
,p_column_alias=>'EXECUTIONS'
,p_column_display_sequence=>9
,p_column_heading=>'Esecuzioni'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171460708330609160.4504)
,p_query_column_id=>6
,p_column_alias=>'EFFICIENCY'
,p_column_display_sequence=>13
,p_column_heading=>'Richieste buffer<br />/Righe<br />elaborate'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189510522012751279.4504)
,p_query_column_id=>7
,p_column_alias=>'EFFICIENCY2'
,p_column_display_sequence=>14
,p_column_heading=>'Richieste<br />buffer/<br />esecuzioni'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171389514740544854.4504)
,p_query_column_id=>8
,p_column_alias=>'CHILD_NUMBER'
,p_column_display_sequence=>10
,p_column_heading=>'Child Number'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171389602402544854.4504)
,p_query_column_id=>9
,p_column_alias=>'HASH_VALUE'
,p_column_display_sequence=>11
,p_column_heading=>'Hash Value'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171389730882544854.4504)
,p_query_column_id=>10
,p_column_alias=>'ADDRESS'
,p_column_display_sequence=>12
,p_column_heading=>'Address'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(287415608918139948.4504)
,p_query_column_id=>11
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'<br />'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182588111320364025.4504)
,p_query_column_id=>12
,p_column_alias=>'LINK'
,p_column_display_sequence=>2
,p_column_heading=>'<br />'
,p_column_link=>'f?p=&APP_ID.:551:&SESSION.::&DEBUG.:551:P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER:#ADDRESS#,#HASH_VALUE#,#CHILD_NUMBER#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#24find.gif" border="0" alt="" width="24" height="24" />'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189510628385751281.4504)
,p_query_column_id=>13
,p_column_alias=>'ELAPSED_TIME'
,p_column_display_sequence=>4
,p_column_heading=>'Elapsed <br />Time in<br />Seconds'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193252116724137021.4504)
,p_query_column_id=>14
,p_column_alias=>'THE_TIME'
,p_column_display_sequence=>3
,p_column_heading=>'Tempo in<br />secondi'
,p_column_css_style=>'white-space:nowrap;'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193302526383187173.4504)
,p_query_column_id=>15
,p_column_alias=>'READS'
,p_column_display_sequence=>6
,p_column_heading=>'Letture'
,p_column_css_style=>'white-space:nowrap;'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193326725259205755.4504)
,p_query_column_id=>16
,p_column_alias=>'MODULE'
,p_column_display_sequence=>15
,p_column_heading=>'Modulo'
,p_column_hit_highlight=>'&P21_MODULE.'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160636525408008427.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(160632704976002525.4504)
,p_button_name=>'P21_GO'
,p_button_static_id=>'P21_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(160636702055008428.4504)
,p_branch_action=>'f?p=&FLOW_ID.:21:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160635519867006875.4504)
,p_name=>'P21_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(160632704976002525.4504)
,p_prompt=>'Testo SQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere i criteri della query senza distinzione tra maiuscole e minuscole nel testo SQL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161861005551431142.4504)
,p_name=>'P21_TOP_N'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_api.id(160632704976002525.4504)
,p_item_default=>'10'
,p_prompt=>'Visualizza prime'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap" style="padding-left:15px;"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identificare il numero massimo di istruzioni SQL da visualizzare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(171366328266454012.4504)
,p_name=>'P21_TOP_BY'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_api.id(160632704976002525.4504)
,p_prompt=>'Prime per'
,p_source=>'EFFICIENCY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TOP_SQL_BY'
,p_lov=>'.'||wwv_flow_api.id(236910808625037522.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicare la preferenza di ordinamento del report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180387913498802349.4504)
,p_name=>'P21_MINIMUM_EXECUTIONS'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(160632704976002525.4504)
,p_prompt=>'Numero minimo di esecuzioni'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap" style="padding-left:15px;"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Vincolare la query ai comandi SQL con almeno questo numero di esecuzioni.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(192864705765667292.4504)
,p_name=>'P21_MODULE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(160632704976002525.4504)
,p_prompt=>'Modulo'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct module d, module r',
'  from sys.gv_$sql'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap" style="padding-left:15px;"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identificare il modulo impostato dall''applicazione client.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(238759409305130430.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'21'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(241565932566286195.4504)
,p_validation_name=>'P21_MINIMUM_EXECUTIONS'
,p_validation_sequence=>10
,p_validation=>'P21_MINIMUM_EXECUTIONS'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Immettere un valore numerico'
,p_associated_item=>wwv_flow_api.id(180387913498802349.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(160637327486009049.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_api.create_page(
 p_id=>22.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'crea trigger dalla tabella'
,p_alias=>'TRIGGER_CREATE2'
,p_step_title=>'Crea trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="ob_trigTog(''P22_OPT'');"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'function ob_trigTog(pThis){',
'  var tValue = html_GetElement(pThis);',
' if(pThis && tValue && tValue.value == ''update of''){',
'   html_ShowItemRow(''P22_COL_NAME'');',
' }else{',
'   html_HideItemRow(''P22_COL_NAME'');',
' }',
'}',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145976118207192151.4504)
,p_plug_name=>'Crea trigger'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(145976303508192158.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id, COLUMN_NAME,  DATA_TYPE, DATA_LENGTH, DATA_PRECISION, DATA_SCALE, NULLABLE',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'P3_TABLE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145976604515192159.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145976702012192159.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145976829673192159.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145976930838192159.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145977001770192159.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145977111250192159.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145976527242192158.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(145977220168192159.4504)
,p_name=>'Trigger esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'       trigger_name, ',
'       table_owner,',
'       TABLE_NAME,',
'       BASE_OBJECT_TYPE,',
'       TRIGGER_TYPE,',
'       TRIGGERING_EVENT,',
'       WHEN_CLAUSE,',
'       ACTION_TYPE,',
'       status,',
'       TRIGGER_BODY',
'from sys.dba_triggers t',
'where t.table_name = :OBJECT_NAME',
'and t.table_owner = :OB_SCHEMA',
'order by t.trigger_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145977426744192160.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema di trigger'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145977503608192160.4504)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145977601226192160.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Schema di tabella'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145977702975192160.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome tabella'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145977826663192160.4504)
,p_query_column_id=>5
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Oggetto base'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145977913239192160.4504)
,p_query_column_id=>6
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145978018767192161.4504)
,p_query_column_id=>7
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>7
,p_column_heading=>'Evento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145978119250192161.4504)
,p_query_column_id=>8
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>8
,p_column_heading=>'Quando'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145978208812192161.4504)
,p_query_column_id=>9
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>9
,p_column_heading=>'Azione'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145978308909192161.4504)
,p_query_column_id=>10
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145978410713192161.4504)
,p_query_column_id=>11
,p_column_alias=>'TRIGGER_BODY'
,p_column_display_sequence=>11
,p_column_heading=>'Corpo'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(145978726604192172.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(145978527031192162.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(145986020520192238.4504)
,p_branch_action=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145979118524192174.4504)
,p_name=>'P22_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&OB_SCHEMA.'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145979622996192189.4504)
,p_name=>'P22_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>':OBJECT_NAME'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tabella:'
,p_source=>':OBJECT_NAME'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Nome della tabella per la quale creare il trigger'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145980304034192191.4504)
,p_name=>'P22_TRIGGER_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&OBJECT_NAME._T1'
,p_prompt=>'Nome trigger'
,p_source=>'&OBJECT_NAME._T1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome del trigger da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145980820441192192.4504)
,p_name=>'P22_PRESERVE_CASE'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145981011748192192.4504)
,p_name=>'P22_BEFORE_OR_AFTER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_item_default=>'BEFORE'
,p_prompt=>'Punto di attivazione:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:BEFORE;BEFORE,AFTER;AFTER'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare quando il trigger deve essere eseguito'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145981502751192193.4504)
,p_name=>'P22_OPT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_item_default=>'insert, update, delete'
,p_prompt=>'Opzioni:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC(~,*):delete*delete~delete, insert*delete, insert~insert*insert~insert, update*insert, update~insert, update, delete*insert, update, delete~update*update~update, delete*update, delete~update of *update of'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'onchange="ob_trigTog(this)"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare le azioni che comportano l''esecuzione del trigger'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145982021984192195.4504)
,p_name=>'P22_TNAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>':OBJECT_NAME'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'su:'
,p_source=>':OBJECT_NAME'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Nome della tabella per la quale creare il trigger'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145982428529192205.4504)
,p_name=>'P22_PROCESSED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_item_default=>'for each row'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FOR.EACH.ROW'
,p_lov=>'.'||wwv_flow_api.id(88058923955804681.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specificare se deve essere conservata la distinzione tra maiuscole e minuscole nel nome del trigger'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145983109397192207.4504)
,p_name=>'P22_TEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_prompt=>'Corpo trigger:'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il corpo PL/SQL per il trigger'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145983610662192207.4504)
,p_name=>'P22_COL_NAME'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_prompt=>'Colonna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select wwv_flow_escape.html(column_name) d, column_name r from sys.dba_tab_columns where table_name = :P22_TABLE AND OWNER = :OB_SCHEMA'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Scegliere una colonna se si seleziona un trigger di aggiornamento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145984121881192208.4504)
,p_name=>'P22_WHEN'
,p_item_sequence=>82
,p_item_plug_id=>wwv_flow_api.id(145976118207192151.4504)
,p_prompt=>'Quando'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Immettere una clausola WHEN valida per il trigger. \00C8 possibile utilizzare i riferimenti:'),
'</p>',
'<p>',
'NEW.deptno > 5',
'</p>',
'<p>',
unistr('Nota: nella clausola WHEN non \00E8 possibile utilizzare la sintassi :NEW.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(145984621119192219.4504)
,p_computation_sequence=>5
,p_computation_item=>'P22_TRIGGER_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P22_TRIGGER_NAME,chr(32),''_''))'
,p_compute_when=>'P22_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(145984800715192227.4504)
,p_computation_sequence=>10
,p_computation_item=>'P25_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
't_name varchar2(2000);',
'begin',
' if :P22_PRESERVE_CASE = ''Y'' then',
'   t_name := :P22_TRIGGER_NAME;',
' else',
'   t_name := upper(:P22_TRIGGER_NAME);',
' end if;',
'return wwv_flow_sw_util.get_trigger2_ddl(',
'         p_table_name => :OBJECT_NAME,',
'         p_action     => ''create or replace'',',
'         p_trigger_nm => t_name,',
'         p_when       => :P22_BEFORE_OR_AFTER,',
'         p_operations => replace(:P22_OPT,'','','' or''),',
'         p_for_each   => :P22_PROCESSED,',
'         p_body       => :P22_TEXT,',
'         p_col        => :P22_COL_NAME,',
'         p_col_when   => :P22_WHEN );',
'end;'))
,p_computation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare q varchar2(32767);',
'begin',
'   q := ''create or replace trigger ''||:P84_TRIGGER_NAME||chr(10);',
'   q := q||:P84_BEFORE_OR_AFTER||'' ''||replace(:P84_OPT,'','','' or'')||',
'        '' on ''||:p57_TABLE||chr(10);',
'   q := q||:P84_PROCESSED||chr(10);',
'   q := q||''begin''||chr(10)||:P84_TEXT||chr(10)||''end;''||chr(10)||''/'';   ',
'   return q;',
'end;'))
,p_computation_error_message=>'Impossibile generare la sintassi SQL per la creazione dell''indice.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(145985004479192229.4504)
,p_validation_name=>'TriggerNameMand'
,p_validation_sequence=>10
,p_validation=>'P22_TRIGGER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare il nome del trigger.'
,p_associated_item=>wwv_flow_api.id(145980304034192191.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(145985207924192235.4504)
,p_validation_name=>'TriggerTextMand'
,p_validation_sequence=>20
,p_validation=>'P22_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Corpo trigger.'
,p_associated_item=>wwv_flow_api.id(145983109397192207.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(145985424382192236.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P22_TRIGGER_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato del trigger \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(145985608174192236.4504)
,p_validation_name=>'Unique trigger name'
,p_validation_sequence=>40
,p_validation=>'select 1 from sys.dba_triggers where trigger_name = :P22_TRIGGER_NAME and owner = :P22_SCHEMA'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Nome trigger gi\00E0 utilizzato.')
,p_when_button_pressed=>wwv_flow_api.id(145978726604192172.4504)
,p_associated_item=>wwv_flow_api.id(145980304034192191.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(145985830826192237.4504)
,p_validation_name=>'valid update of and column name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p22_opt = ''update of'' and :p22_col_name = ''0'' then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Selezionare una colonna per l''aggiornamento del trigger'
,p_when_button_pressed=>wwv_flow_api.id(145978726604192172.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00023
begin
wwv_flow_api.create_page(
 p_id=>23.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'risultati Query Builder'
,p_alias=>'QUERY_BUILDER_RESULTS'
,p_step_title=>'risultati Query Builder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(14599108081253832.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_proc.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4345425019330550.4504)
,p_name=>'results'
,p_template=>wwv_flow_api.id(12270828624874231.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_query_builder.check_priv (p_schema => :P1002_SCHEMA);',
'    return :P1002_QUERY;',
'end; '))
,p_footer=>'<span class="htmldbCSV"><a href="f?p=&APP_ID.:&APP_PAGE_ID.:&APP_SESSION.:FLOW_EXCEL_OUTPUT_R4345425019330550">Scarica</a></span>'
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1002_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348623393330557.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348732177330557.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348819176330557.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348911783330557.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349009268330557.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349101121330558.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349218228330558.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349303988330558.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349424164330558.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349532076330558.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349605066330558.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349732439330558.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349801732330558.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4349928913330558.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350005849330559.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350116939330559.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350207886330559.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350303267330559.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350418593330559.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350508128330559.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350601606330559.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350714454330559.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350817456330559.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4350906976330560.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4351027155330560.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4351104489330560.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4351200861330560.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4351310658330560.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4351417497330560.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4351530996330560.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4345606818330554.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4345709023330554.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4345812127330554.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4345917382330554.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346028532330554.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346124612330554.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346213755330554.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346314733330554.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346413799330555.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346503891330555.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346601482330555.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346727710330555.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346828687330555.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4346920935330555.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347001983330555.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347116666330555.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347208498330555.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347302539330555.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347422580330556.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347527682330556.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347629829330556.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347710057330556.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347807428330556.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4347902500330556.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348012066330556.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348102133330556.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348202924330557.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348327301330557.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348402381330557.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4348515291330557.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
end;
/
prompt --application/pages/page_00024
begin
wwv_flow_api.create_page(
 p_id=>24.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Strumento di ricerca tabelle'
,p_step_title=>'Strumento di ricerca tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="p24_Init()"'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function p24_AppendBack(){',
'    var lValue = opener.$v(''P1003_SQL_COMMAND1'') + ''\n\n'' + $v(''qReturn'');',
'    opener.setCodeEditorValue(lValue);',
'    window.close();',
'}',
'',
'function p24_ReplaceBack(){',
'    opener.setCodeEditorValue($v(''qReturn''));',
'    window.close();',
'}',
'',
'var p24TabTest = false;',
'function p24_Init(){',
'    if(p24TabTest){',
'        $d_TabClick(''columntab'',''columnreport'',''tabcurrent'',p24Tabs)',
'    }else{',
'        $d_TabClick(''tabletab'',''tablereport'',''tabcurrent'',p24Tabs)',
'    }',
'}',
'',
'var p24Tabs = [''tabletab'',''columntab''];',
'</script>'))
,p_step_template=>wwv_flow_api.id(203703017586195109.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/wrkshp_table_finder.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12117026009139651.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>7
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_2'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(12183729610626245.4504)
,p_name=>'Tables'
,p_template=>wwv_flow_api.id(42819301025617014.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_display_point=>'BODY_3'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.object_id,',
'       t.table_name,',
'       t.num_rows,',
'       t.last_analyzed,',
'       ''TABLE'' object_type',
'  from sys.user_tables t,',
'       sys.user_objects o',
' where o.object_name = t.table_name',
'   and o.object_type = ''TABLE''',
'   and (instr(upper(t.table_name), upper(:P24_FIND)) > 0 or :P24_FIND IS NULL)',
'union all',
'select o.object_id,',
'       v.view_name table_name,',
'       null num_rows,',
'       null last_analyzed,',
'       ''VIEW'' object_type',
'  from sys.user_views v,',
'       sys.user_objects o',
' where o.object_name = v.view_name',
'   and o.object_type = ''VIEW''',
'   and (instr(upper(v.view_name), upper(:P24_FIND)) > 0 or :P24_FIND IS NULL)',
'   and :P24_INCLUDE_VIEWS = ''YES'''))
,p_header=>'<div id="tablereport">'
,p_footer=>'</div>'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_item=>'P24_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>20000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12184028410626250.4504)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12184115287626250.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tabella'
,p_column_link=>'f?p=&APP_ID.:24:&SESSION.:&REQUEST.:&DEBUG.::P24_TABLE_NAME:#TABLE_NAME#'
,p_column_linktext=>'#TABLE_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12184223295626250.4504)
,p_query_column_id=>3
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>3
,p_column_heading=>'Righe'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40945525348156654.4504)
,p_query_column_id=>4
,p_column_alias=>'LAST_ANALYZED'
,p_column_display_sequence=>4
,p_column_heading=>'Ultima analisi'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12184404832626251.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(12243208082566182.4504)
,p_name=>'Columns'
,p_template=>wwv_flow_api.id(42819301025617014.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_display_point=>'BODY_3'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name,',
'       data_type,',
'       data_length,',
'       data_precision,',
'       data_scale,',
'       nullable',
'  from sys.user_tab_columns',
' where table_name = :P24_TABLE_NAME',
' order by column_id'))
,p_display_when_condition=>'P24_TABLE_NAME'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>150000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>150000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12243500051566185.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Colonna'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12243616112566185.4504)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo dati'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12243703595566185.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>3
,p_column_heading=>'Lunghezza'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12243817097566185.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>4
,p_column_heading=>'Precisione'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12243901714566185.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>5
,p_column_heading=>'Scala'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40969229915337787.4504)
,p_query_column_id=>6
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>6
,p_column_heading=>'Annullabile'
,p_display_as=>'TEXT_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(23482928300634173)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12257807960632350.4504)
,p_plug_name=>'Select View'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;padding-top:10px; width:100%"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'q2 varchar2(32767);',
'begin',
'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);',
'q2 := ''select ''||chr(10);',
'for c1 in (',
'select column_name',
'from sys.dba_TAB_COLUMNS c',
'where table_name = :P24_TABLE_NAME and',
'    c.owner = :P1003_SCHEMA',
'order by column_id) loop',
'q2 := q2 ||'' ''||wwv_flow_escape.html(c1.column_name)||'',''||chr(10);',
'end loop;',
'q2 := rtrim(rtrim(q2,chr(10)),'','')||chr(10)||'' from ''||wwv_flow_escape.html(:P24_TABLE_NAME)||chr(10);',
'sys.htp.p(''<textarea id="qReturn" style="width:100%;height:200px;">''||q2||''</textarea>'');',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P24_TABLE_NAME'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98328429053791328.4504)
,p_plug_name=>'Open Div'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'<div>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_header=>'<div id="tables" style="clear:both;">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98328622929791328.4504)
,p_plug_name=>'Close Div'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>2000
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'</div>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98334600702811560.4504)
,p_plug_name=>'Region_Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_list_id=>wwv_flow_api.id(98332317887807047.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98338412608824440.4504)
,p_plug_name=>'js'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'var p24TabTest = true;',
'//-->',
'</script>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P24_TABLE_NAME'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98339511354833599.4504)
,p_plug_name=>'Sub Div Open'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>29
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'<div id="columnreport" style="display:none;">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98339730224833600.4504)
,p_plug_name=>'Sub Div Close'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'</div>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98520530596378377.4504)
,p_plug_name=>'Save to Worksheet'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;padding-top:10px;"'
,p_plug_template=>wwv_flow_api.id(2976007666683831.4504)
,p_plug_display_sequence=>45
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<button value="''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.APPEND'')||''" class="a-Button" type="button" onclick="p24_AppendBack()">''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.APPEND'')||''</button>'');',
'sys.htp.p(''<button value="''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.REPLACE'')||''" class="a-Button" type="button" onclick="p24_ReplaceBack()">''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.REPLACE'')||''</button>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P24_STATE'
,p_plug_display_when_cond2=>'SC'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div style=''padding-bottom:40px''>'
,p_plug_footer=>'</div>'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(142868013283899762.4504)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div style="display:none;">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12166516320262781.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(12117026009139651.4504)
,p_button_name=>'P24_GO'
,p_button_static_id=>'P24_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12226604666243469.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(12117026009139651.4504)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Chiudi'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12166725687262782.4504)
,p_branch_action=>'f?p=&APP_ID.:24:&SESSION.:&REQUEST.:&DEBUG.::p24_table_name:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12165709394260825.4504)
,p_name=>'P24_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(12117026009139651.4504)
,p_prompt=>'Cerca'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Immettere i criteri della query e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12182711818611559.4504)
,p_name=>'P24_INCLUDE_VIEWS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(12117026009139651.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX FOR VIEWS'
,p_lov=>'.'||wwv_flow_api.id(12319218872723617.4504)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Selezionare per includere le viste'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12221908775216250.4504)
,p_name=>'P24_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(12117026009139651.4504)
,p_item_default=>'15'
,p_prompt=>'Righe'
,p_source=>'15'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determina il numero massimo di righe di risultati da visualizzare per le query SQL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12244614315567983.4504)
,p_name=>'P24_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(12243208082566182.4504)
,p_prompt=>'Tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il nome della tabella selezionata'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14003528650686435.4504)
,p_name=>'P24_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(12117026009139651.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_post_element_text=>'&nbsp;'
,p_source=>'&P1003_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema selezionato'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(142872704756906673.4504)
,p_name=>'P24_STATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(142868013283899762.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12253126483599912.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(12166516320262781.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(77533228440026331.4504)
,p_process_sequence=>1
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'POPUP FROM OB'
,p_process_sql_clob=>':P1003_SCHEMA := :P2001_FEED_OWNER;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OB'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432752016817981645.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00025
begin
wwv_flow_api.create_page(
 p_id=>25.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma creazione trigger'
,p_step_title=>'Conferma modifica tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_trig.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(146000726976226026.4504)
,p_plug_name=>'Confermare la richiesta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(146000925307226031.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>30
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146001305874226033.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(146000726976226026.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea trigger'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146001515089226033.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(146000726976226026.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146001104570226032.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(146000726976226026.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(146004027881226041.4504)
,p_branch_action=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(146001305874226033.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146001707896226033.4504)
,p_name=>'P25_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(146000726976226026.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146002221454226035.4504)
,p_name=>'P25_ACTION'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(146000726976226026.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Azione:'
,p_source=>'Create trigger &P22_TRIGGER_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il tipo di azione da eseguire sulla tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146002702523226036.4504)
,p_name=>'P25_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(146000925307226031.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146002904793226037.4504)
,p_name=>'P25_TABLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(146000726976226026.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Oggetto:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(146003421234226039.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &P56_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(146001305874226033.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(146003628078226039.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P26_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P25_SQL );',
'',
'for c in (select object_id from sys.dba_objects ',
'           where object_name = :P22_TRIGGER_NAME and owner = :OB_SCHEMA and',
'          object_type = ''TRIGGER'') loop',
'  :object_id := c.object_id;',
'  :object_type := ''TRIGGER'';',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(146001305874226033.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(146003823945226040.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P25_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(146001305874226033.4504)
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_api.create_page(
 p_id=>26.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare il trigger'
,p_step_title=>'Impossibile creare il trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_trig.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(146006721667233564.4504)
,p_plug_name=>'Unable to Create Trigger'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>31
,p_plug_source=>'&P26_MSG.'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P26_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146007325893233569.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(146006721667233564.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(182318116609722105.4504)
,p_branch_action=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146007721346233571.4504)
,p_name=>'P26_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(146006721667233564.4504)
,p_prompt=>'Messaggio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(127846811585766356.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for r in ( ',
'   select object_name, owner',
'     from sys.dba_objects',
'    where owner = :OB_SCHEMA',
'      and object_id = :OBJECT_ID',
'      and object_type = ''TRIGGER'' )',
'loop',
'   :OBJECT_NAME  := r.object_name;',
'   :OBJECT_OWNER := r.owner;',
'end loop;',
'',
'sys.owa_util.http_header_close();',
'sys.htp.p(''<script>top.gSideBar.reload('' ||',
'          wwv_flow_escape.js_literal(replace(:OBJECT_TYPE, '' '', ''_'')) || '','' ||',
'          wwv_flow_escape.js_literal(:OBJECT_ID) || '',true);</script>'');',
'wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P26_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_api.create_page(
 p_id=>27.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Cerca nel codice sorgente PL/SQL'
,p_step_title=>'Cerca nel codice sorgente PL/SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276002212445738952)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_plsql.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42229710876797320.4504)
,p_plug_name=>'Cerca origine PL/SQL'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>30
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       type,',
'       line,',
'       text',
'  from sys.user_source',
' where line >= nvl(:P27_FROM_LINE, 0)',
'   and line <= nvl(:P27_TO_LINE, 999999999)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P27_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(42229808451797320.4504)
,p_name=>'Search PL/SQL Source'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(42230023926797336.4504)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nome oggetto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(42230117345797337.4504)
,p_db_column_name=>'TYPE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(42230216998797338.4504)
,p_db_column_name=>'LINE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Riga'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(42230313084797338.4504)
,p_db_column_name=>'TEXT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Testo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(163544124488204308.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(163937914275639630.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(163544124488204308.4504)
,p_button_name=>'P27_GO'
,p_button_static_id=>'P27_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Imposta'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722739444901798622.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(42229710876797320.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(163938104362639631.4504)
,p_branch_action=>'f?p=&FLOW_ID.:27:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10272119258228776.4504)
,p_name=>'P27_FROM_LINE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(163544124488204308.4504)
,p_prompt=>'Dalla riga'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Per limitare la ricerca a un intervallo di numeri di riga degli oggetti PL/SQL, immettere il numero della riga iniziale. \00C8 quindi possibile fare clic su <strong>Vai</strong> o immettere un numero di riga finale nel campo <strong>Alla riga</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10272901381233082.4504)
,p_name=>'P27_TO_LINE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(163544124488204308.4504)
,p_prompt=>'Alla riga'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Per limitare la ricerca a un intervallo di numeri di riga degli oggetti PL/SQL, immettere il numero della riga finale da includere nella ricerca e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(163539403139131919.4504)
,p_name=>'P27_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(163544124488204308.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(276406030441418929.4504)
,p_computation_sequence=>10
,p_computation_item=>'P27_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema;'
,p_compute_when=>'P27_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69230410388689297.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P27_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Convalida schema'
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_api.create_page(
 p_id=>28.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Modifica griglia del dizionario attributi'
,p_step_title=>'Modifica griglia del dizionario attributi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(262134402124898913.4504)
,p_name=>'Grid Edit of Attribute Dictionary'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COLUMN_ID,',
'       COLUMN_NAME,',
'       LABEL,',
'       HELP_TEXT,',
'       FORMAT_MASK,',
'       DEFAULT_VALUE',
'  from WWV_FLOW_HNT_COLUMN_DICT',
' where security_group_id = :flow_security_group_id',
'   and (instr(column_name,upper(:P28_COLUMN_QUERY)) > 0 or',
'        :P28_COLUMN_QUERY is null)'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>20
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262134725222898919.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'COLUMN_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262134823360898920.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome colonna'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>30
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'COLUMN_NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262134932029898920.4504)
,p_query_column_id=>3
,p_column_alias=>'LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Etichetta'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>15
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'LABEL'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262135001507898920.4504)
,p_query_column_id=>4
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Testo Guida'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>30
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'HELP_TEXT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262135132608898920.4504)
,p_query_column_id=>5
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>6
,p_column_heading=>'Formato di visualizzazione'
,p_heading_alignment=>'LEFT'
,p_display_as=>'POPUP'
,p_named_lov=>wwv_flow_api.id(197481124765787930)
,p_lov_show_nulls=>'NO'
,p_column_width=>15
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'FORMAT_MASK'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262135207815898920.4504)
,p_query_column_id=>6
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>7
,p_column_heading=>'Valore predefinito'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>10
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'DEFAULT_VALUE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(628568620310013555.4504)
,p_query_column_id=>7
,p_column_alias=>'LINK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_column_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:P17_COLUMN_ID,F4500_LAST_VIEW:#COLUMN_ID#,28'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="">'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_derived_column=>'Y'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(262141417301940636.4504)
,p_column_sequence=>1
,p_query_column_name=>'COLUMN_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(262141507017940641.4504)
,p_column_sequence=>2
,p_query_column_name=>'COLUMN_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(262141605371940641.4504)
,p_column_sequence=>3
,p_query_column_name=>'LABEL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(262141729127940641.4504)
,p_column_sequence=>4
,p_query_column_name=>'HELP_TEXT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(262141805621940641.4504)
,p_column_sequence=>5
,p_query_column_name=>'FORMAT_MASK'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(262141907022940641.4504)
,p_column_sequence=>6
,p_query_column_name=>'DEFAULT_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(262137418855903221.4504)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(262138925219914472.4504)
,p_plug_name=>'Modifica griglia'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>25
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>\00C8 possibile soltanto modificare gli attributi generali di una colonna. Per aggiornare gli attributi specifici di un form o di un report, occorre modificare la colonna direttamente.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(262145005012974917.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(262137418855903221.4504)
,p_button_name=>'P28_GO'
,p_button_static_id=>'P28_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(262135320808898922.4504)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(262137418855903221.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(262148929515000904.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(262137418855903221.4504)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RP,28::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(262135417041898922.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(262137418855903221.4504)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(262136116677898928.4504)
,p_branch_action=>'f?p=&APP_ID.:28:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262143517217959511.4504)
,p_name=>'P28_COLUMN_QUERY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(262137418855903221.4504)
,p_prompt=>'Nome colonna'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Immettere criteri di ricerca senza distinzione tra maiuscole e minuscole per il nome della colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(262135932386898924.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(262134402124898913.4504)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_03=>'COLUMN_ID'
,p_process_error_message=>'Impossibile elaborare l''aggiornamento.'
,p_process_when_button_id=>wwv_flow_api.id(262135417041898922.4504)
,p_process_success_message=>'#MRU_COUNT# riga/e aggiornata/e, #MRI_COUNT# riga/e inserita/e.'
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_api.create_page(
 p_id=>29.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Genera DDL'
,p_page_mode=>'MODAL'
,p_step_title=>'Genera DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215532403383713875)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(82336717613137775.4504)
,p_plug_name=>'Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_num_rows=>1000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fielddata">Nessun oggetto trovato.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(87151528579582262.4504)
,p_plug_name=>'Navigazione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208285310117555084.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(87134126220568115.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208322925662624972.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(946327948158664045.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208322925662624972.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(82681018106461976.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208322925662624972.4504)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87105209651530215.4504)
,p_name=>'F4500_P18_DDL_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(82336717613137775.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87217505239653834.4504)
,p_name=>'F4500_P18_DDL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(82336717613137775.4504)
,p_prompt=>'DDL generato'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_help_text=>'Identifica l''istruzione SQL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv ( p_schema => :F4500_P18_SCHEMA );',
'',
'if :F4500_P18_DDL_TYPE = ''OBJECT_TYPE'' then',
'   wwv_flow_generate_ddl.execute_get_ddl(',
'           p_schema       => :F4500_P18_SCHEMA,',
'           p_object_types => :F4500_P18_OBJECT_TYPE,',
'           p_output_type  => ''DISPLAY'');',
'elsif :F4500_P18_DDL_TYPE = ''OBJECT_NAME'' then',
'   wwv_flow_generate_ddl.execute_get_ddl(',
'         p_schema => :F4500_P18_SCHEMA,',
'         p_object_types => :F4500_P18_OBJECT_TYPE,',
'         p_objects => :F4500_P18_OBJECT_NAME,',
'         p_output_type => ''DISPLAY'');',
'end if;'))
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(946328199192666145.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(946327948158664045.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(946328409674666146.4504)
,p_event_id=>wwv_flow_api.id(946328199192666145.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_api.create_page(
 p_id=>30.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Sinonimo attributo colonna'
,p_page_mode=>'MODAL'
,p_step_title=>'Sinonimo attributo colonna'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200278631019645978.4504)
,p_plug_name=>'Sinonimo attributo colonna'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1019615273077762321.4504)
,p_plug_name=>'button region'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200279126469645983.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1019615273077762321.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200278818960645982.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1019615273077762321.4504)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'CREATE'
,p_button_condition=>'P30_SYN_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200279030745645982.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1019615273077762321.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P30_SYN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200278916710645982.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1019615273077762321.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'EDIT'
,p_button_condition=>'P30_SYN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200279929766645986.4504)
,p_branch_action=>'f?p=&APP_ID.:17:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200280111389645987.4504)
,p_name=>'P30_SYN_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(200278631019645978.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'SYN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200280308834646002.4504)
,p_name=>'P30_SYN_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(200278631019645978.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sinonimo'
,p_source=>'SYN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Sinonimo della colonna di base.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200445632275152368.4504)
,p_name=>'P30_COLUMN_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(200278631019645978.4504)
,p_prompt=>'Nome colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Colonna di base.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200445910935155668.4504)
,p_name=>'P30_COLUMN_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(200278631019645978.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P17_COLUMN_ID.'
,p_source=>'COLUMN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200447126912188700.4504)
,p_validation_name=>'P30_SYN_NAME UNIQUE'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_col_dict_syn',
' where syn_name = upper(:P30_SYN_NAME)',
'   and syn_id  != nvl(:P30_SYN_ID,0)',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Questo nome esiste gi\00E0 come colonna o sinonimo di una colonna.')
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(200280308834646002.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1019616406385773800.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(200279126469645983.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1019616791204773802.4504)
,p_event_id=>wwv_flow_api.id(1019616406385773800.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(200280525520646005.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_COL_DICT_SYN'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COL_DICT_SYN'
,p_attribute_03=>'P30_SYN_ID'
,p_attribute_04=>'SYN_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossibile recuperare la riga.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(200449613284251025.4504)
,p_process_sequence=>50
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Column Name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select column_name',
'     from wwv_flow_hnt_column_dict',
'    where column_id = :P30_COLUMN_ID )',
'loop',
'   :P30_COLUMN_NAME := c1.column_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Caricamento del nome colonna non riuscito.'
,p_process_when=>'P30_COLUMN_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(200280709877646006.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_COL_DICT_SYN'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COL_DICT_SYN'
,p_attribute_03=>'P30_SYN_ID'
,p_attribute_04=>'SYN_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Impossibile elaborare la riga della tabella WWV_FLOW_HNT_COL_DICT_SYN.'
,p_process_success_message=>'Azione elaborata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(200280928125646007.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'30'
,p_process_when_button_id=>wwv_flow_api.id(200279030745645982.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1019616973406776824.4504)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'close dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Azione elaborata.'
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_api.create_page(
 p_id=>31.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Quota script'
,p_page_mode=>'MODAL'
,p_step_title=>'Quota script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_height=>'430'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_quotas.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150029301997796011.4504)
,p_plug_name=>'Quota dei risultati in byte'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164592024753268295.4504)
,p_plug_name=>'Quota script in byte'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755298110427836847.4504)
,p_plug_name=>'Pulsanti procedura guidata'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(150929922265552010.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(755298110427836847.4504)
,p_button_name=>'OK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Chiudi'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150030705591806521.4504)
,p_name=>'P31_SCRIPT_QUOTA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(150029301997796011.4504)
,p_prompt=>'Dimensione massima risultati di script:'
,p_source=>'to_char(nvl(to_number(wwv_flow_platform.get_preference(''SQL_SCRIPT_MAX_OUTPUT_SIZE'')),2000000),''999G999G999G999G999'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la dimensione massima consentita per un singolo risultato dello script. Questa quota \00E8 stabilita da un amministratore e non pu\00F2 essere modificata all''interno dello spazio di lavoro. Quando viene raggiunta la dimensione massima consentita p')
||unistr('er un singolo risultato dello script, qualsiasi script in esecuzione verr\00E0 annullato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150032513210808776.4504)
,p_name=>'P31_TOTAL_QUOTA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(150029301997796011.4504)
,p_prompt=>'Quota per tutti i risultati di script:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la quantit\00E0 di spazio allocato per i risultati dello script. Questa quota \00E8 stabilita da un amministratore e non pu\00F2 essere modificata all''interno dello spazio di lavoro. Quando viene raggiunta la quota per tutti i risultati degli script, ')
||unistr('qualsiasi script in esecuzione verr\00E0 annullato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150033722214811335.4504)
,p_name=>'P31_FREE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(150029301997796011.4504)
,p_prompt=>'Libero:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica lo spazio disponibile nell''area di lavoro per la generazione dei risultati degli script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150034629833813503.4504)
,p_name=>'P31_AVAILABLE_SPACE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(150029301997796011.4504)
,p_prompt=>'Quota:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identifica la percentuale della quota per i risultati degli script attualmente utilizzata nell''area di lavoro.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150040021091829941.4504)
,p_name=>'P31_USED'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(150029301997796011.4504)
,p_prompt=>'Utilizzata'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica la dimensione dei risultati degli script attualmente utilizzata nell''area di lavoro.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164592806529272486.4504)
,p_name=>'P31_SCRIPT_MAX_SIZE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(164592024753268295.4504)
,p_prompt=>'Dimensione massima script:'
,p_source=>'to_char(nvl(to_number(wwv_flow_platform.get_preference(''MAX_SCRIPT_SIZE'')),2000000),''999G999G999G999G999'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la dimensione massima consentita per un singolo script. Questa quota \00E8 stabilita da un amministratore e non pu\00F2 essere modificata all''interno dell''area di lavoro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(755298281503836848.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(150929922265552010.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(755298318870836849.4504)
,p_event_id=>wwv_flow_api.id(755298281503836848.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(150010615148724106.4504)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Space Info at Bottom'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_max_output_size   number := 0;',
'    l_used              number := 0;',
'    l_free              number := 0;',
'begin',
'    l_max_output_size := nvl(wwv_flow_platform.get_preference(''WORKSPACE_MAX_OUTPUT_SIZE''),10000000);',
'    for c1 in (select sum(result_size) the_sum',
'                 from wwv_flow_sw_detail_results',
'                where security_group_id = :flow_security_group_id)',
'    loop',
'        l_used := nvl(c1.the_sum,0);',
'        exit;',
'    end loop;--c1',
'    ',
'    l_free := nvl(l_max_output_size - l_used,0);',
'    if sign(l_free) = -1 then',
'        l_free := 0;',
'    end if;',
'    ',
'    ',
'    ',
'    ',
'    :P31_FREE := to_char(l_free,''999G999G999G999G999'');',
'    :P31_USED := to_char(l_used,''999G999G999G999G999'');',
'    ',
'    :P31_TOTAL_QUOTA := to_char(l_max_output_size,''999G999G999G999G999'');',
'    ',
'    :P31_AVAILABLE_SPACE := wwv_flow_sw_script.draw_quotameter2(',
'                                   p_max_size       => l_max_output_size,',
'                                   p_current_size   => l_used);',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00032
begin
wwv_flow_api.create_page(
 p_id=>32.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Esegui migrazione dei valori predefiniti interfaccia utente'
,p_step_title=>'Esegui migrazione dei valori predefiniti interfaccia utente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201465610401357811.4504)
,p_plug_name=>'Esegui migrazione dei valori predefiniti interfaccia utente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_id,',
'       table_name',
'  from wwv_flow_hnt_table_info',
' where schema = :P32_SCHEMA'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(201465725331357811.4504)
,p_name=>'Migrate User Interface Defaults'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201465928362357816.4504)
,p_db_column_name=>'TABLE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID tabella'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201466128857357818.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nome oggetto'
,p_column_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:33:P33_TABLE_ID:#TABLE_ID#'
,p_column_linktext=>'#TABLE_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201473024959465101.4504)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206022131398886554.4504)
,p_plug_name=>'Migrazione'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quando si esegue la migrazione dei valori predefiniti di una tabella selezionata, nel dizionario attributi vengono create colonne per ogni colonna che non esiste gi\00E0. Se vengono rilevati conflitti, saranno visualizzati prima della migrazione, al f')
||'ine di decidere se proseguire o meno.<p/>',
'',
unistr('<p>Durante il processo di migrazione, valori predefiniti di una tabella selezionata vengono rimossi poich\00E9, se i processi utilizzano valori predefiniti di interfaccia utente, cercano prima i valori predefiniti specifici della tabella e li utilizzano ')
||'prima di utilizzare il dizionario attributi.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201473216439465161.4504)
,p_name=>'P32_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(201473024959465101.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select /* APEX4500L1 */ wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1003_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1003_SCHEMA) a,:P1003_SCHEMA b from dual '';',
'  q:=q||''where  :P1003_POPUP = 1 '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432752318680991651.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P32_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_api.create_page(
 p_id=>33.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma migrazione dei valori predefiniti interfaccia utente'
,p_step_title=>'Conferma migrazione dei valori predefiniti interfaccia utente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24163417493414861.4504)
,p_plug_name=>'Nessuna colonna in cui eseguire la migrazione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>30
,p_plug_new_grid_column=>false
,p_plug_source=>unistr('Tutte le colonne di questa tabella esistono gi\00E0 nel dizionario attributi. Non vi \00E8 nulla da migrare.')
,p_plug_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P33_CONFLICT_CNT'
,p_plug_display_when_cond2=>'&P33_COL_CNT.'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(201470011706404498.4504)
,p_name=>'Conflitti'
,p_template=>wwv_flow_api.id(717419707883820782.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name',
'  from wwv_flow_hnt_column_info',
' where table_id = :P33_TABLE_ID',
'   and column_name in (',
'       select syn_name',
'         from wwv_flow_hnt_col_dict_syn ',
'        where security_group_id = :flow_security_group_id)'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P33_CONFLICT_CNT != 0 and ',
':P33_CONFLICT_CNT != :P33_COL_CNT'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_header=>unistr('Le colonne riportate di seguito esistono gi\00E0 nel dizionario attributi come colonne o sinonimi. Se si continua, non verr\00E0 eseguita la migrazione di queste colonne.<p/>')
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'nessun dato trovato'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201470316057404505.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201471826167427615.4504)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>5
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201475120897520662.4504)
,p_plug_name=>'Nessun conflitto'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_source=>'Nessun conflitto trovato.'
,p_plug_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_ZERO'
,p_plug_display_when_condition=>'P33_CONFLICT_CNT'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1019605934752642469.4504)
,p_plug_name=>'Conflitti'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(206019507026870044.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201471826167427615.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:33::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(206018822432836649.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(201471826167427615.4504)
,p_button_name=>'MIGRATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esegui migrazione'
,p_button_position=>'CREATE'
,p_button_condition=>'P33_CONFLICT_CNT'
,p_button_condition2=>'&P33_COL_CNT.'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(206019020743836651.4504)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(206018822432836649.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24162923465397638.4504)
,p_name=>'P33_COL_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(201471826167427615.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201471618202425322.4504)
,p_name=>'P33_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(201470011706404498.4504)
,p_prompt=>'Tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_id r',
'  from wwv_flow_hnt_table_info'))
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201474527692513167.4504)
,p_name=>'P33_CONFLICT_CNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(201471826167427615.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(24162612467375600.4504)
,p_computation_sequence=>10
,p_computation_item=>'P33_CONFLICT_CNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_hnt_column_info',
' where table_id = :P33_TABLE_ID',
'   and column_name in (',
'       select syn_name',
'         from wwv_flow_hnt_col_dict_syn ',
'        where security_group_id = :flow_security_group_id)'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(24163027274398784.4504)
,p_computation_sequence=>20
,p_computation_item=>'P33_COL_CNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_hnt_column_info',
' where table_id = :P33_TABLE_ID'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(206019323602846417.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'migrate'
,p_process_sql_clob=>'wwv_flow_hint.migrate(:P33_TABLE_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Migrazione dei valori predefiniti dell''interfaccia utente non riuscita.'
,p_process_when_button_id=>wwv_flow_api.id(206018822432836649.4504)
,p_process_success_message=>'Migrazione dei valori predefiniti dell''interfaccia utente nel dizionario attributi riuscita.'
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_api.create_page(
 p_id=>34.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Operazioni di lunga durata'
,p_step_title=>'Operazioni di lunga durata'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_long_opr.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467808909208767996.4504)
,p_plug_name=>'Operazioni di lunga durata'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.SID, l.inst_id, l.SERIAL#,s.username,s.module,s.action,s.client_info,',
'       l.OPNAME, l.TARGET, l.TARGET_DESC, l.SOFAR, l.TOTALWORK, l.UNITS, ',
'       l.START_TIME, l.LAST_UPDATE_TIME, round((l.TIME_REMAINING/60),2) TIME_REMAINING, round((l.ELAPSED_SECONDS/60),2) ELAPSED_SECONDS, l.CONTEXT, ',
'       l.MESSAGE,       ',
'       ROUND(l.sofar/l.totalwork*100, 2) pct_complete',
'  from sys.gv_$session_longops l,sys.gv_$session s',
' where l.sid = s.sid',
'   and l.time_remaining > 0',
'   and l.inst_id = s.inst_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(467809024892767996.4504)
,p_name=>'Long Operations'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467809228777768042.4504)
,p_db_column_name=>'SID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'SID'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID:#SID#'
,p_column_linktext=>'#SID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467809332252768048.4504)
,p_db_column_name=>'SERIAL#'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'N. di serie'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467809516758768050.4504)
,p_db_column_name=>'MODULE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Modulo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467809604912768051.4504)
,p_db_column_name=>'ACTION'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Azione'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467809715440768051.4504)
,p_db_column_name=>'CLIENT_INFO'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Informazioni client'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467809807576768052.4504)
,p_db_column_name=>'OPNAME'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Operazione'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467809920217768053.4504)
,p_db_column_name=>'TARGET'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Destinazione'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810032385768054.4504)
,p_db_column_name=>'TARGET_DESC'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Descrizione destinazione'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810127974768055.4504)
,p_db_column_name=>'SOFAR'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Unit<br />correnti'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810210590768056.4504)
,p_db_column_name=>'TOTALWORK'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Unit<br />totali'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810327085768057.4504)
,p_db_column_name=>'UNITS'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Descrizione<br />unit'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810424613768058.4504)
,p_db_column_name=>'START_TIME'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Ora di inizio'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810517935768059.4504)
,p_db_column_name=>'LAST_UPDATE_TIME'
,p_display_order=>13
,p_column_identifier=>'N'
,p_column_label=>'Ora<br />ultimo<br />aggiornamento'
,p_column_type=>'DATE'
,p_format_mask=>'&TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810611827768060.4504)
,p_db_column_name=>'TIME_REMAINING'
,p_display_order=>14
,p_column_identifier=>'O'
,p_column_label=>'Minuti<br />rimanenti'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810717372768061.4504)
,p_db_column_name=>'ELAPSED_SECONDS'
,p_display_order=>15
,p_column_identifier=>'P'
,p_column_label=>'Minuti<br />trascorsi'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810805999768062.4504)
,p_db_column_name=>'CONTEXT'
,p_display_order=>16
,p_column_identifier=>'Q'
,p_column_label=>'Contesto'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467811024642768064.4504)
,p_db_column_name=>'PCT_COMPLETE'
,p_display_order=>17
,p_column_identifier=>'S'
,p_column_label=>'Percentuale di<br /> completamento'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467810931079768063.4504)
,p_db_column_name=>'MESSAGE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Messaggio'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467809409633768049.4504)
,p_db_column_name=>'USERNAME'
,p_display_order=>20
,p_column_identifier=>'C'
,p_column_label=>'Nome utente'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(19254413497333493.4504)
,p_db_column_name=>'INST_ID'
,p_display_order=>21
,p_column_identifier=>'T'
,p_column_label=>'ID istanza'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
end;
/
prompt --application/pages/page_00035
begin
wwv_flow_api.create_page(
 p_id=>35.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Periodo di tempo di report nella home page'
,p_page_mode=>'MODAL'
,p_step_title=>'Periodo di tempo di report nella home page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_height=>'240'
,p_dialog_width=>'730'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203665619718012552.4504)
,p_plug_name=>'Periodo di tempo di report nella home page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(280297113969526814.4504)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203673112500085352.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(280297113969526814.4504)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203672909684085351.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(280297113969526814.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203674027477099952.4504)
,p_branch_name=>'Go To Page &F4500_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203666828123071751.4504)
,p_name=>'P35_TIMEFRAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(203665619718012552.4504)
,p_prompt=>'Periodo di tempo di report'
,p_source=>'select nvl(:P1000_TIMEFRAME,3600) from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P35_TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, to_char(t) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5*60 t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15*60 t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 3600 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 2*3600  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3*3600  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4*3600  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6*3600 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8*3600 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12*3600 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 18*3600 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1*24*60*60 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2*24*60*60 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3*24*60*60 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4*24*60*60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5*24*60*60 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 6*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7*24*60*60 t  from dual',
') q'))
,p_cHeight=>1
,p_grid_column=>3
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Impostare il periodo di tempo per vincolare le query di monitoraggio visualizzate nella home page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(280297214584526815.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(203672909684085351.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(280297365118526816.4504)
,p_event_id=>wwv_flow_api.id(280297214584526815.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203673719166097547.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set timeframe'
,p_process_sql_clob=>':P1000_TIMEFRAME := :P35_TIMEFRAME;'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(203673112500085352.4504)
);
end;
/
prompt --application/pages/page_00036
begin
wwv_flow_api.create_page(
 p_id=>36.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Informazioni sul database'
,p_step_title=>'Informazioni sul database'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(690783120585803188.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_db_detail.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(996831560382082.4504)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5632008088794443.4504)
,p_name=>'Parametri'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,value param_val,ISDEFAULT,',
'       DESCRIPTION',
'  from v$parameter',
' where /* lower(name) like ''%''||lower(:P555_SEARCH)||''%''',
'   and (:P555_SHOW = ''ALL''',
'        or',
'          (:P555_SHOW = ''CUSTOM'' and isdefault = ''FALSE'')) ',
'   and */ substr(name,1,2) != ''__''',
'order by name'))
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':PARAMETER:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5632302474794468.4504)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301369692088065005.4504)
,p_query_column_id=>2
,p_column_alias=>'PARAM_VAL'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5632509538794469.4504)
,p_query_column_id=>3
,p_column_alias=>'ISDEFAULT'
,p_column_display_sequence=>3
,p_column_heading=>'Is&nbsp;Predefinito'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5632627784794469.4504)
,p_query_column_id=>4
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>4
,p_column_heading=>'Descrizione'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(172512209864041595.4504)
,p_name=>'Database'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME,',
'       CREATED,',
'       RESETLOGS_TIME,',
'       PRIOR_RESETLOGS_CHANGE#,',
'       PRIOR_RESETLOGS_TIME,',
'       LOG_MODE,',
'       CHECKPOINT_CHANGE#,',
'       ARCHIVE_CHANGE#,',
'       OPEN_RESETLOGS,',
'       VERSION_TIME,',
'       OPEN_MODE,',
'       PROTECTION_MODE,',
'       PROTECTION_LEVEL,',
'       REMOTE_ARCHIVE,',
'       DATABASE_ROLE,',
'       ARCHIVELOG_CHANGE#,',
'       SWITCHOVER_STATUS,',
'       DATAGUARD_BROKER,',
'       GUARD_STATUS,',
'       FORCE_LOGGING',
'  from v$database'))
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':DATABASE:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172512609361041599.4504)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'NAME'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172512705827041599.4504)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>2
,p_column_heading=>'CREATED'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172512902493041599.4504)
,p_query_column_id=>3
,p_column_alias=>'RESETLOGS_TIME'
,p_column_display_sequence=>3
,p_column_heading=>'RESETLOGS_TIME'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172513026750041599.4504)
,p_query_column_id=>4
,p_column_alias=>'PRIOR_RESETLOGS_CHANGE#'
,p_column_display_sequence=>4
,p_column_heading=>'PRIOR_RESETLOGS_CHANGE#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172513100737041600.4504)
,p_query_column_id=>5
,p_column_alias=>'PRIOR_RESETLOGS_TIME'
,p_column_display_sequence=>5
,p_column_heading=>'PRIOR_RESETLOGS_TIME'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172513201718041600.4504)
,p_query_column_id=>6
,p_column_alias=>'LOG_MODE'
,p_column_display_sequence=>6
,p_column_heading=>'LOG_MODE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172513328511041600.4504)
,p_query_column_id=>7
,p_column_alias=>'CHECKPOINT_CHANGE#'
,p_column_display_sequence=>7
,p_column_heading=>'CHECKPOINT_CHANGE#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172513400321041600.4504)
,p_query_column_id=>8
,p_column_alias=>'ARCHIVE_CHANGE#'
,p_column_display_sequence=>8
,p_column_heading=>'ARCHIVE_CHANGE#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172514000103041600.4504)
,p_query_column_id=>9
,p_column_alias=>'OPEN_RESETLOGS'
,p_column_display_sequence=>9
,p_column_heading=>'OPEN_RESETLOGS'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172514118014041601.4504)
,p_query_column_id=>10
,p_column_alias=>'VERSION_TIME'
,p_column_display_sequence=>10
,p_column_heading=>'VERSION_TIME'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172514200823041601.4504)
,p_query_column_id=>11
,p_column_alias=>'OPEN_MODE'
,p_column_display_sequence=>11
,p_column_heading=>'OPEN_MODE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172514331382041601.4504)
,p_query_column_id=>12
,p_column_alias=>'PROTECTION_MODE'
,p_column_display_sequence=>12
,p_column_heading=>'PROTECTION_MODE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172514405190041601.4504)
,p_query_column_id=>13
,p_column_alias=>'PROTECTION_LEVEL'
,p_column_display_sequence=>13
,p_column_heading=>'PROTECTION_LEVEL'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172514514003041601.4504)
,p_query_column_id=>14
,p_column_alias=>'REMOTE_ARCHIVE'
,p_column_display_sequence=>14
,p_column_heading=>'REMOTE_ARCHIVE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172514819520041601.4504)
,p_query_column_id=>15
,p_column_alias=>'DATABASE_ROLE'
,p_column_display_sequence=>15
,p_column_heading=>'DATABASE_ROLE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172514915226041602.4504)
,p_query_column_id=>16
,p_column_alias=>'ARCHIVELOG_CHANGE#'
,p_column_display_sequence=>16
,p_column_heading=>'ARCHIVELOG_CHANGE#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172515117807041602.4504)
,p_query_column_id=>17
,p_column_alias=>'SWITCHOVER_STATUS'
,p_column_display_sequence=>17
,p_column_heading=>'SWITCHOVER_STATUS'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172515226718041602.4504)
,p_query_column_id=>18
,p_column_alias=>'DATAGUARD_BROKER'
,p_column_display_sequence=>18
,p_column_heading=>'DATAGUARD_BROKER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172515313032041602.4504)
,p_query_column_id=>19
,p_column_alias=>'GUARD_STATUS'
,p_column_display_sequence=>19
,p_column_heading=>'GUARD_STATUS'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172515713476041603.4504)
,p_query_column_id=>20
,p_column_alias=>'FORCE_LOGGING'
,p_column_display_sequence=>20
,p_column_heading=>'FORCE_LOGGING'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(172673725969331492.4504)
,p_name=>'Versione'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>7
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select banner from v$version'
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':VERSION:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_footer=>'<p />'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172673910997331494.4504)
,p_query_column_id=>1
,p_column_alias=>'BANNER'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(172675002205334076.4504)
,p_name=>'Opzioni'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select * from v$option'
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':OPTIONS:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172675205390334077.4504)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172675332169334078.4504)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(172752728356379421.4504)
,p_name=>'National Language Support'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select * from v$nls_parameters order by 1'
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':NLS:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172752905784379422.4504)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro NLS'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172753010951379422.4504)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(172789621476405877.4504)
,p_plug_name=>'Ambiente CGI'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.print_cgi_env',
' (p_html_table_attr=>''class="u-Report" role="presentation" cellpadding="0" cellspacing="0" border="0"'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':CGI:'') > 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1001305952526018.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(996831560382082.4504)
,p_button_name=>'P36_GO'
,p_button_static_id=>'P36_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186757815719295477.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(996831560382082.4504)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:RP,36::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1001509298526032.4504)
,p_branch_action=>'f?p=&FLOW_ID.:36:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1000529716523424.4504)
,p_name=>'P36_DISPLAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(996831560382082.4504)
,p_item_default=>'VERSION'
,p_prompt=>'Visualizza'
,p_source=>'VERSION'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P36_DISPLAY_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(998111353442494.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'7'
,p_attribute_02=>'HORIZONTAL'
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_api.create_page(
 p_id=>37.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Lista di valori statica'
,p_step_title=>'Lista di valori statica'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(293409423986016572.4504)
,p_name=>'Form tabulare'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       COLUMN_ID,',
'       LOV_DISP_SEQUENCE,',
'       LOV_DISP_VALUE,',
'       LOV_RETURN_VALUE',
'  from WWV_FLOW_HNT_LOV_DATA',
' where column_id = :P37_COLUMN_ID',
''))
,p_display_when_condition=>'P803_LOV_QUERY'
,p_display_condition_type=>'ITEM_IS_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(293411632557016588.4504)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(293409717273016579.4504)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(293417105871069157.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_column_default=>'P37_COLUMN_ID'
,p_column_default_type=>'ITEM'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'COLUMN_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(293409807959016579.4504)
,p_query_column_id=>4
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Sequenza'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>5
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'LOV_DISP_SEQUENCE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(293409901347016579.4504)
,p_query_column_id=>5
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>4
,p_column_heading=>'Valore visualizzato'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>32
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'LOV_DISP_VALUE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(293410024985016580.4504)
,p_query_column_id=>6
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Valore restituito'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>32
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'LOV_RETURN_VALUE'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(293416627450069149.4504)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(293416700260069150.4504)
,p_column_sequence=>2
,p_query_column_name=>'COLUMN_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(293416830439069150.4504)
,p_column_sequence=>3
,p_query_column_name=>'LOV_DISP_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(293416924320069154.4504)
,p_column_sequence=>4
,p_query_column_name=>'LOV_DISP_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(293417027781069154.4504)
,p_column_sequence=>5
,p_query_column_name=>'LOV_RETURN_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(293412819869019599.4504)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(293414632121032622.4504)
,p_plug_name=>'Liste di valori statiche'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>25
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Se si crea un form, un report o un form tabulare che comprende questa colonna e se il tipo appropriato di visualizzazione \00E8 impostato in modo da utilizzare una lista di valori (Gruppo pulsanti di scelta o Lista di selezione), la lista di valori de')
||unistr('nominata verr\00E0 creata all''interno dell''applicazione e ad essa far\00E0 riferimento l''elemento o la colonna di report risultante.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(424181607280659513.4504)
,p_plug_name=>'Avvertenza'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>12
,p_plug_source=>'Rimuovere la query di lista di valori prima di definire una lista di valori statica.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P803_LOV_QUERY'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1018745812043609207.4504)
,p_plug_name=>'Modifica lista di valori statica'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293410423423016582.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(293409423986016572.4504)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Aggiungi riga'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'javascript:apex.widget.tabular.addRow();'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293410101662016582.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(293412819869019599.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293410205641016582.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(293412819869019599.4504)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293410327093016582.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(293412819869019599.4504)
,p_button_name=>'MULTI_ROW_DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''MULTI_ROW_DELETE'');'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(293412104986016589.4504)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293415132383051672.4504)
,p_name=>'P37_TABLE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(293409423986016572.4504)
,p_prompt=>'Tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_id r',
'  from WWV_FLOW_HNT_TABLE_INFO '))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293415310697054883.4504)
,p_name=>'P37_COLUMN_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(293409423986016572.4504)
,p_prompt=>'Nome colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_id r',
'  from WWV_FLOW_HNT_COLUMN_INFO'))
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'la colonna attualmente selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(424086824998418734.4504)
,p_validation_name=>'SequenceMand'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_null varchar2(1) := ''N'';',
'begin',
'for i in 1..wwv_flow.g_f05.count loop',
'    if wwv_flow.g_f03(i) is null',
'       then l_null := ''Y'';',
'            exit;',
'    end if;',
'end loop;',
'',
'if l_null = ''Y''',
'   then return false;',
'else ',
'   return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Specificare la sequenza.'
,p_when_button_pressed=>wwv_flow_api.id(293410205641016582.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(424102231578420636.4504)
,p_validation_name=>'SequenceNumeric'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_check varchar2(200);',
'   l_ones  varchar2(200);',
'   l_found varchar2(1) := ''N'';',
'   ',
'begin',
'for i in 1..wwv_flow.g_f05.count',
'loop',
'   if wwv_flow.g_f03(i) is not null',
'      then l_check := wwv_flow.g_f03(i);',
'           l_check := replace(l_check,''0'',''1'');',
'           l_check := replace(l_check,''2'',''1'');',
'           l_check := replace(l_check,''3'',''1'');',
'           l_check := replace(l_check,''4'',''1'');',
'           l_check := replace(l_check,''5'',''1'');',
'           l_check := replace(l_check,''6'',''1'');',
'           l_check := replace(l_check,''7'',''1'');',
'           l_check := replace(l_check,''8'',''1'');',
'           l_check := replace(l_check,''9'',''1'');',
'           l_ones := ''1'';',
'           if l_check = lpad(l_ones,length(l_check),''1'')',
'              then null;',
'           else l_found := ''Y'';',
'                exit;',
'           end if;',
'   end if;',
'end loop;',
'',
'if l_found = ''Y''',
'   then return false;',
'else',
'   return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'La sequenza deve essere numerica.'
,p_when_button_pressed=>wwv_flow_api.id(293410205641016582.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(424102404697422319.4504)
,p_validation_name=>'DisplayMand'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_null varchar2(1) := ''N'';',
'begin',
'for i in 1..wwv_flow.g_f05.count loop',
'    if wwv_flow.g_f04(i) is null',
'       then l_null := ''Y'';',
'            exit;',
'    end if;',
'end loop;',
'',
'if l_null = ''Y''',
'   then return false;',
'else ',
'   return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Specificare un valore per Valore visualizzato.'
,p_when_button_pressed=>wwv_flow_api.id(293410205641016582.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293411213001016585.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(293409423986016572.4504)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_HNT_LOV_DATA'
,p_attribute_03=>'ID'
,p_process_error_message=>'Impossibile elaborare l''aggiornamento.'
,p_process_when_button_id=>wwv_flow_api.id(293410205641016582.4504)
,p_process_success_message=>'#MRU_COUNT# riga/e aggiornata/e, #MRI_COUNT# riga/e inserita/e.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293411416934016586.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(293409423986016572.4504)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'ApplyMRD'
,p_attribute_02=>'WWV_FLOW_HNT_LOV_DATA'
,p_attribute_03=>'ID'
,p_process_error_message=>'Impossibile elaborare l''eliminazione.'
,p_process_when=>'MULTI_ROW_DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'#MRD_COUNT# riga/e eliminata/e.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293411729613016588.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(293409423986016572.4504)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_HNT_LOV_DATA'
,p_attribute_03=>'ID'
,p_process_error_message=>'Impossibile elaborare l''aggiornamento.'
,p_process_when_button_id=>wwv_flow_api.id(293410423423016582.4504)
,p_process_success_message=>'#MRU_COUNT# riga/e aggiornata/e, #MRI_COUNT# riga/e inserita/e.'
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_api.create_page(
 p_id=>38.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Query Builder - SQL salvato'
,p_alias=>'QB_SQL_TAB'
,p_step_title=>'Query salvate'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_step_template=>wwv_flow_api.id(14599108081253832.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/qry_blr_save.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159939829413099962.4504)
,p_plug_name=>'Find Criteria'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(159940232617099966.4504)
,p_name=>'Saved Queries'
,p_template=>wwv_flow_api.id(12270828624874231.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   ID,',
'  initcap(substr(title,1,50)) title,',
'  last_updated_on Updated,',
'  created_by,',
'  last_UPDATED_BY,',
'  description,',
'  QUERY_OWNER schema',
'from wwv_flow_qb_saved_query',
'where security_group_id = :flow_security_group_id',
'and (:p38_find is null or instr( upper(title) ,upper(:p38_find) ) > 0 )',
'and (:p38_owner = ''0'' or created_by = :p38_owner)',
'and query_type = ''W''',
'and (created_by = :APP_USER or',
'exists (',
'select 1',
'from  wwv_flow_developers',
'where security_group_id = :flow_security_group_id and',
'userid = :APP_USER and',
'instr(developer_role||'':'',''ADMIN:'') > 0',
'union',
'select 1',
'from wwv_flow_fnd_user',
'where security_group_id = :FLOW_SECURITY_GROUP_ID',
'and user_name = :APP_USER',
'and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))'))
,p_display_when_condition=>'P38_VIEW'
,p_display_when_cond2=>'DETAIL'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(2251716882439710.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessuna istruzione SQL salvata trovata'
,p_query_num_rows_item=>'P38_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159959511942138966.4504)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Elimina'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160113424849394443.4504)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159940904414099968.4504)
,p_query_column_id=>3
,p_column_alias=>'TITLE'
,p_column_display_sequence=>4
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1002:&SESSION.:LOAD:&DEBUG.::P1002_QUERY_ID,P1002_SCHEMA:#ID#,#SCHEMA#'
,p_column_linktext=>'#TITLE#'
,p_default_sort_column_sequence=>2
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159941115102099968.4504)
,p_query_column_id=>4
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>7
,p_column_heading=>'Aggiornato'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_default_sort_column_sequence=>1
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160107426993376207.4504)
,p_query_column_id=>5
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>3
,p_column_heading=>'Proprietario'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159941312755099969.4504)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>6
,p_column_heading=>'Autore aggiornamento'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159941419384099969.4504)
,p_query_column_id=>7
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>5
,p_column_heading=>'Descrizione'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160115520166404770.4504)
,p_query_column_id=>8
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>8
,p_column_heading=>'Schema'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(160112712017394439.4504)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159956320301128242.4504)
,p_column_sequence=>2
,p_query_column_name=>'TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159956508083128243.4504)
,p_column_sequence=>3
,p_query_column_name=>'UPDATED'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(160107017342376203.4504)
,p_column_sequence=>4
,p_query_column_name=>'CREATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159956717081128243.4504)
,p_column_sequence=>5
,p_query_column_name=>'LAST_UPDATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159956800507128243.4504)
,p_column_sequence=>6
,p_query_column_name=>'DESCRIPTION'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(160115421666404766.4504)
,p_column_sequence=>7
,p_query_column_name=>'SCHEMA'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(159974622387246003.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(159939829413099962.4504)
,p_button_name=>'GO'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Vai'
,p_button_alignment=>'LEFT-BOTTOM'
,p_button_redirect_url=>'javascript:qb_getSavedSQL(false);'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160019417324254067.4504)
,p_button_sequence=>37
,p_button_plug_id=>wwv_flow_api.id(159939829413099962.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina selezione'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:PPR_Tabluar_Submit(''R159940232617099966'',''4500'',''38'',''DELETE'',true,''R159940232617099966'');'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159945027925099984.4504)
,p_branch_action=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159942102412099972.4504)
,p_name=>'P38_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(159939829413099962.4504)
,p_prompt=>'Proprietario'
,p_source=>'V(''APP_USER'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'QUERY_OWNERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r from (',
'select wwv_flow_escape.html(created_by) d, created_by r ',
'  from wwv_flow_qb_saved_query',
'where security_group_id = :flow_security_group_id',
'and exists (     ',
'select 1 ',
'from  wwv_flow_developers ',
'where security_group_id = :flow_security_group_id and ',
'      userid = :flow_user and ',
'      instr(developer_role||'':'',''ADMIN:'') > 0 ',
'union ',
'select 1 ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id ',
'and user_name = :flow_user ',
'and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')) ',
'union all  ',
'select v(''APP_USER'') d, v(''APP_USER'') r',
'FROM DUAL) ',
'group by d,r',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Tutti gli utenti -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Selezionare il proprietario della query e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159942615380099976.4504)
,p_name=>'P38_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(159939829413099962.4504)
,p_prompt=>'Nome'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere la stringa da utilizzare nella ricerca e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159944121760099979.4504)
,p_name=>'P38_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(159939829413099962.4504)
,p_item_default=>'10'
,p_prompt=>'Righe'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_tag_attributes=>'style="min-width: 40px;"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il numero di righe da visualizzare per ogni pagina e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(159944614049099982.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(159940232617099966.4504)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'Delete'
,p_attribute_02=>'WWV_FLOW_QB_SAVED_QUERY'
,p_attribute_03=>'ID'
,p_process_error_message=>'Impossibile eliminare la query'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Query eliminata'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205961520224603885.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_api.create_page(
 p_id=>39.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Esporta dizionario attributi'
,p_page_mode=>'MODAL'
,p_step_title=>'Esporta dizionario attributi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(442015912779378946.4504)
,p_name=>'Dizionario attributi'
,p_template=>wwv_flow_api.id(717419707883820782.4504)
,p_display_sequence=>35
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) count_of_objects',
'  from wwv_flow_hnt_col_dict_syn',
' where security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(617728329737082310.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'nessun dato trovato'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(442016220478378962.4504)
,p_query_column_id=>1
,p_column_alias=>'COUNT_OF_OBJECTS'
,p_column_display_sequence=>1
,p_column_heading=>'Conteggio di colonne'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(717813023228832578.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(755303512721989893.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(717813023228832578.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(442016327500378963.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(717813023228832578.4504)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esporta'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(442017308992378967.4504)
,p_name=>'P39_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(442015912779378946.4504)
,p_item_default=>'DOS'
,p_prompt=>'Formato file'
,p_source=>'DOS'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI DEFAULT EXP IMP FORMATS'
,p_lov=>'.'||wwv_flow_api.id(40883415986261937.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare un formato file. Sono disponibili le opzioni riportate di seguito.',
'<ul>',
'<li><strong>DOS</strong>: le righe nel file risultante terminano con ritorni a capo e avanzamenti riga;</li>',
'<li><strong>UNIX</strong>: le righe nel file risultante terminano con avanzamenti riga.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1009694976479591949.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(755303512721989893.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1009695297795591949.4504)
,p_event_id=>wwv_flow_api.id(1009694976479591949.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(442018605914378985.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow_gen_hint.g_mime_shown := true;',
'',
'wwv_flow_utilities.print_download_header(',
'    p_mime_type => ''application/x-sql'',',
'    p_is_attachment => true,',
'    p_file_name => lower(wwv_flow.get_company_name(p_escape=>false)) || ''_attr_dict.sql''',
');',
'',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_gen_hint.export_attr_dict(',
'    p_format => :P39_FORMAT);',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Esportazione del dizionario attributi non riuscita.'
,p_process_when_button_id=>wwv_flow_api.id(442016327500378963.4504)
,p_process_success_message=>'Dizionario attributi esportato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1009695498066598038.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'close dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(442016327500378963.4504)
);
end;
/
prompt --application/pages/page_00040
begin
wwv_flow_api.create_page(
 p_id=>40.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea lista di valori statica'
,p_step_title=>'Crea lista di valori statica'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(428880730649520691.4504)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(428882302935520704.4504)
,p_plug_name=>'Liste di valori statiche'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>25
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Se si crea un form, un report o un form tabulare che comprende questa colonna e se il tipo appropriato di visualizzazione \00E8 impostato in modo da utilizzare una lista di valori (Gruppo pulsanti di scelta o Lista di selezione), la lista di valori de')
||unistr('nominata verr\00E0 creata all''interno dell''applicazione e ad essa far\00E0 riferimento l''elemento o la colonna di report risultante.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(428882520691520705.4504)
,p_plug_name=>'Avvertenza'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>12
,p_plug_source=>'Rimuovere la query di lista di valori prima di definire una lista di valori statica.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P803_LOV_QUERY'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(428886510649531096.4504)
,p_name=>'Crea lista di valori statica'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i,',
'       ''<input type="text" size="32" maxlength="255" value="" name="f01">'' g01,',
'       ''<input type="text" size="32" maxlength="255" value="" name="f02">'' g02',
'from   wwv_flow_dual100',
'where  i < 16',
'order  by i'))
,p_display_when_condition=>'P803_LOV_QUERY'
,p_display_condition_type=>'ITEM_IS_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'nessun dato trovato'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428886806000531122.4504)
,p_query_column_id=>1
,p_column_alias=>'I'
,p_column_display_sequence=>1
,p_column_heading=>'Sequenza'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428886907071531122.4504)
,p_query_column_id=>2
,p_column_alias=>'G01'
,p_column_display_sequence=>2
,p_column_heading=>'Valore visualizzato'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428887001746531122.4504)
,p_query_column_id=>3
,p_column_alias=>'G02'
,p_column_display_sequence=>3
,p_column_heading=>'Valore restituito'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1014897265161898157.4504)
,p_plug_name=>'Crea lista di valori statica'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(428881105139520693.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(428880730649520691.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(428880907735520693.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(428880730649520691.4504)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'CREATE'
,p_button_condition=>'P803_LOV_QUERY'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(428884626535520896.4504)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:37:P37_TABLE_ID,P37_COLUMN_ID:&P40_TABLE_ID.,&P40_COLUMN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428881506826520694.4504)
,p_name=>'P40_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(428886510649531096.4504)
,p_prompt=>'Tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_id r',
'  from WWV_FLOW_HNT_TABLE_INFO '))
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428881706696520696.4504)
,p_name=>'P40_COLUMN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(428886510649531096.4504)
,p_prompt=>'Nome colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_id r',
'  from WWV_FLOW_HNT_COLUMN_INFO'))
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'la colonna attualmente selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(428890019138571419.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   r  varchar2(4000);',
'begin',
'for i in 1..wwv_flow.g_f01.count',
'   loop',
'      if wwv_flow.g_f01(i) is not null',
'         then',
'            r := nvl(wwv_flow.g_f02(i),wwv_flow.g_f01(i));',
'            wwv_flow_hint.create_lov_data (',
'               p_column_id          => :P40_COLUMN_ID,',
'               p_lov_disp_sequence  => i,',
'               p_lov_disp_value     => wwv_flow.g_f01(i),',
'               p_lov_return_value   => r',
'               );',
'      end if;',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la creazione della lista di valori statica.'
,p_process_when_button_id=>wwv_flow_api.id(428880907735520693.4504)
,p_process_success_message=>'Lista di valori statica creata.'
);
end;
/
prompt --application/pages/page_00041
begin
wwv_flow_api.create_page(
 p_id=>41.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Importa dizionario attributi'
,p_page_mode=>'MODAL'
,p_step_title=>'Importa dizionario attributi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(442032917265604900.4504)
,p_plug_name=>'Importa dizionario attributi'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698586323532530546.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1019660859974192277.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(698586323532530546.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(442033115076604902.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(698586323532530546.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(442036232137604924.4504)
,p_branch_action=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(442033115076604902.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(442033523152604907.4504)
,p_name=>'P41_FILE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(442032917265604900.4504)
,p_prompt=>'Importa file'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>60
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Immettere la posizione del file da importare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(442034110950604909.4504)
,p_name=>'P41_FILE_CHARSET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(442032917265604900.4504)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Set di caratteri file'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(143356515285702408.4504)||'.'
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicare la codifica del set di caratteri per il file da importare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1019661086642196097.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1019660859974192277.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1019661322310196098.4504)
,p_event_id=>wwv_flow_api.id(1019661086642196097.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(442035817268604922.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_title     varchar2(4000) := null;',
'  l_start     number := 0;',
'begin',
'  l_start := instr(:P41_FILE,''/'',1)+1;',
'  l_title := substr(:P41_FILE,l_start);',
'  --',
'  -- save file attributes',
'  --',
'  update wwv_flow_file_objects$ ',
'  set    title             = l_title, ',
'         description       = l_title||'' upload'',',
'         security_group_id = :flow_security_group_id,      ',
'         mime_type         = ''application/text'',',
'         created_by        = :flow_user,',
'         file_charset      = :P41_FILE_CHARSET,',
'         file_type         = ''ATTR_DICT''',
'  where name = :P41_FILE;        ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il caricamento del file di esportazione.'
,p_process_when_button_id=>wwv_flow_api.id(442033115076604902.4504)
,p_process_success_message=>'File di esportazione caricato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(442036004711604923.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P56_FILE_ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P41_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P56_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(442033115076604902.4504)
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_api.create_page(
 p_id=>42.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Query By Example'
,p_step_title=>'Query By Example'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11539602725985552)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<SCRIPT LANGUAGE="JavaScript1.1" type="text/javascript">',
'function ToggleAll(e) ',
'  {',
'  if (e.checked)',
'    CheckAll();',
'  else ',
'    ClearAll();',
'  }',
'function Check(e)    ',
'  {',
'  e.checked = true;',
'  }',
'function Clear(e)    ',
'  {',
'  e.checked = false;',
'  }',
'function CheckAll()    ',
'  {',
'  var ml = document.wwv_flow;',
'  var len = ml.elements.length;',
'  for (var i = 0; i < len; i++)',
'    {',
'    var e = ml.elements[i];',
'    if (e.name == "f01")',
'      Check(e);',
'    }',
'  ml.f01.checked = true;',
'  }',
'function ClearAll()',
'  {',
'  var ml = document.wwv_flow;',
'  var len = ml.elements.length;',
'  for (var i = 0; i < len; i++)',
'    {',
'    var e = ml.elements[i];',
'    if (e.name == "f01")',
'      Clear(e);',
'    }',
'  ml.f01.checked = false;',
'  }',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14689615963936701.4504)
,p_plug_name=>'View Subtabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'VIEW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14744016215230180.4504)
,p_plug_name=>'Table Subtabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'TABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(131505108345142117.4504)
,p_plug_name=>'Query'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>25
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(101162609984227437.4504)
,p_name=>'Filter'
,p_parent_plug_id=>wwv_flow_api.id(131505108345142117.4504)
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q       varchar2(32767);',
'  l_none  varchar2(100);',
'begin',
'l_none := wwv_flow_lang.system_message(''F4000_P806_NONE'');',
'',
'if (wwv_flow_collection.collection_exists(''SW_QBE'')) and',
'   (nvl(:OBJECT_NAME,'' '') = nvl(:F4500_P42_PREV_OBJECT,'' '')) then',
'  q:=''select '';',
'  q:=q||''DECODE(c.c008,c.c004,'';',
'  q:=q||''wwv_flow_item.checkbox(1,c.c004,''''CHECKED''''),'';',
'  q:=q||''wwv_flow_item.checkbox(1,c.c004)) include, '';',
'  q:=q||''c.c003||''''.'''' column_id, '';',
'  q:=q||''c.c004 column_name, '';',
'  q:=q||''decode(substr(c.c006,1,decode(instr(c.c006,''''(''''),0,length(c.c006),instr(c.c006,''''('''')-1)),'';',
'  q:=q||''''''VARCHAR2'''',''''<img src="#IMAGE_PREFIX#varchar.gif" width="16" height="16" alt="varchar2" />'''' '';',
'  q:=q||'',''''CHAR'''',''''<img src="#IMAGE_PREFIX#varchar.gif" width="16" height="16" alt="char" />'''' '';',
'  q:=q||'',''''DATE'''',''''<img src="#IMAGE_PREFIX#date.gif" width="16" height="16" alt="date" />'''' '';',
'  q:=q||'',''''TIMESTAMP'''',''''<img src="#IMAGE_PREFIX#date.gif" width="16" height="16" alt="date">'''' '';',
'  q:=q||'',''''NUMBER'''',''''<img src="#IMAGE_PREFIX#number.gif" width="16" height="16" alt="number" />'''' '';',
'  q:=q||'',wwv_flow_lang.system_message(''''F4500.NO_IMAGE'''')) dt_img, '';',
'  q:=q||''DECODE(substr(c.c006,1,decode(instr(c.c006,''''(''''),0,length(c.c006),instr(c.c006,''''('''')-1)),'';',
'  q:=q||''''''VARCHAR2'''',wwv_flow_item.text(2,c.c005),'';',
'  q:=q||''''''CHAR'''',wwv_flow_item.text(2,c.c005),'';',
'  q:=q||''''''NUMBER'''',wwv_flow_item.text(2,c.c005),'';',
'  q:=q||''''''DATE'''',wwv_flow_item.text(2,c.c005),'';',
'  q:=q||''''''CLOB'''',wwv_flow_item.text(2,c.c005),'';',
'  q:=q||''''''TIMESTAMP'''',wwv_flow_item.text(2,c.c005),'';',
'  q:=q||''''''BINARY_FLOAT'''',wwv_flow_item.text(2,c.c005),'';',
'  q:=q||''''''BINARY_DOUBLE'''',wwv_flow_item.text(2,c.c005),'';',
'  q:=q||''wwv_flow_item.hidden(2,null)||'';',
'  q:=q||''''''<strong>''||wwv_flow_lang.system_message(''F4500_NOT_AVAIL_SEARCH'')||''</strong>'''') condition, '';',
'  q:=q||''DECODE(c.c007,null,'''''' || l_none || '''''',c.c007) comments, '';',
'  q:=q||''wwv_flow_item.hidden(3,c.c006) data_type,  '';',
'  q:=q||''wwv_flow_item.hidden(4,c.c004) column_name2, '';',
'  q:=q||''wwv_flow_item.hidden(5,c.c003) column_id2, '';',
'  q:=q||''wwv_flow_item.hidden(6,c.c007) comments2  '';',
'  q:=q||''from wwv_flow_collections c   '';',
'  q:=q||''where collection_name = ''''SW_QBE''''  '';',
'  q:=q||''order by to_number(c.c003) '';',
'else',
'  q:=''select '';',
'  q:=q||''wwv_flow_item.checkbox(1,x.column_name) include, '';',
'  q:=q||''x.column_id||''''.'''', '';',
'  q:=q||''x.column_name column_name, '';',
'  q:=q||''decode(substr(x.data_type,1,decode(instr(x.data_type,''''(''''),0,length(x.data_type),instr(x.data_type,''''('''')-1)),''''VARCHAR2'''','';',
'  q:=q||''''''<img src="#IMAGE_PREFIX#varchar.gif" width="16" height="16" alt="varchar2" />'''''';',
'  q:=q||'',''''CHAR'''',''''<img src="#IMAGE_PREFIX#varchar.gif" width="16" height="16" alt="char" />'''''';',
'  q:=q||'',''''DATE'''',''''<img src="#IMAGE_PREFIX#date.gif" width="16" height="16" alt="date" />'''' '';',
'q:=q||'',''''TIMESTAMP'''',''''<img src="#IMAGE_PREFIX#date.gif" width="16" height="16" alt="date" />'''' '';',
'  q:=q||'',''''NUMBER'''',''''<img src="#IMAGE_PREFIX#number.gif" width="16" height="16" alt="number" />'''' '';',
'  q:=q||'',''''no image'''') dt_img, '';',
'  q:=q||''DECODE(substr(x.data_type,1,decode(instr(x.data_type,''''(''''),0,length(x.data_type),instr(x.data_type,''''('''')-1)),''''VARCHAR2'''',wwv_flow_item.text(2),'';',
'  q:=q||''''''CHAR'''',wwv_flow_item.text(2),'';',
'  q:=q||''''''NUMBER'''',wwv_flow_item.text(2),'';',
'  q:=q||''''''DATE'''',wwv_flow_item.text(2),'';',
'  q:=q||''''''CLOB'''',wwv_flow_item.text(2),'';',
'  q:=q||''''''TIMESTAMP'''',wwv_flow_item.text(2),'';',
'  q:=q||''''''BINARY_FLOAT'''',wwv_flow_item.text(2),'';',
'  q:=q||''''''BINARY_DOUBLE'''',wwv_flow_item.text(2),'';',
'  q:=q||''wwv_flow_item.hidden(2,null)||'';',
'  q:=q||''''''<strong>''||wwv_flow_lang.system_message(''F4500_NOT_AVAIL_SEARCH'')||''</strong>'''') condition, '';',
'  q:=q||''DECODE(x.comments,null,'''''' || l_none || '''''',x.comments) comments, '';',
'  q:=q||''wwv_flow_item.hidden(3,x.data_type) data_type,  '';',
'  q:=q||''wwv_flow_item.hidden(4,x.column_name) column_name2, '';',
'  q:=q||''wwv_flow_item.hidden(5,x.column_id) column_id2, '';',
'  q:=q||''wwv_flow_item.hidden(6,x.comments) comments2 '';',
'  q:=q||''from ( '';',
'  q:=q||''select  '';',
'  q:=q||'':OBJECT_OWNER owner, '';',
'  q:=q||''t.column_id, '';',
'  q:=q||''t.column_name, '';',
'  q:=q||''t.data_type, '';',
'  q:=q||''c.comments, '';',
'  q:=q||''t.table_name '';',
'  q:=q||''from sys.user_tab_columns t, sys.user_col_comments c '';',
'  q:=q||''where t.table_name = c.table_name '';',
'  q:=q||''and t.column_name = c.column_name '';',
'  q:=q||''and t.table_name = :OBJECT_NAME '';',
'  q:=q||''order by t.column_id) x'';',
'end if;',
'return q;',
'end;'))
,p_header=>'<p>Selezionare le colonne da visualizzare. Per limitare righe specifiche, immettere una condizione in <strong>Condizione colonna</strong>. Utilizzare "%" per i caratteri jolly.</p>'
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_plug_query_max_columns=>60
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'F4500_P42_OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48744611625771964.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48744703732771965.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48744831767771965.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48744920914771965.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745020203771965.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Condizione colonna'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745129314771965.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745220420771965.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Commenti'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745329126771966.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745431859771966.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745516120771966.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745617768771966.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745720531771966.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745806330771966.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48745928932771966.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48746018801771966.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69242806143362965.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69242910418362965.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69243007646362965.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69243112334362966.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69243214008362966.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146117425755734018.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146117519706734019.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146117604210734019.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146117701451734019.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146117828148734019.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146117925306734019.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118011647734019.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118111635734019.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118221134734019.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118327180734020.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118431742734020.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118500343734020.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118621698734020.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118731553734020.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118829855734020.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146118929603734020.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119025530734020.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119106861734020.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119217706734021.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119328043734021.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119413258734021.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119519709734021.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119627127734021.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119724022734021.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119812299734021.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146119908892734021.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120005803734021.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120112231734022.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120200318734022.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120311587734022.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120418996734022.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120513900734022.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120609695734022.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120700991734022.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120810759734022.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146120922378734022.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146121022409734023.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146121118439734023.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146121200153734023.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(146121301000734023.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(103235917082519926.4504)
,p_plug_name=>'Ordering'
,p_parent_plug_id=>wwv_flow_api.id(131505108345142117.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162238101270647034.4504)
,p_plug_name=>'MV Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(15852414527126687.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'MATERIALIZED VIEW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101177717873358107.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(131505108345142117.4504)
,p_button_name=>'QUERY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Query'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61435025248281233.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(131505108345142117.4504)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101176810600355984.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(131505108345142117.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101178015886358109.4504)
,p_branch_action=>'46'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101177717873358107.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1255329411407271.4504)
,p_name=>'F4500_P42_INCLUDE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(101162609984227437.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3561718403811883.4504)
,p_name=>'P42_SHOW_DRILL'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(101162609984227437.4504)
,p_item_default=>'N'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'OBJECT_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_help_text=>unistr('<p>Per impostazione predefinita, il risultato della query viene visualizzato assieme ai collegamenti alle tabelle di riferimento relative all''integrit\00E0 referenziale. Se la tabella contiene un numero elevato di riferimenti all''integrit\00E0 referenziale, ')
||unistr('selezionare <strong>Nascondi</strong> per ottenere un risultato della query pi\00F9 rapido.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61433811957267869.4504)
,p_name=>'P42_PREV_PAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(101162609984227437.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(66628210769913219.4504)
,p_name=>'P42_OBJECT_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(101162609984227437.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101163711050242106.4504)
,p_name=>'F4500_P42_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(131505108345142117.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_post_element_text=>'&nbsp;'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dell''oggetto di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101164306090244448.4504)
,p_name=>'F4500_P42_OBJECT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(131505108345142117.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome tabella/vista:'
,p_post_element_text=>'&nbsp;'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della tabella o vista'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101190532012445134.4504)
,p_name=>'F4500_P42_QUERY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(101162609984227437.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103239521574563385.4504)
,p_name=>'F4500_P42_ORDER_BY_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(103235917082519926.4504)
,p_prompt=>'Ordina per'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P42.ORDER.COLUMNS'
,p_lov=>'select wwv_flow_escape.html(column_name) d, column_name v from sys.dba_tab_columns where owner = :F4500_P42_OBJECT_OWNER and table_name = :F4500_P42_OBJECT_NAME order by column_id'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Selezionare un tipo di ordinamento.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103241122208578357.4504)
,p_name=>'F4500_P42_ORDER_BY_2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(103235917082519926.4504)
,p_prompt=>'Ordina per'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P42.ORDER.COLUMNS'
,p_lov=>'select wwv_flow_escape.html(column_name) d, column_name v from sys.dba_tab_columns where owner = :F4500_P42_OBJECT_OWNER and table_name = :F4500_P42_OBJECT_NAME order by column_id'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Selezionare un tipo di ordinamento.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103242722412593418.4504)
,p_name=>'F4500_P42_ORDER_BY_3'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(103235917082519926.4504)
,p_prompt=>'Ordina per'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P42.ORDER.COLUMNS'
,p_lov=>'select wwv_flow_escape.html(column_name) d, column_name v from sys.dba_tab_columns where owner = :F4500_P42_OBJECT_OWNER and table_name = :F4500_P42_OBJECT_NAME order by column_id'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare un tipo di ordinamento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103245104512601726.4504)
,p_name=>'F4500_P42_ASC_1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(103235917082519926.4504)
,p_item_default=>'ASC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ASC.DESC.RETURNS.ASC.DESC'
,p_lov=>'.'||wwv_flow_api.id(88023114905423598.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103246124125607804.4504)
,p_name=>'F4500_P42_ASC_2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(103235917082519926.4504)
,p_item_default=>'ASC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ASC.DESC.RETURNS.ASC.DESC'
,p_lov=>'.'||wwv_flow_api.id(88023114905423598.4504)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103246819380610060.4504)
,p_name=>'F4500_P42_ASC_3'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(103235917082519926.4504)
,p_item_default=>'ASC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ASC.DESC.RETURNS.ASC.DESC'
,p_lov=>'.'||wwv_flow_api.id(88023114905423598.4504)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106409321557809657.4504)
,p_name=>'F4500_P42_PREV_OBJECT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(101162609984227437.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106571602146350378.4504)
,p_name=>'F4500_P42_VIEW_QUERY'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(101162609984227437.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1260112919412009.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_P42_INCLUDE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01);'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(106410210990814482.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_P42_PREV_OBJECT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':OBJECT_NAME'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101181013311377789.4504)
,p_validation_name=>'select at least one column'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'begin',
'',
'  if wwv_flow.g_f01.count = 0 then',
'',
'    return false;',
'',
'  else',
'',
'    return true;',
'',
'  end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Specificare almeno una colonna da visualizzare. '
,p_when_button_pressed=>wwv_flow_api.id(101177717873358107.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(66629428776918411.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values based on object id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.get_object_info (',
'      p_object_id    => :OBJECT_ID,',
'      p_object_owner => :OB_SCHEMA,',
'      p_object_name  => :OBJECT_NAME,',
'      p_object_type  => :OBJECT_TYPE);',
'',
'--',
'-- Check that the user has the appropriate privileges',
'--',
'wwv_flow_sw_api.check_priv ( p_schema => :OBJECT_OWNER );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(101189126645417246.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'build query for p46 report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql          varchar2(32767) := null;',
'  l_view_sql     varchar2(32767) := null;',
'',
'  l_order_columns wwv_flow_global.vc_arr2;',
'  l_order_ascdesc wwv_flow_global.vc_arr2;',
'begin',
'  if wwv_flow.g_f01.count = 0 then',
'      raise_application_error (-20001,''You must check at least one column to view.'');',
'  end if;',
'',
'  l_order_columns(1) := :F4500_P42_ORDER_BY_1;',
'  l_order_ascdesc(1) := :F4500_P42_ASC_1;',
'  l_order_columns(2) := :F4500_P42_ORDER_BY_2;',
'  l_order_ascdesc(2) := :F4500_P42_ASC_2;',
'  l_order_columns(3) := :F4500_P42_ORDER_BY_3;',
'  l_order_ascdesc(3) := :F4500_P42_ASC_3;',
'',
'  l_sql := wwv_flow_table_drill.build_sql (',
'               p_owner         => :OBJECT_OWNER,',
'               p_to_table      => :OBJECT_NAME,',
'               p_type          => :OBJECT_TYPE,',
'               p_show_drill    => :P42_SHOW_DRILL,',
'               p_include       => :F4500_P42_INCLUDE,',
'               p_where_columns => wwv_flow.g_f04,',
'               p_where_values  => wwv_flow.g_f02,',
'               p_where_types   => wwv_flow.g_f03,',
'               p_order_columns => l_order_columns,',
'               p_order_ascdesc => l_order_ascdesc );',
'',
'  l_view_sql := wwv_flow_table_drill.build_view_sql (',
'               p_owner     => :OBJECT_OWNER,',
'               p_to_table  => :OBJECT_NAME,',
'               p_type      => :OBJECT_TYPE,',
'               p_include       => :F4500_P42_INCLUDE,',
'               p_where_columns => wwv_flow.g_f04,',
'               p_where_values  => wwv_flow.g_f02,',
'               p_where_types   => wwv_flow.g_f03,',
'               p_order_columns => l_order_columns,',
'               p_order_ascdesc => l_order_ascdesc );',
'   ',
'  -- ',
'  -- assign the query as :F4500_P42_QUERY value ',
'  --',
'  :F4500_P42_QUERY := l_sql;',
'  -- ',
'  -- to show sql in SQL command processor ',
'  --',
'  :F4500_P42_VIEW_QUERY := l_view_sql;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la creazione di una query valida.'
,p_process_when_button_id=>wwv_flow_api.id(101177717873358107.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(103312424276747343.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear p46 cache'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'46'
,p_process_when_button_id=>wwv_flow_api.id(101177717873358107.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(102992403743220689.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset pagination'
,p_process_sql_clob=>'wwv_flow_disp_page_plugs.reset_region_pagination(101186020403404926);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(101177717873358107.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(101942521793263623.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(106129625187320240.4504)
,p_process_sequence=>1
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create SW_QBE collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.create_sw_qbe_collection (',
'    p_object_owner     => :OBJECT_OWNER,',
'    p_object_name      => :OBJECT_NAME,',
'    p_column_ids       => wwv_flow.g_f05,',
'    p_column_names     => wwv_flow.g_f04,',
'    p_query_conditions => wwv_flow.g_f02,',
'    p_data_types       => wwv_flow.g_f03,',
'    p_comments         => wwv_flow.g_f06,    ',
'    p_checked          => wwv_flow.g_f01',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la creazione della collection sw_qbe.'
,p_process_when_button_id=>wwv_flow_api.id(101177717873358107.4504)
);
end;
/
prompt --application/pages/page_00043
begin
wwv_flow_api.create_page(
 p_id=>43.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Genera DDL - Tipo di oggetto'
,p_page_mode=>'MODAL'
,p_step_title=>'Genera DDL - Tipo di oggetto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215532403383713875)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function P18_ToggleAll(e){',
'  if (e.checked){CheckAll(); }',
'  else{ClearAll();}',
'}',
'',
'function CheckAll() { ',
'  $f_CheckAll(''F4500_P18_OBJECT_TYPE_CONTAINER'',true);',
'}',
'',
'function ClearAll() {  ',
'  $f_CheckAll(''F4500_P18_OBJECT_TYPE_CONTAINER'',false);',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85523417424861176.4504)
,p_plug_name=>'Genera DDL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<p>Selezionare i tipi di oggetto per i quali si desidera generare la DDL (Data Definition Language). Se si fa clic su <strong>Genera DDL</strong>, viene generata la DDL per i tipi di oggetto selezionati. Per selezionare i nomi oggetto per i tipi di o'
||'ggetto selezionati, fare clic su <strong>Successivo<strong>.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(87143407026576996.4504)
,p_plug_name=>'Navigazione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(87134126220568115.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208305201721589657.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(946273527333420312.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(208305201721589657.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(87097320371476462.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208305201721589657.4504)
,p_button_name=>'GenerateDDL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Genera DDL'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(85539028451868614.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208305201721589657.4504)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(85533522217866787.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208305201721589657.4504)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159388225398837595.4504)
,p_branch_action=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::F4500_P18_DDL_TYPE:OBJECT_TYPE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(87097320371476462.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'(:F4500_P43_OUTPUT_TYPE = ''DISPLAY'') or (:F4500_P43_OUTPUT_TYPE2 = ''DISPLAY'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159389630770876973.4504)
,p_branch_action=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::F4500_P45_DDL_TYPE:OBJECT_TYPE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(87097320371476462.4504)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4500_P43_OUTPUT_TYPE'
,p_branch_condition_text=>'SCRIPT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(85539405441868615.4504)
,p_branch_action=>'44'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(85539028451868614.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(85533911864866789.4504)
,p_branch_action=>'18'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(85533522217866787.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11791613029493611.4504)
,p_name=>'F4500_P43_OUTPUT_TYPE2'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(85523417424861176.4504)
,p_item_default=>'DISPLAY'
,p_prompt=>'Output:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DISPLAY.INLINE'
,p_lov=>'.'||wwv_flow_api.id(88029914736461415.4504)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_security_scheme=>wwv_flow_api.id(11800412655616562)
,p_help_text=>'Seleziona formato di output'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48184530853593205.4504)
,p_name=>'P43_CHECK_ALL'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(85523417424861176.4504)
,p_prompt=>'Seleziona tutto'
,p_post_element_text=>'<input type="checkbox" onclick="P18_ToggleAll(this)" />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Controlla tutte le righe'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85558313530878212.4504)
,p_name=>'F4500_P18_OBJECT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(85523417424861176.4504)
,p_prompt=>'Tipo di oggetto:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'OBJECT.TYPES3'
,p_lov=>'.'||wwv_flow_api.id(149192410304386529.4504)||'.'
,p_cattributes_element=>'id="objects"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Selezionare i tipi di oggetto per i quali si desidera generare la DDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(89861219489547759.4504)
,p_name=>'F4500_P43_OUTPUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(85523417424861176.4504)
,p_item_default=>'DISPLAY'
,p_prompt=>'Output:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DISPLAY_OR_SAVE'
,p_lov=>'.'||wwv_flow_api.id(88028228457455927.4504)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_security_scheme=>wwv_flow_api.id(11650706329157488)
,p_help_text=>'Selezionare un formato di output.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162850203621813354.4504)
,p_name=>'P43_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(85523417424861176.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Set di caratteri file'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(143356515285702408.4504)||'.'
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Il file DDL verr\00E0 codificato nel set di caratteri specificato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(50956205122393401.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'43'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(85589806185896818.4504)
,p_validation_name=>'object type not null'
,p_validation_sequence=>10
,p_validation=>'F4500_P18_OBJECT_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare il tipo di oggetto.'
,p_associated_item=>wwv_flow_api.id(85558313530878212.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(238747200386108968.4504)
,p_validation_name=>'no obj found on selected obj types'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  la_obj_types wwv_flow_global.vc_arr2;',
'  l_cnt        pls_integer := 0;',
'begin',
'	la_obj_types := wwv_flow_utilities.string_to_table2(:F4500_P18_OBJECT_TYPE);',
'	for i in 1..la_obj_types.count',
'	loop',
'    for c1 in (select count(*) cnt',
'               from sys.dba_objects',
'               where owner = :F4500_P18_SCHEMA',
'               and object_type = la_obj_types(i))',
'    loop',
'      l_cnt := l_cnt + c1.cnt;',
'    end loop;',
'  end loop; ',
'  ',
'  if l_cnt = 0 then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Object type selezionato/i senza oggetti per generare DDL.'
,p_validation_condition=>'F4500_P18_OBJECT_TYPE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(85558313530878212.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(946273781692422819.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(946273527333420312.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(946274076362422820.4504)
,p_event_id=>wwv_flow_api.id(946273781692422819.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69944328376943484.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:F4500_P18_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00044
begin
wwv_flow_api.create_page(
 p_id=>44.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Genera DDL - Nome oggetto'
,p_page_mode=>'MODAL'
,p_step_title=>'Genera DDL - Nome oggetto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215532403383713875)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function ToggleAll(e){',
'  if (e.checked){CheckAll(); }',
'  else{ClearAll();}',
'}',
'',
'function CheckAll() { ',
'  html_CheckAll('''',true,document.getElementsByName(''f01''));',
'}',
'',
'function ClearAll() {  ',
'  html_CheckAll('''',false,document.getElementsByName(''f01''));',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85613016500937615.4504)
,p_plug_name=>'Genera DDL'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_security.current_company_can_build(p_in_schema=>:F4500_P18_SCHEMA)'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'<p>Selezionare l''oggetto o gli oggetti per cui si desidera generare la DDL.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1100180815559278538.4504)
,p_name=>'Lista di oggetti'
,p_parent_plug_id=>wwv_flow_api.id(85613016500937615.4504)
,p_template=>wwv_flow_api.id(717419707883820782.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4500_P18_OBJECT_TYPE = ''DATABASE LINK'' then',
'return ''select ''''DATABASE LINK'''' object_type, wwv_flow_item.checkbox(1,db_link) ck, db_link object_name ',
'          from sys.all_db_links'';',
'else',
'return q''[with obj_type_str as (',
'    select '':''||:F4500_P18_OBJECT_TYPE||'':'' obj_type_str from dual ),',
'obj_types as (',
'    select regexp_substr (',
'               obj_type_str,',
'               ''[^:]*'',',
'               instr(obj_type_str,'':'',1,level)+1 ) t',
'    from obj_type_str',
'    connect by level <= length(regexp_replace(obj_type_str,''[^:]+'',null))-1)',
'select object_type,',
'       wwv_flow_item.checkbox(1,object_name) ck,',
'       object_name',
'  from apex_sys_all_objects',
' where owner = :F4500_P18_SCHEMA',
'   and object_type in (select /*+cardinality(obj_types 1)*/ t from obj_types)',
'   and object_name not like ''BIN$%''',
'   and ( instr( object_name, upper(:P44_FILTER) ) > 0 or :P44_FILTER is null )',
' order by object_type, object_name',
']'';',
'end if;'))
,p_display_when_condition=>'wwv_flow_security.current_company_can_build(p_in_schema=>:F4500_P18_SCHEMA)'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P44_FILTER'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>20
,p_query_num_rows=>6000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Nessun oggetto trovato.'
,p_query_row_count_max=>6000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'F4500_P18_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1100181673905278546.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(149192410304386529)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1100181728362278547.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'<input type="checkbox" onclick="ToggleAll(this)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1100181896038278548.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1100181921771278549.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'COL04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1100182078926278550.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'COL05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109715877256401701.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109715938218401702.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716080839401703.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716154046401704.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716204511401705.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716316499401706.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716482884401707.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716531693401708.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716661196401709.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716775366401710.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716807965401711.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109716935303401712.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109717038927401713.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109717177513401714.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109717273339401715.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(87149231167581025.4504)
,p_plug_name=>'Navigazione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(87134126220568115.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208318322976605211.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(946329872802686495.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208318322976605211.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(85623701579946048.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208318322976605211.4504)
,p_button_name=>'Generate_DDL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Genera DDL'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(85619124651943239.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208318322976605211.4504)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159390622374893487.4504)
,p_branch_action=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::F4500_P18_DDL_TYPE:OBJECT_NAME'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(85623701579946048.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'(:F4500_P18_OUTPUT_TYPE = ''DISPLAY'') or (:F4500_P18_OUTPUT_TYPE2 = ''DISPLAY'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159392022636912420.4504)
,p_branch_action=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::F4500_P45_DDL_TYPE:OBJECT_NAME'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(85623701579946048.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4500_P18_OUTPUT_TYPE'
,p_branch_condition_text=>'SCRIPT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(87117401659549150.4504)
,p_branch_action=>'43'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(85619124651943239.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11806523652638638.4504)
,p_name=>'F4500_P18_OUTPUT_TYPE2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(85613016500937615.4504)
,p_prompt=>'Output:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DISPLAY_OR_SAVE'
,p_lov=>'.'||wwv_flow_api.id(88028228457455927.4504)||'.'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_security_scheme=>wwv_flow_api.id(11800412655616562)
,p_help_text=>'Seleziona formato di output'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87024932721261201.4504)
,p_name=>'F4500_P18_OBJECT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(85613016500937615.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(88539701604148954.4504)
,p_name=>'F4500_P18_OUTPUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(85613016500937615.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'DISPLAY'
,p_prompt=>'Output:'
,p_source=>'&F4500_P43_OUTPUT_TYPE.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DISPLAY_OR_SAVE'
,p_lov=>'.'||wwv_flow_api.id(88028228457455927.4504)||'.'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_security_scheme=>wwv_flow_api.id(11650706329157488)
,p_help_text=>'Selezionare un formato di output.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162857217735836311.4504)
,p_name=>'P44_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(85613016500937615.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Set di caratteri file'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(143356515285702408.4504)||'.'
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Il file DDL verr\00E0 codificato nel set di caratteri specificato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1100180268447278532.4504)
,p_name=>'P44_FILTER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(85613016500937615.4504)
,p_prompt=>'Filtro'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Immettere un criterio di filtro per la lista degli oggetti e premere Invio.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(87028623232265585.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_P18_OBJECT_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01);'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(50954820575388422.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'44'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87145702497579131.4504)
,p_validation_name=>'F4500_P18_OBJECT_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'F4500_P18_OBJECT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare gli oggetti per generare DDL.'
,p_when_button_pressed=>wwv_flow_api.id(85623701579946048.4504)
,p_associated_item=>wwv_flow_api.id(87024932721261201.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-AUG-2002 11:42'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(946330041280688776.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(946329872802686495.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(946330320441688777.4504)
,p_event_id=>wwv_flow_api.id(946330041280688776.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(458047418753364501.4504)
,p_name=>'Refresh on Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P44_FILTER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(458047598803364502.4504)
,p_event_id=>wwv_flow_api.id(458047418753364501.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1100180815559278538.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(458047749380364504.4504)
,p_name=>'Search on Enter'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P44_FILTER'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.keyCode === 13'
,p_bind_type=>'bind'
,p_bind_event_type=>'keypress'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(458047813827364505.4504)
,p_event_id=>wwv_flow_api.id(458047749380364504.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1100180815559278538.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(458047935822364506.4504)
,p_event_id=>wwv_flow_api.id(458047749380364504.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CANCEL_EVENT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(364066423071939822.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- check privs',
'if not wwv_flow_security.current_company_can_build(p_in_schema=>:F4500_P18_SCHEMA) then',
'    raise_application_error(-20000, ',
'    wwv_flow_lang.system_message(''WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'',',
'    :flow_user,',
'    :F4500_P18_SCHEMA)',
'    );        ',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00045
begin
wwv_flow_api.create_page(
 p_id=>45.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Genera DDL'
,p_page_mode=>'MODAL'
,p_step_title=>'Genera DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215532403383713875)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(88228113855390371.4504)
,p_plug_name=>'Genera DDL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208285310117555084.4504)
,p_plug_display_sequence=>10
,p_plug_query_num_rows=>1000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fielddata">Nessun oggetto trovato.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>unistr('<p>Immettere il nome e la descrizione dello script che si desidera creare. Lo script SQL verr\00E0 creato nel repository script.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(88230210704390428.4504)
,p_plug_name=>'In corso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(87134126220568115.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208321823107614767.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(946274668663440596.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208321823107614767.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(88228611692390398.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208321823107614767.4504)
,p_button_name=>'Save'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea script'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(88259309698403650.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208321823107614767.4504)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(946297186978452577.4504)
,p_branch_name=>'view SQL scripts'
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(88228611692390398.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(88259710083403653.4504)
,p_branch_action=>'44'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(88259309698403650.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4500_P45_DDL_TYPE'
,p_branch_condition_text=>'OBJECT_NAME'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(89900713605626396.4504)
,p_branch_action=>'43'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(88259309698403650.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4500_P45_DDL_TYPE'
,p_branch_condition_text=>'OBJECT_TYPE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(88229014845390407.4504)
,p_name=>'F4500_P45_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(88228113855390371.4504)
,p_prompt=>'Nome script'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere il nome dello script che si sta creando.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_reference_id=>140278015093574147.4504
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(88229331393390421.4504)
,p_name=>'F4500_P45_FILE_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(88228113855390371.4504)
,p_source=>'sql'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(88229630927390421.4504)
,p_name=>'F4500_P45_DESCRIPTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(88228113855390371.4504)
,p_prompt=>'Descrizione'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<p>Immettere la descrizione dello script che si sta creando.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(89913509495643471.4504)
,p_name=>'F4500_P45_DDL_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(88228113855390371.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(90136209716901753.4504)
,p_validation_name=>'F4500_P45_FILE_TYPE Not Null'
,p_validation_sequence=>1
,p_validation=>'F4500_P45_FILE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare il tipo di file.'
,p_associated_item=>wwv_flow_api.id(88229331393390421.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-AUG-2002 15:14'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(88231113975390470.4504)
,p_validation_name=>'script name not null'
,p_validation_sequence=>10
,p_validation=>'F4500_P45_SCRIPT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome script.'
,p_associated_item=>wwv_flow_api.id(88229014845390407.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(89505410945655253.4504)
,p_validation_name=>'script name cannot be > 50'
,p_validation_sequence=>10
,p_validation=>'length(:F4500_P45_SCRIPT_NAME) < 50'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Nome script non pu\00F2 essere superare i 50 caratteri.')
,p_validation_condition=>'F4500_P45_SCRIPT_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(88228611692390398.4504)
,p_associated_item=>wwv_flow_api.id(88229014845390407.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193110721525110034.4504)
,p_validation_name=>'duplicate script name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cnt pls_integer := 0;',
'begin',
'  for c1 in (select count(*) cnt',
'             from wwv_flow_files',
'             where lower(filename) = lower(:F4500_P45_SCRIPT_NAME)',
'             and file_type = ''SCRIPT'')',
'  loop',
'    l_cnt := c1.cnt;        ',
'    exit;    ',
'  end loop;',
'  ',
'  if l_cnt > 0 then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome script esiste gi\00E0 nell''area di lavoro. Immettere un altro nome.')
,p_validation_condition=>'F4500_P45_SCRIPT_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(88228611692390398.4504)
,p_associated_item=>wwv_flow_api.id(88229014845390407.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(238817812394254361.4504)
,p_validation_name=>'valid script name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_script.valid_script_name (',
'    p_script_name => :F4500_P45_SCRIPT_NAME',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome dello script non pu\00F2 contenere caratteri riservati.')
,p_validation_condition=>'F4500_P45_SCRIPT_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(88228611692390398.4504)
,p_associated_item=>wwv_flow_api.id(88229014845390407.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(946274804120442603.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(946274668663440596.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(946275146913442603.4504)
,p_event_id=>wwv_flow_api.id(946274804120442603.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(88338403552462715.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save ddl'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Check that the user has the appropriate privileges',
'--',
'wwv_flow_sw_api.check_priv ( p_schema => :F4500_P18_SCHEMA );',
'',
'--',
'-- if generate DDL is from page 43, pass only select object types',
'--',
'if :f4500_p45_ddl_type = ''OBJECT_TYPE'' then',
'   wwv_flow_generate_ddl.execute_get_ddl(',
'           p_schema       => :f4500_p18_schema,',
'           p_object_types => :f4500_p18_object_type,',
'           p_output_type  => ''SCRIPT'',',
'           p_filename     => :F4500_P45_SCRIPT_NAME,',
'           p_file_type    => :F4500_P45_FILE_TYPE,',
'           p_description  => :F4500_P45_DESCRIPTION',
'           );',
'--',
'-- if generate DDL is from page 44, pass only select object names',
'--',
'elsif :f4500_p45_ddl_type = ''OBJECT_NAME'' then',
'   wwv_flow_generate_ddl.execute_get_ddl(',
'         p_schema       => :f4500_p18_schema,',
'         p_object_types => :f4500_p18_object_type,',
'         p_objects      => :f4500_p18_object_name,',
'         p_output_type  => ''SCRIPT'',',
'         p_filename     => :F4500_P45_SCRIPT_NAME,',
'         p_file_type    => :F4500_P45_FILE_TYPE,',
'         p_description  => :F4500_P45_DESCRIPTION',
'         );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il salvataggio di DDL.'
,p_process_when_button_id=>wwv_flow_api.id(88228611692390398.4504)
,p_process_success_message=>'DDL salvata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(698586590782530548.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'DDL salvata.'
);
end;
/
prompt --application/pages/page_00046
begin
wwv_flow_api.create_page(
 p_id=>46.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Query By Example'
,p_step_title=>'Query By Example'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11539602725985552)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14722127971082149.4504)
,p_plug_name=>'View Subtabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>5
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'VIEW'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14747013230238766.4504)
,p_plug_name=>'Table SubTabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>5
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'TABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101185129246400775.4504)
,p_plug_name=>'Risultato query'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(69484412197377068.4504)
,p_name=>'Query Result'
,p_parent_plug_id=>wwv_flow_api.id(101185129246400775.4504)
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql      varchar2(32767) := null;',
'  l_view_sql varchar2(32767) := null;',
'  l_include  varchar2(32767) := null;',
'begin',
'  if :F4500_P46_TO_TABLE = :OBJECT_ID then',
'    l_include := :F4500_P42_INCLUDE;',
'  end if;',
'',
'  l_sql := wwv_flow_table_drill.build_sql (',
'               p_owner           => :OB_SCHEMA,',
'               p_from_table      => :F4500_P46_FROM_TABLE,',
'               p_to_table        => :F4500_P46_TO_TABLE,',
'               p_drill           => :F4500_P46_DRILL,',
'               p_rowid_item_name => ''F4500_P46_ROWID'',',
'               p_include         => l_include',
'               );',
'',
'  l_view_sql := wwv_flow_table_drill.build_view_sql (',
'               p_owner           => :OB_SCHEMA,',
'               p_from_table      => :F4500_P46_FROM_TABLE,',
'               p_to_table        => :F4500_P46_TO_TABLE,',
'               p_drill           => :F4500_P46_DRILL,',
'               p_rowid_item_name => ''F4500_P46_ROWID'',',
'               p_include         => l_include',
'               );',
'',
'  :F4500_P42_VIEW_QUERY := l_view_sql;',
'',
'  return l_sql;  ',
'end;'))
,p_display_when_condition=>'F4500_P46_FROM_TABLE'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_query_num_rows=>10
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'N'
,p_plug_query_exp_filename=>'&OBJECT_NAME..csv'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OB_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69487610597386096.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'COL01'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69487732007386096.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'COL02'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69487826029386096.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'COL03'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69487920227386096.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'COL04'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488021695386096.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'COL05'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488118788386096.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488231994386097.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488326692386097.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488407633386097.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488500659386097.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488611268386097.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488722946386097.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488806560386097.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69488924184386097.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69489032417386098.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69489119877386098.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'COL16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69489230778386098.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'COL17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69489317553386098.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'COL18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69489403138386098.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'COL19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69489509082386098.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'COL20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15107626378567287.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'COL21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15107701014567288.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'COL22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15107808278567288.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'COL23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15107906536567288.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'COL24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108018493567288.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'COL25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108124704567288.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'COL26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108212655567288.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'COL27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108323408567289.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'COL28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108411403567289.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'COL29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108528772567289.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'COL30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108611982567289.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'COL31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108719511567289.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'COL32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108801520567289.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'COL33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15108913892567289.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'COL34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109031423567289.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'COL35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109122742567290.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'COL36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109224420567290.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'COL37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109310014567290.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'COL38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109401872567290.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'COL39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109519359567290.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'COL40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109624126567290.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'COL41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109731312567290.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'COL42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109804308567290.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'COL43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15109912259567290.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'COL44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110019656567291.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'COL45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110125580567291.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'COL46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110222423567291.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'COL47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110303557567291.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'COL48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110427172567291.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'COL49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110509535567291.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'COL50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110613539567291.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'COL51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110702815567292.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'COL52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110831583567292.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'COL53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15110908092567292.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'COL54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15111010035567292.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'COL55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15111114867567292.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'COL56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15111222995567292.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'COL57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15111321870567292.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'COL58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15111412726567293.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'COL59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15111510293567293.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'COL60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(101186020403404926.4504)
,p_name=>'Query Result'
,p_parent_plug_id=>wwv_flow_api.id(101185129246400775.4504)
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_sw_api.check_priv (p_schema => :OB_SCHEMA);',
'    return :F4500_P42_query;',
'end;'))
,p_display_when_condition=>'F4500_P46_FROM_TABLE'
,p_display_condition_type=>'ITEM_IS_NULL'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_LEFT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_exp_filename=>'&OBJECT_NAME..csv'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OB_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48579207668771009.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'COL01'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48579323013771009.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'COL02'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48579419363771010.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'COL03'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48579502840771010.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'COL04'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48579607793771010.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'COL05'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48579708631771010.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48579800076771010.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48579928308771010.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48580031208771010.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48580124913771010.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48580203762771010.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48580324646771011.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48580402940771011.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48580508693771011.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48580600184771011.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69268910486477715.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'COL16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69269024984477717.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'COL17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69269113757477717.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'COL18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69269227093477718.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'COL19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(69269319392477718.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'COL20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150611212400561814.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'COL21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150611310381561820.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'COL22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150611423906561820.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'COL23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150611506533561820.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'COL24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150611631420561820.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'COL25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150611712255561820.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'COL26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150611818412561820.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'COL27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150611916265561821.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'COL28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612012721561821.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'COL29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612115964561821.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'COL30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612208386561821.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'COL31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612303977561821.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'COL32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612403654561821.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'COL33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612529000561821.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'COL34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612613984561821.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'COL35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612728071561822.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'COL36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612818217561822.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'COL37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150612904236561822.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'COL38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613001528561822.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'COL39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613115427561822.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'COL40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613217099561822.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'COL41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613304916561822.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'COL42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613428320561823.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'COL43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613524723561823.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'COL44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613605038561823.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'COL45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613700808561823.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'COL46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613808634561823.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'COL47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150613927776561823.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'COL48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614010995561823.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'COL49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614107210561823.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'COL50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614221476561823.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'COL51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
end;
/
begin
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614327076561824.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'COL52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614427935561824.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'COL53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614516912561824.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'COL54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614632673561829.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'COL55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614700579561829.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'COL56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614805421561829.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'COL57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150614910820561829.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'COL58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150615017416561829.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'COL59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150615100422561830.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'COL60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(348462402387839130.4504)
,p_plug_name=>'&nbsp;'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>15
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(102982326232144985.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(101185129246400775.4504)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Crea riga'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:SW_QBE_CREATE::'
,p_button_condition=>'F4500_P42_OBJECT_TYPE'
,p_button_condition2=>'TABLE'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101186631341409303.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(101185129246400775.4504)
,p_button_name=>'NEWQUERY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Nuova query'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.::F4500_P42_OBJECT_NAME:&F4500_P46_TO_TABLE.'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(480845920738296743.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(101185129246400775.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(106550910896194425.4504)
,p_branch_action=>'46'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GO'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15396123103697384.4504)
,p_name=>'P46_RETURN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(69484412197377068.4504)
,p_source=>'select ''<a href="f?p=4500:46:&SESSION.:::46"><span class="fielddata">''||wwv_flow_lang.system_message(''4500_46_RET_TO_QUERY'')||''</span></a>'' from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69421418141132831.4504)
,p_name=>'P46_TO_OBJECT_ID'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(348462402387839130.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69422224028134476.4504)
,p_name=>'P46_FROM_OBJECT_ID'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_api.id(348462402387839130.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69428008706148968.4504)
,p_name=>'P46_OBJECT_TYPE'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_api.id(348462402387839130.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103302307362603264.4504)
,p_name=>'F4500_P46_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(348462402387839130.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103303201539605873.4504)
,p_name=>'F4500_P46_FROM_TABLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(348462402387839130.4504)
,p_prompt=>'From Table'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103303831288607312.4504)
,p_name=>'F4500_P46_TO_TABLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(348462402387839130.4504)
,p_prompt=>'To Table'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(187652405321922937.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103304427838608926.4504)
,p_name=>'F4500_P46_ROWID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(348462402387839130.4504)
,p_prompt=>'Rowid'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103937402056359406.4504)
,p_name=>'F4500_P46_DRILL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(348462402387839130.4504)
,p_prompt=>'Drill'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(106558311087224732.4504)
,p_computation_sequence=>10
,p_computation_item=>'SQL_COMMAND'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':F4500_P42_VIEW_QUERY'
,p_compute_when=>'VIEW_SQL'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(106559803970228000.4504)
,p_computation_sequence=>10
,p_computation_item=>'PARSE_STMT_AS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':OB_SCEMA'
,p_compute_when=>'VIEW_SQL'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(151516106788974407.4504)
,p_computation_sequence=>20
,p_computation_item=>'P47_RETURN_TO'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'46'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5169331098294321.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_P46_TO_TABLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&OBJECT_NAME.'
,p_compute_when=>'F4500_P46_TO_TABLE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15132206002665471.4504)
,p_computation_sequence=>20
,p_computation_item=>'P46_TO_OBJECT_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'OBJECT_ID'
,p_compute_when=>'P46_TO_OBJECT_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69425229354145566.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set value based on TO object id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.get_object_info (',
'      p_object_id    => :OBJECT_ID,',
'      p_object_owner => :OB_SCHEMA,',
'      p_object_name  => :F4500_P46_TO_TABLE,',
'      p_object_type  => :P46_OBJECT_TYPE);',
'',
'--',
'-- Check that the user has the appropriate privileges',
'--',
'wwv_flow_sw_api.check_priv ( p_schema => :OB_SCHEMA );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile recuperare le informazioni sull''oggetto. (F4500_P46_OWNER="&OB_SCHEMA." P46_TO_OBJECT_ID="&OBJECT_ID.")'
,p_process_comment=>'P46_TO_OBJECT_ID'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17556412192086929.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set drill values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.get_object_info (',
'      p_object_id    => :P46_TO_OBJECT_ID,',
'      p_object_owner => :F4500_P46_OWNER,',
'      p_object_name  => :F4500_P46_TO_TABLE,',
'      p_object_type  => :P46_OBJECT_TYPE);',
'',
'wwv_flow_sw_util.get_object_info (',
'      p_object_id    => :P46_FROM_OBJECT_ID,',
'      p_object_owner => :F4500_P46_OWNER,',
'      p_object_name  => :F4500_P46_FROM_TABLE,',
'      p_object_type  => :P46_OBJECT_TYPE);',
'--',
'-- Check that the user has the appropriate privileges',
'--',
'wwv_flow_sw_api.check_priv ( p_schema => :F4500_P46_OWNER );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P46_FROM_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(101248811035320946.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination when max rows change'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(105414322969723992.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset pagination query result 2'
,p_process_sql_clob=>'wwv_flow_disp_page_plugs.reset_region_pagination(103306700171697748);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00047
begin
wwv_flow_api.create_page(
 p_id=>47.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Modifica record'
,p_step_title=>'Modifica record'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11539602725985552)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15004032762379876.4504)
,p_plug_name=>'Table Subtabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(102317702951447123.4504)
,p_plug_name=>'Modifica riga'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.show_record (',
'    p_table_owner=> :OB_SCHEMA,',
'    p_table_name => :OBJECT_NAME,',
'    p_rowid      => :F4500_P47_ID );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_comment=>'Region generated 29-AUG-2002 10:25:17'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(102417628015456854.4504)
,p_plug_name=>'wwv_flow_sw_api.display_error_msg;'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'wwv_flow_sw_api.display_error_msg;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_sw_api.g_raise_errors'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(102970616843017151.4504)
,p_name=>'Informazioni sulla tabella'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select upper(t.column_name) as col01,',
'         upper(t.data_type) as col02,',
'         t.data_length      as col03,',
'         t.data_precision   as col04,',
'         t.data_scale   as col05,',
'         t.nullable     as col06,',
'         t.data_default as col07,',
'         t.column_id    as col08,',
'         c.comments     as col09',
'from sys.dba_tab_columns t, sys.dba_col_comments c',
'where t.column_name = c.column_name               ',
'and t.table_name = :OBJECT_NAME',
'and t.owner = :OB_SCHEMA',
'and c.table_name = :OBJECT_NAME',
'and c.owner = :OB_SCHEMA',
'order by t.column_id;'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48934331148773174.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48934401200773174.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48934524514773174.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Lunghezza'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48934617012773174.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Precisione'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48934728057773174.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Scala'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48934823293773174.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Valore NULL'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48934926654773174.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Valore predefinito'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48935007892773175.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'ID colonna'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48935110998773175.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Commenti'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(131563205602368485.4504)
,p_plug_name=>'Hidden Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(131595728168479006.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(102318008042447131.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(131595728168479006.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(102318215344447131.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(131595728168479006.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(102318321413447131.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(131595728168479006.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(151608800545247030.4504)
,p_branch_action=>'f?p=&APP_ID.:&P47_RETURN_TO.:&SESSION.:NO_RP:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_sw_api.g_raise_errors'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(102432131094504976.4504)
,p_branch_action=>'47'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_sw_api.g_raise_errors'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164506515385063860.4504)
,p_branch_action=>'f?p=&APP_ID.:&P47_RETURN_TO.:&SESSION.:NO_RP:&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(102318008042447131.4504)
,p_branch_sequence=>30
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P47_RETURN_TO'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(102319324026447140.4504)
,p_branch_action=>'46'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(102318008042447131.4504)
,p_branch_sequence=>40
,p_branch_comment=>'Generated 29-AUG-2002 10:25:17'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(102328514412799046.4504)
,p_name=>'F4500_P47_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(131563205602368485.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(102329110746800765.4504)
,p_name=>'F4500_P47_OBJECT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(131563205602368485.4504)
,p_prompt=>'Object Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(102373029642688370.4504)
,p_name=>'F4500_P47_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(131563205602368485.4504)
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151513508389965435.4504)
,p_name=>'P47_RETURN_TO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(131563205602368485.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269930527571365890.4504)
,p_name=>'P47_ROW_MD5'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(131563205602368485.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(269931524239374361.4504)
,p_computation_sequence=>10
,p_computation_item=>'P47_ROW_MD5'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.gen_row_md5 (',
'   p_table_name  => :OBJECT_NAME,',
'   p_table_owner => :OB_SCHEMA,',
'   p_row_id      => :F4500_P47_ID)'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(151930310045760780.4504)
,p_computation_sequence=>20
,p_computation_item=>'P47_RETURN_TO'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'46'
,p_compute_when=>'P47_RETURN_TO'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(102416231613915409.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.update_record (',
'    p_table_owner  => :OB_SCHEMA,    ',
'    p_table_name   => :OBJECT_NAME,',
'    p_rowid        => :F4500_P47_ID,',
'    p_col_names    => wwv_flow.g_f02,',
'    p_col_values   => wwv_flow.g_f01,',
'    p_md5_checksum => :P47_ROW_MD5 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante l''aggiornamento.'
,p_process_when_button_id=>wwv_flow_api.id(102318215344447131.4504)
,p_process_when=>'not wwv_flow_sw_api.g_raise_errors'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(102965808241990729.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.delete_record (',
'    p_table_owner  => :OB_SCHEMA,    ',
'    p_table_name   => :OBJECT_NAME,',
'    p_rowid        => :F4500_P47_ID,',
'    p_md5_checksum => :P47_ROW_MD5,',
'    p_col_names    => wwv_flow.g_f02,',
'    p_col_values   => wwv_flow.g_f01 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante l''eliminazione.'
,p_process_when_button_id=>wwv_flow_api.id(102318321413447131.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(106721627411082212.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update success msg'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(102318215344447131.4504)
,p_process_when=>'not wwv_flow_sw_api.g_raise_errors'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Riga aggiornata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(106724519231089323.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete success msg'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(102318321413447131.4504)
,p_process_when=>'not wwv_flow_sw_api.g_raise_errors'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Riga eliminata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69293020323565765.4504)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values based on object id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.get_object_info (',
'    p_object_id    => :OBJECT_ID,',
'    p_object_owner => :OB_SCHEMA,',
'    p_object_name  => :OBJECT_NAME,',
'    p_object_type  => :OBJECT_TYPE );',
'',
'--',
'-- Check that the user has the appropriate privileges',
'--',
'wwv_flow_sw_api.check_priv ( p_schema => :OB_SCHEMA );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00048
begin
wwv_flow_api.create_page(
 p_id=>48.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea vista - Definizione'
,p_alias=>'VIEW_CREATE'
,p_step_title=>'Crea vista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_views.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31763815903597586.4504)
,p_plug_name=>'Crea vista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_footer=>unistr('<p>Una vista \00E8 una presentazione personalizzata dei dati contenuti in una o pi\00F9 tabelle o in altre viste. Una vista prende l''output di una query e lo tratta come tabella. Una vista pu\00F2 essere considerata una stored query o una tabella virtuale.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149893028841491555.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149867603205408487.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239816621885614257.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752117926803695887.4504)
,p_plug_name=>'Crea vista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1248942980984887849.4504)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(31763815903597586.4504)
,p_button_name=>'QUERY_BUILDER'
,p_button_static_id=>'QUERY_BUILDER'
,p_button_action=>'REDIRECT_URL'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Query Builder'
,p_button_redirect_url=>'javascript:popupURL(''f?p=4500:1002:&SESSION.:::1002:P1002_RETURN_INTO,P1002_POPUP,P1002_SCHEMA:P48_QUERY,1,'' + encodeURIComponent(''&OB_SCHEMA.''));'
,p_button_execute_validations=>'N'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1249107040643523677.4504)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(31763815903597586.4504)
,p_button_name=>'SQL_COMMANDS'
,p_button_static_id=>'SQL_COMMANDS'
,p_button_action=>'REDIRECT_URL'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Comandi SQL'
,p_button_redirect_url=>'javascript:popupURL(''f?p=4500:1003:&SESSION.:::1003:P1003_RETURN_INTO,P1003_POPUP,P1003_SCHEMA:P48_QUERY,1,'' + encodeURIComponent(''&OB_SCHEMA.''));'
,p_button_execute_validations=>'N'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31765312833625110.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239816621885614257.4504)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31765522908625118.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239816621885614257.4504)
,p_button_name=>'next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(31791330728772191.4504)
,p_branch_action=>'52'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(31765522908625118.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31769318205664479.4504)
,p_name=>'P48_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(31763815903597586.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Selezionare lo schema di database (o nome utente) nel quale si desidera creare la vista. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31770223746666126.4504)
,p_name=>'P48_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(31763815903597586.4504)
,p_prompt=>'Nome vista'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Specificare il nome della vista. I nomi di vista devono essere conformi alle convenzioni di denominazione Oracle e non possono contenere spazi o iniziare con numeri o caratteri di sottolineatura.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31771406347680005.4504)
,p_name=>'P48_QUERY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(31763815903597586.4504)
,p_prompt=>'Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>14
,p_field_template=>wwv_flow_api.id(492677350674053149.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'<p>Immettere una query.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72486212803308467.4504)
,p_name=>'P48_PRESERVE_CASE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(31763815903597586.4504)
,p_prompt=>'Conserva maiuscole/minuscole'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72489015012318586.4504)
,p_computation_sequence=>10
,p_computation_item=>'P48_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(upper(v(''P48_NAME'')),chr(32),''_'')'
,p_compute_when=>'P48_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(106613303672523495.4504)
,p_computation_sequence=>20
,p_computation_item=>'P48_QUERY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(32000);',
'begin',
'  l_sql := wwv_flow_utilities.remove_trailing_whitespace(v(''P48_QUERY''));',
'  l_sql := rtrim(l_sql,chr(10));',
'  l_sql := rtrim(l_sql,chr(13));',
'l_sql := wwv_flow.trim_sql(p_sql=>l_sql,p_ends_in_semicolon=>false,p_do_substitutions=>false);',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4058523663710928.4504)
,p_computation_sequence=>30
,p_computation_item=>'P52_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_util.get_view_ddl(',
'         p_view_name => :P48_NAME,',
'         p_body      => :P48_QUERY)'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(31833426872092775.4504)
,p_validation_name=>'valid NAME'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if not wwv_flow_builder.is_valid_identifier(''"''||:P48_NAME||''"'') then',
'        return wwv_flow_lang.system_message(''NOT_VALID_VIEW_NAME'',wwv_flow_escape.html(:P48_NAME));',
'    end if;',
'    ',
'    if not wwv_flow_sw_util.is_available_name2(p_name => :P48_NAME, p_owner=> :P48_SCHEMA, p_type => ''VIEW'') then',
'        return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P48_NAME));',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Nome vista deve essere un identificativo valido.'
,p_when_button_pressed=>wwv_flow_api.id(31765522908625118.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(66948523851412061.4504)
,p_validation_name=>'query not null'
,p_validation_sequence=>20
,p_validation=>'P48_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare la query.'
,p_associated_item=>wwv_flow_api.id(31771406347680005.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294806507217724765.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P48_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della vista \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00049
begin
wwv_flow_api.create_page(
 p_id=>49.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Raccogli statistiche tabelle'
,p_step_title=>'Raccogli statistiche tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'',
'function toggleEst(estimate){',
'',
'  if (estimate){',
'    disItem = document.getElementById(''estType'');',
'    disItem.style.display = ''inline'';',
'    disItem = document.getElementById(''estAmt'');',
'    disItem.style.display = ''inline'';',
'   }',
'  else {',
'    disItem = document.getElementById(''estType'');',
'    disItem.style.display = ''none'';',
'    disItem = document.getElementById(''estAmt'');',
'    disItem.style.display = ''none'';',
'  }',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(591271575115288072.4504)
,p_plug_name=>'Raccogli statistiche tabelle'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(556019148142256091.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(591271575115288072.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(556019598453256092.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(591271575115288072.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:TABLE_DETAIL:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(556028338173256115.4504)
,p_branch_name=>'Go To Page 67'
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(556019148142256091.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(556019941279256093.4504)
,p_name=>'P49_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(591271575115288072.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_post_element_text=>' '
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(556020833310256103.4504)
,p_name=>'P49_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(591271575115288072.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_post_element_text=>' '
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della tabella per la raccolta delle statistiche.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(556024520049256106.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return ''begin ''||chr(10)||',
'    ''  dbms_stats.gather_table_stats (ownname => ''''''||wwv_flow_assert.enquote_name(:OBJECT_OWNER)||'''''', tabname => ''''''||wwv_flow_assert.enquote_name(:OBJECT_NAME)||'''''');''||chr(10)||',
'    ''end;''||',
'    chr(10);'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(556024961779256110.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''GATHER_TABLE_STATS'');'
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_api.create_page(
 p_id=>50.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea applicazione su tabella'
,p_step_title=>'Crea applicazione su tabella'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1151996259525522951.4504)
,p_plug_name=>'Crea applicazione'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(588436084250019905.4504)
,p_plug_name=>'Form'
,p_parent_plug_id=>wwv_flow_api.id(1151996259525522951.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(588435926021019904.4504)
,p_plug_name=>'Pulsanti'
,p_parent_plug_id=>wwv_flow_api.id(588436084250019905.4504)
,p_region_template_options=>'a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(588444760463068030.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(588435926021019904.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP:OBJECT_NAME:&OBJECT_NAME.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(588445184915068031.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(588435926021019904.4504)
,p_button_name=>'create_app'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea applicazione'
,p_button_position=>'CHANGE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(825273956253768709.4504)
,p_branch_name=>'Branch to Create App Wizard'
,p_branch_action=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:RP,1,5,130,150,170,250:P1_SCHEMA,P1_NEW_TABLE_NAME:&P50_OWNER.,&P50_TABLE.'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(588445590038068041.4504)
,p_name=>'P50_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(588436084250019905.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proprietario'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(588445948592068042.4504)
,p_name=>'P50_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(588436084250019905.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(825274011261768710.4504)
,p_name=>'Submit Page'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(588445184915068031.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(825274167096768711.4504)
,p_event_id=>wwv_flow_api.id(825274011261768710.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_api.create_page(
 p_id=>51.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea riga'
,p_step_title=>'Crea riga'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11539602725985552)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(90706801829196318.4504)
,p_plug_name=>'display error region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'wwv_flow_sw_api.display_error_msg;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_sw_api.g_raise_errors'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(103013815887397403.4504)
,p_plug_name=>'Crea riga'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.show_record (',
'    p_table_owner => :OB_SCHEMA,',
'    p_table_name  => :OBJECT_NAME,',
'    p_rowid       => null );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(103014507907401156.4504)
,p_name=>'Informazioni sulla tabella'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select upper(t.column_name) column_name,',
'         upper(t.data_type) data_type,',
'         t.data_length,',
'         t.data_precision,',
'         t.data_scale,',
'         t.nullable,',
'         t.data_default,',
'         t.column_id,',
'         c.comments',
'from sys.dba_tab_columns t, sys.dba_col_comments c',
'where t.column_name = c.column_name',
'and t.owner = c.owner',
'and t.table_name = c.table_name               ',
'and t.table_name = :OBJECT_NAME',
'and t.owner = :OB_SCHEMA',
'order by t.column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48541330504770714.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48541403039770714.4504)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48541512819770715.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>3
,p_column_heading=>'Lunghezza'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48541625498770715.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>4
,p_column_heading=>'Precisione'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48541700316770715.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>5
,p_column_heading=>'Scala'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48541806300770715.4504)
,p_query_column_id=>6
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>6
,p_column_heading=>'Valore NULL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48541906901770715.4504)
,p_query_column_id=>7
,p_column_alias=>'DATA_DEFAULT'
,p_column_display_sequence=>7
,p_column_heading=>'Valore predefinito'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48542024839770715.4504)
,p_query_column_id=>8
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>8
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48542131623770715.4504)
,p_query_column_id=>9
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>9
,p_column_heading=>'Commenti'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(103017506483413726.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(103013815887397403.4504)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21886922328000266.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(103013815887397403.4504)
,p_button_name=>'CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Crea e crea di nuovo'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(103016628516410615.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(103013815887397403.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21887202502000272.4504)
,p_branch_name=>'Go To Page 51'
,p_branch_action=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21886922328000266.4504)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_sw_api.g_raise_errors'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(103017807083413728.4504)
,p_branch_name=>'Go To Page &F4500_LAST_VIEW.'
,p_branch_action=>'&F4500_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(103017506483413726.4504)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'(:F4500_LAST_VIEW is not null) and (not wwv_flow_sw_api.g_raise_errors)'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(90825405526689374.4504)
,p_branch_name=>'Go To Page 51'
,p_branch_action=>'51'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_sw_api.g_raise_errors'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(103016918815410623.4504)
,p_branch_action=>'&F4500_LAST_VIEW.'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(103016628516410615.4504)
,p_branch_sequence=>20
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'F4500_LAST_VIEW'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69823618863890746.4504)
,p_name=>'P51_OBJECT_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(103013815887397403.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106747531986363784.4504)
,p_name=>'F4500_P51_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(103013815887397403.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106748124438367351.4504)
,p_name=>'F4500_P51_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(103013815887397403.4504)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(225468614441647527.4504)
,p_validation_name=>'at least one value must be entered'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_null_cnt pls_integer := 0;',
'begin',
'  for i in 1..wwv_flow.g_f01.count',
'  loop',
'    if replace(wwv_flow.g_f01(i),'' '') is null then',
'      l_null_cnt := l_null_cnt + 1;',
'    end if;',
'  end loop;',
'  if l_null_cnt = wwv_flow.g_f01.count then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Immettere almeno un valore per inserire una riga.'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(103023427914452609.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.create_record (',
'    p_table_owner => :OB_SCHEMA,',
'    p_table_name  => :OBJECT_NAME,    ',
'    p_col_names   => wwv_flow.g_f02,',
'    p_col_values  => wwv_flow.g_f01 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la creazione della riga in &F4500_P51_TABLE_NAME..'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(106714800961065119.4504)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'show success msg'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_sw_api.g_raise_errors'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Riga creata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69026528775953116.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set object p51 values based on object id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.get_object_info (',
'      p_object_id    => :OBJECT_ID,',
'      p_object_owner => :OB_SCHEMA,',
'      p_object_name  => :OBJECT_NAME,',
'      p_object_type  => :OBJECT_TYPE);',
'',
'--',
'-- Check that the user has the appropriate privileges',
'--',
'wwv_flow_sw_api.check_priv ( p_schema => :OB_SCHEMA );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00052
begin
wwv_flow_api.create_page(
 p_id=>52.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea vista - Conferma'
,p_step_title=>'Crea vista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P52_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P52_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_views.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19908828334659031.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31787927134761748.4504)
,p_plug_name=>'Crea vista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149894104731494095.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149867603205408487.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239817912975668450.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118097786695887.4504)
,p_plug_name=>'Crea vista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31788615145767677.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239817912975668450.4504)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31788810288767680.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239817912975668450.4504)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea vista'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31789111989767681.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239817912975668450.4504)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10854500105543433.4504)
,p_branch_action=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(31788810288767680.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(31798926966799517.4504)
,p_branch_action=>'2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(31790022417769779.4504)
,p_branch_action=>'48'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(31789111989767681.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10858224047578787.4504)
,p_name=>'P52_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(31787927134761748.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31828119075052739.4504)
,p_name=>'P52_SQL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(19908828334659031.4504)
,p_prompt=>'SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31882620505832053.4504)
,p_name=>'P52_CONFIRM_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(31787927134761748.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'P48_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31882814862832056.4504)
,p_name=>'P52_CONFIRM_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(31787927134761748.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome vista:'
,p_source=>'P48_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della vista da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4065228605769156.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P48_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(31788810288767680.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4066314191774453.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P54_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :OB_SCHEMA,',
'              p_sql        => :P52_SQL );',
'',
'for c in (select object_id from sys.dba_objects where object_name = :p48_name and owner = :OB_SCHEMA and object_type = ''VIEW'') loop',
'  :p52_id := c.object_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(31788810288767680.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4069529214788188.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P52_SQL,',
'    p_schema            => :P48_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(31788810288767680.4504)
);
end;
/
prompt --application/pages/page_00053
begin
wwv_flow_api.create_page(
 p_id=>53.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica dati'
,p_step_title=>'Carica dati'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1336417175981097756.4504)
,p_plug_name=>'Carica dati'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(772857000705594710.4504)
,p_plug_name=>'Dettagli tabella'
,p_parent_plug_id=>wwv_flow_api.id(1336417175981097756.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(772856842476594709.4504)
,p_plug_name=>'Pulsanti'
,p_parent_plug_id=>wwv_flow_api.id(772857000705594710.4504)
,p_region_template_options=>'a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184422955216574823.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(772856842476594709.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP:OBJECT_NAME:&OBJECT_NAME.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184423353096574825.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(772856842476594709.4504)
,p_button_name=>'LOAD_DATA'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Carica dati'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:3100,3110,3120,APEX$DATALOAD_COLUMNS:P3100_SOURCE_TYPE,P3100_LOAD_TO,P3100_TABLE_OWNER,P3100_EXISTING_TABLE:FILE,EXISTING,&P53_OWNER.,&P53_TABLE.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184421826151574812.4504)
,p_name=>'P53_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(772857000705594710.4504)
,p_prompt=>'Proprietario'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184422282314574813.4504)
,p_name=>'P53_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(772857000705594710.4504)
,p_prompt=>'Tabella'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00054
begin
wwv_flow_api.create_page(
 p_id=>54.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Creazione vista non riuscita'
,p_step_title=>'Creazione vista non riuscita'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_views.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14816523412676989.4504)
,p_plug_name=>'Impossibile creare la vista'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>50
,p_plug_source=>'&P54_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P54_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(265757707941998248.4504)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75783414177046532.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(265757707941998248.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15697025198249762.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(265757707941998248.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.:GETOBJECT:&DEBUG.::OB_OBJECT_NAME:&OBJECT_ID.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14826608353710433.4504)
,p_branch_action=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(75783414177046532.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4068002894780655.4504)
,p_name=>'P54_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(14816523412676989.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182397600931010972.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route process'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' for r in ( select object_id,object_name,owner,object_type',
'from sys.dba_objects',
'where owner = :OB_SCHEMA',
'and object_name = :P48_NAME',
'and object_type = ''VIEW'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P54_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00055
begin
wwv_flow_api.create_page(
 p_id=>55.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Vai alla home'
,p_step_title=>'Vai alla home'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>'MUST_NOT_BE_PUBLIC_USER'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(111521808820941179.4504)
,p_branch_action=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00056
begin
wwv_flow_api.create_page(
 p_id=>56.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Importa dizionario attributi'
,p_page_mode=>'MODAL'
,p_step_title=>'Importa dizionario attributi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(442059416850114565.4504)
,p_plug_name=>'Installa dizionario attributi'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_attr_dict_workspace(:P56_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Importazione del file di esportazione riuscita.</p>',
'<p>Per eseguire l''installazione immediatamente, fare clic su <strong>Installa</strong>.</p>',
unistr('<p>\00C8 inoltre possibile installare il file in un secondo momento, spostandosi nel repository di esportazione dell''App Builder.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(442060817629114578.4504)
,p_plug_name=>'Invalid File'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_source=>unistr('Il file non \00E8 un file di esportazione di dizionario tabelle &PRODUCT_NAME. valido.')
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_attr_dict_workspace(:P56_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(717815980221881011.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1019661617684203637.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(717815980221881011.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(442059610391114568.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(717815980221881011.4504)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Installa'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(442060010582114574.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(717815980221881011.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(442062111270114601.4504)
,p_branch_action=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(442059610391114568.4504)
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(442060230463114574.4504)
,p_name=>'P56_FILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(442059416850114565.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(442060601613114576.4504)
,p_name=>'P56_EXP_WORKSPACE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(442059416850114565.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Esportazione da area di lavoro:'
,p_source=>'wwv_flow_imp_parser.get_attr_dict_workspace(:P56_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(442061730972114594.4504)
,p_validation_name=>'check version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :P56_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('NON COMPATIBILE (l''esportazione pu\00F2 contenere chiamate non supportate dalla versione dell''applicazione dell''utente).')
,p_when_button_pressed=>wwv_flow_api.id(442059610391114568.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1019661864828206677.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1019661617684203637.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1019662135563206678.4504)
,p_event_id=>wwv_flow_api.id(1019661864828206677.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(442061927469114595.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_imp_parser.parse (',
'     p_file_id => :P56_FILE_ID',
'     );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Installazione del dizionario attributi non riuscita.'
,p_process_when_button_id=>wwv_flow_api.id(442059610391114568.4504)
,p_process_success_message=>'Dizionario attributi installato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(717815642935877734.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(442059610391114568.4504)
,p_process_success_message=>'Dizionario attributi installato.'
);
end;
/
prompt --application/pages/page_00057
begin
wwv_flow_api.create_page(
 p_id=>57.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Gestisci tabella'
,p_alias=>'INDEX_CREATE'
,p_step_title=>'Gestisci tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31955330727370607.4504)
,p_plug_name=>'Crea indice'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149934430975596262.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149926526903576167.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'F4500_LAST_VIEW'
,p_plug_display_when_cond2=>'2102'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208336826411729249.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118217569695888.4504)
,p_plug_name=>'Crea indice'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31956232290370609.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208336826411729249.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31956525809370609.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208336826411729249.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16045526815792505.4504)
,p_branch_action=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(31956525809370609.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P57_CTYPE'
,p_branch_condition_text=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16048004436795528.4504)
,p_branch_name=>'Go To Page 94'
,p_branch_action=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(31956525809370609.4504)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P57_CTYPE'
,p_branch_condition_text=>'T'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4141319324496024.4504)
,p_branch_name=>'Go To Page 224'
,p_branch_action=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:224,225,226,227:P224_TABLE:&P57_TABLE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(36255912114236908.4504)
,p_branch_name=>'Go To Page 57'
,p_branch_action=>'57'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16025727676754997.4504)
,p_name=>'P57_CTYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(31955330727370607.4504)
,p_item_default=>'N'
,p_prompt=>'Tipo di indice'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE INDEX TYPES'
,p_lov=>'.'||wwv_flow_api.id(16028009107759017.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specificare il tipo di indice da creare. Gli indici normali servono per l''indicizzazione di numeri e data VARCHAR, gli indici di testo servono per l''indicizzazione delle colonne CLOB.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16082819814885127.4504)
,p_name=>'P57_SHOW_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(31955330727370607.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P57_FROM'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Nome della tabella su cui si baser\00E0 la creazione dell''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16108812981939994.4504)
,p_name=>'P57_FROM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(31955330727370607.4504)
,p_source=>':REQUEST'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31956022961370609.4504)
,p_name=>'P57_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(31955330727370607.4504)
,p_prompt=>'Nome tabella'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_name r',
'from sys.dba_tables',
'where owner = :OB_SCHEMA',
'and table_name not like ''BIN$%''',
'and table_name not like ''DR$%''',
'order by 1'))
,p_cSize=>40
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P57_FROM'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Selezionare la tabella che si desidera modificare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31984122526428723.4504)
,p_name=>'P57_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(31955330727370607.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(16127718747007882.4504)
,p_computation_sequence=>10
,p_computation_item=>'P57_TABLE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P57_SHOW_TABLE'
,p_compute_when=>'P57_FROM'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(34727831523348971.4504)
,p_validation_name=>'P57_TABLE Exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_match varchar2(30);',
'begin',
'  l_match := wwv_flow_builder.is_valid_table_or_view',
'    (:OB_SCHEMA,:P57_TABLE);',
'  if l_match = ''E'' then',
'    return true;',
'  elsif l_match = ''U'' then',
'    :P57_TABLE := upper(:P57_TABLE);',
'    return true;',
'  else',
'    return false;',
'  end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'La tabella deve esistere.'
,p_when_button_pressed=>wwv_flow_api.id(31956525809370609.4504)
,p_associated_item=>wwv_flow_api.id(31956022961370609.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 12-FEB-2003 12:07'
);
end;
/
prompt --application/pages/page_00058
begin
wwv_flow_api.create_page(
 p_id=>58.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare il database link'
,p_step_title=>'Impossibile creare il database link'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_dblink.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15527115811594176.4504)
,p_plug_name=>'Impossibile creare il database link'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>21
,p_plug_source=>'&P58_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P58_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969055128057554638.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(155457122955076900.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(969055128057554638.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15528720790605062.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(969055128057554638.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(155764225945313078.4504)
,p_name=>'P58_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15527115811594176.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182539108278268527.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' :OBJECT_ID    := :P92_ID;',
' :OBJECT_NAME  := :P91_NAME;',
' :OBJECT_OWNER := :OB_SCHEMA;',
' :OBJECT_TYPE  := ''DATABASE_LINK'';',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P58_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00059
begin
wwv_flow_api.create_page(
 p_id=>59.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'popup Query Builder'
,p_alias=>'QB_RESULTS'
,p_step_title=>'risultati Query Builder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(14599108081253832.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3647026120165922.4504)
,p_plug_name=>'table popup'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(12270828624874231.4504)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_when_condition=>'TABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3689913662588164.4504)
,p_name=>'P59_CHECK_ALL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3647026120165922.4504)
,p_prompt=>'Seleziona tutto'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'Y_NOPROMPT'
,p_lov=>'.'||wwv_flow_api.id(88018003898325845.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="qb_CheckAllColumns(this)" onclick="this.blur()"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Selezionare le prime 20 colonne di questa tabella. Si possono selezionare fino a 60 colonne.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3692425661657808.4504)
,p_name=>'P59_TNAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3647026120165922.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3695017874693481.4504)
,p_name=>'P59_PARENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3647026120165922.4504)
,p_prompt=>'Aggiungi padre'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TABLE_PARENTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select wwv_flow_lang.system_message(''4500_1002_QB_JOIN'')||',
' '' ''||wwv_flow_escape.html(c.column_name)||'' ''||wwv_flow_lang.system_message(''4500_1002_QB_TO'')||',
' '' ''||wwv_flow_escape.html(p.table_name)||''.''||wwv_flow_escape.html(p.column_name) d , o.object_id||''|''||p.column_name||''|''||c.column_name r ',
'from',
'       sys.dba_cons_columns c,',
'       sys.dba_cons_columns p,',
'        sys.dba_objects o,',
'      ( SELECT c.r_constraint_name pc, c.table_name cn , c.constraint_name cc, rownum',
'        FROM sys.dba_constraints c ',
'        WHERE  c.constraint_type = ''R''',
'        AND c.table_name = :P59_TNAME',
'        and c.owner = :P59_SCHEMA ) t',
'where  t.cc = c.constraint_name',
'and c.owner = :P59_SCHEMA',
'and t.pc = p.constraint_name',
'and p.owner = :P59_SCHEMA',
'and o.object_name = p.table_name',
'and o.owner = c.owner'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="qb_makeJoin(this);"'
,p_label_alignment=>'RIGHT'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from dual where exists (',
' select null ',
' from sys.dba_cons_columns c, ',
' 	  sys.dba_cons_columns p,',
'	  ( SELECT p.table_name pn, p.constraint_name pc, c.table_name cn , c.constraint_name cc ,o.object_id ,o.object_name',
'	    FROM sys.dba_constraints p, sys.dba_constraints c , sys.dba_objects o ',
'	    WHERE (p.constraint_type = ''P'' OR p.constraint_type = ''U'') ',
'		AND c.constraint_type = ''R'' ',
'		AND p.constraint_name = c.r_constraint_name ',
'		AND c.table_name = UPPER(:P59_TNAME) ',
'		and p.owner = :P59_SCHEMA',
'		and o.object_name = p.table_name',
'		and o.owner = p.owner',
'                and p.owner = c.owner) t',
'where t.cc = c.constraint_name',
'and t.pc = p.constraint_name',
'and c.owner = :P59_SCHEMA',
'and p.owner = c.owner ',
')'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare una tabella padre correlata da aggiungere alla query. Le tabelle padre visualizzate sono tabelle a cui fa riferimento la tabella corrente.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3695901382698165.4504)
,p_name=>'P59_CHILDREN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3647026120165922.4504)
,p_prompt=>'Aggiungi figlio'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TABLE_CHILDREN'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''4500_1002_QB_JOIN'')||',
'       '' ''||wwv_flow_escape.html(p.column_name)||',
'       '' ''||wwv_flow_lang.system_message(''4500_1002_QB_TO'')||',
'       '' ''||wwv_flow_escape.html(c.table_name)||''.''||wwv_flow_escape.html(c.column_name) d , t.cid||''|''||c.column_name||''|''||p.column_name r',
'  from sys.dba_cons_columns c,',
'       sys.dba_cons_columns p,',
'       sys.dba_objects o,',
'       ( select c.r_constraint_name pc, ',
'                c.table_name cn, ',
'                c.constraint_name cc,',
'                oo.object_id cid, ',
'                rownum',
'           from sys.dba_constraints c,',
'                sys.dba_objects oo',
'          where c.constraint_type = ''R''',
'            and c.owner = :P59_SCHEMA',
'            and oo.object_name = c.table_name',
'            and oo.owner = c.owner ) t',
' where t.cc             = c.constraint_name',
'   and c.owner          = :P59_SCHEMA',
'   and t.pc             = p.constraint_name',
'   and p.owner          = :P59_SCHEMA',
'   and p.table_name     = :P59_TNAME ',
'   and o.object_name    = p.table_name',
'   and o.owner          = c.owner'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="qb_makeJoin(this);"'
,p_label_alignment=>'RIGHT'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from dual where exists (',
' select null',
' from sys.dba_cons_columns c,',
' 	  sys.dba_cons_columns p,',
'	  ( SELECT p.table_name pn, p.constraint_name pc, c.table_name cn , c.constraint_name cc ,o.object_id ,o.object_name',
'	    FROM sys.dba_constraints p, sys.dba_constraints c , sys.dba_objects o',
'	    WHERE (p.constraint_type = ''P'' OR p.constraint_type = ''U'')',
'		AND c.constraint_type = ''R''',
'		AND p.constraint_name = c.r_constraint_name',
'		AND p.table_name = UPPER(:P59_TNAME)',
'		and p.owner = :P59_SCHEMA',
'		and o.object_name = c.table_name',
'		and o.owner = p.owner',
'                and p.owner = c.owner) t',
'where t.cc = c.constraint_name',
'and t.pc = p.constraint_name',
'and c.owner = :P59_SCHEMA',
'and p.owner = c.owner',
')'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare una tabella figlio correlata da aggiungere alla query. Le tabelle figlio visualizzate fanno riferimento alla chiave primaria di questa tabella.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3700222909808461.4504)
,p_name=>'P59_SCHEMA'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3647026120165922.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4335521893253922.4504)
,p_name=>'P59_BUTTON'
,p_item_sequence=>0
,p_item_plug_id=>wwv_flow_api.id(3647026120165922.4504)
,p_item_default=>'<img src="#IMAGE_PREFIX#qb/vertical_close.png" onclick="qb_tablePopup(this)" style="float:right;" />'
,p_source=>'<img class="htmldbPseudoButton" src="#IMAGE_PREFIX#qb/vertical_close.png" onclick="qb_close(this)" style="float:right;" />'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3723413137900295.4504)
,p_computation_sequence=>10
,p_computation_item=>'P59_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1002_SCHEMA'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00060
begin
wwv_flow_api.create_page(
 p_id=>60.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Editor degli script'
,p_step_title=>'Editor degli script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213236600761856491)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'htmldb_invalid_script_name=''"INVALID_SCRIPT_NAME"'';',
'htmldb_dup_script_name=''"DUP_SCRIPT_NAME"'';',
'htmldb_rename_script_name=''"RENAME_SCRIPT_NAME"'';',
'htmldb_null_script_name=''"NULL_SCRIPT_NAME"'';',
'htmldb_null_script=''"NULL_SCRIPT"'';',
'htmldb_max_script_size=''"MAX_SCRIPT_SIZE"'';',
'',
'var g_run = false;',
'',
'function gStoreScript(req, run, cb) {',
'  var plsqlCode, scriptLength,',
'    saveNew = false,',
'    maxLength = $v("P60_MAX_LENGTH"),',
'    fileID = $v("P60_FILE_ID"),',
'    scriptName = $v("P60_SCRIPT_NAME");',
'',
'  function validateName(s) {',
'    var i, char2check,',
'      invalidChars= ";=\/@&!#$%^*()+=-{}[]|\\:\"''''<>,?/~`";',
'',
'    for (i = 0; i < invalidChars.length; i++) {',
'      char2check = invalidChars.charAt(i);',
'      if (s.indexOf(char2check) > -1) {',
'        return false;',
'      }',
'    }',
'    return true;',
'  }',
'',
'  function dupNameCheck(cb) {',
'    var status = "";',
'    apex.server.process( "sr_dup_name", {',
'        pageItems: ["P60_SCRIPT_NAME", "P60_OLD_SCRIPT_NAME", "P60_FILE_ID"]',
'    }, {',
'      dataType: "text"',
'    }).done(function(data) {',
'      if ( data.substr(0,11) == ''FAIL_RENAME'' ) {',
'        status = "FAIL_RENAME";',
'      } else if ( data.substr(0,4) == ''FAIL'' ) {',
'        status = "FAIL";',
'      } else if ( data.substr(0,8) == ''SAVE_NEW'' ) {',
'        status = "SAVE_NEW";',
'      } else {',
'        status = "SUCCESS";',
'      }',
'    }).always(function() {',
'      cb(status);',
'    });',
'  }',
'',
'  function doSave() {',
'    apex.builder.plugin.codeEditor.saveProcess("#codeEditor_widget", "STORE_SCRIPT", "f01", {f02: fileID,f03: scriptName})',
'      .always(function() {',
'          cb(saveNew);',
'      });',
'  }',
'',
'  plsqlCode = $("#codeEditor_widget").codeEditor("getValue");',
'  scriptLength = plsqlCode.length;',
'',
'  if (!scriptName) {',
'    alert(htmldb_null_script_name);',
'    return false;',
'  }',
'  if (!plsqlCode) {',
'    alert(htmldb_null_script);',
'    return false;',
'  }',
'  if (!validateName(scriptName)) {',
'    alert(htmldb_invalid_script_name);',
'    return false;',
'  }',
'  if (req !== ''GET'' && req !== ''REPLACE'') {',
'    if (scriptLength > maxLength) {',
'      alert(htmldb_max_script_size);',
'      return false;',
'    }',
'',
'    dupNameCheck(function(status) {',
'      if (status == ''FAIL'') {',
'        g_run = run;',
'        apex.theme.openRegion("saveDialog");',
'        return;',
'      } else if (status == ''FAIL_RENAME'') {',
'        alert(htmldb_rename_script_name);',
'        return;',
'      } else if (status == ''SAVE_NEW'' && req != ''CREATE'') {',
'        saveNew = true;',
'      }',
'      doSave()',
'    });',
'  } else {',
'      doSave()',
'  }',
'',
'  return true;',
'}',
'',
'',
'$(document).on("apexreadyend", function() {',
'  apex.jQuery(".a-Body, .a-Main, #codeEditor, #codeEditor > .a-Region-body, .a-MonacoEditor").addClass("resize");',
'  apex.theme.pageResizeInit();',
'});'))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8319409375555186.4504)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(133086723654895090.4504)
,p_plug_name=>'Edit Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2976007666683831.4504)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_sw_api.g_raise_errors'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138352509674476936.4504)
,p_plug_name=>'Salva script'
,p_region_name=>'saveDialog'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1131993087623131882.4504)
,p_plug_display_sequence=>50
,p_plug_source=>unistr('<p>Uno script con lo stesso nome esiste gi\00E0. Sovrascriverlo?</p>')
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(657007663334142125.4504)
,p_plug_name=>'Script'
,p_region_name=>'codeEditor'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'  from wwv_flow_collections',
' where collection_name = ''APEX_4500_60'''))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'DDL'
,p_attribute_02=>'30'
,p_attribute_03=>'N'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138359330068530191.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(138352509674476936.4504)
,p_button_name=>'CANCEL'
,p_button_static_id=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138360700895540644.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(138352509674476936.4504)
,p_button_name=>'YES'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('S\00EC')
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(108477306269478215.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Crea'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(929194157205394205.4504)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'SAVE_ONLY'
,p_button_static_id=>'saveButton'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Salva'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(133097724606939967.4504)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'SAVE'
,p_button_static_id=>'saveButton'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Salva'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(133522817791564007.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106549728476820975.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'DOWNLOAD_SCRIPT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--gapRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Scarica'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91124011966862772.4504)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(70905955607824816.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'CREATE_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Crea applicazione'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:RP,20:P20_SCRIPT_FILE_ID:&P60_FILE_ID.'
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106937316772503576.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'RUN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esegui'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164269527228796320.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_button_name=>'CREATE_RUN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esegui'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(106937509658503599.4504)
,p_branch_action=>'f?p=&APP_ID.:1022:&SESSION.::&DEBUG.::P1022_FILE_ID:&P60_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'((wwv_flow_sw_parser.parsed(:P60_FILE_ID) = 1) and (wwv_flow_sw_script.invalid_script(:P60_FILE_ID) = 1)) AND :REQUEST in (''RUN'',''REPLACE_RUN'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107280029269051559.4504)
,p_branch_action=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::F4500_P10_FILE_ID:&P60_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'((wwv_flow_sw_parser.parsed(:P60_FILE_ID) = 1) and (wwv_flow_sw_script.invalid_script(:P60_FILE_ID) = 0)) AND :REQUEST in (''RUN'',''REPLACE_RUN'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107281716933057420.4504)
,p_branch_action=>'f?p=&APP_ID.:1023:&SESSION.::&DEBUG.::P1023_FILE_ID:&P60_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'((wwv_flow_sw_parser.parsed(:P60_FILE_ID) = 0)) AND :REQUEST in (''RUN'',''REPLACE_RUN'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11486929047542446.4504)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108548416854020696.4504)
,p_name=>'P60_STORE_TEMP_SCRIPT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(133086723654895090.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(133366221073346269.4504)
,p_name=>'P60_MAX_LENGTH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(133086723654895090.4504)
,p_source=>'nvl(wwv_flow_platform.get_preference(''MAX_SCRIPT_SIZE''),500000)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(133520024029557477.4504)
,p_name=>'P60_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(133086723654895090.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138327500427906596.4504)
,p_name=>'P60_OLD_SCRIPT_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'from wwv_flow_files',
'where id = :P60_FILE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(139587000222243903.4504)
,p_name=>'P60_SCRIPT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(8319409375555186.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome script'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'from wwv_flow_files',
'where id = :P60_FILE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>35
,p_cMaxlength=>70
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome dello script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929194302076394207.4504)
,p_name=>'Save'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(133097724606939967.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929194434908394208.4504)
,p_event_id=>wwv_flow_api.id(929194302076394207.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''SAVE'', false, function(saveNew) {',
'  apex.server.process(saveNew ? "sr_create_script" : "sr_save_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      apex.submit(''PARSE'');',
'    }',
'  });',
'});',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929194586508394209.4504)
,p_name=>'Save Only'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(929194157205394205.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929194699358394210.4504)
,p_event_id=>wwv_flow_api.id(929194586508394209.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''SAVE'', false, function(saveNew) {',
'  apex.server.process(saveNew ? "sr_create_script" : "sr_save_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      $("#codeEditor_widget").codeEditor("showNotification", ',
'        "<ul><li class=''is-success''>" + apex.util.escapeHTML(apex.lang.getMessage("SCRIPTS.CHANGES_SAVED")) + "</li></ul>");',
'    }',
'  });',
'});',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929194857449394212.4504)
,p_name=>'Download'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(106549728476820975.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929194943733394213.4504)
,p_event_id=>wwv_flow_api.id(929194857449394212.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''GET'', false, function() {',
'  apex.submit(''DOWNLOAD'');',
'});',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929195078635394214.4504)
,p_name=>'Delete'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(91124011966862772.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929195113281394215.4504)
,p_event_id=>wwv_flow_api.id(929195078635394214.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.confirm(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929195268604394216.4504)
,p_name=>'Create'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(108477306269478215.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929195320595394217.4504)
,p_event_id=>wwv_flow_api.id(929195268604394216.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''CREATE'', false, function() {',
'  apex.server.process("sr_create_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      apex.submit(''PARSE'');',
'    }',
'  });',
'});',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929195456922394218.4504)
,p_name=>'Run'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(106937316772503576.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929195536549394219.4504)
,p_event_id=>wwv_flow_api.id(929195456922394218.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''SAVE'', true, function(saveNew) {',
'  apex.server.process(saveNew ? "sr_create_script" : "sr_save_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      apex.submit(''RUN'');',
'    }',
'  });',
'});',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929195655906394220.4504)
,p_name=>'Create Run'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(164269527228796320.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929195719790394221.4504)
,p_event_id=>wwv_flow_api.id(929195655906394220.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''CREATE'', true, function() {',
'  apex.server.process("sr_create_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      apex.submit(''RUN'');',
'    }',
'  });',
'});',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929196268004394226.4504)
,p_name=>'Update save button'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P60_SCRIPT_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P60_FILE_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929196339444394227.4504)
,p_event_id=>wwv_flow_api.id(929196268004394226.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#saveButton")[0].disabled = $v("P60_SCRIPT_NAME") !== $v("P60_OLD_SCRIPT_NAME");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929196462393394228.4504)
,p_name=>'Cancel'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(138359330068530191.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929196557267394229.4504)
,p_event_id=>wwv_flow_api.id(929196462393394228.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(138352509674476936.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929196601940394230.4504)
,p_name=>'Save and replace'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(138360700895540644.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929196718724394231.4504)
,p_event_id=>wwv_flow_api.id(929196601940394230.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.theme.closeRegion("saveDialog");',
'gStoreScript("REPLACE", g_run, function(saveNew) {',
'  apex.server.process("sr_replace_script", {}, {',
'    dataType: "",',
'    success: function() {',
'        apex.submit(g_run ? "REPLACE_RUN" : "PARSE");',
'    }',
'  });',
'});',
''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(91125406557870640.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_files',
'where id = :P60_FILE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile eliminare lo script.'
,p_process_when_button_id=>wwv_flow_api.id(91124011966862772.4504)
,p_process_success_message=>'Script eliminato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107296117288133287.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clob        clob;',
'  l_script_name varchar2(4000) := null;',
'begin',
'  for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'             from htmldb_collections',
'             where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'    l_clob := c1.script;',
'    l_script_name := c1.name;           ',
'  end loop;',
'  if instr(l_script_name,''.sql'',1) = 0 then',
'  	l_script_name := l_script_name||''.sql'';',
'  end if;',
'  wwv_flow_init_htp_buffer;',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow.g_unrecoverable_error := true;',
'  ',
'  wwv_flow_utilities.print_download_header(',
'    p_mime_type =>     ''text/plain'',',
'    p_file_name =>     l_script_name,',
'    p_is_attachment => true',
'  );',
'  ',
'  sys.owa_util.http_header_close;',
'  ',
'  wwv_flow_sw_script.print_clob(p_str => l_clob);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile scaricare lo script'
,p_process_when=>'DOWNLOAD'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164287405457168586.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set file_id for create and run'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select clob001 script, c001 file_id',
'           from htmldb_collections',
'           where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'    :P60_FILE_ID := c1.file_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'RUN'
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(251810317427563975.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set file_id for replace and run'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'             from htmldb_collections',
'             where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'      for c2 in (select id',
'                 from wwv_flow_files',
'                 where lower(filename) = lower(c1.name)',
'                 and file_type = ''SCRIPT'')',
'      loop',
'          l_file_id := c2.id;',
'          exit;',
'      end loop; ',
'      :P60_FILE_ID := l_file_id;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'REPLACE_RUN,RUN'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(657008053639142129.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert BLOB to CLOB'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob         clob;',
'    l_dest_offsset integer := 1;',
'    l_src_offsset  integer := 1;',
'    l_lang_context integer := sys.dbms_lob.default_lang_ctx;',
'    l_warning      integer;',
'begin',
'    apex_collection.create_or_truncate_collection( ''APEX_4500_60'' );',
'    for c1 in ( select blob_content, file_charset',
'                from wwv_flow_files',
'                where id = :P60_FILE_ID ) loop',
'        sys.dbms_lob.createTemporary(lob_loc => l_clob,cache => false);',
'',
'        sys.dbms_lob.converttoclob(',
'            dest_lob     => l_clob,',
'            src_blob     => c1.blob_content,',
'            amount       => sys.dbms_lob.lobmaxsize,',
'            dest_offset  => l_dest_offsset,',
'            src_offset   => l_src_offsset,',
'            blob_csid    => nvl( nls_charset_id( wwv_flow_lang.map_db_charset( c1.file_charset ) ), sys.dbms_lob.default_csid ),',
'            lang_context => l_lang_context,',
'            warning      => l_warning',
'        );',
'        --if l_warning is null then',
'            apex_collection.add_member( p_collection_name => ''APEX_4500_60'',',
'                                        p_clob001         => l_clob );',
'        --end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(929194220744394206.4504)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'STORE_SCRIPT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'    l_file_id     number := null;',
'    l_script_name varchar2(4000) := null;',
'begin    ',
'    sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'',
'    htmldb_collection.create_or_truncate_collection(',
'        p_collection_name => ''SR_SCRIPT_SOURCE'');',
'',
'    for i in 1..wwv_flow.g_f01.count loop   	   ',
'        sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f01(i)),wwv_flow.g_f01(i));        ',
'    end loop;',
'',
'    l_file_id := wwv_flow_sw_script.array_element(wwv_flow.g_f02,1);',
'    if l_file_id is null then',
'      l_file_id := wwv_flow_id.next_val;',
'    end if;',
'    l_script_name := wwv_flow_sw_script.array_element(wwv_flow.g_f03,1);',
'',
'    htmldb_collection.add_member(',
'        p_collection_name => ''SR_SCRIPT_SOURCE'',',
'        p_c001            => l_file_id,',
'        p_c002            => l_script_name,',
'        p_clob001         => l_code);',
'',
'    sys.owa_util.status_line(204, ''No Content'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00061
begin
wwv_flow_api.create_page(
 p_id=>61.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Controlla aggiornamenti disponibili'
,p_page_mode=>'MODAL'
,p_step_title=>' Aggiornamenti disponibili'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690782249755803171.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_height=>'240'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492584931379861304.4504)
,p_plug_name=>'Controlla aggiornamenti disponibili'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Questa pagina controlla le operazioni richieste e inviate a Oracle Corporation.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492938503955930481.4504)
,p_plug_name=>'Statistiche raccolte'
,p_parent_plug_id=>wwv_flow_api.id(492584931379861304.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(35638231141594602.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'wwv_flow_4000_ui.show_sent_statistics;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(493000426932220927.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492585130076861304.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(493000426932220927.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492585304562861306.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(493000426932220927.4504)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492586206509861315.4504)
,p_name=>'P61_SHOW_NEWS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(492584931379861304.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Mostra area notizie'
,p_source=>'F4500_P1000_SHOW_NEWS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_api.id(23482928300634173.4504)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Questo attributo determina se \00E8 necessario recuperare e visualizzare nella home page le notizie fornite da Oracle Corporation.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492591929567919172.4504)
,p_name=>'P61_SHOW_REPOSITORY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(492584931379861304.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Mostra area repository'
,p_source=>'F4500_P1000_SHOW_REPOSITORY'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_api.id(23482928300634173.4504)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Questo attributo determina se \00E8 necessario visualizzare nella home page l''area repository di &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492593014114924142.4504)
,p_name=>'P61_SHOW_UPDATES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(492584931379861304.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Controlla aggiornamenti disponibili'
,p_source=>'F4500_P1000_SHOW_UPDATES'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_api.id(23482928300634173.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Questo attributo determina se &PRODUCT_NAME. deve controllare la disponibilit\00E0 di aggiornamenti per &PRODUCT_NAME. e Oracle REST Data Services.</p>'),
'',
unistr('<p>Nota: per eseguire il controllo, &PRODUCT_NAME. trasmette il numero di versione di &PRODUCT_NAME. e di altri componenti del sistema a Oracle Corporation. Per continuare a migliorare i propri prodotti, Oracle \00E8 interessata a conoscere l''uso che vie')
||unistr('ne fatto dei prodotti. A questo scopo, sono disponibili statistiche che possono essere inviate a Oracle per descrivere le funzioni del prodotto in uso. Non verr\00E0 inviata alcuna informazione personale. \00C8 possibile esaminare la <a href="https://www.ora')
||'cle.com/privacy">politica sulla privacy di Oracle</a>.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(493002408063253346.4504)
,p_name=>'Statistics Collected'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P61_SEND_STATISTICS'
,p_condition_element=>'P61_SEND_STATISTICS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(493002728685253351.4504)
,p_event_id=>wwv_flow_api.id(493002408063253346.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(492938503955930481.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(493002926711253353.4504)
,p_event_id=>wwv_flow_api.id(493002408063253346.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(492938503955930481.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(716354057925823647.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(492585130076861304.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(716354188181823648.4504)
,p_event_id=>wwv_flow_api.id(716354057925823647.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492612726057239858.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Set F4500_P1000_SHOW_NEWS'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE'
,p_attribute_02=>'F4500_P1000_SHOW_NEWS'
,p_attribute_03=>'P61_SHOW_NEWS'
,p_process_when_button_id=>wwv_flow_api.id(492585304562861306.4504)
,p_process_success_message=>'Preferenze applicate'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492613504370242991.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Set F4500_P1000_SHOW_REPOSITORY'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE'
,p_attribute_02=>'F4500_P1000_SHOW_REPOSITORY'
,p_attribute_03=>'P61_SHOW_REPOSITORY'
,p_process_when_button_id=>wwv_flow_api.id(492585304562861306.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492613909911244609.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Set F4500_P1000_SHOW_UPDATES'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE'
,p_attribute_02=>'F4500_P1000_SHOW_UPDATES'
,p_attribute_03=>'P61_SHOW_UPDATES'
,p_process_when_button_id=>wwv_flow_api.id(492585304562861306.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(716353930713823646.4504)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(492585304562861306.4504)
);
end;
/
prompt --application/pages/page_00062
begin
wwv_flow_api.create_page(
 p_id=>62.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare la funzione'
,p_step_title=>'Impossibile creare la funzione'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_brows_create.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1081400217054630125.4504)
,p_plug_name=>'Impossibile creare la funzione'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_plug_source=>'&P62_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1081400944733630166.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(207425354083369650.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1081400944733630166.4504)
,p_button_name=>'VIEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Visualizza funzione'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP,1001:OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:&P109_OBJECT_ID.,FUNCTION,&P98_SCHEMA.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1081401143595630166.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1081400944733630166.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1081400499335630142.4504)
,p_name=>'P62_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1081400217054630125.4504)
,p_prompt=>'Messaggio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1081401711193630218.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for r in ( select object_id,object_name,owner,object_type',
' from sys.dba_objects',
' where owner = :OB_SCHEMA',
' and object_name = :P98_NAME',
' and object_type = ''FUNCTION'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P62_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00065
begin
wwv_flow_api.create_page(
 p_id=>65.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Esporta script SQL'
,p_step_title=>'Esporta script SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_transfer.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(221594212518002207.4504)
,p_name=>'Script'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'  f.id,',
'  substr(f.filename,1,50) t,',
'  f.created_by,',
'  nvl(f.updated_on,f.created_on) updated,',
'  f.doc_size doc_size',
'from wwv_flow_files f, wwv_flow_fnd_user u',
'where u.security_group_id = :flow_security_group_id',
'and u.user_name = :APP_USER',
'and f.file_type = ''SCRIPT''',
'and (f.created_by = :P65_OWNER or nvl(:P65_OWNER,''0'') = ''0'')',
'and (instr(upper(f.filename||''\\''||f.created_by||''\\''||f.updated_by),',
'     upper(:P65_SCRIPT))>0',
'     or :P65_SCRIPT is null)',
'and f.id not in (select c001 script_id',
'                 from htmldb_collections',
'                 where collection_name = ''SCRIPTS_TO_EXPORT'' )'))
,p_header=>unistr('<p>Utilizzare questa pagina per esportare uno o pi\00F9 script per l''importazione in un''altra area di lavoro.</p>')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessuno script trovato'
,p_query_num_rows_item=>'P65_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(240505720206614239.4504)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(221594526240002215.4504)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(221594728717002215.4504)
,p_query_column_id=>3
,p_column_alias=>'T'
,p_column_display_sequence=>4
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(221594910026002215.4504)
,p_query_column_id=>4
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>3
,p_column_heading=>'Proprietario'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(221595021213002216.4504)
,p_query_column_id=>5
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>5
,p_column_heading=>'Aggiornato'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(221595214182002216.4504)
,p_query_column_id=>6
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>6
,p_column_heading=>'Byte'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(240504819167613940.4504)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(240505025462613941.4504)
,p_column_sequence=>2
,p_query_column_name=>'T'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(240505123175613941.4504)
,p_column_sequence=>3
,p_query_column_name=>'CREATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(240505213863613941.4504)
,p_column_sequence=>4
,p_query_column_name=>'UPDATED'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(240505331731613941.4504)
,p_column_sequence=>5
,p_query_column_name=>'DOC_SIZE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(223023600623732430.4504)
,p_name=>'Script da esportare'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(4,c001) script_id, c003 script_name, c002 script_owner',
'from wwv_flow_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessuno script selezionato per l''esportazione. Selezionare gli script da esportare, quindi fare clic su <strong>Aggiungi a esportazione</strong>.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(240515522022631840.4504)
,p_query_column_id=>1
,p_column_alias=>'SCRIPT_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Rimuovi'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(223024030248732761.4504)
,p_query_column_id=>2
,p_column_alias=>'SCRIPT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236919731229100888.4504)
,p_query_column_id=>3
,p_column_alias=>'SCRIPT_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Proprietario'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(851296250267898501.4504)
,p_plug_name=>'Esporta script SQL'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1141996850168158802.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(221626407641123826.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1141996850168158802.4504)
,p_button_name=>'P65_GO'
,p_button_static_id=>'P65_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(237021909392643306.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(223023600623732430.4504)
,p_button_name=>'REMOVE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Rimuovi selezione'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 e',
'from htmldb_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(236922711190123460.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(223023600623732430.4504)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esporta tutto'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 e',
'from htmldb_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(238488908509330323.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(851296250267898501.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(221610015943050593.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(851296250267898501.4504)
,p_button_name=>'ADD_TO_EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aggiungi a esportazione'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(221610220380050594.4504)
,p_branch_action=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(238489106074330326.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1004:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(238488908509330323.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(221614211488077690.4504)
,p_name=>'P65_SCRIPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1141996850168158802.4504)
,p_prompt=>'Trova'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Individuare gli script in base al nome, al proprietario o all''autore dell''aggiornamento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(221617207810086022.4504)
,p_name=>'P65_OWNER'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(1141996850168158802.4504)
,p_prompt=>'Proprietario'
,p_source=>'APP_USER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_USERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || wwv_flow_lang.system_message(''ALL_USERS'') || '' -'' d, ''0'' r',
'  from dual',
' where exists (',
'    select null',
'      from  wwv_flow_developers ',
'     where security_group_id = :flow_security_group_id ',
'       and userid = :flow_user ',
'       and instr(developer_role||'':'',''ADMIN:'') > 0)',
'union all',
'select user_name d, user_name r',
'  from wwv_flow_fnd_user',
' where security_group_id = :flow_security_group_id',
'   and (user_name = :flow_user or exists',
'        (select null from wwv_flow_developers',
'          where security_group_id = :flow_security_group_id',
'            and userid = :flow_user',
'            and instr(developer_role||'':'',''ADMIN:'') > 0))',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il proprietario degli script che si desidera visualizzare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(221619030666092658.4504)
,p_name=>'P65_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1141996850168158802.4504)
,p_item_default=>'10'
,p_prompt=>'Righe'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identificare il numero di righe da visualizzare per pagina.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(239423928369687764.4504)
,p_name=>'P65_FILE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(223023600623732430.4504)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower(wwv_flow.get_company_name(p_escape=>false))||''_script.sql''',
''))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Nome file'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from htmldb_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Salvare l''esportazione dello script generato con questo nome file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(238654020553478736.4504)
,p_validation_name=>'must select at least one script'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f04.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('\00C8 necessario selezionare almeno uno script da esportare')
,p_when_button_pressed=>wwv_flow_api.id(237021909392643306.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(221625026903119899.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(223021505855686598.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add selected members to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_f01  number := null;',
'  ',
'  function array_element( ',
'      p_vcarr in wwv_flow_global.vc_arr2,',
'      p_index in number )',
'      return varchar2',
'  is',
'      l_return_value varchar2(4000) := NULL;',
'  begin',
'      if p_vcarr is not null then',
'          l_return_value := substr(p_vcarr( p_index ), 1, 4000);',
'      end if;  ',
'      ',
'      return l_return_value;  ',
'  exception',
'      when others then',
'          return NULL;',
'  end;',
'begin',
'  for i in 1..wwv_flow.g_f02.count loop',
'  	l_f01 := array_element(wwv_flow.g_f01,i);',
'  	if l_f01 is not null then',
'      HTMLDB_COLLECTION.ADD_MEMBER(',
'       p_collection_name => ''SCRIPTS_TO_EXPORT'',',
'       p_c001          => wwv_flow.g_f02(l_f01),',
'       p_c002          => wwv_flow.g_f03(l_f01),',
'       p_c003          => wwv_flow.g_f04(l_f01));',
'    end if;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile aggiungere gli script selezionati alla collection.'
,p_process_when_button_id=>wwv_flow_api.id(221610015943050593.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(236921832183120045.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_user     varchar2(255):= null;',
'  l_filename varchar2(32767) := null;',
'begin',
'  l_filename := nvl(:P65_FILE_NAME,wwv_flow.get_company_name(p_escape=>false)||''_script.sql'');',
'',
'  sys.htp.init;',
'  wwv_flow.g_page_text_generated := true;',
'  ',
'  wwv_flow_utilities.print_download_header(',
'      p_mime_type => ''application/text'',',
'      p_is_attachment => true,',
'      p_file_name => l_filename',
'  );',
'  ',
'  sys.owa_util.http_header_close;',
'  ',
'  wwv_flow_gen_api2.export_script(    ',
'      p_commit=>nvl(:F4000_P105_COMMIT,''NO''),',
'      p_format=>:F4000_P105_FORMAT);',
'',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile esportare gli script selezionati.'
,p_process_when_button_id=>wwv_flow_api.id(236922711190123460.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(237315715588692488.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove select script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select seq_id, c001 script_id, c002 script_name, c003 script_owner',
'from htmldb_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'') loop',
'',
'for i in 1..wwv_flow.g_f04.count loop',
'   if wwv_flow.g_f04(i) = c1.script_id then',
'      HTMLDB_COLLECTION.DELETE_MEMBER(',
'       p_collection_name => ''SCRIPTS_TO_EXPORT'',',
'       p_seq => c1.seq_ID);',
'   end if;',
'end loop;',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile rimuovere gli script selezionati.'
,p_process_when_button_id=>wwv_flow_api.id(237021909392643306.4504)
,p_process_success_message=>'Script selezionati rimossi.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(223020132259675341.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create collection if needed'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not HTMLDB_COLLECTION.COLLECTION_EXISTS  (',
'  p_collection_name => ''SCRIPTS_TO_EXPORT'' ) then',
'  ',
'  HTMLDB_COLLECTION.CREATE_COLLECTION(',
'    p_collection_name => ''SCRIPTS_TO_EXPORT'' );',
'  ',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile creare la collection.'
);
end;
/
prompt --application/pages/page_00066
begin
wwv_flow_api.create_page(
 p_id=>66.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Aggiungi colonna'
,p_step_title=>'Aggiungi colonna'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24195900874332971.4504)
,p_plug_name=>'Generate Javascript'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    vColumnListCode VARCHAR2(32000);',
'begin',
'    wwv_flow_javascript.add_library(',
'        p_name      => ''ob_table_functions'',',
'        p_version   => NULL,',
'        p_directory => ''#IMAGE_PREFIX#ob/'');',
'',
'    -- add an on change event for P66_DATATYPE and execute it immediately to set the fields',
'    wwv_flow_javascript.add_onload_code(',
'        p_code => ''apex.jQuery("#P66_DATATYPE").change(ob_setDataType).change();'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31958520054370618.4504)
,p_plug_name=>'Aggiungi colonna'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(31989730538459451.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id,',
'       column_name,',
'       data_type,',
'       data_length,',
'       data_precision,',
'       data_scale,',
'       nullable',
'  from sys.user_tab_columns',
' where table_name= :object_name and column_id is not null',
' order by column_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48680613977771626.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48680717684771626.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48680830383771627.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48680919610771627.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48681028110771627.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48681116161771627.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48681229748771627.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31959729937370622.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31959406946370622.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(31961125684370625.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(31959729937370622.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32355304863054801.4504)
,p_branch_action=>'66'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31959228710370621.4504)
,p_name=>'P66_COL1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_prompt=>'Aggiungi colonna'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specificare il nome della colonna da aggiungere'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31993210714472577.4504)
,p_name=>'P66_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31994425951477045.4504)
,p_name=>'P66_TABLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della tabella in cui aggiungere la colonna'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31996829545487484.4504)
,p_name=>'P66_DATATYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_prompt=>'Tipo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA_TYPES'
,p_lov=>'.'||wwv_flow_api.id(21015224563508746.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare il tipo di dati della colonna da aggiungere'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32001221150504058.4504)
,p_name=>'P66_PRECISION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_prompt=>'Precisione'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specificare la precisione della colonna da aggiungere'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32001825652505295.4504)
,p_name=>'P66_SCALE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_prompt=>'Scala'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specificare la scala della colonna da aggiungere'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32148220791946691.4504)
,p_name=>'P66_LENGTH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_prompt=>'Lunghezza'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specificare la lunghezza della colonna da aggiungere'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35004214374056684.4504)
,p_name=>'P66_NULL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_item_default=>'NULL'
,p_prompt=>'Annullabile'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NULL.NOTNULL'
,p_lov=>'.'||wwv_flow_api.id(88038204225524574.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare se la colonna deve supportare valori NULL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72496005840353862.4504)
,p_name=>'P66_PRESERVE_CASE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(282814305001162696.4504)
,p_name=>'P66_IDENTITY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(31958520054370618.4504)
,p_prompt=>unistr('Identit\00E0')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IDENTITY_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(254185527365105468.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Nessuno'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_show boolean := true;',
'    l_owner varchar2(255) := :OBJECT_OWNER;',
'    l_table varchar2(255) := :OBJECT_NAME;',
'begin',
'    $if wwv_flow_global.g_12c $then',
'        for c1 in (select 1',
'                     from sys.dba_tab_columns',
'                    where owner = l_owner',
'                      and table_name = l_table',
'                      and identity_column = ''YES'' ) loop',
'            l_show := false;',
'        end loop;',
'    $else',
'        l_show := false;',
'    $end',
'    return l_show;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Specificare se la colonna contiene le identit\00E0.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72497628696360397.4504)
,p_computation_sequence=>5
,p_computation_item=>'P66_COL1'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(trim(:P66_COL1),chr(32),''_''))'
,p_compute_when=>'P66_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62310406440011880.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''ADD_COLUMN_NAME'',:P66_COL1);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(32360321186087866.4504)
,p_validation_name=>'P66_COL1 Not Null'
,p_validation_sequence=>1
,p_validation=>'P66_COL1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Aggiungi colonna.'
,p_when_button_pressed=>wwv_flow_api.id(31959729937370622.4504)
,p_associated_item=>wwv_flow_api.id(31959228710370621.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-FEB-2003 17:43'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24199330010369807.4504)
,p_validation_name=>'P66_DATATYPE Not Null'
,p_validation_sequence=>2
,p_validation=>'P66_DATATYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare il tipo di dati.'
,p_when_button_pressed=>wwv_flow_api.id(31959729937370622.4504)
,p_associated_item=>wwv_flow_api.id(31996829545487484.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-FEB-2003 17:49'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24199104599352962.4504)
,p_validation_name=>'Need length for certain data types'
,p_validation_sequence=>3
,p_validation=>'P66_LENGTH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare la lunghezza.'
,p_validation_condition=>'P66_DATATYPE'
,p_validation_condition2=>'VARCHAR2:NVARCHAR2:RAW'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(32148220791946691.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24203306536618452.4504)
,p_validation_name=>'P66_LENGTH is numeric'
,p_validation_sequence=>4
,p_validation=>'P66_LENGTH'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Il valore della lunghezza deve essere numerico.'
,p_when_button_pressed=>wwv_flow_api.id(31959729937370622.4504)
,p_associated_item=>wwv_flow_api.id(32148220791946691.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24203613116620339.4504)
,p_validation_name=>'P66_PRECISION is numeric'
,p_validation_sequence=>5
,p_validation=>'P66_PRECISION'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Il valore della precisione deve essere numerico.'
,p_when_button_pressed=>wwv_flow_api.id(31959729937370622.4504)
,p_associated_item=>wwv_flow_api.id(32001221150504058.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24203820042622291.4504)
,p_validation_name=>'P66_SCALE is numeric'
,p_validation_sequence=>6
,p_validation=>'P66_SCALE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Il valore della scala deve essere numerico.'
,p_when_button_pressed=>wwv_flow_api.id(31959729937370622.4504)
,p_associated_item=>wwv_flow_api.id(32001825652505295.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294824622988842815.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>11
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P66_COL1) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della colonna \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(31959228710370621.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(282816922298194861.4504)
,p_name=>'Toggle IDENTITY'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P66_DATATYPE'
,p_condition_element=>'P66_DATATYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'NUMBER,FLOAT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'wwv_flow_global.g_12c'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(282817214068194862.4504)
,p_event_id=>wwv_flow_api.id(282816922298194861.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P66_IDENTITY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(282817401474194863.4504)
,p_event_id=>wwv_flow_api.id(282816922298194861.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P66_IDENTITY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24209820875707758.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get SQL Statement'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P67_SQL := wwv_flow_sw_util.get_altertable_column_ddl(',
'                    p_owner       => :OBJECT_OWNER,',
'                    p_table_name  => :OBJECT_NAME,',
'                    p_column_name => :P66_COL1,',
'                    p_data_type   => :P66_DATATYPE,',
'                    p_length      => :P66_LENGTH,',
'                    p_precision   => :P66_PRECISION,',
'                    p_scale       => :P66_SCALE,',
'                    p_null        => :P66_NULL,',
'                    p_identity    => :P66_IDENTITY,',
'                    p_action      => ''add'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(31959729937370622.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21978613439156478.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00067
begin
wwv_flow_api.create_page(
 p_id=>67.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma modifica dell''oggetto'
,p_step_title=>'Conferma modifica dell''oggetto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6525315220596275.4504)
,p_plug_name=>'SQL criteri di protezione dati sensibili'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>40
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 ',
'             from sys.dba_tab_privs ',
'            where privilege = ''EXECUTE'' ',
'              and table_name = ''DBMS_REDACT'' ',
'              and grantee = :OBJECT_OWNER ) loop',
'    return :P67_REDACT_SQL is not null;',
'end loop;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31961703823370626.4504)
,p_plug_name=>'Confermare la richiesta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(50858609896789230.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>30
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31962909257370631.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(31961703823370626.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Fine'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31962815244370631.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(31961703823370626.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P67_ACTION'
,p_button_condition2=>'TRUNCATE'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31962628769370631.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(31961703823370626.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(31964314606370635.4504)
,p_branch_action=>'68'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(31962909257370631.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29515102301286299.4504)
,p_branch_action=>'P67_PREVIOUS'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
,p_branch_when_button_id=>wwv_flow_api.id(31962815244370631.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6520631544032226.4504)
,p_name=>'P67_REDACT_SQL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(6525315220596275.4504)
,p_prompt=>'Istruzione SQL criterio di protezione dati sensibili'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14876912012900796.4504)
,p_name=>'P67_NEW_OBJECT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(31961703823370626.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31962431352370630.4504)
,p_name=>'P67_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(50858609896789230.4504)
,p_prompt=>'Istruzione SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32158915605020942.4504)
,p_name=>'P67_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(31961703823370626.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema proprietario dell''oggetto selezionato.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36285221914372264.4504)
,p_name=>'P67_TABLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(31961703823370626.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Oggetto:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Identifica il nome dell''oggetto selezionato.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(50845824329585202.4504)
,p_name=>'P67_PREVIOUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(31961703823370626.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62303216652976982.4504)
,p_name=>'P67_ACTION_TEXT'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(31961703823370626.4504)
,p_prompt=>'Azione:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il tipo di azione da eseguire sull''oggetto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(246007309091952701.4504)
,p_name=>'P67_ACTION'
,p_item_sequence=>40
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72645701927920374.4504)
,p_computation_sequence=>10
,p_computation_item=>'P57_TABLE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P73_NEW_TABLE_NAME'
,p_compute_when=>':P70_ACTION = ''RENAME'' and :REQUEST = ''FINISH'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(50854417468763035.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_PREVIOUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P67_ACTION',
'  when ''GATHER_TABLE_STATS'' then return ''49'';',
'',
'  when ''ADD'' then return ''66'';',
'  when ''MODIFY'' then return ''71'';',
'  when ''REMOVE'' then return ''72'';',
'  when ''TRUNCATE'' then return ''92'';',
'  when ''COPY'' then return ''93'';',
'',
'  when ''ADD_COLUMN'' then return ''66'';',
'  when ''RENAME_COLUMN'' then return ''76'';',
'  when ''DROP_COLUMN'' then return ''72''; ',
'  when ''MODIFY_COLUMN'' then return ''71'';',
'',
'  when ''DROP_CONSTRAINT'' then return ''83'';',
'  when ''ADD_CONSTRAINT'' then return ''79'';',
'  when ''ENABLE_CONSTRAINT'' then return ''82'';',
'  when ''DISABLE_CONSTRAINT'' then return ''80'';',
'',
'  when ''CREATE_INDEX'' then return ''77'';',
'  when ''DROP_INDEX'' then return ''78'';',
'  when ''CREATE_TEXT_INDEX'' then return ''94'';',
'',
'  when ''RENAME'' then return ''73'';',
'',
'  when ''CREATE_TRIGGER'' then return ''84'';',
'  when ''DISABLE_TRIGGER'' then return ''85'';',
'  when ''ENABLE_TRIGGER'' then return ''86'';',
'  when ''DROP_TRIGGER'' then return ''87'';',
'',
'  when ''ANALYZE'' then return ''90'';',
'  when ''REVOKE_GRANT'' then return ''142'';',
'  when ''GRANT'' then return ''143'';',
'else',
'  return ''150'';',
'end case;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15936205953455384.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_SQL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'''truncate table "''||:OBJECT_NAME||''"''||chr(10)||''/'''
,p_compute_when=>'P67_ACTION'
,p_compute_when_text=>'TRUNCATE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(246117024394136994.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''TRUNCATE_TABLE'',:P102_ON);'
,p_compute_when=>'P67_ACTION'
,p_compute_when_text=>'TRUNCATE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34673118851080406.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(31962909257370631.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34854018531007600.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OBJECT_OWNER),',
'              p_sql        => :P67_SQL );',
'',
'if :P67_REDACT_SQL is not null then',
'    :P68_MSG := :P68_MSG||''<p>''||wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OBJECT_OWNER),',
'              p_sql        => :P67_REDACT_SQL );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(31962909257370631.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34855217970016961.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P67_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );',
'',
'if :P67_REDACT_SQL is not null then',
'    wwv_flow_sw_api.save_history (',
'        p_security_group_id => :flow_security_group_id ,',
'        p_user              => :flow_user,',
'        p_sql_cmd           => :P67_REDACT_SQL,',
'        p_schema            => upper(:OB_SCHEMA)',
'        );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(31962909257370631.4504)
);
end;
/
prompt --application/pages/page_00068
begin
wwv_flow_api.create_page(
 p_id=>68.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Gestisci tabella'
,p_step_title=>'Gestisci tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7487708344822391.4504)
,p_plug_name=>'SQL criteri di protezione dati sensibili'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>51
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P67_REDACT_SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15702522390296249.4504)
,p_plug_name=>'Errore'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>31
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''operazione su &OBJECT_TYPE. non \00E8 riuscita per il seguente motivo:'),
'<p>&P68_MSG.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P68_MSG not in (''SUCCESS'',''SUCCESS<p>SUCCESS'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15714628764383203.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>41
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160665102465010569.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15702522390296249.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(160665411613010591.4504)
,p_branch_action=>'f?p=&FLOW_ID.:67:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(160665102465010569.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7488132205834794.4504)
,p_name=>'P68_REDACTION_SQL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(7487708344822391.4504)
,p_source=>'P67_REDACT_SQL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34847107965966675.4504)
,p_name=>'P68_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15714628764383203.4504)
,p_prompt=>'Messaggio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'N'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(71609821128167913.4504)
,p_name=>'P68_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15714628764383203.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265734121536506514.4504)
,p_name=>'P68_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(15714628764383203.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Istruzione SQL'
,p_source=>'P67_SQL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(71613107407173453.4504)
,p_computation_sequence=>10
,p_computation_item=>'P68_OBJECT_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id',
'from sys.dba_objects',
'where owner = :OB_SCHEMA',
'and object_name = :P57_TABLE',
'and object_type = ''TABLE'''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181862205651902265.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reload object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  if ( :P67_ACTION in (''RENAME'',''COPY'') ) then ',
'    if ( :P67_ACTION = ''COPY'') then ',
'        for c1 in (select object_id,object_name,owner,object_type',
'                    from sys.dba_objects',
'                   where owner = :OB_SCHEMA',
'                   and object_name = :P93_NEW_TABLE)',
'       loop',
'          :OBJECT_ID    := c1.object_id;',
'          :OBJECT_NAME  := c1.object_name;',
'          :OBJECT_TYPE  := c1.object_type;',
'          :OBJECT_OWNER := c1.owner;',
'      end loop;',
'   end if;',
'    if ( :P67_ACTION = ''RENAME'') then ',
'        for c1 in (select object_id,object_name,owner,object_type',
'                    from sys.dba_objects',
'                   where owner = :OB_SCHEMA',
'                   and object_name = :P73_NEW_TABLE_NAME)',
'       loop',
'          :OBJECT_ID    := c1.object_id;',
'          :OBJECT_NAME  := c1.object_name;',
'          :OBJECT_TYPE  := c1.object_type;',
'          :OBJECT_OWNER := c1.owner;',
'      end loop;',
'   end if;',
'end if;',
'',
'sys.owa_util.http_header_close;',
'sys.htp.p(''<script>top.gSideBar.reload("TABLE",''||wwv_flow_escape.js_literal(:OBJECT_ID)||'',true);</script>'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P68_MSG in (''SUCCESS'',''SUCCESS<p>SUCCESS'') and  :P67_ACTION in (''RENAME'',''COPY'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(267197326023482486.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reload other objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.owa_util.http_header_close();',
'sys.htp.p(''<script>top.gSideBar.reload('' ||',
'          wwv_flow_escape.js_literal(replace(:OBJECT_TYPE, '' '', ''_'')) || ',
'          '','' ||',
'          wwv_flow_escape.js_literal(:OBJECT_ID) ||',
'          '',true);</script>'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P68_MSG in (''SUCCESS'',''SUCCESS<p>SUCCESS'') and  :P67_ACTION not in (''RENAME'',''COPY'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00070
begin
wwv_flow_api.create_page(
 p_id=>70.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Modifica commento tabella'
,p_step_title=>'Modifica commento tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460471505997643177.4504)
,p_plug_name=>'Modifica commento tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(956276052917084382.4504)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(956277056436094930.4504)
,p_plug_name=>'Modifica commento tabella'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460471703411643179.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(956276052917084382.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460471930670643180.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(956276052917084382.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(460476410549643238.4504)
,p_branch_action=>'701'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460470502008643165.4504)
,p_name=>'P70_EDIT_IND'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(460471505997643177.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460470724212643170.4504)
,p_name=>'P70_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(460471505997643177.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460472113969643181.4504)
,p_name=>'P70_TABLE_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(460471505997643177.4504)
,p_prompt=>'Nome tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460472711726643182.4504)
,p_name=>'P70_TABLE_COMMENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(460471505997643177.4504)
,p_prompt=>'Commento tabella:'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>12
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>'Commenti per la tabella'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(460475202101643222.4504)
,p_computation_sequence=>1
,p_computation_item=>'P70_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P701_OWNER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(460475408127643226.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'UpdateComment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_sw_page_calls.update_comment(:p70_owner,:p70_table_name,:p70_table_comment);',
'    :P70_EDIT_IND := ''N'';',
'    :P70_TABLE_NAME := null;',
'    :P70_TABLE_COMMENT := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante l''aggiornamento del commento.'
,p_process_when_button_id=>wwv_flow_api.id(460471930670643180.4504)
,p_process_success_message=>'Commento aggiornato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(460476012661643231.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'LoadTableComment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_names  wwv_flow_dynamic_exec.vc_arr2;',
'    l_values wwv_flow_dynamic_exec.vc_arr2;',
'begin',
'    l_names(1)  := ''OWNER'';',
'    l_values(1) := nvl(:P70_OWNER, wwv_flow_user_api.get_default_schema);',
'    l_names(2)  := ''TABLE_NAME'';',
'    l_values(2) := :P70_TABLE_NAME;',
'    ',
'    wwv_flow_sw_api.check_priv(l_values(1));',
'',
'    wwv_flow_code_exec.execute (',
'        p_code => q''{',
'begin',
'    for c1 in (',
'    select comments',
'      from sys.all_tab_comments',
'     where table_name = :TABLE_NAME',
'       and owner      = :OWNER )',
'    loop',
'       :P70_TABLE_COMMENT := c1.comments;',
'    end loop;',
'end;}'',',
'    p_language        => wwv_flow_code_exec.c_plsql,',
'    p_names           => l_names,',
'    p_values          => l_values,',
'    p_parse_as_schema => :P70_OWNER );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il caricamento del commento.'
);
end;
/
prompt --application/pages/page_00071
begin
wwv_flow_api.create_page(
 p_id=>71.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Modifica colonna'
,p_step_title=>'Modifica colonna'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function f4500_p71_setColumn(pColumnName, pColumnList){',
'  // pColumnList has to be of format',
'  // { "ABC": {dataType: "NUMBER", length: "10", precision: "5", scale: "3", isNullable: true}, ...next one... }',
'  $s(''P71_LENGTH'',    pColumnList[pColumnName].length);',
'  $s(''P71_PRECISION'', pColumnList[pColumnName].precision);',
'  $s(''P71_SCALE'',     pColumnList[pColumnName].scale);',
'  $s(''P71_NULL'',      (pColumnList[pColumnName].isNullable?''NULL'':''NOT NULL''));',
'  $s(''P71_DATATYPE'',  pColumnList[pColumnName].dataType); /* will trigger the change event */',
'}'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24152101521537761.4504)
,p_plug_name=>'Generate Javascript'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    vColumnListCode VARCHAR2(32000);',
'begin',
'    wwv_flow_javascript.add_library(',
'        p_name      => ''ob_table_functions'',',
'        p_version   => NULL,',
'        p_directory => ''#IMAGE_PREFIX#ob/'');',
'',
'    -- generates a javascript object array in the format',
'    -- { "ABC": {dataType: "NUMBER", length: "10", precision: "5", scale: "3", isNullable: true}, ...next one... }',
'    for r_column in ( select column_name,',
'                             replace(',
'                                 replace(data_type, ''(''||data_precision||'')'', NULL),',
'                                 ''(''||data_scale||'')'', NULL) as data_type,',
'                             data_length,',
'                             data_precision,',
'                             data_scale,',
'                             case nullable when ''Y'' then ''true'' else ''false'' end as is_nullable',
'                        from sys.dba_tab_columns',
'                       where owner      = :OBJECT_OWNER',
'                         and table_name = :OBJECT_NAME',
'                    )',
'    loop',
'        vColumnListCode := vColumnListCode || case when vColumnListCode is not null then '',''||chr(10) end||',
'                           ''"''||r_column.column_name||''":{''||',
'                           ''dataType:"'' ||r_column.data_type     ||''",''||',
'                           ''length:"''   ||r_column.data_length   ||''",''||',
'                           ''precision:"''||r_column.data_precision||''",''||',
'                           ''scale:"''    ||r_column.data_scale    ||''",''||',
'                           ''isNullable:''||r_column.is_nullable   ||''}'';',
'    end loop;',
'    vColumnListCode := ''var lColumnList = {''||vColumnListCode||''};'';',
'',
'    -- add an on change event to P71_COL1 and P71_DATATYPE and trigger it immediately to populate the values',
'    wwv_flow_javascript.add_onload_code(',
'        p_code => ''apex.jQuery("#P71_DATATYPE").change(ob_setDataType);''||chr(10)||',
'                  ''apex.jQuery("#P71_COL1").change(function(){''||chr(10)||',
'                  vColumnListCode||chr(10)||',
'                  ''f4500_p71_setColumn($v("P71_COL1"), lColumnList); }).change();'' );',
'    -- if the page is rerendered because of an error we have to restore the',
'    -- posted values, because setColumn will reset it to the original values',
'    if wwv_flow.g_inline_validation_error_cnt > 0 then',
'        wwv_flow_javascript.add_onload_code(',
'            p_code => ''$s("P71_LENGTH", "''   ||:P71_LENGTH   ||''");''||chr(10)||',
'                      ''$s("P71_PRECISION", "''||:P71_PRECISION||''");''||chr(10)||',
'                      ''$s("P71_SCALE", "''    ||:P71_SCALE    ||''");''||chr(10)||',
'                      ''$s("P71_NULL", "''     ||:P71_NULL     ||''");''||chr(10)||',
'                      ''$s("P71_DATATYPE", "'' ||:P71_DATATYPE ||''");'');',
'    end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32076823606502986.4504)
,p_plug_name=>'Modifica colonna'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Utilizzare questa pagina per aumentare la lunghezza dei tipi di dati per la colonna dei caratteri.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6518916637954833.4504)
,p_plug_name=>'Protezione dati sensibili'
,p_parent_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 ',
'             from sys.dba_tab_privs ',
'            where privilege = ''EXECUTE'' ',
'              and table_name = ''DBMS_REDACT'' ',
'              and grantee = :OBJECT_OWNER ) loop',
'    return true;',
'end loop;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32077427778502992.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id,',
'       column_name,',
'       data_type,',
'       data_length,',
'       data_precision,',
'       data_scale,',
'       nullable',
'  from sys.user_tab_columns',
' where table_name = :OBJECT_NAME and column_id is not null',
' order by column_id'))
,p_header=>'<div id="EXISTING_COLUMNS">'
,p_footer=>'</div>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48470928463770235.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48471012424770236.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48471132186770236.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48471230676770236.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48471315855770237.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48471407780770237.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48471530220770237.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32077721851503004.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32078313689503011.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19397907596155016.4504)
,p_branch_action=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(32078313689503011.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6519320367991859.4504)
,p_name=>'P71_REDACT_NAME_ORIG'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6519522843992183.4504)
,p_name=>'P71_REDACT_EXP_ORIG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6519727333992183.4504)
,p_name=>'P71_REDACT_TYPE_ORIG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6519912387992183.4504)
,p_name=>'P71_REDACT_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_prompt=>'Nome criterio'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_read_only_when=>'P71_REDACT_NAME_ORIG'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Immettere un nome univoco per il criterio di protezione dei dati sensibili.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6520127833992184.4504)
,p_name=>'P71_REDACT_EXP'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_prompt=>'Espressione'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_EXPRESSIONS'
,p_lov=>'.'||wwv_flow_api.id(7516909805609852.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere un''espressione SQL booleana oppure sceglierne una dalla lista popup. La protezione dei dati sensibili viene attivata solo se questa espressione criteri restituisce TRUE. Prestare attenzione durante l''esecuzione dei confronti con il valore N'
||unistr('ULL. Tenere presente che in SQL il valore NULL \00E8 indefinito e che pertanto i confronti con NULL tendono a restituire FALSE. Questa espressione deve essere basata sui valori SYS_CONTEXT di uno spazio di nomi specificato. Lo spazio di nomi predefinito ')
||unistr('per SYS_CONTEXT \00E8 USERENV, che include valori quali SESSION_USER e CLIENT_IDENTIFIER. (Vedere Oracle Database SQL Language Reference per informazioni dettagliate su questa funzione). Oltre a SYS_CONTEXT, \00E8 possibile usare le funzioni V e NV (per Orac')
||unistr('le Application Express) e la funzione DOMINATES (per Oracle Label Security). Non \00E8 possibile usare funzioni create dall''utente nel parametro dell''espressione.'),
'',
unistr('<p />Nell''espressione criteri, oltre alla funzione SYS_CONTEXT, \00E8 possibile usare solo gli operatori seguenti: =, !=, >, <, >=, <=')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6520310781992208.4504)
,p_name=>'P71_REDACT_TYPE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_prompt=>'Tipo di funzione'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:Full;FULL,Partial;PARTIAL,Regular Expression;REGEXP,Random;RANDOM,None;NONE'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleziona tipo protezione dati sensibili --'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare una funzione che imposti il tipo di protezione dei dati sensibili.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7439102119277587.4504)
,p_name=>'P71_FUNCTION_PARMS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_prompt=>'Parametri di funzione'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_FUNC_PARMS'
,p_lov=>'.'||wwv_flow_api.id(7469301964208818.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Immettere o scegliere dalla lista popup la modalit\00E0 di visualizzazione della protezione dei dati sensibili delle colonne. Per ulteriori informazioni, vedere Syntax for Performing Partial Data Redaction in Oracle Database Advanced Security Guide 12c R')
||'elease 1 (12.1).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7439326123277947.4504)
,p_name=>'P71_REGEXP_PATTERN'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_prompt=>'Pattern espressione regolare'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_REGEXP_PATTERN'
,p_lov=>'.'||wwv_flow_api.id(7472906353351996.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Immettere o scegliere dalla lista popup l''espressione regolare per la corrispondenza dei dati sensibili da proteggere. Se viene definita una corrispondenza, i dati sensibili verranno protetti mediante l''espressione regolare specificata nel campo Stri'
||'nga espressione regolare Replace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7439517966277948.4504)
,p_name=>'P71_REGEXP_REPLACE_STR'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_prompt=>'Stringa espressione regolare Replace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_REGEXP_REPL_STR'
,p_lov=>'.'||wwv_flow_api.id(7474914908572203.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Immettere o scegliere dalla lista popup la modalit\00E0 di sostituzione dei dati sensibili da proteggere. I dati possono essere di uno qualsiasi dei tipi CHAR, VARCHAR2, NCHAR e NVARCHAR2. regexp_replace_string pu\00F2 contenere fino a 500 riferimenti all''in')
||unistr('dietro a espressioni secondarie con il formato \005Cn, dove n \00E8 un numero compreso tra 1 e 9. Se si desidera includere una barra rovesciata (\005C) nell''impostazione regexp_replace_string, \00E8 necessario farla precedere da un carattere di escape, ovvero da un''')
||unistr('altra barra rovesciata. Ad esempio, per sostituire letteralmente il pattern corrispondente con \005C2 (anzich\00E9 sostituirlo con la seconda espressione secondaria corrispondente del pattern corrispondente), \00E8 necessario immettere \005C\005C2 nell''impostazione rege')
||'xp_replace_string. Per ulteriori informazioni, vedere Oracle Database SQL Language Reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7439712152277949.4504)
,p_name=>'P71_REGEXP_POSITION'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_item_default=>'1'
,p_prompt=>'Posizione espressione regolare'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>10
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Immettere la posizione iniziale per la ricerca della stringa. Si tratta di un numero intero positivo che indica il carattere dei dati column_name dal quale Oracle Database dovr\00E0 iniziare la ricerca. L''impostazione predefinita 1 indica che Oracle Data')
||'base avvia la ricerca dal primo carattere dei dati column_name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7439928632277949.4504)
,p_name=>'P71_REGEXP_OCCURANCE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_item_default=>'0'
,p_prompt=>'Ricorrenza espressione regolare'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>10
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Immettere un numero intero non negativo per specificare la ricorrenza di esecuzione dell''operazione di ricerca e sostituzione. Se si immette 0, verranno sostituite tutte le ricorrenze.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7440119824277949.4504)
,p_name=>'P71_REGEXP_MATCH_PARM'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_prompt=>'Parametro di corrispondenza espressione regolare'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGEXP_MATCH_PARAM'
,p_lov=>'.'||wwv_flow_api.id(7477530753595662.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleziona parametro corrispondenza --'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Selezionare il funzionamento corrispondente predefinito della funzione. Il funzionamento di questo parametro \00E8 uguale per questa funzione e per la funzione SQL REGEXP_REPLACE.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7462111804491855.4504)
,p_name=>'P71_REMOVE_REDACT_POLICY'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC:Remove redaction policy;Y'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>'P71_REDACT_NAME_ORIG'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7467213177190233.4504)
,p_name=>'P71_REDACT_COLS_ORIG'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7485009130313645.4504)
,p_name=>'P71_REMOVE_COL_FROM_POLICY'
,p_item_sequence=>175
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC:Remove column from policy;Y'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>'P71_REDACT_COLS_ORIG'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7499007775104384.4504)
,p_name=>'P71_REDACT_ENABLED_ORIG'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7501913209314556.4504)
,p_name=>'P71_REDACT_ENABLED'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(6518916637954833.4504)
,p_item_default=>'Y'
,p_prompt=>'Criterio abilitato'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REDACTION_ENABLED'
,p_lov=>'.'||wwv_flow_api.id(7500901536272987.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare Abilita o Disabilita per abilitare o disabilitare il criterio di protezione dei dati sensibili.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32078603721503011.4504)
,p_name=>'P71_COL1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_prompt=>'Colonna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P71_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER',
' and table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare la colonna da modificare'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32078917722503016.4504)
,p_name=>'P71_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32079231310503022.4504)
,p_name=>'P71_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella da modificare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32080113617503024.4504)
,p_name=>'P71_LENGTH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_prompt=>'Lunghezza'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P71_DATATYPE'
,p_display_when2=>'CHAR:VARCHAR2:VARCHAR:CHARACTER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la lunghezza della colonna da modificare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32163915306049192.4504)
,p_name=>'P71_DATATYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_prompt=>'Tipo di dati'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA_TYPES'
,p_lov=>'.'||wwv_flow_api.id(21015224563508746.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare il tipo di dati della colonna da modificare.'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'lov used to be STATIC2:NUMBER;NUMBER,VARCHAR2;VARCHAR2,DATE;DATE,TIMESTAMP;TIMESTAMP,CHAR;CHAR,CLOB;CLOB,BLOB;BLOB,NVARCHAR2;NVARCHAR2'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32364307596102876.4504)
,p_name=>'P71_PRECISION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_prompt=>'Precisione'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P71_DATATYPE'
,p_display_when2=>'NUMBER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la precisione della colonna da modificare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32364912098104207.4504)
,p_name=>'P71_SCALE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_prompt=>'Scala'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P71_DATATYPE'
,p_display_when2=>'NUMBER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la scala della colonna da modificare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35236110481792167.4504)
,p_name=>'P71_NULL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(32076823606502986.4504)
,p_prompt=>'Annullabile'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NULL.NOTNULL'
,p_lov=>'.'||wwv_flow_api.id(88038204225524574.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare se la colonna deve supportare valori NULL'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62354727546216711.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''MODIFY_COLUMN'',:P71_COL1);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(32369911321122959.4504)
,p_validation_name=>'P71_COL1 Not Null'
,p_validation_sequence=>10
,p_validation=>'P71_COL1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Modifica colonna.'
,p_when_button_pressed=>wwv_flow_api.id(32078313689503011.4504)
,p_associated_item=>wwv_flow_api.id(32078603721503011.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-FEB-2003 17:49'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(32370120131122959.4504)
,p_validation_name=>'P71_DATATYPE Not Null'
,p_validation_sequence=>20
,p_validation=>'P71_DATATYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare il tipo di dati.'
,p_when_button_pressed=>wwv_flow_api.id(32078313689503011.4504)
,p_associated_item=>wwv_flow_api.id(32163915306049192.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-FEB-2003 17:49'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24202203157598514.4504)
,p_validation_name=>'P71_LENGTH is numeric'
,p_validation_sequence=>30
,p_validation=>'P71_LENGTH'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Il valore della lunghezza deve essere numerico.'
,p_when_button_pressed=>wwv_flow_api.id(32078313689503011.4504)
,p_associated_item=>wwv_flow_api.id(32080113617503024.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24202602249607704.4504)
,p_validation_name=>'P71_PRECISION is numeric'
,p_validation_sequence=>40
,p_validation=>'P71_PRECISION'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Il valore della precisione deve essere numerico.'
,p_when_button_pressed=>wwv_flow_api.id(32078313689503011.4504)
,p_associated_item=>wwv_flow_api.id(32364307596102876.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24202923374613865.4504)
,p_validation_name=>'P71_SCALE is numeric'
,p_validation_sequence=>50
,p_validation=>'P71_SCALE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Il valore della scala deve essere numerico.'
,p_when_button_pressed=>wwv_flow_api.id(32078313689503011.4504)
,p_associated_item=>wwv_flow_api.id(32364912098104207.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6387227755786319.4504)
,p_validation_name=>'Need length for certain data types'
,p_validation_sequence=>60
,p_validation=>'P71_LENGTH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare la lunghezza.'
,p_validation_condition=>'P71_DATATYPE'
,p_validation_condition2=>'VARCHAR2:NVARCHAR2:RAW'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(32078313689503011.4504)
,p_associated_item=>wwv_flow_api.id(32080113617503024.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(282824032050301702.4504)
,p_name=>'Toggle IDENTITY'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P71_DATATYPE'
,p_condition_element=>'P71_DATATYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'NUMBER,FLOAT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'wwv_flow_global.g_12c'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(282824323843301703.4504)
,p_event_id=>wwv_flow_api.id(282824032050301702.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P71_IDENTITY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(282824531664301703.4504)
,p_event_id=>wwv_flow_api.id(282824032050301702.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P71_IDENTITY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7441011960557451.4504)
,p_name=>'Enable Function Parameters'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P71_REDACT_TYPE'
,p_condition_element=>'P71_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PARTIAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7441308272557607.4504)
,p_event_id=>wwv_flow_api.id(7441011960557451.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P71_FUNCTION_PARMS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7441518076557635.4504)
,p_event_id=>wwv_flow_api.id(7441011960557451.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P71_FUNCTION_PARMS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7441729060571910.4504)
,p_name=>'Enable REGEXP Items'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P71_REDACT_TYPE'
,p_condition_element=>'P71_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGEXP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7442025651571912.4504)
,p_event_id=>wwv_flow_api.id(7441729060571910.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P71_REGEXP_PATTERN,P71_REGEXP_REPLACE_STR,P71_REGEXP_POSITION,P71_REGEXP_OCCURANCE,P71_REGEXP_MATCH_PARM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7442219813571913.4504)
,p_event_id=>wwv_flow_api.id(7441729060571910.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P71_REGEXP_PATTERN,P71_REGEXP_REPLACE_STR,P71_REGEXP_POSITION,P71_REGEXP_OCCURANCE,P71_REGEXP_MATCH_PARM'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7461328191391320.4504)
,p_name=>'get redaction col properties'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P71_COL1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 ',
'             from sys.dba_tab_privs ',
'            where privilege = ''EXECUTE'' ',
'              and table_name = ''DBMS_REDACT'' ',
'              and grantee = :OBJECT_OWNER ) loop',
'    return :P71_REDACT_NAME_ORIG is not null;',
'end loop;',
'return false;',
''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7461631244391595.4504)
,p_event_id=>wwv_flow_api.id(7461328191391320.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P71_REDACT_TYPE,P71_FUNCTION_PARMS,P71_REGEXP_PATTERN,P71_REGEXP_REPLACE_STR,P71_REGEXP_POSITION,P71_REGEXP_OCCURANCE,P71_REGEXP_MATCH_PARM'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(function_type,'' REDACTION'',null) function_type,',
'       function_parameters, regexp_pattern, regexp_replace_string, ',
'       regexp_position, regexp_occurrence, regexp_match_parameter ',
'  from redaction_columns ',
' where object_owner = :OBJECT_OWNER ',
'   and object_name = :OBJECT_NAME ',
'   and column_name = :P71_COL1'))
,p_attribute_07=>'P71_COL1'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24210330702720063.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get SQL Statements'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_redact_action varchar2(128);',
'    l_enabled boolean := true;',
'begin',
'    :P67_SQL := wwv_flow_sw_util.get_altertable_column_ddl(',
'                    p_owner       => :OBJECT_OWNER,',
'                    p_table_name  => :OBJECT_NAME,',
'                    p_column_name => :P71_COL1,',
'                    p_data_type   => :P71_DATATYPE,',
'                    p_length      => :P71_LENGTH,',
'                    p_precision   => :P71_PRECISION,',
'                    p_scale       => :P71_SCALE,',
'                    p_null        => :P71_NULL,',
'                    p_identity    => :P71_IDENTITY,',
'                    p_action      => ''modify'');',
'    if nvl(:P71_REDACT_EXP_ORIG,''x'') != nvl(:P71_REDACT_EXP,''x'') or ',
'       nvl(:P71_REDACT_TYPE_ORIG,''x'') != nvl(:P71_REDACT_TYPE,''x'') or',
'       nvl(:P71_REMOVE_REDACT_POLICY,''N'') = ''Y'' or ',
'       :P71_REDACT_ENABLED_ORIG is not null and :P71_REDACT_ENABLED_ORIG != :P71_REDACT_ENABLED then',
'        if :P71_REDACT_ENABLED != ''Y'' then',
'            l_enabled := false;',
'        end if;',
'        if :P71_REDACT_NAME_ORIG is null then',
'            l_redact_action := ''CREATE'';',
'        elsif nvl(:P71_REMOVE_REDACT_POLICY,''N'') = ''Y'' then',
'            l_redact_action := ''DROP'';',
'        elsif nvl(:P71_REMOVE_COL_FROM_POLICY,''N'') = ''Y'' then ',
'            l_redact_action := ''DROP_COLUMN'';',
'        elsif nvl(:P71_REDACT_EXP_ORIG,''x'') != nvl(:P71_REDACT_EXP,''x'') then',
'            l_redact_action := ''MODIFY_EXPRESSION'';',
'        elsif :P71_REDACT_ENABLED_ORIG is not null ',
'          and :P71_REDACT_ENABLED_ORIG != :P71_REDACT_ENABLED then',
'            l_redact_action := ''ENABLE_DISABLE'';',
'        elsif instr(:P71_REDACT_COLS_ORIG,:P71_COL1||'':'') > 0 then',
'            l_redact_action := ''MODIFY_COLUMN'';',
'        else',
'            l_redact_action := ''ADD_COLUMN'';',
'        end if;',
'        ',
'        :P67_REDACT_SQL := wwv_flow_sw_util.get_data_redaction_ddl(',
'                             p_owner       => :OBJECT_OWNER,',
'                             p_table_name  => :OBJECT_NAME,',
'                             p_column_name => :P71_COL1,',
'                             p_redact_name => :P71_REDACT_NAME,',
'                             p_redact_exp  => :P71_REDACT_EXP,',
'                             p_redact_type => :P71_REDACT_TYPE,',
'                             p_func_parms  => :P71_FUNCTION_PARMS,',
'                             p_regexp_pat  => :P71_REGEXP_PATTERN,',
'                             p_regexp_rep  => :P71_REGEXP_REPLACE_STR,',
'                             p_regexp_pos  => nvl(:P71_REGEXP_POSITION,''1''),',
'                             p_regexp_occ  => nvl(:P71_REGEXP_OCCURANCE,''0''),',
'                             p_regexp_matp => :P71_REGEXP_MATCH_PARM,',
'                             p_enabled     => l_enabled,',
'                             p_action      => l_redact_action );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(32078313689503011.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6522420043619934.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate redaction items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select a.policy_name, a.expression, substr(a.enable,1,1) enable',
'             from redaction_policies a',
'            where a.object_owner = :OBJECT_OWNER',
'              and a.object_name = :OBJECT_NAME ) loop',
'',
'    :P71_REDACT_NAME_ORIG := c1.policy_name;',
'    :P71_REDACT_EXP_ORIG := c1.expression;',
'    :P71_REDACT_ENABLED_ORIG := c1.enable;',
'    :P71_REDACT_NAME := c1.policy_name;',
'    :P71_REDACT_EXP := c1.expression;',
'    :P71_REDACT_ENABLED := c1.enable;',
'end loop;',
'',
'for c1 in (select column_name',
'             from redaction_columns',
'            where object_owner = :OBJECT_OWNER',
'              and object_name = :OBJECT_NAME ) loop',
'    :P71_REDACT_COLS_ORIG := :P71_REDACT_COLS_ORIG||c1.column_name||'':'';',
'end loop;',
'',
'for c1 in (select replace(function_type,'' REDACTION'',null) function_type,',
'       function_parameters, regexp_pattern, regexp_replace_string, ',
'       regexp_position, regexp_occurrence, regexp_match_parameter ',
'  from redaction_columns ',
' where object_owner = :OBJECT_OWNER ',
'   and object_name = :OBJECT_NAME ',
'   and column_name = :P71_COL1 ) loop',
'',
'    :P71_REDACT_TYPE := c1.function_type;',
'    :P71_FUNCTION_PARMS := c1.function_parameters;',
'    :P71_REGEXP_PATTERN := c1.regexp_pattern;',
'    :P71_REGEXP_REPLACE_STR := c1.regexp_replace_string;',
'    :P71_REGEXP_POSITION := c1.regexp_position;',
'    :P71_REGEXP_OCCURANCE := c1.regexp_occurrence;',
'    :P71_REGEXP_MATCH_PARM := c1.regexp_match_parameter;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 ',
'             from sys.dba_tab_privs ',
'            where privilege = ''EXECUTE'' ',
'              and table_name = ''DBMS_REDACT'' ',
'              and grantee = :OBJECT_OWNER ) loop',
'    return :P71_REDACT_NAME_ORIG is null;',
'end loop;',
'return false;',
''))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21956324389636155.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00072
begin
wwv_flow_api.create_page(
 p_id=>72.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Elimina colonna'
,p_step_title=>'Elimina colonna'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32093818186587794.4504)
,p_plug_name=>'Elimina colonna'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32094409149587799.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id,',
'       column_name,',
'       data_type,',
'       data_length,',
'       data_precision,',
'       data_scale,',
'       nullable',
'  from sys.user_tab_columns',
' where table_name = :OBJECT_NAME and column_id is not null',
' order by column_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48873824282772685.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48873923198772685.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48874004176772685.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48874128603772685.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48874208421772685.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48874318918772686.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48874402050772686.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32095424897587803.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(32093818186587794.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32096017004587804.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(32093818186587794.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19401303703172882.4504)
,p_branch_action=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(32096017004587804.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32096603555587806.4504)
,p_name=>'P72_COL1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32093818186587794.4504)
,p_prompt=>'Rimuovi colonna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P71_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER',
' and table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna da rimuovere'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32096907052587806.4504)
,p_name=>'P72_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(32093818186587794.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32097215675587807.4504)
,p_name=>'P72_TABLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(32093818186587794.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella dalla quale rimuovere la colonna'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(32134919387794874.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(4000);',
'  l_col_claus varchar2(255);',
'begin',
'  l_col_claus := ''"''||:P72_COL1||''"''; ',
'  l_sql := wwv_flow_sw_util.get_altertable_ddl(',
'             p_table_name => :OBJECT_NAME,',
'             p_action     => ''drop column'',',
'             p_con_claus  => null,',
'             p_col_claus  => l_col_claus );',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(246065820482003354.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''DROP_COLUMN'',:P72_COL1);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(32361400192091328.4504)
,p_validation_name=>'P72_COL1 Not Null'
,p_validation_sequence=>1
,p_validation=>'P72_COL1'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Specificare un valore per Rimuovi colonna.'
,p_associated_item=>wwv_flow_api.id(32096603555587806.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-FEB-2003 17:44'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21956529237637586.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00073
begin
wwv_flow_api.create_page(
 p_id=>73.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Rinomina tabella'
,p_step_title=>'Rinomina tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32115316863713086.4504)
,p_plug_name=>'Rinomina tabella'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32115605586713088.4504)
,p_plug_name=>'Rinomina tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(81906901123495005.4504)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilizzare questa pagina per rinominare una tabella. L''istruzione ALTER TABLE verr\00E0 generata automaticamente.</p>')
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32115909831713091.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id, COLUMN_NAME,  DATA_TYPE, DATA_LENGTH, DATA_PRECISION, DATA_SCALE, NULLABLE',
'from sys.dba_tab_columns',
'where owner =  nvl(:P56_SCHEMA,:OB_SCHEMA) and',
'table_name= nvl(:p57_table,:OBJECT_NAME) and column_id is not null',
'order by column_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(7082409118250737.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48548801036770760.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48548910953770760.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48549006336770760.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48549130884770761.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48549222694770761.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48549306661770761.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48549400010770761.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32116920222713095.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(32115316863713086.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32117524646713096.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(32115316863713086.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32119409669713101.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(32117524646713096.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32117822205713097.4504)
,p_name=>'P73_NEW_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(32115316863713086.4504)
,p_prompt=>'Nuovo nome tabella'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere un nuovo nome per la tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32118101338713098.4504)
,p_name=>'P73_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32115316863713086.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32118400760713099.4504)
,p_name=>'P73_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32115316863713086.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome corrente tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella corrente'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72603930698805715.4504)
,p_name=>'P73_PRESERVE_CASE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(32115316863713086.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72605313514810168.4504)
,p_computation_sequence=>10
,p_computation_item=>'P73_NEW_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P73_NEW_TABLE_NAME,chr(32),''_''))'
,p_compute_when=>'P73_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(32130115746756001.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(4000);',
'  l_col_claus varchar2(255);',
'begin',
'  l_col_claus := ''to "''||:P73_NEW_TABLE_NAME||''"'';',
'  l_sql := wwv_flow_sw_util.get_altertable_ddl(',
'             p_table_name => :OBJECT_NAME,',
'             p_action     => ''rename'',',
'             p_con_claus  => null,',
'             p_col_claus  => l_col_claus );',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62360806814239066.4504)
,p_computation_sequence=>30
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''RENAME_TABLE'',:OBJECT_NAME,:P73_NEW_TABLE_NAME);'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(246077707369027984.4504)
,p_computation_sequence=>40
,p_computation_item=>'P67_ACTION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'RENAME'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(32372622749126249.4504)
,p_validation_name=>'P73_NEW_TABLE_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P73_NEW_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nuovo nome tabella.'
,p_associated_item=>wwv_flow_api.id(32117822205713097.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-FEB-2003 17:50'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294842200225893076.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P73_NEW_TABLE_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della nuova tabella \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00076
begin
wwv_flow_api.create_page(
 p_id=>76.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Rinomina colonna'
,p_step_title=>'Rinomina colonna'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32421803550702134.4504)
,p_plug_name=>'Rinomina colonna'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('Identificare la colonna da rinominare. Tenere presente che questa azione pu\00F2 avere effetto sui programmi che utilizzano il vecchio nome di colonna.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32422432008702155.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id,',
'       column_name,',
'       data_type,',
'       data_length,',
'       data_precision,',
'       data_scale,',
'       nullable',
'  from sys.user_tab_columns',
' where table_name = :OBJECT_NAME and column_id is not null',
' order by column_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48617000673771229.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48617125212771229.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48617229868771229.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48617307917771229.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48617424949771229.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48617510697771230.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48617616123771230.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32423604400702237.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(32421803550702134.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32424204511702245.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(32421803550702134.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32428427427702304.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(32424204511702245.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32428731522702304.4504)
,p_branch_action=>'71'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32424822487702254.4504)
,p_name=>'P76_NEW_COLUMN_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(32421803550702134.4504)
,p_prompt=>'Nuovo nome colonna'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere il nome per rinominare la colonna'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32425702284702256.4504)
,p_name=>'P76_COL1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(32421803550702134.4504)
,p_prompt=>'Nome colonna corrente'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P76_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna da rinominare'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32426013565702258.4504)
,p_name=>'P76_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32421803550702134.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32426316556702258.4504)
,p_name=>'P76_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32421803550702134.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72595513121781761.4504)
,p_name=>'P76_PRESERVE_CASE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(32421803550702134.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72597900092787455.4504)
,p_computation_sequence=>10
,p_computation_item=>'P76_NEW_COLUMN_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P76_NEW_COLUMN_NAME,chr(32),''_''))'
,p_compute_when=>'P76_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(32427011137702278.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(4000);',
'  l_col_claus varchar2(255);',
'begin',
'  l_col_claus := ''"''||:P76_COL1||''" to "''||:P76_NEW_COLUMN_NAME||''"''; ',
'  l_sql := wwv_flow_sw_util.get_altertable_ddl(',
'             p_table_name => :OBJECT_NAME,',
'             p_action     => ''rename column'',',
'             p_con_claus  => null,',
'             p_col_claus  => l_col_claus );',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62358800450227820.4504)
,p_computation_sequence=>30
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''RENAME_COLUMN'',:P76_COL1,:P76_NEW_COLUMN_NAME);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25598306052823717.4504)
,p_validation_name=>'current col not null'
,p_validation_sequence=>10
,p_validation=>'P76_COL1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome colonna corrente.'
,p_associated_item=>wwv_flow_api.id(32425702284702256.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25599320943828016.4504)
,p_validation_name=>'new col name not null'
,p_validation_sequence=>20
,p_validation=>'P76_NEW_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nuovo nome colonna.'
,p_associated_item=>wwv_flow_api.id(32424822487702254.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294838728360882297.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P76_NEW_COLUMN_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della nuova colonna \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21956919850682186.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00077
begin
wwv_flow_api.create_page(
 p_id=>77.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice'
,p_step_title=>'Crea indice'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32485129415831974.4504)
,p_plug_name=>'Crea indice'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32485706267832015.4504)
,p_name=>'Colonne tabelle'
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id, COLUMN_NAME COLUMN_NAME1,  DATA_TYPE, DATA_LENGTH, DATA_PRECISION, DATA_SCALE, NULLABLE',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P57_TABLE and column_id is not null',
'order by column_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48585329775771038.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'<br />'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159790627635409358.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME1'
,p_column_display_sequence=>2
,p_column_heading=>'Nome colonna'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48585516055771038.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48585627100771039.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48585701664771039.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48585806623771039.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48585920862771039.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32518419220013188.4504)
,p_name=>'Indici tabelle'
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.index_name,',
'       c.column_name, ',
'       c.column_position, ',
'       c.column_length, ',
'       c.descend ',
'from sys.dba_ind_columns c',
'where c.table_name = :P57_TABLE ',
'and c.table_owner = :OB_SCHEMA',
'order by c.index_name, c.column_position'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48512821865770536.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome indice'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48512915514770536.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48513007911770536.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>3
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48513106391770536.4504)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48513205412770536.4504)
,p_query_column_id=>5
,p_column_alias=>'DESCEND'
,p_column_display_sequence=>5
,p_column_heading=>'Ordina'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149948005872626804.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149926526903576167.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'F4500_LAST_VIEW'
,p_plug_display_when_cond2=>'2102'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208338030005739758.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118316275695888.4504)
,p_plug_name=>'Crea indice'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32487319018832027.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208338030005739758.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32487907865832034.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208338030005739758.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16051127985802353.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208338030005739758.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29519220094300863.4504)
,p_branch_action=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::P5_ACTION,P5_PREVIOUS:CREATE_INDEX,77'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(32487907865832034.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32489400580832055.4504)
,p_name=>'P77_COL1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_prompt=>'Colonna 1 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P57_TABLE and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna per la prima posizione nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32489707325832056.4504)
,p_name=>'P77_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32490017423832056.4504)
,p_name=>'P77_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'P57_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella per la quale creare l''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32526706238047271.4504)
,p_name=>'P77_INDEX_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_item_default=>'&P57_TABLE._IDX1'
,p_prompt=>'Nome indice'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere un nome per l''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32540321307089508.4504)
,p_name=>'P77_COL2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_prompt=>'Colonna 2 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P57_TABLE and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna per la seconda posizione nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32540623731090213.4504)
,p_name=>'P77_COL3'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_prompt=>'Colonna 3 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P57_TABLE and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna per la terza posizione nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32540926156090952.4504)
,p_name=>'P77_COL4'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_prompt=>'Colonna 4 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P57_TABLE and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna per la quarta posizione nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34337612000916027.4504)
,p_name=>'P77_UNIQUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_item_default=>'0'
,p_prompt=>unistr('Univocit\00E0')
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UNIQUE'
,p_lov=>'.'||wwv_flow_api.id(88045300809552005.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Non univoco'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Specificare se l''indice sar\00E0 univoco')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72407422210065242.4504)
,p_name=>'P77_PRESERVE_CASE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(32485129415831974.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72416225982113592.4504)
,p_computation_sequence=>10
,p_computation_item=>'P77_INDEX_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P77_INDEX_NAME,chr(32),''_''))'
,p_compute_when=>'P77_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(32490701818832058.4504)
,p_computation_sequence=>20
,p_computation_item=>'P5_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_util.get_index_ddl(',
'         p_table_name => :P57_TABLE,',
'         p_index_name => :P77_INDEX_NAME,',
'         p_action     => ''create'',',
'         p_unique     => :P77_UNIQUE,',
'         p_col1       => :P77_COL1,',
'         p_col2       => :P77_COL2,',
'         p_col3       => :P77_COL3,',
'         p_col4       => :P77_COL4,',
'         p_indextype  => null );'))
,p_computation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare q varchar2(32767);',
'begin',
'   q :=     ''create '';',
'   if :P77_UNIQUE = ''UNIQUE'' then',
'      q := q||''unique '';',
'   end if;',
'   q := q||''index ''||:P77_INDEX_NAME||'' on ''||:P57_TABLE|| '' ('';',
'   if :P77_COL1 != ''0'' then',
'      q := q||:P77_COL1;',
'   end if;',
'   if :P77_COL2 != ''0'' then',
'      q := q||'', ''||:P77_COL2;',
'   end if;',
'   if :P77_COL3 != ''0'' then',
'      q := q||'', ''||:P77_COL3;',
'   end if;',
'   if :P77_COL4 != ''0'' then',
'      q := q||'', ''||:P77_COL4;',
'   end if;',
'   q := q||'')''||chr(10)||''/'';',
'   return q;',
'end;'))
,p_computation_error_message=>'Impossibile generare la sintassi SQL per la creazione dell''indice.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(32535302691065180.4504)
,p_validation_name=>'P77_INDEX_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P77_INDEX_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome indice.'
,p_associated_item=>wwv_flow_api.id(32526706238047271.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(32535500611065184.4504)
,p_validation_name=>'P77_COL1 Not Null'
,p_validation_sequence=>20
,p_validation=>'P77_COL1'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Colonna 1 indice.'
,p_associated_item=>wwv_flow_api.id(32489400580832055.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20256525927998979.4504)
,p_validation_name=>'name too long'
,p_validation_sequence=>30
,p_validation=>'length(:P77_INDEX_NAME) <= wwv_flow_global.c_dbms_id_length'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'I nomi di indice devono avere una lunghezza massima di 30 caratteri.'
,p_when_button_pressed=>wwv_flow_api.id(32487907865832034.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294752327303380442.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P77_INDEX_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato dell''indice \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(268063702683085350.4504)
,p_validation_name=>'name available'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_util.is_available_name2(',
'p_name => :P77_INDEX_NAME,                                          p_owner=> :OB_SCHEMA,',
'p_type => ''INDEX''',
') then',
'  return',
'wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P77_INDEX_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_when_button_pressed=>wwv_flow_api.id(32487907865832034.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00078
begin
wwv_flow_api.create_page(
 p_id=>78.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Elimina indice'
,p_step_title=>'Elimina indice'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32591920534353695.4504)
,p_name=>'Indici esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select index_name,',
'       column_name col_name,',
'       column_position,',
'       column_length,',
'       descend',
'  from sys.user_ind_columns',
' where table_name = :OBJECT_NAME',
' order by index_name, column_position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'>Nessun indice trovato.'
,p_query_row_count_max=>5000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48554603452770785.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome indice'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160687303812058273.4504)
,p_query_column_id=>2
,p_column_alias=>'COL_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48554823761770785.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>3
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48554920215770785.4504)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48555017161770785.4504)
,p_query_column_id=>5
,p_column_alias=>'DESCEND'
,p_column_display_sequence=>5
,p_column_heading=>'Decrescente'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32592210185353701.4504)
,p_plug_name=>'Elimina indice'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32592827834353706.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id,',
'       column_name,',
'       data_type,',
'       data_length,',
'       data_precision,',
'       data_scale,',
'       nullable',
'  from sys.user_tab_columns',
' where table_name = :OBJECT_NAME',
' order by column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48872302244772680.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48872405565772680.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48872512478772680.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48872625246772680.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48872707129772680.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48872831252772680.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48872911674772681.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32595003852353731.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(32592210185353701.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32594416878353712.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(32592210185353701.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32599330557353769.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(32595003852353731.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32599606698353770.4504)
,p_branch_action=>'71'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32595315844353732.4504)
,p_name=>'P78_INDEX_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(32592210185353701.4504)
,p_prompt=>'Elimina questo indice:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(index_name) d, index_name r',
'from sys.dba_indexes',
'where table_name = :OBJECT_NAME and table_owner = :OBJECT_OWNER',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona indice -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Selezionare l''indice che si desidera eliminare.</p>'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32596914492353747.4504)
,p_name=>'P78_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32592210185353701.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32597230080353748.4504)
,p_name=>'P78_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32592210185353701.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella dalla quale rimuovere l''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(32597926757353752.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_util.get_index_ddl(',
'         p_table_name => null,',
'         p_index_name => :P78_INDEX_NAME,',
'         p_action     => ''drop'',',
'         p_unique     => null,',
'         p_col1       => null,',
'         p_col2       => null,',
'         p_col3       => null,',
'         p_col4       => null,',
'         p_indextype  => null );'))
,p_computation_error_message=>'Impossibile generare la sintassi SQL per la creazione dell''indice.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62338021649139305.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'drop index &P78_INDEX_NAME.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(270760026704090342.4504)
,p_validation_name=>'P78_INDEX_NAME'
,p_validation_sequence=>10
,p_validation=>'P78_INDEX_NAME'
,p_validation2=>'0'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>'Specificare un valore.'
,p_when_button_pressed=>wwv_flow_api.id(32595003852353731.4504)
,p_associated_item=>wwv_flow_api.id(32595315844353732.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21980731222445435.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00079
begin
wwv_flow_api.create_page(
 p_id=>79.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Aggiungi vincolo'
,p_step_title=>'Aggiungi vincolo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32636300077490641.4504)
,p_plug_name=>'Aggiungi vincolo'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32636926197490651.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id,',
'       column_name,',
'       data_type,',
'       data_length,',
'       data_precision,',
'       data_scale,',
'       nullable',
'  from sys.user_tab_columns',
' where table_name = :OBJECT_NAME ',
'   and column_id is not null',
' order by column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48691706405771664.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48691804852771664.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48691927968771664.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48692029482771664.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48692117074771664.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48692230465771664.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48692328458771664.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32883508698751250.4504)
,p_name=>'Vincoli esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER constraint_owner,',
'       c.constraint_name,',
'       decode(c.constraint_type,''C'', null, l.column_name) table_column,',
'       decode(c.constraint_type,',
'              ''P'',wwv_flow_lang.system_message(''F4500_PRIMARY''),',
'              ''U'',wwv_flow_lang.system_message(''F4500_UNIQUE''),',
'              ''C'',wwv_flow_lang.system_message(''F4500_CHECK''),',
'              ''R'',wwv_flow_lang.system_message(''F4500_FOREIGN_KEY''))  constraint_type,',
'       initcap(c.status) constraint_status,',
'       c.search_condition,',
'       case when c.constraint_type = ''R'' then',
'           ( select r.owner||''.''||r.table_name||'' (''||c.r_constraint_name||'')''',
'               from apex_sys_all_constraints r',
'              where r.owner           = c.r_owner',
'                and r.constraint_name = c.r_constraint_name',
'           )',
'       end as related_table,',
'       l.position',
'  from sys.user_constraints c,',
'       sys.user_cons_columns l',
' where c.table_name      = :OBJECT_NAME',
'   and c.constraint_type in (''P'', ''U'', ''C'', ''R'')',
'   and l.table_name      = c.table_name',
'   and l.constraint_name = c.constraint_name',
' order by c.constraint_name, c.constraint_type, l.position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48783403508772192.4504)
,p_query_column_id=>1
,p_column_alias=>'CONSTRAINT_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48783506616772192.4504)
,p_query_column_id=>2
,p_column_alias=>'CONSTRAINT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48783631617772192.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_COLUMN'
,p_column_display_sequence=>3
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48783714523772193.4504)
,p_query_column_id=>4
,p_column_alias=>'CONSTRAINT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48783806895772193.4504)
,p_query_column_id=>5
,p_column_alias=>'CONSTRAINT_STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Stato'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48783916740772193.4504)
,p_query_column_id=>6
,p_column_alias=>'SEARCH_CONDITION'
,p_column_display_sequence=>6
,p_column_heading=>'Condizione'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(115224619069111484.4504)
,p_query_column_id=>7
,p_column_alias=>'RELATED_TABLE'
,p_column_display_sequence=>8
,p_column_heading=>'Tabella correlata'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48784012286772193.4504)
,p_query_column_id=>8
,p_column_alias=>'POSITION'
,p_column_display_sequence=>7
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32638430172490662.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32637819258490657.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:TABLE_DETAIL:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(284730704353046532.4504)
,p_branch_action=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.::P67_ACTION:ADD_CONSTRAINT'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(32638430172490662.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32642611399490686.4504)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32638719893490662.4504)
,p_name=>'P79_CHECK_CONSTRAINT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Espressione di vincolo'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>10
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'CHECK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere la condizione di vincolo CHECK SQL. L''espressione viene aggiunta al vincolo ',
'selezionato nel valore della colonna. '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32639027075490664.4504)
,p_name=>'P79_CON_COL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Vincolo su colonna:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'CHECK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna a cui applicare un vincolo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32639326395490665.4504)
,p_name=>'P79_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32639609901490665.4504)
,p_name=>'P79_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella in cui aggiungere il vincolo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32640419435490669.4504)
,p_name=>'P79_CONSTRAINT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_item_default=>'CHECK'
,p_prompt=>'Tipo di vincolo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONSTRAINT.TYPES'
,p_lov=>'.'||wwv_flow_api.id(88046920202557653.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare il tipo di vincolo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32640711752490669.4504)
,p_name=>'P79_CONSTRAINT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_item_default=>'&OBJECT_NAME._CON'
,p_prompt=>'Nome vincolo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'&P79_CONSTRAINT_TYPE.'
,p_display_when2=>'NULL:NOT_NULL'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere il nome del vincolo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34302531946486498.4504)
,p_name=>'P79_NOT_NULL_COLUMN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Non rendere nulla questa colonna:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'NOT_NULL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare se la colonna non deve supportare valori NULL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34304207499564646.4504)
,p_name=>'P79_NULL_COLUMN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Consenti valori nulli in questa colonna:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'NULL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare se la colonna deve supportare valori NULL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34305724814569646.4504)
,p_name=>'P79_UNIQUE_COLUMN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Colonna univoca 1:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'UNIQUE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la prima colonna per il vincolo UNIQUE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34307315941576542.4504)
,p_name=>'P79_PK1'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Colonna 1 chiave primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'PK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la prima colonna per il vincolo PRIMARY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34308225984579433.4504)
,p_name=>'P79_PK2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Colonna 2 chiave primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'PK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la seconda colonna per il vincolo PRIMARY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34308831871581115.4504)
,p_name=>'P79_PK3'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Colonna 3 chiave primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'PK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la terza colonna per il vincolo PRIMARY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34327214546850515.4504)
,p_name=>'P79_FK_TABLE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Nome tabella di riferimento'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(table_name) d, table_name v',
'from sys.dba_tables',
'where owner = :OBJECT_OWNER',
'and table_name not like ''BIN$%''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona tabella di riferimento -'
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'FK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specificare il nome della tabella per la chiave esterna'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34329130261864498.4504)
,p_name=>'P79_FK_COLUMNS'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Colonna/e tabella di riferimento.'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) d, column_name v',
'from sys.dba_tab_columns',
'where owner = :OBJECT_OWNER',
'and table_name = :P79_FK_TABLE and column_id is not null',
'order by 1'))
,p_lov_cascade_parent_items=>'P79_FK_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'FK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna della tabella per la chiave esterna'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34330524851872376.4504)
,p_name=>'P79_FK'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Colonna/e chiavi esterne'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) d, column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_cHeight=>5
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'FK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna contenente una chiave esterna'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35380424398326133.4504)
,p_name=>'P79_UNIQUE_COLUMN2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Colonna univoca 2::'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'UNIQUE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la seconda colonna per il vincolo UNIQUE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35383105482330158.4504)
,p_name=>'P79_UNIQUE_COLUMN3'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_prompt=>'Colonna univoca 3:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'UNIQUE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la terza colonna per il vincolo UNIQUE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72505721470386707.4504)
,p_name=>'P79_PRESERVE_CASE'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(83743732613158499.4504)
,p_name=>'P79_CASCADE'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(32636300077490641.4504)
,p_item_default=>'D'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE_TABLE_FK_TYPE'
,p_lov=>'.'||wwv_flow_api.id(111182618715174982.4504)||'.'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'P79_CONSTRAINT_TYPE'
,p_display_when2=>'FK'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72508627273407347.4504)
,p_computation_sequence=>5
,p_computation_item=>'P79_CONSTRAINT_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P79_CONSTRAINT_NAME,chr(32),''_''))'
,p_compute_when=>'P79_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(32641119513490671.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql         varchar2(4000);',
'  q             varchar2(255);',
'  ',
'  la_fk         wwv_flow_global.vc_arr2;',
'  l_fk          varchar2(4000) := null;',
'  la_fk_columns wwv_flow_global.vc_arr2;',
'  l_fk_columns  varchar2(4000) := null;',
'begin',
'  if :P79_CONSTRAINT_TYPE = ''PK'' then',
'    q := ''"''||:P79_CONSTRAINT_NAME||''"''||',
'       '' primary key ("''||:p79_pk1||''"'';',
'    if :p79_pk2 != ''0'' then',
'       q := q||'', "''||:p79_pk2||''"'';',
'    end if;',
'    if :p79_pk3 != ''0'' then',
'       q := q||'', "''||:p79_pk3||''"'';',
'    end if;',
'    q := q||'')'';',
'  elsif :P79_CONSTRAINT_TYPE = ''FK'' then',
'    la_fk := wwv_flow_utilities.string_to_table2(:p79_fk);',
'    la_fk_columns := wwv_flow_utilities.string_to_table2(:p79_fk_columns);',
'    ',
'    for i in 1..la_fk.count',
'    loop',
'      if i > 1 then',
'        l_fk := l_fk||'','';',
'      end if;',
'      l_fk := l_fk||''"''||la_fk(i)||''"'';',
'    end loop;',
'    for i in 1..la_fk_columns.count',
'    loop',
'      if i > 1 then',
'        l_fk_columns := l_fk_columns||'','';',
'      end if;',
'      l_fk_columns := l_fk_columns||''"''||la_fk_columns(i)||''"'';',
'    end loop;',
'    ',
'    q := ''"''||:P79_CONSTRAINT_NAME||''" foreign key (''||',
'         l_fk||'') references "''||:p79_fk_table||''" (''||',
'         l_fk_columns||'')'';  ',
'    if :P79_CASCADE = ''C'' then',
'      q := q||'' on delete cascade'';',
'    elsif :P79_CASCADE = ''N'' then',
'      q := q||'' on delete set null'';',
'    end if;       ',
'  elsif :P79_CONSTRAINT_TYPE = ''CHECK'' then',
'    q := ''"''||:P79_CONSTRAINT_NAME||''"''||',
'       '' check ( "''||:P79_CON_COL||''" ''||:P79_CHECK_CONSTRAINT||'')'';',
'  elsif :P79_CONSTRAINT_TYPE = ''UNIQUE'' then',
'    q := ''"''||:P79_CONSTRAINT_NAME||''"''||',
'       '' unique ("''||:P79_UNIQUE_COLUMN||''"'';',
'    if :P79_UNIQUE_COLUMN2 != ''0'' then',
'       q := q||'',"''||:P79_UNIQUE_COLUMN2||''"'';',
'    end if;',
'    if :P79_UNIQUE_COLUMN3 != ''0'' then',
'       q := q||'',"''||:P79_UNIQUE_COLUMN3||''"'';',
'    end if;',
'    q := q||'')'';',
'  else',
'    q := ''"''||:P79_CONSTRAINT_NAME||''"''||',
'       '' ''||:P79_CONSTRAINT_TYPE;',
'  end if;',
'  l_sql := wwv_flow_sw_util.get_altertable_ddl(',
'             p_table_name => :OBJECT_NAME,',
'             p_action     => ''add constraint'',',
'             p_con_claus  => q,',
'             p_col_claus  => null );',
'  return l_sql;',
'end;'))
,p_computation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767);',
'begin',
'  if :P79_CONSTRAINT_TYPE = ''PK'' then',
'    q := ''alter table ''||:P57_TABLE||',
'       '' add (constraint ''||:P79_CONSTRAINT_NAME||',
'       '' primary key ( ''||:p79_pk1;',
'    if :p79_pk2 != ''0'' then',
'       q := q||'', ''||:p79_pk2;',
'    end if;',
'    if :p79_pk3 != ''0'' then',
'       q := q||'', ''||:p79_pk3;',
'    end if;',
'    q := q||''))'';',
'  elsif :P79_CONSTRAINT_TYPE = ''FK'' then',
'    q := ''alter table ''||:P57_TABLE||',
'       '' add (constraint ''||:P79_CONSTRAINT_NAME||',
'       '' foreign key ( ''||:p79_fk||'') references (''||',
'       :p79_fk_table||'' (''||:p79_fk_columns||''))'';',
'  elsif :P79_CONSTRAINT_TYPE = ''CHECK'' then',
'    q := ''alter table ''||:P57_TABLE||',
'       '' add (constraint ''||:P79_CONSTRAINT_NAME||',
'       '' check ( ''||:P79_CHECK_CONSTAINT||''))'';',
'  elsif :P79_CONSTRAINT_TYPE = ''NULL'' then',
'    q := ''alter table ''||:P57_TABLE||',
'       '' modify ''||:P79_NULL_COLUMN||',
'       '' null'';',
'  elsif :P79_CONSTRAINT_TYPE = ''NOT_NULL'' then',
'    q := ''alter table ''||:P57_TABLE||',
'       '' modify ''||:P79_NULL_COLUMN||',
'       '' not null'';',
'  elsif :P79_CONSTRAINT_TYPE = ''UNIQUE'' then',
'    q := ''alter table ''||:P57_TABLE||',
'       '' add (constraint ''||:P79_CONSTRAINT_NAME||',
'       '' unique ( ''||:P79_UNIQUE_COLUMN||''))'';',
'  else',
'    q := ''alter table ''||',
'       :P57_TABLE||',
'       '' add (constraint ''||:P79_CONSTRAINT_NAME||',
'       '' ''||:P79_CONSTRAINT_TYPE ||'')'';',
'  end if;',
'  return q;',
'end;'))
,p_computation_error_message=>'Impossibile calcolare l''istruzione SQL.'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62313213151023358.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'add constraint &P79_CONSTRAINT_NAME.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71814927604437735.4504)
,p_validation_name=>'ConstraintNameMand'
,p_validation_sequence=>10
,p_validation=>'P79_CONSTRAINT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome vincolo.'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(32640711752490669.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(99806723153504393.4504)
,p_validation_name=>'ConstraintNameValid'
,p_validation_sequence=>15
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_builder.is_valid_identifier(''"''||:P79_CONSTRAINT_NAME||''"'') then',
'   return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P79_CONSTRAINT_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71829121726511681.4504)
,p_validation_name=>'Check-ColMand'
,p_validation_sequence=>20
,p_validation=>'P79_CON_COL'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Vincolo su colonna.'
,p_validation_condition=>'P79_CONSTRAINT_TYPE'
,p_validation_condition2=>'CHECK'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(32639027075490664.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71858231740637649.4504)
,p_validation_name=>'Check-ConsTextMand'
,p_validation_sequence=>30
,p_validation=>'P79_CHECK_CONSTRAINT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Espressione di vincolo.'
,p_validation_condition=>'P79_CONSTRAINT_TYPE'
,p_validation_condition2=>'CHECK'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(32638719893490662.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71831723956518182.4504)
,p_validation_name=>'UK-UniqueCol1Mand'
,p_validation_sequence=>40
,p_validation=>'P79_UNIQUE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Colonna univoca 1.'
,p_validation_condition=>'P79_CONSTRAINT_TYPE'
,p_validation_condition2=>'UNIQUE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(34305724814569646.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-JUL-2003 17:07'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71832012214518183.4504)
,p_validation_name=>'PK-PKCol1Mand'
,p_validation_sequence=>50
,p_validation=>'P79_PK1'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Colonna 1 chiavi primarie.'
,p_validation_condition=>'P79_CONSTRAINT_TYPE'
,p_validation_condition2=>'PK'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(34307315941576542.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-JUL-2003 17:07'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71832311606518183.4504)
,p_validation_name=>'FK-FKcolMand'
,p_validation_sequence=>60
,p_validation=>'P79_FK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Colonna/e chiavi esterne.'
,p_validation_condition=>'P79_CONSTRAINT_TYPE'
,p_validation_condition2=>'FK'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(34330524851872376.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-JUL-2003 17:07'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71832603835518184.4504)
,p_validation_name=>'FK-FKtableMand'
,p_validation_sequence=>70
,p_validation=>'P79_FK_TABLE'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Nome tabella di riferimento.'
,p_validation_condition=>'P79_CONSTRAINT_TYPE'
,p_validation_condition2=>'FK'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(34327214546850515.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-JUL-2003 17:07'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71832908189518185.4504)
,p_validation_name=>'FK-FKtableColMand'
,p_validation_sequence=>80
,p_validation=>'P79_FK_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Lista colonne tabella di riferimento.'
,p_validation_condition=>'P79_CONSTRAINT_TYPE'
,p_validation_condition2=>'FK'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(32638430172490662.4504)
,p_associated_item=>wwv_flow_api.id(34329130261864498.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-JUL-2003 17:07'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294829915285859571.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P79_CONSTRAINT_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato del vincolo \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21981013785506612.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00080
begin
wwv_flow_api.create_page(
 p_id=>80.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Disabilita vincolo'
,p_step_title=>'Disabilita vincolo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32905606065793633.4504)
,p_plug_name=>'Disabilita vincolo'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32907905028793686.4504)
,p_name=>'Vincoli esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER constraint_owner,',
'       c.constraint_name,',
'       decode(c.constraint_type, ''C'', null, l.column_name) table_column,',
'       decode(c.constraint_type,',
'              ''P'',wwv_flow_lang.system_message(''F4500_PRIMARY''),',
'              ''U'',wwv_flow_lang.system_message(''F4500_UNIQUE''),',
'              ''C'',wwv_flow_lang.system_message(''F4500_CHECK''),',
'              ''R'',wwv_flow_lang.system_message(''F4500_FOREIGN_KEY''))  constraint_type,',
'       initcap(c.status) constraint_status,',
'       c.search_condition,',
'       l.position',
'  from sys.user_constraints c,',
'       sys.user_cons_columns l',
' where c.table_name      = :OBJECT_NAME',
'   and c.constraint_type in (''P'', ''U'', ''C'', ''R'')',
'   and l.table_name      = c.table_name',
'   and l.constraint_name = c.constraint_name',
' order by c.constraint_name, c.constraint_type, l.position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48601600091771130.4504)
,p_query_column_id=>1
,p_column_alias=>'CONSTRAINT_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48601701314771130.4504)
,p_query_column_id=>2
,p_column_alias=>'CONSTRAINT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48601830868771130.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_COLUMN'
,p_column_display_sequence=>3
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48601900006771131.4504)
,p_query_column_id=>4
,p_column_alias=>'CONSTRAINT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48602013616771131.4504)
,p_query_column_id=>5
,p_column_alias=>'CONSTRAINT_STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Stato'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48602124015771131.4504)
,p_query_column_id=>6
,p_column_alias=>'SEARCH_CONDITION'
,p_column_display_sequence=>6
,p_column_heading=>'Condizione'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48602205159771131.4504)
,p_query_column_id=>7
,p_column_alias=>'POSITION'
,p_column_display_sequence=>7
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32909520370793703.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(32905606065793633.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32908918464793689.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(32905606065793633.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32912612202793730.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(32909520370793703.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32912909593793731.4504)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32910403115793712.4504)
,p_name=>'P80_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(32905606065793633.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32910713697793713.4504)
,p_name=>'P80_TABLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(32905606065793633.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella in cui disabilitare il vincolo '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32911603034793715.4504)
,p_name=>'P80_CONSTRAINT_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(32905606065793633.4504)
,p_prompt=>'Identifica vincolo da disabilitare'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MANAGE.TABLE.CONSTRAINTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.constraint_name) d,  c.constraint_name r',
'from sys.dba_constraints c, sys.dba_cons_columns l',
'where c.table_name = :OBJECT_NAME',
'and c.owner = :OBJECT_OWNER',
'and c.constraint_type in (''P'',''U'',''C'',''R'')',
'and c.constraint_name = l.constraint_name ',
'and l.owner = :OBJECT_OWNER',
'and l.table_name = :OBJECT_NAME',
'and (l.position = 1 or l.position is null)',
'and c.status = ''ENABLED''',
'order by c.constraint_name, c.constraint_type, l.position'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona vincolo -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Selezionare il vincolo che si desidera disabilitare.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(32912016704793717.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(4000);',
'begin',
'  l_sql := wwv_flow_sw_util.get_altertable_ddl(',
'             p_table_name => :OBJECT_NAME,',
'             p_action     => ''disable constraint'',',
'             p_con_claus  => :P80_CONSTRAINT_NAME,',
'             p_col_claus  => null );',
'  return l_sql;',
'end;'))
,p_computation_error_message=>'Impossibile calcolare l''istruzione SQL.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62329722380092199.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'disable constraint &P80_CONSTRAINT_NAME.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(246136428859185522.4504)
,p_computation_sequence=>30
,p_computation_item=>'P67_ACTION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'DISABLE_CONSTRAINT'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(34265928202315123.4504)
,p_validation_name=>'item not null'
,p_validation_sequence=>10
,p_validation=>'P80_CONSTRAINT_NAME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore.'
,p_when_button_pressed=>wwv_flow_api.id(32909520370793703.4504)
,p_associated_item=>wwv_flow_api.id(32911603034793715.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21950423444342646.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00082
begin
wwv_flow_api.create_page(
 p_id=>82.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Abilita vincolo'
,p_step_title=>'Abilita vincolo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34269314784357871.4504)
,p_name=>'Vincoli esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER constraint_owner,',
'       c.constraint_name,',
'       decode(c.constraint_type, ''C'', null, l.column_name) table_column,',
'       decode(c.constraint_type,',
'              ''P'',wwv_flow_lang.system_message(''F4500_PRIMARY''),',
'              ''U'',wwv_flow_lang.system_message(''F4500_UNIQUE''),',
'              ''C'',wwv_flow_lang.system_message(''F4500_CHECK''),',
'              ''R'',wwv_flow_lang.system_message(''F4500_FOREIGN_KEY''))  constraint_type,',
'       initcap(c.status) constraint_status,',
'       c.search_condition,',
'       l.position',
'  from sys.user_constraints c,',
'       sys.user_cons_columns l',
' where c.table_name      = :OBJECT_NAME',
'   and c.constraint_type in (''P'', ''U'', ''C'', ''R'')',
'   and l.table_name      = c.table_name',
'   and l.constraint_name = c.constraint_name',
' order by c.constraint_name, c.constraint_type, l.position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48797225517772266.4504)
,p_query_column_id=>1
,p_column_alias=>'CONSTRAINT_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48797309352772266.4504)
,p_query_column_id=>2
,p_column_alias=>'CONSTRAINT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48797423511772266.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_COLUMN'
,p_column_display_sequence=>3
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48797515913772266.4504)
,p_query_column_id=>4
,p_column_alias=>'CONSTRAINT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48797601516772266.4504)
,p_query_column_id=>5
,p_column_alias=>'CONSTRAINT_STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Stato'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48797703522772266.4504)
,p_query_column_id=>6
,p_column_alias=>'SEARCH_CONDITION'
,p_column_display_sequence=>6
,p_column_heading=>'Condizione'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48797817383772267.4504)
,p_query_column_id=>7
,p_column_alias=>'POSITION'
,p_column_display_sequence=>7
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34270329776357876.4504)
,p_plug_name=>'Abilita vincolo'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34271512104357928.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34270329776357876.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34270924063357921.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34270329776357876.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34273718996357960.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(34271512104357928.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34274301807357965.4504)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34271816155357929.4504)
,p_name=>'P82_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(34270329776357876.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34272111588357945.4504)
,p_name=>'P82_TABLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(34270329776357876.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella in cui abilitare il vincolo '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34272725357357946.4504)
,p_name=>'P82_CONSTRAINT_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(34270329776357876.4504)
,p_prompt=>'Identifica vincolo da abilitare'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P82_CONSTRAINTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.constraint_name) d,  c.constraint_name r',
'from sys.dba_constraints c, sys.dba_cons_columns l',
'where c.table_name = :OBJECT_NAME',
'and c.owner = :OBJECT_OWNER',
'and c.constraint_type in (''P'',''U'',''C'',''R'')',
'and c.constraint_name = l.constraint_name ',
'and l.owner = :OBJECT_OWNER',
'and l.table_name = :OBJECT_NAME',
'and c.status = ''DISABLED''',
'order by c.constraint_name, c.constraint_type, l.position'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona vincolo -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Selezionare il vincolo attualmente disabilitato che si desidera abilitare.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34273123382357952.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(4000);',
'begin',
'  l_sql := wwv_flow_sw_util.get_altertable_ddl(',
'             p_table_name => :OBJECT_NAME,',
'             p_action     => ''enable constraint'',',
'             p_con_claus  => :P82_CONSTRAINT_NAME,',
'             p_col_claus  => null );',
'  return l_sql;',
'end;'))
,p_computation_error_message=>'Impossibile calcolare l''istruzione SQL.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62349408714201823.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'enable constraint &P82_CONSTRAINT_NAME.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(246133405656178800.4504)
,p_computation_sequence=>30
,p_computation_item=>'P67_ACTION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ENABLE_CONSTRAINT'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(34273431457357959.4504)
,p_validation_name=>'item not null'
,p_validation_sequence=>10
,p_validation=>'P82_CONSTRAINT_NAME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore.'
,p_when_button_pressed=>wwv_flow_api.id(34271512104357928.4504)
,p_associated_item=>wwv_flow_api.id(34272725357357946.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21959213279756012.4504)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00083
begin
wwv_flow_api.create_page(
 p_id=>83.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Elimina vincolo'
,p_step_title=>'Elimina vincolo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34288320346452314.4504)
,p_plug_name=>'Elimina vincolo'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34289516609452325.4504)
,p_name=>'Vincoli esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER constraint_owner,',
'       c.constraint_name,',
'       decode(c.constraint_type, ''C'', null, l.column_name) table_column,',
'       decode(c.constraint_type,',
'              ''P'',wwv_flow_lang.system_message(''F4500_PRIMARY''),',
'              ''U'',wwv_flow_lang.system_message(''F4500_UNIQUE''),',
'              ''C'',wwv_flow_lang.system_message(''F4500_CHECK''),',
'              ''R'',wwv_flow_lang.system_message(''F4500_FOREIGN_KEY''))  constraint_type,',
'       initcap(c.status) constraint_status,',
'       c.search_condition,',
'       l.position',
'  from sys.user_constraints c,',
'       sys.user_cons_columns l',
' where c.table_name      = :OBJECT_NAME',
'   and c.constraint_type in (''P'', ''U'', ''C'', ''R'')',
'   and l.table_name      = c.table_name',
'   and l.constraint_name = c.constraint_name',
' order by c.constraint_name, c.constraint_type, l.position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48458729423770142.4504)
,p_query_column_id=>1
,p_column_alias=>'CONSTRAINT_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48458825538770142.4504)
,p_query_column_id=>2
,p_column_alias=>'CONSTRAINT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48458931419770142.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_COLUMN'
,p_column_display_sequence=>3
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48459002406770142.4504)
,p_query_column_id=>4
,p_column_alias=>'CONSTRAINT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48459128128770142.4504)
,p_query_column_id=>5
,p_column_alias=>'CONSTRAINT_STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Stato'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48459232662770142.4504)
,p_query_column_id=>6
,p_column_alias=>'SEARCH_CONDITION'
,p_column_display_sequence=>6
,p_column_heading=>'Condizione'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48459306311770142.4504)
,p_query_column_id=>7
,p_column_alias=>'POSITION'
,p_column_display_sequence=>7
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34291107137452330.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34288320346452314.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34290506761452328.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34288320346452314.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34293318201452337.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(34291107137452330.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34293906588452339.4504)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34291400426452331.4504)
,p_name=>'P83_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(34288320346452314.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34291718358452333.4504)
,p_name=>'P83_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(34288320346452314.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella in cui eliminare il vincolo '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34292317611452335.4504)
,p_name=>'P83_CONSTRAINT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(34288320346452314.4504)
,p_prompt=>'Identifica vincolo da eliminare:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.constraint_name) d,  c.constraint_name r',
'from sys.dba_constraints c, sys.dba_cons_columns l',
'where c.table_name = :OBJECT_NAME',
'and c.owner = :OBJECT_OWNER',
'and c.constraint_type in (''P'',''U'',''C'',''R'')',
'and c.constraint_name = l.constraint_name ',
'and l.owner = :OBJECT_OWNER',
'and l.table_name = :OBJECT_NAME',
'and (l.position = 1 or l.position is null)',
'order by c.constraint_name, c.constraint_type, l.position'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona vincolo -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Selezionare il vincolo che si desidera rimuovere.</p>'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34292711969452336.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(4000);',
'begin',
'  l_sql := wwv_flow_sw_util.get_altertable_ddl(',
'             p_table_name => :OBJECT_NAME,',
'             p_action     => ''drop constraint'',',
'             p_con_claus  => ''"''||:P83_CONSTRAINT_NAME||''"'',',
'             p_col_claus  => null );',
'  return l_sql;',
'end;'))
,p_computation_error_message=>'Impossibile calcolare l''istruzione SQL.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62335630738123051.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'drop constraint "&P83_CONSTRAINT_NAME."'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(246130710373170716.4504)
,p_computation_sequence=>30
,p_computation_item=>'P67_ACTION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'DROP_CONSTRAINT'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(34293018753452336.4504)
,p_validation_name=>'item not null'
,p_validation_sequence=>10
,p_validation=>'P83_CONSTRAINT_NAME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore.'
,p_when_button_pressed=>wwv_flow_api.id(34291107137452330.4504)
,p_associated_item=>wwv_flow_api.id(34292317611452335.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21982022621546973.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00084
begin
wwv_flow_api.create_page(
 p_id=>84.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea trigger'
,p_step_title=>'Crea trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="ob_trigTog(''P84_OPT'');"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'function ob_trigTog(pThis){',
'  var tValue = html_GetElement(pThis);',
' if(pThis && tValue && tValue.value == ''update of''){',
'   html_ShowItemRow(''P84_COL_NAME'');',
' }else{',
'   html_HideItemRow(''P84_COL_NAME'');',
' }',
'}',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34361330558113670.4504)
,p_plug_name=>'Crea trigger'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34361826707113674.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id, COLUMN_NAME,  DATA_TYPE, DATA_LENGTH, DATA_PRECISION, DATA_SCALE, NULLABLE',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P3_TABLE and column_id is not null',
'order by column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48459607228770152.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48459712120770152.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48459810419770152.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48459921925770152.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48460030626770152.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48460125453770152.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48460201303770152.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34687113357107190.4504)
,p_name=>'Trigger esistenti'
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'       trigger_name, ',
'       table_owner,',
'       TABLE_NAME,',
'       BASE_OBJECT_TYPE,',
'       TRIGGER_TYPE,',
'       TRIGGERING_EVENT,',
'       WHEN_CLAUSE,',
'       ACTION_TYPE,',
'       status,',
'       TRIGGER_BODY',
'from sys.dba_triggers t',
'where t.table_name = upper(:P3_TABLE)',
'and t.table_owner = :OB_SCHEMA',
'order by t.trigger_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48820214401772382.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema di trigger'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48820310988772382.4504)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48820429020772383.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Schema di tabella'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48820511638772383.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome tabella'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48820627295772383.4504)
,p_query_column_id=>5
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Oggetto base'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48820708242772383.4504)
,p_query_column_id=>6
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48820810116772383.4504)
,p_query_column_id=>7
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>7
,p_column_heading=>'Evento'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48820913099772383.4504)
,p_query_column_id=>8
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>8
,p_column_heading=>'Quando'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48821024101772383.4504)
,p_query_column_id=>9
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>9
,p_column_heading=>'Azione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48821132233772383.4504)
,p_query_column_id=>10
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Stato'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48821231821772384.4504)
,p_query_column_id=>11
,p_column_alias=>'TRIGGER_BODY'
,p_column_display_sequence=>11
,p_column_heading=>'Corpo'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150817011360141482.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150811814776114073.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240128720975023871.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118494150695889.4504)
,p_plug_name=>'Crea trigger'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34364011542113694.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(240128720975023871.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106858312412557446.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240128720975023871.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34363412222113686.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(240128720975023871.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(106856921285550532.4504)
,p_branch_action=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34364308724113695.4504)
,p_name=>'P84_TRIGGER_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_item_default=>'&P84_TABLE._T1'
,p_prompt=>'Nome trigger'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere un nome per il trigger da creare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34364611277113698.4504)
,p_name=>'P84_PROCESSED'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_item_default=>'for each row'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FOR.EACH.ROW'
,p_lov=>'.'||wwv_flow_api.id(88058923955804681.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specificare se deve essere conservata la distinzione tra maiuscole e minuscole nel nome del trigger'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34364924787113699.4504)
,p_name=>'P84_TEXT'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_prompt=>'Corpo trigger:'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>12
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(492677350674053149.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere il corpo PL/SQL per il trigger.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DDL'
,p_attribute_04=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34365511099113700.4504)
,p_name=>'P84_OPT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_item_default=>'insert, update, delete'
,p_prompt=>'Opzioni:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC(~,*):delete*delete~delete, insert*delete, insert~insert*insert~insert, update*insert, update~insert, update, delete*insert, update, delete~update*update~update, delete*update, delete~update of *update of'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'onchange="ob_trigTog(this)"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare le azioni che comportano l''esecuzione del trigger.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34365831815113701.4504)
,p_name=>'P84_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&OB_SCHEMA.'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica il nome del proprietario dello schema di database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34366129993113702.4504)
,p_name=>'P84_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'upper(:P3_TABLE)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tabella:'
,p_source=>':P3_TABLE'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il nome della tabella associata al trigger.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34366707111113706.4504)
,p_name=>'P84_BEFORE_OR_AFTER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_item_default=>'BEFORE'
,p_prompt=>'Punto di attivazione:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:BEFORE;BEFORE,AFTER;AFTER'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specificare quando il trigger deve essere eseguito.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34381011728171438.4504)
,p_name=>'P84_TNAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'upper(:P3_TABLE)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'su:'
,p_source=>':P3_TABLE'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il nome della tabella associata al trigger.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72453601282248442.4504)
,p_name=>'P84_PRESERVE_CASE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(111293211386768988.4504)
,p_name=>'P84_COL_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_prompt=>'Colonna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select wwv_flow_escape.html(column_name) d, column_name r from sys.dba_tab_columns where table_name = :P84_TABLE and owner = :OB_SCHEMA'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Scegliere una colonna se si seleziona un trigger di aggiornamento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(111349427596943913.4504)
,p_name=>'P84_WHEN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(34361330558113670.4504)
,p_prompt=>'Quando'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Immettere una clausola WHEN valida per il trigger. \00C8 possibile utilizzare i riferimenti. Ad esempio:'),
'<code>',
'NEW.deptno > 5',
'</code>',
'<p>',
unistr('Nella clausola WHEN non \00E8 possibile utilizzare la sintassi :NEW.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72463511025279637.4504)
,p_computation_sequence=>10
,p_computation_item=>'P84_TRIGGER_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P84_TRIGGER_NAME,chr(32),''_''))'
,p_compute_when=>'P84_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34367105575113713.4504)
,p_computation_sequence=>20
,p_computation_item=>'P9_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
't_name varchar2(2000);',
'begin',
' if :P84_PRESERVE_CASE = ''Y'' then',
'   t_name := :P84_TRIGGER_NAME;',
' else',
'   t_name := upper(:P84_TRIGGER_NAME);',
' end if;',
'return wwv_flow_sw_util.get_trigger2_ddl(',
'         p_table_name => :P3_TABLE,',
'         p_action     => ''create or replace'',',
'         p_trigger_nm => t_name,',
'         p_when       => :P84_BEFORE_OR_AFTER,',
'         p_operations => replace(:P84_OPT,'','','' or''),',
'         p_for_each   => :P84_PROCESSED,',
'         p_body       => :P84_TEXT,',
'         p_col        => :P84_COL_NAME,',
'         p_col_when   => :P84_WHEN );',
'end;'))
,p_computation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare q varchar2(32767);',
'begin',
'   q := ''create or replace trigger ''||:P84_TRIGGER_NAME||chr(10);',
'   q := q||:P84_BEFORE_OR_AFTER||'' ''||replace(:P84_OPT,'','','' or'')||',
'        '' on ''||:p57_TABLE||chr(10);',
'   q := q||:P84_PROCESSED||chr(10);',
'   q := q||''begin''||chr(10)||:P84_TEXT||chr(10)||''end;''||chr(10)||''/'';   ',
'   return q;',
'end;'))
,p_computation_error_message=>'Impossibile generare la sintassi SQL per la creazione dell''indice.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(268079610835201275.4504)
,p_validation_name=>'available name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_util.is_available_name2(',
'        p_name => :P84_TRIGGER_NAME,',
'        p_owner=> :OB_SCHEMA,',
'        p_type => ''TRIGGER'' ) then',
'   return',
'wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P84_TRIGGER_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_when_button_pressed=>wwv_flow_api.id(34364011542113694.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71733026817380701.4504)
,p_validation_name=>'TriggerNameMand'
,p_validation_sequence=>20
,p_validation=>'P84_TRIGGER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare il nome del trigger.'
,p_associated_item=>wwv_flow_api.id(34364308724113695.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294803705701714850.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P84_TRIGGER_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato del trigger \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(111369629253039073.4504)
,p_validation_name=>'valid update of and column name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p84_opt = ''update of'' and :p84_col_name = ''0'' then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Selezionare una colonna per l''aggiornamento del trigger'
,p_when_button_pressed=>wwv_flow_api.id(34364011542113694.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00085
begin
wwv_flow_api.create_page(
 p_id=>85.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Disabilita trigger'
,p_step_title=>'Disabilita trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34532900127735750.4504)
,p_plug_name=>'Disabilita trigger'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34689808986115378.4504)
,p_name=>'Trigger esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER as owner,',
'       trigger_name,',
'       table_owner,',
'       table_name,',
'       base_object_type,',
'       trigger_type,',
'       triggering_event,',
'       when_clause,',
'       action_type,',
'       status,',
'       trigger_body',
'  from sys.user_triggers',
' where table_name = :OBJECT_NAME',
' order by trigger_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48534407737770673.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema di trigger'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48534506504770673.4504)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48534617018770674.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Schema di tabella'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48534724324770674.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome tabella'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48534804145770674.4504)
,p_query_column_id=>5
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Oggetto base'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48534913848770674.4504)
,p_query_column_id=>6
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48535012005770674.4504)
,p_query_column_id=>7
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>7
,p_column_heading=>'Evento'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48535131352770674.4504)
,p_query_column_id=>8
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>8
,p_column_heading=>'Quando'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48535220649770674.4504)
,p_query_column_id=>9
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>9
,p_column_heading=>'Azione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48535315642770674.4504)
,p_query_column_id=>10
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Stato'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48535421718770675.4504)
,p_query_column_id=>11
,p_column_alias=>'TRIGGER_BODY'
,p_column_display_sequence=>11
,p_column_heading=>'Corpo'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34534107021735762.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34532900127735750.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34533509811735754.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34532900127735750.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34536218725735789.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(34534107021735762.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34536818737735798.4504)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34534431105735763.4504)
,p_name=>'P85_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(34532900127735750.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34534723507735767.4504)
,p_name=>'P85_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(34532900127735750.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella per la quale disabilitare un trigger'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34535212202735769.4504)
,p_name=>'P85_TRIGGER_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(34532900127735750.4504)
,p_prompt=>'Identifica trigger da disabilitare'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.trigger_name) d, t.trigger_name r',
'from sys.dba_triggers t',
'where t.table_name = :OBJECT_NAME',
'and t.table_owner = :OBJECT_OWNER',
'order by t.trigger_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona trigger -'
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Selezionare il trigger che si desidera disabilitare.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34535616749735772.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return ''alter trigger "''||:P85_TRIGGER_NAME||''" disable'';'
,p_computation_error_message=>'Impossibile calcolare l''istruzione SQL.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62331532207104555.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''DISABLE_TRIGGER'',:P85_TRIGGER_NAME);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(34554606693774107.4504)
,p_validation_name=>'P85_TRIGGER_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P85_TRIGGER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare il trigger da disabilitare.'
,p_associated_item=>wwv_flow_api.id(34535212202735769.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 12-FEB-2003 10:31'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21982522498963225.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00086
begin
wwv_flow_api.create_page(
 p_id=>86.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Abilita trigger'
,p_step_title=>'Abilita trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34569822515803765.4504)
,p_plug_name=>'Abilita trigger'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34699609463125056.4504)
,p_name=>'Trigger esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER as owner,',
'       trigger_name,',
'       table_owner,',
'       table_name,',
'       base_object_type,',
'       trigger_type,',
'       triggering_event,',
'       when_clause,',
'       action_type,',
'       status,',
'       trigger_body',
'  from sys.user_triggers',
' where table_name = :OBJECT_NAME',
' order by trigger_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48480713123770294.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema di trigger'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48480813244770294.4504)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48480926298770294.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Schema di tabella'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48481018657770294.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome tabella'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48481125147770295.4504)
,p_query_column_id=>5
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Oggetto base'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48481212000770295.4504)
,p_query_column_id=>6
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48481311297770295.4504)
,p_query_column_id=>7
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>7
,p_column_heading=>'Evento'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48481420044770295.4504)
,p_query_column_id=>8
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>8
,p_column_heading=>'Quando'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48481520138770295.4504)
,p_query_column_id=>9
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>9
,p_column_heading=>'Azione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48481603885770295.4504)
,p_query_column_id=>10
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Stato'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48481704737770295.4504)
,p_query_column_id=>11
,p_column_alias=>'TRIGGER_BODY'
,p_column_display_sequence=>11
,p_column_heading=>'Corpo'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34572509688803787.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34569822515803765.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34571908284803781.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34569822515803765.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34574719366803801.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(34572509688803787.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34575322351803802.4504)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34572804703803788.4504)
,p_name=>'P86_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(34569822515803765.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34573111734803791.4504)
,p_name=>'P86_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(34569822515803765.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella per la quale abilitare un trigger'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34573712350803794.4504)
,p_name=>'P86_TRIGGER_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(34569822515803765.4504)
,p_prompt=>'Identifica trigger da abilitare'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P86_TRIGGERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.trigger_name)||'' (''||t.status||'')'' d, t.trigger_name r',
'from sys.dba_triggers t',
'where t.table_name = :OBJECT_NAME ',
'and t.table_owner = :OBJECT_OWNER',
'order by t.trigger_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona trigger -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Selezionare il trigger che si desidera disabilitare.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34574106802803795.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return ''alter trigger "''||:P86_TRIGGER_NAME||''" enable'';'
,p_computation_error_message=>'Impossibile calcolare l''istruzione SQL.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62306404447992440.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''ENABLE_TRIGGER'',:P86_TRIGGER_NAME);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(34574401875803800.4504)
,p_validation_name=>'P86_TRIGGER_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P86_TRIGGER_NAME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare il nome del trigger.'
,p_associated_item=>wwv_flow_api.id(34573712350803794.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 12-FEB-2003 10:31'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21959606690028437.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00087
begin
wwv_flow_api.create_page(
 p_id=>87.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Elimina trigger'
,p_step_title=>'Elimina trigger'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34654720062038638.4504)
,p_plug_name=>'Elimina trigger'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34655314117038642.4504)
,p_name=>'Trigger esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER as owner,',
'       trigger_name,',
'       table_owner,',
'       table_name,',
'       base_object_type,',
'       trigger_type,',
'       triggering_event,',
'       when_clause,',
'       action_type,',
'       status,',
'       trigger_body',
'  from sys.user_triggers',
' where table_name = :OBJECT_NAME',
' order by trigger_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710014780771732.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Schema di trigger'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710120452771732.4504)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710213651771732.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Schema di tabella'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710312572771732.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome tabella'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710415849771732.4504)
,p_query_column_id=>5
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Oggetto base'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710514626771732.4504)
,p_query_column_id=>6
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710603758771733.4504)
,p_query_column_id=>7
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>7
,p_column_heading=>'Evento'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710704676771733.4504)
,p_query_column_id=>8
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>8
,p_column_heading=>'Quando'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710819154771733.4504)
,p_query_column_id=>9
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>9
,p_column_heading=>'Azione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48710911856771733.4504)
,p_query_column_id=>10
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Stato'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48711019614771733.4504)
,p_query_column_id=>11
,p_column_alias=>'TRIGGER_BODY'
,p_column_display_sequence=>11
,p_column_heading=>'Corpo'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34657524492038656.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34654720062038638.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34656924259038654.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34654720062038638.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34659623944038675.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(34657524492038656.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34660202405038676.4504)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34657821777038656.4504)
,p_name=>'P87_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(34654720062038638.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34658104220038657.4504)
,p_name=>'P87_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(34654720062038638.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella dalla quale eliminare un trigger'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34658730547038659.4504)
,p_name=>'P87_TRIGGER_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(34654720062038638.4504)
,p_prompt=>'Elimina trigger'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.trigger_name) d, t.trigger_name r',
'from sys.dba_triggers t',
'where t.table_name = :OBJECT_NAME',
'and t.table_owner = :OBJECT_OWNER',
'order by t.trigger_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona trigger -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selezionare il trigger che si desidera rimuovere.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34659101838038660.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return ''drop trigger "''||:P87_TRIGGER_NAME||''"'';'
,p_computation_error_message=>'Impossibile calcolare l''istruzione SQL.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62346705682182052.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''DROP TRIGGER'',:P87_TRIGGER_NAME);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(34659418982038667.4504)
,p_validation_name=>'P87_TRIGGER_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P87_TRIGGER_NAME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare il trigger da eliminare.'
,p_associated_item=>wwv_flow_api.id(34658730547038659.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 12-FEB-2003 10:31'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21982815104027363.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00091
begin
wwv_flow_api.create_page(
 p_id=>91.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea database link - Definisci'
,p_alias=>'DATABASE_LINK_CREATE'
,p_step_title=>'Crea database link'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_dblink.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23187817672522595.4504)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>':P91_PASSWORD := null;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149899606378513423.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149896424470499729.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154644610747510891.4504)
,p_plug_name=>'Crea database link'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Un database link \00E8 un oggetto di schema in un database che consente di accedere agli oggetti in un altro database. Dopo aver creato il database link, \00E8 possibile accedere agli oggetti remoti aggiungendo <strong>@dblink</strong> al nome della tabel')
||unistr('la o della vista; "dblink" \00E8 il nome del database link specificato in questa pagina.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240134204053047377.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118547258695889.4504)
,p_plug_name=>'Crea database link'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154682221061608431.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240134204053047377.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154681514481606594.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(240134204053047377.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154721228558676848.4504)
,p_branch_action=>'f?p=&FLOW_ID.:92:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154682221061608431.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154674630149592112.4504)
,p_name=>'P91_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(154644610747510891.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Selezionare lo schema di database (o nome utente) nel quale si desidera creare il database link. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154676407770595166.4504)
,p_name=>'P91_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(154644610747510891.4504)
,p_prompt=>'Nome database link'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il nome del database link. I database link devono essere conformi alle convenzioni di denominazione Oracle e non possono contenere spazi o iniziare con numeri o caratteri di sottolineatura.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154814816166928719.4504)
,p_name=>'P91_CONNECT_TO_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(154644610747510891.4504)
,p_prompt=>'Connetti a schema'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere il nome dello schema di database al quale accedere sul sistema remoto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154815728979932401.4504)
,p_name=>'P91_PASSWORD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(154644610747510891.4504)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Immettere la password per lo schema di database remoto.'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154818608687011794.4504)
,p_name=>'P91_REMOTE_HOST'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(154644610747510891.4504)
,p_prompt=>'Nome host o indirizzo IP remoto'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere il nome host o l''indirizzo IP del database server al quale si desidera accedere.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154851703371076464.4504)
,p_name=>'P91_SID_OR_SERVICE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(154644610747510891.4504)
,p_prompt=>'Identificato da'
,p_source=>'SID'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SID_SERVICE'
,p_lov=>'.'||wwv_flow_api.id(270736905720819349.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Scegliere "SID" (Oracle System Identifier) e immettere il nome SID se il database remoto \00E8 identificato da un SID. Scegliere "Nome servizio" e immettere il nome del servizio se il database remoto \00E8 identificato da un nome di servizio.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154855730383084268.4504)
,p_name=>'P91_SID_OR_SERVICE_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(154644610747510891.4504)
,p_prompt=>'SID o nome servizio'
,p_source=>'ORCL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154861003633095473.4504)
,p_name=>'P91_REMOTE_HOST_PORT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(154644610747510891.4504)
,p_prompt=>'Porta host remoto'
,p_source=>'1521'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Immettere il numero della porta di rete su cui il listener di Oracle Net accetta le richieste. Di solito \00E8 la porta numero 1521.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(355201807383076781.4504)
,p_computation_sequence=>10
,p_computation_item=>'P91_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(upper(:P91_NAME),chr(32),''_'')'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2984430824881087.4504)
,p_computation_sequence=>20
,p_computation_item=>'P91_CONNECT_TO_SCHEMA'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P91_CONNECT_TO_SCHEMA)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(155447621930046954.4504)
,p_computation_sequence=>40
,p_computation_item=>'P92_SQL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.get_dblink_ddl(',
'      p_link_name   => :P91_NAME,',
'      p_schema      => :P91_CONNECT_TO_SCHEMA,',
'      p_password    => :P91_PASSWORD,',
'      p_host        => :P91_REMOTE_HOST,',
'      p_host_port   => :P91_REMOTE_HOST_PORT,',
'      p_sid_or_serv => :P91_SID_OR_SERVICE,',
'      p_sid_name    => :P91_SID_OR_SERVICE_NAME )'))
,p_compute_when=>'NEXT'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154892900450264837.4504)
,p_validation_name=>'P91_NAME'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  if not wwv_flow_builder.is_valid_dblink_name(upper(:P91_NAME)) then',
'    return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P91_NAME));',
'  end if;',
'',
'  if not wwv_flow_sw_util.is_available_name2(p_name => upper(:P91_NAME), p_owner=> :OB_SCHEMA,p_type => ''DATABASE_LINK'') then',
'    return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P91_NAME));',
'  end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Nome database link non valido.'
,p_when_button_pressed=>wwv_flow_api.id(154682221061608431.4504)
,p_associated_item=>wwv_flow_api.id(154676407770595166.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154894625384272093.4504)
,p_validation_name=>'P91_CONNECT_TO_SCHEMA'
,p_validation_sequence=>20
,p_validation=>'P91_CONNECT_TO_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Immettere lo schema remoto al quale connettersi.'
,p_when_button_pressed=>wwv_flow_api.id(154682221061608431.4504)
,p_associated_item=>wwv_flow_api.id(154814816166928719.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154895911317277431.4504)
,p_validation_name=>'P91_PASSWORD'
,p_validation_sequence=>30
,p_validation=>'P91_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Immettere una password per lo schema remoto.'
,p_when_button_pressed=>wwv_flow_api.id(154682221061608431.4504)
,p_associated_item=>wwv_flow_api.id(154815728979932401.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154897629671282701.4504)
,p_validation_name=>'P91_REMOTE_HOST'
,p_validation_sequence=>40
,p_validation=>'P91_REMOTE_HOST'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Immettere il nome host o l''indirizzo IP del server remoto.'
,p_when_button_pressed=>wwv_flow_api.id(154682221061608431.4504)
,p_associated_item=>wwv_flow_api.id(154818608687011794.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154900731449311666.4504)
,p_validation_name=>'P91_REMOTE_HOST_PORT'
,p_validation_sequence=>50
,p_validation=>'P91_REMOTE_HOST_PORT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Immettere il numero di porta per il listener di Oracle Net sull''host remoto.'
,p_when_button_pressed=>wwv_flow_api.id(154682221061608431.4504)
,p_associated_item=>wwv_flow_api.id(154861003633095473.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154902218421317331.4504)
,p_validation_name=>'P91_SID_OR_SERVICE_NAME'
,p_validation_sequence=>60
,p_validation=>'P91_SID_OR_SERVICE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Immettere il SID o il nome servizio.'
,p_when_button_pressed=>wwv_flow_api.id(154682221061608431.4504)
,p_associated_item=>wwv_flow_api.id(154855730383084268.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294808612674745229.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P91_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato del database link \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23194213563549746.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset'
,p_process_sql_clob=>':P91_PASSWORD := null;'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_api.create_page(
 p_id=>92.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea database link - Conferma'
,p_step_title=>'Crea database link'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P92_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P92_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_dblink.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149900612958515299.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149896424470499729.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154631030051493674.4504)
,p_plug_name=>'Crea database link'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(238952204859583316.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240135213188059442.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118679563695890.4504)
,p_plug_name=>'Crea database link'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(149788220371252557.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(240135213188059442.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154632507005493703.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(240135213188059442.4504)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea database link'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154632919821493703.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240135213188059442.4504)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154637810657493739.4504)
,p_branch_action=>'58'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(154632507005493703.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154638227956493741.4504)
,p_branch_action=>'2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154638609480493741.4504)
,p_branch_action=>'91'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(154632919821493703.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15540110495658812.4504)
,p_name=>'P92_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(154631030051493674.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154633308549493705.4504)
,p_name=>'P92_CONFIRM_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(154631030051493674.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'P91_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Il nome dello schema di database che sar\00E0 proprietario del database link.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154634001600493717.4504)
,p_name=>'P92_CONFIRM_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(154631030051493674.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome database link:'
,p_source=>'P91_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome del database link da creare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154635815836493722.4504)
,p_name=>'P92_SQL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(238952204859583316.4504)
,p_prompt=>'SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154636618338493730.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P91_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(154632507005493703.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154637032222493737.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P58_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P91_SCHEMA,',
'              p_sql        => :P92_SQL );',
'',
'for c in (select ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) object_id from sys.dba_objects where object_name = :p91_name) loop',
'  :p92_id := c.object_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(154632507005493703.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154637408044493738.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P92_SQL,',
'    p_schema            => :P91_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(154632507005493703.4504)
);
end;
/
prompt --application/pages/page_00093
begin
wwv_flow_api.create_page(
 p_id=>93.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Copia tabella'
,p_alias=>'TABLE_COPY'
,p_step_title=>'Copia tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35623004950458157.4504)
,p_plug_name=>'Copia tabella'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(35624527657458219.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(35625116509458227.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(35627911754458245.4504)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(35625116509458227.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(150935901664583904.4504)
,p_branch_action=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35625707666458232.4504)
,p_name=>'P93_COLUMNS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_prompt=>'Seleziona colonne'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'F4500_P93_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  upper(:OB_SCHEMA) and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>10
,p_display_when=>':P93_CHOOSE_COLUMNS is not null and :P93_CHOOSE_COLUMNS != ''ALL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare le colonne da includere nella copia.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'Y'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35626303204458234.4504)
,p_name=>'P93_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica il nome della tabella da copiare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35652217311487886.4504)
,p_name=>'P93_ROWS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_item_default=>'ALL'
,p_prompt=>'Visualizza'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW.SELECT'
,p_lov=>'.'||wwv_flow_api.id(88095631994062466.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare se deve essere conservata la distinzione tra maiuscole e minuscole nel nome della nuova tabella'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35657009824495188.4504)
,p_name=>'P93_NEW_TABLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_prompt=>'Nuova tabella'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere il nome della tabella in cui eseguire la copia.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35666122768508399.4504)
,p_name=>'P93_WHERE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_prompt=>'Where'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P93_ROWS'
,p_display_when2=>'SELECTED'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere una clausola WHERE per limitare il numero di righe da copiare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35670521514517479.4504)
,p_name=>'P93_CHOOSE_COLUMNS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_item_default=>'ALL'
,p_prompt=>'Colonne'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ALL.SELECTED.COLS'
,p_lov=>'.'||wwv_flow_api.id(88062000322816814.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare se copiare tutte le colonne o solo quelle selezionate.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72527030408559605.4504)
,p_name=>'P93_PRESERVE_CASE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(35623004950458157.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72529432271569606.4504)
,p_computation_sequence=>10
,p_computation_item=>'P93_NEW_TABLE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P93_NEW_TABLE,chr(32),''_''))'
,p_compute_when=>'P93_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35627009092458236.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cols varchar2(4000);',
'  l_where varchar2(4000);',
'begin',
'  if :P93_CHOOSE_COLUMNS != ''ALL'' then',
'    l_cols := :P93_COLUMNS;',
'  else ',
'    l_cols := null;',
'  end if;',
'  if :P93_ROWS != ''ALL'' then',
'     if :P93_ROWS = ''NONE'' then',
'       l_where := ''1=2'';',
'     else',
'       l_where := :P93_WHERE;',
'     end if;',
'  else ',
'    l_where := null;',
'  end if;',
'',
'return wwv_flow_sw_util.get_copytbl_ddl(',
'         p_table_name => :P93_NEW_TABLE,',
'         p_cp_table   => :OBJECT_NAME,',
'         p_columns    => l_cols,',
'         p_where      => l_where );',
'',
'end;'))
,p_computation_error_message=>'Impossibile copiare la tabella.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62321922894054541.4504)
,p_computation_sequence=>30
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''COPY_TABLE'',:OBJECT_NAME,:P93_NEW_TABLE);'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(246110127464109455.4504)
,p_computation_sequence=>40
,p_computation_item=>'P67_ACTION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'COPY'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(35678504114531427.4504)
,p_validation_name=>'P93_NEW_TABLE Not Null'
,p_validation_sequence=>10
,p_validation=>'P93_NEW_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nuova tabella.'
,p_when_button_pressed=>wwv_flow_api.id(35625116509458227.4504)
,p_associated_item=>wwv_flow_api.id(35657009824495188.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-FEB-2003 13:37'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(51100105103942217.4504)
,p_validation_name=>'must choose columns'
,p_validation_sequence=>20
,p_validation=>'P93_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Colonne.'
,p_validation_condition=>'P93_CHOOSE_COLUMNS'
,p_validation_condition2=>'SELECTED'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(35625116509458227.4504)
,p_associated_item=>wwv_flow_api.id(35625707666458232.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00094
begin
wwv_flow_api.create_page(
 p_id=>94.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice di testo'
,p_step_title=>'Crea indice di testo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(35905518226098653.4504)
,p_name=>'Indici esistenti'
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.index_name,',
'       c.column_name, ',
'       c.column_position, ',
'       c.column_length, ',
'       c.descend ',
'from sys.dba_ind_columns c',
'where c.table_name = :P57_TABLE',
'and c.table_owner = :OB_SCHEMA',
'order by c.index_name, c.column_position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48483316975770307.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome indice'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48483400207770307.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48483510022770307.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>3
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48483630774770307.4504)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48483721350770308.4504)
,p_query_column_id=>5
,p_column_alias=>'DESCEND'
,p_column_display_sequence=>5
,p_column_heading=>'Ordina'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35905822519098661.4504)
,p_plug_name=>'Crea indice di testo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(35906416621098664.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id, COLUMN_NAME Col_name,  DATA_TYPE, DATA_LENGTH, DATA_PRECISION, DATA_SCALE, NULLABLE',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P57_TABLE',
'order by column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48782526567772187.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162723218035457883.4504)
,p_query_column_id=>2
,p_column_alias=>'COL_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48782729534772187.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48782813700772187.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48782905808772187.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48783009768772188.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48783124544772188.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149948508643627633.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149926526903576167.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208340131175749543.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118747955695890.4504)
,p_plug_name=>'Crea indice di testo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(35908831703098679.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208340131175749543.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16056102274813867.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208340131175749543.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(35908215610098675.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208340131175749543.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107552316182353570.4504)
,p_branch_action=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::P5_ACTION,P5_PREVIOUS:CREATE_INDEX,94'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(35908831703098679.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35909109474098679.4504)
,p_name=>'P94_INDEX_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(35905822519098661.4504)
,p_item_default=>'&P57_TABLE._CTX1'
,p_prompt=>'Nome indice'
,p_source=>'&P57_TABLE._CTX1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere il nome dell''indice da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35910323774098684.4504)
,p_name=>'P94_COL1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(35905822519098661.4504)
,p_prompt=>'Colonna 1 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P57_TABLE',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la prima colonna da utilizzare nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35910601024098684.4504)
,p_name=>'P94_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(35905822519098661.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica il nome dello schema di database in cui verr\00E0 creato l''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35910904112098685.4504)
,p_name=>'P94_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(35905822519098661.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'P57_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nome della tabella su cui si baser\00E0 la creazione dell''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72540102797608374.4504)
,p_name=>'P94_PRESERVE_CASE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(35905822519098661.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72542226346615200.4504)
,p_computation_sequence=>10
,p_computation_item=>'P94_INDEX_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P94_INDEX_NAME,chr(32),''_''))'
,p_compute_when=>'P94_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35911926940098697.4504)
,p_computation_sequence=>20
,p_computation_item=>'P5_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_util.get_index_ddl(',
'         p_table_name => :P57_TABLE,',
'         p_index_name => :P94_INDEX_NAME,',
'         p_action     => ''create'',',
'         p_unique     => null,',
'         p_col1       => :P94_COL1,',
'         p_col2       => null,',
'         p_col3       => null,',
'         p_col4       => null,',
'         p_indextype  => ''ctxsys.context'' );'))
,p_computation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare q varchar2(32767);',
'begin',
'   q :=     ''create '';',
'   if :P77_UNIQUE = ''UNIQUE'' then',
'      q := q||''unique '';',
'   end if;',
'   q := q||''index ''||:P77_INDEX_NAME||'' on ''||:P57_TABLE|| '' ('';',
'   if :P77_COL1 != ''0'' then',
'      q := q||:P77_COL1;',
'   end if;',
'   if :P77_COL2 != ''0'' then',
'      q := q||'', ''||:P77_COL2;',
'   end if;',
'   if :P77_COL3 != ''0'' then',
'      q := q||'', ''||:P77_COL3;',
'   end if;',
'   if :P77_COL4 != ''0'' then',
'      q := q||'', ''||:P77_COL4;',
'   end if;',
'   q := q||'')''||chr(10)||''/'';',
'   return q;',
'end;'))
,p_computation_error_message=>'Impossibile generare la sintassi SQL per la creazione dell''indice.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(35912223425098700.4504)
,p_validation_name=>'P94_INDEX_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P94_INDEX_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome indice.'
,p_associated_item=>wwv_flow_api.id(35909109474098679.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(35912520934098702.4504)
,p_validation_name=>'P94_COL1 Not Null'
,p_validation_sequence=>20
,p_validation=>'P94_COL1'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Colonna 1 indice.'
,p_associated_item=>wwv_flow_api.id(35910323774098684.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294835728575872808.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P94_INDEX_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato dell''indice \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(268065604546095318.4504)
,p_validation_name=>'available name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_util.is_available_name2(',
'p_name => :P94_INDEX_NAME,                                          p_owner=> :OB_SCHEMA,',
'p_type => ''INDEX''',
') then',
'  return',
'wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P94_INDEX_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_when_button_pressed=>wwv_flow_api.id(35908831703098679.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(270782515603285822.4504)
,p_validation_name=>'valid index column type'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_return boolean;',
'begin',
'  for c1 in (select data_type',
'             from sys.dba_tab_columns',
'             where owner =  :OB_SCHEMA ',
'              and table_name= :P57_TABLE',
'              and column_name = :P94_COL1) loop',
'    if c1.data_type in (''DATE'',''NUMBER'') then',
'      return false;',
'    end if;',
'  end loop;',
'return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il tipo di dati di colonna selezionato non pu\00F2 essere utilizzato per l''indice di testo.')
,p_when_button_pressed=>wwv_flow_api.id(35908831703098679.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00095
begin
wwv_flow_api.create_page(
 p_id=>95.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Gestisci tabella'
,p_step_title=>'Gestisci tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(411873711729766032.4504)
,p_plug_name=>'Crea indice'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(411874117043766037.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(411873711729766032.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(411873929769766036.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(411873711729766032.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(411877619544766050.4504)
,p_branch_action=>'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(411874117043766037.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P95_CTYPE'
,p_branch_condition_text=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(411877825616766050.4504)
,p_branch_action=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(411874117043766037.4504)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P95_CTYPE'
,p_branch_condition_text=>'T'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1664917153963733.4504)
,p_branch_name=>'Go To Page 220'
,p_branch_action=>'f?p=&APP_ID.:220:&SESSION.::&DEBUG.:220,221,222,224::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(411874117043766037.4504)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P95_CTYPE'
,p_branch_condition_text=>'S'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(411878014741766050.4504)
,p_branch_name=>'Go To Page 95'
,p_branch_action=>'95'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411874513568766039.4504)
,p_name=>'P95_CTYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(411873711729766032.4504)
,p_item_default=>'N'
,p_prompt=>'Tipo di indice'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE INDEX TYPES'
,p_lov=>'.'||wwv_flow_api.id(16028009107759017.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specificare il tipo di indice da creare. Gli indici normali servono per l''indicizzazione di numeri e data VARCHAR, gli indici di testo servono per l''indicizzazione delle colonne CLOB.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411875002311766042.4504)
,p_name=>'P95_SHOW_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(411873711729766032.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P95_FROM'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Nome della tabella su cui si baser\00E0 la creazione dell''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411875525189766042.4504)
,p_name=>'P95_FROM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(411873711729766032.4504)
,p_source=>':REQUEST'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411875707398766043.4504)
,p_name=>'P95_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(411873711729766032.4504)
,p_prompt=>'Nome tabella'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_name r',
'from sys.dba_tables',
'where owner = :OB_SCHEMA',
'and table_name not like ''BIN$%''',
'and table_name not like ''DR$%''',
'order by 1'))
,p_cSize=>40
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>'P95_FROM'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Selezionare la tabella che si desidera modificare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411876215048766043.4504)
,p_name=>'P95_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(411873711729766032.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(411877217870766047.4504)
,p_computation_sequence=>10
,p_computation_item=>'P95_TABLE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P95_SHOW_TABLE'
,p_compute_when=>'P95_FROM'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(411877424365766048.4504)
,p_validation_name=>'P95_TABLE Exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_match varchar2(30);',
'begin',
'  l_match := wwv_flow_builder.is_valid_table_or_view',
'    (:OB_SCHEMA,:P95_TABLE);',
'  if l_match = ''E'' then',
'    return true;',
'  elsif l_match = ''U'' then',
'    :P95_TABLE := upper(:P95_TABLE);',
'    return true;',
'  else',
'    return false;',
'  end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'La tabella deve esistere.'
,p_when_button_pressed=>wwv_flow_api.id(411874117043766037.4504)
,p_associated_item=>wwv_flow_api.id(411875707398766043.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 12-FEB-2003 12:07'
);
end;
/
prompt --application/pages/page_00097
begin
wwv_flow_api.create_page(
 p_id=>97.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea sequenza'
,p_alias=>'SEQUENCE_CREATE'
,p_step_title=>'Crea sequenza'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38675310579869803.4504)
,p_plug_name=>'Crea sequenza'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_footer=>'<p>Le sequenze di database sono oggetti di database utilizzati per generare valori interi in base a regole definite al momento della creazione della sequenza. In genere le sequenze di database vengono utilizzate per popolare le chiavi primarie di tab'
||'ella.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150798020776973841.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150794104668931302.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239881831909815885.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118881273695890.4504)
,p_plug_name=>'Crea sequenza'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38680611686882856.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239881831909815885.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38680422831882850.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239881831909815885.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3833719320578603.4504)
,p_branch_action=>'116'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(38680611686882856.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3769029344430084.4504)
,p_name=>'P97_INCREMENT_BY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_item_default=>'1'
,p_prompt=>'Increment By'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere un incremento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16312022143879385.4504)
,p_name=>'P97_MIN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_prompt=>'Valore minimo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere un valore.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16312903920883504.4504)
,p_name=>'P97_MAX'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_prompt=>'Valore massimo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere un valore.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16314106821893841.4504)
,p_name=>'P97_CYCLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'OB_CYCLE'
,p_lov=>'.'||wwv_flow_api.id(276749314239737540.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fielddata"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16320508862941714.4504)
,p_name=>'P97_CACHE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_prompt=>'Numero da inserire nella cache'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Immettere una dimensione per la cache. Il valore viene utilizzato per preallocare un set di numeri di sequenza e per mantenerli in memoria in modo che sia possibile accedervi pi\00F9 rapidamente. Quando viene utilizzato l''ultimo numero di sequenza nella ')
||'cache, il database legge un altro set di numeri nella cache.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16321829640947727.4504)
,p_name=>'P97_ORDER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'OB_ORDER'
,p_lov=>'.'||wwv_flow_api.id(276750123935740352.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fielddata"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38676423046873455.4504)
,p_name=>'P97_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Selezionare lo schema di database (o nome utente) nel quale si desidera creare l''oggetto. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38678006208877969.4504)
,p_name=>'P97_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_prompt=>'Nome sequenza'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il nome dell''oggetto. I nomi di oggetto devono essere conformi alle convenzioni di denominazione Oracle e non possono contenere spazi o iniziare con numeri o caratteri di sottolineatura.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38742328360209072.4504)
,p_name=>'P97_START_WITH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_prompt=>'Inizia con'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere un valore.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72435604174182996.4504)
,p_name=>'P97_PRESERVE_CASE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(38675310579869803.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72436826337189429.4504)
,p_computation_sequence=>10
,p_computation_item=>'P97_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(upper(:P97_NAME),chr(32))'
,p_compute_when=>'P97_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4106725497194020.4504)
,p_computation_sequence=>20
,p_computation_item=>'P116_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'      c varchar2(32767)             := null;',
'  begin',
'    c:=''create sequence "''||:P97_NAME||''"''||chr(10);',
'    if :P97_START_WITH is not null then',
'        c:=c||''start with '' ||:P97_START_WITH||chr(10);',
'    end if;',
'    if :P97_INCREMENT_BY is not null then',
'        c:=c||''increment by ''||:P97_INCREMENT_BY||chr(10);',
'    end if;',
'    if :P97_MAX is not null then',
'        c:=c||''maxvalue ''||:P97_MAX||chr(10);',
'    end if;',
'    if :P97_MIN is not null then',
'        c:=c||''minvalue ''||:P97_MIN||chr(10);',
'    end if;',
'    if (:P97_CACHE is null or :P97_CACHE = 0) then',
'        c:=c||''nocache''||chr(10);',
'    else ',
'        c:=c||''cache ''||:P97_CACHE||chr(10);',
'    end if;',
'',
'    if :P97_CYCLE = ''CYCLE'' then',
'        c:=c||''cycle''||chr(10);',
'    else',
'        c:=c||''nocycle''||chr(10);',
'    end if;',
'',
'    if :P97_ORDER = ''ORDER'' then',
'        c:=c||''order''||chr(10);',
'    else',
'        c:=c||''noorder''||chr(10);',
'    end if;',
'',
'    return c||''/   ''||chr(10);',
'',
'end',
''))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3862726817647009.4504)
,p_validation_name=>'valid name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_builder.is_valid_identifier(''"''||:P97_NAME||''"'') then',
'  return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P97_NAME));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name2(p_name => :P97_NAME, p_owner=> :P97_SCHEMA,p_type => ''SEQUENCE'') then',
'  return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P97_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_when_button_pressed=>wwv_flow_api.id(38680611686882856.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294782914115499622.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P97_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della sequenza \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(16327317613001041.4504)
,p_validation_name=>'Start with greater than Max'
,p_validation_sequence=>30
,p_validation=>'to_number(nvl(:P97_START_WITH,''1'')) >= to_number(nvl(:P97_MIN,''0''))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Il valore di Inizia con deve essere maggiore o uguale al valore minimo.'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(106221720460320237.4504)
,p_validation_name=>'max grtr than min'
,p_validation_sequence=>40
,p_validation=>'to_number(nvl(:P97_MAX,''1'')) > to_number(nvl(:P97_MIN,''0''))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Il valore massimo deve essere maggiore del valore minimo.'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00098
begin
wwv_flow_api.create_page(
 p_id=>98.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea funzione - Nome'
,p_alias=>'FUNCTION_CREATE'
,p_step_title=>'Crea funzione'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_func.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38685100673891788.4504)
,p_plug_name=>'Crea funzione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149916506902551468.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149902807201523152.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239979305889130087.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752118923687695890.4504)
,p_plug_name=>'Crea funzione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38685431104891789.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239979305889130087.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38686016669891790.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239979305889130087.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40056712085735050.4504)
,p_branch_action=>'100'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P98_INCLUDE_ARG'
,p_branch_condition_text=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(38814732621309984.4504)
,p_branch_action=>'107'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P98_INCLUDE_ARG'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38686306052891791.4504)
,p_name=>'P98_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(38685100673891788.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Selezionare lo schema di database (o nome utente) nel quale si desidera creare l''oggetto. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38686924541891794.4504)
,p_name=>'P98_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(38685100673891788.4504)
,p_prompt=>'Nome funzione'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica il nome dell''oggetto. I nomi di oggetto devono essere conformi alle convenzioni di denominazione Oracle e non possono contenere spazi o iniziare con numeri o caratteri di sottolineatura.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38737619787187715.4504)
,p_name=>'P98_RETURN_DATA_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(38685100673891788.4504)
,p_item_default=>'VARCHAR2'
,p_prompt=>'Tipo di dati restituito'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:NUMBER;NUMBER,VARCHAR2;VARCHAR2,DATE;DATE,BOOLEAN;BOOLEAN,TIMESTAMP;TIMESTAMP,CHAR;CHAR,CLOB;CLOB,BLOB;BLOB,NVARCHAR2;NVARCHAR2'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare un tipo di dati.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40044913340725904.4504)
,p_name=>'P98_INCLUDE_ARG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(38685100673891788.4504)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE.ARGS.Y'
,p_lov=>'.'||wwv_flow_api.id(88064701145826564.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72373916173902639.4504)
,p_name=>'P98_PRESERVE_CASE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(38685100673891788.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(41056415240201747.4504)
,p_computation_sequence=>10
,p_computation_item=>'P98_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(upper(v(''P98_NAME'')),chr(32))'
,p_compute_when=>'P98_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(49541425655751138.4504)
,p_computation_sequence=>20
,p_computation_item=>'P98_INCLUDE_ARG'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P98_INCLUDE_ARG'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41053207706180613.4504)
,p_validation_name=>'validate name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_builder.is_valid_identifier(''"''||:P98_NAME||''"'') then',
'  return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P98_NAME));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name2(p_name => :P98_NAME, p_owner => :OB_SCHEMA,p_type => ''FUNCTION'') then',
'  return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P98_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_associated_item=>wwv_flow_api.id(38686924541891794.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294749510203366077.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P98_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della funzione \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41233119948185706.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clear collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(',
'    p_collection_name => ''SW_CREATE_FUNCTION'');'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00099
begin
wwv_flow_api.create_page(
 p_id=>99.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea sinonimo'
,p_alias=>'SYNONYM_CREATE'
,p_step_title=>'Crea sinonimo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_required_patch=>wwv_flow_api.id(240237502901130926.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_syn.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38698721808916158.4504)
,p_plug_name=>'Crea sinonimo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Utilizzare la schermata Crea sinonimo per creare un sinonimo per un oggetto di database al quale si ha accesso. Un <strong>sinonimo</strong> \00E8 un nome alternativo per una tabella, una vista, una sequenza, una procedura, una stored function, un pac')
||'kage o un altro sinonimo.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150809810012093782.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150805024941050729.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240206104708094814.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119092158695891.4504)
,p_plug_name=>'Crea sinonimo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38699009923916159.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240206104708094814.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38699606904916160.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(240206104708094814.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3902729381732927.4504)
,p_branch_action=>'127'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(38699009923916159.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3794129438486945.4504)
,p_name=>'P99_PUBIC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(38698721808916158.4504)
,p_item_default=>'PRIVATE'
,p_prompt=>'Pubblico o privato'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PUBLIC.PRIVATE'
,p_lov=>'.'||wwv_flow_api.id(88067712358839197.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specificare se il sinonimo deve essere pubblico o privato.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38699909001916161.4504)
,p_name=>'P99_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(38698721808916158.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Selezionare lo schema di database (o nome utente) nel quale si desidera creare il sinonimo. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38700512842916163.4504)
,p_name=>'P99_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(38698721808916158.4504)
,p_prompt=>'Nome sinonimo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica il nome del sinonimo da creare. I nomi di sinonimo devono essere conformi alle convenzioni di denominazione Oracle e non possono contenere spazi o iniziare con numeri o caratteri di sottolineatura.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38725510035080785.4504)
,p_name=>'P99_SYN_SCHEMA'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(38698721808916158.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Specificare lo schema di database (o nome utente) proprietario dell''oggetto in base al quale si desidera creare il sinonimo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38726420077083682.4504)
,p_name=>'P99_SYN_OBJECT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(38698721808916158.4504)
,p_prompt=>'Oggetto'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere il nome dell''oggetto in base al quale creare un sinonimo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38727920208093259.4504)
,p_name=>'P99_DB_LINK'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(38698721808916158.4504)
,p_prompt=>'Database link'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere il nome del database link da utilizzare se il sinonimo deve essere creato su un oggetto remoto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38728805102098274.4504)
,p_name=>'P99_X'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(38698721808916158.4504)
,p_source=>'''&nbsp;</span><p /><span class="fielddatabold">''||wwv_flow_lang.system_message(''F4500.P99.CREATE_SYNONYM_ON'')||'':'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72440515649214711.4504)
,p_name=>'P99_PRESERVE_CASE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(38698721808916158.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72442325823227158.4504)
,p_computation_sequence=>10
,p_computation_item=>'P99_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(v(''P99_NAME''),chr(32),''_''))'
,p_computation_comment=>'used to be replace(v(''P99_NAME''),chr(32))'
,p_compute_when=>'P99_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4230225254326374.4504)
,p_computation_sequence=>20
,p_computation_item=>'P127_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_util.get_synonym_ddl(',
'         p_syn_name   => :P99_NAME,',
'         p_type       => :P99_PUBIC,',
'         p_schema_to  => :P99_SYN_SCHEMA,',
'         p_object_to  => :P99_SYN_OBJECT,',
'         p_link       => :P99_DB_LINK)'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(13508806269115626.4504)
,p_computation_sequence=>30
,p_computation_item=>'P127_TYPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'99'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3914613676794572.4504)
,p_validation_name=>'P99_SYN_SCHEMA Not Null'
,p_validation_sequence=>10
,p_validation=>'P99_SYN_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare uno schema.'
,p_associated_item=>wwv_flow_api.id(38725510035080785.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 26-FEB-2003 19:01'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3916623026797340.4504)
,p_validation_name=>'P99_NAME Not Null'
,p_validation_sequence=>20
,p_validation=>'P99_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome sinonimo.'
,p_associated_item=>wwv_flow_api.id(38700512842916163.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 26-FEB-2003 19:01'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3914830017794572.4504)
,p_validation_name=>'P99_SYN_OBJECT Not Null'
,p_validation_sequence=>30
,p_validation=>'P99_SYN_OBJECT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un oggetto.'
,p_associated_item=>wwv_flow_api.id(38726420077083682.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 26-FEB-2003 19:01'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3868930195666962.4504)
,p_validation_name=>'validate name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_builder.is_valid_identifier(''"''||:P99_NAME||''"'') then',
'  return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P99_NAME));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name2(p_name => :P99_NAME, p_owner => :OB_SCHEMA, p_type => ''SYNONYM'') then',
'  return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P99_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_when_button_pressed=>wwv_flow_api.id(38699009923916159.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4334528567516626.4504)
,p_validation_name=>'validate db link'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_db_links',
' where db_link = upper(:P99_DB_LINK)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Il database link non esiste.'
,p_validation_condition=>'P99_DB_LINK'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(38699009923916159.4504)
,p_associated_item=>wwv_flow_api.id(38727920208093259.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294784613900509092.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P99_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato del sinonimo \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00100
begin
wwv_flow_api.create_page(
 p_id=>100.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea funzione - Corpo funzione'
,p_step_title=>'Crea funzione'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_func.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38815228597318285.4504)
,p_plug_name=>'Crea funzione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilizzare questa pagina per immettere il blocco PL/SQL da utilizzare come corpo della funzione. Per corpo della funzione si intende tutto ci\00F2 che \00E8 compreso tra <strong>BEGIN</strong> e <strong>END;</strong></p>'),
unistr('<p>Ad esempio, se nel passo precedente \00E8 stato definito un parametro di tipo VARCHAR2 denominato p_name, \00E8 possibile immettere il seguente codice nel corpo della funzione:</p>'),
'<pre>',
'return p_name;',
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(40167506591111938.4504)
,p_name=>'Argomenti definiti'
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001,c002,c003',
'from wwv_flow_collections',
'where collection_name = ''SW_CREATE_FUNCTION''',
'and c001 is not null',
'order by seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48852101199772554.4504)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Nome argomento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48852203605772554.4504)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo argomento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48852312932772554.4504)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'Valore predefinito'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149921326772566675.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149902807201523152.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239982628530146013.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119180917695891.4504)
,p_plug_name=>'Crea funzione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38816510132333143.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239982628530146013.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38816204639333142.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239982628530146013.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38816014314333135.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239982628530146013.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40058827669739505.4504)
,p_branch_action=>'109'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(38816510132333143.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40060620659756445.4504)
,p_branch_action=>'98'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(38816204639333142.4504)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P98_INCLUDE_ARG'
,p_branch_condition_text=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(38817520894335046.4504)
,p_branch_action=>'107'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(38816204639333142.4504)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P98_INCLUDE_ARG'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38825023065392407.4504)
,p_name=>'P100_FUNCTION_BODY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(38815228597318285.4504)
,p_prompt=>'Corpo funzione:'
,p_post_element_text=>' '
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(492677350674053149.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Immettere il blocco PL/SQL che si desidera utilizzare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DDL'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40095104785855878.4504)
,p_name=>'P100_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(38815228597318285.4504)
,p_source=>'P98_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40096115520859023.4504)
,p_name=>'P100_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(38815228597318285.4504)
,p_source=>'P98_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Nome della funzione da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40098629026862920.4504)
,p_name=>'P100_RETURN_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(38815228597318285.4504)
,p_source=>'P98_RETURN_DATA_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Tipo di dati restituito dalla funzione'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(679116755329723.4504)
,p_computation_sequence=>10
,p_computation_item=>'P109_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_args varchar2(32767) := null;',
'begin  ',
'  if :P98_INCLUDE_ARG = ''Y'' then',
'    for c1 in (select c001 arg, c002 type, c003 def',
'               from wwv_flow_collections',
'               where collection_name = ''SW_CREATE_FUNCTION''',
'               and c001 is not null)',
'    loop',
'      l_args:=l_args||c1.arg||'' in ''||c1.type;',
'      if c1.def is not null then',
'      	 if (c1.type = ''NUMBER'') or (c1.type = ''BOOLEAN'') or (lower(c1.def) = ''null'') then',
'           l_args:=l_args||'' default ''||c1.def;',
'         else           ',
'           l_args:=l_args||'' default ''''''||c1.def||'''''''';',
'         end if;',
'      end if;',
'      l_args:=l_args||'',''||chr(10);	',
'    end loop;',
'    l_args:=rtrim(l_args,'',''||chr(10));',
'  end if;',
'',
'  return wwv_flow_sw_util.get_function_ddl(',
'           p_func_name   => :P98_NAME,',
'           p_arguments   => l_args,',
'           p_return      => :P98_RETURN_DATA_TYPE,',
'           p_body        => :P100_FUNCTION_BODY );',
'end;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4347131431574173.4504)
,p_validation_name=>'function body not null'
,p_validation_sequence=>10
,p_validation=>'P100_FUNCTION_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Corpo funzione.'
,p_when_button_pressed=>wwv_flow_api.id(38816510132333143.4504)
,p_associated_item=>wwv_flow_api.id(38825023065392407.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_api.create_page(
 p_id=>101.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Normalizza tabella'
,p_step_title=>'Normalizza tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33494424348462077.4504)
,p_plug_name=>'Crea tabella di ricerca'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Selezionare la colonna per la quale si desidera creare una tabella di ricerca. La colonna selezionata diventer\00E0 una chiave esterna per la tabella di ricerca.</p >')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33495620572462085.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33494424348462077.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33495918152462086.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33494424348462077.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33496823156462094.4504)
,p_branch_action=>'f?p=&FLOW_ID.:103:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33495918152462086.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33495113086462084.4504)
,p_name=>'P101_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(33494424348462077.4504)
,p_prompt=>'Schema:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33495412167462085.4504)
,p_name=>'P101_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(33494424348462077.4504)
,p_prompt=>'Nome tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella in base alla quale creare una tabella di ricerca'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33606630022418519.4504)
,p_name=>'P101_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33494424348462077.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P101_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.column_name)||'' - ''||lower(t.data_type) d, ',
'       t.column_name r',
'from   sys.dba_tab_columns t',
'where              ',
'      t.table_name = :P101_TABLE_NAME',
'  and t.owner = :P101_TABLE_OWNER and',
'      (nvl(:P101_SHOW,''1'') = ''1'' or t.data_type in (''VARCHAR'',''VARCHAR2'')) and column_id is not null',
'order by t.column_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   sys.dba_tab_columns t',
'where              ',
'      t.table_name = :P101_TABLE_NAME',
'  and t.owner = :P101_TABLE_OWNER and',
'      (nvl(:P101_SHOW,''1'') = ''1'' or t.data_type in (''VARCHAR'',''VARCHAR2''))'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specificare la colonna da utilizzare per generare la tabella di ricerca'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46071123079504519.4504)
,p_name=>'P101_SHOW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(33494424348462077.4504)
,p_item_default=>'0'
,p_prompt=>'Mostra:'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ALL.OR.VARCHAR2.COLUMN.TYPES'
,p_lov=>'.'||wwv_flow_api.id(88068725864843110.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'In genere, si desidera normalizzare solo una colonna di tipo VARCHAR o VARCHAR2. Questo selettore consente di limitare le colonne di una tabella solo a quelle di tipo VARCHAR o VARCHAR2.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'REDIRECT_SET_VALUE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(222711821052775929.4504)
,p_name=>'P101_COLUMN2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33494424348462077.4504)
,p_item_default=>'wwv_flow_lang.system_message(''F4500_P101_NO_VARCHAR'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   sys.dba_tab_columns t',
'where              ',
'      t.table_name = :P101_TABLE_NAME',
'  and t.owner = :P101_TABLE_OWNER and',
'      (nvl(:P101_SHOW,''1'') = ''1'' or t.data_type in (''VARCHAR'',''VARCHAR2''))'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare la colonna da utilizzare per generare la tabella di ricerca.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(46210509722011584.4504)
,p_validation_name=>'table name not null'
,p_validation_sequence=>10
,p_validation=>'P101_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore.'
,p_associated_item=>wwv_flow_api.id(33495412167462085.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(46226100858094191.4504)
,p_validation_name=>'ename not null'
,p_validation_sequence=>20
,p_validation=>'P101_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per la colonna.'
,p_associated_item=>wwv_flow_api.id(33606630022418519.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(66436800858219657.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values based on object id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P101_TABLE_OWNER := :OBJECT_OWNER;',
':P101_TABLE_NAME  := :OBJECT_NAME;',
':F4500_P502_OBJECT_TYPE := :OBJECT_TYPE;',
'',
'/*',
'wwv_flow_sw_util.get_object_info (',
'      p_object_id    => :OB_object_id,',
'      p_object_owner => :P101_TABLE_OWNER,',
'      p_object_name  => :P101_TABLE_NAME,',
'      p_object_type  => :F4500_P502_OBJECT_TYPE);',
'',
'*/',
'--',
'-- Check that the user has the appropriate privileges',
'--',
'wwv_flow_sw_api.check_priv ( p_schema => :P101_TABLE_OWNER );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00102
begin
wwv_flow_api.create_page(
 p_id=>102.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Elimina oggetto di database'
,p_step_title=>'Elimina oggetto di database'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P102_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P102_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'',
'    function cascadeConstraint(doCascade) {',
'    	  theDDL = document.getElementById(''P102_SQL'');',
'    	  if (doCascade.checked) {',
'    	  	theDDL.value = document.getElementById(''P102_SQL_DROP_TAB_CASCADE'').value;',
'    	  } else {',
'    	  	theDDL.value = document.getElementById(''P102_SQL_DROP_TAB'').value;',
'    	  }',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_brows_create.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2732521196445609.4504)
,p_plug_name=>'Conferma eliminazione oggetto'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_query_row_template=>wwv_flow_api.id(7082409118250737.4504)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_col_allignments=>'L:L:L:L:L:L:L'
,p_plug_query_break_cols=>'0'
,p_plug_query_sum_cols=>'::::::'
,p_plug_query_number_formats=>'::::::'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(265742814587829805.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2798402568485841.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Elimina'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2798728911485842.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:top.ob_Reset();'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14757915925334126.4504)
,p_branch_action=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2798402568485841.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2768029985457625.4504)
,p_name=>'P102_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_prompt=>'Schema:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2789704143459614.4504)
,p_name=>'P102_OT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo di oggetto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Tipo di oggetto da eliminare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2791918688463797.4504)
,p_name=>'P102_ON'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_prompt=>'Nome oggetto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome dell''oggetto da eliminare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3344304377319281.4504)
,p_name=>'P102_SQL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(265742814587829805.4504)
,p_prompt=>'Istruzione SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>unistr('L''istruzione SQL che verr\00E0 eseguita.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14945325471226355.4504)
,p_name=>'P102_LINK'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22373609203643350.4504)
,p_name=>'P102_SQL_DROP_TAB_CASCADE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_cascade varchar2(1) := null;',
' l_obj_name varchar2(100) := null;',
'begin',
' if :P102_OT = ''TABLE'' then',
'    l_cascade := ''Y'';',
' end if;',
'  for c1 in (select object_name',
'               from sys.dba_objects',
'              where object_type = :P102_OT',
'                and owner = :P102_OWNER',
'                and object_name = :P102_ON) loop',
'      l_obj_name := ''"'' || c1.object_name ||  ''"'';',
'wwv_flow.debug(''1 -''||l_obj_name);',
'      exit;',
'  end loop;',
'  if l_obj_name is null then',
'      for c1 in (select object_name',
'                   from sys.dba_objects',
'                  where object_type = upper(:P102_OT)',
'                    and owner = upper(:P102_OWNER)',
'                    and object_name = upper(:P102_ON)) loop',
'          l_obj_name := c1.object_name;',
'wwv_flow.debug(''2 -''||l_obj_name);',
'          exit;',
'      end loop;',
'  end if;',
' return wwv_flow_sw_util.get_drop_ddl(',
'          p_object_type => :P102_OT,',
'          p_object_name => l_obj_name,',
'          p_cascade     => l_cascade );',
'',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22375530328649498.4504)
,p_name=>'P102_SQL_DROP_TAB'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_cascade varchar2(1) := null;',
' l_obj_name varchar2(100) := null;',
'begin',
'',
'  for c1 in (select object_name',
'               from sys.dba_objects',
'              where object_type = :P102_OT',
'                and owner = :P102_OWNER',
'                and object_name = :P102_ON) loop',
'      l_obj_name := ''"'' || c1.object_name ||  ''"'';',
'wwv_flow.debug(''1 -''||l_obj_name);',
'      exit;',
'  end loop;',
'  if l_obj_name is null then',
'      for c1 in (select object_name',
'                   from sys.dba_objects',
'                  where object_type = upper(:P102_OT)',
'                    and owner = upper(:P102_OWNER)',
'                    and object_name = upper(:P102_ON)) loop',
'          l_obj_name := c1.object_name;',
'wwv_flow.debug(''2 -''||l_obj_name);',
'          exit;',
'      end loop;',
'  end if;',
' return wwv_flow_sw_util.get_drop_ddl(',
'          p_object_type => :P102_OT,',
'          p_object_name => l_obj_name,',
'          p_cascade     => l_cascade );',
'',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22382717477693098.4504)
,p_name=>'P102_CASCADE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2732521196445609.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Vincoli a catena:'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'YES_CHECKBOX'
,p_lov=>'.'||wwv_flow_api.id(270681628960428645.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Verificare per includere l''opzione "cascade constraints"'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(14966512405279316.4504)
,p_computation_sequence=>10
,p_computation_item=>'P102_LINK'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:OBJECT_TYPE,'' '',''_'')||''_DETAIL'''
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(13374915096380118.4504)
,p_computation_sequence=>20
,p_computation_item=>'P102_SQL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_cascade varchar2(1) := null;',
'',
'begin',
' return wwv_flow_sw_util.get_drop_ddl(',
'          p_object_type => :P102_OT,',
'          p_object_name => ''"''||:OBJECT_NAME||''"'',',
'          p_cascade     => l_cascade );',
'',
'end;'))
,p_computation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'old code -',
'declare',
' l_cascade varchar2(1) := null;',
' l_obj_name varchar2(255) := null;',
'begin',
'  wwv_flow.debug(''*** begining computation of drop table command'');',
'  wwv_flow.debug(''*** object type="''||htf.escape_sc(:P102_OT)||''"'');',
'  wwv_flow.debug(''*** object owner="''||htf.escape_sc(:P102_OWNER)||''"'');',
'  wwv_flow.debug(''*** object name="''||htf.escape_sc(:P102_ON)||''"'');',
'  wwv_flow.debug(''*** object name="''||:P102_ON||''"'');',
'  for c1 in (select object_name',
'               from sys.dba_objects',
'              where object_type = :P102_OT',
'                and owner = :P102_OWNER',
'                and object_name = :P102_ON) loop',
'',
'  wwv_flow.debug(''*** object found.'');',
'',
'      l_obj_name := ''"'' || c1.object_name ||  ''"'';',
'wwv_flow.debug(''1 -''||l_obj_name);',
'      exit;',
'  end loop;',
'  if l_obj_name is null then',
'      for c1 in (select object_name',
'                   from sys.dba_objects',
'                  where object_type = upper(:P102_OT)',
'                    and owner = upper(:P102_OWNER)',
'                    and object_name = upper(:P102_ON)) loop',
'          l_obj_name := c1.object_name;',
'wwv_flow.debug(''2 -''||l_obj_name);',
'          exit;',
'      end loop;',
'  end if;',
'',
' return wwv_flow_sw_util.get_drop_ddl(',
'          p_object_type => :P102_OT,',
'          p_object_name => l_obj_name,',
'          p_cascade     => l_cascade );',
'',
'',
'end;'))
,p_computation_error_message=>'Impossibile determinare l''istruzione SQL.'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(21409509795827040.4504)
,p_name=>'Add Cascade Constraint'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P102_CASCADE'
,p_condition_element=>'P102_CASCADE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21409826595827049.4504)
,p_event_id=>wwv_flow_api.id(21409509795827040.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P102_SQL_CONTROL'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''P102_SQL'',$v(''P102_SQL_DROP_TAB_CASCADE''));',
''))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21410017837827056.4504)
,p_event_id=>wwv_flow_api.id(21409509795827040.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P102_SQL_CONTROL'
,p_attribute_01=>'$s(''P102_SQL'',$v(''P102_SQL_DROP_TAB''));'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3359610067481864.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P102_OWNER);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(2798402568485841.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3360708467490833.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P104_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :OB_SCHEMA,',
'              p_sql        => :P102_SQL );',
'',
':OBJECT_ID := null;',
':OBJECT_NAME := null;',
':OBJECT_TYPE := null;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(2798402568485841.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3362216694512162.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save history'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P102_SQL,',
'    p_schema            => :P102_OWNER',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(2798402568485841.4504)
);
end;
/
prompt --application/pages/page_00103
begin
wwv_flow_api.create_page(
 p_id=>103.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea tabella di ricerca'
,p_step_title=>'Crea tabella di ricerca'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33497518501462095.4504)
,p_plug_name=>'Crea tabella di ricerca'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Specificare la nuova tabella da creare. Questa nuova tabella memorizzer\00E0 una lista normalizzata di valori (cio\00E8 una lista univoca di valori nella colonna selezionata).</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33499625217462101.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33499503642462101.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33499314569462101.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33501028083462104.4504)
,p_branch_action=>'f?p=&FLOW_ID.:105:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33499625217462101.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33500507344462103.4504)
,p_branch_action=>'f?p=&FLOW_ID.:101:&SESSION.'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33499503642462101.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33498213914462099.4504)
,p_name=>'P103_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P101_TABLE_OWNER.'
,p_prompt=>'Schema:'
,p_source=>'P101_TABLE_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33498517093462100.4504)
,p_name=>'P103_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome tabella:'
,p_source=>'P101_TABLE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella da utilizzare per generare la tabella di ricerca'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33498827392462100.4504)
,p_name=>'P103_NEW_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_item_default=>'replace(upper(:P101_COLUMN),'' '',''_'')||''_LOOKUP'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Nuovo nome tabella'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Immettere un nuovo nome di tabella.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33499126484462101.4504)
,p_name=>'P103_PRIMARY_KEY_COLUMN_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_item_default=>'&P103_COLUMN._ID'
,p_prompt=>'Primary Key Column Name (for new table)'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>40
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33821321757162231.4504)
,p_name=>'P103_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P101_COLUMN.'
,p_prompt=>'Colonna da normalizzare:'
,p_source=>'P101_COLUMN'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della colonna da utilizzare per generare la tabella di ricerca'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46186802225943179.4504)
,p_name=>'P103_NEW_SEQUENCE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_prompt=>'Nuova sequenza'
,p_source=>'upper(substr(replace(:P103_NEW_TABLE_NAME,'' '',''_''),1,26)||''_seq'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Immettere una nuova sequenza.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(134796318939964327.4504)
,p_name=>'P103_PRESERVE_CASE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(33497518501462095.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33831513277197639.4504)
,p_computation_sequence=>10
,p_computation_item=>'P103_NEW_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P103_NEW_TABLE_NAME,'' '',''_''))'
,p_compute_when=>'P103_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(134799201193978076.4504)
,p_computation_sequence=>20
,p_computation_item=>'P103_NEW_SEQUENCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P103_NEW_SEQUENCE,'' '',''_''))'
,p_compute_when=>'P103_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33832017779198899.4504)
,p_validation_name=>'P103_NEW_TABLE_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P103_NEW_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nuovo nome tabella.'
,p_associated_item=>wwv_flow_api.id(33498827392462100.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 25-APR-2003 09:50'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(46206805782001039.4504)
,p_validation_name=>'valid new table name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if not wwv_flow_builder.is_valid_identifier(''"''||:P103_NEW_TABLE_NAME||''"'') then',
'   return wwv_flow_lang.system_message(''F4500.NOT_VALID_TABLE_NAME'',wwv_flow_escape.html(:P103_NEW_TABLE_NAME));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name(p_name => :P103_NEW_TABLE_NAME, p_owner => :P101_TABLE_OWNER) then',
'   return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P103_NEW_TABLE_NAME));',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_validation_condition=>'P103_NEW_TABLE_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(33499625217462101.4504)
,p_associated_item=>wwv_flow_api.id(33498827392462100.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(46233813934116901.4504)
,p_validation_name=>'valid sequence name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if not wwv_flow_builder.is_valid_identifier(''"''||:P103_NEW_SEQUENCE||''"'') then',
'        return wwv_flow_lang.system_message(''F4300.F4500.NOT_VALID_SEQ_NAME'',wwv_flow_escape.html(:P103_NEW_SEQUENCE));',
'    end if;',
'    ',
'    if not wwv_flow_sw_util.is_available_name(p_name => :P103_NEW_SEQUENCE, p_owner => :P101_TABLE_OWNER) then',
'        return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P103_NEW_SEQUENCE));',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_associated_item=>wwv_flow_api.id(46186802225943179.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00104
begin
wwv_flow_api.create_page(
 p_id=>104.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile eliminare l''oggetto di database'
,p_step_title=>'Impossibile eliminare l''oggetto di database'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(158578117621515373.4504)
,p_plug_name=>'Impossibile eliminare l''oggetto di database'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>21
,p_plug_source=>'&P104_MSG.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P104_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3370914410596572.4504)
,p_name=>'P104_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(158578117621515373.4504)
,p_prompt=>'Messaggio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(969055816755554645.4504)
,p_name=>'Refresh Sidebar'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P104_MSG'
,p_display_when_cond2=>'SUCCESS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(969055927220554646.4504)
,p_event_id=>wwv_flow_api.id(969055816755554645.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'top.gSideBar.onchange(true);'
);
end;
/
prompt --application/pages/page_00105
begin
wwv_flow_api.create_page(
 p_id=>105.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea tabella di ricerca'
,p_step_title=>'Crea tabella di ricerca'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33501706759462106.4504)
,p_plug_name=>'Crea tabella di ricerca'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>La conferma di questa richiesta crea una nuova tabella e modifica la struttura della tabella corrente.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33666020081898209.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<pre>'
,p_plug_footer=>'</pre>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33502720345462109.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea tabella di ricerca'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33502810838462109.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33502630883462109.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33504306799462112.4504)
,p_branch_action=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33502720345462109.4504)
,p_branch_sequence=>10
,p_branch_comment=>'&F4500_LAST_VIEW.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33503800158462111.4504)
,p_branch_action=>'f?p=&FLOW_ID.:103:&SESSION.'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33502810838462109.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33502420846462108.4504)
,p_name=>'P105_SQL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33671821644936549.4504)
,p_name=>'P105_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P101_TABLE_OWNER.'
,p_prompt=>'Schema:'
,p_source=>'P101_TABLE_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33672428224938464.4504)
,p_name=>'P105_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'P101_TABLE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della tabella da utilizzare per generare la tabella di ricerca'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33673305630950865.4504)
,p_name=>'P105_SQL_ALTER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33679404553997818.4504)
,p_name=>'P105_NORMALIZE_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ricerca basata sulla colonna:'
,p_source=>'P101_COLUMN'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Nome della colonna da utilizzare per generare la tabella di ricerca'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 24-APR-2003 15:07:16'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33682014035010064.4504)
,p_name=>'P105_DROP_SQL'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33684312780019106.4504)
,p_name=>'P105_RENAME_SQL'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33688321354040491.4504)
,p_name=>'P105_UPDATE_COL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33696726820136666.4504)
,p_name=>'P105_FK'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33827824790182036.4504)
,p_name=>'P105_NEW_TABLE_TO_BE_CREATED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella di ricerca:'
,p_source=>'P103_NEW_TABLE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della tabella di ricerca appena creata'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33829012107187820.4504)
,p_name=>'P105_NEW_TABLE_PK_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Chiave primaria tabella di ricerca:'
,p_source=>'P103_PRIMARY_KEY_COLUMN_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della colonna chiave primaria nella tabella di ricerca appena creata'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38191328248222163.4504)
,p_name=>'P105_TRIGGER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41882324160607392.4504)
,p_name=>'P105_SEQUENCE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41892526388768921.4504)
,p_name=>'P105_TABLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43050930269681014.4504)
,p_name=>'P105_IDX'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46085424773552331.4504)
,p_name=>'P105_MSG'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46440900436239024.4504)
,p_name=>'P105_NEW_TABLE_SEQUENCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33501706759462106.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequenza tabella di ricerca:'
,p_source=>'P103_NEW_SEQUENCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della sequenza da utilizzare nella tabella di ricerca appena creata'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53746709922697875.4504)
,p_name=>'P105_LOV'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(33666020081898209.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33663108868885467.4504)
,p_computation_sequence=>10
,p_computation_item=>'P105_SQL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_table_name varchar2(4000) := null;',
'  l_column         varchar2(4000) := null;',
'  l_table_owner    varchar2(4000) := null;',
'  l_table_name     varchar2(4000) := null;',
'  l_sql            varchar2(32767) := null;',
'begin',
'  l_new_table_name := :P103_NEW_TABLE_NAME;',
'  l_column := :P101_COLUMN;',
'  l_table_owner := :P101_TABLE_OWNER;',
'  l_table_name := :P101_TABLE_NAME;',
'  ',
'  l_new_table_name := ''"''||l_new_table_name||''"'';',
'  l_column := ''"''||l_column||''"'';  ',
'  l_table_owner := ''"''||l_table_owner||''"'';',
'  l_table_name := ''"''||l_table_name||''"'';',
'  ',
'  l_sql := ''insert into ''||l_new_table_name||'' ( ''||l_column||'' ) ''||chr(10)||',
'  ''select distinct ''||l_column||',
'  '' from ''||l_table_owner||''.''||l_table_name||chr(10)||',
'  ''where ''||l_column||'' is not null'';',
'  ',
'  return l_sql;',
'end;'))
,p_computation_error_message=>'Impossibile generare il comando SQL.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(41893926519778425.4504)
,p_computation_sequence=>20
,p_computation_item=>'P105_TABLE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_table_name varchar2(4000) := null;',
'  l_column         varchar2(4000) := null;  ',
'  l_sql            varchar2(32767) := null;',
'begin',
'  l_new_table_name := :P103_NEW_TABLE_NAME;',
'  l_column := :P101_COLUMN;',
'  ',
'  l_new_table_name := ''"''||l_new_table_name||''"'';',
'  l_column := ''"''||l_column||''"'';',
'  ',
'  l_sql := ''create table ''||l_new_table_name||',
'  ''("''||:P103_PRIMARY_KEY_COLUMN_NAME||''" number not null primary key, ''||',
'  l_column||'' varchar2(4000) not null)'';',
'',
'  return l_sql;',
'end;'))
,p_computation_error_message=>'Impossibile generare la sintassi per la creazione della tabella.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33691102485072951.4504)
,p_computation_sequence=>30
,p_computation_item=>'P105_UPDATE_COL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_table_name  varchar2(4000) := null;',
'  l_table_name      varchar2(4000) := null;',
'  l_column          varchar2(4000) := null;',
'  l_orig_column     varchar2(4000) := null;',
'  l_primary_key_col varchar2(4000) := null;',
'  l_sql             varchar2(32767) := null;',
'begin',
'  l_new_table_name := :P103_NEW_TABLE_NAME;',
'  l_table_name := :p101_table_name;',
'  l_column := :p101_column||''2'';',
'  l_primary_key_col := :P103_PRIMARY_KEY_COLUMN_NAME;',
'  ',
'  l_new_table_name := ''"''||l_new_table_name||''"'';',
'  l_table_name := ''"''||l_table_name||''"'';',
'  l_column := ''"''||l_column||''"'';',
'  l_orig_column := ''"''||:p101_column||''"'';',
'  l_primary_key_col := ''"''||l_primary_key_col||''"'';',
'  ',
'  l_sql := ''update ''||l_table_name||'' x set ''||l_column||'' = (select ''||',
'  l_primary_key_col||',
'  '' from ''||',
'  l_new_table_name||',
'  '' where ''||l_orig_column||'' = x.''||l_orig_column||'')'';',
'  ',
'  return l_sql;',
'end;'))
,p_computation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_table_name  varchar2(4000) := null;',
'  l_table_name      varchar2(4000) := null;',
'  l_column          varchar2(4000) := null;',
'  l_primary_key_col varchar2(4000) := null;',
'  l_sql             varchar2(32767) := null;',
'begin',
'  l_new_table_name := :P103_NEW_TABLE_NAME;',
'  l_table_name := :p101_table_name;',
'  l_column := :p101_column||''2'';',
'  l_primary_key_col := :P103_PRIMARY_KEY_COLUMN_NAME;',
'  ',
'  l_new_table_name := ''"''||l_new_table_name||''"'';',
'  l_table_name := ''"''||l_table_name||''"'';',
'  l_column := ''"''||l_column||''"'';',
'  l_primary_key_col := ''"''||l_primary_key_col||''"'';',
'  ',
'  l_sql := ''update ''||l_table_name||'' x set ''||l_column||'' = (select ''||',
'  l_primary_key_col||',
'  '' from ''||',
'  l_new_table_name||',
'  '' where ''||l_column||'' = x.''||l_column||'')'';',
'  ',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33674010824952293.4504)
,p_computation_sequence=>40
,p_computation_item=>'P105_SQL_ALTER'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_table_name varchar2(4000) := null;',
'  l_column     varchar2(4000) := null;',
'  l_sql        varchar2(32767) := null;',
'begin',
'  l_table_name := :P101_TABLE_NAME;',
'  l_column := :P101_COLUMN||''2'';',
'  ',
'  l_table_name := ''"''||l_table_name||''"'';',
'  l_column := ''"''||l_column||''"'';',
'  ',
'  l_sql := ''alter table ''||l_table_name||'' add ''||l_column||'' number'';',
'  ',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33682726155013513.4504)
,p_computation_sequence=>50
,p_computation_item=>'P105_DROP_SQL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_table_name varchar2(4000) := null;',
'  l_column     varchar2(4000) := null;',
'  l_sql        varchar2(32767) := null;',
'begin',
'  l_table_name := :P101_TABLE_NAME;',
'  l_column := :P101_COLUMN;',
'  ',
'  l_table_name := ''"''||l_table_name||''"'';',
'  l_column := ''"''||l_column||''"'';',
'  ',
'  l_sql := ''alter table ''||l_table_name||'' drop column ''||l_column;',
'  ',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33685201830025369.4504)
,p_computation_sequence=>60
,p_computation_item=>'P105_RENAME_SQL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_table_name varchar2(4000) := null;',
'  l_column1    varchar2(4000) := null;',
'  l_column2    varchar2(4000) := null;',
'  l_sql        varchar2(32767) := null;',
'begin',
'  l_table_name := :P101_TABLE_NAME;',
'  l_column1 := :P101_COLUMN;',
'  l_column2 := :P101_COLUMN||''2'';',
'  ',
'  l_table_name := ''"''||l_table_name||''"'';',
'  l_column1 := ''"''||l_column1||''_ID"'';',
'  l_column2 := ''"''||l_column2||''"'';',
'  ',
'  l_sql := ''alter table ''||l_table_name||'' rename column ''||l_column2||''  to ''||l_column1;',
'  ',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33697928336146612.4504)
,p_computation_sequence=>70
,p_computation_item=>'P105_FK'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_table_name     varchar2(4000) := null;',
'  l_column         varchar2(4000) := null;',
'  l_new_table_name varchar2(4000) := null;',
'  l_pk             varchar2(4000) := null;',
'  l_sql            varchar2(32767) := null;',
'begin',
'  l_table_name := :p101_table_name;',
'  l_column := :p101_column;',
'  l_new_table_name := :P103_NEW_TABLE_NAME;',
'  l_pk := :P103_PRIMARY_KEY_COLUMN_NAME;',
'  ',
'  l_table_name := ''"''||l_table_name||''"'';',
'  l_column := ''"''||l_column||''_ID"'';',
'  l_new_table_name := ''"''||l_new_table_name||''"'';',
'  l_pk := ''"''||l_pk||''"'';',
'  ',
'  l_sql := ''alter table ''||l_table_name||'' add foreign key (''||',
'           l_column||'') references ''||l_new_table_name||',
'           ''(''||l_pk||'')'';',
'  ',
'  return l_sql;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(41883218404615229.4504)
,p_computation_sequence=>80
,p_computation_item=>'P105_SEQUENCE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_seq  varchar2(4000) := null;',
'  l_sql      varchar2(32767) := null;',
'begin',
'  l_new_seq := :P103_NEW_SEQUENCE;',
'  l_new_seq := ''"''||l_new_seq||''"'';',
'  ',
'  l_sql := ''create sequence ''||l_new_seq;',
'  return l_sql;',
'end;'))
,p_computation_error_message=>'Impossibile creare una colonna predefinita.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(41877514978566886.4504)
,p_computation_sequence=>90
,p_computation_item=>'P105_TRIGGER'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_table_name varchar2(4000) := null;',
'  l_new_seq        varchar2(4000) := null;',
'  l_sql            varchar2(32767) := null;',
'begin',
'  l_new_table_name := :P103_NEW_TABLE_NAME;',
'  l_new_seq := :P103_NEW_SEQUENCE;',
'  ',
'  l_new_table_name := ''"''||l_new_table_name||''"'';',
'  l_new_seq := ''"''||l_new_seq||''"'';',
'  ',
'  l_sql := ''create or replace trigger "T_''||substr(:P103_NEW_TABLE_NAME,1,29)||''"''||',
'           '' before insert or update on ''||',
'           l_new_table_name||'' for each row ''||',
'           ''begin ''||',
'           ''if inserting and :new."''||:P103_PRIMARY_KEY_COLUMN_NAME||''" is null then ''||chr(13)||chr(10)||',
'           ''  for c1 in (select ''||l_new_seq||''.nextval nv from dual) loop ''||chr(13)||chr(10)||',
'           ''     :new."''||:P103_PRIMARY_KEY_COLUMN_NAME||''" := c1.nv; ''||',
'           ''  end loop; ''||',
'           ''end if; ''||',
'           ''end;'';',
'   return l_sql;',
'end;'))
,p_computation_error_message=>'Impossibile costruire il trigger'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(43053614255695300.4504)
,p_computation_sequence=>100
,p_computation_item=>'P105_IDX'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_table_name varchar2(4000) := null;',
'  l_column         varchar2(4000) := null;',
'  l_sql            varchar2(32767) := null;',
'begin',
'  l_new_table_name := :P103_NEW_TABLE_NAME;',
'  l_column := :P101_COLUMN;',
'  ',
'  l_new_table_name := ''"''||l_new_table_name||''"'';',
'  l_column := ''"''||l_column||''"'';',
'  ',
'  l_sql := ''create index "I_''||substr(:P103_NEW_TABLE_NAME,1,10)||''_''||',
'           substr(replace(:P101_COLUMN,'' '',''_''),1,17)||',
'           ''" on ''||l_new_table_name||'' (''||l_column',
'           ||'')'';',
'  return l_sql;',
'end;'))
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(53810104568809957.4504)
,p_computation_sequence=>110
,p_computation_item=>'P105_LOV'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' q varchar2(32767);',
'begin',
' q := ''begin ',
'   wwv_flow_hint.create_normalize_hint (',
'   p_schema => ''''''||:P101_TABLE_OWNER||'''''',',
'   p_table_name => ''''''||replace(:P101_TABLE_NAME,'''''''','''''''''''')||'''''',',
'   p_column_name => '''''' || replace(:P101_COLUMN,'''''''','''''''''''') ||''_ID'' ||'''''',',
'   p_lov_query => ''''select ''||replace(:P101_COLUMN,'''''''','''''''''''') ||'' display, ''||replace(:P103_PRIMARY_KEY_COLUMN_NAME,'''''''','''''''''''')||'' from ''||',
'      :P103_NEW_TABLE_NAME||'' order by 1'''');',
'   end;'';',
' return q;',
'end;'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46131319868796900.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run ddl'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_mesg  varchar2(32767);',
'    l_workspace_name varchar2(255);',
'begin',
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P101_TABLE_OWNER);',
'',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_TABLE);',
'',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''1...''||wwv_flow_escape.html(:P105_TABLE) ||  wwv_flow_escape.html(l_mesg));',
'end if;',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_SEQUENCE);',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''2...''||wwv_flow_escape.html(:P105_SEQUENCE));',
'end if;',
'',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_TRIGGER);',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''3...''||wwv_flow_escape.html(:P105_TRIGGER));',
'end if;',
'',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_SQL);',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''4...''||wwv_flow_escape.html(:P105_SQL));',
'end if;',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_SQL_ALTER);',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''5...''||wwv_flow_escape.html(:P105_SQL_ALTER));',
'end if;',
'',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_UPDATE_COL);',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''6...''||wwv_flow_escape.html(:P105_UPDATE_COL));',
'end if;',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_DROP_SQL);',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''7...''||wwv_flow_escape.html(:P105_DROP_SQL));',
'end if;',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_RENAME_SQL);',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''8...''||wwv_flow_escape.html(:P105_RENAME_SQL));',
'end if;',
'',
'l_mesg := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :P101_TABLE_OWNER,',
'              p_sql        => :P105_FK);',
'if l_mesg != ''SUCCESS'' then',
'    raise_application_error (-20001,''9...''||wwv_flow_escape.html(:P105_FK));',
'end if;',
'',
'-- dictionary cache',
'begin',
'l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'wwv_dictionary_cache_dev.reset_dictionary_table_cache(',
'    p_workspace_name           => l_workspace_name,',
'    p_schema                   => :P101_TABLE_OWNER,',
'    p_table_name               => :P101_TABLE_NAME,',
'    p_gather_stats             => true,',
'    p_cache_fk_references      => true);',
'exception when others then',
'    raise_application_error (-20001,''dictionary cache error ''||sqlerrm);',
'end;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la creazione della tabella di ricerca.'
,p_process_when_button_id=>wwv_flow_api.id(33502720345462109.4504)
,p_process_success_message=>'Tabella di ricerca creata.'
);
end;
/
prompt --application/pages/page_00106
begin
wwv_flow_api.create_page(
 p_id=>106.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice'
,p_step_title=>'Crea indice'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(411978907057772634.4504)
,p_plug_name=>'Crea indice'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(411984103879772647.4504)
,p_name=>'Colonne tabella'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id, COLUMN_NAME COLUMN_NAME1,  DATA_TYPE, DATA_LENGTH, DATA_PRECISION, DATA_SCALE, NULLABLE',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P95_TABLE',
'order by column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411984310325772649.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'<br />'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411984402398772649.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME1'
,p_column_display_sequence=>2
,p_column_heading=>'Nome colonna'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411984519009772649.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411984611765772649.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411984709710772649.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411984822424772649.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411984909483772649.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(411985003268772649.4504)
,p_name=>'Indici tabelle'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.index_name,',
'       c.column_name, ',
'       c.column_position, ',
'       c.column_length, ',
'       c.descend ',
'from sys.dba_ind_columns c',
'where c.table_name = :P95_TABLE ',
'and c.table_owner = :OB_SCHEMA',
'order by c.index_name, c.column_position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411985227105772649.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome indice'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411985304925772649.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411985427550772649.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>3
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411985531718772649.4504)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(411985606918772649.4504)
,p_query_column_id=>5
,p_column_alias=>'DESCEND'
,p_column_display_sequence=>5
,p_column_heading=>'Ordina'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(411979326258772634.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(411979530133772634.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(411979132273772634.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(411990907396772652.4504)
,p_branch_action=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.::P113_ACTION,P113_PREVIOUS:CREATE_INDEX,106'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(411979326258772634.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411979716983772635.4504)
,p_name=>'P106_COL1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_prompt=>'Colonna 1 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P95_TABLE and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna per la prima posizione nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411980212173772638.4504)
,p_name=>'P106_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411980706942772639.4504)
,p_name=>'P106_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'P95_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella per la quale creare l''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411981411449772640.4504)
,p_name=>'P106_INDEX_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_item_default=>'&P95_TABLE._IDX1'
,p_prompt=>'Nome indice'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere un nome per l''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411981927837772640.4504)
,p_name=>'P106_COL2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_prompt=>'Colonna 2 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P95_TABLE  and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna per la seconda posizione nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411982415211772641.4504)
,p_name=>'P106_COL3'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_prompt=>'Colonna 3 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P95_TABLE and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna per la terza posizione nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411982926244772641.4504)
,p_name=>'P106_COL4'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_prompt=>'Colonna 4 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P95_TABLE and column_id is not null',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la colonna per la quarta posizione nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411983405102772642.4504)
,p_name=>'P106_UNIQUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_item_default=>'0'
,p_prompt=>unistr('Univocit\00E0')
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UNIQUE'
,p_lov=>'.'||wwv_flow_api.id(88045300809552005.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Non univoco'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Specificare se l''indice sar\00E0 univoco')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411983902280772643.4504)
,p_name=>'P106_PRESERVE_CASE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(411978907057772634.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(411987318472772650.4504)
,p_computation_sequence=>10
,p_computation_item=>'P106_INDEX_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P106_INDEX_NAME,chr(32),''_''))'
,p_compute_when=>'P106_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(411987825862772651.4504)
,p_computation_sequence=>20
,p_computation_item=>'P113_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_util.get_index_ddl(',
'         p_table_name => :P95_TABLE,',
'         p_index_name => :P106_INDEX_NAME,',
'         p_action     => ''create'',',
'         p_unique     => :P106_UNIQUE,',
'         p_col1       => :P106_COL1,',
'         p_col2       => :P106_COL2,',
'         p_col3       => :P106_COL3,',
'         p_col4       => :P106_COL4,',
'         p_indextype  => null );'))
,p_computation_error_message=>'Impossibile generare la sintassi SQL per la creazione dell''indice.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(411988404715772651.4504)
,p_validation_name=>'P106_INDEX_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P106_INDEX_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome indice.'
,p_associated_item=>wwv_flow_api.id(411981411449772640.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(411988928155772651.4504)
,p_validation_name=>'P106_COL1 Not Null'
,p_validation_sequence=>20
,p_validation=>'P106_COL1'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Colonna 1 indice.'
,p_associated_item=>wwv_flow_api.id(411979716983772635.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(411989511583772651.4504)
,p_validation_name=>'name too long'
,p_validation_sequence=>30
,p_validation=>'length(:P106_INDEX_NAME) <= 30'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'I nomi di indice devono avere una lunghezza massima di 30 caratteri.'
,p_when_button_pressed=>wwv_flow_api.id(411979326258772634.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(411990004278772651.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P106_INDEX_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato dell''indice \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(411990409173772652.4504)
,p_validation_name=>'name available'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_util.is_available_name2(',
'p_name => :P106_INDEX_NAME,p_owner=> :OB_SCHEMA,p_type => ''INDEX''',
') then',
'  return',
'wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P106_INDEX_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_when_button_pressed=>wwv_flow_api.id(411979326258772634.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00107
begin
wwv_flow_api.create_page(
 p_id=>107.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea funzione - Argomenti'
,p_step_title=>'Crea funzione'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="top.ob_Resize();"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_func.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(39990726088549772.4504)
,p_plug_name=>'Crea funzione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  la_arg      wwv_flow_global.vc_arr2;',
'  la_type     wwv_flow_global.vc_arr2;',
'  la_default  wwv_flow_global.vc_arr2;',
'  la_seq      wwv_flow_global.vc_arr2;',
'  l_arg       varchar2(4000);',
'  l_type      varchar2(255);',
'  l_default   varchar2(4000);',
'  l_seq       varchar2(255);',
'begin',
'  sys.htp.prn(''<br />'');',
'  sys.htp.prn(''<table cellspacing="0" cellpadding="0" border="0" role="presentation" class="u-Report u-Report--stretch">'');',
'  sys.htp.prn(''<tr>'');  ',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''ARGUMENT_NAME'')||''</th>'');',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''ARGUMENT_TYPE'')||''</th>'');',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.DEFAULT'')||''</th>'');',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''MOVE'')||''</th>'');',
'  sys.htp.p(''</tr>'');',
'  ',
'  for c1 in (select rownum,seq_id,c001, c002, c003',
'                from wwv_flow_collections        ',
'               where collection_name = ''SW_CREATE_FUNCTION''',
'               order by seq_id)',
'  loop',
'      la_arg(c1.rownum)      := c1.c001;',
'      la_type(c1.rownum)     := c1.c002; ',
'      la_default(c1.rownum)  := c1.c003;     ',
'      la_seq(c1.rownum)      := c1.seq_id;',
'  end loop;',
'  ',
'  for i in 1..:P107_COLUMNS loop',
'        l_arg     := null;',
'        l_type    := null; ',
'        l_default := null;       ',
'        l_seq     := null;',
'',
'        begin',
'            if length(la_arg(i)) > 0 then',
'                begin l_arg     := la_arg(i)    ; exception when others then null; end;',
'                begin l_type    := la_type(i)   ; exception when others then null; end; ',
'                begin l_default := la_default(i); exception when others then null; end;               ',
'                begin l_seq     := la_seq(i)    ; exception when others then null; end;',
'            end if;',
'        exception when others then null; end;',
'        if l_type is null then',
'           l_type := ''VARCHAR2'';',
'        end if;        ',
'        ',
'        sys.htp.prn(''<tr>'');',
'        sys.htp.prn(''<td><label for="arg''||i||''" class="hideMe508">''||wwv_flow_lang.system_message(''ARGUMENT_NAME'')||''</label>''||wwv_flow_item.text(1,l_arg,30,wwv_flow_global.c_dbms_id_length,''id="arg''||i||''"'')||''</td>'');',
'        sys.htp.prn(''<td><label for="type''||i||''" class="hideMe508">''||wwv_flow_lang.system_message(''ARGUMENT_TYPE'')||''</label>''||wwv_flow_item.select_list(2,l_type,''NUMBER;NUMBER,VARCHAR2;VARCHAR2,DATE;DATE,BOOLEAN;BOOLEAN,TIMESTAMP;TIMESTAMP,CHAR;C'
||'HAR,CLOB;CLOB,BLOB;BLOB,NVARCHAR2;NVARCHAR2'',''id="type''||i||''"'')||''</td>'');',
'        sys.htp.prn(''<td><label for="def''||i||''" class="hideMe508">''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.DEFAULT'')||''</label>''||wwv_flow_item.text(3,l_default,30,wwv_flow_global.c_dbms_id_length,''id="def''||i||''"'')||''</td>'');        ',
'        --',
'        sys.htp.prn(''<td>'');',
'        if i < :P107_COLUMNS then',
'            sys.htp.prn(''<a title="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_DOWN'')||''" href="javascript:doSubmit(''''MOVE_DOWN_''||i||'''''');"><span class="a-Icon icon-down-arrow"></span></a>'');',
'        end if;',
'        if i > 1 then',
'            sys.htp.prn(''<a title="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_UP'')||''" href="javascript:doSubmit(''''MOVE_UP_''||i||'''''');"><span class="a-Icon icon-up-arrow"></span></a>'');',
'        end if;',
'        sys.htp.prn(''</td>'');',
'        --',
'        sys.htp.p(''</tr>'');',
'    End Loop; --i                ',
'   ',
'    sys.htp.p(''</table>'');',
'    sys.htp.p(''<button type="button" value="''||wwv_flow_lang.system_message(''ADD_ARGUEMENT'')||''" onClick="javascript:doSubmit(''''ADD_COLUMN'''');" class="a-Button a-Button--primary"><span>''||wwv_flow_lang.system_message(''ADD_ARGUEMENT'')||''</span></butto'
||'n>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<img src="#IMAGE_PREFIX#green_arrow_down.gif" alt="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_DOWN'')||''" />',
'',
'<img src="#IMAGE_PREFIX#green_arrow_up.gif" alt="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_UP'')||''" />'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149920821924565256.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149902807201523152.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239980930477137203.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119266214695891.4504)
,p_plug_name=>'Crea funzione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40026618626679870.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239980930477137203.4504)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40026327225679869.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239980930477137203.4504)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40026117879679867.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239980930477137203.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40030024244691240.4504)
,p_branch_action=>'100'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40026618626679870.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41147704767585201.4504)
,p_branch_action=>'107'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40029316625688982.4504)
,p_branch_action=>'98'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40026327225679869.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40085814865811540.4504)
,p_name=>'P107_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(39990726088549772.4504)
,p_source=>'P98_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40088101144817052.4504)
,p_name=>'P107_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(39990726088549772.4504)
,p_source=>'P98_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Nome della funzione in cui aggiungere argomenti.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40088909455819367.4504)
,p_name=>'P107_RETURN_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(39990726088549772.4504)
,p_source=>'P98_RETURN_DATA_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Tipo di dati del valore restituito dalla funzione.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41145012255577942.4504)
,p_name=>'P107_COLUMNS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(39990726088549772.4504)
,p_item_default=>'10'
,p_prompt=>'Columns'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(41206324104836848.4504)
,p_computation_sequence=>10
,p_computation_item=>'P107_COLUMNS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'TO_NUMBER(:P107_COLUMNS) + 1'
,p_compute_when=>'ADD_COLUMN'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41201029729819489.4504)
,p_validation_name=>'duplicate arg name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cols          pls_integer     := :P107_COLUMNS;',
'    l_any_cols      boolean         := false;',
'    l_error_text    varchar2(1000)  := null;',
'    l_index_cols    varchar2(4000)  := null;',
'begin',
'    for c1 in (select seq_id,c001 ',
'                from wwv_flow_collections',
'               where collection_name = ''SW_CREATE_FUNCTION''',
'               order by seq_id)',
'    loop',
'        if length(c1.c001) > 0 then',
'            l_any_cols := true;',
'            for c2 in (select seq_id,c001',
'                         from wwv_flow_collections',
'                        where collection_name = ''SW_CREATE_FUNCTION''',
'                          and c001 = c1.c001',
'                          and seq_id != c1.seq_id',
'                          and instr('':''||l_index_cols||'':'','':''||seq_id||'':'') = 0)',
'            loop',
'                l_index_cols := l_index_cols ||c1.seq_id||'':'';',
'                l_error_text := l_error_text || wwv_flow_lang.system_message(''F4500.DUP_ARG_NAMES'',c1.c001);',
'            end loop;--c2  ',
'        end if;    ',
'    end loop; --c1',
'',
'    if l_error_text is not null',
'       then return wwv_flow_escape.html(l_error_text);',
'    end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_when_button_pressed=>wwv_flow_api.id(40026618626679870.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40119309989933098.4504)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare    ',
'    l_cols      pls_integer;',
'     ',
'    function arg_name(p_name in varchar2)',
'        return varchar2',
'    is',
'    	l_arg_name varchar2(4000) := null;',
'    begin',
'    	l_arg_name := replace(lower(p_name),'' '',''_'');',
'--    	if l_arg_name not like ''p_%'' then',
'--    	   l_arg_name := ''p_''||l_arg_name;',
'--    	end if;',
'        return l_arg_name;',
'    end arg_name;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(''SW_CREATE_FUNCTION'');',
'   ',
'    if :REQUEST = ''ADD_COLUMNS'' then',
'        l_cols := :P107_COLUMNS-1;',
'    else',
'        l_cols := :P107_COLUMNS;',
'    end if;',
'    begin',
'    for i in 1..l_cols loop                    ',
'        wwv_flow_collection.add_member(',
'            p_collection_name => ''SW_CREATE_FUNCTION'',',
'            p_c001            => arg_name(wwv_flow.g_f01(i)),',
'            p_c002            => wwv_flow.g_f02(i),',
'            p_c003            => wwv_flow.g_f03(i));            ',
'    end loop;',
'    exception when others then null;',
'    end;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il salvataggio della collection.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41148930047592517.4504)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'MOVE COLUMN DOWN'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.move_member_up(',
'    p_collection_name => ''SW_CREATE_FUNCTION'',',
'    p_seq             => to_number(replace(:REQUEST,''MOVE_DOWN_''))',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'instr(:REQUEST,''MOVE_DOWN'')>0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41149814941597621.4504)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'MOVE COLUMN UP'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.move_member_down(',
'    p_collection_name => ''SW_CREATE_FUNCTION'',',
'    p_seq             => to_number(replace(:REQUEST,''MOVE_UP_''))',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'instr(:REQUEST,''MOVE_UP'')>0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00108
begin
wwv_flow_api.create_page(
 p_id=>108.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DATABASE_LINK_SYNONYM'
,p_step_title=>'Sinonimi di tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15729904895543698.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(7818718708685757.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15730129588543699.4504)
,p_name=>'Sinonimi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT owner,',
'       synonym_name',
'  from apex_sys_all_synonyms',
' where table_owner = :OBJECT_OWNER',
'   and table_name  = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questo database link non ha sinonimi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15730322442543702.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15730403586543702.4504)
,p_query_column_id=>2
,p_column_alias=>'SYNONYM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome sinonimo'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21983208627157915.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00109
begin
wwv_flow_api.create_page(
 p_id=>109.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea funzione - Conferma'
,p_step_title=>'Crea funzione'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P109_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P109_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_func.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40474312416250483.4504)
,p_plug_name=>'Crea funzione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149922629889567555.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149902807201523152.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(238920620995502877.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239989315482350408.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119304059695891.4504)
,p_plug_name=>'Crea funzione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40476125153250508.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239989315482350408.4504)
,p_button_name=>'finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea funzione'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40475806989250508.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239989315482350408.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40475521715250502.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239989315482350408.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29441216060233417.4504)
,p_branch_name=>'Go To Page 62'
,p_branch_action=>'f?p=&APP_ID.:62:&SESSION.:GETOBJECT:&DEBUG.::OB_OBJECT_NAME:&P109_OBJECT_ID.:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40476125153250508.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29438727703227336.4504)
,p_name=>'P109_OBJECT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(40474312416250483.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40476420873250509.4504)
,p_name=>'P109_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40474312416250483.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'P98_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40477005734250518.4504)
,p_name=>'P109_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(238920620995502877.4504)
,p_prompt=>'SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40477331663250519.4504)
,p_name=>'P109_OBJECT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40474312416250483.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Oggetto:'
,p_source=>'P57_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P109_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome dell''oggetto su cui eseguire l''azione'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40501826802318563.4504)
,p_name=>'P109_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40474312416250483.4504)
,p_item_default=>'98'
,p_prompt=>'Tipo di oggetto:'
,p_source=>'98'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'OBJECT.TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''FUNCTION'')) d, ''98'' r from dual union all',
'select initcap(wwv_flow_lang.system_message(''INDEX'')) d, ''INDEX'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PACKAGE'')) d, ''117'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PROCEDURE'')) d, ''121'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SEQUENCE'')) d, ''97'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SYNONYM'')) d, ''99'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TABLE'')) d, ''600'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TRIGGER'')) d, ''TRIGGER'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''VIEW'')) d, ''48'' r from dual',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Tipo di oggetto su cui eseguire l''azione'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40478626385250536.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P98_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &P67_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(40476125153250508.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40478009108250526.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P62_MSG := wwv_flow_sw_util.run_other_sql(',
'               p_schema     => :P98_SCHEMA,',
'               p_sql        => :P109_SQL );',
'',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :P98_NAME ',
'           and object_type = ''FUNCTION'' ) loop',
'  :P109_OBJECT_ID := c.object_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(40476125153250508.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40478308615250535.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P109_SQL,',
'    p_schema            => :P98_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(40476125153250508.4504)
);
end;
/
prompt --application/pages/page_00110
begin
wwv_flow_api.create_page(
 p_id=>110.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare la procedura'
,p_step_title=>'Impossibile creare la procedura'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_brows_create.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(182472023113168758.4504)
,p_plug_name=>'Impossibile creare la procedura'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_plug_source=>'&P110_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969055646327554643.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75768502178976857.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(969055646327554643.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:114:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(171501502882021989.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(969055646327554643.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40488104888281369.4504)
,p_name=>'P110_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(182472023113168758.4504)
,p_prompt=>'Messaggio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19989114621440440.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for r in ( select object_id,object_name,owner,object_type',
' from sys.dba_objects',
' where owner = :OB_SCHEMA',
' and object_name = :P121_NAME',
' and object_type = ''PROCEDURE'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P110_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00112
begin
wwv_flow_api.create_page(
 p_id=>112.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Importa script'
,p_step_title=>'Importa script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_transfer.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45313425484446302.4504)
,p_plug_name=>'Importa script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Selezionare il file di esportazione che si desidera importare.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(846720149938214911.4504)
,p_plug_name=>'Importa script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(846720290809214912.4504)
,p_plug_name=>'Pulsanti procedura guidata'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45314316560446306.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(846720290809214912.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45314626525446306.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(846720290809214912.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45316031293446311.4504)
,p_branch_action=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(45314626525446306.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(317708930532127772.4504)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(45314316560446306.4504)
,p_branch_sequence=>2
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45314128381446303.4504)
,p_name=>'P112_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(45313425484446302.4504)
,p_prompt=>'Importa file'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>65
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il file di esportazione da importare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
,p_item_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(144813309454701505.4504)
,p_name=>'P112_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(45313425484446302.4504)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Set di caratteri file'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(143356515285702408.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicare la codifica del set di caratteri per il file da importare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47823429294935916.4504)
,p_validation_name=>'file not null'
,p_validation_sequence=>10
,p_validation=>'P112_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Selezionare un file da caricare.'
,p_when_button_pressed=>wwv_flow_api.id(45314626525446306.4504)
,p_associated_item=>wwv_flow_api.id(45314128381446303.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46711932360845989.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload export file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_title varchar2(4000) := substr(:P112_FILE,instr(:P112_FILE,''/'',1)+1);',
'begin',
'  update wwv_flow_file_objects$ ',
'  set    title = l_title,',
'         description = l_title||'' upload'',',
'         security_group_id = :flow_security_group_id,      ',
'         mime_type = ''application/text'',',
'         created_by = :flow_user,',
'         file_charset = :P112_FILE_CHARSET,',
'         file_type = ''SCRIPT_FILE_EXPORT''',
'  where name = :P112_FILE;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il caricamento del file di esportazione.'
,p_process_success_message=>'File di esportazione caricato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(53577809201103154.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set p115_file_id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P112_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P115_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(45314626525446306.4504)
);
end;
/
prompt --application/pages/page_00113
begin
wwv_flow_api.create_page(
 p_id=>113.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma modifica indice'
,p_step_title=>'Conferma modifica indice'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(412079424300779105.4504)
,p_plug_name=>'Confermare la richiesta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(412082121059779109.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(412082515006779110.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149926526903576167.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(23328315128356826.4504)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'F4500_LAST_VIEW'
,p_plug_display_when_cond2=>'2102'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(412079824907779106.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(412079424300779105.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea indice'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(412080030007779106.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(412079424300779105.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P113_PREVIOUS.:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(412079611901779106.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(412079424300779105.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(412083805066779112.4504)
,p_branch_action=>'f?p=&APP_ID.:128:&SESSION.::&DEBUG.::P128_OBJECT_ID:&P113_NEW_OBJECT_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(412079824907779106.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412080209921779106.4504)
,p_name=>'P113_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(412079424300779105.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412080705501779108.4504)
,p_name=>'P113_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(412079424300779105.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Oggetto:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p113_PREVIOUS = ''106'' then ',
' return :P106_INDEX_NAME;',
'else',
' return :P130_INDEX_NAME;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412081210818779108.4504)
,p_name=>'P113_ACTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(412079424300779105.4504)
,p_prompt=>'Azione:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il tipo di azione da eseguire sulla tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412081714601779108.4504)
,p_name=>'P113_PREVIOUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(412079424300779105.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412081921309779109.4504)
,p_name=>'P113_NEW_OBJECT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(412079424300779105.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412082328397779110.4504)
,p_name=>'P113_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(412082121059779109.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(412083023639779111.4504)
,p_computation_sequence=>10
,p_computation_item=>'P113_TABLE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P73_NEW_TABLE_NAME'
,p_compute_when=>':P70_ACTION = ''RENAME'' and :REQUEST = ''FINISH'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(412083130360779111.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(412079824907779106.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(412083302177779112.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P128_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P113_SQL );',
'if :p113_PREVIOUS = ''130'' then',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :p130_index_name ',
'          and owner = :OB_SCHEMA ',
'          and object_type = ''INDEX'') loop',
'  :P113_NEW_OBJECT_ID := c.object_id;',
'end loop;',
'else',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :p106_index_name ',
'          and owner = :OB_SCHEMA ',
'          and object_type = ''INDEX'') loop',
'  :P113_NEW_OBJECT_ID := c.object_id;',
'end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(412079824907779106.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(412083523909779112.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P113_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(412079824907779106.4504)
);
end;
/
prompt --application/pages/page_00114
begin
wwv_flow_api.create_page(
 p_id=>114.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea procedura - Conferma'
,p_step_title=>'Crea procedura'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P114_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P114_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3786611233481777.4504)
,p_plug_name=>'Crea procedura'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150842525015306247.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150037318536819700.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(238934832255543953.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239976401949119463.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119487545695891.4504)
,p_plug_name=>'Crea procedura'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3787826012481786.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239976401949119463.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3788122971481787.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239976401949119463.4504)
,p_button_name=>'finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea procedura'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3788427069481788.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239976401949119463.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3791509600481799.4504)
,p_branch_action=>'110'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(3788122971481787.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3792102644481801.4504)
,p_branch_action=>'123'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(3788427069481788.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3788724043481789.4504)
,p_name=>'P114_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3786611233481777.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_post_element_text=>' '
,p_source=>'P121_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3789009525481791.4504)
,p_name=>'P114_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3786611233481777.4504)
,p_item_default=>'121'
,p_prompt=>'Tipo di oggetto:'
,p_post_element_text=>' '
,p_source=>'121'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'OBJECT.TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''FUNCTION'')) d, ''98'' r from dual union all',
'select initcap(wwv_flow_lang.system_message(''INDEX'')) d, ''INDEX'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PACKAGE'')) d, ''117'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PROCEDURE'')) d, ''121'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SEQUENCE'')) d, ''97'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SYNONYM'')) d, ''99'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TABLE'')) d, ''600'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TRIGGER'')) d, ''TRIGGER'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''VIEW'')) d, ''48'' r from dual',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Tipo di oggetto su cui eseguire l''azione'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3789311892481791.4504)
,p_name=>'P114_OBJECT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3786611233481777.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Oggetto:'
,p_post_element_text=>' '
,p_source=>'P121_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome dell''oggetto su cui eseguire l''azione'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3790200866481793.4504)
,p_name=>'P114_SQL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(238934832255543953.4504)
,p_prompt=>'SQL'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3790611056481795.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P121_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &P67_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(3788122971481787.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3790931574481797.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P110_MSG := wwv_flow_sw_util.run_other_sql(',
'             p_schema     => :P121_SCHEMA,',
'             p_sql        => :P114_SQL );',
'',
'for c in (select object_id,',
'                 owner,',
'                 object_type,',
'                 object_name',
'           from sys.dba_objects ',
'           where object_name = :P121_NAME',
'           and   owner = :OB_SCHEMA',
'           and   object_type = ''PROCEDURE'') loop',
'  :object_id    := c.object_id;',
'  :object_owner := c.owner;',
'  :object_name  := c.object_name;',
'  :object_type  := c.object_type;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(3788122971481787.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3791217094481798.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P114_SQL,',
'    p_schema            => :P121_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(3788122971481787.4504)
);
end;
/
prompt --application/pages/page_00115
begin
wwv_flow_api.create_page(
 p_id=>115.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Importa script'
,p_step_title=>'Importa script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_transfer.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48434504766677479.4504)
,p_plug_name=>'Importa script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(241334518256723791.4504)
,p_plug_name=>'Non compatibile'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'N'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('Il file di esportazione non \00E8 supportato.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(846720480377214914.4504)
,p_plug_name=>'Non compatibili'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'N'
,p_plug_header=>unistr('Il file di esportazione non \00E8 supportato.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(846720580825214915.4504)
,p_plug_name=>'Pulsanti Non compatibili'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(846720647219214916.4504)
,p_plug_name=>'Importa script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(846720747915214917.4504)
,p_plug_name=>'Pulsanti importazione script'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48439106283687354.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(846720747915214917.4504)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Importa script'
,p_button_position=>'NEXT'
,p_button_condition=>'P115_INSTALL'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(241361201128832328.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(846720580825214915.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(240445017133024625.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(846720747915214917.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(241366231734850616.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(846720580825214915.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48435614809680294.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(846720747915214917.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(241286527335631773.4504)
,p_branch_action=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>5
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(241367712472854513.4504)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>7
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CANCEL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48439400077687355.4504)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48439106283687354.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(163315910465186289.4504)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'NEVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49326827810797604.4504)
,p_name=>'P115_IMP_COMPANY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48434504766677479.4504)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow.get_company_name(',
'    p_escape => false );'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Script esportati da area di lavoro:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p115_file_id) = :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'L''area di lavoro da cui sono stati esportati gli script in questo file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49328616859803981.4504)
,p_name=>'P115_IMP_COMPANY_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(48434504766677479.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_lang.system_message(''SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'',wwv_flow_imp_parser.get_security_group_id (p_file_id => :p115_file_id),v(''PRODUCT_NAME''));'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p115_file_id) <> :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'L''ID area di lavoro da cui sono stati esportati gli script in questo file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53858004081074800.4504)
,p_name=>'P115_FILE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(48434504766677479.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(237819228092998884.4504)
,p_name=>'P115_SCRIPTS_TO_IMPORT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(48434504766677479.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(240408118359788422.4504)
,p_name=>'P115_INSTALL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(48434504766677479.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(240417824041875264.4504)
,p_name=>'P115_CONFIRM'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(48434504766677479.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P115_INSTALL'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>'sys.htp.p(wwv_flow_lang.system_message(''F4500_P115.CONFIRM''));'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(240431724742951138.4504)
,p_name=>'P115_ERROR'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(48434504766677479.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P115_INSTALL'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table cellspacing="0" cellpadding="0" border="0" role="presentation"><tr>'');',
'sys.htp.p(''<td>'');',
'sys.htp.p(''<img src="''||wwv_flow.g_image_prefix||''error.gif" width="32" height="32" alt="''||wwv_flow_lang.system_message(''ERROR'')||''" />'');',
'sys.htp.p(''</td>'');',
'sys.htp.p(''<td>'');',
'sys.htp.p(wwv_flow_lang.system_message(''F4500_P115.ERROR'',v(''PRODUCT_NAME'')));',
'sys.htp.p(''</td>'');',
'sys.htp.p(''</tr>'');',
'sys.htp.p(''</table>'');'))
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(241338415317760784.4504)
,p_name=>'P115_COMPATIBLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(241334518256723791.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(237816617572986308.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'list contents only'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c_browser_language  constant varchar2(255)   := wwv_flow.g_browser_language;',
'  c_nls_numeric_chars constant varchar2(8)     := wwv_flow.g_nls_decimal_separator || wwv_flow.g_nls_group_separator;',
'  l_list                       varchar2(32767);',
'  l_size                       varchar2(255);',
'begin',
'  wwv_flow_api.g_raise_errors       := false;',
'  wwv_flow_api.g_list_contents_only := true;',
'  wwv_flow_imp_parser.parse ( p_file_id => :P115_FILE_ID );',
'  -- Restore NLS settings since parsing of an export file has likely changed it',
'  wwv_flow.g_browser_language := c_browser_language;',
'',
'  sys.dbms_session.set_nls (',
'      param => ''NLS_NUMERIC_CHARACTERS'',',
'      value => '''''''' || replace(c_nls_numeric_chars, '''''''', '''''''''''') || '''''''' );',
'',
'  wwv_flow.reset_g_nls_decimal_separator ();',
'',
'  for i in 1..wwv_flow_api.g_import_script_files.count loop',
'       if wwv_flow_api.g_import_script_status(i) like ''%SCRIPT_EXCEEDS_MAX'' then',
'           l_size := substr(wwv_flow_api.g_import_script_status(i),',
'                     1,',
'                     instr(wwv_flow_api.g_import_script_status(i), ''_'', 1) - 1',
'                     );',
'       end if;',
'       ',
'       if i = 1 then',
'           l_list := ''<table class="a-Report  a-Report--stretch" cellspacing="0" cellpadding="0" border="0" aria-label="''||wwv_flow_lang.system_message(''F4500_P115.SCRIPTS_TO_INSTALL'')||''">'';',
'           l_list := l_list||''<tr><th scope="col" class="a-Report-colHead">''||wwv_flow_lang.system_message(''F4500_P115.SCRIPTS_TO_INSTALL'');',
'           l_list := l_list||''</td><th scope="col" class="a-Report-colHead">''||wwv_flow_lang.system_message(''F4000_P801_ACTION'')||''</td></tr>'';',
'       end if;',
'',
'       l_list := l_list||''<tr>'';',
'       l_list := l_list||''<td class="a-Report-cell" scope="row">''||wwv_flow_escape.html(wwv_flow_api.g_import_script_files(i))||''</td>'';',
'       l_list := l_list||''<td class="a-Report-cell" scope="row">''||',
'                 ( case when wwv_flow_api.g_import_script_status(i) like ''%SCRIPT_EXCEEDS_MAX'' then',
'                     wwv_flow_lang.system_message(''WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'', l_size)',
'                 when wwv_flow_api.g_import_script_status(i) = ''REPLACE'' then',
'                     wwv_flow_lang.system_message(''WWV_FLOW_API.REPLACE_SCRIPT_FILE'')',
'                 when wwv_flow_api.g_import_script_status(i) = ''NEW'' then',
'                     wwv_flow_lang.system_message(''WWV_FLOW_API.NEW_SCRIPT_FILE'')',
'                 end )',
'                 ||''</td>'';',
'       l_list := l_list||''</tr>'';',
'       if i = wwv_flow_api.g_import_script_files.count then',
'           l_list := l_list||''</table>'';',
'       end if;',
'  end loop;',
'',
'  if wwv_flow_api.g_raise_errors then',
'      :P115_INSTALL := ''N'';',
'  else',
'      :P115_INSTALL := ''Y'';',
'  end if;',
'  :P115_SCRIPTS_TO_IMPORT := l_list;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile elencare i nomi degli script.'
,p_process_when=>'P115_COMPATIBLE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49330606732819896.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Import Script Files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.g_list_contents_only := false;',
'',
'wwv_flow_imp_parser.parse (',
'    p_file_id => :P115_FILE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile importare lo script. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_api.id(48439106283687354.4504)
,p_process_success_message=>'File di script importati.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(241191829423357951.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete uploaded export file when done'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- delete uploaded export file when install is done or previous button clicked',
'delete from wwv_flow_files',
'where id = :P115_FILE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile eliminare un file di esportazione caricato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(241344730948793602.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set p115_compatible'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_version varchar2(4000) := null;',
'begin',
'    l_version := wwv_flow_imp_parser.get_version(p_file_id=>:P115_FILE_ID);',
'    if l_version is not null then',
'        :P115_COMPATIBLE := ''Y'';',
'    else',
'        :P115_COMPATIBLE := ''N'';',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossibile verificare la compatibilit\00E0.')
);
end;
/
prompt --application/pages/page_00116
begin
wwv_flow_api.create_page(
 p_id=>116.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea sequenza'
,p_step_title=>'Crea sequenza'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P116_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P116_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_seq.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3840709436598309.4504)
,p_plug_name=>'Crea sequenza'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150802518099029858.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150794104668931302.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(238940003427554503.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239886309146866097.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119551438695892.4504)
,p_plug_name=>'Crea sequenza'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3841610345598315.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239886309146866097.4504)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea sequenza'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3841906900598316.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239886309146866097.4504)
,p_button_name=>'previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:97:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3841312854598313.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239886309146866097.4504)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16297410790781480.4504)
,p_branch_action=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3841610345598315.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3842220917598317.4504)
,p_name=>'P116_CONFIRM_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3840709436598309.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'P97_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3842515421598318.4504)
,p_name=>'P116_CONFIRM_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3840709436598309.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome sequenza:'
,p_source=>'P97_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della sequenza da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3843127323598320.4504)
,p_name=>'P116_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(238940003427554503.4504)
,p_prompt=>'SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16279304763694598.4504)
,p_name=>'P116_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3840709436598309.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16301527113814501.4504)
,p_name=>'P116_MSG'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3840709436598309.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4117812253209144.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :OB_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(3841610345598315.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4126126237222628.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P116_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :OB_SCHEMA,',
'              p_sql        => :P116_SQL );',
'',
'',
'for c in (select object_id from sys.dba_objects where object_name = :p97_name and owner = :OB_SCHEMA and',
'          object_type = ''SEQUENCE'') loop',
'  :object_id := c.object_id;',
'  :object_type := ''SEQUENCE'';',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4137615979229160.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P116_SQL,',
'    p_schema            => :OB_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(3841610345598315.4504)
);
end;
/
prompt --application/pages/page_00117
begin
wwv_flow_api.create_page(
 p_id=>117.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea package - Metodo'
,p_alias=>'PACKAGE_CREATE'
,p_step_title=>'Crea package'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40514403084433406.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un <strong>package</strong> \00E8 un oggetto di database che raggruppa i tipi, gli elementi, le funzioni e le procedure PL/SQL in relazione logica. In genere i package presentano due parti:</p>'),
'<ul class="noIndent">',
'<li>la <strong>specifica</strong>, ovvero l''interfaccia per l''applicazione; </li>',
'<li>il <strong>corpo</strong>, che implementa la specifica (a volte non necessario).</li>',
'</ul>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
,p_plug_comment=>'Region generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149999218433687230.4504)
,p_plug_name=>'Indicatore di avanzamento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149957726913651895.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208331207879686023.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119698405695892.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40515619912433413.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208331207879686023.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722738332959798611.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208331207879686023.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40923214850072590.4504)
,p_branch_action=>'120'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40515619912433413.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P117_CREATE_PACKAGE'
,p_branch_condition_text=>'TABLE'
,p_branch_comment=>'Created 23-FEB-2003 14:01 by MIKE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40516502250433422.4504)
,p_branch_action=>'118'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40515619912433413.4504)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P117_CREATE_PACKAGE'
,p_branch_condition_text=>'SPEC'
,p_branch_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17707524004238271.4504)
,p_branch_action=>'f?p=&APP_ID.:186:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40515619912433413.4504)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P117_CREATE_PACKAGE'
,p_branch_condition_text=>'BODY'
,p_branch_comment=>'Created 07-FEB-2005 14:44 by KRIS.RICE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(149845423581310217.4504)
,p_branch_action=>'f?p=&APP_ID.:117:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_comment=>'Created 25-MAR-2005 13:57 by MIKE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14618306857451553.4504)
,p_name=>'P117_CREATE_PACKAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40514403084433406.4504)
,p_item_default=>'SPEC'
,p_prompt=>'Crea package:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE PACKAGE OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(14616623348446893.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Specificare la modalit\00E0 di creazione del package o del package body.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(308445231539256316.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'120:124:125:126'
);
end;
/
prompt --application/pages/page_00118
begin
wwv_flow_api.create_page(
 p_id=>118.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea package - Nome'
,p_step_title=>'Crea package'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_pack.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40517217765433423.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
,p_plug_comment=>'Region generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150014105928730974.4504)
,p_plug_name=>'Indicatore di avanzamento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149957726913651895.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208332306279695086.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(786443853448938545.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40518427328433427.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208332306279695086.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40518331878433427.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208332306279695086.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:117:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(786444773331963598.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208332306279695086.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17069803001935107.4504)
,p_branch_action=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:131::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'Created 04-FEB-2005 19:13 by KRIS.RICE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40517901186433426.4504)
,p_name=>'P118_PACKAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40517217765433423.4504)
,p_prompt=>'Nome package'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere il nome del package da creare.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(71647612705307456.4504)
,p_name=>'P118_OBJECT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40517217765433423.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72420211006128197.4504)
,p_name=>'P118_PRESERVE_CASE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40517217765433423.4504)
,p_prompt=>'Conserva maiuscole/minuscole'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41037932088572566.4504)
,p_validation_name=>'validate object name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_builder.is_valid_identifier(''"''||:P118_PACKAGE_NAME||''"'') then',
' return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P118_PACKAGE_NAME));',
'end if;',
'    ',
'if :P118_PRESERVE_CASE = ''Y'' then',
'  if not wwv_flow_sw_util.is_available_name2(',
'              p_name => :P118_PACKAGE_NAME, ',
'              p_owner => :OB_SCHEMA, ',
'              p_type => ''PACKAGE_CS'') then',
'      return wwv_flow_lang.system_message(',
'                ''F4300.F4500.NAME_ALREADY_USED'',',
'                wwv_flow_escape.html(:P118_PACKAGE_NAME));',
'  end if;',
'else ',
'  if not wwv_flow_sw_util.is_available_name2(',
'              p_name => upper(:P118_PACKAGE_NAME), ',
'              p_owner => :OB_SCHEMA, ',
'              p_type => ''PACKAGE'') then',
'      return wwv_flow_lang.system_message(',
'                ''F4300.F4500.NAME_ALREADY_USED'',',
'                wwv_flow_escape.html(:P118_PACKAGE_NAME));',
'  end if;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Il nome deve essere un nome oggetto di database valido.'
,p_associated_item=>wwv_flow_api.id(40517901186433426.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294755923756398349.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P118_PACKAGE_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato del package \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21739511455115312.4504)
,p_validation_name=>'package name not null'
,p_validation_sequence=>30
,p_validation=>'replace(:P118_PACKAGE_NAME,chr(32)) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Specificare un valore per Nome package.'
,p_when_button_pressed=>wwv_flow_api.id(40518427328433427.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00120
begin
wwv_flow_api.create_page(
 p_id=>120.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea package su tabella'
,p_step_title=>'Crea package su tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40523827920433441.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150015111816732608.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149957726913651895.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208330211557677621.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119785231695892.4504)
,p_plug_name=>'Crea package su tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40524801546433444.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208330211557677621.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722737830942798606.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(208330211557677621.4504)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:117:&SESSION.::&DEBUG.:RP:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(731913040202132963.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(208330211557677621.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40526426326433447.4504)
,p_branch_action=>'124'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40524801546433444.4504)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40960921017244740.4504)
,p_name=>'P120_PACKAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40523827920433441.4504)
,p_prompt=>'Nome package'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere un nome package.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72672508254979049.4504)
,p_name=>'P120_PRESERVE_CASE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40523827920433441.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Selezionare la casella Conserva distinzione maiuscole/minuscole se si desidera conservare la combinazione di maiuscole/minuscole negli identificativi degli oggetti quali i nomi di package e tabella. In caso contrario, i caratteri verranno convertiti '
||'in maiuscolo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72676525223983908.4504)
,p_computation_sequence=>10
,p_computation_item=>'P120_PACKAGE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P120_PACKAGE_NAME)'
,p_compute_when=>'P120_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41047425817618127.4504)
,p_validation_name=>'validate object name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_builder.is_valid_identifier(''"''||:P120_PACKAGE_NAME||''"'') then',
'  return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P120_PACKAGE_NAME));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name2(p_name => :P120_PACKAGE_NAME, p_owner => :OB_SCHEMA, p_type => ''PACKAGE'') then',
'  return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P120_PACKAGE_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_associated_item=>wwv_flow_api.id(40960921017244740.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294758725272408291.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P120_PACKAGE_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato del package \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00121
begin
wwv_flow_api.create_page(
 p_id=>121.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea procedura - Nome'
,p_alias=>'PROCEDURE_CREATE'
,p_step_title=>'Crea procedura'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40840018923664473.4504)
,p_plug_name=>'Crea procedura'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150834925184268420.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150037318536819700.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239971807096092550.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119824492695892.4504)
,p_plug_name=>'Crea procedura'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40840627234664478.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239971807096092550.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40841224053664482.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239971807096092550.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40844008784664505.4504)
,p_branch_action=>'123'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P121_INCLUDE_ARG'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40843416360664500.4504)
,p_branch_action=>'122'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P121_INCLUDE_ARG'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14608717667360059.4504)
,p_name=>'P121_CREATE_OPTION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(40840018923664473.4504)
,p_item_default=>'Y'
,p_prompt=>'Utilizza una procedura guidata'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Yes;Y,No;N'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specificare se utilizzare la procedura guidata per facilitare la creazione dei parametri di procedura.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40841504516664482.4504)
,p_name=>'P121_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40840018923664473.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Selezionare lo schema di database (o nome utente) nel quale si desidera creare l''oggetto. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40842130241664496.4504)
,p_name=>'P121_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40840018923664473.4504)
,p_prompt=>'Nome procedura'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Identifica il nome della procedura. I nomi di oggetto devono essere conformi alle convenzioni di denominazione Oracle e non possono contenere spazi o iniziare con numeri o caratteri di sottolineatura.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40843018813664499.4504)
,p_name=>'P121_INCLUDE_ARG'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40840018923664473.4504)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE.ARGS.Y'
,p_lov=>'.'||wwv_flow_api.id(88064701145826564.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72428909322156161.4504)
,p_name=>'P121_PRESERVE_CASE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(40840018923664473.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72430919149168400.4504)
,p_computation_sequence=>10
,p_computation_item=>'P121_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(upper(v(''P121_NAME'')),chr(32))'
,p_compute_when=>'P121_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(49519512131595867.4504)
,p_computation_sequence=>20
,p_computation_item=>'P121_INCLUDE_ARG'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P121_INCLUDE_ARG'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41061318535240496.4504)
,p_validation_name=>'validate object name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_builder.is_valid_identifier(''"''||:P121_NAME||''"'') then',
'  return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P121_NAME));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name2(p_name => :P121_NAME, p_owner => :OB_SCHEMA,p_type => ''PROCEDURE'') then',
'  return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P121_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_associated_item=>wwv_flow_api.id(40842130241664496.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294778615585481176.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P121_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della procedura \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41284219592459990.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clear collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(',
'    p_collection_name => ''SW_CREATE_PROCEDURE'');'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00122
begin
wwv_flow_api.create_page(
 p_id=>122.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea procedura - Argomenti'
,p_step_title=>'Crea procedura'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40849803753696593.4504)
,p_plug_name=>'Crea procedura'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  la_arg     wwv_flow_global.vc_arr2;',
'  la_inout   wwv_flow_global.vc_arr2;',
'  la_type    wwv_flow_global.vc_arr2;',
'  la_default wwv_flow_global.vc_arr2;',
'  la_seq     wwv_flow_global.vc_arr2;',
'  l_arg      varchar2(4000);',
'  l_inout    varchar2(255);',
'  l_type     varchar2(255);',
'  l_default  varchar2(4000);',
'  l_seq      varchar2(255);',
'begin  ',
'  sys.htp.prn(''<br />'');',
'  sys.htp.prn(''<table cellspacing="0" cellpadding="0" border="0" role="presentation" class="u-Report u-Report--stretch">'');',
'  sys.htp.prn(''<tr>'');  ',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''ARGUMENT_NAME'')||''</th>'');',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''IN/OUT'')||''</th>'');',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''ARGUMENT_TYPE'')||''</th>'');',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.DEFAULT'')||''</th>'');',
'  sys.htp.prn(''<th>''||wwv_flow_lang.system_message(''MOVE'')||''</th>'');',
'  sys.htp.p(''</tr>'');',
'  ',
'  for c1 in (select rownum,seq_id,c001, c002, c003, c004',
'                from wwv_flow_collections        ',
'               where collection_name = ''SW_CREATE_PROCEDURE''',
'               order by seq_id)',
'  loop',
'      la_arg(c1.rownum)      := c1.c001;',
'      la_inout(c1.rownum)    := c1.c002;',
'      la_type(c1.rownum)     := c1.c003;   ',
'      la_default(c1.rownum)  := c1.c004;   ',
'      la_seq(c1.rownum)      := c1.seq_id;',
'  end loop;',
'  ',
'  for i in 1..:P122_COLUMNS loop',
'        l_arg     := null;',
'        l_inout   := null;',
'        l_type    := null; ',
'        l_default := null;       ',
'        l_seq     := null;',
'',
'        begin',
'            if length(la_arg(i)) > 0 then',
'                begin l_arg     := la_arg(i)    ; exception when others then null; end;',
'                begin l_inout   := la_inout(i)  ; exception when others then null; end;',
'                begin l_type    := la_type(i)   ; exception when others then null; end; ',
'                begin l_default := la_default(i); exception when others then null; end;              ',
'                begin l_seq     := la_seq(i)    ; exception when others then null; end;',
'            end if;',
'        exception when others then null; end;',
'        if l_type is null then',
'           l_type := ''VARCHAR2'';',
'        end if;        ',
'        ',
'        sys.htp.prn(''<tr>'');',
'        sys.htp.prn(''<td>''||wwv_flow_item.text(1,l_arg,30,wwv_flow_global.c_dbms_id_length)||''</td>'');',
'        sys.htp.prn(''<td>''||wwv_flow_item.select_list(2,l_inout,''IN,OUT,IN OUT'')||''</td>'');',
'        sys.htp.prn(''<td>''||wwv_flow_item.select_list(3,l_type,''NUMBER,VARCHAR2,DATE,BOOLEAN,TIMESTAMP,CHAR,CLOB,BLOB,NVARCHAR2'')||''</td>'');',
'        sys.htp.prn(''<td>''||wwv_flow_item.text(4,l_default,30,wwv_flow_global.c_dbms_id_length)||''</td>'');        ',
'        --',
'        sys.htp.prn(''<td>'');',
'        if i < :P122_COLUMNS then',
'            sys.htp.prn(''<a title="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_DOWN'')||''" href="javascript:doSubmit(''''MOVE_DOWN_''||i||'''''');"><span class="a-Icon icon-down-arrow"></span></a>'');',
'        end if;',
'        if i > 1 then',
'            sys.htp.prn(''<a title="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_UP'')||''" href="javascript:doSubmit(''''MOVE_UP_''||i||'''''');"><span class="a-Icon icon-up-arrow"></span></a>'');',
'        end if;',
'        sys.htp.prn(''</td>'');',
'        --',
'        sys.htp.p(''</tr>'');',
'    End Loop; --i                ',
'   ',
'    sys.htp.p(''</table>'');',
'    sys.htp.p(''<button type="button" value="''||wwv_flow_lang.system_message(''ADD_ARGUEMENT'')||''" onClick="javascript:doSubmit(''''ADD_COLUMN'''');" class="a-Button a-Button--primary"><span>''||wwv_flow_lang.system_message(''ADD_ARGUEMENT'')||''</span></butto'
||'n>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<p>Identificare gli argomenti da includere nella procedura. Gli argomenti sono parametri da passare alle procedure o restituiti dalle procedure. Per impostare il valore predefinito nullo per l''argomento, digitare <strong>Nullo</strong> come valore pr'
||'edefinito.</p>'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150837521159276725.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150037318536819700.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239973631684099679.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752119959148695893.4504)
,p_plug_name=>'Crea procedura'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40851606630696604.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239973631684099679.4504)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40851317640696604.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239973631684099679.4504)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40851026026696603.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239973631684099679.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40853515102696611.4504)
,p_branch_action=>'123'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40851606630696604.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41270515604421000.4504)
,p_branch_action=>'122'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40853805019696612.4504)
,p_branch_action=>'121'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40851317640696604.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40851916252696605.4504)
,p_name=>'P122_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40849803753696593.4504)
,p_prompt=>'Schema:'
,p_source=>'P121_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40852232328696606.4504)
,p_name=>'P122_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40849803753696593.4504)
,p_prompt=>'Nome procedura:'
,p_source=>'P121_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della procedura in cui aggiungere argomenti'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41266011486372480.4504)
,p_name=>'P122_COLUMNS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40849803753696593.4504)
,p_item_default=>'10'
,p_prompt=>'Columns'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(41267028455377425.4504)
,p_computation_sequence=>10
,p_computation_item=>'P122_COLUMNS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'TO_NUMBER(:P122_COLUMNS) + 1'
,p_compute_when=>'ADD_COLUMN'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41268331010387645.4504)
,p_validation_name=>'duplicate arg name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cols          pls_integer     := :P122_COLUMNS;',
'    l_any_cols      boolean         := false;',
'    l_error_text    varchar2(1000)  := null;',
'    l_index_cols    varchar2(4000)  := null;',
'begin',
'    for c1 in (select seq_id,c001 ',
'                from wwv_flow_collections',
'               where collection_name = ''SW_CREATE_PROCEDURE''',
'               order by seq_id)',
'    loop',
'        if length(c1.c001) > 0 then',
'            l_any_cols := true;',
'            for c2 in (select seq_id,c001',
'                         from wwv_flow_collections',
'                        where collection_name = ''SW_CREATE_PROCEDURE''',
'                          and c001 = c1.c001',
'                          and seq_id != c1.seq_id',
'                          and instr('':''||l_index_cols||'':'','':''||seq_id||'':'') = 0)',
'            loop',
'                l_index_cols := l_index_cols ||c1.seq_id||'':'';',
'                l_error_text := l_error_text || wwv_flow_lang.system_message(''F4500.DUP_ARG_NAMES'',c1.c001);',
'            end loop;--c2  ',
'        end if;    ',
'    end loop; --c1',
'',
'    if l_error_text is not null',
'       then return wwv_flow_escape.html(l_error_text);',
'    end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_when_button_pressed=>wwv_flow_api.id(40851606630696604.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40853204109696611.4504)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare    ',
'    l_cols      pls_integer;',
'     ',
'    function arg_name(p_name in varchar2)',
'        return varchar2',
'    is',
'    	l_arg_name varchar2(4000) := null;',
'    begin',
'    	l_arg_name := replace(lower(p_name),'' '',''_'');',
'--    	if l_arg_name not like ''p_%'' then',
'--    	   l_arg_name := ''p_''||l_arg_name;',
'--    	end if;',
'        return l_arg_name;',
'    end arg_name;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(''SW_CREATE_PROCEDURE'');',
'   ',
'    if :REQUEST = ''ADD_COLUMNS'' then',
'        l_cols := :P122_COLUMNS-1;',
'    else',
'        l_cols := :P122_COLUMNS;',
'    end if;',
'    begin',
'    for i in 1..l_cols loop                    ',
'        wwv_flow_collection.add_member(',
'            p_collection_name => ''SW_CREATE_PROCEDURE'',',
'            p_c001            => arg_name(wwv_flow.g_f01(i)),',
'            p_c002            => wwv_flow.g_f02(i),',
'            p_c003            => wwv_flow.g_f03(i),',
'            p_c004            => wwv_flow.g_f04(i));            ',
'    end loop;',
'    exception when others then null;',
'    end;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il salvataggio della collection.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41271330496425285.4504)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'MOVE COLUMN DOWN'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.move_member_up(',
'    p_collection_name => ''SW_CREATE_PROCEDURE'',',
'    p_seq             => to_number(replace(:REQUEST,''MOVE_DOWN_''))',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'instr(:REQUEST,''MOVE_DOWN'')>0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41272516774430784.4504)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'MOVE COLUMN UP'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.move_member_down(',
'    p_collection_name => ''SW_CREATE_PROCEDURE'',',
'    p_seq             => to_number(replace(:REQUEST,''MOVE_UP_''))',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'instr(:REQUEST,''MOVE_UP'')>0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00123
begin
wwv_flow_api.create_page(
 p_id=>123.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea procedura - Definisci'
,p_step_title=>'Crea procedura'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_proc.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(40857211750706236.4504)
,p_name=>'Argomenti definiti'
,p_template=>wwv_flow_api.id(208285802016555084.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001,c002,c003,c004',
'from wwv_flow_collections',
'where collection_name = ''SW_CREATE_PROCEDURE''',
'and c001 is not null',
'order by seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48456015621770119.4504)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Nome argomento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48456101092770119.4504)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'In/Out'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48456216383770119.4504)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo argomento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48456331273770119.4504)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'Valore predefinito'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40857516888706240.4504)
,p_plug_name=>'Crea procedura'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilizzare questa pagina per immettere il blocco PL/SQL da utilizzare come corpo procedurale. Per corpo procedurale si intende tutto ci\00F2 che \00E8 compreso tra <strong>BEGIN</strong> e <strong>END;</strong></p>'),
unistr('<p>Ad esempio, se nel passo precedente \00E8 stato definito un parametro IN di tipo VARCHAR2 denominato p_name, \00E8 possibile immettere il seguente codice nel corpo procedurale:</p>'),
'<pre>',
'sys.htp.p(''Hi ''||p_name);',
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150839632718289591.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150037318536819700.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239975003203110367.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752120001979695893.4504)
,p_plug_name=>'Crea procedura'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40858714867706248.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239975003203110367.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40858125682706247.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239975003203110367.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40858420974706247.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239975003203110367.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40861202867706256.4504)
,p_branch_action=>'114'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40858714867706248.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40861502924706257.4504)
,p_branch_action=>'121'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40858125682706247.4504)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P121_INCLUDE_ARG'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40860907246706256.4504)
,p_branch_action=>'122'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40858125682706247.4504)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P121_INCLUDE_ARG'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40859005789706249.4504)
,p_name=>'P123_BODY'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(40857516888706240.4504)
,p_prompt=>'Corpo procedurale:'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(492677350674053149.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere il blocco PLSQL da utilizzare come corpo procedurale.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DDL'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40859613054706251.4504)
,p_name=>'P123_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40857516888706240.4504)
,p_prompt=>'Nome procedura:'
,p_source=>'P121_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome del package '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40859922705706252.4504)
,p_name=>'P123_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40857516888706240.4504)
,p_prompt=>'Schema:'
,p_source=>'P121_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1380410884529666.4504)
,p_computation_sequence=>10
,p_computation_item=>'P114_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(32767) := null;',
'begin   ',
'  if :P121_INCLUDE_ARG = ''Y'' then',
'    for c1 in (select c001 arg, c002 inout, c003 type, c004 def',
'               from wwv_flow_collections',
'               where collection_name = ''SW_CREATE_PROCEDURE''',
'               and c001 is not null)',
'    loop',
'      l_sql:=l_sql||c1.arg||'' ''||c1.inout||'' ''||c1.type;',
'      if c1.def is not null then',
'      	 if (c1.type = ''NUMBER'') or (lower(c1.def) = ''null'') then',
'           l_sql:=l_sql||'' default ''||c1.def;',
'         else           ',
'           l_sql:=l_sql||'' default ''''''||c1.def||'''''''';',
'         end if;',
'      end if;',
'      l_sql:=l_sql||'',''||chr(10);	',
'    end loop;',
'    l_sql:=rtrim(l_sql,'',''||chr(10));',
'  end if;  ',
'',
'  return wwv_flow_sw_util.get_function_ddl(',
'           p_func_name   => :P121_NAME,',
'           p_arguments   => l_sql,',
'           p_return      => null,',
'           p_body        => :P123_BODY );',
'end;'))
);
end;
/
prompt --application/pages/page_00124
begin
wwv_flow_api.create_page(
 p_id=>124.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea package su tabelle'
,p_step_title=>'Crea package su tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_pack.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40935203709143747.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_footer=>'<p>Specificare le tabelle per le quali si desidera generare un''interfaccia API (Application Program Interface) basata su package PL/SQL.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150016722551735736.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149957726913651895.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239954516961057568.4504)
,p_plug_name=>'WIzard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752120117475695893.4504)
,p_plug_name=>'Crea package su tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40936707199143767.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239954516961057568.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40936428728143763.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239954516961057568.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(731914413414174282.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239954516961057568.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40938025082143770.4504)
,p_branch_action=>'125'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40936707199143767.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40937732167143770.4504)
,p_branch_action=>'120'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(40936428728143763.4504)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40937022841143768.4504)
,p_name=>'P124_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'upper(:OB_SCHEMA)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40950615252176842.4504)
,p_name=>'P124_TABLE1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 1'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40955125126217527.4504)
,p_name=>'P124_TABLE2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 2'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40955428936218616.4504)
,p_name=>'P124_TABLE3'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 3'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40955732745219728.4504)
,p_name=>'P124_TABLE4'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 4'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40956004479221029.4504)
,p_name=>'P124_TABLE5'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 5'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40956308981222307.4504)
,p_name=>'P124_TABLE6'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 6'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40956613483223608.4504)
,p_name=>'P124_TABLE7'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 7'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40956916600224542.4504)
,p_name=>'P124_TABLE8'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 8'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40957220409225596.4504)
,p_name=>'P124_TABLE9'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 9'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40957523872226576.4504)
,p_name=>'P124_TABLE10'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Tabella 10'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :OB_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome della tabella per la quale generare un''API'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40962010413251074.4504)
,p_name=>'P124_PACKAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40935203709143747.4504)
,p_prompt=>'Nome package:'
,p_source=>'P120_PACKAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nome del package che conterr\00E0 l''API da creare')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(830611802508144336.4504)
,p_computation_sequence=>10
,p_computation_item=>'OB_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'OB_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41051007032631596.4504)
,p_validation_name=>'P124_TABLE1 Not Null'
,p_validation_sequence=>10
,p_validation=>'P124_TABLE1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare una tabella.'
,p_associated_item=>wwv_flow_api.id(40950615252176842.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-FEB-2003 18:20'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3371318219597712.4504)
,p_validation_name=>'tables exist'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P124_TABLE1 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE1,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE1),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE2 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE2,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE2),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE3 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE3,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE3),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE4 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE4,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE4),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE5 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE5,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE5),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE6 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE6,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE6),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE7 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE7,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE7),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE8 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE8,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE8),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE9 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE9,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE9),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;',
'if :P124_TABLE10 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE10,upper(:OB_SCHEMA)) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE10),wwv_flow_escape.html(:OB_SCHEMA));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_when_button_pressed=>wwv_flow_api.id(40936707199143767.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(108074006656521986.4504)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'make table names upper case'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P124_TABLE1  := upper(:P124_TABLE1);',
':P124_TABLE2  := upper(:P124_TABLE2);',
':P124_TABLE3  := upper(:P124_TABLE3);',
':P124_TABLE4  := upper(:P124_TABLE4);',
':P124_TABLE5  := upper(:P124_TABLE5);',
':P124_TABLE6  := upper(:P124_TABLE6);',
':P124_TABLE7  := upper(:P124_TABLE7);',
':P124_TABLE8  := upper(:P124_TABLE8);',
':P124_TABLE9  := upper(:P124_TABLE9);',
':P124_TABLE10 := upper(:P124_TABLE10);'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P120_PRESERVE_CASE'
,p_process_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_00125
begin
wwv_flow_api.create_page(
 p_id=>125.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Creazione API tabelle'
,p_step_title=>'Crea package su tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function showDDLSpec(){',
'    theDDL = document.getElementById(''pkgSpec'');',
'    showDiv = document.getElementById(''ddlSpecShow'');',
'    hideDiv = document.getElementById(''ddlSpecHide'');',
'    hideDiv.style.display = ''block'';',
'    theDDL.style.display = ''block'';',
'    showDiv.style.display = ''none'';',
'    }',
'',
'function hideDDLSpec(){',
'    theDDL = document.getElementById(''pkgSpec'');',
'    showDiv = document.getElementById(''ddlSpecShow'');',
'    hideDiv = document.getElementById(''ddlSpecHide'');',
'    hideDiv.style.display = ''none'';',
'    theDDL.style.display = ''none'';',
'    showDiv.style.display = ''block'';',
'    }',
'',
'function showDDLBody(){',
'    theDDL = document.getElementById(''pkgBody'');',
'    showDiv = document.getElementById(''ddlBodyShow'');',
'    hideDiv = document.getElementById(''ddlBodyHide'');',
'    hideDiv.style.display = ''block'';',
'    theDDL.style.display = ''block'';',
'    showDiv.style.display = ''none'';',
'    }',
'',
'function hideDDLBody(){',
'    theDDL = document.getElementById(''pkgBody'');',
'    showDiv = document.getElementById(''ddlBodyShow'');',
'    hideDiv = document.getElementById(''ddlBodyHide'');',
'    hideDiv.style.display = ''none'';',
'    theDDL.style.display = ''none'';',
'    showDiv.style.display = ''block'';',
'    }',
''))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ddlClass {',
'    width:400px;',
'    height:300px;',
'    border:1px #3F8640 solid;',
'    font-family:monospace;',
'    text-overflow:auto;',
'    background:#C5D5C5;',
'    display:none;',
'    white-space: pre;}',
''))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1962729556076041.4504)
,p_plug_name=>'Package PL/SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_generate_table_api.create_api(',
'  p_owner => :OB_SCHEMA,',
'  p_app_name => :P120_PACKAGE_NAME,',
'  p_table_name_01 => :P124_TABLE1,',
'  p_table_name_02 => :P124_TABLE2,',
'  p_table_name_03 => :P124_TABLE3,',
'  p_table_name_04 => :P124_TABLE4,',
'  p_table_name_05 => :P124_TABLE5,',
'  p_table_name_06 => :P124_TABLE6,',
'  p_table_name_07 => :P124_TABLE7,',
'  p_table_name_08 => :P124_TABLE8,',
'  p_table_name_09 => :P124_TABLE9,',
'  p_table_name_10 => :P124_TABLE10',
');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Confermare la richiesta.',
'<br /><br />'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239962318955077077.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(273115725560451995.4504)
,p_plug_name=>'Indicatore di avanzamento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149957726913651895.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752120212176695894.4504)
,p_plug_name=>'Crea package su tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2320006090100655.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239962318955077077.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea package'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2278707972911932.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239962318955077077.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(731960813407217756.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239962318955077077.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(722738102808798609.4504)
,p_branch_name=>'Go To Page 126'
,p_branch_action=>'f?p=&APP_ID.:126:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2320006090100655.4504)
,p_branch_sequence=>5
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2327302458137435.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'compile package'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_generate_table_api.create_api(',
'  p_owner => :P124_OWNER,',
'  p_app_name => :P120_PACKAGE_NAME,',
'  p_table_name_01 => :P124_TABLE1,',
'  p_table_name_02 => :P124_TABLE2,',
'  p_table_name_03 => :P124_TABLE3,',
'  p_table_name_04 => :P124_TABLE4,',
'  p_table_name_05 => :P124_TABLE5,',
'  p_table_name_06 => :P124_TABLE6,',
'  p_table_name_07 => :P124_TABLE7,',
'  p_table_name_08 => :P124_TABLE8,',
'  p_table_name_09 => :P124_TABLE9,',
'  p_table_name_10 => :P124_TABLE10,',
'  p_action => ''EXECUTE''',
');',
':P126_DDL_STATUS := ''SUCCESS'';',
'',
'      :OBJECT_NAME  := :P120_PACKAGE_NAME;',
'      :OBJECT_OWNER := :P120_OWNER;',
'      :OBJECT_TYPE  := ''PACKAGE'';',
'',
'FOR C IN (SELECT OBJECT_ID FROM sys.DBA_OBJECTS ',
'          WHERE OBJECT_NAME = :P120_PACKAGE_NAME ',
'          AND OWNER = :OB_SCHEMA',
'          AND OBJECT_TYPE = ''PACKAGE'') LOOP',
':OBJECT_ID := C.OBJECT_ID;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(2320006090100655.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2259621075811652.4504)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download spec'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_generate_table_api.create_api(',
'  p_owner => :P124_OWNER,',
'  p_app_name => :P120_PACKAGE_NAME,',
'  p_table_name_01 => :P124_TABLE1,',
'  p_table_name_02 => :P124_TABLE2,',
'  p_table_name_03 => :P124_TABLE3,',
'  p_table_name_04 => :P124_TABLE4,',
'  p_table_name_05 => :P124_TABLE5,',
'  p_table_name_06 => :P124_TABLE6,',
'  p_table_name_07 => :P124_TABLE7,',
'  p_table_name_08 => :P124_TABLE8,',
'  p_table_name_09 => :P124_TABLE9,',
'  p_table_name_10 => :P124_TABLE10,',
'  p_action => ''DOWNLOAD_SPEC''',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DOWNLOAD_SPEC'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2260505061825908.4504)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download body'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_generate_table_api.create_api(',
'  p_owner => :P124_OWNER,',
'  p_app_name => :P120_PACKAGE_NAME,',
'  p_table_name_01 => :P124_TABLE1,',
'  p_table_name_02 => :P124_TABLE2,',
'  p_table_name_03 => :P124_TABLE3,',
'  p_table_name_04 => :P124_TABLE4,',
'  p_table_name_05 => :P124_TABLE5,',
'  p_table_name_06 => :P124_TABLE6,',
'  p_table_name_07 => :P124_TABLE7,',
'  p_table_name_08 => :P124_TABLE8,',
'  p_table_name_09 => :P124_TABLE9,',
'  p_table_name_10 => :P124_TABLE10,',
'  p_action => ''DOWNLOAD_BODY''',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DOWNLOAD_BODY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00126
begin
wwv_flow_api.create_page(
 p_id=>126.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare il package'
,p_step_title=>'Impossibile creare il package'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2308725586092552.4504)
,p_plug_name=>'Unable to Create Package'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(722738203744798610.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16898919354444866.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(722738203744798610.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2309022777092554.4504)
,p_name=>'P126_DDL_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2308725586092552.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182444624190121727.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' for r in ( select object_id,object_name,owner,object_type',
'from sys.dba_objects',
'where owner = :OB_SCHEMA',
'and object_name = :P120_PACKAGE_NAME',
'and object_type = ''PACKAGE'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P126_DDL_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00127
begin
wwv_flow_api.create_page(
 p_id=>127.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea sinonimo'
,p_step_title=>'Crea sinonimo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P127_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P127_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_required_patch=>wwv_flow_api.id(240237502901130926.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_syn.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3886405806720882.4504)
,p_plug_name=>'Crea sinonimo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150808213560075800.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150805024941050729.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(238944031824562719.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240207332413102825.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752120428655695894.4504)
,p_plug_name=>'Crea sinonimo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3887929732720893.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(240207332413102825.4504)
,p_button_name=>'finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea sinonimo'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3888207496720894.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240207332413102825.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3887611240720891.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(240207332413102825.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(108143912810509976.4504)
,p_branch_action=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3887929732720893.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3888514112720895.4504)
,p_name=>'P127_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3886405806720882.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_post_element_text=>' '
,p_source=>'P99_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica il nome dello schema in cui verr\00E0 creato questo sinonimo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3888803874720896.4504)
,p_name=>'P127_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3886405806720882.4504)
,p_prompt=>'Tipo di oggetto:'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'OBJECT.TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''FUNCTION'')) d, ''98'' r from dual union all',
'select initcap(wwv_flow_lang.system_message(''INDEX'')) d, ''INDEX'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PACKAGE'')) d, ''117'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PROCEDURE'')) d, ''121'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SEQUENCE'')) d, ''97'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SYNONYM'')) d, ''99'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TABLE'')) d, ''600'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TRIGGER'')) d, ''TRIGGER'' r from dual union all     ',
'select initcap(wwv_flow_lang.system_message(''VIEW'')) d, ''48'' r from dual',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Questo attributo identifica il tipo di oggetto su cui si baser\00E0 la creazione del sinonimo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3889121116720897.4504)
,p_name=>'P127_OBJECT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3886405806720882.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome:'
,p_post_element_text=>' '
,p_source=>'P99_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Questo attributo identifica il nome del sinonimo da creare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3890029179720900.4504)
,p_name=>'P127_SQL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(238944031824562719.4504)
,p_prompt=>'SQL'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3890409478720902.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :OB_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &P67_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(3887929732720893.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3890719942720904.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P8_MSG := wwv_flow_sw_util.run_other_sql(',
'             p_schema     => :OB_SCHEMA,',
'             p_sql        => :P127_SQL );',
'',
'for c in (select object_id from sys.dba_objects where object_name = :p99_name and owner = :OB_SCHEMA and',
'          object_type = ''SYNONYM'') loop',
'  :object_id := c.object_id;',
'  :object_type := ''SYNONYM'';',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(3887929732720893.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3891011624720905.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P127_SQL,',
'    p_schema            => :OB_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(3887929732720893.4504)
);
end;
/
prompt --application/pages/page_00128
begin
wwv_flow_api.create_page(
 p_id=>128.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare l''indice'
,p_step_title=>'Impossibile creare l''indice'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(412212828569788507.4504)
,p_plug_name=>'Impossibile creare l''indice'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>31
,p_plug_source=>'&P128_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P128_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(412213202285788507.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(412212828569788507.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'a-Button--iconLeft'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(412215401862788513.4504)
,p_branch_action=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(412213202285788507.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412214428521788509.4504)
,p_name=>'P128_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(412212828569788507.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412214930359788512.4504)
,p_name=>'P128_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(412212828569788507.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(412215101288788512.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- SR: JAS 01/26/09 - could not determine how to exercise page, did not change',
'declare',
' l_name varchar2(2000);',
'begin',
' if :P113_PREVIOUS = 130 then',
'   l_name := :P130_INDEX_NAME;',
' else',
'   l_name := :P106_INDEX_NAME;',
' end if;',
' if ( :P113_ACTION = ''CREATE_INDEX'') then ',
'  for r in ( select object_id,object_name,owner,object_type',
'   from sys.dba_objects',
'   where owner = :OB_SCHEMA',
'   and object_name = l_name',
'   and object_type = ''INDEX'' ) loop',
'     :OBJECT_ID    := r.object_id;',
'     :OBJECT_NAME  := r.object_name;',
'     :OBJECT_OWNER := r.owner;',
'     :OBJECT_TYPE  := r.object_type;',
'  end loop;',
' end if; /* end create_index */',
'',
'sys.owa_util.http_header_close;',
'sys.htp.p(''<script>top.gSideBar.reload(''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||',
'          '',''||wwv_flow_escape.js_literal(:OBJECT_ID)||',
'          '',true);</script>'');',
'wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P128_MSG = ''SUCCESS'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00129
begin
wwv_flow_api.create_page(
 p_id=>129.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare la sequenza'
,p_step_title=>'Impossibile creare la sequenza'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_seq.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16274914905676062.4504)
,p_plug_name=>'Impossibile creare la sequenza'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>21
,p_plug_source=>'&P129_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P129_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969055308066554640.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16275109594676062.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(969055308066554640.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:116:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16275318171676063.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(969055308066554640.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16275723369676064.4504)
,p_name=>'P129_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16274914905676062.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'P116_MSG'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16303516509820973.4504)
,p_name=>'P129_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16274914905676062.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'P116_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182466513632156559.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for r in ( select object_id,object_name,owner,object_type',
' from sys.dba_objects',
' where owner = :OB_SCHEMA',
' and object_name = :P97_NAME',
' and object_type = ''SEQUENCE'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P116_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00130
begin
wwv_flow_api.create_page(
 p_id=>130.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice di testo'
,p_step_title=>'Crea indice di testo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(412329109434800085.4504)
,p_name=>'Indici esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.index_name,',
'       c.column_name, ',
'       c.column_position, ',
'       c.column_length, ',
'       c.descend ',
'from sys.dba_ind_columns c',
'where c.table_name = :P95_TABLE',
'and c.table_owner = :OB_SCHEMA',
'order by c.index_name, c.column_position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412329331784800085.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome indice'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412329415502800086.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412329527079800086.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>3
,p_column_heading=>'Posizione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412329614832800086.4504)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412329719605800086.4504)
,p_query_column_id=>5
,p_column_alias=>'DESCEND'
,p_column_display_sequence=>5
,p_column_heading=>'Ordina'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(412329804111800086.4504)
,p_plug_name=>'Crea indice di testo'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(412333203262800088.4504)
,p_name=>'Colonne esistenti'
,p_template=>wwv_flow_api.id(717403738062820750.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_id, COLUMN_NAME Col_name,  DATA_TYPE, DATA_LENGTH, DATA_PRECISION, DATA_SCALE, NULLABLE',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P95_TABLE',
'order by column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412333423194800088.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412333507208800088.4504)
,p_query_column_id=>2
,p_column_alias=>'COL_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412333603091800088.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412333722473800088.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_column_format=>'999G999G990'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412333813133800088.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412333918428800088.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(412334011144800088.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Valori nulli'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(412330218298800086.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(412329804111800086.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(412330400861800086.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(412329804111800086.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(412330030241800086.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(412329804111800086.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(412336211705800092.4504)
,p_branch_action=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.::P113_ACTION,P113_PREVIOUS:CREATE_INDEX,130'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(412330218298800086.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412330601003800086.4504)
,p_name=>'P130_INDEX_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(412329804111800086.4504)
,p_item_default=>'&P95_TABLE._CTX1'
,p_prompt=>'Nome indice'
,p_source=>'&P95_TABLE._CTX1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Immettere il nome dell''indice da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412331117214800088.4504)
,p_name=>'P130_COL1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(412329804111800086.4504)
,p_prompt=>'Colonna 1 indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OB_SCHEMA and',
'table_name= :P95_TABLE',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la prima colonna da utilizzare nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412331613902800088.4504)
,p_name=>'P130_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(412329804111800086.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica il nome dello schema di database in cui verr\00E0 creato l''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412332114221800088.4504)
,p_name=>'P130_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(412329804111800086.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'P95_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nome della tabella su cui si baser\00E0 la creazione dell''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412332814091800088.4504)
,p_name=>'P130_PRESERVE_CASE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(412329804111800086.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(412334815869800091.4504)
,p_computation_sequence=>10
,p_computation_item=>'P130_INDEX_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P130_INDEX_NAME,chr(32),''_''))'
,p_compute_when=>'P130_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(412335006797800091.4504)
,p_computation_sequence=>20
,p_computation_item=>'P113_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_util.get_index_ddl(',
'         p_table_name => :P95_TABLE,',
'         p_index_name => :P130_INDEX_NAME,',
'         p_action     => ''create'',',
'         p_unique     => null,',
'         p_col1       => :P130_COL1,',
'         p_col2       => null,',
'         p_col3       => null,',
'         p_col4       => null,',
'         p_indextype  => ''ctxsys.context'' );'))
,p_computation_error_message=>'Impossibile generare la sintassi SQL per la creazione dell''indice.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(412335221495800091.4504)
,p_validation_name=>'P130_INDEX_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P130_INDEX_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome indice.'
,p_associated_item=>wwv_flow_api.id(412330601003800086.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(412335413278800091.4504)
,p_validation_name=>'P130_COL1 Not Null'
,p_validation_sequence=>20
,p_validation=>'P130_COL1'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Colonna 1 indice.'
,p_associated_item=>wwv_flow_api.id(412331117214800088.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(412335609290800092.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P130_INDEX_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato dell''indice \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(412335804435800092.4504)
,p_validation_name=>'available name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_util.is_available_name2(',
'p_name => :P130_INDEX_NAME,                                          p_owner=> :OB_SCHEMA,',
'p_type => ''INDEX''',
') then',
'  return',
'wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P130_INDEX_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_when_button_pressed=>wwv_flow_api.id(412330218298800086.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(412336022260800092.4504)
,p_validation_name=>'valid index column type'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_return boolean;',
'begin',
'  for c1 in (select data_type',
'             from sys.dba_tab_columns',
'             where owner =  :OB_SCHEMA ',
'              and table_name= :P95_TABLE',
'              and column_name = :P130_COL1) loop',
'    if c1.data_type in (''DATE'',''NUMBER'') then',
'      return false;',
'    end if;',
'  end loop;',
'return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il tipo di dati di colonna selezionato non pu\00F2 essere utilizzato per l''indice di testo.')
,p_when_button_pressed=>wwv_flow_api.id(412330218298800086.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00131
begin
wwv_flow_api.create_page(
 p_id=>131.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea package - Definisci'
,p_step_title=>'Crea package'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_pack.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4295329244425076.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_footer=>'</td></tr></table>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150015514586733408.4504)
,p_plug_name=>'Indicatore di avanzamento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149957726913651895.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(722737929482798607.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(786444445764950349.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4296810331425098.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(722737929482798607.4504)
,p_button_name=>'finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea specifica package'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4297111406425099.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(722737929482798607.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(786446684477984575.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(722737929482798607.4504)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4300212336425117.4504)
,p_branch_action=>'132'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(4296810331425098.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4297426782425100.4504)
,p_name=>'P131_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(4295329244425076.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4297714981425104.4504)
,p_name=>'P131_TYPE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(4295329244425076.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo di oggetto:'
,p_source=>'initcap(wwv_Flow_lang.system_message(''PACKAGE''))'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Tipo di oggetto da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4298915941425108.4504)
,p_name=>'P131_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4295329244425076.4504)
,p_prompt=>'Specifica'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return ''create or replace package ''||',
'         case when :P118_PRESERVE_CASE = ''Y'' then ''"''||:P118_PACKAGE_NAME||''"''',
'               else upper(:P118_PACKAGE_NAME)',
'         end||'' as',
'',
'procedure test (',
'   p_arg1 in varchar2 default null,',
'   p_arg2 in number   default null);',
'',
'function test_func (',
'    p_arg1 in number )',
'    return varchar2;',
'',
'end;',
'/'';'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Testo SQL per la specifica del package da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DDL'
,p_attribute_04=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17938002307916297.4504)
,p_computation_sequence=>10
,p_computation_item=>'P132_PREVIOUS'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&APP_PAGE_ID.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4299321840425110.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :OB_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(4296810331425098.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4299614070425116.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_name varchar2(2000);',
'begin',
'  :P132_MSG := wwv_flow_sw_util.run_other_sql(',
'             p_schema     => :OB_SCHEMA,',
'             p_sql        => :P131_SQL );',
'',
'  if :P118_PRESERVE_CASE = ''Y'' then',
'   l_name := :P118_PACKAGE_NAME;',
'  else ',
'   l_name := upper(:P118_PACKAGE_NAME);',
'  end if;',
'',
'  for c in (select object_id,',
'                 owner,',
'                 object_type,',
'                 object_name',
'           from sys.dba_objects ',
'           where object_name = l_name',
'           and   owner = :OB_SCHEMA',
'           and   object_type = ''PACKAGE'') loop',
'    :OBJECT_ID    := c.object_id;',
'    :OBJECT_OWNER := c.owner;',
'    :OBJECT_NAME  := c.object_name;',
'    :OBJECT_TYPE  := c.object_type;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(4296810331425098.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4299927404425116.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P131_SQL,',
'    p_schema            => :P118_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(4296810331425098.4504)
);
end;
/
prompt --application/pages/page_00132
begin
wwv_flow_api.create_page(
 p_id=>132.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare il package'
,p_step_title=>'Impossibile creare il package'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4360901884689688.4504)
,p_plug_name=>'Impossibile creare il package'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>'&P132_MSG.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P132_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'htp.p(''<p />&nbsp;<table><tr><td align="center"><a href="f?p=4500:2:&SESSION." class="tab3archiveslink">'');',
'htp.p(''<img src="#IMAGE_PREFIX#htmldb/builder/sql_workshop.gif" alt="''||l_home||''" border="0" title="''||l_home||''"><br>'');',
'htp.p(l_home);',
'htp.p(''</a></td></tr></table>'');',
'*/'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969055559242554642.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75786827599069334.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(969055559242554642.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460257208599880353.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(969055559242554642.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17699704349213661.4504)
,p_branch_action=>'f?p=&APP_ID.:&P132_PREVIOUS.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(75786827599069334.4504)
,p_branch_sequence=>10
,p_branch_comment=>'Created 07-FEB-2005 14:40 by KRIS.RICE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4361226051689691.4504)
,p_name=>'P132_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4360901884689688.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4375418823835521.4504)
,p_name=>'P132_MSG2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4360901884689688.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17934607370908217.4504)
,p_name=>'P132_PREVIOUS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4360901884689688.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17944005470945499.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new OB_NAME/OWNER/ID ( Pkg Body )'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
' l_id number;',
'begin',
'  if :P132_PREVIOUS = ''131'' then',
'   l_id := :OBJECT_ID;',
'  else ',
'  l_id := :P186_PACKAGE;',
'  end if;',
'for r in ( select object_id,object_name,object_type,owner',
'             from sys.dba_objects',
'             where object_id = l_id) loop',
'  :OBJECT_OWNER := r.owner;',
'  :OBJECT_NAME  := r.object_name;',
'  :OBJECT_TYPE  := r.object_type;',
'  :OBJECT_ID    := r.object_id;',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P132_MSG = ''SUCCESS'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00135
begin
wwv_flow_api.create_page(
 p_id=>135.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea vista materializzata'
,p_alias=>'MATERIALIZED_VIEW_CREATE'
,p_step_title=>'Crea vista materializzata'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_required_patch=>wwv_flow_api.id(240247031763163202.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_mview.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19868408617343481.4504)
,p_plug_name=>'Crea vista materializzata'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_footer=>unistr('<p>Una vista \00E8 una presentazione personalizzata dei dati contenuti in una o pi\00F9 tabelle o in altre viste. Una vista prende l''output di una query e lo tratta come tabella. Una vista pu\00F2 essere considerata una stored query o una tabella virtuale.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149955108558646570.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149951426304632759.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240169608471067528.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752120528394695894.4504)
,p_plug_name=>'Crea vista materializzata'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1272959565997046977.4504)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(19868408617343481.4504)
,p_button_name=>'P135_QUERY_BUILDER'
,p_button_static_id=>'P135_QUERY_BUILDER'
,p_button_action=>'REDIRECT_URL'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Query Builder'
,p_button_redirect_url=>'javascript:popupURL(''f?p=4500:1002:&SESSION.:::1002:P1002_RETURN_INTO,P1002_POPUP,P1002_SCHEMA:P135_QUERY,1,'' + encodeURIComponent(''&OB_SCHEMA.''));'
,p_button_execute_validations=>'N'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1272960136469063631.4504)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(19868408617343481.4504)
,p_button_name=>'P135_SQL_COMMANDS'
,p_button_static_id=>'P135_SQL_COMMANDS'
,p_button_action=>'REDIRECT_URL'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Comandi SQL'
,p_button_redirect_url=>'javascript:popupURL(''f?p=4500:1003:&SESSION.:::1003:P1003_RETURN_INTO,P1003_POPUP,P1003_SCHEMA:P135_QUERY,1,'' + encodeURIComponent(''&OB_SCHEMA.''));'
,p_button_execute_validations=>'N'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19868826475343484.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240169608471067528.4504)
,p_button_name=>'next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19868625772343484.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(240169608471067528.4504)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19871903256343499.4504)
,p_branch_action=>'136'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(19868826475343484.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19869019312343486.4504)
,p_name=>'P135_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(19868408617343481.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Selezionare lo schema di database (o nome utente) nel quale si desidera creare la vista. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19869528294343488.4504)
,p_name=>'P135_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(19868408617343481.4504)
,p_prompt=>'Nome vista materializzata'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specificare il nome della vista. I nomi di vista devono essere conformi alle convenzioni di denominazione Oracle e non possono contenere spazi o iniziare con numeri o caratteri di sottolineatura.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19870031035343489.4504)
,p_name=>'P135_PRESERVE_CASE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(19868408617343481.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19870405002343490.4504)
,p_name=>'P135_QUERY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(19868408617343481.4504)
,p_prompt=>'Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>14
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(492677350674053149.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere una query.',
'<p>Per effettuare il collegamento a Query Builder o al processore comandi SQL, fare clic sul collegamento appropriato nella parte inferiore della pagina.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21768616443552089.4504)
,p_computation_sequence=>10
,p_computation_item=>'P135_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(v(''P135_NAME''),chr(32))'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(19890025714469080.4504)
,p_computation_sequence=>20
,p_computation_item=>'P136_SQL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''create  materialized view ''||',
' case when :P135_PRESERVE_CASE = ''Y'' then ''"''||:P135_NAME||''"'' ',
'      else :P135_NAME end||chr(10)||',
'''as''||chr(10)||',
':P135_QUERY||chr(10)',
'||''/'''))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(19871303650343496.4504)
,p_validation_name=>'valid NAME'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if not wwv_flow_builder.is_valid_identifier(''"''||:P135_NAME||''"'') then',
'        return wwv_flow_lang.system_message(''F4500.NOT_VALID_TABLE_NAME'',wwv_flow_escape.html(:P135_NAME));',
'    end if;',
'    ',
'    if not wwv_flow_sw_util.is_available_name2(p_name => :P135_NAME, p_owner=> :OB_SCHEMA, p_type => ''MATERIALIZED_VIEW'') then',
'        return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P135_NAME));',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Nome vista deve essere un identificativo valido.'
,p_when_button_pressed=>wwv_flow_api.id(19868826475343484.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(19871514438343496.4504)
,p_validation_name=>'query not null'
,p_validation_sequence=>20
,p_validation=>'P135_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare la query.'
,p_associated_item=>wwv_flow_api.id(19870405002343490.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(19871710379343497.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P135_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della vista \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00136
begin
wwv_flow_api.create_page(
 p_id=>136.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma vista materializzata'
,p_step_title=>'Conferma vista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P52_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P52_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_required_patch=>wwv_flow_api.id(240247031763163202.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_mview.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19875013139383388.4504)
,p_plug_name=>'Crea vista materializzata'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19892812123484000.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149955912022647500.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149951426304632759.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240173107348086183.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752120624459695894.4504)
,p_plug_name=>'Conferma vista materializzata'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19875415160383391.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(240173107348086183.4504)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea vista materializzata'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19875610471383391.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(240173107348086183.4504)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19875211121383390.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(240173107348086183.4504)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19878629284383400.4504)
,p_branch_action=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19875415160383391.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19878408299383400.4504)
,p_branch_action=>'135'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(19875610471383391.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19875801272383391.4504)
,p_name=>'P136_CONFIRM_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(19875013139383388.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19876309801383393.4504)
,p_name=>'P136_CONFIRM_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(19875013139383388.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome vista materializzata:'
,p_source=>'P135_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Nome della vista da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19877220916383395.4504)
,p_name=>'P136_SQL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(19892812123484000.4504)
,p_prompt=>'SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>' readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19877603841383398.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :OB_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(19875415160383391.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19877816667383398.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P141_MSG  := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :OB_SCHEMA,',
'              p_sql        => :P136_SQL );',
'',
'for c in (select object_id,',
'                 owner,',
'                 object_type,',
'                 object_name',
'           from sys.dba_objects ',
'           where object_name = upper(:p135_name)',
'           and   owner = :OB_SCHEMA',
'           and   object_type = ''MATERIALIZED VIEW'') loop',
'  :object_id    := c.object_id;',
'  :object_owner := c.owner;',
'  :object_name  := c.object_name;',
'  :object_type  := ''MATERIALIZED_VIEW'';',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19878025448383399.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P136_SQL,',
'    p_schema            => :P48_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(19875415160383391.4504)
);
end;
/
prompt --application/pages/page_00138
begin
wwv_flow_api.create_page(
 p_id=>138.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Immettere le bind variable'
,p_alias=>'SC_GETBINDS'
,p_step_title=>'Immettere le bind variable'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_footer_text=>'<input type="text" style="display:none;" />'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script src="#IMAGE_PREFIX#sc/sc_core.js" type="text/javascript"></script>',
''))
,p_step_template=>wwv_flow_api.id(102479827851590823.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21663321664876078.4504)
,p_plug_name=>'Bind Variables'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    tBind     varchar2(2000);',
'    l_binds   wwv_flow_global.vc_arr2;',
'    l_bindVar wwv_flow_global.vc_arr2;',
'begin',
'    l_binds := wwv_flow_utilities.string_to_table (str => v(''p1200_binds''),sep => '','');',
'    l_bindVar := wwv_flow_utilities.string_to_table (str => v(''p1200_bind_vals''),sep => '','');',
'    ',
'    if l_binds.count > 0 then',
'        sys.htp.p(''<div class="a-Report a-Report--stretch"><div class="a-Report-wrap"><div class="a-Report-tableWrap">'');',
'        sys.htp.p(''<table class="a-Report-report" ''||wwv_flow_utilities.get_layout_table_attributes||''>'');',
'        sys.htp.p(''<thead><tr>'');',
'        sys.htp.p(''<th class="a-Report-colHead" align="left" id="BIND_VAR">''||wwv_flow_lang.system_message(''BIND_VARIABLE'')||''</th>'');',
'        sys.htp.p(''<th class="a-Report-colHead" align="left" id="TO_VALUE">''||wwv_flow_lang.system_message(''F4500_P10_VALUE'')||''</th>'');',
'        sys.htp.p(''</tr></thead>'');',
'        sys.htp.p(''<tbody>'');',
'    end if;',
'',
'    for i in 1..l_binds.count loop',
'        begin',
'            select decode(l_bindVar(i),''HTMLDB:NULL'','''',l_bindVar(i)) ',
'              into tBind from dual;',
'        exception when no_data_found then',
'            tBind := ''HTMLDB:NULL'';',
'        end;',
'',
'        sys.htp.prn(''<tr><td class="a-Report-cell" headers="BIND_VAR" align="right">'');',
'        sys.htp.prn(HTMLDB_ITEM.HIDDEN(1,wwv_flow_escape.html(l_binds(i))));',
'        sys.htp.prn(wwv_flow_escape.html(l_binds(i))||''</td><td class="a-Report-cell" headers="TO_VALUE">'');',
'',
'       if (l_bindVar.count >= i) then',
'           sys.htp.prn(HTMLDB_ITEM.TEXT(2,wwv_flow_escape.html(tBind),null,null,''title="''||wwv_flow_lang.system_message(''NEW_BIND_VARIABLE'',wwv_flow_escape.html(l_binds(i)))||''"''));  ',
'       else ',
'           sys.htp.prn(HTMLDB_ITEM.TEXT(2,null,null,null,''title="''||wwv_flow_lang.system_message(''NEW_BIND_VARIABLE'',wwv_flow_escape.html(l_binds(i)))||''"''));  ',
'       end if;',
'',
'       sys.htp.p(''</td></tr>'');',
'    end loop;',
'',
'    if l_binds.count > 0 then',
'        sys.htp.p(''</tbody>'');',
'        sys.htp.p(''</table>'');',
'        sys.htp.p(''</div></div></div>'');',
'    end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1272646864697365249.4504)
,p_plug_name=>'Barra dei pulsanti'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21684021092159769.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1272646864697365249.4504)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sottometti'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21710203515485840.4504)
,p_branch_action=>'f?p=&APP_ID.:138:&SESSION.:LEAVE:&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21684021092159769.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1119153986522390602.4504)
,p_name=>'Post Binds'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'LEAVE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1119154041010390603.4504)
,p_event_id=>wwv_flow_api.id(1119153986522390602.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sc_postBind("&P1200_BIND_VALS.");'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21707831172465411.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'post_binds'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.debug(''binds ''||HTMLDB_APPLICATION.G_F01.COUNT);',
'wwv_flow.debug(''vals ''||HTMLDB_APPLICATION.G_F02.COUNT);',
'FOR I in 1..HTMLDB_APPLICATION.G_F01.COUNT LOOP',
'  if (HTMLDB_APPLICATION.G_F02.count >= i) then',
'    if (i = 1) then',
'      :p1200_bind_vals := nvl(HTMLDB_APPLICATION.G_F02(i),''HTMLDB:NULL'');',
'    else',
'      :p1200_bind_vals := :p1200_bind_vals||'',''||HTMLDB_APPLICATION.G_F02(i);',
'    end if;',
'  end if;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(21684021092159769.4504)
);
end;
/
prompt --application/pages/page_00139
begin
wwv_flow_api.create_page(
 p_id=>139.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Descrivi comando SQL'
,p_alias=>'SQL_CMD_DESC'
,p_step_title=>'Descrivi comando SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213236325564854129)
,p_step_template=>wwv_flow_api.id(14599108081253832.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22151631482530337.4504)
,p_plug_name=>'Describe'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22734206162670902.4504)
,p_name=>'Functions and Procedures'
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P139_OWNER as owner,',
'       object_name,',
'       nvl (',
'           argument_name,',
'           decode(in_out, ''OUT'', ''<return value>'', ''<none>'')',
'           ) as argument,',
'       nvl(in_out, ''IN'') as in_out,',
'       case',
'         when type_subname is null then',
'           case',
'             when data_type = ''VARCHAR2'' and data_length is not null then data_type||'' (''||data_length||'')''',
'             else data_type',
'           end',
'         else data_type||'' (''||type_subname||'')''',
'       end as datatype',
'  from sys.user_arguments',
' where object_name = trim(:P139_OBJECT)',
' order by object_name, overload, position'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P139_TYPE in (''PROCEDURE'',''FUNCTION'') and',
'(:P139_OBJECT is not null) and ',
':P139_STATUS = ''VALID'''))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Nessun argomento per questo oggetto.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(133525430001143648.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Owner'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22787418942954200.4504)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome oggetto'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:sc_getSQL(''&P139_OWNER..#OBJECT_NAME#'');'
,p_column_linktext=>'#OBJECT_NAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22787805472954201.4504)
,p_query_column_id=>3
,p_column_alias=>'ARGUMENT'
,p_column_display_sequence=>2
,p_column_heading=>'Argomento'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23989902807114363.4504)
,p_query_column_id=>4
,p_column_alias=>'IN_OUT'
,p_column_display_sequence=>3
,p_column_heading=>'In Out'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23650632085677148.4504)
,p_query_column_id=>5
,p_column_alias=>'DATATYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo di dati'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22918222587536700.4504)
,p_name=>'Package'
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P139_OWNER as owner,',
'       package_name,',
'       decode(overload, null, object_name, object_name||''(''||to_char(overload)||'')'') as procedure,',
'       argument_name as argument,',
'       decode(argument_name, null, decode(data_type, null, '''', ''OUT''), in_out) as in_out,',
'       case',
'         when type_subname is null then',
'           case',
'             when data_type = ''VARCHAR2'' and data_length is not null then data_type||'' (''||data_length||'')''',
'             else data_type',
'           end',
'         else data_type||'' (''||type_subname||'')''',
'       end as datatype,',
'       object_name',
'  from sys.user_arguments',
' where package_name = trim(:P139_OBJECT)',
'   and data_level < 1',
' order by object_name, overload, position'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P139_TYPE in (''PACKAGE'') and',
'(:P139_OBJECT is not null or',
':P139_OBJECT != ''0'')'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(133493118423979428.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>7
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23998524072205627.4504)
,p_query_column_id=>2
,p_column_alias=>'PACKAGE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome package'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:ret_Column(''&P139_OWNER..#PACKAGE_NAME#'');'
,p_column_linktext=>'#PACKAGE_NAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23652810951686944.4504)
,p_query_column_id=>3
,p_column_alias=>'PROCEDURE'
,p_column_display_sequence=>2
,p_column_heading=>'Procedura'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:sc_getSQL(''&P139_OWNER..#PACKAGE_NAME#.#OBJECT_NAME#'');'
,p_column_linktext=>'#PROCEDURE#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22918909183536703.4504)
,p_query_column_id=>4
,p_column_alias=>'ARGUMENT'
,p_column_display_sequence=>3
,p_column_heading=>'Argomento'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23652914818686944.4504)
,p_query_column_id=>5
,p_column_alias=>'IN_OUT'
,p_column_display_sequence=>4
,p_column_heading=>'In Out'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23653012360686944.4504)
,p_query_column_id=>6
,p_column_alias=>'DATATYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo di dati'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23998008488201171.4504)
,p_query_column_id=>7
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26118215107900863.4504)
,p_plug_name=>'INVALID Function/Procedure'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table><tr><td valign="top"><img src="''||wwv_flow.g_image_prefix||''error.gif" width="32" height="32"></td>'');',
'sys.htp.p(''<td valign="top" style="color:red;font-size:smaller">'');',
'sys.htp.p(wwv_flow_lang.system_message(''INVALID_OBJECT'',:P139_OBJECT));',
'sys.htp.p(''</td></tr></table>'');',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P139_TYPE in (''PROCEDURE'',''FUNCTION'') and',
'(:P139_OBJECT is not null or :P139_OBJECT != ''0'')',
'and :P139_STATUS != ''VALID'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181940330173429738.4504)
,p_plug_name=>'Describe Help Message'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''SC_DESCRIBE''));'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'v(''P139_TYPE'') = ''---'' and v(''P139_OBJECT'') = ''---'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(198570132213852702.4504)
,p_plug_name=>'Describe object not found'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>17
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(wwv_flow_lang.system_message(''SC_NOT_VALID_OBJECT''));',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'v(''P139_TYPE'') = ''---'' and v(''P139_OBJECT'') != ''---'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(367602808298431816.4504)
,p_name=>'Tables and Views'
,p_display_sequence=>22
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.owner,',
'       t.table_name,',
'       t.column_name,',
'       t.data_type,',
'       decode (',
'           t.data_precision,',
'           null,',
'           decode (',
'               t.data_type,',
'               ''CHAR'',      t.char_length,',
'               ''NCHAR'',     t.char_length,',
'               ''VARCHAR'',   t.char_length,',
'               ''VARCHAR2'',  t.char_length,',
'               ''NVARCHAR2'', t.char_length,',
'               t.data_length ),',
'               decode (',
'                   t.data_type,',
'                   ''NUMBER'',',
'                   null,',
'                   t.data_precision ) ) as data_length,',
'       t.data_precision,',
'       t.data_scale,',
'       cons.position pk,',
'       decode(t.nullable,''Y'',''<img src="#IMAGE_PREFIX#check_small_black.gif" border="0" height="15" width="15" alt="''||wwv_flow_lang.system_message(''F4500.NULLABLE'')||''" />'',null) nullable,',
'       t.data_default,',
'       t.column_id,',
'       c.comments comments',
'  from sys.all_tab_columns t,',
'       sys.all_col_comments c,',
'       ( select cl.column_name, cl.position',
'             from sys.all_cons_columns cl,',
'                  sys.all_constraints cn',
'            where cn.owner           = replace(trim(:P139_OWNER),''"'')',
'              and cn.table_name      = replace(trim(:P139_OBJECT),''"'')',
'              and cn.constraint_type = ''P''',
'              and cl.owner           = cn.owner',
'              and cl.table_name      = cn.table_name',
'              and cl.constraint_name = cn.constraint_name',
'        ) cons',
' where t.column_name = c.column_name',
'   and c.table_name  = t.table_name',
'   and c.owner       = t.owner',
'   and t.table_name  = replace(trim(:P139_OBJECT),''"'')',
'   and t.owner       = replace(trim(:P139_OWNER),''"'')',
'   and t.column_name = cons.column_name (+)',
' order by t.column_id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P139_TYPE in (''TABLE'',''VIEW'') and',
'(:P139_OBJECT is not null)'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603003019431819.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>12
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603114805431819.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Tabella'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:ret_Column(''&P139_OWNER..#TABLE_NAME#'');'
,p_column_linktext=>'#TABLE_NAME#'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603215003431819.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:ret_Column(''#COLUMN_NAME#'');'
,p_column_linktext=>'#COLUMN_NAME#'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603325404431819.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo dati'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603432375431819.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603513875431819.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603626301431819.4504)
,p_query_column_id=>7
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603732700431819.4504)
,p_query_column_id=>8
,p_column_alias=>'PK'
,p_column_display_sequence=>7
,p_column_heading=>'Chiave primaria'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603804807431820.4504)
,p_query_column_id=>9
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>8
,p_column_heading=>'Annullabile'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367603919443431820.4504)
,p_query_column_id=>10
,p_column_alias=>'DATA_DEFAULT'
,p_column_display_sequence=>9
,p_column_heading=>'Valore predefinito'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367604017413431820.4504)
,p_query_column_id=>11
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>10
,p_column_heading=>'Column'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(367604102858431820.4504)
,p_query_column_id=>12
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>11
,p_column_heading=>'Commento'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22156222310565561.4504)
,p_name=>'P139_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22151631482530337.4504)
,p_prompt=>'Tipo di oggetto'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P139_TYPE'
,p_display_when2=>'---'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Selezionare il tipo di dati dell''oggetto di database che si desidera descrivere.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22174606305655533.4504)
,p_name=>'P139_OBJECT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(22151631482530337.4504)
,p_prompt=>'Oggetto'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P139_TYPE'
,p_display_when2=>'---'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Selezionare il nome dell''oggetto di database che si desidera descrivere.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26109431636848823.4504)
,p_name=>'P139_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(22151631482530337.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(163607902932567187.4504)
,p_name=>'P139_OWNER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(22151631482530337.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(163900618281479961.4504)
,p_name=>'P139_ACTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(22151631482530337.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(260345913184518928.4504)
,p_name=>'P139_PREV_SQL'
,p_data_type=>'CLOB'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(22151631482530337.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22516125575777686.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.get_describe_object_info (',
'    p_action           => :P139_ACTION,',
'    p_schema           => :P1003_SCHEMA,',
'    p_desc_object_name => rtrim(ltrim( :P139_OBJECT )),',
'    -- output computed item values',
'    p_object_owner     => :P139_OWNER,',
'    p_object_name      => :P139_OBJECT,',
'    p_object_type      => :P139_TYPE,',
'    p_object_status    => :P139_STATUS );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22816121146082168.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(260344915824510246.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save history'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P1003_SQL_COMMAND2,',
'    p_schema            => :P1003_SCHEMA',
'    );',
'',
':P139_PREV_SQL := :P1003_SQL_COMMAND2;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P1003_SQL_COMMAND2 != nvl(:P139_PREV_SQL,'' '')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00141
begin
wwv_flow_api.create_page(
 p_id=>141.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare la vista materializzata'
,p_step_title=>'Impossibile creare la vista materializzata'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_mview.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19913801958670688.4504)
,p_plug_name=>'Impossibile creare la vista materializzata'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>50
,p_plug_source=>'&P141_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P141_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(265751914643933939.4504)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19914027550670689.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(265751914643933939.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19914423362670690.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(265751914643933939.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19914615673670690.4504)
,p_name=>'P141_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(19913801958670688.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182413807474060143.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' for r in ( select object_id,object_name,owner,object_type',
'from sys.dba_objects',
'where owner = :OB_SCHEMA',
'and object_name = :P135_NAME',
'and object_type = ''MATERIALIZED VIEW'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := ''MATERIALIZED_VIEW'';',
'',
'end loop;',
'',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P141_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00142
begin
wwv_flow_api.create_page(
 p_id=>142.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Revoke_Grant'
,p_step_title=>'Revoke_Grant'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15237504979907211.4504)
,p_plug_name=>'Revoca privilegio'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15243923380940997.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15237504979907211.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15243009874937033.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15237504979907211.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15244103749940998.4504)
,p_branch_action=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15243923380940997.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15248616547995744.4504)
,p_branch_action=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>200
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15247005334983051.4504)
,p_name=>'P142_REVOKE_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15237504979907211.4504)
,p_prompt=>'Revoca da'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(grantee) a,grantee b from (',
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, COLUMN_NAME object_name',
'from sys.dba_col_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME =  :OBJECT_NAME ',
'union all',
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, table_NAME object_name',
'from sys.dba_tab_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME = :OBJECT_NAME)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona assegnatario -'
,p_lov_null_value=>'-'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare l''utente al quale revocare i privilegi.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15253324606054847.4504)
,p_name=>'P142_REVOKE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15237504979907211.4504)
,p_prompt=>'Revoca'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''F4050.ALL'') a,''ALL'' b from dual',
'union all',
'Select PRIVILEGE||'' ("''||COLUMN_NAME||''")'' a,',
' PRIVILEGE  b',
'from sys.dba_col_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME =  :OBJECT_NAME',
' and grantee = :P142_REVOKE_FROM',
'union all',
'Select PRIVILEGE a,PRIVILEGE b',
'from sys.dba_tab_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME = :OBJECT_NAME',
' and grantee = :P142_REVOKE_FROM'))
,p_lov_cascade_parent_items=>'P142_REVOKE_FROM'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare il privilegio da revocare all''utente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15254805605077762.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''revoke ''||replace(:P142_REVOKE,''^'',''"'')||'' on "''||:OBJECT_NAME||',
'   ''" from ''||:P142_REVOKE_FROM'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15255825345083446.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'revoke grant'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(16041501881785389.4504)
,p_validation_name=>'P142_REVOKE_FROM'
,p_validation_sequence=>10
,p_validation=>'P142_REVOKE_FROM'
,p_validation2=>'-'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>'Specificare un valore.'
,p_when_button_pressed=>wwv_flow_api.id(15243923380940997.4504)
,p_associated_item=>wwv_flow_api.id(15247005334983051.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21983711978300791.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00143
begin
wwv_flow_api.create_page(
 p_id=>143.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Concedi'
,p_step_title=>'Concedi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15260702667114775.4504)
,p_plug_name=>'Concedi'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15262627254121828.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15260702667114775.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15261614441118155.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15260702667114775.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15262806836121829.4504)
,p_branch_action=>'f?p=&FLOW_ID.:67:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15262627254121828.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15273000860208818.4504)
,p_branch_action=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>200
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15265507562144596.4504)
,p_name=>'P143_GRANTEE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15260702667114775.4504)
,p_prompt=>'Assegnatario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare l''utente al quale concedere i privilegi.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15266825485168644.4504)
,p_name=>'P143_PRIVS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15260702667114775.4504)
,p_prompt=>'Privilegi specifici  '
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'OB_GRANT_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select privilege_name a, privilege_name b',
'  from sys.v_$object_privilege',
' where object_type_name = case :OBJECT_TYPE',
'                          when ''MATERIALIZED VIEW'' then ''TABLE''',
'                          when ''PACKAGE BODY'' then ''PACKAGE''',
'                          else :OBJECT_TYPE',
'                          end'))
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare i privilegi da concedere.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15267715920175398.4504)
,p_name=>'P143_ALL_PRIVS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(15260702667114775.4504)
,p_item_default=>'All'
,p_prompt=>'Concedi'
,p_source=>'All'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'GRANT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(270678820518416779.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare se concedere TUTTI i privilegi sull''oggetto o solo privilegi specifici.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15276510950240164.4504)
,p_name=>'P143_WITH_GRANT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(15260702667114775.4504)
,p_prompt=>'WITH GRANT OPTION'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'YES_CHECKBOX'
,p_lov=>'.'||wwv_flow_api.id(270681628960428645.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Specificare se l''utente pu\00F2 concedere i privilegi.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15275628826235876.4504)
,p_computation_sequence=>10
,p_computation_item=>'P67_SQL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''grant ''||',
' case when :P143_ALL_PRIVS = ''All'' then ''All''',
'   else replace(:P143_PRIVS,'':'','','')',
'   end',
'||'' on "''||:OBJECT_NAME||''"''',
'||'' to ''||:P143_GRANTEE||',
'case when :P143_with_grant = ''Y'' then '' with grant option''',
'  else null',
'  end'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15277425494244346.4504)
,p_computation_sequence=>20
,p_computation_item=>'P67_ACTION_TEXT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'add grant'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(265630916905308259.4504)
,p_validation_name=>'P143_GRANTEE not null'
,p_validation_sequence=>10
,p_validation=>'trim(:P143_GRANTEE) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Specificare l''assegnatario.'
,p_when_button_pressed=>wwv_flow_api.id(15262627254121828.4504)
,p_associated_item=>wwv_flow_api.id(15265507562144596.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(265630114761294063.4504)
,p_validation_name=>'P143_PRIVS not null'
,p_validation_sequence=>20
,p_validation=>'P143_PRIVS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Selezionare il privilegio o i privilegi da concedere.'
,p_validation_condition=>'P143_ALL_PRIVS'
,p_validation_condition2=>'All'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(15262627254121828.4504)
,p_associated_item=>wwv_flow_api.id(15266825485168644.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(264417925009141008.4504)
,p_name=>'Show/hide P143_PRIVS'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P143_ALL_PRIVS'
,p_condition_element=>'P143_ALL_PRIVS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'All'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(264418212078141009.4504)
,p_event_id=>wwv_flow_api.id(264417925009141008.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P143_PRIVS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(264418626583152173.4504)
,p_event_id=>wwv_flow_api.id(264417925009141008.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P143_PRIVS'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00145
begin
wwv_flow_api.create_page(
 p_id=>145.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea tabella - Chiave esterna'
,p_alias=>'CREATE_TABLE_FK'
,p_step_title=>'Crea tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="htmldb_F4500_pg_145();"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script src="#IMAGE_PREFIX#ob/ob_table_functions.js" type="text/javascript"></script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'function htmldb_hideCol(){',
' html_HideItemRow(''P145_FK_REF_COLUMN'');',
' html_HideItemRow(''P145_FK_REF_COLUMN_SEL'');',
' html_GetElement(''P145_FK_REF_COLUMN_SEL'').options.length = 0;',
' html_GetElement(''P145_FK_THIS_COLUMN_SEL'').options.length = 0;',
'}',
'',
'var Shuttle;',
'var Shuttle2;',
'',
'function htmldb_F4500_pg_145(){',
'htmldb_hideCol(''P145_OB_TABLE_FK_COLUMN'');',
' Shuttle = new dhtml_ShuttleObject(''P145_FK_THIS_COLUMN'',''P145_FK_THIS_COLUMN_SEL'');',
'}',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20958812323871382.4504)
,p_plug_name=>'Aggiungi chiave esterna'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208285802016555084.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149855002981342149.4504)
,p_plug_name=>'Progress Inidicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149747621878186797.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(171620315652606850.4504)
,p_plug_name=>'Chiavi esterne'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208285802016555084.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    sys.htp.prn(''<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" role="presentation" id="htmldbNewTable"><tbody>'');',
'    sys.htp.prn(''<tr><th class="tableheader2">''||    ',
'     wwv_flow_lang.system_message(''OB_FK_NAME'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''CREATE_CONDITION.COLUMNS'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''OB_FK_REFERENCED'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''OB_FK_REFERENCED_TAB'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''DEMO_APPLICATION.ACTION'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||''&nbsp;''||''</th>'');',
'    sys.htp.p(''</tr>'');',
'',
'for c1 in (select seq_id,c001, c002, c003,c004,c005',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_FKS''',
'                order by seq_id) loop',
'    sys.htp.prn(''<tr id="fkTab_''||c1.seq_id||''">'');',
'    sys.htp.prn(''<td>''||c1.c001||''</td>'');',
'    sys.htp.prn(''<td>''||c1.c002||''</td>'');',
'    sys.htp.prn(''<td>''||c1.c003||''</td>'');',
'    sys.htp.prn(''<td>''||c1.c004||''</td>'');',
'    sys.htp.prn(''<td>'');',
'    if c1.c005 = ''C'' then',
'      sys.htp.prn(wwv_flow_lang.system_message(''OB_CASCADE_DELETE'')||''</td>'');',
'    elsif c1.c005 = ''N'' then',
'      sys.htp.prn(wwv_flow_lang.system_message(''OB_SET_NULL'')||''</td>'');',
'    else',
'      sys.htp.prn(wwv_flow_lang.system_message(''SQL_REPORT_WIZ.DEFAULT'')||''</td>'');',
'    end if;',
'    sys.htp.prn(''<td style="text-align: center;" class="htmldbPseudoButton">'');',
'    sys.htp.prn(''<img src="#IMAGE_PREFIX#delete.gif" onclick="ob_rmFkRow('');',
'    sys.htp.prn(c1.seq_id||'')" /></td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'    sys.htp.p(''</tbody></table>'');',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239250309023360429.4504)
,p_plug_name=>'Chiave esterna'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208285802016555084.4504)
,p_plug_display_sequence=>400
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Una chiave esterna stabilisce una relazione tra una colonna o le colonne di una tabella e una chiave primaria o univoca di un''altra tabella.',
'<p />',
'Per definire una chiave esterna, effettuare quanto riportato di seguito.',
'<ul>',
unistr('<li>Selezionare una o pi\00F9 colonne e fare clic sull''icona <strong>Aggiungi</strong>.</li>'),
'<li>Selezionare il nome della tabella che contiene la chiave primaria corrispondente.</li>',
'<li>Selezionare la colonna o le colonne chiave primaria corrispondenti e fare clic sull''icona <strong>Aggiungi</strong>.</li>',
'<li>Selezionare <strong>Non consentire eliminazione</strong> per bloccare l''eliminazione delle righe dalla tabella di riferimento quando vi sono righe dipendenti in tale tabella.</li>',
'<li>Selezionare <strong>Eliminazione a catena</strong> per eliminare le righe dipendenti da questa tabella quando la riga della tabella padre corrispondente viene eliminata.</li>',
'<li>Selezionare <strong>Imposta su null se eliminato</strong> per impostare i valori della colonna chiave esterna su null quando la riga della tabella padre corrispondente viene eliminata.</li>',
'<li>Fare clic su <strong>Aggiungi</strong>.</li>',
'</ul>',
'<p />',
unistr('\00C8 possibile definire pi\00F9 chiavi esterne su questa pagina ma solo quelle visualizzate nel report all''inizio della pagina verranno incluse nell''istruzione CREATE TABLE risultante.'),
'<p />',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239338003185258755.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752120888989695895.4504)
,p_plug_name=>'Crea tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(240260724323995341.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239338003185258755.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(240255312763982575.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239338003185258755.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20962713193909442.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239338003185258755.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(172193313401145063.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(20958812323871382.4504)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aggiungi'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169862105853053599.4504)
,p_branch_action=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'COL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(240260913012995342.4504)
,p_branch_action=>'f?p=&FLOW_ID.:149:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(240260724323995341.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(240255507849982575.4504)
,p_branch_action=>'f?p=&FLOW_ID.:604:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(240255312763982575.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169863013472055830.4504)
,p_branch_action=>'f?p=&APP_ID.:604:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'PK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169863824900059163.4504)
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CONS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169864801136061752.4504)
,p_branch_action=>'f?p=&APP_ID.:612:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CONF'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169867308408063808.4504)
,p_branch_name=>'Go To Page 145'
,p_branch_action=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.:145:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21569902964170491.4504)
,p_name=>'P145_FK_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20958812323871382.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_sw_util.generate_name (',
'    p_owner  => :OB_SCHEMA,',
'    p_name   => :P602_NAME,',
'    p_suffix => ''_FK'' );'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Il nome del vincolo di chiave esterna che si sta definendo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21576426475224562.4504)
,p_name=>'P145_FK_REF_TABLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20958812323871382.4504)
,p_prompt=>'Tabella dei riferimenti'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name ,table_name  r  ',
'from  sys.dba_tables',
'where owner = upper(:OB_SCHEMA)',
'and   table_name not like ''DR$%''',
'and   table_name not like ''BIN$%''',
'order by 1',
''))
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'onblur="ob_createTableFKCols();"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare la tabella a cui viene fatto riferimento da questa chiave esterna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(111184421963185396.4504)
,p_name=>'P145_FK_ACTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20958812323871382.4504)
,p_source=>'D'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE_TABLE_FK_TYPE'
,p_lov=>'.'||wwv_flow_api.id(111182618715174982.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(171725607581572698.4504)
,p_name=>'P145_SCHEMA'
,p_item_sequence=>70
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(172202924332337443.4504)
,p_name=>'P145_FROM_COLS'
,p_item_sequence=>100
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(172204104031341004.4504)
,p_name=>'P145_TO_COLS'
,p_item_sequence=>110
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(172818112734422234.4504)
,p_name=>'P145_FK_SEQ'
,p_item_sequence=>120
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180385509211791632.4504)
,p_name=>'P145_TABLE_NAME'
,p_item_sequence=>130
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_item_default=>'&P602_NAME.'
,p_source=>'P602_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(955892340150997334.4504)
,p_name=>'P145_FK_THIS_COLUMN_SEL'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(20958812323871382.4504)
,p_prompt=>'Seleziona colonna/e chiave'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>'select wwv_flow_escape.html(c001) d, c001 r from wwv_flow_collections where collection_name = ''TBL_WIZ_COLUMNS'' and c001 is not null'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(955892478789997335.4504)
,p_name=>'P145_FK_REF_COLUMN_SEL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(20958812323871382.4504)
,p_prompt=>'Colonna/e di riferimento'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(tc.column_name) d,tc.column_name  r  ',
'from sys.dba_tab_columns tc',
'where tc.owner = upper(:OB_SCHEMA)',
'and   tc.table_name  = upper(:P145_FK_REF_TABLE)'))
,p_lov_cascade_parent_items=>'P145_FK_REF_TABLE'
,p_ajax_items_to_submit=>'P145_FK_REF_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(955892507987997336.4504)
,p_computation_sequence=>10
,p_computation_item=>'P145_TO_COLS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:P145_FK_REF_COLUMN_SEL,'':'','','')'
,p_compute_when=>'ADD'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(955892605213997337.4504)
,p_computation_sequence=>20
,p_computation_item=>'P145_FROM_COLS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:P145_FK_THIS_COLUMN_SEL,'':'','','')'
,p_compute_when=>'ADD'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171814500683797716.4504)
,p_computation_sequence=>10
,p_computation_item=>'P145_FK_REF_TABLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171769000842684278.4504)
,p_computation_sequence=>20
,p_computation_item=>'P145_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'OB_SCHEMA'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(228353121517062989.4504)
,p_validation_name=>'Foreign key match'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_fk_string wwv_flow_global.vc_arr2;',
'l_pk_string wwv_flow_global.vc_arr2;',
'l_data_type_count number;',
'l_p_count number;',
'',
'begin',
'for c1 in (select seq_id,c002,c003,c004',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_FKS''',
'                order by seq_id)',
'',
'loop',
'l_fk_string := wwv_flow_utilities.string_to_table(to_char(c1.c002),'','');',
'l_pk_string := wwv_flow_utilities.string_to_table(to_char(c1.c004),'','');',
'',
'select count(*) into l_p_count',
'  from sys.dba_cons_columns',
'where table_name = c1.c003',
'  and owner = :P145_SCHEMA',
'  and constraint_name = (select constraint_name',
'                           from sys.dba_constraints',
'                          where table_name = c1.c003',
'                            and owner = :P145_SCHEMA',
'                            and constraint_type = ''P'');',
'',
'if l_fk_string.count <> l_p_count then',
'   return false;',
'end if;',
'',
'for i in 1..l_fk_string.count',
'loop',
'      for c2 in (select c001,C002',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_COLUMNS''',
'                 and c001 = l_fk_string(i)',
'                order by seq_id)',
'     loop',
'          select count(data_type) into l_data_type_count',
'              from sys.dba_tab_columns ',
'              where table_name = c1.c003',
'              and owner = :P145_SCHEMA',
'              and column_name = l_pk_string(i)',
'              and data_type = c2.c002;',
'          if l_data_type_count <> 1 then',
'              return false;',
'          end if;',
'     end loop;',
'end loop;',
'end loop;',
'return true;',
'exception when no_data_found then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Il numero di colonne/tipi di dati di riferimento deve corrispondere alle colonne di riferimento.'
,p_when_button_pressed=>wwv_flow_api.id(240260724323995341.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(955892705089997338.4504)
,p_validation_name=>'fk name not null'
,p_validation_sequence=>30
,p_validation=>'P145_FK_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Il nome del vincolo FOREIGN KEY \00E8 obbligatorio.')
,p_when_button_pressed=>wwv_flow_api.id(172193313401145063.4504)
,p_associated_item=>wwv_flow_api.id(21569902964170491.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(955892863007997339.4504)
,p_validation_name=>'ref table not null'
,p_validation_sequence=>40
,p_validation=>'P145_FK_REF_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La tabella di riferimento \00E8 obbligatoria.')
,p_when_button_pressed=>wwv_flow_api.id(172193313401145063.4504)
,p_associated_item=>wwv_flow_api.id(21576426475224562.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(955892947222997340.4504)
,p_validation_name=>'from cols not null'
,p_validation_sequence=>50
,p_validation=>'P145_FROM_COLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Selezionare una o pi\00F9 colonne.')
,p_when_button_pressed=>wwv_flow_api.id(172193313401145063.4504)
,p_associated_item=>wwv_flow_api.id(955892340150997334.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(955893029905997341.4504)
,p_validation_name=>'to cols not null'
,p_validation_sequence=>60
,p_validation=>'P145_TO_COLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Selezionare una o pi\00F9 colonne.')
,p_when_button_pressed=>wwv_flow_api.id(172193313401145063.4504)
,p_associated_item=>wwv_flow_api.id(955892478789997335.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(955893268622997343.4504)
,p_validation_name=>'constraint name not taken'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_counter number;',
'  l_name  varchar2(255);',
'  l_schema varchar2(255);',
'begin',
'',
'  l_name := upper(:P145_FK_NAME);',
'',
' select count(*) into l_counter',
' from wwv_flow_collections',
' where collection_name = ''TBL_WIZ_FKS''',
'  and c001 = l_name;',
'',
'  if l_counter > 0 then',
'    return false;',
'  end if;',
'',
'  l_schema := :P145_SCHEMA;',
'',
' select count(*) into l_counter',
' from sys.dba_objects',
' where object_name = l_name and owner = l_schema;',
'',
' if l_counter > 0 then',
'    return false;',
' end if;',
'',
' return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome vincolo non \00E8 disponibile.')
,p_when_button_pressed=>wwv_flow_api.id(172193313401145063.4504)
,p_associated_item=>wwv_flow_api.id(21569902964170491.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(955893147695997342.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate TBL_WIZ_FKS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_id      number;   ',
'begin',
'   begin',
'      wwv_flow_collection.create_collection(''TBL_WIZ_FKS'');',
'   exception',
'     when others then null;',
'   end;',
'   l_id := wwv_flow_collection.add_member(',
'            p_collection_name => ''TBL_WIZ_FKS'',',
'            p_c001          => upper(v(''P145_FK_NAME'')),',
'            p_c002          => v(''P145_FROM_COLS''),',
'            p_c003          => v(''P145_FK_REF_TABLE''),',
'            p_c004          => v(''P145_TO_COLS''),',
'            p_c005          => v(''P145_FK_ACTION''));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(172193313401145063.4504)
);
end;
/
prompt --application/pages/page_00147
begin
wwv_flow_api.create_page(
 p_id=>147.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Origine download'
,p_step_title=>'Origine download'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15509827922521909.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if not wwv_flow_security.current_company_can_build(',
'                          p_in_schema=>:OBJECT_OWNER) then',
'      raise_application_error(-20000,           wwv_flow_lang.system_message(',
'             p_name=>''WWV_FLOW_SW_API.CHECK_PRIV'',',
'             p0=>wwv_flow.g_user,p1=>:OBJECT_OWNER));',
'        end if;',
'',
'',
'    --',
'    -- set up HTTP header',
'    --',
'    sys.htp.init;',
'',
'    wwv_flow_utilities.print_download_header(',
'        p_mime_type =>     ''text/plain'',',
'        p_file_name =>     :OBJECT_NAME || (',
'            case ',
'                when :OBJECT_TYPE = ''FUNCTION''     then ''.fun''',
'                when :OBJECT_TYPE = ''PROCEDURE''    then ''.prc''',
'                when :OBJECT_TYPE = ''PACKAGE''      then ''.pks''',
'                when :OBJECT_TYPE = ''PACKAGE BODY'' then ''.pkb''',
'                when :OBJECT_TYPE = ''TRIGGER''      then ''.trg''',
'                else ''.sql'' ',
'            end',
'        ),  ',
'        p_is_attachment => true',
'    );',
'',
'    sys.owa_util.http_header_close;',
'',
'    sys.htp.prn(''create or replace '');',
'    for r in ( select text from sys.dba_source ',
'                  where name = :OBJECT_NAME',
'                   and  OWNER = :OBJECT_OWNER ',
'                   and  type  = :OBJECT_TYPE ) loop',
'      sys.htp.prn(r.text);',
'    end loop;',
'',
'    wwv_flow.g_unrecoverable_Error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00149
begin
wwv_flow_api.create_page(
 p_id=>149.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea tabella - Vincoli'
,p_alias=>'OB_TABLE_FK_COLUMN'
,p_step_title=>'Crea tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="ob_loader()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'function ob_loader(){',
' html_GetElement(''P149_SEL_COLS'').options.length = 0;',
' Shuttle = new dhtml_ShuttleObject(''P149_AVAIL_COLS'',''P149_SEL_COLS'');      ',
' p149_RadioTog();',
'}',
'//-->',
'</script>',
'<script src="#IMAGE_PREFIX#ob/ob_table_functions.js" type="text/javascript"></script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167444826113539656.4504)
,p_plug_name=>'Progress Inidicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149747621878186797.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167445024564539658.4504)
,p_plug_name=>'Vincoli'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    sys.htp.p(''<DIV>'');',
'    sys.htp.prn(''<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" role="presentation" id="htmldbNewTable"><tbody>'');',
'    sys.htp.prn(''<tr><th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''OB_CONSTRAINT_NAME'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''PAGE_REGION.TREE_TYPE'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||',
'     wwv_flow_lang.system_message(''OB_CONS_INFO'')||''</th>'');',
'    sys.htp.prn(''<th class="tableheader2">''||''&nbsp;''||''</th>'');',
'    sys.htp.p(''</tr>'');',
'',
'for c1 in (select seq_id,c001, c002, c003, c004',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_CONS''',
'                and c001 is not null',
'                order by seq_id ) loop',
'    sys.htp.prn(''<tr id="consTab_''||c1.seq_id||''">'');',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.c001)||''</td>'');',
'    if c1.c002 = ''C'' then',
'      sys.htp.prn(''<td>''||wwv_flow_lang.system_message(''F4500_CHECK'')||''</td>'');',
'      sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.c004)||''</td>'');',
'    else',
'      sys.htp.prn(''<td>''||wwv_flow_lang.system_message(''F4500_UNIQUE'')||''</td>'');',
'      sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.c003)||''</td>'');',
'    end if;',
'    sys.htp.prn(''<td style="text-align: center;" class="htmldbPseudoButton">'');',
'    sys.htp.prn(''<img src="#IMAGE_PREFIX#delete.gif" onclick="ob_rmConsRow('');',
'    sys.htp.prn(c1.seq_id||'')" /></td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'    sys.htp.p(''</table>'');',
'    sys.htp.p(''</DIV>'');',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(175407523288187065.4504)
,p_plug_name=>'Colonne disponibili'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(''<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" role="presentation" id="htmldbTabCols"><tbody>'');',
'for c in ( select seq_id,c001, c002, c003,c004,c005',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_COLUMNS''',
'                 and c001 is not null',
'                order by seq_id) loop',
'sys.htp.p(''<tr>'');',
'sys.htp.p(''<td>''||wwv_flow_escape.html(c.c001)||''</td>'');',
'sys.htp.p(''<td>''||wwv_flow_escape.html(c.c002)||''</td>'');',
'sys.htp.p(''</tr>'');',
'end loop;',
'sys.htp.p(''</TABLE>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(175418023989262992.4504)
,p_plug_name=>'Aggiungi vincolo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239258012879389908.4504)
,p_plug_name=>'Vincolo UNIQUE'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>80
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Un vincolo UNIQUE designa una colonna o una combinazione di colonne come chiave univoca. Per soddisfare un vincolo UNIQUE, nella tabella non devono esserci due righe contenenti gli stessi valori per le colonne specificate.',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239259424307393233.4504)
,p_plug_name=>'Vincolo CHECK'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208285802016555084.4504)
,p_plug_display_sequence=>70
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Un vincolo CHECK \00E8 un controllo di convalida su una o pi\00F9 colonne all''interno della tabella. In una tabella non \00E8 possibile inserire o aggiornare alcun valore che violi un vincolo CHECK abilitato.'),
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239577718447968797.4504)
,p_plug_name=>'Vincoli CHECK di esempio'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'STATUS IN (''OPEN'',''CLOSED'',''PENDING'')',
'<p />',
'SAL IS NOT NULL OR COMM IS NOT NULL',
'<p />',
'LENGTH(ENAME) >= 6',
'<p />',
'SAL > 0',
'<p />',
'SAL + NVL(COMM,0) > 1000',
'<p />',
'ENAME = UPPER(ENAME)',
'<p />',
'(SAL * 100) = trunc(SAL * 100)',
'<p />',
'HIREDATE > SYSDATE - 7'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239810522906463139.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(241175307212323180.4504)
,p_plug_name=>'Vincoli'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208285802016555084.4504)
,p_plug_display_sequence=>60
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilizzare questa pagina per definire i vincoli per la tabella. \00C8 possibile creare pi\00F9 vincoli di ciascun tipo, ma \00E8 necessario <strong>aggiungere</strong> ogni vincolo. Solo i vincoli visualizzati nel report all''inizio della pagina verranno inclusi ')
||'nell''istruzione CREATE TABLE risultante.',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752120964621695895.4504)
,p_plug_name=>'Crea tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(175504903164578656.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(175418023989262992.4504)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aggiungi'
,p_button_position=>'ABOVE_BOX'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(167445401389539663.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239810522906463139.4504)
,p_button_name=>'CONF'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(240258105622989902.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239810522906463139.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(167445601741539663.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239810522906463139.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169870500013080312.4504)
,p_branch_action=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'COL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(240258324658989903.4504)
,p_branch_action=>'f?p=&FLOW_ID.:145:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(240258105622989902.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169871106592082201.4504)
,p_branch_action=>'f?p=&APP_ID.:604:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'PK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169871713172084124.4504)
,p_branch_action=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'FK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169872321484086591.4504)
,p_branch_action=>'f?p=&APP_ID.:612:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CONF'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169873226678088084.4504)
,p_branch_name=>'Go To Page 149'
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(175401331505132676.4504)
,p_name=>'P149_CONST_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(175418023989262992.4504)
,p_item_default=>'C'
,p_prompt=>'Tipo di vincolo'
,p_source=>'C'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CONTRAINT TYPES'
,p_lov=>'.'||wwv_flow_api.id(270341627024745223.4504)||'.'
,p_tag_attributes=>'onchange="p149_RadioTog();"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(175402922417148992.4504)
,p_name=>'P149_CHECK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(175418023989262992.4504)
,p_prompt=>'Condizione CHECK'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(175507700524587353.4504)
,p_name=>'P149_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(175418023989262992.4504)
,p_prompt=>'Nome'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Il nome del vincolo che si sta definendo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176139216274722491.4504)
,p_name=>'P149_CONS_SEQ'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(167445024564539658.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180380400638770211.4504)
,p_name=>'P149_TABLE_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(167445024564539658.4504)
,p_item_default=>'&P602_NAME.'
,p_source=>'P602_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(955893358552997344.4504)
,p_name=>'P149_CON_COLS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(175418023989262992.4504)
,p_prompt=>'Colonna/e chiave'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>'select wwv_flow_escape.html(c001) d, c001 r from wwv_flow_collections where collection_name = ''TBL_WIZ_COLUMNS'' and c001 is not null'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(955893428857997345.4504)
,p_validation_name=>'Name not null'
,p_validation_sequence=>10
,p_validation=>'P149_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Nome vincolo obbligatorio.'
,p_when_button_pressed=>wwv_flow_api.id(175504903164578656.4504)
,p_associated_item=>wwv_flow_api.id(175507700524587353.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(955893557649997346.4504)
,p_validation_name=>'constraint column required'
,p_validation_sequence=>20
,p_validation=>'P149_CON_COLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Selezionare una o pi\00F9 colonne.')
,p_validation_condition=>'P149_CONST_TYPE'
,p_validation_condition2=>'U'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(175504903164578656.4504)
,p_associated_item=>wwv_flow_api.id(955893358552997344.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(955893660330997347.4504)
,p_validation_name=>'check condition requried'
,p_validation_sequence=>30
,p_validation=>'P149_CHECK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Condizione CHECK obbligatoria.'
,p_validation_condition=>'P149_CONST_TYPE'
,p_validation_condition2=>'C'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(175504903164578656.4504)
,p_associated_item=>wwv_flow_api.id(175402922417148992.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1288749572112738743.4504)
,p_validation_name=>'constraint name not taken'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_counter number;',
'  l_name  varchar2(255);',
'  l_schema varchar2(255);',
'begin',
'',
'  l_name := upper(:P149_NAME);',
'',
' select count(*) into l_counter',
' from wwv_flow_collections',
' where collection_name = ''TBL_WIZ_CONS''',
'  and c001 = l_name;',
'',
'  if l_counter > 0 then',
'    return false;',
'  end if;',
'',
'  l_schema := :P145_SCHEMA;',
'',
' select count(*) into l_counter',
' from sys.dba_objects',
' where object_name = l_name and owner = l_schema;',
'',
' if l_counter > 0 then',
'    return false;',
' end if;',
'',
' return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome vincolo non \00E8 disponibile.')
,p_when_button_pressed=>wwv_flow_api.id(175504903164578656.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(955893798451997348.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop TBL_WIZ_CONS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_id      number;',
'begin',
'   begin',
'     wwv_flow_collection.create_collection(''TBL_WIZ_CONS'');',
'   exception',
'     when others then null;',
'   end;',
'   l_id := wwv_flow_collection.add_member(',
'                    p_collection_name => ''TBL_WIZ_CONS'',',
'                    p_c001          => upper(v(''P149_NAME'')),',
'                    p_c002          => v(''P149_CONST_TYPE''),',
'                    p_c003          => replace(:P149_CON_COLS,'':'','',''),',
'                    p_c004          => v(''P149_CHECK'') );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(175504903164578656.4504)
);
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_api.create_page(
 p_id=>150.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'IFRAME vuoto'
,p_alias=>'BLANK_IFRAME'
,p_step_title=>'BLANK_IFRAME'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'style="margin:0;padding:0;min-width:760px;"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_page_comment=>'Page is used by Object Browser JavaScript Code as a landing page. Don''t delete it! -Patrick'
);
end;
/
prompt --application/pages/page_00159
begin
wwv_flow_api.create_page(
 p_id=>159.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'INDEX_STATISTICS'
,p_alias=>'INDEX_STATISTICS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15781108731707927.4504)
,p_plug_name=>'Index Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(7770017698212372.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15781330359707928.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(15790302694745667.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15781515020707928.4504)
,p_name=>'Stat Query'
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select num_rows,  sample_size, last_analyzed, last_analyzed last_analyzed_since, COMPRESSION',
'from ',
' sys.dba_indexes',
'where owner = :OB_SCHEMA',
'and  index_name = :OBJECT_NAME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15781717033707929.4504)
,p_query_column_id=>1
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>1
,p_column_heading=>'Numero di righe'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15782015404707929.4504)
,p_query_column_id=>2
,p_column_alias=>'SAMPLE_SIZE'
,p_column_display_sequence=>2
,p_column_heading=>'Dimensione campione'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15782106154707929.4504)
,p_query_column_id=>3
,p_column_alias=>'LAST_ANALYZED'
,p_column_display_sequence=>3
,p_column_heading=>'Ultima analisi'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15782227621707930.4504)
,p_query_column_id=>4
,p_column_alias=>'LAST_ANALYZED_SINCE'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15782317377707930.4504)
,p_query_column_id=>5
,p_column_alias=>'COMPRESSION'
,p_column_display_sequence=>5
,p_column_heading=>'Compressione'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
end;
/
prompt --application/pages/page_00160
begin
wwv_flow_api.create_page(
 p_id=>160.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Analizza indice'
,p_step_title=>'Analizza tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15793005228754209.4504)
,p_plug_name=>'Analizza indice'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15793829653754212.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15793005228754209.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15793612529754211.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15793005228754209.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:INDEX_DETAIL:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16218405980382694.4504)
,p_branch_action=>'f?p=&APP_ID.:177:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15793829653754212.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15794002664754212.4504)
,p_name=>'P160_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(15793005228754209.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_post_element_text=>' '
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15794508848754217.4504)
,p_name=>'P160_TABLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(15793005228754209.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome indice corrente:'
,p_post_element_text=>' '
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della tabella da analizzare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15795005024754217.4504)
,p_name=>'P160_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15793005228754209.4504)
,p_item_default=>'ESTIMATE'
,p_prompt=>unistr('Modalit\00E0:')
,p_post_element_text=>' '
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ANALYZE.OPTS'
,p_lov=>'.'||wwv_flow_api.id(88060821315813411.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Specificare la modalit\00E0 di esecuzione dell''operazione di analisi')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15795506660754220.4504)
,p_name=>'P160_EST_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15793005228754209.4504)
,p_item_default=>'percent'
,p_prompt=>'Tipo:'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ROWS.PERCENT'
,p_lov=>'.'||wwv_flow_api.id(88059704693808617.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specificare il numero di righe da utilizzare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15796001151754221.4504)
,p_name=>'P160_EST_AMT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(15793005228754209.4504)
,p_prompt=>'Importo:'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Immettere le righe degli importi per eseguire l''analisi della percentuale e del numero di righe'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15796712491754225.4504)
,p_computation_sequence=>10
,p_computation_item=>'P177_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_est_claus varchar2(255);',
'  c varchar2(32767)             := null;',
'begin',
'  if :P160_MODE = ''ESTIMATE'' then',
'    l_est_claus := :P160_EST_AMT||'' ''||:P160_EST_TYPE;',
'  else',
'    l_est_claus := null;',
'  end if;',
'',
'',
'    c:= ''analyze index "''||:OBJECT_NAME||''"''||chr(10);',
'    c:=c||:P160_MODE;',
'    if upper(:P160_MODE) = ''VALIDATE'' then',
'        c:=c||'' structure'';',
'    else',
'        c:=c||'' statistics'';',
'    end if;',
'    if l_est_claus is not null then',
'        c:=c||'' sample ''||l_est_claus;',
'    end if;',
'    c:=c||chr(10)||''/''||chr(10);',
'',
'    return c;',
'',
'end;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15797100299754227.4504)
,p_validation_name=>'amt required if estimate'
,p_validation_sequence=>10
,p_validation=>'P160_EST_AMT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare l''importo stimato.'
,p_validation_condition=>'P160_MODE'
,p_validation_condition2=>'ESTIMATE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(15793829653754212.4504)
,p_associated_item=>wwv_flow_api.id(15796001151754221.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15797313143754229.4504)
,p_validation_name=>'AmtNumericIfEstimate'
,p_validation_sequence=>15
,p_validation=>'P160_EST_AMT'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'L''importo stimato deve essere numerico.'
,p_validation_condition=>'P160_MODE'
,p_validation_condition2=>'ESTIMATE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(15793829653754212.4504)
,p_associated_item=>wwv_flow_api.id(15796001151754221.4504)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15797509552754230.4504)
,p_validation_name=>'ValidPercent'
,p_validation_sequence=>20
,p_validation=>':P160_EST_AMT > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'L''importo stimato delle righe deve essere maggiore di 0.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P160_MODE = ''ESTIMATE'' and',
':P160_EST_TYPE = ''rows'' and',
':P160_EST_AMT is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(15793829653754212.4504)
,p_associated_item=>wwv_flow_api.id(15796001151754221.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15797700045754230.4504)
,p_validation_name=>'ValidRows'
,p_validation_sequence=>30
,p_validation=>':P160_EST_AMT between 1 and 100'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La percentuale dell''importo stimato deve essere compreso tra 1 e 100.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P160_MODE = ''ESTIMATE'' and',
':P160_EST_TYPE = ''percent'' and',
':P160_EST_AMT is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(15793829653754212.4504)
,p_associated_item=>wwv_flow_api.id(15796001151754221.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(969053701506554624.4504)
,p_name=>'Estimate'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P160_MODE'
,p_condition_element=>'P160_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ESTIMATE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(969053841741554625.4504)
,p_event_id=>wwv_flow_api.id(969053701506554624.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P160_EST_TYPE,P160_EST_AMT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(969053909301554626.4504)
,p_event_id=>wwv_flow_api.id(969053701506554624.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P160_EST_TYPE,P160_EST_AMT'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00161
begin
wwv_flow_api.create_page(
 p_id=>161.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Vista materializzata'
,p_alias=>'MATERIALIZED_VIEW_DETAIL'
,p_step_title=>'Vista materializzata'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15853705654133554.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(15852414527126687.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15878329212216004.4504)
,p_name=>'Details'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name,',
' case when data_type = ''CHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''VARCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''VARCHAR2'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NUMBER'' then',
'      case when c.data_precision is null then',
'          ''NUMBER''',
'      else ',
'          data_type||''(''||c.data_precision||'',''||c.data_SCALE||'')''',
'      end',
'    when data_type = ''NVARCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NVARCHAR2'' then',
'      data_type||''(''||c.char_length||'')''',
'    else',
'      data_type',
'    end data_type,',
'  decode(nullable,''Y'',''Yes'',''No'') nullable,',
'  c.DATA_DEFAULT,',
'   sub.column_position pk	   ',
'  from sys.dba_tab_columns c,',
' (  select column_name,column_position from sys.dba_ind_columns',
'    where (index_owner,index_name) = ',
'   (select owner,index_name from sys.dba_constraints',
'    where owner =:OB_SCHEMA',
'    and  table_name = ',
'  (select object_name from sys.dba_objects where object_id = :OB_OBJECT_NAME )',
'	and  constraint_type = ''P'')) sub',
' where c.column_name = sub.column_name(+)',
'   and  c.owner      = :OBJECT_OWNER',
'  and  c.table_name =  :OBJECT_NAME ',
'  order by sub.column_position,column_id '))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>50000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15878504036216005.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15878631323216005.4504)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo dati'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15878703686216005.4504)
,p_query_column_id=>3
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Annullabile'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15878825892216006.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_DEFAULT'
,p_column_display_sequence=>4
,p_column_heading=>'Valore predefinito'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15878922802216006.4504)
,p_query_column_id=>5
,p_column_alias=>'PK'
,p_column_display_sequence=>5
,p_column_heading=>'Chiave primaria'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19934902351925941.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(19933910744920832.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181323926930568207.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00162
begin
wwv_flow_api.create_page(
 p_id=>162.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Vista materializzata '
,p_alias=>'MATERIALIZED_VIEW_SQL'
,p_step_title=>'Vista materializzata'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_mview.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15857011873150986.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(15852414527126687.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15874612112201698.4504)
,p_plug_name=>'source'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<pre class="code">'');',
'',
'wwv_flow_generate_ddl.execute_get_ddl (',
'    p_schema       => :OB_SCHEMA,',
'    p_objects      => :OBJECT_NAME,',
'    p_object_types => :OBJECT_TYPE,',
'    p_output_type  => ''DISPLAY''',
'    );',
'',
'sys.htp.p(''</pre>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
end;
/
prompt --application/pages/page_00163
begin
wwv_flow_api.create_page(
 p_id=>163.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Vista materializzata '
,p_alias=>'MATERIALIZED_VIEW_DATA'
,p_step_title=>'Vista materializzata'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_mview.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15861300617166847.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(15852414527126687.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15884530297244726.4504)
,p_name=>'Data'
,p_template=>wwv_flow_api.id(12270828624874231.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  v_sql varchar2(2000) := '' dual'';',
'  v_min number;',
'begin',
'  for r in (  select ''"''||owner||''"."''||',
'                       object_name||''"'' t ',
'                from sys.dba_objects ',
'                where object_id = :OB_OBJECT_NAME ) loop',
'      v_sql := r.t;',
'  end loop;',
'',
'  wwv_flow_sw_api.check_priv(:OBJECT_OWNER);',
'',
'  wwv_flow.debug(''select ''||replace(:P163_COLUMNS,'':'','','')||'' from ''||v_sql);',
'return ''select ''||replace(substr(:P163_COLUMNS,2),'':'','','')||'' from ''||v_sql;',
'end;'))
,p_display_when_condition=>'COUNT'
,p_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_header=>'&P2101_MESSAGE.'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>10
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'<span class="instructiontext">Questa vista materializzata non contiene dati.</span>'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'N'
,p_plug_query_exp_filename=>'&OBJECT_NAME..csv'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889206249244736.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889320403244736.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889428654244737.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889521709244737.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15884707677244727.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15884800082244727.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15884915567244727.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885010854244727.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885130815244728.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885226588244728.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885311493244728.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885431049244728.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885526986244728.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885629077244728.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885713828244728.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885815100244728.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15885913991244728.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886015159244729.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886112573244729.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886217499244729.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886328660244729.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886423564244729.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886505507244729.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886607443244729.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886700353244729.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886808060244734.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15886916349244734.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887031175244734.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887126193244734.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887208660244734.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887304204244734.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887418053244734.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887514798244734.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887615193244734.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887715487244735.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887819817244735.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15887908236244735.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888025997244735.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888128467244735.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888217808244735.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888317890244735.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888401728244735.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888505488244736.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888622080244736.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888728580244736.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888820443244736.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15888928961244736.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889023125244736.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889122470244736.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889625830244737.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889732721244737.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889808281244737.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15889901367244737.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15890000844244737.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15890125181244737.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15890211325244738.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15890332045244738.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15890427100244738.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15890512978244738.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15890618438244738.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15912707535294913.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(14089426771868187.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181433615155914912.4504)
,p_plug_name=>'Count'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'COUNT'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15893721771251769.4504)
,p_name=>'P163_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15884530297244726.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15896310127257885.4504)
,p_name=>'P163_MESSAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15884530297244726.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181434222428917043.4504)
,p_name=>'P163_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(181433615155914912.4504)
,p_prompt=>'Conteggio righe:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488425207817537856.4504)
,p_process_sequence=>5
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Verify Authorization'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15908213722268328.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Cols'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_owner varchar2(500);',
' l_name  varchar2(500);',
' i       number := 0;',
' l_max   number := 30;',
'begin',
':P163_COLUMNS := '''';--''rowid'';',
'  for r in ( select column_name',
'             from sys.dba_tab_Columns ',
'             where owner       = :OBJECT_OWNER',
'             and   table_name  = :OBJECT_NAME',
'             order by  column_name ) loop',
'    i := i +1;',
'   exit when i >l_max;',
'   :P163_COLUMNS := :P163_COLUMNS ||'':"''||r.column_name||''"'';',
'  end loop;',
'  if i >l_max then ',
'     :P163_MESSAGE  := wwv_flow_lang.system_message(p_name=>''4500_OBJECT_BROWSER_ONLY_N_COLS'',p0=>l_max);',
'   else',
'     :P163_MESSAGE  := '''';',
'   end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181435311131923295.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'count'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P163_COUNT := ',
'wwv_flow_f4000_util.countem(',
'  ''select count(1) from "''||:OBJECT_OWNER||''"."''||:OBJECT_NAME||''"'',',
'    :OBJECT_OWNER);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile contare le righe: #SQLERRM#'
,p_process_when=>'COUNT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00166
begin
wwv_flow_api.create_page(
 p_id=>166.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Vista materializzata '
,p_alias=>'MATERIALIZED_VIEW_DETAILS'
,p_step_title=>'Vista materializzata'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_mview.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15867620430185191.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(15852414527126687.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15869316136193349.4504)
,p_name=>'Details'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER as owner,',
'       name,',
'       table_name,',
'       master_view,',
'       master_owner,',
'       master,',
'       master_link,',
'       can_use_log,',
'       updatable,',
'       refresh_method,',
'       last_refresh,',
'       error,',
'       fr_operations,',
'       cr_operations,',
'       type,',
'       next,',
'       start_with,',
'       refresh_group,',
'       update_trig,',
'       update_log,',
'       query,',
'       master_rollback_seg,',
'       status,',
'       refresh_mode,',
'       prebuilt',
'  from user_snapshots',
' where name = :OBJECT_NAME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15869620223193359.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15869725547193359.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15869820890193359.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'TABLE_NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15869919519193359.4504)
,p_query_column_id=>4
,p_column_alias=>'MASTER_VIEW'
,p_column_display_sequence=>4
,p_column_heading=>'MASTER_VIEW'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870004589193359.4504)
,p_query_column_id=>5
,p_column_alias=>'MASTER_OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'MASTER_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870114880193359.4504)
,p_query_column_id=>6
,p_column_alias=>'MASTER'
,p_column_display_sequence=>6
,p_column_heading=>'MASTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870223731193359.4504)
,p_query_column_id=>7
,p_column_alias=>'MASTER_LINK'
,p_column_display_sequence=>7
,p_column_heading=>'MASTER_LINK'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870319784193360.4504)
,p_query_column_id=>8
,p_column_alias=>'CAN_USE_LOG'
,p_column_display_sequence=>8
,p_column_heading=>'CAN_USE_LOG'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870418020193360.4504)
,p_query_column_id=>9
,p_column_alias=>'UPDATABLE'
,p_column_display_sequence=>9
,p_column_heading=>'UPDATABLE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870529182193360.4504)
,p_query_column_id=>10
,p_column_alias=>'REFRESH_METHOD'
,p_column_display_sequence=>10
,p_column_heading=>'REFRESH_METHOD'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870609748193360.4504)
,p_query_column_id=>11
,p_column_alias=>'LAST_REFRESH'
,p_column_display_sequence=>11
,p_column_heading=>'LAST_REFRESH'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870726536193360.4504)
,p_query_column_id=>12
,p_column_alias=>'ERROR'
,p_column_display_sequence=>12
,p_column_heading=>'ERROR'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870818190193360.4504)
,p_query_column_id=>13
,p_column_alias=>'FR_OPERATIONS'
,p_column_display_sequence=>13
,p_column_heading=>'FR_OPERATIONS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15870909278193360.4504)
,p_query_column_id=>14
,p_column_alias=>'CR_OPERATIONS'
,p_column_display_sequence=>14
,p_column_heading=>'CR_OPERATIONS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871003607193360.4504)
,p_query_column_id=>15
,p_column_alias=>'TYPE'
,p_column_display_sequence=>15
,p_column_heading=>'TYPE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871132060193360.4504)
,p_query_column_id=>16
,p_column_alias=>'NEXT'
,p_column_display_sequence=>16
,p_column_heading=>'NEXT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871220571193361.4504)
,p_query_column_id=>17
,p_column_alias=>'START_WITH'
,p_column_display_sequence=>17
,p_column_heading=>'START_WITH'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871316658193361.4504)
,p_query_column_id=>18
,p_column_alias=>'REFRESH_GROUP'
,p_column_display_sequence=>18
,p_column_heading=>'REFRESH_GROUP'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871420849193361.4504)
,p_query_column_id=>19
,p_column_alias=>'UPDATE_TRIG'
,p_column_display_sequence=>19
,p_column_heading=>'UPDATE_TRIG'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871523618193361.4504)
,p_query_column_id=>20
,p_column_alias=>'UPDATE_LOG'
,p_column_display_sequence=>20
,p_column_heading=>'UPDATE_LOG'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871606908193361.4504)
,p_query_column_id=>21
,p_column_alias=>'QUERY'
,p_column_display_sequence=>21
,p_column_heading=>'QUERY'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871721419193361.4504)
,p_query_column_id=>22
,p_column_alias=>'MASTER_ROLLBACK_SEG'
,p_column_display_sequence=>22
,p_column_heading=>'MASTER_ROLLBACK_SEG'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871829646193361.4504)
,p_query_column_id=>23
,p_column_alias=>'STATUS'
,p_column_display_sequence=>23
,p_column_heading=>'STATUS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15871922956193361.4504)
,p_query_column_id=>24
,p_column_alias=>'REFRESH_MODE'
,p_column_display_sequence=>24
,p_column_heading=>'REFRESH_MODE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15872030111193361.4504)
,p_query_column_id=>25
,p_column_alias=>'PREBUILT'
,p_column_display_sequence=>25
,p_column_heading=>'PREBUILT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21984515581737047.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00173
begin
wwv_flow_api.create_page(
 p_id=>173.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Privilegi di vista materializzata'
,p_alias=>'MATERIALIZED_VIEW_GRANTS'
,p_step_title=>'FUNCTION_GRANTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_mview.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15917623841350015.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(15238925543915636.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15917819771350016.4504)
,p_name=>'Grants'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, COLUMN_NAME object_name',
'from sys.user_col_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME =  :OBJECT_NAME ',
'union all',
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, table_NAME object_name',
'from sys.user_tab_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa vista materializzata non ha concessioni di privilegi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15918028295350016.4504)
,p_query_column_id=>1
,p_column_alias=>'PRIVILEGE'
,p_column_display_sequence=>1
,p_column_heading=>'Privilegio'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15918102557350017.4504)
,p_query_column_id=>2
,p_column_alias=>'GRANTEE'
,p_column_display_sequence=>2
,p_column_heading=>'Assegnatario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15918217040350017.4504)
,p_query_column_id=>3
,p_column_alias=>'GRANTABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Assegnabile'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15918302424350017.4504)
,p_query_column_id=>4
,p_column_alias=>'GRANTOR'
,p_column_display_sequence=>4
,p_column_heading=>'Concedente'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15918408162350017.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nome oggetto'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15918519981350017.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(15852414527126687.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21984828225778558.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00174
begin
wwv_flow_api.create_page(
 p_id=>174.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Sinonimi di vista materializzata'
,p_alias=>'MATERIALIZED_VIEW_SYNONYMS'
,p_step_title=>'Sinonimi di tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_mview.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15924101753381231.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(15852414527126687.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15924313735381232.4504)
,p_name=>'Sinonimi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'       synonym_name',
'  from apex_sys_all_synonyms',
' where table_owner = :OBJECT_OWNER',
'   and table_name  = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa vista materializzata non ha sinonimi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15924515259381233.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15924628166381233.4504)
,p_query_column_id=>2
,p_column_alias=>'SYNONYM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'SYNONYM_NAME'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(18445319133654285.4504)
,p_name=>'Riferimenti'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select referenced_owner as owner,',
'       referenced_name as table_name,',
'       referenced_type,',
'       replace(referenced_type, '' '', ''_'') as type_link,',
'       ( select object_id',
'           from apex_sys_all_objects',
'          where owner       = dd.referenced_owner',
'            and object_name = dd.referenced_name',
'            and object_type = dd.referenced_type ) object_id',
'  from apex_sys_all_dependencies dd',
' where type             = ''MATERIALIZED VIEW''',
'   and name             = :OBJECT_NAME',
'   and referenced_name != :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa vista materializzata non ha riferimenti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18445517892654290.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18445617223654291.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#TABLE_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(286169307857344920.4504)
,p_query_column_id=>3
,p_column_alias=>'REFERENCED_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(286169423449344920.4504)
,p_query_column_id=>4
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18445717774654291.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>3
,p_column_heading=>'OBJECT_ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(18446926751656408.4504)
,p_name=>'Riferimento proveniente da'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'       name,',
'       type,',
'       decode (',
'           type,',
'           ''PACKAGE BODY'',',
'           ''PACKAGE'',',
'           replace(type, '' '', ''_'' )) as type_link,',
'       ( select ao.object_id',
'           from apex_sys_all_objects ao',
'          where ao.owner       = dd.owner',
'            and ao.object_name = dd.name',
'            and ao.object_type = dd.type) as object_id',
'  from apex_sys_all_dependencies dd',
' where referenced_owner = :OBJECT_OWNER',
'   and (referenced_type = :OBJECT_TYPE or referenced_type = ''TABLE'')',
'   and referenced_name  = :OBJECT_NAME',
'   and name            != :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'A questa vista materializzata non fanno riferimento altri oggetti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
,p_comment=>'Needed to add ''TABLE'' to the WHERE because dba_dependencies marks materialized views as tables.  Also needed to remove references to itself - for some reason all materialized views have a reference to themselves in dba_dependencies.'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18447113148656409.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18447226588656409.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18447329532656410.4504)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18447429766656410.4504)
,p_query_column_id=>4
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>4
,p_column_heading=>'TYPE_LINK'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18447517054656410.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>5
,p_column_heading=>'OBJECT_ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21985109572801527.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00177
begin
wwv_flow_api.create_page(
 p_id=>177.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'conferma modifica indice'
,p_step_title=>'Conferma modifica tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16226912531446062.4504)
,p_plug_name=>'Confermare la richiesta. '
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16227102658446068.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>30
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16227529181446073.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16226912531446062.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Fine'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16227703395446073.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(16226912531446062.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:160:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16227327409446070.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16226912531446062.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:INDEX_DETAIL:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16231604732446095.4504)
,p_branch_name=>'Go To Page 178'
,p_branch_action=>'178'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(16227529181446073.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16227919435446076.4504)
,p_name=>'P177_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(16226912531446062.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16228425644446080.4504)
,p_name=>'P177_TABLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(16226912531446062.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Indice:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16228921646446081.4504)
,p_name=>'P177_ACTION'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(16226912531446062.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Analizza indice con:'
,p_source=>'P160_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ANALYZE.OPTS'
,p_lov=>'.'||wwv_flow_api.id(88060821315813411.4504)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica il tipo di azione da eseguire sulla tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16229400830446082.4504)
,p_name=>'P177_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16227102658446068.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16230831216446092.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &P56_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(16227529181446073.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16231019801446092.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P178_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P177_SQL );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la modifica dell''indice. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(16227529181446073.4504)
,p_process_success_message=>'Modificato indice.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16231216755446093.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P177_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(16227529181446073.4504)
);
end;
/
prompt --application/pages/page_00178
begin
wwv_flow_api.create_page(
 p_id=>178.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Indice modificato'
,p_step_title=>'Indice modificato'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_trig.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(269031784558330629.4504)
,p_plug_name=>'Operazione riuscita'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Esecuzione dell''operazione &OBJECT_TYPE. completata.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P178_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(392708126772105349.4504)
,p_plug_name=>'Errore'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><img src="#IMAGE_PREFIX#htmldb/builder/fail.gif" alt=""/>L''operazione &OBJECT_TYPE. non \00E8 riuscita per il seguente motivo:</p>'),
'<p>&P178_MSG.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P178_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(392709476811105372.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(392709848995105372.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(392708126772105349.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'BELOW_BOX'
,p_button_redirect_url=>'f?p=&APP_ID.:177:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(392710231855105374.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(269031784558330629.4504)
,p_button_name=>'OK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'BELOW_BOX'
,p_button_redirect_url=>'f?p=&APP_ID.:159:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(392708552869105363.4504)
,p_name=>'P178_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(392708126772105349.4504)
,p_prompt=>'Messaggio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Testo Guida non richiesto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(392710691939105394.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for r in ( select object_id,object_name,owner,object_type',
' from sys.dba_objects',
' where owner = :OB_SCHEMA',
' and object_name = :P84_TRIGGER_NAME',
' and object_type = ''TRIGGER'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_00179
begin
wwv_flow_api.create_page(
 p_id=>179.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Modifica sequenza'
,p_alias=>'ALTER_SEQUENCE'
,p_step_title=>'Crea sequenza'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_seq.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16339623052076914.4504)
,p_plug_name=>'Modifica sequenza'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>11
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Le sequenze di database sono oggetti di database utilizzati per generare valori interi in base a regole definite al momento della creazione della sequenza. In genere le sequenze di database vengono utilizzate per popolare le chiavi primarie di tab'
||'ella.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16340011466076922.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16339803346076921.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:SEQUENCE_DETAIL:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16345330197076937.4504)
,p_branch_action=>'180'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(16340011466076922.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16340202646076923.4504)
,p_name=>'P179_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Selezionare lo schema di database (o nome utente) nel quale si desidera creare l''oggetto. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16340725280076925.4504)
,p_name=>'P179_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome sequenza'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Identifica il nome dell''oggetto. I nomi di oggetto devono essere conformi alle convenzioni di denominazione Oracle e non possono contenere spazi o iniziare con numeri o caratteri di sottolineatura.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16341407655076927.4504)
,p_name=>'P179_CURR_VAL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_prompt=>'Valore corrente'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'<p>Valore Inizia con.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16341923418076928.4504)
,p_name=>'P179_INCREMENT_BY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_prompt=>'Increment By'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere un incremento.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16342411789076928.4504)
,p_name=>'P179_MIN'
,p_item_sequence=>33
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_prompt=>'Valore minimo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere un valore.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16342921663076929.4504)
,p_name=>'P179_MAX'
,p_item_sequence=>36
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_prompt=>'Valore massimo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere un valore.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16343425255076930.4504)
,p_name=>'P179_CYCLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_prompt=>'Ciclo'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare CYCLE per indicare che la sequenza continua a generare valori dopo che ha raggiunto il valore massimo o minimo. Una sequenza con ordine crescente, quando raggiunge il valore massimo, genera il valore minimo. Una sequenza con ordine decres'
||'cente, quando raggiunge il valore minimo, genera il valore massimo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16343613021076931.4504)
,p_name=>'P179_CACHE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_prompt=>'Numero da inserire nella cache'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere un incremento.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16344123984076932.4504)
,p_name=>'P179_ORDER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16339623052076914.4504)
,p_prompt=>'Ordina'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Specificare ORDER per garantire che i numeri di sequenza vengano generati in base all''ordine di richiesta. Questa clausola \00E8 utile se si utilizzano i numeri di sequenza come indicatori orari. Di solito, non \00E8 importante che l''ordine di richiesta sia ')
||'garantito per le sequenza utilizzate per generare chiavi primarie.',
'',
unistr('<p>La clausola ORDER \00E8 necessaria solo per garantire una generazione ordinata se si utilizza un database Oracle con Real Application Clusters. Se si utilizza la modalit\00E0 esclusiva, i numeri di sequenza vengono generati sempre in ordine.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(16344517657076934.4504)
,p_computation_sequence=>10
,p_computation_item=>'P180_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c varchar2(32767)  := null;',
'begin',
'    c:=''alter sequence "''||:OBJECT_NAME||''"''||chr(10);',
'',
'if to_number(nvl(:P179_MIN,''0'')) <= to_number(nvl(:P179_CURR_VAL,''0'')) then',
'    c:=c||''minvalue ''||:P179_MIN||chr(10);',
'end if;',
'',
'    c:=c||''maxvalue ''||:P179_MAX||chr(10);',
'    c:=c||''increment by ''||:P179_INCREMENT_BY||chr(10);',
'',
'if (:P179_CYCLE = ''Y'') then',
'    c:=c||''cycle''||chr(10);',
'else ',
'    c:=c||''nocycle''||chr(10);',
'end if;',
'',
'if (:P179_CACHE is not null and :P179_CACHE > 0) then',
'    c:=c||''cache ''||:P179_CACHE||chr(10);',
'else',
'    c:=c||''nocache''||chr(10);',
'end if;',
'',
'if (:P179_ORDER = ''Y'') then',
'    c:=c||''order''||chr(10);',
'else',
'    c:=c||''noorder''||chr(10);',
'end if;',
'',
'    return c||''/   ''||chr(10);',
'',
'end;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(109464428032947069.4504)
,p_validation_name=>'P179_MIN'
,p_validation_sequence=>10
,p_validation=>'to_number(nvl(:P179_MIN,''0'')) <= to_number(nvl(:P179_CURR_VAL,''0''))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Il valore minimo non pu\00F2 superare il valore corrente.')
,p_associated_item=>wwv_flow_api.id(16342411789076928.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16365005902217848.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c in (select * from sys.dba_sequences where sequence_name = :OBJECT_NAME and sequence_owner = :OBJECT_OWNER) loop',
'  :P179_MIN          := c.MIN_VALUE;',
'  :P179_MAX          := c.MAX_VALUE;',
'  :P179_INCREMENT_BY := c.INCREMENT_BY;',
'  :P179_CYCLE        := c.CYCLE_FLAG;',
'  :P179_CACHE        := c.CACHE_SIZE;',
'  :P179_ORDER        := c.ORDER_FLAG;',
'  :P179_CURR_VAL     := c.last_number;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'ALTER'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21985519062889455.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00180
begin
wwv_flow_api.create_page(
 p_id=>180.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma modifica sequenza'
,p_step_title=>'Conferma modifica sequenza'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16347120503080547.4504)
,p_plug_name=>'Conferma modifica sequenza'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969054029221554627.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16347531387080549.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(16347120503080547.4504)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Fine'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16347703080080549.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16347120503080547.4504)
,p_button_name=>'previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16347307691080549.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16347120503080547.4504)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:SEQUENCE_DETAIL:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16350503044080559.4504)
,p_branch_name=>'Go To Page 2400'
,p_branch_action=>'f?p=&APP_ID.:2400:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(16347531387080549.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16347924321080550.4504)
,p_name=>'P180_CONFIRM_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(16347120503080547.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16348422031080551.4504)
,p_name=>'P180_CONFIRM_NAME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(16347120503080547.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome sequenza:'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'N'
,p_help_text=>'Nome della sequenza da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16349321087080554.4504)
,p_name=>'P180_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(969054029221554627.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16349717684080556.4504)
,p_name=>'P180_MSG'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16347120503080547.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16349909687080558.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :OB_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(16347531387080549.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16350103685080558.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P180_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :OB_SCHEMA,',
'              p_sql        => :P180_SQL );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la modifica della sequenza. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Sequenza modificata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16350323089080559.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P180_SQL,',
'    p_schema            => :OB_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(16347531387080549.4504)
);
end;
/
prompt --application/pages/page_00182
begin
wwv_flow_api.create_page(
 p_id=>182.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea selettore di tipo'
,p_alias=>'TYPE_CREATE'
,p_step_title=>'Crea selettore di tipo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_type.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16519816165437924.4504)
,p_plug_name=>'Crea tipo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150832822844248889.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150827529723222442.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239891710279923133.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752121028289695895.4504)
,p_plug_name=>'Crea tipo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16556117437930301.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239891710279923133.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16520706946444766.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239891710279923133.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16556317470930302.4504)
,p_branch_action=>'f?p=&APP_ID.:183:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P182_TYPE'
,p_branch_condition_text=>'C'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16522817812457393.4504)
,p_name=>'P182_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16519816165437924.4504)
,p_prompt=>'Nome tipo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere il nome del tipo da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16523710671464707.4504)
,p_name=>'P182_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16519816165437924.4504)
,p_item_default=>'C'
,p_prompt=>'Tipo da creare'
,p_source=>'C'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TYPE_OF_TYPE'
,p_lov=>'.'||wwv_flow_api.id(16521502229452853.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare il tipo da creare.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(111028716442293488.4504)
,p_name=>'P182_PRESERVE_CASE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16519816165437924.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21778206326643787.4504)
,p_computation_sequence=>10
,p_computation_item=>'P182_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(v(''P182_NAME''),chr(32),''_''))'
,p_compute_when=>'P182_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(16558118954940258.4504)
,p_validation_name=>'P182_NAME no null'
,p_validation_sequence=>10
,p_validation=>'P182_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore.'
,p_associated_item=>wwv_flow_api.id(16522817812457393.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(268070130565131249.4504)
,p_validation_name=>'name available'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_util.is_available_name2(',
'p_name => :P182_NAME,                                          p_owner=> :OB_SCHEMA,',
'p_type => ''TYPE''',
') then',
'  return',
'wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P182_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00183
begin
wwv_flow_api.create_page(
 p_id=>183.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea tipo di collection'
,p_alias=>'TYPE_CREATE_COL'
,p_step_title=>'Crea tipo di collection'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16526706487586526.4504)
,p_plug_name=>'Crea tipo di collection'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150831609338244906.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150827529723222442.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239894406385940994.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752121189960695896.4504)
,p_plug_name=>'Crea tipo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16881318699397305.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239894406385940994.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16528503155595077.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239894406385940994.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16527622071591026.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239894406385940994.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16881532230397306.4504)
,p_branch_action=>'f?p=&FLOW_ID.:184:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(16881318699397305.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16781907178637009.4504)
,p_branch_action=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(16528503155595077.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16530622333610011.4504)
,p_name=>'P183_COLL_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16526706487586526.4504)
,p_item_default=>'V'
,p_prompt=>'Tipo'
,p_source=>'V'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TYPE_COLLECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(16529130513602905.4504)||'.'
,p_tag_attributes=>'onChange="toggleLen(this.value);"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Selezionare un tipo di collection da creare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16532218355646784.4504)
,p_name=>'P183_DATA_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16526706487586526.4504)
,p_prompt=>'Tipo dati'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TYPE_DATA_TYPES'
,p_lov=>'.'||wwv_flow_api.id(16534820904659665.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specificare il tipo di dati del varray.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16550501526727087.4504)
,p_name=>'P183_LENGTH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(16526706487586526.4504)
,p_item_default=>'1'
,p_prompt=>'Lunghezza'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Testo Guida non disponibile.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16728329267387984.4504)
,p_name=>'P183_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16526706487586526.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16728513649387985.4504)
,p_name=>'P183_OBJECT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16526706487586526.4504)
,p_prompt=>'Oggetto'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TYPE_AVAILABLE'
,p_lov=>'select wwv_flow_escape.html(type_name) d, type_name r from sys.dba_types where owner = :OB_SCHEMA'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Testo Guida non disponibile.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16728718572387985.4504)
,p_name=>'P183_LIMIT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16526706487586526.4504)
,p_prompt=>'Limite'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Immettere il numero di elementi in un VARRAY. Specificare un numero intero maggiore del numero massimo corrente di elementi nel VARRAY.  Questa operazione non \00E8 valida per le tabelle nidificate. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16728912451387986.4504)
,p_name=>'P183_PRECISION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(16526706487586526.4504)
,p_prompt=>'Precisione'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Testo Guida non disponibile.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16729128130387986.4504)
,p_name=>'P183_SCALE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16526706487586526.4504)
,p_prompt=>'Scala'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Testo Guida non disponibile.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(16877611511376372.4504)
,p_computation_sequence=>10
,p_computation_item=>'P184_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' c varchar2(32000) := null;',
'begin',
'  c := ''create or replace type "''||:p182_NAME||''" as '';',
'  if (:P183_COLL_TYPE = ''V'') then',
'    c := c||''varray(''||:P183_LIMIT||'') of '';',
'  else ',
'    c := c||''table of '';',
'  end if;',
'',
'  if (:P183_DATA_TYPE = ''NEST'') then',
'    c:=c||:P183_OBJECT;',
'  elsif (:P183_DATA_TYPE = ''REF'') then',
'    c:=c||'' REF ''||:P183_OBJECT;',
'  elsif (:P183_DATA_TYPE in (''RAW'',''VARCHAR2'',''CHAR'')) then',
'    c:=c||:P183_DATA_TYPE||''(''||:P183_LENGTH||'')'';',
'  elsif (:P183_DATA_TYPE in (''NUMBER'',''DECIMAL'')) then',
'    c:=c||:P183_DATA_TYPE||''(''||:P183_PRECISION||'',''||:P183_SCALE||'')'';',
'  elsif (:P183_DATA_TYPE = ''FLOAT'') then',
'    c:=c||:P183_DATA_TYPE||''(''||:P183_PRECISION||'')'';',
'  else',
'    c:=c||:P183_DATA_TYPE;',
'  end if;',
'',
'  return c;',
'',
'end;'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(886494008073981516.4504)
,p_name=>'Toggle Len'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P183_COLL_TYPE'
,p_condition_element=>'P183_COLL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'V'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886494129387981517.4504)
,p_event_id=>wwv_flow_api.id(886494008073981516.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886494225016981518.4504)
,p_event_id=>wwv_flow_api.id(886494008073981516.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(886494305860981519.4504)
,p_name=>'REF & NEST Settings'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P183_DATA_TYPE'
,p_condition_element=>'P183_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REF,NEST'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886494441347981520.4504)
,p_event_id=>wwv_flow_api.id(886494305860981519.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_SCHEMA,P183_OBJECT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886495196245981527.4504)
,p_event_id=>wwv_flow_api.id(886494305860981519.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_SCHEMA,P183_OBJECT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(886494585192981521.4504)
,p_name=>'CHAR, RAW & VARCHAR settings'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P183_DATA_TYPE'
,p_condition_element=>'P183_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'CHAR,RAW,VARCHAR2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886494647463981522.4504)
,p_event_id=>wwv_flow_api.id(886494585192981521.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_LENGTH'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886495232448981528.4504)
,p_event_id=>wwv_flow_api.id(886494585192981521.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_LENGTH'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(886494750333981523.4504)
,p_name=>'DECIMAL, NUMBER settings'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P183_DATA_TYPE'
,p_condition_element=>'P183_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DECIMAL,NUMBER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886494819330981524.4504)
,p_event_id=>wwv_flow_api.id(886494750333981523.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_SCALE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886495367240981529.4504)
,p_event_id=>wwv_flow_api.id(886494750333981523.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_SCALE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(886494995549981525.4504)
,p_name=>'FLOAT settings'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P183_DATA_TYPE'
,p_condition_element=>'P183_DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FLOAT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886495028672981526.4504)
,p_event_id=>wwv_flow_api.id(886494995549981525.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_PRECISION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(886495591117981531.4504)
,p_name=>'Precision Setting'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P183_DATA_TYPE'
,p_condition_element=>'P183_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DECIMAL,NUMBER,FLOAT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886495624254981532.4504)
,p_event_id=>wwv_flow_api.id(886495591117981531.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_PRECISION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886495774285981533.4504)
,p_event_id=>wwv_flow_api.id(886495591117981531.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P183_PRECISION'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00184
begin
wwv_flow_api.create_page(
 p_id=>184.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conferma creazione del tipo'
,p_step_title=>'Conferma creazione del tipo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16836225734133828.4504)
,p_plug_name=>'Crea tipo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150830631717241944.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(150827529723222442.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(238948807152574537.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239910727641956606.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752121264238695896.4504)
,p_plug_name=>'Crea tipo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16836631431133831.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239910727641956606.4504)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea tipo'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16836807357133831.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239910727641956606.4504)
,p_button_name=>'previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:183:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16836423371133830.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239910727641956606.4504)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16839419375133846.4504)
,p_branch_action=>'f?p=&APP_ID.:185:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(16836631431133831.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16837007823133833.4504)
,p_name=>'P184_CONFIRM_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16836225734133828.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16837519561133837.4504)
,p_name=>'P184_CONFIRM_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16836225734133828.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome tipo:'
,p_source=>'P182_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'N'
,p_help_text=>'Nome del tipo da creare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16838414890133840.4504)
,p_name=>'P184_SQL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(238948807152574537.4504)
,p_prompt=>'SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16838818724133844.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :OB_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(16836631431133831.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16839030754133845.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P185_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => :OB_SCHEMA,',
'              p_sql        => :P184_SQL );',
'',
'for c in (select object_id from sys.dba_objects where object_name = :p182_name and owner = :OB_SCHEMA and',
'          object_type = ''TYPE'') loop',
'  :object_id := c.object_id;',
'  :object_type := ''TYPE'';',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16839215506133845.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P184_SQL,',
'    p_schema            => :OB_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(16836631431133831.4504)
);
end;
/
prompt --application/pages/page_00185
begin
wwv_flow_api.create_page(
 p_id=>185.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare il tipo'
,p_step_title=>'Impossibile creare il tipo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_type.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16914702569475149.4504)
,p_plug_name=>'Impossibile creare il tipo'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>21
,p_plug_source=>'&P185_MSG.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P185_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969055407164554641.4504)
,p_plug_name=>'Pulsanti procedura guidata'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16915114957475151.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(969055407164554641.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:184:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16915314850475151.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(969055407164554641.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16915715182475152.4504)
,p_name=>'P185_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16914702569475149.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182512207885240088.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'route page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for r in ( select object_id,object_name,owner,object_type',
' from sys.dba_objects',
' where owner = :OB_SCHEMA',
' and object_name = :P182_NAME',
' and object_type = ''TYPE'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P185_MSG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00186
begin
wwv_flow_api.create_page(
 p_id=>186.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea package body'
,p_step_title=>'Crea package body'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17717230846259101.4504)
,p_plug_name=>'Crea package body'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150015917010734102.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149957726913651895.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208333301908703250.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(762727956489443752.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17726310461281666.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208333301908703250.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17728503320289098.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208333301908703250.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(150021606537750072.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208333301908703250.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17727320850284602.4504)
,p_branch_action=>'javascript:ob_Reset();'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17726310461281666.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'Created 07-FEB-2005 14:51 by KRIS.RICE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17736831370297134.4504)
,p_branch_action=>'f?p=&APP_ID.:187:&SESSION.::&DEBUG.:187::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17728503320289098.4504)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'Created 07-FEB-2005 14:54 by KRIS.RICE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(150021823700750074.4504)
,p_branch_action=>'f?p=&APP_ID.:117:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(150021606537750072.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17721803057270069.4504)
,p_name=>'P186_PACKAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17717230846259101.4504)
,p_prompt=>'Package'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(object_name) a , object_id b from sys.dba_objects ',
'where owner = :OB_SCHEMA',
'and   object_type = ''PACKAGE''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Specifica un package -'
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Indicare la specifica di package per la quale creare il package body.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(267489612843445397.4504)
,p_validation_name=>'P186_PACKAGE'
,p_validation_sequence=>10
,p_validation=>'P186_PACKAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare il package'
,p_when_button_pressed=>wwv_flow_api.id(17728503320289098.4504)
,p_associated_item=>wwv_flow_api.id(17721803057270069.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00187
begin
wwv_flow_api.create_page(
 p_id=>187.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea package body'
,p_step_title=>'Crea package'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_pack.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17731404031294302.4504)
,p_plug_name=>'Crea package body'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_footer=>'</td></tr></table>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150016319434734851.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149957726913651895.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208335201346712560.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(762728385967450753.4504)
,p_plug_name=>'Crea package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17731808857294308.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208335201346712560.4504)
,p_button_name=>'finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea package body'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17732028006294308.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208335201346712560.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:186:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17731631760294305.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208335201346712560.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17734519133294321.4504)
,p_branch_action=>'132'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(17731808857294308.4504)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17732221203294309.4504)
,p_name=>'P187_SCHEMA'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(17731404031294302.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17732700943294312.4504)
,p_name=>'P187_TYPE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(17731404031294302.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo di oggetto:'
,p_source=>'initcap(wwv_Flow_lang.system_message(''PACKAGE_BODY''))'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Tipo di oggetto da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17733413717294315.4504)
,p_name=>'P187_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17731404031294302.4504)
,p_prompt=>'Corpo'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>32767
,p_cHeight=>30
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Testo SQL per la specifica del package da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DDL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17939314774919895.4504)
,p_computation_sequence=>10
,p_computation_item=>'P132_PREVIOUS'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&APP_PAGE_ID.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17733913484294318.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :OB_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(17731808857294308.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17734130746294320.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P132_MSG := wwv_flow_sw_util.run_other_sql(',
'             p_schema     => :OB_SCHEMA,',
'             p_sql        => :P187_SQL );',
'',
'',
'',
'for c in (select object_id,',
'                 owner,',
'                 object_type,',
'                 object_name',
'           from sys.dba_objects ',
'           where object_name = (SELECT OBJECT_NAME FROM sys.DBA_OBJECTS WHERE OBJECT_ID = :P186_PACKAGE)',
'           and   owner = :OB_SCHEMA',
'           and   object_type = ''PACKAGE'') loop',
'  :object_id    := c.object_id;',
'  :object_owner := c.owner;',
'  :object_name  := c.object_name;',
'  :object_type  := c.object_type;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(17731808857294308.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17734312692294320.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P187_SQL,',
'    p_schema            => :P118_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(17731808857294308.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17770626456466056.4504)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load New Body'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_type     varchar2(300);',
'  l_params   varchar2(32767);',
'  l_has_args boolean;',
'  l_name     varchar2(2000);',
'  l_owner    varchar2(2000);',
'  l_datatype varchar2(2000);',
'  l_ret      varchar2(32767);',
'  i          number;',
'begin',
'   for r in ',
'      ( select object_name,owner ',
'          from sys.dba_objects ',
'         where object_id = :P186_PACKAGE ) loop',
'      l_name := r.object_name;',
'      l_owner := r.owner;',
'   end loop;',
'',
'   l_ret := l_ret || ''create or replace package body "''||l_name||''" is''||chr(10);',
'',
'   for r in ',
'      ( select distinct object_name,overload ',
'          from sys.dba_ARGUMENTS',
'         where owner = l_owner',
'           and package_name = l_name ) loop',
'',
'      l_params := null;',
'      l_type := ''procedure'';',
'      i := 0;',
'      l_has_args := false;',
'',
'      for r1 in ',
'         ( select * ',
'             from sys.dba_ARGUMENTS',
'            where owner        = l_owner',
'              and package_name = l_name',
'              and ( overload   = r.overload or',
'                    (overload is null and r.overload is null) ) ',
'              and object_name  = r.object_name',
'            order by object_name, argument_name, position ) loop',
'',
'         i := i+1; /* arg count */',
'         l_datatype := case when r1.type_name is not null then',
'                            case when r1.type_owner <> ''PUBLIC'' then r1.type_owner||''.'' end ||',
'                                      r1.type_name||''.''||r1.type_subname                         ',
'                            else r1.pls_type end;',
'                ',
'        if ( r1.argument_name is null and r1.in_out = ''OUT'' ) then',
'          l_type := ''function'';',
'          l_params := l_params||case when i>1 then '')'' end || '' return ''||l_datatype|| chr(10);',
'        end if;   ',
'        ',
'        if ( i > 1 AND r1.argument_name is not null ) then ',
'          l_params := l_params||''      ,''||r1.argument_name ||'' ''||',
'                      replace(r1.in_out,''/'','' '')||'' ''||l_datatype|| chr(10);',
'          l_has_args:= true;',
'          elsif ( r1.argument_name is not null ) then',
'              l_params := l_params||''       ''||r1.argument_name||'' ''||',
'                          replace(r1.in_out,''/'','' '')||'' ''||l_datatype|| chr(10);',
'              l_has_args := true;',
'        end if;',
'      end loop;/* end argument loop */',
'            ',
'      l_ret := l_ret || l_type||'' ''||r.object_name||',
'               case when (l_has_args and l_type = ''procedure'') or ',
'                         (l_has_args and l_type = ''function'') then ''('' end;',
'      l_ret := l_ret || l_params||case when l_type = ''procedure'' and l_has_args ',
'                                  then '')'' end||chr(10);',
'      l_ret := l_ret || ''as''||chr(10);',
'      l_ret := l_ret || ''begin''||chr(10);',
'      l_ret := l_ret || '' null; /* insert ''||l_type||'' code */''||chr(10);',
'      l_ret := l_ret || ''end ''||r.object_name||'';''||chr(10);',
'      l_ret := l_ret || ''''||chr(10);',
'',
'   end loop;/* end main loop */',
'',
'   l_ret := l_ret || ''end "''||l_name||''";''||chr(10);',
'   l_ret := l_ret || ''/'';',
'',
'   :P187_SQL := l_ret;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P187_SQL'
,p_process_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_00200
begin
wwv_flow_api.create_page(
 p_id=>200.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Gestisci dati di esempio'
,p_step_title=>'Gestisci dati di esempio'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164012970789368906.4504)
,p_plug_name=>'Data set di esempio'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>I data set di esempio consentono di creare, aggiornare o rimuovere set di oggetti di database utili a scopo di dimostrazione.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(165488781375201416.4504)
,p_plug_name=>'Data set di esempio'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>11
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
', name',
', description',
', last_refresh_date',
', table_prefix',
'from wwv_sample_datasets d'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(165488893053201416.4504)
,p_name=>'Schema Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>165488893053201416
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164012436342368901.4504)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164012577251368902.4504)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'Data set'
,p_column_link=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:RP,201:P201_DATASET_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164012694267368903.4504)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'Descrizione'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164012857803368905.4504)
,p_db_column_name=>'TABLE_PREFIX'
,p_display_order=>50
,p_column_identifier=>'R'
,p_column_label=>'Prefisso tabella'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164012778081368904.4504)
,p_db_column_name=>'LAST_REFRESH_DATE'
,p_display_order=>60
,p_column_identifier=>'Q'
,p_column_label=>'Ultimo aggiornamento data set'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'DD-MON-YYYY'
,p_tz_dependent=>'Y'
);
end;
/
prompt --application/pages/page_00201
begin
wwv_flow_api.create_page(
 p_id=>201.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Gestisci data set'
,p_step_title=>'Gestisci data set'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164013012634368907.4504)
,p_plug_name=>'Dettagli data set'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(328044736026804566.4504)
,p_plug_name=>'Data set di esempio'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>I data set di esempio consentono di creare, aggiornare o rimuovere set di oggetti di database utili a scopo di dimostrazione.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(329520546612637076.4504)
,p_plug_name=>'Gestisci data set'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
', name',
', description',
', last_refresh_date',
', table_prefix',
'from wwv_sample_datasets d'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(329520658290637076.4504)
,p_name=>'Schema Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>329520658290637076
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164032467678435683.4504)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164032889377435686.4504)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'Data set'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164033268322435686.4504)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'Descrizione'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164034024956435687.4504)
,p_db_column_name=>'TABLE_PREFIX'
,p_display_order=>50
,p_column_identifier=>'R'
,p_column_label=>'Prefisso tabella'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(164033673818435686.4504)
,p_db_column_name=>'LAST_REFRESH_DATE'
,p_display_order=>60
,p_column_identifier=>'Q'
,p_column_label=>'Data ultimo aggiornamento'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'DD-MON-YYYY'
,p_tz_dependent=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164014183687368918.4504)
,p_name=>'P201_DATASET_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(164013012634368907.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164014249133368919.4504)
,p_name=>'P201_WS_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(164013012634368907.4504)
,p_prompt=>'Ultimo aggiornamento area di lavoro'
,p_format_mask=>'DD-MON-YYYY HH24:MI'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164014367738368920.4504)
,p_name=>'P201_SCHEMA'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(164013012634368907.4504)
,p_prompt=>'Installato nello schema'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164014559321368922.4504)
,p_name=>'P201_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(164013012634368907.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data set'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164014660950368923.4504)
,p_name=>'P201_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(164013012634368907.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Descrizione'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164014779365368924.4504)
,p_name=>'P201_TABLE_PREFIX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(164013012634368907.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Prefisso tabella'
,p_source=>'TABLE_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164014862083368925.4504)
,p_name=>'P201_LAST_REFRESH_DATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(164013012634368907.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ultimo aggiornamento data set'
,p_format_mask=>'DD-MON-YYYY'
,p_source=>'LAST_REFRESH_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164014488800368921.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch WWV_SAMPLE_DATASETS'
,p_attribute_02=>'WWV_SAMPLE_DATASETS'
,p_attribute_03=>'P201_DATASET_ID'
,p_attribute_04=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00220
begin
wwv_flow_api.create_page(
 p_id=>220.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice spaziale'
,p_alias=>'SPATIAL-INDEX-1'
,p_step_title=>'Crea indice spaziale'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(414430374768040869.4504)
,p_plug_name=>'Crea indice spaziale'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1665017817963734.4504)
,p_name=>'Registro Spatial'
,p_parent_plug_id=>wwv_flow_api.id(414430374768040869.4504)
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name,',
'       c.srid,',
'       w.cs_name ',
'  from mdsys.user_sdo_geom_metadata c, mdsys.cs_srs w',
'where c.srid = w.srid',
'  and c.table_name  = :P220_TABLE',
'  and c.column_name = :P220_COL1',
'  '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P220_TABLE,P220_COL1,P220_SCHEMA'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Colonna &P220_COL1!HTML. non trovata nel registro Spatial.'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OB_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1665282791963736.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Colonna'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:222:&SESSION.::&DEBUG.::P222_COLUMN_NAME,P222_TABLE,P222_EDIT,P222_SCHEMA:#COLUMN_NAME#,&P220_TABLE.,YES,&P220_SCHEMA.'
,p_column_linktext=>'#COLUMN_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1665619571963740.4504)
,p_query_column_id=>2
,p_column_alias=>'SRID'
,p_column_display_sequence=>30
,p_column_heading=>'ID sistema di coordinate'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1665992926963743.4504)
,p_query_column_id=>3
,p_column_alias=>'CS_NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Nome sistema di coordinate'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1666466942963748.4504)
,p_plug_name=>'Tabella e colonne'
,p_parent_plug_id=>wwv_flow_api.id(414430374768040869.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(414429680091040868.4504)
,p_name=>'Indici esistenti'
,p_parent_plug_id=>wwv_flow_api.id(414430374768040869.4504)
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.index_name,',
'       c.column_name,',
'       i.ITYP_NAME',
'  from sys.dba_ind_columns c, sys.dba_indexes i',
'where c.table_name  = i.table_name',
'  and c.table_owner = i.table_owner',
'  and c.table_name  = :P220_TABLE',
'  and c.table_owner = :OB_SCHEMA',
'  and i.ityp_name   in (''SPATIAL_INDEX'', ''SPATIAL_INDEX_V2'')',
'  and i.ityp_owner  = ''MDSYS''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'La tabella non contiene indici spaziali.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2101092495240824.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome indice'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2101412197240834.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2231099501834418.4504)
,p_query_column_id=>3
,p_column_alias=>'ITYP_NAME'
,p_column_display_sequence=>12
,p_column_heading=>'Tipo indice'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2231384316834421.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(414430374768040869.4504)
,p_button_name=>'REGISTER_COLUMN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Registra colonna'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2103311425240841.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(414430374768040869.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2103753133240856.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(414430374768040869.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2104135892240857.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(414430374768040869.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2231455990834422.4504)
,p_branch_name=>'Go To Page 222'
,p_branch_action=>'f?p=&APP_ID.:222:&SESSION.::&DEBUG.::P222_TABLE,P222_COLUMN_NAME,P222_EDIT:&P220_TABLE.,&P220_COL1.,NO&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2231384316834421.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2114436033240926.4504)
,p_branch_name=>'Go To Page 221'
,p_branch_action=>'f?p=&APP_ID.:221:&SESSION.::&DEBUG.::P221_ACTION,P221_TABLE:CREATE_INDEX,&P220_INDEX_NAME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2103311425240841.4504)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104546588240857.4504)
,p_name=>'P220_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_prompt=>'Schema:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica il nome dello schema di database in cui verr\00E0 creato l''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2105450681240875.4504)
,p_name=>'P220_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_prompt=>'Tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nome della tabella su cui si baser\00E0 la creazione dell''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2106397564240875.4504)
,p_name=>'P220_INDEX_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_item_default=>'&P220_TABLE._SX'
,p_prompt=>'Nome indice'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Immettere il nome dell''indice da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2107267582240875.4504)
,p_name=>'P220_PRESERVE_CASE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_item_default=>'N'
,p_prompt=>'Conserva maiuscole/minuscole'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indica se generare un nome indice con distinzione tra maiuscole e minuscole.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2107661249240876.4504)
,p_name=>'P220_COL1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_prompt=>'Colonna  indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'  from sys.dba_tab_columns',
' where owner      = :OB_SCHEMA ',
'   and table_name = :P220_TABLE',
'   and data_type  = ''SDO_GEOMETRY''',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la prima colonna da utilizzare nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2233327041834441.4504)
,p_name=>'P220_MSG'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2234233790834450.4504)
,p_name=>'P220_COLUMN_HAS_METADATA'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4140427325496015.4504)
,p_name=>'P220_USE_V2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_item_default=>'Y'
,p_prompt=>'Indice gestito dal sistema'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'sys.dbms_db_version.version > 12 or ( sys.dbms_db_version.version = 12 and sys.dbms_db_version.release = 2 ) '
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Specificare se usare un indice spaziale <em>gestito dal sistema</em>, che \00E8 un''operazione consigliata. Se abilitata, APEX crea un indice spaziale di tipo <strong>MDSYS.SPATIAL_INDEX_V2</strong>. Se disabilitata, verr\00E0 usato l''indice <strong>MDSYS.SPA')
||'TIAL_INDEX</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4140586870496016.4504)
,p_name=>'P220_POINTS_ONLY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(1666466942963748.4504)
,p_item_default=>'N'
,p_prompt=>'La tabella contiene solo oggetti punto'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Abilitare questa opzione se la tabella contiene <em>solo</em> oggetti geometria di punti in modo da ottenere una struttura di indici pi\00F9 efficiente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2111778448240920.4504)
,p_computation_sequence=>10
,p_computation_item=>'P220_INDEX_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P220_INDEX_NAME,chr(32),''_''))'
,p_compute_when=>'P220_PRESERVE_CASE'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4141466150496025.4504)
,p_computation_sequence=>10
,p_computation_item=>'P220_TABLE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P95_TABLE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1205604839248108.4504)
,p_computation_sequence=>20
,p_computation_item=>'P220_SCHEMA'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'nvl( :OBJECT_OWNER, :OB_SCHEMA )'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2112406844240922.4504)
,p_validation_name=>'P220_INDEX_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P220_INDEX_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome indice.'
,p_when_button_pressed=>wwv_flow_api.id(2103311425240841.4504)
,p_associated_item=>wwv_flow_api.id(2106397564240875.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2112892479240924.4504)
,p_validation_name=>'P220_COL1 Not Null'
,p_validation_sequence=>20
,p_validation=>'P220_COL1'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Colonna 1 indice.'
,p_validation_condition=>'NEXT:REGISTER_COLUMN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(2107661249240876.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2113283034240924.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P220_INDEX_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato dell''indice \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2113698040240925.4504)
,p_validation_name=>'available name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_util.is_available_name2(',
'p_name => :P220_INDEX_NAME,                                          p_owner=> :OB_SCHEMA,',
'p_type => ''INDEX''',
') then',
'  return',
'wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P220_INDEX_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_when_button_pressed=>wwv_flow_api.id(2103311425240841.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2114073499240925.4504)
,p_validation_name=>'valid index column type'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_return boolean;',
'begin',
'  for c1 in (select data_type',
'             from sys.dba_tab_columns',
'             where owner =  :OB_SCHEMA ',
'              and table_name= :P220_TABLE',
'              and column_name = :P220_COL1) loop',
'    if c1.data_type != ''SDO_GEOMETRY'' then',
'      return false;',
'    end if;',
'  end loop;',
'return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il tipo di dati di colonna selezionato non pu\00F2 essere utilizzato per l''indice spaziale.')
,p_when_button_pressed=>wwv_flow_api.id(2103311425240841.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2231122161834419.4504)
,p_validation_name=>'Has Spatial Metadata'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.get_geom_metadata(',
'    p_owner        => :OB_SCHEMA,',
'    p_table_name   => :P220_TABLE,',
'    p_column_name  => :P220_COL1 ) is not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Colonna &P220_COL1!HTML. assente nel registro Spatial.'
,p_validation_condition=>':P220_COLUMN_TYPE = ''GEOMETRY'' and :P220_COL1 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2103311425240841.4504)
,p_associated_item=>wwv_flow_api.id(2107661249240876.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1206062071248112.4504)
,p_validation_name=>'Table contains only points'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.validate_gtype(',
'    p_table_name     => :P220_TABLE,',
'    p_owner          => :OB_SCHEMA,',
'    p_column_name    => :P220_COL1,',
'    p_gtype          => 2001 )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La tabella contiene oggetti geometria che non sono punti. Esaminare l''attributo SDO_GEOMETRY.SDO_GTYPE.'
,p_validation_condition=>'P220_POINTS_ONLY'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2103311425240841.4504)
,p_associated_item=>wwv_flow_api.id(4140586870496016.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1666176229963745.4504)
,p_name=>'Geometry'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P220_COLUMN_TYPE'
,p_condition_element=>'P220_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOMETRY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1666270719963746.4504)
,p_event_id=>wwv_flow_api.id(1666176229963745.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P220_FB_COL1,P220_FB_COL2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4140311145496014.4504)
,p_event_id=>wwv_flow_api.id(1666176229963745.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P220_COL1'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1666371758963747.4504)
,p_event_id=>wwv_flow_api.id(1666176229963745.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P220_FB_COL1,P220_FB_COL2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4140285793496013.4504)
,p_event_id=>wwv_flow_api.id(1666176229963745.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P220_COL1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4139058840496001.4504)
,p_name=>'Check Metadata'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P220_COL1'
,p_condition_element=>'P220_COL1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206227926248114.4504)
,p_event_id=>wwv_flow_api.id(4139058840496001.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P220_USE_V2,P220_POINTS_ONLY,P220_PRESERVE_CASE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4139177467496002.4504)
,p_event_id=>wwv_flow_api.id(4139058840496001.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P220_COLUMN_HAS_METADATA'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_sw_util.get_geom_metadata(',
'    p_owner        => :OB_SCHEMA,',
'    p_table_name   => :P220_TABLE,',
'    p_column_name  => :P220_COL1 ) from sys.dual'))
,p_attribute_07=>'P220_TABLE,P220_COL1'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4141564482496026.4504)
,p_event_id=>wwv_flow_api.id(4139058840496001.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1665017817963734.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4141636409496027.4504)
,p_event_id=>wwv_flow_api.id(4139058840496001.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1665017817963734.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4139856124496009.4504)
,p_event_id=>wwv_flow_api.id(4139058840496001.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1665017817963734.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4142852346496039.4504)
,p_event_id=>wwv_flow_api.id(4139058840496001.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2231384316834421.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206127692248113.4504)
,p_event_id=>wwv_flow_api.id(4139058840496001.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P220_USE_V2,P220_POINTS_ONLY,P220_PRESERVE_CASE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4142998983496040.4504)
,p_event_id=>wwv_flow_api.id(4139058840496001.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2103311425240841.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4139206783496003.4504)
,p_name=>'Show / Hide button'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P220_COLUMN_HAS_METADATA'
,p_condition_element=>'P220_COLUMN_HAS_METADATA'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4139367536496004.4504)
,p_event_id=>wwv_flow_api.id(4139206783496003.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2231384316834421.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4139734953496008.4504)
,p_event_id=>wwv_flow_api.id(4139206783496003.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2103311425240841.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4139585597496006.4504)
,p_event_id=>wwv_flow_api.id(4139206783496003.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2103311425240841.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4139610050496007.4504)
,p_event_id=>wwv_flow_api.id(4139206783496003.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2231384316834421.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2231297520834420.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate Create Index DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P221_SQL:= wwv_flow_sw_util.get_index_ddl(',
'         p_table_name => :P220_TABLE,',
'         p_index_name => :P220_INDEX_NAME,',
'         p_action     => ''create'',',
'         p_unique     => null,',
'         p_col1       => :P220_COL1,',
'         p_col2       => null,',
'         p_col3       => null,',
'         p_col4       => null,',
'         p_indextype  => ''mdsys.spatial_index'' || case when :P220_USE_V2 = ''Y'' then ''_v2'' end,',
'         p_parameters => case when :P220_POINTS_ONLY = ''Y'' then ''layer_gtype=point'' end );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00221
begin
wwv_flow_api.create_page(
 p_id=>221.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice spaziale'
,p_alias=>'SPATIAL-INDEX-2'
,p_step_title=>'Crea indice spaziale'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415680391819795683.4504)
,p_plug_name=>'Confermare la richiesta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415683088578795687.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415683482525795688.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149926526903576167.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(23328315128356826.4504)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'F4500_LAST_VIEW'
,p_plug_display_when_cond2=>'2102'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3601526565016610.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(415680391819795683.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea indice'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3601944162016610.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(415680391819795683.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:220:&SESSION.::&DEBUG.:221::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3602363516016611.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(415680391819795683.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3608818463016645.4504)
,p_branch_action=>'f?p=&APP_ID.:128:&SESSION.::&DEBUG.::P128_OBJECT_ID:&P221_NEW_OBJECT_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3601526565016610.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3602753413016614.4504)
,p_name=>'P221_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(415680391819795683.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3603560466016619.4504)
,p_name=>'P221_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(415680391819795683.4504)
,p_prompt=>'Oggetto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3604470555016620.4504)
,p_name=>'P221_ACTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(415680391819795683.4504)
,p_prompt=>'Azione:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il tipo di azione da eseguire sulla tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3605782645016620.4504)
,p_name=>'P221_NEW_OBJECT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(415680391819795683.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3606456269016622.4504)
,p_name=>'P221_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(415683088578795687.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3607502692016640.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(3601526565016610.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3607965816016644.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P128_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P221_SQL );',
'if :p221_PREVIOUS = ''130'' then',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :p130_index_name ',
'          and owner = :OB_SCHEMA ',
'          and object_type = ''INDEX'') loop',
'  :P221_NEW_OBJECT_ID := c.object_id;',
'end loop;',
'else',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :p106_index_name ',
'          and owner = :OB_SCHEMA ',
'          and object_type = ''INDEX'') loop',
'  :P221_NEW_OBJECT_ID := c.object_id;',
'end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(3601526565016610.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3608372428016644.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P221_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(3601526565016610.4504)
);
end;
/
prompt --application/pages/page_00222
begin
wwv_flow_api.create_page(
 p_id=>222.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Metadati spaziali'
,p_alias=>'SPATIAL-METADATA-1'
,p_step_title=>'Metadati spaziali'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(418330911526128753.4504)
,p_plug_name=>'Metadati spaziali'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5567003701051632.4504)
,p_plug_name=>'Registra colonna'
,p_parent_plug_id=>wwv_flow_api.id(418330911526128753.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2232261040834430.4504)
,p_plug_name=>'Dimensioni'
,p_parent_plug_id=>wwv_flow_api.id(5567003701051632.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3901174089087909.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(418330911526128753.4504)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aggiungi metadati spaziali'
,p_button_position=>'NEXT'
,p_button_condition=>'P222_EDIT'
,p_button_condition2=>'NO'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2233902616834447.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(418330911526128753.4504)
,p_button_name=>'REPLACE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sostituisci metadati spaziali'
,p_button_position=>'NEXT'
,p_button_condition=>'P222_EDIT'
,p_button_condition2=>'YES'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3901541178087909.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(418330911526128753.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:220:&SESSION.::&DEBUG.:222::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3901986726087910.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(418330911526128753.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3919059359087954.4504)
,p_branch_name=>'Go To Page 223'
,p_branch_action=>'f?p=&APP_ID.:223:&SESSION.::&DEBUG.::P223_ACTION,P223_TABLE,P223_COLUMN_NAME:INSERT_GEOM_METADATA,&P222_TABLE.,&P222_COLUMN_NAME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3901174089087909.4504)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4140079927496011.4504)
,p_branch_name=>'Go To Page 223'
,p_branch_action=>'f?p=&APP_ID.:223:&SESSION.::&DEBUG.::P223_ACTION,P223_TABLE,P223_COLUMN_NAME:REPLACE_GEOM_METADATA,&P222_TABLE.,&P222_COLUMN_NAME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2233902616834447.4504)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1204929199248101.4504)
,p_name=>'P222_DIMX_TOL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2232261040834430.4504)
,p_prompt=>'Tolleranza spaziale'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<em>Tolleranza</em> spaziale da usare per l''asse X. Se due punti sono pi\00F9 vicini l''uno all''altro rispetto alla tolleranza specificata, Oracle Spatial li considera come se fossero lo stesso punto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1205016794248102.4504)
,p_name=>'P222_DIM_X_HDR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2232261040834430.4504)
,p_prompt=>'Dimensione'
,p_source=>'X'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>1
,p_grid_column=>3
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1205188090248103.4504)
,p_name=>'P222_DIM_Y_HDR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2232261040834430.4504)
,p_prompt=>'Dimensione'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>1
,p_grid_column=>3
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2231510169834423.4504)
,p_name=>'P222_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5567003701051632.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'  from sys.dba_tab_columns',
'where owner      = :OB_SCHEMA ',
'  and table_name = :P222_TABLE',
'  and data_type  = ''SDO_GEOMETRY''',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della colona geometria.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2231698984834424.4504)
,p_name=>'P222_SRID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5567003701051632.4504)
,p_prompt=>'Sistema di coordinate'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select srid ||'': '' || cs_name as d,',
'       srid as r',
'  from mdsys.cs_srs ',
' where wktext is not null',
' order by srid'))
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Sistema di coordinate degli oggetti geometria nella tabella spaziale (<em>ID sistema di riferimento spaziale</em>.',
'</p>',
'<p>Se i dati sono composti da longitudine e latitudine, usare <strong>4326 (WGS 84)</strong></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Coordinate System (SRID)'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2231829508834426.4504)
,p_name=>'P222_CS_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(5567003701051632.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2232117715834429.4504)
,p_name=>'P222_DIMX_MIN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2232261040834430.4504)
,p_prompt=>'Minimo'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Limite del valore minimo dell''asse X degli oggetti spaziali nella tabella. Per i sistemi di coordinate latitudine/longitudine, in genere il valore \00E8 -180.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2232378411834431.4504)
,p_name=>'P222_DIMX_MAX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2232261040834430.4504)
,p_prompt=>'Massimo:'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Limite del valore massimo dell''asse X degli oggetti spaziali nella tabella. Per i sistemi di coordinate latitudine/longitudine, in genere il valore \00E8 180.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2232443112834432.4504)
,p_name=>'P222_DIMY_MIN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2232261040834430.4504)
,p_prompt=>'Minimo'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Limite del valore minimo dell''asse Y degli oggetti spaziali nella tabella. Per i sistemi di coordinate latitudine/longitudine, in genere il valore \00E8 -90.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2232537398834433.4504)
,p_name=>'P222_DIMY_MAX'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2232261040834430.4504)
,p_prompt=>'Massimo'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Limite del valore massimo dell''asse Y degli oggetti spaziali nella tabella. Per i sistemi di coordinate latitudine/longitudine, in genere il valore \00E8 90.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2232964428834437.4504)
,p_name=>'P222_DIMY_TOL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2232261040834430.4504)
,p_prompt=>'Tolleranza spaziale'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<em>Tolleranza</em> spaziale da usare per l''asse Y. Se due punti sono pi\00F9 vicini l''uno all''altro rispetto alla tolleranza specificata, Oracle Spatial li considera come se fossero lo stesso punto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2233612517834444.4504)
,p_name=>'P222_EDIT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(5567003701051632.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3905987779087920.4504)
,p_name=>'P222_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5567003701051632.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica il nome dello schema di database della tabella spaziale.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3906874853087932.4504)
,p_name=>'P222_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5567003701051632.4504)
,p_prompt=>'Tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1205730981248109.4504)
,p_validation_name=>'SRID matches Table Geometries'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.validate_srid(',
'    p_table_name     => :P222_TABLE,',
'    p_owner          => :OB_SCHEMA,',
'    p_column_name    => :P222_COLUMN_NAME,',
'    p_srid           => :P222_SRID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La tabella contiene oggetti geometria con un ID sistema di coordinate diverso. Esaminare l''attributo SDO_GEOMETRY.SDO_SRID.'
,p_validation_condition=>'ADD:REPLACE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(2231698984834424.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3917577902087951.4504)
,p_name=>'Geometry'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P222_COLUMN_TYPE'
,p_condition_element=>'P222_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOMETRY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3918077898087953.4504)
,p_event_id=>wwv_flow_api.id(3917577902087951.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P222_COL2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3918538708087954.4504)
,p_event_id=>wwv_flow_api.id(3917577902087951.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P222_COL2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2231900186834427.4504)
,p_name=>'Get CS type'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P222_SRID'
,p_condition_element=>'P222_SRID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2232016960834428.4504)
,p_event_id=>wwv_flow_api.id(2231900186834427.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P222_CS_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr( wktext, 1, 6 )',
'  from mdsys.cs_srs',
' where srid = :P222_SRID'))
,p_attribute_07=>'P222_SRID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2232685817834434.4504)
,p_name=>'Set Defaults'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P222_CS_TYPE'
,p_condition_element=>'P222_CS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOGCS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2232745088834435.4504)
,p_event_id=>wwv_flow_api.id(2232685817834434.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s("P222_DIMX_MIN", -180 );',
'$s("P222_DIMX_MAX",  180 );',
'$s("P222_DIMY_MIN",  -90 );',
'$s("P222_DIMY_MAX",   90 );',
'$s("P222_DIMX_TOL",    1 );',
'$s("P222_DIMY_TOL",    1 );',
''))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2232839620834436.4504)
,p_event_id=>wwv_flow_api.id(2232685817834434.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s("P222_DIMX_MIN",         0 );',
'$s("P222_DIMX_MAX",  10000000 );',
'$s("P222_DIMY_MIN",         0 );',
'$s("P222_DIMY_MAX",  10000000 );',
'$s("P222_DIMX_TOL",       0.5 );',
'$s("P222_DIMY_TOL",       0.5 );'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3917136172087951.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate Spatial Metadata DML'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P223_SQL:= wwv_flow_sw_util.get_add_geom_metadata_dml(',
'                p_table_name    => :P222_TABLE,',
'                p_column_name   => :P222_COLUMN_NAME,',
'                p_action        => case when :P222_EDIT = ''YES'' then ''recreate'' else ''create'' end,',
'                p_srid          => :P222_SRID,',
'                p_dim_x_min     => :P222_DIMX_MIN,',
'                p_dim_x_max     => :P222_DIMX_MAX,',
'                p_dim_y_min     => :P222_DIMY_MIN,',
'                p_dim_y_max     => :P222_DIMY_MAX,',
'                p_dim_x_tol     => :P222_DIMX_TOL,',
'                p_dim_y_tol     => :P222_DIMY_TOL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'ADD,REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2233884077834446.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Metadata'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_metadata wwv_flow_t_varchar2 := wwv_flow_t_varchar2();',
'begin',
'    case when :P222_EDIT = ''YES'' then ',
'        l_metadata := wwv_flow_string.split(',
'                        wwv_flow_sw_util.get_geom_metadata(',
'                            p_owner         => :OB_SCHEMA,',
'                            p_table_name    => :P222_TABLE,',
'                            p_column_name   => :P222_COLUMN_NAME ), '':'' );',
'',
'        if l_metadata.count = 7 then',
'            :P222_SRID := l_metadata( 1 );',
'            :P222_DIMX_MIN := l_metadata( 2 );',
'            :P222_DIMX_MAX := l_metadata( 3 );',
'            :P222_DIMX_TOL := l_metadata( 4 );',
'            :P222_DIMY_MIN := l_metadata( 5 );',
'            :P222_DIMY_MAX := l_metadata( 6 );',
'            :P222_DIMY_TOL := l_metadata( 7 );',
'        end if;',
'    else',
'        :P222_SRID := ''4326'';',
'        :P222_DIMX_MIN := ''-180'';',
'        :P222_DIMX_MAX := ''180'';',
'        :P222_DIMX_TOL := 0.05;',
'        :P222_DIMY_MIN := ''-90'';',
'        :P222_DIMY_MAX := ''90'';',
'        :P222_DIMY_TOL := 0.05;',
'    end case;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00223
begin
wwv_flow_api.create_page(
 p_id=>223.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Metadati spaziali'
,p_alias=>'SPATIAL-METADATA-2'
,p_step_title=>'Metadati spaziali'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416190266106022820.4504)
,p_plug_name=>'Confermare la richiesta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416192962865022824.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416193356812022825.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149926526903576167.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(23328315128356826.4504)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'F4500_LAST_VIEW'
,p_plug_display_when_cond2=>'2102'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4111407303243742.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(416190266106022820.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esegui'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4111811138243742.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(416190266106022820.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:222:&SESSION.::&DEBUG.:223::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4112230127243743.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(416190266106022820.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4118810789243762.4504)
,p_branch_name=>'Go To Page 220'
,p_branch_action=>'f?p=&APP_ID.:220:&SESSION.::&DEBUG.:222,223::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4111407303243742.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2233181126834439.4504)
,p_name=>'P223_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416190266106022820.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2233274572834440.4504)
,p_name=>'P223_ACTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416190266106022820.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4113588129243748.4504)
,p_name=>'P223_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416190266106022820.4504)
,p_prompt=>'Oggetto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4116408837243751.4504)
,p_name=>'P223_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416192962865022824.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4117570441243760.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(4111407303243742.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4117908573243761.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P220_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P223_SQL );',
''))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(4111407303243742.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4118361380243761.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P223_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(4111407303243742.4504)
);
end;
/
prompt --application/pages/page_00224
begin
wwv_flow_api.create_page(
 p_id=>224.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice spaziale'
,p_alias=>'SPATIAL-INDEX-WIZARD-1'
,p_step_title=>'Crea indice spaziale'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4141779562496028.4504)
,p_plug_name=>'Progress Indicator'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(4555880609113142.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4141959781496030.4504)
,p_plug_name=>'Crea indice spaziale'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142007237496031.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(418945465855109809.4504)
,p_plug_name=>'Crea indice spaziale'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(6180108905032674.4504)
,p_name=>'Registro Spatial'
,p_parent_plug_id=>wwv_flow_api.id(418945465855109809.4504)
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name,',
'       c.srid,',
'       w.cs_name ',
'  from mdsys.user_sdo_geom_metadata c, mdsys.cs_srs w',
'where c.srid = w.srid',
'  and c.table_name  = :P224_TABLE',
'  and c.column_name = :P224_COL1',
'  '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P224_TABLE,P224_COL1,P224_SCHEMA'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Colonna &P224_COL1!HTML. non trovata nel registro Spatial.'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OB_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4519093935068964.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Colonna'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.::P226_COLUMN_NAME,P226_TABLE,P226_EDIT,P226_SCHEMA:#COLUMN_NAME#,&P224_TABLE.,YES,&P224_SCHEMA.'
,p_column_linktext=>'#COLUMN_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4519498522068964.4504)
,p_query_column_id=>2
,p_column_alias=>'SRID'
,p_column_display_sequence=>30
,p_column_heading=>'ID sistema di coordinate'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4519863522068964.4504)
,p_query_column_id=>3
,p_column_alias=>'CS_NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Nome sistema di coordinate'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6181558030032688.4504)
,p_plug_name=>'Tabella e colonne'
,p_parent_plug_id=>wwv_flow_api.id(418945465855109809.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(418944771178109808.4504)
,p_name=>'Indici esistenti'
,p_parent_plug_id=>wwv_flow_api.id(418945465855109809.4504)
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.index_name,',
'       c.column_name,',
'       i.ITYP_NAME',
'  from sys.dba_ind_columns c, sys.dba_indexes i',
'where c.table_name  = i.table_name',
'  and c.table_owner = i.table_owner',
'  and c.table_name  = :P224_TABLE',
'  and c.table_owner = :OB_SCHEMA',
'  and i.ityp_name   in (''SPATIAL_INDEX'', ''SPATIAL_INDEX_V2'')',
'  and i.ityp_owner  = ''MDSYS''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'La tabella non contiene indici spaziali.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4517545641068959.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome indice'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4517935253068962.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4518354313068962.4504)
,p_query_column_id=>3
,p_column_alias=>'ITYP_NAME'
,p_column_display_sequence=>12
,p_column_heading=>'Tipo indice'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4516868225068955.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(4142007237496031.4504)
,p_button_name=>'REGISTER_COLUMN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Registra colonna'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4515696434068953.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(4142007237496031.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4516092647068954.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4142007237496031.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4516455469068955.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4142007237496031.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4538956634068993.4504)
,p_branch_name=>'Go To Page 222'
,p_branch_action=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.::P226_TABLE,P226_COLUMN_NAME,P226_EDIT:&P224_TABLE.,&P224_COL1.,NO&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4516868225068955.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4538562556068993.4504)
,p_branch_name=>'Go To Page 225'
,p_branch_action=>'f?p=&APP_ID.:225:&SESSION.::&DEBUG.::P225_ACTION,P225_TABLE:CREATE_INDEX,&P224_INDEX_NAME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4515696434068953.4504)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4520565392068965.4504)
,p_name=>'P224_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_prompt=>'Schema:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica il nome dello schema di database in cui verr\00E0 creato l''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4521404124068966.4504)
,p_name=>'P224_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_prompt=>'Tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nome della tabella su cui si baser\00E0 la creazione dell''indice.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4522311682068967.4504)
,p_name=>'P224_INDEX_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_item_default=>'&P224_TABLE._SX'
,p_prompt=>'Nome indice'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Immettere il nome dell''indice da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4523228092068967.4504)
,p_name=>'P224_PRESERVE_CASE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_item_default=>'N'
,p_prompt=>'Conserva maiuscole/minuscole'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indica se generare un nome indice con distinzione tra maiuscole e minuscole.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4524114727068967.4504)
,p_name=>'P224_USE_V2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_item_default=>'Y'
,p_prompt=>'Indice gestito dal sistema'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'sys.dbms_db_version.version > 12 or ( sys.dbms_db_version.version = 12 and sys.dbms_db_version.release = 2 ) '
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Specificare se usare un indice spaziale <em>gestito dal sistema</em>, che \00E8 un''operazione consigliata. Se abilitata, APEX crea un indice spaziale di tipo <strong>MDSYS.SPATIAL_INDEX_V2</strong>. Se disabilitata, verr\00E0 usato l''indice <strong>MDSYS.SPA')
||'TIAL_INDEX</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4525004704068968.4504)
,p_name=>'P224_POINTS_ONLY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_item_default=>'N'
,p_prompt=>'La tabella contiene solo oggetti punto'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Abilitare questa opzione se la tabella contiene <em>solo</em> oggetti geometria di punti in modo da ottenere una struttura di indici pi\00F9 efficiente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4525944116068969.4504)
,p_name=>'P224_COL1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_prompt=>'Colonna  indice'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'  from sys.dba_tab_columns',
' where owner      = :OB_SCHEMA ',
'   and table_name = :P224_TABLE',
'   and data_type  = ''SDO_GEOMETRY''',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare la prima colonna da utilizzare nell''indice'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4526852814068969.4504)
,p_name=>'P224_MSG'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4527221209068970.4504)
,p_name=>'P224_COLUMN_HAS_METADATA'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(6181558030032688.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4527718199068984.4504)
,p_computation_sequence=>10
,p_computation_item=>'P224_INDEX_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P224_INDEX_NAME,chr(32),''_''))'
,p_compute_when=>'P224_PRESERVE_CASE'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1205557413248107.4504)
,p_computation_sequence=>10
,p_computation_item=>'P224_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'nvl( :OBJECT_OWNER, :OB_SCHEMA )'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4528518700068984.4504)
,p_validation_name=>'P224_INDEX_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P224_INDEX_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome indice.'
,p_when_button_pressed=>wwv_flow_api.id(4515696434068953.4504)
,p_associated_item=>wwv_flow_api.id(4522311682068967.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4528950468068986.4504)
,p_validation_name=>'P224_COL1 Not Null'
,p_validation_sequence=>20
,p_validation=>'P224_COL1'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare un valore per Colonna 1 indice.'
,p_validation_condition=>'NEXT:REGISTER_COLUMN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(4525944116068969.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-FEB-2003 10:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4529344797068986.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P224_INDEX_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato dell''indice \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4529723586068987.4504)
,p_validation_name=>'available name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_util.is_available_name2(',
'p_name => :P224_INDEX_NAME,                                          p_owner=> :OB_SCHEMA,',
'p_type => ''INDEX''',
') then',
'  return',
'wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P224_INDEX_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_when_button_pressed=>wwv_flow_api.id(4515696434068953.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4530155067068987.4504)
,p_validation_name=>'valid index column type'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_return boolean;',
'begin',
'  for c1 in (select data_type',
'             from sys.dba_tab_columns',
'             where owner =  :OB_SCHEMA ',
'              and table_name= :P224_TABLE',
'              and column_name = :P224_COL1) loop',
'    if c1.data_type != ''SDO_GEOMETRY'' then',
'      return false;',
'    end if;',
'  end loop;',
'return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il tipo di dati di colonna selezionato non pu\00F2 essere utilizzato per l''indice spaziale.')
,p_when_button_pressed=>wwv_flow_api.id(4515696434068953.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4530579503068987.4504)
,p_validation_name=>'Has Spatial Metadata'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.get_geom_metadata(',
'    p_owner        => :OB_SCHEMA,',
'    p_table_name   => :P224_TABLE,',
'    p_column_name  => :P224_COL1 ) is not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Colonna &P224_COL1!HTML. assente nel registro Spatial.'
,p_validation_condition=>':P224_COLUMN_TYPE = ''GEOMETRY'' and :P224_COL1 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(4515696434068953.4504)
,p_associated_item=>wwv_flow_api.id(4525944116068969.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2505531120049731.4504)
,p_validation_name=>'Table contains only points'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.validate_gtype(',
'    p_table_name     => :P224_TABLE,',
'    p_owner          => :OB_SCHEMA,',
'    p_column_name    => :P224_COL1,',
'    p_gtype          => 2001 )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La tabella contiene oggetti geometria che non sono punti. Esaminare l''attributo SDO_GEOMETRY.SDO_GTYPE.'
,p_validation_condition=>'P224_POINTS_ONLY'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4515696434068953.4504)
,p_associated_item=>wwv_flow_api.id(4525004704068968.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4531201574068988.4504)
,p_name=>'Geometry'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P224_COLUMN_TYPE'
,p_condition_element=>'P224_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOMETRY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4531703347068990.4504)
,p_event_id=>wwv_flow_api.id(4531201574068988.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P224_FB_COL1,P224_FB_COL2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4533238625068990.4504)
,p_event_id=>wwv_flow_api.id(4531201574068988.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P224_COL1'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4532237602068990.4504)
,p_event_id=>wwv_flow_api.id(4531201574068988.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P224_FB_COL1,P224_FB_COL2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4532752752068990.4504)
,p_event_id=>wwv_flow_api.id(4531201574068988.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P224_COL1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4533633053068990.4504)
,p_name=>'Check Metadata'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P224_COL1'
,p_condition_element=>'P224_COL1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206436645248116.4504)
,p_event_id=>wwv_flow_api.id(4533633053068990.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P224_USE_V2,P224_POINTS_ONLY,P224_PRESERVE_CASE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4535133168068991.4504)
,p_event_id=>wwv_flow_api.id(4533633053068990.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P224_COLUMN_HAS_METADATA'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_sw_util.get_geom_metadata(',
'    p_owner        => :OB_SCHEMA,',
'    p_table_name   => :P224_TABLE,',
'    p_column_name  => :P224_COL1 ) from sys.dual'))
,p_attribute_07=>'P224_TABLE,P224_COL1'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4534167995068991.4504)
,p_event_id=>wwv_flow_api.id(4533633053068990.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6180108905032674.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4534697962068991.4504)
,p_event_id=>wwv_flow_api.id(4533633053068990.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6180108905032674.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4143001879496041.4504)
,p_event_id=>wwv_flow_api.id(4533633053068990.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4515696434068953.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4535646094068991.4504)
,p_event_id=>wwv_flow_api.id(4533633053068990.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6180108905032674.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206341321248115.4504)
,p_event_id=>wwv_flow_api.id(4533633053068990.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P224_USE_V2,P224_POINTS_ONLY,P224_PRESERVE_CASE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4143187478496042.4504)
,p_event_id=>wwv_flow_api.id(4533633053068990.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4516868225068955.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4536041587068991.4504)
,p_name=>'Show / Hide button'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P224_COLUMN_HAS_METADATA'
,p_condition_element=>'P224_COLUMN_HAS_METADATA'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4536595440068992.4504)
,p_event_id=>wwv_flow_api.id(4536041587068991.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4516868225068955.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4538058476068992.4504)
,p_event_id=>wwv_flow_api.id(4536041587068991.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4515696434068953.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4537073100068992.4504)
,p_event_id=>wwv_flow_api.id(4536041587068991.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4515696434068953.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4537566783068992.4504)
,p_event_id=>wwv_flow_api.id(4536041587068991.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4516868225068955.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4530849656068987.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate Create Index DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P225_SQL:= wwv_flow_sw_util.get_index_ddl(',
'         p_table_name => :P224_TABLE,',
'         p_index_name => :P224_INDEX_NAME,',
'         p_action     => ''create'',',
'         p_unique     => null,',
'         p_col1       => :P224_COL1,',
'         p_col2       => :P224_COL2,',
'         p_col3       => null,',
'         p_col4       => null,',
'         p_indextype  => ''mdsys.spatial_index'' || case when :P224_USE_V2 = ''Y'' then ''_v2'' end,',
'         p_parameters => case when :P224_POINTS_ONLY = ''Y'' then ''layer_gtype=point'' end );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00225
begin
wwv_flow_api.create_page(
 p_id=>225.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice spaziale'
,p_alias=>'SPATIAL-INDEX-WIZARD-2'
,p_step_title=>'Crea indice spaziale'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142140861496032.4504)
,p_plug_name=>'Crea indice spaziale'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142203978496033.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(420238686153914871.4504)
,p_plug_name=>'Confermare la richiesta'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(420241382912914875.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(420241776859914876.4504)
,p_plug_name=>'Progress Indicator'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4555880609113142.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4558881865119199.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4142203978496033.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea indice'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4559214713119199.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4142203978496033.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:225::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4559686671119199.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4142203978496033.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4565390738119218.4504)
,p_branch_name=>'Go To Page 4'
,p_branch_action=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.::P4_OBJECT_ID,P5_PREVIOUS,P4_MSG:&P225_NEW_OBJECT_ID.,225,&P225_MSG.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4558881865119199.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1666660957963750.4504)
,p_name=>'P225_MSG'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(420238686153914871.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4560044571119200.4504)
,p_name=>'P225_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(420238686153914871.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database proprietario della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4560938814119203.4504)
,p_name=>'P225_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(420238686153914871.4504)
,p_prompt=>'Oggetto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4561865409119203.4504)
,p_name=>'P225_ACTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(420238686153914871.4504)
,p_prompt=>'Azione:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il tipo di azione da eseguire sulla tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4562760267119203.4504)
,p_name=>'P225_NEW_OBJECT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(420238686153914871.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4563446450119204.4504)
,p_name=>'P225_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(420241382912914875.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4564124077119214.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(4558881865119199.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4564402616119214.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P225_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P225_SQL );',
'if :p225_PREVIOUS = ''130'' then',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :p130_index_name ',
'          and owner = :OB_SCHEMA ',
'          and object_type = ''INDEX'') loop',
'  :P225_NEW_OBJECT_ID := c.object_id;',
'end loop;',
'else',
'for c in (select object_id ',
'          from sys.dba_objects ',
'          where object_name = :p106_index_name ',
'          and owner = :OB_SCHEMA ',
'          and object_type = ''INDEX'') loop',
'  :P225_NEW_OBJECT_ID := c.object_id;',
'end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(4558881865119199.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4564861629119215.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P225_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(4558881865119199.4504)
);
end;
/
prompt --application/pages/page_00226
begin
wwv_flow_api.create_page(
 p_id=>226.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Metadati spaziali'
,p_alias=>'SPATIAL-METADATA-WIZARD-1'
,p_step_title=>'Metadati spaziali'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142363135496034.4504)
,p_plug_name=>'Metadati spaziali'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142407593496035.4504)
,p_plug_name=>'Progress Indicator'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(4555880609113142.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142512716496036.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(422908880345315242.4504)
,p_plug_name=>'Metadati spaziali'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10144972520238121.4504)
,p_plug_name=>'Registra colonna'
,p_parent_plug_id=>wwv_flow_api.id(422908880345315242.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6810229860020919.4504)
,p_plug_name=>'Dimensioni'
,p_parent_plug_id=>wwv_flow_api.id(10144972520238121.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4578507562186500.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(4142512716496036.4504)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aggiungi metadati spaziali'
,p_button_position=>'NEXT'
,p_button_condition=>'P226_EDIT'
,p_button_condition2=>'NO'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4579740360186501.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(4142512716496036.4504)
,p_button_name=>'REPLACE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sostituisci metadati spaziali'
,p_button_position=>'NEXT'
,p_button_condition=>'P226_EDIT'
,p_button_condition2=>'YES'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4578992574186501.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4142512716496036.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:226::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4579370617186501.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4142512716496036.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4594187490186537.4504)
,p_branch_name=>'Go To Page 227'
,p_branch_action=>'f?p=&APP_ID.:227:&SESSION.::&DEBUG.::P227_ACTION,P227_TABLE,P227_COLUMN_NAME:INSERT_GEOM_METADATA,&P226_TABLE.,&P226_COLUMN_NAME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4578507562186500.4504)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4594577781186537.4504)
,p_branch_name=>'Go To Page 227'
,p_branch_action=>'f?p=&APP_ID.:227:&SESSION.::&DEBUG.::P227_ACTION,P227_TABLE,P227_COLUMN_NAME:REPLACE_GEOM_METADATA,&P226_TABLE.,&P226_COLUMN_NAME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4579740360186501.4504)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1205264509248104.4504)
,p_name=>'P226_DIMX_TOL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(6810229860020919.4504)
,p_prompt=>'Tolleranza spaziale'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<em>Tolleranza</em> spaziale da usare per l''asse X. Se due punti sono pi\00F9 vicini l''uno all''altro rispetto alla tolleranza specificata, Oracle Spatial li considera come se fossero lo stesso punto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1205325021248105.4504)
,p_name=>'P226_DIMY_HDR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(6810229860020919.4504)
,p_prompt=>'Dimensione'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>1
,p_grid_column=>3
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1205423716248106.4504)
,p_name=>'P226_DIMX_HDR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6810229860020919.4504)
,p_prompt=>'Dimensione'
,p_source=>'X'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>1
,p_grid_column=>3
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4580403404186505.4504)
,p_name=>'P226_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(10144972520238121.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica il nome dello schema di database della tabella spaziale.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4581380317186508.4504)
,p_name=>'P226_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(10144972520238121.4504)
,p_prompt=>'Tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nome della tabella.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4582212188186508.4504)
,p_name=>'P226_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(10144972520238121.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'  from sys.dba_tab_columns',
'where owner      = :OB_SCHEMA ',
'  and table_name = :P226_TABLE',
'  and data_type  = ''SDO_GEOMETRY''',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona colonna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della colona geometria.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4583118668186510.4504)
,p_name=>'P226_SRID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(10144972520238121.4504)
,p_prompt=>'Sistema di coordinate'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select srid ||'': '' || cs_name as d,',
'       srid as r',
'  from mdsys.cs_srs ',
' where wktext is not null',
' order by srid'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Sistema di coordinate degli oggetti geometria nella tabella spaziale (<em>ID sistema di riferimento spaziale</em>.',
'</p>',
'<p>Se i dati sono composti da longitudine e latitudine, usare <strong>4326 (WGS 84)</strong></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Coordinate System (SRID)'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4584067464186510.4504)
,p_name=>'P226_CS_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(10144972520238121.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4584453674186515.4504)
,p_name=>'P226_EDIT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(10144972520238121.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4585041264186515.4504)
,p_name=>'P226_DIMX_MIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6810229860020919.4504)
,p_prompt=>'Minimo'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Limite del valore minimo dell''asse X degli oggetti spaziali nella tabella. Per i sistemi di coordinate latitudine/longitudine, in genere il valore \00E8 -180.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4585904996186516.4504)
,p_name=>'P226_DIMX_MAX'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6810229860020919.4504)
,p_prompt=>'Massimo:'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Limite del valore massimo dell''asse X degli oggetti spaziali nella tabella. Per i sistemi di coordinate latitudine/longitudine, in genere il valore \00E8 180.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4586852056186516.4504)
,p_name=>'P226_DIMY_MIN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(6810229860020919.4504)
,p_prompt=>'Minimo'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Limite del valore minimo dell''asse Y degli oggetti spaziali nella tabella. Per i sistemi di coordinate latitudine/longitudine, in genere il valore \00E8 -90.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4587795203186516.4504)
,p_name=>'P226_DIMY_MAX'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(6810229860020919.4504)
,p_prompt=>'Massimo'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Limite del valore massimo dell''asse Y degli oggetti spaziali nella tabella. Per i sistemi di coordinate latitudine/longitudine, in genere il valore \00E8 90.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4588607047186517.4504)
,p_name=>'P226_DIMY_TOL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(6810229860020919.4504)
,p_prompt=>'Tolleranza spaziale'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<em>Tolleranza</em> spaziale da usare per l''asse Y. Se due punti sono pi\00F9 vicini l''uno all''altro rispetto alla tolleranza specificata, Oracle Spatial li considera come se fossero lo stesso punto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1205829756248110.4504)
,p_validation_name=>'SRID matches Table Geometries'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.validate_srid(',
'    p_table_name     => :P226_TABLE,',
'    p_owner          => :OB_SCHEMA,',
'    p_column_name    => :P226_COLUMN_NAME,',
'    p_srid           => :P226_SRID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La tabella contiene oggetti geometria con un ID sistema di coordinate diverso. Esaminare l''attributo SDO_GEOMETRY.SDO_SRID.'
,p_validation_condition=>'ADD:REPLACE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(4583118668186510.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4590393029186531.4504)
,p_name=>'Geometry'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P226_COLUMN_TYPE'
,p_condition_element=>'P226_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOMETRY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4590828257186533.4504)
,p_event_id=>wwv_flow_api.id(4590393029186531.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P226_COL2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4591367664186533.4504)
,p_event_id=>wwv_flow_api.id(4590393029186531.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P226_COL2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4591764163186533.4504)
,p_name=>'Get CS type'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P226_SRID'
,p_condition_element=>'P226_SRID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4592246768186535.4504)
,p_event_id=>wwv_flow_api.id(4591764163186533.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P226_CS_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr( wktext, 1, 6 )',
'  from mdsys.cs_srs',
' where srid = :P226_SRID'))
,p_attribute_07=>'P226_SRID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4592603695186535.4504)
,p_name=>'Set Defaults'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P226_CS_TYPE'
,p_condition_element=>'P226_CS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOGCS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4593104368186536.4504)
,p_event_id=>wwv_flow_api.id(4592603695186535.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s("P226_DIMX_MIN", -180 );',
'$s("P226_DIMX_MAX",  180 );',
'$s("P226_DIMY_MIN",  -90 );',
'$s("P226_DIMY_MAX",   90 );',
'$s("P226_TOLERANCE",   1 );',
''))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4593604197186536.4504)
,p_event_id=>wwv_flow_api.id(4592603695186535.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s("P226_DIMX_MIN",         0 );',
'$s("P226_DIMX_MAX",  10000000 );',
'$s("P226_DIMY_MIN",         0 );',
'$s("P226_DIMY_MAX",  10000000 );',
'$s("P226_TOLERANCE",      0.5 );',
''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4589908065186531.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate Spatial Metadata DML'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P227_SQL:= wwv_flow_sw_util.get_add_geom_metadata_dml(',
'                p_table_name    => :P226_TABLE,',
'                p_column_name   => :P226_COLUMN_NAME,',
'                p_action        => case when :P226_EDIT = ''YES'' then ''recreate'' else ''create'' end,',
'                p_srid          => :P226_SRID,',
'                p_dim_x_min     => :P226_DIMX_MIN,',
'                p_dim_x_max     => :P226_DIMX_MAX,',
'                p_dim_y_min     => :P226_DIMY_MIN,',
'                p_dim_y_max     => :P226_DIMY_MAX,',
'                p_dim_x_tol     => :P226_DIMX_TOL,',
'                p_dim_y_tol     => :P226_DIMY_TOL );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'ADD,REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4589596910186531.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Metadata'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_metadata wwv_flow_t_varchar2 := wwv_flow_t_varchar2();',
'begin',
'    case when :P226_EDIT = ''YES'' then ',
'        l_metadata := wwv_flow_string.split(',
'                        wwv_flow_sw_util.get_geom_metadata(',
'                            p_owner         => :OB_SCHEMA,',
'                            p_table_name    => :P226_TABLE,',
'                            p_column_name   => :P226_COLUMN_NAME ), '':'' );',
'',
'        if l_metadata.count = 7 then',
'            :P226_SRID := l_metadata( 1 );',
'            :P226_DIMX_MIN := l_metadata( 2 );',
'            :P226_DIMX_MAX := l_metadata( 3 );',
'            :P226_DIMX_TOL := l_metadata( 4 );',
'            :P226_DIMY_MIN := l_metadata( 5 );',
'            :P226_DIMY_MAX := l_metadata( 6 );',
'            :P226_DIMY_TOL := l_metadata( 7 );',
'        end if;',
'    else',
'        :P226_SRID := ''4326'';',
'        :P226_DIMX_MIN := ''-180'';',
'        :P226_DIMX_MAX := ''180'';',
'        :P226_DIMX_TOL := 0.05;',
'        :P226_DIMY_MIN := ''-90'';',
'        :P226_DIMY_MAX := ''90'';',
'        :P226_DIMY_TOL := 0.05;',
'    end case;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00227
begin
wwv_flow_api.create_page(
 p_id=>227.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Metadati spaziali'
,p_alias=>'SPATIAL-METADATA-WIZARD-2'
,p_step_title=>'Metadati spaziali'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'    function showDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P67_SQL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'</script>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_index.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142627916496037.4504)
,p_plug_name=>'Metadati spaziali'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142714166496038.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(420801841155405923.4504)
,p_plug_name=>'Confermare la richiesta'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(420804537914405927.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(420804931861405928.4504)
,p_plug_name=>'Progress Indicator'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4555880609113142.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'F4500_LAST_VIEW'
,p_plug_display_when_cond2=>'2102'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4612029256383115.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4142714166496038.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esegui'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4612457035383116.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4142714166496038.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.:227::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4612828934383116.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4142714166496038.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4618250781383135.4504)
,p_branch_name=>'Go To Page 224'
,p_branch_action=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:226,227::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4612029256383115.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4613214344383118.4504)
,p_name=>'P227_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(420801841155405923.4504)
,p_prompt=>'Oggetto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4614188226383120.4504)
,p_name=>'P227_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(420801841155405923.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4615004306383120.4504)
,p_name=>'P227_ACTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(420801841155405923.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica il nome della tabella selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4616252367383122.4504)
,p_name=>'P227_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(420804537914405927.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4616935188383133.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Non si dispone del privilegio su &OB_SCHEMA..'
,p_process_when_button_id=>wwv_flow_api.id(4612029256383115.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4617333859383134.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P224_MSG := wwv_flow_sw_util.run_other_sql(',
'              p_schema     => upper(:OB_SCHEMA),',
'              p_sql        => :P227_SQL );',
''))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(4612029256383115.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4617711193383134.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P227_SQL,',
'    p_schema            => upper(:OB_SCHEMA)',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(4612029256383115.4504)
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_api.create_page(
 p_id=>400.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Oggetti eliminati'
,p_step_title=>'Oggetti eliminati'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215661000733996927)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_rcycl_.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4240028411514106.4504)
,p_plug_name=>'Task'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(151000331198918456.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11603702678674839.4504)
,p_plug_name=>'schema owner'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72170018852796333.4504)
,p_plug_name=>'Cestino'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Quando si elimina una tabella, il database Oracle non rimuove immediatamente lo spazio a essa associato, bens\00EC rinomina la tabella e la inserisce insieme a tutti gli oggetti associati in un cestino, da dove sar\00E0 possibile recuperarla in un secondo mo')
||unistr('mento. Tenere presente che questo funzionamento pu\00F2 essere disabilitato da un amministratore del database.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(478189003940910628.4504)
,p_plug_name=>'Cestino'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.object_name identifier,',
'  o.original_name,',
'  o.object_name,',
'  replace(o.type,'' '',''_'') type,',
'  o.operation,',
'  o.createtime,',
'  o.droptime,',
'  to_date(o.droptime,''YYYY-MM-DD:HH24:MI:SS'') droptimesince,',
'  o.can_undrop,',
'  o.can_purge,',
'  /*o.base_object object_id*/',
'  o.purge_object object_id',
'from sys.user_recyclebin o',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P400_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(478189118717910628.4504)
,p_name=>'Recycle Bin'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478189318636910642.4504)
,p_db_column_name=>'IDENTIFIER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_link=>'f?p=&FLOW_ID.:401:&SESSION.::&DEBUG.::P401_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#24find.gif" border="0" height="24" width="24">'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478189431476910645.4504)
,p_db_column_name=>'ORIGINAL_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nome originale'
,p_column_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::P401_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#ORIGINAL_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478189628200910648.4504)
,p_db_column_name=>'TYPE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478189517434910646.4504)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Nome oggetto'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478189723375910649.4504)
,p_db_column_name=>'OPERATION'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Operazione'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478189803915910650.4504)
,p_db_column_name=>'CREATETIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Data creazione'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478189903360910652.4504)
,p_db_column_name=>'DROPTIME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Data di eliminazione'
,p_column_type=>'STRING'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478190112436910654.4504)
,p_db_column_name=>'CAN_UNDROP'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'&nbsp;'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478190215884910656.4504)
,p_db_column_name=>'CAN_PURGE'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'&nbsp;'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478190318059910657.4504)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'ID oggetto'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478190025531910653.4504)
,p_db_column_name=>'DROPTIMESINCE'
,p_display_order=>11
,p_column_identifier=>'H'
,p_column_label=>'Eliminato'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(465926830788091.4504)
,p_branch_action=>'f?p=&FLOW_ID.:400:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(525320683135333.4504)
,p_name=>'P400_SCHEMA'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(11603702678674839.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(187652405321922937.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema (nome utente) che si desidera visualizzare. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(175580808373672184.4504)
,p_name=>'P400_DEFAULT_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(478189003940910628.4504)
,p_source=>'return wwv_flow_user_api.get_default_schema;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(69327630670884389.4504)
,p_computation_sequence=>10
,p_computation_item=>'P400_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P400_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1020677943389018448.4504)
,p_name=>'RENDERING: Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(4240028411514106.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1020678234799018449.4504)
,p_event_id=>wwv_flow_api.id(1020677943389018448.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:400:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69316307206858608.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P400_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
,p_process_when=>'P400_SCHEMA'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
end;
/
prompt --application/pages/page_00401
begin
wwv_flow_api.create_page(
 p_id=>401.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dettagli oggetto'
,p_step_title=>'Dettagli oggetto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_rcycl_.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473825148833877.4504)
,p_plug_name=>'Dettagli oggetto'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Questa pagina fornisce ulteriori informazioni sull''oggetto contenuto nel cestino e consente la rimozione degli oggetti (eliminazione permanente) oppure il loro ripristino dal cestino.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(476219177851040.4504)
,p_name=>'Dettagli oggetto eliminato'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.object_name identifier,',
'  b.original_name base_object_name,',
'  o.original_name,',
'  o.object_name,',
'  o.type,',
'  o.operation,',
'  o.createtime,',
'  o.droptime,',
'  substr(o.can_undrop, 1, 1) as can_undrop,',
'  substr(o.can_purge, 1, 1) as can_purge',
'from sys.dba_recyclebin o, sys.dba_recyclebin b',
'where o.owner = :P401_OBJECT_OWNER',
'and b.purge_object = o.base_object',
'and o.object_name = :P401_OBJECT_NAME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(476622036851053.4504)
,p_query_column_id=>1
,p_column_alias=>'IDENTIFIER'
,p_column_display_sequence=>1
,p_column_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(476708297851053.4504)
,p_query_column_id=>2
,p_column_alias=>'BASE_OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome oggetto di base'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(476810063851053.4504)
,p_query_column_id=>3
,p_column_alias=>'ORIGINAL_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome oggetto originale'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(476925144851053.4504)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome oggetto'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(477024808851053.4504)
,p_query_column_id=>5
,p_column_alias=>'TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(477105517851054.4504)
,p_query_column_id=>6
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>6
,p_column_heading=>'Operazione'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(477217067851054.4504)
,p_query_column_id=>7
,p_column_alias=>'CREATETIME'
,p_column_display_sequence=>7
,p_column_heading=>'Data creazione'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(477320606851054.4504)
,p_query_column_id=>8
,p_column_alias=>'DROPTIME'
,p_column_display_sequence=>8
,p_column_heading=>'Data eliminazione'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(477409806851054.4504)
,p_query_column_id=>9
,p_column_alias=>'CAN_UNDROP'
,p_column_display_sequence=>9
,p_column_heading=>unistr('Pu\00F2 essere ripristinato?')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(23482928300634173)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(477520310851054.4504)
,p_query_column_id=>10
,p_column_alias=>'CAN_PURGE'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Pu\00F2 essere rimosso?')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(23482928300634173)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(499410144971419.4504)
,p_name=>'Colonne tabella'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.column_name,',
'         initcap(t.data_type) data_type,',
'         decode(t.data_type,''NUMBER'',null,t.data_length) data_length,',
'         t.data_precision,',
'         t.data_scale,',
'         wwv_flow_sw_util.get_pk_position (t.owner,t.table_name,t.column_name) pk,',
'decode(t.nullable,''Y'',''<span class="a-Icon icon-check"></span>'',null) nullable,',
'         t.data_default,',
'         t.column_id,',
'         substr(c.comments,1,3000) comments',
'from sys.dba_tab_columns t, sys.dba_col_comments c',
'where t.column_name = c.column_name               ',
'  and t.table_name = :P401_OBJECT_NAME',
'  and c.table_name = :P401_OBJECT_NAME',
'  and t.owner = :P401_OBJECT_OWNER',
'order by t.column_id'))
,p_display_when_condition=>'P401_OBJECT_TYPE'
,p_display_when_cond2=>'TABLE'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'<span class="instructiontext">Nessuna colonna trovata.</span>'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(499624525971424.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(499732289971424.4504)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(499827940971424.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Lunghezza'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(499932389971424.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precisione'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(500032050971424.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scala'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(500105274971424.4504)
,p_query_column_id=>6
,p_column_alias=>'PK'
,p_column_display_sequence=>1
,p_column_heading=>'Chiave primaria'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(500223719971425.4504)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Annullabile'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(500303898971425.4504)
,p_query_column_id=>8
,p_column_alias=>'DATA_DEFAULT'
,p_column_display_sequence=>8
,p_column_heading=>'Valore predefinito'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(500425198971425.4504)
,p_query_column_id=>9
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>9
,p_column_heading=>'Column Id'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(500526057971425.4504)
,p_query_column_id=>10
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>10
,p_column_heading=>'Commenti'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(506831316005926.4504)
,p_name=>'Riepilogo indice'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select OWNER,',
'       INDEX_NAME,',
'       INDEX_TYPE,',
'       TABLE_OWNER,',
'       TABLE_NAME,',
'       TABLE_TYPE,',
'       UNIQUENESS,',
'       COMPRESSION,',
'       PREFIX_LENGTH,',
'       TABLESPACE_NAME,',
'       STATUS,',
'       LAST_ANALYZED',
' from sys.dba_indexes i',
'where i.index_name = :P401_OBJECT_NAME',
'and i.owner = :P401_OBJECT_OWNER'))
,p_display_when_condition=>'P401_OBJECT_TYPE'
,p_display_when_cond2=>'NORMAL_INDEX:INDEX'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(277999816507196427.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(277999924067196428.4504)
,p_query_column_id=>2
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome indice'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000013408196428.4504)
,p_query_column_id=>3
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo indice'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000110551196428.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>4
,p_column_heading=>'Proprietario tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000217638196428.4504)
,p_query_column_id=>5
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nome tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000301536196429.4504)
,p_query_column_id=>6
,p_column_alias=>'TABLE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo di tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000412358196429.4504)
,p_query_column_id=>7
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Univocit\00E0')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000509329196429.4504)
,p_query_column_id=>8
,p_column_alias=>'COMPRESSION'
,p_column_display_sequence=>8
,p_column_heading=>'Compressione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000624209196429.4504)
,p_query_column_id=>9
,p_column_alias=>'PREFIX_LENGTH'
,p_column_display_sequence=>9
,p_column_heading=>'Lunghezza prefisso'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000717643196429.4504)
,p_query_column_id=>10
,p_column_alias=>'TABLESPACE_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Nome tablespace'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000831033196430.4504)
,p_query_column_id=>11
,p_column_alias=>'STATUS'
,p_column_display_sequence=>11
,p_column_heading=>'Stato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(278000910266196430.4504)
,p_query_column_id=>12
,p_column_alias=>'LAST_ANALYZED'
,p_column_display_sequence=>12
,p_column_heading=>'Ultima analisi'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(565731416606686.4504)
,p_name=>'Informazioni di riepilogo trigger'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'trigger_name,',
'trigger_type,',
'triggering_event,',
'table_owner,',
'base_object_type,',
'table_name,',
'column_name,',
'referencing_names,',
'when_clause,',
'status,',
'description,',
'action_type',
'from sys.dba_triggers',
'where trigger_name = :P401_OBJECT_NAME and owner = :P401_OBJECT_OWNER'))
,p_display_when_condition=>'P401_OBJECT_TYPE'
,p_display_when_cond2=>'TRIGGER'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(565924109606694.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566021271606694.4504)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome trigger'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566126880606694.4504)
,p_query_column_id=>3
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo di trigger'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566211863606694.4504)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>4
,p_column_heading=>'Evento di trigger'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566324866606694.4504)
,p_query_column_id=>5
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Proprietario tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566410720606694.4504)
,p_query_column_id=>6
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo di oggetto di base'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566522449606694.4504)
,p_query_column_id=>7
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>7
,p_column_heading=>'Nome tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566609492606695.4504)
,p_query_column_id=>8
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>8
,p_column_heading=>'Nome colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566704941606695.4504)
,p_query_column_id=>9
,p_column_alias=>'REFERENCING_NAMES'
,p_column_display_sequence=>9
,p_column_heading=>'Nomi di riferimento'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566829022606695.4504)
,p_query_column_id=>10
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>10
,p_column_heading=>'Clausola WHEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(566902023606695.4504)
,p_query_column_id=>11
,p_column_alias=>'STATUS'
,p_column_display_sequence=>11
,p_column_heading=>'Stato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(567013947606695.4504)
,p_query_column_id=>12
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>12
,p_column_heading=>'Descrizione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(567113619606695.4504)
,p_query_column_id=>13
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>13
,p_column_heading=>'Tipo di azione'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(570014017620550.4504)
,p_name=>'Corpo trigger'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trigger_body',
'from sys.dba_triggers',
'where trigger_name = :P401_OBJECT_NAME and owner = :P401_OBJECT_OWNER'))
,p_display_when_condition=>'P401_OBJECT_TYPE'
,p_display_when_cond2=>'TRIGGER'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(570226900620552.4504)
,p_query_column_id=>1
,p_column_alias=>'TRIGGER_BODY'
,p_column_display_sequence=>1
,p_column_heading=>'Corpo trigger'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(278739423349285182.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(572503684721678.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(278739423349285182.4504)
,p_button_name=>'PURGE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Rimuovi oggetto'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P401_CAN_PURGE = ''YES''',
'and :P401_OBJECT_TYPE in (''TABLE'', ''NORMAL_INDEX'', ''INDEX'')'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(563731632597236.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(278739423349285182.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(612020877142921.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(278739423349285182.4504)
,p_button_name=>'RESTORE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ripristina oggetto'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P401_CAN_UNDROP = ''YES''',
'and :P401_OBJECT_TYPE = ''TABLE'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(572805476721679.4504)
,p_branch_name=>'Go To Page 1070'
,p_branch_action=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(572503684721678.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(616919313454755.4504)
,p_branch_name=>'Go To Page 1070'
,p_branch_action=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(612020877142921.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(479427965863057.4504)
,p_name=>'P401_OBJECT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(476219177851040.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(497007936961304.4504)
,p_name=>'P401_OBJECT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(476219177851040.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(518214740029578.4504)
,p_name=>'P401_OBJECT_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(476219177851040.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14575304481510701.4504)
,p_name=>'P401_CAN_UNDROP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(476219177851040.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14576222189544219.4504)
,p_name=>'P401_CAN_PURGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(476219177851040.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46243200227025823.4504)
,p_name=>'P401_OBJECT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(476219177851040.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1500323633186760220.4504)
,p_name=>'P401_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(278739423349285182.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(574207624732252.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_base_object number;',
'    l_msg         varchar2(32767);',
'begin',
'select base_object into l_base_object ',
'  from sys.dba_recyclebin',
' where purge_object = :P401_OBJECT_ID;',
'',
'',
'for c1 in (',
'     select owner, object_name, type',
'     from sys.dba_recyclebin',
'     where purge_object = l_base_object ',
') loop',
'    l_msg := wwv_flow_sw_page_calls.purge_object(c1.object_name,c1.owner,c1.type);',
'end loop;',
'',
'if l_msg <> ''SUCCESS'' then',
'        raise_application_error( -20999, l_msg );',
'end if;',
'',
'--:P402_MSG := wwv_flow_sw_page_calls.purge_object(l_owner,:P401_OBJECT_OWNER,:P401_OBJECT_TYPE);',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(572503684721678.4504)
,p_process_when=>'P401_CAN_PURGE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'YES'
,p_process_success_message=>'Oggetto rimosso.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(615905115450652.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'restore object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_base_object number;',
'    l_msg         varchar2(32767);',
'begin',
'  select base_object into l_base_object ',
'    from sys.dba_recyclebin',
'   where purge_object = :P401_OBJECT_ID',
'     and can_undrop = ''YES'';',
'',
'',
'  for c1 in (',
'     select owner, object_name, type',
'     from sys.dba_recyclebin',
'     where purge_object = l_base_object ',
'  )loop',
'    l_msg := wwv_flow_sw_page_calls.restore_object(c1.object_name,c1.owner,c1.type);',
'  end loop;',
'',
'  if l_msg <> ''SUCCESS'' then',
'      raise_application_error( -20999, l_msg );',
'  end if;',
'',
'--:P402_MSG := wwv_flow_sw_page_calls.restore_object(:P401_OBJECT_NAME,:P401_OBJECT_OWNER,:P401_OBJECT_TYPE);',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(612020877142921.4504)
,p_process_when=>'P401_CAN_UNDROP'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'YES'
,p_process_success_message=>'Oggetto ripristinato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46245924599042376.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values based on object id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'     select owner, object_name, type, can_undrop, can_purge',
'     from sys.dba_recyclebin',
'     where purge_object = :P401_OBJECT_ID',
') loop',
'     :P401_OBJECT_OWNER := c1.owner;',
'     :P401_OBJECT_NAME  := c1.object_name;',
'     :P401_OBJECT_TYPE  := c1.type;',
'     :P401_CAN_UNDROP   := c1.can_undrop;',
'     :P401_CAN_PURGE    := c1.can_purge;',
'end loop; ',
'',
'wwv_flow_sw_api.check_priv ( p_schema => :P401_OBJECT_OWNER );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00403
begin
wwv_flow_api.create_page(
 p_id=>403.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Svuota cestino'
,p_page_mode=>'MODAL'
,p_step_title=>'Svuota cestino'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215661000733996927)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEUTL/sql_utl_rcycl_empty.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12915923927664202.4504)
,p_plug_name=>'Svuota cestino'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Confermare la richiesta di rimozione del cestino.</p>',
'',
unistr('<p>Se si decide che non verranno mai ripristinati, \00E8 possibile rimuovere gli oggetti contenuti nel cestino. L''operazione di rimozione rimuover\00E0 <strong>tutti</strong> gli oggetti liberandone lo spazio di memorizzazione.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select 1 from sys.dba_recyclebin where owner = nvl(:P400_SCHEMA,wwv_flow_user_api.get_default_schema)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(157938819580413996.4504)
,p_plug_name=>'Cestino vuoto'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>40
,p_plug_source=>unistr('<p>Il cestino \00E8 vuoto e non pu\00F2 essere svuotato.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>'select 1 from sys.dba_recyclebin where owner = nvl(:P400_SCHEMA,wwv_flow_user_api.get_default_schema)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(722737454749798602.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12926028785741314.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(722737454749798602.4504)
,p_button_name=>'PURGE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Svuota cestino'
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from sys.dba_recyclebin where owner = nvl(:P400_SCHEMA,wwv_flow_user_api.get_default_schema)'
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722737538240798603.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(722737454749798602.4504)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1119154104615390604.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(722737538240798603.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1119154226953390605.4504)
,p_event_id=>wwv_flow_api.id(1119154104615390604.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12930701043780683.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge recyclebin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_msg varchar2(32767);',
'begin',
'    l_msg := wwv_flow_sw_page_calls.purge_recyclebin(:P400_SCHEMA);',
'    if l_msg <> ''SUCCESS'' then',
'        raise_application_error( -20999, l_msg );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(12926028785741314.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(722737639681798604.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(12926028785741314.4504)
,p_process_success_message=>'Svuotato cestino.'
);
end;
/
prompt --application/pages/page_00500
begin
wwv_flow_api.create_page(
 p_id=>500.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Tutti gli oggetti'
,p_step_title=>'Tutti gli oggetti'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215533113079716670)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8298414867976068.4504)
,p_plug_name=>'Schema in Jog'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441220613960112851.4504)
,p_plug_name=>'Risultati oggetti di database'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :F4500_P500_SCHEMA object_owner,',
'       object_name, ',
'       status, ',
'       object_type object_type,',
'       created date_created,',
'       nvl(LAST_DDL_TIME,created) lastddltime,',
'       case',
'       when object_type in (''TYPE BODY'', ''PACKAGE BODY'')',
'       then replace(object_type, '' BODY'', null)',
'       when object_type = ''LOB''',
'       then ''TABLE''',
'       when object_type in (''MATERIALIZED VIEW'', ''DATABASE LINK'')',
'       then replace(object_type, '' '', ''_'')',
'       else object_type',
'       end  object_type_link,',
'       case',
'       when object_type in (''TYPE BODY'', ''PACKAGE BODY'')',
'       then ( select to_char(o2.object_id)',
'                from sys.user_objects o2',
'               where o2.object_name = o.object_name',
'                 and o2.object_type = replace(o.object_type, '' BODY'', null) )',
'       when object_type = ''LOB''',
'       then ( select to_char(o2.object_id)',
'                from sys.user_objects o2,',
'                     sys.user_lobs l',
'               where o2.object_name = l.table_name',
'                 and l.segment_name = o.object_name )',
'       when object_type = ''DATABASE LINK''',
'       then ''DBASE''||',
'            ltrim (',
'                to_char (',
'                    ora_hash (',
'                        upper(:F4500_P500_SCHEMA ||''.'' || object_name),',
'                        1000000000, ',
'                        power(2,30)),',
'                    rpad(''X'',29,''X'')||''X'' ))',
'       else to_char(object_id)',
'       end object_id',
'  from sys.user_objects o',
' where upper(object_name) not like ''BIN$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'F4500_P500_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441220719108112851.4504)
,p_name=>'Database Object Results'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441220915412112864.4504)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441221010045112865.4504)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nome oggetto'
,p_column_link=>'f?p=4500:1001:&SESSION.:FOCUS:&DEBUG.::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:#OBJECT_ID#,#OBJECT_TYPE_LINK#,#OBJECT_OWNER#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441221132283112866.4504)
,p_db_column_name=>'STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Stato'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441221201214112867.4504)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441221329379112868.4504)
,p_db_column_name=>'DATE_CREATED'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Data creazione'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441221422134112869.4504)
,p_db_column_name=>'LASTDDLTIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Ultima DDL'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441221518897112870.4504)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'ID'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30077039500107805.4504)
,p_db_column_name=>'OBJECT_TYPE_LINK'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Collegamento tipo di oggetto'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722739336427798621.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441220613960112851.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.::'
,p_icon_css_classes=>'fa-undo'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33071078540256522.4504)
,p_branch_action=>'500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33071617059256525.4504)
,p_name=>'F4500_P500_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8298414867976068.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema (nome utente) che si desidera visualizzare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(101429917448484868.4504)
,p_computation_sequence=>10
,p_computation_item=>'LAST_SELECTED_PARSE_AS'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4500_P500_SCHEMA'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(276391831864372049.4504)
,p_computation_sequence=>20
,p_computation_item=>'F4500_P500_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'F4500_P500_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48602961334414461.4504)
,p_computation_sequence=>30
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'500'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(128711215402133951.4504)
,p_validation_name=>'must select schema'
,p_validation_sequence=>10
,p_validation=>'F4500_P500_SCHEMA'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Specificare uno schema Oracle (NOME UTENTE).'
,p_associated_item=>wwv_flow_api.id(33071617059256525.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69259125073778677.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:F4500_P500_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00540
begin
wwv_flow_api.create_page(
 p_id=>540.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Sessioni'
,p_step_title=>'Sessioni'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(159560000024320866.4504)
,p_name=>'Query sessioni'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid, inst_id from sys.gv_$mystat where rownum = 1), ',
'vs as (select inst_id, rownum rnum,sid,status,username,last_call_et,',
'              command,machine,osuser,module,action,resource_consumer_group,',
'              client_info,client_identifier,type,terminal',
'         from sys.gv_$session) ',
' select case when (select sid from my_s where rownum = 1) = vs.sid then  ',
'                  ''C'' ',
'             when vs.status = ''ACTIVE'' then ',
'                  case when last_call_et > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  vs.status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status, vs.sid,',
'        vs.username,',
'        case when vs.status = ''ACTIVE'' ',
'                  then last_call_et ',
'             else null end seconds_in_wait,',
'        decode(vs.command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(vs.command)) command,',
'        case when length(vs.machine) > 15 then substr(vs.machine,1,15)||''...''  ',
'             else lower(vs.machine) end machine,',
'        vs.machine machine2,',
'        vs.osuser, ',
'        initcap(vs.status) status,',
'        case when length(vs.module) > 15 then substr(vs.module,1,15)||''...''',
'             else vs.module end module,',
'        vs.module module2,',
'        case when length(vs.action) > 15 then substr(vs.action,1,15)||''...'' ',
'             else vs.action end action,',
'        vs.action action2,',
'        vs.resource_consumer_group,vs.client_info,vs.client_identifier,',
'         -- 10g only blocking_session,',
'        vs.inst_id',
'   from vs ',
'  where vs.USERNAME is not null',
'    and nvl(vs.osuser,''x'') <> ''SYSTEM''',
'    and vs.type <> ''BACKGROUND''',
'    and (:P540_STATUS = ''ALL'' or (:P540_STATUS = ''ACTIVE'' and vs.status = ''ACTIVE''))',
'    and (:P540_SEARCH is null',
'        or',
'        (:P540_SEARCH is not null',
'         and',
'            (vs.username like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.osuser) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.machine) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.module) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.client_info) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.client_identifier) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or',
'             to_char(vs.sid) = :P540_SEARCH',
'            )',
'         )',
'    )',
'   '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna sessione trovata'
,p_query_num_rows_item=>'P540_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030035934459536811.4504)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato sessione'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159560724478320875.4504)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159560320922320875.4504)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Utente<br />database'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159561608504320876.4504)
,p_query_column_id=>4
,p_column_alias=>'SECONDS_IN_WAIT'
,p_column_display_sequence=>6
,p_column_heading=>'Secondi<br />nel<br />database'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159561806964320876.4504)
,p_query_column_id=>5
,p_column_alias=>'COMMAND'
,p_column_display_sequence=>5
,p_column_heading=>'Comando'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>3
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036034320536812.4504)
,p_query_column_id=>6
,p_column_alias=>'MACHINE'
,p_column_display_sequence=>7
,p_column_heading=>'Computer'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036153860536813.4504)
,p_query_column_id=>7
,p_column_alias=>'MACHINE2'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036203488536814.4504)
,p_query_column_id=>8
,p_column_alias=>'OSUSER'
,p_column_display_sequence=>9
,p_column_heading=>'Utente del sistema operativo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036357969536815.4504)
,p_query_column_id=>9
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036433316536816.4504)
,p_query_column_id=>10
,p_column_alias=>'MODULE'
,p_column_display_sequence=>11
,p_column_heading=>'Modulo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036592847536817.4504)
,p_query_column_id=>11
,p_column_alias=>'MODULE2'
,p_column_display_sequence=>12
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036642525536818.4504)
,p_query_column_id=>12
,p_column_alias=>'ACTION'
,p_column_display_sequence=>13
,p_column_heading=>'Azione'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036712262536819.4504)
,p_query_column_id=>13
,p_column_alias=>'ACTION2'
,p_column_display_sequence=>14
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036826358536820.4504)
,p_query_column_id=>14
,p_column_alias=>'RESOURCE_CONSUMER_GROUP'
,p_column_display_sequence=>15
,p_column_heading=>'Gruppo di consumer di risorse'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030036926884536821.4504)
,p_query_column_id=>15
,p_column_alias=>'CLIENT_INFO'
,p_column_display_sequence=>16
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1030037057648536822.4504)
,p_query_column_id=>16
,p_column_alias=>'CLIENT_IDENTIFIER'
,p_column_display_sequence=>17
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18811011728799476.4504)
,p_query_column_id=>17
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID istanza'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159573010728350258.4504)
,p_plug_name=>'Schede sessione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_api.id(159562414490322899.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159576332199356488.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(159580715492370509.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(159576332199356488.4504)
,p_button_name=>'P540_GO'
,p_button_static_id=>'P540_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159580928891370510.4504)
,p_branch_action=>'f?p=&FLOW_ID.:540:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159579603887366941.4504)
,p_name=>'P540_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(159576332199356488.4504)
,p_prompt=>'Cerca'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere i criteri per eseguire la ricerca nei seguenti campi, quindi fare clic su <strong>Vai</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Utente database</li>',
'<li>Computer</li>',
'<li>Utente del sistema operativo</li>',
'<li>Informazioni client</li>',
'<li>Identificativo del client</li>',
'<li>Modulo</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159602622343467194.4504)
,p_name=>'P540_ROWS'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_api.id(159576332199356488.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il numero di sessioni da visualizzare e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159860516070913064.4504)
,p_name=>'P540_COLUMNS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(159576332199356488.4504)
,p_item_default=>'MORE'
,p_prompt=>'Mostra'
,p_source=>'MORE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MORE_LESS_COLUMNS'
,p_lov=>'.'||wwv_flow_api.id(161595731562973452.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Effettuare una selezione per limitare o espandere il numero di colonne visualizzate e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159922305306032954.4504)
,p_name=>'P540_STATUS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(159576332199356488.4504)
,p_item_default=>'ACTIVE'
,p_prompt=>'Stato'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION MONITORING STATUS'
,p_lov=>'.'||wwv_flow_api.id(159923116388036162.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Limitare la visualizzazione selezionando uno stato e facendo clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(159928527517067731.4504)
,p_computation_sequence=>10
,p_computation_item=>'P540_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ACTIVE'
,p_compute_when=>'P540_STATUS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(166559913619454189.4504)
,p_computation_sequence=>10
,p_computation_item=>'P540_COLUMNS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'MORE'
,p_compute_when=>'P540_COLUMNS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(159606011177482895.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(159580715492370509.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166556909332443474.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set More / Less on other pages'
,p_process_sql_clob=>':P548_COLUMNS := nvl(:P540_COLUMNS,''MORE'');'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00541
begin
wwv_flow_api.create_page(
 p_id=>541.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Lock a livello di sessione'
,p_step_title=>'Lock'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160154029453569089.4504)
,p_plug_name=>'Schede sessione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_api.id(159562414490322899.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160154225031569089.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(201909305328005313.4504)
,p_name=>'Session Locks'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with locks as(',
'    select session_id,lock_type,',
'           mode_held,mode_requested,lock_id1,lock_id2,blocking_others',
'      from sys.dba_lock),',
'waiters as (',
'    select w.session_id waiting_session,',
'            h.session_id holding_session,',
'            w.lock_type lock_type,',
'            h.mode_held mode_held,',
'            w.mode_requested mode_requested,',
'            w.lock_id1,',
'            w.lock_id2',
'      from locks w, locks h',
'     where h.blocking_others =  ''Blocking''',
'      and  h.mode_held      !=  ''None''',
'      and  h.mode_held      !=  ''Null''',
'      and  w.mode_requested !=  ''None''',
'      and  w.lock_type       =  h.lock_type',
'      and  w.lock_id1        =  h.lock_id1',
'      and  w.lock_id2        =  h.lock_id2),',
'blockers as(',
'    select holding_session waiting_session, to_number(null) holding_session, ',
'           ''None'' lock_type, null mode_held, null mode_requested, ',
'           null lock_id1, null lock_id2',
'      from waiters',
'     minus',
'    select waiting_session waiting_session, to_number(null) holding_session, ',
'           ''None'' lock_type, null mode_held, null mode_requested, ',
'           null lock_id1, null lock_id2',
'      from waiters),',
'waiters_blockers as(',
'    select waiting_session,holding_session,lock_type,mode_held,mode_requested,lock_id1,lock_id2',
'      from waiters',
'     union all',
'    select waiting_session,holding_session,lock_type,mode_held,mode_requested,lock_id1,lock_id2',
'      from blockers),',
'lock_objects as(',
'    select session_id,cnt lock_obj_count,',
'           case when cnt = 1 then object_name',
'                else null end object_name,',
'           object_id,owner,object_type',
'      from(',
'        select session_id,count(distinct object_name) cnt,max(object_name) object_name,',
'               max(lo.object_id) object_id, max(ao.owner) owner,max(object_type) object_type',
'          from sys.gv_$locked_object lo,sys.dba_objects ao',
'         where lo.object_id = ao.object_id',
'         group by session_id)),',
'wait_block_ses as(',
'select waiting_session,holding_session,lock_type,mode_held,mode_requested,',
'       s.username,s.osuser,s.CLIENT_INFO,s.CLIENT_IDENTIFIER,o.object_name,o.owner,o.object_id,module,o.object_type,o.lock_obj_count,s.inst_id,',
'        decode(s.command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(s.command)) command',
'  from waiters_blockers wb, sys.gv_$session s,',
'       lock_objects o',
' where s.sid = wb.waiting_session',
'   and o.session_id(+) = wb.waiting_session',
'  ),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id)',
'select  case when holding_session is null then ''B'' ',
'             else ''D''',
'       end session_status,',
'       decode(level,1,1,power(level*3,2)) padding,level lvl,waiting_session,holding_session,',
'       username,osuser,CLIENT_INFO,CLIENT_IDENTIFIER,inst_id,',
'       case when lock_obj_count = 1 then',
'            case when owner in (select schema from ws_schemas) then',
'                ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||',
'                object_id||'',''||object_type||'',''||wwv_flow_escape.html(owner||''">''||object_name)||''</br>''',
'            else object_name end',
'        else ''<br />'' end object_name,     ',
'       object_id,owner,module,object_type',
'  from wait_block_ses ',
' start with holding_session is null',
' connect by prior waiting_session = holding_session'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun lock esistente'
,p_query_num_rows_item=>'P541_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1104686689608514408.4504)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato sessione'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201909801727005344.4504)
,p_query_column_id=>2
,p_column_alias=>'PADDING'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201909915384005344.4504)
,p_query_column_id=>3
,p_column_alias=>'LVL'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910003086005345.4504)
,p_query_column_id=>4
,p_column_alias=>'WAITING_SESSION'
,p_column_display_sequence=>4
,p_column_heading=>'SID'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#WAITING_SESSION#,#INST_ID#'
,p_column_linktext=>'#WAITING_SESSION#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910100459005345.4504)
,p_query_column_id=>5
,p_column_alias=>'HOLDING_SESSION'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910215980005346.4504)
,p_query_column_id=>6
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>7
,p_column_heading=>'Nome utente'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910317370005346.4504)
,p_query_column_id=>7
,p_column_alias=>'OSUSER'
,p_column_display_sequence=>8
,p_column_heading=>'Utente del sistema operativo'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910415010005346.4504)
,p_query_column_id=>8
,p_column_alias=>'CLIENT_INFO'
,p_column_display_sequence=>9
,p_column_heading=>'Informazioni client'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910509766005346.4504)
,p_query_column_id=>9
,p_column_alias=>'CLIENT_IDENTIFIER'
,p_column_display_sequence=>10
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(19584330054508562.4504)
,p_query_column_id=>10
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>5
,p_column_heading=>'ID istanza'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910617106005346.4504)
,p_query_column_id=>11
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>13
,p_column_heading=>'Nome oggetto'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910728257005346.4504)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>14
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910831228005346.4504)
,p_query_column_id=>13
,p_column_alias=>'OWNER'
,p_column_display_sequence=>12
,p_column_heading=>'Proprietario oggetto'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(201910926632005346.4504)
,p_query_column_id=>14
,p_column_alias=>'MODULE'
,p_column_display_sequence=>11
,p_column_heading=>'Modulo'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203542111299338200.4504)
,p_query_column_id=>15
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>15
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160155109735569098.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(160154225031569089.4504)
,p_button_name=>'P541_GO'
,p_button_static_id=>'P541_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(160156623684569105.4504)
,p_branch_action=>'f?p=&FLOW_ID.:541:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160155305071569098.4504)
,p_name=>'P541_ROWS'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_api.id(160154225031569089.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il numero di sessioni da visualizzare e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(160156419438569104.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_00542
begin
wwv_flow_api.create_page(
 p_id=>542.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'SQL sessione'
,p_step_title=>'SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(159946628564101172.4504)
,p_name=>'Sessions SQL'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid from sys.gv_$mystat where rownum = 1),',
'system_msg_prv as (',
'    select rownum, wwv_flow_lang.system_message(''SESSION_MON_PREVIOUS'') the_message from dual),',
'system_msg_cur as (',
'    select rownum,wwv_flow_lang.system_message(''SESSION_MON_CURRENT'') the_message from dual)',
' select case when (select sid from my_s where rownum = 1) = sid then  ',
'                  ''C'' ',
'             when status = ''ACTIVE'' then ',
'                  case when last_call_et > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status, sid,',
'        username,current_previous,inst_id,',
'        case when vs.status = ''ACTIVE'' ',
'                 then last_call_et ',
'             else null end seconds_in_wait,',
'        case when length(sql_text) > decode(:P542_COLUMNS,''LESS'',125,75)',
'             then substr(replace(sql_text,'','','', ''),1,decode(:P542_COLUMNS,''LESS'',125,75))||''...''',
'             else replace(sql_text,'','','', '') end sql_text,',
'             sql_text full_sql,address,hash_value,child_number,',
'             case when exists (select 1 cnt from sys.gv_$sql_plan p ',
'                         where p.address = vs.address ',
'                           and vs.hash_value = p.hash_value',
'                           and vs.child_number = p.child_number',
'                           and vs.inst_id = p.inst_id) ',
'                  then ''<a href="f?p=''||:APP_ID||'':551:''||:APP_SESSION||''::NO::P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER,P551_INST_ID:''||',
'                       vs.address||'',''||vs.hash_value||'',''||vs.child_number||'',''||vs.inst_id ||''">''||',
'                            wwv_flow_escape.html(',
'                            case when length(sql_text) > decode(:P542_COLUMNS,''LESS'',125,75)',
'                             then substr(replace(sql_text,'','','', ''),1,decode(:P542_COLUMNS,''LESS'',125,75))||''...''',
'                             else replace(sql_text,'','','', '')',
'                            end) ||',
'                       ''</a>''',
'                else wwv_flow_escape.html(',
'                     case when length(sql_text) > decode(:P542_COLUMNS,''LESS'',125,75)',
'                     then substr(replace(sql_text,'','','', ''),1,decode(:P542_COLUMNS,''LESS'',125,75))||''...''',
'                     else replace(sql_text,'','','', '')',
'                     end )',
'                end link1',
'   from   ',
'   (select s.sid,s.inst_id,s.status,s.last_call_et SECONDS_IN_WAIT,s.username,',
'                (select the_message from system_msg_cur where rownum = 1) current_previous,',
'                sql_text,fetches,executions,parse_calls,disk_reads,cpu_time,elapsed_time,',
'                q.address,q.hash_value,q.child_number,last_call_et',
'           from sys.gv_$session s, sys.gv_$sql q',
'          where s.sql_id is not null',
'            and s.inst_id = q.inst_id',
'            and s.sql_address = q.address',
'            and s.sql_hash_value = q.hash_value',
'            and s.USERNAME is not null',
'            and nvl(s.osuser,''x'') <> ''SYSTEM''',
'            and s.type <> ''BACKGROUND''',
'          union',
'         select s.sid,s.inst_id,s.status,s.last_call_et SECONDS_IN_WAIT,s.username,',
'                (select the_message from system_msg_prv where rownum = 1) current_previous,',
'                sql_text,fetches,executions,parse_calls,disk_reads,cpu_time,elapsed_time,',
'                q.address,q.hash_value,q.child_number,last_call_et',
'           from sys.gv_$session s, sys.gv_$sql q',
'          where s.sql_id is null',
'            and s.inst_id = q.inst_id',
'            and s.prev_sql_addr = q.address',
'            and s.prev_hash_value = q.hash_value',
'            and s.USERNAME is not null',
'            and nvl(s.osuser,''x'') <> ''SYSTEM''',
'            and s.type <> ''BACKGROUND'') vs',
'  where 1=1',
'    and (:P542_STATUS = ''ALL'' or (:P542_STATUS = ''ACTIVE'' and vs.status = ''ACTIVE''))',
'    and (:P542_SEARCH is null',
'        or',
'        (:P542_SEARCH is not null',
'         and',
'            (vs.username like ''%''||upper(:P542_SEARCH)||''%'' ',
'             or ',
'             upper(vs.sql_text) like ''%''||upper(:P542_SEARCH)||''%''',
'             or',
'             to_char(vs.sid) = :P542_SEARCH ',
'            )',
'         )',
'        )'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna sessione trovata'
,p_query_num_rows_item=>'P542_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1104686955361514411.4504)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato sessione'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159947413171101175.4504)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159947128376101174.4504)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Utente<br />database'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160121010032450640.4504)
,p_query_column_id=>4
,p_column_alias=>'CURRENT_PREVIOUS'
,p_column_display_sequence=>5
,p_column_heading=>'Corrente<br />Precedente'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18825904174327086.4504)
,p_query_column_id=>5
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID istanza'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160123809471459968.4504)
,p_query_column_id=>6
,p_column_alias=>'SECONDS_IN_WAIT'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159960931962162045.4504)
,p_query_column_id=>7
,p_column_alias=>'SQL_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'SQL'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#LINK1#'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162148513532035585.4504)
,p_query_column_id=>8
,p_column_alias=>'FULL_SQL'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160447305278223756.4504)
,p_query_column_id=>9
,p_column_alias=>'ADDRESS'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160447417088223757.4504)
,p_query_column_id=>10
,p_column_alias=>'HASH_VALUE'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160455710276386082.4504)
,p_query_column_id=>11
,p_column_alias=>'CHILD_NUMBER'
,p_column_display_sequence=>10
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166648819224335782.4504)
,p_query_column_id=>12
,p_column_alias=>'LINK1'
,p_column_display_sequence=>12
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159948329119101177.4504)
,p_plug_name=>'Schede sessione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_api.id(159562414490322899.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159948526162101178.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(159949431390101180.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(159948526162101178.4504)
,p_button_name=>'P542_GO'
,p_button_static_id=>'P542_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159950911378101184.4504)
,p_branch_action=>'f?p=&FLOW_ID.:542:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159948921511101179.4504)
,p_name=>'P542_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(159948526162101178.4504)
,p_prompt=>'Cerca'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere i criteri per eseguire la ricerca nei seguenti campi, quindi fare clic su <strong>Vai</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Utente database</li>',
'<li>SQL</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159949601014101181.4504)
,p_name=>'P542_ROWS'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_api.id(159948526162101178.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il numero di sessioni da visualizzare e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159950109461101182.4504)
,p_name=>'P542_COLUMNS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(159948526162101178.4504)
,p_item_default=>'MORE'
,p_prompt=>'Mostra'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MORE_LESS_COLUMNS'
,p_lov=>'.'||wwv_flow_api.id(161595731562973452.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Effettuare una selezione per limitare o espandere il numero di colonne visualizzate e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159950311811101182.4504)
,p_name=>'P542_STATUS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(159948526162101178.4504)
,p_item_default=>'ALL'
,p_prompt=>'Stato'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION MONITORING STATUS'
,p_lov=>'.'||wwv_flow_api.id(159923116388036162.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Limitare la visualizzazione selezionando uno stato e facendo clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(159950521007101183.4504)
,p_computation_sequence=>10
,p_computation_item=>'P542_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ALL'
,p_compute_when=>'P542_STATUS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(159950714928101184.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_00543
begin
wwv_flow_api.create_page(
 p_id=>543.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Cursori aperti'
,p_step_title=>'Cursori aperti'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(160210418551732438.4504)
,p_name=>'Open Cursors'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid from sys.gv_$mystat where rownum = 1), ',
'vs as (select * from sys.gv_$session),',
'oc as (select sid, inst_id, count(*) open_cursors from sys.gv_$open_cursor group by sid, inst_id)',
' select case when (select sid from my_s where rownum = 1) = vs.sid then  ',
'                  ''C'' ',
'             when vs.status = ''ACTIVE'' then ',
'                  case when last_call_et > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  vs.status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status, ',
'        vs.sid, oc.open_cursors, vs.username, vs.inst_id',
'   from vs, oc',
'  where vs.sid = oc.sid',
'    and vs.inst_id = oc.inst_id',
'    and vs.USERNAME > ''!''',
'    and nvl(vs.osuser,''x'') <> ''SYSTEM''',
'    and vs.type <> ''BACKGROUND''',
'    and (:P543_STATUS = ''ALL'' or (:P543_STATUS = ''ACTIVE'' and vs.status = ''ACTIVE''))',
'    and (:P543_SEARCH is null',
'        or',
'        (:P543_SEARCH is not null',
'         and',
'            (vs.username like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.osuser) like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.terminal) like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.module) like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.client_info) like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.sid) like ''%''||upper(:P543_SEARCH)||''%'' ',
'            )',
'         )',
'        )'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna sessione trovata'
,p_query_num_rows_item=>'P543_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1104687056530514412.4504)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato sessione'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160211228557732440.4504)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160218014225754630.4504)
,p_query_column_id=>3
,p_column_alias=>'OPEN_CURSORS'
,p_column_display_sequence=>5
,p_column_heading=>'Conteggio cursori aperti'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.::P546_SID,P546_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#OPEN_CURSORS#'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160222612278763591.4504)
,p_query_column_id=>4
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Utente<br />database'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18826220020350671.4504)
,p_query_column_id=>5
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID istanza'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160212118897732441.4504)
,p_plug_name=>'Schede sessione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_api.id(159562414490322899.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160212320118732442.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160213205206732444.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(160212320118732442.4504)
,p_button_name=>'P543_GO'
,p_button_static_id=>'P543_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(160214724459732449.4504)
,p_branch_action=>'f?p=&FLOW_ID.:543:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160212712536732443.4504)
,p_name=>'P543_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(160212320118732442.4504)
,p_prompt=>'Cerca'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere i criteri per eseguire la ricerca nei seguenti campi, quindi fare clic su <strong>Vai</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Utente database</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160213409142732444.4504)
,p_name=>'P543_ROWS'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_api.id(160212320118732442.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il numero di sessioni da visualizzare e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160214104600732447.4504)
,p_name=>'P543_STATUS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(160212320118732442.4504)
,p_item_default=>'ALL'
,p_prompt=>'Stato'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION MONITORING STATUS'
,p_lov=>'.'||wwv_flow_api.id(159923116388036162.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Limitare i risultati selezionando uno stato e facendo clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(160214330133732448.4504)
,p_computation_sequence=>10
,p_computation_item=>'P543_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ALL'
,p_compute_when=>'P543_STATUS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(160214523933732449.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_00545
begin
wwv_flow_api.create_page(
 p_id=>545.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'I/O sessione'
,p_step_title=>'I/O'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(159844815240842239.4504)
,p_name=>'Query I/O sessione'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid from sys.gv_$mystat where rownum = 1), ',
'vs as (select *  ',
'          from sys.gv_$session),',
'io_s as (select sid, block_gets, consistent_gets, physical_reads, block_changes, consistent_changes, inst_id ',
'   from sys.gv_$sess_io) ',
' select case when (select sid from my_s where rownum = 1) = vs.sid then  ',
'                  ''C'' ',
'             when vs.status = ''ACTIVE'' then ',
'                  case when last_call_et > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  vs.status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status, vs.sid,',
'        vs.username,',
'        vs.inst_id,',
'        case when vs.status = ''ACTIVE'' ',
'                  then last_call_et ',
'             else null end seconds_in_wait,',
'        decode(vs.command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(vs.command)) command,',
'        block_gets, consistent_gets, physical_reads, block_changes, consistent_changes',
'   from vs,io_s',
'  where io_s.sid = vs.sid',
'    and io_s.inst_id = vs.inst_id',
'    and vs.USERNAME > ''!''',
'    and nvl(vs.osuser,''x'') <> ''SYSTEM''',
'    and vs.type <> ''BACKGROUND''',
'    and (:P545_SEARCH is null',
'        or',
'        (:P545_SEARCH is not null',
'         and',
'            (vs.username like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.osuser) like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.terminal) like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.module) like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.client_info) like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.sid) like ''%''||upper(:P545_SEARCH)||''%'' ',
'            )',
'         )',
'        )'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna sessione trovata'
,p_query_num_rows_item=>'P545_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1104686827477514410.4504)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato sessione'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159845300132842243.4504)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159845031154842242.4504)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Utente<br />database'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18825706336308831.4504)
,p_query_column_id=>4
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID istanza'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159846007799842244.4504)
,p_query_column_id=>5
,p_column_alias=>'SECONDS_IN_WAIT'
,p_column_display_sequence=>6
,p_column_heading=>'Quando'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159846114062842244.4504)
,p_query_column_id=>6
,p_column_alias=>'COMMAND'
,p_column_display_sequence=>5
,p_column_heading=>'Comando'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159852724634858715.4504)
,p_query_column_id=>7
,p_column_alias=>'BLOCK_GETS'
,p_column_display_sequence=>7
,p_column_heading=>'Richieste su<br />blocchi'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159852830699858716.4504)
,p_query_column_id=>8
,p_column_alias=>'CONSISTENT_GETS'
,p_column_display_sequence=>8
,p_column_heading=>'Richieste<br />congruenti'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159852903559858716.4504)
,p_query_column_id=>9
,p_column_alias=>'PHYSICAL_READS'
,p_column_display_sequence=>9
,p_column_heading=>'Letture<br />fisiche'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159853004646858716.4504)
,p_query_column_id=>10
,p_column_alias=>'BLOCK_CHANGES'
,p_column_display_sequence=>10
,p_column_heading=>'Modifiche ai<br />blocchi'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159853108630858716.4504)
,p_query_column_id=>11
,p_column_alias=>'CONSISTENT_CHANGES'
,p_column_display_sequence=>11
,p_column_heading=>'Modifiche<br />coerenti'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159846228937842244.4504)
,p_plug_name=>'Schede sessione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(159562414490322899.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159846414980842244.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(159847321329842249.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(159846414980842244.4504)
,p_button_name=>'P545_GO'
,p_button_static_id=>'P545_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159848225788842251.4504)
,p_branch_action=>'f?p=&FLOW_ID.:545:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159846809948842246.4504)
,p_name=>'P545_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(159846414980842244.4504)
,p_prompt=>'Cerca'
,p_post_element_text=>'&nbsp;&nbsp;'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere i criteri per eseguire la ricerca nei seguenti campi, quindi fare clic su <strong>Vai</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Utente database</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159847504928842249.4504)
,p_name=>'P545_ROWS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(159846414980842244.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il numero di sessioni da visualizzare e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(159848001527842250.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_00546
begin
wwv_flow_api.create_page(
 p_id=>546.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dettagli cursore'
,p_step_title=>'Dettagli cursore'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(160520708337520904.4504)
,p_name=>'Open Cursors'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(SQL_TEXT,chr(0)) sql_text, sid,',
'       replace(case when exists (select 1 cnt from sys.gv_$sql_plan p ',
'                         where p.address = oc.address ',
'                           and oc.hash_value = p.hash_value',
'                            and oc.inst_id = p.inst_id) ',
'                  then ''<a href="f?p=''||:APP_ID||'':551:''||:APP_SESSION||''::NO::P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER,P551_INST_ID:''||',
'                       oc.address||'',''||oc.hash_value||'',''||0||'',''||oc.inst_id ||''">''||',
'                            sql_text || ''</a>'' ',
'                else ',
'                     sql_text',
'                end,chr(0)) link1',
'  from sys.gv_$open_cursor oc',
' where sid = :P546_SID',
'   and inst_id = :P546_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Cursori aperti'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun cursore aperto'
,p_query_num_rows_item=>'P546_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160520904823520911.4504)
,p_query_column_id=>1
,p_column_alias=>'SQL_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Testo SQL'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#LINK1#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160557302599680183.4504)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>1
,p_column_heading=>'SID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(167341501879504078.4504)
,p_query_column_id=>3
,p_column_alias=>'LINK1'
,p_column_display_sequence=>3
,p_column_heading=>'Link1'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160541914280626775.4504)
,p_plug_name=>'Session Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_api.id(159562414490322899.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160559422338685883.4504)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160546329779650138.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(160559422338685883.4504)
,p_button_name=>'P546_GO'
,p_button_static_id=>'P546_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(160546521102650140.4504)
,p_branch_action=>'f?p=&FLOW_ID.:546:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19590430887594024.4504)
,p_name=>'P546_INST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(160559422338685883.4504)
,p_prompt=>'ID istanza'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>38
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160521713878522509.4504)
,p_name=>'P546_SID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(160559422338685883.4504)
,p_prompt=>'SID'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sid d, sid r',
'from sys.gv_$session',
'order by sid'))
,p_cSize=>10
,p_cMaxlength=>38
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160522719072524094.4504)
,p_name=>'P546_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(160559422338685883.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Selezionare il numero massimo di righe da visualizzare nei report che restituiscono pi\00F9 righe e fare clic su <strong>Vai</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00548
begin
wwv_flow_api.create_page(
 p_id=>548.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Eventi di attesa'
,p_step_title=>'Attese'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'table.waitsColumn{border:0px;}',
'table.waitsColumn th{background:#efefef;border:0px;padding:0px 5px 0px 0px;text-align:right;}',
'table.waitsColumn td{border:0px;padding:1px;white-space:nowrap;font-weight:bold;}',
'table.waitsColumn td.l{text-align:right;font-weight:normal;padding-right:5px;}'))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(164313818540444573.4504)
,p_name=>'Eventi di attesa'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid from sys.gv_$mystat where rownum = 1),',
'wait_obj as (select s1.sid,d1.owner||''.''||d1.object_name obj_name,s1.row_wait_obj#,d1.object_id,d1.data_object_id,d1.object_name,d1.owner object_owner,',
'                    d1.object_type',
'               from sys.gv_$session s1,sys.dba_objects d1',
'              where s1.row_wait_obj# = d1.object_id',
'                and s1.wait_time = 0',
'                and s1.wait_class != ''Idle''),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id)',
'select case when (select sid from my_s where rownum = 1) = s.sid then  ',
'                  ''C'' ',
'             when s.status = ''ACTIVE'' then ',
'                  case when sw.seconds_in_wait > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  s.status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status,',
'       s.sid,s.username,sw.event, decode(sw.wait_time,0,''W'',''C'') waiting,',
'       sw.wait_time, sw.state,sw.seconds_in_wait,s.status,s.module,s.client_info,',
'       case when o.object_type in (''TABLE'',''VIEW'',''INDEX'',''MATERIALIZED VIEW'') then',
'            case when o.object_owner in  (select schema from ws_schemas)',
'                 then ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||o.object_id||'',''||o.object_type||'',''||wwv_flow_escape.html(o.object_owner)||''"''||wwv_flow_escape.html(o.object_name)||''</a>'' ',
'                 else wwv_flow_escape.html(o.object_name) end',
'            else wwv_flow_escape.html(object_name) end object_name,',
'       sw.p1text,sw.p1,sw.p2text,sw.p2,sw.p3text,sw.p3,sw.wait_class,',
'       s.inst_id,',
'       null dummy',
'  from sys.gv_$session s, sys.gv_$session_wait sw, wait_obj o',
' where s.sid = sw.sid',
'   and s.inst_id = sw.inst_id',
'   and s.sid = o.sid(+)',
'   and s.username is not null',
'   and nvl(s.osuser,''x'') <> ''SYSTEM''',
'   and s.type <> ''BACKGROUND''',
'   and (:P548_ACTIVE = ''ALL'' or s.status = ''ACTIVE'')',
'   and (:P548_SEARCH is null',
'        or',
'        (:P548_SEARCH is not null',
'         and',
'            (s.username like ''%''||upper(:P548_SEARCH)||''%'' ',
'             or ',
'             upper(s.module) like ''%''||upper(:P548_SEARCH)||''%'' ',
'             or ',
'             upper(s.client_info) like ''%''||upper(:P548_SEARCH)||''%''              ',
'             or',
'             to_char(s.sid) = :P548_SEARCH',
'            )',
'         )',
'    )'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna sessione trovata'
,p_query_num_rows_item=>'P548_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1104686783117514409.4504)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato sessione'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164384110089229671.4504)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164460107102588343.4504)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Utente<br />database'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164370221208185538.4504)
,p_query_column_id=>4
,p_column_alias=>'EVENT'
,p_column_display_sequence=>7
,p_column_heading=>'Evento'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164422311455428749.4504)
,p_query_column_id=>5
,p_column_alias=>'WAITING'
,p_column_display_sequence=>10
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164370332690185539.4504)
,p_query_column_id=>6
,p_column_alias=>'WAIT_TIME'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164422432492428749.4504)
,p_query_column_id=>7
,p_column_alias=>'STATE'
,p_column_display_sequence=>11
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164422531764428749.4504)
,p_query_column_id=>8
,p_column_alias=>'SECONDS_IN_WAIT'
,p_column_display_sequence=>12
,p_column_heading=>'Secondi in<br />attesa'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164454816752562796.4504)
,p_query_column_id=>9
,p_column_alias=>'STATUS'
,p_column_display_sequence=>13
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164463730005623312.4504)
,p_query_column_id=>10
,p_column_alias=>'MODULE'
,p_column_display_sequence=>5
,p_column_heading=>'Modulo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164463806034623313.4504)
,p_query_column_id=>11
,p_column_alias=>'CLIENT_INFO'
,p_column_display_sequence=>6
,p_column_heading=>'Informazioni<br />client'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(165416519153630756.4504)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>9
,p_column_heading=>'Nome oggetto'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166531312861274156.4504)
,p_query_column_id=>13
,p_column_alias=>'P1TEXT'
,p_column_display_sequence=>15
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166531414063274158.4504)
,p_query_column_id=>14
,p_column_alias=>'P1'
,p_column_display_sequence=>16
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166531511344274158.4504)
,p_query_column_id=>15
,p_column_alias=>'P2TEXT'
,p_column_display_sequence=>17
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166531612947274158.4504)
,p_query_column_id=>16
,p_column_alias=>'P2'
,p_column_display_sequence=>18
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166531721019274158.4504)
,p_query_column_id=>17
,p_column_alias=>'P3TEXT'
,p_column_display_sequence=>19
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166531814344274158.4504)
,p_query_column_id=>18
,p_column_alias=>'P3'
,p_column_display_sequence=>20
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166531908149274158.4504)
,p_query_column_id=>19
,p_column_alias=>'WAIT_CLASS'
,p_column_display_sequence=>14
,p_column_heading=>'Classe di attesa'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18825404689289422.4504)
,p_query_column_id=>20
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID istanza'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(167166504668306104.4504)
,p_query_column_id=>21
,p_column_alias=>'DUMMY'
,p_column_display_sequence=>21
,p_column_heading=>'P1...P3'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" class="waitsColumn">',
'<tr><th>#P1TEXT#</th><td>#P1#</td></tr>',
'<tr><th>#P2TEXT#</th><td>#P2#</td></tr>',
'<tr><th>#P3TEXT#</th><td>#P3#</td></tr>',
'</table>'))
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164315004796444581.4504)
,p_plug_name=>'Schede sessione'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(159562414490322899.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164315227809444581.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164316110214444589.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(164315227809444581.4504)
,p_button_name=>'P548_GO'
,p_button_static_id=>'P548_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164317018261444596.4504)
,p_branch_action=>'f?p=&FLOW_ID.:548:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164315604152444584.4504)
,p_name=>'P548_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(164315227809444581.4504)
,p_prompt=>'Cerca'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Immettere i criteri per eseguire la ricerca nei seguenti campi, quindi fare clic su <strong>Vai</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Utente database</li>',
'<li>Modulo</li>',
'<li>Informazioni client</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164316311493444590.4504)
,p_name=>'P548_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(164315227809444581.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Selezionare il numero di sessioni da visualizzare e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164457018961572885.4504)
,p_name=>'P548_ACTIVE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(164315227809444581.4504)
,p_item_default=>'ACTIVE'
,p_prompt=>'Stato'
,p_source=>'ACTIVE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION MONITORING STATUS'
,p_lov=>'.'||wwv_flow_api.id(159923116388036162.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Limitare la visualizzazione selezionando uno stato e facendo clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(166537804727309695.4504)
,p_name=>'P548_COLUMNS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(164315227809444581.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'MORE'
,p_prompt=>'Mostra'
,p_source=>'P540_COLUMNS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MORE_LESS_COLUMNS'
,p_lov=>'.'||wwv_flow_api.id(161595731562973452.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Effettuare una selezione per limitare o espandere il numero di colonne visualizzate e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(166540127237316127.4504)
,p_computation_sequence=>10
,p_computation_item=>'P540_COLUMNS'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P548_COLUMNS'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164316814785444594.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_00549
begin
wwv_flow_api.create_page(
 p_id=>549.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Termina sessione'
,p_step_title=>'Termina sessione'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159831314115768578.4504)
,p_plug_name=>'Termina sessione'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>'Fare clic sul pulsante <strong>Termina sessione</strong> per terminare la sessione.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969056127360554648.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(159831513762768579.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(969056127360554648.4504)
,p_button_name=>'KILL_SESSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Termina sessione'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(159831703365768580.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(969056127360554648.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159832109455768585.4504)
,p_branch_action=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160141018353528779.4504)
,p_name=>'P549_SID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(159831314115768578.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'SID:'
,p_source=>'P550_SID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(159831911140768584.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Kill Session'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_serial  number;',
'begin',
'    for c1 in (select serial#',
'                 from sys.gv_$session',
'                where sid = :P550_SID',
'                  and inst_id = :P550_INST_ID) loop',
'       l_serial := c1.serial#;',
'       exit;',
'    end loop;',
'',
'    wwv_flow_dynamic_exec.kill_session( p_sid => :P550_SID, p_inst_id => :P550_INST_ID, p_serial# => l_serial );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(159831513762768579.4504)
,p_process_success_message=>'Sessione terminata'
);
end;
/
prompt --application/pages/page_00550
begin
wwv_flow_api.create_page(
 p_id=>550.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dettagli sessioni'
,p_step_title=>'Dettagli sessioni'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'',
'table.htmldbRR{width:97%;margin:0px 5px 0px 5px 0px;vertical-align:top;}',
'',
'table.htmldbSessionLayout td table td{vertical-align:top; }',
'',
'table.htmldbRptRowNoBack td{font-size:8pt;padding:1px 3px;}',
'   table.htmldbRptRowNoBack td.p{text-align:right;color:#3F8640;font-weight:bold;border-right: 1px #efefef solid;width:220px;}',
'   ',
'<!-- delete the following classes once in CSS -->',
'   table.htmldbRptNoBackground th,table.htmldbRptNoBackground td{font-size:8pt;padding:1px 3px;}',
'   table.htmldbRptNoBackground th{text-align:center;color:#3F8640;font-weight:bold;padding:1px 3px;}',
'',
'</style>',
''))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(159696707442087376.4504)
,p_name=>'Server (sessione database)'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.SID,s.inst_id,s.status,s.username,s.process,s.LOGON_TIME,',
'       s.logon_time since,s.server,s.type,p.spid,p.TRACEID,',
'       s.serial#',
'  from sys.gv_$session s, sys.gv_$process p',
' where sid = :P550_SID',
'   and s.paddr = p.addr',
'   and s.inst_id = p.inst_id',
'   and s.inst_id = :P550_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Server'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340556612002171029.4504)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Sessione non trovata'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159703726236149506.4504)
,p_query_column_id=>1
,p_column_alias=>'SID'
,p_column_display_sequence=>1
,p_column_heading=>'SID'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18815227059860661.4504)
,p_query_column_id=>2
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID istanza'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159703820066149507.4504)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>4
,p_column_heading=>'Stato'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159703914106149507.4504)
,p_query_column_id=>4
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nome utente'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159704000699149508.4504)
,p_query_column_id=>5
,p_column_alias=>'PROCESS'
,p_column_display_sequence=>6
,p_column_heading=>'Process'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159704116355149508.4504)
,p_query_column_id=>6
,p_column_alias=>'LOGON_TIME'
,p_column_display_sequence=>7
,p_column_heading=>'Logon Time'
,p_column_format=>'&LONG_DATE_FORMAT. HH24:MI:SS'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159704217897149508.4504)
,p_query_column_id=>7
,p_column_alias=>'SINCE'
,p_column_display_sequence=>8
,p_column_heading=>'Tempo di collegamento'
,p_column_format=>'SINCE'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159704300579149508.4504)
,p_query_column_id=>8
,p_column_alias=>'SERVER'
,p_column_display_sequence=>9
,p_column_heading=>'Server'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159704409056149508.4504)
,p_query_column_id=>9
,p_column_alias=>'TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Tipo'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161291615728275134.4504)
,p_query_column_id=>10
,p_column_alias=>'SPID'
,p_column_display_sequence=>11
,p_column_heading=>'ID processo del sistema operativo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161291709916275134.4504)
,p_query_column_id=>11
,p_column_alias=>'TRACEID'
,p_column_display_sequence=>12
,p_column_heading=>'Traceid'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189491201917669777.4504)
,p_query_column_id=>12
,p_column_alias=>'SERIAL#'
,p_column_display_sequence=>2
,p_column_heading=>'Numero di serie'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(159727213057344478.4504)
,p_name=>'Client'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select osuser,machine,terminal,CLIENT_INFO,CLIENT_IDENTIFIER',
'  from sys.gv_$session',
' where sid = :P550_SID',
'   and inst_id = :P550_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Client'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340556612002171029.4504)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Sessione non trovata'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(159727213057344478.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159727525728344482.4504)
,p_query_column_id=>1
,p_column_alias=>'OSUSER'
,p_column_display_sequence=>1
,p_column_heading=>'Utente del sistema operativo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159727629047344482.4504)
,p_query_column_id=>2
,p_column_alias=>'MACHINE'
,p_column_display_sequence=>2
,p_column_heading=>'Computer'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159727722017344482.4504)
,p_query_column_id=>3
,p_column_alias=>'TERMINAL'
,p_column_display_sequence=>3
,p_column_heading=>'Terminale'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159727830806344483.4504)
,p_query_column_id=>4
,p_column_alias=>'CLIENT_INFO'
,p_column_display_sequence=>4
,p_column_heading=>'Informazioni client'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159727918652344483.4504)
,p_query_column_id=>5
,p_column_alias=>'CLIENT_IDENTIFIER'
,p_column_display_sequence=>5
,p_column_heading=>'Identificativo del client'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(159732903885379685.4504)
,p_name=>'Applicazione'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(command)) command,LAST_CALL_ET,program,module,action',
'-- need open_cursors, current_sql, previous_sql, trace, program service?',
'  from sys.gv_$session',
' where sid = :P550_SID',
'   and inst_id = :P550_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Applicazione'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340556612002171029.4504)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Sessione non trovata'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(159732903885379685.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159733215352379691.4504)
,p_query_column_id=>1
,p_column_alias=>'COMMAND'
,p_column_display_sequence=>1
,p_column_heading=>'Comando'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159733315050379692.4504)
,p_query_column_id=>2
,p_column_alias=>'LAST_CALL_ET'
,p_column_display_sequence=>2
,p_column_heading=>'Tempo trascorso ultima chiamata'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159733413526379692.4504)
,p_query_column_id=>3
,p_column_alias=>'PROGRAM'
,p_column_display_sequence=>3
,p_column_heading=>'Programma'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159733514417379692.4504)
,p_query_column_id=>4
,p_column_alias=>'MODULE'
,p_column_display_sequence=>4
,p_column_heading=>'Modulo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159733626539379692.4504)
,p_query_column_id=>5
,p_column_alias=>'ACTION'
,p_column_display_sequence=>5
,p_column_heading=>'Azione'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159760820526535896.4504)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160531823621553788.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c pls_integer := 0;',
'  ',
'begin',
'for c1 in (select rawtohex(SQL_ADDRESS) sql_address,SQL_HASH_VALUE,SQL_CHILD_NUMBER,inst_id',
'            from sys.gv_$session s           ',
'           where s.sid = :P550_SID',
'             and s.inst_id = :P550_INST_ID',
'             and exists (select 1 ',
'                           from sys.gv_$sql_plan p',
'                          where s.SQL_ADDRESS = p.address',
'                            and s.SQL_HASH_VALUE = p.hash_value',
'                            and s.SQL_CHILD_NUMBER = p.child_number',
'                            and s.inst_id = p.inst_id)',
'          )',
'loop',
'    sys.htp.p(''<a href="f?p=&APP_ID.:551:''||',
'      :APP_SESSION||',
'      ''::::P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER,P551_INST_ID:''||',
'      c1.SQL_ADDRESS||'',''||c1.SQL_HASH_VALUE||'',''||',
'      c1.SQL_CHILD_NUMBER||'',''||c1.inst_id||''">''||',
'      wwv_flow_lang.system_message(''Explain Plan'')||''</a>'');',
'    exit;',
'end loop;',
'',
'',
'for c1 in(select replace(q.sql_fulltext,chr(0)) sql_text',
'            from sys.gv_$session s, sys.gv_$sql q',
'           where s.sql_address = q.address',
'             and s.sql_hash_value = q.hash_value',
'             and s.SQL_CHILD_NUMBER = q.child_number',
'             and s.inst_id = q.inst_id',
'             and s.inst_id = :P550_INST_ID',
'             and s.sid = :P550_SID)',
'loop',
'    c := c+ 1;',
'    sys.htp.prn(''<div class="u-fixedFont" style="white-space: pre-wrap">'');',
'    sys.htp.prn(replace(wwv_flow_escape.html(c1.sql_text),chr(10),''<br />''));',
'    sys.htp.prn(''</div>'');',
'',
'end loop;',
'',
'',
'if c = 0 then',
'    sys.htp.prn(''<span class="fieldData">''||wwv_flow_lang.system_message(''SQL not available'')||''</span>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_comment=>'10g+ Version'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(161382425489157968.4504)
,p_name=>'Conflitto (lock)'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with locks as(',
'    select session_id,lock_type,',
'           mode_held,mode_requested,lock_id1,lock_id2,blocking_others',
'      from sys.dba_lock),',
'waiters as (',
'    select w.session_id waiting_session,',
'            h.session_id holding_session,',
'            w.lock_type lock_type,',
'            h.mode_held mode_held,',
'            w.mode_requested mode_requested,',
'            w.lock_id1,',
'            w.lock_id2',
'      from locks w, locks h',
'     where h.blocking_others =  ''Blocking''',
'      and  h.mode_held      !=  ''None''',
'      and  h.mode_held      !=  ''Null''',
'      and  w.mode_requested !=  ''None''',
'      and  w.lock_type       =  h.lock_type',
'      and  w.lock_id1        =  h.lock_id1',
'      and  w.lock_id2        =  h.lock_id2',
'      and  (w.session_id = :P550_SID',
'            or',
'            h.session_id = :P550_SID)),',
'blockers as(',
'    select holding_session waiting_session, to_number(null) holding_session, ',
'           ''None'' lock_type, null mode_held, null mode_requested, ',
'           null lock_id1, null lock_id2',
'      from waiters',
'     minus',
'    select waiting_session waiting_session, to_number(null) holding_session, ',
'           ''None'' lock_type, null mode_held, null mode_requested, ',
'           null lock_id1, null lock_id2',
'      from waiters),',
'waiters_blockers as(',
'    select waiting_session,holding_session,lock_type,mode_held,mode_requested,lock_id1,lock_id2',
'      from waiters',
'     union all',
'    select waiting_session,holding_session,lock_type,mode_held,mode_requested,lock_id1,lock_id2',
'      from blockers),',
'lock_objects as(',
'    select session_id,cnt lock_obj_count, inst_id,',
'           case when cnt = 1 then object_name',
'                else null end object_name,',
'           object_id,owner,object_type',
'      from(',
'        select session_id,inst_id,count(distinct object_name) cnt,max(object_name) object_name,',
'               max(lo.object_id) object_id, max(ao.owner) owner,max(object_type) object_type',
'          from sys.gv_$locked_object lo,sys.dba_objects ao,waiters_blockers wb',
'         where lo.object_id = ao.object_id',
'           and (wb.waiting_session = lo.session_id',
'                or',
'                wb.holding_session = lo.session_id)',
'         group by session_id, inst_id)),',
'wait_block_ses as(',
'select waiting_session,holding_session,lock_type,mode_held,mode_requested,',
'       s.username,s.osuser,s.CLIENT_INFO,s.CLIENT_IDENTIFIER,o.object_name,o.owner,o.object_id,module,o.object_type,o.lock_obj_count,',
'        decode(s.command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(s.command)) command',
'  from waiters_blockers wb, sys.gv_$session s,',
'       lock_objects o',
' where s.sid = wb.waiting_session',
'   and s.inst_id = :P550_INST_ID',
'   and o.session_id(+) = wb.waiting_session',
'   and o.inst_id = s.inst_id',
'  ),',
'ws_schemas as(',
'select schema ',
'  from wwv_flow_company_schemas',
' where security_group_id = :flow_security_group_id)',
'select  case when holding_session is null then ''<img src="#IMAGE_PREFIX#htmldb/sessions/locks.gif" />'' ',
'             else ''<span style="padding-left:''||power(2*level,2)||''px;"''||',
'                           ''><img src="#IMAGE_PREFIX#htmldb/sessions/lock_wait.gif" /></span>''',
'       end status_icon,',
'       waiting_session,',
'       username,',
'       case when lock_obj_count = 1 then',
'            case when owner in (select schema from ws_schemas) then',
'                ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||',
'                object_id||'',''||object_type||'',''||wwv_flow_escape.html(owner||''">''||object_name)||''</br>''',
'            else wwv_flow_escape.html(object_name) end',
'        else ''<br />'' end object_name,      ',
'       object_id,owner,object_type',
'  from wait_block_ses ',
' start with holding_session is null',
' connect by prior waiting_session =  holding_session'))
,p_customized=>'1'
,p_customized_name=>'Conflitto'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun lock trovato'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(161382425489157968.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161383523003157982.4504)
,p_query_column_id=>1
,p_column_alias=>'STATUS_ICON'
,p_column_display_sequence=>1
,p_column_heading=>'Stato'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203555320793420208.4504)
,p_query_column_id=>2
,p_column_alias=>'WAITING_SESSION'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161383009895157982.4504)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome utente'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161383120215157982.4504)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Oggetto'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203555805807420209.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203555930087420209.4504)
,p_query_column_id=>6
,p_column_alias=>'OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Owner'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203556123615420209.4504)
,p_query_column_id=>7
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Object Type'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(161388000911226566.4504)
,p_name=>'Attese'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select event,p1,p2,',
'       case when p3 = 0 then null else p3 end p3',
'  from sys.gv_$session_wait',
' where sid = :P550_SID',
'   and inst_id = :P550_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Attese'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340556612002171029.4504)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    x   varchar2(32767);',
'begin',
'    for c1 in (select p1text,p2text,p3text,p3',
'                 from sys.gv_$session_wait',
'                where sid = :P550_SID',
'                  and inst_id = :P550_INST_ID',
'                  and rownum = 1)',
'    loop',
'        x := wwv_flow_lang.system_message(''4500_SESS_EVENT'')||'':''||c1.p1text||'':''||c1.p2text;',
'        ',
'        if c1.p3 > 0 then',
'            x:=x||'':''||c1.p3text;',
'        end if;',
'        ',
'    end loop;',
'    ',
'    return x;',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(161388000911226566.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161388322508226572.4504)
,p_query_column_id=>1
,p_column_alias=>'EVENT'
,p_column_display_sequence=>1
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161388510769226572.4504)
,p_query_column_id=>2
,p_column_alias=>'P1'
,p_column_display_sequence=>2
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161388719388226572.4504)
,p_query_column_id=>3
,p_column_alias=>'P2'
,p_column_display_sequence=>3
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(180105911818180025.4504)
,p_query_column_id=>4
,p_column_alias=>'P3'
,p_column_display_sequence=>4
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(174749827669973447.4504)
,p_name=>'Statistiche sul tempo (secondi)'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,(C003/100) C003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''TIME''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174750102002973464.4504)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174750209294973464.4504)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_column_format=>'999G999G999G999G990D0'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(174760416334026933.4504)
,p_name=>'Statistiche cursore SQL'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,to_number(C003) c003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''SQL_CURSOR''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(174760416334026933.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174760715110026936.4504)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174760617695026935.4504)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(174763401012041476.4504)
,p_name=>'Statistiche di I/O logici'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,',
'       case when c002 = ''redo size'' ',
'            then case when to_Number(C003) > 104857 ',
'                 then to_char(to_Number(C003)/1024/1024,''999G999G999999G999G999G990D0'')||'' ''',
'                   || wwv_flow_lang.system_message(''4500_SESS_MEGABYTES'')',
'            else to_char(to_Number(C003)/1024,''999G999G999999G999G999G990D0'') ||'' ''',
'              ||wwv_flow_lang.system_message(''4500_SESS_KILOBYTES'') end',
'       else to_char(to_number(C003),''999G999G999999G999G999G990'') end c003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''LOGICAL_IO''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
end;
/
begin
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(174763401012041476.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174763715768041478.4504)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174763619193041477.4504)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(174764715211045565.4504)
,p_name=>'Statistiche di I/O fisici'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,',
'       to_number(C003) c003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''PHYSICAL_IO''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(181122418053358449.4504)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'C002'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(181122525668358449.4504)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'C003'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(174766225039057809.4504)
,p_name=>'Statistiche delle transazioni'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,C003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''TRANSACTION''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174766526003057812.4504)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174766416592057812.4504)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(174767004045061216.4504)
,p_name=>'Statistiche di memoria'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,',
'       case when C002 in (''session uga memory'',''session pga memory'')',
'            then ',
'            case when to_Number(C003) > 104857 ',
'                 then to_char(to_Number(C003)/1024/1024,''999G999G999999G999G999G999D0'')||'' ''',
'                   || wwv_flow_lang.system_message(''4500_SESS_MEGABYTES'')',
'            else to_char(to_Number(C003)/1024,''999G999G999999G999G999G999D0'') ||'' ''',
'              ||wwv_flow_lang.system_message(''4500_SESS_KILOBYTES'') end',
'       else to_char(to_number(C003),''999G999G999999G999G999G999'') end c003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''MEMORY''',
'order by seq_id',
''))
,p_customized=>'1'
,p_customized_name=>'Statistiche di memoria'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46912117501975223.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(174767004045061216.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174767301751061218.4504)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174767209260061218.4504)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(159762828968547746.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(159760820526535896.4504)
,p_button_name=>'P550_GO'
,p_button_static_id=>'P550_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1020668628334854542.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(159760820526535896.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161609804176088573.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(159760820526535896.4504)
,p_button_name=>'TRACE_SESSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Trace sessione'
,p_button_position=>'NEXT'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461031001565380178.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(159760820526535896.4504)
,p_button_name=>'KILL_SESSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Termina sessione'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159835004193777176.4504)
,p_branch_action=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(461031001565380178.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159763013275547748.4504)
,p_branch_action=>'f?p=&FLOW_ID.:550:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18822226450191580.4504)
,p_name=>'P550_INST_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(159760820526535896.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159698314021089255.4504)
,p_name=>'P550_SID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(159760820526535896.4504)
,p_prompt=>'SID'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sid||'' - ''||username d, sid r',
'from sys.gv_$session',
'where type <> ''BACKGROUND''',
'order by sid'))
,p_cSize=>10
,p_cMaxlength=>38
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere un SID (ID sessione) e fare clic su <strong>Vai</strong>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(238762228699136055.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'550'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(241918623881406650.4504)
,p_validation_name=>'SID Exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_dummy number;',
'begin',
'',
'    begin',
'      l_dummy := :P550_SID;',
'    exception when others then return false;',
'    end;',
'',
'for c1 in (select 1',
'             from sys.gv_$session',
'            where sid = :P550_SID',
'              and inst_id = :P550_INST_ID)',
'loop',
'   return true;',
'end loop;--c1',
'',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Scegliere o immettere un identificativo di sessione numerico valido'
,p_when_button_pressed=>wwv_flow_api.id(159762828968547746.4504)
,p_associated_item=>wwv_flow_api.id(159698314021089255.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(160296627104938155.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(159762828968547746.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(174748328099954603.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Collection'
,p_process_sql_clob=>'wwv_flow_session_mon.populate_stats_array( p_sid => :P550_SID, p_inst_id => :P550_INST_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'select 1 from sys.gv_$session where sid = :P550_SID and inst_id = :P550_INST_ID'
,p_process_when_type=>'EXISTS'
);
end;
/
prompt --application/pages/page_00551
begin
wwv_flow_api.create_page(
 p_id=>551.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Piano SQL della sessione'
,p_step_title=>'Piano SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(206250111084432914)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'  a.indexUsed, a.indexUsed:link,a.indexUsed:visited{font-weight:bold;color:#333333}',
'span.highLight{color:#2F9F58;font-weight:bold;}',
'.fielddatabold{padding-left:7px;}',
'span.noIndex{font-weight:bold;color:#ff0000;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_topsql.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(160439524013199750.4504)
,p_name=>'Piano di esecuzione della query'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select id,position,',
'           address,hash_value,child_number,operation,options,',
'           object_type,OBJECT#,object_name,object_owner,',
'           cost,cardinality,bytes,',
'           access_predicates,filter_predicates,time,parent_id,',
'           SEARCH_COLUMNS',
'      from sys.gv_$sql_plan',
'    where address =  :P551_ADDRESS',
'      and hash_value = :P551_HASH_VALUE',
'      and child_number = :P551_CHILD_NUMBER',
'      and inst_id = :P551_INST_ID),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id) ',
'select operation,options,',
'       case when object_type in (''TABLE'',''VIEW'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'') then',
'            case when object_owner in (select schema from ws_schemas) then',
'                 ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||OBJECT#||'',''||replace(object_type,'' (UNIQUE)'')||'',''|| wwv_flow_escape.html(object_owner)||''">''||wwv_flow_escape.html(object_name)||''</a>''',
'            else wwv_flow_escape.html(object_name) end ',
'       else wwv_flow_escape.html(object_name) end object_name,',
'       cost,cardinality,bytes,',
'       decode(level,1,1,power(level,2)+15) padding,access_predicates,filter_predicates,TIME,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,filter_predicates) ',
'       else wwv_flow_escape.html(replace(filter_predicates,''='','' = '')) end filter_predicates2,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,access_predicates) ',
'       else wwv_flow_escape.html(replace(access_predicates,''='','' = '')) end access_predicates2',
'       ,SEARCH_COLUMNS,',
'       OBJECT# object_id,object_type',
'        from sqlplan s1',
'  start with (address =  :P551_ADDRESS',
'              and hash_value = :P551_HASH_VALUE',
'              and child_number = :P551_CHILD_NUMBER',
'              and id=0 )',
'connect by prior id = parent_id',
'        and prior address = address',
'        and prior hash_value = hash_value',
'        and prior child_number = child_number',
'order by id, position'))
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'* Le colonne non indicizzate vengono visualizzate in rosso',
'<p><br /></p>'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Nessun piano disponibile per questa istruzione.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160440325113199764.4504)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>'Operazione'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<div style="padding-left:#PADDING#;white-space:nowrap;font-family:monospace;">#OPERATION#</div>'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160440401689199764.4504)
,p_query_column_id=>2
,p_column_alias=>'OPTIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Opzioni'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;font-family:monospace;'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160466103836469312.4504)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Oggetto'
,p_column_css_style=>'font-family:monospace;'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160441724143199767.4504)
,p_query_column_id=>4
,p_column_alias=>'COST'
,p_column_display_sequence=>5
,p_column_heading=>'Costo'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160441824001199767.4504)
,p_query_column_id=>5
,p_column_alias=>'CARDINALITY'
,p_column_display_sequence=>4
,p_column_heading=>'Righe'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160464600242458839.4504)
,p_query_column_id=>6
,p_column_alias=>'BYTES'
,p_column_display_sequence=>7
,p_column_heading=>'Byte'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160466211715469312.4504)
,p_query_column_id=>7
,p_column_alias=>'PADDING'
,p_column_display_sequence=>9
,p_column_heading=>'Padding'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(177482610888475900.4504)
,p_query_column_id=>8
,p_column_alias=>'ACCESS_PREDICATES'
,p_column_display_sequence=>8
,p_column_heading=>'Access<br />Predicates'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(177493424656498802.4504)
,p_query_column_id=>9
,p_column_alias=>'FILTER_PREDICATES'
,p_column_display_sequence=>10
,p_column_heading=>'Filter<br />Predicates'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(177499728381518816.4504)
,p_query_column_id=>10
,p_column_alias=>'TIME'
,p_column_display_sequence=>6
,p_column_heading=>'Quando'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188855513759384744.4504)
,p_query_column_id=>11
,p_column_alias=>'FILTER_PREDICATES2'
,p_column_display_sequence=>11
,p_column_heading=>'Predicati di<br />filtro*'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188856714582394409.4504)
,p_query_column_id=>12
,p_column_alias=>'ACCESS_PREDICATES2'
,p_column_display_sequence=>12
,p_column_heading=>'Predicati di<br />accesso'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191261706669295834.4504)
,p_query_column_id=>13
,p_column_alias=>'SEARCH_COLUMNS'
,p_column_display_sequence=>13
,p_column_heading=>'Search Columns'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(192458011625374082.4504)
,p_query_column_id=>14
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>14
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(192458111378374082.4504)
,p_query_column_id=>15
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>15
,p_column_heading=>'Object Type'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160444301899203800.4504)
,p_plug_name=>'SQL Statement'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p><br /></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(191852001361786364.4504)
,p_name=>'Indici'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select object_type,OBJECT#,object_name,object_owner',
'      from sys.gv_$sql_plan',
'    where address =  :P551_ADDRESS',
'      and hash_value = :P551_HASH_VALUE',
'      and child_number = :P551_CHILD_NUMBER',
'      and inst_id = :P551_INST_ID',
'      and object_type in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id),',
't as(',
'        select object_owner table_owner,object_name table_name,',
'               OBJECT# OBJECT_ID',
'          from sqlplan',
'         where object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name,',
'               d.OBJECT_ID',
'          from sys.dba_indexes d1, sqlplan s1,',
'               sys.dba_objects d',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and s1.object_type in(''INDEX'',''INDEX (UNIQUE)'')',
'           and d.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'           and d.owner = d1.table_owner',
'           and d.object_name = d1.table_name',
'           ),',
'cols as(',
'    select table_owner,index_name,',
'           rtrim(',
'           max(decode(position,1 ,column_name))||'',''||',
'           max(decode(position,2 ,column_name))||'',''||',
'           max(decode(position,3 ,column_name))||'',''||',
'           max(decode(position,4 ,column_name))||'',''||',
'           max(decode(position,5 ,column_name))||'',''||',
'           max(decode(position,6 ,column_name))||'',''||',
'           max(decode(position,7 ,column_name))||'',''||',
'           max(decode(position,8,column_name))',
'           ,'','') columns',
'     from(',
'        select c.table_owner,c.index_name,c.column_name,c.column_position position',
'          from sys.dba_ind_columns c, t',
'         where t.table_owner = c.table_owner',
'           and t.table_name = c.table_name)',
'    group by table_owner,index_name',
')',
'select di.owner, ',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||t.object_id||'',TABLE,''|| wwv_flow_escape.html(di.owner)||''">''||wwv_flow_escape.html(di.table_name)||''</a>''',
'       else wwv_flow_escape.html(di.table_name) end table_name,',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||do2.object_id||'',INDEX,''|| wwv_flow_escape.html(di.owner)||''">''||wwv_flow_escape.html(di.index_name)||''</a>''',
'       else wwv_flow_escape.html(di.index_name) end index_name,',
'       case when (select count(*) cnt ',
'                    from sqlplan sp1',
'                   where sp1.object_type like ''INDEX%''',
'                     and sp1.object_name = di.index_name) > 0 ',
'            then ''<span class="a-Icon icon-check"></span>''',
'       end check_mark,',
'      c.columns, uniqueness, di.status,',
'      index_type, partitioned, ',
'      funcidx_status, join_index,t.object_id, do2.object_id index_object_id',
'from   sys.dba_indexes di,sys.dba_objects do2,',
'       t,cols c',
'where di.table_owner = t.table_owner',
'  and di.table_name = t.table_name',
'  and index_type != ''LOB''',
'  and do2.object_type = ''INDEX''',
'  and do2.owner = di.owner',
'  and do2.object_name = di.index_name',
'  and c.table_owner = di.table_owner',
'  and c.index_name  = di.index_name'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'Nessun indice trovato'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10g Version'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191903916308894727.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191914004281948081.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tabella'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_inline_lov=>'f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA'
,p_lov_language=>'PLSQL'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904029943894727.4504)
,p_query_column_id=>3
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome indice'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193103521263091034.4504)
,p_query_column_id=>4
,p_column_alias=>'CHECK_MARK'
,p_column_display_sequence=>4
,p_column_heading=>'Utilizzato nel<br />piano'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904131795894727.4504)
,p_query_column_id=>5
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>5
,p_column_heading=>'Colonne'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904218976894727.4504)
,p_query_column_id=>6
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Univocit\00E0')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904322350894727.4504)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>8
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904408586894727.4504)
,p_query_column_id=>8
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Tipo di<br />indice'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904629439894728.4504)
,p_query_column_id=>9
,p_column_alias=>'PARTITIONED'
,p_column_display_sequence=>9
,p_column_heading=>'Partitioned'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904726268894728.4504)
,p_query_column_id=>10
,p_column_alias=>'FUNCIDX_STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Funcidx Status'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904825185894728.4504)
,p_query_column_id=>11
,p_column_alias=>'JOIN_INDEX'
,p_column_display_sequence=>11
,p_column_heading=>'Join Index'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191904910408894728.4504)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>12
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(192352008977606896.4504)
,p_query_column_id=>13
,p_column_alias=>'INDEX_OBJECT_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Index Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192365729203697830.4504)
,p_plug_name=>'Testo SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>21
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(241221106969455523.4504)
,p_name=>'Colonne tabelle'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select object_type,OBJECT# object_id,object_name,object_owner',
'      from sys.gv_$sql_plan',
'    where address =  :P551_ADDRESS',
'      and hash_value = :P551_HASH_VALUE',
'      and child_number = :P551_CHILD_NUMBER',
'      and inst_id = :P551_INST_ID',
'      and object_type in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')),',
't1 as(',
'        select s.object_owner table_owner,s.object_name table_name',
'          from sqlplan s',
'         where s.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name',
'          from sys.dba_indexes d1, sqlplan s1',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and replace(s1.object_type,'' (UNIQUE)'') = ''INDEX''',
'           )',
'select t.table_owner,t.table_name,c.column_name,c.data_type',
'  from t1 t,sys.dba_tab_columns c',
' where t.table_name = c.table_name',
'   and t.table_owner = c.owner',
' order by t.table_owner,t.table_name,c.column_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>2000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'Nessuna colonna trovata.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10+ Version'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241221323469455535.4504)
,p_query_column_id=>1
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241221421528455535.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241221513889455535.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241221617348455535.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo dati'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18819425393039925.4504)
,p_name=>'P551_INST_ID'
,p_item_sequence=>67
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160445115405207764.4504)
,p_name=>'P551_ADDRESS'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160446226487210993.4504)
,p_name=>'P551_HASH_VALUE'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160458200017392570.4504)
,p_name=>'P551_CHILD_NUMBER'
,p_item_sequence=>39.5
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187875109566080761.4504)
,p_name=>'P551_EXECUTIONS'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Esecuzioni:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Numero di volte in cui questa istruzione SQL \00E8 stata eseguita')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187948130129096183.4504)
,p_name=>'P551_CPU_TIME'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Tempo CPU (secondi):'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Tempo CPU in secondi richiesto da questa istruzione SQL durante l''ultima esecuzione.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187998417100101852.4504)
,p_name=>'P551_ROWS_PROCESSED'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Righe elaborate:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Numero di righe restituite da questa istruzione SQL durante l''ultima esecuzione.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(188075326928114152.4504)
,p_name=>'P551_DISK_READS'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Letture disco:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Il numero di letture di blocchi dal disco durante l''ultima esecuzione di questa istruzione SQL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(188121511129119012.4504)
,p_name=>'P551_BUFFER_GETS'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Richieste buffer:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Numero di blocchi in memoria a cui ha avuto accesso questa istruzione SQL durante l''ultima esecuzione'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(188138429483124368.4504)
,p_name=>'P551_GETS_PROCESSED'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Richieste buffer/righe elaborate:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Il numero di letture dei blocchi diviso per il numero di righe restituite. Questa \00E8 una misura di efficienza e sar\00E0 nulla se le righe elaborate sono pari a zero.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(191923404983023978.4504)
,p_name=>'P551_EFFICIENCY2'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Richieste buffer/esecuzioni:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Numero di letture dei blocchi diviso per il numero di volte in cui una query \00E8 stata eseguita. Valori maggiori indicano un numero elevato di letture dei blocchi per esecuzione.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(192366606825700813.4504)
,p_name=>'P551_SQL_TEXT'
,p_item_sequence=>47
,p_item_plug_id=>wwv_flow_api.id(192365729203697830.4504)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'style="font-family:monospace;"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(192371420855742707.4504)
,p_name=>'P551_MODULE'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Modulo: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'style="white-space:nowrap;"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Il modulo impostato dallo strumento client. Nel caso di questo prodotto, il modulo \00E8 impostato come:<br />'),
'HTMLDB APPLICATION: ####',
unistr('dove "####" \00E8 il numero dell''applicazione che ha eseguito questa istruzione SQL l''ultima volta.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(192372800207746239.4504)
,p_name=>'P551_ACTION'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(160444301899203800.4504)
,p_prompt=>'Azione:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Questa \00E8 l''azione impostata dallo strumento client. Nel caso di questo prodotto, l''azione \00E8 impostata su:'),
'PAGE ####',
unistr('dove "####" \00E8 il numero di pagina dell''applicazione che ha eseguito questa istruzione SQL l''ultima volta.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(188648032216172463.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Top Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    type local_arr is table of varchar2(50);',
'    keyWords local_arr;',
'    ',
'    function highlight_keywords(p_sql in varchar2)',
'    return varchar2',
'    is',
'        l_sql   varchar2(32767) := replace(p_sql,chr(0));',
'    begin',
'        keyWords := local_arr(''SELECT'',''FROM'',''WHERE'',''AND'',''OR'',''ORDER BY'',''WITH'',''BETWEEN'',',
'                              ''GROUP BY'',''HAVING'',''CONNECT BY'',''START WITH'',''PRIOR'',''EXISTS'',',
'                              ''NOT'',''IN'',',
'                              ''LIKE'',''CONTAINS'',''REGEXP_INSTR'',''REGEXP_LIKE'',''IS'',''NULL'');',
'        for i in keyWords.first..keyWords.last loop',
'            l_sql := replace(upper(l_sql),keyWords(i)||'' '',''<span class="highLight">''||keyWords(i)||''</span> '');',
'        end loop;--i',
'        return l_sql;',
'    end highlight_keywords;',
'begin',
'    ',
'    ',
'    for c1 in (select EXECUTIONS,',
'                      DISK_READS,',
'                      (CPU_TIME / 1000000) CPU_TIME,',
'                      BUFFER_GETS,',
'                      ROWS_PROCESSED,',
'                      case when ROWS_PROCESSED = 0 then null ',
'                           else (BUFFER_GETS / replace(ROWS_PROCESSED,0,1)) end GETS_PROCESSED,',
'                      case when EXECUTIONS = 0 then null ',
'                           else (BUFFER_GETS / replace(EXECUTIONS,0,1)) end GETS_EXECUTIONS,',
'                      sql_fulltext,',
'                      MODULE,ACTION',
'                 from sys.gv_$sql',
'                where address       = :P551_ADDRESS',
'                  and HASH_VALUE    = :P551_HASH_VALUE',
'                  and inst_id       = :P551_INST_ID',
'                  and CHILD_NUMBER  = :P551_CHILD_NUMBER)',
'    loop',
'        :P551_EXECUTIONS        := to_char(c1.EXECUTIONS,''999G999G999G999G999G999G999G990'');',
'        :P551_DISK_READS        := to_char(c1.DISK_READS,''999G999G999G999G999G999G999G990'');',
'        :P551_CPU_TIME          := to_char(c1.CPU_TIME,''999G999G999G999G999G999G999G990D0'');',
'        :P551_BUFFER_GETS       := to_char(c1.BUFFER_GETS,''999G999G999G999G999G999G999G990'');',
'        :P551_ROWS_PROCESSED    := to_char(c1.ROWS_PROCESSED,''999G999G999G999G999G999G999G990'');',
'        :P551_GETS_PROCESSED    := to_char(c1.GETS_PROCESSED,''999G999G999G999G999G999G999G990'');',
'        :P551_EFFICIENCY2       := to_char(c1.GETS_EXECUTIONS,''999G999G999G999G999G999G999G990'');',
'        :P551_SQL_TEXT          := substr(highlight_keywords(replace(wwv_flow_escape.html(sys.dbms_lob.substr(c1.sql_fulltext,3200,1)),chr(10),''<br />'')),1,32000);',
'        :P551_MODULE            := c1.module;',
'        :P551_ACTION            := c1.action;',
'',
'    end loop;--c1',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00560
begin
wwv_flow_api.create_page(
 p_id=>560.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Statistiche di sistema'
,p_step_title=>'Statistiche di sistema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'table.statsBlock{margin:5px 10px 15px 10px;width:250px;float:left;vertical-align:top;}',
'table.statsBlock th{font-size:8pt;color:#777777;text-align:center;border-bottom:1px #cccccc solid;}',
'table.statsBlock td{font-size:8pt;padding-left:5px;border-left: 1px #efefef solid;}',
'table.statsBlock td.n{color:#3F8640;text-align:right;font-weight:bold;padding-right:5px;padding-left:0px; border-left:0px;width:200px;}',
'',
'table.statsLayoutTbl td{vertical-align:top;}',
'',
'table.htmldbRptNoBackground th,table.htmldbRptNoBackground td{font-size:9pt;}',
'table.htmldbRptNoBackground th{text-align:right;color:#3F8640;font-weight:bold;}',
'',
'table.htmldbRptRowNoBack td{font-size:8pt;padding:1px 3px;}',
'table.htmldbRptRowNoBack td.p{text-align:right;color:#3F8640;font-weight:bold;border-right: 1px #efefef solid;width:220px;}',
'',
'table.htmldbRR2{width:97%;margin:0px 5px 0px 5px 0px;vertical-align:top;}',
'table.htmldbRR2 th.T,table.htmldbRR2 th.BT {padding:0px 5px 0px 5px;font-size:10pt;color:#777777;border-bottom:1px #cccccc solid;}',
'table.htmldbRR2 th.T{text-align:left;}',
'table.htmldbRR2 td{vertical-align:top;}',
'',
'table.htmldbSessionLayout td table td{vertical-align:top; }',
'.rounded-corner-region .rc-body .rc-content-bin {height:150px;}',
'</style>',
''))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(206059717799303330)
,p_required_patch=>wwv_flow_api.id(140265918963157648.4504)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_stats.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(182527924521262618.4504)
,p_name=>'Statistiche sul tempo (secondi)'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>85
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 Parameter,(C003/100) value, seq_id, 1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS'' and ',
'       nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'   and C001 = ''TIME''',
'union all',
'select c002 Parameter,(select max(c003/100 - a.C003/100) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002 and C001 = ''TIME'') value, a.seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''TIME'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Saved'' Parameter,(C003/100) value, seq_id, 2 o',
'  from htmldb_collections',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''TIME'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'union all'))
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(182527924521262618.4504)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182983722307360701.4504)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182983826081360702.4504)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_column_format=>'999G999G999G999G990D00'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182984330965363237.4504)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183145429560561544.4504)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'O'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(182528319308262620.4504)
,p_name=>'Statistiche cursore SQL'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>95
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,to_number(C003) value, seq_id, 1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''SQL_CURSOR'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,(select max(c003 - a.C003) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002) ',
'       value,',
'       seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''SQL_CURSOR'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(182528319308262620.4504)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183164027192664907.4504)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183164125402664908.4504)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183164218510664908.4504)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183164301537664908.4504)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'Order'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(182528707687262620.4504)
,p_name=>'Statistiche di I/O logici'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,',
'       to_number(C003) value,',
'       seq_id,',
'       1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''LOGICAL_IO'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,',
'      (select max(c003 - a.C003) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002 and c001 = ''LOGICAL_IO'') ',
'       value,',
'       seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''LOGICAL_IO'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,',
'       case when c002 = ''redo size'' ',
'            then case when to_Number(C003) > 104857 ',
'                 then to_char(to_Number(C003)/1024/1024,''999G999G999999G999G999G990D0'')||'' ''',
'                   || wwv_flow_lang.system_message(''4500_SESS_MEGABYTES'')',
'            else to_char(to_Number(C003)/1024,''999G999G999999G999G999G990D0'') ||'' ''',
'              ||wwv_flow_lang.system_message(''4500_SESS_KILOBYTES'') end',
'       else to_char(to_number(C003),''999G999G999999G999G999G990'') end value,',
'       seq_id,',
'       1 o',
'  from htmldb_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''LOGICAL_IO''',
'order by seq_id, o'))
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(182528707687262620.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183207827595769121.4504)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183207930060769121.4504)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_column_format=>'999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183208021202769122.4504)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183208116247769122.4504)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'Order'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(182529109073262622.4504)
,p_name=>'Statistiche di I/O fisici'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,',
'       to_number(C003) value,',
'       seq_id, 1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''PHYSICAL_IO'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,(select max(c003 - a.C003) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002) ',
'       value,',
'       seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''PHYSICAL_IO'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183009205778412759.4504)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183009312242412760.4504)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183009411366412760.4504)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183153209868584209.4504)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'Order'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(182529520304262623.4504)
,p_name=>'Statistiche delle transazioni'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>125
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 Parameter,',
'       to_number(C003) value,',
'       seq_id, ',
'       1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''TRANSACTION'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,',
'       (select max(c003 - a.C003) from htmldb_collections ',
'        where collection_name = ''SYSTEM_STATS'' and c002 = a.c002) ',
'       value,',
'       seq_id, ',
'       3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and a.C001 = ''TRANSACTION'' ',
'   and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(182529520304262623.4504)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183198502614733509.4504)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183198608531733509.4504)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183198724559733509.4504)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Seq Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183198831536733510.4504)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'O'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(182529925349262624.4504)
,p_name=>'Statistiche di memoria'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,',
'      to_Number(C003) value,',
'      seq_id,',
'      1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''MEMORY'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,',
'      (select max(c003 - a.C003) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002 and c001 = ''MEMORY'') ',
'       value,',
'       seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''MEMORY'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_customized_name=>'Statistiche di memoria'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,',
'       case when C002 in (''session uga memory'',''session pga memory'')',
'            then ',
'            case when to_Number(C003) > 104857 ',
'                 then to_char(to_Number(C003)/1024/1024,''999G999G999999G999G999G999D0'')||'' ''',
'                   || wwv_flow_lang.system_message(''4500_SESS_MEGABYTES'')',
'            else to_char(to_Number(C003)/1024,''999G999G999999G999G999G999D0'') ||'' ''',
'              ||wwv_flow_lang.system_message(''4500_SESS_KILOBYTES'') end',
'       else to_char(to_number(C003),''999G999G999999G999G999G999'') end c003',
'  from htmldb_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''MEMORY''',
'order by seq_id'))
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(182529925349262624.4504)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183229108080829769.4504)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parametro'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183229230442829769.4504)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valore'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183229925395834757.4504)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183230019659834757.4504)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'Order'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(182640107698476570.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(467824415050070719.4504)
,p_button_sequence=>7
,p_button_plug_id=>wwv_flow_api.id(182640107698476570.4504)
,p_button_name=>'REMOVE_SAVED_STATISTICS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Rimuovi statistiche salvate'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:560:&SESSION.:TRUNCATE:&DEBUG.::P560_SHOW_SAVED_STATISTICS:N'
,p_button_condition=>'return wwv_flow_collection.collection_exists(''SYSTEM_STATS_SAVE'');'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(206248007144422393.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(182640107698476570.4504)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva statistiche'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:560:&SESSION.:SAVE:&DEBUG.::P560_SHOW_SAVED_STATISTICS:Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(182765111104723592.4504)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(182640107698476570.4504)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Aggiorna report'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(182531531518262643.4504)
,p_branch_action=>'f?p=&FLOW_ID.:560:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183015231058420053.4504)
,p_name=>'P560_SHOW_SAVED_STATISTICS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(182640107698476570.4504)
,p_prompt=>'Mostra delta tra valori correnti e salvati'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'Y_NOPROMPT'
,p_lov=>'.'||wwv_flow_api.id(88018003898325845.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Visualizzare i valori statistici effettivi o visualizzare i delta tra un valore salvato e il valore corrente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183089811974461829.4504)
,p_name=>'P560_STATISTICS_SAVED'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(182640107698476570.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183101009812480164.4504)
,p_name=>'P560_ELAPSED_SECONDS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(182640107698476570.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tempo trascorso dall''ultimo salvataggio, in secondi:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  return (sys.dbms_utility.get_time - :P560_STATISTICS_SAVED) / 100;',
'exception',
'when others then return null;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>'P560_SHOW_SAVED_STATISTICS'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indica il periodo di tempo trascorso dall''ultimo salvataggio delle statistiche.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182531113511262640.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182531303248262640.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Collection'
,p_process_sql_clob=>'wwv_flow_session_mon.populate_sys_stats_array (p_mode=>''REPORT'');'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile popolare le statistiche'
,p_process_when=>'SAVE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182964815765311595.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Baseline Statistics'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_session_mon.populate_sys_stats_array (p_mode=>''SAVE'');',
':P560_STATISTICS_SAVED := sys.dbms_utility.get_time;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'SAVE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Statistiche salvate'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(183083215175443839.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate saved collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.truncate_collection(''SYSTEM_STATS_SAVE'');',
'wwv_flow_collection.delete_collection(''SYSTEM_STATS_SAVE'');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile rimuovere le statistiche salvate'
,p_process_when=>'TRUNCATE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Statistiche salvate rimosse'
);
end;
/
prompt --application/pages/page_00602
begin
wwv_flow_api.create_page(
 p_id=>602.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea tabella - Colonne'
,p_alias=>'TABLE_CREATE'
,p_step_title=>'Crea tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_javascript_file_urls=>'#IMAGE_PREFIX#ob/ob_table_functions.js'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'first_field();',
'gLastRowHighlight = false;'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'/AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486513067692688.4504)
,p_plug_name=>'Crea tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_row number := -1;',
'    l_add  number:= 0;',
'    l_checked varchar2(200);',
'begin',
'    sys.htp.prn(''<table cellpadding="0" cellspacing="0" class="aSimpleReport u-Report legacy-tableForm" width="100%"  border="0" aria-label="''||wwv_flow_lang.system_message(''F4500.NEW_COLUMNS'')||''" id="htmldbNewTable">'');',
'    sys.htp.prn(''<tr>'');',
'    sys.htp.prn(''<th id="c1" scope="col">''||wwv_flow_lang.system_message(''COLUMN_NAME'')||''</th>'');',
'    sys.htp.prn(''<th id="c2" scope="col">''||wwv_flow_lang.system_message(''PAGE_REGION.TREE_TYPE'')||''</th>'');',
'    sys.htp.prn(''<th id="c3" scope="col">''||wwv_flow_lang.system_message(''PRECISION'')||''</th>'');',
'    sys.htp.prn(''<th id="c4" scope="col">''||wwv_flow_lang.system_message(''CONFIRM.CHART_SCALE'')||''</th>'');',
'    sys.htp.prn(''<th id="c5" scope="col">''||wwv_flow_lang.system_message(''NOT_NULL'')||''</th>'');',
'    if wwv_flow_global.g_12c then',
'        sys.htp.prn(''<th id="c6" scope="col">''||wwv_flow_lang.system_message(''F4500_P602_IDENTITY'')||''</th>'');',
'    end if;',
'    sys.htp.prn(''<th id="c7" scope="col">''||wwv_flow_lang.system_message(''MOVE'')||''</th>'');',
'    sys.htp.p(''</tr>'');',
'    for c1 in (select rownum,seq_id,c001, c002, c003,c004,c005,c006',
'                 from wwv_flow_collections',
'                where collection_name = ''TBL_WIZ_COLUMNS''',
'                order by seq_id)',
'    loop',
'        l_row := l_row+1;',
'        sys.htp.prn(''<tr>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(''<span id="r''||l_row||''" class="hideMeButHearMe" tabindex="-1">''||l_row||''</span>'');    --tabindex in order to include <span> in browser accessibility tree.',
'        sys.htp.prn(wwv_flow_item.text(1,c1.c001,30,wwv_flow_global.c_dbms_id_length,''aria-labelledby="c1 r''||l_row||''"'',''colname''||l_row));',
'        sys.htp.prn(''</td>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(wwv_flow_item.select_list_from_lov(',
'            p_idx       => 2,',
'            p_value     => c1.c002,',
'            p_lov       => ''DATA_TYPES'',',
'            p_attributes=> ''onchange="ob_TableToggleType(this);" aria-labelledby="c2 r''||l_row||''"'',',
'            p_show_null => ''YES'',',
'            p_null_value=> 0,',
'            p_null_text => wwv_flow_lang.system_message(''OB_SELECT_DATATYPE''),',
'            p_item_id   => ''type''||l_row));',
'        sys.htp.prn(''</td>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(wwv_flow_item.text(3,c1.c003,5,7,''style="visibility:hidden;" aria-labelledby="c3 r''||l_row||''"'',''scale''||l_row));',
'        sys.htp.prn(''</td>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(wwv_flow_item.text(4,c1.c004,5,7,''style="visibility:hidden;" aria-labelledby="c4 r''||l_row||''"'',''precision''||l_row));',
'        sys.htp.prn(''</td>'');',
'        if c1.c005 = ''Y'' then',
'          sys.htp.prn(''<td>'');',
'          sys.htp.prn(wwv_flow_item.checkbox(44,c1.seq_id,''style="visibility:hidden;" onclick="ob_ToggleNN(this);" aria-labelledby="c5 r''||l_row||''"'',c1.seq_id));',
'          sys.htp.prn(wwv_flow_item.hidden(7,''Y''));',
'          sys.htp.prn(''</td>'');',
'        else',
'          sys.htp.prn(''<td>'');',
'          sys.htp.prn(wwv_flow_item.checkbox(44,c1.seq_id,''style="visibility:hidden;" onclick="ob_ToggleNN(this);" aria-labelledby="c5 r''||l_row||''"''));',
'          sys.htp.prn(wwv_flow_item.hidden(7,''N''));',
'          sys.htp.prn(''</td>'');',
'        end if;',
'        if wwv_flow_global.g_12c then',
'            sys.htp.prn(''<td>'');',
'            sys.htp.prn(wwv_flow_item.select_list_from_lov(',
'                p_idx       => 8,',
'                p_value     => c1.c006,',
'                p_lov       => ''IDENTITY_OPTIONS'',',
'                p_attributes=> ''style="visibility:hidden;" aria-labelledby="c6 r''||l_row||''"'',',
'                p_show_null => ''YES'',',
'                p_null_value=> 0,',
'                p_null_text => wwv_flow_lang.system_message(''APEXIR_NONE''),',
'                p_item_id   => ''identity''||l_row));',
'            sys.htp.prn(''</td>'');',
'        end if;',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(''<a href="#" title="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_UP'')||''" class="htmldbPseudoButton" onclick="html_RowUp(this);ob_delayOrder();"><span class="a-Icon icon-up-arrow"></span></a>'');',
'        sys.htp.prn(''<a href="#" title="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_DOWN'')||''" class="htmldbPseudoButton" onclick="html_RowDown(this);ob_delayOrder();"><span class="a-Icon icon-down-arrow"></span></a>'');',
'        sys.htp.prn(''</td>'');',
'        sys.htp.p(''</tr>'');',
'    end loop;',
'',
'    if ( l_row = -1 ) then',
'       l_add := :P602_COLUMNS;',
'    else',
'       l_add := 3;',
'    end if;',
'',
'    for i in l_row+1..l_row+l_add loop',
'        sys.htp.prn(''<tr>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(''<span id="r''||i||''" class="hideMeButHearMe" tabindex="-1">''||i||''</span>'');    --tabindex in order to include <span> in browser accessibility tree.',
'        sys.htp.prn(wwv_flow_item.text(1,null,30,wwv_flow_global.c_dbms_id_length,''aria-labelledby="c1 r''||i||''"'',''tblname''||i));',
'        sys.htp.prn(''</td>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(wwv_flow_item.select_list_from_lov(',
'            p_idx        => 2,',
'            p_value      => 0,',
'            p_lov        => ''DATA_TYPES'',',
'            p_attributes => ''onchange="ob_TableToggleType(this);" aria-labelledby="c2 r''||i||''"'',',
'            p_show_null  => ''YES'',',
'            p_null_value => 0,',
'            p_show_extra => ''N'',',
'            p_null_text  => wwv_flow_lang.system_message(''OB_SELECT_DATATYPE''),',
'            p_item_id    => ''type''||i));',
'        sys.htp.prn(''</td>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(wwv_flow_item.text(3,null,5,7,''style="visibility:hidden;" aria-labelledby="c3 r''||i||''"'',''precision''||i));',
'        sys.htp.prn(''</td>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(wwv_flow_item.text(4,null,5,7,''style="visibility:hidden;" aria-labelledby="c4 r''||i||''"'', ''scale''||i));',
'        sys.htp.prn(''</td>'');',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(wwv_flow_item.checkbox(44,i,''style="visibility:hidden;" onclick="ob_ToggleNN(this);" aria-labelledby="c5 r''||i||''"''));',
'        sys.htp.prn(wwv_flow_item.hidden(7,''N''));',
'        sys.htp.prn(''</td>'');',
'        if wwv_flow_global.g_12c then',
'            sys.htp.prn(''<td>'');',
'            sys.htp.prn(wwv_flow_item.select_list_from_lov(',
'                p_idx        => 8,',
'                p_value      => 0,',
'                p_lov        => ''IDENTITY_OPTIONS'',',
'                p_attributes => ''style="visibility:hidden;" aria-labelledby="c6 r''||i||''"'',',
'                p_show_null  => ''YES'',',
'                p_null_value => 0,',
'                p_show_extra => ''N'',',
'                p_null_text  => wwv_flow_lang.system_message(''APEXIR_NONE''),',
'                p_item_id    => ''identity''||i));',
'            sys.htp.prn(''</td>'');',
'        end if;',
'        sys.htp.prn(''<td>'');',
'        sys.htp.prn(''<a href="#" title="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_UP'')||''" class="htmldbPseudoButton" onclick="return ob_RowUp(this);"><span class="a-Icon icon-up-chevron"></span></a>'');',
'        sys.htp.prn(''<a href="#" title="''||wwv_flow_lang.system_message(''F4500.MOVE_COLUMN_DOWN'')||''" class="htmldbPseudoButton" onclick="return ob_RowDown(this);"><span class="a-Icon icon-down-chevron"></span></a>'');',
'        sys.htp.prn(''</td>'');',
'        sys.htp.p(''</tr>'');',
'    end loop;',
'    sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149778129674226806.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149747621878186797.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239272606807146237.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752121331287695896.4504)
,p_plug_name=>'Crea tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13099823231294393.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(486513067692688.4504)
,p_button_name=>'ADD_ROW'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Aggiungi colonna'
,p_button_position=>'BOTTOM'
,p_button_alignment=>'LEFT'
,p_button_redirect_url=>'javascript:ob_TableAddColumn(this,''htmldbNewTable'',1);'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(506332348190289.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239272606807146237.4504)
,p_button_name=>'CONF'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Fine'
,p_button_position=>'NEXT'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(239981626533605059.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239272606807146237.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(504800487181098.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239272606807146237.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(268494416019245169.4504)
,p_branch_action=>'604'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(239981626533605059.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169834900602948051.4504)
,p_branch_action=>'f?p=&APP_ID.:604:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'PK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169835509260950584.4504)
,p_branch_action=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'FK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169836122766954454.4504)
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CONS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169836731077956872.4504)
,p_branch_action=>'f?p=&APP_ID.:612:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CONF'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169839804805977651.4504)
,p_branch_action=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20256110399045015.4504)
,p_name=>'P602_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(486513067692688.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('<p>Selezionare lo schema di database Oracle (o nome utente) nel quale si desidera creare la tabella. L''intervallo di schemi disponibili \00E8 gestito dall''amministratore.</p>')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20257232562051420.4504)
,p_name=>'P602_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(486513067692688.4504)
,p_prompt=>'Nome tabella'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica il nome della tabella. I nomi di tabella devono essere conformi alle convenzioni di denominazione Oracle e non devono contenere spazi o iniziare con numeri o caratteri di sottolineatura.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20398603610228815.4504)
,p_name=>'P602_COLUMNS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(486513067692688.4504)
,p_item_default=>'8'
,p_prompt=>'Columns'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72321504952464144.4504)
,p_name=>'P602_PRESERVE_CASE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(486513067692688.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRESERVE.CASE.Y'
,p_lov=>'.'||wwv_flow_api.id(88034811582507798.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(268397513698676769.4504)
,p_name=>'P602_COL_ORDER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(486513067692688.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21820730434737654.4504)
,p_computation_sequence=>10
,p_computation_item=>'P602_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(trim(:P602_NAME),chr(32),''_''))'
,p_compute_when=>'P602_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21821404246739503.4504)
,p_computation_sequence=>20
,p_computation_item=>'P602_SCHEMA'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:OB_SCHEMA)'
,p_compute_when=>'P602_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20403326775282828.4504)
,p_computation_sequence=>30
,p_computation_item=>'P602_COLUMNS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'TO_NUMBER(:P602_COLUMNS) + 1'
,p_compute_when=>'ADD_COLUMN'
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(122821022376346325.4504)
,p_computation_sequence=>40
,p_computation_item=>'LAST_SELECTED_PARSE_AS'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P602_SCHEMA'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15509006105515624.4504)
,p_computation_sequence=>50
,p_computation_item=>'P602_COLUMNS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'HTMLDB_COLLECTION.COLLECTION_MEMBER_COUNT (',
'p_collection_name => ''TBL_WIZ_COLUMNS'')'))
,p_compute_when=>'HTMLDB_COLLECTION.COLLECTION_MEMBER_COUNT (p_collection_name => ''TBL_WIZ_COLUMNS'' )>0'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21020206630341312.4504)
,p_validation_name=>'NAME NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P602_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per Nome tabella.'
,p_associated_item=>wwv_flow_api.id(20257232562051420.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21017813425333802.4504)
,p_validation_name=>'SCHEMA NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P602_SCHEMA'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Specificare uno schema per questa tabella.'
,p_associated_item=>wwv_flow_api.id(20256110399045015.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21082517730846050.4504)
,p_validation_name=>'NAME VALID'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if lengthb(:P602_NAME) > wwv_flow_global.c_dbms_id_length then',
'   return wwv_flow_lang.system_message(''TABLE_NAME_TOO_LONG'',wwv_flow_escape.html(:P602_NAME));',
'end if;',
'',
'if not wwv_flow_builder.is_valid_identifier(''"''||:P602_NAME||''"'') then',
'   return wwv_flow_lang.system_message(''F4500.NOT_VALID_TABLE_NAME'',wwv_flow_escape.html(:P602_NAME));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name2(:P602_NAME,:P602_SCHEMA,''TABLE'') then',
'   return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P602_NAME));',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21486726168726549.4504)
,p_validation_name=>'No duplicate cols'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cols          pls_integer     := :P602_COLUMNS;',
'    l_any_cols      boolean         := false;',
'    l_error_text    varchar2(1000)  := null;',
'    l_index_cols    varchar2(4000)  := null;',
'begin',
'    for c1 in (select seq_id,c001 ',
'                from wwv_flow_collections',
'               where collection_name = ''TBL_WIZ_COLUMNS''',
'               order by seq_id)',
'    loop',
'        if length(c1.c001) > 0 then',
'            l_any_cols := true;',
'            for c2 in (select seq_id,c001',
'                         from wwv_flow_collections',
'                        where collection_name = ''TBL_WIZ_COLUMNS''',
'                          and c001 = c1.c001',
'                          and seq_id != c1.seq_id',
'                          and instr('':''||l_index_cols||'':'','':''||seq_id||'':'') = 0)',
'            loop',
'                l_index_cols := l_index_cols ||c1.seq_id||'':'';',
'                if l_error_text is null then',
'                   l_error_text := c1.c001;',
'                else',
'                   l_error_text := l_error_text || '','' || c1.c001;',
'                end if;',
'                ',
'            end loop;--c2  ',
'        end if;    ',
'    end loop; --c1',
'if l_error_text is not null',
'   then',
'   return wwv_flow_lang.system_message(''F4500.P602.DUP_COL_NAME'',wwv_flow_escape.html(l_error_text));',
'end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21042923655450296.4504)
,p_validation_name=>'Column Name Valid'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cols          pls_integer     := :P602_COLUMNS;',
'    l_any_cols      boolean         := false;',
'    l_error_text    varchar2(1000)  := null;',
'begin',
'    for c1 in (select seq_id,c001 ',
'                from wwv_flow_collections',
'               where collection_name = ''TBL_WIZ_COLUMNS''',
'               order by seq_id)',
'    loop',
'        if length(c1.c001) > 0 then',
'            l_any_cols := true;',
'            if wwv_flow_builder.is_valid_identifier(''"''||c1.c001||''"'') = false ',
'              or c1.c001 in (''DATE'',''NUMBER'',''VARCHAR2'',''CLOB'',''BLOB'') then',
'                l_error_text := l_error_text || wwv_flow_lang.system_message(''F4500.P602.INVALID_COL_NAME'',wwv_flow_escape.html(c1.c001));',
'            end if;',
'        end if;    ',
'    end loop; --c1',
'    ',
'    if l_any_cols = false then',
'        l_error_text := wwv_flow_lang.system_message(''F4500.P602.ENTER_AT_LEAST_ONE_COL'');',
'    end if;',
'        ',
'    return l_error_text;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21532827693162188.4504)
,p_validation_name=>'Types are valid'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_text varchar2(1000) := null;',
'begin',
'    for c1 in (select seq_id,',
'                      c001                 as column_name,',
'                      c002                 as data_type,',
'                      replace(c003,''*'',38) as precision,',
'                      c004                 as scale',
'                from wwv_flow_collections',
'               where collection_name = ''TBL_WIZ_COLUMNS''',
'               order by seq_id)',
'    loop',
'        if length(c1.column_name) > 0 then',
'            if c1.precision is not null and wwv_flow_utilities.is_numeric(c1.precision)=false then',
'                l_error_text := l_error_text || wwv_flow_lang.system_message(''F4500.P602.INVALID_PRECISION'',wwv_flow_escape.html(c1.column_name));',
'            elsif c1.scale is not null and wwv_flow_utilities.is_numeric(c1.scale)=false then',
'                l_error_text := l_error_text || wwv_flow_lang.system_message(''F4500.P602.INVALID_SCALE'',wwv_flow_escape.html(c1.column_name));',
'            elsif c1.data_type = ''0'' then',
'                l_error_text := wwv_flow_lang.system_message(''F4500_P602_NO_DATATYPE'',wwv_flow_escape.html(c1.column_name));',
'            elsif c1.data_type in (''VARCHAR2'', ''NVARCHAR2'', ''RAW'') and c1.scale is null then',
'                l_error_text := l_error_text || wwv_flow_lang.system_message(''F4500.P602.SCALE_REQUIRED'',wwv_flow_escape.html(c1.column_name));',
'            elsif not wwv_flow_lov.is_valid_value (',
'                          p_shared_lov_id   => null,',
'                          p_shared_lov_name => ''DATA_TYPES'',',
'                          p_value           => c1.data_type )',
'            then',
'                l_error_text := l_error_text || wwv_flow_lang.system_message(''UNSUPPORTED_DATA_TYPE'');',
'            end if;',
'        end if;    ',
'    end loop; --c1',
'            ',
'    return l_error_text;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294787832732523947.4504)
,p_validation_name=>'reserved name'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P602_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della tabella \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(294791110793583854.4504)
,p_validation_name=>'column name reserved word'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (select c001 ',
'           from wwv_flow_collections',
'           where collection_name = ''TBL_WIZ_COLUMNS''',
'           order by seq_id)',
'loop               ',
'  if wwv_flow_sw_util.is_database_reserved_word(p_word=>upper(c1.c001)) then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato della colonna \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(280204424805870831.4504)
,p_validation_name=>'Only 1 Identity Column defined'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cnt number;',
'begin',
'    select count(*) into l_cnt ',
'      from wwv_flow_collections',
'     where collection_name = ''TBL_WIZ_COLUMNS'' ',
'       and c006 is not null and c006 !=''0'';',
'',
'    return l_cnt <=1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Solo una colonna pu\00F2 essere identificata come colonna identit\00E0.')
,p_validation_condition=>'wwv_flow_global.g_12c'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(239981626533605059.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(137979592434832809.4504)
,p_name=>'Show Column Attributes'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'apex_error.have_errors_occurred'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(137979697285832810.4504)
,p_event_id=>wwv_flow_api.id(137979592434832809.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// A workaround for the missing column attributes',
'// when a page error occurs from validation.',
'$(''[name=f01]'').each(function(){',
'    var $txtField = $( this ),',
'        columnName = $txtField.val();',
'    if ( columnName ) {',
'        $txtField',
'            .parent()',
'            .next()',
'            .find(''select'')',
'            .trigger(''change'');',
'    }',
'});'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(137979723537832811.4504)
,p_name=>'Init Table Prev'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'HTMLDB_COLLECTION.COLLECTION_MEMBER_COUNT (p_collection_name =>',
'''TBL_WIZ_COLUMNS'' )>0'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(137979871636832812.4504)
,p_event_id=>wwv_flow_api.id(137979723537832811.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'ob_TablePrevInit();'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(850223095956264.4504)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Collection (Commit)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cols  pls_integer;',
'    l_nn varchar2(2000);',
'    l_order wwv_flow_global.vc_Arr2;',
'    h number;',
'    i number;',
'    l_seq number;',
'    l_ident wwv_flow_global.t_dbms_id;',
'',
'    function f_name(p_name in varchar2)',
'        return varchar2',
'    is',
'    begin',
'      if :P602_PRESERVE_CASE is null then',
'        return substr(upper(replace(trim(p_name),'' '',''_'')),1,wwv_flow_global.c_dbms_id_length);',
'      else',
'        return substr(trim(p_name),1,wwv_flow_global.c_dbms_id_length);',
'      end if;',
'    end f_name;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(''TBL_WIZ_COLUMNS'');',
'    l_order := wwv_flow_utilities.string_to_Table2(:P602_COL_ORDER,'';'');',
'',
'    begin',
'       for i in 1..wwv_flow.g_f01.count loop',
'         l_seq := 0;',
'           if (wwv_flow.g_f01(i) is not null) then',
'               /* get the sequence */ ',
'               for h in 1..l_order.count loop',
'                  wwv_flow.debug(''Col:''||l_order(h));',
'                  if ( wwv_flow.g_f01(i) = l_order(h) ) then ',
'                    l_seq := h;',
'                    wwv_flow.debug(''Got it'');',
'                  end if;',
'               end loop; ',
'',
'               if wwv_flow_global.g_12c then',
'                 l_ident := wwv_flow.g_f08(i);',
'               else',
'                 l_ident := null;',
'               end if;',
'',
'                wwv_flow_collection.add_member(',
'                    p_collection_name => ''TBL_WIZ_COLUMNS'',',
'                    p_c001          => f_name(wwv_flow.g_f01(i)),',
'                    p_c002          => wwv_flow.g_f02(i),',
'                    p_c003          => wwv_flow.g_f03(i),',
'                    p_c004          => wwv_flow.g_f04(i),',
'                    p_c005          => wwv_flow.g_f07(i),',
'                    p_c006          => l_ident,',
'                    p_c010          => l_seq );',
'           end if; /* end null f01 check */',
'       end loop; /* end inner loop */',
'       ',
'    -- Without the commit, new column names won''t be saved in the collection',
'    -- if there is a validation error',
'    commit;',
'    -- exception when others then null;',
'    end;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'CANCEL'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00604
begin
wwv_flow_api.create_page(
 p_id=>604.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea tabella - Chiave primaria'
,p_step_title=>'Crea tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20269329848154731.4504)
,p_plug_name=>'Chiave primaria'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91083416001580038.4504)
,p_plug_name=>'Options'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149852620857337889.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149747621878186797.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239243731701329099.4504)
,p_plug_name=>'Chiave primaria'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208285802016555084.4504)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Una chiave primaria consente l''identificazione univoca di ciascuna riga di una tabella.</p>',
unistr('<p>Se si sceglie di popolare la chiave primaria da una nuova sequenza, verr\00E0 richiesto di immettere il nome della nuova sequenza. Se si sceglie di popolare la chiave primaria da una sequenza esistente, verr\00E0 richiesto di selezionare la sequenza. Entr')
||unistr('ambi i metodi provocano la generazione di un trigger sulla tabella. \00C8 anche possibile scegliere di non popolare la chiave primaria. Questo \00E8 l''unico metodo che consente di definire una chiave primaria composta costituita da pi\00F9 di due colonne.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239303110495213551.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752121422760695896.4504)
,p_plug_name=>'Crea tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20276207347223870.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239303110495213551.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20277321546227985.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(239303110495213551.4504)
,p_button_name=>'CONF'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Fine'
,p_button_position=>'CREATE'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(240252312979973105.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239303110495213551.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(240249023929966875.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239303110495213551.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169842000088985699.4504)
,p_branch_action=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'COL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(240252528121973106.4504)
,p_branch_action=>'f?p=&FLOW_ID.:145:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(240252312979973105.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169842608399988117.4504)
,p_branch_action=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'FK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169843216364990412.4504)
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CONS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169843826060993200.4504)
,p_branch_action=>'f?p=&APP_ID.:612:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CONF'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169844431255994742.4504)
,p_branch_action=>'f?p=&APP_ID.:604:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(240249208940966882.4504)
,p_branch_action=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(240249023929966875.4504)
,p_branch_sequence=>70
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20270022706162118.4504)
,p_name=>'P604_PK1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20269329848154731.4504)
,p_prompt=>'Chiave primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001||''(''||c002||'')'') a, c001',
'  from wwv_flow_collections',
' where collection_name = ''TBL_WIZ_COLUMNS'' and c001 is not null',
' order by seq_id',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona chiave primaria -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('<p>Specificare la colonna da utilizzare come chiave primaria della tabella. Una chiave primaria \00E8 una colonna che identifica una riga in modo univoco. Sebbene il database Oracle non richieda che una tabella disponga di una chiave primaria, questa pro')
||'cedura guidata richiede di definirne una.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20334224043534527.4504)
,p_name=>'P604_PK1_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20269329848154731.4504)
,p_prompt=>'Nome vincolo PRIMARY KEY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Specificare il nome del vincolo PRIMARY KEY.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20530911799365187.4504)
,p_name=>'P604_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20269329848154731.4504)
,p_prompt=>'Schema:'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20539917256385753.4504)
,p_name=>'P604_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20269329848154731.4504)
,p_prompt=>'Nome tabella:'
,p_source=>'P602_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Identifica il nome della tabella. I nomi di tabella devono essere conformi alle convenzioni di denominazione Oracle e non devono contenere spazi o iniziare con numeri o caratteri di sottolineatura/'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20554225614416502.4504)
,p_name=>'P604_PK_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20269329848154731.4504)
,p_item_default=>'NONE'
,p_prompt=>'Chiave primaria:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PK_TYPES'
,p_lov=>'.'||wwv_flow_api.id(20561306137429854.4504)||'.'
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Scegliere la modalit\00E0 di popolamento della chiave primaria. In alternativa, scegliere che il valore della chiave primaria non venga impostato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20608530481569326.4504)
,p_name=>'P604_EXISTING_SEQUENCE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(20269329848154731.4504)
,p_prompt=>'Nome sequenza'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SEQUENCES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(sequence_name) a, sequence_name b from sys.dba_sequences ',
'where sequence_owner = :OB_SCHEMA',
'order by sequence_name',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona sequenza -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'<p>Selezionare il nome della sequenza di database esistente da utilizzare per popolare il valore della chiave primaria.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20620731052635709.4504)
,p_name=>'P604_NEW_SEQUENCE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(20269329848154731.4504)
,p_prompt=>'Nome sequenza'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'<p>Selezionare il nome della nuova sequenza di database da creare per popolare la chiave primaria per questa nuova tabella.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23704509807354309.4504)
,p_name=>'P604_PK2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(20269329848154731.4504)
,p_prompt=>'Chiave primaria composta '
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001||''(''||c002||'')'') a, c001',
'  from wwv_flow_collections',
' where collection_name = ''TBL_WIZ_COLUMNS'' and c001 is not null',
' order by seq_id',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona chiave primaria composta -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('<p>Specificare la colonna che dovr\00E0 essere la seconda colonna nella chiave primaria della tabella. Sebbene il database Oracle non richieda che una tabella disponga di una chiave primaria composta, questa procedura guidata consente di identificarne un')
||'a composta da due colonne.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20578219212452492.4504)
,p_computation_sequence=>10
,p_computation_item=>'P604_PK1_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.generate_pk_name (',
'    p_owner => :OB_SCHEMA,',
'    p_name  => :P602_NAME )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20715932642901126.4504)
,p_computation_sequence=>20
,p_computation_item=>'P604_PK1'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P604_PK_TYPE = ''NONE'' or :P604_PK_TYPE is null) then',
'  return ''0'';',
'else',
'  return wwv_flow_sw_util.pick_pk(''TBL_WIZ_COLUMNS'');',
'end if;'))
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20631228028691583.4504)
,p_computation_sequence=>30
,p_computation_item=>'P604_NEW_SEQUENCE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_util.generate_seq_name (',
'    p_owner => :OB_SCHEMA,',
'    p_name  => :P602_NAME )'))
,p_compute_when=>'P604_NEW_SEQUENCE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20652831108739850.4504)
,p_validation_name=>'PK not null'
,p_validation_sequence=>10
,p_validation=>'P604_PK1'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare la chiave primaria.'
,p_validation_condition=>'P604_PK_TYPE'
,p_validation_condition2=>'NONE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(20270022706162118.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20665015093754100.4504)
,p_validation_name=>'PK_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P604_PK1_NAME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare il nome della chiave primaria.'
,p_validation_condition=>'P604_PK_TYPE'
,p_validation_condition2=>'NONE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(20334224043534527.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20691720466793559.4504)
,p_validation_name=>'PK_NAME available'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if not wwv_flow_builder.is_valid_identifier(''"''||:P604_PK1_NAME||''"'') then',
'   return wwv_flow_lang.system_message(''F4300.NOT_VALID_PK_NAME'',wwv_flow_escape.html(:P604_PK1_NAME));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name(p_name => :P604_PK1_NAME, p_owner => :P602_SCHEMA) then',
'   return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P604_PK1_NAME));',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore'
,p_validation_condition=>'P604_PK_TYPE'
,p_validation_condition2=>'NONE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(20334224043534527.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20695132025806363.4504)
,p_validation_name=>'SEQ_NAME available'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if not wwv_flow_builder.is_valid_identifier(''"''||:P604_NEW_SEQUENCE||''"'') then',
'   return wwv_flow_lang.system_message(''F4300.F4500.NOT_VALID_SEQ_NAME'',wwv_flow_escape.html(:P604_NEW_SEQUENCE));',
'end if;',
'    ',
'if not wwv_flow_sw_util.is_available_name(p_name => :P604_NEW_SEQUENCE, p_owner => :P602_SCHEMA) then',
'   return wwv_flow_lang.system_message(''F4300.F4500.NAME_ALREADY_USED'',wwv_flow_escape.html(:P604_NEW_SEQUENCE));',
'end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Errore.'
,p_validation_condition=>'P604_PK_TYPE'
,p_validation_condition2=>'NEW_SEQUENCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(20620731052635709.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20699525361823361.4504)
,p_validation_name=>'SEQUENCE not null'
,p_validation_sequence=>50
,p_validation=>'P604_EXISTING_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Specificare la sequenza.'
,p_validation_condition=>'P604_PK_TYPE'
,p_validation_condition2=>'EXISTING_SEQUENCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(20608530481569326.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(969054213424554629.4504)
,p_name=>'Hide All'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P604_PK_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(969054341878554630.4504)
,p_event_id=>wwv_flow_api.id(969054213424554629.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P604_EXISTING_SEQUENCE,P604_PK1_NAME,P604_PK1,P604_PK2,P604_NEW_SEQUENCE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(969054464401554631.4504)
,p_name=>'New Sequence'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P604_PK_TYPE'
,p_condition_element=>'P604_PK_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW_SEQUENCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(969054504918554632.4504)
,p_event_id=>wwv_flow_api.id(969054464401554631.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P604_NEW_SEQUENCE,P604_PK1,P604_PK1_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(969054601402554633.4504)
,p_name=>'Existing Sequence'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P604_PK_TYPE'
,p_condition_element=>'P604_PK_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING_SEQUENCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(969054776447554634.4504)
,p_event_id=>wwv_flow_api.id(969054601402554633.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P604_EXISTING_SEQUENCE,P604_PK1,P604_PK1_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(969054856433554635.4504)
,p_name=>'Not Populated/Identify'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P604_PK_TYPE'
,p_condition_element=>'P604_PK_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'NOT_GENERATED,IDENTITY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(969054914322554636.4504)
,p_event_id=>wwv_flow_api.id(969054856433554635.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P604_PK1_NAME,P604_PK1,P604_PK2'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00612
begin
wwv_flow_api.create_page(
 p_id=>612.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea tabella - Conferma'
,p_step_title=>'Crea tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215532403383713875)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'/*',
'    function showDDL(){',
'        theDDL = document.getElementById(''P612_DDL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''inline'';',
'        theDDL.style.display = ''inline'';',
'        showDiv.style.display = ''none'';',
'        }',
'        ',
'    function hideDDL(){',
'        theDDL = document.getElementById(''P612_DDL'');',
'        showDiv = document.getElementById(''ddlShow'');',
'        hideDiv = document.getElementById(''ddlHide'');',
'        hideDiv.style.display = ''none'';',
'        theDDL.style.display = ''none'';',
'        showDiv.style.display = ''inline'';',
'        }',
'*/',
'',
'    function buttonName(button){',
'        theButton = document.getElementById(''finishButton'');',
'        theRadio  = document.wwv_flow.p_v02;',
'        ',
'        for ( i = 0; i < theRadio.length; i++){',
'            if(theRadio[i].checked == "1"){',
'                theButton.value=''Next'';',
'                if(theRadio[i].value==''EDIT''){',
'                    theButton.value=''Next \>'';',
'                    break;}',
'                else{',
'			        theButton.value=''Finish'';',
'			        break;}',
'			}',
'        }',
'    }',
'',
'</script>',
'<style type="text/css">',
'    div.ddlClass{',
'        width:400px;',
'        height:300px;',
'        border:1px #3F8640 solid;',
'        font-family:monospace;',
'        text-overflow:auto;',
'        background:#C5D5C5;',
'        display:none;',
'        white-space: pre;}',
'',
'',
'</style>'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20110830429015704.4504)
,p_plug_name=>'DDL precedente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>30
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20121426189033453.4504)
,p_plug_name=>'Crea tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Confermare la richiesta.',
'<br /><br />'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20300320843502232.4504)
,p_plug_name=>'area di visualizzazione degli errori'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_source=>'wwv_flow_sw_api.display_error_msg (:SQL_COMMAND);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_sw_api.g_raise_errors'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35585522562396831.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>40
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149856819257346836.4504)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149747621878186797.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(703372217110859571.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239814206901553124.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752121581093695896.4504)
,p_plug_name=>'Crea tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20330523650506045.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239814206901553124.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20122606234037085.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(239814206901553124.4504)
,p_button_name=>'CREATE_TABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea tabella'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24249023185967338.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239814206901553124.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169879204215109957.4504)
,p_branch_action=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'COL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20332002013509754.4504)
,p_branch_action=>'604'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'PK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169880318414114045.4504)
,p_branch_action=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'FK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20975812341022796.4504)
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'CONS,PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169882531358127258.4504)
,p_branch_action=>'f?p=&APP_ID.:614:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(20122606234037085.4504)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20112732291025750.4504)
,p_name=>'P612_DDL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(35585522562396831.4504)
,p_prompt=>'Script SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>20
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20289304595374536.4504)
,p_name=>'P612_PARSE_STMT_AS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20121426189033453.4504)
,p_item_default=>'&OB_SCHEMA.'
,p_prompt=>'Schema:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20780626483154818.4504)
,p_name=>'P612_SEQUENCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20121426189033453.4504)
,p_prompt=>'Sequence'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21515224380972017.4504)
,p_name=>'P612_TABLENAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20121426189033453.4504)
,p_prompt=>'Nome tabella:'
,p_source=>'P602_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nome della tabella da creare'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21659220814256452.4504)
,p_name=>'P612_OPTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20121426189033453.4504)
,p_item_default=>'RUN'
,p_prompt=>'Azione:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE.TABLE.NOW.SCRIPT'
,p_lov=>'.'||wwv_flow_api.id(88093424937050988.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onClick="javascript:buttonName(''finishButton'');"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Le azioni disponibili includono:</p>',
'<ul class="noIndent">',
'<li>Selezionare l''opzione <strong>Crea tabella ora</strong> se si desidera creare la tabella utilizzando l''istruzione SQL generata da questa procedura guidata.</li> ',
'<li>Selezionare l''opzione <strong>Crea uno script per la modifica SQL</strong> per visualizzare e modificare le istruzioni SQL create da questa procedura guidata prima di creare o salvare la tabella.</li>',
'</li>',
'<li>Crea script per consentire la modifica SQL:<br />',
'Selezionare questa opzione se si desidera modificare lo script SQL generato oppure per conservarne una copia. Se si sceglie questa opzione, verranno visualizzati passi aggiuntivi della procedura guidata.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21839029227775115.4504)
,p_name=>'P612_JAVASCRIPT_FOR_RADIO'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20121426189033453.4504)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!-- do not translate -->',
'<script language="JavaScript1.1" type="text/javascript">',
'    buttonName(''finishButton'');',
'</script>'))
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20290106111384413.4504)
,p_computation_sequence=>10
,p_computation_item=>'P612_DDL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(32767) := :P612_DDL;',
'begin',
'  if l_sql is not null then',
'    l_sql := wwv_flow_utilities.remove_trailing_whitespace(l_sql);',
'    l_sql := rtrim(l_sql,chr(10)||''/'');',
'    l_sql := wwv_flow.trim_sql(p_sql=>l_sql,p_ends_in_semicolon=>false,p_do_substitutions=>true);',
'    return l_sql;',
'  end if;',
'end;'))
,p_computation_error_message=>'Impossibile calcolare la DDL.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20292829576410103.4504)
,p_validation_name=>'must select parse as'
,p_validation_sequence=>10
,p_validation=>'P612_PARSE_STMT_AS'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Specificare uno schema Oracle (NOME UTENTE) per l''analisi di questa istruzione.'
,p_validation_condition=>'CREATE_TABLE,SAVE_AS'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(20289304595374536.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20294006982422536.4504)
,p_validation_name=>'statement required'
,p_validation_sequence=>20
,p_validation=>'P612_DDL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un''istruzione per la creazione della tabella.'
,p_validation_condition=>'CREATE_TABLE,SAVE_AS'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(20112732291025750.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20295524774437073.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P612_PARSE_STMT_AS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il controllo dei privilegi.'
,p_process_when_button_id=>wwv_flow_api.id(20122606234037085.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21991618846548037.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
':P614_DDL_STATUS := wwv_flow_sw_page_calls.run_ddl(:P604_PK1,:P604_PK_TYPE,:P604_PK2,',
'                     :P602_NAME,:OB_SCHEMA,:P604_PK1_NAME,:P612_SEQUENCE);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(20122606234037085.4504)
,p_process_when=>'P612_OPTION'
,p_process_when2=>'RUN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20845603945271278.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset sequence name'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P612_SEQUENCE'
,p_process_when_type=>'WHEN_THIS_PAGE_NOT_SUBMITTED'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20900115851284176.4504)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set sequence name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  if :P604_PK_TYPE = ''NEW_SEQUENCE'' then',
'    :P612_SEQUENCE := :P604_NEW_SEQUENCE;',
'  elsif :P604_PK_TYPE = ''EXISTING_SEQUENCE'' then',
'    :P612_SEQUENCE := :P604_EXISTING_SEQUENCE;',
'  else',
'    :P612_SEQUENCE := NULL;',
'  end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'WHEN_THIS_PAGE_NOT_SUBMITTED'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20307224736184661.4504)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_temp varchar2(32767);',
'    l_test varchar2(32767);',
'    l_pk1 varchar2(200);',
'    l_pk2 varchar2(200);',
'begin',
'',
'  if (:P604_PK1 = ''0'' or :P604_PK1 is null  or :P604_PK_TYPE = ''NONE'')  then',
'    l_pk1 := null;',
'    :P604_PK1 := ''0'';',
'    :P604_PK1_NAME := null;',
'    :P604_PK_TYPE := null;',
'  else ',
'    l_pk1 := :P604_PK1;',
'  end if;',
'',
'  if (:P604_PK2 = ''0'' or :P604_PK2 is null  or :P604_PK_TYPE = ''NONE'') then',
'    l_pk2 := null;',
'  else ',
'    l_pk2 := :P604_PK2;',
'  end if;',
'',
'',
'l_temp := wwv_flow_sw_util.get_ddl(',
'  p_table_name =>:P602_NAME,',
'  p_schema     =>:OB_SCHEMA,',
'  p_pk1        =>l_pk1,',
'  p_pk2        =>l_pk2,',
'  p_pk1_name   =>:P604_PK1_NAME,',
'  p_pk1_type   =>:P604_PK_TYPE,',
'  p_seq_name   =>:P612_SEQUENCE,',
'  p_fk_name  => null,',
'  p_fk_col  =>   null,',
'  p_fk_ftable =>  null,',
'  p_fk_fcol  =>  null,',
'  p_fk_type  =>  null',
');',
':P612_DDL := l_temp;',
'',
'for c1 in (select seq_id,c001, c002, c003,c004,c005',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_FKS''',
'                order by seq_id) loop',
'',
'  l_temp := wwv_flow_sw_util.get_foreign_key_ddl(',
'    p_table_name =>:P602_NAME,',
'    p_schema     =>:OB_SCHEMA,',
'    p_seq_name   => null,',
'    p_fk_name    =>c1.c001,',
'    p_fk_col     =>c1.c002,',
'    p_fk_ftable  =>c1.c003,',
'    p_fk_fcol    =>c1.c004,',
'    p_fk_type    =>c1.c005',
'  );',
':P612_DDL := :P612_DDL||l_temp;',
'end loop;',
'',
'for c1 in (select seq_id,c001, c002, c003,c004',
'                 from wwv_flow_collections        ',
'                where collection_name = ''TBL_WIZ_CONS''',
'                order by seq_id) loop',
'',
'  l_temp := wwv_flow_sw_util.get_const_ddl(',
'    p_table_name =>:P602_NAME,',
'    p_schema     =>:OB_SCHEMA,',
'    p_con_name   =>c1.c001,',
'    p_type       =>c1.c002,',
'    p_check      =>c1.c004,',
'    p_cols       =>c1.c003',
'  );',
':P612_DDL := :P612_DDL||l_temp;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This is not the SQL that is run it is for displlay only'
);
end;
/
prompt --application/pages/page_00614
begin
wwv_flow_api.create_page(
 p_id=>614.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impossibile creare la tabella'
,p_step_title=>'Impossibile creare la tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215538527409730225)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_table.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15614407630951397.4504)
,p_plug_name=>'Impossibile creare la tabella'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>50
,p_plug_source=>'&P614_DDL_STATUS.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P614_DDL_STATUS'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969055267076554639.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15619015726963172.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(969055267076554639.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:612:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(480478407583792468.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(969055267076554639.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21888602027003848.4504)
,p_name=>'P614_DDL_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15614407630951397.4504)
,p_prompt=>'Stato'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when_type=>'NEVER'
,p_help_text=>'Testo Guida non disponibile.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35474220747561605.4504)
,p_computation_sequence=>20
,p_computation_item=>'P57_TABLE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&P602_NAME.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(70051718722155566.4504)
,p_computation_sequence=>30
,p_computation_item=>'P42_OBJECT_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id',
'from sys.dba_objects',
'where owner = :P56_SCHEMA',
'and object_name = :P57_TABLE',
'and object_type = ''TABLE'''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19976805608362137.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object_name/type/id and redirect to object browser'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' for r in ( select object_id,object_name,owner,object_type',
'from sys.dba_objects',
'where owner = :OB_SCHEMA',
'and object_name = :P602_NAME',
'and object_type = ''TABLE'' ) loop',
' :OBJECT_ID    := r.object_id;',
' :OBJECT_NAME  := r.object_name;',
' :OBJECT_OWNER := r.owner;',
' :OBJECT_TYPE  := r.object_type;',
'',
'end loop;',
'',
'sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':1001:''||:SESSION||'':FOCUS:::OB_CURRENT_TYPE,OB_OBJECT_ID:''||:OBJECT_TYPE||'',''||:OBJECT_ID);',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P614_DDL_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SUCCESS'
);
end;
/
prompt --application/pages/page_00701
begin
wwv_flow_api.create_page(
 p_id=>701.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Commenti tabelle'
,p_step_title=>'Commenti tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1514318650310360.4504)
,p_plug_name=>'Commenti tabelle'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P701a */ table_name,',
'       table_type,',
'       comments',
'  from sys.user_tab_comments',
' where table_name not like ''BIN$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P701_OWNER'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P701_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1514423881310360.4504)
,p_name=>'Table Comments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:70:P70_TABLE_NAME:#TABLE_NAME#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1514703753310477.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nome tabella'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1514823402310477.4504)
,p_db_column_name=>'TABLE_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Tipo di tabella'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1514913537310477.4504)
,p_db_column_name=>'COMMENTS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Commenti'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11566007059392200.4504)
,p_plug_name=>'schema holder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722740347063798631.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1514318650310360.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(24788509909060041.4504)
,p_branch_action=>'f?p=&FLOW_ID.:&P701_BACK.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P701_BACK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18552102336256921.4504)
,p_branch_action=>'701'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1516219246331048.4504)
,p_name=>'P701_EDIT_IND'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(11566007059392200.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18551728761256919.4504)
,p_name=>'P701_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11566007059392200.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema - '
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112117709249457804.4504)
,p_computation_sequence=>10
,p_computation_item=>'P701_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P701_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69207929426619009.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P701_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
,p_process_when=>'P701_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00702
begin
wwv_flow_api.create_page(
 p_id=>702.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Tabelle senza chiavi primarie'
,p_step_title=>'Tabelle senza chiavi primarie'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_excp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11591004915561994.4504)
,p_plug_name=>'object owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34150120028169627.4504)
,p_plug_name=>'Tabelle senza chiavi primarie'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name',
'  from sys.user_tables',
' where temporary = ''N''',
'   and table_name not like ''BIN$%''',
'   and table_name not in (select table_name',
'                            from sys.user_constraints',
'                           where constraint_type = ''P'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P702_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(34150221388169627.4504)
,p_name=>'Tables without Primary Keys'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34150426203169816.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Tabella senza chiavi primarie'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722738776029798615.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34150120028169627.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18560914534285915.4504)
,p_branch_action=>'702'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18560506556285914.4504)
,p_name=>'P702_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11591004915561994.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare il nome del proprietario dello schema di database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112186401059739325.4504)
,p_computation_sequence=>10
,p_computation_item=>'P702_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P702_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24507405816261503.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69216118044644162.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P702_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00704
begin
wwv_flow_api.create_page(
 p_id=>704.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Chiavi esterne non indicizzate'
,p_step_title=>'Chiavi esterne non indicizzate'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_excp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8710806460667309.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24484410870177872.4504)
,p_plug_name=>'Chiavi esterne non indicizzate'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Questo report visualizza le tabelle senza chiavi esterne indicizzate. La mancata indicizzazione delle chiavi esterne pu\00F2 provocare prestazioni di join insoddisfacenti e causare un lock escalation. In genere \00E8 buona norma di programmazione indicizz')
||'are le chiavi esterne.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441195900047724309.4504)
,p_plug_name=>'Chiavi esterne non indicizzate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'/*gather all referential constraints of interest, including their column lists*/',
'cons_cols as (',
'    select',
'        cons.owner,',
'        cons.table_name,',
'        cons.constraint_name,',
'        listagg(''"''||cols.column_name||''"'', '','') within group (order by cols.position) as columns',
'    from sys.user_constraints cons',
'    join sys.user_cons_columns cols',
'        on cols.owner = cons.owner',
'        and cols.constraint_name = cons.constraint_name',
'    where cons.constraint_type = ''R''',
'    and cons.table_name not like ''BIN$%''',
'    and cons.table_name not like ''DR$%''',
'    and cons.table_name not like ''APEX$%''',
'    group by',
'        cons.owner,',
'        cons.table_name,',
'        cons.constraint_name',
'),',
'/*generate a suggested name for the index*/',
'cons as (',
'    select',
'        cons_cols.owner,',
'        cons_cols.table_name,',
'        cons_cols.constraint_name,',
'        cons_cols.columns,',
'        replace(''%_IDX'', ''%'',',
'            rtrim(substr(',
'                case when cons_cols.constraint_name like ''SYS/_%'' escape ''/''',
'                then replace(cons_cols.constraint_name,''_FK'','''')',
'                else cons_cols.table_name || ''_'' || translate(cons_cols.columns,''A,"'',''A'')',
'                end',
'                ,1,to_number(:P704_MAX_IDENTIFIER_LENGTH)-length(''%_IDX'')+1)',
'                ,''_'')',
'           ) as suggested_index_name        ',
'    from cons_cols',
')',
'/*report any referential integrity constraints that don''t have a matching index (i.e. leading columns are indexed)*/',
'select',
'    cons.owner,',
'    cons.table_name,',
'    cons.constraint_name,',
'    cons.columns as foreign_key_columns,',
'    suggested_index_name,',
'    ''CREATE INDEX "'' || cons.owner || ''"."'' || cons.suggested_index_name',
'        || ''" ON "'' || cons.owner || ''"."'' || cons.table_name',
'        || ''" ('' || cons.columns || '');'' as suggested_ddl',
'from cons',
'left join (',
'    /*note that this will not detect an index of interest that happens to be owned by a different schema;',
'      we could use all_ind_columns and join on table_owner but performance on large multitenant instances',
'      like our hosted instances suffers*/',
'    select',
'        table_name,',
'        index_name,',
'        listagg(''"''||column_name||''"'', '','') within group (order by column_position) as columns',
'    from sys.user_ind_columns',
'    group by',
'        table_name,',
'        index_name',
'    ) ind',
'    on ind.table_name = cons.table_name',
'    and ind.columns like cons.columns || ''%'' /*if the index includes additional columns, it''s still suitable*/',
'where ind.table_name is null /*only show the ones where a matching index was not found*/',
'order by',
'    cons.owner,',
'    cons.table_name,',
'    cons.constraint_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P704_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441196021144724309.4504)
,p_name=>'Unindexed Foreign Keys'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2700325745215603.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>10
,p_column_identifier=>'E'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441196217916724534.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>20
,p_column_identifier=>'A'
,p_column_label=>'Nome tabella'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441196309630724537.4504)
,p_db_column_name=>'CONSTRAINT_NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Nome vincolo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2700458601215604.4504)
,p_db_column_name=>'FOREIGN_KEY_COLUMNS'
,p_display_order=>40
,p_column_identifier=>'F'
,p_column_label=>'Colonne chiavi esterne'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2700559254215605.4504)
,p_db_column_name=>'SUGGESTED_INDEX_NAME'
,p_display_order=>50
,p_column_identifier=>'G'
,p_column_label=>'Nome indice suggerito'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2700616717215606.4504)
,p_db_column_name=>'SUGGESTED_DDL'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'DDL suggerito'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722738533377798613.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441195900047724309.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2700768472215607.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(441195900047724309.4504)
,p_button_name=>'CREATE_SCRIPT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea script'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2700919157215609.4504)
,p_branch_name=>'show script'
,p_branch_action=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:60:P60_FILE_ID:&P704_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2700768472215607.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P704_FILE_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18587514102515500.4504)
,p_branch_name=>'Go To Page 704'
,p_branch_action=>'704'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2700105229215601.4504)
,p_name=>'P704_MAX_IDENTIFIER_LENGTH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8710806460667309.4504)
,p_source=>'return wwv_flow_db_version.c_actual_dbms_id_length;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2700291216215602.4504)
,p_name=>'P704_FILE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(8710806460667309.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2701043322215610.4504)
,p_name=>'P704_SCRIPT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(8710806460667309.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18587109795515499.4504)
,p_name=>'P704_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8710806460667309.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112203211972780360.4504)
,p_computation_sequence=>10
,p_computation_item=>'P704_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P704_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2700863414215608.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_max_identifier_length number := wwv_flow_db_version.c_actual_dbms_id_length;',
'    l_script_name           varchar2(255);',
'    l_clob                  clob;',
'    l_file_id               number;',
'begin',
'',
'    l_script_name := ''FK indexes for '' || :P704_OWNER;',
'',
'    l_clob := '''';',
'',
'    -- this must use the dba dictionary views',
'    for r in (',
'        with',
'        /*gather all referential constraints of interest, including their column lists*/',
'        cons_cols as (',
'            select',
'                cons.owner,',
'                cons.table_name,',
'                cons.constraint_name,',
'                listagg(''"''||cols.column_name||''"'', '','') within group (order by cols.position) as columns',
'            from sys.dba_constraints cons',
'            join sys.dba_cons_columns cols',
'                on cols.owner = cons.owner',
'                and cols.constraint_name = cons.constraint_name',
'            where cons.constraint_type = ''R''',
'            and cons.table_name not like ''BIN$%''',
'            and cons.table_name not like ''DR$%''',
'            and cons.table_name not like ''APEX$%''',
'            and cons.owner = :P704_OWNER',
'            group by',
'                cons.owner,',
'                cons.table_name,',
'                cons.constraint_name',
'        ),',
'        /*generate a suggested name for the index*/',
'        cons as (',
'            select',
'                cons_cols.owner,',
'                cons_cols.table_name,',
'                cons_cols.constraint_name,',
'                cons_cols.columns,',
'                replace(''%_IDX'', ''%'',',
'                    rtrim(substr(',
'                        case when cons_cols.constraint_name like ''SYS/_%'' escape ''/''',
'                        then replace(cons_cols.constraint_name,''_FK'','''')',
'                        else cons_cols.table_name || ''_'' || translate(cons_cols.columns,''A,"'',''A'')',
'                        end',
'                        ,1,l_max_identifier_length-length(''%_IDX'')+1)',
'                        ,''_'')',
'                   ) as suggested_index_name        ',
'            from cons_cols',
'        )',
'        /*report any referential integrity constraints that don''t have a matching index (i.e. leading columns are indexed)*/',
'        select',
'            cons.owner,',
'            cons.table_name,',
'            cons.constraint_name,',
'            cons.columns as foreign_key_columns,',
'            suggested_index_name,',
'            ''CREATE INDEX "'' || cons.owner || ''"."'' || cons.suggested_index_name',
'                || ''" ON "'' || cons.owner || ''"."'' || cons.table_name',
'                || ''" ('' || cons.columns || '');'' as suggested_ddl',
'        from cons',
'        left join (',
'            select',
'                table_owner,',
'                table_name,',
'                index_name,',
'                listagg(''"''||column_name||''"'', '','') within group (order by column_position) as columns',
'            from sys.dba_ind_columns',
'            where table_owner = :P704_OWNER',
'            group by',
'                table_owner,',
'                table_name,',
'                index_name',
'            ) ind',
'            on ind.table_owner = cons.owner',
'            and ind.table_name = cons.table_name',
'            and ind.columns like cons.columns || ''%'' /*if the index includes additional columns, it''s still suitable*/',
'        where ind.table_name is null /*only show the ones where a matching index was not found*/',
'        order by',
'            cons.owner,',
'            cons.table_name,',
'            cons.constraint_name',
'    ) loop',
'        l_clob := case when l_clob is not null then',
'                      l_clob',
'                      || wwv_flow.lf',
'                  end',
'            || ''prompt Create index '' || r.suggested_index_name || '' on '' || r.owner || ''.'' || r.table_name',
'            || wwv_flow.lf',
'            || r.suggested_ddl',
'            || wwv_flow.lf;',
'    end loop;',
'',
'    if l_clob is null then',
'        raise_application_error(-20000, ''No indexes were suggested.'');',
'    end if;',
'    ',
'    l_file_id := wwv_flow_id.next_val;',
'',
'    wwv_flow_sw_script.create_script_from_clob (        ',
'        p_script_name => l_script_name,',
'        p_script      => l_clob,',
'        p_file_id     => l_file_id',
'    );',
'    ',
'    :P704_FILE_ID     := l_file_id;',
'    :P704_SCRIPT_NAME := l_script_name;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2700768472215607.4504)
,p_process_success_message=>'Script creato: &P704_SCRIPT_NAME.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69219124755655532.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P704_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00706
begin
wwv_flow_api.create_page(
 p_id=>706.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Vincoli di tabella'
,p_step_title=>'Vincoli di tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11572824898435245.4504)
,p_plug_name=>'object owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441097114297107344.4504)
,p_plug_name=>'Vincoli di tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P706a */ table_name,',
'       constraint_name,',
'      decode(c.constraint_type,',
'''P'',wwv_flow_lang.system_message(''F4500_PRIMARY''),',
'''U'',wwv_flow_lang.system_message(''F4500_UNIQUE''),',
'''R'',wwv_flow_lang.system_message(''F4500_REFERENTIAL''),',
'''C'',wwv_flow_lang.system_message(''F4500_CHECK'')) cons_type,',
'      status, :P706_OWNER as owner',
'  from sys.user_constraints c',
' where table_name not like ''BIN$%'' and table_name not like ''DR$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P706_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441097230058107344.4504)
,p_name=>'Table Constraints'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441097414035107425.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nome tabella'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441097524547107435.4504)
,p_db_column_name=>'CONSTRAINT_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nome vincolo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441097614240107437.4504)
,p_db_column_name=>'CONS_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Tipo di vincolo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441097708697107438.4504)
,p_db_column_name=>'STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Stato'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441097818220107439.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722740289719798630.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441097114297107344.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21102712190146129.4504)
,p_branch_action=>'706'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21102311093146127.4504)
,p_name=>'P706_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11572824898435245.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112167713853591637.4504)
,p_computation_sequence=>10
,p_computation_item=>'P706_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P706_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69209918475625379.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P706_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00707
begin
wwv_flow_api.create_page(
 p_id=>707.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Tabelle senza indici'
,p_step_title=>'Tabelle senza indici'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_excp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8706200096656047.4504)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34151919153185207.4504)
,p_plug_name=>'Tabelle senza indici'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.table_name, :P707_OWNER as object_owner, o.object_id',
'from sys.user_objects o,',
'(select table_name',
'   from sys.user_tables ut',
'  where ut.temporary = ''N''',
'    and ut.table_name not like ''BIN$%''',
'    and ut.table_name not in ( select table_name',
'                              from sys.user_indexes)',
'    and not exists (select 1 from sys.user_objects where ut.table_name = object_name and object_type = ''MATERIALIZED VIEW'')',
') t',
'where o.object_type = ''TABLE''',
'  and t.table_name = o.object_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P707_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(34152010345185207.4504)
,p_name=>'Tables without Indexes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34152223184185456.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nome tabella'
,p_column_link=>'f?p=4500:1001:&SESSION.:FOCUS:&DEBUG.::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:#OBJECT_ID#,#OBJECT_TYPE#,#OBJECT_OWNER#'
,p_column_linktext=>'#TABLE_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34152419864185457.4504)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Oggetto'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34152308640185457.4504)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722738668314798614.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34151919153185207.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29035419971246286.4504)
,p_branch_action=>'707'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29034726120246281.4504)
,p_name=>'P707_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8706200096656047.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112197521060764030.4504)
,p_computation_sequence=>10
,p_computation_item=>'P707_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P707_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69217908479650829.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P707_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_00800
begin
wwv_flow_api.create_page(
 p_id=>800.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dizionario tabelle'
,p_step_title=>'Dizionario tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40286007077665046.4504)
,p_plug_name=>'Valori predefiniti interfaccia utente'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       wwv_flow_lang.system_message(''NO'') defaults_exist,',
'       ''#IMAGE_PREFIX#htmldb/icons/icon_uid_without_defaults.gif'' icon_name,',
'       decode(wo.object_type,',
'              ''TABLE'',wwv_flow_lang.system_message(''TABLE''),',
'              ''VIEW'',wwv_flow_lang.system_message(''VIEW''),',
'              wo.object_type) icon_alt_tag,',
'       ''f?p=4500:801:''||:app_session||',
'       ''::NO:RP,801,802:P800_SCHEMA,P801_TABLE_ID,P802_TABLE_ID:''||',
'       :P800_SCHEMA||'',''||wo.object_id||'','' edit_link,',
'       replace(replace(wo.object_name,''_'','' ''),''$'',''$ '') object_display_name,',
'       replace(wo.object_name,''$'',''$ '') object_name,',
'       wo.object_id,',
'       wo.object_type',
'  from ',
'(',
'-- objects without hints',
'select (select object_id',
'          from sys.dba_objects a',
'         where h.table_name = a.object_name',
'           and a.owner = :P800_SCHEMA',
'           and a.object_type in (''TABLE'',''VIEW'')) object_id,',
'       h.table_name object_name,',
'       (select d.object_type',
'          from sys.dba_objects d',
'         where h.table_name = d.object_name',
'           and d.owner = :P800_SCHEMA',
'           and d.object_type in (''TABLE'',''VIEW'')) object_type',
'  from (select object_name table_name',
'          from sys.dba_objects',
'         where object_type in (''TABLE'',''VIEW'')',
'           and owner = :P800_SCHEMA',
'           and object_name not like ''BIN$%''',
'           and object_name not like ''APEX$%''',
'           and object_name not like ''DR$%''',
'           and object_name not like ''SYS_IOT_%''',
'        MINUS',
'        select table_name',
'          from WWV_FLOW_HNT_TABLE_INFO',
'         where SCHEMA = :P800_SCHEMA) h ',
') wo',
'UNION',
'-- objects with hints',
'select wwv_flow_lang.system_message(''YES'') defaults_exist,',
'        decode(w.object_type,',
'               ''N'',''#IMAGE_PREFIX#htmldb/icons/icon_uid_without_table.gif'',',
'                   ''#IMAGE_PREFIX#htmldb/icons/icon_uid_with_defaults.gif'') icon_name,',
'       decode(w.object_type,',
'              ''N'',wwv_flow_lang.system_message(''NOT_IN_DATA_DICT''),',
'                  w.object_type) icon_alt_tag,',
'       ''f?p=4500:802:''||:app_session||',
'       ''::NO:RP,802:P800_SCHEMA,P802_TABLE_ID:''||',
'       :P800_SCHEMA||'',''||w.table_id edit_link,',
'       replace(w.object_name,''_'','' '') object_display_name,',
'       w.object_name,',
'       w.table_id object_id,',
'       upper(w.object_type) object_type',
'  from (',
'select h.table_id,',
'       h.table_name object_name,',
'       nvl((select decode(d.object_type,',
'                          ''TABLE'',wwv_flow_lang.system_message(''TABLE''),',
'                          ''VIEW'',wwv_flow_lang.system_message(''VIEW''),',
'                          d.object_type)',
'              from sys.dba_objects d',
'             where h.table_name = d.object_name',
'               and h.schema = d.owner',
'               and d.object_type in (''TABLE'',''VIEW'')),',
'            wwv_flow_lang.system_message(''NOT_IN_DATA_DICT'')) object_type,',
'       last_updated_on,',
'       last_updated_by',
'  from WWV_FLOW_HNT_TABLE_INFO h',
' where h.schema  = :P800_SCHEMA',
') w'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(40286123901665046.4504)
,p_name=>'User Interface Defaults'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'EDIT_LINK'
,p_icon_view_img_src_column=>'ICON_NAME'
,p_icon_view_label_column=>'OBJECT_DISPLAY_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40286431240665098.4504)
,p_db_column_name=>'ICON_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Icona'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#ICON_NAME#'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40286524116665098.4504)
,p_db_column_name=>'ICON_ALT_TAG'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Tag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40286627278665098.4504)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Collegamento Modifica'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40286730575665098.4504)
,p_db_column_name=>'OBJECT_DISPLAY_NAME'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Nome oggetto'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40286829978665098.4504)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'ID oggetto'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40286918582665099.4504)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40286319008665090.4504)
,p_db_column_name=>'DEFAULTS_EXIST'
,p_display_order=>7
,p_column_identifier=>'A'
,p_column_label=>'Esistono valori predefiniti'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471529820585334127.4504)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Nome oggetto'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40290006946818687.4504)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40848912973693399.4504)
,p_plug_name=>'Task'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(40848526002687735.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194506030480237353.4504)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(194504915759237345.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201908823096522017.4504)
,p_plug_name=>'Dizionario tabelle'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I valori predefiniti dell''interfaccia utente vengono utilizzati per popolare i valori iniziali per l''area e le propriet\00E0 degli elementi che assicurano la coerenza su pi\00F9 pagine in un''applicazione o su pi\00F9 applicazioni.</p>'),
'',
unistr('<p>Il dizionario tabelle \00E8 specifico di tabelle e colonne all''interno di uno schema selezionato. Questi valori predefiniti saranno utilizzati in quelli definiti in un dizionario attributi.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(262104519763193943.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(40286007077665046.4504)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(46779314754007949.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(40286007077665046.4504)
,p_button_name=>'SYNCHRONIZE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sincronizza'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:840:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40668908699241110.4504)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40287126977670257.4504)
,p_name=>'P800_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40290006946818687.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select /* APEX4500L1 */ wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1003_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1003_SCHEMA) a,:P1003_SCHEMA b from dual '';',
'  q:=q||''where  :P1003_POPUP = 1 '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1019610214909694499.4504)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(40848912973693399.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1019610511242694500.4504)
,p_event_id=>wwv_flow_api.id(1019610214909694499.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:800:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40288828108777466.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>':P800_SCHEMA := nvl(:P3002_SCHEMA, upper(wwv_flow_user_api.get_default_schema));'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P800_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2555920107878997793.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00801
begin
wwv_flow_api.create_page(
 p_id=>801.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea valori predefiniti di dizionario di tabella'
,p_step_title=>'Crea valori predefiniti di dizionario di tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40294116352925502.4504)
,p_plug_name=>'Crea valori predefiniti di dizionario di tabella'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>30
,p_plug_header=>'<p>La tabella/vista selezionata non si trova attualmente nel dizionario tabelle. I valori predefiniti verranno creati dalla definizione di tabella e colonna nel database.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755295791925836823.4504)
,p_plug_name=>'Pulsanti procedura guidata'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755295807893836824.4504)
,p_plug_name=>'Crea valori predefiniti di dizionario di tabella'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40294524926946897.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(755295791925836823.4504)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea valori predefiniti'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40301521828097320.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(755295791925836823.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40301830704097320.4504)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40294009426923443.4504)
,p_name=>'P801_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40294116352925502.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40300901265081958.4504)
,p_name=>'P801_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40294116352925502.4504)
,p_prompt=>'Nome tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40304405092234425.4504)
,p_name=>'P801_DEFAULT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40294116352925502.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40304718252238203.4504)
,p_name=>'P801_DEFAULT_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(40294116352925502.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(427726303876522786.4504)
,p_name=>'P801_SCHEMA'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(40294116352925502.4504)
,p_prompt=>'Schema:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40293109595885680.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create meta data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_hint.synch_hints(',
'  p_schema=>:P800_SCHEMA,',
'  p_table_name=>:P801_TABLE_NAME);',
'',
'-- Get new table id',
'for c1 in (select table_id',
'             from wwv_flow_hnt_table_info',
'            where schema     = :P800_SCHEMA',
'              and table_name = :P801_TABLE_NAME)',
'loop',
'   :P801_DEFAULT_ID := c1.table_id;',
'end loop;',
'',
':P801_DEFAULT_STATUS := wwv_flow_hint.check_table(',
'    p_schema=>:P800_SCHEMA,',
'    p_table_name=>:P801_TABLE_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Azione non completata'
,p_process_success_message=>'Azione completata'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2555923208205196619.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40305830813298591.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select object_name ',
'from sys.dba_objects ',
'where object_id = :P801_TABLE_ID) loop',
'   :P801_table_name := c1.object_name;',
'end loop;',
'',
':P801_SCHEMA := :P800_SCHEMA;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00802
begin
wwv_flow_api.create_page(
 p_id=>802.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>unistr('Propriet\00E0 tabella e colonna')
,p_step_title=>unistr('Propriet\00E0 tabella e colonna')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_javascript_code=>'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40299713207047545.4504)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40437215497993577.4504)
,p_plug_name=>'Valori predefiniti interfaccia utente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT TABLE_ID,',
'       COLUMN_ID, ',
'       ''f?p=4500:803:''||:FLOW_SESSION||''::NO:803:''||',
'          ''P803_TABLE_ID,P803_COLUMN_ID:''||',
'          table_id||'',''||column_id',
'       edit_link,',
'       COLUMN_NAME, ',
'       LABEL,',
'      (select max(GROUP_NAME)',
'       from   WWV_FLOW_HNT_GROUPS g',
'       where  g.table_id = c.table_id and',
'              g.group_id = c.group_id) column_group,',
'      (select max(DISPLAY_SEQUENCE) ',
'       from   WWV_FLOW_HNT_GROUPS g',
'       where  g.table_id = c.table_id and',
'              g.group_id = c.group_id) column_group_DISPLAY_SEQUENCE,',
'       decode(display_in_report,''Y'',''<span class="a-Icon icon-check"></span>'',null) display_in_report, ',
'       DISPLAY_SEQ_REPORT, ',
'       MASK_REPORT,',
'       decode(c.alignment,',
'              ''L'',l.m,''C'',ctr.m,''R'',r.m,null) alignment,',
'       DISPLAY_AS_TAB_FORM,  -- need lov',
'       decode(display_in_form,''Y'',''<span class="a-Icon icon-check"></span>'',null) display_in_form, ',
'       DISPLAY_SEQ_FORM, ',
'       DISPLAY_AS_FORM,      -- need lov',
'       MASK_FORM,',
'       DEFAULT_VALUE, ',
'       DISPLAY_WIDTH, ',
'       MAX_WIDTH, ',
'       HEIGHT, ',
'       decode(required,''Y'',''<span class="a-Icon icon-check"></span>'',null) required, ',
'       (case when length(help_text) > 255 ',
'             then substr(help_text,1,255)||'' ...''',
'             else help_text',
'             end) ',
'             help_text, ',
'       length(help_text) help_length,',
'       (case when length(lov_query) > 255 ',
'             then substr(LOV_QUERY,1,255)||'' ...''',
'             else lov_query',
'             end) ',
'             lov_query,',
'       (case when length(WWV_FLOW_HINT.GET_STATIC_LOV_STRING(COLUMN_ID)) > 255',
'             then substr(WWV_FLOW_HINT.GET_STATIC_LOV_STRING(COLUMN_ID),1,255)||'' ...''',
'             else WWV_FLOW_HINT.GET_STATIC_LOV_STRING(COLUMN_ID)',
'             end) STATIC_LOV',
'  FROM WWV_FLOW_HNT_COLUMN_INFO c,',
'       (select wwv_flow_lang.system_message(''LEFT'') m from dual) l,',
'       (select wwv_flow_lang.system_message(''CENTER'') m from dual) ctr,',
'       (select wwv_flow_lang.system_message(''RIGHT'') m from dual) r',
' where table_id = :P802_TABLE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(40437331524993577.4504)
,p_name=>'User Interface Defaults'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40437508053993609.4504)
,p_db_column_name=>'TABLE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID tabella'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40437615428993612.4504)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'ID colonna'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40437724037993613.4504)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nome colonna'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#COLUMN_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40437821566993613.4504)
,p_db_column_name=>'LABEL'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Etichetta'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40437913601993613.4504)
,p_db_column_name=>'DISPLAY_IN_REPORT'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Visualizza nel report'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40438002528993613.4504)
,p_db_column_name=>'DISPLAY_SEQ_REPORT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Sequenza'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40438232560993613.4504)
,p_db_column_name=>'MASK_REPORT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Maschera di visualizzazione report'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40438309835993614.4504)
,p_db_column_name=>'ALIGNMENT'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Allineamento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40438723721993614.4504)
,p_db_column_name=>'DISPLAY_AS_TAB_FORM'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Visualizza come form di scheda'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40438825175993614.4504)
,p_db_column_name=>'DISPLAY_IN_FORM'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Visualizza nel form'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40438914466993615.4504)
,p_db_column_name=>'DISPLAY_SEQ_FORM'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Sequenza form'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439021205993615.4504)
,p_db_column_name=>'DISPLAY_AS_FORM'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Visualizza come form'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(29577622544843540)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439117728993615.4504)
,p_db_column_name=>'MASK_FORM'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Maschera di visualizzazione form'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439220175993615.4504)
,p_db_column_name=>'DEFAULT_VALUE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Valore predefinito'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439329305993615.4504)
,p_db_column_name=>'DISPLAY_WIDTH'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Larghezza visualizzazione'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439407905993615.4504)
,p_db_column_name=>'MAX_WIDTH'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Larghezza massima'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439517919993616.4504)
,p_db_column_name=>'HEIGHT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Altezza'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439605629993616.4504)
,p_db_column_name=>'REQUIRED'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Richiesto'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439731737993617.4504)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Testo Guida'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439807311993617.4504)
,p_db_column_name=>'LOV_QUERY'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Query LOV'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40439919134993617.4504)
,p_db_column_name=>'STATIC_LOV'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'LOV statica'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40592205362023494.4504)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Collegamento Modifica'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40609316069499661.4504)
,p_db_column_name=>'COLUMN_GROUP'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Gruppo di colonne'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40609515161508828.4504)
,p_db_column_name=>'COLUMN_GROUP_DISPLAY_SEQUENCE'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Sequenza di visualizzazione dei gruppi di colonne'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40837013881334138.4504)
,p_db_column_name=>'HELP_LENGTH'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Lunghezza Guida'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40666404319823610.4504)
,p_plug_name=>'Task'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(40650212014681045.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(429073412399033036.4504)
,p_plug_name=>'Avvertenza: le colonne richiedono una lista di valori'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385893260111566687.4504)
,p_plug_display_sequence=>25
,p_plug_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_hint.check_lov_issues(:P802_TABLE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<img src="#IMAGE_PREFIX#htmldb/icons/alert_warning.gif" alt=""/> La seguente o le seguenti colonne hanno tipi di visualizzazione che richiedono una lista di valori, che per\00F2 non \00E8 stata definita.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201423923688272695.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_button_name=>'EDIT_TABLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Modifica valori predefiniti tabella'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:19:P19_TABLE_ID:&P802_TABLE_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451854508938899874.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_button_name=>'GET_PREVIOUS_TABLE_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_TABLE_ID'')'
,p_button_condition=>'P802_TABLE_ID_PREV'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451854426160899873.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_button_name=>'GET_NEXT_TABLE_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Successivo'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_TABLE_ID'')'
,p_button_condition=>'P802_TABLE_ID_NEXT'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451855830940899886.4504)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.::P802_TABLE_ID:&P802_TABLE_ID_NEXT.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(451854426160899873.4504)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451856005423899888.4504)
,p_branch_action=>'f?p=&FLOW_ID.:802:&SESSION.::&DEBUG.::P802_TABLE_ID:&P802_TABLE_ID_PREV.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(451854508938899874.4504)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40300021172049834.4504)
,p_name=>'P802_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40302223475116797.4504)
,p_name=>'P802_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_prompt=>'Nome oggetto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica la tabella o la vista di database corrispondente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40353026503720715.4504)
,p_name=>'P802_TABLE_EXISTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_prompt=>'Oggetto esistente:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indica se la tabella esiste nello schema selezionato.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40649202486640460.4504)
,p_name=>'P802_SCHEMA'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica lo schema di database selezionato.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201435615695393318.4504)
,p_name=>'P802_FORM_REGION_TITLE'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_prompt=>'Titolo area form:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se si crea un form che fa riferimento a questa tabella, questo titolo verr\00E0 utilizzato come titolo di area risultante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201436224006395726.4504)
,p_name=>'P802_REPORT_REGION_TITLE'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_prompt=>'Titolo area report:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se si crea un report che fa riferimento a questa tabella, questo titolo verr\00E0 utilizzato come titolo di area risultante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(429075312923071029.4504)
,p_name=>'P802_LOV_ISSUES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(429073412399033036.4504)
,p_source=>'wwv_flow_hint.check_lov_issues(:P802_TABLE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="htmldbWarning"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451854810728899876.4504)
,p_name=>'P802_TABLE_ID_NEXT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451855005289899881.4504)
,p_name=>'P802_TABLE_ID_PREV'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451855229265899883.4504)
,p_name=>'P802_TABLE_ID_COUNT'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(40299713207047545.4504)
,p_prompt=>'Oggetto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451855629871899885.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_HNT_TABLE_INFO'
,p_attribute_03=>'P802_TABLE_ID'
,p_attribute_04=>'TABLE_ID'
,p_attribute_07=>'TABLE_NAME'
,p_attribute_09=>'P802_TABLE_ID_NEXT'
,p_attribute_10=>'P802_TABLE_ID_PREV'
,p_attribute_13=>'P802_TABLE_ID_COUNT'
,p_attribute_14=>'schema = :P800_SCHEMA'
,p_process_error_message=>'Impossibile eseguire il processo Richiama valore di chiave primaria successivo o precedente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2555916914580933506.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40306618261313899.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'load table properties'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select schema, table_name, form_region_title, report_region_title',
'     from #OWNER#.WWV_FLOW_HNT_TABLE_INFO ',
'    where table_id = :P802_TABLE_ID) ',
'loop',
'   if 1||:P800_SCHEMA <> 1||c1.schema then',
'      :P802_TABLE_ID := null;',
'      exit;',
'   end if;',
'',
'   :P802_TABLE_NAME          := c1.table_name;',
'   :P802_FORM_REGION_TITLE   := c1.form_region_title;',
'   :P802_REPORT_REGION_TITLE := c1.report_region_title;',
'   :P802_TABLE_EXISTS        := ''No'';',
'',
'   for c2 in (',
'      select table_name',
'        from sys.user_tables',
'       where table_name = c1.table_name) ',
'   loop',
'      :P802_TABLE_EXISTS := ''Yes'';',
'   end loop;',
'',
'   if :P802_TABLE_EXISTS = ''No'' then',
'      for c3 in (',
'         select view_name',
'           from sys.user_views',
'          where view_name = c1.table_name) ',
'      loop',
'         :P802_TABLE_EXISTS := ''Yes'';',
'      end loop;',
'   end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00803
begin
wwv_flow_api.create_page(
 p_id=>803.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Valori predefiniti colonne'
,p_step_title=>'Valori predefiniti colonne'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_javascript_code=>'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
,p_step_template=>wwv_flow_api.id(690783120585803188.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40567718307686659.4504)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40593701599050795.4504)
,p_plug_name=>'Colonna'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40593919911050798.4504)
,p_plug_name=>'Valori predefiniti generali'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40594104898050799.4504)
,p_plug_name=>'Valori predefiniti report e form tabulare'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40594513838050802.4504)
,p_plug_name=>'Valori predefiniti form'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'// nascondere gli attributi dinamici subito dopo che sono stati visualizzati, ',
unistr('// poich\00E9 jQuery.ready potrebbe richiedere troppo tempo. '),
'apex.builder.dynamicAttributes.hide(''P803_FORM_'');',
'</script>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40650909721689914.4504)
,p_plug_name=>'Task'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(40650212014681045.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46292112983679077.4504)
,p_plug_name=>'Selettore di visualizzazione area'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717413953976820775.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(293403116472848342.4504)
,p_plug_name=>'Lista di valori'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(423915426347766246.4504)
,p_plug_name=>'Valori predefiniti colonne'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Se \00E8 stato selezionato un tipo di visualizzazione che richiede una lista di valori (ad esempio Gruppo pulsanti di scelta o Lista di selezione), fornire una query di lista di valori o creare una lista di valori statica.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(429076825998093741.4504)
,p_plug_name=>'Avvertenza: lista di valori richiesta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_plug_source=>unistr('<img src="#IMAGE_PREFIX#htmldb/icons/alert_warning.gif" alt=""/> Questa colonna ha un tipo di visualizzazione (per form o report) che richiede una lista di valori, che per\00F2 non \00E8 stata definita.')
,p_plug_query_row_template=>wwv_flow_api.id(11028007180514315.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'instr('',''||wwv_flow_hint.check_lov_issues(:P803_TABLE_ID)||'','','',''||:P803_COLUMN_NAME||'','') > 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460118521920020424.4504)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>90
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P803_DISPLAY_AS_FORM and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_item_type,',
'        p_type_page_item_name => ''P803_DISPLAY_AS_FORM'',',
'        p_page_item_prefix    => ''P803_FORM_'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40559215564661672.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(436576801146358511.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(293403116472848342.4504)
,p_button_name=>'QB'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Query Builder'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:popupURL(''f?p=4500:1002:&SESSION.:::1002:P1002_RETURN_INTO,P1002_POPUP,P1002_SCHEMA:P803_LOV_QUERY,1,'' + encodeURIComponent(''&P800_SCHEMA.''));'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(424043318671360140.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(293403116472848342.4504)
,p_button_name=>'EDIT_STATIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Modifica lista di valori statica'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_lov_data',
' where column_id = :P803_COLUMN_ID'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(429089022685253660.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40559018900661671.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'CREATE'
,p_button_condition=>'P803_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(424026324989342982.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(293403116472848342.4504)
,p_button_name=>'CREATE_STATIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Crea lista di valori statica'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_lov_data',
' where column_id = :P803_COLUMN_ID'))
,p_button_condition_type=>'NOT_EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451876812708034876.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_button_name=>'GET_PREVIOUS_COLUMN_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_COLUMN_ID'')'
,p_button_condition=>'P803_COLUMN_ID_PREV'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451876702153034876.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_button_name=>'GET_NEXT_COLUMN_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Successivo'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_COLUMN_ID'')'
,p_button_condition=>'P803_COLUMN_ID_NEXT'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451880720379034887.4504)
,p_branch_action=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:803:P803_COLUMN_ID:&P803_COLUMN_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(451876702153034876.4504)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451880918162034887.4504)
,p_branch_action=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:803:P803_COLUMN_ID:&P803_COLUMN_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(451876812708034876.4504)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(251498918988497391.4504)
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:RP,40:P40_TABLE_ID,P40_COLUMN_ID:&P803_TABLE_ID.,&P803_COLUMN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_STATIC'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(428894725765601748.4504)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:RP,37:P37_TABLE_ID,P37_COLUMN_ID:&P803_TABLE_ID.,&P803_COLUMN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_STATIC'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40559413672661673.4504)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:803::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5941804461132033.4504)
,p_name=>'P803_FORM_ATTRIBUTE_11'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P803_FORM_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5942020465132037.4504)
,p_name=>'P803_FORM_ATTRIBUTE_12'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P803_FORM_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5942219964132037.4504)
,p_name=>'P803_FORM_ATTRIBUTE_13'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P803_FORM_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5942408013132037.4504)
,p_name=>'P803_FORM_ATTRIBUTE_14'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P803_FORM_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5942605629132038.4504)
,p_name=>'P803_FORM_ATTRIBUTE_15'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P803_FORM_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40559617798661674.4504)
,p_name=>'P803_COLUMN_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'COLUMN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40559812141661688.4504)
,p_name=>'P803_TABLE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabella:'
,p_source=>'TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_id r',
'  from WWV_FLOW_HNT_TABLE_INFO '))
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40560224805661691.4504)
,p_name=>'P803_COLUMN_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(40593701599050795.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nome colonna:'
,p_source=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'la colonna attualmente selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40560601899661692.4504)
,p_name=>'P803_LABEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(40593919911050798.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etichetta'
,p_source=>'LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se si crea un form su questa tabella o vista, verr\00E0 utilizzato come etichetta per l''elemento, qualora questa colonna sia inclusa. Se si crea un report o un form tabulare, verr\00E0 utilizzato come intestazione di colonna, qualora questa colonna sia inclu')
||'sa. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40560825886661692.4504)
,p_name=>'P803_HELP_TEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(40593919911050798.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Testo Guida'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Utilizzato come testo della Guida in un form o in un report interattivo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40561005216661692.4504)
,p_name=>'P803_FORM_FORMAT_MASK'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato di visualizzazione'
,p_source=>'MASK_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un form su questa tabella o vista, specifica il formato che verr\00E0 applicato all''elemento, ad esempio 999-99-9999. Non utilizzato per elementi basati su caratteri.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40561221322661692.4504)
,p_name=>'P803_DISPLAY_SEQ_FORM'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequenza di visualizzazione'
,p_source=>'DISPLAY_SEQ_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Se si crea un form su questa tabella o vista, determina la sequenza di visualizzazione delle colonne nella pagina di form risultante.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40561426448661692.4504)
,p_name=>'P803_DISPLAY_IN_FORM'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Visualizza'
,p_source=>'DISPLAY_IN_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_api.id(23482928300634173.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un form su questa tabella o vista, determina se questa colonna verr\00E0 visualizzata nella pagina di form risultante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40561609640661693.4504)
,p_name=>'P803_DISPLAY_AS_FORM'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TEXT'
,p_prompt=>'Visualizza come'
,p_source=>'DISPLAY_AS_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM_TYPES (WITHOUT PLUGINS)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_native_plugins varchar2(255);',
'begin',
'    l_native_plugins := '' union all select display_name as d, name_with_prefix as r from wwv_flow_native_plugins where plugin_type = ''''ITEM TYPE'''' order by 1'';',
'',
'    if lower(wwv_flow.g_flow_language) = ''en'' then',
'        return ''select display_name as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    else',
'        return ''select wwv_flow_lang.system_message(''''ITEM_TYPE.''''||name) as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    end if;',
'end;'))
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Se si crea un form su questa tabella o vista, determina la modalit\00E0 di visualizzazione della colonna, ad esempio come area di testo o campo di testo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40561801206661693.4504)
,p_name=>'P803_DISPLAY_AS_TAB_FORM'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(40594104898050799.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TEXT'
,p_prompt=>'Visualizza come'
,p_source=>'DISPLAY_AS_TAB_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI_DEF_DISPLAY_AS_TABULAR_FORMS'
,p_lov=>'.'||wwv_flow_api.id(251435312257287190.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un form tabulare su questa tabella o vista, determina la modalit\00E0 di visualizzazione della colonna, ad esempio Lista di selezione o LOV popup.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40562003085661693.4504)
,p_name=>'P803_DISPLAY_SEQ_REPORT'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(40594104898050799.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequenza di visualizzazione'
,p_source=>'DISPLAY_SEQ_REPORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Se si crea un report su questa tabella o vista, determina la sequenza di visualizzazione delle colonne nel report risultante.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40562218785661693.4504)
,p_name=>'P803_DISPLAY_IN_REPORT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(40594104898050799.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Visualizza'
,p_source=>'DISPLAY_IN_REPORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_api.id(23482928300634173.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un report su questa tabella o vista, determina se questa colonna verr\00E0 visualizzata nel report risultante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40562600042661694.4504)
,p_name=>'P803_MASK_REPORT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(40594104898050799.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato di visualizzazione'
,p_source=>'MASK_REPORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un report su questa tabella o vista, specifica il formato che verr\00E0 applicato ai dati, ad esempio 999-99-9999. Non utilizzato per elementi basati su caratteri.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40563015040661694.4504)
,p_name=>'P803_LOV_QUERY'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(293403116472848342.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Query lista di valori'
,p_source=>'LOV_QUERY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40563228954661694.4504)
,p_name=>'P803_DEFAULT_VALUE'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valore predefinito'
,p_source=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Se si crea un form su questa tabella o vista, specifica il valore predefinito per l''elemento risultante da questa colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40563412199661695.4504)
,p_name=>'P803_REQUIRED'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Richiesto'
,p_source=>'REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_api.id(23482928300634173.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se si crea un form su questa tabella o vista, specifica che verr\00E0 generata una convalida in cui l''elemento risultante deve essere NOT NULL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40563628013661695.4504)
,p_name=>'P803_ALIGNMENT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(40594104898050799.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'L'
,p_prompt=>'Allineamento'
,p_source=>'ALIGNMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI_DEF_ALIGNMENT_L_C_R'
,p_lov=>'.'||wwv_flow_api.id(260501806598530292.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Se si crea un report su questa tabella o vista, determina l''allineamento della colonna di report risultante (a sinistra, al centro o a destra).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40563830413661695.4504)
,p_name=>'P803_FORM_CSIZE'
,p_data_type=>'NUMBER'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Larghezza'
,p_source=>'DISPLAY_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>12
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specificare la lunghezza (in caratteri) dell''elemento di form visualizzato per questo elemento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40564000801661695.4504)
,p_name=>'P803_FORM_CMAXLENGTH'
,p_data_type=>'NUMBER'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Larghezza massima'
,p_source=>'MAX_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specificare il numero massimo di caratteri che gli utenti possono digitare in questo elemento di form.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40564206968661696.4504)
,p_name=>'P803_FORM_CHEIGHT'
,p_data_type=>'NUMBER'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Altezza'
,p_source=>'HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specificare l''altezza (in righe) delle aree di testo, degli shuttle e delle liste a selezione multipla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40566402628661698.4504)
,p_name=>'P803_GROUP_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(40593919911050798.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Gruppo'
,p_source=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, group_id',
'from WWV_FLOW_HNT_GROUPS',
'where table_id = :P803_TABLE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_HNT_GROUPS',
' where table_id = :P803_TABLE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare un gruppo al quale deve appartenere questa colonna. I gruppi consentono di stabilire aree predefinite in form e gruppi di colonne nei report interattivi.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451879713461034884.4504)
,p_name=>'P803_COLUMN_ID_NEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451879920761034884.4504)
,p_name=>'P803_COLUMN_ID_PREV'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451880106254034885.4504)
,p_name=>'P803_COLUMN_ID_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40567718307686659.4504)
,p_prompt=>'Colonna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(456283231949087342.4504)
,p_name=>'P803_DISPLAY_AS_FORM_JS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_prompt=>'&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_itemlink varchar2(32767) := null;',
'begin',
'  l_itemlink:=l_itemlink||''<div style="font-size:small">'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_TEXT_FIELD'''');">[''||wwv_flow_lang.system_message(''PAGE_REGION.LIST_ITEM_TEXT'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_NUMBER_FIELD'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_NUMBER_FIELD'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_DATE_PICKER'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_DATE_PICKER'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_TEXTAREA'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_TEXTAREA'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_SELECT_LIST'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_SELECT_LIST'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_RADIOGROUP'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_RADIOGROUP'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_POPUP_LOV'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_POPUP_LOV'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_CHECKBOX'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_CHECKBOX'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_DISPLAY_ONLY'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_DISPLAY_ONLY'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_HIDDEN'''');">[''||wwv_flow_lang.system_message(''WWV_FLOW_CUSTOMIZE.T_HIDDEN'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''</div>'';',
'  ',
'  return l_itemlink;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460092709566874978.4504)
,p_name=>'P803_FORM_ATTRIBUTE_01'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P803_FORM_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460094321687878422.4504)
,p_name=>'P803_FORM_ATTRIBUTE_02'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P803_FORM_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460095328266880315.4504)
,p_name=>'P803_FORM_ATTRIBUTE_03'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P803_FORM_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460096301386882055.4504)
,p_name=>'P803_FORM_ATTRIBUTE_04'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P803_FORM_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460096607273883789.4504)
,p_name=>'P803_FORM_ATTRIBUTE_05'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P803_FORM_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460098614891885971.4504)
,p_name=>'P803_FORM_ATTRIBUTE_06'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P803_FORM_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460099721471887849.4504)
,p_name=>'P803_FORM_ATTRIBUTE_07'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P803_FORM_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460100827705889689.4504)
,p_name=>'P803_FORM_ATTRIBUTE_08'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P803_FORM_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460101901517891591.4504)
,p_name=>'P803_FORM_ATTRIBUTE_09'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P803_FORM_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460103607750893373.4504)
,p_name=>'P803_FORM_ATTRIBUTE_10'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P803_FORM_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(717397080423801376.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460105704549911343.4504)
,p_name=>'P803_FORM_FORMAT_MASK_DATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_prompt=>'Formato di visualizzazione'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identificare il formato di visualizzazione della data utilizzato dal tipo di elemento. Si pu\00F2 utilizzare una sintassi di sostituzione per fare riferimento a un formato di visualizzazione dinamico da un elemento di applicazione o di pagina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460109927752918087.4504)
,p_name=>'P803_FORM_FORMAT_MASK_NUMBER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(40594513838050802.4504)
,p_prompt=>'Formato di visualizzazione'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_NUMBER (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''N''',
''))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identificare il formato di visualizzazione della data utilizzato dal tipo di elemento. Si pu\00F2 utilizzare una sintassi di sostituzione per fare riferimento a un formato di visualizzazione dinamico da un elemento di applicazione o di pagina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(460113718794943834.4504)
,p_computation_sequence=>10
,p_computation_item=>'P803_FORM_FORMAT_MASK_NUMBER'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P803_FORM_FORMAT_MASK'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_native_plugins',
' where plugin_type = ''ITEM TYPE''',
'   and name        = substr(:P803_DISPLAY_AS_FORM, 8)',
'   and instr(standard_attributes, ''FORMAT_MASK_NUMBER'') > 0'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(460113030999928412.4504)
,p_computation_sequence=>20
,p_computation_item=>'P803_FORM_FORMAT_MASK_DATE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P803_FORM_FORMAT_MASK'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_native_plugins',
' where plugin_type = ''ITEM TYPE''',
'   and name        = substr(:P803_DISPLAY_AS_FORM, 8)',
'   and instr(standard_attributes, ''FORMAT_MASK_DATE'') > 0'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(460135423025200528.4504)
,p_validation_name=>'Validate Plugin Form Attributes'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id   => 4411,',
'        p_page_id          => null,',
'        p_plugin_type      => wwv_flow_plugin.c_plugin_type_item_type,',
'        p_plugin_name      => :P803_DISPLAY_AS_FORM,',
'        p_attribute_scope  => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix => ''P803_FORM_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Errore'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(424143832711477640.4504)
,p_validation_name=>'LOV_QUERY valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.is_valid_lov_query (',
'           p_parse_as_schema => :P800_SCHEMA,',
'           p_query           => :P803_LOV_QUERY );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Query di lista di valori non valida.'
,p_validation_condition=>'P803_LOV_QUERY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(40563015040661694.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(424156205877507799.4504)
,p_validation_name=>'can''t have lov query and static lov'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_nbr_static_entries  number;',
'begin',
'',
'select count(*)',
'  into l_nbr_static_entries',
'  from wwv_flow_hnt_lov_data',
' where column_id = :P803_COLUMN_ID;',
'',
'if l_nbr_static_entries > 0 and',
'   :P803_LOV_QUERY is not null',
'then return false;',
'else return true;',
'end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Non pu\00F2 esistere sia una query di lista di valori che una lista di valori statica.')
,p_validation_condition=>'P803_LOV_QUERY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(40563015040661694.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(698585127520530534.4504)
,p_name=>'Handle Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(40650909721689914.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(698585269385530535.4504)
,p_event_id=>wwv_flow_api.id(698585127520530534.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'location.reload();'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40566704848661698.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_03=>'P803_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossibile recuperare la riga.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203930681939288838.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.init_number_fields_for_display (',
'        p_application_id   => 4411,',
'        p_page_id          => null,',
'        p_plugin_type      => wwv_flow_plugin.c_plugin_type_item_type,',
'        p_plugin_name      => :P803_DISPLAY_AS_FORM,',
'        p_attribute_scope  => wwv_flow_plugin.c_attribute_scope_component );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451880529772034886.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_03=>'P803_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_07=>'DISPLAY_SEQ_REPORT'
,p_attribute_09=>'P803_COLUMN_ID_NEXT'
,p_attribute_10=>'P803_COLUMN_ID_PREV'
,p_attribute_13=>'P803_COLUMN_ID_COUNT'
,p_attribute_14=>'table_id = :P803_TABLE_ID'
,p_process_error_message=>'Impossibile eseguire il processo Richiama valore di chiave primaria successivo o precedente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(460141623380276345.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set form format mask'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_plugin in (',
'        select standard_attributes',
'         from wwv_flow_native_plugins',
'        where plugin_type = ''ITEM TYPE''',
'          and name        = substr(:P803_DISPLAY_AS_FORM, 8)',
'          and instr(standard_attributes, ''FORMAT_MASK'') > 0 )',
'    loop',
'        if l_plugin.standard_attributes like ''%FORMAT_MASK_DATE%'' then',
'            :P803_FORM_FORMAT_MASK := :P803_FORM_FORMAT_MASK_DATE;',
'        elsif l_plugin.standard_attributes like ''%FORMAT_MASK_NUMBER%'' then',
'            :P803_FORM_FORMAT_MASK := :P803_FORM_FORMAT_MASK_NUMBER;',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(429089223162263191.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Column'
,p_process_sql_clob=>'wwv_flow_hint.remove_column_hint(:P803_COLUMN_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante l''eliminazione dei valori predefiniti della colonna.'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Valori predefiniti colonna eliminati.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(828554424683615725.4504)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id   => 4411,',
'        p_page_id          => null,',
'        p_plugin_type      => wwv_flow_plugin.c_plugin_type_item_type,',
'        p_plugin_name      => :P803_DISPLAY_AS_FORM,',
'        p_attribute_scope  => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix => ''P803_FORM_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40566927819661700.4504)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_03=>'P803_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_process_error_message=>'Impossibile elaborare la riga della tabella WWV_FLOW_HNT_COLUMN_INFO.'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Azione elaborata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2555915326214851788.4504)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00804
begin
wwv_flow_api.create_page(
 p_id=>804.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Gruppo di colonne'
,p_page_mode=>'MODAL'
,p_step_title=>'Gruppo di colonne'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40637106508421525.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40637310468421529.4504)
,p_plug_name=>'Gruppo di colonne'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(40843211185588780.4504)
,p_name=>'Gruppi di colonne'
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    GROUP_NAME,',
'    DESCRIPTION,',
'    DISPLAY_SEQUENCE',
'from WWV_FLOW_HNT_GROUPS',
'where table_id = :P802_TABLE_ID',
'order by display_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun gruppo di colonne esistente.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40843520416588799.4504)
,p_query_column_id=>1
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome gruppo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40843615031588803.4504)
,p_query_column_id=>2
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_column_heading=>'Descrizione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40843919497591263.4504)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequenza'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1019193188451734746.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(40637106508421525.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40638508351421532.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(40637106508421525.4504)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'CREATE'
,p_button_condition=>'P804_GROUP_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40638100770421531.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(40637106508421525.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P804_GROUP_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40638318244421532.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(40637106508421525.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'EDIT'
,p_button_condition=>'P804_GROUP_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40642912894421543.4504)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40638701715421533.4504)
,p_name=>'P804_GROUP_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(40637310468421529.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40638915692421535.4504)
,p_name=>'P804_TABLE_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(40637310468421529.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40639100311421535.4504)
,p_name=>'P804_GROUP_NAME'
,p_is_required=>true
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(40637310468421529.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Gruppo'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica un gruppo di elementi o colonne correlate. Questo sar\00E0 il nome area nei form risultanti e sar\00E0 visualizzato nell''intestazione della vista dettagliata di qualsiasi report interattivo risultante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40639600534421535.4504)
,p_name=>'P804_DESCRIPTION'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(40637310468421529.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Descrizione'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Una descrizione del gruppo. Diventa la descrizione del gruppo di colonne in qualsiasi report interattivo risultante, ma non \00E8 mai visualizzata dagli utenti finali.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40640121046421536.4504)
,p_name=>'P804_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>2.5
,p_item_plug_id=>wwv_flow_api.id(40637310468421529.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequenza'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>7
,p_cMaxlength=>30
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'La sequenza consente di ordinare i gruppi di colonne in qualsiasi form o vista dei dettagli in un report interattivo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40647713727530234.4504)
,p_name=>'P804_TABLE_NAME'
,p_item_sequence=>2.2
,p_item_plug_id=>wwv_flow_api.id(40637310468421529.4504)
,p_prompt=>'Nome tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1019193365148737225.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1019193188451734746.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1019193634042737229.4504)
,p_event_id=>wwv_flow_api.id(1019193365148737225.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40642209530421541.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_GROUPS'
,p_attribute_03=>'P804_GROUP_ID'
,p_attribute_04=>'GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossibile recuperare la riga.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40642419089421542.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_GROUPS'
,p_attribute_03=>'P804_GROUP_ID'
,p_attribute_04=>'GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Impossibile elaborare la riga della tabella WWV_FLOW_HNT_GROUPS.'
,p_process_success_message=>'Azione elaborata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40642611037421542.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'33'
,p_process_when_button_id=>wwv_flow_api.id(40638100770421531.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(698585011297530533.4504)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Azione elaborata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40647826541533918.4504)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select table_name ',
'from #OWNER#.WWV_FLOW_HNT_TABLE_INFO ',
'where table_id = :P804_TABLE_ID) loop',
'   :P804_table_name := c1.table_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2555921832746175381.4504)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00805
begin
wwv_flow_api.create_page(
 p_id=>805.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Gruppi di colonne'
,p_step_title=>'Gruppi di colonne'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40837822255349176.4504)
,p_plug_name=>'Gruppi colonne predefiniti interfaccia utente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    GROUP_ID,',
'    TABLE_ID,',
'    GROUP_NAME,',
'    DESCRIPTION,',
'    DISPLAY_SEQUENCE,',
'    CREATED_BY,',
'    CREATED_ON,',
'    LAST_UPDATED_BY,',
'    LAST_UPDATED_ON',
'from WWV_FLOW_HNT_GROUPS',
'where table_id = :P802_TABLE_ID'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(40837918562349176.4504)
,p_name=>'User Interface Default Column Groups'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838127245349181.4504)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID gruppo'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838211364349183.4504)
,p_db_column_name=>'TABLE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'ID tabella'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838327088349183.4504)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nome gruppo'
,p_column_link=>'f?p=&APP_ID.:804:&SESSION.::&DEBUG.::P804_GROUP_ID:#GROUP_ID#'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838409289349183.4504)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Descrizione'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838530925349183.4504)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Sequenza'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838627304349183.4504)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Creazione di'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838719590349183.4504)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Data creazione'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838829417349184.4504)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Autore aggiornamento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40838926410349184.4504)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Aggiornato'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40839523456403132.4504)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40842906552578067.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(40839523456403132.4504)
,p_button_name=>'CREATE_COLUMN_GROUP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea gruppo di colonne'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:804:&SESSION.::&DEBUG.:804:P804_TABLE_ID:&P802_TABLE_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40840320428403143.4504)
,p_name=>'P805_SCHEMA'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(40839523456403132.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40840526158403143.4504)
,p_name=>'P805_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40839523456403132.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40840725076403143.4504)
,p_name=>'P805_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40839523456403132.4504)
,p_prompt=>'Nome tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica la tabella o la vista di database corrispondente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(698585300165530536.4504)
,p_name=>'Dialog Closed (Report)'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(40837822255349176.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(698585465831530537.4504)
,p_event_id=>wwv_flow_api.id(698585300165530536.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(40837822255349176.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(698585551385530538.4504)
,p_name=>'Dialog Closed (Button)'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(40842906552578067.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(698585684215530539.4504)
,p_event_id=>wwv_flow_api.id(698585551385530538.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(40837822255349176.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(42233223988861200.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40841306403417161.4504)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select table_name ',
'from #OWNER#.WWV_FLOW_HNT_TABLE_INFO ',
'where table_id = :P802_TABLE_ID) loop',
'   :P805_table_name := c1.table_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00807
begin
wwv_flow_api.create_page(
 p_id=>807.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Sincronizza con database'
,p_step_title=>'Sincronizza con database'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(429082326437172991.4504)
,p_plug_name=>'Sincronizza da database'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(429088021384234343.4504)
,p_plug_name=>'Sincronizza con database'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419046555820782.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Quando si sincronizza una tabella con il database, le colonne che non esistono pi\00F9 nella tabella o nella vista di database saranno rimosse e verranno aggiunte nuove colonne alla definizione di colonna. Non verr\00E0 modificata alcuna propriet\00E0 di defi')
||'nizione di colonna per le colonne esistenti.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1019602928435527658.4504)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1019604657553619497.4504)
,p_plug_name=>'Sincronizza con database'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(429082519978172992.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1019602928435527658.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(429082712096172994.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1019602928435527658.4504)
,p_button_name=>'SYNC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sincronizza'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(429084402988173260.4504)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(429083105420172995.4504)
,p_name=>'P807_TABLE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(429082326437172991.4504)
,p_prompt=>'Nome tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(429083306480172997.4504)
,p_name=>'P807_SCHEMA'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(429082326437172991.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(429084022205173256.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select table_name ',
'     from WWV_FLOW_HNT_TABLE_INFO ',
'    where table_id = :P802_TABLE_ID) ',
'loop',
'   :P807_table_name := c1.table_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P802_TABLE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(429084212787173257.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'synch defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv(:P800_SCHEMA);',
'wwv_flow_hint.synch_hints(:P800_SCHEMA,:P807_TABLE_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(429082712096172994.4504)
,p_process_success_message=>'Sincronizzazione della voce di dizionario tabelle con il dizionario dati del database riuscita.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2555922331492184433.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00813
begin
wwv_flow_api.create_page(
 p_id=>813.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Valori predefiniti interfaccia utente'
,p_step_title=>'Valori predefiniti interfaccia utente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(421012108481729215.4504)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(194504915759237345.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(196867506292090262.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(421012312637730439.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(421013623981752601.4504)
,p_name=>'Dizionario attributi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_sub_css_classes=>'a-BadgeList--cols a-BadgeList--responsive a-BadgeList--large'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) c,',
'       max(nvl(c.last_updated_on,c.created_on)) last_updated_on',
'  from WWV_FLOW_HNT_COLUMN_DICT c,',
'       wwv_flow_hnt_col_dict_syn s',
' where c.security_group_id = :flow_security_group_id',
'   and c.column_id = s.column_id',
'   and s.security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'nessun dato trovato'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(421013623981752601.4504)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(421013926949752640.4504)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'Conteggio di attributi'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(421016406113832584.4504)
,p_query_column_id=>2
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>2
,p_column_heading=>'Aggiornato'
,p_use_as_row_header=>'N'
,p_column_format=>'Since'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(421014330691764059.4504)
,p_name=>'Dizionario tabelle'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) count_of_tables,',
'       max(nvl(last_updated_on,created_on)) last_updated_on,',
'       :P813_SCHEMA default_schema',
'  from WWV_FLOW_HNT_TABLE_INFO h',
' where h.schema  = nvl(:P813_SCHEMA,:P813_DEFAULT_SCHEMA)'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'nessun dato trovato'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(421014330691764059.4504)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(421015819011817386.4504)
,p_query_column_id=>1
,p_column_alias=>'COUNT_OF_TABLES'
,p_column_display_sequence=>1
,p_column_heading=>'Conteggio di tabelle con valori predefiniti'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(421015918273817386.4504)
,p_query_column_id=>2
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>2
,p_column_heading=>'Aggiornato'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(421017006375851615.4504)
,p_query_column_id=>3
,p_column_alias=>'DEFAULT_SCHEMA'
,p_column_display_sequence=>3
,p_column_heading=>'Schema predefinito'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(421523419900723720.4504)
,p_plug_name=>'Valori predefiniti interfaccia utente'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I valori predefiniti dell''interfaccia utente vengono utilizzati per popolare i valori iniziali per la colonna di report e le propriet\00E0 degli elementi che assicurano la coerenza su pi\00F9 pagine in un''applicazione o su pi\00F9 applicazioni.</p>'),
'',
unistr('<p>I valori predefiniti di interfaccia utente sono composti da un dizionario attributi di nomi colonna e da un dizionario tabelle pi\00F9 specifico, in cui i valori predefiniti sono specifici per una combinazione di tabella e colonna. Se nell''App Builder')
||' vengono utilizzati valori predefiniti e ne esistono a livello di tabella, saranno utilizzati al posto della definizione di colonna.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628556724325856603.4504)
,p_name=>'P813_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(421012312637730439.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select /* APEX4500L1 */ wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1003_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1003_SCHEMA) a,:P1003_SCHEMA b from dual '';',
'  q:=q||''where  :P1003_POPUP = 1 '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628559716529889439.4504)
,p_name=>'P813_DEFAULT_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(421012312637730439.4504)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select min(d)',
'from',
'(',
'select c.schema d',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
'where  c.security_group_id = :flow_security_group_id and',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :flow_user and',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'        instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'  and  nvl(:P1003_POPUP,0) <> 1',
'union all',
'select :P1003_SCHEMA d',
'from   dual',
'where  :P1003_POPUP = 1',
')'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(628819707504485750.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>':P813_SCHEMA := nvl(:P3002_SCHEMA, upper(wwv_flow_user_api.get_default_schema));'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P813_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2555920717453066833.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P813_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00830
begin
wwv_flow_api.create_page(
 p_id=>830.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Rimuovi da dizionario tabelle'
,p_step_title=>'Rimuovi da dizionario tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40821612047201204.4504)
,p_plug_name=>'Rimuovi da dizionario tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698585887524530541.4504)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755295941579836825.4504)
,p_plug_name=>'Rimuovi da dizionario tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1019609081712660734.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(698585887524530541.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40824010145229012.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(698585887524530541.4504)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Rimuovi valori predefiniti'
,p_button_position=>'EDIT'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40824424214233093.4504)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40821920358203611.4504)
,p_name=>'P830_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40821612047201204.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40822908846219133.4504)
,p_name=>'P830_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40821612047201204.4504)
,p_prompt=>'Nome tabella:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica la tabella o la vista di database corrispondente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40869710633023841.4504)
,p_name=>'P830_SCHEMA'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(40821612047201204.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40875212036175609.4504)
,p_name=>'P830_COLUMNS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40821612047201204.4504)
,p_prompt=>'Colonne:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40821401312198123.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove table hint'
,p_process_sql_clob=>'wwv_flow_hint.remove_table_hint(p_table_id=>:P830_TABLE_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(40824010145229012.4504)
,p_process_success_message=>'Rimozione dei valori predefiniti dell''interfaccia utente riuscita.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2555922515001189163.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40823318543221957.4504)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select table_name ',
'from #OWNER#.WWV_FLOW_HNT_TABLE_INFO ',
'where table_id = :P830_TABLE_ID) loop',
'   :P830_table_name := c1.table_name;',
'end loop;',
'for c1 in (',
'select count(*) c from WWV_FLOW_HNT_COLUMN_INFO where table_id = :P830_TABLE_ID) loop',
'   :P830_COLUMNS := c1.c;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00840
begin
wwv_flow_api.create_page(
 p_id=>840.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Sincronizza valori predefiniti'
,p_step_title=>'Sincronizza valori predefiniti'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(40862329277925160.4504)
,p_name=>'Valori predefiniti interfaccia utente'
,p_template=>wwv_flow_api.id(717419707883820782.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       wwv_flow_lang.system_message(''F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'') defaults_exist, count(*) count_of_objects',
'  from ',
'(',
'-- objects without hints',
'select (select object_id',
'          from sys.dba_objects a',
'         where h.table_name = a.object_name',
'           and a.owner = :P800_SCHEMA',
'           and a.object_type in (''TABLE'',''VIEW'')) object_id,',
'       h.table_name object_name,',
'       (select d.object_type',
'          from sys.dba_objects d',
'         where h.table_name = d.object_name',
'           and d.owner = :P800_SCHEMA',
'           and d.object_type in (''TABLE'',''VIEW'')) object_type',
'  from (select object_name table_name',
'          from sys.dba_objects',
'         where object_type in (''TABLE'',''VIEW'')',
'           and owner = :P800_SCHEMA',
'           and object_name not like ''BIN$%''',
'           and object_name not like ''APEX$%''',
'           and object_name not like ''DR$%''',
'           and object_name not like ''SYS_IOT_%''',
'        MINUS',
'        select table_name',
'          from WWV_FLOW_HNT_TABLE_INFO',
'         where SCHEMA = :P800_SCHEMA) h ',
') wo',
'UNION',
'-- objects with hints',
'select wwv_flow_lang.system_message(''F4500_DICTIONARY_OBJECTS_W_DEFAULTS'') defaults_exist, count(*) count_of_objects',
'  from (',
'select h.table_id,',
'       h.table_name object_name,',
'       nvl((select decode(d.object_type,',
'                          ''TABLE'',wwv_flow_lang.system_message(''TABLE''),',
'                          ''VIEW'',wwv_flow_lang.system_message(''VIEW''),',
'                          d.object_type)',
'              from sys.dba_objects d',
'             where h.table_name = d.object_name',
'               and h.schema = d.owner',
'               and d.object_type in (''TABLE'',''VIEW'')),',
'            ''N'') object_type,',
'       last_updated_on,',
'       last_updated_by',
'  from WWV_FLOW_HNT_TABLE_INFO h',
' where h.schema  = :P800_SCHEMA',
') w'))
,p_header=>unistr('<p>Sincronizzare i valori predefiniti con il dizionario dati del database. Verranno aggiunte nuove colonne alle tabelle rispetto all''ultima sincronizzazione e verranno rimosse le colonne che non esistono pi\00F9.</p> ')
,p_footer=>'<p />'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'nessun dato trovato'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40862615831925164.4504)
,p_query_column_id=>1
,p_column_alias=>'DEFAULTS_EXIST'
,p_column_display_sequence=>1
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40862717180925164.4504)
,p_query_column_id=>2
,p_column_alias=>'COUNT_OF_OBJECTS'
,p_column_display_sequence=>2
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(763471694281364474.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(763472607085385886.4504)
,p_plug_name=>'Valori predefiniti interfaccia utente'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>5
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40868410371004862.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(763471694281364474.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40868607789004863.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(763471694281364474.4504)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sincronizza valori predefiniti'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40868917297006878.4504)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40868024438999502.4504)
,p_name=>'P840_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40862329277925160.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_colspan=>4
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40869029417010357.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create missing user interface defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv(:P800_SCHEMA);',
'for c1 in (',
'select object_name table_name',
'          from sys.dba_objects',
'         where object_type in (''TABLE'',''VIEW'')',
'           and owner = :P800_SCHEMA',
'           and object_name not like ''BIN$%''',
'           and object_name not like ''APEX$%''',
'           and object_name not like ''DR$%''',
'           and object_name not like ''SYS_IOT_%''',
'           ) loop',
'    wwv_flow_hint.synch_hints(:P800_SCHEMA,c1.table_name);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'Sincronizzazione dei valori predefiniti dell''interfaccia utente con il dizionario dati del database riuscita.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(42231501778826373.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00841
begin
wwv_flow_api.create_page(
 p_id=>841.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Esporta dizionario tabelle'
,p_page_mode=>'MODAL'
,p_step_title=>'Esporta dizionario tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(40877330444219839.4504)
,p_name=>'Dizionario tabelle'
,p_template=>wwv_flow_api.id(717419707883820782.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''OBJECTS_WITH_DEFAULTS'') defaults_exist,',
'       count(*) count_of_objects',
'  from (',
'select h.table_id,',
'       h.table_name object_name,',
'       nvl((select decode(d.object_type,',
'                          ''TABLE'',wwv_flow_lang.system_message(''TABLE''),',
'                          ''VIEW'',wwv_flow_lang.system_message(''VIEW''),',
'                          d.object_type)',
'              from sys.dba_objects d',
'             where h.table_name = d.object_name',
'               and h.schema = d.owner',
'               and d.object_type in (''TABLE'',''VIEW'')),',
'            ''N'') object_type,',
'       last_updated_on,',
'       last_updated_by',
'  from WWV_FLOW_HNT_TABLE_INFO h',
' where h.schema  = :P800_SCHEMA',
') w',
'UNION',
'select wwv_flow_lang.system_message(''OBJECTS_WITHOUT_DEFAULTS'') defaults_exist,',
'       count(*) count_of_objects',
'  from (',
'select (select object_id',
'          from sys.dba_objects a',
'         where h.table_name = a.object_name',
'           and a.owner = :P800_SCHEMA',
'           and a.object_type in (''TABLE'',''VIEW'')) object_id,',
'       h.table_name object_name,',
'       (select d.object_type',
'          from sys.dba_objects d',
'         where h.table_name = d.object_name',
'           and d.owner = :P800_SCHEMA',
'           and d.object_type in (''TABLE'',''VIEW'')) object_type',
'  from (select object_name table_name',
'          from sys.dba_objects',
'         where object_type in (''TABLE'',''VIEW'')',
'           and owner = :P800_SCHEMA',
'           and object_name not like ''BIN$%''    ',
'        MINUS',
'        select table_name',
'          from WWV_FLOW_HNT_TABLE_INFO',
'         where SCHEMA = :P800_SCHEMA) h ',
') wo'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'nessun dato trovato'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40877516743219840.4504)
,p_query_column_id=>1
,p_column_alias=>'DEFAULTS_EXIST'
,p_column_display_sequence=>1
,p_column_heading=>'Stato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40877610738219840.4504)
,p_query_column_id=>2
,p_column_alias=>'COUNT_OF_OBJECTS'
,p_column_display_sequence=>2
,p_column_heading=>'Conteggio di oggetti'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(692817211130250934.4504)
,p_plug_name=>'Esporta dizionario tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(717761919422725416.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(755302360322951128.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(717761919422725416.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40878414686219858.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(717761919422725416.4504)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esporta'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40878604670219859.4504)
,p_name=>'P841_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40877330444219839.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Schema il cui dizionario tabelle viene esportato.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40883121396254052.4504)
,p_name=>'P841_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40877330444219839.4504)
,p_item_default=>'DOS'
,p_prompt=>'Formato file'
,p_source=>'DOS'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI DEFAULT EXP IMP FORMATS'
,p_lov=>'.'||wwv_flow_api.id(40883415986261937.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare un formato file. Sono disponibili le opzioni riportate di seguito.',
'<ul>',
'<li><strong>DOS</strong>: le righe nel file risultante terminano con ritorni a capo e avanzamenti riga;</li>',
'<li><strong>UNIX</strong>: le righe nel file risultante terminano con avanzamenti riga.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1019611456383706785.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(755302360322951128.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1019611720157706789.4504)
,p_event_id=>wwv_flow_api.id(1019611456383706785.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40882702349248568.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv(:P800_SCHEMA);',
'sys.htp.init;',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow_gen_hint.g_mime_shown := true;',
'',
'wwv_flow_utilities.print_download_header(',
'  p_mime_type => ''application/x-sql'',',
'  p_is_attachment => true,',
'  p_file_name => lower(:P800_SCHEMA)||''_table_dict.sql''',
');',
'',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_gen_hint.export(',
'    p_schema => :P800_SCHEMA,',
'    p_format => :P841_FORMAT);',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Esportazione del dizionario tabelle non riuscita.'
,p_process_success_message=>'Dizionario tabelle esportato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1019611226268704613.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'close dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(42231814591830072.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00842
begin
wwv_flow_api.create_page(
 p_id=>842.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Importa dizionario tabelle'
,p_page_mode=>'MODAL'
,p_step_title=>'Importa dizionario tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40888907506297365.4504)
,p_plug_name=>'Importa dizionario tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(717763899567749057.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1009688824679531697.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(717763899567749057.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40880720135227490.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(717763899567749057.4504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40881413589227491.4504)
,p_branch_action=>'f?p=&APP_ID.:843:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40880720135227490.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40881128858227491.4504)
,p_name=>'P842_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40888907506297365.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(424240005941037614.4504)
,p_name=>'P842_FILE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40888907506297365.4504)
,p_prompt=>'Importa file'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Immettere la posizione del file da importare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(424269810284152400.4504)
,p_name=>'P842_FILE_CHARSET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40888907506297365.4504)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Set di caratteri file'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(143356515285702408.4504)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicare la codifica del set di caratteri per il file da importare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1009689045695533892.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1009688824679531697.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1009689362614533893.4504)
,p_event_id=>wwv_flow_api.id(1009689045695533892.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(424262519372136112.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_title     varchar2(4000) := null;',
'  l_start     number := 0;',
'begin',
'  l_start := instr(:P842_FILE,''/'',1)+1;',
'  l_title := substr(:P842_FILE,l_start);',
'  --',
'  -- save file attributes',
'  --',
'  update wwv_flow_file_objects$ ',
'  set    title             = l_title, ',
'         description       = l_title||'' upload'',',
'         security_group_id = :flow_security_group_id,      ',
'         mime_type         = ''application/text'',',
'         created_by        = :flow_user,',
'         file_charset      = :P842_FILE_CHARSET,',
'         file_type         = ''UI_DEFAULTS''',
'  where name = :P842_FILE;        ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il caricamento del file di esportazione.'
,p_process_when_button_id=>wwv_flow_api.id(40880720135227490.4504)
,p_process_success_message=>'File di esportazione caricato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(424272720027183574.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P843_FILE_ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P842_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P843_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(40880720135227490.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(42232126712833550.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00843
begin
wwv_flow_api.create_page(
 p_id=>843.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Importa dizionario tabelle'
,p_page_mode=>'MODAL'
,p_step_title=>'Importa dizionario tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(201270629259751113)
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40888428846294007.4504)
,p_plug_name=>'Installa dizionario tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Importazione del file di esportazione riuscita.</p>',
'<p>Per eseguire l''installazione immediatamente, fare clic su <strong>Installa</strong>.</p>',
unistr('<p>\00C8 inoltre possibile installare il file in un secondo momento, spostandosi nel repository di esportazione dell''App Builder.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(424274923668222439.4504)
,p_plug_name=>'Invalid File'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_source=>unistr('Il file non \00E8 un file di esportazione di dizionario tabelle &PRODUCT_NAME. valido.')
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698586091443530543.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1009690863443563034.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(698586091443530543.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40886628072281718.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(698586091443530543.4504)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Installa'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40887430447285055.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(698586091443530543.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40887325788281719.4504)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40887008305281719.4504)
,p_name=>'P843_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40888428846294007.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema corrente:'
,p_source=>'P800_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(424275516181229788.4504)
,p_name=>'P843_FILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40888428846294007.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(424276305015245463.4504)
,p_name=>'P843_SCHEMA_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40888428846294007.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Esportato da schema:'
,p_source=>'wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Lo schema associato al dizionario delle tabelle per i valori predefiniti interfaccia utente. Questo schema deve essere associato all''area di lavoro corrente per poter proseguire l''importazione.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(424278603676273502.4504)
,p_validation_name=>'check version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :P843_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('NON COMPATIBILE (l''esportazione pu\00F2 contenere chiamate non supportate dalla versione dell''applicazione dell''utente).')
,p_when_button_pressed=>wwv_flow_api.id(40886628072281718.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(424278924801279554.4504)
,p_validation_name=>'valid export file'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il file non \00E8 un file di esportazione di dizionario tabelle &PRODUCT_NAME. valido.')
,p_when_button_pressed=>wwv_flow_api.id(40886628072281718.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(628825426139661358.4504)
,p_validation_name=>'file schema associated with workspace'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_exp_schema varchar(255) := wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID);',
'begin',
'   for c1 in (',
'      select c.schema',
'        from wwv_flow_company_schemas c,',
'             wwv_flow_fnd_user u',
'       where c.security_group_id = :flow_security_group_id and',
'             u.security_group_id = :flow_security_group_id and',
'             u.user_name = :flow_user and',
'             (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'              instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0) )',
'   loop',
'      if c1.schema = l_exp_schema then',
'         return true;',
'      end if;',
'   end loop;',
'',
'   return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Esportato da uno schema non associato all''area di lavoro corrente.'
,p_when_button_pressed=>wwv_flow_api.id(40886628072281718.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1009691998544566539.4504)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1009690863443563034.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1009692286742566540.4504)
,p_event_id=>wwv_flow_api.id(1009691998544566539.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(424279312811285618.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_imp_parser.parse (',
'     p_file_id => :P843_FILE_ID',
'     );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante l''installazione del dizionario tabelle.'
,p_process_when_button_id=>wwv_flow_api.id(40886628072281718.4504)
,p_process_success_message=>'Dizionario tabelle installato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(698586175593530544.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(40886628072281718.4504)
,p_process_success_message=>'Dizionario tabelle installato.'
);
end;
/
prompt --application/pages/page_00900
begin
wwv_flow_api.create_page(
 p_id=>900.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Autenticazione Builder SSO - Imposta password'
,p_step_title=>'Impostare la password dell''account APEX - Oracle APEX'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-ControlBar {display: none;}',
'.a-Alert--wizard .a-Alert-icon .large-icon {width: 96px; height: 96px;}'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>'MUST_NOT_BE_PUBLIC_USER'
,p_required_patch=>wwv_flow_api.id(1694682434415493288.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1694248221876928011.4504)
,p_plug_name=>'Benvenuti in &PRODUCT_NAME.'
,p_icon_css_classes=>'large-icon gi-icon-apex-logo-icon'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Prima di iniziare, impostare la password del proprio account &PRODUCT_NAME. (APEX).</p>',
unistr('<p>L''accesso a questo servizio \00E8 controllato da SSO (Single Sign-On). Quando si crea l''area di lavoro, viene creato anche un account APEX con il proprio nome utente SSO e una password generata in modo casuale. Per poter eseguire le applicazioni creat')
||unistr('e \00E8 necessario reimpostare questa password.</p>'),
'<p><small>Nota: questa operazione non comporta la reimpostazione della password SSO.</small></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1694248456138928013.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1694248221876928011.4504)
,p_button_name=>'SET_PWD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Imposta password account APEX'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=4350:3:&APP_SESSION.::::#pwd'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1694248723011928016.4504)
,p_branch_name=>'Redirect to APEX Homepage'
,p_branch_action=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1694248582045928014.4504)
,p_name=>'Redirect to Homepage after Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1694248456138928013.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1694248624745928015.4504)
,p_event_id=>wwv_flow_api.id(1694248582045928014.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_api.create_page(
 p_id=>1000.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Oracle APEX'
,p_alias=>'AHOME'
,p_step_title=>'Oracle APEX'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Developer Toolbar integration */',
'apex.builder.nameBuilderWindow();',
''))
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>'MUST_NOT_BE_PUBLIC_USER'
,p_help_text=>'start_db_home.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8979914911187153.4504)
,p_plug_name=>'Hidden'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20620316437401020.4504)
,p_plug_name=>'Prime applicazioni'
,p_region_name=>'dashboard_region'
,p_region_css_classes=>'a-Region--scrollAuto u-Height i-h540 a-Region--simple margin-top-none a-Region--noBottomBorder'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.top_applications_combo2 (',
'    p_app_session  => :app_session,',
'    p_security_group_id => :flow_security_group_id,    ',
'    p_image_prefix  => :image_prefix,',
'    p_days  => :P1000_TIMEFRAME,',
'    p_display_count => 25,',
'    p_chart_width  => 100,',
'    p_link => ''f?p=4500:35:''||:app_session||'':::35'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(12506407035221692)
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20622532086935448.4504)
,p_plug_name=>'Primi utenti'
,p_region_name=>'top-users'
,p_region_css_classes=>'a-Region--scrollAuto u-Height i-h540 a-Region--simple margin-top-none a-Region--noBottomBorder'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.top_users2 (',
'    p_app_session       => :app_session,',
'    p_security_group_id => :flow_security_group_id,    ',
'    p_image_prefix      => :image_prefix,',
'    p_days              => nvl(:P1000_TIMEFRAME,1),',
'    p_display_count     => 25,',
'    p_max_length        => 30,',
'    p_chart_width       => 100,',
'    p_link => ''f?p=4500:35:''||:app_session||'':::35'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--leftBorder'
,p_plug_required_role=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20626331028133790.4504)
,p_plug_name=>'Set Timeframe'
,p_region_css_classes=>'a-Region-caption'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.show_page_event_link (',
'    p_days  => :P1000_TIMEFRAME,',
'    p_link => wwv_flow_page_api.get_url( p_page => 35 ));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--topBorder'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30606315059404549.4504)
,p_plug_name=>'Area di lavoro &COMPANY.'
,p_region_sub_css_classes=>'a-ImageNav--primary'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(46901918965530186.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(385894774262579225.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48023203771669615.4504)
,p_plug_name=>'Informazioni'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Oracle APEX \00E8 una piattaforma di sviluppo low-code che consente di creare applicazioni enterprise scalabili e sicure, con funzioni di primissimo livello, che possono essere distribuite ovunque.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72206627172569503.4504)
,p_plug_name=>'Learn More Region'
,p_region_css_classes=>'a-ButtonRegion--banner apex-app-builder'
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>120
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock">'');',
'sys.htp.p(''    <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''        <span class="icon-get-started" aria-hidden="true"></span>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''    <div class="a-MediaBlock-content">'');',
'sys.htp.p(''        <h2>''||wwv_flow_lang.system_message(''LEARN_MORE_APEX_HOME'')||''</h2>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(387735895564483664.4504)
,p_plug_name=>'Overview Container'
,p_region_css_classes=>'a-Region--scrollAuto u-Height i-h540 a-Region--simple margin-top-none'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--leftBorder'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26973523154854887.4504)
,p_plug_name=>'Messaggio di upgrade'
,p_parent_plug_id=>wwv_flow_api.id(387735895564483664.4504)
,p_region_css_classes=>'a-Region--simple a-Region--noBottomBorder a-Region--helpRegion margin-top-none'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'' then',
'    sys.htp.p(wwv_flow_lang.system_message(',
'        p_name => ''F4000_P78_UPGRADE_AVAILABLE'',',
'        p0     => wwv_flow_cloud_db_services.get_upgrade_status().upgrade_version,',
'        p1     => to_char(wwv_flow_cloud_db_services.get_upgrade_status().upgrade_date, ''fmMonth DD, YYYY''),',
'        p2     => ''https://apex.oracle.com/adb-latest''));',
'else',
'    sys.htp.p(wwv_flow_lang.system_message(',
'        p_name => ''F4000_P78_UPGRADING'',',
'        p0     => ''&PRODUCT_NAME.'',',
'        p1     => ''3''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state is not null'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(38816020965219111.4504)
,p_name=>'Risorse'
,p_parent_plug_id=>wwv_flow_api.id(387735895564483664.4504)
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>60
,p_region_css_classes=>'a-Region--simple a-Region--noBottomBorder margin-bottom-md'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4500P1000b */ decode(task_link,null,''<a href="#">''||wwv_flow_escape.html(task_name)||''</a>'',''<a href="''||replace(replace(replace(task_link,''&''||''SESSION.'',:APP_SESSION),''&''||''FLOW_SESSION.'',:APP_SESSION),''&''||''APP_SESSION.'',:APP_SESSIO'
||'N)||''">''||wwv_flow_escape.html(task_name)||''</a>'') d',
'from wwv_flow_customized_tasks where (security_group_id is null or security_group_id = :FLOW_SECURITY_GROUP_ID) and displayed = ''Y'' and display_location = ''WORKSPACE_HOME'' order by display_sequence'))
,p_display_when_condition=>'select 1 from wwv_flow_customized_tasks where (security_group_id is null or security_group_id = :flow_security_group_id) and displayed = ''Y'' and display_location = ''WORKSPACE_HOME'''
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(38811532466194226.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(38816315255219128.4504)
,p_query_column_id=>1
,p_column_alias=>'D'
,p_column_display_sequence=>1
,p_column_heading=>'D'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138795815972108295.4504)
,p_plug_name=>'Messaggio di sistema'
,p_parent_plug_id=>wwv_flow_api.id(387735895564483664.4504)
,p_region_css_classes=>'a-Region--simple a-Region--noBottomBorder margin-bottom-md'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock" style="align-items: center;">'');',
'sys.htp.p(''      <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''            <span class="a-Icon a-Icon--medium icon-system-message"></span>'');',
'sys.htp.p(''      </div>'');',
'sys.htp.p(''      <div class="a-MediaBlock-content">'');',
'wwv_flow_4050_ui.show_system_message(p_app_session => :APP_SESSION);',
'sys.htp.p(''      </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4050_ui.system_message_exists()'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491902500090614783.4504)
,p_plug_name=>'Aggiornamenti disponibili'
,p_parent_plug_id=>wwv_flow_api.id(387735895564483664.4504)
,p_region_css_classes=>'a-Region--simple a-Region--noBottomBorder margin-bottom-md'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock" style="align-items: center;">'');',
'sys.htp.p(''      <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''            <span class="a-Icon a-Icon--medium icon-check-circle-s u-success-text"></span>'');',
'sys.htp.p(''      </div>'');',
'sys.htp.p(''      <div class="a-MediaBlock-content">'');',
'sys.htp.p(''      <div id="updates"></div>'');',
'sys.htp.p(''      </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4000_ui.updates_check_enabled()'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(719905102797336935.4504)
,p_name=>'Riepilogo'
,p_region_name=>'dashboard'
,p_parent_plug_id=>wwv_flow_api.id(387735895564483664.4504)
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_css_classes=>'a-Region--simple a-Region--noBottomBorder margin-bottom-md margin-top-none'
,p_region_sub_css_classes=>'a-AVPList--inlineDash'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4500P1000c */',
'   (select to_char(count(*),''999G999G999G990'') from wwv_flows where security_group_id = :flow_security_group_id)  applications,',
'   --',
'   ( select to_char(count(*),''999G999G999G990'')',
'       from sys.dba_tables',
'      where owner = ( select default_schema',
'                        from wwv_flow_fnd_user',
'                       where security_group_id = :WORKSPACE_ID',
'                         and user_name         = :APP_USER',
'                    )',
'   ) as tables,',
'   ( select to_char(count(*),''999G999G999G990'')',
'       from wwv_flow_workspace_users',
'      where workspace_id = :flow_security_group_id',
'        and DEVELOPER_TYPE in (''ADMIN'',''DEVELOPER'')',
'   ) as developers',
'',
'from dual'))
,p_required_role=>wwv_flow_api.id(173297929258927869)
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340556612002171029.4504)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Il report non contiene dati'
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_comment=>'style="width:33%; float:left;"'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(719907467582374228.4504)
,p_query_column_id=>1
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>1
,p_column_heading=>'Applicazioni'
,p_column_link=>'f?p=4000:1500:&SESSION.::&DEBUG.:RP,1500,RIR:::'
,p_column_linktext=>'#APPLICATIONS#'
,p_report_column_required_role=>wwv_flow_api.id(12506407035221692)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(716353599820823642.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLES'
,p_column_display_sequence=>2
,p_column_heading=>'Tabelle'
,p_column_link=>'f?p=4500:3002:&SESSION.::&DEBUG.:RP,3002:::'
,p_column_linktext=>'#TABLES#'
,p_disable_sort_column=>'N'
,p_report_column_required_role=>wwv_flow_api.id(178925305824656679)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(725648466450203303.4504)
,p_query_column_id=>3
,p_column_alias=>'DEVELOPERS'
,p_column_display_sequence=>14
,p_column_heading=>'Sviluppatori'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(735033258614168727.4504)
,p_plug_name=>'Messaggio di area di lavoro'
,p_parent_plug_id=>wwv_flow_api.id(387735895564483664.4504)
,p_region_css_classes=>'a-Region--simple a-Region--noBottomBorder margin-bottom-md'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_4000_ui.workspace_notification_exists(p_workspace_id => :flow_security_group_id) then',
'    sys.htp.p(''<div class="a-MediaBlock" style="align-items: center;">'');',
'    sys.htp.p(''      <div class="a-MediaBlock-graphic">'');',
'    sys.htp.p(''            <span class="a-Icon a-Icon--medium icon-system-message"></span>'');',
'    sys.htp.p(''      </div>'');',
'    sys.htp.p(''      <div class="a-MediaBlock-content">'');',
'    wwv_flow_4000_ui.show_workspace_notification (',
'        p_workspace_id       => :flow_security_group_id,',
'        p_session            => :app_session);',
'    sys.htp.p(''      </div>'');',
'    sys.htp.p(''</div>'');',
'else',
'    sys.htp.p(''<div class="nodatafound padding-none">'');',
'    sys.htp.p(wwv_flow_lang.system_message(''F4500_P1000_NO_WS_MESSAGE''));',
'    sys.htp.p(''</div>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(424658727026558082.4504)
,p_plug_name=>'Language'
,p_region_name=>'builder_home_lang_selector'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>110
,p_plug_source=>'sys.htp.p( wwv_flow_lang.get_language_selector_list );'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_column_width=>'apex-col--bottomBorder'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4000_ui.is_translation_installed( p_flow_id => 4000 )'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446737559680201421.4504)
,p_plug_name=>'Ulteriori informazioni'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>141
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(454525848376819263.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446737607746201422.4504)
,p_plug_name=>'Social'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>151
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(',
'   ''<div class="a-Login-social" style="padding: 8px">''',
'|| ''<ul class="a-Login-socialLinks">''',
'|| ''  <li class="a-Login-socialLinks-item">''',
'|| ''    <a href="https://apex.oracle.com/twitter" target="_blank" rel="noreferrer" class="a-Login-socialLinks-link">''',
'|| ''      <span class="a-Icon icon-twitter"></span>''',
'|| ''      <span class="u-VisuallyHidden">Twitter</span>''',
'|| ''    </a>''',
'|| ''  </li>''',
'|| ''  <li class="a-Login-socialLinks-item">''',
'|| ''    <a href="https://apex.oracle.com/linkedin" target="_blank" rel="noreferrer" class="a-Login-socialLinks-link">''',
'|| ''      <span class="a-Icon icon-linkedin"></span>''',
'|| ''      <span class="u-VisuallyHidden">LinkedIn</span>''',
'|| ''    </a>''',
'|| ''  </li>''',
'|| ''  <li class="a-Login-socialLinks-item">''',
'|| ''    <a href="https://apex.oracle.com/facebook" target="_blank" rel="noreferrer" class="a-Login-socialLinks-link">''',
'|| ''      <span class="a-Icon icon-facebook"></span>''',
'|| ''      <span class="u-VisuallyHidden">Facebook</span>''',
'|| ''    </a>''',
'|| ''  </li>''',
'|| ''  <li class="a-Login-socialLinks-item">''',
'|| ''    <a href="https://apex.oracle.com/youtube" target="_blank" rel="noreferrer" class="a-Login-socialLinks-link">''',
'|| ''      <span class="a-Icon icon-youtube"></span>''',
'|| ''      <span class="u-VisuallyHidden">YouTube</span>''',
'|| ''    </a>''',
'|| ''  </li>''',
'|| ''</ul>''',
'|| ''</div>''',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(725648505217203304.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(735033258614168727.4504)
,p_button_name=>'UPDATE_WS_MESSAGE'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Definisci messaggio area di lavoro'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=4350:35:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-edit'
,p_security_scheme=>wwv_flow_api.id(12520119493499631)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(72206758387569504.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(72206627172569503.4504)
,p_button_name=>'GET_STARTED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Introduzione'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''&P1000_GET_STARTED_URL!JS.'');'
,p_button_css_classes=>'a-Button--dark'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(46201909505253550.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(491902500090614783.4504)
,p_button_name=>'SET_PREFERENCES_UPDATES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Imposta preferenze per aggiornamenti disponibili'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:RP,61:::'
,p_button_css_classes=>'a-Button a-Button--withIcon a-Button--noLabel a-Button--small a-Button--noUI'
,p_icon_css_classes=>'icon-gear'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27407705274714169.4504)
,p_branch_action=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22687012557626819.4504)
,p_name=>'P1000_WARNING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30606315059404549.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27415428967549306.4504)
,p_name=>'P1000_DAYS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30606315059404549.4504)
,p_item_default=>'7'
,p_source=>'7'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27416305914703477.4504)
,p_name=>'P1000_ACTIVITY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(30606315059404549.4504)
,p_item_default=>'V'
,p_source=>'V'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30574131974905133.4504)
,p_name=>'P1000_TIMEFRAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(8979914911187153.4504)
,p_item_default=>'3600'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Impostare il periodo di tempo per vincolare le query di monitoraggio visualizzate in questa pagina.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(279105376347806101.4504)
,p_name=>'P1000_GET_STARTED_URL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(72206627172569503.4504)
,p_source=>'wwv_flow_platform.get_preference(''GET_STARTED_URL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(27278600204929395.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1000'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(109719535125401738.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1000_TIMEFRAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3600'
,p_compute_when=>'P1000_TIMEFRAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(722892902015355701.4504)
,p_name=>'Updates - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(46201909505253550.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(722893014886355702.4504)
,p_event_id=>wwv_flow_api.id(722892902015355701.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(491902500090614783.4504)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Reload page. We have to do it with a timer, because Firefox prevents the redirect otherwise',
'setTimeout(function() {',
'    apex.navigation.redirect( apex.util.makeApplicationUrl({}) );',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1143246546594567418.4504)
,p_name=>'News - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(387735895564483664.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(111520328765861730.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set language fsp pref'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'APEX_UTIL.SET_PREFERENCE(        ',
'             p_preference => ''FSP_LANGUAGE_PREFERENCE'',',
'             p_value      => :P1000_LANGUAGE,      ',
'             p_user       => :APP_USER);'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(491904525501631557.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_FOOTER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Call Home'
,p_process_sql_clob=>'wwv_flow_4000_ui.updates;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'wwv_flow_4000_ui.updates_check_enabled()'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_01001
begin
wwv_flow_api.create_page(
 p_id=>1001.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Browser oggetti'
,p_alias=>'OBJECTBROWSER'
,p_step_title=>'Browser oggetti'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11539602725985552)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
''))
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#ob/ob.js',
'#IMAGE_PREFIX#sw/minified/htmldb_data.min.js',
'#IMAGE_PREFIX#sw/minified/htmldb_objectlist.min.js'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var vCurrentAppArea = ''OBJECTBROWSER'';',
'var gNewObject = ''&REQUEST.'';',
'',
'function pg1001_Init(){',
'  var i, len, blankSrc, m;',
'',
'  $(''#obObjectSelect'').val($v(''OB_CURRENT_TYPE''));',
'  ob_initObject();',
'  var vFrameSrc = html_GetElement(''OB_IFRAME'');',
'',
'  if(gNewObject ==''CREATE'')',
'     ob_CreateObject($v(''OB_CURRENT_TYPE''));',
'  else if(gNewObject !=''NEW''){  ',
'    if ( gNewObject == "FOCUS" && "&OB_OBJECT_ID." != "" ) {',
'      gSideBar.reload($v(''OB_CURRENT_TYPE''),"&OB_OBJECT_ID.",true);  ',
'    } else if (vFrameSrc.value) {',
'      gSideBar.reload();',
'      ob_IframeUrl("f?p=4500:"+vFrameSrc.value);',
'    } else {',
'      blankSrc = "f?p=4500:BLANK_IFRAME:" + $v("pInstance");',
'      m = vFrame.src.match(/\/(f\?p=.*$)/);',
'      if (m && m[1] !== blankSrc) {',
'        ob_IframeUrl(blankSrc);',
'      }',
'      gSideBar.reload();',
'    }',
'  } else {',
'    html_ShowElement(vFrame);',
'  }',
'}'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".a-Body, .a-Main").addClass("resize");  ',
'apex.theme.pageResizeInit();',
'pg1001_Init();',
'apex.jQuery("#dbaseContent").on("load", function() {',
'  if ( gProgressActive ) {',
'    gProgressActive = false;',
'    apex.util.delayLinger.finish( "iframeLoad", function() {',
'      gSpinner$.remove();',
'    });',
'  }',
'});',
'apex.jQuery("#OB_FIND").keydown(function(e) {',
'   if (e.which === 13) {',
'       e.preventDefault();',
'   } ',
'});'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'table.formlayout > tbody > tr > td {padding: 4px 0}',
'.a-ButtonRegion { margin: 0; }'))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12044519546386319.4504)
,p_plug_name=>'Page Hidden Items'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(762796609160793663.4504)
,p_plug_name=>'Crea menu'
,p_region_name=>'obCreateMenu'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(18696924586125446.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(385776364537002403.4504)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157684150404338202.4504)
,p_plug_name=>'Main'
,p_region_name=>'obTable'
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width: 600px; height: 400px;"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attribute_02=>'horizontal'
,p_attribute_03=>'begin'
,p_attribute_04=>'280'
,p_attribute_05=>'N'
,p_attribute_08=>'200'
,p_attribute_09=>'N'
,p_attribute_12=>'Separatore sinistro'
,p_attribute_13=>'Y'
,p_attribute_14=>'Y'
,p_attribute_15=>'Y'
,p_attribute_16=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157684295177338203.4504)
,p_plug_name=>'Left'
,p_region_name=>'obLeftColumn'
,p_parent_plug_id=>wwv_flow_api.id(1157684150404338202.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="obLeftHeader">'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12060303269731750.4504)
,p_plug_name=>'Ricerca oggetto (in alto a sinistra)'
,p_parent_plug_id=>wwv_flow_api.id(1157684295177338203.4504)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding-top: 8px;"'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'</div><!-- Chiude #obLeftHeader -->'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23684331381142907.4504)
,p_plug_name=>'Object types'
,p_parent_plug_id=>wwv_flow_api.id(1157684295177338203.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(23674222199102465.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(23673306353078906.4504)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157684609201338207.4504)
,p_plug_name=>'Lista di oggetti'
,p_region_name=>'ob_ObjectsSlider'
,p_parent_plug_id=>wwv_flow_api.id(1157684295177338203.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157684351585338204.4504)
,p_plug_name=>'A destra'
,p_region_name=>'dbaseFrameHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157684150404338202.4504)
,p_region_css_classes=>'dbaseFrameHolder resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12034411338166350.4504)
,p_plug_name=>'Object Detail (Bottom Right)'
,p_parent_plug_id=>wwv_flow_api.id(1157684351585338204.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<iframe class="resize" frameborder="0" framespacing="0" height="400" width="600" src="f?p=&APP_ID.:BLANK_IFRAME:&APP_SESSION." id="dbaseContent" marginwidth="0" marginheight="0" name="dbaseContent" title="Dettagli oggetto" scrolling="auto"></iframe>'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'f?p=4500:BLANK_IFRAME:&SESSION.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157684465593338205.4504)
,p_plug_name=>'Button Bar'
,p_region_name=>'obRightHeader'
,p_parent_plug_id=>wwv_flow_api.id(1157684351585338204.4504)
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--slimPadding'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="ob_ObjectsDetail"></div>'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1157685656028338217.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(12060303269731750.4504)
,p_button_name=>'REFRESH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Aggiorna'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-refresh'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(762796362867786612.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1157684465593338205.4504)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(385765690470963369.4504)
,p_button_image_alt=>'Crea'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-plus'
,p_button_cattributes=>'data-menu="obCreateMenu_menu"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10845422346444957.4504)
,p_branch_action=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10836903458325936.4504)
,p_name=>'OB_CURRENT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(12044519546386319.4504)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10837501474382161.4504)
,p_name=>'OB_CURRENT_ITEMID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(12044519546386319.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10838111170384930.4504)
,p_name=>'OB_IFRAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(12044519546386319.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10844109748431834.4504)
,p_name=>'OB_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(387994680244652086.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_tag_attributes=>'class="a-Form-select" onchange="gSideBar.onchange();"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica il nome del proprietario dello schema di database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12061301454750109.4504)
,p_name=>'OB_FIND'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(12060303269731750.4504)
,p_prompt=>'Cerca'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>2000
,p_tag_css_classes=>'a-Form-searchField'
,p_tag_attributes=>'onkeyup="gSideBar.filter(event)"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(11535203212720757.4504)
,p_computation_sequence=>10
,p_computation_item=>'OB_SCHEMA'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'OB_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171443603192369341.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1001'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157685791306338218.4504)
,p_name=>'refresh'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1157685656028338217.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157685805160338219.4504)
,p_event_id=>wwv_flow_api.id(1157685791306338218.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'gSideBar.onchange();'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(260975623615469245.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OB_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OB_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01002
begin
wwv_flow_api.create_page(
 p_id=>1002.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Query Builder'
,p_alias=>'QUERYBUILDER'
,p_step_title=>'Query Builder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
''))
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#qb/qb_core.js',
'f?p=4500:0:&SESSION.:APPLICATION_PROCESS=qb_get_saved_query'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var gLastRowHighlight = false;',
'',
'apex.jQuery(document).ready(function() {',
'  apex.jQuery(".a-Body, .a-Main, #QUERYTEXT_fieldset").addClass("resize");  ',
'  apex.theme.pageResizeInit();    ',
'});',
'',
'function pageInit() {',
'  qb_initPage();',
'  qb_getTableList();',
'  var ret = $v(''P1002_RETURN_INTO'');',
'  if (ret != '''' && opener) {',
'    var cSql;',
'    try {',
'        cSql = opener.$( "#" + ret ).codeEditor( "getValue" );',
'    } catch( e ) {',
'        cSql = opener.$v(ret);',
'    }',
'    if (cSql != '''' && $v(''P1002_POPUP'') == 1) {',
'      apex.theme.openRegion("warnDialog");',
'    }',
'  }',
'}',
''))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("body").trigger("resize");',
'pageInit();'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'body .ui-dialog.ui-front {z-index: 20001;}',
'body .ui-dialog.ui-dialog--helpDialog {z-index: 20002;}',
'.d1fix {position:relative;left:0;top:0;overflow:hidden;}',
'.d2fix {position:relative;left:0;top:0;overflow:hidden;}',
''))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/qry_bldr.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1973330602194207.4504)
,p_plug_name=>'(DHTML) Clone Table Rows'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table style="display:none;" role="presentation">',
'<tr id="clone">',
'<td style="text-align: center;" class="qbTableData"><img class="htmldbPseudoButton" style="margin: 2px;" src="#IMAGE_PREFIX#green_arrow_up.gif" onclick="qb_RowUp(this)" /><img class="htmldbPseudoButton" style="margin: 2px;" src="#IMAGE_PREFIX#green_a'
||'rrow_down.gif" onclick="qb_RowDown(this)" /></td>',
'<td class="qbTableData"><br /></td>',
'<td style="text-align: center;" class="qbTableData"><input id="_alias" onchange="qb_genSql()" onblur="qb_genSql()" /></td>',
'<td class="qbTableData"><br /></td>',
'<td style="text-align: center;" class="qbTableData"><input id="_con" onchange="qb_genSql()" onblur="qb_genSql()" /></td>',
'<td style="text-align: center;" class="qbTableData"><select id="_st" onchange="qb_genSql()"><option value="ASC">Asc</option><option value="DESC">Desc</option></select></td>',
'<td style="text-align: center;" class="qbTableData"><input style="width:30px;" id=" _so" onchange="qbValSo(this)" onblur="qbValSo(this)" /></td>',
'<td style="text-align: center;" class="qbTableData"><input id="_out" type="checkbox" checked="checked" onclick="qb_toggleOut(this)" onfocus="qbSetFocus();" /></td>',
'<td style="text-align: center;" class="qbTableData"><select onchange="qb_setFun(this)" class="qbfun" id="_fun"></select></td>',
'<td style="text-align: center;" class="qbTableData"><input id="_grp" type="checkbox" onclick="qb_toggleGrp(this)" /></td>',
'<td style="text-align: center;" class="htmldbPseudoButton"><img id="_del"  src="#IMAGE_PREFIX#delete.gif" onclick="qb_rmConditionImg(this.value)" /></td>',
'</tr>',
'</table>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1996130208515869.4504)
,p_plug_name=>'Query Builder List Menu'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_list_id=>wwv_flow_api.id(1993413324492056.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(18702621564272688.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="defaultLinkMenu" style="display:none;">'
,p_plug_footer=>'</div>'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2310326687229087.4504)
,p_plug_name=>'Salva SQL'
,p_region_name=>'saveDialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1131993087623131882.4504)
,p_plug_display_sequence=>50
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2422415865645260.4504)
,p_plug_name=>'Dynamic js '
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>90
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<script type="text/javascript"> '');',
'sys.htp.p(''var l_maxCols="''||',
'            wwv_flow_lang.system_message(p_name=>''4500_1002_QB_MAX_COLS'')||''";'');',
'sys.htp.p(''var l_noSave="''||',
'            wwv_flow_lang.system_message(p_name=>''QB_NOTHING_TO_SAVE'')||''";'');',
'sys.htp.p(''var l_noName="''||',
'            wwv_flow_lang.system_message(p_name=>''SC_NAME_NN'')||''";'');',
'sys.htp.p(''var l_invSo="''||',
'            wwv_flow_lang.system_message(p_name=>''INVALID_SORT_ORDER'')||''";'');',
'sys.htp.p(''</script>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11768119830012071.4504)
,p_plug_name=>'Schema'
,p_region_name=>'apex-control-icons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(2976007666683831.4504)
,p_plug_display_sequence=>190
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28526129350879148.4504)
,p_plug_name=>'Avvertenza'
,p_region_name=>'warnDialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1131993087623131882.4504)
,p_plug_display_sequence=>60
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''QB_WARN_MESSAGE''));'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
''))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(170603309758466390.4504)
,p_plug_name=>'navigazione di SQL Workshop'
,p_region_name=>'apex-sqlws-icons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(2976007666683831.4504)
,p_plug_display_sequence=>180
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(170601318269466378.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(212033724996722960.4504)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(249359403920818462.4504)
,p_plug_name=>'hidden items'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157684743709338208.4504)
,p_plug_name=>'Main'
,p_region_name=>'qbTable'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="height:600px;width:800px;"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attribute_02=>'horizontal'
,p_attribute_03=>'begin'
,p_attribute_04=>'220'
,p_attribute_05=>'N'
,p_attribute_09=>'N'
,p_attribute_12=>'Separatore sinistro'
,p_attribute_13=>'Y'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157684801680338209.4504)
,p_plug_name=>'Left'
,p_region_name=>'qbSideBar'
,p_parent_plug_id=>wwv_flow_api.id(1157684743709338208.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1038321573565388.4504)
,p_plug_name=>'Left Header'
,p_region_name=>'qbLeftHeader'
,p_parent_plug_id=>wwv_flow_api.id(1157684801680338209.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157685310203338214.4504)
,p_plug_name=>'Objects List'
,p_region_name=>'dbaseObjectsSlider'
,p_parent_plug_id=>wwv_flow_api.id(1157684801680338209.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157684935965338210.4504)
,p_plug_name=>'Right Splitter'
,p_region_name=>'qbFrameHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157684743709338208.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1225836530715180993.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attribute_01=>'#qbFrameHolder_content'
,p_attribute_02=>'vertical'
,p_attribute_03=>'end'
,p_attribute_04=>'280'
,p_attribute_05=>'N'
,p_attribute_09=>'N'
,p_attribute_12=>'Separatore inferiore'
,p_attribute_13=>'Y'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157685084512338211.4504)
,p_plug_name=>'Top'
,p_parent_plug_id=>wwv_flow_api.id(1157684935965338210.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1039008891571168.4504)
,p_plug_name=>'Right Column Top'
,p_parent_plug_id=>wwv_flow_api.id(1157685084512338211.4504)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157685417712338215.4504)
,p_plug_name=>'Diagram Area'
,p_region_name=>'qbTableHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157685084512338211.4504)
,p_region_css_classes=>'d1 resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div>',
'  <div id="qbLinkHolder" class="resize"></div>',
'</div>'))
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157685103835338212.4504)
,p_plug_name=>'Bottom'
,p_region_name=>'qbBottomHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157684935965338210.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1393317200204756.4504)
,p_plug_name=>'Query Builder Sub Tabs'
,p_parent_plug_id=>wwv_flow_api.id(1157685103835338212.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(1390719147195878.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157685538149338216.4504)
,p_plug_name=>'Tab Holder'
,p_region_name=>'htmlTabHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157685103835338212.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="overflow:auto;"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1333007308012693.4504)
,p_plug_name=>'SubTab Conditions'
,p_parent_plug_id=>wwv_flow_api.id(1157685538149338216.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(''<div id="conditionsHolder">'');',
'wwv_flow_query_builder.renderCloneRow;',
'sys.htp.prn(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table id="conditionsHolder" cellpadding="0" cellspacing="0" border="0" summary="" class="mshtmldbRowWithBorders">',
'            <tr>',
'              <td align="right" class="mshtmldbRowWithBorders2">',
'                <table id="conditions" class="htmldbStandard3" summary="" cellpadding="0" cellspacing="0" border="0" width="95%">',
'                  <tbody>',
'                    <tr>',
'                      <th><br /></th>',
'                      <th>Column</th>',
'                      <th>Alias</th>',
'                      <th>Object</th>',
'                      <th>Condition</th>',
'                      <th>Sort Type</th>',
'                      <th>Sort Order</th>',
'                      <th>Output?</th>',
'                      <th>Function</th>',
'                      <th>Group By</th>',
'                    </tr>',
'                  </tbody>',
'                </table>',
'              </td>',
'            </tr>',
'          </table>',
''))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1436110377335282.4504)
,p_plug_name=>'SubTab SQL'
,p_parent_plug_id=>wwv_flow_api.id(1157685538149338216.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="queryText_table" class="resize" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1437123537339088.4504)
,p_plug_name=>'SubTab Results'
,p_parent_plug_id=>wwv_flow_api.id(1157685538149338216.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<div id="queryResults"><br/></div>'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="queryResults_table" style="display:none">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(159962509565166619.4504)
,p_plug_name=>'SubTab SavedSQL'
,p_parent_plug_id=>wwv_flow_api.id(1157685538149338216.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="SavedSQLHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157686118374338222.4504)
,p_plug_name=>'Popup Style'
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.a-Header, #R387929284740561918, .a-Footer {display: none;}',
'</style>'))
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1002_POPUP'
,p_plug_display_when_cond2=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2413904428566265.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2310326687229087.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2415211139577627.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2310326687229087.4504)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28645317900165287.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(28526129350879148.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Torna'
,p_button_position=>'NEXT'
,p_button_condition=>'P1002_POPUP'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28651301755170068.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(28526129350879148.4504)
,p_button_name=>'OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13297030016911316.4504)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(1039008891571168.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
,p_button_condition=>'P1002_POPUP'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2314619470331004.4504)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(1039008891571168.4504)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Salva'
,p_button_position=>'NEXT'
,p_button_condition=>'p1002_popup'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1978217274228265.4504)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(1039008891571168.4504)
,p_button_name=>'RUN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Esegui'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:qb_genSql();html_TabClick(html_GetElement(''result_tab''),''queryResults_table'');qb_getQueryResults();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13144627705418685.4504)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(1039008891571168.4504)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Torna'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:qb_returnSQL();'
,p_button_condition=>'p1002_popup'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3579503096092654.4504)
,p_branch_action=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.::P1002_QUERY_ID:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1476718454545792.4504)
,p_name=>'P1002_FIND'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(1038321573565388.4504)
,p_prompt=>'Trova'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>25
,p_cMaxlength=>2000
,p_tag_css_classes=>'a-Form-searchField'
,p_tag_attributes=>'onkeyup="qb_searchTables()" onchange="qb_sendState()"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1509710676657010.4504)
,p_name=>'P1002_QUERY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(249359403920818462.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1634500089515010.4504)
,p_name=>'P1002_ID'
,p_item_sequence=>0
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2081632332595130.4504)
,p_name=>'P1002_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(249359403920818462.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2306118535113108.4504)
,p_name=>'P1002_QUERY_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(249359403920818462.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2306306638113110.4504)
,p_name=>'P1002_QUERY_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2310326687229087.4504)
,p_prompt=>'Tipo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'QUERY_BUILDER_TYPE'
,p_lov=>'.'||wwv_flow_api.id(2308814912225605.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3301520602864636.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Testo Guida non disponibile.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2306502403113110.4504)
,p_name=>'P1002_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(249359403920818462.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2306731044113111.4504)
,p_name=>'P1002_QUERY_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2310326687229087.4504)
,p_prompt=>'Nome'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_tag_attributes=>'style="cursor:text;padding:0; z-index:8000;position:relative;"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('La query verr\00E0 salvata con questo nome.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2312432143249546.4504)
,p_name=>'P1002_QUERY_DESC'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2310326687229087.4504)
,p_prompt=>'Descrizione'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere una descrizione opzionale della query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3571131333951282.4504)
,p_name=>'QUERYTEXT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(1436110377335282.4504)
,p_prompt=>'Query SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>100
,p_cMaxlength=>32767
,p_cHeight=>12
,p_tag_css_classes=>'u-fixedFont resize'
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3964727904071332.4504)
,p_name=>'P1002_ONCLICK'
,p_item_sequence=>310
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11769701953016299.4504)
,p_name=>'P1002_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(387994680244652086.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-QB'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, ''; ',
'  q:=q||''       wwv_flow_fnd_user u ''; ',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1002_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1002_SCHEMA) a,:P1002_SCHEMA b from dual '';',
'  q:=q||''where  :P1002_POPUP = 1 '';',
'  q:=q||''order by 1'';',
'  return q;',
'end;'))
,p_cHeight=>1
,p_tag_attributes=>'a-Form-select'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13132612421385865.4504)
,p_name=>'P1002_POPUP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2422415865645260.4504)
,p_item_default=>'0'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13137304371402423.4504)
,p_name=>'P1002_RETURN_INTO'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2422415865645260.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110230120799906584.4504)
,p_name=>'P1002_RESULTS_ERROR_MSG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(2422415865645260.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_lang.system_message(''QB_CREATE_QUERY'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114668822188903097.4504)
,p_name=>'P1002_IMAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(249359403920818462.4504)
,p_source=>'<div id="dragimg" style="position:absolute;left:0;top:0;display:none;"><img src="#IMAGE_PREFIX#qb/drag.png" alt="" /></div>'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'style="display:none;"'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2158316801387544526.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1002_POPUP'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2324421042444998.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1002_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1002_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL_OR_ZERO'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929196863636394232.4504)
,p_name=>'Save'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2314619470331004.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929196916531394233.4504)
,p_event_id=>wwv_flow_api.id(929196863636394232.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2310326687229087.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929197068811394234.4504)
,p_name=>'Save SQL Cancel'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2413904428566265.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929197142931394235.4504)
,p_event_id=>wwv_flow_api.id(929197068811394234.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2310326687229087.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929197233776394236.4504)
,p_name=>'Save SQL Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2415211139577627.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929197343166394237.4504)
,p_event_id=>wwv_flow_api.id(929197233776394236.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'qb_saveQuery(''SAVE'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929197456427394238.4504)
,p_name=>'Warning Cancel'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(28645317900165287.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929197547407394239.4504)
,p_event_id=>wwv_flow_api.id(929197456427394238.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'window.close();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929197621895394240.4504)
,p_name=>'Warning OK'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(28651301755170068.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929197781041394241.4504)
,p_event_id=>wwv_flow_api.id(929197621895394240.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(28526129350879148.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(260977613488485260.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1002_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1002_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2305502473099041.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Page Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p1002_query_id is null then',
'  :p1002_query_type := ''P'';',
'  :p1002_owner := :FLOW_USER;',
'  :p1002_query_name := '''';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile popolare i valori iniziali.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7886012904365381.4504)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save_Query_PPR'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i number;',
'  l_ret varchar2(32767);',
'  qid number := -99;',
'  l_o_name varchar2(2000);',
'begin',
'  wwv_flow_sw_api.check_priv(:P1002_SCHEMA);',
'',
'  begin',
'    if wwv_flow.g_f22(1) is not null then',
'      qid := wwv_flow.g_f22(1);',
'    end if;',
'  exception when others then',
'    null;',
'  end;',
'',
'  begin',
'    select title into l_o_name from wwv_flow_qb_saved_query where id = qid;',
'  exception when others then',
'    l_o_name := ''''; ',
'  end;',
'',
'  if (wwv_flow.g_f19(1) = l_o_name) then',
'    delete from wwv_flow_qb_saved_query where id = qid;',
'    commit;',
'  else',
'      qid := wwv_flow_id.next_val;',
'  end if;',
'  ',
'  insert into wwv_flow_qb_saved_query ',
'   (id, title, query_type, description, qb_sql, query_owner, created_by ) ',
'  values ',
'   (qid, wwv_flow.g_f19(1) , ''W'', wwv_flow.g_f21(1), wwv_flow.g_f23(1), :P1002_SCHEMA, :FLOW_USER );',
'',
'  for i in 1..wwv_flow.g_f01.count loop',
'    insert into wwv_flow_qb_saved_tabs ',
'     (id, oid, cnt, top, left, tname ) ',
'    values ',
'     (qid,wwv_flow.g_f01(i),wwv_flow.g_f02(i),wwv_flow.g_f03(i),wwv_flow.g_f04(i),wwv_flow.g_f05(i));',
'  end loop;',
'',
'  for i in 1..wwv_flow.g_f06.count loop',
'    insert into wwv_flow_qb_saved_cond ',
'     (id, col, alias, fv, fp, out, st, so, grp, con, ord) ',
'    values ',
'     (qid, wwv_flow.g_f06(i), wwv_flow.g_f07(i), wwv_flow.g_f08(i), wwv_flow.g_f09(i),',
'      wwv_flow.g_f10(i), wwv_flow.g_f11(i), wwv_flow.g_f12(i), wwv_flow.g_f13(i), wwv_flow.g_f14(i),',
'      i);',
'  end loop;',
'   ',
'  for i in 1..wwv_flow.g_f15.count loop',
'    insert into wwv_flow_qb_saved_join ',
'     (id, field1, field2, cond) ',
'    values ',
'     (qid,wwv_flow.g_f15(i),wwv_flow.g_f16(i),wwv_flow.g_f17(i));',
'  end loop;',
'',
'  sys.htp.prn(qid);',
'  wwv_flow.g_unrecoverable_error := true;',
'EXCEPTION WHEN OTHERS THEN ',
' sys.htp.prn(''---''||wwv_flow_escape.html(SQLERRM));',
' wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'SAVE_QUERY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Operazione completata'
);
end;
/
prompt --application/pages/page_01003
begin
wwv_flow_api.create_page(
 p_id=>1003.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Processore comandi SQL'
,p_alias=>'SQLCOMMANDPROCESSOR'
,p_step_title=>'Comandi SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213236325564854129)
,p_javascript_file_urls=>'#IMAGE_PREFIX#sc/sc_core.js'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(document).ready(function() {',
'  apex.jQuery(".a-Body, .a-Main").addClass("resize");  ',
'  apex.theme.pageResizeInit();',
'});',
''))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sc_PageInit();',
'',
'$("body").trigger("resize");',
'',
'var resizeTimeout = 0;',
'',
'var editorWidget = $("#P1003_SQL_COMMAND1_widget");',
'',
'editorWidget.css("height", "100%");',
'editorWidget.resize();',
'',
'// resize event is triggered twice',
'// adding a timeout for resizing the code editor only once',
'$(''#scCommandHolder'').on(''resize'', function(){',
'    clearTimeout(resizeTimeout);',
'    resizeTimeout = setTimeout(function(){',
'        editorWidget.resize();',
'    }, 100);',
'});',
'',
'var runButton = $(''#scRightHeader .a-Button--hot'');',
'',
'if ( runButton.length ) {',
'    runButton.click( function() {',
'        apex.item("P1003_SQL_COMMAND1").setFocus();',
'    });',
'}',
''))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#htmlTabHolder ',
'{',
'    overflow: auto; ',
'}',
'',
'#P1003_SQL_COMMAND1_CONTAINER',
'{',
'    overflow: hidden ',
'}',
'',
'.a-Form-inputContainer',
'{',
'    height: 100%;',
'}',
''))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/sql_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6464923591877238.4504)
,p_plug_name=>'Salva SQL'
,p_region_name=>'saveDialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1131993087623131882.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22950425871849907.4504)
,p_plug_name=>'javascript'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'var ret = $v("P1003_RETURN_INTO"), value = opener.$v(ret);',
'$s("P1003_SQL_COMMAND2", value);',
'$s("P1003_SQL_COMMAND1", value);',
'</script>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':p1003_popup = 1 ',
'and :p1003_RETURN_INTO is not null'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_read_only_when2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160850031678663106.4504)
,p_plug_name=>'Dynamic Js'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<script type="text/javascript"> '');',
'sys.htp.p(''g_Running="''|| ',
'            wwv_flow_lang.system_message(p_name=>''SC_SQL_RUNNING'')||''";'');',
'sys.htp.p(''</script>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157686386582338224.4504)
,p_plug_name=>'Main'
,p_region_name=>'SqlAndResults'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="height:600px;width:100%;" 400px;"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_02=>'vertical'
,p_attribute_03=>'end'
,p_attribute_04=>'200'
,p_attribute_08=>'100'
,p_attribute_09=>'N'
,p_attribute_12=>'Separatore inferiore'
,p_attribute_13=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157686476230338225.4504)
,p_plug_name=>'Top'
,p_parent_plug_id=>wwv_flow_api.id(1157686386582338224.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1008808320154634.4504)
,p_plug_name=>'SQL Command Entry'
,p_region_name=>'scCommandHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157686476230338225.4504)
,p_region_css_classes=>'a-Form--slimPadding resize d1'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149883011479458110.4504)
,p_plug_name=>'Top Header'
,p_region_name=>'scRightHeader'
,p_parent_plug_id=>wwv_flow_api.id(1157686476230338225.4504)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157686581263338226.4504)
,p_plug_name=>'Bottom'
,p_region_name=>'scBottomHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157686386582338224.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'aria-live="polite"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(998332374048023.4504)
,p_plug_name=>'SQL Command Sub Tabs'
,p_parent_plug_id=>wwv_flow_api.id(1157686581263338226.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(996508348031635.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157686726641338228.4504)
,p_plug_name=>'Ancoraggio scheda'
,p_region_name=>'htmlTabHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157686581263338226.4504)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7074001099790125.4504)
,p_plug_name=>'SubTab Results'
,p_region_name=>'resultsHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157686726641338228.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="fielddata"'
,p_plug_template=>wwv_flow_api.id(2976007666683831.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="fielddata">',
'Immettere l''istruzione SQL o il comando PL/SQL e fare clic su Esegui per visualizzare i risultati.',
'</span>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7077724001825157.4504)
,p_plug_name=>'SubTab Explain'
,p_parent_plug_id=>wwv_flow_api.id(1157686726641338228.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="explainHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7079506471829522.4504)
,p_plug_name=>'SubTab SavedSQL'
,p_parent_plug_id=>wwv_flow_api.id(1157686726641338228.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="SavedSQLHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11759823723994214.4504)
,p_plug_name=>'schema'
,p_region_name=>'sql-schema-select'
,p_parent_plug_id=>wwv_flow_api.id(1157686726641338228.4504)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2976007666683831.4504)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22163002271588185.4504)
,p_plug_name=>'SubTab Describe'
,p_parent_plug_id=>wwv_flow_api.id(1157686726641338228.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="describeHolder" style="display:none;">'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'',
'',
'',
'',
'<script language="JavaScript1.1" type="text/javascript">',
'     <!-- Comment out script for old browsers',
' function filter_escape(in_value) {',
'                out_value = escape( in_value );',
'                return out_value;',
'            }',
'        function genList0_p_t02_4(filter)',
'         {',
'         ',
'pUrl = "wwv_flow_utilities.gen_popup_list";',
'pUrl += "?p_filter="  + filter_escape(filter.value);',
'pUrl += "&p_name=" + escape(''p_t02'');',
'pUrl += "&p_element_index=" + escape(''4'');',
'pUrl += "&p_form_index=" + escape(''0'');',
'pUrl += "&p_max_elements=" + escape('''');',
'pUrl += "&p_escape_html=" + escape('''');',
'pUrl += "&p_ok_to_query=" + escape(''YES'');',
'pUrl += "&p_flow_id=" + escape(''4500'');',
'pUrl += "&p_page_id=" + escape(''139'');',
'pUrl += "&p_session_id=" + escape(''&APP_SESSION.'');',
'pUrl += "&p_eval_value=" + escape('''');',
'pUrl += "&p_translation=" + escape(''N'');',
'pUrl += "&p_lov=" + filter_escape(''select owner||\''.\''||object_name d,owner||\''.\''||object_name r  from sys.dba_objects   where object_type = :p139_type   and object_name not like \''BIN%\''   and object_name not like \''DR$%\''   order by 1'');',
'pUrl += "&p_lov_checksum=11C9E09D7D7595D2A70B20B404698D22";',
'cDebug(pUrl)',
'           w = open(pUrl,"winLovList","Scrollbars=1,resizable=1,width=400,height=500");',
'           if (w.opener == null)',
'             w.opener = self;',
'           w.focus();',
'         }//-->',
'     </script>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23969318672589066.4504)
,p_plug_name=>'SubTab History'
,p_parent_plug_id=>wwv_flow_api.id(1157686726641338228.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="historyHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157686679267338227.4504)
,p_plug_name=>'Hidden Items'
,p_plug_display_sequence=>30
,p_plug_display_point=>'AFTER_HEADER'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1272958007418897127.4504)
,p_plug_name=>'Popup Style'
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.a-Header, #R387929284740561918, .a-Footer {display: none;}',
'</style>'))
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1003_POPUP'
,p_plug_display_when_cond2=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22939220621744313.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Torna'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:sc_returnSQL();'
,p_button_condition=>'P1003_POPUP'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10646217569354338.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Salva'
,p_button_position=>'CREATE'
,p_button_condition=>'P1003_POPUP'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10644629905348428.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_button_name=>'RUN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Esegui'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6472826193915838.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6464923591877238.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6474106585919640.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(6464923591877238.4504)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13280425243815372.4504)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'VIEW_SCRIPTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4421816717753960.4504)
,p_branch_action=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1009422172158645.4504)
,p_name=>'P1003_SQL_COMMAND2'
,p_data_type=>'CLOB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1157686679267338227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1010404642163039.4504)
,p_name=>'P1003_SQL_COMMAND1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(1008808320154634.4504)
,p_prompt=>'Comando SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>5
,p_tag_css_classes=>'a-Form-textarea--code'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'resize'
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P1003_CMD_LANGUAGE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1928693836020541.4504)
,p_name=>'P1003_CMD_LANGUAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_prompt=>'Lingua'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Determina il linguaggio che deve essere utilizzato per eseguire l''istruzione immessa.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6470812902902555.4504)
,p_name=>'P1003_SAVE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6464923591877238.4504)
,p_prompt=>'Nome'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('La query verr\00E0 salvata con questo nome.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6471725716906222.4504)
,p_name=>'P1003_SAVE_DESC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6464923591877238.4504)
,p_prompt=>'Descrizione'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere una descrizione opzionale della query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6499004703108337.4504)
,p_name=>'P1003_QUERY_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1157686679267338227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11765804246007547.4504)
,p_name=>'P1003_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(387994680244652086.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select /* APEX4500L1 */ wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1003_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1003_SCHEMA) a,:P1003_SCHEMA b from dual '';',
'  q:=q||''where  :P1003_POPUP = 1 '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_tag_attributes=>'class="a-Form-select" onchange="sc_SetSchemaOnly()"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12103711913917886.4504)
,p_name=>'P1003_ERASE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_source=>'''<a href="javascript:setValue(''''P1003_SQL_COMMAND1'''','''''''');$x(''''P1003_SQL_COMMAND1'''').focus();" class="a-Button a-Button--small">''||wwv_flow_lang.system_message(''CLEAR_COMMAND'')||''</a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''<a href="javascript:setValue(''''P1003_SQL_COMMAND1'''','''''''');$x(''''P1003_SQL_COMMAND1'''').focus();" class="a-Button a-Button--small">',
'<img alt="''||wwv_flow_lang.system_message(''CLEAR_COMMAND'')||''" title="''||wwv_flow_lang.system_message(''CLEAR_COMMAND'')||''" src="#IMAGE_PREFIX#htmldb/icons/erase_16.gif" />',
'</a>'''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12106403864934485.4504)
,p_name=>'P1003_FIND_ICON'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''<a href="javascript:popupURL(''''f?p=4500:24:&SESSION.:SC::24:P24_STATE:SC:'''');"',
'    class="a-Button a-Button--small a-Button--padLeft">'' ||',
'    wwv_flow_lang.system_message(''FIND_TABLES'') ||',
'    ''</a>'''))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22427709467385060.4504)
,p_name=>'P1003_DESC_OBJ'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1157686679267338227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22928616063638920.4504)
,p_name=>'P1003_POPUP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1157686679267338227.4504)
,p_item_default=>'0'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22929809614646511.4504)
,p_name=>'P1003_RETURN_INTO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1157686679267338227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(136320022504169238.4504)
,p_name=>'P1003_AUTOCOMMIT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_item_default=>'Y'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'AUTOCOMMIT'
,p_lov=>'.'||wwv_flow_api.id(136789232141518670.4504)||'.'
,p_tag_attributes=>'onclick="this.blur();" onchange="sc_toggleJob(this);"'
,p_display_when=>'nvl(wwv_flow_platform.get_preference(''ENABLE_TRANSACTIONAL_SQL''),''N'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_required_patch=>wwv_flow_api.id(140211619632429750.4504)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(136534514172415835.4504)
,p_name=>'P1003_JOBID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1157686679267338227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138940226594571588.4504)
,p_name=>'P1003_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_item_default=>'10'
,p_prompt=>'Righe'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Determina il numero massimo di righe di risultati da visualizzare per le query SQL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183853180032893742.4504)
,p_name=>'P1003_DICTIONARY_QUERY_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(1008808320154634.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(355992729508853224.4504)
,p_name=>'P1003_LANGUAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(149883011479458110.4504)
,p_use_cache_before_default=>'NO'
,p_source=>'return wwv_flow.g_browser_language;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1157686252918338223.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1003_POPUP'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1440283825697991815.4504)
,p_name=>'REMOVE_JOB_ON_UNLOAD'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'unload'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1440284123781991817.4504)
,p_event_id=>wwv_flow_api.id(1440283825697991815.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'EVENT_SOURCE'
,p_attribute_01=>'sc_removeJob();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929197857307394242.4504)
,p_name=>'Save Cancel'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(6472826193915838.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929197977146394243.4504)
,p_event_id=>wwv_flow_api.id(929197857307394242.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sc_CancelSave();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929198077910394244.4504)
,p_name=>'Save Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(6474106585919640.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929198114155394245.4504)
,p_event_id=>wwv_flow_api.id(929198077910394244.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sc_saveSql();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929198245230394246.4504)
,p_name=>'Open Save Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(10646217569354338.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929198332391394247.4504)
,p_event_id=>wwv_flow_api.id(929198245230394246.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6464923591877238.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929198492500394248.4504)
,p_name=>'Run'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(10644629905348428.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929198544616394249.4504)
,p_event_id=>wwv_flow_api.id(929198492500394248.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'html_TabClick(html_GetElement(''result_tab''),''resultsHolder'');',
'setTimeout(function() {',
'    sc_getResults(''&SESSION.'', true);',
'},100);',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183853259628893743.4504)
,p_name=>'Set Chart Query'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'CHART_QUERY'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183853351376893744.4504)
,p_event_id=>wwv_flow_api.id(183853259628893743.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1003_SQL_COMMAND1'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       decode(FK_CHART_QUERY,',
'              null,',
'              ''select "''||COLUMN_NAME||''", count(*) c ''||chr(10)||',
'              ''from "''||TABLE_NAME||''" ''||chr(10)||',
'              ''group by "''||COLUMN_NAME||''" ''||chr(10)||',
'              ''order by 2 desc'',FK_CHART_QUERY) chart_query',
'from WWV_DICTIONARY_CACHE_COL',
'where OWNER_NAME = :OB_SCHEMA',
'  and TABLE_NAME = :OBJECT_NAME',
'  and security_group_id = :WORKSPACE_ID',
'  and id = :P1003_DICTIONARY_QUERY_ID',
''))
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183853431151893745.4504)
,p_event_id=>wwv_flow_api.id(183853259628893743.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'html_TabClick(html_GetElement(''result_tab''),''resultsHolder'');',
'setTimeout(function() {',
'    sc_getResults(''&SESSION.'', true);',
'},100);',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(173569190786980902.4504)
,p_name=>'Set Table Query'
,p_event_sequence=>70
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'TABLE_QUERY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173569217880980903.4504)
,p_event_id=>wwv_flow_api.id(173569190786980902.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1003_SQL_COMMAND1'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sys.dbms_lob.substr(DEFAULT_QUERY,32767,1) DEFAULT_QUERY',
'  from WWV_DICTIONARY_CACHE_OBJ co',
' where co.object_owner = :OB_SCHEMA',
'   and co.object_name = :OBJECT_NAME',
'   and co.security_group_id = :WORKSPACE_ID ',
''))
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173569334225980904.4504)
,p_event_id=>wwv_flow_api.id(173569190786980902.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'html_TabClick(html_GetElement(''result_tab''),''resultsHolder'');',
'setTimeout(function() {',
'    sc_getResults(''&SESSION.'', true);',
'},100);',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(616816958352762844.4504)
,p_name=>'Initialize Ctrl+Enter command'
,p_event_sequence=>80
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(616817066061762845.4504)
,p_event_id=>wwv_flow_api.id(616816958352762844.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function execute(){',
'    html_TabClick($x(''result_tab''), ''resultsHolder'');',
'    // keeps the UI usable while waiting for results.',
'    setTimeout(function () {',
'      sc_getResults($v("pInstance"));',
'    }, 1);',
'}',
'',
'var isMacLike = /(Mac|iPhone|iPod|iPad)/i.test(navigator.platform);',
'',
'var editor = $(''#P1003_SQL_COMMAND1_widget'').codeEditor(''getEditor'');',
'',
'if( isMacLike ){',
'    // special control key on Mac',
'    // this won''t override Insert Line Below as they are mapped to different keys',
'    editor.addCommand(monaco.KeyMod.WinCtrl | monaco.KeyCode.Enter, execute);',
'} else {',
'    // regular control key for all other OSes',
'    // this will override Insert Line Below, which is ok',
'    editor.addCommand(monaco.KeyMod.CtrlCmd | monaco.KeyCode.Enter, execute);',
'}'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14017618785721380.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'default schema'
,p_process_sql_clob=>':P1003_SCHEMA := upper(wwv_flow_user_api.get_default_schema);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(260980702453510428.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(161193710216800474.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1003_SQL_COMMAND2 := '''';',
':P1003_QUERY_ID := '''';',
':P1003_SQL_COMMAND1 := '''';',
':P1003_SAVE_NAME  := '''';',
':P1003_SAVE_DESC := '''';'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01004
begin
wwv_flow_api.create_page(
 p_id=>1004.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Script SQL'
,p_alias=>'SQLSCRIPTS'
,p_step_title=>'Script SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>',
'<script src="#IMAGE_PREFIX#sc/sc_core.js" type="text/javascript"></script>'))
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(163472020717455733.4504)
,p_plug_name=>'Task'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(163470423703447178.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467833706021240350.4504)
,p_plug_name=>'Script'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P1004a */',
'f.id,',
'decode(doc_size,0,',
'       ''&nbsp'',',
'       ''<a href="''||wwv_flow_utilities.prepare_url(''f?p=4500:60:''||:flow_session||''::::P60_FILE_ID:'' ||f.id)||''" class="a-Button a-Button--small">''||',
'       ''<span class="a-Icon icon-edit" title="&EDIT."></span></a>''',
'       ) edit,',
'wwv_flow_item.checkbox(1,f.id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(f.filename))||''"'') cb,',
'substr(f.filename,1,50) t,',
'f.CREATED_ON created,',
'f.created_by,',
'nvl(f.updated_on,f.created_on) updated,',
'f.updated_by,',
'f.doc_size doc_size,',
'(select decode(count(*),0,',
'        ''0'',',
'        sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1220:''||:flow_session||''::::IR_FILE_ID:''||f.id),',
'        to_char(count(*),''999G999G999G999G990''))) c ',
'        from WWV_FLOW_SW_RESULTS',
'        where file_id = f.id) ouput_count,       ',
'decode(doc_size,1,sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1022:''||:flow_session||''::::P1022_FILE_ID:''|| f.id),',
'       ''<img src="#IMAGE_PREFIX#htmldb/icons/error_small.gif" alt="''||wwv_flow_lang.system_message(''ERROR'')||''" />''),',
'decode(wwv_flow_sw_parser.parsed(f.id),1,',
'decode(wwv_flow_sw_script.invalid_script(f.id), 1,',
'       sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1022:''||:flow_session||''::::P1022_FILE_ID:''|| f.id),',
'       ''<span class="a-Icon icon-error" title="''||wwv_flow_lang.system_message(''ERROR'')||''"></span>''),',
'       sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:10:''||:flow_session||''::::F4500_P10_FILE_ID:''|| f.id),',
'       ''<span class="a-Icon icon-run-script" title="''||wwv_flow_lang.system_message(''DEMO_APPLICATION.RUN'')||''"></span>'')),',
'       sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1023:''||:flow_session||''::::P1023_FILE_ID:''|| f.id),',
'       ''<span class="a-Icon icon-run-script" title="''||wwv_flow_lang.system_message(''DEMO_APPLICATION.RUN'')||''"></span>''))) r,',
'       nvl(updated_on,created_on) updated_on_sort,',
'       ''icon-util-script'' icon_img, ',
'   ''&EDIT.'' icon_alt,',
'    decode(doc_size,0,',
'       ''#'',',
'     wwv_flow_utilities.prepare_url(',
'       ''f?p=4500:60:''||:flow_session||''::::P60_FILE_ID:'' ||f.id)',
'       ) icon_edit,',
'       substr(f.filename,1,50) icon_script_name',
'from wwv_flow_files f, wwv_flow_fnd_user u',
'where u.security_group_id = :flow_security_group_id',
'and u.user_name = :APP_USER',
'and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'       or exists ( select 1',
'                     from  wwv_flow_developers',
'                    where security_group_id = :flow_security_group_id',
'                      and userid = :APP_USER',
'                      and instr(developer_role||'':'',''ADMIN:'') > 0',
'                    union',
'                   select 1',
'                     from wwv_flow_fnd_user',
'                    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                      and user_name = :APP_USER',
'                      and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(467833818073240350.4504)
,p_name=>'Scripts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#ICON_EDIT#" class="a-IRR-icon"><span class="a-Icon #ICON_IMG#"></span><span class="a-IRR-iconName">#ICON_SCRIPT_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834017393240364.4504)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834225670240368.4504)
,p_db_column_name=>'CB'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834117249240367.4504)
,p_db_column_name=>'EDIT'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Modifica'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834516929240371.4504)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834312564240369.4504)
,p_db_column_name=>'T'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Nome'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834400346240370.4504)
,p_db_column_name=>'CREATED'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Data creazione'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834613111240372.4504)
,p_db_column_name=>'UPDATED'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Data aggiornamento'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834724673240373.4504)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Autore aggiornamento'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467835106111240377.4504)
,p_db_column_name=>'UPDATED_ON_SORT'
,p_display_order=>9
,p_column_identifier=>'L'
,p_column_label=>'Aggiornato'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834829151240374.4504)
,p_db_column_name=>'DOC_SIZE'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Byte'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467834916936240375.4504)
,p_db_column_name=>'OUPUT_COUNT'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Risultati'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467835016550240376.4504)
,p_db_column_name=>'R'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Esegui'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467835717156298381.4504)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Immagine icona'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467835812010298382.4504)
,p_db_column_name=>'ICON_ALT'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Testo alternativo icona'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467835920704298388.4504)
,p_db_column_name=>'ICON_EDIT'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Modifica icona'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467836014574298389.4504)
,p_db_column_name=>'ICON_SCRIPT_NAME'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Nome script'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10684914348921132.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(467833706021240350.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina selezione'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10807025483846713.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(467833706021240350.4504)
,p_button_name=>'UPLOAD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Carica'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1017:&SESSION.::&DEBUG.:RP,1017:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213240874740764243.4504)
,p_button_sequence=>25
,p_button_plug_id=>wwv_flow_api.id(467833706021240350.4504)
,p_button_name=>'CREATE_QS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Quick SQL'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10811003413897151.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(467833706021240350.4504)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:60,SR_SCRIPT_SOURCE::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10682401792909898.4504)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112519217202485006.4504)
,p_validation_name=>'must select script(s) to delete'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Specificare gli script da eliminare.'
,p_when_button_pressed=>wwv_flow_api.id(10684914348921132.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(657007896931142127.4504)
,p_name=>'Refresh Report'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(10807025483846713.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(657007940226142128.4504)
,p_event_id=>wwv_flow_api.id(657007896931142127.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(467833706021240350.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199175924058878435.4504)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(467833706021240350.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199176000849878436.4504)
,p_event_id=>wwv_flow_api.id(1199175924058878435.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(10688117596931583.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    wwv_flow_sw_script.delete_file (wwv_flow.g_f01(i));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile eliminare lo script o gli script.'
,p_process_when_button_id=>wwv_flow_api.id(10684914348921132.4504)
,p_process_success_message=>'Script eliminato/i.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(109964518598304737.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_01005
begin
wwv_flow_api.create_page(
 p_id=>1005.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Utility'
,p_alias=>'UTILITIES'
,p_step_title=>'Utility'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11093307704620192)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169564631965962067.4504)
,p_plug_name=>'Utility'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--noBadge:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(169562905299954428.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(692727073209839891.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(171468212018684047.4504)
,p_plug_name=>'Crea oggetto'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149627725126847053.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466733423380364017.4504)
,p_plug_name=>'Informazioni'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Usare queste utility per caricare e scaricare i dati da un database Oracle, generare DDL, visualizzare i report sugli oggetti e ripristinare gli oggetti di database eliminati.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171468103360681580.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1005'
);
end;
/
prompt --application/pages/page_01017
begin
wwv_flow_api.create_page(
 p_id=>1017.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica script'
,p_page_mode=>'MODAL'
,p_step_title=>'Carica script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_script_upload.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10998013210200854.4504)
,p_plug_name=>'Carica script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>11
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208324524754634133.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>21
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10999819574212100.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208324524754634133.4504)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Carica'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(969052831447554615.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208324524754634133.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8484026248651124.4504)
,p_name=>'P1017_SCRIPT_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(10998013210200854.4504)
,p_prompt=>'Nome script'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>70
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere un nome script se si desidera utilizzarne uno diverso rispetto a quello caricato.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11002725686280101.4504)
,p_name=>'P1017_FILE'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(10998013210200854.4504)
,p_prompt=>'File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>50
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Fare clic su <strong>Sfoglia</strong> per individuare lo script da caricare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11003907378303220.4504)
,p_name=>'P1017_FILE_CHARSET'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(10998013210200854.4504)
,p_prompt=>'Set di caratteri file'
,p_source=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(143356515285702408.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Scegliere il set di caratteri in base al quale lo script \00E8 codificato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16681422922177974.4504)
,p_name=>'P1017_FILENAME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(10998013210200854.4504)
,p_prompt=>'Nome file'
,p_source=>'substr(:P1017_FILE,instr(:P1017_FILE,''/'')+1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Nome dello script da caricare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(16561628697971464.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1017_SCRIPT_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(:P1017_FILE,instr(:P1017_FILE,''/'')+1)'
,p_compute_when=>'P1017_SCRIPT_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(11011107687350655.4504)
,p_validation_name=>'P1017_FILE'
,p_validation_sequence=>20
,p_validation=>'P1017_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Caricare lo script.'
,p_when_button_pressed=>wwv_flow_api.id(10999819574212100.4504)
,p_associated_item=>wwv_flow_api.id(11002725686280101.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8495330235690148.4504)
,p_validation_name=>'script name must be unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cnt number := 0;',
'begin',
'  for c1 in (select count(*) cnt',
'             from wwv_flow_files',
'             where lower(filename) = lower(:P1017_SCRIPT_NAME)',
'             and file_type = ''SCRIPT'')',
'  loop',
'    l_cnt := c1.cnt;',
'  end loop;',
'  if l_cnt > 0 then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Uno script con questo nome esiste gi\00E0. Caricare lo script con un nome diverso.')
,p_validation_condition=>'P1017_SCRIPT_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(10999819574212100.4504)
,p_associated_item=>wwv_flow_api.id(8484026248651124.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12498215168590766.4504)
,p_validation_name=>'valid script name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_sw_script.valid_script_name (',
'    p_script_name => :P1017_SCRIPT_NAME) then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome dello script non pu\00F2 contenere caratteri riservati.')
,p_validation_condition=>'P1017_SCRIPT_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(10999819574212100.4504)
,p_associated_item=>wwv_flow_api.id(8484026248651124.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(133436003289757453.4504)
,p_validation_name=>'script not 0 bytes'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_doc_size number := 0;',
'begin',
'  for c1 in (select doc_size                     ',
'             from wwv_flow_files',
'             where name = :P1017_FILE)',
'  loop',
'    l_doc_size := c1.doc_size;',
'  end loop;',
'  if l_doc_size = 0 then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Lo script caricato \00E8 vuoto. Caricare lo script con il contenuto.')
,p_validation_condition=>'P1017_FILE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(10999819574212100.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(133442803382814264.4504)
,p_validation_name=>'exceeds max size'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_doc_size number := 0;',
'  l_max_size number := 0;',
'begin',
'  l_max_size := nvl(wwv_flow_platform.get_preference(''MAX_SCRIPT_SIZE''),500000);',
'  ',
'  for c1 in (select doc_size                     ',
'             from wwv_flow_files',
'             where name = :P1017_FILE)',
'  loop',
'    l_doc_size := c1.doc_size;',
'  end loop;',
'  if l_doc_size > l_max_size then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Lo script supera la dimensione massima consentita.'
,p_validation_condition=>'P1017_FILE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(10999819574212100.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(969053132020554618.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(969052831447554615.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(969053206061554619.4504)
,p_event_id=>wwv_flow_api.id(969053132020554618.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(11012208080379125.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save File Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_script.save_file_attrib(',
'    p_flow_id           => :flow_id,',
'    p_security_group_id => :flow_security_group_id,',
'    p_name              => :P1017_FILE,',
'    p_created_by        => :flow_user,',
'    p_filename          => :P1017_SCRIPT_NAME,    ',
'    p_file_type         => ''SCRIPT'',',
'    p_file_charset      => :P1017_FILE_CHARSET',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile caricare lo script.'
,p_process_when_button_id=>wwv_flow_api.id(10999819574212100.4504)
,p_process_success_message=>unistr('Script scaricato. \00C8 possibile fare clic sullo script per modificarlo o eseguirlo.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(11013500377395876.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Parse Uploaded File'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_id number := 0;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_files',
'             where name = :P1017_FILE)',
'  loop',
'    l_id := c1.id;',
'  end loop;',
'  if l_id != 0 then',
'    wwv_flow_sw_parser.parse_file( p_file_id => l_id );',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile analizzare lo script.'
,p_process_when_button_id=>wwv_flow_api.id(10999819574212100.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(657007761187142126.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01022
begin
wwv_flow_api.create_page(
 p_id=>1022.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Script non valido'
,p_step_title=>'Script non valido'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27980719731681180.4504)
,p_plug_name=>'Script non valido'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_script.display_invalid_stmt(',
'    p_file_id => :P1022_FILE_ID,',
'    p_date_time_format => :DATE_TIME_FORMAT );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1301955172115853704.4504)
,p_name=>'&nbsp;'
,p_parent_plug_id=>wwv_flow_api.id(27980719731681180.4504)
,p_template=>wwv_flow_api.id(746376253838324384.4504)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.filename "Script Name",',
'               f.created_by "Created By",',
'               f.created_on "Created On",',
'               f.updated_on "Updated",',
'               f.doc_size "Script Size in Bytes",',
'               (select count(distinct stmt_number) "Number of Statements"',
'               from wwv_flow_sw_stmts',
'               where file_id = f.id',
'               and isrunnable = ''Y''',
'               and security_group_id = :FLOW_SECURITY_GROUP_ID) cnt',
'               from wwv_flow_files f',
'               where f.id = :P1022_FILE_ID'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301955215074853705.4504)
,p_query_column_id=>1
,p_column_alias=>'Script Name'
,p_column_display_sequence=>1
,p_column_heading=>'Nome script'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301955354792853706.4504)
,p_query_column_id=>2
,p_column_alias=>'Created By'
,p_column_display_sequence=>2
,p_column_heading=>'Creazione di'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301955457770853707.4504)
,p_query_column_id=>3
,p_column_alias=>'Created On'
,p_column_display_sequence=>3
,p_column_heading=>'Data creazione'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301955562422853708.4504)
,p_query_column_id=>4
,p_column_alias=>'Updated'
,p_column_display_sequence=>4
,p_column_heading=>'Aggiornato'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301955678832853709.4504)
,p_query_column_id=>5
,p_column_alias=>'Script Size in Bytes'
,p_column_display_sequence=>5
,p_column_heading=>'Dimensione script in byte'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301955726828853710.4504)
,p_query_column_id=>6
,p_column_alias=>'CNT'
,p_column_display_sequence=>6
,p_column_heading=>'Numero di istruzioni'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28014901498959784.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(27980719731681180.4504)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Modifica script'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:&P1022_FILE_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28020314789973088.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(27980719731681180.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27995229493863723.4504)
,p_name=>'P1022_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(27980719731681180.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01023
begin
wwv_flow_api.create_page(
 p_id=>1023.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Analizza script'
,p_step_title=>'Analizza script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="sc_parsing()"'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function sc_parsing(){      ',
'  var get = new htmldb_Get(null,4500,''APPLICATION_PROCESS=sr_parsing'',0);',
'  var results = get.get();',
'  var status = results.substring(0,7);',
'  if (status == ''FAILURE''){',
'    doSubmit(''FAILURE'');',
'  }',
'  else{',
'    doSubmit(''SUCCESS'');',
'  } ',
'}'))
,p_step_template=>wwv_flow_api.id(703368619593851824.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28035817091039968.4504)
,p_plug_name=>'Parsing Script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969056247209554649.4504)
,p_plug_name=>'Analisi dello script in corso. Attendere.'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(717420493098820783.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969056395065554650.4504)
,p_plug_name=>'Pulsanti procedura guidata'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28113528248298642.4504)
,p_branch_action=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::F4500_P10_FILE_ID:&P1023_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SUCCESS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28114808293302384.4504)
,p_branch_action=>'f?p=&APP_ID.:1022:&SESSION.::&DEBUG.::P1022_FILE_ID:&P1023_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'FAILURE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28037905448046026.4504)
,p_name=>'P1023_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(28035817091039968.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28058730045128869.4504)
,p_name=>'P1023_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(28035817091039968.4504)
,p_source=>'PARSING'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01040
begin
wwv_flow_api.create_page(
 p_id=>1040.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Oggetti non validi'
,p_step_title=>'Oggetti non validi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(275619009526176844)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11724207541696289.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34145430213104114.4504)
,p_plug_name=>'Oggetti non validi'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1040_OWNER as object_owner,',
'       object_name,',
'       replace(object_type,'' '',''_'') object_type,',
'       status,',
'       decode(object_type,''DATABASE LINK'',''DBASE''||',
'   ltrim(to_char(ora_hash(upper(:P1040_OWNER || ''.'' || object_name),1000000000,',
'          power(2,30)),',
'       rpad( ''X'',29,''X'')||''X'')),object_id) object_id,',
'       created date_created,',
'       nvl(last_ddl_time, created) lastddltime',
'  from sys.user_objects',
' where status = ''INVALID''',
'   and object_name not like ''BIN$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1040_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(34145524067104114.4504)
,p_name=>'Invalid Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34145824988104161.4504)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Nome oggetto'
,p_column_link=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:#OBJECT_ID#,#OBJECT_TYPE#,#OBJECT_OWNER#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34146001711104161.4504)
,p_db_column_name=>'STATUS'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Stato'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34145931016104161.4504)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34145717239104156.4504)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34146117372104161.4504)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34146222448104161.4504)
,p_db_column_name=>'DATE_CREATED'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Data creazione'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34146323886104162.4504)
,p_db_column_name=>'LASTDDLTIME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Ultima DDL'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722739206044798620.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34145430213104114.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11062627377486815.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1040:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11061518898481403.4504)
,p_name=>'P1040_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11724207541696289.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112248625019926062.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1040_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1040_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69260509967783707.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1040_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_01042
begin
wwv_flow_api.create_page(
 p_id=>1042.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Report oggetti'
,p_step_title=>'Report oggetti'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(275619009526176844)
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_obj_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32415731233960470.4504)
,p_plug_name=>'Report tabelle'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_api.id(703386252988943977.4504)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(11239830706238313.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(32427114807996970.4504)
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32440018476060806.4504)
,p_plug_name=>'Report PL/SQL'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_api.id(703386252988943977.4504)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(11319530060616601.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(32427114807996970.4504)
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32443902808075234.4504)
,p_plug_name=>'Report eccezioni'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_api.id(703386252988943977.4504)
,p_plug_display_sequence=>110
,p_list_id=>wwv_flow_api.id(11254208206307506.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(32427114807996970.4504)
,p_plug_column_width=>'apex-col--bottomBorder'
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32452801432150529.4504)
,p_plug_name=>'Report sicurezza'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_api.id(703386252988943977.4504)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(11271128516379623.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(32427114807996970.4504)
,p_plug_column_width=>'apex-col--leftBorder'
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32460223642185327.4504)
,p_plug_name=>'Report su tutti gli oggetti'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_api.id(703386252988943977.4504)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(276235426866859669.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(32427114807996970.4504)
,p_plug_column_width=>'apex-col--leftBorder'
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(171473203060709860.4504)
,p_plug_name=>'Crea oggetto'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(149627725126847053.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171473126132707058.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1042'
);
end;
/
prompt --application/pages/page_01046
begin
wwv_flow_api.create_page(
 p_id=>1046.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Argomenti program unit PL/SQL'
,p_step_title=>'Argomenti program unit PL/SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276002212445738952)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_plsql.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11704507223573166.4504)
,p_plug_name=>'Owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441250116947415301.4504)
,p_plug_name=>'Tutti gli argomenti'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1046_OWNER as owner,',
'       package_name,',
'       object_name,',
'       object_id,',
'       argument_name,',
'       position,',
'       in_out',
'  from sys.user_arguments',
' where argument_name is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1046_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441250212488415301.4504)
,p_name=>'All Arguments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441250410030415304.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441250522806415305.4504)
,p_db_column_name=>'PACKAGE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Package'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441250631454415306.4504)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Program unit'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441250931756415325.4504)
,p_db_column_name=>'POSITION'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Posizione'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441250825763415325.4504)
,p_db_column_name=>'ARGUMENT_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Argomento'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441251016200415326.4504)
,p_db_column_name=>'IN_OUT'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'In Out'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441250710319415307.4504)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>7
,p_column_identifier=>'D'
,p_column_label=>'Oggetto'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722739608986798624.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441250116947415301.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11193001302595653.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1046:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11191616949590962.4504)
,p_name=>'P1046_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11704507223573166.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(69226109218679418.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1046_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1046_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69222531120666822.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1046_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_01047
begin
wwv_flow_api.create_page(
 p_id=>1047.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Colonne tabelle'
,p_step_title=>'Colonne tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(275619009526176844)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5096130889958700.4504)
,p_plug_name=>'Colonne tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P1047a */',
'   :P1047_OWNER owner,',
'   table_name,',
'   column_name,',
'   initcap(data_type) ||',
'      decode(data_type,',
'          ''CHAR'',      ''(''|| char_length ||'')'',',
'          ''VARCHAR'',   ''(''|| char_length ||'')'',',
'          ''VARCHAR2'',  ''(''|| char_length ||'')'',',
'          ''NCHAR'',     ''(''|| char_length ||'')'',',
'          ''NVARCHAR'',  ''(''|| char_length ||'')'',',
'          ''NVARCHAR2'', ''(''|| char_length ||'')'',',
'          ''NUMBER'',    ''(''||',
'                       nvl(data_precision,data_length)||',
'                       decode(data_scale,null,null,',
'                                        '',''||data_scale)||'')'',',
'          null) data_type,',
'decode(nullable,''Y'',''<span class="a-Icon icon-check"></span>'',null) nullable,',
'         column_id',
'from sys.user_tab_columns',
'where table_name not like ''BIN$%''',
'  and column_id is not null',
'order by table_name, column_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1047_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(5096215461958700.4504)
,p_name=>'Table Columns'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5096418083958758.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5096525354958758.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Tabella'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5096909376958759.4504)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5096613345958758.4504)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Colonna'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5096719279958758.4504)
,p_db_column_name=>'DATA_TYPE'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5096800255958758.4504)
,p_db_column_name=>'NULLABLE'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Annullabile'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11560827900610888.4504)
,p_plug_name=>'Owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722740442598798632.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5096130889958700.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11170511130439125.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1047:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11163701113293085.4504)
,p_name=>'P1047_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11560827900610888.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Proprietario'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(8024706122365449.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1047_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1047_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69201622930598210.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1047_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_01048
begin
wwv_flow_api.create_page(
 p_id=>1048.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dimensioni memorizzazione tabelle'
,p_step_title=>'Dimensioni memorizzazione tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11527527033122057.4504)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441113717051166865.4504)
,p_plug_name=>'Dimensioni tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>11
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1048_OWNER owner,',
'       segment_name, ',
'       tablespace_name, ',
'       round(bytes/1024/1024,2) megabytes',
'from sys.user_segments',
'where segment_type = ''TABLE'' and',
'(nvl(:P1048_INCLUDE_RECYCLE_BIN,''N'')=''Y'' or segment_name not like ''BIN$%'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1048_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441113831627166865.4504)
,p_name=>'Table Sizes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441114119746166872.4504)
,p_db_column_name=>'SEGMENT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Nome'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441114200482166873.4504)
,p_db_column_name=>'TABLESPACE_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Tablespace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(973959280123400202.4504)
,p_db_column_name=>'MEGABYTES'
,p_display_order=>12
,p_column_identifier=>'F'
,p_column_label=>'Megabyte'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441114026679166871.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>22
,p_column_identifier=>'A'
,p_column_label=>'OWNER'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(468202327871617260.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441113717051166865.4504)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1048:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11225609681895677.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1048:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11224616639893667.4504)
,p_name=>'P1048_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11527527033122057.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Proprietario'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identificare il proprietario dello schema di database. Ogni area di lavoro pu\00F2 disporre di privilegi in uno o pi\00F9 schemi.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85310118139997572.4504)
,p_name=>'P1048_INCLUDE_RECYCLE_BIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(11527527033122057.4504)
,p_item_default=>'N'
,p_prompt=>'Includi cestino'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_api.id(23482928300634173.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Selezionare <strong>S\00EC</strong> per includere gli oggetti nel cestino e fare clic su <strong>Vai</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112175516671620820.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1048_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1048_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69214501075639261.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1048_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_01052
begin
wwv_flow_api.create_page(
 p_id=>1052.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Statistiche tabelle'
,p_step_title=>'Statistiche tabelle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276037127560809519)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11575703689448002.4504)
,p_plug_name=>'object owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441100513841137953.4504)
,p_plug_name=>'Statistiche tabelle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P1052a */',
'  :p1052_schema owner,',
'  table_name,',
'  decode(IOT_TYPE,''YES'',''IOT'',''HEAP'')||',
'    decode(temporary,''N'',null,''-Temporary'')||',
'    decode(trim(cache),''N'',null,''-Cached'')||',
'    decode(partitioned,''NO'',null,''-Partitioned'')||',
'    decode(compression,''DISABLED'',null,''-Compressed'')',
'    table_type,',
'  last_analyzed,',
'  NUM_ROWS,',
'  AVG_ROW_LEN',
'from sys.user_tables',
'where table_name not like ''BIN$%'' and',
'      table_name not like ''DR$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1052_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441100608395137953.4504)
,p_name=>'Table Statistics'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441100801813137973.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441100913652137974.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nome tabella'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441101103682137976.4504)
,p_db_column_name=>'LAST_ANALYZED'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Ultima analisi'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441101204942137976.4504)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Righe'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441101319944137977.4504)
,p_db_column_name=>'AVG_ROW_LEN'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Lunghezza media righe'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441101001547137975.4504)
,p_db_column_name=>'TABLE_TYPE'
,p_display_order=>6
,p_column_identifier=>'C'
,p_column_label=>'Tipo di tabella'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722740182933798629.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441100513841137953.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11577832217465775.4504)
,p_name=>'P1052_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11575703689448002.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112170304981598569.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1052_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1052_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69211808563631993.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1052_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_01054
begin
wwv_flow_api.create_page(
 p_id=>1054.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conteggi righe program unit PL/SQL'
,p_step_title=>'Conteggi righe program unit PL/SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276002212445738952)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_plsql.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5100303284971553.4504)
,p_plug_name=>'Conteggi righe program unit PL/SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1054_SCHEMA owner,',
'  type,',
'  name,',
'  count(*) lines',
'from sys.user_source',
'group by 1, type, name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1054_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(5100428245971553.4504)
,p_name=>'PL/SQL Program Unit Line Counts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5100629890971562.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5100701521971562.4504)
,p_db_column_name=>'TYPE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Tipo di oggetto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5100822171971562.4504)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nome oggetto PL/SQL'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5100916967971562.4504)
,p_db_column_name=>'LINES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Righe'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11706409610621133.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722739545318798623.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5100303284971553.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11715609787659055.4504)
,p_branch_action=>'f?p=&APP_ID.:1054:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11708029003626749.4504)
,p_name=>'P1054_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11706409610621133.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112238622333906358.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1054_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1054_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(276581106200129678.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69228525494684171.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1054_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_01055
begin
wwv_flow_api.create_page(
 p_id=>1055.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Calendario creazione oggetti'
,p_step_title=>'Calendario creazione oggetti'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(275619009526176844)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8288117937948579.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(722738912283798617.4504)
,p_plug_name=>'Calendario creazione oggetti'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id, owner, object_type||'': ''||object_name object_name, created, last_DDL_time, object_type',
'from sys.dba_objects',
'where owner = :p1055_schema and object_name not like ''BIN$%''',
'order by created'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1055_SCHEMA'
,p_attribute_01=>'LAST_DDL_TIME'
,p_attribute_03=>'OBJECT_NAME'
,p_attribute_09=>'month:list:navigation'
,p_attribute_13=>'N'
,p_attribute_17=>'Y'
,p_attribute_19=>'N'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11337325344701687.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1055:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8288822786949976.4504)
,p_name=>'P1055_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8288117937948579.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112254729090946101.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1055_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1055_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69262125550788241.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1055_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
,p_process_when=>'P1055_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01059
begin
wwv_flow_api.create_page(
 p_id=>1059.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Conteggi di oggetti per tipo'
,p_step_title=>'Conteggi di oggetti per tipo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(275619009526176844)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8517111890760577.4504)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441228300730210134.4504)
,p_plug_name=>'Oggetti database per tipo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1059_SCHEMA owner, object_type, count(*) object_count',
'from sys.user_objects',
'where upper(object_name) not like ''BIN$%''',
'group by 1, object_type'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1059_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441228426684210134.4504)
,p_name=>'Database Objects by Type'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441228624524210143.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441228701422210144.4504)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Tipo di oggetto'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441228806701210144.4504)
,p_db_column_name=>'OBJECT_COUNT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Conteggio oggetti'
,p_column_link=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:500,RIR:IR_OBJECT_TYPE,F4500_P500_SCHEMA:#OBJECT_TYPE#,&P1059_SCHEMA.'
,p_column_linktext=>'#OBJECT_COUNT#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722738837231798616.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441228300730210134.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(276213904693777514.4504)
,p_branch_action=>'f?p=&APP_ID.:1059:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8519204749767917.4504)
,p_name=>'P1059_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8517111890760577.4504)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema di database (nome utente) che si desidera visualizzare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112258025412954595.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1059_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1059_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69263710444793307.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1059_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
);
end;
/
prompt --application/pages/page_01070
begin
wwv_flow_api.create_page(
 p_id=>1070.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Cestino'
,p_step_title=>'Cestino'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_restor.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11402600478509665.4504)
,p_plug_name=>'Cestino'
,p_icon_css_classes=>'icon-utilites-recycle-bin'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(703386252988943977.4504)
,p_plug_display_sequence=>11
,p_list_id=>wwv_flow_api.id(11401232423499912.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(704358525679957526.4504)
,p_plug_required_role=>wwv_flow_api.id(240648913515910366)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240662923622936918.4504)
,p_plug_name=>'Cestino non supportato'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>21
,p_plug_source=>unistr('Il cestino non \00E8 supportato nella versione del database corrente, ma \00E8 disponibile solo per la release Oracle 10.1 o successiva.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>'!'||wwv_flow_api.id(240648913515910366)
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1020678633228036507.4504)
,p_name=>'RENDERING: Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(11402600478509665.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1020678912790036509.4504)
,p_event_id=>wwv_flow_api.id(1020678633228036507.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:1070:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
end;
/
prompt --application/pages/page_01100
begin
wwv_flow_api.create_page(
 p_id=>1100.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Quick SQL'
,p_step_title=>'Quick SQL'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'[require requirejs]#IMAGE_PREFIX#libraries/monaco-editor/0.22.3/min/vs/editor/editor.main.js',
'[require requirejs]#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.codeEditor#MIN#.js',
'[require requirejs]#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#quickSQL#MIN#.js'))
,p_javascript_code_onload=>'// see var QuickSQL in DA: Initialization'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.qs-main {',
'	max-width: 100vw;',
'}',
'.qs-main,',
'.qs-main > .apex-grid-container,',
'.qs-main .apex-row,',
'.qs-main-col,',
'.qs-col-body {',
'    flex-grow: 1;',
'    display: flex;',
'}',
'',
'.qs-main .apex-col {',
'    display: flex;',
'}',
'',
'.qs-main,',
'.qs-main-col,',
'.qs-main .apex-col,',
'.qs-col-body {',
'    flex-direction: column;',
'}',
'',
'.sql-container{',
'    display: flex;',
'    flex-grow: 1;',
'    flex-direction: column;',
'}',
'',
'.sql-container {',
'	  justify-content: center;',
'}',
'',
'h2.no-sql-yet {margin: 24px;text-align: center;color: rgba(0,0,0,.55);font-size: 20px;line-height: 1.5;font-weight: 400;}',
'.a-ButtonRegion--showTitle .a-ButtonRegion-title {',
'    font-size: 14px;',
'    font-weight: 500;',
'}',
'',
'.a-Button--iconTextButton .fa {',
'    margin-left: 4px;',
'}',
'.a-Button--iconLeft .fa {',
'    margin-left: 0;',
'}',
'.a-Button--iconLeft {',
'    padding-left: 28px;',
'}',
'',
'span.quicksql-table {',
'    color: #1E84BF;',
'    font-weight: bold;',
'}'))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213236648802764201.4504)
,p_plug_name=>'Elementi nascosti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213236759445764202.4504)
,p_plug_name=>'Contenitore Quick SQL'
,p_region_name=>'qs_container'
,p_region_css_classes=>'qs-main a-Region--touchTop'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213236842105764203.4504)
,p_plug_name=>'Contenitore sintassi abbreviata'
,p_parent_plug_id=>wwv_flow_api.id(4213236759445764202.4504)
,p_region_css_classes=>'qs-main-col'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213237147658764206.4504)
,p_plug_name=>'Quick SQL'
,p_parent_plug_id=>wwv_flow_api.id(4213236842105764203.4504)
,p_region_css_classes=>'apex-col--bottomBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213237222183764207.4504)
,p_plug_name=>'Input'
,p_parent_plug_id=>wwv_flow_api.id(4213236842105764203.4504)
,p_region_css_classes=>'qs-col-body'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div class="sql-container" id="quicksql_input"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213236929029764204.4504)
,p_plug_name=>'Contenitore di output'
,p_parent_plug_id=>wwv_flow_api.id(4213236759445764202.4504)
,p_region_css_classes=>'qs-main-col'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--leftBorder'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213237340125764208.4504)
,p_plug_name=>'SQL'
,p_parent_plug_id=>wwv_flow_api.id(4213236929029764204.4504)
,p_region_css_classes=>'apex-col--bottomBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213237403490764209.4504)
,p_plug_name=>'Output'
,p_region_name=>'output-sql-region'
,p_parent_plug_id=>wwv_flow_api.id(4213236929029764204.4504)
,p_region_css_classes=>'qs-col-body'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="sql-container" id="quicksql_output">',
'<h2 class="no-sql-yet">Digitare alcune istruzioni SQL a sintassi abbreviata <br>e fare clic sul pulsante Genera SQL</h2>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213237553577764210.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4213237147658764206.4504)
,p_button_name=>'CLEAR'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Cancella'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:RP,1100::'
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'fa fa-eraser'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213237625352764211.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4213237147658764206.4504)
,p_button_name=>'LOAD_MODEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Carica'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1103:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'fa fa-cloud-download'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213237954091764214.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4213237340125764208.4504)
,p_button_name=>'SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Impostazioni'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1101:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'fa fa-wrench'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213237751589764212.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4213237147658764206.4504)
,p_button_name=>'SYNTAX'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Guida'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1102:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'fa fa-keyboard-o'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213237886610764213.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4213237340125764208.4504)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Scarica'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109719613560401739.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(4213237147658764206.4504)
,p_button_name=>'SAVE_MODEL'
,p_button_static_id=>'saveModel_btn'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Salva modello'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1105:&SESSION.::&DEBUG.:1105::'
,p_button_css_classes=>'a-Button--simple'
,p_button_cattributes=>'disabled'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213241085471764245.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(4213237340125764208.4504)
,p_button_name=>'SAVE'
,p_button_static_id=>'save_btn'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Salva script SQL'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1104:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213237005118764205.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(4213237147658764206.4504)
,p_button_name=>'GEN_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Genera SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213512950070243944.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(4213237340125764208.4504)
,p_button_name=>'RUN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Riesamina ed esegui'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa fa-play-circle'
,p_button_cattributes=>'disabled'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4032943427297342950.4504)
,p_branch_name=>'branchToRun'
,p_branch_action=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:RP,60:P60_FILE_ID:&P1100_SCRIPT_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4032943314209342949.4504)
,p_name=>'P1100_SCRIPT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4213236648802764201.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213238093096764215.4504)
,p_name=>'P1100_RAW_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4213237222183764207.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213240908381764244.4504)
,p_name=>'P1100_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4213236648802764201.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'US_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213511259383243927.4504)
,p_name=>'P1100_MODEL_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4213236648802764201.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4227543364252913707.4504)
,p_name=>'Initialize Editor'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4227543463286913708.4504)
,p_event_id=>wwv_flow_api.id(4227543364252913707.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var btn$ = apex.item(''saveModel_btn'');',
'',
'QuickSQL = new apex.quickSql({',
'    onInputEditorInitialized: function(editor){',
'',
'        if ( $v("P1100_RAW_SQL").length ) {',
'            QuickSQL.generate();',
'        }',
'',
'        editor.onDidChangeModelContent(function(){',
'            if(editor.getValue().trim() === ""){',
'                btn$.disable();',
'            } else {',
'                btn$.enable();',
'            }',
'        })',
'    }',
'});'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213238359191764218.4504)
,p_name=>'Generate SQL on Button Click'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4213237005118764205.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213238440854764219.4504)
,p_event_id=>wwv_flow_api.id(4213238359191764218.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.hidePageSuccess();',
'QuickSQL.generate();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213238551745764220.4504)
,p_name=>'Download File'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4213237886610764213.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213238644578764221.4504)
,p_event_id=>wwv_flow_api.id(4213238551745764220.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'QuickSQL.download();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213510882703243923.4504)
,p_name=>'Settings Updated'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4213237954091764214.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213510988860243924.4504)
,p_event_id=>wwv_flow_api.id(4213510882703243923.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.showPageSuccess(this.data.successMessage.text);',
'QuickSQL.clearOutput().generate( true );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213511046988243925.4504)
,p_name=>'Load Model'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4213237625352764211.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213511179879243926.4504)
,p_event_id=>wwv_flow_api.id(4213511046988243925.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_MODEL_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P1103_MODEL_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213512378722243938.4504)
,p_event_id=>wwv_flow_api.id(4213511046988243925.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_RAW_SQL'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_model clob;',
'begin',
'    for l_quick_sql in (',
'        select quick_sql model',
'        into l_model',
'        from wwv_qs_models ',
'        where id = :P1100_MODEL_ID )',
'    loop',
'        l_model := l_quick_sql.model;',
'    end loop;',
'    ',
'    if l_model is null then',
'        for l_quick_sql in (',
'            select model',
'            from wwv_qs_saved_models ',
'            where id = :P1100_MODEL_ID )',
'        loop',
'            l_model := l_quick_sql.model;',
'        end loop;',
'    end if;',
'    ',
'    return l_model;',
'end;'))
,p_attribute_07=>'P1100_MODEL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213512436337243939.4504)
,p_event_id=>wwv_flow_api.id(4213511046988243925.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( QuickSQL.inputEditor$ ).codeEditor( ''setValue'', $v(''P1100_RAW_SQL'' ) );',
'QuickSQL.generate();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234029578097714211.4504)
,p_name=>'Load Model from Help'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4213237751589764212.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234029627917714212.4504)
,p_event_id=>wwv_flow_api.id(234029578097714211.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_MODEL_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P1102_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234029751802714213.4504)
,p_event_id=>wwv_flow_api.id(234029578097714211.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_RAW_SQL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>'select QUICK_SQL from wwv_qs_models where id = :P1100_MODEL_ID'
,p_attribute_07=>'P1100_MODEL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234029866406714214.4504)
,p_event_id=>wwv_flow_api.id(234029578097714211.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( QuickSQL.inputEditor$ ).codeEditor( ''setValue'', $v( ''P1100_RAW_SQL'' ) );',
'QuickSQL.generate();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213512583487243940.4504)
,p_name=>'Script Saved'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4213241085471764245.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213512788365243942.4504)
,p_event_id=>wwv_flow_api.id(4213512583487243940.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_SCRIPT_NAME'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P1104_SCRIPT_NAME'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213512603284243941.4504)
,p_event_id=>wwv_flow_api.id(4213512583487243940.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess(this.data.successMessage.text);'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4229299179126069801.4504)
,p_event_id=>wwv_flow_api.id(4213512583487243940.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4213512950070243944.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213513154944243946.4504)
,p_name=>'Enable Run'
,p_event_sequence=>100
,p_condition_element=>'P1100_SCRIPT_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213513253945243947.4504)
,p_event_id=>wwv_flow_api.id(4213513154944243946.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4213512950070243944.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4227543096922913704.4504)
,p_name=>'Toggle Download Button'
,p_event_sequence=>110
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#quicksql_output'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'QuickSQL.hasContent()'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4227543105787913705.4504)
,p_event_id=>wwv_flow_api.id(4227543096922913704.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4213237886610764213.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4227543283725913706.4504)
,p_event_id=>wwv_flow_api.id(4227543096922913704.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(4213237886610764213.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(160975260602355734.4504)
,p_name=>'Model Saved'
,p_event_sequence=>140
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(109719613560401739.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(160975343161355735.4504)
,p_event_id=>wwv_flow_api.id(160975260602355734.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess(this.data.successMessage.text);'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(185275617932967008.4504)
,p_name=>'set Quick SQL syntax in session state'
,p_event_sequence=>150
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(109719613560401739.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(185275705063967009.4504)
,p_event_id=>wwv_flow_api.id(185275617932967008.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P1100_RAW_SQL'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(616813559675762810.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add Text Messages To Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<script>'');',
'',
'wwv_flow_json.initialize_clob_output;',
'wwv_flow_json.open_object;',
'for text_msg in (',
'    select name',
'      from wwv_flow_messages$',
'     where flow_id = 4411',
'       and name like ''QUICKSQL.HELP.%''',
') loop',
'    wwv_flow_json.write(text_msg.name, wwv_flow_lang.system_message(p_name => text_msg.name));',
'end loop;',
'wwv_flow_json.close_object;',
'',
'sys.htp.p(''apex.lang.addMessages('' || wwv_flow_json.get_clob_output(p_free => true) || '');'');',
'sys.htp.p(''</script>'');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4032943218417342948.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'runScript'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_script_id     number;',
'    l_script_name   varchar2(4000);',
'    --',
'    l_message       varchar2(32767);',
'    l_qs_script_id  varchar2(255);',
'    c               integer := 0;',
'    l_audit_cols    varchar2(1) := ''N'';',
'    l_row_version   varchar2(1) := ''N'';',
'    l_row_key       varchar2(1) := ''N'';',
'    l_tenant_id     varchar2(1) := ''N'';',
'begin',
'    -- geneate SQL',
'    begin',
'    if instr (:P1101_ADTL_COLS,''AUDIT_COLS'') > 0 then l_audit_cols := ''Y'';   end if;',
'    if instr (:P1101_ADTL_COLS,''ROW_VERSION'') > 0 then l_row_version := ''Y''; end if;',
'    if instr (:P1101_ADTL_COLS,''ROW_KEY'') > 0 then l_row_key := ''Y'';         end if;',
'    if instr (:P1101_ADTL_COLS,''TENANT_ID'') > 0 then l_tenant_id := ''Y'';     end if;',
'    ',
'    wwv_qs_design_schema_pub.add_tables (',
'        P_TABLE_PREFIX       => :P1101_TABLE_PREFIX,',
'        P_DATE_DATATYPE      => NVL(:P1101_DATE_DATATYPE,''DATE''), ',
'        P_INC_AUDITING       => l_audit_cols,',
'        P_TABLES             => :P1100_RAW_SQL,',
'        P_PRIMARY_KEY        => ''ID'',',
'        P_ROW_VERSION        => l_row_version,',
'        P_ROW_KEY            => l_row_key,',
'        p_tenant_id          => l_tenant_id,',
'        p_compressed         => NVL(:P1101_COMPRESSED,''N''),',
'        p_LONGER_IDENTIFIERS => ''N'',',
'        p_AUTO_GEN_PK        => NVL(:P1101_AUTO_GEN_PK,''N''),',
'        p_apis               => NVL(:P1101_API,''N''),',
'        p_longer_varchars_yn => NVL(:P1101_LONGER_VARCHARS,''N''),',
'        p_schema             => :P1101_SCHEMA,',
'        p_inserts            => 0,   -- depricate l_inserts',
'        p_selects            => ''N'', -- depricate l_selects',
'        p_uncomment          => null,',
'        p_tags_fw_yn         => NVL(:P1101_TAGS_FW,''N''),',
'        p_semantics          => :P1101_SEMANTICS );',
'        ',
'    wwv_qs_design_schema_pub.g_gen_mode := ''CLOB'';',
'    ',
'    wwv_qs_design_schema_pub.save_as_sql (',
'        P_APP_USER           => :APP_USER,',
'        P_APP_SESSION        => :APP_SESSION,',
'        P_TRIGGER_METHOD     => NVL(:P1101_TRIGGER_METHOD,''TRIG''),',
'        P_FK                 => NVL(:P1101_ON_DELETE,''RESTRICT''),',
'        P_ROW_VERSION        => l_row_version,',
'        P_ROW_KEY            => l_row_key,',
'        p_tenant_id          => l_tenant_id,',
'        p_compressed         => NVL(:P1101_COMPRESSED,''N''),',
'        P_TABLE_PREFIX       => NVL(:P1101_TABLE_PREFIX,''''),',
'        p_include_drops      => NVL(:P1101_INCLUDE_DROPS,''N''),',
'        p_db_version         => coalesce( :P1101_DB_VERSION, wwv_qs_design_schema_pub.get_default_db_version ), ',
'        p_LONGER_IDENTIFIERS => ''N'',',
'        p_apis               => NVL(:P1101_API,''N''),',
'        p_message            => l_message,',
'        P_SCRIPT_ID          => l_qs_script_id,',
'        p_AUTO_GEN_PK        => NVL(:P1101_AUTO_GEN_PK,''N''),',
'        p_audit_cols         => l_audit_cols,',
'        p_DATE_DATATYPE      => NVL(:P1101_DATE_DATATYPE,''DATE''),',
'        p_editionable        => NVL(:P1101_EDITIONABLE,''N''),',
'        p_language           => NVL(:P1101_LANGUAGE,''EN''),',
'        p_apex               => NVL(:P1101_APEX,''N''),',
'        --',
'        P_PREFIX_PK_WITH_TNAME   => NVL(:P1101_PREFIX_PK_WITH_TNAME,    ''N''),',
'        P_CREATED_COLUMN_NAME    => NVL(:P1101_CREATED_COLUMN_NAME,     ''created''),',
'        P_CREATED_BY_COLUMN_NAME => NVL(:P1101_CREATED_BY_COLUMN_NAME,  ''created_by''),',
'        P_UPDATED_COLUMN_NAME    => NVL(:P1101_UPDATED_COLUMN_NAME,     ''updated''),',
'        P_UPDATED_BY_COLUMN_NAME => NVL(:P1101_UPDATED_BY_COLUMN_NAME,  ''updated_by''),',
'        --',
'        p_longer_varchars_yn => NVL(:P1101_LONGER_VARCHARS,''N''),',
'        p_schema             => :P1101_SCHEMA,',
'        p_inserts            => 0, -- depricate l_inserts',
'        p_selects            => ''N'', -- depricate l_selects',
'        p_uncomment          => null, -- depricate',
'        p_tags_fw_yn         => NVL(:P1101_TAGS_FW,''N''),',
'        p_semantics          => :P1101_SEMANTICS );',
'    exception when others then ',
'         l_message := sqlerrm;',
'    end;',
'    ',
'    -- save SQL ',
'    l_script_name := :P1100_SCRIPT_NAME;',
'    ',
'    for l_script in (',
'        select id',
'        from wwv_flow_files f, wwv_flow_fnd_user u',
'        where u.security_group_id = :flow_security_group_id',
'        and u.user_name = :APP_USER',
'        and f.filename = l_script_name',
'        and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'               or exists ( select 1',
'                             from  wwv_flow_developers',
'                            where security_group_id = :flow_security_group_id',
'                              and userid = :APP_USER',
'                              and instr(developer_role||'':'',''ADMIN:'') > 0',
'                            union',
'                           select 1',
'                             from wwv_flow_fnd_user',
'                            where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                              and user_name = :APP_USER',
'                              and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER''))) )',
'    loop',
'        l_script_id := l_script.id;',
'    end loop;',
'    ',
'    if l_script_id is null then',
'        wwv_flow_sw_script.create_script_from_clob (        ',
'             p_script_name => l_script_name,',
'             p_script      => wwv_qs_design_schema_pub.g_clob );',
'    else',
'        wwv_flow_sw_script.update_script_file (',
'             p_file_id     => l_script_id,',
'             p_script_name => l_script_name,',
'             p_script      => wwv_qs_design_schema_pub.g_clob );',
'    end if;',
'    ',
'    :P1100_SCRIPT_ID := l_script_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4213396239246364009.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1101_TABLE_PREFIX      := null;',
':P1101_SCHEMA            := null;',
':P1101_ON_DELETE         := ''CASCADE'';',
':P1101_COMPRESSED        := ''N'';',
':P1101_GENERATE_INSERTS  := ''Y'';',
'',
'if sys.dbms_db_version.version >= 12 then',
'    :P1101_TRIGGER_METHOD := ''IDENTITY'';',
'else',
'    :P1101_TRIGGER_METHOD := ''GUID'';',
'end if;',
':P1101_DATE_DATATYPE     := ''DATE'';',
':P1101_SEMANTICS         := ''CHAR'';',
':P1101_ADTL_COLS         := null;',
':P1101_LANGUAGE          := ''EN'';',
':P1101_API               := ''N'';',
':P1101_INCLUDE_DROPS     := ''N'';',
':P1101_AUTO_GEN_PK       := ''Y'';',
':P1101_LONGER_VARCHARS   := ''N'';',
':P1101_EDITIONABLE       := ''N'';',
':P1101_APEX              := ''Y'';',
':P1101_TAGS_FW           := ''N'';',
':P1101_DB_VERSION        := wwv_qs_design_schema_pub.get_default_db_version;',
':P1101_PREFIX_PK_WITH_TNAME   := ''N'';',
':P1101_CREATED_COLUMN_NAME    := ''created'';',
':P1101_CREATED_BY_COLUMN_NAME := ''created_by'';',
':P1101_UPDATED_COLUMN_NAME    := ''updated'';',
':P1101_UPDATED_BY_COLUMN_NAME := ''updated_by'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4213355838454734992.4504)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'format_sql'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_message            varchar2(32767);',
'   l_qs_script_id       varchar2(255);',
'   c                    integer := 0;',
'   l_audit_cols         varchar2(1) := ''N'';',
'   l_row_version        varchar2(1) := ''N'';',
'   l_row_key            varchar2(1) := ''N'';',
'   l_tenant_id          varchar2(1) := ''N'';',
'begin',
'  if instr (:P1101_ADTL_COLS,''AUDIT_COLS'') > 0 then l_audit_cols := ''Y'';   end if;',
'  if instr (:P1101_ADTL_COLS,''ROW_VERSION'') > 0 then l_row_version := ''Y''; end if;',
'  if instr (:P1101_ADTL_COLS,''ROW_KEY'') > 0 then l_row_key := ''Y'';         end if;',
'  if instr (:P1101_ADTL_COLS,''TENANT_ID'') > 0 then l_tenant_id := ''Y'';     end if;',
'    ',
'  begin',
'  wwv_qs_design_schema_pub.add_tables (',
'       P_TABLE_PREFIX       => :P1101_TABLE_PREFIX,',
'       P_DATE_DATATYPE      => NVL(:P1101_DATE_DATATYPE,''DATE''), ',
'       P_INC_AUDITING       => l_audit_cols,',
'       P_TABLES             => :P1100_RAW_SQL,',
'       P_PRIMARY_KEY        => ''ID'',',
'       P_ROW_VERSION        => l_row_version,',
'       P_ROW_KEY            => l_row_key,',
'       p_tenant_id          => l_tenant_id,',
'       p_compressed         => NVL(:P1101_COMPRESSED,''N''),',
'       p_LONGER_IDENTIFIERS => ''N'',',
'       p_AUTO_GEN_PK        => NVL(:P1101_AUTO_GEN_PK,''N''),',
'       p_apis               => NVL(:P1101_API,''N''),',
'       p_longer_varchars_yn => NVL(:P1101_LONGER_VARCHARS,''N''),',
'       p_schema             => :P1101_SCHEMA,',
'       p_inserts            => 0,   -- depricate l_inserts',
'       p_selects            => ''N'', -- depricate l_selects',
'       p_uncomment          => null,',
'       p_tags_fw_yn         => NVL(:P1101_TAGS_FW,''N''),',
'       p_semantics          => :P1101_SEMANTICS );',
'   exception when others then',
'       htp.p(''add_tables: ''||sqlerrm);',
'   end;',
'    ',
'  --sys.htp.init;',
'  sys.owa_util.mime_header(''text/plain'', true );',
'  sys.htp.prn(''<div id="sql_output">'');',
'  sys.htp.prn(''<div id="formatted_sql_output">'');',
' ',
'  begin',
'   if NVL(:P1101_GENERATE_INSERTS,''Y'') = ''Y'' then',
'       wwv_qs_design_schema_pub.g_enable_inserts := true;',
'   else',
'       wwv_qs_design_schema_pub.g_enable_inserts := false;',
'   end if;',
'   wwv_qs_design_schema_pub.g_gen_mode := ''HTP'';',
'   wwv_qs_design_schema_pub.save_as_sql (',
'       P_APP_USER           => :APP_USER,',
'       P_APP_SESSION        => :APP_SESSION,',
'       P_TRIGGER_METHOD     => NVL(:P1101_TRIGGER_METHOD,''GUID''),',
'       P_FK                 => NVL(:P1101_ON_DELETE,''RESTRICT''),',
'       P_ROW_VERSION        => l_row_version,',
'       P_ROW_KEY            => l_row_key,',
'       p_tenant_id          => l_tenant_id,',
'       p_compressed         => NVL(:P1101_COMPRESSED,''N''),',
'       P_TABLE_PREFIX       => NVL(:P1101_TABLE_PREFIX,''''),',
'       p_include_drops      => NVL(:P1101_INCLUDE_DROPS,''N''),',
'       p_db_version         => coalesce( :P1101_DB_VERSION, wwv_qs_design_schema_pub.get_default_db_version ), ',
'       p_LONGER_IDENTIFIERS => ''N'',',
'       p_apis               => NVL(:P1101_API,''N''),',
'       p_message            => l_message,',
'       P_SCRIPT_ID          => l_qs_script_id,',
'       p_AUTO_GEN_PK        => NVL(:P1101_AUTO_GEN_PK,''N''),',
'       p_audit_cols         => l_audit_cols,',
'       p_DATE_DATATYPE      => NVL(:P1101_DATE_DATATYPE,''DATE''),',
'       p_editionable        => NVL(:P1101_EDITIONABLE,''N''),',
'       p_language           => NVL(:P1101_LANGUAGE,''EN''),',
'       p_apex               => NVL(:P1101_APEX,''N''),',
'       --',
'       P_PREFIX_PK_WITH_TNAME   => NVL(:P1101_PREFIX_PK_WITH_TNAME,    ''N''),',
'       P_CREATED_COLUMN_NAME    => NVL(:P1101_CREATED_COLUMN_NAME,     ''created''),',
'       P_CREATED_BY_COLUMN_NAME => NVL(:P1101_CREATED_BY_COLUMN_NAME,  ''created_by''),',
'       P_UPDATED_COLUMN_NAME    => NVL(:P1101_UPDATED_COLUMN_NAME,     ''updated''),',
'       P_UPDATED_BY_COLUMN_NAME => NVL(:P1101_UPDATED_BY_COLUMN_NAME,  ''updated_by''),',
'       --',
'       p_longer_varchars_yn => NVL(:P1101_LONGER_VARCHARS,''N''),',
'       p_schema             => :P1101_SCHEMA,',
'       p_inserts            => 0, -- depricate l_inserts',
'       p_selects            => ''N'', -- depricate l_selects',
'       p_uncomment          => null, -- depricate',
'       p_tags_fw_yn         => NVL(:P1101_TAGS_FW,''N''),',
'       p_semantics          => :P1101_SEMANTICS',
'   );',
'   exception when others then',
'       sys.htp.p(''save_as_sql: ''||sqlerrm);',
'   end;',
'   ',
'   wwv_qs_design_schema_pub.print_settings(p_text=>:P1100_RAW_SQL);',
'   ',
'   sys.htp.prn(''</div>'');',
'   sys.htp.prn(''<div id="sql_sequence">'');',
'   -- :key := NVL(:KEY,0) + 1;',
'   ',
'   c := 0;',
'   -- for c1 in (select id from wwv_qs_saved_models where identifier = :MODEL_KEY and created_by = :APP_USER) loop',
'   --     c := c + 1;',
'   --     sys.htp.prn('' <a href="''||apex_page.get_url(p_page => 1100, p_request => ''MODEL''||to_char(c1.id))||''">''||apex_escape.html(:MODEL_NAME)||''.''||:KEY||''</a>'');',
'   -- end loop;',
'   -- if c = 0 then',
'   --   sys.htp.prn(:MODEL_NAME||''.''||:KEY);',
'   -- end if;',
'   ',
'   sys.htp.prn(''</div></div>'');',
'  ',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
null;
end;
/
prompt --application/pages/page_01101
begin
wwv_flow_api.create_page(
 p_id=>1101.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Impostazioni'
,p_page_mode=>'MODAL'
,p_step_title=>'Impostazioni'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213238967558764224.4504)
,p_plug_name=>'Tabella'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213239074761764225.4504)
,p_plug_name=>'Colonna'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213239169987764226.4504)
,p_plug_name=>'Colonne aggiuntive'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_plug_name=>'Opzioni'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213239316838764228.4504)
,p_plug_name=>'Preferenze'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213240264228764237.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213240448767764239.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4213240264228764237.4504)
,p_button_name=>'RESET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213240387572764238.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4213240264228764237.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva modifiche'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213240521142764240.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4213240264228764237.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4211581002465736742.4504)
,p_name=>'P1101_ADTL_COLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4213239169987764226.4504)
,p_item_default=>'return NVL(:P1101_ADTL_COLS,'''');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Includi'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P1101_AUDIT_COL_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(561151526618018480.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4211581136224736743.4504)
,p_name=>'P1101_LANGUAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'return NVL(:P1101_LANGUAGE,''EN'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Lingua dati'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'QUICKSQL_DATA_LANG'
,p_lov=>'.'||wwv_flow_api.id(397206437082468486.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Controllare il linguaggio utilizzato per la generazione dei dati tramite il flag /INSERT.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4211581252875736744.4504)
,p_name=>'P1101_API'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'return NVL(:P1101_API,''N'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'PL/SQL API'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando l''impostazione \00E8 <strong>Attivo</strong>, questa applicazione genera un''interfaccia API PL/SQL con un package per tabella in tutte le tabelle.'),
unistr('Quando l''impostazione \00E8 <strong>Non attivo</strong>, questa applicazione genera le interfacce API PL/SQL solo per le tabelle che includono <strong>/api</strong> alla fine del nome. Ad esempio:'),
'<pre>',
'employees /api',
'   name',
'   email',
'   phone num',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4211581316983736745.4504)
,p_name=>'P1101_INCLUDE_DROPS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'return NVL(:P1101_INCLUDE_DROPS,''N'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Includi eliminazioni'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Includere i comandi di eliminazione degli oggetti nell''output. Quando l''impostazione \00E8 <strong>Attivo</strong>, viene generato un comando di eliminazione (drop) per ogni oggetto di database creato. Ad esempio:'),
'<pre>',
'drop table X including contents;',
'drop table Y including contents;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4211581592238736747.4504)
,p_name=>'P1101_AUTO_GEN_PK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'return NVL(:P1101_AUTO_GEN_PK,''Y'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chiave primaria automatica'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quando l''impostazione \00E8 <strong>Attivo</strong>, le colonne di chiave primaria vengono generate in modo automatico per le tabelle. Il nome della colonna di chiave primaria sar\00E0 <strong>ID</strong> e sar\00E0 del tipo <strong>numerico</strong>. Ad esem')
||'pio:</p>',
'<pre>',
'employees',
'    name',
'    email',
'    phone num',
'</pre>',
'<p>',
'   La sintassi abbreviata di tabella precedente genera l''istruzione di creazione tabella seguente:',
'</p>',
'<pre>',
'create table EMPLOYEES (',
'    ID                             NUMBER GENERATED BY DEFAULT ON NULL AS IDENTITY primary key,',
'    NAME                           VARCHAR2(255),',
'    EMAIL                          VARCHAR2(255),',
'    PHONE                          NUMBER',
')',
';',
'</pre>',
'<p>',
unistr('    Tenere presente che il metodo di inserimento della chiave primaria \00E8 un''opzione. Nell''esempio precedente viene utilizzata la clausola IDENTITY del database 12c, ma l''utente pu\00F2 scegliere di inserire la chiave primaria da un trigger di database.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4211581680215736748.4504)
,p_name=>'P1101_DB_VERSION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'wwv_qs_design_schema_pub.get_default_db_version'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Compatibilit\00E0')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1101_DB_VERSION'
,p_lov=>'.'||wwv_flow_api.id(561159215572120923.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Assicura che il codice SQL generato sia compatibile con la release di database selezionata.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4211581777611736749.4504)
,p_name=>'P1101_LONGER_VARCHARS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'return NVL(:P1101_LONGER_VARCHARS,''N'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Varchar pi\00F9 lunghi')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('I Varchar pi\00F9 lunghi sono una nuova funzione del database 12.1 che consente di disporre di colonne con dimensioni massime fino a 32 KB. Se si desidera utilizzare la funzione, assicurarsi che il database in uso sia configurato per supportare i Varchar')
||unistr(' pi\00F9 lunghi.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4211581865073736750.4504)
,p_name=>'P1101_EDITIONABLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'return NVL(:P1101_EDITIONABLE,''N'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Abilitazione edizioni possibile'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Durante la fase di generazione, gli oggetti PL/SQL che includono trigger e package rendono possibile l''abilitazione di edizioni per tali elementi.  '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213239484201764229.4504)
,p_name=>'P1101_TABLE_PREFIX'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4213238967558764224.4504)
,p_item_default=>'return NVL(:P1101_TABLE_PREFIX,'''');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Prefisso oggetti'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggiunge questo valore come prefisso a tutti i nomi oggetto.',
''))
,p_inline_help_text=>'Aggiunge questo valore come prefisso a tutti i nomi oggetto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213239526879764230.4504)
,p_name=>'P1101_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4213238967558764224.4504)
,p_item_default=>'return NVL(:P1101_SCHEMA,'''');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggiungi nome schema come prefisso ai nomi oggetto',
''))
,p_inline_help_text=>'Aggiungi nome schema come prefisso ai nomi oggetto'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213239617519764231.4504)
,p_name=>'P1101_ON_DELETE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4213238967558764224.4504)
,p_item_default=>'return NVL(:P1101_ON_DELETE,''CASCADE'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Su eliminazione'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1101_ON_DELETE'
,p_lov=>'.'||wwv_flow_api.id(561149224457990543.4504)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    ',
'Specificare il funzionamento predefinito desiderato per le chiavi esterne all''eliminazione della riga padre.</p>',
'',
'<p>',
'    Chiave esterna con "Imposta su null se eliminato": se si elimina un record nella tabella padre, i campi della chiave esterna nei record corrispondenti nella tabella figlio verranno impostati su un valore nullo. ',
'</p>',
'',
'<p>',
unistr('    Chiave esterna con "In caso di eliminazione a catena": la riga figlio verr\00E0 eliminata in modo automatico quando si elimina la riga padre corrispondente.'),
'</p>',
'',
'<P>',
unistr('    Chiave esterna con "Impedisci eliminazione": l''eliminazione della riga padre verr\00E0 impedita se esiste una riga figlio.'),
'</P>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213239709227764232.4504)
,p_name=>'P1101_COMPRESSED'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4213238967558764224.4504)
,p_item_default=>'return NVL(:P1101_COMPRESSED,''N'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Compressione'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specificare se si desidera che le tabelle vengano compresse oppure no.',
'</p>',
'<p>',
unistr('   La compressione delle tabelle consente di risparmiare spazio su disco e di ridurre l''uso della memoria nella buffer cache. La compressione delle tabelle pu\00F2 inoltre rendere pi\00F9 veloce l''esecuzione delle query durante le operazioni di lettura. Esis')
||unistr('te tuttavia un costo in termini di sovraccarico della CPU per il caricamento dei dati e il linguaggio DML. La compressione delle tabelle \00E8 completamente trasparente per le applicazioni. Si rivela particolarmente utile nei sistemi di elaborazione anal')
||unistr('itica in linea (OLAP), in cui esistono operazioni di sola lettura che richiedono tempo, ma pu\00F2 essere utilizzata anche nei sistemi di elaborazione delle transazioni in linea (OLTP).</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213239809630764233.4504)
,p_name=>'P1101_TRIGGER_METHOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4213239074761764225.4504)
,p_prompt=>'Chiavi primarie'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1101_TRIGGER_METHOD'
,p_lov=>'.'||wwv_flow_api.id(561153525630044678.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Questo attributo definisce le modalit\00E0 di popolamento delle chiavi primarie di tabella. Sono disponibili le opzioni riportate di seguito.'),
'</p>',
'<ul>',
unistr('    <li><strong>SYS_GUID:</strong> questo metodo consente di popolare la chiave primaria con un identificativo univoco a livello globale. Genera un valore numerico casuale non sequenziale e di lunghezza non uniforme. Questo metodo \00E8 utile perch\00E9 pu\00F2 ')
||unistr('essere pi\00F9 sicuro e consente inoltre di unire i dati di database diversi senza temere conflitti di chiavi primarie.</li>'),
unistr('    <li><strong>Colonna identit\00E0:</strong> imposta la chiave primaria per impostazione predefinita in base a un numero che aumenta continuamente.</li>'),
unistr('    <li><strong>Sequenza:</strong> questo metodo incrementer\00E0 la chiave primaria usando una sequenza numerica. Questo popolamento della chiave primaria viene implementato tramite un trigger di database.</li>'),
'</ul>'))
,p_inline_help_text=>'Metodo di inserimento dati colonna chiave primaria'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213239938816764234.4504)
,p_name=>'P1101_DATE_DATATYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4213239074761764225.4504)
,p_item_default=>'return NVL(:P1101_DATE_DATATYPE,''DATE'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tipo di dati data'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1101_DATE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(561155009716075756.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Definisce il tipo di data da usare per la memorizzazione delle colonne identificate come date. Sono disponibili le opzioni seguenti:',
'<ul>',
'<li>Data</li>',
'<li>Indicatore orario</li>',
'<li>Indicatore orario con fuso orario locale</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213240026535764235.4504)
,p_name=>'P1101_SEMANTICS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4213239074761764225.4504)
,p_item_default=>'return NVL(:P1101_SEMANTICS,''CHAR'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Semantica'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1101_LENGTH_SEMANTICS'
,p_lov=>'.'||wwv_flow_api.id(561157497023099105.4504)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('CHAR indica che la semantica della colonna sar\00E0 del tipo carattere. BYTE indica che la semantica della colonna sar\00E0 del tipo lunghezza in byte. Se si sceglie "Valore predefinito" verr\00E0 utilizzata l''impostazione del database. Se non si \00E8 sicuri, scegl')
||'iere "Valore predefinito".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213395487977364001.4504)
,p_name=>'P1101_APEX'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'return NVL(:P1101_APEX,''Y'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Abilitato per APEX'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213395519786364002.4504)
,p_name=>'P1101_TAGS_FW'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(4213239246459764227.4504)
,p_item_default=>'return NVL(:P1101_TAGS_FW,''N'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Framework tag'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213395649583364003.4504)
,p_name=>'P1101_PREFIX_PK_WITH_TNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4213239316838764228.4504)
,p_item_default=>'return NVL(:P1101_PREFIX_PK_WITH_TNAME,    ''N'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Aggiungi nome tabella come prefisso alle chiavi primarie'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213395708955364004.4504)
,p_name=>'P1101_CREATED_COLUMN_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4213239316838764228.4504)
,p_prompt=>'Nome colonna Data creazione'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'Durante la fase di generazione, le colonne di audit controllano il nome della colonna di audit.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213395805560364005.4504)
,p_name=>'P1101_CREATED_BY_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4213239316838764228.4504)
,p_prompt=>'Nome colonna Creazione di'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'Durante la fase di generazione, le colonne di audit controllano il nome della colonna di audit.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213395919520364006.4504)
,p_name=>'P1101_UPDATED_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4213239316838764228.4504)
,p_prompt=>'Nome colonna Data aggiornamento'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'Durante la fase di generazione, le colonne di audit controllano il nome della colonna di audit.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213396097010364007.4504)
,p_name=>'P1101_UPDATED_BY_COLUMN_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4213239316838764228.4504)
,p_prompt=>'Nome colonna Autore aggiornamento'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'Durante la fase di generazione, le colonne di audit controllano il nome della colonna di audit.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213396158971364008.4504)
,p_name=>'P1101_GENERATE_INSERTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4213238967558764224.4504)
,p_item_default=>'return NVL(:P1101_GENERATE_INSERTS,''Y'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Genera inserimenti'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('La generazione degli inserimenti pu\00F2 richiedere molto tempo e influire negativamente sull''usabilit\00E0. Si consiglia di disattivare la generazione degli inserimenti quando si ottimizza il modello dati e di riattivarla quando si \00E8 pronti a generare i dat')
||'i.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213240640984764241.4504)
,p_name=>'Cancel Button'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4213240521142764240.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213240776604764242.4504)
,p_event_id=>wwv_flow_api.id(4213240640984764241.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4213466897943559802.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Impostazioni salvate'
);
end;
/
prompt --application/pages/page_01102
begin
wwv_flow_api.create_page(
 p_id=>1102.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Guida di Quick SQL'
,p_page_mode=>'MODAL'
,p_step_title=>'Guida'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Dialog--wizard .a-Dialog-body { padding: 12px; }',
'.a-Region-header { padding: 0; }',
'.a-Region .a-Region-title { font-weight: 500; font-size: 16px; }',
'.about-region h3 { font-size: 14px; line-height: 20px; margin-bottom: 8px; color: #707070; font-weight: bold; }',
'.about-region p, .about-region ul { font-size: 14px; line-height: 20px; color: #404040; }',
'.about-region ul { margin: 0 12px 0 32px; }',
'.about-region p { margin-bottom: 16px; }'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176251420272916914.4504)
,p_plug_name=>'Tipi di dati'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'sys.htp.p(wwv_qs_design_schema_pub.get_column_datatypes);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213508697531243901.4504)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213508778625243902.4504)
,p_plug_name=>'Informazioni'
,p_region_css_classes=>'about-region'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(wwv_qs_design_schema_pub.get_about);  ',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213508882269243903.4504)
,p_plug_name=>'Direttive di tabella'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'sys.htp.p(wwv_qs_design_schema_pub.get_table_directives);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213508913789243904.4504)
,p_plug_name=>'Direttive di colonna'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'sys.htp.p(wwv_qs_design_schema_pub.get_column_directives);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213509032311243905.4504)
,p_plug_name=>'Viste'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'sys.htp.p(wwv_qs_design_schema_pub.get_view_syntax);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213509121351243906.4504)
,p_plug_name=>'Impostazioni'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'sys.htp.p(wwv_qs_design_schema_pub.get_pound_options);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4502341925178775194.4504)
,p_name=>'Esempi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       wwv_flow_lang_dev.builder_message(name) name,',
'       wwv_flow_lang_dev.builder_message(description) description,',
'       created,',
'       lower(created_by) created_by,',
'       updated,',
'       lower(updated_by) updated_by,',
'       null run_model',
'from WWV_QS_MODELS',
'where published_yn = ''Y''',
'order by name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Nessun modello di esempio'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(288832971898531288.4504)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(288833320886531290.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>#NAME#</strong><br>',
'#DESCRIPTION#'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(288833712302531290.4504)
,p_query_column_id=>3
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(288834182073531291.4504)
,p_query_column_id=>4
,p_column_alias=>'CREATED'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(288834522632531291.4504)
,p_query_column_id=>5
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(288834905665531291.4504)
,p_query_column_id=>6
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(288835389467531292.4504)
,p_query_column_id=>7
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(288835747558531292.4504)
,p_query_column_id=>8
,p_column_alias=>'RUN_MODEL'
,p_column_display_sequence=>8
,p_column_heading=>'Esegui modello'
,p_column_link=>'#'
,p_column_linktext=>'Carica modello'
,p_column_link_attr=>'class="a-Button a-Button--small js-loadModel" data-id="#ID#"'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(288836128723531292.4504)
,p_name=>'P1102_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4502341925178775194.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(288836741204534631.4504)
,p_name=>'Load Model'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.js-loadModel'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(288837167967534632.4504)
,p_event_id=>wwv_flow_api.id(288836741204534631.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1102_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(288837628495534632.4504)
,p_event_id=>wwv_flow_api.id(288836741204534631.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'LOAD_MODEL'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(288838543080543084.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P1102_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01103
begin
wwv_flow_api.create_page(
 p_id=>1103.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica'
,p_page_mode=>'MODAL'
,p_step_title=>'Carica'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109720083786401743.4504)
,p_plug_name=>'Schede'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164965429122482309.4504)
,p_plug_name=>'Cerca'
,p_parent_plug_id=>wwv_flow_api.id(109720083786401743.4504)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164965644813482311.4504)
,p_plug_name=>'Salvato'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>100
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(109720158381401744.4504)
,p_name=>'Modelli personali'
,p_parent_plug_id=>wwv_flow_api.id(164965644813482311.4504)
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       coalesce( description, sys.dbms_lob.substr(model,300,1)) description,',
'       wwv_flow_page_api.get_url(',
'           p_application => :APP_ID,',
'           p_page        => 1107,',
'           p_session     => :APP_SESSION,',
'           p_clear_cache => 1107,',
'           p_items       => ''P1107_ID'',',
'           p_values      => id ) target_url,',
'       htmldb_util.get_since(created) created,',
'       lower(created_by) created_by,',
'       htmldb_util.get_since(updated) updated,',
'       lower(updated_by) updated_by,',
'       null run_model',
'from wwv_qs_saved_models',
'where created_by = :APP_USER',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and ( :P1103_SEARCH is null or',
'      instr( upper(name), upper(:P1103_SEARCH) ) > 0 or',
'      instr( upper(created_by), upper(:P1103_SEARCH) ) > 0 )',
'order by name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Nessun modello salvato'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109720363423401746.4504)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109720421448401747.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong><a href="#TARGET_URL#">#NAME#</a></strong> ( #CREATED_BY#, #CREATED# )<br />',
'#DESCRIPTION#'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109720587335401748.4504)
,p_query_column_id=>3
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185275001696967002.4504)
,p_query_column_id=>4
,p_column_alias=>'TARGET_URL'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109720636207401749.4504)
,p_query_column_id=>5
,p_column_alias=>'CREATED'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109720735913401750.4504)
,p_query_column_id=>6
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160971966849355701.4504)
,p_query_column_id=>7
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160972065543355702.4504)
,p_query_column_id=>8
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160972158666355703.4504)
,p_query_column_id=>9
,p_column_alias=>'RUN_MODEL'
,p_column_display_sequence=>9
,p_column_heading=>'Carica modello'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'Carica modello'
,p_column_link_attr=>'class="a-Button a-Button--small js-loadModel" data-id="#ID#"'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(160976864824355750.4504)
,p_name=>'Modelli area di lavoro'
,p_parent_plug_id=>wwv_flow_api.id(164965644813482311.4504)
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       coalesce( description, sys.dbms_lob.substr(model,300,1)) description,',
'       wwv_flow_page_api.get_url(',
'           p_application => :APP_ID,',
'           p_page        => 1107,',
'           p_session     => :APP_SESSION,',
'           p_clear_cache => 1107,',
'           p_items       => ''P1107_ID'',',
'           p_values      => id ) target_url,',
'       htmldb_util.get_since(created) created,',
'       lower(created_by) created_by,',
'       htmldb_util.get_since(updated) updated,',
'       lower(updated_by) updated_by,',
'       null run_model',
'from wwv_qs_saved_models',
'where security_group_id = :FLOW_SECURITY_GROUP_ID',
'and ( :P1103_SEARCH is null or',
'      instr( upper(name), upper(:P1103_SEARCH) ) > 0 or',
'      instr( upper(created_by), upper(:P1103_SEARCH) ) > 0 )',
'order by name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Nessun modello salvato dell''area di lavoro'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164964650386482301.4504)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164964721158482302.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong><a href="#TARGET_URL#">#NAME#</a></strong> ( #CREATED_BY#, #CREATED# )<br />',
'#DESCRIPTION#'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164964882281482303.4504)
,p_query_column_id=>3
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164967644212482331.4504)
,p_query_column_id=>4
,p_column_alias=>'TARGET_URL'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164964953103482304.4504)
,p_query_column_id=>5
,p_column_alias=>'CREATED'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164965098845482305.4504)
,p_query_column_id=>6
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164965192342482306.4504)
,p_query_column_id=>7
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164965298423482307.4504)
,p_query_column_id=>8
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164965322324482308.4504)
,p_query_column_id=>9
,p_column_alias=>'RUN_MODEL'
,p_column_display_sequence=>9
,p_column_heading=>'Esegui modello'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'Carica modello'
,p_column_link_attr=>'class="a-Button a-Button--small js-loadModel" data-id="#ID#"'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4213509296976243907.4504)
,p_name=>'Esempi'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       wwv_flow_lang_dev.builder_message(name) name,',
'       wwv_flow_lang_dev.builder_message(description) description,',
'       created,',
'       lower(created_by) created_by,',
'       updated,',
'       lower(updated_by) updated_by,',
'       null run_model',
'from WWV_QS_MODELS',
'where published_yn = ''Y''',
'and ( :P1103_SEARCH is null or',
'      instr( upper(name), upper(:P1103_SEARCH) ) > 0 )',
'order by name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Nessun modello di esempio'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213509398794243908.4504)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213509422627243909.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>#NAME#</strong><br>',
'#DESCRIPTION#'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213509549091243910.4504)
,p_query_column_id=>3
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213509732781243912.4504)
,p_query_column_id=>4
,p_column_alias=>'CREATED'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213509825902243913.4504)
,p_query_column_id=>5
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213509924058243914.4504)
,p_query_column_id=>6
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213510004791243915.4504)
,p_query_column_id=>7
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213510248949243917.4504)
,p_query_column_id=>8
,p_column_alias=>'RUN_MODEL'
,p_column_display_sequence=>8
,p_column_heading=>'Esegui modello'
,p_column_link=>'#'
,p_column_linktext=>'Carica modello'
,p_column_link_attr=>'class="a-Button a-Button--small js-loadModel" data-id="#ID#"'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164965762657482312.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(164965429122482309.4504)
,p_button_name=>'FIND'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Trova'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164965582758482310.4504)
,p_name=>'P1103_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(164965429122482309.4504)
,p_prompt=>'Cerca'
,p_placeholder=>'Cerca per nome'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213510333631243918.4504)
,p_name=>'P1103_MODEL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(109720083786401743.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213510436840243919.4504)
,p_name=>'Load Model'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.js-loadModel'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213510594520243920.4504)
,p_event_id=>wwv_flow_api.id(4213510436840243919.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1103_MODEL_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213510619859243921.4504)
,p_event_id=>wwv_flow_api.id(4213510436840243919.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'LOAD_MODEL'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4213510729325243922.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P1103_MODEL_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'LOAD_MODEL'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_01104
begin
wwv_flow_api.create_page(
 p_id=>1104.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Salva script'
,p_page_mode=>'MODAL'
,p_step_title=>'Salva script'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
,p_dialog_height=>'320'
,p_dialog_width=>'480'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213511558797243930.4504)
,p_plug_name=>'Form'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4213511738452243932.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213511874005243933.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4213511738452243932.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva script'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4213511973236243934.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4213511738452243932.4504)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4213511627570243931.4504)
,p_name=>'P1104_SCRIPT_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4213511558797243930.4504)
,p_prompt=>'Nome script'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'US_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4032942963591342945.4504)
,p_validation_name=>'script exists replace'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_script in (',
'    select id',
'    from wwv_flow_files f, wwv_flow_fnd_user u',
'    where u.security_group_id = :flow_security_group_id',
'    and u.user_name = :APP_USER',
'    and f.filename = :P1104_SCRIPT_NAME',
'    and f.created_by != :APP_USER',
'    and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'           or exists ( select 1',
'                         from  wwv_flow_developers',
'                        where security_group_id = :flow_security_group_id',
'                          and userid = :APP_USER',
'                          and instr(developer_role||'':'',''ADMIN:'') > 0',
'                        union',
'                       select 1',
'                         from wwv_flow_fnd_user',
'                        where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                          and user_name = :APP_USER',
'                          and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER''))) )',
'loop',
'    return false;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome script specificato esiste gi\00E0 nell''area di lavoro ed \00E8 di propriet\00E0 di un altro utente. Immettere un altro nome script.')
,p_when_button_pressed=>wwv_flow_api.id(4213511874005243933.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213512088867243935.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4213511973236243934.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213512109682243936.4504)
,p_event_id=>wwv_flow_api.id(4213512088867243935.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4032943063908342946.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SaveScript'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_script_id     number;',
'    l_script_name   varchar2(4000);',
'    --',
'    l_message       varchar2(32767);',
'    l_qs_script_id  varchar2(255);',
'    c               integer := 0;',
'    l_audit_cols    varchar2(1) := ''N'';',
'    l_row_version   varchar2(1) := ''N'';',
'    l_row_key       varchar2(1) := ''N'';',
'    l_tenant_id     varchar2(1) := ''N'';',
'begin',
'    -- geneate SQL',
'    begin',
'  ',
'    if instr (:P1101_ADTL_COLS,''AUDIT_COLS'') > 0 then l_audit_cols := ''Y'';   end if;',
'    if instr (:P1101_ADTL_COLS,''ROW_VERSION'') > 0 then l_row_version := ''Y''; end if;',
'    if instr (:P1101_ADTL_COLS,''ROW_KEY'') > 0 then l_row_key := ''Y'';         end if;',
'    if instr (:P1101_ADTL_COLS,''TENANT_ID'') > 0 then l_tenant_id := ''Y'';     end if;',
'    ',
'    wwv_qs_design_schema_pub.add_tables (',
'        P_TABLE_PREFIX       => :P1101_TABLE_PREFIX,',
'        P_DATE_DATATYPE      => NVL(:P1101_DATE_DATATYPE,''DATE''), ',
'        P_INC_AUDITING       => l_audit_cols,',
'        P_TABLES             => :P1100_RAW_SQL,',
'        P_PRIMARY_KEY        => ''ID'',',
'        P_ROW_VERSION        => l_row_version,',
'        P_ROW_KEY            => l_row_key,',
'        p_tenant_id          => l_tenant_id,',
'        p_compressed         => NVL(:P1101_COMPRESSED,''N''),',
'        p_LONGER_IDENTIFIERS => NVL(:P1101_LONGER_IDENTIFIERS,''N''),',
'        p_AUTO_GEN_PK        => NVL(:P1101_AUTO_GEN_PK,''N''),',
'        p_apis               => NVL(:P1101_API,''N''),',
'        p_longer_varchars_yn => NVL(:P1101_longer_varchars,''N''),',
'        p_schema             => :P1101_SCHEMA,',
'        p_inserts            => 0,   -- depricate l_inserts',
'        p_selects            => ''N'', -- depricate l_selects',
'        p_uncomment          => :UNCOMMENT,',
'        p_tags_fw_yn         => NVL(:P1101_TAGS_FW,''N''),',
'        p_semantics          => :P1101_SEMANTICS );',
'    wwv_qs_design_schema_pub.g_gen_mode := ''CLOB'';',
'    wwv_qs_design_schema_pub.save_as_sql (',
'        P_APP_USER           => :APP_USER,',
'        P_APP_SESSION        => :APP_SESSION,',
'        P_TRIGGER_METHOD     => NVL(:P1101_TRIGGER_METHOD,''TRIG''),',
'        P_FK                 => NVL(:P1101_ON_DELETE,''RESTRICT''),',
'        P_ROW_VERSION        => l_row_version,',
'        P_ROW_KEY            => l_row_key,',
'        p_tenant_id          => l_tenant_id,',
'        p_compressed         => NVL(:P1101_COMPRESSED,''N''),',
'        P_TABLE_PREFIX       => NVL(:P1101_TABLE_PREFIX,''''),',
'        p_include_drops      => NVL(:P1101_INCLUDE_DROPS,''N''),',
'        p_db_version         => coalesce( :P1101_DB_VERSION, wwv_qs_design_schema_pub.get_default_db_version ), ',
'        p_LONGER_IDENTIFIERS => NVL(:P1101_LONGER_IDENTIFIERS,''N''),',
'        p_apis               => NVL(:P1101_API,''N''),',
'        p_message            => l_message,',
'        P_SCRIPT_ID          => l_qs_script_id,',
'        p_AUTO_GEN_PK        => NVL(:P1101_AUTO_GEN_PK,''N''),',
'        p_audit_cols         => l_audit_cols,',
'        p_DATE_DATATYPE      => NVL(:P1101_DATE_DATATYPE,''DATE''),',
'        p_editionable        => NVL(:P1101_EDITIONABLE,''N''),',
'        p_language           => NVL(:P1101_LANGUAGE,''EN''),',
'        p_apex               => NVL(:P1101_APEX,''N''),',
'        --',
'        P_PREFIX_PK_WITH_TNAME   => NVL(:P1101_PREFIX_PK_WITH_TNAME,    ''N''),',
'        P_CREATED_COLUMN_NAME    => NVL(:P1101_CREATED_COLUMN_NAME,     ''created''),',
'        P_CREATED_BY_COLUMN_NAME => NVL(:P1101_CREATED_BY_COLUMN_NAME,  ''created_by''),',
'        P_UPDATED_COLUMN_NAME    => NVL(:P1101_UPDATED_COLUMN_NAME,     ''updated''),',
'        P_UPDATED_BY_COLUMN_NAME => NVL(:P1101_UPDATED_BY_COLUMN_NAME,  ''updated_by''),',
'        --',
'        p_longer_varchars_yn => NVL(:longer_varchars,''N''),',
'        p_schema             => :P1101_SCHEMA,',
'        p_inserts            => 0, -- depricate l_inserts',
'        p_selects            => ''N'', -- depricate l_selects',
'        p_uncomment          => '''', -- depricate :UNCOMMENT,',
'        p_tags_fw_yn         => NVL(:P1101_TAGS_FW,''N''),',
'        p_semantics          => :P1101_SEMANTICS',
'    );',
'    exception when others then ',
'         l_message := sqlerrm;',
'    end;',
'   ',
'    wwv_qs_design_schema_pub.print_settings( p_text=>:P1100_RAW_SQL );',
'',
'    -- save SQL ',
'    l_script_name := :P1104_SCRIPT_NAME;',
'    ',
'    for l_script in (',
'        select id',
'        from wwv_flow_files f, wwv_flow_fnd_user u',
'        where u.security_group_id = :flow_security_group_id',
'        and u.user_name = :APP_USER',
'        and f.filename = l_script_name',
'        and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'               or exists ( select 1',
'                             from  wwv_flow_developers',
'                            where security_group_id = :flow_security_group_id',
'                              and userid = :APP_USER',
'                              and instr(developer_role||'':'',''ADMIN:'') > 0',
'                            union',
'                           select 1',
'                             from wwv_flow_fnd_user',
'                            where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                              and user_name = :APP_USER',
'                              and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER''))) )',
'    loop',
'        l_script_id := l_script.id;',
'    end loop;',
'    ',
'    if l_script_id is null then',
'        wwv_flow_sw_script.create_script_from_clob (        ',
'             p_script_name => l_script_name,',
'             p_script      => wwv_qs_design_schema_pub.g_clob );',
'    else',
'        wwv_flow_sw_script.update_script_file (',
'             p_file_id     => l_script_id,',
'             p_script_name => l_script_name,',
'             p_script      => wwv_qs_design_schema_pub.g_clob );',
'             ',
'        :P1100_SCRIPT_NAME := l_script_name;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4213511874005243933.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4032943149813342947.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'closeDialog'
,p_attribute_01=>'P1104_SCRIPT_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Script "&P1104_SCRIPT_NAME." salvato'
);
end;
/
prompt --application/pages/page_01105
begin
wwv_flow_api.create_page(
 p_id=>1105.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Salva modello'
,p_alias=>'SAVE-MODEL'
,p_page_mode=>'MODAL'
,p_step_title=>'Salva modello'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
,p_dialog_height=>'320'
,p_dialog_width=>'480'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(322850391897931279.4504)
,p_plug_name=>'Dettagli modello'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>50
,p_query_type=>'TABLE'
,p_query_table=>'WWV_QS_SAVED_MODELS'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4374476372760452414.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161432681248974219.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(4374476372760452414.4504)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva modello'
,p_button_position=>'NEXT'
,p_button_condition=>'P1105_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160966326559208507.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4374476372760452414.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161433093416974222.4504)
,p_name=>'P1105_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(322850391897931279.4504)
,p_item_source_plug_id=>wwv_flow_api.id(322850391897931279.4504)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161434220697974223.4504)
,p_name=>'P1105_MODEL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(322850391897931279.4504)
,p_item_source_plug_id=>wwv_flow_api.id(322850391897931279.4504)
,p_prompt=>'Nome modello'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161434657465974223.4504)
,p_name=>'P1105_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(322850391897931279.4504)
,p_item_source_plug_id=>wwv_flow_api.id(322850391897931279.4504)
,p_prompt=>'Descrizione'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161435015389974224.4504)
,p_name=>'P1105_MODEL'
,p_source_data_type=>'CLOB'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(322850391897931279.4504)
,p_item_source_plug_id=>wwv_flow_api.id(322850391897931279.4504)
,p_item_default=>'P1100_RAW_SQL'
,p_item_default_type=>'ITEM'
,p_source=>'MODEL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(160972358555355705.4504)
,p_validation_name=>'model not null'
,p_validation_sequence=>10
,p_validation=>'P1105_MODEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Per eseguire il salvataggio, \00E8 necessario specificare la sintassi Quick SQL.')
,p_validation_condition=>'CREATE, SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(160966829022208518.4504)
,p_validation_name=>'model name exists, use different name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_model in (',
'    select id',
'    from wwv_qs_saved_models',
'    where security_group_id = :flow_security_group_id',
'    and name = :P1105_MODEL_NAME',
'    and ( id != :P1105_ID or :P1105_ID is null ) )',
'loop',
'    return false;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome del modello esiste gi\00E0 nell''area di lavoro. Immettere un altro nome.')
,p_validation_condition=>'CREATE, SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(161434220697974223.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(160967999436208524.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(160966326559208507.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(160968483954208525.4504)
,p_event_id=>wwv_flow_api.id(160967999436208524.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(160975469978355736.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set P1100_MODEL_ID'
,p_process_sql_clob=>':P1103_MODEL_ID := :P1105_ID;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(160967102552208521.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(322850391897931279.4504)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'SaveModel'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_process_error_message=>'Impossibile salvare il modello'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(160967514690208524.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'closeDialog'
,p_attribute_01=>'P1103_MODEL_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Modello salvato'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(160974971020355731.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(322850391897931279.4504)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Model Detail'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01107
begin
wwv_flow_api.create_page(
 p_id=>1107.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Modifica modello'
,p_alias=>'EDIT-MODEL'
,p_page_mode=>'MODAL'
,p_step_title=>'Modifica modello'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12506407035221692)
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(485634170968606312.4504)
,p_plug_name=>'Dettagli modello'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>50
,p_query_type=>'TABLE'
,p_query_table=>'WWV_QS_SAVED_MODELS'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4537260151831127447.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(162785179424675041.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4537260151831127447.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1107_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(162784336183675039.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(4537260151831127447.4504)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva'
,p_button_position=>'NEXT'
,p_button_condition=>'P1107_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(162784731683675041.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4537260151831127447.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1103:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185274917186967001.4504)
,p_branch_name=>'back to load'
,p_branch_action=>'f?p=&APP_ID.:1103:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162786242905675047.4504)
,p_name=>'P1107_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(485634170968606312.4504)
,p_item_source_plug_id=>wwv_flow_api.id(485634170968606312.4504)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162786614227675052.4504)
,p_name=>'P1107_MODEL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(485634170968606312.4504)
,p_item_source_plug_id=>wwv_flow_api.id(485634170968606312.4504)
,p_prompt=>'Nome modello'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162787043588675052.4504)
,p_name=>'P1107_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(485634170968606312.4504)
,p_item_source_plug_id=>wwv_flow_api.id(485634170968606312.4504)
,p_prompt=>'Descrizione'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(162789961188675059.4504)
,p_validation_name=>'model name exists, use different name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_model in (',
'    select id',
'    from wwv_qs_saved_models',
'    where security_group_id = :flow_security_group_id',
'    and name = :P1107_MODEL_NAME',
'    and ( id != :P1107_ID or :P1107_ID is null ) )',
'loop',
'    return false;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome del modello esiste gi\00E0 nell''area di lavoro. Immettere un altro nome.')
,p_when_button_pressed=>wwv_flow_api.id(162784336183675039.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(162789035349675054.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(485634170968606312.4504)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'SaveModel'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_process_error_message=>'Impossibile salvare il modello.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Azione elaborata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(162789454864675054.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(485634170968606312.4504)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Model Detail'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01200
begin
wwv_flow_api.create_page(
 p_id=>1200.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Query SQL'
,p_step_title=>'Query SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213236325564854129)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'	table.htmldbShowHideMin{border-collapse:collapse;border:none;width:600px;}',
'	th.htmldbShowHideMin{font-weight:bold;font-size:12px;text-align:left;}',
'	td.htmldbShowHideMin{border:1px #cccccc solid;padding:4px;font-size:12px;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(14599108081253832.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5837904136173370.4504)
,p_plug_name=>'SQL Script results (autocommit)'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_2'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'wwv_flow_sw_page_calls.sql_results(:p1003_sql_command2, :p1200_bind_vals,:p1003_schema,:p1003_cmd_language);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(( upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) != ''SELECT'' and',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,4)) != ''WITH'' and',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) != ''COMMIT'' and',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,8)) != ''ROLLBACK''',
') or',
':P1003_CMD_LANGUAGE in ( wwv_flow_code_exec.c_javascript, wwv_flow_code_exec.c_java, wwv_flow_code_exec.c_python ) ) and',
':P1003_AUTOCOMMIT = ''Y'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21503410687604939.4504)
,p_plug_name=>'SQL Command Results (autocommit)'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_sql       clob;',
'    report      wwv_flow_global.vc_arr2;',
'    binds       wwv_flow_global.vc_arr2;',
'    l_start     number;',
'begin',
'',
'-- get the statement to run',
'  l_sql := :P1003_SQL_COMMAND2;',
'',
'-- get the binds values used last time if they exist',
'  binds := wwv_flow_utilities.string_to_table (',
'                            str => v(''P1200_BIND_VALS''),',
'                            sep => '','');',
'',
'  for i in 1..binds.count loop',
'   if binds(i) = ''HTMLDB:NULL'' then',
'    binds(i) := null;',
'   end if;',
'  end loop;',
'',
'-- get start time',
'l_start := sys.dbms_utility.get_time;',
'',
'if upper(substr(ltrim(:P1003_SQL_COMMAND2),1,6)) = ''COMMIT'' then',
'  sys.htp.p(wwv_flow_lang.system_message(''AUTOCOMMIT'')); ',
'elsif upper(substr(ltrim(:P1003_SQL_COMMAND2),1,8)) = ''ROLLBACK'' then',
'  sys.htp.p(wwv_flow_lang.system_message(''ROLLBACK'')); ',
'else',
'  -- get the results ',
'    wwv_flow_sw_api.check_priv(:P1003_SCHEMA);	',
'    wwv_flow_security.g_parse_as_schema := :P1003_SCHEMA;',
'    report := wwv_flow_render_query.get_report (',
'        p_owner  => :P1003_SCHEMA,',
'        p_query  => l_sql,',
'        p_values => binds,',
'        p_format => ''HTMLR'',',
'        p_limit_type => ''R'',',
'        p_max_rows => :P1003_ROWS',
'    );',
'  wwv_flow_security.g_parse_as_schema := wwv_flow.g_flow_schema_owner;',
'  -- get count minus 1 because of header row returned',
'  -- get count minus 2 because of to many rows message',
'  if (report.count > to_number(v(''P1003_ROWS''))+1) then',
'       :p1200_rows := report.count-2;',
'  else',
'       :p1200_rows := report.count-1;',
'  end if;',
'',
'  sys.htp.p(''<div id=ResultsSQL>'');',
'  -- print the results',
'  for i in 1..report.count loop',
'    sys.htp.p(report(i));',
'  end loop;',
'  sys.htp.p(''</div>'');',
'  if (report.count > 1) then',
'    -- print row count and timing information',
'    sys.htp.prn(''<table><tr><td>'');   ',
'    sys.htp.prn(''<span style="font-size:13px">''||wwv_flow_lang.system_message(''ROWS_IN_SECONDS'',:p1200_rows,to_char(round((sys.dbms_utility.get_time-l_start)/100,2),''999G999G999G990D00''))||''</span>'');',
'sys.htp.prn(''</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><span style="font-size:11px"><a href="f?p=4500:1204:''||:SESSION||''::::P1204_BROWSER_LANG:''||wwv_flow.g_browser_language||''">''||',
'         wwv_flow_lang.system_message(''F4000.P420.CSV_EXPORT'')||',
'         ''</a></span></td></tr></table>'');',
'  end if;',
'end if;',
'exception when others then',
'  wwv_flow_security.g_parse_as_schema := wwv_flow.g_flow_schema_owner;',
'  wwv_flow_debug.log_exception;',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'((upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) = ''SELECT'' or',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,4)) = ''WITH'' or',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) = ''COMMIT'' or',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,8)) = ''ROLLBACK'') and',
':P1003_CMD_LANGUAGE not in ( wwv_flow_code_exec.c_javascript, wwv_flow_code_exec.c_java, wwv_flow_code_exec.c_python ) and',
':P1003_AUTOCOMMIT = ''Y'')'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27937306591128514.4504)
,p_plug_name=>'Output DBMS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(35638231141594602.4504)
,p_plug_display_sequence=>32
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_count number := v(''P1200_ROWS'');',
'begin',
'  sys.htp.p(''<pre>'');',
'  for i in 1..wwv_flow_render_query.g_dbms_output.count loop',
'    sys.htp.p(wwv_flow_render_query.g_dbms_output(i));',
'  end loop;',
'  sys.htp.p(''</pre>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'((upper(substr(ltrim(:P1003_SQL_COMMAND2),1,6)) = ''SELECT'' or',
'upper(substr(ltrim(:P1003_SQL_COMMAND2),1,4)) = ''WITH'')) and',
'wwv_flow_render_query.g_dbms_output.count > 1'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_read_only_when2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27945305393241780.4504)
,p_plug_name=>'Item Holder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>1
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_1'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(136436823187793970.4504)
,p_plug_name=>'SQL Script results (no autocommit)'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>42
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_2'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<!-- HTMLDB:RUNNING'' || :P1003_CMD_LANGUAGE || '' --><DIV id="dSQLResult">'');',
'sys.htp.p(wwv_flow_lang.system_message(p_name=>''SC_SQL_RUNNING''));',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(( upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) != ''SELECT'' and',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,4)) != ''WITH'' ) or',
':P1003_CMD_LANGUAGE in ( wwv_flow_code_exec.c_javascript, wwv_flow_code_exec.c_java, wwv_flow_code_exec.c_python ) ) and',
':P1003_AUTOCOMMIT != ''Y'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(137068820874069237.4504)
,p_plug_name=>'SQL Command Results (no autocommit)'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>31
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<!-- HTMLDB:RUNNINGSQL --><DIV id="dSQLResult">'');',
'sys.htp.p(wwv_flow_lang.system_message(p_name=>''SC_SQL_RUNNING''));',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) = ''SELECT'' or',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,4)) = ''WITH'') and',
':P1003_CMD_LANGUAGE not in ( wwv_flow_code_exec.c_javascript, wwv_flow_code_exec.c_java, wwv_flow_code_exec.c_python ) and',
':P1003_AUTOCOMMIT != ''Y'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(137341724550811368.4504)
,p_plug_name=>'Output DBMS'
,p_region_name=>'dbms_output_show_hide'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_api.id(35638231141594602.4504)
,p_plug_display_sequence=>52
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'<div id="DBMS_OUTPUT_DIV"></div>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4417028828681705.4504)
,p_name=>'P1200_ROWS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(27945305393241780.4504)
,p_item_default=>'10'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4418303464693368.4504)
,p_name=>'P1200_PREV_SQL'
,p_data_type=>'CLOB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(27945305393241780.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21572909937200807.4504)
,p_name=>'P1200_ACTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(27945305393241780.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21606912080381235.4504)
,p_name=>'P1200_BINDS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(27945305393241780.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21736625668766618.4504)
,p_name=>'P1200_BIND_VALS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(27945305393241780.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141063525539678026.4504)
,p_name=>'P1200_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(27945305393241780.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141446907512589228.4504)
,p_name=>'P1200_STMT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(27945305393241780.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(302525021229299586.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(27211261219513908.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Strip start comments from P1003_SQL_COMMAND2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- convert CRLF to LF',
'-- remove -- comments at the beginning',
'--',
':P1003_SQL_COMMAND2 := regexp_replace (',
'                           regexp_replace (',
'                               :P1003_SQL_COMMAND2,',
'                               chr(13)||''?''||chr(10),',
'                               chr(10) ),',
'                           ''^(\s*--[^''||chr(10)||'']*''||chr(10)||'')+'',',
'                           null );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1003_SQL_COMMAND2 != nvl(:P1200_PREV_SQL,'' '')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6214509600387615.4504)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save history'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P1003_SQL_COMMAND2,',
'    p_schema            => :P1003_SCHEMA',
'    );',
'',
':P1200_PREV_SQL := :P1003_SQL_COMMAND2 ;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile salvare la cronologia di comandi.'
,p_process_when=>':P1003_SQL_COMMAND2 != nvl(:P1200_PREV_SQL,'' '')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_01201
begin
wwv_flow_api.create_page(
 p_id=>1201.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Cronologia'
,p_step_title=>'Cronologia'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213236325564854129)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script src="#IMAGE_PREFIX#javascript/htmldb_html_elements.js" type="text/javascript"></script>',
'<script src="#IMAGE_PREFIX#javascript/htmldb_get.js" type="text/javascript"></script>',
'<script src="#IMAGE_PREFIX#sc/sc_core.js" type="text/javascript"></script>'))
,p_step_template=>wwv_flow_api.id(14599108081253832.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5983109938894128.4504)
,p_name=>'Cronologia comandi SQL'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       CREATED_ON created, ',
'       created_by, ',
'       sys.dbms_lob.substr(command,100,1) sql_cmd,',
'       PARSED_SCHEMA,',
'       ''javascript:sc_postHistory(''||',
'       wwv_flow_escape.js_literal(ID)||',
'       '',''||wwv_flow_escape.js_literal(PARSED_SCHEMA)||',
'       '');'' link',
'from wwv_flow_sw_sql_cmds  ',
'where security_group_id = :flow_security_group_id  ',
'and created_by = :flow_user ',
'and (:P1201_FIND is null or instr(upper(command),upper(:P1201_FIND)) > 0)',
'order by CREATED_ON desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessuna cronologia dei comandi trovata.'
,p_query_row_count_max=>100
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23982602424811438.4504)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5983413805894138.4504)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>1
,p_column_heading=>'Quando'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5983518709894138.4504)
,p_query_column_id=>3
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>3
,p_column_heading=>'By'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5983625499894139.4504)
,p_query_column_id=>4
,p_column_alias=>'SQL_CMD'
,p_column_display_sequence=>2
,p_column_heading=>'SQL'
,p_use_as_row_header=>'N'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#SQL_CMD#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161196926932862064.4504)
,p_query_column_id=>5
,p_column_alias=>'PARSED_SCHEMA'
,p_column_display_sequence=>5
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(423052112825639938.4504)
,p_query_column_id=>6
,p_column_alias=>'LINK'
,p_column_display_sequence=>6
,p_column_heading=>'Link'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26154723718225041.4504)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23976007778699484.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(26154723718225041.4504)
,p_button_name=>'GO'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_button_alignment=>'LEFT-CENTER'
,p_button_redirect_url=>'javascript:sc_DisplayHist(true);'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(5985722851905156.4504)
,p_branch_action=>'javascript:sc_DisplayHist();'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5986320805906753.4504)
,p_name=>'P1201_PASSBACK1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5983109938894128.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5986924960907925.4504)
,p_name=>'P1201_PASSBACK2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5983109938894128.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6341431950207894.4504)
,p_name=>'P1201_HISTORY_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(5983109938894128.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13468207898983653.4504)
,p_name=>'P1201_FIND'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(26154723718225041.4504)
,p_prompt=>'Trova'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Immettere la condizione di query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
prompt --application/pages/page_01202
begin
wwv_flow_api.create_page(
 p_id=>1202.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Explain plan della query'
,p_step_title=>'Piano'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213236325564854129)
,p_step_template=>wwv_flow_api.id(14599108081253832.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(135681931596634447.4504)
,p_plug_name=>'plan'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(239514318560826866.4504)
,p_name=>'Colonne indice'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select c006 object_owner, c007 object_type,c008 object_name',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''',
'       and c007 in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')),',
'ws_schemas as(',
'    select schema',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id),',
't as(',
'        select s.object_owner table_owner,s.object_name table_name,',
'               d.OBJECT_ID',
'          from sqlplan s,sys.dba_objects d',
'         where s.object_owner = d.owner',
'           and s.object_name = d.object_name',
'           and s.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name,',
'               d.OBJECT_ID',
'          from sys.dba_indexes d1, sqlplan s1,',
'               sys.dba_objects d',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and replace(s1.object_type,'' (UNIQUE)'') = ''INDEX''',
'           and d.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'           and d.owner = d1.table_owner',
'           and d.object_name = d1.table_name',
'           ),',
'cols as(',
'    select table_owner,index_name,',
'           rtrim(',
'           max(decode(position,1 ,column_name))||'',''||',
'           max(decode(position,2 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,3 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,4 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,5 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,6 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,7 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,8 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,9 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,10,substr(column_name,1,128)))',
'           ,'','') columns',
'     from(',
'        select c.table_owner,c.index_name,c.column_name,c.column_position position',
'          from sys.dba_ind_columns c, t',
'         where t.table_owner = c.table_owner',
'           and t.table_name = c.table_name)',
'    group by table_owner,index_name',
')',
'select di.owner,',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||t.object_id||'',TABLE,''|| wwv_flow_escape.html(di.owner)||''">''||wwv_flow_escape.html(di.table_name)||''</a>''',
'       else wwv_flow_escape.html(di.table_name) end table_name,',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||do2.object_id||'',INDEX,''|| wwv_flow_escape.html(di.owner)||''">''||wwv_flow_escape.html(di.index_name)||''</a>''',
'       else wwv_flow_escape.html(di.index_name) end index_name,',
'       case when (select count(*) cnt',
'                    from sqlplan sp1',
'                   where sp1.object_type like ''INDEX%''',
'                     and sp1.object_name = di.index_name) > 0',
'            then ''<img src="#IMAGE_PREFIX#check_small_black.gif" alt=""/>''',
'            else ''<br />''',
'       end check_mark,',
'      c.columns, uniqueness, di.status,',
'      index_type, partitioned,',
'      funcidx_status, join_index,t.object_id, do2.object_id index_object_id',
'from   sys.dba_indexes di,sys.dba_objects do2,',
'       t,cols c',
'where di.table_owner = t.table_owner',
'  and di.table_name = t.table_name',
'  and index_type != ''LOB''',
'  and do2.object_type = ''INDEX''',
'  and do2.owner = di.owner',
'  and do2.object_name = di.index_name',
'  and c.table_owner = di.table_owner',
'  and c.index_name  = di.index_name'))
,p_display_when_condition=>'P1202_DISPLAY_VERSION'
,p_display_when_cond2=>'10'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'Nessun indice trovato'
,p_query_row_count_max=>1000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10g Version'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241097528833140170.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239515507477826873.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tabella'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_inline_lov=>'f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA'
,p_lov_language=>'PLSQL'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241097615533140170.4504)
,p_query_column_id=>3
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome indice'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241097704512140171.4504)
,p_query_column_id=>4
,p_column_alias=>'CHECK_MARK'
,p_column_display_sequence=>4
,p_column_heading=>'Utilizzato nel<br />piano'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241097817354140171.4504)
,p_query_column_id=>5
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>5
,p_column_heading=>'Colonne'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241097917854140171.4504)
,p_query_column_id=>6
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Univocit\00E0')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241098028330140171.4504)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241098131175140171.4504)
,p_query_column_id=>8
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>8
,p_column_heading=>'Tipo indice'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241098226446140171.4504)
,p_query_column_id=>9
,p_column_alias=>'PARTITIONED'
,p_column_display_sequence=>9
,p_column_heading=>'Partitioned'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241098301230140171.4504)
,p_query_column_id=>10
,p_column_alias=>'FUNCIDX_STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Funcidx Status'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241098430048140172.4504)
,p_query_column_id=>11
,p_column_alias=>'JOIN_INDEX'
,p_column_display_sequence=>11
,p_column_heading=>'Indice di join'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241098518617140172.4504)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>12
,p_column_heading=>'Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241098624718140172.4504)
,p_query_column_id=>13
,p_column_alias=>'INDEX_OBJECT_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Index Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(239555324756875948.4504)
,p_name=>'Piano di esecuzione della query'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select to_number(c001) id, to_number(c002) parent_id,to_number(c003) position,',
'           c004 operation, c005 options,',
'           c006 object_owner, c007 object_type,c008 object_name,',
'           c009 access_predicates, c010 filter_predicates,',
'           to_number(c011) cardinality, to_number(c012)cost,',
'           to_number(c013) bytes, to_number(c014)time',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''),',
'objects as (',
'   select o.object_id,s.id',
'     from sys.dba_objects o,sqlplan s',
'    where o.owner = s.object_owner',
'      and o.object_name = s.object_name',
'      and replace(s.object_type,'' (UNIQUE)'') = o.object_type',
'      and s.object_type in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')',
'     ),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id), ',
'plan_objects as(',
'    select s.id,parent_id,position,',
'           operation,options,',
'           object_owner,object_type,object_name,',
'           access_predicates,filter_predicates,',
'           cardinality,cost,bytes,time,',
'           o.object_id',
'      from sqlplan s,objects o',
'     where s.id = o.id(+))',
'select operation,options,',
'       case when object_type in (''TABLE'',''VIEW'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'') then',
'            case when object_owner in (select schema from ws_schemas) then',
'                 ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||object_id||'',''||replace(object_type,'' (UNIQUE)'')||'',''|| wwv_flow_escape.html(object_owner)||''">''||wwv_flow_escape.html(object_name)||''</a>''',
'            else wwv_flow_escape.html(object_name) end ',
'       else wwv_flow_escape.html(object_name) end object_name,',
'       cost,cardinality,bytes,',
'       decode(level,1,1,power(level,2)+15) padding,access_predicates,filter_predicates,TIME,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,filter_predicates)',
'       else wwv_flow_escape.html(replace(filter_predicates,''='','' = '')) end filter_predicates2,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,access_predicates) ',
'       else wwv_flow_escape.html(replace(access_predicates,''='','' = '')) end access_predicates2,',
'       object_id,object_type',
'   from plan_objects s1',
'  start with id = 0',
'connect by prior id = parent_id',
'  order by id, position'))
,p_display_when_condition=>'P1202_DISPLAY_VERSION'
,p_display_when_cond2=>'10'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'* Le colonne non indicizzate vengono visualizzate in rosso',
'<br />'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessun piano disponibile per questa istruzione.'
,p_query_row_count_max=>10000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10g Version'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239555800201875951.4504)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>'Operazione'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<div style="padding-left:#PADDING#px;white-space:nowrap;font-family:monospace;">#OPERATION#</div>'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239555912431875952.4504)
,p_query_column_id=>2
,p_column_alias=>'OPTIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Opzioni'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;font-family:monospace;'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239555711134875950.4504)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Oggetto'
,p_column_css_style=>'font-family:monospace;'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239556015951875952.4504)
,p_query_column_id=>4
,p_column_alias=>'COST'
,p_column_display_sequence=>6
,p_column_heading=>'Costo'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239556131228875952.4504)
,p_query_column_id=>5
,p_column_alias=>'CARDINALITY'
,p_column_display_sequence=>4
,p_column_heading=>'Righe'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239555612991875950.4504)
,p_query_column_id=>6
,p_column_alias=>'BYTES'
,p_column_display_sequence=>7
,p_column_heading=>'Byte'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239555528964875950.4504)
,p_query_column_id=>7
,p_column_alias=>'PADDING'
,p_column_display_sequence=>10
,p_column_heading=>'Padding'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239556514881875952.4504)
,p_query_column_id=>8
,p_column_alias=>'ACCESS_PREDICATES'
,p_column_display_sequence=>8
,p_column_heading=>'Access<br />Predicates'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239556626602875952.4504)
,p_query_column_id=>9
,p_column_alias=>'FILTER_PREDICATES'
,p_column_display_sequence=>9
,p_column_heading=>'Filter<br />Predicates'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239556719045875953.4504)
,p_query_column_id=>10
,p_column_alias=>'TIME'
,p_column_display_sequence=>5
,p_column_heading=>'Quando'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239557011368875953.4504)
,p_query_column_id=>11
,p_column_alias=>'FILTER_PREDICATES2'
,p_column_display_sequence=>11
,p_column_heading=>'Predicati di<br />filtro*'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239557112931875953.4504)
,p_query_column_id=>12
,p_column_alias=>'ACCESS_PREDICATES2'
,p_column_display_sequence=>12
,p_column_heading=>'Predicati di<br />accesso'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239556820353875953.4504)
,p_query_column_id=>13
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239556911845875953.4504)
,p_query_column_id=>14
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>14
,p_column_heading=>'Object Type'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(239675610426212457.4504)
,p_name=>'Colonne tabelle'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select c006 object_owner, c007 object_type,c008 object_name',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''',
'       and c007 in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')),',
't1 as(',
'        select s.object_owner table_owner,s.object_name table_name',
'          from sqlplan s',
'         where s.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name',
'          from sys.dba_indexes d1, sqlplan s1',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and replace(s1.object_type,'' (UNIQUE)'') = ''INDEX''',
'           ),',
't as (select t1.table_owner, t1.table_name,',
'             o.object_id',
'        from t1, sys.dba_objects o',
'       where t1.table_owner = o.owner',
'         and t1.table_name = o.object_name',
'         and o.object_type in (''TABLE'',''MATERIALIZED VIEW'') ',
'      )',
'select t.table_owner,t.table_name,c.column_name,c.data_type',
'  from t,sys.dba_tab_columns c',
' where t.table_name = c.table_name',
'   and t.table_owner = c.owner',
' order by t.table_owner,t.table_name,c.column_id'))
,p_display_when_condition=>'P1202_DISPLAY_VERSION'
,p_display_when_cond2=>'10'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>2000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10g Version'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239675924163212494.4504)
,p_query_column_id=>1
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239676025992212494.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239676117659212494.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(239676200856212494.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo dati'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(252410704790298347.4504)
,p_name=>'Piano di esecuzione della query'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select to_number(c001) id, to_number(c002) parent_id,to_number(c003) position,',
'           c004 operation, c005 options,',
'           c006 object_owner, c007 object_type,c008 object_name,',
'           c009 access_predicates, c010 filter_predicates,',
'           to_number(c011) cardinality, to_number(c012)cost,',
'           to_number(c013) bytes, to_number(c014)time',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''),',
'objects as (',
'   select o.object_id,s.id',
'     from sys.dba_objects o,sqlplan s',
'    where o.owner = s.object_owner',
'      and o.object_name = s.object_name',
'      and replace(s.object_type,'' (UNIQUE)'') = o.object_type',
'      and s.object_type in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')',
'     ),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id), ',
'plan_objects as(',
'    select s.id,parent_id,position,',
'           operation,options,',
'           object_owner,object_type,object_name,',
'           access_predicates,filter_predicates,',
'           cardinality,cost,bytes,time,',
'           o.object_id',
'      from sqlplan s,objects o',
'     where s.id = o.id(+))',
'select operation,options,',
'       case when object_type in (''TABLE'',''VIEW'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'') then',
'            case when object_owner in (select schema from ws_schemas) then',
'                 ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||object_id||'',''||replace(object_type,'' (UNIQUE)'')||'',''|| wwv_flow_escape.html(object_owner)||''">''||wwv_flow_escape.html(object_name)||''</a>''',
'            else wwv_flow_escape.html(object_name) end ',
'       else wwv_flow_escape.html(object_name) end object_name,',
'       cost,cardinality,bytes,',
'       decode(level,1,1,power(level,2)+15) padding,access_predicates,filter_predicates,TIME,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,filter_predicates) ',
'       else wwv_flow_escape.html(replace(filter_predicates,''='','' = '')) end filter_predicates2,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,access_predicates) ',
'       else wwv_flow_escape.html(replace(access_predicates,''='','' = '')) end access_predicates2,',
'       object_id,object_type',
'   from plan_objects s1',
'  start with id = 0',
'connect by prior id = parent_id',
'  order by id, position'))
,p_display_when_condition=>'P1202_DISPLAY_VERSION'
,p_display_when_cond2=>'9'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'* Le colonne non indicizzate vengono visualizzate in rosso',
'<br />'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessun piano disponibile per questa istruzione.'
,p_query_row_count_max=>10000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'9i Version'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411230815298351.4504)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>'Operazione'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<div style="padding-left:#PADDING#;white-space:nowrap;font-family:monospace;">#OPERATION#</div>'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411323676298351.4504)
,p_query_column_id=>2
,p_column_alias=>'OPTIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Opzioni'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;font-family:monospace;'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411100531298351.4504)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Oggetto'
,p_column_css_style=>'font-family:monospace;'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411429033298351.4504)
,p_query_column_id=>4
,p_column_alias=>'COST'
,p_column_display_sequence=>6
,p_column_heading=>'Costo'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411514671298351.4504)
,p_query_column_id=>5
,p_column_alias=>'CARDINALITY'
,p_column_display_sequence=>4
,p_column_heading=>'Righe'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411003232298350.4504)
,p_query_column_id=>6
,p_column_alias=>'BYTES'
,p_column_display_sequence=>7
,p_column_heading=>'Byte'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252410923530298350.4504)
,p_query_column_id=>7
,p_column_alias=>'PADDING'
,p_column_display_sequence=>10
,p_column_heading=>'Padding'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411628421298351.4504)
,p_query_column_id=>8
,p_column_alias=>'ACCESS_PREDICATES'
,p_column_display_sequence=>8
,p_column_heading=>'Access<br />Predicates'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411706657298351.4504)
,p_query_column_id=>9
,p_column_alias=>'FILTER_PREDICATES'
,p_column_display_sequence=>9
,p_column_heading=>'Filter<br />Predicates'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411821834298351.4504)
,p_query_column_id=>10
,p_column_alias=>'TIME'
,p_column_display_sequence=>5
,p_column_heading=>'Quando'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252412130592298352.4504)
,p_query_column_id=>11
,p_column_alias=>'FILTER_PREDICATES2'
,p_column_display_sequence=>11
,p_column_heading=>'Predicati di<br />filtro*'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252412229051298352.4504)
,p_query_column_id=>12
,p_column_alias=>'ACCESS_PREDICATES2'
,p_column_display_sequence=>12
,p_column_heading=>'Predicati di<br />accesso'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252411930106298351.4504)
,p_query_column_id=>13
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252412009763298352.4504)
,p_query_column_id=>14
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>14
,p_column_heading=>'Object Type'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(252415124183303959.4504)
,p_name=>'Colonne indici'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select c006 object_owner, c007 object_type,c008 object_name',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''',
'       and c008 is not null),',
'ws_schemas as(',
'    select schema',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id),',
't as(',
'        select s.object_owner table_owner,s.object_name table_name,',
'               d.OBJECT_ID',
'          from sqlplan s,sys.dba_objects d',
'         where s.object_owner = d.owner',
'           and s.object_name = d.object_name',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name,',
'               d.OBJECT_ID',
'          from sys.dba_indexes d1, sqlplan s1,',
'               sys.dba_objects d',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and d.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'           and d.owner = d1.table_owner',
'           and d.object_name = d1.table_name',
'           ),',
'cols as(',
'    select table_owner,index_name,',
'           rtrim(',
'           max(decode(position,1 ,column_name))||'',''||',
'           max(decode(position,2 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,3 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,4 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,5 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,6 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,7 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,8 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,9 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,10,substr(column_name,1,128)))',
'           ,'','') columns',
'     from(',
'        select c.table_owner,c.index_name,c.column_name,c.column_position position',
'          from sys.dba_ind_columns c, t',
'         where t.table_owner = c.table_owner',
'           and t.table_name = c.table_name)',
'    group by table_owner,index_name',
')',
'select di.owner,',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||t.object_id||'',TABLE,''|| wwv_flow_escape.html(di.owner)||''">''||wwv_flow_escape.html(di.table_name)||''</a>''',
'       else wwv_flow_escape.html(di.table_name) end table_name,',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:''||do2.object_id||'',INDEX,''|| wwv_flow_escape.html(di.owner)||''">''||wwv_flow_escape.html(di.index_name)||''</a>''',
'       else wwv_flow_escape.html(di.index_name) end index_name,',
'       case when (select count(*) cnt',
'                    from sqlplan sp1',
'                   where sp1.object_name = di.index_name) > 0',
'            then ''<img src="#IMAGE_PREFIX#check_small_black.gif" />''',
'            else ''<br />''',
'       end check_mark,',
'      c.columns, uniqueness, di.status,',
'      index_type, partitioned,',
'      funcidx_status, join_index,t.object_id, do2.object_id index_object_id',
'from   sys.dba_indexes di,sys.dba_objects do2,',
'       t,cols c',
'where di.table_owner = t.table_owner',
'  and di.table_name = t.table_name',
'  and index_type != ''LOB''',
'  and do2.object_type = ''INDEX''',
'  and do2.owner = di.owner',
'  and do2.object_name = di.index_name',
'  and c.table_owner = di.table_owner',
'  and c.index_name  = di.index_name'))
,p_display_when_condition=>'P1202_DISPLAY_VERSION'
,p_display_when_cond2=>'9'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'Nessun indice trovato'
,p_query_row_count_max=>1000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'9i Version'
);
end;
/
begin
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252415421113303961.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252415311453303961.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tabella'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_inline_lov=>'f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA'
,p_lov_language=>'PLSQL'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252415503649303961.4504)
,p_query_column_id=>3
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome indice'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252415632676303961.4504)
,p_query_column_id=>4
,p_column_alias=>'CHECK_MARK'
,p_column_display_sequence=>4
,p_column_heading=>'Utilizzato nel<br />piano'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252415731634303961.4504)
,p_query_column_id=>5
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>5
,p_column_heading=>'Colonne'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252415825974303961.4504)
,p_query_column_id=>6
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Univocit\00E0')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252415911170303962.4504)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252416004020303962.4504)
,p_query_column_id=>8
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>8
,p_column_heading=>'Tipo indice'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252416105849303962.4504)
,p_query_column_id=>9
,p_column_alias=>'PARTITIONED'
,p_column_display_sequence=>9
,p_column_heading=>'Partitioned'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252416228198303962.4504)
,p_query_column_id=>10
,p_column_alias=>'FUNCIDX_STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Funcidx Status'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252416313466303962.4504)
,p_query_column_id=>11
,p_column_alias=>'JOIN_INDEX'
,p_column_display_sequence=>11
,p_column_heading=>'Indice di join'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252416417060303962.4504)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>12
,p_column_heading=>'Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252416530517303962.4504)
,p_query_column_id=>13
,p_column_alias=>'INDEX_OBJECT_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Index Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(252418504921307803.4504)
,p_name=>'Colonne tabelle'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select c006 object_owner, c007 object_type,c008 object_name',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''',
'       and c008 is not null),',
't1 as(',
'        select s.object_owner table_owner,s.object_name table_name',
'          from sqlplan s,sys.dba_tables d',
'         where s.object_name  = d.table_name',
'           and s.object_owner = d.owner',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name',
'          from sys.dba_indexes d1, sqlplan s1',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           ),',
't as (select t1.table_owner, t1.table_name,',
'             o.object_id',
'        from t1, sys.dba_objects o',
'       where t1.table_owner = o.owner',
'         and t1.table_name = o.object_name',
'         and o.object_type in (''TABLE'',''MATERIALIZED VIEW'') ',
'      )',
'select t.table_owner,t.table_name,c.column_name,c.data_type',
'  from t,sys.dba_tab_columns c',
' where t.table_name = c.table_name',
'   and t.table_owner = c.owner',
' order by t.table_owner,t.table_name,c.column_id'))
,p_display_when_condition=>'P1202_DISPLAY_VERSION'
,p_display_when_cond2=>'9'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>2000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'9i Version'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252418703042307804.4504)
,p_query_column_id=>1
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252418818352307804.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252418911086307804.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(252419018758307804.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo dati'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6369926344376593.4504)
,p_name=>'P1202_PLAN_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(135681931596634447.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(256632316355836384.4504)
,p_name=>'P1202_DISPLAY_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(135681931596634447.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(302531415221364040.4504)
,p_process_sequence=>5
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6370900633388058.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create plan table if needed.'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.create_plan_table (',
'    p_schema => :P1003_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante la spiegazione del piano per l''istruzione: <pre>exit</pre>'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6373330761396752.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Explain Plan'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_plan_id number := wwv_flow_id.next_val;',
'begin',
'  :P1202_PLAN_ID := l_plan_id;',
'  wwv_flow_sw_api.explain_plan (',
'    p_plan_id => l_plan_id,',
'    p_sql     => wwv_flow_sw_api.to_sql_command(wwv_flow.g_f01),',
'    p_schema  => :P1003_SCHEMA',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Errore durante il calcolo del piano per l''istruzione.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(256644405713890081.4504)
,p_process_sequence=>35
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Determine db Version'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1202_DISPLAY_VERSION  := ''NONE'';',
'',
'begin',
'for c1 in (select 1 ',
'             from dual',
'            where exists(',
'                  select 1',
'                    from htmldb_collections',
'                   where COLLECTION_NAME=''HTMLDB_QUERY_PLAN'')',
'           )',
'loop',
'    if wwv_flow_utilities.db_version_is_at_least(''10.1'') then',
'        :P1202_DISPLAY_VERSION  := ''10'';',
'    else',
'        :P1202_DISPLAY_VERSION  := ''9'';',
'    end if;',
'end loop;--c1',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01203
begin
wwv_flow_api.create_page(
 p_id=>1203.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Processori comandi SQL - SQL salvato'
,p_step_title=>'SQL salvato'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213236325564854129)
,p_step_template=>wwv_flow_api.id(14599108081253832.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(6415019707620645.4504)
,p_name=>'SQL salvato'
,p_template=>wwv_flow_api.id(12270828624874231.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid=>true
,p_display_column=>1
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       QUERY_OWNER,',
'       case query_type',
'         when ''W'' then wwv_flow_lang.system_message(''SC_VQ'')',
'         when ''R'' then wwv_flow_lang.system_message(''SC_SC'')',
'       end qType,',
'       title,',
'       sys.dbms_lob.substr(QB_SQL,120) as QB_SQL,',
'       DESCRIPTION,',
'       CREATED_BY,',
'       CREATED_ON,',
'       LAST_UPDATED_BY,',
'       LAST_UPDATED_ON,',
'       SECURITY_GROUP_ID,',
'       ''javascript:sc_postSavedSQL(''||',
'            wwv_flow_escape.js_literal(id)||',
'       '',''||wwv_flow_escape.js_literal(title)||',
'       '',''||wwv_flow_escape.js_literal(description)||',
'       '',''||wwv_flow_escape.js_literal(',
'                case query_type',
'                  when ''W'' then ''VQB''',
'                  when ''R'' then ''SC''',
'                end)||',
'       '',''||wwv_flow_escape.js_literal(query_owner)||',
'       '');'' link_url',
' from WWV_FLOW_QB_SAVED_QUERY',
'where security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and (:P1203_FIND is null',
'       or instr(upper(title),upper(:P1203_FIND)) > 0 ',
'       or instr(upper(QB_SQL),upper(:P1203_FIND)) > 0 )',
'  and (created_by = case when :P1203_SHOW = ''0'' then created_by else :P1203_SHOW end) ',
'  and (created_by = :APP_USER',
'      or exists ( select 1',
'                    from wwv_flow_developers',
'                   where security_group_id = :flow_security_group_id',
'                     and userid = :APP_USER',
'                     and instr(developer_role||'':'',''ADMIN:'') > 0',
'                   union',
'                  select 1',
'                    from wwv_flow_fnd_user',
'                   where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                     and user_name = :APP_USER',
'                     and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))',
'order by LAST_UPDATED_ON desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(2251716882439710.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessuna istruzione SQL salvata trovata'
,p_query_num_rows_item=>'P1203_ROWS'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6415504466620655.4504)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158049613622816668.4504)
,p_query_column_id=>2
,p_column_alias=>'QUERY_OWNER'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159619215751589324.4504)
,p_query_column_id=>3
,p_column_alias=>'QTYPE'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158049717816816670.4504)
,p_query_column_id=>4
,p_column_alias=>'TITLE'
,p_column_display_sequence=>6
,p_column_heading=>'Nome'
,p_column_link=>'#LINK_URL#'
,p_column_linktext=>'#TITLE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158049805684816670.4504)
,p_query_column_id=>5
,p_column_alias=>'QB_SQL'
,p_column_display_sequence=>8
,p_column_heading=>'SQL'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158049907140816670.4504)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>7
,p_column_heading=>'Descrizione'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6415807384620655.4504)
,p_query_column_id=>7
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>4
,p_column_heading=>'Proprietario'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158050107364816670.4504)
,p_query_column_id=>8
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158050228739816670.4504)
,p_query_column_id=>9
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>10
,p_column_heading=>'Autore aggiornamento'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158050326944816671.4504)
,p_query_column_id=>10
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>11
,p_column_heading=>'Aggiornato'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158050425755816671.4504)
,p_query_column_id=>11
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>12
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(423020317449535345.4504)
,p_query_column_id=>12
,p_column_alias=>'LINK_URL'
,p_column_display_sequence=>13
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(159446531179807318.4504)
,p_query_column_id=>13
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Elimina'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444003821799425.4504)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444115343799426.4504)
,p_column_sequence=>2
,p_query_column_name=>'QUERY_OWNER'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159618306552589318.4504)
,p_column_sequence=>3
,p_query_column_name=>'QTYPE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444208693799426.4504)
,p_column_sequence=>4
,p_query_column_name=>'TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444319711799426.4504)
,p_column_sequence=>5
,p_query_column_name=>'QB_SQL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444406523799426.4504)
,p_column_sequence=>6
,p_query_column_name=>'DESCRIPTION'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444630169799427.4504)
,p_column_sequence=>7
,p_query_column_name=>'CREATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444723920799427.4504)
,p_column_sequence=>8
,p_query_column_name=>'CREATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444806816799427.4504)
,p_column_sequence=>9
,p_query_column_name=>'LAST_UPDATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159444909486799427.4504)
,p_column_sequence=>10
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(159445029183799427.4504)
,p_column_sequence=>11
,p_query_column_name=>'SECURITY_GROUP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(423020228600535343.4504)
,p_column_sequence=>12
,p_query_column_name=>'LINK_URL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(158079710730882097.4504)
,p_plug_name=>'Page Item'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(158072826052867579.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(158079710730882097.4504)
,p_button_name=>'GO'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_button_alignment=>'LEFT-BOTTOM'
,p_button_redirect_url=>'javascript:sc_getSavedSQL();'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(159470001406874413.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(158079710730882097.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina selezione'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:PPR_Tabluar_Submit(''R6415019707620645'',''4500'',''1203'',''DELETE'',true,''R6415019707620645'');'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(6428713494666085.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1203:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6424513652656720.4504)
,p_name=>'P1203_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(158079710730882097.4504)
,p_item_default=>'&APP_USER.'
,p_prompt=>'Proprietario'
,p_source=>':APP_USER'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'QUERY_OWNERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r from (',
'select wwv_flow_escape.html(created_by) d, created_by r ',
'  from wwv_flow_qb_saved_query',
'where security_group_id = :flow_security_group_id',
'and exists (     ',
'select 1 ',
'from  wwv_flow_developers ',
'where security_group_id = :flow_security_group_id and ',
'      userid = :flow_user and ',
'      instr(developer_role||'':'',''ADMIN:'') > 0 ',
'union ',
'select 1 ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id ',
'and user_name = :flow_user ',
'and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')) ',
'union all  ',
'select v(''APP_USER'') d, v(''APP_USER'') r',
'FROM DUAL) ',
'group by d,r',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Tutti gli utenti -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identificare il nome utente da visualizzare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6426331313661863.4504)
,p_name=>'P1203_FIND'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(158079710730882097.4504)
,p_prompt=>'Trova'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Immettere la condizione di query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7140916813154218.4504)
,p_name=>'P1203_SAVE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(158079710730882097.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161238102522892832.4504)
,p_name=>'P1203_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(158079710730882097.4504)
,p_item_default=>'10'
,p_prompt=>'Righe'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cHeight=>1
,p_tag_attributes=>'style="min-width: 40px;"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(159468320668870516.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(6415019707620645.4504)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'Delete'
,p_attribute_02=>'WWV_FLOW_QB_SAVED_QUERY'
,p_attribute_03=>'ID'
,p_process_error_message=>'Impossibile rimuovere la/le riga/e di query'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Riga/e di query rimosse'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205718418307439419.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_01204
begin
wwv_flow_api.create_page(
 p_id=>1204.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Report sul download dei comandi SQL'
,p_alias=>'SC_DL_REPORT'
,p_step_title=>'Report sul download dei comandi SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11539602725985552)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1287321922908833672.4504)
,p_plug_name=>'Browser Language'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1287345129834835717.4504)
,p_name=>'P1204_BROWSER_LANG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1287321922908833672.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(302540120808394071.4504)
,p_process_sequence=>5
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(204028208695700079.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'print report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql varchar2(32700);',
'  report wwv_flow_global.vc_arr2;',
'  binds  wwv_flow_global.vc_arr2;',
'',
'  l_csv_charset varchar2(255) := NULL;',
'  l_export_clob clob;',
'  l_export_blob blob;  ',
'        ',
'begin',
'',
'  wwv_flow.g_browser_language := :P1204_BROWSER_LANG;',
'  wwv_flow_lang.alter_session(wwv_flow_lang.map_language(wwv_flow.g_browser_language)); ',
'             ',
'  wwv_flow_init_htp_buffer;',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow.g_unrecoverable_error := true;',
'    ',
'  wwv_flow_utilities.print_download_header(',
'    p_mime_type =>     ''text/plain'',',
'    p_file_name =>     ''report.csv'',',
'    p_is_attachment => true',
'  );',
'  ',
'  sys.owa_util.http_header_close;',
'',
'  if wwv_flow_preferences.get_preference( p_preference => ''F4500_CSV_DOWNLOAD_UNICODE'' ) = ''Y'' then',
'      l_csv_charset := ''AL32UTF8'';',
'  else',
'      for c1 in (',
'          select csv_encoding, flow_language_derived_from',
'          from wwv_flows',
'          where id = wwv_flow.g_flow_id',
'      ) loop',
'          if c1.flow_language_derived_from <> ''0'' and nvl(c1.csv_encoding,''N'') = ''Y'' then',
'              l_csv_charset := wwv_flow_lang.get_nls_windows_charset;',
'          end if;',
'          exit;',
'      end loop;',
'  end if;',
'  ',
'  if (l_csv_charset is not null) then  ',
'     sys.dbms_lob.createtemporary( l_export_clob, true, sys.dbms_lob.session );    ',
'     sys.dbms_lob.open( l_export_clob, sys.dbms_lob.lob_readwrite );    ',
'  end if;  ',
'    ',
'-- get the statement to run',
'  l_sql := v(''P1003_SQL_COMMAND2'');',
'',
'-- get the binds values used last time if they exist',
'  binds := wwv_flow_utilities.string_to_table (',
'                            str => v(''P1200_BIND_VALS''),',
'                            sep => '','');',
'',
'  for i in 1..binds.count loop',
'   if binds(i) = ''HTMLDB:NULL'' then',
'    binds(i) := null;',
'   end if;',
'  end loop;',
'',
'  report := wwv_flow_render_query.get_report (',
'        p_owner  => v(''P1003_SCHEMA''),',
'        p_query  => l_sql,',
'        p_values => binds,',
'        p_format => ''CSV'',',
'        p_limit_type => ''R'',',
'        p_max_rows => v(''P1003_ROWS'')',
'    );',
'',
'  -- print the results',
'  for i in 1..report.count loop',
'  ',
'     if (l_csv_charset is not null) then',
'        sys.dbms_lob.writeappend( l_export_clob, length(report(i)||chr(10)), report(i)||chr(10));    ',
'     else',
'        sys.htp.p(report(i));',
'     end if;',
'',
'  end loop;',
'',
'  if (l_csv_charset is not null) then',
'    ',
'        sys.dbms_lob.close( l_export_clob );',
'        ',
'        l_export_blob := wwv_flow_utilities.clob_to_blob( p_clob => l_export_clob, p_charset => l_csv_charset );',
'        ',
'        -- download the binary contents of the BLOB',
'        wpg_docload.download_file( l_export_blob ); ',
'    ',
'        -- cleanup the temporary BLOB ',
'        sys.dbms_lob.freetemporary( l_export_blob );   ',
'',
'        -- cleanup the temporary CLOB     ',
'        sys.dbms_lob.freetemporary( l_export_clob );',
'        ',
'  end if;   ',
'      ',
'  wwv_flow.g_unrecoverable_error := true;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'errore'
,p_process_success_message=>'ok'
);
end;
/
prompt --application/pages/page_01220
begin
wwv_flow_api.create_page(
 p_id=>1220.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Risultati script'
,p_step_title=>'Gestisci risultati script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467846201977971481.4504)
,p_plug_name=>'Risultati'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with dr as',
'(select result_id,',
'        sum(result_size) the_sum',
'  from wwv_flow_sw_detail_results ',
' where security_group_id = :flow_security_group_id',
' group by result_id),',
'wv_lang as',
'    (select r.result_id,s.file_id,',
'            wwv_flow_lang.system_message(''FORM_OF'',r.cnt,s.cnt) the_msg,',
'            wwv_flow_lang.system_message(''FORM_OF'',r.cnt,r.cnt) the_msg2',
'      from',
'        (select file_id,count(distinct stmt_number) cnt',
'           from wwv_flow_sw_stmts',
'          where isrunnable = ''Y''',
'            and security_group_id = :flow_security_group_id',
'          group by file_id) s,',
'        (select result_id,file_id,count(*) cnt',
'           from wwv_flow_sw_detail_results',
'          where security_group_id = :flow_security_group_id',
'          group by result_id,file_id) r',
'     where s.file_id = r.file_id(+))',
'SELECT ',
'   r.id edit_script,',
'   r.id "ID", ',
'   r.file_id,',
'   r.file_id details,',
'   f.filename FILE_Name, ',
'   f.filename script_name,',
'   r.job_id "JOB_ID", ',
'   r.run_by "RUN_BY", ',
'   r.run_as run_as,',
'   the_sum output_size,  ',
'   r.started "STARTED", ',
'   r.ended "ENDED",    ',
'   (decode(sign(r.end_time-r.start_time),-1,24*60*60*(nvl(r.ended,sysdate) - r.started),r.end_time-r.start_time)/100) elapsed,',
'   decode(r.status,''EXECUTING'',',
'          sys.htf.anchor(''f?p=4500:1225:''||:app_session||''::::P1224_RESULT_ID:''||r.id,wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.EXECUTING'')),',
'   wwv_flow_escape.html(case when r.status = ''SUBMITTED'' then wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.SUBMITTED'') when r.status = ''EXECUTING'' then wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.EXECUTING'') when r.status = ''COMPLETE'' then w'
||'wv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.COMPLETED'') when r.status = ''CANCELED'' then wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.CANCELED'')  when r.status = ''CANCELING'' then wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.CANCELING'') end'
||')) status,',
'   r.run_comments "RUN_COMMENTS", ',
'   r.security_group_id "SECURITY_GROUP_ID",',
'   decode(r.status,''COMPLETE'',htmldb_item.checkbox(1,r.id,null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''DELETE_LABEL'', wwv_flow_escape.html(f.filename))),',
'          ''CANCELED'',htmldb_item.checkbox(1,r.id,null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''DELETE_LABEL'', wwv_flow_escape.html(f.filename))),',
'          null) purge,',
'    -- wv_lang.the_msg  statements,',
'    (select decode(r.status,''COMPLETE'',the_msg2,the_msg) from wv_lang where wv_lang.file_id = r.file_id and wv_lang.result_id = r.id) statements,',
'decode(r.status,''EXECUTING'',''Y'',''SUBMITTED'',''Y'',''N'') highlight_row',
'FROM ',
'   wwv_flow_sw_results r, wwv_flow_files f,dr',
'where r.file_id = f.id',
'  and dr.result_id(+) = r.id',
'  and r.security_group_id = :flow_security_group_id',
'  and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'       or exists ( select 1',
'                     from  wwv_flow_developers',
'                    where security_group_id = :flow_security_group_id',
'                      and userid = :APP_USER',
'                      and instr(developer_role||'':'',''ADMIN:'') > 0',
'                    union',
'                   select 1',
'                     from wwv_flow_fnd_user',
'                    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                      and user_name = :APP_USER',
'                      and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(467846302875971481.4504)
,p_name=>'Results'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467848112067971525.4504)
,p_db_column_name=>'PURGE'
,p_display_order=>1
,p_column_identifier=>'Q'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_column_comment=>'<input type="checkbox" name="x01" value="1" onClick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467846507842971503.4504)
,p_db_column_name=>'EDIT_SCRIPT'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Modifica'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847028132971513.4504)
,p_db_column_name=>'SCRIPT_NAME'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Script '
,p_column_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:#FILE_ID#'
,p_column_linktext=>'#SCRIPT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467846730134971505.4504)
,p_db_column_name=>'FILE_ID'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'File selezionato'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847105887971514.4504)
,p_db_column_name=>'JOB_ID'
,p_display_order=>5
,p_column_identifier=>'G'
,p_column_label=>'ID job'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847212983971515.4504)
,p_db_column_name=>'RUN_BY'
,p_display_order=>6
,p_column_identifier=>'H'
,p_column_label=>'Autore esecuzione'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847309666971516.4504)
,p_db_column_name=>'RUN_AS'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Esegui come'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847502077971518.4504)
,p_db_column_name=>'STARTED'
,p_display_order=>8
,p_column_identifier=>'K'
,p_column_label=>'Avviato'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847605493971519.4504)
,p_db_column_name=>'ENDED'
,p_display_order=>9
,p_column_identifier=>'L'
,p_column_label=>'Terminato'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847720961971520.4504)
,p_db_column_name=>'ELAPSED'
,p_display_order=>10
,p_column_identifier=>'M'
,p_column_label=>'Tempo trascorso'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847829876971521.4504)
,p_db_column_name=>'STATUS'
,p_display_order=>11
,p_column_identifier=>'N'
,p_column_label=>'Stato'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847927845971522.4504)
,p_db_column_name=>'RUN_COMMENTS'
,p_display_order=>12
,p_column_identifier=>'O'
,p_column_label=>'Commenti esecuzione'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467848014449971523.4504)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>13
,p_column_identifier=>'P'
,p_column_label=>'ID gruppo di sicurezza'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467846607473971504.4504)
,p_db_column_name=>'ID'
,p_display_order=>14
,p_column_identifier=>'B'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467848206284971526.4504)
,p_db_column_name=>'STATEMENTS'
,p_display_order=>15
,p_column_identifier=>'R'
,p_column_label=>'Istruzioni'
,p_column_type=>'STRING'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467847424073971517.4504)
,p_db_column_name=>'OUTPUT_SIZE'
,p_display_order=>16
,p_column_identifier=>'J'
,p_column_label=>'Byte'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467846906672971512.4504)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>17
,p_column_identifier=>'E'
,p_column_label=>'Riepilogo'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#htmldb/icons/copy_small.gif" border="0" alt="xxx">'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467846815659971511.4504)
,p_db_column_name=>'DETAILS'
,p_display_order=>18
,p_column_identifier=>'D'
,p_column_label=>'Visualizza risultati'
,p_column_link=>'f?p=&APP_ID.:1225:&SESSION.::&DEBUG.::P1224_RESULT_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-search"></span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467848316753971527.4504)
,p_db_column_name=>'HIGHLIGHT_ROW'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'&nbsp;'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11250108787573812.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(467846201977971481.4504)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina selezione'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_sw_results',
'where security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10120023136690967.4504)
,p_branch_action=>'1220'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(277455912402422805.4504)
,p_name=>'P1220_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(467846201977971481.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1896404407400627.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1220_FILE_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1220_FIND'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(11613201326226114.4504)
,p_validation_name=>'must select output(s) to delete'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Nessun output di script selezionato'
,p_when_button_pressed=>wwv_flow_api.id(11250108787573812.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199176160684878437.4504)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(467846201977971481.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199176295390878438.4504)
,p_event_id=>wwv_flow_api.id(1199176160684878437.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(10119807492690965.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'Refresh,GO'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(11611202449207579.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete output'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  delete from wwv_flow_sw_results',
'  where id = wwv_flow.g_f01(i)',
'  and security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile eliminare l''output selezionato.'
,p_process_when_button_id=>wwv_flow_api.id(11250108787573812.4504)
,p_process_success_message=>'Output selezionato eliminato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182280216628523464.4504)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clean out orphan long ops'
,p_process_sql_clob=>'wwv_flow_sw_script.clean_out_orphan_long_op;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossibile annullare uno script che non \00E8 in esecuzione.')
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_01225
begin
wwv_flow_api.create_page(
 p_id=>1225.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Risultati'
,p_step_title=>'Risultati'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>'<script src="#IMAGE_PREFIX#sc/sc_core.js" type="text/javascript"></script>'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11922008681959891.4504)
,p_plug_name=>'Output'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_elapsed number := 0;',
'begin',
'  sys.htp.prn(''<span class="fielddata">'');',
'  sys.htp.prn(''<hr />'');',
'  for c1 in (select id, result_id, stmt_num, stmt_text, msg, result, ',
'                    started, start_time, ended, end_time, Result_Rows',
'             from wwv_flow_sw_detail_results',
'             where result_id = :p1224_result_id',
'             and security_group_id = :flow_security_group_id',
'             order by seq_id)',
'  loop',
'    -- statement',
'    if instr('':''||:P1225_VIEW_MODE||'':'','':STMT:'') > 0 then',
'      sys.htp.prn(''<pre>'');',
'      wwv_flow_sw_script.print_stmt(p_id => c1.id);',
'      sys.htp.prn(''</pre>'');',
'    end if;',
'  ',
'    -- results',
'    if instr('':''||:P1225_VIEW_MODE||'':'','':RESULTS:'') > 0 then',
'          sys.htp.prn(''<div class="htmldbScriptResult">'');',
'    	wwv_flow_sw_script.print_result(p_id => c1.id);',
'          sys.htp.prn(''</div>'');',
'    end if;',
'  ',
'    -- feedback',
'    if instr('':''||:P1225_VIEW_MODE||'':'','':MSG:'') > 0 then',
'      sys.htp.prn(''<br />'');',
'      sys.htp.prn(wwv_flow_escape.html(c1.msg));',
'    end if;',
'  ',
'    -- rows',
'    /*if instr('':''||:P1225_VIEW_MODE||'':'','':MSG:'') > 0 then',
'      if c1.result_rows is not null then',
'        if c1.result_rows = 1 then ',
'        	 sys.htp.prn(wwv_flow_lang.system_message(',
'        	          ''WWV_FLOW_SW_SCRIPT.RESULT_ROW'',',
'        	          to_char(c1.Result_Rows,''999G999G999G999G999G999G990'')',
'        	          ));                ',
'        else         ',
'           sys.htp.prn(wwv_flow_lang.system_message(',
'        	          ''WWV_FLOW_SW_SCRIPT.RESULT_ROWS'',',
'        	          to_char(c1.Result_Rows,''999G999G999G999G999G999G990'')',
'        	          ));',
'        end if;',
'      end if;',
'    end if;*/',
'  ',
'    -- elap time',
'    if instr('':''||:P1225_VIEW_MODE||'':'','':MSG:'') > 0 then ',
'      if sign(c1.end_time-c1.start_time) = -1 then',
'        l_elapsed := 24*60*60*(nvl(c1.ended,sysdate) - c1.started);',
'      else',
'        l_elapsed := c1.end_time-c1.start_time;',
'      end if;',
'      l_elapsed := l_elapsed/100;',
'      ',
'      -- don''t show elapsed time for result with errors',
'      if sys.dbms_lob.instr(c1.msg,''ORA-'',1,1) > 0 then',
'        l_elapsed := null;',
'      end if;',
'      ',
'      if l_elapsed is not null then',
'        sys.htp.prn('' ''||wwv_flow_lang.system_message(',
'                  ''WWV_FLOW_SW_SCRIPT.ELAPSED'',',
'                  to_char(l_elapsed,''999G999G999G999G990D00'')',
'                  ));',
'      end if;',
'    end if;',
'  ',
'    -- end of statement',
'    sys.htp.prn(''<hr />'');',
'  end loop;',
'  sys.htp.prn(''</span>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1225_VIEW'
,p_plug_display_when_cond2=>'DETAIL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11941610899045610.4504)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(12089027223164064.4504)
,p_name=>'Riepilogo script (vista dei dettagli)'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left; clear:both;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT ',
'   id edit_script,',
'   "ID" "ID", ',
'   file_id,',
'   file_id details,',
'   (select fileName from wwv_flow_files where id = r.file_id) FILE_Name, ',
'   (select fileName from wwv_flow_files where id = r.file_id) script_name,',
'   "JOB_ID" "JOB_ID", ',
'   "RUN_BY" "RUN_BY", ',
'   run_as run_as,',
'   "STARTED" "STARTED",',
'   started started2, ',
'   "ENDED" "ENDED", ',
'   decode(end_time,null,null,',
'   wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.ELAPSED'',to_char((decode(sign(end_time-start_time),-1,24*60*60*(nvl(ended,sysdate) - started),end_time-start_time)/100),''999G999G999G999G990D00''))) elapsed,',
'   status,',
'   "RUN_COMMENTS" "RUN_COMMENTS", ',
'   "SECURITY_GROUP_ID" "SECURITY_GROUP_ID",',
'   (select count(*) from wwv_flow_sw_detail_results where result_id = r.id) statements,',
'   wwv_flow_sw_script.get_success_cnt(:P1224_RESULT_ID) succesful,',
'   wwv_flow_sw_script.get_failure_cnt(:P1224_RESULT_ID) with_errors ',
'FROM ',
'   "WWV_FLOW_SW_RESULTS" r',
'where security_group_id = :flow_security_group_id',
'  and id = :P1224_RESULT_ID'))
,p_display_when_condition=>'P1225_VIEW'
,p_display_when_cond2=>'DETAIL'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'N'
,p_plug_query_exp_filename=>'scripts.csv'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12089224469164067.4504)
,p_query_column_id=>1
,p_column_alias=>'EDIT_SCRIPT'
,p_column_display_sequence=>1
,p_column_heading=>'Edit Script'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12089301193164068.4504)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12089405069164068.4504)
,p_query_column_id=>3
,p_column_alias=>'FILE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'File Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12089503956164068.4504)
,p_query_column_id=>4
,p_column_alias=>'DETAILS'
,p_column_display_sequence=>4
,p_column_heading=>'Details'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12089625641164068.4504)
,p_query_column_id=>5
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'File Name'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12089729410164068.4504)
,p_query_column_id=>6
,p_column_alias=>'SCRIPT_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Script Name'
,p_column_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:#FILE_ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#ed-item.gif" border="0" alt="&EDIT.">#SCRIPT_NAME#'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12089814037164068.4504)
,p_query_column_id=>7
,p_column_alias=>'JOB_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Job'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12089907680164068.4504)
,p_query_column_id=>8
,p_column_alias=>'RUN_BY'
,p_column_display_sequence=>8
,p_column_heading=>'Autore esecuzione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12090009316164068.4504)
,p_query_column_id=>9
,p_column_alias=>'RUN_AS'
,p_column_display_sequence=>9
,p_column_heading=>'Schema di analisi'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12090132705164069.4504)
,p_query_column_id=>10
,p_column_alias=>'STARTED'
,p_column_display_sequence=>10
,p_column_heading=>'Script avviato'
,p_column_format=>'&LONG_DATE_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(112578215367052286.4504)
,p_query_column_id=>11
,p_column_alias=>'STARTED2'
,p_column_display_sequence=>11
,p_column_heading=>'<br />'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12090217850164069.4504)
,p_query_column_id=>12
,p_column_alias=>'ENDED'
,p_column_display_sequence=>12
,p_column_heading=>'Script Ended'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12090310919164069.4504)
,p_query_column_id=>13
,p_column_alias=>'ELAPSED'
,p_column_display_sequence=>13
,p_column_heading=>'Tempo trascorso'
,p_column_format=>'999G999G999G999G990D00'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16883519523407070.4504)
,p_query_column_id=>14
,p_column_alias=>'STATUS'
,p_column_display_sequence=>14
,p_column_heading=>'Status'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(16851103836270043)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12090506322164069.4504)
,p_query_column_id=>15
,p_column_alias=>'RUN_COMMENTS'
,p_column_display_sequence=>16
,p_column_heading=>'Comments'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12090622401164069.4504)
,p_query_column_id=>16
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>17
,p_column_heading=>'Security Group'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12094102120194661.4504)
,p_query_column_id=>17
,p_column_alias=>'STATEMENTS'
,p_column_display_sequence=>15
,p_column_heading=>'Istruzioni elaborate'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182182231491300604.4504)
,p_query_column_id=>18
,p_column_alias=>'SUCCESFUL'
,p_column_display_sequence=>18
,p_column_heading=>'Operazione completata'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182182312450300604.4504)
,p_query_column_id=>19
,p_column_alias=>'WITH_ERRORS'
,p_column_display_sequence=>19
,p_column_heading=>'Con errori'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(164053306541529880.4504)
,p_name=>'Riepilogo risultato'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="float:left; clear:both;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'(decode(sign(end_time-start_time),-1,24*60*60*(nvl(ended,sysdate) - started),end_time-start_time)/100) elapsed,',
'sys.dbms_lob.substr(stmt_text,60,1) stmt,',
'sys.dbms_lob.substr(result,60,1) log,',
'nvl(msg,wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.EXECUTING'')) msg,',
'result_rows rowcnt,',
'decode(nvl(sys.dbms_lob.getlength(result),0),0,null,',
'  sys.htf.anchor(''javascript:sc_callResultPopup(''''&SESSION.'''',''''''||id||'''''');'',',
'  wwv_flow_lang.system_message(''F4500_P1224_VIEW_OUTPUT''))) output',
'from wwv_flow_sw_detail_results',
'where result_id = :P1224_RESULT_ID',
'and security_group_id = :flow_security_group_id'))
,p_display_when_condition=>'P1225_VIEW'
,p_display_when_cond2=>'SUMMARY'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_footer=>'<p />'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_item=>'P1225_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'N'
,p_plug_query_exp_filename=>'results.csv'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164053523951529886.4504)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Numero'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164053615089529886.4504)
,p_query_column_id=>2
,p_column_alias=>'ELAPSED'
,p_column_display_sequence=>2
,p_column_heading=>'Tempo trascorso'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164054031009529886.4504)
,p_query_column_id=>3
,p_column_alias=>'STMT'
,p_column_display_sequence=>3
,p_column_heading=>'Istruzione'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164053702812529886.4504)
,p_query_column_id=>4
,p_column_alias=>'LOG'
,p_column_display_sequence=>4
,p_column_heading=>'Log'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164053916316529886.4504)
,p_query_column_id=>5
,p_column_alias=>'MSG'
,p_column_display_sequence=>5
,p_column_heading=>'Feedback'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164053808466529886.4504)
,p_query_column_id=>6
,p_column_alias=>'ROWCNT'
,p_column_display_sequence=>6
,p_column_heading=>'Righe'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164054105991529886.4504)
,p_query_column_id=>7
,p_column_alias=>'OUTPUT'
,p_column_display_sequence=>7
,p_column_heading=>'Output'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(182075813896125294.4504)
,p_name=>'Riepilogo script (vista di riepilogo)'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_region_attributes=>'style="float:left; clear:both;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) statements_processed, ',
'wwv_flow_sw_script.get_success_cnt(:P1224_RESULT_ID) succesful,',
'wwv_flow_sw_script.get_failure_cnt(:P1224_RESULT_ID) with_errors ',
'from wwv_flow_sw_detail_results where result_id = :P1224_RESULT_ID'))
,p_display_when_condition=>'P1225_VIEW'
,p_display_when_cond2=>'SUMMARY'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717423775712828084.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182089208448180458.4504)
,p_query_column_id=>1
,p_column_alias=>'STATEMENTS_PROCESSED'
,p_column_display_sequence=>1
,p_column_heading=>'Istruzioni elaborate'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182178606211293375.4504)
,p_query_column_id=>2
,p_column_alias=>'SUCCESFUL'
,p_column_display_sequence=>2
,p_column_heading=>'Operazione completata'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182090016067182690.4504)
,p_query_column_id=>3
,p_column_alias=>'WITH_ERRORS'
,p_column_display_sequence=>3
,p_column_heading=>'Con errori'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11944332370051884.4504)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_button_name=>'P1225_GO'
,p_button_static_id=>'P1225_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Vai'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4212068580375544812.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_button_name=>'CREATE_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Crea applicazione'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:RP,20:P20_SCRIPT_FILE_ID,P20_SCHEMA:&P1225_FILE_ID.,&P1225_RUN_AS.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(467856212269044380.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_button_name=>'EDIT_SCRIPT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Modifica script'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:&P1225_FILE_ID.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11938414231037148.4504)
,p_name=>'P1225_VIEW_MODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_prompt=>'Mostra:'
,p_source=>':STMT:MSG:ELAPSED:ROWS:RESULTS:'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SCRIPT_OUTPUT_VIEW_MODE'
,p_lov=>'.'||wwv_flow_api.id(11936228645031897.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>'P1225_VIEW'
,p_display_when2=>'DETAIL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Selezionare il tipo di output da visualizzare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(82706511505738138.4504)
,p_name=>'P1225_RUN_AS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select run_as',
'from wwv_flow_sw_results',
'where security_group_id = :flow_security_group_id',
'and id = :P1224_RESULT_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164056220178543294.4504)
,p_name=>'P1225_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_prompt=>'Script:'
,p_post_element_text=>'&nbsp;&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  (select fileName from wwv_flow_files where id = r.file_id) script_name',
'FROM ',
'   "WWV_FLOW_SW_RESULTS" r',
'where security_group_id = :flow_security_group_id',
'  and id = :P1224_RESULT_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Nome dello script SQL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164057801955547440.4504)
,p_name=>'P1225_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_prompt=>'Stato:'
,p_post_element_text=>'&nbsp;&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   status',
'FROM ',
'   "WWV_FLOW_SW_RESULTS" r',
'where security_group_id = :flow_security_group_id',
'  and id = :P1224_RESULT_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SCRIPT_RESULT_STATUS'
,p_lov=>'.'||wwv_flow_api.id(16851103836270043.4504)||'.'
,p_cSize=>2
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('La condizione dello script SQL. Utilizzare tale condizione per determinare se lo script \00E8 in esecuzione o se l''esecuzione \00E8 stata completata.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164110808750890063.4504)
,p_name=>'P1224_RESULT_ID'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164194224977256815.4504)
,p_name=>'P1225_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_item_default=>'15'
,p_prompt=>'Righe'
,p_source=>'15'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_api.id(88005728392276151.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>'nvl(:P1225_VIEW,''SUMMARY'')=''SUMMARY'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identificare il numero di righe da visualizzare per pagina.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164617423386419293.4504)
,p_name=>'P1225_VIEW'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_item_default=>'SUMMARY'
,p_prompt=>'Vista:'
,p_source=>'SUMMARY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'VIEW_DETAIL_SUMMARY'
,p_lov=>'.'||wwv_flow_api.id(183733207435875441.4504)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Visualizzare un riepilogo o una vista dettagliata dei risultati degli script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(245278829308900214.4504)
,p_name=>'P1225_FILE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(11941610899045610.4504)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_id',
'from wwv_flow_sw_results',
'where id = :P1224_RESULT_ID',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(856093801147711151.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1225_FILE_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_id',
'from wwv_flow_sw_results',
'where id = :P1224_RESULT_ID',
'and security_group_id = :flow_security_group_id'))
);
end;
/
prompt --application/pages/page_01350
begin
wwv_flow_api.create_page(
 p_id=>1350.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Confronto degli schemi'
,p_step_title=>'Confronto degli schemi'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_comp_schema.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14640703422583946.4504)
,p_plug_name=>'Confronta'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(14654103993650366.4504)
,p_name=>'Risultati'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_type, object_name, table_name, ',
'       decode(schema1,0,null,''<span class="a-Icon icon-check"></span>'') schema1, ',
'       decode(schema2,0,null,''<span class="a-Icon icon-check"></span>'') schema2',
'from (',
'select',
'  ''TABLE.TRIGGER'' object_type,',
'  table_name object_name,',
'  TABLE_NAME||''.''||TRIGGER_NAME||''.''||TRIGGER_TYPE||''.''||',
'    TRIGGERING_EVENT||''.''||WHEN_CLAUSE||''.''||ACTION_TYPE table_name,',
'  sum(decode(OWNER,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(OWNER,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_triggers',
'where (OWNER = :P1350_SCHEMA_1 or OWNER = :P1350_SCHEMA_2) and',
'      TABLE_NAME not like ''BIN$%'' and',
'      TABLE_NAME not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(TABLE_NAME)||''.''||upper(trigger_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''TRIGGER'')',
'group by table_name, TABLE_NAME||''.''||TRIGGER_NAME||''.''||TRIGGER_TYPE||''.''||',
'    TRIGGERING_EVENT||''.''||WHEN_CLAUSE||''.''||ACTION_TYPE ',
'union all',
'select',
'  ''SEQUENCE'' object_type,',
'  sequence_name object_name,',
'  SEQUENCE_NAME||''.''||INCREMENT_BY||''.''||',
'    CYCLE_FLAG||''.''||ORDER_FLAG||''.''||CACHE_SIZE table_name,',
'  sum(decode(sequence_owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(sequence_owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_sequences',
'where (sequence_owner = :P1350_SCHEMA_1 or sequence_owner = :P1350_SCHEMA_2) and',
'      SEQUENCE_NAME not like ''BIN$%'' and',
'      SEQUENCE_NAME not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(SEQUENCE_NAME),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''SEQUENCE'')',
'group by sequence_name, SEQUENCE_NAME||''.''||INCREMENT_BY||''.''||CYCLE_FLAG||''.''||ORDER_FLAG||''.''||CACHE_SIZE',
'union all',
'select type object_type, ',
'       object_name,',
'       table_name, ',
'       sum(decode(owner,:P1350_SCHEMA_1,1,0)) schema1,',
'       sum(decode(owner,:P1350_SCHEMA_2,1,0)) schema2',
'from (',
'select type, name object_name, name||''.''||type||'' ''||t.l_lines||''=''||max(line)||'' ''||t.l_size||''=''||sum(length(text)) table_name, owner',
'from sys.dba_source s,',
'     (select wwv_flow_lang.system_message(''LINES'') l_lines,',
'             wwv_flow_lang.system_message(''SIZE'') l_size',
'      from dual) t',
'where owner in (:P1350_SCHEMA_1,:P1350_SCHEMA_2) and',
'      name not like ''BIN$%'' and',
'      name not like ''DR$%'' and',
'      (:P1350_SEARCH is null or instr(upper(name),upper(:P1350_SEARCH))>0) and',
'      (:P1350_COMPARE = ''0'' or :P1350_COMPARE = type)',
'group by owner, name,type, t.l_lines, t.l_size ) plsql',
'group by type, object_name, table_name',
'union all',
'select',
'  ''TABLE'' object_type,',
'  t.table_name object_name,',
'  t.table_name,',
'  sum(decode(t.owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(t.owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_tables t',
'where (owner = :P1350_SCHEMA_1 or owner = :P1350_SCHEMA_2) and',
'      table_name not like ''BIN$%'' and',
'      table_name not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(table_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''TABLE'')',
'group by t.table_name',
'union all',
'select',
'  ''VIEW'' object_type,',
'  t.view_name object_name,',
'  t.view_name table_name,',
'  sum(decode(t.owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(t.owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_views t',
'where (owner = :P1350_SCHEMA_1 or owner = :P1350_SCHEMA_2) and',
'      view_name not like ''BIN$%'' and',
'      view_name not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(view_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''VIEW'')',
'group by t.view_name',
'union all',
'select',
'  ''TABLE.COLUMN'' object_type,',
'  t.table_name||''.''||t.column_name object_name,',
'  t.table_name||''.''||t.column_name table_name,',
'  sum(decode(t.owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(t.owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_tab_columns t',
'where (owner = :P1350_SCHEMA_1 or owner = :P1350_SCHEMA_2) and',
'      table_name not like ''BIN$%'' and',
'      table_name not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(table_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''COLUMN'')',
'group by t.table_name||''.''||t.column_name',
'union all',
'select',
'  ''TABLE.COLUMN.DATATYPE'' object_type,',
'  t.table_name||''.''||t.column_name||''.''||data_type object_name,',
'  t.table_name||''.''||t.column_name||''.''||data_type||''.''||',
'   data_length||''.''||data_scale||''.''||DATA_PRECISION||''.''||nullable table_name,',
'  sum(decode(t.owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(t.owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_tab_columns t',
'where (owner = :P1350_SCHEMA_1 or owner = :P1350_SCHEMA_2) and',
'      table_name not like ''BIN$%'' and',
'      table_name not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(table_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''DATATYPE'')',
'group by t.table_name||''.''||t.column_name||''.''||data_type,',
'         t.table_name||''.''||t.column_name||''.''||data_type||''.''||',
'          data_length||''.''||data_scale||''.''||DATA_PRECISION||''.''||nullable',
'union all',
'select ''TABLE.INDEX'' object_type,',
'       object_name,',
'       table_name,',
'       sum(decode(table_owner,:P1350_SCHEMA_1,1,0)) schema1,',
'       sum(decode(table_owner,:P1350_SCHEMA_2,1,0)) schema2',
'from (',
'    select table_owner,',
'           table_name||'' ''||uniqueness||'' (''||',
'           max(decode(position,1 ,column_name))||',
'           max(decode(position,2 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,3 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,4 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,5 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,6 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,7 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,8 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,9 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,10,'',''||substr(column_name,1,128)))||'')''',
'           object_name,',
'           table_name||''.''||',
'           decode(substr(index_name,1,4),''SYS_'',''SYS'',index_name',
'           )||''.''||uniqueness||'':''||',
'           max(decode(position,1 ,column_name))||',
'           max(decode(position,2 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,3 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,4 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,5 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,6 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,7 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,8 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,9 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,10,'',''||substr(column_name,1,128)))',
'           table_name',
'     from(',
'        select dc.table_name, dc.table_owner,dc.index_name,di.uniqueness, di.status,',
'               di.index_type, di.temporary, di.partitioned,di.funcidx_status, di.join_index,',
'               dc.column_name,dc.column_position position',
'          from sys.dba_ind_columns dc,sys.dba_indexes di',
'         where dc.table_owner in (:P1350_SCHEMA_1,:P1350_SCHEMA_2)',
'           and dc.table_name not like ''BIN$%''',
'           and dc.table_name not like ''DR$%''',
'           and dc.index_name = di.index_name',
'           and dc.index_owner = di.owner ',
'           and (:P1350_SEARCH is null or instr(upper(dc.table_name),upper(:P1350_SEARCH))>0)',
'           and (:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''INDEX'')',
'           )',
'    group by table_name,table_owner,index_name,uniqueness, status,',
'             index_type, temporary, partitioned,funcidx_status, join_index',
') idx',
'group by object_name, table_name)',
'full_query',
'where (',
'      nvl(:P1350_SHOW_DELTA,''N'')=''N'' or ',
'      (nvl(:P1350_SHOW_DELTA,''N'')=''Y'' and schema1 != schema2)',
'      )',
'order by 1, 2'))
,p_display_when_condition=>'nvl(:P1350_SCHEMA_1,''0'') != ''0'' and nvl(:P1350_SCHEMA_2,''0'') != ''0'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Il report non contiene dati'
,p_query_num_rows_item=>'P1350_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Stampa'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width_units=>'PERCENTAGE'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&PRODUCT_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_query_exp_filename=>'schemacompare.csv'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14722611958002774.4504)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo di oggetto'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(20432031610471969.4504)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome oggetto'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P1350_SEARCH.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14654425108650367.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Dettagli'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P1350_SEARCH.'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P1350_SHOW_DETAILS'
,p_display_when_condition2=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14710629254856310.4504)
,p_query_column_id=>4
,p_column_alias=>'SCHEMA1'
,p_column_display_sequence=>4
,p_column_heading=>'Schema 1'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14710719432856310.4504)
,p_query_column_id=>5
,p_column_alias=>'SCHEMA2'
,p_column_display_sequence=>5
,p_column_heading=>'Schema 2'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14649315374625282.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(14640703422583946.4504)
,p_button_name=>'P1350_GO'
,p_button_static_id=>'P1350_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Confronta'
,p_button_position=>'NEXT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14649526303625283.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1350:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14644528141600532.4504)
,p_name=>'P1350_SCHEMA_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(14640703422583946.4504)
,p_prompt=>'Schema 1'
,p_source=>'upper(wwv_flow_user_api.get_default_schema)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare uno schema da confrontare da una lista basata sugli schemi disponibili per l''area di lavoro.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14646929311610356.4504)
,p_name=>'P1350_SCHEMA_2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(14640703422583946.4504)
,p_prompt=>'Schema 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona schema -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare uno schema da confrontare da una lista basata sugli schemi disponibili per l''area di lavoro.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14648208102623119.4504)
,p_name=>'P1350_COMPARE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(14640703422583946.4504)
,p_prompt=>'Confronta'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SCHEMA COMPARE CATEGORIES'
,p_lov=>'.'||wwv_flow_api.id(14728126072025797.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Tutto -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identificare il tipo di oggetto di database da confrontare e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14651704770631707.4504)
,p_name=>'P1350_SEARCH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(14640703422583946.4504)
,p_prompt=>'Cerca'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Per cercare un oggetto, immettere un nome senza distinzione tra maiuscole e minuscole e fare clic su <strong>Vai</strong>. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14843209188019369.4504)
,p_name=>'P1350_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(14640703422583946.4504)
,p_item_default=>'20'
,p_prompt=>'Righe'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_B'
,p_lov=>'.'||wwv_flow_api.id(88008910861280555.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>'P1300_VIEW'
,p_display_when2=>'TREE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare il numero di righe da visualizzare e fare clic su <strong>Vai</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14846617284031121.4504)
,p_name=>'P1350_SHOW_DELTA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(14640703422583946.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SHOW DIFFERENCE ONLY CHECKBOX'
,p_lov=>'.'||wwv_flow_api.id(14974704196733524.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20434508323484132.4504)
,p_name=>'P1350_SHOW_DETAILS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(14640703422583946.4504)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SHOW DETAILS CHECKBOX'
,p_lov=>'.'||wwv_flow_api.id(20435801528491678.4504)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14741310928078139.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14973521034728897.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P1350_SCHEMA_1,''0'') != ''0'' then',
'wwv_flow_sw_api.check_priv(:P1350_SCHEMA_1);',
'end if;',
'if nvl(:P1350_SCHEMA_2,''0'') != ''0'' then',
'wwv_flow_sw_api.check_priv(:P1350_SCHEMA_2);',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01401
begin
wwv_flow_api.create_page(
 p_id=>1401.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Privilegi di oggetto'
,p_step_title=>'Privilegi di oggetto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276009919979760075)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8930331192104360.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19407804003066810.4504)
,p_plug_name=>'Tutti i privilegi delle schede'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'GRANTOR,',
'GRANTEE,',
'TABLE_NAME,',
'PRIVILEGE,',
'GRANTABLE',
'from sys.user_tab_privs',
'where',
'(grantor = :P1401_SCHEMA or grantee = :P1401_SCHEMA) '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1401_SCHEMA'
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'P1401_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(19407932308066810.4504)
,p_name=>'All Tab Privs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(19408129440066938.4504)
,p_db_column_name=>'GRANTOR'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Concedente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(19408221393066943.4504)
,p_db_column_name=>'GRANTEE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Assegnatario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(19408332550066943.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nome tabella'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(19408400366066943.4504)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Privilegio'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(19408502099066944.4504)
,p_db_column_name=>'GRANTABLE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Assegnabile'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722740039977798628.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(19407804003066810.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8938919971162017.4504)
,p_branch_action=>'f?p=&FLOW_ID.:1401:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8931603403115248.4504)
,p_name=>'P1401_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8930331192104360.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'nvl(wwv_flow_user_api.get_default_schema,:OB_SCHEMA)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema del database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112221103801863163.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1401_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1401_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69232127357694165.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1401_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
,p_process_when=>'P1401_SCHEMA'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
end;
/
prompt --application/pages/page_01402
begin
wwv_flow_api.create_page(
 p_id=>1402.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Privilegi di colonna'
,p_step_title=>'Privilegi di colonna'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28377513056022881.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441212808045963738.4504)
,p_plug_name=>'Tutti i privilegi colonna'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select grantor, grantee, table_name, column_name, privilege,',
'grantable',
'  from sys.user_col_privs',
' where (upper(grantor) = upper(:p1402_schema)',
'        or upper(grantee) = upper(:p1402_schema))'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1402_SCHEMA'
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'P1402_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441212915505963738.4504)
,p_name=>'All Col Privs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441213128313963754.4504)
,p_db_column_name=>'GRANTOR'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Concedente'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441213207272963755.4504)
,p_db_column_name=>'GRANTEE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Assegnatario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441213321567963755.4504)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nome tabella'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441213431235963756.4504)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nome colonna'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441213531369963757.4504)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Privilegio'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441213628578963758.4504)
,p_db_column_name=>'GRANTABLE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Assegnabile'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722739928414798627.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441212808045963738.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28429512607240356.4504)
,p_branch_action=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28300321967968632.4504)
,p_name=>'P1402_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(28377513056022881.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'nvl(wwv_flow_user_api.get_default_schema,:OB_SCHEMA)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema del database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(112226723325878216.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1402_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1402_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28427427020235094.4504)
,p_process_sequence=>99
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69234508441698183.4504)
,p_process_sequence=>109
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1402_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
,p_process_when=>'P1402_SCHEMA'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
end;
/
prompt --application/pages/page_01404
begin
wwv_flow_api.create_page(
 p_id=>1404.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Privilegi di sistema'
,p_step_title=>'Privilegi di sistema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276009919979760075)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30630307037341820.4504)
,p_plug_name=>'Privilegi SYS utenti'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username grantee, privilege, admin_option ',
'  from sys.user_sys_privs ',
' where username = :P1404_SCHEMA'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1404_SCHEMA'
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'P1404_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(30630407492341820.4504)
,p_name=>'User Sys Privs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30630625932341868.4504)
,p_db_column_name=>'GRANTEE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Assegnatario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30630716656341874.4504)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Privilegio'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30630808201341874.4504)
,p_db_column_name=>'ADMIN_OPTION'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Admin Option'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150985103138335771.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722739709913798625.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(30630307037341820.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(150987612640335791.4504)
,p_branch_action=>'f?p=&APP_ID.:1404:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150985502980335774.4504)
,p_name=>'P1404_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(150985103138335771.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'nvl(wwv_flow_user_api.get_default_schema,:OB_SCHEMA)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema del database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(150987232512335786.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1404_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1404_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69255828405770104.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1404_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Convalida schema'
,p_process_when=>'P1404_SCHEMA'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
end;
/
prompt --application/pages/page_01502
begin
wwv_flow_api.create_page(
 p_id=>1502.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Privilegi di ruolo'
,p_step_title=>'Privilegi di ruolo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(276009919979760075)
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8974807332440625.4504)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(441216315087051564.4504)
,p_plug_name=>'Privilegi di ruolo'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'username GRANTEE,',
'GRANTED_ROLE,',
'ADMIN_OPTION,',
'DEFAULT_ROLE',
'from sys.USER_ROLE_PRIVS',
'where username = :P1502_schema'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1502_SCHEMA'
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'P1502_schema'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(441216418813051564.4504)
,p_name=>'Role Privileges'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441216721271051571.4504)
,p_db_column_name=>'GRANTED_ROLE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Ruolo concesso'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441216829439051572.4504)
,p_db_column_name=>'ADMIN_OPTION'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Opzione di amministrazione'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441216900766051573.4504)
,p_db_column_name=>'DEFAULT_ROLE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Ruolo predefinito'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(441216616979051570.4504)
,p_db_column_name=>'GRANTEE'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>'Assegnatario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(722739854916798626.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(441216315087051564.4504)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Reimposta'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138867815025815665.4504)
,p_branch_action=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8976932612447907.4504)
,p_name=>'P1502_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8974807332440625.4504)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema del database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(69251110828746190.4504)
,p_computation_sequence=>10
,p_computation_item=>'P1502_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>'P1502_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69249227319741483.4504)
,p_process_sequence=>109
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1502_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Schema non valido'
,p_process_when=>'P1502_schema'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
end;
/
prompt --application/pages/page_02001
begin
wwv_flow_api.create_page(
 p_id=>2001.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'OB_DATA_FEED_OBJECTS'
,p_alias=>'OB_DATA_FEED_OBJECTS'
,p_step_title=>'OB_DATA_FEED_OBJECTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11539602725985552)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_brows.htm'
,p_page_comment=>'Page Items of this page are used by an application process used by Object Browser. Don''t delete! -Patrick'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11545303511042525.4504)
,p_plug_name=>'Object Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11545932601050949.4504)
,p_name=>'P2001_FEED_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11545303511042525.4504)
,p_prompt=>'Tipo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11546117846050959.4504)
,p_name=>'P2001_FEED_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(11545303511042525.4504)
,p_prompt=>'Proprietario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11546332706050962.4504)
,p_name=>'P2001_FEED_START'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(11545303511042525.4504)
,p_prompt=>'Avvio'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11546525225050977.4504)
,p_name=>'P2001_FEED_STOP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(11545303511042525.4504)
,p_prompt=>'Arresta'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11546718928050978.4504)
,p_name=>'P2001_FEED_DISPLAY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(11545303511042525.4504)
,p_prompt=>'Visualizza'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11546905323050998.4504)
,p_name=>'P2001_FEED_INCLUDE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(11545303511042525.4504)
,p_prompt=>'Includi'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11547117493050998.4504)
,p_name=>'P2001_FEED_ONCLICK'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(11545303511042525.4504)
,p_prompt=>'OnClick'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11547331758050999.4504)
,p_name=>'P2001_FEED_CLASS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(11545303511042525.4504)
,p_prompt=>'Classe'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(6693608793786901.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
prompt --application/pages/page_02100
begin
wwv_flow_api.create_page(
 p_id=>2100.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dettagli tabella'
,p_alias=>'TABLE_DETAIL'
,p_step_title=>'Dettagli tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( ''body'' ).on( ''click'', ''#B173569480899980905'', function() {',
'    // BUG 31091609: Appending behavior on Sample Queries since first load does not attach it.',
'    apex.util.getTopApex().navigation.redirect(''f?p=&APP_ID.:1003:&SESSION.:TABLE_QUERY:&DEBUG.'');',
'});'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'body .a-Report-wrap {',
'    float: none;',
'}'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6377926652423915.4504)
,p_plug_name=>'Azioni'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>15
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(6375626175414380.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11749022198908616.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(12048400172532158.4504)
,p_name=>'Dettagli'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name,',
'  case when data_type = ''CHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''VARCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''VARCHAR2'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NUMBER'' then',
'      case when c.data_precision is null then',
'          ''NUMBER''',
'      else',
'          data_type||''(''||c.data_precision||'',''||c.data_SCALE||'')''',
'      end',
'    when data_type = ''NVARCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NVARCHAR2'' then',
'      data_type||''(''||c.char_length||'')''',
'    else',
'      data_type',
'    end data_type,',
'  nullable,',
'  c.DATA_DEFAULT,',
'   sub.column_position pk',
'  from sys.dba_tab_columns c,',
' (select a.column_name, a.column_position',
'  from sys.dba_ind_columns a,',
'       sys.dba_constraints b',
' where a.index_owner = :OB_SCHEMA',
'   and a.index_name = b.index_name',
'   and b.owner = :OB_SCHEMA',
'   and b.constraint_type = ''P''',
'   and b.table_name = :OBJECT_NAME) sub',
' where c.column_name = sub.column_name(+)',
'   and c.owner      = :OBJECT_OWNER',
'   and c.table_name =  :OBJECT_NAME',
'   and c.column_id is not null',
'  order by sub.column_position,column_id'))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>50000
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Stampa'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&PRODUCT_NAME.',
'&OB_SCHEMA..&OBJECT_NAME.'))
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#cfdccf'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1879030682248539.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome colonna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'40'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1879118685248539.4504)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo dati'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1879225670248539.4504)
,p_query_column_id=>3
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Annullabile'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(23482928300634173)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'10'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1879312253248539.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_DEFAULT'
,p_column_display_sequence=>4
,p_column_heading=>'Valore predefinito'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1879422756248540.4504)
,p_query_column_id=>5
,p_column_alias=>'PK'
,p_column_display_sequence=>5
,p_column_heading=>'Chiave primaria'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'10'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181181313634038466.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object details'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_02101
begin
wwv_flow_api.create_page(
 p_id=>2101.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_DATA'
,p_alias=>'TABLE_DATA'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11777104686064400.4504)
,p_plug_name=>'Table Tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(12263304791753728.4504)
,p_name=>'Dati'
,p_template=>wwv_flow_api.id(737759501522573640.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  v_sql varchar2(32767) := '' dual'';',
'  v_min number;',
'begin',
'  wwv_flow_sw_api.check_priv(:OBJECT_OWNER);',
'  for r in (  select owner,',
'                     object_name',
'                from sys.dba_objects ',
'                where object_id = :OB_OBJECT_NAME ) loop',
'      v_sql := wwv_flow_assert.enquote_name(r.owner)||''.''||wwv_flow_assert.enquote_name(r.object_name);',
'  end loop;',
'  wwv_flow.debug(''select ''||replace(:P2101_COLUMNS,''^'','','')||'' from ''||v_sql);',
'  return ''select ''||replace(substr(:P2101_COLUMNS,2),''^'','','')||'' from ''||v_sql;',
'end;'))
,p_display_when_condition=>'COUNT'
,p_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_header=>'<div class="fielddata">&P2101_MESSAGE.</div>'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(2251716882439710.4504)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'<span class="instructiontext">Questa tabella non contiene dati.</span>'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'N'
,p_plug_query_exp_filename=>'&OBJECT_NAME..csv'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12335320167543587.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>'nvl(v(''request''),''x'') not like ''FLOW_EXCEL%'''
,p_display_when_condition2=>'PLSQL'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12335422008543596.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12335510273543596.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12335615707543596.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12335714623543599.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12335803022543600.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12335900878543600.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336003122543600.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336121379543600.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336215199543600.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336309301543600.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336400423543600.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336514702543601.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336619148543601.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336731629543601.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336805109543601.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12336919029543601.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337029318543601.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337110678543601.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337226602543602.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337301044543602.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337423977543602.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337514945543602.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337612902543602.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337731128543604.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337809112543604.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12337922883543605.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338026903543605.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338112751543605.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338222233543605.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338328251543605.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338407794543605.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338531437543606.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338609522543606.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338719073543606.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338809461543606.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12338932063543606.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339017669543606.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339121682543606.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339221916543607.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339307189543607.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339411241543607.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339524506543607.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339605538543607.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339727755543607.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339819082543607.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12339905857543608.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340030586543608.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340120921543608.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340218883543608.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340311448543608.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340404877543608.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340502620543608.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340601273543609.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340714373543609.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340828981543609.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12340914244543609.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12341015803543610.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12341127564543610.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12341209849543610.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14094513658892729.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(14089426771868187.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(151456315081825472.4504)
,p_name=>'Count'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--xlarge'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'to_char(wwv_flow_f4000_util.countem(',
'  ''select count(1) from "''||:OBJECT_OWNER||''"."''||:OBJECT_NAME||''"'',',
'    :OBJECT_OWNER), ''999G999G99G999G999G999G999G990'') as count_objects',
'from dual'))
,p_display_when_condition=>'COUNT'
,p_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717423775712828084.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(470837723463277727.4504)
,p_query_column_id=>1
,p_column_alias=>'COUNT_OBJECTS'
,p_column_display_sequence=>1
,p_column_heading=>'Righe'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12265200551771419.4504)
,p_name=>'P2101_COLUMNS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(12263304791753728.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14082823907810538.4504)
,p_name=>'P2101_MESSAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(12263304791753728.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fielddata"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(24082851096996908.4504)
,p_name=>'Update Load Data to use getTopApex'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(24082949223996909.4504)
,p_event_id=>wwv_flow_api.id(24082851096996908.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var loadDataButton$ = $(''#load_data_btn'');',
'var btnLink = loadDataButton$.attr(''onclick'');',
'',
'loadDataButton$.attr(''onclick'',''javascript:apex.util.getTopApex().navigation'' + btnLink.substr(btnLink.indexOf(''.dialog'')));'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12266009339783471.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Cols '
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_owner varchar2(500);',
' l_name  varchar2(500);',
' i       number := 0;',
' l_max   number := 31;',
'begin',
':P2101_COLUMNS := ''  ''''<a href="f?p=4500:47:''',
'                      ||:session||'':::47,SW_QBE_UPDATE:P47_RETURN_TO,F4500_P47_ID:2101,''''||',
'                      wwv_flow_utilities.url_encode(rowid)||''''">',
'<img src="#IMAGE_PREFIX#e2.gif" border="0" height="18" width="18" alt="''||wwv_flow_lang.system_message(''EDIT'')||''" /></a>'''' ''||wwv_flow_lang.system_message(''EDIT'');',
'',
'',
'  for r in ( select column_name',
'             from sys.dba_tab_Columns ',
'             where owner       = :OBJECT_OWNER',
'             and   table_name  = :OBJECT_NAME',
'             and   column_id is not null',
'             order by  column_id ) loop',
'    i := i +1;',
'   exit when i >l_max;',
'   :P2101_COLUMNS := :P2101_COLUMNS ||''^"''||r.column_name||''"'';',
'  end loop;',
'/*',
'',
'  if i >l_max then ',
'     :P2101_MESSAGE  := ''<div class="fielddata">''||',
'       wwv_flow_lang.system_message(p_name=>''4500_OBJECT_BROWSER_ONLY_N_COLS'',p0=>l_max)',
'       ||''</div>'';',
'   else',
'     :P2101_MESSAGE  := '''';',
'   end if;',
'',
'*/',
'  if i >l_max then ',
'     :P2101_MESSAGE  :=     wwv_flow_lang.system_message(p_name=>''4500_OBJECT_BROWSER_ONLY_N_COLS'',p0=>l_max);',
'   else',
'     :P2101_MESSAGE  := '''';',
'   end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13728901523596854.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'RP'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'NO_RP'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
end;
/
prompt --application/pages/page_02102
begin
wwv_flow_api.create_page(
 p_id=>2102.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_INDEXES'
,p_alias=>'TABLE_INDEXES'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5737432600960966.4504)
,p_name=>'Indici'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with index_cols as (',
'    select table_owner,',
'           index_name,',
'           uniqueness,',
'           status,',
'           index_type,',
'           temporary,',
'           partitioned,',
'           funcidx_status,',
'           join_index,',
'           max(decode(position, 1, column_name))||',
'           max(decode(position, 2, '', ''||column_name))||',
'           max(decode(position, 3, '', ''||column_name))||',
'           max(decode(position, 4, '', ''||column_name))||',
'           max(decode(position, 5, '', ''||column_name))||',
'           max(decode(position, 6, '', ''||column_name))||',
'           max(decode(position, 7, '', ''||column_name))||',
'           max(decode(position, 8, '', ''||column_name)) as columns',
'      from ( select :OBJECT_OWNER as table_owner,',
'                    dc.index_name,',
'                    di.uniqueness,',
'                    di.status,',
'                    di.index_type,',
'                    di.temporary,',
'                    di.partitioned,',
'                    di.funcidx_status,',
'                    di.join_index,',
'                    dc.column_name,',
'                    dc.column_position position',
'               from sys.user_ind_columns dc,',
'                    sys.user_indexes di',
'              where dc.table_name = :OBJECT_NAME',
'                and di.index_name = dc.index_name',
'           )',
'     group by table_owner,',
'              index_name,',
'              uniqueness,',
'              status,',
'              index_type,',
'              temporary,',
'              partitioned,',
'              funcidx_status,',
'              join_index',
')',
'select ic.table_owner as owner,',
'       ic.index_name,',
'       ic.columns,',
'       ic.uniqueness,',
'       ic.status,',
'       ic.index_type,',
'       ic.temporary,',
'       ic.partitioned,',
'       ic.funcidx_status,',
'       ic.join_index,',
'       do.object_id',
'  from index_cols ic,',
'       sys.user_objects do',
' where do.object_name = ic.index_name',
'   and do.object_type = ''INDEX'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa tabella non ha indici.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner, index_name, ',
'(select column_name from sys.dba_ind_columns c where di.index_name = c.index_name and di.table_owner = c.table_owner and column_position = 1)||',
'(select '', ''||column_name from sys.dba_ind_columns c where di.index_name = c.index_name and di.table_owner = c.table_owner and column_position = 2)||',
'(select '', ''||column_name from sys.dba_ind_columns c where di.index_name = c.index_name and di.table_owner = c.table_owner and column_position = 3)||',
'(select '', ''||column_name from sys.dba_ind_columns c where di.index_name = c.index_name and di.table_owner = c.table_owner and column_position = 4)||',
'(select '', ''||column_name from sys.dba_ind_columns c where di.index_name = c.index_name and di.table_owner = c.table_owner and column_position = 5)',
' columns, uniqueness, status',
'       ,INDEX_TYPE, TEMPORARY, PARTITIONED, ',
'      funcidx_status, join_index,',
'   (select object_id ',
'      from sys.dba_objects  do',
'      where object_type = ''INDEX'' ',
'      and   do.owner = di.owner',
'      and   object_name = index_name ) object_id',
'from   sys.dba_INDEXES di',
'where  table_owner = :OBJECT_OWNER',
'and    table_name  =  :OBJECT_NAME '))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5737721413961211.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Owner'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5737811031961211.4504)
,p_query_column_id=>2
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome indice'
,p_column_link=>'f?p=&APP_ID.:INDEX_DETAIL:&SESSION.:FOCUS:&DEBUG.::OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#INDEX_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(182862813940904141.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>4
,p_column_heading=>'Colonne'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5737918899961211.4504)
,p_query_column_id=>4
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Univocit\00E0')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5738004733961211.4504)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Stato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5738100229961211.4504)
,p_query_column_id=>6
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo indice'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5738216127961212.4504)
,p_query_column_id=>7
,p_column_alias=>'TEMPORARY'
,p_column_display_sequence=>7
,p_column_heading=>'Temporanea'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5738313035961212.4504)
,p_query_column_id=>8
,p_column_alias=>'PARTITIONED'
,p_column_display_sequence=>8
,p_column_heading=>'Partizionata'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5738420010961212.4504)
,p_query_column_id=>9
,p_column_alias=>'FUNCIDX_STATUS'
,p_column_display_sequence=>9
,p_column_heading=>'Stato funzione'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5738531782961212.4504)
,p_query_column_id=>10
,p_column_alias=>'JOIN_INDEX'
,p_column_display_sequence=>10
,p_column_heading=>'Indice di join'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5738606720961212.4504)
,p_query_column_id=>11
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>11
,p_column_heading=>'Object ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11776017714058770.4504)
,p_plug_name=>'Table Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14923522906140464.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(14921315593135016.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181291013960287548.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21987824378524793.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02103
begin
wwv_flow_api.create_page(
 p_id=>2103.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_MODEL'
,p_alias=>'TABLE_MODEL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5739706197972237.4504)
,p_plug_name=>'Model'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_table_drill.draw_data_model (',
'    p_owner      =>:OBJECT_OWNER,',
'    p_table_name =>:OBJECT_NAME,',
'    p_session    =>:SESSION,',
'    p_page       =>2103,',
'    p_request    =>''GETOBJECT'',',
'    p_clear_cache=>''RP'',',
'    p_item_oid   =>''OB_OBJECT_ID''',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11777711612066487.4504)
,p_plug_name=>'Table Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181177413232934247.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object details'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'GETOBJECT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_02104
begin
wwv_flow_api.create_page(
 p_id=>2104.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_CONSTRAINTS'
,p_alias=>'TABLE_CONSTRAINTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5770727255498748.4504)
,p_name=>'Constraints'
,p_display_sequence=>30
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with constraint_cols as(',
'    select owner, constraint_name, table_name,',
'           max(decode(position,1 ,column_name))||',
'           max(decode(position,2 ,'', ''||column_name))||',
'           max(decode(position,3 ,'', ''||column_name))||',
'           max(decode(position,4 ,'', ''||column_name))||',
'           max(decode(position,5 ,'', ''||column_name))||',
'           max(decode(position,6 ,'', ''||column_name))||',
'           max(decode(position,7 ,'', ''||column_name))||',
'           max(decode(position,8 ,'', ''||column_name))',
'           columns',
'     from(',
'        select :OBJECT_OWNER as owner, dc.constraint_name, dc.table_name, dcc.position, dcc.column_name',
'          from sys.user_cons_columns dcc, sys.user_constraints dc',
'         where dc.table_name      = :OBJECT_NAME',
'           and dc.constraint_name = dcc.constraint_name',
'           and dc.table_name      = dcc.table_name)',
'    group by owner, constraint_name, table_name',
')',
'select c.owner,',
'       c.constraint_name,',
'       decode(c.constraint_type,',
'              ''P'',wwv_flow_lang.system_message(''F4500_PRIMARY''),',
'              ''U'',wwv_flow_lang.system_message(''F4500_UNIQUE''),',
'              ''C'',wwv_flow_lang.system_message(''F4500_CHECK''),',
'              ''R'',wwv_flow_lang.system_message(''F4500_FOREIGN''),',
'              c.constraint_type)  constraint_type,',
'       c.table_name,',
'       c.search_condition,',
'       c.r_owner,',
'       c.r_constraint_name,',
'       c.delete_rule,',
'       c.status,',
'       c.deferrable,',
'       c.deferred,',
'       c.validated,',
'       c.generated,',
'       c.bad,',
'       c.rely,',
'       c.last_change,',
'       c.index_owner,',
'       c.index_name,',
'       c.invalid,',
'       c.view_related,',
'       case when c.constraint_type = ''R'' then',
'           ( select c.constraint_name||'' (''||r.owner||''.''||r.table_name||'')''',
'               from apex_sys_all_constraints r',
'              where r.owner           = c.r_owner',
'                and r.constraint_name = c.r_constraint_name',
'           )',
'       end as "Related Table",',
'       cc.columns',
'  from sys.user_constraints c, constraint_cols cc',
' where c.table_name       = :OBJECT_NAME',
'   and cc.table_name      = :OBJECT_NAME',
'   and cc.constraint_name = c.constraint_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa tabella non ha vincoli.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.OWNER,',
'       c.CONSTRAINT_NAME,',
'       decode(c.constraint_type,',
'              ''P'',wwv_flow_lang.system_message(''F4500_PRIMARY''),',
'              ''U'',wwv_flow_lang.system_message(''F4500_UNIQUE''),',
'              ''C'',wwv_flow_lang.system_message(''F4500_CHECK''),',
'              ''R'',wwv_flow_lang.system_message(''F4500_FOREIGN''),',
'              c.CONSTRAINT_TYPE)  CONSTRAINT_TYPE,',
'       c.TABLE_NAME,',
'       c.SEARCH_CONDITION,',
'       c.R_OWNER,',
'       c.R_CONSTRAINT_NAME,',
'       c.DELETE_RULE,',
'       c.STATUS,',
'       c.DEFERRABLE,',
'       c.DEFERRED,',
'       c.VALIDATED,',
'       c.GENERATED,',
'       c.BAD,',
'       c.RELY,',
'       c.LAST_CHANGE,',
'       c.INDEX_OWNER,',
'       c.INDEX_NAME,',
'       c.INVALID,',
'       c.VIEW_RELATED,',
'       (select c.r_owner||''.''||r.table_name||''.''||c.r_constraint_name',
'          from sys.dba_constraints r',
'         where c.constraint_type   = ''R''',
'           and c.r_owner           = r.owner',
'           and c.r_constraint_name = r.constraint_name) "Related Table"',
'  from sys.dba_constraints c',
' where c.table_name = :OBJECT_NAME',
'   and c.owner      = :OBJECT_OWNER'))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771008472498757.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Owner'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771112598498757.4504)
,p_query_column_id=>2
,p_column_alias=>'CONSTRAINT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Vincolo'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771203493498757.4504)
,p_query_column_id=>3
,p_column_alias=>'CONSTRAINT_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771307922498757.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Table'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771401388498757.4504)
,p_query_column_id=>5
,p_column_alias=>'SEARCH_CONDITION'
,p_column_display_sequence=>5
,p_column_heading=>'Condizione di ricerca'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771505514498757.4504)
,p_query_column_id=>6
,p_column_alias=>'R_OWNER'
,p_column_display_sequence=>6
,p_column_heading=>'Related Table Owner'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771615044498757.4504)
,p_query_column_id=>7
,p_column_alias=>'R_CONSTRAINT_NAME'
,p_column_display_sequence=>8
,p_column_heading=>'Related Constraint'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771704381498757.4504)
,p_query_column_id=>8
,p_column_alias=>'DELETE_RULE'
,p_column_display_sequence=>10
,p_column_heading=>'Elimina regola'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771803318498757.4504)
,p_query_column_id=>9
,p_column_alias=>'STATUS'
,p_column_display_sequence=>11
,p_column_heading=>'Stato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5771916334498757.4504)
,p_query_column_id=>10
,p_column_alias=>'DEFERRABLE'
,p_column_display_sequence=>12
,p_column_heading=>'Deferrable'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772019622498758.4504)
,p_query_column_id=>11
,p_column_alias=>'DEFERRED'
,p_column_display_sequence=>13
,p_column_heading=>'Deferred'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772129046498758.4504)
,p_query_column_id=>12
,p_column_alias=>'VALIDATED'
,p_column_display_sequence=>14
,p_column_heading=>'Validated'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772212672498758.4504)
,p_query_column_id=>13
,p_column_alias=>'GENERATED'
,p_column_display_sequence=>15
,p_column_heading=>'Generated'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772320212498758.4504)
,p_query_column_id=>14
,p_column_alias=>'BAD'
,p_column_display_sequence=>16
,p_column_heading=>'Bad'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772412849498758.4504)
,p_query_column_id=>15
,p_column_alias=>'RELY'
,p_column_display_sequence=>17
,p_column_heading=>'Rely'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772521270498758.4504)
,p_query_column_id=>16
,p_column_alias=>'LAST_CHANGE'
,p_column_display_sequence=>18
,p_column_heading=>'Ultima modifica'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772603863498758.4504)
,p_query_column_id=>17
,p_column_alias=>'INDEX_OWNER'
,p_column_display_sequence=>19
,p_column_heading=>'Index Owner'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772730552498758.4504)
,p_query_column_id=>18
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Indice'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772817711498759.4504)
,p_query_column_id=>19
,p_column_alias=>'INVALID'
,p_column_display_sequence=>21
,p_column_heading=>'Non valido'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5772931970498759.4504)
,p_query_column_id=>20
,p_column_alias=>'VIEW_RELATED'
,p_column_display_sequence=>22
,p_column_heading=>'View Related'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109411509099099402.4504)
,p_query_column_id=>21
,p_column_alias=>'Related Table'
,p_column_display_sequence=>7
,p_column_heading=>'Vincolo correlato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(29303816211191964.4504)
,p_query_column_id=>22
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>9
,p_column_heading=>'Colonne'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11778318538068410.4504)
,p_plug_name=>'Table Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14994232369351385.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(14992414558348243.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21988108064567463.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02105
begin
wwv_flow_api.create_page(
 p_id=>2105.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_GRANTS'
,p_alias=>'TABLE_GRANTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11780423302438893.4504)
,p_plug_name=>'Table Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(13966119752109187.4504)
,p_name=>'Query'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, COLUMN_NAME object_name',
'from sys.user_col_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME =  :OBJECT_NAME ',
'union all',
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, table_NAME object_name',
'from sys.user_tab_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa tabella non ha concessioni di privilegi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13966428852109197.4504)
,p_query_column_id=>1
,p_column_alias=>'PRIVILEGE'
,p_column_display_sequence=>1
,p_column_heading=>'Privilegio'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13966501551109197.4504)
,p_query_column_id=>2
,p_column_alias=>'GRANTEE'
,p_column_display_sequence=>2
,p_column_heading=>'Assegnatario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13966604918109197.4504)
,p_query_column_id=>3
,p_column_alias=>'GRANTABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Assegnabile'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13966715035109197.4504)
,p_query_column_id=>4
,p_column_alias=>'GRANTOR'
,p_column_display_sequence=>4
,p_column_heading=>'Concedente'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13966825250109197.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nome oggetto'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15240212728918941.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(15238925543915636.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21988430489592836.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02106
begin
wwv_flow_api.create_page(
 p_id=>2106.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_STATISTICS'
,p_alias=>'TABLE_STATISTICS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5740810746001985.4504)
,p_name=>'Statistiche tabelle'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch:a-Report--rowHighlight'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select num_rows,',
'       blocks,',
'       avg_row_len,',
'       sample_size,',
'       last_analyzed,',
'       last_analyzed last_analyzed_since',
'  from sys.user_tables',
' where table_name = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5741131297001992.4504)
,p_query_column_id=>1
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>1
,p_column_heading=>'Righe'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5741203852001992.4504)
,p_query_column_id=>2
,p_column_alias=>'BLOCKS'
,p_column_display_sequence=>2
,p_column_heading=>'Blocchi'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5741326510001992.4504)
,p_query_column_id=>3
,p_column_alias=>'AVG_ROW_LEN'
,p_column_display_sequence=>3
,p_column_heading=>'Lunghezza media righe'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5741411337001992.4504)
,p_query_column_id=>4
,p_column_alias=>'SAMPLE_SIZE'
,p_column_display_sequence=>4
,p_column_heading=>'Dimensione campione'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5741506995001992.4504)
,p_query_column_id=>5
,p_column_alias=>'LAST_ANALYZED'
,p_column_display_sequence=>5
,p_column_heading=>'Last Analyzed'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5741619473001992.4504)
,p_query_column_id=>6
,p_column_alias=>'LAST_ANALYZED_SINCE'
,p_column_display_sequence=>6
,p_column_heading=>'Ultima analisi'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11781030228440851.4504)
,p_plug_name=>'Table Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15127116906630777.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(15123613473622266.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(525109117816577111.4504)
,p_name=>'Statistiche colonne'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch:a-Report--rowHighlight'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name,',
'       data_type,',
'       num_distinct,',
'       decode(data_type,''BLOB'',null,''CLOB'',null,''RAW'',null,data_length) data_length,',
'       data_precision,',
'       data_scale,',
'       density,',
'       num_nulls,',
'       num_buckets,',
'       last_analyzed,',
'       sample_size',
'  from sys.user_tab_columns',
' where table_name = :OBJECT_NAME',
'order by column_name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>1200
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525109808941577118.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome colonna'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525109997018577119.4504)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo dati'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525110074412577120.4504)
,p_query_column_id=>3
,p_column_alias=>'NUM_DISTINCT'
,p_column_display_sequence=>6
,p_column_heading=>'Distinti'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525110433820577124.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>3
,p_column_heading=>'Lunghezza dati'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525110556070577125.4504)
,p_query_column_id=>5
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>4
,p_column_heading=>'Precisione dati'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525110672204577126.4504)
,p_query_column_id=>6
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>5
,p_column_heading=>'Scala dati'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525110128204577121.4504)
,p_query_column_id=>7
,p_column_alias=>'DENSITY'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Densit\00E0')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D000000'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525110222474577122.4504)
,p_query_column_id=>8
,p_column_alias=>'NUM_NULLS'
,p_column_display_sequence=>8
,p_column_heading=>'Valori nulli'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525110353974577123.4504)
,p_query_column_id=>9
,p_column_alias=>'NUM_BUCKETS'
,p_column_display_sequence=>9
,p_column_heading=>'Bucket'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525109685084577116.4504)
,p_query_column_id=>10
,p_column_alias=>'LAST_ANALYZED'
,p_column_display_sequence=>11
,p_column_heading=>'Ultima analisi'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525109543546577115.4504)
,p_query_column_id=>11
,p_column_alias=>'SAMPLE_SIZE'
,p_column_display_sequence=>10
,p_column_heading=>'Dimensione campione'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21988715168607353.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02108
begin
wwv_flow_api.create_page(
 p_id=>2108.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_TRIGGERS'
,p_alias=>'TABLE_TRIGGERS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11783903824452123.4504)
,p_plug_name=>'Table Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(13972326940130133.4504)
,p_name=>'Query'
,p_display_sequence=>20
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dt.trigger_name,',
'       dt.trigger_type,',
'       dt.triggering_event,',
'       dt.status,',
'       do.object_id',
'  from sys.user_triggers dt,',
'       sys.user_objects do',
' where do.object_type = ''TRIGGER''',
'   and dt.table_name  = :object_name',
'   and do.object_name = dt.trigger_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa tabella non ha trigger.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13977117506146337.4504)
,p_query_column_id=>1
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome trigger'
,p_column_link=>'f?p=&APP_ID.:2500:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#TRIGGER_NAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14048009662427951.4504)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo di trigger'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14048129455427951.4504)
,p_query_column_id=>3
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>4
,p_column_heading=>'Evento di trigger'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14048227083427952.4504)
,p_query_column_id=>4
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Stato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14045005066369887.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15142002445307800.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(15140917230304234.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21989325566685954.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02109
begin
wwv_flow_api.create_page(
 p_id=>2109.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_DEPENDENCIES'
,p_alias=>'TABLE_DEPENDENCIES'
,p_step_title=>'Dipendenze della tabella'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1371684178674206.4504)
,p_name=>'Sincronizzazioni REST'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.application_id,',
'       w.application_name,',
'       w.module_name,',
'       w.sync_interval,',
'       w.sync_is_active,',
'       w.last_synchronization,',
'       w.next_synchronization',
'  from apex_appl_web_src_modules w, apex_applications a',
' where a.application_id = w.application_id',
'   and sync_table_name = :OBJECT_NAME',
'   and ( sync_table_owner = :OBJECT_OWNER or  ( :OBJECT_OWNER = a.owner and w.sync_table_owner is null ) )',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessuna origine dati REST in questa area di lavoro sincronizzata con questa tabella.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1372747492674217.4504)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID applicazione'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1372820760674218.4504)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome applicazione'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1372554734674215.4504)
,p_query_column_id=>3
,p_column_alias=>'MODULE_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Origine REST'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1372244994674212.4504)
,p_query_column_id=>4
,p_column_alias=>'SYNC_INTERVAL'
,p_column_display_sequence=>7
,p_column_heading=>'Intervallo di job'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1372961947674219.4504)
,p_query_column_id=>5
,p_column_alias=>'SYNC_IS_ACTIVE'
,p_column_display_sequence=>6
,p_column_heading=>'Attivo'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(23482928300634173)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1373062379674220.4504)
,p_query_column_id=>6
,p_column_alias=>'LAST_SYNCHRONIZATION'
,p_column_display_sequence=>8
,p_column_heading=>'Ultima sincronizzazione'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1373111332674221.4504)
,p_query_column_id=>7
,p_column_alias=>'NEXT_SYNCHRONIZATION'
,p_column_display_sequence=>9
,p_column_heading=>'Sincronizzazione successiva'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5743708284048521.4504)
,p_name=>'Riferimenti'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dc2.owner as owner,',
'       dc2.table_name as table_name,',
'       (select ao.object_id from apex_sys_all_objects ao',
'          where dc2.owner      = ao.owner',
'            and dc2.table_name = ao.object_name ) object_id',
' from sys.user_constraints dc1,',
'      apex_sys_all_constraints dc2',
'where dc1.table_name      = :OBJECT_NAME',
'  and dc1.constraint_type = ''R''',
'  and dc2.owner           = dc1.r_owner',
'  and dc2.constraint_name = dc1.r_constraint_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa tabella non ha riferimenti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5744029103048539.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5744114552048539.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tabella'
,p_column_link=>'f?p=&APP_ID.:TABLE_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#TABLE_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5744204472048539.4504)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Object ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5745426208072699.4504)
,p_name=>'Riferimento proveniente da'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner, name, type, decode(type,''PACKAGE BODY'',''PACKAGE'',',
'                                 replace(type,'' '',''_'')) type_link,',
'          (select ao.object_id from apex_sys_all_objects ao',
'                          where dd.owner = ao.owner',
'                          and   dd.name  = ao.object_name',
'                          and   dd.type  = ao.object_type) object_id',
' from apex_sys_all_dependencies dd',
'where referenced_owner = :OBJECT_OWNER',
'  and referenced_type = :OBJECT_TYPE',
'  and referenced_name = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'A questa tabella non fanno riferimento altri oggetti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5745709897072710.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5745808414072710.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5745912622072710.4504)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5746010257072710.4504)
,p_query_column_id=>4
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>4
,p_column_heading=>'Type Link'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5746109152072710.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Object ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11775101784054165.4504)
,p_plug_name=>'Table Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(17843314391916747.4504)
,p_name=>'Sinonimi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner, synonym_name',
'  from apex_sys_all_synonyms',
' where table_owner = :OBJECT_OWNER',
'   and table_name  = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun sinonimo trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(17843503467916753.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(17843611242916753.4504)
,p_query_column_id=>2
,p_column_alias=>'SYNONYM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome sinonimo'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21989631453687716.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02110
begin
wwv_flow_api.create_page(
 p_id=>2110.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TABLE_DDL'
,p_alias=>'TABLE_DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5747212271087594.4504)
,p_plug_name=>'DDL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<pre class="code">'');',
'',
'wwv_flow_generate_ddl.execute_get_table_ddl (',
'    p_schema       => :OBJECT_OWNER,',
'    p_table_name   => :OBJECT_NAME',
'    );',
'',
'',
'sys.htp.p(''</pre>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11774220008049973.4504)
,p_plug_name=>'Table Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
end;
/
prompt --application/pages/page_02111
begin
wwv_flow_api.create_page(
 p_id=>2111.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'OBJECT_REST'
,p_alias=>'OBJECT_REST'
,p_step_title=>'OBJECT_REST'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(802775228359756685)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(182315576949728920.4504)
,p_plug_name=>'View Tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'VIEW'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(182315650272728921.4504)
,p_plug_name=>'PLSQL Tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(8047123559654396.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'TABLE:VIEW'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(243330632968719606.4504)
,p_plug_name=>'Barra dei pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_min_ords_version   varchar2(255);',
'    l_return             varchar2(32767);',
'    l_min_ver_met        varchar2(10);',
'    l_ords_version       varchar2(50);    ',
'',
'begin ',
'  -- Get the minimum ORDS version required for ORDS REST',
'  l_min_ords_version := wwv_flow_rest_ws.c_ords_major||''.''||',
'                        wwv_flow_rest_ws.c_ords_minor||''.''||',
'                        wwv_flow_rest_ws.c_ords_patch||''.''||',
'                        wwv_flow_rest_ws.c_ords_day||''.0.0'';',
'                        ',
'                        ',
'  -- If we didn''t find ORDS or We''re runnin in the CDB ',
'  if wwv_flow_rest_ws.get_db_type = ''CDB'' then ',
'        return FALSE;',
'  elsif wwv_flow_rest_ws.get_ords_version(wwv_flow_user_api.get_default_schema) = ''0.0.0.0.0.0'' then ',
'        return FALSE;',
'  -- We''re running ORDS but we need to make sure it''s the right version  ',
'  else',
'     l_ords_version := wwv_flow_rest_ws.get_ords_version(wwv_flow_user_api.get_default_schema);',
'     l_min_ver_met := wwv_flow_rest_ws.ords_min_ver_met(p_current_version => l_ords_version);',
'     -- Check to see if we''re running the minimum version ',
'     if l_min_ver_met = ''TRUE'' then ',
'        -- Check to see if the Schema is enabled',
'        l_return := wwv_flow_rest_ws.schema_is_ords_enabled(p_schema => :OBJECT_OWNER);',
'        if l_return = ''FALSE'' then ',
'            return FALSE;',
'        else ',
'            return TRUE;',
'        end if;',
'     else  -- Not the minimum version ',
'        return FALSE;',
'     end if;',
'  end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(243331455442719614.4504)
,p_plug_name=>'Messaggio ORDS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385893260111566687.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_min_ords_version   varchar2(255);',
'    l_return             varchar2(32767);',
'    l_min_ver_met        varchar2(10);',
'    l_ords_version       varchar2(50);    ',
'',
'begin ',
'  -- Get the minimum ORDS version required for ORDS REST',
'  l_min_ords_version := wwv_flow_rest_ws.c_ords_major||''.''||',
'                        wwv_flow_rest_ws.c_ords_minor||''.''||',
'                        wwv_flow_rest_ws.c_ords_patch||''.''||',
'                        wwv_flow_rest_ws.c_ords_day||''.0.0'';',
'                        ',
'                        ',
'  -- If we didn''t find ORDS or We''re runnin in the CDB ',
'  if wwv_flow_rest_ws.get_db_type = ''CDB'' then ',
'        wwv_flow_lang.system_message_p(''SQL_WS.OB.NO_REST_IN_CDB'', l_min_ords_version);',
'  elsif wwv_flow_rest_ws.get_ords_version(wwv_flow_user_api.get_default_schema) = ''0.0.0.0.0.0'' then ',
'      -- Otherwise we didn''t find ORDS so tell them.  ',
'      wwv_flow_lang.system_message_p(''SQL_WS.OB.ORDS_NOT_FOUND'');',
'  -- We''re running ORDS but we need to make sure it''s the right version  ',
'  else',
'     l_ords_version := wwv_flow_rest_ws.get_ords_version(wwv_flow_user_api.get_default_schema);',
'     l_min_ver_met := wwv_flow_rest_ws.ords_min_ver_met(p_current_version => l_ords_version);',
'     -- Check to see if we''re running the minimum version ',
'     if l_min_ver_met = ''TRUE'' then ',
'        -- Check to see if the Schema is enabled',
'        l_return := wwv_flow_rest_ws.schema_is_ords_enabled(p_schema => :OBJECT_OWNER);',
'        if l_return = ''FALSE'' then ',
'            wwv_flow_lang.system_message_p(''SQL_WS.OB.NOT_ORDS_ENABLED'');',
'        else ',
'            wwv_flow_lang.system_message_p(''SQL_WS.OB.ORDS_VERION'', l_ords_version);',
'        end if;',
'     else  -- Not the minimum version ',
'        wwv_flow_lang.system_message_p(''SQL_WS.OB.OLD_ORDS_VERSION'', l_ords_version, l_min_ords_version);',
'     end if;',
'  end if;',
'end;',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(249072655257785483.4504)
,p_plug_name=>'REST'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_min_ords_version   varchar2(255);',
'    l_return             varchar2(32767);',
'    l_min_ver_met        varchar2(10);',
'    l_ords_version       varchar2(50);    ',
'',
'begin ',
'  -- Get the minimum ORDS version required for ORDS REST',
'  l_min_ords_version := wwv_flow_rest_ws.c_ords_major||''.''||',
'                        wwv_flow_rest_ws.c_ords_minor||''.''||',
'                        wwv_flow_rest_ws.c_ords_patch||''.''||',
'                        wwv_flow_rest_ws.c_ords_day||''.0.0'';',
'                        ',
'                        ',
'  -- If we didn''t find ORDS or We''re runnin in the CDB ',
'  if wwv_flow_rest_ws.get_db_type = ''CDB'' then ',
'        return FALSE;',
'  elsif wwv_flow_rest_ws.get_ords_version(wwv_flow_user_api.get_default_schema) = ''0.0.0.0.0.0'' then ',
'        return FALSE;',
'  -- We''re running ORDS but we need to make sure it''s the right version  ',
'  else',
'     l_ords_version := wwv_flow_rest_ws.get_ords_version(wwv_flow_user_api.get_default_schema);',
'     l_min_ver_met := wwv_flow_rest_ws.ords_min_ver_met(p_current_version => l_ords_version);',
'     -- Check to see if we''re running the minimum version ',
'     if l_min_ver_met = ''TRUE'' then ',
'        -- Check to see if the Schema is enabled',
'        l_return := wwv_flow_rest_ws.schema_is_ords_enabled(p_schema => :OBJECT_OWNER);',
'        if l_return = ''FALSE'' then ',
'            return FALSE;',
'        else ',
'            return TRUE;',
'        end if;',
'     else  -- Not the minimum version ',
'        return FALSE;',
'     end if;',
'  end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(255099662994747862.4504)
,p_plug_name=>'Table Tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'TABLE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(243330545992719605.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(243330632968719606.4504)
,p_button_name=>'APPLY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(65555022831750610.4504)
,p_name=>'P2111_ERROR_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156404475494150747.4504)
,p_name=>'P2111_AUTHORIZATION_REQUIRED'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_item_default=>'TRUE'
,p_prompt=>'Autorizzazione obbligatoria'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES NO TRUE FALSE'
,p_lov=>'.'||wwv_flow_api.id(550748599416480697.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indica se agli utenti esterni che stanno tentando di accedere all''oggetto abilitato per RESTful deve essere assegnato il ruolo correlato. Il nome del ruolo viene visualizzato se l''opzione Autorizzazione richiesta \00E8 stata <strong>attivata</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(243330167057719601.4504)
,p_name=>'P2111_OBJECT_ALIAS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_item_default=>'lower(:OBJECT_NAME)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Alias oggetto'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Specificare l''alias da usare per l''oggetto selezionato. Questo alias sostituir\00E0 il nome dell''oggetto nell''URL RESTful.'),
'</br></br>',
unistr('Per motivi di sicurezza, \00E8 sempre preferibile fornire un alias diverso dal nome dell''oggetto sottostante.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(243330332675719603.4504)
,p_name=>'P2111_ENABLE_OBJECT'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_item_default=>'FALSE'
,p_prompt=>'Abilita oggetto per REST'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES NO TRUE FALSE'
,p_lov=>'.'||wwv_flow_api.id(550748599416480697.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indica se l''oggetto selezionato \00E8 abilitato (attivo) o meno (non attivo) per REST. Questo oggetto visualizzer\00E0 l''oggetto dall''URI RESTful indicato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(243330783371719607.4504)
,p_name=>'P2111_OBJECT_URI'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URI RESTful'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--small" onclick="void(0);" aria-label="&APP_TEXT$REST_WS_COPY_TO_CLIPBOARD_ARIA." type="button"  title="&APP_TEXT$REST_WS_COPY_TO_CLIPBOARD." data-clipboard-source="#P2111_OBJECT_U'
||'RI" style="margin-left:5px;"><span class="a-Icon icon-copy" aria-hidden="true"></span></button>',
''))
,p_source=>'&P2111_PROTOCOL.://&P2111_HTTP_HOST.&P2111_SCRIPT_NAME./&P2111_SCHEMA_ALIAS./&P2111_OBJECT_ALIAS./'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P2111_ENABLE_OBJECT'
,p_display_when2=>'TRUE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fornisce l''URI <em>con distinzione tra maiuscole e minuscole</em> utilizzato per accedere all''oggetto abilitato per REST. ',
'Esempio: <br/><br/>',
'<pre>',
'http://example.com/ords/schemaAlias/objectAlias',
'|_________________|____|___________|__________|',
'           |        |       |          |',
'           |        |       |          |',
'           |        |       |          |',
'           |        |       |          | ',
'           |        |       |          |',
'           |        |       |           - Alias oggetto',
'           |        |       |',
'           |        |        - Alias schema',
'           |        |      ',
'           |         - Alias ORDS',
'           |               ',
'            - URL server               ',
' </pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(243330863961719608.4504)
,p_name=>'P2111_AUTH_ROLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_prompt=>'Ruolo autorizzazione'
,p_source=>'oracle.dbtools.role.autorest.&OBJECT_OWNER..&OBJECT_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P2111_AUTHORIZATION_REQUIRED'
,p_display_when2=>'TRUE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Il ruolo Autorizzazione ORDS richiede l''accesso all''oggetto abilitato per RESTful.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(243331589397719615.4504)
,p_name=>'P2111_SCHEMA_ALIAS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(243331619117719616.4504)
,p_name=>'P2111_PROTOCOL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(243331765989719617.4504)
,p_name=>'P2111_HTTP_HOST'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(243331879482719618.4504)
,p_name=>'P2111_SCRIPT_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(249072655257785483.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(243331073261719610.4504)
,p_validation_name=>'Alias is not null'
,p_validation_sequence=>10
,p_validation=>'P2111_OBJECT_ALIAS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_always_execute=>'Y'
,p_associated_item=>wwv_flow_api.id(243330167057719601.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(243330966624719609.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ENABLE_DISABLE_OBJECT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN ',
'',
'WWV_FLOW_REST_WS.ENABLE_OBJECT(',
'    P_ENABLED => :P2111_ENABLE_OBJECT,',
'    P_SCHEMA => :OBJECT_OWNER,',
'    P_OBJECT => :OBJECT_NAME,',
'    P_OBJECT_TYPE => :OBJECT_TYPE,',
'    P_OBJECT_ALIAS => :P2111_OBJECT_ALIAS,',
'    P_AUTO_REST_AUTH => :P2111_AUTHORIZATION_REQUIRED',
'  );',
'  ',
'EXCEPTION WHEN OTHERS THEN ',
'    if SQLCODE = -20003 then ',
'        htmldb_util.set_session_state(''P2111_ERROR_TEXT'' , wwv_flow_lang.system_message(''SQL_WS.OB.INVALID_ALIAS''));',
'    elsif SQLCODE = -20006 then ',
'        htmldb_util.set_session_state(''P2111_ERROR_TEXT'' , wwv_flow_lang.system_message(''SQL_WS.OB.DUPLICATE_ALIAS''));',
'    else ',
'        htmldb_util.set_session_state(''P2111_ERROR_TEXT'' , SQLERRM) ;',
'    end if;',
'    raise;',
' ',
'END;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossibile elaborare &OBJECT_TYPE. &OBJECT_NAME.<br>',
'&P2111_ERROR_TEXT.',
''))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(243330545992719605.4504)
,p_process_success_message=>'Elaborazione di &OBJECT_TYPE. &OBJECT_NAME. riuscita'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182315742837728922.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema Access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(243331113091719611.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_enable_object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'DECLARE',
'    l_return varchar2(32767);',
'    l_table apex_t_varchar2;',
'BEGIN ',
'    --',
'    -- Pull the data about the currently selected object back ',
'    --',
'    l_return := wwv_flow_rest_ws.get_enabled_object(p_schema => :OBJECT_OWNER, p_object => :OBJECT_NAME);',
'    --',
'    -- Check to see if we have an error (passes back two asterisks then SQLERRM)',
'    --',
'    IF substr(l_return,1,2) = ''**'' THEN ',
'        --- Handle the error',
'        APEX_ERROR.ADD_ERROR (p_message => l_return,',
'                              p_display_location => apex_error.c_inline_in_notification );',
'    --',
'    -- Else if the the string is simply ''::'' then the object is not already enabled so set defaults',
'    --',
'    ELSIF l_return = ''::'' THEN',
'       :P2111_ENABLE_OBJECT := ''FALSE'';',
'       :P2111_OBJECT_ALIAS  := :OBJECT_NAME;',
'       :P2111_AUTHORIZATION_REQUIRED := ''TRUE'';',
'    --',
'    -- Lastly process the string and expose the current settings',
'    ELSE ',
'        l_table := apex_string.split(l_return,'':'');',
'        if l_table(2) = ''ENABLED'' then ',
'            :P2111_ENABLE_OBJECT := ''TRUE'';',
'        else ',
'            :P2111_ENABLE_OBJECT := ''FALSE'';',
'        end if;',
'        :P2111_OBJECT_ALIAS  := l_table(1);',
'        if l_table(3) = ''ENABLED'' then ',
'            :P2111_AUTHORIZATION_REQUIRED := ''TRUE'';',
'        else ',
'            :P2111_AUTHORIZATION_REQUIRED := ''FALSE'';',
'        end if;',
'    END IF;',
'EXCEPTION ',
'    when others then ',
'        raise;',
'end;',
'',
'    ',
'    ',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- If we''re running in the CDB',
'IF (wwv_flow_rest_ws.get_db_type = ''CDB'')',
'THEN ',
'    RETURN false;',
'ELSE ',
'    RETURN true;',
'END IF;',
''))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(243331993891719619.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Calculate URL components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_return varchar2(32767);',
'',
'BEGIN ',
'--',
':P2111_PROTOCOL     := sys.owa_util.get_cgi_env(''REQUEST_PROTOCOL'');',
':P2111_HTTP_HOST    := sys.owa_util.get_cgi_env(''HTTP_HOST'');',
':P2111_SCRIPT_NAME  := sys.owa_util.get_cgi_env(''SCRIPT_NAME'');',
'--',
'   l_return := wwv_flow_rest_ws.GET_SCHEMA_ALIAS (p_schema => :OBJECT_OWNER);',
'   ',
'   if substr(l_return,1,2) = ''**'' then ',
'       null;',
'   end if;',
'   --',
'   :P2111_SCHEMA_ALIAS := l_return;',
'',
'END;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- If we''re running in the CDB',
'IF (wwv_flow_rest_ws.get_db_type = ''CDB'')',
'THEN ',
'    RETURN false;',
'ELSE ',
'    RETURN true;',
'END IF;',
''))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_02112
begin
wwv_flow_api.create_page(
 p_id=>2112.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Query di esempio'
,p_alias=>'OBJECT_SAMPLE_QUERIES'
,p_step_title=>'Query di esempio'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'body .a-Report-wrap {',
'    float: none;',
'}'))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(565824244955226202.4504)
,p_name=>'Query colonne'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select FILTERABLE_SCORE,',
'       decode(RECOMMEND_CHART_TYPE,''PIE'',m.PIE_CHART,''BAR'',m.BAR_CHART,RECOMMEND_CHART_TYPE) RECOMMEND_CHART_TYPE,',
'       decode(FK_CHART_QUERY,',
'              null,',
'              ''select "''||COLUMN_NAME||''", count(*) c ''||chr(10)||',
'              ''from "''||TABLE_NAME||''" ''||chr(10)||',
'              ''group by "''||COLUMN_NAME||''" ''||chr(10)||',
'              ''order by 2 desc'',FK_CHART_QUERY) chart_query,',
'/* to remain in same window',
'sys.htf.anchor(''javascript:apex.util.getTopApex().navigation.redirect(''''''||wwv_flow_utilities.prepare_url(''f?p=4500:1003:&APP_SESSION.:CHART_QUERY:&DEBUG.::P1003_DICTIONARY_QUERY_ID:''||ID)||'''''');'',',
'''<span class="a-Icon icon-run-script" title="''||wwv_flow_lang.system_message(''DEMO_APPLICATION.RUN'')||''"></span>'') r',
'*/',
'sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1003:&APP_SESSION.:CHART_QUERY:&DEBUG.::P1003_DICTIONARY_QUERY_ID:''||ID),',
'''<span class="a-Icon icon-run-script" title="''||wwv_flow_lang.system_message(''DEMO_APPLICATION.RUN'')||''"></span>'', cattributes=>'''') r,',
'wwv_flow_utilities.prepare_url(''f?p=4500:1003:&APP_SESSION.:CHART_QUERY:&DEBUG.::P1003_DICTIONARY_QUERY_ID:''||ID) run_link',
'from WWV_DICTIONARY_CACHE_COL,',
'        (select wwv_flow_lang.system_message(''BAR_CHART'')   BAR_CHART,',
'                wwv_flow_lang.system_message(''PIE_CHART'')   PIE_CHART',
'         from dual) m',
'where OWNER_NAME = :OB_SCHEMA',
'  and TABLE_NAME = :OBJECT_NAME',
'  and security_group_id = :WORKSPACE_ID',
'  and FILTERABLE_SCORE >= 20 and',
'     (DATA_TYPE in (''VARCHAR'',''VARCHAR2'',''CHAR'') or FK_CHART_QUERY is not null)',
'order by FILTERABLE_SCORE desc',
'',
'',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_DICTIONARY_CACHE_COL',
'where OWNER_NAME = :OB_SCHEMA',
'  and TABLE_NAME = :OBJECT_NAME',
'  and security_group_id = :WORKSPACE_ID',
'  and FILTERABLE_SCORE >= 20 and',
'     (DATA_TYPE in (''VARCHAR'',''VARCHAR2'',''CHAR'') or FK_CHART_QUERY is not null)'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(565824597519226205.4504)
,p_query_column_id=>1
,p_column_alias=>'FILTERABLE_SCORE'
,p_column_display_sequence=>1
,p_column_heading=>'Pertinenza'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_report_column_width=>48
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(565824331746226203.4504)
,p_query_column_id=>2
,p_column_alias=>'RECOMMEND_CHART_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Suggerimento'
,p_use_as_row_header=>'N'
,p_report_column_width=>96
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(565824480477226204.4504)
,p_query_column_id=>3
,p_column_alias=>'CHART_QUERY'
,p_column_display_sequence=>3
,p_column_heading=>'Query'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>#CHART_QUERY#</pre>',
'<a href="#RUN_LINK#" onclick="javascript:apex.util.getTopApex().navigation.redirect(''#RUN_LINK#'');" class="a-Button a-Button--small">Esegui query</a>'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183853059243893741.4504)
,p_query_column_id=>4
,p_column_alias=>'R'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(174338174464967801.4504)
,p_query_column_id=>5
,p_column_alias=>'RUN_LINK'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(577562097664126046.4504)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1128071127137549139.4504)
,p_plug_name=>'Query tabella'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select sys.dbms_lob.substr(DEFAULT_QUERY,32767,1) DEFAULT_QUERY',
'  from WWV_DICTIONARY_CACHE_OBJ co',
' where co.object_owner = :OB_SCHEMA',
'   and co.object_name = :OBJECT_NAME',
'   and co.security_group_id = :WORKSPACE_ID ) ',
'loop',
'',
'    sys.htp.prn(''<pre class="padding-md">'');',
'    ',
'    sys.htp.p(wwv_flow_escape.html(c1.DEFAULT_QUERY));',
'    ',
'    sys.htp.prn(''</pre>'');',
'',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173569480899980905.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1128071127137549139.4504)
,p_button_name=>'Run'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Esegui'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(174338283798967802.4504)
,p_name=>'Open SQL Commands'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(173569480899980905.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(174338381357967803.4504)
,p_event_id=>wwv_flow_api.id(174338283798967802.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.util.getTopApex().navigation.redirect(''f?p=&APP_ID.:1003:&SESSION.:TABLE_QUERY:&DEBUG.'');'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(565816584845217435.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object details'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(565816970332217436.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Dictionary Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :OBJECT_TYPE = ''TABLE'' then',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'        p_schema                   => :OB_SCHEMA, ',
'        p_table_name               => :OBJECT_NAME,',
'        --',
'        p_cache_fk_references      => true,',
'        --',
'        p_max_cache_stale_seconds  => 10 );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_02150
begin
wwv_flow_api.create_page(
 p_id=>2150.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Visualizza dettaglio'
,p_alias=>'VIEW_DETAIL'
,p_step_title=>'Visualizza dettaglio'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9937816657774220.4504)
,p_name=>'Column Details'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name,  case when data_type = ''CHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''VARCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''VARCHAR2'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NUMBER'' then',
'      case when c.data_precision is null then',
'          ''NUMBER''',
'      else',
'          data_type||''(''||c.data_precision||'',''||c.data_SCALE||'')''',
'      end',
'    when data_type = ''NVARCHAR'' then',
'      data_type||''(''||c.char_length||'')''',
'    when data_type = ''NVARCHAR2'' then',
'      data_type||''(''||c.char_length||'')''',
'    else',
'      data_type',
'    end data_type,',
'  decode(nullable,''Y'',wwv_flow_lang.system_message(''F4000.YES''),',
'  wwv_flow_lang.system_message(''F4000.NO'')) nullable,',
'  c.DATA_DEFAULT,',
'   sub.column_position pk',
'  from sys.user_tab_columns c,',
' (  select column_name,column_position from sys.user_ind_columns',
'    where (index_name) =',
'   (select index_name from sys.user_constraints',
'    where table_name =',
'  (select object_name from sys.user_objects',
'         where object_name =  :OBJECT_NAME  )',
'        and  constraint_type = ''P'')) sub',
' where c.column_name = sub.column_name(+)',
'  and  c.table_name =  :OBJECT_NAME',
'  order by sub.column_position,column_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9938122080774239.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9938223708774239.4504)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo dati'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9938305941774239.4504)
,p_query_column_id=>3
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Annullabile'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9938402854774239.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_DEFAULT'
,p_column_display_sequence=>4
,p_column_heading=>'Data Default'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9938522960774239.4504)
,p_query_column_id=>5
,p_column_alias=>'PK'
,p_column_display_sequence=>5
,p_column_heading=>'Pk'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10271100163529485.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(10264324489517545.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11801815262531110.4504)
,p_plug_name=>'View Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15693609698226307.4504)
,p_plug_name=>'Compila'
,p_region_template_options=>'#DEFAULT#:a-Alert--defaultIcons:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>17
,p_plug_source=>'wwv_flow_sw_page_calls.do_compile(:object_name,:object_owner,:object_type);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'COMPILE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181320617664546654.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21992607549321937.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02151
begin
wwv_flow_api.create_page(
 p_id=>2151.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'VIEW_GRANTS'
,p_alias=>'VIEW_GRANTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9949919914860394.4504)
,p_name=>'Grants'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, COLUMN_NAME object_name',
'from sys.user_col_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME =  :OBJECT_NAME ',
'union all',
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, table_NAME object_name',
'from sys.user_tab_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa vista non ha concessioni di privilegi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9950200237860402.4504)
,p_query_column_id=>1
,p_column_alias=>'PRIVILEGE'
,p_column_display_sequence=>1
,p_column_heading=>'Privilegio'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9950328291860403.4504)
,p_query_column_id=>2
,p_column_alias=>'GRANTEE'
,p_column_display_sequence=>2
,p_column_heading=>'Assegnatario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9950408818860403.4504)
,p_query_column_id=>3
,p_column_alias=>'GRANTABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Assegnabile'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9950523276860403.4504)
,p_query_column_id=>4
,p_column_alias=>'GRANTOR'
,p_column_display_sequence=>4
,p_column_heading=>'Concedente'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9950614231860403.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nome oggetto'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11802422880533388.4504)
,p_plug_name=>'View Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15650817205020395.4504)
,p_plug_name=>'actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(15238925543915636.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21992901493358042.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02153
begin
wwv_flow_api.create_page(
 p_id=>2153.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'VIEW_DEPENDENCIES'
,p_alias=>'VIEW_DEPENDENCIES'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9940709300791000.4504)
,p_name=>'Riferimenti'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select referenced_owner,referenced_name,referenced_type,',
'    replace(referenced_type,'' '',''_'') type_link,',
' (select object_id from sys.user_objects where object_name = dd.referenced_name',
'and object_type = dd.referenced_type) object_id',
'from sys.user_dependencies dd',
'where type  = ''VIEW''',
'and   name  = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa vista non ha riferimenti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9941018617791008.4504)
,p_query_column_id=>1
,p_column_alias=>'REFERENCED_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9941111815791008.4504)
,p_query_column_id=>2
,p_column_alias=>'REFERENCED_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#REFERENCED_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9941215293791008.4504)
,p_query_column_id=>3
,p_column_alias=>'REFERENCED_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9941308437791008.4504)
,p_query_column_id=>4
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>4
,p_column_heading=>'Type Link'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9941414064791008.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9942022460794805.4504)
,p_name=>'Riferimento proveniente da'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,name,type,replace(type,'' '',''_'') type_link,',
'          (select ao.object_id from apex_sys_all_objects ao',
'                          where dd.owner = ao.owner',
'                          and   dd.NAME = ao.object_name',
'                          and   dd.type = ao.object_type) object_id',
'from apex_sys_all_dependencies dd',
'where referenced_owner = :OBJECT_OWNER',
'and   referenced_type  = :OBJECT_TYPE',
'and   referenced_name  = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'A questa vista non fanno riferimento altri oggetti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9942310422794818.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9942430970794818.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'NAME'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9942532623794819.4504)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'TYPE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9942616721794819.4504)
,p_query_column_id=>4
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>4
,p_column_heading=>'TYPE_LINK'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9942705420794819.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>5
,p_column_heading=>'OBJECT_ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11803603618537204.4504)
,p_plug_name=>'View Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(18360915108312433.4504)
,p_name=>'Sinonimi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT owner, synonym_name',
'  FROM apex_sys_all_synonyms',
' WHERE table_owner = :OBJECT_OWNER',
'  AND table_name = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Questa vista non ha sinonimi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18361201355312444.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18361318896312445.4504)
,p_query_column_id=>2
,p_column_alias=>'SYNONYM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'SYNONYM_NAME'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21993213052370919.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02154
begin
wwv_flow_api.create_page(
 p_id=>2154.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Visualizza DDL (Data Definition Language)'
,p_alias=>'VIEW_DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9952616151887637.4504)
,p_plug_name=>'DDL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<pre class="code">'');',
'',
'wwv_flow_generate_ddl.execute_get_ddl (',
'    p_schema       => :OBJECT_OWNER,',
'    p_objects      => :OBJECT_NAME,',
'    p_object_types => :OBJECT_TYPE,',
'    p_output_type  => ''DISPLAY''',
'    );',
'',
'sys.htp.p(''</pre>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11804216778541089.4504)
,p_plug_name=>'View Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
end;
/
prompt --application/pages/page_02155
begin
wwv_flow_api.create_page(
 p_id=>2155.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Report valori predefiniti interfaccia utente del browser oggetti'
,p_alias=>'OB_UI_DEFAULTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15606421957933213.4504)
,p_plug_name=>'View Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'VIEW'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15606617449933216.4504)
,p_name=>'Table/View-level User Interface Defaults'
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.FORM_REGION_TITLE,',
'       t.REPORT_REGION_TITLE',
'  from WWV_FLOW_HNT_TABLE_INFO t',
' where t.table_id = (select table_id ',
'                      from WWV_FLOW_HNT_TABLE_INFO ',
'                      where schema = :OBJECT_OWNER ',
'                      and table_name = :OBJECT_NAME)'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'A questa tabella/vista non sono attualmente assegnati valori predefiniti di interfaccia utente.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15607004663933219.4504)
,p_query_column_id=>1
,p_column_alias=>'FORM_REGION_TITLE'
,p_column_display_sequence=>2
,p_column_heading=>'Titolo area form:'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15607103397933219.4504)
,p_query_column_id=>2
,p_column_alias=>'REPORT_REGION_TITLE'
,p_column_display_sequence=>1
,p_column_heading=>'Titolo area report:'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15607221124933219.4504)
,p_name=>'Column-level User Interface Defaults'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT COLUMN_NAME, ',
'       LABEL, ',
'       DISPLAY_SEQ_REPORT, ',
'       DISPLAY_SEQ_FORM,',
'       decode(display_in_report,''Y'',DISPLAY_AS_REPORT,''-'') DISPLAY_AS_REPORT,',
'       decode(display_in_report,''Y'',DISPLAY_AS_TAB_FORM,''-'') DISPLAY_AS_TAB_FORM,',
'       decode(display_in_form,''Y'',DISPLAY_AS_FORM,''-'') DISPLAY_AS_FORM',
'  FROM WWV_FLOW_HNT_COLUMN_INFO',
' where table_id = (select table_id ',
'                      from WWV_FLOW_HNT_TABLE_INFO ',
'                      where schema = :OBJECT_OWNER ',
'                      and table_name = :OBJECT_NAME)'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>10000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15607528498933221.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome colonna'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15607612818933221.4504)
,p_query_column_id=>2
,p_column_alias=>'LABEL'
,p_column_display_sequence=>2
,p_column_heading=>'Etichetta'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15607815755933221.4504)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQ_REPORT'
,p_column_display_sequence=>3
,p_column_heading=>'Sequenza di<br />report'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15608431998933222.4504)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_SEQ_FORM'
,p_column_display_sequence=>6
,p_column_heading=>'Sequenza di<br />form'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(24423608907207236.4504)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_AS_REPORT'
,p_column_display_sequence=>4
,p_column_heading=>'Visualizzazione<br />report'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(285136607862263925)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(24423728952207237.4504)
,p_query_column_id=>6
,p_column_alias=>'DISPLAY_AS_TAB_FORM'
,p_column_display_sequence=>5
,p_column_heading=>'Visualizzazione<br />form tabulare'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(173321532130152965)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(24423819606207237.4504)
,p_query_column_id=>7
,p_column_alias=>'DISPLAY_AS_FORM'
,p_column_display_sequence=>7
,p_column_heading=>'Visualizzazione<br />form'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(29577622544843540)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20354128351928514.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>12
,p_list_id=>wwv_flow_api.id(20344107517818485.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20355117746934983.4504)
,p_plug_name=>'Hint Text'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>11
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<span class="instructiontext">'');',
'sys.htp.p(wwv_flow_lang.system_message(''4500_UI_DEF_HINT_TEXT''));',
'sys.htp.p(''</span><br />'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22801712264013350.4504)
,p_plug_name=>'DB Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>5
,p_list_id=>wwv_flow_api.id(11739111107829730.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'TABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20362202041996615.4504)
,p_branch_action=>'f?p=&APP_ID.:2155:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(491825219538357666.4504)
,p_name=>'P2155_UI_DEF_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20354128351928514.4504)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_id',
'  from wwv_flow_hnt_table_info',
' where table_name = :OBJECT_NAME',
'   and schema = :OBJECT_OWNER'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_02156
begin
wwv_flow_api.create_page(
 p_id=>2156.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Visualizza dati'
,p_alias=>'VIEW_DATA'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11539602725985552)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_brows.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14654015267783067.4504)
,p_plug_name=>'View Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(14654206818783069.4504)
,p_name=>'Data'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  v_sql varchar2(2000) := '' dual'';',
'  v_min number;',
'begin',
'  wwv_flow_sw_api.check_priv(:OBJECT_OWNER);',
'  for r in (  select owner,',
'                     object_name',
'                from sys.dba_objects ',
'               where object_id = :OB_OBJECT_NAME ) loop',
'      v_sql := wwv_flow_assert.enquote_name(r.owner)||''.''||wwv_flow_assert.enquote_name(r.object_name);',
'  end loop;',
'',
'  wwv_flow.debug(''select ''||replace(:P2156_COLUMNS,'':'','','')||'' from ''||v_sql);',
'return ''select ''||replace(substr(:P2156_COLUMNS,2),'':'','','')||'' from ''||v_sql;',
'end;'))
,p_display_when_condition=>'COUNT'
,p_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_header=>'&P2156_MESSAGE.'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa vista non contiene dati.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Scarica'
,p_prn_output=>'N'
,p_plug_query_exp_filename=>'&OBJECT_NAME..csv'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658918830783077.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659008966783077.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659108349783077.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659225030783077.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14654417699783072.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14654507906783072.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14654606735783072.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14654709470783072.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14654832458783072.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14654907743783072.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655018423783072.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655110626783072.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655220854783072.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655303847783073.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655428225783073.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655524263783073.4504)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655619586783073.4504)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655729765783073.4504)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655814703783073.4504)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14655921256783073.4504)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656012237783073.4504)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656115688783073.4504)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656228408783074.4504)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656308818783074.4504)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656420849783074.4504)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656507566783074.4504)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656602408783074.4504)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656717325783074.4504)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656807873783074.4504)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14656902285783074.4504)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657021882783074.4504)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657105803783075.4504)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657221637783075.4504)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657308195783075.4504)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657419571783075.4504)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657508624783075.4504)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657619065783075.4504)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657706368783075.4504)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657810177783075.4504)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14657910402783075.4504)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658028163783075.4504)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658128659783076.4504)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658227093783076.4504)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658302707783076.4504)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658418485783076.4504)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658527954783076.4504)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658622589783076.4504)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658704493783076.4504)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14658811011783076.4504)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659300150783077.4504)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659413649783077.4504)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659527682783077.4504)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659600240783077.4504)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659706762783077.4504)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659827444783077.4504)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14659910327783078.4504)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14660012561783078.4504)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14660131203783078.4504)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14660210452783078.4504)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14660323071783078.4504)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14660404363783078.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(14089426771868187.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181423604111864436.4504)
,p_plug_name=>'Count'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'COUNT'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14660631488783080.4504)
,p_name=>'P2156_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(14654206818783069.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14660803776783082.4504)
,p_name=>'P2156_MESSAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(14654206818783069.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181424417963868471.4504)
,p_name=>'P2156_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(181423604111864436.4504)
,p_prompt=>'Conteggio righe:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14661013841783085.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Cols '
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_owner varchar2(500);',
' l_name  varchar2(500);',
' i       number := 0;',
' l_max   number := 30;',
'begin',
':P2156_COLUMNS := '''';--''rowid'';',
'  for r in ( select column_name',
'             from sys.dba_tab_Columns ',
'             where owner       = :OBJECT_OWNER',
'             and   table_name  = :OBJECT_NAME',
'             order by  column_id ) loop',
'    i := i +1;',
'   exit when i >l_max;',
'   :P2156_COLUMNS := :P2156_COLUMNS ||'':"''||r.column_name||''"'';',
'  end loop;',
'  if i >l_max then ',
'     :P2156_MESSAGE  := wwv_flow_lang.system_message(p_name=>''4500_OBJECT_BROWSER_ONLY_N_COLS'',p0=>l_max);',
'   else',
'     :P2156_MESSAGE  := '''';',
'   end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14661202962783086.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'RP'
,p_attribute_01=>'THIS_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181425718441878045.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'count'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2156_COUNT := ',
'wwv_flow_f4000_util.countem(',
'  ''select count(1) from "''||:OBJECT_OWNER||''"."''||:OBJECT_NAME||''"'',',
'    :OBJECT_OWNER);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossibile contare le righe: #SQLERRM#'
,p_process_when=>'COUNT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_02200
begin
wwv_flow_api.create_page(
 p_id=>2200.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'INDEX_DETAIL'
,p_alias=>'INDEX_DETAIL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7772609433238313.4504)
,p_plug_name=>'INDEX SUB TABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(7770017698212372.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(7778414244287081.4504)
,p_name=>'Index Details'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select index_name,index_type,table_owner,',
'       table_name,',
'       table_type,',
'       uniqueness,compression,prefix_length,tablespace_name,',
'       status,last_analyzed,',
'       (select object_id',
'          from sys.user_objects',
'         where object_type = i.table_type',
'           and object_name = i.table_name) link',
'  from sys.user_indexes i',
' where index_name = :OBJECT_NAME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7778716306287101.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome indice'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7778803166287101.4504)
,p_query_column_id=>2
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo indice'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7778930538287102.4504)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Proprietario tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779013788287102.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome tabella'
,p_column_link=>'f?p=&APP_ID.:TABLE_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#LINK#'
,p_column_linktext=>'#TABLE_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779108085287102.4504)
,p_query_column_id=>5
,p_column_alias=>'TABLE_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo di tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779213931287102.4504)
,p_query_column_id=>6
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Univocit\00E0')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779324821287102.4504)
,p_query_column_id=>7
,p_column_alias=>'COMPRESSION'
,p_column_display_sequence=>7
,p_column_heading=>'Compressione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779419452287102.4504)
,p_query_column_id=>8
,p_column_alias=>'PREFIX_LENGTH'
,p_column_display_sequence=>8
,p_column_heading=>'Lunghezza prefisso'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779509838287102.4504)
,p_query_column_id=>9
,p_column_alias=>'TABLESPACE_NAME'
,p_column_display_sequence=>9
,p_column_heading=>'Nome tablespace'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779618398287102.4504)
,p_query_column_id=>10
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Stato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779707866287102.4504)
,p_query_column_id=>11
,p_column_alias=>'LAST_ANALYZED'
,p_column_display_sequence=>11
,p_column_heading=>'Ultima analisi'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7779822076287102.4504)
,p_query_column_id=>12
,p_column_alias=>'LINK'
,p_column_display_sequence=>12
,p_column_heading=>'Link'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(7792428583376353.4504)
,p_name=>'Colonne indice'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name',
'       ,i.column_expression,c.column_position',
'  from sys.user_ind_columns c,',
'      (select column_expression,column_position',
'         from sys.user_ind_expressions',
'        where index_name = :OBJECT_NAME) i',
' where c.index_name = :OBJECT_NAME',
'   and c.column_position = i.column_position(+)',
' order by c.column_position'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7792720329376367.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome colonna'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7792827329376367.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_EXPRESSION'
,p_column_display_sequence=>2
,p_column_heading=>'Espressione colonna'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7792911791376367.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>3
,p_column_heading=>'Posizione colonna'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10329708530635992.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(10296931855576458.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16259928770559583.4504)
,p_plug_name=>'Disable'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>16
,p_plug_source=>'wwv_flow_sw_page_calls.disable_index(:object_name ,:object_owner ,:object_type);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'DISABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16263916397612746.4504)
,p_plug_name=>'Rebuild'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>18
,p_plug_source=>'wwv_flow_sw_page_calls.rebuild_index(:object_name ,:object_owner ,:object_type);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'REBUILD'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181182431988043702.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object details'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21993530808432776.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02201
begin
wwv_flow_api.create_page(
 p_id=>2201.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'INDEX_DDL'
,p_alias=>'INDEX_DDL'
,p_step_title=>'INDEX_DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7775918699259921.4504)
,p_plug_name=>'INDEX SUB TABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(7770017698212372.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7801022789431476.4504)
,p_plug_name=>'Index DDL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<pre class="code">'');',
'',
'wwv_flow_generate_ddl.execute_get_ddl (',
'    p_schema       => :OBJECT_OWNER,',
'    p_objects      => :OBJECT_NAME,',
'    p_object_types => :OBJECT_TYPE,',
'    p_output_type  => ''DISPLAY''',
'    );',
'',
'sys.htp.p(''</pre>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<pre>'
,p_plug_footer=>'</pre>'
);
end;
/
prompt --application/pages/page_02250
begin
wwv_flow_api.create_page(
 p_id=>2250.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dettagli oggetto PL/SQL'
,p_alias=>'FUNCTION_DETAIL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function saveCode(cb) {',
'  apex.builder.plugin.codeEditor.saveProcess("#codeEditor_widget", "STORE_SCRIPT", "f01", {})',
'    .always(function() {',
'      cb();',
'  });',
'}',
'',
'function doCompile(){',
'',
'  saveCode(function() {',
'    var get = new htmldb_Get(null,4500,''APPLICATION_PROCESS=compile_plsql_code'',0);',
'    var message = get.get(''FULL'');',
'    var status = message.substr(0,1);',
'    message = message.substr(1);',
'    html_GetElement(''results'').innerHTML = message;',
'    if (status==''0'') {',
'      html_GetElement(''results'').className = ''compileFailure'';',
'    } else {',
'      html_GetElement(''results'').className = ''compileSuccess'';',
'    }',
'    $("body").trigger("resize");',
'  });',
'}',
'',
'function goToLine(lineID) {',
'  $("#codeEditor_widget").codeEditor("setCursor", parseInt(lineID,10) - 1, 0 );',
'  setTimeout(function() {',
'    $("#codeEditor_widget").codeEditor("focus");',
'  }, 1);',
'}',
'',
'function downloadCode() {',
'  saveCode(function() {',
'    doSubmit(''DOWNLOAD_CODE'');',
'  });',
'}',
''))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".a-Dialog, .a-Dialog-wrap, .a-Dialog-body, .a-MonacoEditor").addClass("resize");',
'apex.jQuery(".a-Dialog").removeClass("a-Dialog");',
'apex.theme.pageResizeInit();'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#results.compileFailure, #results.compileSuccess {',
'    padding:8px;',
'}',
''))
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8051023175701535.4504)
,p_plug_name=>'FUNCTION_SUBTABS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(8047123559654396.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'TRIGGER:VIEW'
,p_plug_header=>'<div id="func_tab_menu">'
,p_plug_footer=>'</div>'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10328122598630580.4504)
,p_plug_name=>'azioni'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(10281517394553333.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108852022973564705.4504)
,p_plug_name=>'Risultati'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear:both;"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>26
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<div id="results" style="overflow:auto;max-height:280px"></div>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178217628284980511.4504)
,p_plug_name=>'TRIGGER_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(9213221268571230.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'TRIGGER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(275803816639992610.4504)
,p_plug_name=>'VIEW_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>17
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(11795609889491706.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'OBJECT_TYPE'
,p_plug_display_when_cond2=>'VIEW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(621103132332076428.4504)
,p_plug_name=>'New Code Area'
,p_region_name=>'codeEditor'
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear:both"'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'  from wwv_flow_collections',
' where collection_name = ''P2250_OBJECT_DDL'''))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'DDL'
,p_attribute_02=>'30'
,p_attribute_03=>'N'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(113022513568749711.4504)
,p_branch_action=>'f?p=&FLOW_ID.:2250:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181322210869554190.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS:GETOBJECT_TREE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(621103027751076427.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'     l_clob_arr    wwv_flow.clob_arr;',
'     l_code        clob := empty_clob;',
'     i             integer;',
'begin',
'',
'     wwv_flow_collection.create_or_truncate_collection(''P2250_OBJECT_DDL'');',
'',
'     if (:OBJECT_TYPE=''VIEW'') then',
'',
'        l_clob_arr := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'            p_schema       => :OBJECT_OWNER,',
'            p_objects      => :OBJECT_NAME,',
'            p_object_type  => :OBJECT_TYPE );',
'',
'        for i in 1..l_clob_arr.count loop',
'            l_code := l_code || l_clob_arr(i);',
'        end loop;',
'',
'        if substr(l_code,length(l_code),1) = '';'' then',
'            l_code := rtrim(l_code,chr(32)||'';''||chr(10)||chr(32)||chr(10));',
'            l_code := l_code||chr(10)||''/''||chr(10);',
'        elsif substr(l_code,length(l_code),1) = ''/'' then',
'            l_code := l_code||chr(10)||chr(10);',
'        end if;',
'',
'     else',
'',
'        l_code := ''create or replace '';',
'        for r in ( select text',
'              from sys.dba_source',
'              where name = :OBJECT_NAME',
'              and   owner = :OBJECT_OWNER',
'              and   type = :OBJECT_TYPE',
'              order by line)',
'        loop',
'',
'            l_code := l_code||r.text;',
'        end loop;',
'     end if;',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''P2250_OBJECT_DDL'',',
'        p_clob001         => l_code);',
'',
'exception',
'    when DUP_VAL_ON_INDEX then',
'        -- ignore unique constraint error that was raised when double-clicking on link to page, collection only needs to be populated once',
'        null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19367500193793333.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download code'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_code_lines sys.dbms_sql.varchar2a;',
'  l_file_name varchar2(4000);',
'  g_default_mime_charset varchar2(100) := ''utf-8'';',
'',
'begin',
'',
'  wwv_flow_init_htp_buffer;',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow.g_unrecoverable_error := true;',
'  ',
'  wwv_flow_utilities.print_download_header(',
'    p_mime_type =>     ''text/plain'',',
'    p_file_name =>     :OBJECT_NAME || case when :OBJECT_TYPE = ''PACKAGE BODY'' then l_file_name ||''.plb'' else l_file_name ||''.sql'' end,',
'    p_is_attachment => true',
'  );',
'    ',
'  sys.owa_util.http_header_close;',
'',
'  for c1 in (',
'    select * from htmldb_collections ',
'    where collection_name = ''PLSQL_OBJECT_SOURCE''',
'  ) loop',
'    if :OBJECT_TYPE = ''TRIGGER'' or :OBJECT_TYPE = ''VIEW'' then',
'        sys.htp.p(wwv_flow_utilities.clob_to_varchar2(c1.clob001));',
'    else',
'        l_code_lines := wwv_flow_plsql_editor.get_lines(c1.clob001);',
'        for i in 1..l_code_lines.count loop',
'            sys.htp.p(l_code_lines(i));',
'        end loop;',
'    end if;    ',
'  end loop;  ',
'',
'  htmldb_collection.truncate_collection(',
'    p_collection_name => ''PLSQL_OBJECT_SOURCE'' ',
'  );',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DOWNLOAD_CODE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21993814016465742.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19366208027786100.4504)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'STORE_SCRIPT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code clob := empty_clob;',
'begin',
'    sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'',
'    htmldb_collection.create_or_truncate_collection(',
'        p_collection_name => ''PLSQL_OBJECT_SOURCE'' ',
'    );',
'',
'    for i in 1..wwv_flow.g_f01.count loop',
'        sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f01(i)),wwv_flow.g_f01(i));',
'    end loop;',
'',
'    htmldb_collection.add_member(',
'        p_collection_name => ''PLSQL_OBJECT_SOURCE'',',
'        p_clob001         => l_code',
'    );',
'',
'    sys.owa_util.status_line(204, ''No Content'');',
'end;',
''))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_02251
begin
wwv_flow_api.create_page(
 p_id=>2251.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'FUNCTION_DEPENDENCIES'
,p_alias=>'FUNCTION_DEPENDENCIES'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8060525824768557.4504)
,p_plug_name=>'FUNCTION_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(8047123559654396.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9955821262908088.4504)
,p_name=>'Riferimenti'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT B.OBJECT_ID,',
'       :OBJECT_OWNER owner,',
'       b.object_type,',
'       b.object_name,',
'       b.status,',
'       replace(b.object_type,'' '',''_'') type_link',
'  FROM sys.user_objects a,',
'       sys.user_objects b,',
'       (SELECT object_id, referenced_object_id',
'        FROM public_dependency',
'        START WITH object_id = :P2251_OBJECT_ID',
'        CONNECT BY PRIOR referenced_object_id = object_id) c',
' WHERE a.object_id = c.object_id',
'   AND b.object_id = c.referenced_object_id',
'   AND a.object_name <> ''DUAL''',
'   AND b.object_name <> ''DUAL'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questo oggetto non ha riferimenti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9956128439908094.4504)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9956227291908095.4504)
,p_query_column_id=>2
,p_column_alias=>'OWNER'
,p_column_display_sequence=>2
,p_column_heading=>'Proprietario'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9956309042908095.4504)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo di oggetto'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9956416893908095.4504)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome oggetto'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9956511793908095.4504)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9956609834908095.4504)
,p_query_column_id=>6
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>6
,p_column_heading=>'Type Link'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9957404077912501.4504)
,p_name=>'Riferimento proveniente da'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT :OBJECT_OWNER owner, object_type, object_name, object_id,',
'    status , decode(replace(object_type,'' '',''_''),''PACKAGE_BODY'',''PACKAGE'',replace(object_type,'' '',''_'')) type_link',
'  FROM sys.user_objects',
' WHERE object_id IN (',
'          SELECT object_id',
'            FROM public_dependency',
'          CONNECT BY PRIOR object_id = referenced_object_id',
'          START WITH referenced_object_id = :P2251_OBJECT_ID )'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'A questo oggetto non fanno riferimento altri oggetti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9957718734912506.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9957824105912506.4504)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo di oggetto'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9957922665912506.4504)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome oggetto'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9958000834912506.4504)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9958104144912506.4504)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Status'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9958222589912506.4504)
,p_query_column_id=>6
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>6
,p_column_heading=>'Type Link'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(18365802127346570.4504)
,p_name=>'Sinonimi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT owner, synonym_name',
'  FROM apex_sys_all_synonyms',
' WHERE table_owner = :OBJECT_OWNER',
'  AND table_name = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Questo oggetto non ha sinonimi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18366126119346573.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18366216601346573.4504)
,p_query_column_id=>2
,p_column_alias=>'SYNONYM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'SYNONYM_NAME'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(286296311618367964.4504)
,p_name=>'P2251_OBJECT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8060525824768557.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21994119127486208.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(286307411328471932.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set object_id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  if :OBJECT_TYPE = ''PACKAGE'' then',
'    :P2251_OBJECT_ID := :OBJECT_ID;',
'  else',
'    select object_id into :P2251_OBJECT_ID ',
'    from sys.dba_objects ',
'    where owner = :OB_SCHEMA',
'      and object_name = :OBJECT_NAME',
'      and object_type = ''PACKAGE BODY'';',
'  end if;',
'exception when others then',
'    :P2251_OBJECT_ID := :OBJECT_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_02252
begin
wwv_flow_api.create_page(
 p_id=>2252.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'FUNCTION_ERRORS'
,p_alias=>'FUNCTION_ERRORS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8061616951775490.4504)
,p_plug_name=>'FUNCTION_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(8047123559654396.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9961501007940089.4504)
,p_name=>'Errors'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT  line, POSITION, SUBSTR (text, 1, 200) text',
'  FROM  sys.user_errors',
' WHERE  NAME = :OBJECT_NAME',
'    AND TYPE = :OBJECT_TYPE'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questo oggetto non ha errori.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9961824964940093.4504)
,p_query_column_id=>1
,p_column_alias=>'LINE'
,p_column_display_sequence=>1
,p_column_heading=>'Riga'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9961926482940093.4504)
,p_query_column_id=>2
,p_column_alias=>'POSITION'
,p_column_display_sequence=>2
,p_column_heading=>'Posizione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9962022175940093.4504)
,p_query_column_id=>3
,p_column_alias=>'TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Testo'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21994409823511805.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02253
begin
wwv_flow_api.create_page(
 p_id=>2253.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'FUNCTION_GRANTS'
,p_alias=>'FUNCTION_GRANTS'
,p_step_title=>'FUNCTION_GRANTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8063213272783802.4504)
,p_plug_name=>'FUNCTION_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(8047123559654396.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(108863608130594810.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9978614962076580.4504)
,p_name=>'Grants'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, COLUMN_NAME object_name',
'from sys.user_col_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME =  :OBJECT_NAME ',
'union all',
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, table_NAME object_name',
'from sys.user_tab_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questo oggetto non ha concessioni di privilegi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9978825499076582.4504)
,p_query_column_id=>1
,p_column_alias=>'PRIVILEGE'
,p_column_display_sequence=>1
,p_column_heading=>'Privilegio'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9978928153076583.4504)
,p_query_column_id=>2
,p_column_alias=>'GRANTEE'
,p_column_display_sequence=>2
,p_column_heading=>'Assegnatario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9979020343076583.4504)
,p_query_column_id=>3
,p_column_alias=>'GRANTABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Assegnabile'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9979127251076583.4504)
,p_query_column_id=>4
,p_column_alias=>'GRANTOR'
,p_column_display_sequence=>4
,p_column_heading=>'Concedente'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9979231209076583.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nome oggetto'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15669703147101475.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(15238925543915636.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21994717535570856.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02300
begin
wwv_flow_api.create_page(
 p_id=>2300.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dettaglio package'
,p_alias=>'PACKAGE_DETAIL'
,p_step_title=>'Dettaglio package'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_help_text=>'AEUTL/obj_pack.htm'
,p_page_comment=>'This page is used by the Object Browser as landing page for the currently selected object type. Don''t delete it! - Patrick'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(467006627439825669.4504)
,p_branch_name=>'Go To Page 2250'
,p_branch_action=>'f?p=&APP_ID.:2250:&SESSION.:GETOBJECT_TREE:&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_02350
begin
wwv_flow_api.create_page(
 p_id=>2350.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'PROCEDURE_DETAIL'
,p_alias=>'PROCEDURE_DETAIL'
,p_step_title=>'PROCEDURE_DETAIL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_page_comment=>'This page is used by the Object Browser as landing page for the currently selected object type. Don''t delete it! - Patrick'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(108575632372195458.4504)
,p_branch_action=>'f?p=&APP_ID.:2250:&SESSION.:GETOBJECT_TREE:&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_02400
begin
wwv_flow_api.create_page(
 p_id=>2400.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'SEQUENCE_DETAIL'
,p_alias=>'SEQUENCE_DETAIL'
,p_step_title=>'SEQUENCE_DETAIL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9304215810601029.4504)
,p_plug_name=>'SEQUENCE_SUBTAB'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9285616718241773.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(10094220727494528.4504)
,p_name=>'Details'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :object_owner SEQUENCE_OWNER, SEQUENCE_NAME,',
'       MIN_VALUE, MAX_VALUE, INCREMENT_BY, CYCLE_FLAG,',
'       ORDER_FLAG, CACHE_SIZE, LAST_NUMBER',
'from sys.user_sequences',
'where sequence_name = :object_name'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10094508775494537.4504)
,p_query_column_id=>1
,p_column_alias=>'SEQUENCE_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence Owner'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10094605303494537.4504)
,p_query_column_id=>2
,p_column_alias=>'SEQUENCE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence Name'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10094726014494538.4504)
,p_query_column_id=>3
,p_column_alias=>'MIN_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Min Value'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10094821053494538.4504)
,p_query_column_id=>4
,p_column_alias=>'MAX_VALUE'
,p_column_display_sequence=>4
,p_column_heading=>'Max Value'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10094930660494538.4504)
,p_query_column_id=>5
,p_column_alias=>'INCREMENT_BY'
,p_column_display_sequence=>5
,p_column_heading=>'Increment By'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10095022937494538.4504)
,p_query_column_id=>6
,p_column_alias=>'CYCLE_FLAG'
,p_column_display_sequence=>6
,p_column_heading=>'Cycle Flag'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10095122920494538.4504)
,p_query_column_id=>7
,p_column_alias=>'ORDER_FLAG'
,p_column_display_sequence=>7
,p_column_heading=>'Order Flag'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10095205995494538.4504)
,p_query_column_id=>8
,p_column_alias=>'CACHE_SIZE'
,p_column_display_sequence=>8
,p_column_heading=>'Cache Size'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10095318805494538.4504)
,p_query_column_id=>9
,p_column_alias=>'LAST_NUMBER'
,p_column_display_sequence=>9
,p_column_heading=>'Ultimo numero'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10345508708673857.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(10306018611591561.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181325319442575510.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22105712087676221.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02401
begin
wwv_flow_api.create_page(
 p_id=>2401.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'SEQUENCE_GRANTS'
,p_alias=>'SEQUENCE_GRANTS'
,p_step_title=>'SEQUENCE_GRANTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9305621423615345.4504)
,p_plug_name=>'SEQUENCE_SUBTAB'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9285616718241773.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9983604358082998.4504)
,p_name=>'Grants'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, COLUMN_NAME object_name',
'from sys.user_col_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME =  :OBJECT_NAME ',
'union all',
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, table_NAME object_name',
'from sys.user_tab_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa sequenza non ha concessioni di privilegi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9983811697082999.4504)
,p_query_column_id=>1
,p_column_alias=>'PRIVILEGE'
,p_column_display_sequence=>1
,p_column_heading=>'Privilegio'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9983901777082999.4504)
,p_query_column_id=>2
,p_column_alias=>'GRANTEE'
,p_column_display_sequence=>2
,p_column_heading=>'Assegnatario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9984009863082999.4504)
,p_query_column_id=>3
,p_column_alias=>'GRANTABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Assegnabile'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9984115334082999.4504)
,p_query_column_id=>4
,p_column_alias=>'GRANTOR'
,p_column_display_sequence=>4
,p_column_heading=>'Concedente'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9984202854082999.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nome oggetto'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16046128546793097.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(15238925543915636.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22106029533690660.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02403
begin
wwv_flow_api.create_page(
 p_id=>2403.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'SEQUENCE_USED'
,p_alias=>'SEQUENCE_USED'
,p_step_title=>'SEQUENCE_USED'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9313814529872000.4504)
,p_plug_name=>'SEQUENCE_SUBTAB'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9285616718241773.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9991510376094131.4504)
,p_name=>'Riferimenti'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select referenced_owner,referenced_name,referenced_type,replace(referenced_type,'' '',''_'') type_link,',
' (select object_id',
'    from apex_sys_all_objects',
'   where object_name = dd.referenced_name',
'     and owner = dd.referenced_owner',
'     and object_type = dd.referenced_type) object_id',
'from apex_sys_all_dependencies dd',
'where type  = ''VIEW''',
'and   owner = :OBJECT_OWNER',
'and   name  = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa sequenza non ha riferimenti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9991720311094132.4504)
,p_query_column_id=>1
,p_column_alias=>'REFERENCED_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9991804771094133.4504)
,p_query_column_id=>2
,p_column_alias=>'REFERENCED_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#REFERENCED_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9991916098094133.4504)
,p_query_column_id=>3
,p_column_alias=>'REFERENCED_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9992019057094133.4504)
,p_query_column_id=>4
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>4
,p_column_heading=>'Type Link'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9992118769094133.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9992615225095539.4504)
,p_name=>'Riferimento proveniente da'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,name,type,replace(type,'' '',''_'') type_link,',
'          (select ao.object_id from apex_sys_all_objects ao',
'                          where dd.owner = ao.owner',
'                          and   dd.NAME = ao.object_name',
'                          and   dd.type = ao.object_type) object_id',
'from apex_sys_all_dependencies dd',
'where referenced_owner = :OBJECT_OWNER',
'and   referenced_type  = :OBJECT_TYPE',
'and   referenced_name  = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'A questa sequenza non fanno riferimento altri oggetti.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9992817292095540.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9992925625095540.4504)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome'
,p_column_link=>'f?p=&APP_ID.:#TYPE_LINK#_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9993008685095541.4504)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9993103138095541.4504)
,p_query_column_id=>4
,p_column_alias=>'TYPE_LINK'
,p_column_display_sequence=>4
,p_column_heading=>'TYPE_LINK'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9993220758095541.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>5
,p_column_heading=>'OBJECT_ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(18381118365398541.4504)
,p_name=>'Sinonimi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT owner, synonym_name',
'  FROM apex_sys_all_synonyms',
' WHERE table_owner = :OBJECT_OWNER',
'   and table_name = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questa sequenza non ha sinonimi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18381412280398544.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18381523479398544.4504)
,p_query_column_id=>2
,p_column_alias=>'SYNONYM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome sinonimo'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22106313303714398.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02404
begin
wwv_flow_api.create_page(
 p_id=>2404.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'SEQUENCE_SQL'
,p_alias=>'SEQUENCE_SQL'
,p_step_title=>'SEQUENCE_SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9315117331898899.4504)
,p_plug_name=>'SEQUENCE_SUBTAB'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9285616718241773.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9994024921098344.4504)
,p_plug_name=>'DDL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<pre class="code">'');',
'',
'wwv_flow_generate_ddl.execute_get_ddl (',
'    p_schema       => :OBJECT_OWNER,',
'    p_objects      => :OBJECT_NAME,',
'    p_object_types => :OBJECT_TYPE,',
'    p_output_type  => ''DISPLAY''',
'    );',
'',
'sys.htp.p(''</pre>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
end;
/
prompt --application/pages/page_02450
begin
wwv_flow_api.create_page(
 p_id=>2450.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'SYNONYM_DETAIL'
,p_alias=>'SYNONYM_DETAIL'
,p_step_title=>'SYNONYM_DETAIL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9226509765662591.4504)
,p_plug_name=>'SYNONYM_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9225416906655157.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(10106732464545209.4504)
,p_name=>'Details'
,p_display_sequence=>20
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.synonym_name, :object_owner synonym_owner, s.table_owner object_owner,',
'    case',
'    -- add link if owners are same b/c syonym can reference other workspace schema object',
'    when :object_owner = s.table_owner then',
'        case',
'            when o.object_type like ''PACKAGE%'' then',
'                ''<a href=f?p=4500:2250:''|| :APP_SESSION ||'':FOCUS::RP:OB_OBJECT_ID:''||',
'                (select p.object_id from sys.user_objects p where p.object_name = O.object_name and p.object_type = ''PACKAGE'') ||',
'                ''>'' || apex_escape.html( s.table_name ) || ''</a>''',
'            else',
'                ''<a href=f?p=4500:''|| replace( o.object_type, '' '', ''_'' ) ||''_DETAIL:''|| :APP_SESSION ||',
'                '':FOCUS::RP:OB_OBJECT_ID:''||o.object_id||''>'' || apex_escape.html( s.table_name ) || ''</a>''',
'            end',
'    else',
'        apex_escape.html( s.table_name )',
'    end object_name,',
'    o.object_type,',
'    o.status',
'from sys.user_synonyms S, sys.user_objects O',
'where s.synonym_name = :object_name',
'  and s.table_name = o.object_name(+)'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10107030508545214.4504)
,p_query_column_id=>1
,p_column_alias=>'SYNONYM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome sinonimo'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10107102179545215.4504)
,p_query_column_id=>2
,p_column_alias=>'SYNONYM_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario sinonimo'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10107224398545215.4504)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Proprietario oggetto'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10107303964545215.4504)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nome oggetto'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10107423122545215.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo di oggetto'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10107526835545215.4504)
,p_query_column_id=>6
,p_column_alias=>'STATUS'
,p_column_display_sequence=>6
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10348123946678261.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(10312125668603017.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181326405721581036.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22106731442729037.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02500
begin
wwv_flow_api.create_page(
 p_id=>2500.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TRIGGER_DETAIL'
,p_alias=>'TRIGGER_DETAIL'
,p_step_title=>'TRIGGER_DETAIL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8487717291514341.4504)
,p_plug_name=>'imposta stato'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>3
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'select dt.STATUS into :P2500_STATUS ',
' from sys.dba_triggers dt, sys.dba_objects o',
' where dt.OWNER = o.OWNER',
'  and dt.TRIGGER_NAME = o.OBJECT_NAME',
'  and o.OBJECT_TYPE = ''TRIGGER''',
'  and o.owner = :OBJECT_OWNER',
'  and dt.trigger_name = :OBJECT_NAME;',
'exception when others then ',
':P2500_STATUS := null;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9216416466598229.4504)
,p_plug_name=>'TRIGGER_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9213221268571230.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(10098123067514126.4504)
,p_name=>'Colonne'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select TABLE_OWNER,',
'       TABLE_NAME,',
'       COLUMN_NAME,',
'       DECODE(column_usage,',
'                 ''NEW IN'', ''New'',',
'                 ''NEW OUT'', ''New modified'',',
'                 ''OLD IN'', ''Old'',',
'                 ''OLD OUT'', ''Out modified'') Usage,',
'       do.object_id',
'from   sys.user_trigger_cols, sys.user_objects do',
'where  trigger_name = :OBJECT_NAME',
'  and  table_name    = do.object_name'))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10098432042514135.4504)
,p_query_column_id=>1
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Proprietario tabella'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10098502350514135.4504)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Tabella'
,p_column_link=>'f?p=&APP_ID.:TABLE_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP,:OB_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#TABLE_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10098620542514135.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10098727567514135.4504)
,p_query_column_id=>4
,p_column_alias=>'USAGE'
,p_column_display_sequence=>4
,p_column_heading=>'Uso'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14049616850448962.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Object Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10350605376682366.4504)
,p_plug_name=>'Azioni'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(10314911600608476.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(16467127203312146.4504)
,p_name=>'Dettagli'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.status object_status,',
'       dt.TRIGGER_TYPE,',
'       dt.TRIGGERING_EVENT,',
'       dt.TABLE_OWNER,',
'       dt.BASE_OBJECT_TYPE,',
'       dt.TABLE_NAME,',
'       dt.COLUMN_NAME,',
'       dt.REFERENCING_NAMES,',
'       dt.WHEN_CLAUSE,',
'       dt.STATUS trigger_status,',
'       dt.DESCRIPTION,',
'       dt.ACTION_TYPE,',
'       (select object_id',
'          from sys.user_objects',
'         where object_type = dt.BASE_OBJECT_TYPE',
'           and object_name = dt.TABLE_NAME) link',
'  from sys.user_triggers dt, sys.user_objects o',
' where dt.TRIGGER_NAME = o.OBJECT_NAME',
'   and o.OBJECT_TYPE   = ''TRIGGER''',
'   and dt.trigger_name = :OBJECT_NAME'))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16489213379535289.4504)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato oggetto'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16489305405535289.4504)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo di trigger'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16489406479535289.4504)
,p_query_column_id=>3
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>4
,p_column_heading=>'Evento di trigger'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16489529357535289.4504)
,p_query_column_id=>4
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>6
,p_column_heading=>'Proprietario oggetto di base'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16489617468535289.4504)
,p_query_column_id=>5
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo di oggetto di base'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16489701066535289.4504)
,p_query_column_id=>6
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>7
,p_column_heading=>'Nome oggetto di base'
,p_column_link=>'f?p=&APP_ID.:TABLE_DETAIL:&SESSION.:FOCUS:&DEBUG.:RP:OB_OBJECT_ID:#LINK#'
,p_column_linktext=>'#TABLE_NAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16489810142535289.4504)
,p_query_column_id=>7
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>8
,p_column_heading=>'Nome colonna'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16489904800535290.4504)
,p_query_column_id=>8
,p_column_alias=>'REFERENCING_NAMES'
,p_column_display_sequence=>9
,p_column_heading=>'Nomi di riferimento'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16490016546535290.4504)
,p_query_column_id=>9
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>10
,p_column_heading=>'Clausola WHEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16490119367535290.4504)
,p_query_column_id=>10
,p_column_alias=>'TRIGGER_STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Stato trigger'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16490206533535290.4504)
,p_query_column_id=>11
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>11
,p_column_heading=>'Descrizione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16490305091535290.4504)
,p_query_column_id=>12
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>12
,p_column_heading=>'Tipo di azione'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(99124907392488735.4504)
,p_query_column_id=>13
,p_column_alias=>'LINK'
,p_column_display_sequence=>13
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16476231808445943.4504)
,p_plug_name=>'Disabilita'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>30
,p_plug_source=>'wwv_flow_sw_page_calls.disable_trigger(:object_name,:object_owner,:object_type);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'DISABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16477810945458880.4504)
,p_plug_name=>'Abilita'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>31
,p_plug_source=>'wwv_flow_sw_page_calls.enable_trigger(:object_name,:object_owner,:object_type);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'ENABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16478732762465102.4504)
,p_plug_name=>'Compila'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>32
,p_plug_source=>'wwv_flow_sw_page_calls.do_compile(:object_name,:object_owner,:object_type);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'COMPILE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152215404521610769.4504)
,p_name=>'P2500_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(9216416466598229.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181317927445530516.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22180903709544144.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02501
begin
wwv_flow_api.create_page(
 p_id=>2501.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TRIGGER_ERRORS'
,p_alias=>'TRIGGER_ERRORS'
,p_step_title=>'TRIGGER_ERRORS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9217804122606055.4504)
,p_plug_name=>'TRIGGER_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9213221268571230.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(10000324706107710.4504)
,p_name=>'Errors'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT  line, POSITION, SUBSTR (text, 1, 200) text',
'  FROM  sys.user_errors',
' WHERE  NAME = :OBJECT_NAME',
'    AND TYPE = :OBJECT_TYPE'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_lang.system_message(''CONFIRM.CHART_LINE'')||'':''||',
'wwv_flow_lang.system_message(''OB_POSITION'')||'':''||',
'wwv_flow_lang.system_message(''PAGE_REGION.LIST_ITEM_TEXT'')'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questo trigger non ha errori.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10000523749107712.4504)
,p_query_column_id=>1
,p_column_alias=>'LINE'
,p_column_display_sequence=>1
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10000606065107712.4504)
,p_query_column_id=>2
,p_column_alias=>'POSITION'
,p_column_display_sequence=>2
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10000714307107712.4504)
,p_query_column_id=>3
,p_column_alias=>'TEXT'
,p_column_display_sequence=>3
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22181300208590489.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02503
begin
wwv_flow_api.create_page(
 p_id=>2503.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TRIGGER_SQL'
,p_alias=>'TRIGGER_SQL'
,p_step_title=>'TRIGGER_SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9220327758618956.4504)
,p_plug_name=>'TRIGGER_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9213221268571230.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9995131155100130.4504)
,p_plug_name=>'DDL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<pre class="code">'');',
'',
'wwv_flow_generate_ddl.execute_get_ddl (',
'    p_schema       => :OBJECT_OWNER,',
'    p_objects      => :OBJECT_NAME,',
'    p_object_types => :OBJECT_TYPE,',
'    p_output_type  => ''DISPLAY''',
'    );',
'',
'sys.htp.p(''</pre>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
end;
/
prompt --application/pages/page_02550
begin
wwv_flow_api.create_page(
 p_id=>2550.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TYPE_DETAIL'
,p_alias=>'TYPE_DETAIL'
,p_step_title=>'TYPE_DETAIL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9196124675468146.4504)
,p_plug_name=>'TYPE_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9111807762217267.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(10101307746528647.4504)
,p_name=>'Details'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER OWNER,',
'       TYPE_NAME,',
'       TYPE_OID,',
'       TYPECODE,',
'       ATTRIBUTES,',
'       METHODS,',
'       PREDEFINED,',
'       decode(INCOMPLETE,''YES'',''NO'',''NO'',''YES'',INCOMPLETE) INCOMPLETE,',
'       FINAL,',
'       INSTANTIABLE,',
'       SUPERTYPE_OWNER,',
'       SUPERTYPE_NAME,',
'       LOCAL_ATTRIBUTES,',
'       LOCAL_METHODS,',
'       TYPEID',
'from sys.user_TYPES',
'where TYPE_NAME = :OBJECT_NAME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10101600771528653.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10101703008528654.4504)
,p_query_column_id=>2
,p_column_alias=>'TYPE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10101828029528654.4504)
,p_query_column_id=>3
,p_column_alias=>'TYPE_OID'
,p_column_display_sequence=>3
,p_column_heading=>'OID tipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10101919512528654.4504)
,p_query_column_id=>4
,p_column_alias=>'TYPECODE'
,p_column_display_sequence=>4
,p_column_heading=>'Oggetto/collection'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102022940528654.4504)
,p_query_column_id=>5
,p_column_alias=>'ATTRIBUTES'
,p_column_display_sequence=>5
,p_column_heading=>'N. di attributi'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102124202528654.4504)
,p_query_column_id=>6
,p_column_alias=>'METHODS'
,p_column_display_sequence=>6
,p_column_heading=>'N. di metodi'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102211550528654.4504)
,p_query_column_id=>7
,p_column_alias=>'PREDEFINED'
,p_column_display_sequence=>7
,p_column_heading=>'Predefinito'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102307795528654.4504)
,p_query_column_id=>8
,p_column_alias=>'INCOMPLETE'
,p_column_display_sequence=>8
,p_column_heading=>'Completato'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102422075528654.4504)
,p_query_column_id=>9
,p_column_alias=>'FINAL'
,p_column_display_sequence=>9
,p_column_heading=>'Finale'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102509310528655.4504)
,p_query_column_id=>10
,p_column_alias=>'INSTANTIABLE'
,p_column_display_sequence=>10
,p_column_heading=>'Creazione istanze possibile'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102622534528655.4504)
,p_query_column_id=>11
,p_column_alias=>'SUPERTYPE_OWNER'
,p_column_display_sequence=>11
,p_column_heading=>'Proprietario supertipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102717521528655.4504)
,p_query_column_id=>12
,p_column_alias=>'SUPERTYPE_NAME'
,p_column_display_sequence=>12
,p_column_heading=>'Nome supertipo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102822025528655.4504)
,p_query_column_id=>13
,p_column_alias=>'LOCAL_ATTRIBUTES'
,p_column_display_sequence=>13
,p_column_heading=>'Attributi locali'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10102909660528655.4504)
,p_query_column_id=>14
,p_column_alias=>'LOCAL_METHODS'
,p_column_display_sequence=>14
,p_column_heading=>'Metodi locali'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10103029679528655.4504)
,p_query_column_id=>15
,p_column_alias=>'TYPEID'
,p_column_display_sequence=>15
,p_column_heading=>'Typeid'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10353521652687013.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(10323630778623422.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181327603082589777.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22181611898612735.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02551
begin
wwv_flow_api.create_page(
 p_id=>2551.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TYPE_SYNONYM'
,p_alias=>'TYPE_SYNONYM'
,p_step_title=>'TYPE_SYNONYM'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9198109905474450.4504)
,p_plug_name=>'TYPE_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9111807762217267.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(10005616179114756.4504)
,p_name=>'Synonyms'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT owner, synonym_name',
'  FROM apex_sys_all_synonyms',
' WHERE table_owner = :OBJECT_OWNER',
'   and table_name = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questo tipo non ha sinonimi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10005808653114757.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10005912033114757.4504)
,p_query_column_id=>2
,p_column_alias=>'SYNONYM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'SYNONYM_NAME'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22181903942686111.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02552
begin
wwv_flow_api.create_page(
 p_id=>2552.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TYPE_GRANTS'
,p_alias=>'TYPE_GRANTS'
,p_step_title=>'TYPE_GRANTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(7676404413799609)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9200606719478913.4504)
,p_plug_name=>'TYPE_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9111807762217267.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(9984710245084642.4504)
,p_name=>'Grants'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, COLUMN_NAME object_name',
'from sys.user_col_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME =  :OBJECT_NAME ',
'union all',
'Select PRIVILEGE, GRANTEE, GRANTABLE, GRANTOR, table_NAME object_name',
'from sys.user_tab_privs',
'where owner = :OBJECT_OWNER',
' and TABLE_NAME = :OBJECT_NAME'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Questo tipo non ha concessioni di privilegi.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9984908031084643.4504)
,p_query_column_id=>1
,p_column_alias=>'PRIVILEGE'
,p_column_display_sequence=>1
,p_column_heading=>'Privilegio'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9985022419084643.4504)
,p_query_column_id=>2
,p_column_alias=>'GRANTEE'
,p_column_display_sequence=>2
,p_column_heading=>'Assegnatario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9985105543084643.4504)
,p_query_column_id=>3
,p_column_alias=>'GRANTABLE'
,p_column_display_sequence=>3
,p_column_heading=>'Assegnabile'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9985231113084644.4504)
,p_query_column_id=>4
,p_column_alias=>'GRANTOR'
,p_column_display_sequence=>4
,p_column_heading=>'Concedente'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9985323994084644.4504)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nome oggetto'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16958010285612540.4504)
,p_plug_name=>'grant actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>15
,p_list_id=>wwv_flow_api.id(15238925543915636.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22182208706706434.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02553
begin
wwv_flow_api.create_page(
 p_id=>2553.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'TYPE_SQL'
,p_alias=>'TYPE_SQL'
,p_step_title=>'TYPE_SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9204023963485458.4504)
,p_plug_name=>'TYPE_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(9111807762217267.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9996004620101910.4504)
,p_plug_name=>'DDL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<pre class="code">'');',
'',
'wwv_flow_generate_ddl.execute_get_ddl (',
'    p_schema       => :OBJECT_OWNER,',
'    p_objects      => :OBJECT_NAME,',
'    p_object_types => :OBJECT_TYPE,',
'    p_output_type  => ''DISPLAY''',
'    );',
'',
'sys.htp.p(''</pre>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
end;
/
prompt --application/pages/page_02600
begin
wwv_flow_api.create_page(
 p_id=>2600.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DATABASE_LINK_DETAIL'
,p_alias=>'DATABASE_LINK_DETAIL'
,p_step_title=>'DATABASE_LINK_DETAIL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7832327609905917.4504)
,p_plug_name=>'OB_DATABASE_LINK_DETAIL_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(7818718708685757.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10363627371726530.4504)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(10360630703718055.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1241653799958177324.4504)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(10374424694782564.4504)
,p_name=>'Details'
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :OBJECT_OWNER OWNER,DB_LINK,USERNAME,HOST,CREATED',
'  from sys.user_db_links',
' where db_link = :OBJECT_NAME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun dato trovato.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10374716351782574.4504)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Proprietario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10374821911782574.4504)
,p_query_column_id=>2
,p_column_alias=>'DB_LINK'
,p_column_display_sequence=>2
,p_column_heading=>'DB link'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10374922167782574.4504)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nome utente'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10375023120782574.4504)
,p_query_column_id=>4
,p_column_alias=>'HOST'
,p_column_display_sequence=>4
,p_column_heading=>'Host'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10375125831782574.4504)
,p_query_column_id=>5
,p_column_alias=>'CREATED'
,p_column_display_sequence=>5
,p_column_heading=>'Data creazione'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181328518666594224.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22182531694722561.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_02601
begin
wwv_flow_api.create_page(
 p_id=>2601.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DATABASE_LINK_DDL'
,p_alias=>'DATABASE_LINK_DDL'
,p_step_title=>'OB_DATABASE_LINK_DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7834228741963029.4504)
,p_plug_name=>'OB_DATABASE_LINK_DETAIL_SUBTABS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(7818718708685757.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10368323347734887.4504)
,p_plug_name=>'DDL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_type varchar2(2000);',
'begin',
'',
'select decode(:OBJECT_TYPE,''DATABASE_LINK'',''DATABASE LINK'',:OBJECT_TYPE)',
' into l_type from dual;',
'',
'sys.htp.p(''<pre class="code">'');',
'',
'wwv_flow_generate_ddl.execute_get_ddl (',
'    p_schema       => :OBJECT_OWNER,',
'    p_objects      => :OBJECT_NAME,',
'    p_object_types => l_type,',
'    p_output_type  => ''DISPLAY''',
'    );',
'',
'sys.htp.p(''</pre>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
end;
/
prompt --application/pages/page_02602
begin
wwv_flow_api.create_page(
 p_id=>2602.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Test del database link'
,p_alias=>'DATABASE_LINK_TEST'
,p_step_title=>'Test del database link'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15351823104347268.4504)
,p_plug_name=>'Test del database link'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(969054197194554628.4504)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_plug_template=>wwv_flow_api.id(717403738062820750.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15375416149468259.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15351823104347268.4504)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Fine'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(131351608553070123.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15351823104347268.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2600:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15360005058389360.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15351823104347268.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:DATABASE_LINK_DETAIL:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15489420847359005.4504)
,p_branch_action=>'f?p=&APP_ID.:2603:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15375416149468259.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15353023235356752.4504)
,p_name=>'P2602_LINK'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15351823104347268.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Database link'
,p_source=>'OBJECT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica attributo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15355124405366516.4504)
,p_name=>'P2602_SCHEMA'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(15351823104347268.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'OB_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15366423459423097.4504)
,p_name=>'P2602_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(969054197194554628.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Script SQL'
,p_source=>'select ''select 1 from dual@''||:OBJECT_NAME from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>5
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>unistr('L''istruzione SQL che verr\00E0 eseguita.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15481325779341591.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check Privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :OB_SCHEMA);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(15375416149468259.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15483818638348901.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run Sql'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  :P2603_MSG := wwv_flow_sw_page_calls.test_dblink(:P2602_SQL,:OB_SCHEMA);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(15375416149468259.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15486401800353588.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SAve History'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id ,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P2602_SQL,',
'    p_schema            => :OB_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(15375416149468259.4504)
);
end;
/
prompt --application/pages/page_02603
begin
wwv_flow_api.create_page(
 p_id=>2603.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Stato del test del database link'
,p_step_title=>'Stato del test del database link'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15378905357490906.4504)
,p_plug_name=>'Operazione completata'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Test completato. Il database link funziona.<br>',
'Test del database link completato.<br />',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2603_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15379114389490908.4504)
,p_plug_name=>'Errore'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(737759501522573640.4504)
,p_plug_display_sequence=>50
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Errore durante il test del database link.<br />',
'&P2603_MSG.'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2603_MSG'
,p_plug_display_when_cond2=>'SUCCESS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15379517204490912.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15378905357490906.4504)
,p_button_name=>'OK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15518406976553736.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15379114389490908.4504)
,p_button_name=>'OK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15379329549490911.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15379114389490908.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15380314821490919.4504)
,p_branch_action=>'f?p=&APP_ID.:DATABASE_LINK_DETAIL:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15379517204490912.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15380112368490919.4504)
,p_branch_action=>'f?p=&APP_ID.:2602:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15379329549490911.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15379707387490913.4504)
,p_name=>'P2603_MSG'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Msg'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_03002
begin
wwv_flow_api.create_page(
 p_id=>3002.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'SQL Workshop'
,p_step_title=>'SQL Workshop'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(385762900697898960.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_deep_linking=>'Y'
,p_help_text=>'AEUTL/sql_about.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(769212543972447.4504)
,p_plug_name=>'&P3002_SCHEMA.'
,p_region_sub_css_classes=>'sql-workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_api.id(46900227098494683.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(385894774262579225.4504)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(24083118039996911.4504)
,p_name=>'Script SQL recenti'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P3002c */',
'substr(f.filename,1,50) name,',
'nvl(f.updated_on,f.created_on) updated,',
'f.id',
'from wwv_flow_files f, wwv_flow_fnd_user u',
'where u.security_group_id = :flow_security_group_id',
'and u.user_name = :APP_USER',
'and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'       or exists ( select 1',
'                     from  wwv_flow_developers',
'                    where security_group_id = :flow_security_group_id',
'                      and userid = :APP_USER',
'                      and instr(developer_role||'':'',''ADMIN:'') > 0',
'                    union',
'                   select 1',
'                     from wwv_flow_fnd_user',
'                    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                      and user_name = :APP_USER',
'                      and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))',
'order by updated desc'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1340557295961171098.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(24083118039996911.4504)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(24084858275996928.4504)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(24083855649996918.4504)
,p_query_column_id=>2
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>2
,p_column_heading=>'Aggiornato'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(24083270378996912.4504)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33438082761898212.4504)
,p_plug_name=>'Learn More Region'
,p_region_css_classes=>'a-ButtonRegion--banner apex-sql-workshop'
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>70
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock">'');',
'sys.htp.p(''    <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''        <span class="icon-get-started" aria-hidden="true"></span>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''    <div class="a-MediaBlock-content">'');',
'sys.htp.p(''        <h2>''||wwv_flow_lang.system_message(''LEARN_MORE_SQL_WORKSHOP'')||''</h2>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_platform.get_preference(''GETTING_STARTED_ENABLED'') = ''Y'';'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46904309839593843.4504)
,p_name=>'Tabelle create di recente'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P3002a */ object_name,',
'       created,',
'       object_id,',
'       :P3002_SCHEMA object_owner',
'from sys.user_objects',
'where',
'      object_name not like ''BIN$%'' and',
'      object_type = ''TABLE''',
'order by created desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46912117501975223.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessuna tabella trovata'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P3002_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46904602375593856.4504)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_link=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP,1001:OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA:#OBJECT_ID#,TABLE,#OBJECT_OWNER#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46904718036593858.4504)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>3
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46904828986593858.4504)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(710588573054275238.4504)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_OWNER'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46915904438027404.4504)
,p_name=>'Comandi SQL recenti'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P3002b */',
'    replace(replace(',
'       sys.dbms_lob.substr(command,35,1),chr(10),'' ''),chr(13),'' '')||',
'       decode(greatest(sys.dbms_lob.getlength(command),35),35,null,''...'') sql_cmd,',
'    CREATED_ON created, ',
'    created_by, ',
'    id,',
'    PARSED_SCHEMA',
'from ',
'    wwv_flow_sw_sql_cmds  ',
'where ',
'    security_group_id = :flow_security_group_id  ',
'    and created_by = :flow_user ',
'    and PARSED_SCHEMA = :P3002_SCHEMA',
'order by ',
'    created_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46912117501975223.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Nessun comando SQL trovato'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(46915904438027404.4504)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46917202491036341.4504)
,p_query_column_id=>1
,p_column_alias=>'SQL_CMD'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46916227762027412.4504)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46917330903036341.4504)
,p_query_column_id=>3
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>3
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46917410539036341.4504)
,p_query_column_id=>4
,p_column_alias=>'ID'
,p_column_display_sequence=>4
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46917526117036341.4504)
,p_query_column_id=>5
,p_column_alias=>'PARSED_SCHEMA'
,p_column_display_sequence=>5
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48531311825296092.4504)
,p_plug_name=>'Informazioni'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL Workshop \00E8 una raccolta di strumenti per la gestione degli oggetti di database.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeutl/getting-started.html">Ulteriori informazioni...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201516612078031858.4504)
,p_plug_name=>'Schema'
,p_region_css_classes=>'a-Form--floatColsLeft'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Form--leftLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>65
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'Selezionare lo schema di database predefinito per la sessione di SQL Workshop.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239952824355031188.4504)
,p_plug_name=>'Crea oggetto'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(149627725126847053.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20507805987268923.4504)
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'OB_SCHEMA'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201517111863041261.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(201516612078031858.4504)
,p_button_name=>'SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Imposta'
,p_button_execute_validations=>'N'
,p_button_cattributes=>'style="margin: 8px"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33441178232898243.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33438082761898212.4504)
,p_button_name=>'GET_STARTED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Introduzione'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/go/get_started_sql_workshop'');'
,p_button_css_classes=>'a-Button--dark'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27786530080161924.4504)
,p_branch_action=>'f?p=&APP_ID.:3002:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46910410185943935.4504)
,p_name=>'P3002_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(201516612078031858.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select /* APEX4500L1 */ wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''  and  nvl(:P1003_POPUP,0) <> 1 '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_escape.html(:P1003_SCHEMA) a,:P1003_SCHEMA b from dual '';',
'  q:=q||''where  :P1003_POPUP = 1 '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_tag_css_classes=>'a-Form-field stretch'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171443012411362459.4504)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3002'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201517700566047477.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv(:P3002_SCHEMA);',
':OB_SCHEMA := :P3002_SCHEMA;',
':P800_SCHEMA := :P3002_SCHEMA;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46913903783979944.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3002_SCHEMA := upper(wwv_flow_user_api.get_default_schema);',
':OB_SCHEMA := :P3002_SCHEMA;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P3002_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46968921284148678.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P3002_SCHEMA);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_03100
begin
wwv_flow_api.create_page(
 p_id=>3100.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica dati'
,p_page_mode=>'MODAL'
,p_step_title=>'Carica dati'
,p_reload_on_submit=>'A'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div#configureColumns {',
'    margin-left: calc(30% + 8px);',
'    box-shadow: none;',
'    margin-right: 16px;',
'    margin-top: 4px;',
'    margin-bottom: 4px;',
'}',
'',
'#configureColumns .a-Alert-body {',
'  margin: 0;',
'}',
'',
'div#configureColumns .a-Alert-icon, ',
'div#configureColumns .a-Alert-content, ',
'div#configureColumns .a-Alert-buttons {',
'  padding: 8px 0;',
'}',
'',
'div#configureColumns .a-Alert-buttons {',
'    padding: 8px;',
'}',
'',
'div#configureColumns .a-Report-cell {',
'  padding: 0 8px;',
'  background-color: transparent;',
'}'))
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
,p_dialog_height=>'720'
,p_dialog_width=>'1024'
,p_dialog_attributes=>'resizable:true'
,p_dialog_css_classes=>'a-Page--DataLoad &P3100_BODY_CLASS.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1620249167834602.4504)
,p_plug_name=>'File'
,p_region_name=>'drag_drop_file'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>60
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1623796617834637.4504)
,p_plug_name=>'File caricato'
,p_region_name=>'load_completed'
,p_parent_plug_id=>wwv_flow_api.id(1620249167834602.4504)
,p_region_css_classes=>'a-FileDrop'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-item-group apex-item-group--file upload-completed">',
'  <div class="apex-item-file-dropzone" aria-hidden="true">',
'    <span class="a-FileDrop-icon"><span class="a-Icon a-Icon--large icon-ig-dl-xls" aria-hidden="true"></span></span>',
'    <span class="a-FileDrop-label">&P3100_FILE_NAME.</span>',
'  </div>',
'</div>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3100_FILE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1620435155834604.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1697074737214101.4504)
,p_plug_name=>'Anteprima'
,p_region_css_classes=>'a-DataLoad-preview'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>95
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1621706117834617.4504)
,p_name=>'Dati analizzati'
,p_region_name=>'preview_table'
,p_parent_plug_id=>wwv_flow_api.id(1697074737214101.4504)
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select line_number, col001,col002,col003,col004,col005,col006,col007,col008,col009,col010',
'from apex_application_temp_files f, ',
'     table( wwv_flow_data_parser.parse(',
'                p_content               => f.blob_content,',
'                p_file_name             => f.filename,',
'                --   ',
'                p_add_headers_row       => ''Y'',',
'                -- please *always* set p_max_rows as a safeguard against fully parsing large files',
'                p_max_rows              => nullif(:P3100_MAX_ROW_COUNT, ''0''),',
'                -- for parser to return p_return_rows, region max rows must be > p_return_rows',
'                p_return_rows           => 5,',
'                p_xlsx_sheet_name       => ( case when :P3100_FILE_TYPE = 1 and :P3100_XLSX_SHEET is not null then :P3100_XLSX_SHEET end ),',
'                p_csv_col_delimiter     => replace(:P3100_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                p_file_charset          => coalesce( :P3100_FILE_CHARSET, ''AL32UTF8'' ),',
'                p_csv_enclosed          => nullif( :P3100_CSV_ENCLOSED, ''None'' ),',
'                p_force_trim_whitespace => :P3120_TRIM_WHITESPACE,',
'                p_nullif                => :P3120_NULLIF )',
'                )',
'where f.name = :P3100_FILE',
'and :P3100_SOURCE_TYPE = ''FILE''',
'union all',
'select line_number, col001,col002,col003,col004,col005,col006,col007,col008,col009,col010',
'from apex_collections c, ',
'     table( wwv_flow_data_parser.parse(',
'                p_content               => c.blob001,',
'                p_file_type             => 2,',
'                --   ',
'                p_add_headers_row       => ''Y'',',
'                p_max_rows              => nullif(:P3100_MAX_ROW_COUNT, ''0''),',
'                -- for parser to return p_return_rows, region max rows must be > p_return_rows',
'                p_return_rows           => 5,',
'                p_csv_col_delimiter     => replace(:P3100_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                p_file_charset          => coalesce( :P3100_FILE_CHARSET, ''AL32UTF8'' ),',
'                p_force_trim_whitespace => :P3120_TRIM_WHITESPACE,',
'                p_csv_enclosed          => nullif( :P3100_CSV_ENCLOSED, ''None'' ),',
'                p_nullif                => :P3120_NULLIF )',
'                )',
'where c.collection_name=''CLOB_CONTENT''',
'and :P3100_SOURCE_TYPE = ''COPY_PASTE'';',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_row_count_max=>150
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1621834152834618.4504)
,p_query_column_id=>1
,p_column_alias=>'LINE_NUMBER'
,p_column_display_sequence=>1
,p_column_heading=>'Riga'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1621903762834619.4504)
,p_query_column_id=>2
,p_column_alias=>'COL001'
,p_column_display_sequence=>2
,p_column_heading=>'COL001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622051084834620.4504)
,p_query_column_id=>3
,p_column_alias=>'COL002'
,p_column_display_sequence=>3
,p_column_heading=>'COL002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622187965834621.4504)
,p_query_column_id=>4
,p_column_alias=>'COL003'
,p_column_display_sequence=>4
,p_column_heading=>'COL003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622266185834622.4504)
,p_query_column_id=>5
,p_column_alias=>'COL004'
,p_column_display_sequence=>5
,p_column_heading=>'COL004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622338030834623.4504)
,p_query_column_id=>6
,p_column_alias=>'COL005'
,p_column_display_sequence=>6
,p_column_heading=>'COL005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622446791834624.4504)
,p_query_column_id=>7
,p_column_alias=>'COL006'
,p_column_display_sequence=>7
,p_column_heading=>'COL006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622556563834625.4504)
,p_query_column_id=>8
,p_column_alias=>'COL007'
,p_column_display_sequence=>8
,p_column_heading=>'COL007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622647721834626.4504)
,p_query_column_id=>9
,p_column_alias=>'COL008'
,p_column_display_sequence=>9
,p_column_heading=>'COL008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622722391834627.4504)
,p_query_column_id=>10
,p_column_alias=>'COL009'
,p_column_display_sequence=>10
,p_column_heading=>'COL009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1622845352834628.4504)
,p_query_column_id=>11
,p_column_alias=>'COL010'
,p_column_display_sequence=>11
,p_column_heading=>'COL010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1753932155870113.4504)
,p_plug_name=>'get file profile and save'
,p_region_name=>'getFileProfile'
,p_parent_plug_id=>wwv_flow_api.id(1697074737214101.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile             clob;',
'    l_file_content        blob;',
'    l_profile_record      wwv_flow_data_parser.t_file_profile;',
'begin',
'    l_profile        := wwv_flow_data_parser.get_file_profile;',
'    l_profile_record := wwv_flow_data_parser.json_to_profile( l_profile );',
'  ',
'    if :P3100_FIRST_LINE is null or :P3100_FIRST_LINE != ''HEADERS'' then',
'        for i in 1 .. l_profile_record.file_columns.count loop',
'            l_profile_record.file_columns( i ).name := ''COL'' || lpad( i,3,''0'');',
'        end loop;',
'        l_profile := wwv_flow_data_parser.profile_to_json(l_profile_record);',
'    end if;',
'    ',
'    -- save file profile in collection for later use',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'    wwv_flow_collection.add_member( ''APEX$DATALOAD'', p_clob001 => l_profile );',
'    ',
'    :P3100_FILE_TYPE           := l_profile_record.file_type;',
'    :P3100_CSV_COL_DELIMITER   := l_profile_record.csv_delimiter;',
'    :P3100_NEW_COL_DELIMITER   := ( case when l_profile_record.csv_delimiter = chr(9) then ''tab'' else l_profile_record.csv_delimiter end );',
'    :P3100_PARSED_ROW_COUNT    := l_profile_record.parsed_rows;',
'    ',
'    if l_profile_record.file_columns.count <= 10 then',
'        :P3100_PARSED_COLUMN_COUNT := l_profile_record.file_columns.count;',
'    else',
'        :P3100_PARSED_COLUMN_COUNT := 10;',
'    end if;',
'',
'    :P3100_FILE_COLUMN_COUNT   := l_profile_record.file_columns.count;',
'    :P3100_FILE_INVALID        := ''N'';',
'exception',
'    when others then',
'        :P3100_FILE_INVALID := ''Y'';',
'        wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16455974874013422.4504)
,p_plug_name=>'Preview Information'
,p_parent_plug_id=>wwv_flow_api.id(1697074737214101.4504)
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_icon_css_classes=>'icon-report'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="desc">Analizzate le prime <span id="placeholder_P3100_PARSED_ROW_COUNT">&P3100_PARSED_ROW_COUNT.</span> righe per effettuare il campionamento dei tipi di colonna. Nell''anteprima riportata di seguito vengono visualizzate solo le prime <span '
||'id="placeholder_P3100_PARSED_COLUMN_COUNT">&P3100_PARSED_COLUMN_COUNT.</span> colonne e 5 righe. Per visualizzare l''intera anteprima e configurare le impostazioni di caricamento dei dati, fare clic sul pulsante <strong>Anteprima</strong>.</p>',
''))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1700073592214131.4504)
,p_plug_name=>'Impostazioni'
,p_region_name=>'settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>85
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16455885026013421.4504)
,p_plug_name=>'Settings Item Container'
,p_parent_plug_id=>wwv_flow_api.id(1700073592214131.4504)
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3993380922355405.4504)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6218048841571854.4504)
,p_plug_name=>'Informazioni caricamento'
,p_region_name=>'load-to-table'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>105
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2829146353927247.4504)
,p_name=>'Job ancora in esecuzione per il caricamento dei dati'
,p_parent_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_template=>wwv_flow_api.id(717419046555820782.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    j.job_name, ',
'    j.state,',
'    j.start_date,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,2,''i'',2 ) as workspace_user,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,3,''i'',2 ) as table_owner,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,4,''i'',2 ) as table_name',
' from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'  and c.display_name = :COMPANY',
'  and j.state = ''RUNNING''',
'  and job_name like ''ORACLE_APEX_DTLD$%'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
' from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'  and c.display_name = :COMPANY ',
'  and j.state = ''RUNNING''',
'  and job_name like ''ORACLE_APEX_DTLD$%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(218530990339706541.4504)
,p_query_column_id=>1
,p_column_alias=>'JOB_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome del job DBMS_SCHEDULER'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(218529334602706525.4504)
,p_query_column_id=>2
,p_column_alias=>'STATE'
,p_column_display_sequence=>2
,p_column_heading=>'Stato job'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(218529455390706526.4504)
,p_query_column_id=>3
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Avviato'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(218529523739706527.4504)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_USER'
,p_column_display_sequence=>4
,p_column_heading=>'Utente area di lavoro'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(218529625567706528.4504)
,p_query_column_id=>5
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Proprietario tabella'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(218529730064706529.4504)
,p_query_column_id=>6
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Nome tabella'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(52175039421071205.4504)
,p_plug_name=>'Specificare la posizione in cui si desidera caricare i dati.'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>65
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(52038037134715336.4504)
,p_plug_name=>'Informazioni tabella di base'
,p_parent_plug_id=>wwv_flow_api.id(52175039421071205.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(52038248707715338.4504)
,p_plug_name=>'Definizione tabella'
,p_parent_plug_id=>wwv_flow_api.id(52175039421071205.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(52038303945715339.4504)
,p_plug_name=>'Campi aggiuntivi'
,p_parent_plug_id=>wwv_flow_api.id(52175039421071205.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(82702857605738101.4504)
,p_name=>'Configure Information'
,p_region_name=>'configureColumns'
,p_parent_plug_id=>wwv_flow_api.id(52175039421071205.4504)
,p_template=>wwv_flow_api.id(746376253838324384.4504)
,p_display_sequence=>30
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_icon_css_classes=>'icon-report'
,p_region_template_options=>'a-Alert--colorBG:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--noBorders'
,p_region_attributes=>'style="display: none;"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_info           varchar2(32767);',
'    l_mapped_col_cnt number;',
'    l_file_col_cnt   number;',
'begin',
'    l_mapped_col_cnt := to_number(:P3100_MAPPED_COLUMN_COUNT);',
'    l_file_col_cnt := to_number(:P3100_FILE_COLUMN_COUNT);',
'    ',
'    if :P3100_LOAD_TO = ''EXISTING'' then',
'        if l_mapped_col_cnt = 0 then',
'            l_info := wwv_flow_lang.system_message( ''DATA.LOAD.DEFINE_COL_MAPPING'', wwv_flow_escape.html(:P3100_EXISTING_TABLE ));',
'        else',
'            if l_mapped_col_cnt = l_file_col_cnt then',
'                l_info := wwv_flow_lang.system_message( ''DATA.LOAD.ALL_COL_MAPPED'', :P3100_FILE_COLUMN_COUNT, wwv_flow_escape.html(:P3100_EXISTING_TABLE ) );',
'            elsif l_mapped_col_cnt < l_file_col_cnt then',
'                l_info := wwv_flow_lang.system_message( ''DATA.LOAD.MAP_REMAINING_COLS'', :P3100_MAPPED_COLUMN_COUNT, :P3100_FILE_COLUMN_COUNT, wwv_flow_escape.html(:P3100_EXISTING_TABLE ) );',
'            end if;',
'        end if;',
'    else',
'        l_info := wwv_flow_lang.system_message(''DATA.LOAD.SELECT_COLS'');',
'    end if;',
'',
'    return ''select ''||wwv_flow_assert.enquote_literal(l_info)||'' info from sys.dual'';',
'end;'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(82703320182738106.4504)
,p_query_column_id=>1
,p_column_alias=>'INFO'
,p_column_display_sequence=>1
,p_column_heading=>'Informazioni'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(118039895666597546.4504)
,p_plug_name=>'Choose Source'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type is null then',
'    return true;',
'else',
'    if :p3100_source_type = ''FILE'' then',
'      if :P3100_FILE is null then',
'          return true;',
'      end if;',
'    elsif :p3100_source_type = ''COPY_PASTE'' then',
'      if :P3100_DATA is null then',
'          return true;',
'      end if;',
'    end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(118040030879597548.4504)
,p_plug_name=>'Copia e incolla contenitore'
,p_region_name=>'copy_paste_file'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>40
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(217930797515203801.4504)
,p_plug_name=>'Esempi'
,p_parent_plug_id=>wwv_flow_api.id(118040030879597548.4504)
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('\00C8 possibile copiare e incollare i dati CSV o selezionare un data set di esempio.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P3100_DATA'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(217930831433203802.4504)
,p_plug_name=>'Copia e incolla area di testo'
,p_parent_plug_id=>wwv_flow_api.id(118040030879597548.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2976007666683831.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P3100_DATA'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212734359026785604.4504)
,p_plug_name=>'Dati incollati'
,p_region_css_classes=>'a-FileDrop'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>50
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="apex-item-group apex-item-group--file upload-completed">'');',
'sys.htp.p(''  <div class="apex-item-file-dropzone" aria-hidden="true">'');',
'sys.htp.p(''    <span class="a-FileDrop-icon"><span class="a-Icon a-Icon--large icon-page-dynamic" aria-hidden="true"></span></span>'');',
'sys.htp.p(''    <span class="a-FileDrop-label">''||wwv_flow_lang.system_message(''DATA.LOAD.PASTED_DATA'')||''</span>'');',
'sys.htp.p(''  </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3100_DATA'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon a-Icon--large icon-clipboard" aria-hidden="true"></span>',
'The data pasted and parsed.'))
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1620594128834605.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1620435155834604.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4142265341584031.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16455974874013422.4504)
,p_button_name=>'FULL_PREVIEW'
,p_button_static_id=>'bt-full-preview'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Anteprima'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:RP,3120:P3120_FIRST_LINE,P3120_MAX_ROW_COUNT,P3120_PREV_MAX_ROW_COUNT,P3120_XLSX_SHEET,P3120_CSV_COL_DELIMITER,P3120_CSV_ENCLOSED,P3120_FILE_CHARSET,P3120_FILE_SIZE,P3120_NULLIF,P3120_ACTION:&P3100_FIRST_LINE.,&P3100_MAX_ROW_COUNT.,&P3100_PREV_MAX_ROW_COUNT.,&P3100_XLSX_SHEET.,\&P3100_CSV_COL_DELIMITER.\,\&P3100_CSV_ENCLOSED.\,&P3100_FILE_CHARSET.,&P3100_FILE_SIZE.,&P3120_NULLIF.,tab_preview'
,p_icon_css_classes=>'icon-open-in-dialog margin-left-sm'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(212734620593785607.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1620435155834604.4504)
,p_button_name=>'NEXT'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Successivo'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.widget.textareaClob.uploadNonEmpty(''P3100_DATA'', ''NEXT'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_DATA is null and :P3100_FILE is null then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1620874202834608.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1620435155834604.4504)
,p_button_name=>'LOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Carica dati'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null and coalesce( :P3100_FILE_INVALID, ''N'' ) = ''N'' then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null and coalesce( :P3100_FILE_INVALID, ''N'' ) = ''N'' then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(69708360594469904.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(82702857605738101.4504)
,p_button_name=>'CONFIGURE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Configura'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:RP,3120:P3120_FIRST_LINE,P3120_MAX_ROW_COUNT,P3120_PREV_MAX_ROW_COUNT,P3120_XLSX_SHEET,P3120_CSV_COL_DELIMITER,P3120_CSV_ENCLOSED,P3120_FILE_CHARSET,P3120_FILE_SIZE,P3120_NULLIF,P3120_ACTION:&P3100_FIRST_LINE.,&P3100_MAX_ROW_COUNT.,&P3100_PREV_MAX_ROW_COUNT.,&P3100_XLSX_SHEET.,\&P3100_CSV_COL_DELIMITER.\,\&P3100_CSV_ENCLOSED.\,&P3100_FILE_CHARSET.,&P3100_FILE_SIZE.,&P3120_NULLIF.,tab_columns'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null and coalesce( :P3100_FILE_INVALID, ''N'' ) = ''N'' then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null and coalesce( :P3100_FILE_INVALID, ''N'' ) = ''N'' then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-open-in-dialog margin-left-sm'
);
end;
/
begin
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1698876190214119.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1620435155834604.4504)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1698422687214115.4504)
,p_branch_name=>'View Load Detail'
,p_branch_action=>'f?p=&APP_ID.:3110:&SESSION.::&DEBUG.:RP,3110:P3110_LOAD_TO:&P3100_LOAD_TO.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1620874202834608.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4095429302018728.4504)
,p_branch_name=>'Upload File'
,p_branch_action=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'UPLOAD_FILE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1620366629834603.4504)
,p_name=>'P3100_FILE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1620249167834602.4504)
,p_prompt=>'Carica file'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3100_SOURCE_TYPE = ''FILE'' and',
':P3100_FILE is null'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-FileDrop data-load-input'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_12=>'NATIVE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1623446560834634.4504)
,p_name=>'P3100_CSV_COL_DELIMITER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(16455885026013421.4504)
,p_prompt=>'Delimitatore colonne'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov=>'.'||wwv_flow_api.id(3927422505659936.4504)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare un carattere delimitatore di colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1623832490834638.4504)
,p_name=>'P3100_FILE_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1623974907834639.4504)
,p_name=>'P3100_FILE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1623796617834637.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1624290645834642.4504)
,p_name=>'P3100_FIRST_LINE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16455885026013421.4504)
,p_prompt=>'Intestazioni colonna'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DATA.LOAD.FIRST_LINE'
,p_lov=>'.'||wwv_flow_api.id(3934090607812623.4504)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) not in (wwv_flow_data_parser.c_file_type_xml, wwv_flow_data_parser.c_file_type_json) then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare questa opzione se i dati contengono nomi di colonne nella prima riga.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1701709661214148.4504)
,p_name=>'P3100_XLSX_SHEET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16455885026013421.4504)
,p_prompt=>'Seleziona foglio'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_file_name',
'from apex_application_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_''',
'  and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' )',
'  and rownum = 1',
'order by sheet_sequence'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_display_name, sheet_file_name',
'from apex_application_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_''',
'  and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' )',
'order by sheet_sequence;'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sheet_cnt number := 0;',
'begin',
'    -- shortcut: return immediately when we don''t have an XLSX file, since invoking wwv_flow_data_parser.get_xlsx_worksheets',
'    -- is an expensive operation leading to nothing',
'    if lower( :P3100_FILE ) not like ''%.xls_'' then',
'        return false;',
'    end if;',
'',
'    select count(*)',
'    into l_sheet_cnt',
'    from apex_application_temp_files f, ',
'         table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                    p_content => f.blob_content ) )',
'    where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_''',
'      and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' );',
'    ',
'    -- if there is multiple sheets, display',
'    if ( l_sheet_cnt > 1 ) then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'exception',
'    when others then ',
'        return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Il file contiene pi\00F9 fogli di lavoro. Selezionare il foglio di lavoro che si desidera caricare.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1755986144870133.4504)
,p_name=>'P3100_CSV_ENCLOSED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16455885026013421.4504)
,p_prompt=>'Racchiuso da'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov=>'.'||wwv_flow_api.id(3931221323686172.4504)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Selezionare un carattere in cui racchiudere i valori della colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1821527306529505.4504)
,p_name=>'P3100_PARSED_COLUMN_COUNT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1821614646529506.4504)
,p_name=>'P3100_MAX_ROW_COUNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16455885026013421.4504)
,p_item_default=>'200'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Selezionare il numero massimo di righe da utilizzare per effettuare il campionamento dei tipi di colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1835450193875914.4504)
,p_name=>'P3100_PARSED_ROW_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2877400520221585.4504)
,p_name=>'P3100_TABLE_OWNER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(52038037134715336.4504)
,p_prompt=>'Proprietario tabella'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Selezionare lo schema di database da creare e in cui caricare i dati.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2878249657221664.4504)
,p_name=>'P3100_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(52038248707715338.4504)
,p_prompt=>'Nome tabella'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identificare il nome della tabella da creare. Per impostazione predefinita, tutti i nomi di tabella vengono convertiti in lettere maiuscole.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2879125861221669.4504)
,p_name=>'P3100_ERROR_TABLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(52038303945715339.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identificare il nome della tabella di errori desiderata per salvare gli errori durante il caricamento dei dati. Per impostazione predefinita, tutti nomi di tabella vengono convertiti in lettere maiuscole. Se il caricamento dei dati viene completato s'
||'enza errori, questa tabella di errori viene eliminata automaticamente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2880013230221675.4504)
,p_name=>'P3100_USE_DATA_TYPES'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(52038303945715339.4504)
,p_item_default=>'Y'
,p_prompt=>'Usa tipi di dati'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DATA.LOAD.USE_DATA_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2791739671154769.4504)||'.'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Selezionare questa opzione per utilizzare i tipi di colonna analizzati dal file. Se deselezionata, le colonne della tabella verranno create come VARCHAR2(4000).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3714657994479804.4504)
,p_name=>'P3100_LOAD_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3993413092355406.4504)
,p_name=>'P3100_SHOW_CONFIG_SAVED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3993380922355405.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3994208357355414.4504)
,p_name=>'P3100_BODY_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3993380922355405.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4093251523018706.4504)
,p_name=>'P3100_NEW_COL_DELIMITER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4093425258018708.4504)
,p_name=>'P3100_FILE_SIZE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4094333119018717.4504)
,p_name=>'P3100_PREV_MAX_ROW_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16455885026013421.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4142757793584036.4504)
,p_name=>'P3100_FILE_INVALID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3993380922355405.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4143126851584040.4504)
,p_name=>'P3100_FILE_CHARSET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16455885026013421.4504)
,p_item_default=>'AL32UTF8'
,p_prompt=>'Codifica file'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_DB_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(143362112016702427.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Scegliere il set di caratteri in cui il file \00E8 codificato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52175474041071209.4504)
,p_name=>'P3100_LOAD_TO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(52038037134715336.4504)
,p_item_default=>'NEW'
,p_prompt=>'Carica in'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P3100_LOAD_TO'
,p_lov=>'.'||wwv_flow_api.id(60089930390905970.4504)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52175634888071211.4504)
,p_name=>'P3100_EXISTING_TABLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(52038248707715338.4504)
,p_prompt=>'Tabella'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name a, table_name b',
'from sys.dba_tables',
'where owner=:P3100_TABLE_OWNER',
'and table_name not like ''BIN$%''',
'order by table_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona tabella -'
,p_lov_cascade_parent_items=>'P3100_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>50
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare la tabella di database in cui si desidera caricare i dati.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52176221364071217.4504)
,p_name=>'P3100_UPDATE_METHOD'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(52038303945715339.4504)
,p_item_default=>'APPEND'
,p_prompt=>'Aggiorna metodo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P3100_UPDATE_METHOD'
,p_lov=>'.'||wwv_flow_api.id(60103143434104047.4504)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>Aggiungi</strong>: se nella tabella sono gi\00E0 presenti dei dati, la procedura guidata aggiunge le nuove righe nella tabella. Se i dati non sono presenti, le nuove righe vengono semplicemente caricate.</li>'),
'    <li><strong>Sostituisci</strong>: viene sostituita l''intera tabella; prima viene eliminato l''intero contenuto della tabella, quindi le nuove righe vengono caricate nella tabella.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(82692293286962401.4504)
,p_name=>'P3100_MAPPED_COLUMN_COUNT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(118039922747597547.4504)
,p_name=>'P3100_SOURCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(118039895666597546.4504)
,p_item_default=>'FILE'
,p_prompt=>'Tipo di origine'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(212732804335774230.4504)||'.'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'apex-button-group a-DataLoad-sourceType'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(207424569646369642.4504)
,p_name=>'P3100_FORCE_SYSGUID_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(52038303945715339.4504)
,p_item_default=>'N'
,p_prompt=>'Chiavi primarie'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.FORCE_SYSGUID'
,p_lov=>'.'||wwv_flow_api.id(325824092198610958.4504)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_display_when=>'sys.dbms_db_version.version >= 12'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selezionare la modalit\00E0 di impostazione della chiave primaria. Le chiavi primarie possono essere impostate utilizzando SYS_GUID o la colonna identit\00E0.</p>'),
'<p>',
'SYS_GUID genera e restituisce un identificativo univoco globale. Nella maggior parte delle piattaforme, questo identificativo generato si basa su un identificativo host, un identificativo di processo o di thread del processo o del thread che richiama'
||' la funzione e su un valore non ricorrente (sequenza di byte). ',
'</p>',
'<p>',
unistr('<strong>SYS_GUID</strong> utilizza una maggiore quantit\00E0 di spazio, ma \00E8 imprevedibile. <strong>Colonna identit\00E0</strong> \00E8 un valore compatto, ma pu\00F2 essere prevedibile.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(212734444925785605.4504)
,p_name=>'P3100_DATA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(217930831433203802.4504)
,p_prompt=>'Copia e incolla dati'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>10
,p_tag_attributes=>'spellcheck="false"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(212736048149785621.4504)
,p_name=>'P3100_LOAD_SAMPLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(217930797515203801.4504)
,p_prompt=>'Esempio'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SAMPLE.DATA.SPREADSHEETS'
,p_lov=>'.'||wwv_flow_api.id(217855733246275209.4504)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona esempio -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'hide-visibility'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(275647023544510048.4504)
,p_name=>'P3100_FILE_COLUMN_COUNT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(6218048841571854.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4264573968082529.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3100_FIRST_LINE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P3100_FIRST_LINE'
,p_compute_when_text=>'CHANGE_TO_NULL'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(90116888862448617.4504)
,p_computation_sequence=>20
,p_computation_item=>'P3100_FILE_CHARSET'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_bom       raw(4);',
'    l_file_blob blob;',
'    l_charset   varchar2(20) := ''WE8ISO8859P1'';',
'begin ',
'    select f.blob_content',
'      into l_file_blob',
'      from apex_application_temp_files f ',
'     where f.name = :P3100_FILE',
'       and :P3100_SOURCE_TYPE = ''FILE'';',
'',
'    if sys.dbms_lob.getlength( l_file_blob ) > 2 then',
'        l_bom := sys.dbms_lob.substr( lob_loc => l_file_blob, amount => 3, offset => 1 );',
'        if l_bom = hextoraw(''EFBBBF'') then',
'            -- UTF-8 BOM',
'            l_charset := ''AL32UTF8'';',
'        else',
'            -- UTF-16 BOM',
'            if sys.utl_raw.substr(l_bom, 1, 2) = hextoraw(''FEFF'') then ',
'                l_charset := ''AL16UTF16''; ',
'            elsif sys.utl_raw.substr(l_bom, 1, 2) = hextoraw(''FFFE'') then ',
'                l_charset := ''AL16UTF16LE''; ',
'            end if; ',
'        end if;',
'    end if;',
'    return l_charset;',
'exception',
'    when NO_DATA_FOUND then',
'        return null;',
'end;'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE   = ''FILE''    and ',
'   :P3100_FILE          is not null and ',
'   :P3100_FILE_CHARSET  is null and',
'   substr( lower ( :P3100_FILE ), -4 ) in ( ''.txt'', ''.csv'', ''.tsv'' ) ',
'then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2825983102927215.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3100_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P3100_TABLE_NAME)'
,p_compute_when=>'P3100_LOAD_TO'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2826085522927216.4504)
,p_computation_sequence=>20
,p_computation_item=>'P3100_ERROR_TABLE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_loader_dev.get_error_table_name(',
'    p_table_owner => :P3100_TABLE_OWNER,',
'    p_table_name  => (',
'                     case when :P3100_LOAD_TO = ''NEW'' then',
'                         :P3100_TABLE_NAME',
'                     when :P3100_LOAD_TO = ''EXISTING'' then',
'                         :P3100_EXISTING_TABLE',
'                     end) );'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4264646118082530.4504)
,p_computation_sequence=>30
,p_computation_item=>'P3100_FIRST_LINE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'HEADERS'
,p_compute_when=>'UPLOAD_FILE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(55560538278883047.4504)
,p_computation_sequence=>40
,p_computation_item=>'P3100_CSV_ENCLOSED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'"'
,p_compute_when=>'UPLOAD_FILE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2826480966927220.4504)
,p_validation_name=>'table name not null'
,p_validation_sequence=>10
,p_validation=>'P3100_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2883179759304436.4504)
,p_validation_name=>'table name not > 30 (11g) or > 128 (12.2)'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if length(:P3100_TABLE_NAME) > wwv_flow_global.c_dbms_id_length then',
'  return wwv_flow_lang.system_message(''F4300.TABLE_NAMES_NOT_LONGER_THAN_30'',wwv_flow_global.c_dbms_id_length);',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(2878249657221664.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2883434847305509.4504)
,p_validation_name=>'cannot have same table name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from sys.dba_tables',
'where table_name = :P3100_TABLE_NAME',
'and owner = :P3100_TABLE_OWNER;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('#LABEL# esiste gi\00E0.')
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(2878249657221664.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2883783996306921.4504)
,p_validation_name=>'table name is reserved word'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_sw_util.is_database_reserved_word(p_word=>:P3100_TABLE_NAME) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Il nome identificato #LABEL# \00E8 una parola riservata Oracle. Scegliere un altro nome.')
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(2878249657221664.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2829413078927250.4504)
,p_validation_name=>'cannot load until other jobs finish'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_running_job_cnt number;',
'begin',
'',
'    select count(*) into l_running_job_cnt',
'     from user_scheduler_jobs j, wwv_flow_companies c',
'    where job_name like ''ORACLE_APEX_DTLD$%''',
'      --',
'      and c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'      and c.display_name = :COMPANY  ',
'      -- ',
'      and state   = ''RUNNING''',
'      and rownum <= ( wwv_flow_data_loader.c_max_jobs_per_apex_session + 1 ) ;',
'    ',
'    if l_running_job_cnt >= wwv_flow_data_loader.c_max_jobs_per_apex_session then',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Vi sono altri job ancora in esecuzione per il caricamento dei dati. Attendere il completamento di questi job.'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74472471070949601.4504)
,p_validation_name=>'uploaded file is too large'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_size         number;',
'    l_overall_file_size number := wwv_flow_platform.get_preference(''DATA_LOADING_MAX_FILE_SIZE'');',
'begin',
'    begin',
'        select sys.dbms_lob.getlength( blob_content )',
'          into l_file_size',
'          from wwv_flow_temp_files',
'         where name = :P3100_FILE;',
'    exception ',
'        when NO_DATA_FOUND then',
'            return null;',
'        when TOO_MANY_ROWS then',
'            return null;',
'    end;',
'    ',
'    -- overall file size limit, configured in instance settings',
'    if l_overall_file_size is not null and l_file_size > l_overall_file_size then',
'        :P3100_FILE := null;',
'        return wwv_flow_lang.system_message( p_name => ''WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'',',
'                                             p0     => '''',',
'                                             p1     => round( l_overall_file_size / 1048576 ) );    ',
'    end if;',
'    ',
'    -- specific file size limits',
'    if :P3100_FILE like ''%xml'' then',
'        if l_file_size > 104857600 then',
'            :P3100_FILE := null;',
'            return wwv_flow_lang.system_message( p_name => ''WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'',',
'                                                 p0     => ''XML'',',
'                                                 p1     => ''100'');',
'        end if;',
'    elsif :P3100_FILE like ''%js'' or :P3100_FILE like ''%json'' then',
'        if sys.dbms_db_version.version < 12 or ( sys.dbms_db_version.version = 12 and sys.dbms_db_version.release = 1 ) then',
'            if l_file_size > 20971520 then ',
'                :P3100_FILE := null;',
'                return wwv_flow_lang.system_message( p_name => ''WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'',',
'                                                     p0     => ''JSON'',',
'                                                     p1     => ''20'' );',
'            end if;',
'        end if;',
'    elsif :P3100_FILE like ''%xlsx'' then',
'        if l_file_size > 52428800 then',
'            :P3100_FILE := null;',
'            return wwv_flow_lang.system_message( p_name => ''WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'',',
'                                                 p0     => ''XLSX'',',
'                                                 p1     => ''50'' );',
'        end if;',
'    end if;',
'    ',
'    return null;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'UPLOAD_FILE'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'this safeguards against uploading too large XML and XLSX files. Both are processed by database XML functions which consume too much PGA memory for large files.'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(218529884504706530.4504)
,p_validation_name=>'Table names must not contain invalid chars'
,p_validation_sequence=>120
,p_validation=>'P3100_TABLE_NAME'
,p_validation2=>'#&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'#LABEL# non deve contenere #, &, <, >, ", /, ;, *, |, =, % o il carattere ,.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(2878249657221664.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(52178774929071242.4504)
,p_validation_name=>'existing table not null'
,p_validation_sequence=>140
,p_validation=>'P3100_EXISTING_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(82703473624738107.4504)
,p_validation_name=>'column mapping missing'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_MAPPED_COLUMN_COUNT = 0 then',
'    return false;',
'else',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Mapping delle colonne mancante. Mappare le colonne alla tabella esistente prima di caricare i dati.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(82704685257738119.4504)
,p_validation_name=>'CLOB column must be mapped to CLOB'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_profile     wwv_flow_data_parser.t_file_profile;',
'    l_profile          clob;',
'begin',
'    select clob001 into l_profile ',
'    from wwv_flow_collections ',
'    where collection_name =''APEX$DATALOAD''',
'    and rownum = 1;',
'',
'    l_file_profile := wwv_flow_data_parser.json_to_profile( p_json => l_profile );',
'    ',
'    for i in 1 .. l_file_profile.file_columns.count',
'    loop',
'        -- if data contains CLOB column',
'        if l_file_profile.file_columns( i ).data_type = wwv_flow_exec_api.c_data_type_clob then',
'            -- get user configured mapping',
'            for l_configure in (',
'                select',
'                    c002   mapped_column',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                and c001 = l_file_profile.file_columns( i ).name )',
'            loop',
'                -- get mapped column data type',
'                -- if CLOB column not mapped to CLOB column, raise error',
'                for l_mapped_column in (',
'                    select data_type',
'                    from sys.dba_tab_columns',
'                    where owner = :P3100_TABLE_OWNER',
'                    and table_name = :P3100_EXISTING_TABLE',
'                    and column_name = l_configure.mapped_column )',
'                loop',
'                    if l_mapped_column.data_type != ''CLOB'' then',
'                       return false;',
'                    end if;',
'                end loop;',
'            end loop;',
'        end if;',
'    end loop;',
'',
'    -- if there are no user configured mapping and not clob column, pass the validation',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La colonna CLOB \00E8 mappata a un tipo di dati colonna errato. Mappare la colonna a un''altra colonna CLOB.')
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1620874202834608.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1620651033834606.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1620594128834605.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1620722727834607.4504)
,p_event_id=>wwv_flow_api.id(1620651033834606.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1620980613834609.4504)
,p_name=>'Upload File'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_FILE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(306772540166647203.4504)
,p_event_id=>wwv_flow_api.id(1620980613834609.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_DATA'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1621012524834610.4504)
,p_event_id=>wwv_flow_api.id(1620980613834609.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".apex-item-group--file").addClass("uploading");',
'apex.jQuery(".apex-item-file-dropzone").html("<span class=''a-DataLoad-progressMeter''></span>");'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1621303372834613.4504)
,p_event_id=>wwv_flow_api.id(1620980613834609.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_FILE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1621455674834614.4504)
,p_name=>'Initialize UI'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1621533911834615.4504)
,p_event_id=>wwv_flow_api.id(1621455674834614.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Set drag and drop labels',
'apex.jQuery(''.apex-item-group--file:not(.upload-completed)'').append(''<span class="apex-item-file-dropzone"></span>'');',
'',
'var fileUpload$ = apex.jQuery(''.apex-item-group--file:not(.upload-completed) .apex-item-file-dropzone'');',
'',
'fileUpload$.append("<span class=''a-FileDrop-heading''>" + apex.lang.getMessage("DATA.LOAD.DRAG_DROP_FILE_HERE") + "</span> ");',
'fileUpload$.append("<span class=''a-FileDrop-action''>" + apex.lang.getMessage("DATA.LOAD.CHOOSE_FILE") + "</span> ");',
'fileUpload$.append("<span class=''a-FileDrop-formats''>" + apex.lang.getMessage("DATA.LOAD.FILE_FORMATS") + "</span>");'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1624365974834643.4504)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_FIRST_LINE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4212445483056009.4504)
,p_event_id=>wwv_flow_api.id(1624365974834643.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16453972019013402.4504)
,p_name=>'Shade Headers on Load'
,p_event_sequence=>60
,p_condition_element=>'P3100_FIRST_LINE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEADERS'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16454254932013405.4504)
,p_event_id=>wwv_flow_api.id(16453972019013402.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16454305473013406.4504)
,p_event_id=>wwv_flow_api.id(16453972019013402.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").removeClass("first-row-headers");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4093020088018704.4504)
,p_name=>'Adjust display of UI items after page load'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if :P3100_FILE is not null then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    if :P3100_DATA is not null then',
'        return true;',
'    end if;',
'end if;',
'return false;'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4093314800018707.4504)
,p_event_id=>wwv_flow_api.id(4093020088018704.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// replace column count placeholders in header text of parsed data preview region',
'$( "#placeholder_P3100_PARSED_COLUMN_COUNT" ).text( $v( "P3100_PARSED_COLUMN_COUNT" ) );',
'$( "#placeholder_P3100_PARSED_ROW_COUNT"    ).text( $v( "P3100_PARSED_ROW_COUNT"    ) );',
'',
'// set the column delimiter radio group to the actual value, which ',
'// is being determined *after* the item has been rendered, so the browser does not have the correct state.',
'$s( "P3100_CSV_COL_DELIMITER", $v("P3100_NEW_COL_DELIMITER") );',
'',
'// if the file has less than 10 columns: Adjust the header text and hide the "expand preview" button',
'// if ( parseInt( $v( "P3100_PARSED_COLUMN_COUNT" ) ) <= 10 ) {',
'//     $( "span#placeholder_gt10_columns" ).css( "display", "none" );',
'//     $( "#bt-full-preview"              ).css( "display", "none" );',
'// }',
'',
'// if the Invalid File Item is set (wrong extension, parser errors), hide the "Load into Table Region"',
'if ( $v( "P3100_FILE_INVALID" ) === "Y" ) {',
'    $( "#load-to-table"        ).css( "display", "none" );',
'    $( "#preview_table p.desc" ).css( "display", "none" );',
'   // $( "#settings"             ).css( "display", "none" );',
'    $( "#bt-full-preview"      ).css( "display", "none" );',
'}',
'',
'// shared functions',
'var getColId = function( id ){',
'    var int = parseInt( id ), i;',
'    if ( int <= 9 ) {',
'            i = ''COL00'' + int;',
'        } else if ( int > 9 && int <= 99 ) {',
'            i = ''COL0'' + int;',
'        } else {',
'            i = ''COL'' + int;',
'        }',
'    return i;',
'};',
'',
'var toggleCol = function ( columnId, isShowing ) {',
'    if ( columnId ) {',
'        var header$  = $( ''#'' + columnId ),',
'            body$    = $( ''td[headers='' + columnId + '']'' );',
'',
'        if ( isShowing ) {',
'            header$.show();',
'            body$.show();',
'        } else {',
'            header$.hide();',
'            body$.hide();',
'        }',
'    }',
'};',
'',
'// hide empty columns',
'( function () {',
'    var hideGreaterThan = parseInt( $v(''P3100_PARSED_COLUMN_COUNT'') ) + 1,',
'        emptyColId;',
'',
'        for ( i = hideGreaterThan; i <= 100; i++ ) {',
'            emptyColId = getColId( i );',
'            toggleCol( emptyColId, false );',
'        }',
'',
'})();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4093642896018710.4504)
,p_name=>'Confirm "All Rows" for large files'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_MAX_ROW_COUNT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P3100_FILE_SIZE") >= 2097152 && $v("P3100_MAX_ROW_COUNT") === "0"'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4094236591018716.4504)
,p_event_id=>wwv_flow_api.id(4093642896018710.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_PREV_MAX_ROW_COUNT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3100_MAX_ROW_COUNT")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4095047078018724.4504)
,p_event_id=>wwv_flow_api.id(4093642896018710.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_MAX_ROW_COUNT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3100_PREV_MAX_ROW_COUNT")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213315682056018.4504)
,p_event_id=>wwv_flow_api.id(4093642896018710.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4094907728018723.4504)
,p_event_id=>wwv_flow_api.id(4093642896018710.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Il campionamento di tutte le righe pu\00F2 richiedere del tempo per i file di grandi dimensioni. Si \00E8 certi di voler effettuare il campionamento di tutto il file?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4095223549018726.4504)
,p_event_id=>wwv_flow_api.id(4093642896018710.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_MAX_ROW_COUNT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4212566683056010.4504)
,p_event_id=>wwv_flow_api.id(4093642896018710.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4211875853056003.4504)
,p_name=>'Shade Headers for XML, JSON and ICS'
,p_event_sequence=>110
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not ( lower(:P3100_FILE) like ''%.csv'' or',
'lower(:P3100_FILE) like ''%.txt'' or',
'lower(:P3100_FILE) like ''%.xls_'' )'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4211929751056004.4504)
,p_event_id=>wwv_flow_api.id(4211875853056003.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4212677251056011.4504)
,p_name=>'Refresh Preview'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_XLSX_SHEET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4212758492056012.4504)
,p_event_id=>wwv_flow_api.id(4212677251056011.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4212923062056014.4504)
,p_name=>'Col Delimiter Changed'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_CSV_COL_DELIMITER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213071428056015.4504)
,p_event_id=>wwv_flow_api.id(4212923062056014.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213181627056016.4504)
,p_name=>'Enclosed Char Changed'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_CSV_ENCLOSED'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213217254056017.4504)
,p_event_id=>wwv_flow_api.id(4213181627056016.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4143243113584041.4504)
,p_name=>'Charset changed: Refresh Preview'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_FILE_CHARSET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4143358730584042.4504)
,p_event_id=>wwv_flow_api.id(4143243113584041.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16455464300013417.4504)
,p_name=>'Refresh after Preview Closes'
,p_event_sequence=>160
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4142265341584031.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3993097173355402.4504)
,p_event_id=>wwv_flow_api.id(16455464300013417.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.widget.waitPopup();',
'window.location.reload();',
'//apex.navigation.redirect ( "f?p=&APP_ID.:&APP_PAGE_ID.:&APP_SESSION." );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3993618071355408.4504)
,p_name=>'Show Configuration Saved Message'
,p_event_sequence=>170
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P3100_SHOW_CONFIG_SAVED'
,p_display_when_cond2=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3994194095355413.4504)
,p_event_id=>wwv_flow_api.id(3993618071355408.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_SHOW_CONFIG_SAVED'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3993702069355409.4504)
,p_event_id=>wwv_flow_api.id(3993618071355408.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess( apex.lang.getMessage(''DATA.LOAD.CONFIGURATION_SAVED'') );'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(118040198043597549.4504)
,p_name=>'Toggle Upload file or Copy and paste'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_SOURCE_TYPE'
,p_condition_element=>'P3100_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(118040233834597550.4504)
,p_event_id=>wwv_flow_api.id(118040198043597549.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1620249167834602.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(212734214591785603.4504)
,p_event_id=>wwv_flow_api.id(118040198043597549.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1620249167834602.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(212734019025785601.4504)
,p_event_id=>wwv_flow_api.id(118040198043597549.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(118040030879597548.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(212734123228785602.4504)
,p_event_id=>wwv_flow_api.id(118040198043597549.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(118040030879597548.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(185533117272749149.4504)
,p_event_id=>wwv_flow_api.id(118040198043597549.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1620435155834604.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(185533211262749150.4504)
,p_event_id=>wwv_flow_api.id(118040198043597549.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1620435155834604.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(217950443854386701.4504)
,p_event_id=>wwv_flow_api.id(118040198043597549.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Trigger Window Resize',
'$(window).trigger("apexwindowresized");'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(207423119915369628.4504)
,p_name=>'Show File or Copy Paste'
,p_event_sequence=>190
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P3100_SOURCE_TYPE'
,p_display_when_cond2=>'FILE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(207423255527369629.4504)
,p_event_id=>wwv_flow_api.id(207423119915369628.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1620249167834602.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(207423435392369631.4504)
,p_event_id=>wwv_flow_api.id(207423119915369628.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(118040030879597548.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(212736112486785622.4504)
,p_name=>'Get Sample'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_LOAD_SAMPLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(212736253657785623.4504)
,p_event_id=>wwv_flow_api.id(212736112486785622.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.server.process(',
'    "get_sample_csv", {',
'        pageItems: [''P3100_LOAD_SAMPLE'']',
'    }, {',
'        dataType: "text",',
'        loadingIndicator: ''P3100_DATA'',',
'        loadingIndicatorPosition: "centered",',
'        success: function(pData) {',
'            $(''#P3100_DATA'').val(pData);',
'        }',
'    }',
');'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(52174810176071203.4504)
,p_name=>'On Preview click save PK setting'
,p_event_sequence=>210
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4142265341584031.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52174945017071204.4504)
,p_event_id=>wwv_flow_api.id(52174810176071203.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3100_FORCE_SYSGUID_ID,P3100_TABLE_OWNER'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(465287104958492826.4504)
,p_name=>'set load to in session state'
,p_event_sequence=>215
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_LOAD_TO'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(465287223385492827.4504)
,p_event_id=>wwv_flow_api.id(465287104958492826.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- reset column configuration collection ',
'-- as the collection saves:',
'--     select columns info, if new table',
'--     column mapping, if existing table',
'wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
''))
,p_attribute_02=>'P3100_LOAD_TO'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82703849943738111.4504)
,p_event_id=>wwv_flow_api.id(465287104958492826.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1621706117834617.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82704384858738116.4504)
,p_event_id=>wwv_flow_api.id(465287104958492826.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(82702857605738101.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(52175777779071212.4504)
,p_name=>'show hide new and existing'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_LOAD_TO'
,p_condition_element=>'P3100_LOAD_TO'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52178935302071244.4504)
,p_event_id=>wwv_flow_api.id(52175777779071212.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_TABLE_NAME,P3100_FORCE_SYSGUID_ID,P3100_USE_DATA_TYPES'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52177623415071231.4504)
,p_event_id=>wwv_flow_api.id(52175777779071212.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_TABLE_NAME,P3100_FORCE_SYSGUID_ID,P3100_USE_DATA_TYPES'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52179130531071246.4504)
,p_event_id=>wwv_flow_api.id(52175777779071212.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_EXISTING_TABLE,P3100_UPDATE_METHOD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52177847149071233.4504)
,p_event_id=>wwv_flow_api.id(52175777779071212.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_EXISTING_TABLE,P3100_UPDATE_METHOD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(69708079265469901.4504)
,p_event_id=>wwv_flow_api.id(52175777779071212.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_EXISTING_TABLE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52178602083071241.4504)
,p_event_id=>wwv_flow_api.id(52175777779071212.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_TABLE_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(69710307005469924.4504)
,p_name=>'display configure region'
,p_event_sequence=>230
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_TABLE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P3100_LOAD_TO").getValue() === "NEW" && apex.item("P3100_TABLE_NAME").getValue() != ""'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(363474706432315405.4504)
,p_event_id=>wwv_flow_api.id(69710307005469924.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3100_TABLE_NAME'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52038419075715340.4504)
,p_event_id=>wwv_flow_api.id(69710307005469924.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(82702857605738101.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82704174426738114.4504)
,p_event_id=>wwv_flow_api.id(69710307005469924.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(82702857605738101.4504)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(69710691103469927.4504)
,p_name=>'auto-map cols and display configure'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_EXISTING_TABLE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P3100_LOAD_TO").getValue() === "EXISTING" && apex.item("P3100_EXISTING_TABLE").getValue() != ""'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(554413800972229304.4504)
,p_event_id=>wwv_flow_api.id(69710691103469927.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- clear column mapping configuration as existing table changed',
'wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );'))
,p_attribute_05=>'PLSQL'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(465286152048492816.4504)
,p_event_id=>wwv_flow_api.id(69710691103469927.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile             clob;',
'    l_file_profile        wwv_flow_data_parser.t_file_profile;',
'    l_column_name_changed boolean := false;',
'    l_column_map          wwv_flow_global.vc_map := wwv_flow_global.c_empty_vc_map;',
'begin',
'    select clob001 into l_profile ',
'    from wwv_flow_collections ',
'    where collection_name =''APEX$DATALOAD''',
'    and rownum = 1;',
'',
'    l_file_profile := wwv_flow_data_parser.json_to_profile( p_json => l_profile );',
'    if :P3100_FIRST_LINE is null or :P3100_FIRST_LINE != ''HEADERS'' then',
'        for i in 1 .. l_file_profile.file_columns.count loop',
'            l_file_profile.file_columns( i ).name := ''COL'' || lpad( i,3,''0'');',
'        end loop;',
'        l_profile := wwv_flow_data_parser.profile_to_json( l_file_profile );',
'        ',
'        l_column_name_changed := true;',
'        ',
'        -- see if configure columns are same, if not column names changed',
'        for i in 1 .. l_file_profile.file_columns.count',
'        loop',
'            for l_configure in (',
'                select',
'                    c001   column_name,',
'                    c002   mapped_column',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                and c001 = l_file_profile.file_columns( i ).name )',
'            loop    ',
'                l_column_name_changed := false;',
'                exit;',
'            end loop;',
'        end loop;',
'    end if;',
'    ',
'    -- save changed file profile for later use',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'    wwv_flow_collection.add_member( ''APEX$DATALOAD'', p_clob001 => l_profile );',
'    ',
'    if l_column_name_changed then',
'        -- clear column mapping configuration as column names changed',
'        wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    end if;',
'    ',
'    -- auto discover column mapping or get mapping user configured',
'    if :P3100_LOAD_TO = ''EXISTING'' then',
'        -- get column mapping user configured',
'        for l_configure in (',
'            select',
'                c001   column_name,',
'                c002   mapped_column',
'            from wwv_flow_collections',
'            where collection_name = ''APEX$DATALOAD_COLUMNS''',
'            and c002 is not null )',
'        loop',
'            l_column_map( l_configure.column_name ) := l_configure.mapped_column;',
'        end loop;',
'        ',
'        if l_column_map.count = 0 then',
'            -- get column mapping with existing table',
'            for i in 1 .. l_file_profile.file_columns.count',
'            loop',
'                for l_existing_table in (',
'                    select column_name',
'                    from sys.dba_tab_columns',
'                    where owner = :P3100_TABLE_OWNER',
'                    and table_name = :P3100_EXISTING_TABLE',
'                    and column_name = l_file_profile.file_columns( i ).name )',
'                loop',
'                    l_column_map( l_file_profile.file_columns( i ).name ) := l_existing_table.column_name;',
'                    -- add APEX$DATALOAD_COLUMNS collection as it is not populated yet',
'                    wwv_flow_collection.add_member(',
'                        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'                        p_c001 => l_existing_table.column_name,                 -- column name',
'                        p_c002 => l_existing_table.column_name,                 -- mapped column',
'                        p_c003 => l_file_profile.file_columns( i ).format_mask, -- format mask',
'                        p_c004 => l_file_profile.file_columns( i ).group_char,  -- group char',
'                        p_c005 => l_file_profile.file_columns( i ).decimal_char -- decimal char    ',
'                        );',
'                end loop;',
'            end loop;',
'        end if;',
'    end if;',
'    -- need to compute here for configure region display',
'    :P3100_FILE_COLUMN_COUNT   := l_file_profile.file_columns.count;',
'    :P3100_MAPPED_COLUMN_COUNT := l_column_map.count;',
'end;'))
,p_attribute_02=>'P3100_FIRST_LINE,P3100_TABLE_OWNER,P3100_EXISTING_TABLE'
,p_attribute_03=>'P3100_MAPPED_COLUMN_COUNT,P3100_FILE_COLUMN_COUNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82703082744738103.4504)
,p_event_id=>wwv_flow_api.id(69710691103469927.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(82702857605738101.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82703247866738105.4504)
,p_event_id=>wwv_flow_api.id(69710691103469927.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(82702857605738101.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82692780879962406.4504)
,p_event_id=>wwv_flow_api.id(69710691103469927.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1621706117834617.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(82692565955962404.4504)
,p_name=>'Refresh after Map Col Closes'
,p_event_sequence=>260
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(69708360594469904.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82692671323962405.4504)
,p_event_id=>wwv_flow_api.id(82692565955962404.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.widget.waitPopup();',
'window.location.reload();',
'//apex.navigation.redirect ( "f?p=&APP_ID.:&APP_PAGE_ID.:&APP_SESSION." );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(82703933486738112.4504)
,p_name=>'warn replace'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_UPDATE_METHOD'
,p_condition_element=>'P3100_UPDATE_METHOD'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPLACE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82704040481738113.4504)
,p_event_id=>wwv_flow_api.id(82703933486738112.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Tutti i dati esistenti nella tabella verranno eliminati prima del caricamento. Se il caricamento non riesce, \00E8 possibile recuperare i dati eliminati eseguendo il flashback della tabella. Si \00E8 certi di voler sostituire i dati in questa tabella?')
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(363475286580315410.4504)
,p_name=>'set update mothod'
,p_event_sequence=>280
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_UPDATE_METHOD'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(363475339955315411.4504)
,p_event_id=>wwv_flow_api.id(363475286580315410.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3100_UPDATE_METHOD'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(363475493214315412.4504)
,p_name=>'set force SYSGUID'
,p_event_sequence=>290
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_FORCE_SYSGUID_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(363475549299315413.4504)
,p_event_id=>wwv_flow_api.id(363475493214315412.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3100_FORCE_SYSGUID_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2827481640927230.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Click Previous to Clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'3100,3110,3120'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1698876190214119.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(212735502054785616.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy and paste load change clob to blob'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_seq_id number;',
'    l_clob   clob;',
'begin',
'    select seq_id, ',
'           clob001',
'      into l_seq_id, ',
'           l_clob',
'      from wwv_flow_collections',
'     where collection_name = ''CLOB_CONTENT'';',
'    ',
'    wwv_flow_collection.update_member(',
'        p_collection_name => ''CLOB_CONTENT'',',
'        p_seq             => l_seq_id,',
'        p_clob001         => l_clob,',
'        p_blob001         => wwv_flow_utilities.clob_to_blob( p_clob => l_clob ) );',
'end;         ',
'            ',
'    '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'NEXT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3511555467397550.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load to New Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy_message varchar2(32767);',
'begin',
'    wwv_flow_data_loader_dev.load_to_new_table(',
'        p_source_type       => :P3100_SOURCE_TYPE,',
'        p_file_name         => :P3100_FILE,',
'        --',
'        p_target_schema     => :P3100_TABLE_OWNER,',
'        p_target_name       => :P3100_TABLE_NAME,',
'        p_error_table_name  => :P3100_ERROR_TABLE,',
'        --',
'        p_add_id_column     => true,',
'        p_force_sysguid_id  => :P3100_FORCE_SYSGUID_ID = ''Y'',',
'        p_skip_rows         => ( case when :P3100_FIRST_LINE     = ''HEADERS'' and :P3100_FILE_TYPE in ( ''1'', ''2'' ) then 1    else 0     end ),',
'        p_use_column_names  => ( case when :P3100_FIRST_LINE     = ''HEADERS''                                      then true else false end ),',
'        p_use_data_types    => ( case when :P3100_USE_DATA_TYPES = ''Y''                                            then true else false end ),',
'        -- ',
'        p_load_id           => :P3100_LOAD_ID,',
'        p_message           => l_dummy_message );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1620874202834608.4504)
,p_process_when=>'P3100_LOAD_TO'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NEW'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(71166758312651836.4504)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load to Existing Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy_message varchar2(32767);',
'begin',
'    wwv_flow_data_loader_dev.load_to_existing_table(',
'        p_source_type         => :P3100_SOURCE_TYPE,',
'        --',
'        p_file_name           => :P3100_FILE,',
'        --',
'        p_target_schema       => :P3100_TABLE_OWNER,',
'        p_target_name         => :P3100_EXISTING_TABLE,',
'        p_error_table_name    => :P3100_ERROR_TABLE,',
'        --',
'        p_skip_rows           => ( case when :P3100_FIRST_LINE = ''HEADERS'' and :P3100_FILE_TYPE in ( ''1'', ''2'' ) then 1 else 0 end ),',
'        p_truncate_rows       => ( :P3100_UPDATE_METHOD = ''REPLACE'' ),',
'        --',
'        p_load_id             => :P3100_LOAD_ID,',
'        p_message             => l_dummy_message );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1620874202834608.4504)
,p_process_when=>'P3100_LOAD_TO'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'EXISTING'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1624133201834641.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get File Info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile_record wwv_flow_data_parser.t_file_profile;',
'begin',
'    if not :P3100_FILE like ''[Downloaded_File]%'' then',
'        -- get the file name',
'        select filename, sys.dbms_lob.getlength( blob_content) as file_size',
'        into :P3100_FILE_NAME, :P3100_FILE_SIZE',
'        from apex_application_temp_files ',
'        where name = :P3100_FILE;',
'    else',
'        :P3100_FILE_NAME := :P3100_FILE;',
'    end if;',
'    ',
'    if :P3100_SOURCE_TYPE is null then',
'        wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD_COLUMNS'' );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3994483430355416.4504)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Body Class'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_FILE is null and :P3100_DATA is null then',
'  :P3100_BODY_CLASS := ''is-first-step'';',
'else',
'  :P3100_BODY_CLASS := '''';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(212736324940785624.4504)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_sample_csv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  sys.owa_util.mime_header(''text/plain'', true );',
'  if :P3100_LOAD_SAMPLE = ''DEPT_EMP'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_emp_data);',
'  elsif :P3100_LOAD_SAMPLE = ''PROJECTS'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_project_data);',
'  elsif :P3100_LOAD_SAMPLE = ''SPEED'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_vehical_speed_data);',
'  elsif :P3100_LOAD_SAMPLE = ''SALES'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_sales_data);',
'  elsif :P3100_LOAD_SAMPLE = ''WORLD'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_country_population_data);',
'  elsif :P3100_LOAD_SAMPLE = ''ACADEMIC'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_ACADEMIC_data);',
'  elsif :P3100_LOAD_SAMPLE = ''JSON_TEST'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_json_test_data);',
'  elsif :P3100_LOAD_SAMPLE = ''JSON'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_json_only_data);',
'  --elsif :P3100_LOAD_SAMPLE = ''TENNIS'' then',
'  --    sys.htp.prn(wwv_flow_define_app_v3.get_tennis_data);',
'  --elsif :P3100_LOAD_SAMPLE = ''WORLDCUP'' then',
'  --    sys.htp.prn(wwv_flow_define_app_v3.get_worldcup_data);',
'  --    wwv_htp.print_clob(wwv_flow_define_app_v3.get_worldcup_data);',
'  --elsif :P3100_LOAD_SAMPLE = ''F1'' then',
'  --    sys.htp.prn(wwv_flow_define_app_v3.get_f1_data);',
'  --elsif :P3100_LOAD_SAMPLE = ''MOVIE'' then',
'  --    sys.htp.prn(wwv_flow_define_app_v3.get_movie_data);',
'  end if;',
'  :P3100_FIRST_LINE := ''HEADERS'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_03110
begin
wwv_flow_api.create_page(
 p_id=>3110.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica dati'
,p_page_mode=>'MODAL'
,p_step_title=>'Carica dati'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region-headerItems--buttons { white-space: nowrap; }',
'.a-Region-bodyHeader { padding: 12px; margin: 0; border-bottom: 1px solid rgba(0, 0, 0,0.1); background-color: #FFF8E1; color: #202020; }',
''))
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
,p_dialog_height=>'800'
,p_dialog_width=>'960'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1595347007342836.4504)
,p_name=>'Caricamento in corso'
,p_region_name=>'loadInProgress'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 as status,',
'       n001 as rows_processed ',
'from wwv_flow_collections ',
'where collection_name=''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(385896719135645040.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1595498912342837.4504)
,p_query_column_id=>1
,p_column_alias=>'STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(3891423527523942)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1595552243342838.4504)
,p_query_column_id=>2
,p_column_alias=>'ROWS_PROCESSED'
,p_column_display_sequence=>2
,p_column_heading=>'Righe elaborate'
,p_use_as_row_header=>'N'
,p_column_format=>'9G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4212017881056005.4504)
,p_plug_name=>'Caricamento non riuscito'
,p_region_name=>'loadIncomplete'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>50
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Caricamento dei dati non riuscito in modo intermittente e incompleto.',
'<pre id="imcompl_load_error"></pre>',
'Controllare l''errore e riprovare. <br/>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(465285456657492809.4504)
,p_plug_name=>'Nuova tabella'
,p_parent_plug_id=>wwv_flow_api.id(4212017881056005.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Tabella <code>&P3100_TABLE_NAME!HTML.</code> creata. Caricamento di <b id="incompl_success_row_count"></b> righe riuscito. <b class="u-danger-text" id="incompl_fail_row_count"></b> righe rifiutate.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(465285530738492810.4504)
,p_plug_name=>'Tabella esistente'
,p_parent_plug_id=>wwv_flow_api.id(4212017881056005.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_INCOMPLETE'', wwv_flow_escape.html(:P3100_EXISTING_TABLE) ) );',
'elsif :P3100_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_INCOMPLETE'',  wwv_flow_escape.html(:P3100_EXISTING_TABLE) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5339195701073204.4504)
,p_plug_name=>'Operazione riuscita con avvertenza'
,p_region_name=>'loadError'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(465285017247492805.4504)
,p_plug_name=>'Nuova tabella'
,p_parent_plug_id=>wwv_flow_api.id(5339195701073204.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Tabella <code>&P3100_TABLE_NAME!HTML.</code> creata. Caricamento di <b id="err_success_row_count"></b> righe riuscito. <b class="u-danger-text" id="err_fail_row_count"></b> righe rifiutate.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(465285131035492806.4504)
,p_plug_name=>'Tabella esistente'
,p_parent_plug_id=>wwv_flow_api.id(5339195701073204.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_WARNING'', wwv_flow_escape.html(:P3100_EXISTING_TABLE) ) );',
'elsif :P3100_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_WARNING'', wwv_flow_escape.html( :P3100_EXISTING_TABLE) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5339468330073206.4504)
,p_plug_name=>'Caricamento non riuscito'
,p_region_name=>'loadFail'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>40
,p_plug_source=>'Impossibile caricare i dati. Controllare l''errore e riprovare. <b id="fail_row_count"></b> righe con errore.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5339553222073207.4504)
,p_plug_name=>'Caricamento dati riuscito'
,p_region_name=>'loadSuccess'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(465285279958492807.4504)
,p_plug_name=>'Nuova tabella'
,p_parent_plug_id=>wwv_flow_api.id(5339553222073207.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Tabella <code>&P3100_TABLE_NAME!HTML.</code> creata con <b id="success_row_count"></b> righe.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(465285312911492808.4504)
,p_plug_name=>'Tabella esistente'
,p_parent_plug_id=>wwv_flow_api.id(5339553222073207.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_SUCCESS'', wwv_flow_escape.html(:P3100_EXISTING_TABLE) ) );',
'elsif :P3100_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_SUCCESS'', wwv_flow_escape.html( :P3100_EXISTING_TABLE) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5339609838073208.4504)
,p_name=>'Righe rifiutate nella tabella &P3100_ERROR_TABLE!HTML.'
,p_region_name=>'failed_rows'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch:a-Report--rowHighlight'
,p_region_attributes=>'style="display: none;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q              varchar2(32767);',
'    l_column_name  varchar2(255);',
'    l_columns      varchar2(32767);',
'    l_profile_json clob;',
'    l_file_profile wwv_flow_data_parser.t_file_profile;',
'begin',
'    ',
'    select clob001 ',
'    into l_profile_json',
'    from wwv_flow_collections',
'    where collection_name = ''APEX$DATALOAD''',
'    and rownum = 1;',
'',
'    -- query upto 10 columns not including CLOB',
'    for l_file in ( ',
'        select column_position, column_name, data_type ',
'        from table( wwv_flow_data_parser.get_columns(l_profile_json ) )',
'        where rownum <= 10',
'        and data_type != ''CLOB'' )',
'    loop',
'        l_column_name := null;',
'',
'        if :P3100_LOAD_TO = ''EXISTING'' then',
'            for l_existing_table in (',
'                select column_name',
'                from sys.dba_tab_columns',
'                where owner = :P3100_TABLE_OWNER',
'                and table_name = :P3100_EXISTING_TABLE',
'                and column_name = l_file.column_name )',
'            loop',
'                l_column_name := l_existing_table.column_name;',
'            end loop;',
'            -- if column header not used, columns such as c001 mapped to existing column',
'            if l_column_name is null then',
'                for l_configure in (',
'                    select',
'                        c002 mapped_column',
'                    from wwv_flow_collections',
'                    where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                    and c002 is not null',
'                    and c001 = l_file.column_name )',
'                loop',
'                    l_column_name := l_configure.mapped_column;',
'                end loop;',
'            end if;',
'        else',
'            -- validate file columns against newly created table',
'            -- get only the ones created',
'            for l_table in (',
'                select column_name',
'                from sys.dba_tab_columns',
'                where owner = :P3100_TABLE_OWNER',
'                and table_name = :P3100_TABLE_NAME',
'                and column_name = l_file.column_name )',
'            loop',
'                l_column_name := l_table.column_name;',
'            end loop;',
'        end if;',
'',
'        if l_column_name is not null then',
'            l_columns := l_columns ||case when l_columns is not null then '','' end || l_column_name;',
'        end if;',
'    end loop;',
'   ',
'    q := ''select ORA_ERR_MESG$ as error_message''|| ',
'         (case when l_columns is not null then '',''|| l_columns end ) ||',
'         '' from ''||wwv_flow_assert.enquote_name( :P3100_ERROR_TABLE );',
'',
'    return q;',
'end;'))
,p_header=>'Tutte le righe rifiutate vengono memorizzate nella tabella &P3100_ERROR_TABLE!HTML.. Nel report riportato di seguito vengono mostrate le prime 10 righe.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>11
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>10
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
,p_plug_query_parse_override=>'P3100_TABLE_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3520374672543756.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3520702531543767.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3521151693543767.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3521588214543767.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3521949833543767.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3522354084543767.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3522740524543768.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3523119062543768.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3523578712543768.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3523909078543768.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3524395492543769.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5341141690073223.4504)
,p_plug_name=>'Caricamento completato'
,p_region_name=>'load_finished'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8889803744889085.4504)
,p_plug_name=>'Informazioni sulla tabella'
,p_region_name=>'table_info'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="timer-container"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8890101023889088.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3527300320543833.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8890101023889088.4504)
,p_button_name=>'CANCEL'
,p_button_static_id=>'btn_cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3528572823543840.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(8890101023889088.4504)
,p_button_name=>'VIEW_TABLE'
,p_button_static_id=>'viewTableBtn'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Visualizza tabella'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP,1001:OB_SCHEMA,OB_CURRENT_TYPE,OB_OBJECT_ID:&P3100_TABLE_OWNER.,TABLE,&P3110_TAB_OBJ_ID.'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3527705431543838.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(8890101023889088.4504)
,p_button_name=>'CREATE_APP'
,p_button_static_id=>'createAppBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea applicazione'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(207424077958369637.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(5339609838073208.4504)
,p_button_name=>'DROP_TABLE'
,p_button_static_id=>'dropTableBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina tabella e ricarica'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'style="display: none;"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(306772383679647201.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(5339609838073208.4504)
,p_button_name=>'VIEW_ERROR_TABLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Apri nel browser oggetti'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP,1001:OB_SCHEMA,OB_CURRENT_TYPE,OB_OBJECT_ID:&P3100_TABLE_OWNER.,TABLE,&P3110_ERR_TAB_OBJ_ID.'
,p_icon_css_classes=>'icon-open-in-dialog'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3528172063543840.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8890101023889088.4504)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'btn_previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193042467413621230.4504)
,p_branch_name=>'Go To Create App Wizard'
,p_branch_action=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:1,5,130,150,170,250:P1_SCHEMA,P1_NEW_TABLE_NAME:&P3100_TABLE_OWNER.,&P3100_TABLE_NAME.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GOTO_CREATE_APP'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(207424900170369646.4504)
,p_branch_name=>'Go To Page 3100'
,p_branch_action=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:RP,3100,3110,3120::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(207424077958369637.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3517225315543731.4504)
,p_name=>'P3110_LOAD_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1595347007342836.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3517623849543739.4504)
,p_name=>'P3110_PROCESSED_ROW_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1595347007342836.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3518350628543743.4504)
,p_name=>'P3110_GOOD_ROW_CNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(5341141690073223.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3518712757543743.4504)
,p_name=>'P3110_BAD_ROW_CNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(5341141690073223.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3525288239543813.4504)
,p_name=>'P3110_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8889803744889085.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proprietario tabella'
,p_source=>'P3100_TABLE_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3526169869543831.4504)
,p_name=>'P3110_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8889803744889085.4504)
,p_prompt=>'Nome tabella'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3942228815766702.4504)
,p_name=>'P3110_TABLE_CREATED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5341141690073223.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3942711680766707.4504)
,p_name=>'P3110_TAB_OBJ_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5341141690073223.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4212146369056006.4504)
,p_name=>'P3110_LOAD_ERROR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1595347007342836.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69708154742469902.4504)
,p_name=>'P3110_LOAD_TO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5341141690073223.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(207424749954369644.4504)
,p_name=>'P3110_ERR_TAB_OBJ_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5341141690073223.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(579566414994721532.4504)
,p_name=>'P3110_GOOD_ROW_CNT_DISP'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(5341141690073223.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(579566572187721533.4504)
,p_name=>'P3110_BAD_ROW_CNT_DISP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(5341141690073223.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(579566655822721534.4504)
,p_name=>'P3110_PROCESSED_ROW_CNT_DISP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1595347007342836.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(465284904596492804.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3110_TABLE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_LOAD_TO = ''NEW'' then',
'    return :P3100_TABLE_NAME;',
'elsif :P3100_LOAD_TO = ''EXISTING'' then',
'    return :P3100_EXISTING_TABLE;',
'end if;'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3531982674543848.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3527300320543833.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3532493223543849.4504)
,p_event_id=>wwv_flow_api.id(3531982674543848.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3530158368543845.4504)
,p_name=>'Timer for Refresh Progress'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3530667815543847.4504)
,p_event_id=>wwv_flow_api.id(3530158368543845.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSpinner$ = apex.util.showSpinner( $( "#loadInProgress" ) );',
'',
'var showFinished = function(){',
'    // Hide Table Information',
'    apex.region("table_info").element.hide();',
'',
'    var lLoadTo = apex.item("P3110_LOAD_TO").getValue();',
'    var lTableCreated = apex.item( "P3110_TABLE_CREATED" ).getValue();',
'    var lBadRowCnt = apex.item( "P3110_BAD_ROW_CNT" ).getValue();',
'    var lSuccessRowCnt = apex.item("P3110_GOOD_ROW_CNT").getValue();',
'    var lProcessedRowCnt = apex.item( "P3110_PROCESSED_ROW_CNT" ).getValue();',
'    ',
'    var lBadRowCntDisp = apex.item( "P3110_BAD_ROW_CNT_DISP" ).getValue();',
'    var lSuccessRowCntDisp = apex.item("P3110_GOOD_ROW_CNT_DISP").getValue();',
'    var lProcessedRowCntDisp = apex.item( "P3110_PROCESSED_ROW_CNT_DISP" ).getValue();',
'    ',
'    if (lLoadTo === "NEW") {',
'        if (lTableCreated === "Y") {',
'            apex.jQuery("#viewTableBtn").show();',
'            apex.jQuery("#btn_cancel").hide();',
'        }',
'    } else if (lLoadTo === "EXISTING") {',
'        apex.jQuery("#viewTableBtn").show();',
'    }',
'    ',
'    if ( apex.item("P3110_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'        // show failure region',
'',
'        apex.jQuery("#incompl_success_row_count").text( lSuccessRowCntDisp );',
'        apex.jQuery("#incompl_fail_row_count").text( lBadRowCntDisp );',
'        apex.jQuery("#imcompl_load_error").text( apex.item( "P3110_LOAD_ERROR" ).getValue() );        ',
'        apex.region("loadIncomplete").element.show();',
'        if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'        if (lBadRowCnt > "0") {',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'        }',
'    } else {',
'        ',
'        if ( lBadRowCnt === "0" ) {',
'            // show success region',
'            apex.jQuery("#success_row_count").text( lSuccessRowCntDisp );',
'            apex.region("loadSuccess").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            apex.jQuery("#btn_previous").hide();',
'        } else if ( lSuccessRowCnt > "0" && lBadRowCnt > "0" ) {',
'            // show error region',
'            apex.jQuery("#err_success_row_count").text( lSuccessRowCntDisp );',
'            apex.jQuery("#err_fail_row_count").text( lBadRowCntDisp );',
'            apex.region("loadError").element.show();',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'',
'        } else if ( lBadRowCnt === lProcessedRowCnt ) {',
'            // show failure region',
'            apex.jQuery("#fail_row_count").text( lBadRowCntDisp );',
'            apex.region("loadFail").element.show();',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'            if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'        }',
'    }',
' };',
'',
'var triggerRefresh = function(){ ',
'    apex.event.trigger( apex.jQuery("#timer-container"), "job_timer" );',
'',
'    if ( apex.item("P3110_LOAD_STATUS").getValue() === ''FINISHED''  || ',
'         apex.item("P3110_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'      clearInterval( refreshInterval );',
'      apex.region("loadInProgress").element.hide();',
'      lSpinner$.remove();',
'      showFinished();',
'    }',
'};',
'',
'var refreshInterval = setInterval( triggerRefresh, 1000);'))
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3531075388543848.4504)
,p_name=>'Refresh Progress Report on Timer'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#timer-container'
,p_bind_type=>'bind'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'job_timer'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1595200264342835.4504)
,p_event_id=>wwv_flow_api.id(3531075388543848.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1595347007342836.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1825642177529546.4504)
,p_event_id=>wwv_flow_api.id(3531075388543848.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_job_is_running boolean := false;',
'begin',
'    --',
'    -- Step 1: Determine whether the scheduler job is running',
'    --',
'    for j in (',
'        select 1',
'          from sys.user_scheduler_jobs',
'         where job_name like ''ORACLE_APEX_DTLD$%''',
'           and regexp_substr( comments, ''(\:)(.*?)(\:)'',1,5,''i'',2 ) = ''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID',
'           and state    = ''RUNNING'' ',
'           and rownum   = 1 )',
'    loop',
'        l_job_is_running := true;',
'    end loop;',
'',
'    --',
'    -- Step 2: Determine the current status from the status collection',
'    --',
'    for l_load in (',
'        select c001 as status,',
'               c002 as error_message,',
'               n001 as rows_processed ',
'        from wwv_flow_collections ',
'        where collection_name=''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID)',
'    loop',
'        :P3110_LOAD_STATUS       := l_load.status;',
'        :P3110_LOAD_ERROR        := l_load.error_message;',
'        :P3110_PROCESSED_ROW_CNT := l_load.rows_processed;',
'    end loop;',
'',
'    if :P3110_LOAD_STATUS = ''RUNNING'' and not l_job_is_running then',
'        :P3110_LOAD_STATUS       := ''FAILED'';',
'        :P3110_LOAD_ERROR        := wwv_flow_lang.system_message(''DATA.LOAD.JOB_INTERMITTENTLY_FAILED'');',
'    end if;',
'    ',
'    :P3110_PROCESSED_ROW_CNT_DISP := to_char( :P3110_PROCESSED_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'end;'))
,p_attribute_03=>'P3110_LOAD_STATUS,P3110_PROCESSED_ROW_CNT,P3110_LOAD_ERROR,P3110_PROCESSED_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1825966086529549.4504)
,p_event_id=>wwv_flow_api.id(3531075388543848.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_table_exists boolean := false;',
'    l_context wwv_flow_exec.t_context;',
'    q varchar2(32767);',
'begin',
'    if :P3110_LOAD_STATUS in (''FAILED'', ''FINISHED'' ) then',
'        if :P3100_LOAD_TO = ''NEW'' then',
'            for l_table in (',
'                select table_name',
'                from sys.dba_tables',
'                where table_name = :P3100_TABLE_NAME',
'                and owner = :P3100_TABLE_OWNER )',
'            loop',
'                :P3110_TABLE_CREATED := ''Y'';',
'            end loop;',
'        end if;',
'        ',
'        for l_table in (',
'            select table_name',
'            from sys.dba_tables',
'            where table_name = :P3100_ERROR_TABLE',
'            and owner = :P3100_TABLE_OWNER )',
'        loop',
'            l_error_table_exists := true;',
'        end loop;',
'        ',
'        q := ''with'';',
'        q := q||'' success_data as (select count(*) as cnt from ''||',
'             wwv_flow_assert.enquote_name(',
'                 case when :P3100_LOAD_TO = ''NEW'' then',
'                     :P3100_TABLE_NAME',
'                 when :P3100_LOAD_TO = ''EXISTING'' then',
'                     :P3100_EXISTING_TABLE',
'                 end )',
'                 || '')'';',
'        if l_error_table_exists then',
'            q := q||'', failed_data as (select count(*) as cnt from ''||wwv_flow_assert.enquote_name( :P3100_ERROR_TABLE ) || '')'';',
'        end if;',
'        q := q||'' select s.cnt as success_count'';',
'        if l_error_table_exists then',
'            q := q||'', e.cnt as error_count'';',
'        end if;',
'        q:=q||'' from'';',
'        q:=q||'' success_data s'';',
'        if l_error_table_exists then',
'            q:=q||'', failed_data e'';',
'        end if;',
'     ',
'        wwv_flow_exec.open_query_context(',
'            p_context     => l_context,',
'            p_location    => wwv_flow_exec_api.c_location_local_db,',
'            p_query_type  => wwv_flow_exec_api.c_query_type_sql_query,',
'            p_sql_query   => q,',
'            p_parse_as_schema_override => :P3100_TABLE_OWNER );',
'            ',
'        if wwv_flow_exec.next_row( p_context => l_context ) then',
'            :P3110_GOOD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 1 );',
'            if l_error_table_exists then',
'                :P3110_BAD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 2 );',
'            else',
'                :P3110_BAD_ROW_CNT := 0;',
'            end if;',
'        end if;',
'        ',
'        if :P3100_LOAD_TO = ''EXISTING'' then',
'            :P3110_GOOD_ROW_CNT := :P3110_PROCESSED_ROW_CNT - :P3110_BAD_ROW_CNT;',
'        end if;',
'        ',
'        :P3110_GOOD_ROW_CNT_DISP := to_char( :P3110_GOOD_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'        :P3110_BAD_ROW_CNT_DISP  := to_char( :P3110_BAD_ROW_CNT,  ''999G999G999G999G999G999G990'' );',
'        ',
'        wwv_flow_exec.close_context( p_context => l_context );',
'    end if;',
'exception ',
'    when others then',
'        wwv_flow_exec.close_context( p_context => l_context );',
'        raise;',
'end;'))
,p_attribute_03=>'P3110_GOOD_ROW_CNT,P3110_BAD_ROW_CNT,P3110_TABLE_CREATED,P3110_TAB_OBJ_ID,P3110_GOOD_ROW_CNT_DISP,P3110_BAD_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(212737138757785632.4504)
,p_name=>'confirm drop tables'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(207424077958369637.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(212737294452785633.4504)
,p_event_id=>wwv_flow_api.id(212737138757785632.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Si \00E8 certi di voler eliminare le tabelle &P3100_TABLE_NAME. e &P3100_ERROR_TABLE. create dal caricamento dei dati?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(207424826705369645.4504)
,p_event_id=>wwv_flow_api.id(212737138757785632.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DROP_TABLE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(193042576836621231.4504)
,p_name=>'Go to create app wizard'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3527705431543838.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(193042612869621232.4504)
,p_event_id=>wwv_flow_api.id(193042576836621231.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'GOTO_CREATE_APP'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(207425026686369647.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'drop table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_drop1 sys.dbms_sql.varchar2a;',
'    l_drop2 sys.dbms_sql.varchar2a;',
'begin',
'    l_drop1(1) := ''drop table ''||wwv_flow_assert.enquote_name(:P3100_TABLE_NAME);',
'    l_drop2(1) := ''drop table ''||wwv_flow_assert.enquote_name(:P3100_ERROR_TABLE);',
'    ',
'    wwv_flow_dynamic_exec.run_ddl (',
'        p_sql  => l_drop1,',
'        p_user => :P3100_TABLE_OWNER );',
'   ',
'   wwv_flow_dynamic_exec.run_ddl (',
'        p_sql  => l_drop2,',
'        p_user => :P3100_TABLE_OWNER );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(207424077958369637.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(207424671147369643.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get object ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_object in (',
'    select object_id, object_name',
'    from sys.dba_objects',
'    where object_name in (:P3100_TABLE_NAME, :P3100_EXISTING_TABLE, :P3100_ERROR_TABLE)',
'    and owner = :P3100_TABLE_OWNER )',
'loop',
'    if l_object.object_name = :P3100_TABLE_NAME and :P3100_LOAD_TO = ''NEW'' then',
'        :P3110_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3100_EXISTING_TABLE and :P3100_LOAD_TO = ''EXISTING'' then',
'        :P3110_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3100_ERROR_TABLE then',
'        :P3110_ERR_TAB_OBJ_ID := l_object.object_id;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P3110_TAB_OBJ_ID'
,p_process_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_03120
begin
wwv_flow_api.create_page(
 p_id=>3120.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica dati'
,p_page_mode=>'MODAL'
,p_step_title=>'Configura'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690782249755803171.4504)
,p_page_css_classes=>'a-Page--DataLoadPreview'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
,p_dialog_height=>'768'
,p_dialog_width=>'1024'
,p_dialog_chained=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3942307544766703.4504)
,p_plug_name=>'RDS'
,p_region_name=>'preview_selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4142580643584034.4504)
,p_plug_name=>'Pulsanti'
,p_region_css_classes=>'u-tC'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="desc">I tipi di colonna sono basati su un campione delle prime <span id="placeholder_P3120_PARSED_ROW_COUNT">&P3120_PARSED_ROW_COUNT.</span> righe.<br />',
'Vengono visualizzate <span id="placeholder_P3120_PARSED_COLUMN_COUNT">&P3120_PARSED_COLUMN_COUNT.</span> colonne e un massimo 100 righe.</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20163613189354601.4504)
,p_name=>'Colonne da caricare'
,p_region_name=>'tab_columns'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'a-DataLoad-previewColumns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ',
'    l_columns as (',
'        select ',
'            fc.column_position,    ',
'            case when :P3120_FIRST_LINE = ''HEADERS'' then fc.column_name else ''COL'' || lpad( rownum,3,''0'') end as column_name, ',
'            regexp_replace( fc.data_type, ''\(\d+\)'','''') data_type,',
'            case when substr( fc.data_type, 1, 8 ) = ''VARCHAR2''',
'               then replace( substr( fc.data_type, 10 ), '')'' )',
'               else null',
'           end as max_length,',
'            fc.format_mask,',
'            fc.detected_group_char group_char,',
'            fc.detected_decimal_char decimal_char',
'        from wwv_flow_collections c,',
'             table( wwv_flow_data_parser.get_columns( c.clob001 ) ) fc',
'        where c.collection_name =''APEX$DATALOAD'' ),',
'    l_config_columns as (',
'        select',
'            to_number(s.c001) column_position,',
'            s.c002 column_name,',
'            s.c003 format_mask,',
'            s.c004 group_char,',
'            s.c005 decimal_char,',
'            s.c006 data_type,',
'            s.c007 max_length',
'        from wwv_flow_collections s',
'        where collection_name = ''APEX$DATALOAD_COLUMNS'' )',
'select',
'    c.column_position,',
'    apex_item.hidden(',
'        p_idx            => 6,',
'        p_value          => c.column_position )||',
'    apex_item.hidden(',
'        p_idx            => 2,',
'        p_value          => c.column_name )||',
'    apex_item.checkbox2(',
'        p_idx            => 1,',
'        p_value          => c.column_position, ',
'        p_attributes     => ''aria-label="Select Row: ''||wwv_flow_escape.html_attribute(c.column_name)||''"'',',
'        p_checked_values => cf.column_position ) as select_column,   ',
'    c.column_name,',
'    case when cf.data_type = ''CLOB'' then',
'        apex_item.display_and_save(',
'            p_idx            => 7,',
'            p_value          => cf.data_type,',
'            p_item_label     => wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name)) )',
'    else',
'        apex_item.select_list_from_lov(',
'            p_idx            => 7,',
'            p_value          => cf.data_type,',
'            p_lov            => ''DATA.LOAD.DATA_TYPES'',',
'            p_show_null      => ''NO'',',
'            p_show_extra     => ''NO'',',
'            p_attributes     => case when cf.data_type = ''CLOB'' then ''disabled '' end ||',
'                                ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as column_type,',
'    apex_item.text(',
'        p_idx            => 8,',
'        p_value          => cf.max_length,',
'        p_size           => 5,',
'        p_maxLength      => 5,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as max_length,',
'    apex_item.text(',
'        p_idx            => 3,',
'        p_value          => cf.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    apex_item.text(',
'        p_idx            => 4,',
'        p_value          => cf.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    apex_item.text(',
'        p_idx            => 5,',
'        p_value          => cf.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c, l_config_columns cf',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'and  c.column_position = cf.column_position (+)',
'union',
'select',
'    c.column_position,',
'    apex_item.hidden(',
'        p_idx            => 6,',
'        p_value          => c.column_position )||',
'    apex_item.hidden(',
'        p_idx            => 2,',
'        p_value          => c.column_name )||',
'    apex_item.checkbox2(',
'        p_idx            => 1,',
'        p_value          => c.column_position, ',
'        p_attributes     => ''aria-label="Select Row: ''||wwv_flow_escape.html_attribute(c.column_name)||''"'',',
'        p_checked_values => c.column_position) as select_column,    ',
'    c.column_name,',
'    case when c.data_type = ''CLOB'' then',
'        apex_item.display_and_save(',
'            p_idx            => 7,',
'            p_value          => c.data_type,',
'            p_item_label     => wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name)) )',
'    else',
'        apex_item.select_list_from_lov(',
'            p_idx            => 7,',
'            p_value          => c.data_type,',
'            p_lov            => ''DATA.LOAD.DATA_TYPES'',',
'            p_show_null      => ''NO'',',
'            p_show_extra     => ''NO'',',
'            p_attributes     => ( case when c.data_type = ''CLOB'' then ''disabled '' end )||',
'                                ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as column_type,',
'    apex_item.text(',
'        p_idx            => 8,',
'        p_value          => c.max_length,',
'        p_size           => 5,',
'        p_maxLength      => 5,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as max_length,',
'    apex_item.text(',
'        p_idx            => 3,',
'        p_value          => c.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    apex_item.text(',
'        p_idx            => 4,',
'        p_value          => c.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    apex_item.text(',
'        p_idx            => 5,',
'        p_value          => c.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0',
'order by 1'))
,p_display_when_condition=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''NEW'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna colonna trovata.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(17016028737895907.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>62
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16447964178874803.4504)
,p_query_column_id=>2
,p_column_alias=>'SELECT_COLUMN'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" id="toggle-select-all-columns" aria-label="&APP_TEXT$SELECT_ALL.">'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16446390485874789.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome colonna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(84357785070572101.4504)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_TYPE'
,p_column_display_sequence=>12
,p_column_heading=>'Tipo di colonna'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(94755771110727901.4504)
,p_query_column_id=>5
,p_column_alias=>'MAX_LENGTH'
,p_column_display_sequence=>22
,p_column_heading=>'Lunghezza massima'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16447112807874803.4504)
,p_query_column_id=>6
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>32
,p_column_heading=>'Formato di visualizzazione'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(82704532073738118.4504)
,p_query_column_id=>7
,p_column_alias=>'GROUP_CHAR'
,p_column_display_sequence=>42
,p_column_heading=>'Separatore di gruppo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16447595872874803.4504)
,p_query_column_id=>8
,p_column_alias=>'DECIMAL_CHAR'
,p_column_display_sequence=>52
,p_column_heading=>'Carattere decimale'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33184350659846644.4504)
,p_plug_name=>'Settings Item Container'
,p_region_css_classes=>'a-ButtonRegion--DataLoadPreview'
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33362689698963696.4504)
,p_plug_name=>'Preview'
,p_region_name=>'tab_preview'
,p_region_css_classes=>'a-DataLoad-preview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4095522542018729.4504)
,p_name=>'Dati analizzati'
,p_region_name=>'preview_table'
,p_parent_plug_id=>wwv_flow_api.id(33362689698963696.4504)
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select line_number, ',
'       col001,col002,col003,col004,col005,col006,col007,col008,col009,col010,',
'       col011,col012,col013,col014,col015,col016,col017,col018,col019,col020,',
'       col021,col022,col023,col024,col025,col026,col027,col028,col029,col030,',
'       col031,col032,col033,col034,col035,col036,col037,col038,col039,col040,',
'       col041,col042,col043,col044,col045,col046,col047,col048,col049,col050,',
'       col051,col052,col053,col054,col055,col056,col057,col058,col059,col060,',
'       col061,col062,col063,col064,col065,col066,col067,col068,col069,col070,',
'       col071,col072,col073,col074,col075,col076,col077,col078,col079,col080,',
'       col081,col082,col083,col084,col085,col086,col087,col088,col089,col090,',
'       col091,col092,col093,col094,col095,col096,col097,col098,col099,col100',
'from apex_application_temp_files f, ',
'     table( wwv_flow_data_parser.parse(',
'                p_content               => f.blob_content,',
'                p_file_name             => f.filename,',
'                p_add_headers_row       => ''Y'',',
'                -- we cannot use coalesce( :P3120_FIRST_LINE, :P3100_FIRST_LINE ) since :P3120_FIRST_LINE contains NULL when not selected!',
'                --p_skip_rows          => case when :P3120_FIRST_LINE = ''HEADERS'' and :P3100_FILE_TYPE in ( 1, 2 ) then 1 else 0 end,',
'                -- please *always* set p_max_rows as a safeguard against fully parsing large files',
'                p_max_rows              => nullif(:P3120_MAX_ROW_COUNT, ''0''),',
'                -- for parser to return p_return_rows, region max rows must be > p_return_rows',
'                p_return_rows           => 100,',
'                p_xlsx_sheet_name       => ( case when :P3100_FILE_TYPE = 1 and :P3120_XLSX_SHEET is not null then :P3120_XLSX_SHEET end ),',
'                p_csv_col_delimiter     => replace(:P3120_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                p_file_charset          => coalesce( :P3120_FILE_CHARSET, ''AL32UTF8'' ),',
'                p_csv_enclosed          => nullif( :P3120_CSV_ENCLOSED, ''None'' ),',
'                p_force_trim_whitespace => :P3120_TRIM_WHITESPACE,',
'                p_nullif                => :P3120_NULLIF )',
'                )',
'where f.name = :P3100_FILE',
'and :P3100_SOURCE_TYPE = ''FILE''',
'union all',
'select line_number, ',
'       col001,col002,col003,col004,col005,col006,col007,col008,col009,col010,',
'       col011,col012,col013,col014,col015,col016,col017,col018,col019,col020,',
'       col021,col022,col023,col024,col025,col026,col027,col028,col029,col030,',
'       col031,col032,col033,col034,col035,col036,col037,col038,col039,col040,',
'       col041,col042,col043,col044,col045,col046,col047,col048,col049,col050,',
'       col051,col052,col053,col054,col055,col056,col057,col058,col059,col060,',
'       col061,col062,col063,col064,col065,col066,col067,col068,col069,col070,',
'       col071,col072,col073,col074,col075,col076,col077,col078,col079,col080,',
'       col081,col082,col083,col084,col085,col086,col087,col088,col089,col090,',
'       col091,col092,col093,col094,col095,col096,col097,col098,col099,col100',
'from apex_collections c, ',
'     table( wwv_flow_data_parser.parse(',
'                p_content               => c.blob001,',
'                p_file_type             => 2,',
'                --   ',
'                p_add_headers_row       => ''Y'',',
'                p_max_rows              => nullif(:P3120_MAX_ROW_COUNT, ''0''),',
'                -- for parser to return p_return_rows, region max rows must be > p_return_rows',
'                p_return_rows           => 100,',
'                p_csv_col_delimiter     => replace(:P3120_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                p_file_charset          => coalesce( :P3120_FILE_CHARSET, ''AL32UTF8'' ),',
'                p_csv_enclosed          => nullif( :P3120_CSV_ENCLOSED, ''None'' ),',
'                p_force_trim_whitespace => :P3120_TRIM_WHITESPACE,',
'                p_nullif                => :P3120_NULLIF )',
'                )',
'where c.collection_name=''CLOB_CONTENT''',
'and :P3100_SOURCE_TYPE = ''COPY_PASTE'';'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>110
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_row_count_max=>110
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4095627438018730.4504)
,p_query_column_id=>1
,p_column_alias=>'LINE_NUMBER'
,p_column_display_sequence=>1
,p_column_heading=>'Riga'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4095701906018731.4504)
,p_query_column_id=>2
,p_column_alias=>'COL001'
,p_column_display_sequence=>2
,p_column_heading=>'COL001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4095816508018732.4504)
,p_query_column_id=>3
,p_column_alias=>'COL002'
,p_column_display_sequence=>3
,p_column_heading=>'COL002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4095916993018733.4504)
,p_query_column_id=>4
,p_column_alias=>'COL003'
,p_column_display_sequence=>4
,p_column_heading=>'COL003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096078432018734.4504)
,p_query_column_id=>5
,p_column_alias=>'COL004'
,p_column_display_sequence=>5
,p_column_heading=>'COL004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096140312018735.4504)
,p_query_column_id=>6
,p_column_alias=>'COL005'
,p_column_display_sequence=>6
,p_column_heading=>'COL005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096207006018736.4504)
,p_query_column_id=>7
,p_column_alias=>'COL006'
,p_column_display_sequence=>7
,p_column_heading=>'COL006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096399568018737.4504)
,p_query_column_id=>8
,p_column_alias=>'COL007'
,p_column_display_sequence=>8
,p_column_heading=>'COL007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096479039018738.4504)
,p_query_column_id=>9
,p_column_alias=>'COL008'
,p_column_display_sequence=>9
,p_column_heading=>'COL008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096541442018739.4504)
,p_query_column_id=>10
,p_column_alias=>'COL009'
,p_column_display_sequence=>10
,p_column_heading=>'COL009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096698615018740.4504)
,p_query_column_id=>11
,p_column_alias=>'COL010'
,p_column_display_sequence=>11
,p_column_heading=>'COL010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096794029018741.4504)
,p_query_column_id=>12
,p_column_alias=>'COL011'
,p_column_display_sequence=>12
,p_column_heading=>'COL011'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096882678018742.4504)
,p_query_column_id=>13
,p_column_alias=>'COL012'
,p_column_display_sequence=>13
,p_column_heading=>'COL012'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4096977361018743.4504)
,p_query_column_id=>14
,p_column_alias=>'COL013'
,p_column_display_sequence=>14
,p_column_heading=>'COL013'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4097069663018744.4504)
,p_query_column_id=>15
,p_column_alias=>'COL014'
,p_column_display_sequence=>15
,p_column_heading=>'COL014'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4097109638018745.4504)
,p_query_column_id=>16
,p_column_alias=>'COL015'
,p_column_display_sequence=>16
,p_column_heading=>'COL015'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4097296832018746.4504)
,p_query_column_id=>17
,p_column_alias=>'COL016'
,p_column_display_sequence=>17
,p_column_heading=>'COL016'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4097335005018747.4504)
,p_query_column_id=>18
,p_column_alias=>'COL017'
,p_column_display_sequence=>18
,p_column_heading=>'COL017'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4097407519018748.4504)
,p_query_column_id=>19
,p_column_alias=>'COL018'
,p_column_display_sequence=>19
,p_column_heading=>'COL018'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4097570225018749.4504)
,p_query_column_id=>20
,p_column_alias=>'COL019'
,p_column_display_sequence=>20
,p_column_heading=>'COL019'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4097694903018750.4504)
,p_query_column_id=>21
,p_column_alias=>'COL020'
,p_column_display_sequence=>21
,p_column_heading=>'COL020'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4139230045584001.4504)
,p_query_column_id=>22
,p_column_alias=>'COL021'
,p_column_display_sequence=>22
,p_column_heading=>'COL021'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4139353025584002.4504)
,p_query_column_id=>23
,p_column_alias=>'COL022'
,p_column_display_sequence=>23
,p_column_heading=>'COL022'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4139438866584003.4504)
,p_query_column_id=>24
,p_column_alias=>'COL023'
,p_column_display_sequence=>24
,p_column_heading=>'COL023'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4139528587584004.4504)
,p_query_column_id=>25
,p_column_alias=>'COL024'
,p_column_display_sequence=>25
,p_column_heading=>'COL024'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4139626793584005.4504)
,p_query_column_id=>26
,p_column_alias=>'COL025'
,p_column_display_sequence=>26
,p_column_heading=>'COL025'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4139773523584006.4504)
,p_query_column_id=>27
,p_column_alias=>'COL026'
,p_column_display_sequence=>27
,p_column_heading=>'COL026'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4139853620584007.4504)
,p_query_column_id=>28
,p_column_alias=>'COL027'
,p_column_display_sequence=>28
,p_column_heading=>'COL027'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4139943037584008.4504)
,p_query_column_id=>29
,p_column_alias=>'COL028'
,p_column_display_sequence=>29
,p_column_heading=>'COL028'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140020006584009.4504)
,p_query_column_id=>30
,p_column_alias=>'COL029'
,p_column_display_sequence=>30
,p_column_heading=>'COL029'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140128629584010.4504)
,p_query_column_id=>31
,p_column_alias=>'COL030'
,p_column_display_sequence=>31
,p_column_heading=>'COL030'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140221496584011.4504)
,p_query_column_id=>32
,p_column_alias=>'COL031'
,p_column_display_sequence=>32
,p_column_heading=>'COL031'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140305790584012.4504)
,p_query_column_id=>33
,p_column_alias=>'COL032'
,p_column_display_sequence=>33
,p_column_heading=>'COL032'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140455288584013.4504)
,p_query_column_id=>34
,p_column_alias=>'COL033'
,p_column_display_sequence=>34
,p_column_heading=>'COL033'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140588027584014.4504)
,p_query_column_id=>35
,p_column_alias=>'COL034'
,p_column_display_sequence=>35
,p_column_heading=>'COL034'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140662450584015.4504)
,p_query_column_id=>36
,p_column_alias=>'COL035'
,p_column_display_sequence=>36
,p_column_heading=>'COL035'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140741697584016.4504)
,p_query_column_id=>37
,p_column_alias=>'COL036'
,p_column_display_sequence=>37
,p_column_heading=>'COL036'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140892210584017.4504)
,p_query_column_id=>38
,p_column_alias=>'COL037'
,p_column_display_sequence=>38
,p_column_heading=>'COL037'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4140971698584018.4504)
,p_query_column_id=>39
,p_column_alias=>'COL038'
,p_column_display_sequence=>39
,p_column_heading=>'COL038'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141054010584019.4504)
,p_query_column_id=>40
,p_column_alias=>'COL039'
,p_column_display_sequence=>40
,p_column_heading=>'COL039'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141102541584020.4504)
,p_query_column_id=>41
,p_column_alias=>'COL040'
,p_column_display_sequence=>41
,p_column_heading=>'COL040'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141295677584021.4504)
,p_query_column_id=>42
,p_column_alias=>'COL041'
,p_column_display_sequence=>42
,p_column_heading=>'COL041'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141327065584022.4504)
,p_query_column_id=>43
,p_column_alias=>'COL042'
,p_column_display_sequence=>43
,p_column_heading=>'COL042'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141496900584023.4504)
,p_query_column_id=>44
,p_column_alias=>'COL043'
,p_column_display_sequence=>44
,p_column_heading=>'COL043'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
end;
/
begin
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141539072584024.4504)
,p_query_column_id=>45
,p_column_alias=>'COL044'
,p_column_display_sequence=>45
,p_column_heading=>'COL044'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141606742584025.4504)
,p_query_column_id=>46
,p_column_alias=>'COL045'
,p_column_display_sequence=>46
,p_column_heading=>'COL045'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141769077584026.4504)
,p_query_column_id=>47
,p_column_alias=>'COL046'
,p_column_display_sequence=>47
,p_column_heading=>'COL046'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141881409584027.4504)
,p_query_column_id=>48
,p_column_alias=>'COL047'
,p_column_display_sequence=>48
,p_column_heading=>'COL047'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4141944378584028.4504)
,p_query_column_id=>49
,p_column_alias=>'COL048'
,p_column_display_sequence=>49
,p_column_heading=>'COL048'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4142057597584029.4504)
,p_query_column_id=>50
,p_column_alias=>'COL049'
,p_column_display_sequence=>50
,p_column_heading=>'COL049'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4142112774584030.4504)
,p_query_column_id=>51
,p_column_alias=>'COL050'
,p_column_display_sequence=>51
,p_column_heading=>'COL050'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213830519056023.4504)
,p_query_column_id=>52
,p_column_alias=>'COL051'
,p_column_display_sequence=>52
,p_column_heading=>'COL051'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4213985667056024.4504)
,p_query_column_id=>53
,p_column_alias=>'COL052'
,p_column_display_sequence=>53
,p_column_heading=>'COL052'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214058128056025.4504)
,p_query_column_id=>54
,p_column_alias=>'COL053'
,p_column_display_sequence=>54
,p_column_heading=>'COL053'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214108143056026.4504)
,p_query_column_id=>55
,p_column_alias=>'COL054'
,p_column_display_sequence=>55
,p_column_heading=>'COL054'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214201077056027.4504)
,p_query_column_id=>56
,p_column_alias=>'COL055'
,p_column_display_sequence=>56
,p_column_heading=>'COL055'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214356043056028.4504)
,p_query_column_id=>57
,p_column_alias=>'COL056'
,p_column_display_sequence=>57
,p_column_heading=>'COL056'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214416146056029.4504)
,p_query_column_id=>58
,p_column_alias=>'COL057'
,p_column_display_sequence=>58
,p_column_heading=>'COL057'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214534078056030.4504)
,p_query_column_id=>59
,p_column_alias=>'COL058'
,p_column_display_sequence=>59
,p_column_heading=>'COL058'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214647053056031.4504)
,p_query_column_id=>60
,p_column_alias=>'COL059'
,p_column_display_sequence=>60
,p_column_heading=>'COL059'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214783952056032.4504)
,p_query_column_id=>61
,p_column_alias=>'COL060'
,p_column_display_sequence=>61
,p_column_heading=>'COL060'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214830626056033.4504)
,p_query_column_id=>62
,p_column_alias=>'COL061'
,p_column_display_sequence=>62
,p_column_heading=>'COL061'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4214990581056034.4504)
,p_query_column_id=>63
,p_column_alias=>'COL062'
,p_column_display_sequence=>63
,p_column_heading=>'COL062'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215038658056035.4504)
,p_query_column_id=>64
,p_column_alias=>'COL063'
,p_column_display_sequence=>64
,p_column_heading=>'COL063'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215189206056036.4504)
,p_query_column_id=>65
,p_column_alias=>'COL064'
,p_column_display_sequence=>65
,p_column_heading=>'COL064'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215288166056037.4504)
,p_query_column_id=>66
,p_column_alias=>'COL065'
,p_column_display_sequence=>66
,p_column_heading=>'COL065'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215323561056038.4504)
,p_query_column_id=>67
,p_column_alias=>'COL066'
,p_column_display_sequence=>67
,p_column_heading=>'COL066'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215485218056039.4504)
,p_query_column_id=>68
,p_column_alias=>'COL067'
,p_column_display_sequence=>68
,p_column_heading=>'COL067'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215536239056040.4504)
,p_query_column_id=>69
,p_column_alias=>'COL068'
,p_column_display_sequence=>69
,p_column_heading=>'COL068'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215679718056041.4504)
,p_query_column_id=>70
,p_column_alias=>'COL069'
,p_column_display_sequence=>70
,p_column_heading=>'COL069'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215752947056042.4504)
,p_query_column_id=>71
,p_column_alias=>'COL070'
,p_column_display_sequence=>71
,p_column_heading=>'COL070'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215873869056043.4504)
,p_query_column_id=>72
,p_column_alias=>'COL071'
,p_column_display_sequence=>72
,p_column_heading=>'COL071'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4215976896056044.4504)
,p_query_column_id=>73
,p_column_alias=>'COL072'
,p_column_display_sequence=>73
,p_column_heading=>'COL072'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4216096921056045.4504)
,p_query_column_id=>74
,p_column_alias=>'COL073'
,p_column_display_sequence=>74
,p_column_heading=>'COL073'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4216186784056046.4504)
,p_query_column_id=>75
,p_column_alias=>'COL074'
,p_column_display_sequence=>75
,p_column_heading=>'COL074'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4216277094056047.4504)
,p_query_column_id=>76
,p_column_alias=>'COL075'
,p_column_display_sequence=>76
,p_column_heading=>'COL075'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4216365696056048.4504)
,p_query_column_id=>77
,p_column_alias=>'COL076'
,p_column_display_sequence=>77
,p_column_heading=>'COL076'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4216421564056049.4504)
,p_query_column_id=>78
,p_column_alias=>'COL077'
,p_column_display_sequence=>78
,p_column_heading=>'COL077'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4216571845056050.4504)
,p_query_column_id=>79
,p_column_alias=>'COL078'
,p_column_display_sequence=>79
,p_column_heading=>'COL078'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4261747128082501.4504)
,p_query_column_id=>80
,p_column_alias=>'COL079'
,p_column_display_sequence=>80
,p_column_heading=>'COL079'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4261825910082502.4504)
,p_query_column_id=>81
,p_column_alias=>'COL080'
,p_column_display_sequence=>81
,p_column_heading=>'COL080'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4261942413082503.4504)
,p_query_column_id=>82
,p_column_alias=>'COL081'
,p_column_display_sequence=>82
,p_column_heading=>'COL081'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262046820082504.4504)
,p_query_column_id=>83
,p_column_alias=>'COL082'
,p_column_display_sequence=>83
,p_column_heading=>'COL082'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262197071082505.4504)
,p_query_column_id=>84
,p_column_alias=>'COL083'
,p_column_display_sequence=>84
,p_column_heading=>'COL083'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262203979082506.4504)
,p_query_column_id=>85
,p_column_alias=>'COL084'
,p_column_display_sequence=>85
,p_column_heading=>'COL084'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262355414082507.4504)
,p_query_column_id=>86
,p_column_alias=>'COL085'
,p_column_display_sequence=>86
,p_column_heading=>'COL085'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262430686082508.4504)
,p_query_column_id=>87
,p_column_alias=>'COL086'
,p_column_display_sequence=>87
,p_column_heading=>'COL086'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262575343082509.4504)
,p_query_column_id=>88
,p_column_alias=>'COL087'
,p_column_display_sequence=>88
,p_column_heading=>'COL087'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262609592082510.4504)
,p_query_column_id=>89
,p_column_alias=>'COL088'
,p_column_display_sequence=>89
,p_column_heading=>'COL088'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262779568082511.4504)
,p_query_column_id=>90
,p_column_alias=>'COL089'
,p_column_display_sequence=>90
,p_column_heading=>'COL089'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262873318082512.4504)
,p_query_column_id=>91
,p_column_alias=>'COL090'
,p_column_display_sequence=>91
,p_column_heading=>'COL090'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4262986979082513.4504)
,p_query_column_id=>92
,p_column_alias=>'COL091'
,p_column_display_sequence=>92
,p_column_heading=>'COL091'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263080531082514.4504)
,p_query_column_id=>93
,p_column_alias=>'COL092'
,p_column_display_sequence=>93
,p_column_heading=>'COL092'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263124215082515.4504)
,p_query_column_id=>94
,p_column_alias=>'COL093'
,p_column_display_sequence=>94
,p_column_heading=>'COL093'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263239397082516.4504)
,p_query_column_id=>95
,p_column_alias=>'COL094'
,p_column_display_sequence=>95
,p_column_heading=>'COL094'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263315322082517.4504)
,p_query_column_id=>96
,p_column_alias=>'COL095'
,p_column_display_sequence=>96
,p_column_heading=>'COL095'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263447002082518.4504)
,p_query_column_id=>97
,p_column_alias=>'COL096'
,p_column_display_sequence=>97
,p_column_heading=>'COL096'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263507300082519.4504)
,p_query_column_id=>98
,p_column_alias=>'COL097'
,p_column_display_sequence=>98
,p_column_heading=>'COL097'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263690377082520.4504)
,p_query_column_id=>99
,p_column_alias=>'COL098'
,p_column_display_sequence=>99
,p_column_heading=>'COL098'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263792446082521.4504)
,p_query_column_id=>100
,p_column_alias=>'COL099'
,p_column_display_sequence=>100
,p_column_heading=>'COL099'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4263882248082522.4504)
,p_query_column_id=>101
,p_column_alias=>'COL100'
,p_column_display_sequence=>101
,p_column_heading=>'COL100'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18663279696871922.4504)
,p_plug_name=>'get file profile and save'
,p_region_name=>'getFileProfile'
,p_parent_plug_id=>wwv_flow_api.id(33362689698963696.4504)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile             clob;',
'    l_file_content        blob;',
'    l_profile_record      wwv_flow_data_parser.t_file_profile;',
'    ',
'    l_column_name_changed boolean := false;',
'begin',
'    l_profile        := wwv_flow_data_parser.get_file_profile;',
'    l_profile_record := wwv_flow_data_parser.json_to_profile( l_profile );',
'',
'    if :P3120_FIRST_LINE is null or :P3120_FIRST_LINE != ''HEADERS'' then',
'        for i in 1 .. l_profile_record.file_columns.count loop',
'            l_profile_record.file_columns( i ).name := ''COL'' || lpad( i,3,''0'');',
'        end loop;',
'        l_profile := wwv_flow_data_parser.profile_to_json(l_profile_record);',
'        ',
'        l_column_name_changed := true;',
'        ',
'        -- see if configure columns are same, if not column names changed',
'        for i in 1 .. l_profile_record.file_columns.count',
'        loop',
'            for l_configure in (',
'                select',
'                    c001   column_name,',
'                    c002   mapped_column',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                and c001 = l_profile_record.file_columns( i ).name )',
'            loop    ',
'                l_column_name_changed := false;',
'                exit;',
'            end loop;',
'        end loop;',
'    end if;',
'    ',
'    -- save file profile in collection for later use',
'   wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'   wwv_flow_collection.add_member( ''APEX$DATALOAD'', p_clob001 => l_profile );',
'   ',
'    if l_column_name_changed then',
'        wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    end if;',
'   ',
'    :P3120_PARSED_ROW_COUNT := l_profile_record.parsed_rows;',
'    ',
'    if l_profile_record.file_columns.count <= 100 then',
'        :P3120_PARSED_COLUMN_COUNT := l_profile_record.file_columns.count;',
'    else',
'        :P3120_PARSED_COLUMN_COUNT := 100;',
'    end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(193340845691147579.4504)
,p_name=>'Mapping colonne'
,p_region_name=>'tab_columns'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'a-DataLoad-previewColumns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'l_msg as (',
'    select wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.UNMAPPED'') unmapped',
'    from sys.dual)',
', l_columns as (',
'    select ',
'        fc.column_position,    ',
'        case when :P3120_FIRST_LINE = ''HEADERS'' then',
'            fc.column_name',
'        else ',
'            ''COL'' || lpad( rownum,3,''0'')',
'        end as column_name,',
'        case when :P3120_FIRST_LINE = ''HEADERS'' then',
'            ( select tc.column_name ',
'              from sys.dba_tab_columns tc',
'              where tc.owner = :P3100_TABLE_OWNER',
'              and tc.table_name = :P3100_EXISTING_TABLE',
'              and tc.column_name = fc.column_name )',
'        else',
'             null',
'        end as map_column_name, ',
'        fc.data_type, ',
'        fc.format_mask,',
'        fc.detected_group_char group_char,',
'        fc.detected_decimal_char decimal_char',
'    from wwv_flow_collections c,',
'         table( wwv_flow_data_parser.get_columns( c.clob001 ) ) fc',
'    where c.collection_name =''APEX$DATALOAD'' )',
', l_sum_existing_tab_col as (',
'    select sum( length( ''<option value="''|| column_name ||''">''|| column_name ||'' (''|| data_type ||'')</option>'' ) ) total_length',
'    from sys.dba_tab_columns tc',
'    where tc.owner = :P3100_TABLE_OWNER',
'    and tc.table_name = :P3100_EXISTING_TABLE )',
'select',
'    c.column_position,',
'    c.column_name,',
'    c.data_type,',
'    apex_item.hidden(',
'        p_idx            => 1,',
'        p_value          => c.column_name)||',
'    case when tc.total_length <= 3900 then',
'        apex_item.select_list_from_lov(',
'            p_idx            => 2,',
'            p_value          => m.c002,',
'            p_lov            => ''P3120_TABLE_COLUMNS'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,         ',
'            p_show_extra     => ''NO'',',
'            p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'', wwv_flow_escape.html_attribute(c.column_name))||''"'') ',
'    else',
'        -- bug 30464422 fix, show popup if total existing table column option  > 3900 to avoid error',
'        wwv_flow_item.popup_from_lov(',
'            p_idx            => 2,',
'            p_value          => m.c002,',
'            p_lov_name       => ''P3120_TABLE_COLUMNS'',',
'            p_width          => 40,',
'            p_show_null      => ''YES'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as column_map,',
'    apex_item.text(',
'        p_idx            => 3,',
'        p_value          => m.c003,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    apex_item.text(',
'        p_idx            => 4,',
'        p_value          => m.c004,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    apex_item.text(',
'        p_idx            => 5,',
'        p_value          => m.c005,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c, l_sum_existing_tab_col tc, l_msg msg, wwv_flow_collections m',
'where c.column_name = m.c001 (+)',
'and wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'union',
'select',
'    c.column_position,',
'    c.column_name,',
'    c.data_type, ',
'    apex_item.hidden(',
'        p_idx            => 1,',
'        p_value          => c.column_name)||',
'    case when tc.total_length <= 3900 then',
'        apex_item.select_list_from_lov(',
'            p_idx            => 2,',
'            p_value          => c.map_column_name,',
'            p_lov            => ''P3120_TABLE_COLUMNS'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_show_extra     => ''NO'',',
'            p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'', c.column_name )||''"'')',
'    else',
'        -- bug 30464422 fix, show popup if total existing table column option  > 3900 to avoid error ',
'        wwv_flow_item.popup_from_lov(',
'            p_idx            => 2,',
'            p_value          => c.map_column_name,',
'            p_lov_name       => ''P3120_TABLE_COLUMNS'',',
'            p_width          => 40,',
'            p_show_null      => ''YES'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'', c.column_name )||''"'')',
'    end as column_map,',
'    apex_item.text(',
'        p_idx            => 3,',
'        p_value          => c.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    apex_item.text(',
'        p_idx            => 4,',
'        p_value          => c.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    apex_item.text(',
'        p_idx            => 5,',
'        p_value          => c.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char        ',
'from l_columns c, l_msg msg, l_sum_existing_tab_col tc',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0',
'order by 1'))
,p_display_when_condition=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna colonna trovata.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(71165069604648136.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(71164390875648131.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna di origine'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(71164643957648135.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo dati'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(71165427710648136.4504)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_MAP'
,p_column_display_sequence=>4
,p_column_heading=>'Mappa a'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(71166248421648137.4504)
,p_query_column_id=>5
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>5
,p_column_heading=>'Formato di visualizzazione'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(82704401450738117.4504)
,p_query_column_id=>6
,p_column_alias=>'GROUP_CHAR'
,p_column_display_sequence=>6
,p_column_heading=>'Separatore di gruppo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(71165863827648137.4504)
,p_query_column_id=>7
,p_column_alias=>'DECIMAL_CHAR'
,p_column_display_sequence=>7
,p_column_heading=>'Carattere decimale'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3942483089766704.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4142580643584034.4504)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva modifiche'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4142690830584035.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4142580643584034.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Chiudi finestra di dialogo'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4264413621082528.4504)
,p_name=>'P3120_FILE_SIZE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16728721207833241.4504)
,p_name=>'P3120_FIRST_LINE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_prompt=>'Intestazioni colonna'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DATA.LOAD.FIRST_LINE'
,p_lov=>'.'||wwv_flow_api.id(3934090607812623.4504)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) not in (wwv_flow_data_parser.c_file_type_xml, wwv_flow_data_parser.c_file_type_json) then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare questa opzione se i dati contengono nomi di colonne nella prima riga.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16729160519833244.4504)
,p_name=>'P3120_MAX_ROW_COUNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_item_default=>'200'
,p_prompt=>'Righe da campionare'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.MAX_ROW_RANGE'
,p_lov=>'.'||wwv_flow_api.id(3867907456164412.4504)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_css_classes=>'tab-columns'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare il numero massimo di righe da utilizzare per effettuare il campionamento dei tipi di colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16730081104833245.4504)
,p_name=>'P3120_PREV_MAX_ROW_COUNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16730418310833246.4504)
,p_name=>'P3120_XLSX_SHEET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_prompt=>'Seleziona foglio'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_display_name, sheet_file_name',
'from apex_application_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_'';'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sheet_cnt number := 0;',
'begin',
'    -- shortcut: return immediately when we don''t have an XLSX file, since invoking wwv_flow_data_parser.get_xlsx_worksheets',
'    -- is an expensive operation leading to nothing',
'    if lower( :P3100_FILE ) not like ''%.xls_'' then',
'        return false;',
'    end if;',
'',
'    select count(*)',
'    into l_sheet_cnt',
'    from apex_application_temp_files f, ',
'         table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                    p_content => f.blob_content ) )',
'    where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_'';',
'    ',
'    -- if there is multiple sheets, display',
'    if ( l_sheet_cnt > 1 ) then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Il file contiene pi\00F9 fogli di lavoro. Selezionare il foglio di lavoro che si desidera caricare.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16731233824833247.4504)
,p_name=>'P3120_CSV_COL_DELIMITER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_prompt=>'Delimitatore colonne'
,p_source=>'P3100_CSV_COL_DELIMITER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov=>'.'||wwv_flow_api.id(3927422505659936.4504)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare un carattere delimitatore di colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16732148218833247.4504)
,p_name=>'P3120_CSV_ENCLOSED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_prompt=>'Racchiuso da'
,p_source=>'P3100_CSV_ENCLOSED'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov=>'.'||wwv_flow_api.id(3931221323686172.4504)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Selezionare un carattere in cui racchiudere i valori della colonna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16733088247833248.4504)
,p_name=>'P3120_FILE_CHARSET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_item_default=>'AL32UTF8'
,p_prompt=>'Codifica file'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_DB_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(143362112016702427.4504)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Scegliere il set di caratteri in cui il file \00E8 codificato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16753269820154313.4504)
,p_name=>'P3120_PARSED_ROW_COUNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20163613189354601.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16910933728036337.4504)
,p_name=>'P3120_PARSED_COLUMN_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20163613189354601.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20812906888966802.4504)
,p_name=>'P3120_TRIM_WHITESPACE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_item_default=>'Y'
,p_prompt=>'Forza rimozione spazio vuoto'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_css_classes=>'tab-columns'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Controlla in che modo APEX rimuove lo spazio vuoto iniziale e finale dai valori dei dati caricati:',
'</p>',
'<ul>',
unistr('    <li><strong>Disabilitato</strong>: nei file CSV verr\00E0 rimosso solo lo <em>spazio vuoto non racchiuso tra apici</em>. Lo spazio vuoto racchiuso tra apici o quello presente nei file XML, XLSX o JSON verr\00E0 conservato.</li>'),
'    <li><strong>Abilitato</strong>: tutti gli spazi vuoti iniziali e finali verranno rimossi dai valori dei dati caricati.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72668194960230601.4504)
,p_name=>'P3120_ACTION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Used for default tab selection on page load'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(207424466246369641.4504)
,p_name=>'P3120_NULLIF'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(33184350659846644.4504)
,p_prompt=>'Considera come Null'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>20
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(492677255463052067.4504)
,p_item_css_classes=>'tab-columns'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Il valore senza distinzione tra maiuscole e minuscole immesso verr\00E0 considerato NULL. Ad esempio, "tdb", "n/a", "sconosciuto", "-".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(16480193144310407.4504)
,p_validation_name=>'must at least select one column'
,p_validation_sequence=>10
,p_validation=>'apex_application.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Selezionare almeno una colonna da caricare.'
,p_when_button_pressed=>wwv_flow_api.id(3942483089766704.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(81742731063478601.4504)
,p_validation_name=>'check group and decimal char'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_load_to      varchar2(10);',
'    ',
'    l_group_char   varchar2(4);',
'    l_decimal_char varchar2(4);',
'    l_column_name  varchar2(128);',
'    l_error_msg    varchar2(4000);',
'',
'    function validate_group_decimal_char',
'    return varchar2',
'    is',
'        l_msg varchar2(4000);',
'    begin',
'        -- if group separator defined, decimal character must be defined',
'        if l_group_char is not null then',
'            if l_decimal_char is null then',
'                l_msg := wwv_flow_lang.system_message( ',
'                            ''DATA_LOAD.DECIMAL_CHAR_REQUIRED'',',
'                            l_column_name );',
'            end if;',
'        end if;',
'',
'        -- group and decimal chars cannot be same',
'        if l_group_char = l_decimal_char then',
'            l_msg := wwv_flow_lang.system_message(',
'                         ''DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'',',
'                         l_column_name );',
'        end if;',
'        ',
'        return l_msg;',
'    end validate_group_decimal_char;',
'begin',
'    l_load_to := coalesce( :P3100_LOAD_TO, ''NEW'');',
'',
'    if l_load_to = ''NEW'' then',
'        -- loop through all column postions',
'        for i in 1 .. wwv_flow.g_f06.count',
'        loop',
'            for j in 1 .. wwv_flow.g_f01.count',
'            loop',
'                -- if column checked to load, validate',
'                if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'                    l_column_name  := wwv_flow.g_f02( i );',
'                    l_group_char   := wwv_flow.g_f04( i );',
'                    l_decimal_char := wwv_flow.g_f05( i );',
'',
'                    l_error_msg := validate_group_decimal_char;',
'                    if l_error_msg is not null then',
'                        return l_error_msg;',
'                    end if;',
'',
'                    exit;',
'                end if;',
'            end loop;',
'        end loop;',
'    elsif l_load_to= ''EXISTING'' then',
'        for i in 1 .. wwv_flow.g_f02.count',
'        loop',
'            -- if column mapped, check group and decimal char',
'            if wwv_flow.g_f02(i) is not null then',
'                l_column_name  := wwv_flow.g_f02( i );',
'                l_group_char   := wwv_flow.g_f04( i );',
'                l_decimal_char := wwv_flow.g_f05( i );',
'',
'                l_error_msg := validate_group_decimal_char;',
'                if l_error_msg is not null then',
'                    return l_error_msg;',
'                end if;',
'            end if;',
'        end loop;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(3942483089766704.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(285737382733666601.4504)
,p_validation_name=>'table columns not mapped multiple times'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_names  wwv_flow_global.vc_map;',
'    l_col_name_idx  pls_integer;',
'begin',
'    l_col_name_idx := wwv_flow.g_f02.first;',
'    while l_col_name_idx is not null loop',
'        if wwv_flow.g_f02( l_col_name_idx ) is not null then',
'            if l_column_names.exists( wwv_flow.g_f02( l_col_name_idx ) ) then',
'                return wwv_flow_lang.system_message ( ''DATA_LOAD.DUPLICATE_MAPPING'', wwv_flow.g_f02( l_col_name_idx ) );',
'            else',
'                l_column_names( wwv_flow.g_f02( l_col_name_idx ) ) := null;',
'            end if;',
'        end if;',
'',
'        l_col_name_idx := wwv_flow.g_f02.next( l_col_name_idx );',
'    end loop;',
'    return null;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(3942483089766704.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(94756065775727904.4504)
,p_validation_name=>'check max length'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_type    wwv_flow_global.t_dbms_id;',
'    l_max_length   number;',
'begin',
'    ',
'    -- loop through all column postions',
'    for i in 1 .. wwv_flow.g_f06.count',
'    loop',
'',
'        for j in 1 .. wwv_flow.g_f01.count',
'        loop',
'            -- if column checked to load, validate',
'            if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'',
'                l_data_type  := wwv_flow.g_f07( i );',
'',
'                begin',
'                    l_max_length := to_number( wwv_flow.g_f08( i ) );',
'                exception when others then',
'                    if l_data_type = ''VARCHAR2'' then',
'                        -- if not number, validation fails',
'                        return false;',
'                    end if;',
'                end;',
'',
'                if l_data_type = ''VARCHAR2'' then',
'                    -- if null, validation fails',
'                    if l_max_length is null then',
'                        return false;',
'                    else',
'                        -- varchar2 data type max length must be between 1 and allowed max varchar2 size',
'                        if l_max_length < 1 or ',
'                           l_max_length > case when wwv_flow_db_version.c_has_extended_string_size then 32767 else 4000 end',
'                        then',
'                            return false;',
'                        end if;',
'                    end if;',
'                end if;',
'',
'                exit;',
'            end if;',
'        end loop;',
'    end loop;',
'',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La lunghezza massima \00E8 obbligatoria per le colonne VARCHAR2 e deve essere un numero compreso tra 1 e la dimensione massima consentita di VARCHAR2.')
,p_validation_condition=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(3942483089766704.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4213685135056021.4504)
,p_name=>'Hide empty columns'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(4095522542018729.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4213721059056022.4504)
,p_event_id=>wwv_flow_api.id(4213685135056021.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#dataload-full-preview th").each( function ( i,o ) {',
'    var lHdr        = $(o).attr("id");',
'    var lColIsEmpty = false;',
'        ',
'    // check whether the column header is empty ...',
'    if ( lHdr && lHdr !== "" && $(o).text() === "" ) {',
'        lColIsEmpty = true;',
'        ',
'        // now check whether the column is also empty',
'        $( "#dataload-full-preview td[headers=" + lHdr + "]" ).each( function( i, o ) {',
'            if ( $( o ).text() !== "" && $( o ).text() !== ''\xa0'' ) {',
'                lColIsEmpty = false;',
'                return;',
'            }',
'        });',
'        if ( lColIsEmpty ) {',
'            $( "#dataload-full-preview th#" + lHdr ).css( "display", "none");',
'            $( "#dataload-full-preview td[headers=" + lHdr + "]" ).css( "display", "none");',
'        }',
'    }',
'});'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16454539826013408.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4142690830584035.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16454641639013409.4504)
,p_event_id=>wwv_flow_api.id(16454539826013408.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16455260786013415.4504)
,p_name=>'Init UI on load'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16455305658013416.4504)
,p_event_id=>wwv_flow_api.id(16455260786013415.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Dialog size',
'apex.theme.stretchDialog( apex.util.getTopApex().jQuery( ''#'' + window.frameElement.parentNode.id ), 90 );',
'// RDS icons',
'var icon$ = $(''<span class="a-Icon icon-tree-attributes" aria-hidden="true"></span>'');',
'var rdsTab$ = $(''.apex-rds-item:last-child a:first-child span'');',
'var rdsId = $( ''#preview_selector > .apex-rds-container'' ).find( ''ul'' ).attr( ''id'' ).slice(0, -4);',
'icon$.prependTo(rdsTab$);',
'// shared functions',
'var getColId = function( id ){',
'    var int = parseInt( id ), i;',
'    if ( int <= 9 ) {',
'            i = ''COL00'' + int;',
'        } else if ( int > 9 && int <= 99 ) {',
'            i = ''COL0'' + int;',
'        } else {',
'            i = ''COL'' + int;',
'        }',
'    return i;',
'};',
'',
'var toggleCol = function ( columnId, isShowing ) {',
'    if ( columnId ) {',
'        var header$  = $( ''#'' + columnId ),',
'            body$    = $( ''td[headers='' + columnId + '']'' );',
'',
'        if ( isShowing ) {',
'            header$.show();',
'            body$.show();',
'        } else {',
'            header$.hide();',
'            body$.hide();',
'        }',
'    }',
'};',
'',
'var getRds = function(){',
'    return apex.widget.regionDisplaySelector( rdsId );',
'};',
'',
'// hide empty columns',
'( function () {',
'    var hideGreaterThan = parseInt( $v(''P3120_PARSED_COLUMN_COUNT'') ) + 1,',
'        emptyColId;',
'',
'        for ( i = hideGreaterThan; i <= 100; i++ ) {',
'            emptyColId = getColId( i );',
'            toggleCol( emptyColId, false );',
'        }',
'',
'})();',
'',
'// replace column count placeholders in header text of parsed data preview region',
'$( "#placeholder_P3120_PARSED_COLUMN_COUNT" ).text( $v( "P3120_PARSED_COLUMN_COUNT" ) );',
'$( "#placeholder_P3120_PARSED_ROW_COUNT" ).text( $v( "P3120_PARSED_ROW_COUNT" ) );',
'',
'// Setting items hide/show based on RDS',
'var s_col$ = $(''.tab-columns''),',
'    s_prev$ = $(''.tab-preview'');',
'',
'$( ''body'' ).on( ''atabsactivate'', function(){',
'    var id = getRds().getActiveTab().href;',
'    ',
'    if ( id.indexOf( ''columns'' ) > 0 ) {',
'        s_col$.show();',
'        s_prev$.hide();',
'    } else {',
'        s_col$.hide();',
'        s_prev$.show();',
'    }',
'});',
'',
'// checkboxes',
'( function () {',
'',
'    var checkboxes$ = $( ''input[name=f01]'' ),',
'        checkAll$   = $( ''#toggle-select-all-columns'' );',
'',
'    var checkAllState = function(){',
'        checkAll$.prop( ''checked'', checkboxes$.length === $( ''input[name=f01]:checked'' ).length );',
'    };',
'',
'    checkAll$.on( ''click'', function () {',
'        var isAllChecked = checkAll$.is( '':checked'' );',
'        checkboxes$.prop( ''checked'', isAllChecked )',
'    });',
'',
'    // init check state on load',
'    checkAllState();',
'})();',
'',
'$( apex.gPageContext$ ).on( ''apexreadyend'', function() {',
'    setTimeout(function(){',
'       var rds$ = getRds(),',
'        selection = ''#'' + apex.item(''P3120_ACTION'').getValue();',
'        tab$ = rds$.tabs[ selection ];',
'        if ( tab$ ) {',
'            tab$.makeActive();',
'        } ',
'    }, 250);',
'});'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16752054697154301.4504)
,p_name=>'Save Settings'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3942483089766704.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16752168781154302.4504)
,p_event_id=>wwv_flow_api.id(16752054697154301.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3120_FIRST_LINE,P3120_MAX_ROW_COUNT,P3120_XLSX_SHEET,P3120_CSV_COL_DELIMITER,P3120_CSV_ENCLOSED,P3120_FILE_CHARSET'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16752707403154308.4504)
,p_event_id=>wwv_flow_api.id(16752054697154301.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16768954447310903.4504)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_FIRST_LINE'
,p_condition_element=>'P3120_FIRST_LINE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEADERS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16769015705310904.4504)
,p_event_id=>wwv_flow_api.id(16768954447310903.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16769134660310905.4504)
,p_event_id=>wwv_flow_api.id(16768954447310903.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4264029006082524.4504)
,p_name=>'Refresh on Col Delimiter Changed'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_CSV_COL_DELIMITER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4264194567082525.4504)
,p_event_id=>wwv_flow_api.id(4264029006082524.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4264258126082526.4504)
,p_name=>'Refresh on CSV Enclosed Changed'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_CSV_ENCLOSED'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4264376498082527.4504)
,p_event_id=>wwv_flow_api.id(4264258126082526.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16811073562400490.4504)
,p_name=>'Confirm "All Rows" for large files'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_MAX_ROW_COUNT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P3120_FILE_SIZE") >= 2097152 && $v("P3120_MAX_ROW_COUNT") === "0"'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16811926756400496.4504)
,p_event_id=>wwv_flow_api.id(16811073562400490.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_MAX_ROW_COUNT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3120_PREV_MAX_ROW_COUNT")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16812473388400496.4504)
,p_event_id=>wwv_flow_api.id(16811073562400490.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_PREV_MAX_ROW_COUNT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3120_MAX_ROW_COUNT")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16813924321400497.4504)
,p_event_id=>wwv_flow_api.id(16811073562400490.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_COLUMN'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16811426661400495.4504)
,p_event_id=>wwv_flow_api.id(16811073562400490.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Il campionamento di tutte le righe pu\00F2 richiedere del tempo per i file di grandi dimensioni. Si \00E8 certi di voler effettuare il campionamento di tutto il file?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16812990982400496.4504)
,p_event_id=>wwv_flow_api.id(16811073562400490.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_MAX_ROW_COUNT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16813472577400496.4504)
,p_event_id=>wwv_flow_api.id(16811073562400490.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_COLUMN'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(117569538954427443.4504)
,p_name=>'Shade Headers on Load'
,p_event_sequence=>100
,p_condition_element=>'P3120_FIRST_LINE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEADERS'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(117569990360427477.4504)
,p_event_id=>wwv_flow_api.id(117569538954427443.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(117570493134427479.4504)
,p_event_id=>wwv_flow_api.id(117569538954427443.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").removeClass("first-row-headers");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(117570855192429166.4504)
,p_name=>'Shade Headers for XML, JSON and ICS'
,p_event_sequence=>110
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not ( lower(:P3100_FILE) like ''%.csv'' or',
'lower(:P3100_FILE) like ''%.txt'' or',
'lower(:P3100_FILE) like ''%.xls_'' )'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(117571250469429167.4504)
,p_event_id=>wwv_flow_api.id(117570855192429166.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(137427955810428905.4504)
,p_name=>'Refresh on charset change'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_FILE_CHARSET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(137428031631428906.4504)
,p_event_id=>wwv_flow_api.id(137427955810428905.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(20813061159966803.4504)
,p_name=>'Refresh on Trim Whitespace change'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_TRIM_WHITESPACE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20813154193966804.4504)
,p_event_id=>wwv_flow_api.id(20813061159966803.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(137427833294428904.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Action Type (Preview or Column Mapping)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :REQUEST = ''REFRESH_PREVIEW'' then',
'  :P3120_ACTION := ''tab_preview'';',
'elsif :REQUEST = ''REFRESH_COLUMN'' then',
'  :P3120_ACTION := ''tab_columns'';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(856315813437359250.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Collection when Rows to Sample Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH_COLUMN'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Informazioni sul mapping delle colonne cancellate e ricampionate.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3942624774766706.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New Table - Save Column Load Checkbox'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile           clob;',
'    l_col_selected      boolean := false;',
'    l_mapped_col_cnt    pls_integer := 0;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    -- loop through all column postions',
'    for i in 1 .. wwv_flow.g_f06.count',
'    loop',
'        ',
'        for j in 1 .. wwv_flow.g_f01.count',
'        loop',
'            -- if column checked to load, save the column configuration',
'            if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'',
'                wwv_flow_collection.add_member(',
'                    p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'                    p_c001            => wwv_flow.g_f06( i ), -- column position',
'                    p_c002            => wwv_flow.g_f02( i ), -- column name',
'                    p_c003            => wwv_flow.g_f03( i ), -- format mask',
'                    p_c004            => wwv_flow.g_f04( i ), -- group char',
'                    p_c005            => wwv_flow.g_f05( i ), -- decimal char',
'                    p_c006            => wwv_flow.g_f07( i ), -- column type',
'                    p_c007            => case when wwv_flow.g_f07( i ) = ''VARCHAR2'' then wwv_flow.g_f08( i ) end  -- max length',
'                    );',
'',
'                exit;',
'            end if;',
'        end loop;',
'    end loop;',
'        ',
'    select clob001',
'    into l_profile ',
'    from wwv_flow_collections ',
'    where collection_name = ''APEX$DATALOAD'' ',
'    and rownum = 1;',
'    ',
'    for i in (',
'        select column_position, column_name',
'        from table( wwv_flow_data_parser.get_columns( l_profile ) ) c ) ',
'    loop',
'        if wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0 then',
'            l_col_selected := true;',
'        else',
'            l_col_selected := false;',
'            for l_select_col in (',
'                select c001 idx ',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS'' )',
'            loop',
'                begin',
'                    if to_number( l_select_col.idx ) = i.column_position then',
'                        l_col_selected := true;',
'                        exit;',
'                    end if;',
'                exception when invalid_number then null; ',
'                end;',
'            end loop;',
'        end if;',
'        ',
'        if l_col_selected then',
'            l_mapped_col_cnt := l_mapped_col_cnt + 1;',
'        end if;',
'    end loop;',
'    ',
'    :P3100_MAPPED_COLUMN_COUNT := l_mapped_col_cnt;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3942483089766704.4504)
,p_process_when=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(82703578316738108.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Existing Table - Save Column Mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_map    wwv_flow_global.vc_map := wwv_flow_global.c_empty_vc_map;',
'begin    ',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    wwv_flow_collection.add_members(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'        p_c001            => wwv_flow.g_f01,  -- column_name',
'        p_c002            => wwv_flow.g_f02,  -- mapped column',
'        p_c003            => wwv_flow.g_f03,  -- format mask',
'        p_c004            => wwv_flow.g_f04,  -- group char',
'        p_c005            => wwv_flow.g_f05   -- decimal char           ',
'        );',
'    ',
'    -- get column mapping user configured',
'    for l_configure in (',
'        select',
'            c001   column_name,',
'            c002   mapped_column',
'        from wwv_flow_collections',
'        where collection_name = ''APEX$DATALOAD_COLUMNS''',
'        and c002 is not null )',
'    loop',
'        l_column_map( l_configure.column_name ) := l_configure.mapped_column;',
'    end loop;',
'',
'    --',
'    -- if no column has been mapped, clear the collection, so that APEX can automatically',
'    -- map columns again when "save" changes is clicked. This prevents columns from being',
'    -- doubled in the collection (bug #32405712)',
'    --',
'    if l_column_map.count = 0 then',
'        wwv_flow_collection.truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    end if;         ',
'    ',
'    :P3100_MAPPED_COLUMN_COUNT := l_column_map.count;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3942483089766704.4504)
,p_process_when=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3719233401479850.4504)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3100_FIRST_LINE        := ( case when :P3120_FIRST_LINE is null then ''CHANGE_TO_NULL'' else :P3120_FIRST_LINE end );',
':P3100_MAX_ROW_COUNT     := :P3120_MAX_ROW_COUNT;',
':P3100_XLSX_SHEET        := :P3120_XLSX_SHEET;',
':P3100_CSV_COL_DELIMITER := :P3120_CSV_COL_DELIMITER;',
':P3100_CSV_ENCLOSED      := :P3120_CSV_ENCLOSED;',
':P3100_FILE_CHARSET      := :P3120_FILE_CHARSET;',
':P3100_SHOW_CONFIG_SAVED := ''Y'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3942483089766704.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16454432416013407.4504)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3942483089766704.4504)
);
end;
/
prompt --application/pages/page_03130
begin
wwv_flow_api.create_page(
 p_id=>3130.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Area di memorizzazione degli oggetti'
,p_step_title=>'Area di memorizzazione degli oggetti'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function setFileName( pFileName ) {',
'    var lTypeAvro    = "1",',
'        lTypeParquet = "2",',
'        lTypeOther   = "3",',
'        lFileType;',
'    ',
'    function setExternalTableName() {',
'        var lTableName;',
'',
'        if ( lFileType === lTypeAvro ) {',
'            lTableName = pFileName.substr( 0, pFileName.indexOf(".avro"));',
'        } else if ( lFileType === lTypeParquet ) {',
'            lTableName = pFileName.substr( 0, pFileName.indexOf(".parquet"));',
'        } ',
'',
'        if ( lTableName ) {',
'            if ( lTableName.indexOf( "/" ) !== -1 ) {',
'                lTableName = lTableName.substr( lTableName.lastIndexOf( "/" ) + 1 );',
'            }',
'            $s("P3130_EXTERNAL_TABLE_NAME", lTableName.toUpperCase().replace(/[\s-\"\''.,#*+%&\/:;<>=)(]/g, "_") + "_EXT");',
'        }',
'    }',
'',
'    if ( pFileName.substr( -5 ).toLowerCase() === ".avro" ) {',
'        lFileType = lTypeAvro;',
'    } else if ( pFileName.substr( -8 ).toLowerCase() === ".parquet") {',
'        lFileType = lTypeParquet;',
'    } else {',
'        lFileType = lTypeOther;',
'    }',
'    ',
'    if ( $v("P3130_FILE_NAME") === "" ) {',
'        $s( "P3130_FILE_NAME", pFileName );',
'        $s( "P3130_FILE_TYPE", lFileType );',
'        setExternalTableName();',
'    } else {',
unistr('        if ( $v("P3130_FILE_TYPE") === lTypeOther )\00A0{'),
'            $s( "P3130_FILE_NAME", pFileName );  ',
'            $s( "P3130_FILE_TYPE", lFileType );',
'            if ( lFileType !== lTypeOther ) {',
'                setExternalTableName();',
'            }',
'        } else {',
'            if ( ( "," + $v("P3130_FILE_NAME") + ",").indexOf( "," + pFileName + "," ) === -1 ) {',
'                $s("P3130_FILE_NAME", $v("P3130_FILE_NAME") + "," + pFileName );',
'            }',
'        }',
'    }',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1900876712643901.4504)
,p_plug_name=>'Riferimenti area di memorizzazione degli oggetti'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Form--labelsAbove:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Scegliere un riferimento esistente a un''<em>area di memorizzazione degli oggetti</em> per caricare i dati. Un riferimento all''area di memorizzazione degli oggetti \00E8 composto da un URL e dalle informazioni sulle credenziali.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2101503916493910.4504)
,p_plug_name=>'File area di memorizzazione degli oggetti '
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1202011154678505.4504)
,p_plug_name=>'Impossibile accedere all''area di memorizzazione.'
,p_parent_plug_id=>wwv_flow_api.id(2101503916493910.4504)
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('APEX non pu\00F2 accedere all''area di memorizzazione degli oggetti. Controllare l''URL dell''endpoint e le credenziali di autenticazione.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1903884742643931.4504)
,p_plug_name=>'Lista dei file'
,p_parent_plug_id=>wwv_flow_api.id(2101503916493910.4504)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--simple:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name, ',
'       wwv_flow_escape.js_literal( object_name, null ) as file_name_js, ',
'       bytes, ',
'       checksum, ',
'       coalesce( last_modified, created ) as last_modified ',
'  from table( wwv_dbms_cloud.list_files( ',
'                  p_remote_server_id => :P3130_REMOTE_SERVER_ID,',
'                  p_schema           => :P3130_SCHEMA ) )',
' where :P3130_REMOTE_SERVER_ID is not null and :P3130_CAN_ACCESS_STORE = 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P3130_REMOTE_SERVER_ID,P3130_SCHEMA,P3130_CAN_ACCESS_STORE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(2102155945493916.4504)
,p_no_data_found_message=>'Nessun file trovato'
,p_allow_report_saving=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_finder_drop_down=>'N'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'ADMIN'
,p_internal_uid=>2102155945493916
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2102200753493917.4504)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Nome oggetto'
,p_column_link=>'javascript:setFileName(''#FILE_NAME_JS#'');'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2102336445493918.4504)
,p_db_column_name=>'FILE_NAME_JS'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Nome file Js'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2102483050493919.4504)
,p_db_column_name=>'BYTES'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Dimensione'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2102544543493920.4504)
,p_db_column_name=>'CHECKSUM'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Checksum'
,p_allow_sorting=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2102690461493921.4504)
,p_db_column_name=>'LAST_MODIFIED'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Ultima modifica'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1904405065643937.4504)
,p_plug_name=>'Carica file dall''area di memorizzazione degli oggetti'
,p_parent_plug_id=>wwv_flow_api.id(2101503916493910.4504)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2877329203080424.4504)
,p_plug_name=>'Altri elementi'
,p_parent_plug_id=>wwv_flow_api.id(1904405065643937.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2192246260655622.4504)
,p_plug_name=>'Informazioni'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina consente di caricare i file Avro o Parquet da origini dati esterne (area di memorizzazione degli oggetti) nello schema di database corrente.</p>',
unistr('<p>&PRODUCT_NAME. usa il package <strong>DBMS_CLOUD</strong> per fornire <em>tabelle esterne</em> sopra i file esterni. I dati possono essere copiati dalla tabella esterna a una tabella normale, ma \00E8 anche possibile eseguire query direttamente sulle ')
||'tabelle esterne.</p>',
'<p><a href="&SYSTEM_HELP_URL./aeutl/loading-data-from-cloud.html" target="_blank">Ulteriori informazioni...</a></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2102866548493923.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(2877329203080424.4504)
,p_button_name=>'CREATE_EXTTAB'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea tabella esterna'
,p_button_position=>'BELOW_BOX'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2877017327080421.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(2877329203080424.4504)
,p_button_name=>'LOAD_USING_APEX'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Importa file'
,p_button_position=>'BELOW_BOX'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1905039762643943.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1900876712643901.4504)
,p_button_name=>'CREATE_REFERENCE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Crea nuovo'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3131:&SESSION.::&DEBUG.:RP,3131::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2193236526655632.4504)
,p_branch_name=>'Go To Page 3140'
,p_branch_action=>'f?p=&APP_ID.:3140:&SESSION.::&DEBUG.:RP,3140:P3140_EXTERNAL_TABLE_NAME,P3140_SCHEMA:&P3130_EXTERNAL_TABLE_NAME.,&P3130_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2102866548493923.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2877534565080426.4504)
,p_branch_name=>'Go To Page 3100'
,p_branch_action=>'f?p=&APP_ID.:3100:&SESSION.:UPLOAD_FILE:&DEBUG.:RP:P3100_FILE,P3100_SOURCE_TYPE,P3100_FIRST_LINE:&P3130_DOWNLOADED_FILE.,FILE,HEADERS&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2877017327080421.4504)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1203691355678521.4504)
,p_branch_action=>'f?p=&APP_ID.:3131:&SESSION.::&DEBUG.:RP,3131:P3131_REMOTE_SERVER_ID:&P3130_REMOTE_SERVER_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_REMOTE_SERVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2192328040655623.4504)
,p_branch_name=>'Go To Page 3132'
,p_branch_action=>'f?p=&APP_ID.:3132:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_dbms_cloud.check_prerequisites(coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)) != ''SUCCESS'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1201722483678502.4504)
,p_name=>'P3130_CAN_ACCESS_STORE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1900876712643901.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1903629324643929.4504)
,p_name=>'P3130_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1900876712643901.4504)
,p_prompt=>'Riferimento area di memorizzazione degli oggetti'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon a-Button--pillEnd" onclick="void(0);" aria-label="Edit" type="button" id="P3130_EDIT_REMOTE_SERVER_ID" aria-controls="search-container" title="Clear"><span class="a-Icon ico'
||'n-edit" aria-hidden="true"></span></button>',
''))
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LOV_OBJECTSTORE_REFERENCES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, base_url, cloud_credential_name from wwv_remote_servers',
'where security_group_id = :WORKSPACE_ID',
'and server_type = ''CLOUD_OBJECT_STORE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_cSize=>100
,p_tag_attributes=>'style="width: 100%"'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_08=>'1024'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1904584935643938.4504)
,p_name=>'P3130_FILE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1904405065643937.4504)
,p_prompt=>'Pattern nomi file'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon a-Button--pillEnd" onclick="void(0);" aria-label="Clear" type="button" id="P3130_EXTERNAL_TABLE_CLEAR" aria-controls="search-container" title="Clear"><span class="a-Icon ico'
||'n-remove" aria-hidden="true"></span></button>',
''))
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Lista delimitata da virgole di URI file di origine. \00C8 possibile usare i caratteri jolly nei nomi file dei propri URI. Il carattere "*" pu\00F2 essere utilizzato come carattere jolly per pi\00F9 caratteri, mentre il carattere "?" pu\00F2 essere usato come car')
||'attere jolly per un singolo carattere.',
'</p>',
'<p>',
'Il formato degli URI dipende dal servizio cloud di storage degli oggetti in uso. Per i dettagli, vedere i formati URI dei file del package <strong>DBMS_CLOUD</strong>. Si consiglia di evitare di usare caratteri speciali quali "%", spazi o "/" nei nom'
||'i dei file.',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1904664145643939.4504)
,p_name=>'P3130_EXTERNAL_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2877329203080424.4504)
,p_prompt=>'Nome tabella esterna'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Fornire un nome per la tabella esterna da creare. Il nome non deve essere utilizzato per un''altra tabella nello schema &P3130_SCHEMA!HTML..'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1904744737643940.4504)
,p_name=>'P3130_FILE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2877329203080424.4504)
,p_prompt=>'Tipo di file'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Avro;1,Parquet;2,Other;3'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Selezionare il tipo di file tra i file dell''area di memorizzazione degli oggetti scelta. Per i file <strong>Parquet</strong> e <strong>Avro</strong>, APEX crea prima una tabella esterna, poi i dati vengono copiati dalla tabella esterna alla tabel'
||'la di destinazione. Gli altri file vengono scaricati in APE, quindi elaborati dal motore APEX quando vengono caricati in SQL Workshop mediante Carica dati.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2100734287493902.4504)
,p_name=>'P3130_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(387994680244652086.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Nome del proprietario dello schema di database'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2105290202493947.4504)
,p_name=>'P3130_SERVER_URL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1900876712643901.4504)
,p_prompt=>'URL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2877821137080429.4504)
,p_name=>'P3130_DOWNLOADED_FILE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2877329203080424.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2905595021173305.4504)
,p_name=>'P3130_SCHEMA_FROM_FILE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2877329203080424.4504)
,p_item_default=>'FIRST'
,p_prompt=>'Deriva definizione dati'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:First File;FIRST,All Files;ALL'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'     Le colonne della tabella esterna e i tipi di dati derivano direttamente dal file Parquet o Avro. I nomi delle colonne corrisponderanno a quelli trovati nel file Parquet o Avro. I tipi di dati vengono convertiti dai tipi di dati Parquet o Avro in'
||' tipi di dati Oracle. Tutte le colonne vengono aggiunte alla tabella.',
'',
'</p>',
'<p>',
'   <strong>Primo</strong> specifica di utilizzare i metadati dal primo file Parquet o Avro, <strong>Tutti</strong> indica di usare i metadati provenienti dai file Parquet o Avro per generare le colonne e i relativi tipi di dati. Utilizzare <strong>Pr'
||unistr('imo</strong> se tutti i file hanno lo stesso schema. Usare <strong>Tutti</strong> (procedura pi\00F9 lenta) se i file possono avere schemi diversi.    '),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1905703553643950.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3130_EXTERNAL_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P3130_EXTERNAL_TABLE_NAME)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2100994821493904.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3130_SCHEMA'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1201872722678503.4504)
,p_computation_sequence=>20
,p_computation_item=>'P3130_CAN_ACCESS_STORE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when wwv_dbms_cloud.can_access_objectstore( ',
'    p_schema           => :P3130_SCHEMA,',
'    p_remote_server_id => :P3130_REMOTE_SERVER_ID ) then 1 else 0 end'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2877616550080427.4504)
,p_validation_name=>'External Table Name NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P3130_EXTERNAL_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(2102866548493923.4504)
,p_associated_item=>wwv_flow_api.id(1904664145643939.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2912855128299828.4504)
,p_validation_name=>'ext table name not > 30 (11g) or > 128 (12.2)'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if length(:P3130_EXTERNAL_TABLE_NAME) > wwv_flow_global.c_dbms_id_length then',
'  return wwv_flow_lang.system_message(''F4300.TABLE_NAMES_NOT_LONGER_THAN_30'',wwv_flow_global.c_dbms_id_length);',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P3140_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2102866548493923.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(90119211027448641.4504)
,p_validation_name=>'External Table names must not contain invalid chars'
,p_validation_sequence=>20
,p_validation=>'P3130_EXTERNAL_TABLE_NAME'
,p_validation2=>'#&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# non deve contenere #, &, <, >, ", /, ;, *, |, =, % o il carattere ,.',
''))
,p_when_button_pressed=>wwv_flow_api.id(2102866548493923.4504)
,p_associated_item=>wwv_flow_api.id(1904664145643939.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1201690132678501.4504)
,p_validation_name=>'File Name Pattern NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P3130_FILE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(2102866548493923.4504)
,p_associated_item=>wwv_flow_api.id(1904584935643938.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2905492312173304.4504)
,p_validation_name=>'External table does not exist'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_tables',
' where table_name = :P3130_EXTERNAL_TABLE_NAME',
'   and owner      = :P3130_SCHEMA'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('#LABEL# gi\00E0 in uso. Sceglierne un''altra.')
,p_when_button_pressed=>wwv_flow_api.id(2102866548493923.4504)
,p_associated_item=>wwv_flow_api.id(1904664145643939.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(705985525998195105.4504)
,p_validation_name=>'Valid File for Import to APEX'
,p_validation_sequence=>50
,p_validation=>'substr( lower( :P3130_FILE_NAME ), instr( :P3130_FILE_NAME, ''.'', -1 ) ) in (''.js'', ''.json'', ''.geojson'', ''.csv'', ''.tsv'', ''.txt'', ''.xml'', ''.xlsx'', ''.xlsm'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Solo i file CSV, XLSX, XML o JSON possono essere importati in APEX.'
,p_when_button_pressed=>wwv_flow_api.id(2877017327080421.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2101093844493905.4504)
,p_name=>'Clear External Table Name'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P3130_EXTERNAL_TABLE_CLEAR'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2101167113493906.4504)
,p_event_id=>wwv_flow_api.id(2101093844493905.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_FILE_NAME,P3130_EXTERNAL_TABLE_NAME,P3130_FILE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2101332584493908.4504)
,p_name=>'Clear File Name List on ESC'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_FILE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.keyCode===27'
,p_bind_type=>'bind'
,p_bind_event_type=>'keydown'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2101430570493909.4504)
,p_event_id=>wwv_flow_api.id(2101332584493908.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_FILE_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2101765437493912.4504)
,p_name=>'Refresh File Listing'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_REMOTE_SERVER_ID'
,p_condition_element=>'P3130_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1203282970678517.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P3130_EDIT_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1203157882678516.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P3130_EDIT_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2105371194493948.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SERVER_URL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2105484613493949.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SERVER_URL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2101930804493914.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2101503916493910.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2102009481493915.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2101503916493910.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1201954281678504.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_CAN_ACCESS_STORE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when wwv_dbms_cloud.can_access_objectstore( ',
'    p_schema           => :P3130_SCHEMA,',
'    p_remote_server_id => :P3130_REMOTE_SERVER_ID ) then 1 else 0 end    '))
,p_attribute_07=>'P3130_REMOTE_SERVER_ID,P3130_SCHEMA'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2101803975493913.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1903884742643931.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2105536067493950.4504)
,p_event_id=>wwv_flow_api.id(2101765437493912.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SERVER_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url from wwv_remote_servers where id=:P3130_REMOTE_SERVER_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_attribute_07=>'P3130_REMOTE_SERVER_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2905765540173307.4504)
,p_name=>'File Name changed'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_FILE_NAME'
,p_condition_element=>'P3130_FILE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2905851822173308.4504)
,p_event_id=>wwv_flow_api.id(2905765540173307.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2877329203080424.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2905955362173309.4504)
,p_event_id=>wwv_flow_api.id(2905765540173307.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2877329203080424.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2876588630080416.4504)
,p_name=>'File Type Chosen'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_FILE_TYPE'
,p_condition_element=>'P3130_FILE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'3'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2876613373080417.4504)
,p_event_id=>wwv_flow_api.id(2876588630080416.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SCHEMA_FROM_FILE,P3130_EXTERNAL_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2877208402080423.4504)
,p_event_id=>wwv_flow_api.id(2876588630080416.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2877017327080421.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2876722057080418.4504)
,p_event_id=>wwv_flow_api.id(2876588630080416.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2102866548493923.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2876938615080420.4504)
,p_event_id=>wwv_flow_api.id(2876588630080416.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2102866548493923.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2876870003080419.4504)
,p_event_id=>wwv_flow_api.id(2876588630080416.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SCHEMA_FROM_FILE,P3130_EXTERNAL_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2877111754080422.4504)
,p_event_id=>wwv_flow_api.id(2876588630080416.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2877017327080421.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1202169364678506.4504)
,p_name=>'Show / Hide alert'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_CAN_ACCESS_STORE'
,p_condition_element=>'P3130_CAN_ACCESS_STORE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1202296339678507.4504)
,p_event_id=>wwv_flow_api.id(1202169364678506.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1202011154678505.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1202899518678513.4504)
,p_event_id=>wwv_flow_api.id(1202169364678506.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1904405065643937.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1202564739678510.4504)
,p_event_id=>wwv_flow_api.id(1202169364678506.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1903884742643931.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1202746406678512.4504)
,p_event_id=>wwv_flow_api.id(1202169364678506.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1903884742643931.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1202471705678509.4504)
,p_event_id=>wwv_flow_api.id(1202169364678506.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1202011154678505.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1202622226678511.4504)
,p_event_id=>wwv_flow_api.id(1202169364678506.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1904405065643937.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1203455162678519.4504)
,p_name=>'Edit Remote Server'
,p_event_sequence=>100
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P3130_EDIT_REMOTE_SERVER_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1203582696678520.4504)
,p_event_id=>wwv_flow_api.id(1203455162678519.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EDIT_REMOTE_SERVER'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(705985356104195103.4504)
,p_name=>'Click CREATE_EXTTAB'
,p_event_sequence=>110
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2102866548493923.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(705985413980195104.4504)
,p_event_id=>wwv_flow_api.id(705985356104195103.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_EXTTAB'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1904972753643942.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create External Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_dbms_cloud.create_external_table(',
'        p_schema               => :P3130_SCHEMA,',
'        p_remote_server_id     => :P3130_REMOTE_SERVER_ID,',
'        --',
'        p_filename_pattern     => :P3130_FILE_NAME,',
'        p_file_type            => :P3130_FILE_TYPE,',
'        p_schema_from_file     => :P3130_SCHEMA_FROM_FILE,',
'        p_external_table_name  => :P3130_EXTERNAL_TABLE_NAME);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2102866548493923.4504)
,p_process_success_message=>'Tabella esterna &P3130_EXTERNAL_TABLE_NAME. creata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2877496402080425.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Using APEX'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name varchar2(32767);',
'begin',
'    l_name := wwv_dbms_cloud.download_file_to_apex(',
'                  p_schema            => :P3130_SCHEMA,',
'                  p_remote_server_id  => :P3130_REMOTE_SERVER_ID,',
'                  p_filename          => :P3130_FILE_NAME );',
'                  ',
'    :P3130_DOWNLOADED_FILE := l_name;',
'    ',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD_COLUMNS'' );',
'    wwv_flow_session_state.clear_state_for_page( p_page_id => 3100 );',
'    wwv_flow_session_state.clear_state_for_page( p_page_id => 3110 );',
'    wwv_flow_session_state.clear_state_for_page( p_page_id => 3120 );',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2877017327080421.4504)
,p_process_success_message=>'File scaricato.'
);
end;
/
prompt --application/pages/page_03131
begin
wwv_flow_api.create_page(
 p_id=>3131.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea/modifica riferimento area di memorizzazione degli oggetti'
,p_page_mode=>'MODAL'
,p_step_title=>'Riferimento area di memorizzazione degli oggetti'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2103195561493926.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4066085671696583.4504)
,p_plug_name=>'Riferimento area di memorizzazione degli oggetti'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_api.id(717419707883820782.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1204002492678525.4504)
,p_plug_name=>'Credenziali'
,p_parent_plug_id=>wwv_flow_api.id(4066085671696583.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1205300436678538.4504)
,p_plug_name=>'USER_CREDENTIAL'
,p_parent_plug_id=>wwv_flow_api.id(1204002492678525.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2103400135493929.4504)
,p_plug_name=>'Nome utente/Password'
,p_parent_plug_id=>wwv_flow_api.id(1204002492678525.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2878479318080435.4504)
,p_plug_name=>'Credenziale Web'
,p_parent_plug_id=>wwv_flow_api.id(1204002492678525.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4266277708546587.4504)
,p_plug_name=>'Credenziali native OCI'
,p_parent_plug_id=>wwv_flow_api.id(1204002492678525.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2103321713493928.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2103195561493926.4504)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Annulla'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1204301951678528.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2103195561493926.4504)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_button_condition=>'P3131_REMOTE_SERVER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2103281067493927.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2103195561493926.4504)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Applica modifiche'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1204218416678527.4504)
,p_branch_name=>'Go To Page 3130'
,p_branch_action=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:RP:P3130_REMOTE_SERVER_ID:&P3131_REMOTE_SERVER_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2103281067493927.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1204691689678531.4504)
,p_branch_name=>'Go To Page 3130'
,p_branch_action=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:RP:P3130_REMOTE_SERVER_ID:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1204301951678528.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1203764282678522.4504)
,p_name=>'P3131_KEEP_CREDENTIALS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4066085671696583.4504)
,p_item_default=>'Y'
,p_prompt=>'Conserva credenziali'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P3131_REMOTE_SERVER_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Quando il riferimento all''area di memorizzazione degli oggetti viene modificato, decidere se conservare le credenziali esistenti o immetterne di nuove. Quando si elimina il riferimento all''area di memorizzazione degli oggetti, indica se le credenzial'
||'i devono essere conservate o meno.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1204931142678534.4504)
,p_name=>'P3131_CREATE_WEB_CREDENTIAL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1204002492678525.4504)
,p_prompt=>'Crea come credenziale Web'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Indica se memorizzare anche le credenziali nell''area di memorizzazione credenziali APEX. ',
'</p>',
unistr('<p>Tenere presente che l''area di memorizzazione credenziali DBMS_CLOUD \00E8 indipendente dalle credenziali Web APEX e che non \00E8 prevista alcuna sincronizzazione automatica tra tali credenziali.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1205479260678539.4504)
,p_name=>'P3131_USER_CREDENTIAL_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1205300436678538.4504)
,p_prompt=>'Credenziale DBMS_CLOUD'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>'select column_value d, column_value r from table(wwv_dbms_cloud.list_credentials( p_schema => :P3130_SCHEMA ))'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona - '
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare una credenziale DBMS_CLOUD esistente (vista USER_CREDENTIALS). La <a href="https://www.oracle.com/pls/topic/lookup?ctx=en/cloud/paas/autonomous-data-warehouse-cloud&id=CSWHU-GUID-742FC365-AA09-48A8-922C-1987795CF36A" target="_blank">docum'
||'entazione di DBMS_CLOUD</a> contiene ulteriori informazioni.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2103535823493930.4504)
,p_name=>'P3131_USERNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2103400135493929.4504)
,p_prompt=>'Nome utente'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Fornire il nome utente con cui eseguire l''autenticazione.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2103642320493931.4504)
,p_name=>'P3131_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2103400135493929.4504)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Fornire la password per l''autenticazione.'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104752109493942.4504)
,p_name=>'P3131_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4066085671696583.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2163694961052673.4504)
,p_name=>'P3131_SERVER_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4066085671696583.4504)
,p_prompt=>'Nome riferimento'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Fornire un nome in base al quale vengono memorizzati l''URL del server e le informazioni sulle credenziali.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2164010878052681.4504)
,p_name=>'P3131_SERVER_URL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4066085671696583.4504)
,p_prompt=>'URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Fornire l''URL del bucket dell''area di memorizzazione degli oggetti. Per ulteriori informazioni sui formati degli URL dell''area di memorizzazione degli oggetti, consultare la <a href="https://www.oracle.com/pls/topic/lookup?ctx=en/cloud/paas/auton'
||'omous-data-warehouse-cloud&id=CSWHU-GUID-5D3E1614-ADF2-4DB5-B2B2-D5613F10E4FA" target="_blank">documentazione del package DBMS_CLOUD</a>.',
'</p>',
'<p>',
unistr('    Se i file di origine risiedono nello <strong>storage degli oggetti dell''infrastruttura Oracle Cloud</strong>, \00E8 possibile utilizzare gli URI nativi dell''infrastruttura Oracle Cloud, con il formato seguente (non aggiungere il nome file all''URL):'),
'</p>',
'<p>',
'    <code>https://objectstorage.<em>region</em>.oraclecloud.com/n/<em>namespace-string</em>/b/<em>bucket</em>/o/</code>',
'</p>',
'<p>',
'    Se l''area di memorizzazione degli oggetti supporta le cartelle e la cartella fa parte di questo URL, solo i file provenienti da tale cartella saranno visibili per il caricamento dei dati.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2164426432052681.4504)
,p_name=>'P3131_CREDENTIAL_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1204002492678525.4504)
,p_item_default=>'USERPASS'
,p_prompt=>'Tipo di credenziale'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Username/Password;USERPASS,OCI Native;OCI,Web Credential;APEX,DBMS_CLOUD Credential;USER_CREDENTIALS'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_css_classes=>'data-load-input apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Scegliere il tipo di autenticazione.',
'</p>',
'<ul>',
'    <li><strong>Nome utente/Password</strong>: l''autenticazione nell''area di memorizzazione degli oggetti viene eseguita utilizzando semplicemente il nome utente e la password.</li>',
'    <li><strong>Autenticazione nativa OCI</strong>: l''autenticazione viene eseguita utilizzando l''ID utente OCI, l''ID tenancy OCI, la chiave privata e l''impronta della chiave pubblica.</li>',
unistr('    <li><strong>Credenziale Web esistente</strong>: consente di riutilizzare una credenziale esistente creata in Utility area di lavoro, Credenziali Web. Tenere presente che qui \00E8 possibile usare solo le credenziali Web esistenti dei tipi di autentic')
||unistr('azione <strong>Base</strong> (per Nome utente/Password) o <strong>Nativa OCI</strong>. Una nuova credenziale DBMS_CLOUD verr\00E0 creata utilizzando le informazioni memorizzate come Credenziali Web APEX.</li>'),
'    <li><strong>Credenziale DBMS_CLOUD</strong>: usare una credenziale DBMS_CREDENTIAL esistente (voci della vista USER_CREDENTIALS).</li>',
'</ul>',
'<p>',
'    ',
'</p>',
unistr('<p>Tenere presente che l''area di memorizzazione delle credenziali DBMS_CLOUD \00E8 indipendente dalle credenziali Web APEX e non \00E8 prevista alcuna sincronizzazione tra tali credenziali.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2165184719052683.4504)
,p_name=>'P3131_USER_OCID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4266277708546587.4504)
,p_prompt=>'OCID utente'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Immettere l''<em>OCID utente</em> dell''infrastruttura Oracle Cloud. &PRODUCT_NAME. non memorizza queste informazioni in modalit\00E0 cifrata.</p> <p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Doc')
||'umentazione dell''infrastruttura Oracle Cloud</a></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2165534380052684.4504)
,p_name=>'P3131_TENANCY_OCID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4266277708546587.4504)
,p_prompt=>'OCID tenancy'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Immettere l''<em>OCID della tenancy</em> dell''infrastruttura Oracle Cloud.</p>',
'<p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentazione dell''infrastruttura Oracle Cloud</a></p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2165901304052684.4504)
,p_name=>'P3131_PRIVATE_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4266277708546587.4504)
,p_prompt=>'Chiave privata'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('<p>Immettere la chiave privata in formato PEM per l''autenticazione OCI. &PRODUCT_NAME. memorizza queste informazioni in modalit\00E0 cifrata e protetta affinch\00E9 non possano essere recuperate come testo in chiaro.</p><p><a target="_blank" href="https://do')
||'cs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentazione dell''infrastruttura Oracle Cloud</a></p>'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2166372571052684.4504)
,p_name=>'P3131_FINGERPRINT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4266277708546587.4504)
,p_prompt=>'Impronta'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Immettere l''<em>impronta della chiave RSA pubblica</em> per l''autenticazione OCI. </p><p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentazione dell''infrastruttura Oracle Cloud</a></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2879472190080445.4504)
,p_name=>'P3131_WEB_CREDENTIAL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2878479318080435.4504)
,p_prompt=>'Credenziale Web'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'WEB_CREDENTIALS_FOR_DBMS_CLOUD'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       authentication_type,',
'       client_id',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID',
'   and authentication_type in (''OCI'', ''BASIC'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Selezionare una <strong>credenziale Web</strong> gi\00E0 esistente, configurata in Application Builder, Utility Workspace, Credenziali Web. Tenere presente che le informazioni sulle credenziali verranno usate per creare una nuova credenziale dell''are')
||'a di memorizzazione degli oggetti <strong>DBMS_CLOUD</strong>. Le credenziali dell''area di memorizzazione degli oggetti DBMS_CLOUD e le credenziali Web APEX non vengono tenute in sincronizzazione, quindi le credenziali dell''area di memorizzazione deg'
||'li oggetti devono essere aggiornate dopo l''avvenuta modifica della credenziale Web APEX.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2191139061655611.4504)
,p_validation_name=>'USER_OCID required'
,p_validation_sequence=>10
,p_validation=>'P3131_USER_OCID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''OCI'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(2165184719052683.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2191257913655612.4504)
,p_validation_name=>'TENANCY_OCID required'
,p_validation_sequence=>20
,p_validation=>'P3131_TENANCY_OCID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''OCI'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(2165534380052684.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2191415915655614.4504)
,p_validation_name=>'PRIVATE_KEY required'
,p_validation_sequence=>30
,p_validation=>'P3131_PRIVATE_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''OCI'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(2165901304052684.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2191502498655615.4504)
,p_validation_name=>'FINGERPRINT required'
,p_validation_sequence=>40
,p_validation=>'P3131_FINGERPRINT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''OCI'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(2166372571052684.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2191602326655616.4504)
,p_validation_name=>'USERNAME required'
,p_validation_sequence=>50
,p_validation=>'P3131_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''USERPASS'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(2103535823493930.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2191883032655618.4504)
,p_validation_name=>'PASSWORD required'
,p_validation_sequence=>60
,p_validation=>'P3131_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''USERPASS'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(2103642320493931.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2879523972080446.4504)
,p_validation_name=>'Web Credential required'
,p_validation_sequence=>70
,p_validation=>'P3131_WEB_CREDENTIAL_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''APEX'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2191994420655619.4504)
,p_validation_name=>'SERVER_NAME not already taken'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'  from wwv_remote_servers',
' where name              = :P3130_SERVER_NAME',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Il nome del riferimento all''area di memorizzazione degli oggetti \00E8 gi\00E0 in uso.')
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(2163694961052673.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2192128889655621.4504)
,p_validation_name=>'URL starts with HTTPS'
,p_validation_sequence=>90
,p_validation=>'lower(substr(:P3131_SERVER_URL, 1, 8 ) ) = ''https://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'L''URL del server deve iniziare con https://'
,p_when_button_pressed=>wwv_flow_api.id(2103281067493927.4504)
,p_associated_item=>wwv_flow_api.id(2164010878052681.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2103769877493932.4504)
,p_name=>'Username/Password'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_CREDENTIAL_TYPE'
,p_condition_element=>'P3131_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'USERPASS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2103826160493933.4504)
,p_event_id=>wwv_flow_api.id(2103769877493932.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2103400135493929.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1205086266678535.4504)
,p_event_id=>wwv_flow_api.id(2103769877493932.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3131_CREATE_WEB_CREDENTIAL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2103964024493934.4504)
,p_event_id=>wwv_flow_api.id(2103769877493932.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4266277708546587.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2878525171080436.4504)
,p_event_id=>wwv_flow_api.id(2103769877493932.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2878479318080435.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1205519896678540.4504)
,p_event_id=>wwv_flow_api.id(2103769877493932.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1205300436678538.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2877911363080430.4504)
,p_name=>'OCI Native'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_CREDENTIAL_TYPE'
,p_condition_element=>'P3131_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2878269961080433.4504)
,p_event_id=>wwv_flow_api.id(2877911363080430.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2103400135493929.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1205151616678536.4504)
,p_event_id=>wwv_flow_api.id(2877911363080430.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3131_CREATE_WEB_CREDENTIAL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2878692193080437.4504)
,p_event_id=>wwv_flow_api.id(2877911363080430.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2878479318080435.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1205671717678541.4504)
,p_event_id=>wwv_flow_api.id(2877911363080430.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1205300436678538.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2878335156080434.4504)
,p_event_id=>wwv_flow_api.id(2877911363080430.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4266277708546587.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2878908061080440.4504)
,p_name=>'Web Credential'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_CREDENTIAL_TYPE'
,p_condition_element=>'P3131_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'APEX'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2879099008080441.4504)
,p_event_id=>wwv_flow_api.id(2878908061080440.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2103400135493929.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1205213844678537.4504)
,p_event_id=>wwv_flow_api.id(2878908061080440.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3131_CREATE_WEB_CREDENTIAL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2879159033080442.4504)
,p_event_id=>wwv_flow_api.id(2878908061080440.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4266277708546587.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1205709819678542.4504)
,p_event_id=>wwv_flow_api.id(2878908061080440.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1205300436678538.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2879260129080443.4504)
,p_event_id=>wwv_flow_api.id(2878908061080440.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2878479318080435.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1205840013678543.4504)
,p_name=>'USER_CREDENTIAL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_CREDENTIAL_TYPE'
,p_condition_element=>'P3131_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'USER_CREDENTIALS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1205969341678544.4504)
,p_event_id=>wwv_flow_api.id(1205840013678543.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2103400135493929.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206060693678545.4504)
,p_event_id=>wwv_flow_api.id(1205840013678543.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3131_CREATE_WEB_CREDENTIAL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206169682678546.4504)
,p_event_id=>wwv_flow_api.id(1205840013678543.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4266277708546587.4504)
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206223719678547.4504)
,p_event_id=>wwv_flow_api.id(1205840013678543.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2878479318080435.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206300617678548.4504)
,p_event_id=>wwv_flow_api.id(1205840013678543.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1205300436678538.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2104288091493937.4504)
,p_name=>'Compute Remote Server Name'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_SERVER_URL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2104349707493938.4504)
,p_event_id=>wwv_flow_api.id(2104288091493937.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'try {',
'    $s("P3131_SERVER_NAME", $v("P3131_SERVER_URL").replace(/^https?:\/\//, "").replace(/(.*)(\/.*)/, "$1").replace(/[.#_$\/]/g,"-") );',
'} catch ( e ) {}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1203814159678523.4504)
,p_name=>'Show / Hide Credentials'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_KEEP_CREDENTIALS'
,p_condition_element=>'P3131_KEEP_CREDENTIALS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1203936594678524.4504)
,p_event_id=>wwv_flow_api.id(1203814159678523.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1204002492678525.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1204116077678526.4504)
,p_event_id=>wwv_flow_api.id(1203814159678523.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1204002492678525.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1204763374678532.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2103321713493928.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1204841585678533.4504)
,p_event_id=>wwv_flow_api.id(1204763374678532.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2104599819493940.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Object Store Reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_remote_server_id number;',
'begin',
'    if :P3131_REMOTE_SERVER_ID is not null and :P3131_KEEP_CREDENTIALS = ''N'' then',
'        wwv_dbms_cloud.drop_objectstore_reference(',
'            p_schema           => :P3130_SCHEMA,',
'            p_remote_server_id => :P3131_REMOTE_SERVER_ID );',
'    end if;',
'',
'    if :P3131_REMOTE_SERVER_ID is not null and :P3131_KEEP_CREDENTIALS = ''Y'' then',
'        update wwv_remote_servers ',
'           set name     = :P3131_SERVER_NAME,',
'               base_url = :P3131_SERVER_URL',
'         where security_group_id = :WORKSPACE_ID',
'           and id                = :P3131_REMOTE_SERVER_ID;',
'    end if;',
'    ',
'    if :P3131_REMOTE_SERVER_ID is null or :P3131_KEEP_CREDENTIALS = ''N'' then',
'',
'        if :P3131_CREDENTIAL_TYPE = ''USERPASS'' then',
'            l_remote_server_id := wwv_dbms_cloud.create_objectstore_reference(',
'                p_schema                => :P3130_SCHEMA,',
'                p_server_name           => :P3131_SERVER_NAME,',
'                p_server_url            => :P3131_SERVER_URL,',
'                --',
'                p_create_web_credential => ( :P3131_CREATE_WEB_CREDENTIAL = ''Y'' ),',
'                --',
'                p_username              => :P3131_USERNAME,',
'                p_password              => :P3131_PASSWORD ); ',
'        elsif :P3131_CREDENTIAL_TYPE = ''OCI'' then',
'            l_remote_server_id := wwv_dbms_cloud.create_objectstore_reference(',
'                p_schema                => :P3130_SCHEMA,',
'                p_server_name           => :P3131_SERVER_NAME,',
'                p_server_url            => :P3131_SERVER_URL,',
'                --',
'                p_create_web_credential => ( :P3131_CREATE_WEB_CREDENTIAL = ''Y'' ),',
'                --',
'                p_user_ocid             => :P3131_USER_OCID,',
'                p_tenancy_ocid          => :P3131_TENANCY_OCID,',
'                p_private_key           => :P3131_PRIVATE_KEY,',
'                p_fingerprint           => :P3131_FINGERPRINT );         ',
'        elsif :P3131_CREDENTIAL_TYPE = ''USER_CREDENTIALS'' then',
'            l_remote_server_id := wwv_dbms_cloud.create_objectstore_reference(',
'                p_schema                => :P3130_SCHEMA,',
'                p_server_name           => :P3131_SERVER_NAME,',
'                p_server_url            => :P3131_SERVER_URL,',
'                --',
'                p_credential_name       => :P3131_USER_CREDENTIAL_NAME );                ',
'        else',
'            l_remote_server_id := wwv_dbms_cloud.create_objectstore_reference(',
'                p_schema        => :P3130_SCHEMA,',
'                p_server_name   => :P3131_SERVER_NAME,',
'                p_server_url    => :P3131_SERVER_URL,',
'                --',
'                p_credential_id => :P3131_WEB_CREDENTIAL_ID );        ',
'        end if;',
'        :P3131_REMOTE_SERVER_ID := l_remote_server_id;',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2103281067493927.4504)
,p_process_success_message=>'Riferimento all''area di memorizzazione degli oggetti salvato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1204583928678530.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Object Store Reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_dbms_cloud.drop_objectstore_reference(',
'        p_schema           => :P3130_SCHEMA,',
'        p_remote_server_id => :P3131_REMOTE_SERVER_ID,',
'        p_drop_credential  => nvl( :P3131_KEEP_CREDENTIALS, ''N'' ) = ''N'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1204301951678528.4504)
,p_process_success_message=>'Riferimento all''area di memorizzazione degli oggetti eliminato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1203374519678518.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Remote Server'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select name,',
'           base_url',
'      into :P3131_SERVER_NAME,',
'           :P3131_SERVER_URL',
'      from wwv_remote_servers',
'     where security_group_id = :WORKSPACE_ID',
'       and id                = :P3131_REMOTE_SERVER_ID;',
'exception',
'    when NO_DATA_FOUND then',
'        :P3131_REMOTE_SERVER_ID := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P3131_REMOTE_SERVER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_03132
begin
wwv_flow_api.create_page(
 p_id=>3132.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Caricamento area di memorizzazione degli oggetti non disponibile'
,p_step_title=>'Caricamento area di memorizzazione degli oggetti non disponibile'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2192588139655625.4504)
,p_plug_name=>'Caricamento dati dall''area di memorizzazione degli oggetti non disponibile'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'htp.p(wwv_flow_lang.system_message(v(''P3132_DBMS_CLOUD_STATUS''), :P3132_SCHEMA));',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2193034261655630.4504)
,p_plug_name=>'Informazioni'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina consente di caricare i file Avro o Parquet da origini dati esterne (area di memorizzazione degli oggetti) nello schema di database corrente.</p>',
unistr('<p>&PRODUCT_NAME. usa il package <strong>DBMS_CLOUD</strong> per fornire <em>tabelle esterne</em> sopra i file esterni. I dati possono essere copiati dalla tabella esterna a una tabella normale, ma \00E8 anche possibile eseguire query direttamente sulle ')
||'tabelle esterne.</p>',
'<p><a href="&SYSTEM_HELP_URL./aeutl/loading-data-from-cloud.html" target="_blank">Ulteriori informazioni...</a></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2193131108655631.4504)
,p_branch_action=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_dbms_cloud.check_prerequisites(coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)) = ''SUCCESS'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2192646721655626.4504)
,p_name=>'P3132_DBMS_CLOUD_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2192588139655625.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2192825895655628.4504)
,p_name=>'P3132_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(387994680244652086.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2192792665655627.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3132_DBMS_CLOUD_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_dbms_cloud.check_prerequisites(coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema))'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2192906107655629.4504)
,p_computation_sequence=>20
,p_computation_item=>'P3132_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)'
);
end;
/
prompt --application/pages/page_03140
begin
wwv_flow_api.create_page(
 p_id=>3140.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica da tabella esterna'
,p_step_title=>'Carica da tabella esterna'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div#configureColumns {',
'    margin-left: calc(30% + 8px);',
'    box-shadow: none;',
'    margin-right: 16px;',
'    margin-top: 4px;',
'    margin-bottom: 4px;',
'}',
'',
'#configureColumns .a-Alert-body {',
'  margin: 0;',
'}',
'',
'div#configureColumns .a-Alert-icon, ',
'div#configureColumns .a-Alert-content, ',
'div#configureColumns .a-Alert-buttons {',
'  padding: 8px 0;',
'}',
'',
'div#configureColumns .a-Alert-buttons {',
'    padding: 8px;',
'}',
'',
'div#configureColumns .a-Report-cell {',
'  padding: 0 8px;',
'  background-color: transparent;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2193332767655633.4504)
,p_name=>'Tabella esterna &P3140_EXTERNAL_TABLE_NAME!HTML.'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_loader_dev.get_preview_query(',
'           p_table_owner    => :P3140_SCHEMA,',
'           p_table_name     => :P3140_EXTERNAL_TABLE_NAME );',
'           '))
,p_optimizer_hint=>'APEX$USE_NO_PAGINATION'
,p_header=>'Questa anteprima mostra fino a 15 colonne e 10 righe. Fare clic sul pulsante <strong>Visualizza nel browser oggetti</strong> per esaminare la tabella nel browser oggetti.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>15
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_string.join(',
'           wwv_flow_data_loader_dev.get_column_names(',
'               p_table_owner    => :P3140_SCHEMA,',
'               p_table_name     => :P3140_EXTERNAL_TABLE_NAME ), '':'' );',
'           '))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>10
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('La tabella esterna \00E8 vuota.')
,p_query_row_count_max=>10
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
,p_plug_query_parse_override=>'P3140_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2193489325655634.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2193510128655635.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2193649711655636.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2193768725655637.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2193841769655638.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2193961119655639.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194001358655740.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194115840655741.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194272133655742.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194378931655743.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194432990655744.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194593359655745.4504)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194610202655746.4504)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194701190655747.4504)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2194820707655748.4504)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2618318283013901.4504)
,p_plug_name=>'Carica dati'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2621380151013931.4504)
,p_plug_name=>'Campi aggiuntivi'
,p_parent_plug_id=>wwv_flow_api.id(2618318283013901.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(85416193196169617.4504)
,p_name=>'Configure Information'
,p_region_name=>'configureColumns'
,p_parent_plug_id=>wwv_flow_api.id(2618318283013901.4504)
,p_template=>wwv_flow_api.id(746376253838324384.4504)
,p_display_sequence=>10
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_icon_css_classes=>'icon-report'
,p_region_template_options=>'a-Alert--colorBG:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--noBorders'
,p_region_attributes=>'style="display: none;"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_info           varchar2(32767);',
'    l_mapped_col_cnt number;',
'    l_file_col_cnt   number;',
'begin',
'    l_mapped_col_cnt := to_number(:P3140_MAPPED_COLUMN_COUNT);',
'    l_file_col_cnt := to_number(:P3140_FILE_COLUMN_COUNT);',
'    ',
'    if :P3140_LOAD_TO = ''EXISTING'' then',
'        if l_mapped_col_cnt = 0 then',
'            l_info := wwv_flow_lang.system_message( ''DATA.LOAD.DEFINE_COL_MAPPING'', wwv_flow_escape.html( :P3140_EXISTING_TABLE_NAME ) );',
'        else',
'            if l_mapped_col_cnt = l_file_col_cnt then',
'                l_info := wwv_flow_lang.system_message( ''DATA.LOAD.ALL_COL_MAPPED'', :P3140_FILE_COLUMN_COUNT, wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME ) );',
'            elsif l_mapped_col_cnt < l_file_col_cnt then',
'                l_info := wwv_flow_lang.system_message( ''DATA.LOAD.MAP_REMAINING_COLS'', :P3140_MAPPED_COLUMN_COUNT, :P3140_FILE_COLUMN_COUNT, wwv_flow_escape.html( :P3140_EXISTING_TABLE_NAME ) );',
'            end if;',
'        end if;',
'    else',
'        l_info := wwv_flow_lang.system_message(''DATA.LOAD.SELECT_COLS'');',
'    end if;',
'',
'    return ''select ''||wwv_flow_assert.enquote_literal(l_info)||'' info from sys.dual'';',
'end;'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P3140_LOAD_TO,P3140_EXISTING_TABLE_NAME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2713617939431532.4504)
,p_query_column_id=>1
,p_column_alias=>'INFO'
,p_column_display_sequence=>1
,p_column_heading=>'Informazioni'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2619609080013914.4504)
,p_plug_name=>'Informazioni'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Questa pagina mostra il contenuto della tabella esterna in base ai file di area di memorizzazione degli oggetti e consente di copiare le righe dalla tabella esterna a una tabella normale nello schema dell''area di lavoro APEX. In alternativa, le ap'
||unistr('plicazioni possono anche utilizzare direttamente la tabella esterna. Tuttavia, l''accesso alla tabella esterna \00E8 in genere pi\00F9 lento rispetto all''accesso normale alla tabella. Inoltre, le tabelle esterne non possono essere indicizzate. '),
'</p>',
unistr('<p>Per l''accesso frequente ai dati, \00E8 quindi consigliabile caricare i dati in una tabella normale nel database Oracle. Invece di usare questa procedura guidata, il processo pu\00F2 anche essere eseguito utilizzando le istruzioni SQL nei <strong>comandi S')
||'QL</strong>.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2906149752173311.4504)
,p_name=>'Job di caricamento dei dati attivi'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    substr( j.job_name, 18 ) as dataload_job_id,',
'    j.state,',
'    j.start_date,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,2,''i'',2 ) as workspace_user,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,3,''i'',2 ) as table_owner,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,4,''i'',2 ) as table_name',
' from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'  and c.display_name = :COMPANY  ',
'  and j.state = ''RUNNING''',
'  and job_name like ''ORACLE_APEX_DTLD$%''',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select 1',
' from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'  and c.display_name = :COMPANY  ',
'  and j.state = ''RUNNING''',
'  and job_name like ''ORACLE_APEX_DTLD$%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2906231349173312.4504)
,p_query_column_id=>1
,p_column_alias=>'DATALOAD_JOB_ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID job'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2906344075173313.4504)
,p_query_column_id=>2
,p_column_alias=>'STATE'
,p_column_display_sequence=>2
,p_column_heading=>'Stato job'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2906421180173314.4504)
,p_query_column_id=>3
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Avviato'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2906591469173315.4504)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_USER'
,p_column_display_sequence=>4
,p_column_heading=>'Utente area di lavoro'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2906610800173316.4504)
,p_query_column_id=>5
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Proprietario tabella'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2906753539173317.4504)
,p_query_column_id=>6
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Nome tabella'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2619446273013912.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2618318283013901.4504)
,p_button_name=>'VIEW_TABLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Esci dal browser oggetti'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP,1001:OB_SCHEMA,OB_CURRENT_TYPE,OB_OBJECT_ID:&P3140_SCHEMA.,TABLE,&P3140_OBJECT_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2619165209013909.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2618318283013901.4504)
,p_button_name=>'LOAD_DATA'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Carica dati nella tabella locale'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2714014474431537.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(85416193196169617.4504)
,p_button_name=>'CONFIGURE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Configura'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3142:&SESSION.::&DEBUG.:RP,3142:P3120_ACTION:tab_columns'
,p_icon_css_classes=>'icon-open-in-dialog margin-left-sm'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2619854071013916.4504)
,p_branch_name=>'Go To Page 3141'
,p_branch_action=>'f?p=&APP_ID.:3141:&SESSION.::&DEBUG.:RP:P3141_LOAD_TO,P3141_TABLE_OWNER:&P3140_LOAD_TO.,&P3140_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2619165209013909.4504)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P3140_MONITOR_PROGRESS'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(150091984209895807.4504)
,p_branch_action=>'f?p=&APP_ID.:3140:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2619165209013909.4504)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P3140_MONITOR_PROGRESS'
,p_branch_condition_text=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2875468341080405.4504)
,p_branch_name=>'Go To Page 3130'
,p_branch_action=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:RP,3130,3140,3131::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2875695788080407.4504)
,p_branch_action=>'f?p=&APP_ID.:3132:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_dbms_cloud.check_prerequisites(coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)) != ''SUCCESS'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2194955174655749.4504)
,p_name=>'P3140_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(387994680244652086.4504)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2195098390655750.4504)
,p_name=>'P3140_EXTERNAL_TABLE_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2618591561013903.4504)
,p_name=>'P3140_LOAD_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2618318283013901.4504)
,p_item_default=>'NEW'
,p_prompt=>'Carica in'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P3100_LOAD_TO'
,p_lov=>'.'||wwv_flow_api.id(60089930390905970.4504)||'.'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Scegliere se eseguire il caricamento in una tabella nuova o esistente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2618641343013904.4504)
,p_name=>'P3140_NEW_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2618318283013901.4504)
,p_prompt=>'Nuovo nome tabella'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identificare il nome della tabella da creare. Per impostazione predefinita, tutti i nomi di tabella vengono convertiti in lettere maiuscole.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2619280072013910.4504)
,p_name=>'P3140_OBJECT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620124113013919.4504)
,p_name=>'P3140_MAPPED_COLUMN_COUNT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620256188013920.4504)
,p_name=>'P3140_FILE_COLUMN_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2621861215013936.4504)
,p_name=>'P3140_UPDATE_METHOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_item_default=>'APPEND'
,p_prompt=>'Aggiorna metodo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Append;APPEND,Replace;REPLACE'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>Aggiungi</strong>: se nella tabella sono gi\00E0 presenti dei dati, la procedura guidata aggiunge le nuove righe nella tabella. Se i dati non sono presenti, le nuove righe vengono semplicemente caricate.</li>'),
'    <li><strong>Sostituisci</strong>: viene sostituita l''intera tabella; prima viene eliminato l''intero contenuto della tabella, quindi le nuove righe vengono caricate nella tabella.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2621964383013937.4504)
,p_name=>'P3140_ERROR_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2618318283013901.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identificare il nome della tabella di errori desiderata per salvare gli errori durante il caricamento dei dati. Per impostazione predefinita, tutti nomi di tabella vengono convertiti in lettere maiuscole. Se il caricamento dei dati viene completato s'
||'enza errori, questa tabella di errori viene eliminata automaticamente.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2622374790013941.4504)
,p_name=>'P3140_MONITOR_PROGRESS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_item_default=>'Y'
,p_prompt=>'Monitora avanzamento'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se l''opzione \00E8 abilitata, il caricamento dei dati consentir\00E0 di monitorare lo stato di avanzamento del caricamento dei dati eseguendo un commit dopo un batch di righe. Se disabilitata, tutti i dati verranno inseriti in una transazione, che normalment')
||unistr('e \00E8 pi\00F9 veloce, ma non consente di controllare lo stato di avanzamento del caricamento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2622444770013942.4504)
,p_name=>'P3140_SUCCESS_MSG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2711467497285822.4504)
,p_name=>'P3140_EXISTING_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2618318283013901.4504)
,p_prompt=>'Tabella'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name a, table_name b',
'  from sys.dba_tables',
' where owner=:P3140_SCHEMA',
'   and table_name not like ''BIN$%'' ',
'   and external = ''NO''',
' order by table_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona tabella -'
,p_lov_cascade_parent_items=>'P3100_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>50
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selezionare la tabella di database in cui si desidera caricare i dati.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2906981461173319.4504)
,p_name=>'P3140_COMMIT_INTERVAL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_item_default=>'5000'
,p_prompt=>'Intervallo di commit'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:2K;2000,5K;5000,10K;10000,50K;50000,100K;100000'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specificare dopo quante righe caricate APEX deve eseguire un COMMIT.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150091820683895806.4504)
,p_name=>'P3140_DROP_EXTERNAL_TABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2621380151013931.4504)
,p_item_default=>'Y'
,p_prompt=>'Elimina tabella esterna dopo il caricamento'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se l''opzione \00E8 abilitata, la tabella esterna verr\00E0 eliminata dopo il caricamento dei dati.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1905419549643947.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3140_NEW_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P3140_NEW_TABLE_NAME)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1905527064643948.4504)
,p_computation_sequence=>20
,p_computation_item=>'P3140_ERROR_TABLE_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_loader_dev.get_error_table_name(',
'    p_table_owner => :P3140_TABLE_OWNER,',
'    p_table_name  => (',
'                     case when :P3140_LOAD_TO = ''NEW'' then',
'                         :P3140_NEW_TABLE_NAME',
'                     when :P3140_LOAD_TO = ''EXISTING'' then',
'                         :P3140_EXISTING_TABLE_NAME',
'                     end) );'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2619398941013911.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3140_OBJECT_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id',
'  from dba_objects',
' where owner = :P3140_SCHEMA',
'   and object_type = ''TABLE''',
'   and object_name = :P3140_EXTERNAL_TABLE_NAME'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1905676080643949.4504)
,p_validation_name=>'External Table still exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from sys.dba_tables',
' where owner = :P3140_SCHEMA',
'   and table_name = :P3140_EXTERNAL_TABLE_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabella esterna &P3140_EXTERNAL_TABLE_NAME!HTML. non esiste pi\00F9.')
,p_when_button_pressed=>wwv_flow_api.id(2619165209013909.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2910481948183552.4504)
,p_validation_name=>'new table name not > 30 (11g) or > 128 (12.2)'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if length(:P3140_NEW_TABLE_NAME) > wwv_flow_global.c_dbms_id_length then',
'  return wwv_flow_lang.system_message(''F4300.TABLE_NAMES_NOT_LONGER_THAN_30'',wwv_flow_global.c_dbms_id_length);',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P3140_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2619165209013909.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2905360278173303.4504)
,p_validation_name=>'New Table name is required'
,p_validation_sequence=>40
,p_validation=>'P3140_NEW_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>'P3140_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2619165209013909.4504)
,p_associated_item=>wwv_flow_api.id(2618641343013904.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(90119319564448642.4504)
,p_validation_name=>'Table names must not contain invalid chars'
,p_validation_sequence=>50
,p_validation=>'P3140_NEW_TABLE_NAME'
,p_validation2=>'#&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'#LABEL# non deve contenere #, &, <, >, ", /, ;, *, |, =, % o il carattere ,.'
,p_validation_condition=>'P3140_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2619165209013909.4504)
,p_associated_item=>wwv_flow_api.id(2618641343013904.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2907092600173320.4504)
,p_validation_name=>'Commit Interval is not null'
,p_validation_sequence=>60
,p_validation=>'P3140_COMMIT_INTERVAL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>'P3140_MONITOR_PROGRESS'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2619165209013909.4504)
,p_associated_item=>wwv_flow_api.id(2906981461173319.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2619913988013917.4504)
,p_name=>'Existing Table chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3140_EXISTING_TABLE_NAME'
,p_condition_element=>'P3140_EXISTING_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620023735013918.4504)
,p_event_id=>wwv_flow_api.id(2619913988013917.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_profile clob;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );        ',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD'' );',
'',
'    l_file_profile := wwv_flow_data_parser.profile_to_json( wwv_flow_data_loader_dev.get_profile_from_table( :P3140_SCHEMA, :P3140_EXTERNAL_TABLE_NAME ));',
'    wwv_flow_data_loader_dev.build_column_mapping_coll(',
'        p_file_profile_json => l_file_profile,',
'        p_load_to_owner     => :P3140_SCHEMA,',
'        p_load_to_table     => :P3140_EXISTING_TABLE_NAME );',
'    wwv_flow_collection.add_member( p_collection_name => ''APEX$DATALOAD'', p_clob001 => l_file_profile );',
'        ',
'    select count(c001) file_columns, ',
'           count(c002) mapped_columns',
'      into :P3140_FILE_COLUMN_COUNT,',
'           :P3140_MAPPED_COLUMN_COUNT',
'      from wwv_flow_collections',
'     where collection_name = ''APEX$DATALOAD_COLUMNS'';',
'end;'))
,p_attribute_02=>'P3140_SCHEMA,P3140_EXISTING_TABLE_NAME,P3140_EXTERNAL_TABLE_NAME'
,p_attribute_03=>'P3140_MAPPED_COLUMN_COUNT,P3140_FILE_COLUMN_COUNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620534062013923.4504)
,p_event_id=>wwv_flow_api.id(2619913988013917.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(85416193196169617.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620446465013922.4504)
,p_event_id=>wwv_flow_api.id(2619913988013917.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(85416193196169617.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620324571013921.4504)
,p_event_id=>wwv_flow_api.id(2619913988013917.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(85416193196169617.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2620629076013924.4504)
,p_name=>'New or existing'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3140_LOAD_TO'
,p_condition_element=>'P3140_LOAD_TO'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620753443013925.4504)
,p_event_id=>wwv_flow_api.id(2620629076013924.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_NEW_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2623174441013949.4504)
,p_event_id=>wwv_flow_api.id(2620629076013924.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_UPDATE_METHOD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620801064013926.4504)
,p_event_id=>wwv_flow_api.id(2620629076013924.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_EXISTING_TABLE_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2621297025013930.4504)
,p_event_id=>wwv_flow_api.id(2620629076013924.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_EXISTING_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620986005013927.4504)
,p_event_id=>wwv_flow_api.id(2620629076013924.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_EXISTING_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2621147057013929.4504)
,p_event_id=>wwv_flow_api.id(2620629076013924.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_EXISTING_TABLE_NAME,P3140_NEW_TABLE_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2621035050013928.4504)
,p_event_id=>wwv_flow_api.id(2620629076013924.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_NEW_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2623052974013948.4504)
,p_event_id=>wwv_flow_api.id(2620629076013924.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_UPDATE_METHOD'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2621527909013933.4504)
,p_name=>'Dialog closed'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2714014474431537.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2621663378013934.4504)
,p_event_id=>wwv_flow_api.id(2621527909013933.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(85416193196169617.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2622639891013944.4504)
,p_name=>'New Table'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3140_NEW_TABLE_NAME'
,p_condition_element=>'P3140_NEW_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2622866778013946.4504)
,p_event_id=>wwv_flow_api.id(2622639891013944.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_profile clob;',
'begin',
'    l_file_profile := wwv_flow_data_parser.profile_to_json( wwv_flow_data_loader_dev.get_profile_from_table( :P3140_SCHEMA, :P3140_EXTERNAL_TABLE_NAME ));',
'',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD'' );',
'    wwv_flow_collection.add_member( p_collection_name => ''APEX$DATALOAD'', p_clob001 => l_file_profile );',
'        ',
'end;'))
,p_attribute_02=>'P3140_SCHEMA,P3140_NEW_TABLE_NAME,P3140_EXTERNAL_TABLE_NAME'
,p_attribute_03=>'P3140_MAPPED_COLUMN_COUNT,P3140_FILE_COLUMN_COUNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2622712922013945.4504)
,p_event_id=>wwv_flow_api.id(2622639891013944.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(85416193196169617.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2622950162013947.4504)
,p_event_id=>wwv_flow_api.id(2622639891013944.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(85416193196169617.4504)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2907170259173321.4504)
,p_name=>'Show Hide Commit Interval'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3140_MONITOR_PROGRESS'
,p_condition_element=>'P3140_MONITOR_PROGRESS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2907259377173322.4504)
,p_event_id=>wwv_flow_api.id(2907170259173321.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_COMMIT_INTERVAL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2907366118173323.4504)
,p_event_id=>wwv_flow_api.id(2907170259173321.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_COMMIT_INTERVAL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2906897705173318.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Status Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD_STATUS'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2619165209013909.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2619725797013915.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load into new Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.load_to_new_table(',
'    p_source_type       => ''TABLE'',',
'    p_source_schema     => :P3140_SCHEMA,',
'    p_source_name       => :P3140_EXTERNAL_TABLE_NAME,',
'    p_drop_source_table => :P3140_DROP_EXTERNAL_TABLE = ''Y'',',
'    --',
'    p_target_schema     => :P3140_SCHEMA,',
'    p_target_name       => :P3140_NEW_TABLE_NAME,',
'    p_error_table_name  => :P3140_ERROR_TABLE_NAME,',
'    --',
'    p_add_id_column     => false,',
'    --',
'    p_monitor_progress  => :P3140_MONITOR_PROGRESS = ''Y'',',
'    p_commit_interval   => :P3140_COMMIT_INTERVAL,',
'    --',
'    p_load_id           => :P3100_LOAD_ID,',
'    p_message           => :P3140_SUCCESS_MSG );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2619165209013909.4504)
,p_process_when=>'P3140_LOAD_TO'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NEW'
,p_process_success_message=>'&P3140_SUCCESS_MSG.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2621794321013935.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load into existing table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.load_to_existing_table(',
'    p_source_type      => ''TABLE'',',
'    p_source_schema    => :P3140_SCHEMA,',
'    p_source_name      => :P3140_EXTERNAL_TABLE_NAME,',
'    p_drop_source_table => :P3140_DROP_EXTERNAL_TABLE = ''Y'',    ',
'    --',
'    p_target_schema    => :P3140_SCHEMA,',
'    p_target_name      => :P3140_EXISTING_TABLE_NAME,',
'    p_error_table_name => :P3140_ERROR_TABLE_NAME,',
'',
'    p_skip_rows        => 0,',
'    p_truncate_rows    => ( :P3140_UPDATE_METHOD = ''REPLACE'' ),',
'    --',
'    p_monitor_progress => :P3140_MONITOR_PROGRESS = ''Y'',',
'    p_commit_interval  => :P3140_COMMIT_INTERVAL,',
'    --',
'    p_load_id          => :P3100_LOAD_ID,',
'    p_message          => :P3140_SUCCESS_MSG );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2619165209013909.4504)
,p_process_when=>'P3140_LOAD_TO'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'EXISTING'
,p_process_success_message=>'&P3140_SUCCESS_MSG.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2875306072080404.4504)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Drop external table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_dbms_cloud.drop_table(',
'        p_schema     => :P3140_SCHEMA,',
'        p_table_name => :P3140_EXTERNAL_TABLE_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Tabella esterna &P3140_EXTERNAL_TABLE_NAME!HTML. eliminata.'
);
end;
/
prompt --application/pages/page_03141
begin
wwv_flow_api.create_page(
 p_id=>3141.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica dati'
,p_page_mode=>'MODAL'
,p_step_title=>'Carica dati'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region-headerItems--buttons { white-space: nowrap; }',
'.a-Region-bodyHeader { padding: 12px; margin: 0; border-bottom: 1px solid rgba(0, 0, 0,0.1); background-color: #FFF8E1; color: #202020; }',
''))
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
,p_dialog_height=>'800'
,p_dialog_width=>'960'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4231473388833227.4504)
,p_name=>'Caricamento in corso'
,p_region_name=>'loadInProgress'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 as status,',
'       n001 as rows_processed ',
'from wwv_flow_collections ',
'where collection_name=''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(385896719135645040.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2636744459490406.4504)
,p_query_column_id=>1
,p_column_alias=>'STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(3891423527523942)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2637147571490407.4504)
,p_query_column_id=>2
,p_column_alias=>'ROWS_PROCESSED'
,p_column_display_sequence=>2
,p_column_heading=>'Righe elaborate'
,p_use_as_row_header=>'N'
,p_column_format=>'9G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6848144262546396.4504)
,p_plug_name=>'Caricamento non riuscito'
,p_region_name=>'loadIncomplete'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>50
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Caricamento dei dati non riuscito in modo intermittente e incompleto.',
'<pre id="imcompl_load_error"></pre>',
'Controllare l''errore e riprovare. <br/>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467921583038983200.4504)
,p_plug_name=>'Nuova tabella'
,p_parent_plug_id=>wwv_flow_api.id(6848144262546396.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Tabella <code>&P3100_TABLE_NAME!HTML.</code> creata. Caricamento di <b id="incompl_success_row_count"></b> righe riuscito. <b class="u-danger-text" id="incompl_fail_row_count"></b> righe rifiutate.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467921657119983201.4504)
,p_plug_name=>'Tabella esistente'
,p_parent_plug_id=>wwv_flow_api.id(6848144262546396.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_INCOMPLETE'', wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME) ) );',
'elsif :P3100_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_INCOMPLETE'',wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7975322082563595.4504)
,p_plug_name=>'Operazione riuscita con avvertenza'
,p_region_name=>'loadError'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467921143628983196.4504)
,p_plug_name=>'Nuova tabella'
,p_parent_plug_id=>wwv_flow_api.id(7975322082563595.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Tabella <code>&P3141_TABLE_NAME!HTML.</code> creata. Caricamento di <b id="err_success_row_count"></b> righe riuscito. <b class="u-danger-text" id="err_fail_row_count"></b> righe rifiutate.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467921257416983197.4504)
,p_plug_name=>'Tabella esistente'
,p_parent_plug_id=>wwv_flow_api.id(7975322082563595.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3140_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_WARNING'', wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME ) ) );',
'elsif :P3140_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_WARNING'', wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME ) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7975594711563597.4504)
,p_plug_name=>'Caricamento non riuscito'
,p_region_name=>'loadFail'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>40
,p_plug_source=>'Impossibile caricare i dati. Controllare l''errore e riprovare. <b id="fail_row_count"></b> righe con errore.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7975679603563598.4504)
,p_plug_name=>'Caricamento dati riuscito'
,p_region_name=>'loadSuccess'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467921406339983198.4504)
,p_plug_name=>'Nuova tabella'
,p_parent_plug_id=>wwv_flow_api.id(7975679603563598.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Tabella <code>&P3141_TABLE_NAME!HTML.</code> creata con <b id="success_row_count"></b> righe.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467921439292983199.4504)
,p_plug_name=>'Tabella esistente'
,p_parent_plug_id=>wwv_flow_api.id(7975679603563598.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3140_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_SUCCESS'', wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME) ) );',
'elsif :P3140_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_SUCCESS'',wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(7975736219563599.4504)
,p_name=>'Righe rifiutate nella tabella &P3140_ERROR_TABLE_NAME!HTML.'
,p_region_name=>'failed_rows'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch:a-Report--rowHighlight'
,p_region_attributes=>'style="display: none;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q              varchar2(32767);',
'    l_column_name  varchar2(255);',
'    l_columns      varchar2(32767);',
'    l_profile_json clob;',
'    l_file_profile wwv_flow_data_parser.t_file_profile;',
'begin',
'    ',
'    select clob001 ',
'    into l_profile_json',
'    from wwv_flow_collections',
'    where collection_name = ''APEX$DATALOAD''',
'    and rownum = 1;',
'',
'    -- query upto 10 columns not including CLOB',
'    for l_file in ( ',
'        select column_position, column_name, data_type ',
'        from table( wwv_flow_data_parser.get_columns(l_profile_json ) )',
'        where rownum <= 10',
'        and data_type != ''CLOB'' )',
'    loop',
'        l_column_name := null;',
'',
'        if :P3141_LOAD_TO = ''EXISTING'' then',
'            for l_existing_table in (',
'                select column_name',
'                from sys.dba_tab_columns',
'                where owner = :P3140_SCHEMA',
'                and table_name = :P3140_EXISTING_TABLE_NAME',
'                and column_name = l_file.column_name )',
'            loop',
'                l_column_name := l_existing_table.column_name;',
'            end loop;',
'            -- if column header not used, columns such as c001 mapped to existing column',
'            if l_column_name is null then',
'                for l_configure in (',
'                    select',
'                        c002 mapped_column',
'                    from wwv_flow_collections',
'                    where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                    and c002 is not null',
'                    and c001 = l_file.column_name )',
'                loop',
'                    l_column_name := l_configure.mapped_column;',
'                end loop;',
'            end if;',
'        else',
'            -- validate file columns against newly created table',
'            -- get only the ones created',
'            for l_table in (',
'                select column_name',
'                from sys.dba_tab_columns',
'                where owner = :P3140_SCHEMA',
'                and table_name = :P3140_NEW_TABLE_NAME',
'                and column_name = l_file.column_name )',
'            loop',
'                l_column_name := l_table.column_name;',
'            end loop;',
'        end if;',
'',
'        if l_column_name is not null then',
'            l_columns := l_columns ||case when l_columns is not null then '','' end || l_column_name;',
'        end if;',
'    end loop;',
'   ',
'    q := ''select ORA_ERR_MESG$ as error_message''|| ',
'         (case when l_columns is not null then '',''|| l_columns end ) ||',
'         '' from ''||wwv_flow_assert.enquote_name( :P3140_ERROR_TABLE_NAME );',
'',
'    return q;',
'end;'))
,p_header=>'Tutte le righe rifiutate vengono memorizzate nella tabella &P3140_ERROR_TABLE_NAME!HTML.. Nel report riportato di seguito vengono mostrate le prime 10 righe.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>11
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>10
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
,p_plug_query_parse_override=>'P3140_SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2642474943490437.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2642783184490439.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2643103412490440.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2643597772490441.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2643971737490441.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2644389985490442.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2644722864490443.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2645103567490443.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2645549311490445.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2645910817490445.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2646351133490447.4504)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7977268071563614.4504)
,p_plug_name=>'Caricamento completato'
,p_region_name=>'load_finished'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11525930126379476.4504)
,p_plug_name=>'Informazioni sulla tabella'
,p_region_name=>'table_info'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="timer-container"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11526227405379479.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2652436563490456.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11526227405379479.4504)
,p_button_name=>'CANCEL'
,p_button_static_id=>'btn_cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Chiudi'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2652804813490457.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(11526227405379479.4504)
,p_button_name=>'VIEW_TABLE'
,p_button_static_id=>'viewTableBtn'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Visualizza tabella'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP,1001:OB_SCHEMA,OB_CURRENT_TYPE,OB_OBJECT_ID:&P3100_TABLE_OWNER.,TABLE,&P3141_TAB_OBJ_ID.'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2653211373490457.4504)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(11526227405379479.4504)
,p_button_name=>'CREATE_APP'
,p_button_static_id=>'createAppBtn'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea applicazione'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:1,5,130,150,170,250:P1_SCHEMA,P1_NEW_TABLE_NAME:&P3141_TABLE_OWNER.,&P3141_TABLE_NAME.'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2907407723173324.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(7975736219563599.4504)
,p_button_name=>'DROP_TABLE'
,p_button_static_id=>'dropTableBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina tabella e ricarica'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'style="display: none;"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2647149557490448.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(7975736219563599.4504)
,p_button_name=>'VIEW_ERROR_TABLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Apri nel browser oggetti'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP,1001:OB_SCHEMA,OB_CURRENT_TYPE,OB_OBJECT_ID:&P3140_SCHEMA.,TABLE,&P3141_ERR_TAB_OBJ_ID.'
,p_icon_css_classes=>'icon-open-in-dialog'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2653673246490457.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(11526227405379479.4504)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'btn_previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2907854454173328.4504)
,p_branch_action=>'f?p=&APP_ID.:3140:&SESSION.::&DEBUG.:RP,3141,3142::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2907407723173324.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2637521218490412.4504)
,p_name=>'P3141_LOAD_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4231473388833227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2637926336490415.4504)
,p_name=>'P3141_LOAD_ERROR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4231473388833227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2638379139490416.4504)
,p_name=>'P3141_PROCESSED_ROW_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4231473388833227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2638776512490418.4504)
,p_name=>'P3141_PROCESSED_ROW_CNT_DISP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4231473388833227.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2647839701490450.4504)
,p_name=>'P3141_LOAD_TO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7977268071563614.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2648222651490451.4504)
,p_name=>'P3141_TABLE_CREATED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(7977268071563614.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2648623641490451.4504)
,p_name=>'P3141_TAB_OBJ_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(7977268071563614.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2649077941490452.4504)
,p_name=>'P3141_ERR_TAB_OBJ_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(7977268071563614.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2649419661490452.4504)
,p_name=>'P3141_GOOD_ROW_CNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(7977268071563614.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2649835221490452.4504)
,p_name=>'P3141_GOOD_ROW_CNT_DISP'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(7977268071563614.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2650272085490452.4504)
,p_name=>'P3141_BAD_ROW_CNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(7977268071563614.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2650601946490453.4504)
,p_name=>'P3141_BAD_ROW_CNT_DISP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(7977268071563614.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2651388735490454.4504)
,p_name=>'P3141_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11525930126379476.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proprietario tabella'
,p_source=>'P3140_TABLE_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2651744536490455.4504)
,p_name=>'P3141_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(11525930126379476.4504)
,p_prompt=>'Nome tabella'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2654175922490475.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3141_TABLE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3141_LOAD_TO = ''NEW'' then',
'    return :P3140_NEW_TABLE_NAME;',
'elsif :P3141_LOAD_TO = ''EXISTING'' then',
'    return :P3140_EXISTING_TABLE_NAME;',
'end if;'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2655247087490477.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2652436563490456.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2655725505490479.4504)
,p_event_id=>wwv_flow_api.id(2655247087490477.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2656101624490479.4504)
,p_name=>'Timer for Refresh Progress'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2656677307490480.4504)
,p_event_id=>wwv_flow_api.id(2656101624490479.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSpinner$ = false;',
'',
'var showFinished = function(){    ',
'    // Hide Table Information',
'    apex.region("table_info").element.hide();',
'',
'    var lLoadTo = apex.item("P3141_LOAD_TO").getValue();',
'    var lTableCreated = apex.item( "P3141_TABLE_CREATED" ).getValue();',
'    var lBadRowCnt = apex.item( "P3141_BAD_ROW_CNT" ).getValue();',
'    var lSuccessRowCnt = apex.item("P3141_GOOD_ROW_CNT").getValue();',
'    var lProcessedRowCnt = apex.item( "P3141_PROCESSED_ROW_CNT" ).getValue();',
'    ',
'    var lBadRowCntDisp = apex.item( "P3141_BAD_ROW_CNT_DISP" ).getValue();',
'    var lSuccessRowCntDisp = apex.item("P3141_GOOD_ROW_CNT_DISP").getValue();',
'    var lProcessedRowCntDisp = apex.item( "P3141_PROCESSED_ROW_CNT_DISP" ).getValue();',
'    ',
'    if (lLoadTo === "NEW") {',
'        if (lTableCreated === "Y") {',
'            apex.jQuery("#viewTableBtn").show();',
'            apex.jQuery("#btn_cancel").hide();',
'        }',
'    } else if (lLoadTo === "EXISTING") {',
'        apex.jQuery("#viewTableBtn").show();',
'    }',
'    ',
'    if ( apex.item("P3141_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'        // show failure region',
'',
'        apex.jQuery("#incompl_success_row_count").text( lSuccessRowCntDisp );',
'        apex.jQuery("#incompl_fail_row_count").text( lBadRowCntDisp );',
'        apex.jQuery("#imcompl_load_error").text( apex.item( "P3141_LOAD_ERROR" ).getValue() );        ',
'        apex.region("loadIncomplete").element.show();',
'        if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'        if (lBadRowCnt > "0") {',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'        }',
'    } else {',
'        ',
'        if ( lBadRowCnt === "0" ) {',
'            // show success region',
'            apex.jQuery("#success_row_count").text( lSuccessRowCntDisp );',
'            apex.region("loadSuccess").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            apex.jQuery("#btn_previous").hide();',
'        } else if ( lSuccessRowCnt > "0" && lBadRowCnt > "0" ) {',
'            // show error region',
'            apex.jQuery("#err_success_row_count").text( lSuccessRowCntDisp );',
'            apex.jQuery("#err_fail_row_count").text( lBadRowCntDisp );',
'            apex.region("loadError").element.show();',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'',
'        } else if ( lBadRowCnt === lProcessedRowCnt ) {',
'            // show failure region',
'            apex.jQuery("#fail_row_count").text( lBadRowCntDisp );',
'            apex.region("loadFail").element.show();',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'            if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'        }',
'    }',
' };',
'',
'var triggerRefresh = function(){ ',
'    if ( !lSpinner$ ) {',
'        lSpinner$ = apex.util.showSpinner( $( "#loadInProgress" ) );',
'    }',
'        ',
'    apex.event.trigger( apex.jQuery("#timer-container"), "job_timer" );',
'',
'    if ( apex.item("P3141_LOAD_STATUS").getValue() === ''FINISHED''  || ',
'         apex.item("P3141_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'      clearInterval( refreshInterval );',
'      apex.region("loadInProgress").element.hide();',
'      lSpinner$.remove();',
'      showFinished();',
'    }',
'};',
'',
'var refreshInterval = setInterval( triggerRefresh, 1000);'))
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2657037056490480.4504)
,p_name=>'Refresh Progress Report on Timer'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#timer-container'
,p_bind_type=>'bind'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'job_timer'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2657549421490481.4504)
,p_event_id=>wwv_flow_api.id(2657037056490480.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4231473388833227.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2658068440490482.4504)
,p_event_id=>wwv_flow_api.id(2657037056490480.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_job_is_running number;',
'begin',
'    for l_load in (',
'        select c001 as status,',
'               c002 as error_message,',
'               n001 as rows_processed ',
'        from wwv_flow_collections ',
'        where collection_name=''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID)',
'    loop',
'        :P3141_LOAD_STATUS       := l_load.status;',
'        :P3141_LOAD_ERROR        := l_load.error_message;',
'        :P3141_PROCESSED_ROW_CNT := l_load.rows_processed;',
'    end loop;',
'',
'    -- if the status is "RUNNING", check whether we really have an active scheduler job',
'    if :P3141_LOAD_STATUS = ''RUNNING'' then',
'        begin',
'            select 1',
'              into l_job_is_running',
'              from user_scheduler_jobs',
'             where job_name like ''ORACLE_APEX_DTLD$%''',
'               and regexp_substr( comments, ''(\:)(.*?)(\:)'',1,5,''i'',2 ) = ''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID',
'               and state = ''RUNNING'';',
'        exception ',
'            when no_data_found then',
'                :P3141_LOAD_STATUS       := ''FAILED'';',
'                :P3141_LOAD_ERROR        := wwv_flow_lang.system_message(''DATA.LOAD.JOB_INTERMITTENTLY_FAILED'');',
'        end;',
'    end if;',
'    ',
'    :P3141_PROCESSED_ROW_CNT_DISP := to_char( :P3141_PROCESSED_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'end;'))
,p_attribute_03=>'P3141_LOAD_STATUS,P3141_PROCESSED_ROW_CNT,P3141_LOAD_ERROR,P3141_PROCESSED_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2658534748490483.4504)
,p_event_id=>wwv_flow_api.id(2657037056490480.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_table_exists boolean := false;',
'    l_context wwv_flow_exec.t_context;',
'    q varchar2(32767);',
'begin',
'    if :P3141_LOAD_STATUS in (''FAILED'', ''FINISHED'' ) then',
'        if :P3141_LOAD_TO = ''NEW'' then',
'            for l_table in (',
'                select table_name',
'                from sys.dba_tables',
'                where table_name = :P3140_NEW_TABLE_NAME',
'                and owner = :P3140_SCHEMA )',
'            loop',
'                :P3141_TABLE_CREATED := ''Y'';',
'            end loop;',
'        end if;',
'        ',
'        for l_table in (',
'            select table_name',
'            from sys.dba_tables',
'            where table_name = :P3140_ERROR_TABLE_NAME',
'            and owner = :P3140_SCHEMA )',
'        loop',
'            l_error_table_exists := true;',
'        end loop;',
'        ',
'        q := ''with'';',
'        q := q||'' success_data as (select count(*) as cnt from ''||',
'             wwv_flow_assert.enquote_name(',
'                 case when :P3141_LOAD_TO = ''NEW'' then',
'                     :P3140_NEW_TABLE_NAME',
'                 when :P3141_LOAD_TO = ''EXISTING'' then',
'                     :P3140_EXISTING_TABLE_NAME',
'                 end )',
'                 || '')'';',
'        if l_error_table_exists then',
'            q := q||'', failed_data as (select count(*) as cnt from ''||wwv_flow_assert.enquote_name( :P3140_ERROR_TABLE_NAME ) || '')'';',
'        end if;',
'        q := q||'' select s.cnt as success_count'';',
'        if l_error_table_exists then',
'            q := q||'', e.cnt as error_count'';',
'        end if;',
'        q:=q||'' from'';',
'        q:=q||'' success_data s'';',
'        if l_error_table_exists then',
'            q:=q||'', failed_data e'';',
'        end if;',
'     ',
'        wwv_flow_exec.open_query_context(',
'            p_context     => l_context,',
'            p_location    => wwv_flow_exec_api.c_location_local_db,',
'            p_query_type  => wwv_flow_exec_api.c_query_type_sql_query,',
'            p_sql_query   => q,',
'            p_parse_as_schema_override => :P3140_SCHEMA );',
'            ',
'        if wwv_flow_exec.next_row( p_context => l_context ) then',
'            :P3141_GOOD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 1 );',
'            if l_error_table_exists then',
'                :P3141_BAD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 2 );',
'            else',
'                :P3141_BAD_ROW_CNT := 0;',
'            end if;',
'        end if;',
'        ',
'        if :P3141_LOAD_TO = ''EXISTING'' then',
'            :P3141_GOOD_ROW_CNT := :P3141_PROCESSED_ROW_CNT - :P3141_BAD_ROW_CNT;',
'        end if;',
'        ',
'        :P3141_GOOD_ROW_CNT_DISP := to_char( :P3141_GOOD_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'        :P3141_BAD_ROW_CNT_DISP  := to_char( :P3141_BAD_ROW_CNT,  ''999G999G999G999G999G999G990'' );',
'        ',
'        wwv_flow_exec.close_context( p_context => l_context );',
'    end if;',
'exception ',
'    when others then',
'        wwv_flow_exec.close_context( p_context => l_context );',
'        raise;',
'end;'))
,p_attribute_03=>'P3141_GOOD_ROW_CNT,P3141_BAD_ROW_CNT,P3141_TABLE_CREATED,P3141_TAB_OBJ_ID,P3141_GOOD_ROW_CNT_DISP,P3141_BAD_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2907517723173325.4504)
,p_name=>'confirm drop tables'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2907407723173324.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2907674238173326.4504)
,p_event_id=>wwv_flow_api.id(2907517723173325.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Si \00E8 certi di voler eliminare le tabelle &P3141_TABLE_NAME. e &P3140_ERROR_TABLE_NAME. create dal caricamento dei dati?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2907796467173327.4504)
,p_event_id=>wwv_flow_api.id(2907517723173325.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DROP_TABLE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2654816541490476.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'drop table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_drop1 sys.dbms_sql.varchar2a;',
'    l_drop2 sys.dbms_sql.varchar2a;',
'begin',
'    l_drop1(1) := ''drop table ''||wwv_flow_assert.enquote_name(:P3141_TABLE_NAME);',
'    l_drop2(1) := ''drop table ''||wwv_flow_assert.enquote_name(:P3140_ERROR_TABLE_NAME);',
'    ',
'    wwv_flow_dynamic_exec.run_ddl (',
'        p_sql  => l_drop1,',
'        p_user => :P3140_SCHEMA );',
'   ',
'   wwv_flow_dynamic_exec.run_ddl (',
'        p_sql  => l_drop2,',
'        p_user => :P3140_SCHEMA );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2907407723173324.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2875531313080406.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Object ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_object in (',
'    select object_id, object_name',
'    from sys.dba_objects',
'    where object_name in (:P3140_NEW_TABLE_NAME, :P3140_EXISTING_TABLE_NAME, :P3140_ERROR_TABLE_NAME)',
'    and owner = :P3140_SCHEMA )',
'loop',
'    if l_object.object_name = :P3140_NEW_TABLE_NAME and :P3141_LOAD_TO = ''NEW'' then',
'        :P3141_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3140_EXISTING_TABLE_NAME and :P3141_LOAD_TO = ''EXISTING'' then',
'        :P3141_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3140_ERROR_TABLE_NAME then',
'        :P3141_ERR_TAB_OBJ_ID := l_object.object_id;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_03142
begin
wwv_flow_api.create_page(
 p_id=>3142.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Mappa colonne'
,p_page_mode=>'MODAL'
,p_step_title=>'Mappa colonne'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( function () {',
'',
'    var checkboxes$ = $( ''input[name=f01]'' ),',
'        checkAll$   = $( ''#toggle-select-all-columns'' );',
'',
'    var checkAllState = function(){',
'        checkAll$.prop( ''checked'', checkboxes$.length === $( ''input[name=f01]:checked'' ).length );',
'    };',
'',
'    checkboxes$.on( ''click'', function () {',
'        var that$ = $( this ),',
'            colId = getColId( that$.val() ),',
'            isChecked = that$.prop( ''checked'' );',
'',
'        toggleCol( colId, isChecked );',
'',
'        checkAllState();',
'    });',
'',
'    checkAll$.on( ''click'', function () {',
'        var isAllChecked = checkAll$.is( '':checked'' );',
'',
'        checkboxes$',
'            .prop( ''checked'', isAllChecked )',
'            .each(function(){',
'                var cb$ = $( this );',
'                toggleCol( getColId( cb$.val() ), cb$.prop( ''checked'' ) );  ',
'            });',
'    });',
'',
'    // init check state on load',
'    checkAllState();',
'})();'))
,p_step_template=>wwv_flow_api.id(690782249755803171.4504)
,p_page_css_classes=>'a-Page--DataLoadPreview'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
,p_dialog_height=>'768'
,p_dialog_width=>'1024'
,p_dialog_chained=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6668055717333270.4504)
,p_plug_name=>'RDS'
,p_region_name=>'preview_selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6868328816150601.4504)
,p_plug_name=>'Pulsanti'
,p_region_css_classes=>'u-tC'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22889361361921168.4504)
,p_name=>'Colonne da caricare'
,p_region_name=>'tab_columns'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'a-DataLoad-previewColumns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ',
'    l_columns as (',
'        select ',
'            fc.column_position,    ',
'            fc.column_name , ',
'            regexp_replace( fc.data_type, ''\(\d+\)'','''') data_type,',
'            case when substr( fc.data_type, 1, 8 ) = ''VARCHAR2''',
'               then replace( substr( fc.data_type, 10 ), '')'' )',
'               else null',
'            end as max_length,',
'            fc.format_mask,',
'            fc.detected_group_char group_char,',
'            fc.detected_decimal_char decimal_char',
'        from wwv_flow_collections c,',
'             table( wwv_flow_data_parser.get_columns( c.clob001 ) ) fc',
'        where c.collection_name =''APEX$DATALOAD'' ),',
'    l_config_columns as (',
'        select',
'            to_number(s.c001) column_position,',
'            s.c002 column_name,',
'            s.c003 format_mask,',
'            s.c004 group_char,',
'            s.c005 decimal_char,',
'            s.c006 data_type,',
'            s.c007 max_length',
'        from wwv_flow_collections s',
'        where collection_name = ''APEX$DATALOAD_COLUMNS'' )',
'select',
'    c.column_position,',
'    apex_item.hidden(',
'        p_idx            => 6,',
'        p_value          => c.column_position )||',
'    apex_item.hidden(',
'        p_idx            => 2,',
'        p_value          => c.column_name )||',
'    apex_item.checkbox2(',
'        p_idx            => 1,',
'        p_value          => c.column_position,',
'        p_attributes     => ''aria-label="Select Row: ''||wwv_flow_escape.html_attribute(c.column_name)||''"'',',
'        p_checked_values => cf.column_position ) as select_column,   ',
'    c.column_name,',
'    case when cf.data_type = ''CLOB'' then',
'        apex_item.display_and_save(',
'            p_idx            => 7,',
'            p_value          => cf.data_type,',
'            p_item_label     => wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name)) )',
'    else',
'        apex_item.select_list_from_lov(',
'            p_idx            => 7,',
'            p_value          => cf.data_type,',
'            p_lov            => ''DATA.LOAD.DATA_TYPES'',',
'            p_show_null      => ''NO'',',
'            p_show_extra     => ''NO'',',
'            p_attributes     => case when cf.data_type = ''CLOB'' then ''disabled '' end ||',
'                                ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as data_type,',
'    apex_item.text(',
'        p_idx            => 8,',
'        p_value          => cf.max_length,',
'        p_size           => 5,',
'        p_maxLength      => 5,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as max_length,',
'    apex_item.text(',
'        p_idx            => 3,',
'        p_value          => cf.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    apex_item.text(',
'        p_idx            => 4,',
'        p_value          => cf.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    apex_item.text(',
'        p_idx            => 5,',
'        p_value          => cf.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c, l_config_columns cf',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'and  c.column_position = cf.column_position (+)',
'union',
'select',
'    c.column_position,',
'    apex_item.hidden(',
'        p_idx            => 6,',
'        p_value          => c.column_position )||',
'    apex_item.hidden(',
'        p_idx            => 2,',
'        p_value          => c.column_name )||',
'    apex_item.checkbox2(',
'        p_idx            => 1,',
'        p_value          => c.column_position,',
'        p_attributes     => ''aria-label="Select Row: ''||wwv_flow_escape.html_attribute(c.column_name)||''"'',',
'        p_checked_values => c.column_position ) as select_column,    ',
'    c.column_name, ',
'    case when c.data_type = ''CLOB'' then',
'        apex_item.display_and_save(',
'            p_idx            => 7,',
'            p_value          => c.data_type,',
'            p_item_label     => wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name)) )',
'    else',
'        apex_item.select_list_from_lov(',
'            p_idx            => 7,',
'            p_value          => c.data_type,',
'            p_lov            => ''DATA.LOAD.DATA_TYPES'',',
'            p_show_null      => ''NO'',',
'            p_show_extra     => ''NO'',',
'            p_attributes     => ( case when c.data_type = ''CLOB'' then ''disabled '' end )||',
'                                ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as data_type,',
'    apex_item.text(',
'        p_idx            => 8,',
'        p_value          => c.max_length,',
'        p_size           => 5,',
'        p_maxLength      => 5,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as max_length,',
'    apex_item.text(',
'        p_idx            => 3,',
'        p_value          => c.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    apex_item.text(',
'        p_idx            => 4,',
'        p_value          => c.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    apex_item.text(',
'        p_idx            => 5,',
'        p_value          => c.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0',
'order by 1'))
,p_display_when_condition=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''NEW'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna colonna trovata.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2727769881566586.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>53
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2728100161566587.4504)
,p_query_column_id=>2
,p_column_alias=>'SELECT_COLUMN'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" id="toggle-select-all-columns">'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2728556072566588.4504)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nome colonna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2728971934566589.4504)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo dati'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(94755936775727903.4504)
,p_query_column_id=>5
,p_column_alias=>'MAX_LENGTH'
,p_column_display_sequence=>13
,p_column_heading=>'Lunghezza massima'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2729373220566589.4504)
,p_query_column_id=>6
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>23
,p_column_heading=>'Formato di visualizzazione'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2729724797566590.4504)
,p_query_column_id=>7
,p_column_alias=>'GROUP_CHAR'
,p_column_display_sequence=>33
,p_column_heading=>'Separatore di gruppo'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2730157525566590.4504)
,p_query_column_id=>8
,p_column_alias=>'DECIMAL_CHAR'
,p_column_display_sequence=>43
,p_column_heading=>'Carattere decimale'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35910098832413211.4504)
,p_plug_name=>'Settings Item Container'
,p_region_css_classes=>'a-ButtonRegion--DataLoadPreview'
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(196066593863714146.4504)
,p_name=>'Mapping colonne'
,p_region_name=>'tab_columns'
,p_template=>wwv_flow_api.id(385770331595976651.4504)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'a-DataLoad-previewColumns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'l_msg as (',
'    select wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.UNMAPPED'') unmapped',
'      from sys.dual)',
', l_columns as (',
'    select ',
'        fc.column_position,    ',
'        fc.column_name,',
'            ( select tc.column_name ',
'              from sys.dba_tab_columns tc',
'              where tc.owner = :P3140_SCHEMA',
'              and tc.table_name = :P3140_EXISTING_TABLE_NAME',
'              and tc.column_name = fc.column_name )',
'        map_column_name,',
'        fc.data_type, ',
'        fc.format_mask,',
'        fc.detected_group_char group_char,',
'        fc.detected_decimal_char decimal_char',
'    from wwv_flow_collections c,',
'         table( wwv_flow_data_parser.get_columns( c.clob001 ) ) fc',
'    where c.collection_name =''APEX$DATALOAD'' )',
', l_sum_existing_tab_col as (',
'    select sum( length( ''<option value="''|| column_name ||''">''|| column_name ||'' (''|| data_type ||'')</option>'' ) ) total_length',
'    from sys.dba_tab_columns tc',
'    where tc.owner = :P3140_SCHEMA',
'    and tc.table_name = :P3140_EXISTING_TABLE_NAME )',
'select',
'    c.column_position,',
'    c.column_name,',
'    c.data_type,',
'    apex_item.hidden(',
'        p_idx            => 1,',
'        p_value          => c.column_name)||',
'    case when tc.total_length <= 3900 then',
'        apex_item.select_list_from_lov(',
'            p_idx            => 2,',
'            p_value          => m.c002,',
'            p_lov            => ''P3142_TABLE_COLUMNS'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_show_extra     => ''NO'')',
'    else',
'        -- bug 30464422 fix, show popup if total existing table column option  > 3900 to avoid error',
'        wwv_flow_item.popup_from_lov(',
'            p_idx            => 2,',
'            p_value          => m.c002,',
'            p_lov_name       => ''P3142_TABLE_COLUMNS'',',
'            p_width          => 40,',
'            p_show_null      => ''YES'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped )',
'    end as column_map,',
'    apex_item.text(',
'        p_idx            => 3,',
'        p_value          => m.c003,',
'        p_size           => 20,',
'        p_maxLength      => 1000 ) as format_mask,',
'    apex_item.text(',
'        p_idx            => 4,',
'        p_value          => m.c004,',
'        p_size           => 2,',
'        p_maxLength      => 2 ) as group_char,',
'    apex_item.text(',
'        p_idx            => 5,',
'        p_value          => m.c005,',
'        p_size           => 2,',
'        p_maxLength      => 2 ) as decimal_char',
'from l_columns c, l_sum_existing_tab_col tc, l_msg msg, wwv_flow_collections m',
'where c.column_name = m.c001 (+)',
'and wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'union',
'select',
'    c.column_position,',
'    c.column_name,',
'    c.data_type, ',
'    apex_item.hidden(',
'        p_idx            => 1,',
'        p_value          => c.column_name)||',
'    case when tc.total_length <= 3900 then',
'        apex_item.select_list_from_lov(',
'            p_idx            => 2,',
'            p_value          => c.map_column_name,',
'            p_lov            => ''P3142_TABLE_COLUMNS'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_show_extra     => ''NO'')',
'    else',
'        -- bug 30464422 fix, show popup if total existing table column option  > 3900 to avoid error ',
'        wwv_flow_item.popup_from_lov(',
'            p_idx            => 2,',
'            p_value          => c.map_column_name,',
'            p_lov_name       => ''P3142_TABLE_COLUMNS'',',
'            p_width          => 40,',
'            p_show_null      => ''YES'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped )',
'    end as column_map,',
'    apex_item.text(',
'        p_idx            => 3,',
'        p_value          => c.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000 ) as format_mask,',
'    apex_item.text(',
'        p_idx            => 4,',
'        p_value          => c.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2 ) as group_char,',
'    apex_item.text(',
'        p_idx            => 5,',
'        p_value          => c.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2 ) as decimal_char        ',
'from l_columns c, l_msg msg, l_sum_existing_tab_col tc',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0',
'order by 1',
''))
,p_display_when_condition=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Nessuna colonna trovata.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2781051602566683.4504)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2781426044566686.4504)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Colonna di origine'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2781826747566687.4504)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo dati'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2782213212566687.4504)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_MAP'
,p_column_display_sequence=>4
,p_column_heading=>'Mappa a'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2782645018566688.4504)
,p_query_column_id=>5
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>5
,p_column_heading=>'Formato di visualizzazione'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2783080218566689.4504)
,p_query_column_id=>6
,p_column_alias=>'GROUP_CHAR'
,p_column_display_sequence=>6
,p_column_heading=>'Separatore di gruppo'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2783473349566689.4504)
,p_query_column_id=>7
,p_column_alias=>'DECIMAL_CHAR'
,p_column_display_sequence=>7
,p_column_heading=>'Carattere decimale'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2726636014566580.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(6868328816150601.4504)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Salva modifiche'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2727070542566581.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6868328816150601.4504)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Chiudi finestra di dialogo'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2739158268566606.4504)
,p_name=>'P3142_ACTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(35910098832413211.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Used for default tab selection on page load'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2784349989566715.4504)
,p_validation_name=>'must at least select one column'
,p_validation_sequence=>10
,p_validation=>'apex_application.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Selezionare almeno una colonna da caricare.'
,p_when_button_pressed=>wwv_flow_api.id(2726636014566580.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(81742847338478602.4504)
,p_validation_name=>'check group and decimal char'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_load_to      varchar2(10);',
'    ',
'    l_group_char   varchar2(4);',
'    l_decimal_char varchar2(4);',
'    l_column_name  varchar2(128);',
'    l_error_msg    varchar2(4000);',
'',
'    function validate_group_decimal_char',
'    return varchar2',
'    is',
'        l_msg varchar2(4000);',
'    begin',
'        -- if group separator defined, decimal character must be defined',
'        if l_group_char is not null then',
'            if l_decimal_char is null then',
'                l_msg := wwv_flow_lang.system_message( ',
'                            ''DATA_LOAD.DECIMAL_CHAR_REQUIRED'',',
'                            l_column_name );',
'            end if;',
'        end if;',
'',
'        -- group and decimal chars cannot be same',
'        if l_group_char = l_decimal_char then',
'            l_msg := wwv_flow_lang.system_message(',
'                         ''DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'',',
'                         l_column_name );',
'        end if;',
'        ',
'        return l_msg;',
'    end validate_group_decimal_char;',
'begin',
'    l_load_to := coalesce( :P3140_LOAD_TO, ''NEW'');',
'',
'    if l_load_to = ''NEW'' then',
'        -- loop through all column postions',
'        for i in 1 .. wwv_flow.g_f06.count',
'        loop',
'            for j in 1 .. wwv_flow.g_f01.count',
'            loop',
'                -- if column checked to load, validate',
'                if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'                    l_column_name  := wwv_flow.g_f02( i );',
'                    l_group_char   := wwv_flow.g_f04( i );',
'                    l_decimal_char := wwv_flow.g_f05( i );',
'',
'                    l_error_msg := validate_group_decimal_char;',
'                    if l_error_msg is not null then',
'                        return l_error_msg;',
'                    end if;',
'',
'                    exit;',
'                end if;',
'            end loop;',
'        end loop;',
'    elsif l_load_to= ''EXISTING'' then',
'        for i in 1 .. wwv_flow.g_f02.count',
'        loop',
'            -- if column mapped, check group and decimal char',
'            if wwv_flow.g_f02(i) is not null then',
'                l_column_name  := wwv_flow.g_f02( i );',
'                l_group_char   := wwv_flow.g_f04( i );',
'                l_decimal_char := wwv_flow.g_f05( i );',
'',
'                l_error_msg := validate_group_decimal_char;',
'                if l_error_msg is not null then',
'                    return l_error_msg;',
'                end if;',
'            end if;',
'        end loop;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(285737408143666602.4504)
,p_validation_name=>'table columns not mapped multiple times'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_names  wwv_flow_global.vc_map;',
'    l_col_name_idx  pls_integer;',
'begin',
'    l_col_name_idx := wwv_flow.g_f02.first;',
'    while l_col_name_idx is not null loop',
'        if wwv_flow.g_f02( l_col_name_idx ) is not null then',
'            if l_column_names.exists( wwv_flow.g_f02( l_col_name_idx ) ) then',
'                return wwv_flow_lang.system_message ( ''DATA_LOAD.DUPLICATE_MAPPING'', wwv_flow.g_f02( l_col_name_idx ) );',
'            else',
'                l_column_names( wwv_flow.g_f02( l_col_name_idx ) ) := null;',
'            end if;',
'        end if;',
'',
'        l_col_name_idx := wwv_flow.g_f02.next( l_col_name_idx );',
'    end loop;',
'    return null;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2726636014566580.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(742452908834169229.4504)
,p_validation_name=>'check max length'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_type    wwv_flow_global.t_dbms_id;',
'    l_max_length   number;',
'begin',
'    ',
'    -- loop through all column postions',
'    for i in 1 .. wwv_flow.g_f06.count',
'    loop',
'',
'        for j in 1 .. wwv_flow.g_f01.count',
'        loop',
'            -- if column checked to load, validate',
'            if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'',
'                l_data_type  := wwv_flow.g_f07( i );',
'',
'                begin',
'                    l_max_length := to_number( wwv_flow.g_f08( i ) );',
'                exception when others then',
'                    if l_data_type = ''VARCHAR2'' then',
'                        -- if not number, validation fails',
'                        return false;',
'                    end if;',
'                end;',
'',
'                if l_data_type = ''VARCHAR2'' then',
'                    -- if null, validation fails',
'                    if l_max_length is null then',
'                        return false;',
'                    else',
'                        -- varchar2 data type max length must be between 1 and allowed max varchar2 size',
'                        if l_max_length < 1 or ',
'                           l_max_length > case when wwv_flow_db_version.c_has_extended_string_size then 32767 else 4000 end',
'                        then',
'                            return false;',
'                        end if;',
'                    end if;',
'                end if;',
'',
'                exit;',
'            end if;',
'        end loop;',
'    end loop;',
'',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La lunghezza massima \00E8 obbligatoria per le colonne VARCHAR2 e deve essere un numero compreso tra 1 e la dimensione massima consentita di VARCHAR2.')
,p_validation_condition=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(2726636014566580.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2787543165566721.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2727070542566581.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2788053295566721.4504)
,p_event_id=>wwv_flow_api.id(2787543165566721.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2789336626566722.4504)
,p_name=>'Save Settings'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2726636014566580.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2790329219566723.4504)
,p_event_id=>wwv_flow_api.id(2789336626566722.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2785097988566716.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New Table - Save Column Load Checkbox'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile        clob;',
'    l_col_selected      boolean := false;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'     -- loop through all column postions',
'    for i in 1 .. wwv_flow.g_f06.count',
'    loop',
'        ',
'        for j in 1 .. wwv_flow.g_f01.count',
'        loop',
'            -- if column checked to load, save the column configuration',
'            if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'',
'                wwv_flow_collection.add_member(',
'                    p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'                    p_c001            => wwv_flow.g_f06( i ), -- column position',
'                    p_c002            => wwv_flow.g_f02( i ), -- column name',
'                    p_c003            => wwv_flow.g_f03( i ), -- format mask',
'                    p_c004            => wwv_flow.g_f04( i ), -- group char',
'                    p_c005            => wwv_flow.g_f05( i ), -- decimal char',
'                    p_c006            => wwv_flow.g_f07( i ), -- column type',
'                    p_c007            => case when wwv_flow.g_f07( i ) = ''VARCHAR2'' then wwv_flow.g_f08( i ) end  -- max length',
'                    );',
'',
'                exit;',
'            end if;',
'        end loop;',
'    end loop;',
'        ',
'    select clob001',
'    into l_profile ',
'    from wwv_flow_collections ',
'    where collection_name = ''APEX$DATALOAD'' ',
'    and rownum = 1;',
'    ',
'    for i in (',
'        select column_position, column_name',
'        from table( wwv_flow_data_parser.get_columns( l_profile ) ) c ) ',
'    loop',
'        if wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0 then',
'            l_col_selected := true;',
'        else',
'            l_col_selected := false;',
'            for l_select_col in (',
'                select c001 idx ',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS'' )',
'            loop',
'                begin',
'                    if to_number( l_select_col.idx ) = i.column_position then',
'                        l_col_selected := true;',
'                        exit;',
'                    end if;',
'                exception when invalid_number then null; ',
'                end;',
'            end loop;',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2726636014566580.4504)
,p_process_when=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2785856127566718.4504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Existing Table - Save Column Mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_map    wwv_flow_global.vc_map := wwv_flow_global.c_empty_vc_map;',
'begin    ',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    wwv_flow_collection.add_members(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'        p_c001            => wwv_flow.g_f01,  -- column_name',
'        p_c002            => wwv_flow.g_f02,  -- mapped column',
'        p_c003            => wwv_flow.g_f03,  -- format mask',
'        p_c004            => wwv_flow.g_f04,  -- group char',
'        p_c005            => wwv_flow.g_f05   -- decimal char           ',
'        );',
'    ',
'    -- get column mapping user configured',
'    for l_configure in (',
'        select',
'            c001   column_name,',
'            c002   mapped_column',
'        from wwv_flow_collections',
'        where collection_name = ''APEX$DATALOAD_COLUMNS''',
'        and c002 is not null )',
'    loop',
'        l_column_map( l_configure.column_name ) := l_configure.mapped_column;',
'    end loop;',
'    ',
'    :P3140_MAPPED_COLUMN_COUNT := l_column_map.count;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2726636014566580.4504)
,p_process_when=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2785467859566717.4504)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2726636014566580.4504)
);
end;
/
prompt --application/pages/page_03150
begin
wwv_flow_api.create_page(
 p_id=>3150.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica dati nella raccolta SODA'
,p_page_mode=>'MODAL'
,p_step_title=>'Carica dati nella raccolta SODA'
,p_autocomplete_on_off=>'OFF'
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
,p_dialog_height=>'720'
,p_dialog_width=>'1024'
,p_dialog_attributes=>'resisable:true'
,p_dialog_css_classes=>'a-Page--DataLoad &P3150_BODY_CLASS.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3201665929656810.4504)
,p_plug_name=>'Carica in raccolta SODA'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P3150_FILE_NAME is not null and :P3150_VALID_FILE = 1'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3203099837656824.4504)
,p_plug_name=>unistr('Propriet\00E0 JSON')
,p_parent_plug_id=>wwv_flow_api.id(3201665929656810.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3203189517656825.4504)
,p_plug_name=>unistr('Propriet\00E0 comuni')
,p_parent_plug_id=>wwv_flow_api.id(3201665929656810.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3203367147656827.4504)
,p_plug_name=>unistr('Propriet\00E0 ZIP')
,p_parent_plug_id=>wwv_flow_api.id(3201665929656810.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P3150_FILE_NAME like ''%.zip'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3201917616656813.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3150_FILE_NAME'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3366342740004636.4504)
,p_plug_name=>'Caricato file non valido.'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>15
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Il file caricato non \00E8 valido. In una raccolta SODA \00E8 possibile caricare solo i file ZIP o JSON.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P3150_FILE_NAME is not null and :P3150_VALID_FILE = 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3620884258294383.4504)
,p_plug_name=>'File'
,p_region_name=>'drag_drop_file'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_soda_dev.has_soda_role( :P3150_SCHEMA )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3624431708294418.4504)
,p_plug_name=>'File caricato'
,p_region_name=>'load_completed'
,p_parent_plug_id=>wwv_flow_api.id(3620884258294383.4504)
,p_region_css_classes=>'a-FileDrop'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-item-group apex-item-group--file upload-completed">',
'  <div class="apex-item-file-dropzone" aria-hidden="true">',
'    <span class="a-FileDrop-icon"><span class="a-Icon a-Icon--large icon-ig-dl-xls" aria-hidden="true"></span></span>',
'    <span class="a-FileDrop-label">&P3150_FILE_NAME. - &P3150_FILE_SIZE.</span>',
'  </div>',
'</div>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3150_FILE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(74476252882949639.4504)
,p_plug_name=>'Ruolo database SODA_APP obbligatorio'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Allo schema &P3150_SCHEMA!HTML. non \00E8 stato concesso il ruolo <strong>SODA_APP</strong>. Rivolgersi all''amministratore del database per ottenere il ruolo utilizzando il comando SQL seguente:'),
'<pre>',
'grant SODA_APP to &P3150_SCHEMA!HTML.;',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_soda_dev.has_soda_role( :P3150_SCHEMA )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3201857722656812.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3201917616656813.4504)
,p_button_name=>'LOAD_DATA'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Carica dati'
,p_button_position=>'NEXT'
,p_button_condition=>'P3150_VALID_FILE'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3203898791656832.4504)
,p_branch_action=>'f?p=&APP_ID.:3151:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3201857722656812.4504)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3201555224656809.4504)
,p_branch_name=>'Go To Page 3150'
,p_branch_action=>'f?p=&APP_ID.:3150:&SESSION.:UPLOAD_FILE:&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2000935408459793.4504)
,p_name=>'P3150_FILE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3620884258294383.4504)
,p_prompt=>'Carica file'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_display_when=>'P3150_FILE'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(717397144393801382.4504)
,p_item_css_classes=>'a-FileDrop data-load-input'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_12=>'NATIVE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2001672117459798.4504)
,p_name=>'P3150_FILE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3624431708294418.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3201781556656811.4504)
,p_name=>'P3150_NEW_COLL_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_prompt=>'Nome raccolta SODA'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Fornire un nome per la nuova raccolta SODA. Sono supportati solo i nomi in maiuscolo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3202062879656814.4504)
,p_name=>'P3150_SCHEMA'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3202231086656816.4504)
,p_name=>'P3150_LOAD_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_item_default=>'NEW'
,p_prompt=>'Carica in'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:New Collection;NEW,Existing Collection;EXISTING'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Decidere se eseguire il caricamento in una raccolta SODA nuova o esistente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3202383555656817.4504)
,p_name=>'P3150_EXISTING_COLL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_prompt=>'Raccolta SODA esistente'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_soda_dev.get_soda_collections( p_schema => :P3150_SCHEMA ) ) c, sys.dba_tables t',
' where c.column_value = t.table_name',
'   and t.owner = :P3150_SCHEMA'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleziona -'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Scegliere una raccolta SODA esistente in cui caricare i dati.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3202996934656823.4504)
,p_name=>'P3150_RELATIONAL_VIEW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_prompt=>' Nome vista relazionale'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se \00E8 stato fornito il nome di una vista relazionale, APEX utilizzer\00E0 la funzione <em>Guida dati</em> per generare una vista relazionale sopra la raccolta SODA. La vista relazionale pu\00F2 quindi essere usata per creare un''applicazione.'),
'Sono supportati solo i nomi in maiuscolo.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3203272647656826.4504)
,p_name=>'P3150_ROW_SELECTOR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3203099837656824.4504)
,p_prompt=>'Selettore JSON'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3150_FILE_NAME like ''%.js'' or ',
':P3150_FILE_NAME like ''%.json'' or',
':P3150_FILE_NAME like ''%.geojson'''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Fornire un <em>selettore JSON</em> che punta a un array nel file JSON caricato. Ogni oggetto JSON all''interno dell''array verr\00E0 caricato come documento JSON nella raccolta SODA.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3203588428656829.4504)
,p_name=>'P3150_LOAD_NON_JSON'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3203367147656827.4504)
,p_item_default=>'N'
,p_prompt=>'Carica file non JSON'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'not wwv_flow_soda_dev.is_ajd_service'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se l''opzione \00E8 abilitata, nella raccolta verranno caricati anche i file non JSON. Tenere presente che Guida dati non \00E8 disponibile per le raccolte con documenti non JSON.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3203988702656833.4504)
,p_name=>'P3150_LOAD_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3204339623656837.4504)
,p_name=>'P3150_CALLED_FROM'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3366429158004637.4504)
,p_name=>'P3150_VALID_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3366342740004636.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3366672810004639.4504)
,p_name=>'P3150_CONVERT_XML_FILES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3203367147656827.4504)
,p_item_default=>'Y'
,p_prompt=>'Converti file XML in JSON'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se l''opzione \00E8 abilitata, i file XML all''interno dell''archivio ZIP verranno convertiti in JSON prima del caricamento nella raccolta.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12343242850853111.4504)
,p_name=>'P3150_BODY_CLASS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12343878072853117.4504)
,p_name=>'P3150_APPEND_METHOD'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_item_default=>'APPEND'
,p_prompt=>'Aggiorna metodo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Append;APPEND,Replace;REPLACE'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>Aggiungi</strong>: se nella raccolta sono gi\00E0 presenti dei dati, la procedura guidata aggiunge i nuovi documenti alla raccolta. Se i dati non sono presenti, i nuovi documenti vengono semplicemente caricati.</li>'),
'    <li><strong>Sostituisci</strong>: viene sostituita l''intera raccolta eliminando prima i dati e poi caricando i nuovi documenti.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12343949010853118.4504)
,p_name=>'P3150_AUTO_DETECT_SELECTOR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3203099837656824.4504)
,p_item_default=>'Y'
,p_prompt=>'Tipo di selettore JSON'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Auto-Detect;Y,Custom;N,Linefeed (JSON List);CR'
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3150_FILE_NAME like ''%.js'' or ',
':P3150_FILE_NAME like ''%.json'' or',
':P3150_FILE_NAME like ''%.txt'' or',
':P3150_FILE_NAME like ''%.geojson'''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_read_only_when=>':P3150_FILE_NAME like ''%.txt'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specificare come estrarre i documenti JSON dal file caricato</p>.',
'<ul>',
unistr('    <li><strong>Rileva automaticamente</strong> richiede che il file caricato sia un <em>documento JSON valido</em>. APEX cercher\00E0 il primo array JSON all''interno del file caricato e caricher\00E0 nella raccolta SODA ogni oggetto JSON presente nell''array')
||' come documento.</li>',
unistr('    <li><strong>Personalizzato</strong> richiede che il file caricato sia un <em>documento JSON valido</em>. APEX utilizzer\00E0 il <strong>selettore JSON</strong> fornito dall''utente per fare riferimento a un array JSON all''interno del file caricato e c')
||unistr('aricher\00E0 nella raccolta SODA ogni oggetto JSON presente nell''array come documento.</li>'),
unistr('    <li><strong>Linefeed (lista JSON)</strong> richiede un file contenente pi\00F9 documenti JSON, ognuno disposto su un''unica riga e separato da avanzamenti riga. Questo tipo di caricamento JSON supporta singoli documenti JSON (lunghezza riga) fino a 32')
||'.767 byte.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74473851856949615.4504)
,p_name=>'P3150_CREATE_RELATONAL_VIEW'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_item_default=>'case when :P3150_LOAD_TO = ''NEW'' then ''Y'' else ''N'' end'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Crea vista relazionale'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se l''opzione \00E8 abilitata ed \00E8 stato fornito il nome della vista relazionale, APEX utilizzer\00E0 la funzione <em>Guida dati</em> per generare una vista relazionale sopra la raccolta SODA. La vista relazionale pu\00F2 quindi essere usata per creare un''applica')
||'zione.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74474500551949622.4504)
,p_name=>'P3150_FILE_SIZE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3624431708294418.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74477333881949650.4504)
,p_name=>'P3150_SKIP_NON_JSON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3203189517656825.4504)
,p_item_default=>'N'
,p_prompt=>'Salta righe non valide'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>':P3150_FILE_NAME not like ''%.zip'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se abilitata, le righe che contengono documenti JSON non validi verranno saltate. Se disabilitata, verr\00E0 richiamato un errore.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(190994948754372717.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3150_NEW_COLL_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P3150_NEW_COLL_NAME)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(190995069615372718.4504)
,p_computation_sequence=>20
,p_computation_item=>'P3150_RELATIONAL_VIEW'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P3150_CREATE_RELATONAL_VIEW = ''Y'' then upper(:P3150_RELATIONAL_VIEW) end'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3202107511656815.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3150_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce( :P3150_SCHEMA, wwv_flow_user_api.get_default_schema)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(12343145548853110.4504)
,p_computation_sequence=>20
,p_computation_item=>'P3150_FILE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'  from wwv_flow_temp_files',
' where name = :P3150_FILE',
' '))
,p_compute_when=>'P3150_FILE'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(74474799740949624.4504)
,p_computation_sequence=>30
,p_computation_item=>'P3150_FILE_SIZE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_util.filesize_mask( sys.dbms_lob.getlength( blob_content ))',
'  from wwv_flow_temp_files',
' where name = :P3150_FILE',
' '))
,p_compute_when=>'P3150_FILE'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3366588398004638.4504)
,p_computation_sequence=>40
,p_computation_item=>'P3150_VALID_FILE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when substr(lower(:P3150_FILE), instr( :P3150_FILE, ''.'', -1)) in (''.js'',''.json'',''.geojson'',''.zip'', ''.xml'', ''.txt'') then 1 else 0 end'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74473780110949614.4504)
,p_validation_name=>'Check Schema Access'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_sw_api.check_priv(:P3150_SCHEMA);',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Violazione di accesso allo schema.'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(.4504)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74474479047949621.4504)
,p_validation_name=>'Relational View Name NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P3150_RELATIONAL_VIEW'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>'P3150_CREATE_RELATONAL_VIEW'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3202996934656823.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12343454298853113.4504)
,p_validation_name=>'Relational View Name does not yet exist'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from sys.dba_views',
'where owner = :P3150_SCHEMA',
'and view_name = :P3150_RELATIONAL_VIEW'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Nome vista gi\00E0 in uso. Sceglierne un altro.')
,p_validation_condition=>'P3150_CREATE_RELATONAL_VIEW'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3202996934656823.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12343589142853114.4504)
,p_validation_name=>'New Collection Name NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P3150_NEW_COLL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3201781556656811.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(90119599628448644.4504)
,p_validation_name=>'New Relational View must not contain invalid chars'
,p_validation_sequence=>30
,p_validation=>'P3150_RELATIONAL_VIEW'
,p_validation2=>'#''&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# non deve contenere #, &, <, >, ", '', /, ;, *, |, =, % o il carattere ,.',
''))
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3202996934656823.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(90119437498448643.4504)
,p_validation_name=>'New Collection Name must not contain invalid chars'
,p_validation_sequence=>40
,p_validation=>'P3150_NEW_COLL_NAME'
,p_validation2=>'#''&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# non deve contenere #, &, <, >, ", '', /, ;, *, |, =, % o il carattere ,.',
''))
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3201781556656811.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(190993339913372701.4504)
,p_validation_name=>'New Collection Name does not exist'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from sys.dba_tables',
' where owner = :P3150_SCHEMA',
'   and table_name = :P3150_NEW_COLL_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Nome raccolta gi\00E0 in uso. Sceglierne un altro.')
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3201781556656811.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12343382475853112.4504)
,p_validation_name=>'New Collection Name does not exists -2-'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from table( wwv_flow_soda_dev.get_soda_collections( :P3150_SCHEMA ) )',
'where column_value = :P3150_NEW_COLL_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Una raccolta SODA "&P3150_NEW_COLL_NAME." esiste gi\00E0, ma non ha una tabella di memorizzazione.'),
'Eliminare la raccolta mediante DBMS_SODA.DROP_COLLECTION prima di procedere.'))
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3201781556656811.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12343783713853116.4504)
,p_validation_name=>'Existing Collection Name NOT NULL'
,p_validation_sequence=>100
,p_validation=>'P3150_EXISTING_COLL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Specificare un valore per #LABEL#.'
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3202383555656817.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74474843438949625.4504)
,p_validation_name=>'Existing Collection Name exists'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from sys.dba_tables',
'where owner = :P3150_SCHEMA',
'and table_name = :P3150_EXISTING_COLL_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>'La raccolta SODA &P3150_EXISTING_COLL_NAME!HTML. non esiste.'
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(3202383555656817.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74476155699949638.4504)
,p_validation_name=>'Is Valid JSON Document'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_json number;',
'begin',
'    select 1 ',
'      into l_is_json',
'      from apex_application_temp_files',
'     where name = :P3150_FILE',
'       and blob_content is json;',
'   ',
'    return true;',
'exception',
'    when no_data_found then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'I tipi di selettori JSON "Rileva automaticamente" e "Personalizzato" sono consentiti solo per i file JSON validi.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:P3150_FILE_NAME like ''%.js'' or ',
' :P3150_FILE_NAME like ''%.json'' or',
' :P3150_FILE_NAME like ''%.geojson'' ) and :P3150_AUTO_DETECT_SELECTOR in (''Y'', ''N'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(3201857722656812.4504)
,p_associated_item=>wwv_flow_api.id(12343949010853118.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2002976340479908.4504)
,p_name=>'Initialize UI'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2003341016479911.4504)
,p_event_id=>wwv_flow_api.id(2002976340479908.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Set drag and drop labels',
'apex.jQuery(''.apex-item-group--file:not(.upload-completed)'').append(''<span class="apex-item-file-dropzone"></span>'');',
'',
'var fileUpload$ = apex.jQuery(''.apex-item-group--file:not(.upload-completed) .apex-item-file-dropzone'');',
'',
'fileUpload$.append("<span class=''a-FileDrop-heading''>" + apex.lang.getMessage("DATA.LOAD.DRAG_DROP_FILE_HERE") + "</span> ");',
'fileUpload$.append("<span class=''a-FileDrop-action''>" + apex.lang.getMessage("DATA.LOAD.CHOOSE_FILE") + "</span> ");',
'fileUpload$.append("<span class=''a-FileDrop-formats''>" + apex.lang.getMessage("DATA.LOAD.SODA_FILE_FORMATS") + "</span>");'))
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2004492679513599.4504)
,p_name=>'Upload File'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_FILE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2004868624513600.4504)
,p_event_id=>wwv_flow_api.id(2004492679513599.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_DATA'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2005322890513600.4504)
,p_event_id=>wwv_flow_api.id(2004492679513599.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".apex-item-group--file").addClass("uploading");',
'apex.jQuery(".apex-item-file-dropzone").html("<span class=''a-DataLoad-progressMeter''></span>");'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2005885262513600.4504)
,p_event_id=>wwv_flow_api.id(2004492679513599.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_FILE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3202430226656818.4504)
,p_name=>'New Collection'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_LOAD_TO'
,p_condition_element=>'P3150_LOAD_TO'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3202522469656819.4504)
,p_event_id=>wwv_flow_api.id(3202430226656818.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_NEW_COLL_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3202829743656822.4504)
,p_event_id=>wwv_flow_api.id(3202430226656818.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_EXISTING_COLL_NAME,P3150_APPEND_METHOD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3202673691656820.4504)
,p_event_id=>wwv_flow_api.id(3202430226656818.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_EXISTING_COLL_NAME,P3150_APPEND_METHOD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3202762055656821.4504)
,p_event_id=>wwv_flow_api.id(3202430226656818.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_NEW_COLL_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(12344087306853119.4504)
,p_name=>'Auto Detect Row Selector'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_AUTO_DETECT_SELECTOR'
,p_condition_element=>'P3150_AUTO_DETECT_SELECTOR'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12344149259853120.4504)
,p_event_id=>wwv_flow_api.id(12344087306853119.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_ROW_SELECTOR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12344239970853121.4504)
,p_event_id=>wwv_flow_api.id(12344087306853119.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_ROW_SELECTOR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12344392388853122.4504)
,p_event_id=>wwv_flow_api.id(12344087306853119.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_ROW_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(12344408055853123.4504)
,p_name=>'New Collection Name changed'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_NEW_COLL_NAME'
,p_condition_element=>'P3150_NEW_COLL_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12344520496853124.4504)
,p_event_id=>wwv_flow_api.id(12344408055853123.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3150_NEW_COLL_NAME").toUpperCase() + "_VIEW"'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3205155657656845.4504)
,p_name=>'Load Non JSON'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_LOAD_NON_JSON'
,p_condition_element=>'P3150_LOAD_NON_JSON'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3205276503656846.4504)
,p_event_id=>wwv_flow_api.id(3205155657656845.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW,P3150_CREATE_RELATONAL_VIEW'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3205367112656847.4504)
,p_event_id=>wwv_flow_api.id(3205155657656845.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_CREATE_RELATONAL_VIEW'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3205452493656848.4504)
,p_event_id=>wwv_flow_api.id(3205155657656845.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(74474977367949626.4504)
,p_event_id=>wwv_flow_api.id(3205155657656845.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_CREATE_RELATONAL_VIEW'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(74474030821949617.4504)
,p_name=>'Create Relational View'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_CREATE_RELATONAL_VIEW'
,p_condition_element=>'P3150_CREATE_RELATONAL_VIEW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(74474157885949618.4504)
,p_event_id=>wwv_flow_api.id(74474030821949617.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(74474298420949619.4504)
,p_event_id=>wwv_flow_api.id(74474030821949617.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(74474356705949620.4504)
,p_event_id=>wwv_flow_api.id(74474030821949617.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(90115276635448601.4504)
,p_name=>'Linefeed JSON'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_AUTO_DETECT_SELECTOR'
,p_condition_element=>'P3150_AUTO_DETECT_SELECTOR'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CR'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(90115372975448602.4504)
,p_event_id=>wwv_flow_api.id(90115276635448601.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_SKIP_NON_JSON'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(90115409186448603.4504)
,p_event_id=>wwv_flow_api.id(90115276635448601.4504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_SKIP_NON_JSON'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3203712454656831.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load data to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_content blob;',
'    l_file_type    pls_integer;',
'    ',
'    l_row_selector varchar2(255);',
'begin',
'    select blob_content',
'      into l_file_content',
'      from wwv_flow_temp_files',
'     where name = :P3150_FILE;',
'     ',
'    if :P3150_FILE_NAME like ''%.zip'' then',
'        l_file_type := wwv_flow_soda_dev.c_file_type_zip;',
'    elsif  :P3150_FILE_NAME like ''%.js'' or :P3150_FILE_NAME like ''%json'' or :P3150_FILE_NAME like ''%txt'' then',
'        l_file_type := wwv_flow_soda_dev.c_file_type_json_collection;',
'    end if;',
'    ',
'    if l_file_type = wwv_flow_soda_dev.c_file_type_json_collection then',
'        l_row_selector := case when :P3150_AUTO_DETECT_SELECTOR = ''N''  then :P3150_ROW_SELECTOR',
'                               when :P3150_AUTO_DETECT_SELECTOR = ''CR'' then chr( wwv_flow_soda_dev.c_row_selector_chr_jsonlist )',
'                               when :P3150_AUTO_DETECT_SELECTOR = ''Y''  then null',
'                          end;',
'    end if;',
'    ',
'    :P3150_LOAD_ID := wwv_flow_id.next_val;',
'    ',
'    if l_file_type = wwv_flow_soda_dev.c_file_type_zip and :P3150_LOAD_NON_JSON = ''Y'' then',
'        :P3150_RELATIONAL_VIEW := null;',
'    end if;',
'',
'    if :P3150_LOAD_TO = ''NEW'' then',
'        wwv_flow_soda_dev.load_into_new_collection(',
'            p_content              => l_file_content,',
'            p_content_type         => l_file_type,',
'            --',
'            p_collection_name      => :P3150_NEW_COLL_NAME,',
'            p_relational_view_name => :P3150_RELATIONAL_VIEW,',
'            p_handle_nonjson_files => case when :P3150_AUTO_DETECT_SELECTOR = ''CR'' ',
'                                          then',
'                                              case when :P3150_SKIP_NON_JSON = ''N'' then wwv_flow_soda_dev.c_allow_nonjson_files else wwv_flow_soda_dev.c_skip_nonjson_files end',
'                                          else ',
'                                              case when :P3150_LOAD_NON_JSON = ''Y'' then wwv_flow_soda_dev.c_allow_nonjson_files else wwv_flow_soda_dev.c_skip_nonjson_files end',
'                                      end,',
'            p_convert_xml_to_json  => :P3150_CONVERT_XML_FILES = ''Y'',',
'            -- ',
'            p_row_selector         => l_row_selector,',
'            -- ',
'            p_commit_interval      => 200,',
'            p_status_collection    => ''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID,',
'            -- ',
'            p_run_in_background    => true,',
'            -- ',
'            p_execute_as_schema    => :P3150_SCHEMA );',
'    else',
'        wwv_flow_soda_dev.load_into_existing_collection(',
'            p_content              => l_file_content,',
'            p_content_type         => l_file_type,',
'            --',
'            p_handle_nonjson_files => case when :P3150_AUTO_DETECT_SELECTOR = ''CR'' ',
'                                          then',
'                                              case when :P3150_SKIP_NON_JSON = ''N'' then wwv_flow_soda_dev.c_allow_nonjson_files else wwv_flow_soda_dev.c_skip_nonjson_files end',
'                                          else ',
'                                              case when :P3150_LOAD_NON_JSON = ''Y'' then wwv_flow_soda_dev.c_allow_nonjson_files else wwv_flow_soda_dev.c_skip_nonjson_files end',
'                                      end,',
'            p_convert_xml_to_json  => :P3150_CONVERT_XML_FILES = ''Y'',',
'            p_collection_name      => :P3150_EXISTING_COLL_NAME,',
'            p_relational_view_name => null,',
'            -- ',
'            p_row_selector         => l_row_selector,',
'            p_truncate             => ( :P3150_APPEND_METHOD = ''REPLACE'' ),',
'            -- ',
'            p_commit_interval      => 200,',
'            p_status_collection    => ''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID,',
'            -- ',
'            p_run_in_background    => true,',
'            -- ',
'            p_execute_as_schema    => :P3150_SCHEMA );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3201857722656812.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169589682639178940.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P3150_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2604098187653710.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Body Class'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3150_FILE is null and :P3150_DATA is null then',
'  :P3150_BODY_CLASS := ''is-first-step'';',
'else',
'  :P3150_BODY_CLASS := '''';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4391137511679772648.4504)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Selector'
,p_process_sql_clob=>':P3150_AUTO_DETECT_SELECTOR := ''CR'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P3150_FILE_NAME like ''%.txt'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_03151
begin
wwv_flow_api.create_page(
 p_id=>3151.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Carica dati'
,p_page_mode=>'MODAL'
,p_step_title=>'Carica dati'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region-headerItems--buttons { white-space: nowrap; }',
'.a-Region-bodyHeader { padding: 12px; margin: 0; border-bottom: 1px solid rgba(0, 0, 0,0.1); background-color: #FFF8E1; color: #202020; }',
''))
,p_step_template=>wwv_flow_api.id(690784265136803192.4504)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(46619710624049700)
,p_dialog_height=>'800'
,p_dialog_width=>'960'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(6252145073553331.4504)
,p_name=>'Caricamento in corso'
,p_region_name=>'loadInProgress'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 as status,',
'       n001 as rows_processed ',
'from wwv_flow_collections ',
'where collection_name=''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(385896719135645040.4504)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2021287082720117.4504)
,p_query_column_id=>1
,p_column_alias=>'STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Stato'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(3891423527523942)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2021635635720119.4504)
,p_query_column_id=>2
,p_column_alias=>'ROWS_PROCESSED'
,p_column_display_sequence=>2
,p_column_heading=>'Documenti caricati'
,p_use_as_row_header=>'N'
,p_column_format=>'9G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6834087449944525.4504)
,p_plug_name=>'Caricamento non riuscito'
,p_region_name=>'loadIncomplete'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>50
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Caricamento dei dati non riuscito in modo intermittente e incompleto.',
'<pre id="imcompl_load_error"></pre>',
'Controllare l''errore e riprovare. <br/>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467907526226381329.4504)
,p_plug_name=>'Nuova tabella'
,p_parent_plug_id=>wwv_flow_api.id(6834087449944525.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Raccolta <code>&P3151_TABLE_NAME!HTML.</code> creata. Caricamento di <b id="incompl_success_row_count"></b> documenti riuscito. <b class="u-danger-text" id="incompl_fail_row_count"></b> documenti rifiutati.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467907600307381330.4504)
,p_plug_name=>'Tabella esistente'
,p_parent_plug_id=>wwv_flow_api.id(6834087449944525.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3150_APPEND_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'', wwv_flow_escape.html(:P3150_EXISTING_COLL_NAME) ) );',
'elsif :P3150_APPEND_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'',  wwv_flow_escape.html(:P3150_EXISTING_COLL_NAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7960818590952875.4504)
,p_plug_name=>'Caricamento non riuscito'
,p_region_name=>'loadFail'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>40
,p_plug_source=>'Impossibile caricare i dati. Controllare l''errore e riprovare. <b id="fail_row_count"></b> documenti con errore.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9996351288283702.4504)
,p_plug_name=>'Caricamento dati riuscito'
,p_region_name=>'loadSuccess'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(746376253838324384.4504)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(469942078024703302.4504)
,p_plug_name=>'Nuova tabella'
,p_parent_plug_id=>wwv_flow_api.id(9996351288283702.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Raccolta <code>&P3151_TABLE_NAME!HTML.</code> creata con <b id="success_row_count"></b> documenti.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3150_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(469942110977703303.4504)
,p_plug_name=>'Tabella esistente'
,p_parent_plug_id=>wwv_flow_api.id(9996351288283702.4504)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3150_APPEND_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''WWV_FLOW_SODA_DEV.APPEND_SUCCESS'', wwv_flow_escape.html(:P3150_EXISTING_COLL_NAME) ) );',
'elsif :P3150_APPEND_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'',wwv_flow_escape.html(:P3150_EXISTING_COLL_NAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3150_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9997939756283718.4504)
,p_plug_name=>'Caricamento completato'
,p_region_name=>'load_finished'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(385770331595976651.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13546601811099580.4504)
,p_plug_name=>'Informazioni sulla tabella'
,p_region_name=>'table_info'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="timer-container"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13546899090099583.4504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2037068631720149.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(13546899090099583.4504)
,p_button_name=>'CANCEL'
,p_button_static_id=>'btn_cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Chiudi'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2037465062720149.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(13546899090099583.4504)
,p_button_name=>'VIEW_TABLE'
,p_button_static_id=>'viewTableBtn'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_image_alt=>'Visualizza raccolta'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.:FOCUS:&DEBUG.:RP,1001:OB_SCHEMA,OB_CURRENT_TYPE,OB_OBJECT_ID:&P3150_SCHEMA.,SODA_COLLECTION,&P3151_TAB_OBJ_ID.'
,p_button_condition=>'nvl(:P3150_CALLED_FROM, ''X'') != ''OBJECT_BROWSER'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2037893392720150.4504)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(13546899090099583.4504)
,p_button_name=>'CREATE_APP'
,p_button_static_id=>'createAppBtn'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(690706750701136097.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea applicazione'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:1,5,130,150,170,250:P1_SCHEMA,P1_NEW_TABLE_NAME:&P3151_TABLE_OWNER.,&P3150_RELATIONAL_VIEW.'
,p_button_condition=>'nvl(:P3150_CALLED_FROM,''X'') != ''OBJECT_BROWSER'' and :P3150_RELATIONAL_VIEW is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_api.id(12506407035221692)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2038274836720150.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(13546899090099583.4504)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'btn_previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765860428963371.4504)
,p_button_image_alt=>'Precedente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3150:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3365661889004629.4504)
,p_branch_name=>'Go To Page 1'
,p_branch_action=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:RP,1,5,130,150,170,250:P1_SCHEMA,P1_NEW_TABLE_NAME:&P3151_TABLE_OWNER.,&P3150_RELATIONAL_VIEW.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NEVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2022034417720122.4504)
,p_name=>'P3151_LOAD_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6252145073553331.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2022465876720124.4504)
,p_name=>'P3151_LOAD_ERROR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6252145073553331.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2022879838720124.4504)
,p_name=>'P3151_PROCESSED_ROW_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6252145073553331.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2023251178720124.4504)
,p_name=>'P3151_PROCESSED_ROW_CNT_DISP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(6252145073553331.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2032810852720145.4504)
,p_name=>'P3151_TABLE_CREATED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(9997939756283718.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2033235046720146.4504)
,p_name=>'P3151_TAB_OBJ_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(9997939756283718.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2034024225720146.4504)
,p_name=>'P3151_GOOD_ROW_CNT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(9997939756283718.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2034460368720146.4504)
,p_name=>'P3151_GOOD_ROW_CNT_DISP'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(9997939756283718.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2035926806720148.4504)
,p_name=>'P3151_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13546601811099580.4504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'P3150_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q      varchar2(32767) := null;',
'begin  ',
'  q:=''select wwv_flow_escape.html(upper(c.schema)) d, upper(c.schema) v '';',
'  q:=q||''from   wwv_flow_company_schemas c, '';',
'  q:=q||''       wwv_flow_fnd_user u '';',
'  q:=q||''where  c.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.security_group_id = :flow_security_group_id and '';',
'  q:=q||''       u.user_name = :flow_user and '';',
'  q:=q||''       (u.ALLOW_ACCESS_TO_SCHEMAS is null or '';',
'  q:=q||''        instr('''':''''||u.ALLOW_ACCESS_TO_SCHEMAS||'''':'''','''':''''||c.schema||'''':'''')>0) '';',
'  q:=q||''order by 1'';  ',
'  return q;',
'end;'))
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2036340568720149.4504)
,p_name=>'P3151_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(13546601811099580.4504)
,p_prompt=>'Nome collection'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3204039796656834.4504)
,p_name=>'P3151_LOAD_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(9997939756283718.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3204293548656836.4504)
,p_name=>'P3151_VIEW_OBJ_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(9997939756283718.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2038714876720174.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3151_TABLE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3150_LOAD_TO = ''NEW'' then',
'    return :P3150_NEW_COLL_NAME;',
'elsif :P3150_LOAD_TO = ''EXISTING'' then',
'    return :P3150_EXISTING_COLL_NAME;',
'end if;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3204187211656835.4504)
,p_computation_sequence=>20
,p_computation_item=>'P3151_LOAD_TO'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3150_LOAD_TO'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2039719192720175.4504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2037068631720149.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2040223850720176.4504)
,p_event_id=>wwv_flow_api.id(2039719192720175.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2040629796720176.4504)
,p_name=>'Timer for Refresh Progress'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2041138390720177.4504)
,p_event_id=>wwv_flow_api.id(2040629796720176.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSpinner$ = apex.util.showSpinner( $( "#loadInProgress" ) );',
'',
'var showFinished = function(){    ',
'    // Hide Table Information',
'    apex.region("table_info").element.hide();',
'',
'    var lLoadTo = apex.item("P3151_LOAD_TO").getValue();',
'    ',
'    var lTableCreated = apex.item( "P3151_TABLE_CREATED" ).getValue();',
'    var lBadRowCnt = 0;',
'    var lSuccessRowCnt = apex.item("P3151_GOOD_ROW_CNT").getValue();',
'    var lProcessedRowCnt = apex.item( "P3151_PROCESSED_ROW_CNT" ).getValue();',
'    ',
'    var lBadRowCntDisp = 0;',
'    var lSuccessRowCntDisp = apex.item("P3151_GOOD_ROW_CNT_DISP").getValue();',
'    var lProcessedRowCntDisp = apex.item( "P3151_PROCESSED_ROW_CNT_DISP" ).getValue();',
'    ',
'    if (lLoadTo === "NEW") {',
'        if (lTableCreated === "Y") {',
'            apex.jQuery("#viewTableBtn").show();',
'            apex.jQuery("#btn_cancel").hide();',
'        }',
'    } else if (lLoadTo === "EXISTING") {',
'        apex.jQuery("#viewTableBtn").show();',
'    }',
'    ',
'    if ( apex.item("P3151_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'        // show failure region',
'',
'        apex.jQuery("#incompl_success_row_count").text( lSuccessRowCntDisp );',
'        apex.jQuery("#incompl_fail_row_count").text( lBadRowCntDisp );',
'        apex.jQuery("#imcompl_load_error").text( apex.item( "P3151_LOAD_ERROR" ).getValue() );        ',
'        apex.region("loadIncomplete").element.show();',
'        if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'    } else {',
'        ',
'            // show success region',
'            apex.jQuery("#success_row_count").text( lSuccessRowCntDisp );',
'            apex.region("loadSuccess").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            apex.jQuery("#btn_previous").hide();',
'    }',
' };',
'',
'var triggerRefresh = function(){ ',
'    apex.event.trigger( apex.jQuery("#timer-container"), "job_timer" );',
'',
'    if ( apex.item("P3151_LOAD_STATUS").getValue() === ''FINISHED''  || ',
'         apex.item("P3151_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'      clearInterval( refreshInterval );',
'      apex.region("loadInProgress").element.hide();',
'      lSpinner$.remove();',
'      showFinished();',
'    }',
'};',
'',
'var refreshInterval = setInterval( triggerRefresh, 1000);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2041584904720177.4504)
,p_name=>'Refresh Progress Report on Timer'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#timer-container'
,p_bind_type=>'bind'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'job_timer'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2042034037720177.4504)
,p_event_id=>wwv_flow_api.id(2041584904720177.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6252145073553331.4504)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2042531363720178.4504)
,p_event_id=>wwv_flow_api.id(2041584904720177.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_job_is_running boolean := false;',
'begin',
'    --',
'    -- Step 1: Determine whether the scheduler job is running',
'    --',
'    for j in (',
'        select 1',
'          from sys.user_scheduler_jobs',
'         where job_name like ''ORACLE_APEX_DTLD$%''',
'           and regexp_substr( comments, ''(\:)(.*?)(\:)'',1,5,''i'',2 ) = ''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID',
'           and state    = ''RUNNING'' ',
'           and rownum   = 1 )',
'    loop',
'        l_job_is_running := true;',
'    end loop;',
'',
'    --',
'    -- Step 2: Determine the current status from the status collection',
'    --',
'    for l_load in (',
'        select c001 as status,',
'               c002 as error_message,',
'               n001 as rows_processed ',
'        from wwv_flow_collections ',
'        where collection_name=''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID)',
'    loop',
'        :P3151_LOAD_STATUS       := l_load.status;',
'        :P3151_LOAD_ERROR        := l_load.error_message;',
'        :P3151_PROCESSED_ROW_CNT := l_load.rows_processed;',
'    end loop;',
'',
'    if :P3151_LOAD_STATUS = ''RUNNING'' and not l_job_is_running then',
'        :P3151_LOAD_STATUS       := ''FAILED'';',
'        :P3151_LOAD_ERROR        := wwv_flow_lang.system_message(''DATA.LOAD.JOB_INTERMITTENTLY_FAILED'');',
'    end if;',
'    ',
'    :P3151_PROCESSED_ROW_CNT_DISP := to_char( :P3151_PROCESSED_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'end;'))
,p_attribute_03=>'P3151_LOAD_STATUS,P3151_PROCESSED_ROW_CNT,P3151_LOAD_ERROR,P3151_PROCESSED_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2043090830720179.4504)
,p_event_id=>wwv_flow_api.id(2041584904720177.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_table_exists boolean := false;',
'    l_context wwv_flow_exec.t_context;',
'    q varchar2(32767);',
'begin',
'    if :P3151_LOAD_STATUS in (''FAILED'', ''FINISHED'' ) then',
'        if :P3150_LOAD_TO = ''NEW'' then',
'            for l_table in (',
'                select table_name',
'                from sys.dba_tables',
'                where table_name = :P3150_NEW_COLL_NAME',
'                and owner = :P3150_SCHEMA )',
'            loop',
'                :P3151_TABLE_CREATED := ''Y'';',
'            end loop;',
'        end if;',
'        ',
'        q := ''with'';',
'        q := q||'' success_data as (select count(*) as cnt from ''||',
'             wwv_flow_assert.enquote_name( :P3151_TABLE_NAME )|| '')'';',
'        q := q||'' select s.cnt as success_count'';',
'        q:=q||'' from'';',
'        q:=q||'' success_data s'';',
'     ',
'        wwv_flow_exec.open_query_context(',
'            p_context     => l_context,',
'            p_location    => wwv_flow_exec_api.c_location_local_db,',
'            p_query_type  => wwv_flow_exec_api.c_query_type_sql_query,',
'            p_sql_query   => q,',
'            p_parse_as_schema_override => :P3150_SCHEMA );',
'            ',
'        if wwv_flow_exec.next_row( p_context => l_context ) then',
'            :P3151_GOOD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 1 );',
'        end if;',
'        ',
'        if :P3150_LOAD_TO = ''EXISTING'' then',
'            :P3151_GOOD_ROW_CNT := :P3151_PROCESSED_ROW_CNT;',
'        end if;',
'        ',
'        :P3151_GOOD_ROW_CNT_DISP := to_char( :P3151_GOOD_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'        ',
'        wwv_flow_exec.close_context( p_context => l_context );',
'    end if;',
'exception ',
'    when others then',
'        wwv_flow_exec.close_context( p_context => l_context );',
'        raise;',
'end;'))
,p_attribute_03=>'P3151_GOOD_ROW_CNT,P3151_TABLE_CREATED,P3151_TAB_OBJ_ID,P3151_GOOD_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2043418708720179.4504)
,p_name=>'confirm drop tables'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2907407723173324.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2043960383720180.4504)
,p_event_id=>wwv_flow_api.id(2043418708720179.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Si \00E8 certi di voler eliminare la raccolta &P3151_TABLE_NAME. creata dal caricamento dati?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2044422598720180.4504)
,p_event_id=>wwv_flow_api.id(2043418708720179.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DROP_TABLE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3365525928004628.4504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Gather Dictionary Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_dictionary_cache_dev.reset_dictionary_table_cache(',
'        p_workspace_name           => wwv_flow_fnd_user_int.find_company( wwv_flow_security.g_security_group_id ),',
'        p_schema                   => :P3150_SCHEMA,',
'        p_table_name               => :P3150_RELATIONAL_VIEW );',
'end;',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2039371551720175.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Object ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_object in (',
'    select object_id, object_name',
'    from sys.dba_objects',
'    where object_name in (:P3150_NEW_COLL_NAME, :P3150_EXISTING_COLL_NAME, :P3150_RELATIONAL_VIEW)',
'    and owner = :P3150_SCHEMA )',
'loop',
'    if l_object.object_name = :P3150_NEW_COLL_NAME and :P3150_LOAD_TO = ''NEW'' then',
'        :P3151_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3150_EXISTING_COLL_NAME and :P3150_LOAD_TO = ''EXISTING'' then',
'        :P3151_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3150_RELATIONAL_VIEW then',
'        :P3151_VIEW_OBJ_ID := l_object.object_id;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_03160
begin
wwv_flow_api.create_page(
 p_id=>3160.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dettagli raccolta SODA'
,p_alias=>'SODA_COLLECTION_METADATA'
,p_step_title=>'Dettagli raccolta SODA'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12507197648747035.4504)
,p_plug_name=>'SODA_COLLECTION_SUBTABS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(3328044443428468.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13412380719807536.4504)
,p_plug_name=>'Metadati raccolta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob   clob;',
'    l_writer wwv_flow_t_htp_writer := wwv_flow_t_htp_writer();',
'begin',
'    select json_query( wwv_flow_soda_dev.get_collection_details(',
'           p_schema          => :OBJECT_OWNER,',
'           p_collection_name => :OBJECT_NAME,',
'           p_method          => ''get_metadata'' ),''$'' returning clob pretty ) as details_json',
'      into l_clob',
'      from sys.dual;',
'    l_writer.p(''<pre tabindex="0">'');',
'    l_writer.p( l_clob );',
'    l_writer.p(''</pre>'');',
'    l_writer.flush;',
'    if sys.dbms_lob.istemporary( l_clob ) = 1 then',
'        sys.dbms_lob.freetemporary( l_clob );',
'    end if;',
'exception',
'    when others then',
'        if sys.dbms_lob.istemporary( l_clob ) = 1 then',
'            sys.dbms_lob.freetemporary( l_clob );',
'        end if;',
'        htp.p( wwv_flow_lang.system_message (''WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE''));',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1376686185661892724.4504)
,p_name=>'Endpoint REST'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select :P3160_REST_ENDPOINT as rest_endpoint  from sys.dual'
,p_display_when_condition=>'P3160_REST_ENDPOINT'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(707369456410205240.4504)
,p_query_column_id=>1
,p_column_alias=>'REST_ENDPOINT'
,p_column_display_sequence=>1
,p_column_heading=>'Endpoint REST SODA'
,p_use_as_row_header=>'N'
,p_column_link=>'#REST_ENDPOINT#'
,p_column_linktext=>'#REST_ENDPOINT#'
,p_column_link_attr=>'target="_blank"'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3365252171004625.4504)
,p_branch_name=>'No SODA? Go To Page 150'
,p_branch_action=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_db_version.c_has_soda'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(707369500719205241.4504)
,p_name=>'P3160_REST_ENDPOINT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1376686185661892724.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(707369647334205242.4504)
,p_computation_sequence=>10
,p_computation_item=>'P3160_REST_ENDPOINT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_soda_dev.get_soda_rest_endpoint( p_collection_name => :OBJECT_NAME )'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3318515050278965.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load new Object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'  l_hash boolean := false;',
'begin',
'wwv_flow_sw_api.check_priv(:OB_SCHEMA);',
':OBJECT_ID :=  :OB_OBJECT_ID;',
':OB_OBJECT_NAME := :OBJECT_ID;',
'',
'  begin',
'   l_num := :OBJECT_ID;',
'        wwv_flow.debug(''ID value:''||:OBJECT_ID);',
'   exception when others then',
'     l_hash := true;',
'     wwv_flow.debug(''Hashed value:''||:OBJECT_ID);',
'  end;',
'',
'if ( l_hash ) then',
'   for r in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id is null',
'               and  ''DBASE''||ltrim( to_char( ora_hash( upper(owner || ''.'' || object_name),1000000000, power(2,30) ), rpad( ''X'',29,''X'')||''X'' )) ',
'                = :OBJECT_ID and owner = :OB_SCHEMA) loop',
'      :OBJECT_NAME  := r.object_name;',
'      :OBJECT_OWNER := r.owner;',
'      :OBJECT_TYPE  := ''DATABASE_LINK'';',
'   end loop;',
'else',
'   for r2 in ( select object_name,owner,object_type',
'               from  sys.dba_objects ',
'               where object_id = :OBJECT_ID and owner = :OB_SCHEMA ) loop',
'      :OBJECT_NAME  := r2.object_name;',
'      :OBJECT_OWNER := r2.owner;',
'      if(r2.object_type = ''PACKAGE BODY'') then ',
'        :OBJECT_TYPE  := ''PACKAGE'';',
'      else',
'        :OBJECT_TYPE  := r2.object_type;',
'      end if;',
'   end loop;',
'   if ( :REQUEST = ''GETOBJECT_SPEC'' ) then',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_NAME =  :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE'' ) loop',
'          :OBJECT_NAME  := r2.object_name;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'',
'    elsif ( :REQUEST = ''GETOBJECT_BODY'' ) then',
'',
'       for r2 in ( select object_name,owner,object_type',
'                   from  sys.dba_objects ',
'                   where object_name = :OBJECT_NAME',
'                   and   OWNER = :OBJECT_OWNER',
'                   and   OBJECT_TYPE = ''PACKAGE BODY'' ) loop',
'          :OBJECT_NAME  := r2.object_NAME;',
'          :OBJECT_OWNER := r2.owner;',
'          :OBJECT_TYPE  := r2.object_type;',
'       end loop;',
'    end if;',
'end if;',
'/* print for JS to change schema select list */',
'',
'',
'    ',
'if ( :APP_PAGE_ID  not in  ( 0 ) ) then ',
'/* if the page is not zero refresh/highlight the left bar */',
'sys.htp.prn(''',
'<script type="text/javascript">',
'gTempType=''||wwv_flow_escape.js_literal(:OBJECT_TYPE)||'';',
'gTempId=''||wwv_flow_escape.js_literal(:OBJECT_ID)||'';',
'setTimeout(refocusTemp,1);',
'',
'function refocusTemp(){',
'top.gSideBar.reload(gTempType,gTempId,false,false);',
'}',
'</script>'');',
'else',
'/* else return the owner to change the selector */',
'sys.htp.prn(wwv_flow_escape.html(:OBJECT_OWNER)); ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'FOCUS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_required_patch=>wwv_flow_api.id(1080926199001296276.4504)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3318174524278964.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_03161
begin
wwv_flow_api.create_page(
 p_id=>3161.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Guida dati raccolta SODA'
,p_alias=>'SODA_COLLECTION_DATAGUIDE'
,p_step_title=>'Guida dati raccolta SODA'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(3700694428255306.4504)
,p_name=>'Indice di ricerca JSON'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--noBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select index_name, ',
'       domidx_status',
'  from sys.dba_indexes',
' where owner      = :OBJECT_OWNER',
'   and table_name = :OBJECT_NAME',
'   and index_type = ''DOMAIN'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('Non \00E8 stato ancora creato alcun indice di ricerca JSON.')
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3700754615255307.4504)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome indice ricerca'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3700868781255308.4504)
,p_query_column_id=>2
,p_column_alias=>'DOMIDX_STATUS'
,p_column_display_sequence=>2
,p_column_heading=>' Stato'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12533284687019851.4504)
,p_plug_name=>'SODA_COLLECTION_SUBTABS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(3328044443428468.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13340790960660157.4504)
,p_plug_name=>'Guida dati JSON'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob   clob;',
'    l_writer wwv_flow_t_htp_writer := wwv_flow_t_htp_writer();',
'begin',
'    select json_query( wwv_flow_soda_dev.get_collection_details(',
'           p_schema          =>:OBJECT_OWNER,',
'           p_collection_name => :OBJECT_NAME,',
'           p_method          => ''get_data_guide'' ), ''$'' returning clob pretty ) as details_json',
'      into l_clob',
'      from sys.dual;',
'    if l_clob is null or sys.dbms_lob.getlength( l_clob ) = 0 then',
'        l_writer.p( wwv_flow_lang.system_message (''WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE''));',
'    else',
'        l_writer.p(''<pre tabindex="0">'');',
'        l_writer.p( l_clob );',
'        l_writer.p(''<pre>'');',
'    end if;',
'    l_writer.flush;',
'    if sys.dbms_lob.istemporary( l_clob ) = 1 then',
'        sys.dbms_lob.freetemporary( l_clob );',
'    end if;',
'exception',
'    when others then',
'        if sys.dbms_lob.istemporary( l_clob ) = 1 then',
'            sys.dbms_lob.freetemporary( l_clob );',
'        end if;',
'        htp.p( wwv_flow_lang.system_message (''WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE''));',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select index_name, ',
'       domidx_status',
'  from sys.dba_indexes',
' where owner      = :OBJECT_OWNER',
'   and table_name = :OBJECT_NAME',
'   and index_type = ''DOMAIN'''))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15702465815808666.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--slimPadding'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(74475022228949627.4504)
,p_name=>'Viste relazionali'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select v.object_name view_name, ',
'       v.object_id   oid',
'  from sys.dba_objects v, ',
'       sys.dba_dependencies d',
' where d.owner            = v.owner',
'   and d.name             = v.object_name',
'   and v.object_type      = ''VIEW''',
'   and d.type             = ''VIEW''',
'   --',
'   and v.owner            = :OBJECT_OWNER',
'   and d.referenced_name  = :OBJECT_NAME',
'   and d.referenced_owner = :OBJECT_OWNER',
'   and d.referenced_type  = ''TABLE''',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select v.object_name view_name, object_id oid',
'  from sys.dba_objects v, sys.dba_dependencies d',
' where d.owner            = v.owner',
'   and d.name             = v.object_name',
'   and v.object_type      = ''VIEW''',
'   and d.type             = ''VIEW''',
'   --',
'   and v.owner            = :OBJECT_OWNER',
'   and d.referenced_name  = :OBJECT_NAME',
'   and d.referenced_owner = :OBJECT_OWNER',
'   and d.referenced_type  = ''TABLE'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('Non \00E8 stato ancora creato alcun indice di ricerca JSON.')
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(74475363309949630.4504)
,p_query_column_id=>1
,p_column_alias=>'VIEW_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nome vista'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:2150:&SESSION.:FOCUS:&DEBUG.:RP:OBJECT_TYPE,OBJECT_NAME,OB_OBJECT_ID:VIEW,#VIEW_NAME#,#OID#'
,p_column_linktext=>'#VIEW_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(74475403447949631.4504)
,p_query_column_id=>2
,p_column_alias=>'OID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3356729631955528.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15702465815808666.4504)
,p_button_name=>'CREATE_INDEX'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Crea indice ricerca'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3163:&SESSION.::&DEBUG.:RP,3163::'
,p_button_condition=>'P3161_DATA_GUIDE_EXISTS'
,p_button_condition2=>'0'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3700100590255301.4504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(15702465815808666.4504)
,p_button_name=>'DROP_INDEX'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina indice di ricerca'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_condition=>'P3161_DATA_GUIDE_EXISTS'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3357166810955529.4504)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(15702465815808666.4504)
,p_button_name=>'CREATE_VIEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Crea vista relazionale'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3164:&SESSION.::&DEBUG.:RP,3164::'
,p_button_condition=>'P3161_DATA_GUIDE_EXISTS'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3398002293149353.4504)
,p_branch_name=>'No SODA? Go To Page 150'
,p_branch_action=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_db_version.c_has_soda'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3205699822656850.4504)
,p_name=>'P3161_DATA_GUIDE_EXISTS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(12533284687019851.4504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3700255492255302.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Drop Index'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_soda_dev.drop_search_index(',
'        p_schema          => :OBJECT_OWNER,',
'        p_collection_name => :OBJECT_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3700100590255301.4504)
,p_process_success_message=>'Indice di ricerca JSON eliminato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3336738908545445.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3205590690656849.4504)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Data Guide exists?'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dg clob;',
'begin ',
'    l_dg := wwv_flow_soda_dev.get_collection_details(',
'        p_schema =>:OBJECT_OWNER,',
'        p_collection_name => :OBJECT_NAME,',
'        p_method => ''get_data_guide'' );',
'        :P3161_DATA_GUIDE_EXISTS := 1;',
'exception',
'    when others then',
'        :P3161_DATA_GUIDE_EXISTS := 0;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_03162
begin
wwv_flow_api.create_page(
 p_id=>3162.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Dati'
,p_alias=>'SODA_COLLECTION_DETAIL'
,p_step_title=>'Dati'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15902140514032013.4504)
,p_plug_name=>'SODA_COLLECTION_SUBTABS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(3328044443428468.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(16709646787672319.4504)
,p_name=>'Dati'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_soda_dev.get_collection_data_query(',
'    p_schema          => :OBJECT_OWNER,',
'    p_collection_name => :OBJECT_NAME );'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(717436155076828097.4504)
,p_plug_query_max_columns=>10
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_soda_dev.get_collection_column_headers(',
'    p_schema          => :OBJECT_OWNER,',
'    p_collection_name => :OBJECT_NAME );'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>50
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('La raccolta SODA \00E8 vuota.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363047564004603.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363111508004604.4504)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_report_column_width=>700
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363294558004605.4504)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363345838004606.4504)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363412808004607.4504)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363556902004608.4504)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363671923004609.4504)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363725111004610.4504)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363894929004611.4504)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3363927786004612.4504)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(663559526160001431.4504)
,p_plug_name=>'Pulsanti'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--slimPadding'
,p_plug_template=>wwv_flow_api.id(690697788869123307.4504)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(725480325511863232.4504)
,p_name=>'Conteggio documenti'
,p_template=>wwv_flow_api.id(380771699411878611.4504)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>'return ''select count(*) as document_count from '' || wwv_flow_assert.enquote_name( :OBJECT_OWNER ) || ''.'' || wwv_flow_assert.enquote_name (:OBJECT_NAME );'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1127586271702515372.4504)
,p_plug_query_max_columns=>1
,p_query_num_rows=>1
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
,p_plug_query_parse_override=>'OBJECT_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(651004716039913601.4504)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Conteggio documenti'
,p_use_as_row_header=>'N'
,p_column_format=>'9G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(707369765121205243.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(663559526160001431.4504)
,p_button_name=>'LOAD_DATA'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Carica dati'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3150:&SESSION.::&DEBUG.:RP,3150,3151:P3150_LOAD_TO,P3150_EXISTING_COLL_NAME,P3150_CALLED_FROM:EXISTING,&OBJECT_NAME.,OBJECT_BROWSER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(651213758842148293.4504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(663559526160001431.4504)
,p_button_name=>'DROP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_image_alt=>'Elimina'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3165:&SESSION.::&DEBUG.:RP,3165::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3398362769152513.4504)
,p_branch_name=>'No SODA? Go To Page 150'
,p_branch_action=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_db_version.c_has_soda'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3370821204012185.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_03163
begin
wwv_flow_api.create_page(
 p_id=>3163.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea indice'
,p_step_title=>'Crea indice'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15886922292957833.4504)
,p_plug_name=>'SODA_COLLECTION_SUBTABS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(3328044443428468.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16694428566598139.4504)
,p_plug_name=>'Crea indice nella raccolta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12346665626853145.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16694428566598139.4504)
,p_button_name=>'CREATE_INDEX'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'BELOW_BOX'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12347071752853149.4504)
,p_branch_name=>'Go To Page 3161'
,p_branch_action=>'f?p=&APP_ID.:3161:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(12346665626853145.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3398683617153225.4504)
,p_branch_name=>'No SODA? Go To Page 150'
,p_branch_action=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_db_version.c_has_soda'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3362900752004602.4504)
,p_name=>'P3163_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16694428566598139.4504)
,p_item_default=>'OBJECT_OWNER'
,p_item_default_type=>'ITEM'
,p_prompt=>'Proprietario'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12346523643853144.4504)
,p_name=>'P3163_INDEX_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16694428566598139.4504)
,p_item_default=>':OBJECT_NAME || ''_SEARCH_IX'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Nome indice'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Fornire un nome per l''indice di ricerca da creare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12347150323853150.4504)
,p_name=>'P3163_OBJECT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16694428566598139.4504)
,p_item_default=>'OBJECT_NAME'
,p_item_default_type=>'ITEM'
,p_prompt=>'Nome collection'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3365156841004624.4504)
,p_validation_name=>'Index does not already exist'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_indexes',
' where owner      = :OBJECT_OWNER',
'   and index_name = :P3163_INDEX_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Nome indice gi\00E0 in uso. Sceglierne un altro.')
,p_when_button_pressed=>wwv_flow_api.id(12346665626853145.4504)
,p_associated_item=>wwv_flow_api.id(12346523643853144.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(74475714106949634.4504)
,p_name=>'Create Search Index'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(12346665626853145.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(74475821852949635.4504)
,p_event_id=>wwv_flow_api.id(74475714106949634.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_INDEX'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12346967663853148.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Index'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_soda_dev.create_search_index(',
'        p_schema          => :OBJECT_OWNER,',
'        p_collection_name => :OBJECT_NAME,',
'        p_index_name      => :P3163_INDEX_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(12346665626853145.4504)
,p_process_success_message=>'Indice &P3163_INDEX_NAME!HTML. creato.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3354575725938031.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_03164
begin
wwv_flow_api.create_page(
 p_id=>3164.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Crea vista relazionale'
,p_step_title=>'Crea vista relazionale'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19276139983004663.4504)
,p_plug_name=>'SODA_COLLECTION_SUBTABS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(3328044443428468.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20083646256644969.4504)
,p_plug_name=>'Crea vista relazionale'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3390185074046852.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20083646256644969.4504)
,p_button_name=>'CREATE_VIEW'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crea'
,p_button_position=>'BELOW_BOX'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3392606233046874.4504)
,p_branch_name=>'Go To Page 3161'
,p_branch_action=>'f?p=&APP_ID.:3161:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3390185074046852.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3398905937153891.4504)
,p_branch_name=>'No SODA? Go To Page 150'
,p_branch_action=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_db_version.c_has_soda'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390589450046853.4504)
,p_name=>'P3164_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20083646256644969.4504)
,p_item_default=>'OBJECT_OWNER'
,p_item_default_type=>'ITEM'
,p_prompt=>'Proprietario'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390963557046856.4504)
,p_name=>'P3164_OBJECT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20083646256644969.4504)
,p_item_default=>'OBJECT_NAME'
,p_item_default_type=>'ITEM'
,p_prompt=>'Nome collection'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3391367863046857.4504)
,p_name=>'P3164_VIEW_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20083646256644969.4504)
,p_item_default=>':OBJECT_NAME || ''_VIEW'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Nome vista'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(488671190365029680.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Fornire il nome della vista da creare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4391137624825772649.4504)
,p_name=>'P3164_PATH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20083646256644969.4504)
,p_item_default=>'$'
,p_prompt=>'Selettore JSON'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Il percorso del campo JSON da espandere. Utilizza la sintassi dell''espressione di percorso JSON. Espande i discendenti nel percorso specificato e crea le colonne di visualizzazione per ogni valore scalare nella struttura secondaria risultante. Il per'
||'corso $ crea una vista a partire dalla radice del documento JSON.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3365005249004623.4504)
,p_validation_name=>'View Name already taken'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from sys.dba_views',
' where owner     = :OBJECT_OWNER',
'   and view_name = :P3164_VIEW_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Nome vista gi\00E0 in uso. Sceglierne un altro.')
,p_when_button_pressed=>wwv_flow_api.id(3390185074046852.4504)
,p_associated_item=>wwv_flow_api.id(3391367863046857.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(705988613174195136.4504)
,p_validation_name=>'View Name must not contain invalid chars'
,p_validation_sequence=>20
,p_validation=>'instr( :P3164_VIEW_NAME, '''''''' ) = 0 and instr( :P3164_VIEW_NAME, ''"'' ) = 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# non deve contenere '' o caratteri ".'
,p_when_button_pressed=>wwv_flow_api.id(3390185074046852.4504)
,p_associated_item=>wwv_flow_api.id(3391367863046857.4504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(74475526894949632.4504)
,p_name=>'Create View'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3390185074046852.4504)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(74475615133949633.4504)
,p_event_id=>wwv_flow_api.id(74475526894949632.4504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_VIEW'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3392124048046873.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create View'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_soda_dev.create_relational_view(',
'        p_schema          => :OBJECT_OWNER,',
'        p_collection_name => :OBJECT_NAME,',
'        p_view_name       => :P3164_VIEW_NAME,',
'        p_on_path         => :P3164_PATH );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3390185074046852.4504)
,p_process_success_message=>'Vista &P3164_VIEW_NAME!HTML. creata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3391745699046872.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_03165
begin
wwv_flow_api.create_page(
 p_id=>3165.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Elimina raccolta'
,p_step_title=>'Elimina raccolta'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11540120040990569)
,p_step_template=>wwv_flow_api.id(740688669716062470.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20976709800451100.4504)
,p_plug_name=>'SODA_COLLECTION_SUBTABS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(3328044443428468.4504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11751121765920036.4504)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21784216074091406.4504)
,p_plug_name=>'Elimina raccolta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(380771699411878611.4504)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1701460120446478.4504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21784216074091406.4504)
,p_button_name=>'DROP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(385765234519963355.4504)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Elimina'
,p_button_position=>'BELOW_BOX'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1704322687446506.4504)
,p_branch_name=>'Go To Page 104'
,p_branch_action=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1701460120446478.4504)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1704745618446506.4504)
,p_branch_name=>'No SODA? Go To Page 150'
,p_branch_action=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_db_version.c_has_soda'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1701824110446479.4504)
,p_name=>'P3165_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(21784216074091406.4504)
,p_item_default=>'OBJECT_OWNER'
,p_item_default_type=>'ITEM'
,p_prompt=>'Proprietario'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1702259483446482.4504)
,p_name=>'P3165_OBJECT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(21784216074091406.4504)
,p_item_default=>'OBJECT_NAME'
,p_item_default_type=>'ITEM'
,p_prompt=>'Nome collection'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(488671029226029669.4504)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1703834864446504.4504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Drop Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_soda_dev.drop_collection(',
'        p_schema          => :OBJECT_OWNER,',
'        p_collection_name => :OBJECT_NAME );',
'        ',
'    :P104_MSG := ''SUCCESS'';',
'exception',
'    when others then ',
'        :P104_MSG := sqlerrm;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1701460120446478.4504)
,p_process_success_message=>'Raccolta &OBJECT_NAME!HTML. eliminata.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1703421893446503.4504)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:OBJECT_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_04000
begin
wwv_flow_api.create_page(
 p_id=>4000.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy1'
,p_alias=>'DATAGEN-DUMMY1'
,p_step_title=>'DataGen Dummy1'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04001
begin
wwv_flow_api.create_page(
 p_id=>4001.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy2'
,p_alias=>'DATAGEN-DUMMY2'
,p_step_title=>'DataGen Dummy2'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04002
begin
wwv_flow_api.create_page(
 p_id=>4002.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy3'
,p_alias=>'DATAGEN-DUMMY3'
,p_step_title=>'DataGen Dummy3'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04003
begin
wwv_flow_api.create_page(
 p_id=>4003.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy4'
,p_alias=>'DATAGEN-DUMMY4'
,p_step_title=>'DataGen Dummy4'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04004
begin
wwv_flow_api.create_page(
 p_id=>4004.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy5'
,p_alias=>'DATAGEN-DUMMY5'
,p_step_title=>'DataGen Dummy5'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04005
begin
wwv_flow_api.create_page(
 p_id=>4005.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy6'
,p_alias=>'DATAGEN-DUMMY6'
,p_step_title=>'DataGen Dummy6'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04006
begin
wwv_flow_api.create_page(
 p_id=>4006.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy7'
,p_alias=>'DATAGEN-DUMMY7'
,p_step_title=>'DataGen Dummy7'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04007
begin
wwv_flow_api.create_page(
 p_id=>4007.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy8'
,p_alias=>'DATAGEN-DUMMY71'
,p_step_title=>'DataGen Dummy7'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04008
begin
wwv_flow_api.create_page(
 p_id=>4008.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy9'
,p_alias=>'DATAGEN-DUMMY8'
,p_step_title=>'DataGen Dummy8'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04009
begin
wwv_flow_api.create_page(
 p_id=>4009.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy10'
,p_alias=>'DATAGEN-DUMMY10'
,p_step_title=>'DataGen Dummy10'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04010
begin
wwv_flow_api.create_page(
 p_id=>4010.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy11'
,p_alias=>'DATAGEN-DUMMY11'
,p_step_title=>'DataGen Dummy11'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04011
begin
wwv_flow_api.create_page(
 p_id=>4011.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy12'
,p_alias=>'DATAGEN-DUMMY12'
,p_step_title=>'DataGen Dummy12'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04012
begin
wwv_flow_api.create_page(
 p_id=>4012.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy14'
,p_alias=>'DATAGEN-DUMMY14'
,p_step_title=>'DataGen Dummy14'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04014
begin
wwv_flow_api.create_page(
 p_id=>4014.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy15'
,p_alias=>'DATAGEN-DUMMY15'
,p_step_title=>'DataGen Dummy15'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04015
begin
wwv_flow_api.create_page(
 p_id=>4015.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy16'
,p_alias=>'DATAGEN-DUMMY16'
,p_step_title=>'DataGen Dummy16'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04016
begin
wwv_flow_api.create_page(
 p_id=>4016.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy17'
,p_alias=>'DATAGEN-DUMMY17'
,p_step_title=>'DataGen Dummy17'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_04100
begin
wwv_flow_api.create_page(
 p_id=>4100.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'DataGen Dummy13'
,p_alias=>'DATAGEN-DUMMY13'
,p_step_title=>'DataGen Dummy13'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_api.create_page(
 p_id=>8000.4504
,p_user_interface_id=>wwv_flow_api.id(4969205754302342.4504)
,p_name=>'Risultati ricerca area di lavoro'
,p_step_title=>'Risultati ricerca area di lavoro'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(690783685471803190.4504)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29097909672335205.4504)
,p_plug_name=>'Risultati ricerca'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(690714020036152159.4504)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''Application'' type,',
'    id, ',
'    name||'' (''||id||'')'' name,',
'    last_updated_on updated,',
'    lower(last_updated_by)  updated_by,',
'    created_on  created,',
'    lower(created_by) created_by,',
'    f.owner,',
'    decode(f.publish_yn,''Y'',t_yes,''N'',t_no,t_no) published,',
'    ''<button type="button" data-link="''||wwv_flow_dev.get_run_url(id)||',
'        ''" title="''||wwv_flow_escape.html(sm.run)||',
'        ''" aria-label="''||wwv_flow_escape.html(sm.run)||',
'        ''" class="a-Button a-Button--noLabel a-Button--withIcon launch-aut"><span class="a-Icon icon-run-page" aria-hidden="true"></span></button>''',
'        run_link,',
'    ''<a href="''||',
'        decode(build_status,''RUN_ONLY'',',
'        ''f?p=4000:733:''||:app_session||''::::FB_FLOW_ID:''||id,',
'        ''f?p=4000:1:''||:app_session||',
'        '':::RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||',
'        f.id||'',''||f.id||'',''||f.id||'','') ||',
'        ''"><img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-pencil.png" class="apex-edit-pencil"''||',
'        '' border="0" alt="''||wwv_flow_escape.html(sm.m_edit)||''" title="''||wwv_flow_escape.html(sm.m_edit)||''"/></a>''',
'        edit_link',
'from   wwv_flow_visible_flows f,',
'      (select wwv_flow_lang.system_message(''EDIT'') m_edit,',
'              wwv_flow_lang.system_message(''RUN'') run,',
'              wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'              wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'              wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'              wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'              wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'       from dual) sm',
'union all',
'select ',
'    ''Websheet'' type,',
'    w.id,',
'    w.name name, ',
'    w.UPDATED_ON  updated,',
'    lower(w.updated_by) UPDATED_BY,',
'    w.CREATED_ON created,',
'    lower(w.CREATED_BY) created_by,',
'    lower(w.owner) owner,',
'    decode(''N'',''Y'',t_yes,''N'',t_no,t_no) published,',
'    ''<button type="button" data-link="ws?p=''||w.id||'':home:''||:app_session ||',
'        ''" title="''||wwv_flow_escape.html(sm.run)||',
'        ''" aria-label="''||wwv_flow_escape.html(sm.run)||',
'        ''" class="a-Button a-Button--noLabel a-Button--withIcon launch-aut"><span class="a-Icon icon-run-page" aria-hidden="true"></span></button>''',
'        run_link,',
'    ''<a href="f?p=4000:933:''||:app_session||''::::P933_ID:''||w.id||',
'        ''"><img src="#IMAGE_PREFIX#menu/pencil16x16.gif"''||',
'        '' border="0" alt="''||wwv_flow_escape.html(sm.m_edit)||''" title="''||wwv_flow_escape.html(sm.m_edit)||''"/></a>'' ',
'        edit_link',
'  from wwv_flow_ws_applications w,',
'      (select wwv_flow_lang.system_message(''EDIT'') m_edit,',
'              wwv_flow_lang.system_message(''RUN'') run,',
'              wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'              wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'              wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'              wwv_flow_lang.system_message(''F4000.NO'') t_no',
'       from dual) sm',
' where w.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(29098015502335205.4504)
,p_name=>'Search Results'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Questa query restituisce pi\00F9 di 10.000 righe. Filtrare i dati per ottenere risultati completi.')
,p_no_data_found_message=>'Nessun dato trovato.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29098218651335225.4504)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29098630127335227.4504)
,p_db_column_name=>'NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Nome'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29098806283335227.4504)
,p_db_column_name=>'OWNER'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Proprietario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29099308842335228.4504)
,p_db_column_name=>'UPDATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Aggiornato'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29099620468335229.4504)
,p_db_column_name=>'CREATED'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Data creazione'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29099716652335229.4504)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Creazione di'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29108918291498233.4504)
,p_db_column_name=>'TYPE'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Tipo componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29109018593498237.4504)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Autore aggiornamento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29109109335498237.4504)
,p_db_column_name=>'PUBLISHED'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Pubblicato'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29109216943498237.4504)
,p_db_column_name=>'RUN_LINK'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Esegui'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29109308233498237.4504)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Modifica'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
